var Module;
if (!Module) Module = (typeof Module !== "undefined" ? Module : null) || {};
var moduleOverrides = {};
for (var key in Module) {
 if (Module.hasOwnProperty(key)) {
  moduleOverrides[key] = Module[key];
 }
}
var ENVIRONMENT_IS_NODE = typeof process === "object" && typeof require === "function";
var ENVIRONMENT_IS_WEB = typeof window === "object";
var ENVIRONMENT_IS_WORKER = typeof importScripts === "function";
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;
if (ENVIRONMENT_IS_NODE) {
 if (!Module["print"]) Module["print"] = function print(x) {
  process["stdout"].write(x + "\n");
 };
 if (!Module["printErr"]) Module["printErr"] = function printErr(x) {
  process["stderr"].write(x + "\n");
 };
 var nodeFS = require("fs");
 var nodePath = require("path");
 Module["read"] = function read(filename, binary) {
  filename = nodePath["normalize"](filename);
  var ret = nodeFS["readFileSync"](filename);
  if (!ret && filename != nodePath["resolve"](filename)) {
   filename = path.join(__dirname, "..", "src", filename);
   ret = nodeFS["readFileSync"](filename);
  }
  if (ret && !binary) ret = ret.toString();
  return ret;
 };
 Module["readBinary"] = function readBinary(filename) {
  return Module["read"](filename, true);
 };
 Module["load"] = function load(f) {
  globalEval(read(f));
 };
 if (process["argv"].length > 1) {
  Module["thisProgram"] = process["argv"][1].replace(/\\/g, "/");
 } else {
  Module["thisProgram"] = "unknown-program";
 }
 Module["arguments"] = process["argv"].slice(2);
 if (typeof module !== "undefined") {
  module["exports"] = Module;
 }
 process["on"]("uncaughtException", (function(ex) {
  if (!(ex instanceof ExitStatus)) {
   throw ex;
  }
 }));
} else if (ENVIRONMENT_IS_SHELL) {
 if (!Module["print"]) Module["print"] = print;
 if (typeof printErr != "undefined") Module["printErr"] = printErr;
 if (typeof read != "undefined") {
  Module["read"] = read;
 } else {
  Module["read"] = function read() {
   throw "no read() available (jsc?)";
  };
 }
 Module["readBinary"] = function readBinary(f) {
  if (typeof readbuffer === "function") {
   return new Uint8Array(readbuffer(f));
  }
  var data = read(f, "binary");
  assert(typeof data === "object");
  return data;
 };
 if (typeof scriptArgs != "undefined") {
  Module["arguments"] = scriptArgs;
 } else if (typeof arguments != "undefined") {
  Module["arguments"] = arguments;
 }
 this["Module"] = Module;
} else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
 Module["read"] = function read(url) {
  var xhr = new XMLHttpRequest;
  xhr.open("GET", url, false);
  xhr.send(null);
  return xhr.responseText;
 };
 if (typeof arguments != "undefined") {
  Module["arguments"] = arguments;
 }
 if (typeof console !== "undefined") {
  if (!Module["print"]) Module["print"] = function print(x) {
   console.log(x);
  };
  if (!Module["printErr"]) Module["printErr"] = function printErr(x) {
   console.log(x);
  };
 } else {
  var TRY_USE_DUMP = false;
  if (!Module["print"]) Module["print"] = TRY_USE_DUMP && typeof dump !== "undefined" ? (function(x) {
   dump(x);
  }) : (function(x) {});
 }
 if (ENVIRONMENT_IS_WEB) {
  window["Module"] = Module;
 } else {
  Module["load"] = importScripts;
 }
} else {
 throw "Unknown runtime environment. Where are we?";
}
function globalEval(x) {
 eval.call(null, x);
}
if (!Module["load"] && Module["read"]) {
 Module["load"] = function load(f) {
  globalEval(Module["read"](f));
 };
}
if (!Module["print"]) {
 Module["print"] = (function() {});
}
if (!Module["printErr"]) {
 Module["printErr"] = Module["print"];
}
if (!Module["arguments"]) {
 Module["arguments"] = [];
}
if (!Module["thisProgram"]) {
 Module["thisProgram"] = "./this.program";
}
Module.print = Module["print"];
Module.printErr = Module["printErr"];
Module["preRun"] = [];
Module["postRun"] = [];
for (var key in moduleOverrides) {
 if (moduleOverrides.hasOwnProperty(key)) {
  Module[key] = moduleOverrides[key];
 }
}
var Runtime = {
 setTempRet0: (function(value) {
  tempRet0 = value;
 }),
 getTempRet0: (function() {
  return tempRet0;
 }),
 stackSave: (function() {
  return STACKTOP;
 }),
 stackRestore: (function(stackTop) {
  STACKTOP = stackTop;
 }),
 getNativeTypeSize: (function(type) {
  switch (type) {
  case "i1":
  case "i8":
   return 1;
  case "i16":
   return 2;
  case "i32":
   return 4;
  case "i64":
   return 8;
  case "float":
   return 4;
  case "double":
   return 8;
  default:
   {
    if (type[type.length - 1] === "*") {
     return Runtime.QUANTUM_SIZE;
    } else if (type[0] === "i") {
     var bits = parseInt(type.substr(1));
     assert(bits % 8 === 0);
     return bits / 8;
    } else {
     return 0;
    }
   }
  }
 }),
 getNativeFieldSize: (function(type) {
  return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
 }),
 STACK_ALIGN: 16,
 getAlignSize: (function(type, size, vararg) {
  if (!vararg && (type == "i64" || type == "double")) return 8;
  if (!type) return Math.min(size, 8);
  return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
 }),
 dynCall: (function(sig, ptr, args) {
  if (args && args.length) {
   if (!args.splice) args = Array.prototype.slice.call(args);
   args.splice(0, 0, ptr);
   return Module["dynCall_" + sig].apply(null, args);
  } else {
   return Module["dynCall_" + sig].call(null, ptr);
  }
 }),
 functionPointers: [],
 addFunction: (function(func) {
  for (var i = 0; i < Runtime.functionPointers.length; i++) {
   if (!Runtime.functionPointers[i]) {
    Runtime.functionPointers[i] = func;
    return 2 * (1 + i);
   }
  }
  throw "Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.";
 }),
 removeFunction: (function(index) {
  Runtime.functionPointers[(index - 2) / 2] = null;
 }),
 getAsmConst: (function(code, numArgs) {
  if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
  var func = Runtime.asmConstCache[code];
  if (func) return func;
  var args = [];
  for (var i = 0; i < numArgs; i++) {
   args.push(String.fromCharCode(36) + i);
  }
  var source = Pointer_stringify(code);
  if (source[0] === '"') {
   if (source.indexOf('"', 1) === source.length - 1) {
    source = source.substr(1, source.length - 2);
   } else {
    abort("invalid EM_ASM input |" + source + "|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)");
   }
  }
  try {
   var evalled = eval("(function(Module, FS) { return function(" + args.join(",") + "){ " + source + " } })")(Module, typeof FS !== "undefined" ? FS : null);
  } catch (e) {
   Module.printErr("error in executing inline EM_ASM code: " + e + " on: \n\n" + source + "\n\nwith args |" + args + "| (make sure to use the right one out of EM_ASM, EM_ASM_ARGS, etc.)");
   throw e;
  }
  return Runtime.asmConstCache[code] = evalled;
 }),
 warnOnce: (function(text) {
  if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
  if (!Runtime.warnOnce.shown[text]) {
   Runtime.warnOnce.shown[text] = 1;
   Module.printErr(text);
  }
 }),
 funcWrappers: {},
 getFuncWrapper: (function(func, sig) {
  assert(sig);
  if (!Runtime.funcWrappers[sig]) {
   Runtime.funcWrappers[sig] = {};
  }
  var sigCache = Runtime.funcWrappers[sig];
  if (!sigCache[func]) {
   sigCache[func] = function dynCall_wrapper() {
    return Runtime.dynCall(sig, func, arguments);
   };
  }
  return sigCache[func];
 }),
 UTF8Processor: (function() {
  var buffer = [];
  var needed = 0;
  this.processCChar = (function(code) {
   code = code & 255;
   if (buffer.length == 0) {
    if ((code & 128) == 0) {
     return String.fromCharCode(code);
    }
    buffer.push(code);
    if ((code & 224) == 192) {
     needed = 1;
    } else if ((code & 240) == 224) {
     needed = 2;
    } else {
     needed = 3;
    }
    return "";
   }
   if (needed) {
    buffer.push(code);
    needed--;
    if (needed > 0) return "";
   }
   var c1 = buffer[0];
   var c2 = buffer[1];
   var c3 = buffer[2];
   var c4 = buffer[3];
   var ret;
   if (buffer.length == 2) {
    ret = String.fromCharCode((c1 & 31) << 6 | c2 & 63);
   } else if (buffer.length == 3) {
    ret = String.fromCharCode((c1 & 15) << 12 | (c2 & 63) << 6 | c3 & 63);
   } else {
    var codePoint = (c1 & 7) << 18 | (c2 & 63) << 12 | (c3 & 63) << 6 | c4 & 63;
    ret = String.fromCharCode(((codePoint - 65536) / 1024 | 0) + 55296, (codePoint - 65536) % 1024 + 56320);
   }
   buffer.length = 0;
   return ret;
  });
  this.processJSString = function processJSString(string) {
   string = unescape(encodeURIComponent(string));
   var ret = [];
   for (var i = 0; i < string.length; i++) {
    ret.push(string.charCodeAt(i));
   }
   return ret;
  };
 }),
 getCompilerSetting: (function(name) {
  throw "You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work";
 }),
 stackAlloc: (function(size) {
  var ret = STACKTOP;
  STACKTOP = STACKTOP + size | 0;
  STACKTOP = STACKTOP + 15 & -16;
  return ret;
 }),
 staticAlloc: (function(size) {
  var ret = STATICTOP;
  STATICTOP = STATICTOP + size | 0;
  STATICTOP = STATICTOP + 15 & -16;
  return ret;
 }),
 dynamicAlloc: (function(size) {
  var ret = DYNAMICTOP;
  DYNAMICTOP = DYNAMICTOP + size | 0;
  DYNAMICTOP = DYNAMICTOP + 15 & -16;
  if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();
  return ret;
 }),
 alignMemory: (function(size, quantum) {
  var ret = size = Math.ceil(size / (quantum ? quantum : 16)) * (quantum ? quantum : 16);
  return ret;
 }),
 makeBigInt: (function(low, high, unsigned) {
  var ret = unsigned ? +(low >>> 0) + +(high >>> 0) * +4294967296 : +(low >>> 0) + +(high | 0) * +4294967296;
  return ret;
 }),
 GLOBAL_BASE: 8,
 QUANTUM_SIZE: 4,
 __dummy__: 0
};
Module["Runtime"] = Runtime;
var __THREW__ = 0;
var ABORT = false;
var EXITSTATUS = 0;
var undef = 0;
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;
function assert(condition, text) {
 if (!condition) {
  abort("Assertion failed: " + text);
 }
}
var globalScope = this;
function getCFunc(ident) {
 var func = Module["_" + ident];
 if (!func) {
  try {
   func = eval("_" + ident);
  } catch (e) {}
 }
 assert(func, "Cannot call unknown function " + ident + " (perhaps LLVM optimizations or closure removed it?)");
 return func;
}
var cwrap, ccall;
((function() {
 var JSfuncs = {
  "stackSave": (function() {
   Runtime.stackSave();
  }),
  "stackRestore": (function() {
   Runtime.stackRestore();
  }),
  "arrayToC": (function(arr) {
   var ret = Runtime.stackAlloc(arr.length);
   writeArrayToMemory(arr, ret);
   return ret;
  }),
  "stringToC": (function(str) {
   var ret = 0;
   if (str !== null && str !== undefined && str !== 0) {
    ret = Runtime.stackAlloc((str.length << 2) + 1);
    writeStringToMemory(str, ret);
   }
   return ret;
  })
 };
 var toC = {
  "string": JSfuncs["stringToC"],
  "array": JSfuncs["arrayToC"]
 };
 ccall = function ccallFunc(ident, returnType, argTypes, args) {
  var func = getCFunc(ident);
  var cArgs = [];
  var stack = 0;
  if (args) {
   for (var i = 0; i < args.length; i++) {
    var converter = toC[argTypes[i]];
    if (converter) {
     if (stack === 0) stack = Runtime.stackSave();
     cArgs[i] = converter(args[i]);
    } else {
     cArgs[i] = args[i];
    }
   }
  }
  var ret = func.apply(null, cArgs);
  if (returnType === "string") ret = Pointer_stringify(ret);
  if (stack !== 0) Runtime.stackRestore(stack);
  return ret;
 };
 var sourceRegex = /^function\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;
 function parseJSFunc(jsfunc) {
  var parsed = jsfunc.toString().match(sourceRegex).slice(1);
  return {
   arguments: parsed[0],
   body: parsed[1],
   returnValue: parsed[2]
  };
 }
 var JSsource = {};
 for (var fun in JSfuncs) {
  if (JSfuncs.hasOwnProperty(fun)) {
   JSsource[fun] = parseJSFunc(JSfuncs[fun]);
  }
 }
 cwrap = function cwrap(ident, returnType, argTypes) {
  argTypes = argTypes || [];
  var cfunc = getCFunc(ident);
  var numericArgs = argTypes.every((function(type) {
   return type === "number";
  }));
  var numericRet = returnType !== "string";
  if (numericRet && numericArgs) {
   return cfunc;
  }
  var argNames = argTypes.map((function(x, i) {
   return "$" + i;
  }));
  var funcstr = "(function(" + argNames.join(",") + ") {";
  var nargs = argTypes.length;
  if (!numericArgs) {
   funcstr += "var stack = " + JSsource["stackSave"].body + ";";
   for (var i = 0; i < nargs; i++) {
    var arg = argNames[i], type = argTypes[i];
    if (type === "number") continue;
    var convertCode = JSsource[type + "ToC"];
    funcstr += "var " + convertCode.arguments + " = " + arg + ";";
    funcstr += convertCode.body + ";";
    funcstr += arg + "=" + convertCode.returnValue + ";";
   }
  }
  var cfuncname = parseJSFunc((function() {
   return cfunc;
  })).returnValue;
  funcstr += "var ret = " + cfuncname + "(" + argNames.join(",") + ");";
  if (!numericRet) {
   var strgfy = parseJSFunc((function() {
    return Pointer_stringify;
   })).returnValue;
   funcstr += "ret = " + strgfy + "(ret);";
  }
  if (!numericArgs) {
   funcstr += JSsource["stackRestore"].body.replace("()", "(stack)") + ";";
  }
  funcstr += "return ret})";
  return eval(funcstr);
 };
}))();
Module["cwrap"] = cwrap;
Module["ccall"] = ccall;
function setValue(ptr, value, type, noSafe) {
 type = type || "i8";
 if (type.charAt(type.length - 1) === "*") type = "i32";
 switch (type) {
 case "i1":
  HEAP8[ptr >> 0] = value;
  break;
 case "i8":
  HEAP8[ptr >> 0] = value;
  break;
 case "i16":
  HEAP16[ptr >> 1] = value;
  break;
 case "i32":
  HEAP32[ptr >> 2] = value;
  break;
 case "i64":
  tempI64 = [ value >>> 0, (tempDouble = value, +Math_abs(tempDouble) >= +1 ? tempDouble > +0 ? (Math_min(+Math_floor(tempDouble / +4294967296), +4294967295) | 0) >>> 0 : ~~+Math_ceil((tempDouble - +(~~tempDouble >>> 0)) / +4294967296) >>> 0 : 0) ], HEAP32[ptr >> 2] = tempI64[0], HEAP32[ptr + 4 >> 2] = tempI64[1];
  break;
 case "float":
  HEAPF32[ptr >> 2] = value;
  break;
 case "double":
  HEAPF64[ptr >> 3] = value;
  break;
 default:
  abort("invalid type for setValue: " + type);
 }
}
Module["setValue"] = setValue;
function getValue(ptr, type, noSafe) {
 type = type || "i8";
 if (type.charAt(type.length - 1) === "*") type = "i32";
 switch (type) {
 case "i1":
  return HEAP8[ptr >> 0];
 case "i8":
  return HEAP8[ptr >> 0];
 case "i16":
  return HEAP16[ptr >> 1];
 case "i32":
  return HEAP32[ptr >> 2];
 case "i64":
  return HEAP32[ptr >> 2];
 case "float":
  return HEAPF32[ptr >> 2];
 case "double":
  return HEAPF64[ptr >> 3];
 default:
  abort("invalid type for setValue: " + type);
 }
 return null;
}
Module["getValue"] = getValue;
var ALLOC_NORMAL = 0;
var ALLOC_STACK = 1;
var ALLOC_STATIC = 2;
var ALLOC_DYNAMIC = 3;
var ALLOC_NONE = 4;
Module["ALLOC_NORMAL"] = ALLOC_NORMAL;
Module["ALLOC_STACK"] = ALLOC_STACK;
Module["ALLOC_STATIC"] = ALLOC_STATIC;
Module["ALLOC_DYNAMIC"] = ALLOC_DYNAMIC;
Module["ALLOC_NONE"] = ALLOC_NONE;
function allocate(slab, types, allocator, ptr) {
 var zeroinit, size;
 if (typeof slab === "number") {
  zeroinit = true;
  size = slab;
 } else {
  zeroinit = false;
  size = slab.length;
 }
 var singleType = typeof types === "string" ? types : null;
 var ret;
 if (allocator == ALLOC_NONE) {
  ret = ptr;
 } else {
  ret = [ _malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc ][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
 }
 if (zeroinit) {
  var ptr = ret, stop;
  assert((ret & 3) == 0);
  stop = ret + (size & ~3);
  for (; ptr < stop; ptr += 4) {
   HEAP32[ptr >> 2] = 0;
  }
  stop = ret + size;
  while (ptr < stop) {
   HEAP8[ptr++ >> 0] = 0;
  }
  return ret;
 }
 if (singleType === "i8") {
  if (slab.subarray || slab.slice) {
   HEAPU8.set(slab, ret);
  } else {
   HEAPU8.set(new Uint8Array(slab), ret);
  }
  return ret;
 }
 var i = 0, type, typeSize, previousType;
 while (i < size) {
  var curr = slab[i];
  if (typeof curr === "function") {
   curr = Runtime.getFunctionIndex(curr);
  }
  type = singleType || types[i];
  if (type === 0) {
   i++;
   continue;
  }
  if (type == "i64") type = "i32";
  setValue(ret + i, curr, type);
  if (previousType !== type) {
   typeSize = Runtime.getNativeTypeSize(type);
   previousType = type;
  }
  i += typeSize;
 }
 return ret;
}
Module["allocate"] = allocate;
function Pointer_stringify(ptr, length) {
 if (length === 0 || !ptr) return "";
 var hasUtf = false;
 var t;
 var i = 0;
 while (1) {
  t = HEAPU8[ptr + i >> 0];
  if (t >= 128) hasUtf = true; else if (t == 0 && !length) break;
  i++;
  if (length && i == length) break;
 }
 if (!length) length = i;
 var ret = "";
 if (!hasUtf) {
  var MAX_CHUNK = 1024;
  var curr;
  while (length > 0) {
   curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
   ret = ret ? ret + curr : curr;
   ptr += MAX_CHUNK;
   length -= MAX_CHUNK;
  }
  return ret;
 }
 var utf8 = new Runtime.UTF8Processor;
 for (i = 0; i < length; i++) {
  t = HEAPU8[ptr + i >> 0];
  ret += utf8.processCChar(t);
 }
 return ret;
}
Module["Pointer_stringify"] = Pointer_stringify;
function UTF16ToString(ptr) {
 var i = 0;
 var str = "";
 while (1) {
  var codeUnit = HEAP16[ptr + i * 2 >> 1];
  if (codeUnit == 0) return str;
  ++i;
  str += String.fromCharCode(codeUnit);
 }
}
Module["UTF16ToString"] = UTF16ToString;
function stringToUTF16(str, outPtr) {
 for (var i = 0; i < str.length; ++i) {
  var codeUnit = str.charCodeAt(i);
  HEAP16[outPtr + i * 2 >> 1] = codeUnit;
 }
 HEAP16[outPtr + str.length * 2 >> 1] = 0;
}
Module["stringToUTF16"] = stringToUTF16;
function UTF32ToString(ptr) {
 var i = 0;
 var str = "";
 while (1) {
  var utf32 = HEAP32[ptr + i * 4 >> 2];
  if (utf32 == 0) return str;
  ++i;
  if (utf32 >= 65536) {
   var ch = utf32 - 65536;
   str += String.fromCharCode(55296 | ch >> 10, 56320 | ch & 1023);
  } else {
   str += String.fromCharCode(utf32);
  }
 }
}
Module["UTF32ToString"] = UTF32ToString;
function stringToUTF32(str, outPtr) {
 var iChar = 0;
 for (var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
  var codeUnit = str.charCodeAt(iCodeUnit);
  if (codeUnit >= 55296 && codeUnit <= 57343) {
   var trailSurrogate = str.charCodeAt(++iCodeUnit);
   codeUnit = 65536 + ((codeUnit & 1023) << 10) | trailSurrogate & 1023;
  }
  HEAP32[outPtr + iChar * 4 >> 2] = codeUnit;
  ++iChar;
 }
 HEAP32[outPtr + iChar * 4 >> 2] = 0;
}
Module["stringToUTF32"] = stringToUTF32;
function demangle(func) {
 var hasLibcxxabi = !!Module["___cxa_demangle"];
 if (hasLibcxxabi) {
  try {
   var buf = _malloc(func.length);
   writeStringToMemory(func.substr(1), buf);
   var status = _malloc(4);
   var ret = Module["___cxa_demangle"](buf, 0, 0, status);
   if (getValue(status, "i32") === 0 && ret) {
    return Pointer_stringify(ret);
   }
  } catch (e) {} finally {
   if (buf) _free(buf);
   if (status) _free(status);
   if (ret) _free(ret);
  }
 }
 var i = 3;
 var basicTypes = {
  "v": "void",
  "b": "bool",
  "c": "char",
  "s": "short",
  "i": "int",
  "l": "long",
  "f": "float",
  "d": "double",
  "w": "wchar_t",
  "a": "signed char",
  "h": "unsigned char",
  "t": "unsigned short",
  "j": "unsigned int",
  "m": "unsigned long",
  "x": "long long",
  "y": "unsigned long long",
  "z": "..."
 };
 var subs = [];
 var first = true;
 function dump(x) {
  if (x) Module.print(x);
  Module.print(func);
  var pre = "";
  for (var a = 0; a < i; a++) pre += " ";
  Module.print(pre + "^");
 }
 function parseNested() {
  i++;
  if (func[i] === "K") i++;
  var parts = [];
  while (func[i] !== "E") {
   if (func[i] === "S") {
    i++;
    var next = func.indexOf("_", i);
    var num = func.substring(i, next) || 0;
    parts.push(subs[num] || "?");
    i = next + 1;
    continue;
   }
   if (func[i] === "C") {
    parts.push(parts[parts.length - 1]);
    i += 2;
    continue;
   }
   var size = parseInt(func.substr(i));
   var pre = size.toString().length;
   if (!size || !pre) {
    i--;
    break;
   }
   var curr = func.substr(i + pre, size);
   parts.push(curr);
   subs.push(curr);
   i += pre + size;
  }
  i++;
  return parts;
 }
 function parse(rawList, limit, allowVoid) {
  limit = limit || Infinity;
  var ret = "", list = [];
  function flushList() {
   return "(" + list.join(", ") + ")";
  }
  var name;
  if (func[i] === "N") {
   name = parseNested().join("::");
   limit--;
   if (limit === 0) return rawList ? [ name ] : name;
  } else {
   if (func[i] === "K" || first && func[i] === "L") i++;
   var size = parseInt(func.substr(i));
   if (size) {
    var pre = size.toString().length;
    name = func.substr(i + pre, size);
    i += pre + size;
   }
  }
  first = false;
  if (func[i] === "I") {
   i++;
   var iList = parse(true);
   var iRet = parse(true, 1, true);
   ret += iRet[0] + " " + name + "<" + iList.join(", ") + ">";
  } else {
   ret = name;
  }
  paramLoop : while (i < func.length && limit-- > 0) {
   var c = func[i++];
   if (c in basicTypes) {
    list.push(basicTypes[c]);
   } else {
    switch (c) {
    case "P":
     list.push(parse(true, 1, true)[0] + "*");
     break;
    case "R":
     list.push(parse(true, 1, true)[0] + "&");
     break;
    case "L":
     {
      i++;
      var end = func.indexOf("E", i);
      var size = end - i;
      list.push(func.substr(i, size));
      i += size + 2;
      break;
     }
    case "A":
     {
      var size = parseInt(func.substr(i));
      i += size.toString().length;
      if (func[i] !== "_") throw "?";
      i++;
      list.push(parse(true, 1, true)[0] + " [" + size + "]");
      break;
     }
    case "E":
     break paramLoop;
    default:
     ret += "?" + c;
     break paramLoop;
    }
   }
  }
  if (!allowVoid && list.length === 1 && list[0] === "void") list = [];
  if (rawList) {
   if (ret) {
    list.push(ret + "?");
   }
   return list;
  } else {
   return ret + flushList();
  }
 }
 var parsed = func;
 try {
  if (func == "Object._main" || func == "_main") {
   return "main()";
  }
  if (typeof func === "number") func = Pointer_stringify(func);
  if (func[0] !== "_") return func;
  if (func[1] !== "_") return func;
  if (func[2] !== "Z") return func;
  switch (func[3]) {
  case "n":
   return "operator new()";
  case "d":
   return "operator delete()";
  }
  parsed = parse();
 } catch (e) {
  parsed += "?";
 }
 if (parsed.indexOf("?") >= 0 && !hasLibcxxabi) {
  Runtime.warnOnce("warning: a problem occurred in builtin C++ name demangling; build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");
 }
 return parsed;
}
function demangleAll(text) {
 return text.replace(/__Z[\w\d_]+/g, (function(x) {
  var y = demangle(x);
  return x === y ? x : x + " [" + y + "]";
 }));
}
function jsStackTrace() {
 var err = new Error;
 if (!err.stack) {
  try {
   throw new Error(0);
  } catch (e) {
   err = e;
  }
  if (!err.stack) {
   return "(no stack trace available)";
  }
 }
 return err.stack.toString();
}
function stackTrace() {
 return demangleAll(jsStackTrace());
}
Module["stackTrace"] = stackTrace;
var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
 return x + 4095 & -4096;
}
var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;
var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false;
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0;
var DYNAMIC_BASE = 0, DYNAMICTOP = 0;
function enlargeMemory() {
 abort("Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value " + TOTAL_MEMORY + ", (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.");
}
var TOTAL_STACK = Module["TOTAL_STACK"] || 5242880;
var TOTAL_MEMORY = Module["TOTAL_MEMORY"] || 367772160;
var FAST_MEMORY = Module["FAST_MEMORY"] || 2097152;
var totalMemory = 64 * 1024;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2 * TOTAL_STACK) {
 if (totalMemory < 16 * 1024 * 1024) {
  totalMemory *= 2;
 } else {
  totalMemory += 16 * 1024 * 1024;
 }
}
if (totalMemory !== TOTAL_MEMORY) {
 Module.printErr("increasing TOTAL_MEMORY to " + totalMemory + " to be compliant with the asm.js spec");
 TOTAL_MEMORY = totalMemory;
}
assert(typeof Int32Array !== "undefined" && typeof Float64Array !== "undefined" && !!(new Int32Array(1))["subarray"] && !!(new Int32Array(1))["set"], "JS engine does not provide full typed array support");
var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, "Typed arrays 2 must be run on a little-endian system");
Module["HEAP"] = HEAP;
Module["buffer"] = buffer;
Module["HEAP8"] = HEAP8;
Module["HEAP16"] = HEAP16;
Module["HEAP32"] = HEAP32;
Module["HEAPU8"] = HEAPU8;
Module["HEAPU16"] = HEAPU16;
Module["HEAPU32"] = HEAPU32;
Module["HEAPF32"] = HEAPF32;
Module["HEAPF64"] = HEAPF64;
function callRuntimeCallbacks(callbacks) {
 while (callbacks.length > 0) {
  var callback = callbacks.shift();
  if (typeof callback == "function") {
   callback();
   continue;
  }
  var func = callback.func;
  if (typeof func === "number") {
   if (callback.arg === undefined) {
    Runtime.dynCall("v", func);
   } else {
    Runtime.dynCall("vi", func, [ callback.arg ]);
   }
  } else {
   func(callback.arg === undefined ? null : callback.arg);
  }
 }
}
var __ATPRERUN__ = [];
var __ATINIT__ = [];
var __ATMAIN__ = [];
var __ATEXIT__ = [];
var __ATPOSTRUN__ = [];
var runtimeInitialized = false;
var runtimeExited = false;
function preRun() {
 if (Module["preRun"]) {
  if (typeof Module["preRun"] == "function") Module["preRun"] = [ Module["preRun"] ];
  while (Module["preRun"].length) {
   addOnPreRun(Module["preRun"].shift());
  }
 }
 callRuntimeCallbacks(__ATPRERUN__);
}
function ensureInitRuntime() {
 if (runtimeInitialized) return;
 runtimeInitialized = true;
 callRuntimeCallbacks(__ATINIT__);
}
function preMain() {
 callRuntimeCallbacks(__ATMAIN__);
}
function exitRuntime() {
 callRuntimeCallbacks(__ATEXIT__);
 runtimeExited = true;
}
function postRun() {
 if (Module["postRun"]) {
  if (typeof Module["postRun"] == "function") Module["postRun"] = [ Module["postRun"] ];
  while (Module["postRun"].length) {
   addOnPostRun(Module["postRun"].shift());
  }
 }
 callRuntimeCallbacks(__ATPOSTRUN__);
}
function addOnPreRun(cb) {
 __ATPRERUN__.unshift(cb);
}
Module["addOnPreRun"] = Module.addOnPreRun = addOnPreRun;
function addOnInit(cb) {
 __ATINIT__.unshift(cb);
}
Module["addOnInit"] = Module.addOnInit = addOnInit;
function addOnPreMain(cb) {
 __ATMAIN__.unshift(cb);
}
Module["addOnPreMain"] = Module.addOnPreMain = addOnPreMain;
function addOnExit(cb) {
 __ATEXIT__.unshift(cb);
}
Module["addOnExit"] = Module.addOnExit = addOnExit;
function addOnPostRun(cb) {
 __ATPOSTRUN__.unshift(cb);
}
Module["addOnPostRun"] = Module.addOnPostRun = addOnPostRun;
function intArrayFromString(stringy, dontAddNull, length) {
 var ret = (new Runtime.UTF8Processor).processJSString(stringy);
 if (length) {
  ret.length = length;
 }
 if (!dontAddNull) {
  ret.push(0);
 }
 return ret;
}
Module["intArrayFromString"] = intArrayFromString;
function intArrayToString(array) {
 var ret = [];
 for (var i = 0; i < array.length; i++) {
  var chr = array[i];
  if (chr > 255) {
   chr &= 255;
  }
  ret.push(String.fromCharCode(chr));
 }
 return ret.join("");
}
Module["intArrayToString"] = intArrayToString;
function writeStringToMemory(string, buffer, dontAddNull) {
 var array = intArrayFromString(string, dontAddNull);
 var i = 0;
 while (i < array.length) {
  var chr = array[i];
  HEAP8[buffer + i >> 0] = chr;
  i = i + 1;
 }
}
Module["writeStringToMemory"] = writeStringToMemory;
function writeArrayToMemory(array, buffer) {
 for (var i = 0; i < array.length; i++) {
  HEAP8[buffer + i >> 0] = array[i];
 }
}
Module["writeArrayToMemory"] = writeArrayToMemory;
function writeAsciiToMemory(str, buffer, dontAddNull) {
 for (var i = 0; i < str.length; i++) {
  HEAP8[buffer + i >> 0] = str.charCodeAt(i);
 }
 if (!dontAddNull) HEAP8[buffer + str.length >> 0] = 0;
}
Module["writeAsciiToMemory"] = writeAsciiToMemory;
function unSign(value, bits, ignore) {
 if (value >= 0) {
  return value;
 }
 return bits <= 32 ? 2 * Math.abs(1 << bits - 1) + value : Math.pow(2, bits) + value;
}
function reSign(value, bits, ignore) {
 if (value <= 0) {
  return value;
 }
 var half = bits <= 32 ? Math.abs(1 << bits - 1) : Math.pow(2, bits - 1);
 if (value >= half && (bits <= 32 || value > half)) {
  value = -2 * half + value;
 }
 return value;
}
if (!Math["imul"] || Math["imul"](4294967295, 5) !== -5) Math["imul"] = function imul(a, b) {
 var ah = a >>> 16;
 var al = a & 65535;
 var bh = b >>> 16;
 var bl = b & 65535;
 return al * bl + (ah * bl + al * bh << 16) | 0;
};
Math.imul = Math["imul"];
if (!Math["fround"]) {
 var froundBuffer = new Float32Array(1);
 Math["fround"] = (function(x) {
  froundBuffer[0] = x;
  return froundBuffer[0];
 });
}
Math.fround = Math["fround"];
var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null;
function addRunDependency(id) {
 runDependencies++;
 if (Module["monitorRunDependencies"]) {
  Module["monitorRunDependencies"](runDependencies);
 }
}
Module["addRunDependency"] = addRunDependency;
function removeRunDependency(id) {
 runDependencies--;
 if (Module["monitorRunDependencies"]) {
  Module["monitorRunDependencies"](runDependencies);
 }
 if (runDependencies == 0) {
  if (runDependencyWatcher !== null) {
   clearInterval(runDependencyWatcher);
   runDependencyWatcher = null;
  }
  if (dependenciesFulfilled) {
   var callback = dependenciesFulfilled;
   dependenciesFulfilled = null;
   callback();
  }
 }
}
Module["removeRunDependency"] = removeRunDependency;
Module["preloadedImages"] = {};
Module["preloadedAudios"] = {};
var memoryInitializer = null;
STATIC_BASE = 8;
STATICTOP = STATIC_BASE + 971664;
__ATINIT__.push({
 func: (function() {
  __GLOBAL__I_a();
 })
}, {
 func: (function() {
  __GLOBAL__I_a147();
 })
}, {
 func: (function() {
  __GLOBAL__I_a270();
 })
}, {
 func: (function() {
  __GLOBAL__I_a320();
 })
}, {
 func: (function() {
  __GLOBAL__I_a392();
 })
}, {
 func: (function() {
  __GLOBAL__I_a1405();
 })
}, {
 func: (function() {
  __GLOBAL__I_a325();
 })
}, {
 func: (function() {
  __GLOBAL__I_a743();
 })
}, {
 func: (function() {
  __GLOBAL__I_a1055();
 })
}, {
 func: (function() {
  __GLOBAL__I_a1104();
 })
}, {
 func: (function() {
  __GLOBAL__I_a1556();
 })
}, {
 func: (function() {
  __GLOBAL__I_a187();
 })
}, {
 func: (function() {
  __GLOBAL__I_a530();
 })
}, {
 func: (function() {
  __GLOBAL__I_a1585();
 })
}, {
 func: (function() {
  __GLOBAL__I_a1953();
 })
});
var memoryInitializer = "opencv_perf_core.html.mem";
var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);
assert(tempDoublePtr % 8 == 0);
function copyTempFloat(ptr) {
 HEAP8[tempDoublePtr] = HEAP8[ptr];
 HEAP8[tempDoublePtr + 1] = HEAP8[ptr + 1];
 HEAP8[tempDoublePtr + 2] = HEAP8[ptr + 2];
 HEAP8[tempDoublePtr + 3] = HEAP8[ptr + 3];
}
function copyTempDouble(ptr) {
 HEAP8[tempDoublePtr] = HEAP8[ptr];
 HEAP8[tempDoublePtr + 1] = HEAP8[ptr + 1];
 HEAP8[tempDoublePtr + 2] = HEAP8[ptr + 2];
 HEAP8[tempDoublePtr + 3] = HEAP8[ptr + 3];
 HEAP8[tempDoublePtr + 4] = HEAP8[ptr + 4];
 HEAP8[tempDoublePtr + 5] = HEAP8[ptr + 5];
 HEAP8[tempDoublePtr + 6] = HEAP8[ptr + 6];
 HEAP8[tempDoublePtr + 7] = HEAP8[ptr + 7];
}
function _atexit(func, arg) {
 __ATEXIT__.unshift({
  func: func,
  arg: arg
 });
}
function ___cxa_atexit() {
 return _atexit.apply(null, arguments);
}
var ERRNO_CODES = {
 EPERM: 1,
 ENOENT: 2,
 ESRCH: 3,
 EINTR: 4,
 EIO: 5,
 ENXIO: 6,
 E2BIG: 7,
 ENOEXEC: 8,
 EBADF: 9,
 ECHILD: 10,
 EAGAIN: 11,
 EWOULDBLOCK: 11,
 ENOMEM: 12,
 EACCES: 13,
 EFAULT: 14,
 ENOTBLK: 15,
 EBUSY: 16,
 EEXIST: 17,
 EXDEV: 18,
 ENODEV: 19,
 ENOTDIR: 20,
 EISDIR: 21,
 EINVAL: 22,
 ENFILE: 23,
 EMFILE: 24,
 ENOTTY: 25,
 ETXTBSY: 26,
 EFBIG: 27,
 ENOSPC: 28,
 ESPIPE: 29,
 EROFS: 30,
 EMLINK: 31,
 EPIPE: 32,
 EDOM: 33,
 ERANGE: 34,
 ENOMSG: 42,
 EIDRM: 43,
 ECHRNG: 44,
 EL2NSYNC: 45,
 EL3HLT: 46,
 EL3RST: 47,
 ELNRNG: 48,
 EUNATCH: 49,
 ENOCSI: 50,
 EL2HLT: 51,
 EDEADLK: 35,
 ENOLCK: 37,
 EBADE: 52,
 EBADR: 53,
 EXFULL: 54,
 ENOANO: 55,
 EBADRQC: 56,
 EBADSLT: 57,
 EDEADLOCK: 35,
 EBFONT: 59,
 ENOSTR: 60,
 ENODATA: 61,
 ETIME: 62,
 ENOSR: 63,
 ENONET: 64,
 ENOPKG: 65,
 EREMOTE: 66,
 ENOLINK: 67,
 EADV: 68,
 ESRMNT: 69,
 ECOMM: 70,
 EPROTO: 71,
 EMULTIHOP: 72,
 EDOTDOT: 73,
 EBADMSG: 74,
 ENOTUNIQ: 76,
 EBADFD: 77,
 EREMCHG: 78,
 ELIBACC: 79,
 ELIBBAD: 80,
 ELIBSCN: 81,
 ELIBMAX: 82,
 ELIBEXEC: 83,
 ENOSYS: 38,
 ENOTEMPTY: 39,
 ENAMETOOLONG: 36,
 ELOOP: 40,
 EOPNOTSUPP: 95,
 EPFNOSUPPORT: 96,
 ECONNRESET: 104,
 ENOBUFS: 105,
 EAFNOSUPPORT: 97,
 EPROTOTYPE: 91,
 ENOTSOCK: 88,
 ENOPROTOOPT: 92,
 ESHUTDOWN: 108,
 ECONNREFUSED: 111,
 EADDRINUSE: 98,
 ECONNABORTED: 103,
 ENETUNREACH: 101,
 ENETDOWN: 100,
 ETIMEDOUT: 110,
 EHOSTDOWN: 112,
 EHOSTUNREACH: 113,
 EINPROGRESS: 115,
 EALREADY: 114,
 EDESTADDRREQ: 89,
 EMSGSIZE: 90,
 EPROTONOSUPPORT: 93,
 ESOCKTNOSUPPORT: 94,
 EADDRNOTAVAIL: 99,
 ENETRESET: 102,
 EISCONN: 106,
 ENOTCONN: 107,
 ETOOMANYREFS: 109,
 EUSERS: 87,
 EDQUOT: 122,
 ESTALE: 116,
 ENOTSUP: 95,
 ENOMEDIUM: 123,
 EILSEQ: 84,
 EOVERFLOW: 75,
 ECANCELED: 125,
 ENOTRECOVERABLE: 131,
 EOWNERDEAD: 130,
 ESTRPIPE: 86
};
var ERRNO_MESSAGES = {
 0: "Success",
 1: "Not super-user",
 2: "No such file or directory",
 3: "No such process",
 4: "Interrupted system call",
 5: "I/O error",
 6: "No such device or address",
 7: "Arg list too long",
 8: "Exec format error",
 9: "Bad file number",
 10: "No children",
 11: "No more processes",
 12: "Not enough core",
 13: "Permission denied",
 14: "Bad address",
 15: "Block device required",
 16: "Mount device busy",
 17: "File exists",
 18: "Cross-device link",
 19: "No such device",
 20: "Not a directory",
 21: "Is a directory",
 22: "Invalid argument",
 23: "Too many open files in system",
 24: "Too many open files",
 25: "Not a typewriter",
 26: "Text file busy",
 27: "File too large",
 28: "No space left on device",
 29: "Illegal seek",
 30: "Read only file system",
 31: "Too many links",
 32: "Broken pipe",
 33: "Math arg out of domain of func",
 34: "Math result not representable",
 35: "File locking deadlock error",
 36: "File or path name too long",
 37: "No record locks available",
 38: "Function not implemented",
 39: "Directory not empty",
 40: "Too many symbolic links",
 42: "No message of desired type",
 43: "Identifier removed",
 44: "Channel number out of range",
 45: "Level 2 not synchronized",
 46: "Level 3 halted",
 47: "Level 3 reset",
 48: "Link number out of range",
 49: "Protocol driver not attached",
 50: "No CSI structure available",
 51: "Level 2 halted",
 52: "Invalid exchange",
 53: "Invalid request descriptor",
 54: "Exchange full",
 55: "No anode",
 56: "Invalid request code",
 57: "Invalid slot",
 59: "Bad font file fmt",
 60: "Device not a stream",
 61: "No data (for no delay io)",
 62: "Timer expired",
 63: "Out of streams resources",
 64: "Machine is not on the network",
 65: "Package not installed",
 66: "The object is remote",
 67: "The link has been severed",
 68: "Advertise error",
 69: "Srmount error",
 70: "Communication error on send",
 71: "Protocol error",
 72: "Multihop attempted",
 73: "Cross mount point (not really error)",
 74: "Trying to read unreadable message",
 75: "Value too large for defined data type",
 76: "Given log. name not unique",
 77: "f.d. invalid for this operation",
 78: "Remote address changed",
 79: "Can   access a needed shared lib",
 80: "Accessing a corrupted shared lib",
 81: ".lib section in a.out corrupted",
 82: "Attempting to link in too many libs",
 83: "Attempting to exec a shared library",
 84: "Illegal byte sequence",
 86: "Streams pipe error",
 87: "Too many users",
 88: "Socket operation on non-socket",
 89: "Destination address required",
 90: "Message too long",
 91: "Protocol wrong type for socket",
 92: "Protocol not available",
 93: "Unknown protocol",
 94: "Socket type not supported",
 95: "Not supported",
 96: "Protocol family not supported",
 97: "Address family not supported by protocol family",
 98: "Address already in use",
 99: "Address not available",
 100: "Network interface is not configured",
 101: "Network is unreachable",
 102: "Connection reset by network",
 103: "Connection aborted",
 104: "Connection reset by peer",
 105: "No buffer space available",
 106: "Socket is already connected",
 107: "Socket is not connected",
 108: "Can't send after socket shutdown",
 109: "Too many references",
 110: "Connection timed out",
 111: "Connection refused",
 112: "Host is down",
 113: "Host is unreachable",
 114: "Socket already connected",
 115: "Connection already in progress",
 116: "Stale file handle",
 122: "Quota exceeded",
 123: "No medium (in tape drive)",
 125: "Operation canceled",
 130: "Previous owner died",
 131: "State not recoverable"
};
var ___errno_state = 0;
function ___setErrNo(value) {
 HEAP32[___errno_state >> 2] = value;
 return value;
}
var PATH = {
 splitPath: (function(filename) {
  var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
  return splitPathRe.exec(filename).slice(1);
 }),
 normalizeArray: (function(parts, allowAboveRoot) {
  var up = 0;
  for (var i = parts.length - 1; i >= 0; i--) {
   var last = parts[i];
   if (last === ".") {
    parts.splice(i, 1);
   } else if (last === "..") {
    parts.splice(i, 1);
    up++;
   } else if (up) {
    parts.splice(i, 1);
    up--;
   }
  }
  if (allowAboveRoot) {
   for (; up--; up) {
    parts.unshift("..");
   }
  }
  return parts;
 }),
 normalize: (function(path) {
  var isAbsolute = path.charAt(0) === "/", trailingSlash = path.substr(-1) === "/";
  path = PATH.normalizeArray(path.split("/").filter((function(p) {
   return !!p;
  })), !isAbsolute).join("/");
  if (!path && !isAbsolute) {
   path = ".";
  }
  if (path && trailingSlash) {
   path += "/";
  }
  return (isAbsolute ? "/" : "") + path;
 }),
 dirname: (function(path) {
  var result = PATH.splitPath(path), root = result[0], dir = result[1];
  if (!root && !dir) {
   return ".";
  }
  if (dir) {
   dir = dir.substr(0, dir.length - 1);
  }
  return root + dir;
 }),
 basename: (function(path) {
  if (path === "/") return "/";
  var lastSlash = path.lastIndexOf("/");
  if (lastSlash === -1) return path;
  return path.substr(lastSlash + 1);
 }),
 extname: (function(path) {
  return PATH.splitPath(path)[3];
 }),
 join: (function() {
  var paths = Array.prototype.slice.call(arguments, 0);
  return PATH.normalize(paths.join("/"));
 }),
 join2: (function(l, r) {
  return PATH.normalize(l + "/" + r);
 }),
 resolve: (function() {
  var resolvedPath = "", resolvedAbsolute = false;
  for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
   var path = i >= 0 ? arguments[i] : FS.cwd();
   if (typeof path !== "string") {
    throw new TypeError("Arguments to path.resolve must be strings");
   } else if (!path) {
    return "";
   }
   resolvedPath = path + "/" + resolvedPath;
   resolvedAbsolute = path.charAt(0) === "/";
  }
  resolvedPath = PATH.normalizeArray(resolvedPath.split("/").filter((function(p) {
   return !!p;
  })), !resolvedAbsolute).join("/");
  return (resolvedAbsolute ? "/" : "") + resolvedPath || ".";
 }),
 relative: (function(from, to) {
  from = PATH.resolve(from).substr(1);
  to = PATH.resolve(to).substr(1);
  function trim(arr) {
   var start = 0;
   for (; start < arr.length; start++) {
    if (arr[start] !== "") break;
   }
   var end = arr.length - 1;
   for (; end >= 0; end--) {
    if (arr[end] !== "") break;
   }
   if (start > end) return [];
   return arr.slice(start, end - start + 1);
  }
  var fromParts = trim(from.split("/"));
  var toParts = trim(to.split("/"));
  var length = Math.min(fromParts.length, toParts.length);
  var samePartsLength = length;
  for (var i = 0; i < length; i++) {
   if (fromParts[i] !== toParts[i]) {
    samePartsLength = i;
    break;
   }
  }
  var outputParts = [];
  for (var i = samePartsLength; i < fromParts.length; i++) {
   outputParts.push("..");
  }
  outputParts = outputParts.concat(toParts.slice(samePartsLength));
  return outputParts.join("/");
 })
};
var TTY = {
 ttys: [],
 init: (function() {}),
 shutdown: (function() {}),
 register: (function(dev, ops) {
  TTY.ttys[dev] = {
   input: [],
   output: [],
   ops: ops
  };
  FS.registerDevice(dev, TTY.stream_ops);
 }),
 stream_ops: {
  open: (function(stream) {
   var tty = TTY.ttys[stream.node.rdev];
   if (!tty) {
    throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
   }
   stream.tty = tty;
   stream.seekable = false;
  }),
  close: (function(stream) {
   stream.tty.ops.flush(stream.tty);
  }),
  flush: (function(stream) {
   stream.tty.ops.flush(stream.tty);
  }),
  read: (function(stream, buffer, offset, length, pos) {
   if (!stream.tty || !stream.tty.ops.get_char) {
    throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
   }
   var bytesRead = 0;
   for (var i = 0; i < length; i++) {
    var result;
    try {
     result = stream.tty.ops.get_char(stream.tty);
    } catch (e) {
     throw new FS.ErrnoError(ERRNO_CODES.EIO);
    }
    if (result === undefined && bytesRead === 0) {
     throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
    }
    if (result === null || result === undefined) break;
    bytesRead++;
    buffer[offset + i] = result;
   }
   if (bytesRead) {
    stream.node.timestamp = Date.now();
   }
   return bytesRead;
  }),
  write: (function(stream, buffer, offset, length, pos) {
   if (!stream.tty || !stream.tty.ops.put_char) {
    throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
   }
   for (var i = 0; i < length; i++) {
    try {
     stream.tty.ops.put_char(stream.tty, buffer[offset + i]);
    } catch (e) {
     throw new FS.ErrnoError(ERRNO_CODES.EIO);
    }
   }
   if (length) {
    stream.node.timestamp = Date.now();
   }
   return i;
  })
 },
 default_tty_ops: {
  get_char: (function(tty) {
   if (!tty.input.length) {
    var result = null;
    if (ENVIRONMENT_IS_NODE) {
     result = process["stdin"]["read"]();
     if (!result) {
      if (process["stdin"]["_readableState"] && process["stdin"]["_readableState"]["ended"]) {
       return null;
      }
      return undefined;
     }
    } else if (typeof window != "undefined" && typeof window.prompt == "function") {
     result = window.prompt("Input: ");
     if (result !== null) {
      result += "\n";
     }
    } else if (typeof readline == "function") {
     result = readline();
     if (result !== null) {
      result += "\n";
     }
    }
    if (!result) {
     return null;
    }
    tty.input = intArrayFromString(result, true);
   }
   return tty.input.shift();
  }),
  flush: (function(tty) {
   if (tty.output && tty.output.length > 0) {
    Module["print"](tty.output.join(""));
    tty.output = [];
   }
  }),
  put_char: (function(tty, val) {
   if (val === null || val === 10) {
    Module["print"](tty.output.join(""));
    tty.output = [];
   } else {
    tty.output.push(TTY.utf8.processCChar(val));
   }
  })
 },
 default_tty1_ops: {
  put_char: (function(tty, val) {
   if (val === null || val === 10) {
    Module["printErr"](tty.output.join(""));
    tty.output = [];
   } else {
    tty.output.push(TTY.utf8.processCChar(val));
   }
  }),
  flush: (function(tty) {
   if (tty.output && tty.output.length > 0) {
    Module["printErr"](tty.output.join(""));
    tty.output = [];
   }
  })
 }
};
var MEMFS = {
 ops_table: null,
 mount: (function(mount) {
  return MEMFS.createNode(null, "/", 16384 | 511, 0);
 }),
 createNode: (function(parent, name, mode, dev) {
  if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (!MEMFS.ops_table) {
   MEMFS.ops_table = {
    dir: {
     node: {
      getattr: MEMFS.node_ops.getattr,
      setattr: MEMFS.node_ops.setattr,
      lookup: MEMFS.node_ops.lookup,
      mknod: MEMFS.node_ops.mknod,
      rename: MEMFS.node_ops.rename,
      unlink: MEMFS.node_ops.unlink,
      rmdir: MEMFS.node_ops.rmdir,
      readdir: MEMFS.node_ops.readdir,
      symlink: MEMFS.node_ops.symlink
     },
     stream: {
      llseek: MEMFS.stream_ops.llseek
     }
    },
    file: {
     node: {
      getattr: MEMFS.node_ops.getattr,
      setattr: MEMFS.node_ops.setattr
     },
     stream: {
      llseek: MEMFS.stream_ops.llseek,
      read: MEMFS.stream_ops.read,
      write: MEMFS.stream_ops.write,
      allocate: MEMFS.stream_ops.allocate,
      mmap: MEMFS.stream_ops.mmap
     }
    },
    link: {
     node: {
      getattr: MEMFS.node_ops.getattr,
      setattr: MEMFS.node_ops.setattr,
      readlink: MEMFS.node_ops.readlink
     },
     stream: {}
    },
    chrdev: {
     node: {
      getattr: MEMFS.node_ops.getattr,
      setattr: MEMFS.node_ops.setattr
     },
     stream: FS.chrdev_stream_ops
    }
   };
  }
  var node = FS.createNode(parent, name, mode, dev);
  if (FS.isDir(node.mode)) {
   node.node_ops = MEMFS.ops_table.dir.node;
   node.stream_ops = MEMFS.ops_table.dir.stream;
   node.contents = {};
  } else if (FS.isFile(node.mode)) {
   node.node_ops = MEMFS.ops_table.file.node;
   node.stream_ops = MEMFS.ops_table.file.stream;
   node.usedBytes = 0;
   node.contents = null;
  } else if (FS.isLink(node.mode)) {
   node.node_ops = MEMFS.ops_table.link.node;
   node.stream_ops = MEMFS.ops_table.link.stream;
  } else if (FS.isChrdev(node.mode)) {
   node.node_ops = MEMFS.ops_table.chrdev.node;
   node.stream_ops = MEMFS.ops_table.chrdev.stream;
  }
  node.timestamp = Date.now();
  if (parent) {
   parent.contents[name] = node;
  }
  return node;
 }),
 getFileDataAsRegularArray: (function(node) {
  if (node.contents && node.contents.subarray) {
   var arr = [];
   for (var i = 0; i < node.usedBytes; ++i) arr.push(node.contents[i]);
   return arr;
  }
  return node.contents;
 }),
 getFileDataAsTypedArray: (function(node) {
  if (!node.contents) return new Uint8Array;
  if (node.contents.subarray) return node.contents.subarray(0, node.usedBytes);
  return new Uint8Array(node.contents);
 }),
 expandFileStorage: (function(node, newCapacity) {
  if (node.contents && node.contents.subarray && newCapacity > node.contents.length) {
   node.contents = MEMFS.getFileDataAsRegularArray(node);
   node.usedBytes = node.contents.length;
  }
  if (!node.contents || node.contents.subarray) {
   var prevCapacity = node.contents ? node.contents.buffer.byteLength : 0;
   if (prevCapacity >= newCapacity) return;
   var CAPACITY_DOUBLING_MAX = 1024 * 1024;
   newCapacity = Math.max(newCapacity, prevCapacity * (prevCapacity < CAPACITY_DOUBLING_MAX ? 2 : 1.125) | 0);
   if (prevCapacity != 0) newCapacity = Math.max(newCapacity, 256);
   var oldContents = node.contents;
   node.contents = new Uint8Array(newCapacity);
   if (node.usedBytes > 0) node.contents.set(oldContents.subarray(0, node.usedBytes), 0);
   return;
  }
  if (!node.contents && newCapacity > 0) node.contents = [];
  while (node.contents.length < newCapacity) node.contents.push(0);
 }),
 resizeFileStorage: (function(node, newSize) {
  if (node.usedBytes == newSize) return;
  if (newSize == 0) {
   node.contents = null;
   node.usedBytes = 0;
   return;
  }
  if (!node.contents || node.contents.subarray) {
   var oldContents = node.contents;
   node.contents = new Uint8Array(new ArrayBuffer(newSize));
   if (oldContents) {
    node.contents.set(oldContents.subarray(0, Math.min(newSize, node.usedBytes)));
   }
   node.usedBytes = newSize;
   return;
  }
  if (!node.contents) node.contents = [];
  if (node.contents.length > newSize) node.contents.length = newSize; else while (node.contents.length < newSize) node.contents.push(0);
  node.usedBytes = newSize;
 }),
 node_ops: {
  getattr: (function(node) {
   var attr = {};
   attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
   attr.ino = node.id;
   attr.mode = node.mode;
   attr.nlink = 1;
   attr.uid = 0;
   attr.gid = 0;
   attr.rdev = node.rdev;
   if (FS.isDir(node.mode)) {
    attr.size = 4096;
   } else if (FS.isFile(node.mode)) {
    attr.size = node.usedBytes;
   } else if (FS.isLink(node.mode)) {
    attr.size = node.link.length;
   } else {
    attr.size = 0;
   }
   attr.atime = new Date(node.timestamp);
   attr.mtime = new Date(node.timestamp);
   attr.ctime = new Date(node.timestamp);
   attr.blksize = 4096;
   attr.blocks = Math.ceil(attr.size / attr.blksize);
   return attr;
  }),
  setattr: (function(node, attr) {
   if (attr.mode !== undefined) {
    node.mode = attr.mode;
   }
   if (attr.timestamp !== undefined) {
    node.timestamp = attr.timestamp;
   }
   if (attr.size !== undefined) {
    MEMFS.resizeFileStorage(node, attr.size);
   }
  }),
  lookup: (function(parent, name) {
   throw FS.genericErrors[ERRNO_CODES.ENOENT];
  }),
  mknod: (function(parent, name, mode, dev) {
   return MEMFS.createNode(parent, name, mode, dev);
  }),
  rename: (function(old_node, new_dir, new_name) {
   if (FS.isDir(old_node.mode)) {
    var new_node;
    try {
     new_node = FS.lookupNode(new_dir, new_name);
    } catch (e) {}
    if (new_node) {
     for (var i in new_node.contents) {
      throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
     }
    }
   }
   delete old_node.parent.contents[old_node.name];
   old_node.name = new_name;
   new_dir.contents[new_name] = old_node;
   old_node.parent = new_dir;
  }),
  unlink: (function(parent, name) {
   delete parent.contents[name];
  }),
  rmdir: (function(parent, name) {
   var node = FS.lookupNode(parent, name);
   for (var i in node.contents) {
    throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
   }
   delete parent.contents[name];
  }),
  readdir: (function(node) {
   var entries = [ ".", ".." ];
   for (var key in node.contents) {
    if (!node.contents.hasOwnProperty(key)) {
     continue;
    }
    entries.push(key);
   }
   return entries;
  }),
  symlink: (function(parent, newname, oldpath) {
   var node = MEMFS.createNode(parent, newname, 511 | 40960, 0);
   node.link = oldpath;
   return node;
  }),
  readlink: (function(node) {
   if (!FS.isLink(node.mode)) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   return node.link;
  })
 },
 stream_ops: {
  read: (function(stream, buffer, offset, length, position) {
   var contents = stream.node.contents;
   if (position >= stream.node.usedBytes) return 0;
   var size = Math.min(stream.node.usedBytes - position, length);
   assert(size >= 0);
   if (size > 8 && contents.subarray) {
    buffer.set(contents.subarray(position, position + size), offset);
   } else {
    for (var i = 0; i < size; i++) buffer[offset + i] = contents[position + i];
   }
   return size;
  }),
  write: (function(stream, buffer, offset, length, position, canOwn) {
   if (!length) return 0;
   var node = stream.node;
   node.timestamp = Date.now();
   if (buffer.subarray && (!node.contents || node.contents.subarray)) {
    if (canOwn) {
     node.contents = buffer.subarray(offset, offset + length);
     node.usedBytes = length;
     return length;
    } else if (node.usedBytes === 0 && position === 0) {
     node.contents = new Uint8Array(buffer.subarray(offset, offset + length));
     node.usedBytes = length;
     return length;
    } else if (position + length <= node.usedBytes) {
     node.contents.set(buffer.subarray(offset, offset + length), position);
     return length;
    }
   }
   MEMFS.expandFileStorage(node, position + length);
   if (node.contents.subarray && buffer.subarray) node.contents.set(buffer.subarray(offset, offset + length), position); else for (var i = 0; i < length; i++) {
    node.contents[position + i] = buffer[offset + i];
   }
   node.usedBytes = Math.max(node.usedBytes, position + length);
   return length;
  }),
  llseek: (function(stream, offset, whence) {
   var position = offset;
   if (whence === 1) {
    position += stream.position;
   } else if (whence === 2) {
    if (FS.isFile(stream.node.mode)) {
     position += stream.node.usedBytes;
    }
   }
   if (position < 0) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   return position;
  }),
  allocate: (function(stream, offset, length) {
   MEMFS.expandFileStorage(stream.node, offset + length);
   stream.node.usedBytes = Math.max(stream.node.usedBytes, offset + length);
  }),
  mmap: (function(stream, buffer, offset, length, position, prot, flags) {
   if (!FS.isFile(stream.node.mode)) {
    throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
   }
   var ptr;
   var allocated;
   var contents = stream.node.contents;
   if (!(flags & 2) && (contents.buffer === buffer || contents.buffer === buffer.buffer)) {
    allocated = false;
    ptr = contents.byteOffset;
   } else {
    if (position > 0 || position + length < stream.node.usedBytes) {
     if (contents.subarray) {
      contents = contents.subarray(position, position + length);
     } else {
      contents = Array.prototype.slice.call(contents, position, position + length);
     }
    }
    allocated = true;
    ptr = _malloc(length);
    if (!ptr) {
     throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
    }
    buffer.set(contents, ptr);
   }
   return {
    ptr: ptr,
    allocated: allocated
   };
  })
 }
};
var IDBFS = {
 dbs: {},
 indexedDB: (function() {
  if (typeof indexedDB !== "undefined") return indexedDB;
  var ret = null;
  if (typeof window === "object") ret = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
  assert(ret, "IDBFS used, but indexedDB not supported");
  return ret;
 }),
 DB_VERSION: 21,
 DB_STORE_NAME: "FILE_DATA",
 mount: (function(mount) {
  return MEMFS.mount.apply(null, arguments);
 }),
 syncfs: (function(mount, populate, callback) {
  IDBFS.getLocalSet(mount, (function(err, local) {
   if (err) return callback(err);
   IDBFS.getRemoteSet(mount, (function(err, remote) {
    if (err) return callback(err);
    var src = populate ? remote : local;
    var dst = populate ? local : remote;
    IDBFS.reconcile(src, dst, callback);
   }));
  }));
 }),
 getDB: (function(name, callback) {
  var db = IDBFS.dbs[name];
  if (db) {
   return callback(null, db);
  }
  var req;
  try {
   req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
  } catch (e) {
   return callback(e);
  }
  req.onupgradeneeded = (function(e) {
   var db = e.target.result;
   var transaction = e.target.transaction;
   var fileStore;
   if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
    fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
   } else {
    fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
   }
   fileStore.createIndex("timestamp", "timestamp", {
    unique: false
   });
  });
  req.onsuccess = (function() {
   db = req.result;
   IDBFS.dbs[name] = db;
   callback(null, db);
  });
  req.onerror = (function() {
   callback(this.error);
  });
 }),
 getLocalSet: (function(mount, callback) {
  var entries = {};
  function isRealDir(p) {
   return p !== "." && p !== "..";
  }
  function toAbsolute(root) {
   return (function(p) {
    return PATH.join2(root, p);
   });
  }
  var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  while (check.length) {
   var path = check.pop();
   var stat;
   try {
    stat = FS.stat(path);
   } catch (e) {
    return callback(e);
   }
   if (FS.isDir(stat.mode)) {
    check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
   }
   entries[path] = {
    timestamp: stat.mtime
   };
  }
  return callback(null, {
   type: "local",
   entries: entries
  });
 }),
 getRemoteSet: (function(mount, callback) {
  var entries = {};
  IDBFS.getDB(mount.mountpoint, (function(err, db) {
   if (err) return callback(err);
   var transaction = db.transaction([ IDBFS.DB_STORE_NAME ], "readonly");
   transaction.onerror = (function() {
    callback(this.error);
   });
   var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
   var index = store.index("timestamp");
   index.openKeyCursor().onsuccess = (function(event) {
    var cursor = event.target.result;
    if (!cursor) {
     return callback(null, {
      type: "remote",
      db: db,
      entries: entries
     });
    }
    entries[cursor.primaryKey] = {
     timestamp: cursor.key
    };
    cursor.continue();
   });
  }));
 }),
 loadLocalEntry: (function(path, callback) {
  var stat, node;
  try {
   var lookup = FS.lookupPath(path);
   node = lookup.node;
   stat = FS.stat(path);
  } catch (e) {
   return callback(e);
  }
  if (FS.isDir(stat.mode)) {
   return callback(null, {
    timestamp: stat.mtime,
    mode: stat.mode
   });
  } else if (FS.isFile(stat.mode)) {
   node.contents = MEMFS.getFileDataAsTypedArray(node);
   return callback(null, {
    timestamp: stat.mtime,
    mode: stat.mode,
    contents: node.contents
   });
  } else {
   return callback(new Error("node type not supported"));
  }
 }),
 storeLocalEntry: (function(path, entry, callback) {
  try {
   if (FS.isDir(entry.mode)) {
    FS.mkdir(path, entry.mode);
   } else if (FS.isFile(entry.mode)) {
    FS.writeFile(path, entry.contents, {
     encoding: "binary",
     canOwn: true
    });
   } else {
    return callback(new Error("node type not supported"));
   }
   FS.chmod(path, entry.mode);
   FS.utime(path, entry.timestamp, entry.timestamp);
  } catch (e) {
   return callback(e);
  }
  callback(null);
 }),
 removeLocalEntry: (function(path, callback) {
  try {
   var lookup = FS.lookupPath(path);
   var stat = FS.stat(path);
   if (FS.isDir(stat.mode)) {
    FS.rmdir(path);
   } else if (FS.isFile(stat.mode)) {
    FS.unlink(path);
   }
  } catch (e) {
   return callback(e);
  }
  callback(null);
 }),
 loadRemoteEntry: (function(store, path, callback) {
  var req = store.get(path);
  req.onsuccess = (function(event) {
   callback(null, event.target.result);
  });
  req.onerror = (function() {
   callback(this.error);
  });
 }),
 storeRemoteEntry: (function(store, path, entry, callback) {
  var req = store.put(entry, path);
  req.onsuccess = (function() {
   callback(null);
  });
  req.onerror = (function() {
   callback(this.error);
  });
 }),
 removeRemoteEntry: (function(store, path, callback) {
  var req = store.delete(path);
  req.onsuccess = (function() {
   callback(null);
  });
  req.onerror = (function() {
   callback(this.error);
  });
 }),
 reconcile: (function(src, dst, callback) {
  var total = 0;
  var create = [];
  Object.keys(src.entries).forEach((function(key) {
   var e = src.entries[key];
   var e2 = dst.entries[key];
   if (!e2 || e.timestamp > e2.timestamp) {
    create.push(key);
    total++;
   }
  }));
  var remove = [];
  Object.keys(dst.entries).forEach((function(key) {
   var e = dst.entries[key];
   var e2 = src.entries[key];
   if (!e2) {
    remove.push(key);
    total++;
   }
  }));
  if (!total) {
   return callback(null);
  }
  var errored = false;
  var completed = 0;
  var db = src.type === "remote" ? src.db : dst.db;
  var transaction = db.transaction([ IDBFS.DB_STORE_NAME ], "readwrite");
  var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  function done(err) {
   if (err) {
    if (!done.errored) {
     done.errored = true;
     return callback(err);
    }
    return;
   }
   if (++completed >= total) {
    return callback(null);
   }
  }
  transaction.onerror = (function() {
   done(this.error);
  });
  create.sort().forEach((function(path) {
   if (dst.type === "local") {
    IDBFS.loadRemoteEntry(store, path, (function(err, entry) {
     if (err) return done(err);
     IDBFS.storeLocalEntry(path, entry, done);
    }));
   } else {
    IDBFS.loadLocalEntry(path, (function(err, entry) {
     if (err) return done(err);
     IDBFS.storeRemoteEntry(store, path, entry, done);
    }));
   }
  }));
  remove.sort().reverse().forEach((function(path) {
   if (dst.type === "local") {
    IDBFS.removeLocalEntry(path, done);
   } else {
    IDBFS.removeRemoteEntry(store, path, done);
   }
  }));
 })
};
var NODEFS = {
 isWindows: false,
 staticInit: (function() {
  NODEFS.isWindows = !!process.platform.match(/^win/);
 }),
 mount: (function(mount) {
  assert(ENVIRONMENT_IS_NODE);
  return NODEFS.createNode(null, "/", NODEFS.getMode(mount.opts.root), 0);
 }),
 createNode: (function(parent, name, mode, dev) {
  if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var node = FS.createNode(parent, name, mode);
  node.node_ops = NODEFS.node_ops;
  node.stream_ops = NODEFS.stream_ops;
  return node;
 }),
 getMode: (function(path) {
  var stat;
  try {
   stat = fs.lstatSync(path);
   if (NODEFS.isWindows) {
    stat.mode = stat.mode | (stat.mode & 146) >> 1;
   }
  } catch (e) {
   if (!e.code) throw e;
   throw new FS.ErrnoError(ERRNO_CODES[e.code]);
  }
  return stat.mode;
 }),
 realPath: (function(node) {
  var parts = [];
  while (node.parent !== node) {
   parts.push(node.name);
   node = node.parent;
  }
  parts.push(node.mount.opts.root);
  parts.reverse();
  return PATH.join.apply(null, parts);
 }),
 flagsToPermissionStringMap: {
  0: "r",
  1: "r+",
  2: "r+",
  64: "r",
  65: "r+",
  66: "r+",
  129: "rx+",
  193: "rx+",
  514: "w+",
  577: "w",
  578: "w+",
  705: "wx",
  706: "wx+",
  1024: "a",
  1025: "a",
  1026: "a+",
  1089: "a",
  1090: "a+",
  1153: "ax",
  1154: "ax+",
  1217: "ax",
  1218: "ax+",
  4096: "rs",
  4098: "rs+"
 },
 flagsToPermissionString: (function(flags) {
  if (flags in NODEFS.flagsToPermissionStringMap) {
   return NODEFS.flagsToPermissionStringMap[flags];
  } else {
   return flags;
  }
 }),
 node_ops: {
  getattr: (function(node) {
   var path = NODEFS.realPath(node);
   var stat;
   try {
    stat = fs.lstatSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
   if (NODEFS.isWindows && !stat.blksize) {
    stat.blksize = 4096;
   }
   if (NODEFS.isWindows && !stat.blocks) {
    stat.blocks = (stat.size + stat.blksize - 1) / stat.blksize | 0;
   }
   return {
    dev: stat.dev,
    ino: stat.ino,
    mode: stat.mode,
    nlink: stat.nlink,
    uid: stat.uid,
    gid: stat.gid,
    rdev: stat.rdev,
    size: stat.size,
    atime: stat.atime,
    mtime: stat.mtime,
    ctime: stat.ctime,
    blksize: stat.blksize,
    blocks: stat.blocks
   };
  }),
  setattr: (function(node, attr) {
   var path = NODEFS.realPath(node);
   try {
    if (attr.mode !== undefined) {
     fs.chmodSync(path, attr.mode);
     node.mode = attr.mode;
    }
    if (attr.timestamp !== undefined) {
     var date = new Date(attr.timestamp);
     fs.utimesSync(path, date, date);
    }
    if (attr.size !== undefined) {
     fs.truncateSync(path, attr.size);
    }
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  lookup: (function(parent, name) {
   var path = PATH.join2(NODEFS.realPath(parent), name);
   var mode = NODEFS.getMode(path);
   return NODEFS.createNode(parent, name, mode);
  }),
  mknod: (function(parent, name, mode, dev) {
   var node = NODEFS.createNode(parent, name, mode, dev);
   var path = NODEFS.realPath(node);
   try {
    if (FS.isDir(node.mode)) {
     fs.mkdirSync(path, node.mode);
    } else {
     fs.writeFileSync(path, "", {
      mode: node.mode
     });
    }
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
   return node;
  }),
  rename: (function(oldNode, newDir, newName) {
   var oldPath = NODEFS.realPath(oldNode);
   var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
   try {
    fs.renameSync(oldPath, newPath);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  unlink: (function(parent, name) {
   var path = PATH.join2(NODEFS.realPath(parent), name);
   try {
    fs.unlinkSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  rmdir: (function(parent, name) {
   var path = PATH.join2(NODEFS.realPath(parent), name);
   try {
    fs.rmdirSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  readdir: (function(node) {
   var path = NODEFS.realPath(node);
   try {
    return fs.readdirSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  symlink: (function(parent, newName, oldPath) {
   var newPath = PATH.join2(NODEFS.realPath(parent), newName);
   try {
    fs.symlinkSync(oldPath, newPath);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  readlink: (function(node) {
   var path = NODEFS.realPath(node);
   try {
    return fs.readlinkSync(path);
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  })
 },
 stream_ops: {
  open: (function(stream) {
   var path = NODEFS.realPath(stream.node);
   try {
    if (FS.isFile(stream.node.mode)) {
     stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
    }
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  close: (function(stream) {
   try {
    if (FS.isFile(stream.node.mode) && stream.nfd) {
     fs.closeSync(stream.nfd);
    }
   } catch (e) {
    if (!e.code) throw e;
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
  }),
  read: (function(stream, buffer, offset, length, position) {
   if (length === 0) return 0;
   var nbuffer = new Buffer(length);
   var res;
   try {
    res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
   } catch (e) {
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
   if (res > 0) {
    for (var i = 0; i < res; i++) {
     buffer[offset + i] = nbuffer[i];
    }
   }
   return res;
  }),
  write: (function(stream, buffer, offset, length, position) {
   var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
   var res;
   try {
    res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
   } catch (e) {
    throw new FS.ErrnoError(ERRNO_CODES[e.code]);
   }
   return res;
  }),
  llseek: (function(stream, offset, whence) {
   var position = offset;
   if (whence === 1) {
    position += stream.position;
   } else if (whence === 2) {
    if (FS.isFile(stream.node.mode)) {
     try {
      var stat = fs.fstatSync(stream.nfd);
      position += stat.size;
     } catch (e) {
      throw new FS.ErrnoError(ERRNO_CODES[e.code]);
     }
    }
   }
   if (position < 0) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   return position;
  })
 }
};
var _stdin = allocate(1, "i32*", ALLOC_STATIC);
var _stdout = allocate(1, "i32*", ALLOC_STATIC);
var _stderr = allocate(1, "i32*", ALLOC_STATIC);
function _fflush(stream) {}
var FS = {
 root: null,
 mounts: [],
 devices: [ null ],
 streams: [],
 nextInode: 1,
 nameTable: null,
 currentPath: "/",
 initialized: false,
 ignorePermissions: true,
 trackingDelegate: {},
 tracking: {
  openFlags: {
   READ: 1,
   WRITE: 2
  }
 },
 ErrnoError: null,
 genericErrors: {},
 handleFSError: (function(e) {
  if (!(e instanceof FS.ErrnoError)) throw e + " : " + stackTrace();
  return ___setErrNo(e.errno);
 }),
 lookupPath: (function(path, opts) {
  path = PATH.resolve(FS.cwd(), path);
  opts = opts || {};
  if (!path) return {
   path: "",
   node: null
  };
  var defaults = {
   follow_mount: true,
   recurse_count: 0
  };
  for (var key in defaults) {
   if (opts[key] === undefined) {
    opts[key] = defaults[key];
   }
  }
  if (opts.recurse_count > 8) {
   throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
  }
  var parts = PATH.normalizeArray(path.split("/").filter((function(p) {
   return !!p;
  })), false);
  var current = FS.root;
  var current_path = "/";
  for (var i = 0; i < parts.length; i++) {
   var islast = i === parts.length - 1;
   if (islast && opts.parent) {
    break;
   }
   current = FS.lookupNode(current, parts[i]);
   current_path = PATH.join2(current_path, parts[i]);
   if (FS.isMountpoint(current)) {
    if (!islast || islast && opts.follow_mount) {
     current = current.mounted.root;
    }
   }
   if (!islast || opts.follow) {
    var count = 0;
    while (FS.isLink(current.mode)) {
     var link = FS.readlink(current_path);
     current_path = PATH.resolve(PATH.dirname(current_path), link);
     var lookup = FS.lookupPath(current_path, {
      recurse_count: opts.recurse_count
     });
     current = lookup.node;
     if (count++ > 40) {
      throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
     }
    }
   }
  }
  return {
   path: current_path,
   node: current
  };
 }),
 getPath: (function(node) {
  var path;
  while (true) {
   if (FS.isRoot(node)) {
    var mount = node.mount.mountpoint;
    if (!path) return mount;
    return mount[mount.length - 1] !== "/" ? mount + "/" + path : mount + path;
   }
   path = path ? node.name + "/" + path : node.name;
   node = node.parent;
  }
 }),
 hashName: (function(parentid, name) {
  var hash = 0;
  for (var i = 0; i < name.length; i++) {
   hash = (hash << 5) - hash + name.charCodeAt(i) | 0;
  }
  return (parentid + hash >>> 0) % FS.nameTable.length;
 }),
 hashAddNode: (function(node) {
  var hash = FS.hashName(node.parent.id, node.name);
  node.name_next = FS.nameTable[hash];
  FS.nameTable[hash] = node;
 }),
 hashRemoveNode: (function(node) {
  var hash = FS.hashName(node.parent.id, node.name);
  if (FS.nameTable[hash] === node) {
   FS.nameTable[hash] = node.name_next;
  } else {
   var current = FS.nameTable[hash];
   while (current) {
    if (current.name_next === node) {
     current.name_next = node.name_next;
     break;
    }
    current = current.name_next;
   }
  }
 }),
 lookupNode: (function(parent, name) {
  var err = FS.mayLookup(parent);
  if (err) {
   throw new FS.ErrnoError(err, parent);
  }
  var hash = FS.hashName(parent.id, name);
  for (var node = FS.nameTable[hash]; node; node = node.name_next) {
   var nodeName = node.name;
   if (node.parent.id === parent.id && nodeName === name) {
    return node;
   }
  }
  return FS.lookup(parent, name);
 }),
 createNode: (function(parent, name, mode, rdev) {
  if (!FS.FSNode) {
   FS.FSNode = (function(parent, name, mode, rdev) {
    if (!parent) {
     parent = this;
    }
    this.parent = parent;
    this.mount = parent.mount;
    this.mounted = null;
    this.id = FS.nextInode++;
    this.name = name;
    this.mode = mode;
    this.node_ops = {};
    this.stream_ops = {};
    this.rdev = rdev;
   });
   FS.FSNode.prototype = {};
   var readMode = 292 | 73;
   var writeMode = 146;
   Object.defineProperties(FS.FSNode.prototype, {
    read: {
     get: (function() {
      return (this.mode & readMode) === readMode;
     }),
     set: (function(val) {
      val ? this.mode |= readMode : this.mode &= ~readMode;
     })
    },
    write: {
     get: (function() {
      return (this.mode & writeMode) === writeMode;
     }),
     set: (function(val) {
      val ? this.mode |= writeMode : this.mode &= ~writeMode;
     })
    },
    isFolder: {
     get: (function() {
      return FS.isDir(this.mode);
     })
    },
    isDevice: {
     get: (function() {
      return FS.isChrdev(this.mode);
     })
    }
   });
  }
  var node = new FS.FSNode(parent, name, mode, rdev);
  FS.hashAddNode(node);
  return node;
 }),
 destroyNode: (function(node) {
  FS.hashRemoveNode(node);
 }),
 isRoot: (function(node) {
  return node === node.parent;
 }),
 isMountpoint: (function(node) {
  return !!node.mounted;
 }),
 isFile: (function(mode) {
  return (mode & 61440) === 32768;
 }),
 isDir: (function(mode) {
  return (mode & 61440) === 16384;
 }),
 isLink: (function(mode) {
  return (mode & 61440) === 40960;
 }),
 isChrdev: (function(mode) {
  return (mode & 61440) === 8192;
 }),
 isBlkdev: (function(mode) {
  return (mode & 61440) === 24576;
 }),
 isFIFO: (function(mode) {
  return (mode & 61440) === 4096;
 }),
 isSocket: (function(mode) {
  return (mode & 49152) === 49152;
 }),
 flagModes: {
  "r": 0,
  "rs": 1052672,
  "r+": 2,
  "w": 577,
  "wx": 705,
  "xw": 705,
  "w+": 578,
  "wx+": 706,
  "xw+": 706,
  "a": 1089,
  "ax": 1217,
  "xa": 1217,
  "a+": 1090,
  "ax+": 1218,
  "xa+": 1218
 },
 modeStringToFlags: (function(str) {
  var flags = FS.flagModes[str];
  if (typeof flags === "undefined") {
   throw new Error("Unknown file open mode: " + str);
  }
  return flags;
 }),
 flagsToPermissionString: (function(flag) {
  var accmode = flag & 2097155;
  var perms = [ "r", "w", "rw" ][accmode];
  if (flag & 512) {
   perms += "w";
  }
  return perms;
 }),
 nodePermissions: (function(node, perms) {
  if (FS.ignorePermissions) {
   return 0;
  }
  if (perms.indexOf("r") !== -1 && !(node.mode & 292)) {
   return ERRNO_CODES.EACCES;
  } else if (perms.indexOf("w") !== -1 && !(node.mode & 146)) {
   return ERRNO_CODES.EACCES;
  } else if (perms.indexOf("x") !== -1 && !(node.mode & 73)) {
   return ERRNO_CODES.EACCES;
  }
  return 0;
 }),
 mayLookup: (function(dir) {
  var err = FS.nodePermissions(dir, "x");
  if (err) return err;
  if (!dir.node_ops.lookup) return ERRNO_CODES.EACCES;
  return 0;
 }),
 mayCreate: (function(dir, name) {
  try {
   var node = FS.lookupNode(dir, name);
   return ERRNO_CODES.EEXIST;
  } catch (e) {}
  return FS.nodePermissions(dir, "wx");
 }),
 mayDelete: (function(dir, name, isdir) {
  var node;
  try {
   node = FS.lookupNode(dir, name);
  } catch (e) {
   return e.errno;
  }
  var err = FS.nodePermissions(dir, "wx");
  if (err) {
   return err;
  }
  if (isdir) {
   if (!FS.isDir(node.mode)) {
    return ERRNO_CODES.ENOTDIR;
   }
   if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
    return ERRNO_CODES.EBUSY;
   }
  } else {
   if (FS.isDir(node.mode)) {
    return ERRNO_CODES.EISDIR;
   }
  }
  return 0;
 }),
 mayOpen: (function(node, flags) {
  if (!node) {
   return ERRNO_CODES.ENOENT;
  }
  if (FS.isLink(node.mode)) {
   return ERRNO_CODES.ELOOP;
  } else if (FS.isDir(node.mode)) {
   if ((flags & 2097155) !== 0 || flags & 512) {
    return ERRNO_CODES.EISDIR;
   }
  }
  return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
 }),
 MAX_OPEN_FDS: 4096,
 nextfd: (function(fd_start, fd_end) {
  fd_start = fd_start || 0;
  fd_end = fd_end || FS.MAX_OPEN_FDS;
  for (var fd = fd_start; fd <= fd_end; fd++) {
   if (!FS.streams[fd]) {
    return fd;
   }
  }
  throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
 }),
 getStream: (function(fd) {
  return FS.streams[fd];
 }),
 createStream: (function(stream, fd_start, fd_end) {
  if (!FS.FSStream) {
   FS.FSStream = (function() {});
   FS.FSStream.prototype = {};
   Object.defineProperties(FS.FSStream.prototype, {
    object: {
     get: (function() {
      return this.node;
     }),
     set: (function(val) {
      this.node = val;
     })
    },
    isRead: {
     get: (function() {
      return (this.flags & 2097155) !== 1;
     })
    },
    isWrite: {
     get: (function() {
      return (this.flags & 2097155) !== 0;
     })
    },
    isAppend: {
     get: (function() {
      return this.flags & 1024;
     })
    }
   });
  }
  var newStream = new FS.FSStream;
  for (var p in stream) {
   newStream[p] = stream[p];
  }
  stream = newStream;
  var fd = FS.nextfd(fd_start, fd_end);
  stream.fd = fd;
  FS.streams[fd] = stream;
  return stream;
 }),
 closeStream: (function(fd) {
  FS.streams[fd] = null;
 }),
 getStreamFromPtr: (function(ptr) {
  return FS.streams[ptr - 1];
 }),
 getPtrForStream: (function(stream) {
  return stream ? stream.fd + 1 : 0;
 }),
 chrdev_stream_ops: {
  open: (function(stream) {
   var device = FS.getDevice(stream.node.rdev);
   stream.stream_ops = device.stream_ops;
   if (stream.stream_ops.open) {
    stream.stream_ops.open(stream);
   }
  }),
  llseek: (function() {
   throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
  })
 },
 major: (function(dev) {
  return dev >> 8;
 }),
 minor: (function(dev) {
  return dev & 255;
 }),
 makedev: (function(ma, mi) {
  return ma << 8 | mi;
 }),
 registerDevice: (function(dev, ops) {
  FS.devices[dev] = {
   stream_ops: ops
  };
 }),
 getDevice: (function(dev) {
  return FS.devices[dev];
 }),
 getMounts: (function(mount) {
  var mounts = [];
  var check = [ mount ];
  while (check.length) {
   var m = check.pop();
   mounts.push(m);
   check.push.apply(check, m.mounts);
  }
  return mounts;
 }),
 syncfs: (function(populate, callback) {
  if (typeof populate === "function") {
   callback = populate;
   populate = false;
  }
  var mounts = FS.getMounts(FS.root.mount);
  var completed = 0;
  function done(err) {
   if (err) {
    if (!done.errored) {
     done.errored = true;
     return callback(err);
    }
    return;
   }
   if (++completed >= mounts.length) {
    callback(null);
   }
  }
  mounts.forEach((function(mount) {
   if (!mount.type.syncfs) {
    return done(null);
   }
   mount.type.syncfs(mount, populate, done);
  }));
 }),
 mount: (function(type, opts, mountpoint) {
  var root = mountpoint === "/";
  var pseudo = !mountpoint;
  var node;
  if (root && FS.root) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  } else if (!root && !pseudo) {
   var lookup = FS.lookupPath(mountpoint, {
    follow_mount: false
   });
   mountpoint = lookup.path;
   node = lookup.node;
   if (FS.isMountpoint(node)) {
    throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
   }
   if (!FS.isDir(node.mode)) {
    throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
   }
  }
  var mount = {
   type: type,
   opts: opts,
   mountpoint: mountpoint,
   mounts: []
  };
  var mountRoot = type.mount(mount);
  mountRoot.mount = mount;
  mount.root = mountRoot;
  if (root) {
   FS.root = mountRoot;
  } else if (node) {
   node.mounted = mount;
   if (node.mount) {
    node.mount.mounts.push(mount);
   }
  }
  return mountRoot;
 }),
 unmount: (function(mountpoint) {
  var lookup = FS.lookupPath(mountpoint, {
   follow_mount: false
  });
  if (!FS.isMountpoint(lookup.node)) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var node = lookup.node;
  var mount = node.mounted;
  var mounts = FS.getMounts(mount);
  Object.keys(FS.nameTable).forEach((function(hash) {
   var current = FS.nameTable[hash];
   while (current) {
    var next = current.name_next;
    if (mounts.indexOf(current.mount) !== -1) {
     FS.destroyNode(current);
    }
    current = next;
   }
  }));
  node.mounted = null;
  var idx = node.mount.mounts.indexOf(mount);
  assert(idx !== -1);
  node.mount.mounts.splice(idx, 1);
 }),
 lookup: (function(parent, name) {
  return parent.node_ops.lookup(parent, name);
 }),
 mknod: (function(path, mode, dev) {
  var lookup = FS.lookupPath(path, {
   parent: true
  });
  var parent = lookup.node;
  var name = PATH.basename(path);
  if (!name || name === "." || name === "..") {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var err = FS.mayCreate(parent, name);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  if (!parent.node_ops.mknod) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  return parent.node_ops.mknod(parent, name, mode, dev);
 }),
 create: (function(path, mode) {
  mode = mode !== undefined ? mode : 438;
  mode &= 4095;
  mode |= 32768;
  return FS.mknod(path, mode, 0);
 }),
 mkdir: (function(path, mode) {
  mode = mode !== undefined ? mode : 511;
  mode &= 511 | 512;
  mode |= 16384;
  return FS.mknod(path, mode, 0);
 }),
 mkdev: (function(path, mode, dev) {
  if (typeof dev === "undefined") {
   dev = mode;
   mode = 438;
  }
  mode |= 8192;
  return FS.mknod(path, mode, dev);
 }),
 symlink: (function(oldpath, newpath) {
  if (!PATH.resolve(oldpath)) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  var lookup = FS.lookupPath(newpath, {
   parent: true
  });
  var parent = lookup.node;
  if (!parent) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  var newname = PATH.basename(newpath);
  var err = FS.mayCreate(parent, newname);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  if (!parent.node_ops.symlink) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  return parent.node_ops.symlink(parent, newname, oldpath);
 }),
 rename: (function(old_path, new_path) {
  var old_dirname = PATH.dirname(old_path);
  var new_dirname = PATH.dirname(new_path);
  var old_name = PATH.basename(old_path);
  var new_name = PATH.basename(new_path);
  var lookup, old_dir, new_dir;
  try {
   lookup = FS.lookupPath(old_path, {
    parent: true
   });
   old_dir = lookup.node;
   lookup = FS.lookupPath(new_path, {
    parent: true
   });
   new_dir = lookup.node;
  } catch (e) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  }
  if (!old_dir || !new_dir) throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  if (old_dir.mount !== new_dir.mount) {
   throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
  }
  var old_node = FS.lookupNode(old_dir, old_name);
  var relative = PATH.relative(old_path, new_dirname);
  if (relative.charAt(0) !== ".") {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  relative = PATH.relative(new_path, old_dirname);
  if (relative.charAt(0) !== ".") {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
  }
  var new_node;
  try {
   new_node = FS.lookupNode(new_dir, new_name);
  } catch (e) {}
  if (old_node === new_node) {
   return;
  }
  var isdir = FS.isDir(old_node.mode);
  var err = FS.mayDelete(old_dir, old_name, isdir);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  err = new_node ? FS.mayDelete(new_dir, new_name, isdir) : FS.mayCreate(new_dir, new_name);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  if (!old_dir.node_ops.rename) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (FS.isMountpoint(old_node) || new_node && FS.isMountpoint(new_node)) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  }
  if (new_dir !== old_dir) {
   err = FS.nodePermissions(old_dir, "w");
   if (err) {
    throw new FS.ErrnoError(err);
   }
  }
  try {
   if (FS.trackingDelegate["willMovePath"]) {
    FS.trackingDelegate["willMovePath"](old_path, new_path);
   }
  } catch (e) {
   console.log("FS.trackingDelegate['willMovePath']('" + old_path + "', '" + new_path + "') threw an exception: " + e.message);
  }
  FS.hashRemoveNode(old_node);
  try {
   old_dir.node_ops.rename(old_node, new_dir, new_name);
  } catch (e) {
   throw e;
  } finally {
   FS.hashAddNode(old_node);
  }
  try {
   if (FS.trackingDelegate["onMovePath"]) FS.trackingDelegate["onMovePath"](old_path, new_path);
  } catch (e) {
   console.log("FS.trackingDelegate['onMovePath']('" + old_path + "', '" + new_path + "') threw an exception: " + e.message);
  }
 }),
 rmdir: (function(path) {
  var lookup = FS.lookupPath(path, {
   parent: true
  });
  var parent = lookup.node;
  var name = PATH.basename(path);
  var node = FS.lookupNode(parent, name);
  var err = FS.mayDelete(parent, name, true);
  if (err) {
   throw new FS.ErrnoError(err);
  }
  if (!parent.node_ops.rmdir) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (FS.isMountpoint(node)) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  }
  try {
   if (FS.trackingDelegate["willDeletePath"]) {
    FS.trackingDelegate["willDeletePath"](path);
   }
  } catch (e) {
   console.log("FS.trackingDelegate['willDeletePath']('" + path + "') threw an exception: " + e.message);
  }
  parent.node_ops.rmdir(parent, name);
  FS.destroyNode(node);
  try {
   if (FS.trackingDelegate["onDeletePath"]) FS.trackingDelegate["onDeletePath"](path);
  } catch (e) {
   console.log("FS.trackingDelegate['onDeletePath']('" + path + "') threw an exception: " + e.message);
  }
 }),
 readdir: (function(path) {
  var lookup = FS.lookupPath(path, {
   follow: true
  });
  var node = lookup.node;
  if (!node.node_ops.readdir) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
  }
  return node.node_ops.readdir(node);
 }),
 unlink: (function(path) {
  var lookup = FS.lookupPath(path, {
   parent: true
  });
  var parent = lookup.node;
  var name = PATH.basename(path);
  var node = FS.lookupNode(parent, name);
  var err = FS.mayDelete(parent, name, false);
  if (err) {
   if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
   throw new FS.ErrnoError(err);
  }
  if (!parent.node_ops.unlink) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (FS.isMountpoint(node)) {
   throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
  }
  try {
   if (FS.trackingDelegate["willDeletePath"]) {
    FS.trackingDelegate["willDeletePath"](path);
   }
  } catch (e) {
   console.log("FS.trackingDelegate['willDeletePath']('" + path + "') threw an exception: " + e.message);
  }
  parent.node_ops.unlink(parent, name);
  FS.destroyNode(node);
  try {
   if (FS.trackingDelegate["onDeletePath"]) FS.trackingDelegate["onDeletePath"](path);
  } catch (e) {
   console.log("FS.trackingDelegate['onDeletePath']('" + path + "') threw an exception: " + e.message);
  }
 }),
 readlink: (function(path) {
  var lookup = FS.lookupPath(path);
  var link = lookup.node;
  if (!link) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  if (!link.node_ops.readlink) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  return link.node_ops.readlink(link);
 }),
 stat: (function(path, dontFollow) {
  var lookup = FS.lookupPath(path, {
   follow: !dontFollow
  });
  var node = lookup.node;
  if (!node) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  if (!node.node_ops.getattr) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  return node.node_ops.getattr(node);
 }),
 lstat: (function(path) {
  return FS.stat(path, true);
 }),
 chmod: (function(path, mode, dontFollow) {
  var node;
  if (typeof path === "string") {
   var lookup = FS.lookupPath(path, {
    follow: !dontFollow
   });
   node = lookup.node;
  } else {
   node = path;
  }
  if (!node.node_ops.setattr) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  node.node_ops.setattr(node, {
   mode: mode & 4095 | node.mode & ~4095,
   timestamp: Date.now()
  });
 }),
 lchmod: (function(path, mode) {
  FS.chmod(path, mode, true);
 }),
 fchmod: (function(fd, mode) {
  var stream = FS.getStream(fd);
  if (!stream) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  FS.chmod(stream.node, mode);
 }),
 chown: (function(path, uid, gid, dontFollow) {
  var node;
  if (typeof path === "string") {
   var lookup = FS.lookupPath(path, {
    follow: !dontFollow
   });
   node = lookup.node;
  } else {
   node = path;
  }
  if (!node.node_ops.setattr) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  node.node_ops.setattr(node, {
   timestamp: Date.now()
  });
 }),
 lchown: (function(path, uid, gid) {
  FS.chown(path, uid, gid, true);
 }),
 fchown: (function(fd, uid, gid) {
  var stream = FS.getStream(fd);
  if (!stream) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  FS.chown(stream.node, uid, gid);
 }),
 truncate: (function(path, len) {
  if (len < 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var node;
  if (typeof path === "string") {
   var lookup = FS.lookupPath(path, {
    follow: true
   });
   node = lookup.node;
  } else {
   node = path;
  }
  if (!node.node_ops.setattr) {
   throw new FS.ErrnoError(ERRNO_CODES.EPERM);
  }
  if (FS.isDir(node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
  }
  if (!FS.isFile(node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var err = FS.nodePermissions(node, "w");
  if (err) {
   throw new FS.ErrnoError(err);
  }
  node.node_ops.setattr(node, {
   size: len,
   timestamp: Date.now()
  });
 }),
 ftruncate: (function(fd, len) {
  var stream = FS.getStream(fd);
  if (!stream) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  if ((stream.flags & 2097155) === 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  FS.truncate(stream.node, len);
 }),
 utime: (function(path, atime, mtime) {
  var lookup = FS.lookupPath(path, {
   follow: true
  });
  var node = lookup.node;
  node.node_ops.setattr(node, {
   timestamp: Math.max(atime, mtime)
  });
 }),
 open: (function(path, flags, mode, fd_start, fd_end) {
  if (path === "") {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  flags = typeof flags === "string" ? FS.modeStringToFlags(flags) : flags;
  mode = typeof mode === "undefined" ? 438 : mode;
  if (flags & 64) {
   mode = mode & 4095 | 32768;
  } else {
   mode = 0;
  }
  var node;
  if (typeof path === "object") {
   node = path;
  } else {
   path = PATH.normalize(path);
   try {
    var lookup = FS.lookupPath(path, {
     follow: !(flags & 131072)
    });
    node = lookup.node;
   } catch (e) {}
  }
  var created = false;
  if (flags & 64) {
   if (node) {
    if (flags & 128) {
     throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
    }
   } else {
    node = FS.mknod(path, mode, 0);
    created = true;
   }
  }
  if (!node) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
  }
  if (FS.isChrdev(node.mode)) {
   flags &= ~512;
  }
  if (!created) {
   var err = FS.mayOpen(node, flags);
   if (err) {
    throw new FS.ErrnoError(err);
   }
  }
  if (flags & 512) {
   FS.truncate(node, 0);
  }
  flags &= ~(128 | 512);
  var stream = FS.createStream({
   node: node,
   path: FS.getPath(node),
   flags: flags,
   seekable: true,
   position: 0,
   stream_ops: node.stream_ops,
   ungotten: [],
   error: false
  }, fd_start, fd_end);
  if (stream.stream_ops.open) {
   stream.stream_ops.open(stream);
  }
  if (Module["logReadFiles"] && !(flags & 1)) {
   if (!FS.readFiles) FS.readFiles = {};
   if (!(path in FS.readFiles)) {
    FS.readFiles[path] = 1;
    Module["printErr"]("read file: " + path);
   }
  }
  try {
   if (FS.trackingDelegate["onOpenFile"]) {
    var trackingFlags = 0;
    if ((flags & 2097155) !== 1) {
     trackingFlags |= FS.tracking.openFlags.READ;
    }
    if ((flags & 2097155) !== 0) {
     trackingFlags |= FS.tracking.openFlags.WRITE;
    }
    FS.trackingDelegate["onOpenFile"](path, trackingFlags);
   }
  } catch (e) {
   console.log("FS.trackingDelegate['onOpenFile']('" + path + "', flags) threw an exception: " + e.message);
  }
  return stream;
 }),
 close: (function(stream) {
  try {
   if (stream.stream_ops.close) {
    stream.stream_ops.close(stream);
   }
  } catch (e) {
   throw e;
  } finally {
   FS.closeStream(stream.fd);
  }
 }),
 llseek: (function(stream, offset, whence) {
  if (!stream.seekable || !stream.stream_ops.llseek) {
   throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
  }
  stream.position = stream.stream_ops.llseek(stream, offset, whence);
  stream.ungotten = [];
  return stream.position;
 }),
 read: (function(stream, buffer, offset, length, position) {
  if (length < 0 || position < 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  if ((stream.flags & 2097155) === 1) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  if (FS.isDir(stream.node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
  }
  if (!stream.stream_ops.read) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  var seeking = true;
  if (typeof position === "undefined") {
   position = stream.position;
   seeking = false;
  } else if (!stream.seekable) {
   throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
  }
  var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
  if (!seeking) stream.position += bytesRead;
  return bytesRead;
 }),
 write: (function(stream, buffer, offset, length, position, canOwn) {
  if (length < 0 || position < 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  if ((stream.flags & 2097155) === 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  if (FS.isDir(stream.node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
  }
  if (!stream.stream_ops.write) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  if (stream.flags & 1024) {
   FS.llseek(stream, 0, 2);
  }
  var seeking = true;
  if (typeof position === "undefined") {
   position = stream.position;
   seeking = false;
  } else if (!stream.seekable) {
   throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
  }
  var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
  if (!seeking) stream.position += bytesWritten;
  try {
   if (stream.path && FS.trackingDelegate["onWriteToFile"]) FS.trackingDelegate["onWriteToFile"](stream.path);
  } catch (e) {
   console.log("FS.trackingDelegate['onWriteToFile']('" + path + "') threw an exception: " + e.message);
  }
  return bytesWritten;
 }),
 allocate: (function(stream, offset, length) {
  if (offset < 0 || length <= 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
  }
  if ((stream.flags & 2097155) === 0) {
   throw new FS.ErrnoError(ERRNO_CODES.EBADF);
  }
  if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
  }
  if (!stream.stream_ops.allocate) {
   throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
  }
  stream.stream_ops.allocate(stream, offset, length);
 }),
 mmap: (function(stream, buffer, offset, length, position, prot, flags) {
  if ((stream.flags & 2097155) === 1) {
   throw new FS.ErrnoError(ERRNO_CODES.EACCES);
  }
  if (!stream.stream_ops.mmap) {
   throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
  }
  return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
 }),
 ioctl: (function(stream, cmd, arg) {
  if (!stream.stream_ops.ioctl) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
  }
  return stream.stream_ops.ioctl(stream, cmd, arg);
 }),
 readFile: (function(path, opts) {
  opts = opts || {};
  opts.flags = opts.flags || "r";
  opts.encoding = opts.encoding || "binary";
  if (opts.encoding !== "utf8" && opts.encoding !== "binary") {
   throw new Error('Invalid encoding type "' + opts.encoding + '"');
  }
  var ret;
  var stream = FS.open(path, opts.flags);
  var stat = FS.stat(path);
  var length = stat.size;
  var buf = new Uint8Array(length);
  FS.read(stream, buf, 0, length, 0);
  if (opts.encoding === "utf8") {
   ret = "";
   var utf8 = new Runtime.UTF8Processor;
   for (var i = 0; i < length; i++) {
    ret += utf8.processCChar(buf[i]);
   }
  } else if (opts.encoding === "binary") {
   ret = buf;
  }
  FS.close(stream);
  return ret;
 }),
 writeFile: (function(path, data, opts) {
  opts = opts || {};
  opts.flags = opts.flags || "w";
  opts.encoding = opts.encoding || "utf8";
  if (opts.encoding !== "utf8" && opts.encoding !== "binary") {
   throw new Error('Invalid encoding type "' + opts.encoding + '"');
  }
  var stream = FS.open(path, opts.flags, opts.mode);
  if (opts.encoding === "utf8") {
   var utf8 = new Runtime.UTF8Processor;
   var buf = new Uint8Array(utf8.processJSString(data));
   FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
  } else if (opts.encoding === "binary") {
   FS.write(stream, data, 0, data.length, 0, opts.canOwn);
  }
  FS.close(stream);
 }),
 cwd: (function() {
  return FS.currentPath;
 }),
 chdir: (function(path) {
  var lookup = FS.lookupPath(path, {
   follow: true
  });
  if (!FS.isDir(lookup.node.mode)) {
   throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
  }
  var err = FS.nodePermissions(lookup.node, "x");
  if (err) {
   throw new FS.ErrnoError(err);
  }
  FS.currentPath = lookup.path;
 }),
 createDefaultDirectories: (function() {
  FS.mkdir("/tmp");
  FS.mkdir("/home");
  FS.mkdir("/home/web_user");
 }),
 createDefaultDevices: (function() {
  FS.mkdir("/dev");
  FS.registerDevice(FS.makedev(1, 3), {
   read: (function() {
    return 0;
   }),
   write: (function() {
    return 0;
   })
  });
  FS.mkdev("/dev/null", FS.makedev(1, 3));
  TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
  TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
  FS.mkdev("/dev/tty", FS.makedev(5, 0));
  FS.mkdev("/dev/tty1", FS.makedev(6, 0));
  var random_device;
  if (typeof crypto !== "undefined") {
   var randomBuffer = new Uint8Array(1);
   random_device = (function() {
    crypto.getRandomValues(randomBuffer);
    return randomBuffer[0];
   });
  } else if (ENVIRONMENT_IS_NODE) {
   random_device = (function() {
    return require("crypto").randomBytes(1)[0];
   });
  } else {
   random_device = (function() {
    return Math.random() * 256 | 0;
   });
  }
  FS.createDevice("/dev", "random", random_device);
  FS.createDevice("/dev", "urandom", random_device);
  FS.mkdir("/dev/shm");
  FS.mkdir("/dev/shm/tmp");
 }),
 createStandardStreams: (function() {
  if (Module["stdin"]) {
   FS.createDevice("/dev", "stdin", Module["stdin"]);
  } else {
   FS.symlink("/dev/tty", "/dev/stdin");
  }
  if (Module["stdout"]) {
   FS.createDevice("/dev", "stdout", null, Module["stdout"]);
  } else {
   FS.symlink("/dev/tty", "/dev/stdout");
  }
  if (Module["stderr"]) {
   FS.createDevice("/dev", "stderr", null, Module["stderr"]);
  } else {
   FS.symlink("/dev/tty1", "/dev/stderr");
  }
  var stdin = FS.open("/dev/stdin", "r");
  HEAP32[_stdin >> 2] = FS.getPtrForStream(stdin);
  assert(stdin.fd === 0, "invalid handle for stdin (" + stdin.fd + ")");
  var stdout = FS.open("/dev/stdout", "w");
  HEAP32[_stdout >> 2] = FS.getPtrForStream(stdout);
  assert(stdout.fd === 1, "invalid handle for stdout (" + stdout.fd + ")");
  var stderr = FS.open("/dev/stderr", "w");
  HEAP32[_stderr >> 2] = FS.getPtrForStream(stderr);
  assert(stderr.fd === 2, "invalid handle for stderr (" + stderr.fd + ")");
 }),
 ensureErrnoError: (function() {
  if (FS.ErrnoError) return;
  FS.ErrnoError = function ErrnoError(errno, node) {
   this.node = node;
   this.setErrno = (function(errno) {
    this.errno = errno;
    for (var key in ERRNO_CODES) {
     if (ERRNO_CODES[key] === errno) {
      this.code = key;
      break;
     }
    }
   });
   this.setErrno(errno);
   this.message = ERRNO_MESSAGES[errno];
  };
  FS.ErrnoError.prototype = new Error;
  FS.ErrnoError.prototype.constructor = FS.ErrnoError;
  [ ERRNO_CODES.ENOENT ].forEach((function(code) {
   FS.genericErrors[code] = new FS.ErrnoError(code);
   FS.genericErrors[code].stack = "<generic error, no stack>";
  }));
 }),
 staticInit: (function() {
  FS.ensureErrnoError();
  FS.nameTable = new Array(4096);
  FS.mount(MEMFS, {}, "/");
  FS.createDefaultDirectories();
  FS.createDefaultDevices();
 }),
 init: (function(input, output, error) {
  assert(!FS.init.initialized, "FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");
  FS.init.initialized = true;
  FS.ensureErrnoError();
  Module["stdin"] = input || Module["stdin"];
  Module["stdout"] = output || Module["stdout"];
  Module["stderr"] = error || Module["stderr"];
  FS.createStandardStreams();
 }),
 quit: (function() {
  FS.init.initialized = false;
  for (var i = 0; i < FS.streams.length; i++) {
   var stream = FS.streams[i];
   if (!stream) {
    continue;
   }
   FS.close(stream);
  }
 }),
 getMode: (function(canRead, canWrite) {
  var mode = 0;
  if (canRead) mode |= 292 | 73;
  if (canWrite) mode |= 146;
  return mode;
 }),
 joinPath: (function(parts, forceRelative) {
  var path = PATH.join.apply(null, parts);
  if (forceRelative && path[0] == "/") path = path.substr(1);
  return path;
 }),
 absolutePath: (function(relative, base) {
  return PATH.resolve(base, relative);
 }),
 standardizePath: (function(path) {
  return PATH.normalize(path);
 }),
 findObject: (function(path, dontResolveLastLink) {
  var ret = FS.analyzePath(path, dontResolveLastLink);
  if (ret.exists) {
   return ret.object;
  } else {
   ___setErrNo(ret.error);
   return null;
  }
 }),
 analyzePath: (function(path, dontResolveLastLink) {
  try {
   var lookup = FS.lookupPath(path, {
    follow: !dontResolveLastLink
   });
   path = lookup.path;
  } catch (e) {}
  var ret = {
   isRoot: false,
   exists: false,
   error: 0,
   name: null,
   path: null,
   object: null,
   parentExists: false,
   parentPath: null,
   parentObject: null
  };
  try {
   var lookup = FS.lookupPath(path, {
    parent: true
   });
   ret.parentExists = true;
   ret.parentPath = lookup.path;
   ret.parentObject = lookup.node;
   ret.name = PATH.basename(path);
   lookup = FS.lookupPath(path, {
    follow: !dontResolveLastLink
   });
   ret.exists = true;
   ret.path = lookup.path;
   ret.object = lookup.node;
   ret.name = lookup.node.name;
   ret.isRoot = lookup.path === "/";
  } catch (e) {
   ret.error = e.errno;
  }
  return ret;
 }),
 createFolder: (function(parent, name, canRead, canWrite) {
  var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
  var mode = FS.getMode(canRead, canWrite);
  return FS.mkdir(path, mode);
 }),
 createPath: (function(parent, path, canRead, canWrite) {
  parent = typeof parent === "string" ? parent : FS.getPath(parent);
  var parts = path.split("/").reverse();
  while (parts.length) {
   var part = parts.pop();
   if (!part) continue;
   var current = PATH.join2(parent, part);
   try {
    FS.mkdir(current);
   } catch (e) {}
   parent = current;
  }
  return current;
 }),
 createFile: (function(parent, name, properties, canRead, canWrite) {
  var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
  var mode = FS.getMode(canRead, canWrite);
  return FS.create(path, mode);
 }),
 createDataFile: (function(parent, name, data, canRead, canWrite, canOwn) {
  var path = name ? PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name) : parent;
  var mode = FS.getMode(canRead, canWrite);
  var node = FS.create(path, mode);
  if (data) {
   if (typeof data === "string") {
    var arr = new Array(data.length);
    for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
    data = arr;
   }
   FS.chmod(node, mode | 146);
   var stream = FS.open(node, "w");
   FS.write(stream, data, 0, data.length, 0, canOwn);
   FS.close(stream);
   FS.chmod(node, mode);
  }
  return node;
 }),
 createDevice: (function(parent, name, input, output) {
  var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
  var mode = FS.getMode(!!input, !!output);
  if (!FS.createDevice.major) FS.createDevice.major = 64;
  var dev = FS.makedev(FS.createDevice.major++, 0);
  FS.registerDevice(dev, {
   open: (function(stream) {
    stream.seekable = false;
   }),
   close: (function(stream) {
    if (output && output.buffer && output.buffer.length) {
     output(10);
    }
   }),
   read: (function(stream, buffer, offset, length, pos) {
    var bytesRead = 0;
    for (var i = 0; i < length; i++) {
     var result;
     try {
      result = input();
     } catch (e) {
      throw new FS.ErrnoError(ERRNO_CODES.EIO);
     }
     if (result === undefined && bytesRead === 0) {
      throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
     }
     if (result === null || result === undefined) break;
     bytesRead++;
     buffer[offset + i] = result;
    }
    if (bytesRead) {
     stream.node.timestamp = Date.now();
    }
    return bytesRead;
   }),
   write: (function(stream, buffer, offset, length, pos) {
    for (var i = 0; i < length; i++) {
     try {
      output(buffer[offset + i]);
     } catch (e) {
      throw new FS.ErrnoError(ERRNO_CODES.EIO);
     }
    }
    if (length) {
     stream.node.timestamp = Date.now();
    }
    return i;
   })
  });
  return FS.mkdev(path, mode, dev);
 }),
 createLink: (function(parent, name, target, canRead, canWrite) {
  var path = PATH.join2(typeof parent === "string" ? parent : FS.getPath(parent), name);
  return FS.symlink(target, path);
 }),
 forceLoadFile: (function(obj) {
  if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
  var success = true;
  if (typeof XMLHttpRequest !== "undefined") {
   throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
  } else if (Module["read"]) {
   try {
    obj.contents = intArrayFromString(Module["read"](obj.url), true);
    obj.usedBytes = obj.contents.length;
   } catch (e) {
    success = false;
   }
  } else {
   throw new Error("Cannot load without read() or XMLHttpRequest.");
  }
  if (!success) ___setErrNo(ERRNO_CODES.EIO);
  return success;
 }),
 createLazyFile: (function(parent, name, url, canRead, canWrite) {
  function LazyUint8Array() {
   this.lengthKnown = false;
   this.chunks = [];
  }
  LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
   if (idx > this.length - 1 || idx < 0) {
    return undefined;
   }
   var chunkOffset = idx % this.chunkSize;
   var chunkNum = idx / this.chunkSize | 0;
   return this.getter(chunkNum)[chunkOffset];
  };
  LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
   this.getter = getter;
  };
  LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
   var xhr = new XMLHttpRequest;
   xhr.open("HEAD", url, false);
   xhr.send(null);
   if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
   var datalength = Number(xhr.getResponseHeader("Content-length"));
   var header;
   var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
   var chunkSize = 1024 * 1024;
   if (!hasByteServing) chunkSize = datalength;
   var doXHR = (function(from, to) {
    if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
    if (to > datalength - 1) throw new Error("only " + datalength + " bytes available! programmer error!");
    var xhr = new XMLHttpRequest;
    xhr.open("GET", url, false);
    if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
    if (typeof Uint8Array != "undefined") xhr.responseType = "arraybuffer";
    if (xhr.overrideMimeType) {
     xhr.overrideMimeType("text/plain; charset=x-user-defined");
    }
    xhr.send(null);
    if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
    if (xhr.response !== undefined) {
     return new Uint8Array(xhr.response || []);
    } else {
     return intArrayFromString(xhr.responseText || "", true);
    }
   });
   var lazyArray = this;
   lazyArray.setDataGetter((function(chunkNum) {
    var start = chunkNum * chunkSize;
    var end = (chunkNum + 1) * chunkSize - 1;
    end = Math.min(end, datalength - 1);
    if (typeof lazyArray.chunks[chunkNum] === "undefined") {
     lazyArray.chunks[chunkNum] = doXHR(start, end);
    }
    if (typeof lazyArray.chunks[chunkNum] === "undefined") throw new Error("doXHR failed!");
    return lazyArray.chunks[chunkNum];
   }));
   this._length = datalength;
   this._chunkSize = chunkSize;
   this.lengthKnown = true;
  };
  if (typeof XMLHttpRequest !== "undefined") {
   if (!ENVIRONMENT_IS_WORKER) throw "Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";
   var lazyArray = new LazyUint8Array;
   Object.defineProperty(lazyArray, "length", {
    get: (function() {
     if (!this.lengthKnown) {
      this.cacheLength();
     }
     return this._length;
    })
   });
   Object.defineProperty(lazyArray, "chunkSize", {
    get: (function() {
     if (!this.lengthKnown) {
      this.cacheLength();
     }
     return this._chunkSize;
    })
   });
   var properties = {
    isDevice: false,
    contents: lazyArray
   };
  } else {
   var properties = {
    isDevice: false,
    url: url
   };
  }
  var node = FS.createFile(parent, name, properties, canRead, canWrite);
  if (properties.contents) {
   node.contents = properties.contents;
  } else if (properties.url) {
   node.contents = null;
   node.url = properties.url;
  }
  Object.defineProperty(node, "usedBytes", {
   get: (function() {
    return this.contents.length;
   })
  });
  var stream_ops = {};
  var keys = Object.keys(node.stream_ops);
  keys.forEach((function(key) {
   var fn = node.stream_ops[key];
   stream_ops[key] = function forceLoadLazyFile() {
    if (!FS.forceLoadFile(node)) {
     throw new FS.ErrnoError(ERRNO_CODES.EIO);
    }
    return fn.apply(null, arguments);
   };
  }));
  stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
   if (!FS.forceLoadFile(node)) {
    throw new FS.ErrnoError(ERRNO_CODES.EIO);
   }
   var contents = stream.node.contents;
   if (position >= contents.length) return 0;
   var size = Math.min(contents.length - position, length);
   assert(size >= 0);
   if (contents.slice) {
    for (var i = 0; i < size; i++) {
     buffer[offset + i] = contents[position + i];
    }
   } else {
    for (var i = 0; i < size; i++) {
     buffer[offset + i] = contents.get(position + i);
    }
   }
   return size;
  };
  node.stream_ops = stream_ops;
  return node;
 }),
 createPreloadedFile: (function(parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
  Browser.init();
  var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
  function processData(byteArray) {
   function finish(byteArray) {
    if (!dontCreateFile) {
     FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
    }
    if (onload) onload();
    removeRunDependency("cp " + fullname);
   }
   var handled = false;
   Module["preloadPlugins"].forEach((function(plugin) {
    if (handled) return;
    if (plugin["canHandle"](fullname)) {
     plugin["handle"](byteArray, fullname, finish, (function() {
      if (onerror) onerror();
      removeRunDependency("cp " + fullname);
     }));
     handled = true;
    }
   }));
   if (!handled) finish(byteArray);
  }
  addRunDependency("cp " + fullname);
  if (typeof url == "string") {
   Browser.asyncLoad(url, (function(byteArray) {
    processData(byteArray);
   }), onerror);
  } else {
   processData(url);
  }
 }),
 indexedDB: (function() {
  return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
 }),
 DB_NAME: (function() {
  return "EM_FS_" + window.location.pathname;
 }),
 DB_VERSION: 20,
 DB_STORE_NAME: "FILE_DATA",
 saveFilesToDB: (function(paths, onload, onerror) {
  onload = onload || (function() {});
  onerror = onerror || (function() {});
  var indexedDB = FS.indexedDB();
  try {
   var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
  } catch (e) {
   return onerror(e);
  }
  openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
   console.log("creating db");
   var db = openRequest.result;
   db.createObjectStore(FS.DB_STORE_NAME);
  };
  openRequest.onsuccess = function openRequest_onsuccess() {
   var db = openRequest.result;
   var transaction = db.transaction([ FS.DB_STORE_NAME ], "readwrite");
   var files = transaction.objectStore(FS.DB_STORE_NAME);
   var ok = 0, fail = 0, total = paths.length;
   function finish() {
    if (fail == 0) onload(); else onerror();
   }
   paths.forEach((function(path) {
    var putRequest = files.put(FS.analyzePath(path).object.contents, path);
    putRequest.onsuccess = function putRequest_onsuccess() {
     ok++;
     if (ok + fail == total) finish();
    };
    putRequest.onerror = function putRequest_onerror() {
     fail++;
     if (ok + fail == total) finish();
    };
   }));
   transaction.onerror = onerror;
  };
  openRequest.onerror = onerror;
 }),
 loadFilesFromDB: (function(paths, onload, onerror) {
  onload = onload || (function() {});
  onerror = onerror || (function() {});
  var indexedDB = FS.indexedDB();
  try {
   var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
  } catch (e) {
   return onerror(e);
  }
  openRequest.onupgradeneeded = onerror;
  openRequest.onsuccess = function openRequest_onsuccess() {
   var db = openRequest.result;
   try {
    var transaction = db.transaction([ FS.DB_STORE_NAME ], "readonly");
   } catch (e) {
    onerror(e);
    return;
   }
   var files = transaction.objectStore(FS.DB_STORE_NAME);
   var ok = 0, fail = 0, total = paths.length;
   function finish() {
    if (fail == 0) onload(); else onerror();
   }
   paths.forEach((function(path) {
    var getRequest = files.get(path);
    getRequest.onsuccess = function getRequest_onsuccess() {
     if (FS.analyzePath(path).exists) {
      FS.unlink(path);
     }
     FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
     ok++;
     if (ok + fail == total) finish();
    };
    getRequest.onerror = function getRequest_onerror() {
     fail++;
     if (ok + fail == total) finish();
    };
   }));
   transaction.onerror = onerror;
  };
  openRequest.onerror = onerror;
 })
};
function _lseek(fildes, offset, whence) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 try {
  return FS.llseek(stream, offset, whence);
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _mkport() {
 throw "TODO";
}
var SOCKFS = {
 mount: (function(mount) {
  Module["websocket"] = Module["websocket"] && "object" === typeof Module["websocket"] ? Module["websocket"] : {};
  Module["websocket"]._callbacks = {};
  Module["websocket"]["on"] = (function(event, callback) {
   if ("function" === typeof callback) {
    this._callbacks[event] = callback;
   }
   return this;
  });
  Module["websocket"].emit = (function(event, param) {
   if ("function" === typeof this._callbacks[event]) {
    this._callbacks[event].call(this, param);
   }
  });
  return FS.createNode(null, "/", 16384 | 511, 0);
 }),
 createSocket: (function(family, type, protocol) {
  var streaming = type == 1;
  if (protocol) {
   assert(streaming == (protocol == 6));
  }
  var sock = {
   family: family,
   type: type,
   protocol: protocol,
   server: null,
   error: null,
   peers: {},
   pending: [],
   recv_queue: [],
   sock_ops: SOCKFS.websocket_sock_ops
  };
  var name = SOCKFS.nextname();
  var node = FS.createNode(SOCKFS.root, name, 49152, 0);
  node.sock = sock;
  var stream = FS.createStream({
   path: name,
   node: node,
   flags: FS.modeStringToFlags("r+"),
   seekable: false,
   stream_ops: SOCKFS.stream_ops
  });
  sock.stream = stream;
  return sock;
 }),
 getSocket: (function(fd) {
  var stream = FS.getStream(fd);
  if (!stream || !FS.isSocket(stream.node.mode)) {
   return null;
  }
  return stream.node.sock;
 }),
 stream_ops: {
  poll: (function(stream) {
   var sock = stream.node.sock;
   return sock.sock_ops.poll(sock);
  }),
  ioctl: (function(stream, request, varargs) {
   var sock = stream.node.sock;
   return sock.sock_ops.ioctl(sock, request, varargs);
  }),
  read: (function(stream, buffer, offset, length, position) {
   var sock = stream.node.sock;
   var msg = sock.sock_ops.recvmsg(sock, length);
   if (!msg) {
    return 0;
   }
   buffer.set(msg.buffer, offset);
   return msg.buffer.length;
  }),
  write: (function(stream, buffer, offset, length, position) {
   var sock = stream.node.sock;
   return sock.sock_ops.sendmsg(sock, buffer, offset, length);
  }),
  close: (function(stream) {
   var sock = stream.node.sock;
   sock.sock_ops.close(sock);
  })
 },
 nextname: (function() {
  if (!SOCKFS.nextname.current) {
   SOCKFS.nextname.current = 0;
  }
  return "socket[" + SOCKFS.nextname.current++ + "]";
 }),
 websocket_sock_ops: {
  createPeer: (function(sock, addr, port) {
   var ws;
   if (typeof addr === "object") {
    ws = addr;
    addr = null;
    port = null;
   }
   if (ws) {
    if (ws._socket) {
     addr = ws._socket.remoteAddress;
     port = ws._socket.remotePort;
    } else {
     var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
     if (!result) {
      throw new Error("WebSocket URL must be in the format ws(s)://address:port");
     }
     addr = result[1];
     port = parseInt(result[2], 10);
    }
   } else {
    try {
     var runtimeConfig = Module["websocket"] && "object" === typeof Module["websocket"];
     var url = "ws:#".replace("#", "//");
     if (runtimeConfig) {
      if ("string" === typeof Module["websocket"]["url"]) {
       url = Module["websocket"]["url"];
      }
     }
     if (url === "ws://" || url === "wss://") {
      var parts = addr.split("/");
      url = url + parts[0] + ":" + port + "/" + parts.slice(1).join("/");
     }
     var subProtocols = "binary";
     if (runtimeConfig) {
      if ("string" === typeof Module["websocket"]["subprotocol"]) {
       subProtocols = Module["websocket"]["subprotocol"];
      }
     }
     subProtocols = subProtocols.replace(/^ +| +$/g, "").split(/ *, */);
     var opts = ENVIRONMENT_IS_NODE ? {
      "protocol": subProtocols.toString()
     } : subProtocols;
     var WebSocket = ENVIRONMENT_IS_NODE ? require("ws") : window["WebSocket"];
     ws = new WebSocket(url, opts);
     ws.binaryType = "arraybuffer";
    } catch (e) {
     throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
    }
   }
   var peer = {
    addr: addr,
    port: port,
    socket: ws,
    dgram_send_queue: []
   };
   SOCKFS.websocket_sock_ops.addPeer(sock, peer);
   SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
   if (sock.type === 2 && typeof sock.sport !== "undefined") {
    peer.dgram_send_queue.push(new Uint8Array([ 255, 255, 255, 255, "p".charCodeAt(0), "o".charCodeAt(0), "r".charCodeAt(0), "t".charCodeAt(0), (sock.sport & 65280) >> 8, sock.sport & 255 ]));
   }
   return peer;
  }),
  getPeer: (function(sock, addr, port) {
   return sock.peers[addr + ":" + port];
  }),
  addPeer: (function(sock, peer) {
   sock.peers[peer.addr + ":" + peer.port] = peer;
  }),
  removePeer: (function(sock, peer) {
   delete sock.peers[peer.addr + ":" + peer.port];
  }),
  handlePeerEvents: (function(sock, peer) {
   var first = true;
   var handleOpen = (function() {
    Module["websocket"].emit("open", sock.stream.fd);
    try {
     var queued = peer.dgram_send_queue.shift();
     while (queued) {
      peer.socket.send(queued);
      queued = peer.dgram_send_queue.shift();
     }
    } catch (e) {
     peer.socket.close();
    }
   });
   function handleMessage(data) {
    assert(typeof data !== "string" && data.byteLength !== undefined);
    data = new Uint8Array(data);
    var wasfirst = first;
    first = false;
    if (wasfirst && data.length === 10 && data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 && data[4] === "p".charCodeAt(0) && data[5] === "o".charCodeAt(0) && data[6] === "r".charCodeAt(0) && data[7] === "t".charCodeAt(0)) {
     var newport = data[8] << 8 | data[9];
     SOCKFS.websocket_sock_ops.removePeer(sock, peer);
     peer.port = newport;
     SOCKFS.websocket_sock_ops.addPeer(sock, peer);
     return;
    }
    sock.recv_queue.push({
     addr: peer.addr,
     port: peer.port,
     data: data
    });
    Module["websocket"].emit("message", sock.stream.fd);
   }
   if (ENVIRONMENT_IS_NODE) {
    peer.socket.on("open", handleOpen);
    peer.socket.on("message", (function(data, flags) {
     if (!flags.binary) {
      return;
     }
     handleMessage((new Uint8Array(data)).buffer);
    }));
    peer.socket.on("close", (function() {
     Module["websocket"].emit("close", sock.stream.fd);
    }));
    peer.socket.on("error", (function(error) {
     sock.error = ERRNO_CODES.ECONNREFUSED;
     Module["websocket"].emit("error", [ sock.stream.fd, sock.error, "ECONNREFUSED: Connection refused" ]);
    }));
   } else {
    peer.socket.onopen = handleOpen;
    peer.socket.onclose = (function() {
     Module["websocket"].emit("close", sock.stream.fd);
    });
    peer.socket.onmessage = function peer_socket_onmessage(event) {
     handleMessage(event.data);
    };
    peer.socket.onerror = (function(error) {
     sock.error = ERRNO_CODES.ECONNREFUSED;
     Module["websocket"].emit("error", [ sock.stream.fd, sock.error, "ECONNREFUSED: Connection refused" ]);
    });
   }
  }),
  poll: (function(sock) {
   if (sock.type === 1 && sock.server) {
    return sock.pending.length ? 64 | 1 : 0;
   }
   var mask = 0;
   var dest = sock.type === 1 ? SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) : null;
   if (sock.recv_queue.length || !dest || dest && dest.socket.readyState === dest.socket.CLOSING || dest && dest.socket.readyState === dest.socket.CLOSED) {
    mask |= 64 | 1;
   }
   if (!dest || dest && dest.socket.readyState === dest.socket.OPEN) {
    mask |= 4;
   }
   if (dest && dest.socket.readyState === dest.socket.CLOSING || dest && dest.socket.readyState === dest.socket.CLOSED) {
    mask |= 16;
   }
   return mask;
  }),
  ioctl: (function(sock, request, arg) {
   switch (request) {
   case 21531:
    var bytes = 0;
    if (sock.recv_queue.length) {
     bytes = sock.recv_queue[0].data.length;
    }
    HEAP32[arg >> 2] = bytes;
    return 0;
   default:
    return ERRNO_CODES.EINVAL;
   }
  }),
  close: (function(sock) {
   if (sock.server) {
    try {
     sock.server.close();
    } catch (e) {}
    sock.server = null;
   }
   var peers = Object.keys(sock.peers);
   for (var i = 0; i < peers.length; i++) {
    var peer = sock.peers[peers[i]];
    try {
     peer.socket.close();
    } catch (e) {}
    SOCKFS.websocket_sock_ops.removePeer(sock, peer);
   }
   return 0;
  }),
  bind: (function(sock, addr, port) {
   if (typeof sock.saddr !== "undefined" || typeof sock.sport !== "undefined") {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   sock.saddr = addr;
   sock.sport = port || _mkport();
   if (sock.type === 2) {
    if (sock.server) {
     sock.server.close();
     sock.server = null;
    }
    try {
     sock.sock_ops.listen(sock, 0);
    } catch (e) {
     if (!(e instanceof FS.ErrnoError)) throw e;
     if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
    }
   }
  }),
  connect: (function(sock, addr, port) {
   if (sock.server) {
    throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
   }
   if (typeof sock.daddr !== "undefined" && typeof sock.dport !== "undefined") {
    var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
    if (dest) {
     if (dest.socket.readyState === dest.socket.CONNECTING) {
      throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
     } else {
      throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
     }
    }
   }
   var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
   sock.daddr = peer.addr;
   sock.dport = peer.port;
   throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
  }),
  listen: (function(sock, backlog) {
   if (!ENVIRONMENT_IS_NODE) {
    throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
   }
   if (sock.server) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   var WebSocketServer = require("ws").Server;
   var host = sock.saddr;
   sock.server = new WebSocketServer({
    host: host,
    port: sock.sport
   });
   Module["websocket"].emit("listen", sock.stream.fd);
   sock.server.on("connection", (function(ws) {
    if (sock.type === 1) {
     var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
     var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
     newsock.daddr = peer.addr;
     newsock.dport = peer.port;
     sock.pending.push(newsock);
     Module["websocket"].emit("connection", newsock.stream.fd);
    } else {
     SOCKFS.websocket_sock_ops.createPeer(sock, ws);
     Module["websocket"].emit("connection", sock.stream.fd);
    }
   }));
   sock.server.on("closed", (function() {
    Module["websocket"].emit("close", sock.stream.fd);
    sock.server = null;
   }));
   sock.server.on("error", (function(error) {
    sock.error = ERRNO_CODES.EHOSTUNREACH;
    Module["websocket"].emit("error", [ sock.stream.fd, sock.error, "EHOSTUNREACH: Host is unreachable" ]);
   }));
  }),
  accept: (function(listensock) {
   if (!listensock.server) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
   var newsock = listensock.pending.shift();
   newsock.stream.flags = listensock.stream.flags;
   return newsock;
  }),
  getname: (function(sock, peer) {
   var addr, port;
   if (peer) {
    if (sock.daddr === undefined || sock.dport === undefined) {
     throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
    }
    addr = sock.daddr;
    port = sock.dport;
   } else {
    addr = sock.saddr || 0;
    port = sock.sport || 0;
   }
   return {
    addr: addr,
    port: port
   };
  }),
  sendmsg: (function(sock, buffer, offset, length, addr, port) {
   if (sock.type === 2) {
    if (addr === undefined || port === undefined) {
     addr = sock.daddr;
     port = sock.dport;
    }
    if (addr === undefined || port === undefined) {
     throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
    }
   } else {
    addr = sock.daddr;
    port = sock.dport;
   }
   var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
   if (sock.type === 1) {
    if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
     throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
    } else if (dest.socket.readyState === dest.socket.CONNECTING) {
     throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
    }
   }
   var data;
   if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
    data = buffer.slice(offset, offset + length);
   } else {
    data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
   }
   if (sock.type === 2) {
    if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
     if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
      dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
     }
     dest.dgram_send_queue.push(data);
     return length;
    }
   }
   try {
    dest.socket.send(data);
    return length;
   } catch (e) {
    throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
   }
  }),
  recvmsg: (function(sock, length) {
   if (sock.type === 1 && sock.server) {
    throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
   }
   var queued = sock.recv_queue.shift();
   if (!queued) {
    if (sock.type === 1) {
     var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
     if (!dest) {
      throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
     } else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
      return null;
     } else {
      throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
     }
    } else {
     throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
    }
   }
   var queuedLength = queued.data.byteLength || queued.data.length;
   var queuedOffset = queued.data.byteOffset || 0;
   var queuedBuffer = queued.data.buffer || queued.data;
   var bytesRead = Math.min(length, queuedLength);
   var res = {
    buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
    addr: queued.addr,
    port: queued.port
   };
   if (sock.type === 1 && bytesRead < queuedLength) {
    var bytesRemaining = queuedLength - bytesRead;
    queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
    sock.recv_queue.unshift(queued);
   }
   return res;
  })
 }
};
function _recv(fd, buf, len, flags) {
 var sock = SOCKFS.getSocket(fd);
 if (!sock) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 return _read(fd, buf, len);
}
function _pread(fildes, buf, nbyte, offset) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 try {
  var slab = HEAP8;
  return FS.read(stream, slab, buf, nbyte, offset);
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _read(fildes, buf, nbyte) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 try {
  var slab = HEAP8;
  return FS.read(stream, slab, buf, nbyte);
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _fread(ptr, size, nitems, stream) {
 var bytesToRead = nitems * size;
 if (bytesToRead == 0) {
  return 0;
 }
 var bytesRead = 0;
 var streamObj = FS.getStreamFromPtr(stream);
 if (!streamObj) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return 0;
 }
 while (streamObj.ungotten.length && bytesToRead > 0) {
  HEAP8[ptr++ >> 0] = streamObj.ungotten.pop();
  bytesToRead--;
  bytesRead++;
 }
 var err = _read(streamObj.fd, ptr, bytesToRead);
 if (err == -1) {
  if (streamObj) streamObj.error = true;
  return 0;
 }
 bytesRead += err;
 if (bytesRead < bytesToRead) streamObj.eof = true;
 return bytesRead / size | 0;
}
function _fgetc(stream) {
 var streamObj = FS.getStreamFromPtr(stream);
 if (!streamObj) return -1;
 if (streamObj.eof || streamObj.error) return -1;
 var ret = _fread(_fgetc.ret, 1, 1, stream);
 if (ret == 0) {
  return -1;
 } else if (ret == -1) {
  streamObj.error = true;
  return -1;
 } else {
  return HEAPU8[_fgetc.ret >> 0];
 }
}
function _getc() {
 return _fgetc.apply(null, arguments);
}
var _UItoF = true;
var _DtoILow = true;
var _UItoD = true;
function __ZSt18uncaught_exceptionv() {
 return !!__ZSt18uncaught_exceptionv.uncaught_exception;
}
var EXCEPTIONS = {
 last: 0,
 caught: [],
 infos: {},
 deAdjust: (function(adjusted) {
  if (!adjusted || EXCEPTIONS.infos[adjusted]) return adjusted;
  for (var ptr in EXCEPTIONS.infos) {
   var info = EXCEPTIONS.infos[ptr];
   if (info.adjusted === adjusted) {
    return ptr;
   }
  }
  return adjusted;
 }),
 addRef: (function(ptr) {
  if (!ptr) return;
  var info = EXCEPTIONS.infos[ptr];
  info.refcount++;
 }),
 decRef: (function(ptr) {
  if (!ptr) return;
  var info = EXCEPTIONS.infos[ptr];
  assert(info.refcount > 0);
  info.refcount--;
  if (info.refcount === 0) {
   if (info.destructor) {
    Runtime.dynCall("vi", info.destructor, [ ptr ]);
   }
   delete EXCEPTIONS.infos[ptr];
   ___cxa_free_exception(ptr);
  }
 }),
 clearRef: (function(ptr) {
  if (!ptr) return;
  var info = EXCEPTIONS.infos[ptr];
  info.refcount = 0;
 })
};
function ___resumeException(ptr) {
 if (!EXCEPTIONS.last) {
  EXCEPTIONS.last = ptr;
 }
 EXCEPTIONS.clearRef(EXCEPTIONS.deAdjust(ptr));
 throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
}
function ___cxa_find_matching_catch() {
 var thrown = EXCEPTIONS.last;
 if (!thrown) {
  return (asm["setTempRet0"](0), 0) | 0;
 }
 var info = EXCEPTIONS.infos[thrown];
 var throwntype = info.type;
 if (!throwntype) {
  return (asm["setTempRet0"](0), thrown) | 0;
 }
 var typeArray = Array.prototype.slice.call(arguments);
 var pointer = Module["___cxa_is_pointer_type"](throwntype);
 if (!___cxa_find_matching_catch.buffer) ___cxa_find_matching_catch.buffer = _malloc(4);
 HEAP32[___cxa_find_matching_catch.buffer >> 2] = thrown;
 thrown = ___cxa_find_matching_catch.buffer;
 for (var i = 0; i < typeArray.length; i++) {
  if (typeArray[i] && Module["___cxa_can_catch"](typeArray[i], throwntype, thrown)) {
   thrown = HEAP32[thrown >> 2];
   info.adjusted = thrown;
   return (asm["setTempRet0"](typeArray[i]), thrown) | 0;
  }
 }
 thrown = HEAP32[thrown >> 2];
 return (asm["setTempRet0"](throwntype), thrown) | 0;
}
function ___cxa_throw(ptr, type, destructor) {
 EXCEPTIONS.infos[ptr] = {
  ptr: ptr,
  adjusted: ptr,
  type: type,
  destructor: destructor,
  refcount: 0
 };
 EXCEPTIONS.last = ptr;
 if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
  __ZSt18uncaught_exceptionv.uncaught_exception = 1;
 } else {
  __ZSt18uncaught_exceptionv.uncaught_exception++;
 }
 throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
}
function _close(fildes) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 try {
  FS.close(stream);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _fsync(fildes) {
 var stream = FS.getStream(fildes);
 if (stream) {
  return 0;
 } else {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
}
function _fileno(stream) {
 stream = FS.getStreamFromPtr(stream);
 if (!stream) return -1;
 return stream.fd;
}
function _fclose(stream) {
 var fd = _fileno(stream);
 _fsync(fd);
 return _close(fd);
}
var _FtoIHigh = true;
function _pthread_mutex_lock() {}
function _send(fd, buf, len, flags) {
 var sock = SOCKFS.getSocket(fd);
 if (!sock) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 return _write(fd, buf, len);
}
function _pwrite(fildes, buf, nbyte, offset) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 try {
  var slab = HEAP8;
  return FS.write(stream, slab, buf, nbyte, offset);
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _write(fildes, buf, nbyte) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 try {
  var slab = HEAP8;
  return FS.write(stream, slab, buf, nbyte);
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _fwrite(ptr, size, nitems, stream) {
 var bytesToWrite = nitems * size;
 if (bytesToWrite == 0) return 0;
 var fd = _fileno(stream);
 var bytesWritten = _write(fd, ptr, bytesToWrite);
 if (bytesWritten == -1) {
  var streamObj = FS.getStreamFromPtr(stream);
  if (streamObj) streamObj.error = true;
  return 0;
 } else {
  return bytesWritten / size | 0;
 }
}
Module["_strlen"] = _strlen;
function __reallyNegative(x) {
 return x < 0 || x === 0 && 1 / x === -Infinity;
}
function __formatString(format, varargs) {
 var textIndex = format;
 var argIndex = 0;
 function getNextArg(type) {
  var ret;
  if (type === "double") {
   ret = (HEAP32[tempDoublePtr >> 2] = HEAP32[varargs + argIndex >> 2], HEAP32[tempDoublePtr + 4 >> 2] = HEAP32[varargs + (argIndex + 4) >> 2], +HEAPF64[tempDoublePtr >> 3]);
  } else if (type == "i64") {
   ret = [ HEAP32[varargs + argIndex >> 2], HEAP32[varargs + (argIndex + 4) >> 2] ];
  } else {
   type = "i32";
   ret = HEAP32[varargs + argIndex >> 2];
  }
  argIndex += Runtime.getNativeFieldSize(type);
  return ret;
 }
 var ret = [];
 var curr, next, currArg;
 while (1) {
  var startTextIndex = textIndex;
  curr = HEAP8[textIndex >> 0];
  if (curr === 0) break;
  next = HEAP8[textIndex + 1 >> 0];
  if (curr == 37) {
   var flagAlwaysSigned = false;
   var flagLeftAlign = false;
   var flagAlternative = false;
   var flagZeroPad = false;
   var flagPadSign = false;
   flagsLoop : while (1) {
    switch (next) {
    case 43:
     flagAlwaysSigned = true;
     break;
    case 45:
     flagLeftAlign = true;
     break;
    case 35:
     flagAlternative = true;
     break;
    case 48:
     if (flagZeroPad) {
      break flagsLoop;
     } else {
      flagZeroPad = true;
      break;
     }
    case 32:
     flagPadSign = true;
     break;
    default:
     break flagsLoop;
    }
    textIndex++;
    next = HEAP8[textIndex + 1 >> 0];
   }
   var width = 0;
   if (next == 42) {
    width = getNextArg("i32");
    textIndex++;
    next = HEAP8[textIndex + 1 >> 0];
   } else {
    while (next >= 48 && next <= 57) {
     width = width * 10 + (next - 48);
     textIndex++;
     next = HEAP8[textIndex + 1 >> 0];
    }
   }
   var precisionSet = false, precision = -1;
   if (next == 46) {
    precision = 0;
    precisionSet = true;
    textIndex++;
    next = HEAP8[textIndex + 1 >> 0];
    if (next == 42) {
     precision = getNextArg("i32");
     textIndex++;
    } else {
     while (1) {
      var precisionChr = HEAP8[textIndex + 1 >> 0];
      if (precisionChr < 48 || precisionChr > 57) break;
      precision = precision * 10 + (precisionChr - 48);
      textIndex++;
     }
    }
    next = HEAP8[textIndex + 1 >> 0];
   }
   if (precision < 0) {
    precision = 6;
    precisionSet = false;
   }
   var argSize;
   switch (String.fromCharCode(next)) {
   case "h":
    var nextNext = HEAP8[textIndex + 2 >> 0];
    if (nextNext == 104) {
     textIndex++;
     argSize = 1;
    } else {
     argSize = 2;
    }
    break;
   case "l":
    var nextNext = HEAP8[textIndex + 2 >> 0];
    if (nextNext == 108) {
     textIndex++;
     argSize = 8;
    } else {
     argSize = 4;
    }
    break;
   case "L":
   case "q":
   case "j":
    argSize = 8;
    break;
   case "z":
   case "t":
   case "I":
    argSize = 4;
    break;
   default:
    argSize = null;
   }
   if (argSize) textIndex++;
   next = HEAP8[textIndex + 1 >> 0];
   switch (String.fromCharCode(next)) {
   case "d":
   case "i":
   case "u":
   case "o":
   case "x":
   case "X":
   case "p":
    {
     var signed = next == 100 || next == 105;
     argSize = argSize || 4;
     var currArg = getNextArg("i" + argSize * 8);
     var origArg = currArg;
     var argText;
     if (argSize == 8) {
      currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
     }
     if (argSize <= 4) {
      var limit = Math.pow(256, argSize) - 1;
      currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
     }
     var currAbsArg = Math.abs(currArg);
     var prefix = "";
     if (next == 100 || next == 105) {
      if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else argText = reSign(currArg, 8 * argSize, 1).toString(10);
     } else if (next == 117) {
      if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else argText = unSign(currArg, 8 * argSize, 1).toString(10);
      currArg = Math.abs(currArg);
     } else if (next == 111) {
      argText = (flagAlternative ? "0" : "") + currAbsArg.toString(8);
     } else if (next == 120 || next == 88) {
      prefix = flagAlternative && currArg != 0 ? "0x" : "";
      if (argSize == 8 && i64Math) {
       if (origArg[1]) {
        argText = (origArg[1] >>> 0).toString(16);
        var lower = (origArg[0] >>> 0).toString(16);
        while (lower.length < 8) lower = "0" + lower;
        argText += lower;
       } else {
        argText = (origArg[0] >>> 0).toString(16);
       }
      } else if (currArg < 0) {
       currArg = -currArg;
       argText = (currAbsArg - 1).toString(16);
       var buffer = [];
       for (var i = 0; i < argText.length; i++) {
        buffer.push((15 - parseInt(argText[i], 16)).toString(16));
       }
       argText = buffer.join("");
       while (argText.length < argSize * 2) argText = "f" + argText;
      } else {
       argText = currAbsArg.toString(16);
      }
      if (next == 88) {
       prefix = prefix.toUpperCase();
       argText = argText.toUpperCase();
      }
     } else if (next == 112) {
      if (currAbsArg === 0) {
       argText = "(nil)";
      } else {
       prefix = "0x";
       argText = currAbsArg.toString(16);
      }
     }
     if (precisionSet) {
      while (argText.length < precision) {
       argText = "0" + argText;
      }
     }
     if (currArg >= 0) {
      if (flagAlwaysSigned) {
       prefix = "+" + prefix;
      } else if (flagPadSign) {
       prefix = " " + prefix;
      }
     }
     if (argText.charAt(0) == "-") {
      prefix = "-" + prefix;
      argText = argText.substr(1);
     }
     while (prefix.length + argText.length < width) {
      if (flagLeftAlign) {
       argText += " ";
      } else {
       if (flagZeroPad) {
        argText = "0" + argText;
       } else {
        prefix = " " + prefix;
       }
      }
     }
     argText = prefix + argText;
     argText.split("").forEach((function(chr) {
      ret.push(chr.charCodeAt(0));
     }));
     break;
    }
   case "f":
   case "F":
   case "e":
   case "E":
   case "g":
   case "G":
    {
     var currArg = getNextArg("double");
     var argText;
     if (isNaN(currArg)) {
      argText = "nan";
      flagZeroPad = false;
     } else if (!isFinite(currArg)) {
      argText = (currArg < 0 ? "-" : "") + "inf";
      flagZeroPad = false;
     } else {
      var isGeneral = false;
      var effectivePrecision = Math.min(precision, 20);
      if (next == 103 || next == 71) {
       isGeneral = true;
       precision = precision || 1;
       var exponent = parseInt(currArg.toExponential(effectivePrecision).split("e")[1], 10);
       if (precision > exponent && exponent >= -4) {
        next = (next == 103 ? "f" : "F").charCodeAt(0);
        precision -= exponent + 1;
       } else {
        next = (next == 103 ? "e" : "E").charCodeAt(0);
        precision--;
       }
       effectivePrecision = Math.min(precision, 20);
      }
      if (next == 101 || next == 69) {
       argText = currArg.toExponential(effectivePrecision);
       if (/[eE][-+]\d$/.test(argText)) {
        argText = argText.slice(0, -1) + "0" + argText.slice(-1);
       }
      } else if (next == 102 || next == 70) {
       argText = currArg.toFixed(effectivePrecision);
       if (currArg === 0 && __reallyNegative(currArg)) {
        argText = "-" + argText;
       }
      }
      var parts = argText.split("e");
      if (isGeneral && !flagAlternative) {
       while (parts[0].length > 1 && parts[0].indexOf(".") != -1 && (parts[0].slice(-1) == "0" || parts[0].slice(-1) == ".")) {
        parts[0] = parts[0].slice(0, -1);
       }
      } else {
       if (flagAlternative && argText.indexOf(".") == -1) parts[0] += ".";
       while (precision > effectivePrecision++) parts[0] += "0";
      }
      argText = parts[0] + (parts.length > 1 ? "e" + parts[1] : "");
      if (next == 69) argText = argText.toUpperCase();
      if (currArg >= 0) {
       if (flagAlwaysSigned) {
        argText = "+" + argText;
       } else if (flagPadSign) {
        argText = " " + argText;
       }
      }
     }
     while (argText.length < width) {
      if (flagLeftAlign) {
       argText += " ";
      } else {
       if (flagZeroPad && (argText[0] == "-" || argText[0] == "+")) {
        argText = argText[0] + "0" + argText.slice(1);
       } else {
        argText = (flagZeroPad ? "0" : " ") + argText;
       }
      }
     }
     if (next < 97) argText = argText.toUpperCase();
     argText.split("").forEach((function(chr) {
      ret.push(chr.charCodeAt(0));
     }));
     break;
    }
   case "s":
    {
     var arg = getNextArg("i8*");
     var argLength = arg ? _strlen(arg) : "(null)".length;
     if (precisionSet) argLength = Math.min(argLength, precision);
     if (!flagLeftAlign) {
      while (argLength < width--) {
       ret.push(32);
      }
     }
     if (arg) {
      for (var i = 0; i < argLength; i++) {
       ret.push(HEAPU8[arg++ >> 0]);
      }
     } else {
      ret = ret.concat(intArrayFromString("(null)".substr(0, argLength), true));
     }
     if (flagLeftAlign) {
      while (argLength < width--) {
       ret.push(32);
      }
     }
     break;
    }
   case "c":
    {
     if (flagLeftAlign) ret.push(getNextArg("i8"));
     while (--width > 0) {
      ret.push(32);
     }
     if (!flagLeftAlign) ret.push(getNextArg("i8"));
     break;
    }
   case "n":
    {
     var ptr = getNextArg("i32*");
     HEAP32[ptr >> 2] = ret.length;
     break;
    }
   case "%":
    {
     ret.push(curr);
     break;
    }
   default:
    {
     for (var i = startTextIndex; i < textIndex + 2; i++) {
      ret.push(HEAP8[i >> 0]);
     }
    }
   }
   textIndex += 2;
  } else {
   ret.push(curr);
   textIndex += 1;
  }
 }
 return ret;
}
function _fprintf(stream, format, varargs) {
 var result = __formatString(format, varargs);
 var stack = Runtime.stackSave();
 var ret = _fwrite(allocate(result, "i8", ALLOC_STACK), 1, result.length, stream);
 Runtime.stackRestore(stack);
 return ret;
}
function _printf(format, varargs) {
 var stdout = HEAP32[_stdout >> 2];
 return _fprintf(stdout, format, varargs);
}
Module["_i64Subtract"] = _i64Subtract;
function _open(path, oflag, varargs) {
 var mode = HEAP32[varargs >> 2];
 path = Pointer_stringify(path);
 try {
  var stream = FS.open(path, oflag, mode);
  return stream.fd;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _fopen(filename, mode) {
 var flags;
 mode = Pointer_stringify(mode);
 if (mode[0] == "r") {
  if (mode.indexOf("+") != -1) {
   flags = 2;
  } else {
   flags = 0;
  }
 } else if (mode[0] == "w") {
  if (mode.indexOf("+") != -1) {
   flags = 2;
  } else {
   flags = 1;
  }
  flags |= 64;
  flags |= 512;
 } else if (mode[0] == "a") {
  if (mode.indexOf("+") != -1) {
   flags = 2;
  } else {
   flags = 1;
  }
  flags |= 64;
  flags |= 1024;
 } else {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return 0;
 }
 var fd = _open(filename, flags, allocate([ 511, 0, 0, 0 ], "i32", ALLOC_STACK));
 return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
}
var _sqrtf = Math_sqrt;
Module["_strncpy"] = _strncpy;
var _fabsf = Math_abs;
function _usleep(useconds) {
 var msec = useconds / 1e3;
 if ((ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) && self["performance"] && self["performance"]["now"]) {
  var start = self["performance"]["now"]();
  while (self["performance"]["now"]() - start < msec) {}
 } else {
  var start = Date.now();
  while (Date.now() - start < msec) {}
 }
 return 0;
}
function _fputc(c, stream) {
 var chr = unSign(c & 255);
 HEAP8[_fputc.ret >> 0] = chr;
 var fd = _fileno(stream);
 var ret = _write(fd, _fputc.ret, 1);
 if (ret == -1) {
  var streamObj = FS.getStreamFromPtr(stream);
  if (streamObj) streamObj.error = true;
  return -1;
 } else {
  return chr;
 }
}
Module["_i64Add"] = _i64Add;
function _fputs(s, stream) {
 var fd = _fileno(stream);
 return _write(fd, s, _strlen(s));
}
function _puts(s) {
 var stdout = HEAP32[_stdout >> 2];
 var ret = _fputs(s, stdout);
 if (ret < 0) {
  return ret;
 } else {
  var newlineRet = _fputc(10, stdout);
  return newlineRet < 0 ? -1 : ret + 1;
 }
}
function _mknod(path, mode, dev) {
 path = Pointer_stringify(path);
 switch (mode & 61440) {
 case 32768:
 case 8192:
 case 24576:
 case 4096:
 case 49152:
  break;
 default:
  ___setErrNo(ERRNO_CODES.EINVAL);
  return -1;
 }
 try {
  FS.mknod(path, mode, dev);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _mkdir(path, mode) {
 path = Pointer_stringify(path);
 path = PATH.normalize(path);
 if (path[path.length - 1] === "/") path = path.substr(0, path.length - 1);
 try {
  FS.mkdir(path, mode, 0);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _pthread_mutex_init() {}
function _vprintf(format, va_arg) {
 return _printf(format, HEAP32[va_arg >> 2]);
}
function _pthread_mutexattr_destroy() {}
function _emscripten_set_main_loop_timing(mode, value) {
 Browser.mainLoop.timingMode = mode;
 Browser.mainLoop.timingValue = value;
 if (!Browser.mainLoop.func) {
  return 1;
 }
 if (mode == 0) {
  Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler() {
   setTimeout(Browser.mainLoop.runner, value);
  };
  Browser.mainLoop.method = "timeout";
 } else if (mode == 1) {
  Browser.mainLoop.scheduler = function Browser_mainLoop_scheduler() {
   Browser.requestAnimationFrame(Browser.mainLoop.runner);
  };
  Browser.mainLoop.method = "rAF";
 }
 return 0;
}
function _emscripten_set_main_loop(func, fps, simulateInfiniteLoop, arg) {
 Module["noExitRuntime"] = true;
 assert(!Browser.mainLoop.func, "emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters.");
 Browser.mainLoop.func = func;
 Browser.mainLoop.arg = arg;
 var thisMainLoopId = Browser.mainLoop.currentlyRunningMainloop;
 Browser.mainLoop.runner = function Browser_mainLoop_runner() {
  if (ABORT) return;
  if (Browser.mainLoop.queue.length > 0) {
   var start = Date.now();
   var blocker = Browser.mainLoop.queue.shift();
   blocker.func(blocker.arg);
   if (Browser.mainLoop.remainingBlockers) {
    var remaining = Browser.mainLoop.remainingBlockers;
    var next = remaining % 1 == 0 ? remaining - 1 : Math.floor(remaining);
    if (blocker.counted) {
     Browser.mainLoop.remainingBlockers = next;
    } else {
     next = next + .5;
     Browser.mainLoop.remainingBlockers = (8 * remaining + next) / 9;
    }
   }
   console.log('main loop blocker "' + blocker.name + '" took ' + (Date.now() - start) + " ms");
   Browser.mainLoop.updateStatus();
   setTimeout(Browser.mainLoop.runner, 0);
   return;
  }
  if (thisMainLoopId < Browser.mainLoop.currentlyRunningMainloop) return;
  Browser.mainLoop.currentFrameNumber = Browser.mainLoop.currentFrameNumber + 1 | 0;
  if (Browser.mainLoop.timingMode == 1 && Browser.mainLoop.timingValue > 1 && Browser.mainLoop.currentFrameNumber % Browser.mainLoop.timingValue != 0) {
   Browser.mainLoop.scheduler();
   return;
  }
  if (Browser.mainLoop.method === "timeout" && Module.ctx) {
   Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!");
   Browser.mainLoop.method = "";
  }
  Browser.mainLoop.runIter((function() {
   if (typeof arg !== "undefined") {
    Runtime.dynCall("vi", func, [ arg ]);
   } else {
    Runtime.dynCall("v", func);
   }
  }));
  if (thisMainLoopId < Browser.mainLoop.currentlyRunningMainloop) return;
  if (typeof SDL === "object" && SDL.audio && SDL.audio.queueNewAudioData) SDL.audio.queueNewAudioData();
  Browser.mainLoop.scheduler();
 };
 if (fps && fps > 0) _emscripten_set_main_loop_timing(0, 1e3 / fps); else _emscripten_set_main_loop_timing(1, 1);
 Browser.mainLoop.scheduler();
 if (simulateInfiniteLoop) {
  throw "SimulateInfiniteLoop";
 }
}
var Browser = {
 mainLoop: {
  scheduler: null,
  method: "",
  currentlyRunningMainloop: 0,
  func: null,
  arg: 0,
  timingMode: 0,
  timingValue: 0,
  currentFrameNumber: 0,
  queue: [],
  pause: (function() {
   Browser.mainLoop.scheduler = null;
   Browser.mainLoop.currentlyRunningMainloop++;
  }),
  resume: (function() {
   Browser.mainLoop.currentlyRunningMainloop++;
   var timingMode = Browser.mainLoop.timingMode;
   var timingValue = Browser.mainLoop.timingValue;
   var func = Browser.mainLoop.func;
   Browser.mainLoop.func = null;
   _emscripten_set_main_loop(func, 0, false, Browser.mainLoop.arg);
   _emscripten_set_main_loop_timing(timingMode, timingValue);
  }),
  updateStatus: (function() {
   if (Module["setStatus"]) {
    var message = Module["statusMessage"] || "Please wait...";
    var remaining = Browser.mainLoop.remainingBlockers;
    var expected = Browser.mainLoop.expectedBlockers;
    if (remaining) {
     if (remaining < expected) {
      Module["setStatus"](message + " (" + (expected - remaining) + "/" + expected + ")");
     } else {
      Module["setStatus"](message);
     }
    } else {
     Module["setStatus"]("");
    }
   }
  }),
  runIter: (function(func) {
   if (ABORT) return;
   if (Module["preMainLoop"]) {
    var preRet = Module["preMainLoop"]();
    if (preRet === false) {
     return;
    }
   }
   try {
    func();
   } catch (e) {
    if (e instanceof ExitStatus) {
     return;
    } else {
     if (e && typeof e === "object" && e.stack) Module.printErr("exception thrown: " + [ e, e.stack ]);
     throw e;
    }
   }
   if (Module["postMainLoop"]) Module["postMainLoop"]();
  })
 },
 isFullScreen: false,
 pointerLock: false,
 moduleContextCreatedCallbacks: [],
 workers: [],
 init: (function() {
  if (!Module["preloadPlugins"]) Module["preloadPlugins"] = [];
  if (Browser.initted) return;
  Browser.initted = true;
  try {
   new Blob;
   Browser.hasBlobConstructor = true;
  } catch (e) {
   Browser.hasBlobConstructor = false;
   console.log("warning: no blob constructor, cannot create blobs with mimetypes");
  }
  Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : !Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null;
  Browser.URLObject = typeof window != "undefined" ? window.URL ? window.URL : window.webkitURL : undefined;
  if (!Module.noImageDecoding && typeof Browser.URLObject === "undefined") {
   console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
   Module.noImageDecoding = true;
  }
  var imagePlugin = {};
  imagePlugin["canHandle"] = function imagePlugin_canHandle(name) {
   return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
  };
  imagePlugin["handle"] = function imagePlugin_handle(byteArray, name, onload, onerror) {
   var b = null;
   if (Browser.hasBlobConstructor) {
    try {
     b = new Blob([ byteArray ], {
      type: Browser.getMimetype(name)
     });
     if (b.size !== byteArray.length) {
      b = new Blob([ (new Uint8Array(byteArray)).buffer ], {
       type: Browser.getMimetype(name)
      });
     }
    } catch (e) {
     Runtime.warnOnce("Blob constructor present but fails: " + e + "; falling back to blob builder");
    }
   }
   if (!b) {
    var bb = new Browser.BlobBuilder;
    bb.append((new Uint8Array(byteArray)).buffer);
    b = bb.getBlob();
   }
   var url = Browser.URLObject.createObjectURL(b);
   var img = new Image;
   img.onload = function img_onload() {
    assert(img.complete, "Image " + name + " could not be decoded");
    var canvas = document.createElement("canvas");
    canvas.width = img.width;
    canvas.height = img.height;
    var ctx = canvas.getContext("2d");
    ctx.drawImage(img, 0, 0);
    Module["preloadedImages"][name] = canvas;
    Browser.URLObject.revokeObjectURL(url);
    if (onload) onload(byteArray);
   };
   img.onerror = function img_onerror(event) {
    console.log("Image " + url + " could not be decoded");
    if (onerror) onerror();
   };
   img.src = url;
  };
  Module["preloadPlugins"].push(imagePlugin);
  var audioPlugin = {};
  audioPlugin["canHandle"] = function audioPlugin_canHandle(name) {
   return !Module.noAudioDecoding && name.substr(-4) in {
    ".ogg": 1,
    ".wav": 1,
    ".mp3": 1
   };
  };
  audioPlugin["handle"] = function audioPlugin_handle(byteArray, name, onload, onerror) {
   var done = false;
   function finish(audio) {
    if (done) return;
    done = true;
    Module["preloadedAudios"][name] = audio;
    if (onload) onload(byteArray);
   }
   function fail() {
    if (done) return;
    done = true;
    Module["preloadedAudios"][name] = new Audio;
    if (onerror) onerror();
   }
   if (Browser.hasBlobConstructor) {
    try {
     var b = new Blob([ byteArray ], {
      type: Browser.getMimetype(name)
     });
    } catch (e) {
     return fail();
    }
    var url = Browser.URLObject.createObjectURL(b);
    var audio = new Audio;
    audio.addEventListener("canplaythrough", (function() {
     finish(audio);
    }), false);
    audio.onerror = function audio_onerror(event) {
     if (done) return;
     console.log("warning: browser could not fully decode audio " + name + ", trying slower base64 approach");
     function encode64(data) {
      var BASE = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
      var PAD = "=";
      var ret = "";
      var leftchar = 0;
      var leftbits = 0;
      for (var i = 0; i < data.length; i++) {
       leftchar = leftchar << 8 | data[i];
       leftbits += 8;
       while (leftbits >= 6) {
        var curr = leftchar >> leftbits - 6 & 63;
        leftbits -= 6;
        ret += BASE[curr];
       }
      }
      if (leftbits == 2) {
       ret += BASE[(leftchar & 3) << 4];
       ret += PAD + PAD;
      } else if (leftbits == 4) {
       ret += BASE[(leftchar & 15) << 2];
       ret += PAD;
      }
      return ret;
     }
     audio.src = "data:audio/x-" + name.substr(-3) + ";base64," + encode64(byteArray);
     finish(audio);
    };
    audio.src = url;
    Browser.safeSetTimeout((function() {
     finish(audio);
    }), 1e4);
   } else {
    return fail();
   }
  };
  Module["preloadPlugins"].push(audioPlugin);
  var canvas = Module["canvas"];
  function pointerLockChange() {
   Browser.pointerLock = document["pointerLockElement"] === canvas || document["mozPointerLockElement"] === canvas || document["webkitPointerLockElement"] === canvas || document["msPointerLockElement"] === canvas;
  }
  if (canvas) {
   canvas.requestPointerLock = canvas["requestPointerLock"] || canvas["mozRequestPointerLock"] || canvas["webkitRequestPointerLock"] || canvas["msRequestPointerLock"] || (function() {});
   canvas.exitPointerLock = document["exitPointerLock"] || document["mozExitPointerLock"] || document["webkitExitPointerLock"] || document["msExitPointerLock"] || (function() {});
   canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
   document.addEventListener("pointerlockchange", pointerLockChange, false);
   document.addEventListener("mozpointerlockchange", pointerLockChange, false);
   document.addEventListener("webkitpointerlockchange", pointerLockChange, false);
   document.addEventListener("mspointerlockchange", pointerLockChange, false);
   if (Module["elementPointerLock"]) {
    canvas.addEventListener("click", (function(ev) {
     if (!Browser.pointerLock && canvas.requestPointerLock) {
      canvas.requestPointerLock();
      ev.preventDefault();
     }
    }), false);
   }
  }
 }),
 createContext: (function(canvas, useWebGL, setInModule, webGLContextAttributes) {
  if (useWebGL && Module.ctx && canvas == Module.canvas) return Module.ctx;
  var ctx;
  var contextHandle;
  if (useWebGL) {
   var contextAttributes = {
    antialias: false,
    alpha: false
   };
   if (webGLContextAttributes) {
    for (var attribute in webGLContextAttributes) {
     contextAttributes[attribute] = webGLContextAttributes[attribute];
    }
   }
   contextHandle = GL.createContext(canvas, contextAttributes);
   if (contextHandle) {
    ctx = GL.getContext(contextHandle).GLctx;
   }
   canvas.style.backgroundColor = "black";
  } else {
   ctx = canvas.getContext("2d");
  }
  if (!ctx) return null;
  if (setInModule) {
   if (!useWebGL) assert(typeof GLctx === "undefined", "cannot set in module if GLctx is used, but we are a non-GL context that would replace it");
   Module.ctx = ctx;
   if (useWebGL) GL.makeContextCurrent(contextHandle);
   Module.useWebGL = useWebGL;
   Browser.moduleContextCreatedCallbacks.forEach((function(callback) {
    callback();
   }));
   Browser.init();
  }
  return ctx;
 }),
 destroyContext: (function(canvas, useWebGL, setInModule) {}),
 fullScreenHandlersInstalled: false,
 lockPointer: undefined,
 resizeCanvas: undefined,
 requestFullScreen: (function(lockPointer, resizeCanvas) {
  Browser.lockPointer = lockPointer;
  Browser.resizeCanvas = resizeCanvas;
  if (typeof Browser.lockPointer === "undefined") Browser.lockPointer = true;
  if (typeof Browser.resizeCanvas === "undefined") Browser.resizeCanvas = false;
  var canvas = Module["canvas"];
  function fullScreenChange() {
   Browser.isFullScreen = false;
   var canvasContainer = canvas.parentNode;
   if ((document["webkitFullScreenElement"] || document["webkitFullscreenElement"] || document["mozFullScreenElement"] || document["mozFullscreenElement"] || document["fullScreenElement"] || document["fullscreenElement"] || document["msFullScreenElement"] || document["msFullscreenElement"] || document["webkitCurrentFullScreenElement"]) === canvasContainer) {
    canvas.cancelFullScreen = document["cancelFullScreen"] || document["mozCancelFullScreen"] || document["webkitCancelFullScreen"] || document["msExitFullscreen"] || document["exitFullscreen"] || (function() {});
    canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
    if (Browser.lockPointer) canvas.requestPointerLock();
    Browser.isFullScreen = true;
    if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
   } else {
    canvasContainer.parentNode.insertBefore(canvas, canvasContainer);
    canvasContainer.parentNode.removeChild(canvasContainer);
    if (Browser.resizeCanvas) Browser.setWindowedCanvasSize();
   }
   if (Module["onFullScreen"]) Module["onFullScreen"](Browser.isFullScreen);
   Browser.updateCanvasDimensions(canvas);
  }
  if (!Browser.fullScreenHandlersInstalled) {
   Browser.fullScreenHandlersInstalled = true;
   document.addEventListener("fullscreenchange", fullScreenChange, false);
   document.addEventListener("mozfullscreenchange", fullScreenChange, false);
   document.addEventListener("webkitfullscreenchange", fullScreenChange, false);
   document.addEventListener("MSFullscreenChange", fullScreenChange, false);
  }
  var canvasContainer = document.createElement("div");
  canvas.parentNode.insertBefore(canvasContainer, canvas);
  canvasContainer.appendChild(canvas);
  canvasContainer.requestFullScreen = canvasContainer["requestFullScreen"] || canvasContainer["mozRequestFullScreen"] || canvasContainer["msRequestFullscreen"] || (canvasContainer["webkitRequestFullScreen"] ? (function() {
   canvasContainer["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"]);
  }) : null);
  canvasContainer.requestFullScreen();
 }),
 nextRAF: 0,
 fakeRequestAnimationFrame: (function(func) {
  var now = Date.now();
  if (Browser.nextRAF === 0) {
   Browser.nextRAF = now + 1e3 / 60;
  } else {
   while (now + 2 >= Browser.nextRAF) {
    Browser.nextRAF += 1e3 / 60;
   }
  }
  var delay = Math.max(Browser.nextRAF - now, 0);
  setTimeout(func, delay);
 }),
 requestAnimationFrame: function requestAnimationFrame(func) {
  if (typeof window === "undefined") {
   Browser.fakeRequestAnimationFrame(func);
  } else {
   if (!window.requestAnimationFrame) {
    window.requestAnimationFrame = window["requestAnimationFrame"] || window["mozRequestAnimationFrame"] || window["webkitRequestAnimationFrame"] || window["msRequestAnimationFrame"] || window["oRequestAnimationFrame"] || Browser.fakeRequestAnimationFrame;
   }
   window.requestAnimationFrame(func);
  }
 },
 safeCallback: (function(func) {
  return (function() {
   if (!ABORT) return func.apply(null, arguments);
  });
 }),
 safeRequestAnimationFrame: (function(func) {
  return Browser.requestAnimationFrame((function() {
   if (!ABORT) func();
  }));
 }),
 safeSetTimeout: (function(func, timeout) {
  Module["noExitRuntime"] = true;
  return setTimeout((function() {
   if (!ABORT) func();
  }), timeout);
 }),
 safeSetInterval: (function(func, timeout) {
  Module["noExitRuntime"] = true;
  return setInterval((function() {
   if (!ABORT) func();
  }), timeout);
 }),
 getMimetype: (function(name) {
  return {
   "jpg": "image/jpeg",
   "jpeg": "image/jpeg",
   "png": "image/png",
   "bmp": "image/bmp",
   "ogg": "audio/ogg",
   "wav": "audio/wav",
   "mp3": "audio/mpeg"
  }[name.substr(name.lastIndexOf(".") + 1)];
 }),
 getUserMedia: (function(func) {
  if (!window.getUserMedia) {
   window.getUserMedia = navigator["getUserMedia"] || navigator["mozGetUserMedia"];
  }
  window.getUserMedia(func);
 }),
 getMovementX: (function(event) {
  return event["movementX"] || event["mozMovementX"] || event["webkitMovementX"] || 0;
 }),
 getMovementY: (function(event) {
  return event["movementY"] || event["mozMovementY"] || event["webkitMovementY"] || 0;
 }),
 getMouseWheelDelta: (function(event) {
  var delta = 0;
  switch (event.type) {
  case "DOMMouseScroll":
   delta = event.detail;
   break;
  case "mousewheel":
   delta = event.wheelDelta;
   break;
  case "wheel":
   delta = event["deltaY"];
   break;
  default:
   throw "unrecognized mouse wheel event: " + event.type;
  }
  return delta;
 }),
 mouseX: 0,
 mouseY: 0,
 mouseMovementX: 0,
 mouseMovementY: 0,
 touches: {},
 lastTouches: {},
 calculateMouseEvent: (function(event) {
  if (Browser.pointerLock) {
   if (event.type != "mousemove" && "mozMovementX" in event) {
    Browser.mouseMovementX = Browser.mouseMovementY = 0;
   } else {
    Browser.mouseMovementX = Browser.getMovementX(event);
    Browser.mouseMovementY = Browser.getMovementY(event);
   }
   if (typeof SDL != "undefined") {
    Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
    Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
   } else {
    Browser.mouseX += Browser.mouseMovementX;
    Browser.mouseY += Browser.mouseMovementY;
   }
  } else {
   var rect = Module["canvas"].getBoundingClientRect();
   var cw = Module["canvas"].width;
   var ch = Module["canvas"].height;
   var scrollX = typeof window.scrollX !== "undefined" ? window.scrollX : window.pageXOffset;
   var scrollY = typeof window.scrollY !== "undefined" ? window.scrollY : window.pageYOffset;
   if (event.type === "touchstart" || event.type === "touchend" || event.type === "touchmove") {
    var touch = event.touch;
    if (touch === undefined) {
     return;
    }
    var adjustedX = touch.pageX - (scrollX + rect.left);
    var adjustedY = touch.pageY - (scrollY + rect.top);
    adjustedX = adjustedX * (cw / rect.width);
    adjustedY = adjustedY * (ch / rect.height);
    var coords = {
     x: adjustedX,
     y: adjustedY
    };
    if (event.type === "touchstart") {
     Browser.lastTouches[touch.identifier] = coords;
     Browser.touches[touch.identifier] = coords;
    } else if (event.type === "touchend" || event.type === "touchmove") {
     Browser.lastTouches[touch.identifier] = Browser.touches[touch.identifier];
     Browser.touches[touch.identifier] = {
      x: adjustedX,
      y: adjustedY
     };
    }
    return;
   }
   var x = event.pageX - (scrollX + rect.left);
   var y = event.pageY - (scrollY + rect.top);
   x = x * (cw / rect.width);
   y = y * (ch / rect.height);
   Browser.mouseMovementX = x - Browser.mouseX;
   Browser.mouseMovementY = y - Browser.mouseY;
   Browser.mouseX = x;
   Browser.mouseY = y;
  }
 }),
 xhrLoad: (function(url, onload, onerror) {
  var xhr = new XMLHttpRequest;
  xhr.open("GET", url, true);
  xhr.responseType = "arraybuffer";
  xhr.onload = function xhr_onload() {
   if (xhr.status == 200 || xhr.status == 0 && xhr.response) {
    onload(xhr.response);
   } else {
    onerror();
   }
  };
  xhr.onerror = onerror;
  xhr.send(null);
 }),
 asyncLoad: (function(url, onload, onerror, noRunDep) {
  Browser.xhrLoad(url, (function(arrayBuffer) {
   assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
   onload(new Uint8Array(arrayBuffer));
   if (!noRunDep) removeRunDependency("al " + url);
  }), (function(event) {
   if (onerror) {
    onerror();
   } else {
    throw 'Loading data file "' + url + '" failed.';
   }
  }));
  if (!noRunDep) addRunDependency("al " + url);
 }),
 resizeListeners: [],
 updateResizeListeners: (function() {
  var canvas = Module["canvas"];
  Browser.resizeListeners.forEach((function(listener) {
   listener(canvas.width, canvas.height);
  }));
 }),
 setCanvasSize: (function(width, height, noUpdates) {
  var canvas = Module["canvas"];
  Browser.updateCanvasDimensions(canvas, width, height);
  if (!noUpdates) Browser.updateResizeListeners();
 }),
 windowedWidth: 0,
 windowedHeight: 0,
 setFullScreenCanvasSize: (function() {
  if (typeof SDL != "undefined") {
   var flags = HEAPU32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2];
   flags = flags | 8388608;
   HEAP32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2] = flags;
  }
  Browser.updateResizeListeners();
 }),
 setWindowedCanvasSize: (function() {
  if (typeof SDL != "undefined") {
   var flags = HEAPU32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2];
   flags = flags & ~8388608;
   HEAP32[SDL.screen + Runtime.QUANTUM_SIZE * 0 >> 2] = flags;
  }
  Browser.updateResizeListeners();
 }),
 updateCanvasDimensions: (function(canvas, wNative, hNative) {
  if (wNative && hNative) {
   canvas.widthNative = wNative;
   canvas.heightNative = hNative;
  } else {
   wNative = canvas.widthNative;
   hNative = canvas.heightNative;
  }
  var w = wNative;
  var h = hNative;
  if (Module["forcedAspectRatio"] && Module["forcedAspectRatio"] > 0) {
   if (w / h < Module["forcedAspectRatio"]) {
    w = Math.round(h * Module["forcedAspectRatio"]);
   } else {
    h = Math.round(w / Module["forcedAspectRatio"]);
   }
  }
  if ((document["webkitFullScreenElement"] || document["webkitFullscreenElement"] || document["mozFullScreenElement"] || document["mozFullscreenElement"] || document["fullScreenElement"] || document["fullscreenElement"] || document["msFullScreenElement"] || document["msFullscreenElement"] || document["webkitCurrentFullScreenElement"]) === canvas.parentNode && typeof screen != "undefined") {
   var factor = Math.min(screen.width / w, screen.height / h);
   w = Math.round(w * factor);
   h = Math.round(h * factor);
  }
  if (Browser.resizeCanvas) {
   if (canvas.width != w) canvas.width = w;
   if (canvas.height != h) canvas.height = h;
   if (typeof canvas.style != "undefined") {
    canvas.style.removeProperty("width");
    canvas.style.removeProperty("height");
   }
  } else {
   if (canvas.width != wNative) canvas.width = wNative;
   if (canvas.height != hNative) canvas.height = hNative;
   if (typeof canvas.style != "undefined") {
    if (w != wNative || h != hNative) {
     canvas.style.setProperty("width", w + "px", "important");
     canvas.style.setProperty("height", h + "px", "important");
    } else {
     canvas.style.removeProperty("width");
     canvas.style.removeProperty("height");
    }
   }
  }
 }),
 wgetRequests: {},
 nextWgetRequestHandle: 0,
 getNextWgetRequestHandle: (function() {
  var handle = Browser.nextWgetRequestHandle;
  Browser.nextWgetRequestHandle++;
  return handle;
 })
};
var ___tm_current = allocate(44, "i8", ALLOC_STATIC);
var ___tm_timezone = allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
var _tzname = allocate(8, "i32*", ALLOC_STATIC);
var _daylight = allocate(1, "i32*", ALLOC_STATIC);
var _timezone = allocate(1, "i32*", ALLOC_STATIC);
function _tzset() {
 if (_tzset.called) return;
 _tzset.called = true;
 HEAP32[_timezone >> 2] = -(new Date).getTimezoneOffset() * 60;
 var winter = new Date(2e3, 0, 1);
 var summer = new Date(2e3, 6, 1);
 HEAP32[_daylight >> 2] = Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
 function extractZone(date) {
  var match = date.toTimeString().match(/\(([A-Za-z ]+)\)$/);
  return match ? match[1] : "GMT";
 }
 var winterName = extractZone(winter);
 var summerName = extractZone(summer);
 var winterNamePtr = allocate(intArrayFromString(winterName), "i8", ALLOC_NORMAL);
 var summerNamePtr = allocate(intArrayFromString(summerName), "i8", ALLOC_NORMAL);
 if (summer.getTimezoneOffset() < winter.getTimezoneOffset()) {
  HEAP32[_tzname >> 2] = winterNamePtr;
  HEAP32[_tzname + 4 >> 2] = summerNamePtr;
 } else {
  HEAP32[_tzname >> 2] = summerNamePtr;
  HEAP32[_tzname + 4 >> 2] = winterNamePtr;
 }
}
function _localtime_r(time, tmPtr) {
 _tzset();
 var date = new Date(HEAP32[time >> 2] * 1e3);
 HEAP32[tmPtr >> 2] = date.getSeconds();
 HEAP32[tmPtr + 4 >> 2] = date.getMinutes();
 HEAP32[tmPtr + 8 >> 2] = date.getHours();
 HEAP32[tmPtr + 12 >> 2] = date.getDate();
 HEAP32[tmPtr + 16 >> 2] = date.getMonth();
 HEAP32[tmPtr + 20 >> 2] = date.getFullYear() - 1900;
 HEAP32[tmPtr + 24 >> 2] = date.getDay();
 var start = new Date(date.getFullYear(), 0, 1);
 var yday = (date.getTime() - start.getTime()) / (1e3 * 60 * 60 * 24) | 0;
 HEAP32[tmPtr + 28 >> 2] = yday;
 HEAP32[tmPtr + 36 >> 2] = -(date.getTimezoneOffset() * 60);
 var summerOffset = (new Date(2e3, 6, 1)).getTimezoneOffset();
 var winterOffset = start.getTimezoneOffset();
 var dst = date.getTimezoneOffset() == Math.min(winterOffset, summerOffset) | 0;
 HEAP32[tmPtr + 32 >> 2] = dst;
 var zonePtr = HEAP32[_tzname + (dst ? Runtime.QUANTUM_SIZE : 0) >> 2];
 HEAP32[tmPtr + 40 >> 2] = zonePtr;
 return tmPtr;
}
function _localtime(time) {
 return _localtime_r(time, ___tm_current);
}
Module["_bitshift64Ashr"] = _bitshift64Ashr;
Module["_bitshift64Lshr"] = _bitshift64Lshr;
function _isatty(fildes) {
 var stream = FS.getStream(fildes);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return 0;
 }
 if (!stream.tty) {
  ___setErrNo(ERRNO_CODES.ENOTTY);
  return 0;
 }
 return 1;
}
function _ftell(stream) {
 stream = FS.getStreamFromPtr(stream);
 if (!stream) {
  ___setErrNo(ERRNO_CODES.EBADF);
  return -1;
 }
 if (FS.isChrdev(stream.node.mode)) {
  ___setErrNo(ERRNO_CODES.ESPIPE);
  return -1;
 } else {
  return stream.position;
 }
}
function _ftello() {
 return _ftell.apply(null, arguments);
}
var _BDtoIHigh = true;
var PTHREAD_SPECIFIC = {};
var PTHREAD_SPECIFIC_NEXT_KEY = 1;
function _pthread_key_create(key, destructor) {
 if (key == 0) {
  return ERRNO_CODES.EINVAL;
 }
 HEAP32[key >> 2] = PTHREAD_SPECIFIC_NEXT_KEY;
 PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
 PTHREAD_SPECIFIC_NEXT_KEY++;
 return 0;
}
function _putchar(c) {
 return _fputc(c, HEAP32[_stdout >> 2]);
}
Module["_saveSetjmp"] = _saveSetjmp;
Module["_testSetjmp"] = _testSetjmp;
function _longjmp(env, value) {
 asm["setThrew"](env, value || 1);
 throw "longjmp";
}
function _emscripten_longjmp(env, value) {
 _longjmp(env, value);
}
var _environ = allocate(1, "i32*", ALLOC_STATIC);
var ___environ = _environ;
function ___buildEnvironment(env) {
 var MAX_ENV_VALUES = 64;
 var TOTAL_ENV_SIZE = 1024;
 var poolPtr;
 var envPtr;
 if (!___buildEnvironment.called) {
  ___buildEnvironment.called = true;
  ENV["USER"] = "web_user";
  ENV["PATH"] = "/";
  ENV["PWD"] = "/";
  ENV["HOME"] = "/home/web_user";
  ENV["LANG"] = "C";
  ENV["_"] = Module["thisProgram"];
  poolPtr = allocate(TOTAL_ENV_SIZE, "i8", ALLOC_STATIC);
  envPtr = allocate(MAX_ENV_VALUES * 4, "i8*", ALLOC_STATIC);
  HEAP32[envPtr >> 2] = poolPtr;
  HEAP32[_environ >> 2] = envPtr;
 } else {
  envPtr = HEAP32[_environ >> 2];
  poolPtr = HEAP32[envPtr >> 2];
 }
 var strings = [];
 var totalSize = 0;
 for (var key in env) {
  if (typeof env[key] === "string") {
   var line = key + "=" + env[key];
   strings.push(line);
   totalSize += line.length;
  }
 }
 if (totalSize > TOTAL_ENV_SIZE) {
  throw new Error("Environment size exceeded TOTAL_ENV_SIZE!");
 }
 var ptrSize = 4;
 for (var i = 0; i < strings.length; i++) {
  var line = strings[i];
  writeAsciiToMemory(line, poolPtr);
  HEAP32[envPtr + i * ptrSize >> 2] = poolPtr;
  poolPtr += line.length + 1;
 }
 HEAP32[envPtr + strings.length * ptrSize >> 2] = 0;
}
var ENV = {};
function _getenv(name) {
 if (name === 0) return 0;
 name = Pointer_stringify(name);
 if (!ENV.hasOwnProperty(name)) return 0;
 if (_getenv.ret) _free(_getenv.ret);
 _getenv.ret = allocate(intArrayFromString(ENV[name]), "i8", ALLOC_NORMAL);
 return _getenv.ret;
}
function __isLeapYear(year) {
 return year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0);
}
function __arraySum(array, index) {
 var sum = 0;
 for (var i = 0; i <= index; sum += array[i++]) ;
 return sum;
}
var __MONTH_DAYS_LEAP = [ 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ];
var __MONTH_DAYS_REGULAR = [ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ];
function __addDays(date, days) {
 var newDate = new Date(date.getTime());
 while (days > 0) {
  var leap = __isLeapYear(newDate.getFullYear());
  var currentMonth = newDate.getMonth();
  var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  if (days > daysInCurrentMonth - newDate.getDate()) {
   days -= daysInCurrentMonth - newDate.getDate() + 1;
   newDate.setDate(1);
   if (currentMonth < 11) {
    newDate.setMonth(currentMonth + 1);
   } else {
    newDate.setMonth(0);
    newDate.setFullYear(newDate.getFullYear() + 1);
   }
  } else {
   newDate.setDate(newDate.getDate() + days);
   return newDate;
  }
 }
 return newDate;
}
function _strftime(s, maxsize, format, tm) {
 var tm_zone = HEAP32[tm + 40 >> 2];
 var date = {
  tm_sec: HEAP32[tm >> 2],
  tm_min: HEAP32[tm + 4 >> 2],
  tm_hour: HEAP32[tm + 8 >> 2],
  tm_mday: HEAP32[tm + 12 >> 2],
  tm_mon: HEAP32[tm + 16 >> 2],
  tm_year: HEAP32[tm + 20 >> 2],
  tm_wday: HEAP32[tm + 24 >> 2],
  tm_yday: HEAP32[tm + 28 >> 2],
  tm_isdst: HEAP32[tm + 32 >> 2],
  tm_gmtoff: HEAP32[tm + 36 >> 2],
  tm_zone: tm_zone ? Pointer_stringify(tm_zone) : ""
 };
 var pattern = Pointer_stringify(format);
 var EXPANSION_RULES_1 = {
  "%c": "%a %b %d %H:%M:%S %Y",
  "%D": "%m/%d/%y",
  "%F": "%Y-%m-%d",
  "%h": "%b",
  "%r": "%I:%M:%S %p",
  "%R": "%H:%M",
  "%T": "%H:%M:%S",
  "%x": "%m/%d/%y",
  "%X": "%H:%M:%S"
 };
 for (var rule in EXPANSION_RULES_1) {
  pattern = pattern.replace(new RegExp(rule, "g"), EXPANSION_RULES_1[rule]);
 }
 var WEEKDAYS = [ "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" ];
 var MONTHS = [ "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" ];
 function leadingSomething(value, digits, character) {
  var str = typeof value === "number" ? value.toString() : value || "";
  while (str.length < digits) {
   str = character[0] + str;
  }
  return str;
 }
 function leadingNulls(value, digits) {
  return leadingSomething(value, digits, "0");
 }
 function compareByDay(date1, date2) {
  function sgn(value) {
   return value < 0 ? -1 : value > 0 ? 1 : 0;
  }
  var compare;
  if ((compare = sgn(date1.getFullYear() - date2.getFullYear())) === 0) {
   if ((compare = sgn(date1.getMonth() - date2.getMonth())) === 0) {
    compare = sgn(date1.getDate() - date2.getDate());
   }
  }
  return compare;
 }
 function getFirstWeekStartDate(janFourth) {
  switch (janFourth.getDay()) {
  case 0:
   return new Date(janFourth.getFullYear() - 1, 11, 29);
  case 1:
   return janFourth;
  case 2:
   return new Date(janFourth.getFullYear(), 0, 3);
  case 3:
   return new Date(janFourth.getFullYear(), 0, 2);
  case 4:
   return new Date(janFourth.getFullYear(), 0, 1);
  case 5:
   return new Date(janFourth.getFullYear() - 1, 11, 31);
  case 6:
   return new Date(janFourth.getFullYear() - 1, 11, 30);
  }
 }
 function getWeekBasedYear(date) {
  var thisDate = __addDays(new Date(date.tm_year + 1900, 0, 1), date.tm_yday);
  var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
  var janFourthNextYear = new Date(thisDate.getFullYear() + 1, 0, 4);
  var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
  var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
   if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
    return thisDate.getFullYear() + 1;
   } else {
    return thisDate.getFullYear();
   }
  } else {
   return thisDate.getFullYear() - 1;
  }
 }
 var EXPANSION_RULES_2 = {
  "%a": (function(date) {
   return WEEKDAYS[date.tm_wday].substring(0, 3);
  }),
  "%A": (function(date) {
   return WEEKDAYS[date.tm_wday];
  }),
  "%b": (function(date) {
   return MONTHS[date.tm_mon].substring(0, 3);
  }),
  "%B": (function(date) {
   return MONTHS[date.tm_mon];
  }),
  "%C": (function(date) {
   var year = date.tm_year + 1900;
   return leadingNulls(year / 100 | 0, 2);
  }),
  "%d": (function(date) {
   return leadingNulls(date.tm_mday, 2);
  }),
  "%e": (function(date) {
   return leadingSomething(date.tm_mday, 2, " ");
  }),
  "%g": (function(date) {
   return getWeekBasedYear(date).toString().substring(2);
  }),
  "%G": (function(date) {
   return getWeekBasedYear(date);
  }),
  "%H": (function(date) {
   return leadingNulls(date.tm_hour, 2);
  }),
  "%I": (function(date) {
   return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour - 12, 2);
  }),
  "%j": (function(date) {
   return leadingNulls(date.tm_mday + __arraySum(__isLeapYear(date.tm_year + 1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon - 1), 3);
  }),
  "%m": (function(date) {
   return leadingNulls(date.tm_mon + 1, 2);
  }),
  "%M": (function(date) {
   return leadingNulls(date.tm_min, 2);
  }),
  "%n": (function() {
   return "\n";
  }),
  "%p": (function(date) {
   if (date.tm_hour > 0 && date.tm_hour < 13) {
    return "AM";
   } else {
    return "PM";
   }
  }),
  "%S": (function(date) {
   return leadingNulls(date.tm_sec, 2);
  }),
  "%t": (function() {
   return "\t";
  }),
  "%u": (function(date) {
   var day = new Date(date.tm_year + 1900, date.tm_mon + 1, date.tm_mday, 0, 0, 0, 0);
   return day.getDay() || 7;
  }),
  "%U": (function(date) {
   var janFirst = new Date(date.tm_year + 1900, 0, 1);
   var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7 - janFirst.getDay());
   var endDate = new Date(date.tm_year + 1900, date.tm_mon, date.tm_mday);
   if (compareByDay(firstSunday, endDate) < 0) {
    var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth() - 1) - 31;
    var firstSundayUntilEndJanuary = 31 - firstSunday.getDate();
    var days = firstSundayUntilEndJanuary + februaryFirstUntilEndMonth + endDate.getDate();
    return leadingNulls(Math.ceil(days / 7), 2);
   }
   return compareByDay(firstSunday, janFirst) === 0 ? "01" : "00";
  }),
  "%V": (function(date) {
   var janFourthThisYear = new Date(date.tm_year + 1900, 0, 4);
   var janFourthNextYear = new Date(date.tm_year + 1901, 0, 4);
   var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
   var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
   var endDate = __addDays(new Date(date.tm_year + 1900, 0, 1), date.tm_yday);
   if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
    return "53";
   }
   if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
    return "01";
   }
   var daysDifference;
   if (firstWeekStartThisYear.getFullYear() < date.tm_year + 1900) {
    daysDifference = date.tm_yday + 32 - firstWeekStartThisYear.getDate();
   } else {
    daysDifference = date.tm_yday + 1 - firstWeekStartThisYear.getDate();
   }
   return leadingNulls(Math.ceil(daysDifference / 7), 2);
  }),
  "%w": (function(date) {
   var day = new Date(date.tm_year + 1900, date.tm_mon + 1, date.tm_mday, 0, 0, 0, 0);
   return day.getDay();
  }),
  "%W": (function(date) {
   var janFirst = new Date(date.tm_year, 0, 1);
   var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7 - janFirst.getDay() + 1);
   var endDate = new Date(date.tm_year + 1900, date.tm_mon, date.tm_mday);
   if (compareByDay(firstMonday, endDate) < 0) {
    var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth() - 1) - 31;
    var firstMondayUntilEndJanuary = 31 - firstMonday.getDate();
    var days = firstMondayUntilEndJanuary + februaryFirstUntilEndMonth + endDate.getDate();
    return leadingNulls(Math.ceil(days / 7), 2);
   }
   return compareByDay(firstMonday, janFirst) === 0 ? "01" : "00";
  }),
  "%y": (function(date) {
   return (date.tm_year + 1900).toString().substring(2);
  }),
  "%Y": (function(date) {
   return date.tm_year + 1900;
  }),
  "%z": (function(date) {
   var off = date.tm_gmtoff;
   var ahead = off >= 0;
   off = Math.abs(off) / 60;
   off = off / 60 * 100 + off % 60;
   return (ahead ? "+" : "-") + String("0000" + off).slice(-4);
  }),
  "%Z": (function(date) {
   return date.tm_zone;
  }),
  "%%": (function() {
   return "%";
  })
 };
 for (var rule in EXPANSION_RULES_2) {
  if (pattern.indexOf(rule) >= 0) {
   pattern = pattern.replace(new RegExp(rule, "g"), EXPANSION_RULES_2[rule](date));
  }
 }
 var bytes = intArrayFromString(pattern, false);
 if (bytes.length > maxsize) {
  return 0;
 }
 writeArrayToMemory(bytes, s);
 return bytes.length - 1;
}
function _strftime_l(s, maxsize, format, tm) {
 return _strftime(s, maxsize, format, tm);
}
function _gettimeofday(ptr) {
 var now = Date.now();
 HEAP32[ptr >> 2] = now / 1e3 | 0;
 HEAP32[ptr + 4 >> 2] = now % 1e3 * 1e3 | 0;
 return 0;
}
function _vfprintf(s, f, va_arg) {
 return _fprintf(s, f, HEAP32[va_arg >> 2]);
}
function _pthread_mutex_unlock() {}
function _emscripten_memcpy_big(dest, src, num) {
 HEAPU8.set(HEAPU8.subarray(src, src + num), dest);
 return dest;
}
Module["_memcpy"] = _memcpy;
function _sbrk(bytes) {
 var self = _sbrk;
 if (!self.called) {
  DYNAMICTOP = alignMemoryPage(DYNAMICTOP);
  self.called = true;
  assert(Runtime.dynamicAlloc);
  self.alloc = Runtime.dynamicAlloc;
  Runtime.dynamicAlloc = (function() {
   abort("cannot dynamically allocate, sbrk now has control");
  });
 }
 var ret = DYNAMICTOP;
 if (bytes != 0) self.alloc(bytes);
 return ret;
}
Module["_memmove"] = _memmove;
var LOCALE = {
 curr: 0,
 check: (function(locale) {
  if (locale) locale = Pointer_stringify(locale);
  return locale === "C" || locale === "POSIX" || !locale;
 })
};
function _calloc(n, s) {
 var ret = _malloc(n * s);
 _memset(ret, 0, n * s);
 return ret;
}
Module["_calloc"] = _calloc;
function _newlocale(mask, locale, base) {
 if (!LOCALE.check(locale)) {
  ___setErrNo(ERRNO_CODES.ENOENT);
  return 0;
 }
 if (!base) base = _calloc(1, 4);
 return base;
}
function _signal(sig, func) {
 Module.printErr("Calling stub instead of signal()");
 return 0;
}
function ___errno_location() {
 return ___errno_state;
}
var _BItoD = true;
function _unlink(path) {
 path = Pointer_stringify(path);
 try {
  FS.unlink(path);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _rmdir(path) {
 path = Pointer_stringify(path);
 try {
  FS.rmdir(path);
  return 0;
 } catch (e) {
  FS.handleFSError(e);
  return -1;
 }
}
function _remove(path) {
 var ret = _unlink(path);
 if (ret == -1) ret = _rmdir(path);
 return ret;
}
function _pthread_cond_wait() {
 return 0;
}
function _free() {}
Module["_free"] = _free;
function ___cxa_free_exception(ptr) {
 try {
  return _free(ptr);
 } catch (e) {}
}
function ___cxa_end_catch() {
 if (___cxa_end_catch.rethrown) {
  ___cxa_end_catch.rethrown = false;
  return;
 }
 asm["setThrew"](0);
 var ptr = EXCEPTIONS.caught.pop();
 if (ptr) {
  EXCEPTIONS.decRef(EXCEPTIONS.deAdjust(ptr));
  EXCEPTIONS.last = 0;
 }
}
function ___cxa_rethrow() {
 ___cxa_end_catch.rethrown = true;
 var ptr = EXCEPTIONS.caught.pop();
 EXCEPTIONS.last = ptr;
 throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
}
var _DtoIHigh = true;
Module["_llvm_bswap_i32"] = _llvm_bswap_i32;
function _time(ptr) {
 var ret = Date.now() / 1e3 | 0;
 if (ptr) {
  HEAP32[ptr >> 2] = ret;
 }
 return ret;
}
function ___cxa_guard_release() {}
function _ungetc(c, stream) {
 stream = FS.getStreamFromPtr(stream);
 if (!stream) {
  return -1;
 }
 if (c === -1) {
  return c;
 }
 c = unSign(c & 255);
 stream.ungotten.push(c);
 stream.eof = false;
 return c;
}
function _uselocale(locale) {
 var old = LOCALE.curr;
 if (locale) LOCALE.curr = locale;
 return old;
}
function _pthread_mutexattr_settype() {}
function _sysconf(name) {
 switch (name) {
 case 30:
  return PAGE_SIZE;
 case 132:
 case 133:
 case 12:
 case 137:
 case 138:
 case 15:
 case 235:
 case 16:
 case 17:
 case 18:
 case 19:
 case 20:
 case 149:
 case 13:
 case 10:
 case 236:
 case 153:
 case 9:
 case 21:
 case 22:
 case 159:
 case 154:
 case 14:
 case 77:
 case 78:
 case 139:
 case 80:
 case 81:
 case 79:
 case 82:
 case 68:
 case 67:
 case 164:
 case 11:
 case 29:
 case 47:
 case 48:
 case 95:
 case 52:
 case 51:
 case 46:
  return 200809;
 case 27:
 case 246:
 case 127:
 case 128:
 case 23:
 case 24:
 case 160:
 case 161:
 case 181:
 case 182:
 case 242:
 case 183:
 case 184:
 case 243:
 case 244:
 case 245:
 case 165:
 case 178:
 case 179:
 case 49:
 case 50:
 case 168:
 case 169:
 case 175:
 case 170:
 case 171:
 case 172:
 case 97:
 case 76:
 case 32:
 case 173:
 case 35:
  return -1;
 case 176:
 case 177:
 case 7:
 case 155:
 case 8:
 case 157:
 case 125:
 case 126:
 case 92:
 case 93:
 case 129:
 case 130:
 case 131:
 case 94:
 case 91:
  return 1;
 case 74:
 case 60:
 case 69:
 case 70:
 case 4:
  return 1024;
 case 31:
 case 42:
 case 72:
  return 32;
 case 87:
 case 26:
 case 33:
  return 2147483647;
 case 34:
 case 1:
  return 47839;
 case 38:
 case 36:
  return 99;
 case 43:
 case 37:
  return 2048;
 case 0:
  return 2097152;
 case 3:
  return 65536;
 case 28:
  return 32768;
 case 44:
  return 32767;
 case 75:
  return 16384;
 case 39:
  return 1e3;
 case 89:
  return 700;
 case 71:
  return 256;
 case 40:
  return 255;
 case 2:
  return 100;
 case 180:
  return 64;
 case 25:
  return 20;
 case 5:
  return 16;
 case 6:
  return 6;
 case 73:
  return 4;
 case 84:
  {
   if (typeof navigator === "object") return navigator["hardwareConcurrency"] || 1;
   return 1;
  }
 }
 ___setErrNo(ERRNO_CODES.EINVAL);
 return -1;
}
var _SItoD = true;
Module["_memset"] = _memset;
var _BDtoILow = true;
function _strerror_r(errnum, strerrbuf, buflen) {
 if (errnum in ERRNO_MESSAGES) {
  if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
   return ___setErrNo(ERRNO_CODES.ERANGE);
  } else {
   var msg = ERRNO_MESSAGES[errnum];
   writeAsciiToMemory(msg, strerrbuf);
   return 0;
  }
 } else {
  return ___setErrNo(ERRNO_CODES.EINVAL);
 }
}
function _strerror(errnum) {
 if (!_strerror.buffer) _strerror.buffer = _malloc(256);
 _strerror_r(errnum, _strerror.buffer, 256);
 return _strerror.buffer;
}
var _logf = Math_log;
Module["_bitshift64Shl"] = _bitshift64Shl;
function _abort() {
 Module["abort"]();
}
function _pthread_mutex_destroy() {}
function _fgets(s, n, stream) {
 var streamObj = FS.getStreamFromPtr(stream);
 if (!streamObj) return 0;
 if (streamObj.error || streamObj.eof) return 0;
 var byte_;
 for (var i = 0; i < n - 1 && byte_ != 10; i++) {
  byte_ = _fgetc(stream);
  if (byte_ == -1) {
   if (streamObj.error || streamObj.eof && i == 0) return 0; else if (streamObj.eof) break;
  }
  HEAP8[s + i >> 0] = byte_;
 }
 HEAP8[s + i >> 0] = 0;
 return s;
}
function _pthread_mutexattr_init() {}
function _pthread_getspecific(key) {
 return PTHREAD_SPECIFIC[key] || 0;
}
var _fabs = Math_abs;
function _feof(stream) {
 stream = FS.getStreamFromPtr(stream);
 return Number(stream && stream.eof);
}
function _fseek(stream, offset, whence) {
 var fd = _fileno(stream);
 var ret = _lseek(fd, offset, whence);
 if (ret == -1) {
  return -1;
 }
 stream = FS.getStreamFromPtr(stream);
 stream.eof = false;
 return 0;
}
var _sqrt = Math_sqrt;
function _catclose(catd) {
 return 0;
}
function __exit(status) {
 Module["exit"](status);
}
function _exit(status) {
 __exit(status);
}
function _pthread_setspecific(key, value) {
 if (!(key in PTHREAD_SPECIFIC)) {
  return ERRNO_CODES.EINVAL;
 }
 PTHREAD_SPECIFIC[key] = value;
 return 0;
}
function _rewind(stream) {
 _fseek(stream, 0, 0);
 var streamObj = FS.getStreamFromPtr(stream);
 if (streamObj) streamObj.error = false;
}
function ___ctype_b_loc() {
 var me = ___ctype_b_loc;
 if (!me.ret) {
  var values = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 8195, 8194, 8194, 8194, 8194, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 24577, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 55304, 55304, 55304, 55304, 55304, 55304, 55304, 55304, 55304, 55304, 49156, 49156, 49156, 49156, 49156, 49156, 49156, 54536, 54536, 54536, 54536, 54536, 54536, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 50440, 49156, 49156, 49156, 49156, 49156, 49156, 54792, 54792, 54792, 54792, 54792, 54792, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 50696, 49156, 49156, 49156, 49156, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ];
  var i16size = 2;
  var arr = _malloc(values.length * i16size);
  for (var i = 0; i < values.length; i++) {
   HEAP16[arr + i * i16size >> 1] = values[i];
  }
  me.ret = allocate([ arr + 128 * i16size ], "i16*", ALLOC_NORMAL);
 }
 return me.ret;
}
function _freelocale(locale) {
 _free(locale);
}
function _malloc(bytes) {
 var ptr = Runtime.dynamicAlloc(bytes + 8);
 return ptr + 8 & 4294967288;
}
Module["_malloc"] = _malloc;
function ___cxa_allocate_exception(size) {
 return _malloc(size);
}
var _sin = Math_sin;
function _stat(path, buf, dontResolveLastLink) {
 path = typeof path !== "string" ? Pointer_stringify(path) : path;
 try {
  var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
  HEAP32[buf >> 2] = stat.dev;
  HEAP32[buf + 4 >> 2] = 0;
  HEAP32[buf + 8 >> 2] = stat.ino;
  HEAP32[buf + 12 >> 2] = stat.mode;
  HEAP32[buf + 16 >> 2] = stat.nlink;
  HEAP32[buf + 20 >> 2] = stat.uid;
  HEAP32[buf + 24 >> 2] = stat.gid;
  HEAP32[buf + 28 >> 2] = stat.rdev;
  HEAP32[buf + 32 >> 2] = 0;
  HEAP32[buf + 36 >> 2] = stat.size;
  HEAP32[buf + 40 >> 2] = 4096;
  HEAP32[buf + 44 >> 2] = stat.blocks;
  HEAP32[buf + 48 >> 2] = stat.atime.getTime() / 1e3 | 0;
  HEAP32[buf + 52 >> 2] = 0;
  HEAP32[buf + 56 >> 2] = stat.mtime.getTime() / 1e3 | 0;
  HEAP32[buf + 60 >> 2] = 0;
  HEAP32[buf + 64 >> 2] = stat.ctime.getTime() / 1e3 | 0;
  HEAP32[buf + 68 >> 2] = 0;
  HEAP32[buf + 72 >> 2] = stat.ino;
  return 0;
 } catch (e) {
  if (e.node && PATH.normalize(path) !== PATH.normalize(FS.getPath(e.node))) {
   e.setErrno(ERRNO_CODES.ENOTDIR);
  }
  FS.handleFSError(e);
  return -1;
 }
}
function ___cxa_pure_virtual() {
 ABORT = true;
 throw "Pure virtual function called!";
}
function _catgets(catd, set_id, msg_id, s) {
 return s;
}
function _catopen(name, oflag) {
 return -1;
}
function _getcwd(buf, size) {
 if (size == 0) {
  ___setErrNo(ERRNO_CODES.EINVAL);
  return 0;
 }
 var cwd = FS.cwd();
 if (size < cwd.length + 1) {
  ___setErrNo(ERRNO_CODES.ERANGE);
  return 0;
 } else {
  writeAsciiToMemory(cwd, buf);
  return buf;
 }
}
function ___ctype_toupper_loc() {
 var me = ___ctype_toupper_loc;
 if (!me.ret) {
  var values = [ 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255 ];
  var i32size = 4;
  var arr = _malloc(values.length * i32size);
  for (var i = 0; i < values.length; i++) {
   HEAP32[arr + i * i32size >> 2] = values[i];
  }
  me.ret = allocate([ arr + 128 * i32size ], "i32*", ALLOC_NORMAL);
 }
 return me.ret;
}
function _pthread_cond_broadcast() {
 return 0;
}
function ___cxa_guard_acquire(variable) {
 if (!HEAP8[variable >> 0]) {
  HEAP8[variable >> 0] = 1;
  return 1;
 }
 return 0;
}
function ___ctype_tolower_loc() {
 var me = ___ctype_tolower_loc;
 if (!me.ret) {
  var values = [ 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255 ];
  var i32size = 4;
  var arr = _malloc(values.length * i32size);
  for (var i = 0; i < values.length; i++) {
   HEAP32[arr + i * i32size >> 2] = values[i];
  }
  me.ret = allocate([ arr + 128 * i32size ], "i32*", ALLOC_NORMAL);
 }
 return me.ret;
}
function ___cxa_begin_catch(ptr) {
 __ZSt18uncaught_exceptionv.uncaught_exception--;
 EXCEPTIONS.caught.push(ptr);
 EXCEPTIONS.addRef(EXCEPTIONS.deAdjust(ptr));
 return ptr;
}
var _log = Math_log;
var _cos = Math_cos;
function _fseeko() {
 return _fseek.apply(null, arguments);
}
function _pthread_once(ptr, func) {
 if (!_pthread_once.seen) _pthread_once.seen = {};
 if (ptr in _pthread_once.seen) return;
 Runtime.dynCall("v", func);
 _pthread_once.seen[ptr] = 1;
}
Module["_strcpy"] = _strcpy;
var _exp = Math_exp;
var _FtoILow = true;
var ___dso_handle = allocate(1, "i32*", ALLOC_STATIC);
FS.staticInit();
__ATINIT__.unshift({
 func: (function() {
  if (!Module["noFSInit"] && !FS.init.initialized) FS.init();
 })
});
__ATMAIN__.push({
 func: (function() {
  FS.ignorePermissions = false;
 })
});
__ATEXIT__.push({
 func: (function() {
  FS.quit();
 })
});
Module["FS_createFolder"] = FS.createFolder;
Module["FS_createPath"] = FS.createPath;
Module["FS_createDataFile"] = FS.createDataFile;
Module["FS_createPreloadedFile"] = FS.createPreloadedFile;
Module["FS_createLazyFile"] = FS.createLazyFile;
Module["FS_createLink"] = FS.createLink;
Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4);
HEAP32[___errno_state >> 2] = 0;
__ATINIT__.unshift({
 func: (function() {
  TTY.init();
 })
});
__ATEXIT__.push({
 func: (function() {
  TTY.shutdown();
 })
});
TTY.utf8 = new Runtime.UTF8Processor;
if (ENVIRONMENT_IS_NODE) {
 var fs = require("fs");
 NODEFS.staticInit();
}
_fgetc.ret = allocate([ 0 ], "i8", ALLOC_STATIC);
__ATINIT__.push({
 func: (function() {
  SOCKFS.root = FS.mount(SOCKFS, {}, null);
 })
});
_fputc.ret = allocate([ 0 ], "i8", ALLOC_STATIC);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) {
 Browser.requestFullScreen(lockPointer, resizeCanvas);
};
Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) {
 Browser.requestAnimationFrame(func);
};
Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) {
 Browser.setCanvasSize(width, height, noUpdates);
};
Module["pauseMainLoop"] = function Module_pauseMainLoop() {
 Browser.mainLoop.pause();
};
Module["resumeMainLoop"] = function Module_resumeMainLoop() {
 Browser.mainLoop.resume();
};
Module["getUserMedia"] = function Module_getUserMedia() {
 Browser.getUserMedia();
};
___buildEnvironment(ENV);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);
staticSealed = true;
STACK_MAX = STACK_BASE + TOTAL_STACK;
DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);
assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");
var ctlz_i8 = allocate([ 8, 7, 6, 6, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ], "i8", ALLOC_DYNAMIC);
var cttz_i8 = allocate([ 8, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 7, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 1, 0 ], "i8", ALLOC_DYNAMIC);
function invoke_viiiii(index, a1, a2, a3, a4, a5) {
 try {
  Module["dynCall_viiiii"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vif(index, a1, a2) {
 try {
  Module["dynCall_vif"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vid(index, a1, a2) {
 try {
  Module["dynCall_vid"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vi(index, a1) {
 try {
  Module["dynCall_vi"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vii(index, a1, a2) {
 try {
  Module["dynCall_vii"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiii(index, a1, a2, a3, a4, a5, a6) {
 try {
  return Module["dynCall_iiiiiii"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_ii(index, a1) {
 try {
  return Module["dynCall_ii"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiiddi(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10) {
 try {
  Module["dynCall_viiiiiiiddi"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9) {
 try {
  Module["dynCall_viiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viidi(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_viidi"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_vidii(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_vidii"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiii(index, a1, a2, a3, a4, a5) {
 try {
  return Module["dynCall_iiiiii"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iii(index, a1, a2) {
 try {
  return Module["dynCall_iii"](index, a1, a2);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiii(index, a1, a2, a3) {
 try {
  return Module["dynCall_iiii"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiid(index, a1, a2, a3, a4, a5, a6) {
 try {
  Module["dynCall_viiiiid"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8) {
 try {
  Module["dynCall_viiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiii(index, a1, a2, a3, a4, a5, a6) {
 try {
  Module["dynCall_viiiiii"](index, a1, a2, a3, a4, a5, a6);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_di(index, a1) {
 try {
  return Module["dynCall_di"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiid(index, a1, a2, a3, a4, a5) {
 try {
  Module["dynCall_viiiid"](index, a1, a2, a3, a4, a5);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8) {
 try {
  return Module["dynCall_iiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiii(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  Module["dynCall_viiiiiii"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiid(index, a1, a2, a3, a4, a5, a6, a7) {
 try {
  Module["dynCall_viiiiiid"](index, a1, a2, a3, a4, a5, a6, a7);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_fi(index, a1) {
 try {
  return Module["dynCall_fi"](index, a1);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10) {
 try {
  Module["dynCall_viiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiiiiiiiiiiiii(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14) {
 try {
  return Module["dynCall_iiiiiiiiiiiiiii"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_diii(index, a1, a2, a3) {
 try {
  return Module["dynCall_diii"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_i(index) {
 try {
  return Module["dynCall_i"](index);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiiiiiiiiiddi(index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13) {
 try {
  Module["dynCall_viiiiiiiiiiddi"](index, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_iiiii(index, a1, a2, a3, a4) {
 try {
  return Module["dynCall_iiiii"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiid(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_viiid"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viii(index, a1, a2, a3) {
 try {
  Module["dynCall_viii"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_v(index) {
 try {
  Module["dynCall_v"](index);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viid(index, a1, a2, a3) {
 try {
  Module["dynCall_viid"](index, a1, a2, a3);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
function invoke_viiii(index, a1, a2, a3, a4) {
 try {
  Module["dynCall_viiii"](index, a1, a2, a3, a4);
 } catch (e) {
  if (typeof e !== "number" && e !== "longjmp") throw e;
  asm["setThrew"](1, 0);
 }
}
Module.asmGlobalArg = {
 "Math": Math,
 "Int8Array": Int8Array,
 "Int16Array": Int16Array,
 "Int32Array": Int32Array,
 "Uint8Array": Uint8Array,
 "Uint16Array": Uint16Array,
 "Uint32Array": Uint32Array,
 "Float32Array": Float32Array,
 "Float64Array": Float64Array
};
Module.asmLibraryArg = {
 "abort": abort,
 "assert": assert,
 "min": Math_min,
 "invoke_viiiii": invoke_viiiii,
 "invoke_vif": invoke_vif,
 "invoke_vid": invoke_vid,
 "invoke_vi": invoke_vi,
 "invoke_vii": invoke_vii,
 "invoke_iiiiiii": invoke_iiiiiii,
 "invoke_ii": invoke_ii,
 "invoke_viiiiiiiddi": invoke_viiiiiiiddi,
 "invoke_viiiiiiiii": invoke_viiiiiiiii,
 "invoke_viidi": invoke_viidi,
 "invoke_vidii": invoke_vidii,
 "invoke_iiiiii": invoke_iiiiii,
 "invoke_iii": invoke_iii,
 "invoke_iiii": invoke_iiii,
 "invoke_viiiiid": invoke_viiiiid,
 "invoke_viiiiiiii": invoke_viiiiiiii,
 "invoke_viiiiii": invoke_viiiiii,
 "invoke_di": invoke_di,
 "invoke_viiiid": invoke_viiiid,
 "invoke_iiiiiiiii": invoke_iiiiiiiii,
 "invoke_viiiiiii": invoke_viiiiiii,
 "invoke_viiiiiid": invoke_viiiiiid,
 "invoke_fi": invoke_fi,
 "invoke_viiiiiiiiii": invoke_viiiiiiiiii,
 "invoke_iiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiii,
 "invoke_diii": invoke_diii,
 "invoke_i": invoke_i,
 "invoke_viiiiiiiiiiddi": invoke_viiiiiiiiiiddi,
 "invoke_iiiii": invoke_iiiii,
 "invoke_viiid": invoke_viiid,
 "invoke_viii": invoke_viii,
 "invoke_v": invoke_v,
 "invoke_viid": invoke_viid,
 "invoke_viiii": invoke_viiii,
 "_fabs": _fabs,
 "_exp": _exp,
 "_sqrtf": _sqrtf,
 "_fread": _fread,
 "___cxa_guard_acquire": ___cxa_guard_acquire,
 "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv,
 "_longjmp": _longjmp,
 "___ctype_toupper_loc": ___ctype_toupper_loc,
 "__addDays": __addDays,
 "_ftell": _ftell,
 "_signal": _signal,
 "_emscripten_set_main_loop_timing": _emscripten_set_main_loop_timing,
 "_sbrk": _sbrk,
 "___cxa_begin_catch": ___cxa_begin_catch,
 "_emscripten_memcpy_big": _emscripten_memcpy_big,
 "_sysconf": _sysconf,
 "_close": _close,
 "_rewind": _rewind,
 "_cos": _cos,
 "_pthread_mutexattr_settype": _pthread_mutexattr_settype,
 "_puts": _puts,
 "_isatty": _isatty,
 "_unlink": _unlink,
 "_write": _write,
 "__isLeapYear": __isLeapYear,
 "_fsync": _fsync,
 "___cxa_atexit": ___cxa_atexit,
 "___cxa_rethrow": ___cxa_rethrow,
 "_catclose": _catclose,
 "_mknod": _mknod,
 "_mkdir": _mkdir,
 "_send": _send,
 "___cxa_free_exception": ___cxa_free_exception,
 "___cxa_find_matching_catch": ___cxa_find_matching_catch,
 "___cxa_guard_release": ___cxa_guard_release,
 "_strerror_r": _strerror_r,
 "___setErrNo": ___setErrNo,
 "_newlocale": _newlocale,
 "___resumeException": ___resumeException,
 "_freelocale": _freelocale,
 "_putchar": _putchar,
 "_pthread_once": _pthread_once,
 "_printf": _printf,
 "_fopen": _fopen,
 "_logf": _logf,
 "_stat": _stat,
 "_read": _read,
 "_fwrite": _fwrite,
 "_time": _time,
 "_fprintf": _fprintf,
 "_gettimeofday": _gettimeofday,
 "_catopen": _catopen,
 "_exit": _exit,
 "_getcwd": _getcwd,
 "___ctype_b_loc": ___ctype_b_loc,
 "_lseek": _lseek,
 "_vfprintf": _vfprintf,
 "_rmdir": _rmdir,
 "___cxa_allocate_exception": ___cxa_allocate_exception,
 "___buildEnvironment": ___buildEnvironment,
 "_pwrite": _pwrite,
 "_localtime_r": _localtime_r,
 "_tzset": _tzset,
 "_open": _open,
 "_fabsf": _fabsf,
 "_remove": _remove,
 "_uselocale": _uselocale,
 "___cxa_end_catch": ___cxa_end_catch,
 "_strftime": _strftime,
 "_fseek": _fseek,
 "_pthread_mutex_destroy": _pthread_mutex_destroy,
 "_getenv": _getenv,
 "_fclose": _fclose,
 "_log": _log,
 "_pthread_cond_broadcast": _pthread_cond_broadcast,
 "_recv": _recv,
 "_ftello": _ftello,
 "_abort": _abort,
 "_localtime": _localtime,
 "___cxa_pure_virtual": ___cxa_pure_virtual,
 "_pthread_getspecific": _pthread_getspecific,
 "_pthread_cond_wait": _pthread_cond_wait,
 "_sin": _sin,
 "_pthread_key_create": _pthread_key_create,
 "_ungetc": _ungetc,
 "_usleep": _usleep,
 "_fflush": _fflush,
 "_pthread_mutexattr_destroy": _pthread_mutexattr_destroy,
 "_strftime_l": _strftime_l,
 "_pthread_mutex_lock": _pthread_mutex_lock,
 "__reallyNegative": __reallyNegative,
 "_catgets": _catgets,
 "_calloc": _calloc,
 "_fileno": _fileno,
 "__formatString": __formatString,
 "__exit": __exit,
 "_vprintf": _vprintf,
 "__arraySum": __arraySum,
 "_fseeko": _fseeko,
 "___ctype_tolower_loc": ___ctype_tolower_loc,
 "_fputs": _fputs,
 "_pthread_mutex_unlock": _pthread_mutex_unlock,
 "_pread": _pread,
 "_mkport": _mkport,
 "_getc": _getc,
 "_feof": _feof,
 "_emscripten_set_main_loop": _emscripten_set_main_loop,
 "___errno_location": ___errno_location,
 "_pthread_mutexattr_init": _pthread_mutexattr_init,
 "_pthread_setspecific": _pthread_setspecific,
 "_fgetc": _fgetc,
 "_fputc": _fputc,
 "___cxa_throw": ___cxa_throw,
 "_strerror": _strerror,
 "_emscripten_longjmp": _emscripten_longjmp,
 "_fgets": _fgets,
 "_atexit": _atexit,
 "_sqrt": _sqrt,
 "_pthread_mutex_init": _pthread_mutex_init,
 "STACKTOP": STACKTOP,
 "STACK_MAX": STACK_MAX,
 "tempDoublePtr": tempDoublePtr,
 "ABORT": ABORT,
 "cttz_i8": cttz_i8,
 "ctlz_i8": ctlz_i8,
 "NaN": NaN,
 "Infinity": Infinity,
 "___dso_handle": ___dso_handle,
 "_stderr": _stderr,
 "_stdin": _stdin,
 "_stdout": _stdout
};
// EMSCRIPTEN_START_ASM

var asm = (function(global,env,buffer) {

  'use asm';
  
  var HEAP8 = new global.Int8Array(buffer);
  var HEAP16 = new global.Int16Array(buffer);
  var HEAP32 = new global.Int32Array(buffer);
  var HEAPU8 = new global.Uint8Array(buffer);
  var HEAPU16 = new global.Uint16Array(buffer);
  var HEAPU32 = new global.Uint32Array(buffer);
  var HEAPF32 = new global.Float32Array(buffer);
  var HEAPF64 = new global.Float64Array(buffer);


  var STACKTOP=env.STACKTOP|0;
  var STACK_MAX=env.STACK_MAX|0;
  var tempDoublePtr=env.tempDoublePtr|0;
  var ABORT=env.ABORT|0;
  var cttz_i8=env.cttz_i8|0;
  var ctlz_i8=env.ctlz_i8|0;
  var ___dso_handle=env.___dso_handle|0;
  var _stderr=env._stderr|0;
  var _stdin=env._stdin|0;
  var _stdout=env._stdout|0;

  var __THREW__ = 0;
  var threwValue = 0;
  var setjmpId = 0;
  var undef = 0;
  var nan = +env.NaN, inf = +env.Infinity;
  var tempInt = 0, tempBigInt = 0, tempBigIntP = 0, tempBigIntS = 0, tempBigIntR = 0.0, tempBigIntI = 0, tempBigIntD = 0, tempValue = 0, tempDouble = 0.0;

  var tempRet0 = 0;
  var tempRet1 = 0;
  var tempRet2 = 0;
  var tempRet3 = 0;
  var tempRet4 = 0;
  var tempRet5 = 0;
  var tempRet6 = 0;
  var tempRet7 = 0;
  var tempRet8 = 0;
  var tempRet9 = 0;
  var Math_floor=global.Math.floor;
  var Math_abs=global.Math.abs;
  var Math_sqrt=global.Math.sqrt;
  var Math_pow=global.Math.pow;
  var Math_cos=global.Math.cos;
  var Math_sin=global.Math.sin;
  var Math_tan=global.Math.tan;
  var Math_acos=global.Math.acos;
  var Math_asin=global.Math.asin;
  var Math_atan=global.Math.atan;
  var Math_atan2=global.Math.atan2;
  var Math_exp=global.Math.exp;
  var Math_log=global.Math.log;
  var Math_ceil=global.Math.ceil;
  var Math_imul=global.Math.imul;
  var Math_fround=global.Math.fround;
  var abort=env.abort;
  var assert=env.assert;
  var Math_min=env.min;
  var invoke_viiiii=env.invoke_viiiii;
  var invoke_vif=env.invoke_vif;
  var invoke_vid=env.invoke_vid;
  var invoke_vi=env.invoke_vi;
  var invoke_vii=env.invoke_vii;
  var invoke_iiiiiii=env.invoke_iiiiiii;
  var invoke_ii=env.invoke_ii;
  var invoke_viiiiiiiddi=env.invoke_viiiiiiiddi;
  var invoke_viiiiiiiii=env.invoke_viiiiiiiii;
  var invoke_viidi=env.invoke_viidi;
  var invoke_vidii=env.invoke_vidii;
  var invoke_iiiiii=env.invoke_iiiiii;
  var invoke_iii=env.invoke_iii;
  var invoke_iiii=env.invoke_iiii;
  var invoke_viiiiid=env.invoke_viiiiid;
  var invoke_viiiiiiii=env.invoke_viiiiiiii;
  var invoke_viiiiii=env.invoke_viiiiii;
  var invoke_di=env.invoke_di;
  var invoke_viiiid=env.invoke_viiiid;
  var invoke_iiiiiiiii=env.invoke_iiiiiiiii;
  var invoke_viiiiiii=env.invoke_viiiiiii;
  var invoke_viiiiiid=env.invoke_viiiiiid;
  var invoke_fi=env.invoke_fi;
  var invoke_viiiiiiiiii=env.invoke_viiiiiiiiii;
  var invoke_iiiiiiiiiiiiiii=env.invoke_iiiiiiiiiiiiiii;
  var invoke_diii=env.invoke_diii;
  var invoke_i=env.invoke_i;
  var invoke_viiiiiiiiiiddi=env.invoke_viiiiiiiiiiddi;
  var invoke_iiiii=env.invoke_iiiii;
  var invoke_viiid=env.invoke_viiid;
  var invoke_viii=env.invoke_viii;
  var invoke_v=env.invoke_v;
  var invoke_viid=env.invoke_viid;
  var invoke_viiii=env.invoke_viiii;
  var _fabs=env._fabs;
  var _exp=env._exp;
  var _sqrtf=env._sqrtf;
  var _fread=env._fread;
  var ___cxa_guard_acquire=env.___cxa_guard_acquire;
  var __ZSt18uncaught_exceptionv=env.__ZSt18uncaught_exceptionv;
  var _longjmp=env._longjmp;
  var ___ctype_toupper_loc=env.___ctype_toupper_loc;
  var __addDays=env.__addDays;
  var _ftell=env._ftell;
  var _signal=env._signal;
  var _emscripten_set_main_loop_timing=env._emscripten_set_main_loop_timing;
  var _sbrk=env._sbrk;
  var ___cxa_begin_catch=env.___cxa_begin_catch;
  var _emscripten_memcpy_big=env._emscripten_memcpy_big;
  var _sysconf=env._sysconf;
  var _close=env._close;
  var _rewind=env._rewind;
  var _cos=env._cos;
  var _pthread_mutexattr_settype=env._pthread_mutexattr_settype;
  var _puts=env._puts;
  var _isatty=env._isatty;
  var _unlink=env._unlink;
  var _write=env._write;
  var __isLeapYear=env.__isLeapYear;
  var _fsync=env._fsync;
  var ___cxa_atexit=env.___cxa_atexit;
  var ___cxa_rethrow=env.___cxa_rethrow;
  var _catclose=env._catclose;
  var _mknod=env._mknod;
  var _mkdir=env._mkdir;
  var _send=env._send;
  var ___cxa_free_exception=env.___cxa_free_exception;
  var ___cxa_find_matching_catch=env.___cxa_find_matching_catch;
  var ___cxa_guard_release=env.___cxa_guard_release;
  var _strerror_r=env._strerror_r;
  var ___setErrNo=env.___setErrNo;
  var _newlocale=env._newlocale;
  var ___resumeException=env.___resumeException;
  var _freelocale=env._freelocale;
  var _putchar=env._putchar;
  var _pthread_once=env._pthread_once;
  var _printf=env._printf;
  var _fopen=env._fopen;
  var _logf=env._logf;
  var _stat=env._stat;
  var _read=env._read;
  var _fwrite=env._fwrite;
  var _time=env._time;
  var _fprintf=env._fprintf;
  var _gettimeofday=env._gettimeofday;
  var _catopen=env._catopen;
  var _exit=env._exit;
  var _getcwd=env._getcwd;
  var ___ctype_b_loc=env.___ctype_b_loc;
  var _lseek=env._lseek;
  var _vfprintf=env._vfprintf;
  var _rmdir=env._rmdir;
  var ___cxa_allocate_exception=env.___cxa_allocate_exception;
  var ___buildEnvironment=env.___buildEnvironment;
  var _pwrite=env._pwrite;
  var _localtime_r=env._localtime_r;
  var _tzset=env._tzset;
  var _open=env._open;
  var _fabsf=env._fabsf;
  var _remove=env._remove;
  var _uselocale=env._uselocale;
  var ___cxa_end_catch=env.___cxa_end_catch;
  var _strftime=env._strftime;
  var _fseek=env._fseek;
  var _pthread_mutex_destroy=env._pthread_mutex_destroy;
  var _getenv=env._getenv;
  var _fclose=env._fclose;
  var _log=env._log;
  var _pthread_cond_broadcast=env._pthread_cond_broadcast;
  var _recv=env._recv;
  var _ftello=env._ftello;
  var _abort=env._abort;
  var _localtime=env._localtime;
  var ___cxa_pure_virtual=env.___cxa_pure_virtual;
  var _pthread_getspecific=env._pthread_getspecific;
  var _pthread_cond_wait=env._pthread_cond_wait;
  var _sin=env._sin;
  var _pthread_key_create=env._pthread_key_create;
  var _ungetc=env._ungetc;
  var _usleep=env._usleep;
  var _fflush=env._fflush;
  var _pthread_mutexattr_destroy=env._pthread_mutexattr_destroy;
  var _strftime_l=env._strftime_l;
  var _pthread_mutex_lock=env._pthread_mutex_lock;
  var __reallyNegative=env.__reallyNegative;
  var _catgets=env._catgets;
  var _calloc=env._calloc;
  var _fileno=env._fileno;
  var __formatString=env.__formatString;
  var __exit=env.__exit;
  var _vprintf=env._vprintf;
  var __arraySum=env.__arraySum;
  var _fseeko=env._fseeko;
  var ___ctype_tolower_loc=env.___ctype_tolower_loc;
  var _fputs=env._fputs;
  var _pthread_mutex_unlock=env._pthread_mutex_unlock;
  var _pread=env._pread;
  var _mkport=env._mkport;
  var _getc=env._getc;
  var _feof=env._feof;
  var _emscripten_set_main_loop=env._emscripten_set_main_loop;
  var ___errno_location=env.___errno_location;
  var _pthread_mutexattr_init=env._pthread_mutexattr_init;
  var _pthread_setspecific=env._pthread_setspecific;
  var _fgetc=env._fgetc;
  var _fputc=env._fputc;
  var ___cxa_throw=env.___cxa_throw;
  var _strerror=env._strerror;
  var _emscripten_longjmp=env._emscripten_longjmp;
  var _fgets=env._fgets;
  var _atexit=env._atexit;
  var _sqrt=env._sqrt;
  var _pthread_mutex_init=env._pthread_mutex_init;
  var tempFloat = Math_fround(0);
  const f0 = Math_fround(0);

// EMSCRIPTEN_START_FUNCS

function __ZN4perf10Regression6verifyEN2cv8FileNodeERKNS1_11_InputArrayEdNS_10ERROR_TYPEE(i4, i121, i60, d120, i117) {
 i4 = i4 | 0;
 i121 = i121 | 0;
 i60 = i60 | 0;
 d120 = +d120;
 i117 = i117 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i118 = 0, i119 = 0, i122 = 0, i123 = 0, i124 = 0;
 i123 = STACKTOP;
 STACKTOP = STACKTOP + 1360 | 0;
 i118 = i123 + 48 | 0;
 i116 = i123 + 1296 | 0;
 i14 = i123 + 1288 | 0;
 i124 = i123 + 1280 | 0;
 i1 = i123 + 1272 | 0;
 i11 = i123 + 1264 | 0;
 i2 = i123 + 1256 | 0;
 i15 = i123 + 1248 | 0;
 i4 = i123 + 1244 | 0;
 i5 = i123 + 1240 | 0;
 i6 = i123 + 1232 | 0;
 i19 = i123 + 1224 | 0;
 i12 = i123 + 1216 | 0;
 i22 = i123 + 1212 | 0;
 i23 = i123 + 1208 | 0;
 i20 = i123 + 1200 | 0;
 i63 = i123 + 1192 | 0;
 i18 = i123 + 1184 | 0;
 i9 = i123 + 1176 | 0;
 i28 = i123 + 1168 | 0;
 i10 = i123 + 1160 | 0;
 i29 = i123 + 1156 | 0;
 i30 = i123 + 1152 | 0;
 i31 = i123 + 1144 | 0;
 i26 = i123 + 1136 | 0;
 i122 = i123 + 1080 | 0;
 i48 = i123 + 1072 | 0;
 i46 = i123 + 1068 | 0;
 i47 = i123 + 1064 | 0;
 i50 = i123 + 1060 | 0;
 i51 = i123 + 1056 | 0;
 i49 = i123 + 1048 | 0;
 i56 = i123 + 1040 | 0;
 i62 = i123 + 984 | 0;
 i57 = i123 + 968 | 0;
 i58 = i123 + 960 | 0;
 i59 = i123 + 952 | 0;
 i114 = i123 + 896 | 0;
 i82 = i123 + 888 | 0;
 i84 = i123 + 880 | 0;
 i85 = i123 + 868 | 0;
 i86 = i123 + 864 | 0;
 i83 = i123 + 856 | 0;
 i69 = i123 + 848 | 0;
 i65 = i123 + 840 | 0;
 i66 = i123 + 832 | 0;
 i72 = i123 + 828 | 0;
 i73 = i123 + 824 | 0;
 i70 = i123 + 816 | 0;
 i87 = i123 + 792 | 0;
 i88 = i123 + 772 | 0;
 i89 = i123 + 752 | 0;
 i90 = i123 + 732 | 0;
 i110 = i123 + 40 | 0;
 i97 = i123 + 712 | 0;
 i108 = i123 + 656 | 0;
 i111 = i123 + 652 | 0;
 i112 = i123 + 648 | 0;
 i109 = i123 + 640 | 0;
 i100 = i123 + 32 | 0;
 i99 = i123 + 24 | 0;
 i101 = i123 + 636 | 0;
 i102 = i123 + 632 | 0;
 i98 = i123 + 624 | 0;
 i27 = i123 + 616 | 0;
 i16 = i123 + 612 | 0;
 i17 = i123 + 608 | 0;
 i33 = i123 + 604 | 0;
 i34 = i123 + 600 | 0;
 i35 = i123 + 592 | 0;
 i41 = i123 + 584 | 0;
 i52 = i123 + 528 | 0;
 i42 = i123 + 512 | 0;
 i43 = i123 + 504 | 0;
 i44 = i123 + 496 | 0;
 i45 = i123 + 488 | 0;
 i115 = i123 + 432 | 0;
 i71 = i123 + 424 | 0;
 i75 = i123 + 416 | 0;
 i76 = i123 + 404 | 0;
 i77 = i123 + 400 | 0;
 i74 = i123 + 392 | 0;
 i61 = i123 + 384 | 0;
 i54 = i123 + 376 | 0;
 i55 = i123 + 368 | 0;
 i67 = i123 + 364 | 0;
 i68 = i123 + 360 | 0;
 i64 = i123 + 352 | 0;
 i113 = i123 + 296 | 0;
 i78 = i123 + 272 | 0;
 i79 = i123 + 252 | 0;
 i80 = i123 + 232 | 0;
 i81 = i123 + 212 | 0;
 i105 = i123 + 16 | 0;
 i91 = i123 + 192 | 0;
 i103 = i123 + 136 | 0;
 i106 = i123 + 132 | 0;
 i107 = i123 + 128 | 0;
 i104 = i123 + 120 | 0;
 i94 = i123 + 8 | 0;
 i93 = i123;
 i95 = i123 + 116 | 0;
 i96 = i123 + 112 | 0;
 i92 = i123 + 104 | 0;
 __ZNK2cv8FileNodeixEPKc(i124, i121, 170688);
 __ZN2cv4readERKNS_8FileNodeERii(i124, i118, 0);
 i124 = HEAP32[i118 >> 2] | 0;
 HEAP32[i14 >> 2] = i124;
 __ZNK2cv8FileNodeixEPKc(i11, i121, 170696);
 __ZN2cv4readERKNS_8FileNodeERii(i11, i118, 0);
 i11 = HEAP32[i118 >> 2] | 0;
 HEAP32[i1 >> 2] = i11;
 i13 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i60 >> 2] | 0) + 24 >> 2] & 127](i60) | 0;
 HEAP32[i15 >> 2] = i13;
 if ((i124 | 0) == (i13 | 0)) __ZN7testing16AssertionSuccessEv(i2); else {
  __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i118, i14);
  __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i116, i15);
  __ZN7testing8internal9EqFailureEPKcS2_RKNSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEESB_b(i2, 170720, 170736, i118, i116, 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i116);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i118);
 }
 i13 = i2 + 4 | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i14 = (i15 | 0) == 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  do if (!i14) if (!(HEAP8[i15 >> 0] & 1)) {
   i3 = i15 + 1 | 0;
   break;
  } else {
   i3 = HEAP32[i15 + 8 >> 2] | 0;
   break;
  } else i3 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i4, 2, 170184, 453, i3);
  __ZN7testing7MessageC2Ev(i5);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i5 >> 2] | 0) + 8 | 0, 170752, 12) | 0;
  __ZNK2cv8FileNode4nameEv(i6, i121);
  i95 = (HEAP32[i5 >> 2] | 0) + 8 | 0;
  i96 = HEAP32[i6 >> 2] | 0;
  i96 = (i96 | 0) == 0 ? 169928 : i96;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i95, i96, _strlen(i96 | 0) | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i5 >> 2] | 0) + 8 | 0, 170768, 21) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i4, i5);
  __ZN2cv6String10deallocateEv(i6);
  if (HEAP32[i5 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i7 = HEAP32[i5 >> 2] | 0, (i7 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] & 511](i7);
   HEAP32[i5 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i4);
  if (!(HEAP32[i13 >> 2] | 0)) {
   STACKTOP = i123;
   return;
  }
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i8 = HEAP32[i13 >> 2] | 0, (i8 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
   __ZdlPv(i8);
  }
  HEAP32[i13 >> 2] = 0;
  STACKTOP = i123;
  return;
 }
 if (!i14) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i3 = HEAP32[i13 >> 2] | 0, (i3 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
   __ZdlPv(i3);
  }
  HEAP32[i13 >> 2] = 0;
 }
 i15 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i60 >> 2] | 0) + 56 >> 2] & 127](i60, -1) | 0;
 HEAP32[i12 >> 2] = i15;
 if ((i11 | 0) == (i15 | 0)) __ZN7testing16AssertionSuccessEv(i19); else {
  __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i118, i1);
  __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i116, i12);
  __ZN7testing8internal9EqFailureEPKcS2_RKNSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEESB_b(i19, 170792, 170808, i118, i116, 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i116);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i118);
 }
 i15 = i19 + 4 | 0;
 i14 = HEAP32[i15 >> 2] | 0;
 i13 = (i14 | 0) == 0;
 if (!(HEAP8[i19 >> 0] | 0)) {
  do if (!i13) if (!(HEAP8[i14 >> 0] & 1)) {
   i3 = i14 + 1 | 0;
   break;
  } else {
   i3 = HEAP32[i14 + 8 >> 2] | 0;
   break;
  } else i3 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i22, 2, 170184, 454, i3);
  __ZN7testing7MessageC2Ev(i23);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i23 >> 2] | 0) + 8 | 0, 170752, 12) | 0;
  __ZNK2cv8FileNode4nameEv(i20, i121);
  i95 = (HEAP32[i23 >> 2] | 0) + 8 | 0;
  i96 = HEAP32[i20 >> 2] | 0;
  i96 = (i96 | 0) == 0 ? 169928 : i96;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i95, i96, _strlen(i96 | 0) | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i23 >> 2] | 0) + 8 | 0, 170824, 21) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i22, i23);
  __ZN2cv6String10deallocateEv(i20);
  if (HEAP32[i23 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i25 = HEAP32[i23 >> 2] | 0, (i25 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i25 >> 2] | 0) + 4 >> 2] & 511](i25);
   HEAP32[i23 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i22);
  if (!(HEAP32[i15 >> 2] | 0)) {
   STACKTOP = i123;
   return;
  }
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i24 = HEAP32[i15 >> 2] | 0, (i24 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
   __ZdlPv(i24);
  }
  HEAP32[i15 >> 2] = 0;
  STACKTOP = i123;
  return;
 }
 if (!i13) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i21 = HEAP32[i15 >> 2] | 0, (i21 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZdlPv(i21);
  }
  HEAP32[i15 >> 2] = 0;
 }
 __ZNK2cv8FileNodeixEPKc(i63, i121, 170112);
 if (((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i60 >> 2] | 0) + 24 >> 2] & 127](i60) | 0) != 327680 ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i60 >> 2] | 0) + 24 >> 2] & 127](i60) | 0) != 262144 : 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i60 >> 2] | 0) + 24 >> 2] & 127](i60) | 0) != 720896 : 0) {
  if (!(__ZNK2cv8FileNode4typeEv(i63) | 0)) {
   HEAP32[i16 >> 2] = 26;
   i2 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i60 >> 2] | 0) + 52 >> 2] & 127](i60, -1) | 0;
   HEAP32[i17 >> 2] = Math_imul(FUNCTION_TABLE_iii[HEAP32[(HEAP32[i60 >> 2] | 0) + 64 >> 2] & 127](i60, -1) | 0, i2) | 0;
   __ZN7testing8internal11CmpHelperLEIjjEENS_15AssertionResultEPKcS4_RKT_RKT0_(i27, 170928, 171400, i16, i17);
   i2 = i27 + 4 | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   i3 = (i4 | 0) == 0;
   if (HEAP8[i27 >> 0] | 0) {
    if (!i3) {
     if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i36 = HEAP32[i2 >> 2] | 0, (i36 | 0) != 0) : 0) {
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i36);
      __ZdlPv(i36);
     }
     HEAP32[i2 >> 2] = 0;
    }
    HEAP32[i41 >> 2] = HEAP32[i121 >> 2];
    HEAP32[i41 + 4 >> 2] = HEAP32[i121 + 4 >> 2];
    FUNCTION_TABLE_viii[HEAP32[HEAP32[i60 >> 2] >> 2] & 63](i52, i60, -1);
    __ZNK2cv8FileNode4nameEv(i45, i121);
    HEAP32[i44 >> 2] = 0;
    i3 = i44 + 4 | 0;
    HEAP32[i3 >> 2] = 0;
    i2 = i45 + 4 | 0;
    __ZN2cv6String8allocateEj(i44, (HEAP32[i2 >> 2] | 0) + 10 | 0) | 0;
    i1 = HEAP32[i44 >> 2] | 0;
    i5 = i1 + 0 | 0;
    i4 = 171488;
    i7 = i5 + 10 | 0;
    do {
     HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
     i5 = i5 + 1 | 0;
     i4 = i4 + 1 | 0;
    } while ((i5 | 0) < (i7 | 0));
    _memcpy(i1 + 10 | 0, HEAP32[i45 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
    HEAP32[i43 >> 2] = 0;
    i2 = i43 + 4 | 0;
    HEAP32[i2 >> 2] = 0;
    __ZN2cv6String8allocateEj(i43, (HEAP32[i3 >> 2] | 0) + 1 | 0) | 0;
    _memcpy(HEAP32[i43 >> 2] | 0, HEAP32[i44 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
    HEAP8[(HEAP32[i43 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) >> 0] = 34;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i42, HEAP32[i43 >> 2] | 0, HEAP32[i2 >> 2] | 0);
    __ZN4perf10Regression6verifyEN2cv8FileNodeENS1_3MatEdNSt3__112basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS_10ERROR_TYPEE(0, i41, i52, d120, i42, i117);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i42);
    __ZN2cv6String10deallocateEv(i43);
    __ZN2cv6String10deallocateEv(i44);
    __ZN2cv6String10deallocateEv(i45);
    i2 = i52 + 36 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if ((i1 | 0) != 0 ? (i95 = i1 + 12 | 0, i96 = HEAP32[i95 >> 2] | 0, HEAP32[i95 >> 2] = i96 + -1, (i96 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i52);
    HEAP32[i2 >> 2] = 0;
    i96 = i52 + 16 | 0;
    i2 = i52 + 4 | 0;
    HEAP32[i96 + 0 >> 2] = 0;
    HEAP32[i96 + 4 >> 2] = 0;
    HEAP32[i96 + 8 >> 2] = 0;
    HEAP32[i96 + 12 >> 2] = 0;
    if ((HEAP32[i2 >> 2] | 0) > 0) {
     i1 = HEAP32[i52 + 40 >> 2] | 0;
     i3 = 0;
     do {
      HEAP32[i1 + (i3 << 2) >> 2] = 0;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
    }
    i1 = HEAP32[i52 + 44 >> 2] | 0;
    if ((i1 | 0) == (i52 + 48 | 0)) {
     STACKTOP = i123;
     return;
    }
    __ZN2cv8fastFreeEPv(i1);
    STACKTOP = i123;
    return;
   }
   do if (!i3) if (!(HEAP8[i4 >> 0] & 1)) {
    i3 = i4 + 1 | 0;
    break;
   } else {
    i3 = HEAP32[i4 + 8 >> 2] | 0;
    break;
   } else i3 = 169928; while (0);
   __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i33, 2, 170184, 523, i3);
   __ZN7testing7MessageC2Ev(i34);
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i34 >> 2] | 0) + 8 | 0, 170752, 12) | 0;
   __ZNK2cv8FileNode4nameEv(i35, i121);
   i95 = (HEAP32[i34 >> 2] | 0) + 8 | 0;
   i96 = HEAP32[i35 >> 2] | 0;
   i96 = (i96 | 0) == 0 ? 169928 : i96;
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i95, i96, _strlen(i96 | 0) | 0) | 0;
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i34 >> 2] | 0) + 8 | 0, 171448, 35) | 0;
   __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i33, i34);
   __ZN2cv6String10deallocateEv(i35);
   if (HEAP32[i34 >> 2] | 0) {
    if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i40 = HEAP32[i34 >> 2] | 0, (i40 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i40 >> 2] | 0) + 4 >> 2] & 511](i40);
    HEAP32[i34 >> 2] = 0;
   }
   __ZN7testing8internal12AssertHelperD2Ev(i33);
   if (!(HEAP32[i2 >> 2] | 0)) {
    STACKTOP = i123;
    return;
   }
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i38 = HEAP32[i2 >> 2] | 0, (i38 | 0) != 0) : 0) {
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i38);
    __ZdlPv(i38);
   }
   HEAP32[i2 >> 2] = 0;
   STACKTOP = i123;
   return;
  }
  HEAP32[i115 >> 2] = 1124007936;
  i14 = i115 + 4 | 0;
  i3 = i115 + 8 | 0;
  i15 = i115 + 40 | 0;
  i5 = i14 + 0 | 0;
  i7 = i5 + 36 | 0;
  do {
   HEAP32[i5 >> 2] = 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) < (i7 | 0));
  HEAP32[i15 >> 2] = i3;
  i12 = i115 + 48 | 0;
  i13 = i115 + 44 | 0;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i115 + 52 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i118 >> 2] = 1124007936;
  i4 = i118 + 4 | 0;
  i9 = i118 + 8 | 0;
  i6 = i118 + 40 | 0;
  i5 = i4 + 0 | 0;
  i7 = i5 + 36 | 0;
  do {
   HEAP32[i5 >> 2] = 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) < (i7 | 0));
  HEAP32[i6 >> 2] = i9;
  i5 = i118 + 48 | 0;
  i7 = i118 + 44 | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i118 + 52 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  __ZN2cv4readERKNS_8FileNodeERNS_3MatERKS3_(i63, i115, i118);
  i9 = i118 + 36 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  if ((i8 | 0) != 0 ? (i89 = i8 + 12 | 0, i90 = HEAP32[i89 >> 2] | 0, HEAP32[i89 >> 2] = i90 + -1, (i90 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i118);
  HEAP32[i9 >> 2] = 0;
  i90 = i118 + 16 | 0;
  HEAP32[i90 + 0 >> 2] = 0;
  HEAP32[i90 + 4 >> 2] = 0;
  HEAP32[i90 + 8 >> 2] = 0;
  HEAP32[i90 + 12 >> 2] = 0;
  if ((HEAP32[i4 >> 2] | 0) > 0) {
   i9 = HEAP32[i6 >> 2] | 0;
   i8 = 0;
   do {
    HEAP32[i9 + (i8 << 2) >> 2] = 0;
    i8 = i8 + 1 | 0;
   } while ((i8 | 0) < (HEAP32[i4 >> 2] | 0));
  }
  i9 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) != (i5 | 0)) __ZN2cv8fastFreeEPv(i9);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i60 >> 2] >> 2] & 63](i122, i60, -1);
  i11 = i115 + 16 | 0;
  do if (HEAP32[i11 >> 2] | 0) {
   i8 = HEAP32[i14 >> 2] | 0;
   if ((i8 | 0) < 3) i9 = Math_imul(HEAP32[i115 + 12 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0; else {
    i7 = HEAP32[i15 >> 2] | 0;
    i6 = 0;
    i9 = 1;
    do {
     i9 = Math_imul(HEAP32[i7 + (i6 << 2) >> 2] | 0, i9) | 0;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i8 | 0));
   }
   if (i9) {
    i89 = HEAP32[i15 >> 2] | 0;
    i87 = HEAP32[i89 + 4 >> 2] | 0;
    i89 = HEAP32[i89 >> 2] | 0;
    HEAP32[i54 >> 2] = i87;
    HEAP32[i54 + 4 >> 2] = i89;
    i90 = HEAP32[i122 + 40 >> 2] | 0;
    i88 = HEAP32[i90 + 4 >> 2] | 0;
    i90 = HEAP32[i90 >> 2] | 0;
    HEAP32[i55 >> 2] = i88;
    HEAP32[i55 + 4 >> 2] = i90;
    if ((i87 | 0) == (i88 | 0) & (i89 | 0) == (i90 | 0)) __ZN7testing16AssertionSuccessEv(i61); else {
     __ZN7testing13PrintToStringIN2cv5Size_IiEEEENSt3__112basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEERKT_(i118, i54);
     __ZN7testing13PrintToStringIN2cv5Size_IiEEEENSt3__112basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEERKT_(i116, i55);
     __ZN7testing8internal9EqFailureEPKcS2_RKNSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEESB_b(i61, 171120, 171136, i118, i116, 0);
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i116);
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i118);
    }
    i9 = i61 + 4 | 0;
    if (!(HEAP8[i61 >> 0] | 0)) {
     i8 = HEAP32[i9 >> 2] | 0;
     do if (i8) if (!(HEAP8[i8 >> 0] & 1)) {
      i8 = i8 + 1 | 0;
      break;
     } else {
      i8 = HEAP32[i8 + 8 >> 2] | 0;
      break;
     } else i8 = 169928; while (0);
     __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i67, 2, 170184, 540, i8);
     __ZN7testing7MessageC2Ev(i68);
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i68 >> 2] | 0) + 8 | 0, 170752, 12) | 0;
     __ZNK2cv8FileNode4nameEv(i64, i121);
     i89 = (HEAP32[i68 >> 2] | 0) + 8 | 0;
     i90 = HEAP32[i64 >> 2] | 0;
     i90 = (i90 | 0) == 0 ? 169928 : i90;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i89, i90, _strlen(i90 | 0) | 0) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i68 >> 2] | 0) + 8 | 0, 171504, 21) | 0;
     __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i67, i68);
     __ZN2cv6String10deallocateEv(i64);
     if (HEAP32[i68 >> 2] | 0) {
      do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
       i8 = HEAP32[i68 >> 2] | 0;
       if (!i8) break;
       FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] & 511](i8);
      } while (0);
      HEAP32[i68 >> 2] = 0;
     }
     __ZN7testing8internal12AssertHelperD2Ev(i67);
     i8 = 1;
    } else i8 = 0;
    if (HEAP32[i9 >> 2] | 0) {
     do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
      i7 = HEAP32[i9 >> 2] | 0;
      if (!i7) break;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
      __ZdlPv(i7);
     } while (0);
     HEAP32[i9 >> 2] = 0;
    }
    if (i8) break;
    HEAP32[i113 >> 2] = 1124007936;
    i10 = i113 + 4 | 0;
    i8 = i113 + 8 | 0;
    i2 = i113 + 40 | 0;
    i5 = i10 + 0 | 0;
    i7 = i5 + 36 | 0;
    do {
     HEAP32[i5 >> 2] = 0;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) < (i7 | 0));
    HEAP32[i2 >> 2] = i8;
    i1 = i113 + 48 | 0;
    i9 = i113 + 44 | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i113 + 52 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i78 >> 2] = 32088;
    HEAP32[i78 + 12 >> 2] = 0;
    HEAP32[i78 + 16 >> 2] = 0;
    HEAP32[i78 + 4 >> 2] = 16842752;
    HEAP32[i78 + 8 >> 2] = i115;
    HEAP32[i79 >> 2] = 32088;
    HEAP32[i79 + 12 >> 2] = 0;
    HEAP32[i79 + 16 >> 2] = 0;
    HEAP32[i79 + 4 >> 2] = 16842752;
    HEAP32[i79 + 8 >> 2] = i122;
    i90 = i80 + 4 | 0;
    HEAP32[i90 + 0 >> 2] = 0;
    HEAP32[i90 + 4 >> 2] = 0;
    HEAP32[i90 + 8 >> 2] = 0;
    HEAP32[i90 + 12 >> 2] = 0;
    HEAP32[i80 >> 2] = 32232;
    HEAP32[i90 >> 2] = 33619968;
    HEAP32[i80 + 8 >> 2] = i113;
    __ZN2cv7absdiffERKNS_11_InputArrayES2_RKNS_12_OutputArrayE(i78, i79, i80);
    do if (!i117) {
     HEAP32[i81 >> 2] = 32088;
     HEAP32[i81 + 12 >> 2] = 0;
     HEAP32[i81 + 16 >> 2] = 0;
     HEAP32[i81 + 4 >> 2] = 16842752;
     HEAP32[i81 + 8 >> 2] = i113;
     if (__ZN2cv10checkRangeERKNS_11_InputArrayEbPNS_6Point_IiEEdd(i81, 1, 0, 0.0, d120) | 0) break;
     i6 = HEAP32[i14 >> 2] | 0;
     if ((i6 | 0) < 3) i5 = Math_imul(HEAP32[i115 + 12 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0; else {
      i8 = HEAP32[i15 >> 2] | 0;
      i7 = 0;
      i5 = 1;
      do {
       i5 = Math_imul(HEAP32[i8 + (i7 << 2) >> 2] | 0, i5) | 0;
       i7 = i7 + 1 | 0;
      } while ((i7 | 0) != (i6 | 0));
     }
     if ((Math_imul(((HEAP32[i115 >> 2] | 0) >>> 3 & 511) + 1 | 0, i5) | 0) >>> 0 < 12) {
      i96 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 171184, 11) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i96 + (HEAP32[(HEAP32[i96 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i95 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i95 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i95 >> 2] | 0) + 28 >> 2] & 127](i95, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i96, i95) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i96) | 0;
      i96 = __ZN2cvlsERNSt3__113basic_ostreamIcNS0_11char_traitsIcEEEERKNS_3MatE1056(i96, i115) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i96 + (HEAP32[(HEAP32[i96 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i95 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i95 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i95 >> 2] | 0) + 28 >> 2] & 127](i95, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i96, i95) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i96) | 0;
      i96 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i96, 171200, 8) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i96 + (HEAP32[(HEAP32[i96 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i95 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i95 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i95 >> 2] | 0) + 28 >> 2] & 127](i95, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i96, i95) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i96) | 0;
      i96 = __ZN2cvlsERNSt3__113basic_ostreamIcNS0_11char_traitsIcEEEERKNS_3MatE1056(i96, i122) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i96 + (HEAP32[(HEAP32[i96 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i95 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i95 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i95 >> 2] | 0) + 28 >> 2] & 127](i95, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i96, i95) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i96) | 0;
     }
     __ZNK2cv3Mat7reshapeEii(i103, i113, 1, 0);
     HEAP32[i91 >> 2] = 32088;
     HEAP32[i91 + 12 >> 2] = 0;
     HEAP32[i91 + 16 >> 2] = 0;
     HEAP32[i91 + 4 >> 2] = 16842752;
     HEAP32[i91 + 8 >> 2] = i103;
     __ZN2cv9minMaxIdxERKNS_11_InputArrayEPdS3_PiS4_S2_(i91, 0, i105, 0, 0, __ZN2cv7noArrayEv() | 0);
     i4 = i103 + 36 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     do if (i3) {
      i95 = i3 + 12 | 0;
      i96 = HEAP32[i95 >> 2] | 0;
      HEAP32[i95 >> 2] = i96 + -1;
      if ((i96 | 0) != 1) break;
      __ZN2cv3Mat10deallocateEv(i103);
     } while (0);
     HEAP32[i4 >> 2] = 0;
     i96 = i103 + 16 | 0;
     i5 = i103 + 4 | 0;
     HEAP32[i96 + 0 >> 2] = 0;
     HEAP32[i96 + 4 >> 2] = 0;
     HEAP32[i96 + 8 >> 2] = 0;
     HEAP32[i96 + 12 >> 2] = 0;
     if ((HEAP32[i5 >> 2] | 0) > 0) {
      i4 = HEAP32[i103 + 40 >> 2] | 0;
      i3 = 0;
      do {
       HEAP32[i4 + (i3 << 2) >> 2] = 0;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) < (HEAP32[i5 >> 2] | 0));
     }
     i4 = HEAP32[i103 + 44 >> 2] | 0;
     if ((i4 | 0) != (i103 + 48 | 0)) __ZN2cv8fastFreeEPv(i4);
     __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i106, 2, 170184, 556, 171216);
     __ZN7testing7MessageC2Ev(i107);
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i107 >> 2] | 0) + 8 | 0, 171528, 15) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd((HEAP32[i107 >> 2] | 0) + 8 | 0, +HEAPF64[i105 >> 3]) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i107 >> 2] | 0) + 8 | 0, 171544, 21) | 0;
     __ZNK2cv8FileNode4nameEv(i104, i121);
     i95 = (HEAP32[i107 >> 2] | 0) + 8 | 0;
     i96 = HEAP32[i104 >> 2] | 0;
     i96 = (i96 | 0) == 0 ? 169928 : i96;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i95, i96, _strlen(i96 | 0) | 0) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i107 >> 2] | 0) + 8 | 0, 171568, 37) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd((HEAP32[i107 >> 2] | 0) + 8 | 0, d120) | 0;
     __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i106, i107);
     __ZN2cv6String10deallocateEv(i104);
     if (HEAP32[i107 >> 2] | 0) {
      do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
       i4 = HEAP32[i107 >> 2] | 0;
       if (!i4) break;
       FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 511](i4);
      } while (0);
      HEAP32[i107 >> 2] = 0;
     }
     __ZN7testing8internal12AssertHelperD2Ev(i106);
    } else if ((i117 | 0) == 1) {
     i4 = __ZL15countViolationsRKN2cv3MatES2_S2_dPdS3_(i115, i122, i113, d120, i94, i93) | 0;
     if ((i4 | 0) <= 0) break;
     i6 = HEAP32[i14 >> 2] | 0;
     if ((i6 | 0) < 3) i5 = Math_imul(HEAP32[i115 + 12 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0; else {
      i8 = HEAP32[i15 >> 2] | 0;
      i7 = 0;
      i5 = 1;
      do {
       i5 = Math_imul(HEAP32[i8 + (i7 << 2) >> 2] | 0, i5) | 0;
       i7 = i7 + 1 | 0;
      } while ((i7 | 0) != (i6 | 0));
     }
     if ((Math_imul(((HEAP32[i115 >> 2] | 0) >>> 3 & 511) + 1 | 0, i5) | 0) >>> 0 < 12) {
      i91 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 171184, 11) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i91 + (HEAP32[(HEAP32[i91 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i90 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i90 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i90 >> 2] | 0) + 28 >> 2] & 127](i90, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i91, i90) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i91) | 0;
      i91 = __ZN2cvlsERNSt3__113basic_ostreamIcNS0_11char_traitsIcEEEERKNS_3MatE1056(i91, i115) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i91 + (HEAP32[(HEAP32[i91 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i90 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i90 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i90 >> 2] | 0) + 28 >> 2] & 127](i90, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i91, i90) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i91) | 0;
      i91 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i91, 171200, 8) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i91 + (HEAP32[(HEAP32[i91 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i90 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i90 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i90 >> 2] | 0) + 28 >> 2] & 127](i90, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i91, i90) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i91) | 0;
      i91 = __ZN2cvlsERNSt3__113basic_ostreamIcNS0_11char_traitsIcEEEERKNS_3MatE1056(i91, i122) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i91 + (HEAP32[(HEAP32[i91 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i90 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i90 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i90 >> 2] | 0) + 28 >> 2] & 127](i90, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i91, i90) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i91) | 0;
     }
     __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i95, 2, 170184, 569, 171216);
     __ZN7testing7MessageC2Ev(i96);
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i96 >> 2] | 0) + 8 | 0, 171320, 23) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd((HEAP32[i96 >> 2] | 0) + 8 | 0, +HEAPF64[i94 >> 3]) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i96 >> 2] | 0) + 8 | 0, 171344, 4) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd((HEAP32[i96 >> 2] | 0) + 8 | 0, +HEAPF64[i93 >> 3]) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i96 >> 2] | 0) + 8 | 0, 171352, 28) | 0;
     __ZNK2cv8FileNode4nameEv(i92, i121);
     i93 = (HEAP32[i96 >> 2] | 0) + 8 | 0;
     i94 = HEAP32[i92 >> 2] | 0;
     i94 = (i94 | 0) == 0 ? 169928 : i94;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i93, i94, _strlen(i94 | 0) | 0) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i96 >> 2] | 0) + 8 | 0, 171568, 37) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd((HEAP32[i96 >> 2] | 0) + 8 | 0, d120) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i96 >> 2] | 0) + 8 | 0, 171384, 4) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i96 >> 2] | 0) + 8 | 0, i4) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i96 >> 2] | 0) + 8 | 0, 171392, 7) | 0;
     __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i95, i96);
     __ZN2cv6String10deallocateEv(i92);
     if (HEAP32[i96 >> 2] | 0) {
      do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
       i4 = HEAP32[i96 >> 2] | 0;
       if (!i4) break;
       FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 511](i4);
      } while (0);
      HEAP32[i96 >> 2] = 0;
     }
     __ZN7testing8internal12AssertHelperD2Ev(i95);
    } while (0);
    i4 = i113 + 36 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    do if (i3) {
     i95 = i3 + 12 | 0;
     i96 = HEAP32[i95 >> 2] | 0;
     HEAP32[i95 >> 2] = i96 + -1;
     if ((i96 | 0) != 1) break;
     __ZN2cv3Mat10deallocateEv(i113);
    } while (0);
    HEAP32[i4 >> 2] = 0;
    i96 = i113 + 16 | 0;
    HEAP32[i96 + 0 >> 2] = 0;
    HEAP32[i96 + 4 >> 2] = 0;
    HEAP32[i96 + 8 >> 2] = 0;
    HEAP32[i96 + 12 >> 2] = 0;
    if ((HEAP32[i10 >> 2] | 0) > 0) {
     i3 = HEAP32[i2 >> 2] | 0;
     i2 = 0;
     do {
      HEAP32[i3 + (i2 << 2) >> 2] = 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (HEAP32[i10 >> 2] | 0));
    }
    i3 = HEAP32[i9 >> 2] | 0;
    if ((i3 | 0) == (i1 | 0)) break;
    __ZN2cv8fastFreeEPv(i3);
   } else i119 = 248;
  } else i119 = 248; while (0);
  do if ((i119 | 0) == 248) {
   if (!(HEAP32[i122 + 16 >> 2] | 0)) {
    HEAP8[i71 >> 0] = 1;
    HEAP32[i71 + 4 >> 2] = 0;
    break;
   }
   i4 = HEAP32[i122 + 4 >> 2] | 0;
   if ((i4 | 0) < 3) i3 = Math_imul(HEAP32[i122 + 12 >> 2] | 0, HEAP32[i122 + 8 >> 2] | 0) | 0; else {
    i2 = HEAP32[i122 + 40 >> 2] | 0;
    i1 = 0;
    i3 = 1;
    do {
     i3 = Math_imul(HEAP32[i2 + (i1 << 2) >> 2] | 0, i3) | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i4 | 0));
   }
   i96 = (i3 | 0) == 0;
   HEAP8[i71 >> 0] = i96 & 1;
   i4 = i71 + 4 | 0;
   HEAP32[i4 >> 2] = 0;
   if (!i96) {
    __ZN7testing8internal30GetBoolAssertionFailureMessageERKNS_15AssertionResultEPKcS5_S5_(i76, i71, 171056, 171072, 171080);
    if (!(HEAP8[i76 >> 0] & 1)) i3 = i76 + 1 | 0; else i3 = HEAP32[i76 + 8 >> 2] | 0;
    __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i75, 2, 170184, 535, i3);
    __ZN7testing7MessageC2Ev(i77);
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i77 >> 2] | 0) + 8 | 0, 171088, 17) | 0;
    __ZNK2cv8FileNode4nameEv(i74, i121);
    i95 = (HEAP32[i77 >> 2] | 0) + 8 | 0;
    i96 = HEAP32[i74 >> 2] | 0;
    i96 = (i96 | 0) == 0 ? 169928 : i96;
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i95, i96, _strlen(i96 | 0) | 0) | 0;
    __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i75, i77);
    __ZN2cv6String10deallocateEv(i74);
    if (HEAP32[i77 >> 2] | 0) {
     do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
      i3 = HEAP32[i77 >> 2] | 0;
      if (!i3) break;
      FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
     } while (0);
     HEAP32[i77 >> 2] = 0;
    }
    __ZN7testing8internal12AssertHelperD2Ev(i75);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i76);
    if (!(HEAP32[i4 >> 2] | 0)) break;
    do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) break;
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
     __ZdlPv(i3);
    } while (0);
    HEAP32[i4 >> 2] = 0;
   }
  } while (0);
  i3 = i122 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i95 = i2 + 12 | 0, i96 = HEAP32[i95 >> 2] | 0, HEAP32[i95 >> 2] = i96 + -1, (i96 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i122);
  HEAP32[i3 >> 2] = 0;
  i96 = i122 + 16 | 0;
  i3 = i122 + 4 | 0;
  HEAP32[i96 + 0 >> 2] = 0;
  HEAP32[i96 + 4 >> 2] = 0;
  HEAP32[i96 + 8 >> 2] = 0;
  HEAP32[i96 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i122 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i3 = HEAP32[i122 + 44 >> 2] | 0;
  if ((i3 | 0) != (i122 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = i115 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  do if (i2) {
   i95 = i2 + 12 | 0;
   i96 = HEAP32[i95 >> 2] | 0;
   HEAP32[i95 >> 2] = i96 + -1;
   if ((i96 | 0) != 1) break;
   __ZN2cv3Mat10deallocateEv(i115);
  } while (0);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i11 + 0 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  if ((HEAP32[i14 >> 2] | 0) > 0) {
   i3 = HEAP32[i15 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i14 >> 2] | 0));
  }
  i1 = HEAP32[i13 >> 2] | 0;
  if ((i1 | 0) == (i12 | 0)) {
   STACKTOP = i123;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i123;
  return;
 }
 __ZNK2cv8FileNodeixEPKc(i9, i121, 170704);
 __ZN2cv4readERKNS_8FileNodeERii(i9, i118, 0);
 i95 = HEAP32[i118 >> 2] | 0;
 HEAP32[i18 >> 2] = i95;
 i96 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i60 >> 2] | 0) + 52 >> 2] & 127](i60, -1) | 0;
 HEAP32[i10 >> 2] = i96;
 if ((i95 | 0) == (i96 | 0)) __ZN7testing16AssertionSuccessEv(i28); else {
  __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i118, i18);
  __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i116, i10);
  __ZN7testing8internal9EqFailureEPKcS2_RKNSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEESB_b(i28, 170848, 170864, i118, i116, 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i116);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i118);
 }
 i7 = i28 + 4 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i8 = (i9 | 0) == 0;
 if (!(HEAP8[i28 >> 0] | 0)) {
  do if (!i8) if (!(HEAP8[i9 >> 0] & 1)) {
   i3 = i9 + 1 | 0;
   break;
  } else {
   i3 = HEAP32[i9 + 8 >> 2] | 0;
   break;
  } else i3 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i29, 2, 170184, 460, i3);
  __ZN7testing7MessageC2Ev(i30);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i30 >> 2] | 0) + 8 | 0, 170888, 10) | 0;
  __ZNK2cv8FileNode4nameEv(i31, i121);
  i95 = (HEAP32[i30 >> 2] | 0) + 8 | 0;
  i96 = HEAP32[i31 >> 2] | 0;
  i96 = (i96 | 0) == 0 ? 169928 : i96;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i95, i96, _strlen(i96 | 0) | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i30 >> 2] | 0) + 8 | 0, 170904, 23) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i29, i30);
  __ZN2cv6String10deallocateEv(i31);
  if (HEAP32[i30 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i39 = HEAP32[i30 >> 2] | 0, (i39 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i39 >> 2] | 0) + 4 >> 2] & 511](i39);
   HEAP32[i30 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i29);
  if (!(HEAP32[i7 >> 2] | 0)) {
   STACKTOP = i123;
   return;
  }
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i37 = HEAP32[i7 >> 2] | 0, (i37 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i37);
   __ZdlPv(i37);
  }
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i123;
  return;
 }
 if (!i8) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i32 = HEAP32[i7 >> 2] | 0, (i32 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i32);
   __ZdlPv(i32);
  }
  HEAP32[i7 >> 2] = 0;
 }
 __ZNK2cv8FileNodeixEPKc(i26, i121, 170712);
 __ZN2cv4readERKNS_8FileNodeERii(i26, i118, 0);
 i39 = HEAP32[i118 >> 2] | 0;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i60 >> 2] >> 2] & 63](i122, i60, i39);
 do if (!(__ZNK2cv8FileNode4typeEv(i63) | 0)) {
  HEAP32[i46 >> 2] = 26;
  i9 = i122 + 4 | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  if ((i5 | 0) < 3) i4 = Math_imul(HEAP32[i122 + 12 >> 2] | 0, HEAP32[i122 + 8 >> 2] | 0) | 0; else {
   i3 = HEAP32[i122 + 40 >> 2] | 0;
   i7 = 0;
   i4 = 1;
   do {
    i4 = Math_imul(HEAP32[i3 + (i7 << 2) >> 2] | 0, i4) | 0;
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i5 | 0));
  }
  HEAP32[i47 >> 2] = Math_imul(((HEAP32[i122 >> 2] | 0) >>> 3 & 511) + 1 | 0, i4) | 0;
  __ZN7testing8internal11CmpHelperLEIjjEENS_15AssertionResultEPKcS4_RKT_RKT0_(i48, 170928, 170944, i46, i47);
  i3 = i48 + 4 | 0;
  if (!(HEAP8[i48 >> 0] | 0)) {
   i4 = HEAP32[i3 >> 2] | 0;
   do if (i4) if (!(HEAP8[i4 >> 0] & 1)) {
    i4 = i4 + 1 | 0;
    break;
   } else {
    i4 = HEAP32[i4 + 8 >> 2] | 0;
    break;
   } else i4 = 169928; while (0);
   __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i50, 2, 170184, 467, i4);
   __ZN7testing7MessageC2Ev(i51);
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i51 >> 2] | 0) + 8 | 0, 170992, 3) | 0;
   __ZNK2cv8FileNode4nameEv(i49, i121);
   i95 = (HEAP32[i51 >> 2] | 0) + 8 | 0;
   i96 = HEAP32[i49 >> 2] | 0;
   i96 = (i96 | 0) == 0 ? 169928 : i96;
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i95, i96, _strlen(i96 | 0) | 0) | 0;
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i51 >> 2] | 0) + 8 | 0, 171e3, 1) | 0;
   __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i51 >> 2] | 0) + 8 | 0, i39) | 0;
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i51 >> 2] | 0) + 8 | 0, 171008, 36) | 0;
   __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i50, i51);
   __ZN2cv6String10deallocateEv(i49);
   if (HEAP32[i51 >> 2] | 0) {
    do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
     i4 = HEAP32[i51 >> 2] | 0;
     if (!i4) break;
     FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 511](i4);
    } while (0);
    HEAP32[i51 >> 2] = 0;
   }
   __ZN7testing8internal12AssertHelperD2Ev(i50);
   i4 = 1;
  } else i4 = 0;
  if (HEAP32[i3 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i53 = HEAP32[i3 >> 2] | 0, (i53 | 0) != 0) : 0) {
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i53);
    __ZdlPv(i53);
   }
   HEAP32[i3 >> 2] = 0;
  }
  if (!i4) {
   HEAP32[i56 >> 2] = HEAP32[i121 >> 2];
   HEAP32[i56 + 4 >> 2] = HEAP32[i121 + 4 >> 2];
   HEAP32[i62 >> 2] = HEAP32[i122 >> 2];
   i6 = i62 + 4 | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   HEAP32[i6 >> 2] = i4;
   i8 = i62 + 8 | 0;
   HEAP32[i8 >> 2] = HEAP32[i122 + 8 >> 2];
   HEAP32[i62 + 12 >> 2] = HEAP32[i122 + 12 >> 2];
   i2 = i62 + 16 | 0;
   HEAP32[i2 >> 2] = HEAP32[i122 + 16 >> 2];
   HEAP32[i62 + 20 >> 2] = HEAP32[i122 + 20 >> 2];
   HEAP32[i62 + 24 >> 2] = HEAP32[i122 + 24 >> 2];
   HEAP32[i62 + 28 >> 2] = HEAP32[i122 + 28 >> 2];
   HEAP32[i62 + 32 >> 2] = HEAP32[i122 + 32 >> 2];
   i1 = i62 + 36 | 0;
   i3 = HEAP32[i122 + 36 >> 2] | 0;
   HEAP32[i1 >> 2] = i3;
   i5 = i62 + 40 | 0;
   HEAP32[i5 >> 2] = i8;
   i8 = i62 + 48 | 0;
   i7 = i62 + 44 | 0;
   HEAP32[i7 >> 2] = i8;
   HEAP32[i62 + 52 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   if (i3) {
    i4 = i3 + 12 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    i4 = HEAP32[i9 >> 2] | 0;
   }
   if ((i4 | 0) < 3) {
    i95 = HEAP32[i122 + 44 >> 2] | 0;
    i96 = HEAP32[i7 >> 2] | 0;
    HEAP32[i96 >> 2] = HEAP32[i95 >> 2];
    HEAP32[i96 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
   } else {
    HEAP32[i6 >> 2] = 0;
    __ZN2cv3Mat8copySizeERKS0_(i62, i122);
   }
   __ZNK2cv8FileNode4nameEv(i59, i121);
   i3 = HEAP32[i59 >> 2] | 0;
   HEAP32[i118 >> 2] = (i3 | 0) == 0 ? 169928 : i3;
   HEAP32[i118 + 4 >> 2] = i39;
   __ZN2cv6formatEPKcz(i58, 171048, i118);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i57, HEAP32[i58 >> 2] | 0, HEAP32[i58 + 4 >> 2] | 0);
   __ZN4perf10Regression6verifyEN2cv8FileNodeENS1_3MatEdNSt3__112basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS_10ERROR_TYPEE(0, i56, i62, d120, i57, i117);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i57);
   __ZN2cv6String10deallocateEv(i58);
   __ZN2cv6String10deallocateEv(i59);
   i3 = HEAP32[i1 >> 2] | 0;
   do if (i3) {
    i95 = i3 + 12 | 0;
    i96 = HEAP32[i95 >> 2] | 0;
    HEAP32[i95 >> 2] = i96 + -1;
    if ((i96 | 0) != 1) break;
    __ZN2cv3Mat10deallocateEv(i62);
   } while (0);
   HEAP32[i1 >> 2] = 0;
   HEAP32[i2 + 0 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   if ((HEAP32[i6 >> 2] | 0) > 0) {
    i3 = HEAP32[i5 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i6 >> 2] | 0));
   }
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i8 | 0)) break;
   __ZN2cv8fastFreeEPv(i1);
  }
 } else {
  HEAP32[i114 >> 2] = 1124007936;
  i13 = i114 + 4 | 0;
  i3 = i114 + 8 | 0;
  i12 = i114 + 40 | 0;
  i5 = i13 + 0 | 0;
  i7 = i5 + 36 | 0;
  do {
   HEAP32[i5 >> 2] = 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) < (i7 | 0));
  HEAP32[i12 >> 2] = i3;
  i15 = i114 + 48 | 0;
  i14 = i114 + 44 | 0;
  HEAP32[i14 >> 2] = i15;
  HEAP32[i114 + 52 >> 2] = 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i118 >> 2] = 1124007936;
  i4 = i118 + 4 | 0;
  i9 = i118 + 8 | 0;
  i6 = i118 + 40 | 0;
  i5 = i4 + 0 | 0;
  i7 = i5 + 36 | 0;
  do {
   HEAP32[i5 >> 2] = 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) < (i7 | 0));
  HEAP32[i6 >> 2] = i9;
  i5 = i118 + 48 | 0;
  i7 = i118 + 44 | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i118 + 52 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  __ZN2cv4readERKNS_8FileNodeERNS_3MatERKS3_(i63, i114, i118);
  i9 = i118 + 36 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  if ((i8 | 0) != 0 ? (i95 = i8 + 12 | 0, i96 = HEAP32[i95 >> 2] | 0, HEAP32[i95 >> 2] = i96 + -1, (i96 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i118);
  HEAP32[i9 >> 2] = 0;
  i96 = i118 + 16 | 0;
  HEAP32[i96 + 0 >> 2] = 0;
  HEAP32[i96 + 4 >> 2] = 0;
  HEAP32[i96 + 8 >> 2] = 0;
  HEAP32[i96 + 12 >> 2] = 0;
  if ((HEAP32[i4 >> 2] | 0) > 0) {
   i9 = HEAP32[i6 >> 2] | 0;
   i8 = 0;
   do {
    HEAP32[i9 + (i8 << 2) >> 2] = 0;
    i8 = i8 + 1 | 0;
   } while ((i8 | 0) < (HEAP32[i4 >> 2] | 0));
  }
  i9 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) != (i5 | 0)) __ZN2cv8fastFreeEPv(i9);
  i11 = i114 + 16 | 0;
  do if (HEAP32[i11 >> 2] | 0) {
   i8 = HEAP32[i13 >> 2] | 0;
   if ((i8 | 0) < 3) i9 = Math_imul(HEAP32[i114 + 12 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0; else {
    i7 = HEAP32[i12 >> 2] | 0;
    i6 = 0;
    i9 = 1;
    do {
     i9 = Math_imul(HEAP32[i7 + (i6 << 2) >> 2] | 0, i9) | 0;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i8 | 0));
   }
   if (i9) {
    i95 = HEAP32[i12 >> 2] | 0;
    i93 = HEAP32[i95 + 4 >> 2] | 0;
    i95 = HEAP32[i95 >> 2] | 0;
    HEAP32[i65 >> 2] = i93;
    HEAP32[i65 + 4 >> 2] = i95;
    i96 = HEAP32[i122 + 40 >> 2] | 0;
    i94 = HEAP32[i96 + 4 >> 2] | 0;
    i96 = HEAP32[i96 >> 2] | 0;
    HEAP32[i66 >> 2] = i94;
    HEAP32[i66 + 4 >> 2] = i96;
    if ((i93 | 0) == (i94 | 0) & (i95 | 0) == (i96 | 0)) __ZN7testing16AssertionSuccessEv(i69); else {
     __ZN7testing13PrintToStringIN2cv5Size_IiEEEENSt3__112basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEERKT_(i118, i65);
     __ZN7testing13PrintToStringIN2cv5Size_IiEEEENSt3__112basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEERKT_(i116, i66);
     __ZN7testing8internal9EqFailureEPKcS2_RKNSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEESB_b(i69, 171120, 171136, i118, i116, 0);
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i116);
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i118);
    }
    i9 = i69 + 4 | 0;
    if (!(HEAP8[i69 >> 0] | 0)) {
     i8 = HEAP32[i9 >> 2] | 0;
     do if (i8) if (!(HEAP8[i8 >> 0] & 1)) {
      i8 = i8 + 1 | 0;
      break;
     } else {
      i8 = HEAP32[i8 + 8 >> 2] | 0;
      break;
     } else i8 = 169928; while (0);
     __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i72, 2, 170184, 483, i8);
     __ZN7testing7MessageC2Ev(i73);
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i73 >> 2] | 0) + 8 | 0, 171152, 2) | 0;
     __ZNK2cv8FileNode4nameEv(i70, i121);
     i95 = (HEAP32[i73 >> 2] | 0) + 8 | 0;
     i96 = HEAP32[i70 >> 2] | 0;
     i96 = (i96 | 0) == 0 ? 169928 : i96;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i95, i96, _strlen(i96 | 0) | 0) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i73 >> 2] | 0) + 8 | 0, 171e3, 1) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i73 >> 2] | 0) + 8 | 0, i39) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i73 >> 2] | 0) + 8 | 0, 171160, 21) | 0;
     __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i72, i73);
     __ZN2cv6String10deallocateEv(i70);
     if (HEAP32[i73 >> 2] | 0) {
      do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
       i8 = HEAP32[i73 >> 2] | 0;
       if (!i8) break;
       FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] & 511](i8);
      } while (0);
      HEAP32[i73 >> 2] = 0;
     }
     __ZN7testing8internal12AssertHelperD2Ev(i72);
     i8 = 1;
    } else i8 = 0;
    if (HEAP32[i9 >> 2] | 0) {
     do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
      i7 = HEAP32[i9 >> 2] | 0;
      if (!i7) break;
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
      __ZdlPv(i7);
     } while (0);
     HEAP32[i9 >> 2] = 0;
    }
    if (i8) break;
    HEAP32[i116 >> 2] = 1124007936;
    i10 = i116 + 4 | 0;
    i8 = i116 + 8 | 0;
    i2 = i116 + 40 | 0;
    i5 = i10 + 0 | 0;
    i7 = i5 + 36 | 0;
    do {
     HEAP32[i5 >> 2] = 0;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) < (i7 | 0));
    HEAP32[i2 >> 2] = i8;
    i1 = i116 + 48 | 0;
    i9 = i116 + 44 | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i116 + 52 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i87 >> 2] = 32088;
    HEAP32[i87 + 12 >> 2] = 0;
    HEAP32[i87 + 16 >> 2] = 0;
    HEAP32[i87 + 4 >> 2] = 16842752;
    HEAP32[i87 + 8 >> 2] = i114;
    HEAP32[i88 >> 2] = 32088;
    HEAP32[i88 + 12 >> 2] = 0;
    HEAP32[i88 + 16 >> 2] = 0;
    HEAP32[i88 + 4 >> 2] = 16842752;
    HEAP32[i88 + 8 >> 2] = i122;
    i96 = i89 + 4 | 0;
    HEAP32[i96 + 0 >> 2] = 0;
    HEAP32[i96 + 4 >> 2] = 0;
    HEAP32[i96 + 8 >> 2] = 0;
    HEAP32[i96 + 12 >> 2] = 0;
    HEAP32[i89 >> 2] = 32232;
    HEAP32[i96 >> 2] = 33619968;
    HEAP32[i89 + 8 >> 2] = i116;
    __ZN2cv7absdiffERKNS_11_InputArrayES2_RKNS_12_OutputArrayE(i87, i88, i89);
    do if ((i117 | 0) == 1) {
     i4 = __ZL15countViolationsRKN2cv3MatES2_S2_dPdS3_(i114, i122, i116, d120, i100, i99) | 0;
     if ((i4 | 0) <= 0) break;
     i6 = HEAP32[i13 >> 2] | 0;
     if ((i6 | 0) < 3) i5 = Math_imul(HEAP32[i114 + 12 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0; else {
      i8 = HEAP32[i12 >> 2] | 0;
      i7 = 0;
      i5 = 1;
      do {
       i5 = Math_imul(HEAP32[i8 + (i7 << 2) >> 2] | 0, i5) | 0;
       i7 = i7 + 1 | 0;
      } while ((i7 | 0) != (i6 | 0));
     }
     if ((Math_imul(((HEAP32[i114 >> 2] | 0) >>> 3 & 511) + 1 | 0, i5) | 0) >>> 0 < 12) {
      i96 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 171184, 11) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i96 + (HEAP32[(HEAP32[i96 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i95 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i95 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i95 >> 2] | 0) + 28 >> 2] & 127](i95, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i96, i95) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i96) | 0;
      i96 = __ZN2cvlsERNSt3__113basic_ostreamIcNS0_11char_traitsIcEEEERKNS_3MatE1056(i96, i114) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i96 + (HEAP32[(HEAP32[i96 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i95 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i95 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i95 >> 2] | 0) + 28 >> 2] & 127](i95, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i96, i95) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i96) | 0;
      i96 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i96, 171200, 8) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i96 + (HEAP32[(HEAP32[i96 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i95 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i95 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i95 >> 2] | 0) + 28 >> 2] & 127](i95, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i96, i95) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i96) | 0;
      i96 = __ZN2cvlsERNSt3__113basic_ostreamIcNS0_11char_traitsIcEEEERKNS_3MatE1056(i96, i122) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i96 + (HEAP32[(HEAP32[i96 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i95 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i95 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i95 >> 2] | 0) + 28 >> 2] & 127](i95, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i96, i95) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i96) | 0;
     }
     __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i101, 2, 170184, 512, 171216);
     __ZN7testing7MessageC2Ev(i102);
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i102 >> 2] | 0) + 8 | 0, 171320, 23) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd((HEAP32[i102 >> 2] | 0) + 8 | 0, +HEAPF64[i100 >> 3]) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i102 >> 2] | 0) + 8 | 0, 171344, 4) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd((HEAP32[i102 >> 2] | 0) + 8 | 0, +HEAPF64[i99 >> 3]) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i102 >> 2] | 0) + 8 | 0, 171352, 28) | 0;
     __ZNK2cv8FileNode4nameEv(i98, i121);
     i95 = (HEAP32[i102 >> 2] | 0) + 8 | 0;
     i96 = HEAP32[i98 >> 2] | 0;
     i96 = (i96 | 0) == 0 ? 169928 : i96;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i95, i96, _strlen(i96 | 0) | 0) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i102 >> 2] | 0) + 8 | 0, 171e3, 1) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i102 >> 2] | 0) + 8 | 0, i39) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i102 >> 2] | 0) + 8 | 0, 171280, 38) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd((HEAP32[i102 >> 2] | 0) + 8 | 0, d120) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i102 >> 2] | 0) + 8 | 0, 171384, 4) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i102 >> 2] | 0) + 8 | 0, i4) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i102 >> 2] | 0) + 8 | 0, 171392, 7) | 0;
     __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i101, i102);
     __ZN2cv6String10deallocateEv(i98);
     if (HEAP32[i102 >> 2] | 0) {
      do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
       i4 = HEAP32[i102 >> 2] | 0;
       if (!i4) break;
       FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 511](i4);
      } while (0);
      HEAP32[i102 >> 2] = 0;
     }
     __ZN7testing8internal12AssertHelperD2Ev(i101);
    } else if (!i117) {
     HEAP32[i90 >> 2] = 32088;
     HEAP32[i90 + 12 >> 2] = 0;
     HEAP32[i90 + 16 >> 2] = 0;
     HEAP32[i90 + 4 >> 2] = 16842752;
     HEAP32[i90 + 8 >> 2] = i116;
     if (__ZN2cv10checkRangeERKNS_11_InputArrayEbPNS_6Point_IiEEdd(i90, 1, 0, 0.0, d120) | 0) break;
     i6 = HEAP32[i13 >> 2] | 0;
     if ((i6 | 0) < 3) i5 = Math_imul(HEAP32[i114 + 12 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0; else {
      i8 = HEAP32[i12 >> 2] | 0;
      i7 = 0;
      i5 = 1;
      do {
       i5 = Math_imul(HEAP32[i8 + (i7 << 2) >> 2] | 0, i5) | 0;
       i7 = i7 + 1 | 0;
      } while ((i7 | 0) != (i6 | 0));
     }
     if ((Math_imul(((HEAP32[i114 >> 2] | 0) >>> 3 & 511) + 1 | 0, i5) | 0) >>> 0 < 12) {
      i96 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 171184, 11) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i96 + (HEAP32[(HEAP32[i96 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i95 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i95 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i95 >> 2] | 0) + 28 >> 2] & 127](i95, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i96, i95) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i96) | 0;
      i96 = __ZN2cvlsERNSt3__113basic_ostreamIcNS0_11char_traitsIcEEEERKNS_3MatE1056(i96, i114) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i96 + (HEAP32[(HEAP32[i96 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i95 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i95 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i95 >> 2] | 0) + 28 >> 2] & 127](i95, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i96, i95) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i96) | 0;
      i96 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i96, 171200, 8) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i96 + (HEAP32[(HEAP32[i96 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i95 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i95 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i95 >> 2] | 0) + 28 >> 2] & 127](i95, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i96, i95) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i96) | 0;
      i96 = __ZN2cvlsERNSt3__113basic_ostreamIcNS0_11char_traitsIcEEEERKNS_3MatE1056(i96, i122) | 0;
      __ZNKSt3__18ios_base6getlocEv(i118, i96 + (HEAP32[(HEAP32[i96 >> 2] | 0) + -12 >> 2] | 0) | 0);
      i95 = __ZNKSt3__16locale9use_facetERNS0_2idE(i118, 960728) | 0;
      i95 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i95 >> 2] | 0) + 28 >> 2] & 127](i95, 10) | 0;
      __ZNSt3__16localeD2Ev(i118);
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i96, i95) | 0;
      __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i96) | 0;
     }
     __ZNK2cv3Mat7reshapeEii(i108, i116, 1, 0);
     HEAP32[i97 >> 2] = 32088;
     HEAP32[i97 + 12 >> 2] = 0;
     HEAP32[i97 + 16 >> 2] = 0;
     HEAP32[i97 + 4 >> 2] = 16842752;
     HEAP32[i97 + 8 >> 2] = i108;
     __ZN2cv9minMaxIdxERKNS_11_InputArrayEPdS3_PiS4_S2_(i97, 0, i110, 0, 0, __ZN2cv7noArrayEv() | 0);
     i5 = i108 + 36 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     do if (i4) {
      i95 = i4 + 12 | 0;
      i96 = HEAP32[i95 >> 2] | 0;
      HEAP32[i95 >> 2] = i96 + -1;
      if ((i96 | 0) != 1) break;
      __ZN2cv3Mat10deallocateEv(i108);
     } while (0);
     HEAP32[i5 >> 2] = 0;
     i96 = i108 + 16 | 0;
     i7 = i108 + 4 | 0;
     HEAP32[i96 + 0 >> 2] = 0;
     HEAP32[i96 + 4 >> 2] = 0;
     HEAP32[i96 + 8 >> 2] = 0;
     HEAP32[i96 + 12 >> 2] = 0;
     if ((HEAP32[i7 >> 2] | 0) > 0) {
      i6 = HEAP32[i108 + 40 >> 2] | 0;
      i5 = 0;
      do {
       HEAP32[i6 + (i5 << 2) >> 2] = 0;
       i5 = i5 + 1 | 0;
      } while ((i5 | 0) < (HEAP32[i7 >> 2] | 0));
     }
     i5 = HEAP32[i108 + 44 >> 2] | 0;
     if ((i5 | 0) != (i108 + 48 | 0)) __ZN2cv8fastFreeEPv(i5);
     __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i111, 2, 170184, 499, 171216);
     __ZN7testing7MessageC2Ev(i112);
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i112 >> 2] | 0) + 8 | 0, 171224, 24) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd((HEAP32[i112 >> 2] | 0) + 8 | 0, +HEAPF64[i110 >> 3]) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i112 >> 2] | 0) + 8 | 0, 171256, 20) | 0;
     __ZNK2cv8FileNode4nameEv(i109, i121);
     i95 = (HEAP32[i112 >> 2] | 0) + 8 | 0;
     i96 = HEAP32[i109 >> 2] | 0;
     i96 = (i96 | 0) == 0 ? 169928 : i96;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i95, i96, _strlen(i96 | 0) | 0) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i112 >> 2] | 0) + 8 | 0, 171e3, 1) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i112 >> 2] | 0) + 8 | 0, i39) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i112 >> 2] | 0) + 8 | 0, 171280, 38) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd((HEAP32[i112 >> 2] | 0) + 8 | 0, d120) | 0;
     __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i111, i112);
     __ZN2cv6String10deallocateEv(i109);
     if (HEAP32[i112 >> 2] | 0) {
      do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
       i4 = HEAP32[i112 >> 2] | 0;
       if (!i4) break;
       FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 511](i4);
      } while (0);
      HEAP32[i112 >> 2] = 0;
     }
     __ZN7testing8internal12AssertHelperD2Ev(i111);
    } while (0);
    i4 = i116 + 36 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    do if (i3) {
     i95 = i3 + 12 | 0;
     i96 = HEAP32[i95 >> 2] | 0;
     HEAP32[i95 >> 2] = i96 + -1;
     if ((i96 | 0) != 1) break;
     __ZN2cv3Mat10deallocateEv(i116);
    } while (0);
    HEAP32[i4 >> 2] = 0;
    i96 = i116 + 16 | 0;
    HEAP32[i96 + 0 >> 2] = 0;
    HEAP32[i96 + 4 >> 2] = 0;
    HEAP32[i96 + 8 >> 2] = 0;
    HEAP32[i96 + 12 >> 2] = 0;
    if ((HEAP32[i10 >> 2] | 0) > 0) {
     i3 = HEAP32[i2 >> 2] | 0;
     i2 = 0;
     do {
      HEAP32[i3 + (i2 << 2) >> 2] = 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (HEAP32[i10 >> 2] | 0));
    }
    i3 = HEAP32[i9 >> 2] | 0;
    if ((i3 | 0) == (i1 | 0)) break;
    __ZN2cv8fastFreeEPv(i3);
   } else i119 = 110;
  } else i119 = 110; while (0);
  do if ((i119 | 0) == 110) {
   if (!(HEAP32[i122 + 16 >> 2] | 0)) {
    HEAP8[i82 >> 0] = 1;
    HEAP32[i82 + 4 >> 2] = 0;
    break;
   }
   i3 = HEAP32[i122 + 4 >> 2] | 0;
   if ((i3 | 0) < 3) i4 = Math_imul(HEAP32[i122 + 12 >> 2] | 0, HEAP32[i122 + 8 >> 2] | 0) | 0; else {
    i2 = HEAP32[i122 + 40 >> 2] | 0;
    i1 = 0;
    i4 = 1;
    do {
     i4 = Math_imul(HEAP32[i2 + (i1 << 2) >> 2] | 0, i4) | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
   i96 = (i4 | 0) == 0;
   HEAP8[i82 >> 0] = i96 & 1;
   i2 = i82 + 4 | 0;
   HEAP32[i2 >> 2] = 0;
   if (!i96) {
    __ZN7testing8internal30GetBoolAssertionFailureMessageERKNS_15AssertionResultEPKcS5_S5_(i85, i82, 171056, 171072, 171080);
    if (!(HEAP8[i85 >> 0] & 1)) i4 = i85 + 1 | 0; else i4 = HEAP32[i85 + 8 >> 2] | 0;
    __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i84, 2, 170184, 478, i4);
    __ZN7testing7MessageC2Ev(i86);
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i86 >> 2] | 0) + 8 | 0, 171088, 17) | 0;
    __ZNK2cv8FileNode4nameEv(i83, i121);
    i95 = (HEAP32[i86 >> 2] | 0) + 8 | 0;
    i96 = HEAP32[i83 >> 2] | 0;
    i96 = (i96 | 0) == 0 ? 169928 : i96;
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i95, i96, _strlen(i96 | 0) | 0) | 0;
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i86 >> 2] | 0) + 8 | 0, 171e3, 1) | 0;
    __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i86 >> 2] | 0) + 8 | 0, i39) | 0;
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i86 >> 2] | 0) + 8 | 0, 171112, 1) | 0;
    __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i84, i86);
    __ZN2cv6String10deallocateEv(i83);
    if (HEAP32[i86 >> 2] | 0) {
     do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
      i3 = HEAP32[i86 >> 2] | 0;
      if (!i3) break;
      FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
     } while (0);
     HEAP32[i86 >> 2] = 0;
    }
    __ZN7testing8internal12AssertHelperD2Ev(i84);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i85);
    if (!(HEAP32[i2 >> 2] | 0)) break;
    do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break;
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
     __ZdlPv(i3);
    } while (0);
    HEAP32[i2 >> 2] = 0;
   }
  } while (0);
  i3 = i114 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i95 = i2 + 12 | 0, i96 = HEAP32[i95 >> 2] | 0, HEAP32[i95 >> 2] = i96 + -1, (i96 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i114);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i11 + 0 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  if ((HEAP32[i13 >> 2] | 0) > 0) {
   i3 = HEAP32[i12 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i13 >> 2] | 0));
  }
  i1 = HEAP32[i14 >> 2] | 0;
  if ((i1 | 0) != (i15 | 0)) __ZN2cv8fastFreeEPv(i1);
 } while (0);
 i1 = i122 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i95 = i2 + 12 | 0, i96 = HEAP32[i95 >> 2] | 0, HEAP32[i95 >> 2] = i96 + -1, (i96 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i122);
 HEAP32[i1 >> 2] = 0;
 i96 = i122 + 16 | 0;
 i2 = i122 + 4 | 0;
 HEAP32[i96 + 0 >> 2] = 0;
 HEAP32[i96 + 4 >> 2] = 0;
 HEAP32[i96 + 8 >> 2] = 0;
 HEAP32[i96 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i122 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i122 + 44 >> 2] | 0;
 if ((i1 | 0) == (i122 + 48 | 0)) {
  STACKTOP = i123;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i123;
 return;
}
function __ZN2cv4gemmERKNS_11_InputArrayES2_dS2_dRKNS_12_OutputArrayEi(i12, i11, d92, i1, d93, i8, i7) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 d92 = +d92;
 i1 = i1 | 0;
 d93 = +d93;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, d100 = 0.0, d101 = 0.0, d102 = 0.0, d103 = 0.0, d104 = 0.0, d105 = 0.0, d106 = 0.0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, i114 = 0, i115 = 0, i116 = 0;
 i99 = STACKTOP;
 STACKTOP = STACKTOP + 1616 | 0;
 i98 = i99 + 1552 | 0;
 i97 = i99 + 1496 | 0;
 i95 = i99 + 1440 | 0;
 i19 = i99 + 1432 | 0;
 i28 = i99 + 1424 | 0;
 i27 = i99 + 1416 | 0;
 i26 = i99 + 1408 | 0;
 i25 = i99 + 1400 | 0;
 i23 = i99 + 1392 | 0;
 i94 = i99 + 1336 | 0;
 i10 = i99 + 1316 | 0;
 i9 = i99 + 1296 | 0;
 i87 = i99 + 1240 | 0;
 i86 = i99 + 200 | 0;
 i2 = i99 + 192 | 0;
 i22 = i99 + 136 | 0;
 i31 = i99 + 128 | 0;
 i32 = i99 + 120 | 0;
 i50 = i99 + 64 | 0;
 i80 = i99 + 56 | 0;
 i81 = i99 + 48 | 0;
 i82 = i99 + 40 | 0;
 i83 = i99 + 32 | 0;
 i84 = i99 + 24 | 0;
 i85 = i99;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i12 >> 2] >> 2] & 63](i98, i12, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i11 >> 2] >> 2] & 63](i97, i11, -1);
 if (d93 != 0.0) FUNCTION_TABLE_viii[HEAP32[HEAP32[i1 >> 2] >> 2] & 63](i95, i1, -1); else {
  HEAP32[i95 >> 2] = 1124007936;
  i12 = i95 + 8 | 0;
  i11 = i95 + 40 | 0;
  i6 = i95 + 4 | 0;
  i5 = i6 + 36 | 0;
  do {
   HEAP32[i6 >> 2] = 0;
   i6 = i6 + 4 | 0;
  } while ((i6 | 0) < (i5 | 0));
  HEAP32[i11 >> 2] = i12;
  i96 = i95 + 48 | 0;
  HEAP32[i95 + 44 >> 2] = i96;
  HEAP32[i95 + 52 >> 2] = 0;
  HEAP32[i96 >> 2] = 0;
 }
 i96 = i98 + 40 | 0;
 i21 = HEAP32[i96 >> 2] | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i21 = HEAP32[i21 >> 2] | 0;
 i11 = HEAP32[i98 >> 2] | 0;
 i49 = i11 & 4095;
 if (!((i49 | 0) == (HEAP32[i97 >> 2] & 4095 | 0) ? (i49 | 0) == 5 | (i49 | 0) == 6 | (i49 | 0) == 13 | (i49 | 0) == 14 : 0)) {
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  i6 = (__ZN2cv6String8allocateEj(i19, 98) | 0) + 0 | 0;
  i24 = 37144 | 0;
  i5 = i6 + 98 | 0;
  do {
   HEAP8[i6 >> 0] = HEAP8[i24 >> 0] | 0;
   i6 = i6 + 1 | 0;
   i24 = i24 + 1 | 0;
  } while ((i6 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i19, 37248, 37256, 882);
  __ZN2cv6String10deallocateEv(i19);
 }
 i18 = i7 & 3;
 if ((i18 | 0) == 3) {
  i18 = HEAP32[i97 + 8 >> 2] | 0;
  i19 = HEAP32[i97 + 12 >> 2] | 0;
  if ((i21 | 0) == (i19 | 0)) {
   i89 = i18;
   i19 = i21;
   i88 = i20;
  } else {
   HEAP32[i25 >> 2] = 0;
   HEAP32[i25 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i25, 20) | 0) + 0 | 0;
   i24 = 37336 | 0;
   i5 = i6 + 20 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i24 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i24 = i24 + 1 | 0;
   } while ((i6 | 0) < (i5 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i25, 37248, 37256, 904);
   __ZN2cv6String10deallocateEv(i25);
   i89 = i18;
   i88 = i20;
  }
 } else if ((i18 | 0) == 1) {
  i18 = HEAP32[i97 + 12 >> 2] | 0;
  i19 = HEAP32[i97 + 8 >> 2] | 0;
  if ((i21 | 0) == (i19 | 0)) {
   i89 = i18;
   i19 = i21;
   i88 = i20;
  } else {
   HEAP32[i27 >> 2] = 0;
   HEAP32[i27 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i27, 20) | 0) + 0 | 0;
   i24 = 37336 | 0;
   i5 = i6 + 20 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i24 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i24 = i24 + 1 | 0;
   } while ((i6 | 0) < (i5 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i27, 37248, 37256, 894);
   __ZN2cv6String10deallocateEv(i27);
   i89 = i18;
   i88 = i20;
  }
 } else if (!i18) {
  i18 = HEAP32[i97 + 12 >> 2] | 0;
  i19 = HEAP32[i97 + 8 >> 2] | 0;
  if ((i20 | 0) == (i19 | 0)) {
   i89 = i18;
   i19 = i20;
   i88 = i21;
  } else {
   HEAP32[i28 >> 2] = 0;
   HEAP32[i28 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i28, 19) | 0) + 0 | 0;
   i24 = 37312 | 0;
   i5 = i6 + 19 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i24 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i24 = i24 + 1 | 0;
   } while ((i6 | 0) < (i5 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i28, 37248, 37256, 889);
   __ZN2cv6String10deallocateEv(i28);
   i89 = i18;
   i88 = i21;
  }
 } else if ((i18 | 0) == 2) {
  i18 = HEAP32[i97 + 8 >> 2] | 0;
  i19 = HEAP32[i97 + 12 >> 2] | 0;
  if ((i20 | 0) == (i19 | 0)) {
   i89 = i18;
   i19 = i20;
   i88 = i21;
  } else {
   HEAP32[i26 >> 2] = 0;
   HEAP32[i26 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i26, 19) | 0) + 0 | 0;
   i24 = 37312 | 0;
   i5 = i6 + 19 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i24 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i24 = i24 + 1 | 0;
   } while ((i6 | 0) < (i5 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i26, 37248, 37256, 899);
   __ZN2cv6String10deallocateEv(i26);
   i89 = i18;
   i88 = i21;
  }
 } else {
  i89 = 0;
  i19 = 0;
  i88 = 0;
 }
 i91 = i95 + 16 | 0;
 L20 : do if (HEAP32[i91 >> 2] | 0) {
  i18 = HEAP32[i95 + 4 >> 2] | 0;
  if ((i18 | 0) < 3) i17 = Math_imul(HEAP32[i95 + 12 >> 2] | 0, HEAP32[i95 + 8 >> 2] | 0) | 0; else {
   i16 = HEAP32[i95 + 40 >> 2] | 0;
   i15 = 0;
   i17 = 1;
   do {
    i17 = Math_imul(HEAP32[i16 + (i15 << 2) >> 2] | 0, i17) | 0;
    i15 = i15 + 1 | 0;
   } while ((i15 | 0) != (i18 | 0));
  }
  if (i17) {
   do if ((HEAP32[i95 >> 2] & 4095 | 0) == (i49 | 0)) {
    i18 = HEAP32[i95 + 8 >> 2] | 0;
    if (!(i7 & 4)) {
     if ((i18 | 0) != (i88 | 0)) break;
     if ((HEAP32[i95 + 12 >> 2] | 0) == (i89 | 0)) break L20; else break;
    } else {
     if ((i18 | 0) != (i89 | 0)) break;
     if ((HEAP32[i95 + 12 >> 2] | 0) == (i88 | 0)) break L20; else break;
    }
   } while (0);
   HEAP32[i23 >> 2] = 0;
   HEAP32[i23 + 4 >> 2] = 0;
   _memcpy(__ZN2cv6String8allocateEj(i23, 178) | 0, 37360, 178) | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i23, 37248, 37256, 912);
   __ZN2cv6String10deallocateEv(i23);
  }
 } while (0);
 FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i8 >> 2] | 0) + 140 >> 2] & 63](i8, i88, i89, i49, -1, 0, 0);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i8 >> 2] >> 2] & 63](i94, i8, -1);
 if ((i7 & 4 | 0) != 0 ? (HEAP32[i91 >> 2] | 0) == (HEAP32[i94 + 16 >> 2] | 0) : 0) {
  HEAP32[i10 >> 2] = 32088;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAP32[i10 + 16 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 16842752;
  HEAP32[i10 + 8 >> 2] = i95;
  i79 = i9 + 4 | 0;
  HEAP32[i79 + 0 >> 2] = 0;
  HEAP32[i79 + 4 >> 2] = 0;
  HEAP32[i79 + 8 >> 2] = 0;
  HEAP32[i79 + 12 >> 2] = 0;
  HEAP32[i9 >> 2] = 32232;
  HEAP32[i79 >> 2] = 33619968;
  HEAP32[i9 + 8 >> 2] = i95;
  __ZN2cv9transposeERKNS_11_InputArrayERKNS_12_OutputArrayE(i10, i9);
  i7 = i7 & -5;
 }
 L42 : do if ((i7 | 0) == 0 & (i19 | 0) > 1 & (i19 | 0) < 5 ? (i19 | 0) == (i89 | 0) | (i19 | 0) == (i88 | 0) : 0) if ((i49 | 0) == 6) {
  i3 = HEAP32[i94 + 16 >> 2] | 0;
  i4 = HEAP32[i98 + 16 >> 2] | 0;
  i33 = HEAP32[i97 + 16 >> 2] | 0;
  i18 = HEAP32[i91 >> 2] | 0;
  i34 = (HEAP32[i94 + 48 >> 2] | 0) >>> 3;
  i29 = (HEAP32[i98 + 48 >> 2] | 0) >>> 3;
  i30 = (HEAP32[i97 + 48 >> 2] | 0) >>> 3;
  i17 = (i18 | 0) == 0;
  if (i17) i28 = 0; else i28 = (HEAP32[i95 + 48 >> 2] | 0) >>> 3;
  i1 = i17 ? 37096 : i18;
  if ((i19 | 0) == 3) {
   if (!((i89 | 0) != 3 | (i33 | 0) == (i3 | 0))) {
    if ((i88 | 0) <= 0) break;
    i12 = i33 + (i30 << 3) | 0;
    i8 = i30 << 1;
    i11 = i33 + (i8 << 3) | 0;
    i2 = i33 + 8 | 0;
    i5 = i33 + (i30 + 1 << 3) | 0;
    i6 = i33 + ((i8 | 1) << 3) | 0;
    i7 = i33 + 16 | 0;
    i10 = i33 + (i30 + 2 << 3) | 0;
    i8 = i33 + (i8 + 2 << 3) | 0;
    i9 = 0;
    while (1) {
     d104 = +HEAPF64[i4 >> 3];
     d103 = +HEAPF64[i4 + 8 >> 3];
     d102 = +HEAPF64[i4 + 16 >> 3];
     d101 = d104 * +HEAPF64[i2 >> 3] + d103 * +HEAPF64[i5 >> 3] + d102 * +HEAPF64[i6 >> 3];
     d100 = d104 * +HEAPF64[i7 >> 3] + d103 * +HEAPF64[i10 >> 3] + d102 * +HEAPF64[i8 >> 3];
     HEAPF64[i3 >> 3] = (d104 * +HEAPF64[i33 >> 3] + d103 * +HEAPF64[i12 >> 3] + d102 * +HEAPF64[i11 >> 3]) * d92 + +HEAPF64[i1 >> 3] * d93;
     HEAPF64[i3 + 8 >> 3] = d101 * d92 + +HEAPF64[i1 + 8 >> 3] * d93;
     HEAPF64[i3 + 16 >> 3] = d100 * d92 + +HEAPF64[i1 + 16 >> 3] * d93;
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i88 | 0)) break L42; else {
      i4 = i4 + (i29 << 3) | 0;
      i1 = i1 + (i28 << 3) | 0;
      i3 = i3 + (i34 << 3) | 0;
     }
    }
   }
   if ((i4 | 0) == (i3 | 0)) {
    i90 = 89;
    break;
   }
   i9 = (i1 | 0) == 37096;
   i18 = i9 & 1 ^ 1;
   i9 = i9 ? 1 : i28;
   if ((i89 | 0) <= 0) break;
   i17 = i4 + 8 | 0;
   i16 = i4 + 16 | 0;
   i15 = i30 << 1;
   i14 = i4 + (i29 << 3) | 0;
   i13 = i4 + (i29 + 1 << 3) | 0;
   i10 = i4 + (i29 + 2 << 3) | 0;
   i6 = i29 << 1;
   i2 = i4 + (i6 << 3) | 0;
   i5 = i4 + ((i6 | 1) << 3) | 0;
   i6 = i4 + (i6 + 2 << 3) | 0;
   i7 = i9 << 1;
   i8 = i34 << 1;
   i11 = i33;
   i12 = 0;
   while (1) {
    d102 = +HEAPF64[i11 >> 3];
    d101 = +HEAPF64[i11 + (i30 << 3) >> 3];
    d100 = +HEAPF64[i11 + (i15 << 3) >> 3];
    d104 = d102 * +HEAPF64[i14 >> 3] + d101 * +HEAPF64[i13 >> 3] + d100 * +HEAPF64[i10 >> 3];
    d103 = d102 * +HEAPF64[i2 >> 3] + d101 * +HEAPF64[i5 >> 3] + d100 * +HEAPF64[i6 >> 3];
    HEAPF64[i3 >> 3] = (+HEAPF64[i4 >> 3] * d102 + +HEAPF64[i17 >> 3] * d101 + +HEAPF64[i16 >> 3] * d100) * d92 + +HEAPF64[i1 >> 3] * d93;
    HEAPF64[i3 + (i34 << 3) >> 3] = d104 * d92 + +HEAPF64[i1 + (i9 << 3) >> 3] * d93;
    HEAPF64[i3 + (i8 << 3) >> 3] = d103 * d92 + +HEAPF64[i1 + (i7 << 3) >> 3] * d93;
    i12 = i12 + 1 | 0;
    if ((i12 | 0) == (i89 | 0)) break; else {
     i11 = i11 + 8 | 0;
     i1 = i1 + (i18 << 3) | 0;
     i3 = i3 + 8 | 0;
    }
   }
  } else if ((i19 | 0) == 4) {
   if (!((i89 | 0) != 4 | (i33 | 0) == (i3 | 0))) {
    if ((i88 | 0) <= 0) break;
    i19 = i33 + (i30 << 3) | 0;
    i17 = i30 << 1;
    i15 = i33 + (i17 << 3) | 0;
    i16 = i30 * 3 | 0;
    i14 = i33 + (i16 << 3) | 0;
    i13 = i33 + 8 | 0;
    i11 = i33 + (i30 + 1 << 3) | 0;
    i2 = i33 + ((i17 | 1) << 3) | 0;
    i5 = i33 + (i16 + 1 << 3) | 0;
    i6 = i33 + 16 | 0;
    i7 = i33 + (i30 + 2 << 3) | 0;
    i8 = i33 + (i17 + 2 << 3) | 0;
    i9 = i33 + (i16 + 2 << 3) | 0;
    i10 = i33 + 24 | 0;
    i18 = i33 + (i30 + 3 << 3) | 0;
    i17 = i33 + (i17 + 3 << 3) | 0;
    i16 = i33 + (i16 + 3 << 3) | 0;
    i12 = 0;
    while (1) {
     d106 = +HEAPF64[i4 >> 3];
     d105 = +HEAPF64[i4 + 8 >> 3];
     d102 = +HEAPF64[i4 + 16 >> 3];
     d101 = +HEAPF64[i4 + 24 >> 3];
     d100 = d106 * +HEAPF64[i13 >> 3] + d105 * +HEAPF64[i11 >> 3] + d102 * +HEAPF64[i2 >> 3] + d101 * +HEAPF64[i5 >> 3];
     d104 = d106 * +HEAPF64[i6 >> 3] + d105 * +HEAPF64[i7 >> 3] + d102 * +HEAPF64[i8 >> 3] + d101 * +HEAPF64[i9 >> 3];
     d103 = d106 * +HEAPF64[i10 >> 3] + d105 * +HEAPF64[i18 >> 3] + d102 * +HEAPF64[i17 >> 3] + d101 * +HEAPF64[i16 >> 3];
     HEAPF64[i3 >> 3] = (d106 * +HEAPF64[i33 >> 3] + d105 * +HEAPF64[i19 >> 3] + d102 * +HEAPF64[i15 >> 3] + d101 * +HEAPF64[i14 >> 3]) * d92 + +HEAPF64[i1 >> 3] * d93;
     HEAPF64[i3 + 8 >> 3] = d100 * d92 + +HEAPF64[i1 + 8 >> 3] * d93;
     HEAPF64[i3 + 16 >> 3] = d104 * d92 + +HEAPF64[i1 + 16 >> 3] * d93;
     HEAPF64[i3 + 24 >> 3] = d103 * d92 + +HEAPF64[i1 + 24 >> 3] * d93;
     i12 = i12 + 1 | 0;
     if ((i12 | 0) == (i88 | 0)) break L42; else {
      i4 = i4 + (i29 << 3) | 0;
      i1 = i1 + (i28 << 3) | 0;
      i3 = i3 + (i34 << 3) | 0;
     }
    }
   }
   if ((i89 | 0) > 16 | (i4 | 0) == (i3 | 0)) {
    i90 = 89;
    break;
   }
   i6 = (i1 | 0) == 37096;
   i5 = i6 ? 1 : i28;
   i6 = i6 & 1 ^ 1;
   if ((i89 | 0) <= 0) break;
   i27 = i4 + 8 | 0;
   i26 = i4 + 16 | 0;
   i25 = i30 << 1;
   i24 = i4 + 24 | 0;
   i23 = i30 * 3 | 0;
   i10 = i4 + (i29 << 3) | 0;
   i9 = i4 + (i29 + 1 << 3) | 0;
   i8 = i4 + (i29 + 2 << 3) | 0;
   i7 = i4 + (i29 + 3 << 3) | 0;
   i28 = i29 << 1;
   i20 = i4 + (i28 << 3) | 0;
   i21 = i4 + ((i28 | 1) << 3) | 0;
   i22 = i4 + (i28 + 2 << 3) | 0;
   i28 = i4 + (i28 + 3 << 3) | 0;
   i14 = i29 * 3 | 0;
   i17 = i4 + (i14 << 3) | 0;
   i16 = i4 + (i14 + 1 << 3) | 0;
   i15 = i4 + (i14 + 2 << 3) | 0;
   i14 = i4 + (i14 + 3 << 3) | 0;
   i13 = i5 << 1;
   i12 = i34 << 1;
   i11 = i5 * 3 | 0;
   i2 = i34 * 3 | 0;
   i18 = i33;
   i19 = 0;
   while (1) {
    d106 = +HEAPF64[i18 >> 3];
    d105 = +HEAPF64[i18 + (i30 << 3) >> 3];
    d102 = +HEAPF64[i18 + (i25 << 3) >> 3];
    d101 = +HEAPF64[i18 + (i23 << 3) >> 3];
    d100 = d106 * +HEAPF64[i10 >> 3] + d105 * +HEAPF64[i9 >> 3] + d102 * +HEAPF64[i8 >> 3] + d101 * +HEAPF64[i7 >> 3];
    d104 = d106 * +HEAPF64[i20 >> 3] + d105 * +HEAPF64[i21 >> 3] + d102 * +HEAPF64[i22 >> 3] + d101 * +HEAPF64[i28 >> 3];
    d103 = d106 * +HEAPF64[i17 >> 3] + d105 * +HEAPF64[i16 >> 3] + d102 * +HEAPF64[i15 >> 3] + d101 * +HEAPF64[i14 >> 3];
    HEAPF64[i3 >> 3] = (+HEAPF64[i4 >> 3] * d106 + +HEAPF64[i27 >> 3] * d105 + +HEAPF64[i26 >> 3] * d102 + +HEAPF64[i24 >> 3] * d101) * d92 + +HEAPF64[i1 >> 3] * d93;
    HEAPF64[i3 + (i34 << 3) >> 3] = d100 * d92 + +HEAPF64[i1 + (i5 << 3) >> 3] * d93;
    HEAPF64[i3 + (i12 << 3) >> 3] = d104 * d92 + +HEAPF64[i1 + (i13 << 3) >> 3] * d93;
    HEAPF64[i3 + (i2 << 3) >> 3] = d103 * d92 + +HEAPF64[i1 + (i11 << 3) >> 3] * d93;
    i19 = i19 + 1 | 0;
    if ((i19 | 0) == (i89 | 0)) break; else {
     i18 = i18 + 8 | 0;
     i1 = i1 + (i6 << 3) | 0;
     i3 = i3 + 8 | 0;
    }
   }
  } else if ((i19 | 0) == 2) {
   if (!((i89 | 0) != 2 | (i33 | 0) == (i3 | 0))) {
    if ((i88 | 0) <= 0) break;
    i7 = i33 + (i30 << 3) | 0;
    i6 = i33 + 8 | 0;
    i5 = i33 + (i30 + 1 << 3) | 0;
    i2 = 0;
    while (1) {
     d100 = +HEAPF64[i4 >> 3];
     d104 = +HEAPF64[i4 + 8 >> 3];
     d103 = d100 * +HEAPF64[i6 >> 3] + d104 * +HEAPF64[i5 >> 3];
     HEAPF64[i3 >> 3] = (d100 * +HEAPF64[i33 >> 3] + d104 * +HEAPF64[i7 >> 3]) * d92 + +HEAPF64[i1 >> 3] * d93;
     HEAPF64[i3 + 8 >> 3] = d103 * d92 + +HEAPF64[i1 + 8 >> 3] * d93;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i88 | 0)) break L42; else {
      i4 = i4 + (i29 << 3) | 0;
      i1 = i1 + (i28 << 3) | 0;
      i3 = i3 + (i34 << 3) | 0;
     }
    }
   }
   if ((i4 | 0) == (i3 | 0)) {
    i90 = 89;
    break;
   }
   i6 = (i1 | 0) == 37096;
   i10 = i6 & 1 ^ 1;
   i6 = i6 ? 1 : i28;
   if ((i89 | 0) <= 0) break;
   i9 = i4 + 8 | 0;
   i8 = i4 + (i29 << 3) | 0;
   i7 = i4 + (i29 + 1 << 3) | 0;
   i5 = i33;
   i2 = 0;
   while (1) {
    d100 = +HEAPF64[i5 >> 3];
    d104 = +HEAPF64[i5 + (i30 << 3) >> 3];
    d103 = d100 * +HEAPF64[i8 >> 3] + d104 * +HEAPF64[i7 >> 3];
    HEAPF64[i3 >> 3] = (+HEAPF64[i4 >> 3] * d100 + +HEAPF64[i9 >> 3] * d104) * d92 + +HEAPF64[i1 >> 3] * d93;
    HEAPF64[i3 + (i34 << 3) >> 3] = d103 * d92 + +HEAPF64[i1 + (i6 << 3) >> 3] * d93;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i89 | 0)) break; else {
     i5 = i5 + 8 | 0;
     i1 = i1 + (i10 << 3) | 0;
     i3 = i3 + 8 | 0;
    }
   }
  } else {
   i90 = 89;
   break;
  }
 } else if ((i49 | 0) == 5) {
  i3 = HEAP32[i94 + 16 >> 2] | 0;
  i4 = HEAP32[i98 + 16 >> 2] | 0;
  i33 = HEAP32[i97 + 16 >> 2] | 0;
  i18 = HEAP32[i91 >> 2] | 0;
  i34 = (HEAP32[i94 + 48 >> 2] | 0) >>> 2;
  i29 = (HEAP32[i98 + 48 >> 2] | 0) >>> 2;
  i30 = (HEAP32[i97 + 48 >> 2] | 0) >>> 2;
  i17 = (i18 | 0) == 0;
  if (i17) i27 = 0; else i27 = (HEAP32[i95 + 48 >> 2] | 0) >>> 2;
  i1 = i17 ? 37128 : i18;
  if ((i19 | 0) == 2) {
   if (!((i89 | 0) != 2 | (i33 | 0) == (i3 | 0))) {
    if ((i88 | 0) <= 0) break;
    i6 = i33 + (i30 << 2) | 0;
    i7 = i33 + 4 | 0;
    i5 = i33 + (i30 + 1 << 2) | 0;
    i2 = 0;
    while (1) {
     f109 = Math_fround(HEAPF32[i4 >> 2]);
     f108 = Math_fround(f109 * Math_fround(HEAPF32[i33 >> 2]));
     f107 = Math_fround(HEAPF32[i4 + 4 >> 2]);
     f108 = Math_fround(f108 + Math_fround(f107 * Math_fround(HEAPF32[i6 >> 2])));
     f109 = Math_fround(f109 * Math_fround(HEAPF32[i7 >> 2]));
     f107 = Math_fround(f109 + Math_fround(f107 * Math_fround(HEAPF32[i5 >> 2])));
     HEAPF32[i3 >> 2] = Math_fround(+f108 * d92 + +Math_fround(HEAPF32[i1 >> 2]) * d93);
     HEAPF32[i3 + 4 >> 2] = Math_fround(+f107 * d92 + +Math_fround(HEAPF32[i1 + 4 >> 2]) * d93);
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i88 | 0)) break L42; else {
      i4 = i4 + (i29 << 2) | 0;
      i1 = i1 + (i27 << 2) | 0;
      i3 = i3 + (i34 << 2) | 0;
     }
    }
   }
   if ((i4 | 0) == (i3 | 0)) {
    i90 = 89;
    break;
   }
   i6 = (i1 | 0) == 37128;
   i10 = i6 & 1 ^ 1;
   i6 = i6 ? 1 : i27;
   if ((i89 | 0) <= 0) break;
   i8 = i4 + 4 | 0;
   i9 = i4 + (i29 << 2) | 0;
   i7 = i4 + (i29 + 1 << 2) | 0;
   i5 = i33;
   i2 = 0;
   while (1) {
    f110 = Math_fround(HEAPF32[i4 >> 2]);
    f109 = Math_fround(HEAPF32[i5 >> 2]);
    f110 = Math_fround(f110 * f109);
    f108 = Math_fround(HEAPF32[i8 >> 2]);
    f107 = Math_fround(HEAPF32[i5 + (i30 << 2) >> 2]);
    f108 = Math_fround(f110 + Math_fround(f108 * f107));
    f109 = Math_fround(f109 * Math_fround(HEAPF32[i9 >> 2]));
    f107 = Math_fround(f109 + Math_fround(f107 * Math_fround(HEAPF32[i7 >> 2])));
    HEAPF32[i3 >> 2] = Math_fround(+f108 * d92 + +Math_fround(HEAPF32[i1 >> 2]) * d93);
    HEAPF32[i3 + (i34 << 2) >> 2] = Math_fround(+f107 * d92 + +Math_fround(HEAPF32[i1 + (i6 << 2) >> 2]) * d93);
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i89 | 0)) break; else {
     i5 = i5 + 4 | 0;
     i1 = i1 + (i10 << 2) | 0;
     i3 = i3 + 4 | 0;
    }
   }
  } else if ((i19 | 0) == 4) {
   if (!((i89 | 0) != 4 | (i33 | 0) == (i3 | 0))) {
    if ((i88 | 0) <= 0) break;
    i15 = i33 + (i30 << 2) | 0;
    i17 = i30 << 1;
    i14 = i33 + (i17 << 2) | 0;
    i16 = i30 * 3 | 0;
    i13 = i33 + (i16 << 2) | 0;
    i11 = i33 + 4 | 0;
    i2 = i33 + (i30 + 1 << 2) | 0;
    i5 = i33 + ((i17 | 1) << 2) | 0;
    i6 = i33 + (i16 + 1 << 2) | 0;
    i7 = i33 + 8 | 0;
    i8 = i33 + (i30 + 2 << 2) | 0;
    i9 = i33 + (i17 + 2 << 2) | 0;
    i10 = i33 + (i16 + 2 << 2) | 0;
    i19 = i33 + 12 | 0;
    i18 = i33 + (i30 + 3 << 2) | 0;
    i17 = i33 + (i17 + 3 << 2) | 0;
    i16 = i33 + (i16 + 3 << 2) | 0;
    i12 = 0;
    while (1) {
     f113 = Math_fround(HEAPF32[i4 >> 2]);
     f110 = Math_fround(f113 * Math_fround(HEAPF32[i33 >> 2]));
     f112 = Math_fround(HEAPF32[i4 + 4 >> 2]);
     f110 = Math_fround(f110 + Math_fround(f112 * Math_fround(HEAPF32[i15 >> 2])));
     f111 = Math_fround(HEAPF32[i4 + 8 >> 2]);
     f110 = Math_fround(f110 + Math_fround(f111 * Math_fround(HEAPF32[i14 >> 2])));
     f107 = Math_fround(HEAPF32[i4 + 12 >> 2]);
     f110 = Math_fround(f110 + Math_fround(f107 * Math_fround(HEAPF32[i13 >> 2])));
     f109 = Math_fround(f113 * Math_fround(HEAPF32[i11 >> 2]));
     f109 = Math_fround(f109 + Math_fround(f112 * Math_fround(HEAPF32[i2 >> 2])));
     f109 = Math_fround(f109 + Math_fround(f111 * Math_fround(HEAPF32[i5 >> 2])));
     f109 = Math_fround(f109 + Math_fround(f107 * Math_fround(HEAPF32[i6 >> 2])));
     f108 = Math_fround(f113 * Math_fround(HEAPF32[i7 >> 2]));
     f108 = Math_fround(f108 + Math_fround(f112 * Math_fround(HEAPF32[i8 >> 2])));
     f108 = Math_fround(f108 + Math_fround(f111 * Math_fround(HEAPF32[i9 >> 2])));
     f108 = Math_fround(f108 + Math_fround(f107 * Math_fround(HEAPF32[i10 >> 2])));
     f113 = Math_fround(f113 * Math_fround(HEAPF32[i19 >> 2]));
     f112 = Math_fround(f113 + Math_fround(f112 * Math_fround(HEAPF32[i18 >> 2])));
     f111 = Math_fround(f112 + Math_fround(f111 * Math_fround(HEAPF32[i17 >> 2])));
     f107 = Math_fround(f111 + Math_fround(f107 * Math_fround(HEAPF32[i16 >> 2])));
     HEAPF32[i3 >> 2] = Math_fround(+f110 * d92 + +Math_fround(HEAPF32[i1 >> 2]) * d93);
     HEAPF32[i3 + 4 >> 2] = Math_fround(+f109 * d92 + +Math_fround(HEAPF32[i1 + 4 >> 2]) * d93);
     HEAPF32[i3 + 8 >> 2] = Math_fround(+f108 * d92 + +Math_fround(HEAPF32[i1 + 8 >> 2]) * d93);
     HEAPF32[i3 + 12 >> 2] = Math_fround(+f107 * d92 + +Math_fround(HEAPF32[i1 + 12 >> 2]) * d93);
     i12 = i12 + 1 | 0;
     if ((i12 | 0) == (i88 | 0)) break L42; else {
      i4 = i4 + (i29 << 2) | 0;
      i1 = i1 + (i27 << 2) | 0;
      i3 = i3 + (i34 << 2) | 0;
     }
    }
   }
   if ((i4 | 0) == (i3 | 0)) {
    i90 = 89;
    break;
   }
   i5 = (i1 | 0) == 37128;
   i28 = i5 & 1 ^ 1;
   i5 = i5 ? 1 : i27;
   if ((i89 | 0) <= 0) break;
   i6 = i4 + 4 | 0;
   i7 = i4 + 8 | 0;
   i8 = i30 << 1;
   i9 = i4 + 12 | 0;
   i10 = i30 * 3 | 0;
   i20 = i4 + (i29 << 2) | 0;
   i21 = i4 + (i29 + 1 << 2) | 0;
   i22 = i4 + (i29 + 2 << 2) | 0;
   i23 = i4 + (i29 + 3 << 2) | 0;
   i27 = i29 << 1;
   i24 = i4 + (i27 << 2) | 0;
   i25 = i4 + ((i27 | 1) << 2) | 0;
   i26 = i4 + (i27 + 2 << 2) | 0;
   i27 = i4 + (i27 + 3 << 2) | 0;
   i14 = i29 * 3 | 0;
   i17 = i4 + (i14 << 2) | 0;
   i16 = i4 + (i14 + 1 << 2) | 0;
   i15 = i4 + (i14 + 2 << 2) | 0;
   i14 = i4 + (i14 + 3 << 2) | 0;
   i13 = i5 << 1;
   i12 = i34 << 1;
   i11 = i5 * 3 | 0;
   i2 = i34 * 3 | 0;
   i18 = i33;
   i19 = 0;
   while (1) {
    f109 = Math_fround(HEAPF32[i4 >> 2]);
    f113 = Math_fround(HEAPF32[i18 >> 2]);
    f109 = Math_fround(f109 * f113);
    f110 = Math_fround(HEAPF32[i6 >> 2]);
    f112 = Math_fround(HEAPF32[i18 + (i30 << 2) >> 2]);
    f110 = Math_fround(f109 + Math_fround(f110 * f112));
    f109 = Math_fround(HEAPF32[i7 >> 2]);
    f111 = Math_fround(HEAPF32[i18 + (i8 << 2) >> 2]);
    f109 = Math_fround(f110 + Math_fround(f109 * f111));
    f110 = Math_fround(HEAPF32[i9 >> 2]);
    f107 = Math_fround(HEAPF32[i18 + (i10 << 2) >> 2]);
    f110 = Math_fround(f109 + Math_fround(f110 * f107));
    f109 = Math_fround(f113 * Math_fround(HEAPF32[i20 >> 2]));
    f109 = Math_fround(f109 + Math_fround(f112 * Math_fround(HEAPF32[i21 >> 2])));
    f109 = Math_fround(f109 + Math_fround(f111 * Math_fround(HEAPF32[i22 >> 2])));
    f109 = Math_fround(f109 + Math_fround(f107 * Math_fround(HEAPF32[i23 >> 2])));
    f108 = Math_fround(f113 * Math_fround(HEAPF32[i24 >> 2]));
    f108 = Math_fround(f108 + Math_fround(f112 * Math_fround(HEAPF32[i25 >> 2])));
    f108 = Math_fround(f108 + Math_fround(f111 * Math_fround(HEAPF32[i26 >> 2])));
    f108 = Math_fround(f108 + Math_fround(f107 * Math_fround(HEAPF32[i27 >> 2])));
    f113 = Math_fround(f113 * Math_fround(HEAPF32[i17 >> 2]));
    f112 = Math_fround(f113 + Math_fround(f112 * Math_fround(HEAPF32[i16 >> 2])));
    f111 = Math_fround(f112 + Math_fround(f111 * Math_fround(HEAPF32[i15 >> 2])));
    f107 = Math_fround(f111 + Math_fround(f107 * Math_fround(HEAPF32[i14 >> 2])));
    HEAPF32[i3 >> 2] = Math_fround(+f110 * d92 + +Math_fround(HEAPF32[i1 >> 2]) * d93);
    HEAPF32[i3 + (i34 << 2) >> 2] = Math_fround(+f109 * d92 + +Math_fround(HEAPF32[i1 + (i5 << 2) >> 2]) * d93);
    HEAPF32[i3 + (i12 << 2) >> 2] = Math_fround(+f108 * d92 + +Math_fround(HEAPF32[i1 + (i13 << 2) >> 2]) * d93);
    HEAPF32[i3 + (i2 << 2) >> 2] = Math_fround(+f107 * d92 + +Math_fround(HEAPF32[i1 + (i11 << 2) >> 2]) * d93);
    i19 = i19 + 1 | 0;
    if ((i19 | 0) == (i89 | 0)) break; else {
     i18 = i18 + 4 | 0;
     i1 = i1 + (i28 << 2) | 0;
     i3 = i3 + 4 | 0;
    }
   }
  } else if ((i19 | 0) == 3) {
   if (!((i89 | 0) != 3 | (i33 | 0) == (i3 | 0))) {
    if ((i88 | 0) <= 0) break;
    i7 = i33 + (i30 << 2) | 0;
    i8 = i30 << 1;
    i6 = i33 + (i8 << 2) | 0;
    i5 = i33 + 4 | 0;
    i2 = i33 + (i30 + 1 << 2) | 0;
    i11 = i33 + ((i8 | 1) << 2) | 0;
    i12 = i33 + 8 | 0;
    i10 = i33 + (i30 + 2 << 2) | 0;
    i8 = i33 + (i8 + 2 << 2) | 0;
    i9 = 0;
    while (1) {
     f111 = Math_fround(HEAPF32[i4 >> 2]);
     f109 = Math_fround(f111 * Math_fround(HEAPF32[i33 >> 2]));
     f110 = Math_fround(HEAPF32[i4 + 4 >> 2]);
     f109 = Math_fround(f109 + Math_fround(f110 * Math_fround(HEAPF32[i7 >> 2])));
     f107 = Math_fround(HEAPF32[i4 + 8 >> 2]);
     f109 = Math_fround(f109 + Math_fround(f107 * Math_fround(HEAPF32[i6 >> 2])));
     f108 = Math_fround(f111 * Math_fround(HEAPF32[i5 >> 2]));
     f108 = Math_fround(f108 + Math_fround(f110 * Math_fround(HEAPF32[i2 >> 2])));
     f108 = Math_fround(f108 + Math_fround(f107 * Math_fround(HEAPF32[i11 >> 2])));
     f111 = Math_fround(f111 * Math_fround(HEAPF32[i12 >> 2]));
     f110 = Math_fround(f111 + Math_fround(f110 * Math_fround(HEAPF32[i10 >> 2])));
     f107 = Math_fround(f110 + Math_fround(f107 * Math_fround(HEAPF32[i8 >> 2])));
     HEAPF32[i3 >> 2] = Math_fround(+f109 * d92 + +Math_fround(HEAPF32[i1 >> 2]) * d93);
     HEAPF32[i3 + 4 >> 2] = Math_fround(+f108 * d92 + +Math_fround(HEAPF32[i1 + 4 >> 2]) * d93);
     HEAPF32[i3 + 8 >> 2] = Math_fround(+f107 * d92 + +Math_fround(HEAPF32[i1 + 8 >> 2]) * d93);
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i88 | 0)) break L42; else {
      i4 = i4 + (i29 << 2) | 0;
      i1 = i1 + (i27 << 2) | 0;
      i3 = i3 + (i34 << 2) | 0;
     }
    }
   }
   if ((i4 | 0) == (i3 | 0)) {
    i90 = 89;
    break;
   }
   i9 = (i1 | 0) == 37128;
   i18 = i9 & 1 ^ 1;
   i9 = i9 ? 1 : i27;
   if ((i89 | 0) <= 0) break;
   i10 = i4 + 4 | 0;
   i13 = i4 + 8 | 0;
   i14 = i30 << 1;
   i15 = i4 + (i29 << 2) | 0;
   i16 = i4 + (i29 + 1 << 2) | 0;
   i17 = i4 + (i29 + 2 << 2) | 0;
   i6 = i29 << 1;
   i2 = i4 + (i6 << 2) | 0;
   i5 = i4 + ((i6 | 1) << 2) | 0;
   i6 = i4 + (i6 + 2 << 2) | 0;
   i7 = i9 << 1;
   i8 = i34 << 1;
   i11 = i33;
   i12 = 0;
   while (1) {
    f109 = Math_fround(HEAPF32[i4 >> 2]);
    f111 = Math_fround(HEAPF32[i11 >> 2]);
    f109 = Math_fround(f109 * f111);
    f108 = Math_fround(HEAPF32[i10 >> 2]);
    f110 = Math_fround(HEAPF32[i11 + (i30 << 2) >> 2]);
    f108 = Math_fround(f109 + Math_fround(f108 * f110));
    f109 = Math_fround(HEAPF32[i13 >> 2]);
    f107 = Math_fround(HEAPF32[i11 + (i14 << 2) >> 2]);
    f109 = Math_fround(f108 + Math_fround(f109 * f107));
    f108 = Math_fround(f111 * Math_fround(HEAPF32[i15 >> 2]));
    f108 = Math_fround(f108 + Math_fround(f110 * Math_fround(HEAPF32[i16 >> 2])));
    f108 = Math_fround(f108 + Math_fround(f107 * Math_fround(HEAPF32[i17 >> 2])));
    f111 = Math_fround(f111 * Math_fround(HEAPF32[i2 >> 2]));
    f110 = Math_fround(f111 + Math_fround(f110 * Math_fround(HEAPF32[i5 >> 2])));
    f107 = Math_fround(f110 + Math_fround(f107 * Math_fround(HEAPF32[i6 >> 2])));
    HEAPF32[i3 >> 2] = Math_fround(+f109 * d92 + +Math_fround(HEAPF32[i1 >> 2]) * d93);
    HEAPF32[i3 + (i34 << 2) >> 2] = Math_fround(+f108 * d92 + +Math_fround(HEAPF32[i1 + (i9 << 2) >> 2]) * d93);
    HEAPF32[i3 + (i8 << 2) >> 2] = Math_fround(+f107 * d92 + +Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]) * d93);
    i12 = i12 + 1 | 0;
    if ((i12 | 0) == (i89 | 0)) break; else {
     i11 = i11 + 4 | 0;
     i1 = i1 + (i18 << 2) | 0;
     i3 = i3 + 4 | 0;
    }
   }
  } else {
   i90 = 89;
   break;
  }
 } else {
  i90 = 89;
  break;
 } else i90 = 89; while (0);
 if ((i90 | 0) == 89) {
  i28 = HEAP32[i97 + 48 >> 2] | 0;
  HEAP32[i87 >> 2] = 1124007936;
  i78 = i87 + 4 | 0;
  i18 = i87 + 8 | 0;
  i76 = i87 + 40 | 0;
  i6 = i78 + 0 | 0;
  i5 = i6 + 36 | 0;
  do {
   HEAP32[i6 >> 2] = 0;
   i6 = i6 + 4 | 0;
  } while ((i6 | 0) < (i5 | 0));
  HEAP32[i76 >> 2] = i18;
  i79 = i87 + 48 | 0;
  i77 = i87 + 44 | 0;
  HEAP32[i77 >> 2] = i79;
  HEAP32[i87 + 52 >> 2] = 0;
  HEAP32[i79 >> 2] = 0;
  i72 = HEAP32[i91 >> 2] | 0;
  if (!i72) i73 = 0; else i73 = HEAP32[i95 + 48 >> 2] | 0;
  i74 = i86 + 8 | 0;
  HEAP32[i86 >> 2] = i74;
  i75 = i86 + 4 | 0;
  HEAP32[i75 >> 2] = 1032;
  if ((i49 | 0) == 6) {
   i66 = 4;
   i71 = 2;
   i67 = 2;
  } else if ((i49 | 0) == 13) {
   i66 = 5;
   i71 = 3;
   i67 = 3;
  } else if ((i49 | 0) == 5) {
   i66 = 3;
   i71 = 1;
   i67 = 1;
  } else if ((i49 | 0) == 14) i90 = 95; else {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i2, 16) | 0) + 0 | 0;
   i24 = 37544 | 0;
   i5 = i6 + 16 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i24 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i24 = i24 + 1 | 0;
   } while ((i6 | 0) < (i5 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 37248, 37256, 1212);
   __ZN2cv6String10deallocateEv(i2);
   i90 = 95;
  }
  if ((i90 | 0) == 95) {
   i66 = 6;
   i71 = 4;
   i67 = 4;
  }
  i90 = HEAP32[i94 + 16 >> 2] | 0;
  i69 = i98 + 16 | 0;
  if ((i90 | 0) != (HEAP32[i69 >> 2] | 0) ? (i90 | 0) != (HEAP32[i97 + 16 >> 2] | 0) : 0) {
   i70 = i94;
   i8 = 0;
  } else {
   i70 = i87;
   i8 = Math_imul(Math_imul(i89, (i11 >>> 3 & 511) + 1 << (47696 >>> (i49 << 1 & 14) & 3)) | 0, i88) | 0;
  }
  i18 = (i89 | 0) == 1;
  if ((i18 | (i19 | 0) == 1) & (i7 & 2 | 0) == 0 ? (HEAP32[i97 >> 2] & 16384 | 0) != 0 : 0) {
   if (i18) i18 = 0; else i18 = (i11 >>> 3 & 511) + 1 << (47696 >>> (i49 << 1 & 14) & 3);
   i7 = i7 | 2;
   i68 = i18;
  } else i68 = i28;
  if ((i88 | 0) < 65) if ((i19 | 0) < 10001) i90 = 109; else i90 = 107; else if ((i89 | 0) < 65 & (i19 | 0) < 10001 | (i19 | 0) < 11) i90 = 109; else i90 = 107;
  do if ((i90 | 0) == 107) {
   if ((i89 | 0) < 129 ? (i88 | 0) < 129 & (i19 | 0) < 129 : 0) {
    i90 = 109;
    break;
   }
   i60 = i11 & 7;
   i59 = (i11 >>> 3 & 511) + 1 << (47696 >>> (i60 << 1) & 3);
   i60 = i59 << ((i60 | 0) == 5 & 1);
   i61 = (i7 & 1 | 0) != 0;
   i62 = i98 + 48 | 0;
   i58 = HEAP32[i62 >> 2] | 0;
   i57 = i61 ? i59 : i58;
   i58 = i61 ? i58 : i59;
   i63 = (i7 & 2 | 0) != 0;
   i64 = i63 ? i59 : i68;
   i65 = i63 ? i68 : i59;
   if (HEAP32[i91 >> 2] | 0) {
    i27 = HEAP32[i95 + 4 >> 2] | 0;
    if ((i27 | 0) < 3) i28 = Math_imul(HEAP32[i95 + 12 >> 2] | 0, HEAP32[i95 + 8 >> 2] | 0) | 0; else {
     i26 = HEAP32[i95 + 40 >> 2] | 0;
     i25 = 0;
     i28 = 1;
     do {
      i28 = Math_imul(HEAP32[i26 + (i25 << 2) >> 2] | 0, i28) | 0;
      i25 = i25 + 1 | 0;
     } while ((i25 | 0) != (i27 | 0));
    }
    if (i28) {
     i54 = (i7 & 4 | 0) == 0;
     i56 = HEAP32[i95 + 48 >> 2] | 0;
     i25 = i7;
     i55 = i54 ? i56 : i59;
     i56 = i54 ? i59 : i56;
    } else i90 = 133;
   } else i90 = 133;
   if ((i90 | 0) == 133) {
    i25 = i7 & -5;
    i55 = 0;
    i56 = 0;
   }
   i28 = (i88 | 0) < 128 ? i88 : 128;
   i27 = (i89 | 0) < 128 ? i89 : 128;
   i54 = 16384 / (i28 | 0) | 0;
   i53 = 16384 / (i27 | 0) | 0;
   i54 = (i53 | 0) < (i54 | 0) ? i53 : i54;
   i54 = (i19 | 0) < (i54 | 0) ? i19 : i54;
   if ((Math_imul(i54, i28) | 0) > 16384) i28 = 16384 / (i54 | 0) | 0;
   if ((Math_imul(i54, i27) | 0) > 16384) i27 = 16384 / (i54 | 0) | 0;
   i26 = ((i54 | 0) / 8 | 0) + i54 | 0;
   i24 = Math_imul(i26 + 1 | 0, i27 + 2 + ((i27 | 0) / 8 | 0) & -2) | 0;
   i10 = Math_imul(i24, i60) | 0;
   if (i61) {
    i25 = i25 & -2;
    i9 = Math_imul(Math_imul(i26 + 2 & -2, i59) | 0, i28 + 1 + ((i28 | 0) / 8 | 0) | 0) | 0;
   } else i9 = 0;
   i23 = Math_imul(i24, i60 + i59 | 0) | 0;
   i26 = i23 + i8 + i9 | 0;
   if ((HEAP32[i75 >> 2] | 0) >>> 0 < i26 >>> 0) {
    i24 = HEAP32[i86 >> 2] | 0;
    if ((i24 | 0) != (i74 | 0)) {
     if (i24) __ZdaPv(i24);
     HEAP32[i86 >> 2] = i74;
     HEAP32[i75 >> 2] = 1032;
    }
    if (i26 >>> 0 > 1032) {
     i53 = __Znaj(i26) | 0;
     HEAP32[i86 >> 2] = i53;
     HEAP32[i75 >> 2] = i26;
    } else i53 = i74;
   } else {
    HEAP32[i75 >> 2] = i26;
    i53 = HEAP32[i86 >> 2] | 0;
   }
   i51 = i53 + i10 | 0;
   if (i61) i52 = i53 + i23 | 0; else i52 = 0;
   do if ((i8 | 0) > 0) {
    i24 = i9 + i23 | 0;
    i26 = i53 + i24 | 0;
    i9 = i50 + 4 | 0;
    HEAP32[i9 >> 2] = 2;
    i7 = i50 + 8 | 0;
    HEAP32[i7 >> 2] = i88;
    HEAP32[i50 + 12 >> 2] = i89;
    i23 = i50 + 16 | 0;
    HEAP32[i23 >> 2] = i26;
    HEAP32[i50 + 20 >> 2] = i26;
    i26 = i50 + 24 | 0;
    i10 = i50 + 40 | 0;
    HEAP32[i26 + 0 >> 2] = 0;
    HEAP32[i26 + 4 >> 2] = 0;
    HEAP32[i26 + 8 >> 2] = 0;
    HEAP32[i26 + 12 >> 2] = 0;
    HEAP32[i10 >> 2] = i7;
    i7 = i50 + 48 | 0;
    i8 = i50 + 44 | 0;
    HEAP32[i8 >> 2] = i7;
    i48 = Math_imul(i89, i59) | 0;
    HEAP32[i50 >> 2] = i49 | 1124024320;
    HEAP32[i7 >> 2] = i48;
    HEAP32[i50 + 52 >> 2] = i59;
    i24 = i53 + ((Math_imul(i88, i48) | 0) + i24) | 0;
    HEAP32[i50 + 28 >> 2] = i24;
    HEAP32[i26 >> 2] = i24;
    __ZN2cv3MataSERKS0_(i87, i50) | 0;
    i26 = i50 + 36 | 0;
    i24 = HEAP32[i26 >> 2] | 0;
    do if (i24) {
     i48 = i24 + 12 | 0;
     i49 = HEAP32[i48 >> 2] | 0;
     HEAP32[i48 >> 2] = i49 + -1;
     if ((i49 | 0) != 1) break;
     __ZN2cv3Mat10deallocateEv(i50);
    } while (0);
    HEAP32[i26 >> 2] = 0;
    HEAP32[i23 + 0 >> 2] = 0;
    HEAP32[i23 + 4 >> 2] = 0;
    HEAP32[i23 + 8 >> 2] = 0;
    HEAP32[i23 + 12 >> 2] = 0;
    if ((HEAP32[i9 >> 2] | 0) > 0) {
     i26 = HEAP32[i10 >> 2] | 0;
     i24 = 0;
     do {
      HEAP32[i26 + (i24 << 2) >> 2] = 0;
      i24 = i24 + 1 | 0;
     } while ((i24 | 0) < (HEAP32[i9 >> 2] | 0));
    }
    i26 = HEAP32[i8 >> 2] | 0;
    if ((i26 | 0) == (i7 | 0)) break;
    __ZN2cv8fastFreeEPv(i26);
   } while (0);
   if ((i88 | 0) > 0) {
    i21 = i88 << 3;
    i22 = (i89 | 0) > 0;
    i35 = i70 + 16 | 0;
    i36 = i70 + 44 | 0;
    i37 = i70 + 48 | 0;
    i38 = i89 << 3;
    i39 = (i54 | 0) < (i19 | 0);
    i40 = (i19 | 0) > 0;
    i41 = i84 + 4 | 0;
    i42 = i97 + 16 | 0;
    i43 = i19 << 3;
    i50 = (i52 | 0) != 0 & i61;
    i44 = (i59 | 0) == 4;
    i45 = i59 >>> 2;
    i46 = i80 + 4 | 0;
    i47 = i81 + 4 | 0;
    i48 = i82 + 4 | 0;
    i49 = i83 + 4 | 0;
    i20 = 0;
    do {
     i18 = i20 + i28 | 0;
     if ((i18 | 0) < (i88 | 0) ? ((i18 << 3) + i28 | 0) <= (i21 | 0) : 0) i34 = i28; else i34 = i88 - i20 | 0;
     if (i22) {
      i16 = Math_imul(i20, i55) | 0;
      i17 = Math_imul(i20, i57) | 0;
      i18 = (i34 | 0) > 0;
      i15 = 0;
      do {
       i24 = HEAP32[i37 >> 2] | 0;
       i12 = Math_imul(i15, i59) | 0;
       i26 = (HEAP32[i35 >> 2] | 0) + ((Math_imul(i24, i20) | 0) + i12) | 0;
       i13 = i72 + ((Math_imul(i15, i56) | 0) + i16) | 0;
       i14 = i15 + i27 | 0;
       if ((i14 | 0) < (i89 | 0) ? ((i14 << 3) + i27 | 0) <= (i38 | 0) : 0) i14 = i27; else i14 = i89 - i15 | 0;
       i25 = i25 & 15;
       if (i39) {
        i26 = i53;
        i24 = Math_imul(i14, i60) | 0;
       }
       if (i40) {
        i31 = Math_imul(i15, i65) | 0;
        i30 = (i14 | 0) < (i89 | 0);
        i32 = 0;
        do {
         i23 = (HEAP32[i69 >> 2] | 0) + ((Math_imul(i32, i58) | 0) + i17) | 0;
         i1 = HEAP32[i62 >> 2] | 0;
         i10 = (HEAP32[i42 >> 2] | 0) + ((Math_imul(i32, i64) | 0) + i31) | 0;
         i11 = i32 + i54 | 0;
         if ((i11 | 0) < (i19 | 0) ? ((i11 << 3) + i54 | 0) <= (i43 | 0) : 0) i33 = i54; else i33 = i19 - i32 | 0;
         L231 : do if (i61) {
          if (!i50) {
           i29 = i23;
           i2 = i1;
           i1 = i34;
           i11 = i33;
           break;
          }
          i2 = Math_imul(i33, i59) | 0;
          if (!i18) {
           i29 = i52;
           i1 = i33;
           i11 = i34;
           break;
          }
          i5 = (i33 | 0) > 0;
          if (i44) {
           if (i5) {
            i6 = i52;
            i8 = 0;
           } else {
            i23 = 0;
            while (1) {
             i23 = i23 + 1 | 0;
             if ((i23 | 0) >= (i34 | 0)) {
              i29 = i52;
              i1 = i33;
              i11 = i34;
              break L231;
             }
            }
           }
           while (1) {
            i9 = i23;
            i7 = 0;
            while (1) {
             HEAP32[i6 + (i7 << 2) >> 2] = HEAP32[i9 >> 2];
             i7 = i7 + 1 | 0;
             if ((i7 | 0) == (i33 | 0)) break; else i9 = i9 + i1 | 0;
            }
            i8 = i8 + 1 | 0;
            if ((i8 | 0) >= (i34 | 0)) {
             i29 = i52;
             i1 = i33;
             i11 = i34;
             break L231;
            } else {
             i6 = i6 + i2 | 0;
             i23 = i23 + 4 | 0;
            }
           }
          }
          i4 = i33 << 2;
          i3 = i33 << 1;
          i6 = i52;
          i7 = 0;
          while (1) {
           do if ((i59 | 0) == 8) {
            if (!i5) break;
            i9 = i23;
            i8 = 0;
            while (1) {
             i11 = HEAP32[i9 + 4 >> 2] | 0;
             HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i9 >> 2];
             HEAP32[i6 + ((i8 | 1) << 2) >> 2] = i11;
             i8 = i8 + 2 | 0;
             if ((i8 | 0) >= (i3 | 0)) break; else i9 = i9 + i1 | 0;
            }
           } else if ((i59 | 0) == 16) {
            if (!i5) break;
            i9 = i23;
            i8 = 0;
            while (1) {
             i11 = HEAP32[i9 + 4 >> 2] | 0;
             HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i9 >> 2];
             HEAP32[i6 + ((i8 | 1) << 2) >> 2] = i11;
             i11 = HEAP32[i9 + 12 >> 2] | 0;
             HEAP32[i6 + ((i8 | 2) << 2) >> 2] = HEAP32[i9 + 8 >> 2];
             HEAP32[i6 + ((i8 | 3) << 2) >> 2] = i11;
             i8 = i8 + 4 | 0;
             if ((i8 | 0) >= (i4 | 0)) break; else i9 = i9 + i1 | 0;
            }
           } else {
            i29 = i52;
            i1 = i33;
            i11 = i34;
            break L231;
           } while (0);
           i7 = i7 + 1 | 0;
           if ((i7 | 0) >= (i34 | 0)) {
            i29 = i52;
            i1 = i33;
            i11 = i34;
            break;
           } else {
            i6 = i6 + i2 | 0;
            i23 = i23 + i59 | 0;
           }
          }
         } else {
          i29 = i23;
          i2 = i1;
          i1 = i33;
          i11 = i34;
         } while (0);
         do if (i30) {
          i9 = i63 ? i14 : i33;
          i6 = i63 ? i33 : i14;
          i23 = Math_imul(i6, i59) | 0;
          i6 = Math_imul(i6, i45) | 0;
          if (!i9) {
           i10 = i51;
           break;
          }
          i5 = i6 + -4 | 0;
          i4 = (i5 | 0) < 0;
          i3 = i6 & -4;
          i7 = i51;
          while (1) {
           i9 = i9 + -1 | 0;
           if (i4) i8 = 0; else {
            i8 = 0;
            do {
             i116 = i8 | 1;
             i114 = HEAP32[i10 + (i116 << 2) >> 2] | 0;
             HEAP32[i7 + (i8 << 2) >> 2] = HEAP32[i10 + (i8 << 2) >> 2];
             HEAP32[i7 + (i116 << 2) >> 2] = i114;
             i116 = i8 | 2;
             i114 = i8 | 3;
             i115 = HEAP32[i10 + (i114 << 2) >> 2] | 0;
             HEAP32[i7 + (i116 << 2) >> 2] = HEAP32[i10 + (i116 << 2) >> 2];
             HEAP32[i7 + (i114 << 2) >> 2] = i115;
             i8 = i8 + 4 | 0;
            } while ((i8 | 0) <= (i5 | 0));
            i8 = i3;
           }
           if ((i8 | 0) < (i6 | 0)) do {
            HEAP32[i7 + (i8 << 2) >> 2] = HEAP32[i10 + (i8 << 2) >> 2];
            i8 = i8 + 1 | 0;
           } while ((i8 | 0) != (i6 | 0));
           if (!i9) {
            i10 = i51;
            break;
           } else {
            i7 = i7 + i23 | 0;
            i10 = i10 + i68 | 0;
           }
          }
         } else i23 = i68; while (0);
         if (i39) {
          HEAP32[i80 >> 2] = i1;
          HEAP32[i46 >> 2] = i11;
          HEAP32[i81 >> 2] = i14;
          HEAP32[i47 >> 2] = i34;
          FUNCTION_TABLE_viiiiiiiii[i66 & 7](i29, i2, i10, i23, i26, i24, i80, i81, i25);
         } else {
          HEAP32[i82 >> 2] = i1;
          HEAP32[i48 >> 2] = i11;
          HEAP32[i83 >> 2] = i14;
          HEAP32[i49 >> 2] = i34;
          FUNCTION_TABLE_viiiiiiiiiiddi[i71 & 7](i29, i2, i10, i23, i13, i73, i26, i24, i82, i83, d92, d93, i25);
         }
         i25 = i25 | 16;
         i32 = i33 + i32 | 0;
        } while ((i19 | 0) > (i32 | 0));
       }
       if (i39) {
        i11 = (HEAP32[i35 >> 2] | 0) + ((Math_imul(HEAP32[HEAP32[i36 >> 2] >> 2] | 0, i20) | 0) + i12) | 0;
        i12 = HEAP32[i37 >> 2] | 0;
        HEAP32[i84 >> 2] = i14;
        HEAP32[i41 >> 2] = i34;
        FUNCTION_TABLE_viiiiiiiddi[i67 & 7](i13, i73, i26, i24, i11, i12, i84, d92, d93, i25);
       }
       i15 = i14 + i15 | 0;
      } while ((i89 | 0) > (i15 | 0));
     }
     i20 = i34 + i20 | 0;
    } while ((i88 | 0) > (i20 | 0));
   }
  } while (0);
  if ((i90 | 0) == 109) {
   if ((i8 | 0) > 0) {
    if ((HEAP32[i75 >> 2] | 0) >>> 0 < i8 >>> 0) {
     i18 = HEAP32[i86 >> 2] | 0;
     if ((i18 | 0) != (i74 | 0)) {
      if (i18) __ZdaPv(i18);
      HEAP32[i86 >> 2] = i74;
      HEAP32[i75 >> 2] = 1032;
     }
     if (i8 >>> 0 > 1032) {
      i19 = __Znaj(i8) | 0;
      HEAP32[i86 >> 2] = i19;
      HEAP32[i75 >> 2] = i8;
     } else i19 = i74;
    } else {
     HEAP32[i75 >> 2] = i8;
     i19 = HEAP32[i86 >> 2] | 0;
    }
    i15 = i22 + 4 | 0;
    HEAP32[i15 >> 2] = 2;
    i13 = i22 + 8 | 0;
    HEAP32[i13 >> 2] = i88;
    HEAP32[i22 + 12 >> 2] = i89;
    i17 = i22 + 16 | 0;
    HEAP32[i17 >> 2] = i19;
    HEAP32[i22 + 20 >> 2] = i19;
    i18 = i22 + 24 | 0;
    i16 = i22 + 40 | 0;
    HEAP32[i18 + 0 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    HEAP32[i18 + 12 >> 2] = 0;
    HEAP32[i16 >> 2] = i13;
    i13 = i22 + 48 | 0;
    i14 = i22 + 44 | 0;
    HEAP32[i14 >> 2] = i13;
    i84 = (i11 >>> 3 & 511) + 1 << (47696 >>> (i11 << 1 & 14) & 3);
    i90 = Math_imul(i89, i84) | 0;
    HEAP32[i22 >> 2] = i49 | 1124024320;
    HEAP32[i13 >> 2] = i90;
    HEAP32[i22 + 52 >> 2] = i84;
    i19 = i19 + (Math_imul(i88, i90) | 0) | 0;
    HEAP32[i22 + 28 >> 2] = i19;
    HEAP32[i18 >> 2] = i19;
    __ZN2cv3MataSERKS0_(i87, i22) | 0;
    i19 = i22 + 36 | 0;
    i18 = HEAP32[i19 >> 2] | 0;
    if ((i18 | 0) != 0 ? (i84 = i18 + 12 | 0, i90 = HEAP32[i84 >> 2] | 0, HEAP32[i84 >> 2] = i90 + -1, (i90 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i22);
    HEAP32[i19 >> 2] = 0;
    HEAP32[i17 + 0 >> 2] = 0;
    HEAP32[i17 + 4 >> 2] = 0;
    HEAP32[i17 + 8 >> 2] = 0;
    HEAP32[i17 + 12 >> 2] = 0;
    if ((HEAP32[i15 >> 2] | 0) > 0) {
     i18 = HEAP32[i16 >> 2] | 0;
     i17 = 0;
     do {
      HEAP32[i18 + (i17 << 2) >> 2] = 0;
      i17 = i17 + 1 | 0;
     } while ((i17 | 0) < (HEAP32[i15 >> 2] | 0));
    }
    i12 = HEAP32[i14 >> 2] | 0;
    if ((i12 | 0) != (i13 | 0)) __ZN2cv8fastFreeEPv(i12);
   }
   i81 = HEAP32[i69 >> 2] | 0;
   i82 = HEAP32[i98 + 48 >> 2] | 0;
   i83 = HEAP32[i97 + 16 >> 2] | 0;
   i84 = HEAP32[i70 + 16 >> 2] | 0;
   i90 = HEAP32[i70 + 48 >> 2] | 0;
   HEAP32[i31 >> 2] = i20;
   HEAP32[i31 + 4 >> 2] = i21;
   HEAP32[i32 >> 2] = i89;
   HEAP32[i32 + 4 >> 2] = i88;
   FUNCTION_TABLE_viiiiiiiiiiddi[i71 & 7](i81, i82, i83, i68, i72, i73, i84, i90, i31, i32, d92, d93, i7);
  }
  if ((i70 | 0) != (i94 | 0)) {
   i90 = i85 + 4 | 0;
   HEAP32[i90 + 0 >> 2] = 0;
   HEAP32[i90 + 4 >> 2] = 0;
   HEAP32[i90 + 8 >> 2] = 0;
   HEAP32[i90 + 12 >> 2] = 0;
   HEAP32[i85 >> 2] = 32232;
   HEAP32[i90 >> 2] = 33619968;
   HEAP32[i85 + 8 >> 2] = i94;
   __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i70, i85);
  }
  i3 = HEAP32[i86 >> 2] | 0;
  if ((i3 | 0) != (i74 | 0)) {
   if (i3) __ZdaPv(i3);
   HEAP32[i86 >> 2] = i74;
   HEAP32[i75 >> 2] = 1032;
  }
  i3 = i87 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i89 = i2 + 12 | 0, i90 = HEAP32[i89 >> 2] | 0, HEAP32[i89 >> 2] = i90 + -1, (i90 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i87);
  HEAP32[i3 >> 2] = 0;
  i90 = i87 + 16 | 0;
  HEAP32[i90 + 0 >> 2] = 0;
  HEAP32[i90 + 4 >> 2] = 0;
  HEAP32[i90 + 8 >> 2] = 0;
  HEAP32[i90 + 12 >> 2] = 0;
  if ((HEAP32[i78 >> 2] | 0) > 0) {
   i3 = HEAP32[i76 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i78 >> 2] | 0));
  }
  i3 = HEAP32[i77 >> 2] | 0;
  if ((i3 | 0) != (i79 | 0)) __ZN2cv8fastFreeEPv(i3);
 }
 i3 = i94 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i89 = i2 + 12 | 0, i90 = HEAP32[i89 >> 2] | 0, HEAP32[i89 >> 2] = i90 + -1, (i90 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i94);
 HEAP32[i3 >> 2] = 0;
 i90 = i94 + 16 | 0;
 i3 = i94 + 4 | 0;
 HEAP32[i90 + 0 >> 2] = 0;
 HEAP32[i90 + 4 >> 2] = 0;
 HEAP32[i90 + 8 >> 2] = 0;
 HEAP32[i90 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i94 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i3 = HEAP32[i94 + 44 >> 2] | 0;
 if ((i3 | 0) != (i94 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
 i3 = i95 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i90 = i2 + 12 | 0, i94 = HEAP32[i90 >> 2] | 0, HEAP32[i90 >> 2] = i94 + -1, (i94 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i95);
 HEAP32[i3 >> 2] = 0;
 i1 = i95 + 4 | 0;
 HEAP32[i91 + 0 >> 2] = 0;
 HEAP32[i91 + 4 >> 2] = 0;
 HEAP32[i91 + 8 >> 2] = 0;
 HEAP32[i91 + 12 >> 2] = 0;
 if ((HEAP32[i1 >> 2] | 0) > 0) {
  i3 = HEAP32[i95 + 40 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
 }
 i2 = HEAP32[i95 + 44 >> 2] | 0;
 if ((i2 | 0) != (i95 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i97 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i94 = i1 + 12 | 0, i95 = HEAP32[i94 >> 2] | 0, HEAP32[i94 >> 2] = i95 + -1, (i95 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i97);
 HEAP32[i2 >> 2] = 0;
 i95 = i97 + 16 | 0;
 i3 = i97 + 4 | 0;
 HEAP32[i95 + 0 >> 2] = 0;
 HEAP32[i95 + 4 >> 2] = 0;
 HEAP32[i95 + 8 >> 2] = 0;
 HEAP32[i95 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i97 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i97 + 44 >> 2] | 0;
 if ((i1 | 0) != (i97 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i98 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i95 = i2 + 12 | 0, i97 = HEAP32[i95 >> 2] | 0, HEAP32[i95 >> 2] = i97 + -1, (i97 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i98);
 HEAP32[i1 >> 2] = 0;
 i97 = i98 + 16 | 0;
 i3 = i98 + 4 | 0;
 HEAP32[i97 + 0 >> 2] = 0;
 HEAP32[i97 + 4 >> 2] = 0;
 HEAP32[i97 + 8 >> 2] = 0;
 HEAP32[i97 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i96 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i98 + 44 >> 2] | 0;
 if ((i1 | 0) == (i98 + 48 | 0)) {
  STACKTOP = i99;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i99;
 return;
}

function __ZNK2cv12_OutputArray6createEiPKiiibi(i52, i49, i51, i48, i44, i43, i47) {
 i52 = i52 | 0;
 i49 = i49 | 0;
 i51 = i51 | 0;
 i48 = i48 | 0;
 i44 = i44 | 0;
 i43 = i43 | 0;
 i47 = i47 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i45 = 0, i46 = 0, i50 = 0, i53 = 0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 i41 = i53;
 i11 = i53 + 304 | 0;
 i5 = i53 + 296 | 0;
 i12 = i53 + 288 | 0;
 i16 = i53 + 280 | 0;
 i25 = i53 + 272 | 0;
 i3 = i53 + 264 | 0;
 i10 = i53 + 256 | 0;
 i19 = i53 + 248 | 0;
 i22 = i53 + 240 | 0;
 i33 = i53 + 232 | 0;
 i1 = i53 + 224 | 0;
 i6 = i53 + 216 | 0;
 i18 = i53 + 208 | 0;
 i9 = i53 + 200 | 0;
 i27 = i53 + 192 | 0;
 i28 = i53 + 184 | 0;
 i23 = i53 + 176 | 0;
 i36 = i53 + 168 | 0;
 i37 = i53 + 160 | 0;
 i38 = i53 + 152 | 0;
 i7 = i53 + 144 | 0;
 i13 = i53 + 136 | 0;
 i30 = i53 + 128 | 0;
 i46 = i53 + 120 | 0;
 i14 = i53 + 112 | 0;
 i20 = i53 + 104 | 0;
 i24 = i53 + 96 | 0;
 i29 = i53 + 88 | 0;
 i35 = i53 + 80 | 0;
 i15 = i53 + 72 | 0;
 i31 = i53 + 64 | 0;
 i45 = i53 + 56 | 0;
 i17 = i53 + 48 | 0;
 i21 = i53 + 40 | 0;
 i32 = i53 + 32 | 0;
 i34 = i53 + 24 | 0;
 i39 = i53 + 16 | 0;
 i8 = i53 + 8 | 0;
 i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 24 >> 2] & 127](i52) | 0;
 i2 = i48 & 4095;
 if ((i4 | 0) == 131072) {
  if ((i44 | 0) >= 0) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i46 = __ZN2cv6String8allocateEj(i1, 5) | 0;
   HEAP8[i46 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i46 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i46 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i46 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i46 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 27672, 27528, 2241);
   __ZN2cv6String10deallocateEv(i1);
  }
  i5 = HEAP32[i52 + 4 >> 2] & 4095;
  do if ((i2 | 0) != (i5 | 0)) {
   if ((i48 & 4088 | 0) == 0 ? (1 << i5 & i47 | 0) != 0 : 0) break;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i6, 81) | 0) + 0 | 0;
   i26 = 30408 | 0;
   i50 = i1 + 81 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i26 = i26 + 1 | 0;
   } while ((i1 | 0) < (i50 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i6, 27672, 27528, 2243);
   __ZN2cv6String10deallocateEv(i6);
  } while (0);
  if ((i49 | 0) == 2) {
   i3 = HEAP32[i51 >> 2] | 0;
   i1 = i52 + 12 | 0;
   i2 = HEAP32[i52 + 16 >> 2] | 0;
   if ((i3 | 0) == (i2 | 0) ? (HEAP32[i51 + 4 >> 2] | 0) == (HEAP32[i1 >> 2] | 0) : 0) {
    STACKTOP = i53;
    return;
   }
   if ((i43 ? (i3 | 0) == (HEAP32[i1 >> 2] | 0) : 0) ? (HEAP32[i51 + 4 >> 2] | 0) == (i2 | 0) : 0) {
    STACKTOP = i53;
    return;
   }
  }
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  _memcpy(__ZN2cv6String8allocateEj(i18, 129) | 0, 30496, 129) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i18, 27672, 27528, 2245);
  __ZN2cv6String10deallocateEv(i18);
  STACKTOP = i53;
  return;
 } else if ((i4 | 0) == 65536) {
  if ((i44 | 0) >= 0) {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   i46 = __ZN2cv6String8allocateEj(i11, 5) | 0;
   HEAP8[i46 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i46 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i46 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i46 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i46 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i11, 27672, 27528, 2173);
   __ZN2cv6String10deallocateEv(i11);
  }
  i6 = HEAP32[i52 + 8 >> 2] | 0;
  if (i43) {
   if (!(HEAP32[i6 >> 2] & 16384)) {
    if (!(!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 108 >> 2] & 127](i52) | 0) ? !(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 104 >> 2] & 127](i52) | 0) : 0)) {
     HEAP32[i5 >> 2] = 0;
     HEAP32[i5 + 4 >> 2] = 0;
     i1 = (__ZN2cv6String8allocateEj(i5, 28) | 0) + 0 | 0;
     i26 = 30304 | 0;
     i50 = i1 + 28 | 0;
     do {
      HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
      i1 = i1 + 1 | 0;
      i26 = i26 + 1 | 0;
     } while ((i1 | 0) < (i50 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 27672, 27528, 2179);
     __ZN2cv6String10deallocateEv(i5);
    }
    __ZN2cv3Mat7releaseEv(i6);
   }
   if ((((((i49 | 0) == 2 ? (HEAP32[i6 + 4 >> 2] | 0) == 2 : 0) ? (HEAP32[i6 + 16 >> 2] | 0) != 0 : 0) ? (HEAP32[i6 >> 2] & 4095 | 0) == (i2 | 0) : 0) ? (HEAP32[i6 + 8 >> 2] | 0) == (HEAP32[i51 + 4 >> 2] | 0) : 0) ? (HEAP32[i6 + 12 >> 2] | 0) == (HEAP32[i51 >> 2] | 0) : 0) {
    STACKTOP = i53;
    return;
   }
  }
  do if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 108 >> 2] & 127](i52) | 0) {
   i5 = HEAP32[i6 >> 2] | 0;
   if (((i5 ^ i48) & 4088 | 0) == 0 ? (1 << (HEAP32[i52 + 4 >> 2] & 4095) & i47 | 0) != 0 : 0) {
    i2 = i5 & 4095;
    break;
   }
   if ((i2 | 0) != (i5 & 4095 | 0)) {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    i1 = (__ZN2cv6String8allocateEj(i12, 30) | 0) + 0 | 0;
    i26 = 30336 | 0;
    i50 = i1 + 30 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i26 = i26 + 1 | 0;
    } while ((i1 | 0) < (i50 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i12, 27672, 27528, 2193);
    __ZN2cv6String10deallocateEv(i12);
   }
  } while (0);
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 104 >> 2] & 127](i52) | 0) {
   if ((HEAP32[i6 + 4 >> 2] | 0) != (i49 | 0)) {
    HEAP32[i16 >> 2] = 0;
    HEAP32[i16 + 4 >> 2] = 0;
    i1 = (__ZN2cv6String8allocateEj(i16, 11) | 0) + 0 | 0;
    i26 = 30368 | 0;
    i50 = i1 + 11 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i26 = i26 + 1 | 0;
    } while ((i1 | 0) < (i50 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i16, 27672, 27528, 2197);
    __ZN2cv6String10deallocateEv(i16);
   }
   if ((i49 | 0) > 0) {
    i5 = i6 + 40 | 0;
    i4 = i25 + 4 | 0;
    i3 = 0;
    do {
     if ((HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0) != (HEAP32[i51 + (i3 << 2) >> 2] | 0)) {
      HEAP32[i25 >> 2] = 0;
      HEAP32[i4 >> 2] = 0;
      i1 = (__ZN2cv6String8allocateEj(i25, 21) | 0) + 0 | 0;
      i26 = 30384 | 0;
      i50 = i1 + 21 | 0;
      do {
       HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
       i1 = i1 + 1 | 0;
       i26 = i26 + 1 | 0;
      } while ((i1 | 0) < (i50 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i25, 27672, 27528, 2199);
      __ZN2cv6String10deallocateEv(i25);
     }
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (i49 | 0));
   }
  }
  __ZN2cv3Mat6createEiPKii(i6, i49, i51, i2);
  STACKTOP = i53;
  return;
 } else if ((i4 | 0) != 655360) {
  i10 = (i4 | 0) == 262144;
  if ((i4 | 0) == 196608 | (i4 | 0) == 262144) {
   if ((i49 | 0) == 2) {
    i6 = HEAP32[i51 >> 2] | 0;
    if ((i6 | 0) != 1) {
     i46 = HEAP32[i51 + 4 >> 2] | 0;
     if ((i46 | 0) == 1 | (Math_imul(i46, i6) | 0) == 0) i5 = i6; else i26 = 81;
    } else i5 = 1;
   } else i26 = 81;
   if ((i26 | 0) == 81) {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    i1 = (__ZN2cv6String8allocateEj(i9, 68) | 0) + 0 | 0;
    i26 = 30632 | 0;
    i50 = i1 + 68 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i26 = i26 + 1 | 0;
    } while ((i1 | 0) < (i50 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i9, 27672, 27528, 2251);
    __ZN2cv6String10deallocateEv(i9);
    i5 = HEAP32[i51 >> 2] | 0;
   }
   i6 = HEAP32[i51 + 4 >> 2] | 0;
   if ((Math_imul(i6, i5) | 0) > 0) i49 = i5 + -1 + i6 | 0; else i49 = 0;
   i9 = HEAP32[i52 + 8 >> 2] | 0;
   do if (!i10) {
    if ((i44 | 0) >= 0) {
     HEAP32[i23 >> 2] = 0;
     HEAP32[i23 + 4 >> 2] = 0;
     i46 = __ZN2cv6String8allocateEj(i23, 5) | 0;
     HEAP8[i46 + 0 >> 0] = HEAP8[28696] | 0;
     HEAP8[i46 + 1 >> 0] = HEAP8[28697] | 0;
     HEAP8[i46 + 2 >> 0] = HEAP8[28698] | 0;
     HEAP8[i46 + 3 >> 0] = HEAP8[28699] | 0;
     HEAP8[i46 + 4 >> 0] = HEAP8[28700] | 0;
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i23, 27672, 27528, 2268);
     __ZN2cv6String10deallocateEv(i23);
    }
   } else {
    if ((i44 | 0) >= 0) {
     i5 = HEAP32[i9 >> 2] | 0;
     if ((((HEAP32[i9 + 4 >> 2] | 0) - i5 | 0) / 12 | 0 | 0) <= (i44 | 0)) {
      HEAP32[i28 >> 2] = 0;
      HEAP32[i28 + 4 >> 2] = 0;
      i1 = (__ZN2cv6String8allocateEj(i28, 18) | 0) + 0 | 0;
      i26 = 29208 | 0;
      i50 = i1 + 18 | 0;
      do {
       HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
       i1 = i1 + 1 | 0;
       i26 = i26 + 1 | 0;
      } while ((i1 | 0) < (i50 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i28, 27672, 27528, 2264);
      __ZN2cv6String10deallocateEv(i28);
      i5 = HEAP32[i9 >> 2] | 0;
     }
     i9 = i5 + (i44 * 12 | 0) | 0;
     break;
    }
    i6 = i9 + 4 | 0;
    if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 104 >> 2] & 127](i52) | 0 ? (i49 | 0) != (((HEAP32[i6 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0) / 12 | 0 | 0) : 0) {
     HEAP32[i27 >> 2] = 0;
     HEAP32[i27 + 4 >> 2] = 0;
     i1 = (__ZN2cv6String8allocateEj(i27, 32) | 0) + 0 | 0;
     i26 = 30704 | 0;
     i50 = i1 + 32 | 0;
     do {
      HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
      i1 = i1 + 1 | 0;
      i26 = i26 + 1 | 0;
     } while ((i1 | 0) < (i50 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i27, 27672, 27528, 2260);
     __ZN2cv6String10deallocateEv(i27);
     i2 = i9;
    } else i2 = i9;
    i1 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP32[i2 >> 2] | 0;
    i3 = (i1 - i2 | 0) / 12 | 0;
    if (i49 >>> 0 > i3 >>> 0) {
     __ZNSt3__16vectorINS0_IhNS_9allocatorIhEEEENS1_IS3_EEE8__appendEj(i9, i49 - i3 | 0);
     STACKTOP = i53;
     return;
    }
    if (i49 >>> 0 >= i3 >>> 0) {
     STACKTOP = i53;
     return;
    }
    i5 = i2 + (i49 * 12 | 0) | 0;
    if ((i1 | 0) == (i5 | 0)) {
     STACKTOP = i53;
     return;
    }
    do {
     i2 = i1 + -12 | 0;
     HEAP32[i6 >> 2] = i2;
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) i1 = i2; else {
      i1 = i1 + -8 | 0;
      if ((HEAP32[i1 >> 2] | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i3;
      __ZdlPv(i3);
      i1 = HEAP32[i6 >> 2] | 0;
     }
    } while ((i1 | 0) != (i5 | 0));
    STACKTOP = i53;
    return;
   } while (0);
   i6 = HEAP32[i52 + 4 >> 2] | 0;
   i5 = i6 & 4095;
   do if ((i2 | 0) != (i5 | 0)) {
    if (((i6 ^ i48) & 4088 | 0) == 0 ? (1 << i5 & i47 | 0) != 0 : 0) break;
    HEAP32[i36 >> 2] = 0;
    HEAP32[i36 + 4 >> 2] = 0;
    i1 = (__ZN2cv6String8allocateEj(i36, 96) | 0) + 0 | 0;
    i26 = 30744 | 0;
    i50 = i1 + 96 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i26 = i26 + 1 | 0;
    } while ((i1 | 0) < (i50 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i36, 27672, 27528, 2271);
    __ZN2cv6String10deallocateEv(i36);
   } while (0);
   i5 = (i6 >>> 3 & 511) + 1 << (47696 >>> (i6 << 1 & 14) & 3);
   if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 104 >> 2] & 127](i52) | 0 ? (i49 | 0) != ((((HEAP32[i9 + 4 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0) >>> 0) / (i5 >>> 0) | 0 | 0) : 0) {
    HEAP32[i37 >> 2] = 0;
    HEAP32[i37 + 4 >> 2] = 0;
    i1 = (__ZN2cv6String8allocateEj(i37, 61) | 0) + 0 | 0;
    i26 = 30848 | 0;
    i50 = i1 + 61 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i26 = i26 + 1 | 0;
    } while ((i1 | 0) < (i50 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i37, 27672, 27528, 2274);
    __ZN2cv6String10deallocateEv(i37);
   }
   do switch (i5 | 0) {
   case 128:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i4 - i3 >> 7;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIiLi32EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 << 7) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~((i4 + -128 - i1 | 0) >>> 7) << 7);
     STACKTOP = i53;
     return;
    }
   case 512:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i4 - i3 >> 9;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIiLi128EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 << 9) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~((i4 + -512 - i1 | 0) >>> 9) << 9);
     STACKTOP = i53;
     return;
    }
   case 24:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = (i4 - i3 | 0) / 24 | 0;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIiLi6EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 * 24 | 0) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~(((i4 + -24 - i1 | 0) >>> 0) / 24 | 0) * 24 | 0);
     STACKTOP = i53;
     return;
    }
   case 8:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i4 - i3 >> 3;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIiLi2EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 << 3) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~((i4 + -8 - i1 | 0) >>> 3) << 3);
     STACKTOP = i53;
     return;
    }
   case 256:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i4 - i3 >> 8;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIiLi64EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 << 8) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~((i4 + -256 - i1 | 0) >>> 8) << 8);
     STACKTOP = i53;
     return;
    }
   case 1:
    {
     i4 = i9 + 4 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i5 - i3 | 0;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIhNS_9allocatorIhEEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + i49 | 0;
     if ((i5 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i4 >> 2] = i1;
     STACKTOP = i53;
     return;
    }
   case 2:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i4 - i3 >> 1;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIhLi2EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 << 1) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~((i4 + (0 - i1) + -2 | 0) >>> 1) << 1);
     STACKTOP = i53;
     return;
    }
   case 6:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = (i4 - i3 | 0) / 6 | 0;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIsLi3EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 * 6 | 0) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~(((i4 + -6 - i1 | 0) >>> 0) / 6 | 0) * 6 | 0);
     STACKTOP = i53;
     return;
    }
   case 64:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i4 - i3 >> 6;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIiLi16EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 << 6) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~((i4 + -64 - i1 | 0) >>> 6) << 6);
     STACKTOP = i53;
     return;
    }
   case 3:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = (i4 - i3 | 0) / 3 | 0;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIhLi3EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 * 3 | 0) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~(((i4 + (0 - i1) + -3 | 0) >>> 0) / 3 | 0) * 3 | 0);
     STACKTOP = i53;
     return;
    }
   case 32:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i4 - i3 >> 5;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIiLi8EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 << 5) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~((i4 + -32 - i1 | 0) >>> 5) << 5);
     STACKTOP = i53;
     return;
    }
   case 4:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i4 - i3 >> 2;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIiNS_9allocatorIiEEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 << 2) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~((i4 + -4 - i1 | 0) >>> 2) << 2);
     STACKTOP = i53;
     return;
    }
   case 16:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i4 - i3 >> 4;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIiLi4EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 << 4) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~((i4 + -16 - i1 | 0) >>> 4) << 4);
     STACKTOP = i53;
     return;
    }
   case 36:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = (i4 - i3 | 0) / 36 | 0;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIiLi9EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 * 36 | 0) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~(((i4 + -36 - i1 | 0) >>> 0) / 36 | 0) * 36 | 0);
     STACKTOP = i53;
     return;
    }
   case 48:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = (i4 - i3 | 0) / 48 | 0;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIiLi12EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 * 48 | 0) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~(((i4 + -48 - i1 | 0) >>> 0) / 48 | 0) * 48 | 0);
     STACKTOP = i53;
     return;
    }
   case 12:
    {
     i5 = i9 + 4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = (i4 - i3 | 0) / 12 | 0;
     if (i49 >>> 0 > i2 >>> 0) {
      __ZNSt3__16vectorIN2cv3VecIiLi3EEENS_9allocatorIS3_EEE8__appendEj(i9, i49 - i2 | 0);
      STACKTOP = i53;
      return;
     }
     if (i49 >>> 0 >= i2 >>> 0) {
      STACKTOP = i53;
      return;
     }
     i1 = i3 + (i49 * 12 | 0) | 0;
     if ((i4 | 0) == (i1 | 0)) {
      STACKTOP = i53;
      return;
     }
     HEAP32[i5 >> 2] = i4 + (~(((i4 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
     STACKTOP = i53;
     return;
    }
   default:
    {
     HEAP32[i41 >> 2] = i5;
     __ZN2cv6formatEPKcz(i38, 30912, i41);
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i38, 27672, 27528, 2326);
     __ZN2cv6String10deallocateEv(i38);
     STACKTOP = i53;
     return;
    }
   } while (0);
  } else if ((i4 | 0) == 327680) {
   i11 = HEAP32[i52 + 8 >> 2] | 0;
   if ((i44 | 0) < 0) {
    if ((i49 | 0) == 2) {
     i5 = HEAP32[i51 >> 2] | 0;
     if ((i5 | 0) != 1) {
      i45 = HEAP32[i51 + 4 >> 2] | 0;
      if ((i45 | 0) == 1 | (Math_imul(i45, i5) | 0) == 0) i4 = i5; else i26 = 198;
     } else i4 = 1;
    } else i26 = 198;
    if ((i26 | 0) == 198) {
     HEAP32[i13 >> 2] = 0;
     HEAP32[i13 + 4 >> 2] = 0;
     i1 = (__ZN2cv6String8allocateEj(i13, 68) | 0) + 0 | 0;
     i26 = 30632 | 0;
     i50 = i1 + 68 | 0;
     do {
      HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
      i1 = i1 + 1 | 0;
      i26 = i26 + 1 | 0;
     } while ((i1 | 0) < (i50 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i13, 27672, 27528, 2343);
     __ZN2cv6String10deallocateEv(i13);
     i4 = HEAP32[i51 >> 2] | 0;
    }
    i5 = HEAP32[i51 + 4 >> 2] | 0;
    if ((Math_imul(i5, i4) | 0) > 0) i10 = i4 + -1 + i5 | 0; else i10 = 0;
    i6 = i11 + 4 | 0;
    i2 = ((HEAP32[i6 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0) / 56 | 0;
    if (!((i10 | 0) == (i2 | 0) | (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 104 >> 2] & 127](i52) | 0) ^ 1)) {
     HEAP32[i30 >> 2] = 0;
     HEAP32[i30 + 4 >> 2] = 0;
     i1 = (__ZN2cv6String8allocateEj(i30, 27) | 0) + 0 | 0;
     i26 = 31048 | 0;
     i50 = i1 + 27 | 0;
     do {
      HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
      i1 = i1 + 1 | 0;
      i26 = i26 + 1 | 0;
     } while ((i1 | 0) < (i50 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i30, 27672, 27528, 2346);
     __ZN2cv6String10deallocateEv(i30);
    }
    i5 = HEAP32[i6 >> 2] | 0;
    i4 = HEAP32[i11 >> 2] | 0;
    i3 = (i5 - i4 | 0) / 56 | 0;
    if (i10 >>> 0 <= i3 >>> 0) {
     if (i10 >>> 0 < i3 >>> 0 ? (i42 = i4 + (i10 * 56 | 0) | 0, (i5 | 0) != (i42 | 0)) : 0) do {
      i4 = i5 + -56 | 0;
      HEAP32[i6 >> 2] = i4;
      __ZN2cv3Mat7releaseEv(i4);
      i4 = HEAP32[i5 + -12 >> 2] | 0;
      if ((i4 | 0) != (i5 + -8 | 0)) __ZN2cv8fastFreeEPv(i4);
      i5 = HEAP32[i6 >> 2] | 0;
     } while ((i5 | 0) != (i42 | 0));
    } else __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE8__appendEj(i11, i10 - i3 | 0);
    if (!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 108 >> 2] & 127](i52) | 0)) {
     STACKTOP = i53;
     return;
    }
    i8 = HEAP32[i52 + 4 >> 2] & 4095;
    if (i2 >>> 0 >= i10 >>> 0) {
     STACKTOP = i53;
     return;
    }
    i9 = i46 + 4 | 0;
    i5 = HEAP32[i11 >> 2] | 0;
    i7 = i2;
    do {
     i4 = HEAP32[i5 + (i7 * 56 | 0) >> 2] | 0;
     if ((i4 & 4095 | 0) != (i8 | 0)) {
      if (HEAP32[i5 + (i7 * 56 | 0) + 16 >> 2] | 0) {
       i2 = HEAP32[i5 + (i7 * 56 | 0) + 4 >> 2] | 0;
       if ((i2 | 0) < 3) i3 = Math_imul(HEAP32[i5 + (i7 * 56 | 0) + 12 >> 2] | 0, HEAP32[i5 + (i7 * 56 | 0) + 8 >> 2] | 0) | 0; else {
        i1 = HEAP32[i5 + (i7 * 56 | 0) + 40 >> 2] | 0;
        i6 = 0;
        i3 = 1;
        do {
         i3 = Math_imul(HEAP32[i1 + (i6 << 2) >> 2] | 0, i3) | 0;
         i6 = i6 + 1 | 0;
        } while ((i6 | 0) != (i2 | 0));
       }
       if (i3) {
        HEAP32[i46 >> 2] = 0;
        HEAP32[i9 >> 2] = 0;
        i1 = (__ZN2cv6String8allocateEj(i46, 12) | 0) + 0 | 0;
        i26 = 31080 | 0;
        i50 = i1 + 12 | 0;
        do {
         HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
         i1 = i1 + 1 | 0;
         i26 = i26 + 1 | 0;
        } while ((i1 | 0) < (i50 | 0));
        __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i46, 27672, 27528, 2355);
        __ZN2cv6String10deallocateEv(i46);
        i4 = HEAP32[i11 >> 2] | 0;
        i5 = i4;
        i4 = HEAP32[i4 + (i7 * 56 | 0) >> 2] | 0;
       }
      }
      HEAP32[i5 + (i7 * 56 | 0) >> 2] = i4 & -4096 | i8;
     }
     i7 = i7 + 1 | 0;
    } while (i7 >>> 0 < i10 >>> 0);
    STACKTOP = i53;
    return;
   } else {
    i6 = HEAP32[i11 >> 2] | 0;
    if ((((HEAP32[i11 + 4 >> 2] | 0) - i6 | 0) / 56 | 0 | 0) <= (i44 | 0)) {
     HEAP32[i14 >> 2] = 0;
     HEAP32[i14 + 4 >> 2] = 0;
     i1 = (__ZN2cv6String8allocateEj(i14, 17) | 0) + 0 | 0;
     i26 = 31096 | 0;
     i50 = i1 + 17 | 0;
     do {
      HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
      i1 = i1 + 1 | 0;
      i26 = i26 + 1 | 0;
     } while ((i1 | 0) < (i50 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i14, 27672, 27528, 2362);
     __ZN2cv6String10deallocateEv(i14);
     i6 = HEAP32[i11 >> 2] | 0;
    }
    i9 = i6 + (i44 * 56 | 0) | 0;
    if (i43) {
     if (!(HEAP32[i9 >> 2] & 16384)) {
      if (!(!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 108 >> 2] & 127](i52) | 0) ? !(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 104 >> 2] & 127](i52) | 0) : 0)) {
       HEAP32[i20 >> 2] = 0;
       HEAP32[i20 + 4 >> 2] = 0;
       i1 = (__ZN2cv6String8allocateEj(i20, 28) | 0) + 0 | 0;
       i26 = 30304 | 0;
       i50 = i1 + 28 | 0;
       do {
        HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
        i1 = i1 + 1 | 0;
        i26 = i26 + 1 | 0;
       } while ((i1 | 0) < (i50 | 0));
       __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i20, 27672, 27528, 2369);
       __ZN2cv6String10deallocateEv(i20);
      }
      __ZN2cv3Mat7releaseEv(i9);
     }
     if ((((((i49 | 0) == 2 ? (HEAP32[i6 + (i44 * 56 | 0) + 4 >> 2] | 0) == 2 : 0) ? (HEAP32[i6 + (i44 * 56 | 0) + 16 >> 2] | 0) != 0 : 0) ? (HEAP32[i9 >> 2] & 4095 | 0) == (i2 | 0) : 0) ? (HEAP32[i6 + (i44 * 56 | 0) + 8 >> 2] | 0) == (HEAP32[i51 + 4 >> 2] | 0) : 0) ? (HEAP32[i6 + (i44 * 56 | 0) + 12 >> 2] | 0) == (HEAP32[i51 >> 2] | 0) : 0) {
      STACKTOP = i53;
      return;
     }
    }
    do if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 108 >> 2] & 127](i52) | 0) {
     i5 = HEAP32[i9 >> 2] | 0;
     if (((i5 ^ i48) & 4088 | 0) == 0 ? (1 << (HEAP32[i52 + 4 >> 2] & 4095) & i47 | 0) != 0 : 0) {
      i2 = i5 & 4095;
      break;
     }
     if ((i2 | 0) != (i5 & 4095 | 0)) {
      HEAP32[i24 >> 2] = 0;
      HEAP32[i24 + 4 >> 2] = 0;
      i1 = (__ZN2cv6String8allocateEj(i24, 30) | 0) + 0 | 0;
      i26 = 30336 | 0;
      i50 = i1 + 30 | 0;
      do {
       HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
       i1 = i1 + 1 | 0;
       i26 = i26 + 1 | 0;
      } while ((i1 | 0) < (i50 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i24, 27672, 27528, 2383);
      __ZN2cv6String10deallocateEv(i24);
     }
    } while (0);
    if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 104 >> 2] & 127](i52) | 0) {
     if ((HEAP32[i6 + (i44 * 56 | 0) + 4 >> 2] | 0) != (i49 | 0)) {
      HEAP32[i29 >> 2] = 0;
      HEAP32[i29 + 4 >> 2] = 0;
      i1 = (__ZN2cv6String8allocateEj(i29, 11) | 0) + 0 | 0;
      i26 = 30368 | 0;
      i50 = i1 + 11 | 0;
      do {
       HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
       i1 = i1 + 1 | 0;
       i26 = i26 + 1 | 0;
      } while ((i1 | 0) < (i50 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i29, 27672, 27528, 2387);
      __ZN2cv6String10deallocateEv(i29);
     }
     if ((i49 | 0) > 0) {
      i5 = i6 + (i44 * 56 | 0) + 40 | 0;
      i4 = i35 + 4 | 0;
      i3 = 0;
      do {
       if ((HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0) != (HEAP32[i51 + (i3 << 2) >> 2] | 0)) {
        HEAP32[i35 >> 2] = 0;
        HEAP32[i4 >> 2] = 0;
        i1 = (__ZN2cv6String8allocateEj(i35, 21) | 0) + 0 | 0;
        i26 = 30384 | 0;
        i50 = i1 + 21 | 0;
        do {
         HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
         i1 = i1 + 1 | 0;
         i26 = i26 + 1 | 0;
        } while ((i1 | 0) < (i50 | 0));
        __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i35, 27672, 27528, 2389);
        __ZN2cv6String10deallocateEv(i35);
       }
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) < (i49 | 0));
     }
    }
    __ZN2cv3Mat6createEiPKii(i9, i49, i51, i2);
    STACKTOP = i53;
    return;
   }
  } else if (!i4) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i7, 44) | 0) + 0 | 0;
   i26 = 31e3 | 0;
   i50 = i1 + 44 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i26 = i26 + 1 | 0;
   } while ((i1 | 0) < (i50 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i7, 27672, 27528, 2333);
   __ZN2cv6String10deallocateEv(i7);
   STACKTOP = i53;
   return;
  } else if ((i4 | 0) == 720896) {
   i11 = HEAP32[i52 + 8 >> 2] | 0;
   if ((i44 | 0) < 0) {
    if ((i49 | 0) == 2) {
     i5 = HEAP32[i51 >> 2] | 0;
     if ((i5 | 0) != 1) {
      i46 = HEAP32[i51 + 4 >> 2] | 0;
      if ((i46 | 0) == 1 | (Math_imul(i46, i5) | 0) == 0) i4 = i5; else i26 = 256;
     } else i4 = 1;
    } else i26 = 256;
    if ((i26 | 0) == 256) {
     HEAP32[i15 >> 2] = 0;
     HEAP32[i15 + 4 >> 2] = 0;
     i1 = (__ZN2cv6String8allocateEj(i15, 68) | 0) + 0 | 0;
     i26 = 30632 | 0;
     i50 = i1 + 68 | 0;
     do {
      HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
      i1 = i1 + 1 | 0;
      i26 = i26 + 1 | 0;
     } while ((i1 | 0) < (i50 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i15, 27672, 27528, 2402);
     __ZN2cv6String10deallocateEv(i15);
     i4 = HEAP32[i51 >> 2] | 0;
    }
    i5 = HEAP32[i51 + 4 >> 2] | 0;
    if ((Math_imul(i5, i4) | 0) > 0) i10 = i4 + -1 + i5 | 0; else i10 = 0;
    i6 = i11 + 4 | 0;
    i2 = ((HEAP32[i6 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0) / 48 | 0;
    if (!((i10 | 0) == (i2 | 0) | (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 104 >> 2] & 127](i52) | 0) ^ 1)) {
     HEAP32[i31 >> 2] = 0;
     HEAP32[i31 + 4 >> 2] = 0;
     i1 = (__ZN2cv6String8allocateEj(i31, 27) | 0) + 0 | 0;
     i26 = 31048 | 0;
     i50 = i1 + 27 | 0;
     do {
      HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
      i1 = i1 + 1 | 0;
      i26 = i26 + 1 | 0;
     } while ((i1 | 0) < (i50 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i31, 27672, 27528, 2405);
     __ZN2cv6String10deallocateEv(i31);
    }
    i5 = HEAP32[i6 >> 2] | 0;
    i4 = HEAP32[i11 >> 2] | 0;
    i3 = (i5 - i4 | 0) / 48 | 0;
    if (i10 >>> 0 <= i3 >>> 0) {
     if (i10 >>> 0 < i3 >>> 0 ? (i40 = i4 + (i10 * 48 | 0) | 0, (i5 | 0) != (i40 | 0)) : 0) do {
      i46 = i5 + -48 | 0;
      HEAP32[i6 >> 2] = i46;
      __ZN2cv4UMatD2Ev(i46);
      i5 = HEAP32[i6 >> 2] | 0;
     } while ((i5 | 0) != (i40 | 0));
    } else __ZNSt3__16vectorIN2cv4UMatENS_9allocatorIS2_EEE8__appendEj(i11, i10 - i3 | 0);
    if (!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 108 >> 2] & 127](i52) | 0)) {
     STACKTOP = i53;
     return;
    }
    i9 = HEAP32[i52 + 4 >> 2] & 4095;
    if (i2 >>> 0 >= i10 >>> 0) {
     STACKTOP = i53;
     return;
    }
    i8 = i45 + 4 | 0;
    i5 = HEAP32[i11 >> 2] | 0;
    i7 = i2;
    do {
     i4 = HEAP32[i5 + (i7 * 48 | 0) >> 2] | 0;
     if ((i4 & 4095 | 0) != (i9 | 0)) {
      if (HEAP32[i5 + (i7 * 48 | 0) + 24 >> 2] | 0) {
       i2 = HEAP32[i5 + (i7 * 48 | 0) + 4 >> 2] | 0;
       if ((i2 | 0) < 3) i3 = Math_imul(HEAP32[i5 + (i7 * 48 | 0) + 12 >> 2] | 0, HEAP32[i5 + (i7 * 48 | 0) + 8 >> 2] | 0) | 0; else {
        i1 = HEAP32[i5 + (i7 * 48 | 0) + 32 >> 2] | 0;
        i6 = 0;
        i3 = 1;
        do {
         i3 = Math_imul(HEAP32[i1 + (i6 << 2) >> 2] | 0, i3) | 0;
         i6 = i6 + 1 | 0;
        } while ((i6 | 0) != (i2 | 0));
       }
       if (i3) {
        HEAP32[i45 >> 2] = 0;
        HEAP32[i8 >> 2] = 0;
        i1 = (__ZN2cv6String8allocateEj(i45, 12) | 0) + 0 | 0;
        i26 = 31080 | 0;
        i50 = i1 + 12 | 0;
        do {
         HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
         i1 = i1 + 1 | 0;
         i26 = i26 + 1 | 0;
        } while ((i1 | 0) < (i50 | 0));
        __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i45, 27672, 27528, 2414);
        __ZN2cv6String10deallocateEv(i45);
        i4 = HEAP32[i11 >> 2] | 0;
        i5 = i4;
        i4 = HEAP32[i4 + (i7 * 48 | 0) >> 2] | 0;
       }
      }
      HEAP32[i5 + (i7 * 48 | 0) >> 2] = i4 & -4096 | i9;
     }
     i7 = i7 + 1 | 0;
    } while (i7 >>> 0 < i10 >>> 0);
    STACKTOP = i53;
    return;
   }
   i6 = HEAP32[i11 >> 2] | 0;
   if ((((HEAP32[i11 + 4 >> 2] | 0) - i6 | 0) / 48 | 0 | 0) > (i44 | 0)) i9 = i6; else {
    HEAP32[i17 >> 2] = 0;
    HEAP32[i17 + 4 >> 2] = 0;
    i1 = (__ZN2cv6String8allocateEj(i17, 17) | 0) + 0 | 0;
    i26 = 31096 | 0;
    i50 = i1 + 17 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i26 = i26 + 1 | 0;
    } while ((i1 | 0) < (i50 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i17, 27672, 27528, 2421);
    __ZN2cv6String10deallocateEv(i17);
    i9 = HEAP32[i11 >> 2] | 0;
   }
   i8 = i9 + (i44 * 48 | 0) | 0;
   if (i43) {
    if (!(HEAP32[i8 >> 2] & 16384)) {
     if (!(!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 108 >> 2] & 127](i52) | 0) ? !(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 104 >> 2] & 127](i52) | 0) : 0)) {
      HEAP32[i21 >> 2] = 0;
      HEAP32[i21 + 4 >> 2] = 0;
      i1 = (__ZN2cv6String8allocateEj(i21, 28) | 0) + 0 | 0;
      i26 = 30304 | 0;
      i50 = i1 + 28 | 0;
      do {
       HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
       i1 = i1 + 1 | 0;
       i26 = i26 + 1 | 0;
      } while ((i1 | 0) < (i50 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i21, 27672, 27528, 2428);
      __ZN2cv6String10deallocateEv(i21);
     }
     i6 = i9 + (i44 * 48 | 0) + 24 | 0;
     i5 = HEAP32[i6 >> 2] | 0;
     if ((i5 | 0) != 0 ? (i45 = i5 + 8 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv4UMat10deallocateEv(i8);
     HEAP32[HEAP32[i9 + (i44 * 48 | 0) + 32 >> 2] >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
    }
    if ((((((i49 | 0) == 2 ? (HEAP32[i9 + (i44 * 48 | 0) + 4 >> 2] | 0) == 2 : 0) ? (HEAP32[i9 + (i44 * 48 | 0) + 24 >> 2] | 0) != 0 : 0) ? (HEAP32[i8 >> 2] & 4095 | 0) == (i2 | 0) : 0) ? (HEAP32[i9 + (i44 * 48 | 0) + 8 >> 2] | 0) == (HEAP32[i51 + 4 >> 2] | 0) : 0) ? (HEAP32[i9 + (i44 * 48 | 0) + 12 >> 2] | 0) == (HEAP32[i51 >> 2] | 0) : 0) {
     STACKTOP = i53;
     return;
    }
   }
   do if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 108 >> 2] & 127](i52) | 0) {
    i5 = HEAP32[i8 >> 2] | 0;
    if (((i5 ^ i48) & 4088 | 0) == 0 ? (1 << (HEAP32[i52 + 4 >> 2] & 4095) & i47 | 0) != 0 : 0) {
     i2 = i5 & 4095;
     break;
    }
    if ((i2 | 0) != (i5 & 4095 | 0)) {
     HEAP32[i32 >> 2] = 0;
     HEAP32[i32 + 4 >> 2] = 0;
     i1 = (__ZN2cv6String8allocateEj(i32, 30) | 0) + 0 | 0;
     i26 = 30336 | 0;
     i50 = i1 + 30 | 0;
     do {
      HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
      i1 = i1 + 1 | 0;
      i26 = i26 + 1 | 0;
     } while ((i1 | 0) < (i50 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i32, 27672, 27528, 2442);
     __ZN2cv6String10deallocateEv(i32);
    }
   } while (0);
   if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 104 >> 2] & 127](i52) | 0) {
    if ((HEAP32[i9 + (i44 * 48 | 0) + 4 >> 2] | 0) != (i49 | 0)) {
     HEAP32[i34 >> 2] = 0;
     HEAP32[i34 + 4 >> 2] = 0;
     i1 = (__ZN2cv6String8allocateEj(i34, 11) | 0) + 0 | 0;
     i26 = 30368 | 0;
     i50 = i1 + 11 | 0;
     do {
      HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
      i1 = i1 + 1 | 0;
      i26 = i26 + 1 | 0;
     } while ((i1 | 0) < (i50 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i34, 27672, 27528, 2446);
     __ZN2cv6String10deallocateEv(i34);
    }
    if ((i49 | 0) > 0) {
     i5 = i9 + (i44 * 48 | 0) + 32 | 0;
     i4 = i39 + 4 | 0;
     i3 = 0;
     do {
      if ((HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0) != (HEAP32[i51 + (i3 << 2) >> 2] | 0)) {
       HEAP32[i39 >> 2] = 0;
       HEAP32[i4 >> 2] = 0;
       i1 = (__ZN2cv6String8allocateEj(i39, 21) | 0) + 0 | 0;
       i26 = 30384 | 0;
       i50 = i1 + 21 | 0;
       do {
        HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
        i1 = i1 + 1 | 0;
        i26 = i26 + 1 | 0;
       } while ((i1 | 0) < (i50 | 0));
       __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i39, 27672, 27528, 2448);
       __ZN2cv6String10deallocateEv(i39);
      }
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) < (i49 | 0));
    }
   }
   __ZN2cv4UMat6createEiPKiiNS_14UMatUsageFlagsE(i8, i49, i51, i2, 0);
   STACKTOP = i53;
   return;
  } else {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i8, 30) | 0) + 0 | 0;
   i26 = 28928 | 0;
   i50 = i1 + 30 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i26 = i26 + 1 | 0;
   } while ((i1 | 0) < (i50 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i8, 27672, 27528, 2455);
   __ZN2cv6String10deallocateEv(i8);
   STACKTOP = i53;
   return;
  }
 } else {
  if ((i44 | 0) >= 0) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i46 = __ZN2cv6String8allocateEj(i3, 5) | 0;
   HEAP8[i46 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i46 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i46 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i46 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i46 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 27672, 27528, 2207);
   __ZN2cv6String10deallocateEv(i3);
  }
  i9 = HEAP32[i52 + 8 >> 2] | 0;
  if (i43) {
   if (!(HEAP32[i9 >> 2] & 16384)) {
    if (!(!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 108 >> 2] & 127](i52) | 0) ? !(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 104 >> 2] & 127](i52) | 0) : 0)) {
     HEAP32[i10 >> 2] = 0;
     HEAP32[i10 + 4 >> 2] = 0;
     i1 = (__ZN2cv6String8allocateEj(i10, 28) | 0) + 0 | 0;
     i26 = 30304 | 0;
     i50 = i1 + 28 | 0;
     do {
      HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
      i1 = i1 + 1 | 0;
      i26 = i26 + 1 | 0;
     } while ((i1 | 0) < (i50 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 27672, 27528, 2213);
     __ZN2cv6String10deallocateEv(i10);
    }
    i5 = i9 + 24 | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    if ((i4 | 0) != 0 ? (i45 = i4 + 8 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv4UMat10deallocateEv(i9);
    HEAP32[HEAP32[i9 + 32 >> 2] >> 2] = 0;
    HEAP32[i5 >> 2] = 0;
   }
   if (((((((i49 | 0) == 2 ? (HEAP32[i9 + 4 >> 2] | 0) == 2 : 0) ? (HEAP32[i9 + 24 >> 2] | 0) != 0 : 0) ? (Math_imul(HEAP32[i9 + 12 >> 2] | 0, HEAP32[i9 + 8 >> 2] | 0) | 0) != 0 : 0) ? (HEAP32[i9 >> 2] & 4095 | 0) == (i2 | 0) : 0) ? (HEAP32[i9 + 8 >> 2] | 0) == (HEAP32[i51 + 4 >> 2] | 0) : 0) ? (HEAP32[i9 + 12 >> 2] | 0) == (HEAP32[i51 >> 2] | 0) : 0) {
    STACKTOP = i53;
    return;
   }
  }
  do if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 108 >> 2] & 127](i52) | 0) {
   i5 = HEAP32[i9 >> 2] | 0;
   if (((i5 ^ i48) & 4088 | 0) == 0 ? (1 << (HEAP32[i52 + 4 >> 2] & 4095) & i47 | 0) != 0 : 0) {
    i2 = i5 & 4095;
    break;
   }
   if ((i2 | 0) != (i5 & 4095 | 0)) {
    HEAP32[i19 >> 2] = 0;
    HEAP32[i19 + 4 >> 2] = 0;
    i1 = (__ZN2cv6String8allocateEj(i19, 30) | 0) + 0 | 0;
    i26 = 30336 | 0;
    i50 = i1 + 30 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i26 = i26 + 1 | 0;
    } while ((i1 | 0) < (i50 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i19, 27672, 27528, 2227);
    __ZN2cv6String10deallocateEv(i19);
   }
  } while (0);
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i52 >> 2] | 0) + 104 >> 2] & 127](i52) | 0) {
   if ((HEAP32[i9 + 4 >> 2] | 0) != (i49 | 0)) {
    HEAP32[i22 >> 2] = 0;
    HEAP32[i22 + 4 >> 2] = 0;
    i1 = (__ZN2cv6String8allocateEj(i22, 11) | 0) + 0 | 0;
    i26 = 30368 | 0;
    i50 = i1 + 11 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i26 = i26 + 1 | 0;
    } while ((i1 | 0) < (i50 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i22, 27672, 27528, 2231);
    __ZN2cv6String10deallocateEv(i22);
   }
   if ((i49 | 0) > 0) {
    i5 = i9 + 32 | 0;
    i4 = i33 + 4 | 0;
    i3 = 0;
    do {
     if ((HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0) != (HEAP32[i51 + (i3 << 2) >> 2] | 0)) {
      HEAP32[i33 >> 2] = 0;
      HEAP32[i4 >> 2] = 0;
      i1 = (__ZN2cv6String8allocateEj(i33, 21) | 0) + 0 | 0;
      i26 = 30384 | 0;
      i50 = i1 + 21 | 0;
      do {
       HEAP8[i1 >> 0] = HEAP8[i26 >> 0] | 0;
       i1 = i1 + 1 | 0;
       i26 = i26 + 1 | 0;
      } while ((i1 | 0) < (i50 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i33, 27672, 27528, 2233);
      __ZN2cv6String10deallocateEv(i33);
     }
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (i49 | 0));
   }
  }
  __ZN2cv4UMat6createEiPKiiNS_14UMatUsageFlagsE(i9, i49, i51, i2, 0);
  STACKTOP = i53;
  return;
 }
}
function _printf_core(i86, i5, i100, i102, i103) {
 i86 = i86 | 0;
 i5 = i5 | 0;
 i100 = i100 | 0;
 i102 = i102 | 0;
 i103 = i103 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i101 = 0, i104 = 0;
 i104 = STACKTOP;
 STACKTOP = STACKTOP + 864 | 0;
 i83 = i104 + 16 | 0;
 i85 = i104 + 8 | 0;
 i84 = i104 + 836 | 0;
 i53 = i84;
 i80 = i104 + 824 | 0;
 i91 = i104 + 568 | 0;
 i76 = i104 + 528 | 0;
 i97 = i104;
 i88 = i104 + 520 | 0;
 i54 = (i86 | 0) != 0;
 i70 = i76 + 40 | 0;
 i75 = i70;
 i76 = i76 + 39 | 0;
 i77 = i97 + 4 | 0;
 i78 = i97;
 i79 = i80 + 12 | 0;
 i80 = i80 + 11 | 0;
 i81 = i79;
 i55 = i81 - i53 | 0;
 i62 = -2 - i53 | 0;
 i63 = i81 + 2 | 0;
 i64 = i83 + 288 | 0;
 i65 = i84 + 9 | 0;
 i66 = i65;
 i67 = i84 + 8 | 0;
 i17 = 0;
 i16 = 0;
 i11 = 0;
 i4 = 0;
 i19 = 0;
 L1 : while (1) {
  do if ((i11 | 0) > -1) if ((i4 | 0) > (2147483647 - i11 | 0)) {
   HEAP32[(___errno_location() | 0) >> 2] = 75;
   i42 = -1;
   break;
  } else {
   i42 = i4 + i11 | 0;
   break;
  } else i42 = i11; while (0);
  i4 = HEAP8[i5 >> 0] | 0;
  if (!(i4 << 24 >> 24)) {
   i29 = 352;
   break;
  } else i3 = i5;
  while (1) {
   if (!(i4 << 24 >> 24)) {
    i48 = i3;
    i47 = i3;
    break;
   } else if (i4 << 24 >> 24 == 37) {
    i74 = i3;
    i98 = i3;
    i29 = 9;
    break;
   }
   i23 = i3 + 1 | 0;
   i4 = HEAP8[i23 >> 0] | 0;
   i3 = i23;
  }
  L12 : do if ((i29 | 0) == 9) while (1) {
   i29 = 0;
   if ((HEAP8[i74 + 1 >> 0] | 0) != 37) {
    i48 = i74;
    i47 = i98;
    break L12;
   }
   i3 = i98 + 1 | 0;
   i4 = i74 + 2 | 0;
   if ((HEAP8[i4 >> 0] | 0) == 37) {
    i74 = i4;
    i98 = i3;
   } else {
    i48 = i4;
    i47 = i3;
    break;
   }
  } while (0);
  i4 = i47 - i5 | 0;
  if (i54) ___fwritex(i5, i4, i86) | 0;
  if ((i47 | 0) != (i5 | 0)) {
   i5 = i48;
   i11 = i42;
   continue;
  }
  i8 = i48 + 1 | 0;
  i7 = HEAP8[i8 >> 0] | 0;
  i3 = (i7 << 24 >> 24) + -48 | 0;
  if (i3 >>> 0 < 10 ? (HEAP8[i48 + 2 >> 0] | 0) == 36 : 0) {
   i8 = i48 + 3 | 0;
   i7 = HEAP8[i8 >> 0] | 0;
   i14 = 1;
  } else {
   i3 = -1;
   i14 = i19;
  }
  i9 = i7 << 24 >> 24;
  L25 : do if ((i9 & -32 | 0) == 32) {
   i10 = 0;
   do {
    i9 = 1 << i9 + -32;
    if (!(i9 & 75913)) break L25;
    i10 = i9 | i10;
    i8 = i8 + 1 | 0;
    i7 = HEAP8[i8 >> 0] | 0;
    i9 = i7 << 24 >> 24;
   } while ((i9 & -32 | 0) == 32);
  } else i10 = 0; while (0);
  do if (i7 << 24 >> 24 == 42) {
   i7 = i8 + 1 | 0;
   i9 = (HEAP8[i7 >> 0] | 0) + -48 | 0;
   if (i9 >>> 0 < 10 ? (HEAP8[i8 + 2 >> 0] | 0) == 36 : 0) {
    HEAP32[i103 + (i9 << 2) >> 2] = 10;
    i11 = 1;
    i8 = i8 + 3 | 0;
    i9 = HEAP32[i102 + ((HEAP8[i7 >> 0] | 0) + -48 << 3) >> 2] | 0;
   } else {
    if (i14) {
     i99 = -1;
     i29 = 370;
     break L1;
    }
    if (!i54) {
     i8 = i7;
     i28 = 0;
     i26 = 0;
     break;
    }
    i11 = HEAP32[i100 >> 2] | 0;
    i9 = HEAP32[i11 >> 2] | 0;
    HEAP32[i100 >> 2] = i11 + 4;
    i11 = 0;
    i8 = i7;
   }
   if ((i9 | 0) < 0) {
    i10 = i10 | 8192;
    i28 = i11;
    i26 = 0 - i9 | 0;
   } else {
    i28 = i11;
    i26 = i9;
   }
  } else {
   i7 = i7 << 24 >> 24;
   if ((i7 + -48 | 0) >>> 0 < 10) {
    i11 = 0;
    do {
     i11 = i7 + -48 + (i11 * 10 | 0) | 0;
     i8 = i8 + 1 | 0;
     i7 = HEAP8[i8 >> 0] | 0;
    } while ((i7 + -48 | 0) >>> 0 < 10);
    if ((i11 | 0) < 0) {
     i99 = -1;
     i29 = 370;
     break L1;
    } else {
     i28 = i14;
     i26 = i11;
    }
   } else {
    i28 = i14;
    i26 = 0;
   }
  } while (0);
  L46 : do if ((HEAP8[i8 >> 0] | 0) == 46) {
   i11 = i8 + 1 | 0;
   i9 = HEAP8[i11 >> 0] | 0;
   if (i9 << 24 >> 24 != 42) {
    i7 = i9 << 24 >> 24;
    if ((i7 + -48 | 0) >>> 0 < 10) {
     i8 = i11;
     i9 = 0;
    } else {
     i8 = i11;
     i20 = 0;
     break;
    }
    while (1) {
     i9 = i7 + -48 + (i9 * 10 | 0) | 0;
     i8 = i8 + 1 | 0;
     i7 = HEAP8[i8 >> 0] | 0;
     if ((i7 + -48 | 0) >>> 0 >= 10) {
      i20 = i9;
      break L46;
     }
    }
   }
   i7 = i8 + 2 | 0;
   i9 = (HEAP8[i7 >> 0] | 0) + -48 | 0;
   if (i9 >>> 0 < 10 ? (HEAP8[i8 + 3 >> 0] | 0) == 36 : 0) {
    HEAP32[i103 + (i9 << 2) >> 2] = 10;
    i8 = i8 + 4 | 0;
    i20 = HEAP32[i102 + ((HEAP8[i7 >> 0] | 0) + -48 << 3) >> 2] | 0;
    break;
   }
   if (i28) {
    i99 = -1;
    i29 = 370;
    break L1;
   }
   if (i54) {
    i8 = HEAP32[i100 >> 2] | 0;
    i20 = HEAP32[i8 >> 2] | 0;
    HEAP32[i100 >> 2] = i8 + 4;
    i8 = i7;
   } else {
    i8 = i7;
    i20 = 0;
   }
  } else i20 = -1; while (0);
  i14 = 0;
  while (1) {
   i12 = HEAP8[i8 >> 0] | 0;
   i11 = (i12 << 24 >> 24) + -65 | 0;
   if (i11 >>> 0 > 57) {
    i99 = -1;
    i29 = 370;
    break L1;
   }
   i27 = i8 + 1 | 0;
   i11 = HEAP8[970976 + (i14 * 58 | 0) + i11 >> 0] | 0;
   i9 = i11 & 255;
   if ((i9 + -1 | 0) >>> 0 < 8) {
    i8 = i27;
    i14 = i9;
   } else break;
  }
  if (!(i11 << 24 >> 24)) {
   i99 = -1;
   i29 = 370;
   break;
  }
  i7 = (i3 | 0) > -1;
  L65 : do if (i11 << 24 >> 24 == 19) if (i7) {
   i99 = -1;
   i29 = 370;
   break L1;
  } else {
   i56 = i17;
   i57 = i16;
   i29 = 63;
  } else {
   if (i7) {
    HEAP32[i103 + (i3 << 2) >> 2] = i9;
    i57 = i102 + (i3 << 3) | 0;
    i56 = HEAP32[i57 >> 2] | 0;
    i57 = HEAP32[i57 + 4 >> 2] | 0;
    i29 = 63;
    break;
   }
   if (!i54) {
    i99 = 0;
    i29 = 370;
    break L1;
   }
   if ((i11 & 255) > 20) {
    i68 = i12;
    i69 = i17;
    i71 = i16;
   } else do switch (i9 | 0) {
   case 17:
    {
     i58 = HEAP32[i100 >> 2] | 0;
     HEAP32[tempDoublePtr >> 2] = HEAP32[i58 >> 2];
     HEAP32[tempDoublePtr + 4 >> 2] = HEAP32[i58 + 4 >> 2];
     d6 = +HEAPF64[tempDoublePtr >> 3];
     HEAP32[i100 >> 2] = i58 + 8;
     HEAPF64[tempDoublePtr >> 3] = d6;
     i58 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
     i59 = HEAP32[tempDoublePtr >> 2] | 0;
     i29 = 64;
     break L65;
    }
   case 13:
    {
     i58 = HEAP32[i100 >> 2] | 0;
     i59 = HEAP32[i58 >> 2] | 0;
     HEAP32[i100 >> 2] = i58 + 4;
     i58 = (((i59 & 65535) << 16 >> 16 | 0) < 0) << 31 >> 31;
     i59 = i59 << 16 >> 16;
     i29 = 64;
     break L65;
    }
   case 14:
    {
     i58 = HEAP32[i100 >> 2] | 0;
     i59 = HEAP32[i58 >> 2] | 0;
     HEAP32[i100 >> 2] = i58 + 4;
     i58 = 0;
     i59 = i59 & 65535;
     i29 = 64;
     break L65;
    }
   case 18:
    {
     i56 = HEAP32[i100 >> 2] | 0;
     HEAP32[tempDoublePtr >> 2] = HEAP32[i56 >> 2];
     HEAP32[tempDoublePtr + 4 >> 2] = HEAP32[i56 + 4 >> 2];
     d6 = +HEAPF64[tempDoublePtr >> 3];
     HEAP32[i100 >> 2] = i56 + 8;
     HEAPF64[tempDoublePtr >> 3] = d6;
     i56 = HEAP32[tempDoublePtr >> 2] | 0;
     i57 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
     i29 = 63;
     break L65;
    }
   case 10:
    {
     i58 = HEAP32[i100 >> 2] | 0;
     i59 = HEAP32[i58 >> 2] | 0;
     HEAP32[i100 >> 2] = i58 + 4;
     i58 = ((i59 | 0) < 0) << 31 >> 31;
     i29 = 64;
     break L65;
    }
   case 11:
    {
     i58 = HEAP32[i100 >> 2] | 0;
     i59 = HEAP32[i58 >> 2] | 0;
     HEAP32[i100 >> 2] = i58 + 4;
     i58 = 0;
     i29 = 64;
     break L65;
    }
   case 16:
    {
     i58 = HEAP32[i100 >> 2] | 0;
     i59 = HEAP32[i58 >> 2] | 0;
     HEAP32[i100 >> 2] = i58 + 4;
     i58 = 0;
     i59 = i59 & 255;
     i29 = 64;
     break L65;
    }
   case 12:
    {
     i29 = HEAP32[i100 >> 2] | 0;
     i58 = i29;
     i59 = HEAP32[i58 >> 2] | 0;
     i58 = HEAP32[i58 + 4 >> 2] | 0;
     HEAP32[i100 >> 2] = i29 + 8;
     i29 = 64;
     break L65;
    }
   case 9:
    {
     i58 = HEAP32[i100 >> 2] | 0;
     i59 = HEAP32[i58 >> 2] | 0;
     HEAP32[i100 >> 2] = i58 + 4;
     i58 = i16;
     i29 = 64;
     break L65;
    }
   case 15:
    {
     i58 = HEAP32[i100 >> 2] | 0;
     i59 = HEAP32[i58 >> 2] | 0;
     HEAP32[i100 >> 2] = i58 + 4;
     i58 = (((i59 & 255) << 24 >> 24 | 0) < 0) << 31 >> 31;
     i59 = i59 << 24 >> 24;
     i29 = 64;
     break L65;
    }
   default:
    {
     i58 = i16;
     i59 = i17;
     i29 = 64;
     break L65;
    }
   } while (0);
  } while (0);
  if ((i29 | 0) == 63) {
   i29 = 0;
   if (i54) {
    i58 = i57;
    i59 = i56;
    i29 = 64;
   } else {
    i17 = i56;
    i16 = i57;
    i5 = i27;
    i11 = i42;
    i19 = i28;
    continue;
   }
  }
  if ((i29 | 0) == 64) {
   i29 = 0;
   i68 = HEAP8[i8 >> 0] | 0;
   i69 = i59;
   i71 = i58;
  }
  i21 = i68 << 24 >> 24;
  i21 = (i14 | 0) != 0 & (i21 & 15 | 0) == 3 ? i21 & -33 : i21;
  i12 = i10 & -65537;
  i25 = (i10 & 8192 | 0) == 0 ? i10 : i12;
  L89 : do switch (i21 | 0) {
  case 105:
  case 100:
   {
    if ((i71 | 0) < 0) {
     i73 = _i64Subtract(0, 0, i69 | 0, i71 | 0) | 0;
     i72 = tempRet0;
     i92 = 1;
     i93 = 971440;
     i29 = 86;
     break L89;
    }
    if (!(i25 & 2048)) {
     i93 = i25 & 1;
     i72 = i71;
     i73 = i69;
     i92 = i93;
     i93 = (i93 | 0) == 0 ? 971440 : 971442;
     i29 = 86;
    } else {
     i72 = i71;
     i73 = i69;
     i92 = 1;
     i93 = 971441;
     i29 = 86;
    }
    break;
   }
  case 83:
   {
    i5 = i69;
    if (!i20) {
     i40 = i69;
     i41 = i5;
     i39 = 0;
     i29 = 106;
    } else {
     i60 = i5;
     i61 = i69;
     i90 = i20;
     i29 = 101;
    }
    break;
   }
  case 109:
   {
    i82 = _strerror(HEAP32[(___errno_location() | 0) >> 2] | 0) | 0;
    i29 = 96;
    break;
   }
  case 115:
   {
    i82 = (i69 | 0) == 0 ? 971456 : i69;
    i29 = 96;
    break;
   }
  case 110:
   switch (i14 | 0) {
   case 7:
    {
     i17 = i69;
     HEAP32[i17 >> 2] = i42;
     HEAP32[i17 + 4 >> 2] = ((i42 | 0) < 0) << 31 >> 31;
     i17 = i69;
     i16 = i71;
     i5 = i27;
     i11 = i42;
     i19 = i28;
     continue L1;
    }
   case 0:
    {
     HEAP32[i69 >> 2] = i42;
     i17 = i69;
     i16 = i71;
     i5 = i27;
     i11 = i42;
     i19 = i28;
     continue L1;
    }
   case 3:
    {
     HEAP16[i69 >> 1] = i42;
     i17 = i69;
     i16 = i71;
     i5 = i27;
     i11 = i42;
     i19 = i28;
     continue L1;
    }
   case 1:
    {
     HEAP32[i69 >> 2] = i42;
     i17 = i69;
     i16 = i71;
     i5 = i27;
     i11 = i42;
     i19 = i28;
     continue L1;
    }
   case 4:
    {
     HEAP8[i69 >> 0] = i42;
     i17 = i69;
     i16 = i71;
     i5 = i27;
     i11 = i42;
     i19 = i28;
     continue L1;
    }
   case 6:
    {
     HEAP32[i69 >> 2] = i42;
     i17 = i69;
     i16 = i71;
     i5 = i27;
     i11 = i42;
     i19 = i28;
     continue L1;
    }
   case 2:
    {
     i17 = i69;
     HEAP32[i17 >> 2] = i42;
     HEAP32[i17 + 4 >> 2] = ((i42 | 0) < 0) << 31 >> 31;
     i17 = i69;
     i16 = i71;
     i5 = i27;
     i11 = i42;
     i19 = i28;
     continue L1;
    }
   default:
    {
     i17 = i69;
     i16 = i71;
     i5 = i27;
     i11 = i42;
     i19 = i28;
     continue L1;
    }
   }
  case 112:
   {
    i87 = i25 | 8;
    i89 = i20 >>> 0 > 8 ? i20 : 8;
    i96 = 120;
    i29 = 75;
    break;
   }
  case 117:
   {
    i72 = i71;
    i73 = i69;
    i92 = 0;
    i93 = 971440;
    i29 = 86;
    break;
   }
  case 99:
   {
    HEAP8[i76 >> 0] = i69;
    i49 = i69;
    i50 = i71;
    i51 = i76;
    i1 = i12;
    i44 = 1;
    i45 = 0;
    i46 = 971440;
    i43 = i70;
    break;
   }
  case 88:
  case 120:
   {
    i87 = i25;
    i89 = i20;
    i96 = i21;
    i29 = 75;
    break;
   }
  case 111:
   {
    i3 = (i69 | 0) == 0 & (i71 | 0) == 0;
    if (i3) i2 = i70; else {
     i2 = i70;
     i5 = i69;
     i4 = i71;
     do {
      i2 = i2 + -1 | 0;
      HEAP8[i2 >> 0] = i5 & 7 | 48;
      i5 = _bitshift64Lshr(i5 | 0, i4 | 0, 3) | 0;
      i4 = tempRet0;
     } while (!((i5 | 0) == 0 & (i4 | 0) == 0));
    }
    i33 = (i25 & 8 | 0) == 0 | i3;
    i36 = i69;
    i37 = i71;
    i30 = i25;
    i31 = i20;
    i32 = i33 & 1 ^ 1;
    i33 = i33 ? 971440 : 971445;
    i29 = 91;
    break;
   }
  case 67:
   {
    HEAP32[i97 >> 2] = i69;
    HEAP32[i77 >> 2] = 0;
    i60 = i97;
    i61 = i78;
    i90 = -1;
    i29 = 101;
    break;
   }
  case 65:
  case 71:
  case 70:
  case 69:
  case 97:
  case 103:
  case 102:
  case 101:
   {
    HEAP32[tempDoublePtr >> 2] = i69;
    HEAP32[tempDoublePtr + 4 >> 2] = i71;
    d6 = +HEAPF64[tempDoublePtr >> 3];
    HEAP32[i85 >> 2] = 0;
    if ((i71 | 0) >= 0) if (!(i25 & 2048)) {
     i24 = i25 & 1;
     i22 = i24;
     i24 = (i24 | 0) == 0 ? 971465 : 971470;
    } else {
     i22 = 1;
     i24 = 971467;
    } else {
     d6 = -d6;
     i22 = 1;
     i24 = 971464;
    }
    HEAPF64[tempDoublePtr >> 3] = d6;
    i23 = HEAP32[tempDoublePtr + 4 >> 2] & 2146435072;
    if (!(i23 >>> 0 < 2146435072 | (i23 | 0) == 2146435072 & 0 < 0)) {
     i7 = (i21 & 32 | 0) != 0;
     if (d6 != d6 | 0.0 != 0.0) {
      i8 = 0;
      i9 = i7 ? 971504 : 971512;
     } else {
      i8 = i22;
      i9 = i7 ? 971488 : 971496;
     }
     i12 = i8 + 3 | 0;
     i3 = (i26 | 0) > (i12 | 0);
     if ((i25 & 8192 | 0) == 0 & i3) {
      i7 = i26 - i12 | 0;
      _memset(i91 | 0, 32, (i7 >>> 0 > 256 ? 256 : i7) | 0) | 0;
      if (i7 >>> 0 > 255) {
       i5 = i7;
       do {
        ___fwritex(i91, 256, i86) | 0;
        i5 = i5 + -256 | 0;
       } while (i5 >>> 0 > 255);
       i7 = i7 & 255;
      }
      ___fwritex(i91, i7, i86) | 0;
     }
     ___fwritex(i24, i8, i86) | 0;
     ___fwritex(i9, 3, i86) | 0;
     if ((i25 & 73728 | 0) == 8192 & i3) {
      i5 = i26 - i12 | 0;
      _memset(i91 | 0, 32, (i5 >>> 0 > 256 ? 256 : i5) | 0) | 0;
      if (i5 >>> 0 > 255) {
       i4 = i5;
       do {
        ___fwritex(i91, 256, i86) | 0;
        i4 = i4 + -256 | 0;
       } while (i4 >>> 0 > 255);
       i5 = i5 & 255;
      }
      ___fwritex(i91, i5, i86) | 0;
     }
     i17 = i69;
     i16 = i71;
     i5 = i27;
     i11 = i42;
     i4 = i3 ? i26 : i12;
     i19 = i28;
     continue L1;
    }
    d13 = +_frexpl(d6, i85) * 2.0;
    i9 = d13 != 0.0;
    if (i9) HEAP32[i85 >> 2] = (HEAP32[i85 >> 2] | 0) + -1;
    i19 = i21 | 32;
    if ((i19 | 0) == 97) {
     i15 = i21 & 32;
     i16 = (i15 | 0) == 0 ? i24 : i24 + 9 | 0;
     i4 = i22 | 2;
     i9 = i20 >>> 0 > 11 ? 0 : 12 - i20 | 0;
     do if (i9) {
      d6 = 8.0;
      do {
       i9 = i9 + -1 | 0;
       d6 = d6 * 16.0;
      } while ((i9 | 0) != 0);
      if ((HEAP8[i16 >> 0] | 0) == 45) {
       d6 = -(d6 + (-d13 - d6));
       break;
      } else {
       d6 = d13 + d6 - d6;
       break;
      }
     } else d6 = d13; while (0);
     i8 = HEAP32[i85 >> 2] | 0;
     i8 = (i8 | 0) < 0 ? 0 - i8 | 0 : i8;
     if ((i8 | 0) < 0) {
      i7 = i79;
      i9 = i8;
      i8 = ((i8 | 0) < 0) << 31 >> 31;
      while (1) {
       i23 = ___uremdi3(i9 | 0, i8 | 0, 10, 0) | 0;
       i7 = i7 + -1 | 0;
       HEAP8[i7 >> 0] = i23 | 48;
       i23 = i9;
       i9 = ___udivdi3(i9 | 0, i8 | 0, 10, 0) | 0;
       if (!(i8 >>> 0 > 9 | (i8 | 0) == 9 & i23 >>> 0 > 4294967295)) break; else i8 = tempRet0;
      }
     } else {
      i7 = i79;
      i9 = i8;
     }
     if (i9) while (1) {
      i7 = i7 + -1 | 0;
      HEAP8[i7 >> 0] = (i9 >>> 0) % 10 | 0 | 48;
      if (i9 >>> 0 < 10) break; else i9 = (i9 >>> 0) / 10 | 0;
     }
     if ((i7 | 0) == (i79 | 0)) {
      HEAP8[i80 >> 0] = 48;
      i7 = i80;
     }
     HEAP8[i7 + -1 >> 0] = (HEAP32[i85 >> 2] >> 31 & 2) + 43;
     i11 = i7 + -2 | 0;
     HEAP8[i11 >> 0] = i21 + 15;
     if ((i20 | 0) < 1) if (!(i25 & 8)) {
      i7 = i84;
      do {
       i23 = ~~d6;
       i9 = i7 + 1 | 0;
       HEAP8[i7 >> 0] = HEAPU8[971520 + i23 >> 0] | i15;
       d6 = (d6 - +(i23 | 0)) * 16.0;
       if ((i9 - i53 | 0) != 1 | d6 == 0.0) i7 = i9; else {
        HEAP8[i9 >> 0] = 46;
        i7 = i7 + 2 | 0;
       }
      } while (d6 != 0.0);
     } else {
      i7 = i84;
      do {
       i23 = ~~d6;
       i9 = i7 + 1 | 0;
       HEAP8[i7 >> 0] = HEAPU8[971520 + i23 >> 0] | i15;
       d6 = (d6 - +(i23 | 0)) * 16.0;
       if ((i9 - i53 | 0) == 1) {
        HEAP8[i9 >> 0] = 46;
        i7 = i7 + 2 | 0;
       } else i7 = i9;
      } while (d6 != 0.0);
     } else {
      i7 = i84;
      do {
       i23 = ~~d6;
       i9 = i7 + 1 | 0;
       HEAP8[i7 >> 0] = HEAPU8[971520 + i23 >> 0] | i15;
       d6 = (d6 - +(i23 | 0)) * 16.0;
       if ((i9 - i53 | 0) == 1) {
        HEAP8[i9 >> 0] = 46;
        i7 = i7 + 2 | 0;
       } else i7 = i9;
      } while (d6 != 0.0);
     }
     i5 = i11;
     if ((i20 | 0) != 0 & (i62 + i7 | 0) < (i20 | 0)) i12 = i63 + i20 - i5 | 0; else i12 = i55 - i5 + i7 | 0;
     i10 = i12 + i4 | 0;
     i3 = i25 & 73728;
     i14 = (i26 | 0) > (i10 | 0);
     if ((i3 | 0) == 0 & i14) {
      i9 = i26 - i10 | 0;
      _memset(i91 | 0, 32, (i9 >>> 0 > 256 ? 256 : i9) | 0) | 0;
      if (i9 >>> 0 > 255) {
       i8 = i9;
       do {
        ___fwritex(i91, 256, i86) | 0;
        i8 = i8 + -256 | 0;
       } while (i8 >>> 0 > 255);
       i9 = i9 & 255;
      }
      ___fwritex(i91, i9, i86) | 0;
     }
     ___fwritex(i16, i4, i86) | 0;
     if ((i3 | 0) == 65536 & i14) {
      i5 = i26 - i10 | 0;
      _memset(i91 | 0, 48, (i5 >>> 0 > 256 ? 256 : i5) | 0) | 0;
      if (i5 >>> 0 > 255) {
       i4 = i5;
       do {
        ___fwritex(i91, 256, i86) | 0;
        i4 = i4 + -256 | 0;
       } while (i4 >>> 0 > 255);
       i5 = i5 & 255;
      }
      ___fwritex(i91, i5, i86) | 0;
     }
     i7 = i7 - i53 | 0;
     ___fwritex(i84, i7, i86) | 0;
     i9 = i81 - i11 | 0;
     i7 = i12 - i9 - i7 | 0;
     if ((i7 | 0) > 0) {
      _memset(i91 | 0, 48, (i7 >>> 0 > 256 ? 256 : i7) | 0) | 0;
      if (i7 >>> 0 > 255) {
       i5 = i7;
       do {
        ___fwritex(i91, 256, i86) | 0;
        i5 = i5 + -256 | 0;
       } while (i5 >>> 0 > 255);
       i7 = i7 & 255;
      }
      ___fwritex(i91, i7, i86) | 0;
     }
     ___fwritex(i11, i9, i86) | 0;
     if ((i3 | 0) == 8192 & i14) {
      i5 = i26 - i10 | 0;
      _memset(i91 | 0, 32, (i5 >>> 0 > 256 ? 256 : i5) | 0) | 0;
      if (i5 >>> 0 > 255) {
       i4 = i5;
       do {
        ___fwritex(i91, 256, i86) | 0;
        i4 = i4 + -256 | 0;
       } while (i4 >>> 0 > 255);
       i5 = i5 & 255;
      }
      ___fwritex(i91, i5, i86) | 0;
     }
     i17 = i69;
     i16 = i71;
     i5 = i27;
     i11 = i42;
     i4 = i14 ? i26 : i10;
     i19 = i28;
     continue L1;
    }
    i5 = (i20 | 0) < 0 ? 6 : i20;
    if (i9) {
     i9 = (HEAP32[i85 >> 2] | 0) + -28 | 0;
     HEAP32[i85 >> 2] = i9;
     d6 = d13 * 268435456.0;
    } else {
     d6 = d13;
     i9 = HEAP32[i85 >> 2] | 0;
    }
    i23 = (i9 | 0) < 0 ? i83 : i64;
    i18 = i23;
    i11 = i23;
    do {
     i20 = ~~d6 >>> 0;
     HEAP32[i11 >> 2] = i20;
     i11 = i11 + 4 | 0;
     d6 = (d6 - +(i20 >>> 0)) * 1.0e9;
    } while (d6 != 0.0);
    i9 = HEAP32[i85 >> 2] | 0;
    if ((i9 | 0) > 0) {
     i10 = i9;
     i9 = i23;
     while (1) {
      i12 = (i10 | 0) > 29 ? 29 : i10;
      i10 = i11 + -4 | 0;
      do if (i10 >>> 0 >= i9 >>> 0) {
       i8 = 0;
       do {
        i17 = _bitshift64Shl(HEAP32[i10 >> 2] | 0, 0, i12 | 0) | 0;
        i17 = _i64Add(i17 | 0, tempRet0 | 0, i8 | 0, 0) | 0;
        i20 = tempRet0;
        i16 = ___uremdi3(i17 | 0, i20 | 0, 1e9, 0) | 0;
        HEAP32[i10 >> 2] = i16;
        i8 = ___udivdi3(i17 | 0, i20 | 0, 1e9, 0) | 0;
        i10 = i10 + -4 | 0;
       } while (i10 >>> 0 >= i9 >>> 0);
       if (!i8) break;
       i9 = i9 + -4 | 0;
       HEAP32[i9 >> 2] = i8;
      } while (0);
      i3 = i11;
      while (1) {
       if (i3 >>> 0 <= i9 >>> 0) break;
       i11 = i3 + -4 | 0;
       if (!(HEAP32[i11 >> 2] | 0)) i3 = i11; else break;
      }
      i10 = (HEAP32[i85 >> 2] | 0) - i12 | 0;
      HEAP32[i85 >> 2] = i10;
      if ((i10 | 0) > 0) i11 = i3; else {
       i11 = i3;
       break;
      }
     }
    } else {
     i10 = i9;
     i9 = i23;
    }
    L247 : do if ((i10 | 0) < 0) {
     i15 = ((i5 + 25 | 0) / 9 | 0) + 1 | 0;
     if ((i19 | 0) == 102) {
      i8 = i23 + (i15 << 2) | 0;
      while (1) {
       i14 = 0 - i10 | 0;
       i14 = (i14 | 0) > 9 ? 9 : i14;
       do if (i9 >>> 0 < i11 >>> 0) {
        i12 = (1 << i14) + -1 | 0;
        i3 = 1e9 >>> i14;
        i7 = 0;
        i4 = i9;
        do {
         i20 = HEAP32[i4 >> 2] | 0;
         HEAP32[i4 >> 2] = (i20 >>> i14) + i7;
         i7 = Math_imul(i20 & i12, i3) | 0;
         i4 = i4 + 4 | 0;
        } while (i4 >>> 0 < i11 >>> 0);
        i9 = (HEAP32[i9 >> 2] | 0) == 0 ? i9 + 4 | 0 : i9;
        if (!i7) break;
        HEAP32[i11 >> 2] = i7;
        i11 = i11 + 4 | 0;
       } else i9 = (HEAP32[i9 >> 2] | 0) == 0 ? i9 + 4 | 0 : i9; while (0);
       i11 = (i11 - i18 >> 2 | 0) > (i15 | 0) ? i8 : i11;
       i10 = (HEAP32[i85 >> 2] | 0) + i14 | 0;
       HEAP32[i85 >> 2] = i10;
       if ((i10 | 0) >= 0) {
        i16 = i11;
        break L247;
       }
      }
     }
     do {
      i14 = 0 - i10 | 0;
      i14 = (i14 | 0) > 9 ? 9 : i14;
      do if (i9 >>> 0 < i11 >>> 0) {
       i12 = (1 << i14) + -1 | 0;
       i3 = 1e9 >>> i14;
       i7 = 0;
       i4 = i9;
       do {
        i20 = HEAP32[i4 >> 2] | 0;
        HEAP32[i4 >> 2] = (i20 >>> i14) + i7;
        i7 = Math_imul(i20 & i12, i3) | 0;
        i4 = i4 + 4 | 0;
       } while (i4 >>> 0 < i11 >>> 0);
       i9 = (HEAP32[i9 >> 2] | 0) == 0 ? i9 + 4 | 0 : i9;
       if (!i7) break;
       HEAP32[i11 >> 2] = i7;
       i11 = i11 + 4 | 0;
      } else i9 = (HEAP32[i9 >> 2] | 0) == 0 ? i9 + 4 | 0 : i9; while (0);
      if ((i11 - i9 >> 2 | 0) > (i15 | 0)) i11 = i9 + (i15 << 2) | 0;
      i10 = (HEAP32[i85 >> 2] | 0) + i14 | 0;
      HEAP32[i85 >> 2] = i10;
     } while ((i10 | 0) < 0);
     i16 = i11;
    } else i16 = i11; while (0);
    do if (i9 >>> 0 < i16 >>> 0) {
     i11 = (i18 - i9 >> 2) * 9 | 0;
     i12 = HEAP32[i9 >> 2] | 0;
     if (i12 >>> 0 < 10) break; else i10 = 10;
     do {
      i10 = i10 * 10 | 0;
      i11 = i11 + 1 | 0;
     } while (i12 >>> 0 >= i10 >>> 0);
    } else i11 = 0; while (0);
    i15 = (i19 | 0) == 103;
    i10 = i5 - ((i19 | 0) != 102 ? i11 : 0) + ((i15 & (i5 | 0) != 0) << 31 >> 31) | 0;
    if ((i10 | 0) < (((i16 - i18 >> 2) * 9 | 0) + -9 | 0)) {
     i3 = i10 + 9216 | 0;
     i7 = (i3 | 0) / 9 | 0;
     i8 = i23 + (i7 + -1023 << 2) | 0;
     i3 = ((i3 | 0) % 9 | 0) + 1 | 0;
     if ((i3 | 0) < 9) {
      i12 = 10;
      do {
       i12 = i12 * 10 | 0;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != 9);
     } else i12 = 10;
     i14 = HEAP32[i8 >> 2] | 0;
     i4 = (i14 >>> 0) % (i12 >>> 0) | 0;
     if ((i4 | 0) == 0 ? (i23 + (i7 + -1022 << 2) | 0) == (i16 | 0) : 0) {
      i38 = i9;
      i35 = i8;
      i34 = i11;
     } else i29 = 232;
     do if ((i29 | 0) == 232) {
      i29 = 0;
      d6 = (((i14 >>> 0) / (i12 >>> 0) | 0) & 1 | 0) == 0 ? 9007199254740992.0 : 9007199254740994.0;
      i3 = (i12 | 0) / 2 | 0;
      do if (i4 >>> 0 < i3 >>> 0) d13 = .5; else {
       if ((i4 | 0) == (i3 | 0) ? (i23 + (i7 + -1022 << 2) | 0) == (i16 | 0) : 0) {
        d13 = 1.0;
        break;
       }
       d13 = 1.5;
      } while (0);
      do if (i22) {
       if ((HEAP8[i24 >> 0] | 0) != 45) break;
       d6 = d6 * -1.0;
       d13 = d13 * -1.0;
      } while (0);
      i10 = i14 - i4 | 0;
      HEAP32[i8 >> 2] = i10;
      if (!(d6 + d13 != d6)) {
       i38 = i9;
       i35 = i8;
       i34 = i11;
       break;
      }
      i20 = i10 + i12 | 0;
      HEAP32[i8 >> 2] = i20;
      if (i20 >>> 0 > 999999999) while (1) {
       i10 = i8 + -4 | 0;
       HEAP32[i8 >> 2] = 0;
       if (i10 >>> 0 < i9 >>> 0) {
        i9 = i9 + -4 | 0;
        HEAP32[i9 >> 2] = 0;
       }
       i20 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
       HEAP32[i10 >> 2] = i20;
       if (i20 >>> 0 > 999999999) i8 = i10; else {
        i8 = i10;
        break;
       }
      }
      i11 = (i18 - i9 >> 2) * 9 | 0;
      i7 = HEAP32[i9 >> 2] | 0;
      if (i7 >>> 0 < 10) {
       i38 = i9;
       i35 = i8;
       i34 = i11;
       break;
      } else i10 = 10;
      do {
       i10 = i10 * 10 | 0;
       i11 = i11 + 1 | 0;
      } while (i7 >>> 0 >= i10 >>> 0);
      i38 = i9;
      i35 = i8;
      i34 = i11;
     } while (0);
     i10 = i35 + 4 | 0;
     i9 = i38;
     i11 = i34;
     i10 = i16 >>> 0 > i10 >>> 0 ? i10 : i16;
    } else i10 = i16;
    i7 = 0 - i11 | 0;
    i20 = i10;
    while (1) {
     if (i20 >>> 0 <= i9 >>> 0) {
      i17 = 0;
      break;
     }
     i10 = i20 + -4 | 0;
     if (!(HEAP32[i10 >> 2] | 0)) i20 = i10; else {
      i17 = 1;
      break;
     }
    }
    do if (i15) {
     i10 = ((i5 | 0) == 0 & 1) + i5 | 0;
     if ((i10 | 0) > (i11 | 0) & (i11 | 0) > -5) {
      i14 = i21 + -1 | 0;
      i5 = i10 + -1 - i11 | 0;
     } else {
      i14 = i21 + -2 | 0;
      i5 = i10 + -1 | 0;
     }
     if (i25 & 8) break;
     do if (i17) {
      i12 = HEAP32[i20 + -4 >> 2] | 0;
      if (!i12) {
       i8 = 9;
       break;
      }
      if (!((i12 >>> 0) % 10 | 0)) {
       i3 = 10;
       i8 = 0;
      } else {
       i8 = 0;
       break;
      }
      do {
       i3 = i3 * 10 | 0;
       i8 = i8 + 1 | 0;
      } while (((i12 >>> 0) % (i3 >>> 0) | 0 | 0) == 0);
     } else i8 = 9; while (0);
     i10 = ((i20 - i18 >> 2) * 9 | 0) + -9 | 0;
     if ((i14 | 32 | 0) == 102) {
      i21 = i10 - i8 | 0;
      i21 = (i21 | 0) < 0 ? 0 : i21;
      i5 = (i5 | 0) < (i21 | 0) ? i5 : i21;
      break;
     } else {
      i21 = i10 + i11 - i8 | 0;
      i21 = (i21 | 0) < 0 ? 0 : i21;
      i5 = (i5 | 0) < (i21 | 0) ? i5 : i21;
      break;
     }
    } else i14 = i21; while (0);
    i16 = (i5 | 0) != 0;
    if (i16) i10 = 1; else i10 = (i25 & 8 | 0) != 0;
    i4 = i10 & 1;
    i8 = (i14 | 32 | 0) == 102;
    if (i8) {
     i11 = (i11 | 0) > 0 ? i11 : 0;
     i15 = 0;
    } else {
     i3 = (i11 | 0) < 0 ? i7 : i11;
     if ((i3 | 0) < 0) {
      i10 = i79;
      i12 = i3;
      i3 = ((i3 | 0) < 0) << 31 >> 31;
      while (1) {
       i21 = ___uremdi3(i12 | 0, i3 | 0, 10, 0) | 0;
       i10 = i10 + -1 | 0;
       HEAP8[i10 >> 0] = i21 | 48;
       i21 = i12;
       i12 = ___udivdi3(i12 | 0, i3 | 0, 10, 0) | 0;
       if (!(i3 >>> 0 > 9 | (i3 | 0) == 9 & i21 >>> 0 > 4294967295)) break; else i3 = tempRet0;
      }
     } else {
      i10 = i79;
      i12 = i3;
     }
     if (i12) while (1) {
      i10 = i10 + -1 | 0;
      HEAP8[i10 >> 0] = (i12 >>> 0) % 10 | 0 | 48;
      if (i12 >>> 0 < 10) break; else i12 = (i12 >>> 0) / 10 | 0;
     }
     if ((i81 - i10 | 0) < 2) do {
      i10 = i10 + -1 | 0;
      HEAP8[i10 >> 0] = 48;
     } while ((i81 - i10 | 0) < 2);
     HEAP8[i10 + -1 >> 0] = (i11 >> 31 & 2) + 43;
     i15 = i10 + -2 | 0;
     HEAP8[i15 >> 0] = i14;
     i11 = i81 - i15 | 0;
    }
    i18 = i22 + 1 + i5 + i4 + i11 | 0;
    i4 = i25 & 73728;
    i19 = (i26 | 0) > (i18 | 0);
    if ((i4 | 0) == 0 & i19) {
     i11 = i26 - i18 | 0;
     _memset(i91 | 0, 32, (i11 >>> 0 > 256 ? 256 : i11) | 0) | 0;
     if (i11 >>> 0 > 255) {
      i12 = i11;
      do {
       ___fwritex(i91, 256, i86) | 0;
       i12 = i12 + -256 | 0;
      } while (i12 >>> 0 > 255);
      i11 = i11 & 255;
     }
     ___fwritex(i91, i11, i86) | 0;
    }
    ___fwritex(i24, i22, i86) | 0;
    if ((i4 | 0) == 65536 & i19) {
     i11 = i26 - i18 | 0;
     _memset(i91 | 0, 48, (i11 >>> 0 > 256 ? 256 : i11) | 0) | 0;
     if (i11 >>> 0 > 255) {
      i10 = i11;
      do {
       ___fwritex(i91, 256, i86) | 0;
       i10 = i10 + -256 | 0;
      } while (i10 >>> 0 > 255);
      i11 = i11 & 255;
     }
     ___fwritex(i91, i11, i86) | 0;
    }
    do if (i8) {
     i12 = i9 >>> 0 > i23 >>> 0 ? i23 : i9;
     i11 = i12;
     do {
      i10 = HEAP32[i11 >> 2] | 0;
      if (!i10) i9 = i65; else {
       i9 = i65;
       while (1) {
        i9 = i9 + -1 | 0;
        HEAP8[i9 >> 0] = (i10 >>> 0) % 10 | 0 | 48;
        if (i10 >>> 0 < 10) break; else i10 = (i10 >>> 0) / 10 | 0;
       }
      }
      do if ((i11 | 0) == (i12 | 0)) {
       if ((i9 | 0) != (i65 | 0)) break;
       HEAP8[i67 >> 0] = 48;
       i9 = i67;
      } else {
       if (i9 >>> 0 <= i84 >>> 0) break;
       do {
        i9 = i9 + -1 | 0;
        HEAP8[i9 >> 0] = 48;
       } while (i9 >>> 0 > i84 >>> 0);
      } while (0);
      ___fwritex(i9, i66 - i9 | 0, i86) | 0;
      i11 = i11 + 4 | 0;
     } while (i11 >>> 0 <= i23 >>> 0);
     if (!((i25 & 8 | 0) == 0 & (i16 ^ 1))) ___fwritex(971536, 1, i86) | 0;
     if (i11 >>> 0 < i20 >>> 0 & (i5 | 0) > 0) do {
      i9 = HEAP32[i11 >> 2] | 0;
      if (i9) {
       i8 = i65;
       while (1) {
        i8 = i8 + -1 | 0;
        HEAP8[i8 >> 0] = (i9 >>> 0) % 10 | 0 | 48;
        if (i9 >>> 0 < 10) break; else i9 = (i9 >>> 0) / 10 | 0;
       }
       if (i8 >>> 0 > i84 >>> 0) {
        i94 = i8;
        i29 = 301;
       } else i52 = i8;
      } else {
       i94 = i65;
       i29 = 301;
      }
      if ((i29 | 0) == 301) while (1) {
       i29 = 0;
       i7 = i94 + -1 | 0;
       HEAP8[i7 >> 0] = 48;
       if (i7 >>> 0 > i84 >>> 0) i94 = i7; else {
        i52 = i7;
        break;
       }
      }
      ___fwritex(i52, (i5 | 0) > 9 ? 9 : i5, i86) | 0;
      i11 = i11 + 4 | 0;
      i5 = i5 + -9 | 0;
     } while (i11 >>> 0 < i20 >>> 0 & (i5 | 0) > 0);
     if ((i5 | 0) <= 0) break;
     _memset(i91 | 0, 48, (i5 >>> 0 > 256 ? 256 : i5) | 0) | 0;
     if (i5 >>> 0 > 255) {
      i7 = i5;
      do {
       ___fwritex(i91, 256, i86) | 0;
       i7 = i7 + -256 | 0;
      } while (i7 >>> 0 > 255);
      i5 = i5 & 255;
     }
     ___fwritex(i91, i5, i86) | 0;
    } else {
     i14 = i17 ? i20 : i9 + 4 | 0;
     do if ((i5 | 0) > -1) {
      i3 = (i25 & 8 | 0) == 0;
      i12 = i9;
      do {
       i10 = HEAP32[i12 >> 2] | 0;
       if (i10) {
        i11 = i65;
        while (1) {
         i11 = i11 + -1 | 0;
         HEAP8[i11 >> 0] = (i10 >>> 0) % 10 | 0 | 48;
         if (i10 >>> 0 < 10) break; else i10 = (i10 >>> 0) / 10 | 0;
        }
        if ((i11 | 0) != (i65 | 0)) i95 = i11; else i29 = 313;
       } else i29 = 313;
       if ((i29 | 0) == 313) {
        i29 = 0;
        HEAP8[i67 >> 0] = 48;
        i95 = i67;
       }
       do if ((i12 | 0) == (i9 | 0)) {
        i8 = i95 + 1 | 0;
        ___fwritex(i95, 1, i86) | 0;
        if ((i5 | 0) < 1 & i3) break;
        ___fwritex(971536, 1, i86) | 0;
       } else {
        if (i95 >>> 0 > i84 >>> 0) i8 = i95; else {
         i8 = i95;
         break;
        }
        do {
         i8 = i8 + -1 | 0;
         HEAP8[i8 >> 0] = 48;
        } while (i8 >>> 0 > i84 >>> 0);
       } while (0);
       i23 = i66 - i8 | 0;
       ___fwritex(i8, (i5 | 0) > (i23 | 0) ? i23 : i5, i86) | 0;
       i5 = i5 - i23 | 0;
       i12 = i12 + 4 | 0;
      } while (i12 >>> 0 < i14 >>> 0 & (i5 | 0) > -1);
      if ((i5 | 0) <= 0) break;
      _memset(i91 | 0, 48, (i5 >>> 0 > 256 ? 256 : i5) | 0) | 0;
      if (i5 >>> 0 > 255) {
       i7 = i5;
       do {
        ___fwritex(i91, 256, i86) | 0;
        i7 = i7 + -256 | 0;
       } while (i7 >>> 0 > 255);
       i5 = i5 & 255;
      }
      ___fwritex(i91, i5, i86) | 0;
     } while (0);
     ___fwritex(i15, i81 - i15 | 0, i86) | 0;
    } while (0);
    if ((i4 | 0) == 8192 & i19) {
     i5 = i26 - i18 | 0;
     _memset(i91 | 0, 32, (i5 >>> 0 > 256 ? 256 : i5) | 0) | 0;
     if (i5 >>> 0 > 255) {
      i4 = i5;
      do {
       ___fwritex(i91, 256, i86) | 0;
       i4 = i4 + -256 | 0;
      } while (i4 >>> 0 > 255);
      i5 = i5 & 255;
     }
     ___fwritex(i91, i5, i86) | 0;
    }
    i17 = i69;
    i16 = i71;
    i5 = i27;
    i11 = i42;
    i4 = i19 ? i26 : i18;
    i19 = i28;
    continue L1;
   }
  default:
   {
    i49 = i69;
    i50 = i71;
    i51 = i5;
    i1 = i25;
    i44 = i20;
    i45 = 0;
    i46 = 971440;
    i43 = i70;
   }
  } while (0);
  do if ((i29 | 0) == 75) {
   i3 = i96 & 32;
   if (!((i69 | 0) == 0 & (i71 | 0) == 0)) {
    i2 = i70;
    i4 = i69;
    i5 = i71;
    do {
     i2 = i2 + -1 | 0;
     HEAP8[i2 >> 0] = HEAPU8[971520 + (i4 & 15) >> 0] | i3;
     i4 = _bitshift64Lshr(i4 | 0, i5 | 0, 4) | 0;
     i5 = tempRet0;
    } while (!((i4 | 0) == 0 & (i5 | 0) == 0));
    if (!(i87 & 8)) {
     i36 = i69;
     i37 = i71;
     i30 = i87;
     i31 = i89;
     i32 = 0;
     i33 = 971440;
     i29 = 91;
    } else {
     i36 = i69;
     i37 = i71;
     i30 = i87;
     i31 = i89;
     i32 = 2;
     i33 = 971440 + (i96 >> 4) | 0;
     i29 = 91;
    }
   } else {
    i36 = i69;
    i37 = i71;
    i2 = i70;
    i30 = i87;
    i31 = i89;
    i32 = 0;
    i33 = 971440;
    i29 = 91;
   }
  } else if ((i29 | 0) == 86) {
   if (i72 >>> 0 > 0 | (i72 | 0) == 0 & i73 >>> 0 > 4294967295) {
    i2 = i70;
    i3 = i73;
    i5 = i72;
    while (1) {
     i23 = ___uremdi3(i3 | 0, i5 | 0, 10, 0) | 0;
     i2 = i2 + -1 | 0;
     HEAP8[i2 >> 0] = i23 | 48;
     i23 = i3;
     i3 = ___udivdi3(i3 | 0, i5 | 0, 10, 0) | 0;
     if (!(i5 >>> 0 > 9 | (i5 | 0) == 9 & i23 >>> 0 > 4294967295)) break; else i5 = tempRet0;
    }
   } else {
    i2 = i70;
    i3 = i73;
   }
   if (!i3) {
    i36 = i73;
    i37 = i72;
    i30 = i25;
    i31 = i20;
    i32 = i92;
    i33 = i93;
    i29 = 91;
   } else while (1) {
    i2 = i2 + -1 | 0;
    HEAP8[i2 >> 0] = (i3 >>> 0) % 10 | 0 | 48;
    if (i3 >>> 0 < 10) {
     i36 = i73;
     i37 = i72;
     i30 = i25;
     i31 = i20;
     i32 = i92;
     i33 = i93;
     i29 = 91;
     break;
    } else i3 = (i3 >>> 0) / 10 | 0;
   }
  } else if ((i29 | 0) == 96) {
   i29 = 0;
   i5 = _memchr(i82, 0, i20) | 0;
   if (!i5) {
    i49 = i69;
    i50 = i71;
    i51 = i82;
    i1 = i12;
    i44 = i20;
    i45 = 0;
    i46 = 971440;
    i43 = i82 + i20 | 0;
    break;
   } else {
    i49 = i69;
    i50 = i71;
    i51 = i82;
    i1 = i12;
    i44 = i5 - i82 | 0;
    i45 = 0;
    i46 = 971440;
    i43 = i5;
    break;
   }
  } else if ((i29 | 0) == 101) {
   i4 = 0;
   i5 = 0;
   i7 = i60;
   while (1) {
    i3 = HEAP32[i7 >> 2] | 0;
    if (!i3) break;
    i5 = _wctomb(i88, i3) | 0;
    if ((i5 | 0) < 0 | i5 >>> 0 > (i90 - i4 | 0) >>> 0) break;
    i4 = i5 + i4 | 0;
    if (i90 >>> 0 > i4 >>> 0) i7 = i7 + 4 | 0; else break;
   }
   if ((i5 | 0) < 0) {
    i99 = -1;
    i29 = 370;
    break L1;
   } else {
    i40 = i61;
    i41 = i60;
    i39 = i4;
    i29 = 106;
   }
  } while (0);
  if ((i29 | 0) == 91) {
   i29 = 0;
   i1 = (i31 | 0) > -1 ? i30 & -65537 : i30;
   i3 = (i36 | 0) != 0 | (i37 | 0) != 0;
   if (i3 | (i31 | 0) != 0) {
    i44 = (i3 & 1 ^ 1) + (i75 - i2) | 0;
    i49 = i36;
    i50 = i37;
    i51 = i2;
    i44 = (i31 | 0) > (i44 | 0) ? i31 : i44;
    i45 = i32;
    i46 = i33;
    i43 = i70;
   } else {
    i49 = i36;
    i50 = i37;
    i51 = i70;
    i44 = 0;
    i45 = i32;
    i46 = i33;
    i43 = i70;
   }
  } else if ((i29 | 0) == 106) {
   i29 = 0;
   i9 = i25 & 73728;
   i12 = (i26 | 0) > (i39 | 0);
   if ((i9 | 0) == 0 & i12) {
    i5 = i26 - i39 | 0;
    _memset(i91 | 0, 32, (i5 >>> 0 > 256 ? 256 : i5) | 0) | 0;
    if (i5 >>> 0 > 255) {
     i4 = i5;
     do {
      ___fwritex(i91, 256, i86) | 0;
      i4 = i4 + -256 | 0;
     } while (i4 >>> 0 > 255);
     i5 = i5 & 255;
    }
    ___fwritex(i91, i5, i86) | 0;
   }
   L479 : do if (i39) {
    i5 = 0;
    i4 = i41;
    while (1) {
     i7 = HEAP32[i4 >> 2] | 0;
     if (!i7) break L479;
     i7 = _wctomb(i88, i7) | 0;
     i5 = i7 + i5 | 0;
     if ((i5 | 0) > (i39 | 0)) break L479;
     ___fwritex(i88, i7, i86) | 0;
     if (i5 >>> 0 >= i39 >>> 0) break; else i4 = i4 + 4 | 0;
    }
   } while (0);
   if ((i9 | 0) == 8192 & i12) {
    i5 = i26 - i39 | 0;
    _memset(i91 | 0, 32, (i5 >>> 0 > 256 ? 256 : i5) | 0) | 0;
    if (i5 >>> 0 > 255) {
     i4 = i5;
     do {
      ___fwritex(i91, 256, i86) | 0;
      i4 = i4 + -256 | 0;
     } while (i4 >>> 0 > 255);
     i5 = i5 & 255;
    }
    ___fwritex(i91, i5, i86) | 0;
   }
   i17 = i40;
   i16 = i71;
   i5 = i27;
   i11 = i42;
   i4 = i12 ? i26 : i39;
   i19 = i28;
   continue;
  }
  i12 = i43 - i51 | 0;
  i11 = (i44 | 0) < (i12 | 0) ? i12 : i44;
  i3 = i45 + i11 | 0;
  i14 = (i26 | 0) < (i3 | 0) ? i3 : i26;
  i10 = i1 & 73728;
  i9 = (i14 | 0) > (i3 | 0);
  if ((i10 | 0) == 0 & i9) {
   i7 = i14 - i3 | 0;
   _memset(i91 | 0, 32, (i7 >>> 0 > 256 ? 256 : i7) | 0) | 0;
   if (i7 >>> 0 > 255) {
    i5 = i7;
    do {
     ___fwritex(i91, 256, i86) | 0;
     i5 = i5 + -256 | 0;
    } while (i5 >>> 0 > 255);
    i7 = i7 & 255;
   }
   ___fwritex(i91, i7, i86) | 0;
  }
  ___fwritex(i46, i45, i86) | 0;
  if ((i10 | 0) == 65536 & i9) {
   i7 = i14 - i3 | 0;
   _memset(i91 | 0, 48, (i7 >>> 0 > 256 ? 256 : i7) | 0) | 0;
   if (i7 >>> 0 > 255) {
    i5 = i7;
    do {
     ___fwritex(i91, 256, i86) | 0;
     i5 = i5 + -256 | 0;
    } while (i5 >>> 0 > 255);
    i7 = i7 & 255;
   }
   ___fwritex(i91, i7, i86) | 0;
  }
  if ((i11 | 0) > (i12 | 0)) {
   i7 = i11 - i12 | 0;
   _memset(i91 | 0, 48, (i7 >>> 0 > 256 ? 256 : i7) | 0) | 0;
   if (i7 >>> 0 > 255) {
    i5 = i7;
    do {
     ___fwritex(i91, 256, i86) | 0;
     i5 = i5 + -256 | 0;
    } while (i5 >>> 0 > 255);
    i7 = i7 & 255;
   }
   ___fwritex(i91, i7, i86) | 0;
  }
  ___fwritex(i51, i12, i86) | 0;
  if (!((i10 | 0) == 8192 & i9)) {
   i17 = i49;
   i16 = i50;
   i5 = i27;
   i11 = i42;
   i4 = i14;
   i19 = i28;
   continue;
  }
  i5 = i14 - i3 | 0;
  _memset(i91 | 0, 32, (i5 >>> 0 > 256 ? 256 : i5) | 0) | 0;
  if (i5 >>> 0 > 255) {
   i4 = i5;
   do {
    ___fwritex(i91, 256, i86) | 0;
    i4 = i4 + -256 | 0;
   } while (i4 >>> 0 > 255);
   i5 = i5 & 255;
  }
  ___fwritex(i91, i5, i86) | 0;
  i17 = i49;
  i16 = i50;
  i5 = i27;
  i11 = i42;
  i4 = i14;
  i19 = i28;
 }
 if ((i29 | 0) == 352) {
  if (i86) {
   i97 = i42;
   STACKTOP = i104;
   return i97 | 0;
  }
  if (!i19) {
   i97 = 0;
   STACKTOP = i104;
   return i97 | 0;
  } else i3 = 1;
  while (1) {
   i1 = HEAP32[i103 + (i3 << 2) >> 2] | 0;
   if (!i1) {
    i101 = i3;
    break;
   }
   i2 = i102 + (i3 << 3) | 0;
   L534 : do if (i1 >>> 0 <= 20) do switch (i1 | 0) {
   case 14:
    {
     i97 = HEAP32[i100 >> 2] | 0;
     i96 = HEAP32[i97 >> 2] | 0;
     HEAP32[i100 >> 2] = i97 + 4;
     i97 = i2;
     HEAP32[i97 >> 2] = i96 & 65535;
     HEAP32[i97 + 4 >> 2] = 0;
     break L534;
    }
   case 15:
    {
     i97 = HEAP32[i100 >> 2] | 0;
     i96 = HEAP32[i97 >> 2] | 0;
     HEAP32[i100 >> 2] = i97 + 4;
     i96 = (i96 & 255) << 24 >> 24;
     i97 = i2;
     HEAP32[i97 >> 2] = i96;
     HEAP32[i97 + 4 >> 2] = ((i96 | 0) < 0) << 31 >> 31;
     break L534;
    }
   case 16:
    {
     i97 = HEAP32[i100 >> 2] | 0;
     i96 = HEAP32[i97 >> 2] | 0;
     HEAP32[i100 >> 2] = i97 + 4;
     i97 = i2;
     HEAP32[i97 >> 2] = i96 & 255;
     HEAP32[i97 + 4 >> 2] = 0;
     break L534;
    }
   case 17:
    {
     i97 = HEAP32[i100 >> 2] | 0;
     HEAP32[tempDoublePtr >> 2] = HEAP32[i97 >> 2];
     HEAP32[tempDoublePtr + 4 >> 2] = HEAP32[i97 + 4 >> 2];
     d6 = +HEAPF64[tempDoublePtr >> 3];
     HEAP32[i100 >> 2] = i97 + 8;
     HEAPF64[i2 >> 3] = d6;
     break L534;
    }
   case 18:
    {
     i97 = HEAP32[i100 >> 2] | 0;
     HEAP32[tempDoublePtr >> 2] = HEAP32[i97 >> 2];
     HEAP32[tempDoublePtr + 4 >> 2] = HEAP32[i97 + 4 >> 2];
     d6 = +HEAPF64[tempDoublePtr >> 3];
     HEAP32[i100 >> 2] = i97 + 8;
     HEAPF64[i2 >> 3] = d6;
     break L534;
    }
   case 9:
    {
     i96 = HEAP32[i100 >> 2] | 0;
     i97 = HEAP32[i96 >> 2] | 0;
     HEAP32[i100 >> 2] = i96 + 4;
     HEAP32[i2 >> 2] = i97;
     break L534;
    }
   case 10:
    {
     i97 = HEAP32[i100 >> 2] | 0;
     i96 = HEAP32[i97 >> 2] | 0;
     HEAP32[i100 >> 2] = i97 + 4;
     i97 = i2;
     HEAP32[i97 >> 2] = i96;
     HEAP32[i97 + 4 >> 2] = ((i96 | 0) < 0) << 31 >> 31;
     break L534;
    }
   case 11:
    {
     i97 = HEAP32[i100 >> 2] | 0;
     i96 = HEAP32[i97 >> 2] | 0;
     HEAP32[i100 >> 2] = i97 + 4;
     i97 = i2;
     HEAP32[i97 >> 2] = i96;
     HEAP32[i97 + 4 >> 2] = 0;
     break L534;
    }
   case 12:
    {
     i97 = HEAP32[i100 >> 2] | 0;
     i96 = i97;
     i95 = HEAP32[i96 >> 2] | 0;
     i96 = HEAP32[i96 + 4 >> 2] | 0;
     HEAP32[i100 >> 2] = i97 + 8;
     i97 = i2;
     HEAP32[i97 >> 2] = i95;
     HEAP32[i97 + 4 >> 2] = i96;
     break L534;
    }
   case 13:
    {
     i97 = HEAP32[i100 >> 2] | 0;
     i96 = HEAP32[i97 >> 2] | 0;
     HEAP32[i100 >> 2] = i97 + 4;
     i96 = (i96 & 65535) << 16 >> 16;
     i97 = i2;
     HEAP32[i97 >> 2] = i96;
     HEAP32[i97 + 4 >> 2] = ((i96 | 0) < 0) << 31 >> 31;
     break L534;
    }
   default:
    break L534;
   } while (0); while (0);
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= 10) {
    i99 = 1;
    i29 = 370;
    break;
   }
  }
  if ((i29 | 0) == 370) {
   STACKTOP = i104;
   return i99 | 0;
  }
  while (1) {
   if (HEAP32[i103 + (i101 << 2) >> 2] | 0) {
    i99 = -1;
    i29 = 370;
    break;
   }
   i101 = i101 + 1 | 0;
   if ((i101 | 0) >= 10) {
    i99 = 1;
    i29 = 370;
    break;
   }
  }
  if ((i29 | 0) == 370) {
   STACKTOP = i104;
   return i99 | 0;
  }
 } else if ((i29 | 0) == 370) {
  STACKTOP = i104;
  return i99 | 0;
 }
 return 0;
}

function _inflate(i75, i74) {
 i75 = i75 | 0;
 i74 = i74 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i76 = 0;
 i76 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i56 = i76;
 if (!i75) {
  i46 = -2;
  STACKTOP = i76;
  return i46 | 0;
 }
 i70 = HEAP32[i75 + 28 >> 2] | 0;
 if (!i70) {
  i46 = -2;
  STACKTOP = i76;
  return i46 | 0;
 }
 i67 = i75 + 12 | 0;
 i10 = HEAP32[i67 >> 2] | 0;
 if (!i10) {
  i46 = -2;
  STACKTOP = i76;
  return i46 | 0;
 }
 i3 = HEAP32[i75 >> 2] | 0;
 if ((i3 | 0) == 0 ? (HEAP32[i75 + 4 >> 2] | 0) != 0 : 0) {
  i46 = -2;
  STACKTOP = i76;
  return i46 | 0;
 }
 i2 = HEAP32[i70 >> 2] | 0;
 if ((i2 | 0) == 11) {
  HEAP32[i70 >> 2] = 12;
  i2 = 12;
 }
 i61 = i75 + 16 | 0;
 i7 = HEAP32[i61 >> 2] | 0;
 i58 = i75 + 4 | 0;
 i71 = HEAP32[i58 >> 2] | 0;
 i59 = i70 + 56 | 0;
 i72 = i70 + 60 | 0;
 i63 = i70 + 8 | 0;
 i68 = i70 + 24 | 0;
 i19 = i56 + 1 | 0;
 i66 = i70 + 16 | 0;
 i20 = i70 + 32 | 0;
 i21 = i75 + 24 | 0;
 i22 = i70 + 36 | 0;
 i23 = i70 + 20 | 0;
 i69 = i75 + 48 | 0;
 i24 = i70 + 64 | 0;
 i25 = i70 + 12 | 0;
 i26 = (i74 + -5 | 0) >>> 0 < 2;
 i73 = i70 + 4 | 0;
 i27 = i70 + 76 | 0;
 i28 = i70 + 84 | 0;
 i29 = i70 + 80 | 0;
 i30 = i70 + 88 | 0;
 i31 = (i74 | 0) == 6;
 i32 = i70 + 7108 | 0;
 i33 = i70 + 72 | 0;
 i34 = i70 + 7112 | 0;
 i35 = i70 + 68 | 0;
 i36 = i70 + 44 | 0;
 i37 = i70 + 7104 | 0;
 i38 = i70 + 48 | 0;
 i39 = i70 + 52 | 0;
 i60 = i70 + 40 | 0;
 i64 = i75 + 20 | 0;
 i65 = i70 + 28 | 0;
 i40 = i70 + 96 | 0;
 i41 = i70 + 100 | 0;
 i42 = i70 + 92 | 0;
 i43 = i70 + 104 | 0;
 i44 = i70 + 1328 | 0;
 i45 = i70 + 108 | 0;
 i46 = i70 + 112 | 0;
 i47 = i70 + 752 | 0;
 i48 = i70 + 624 | 0;
 i49 = i56 + 2 | 0;
 i50 = i56 + 3 | 0;
 i1 = HEAP32[i72 >> 2] | 0;
 i5 = i71;
 i9 = HEAP32[i59 >> 2] | 0;
 i4 = i7;
 i57 = i10;
 i6 = 0;
 L17 : while (1) {
  L19 : do switch (i2 | 0) {
  case 13:
   {
    i10 = i1 & 7;
    i2 = i9 >>> i10;
    i1 = i1 - i10 | 0;
    if (i1 >>> 0 < 32) while (1) {
     if (!i5) {
      i5 = 0;
      break L17;
     }
     i5 = i5 + -1 | 0;
     i11 = i3 + 1 | 0;
     i2 = (HEAPU8[i3 >> 0] << i1) + i2 | 0;
     i1 = i1 + 8 | 0;
     if (i1 >>> 0 < 32) i3 = i11; else {
      i3 = i11;
      break;
     }
    }
    i8 = i2 & 65535;
    if ((i8 | 0) == (i2 >>> 16 ^ 65535 | 0)) {
     HEAP32[i24 >> 2] = i8;
     HEAP32[i70 >> 2] = 14;
     if (i31) {
      i1 = 0;
      i2 = 0;
      i18 = 281;
      break L17;
     } else {
      i1 = 0;
      i2 = 0;
      i18 = 143;
      break L19;
     }
    } else {
     HEAP32[i21 >> 2] = 143744;
     HEAP32[i70 >> 2] = 29;
     i9 = i2;
     i10 = i4;
     i11 = i57;
     break L19;
    }
   }
  case 9:
   {
    if (i1 >>> 0 < 32) {
     i2 = i9;
     while (1) {
      if (!i5) {
       i5 = 0;
       break L17;
      }
      i5 = i5 + -1 | 0;
      i11 = i3 + 1 | 0;
      i2 = (HEAPU8[i3 >> 0] << i1) + i2 | 0;
      i1 = i1 + 8 | 0;
      if (i1 >>> 0 >= 32) {
       i3 = i11;
       break;
      } else i3 = i11;
     }
    } else i2 = i9;
    i1 = _llvm_bswap_i32(i2 | 0) | 0;
    HEAP32[i68 >> 2] = i1;
    HEAP32[i69 >> 2] = i1;
    HEAP32[i70 >> 2] = 10;
    i1 = 0;
    i2 = 0;
    i18 = 121;
    break;
   }
  case 14:
   {
    i2 = i9;
    i18 = 143;
    break;
   }
  case 15:
   {
    i2 = i9;
    i18 = 144;
    break;
   }
  case 1:
   {
    if (i1 >>> 0 < 16) {
     i2 = i9;
     while (1) {
      if (!i5) {
       i5 = 0;
       break L17;
      }
      i5 = i5 + -1 | 0;
      i11 = i3 + 1 | 0;
      i2 = (HEAPU8[i3 >> 0] << i1) + i2 | 0;
      i1 = i1 + 8 | 0;
      if (i1 >>> 0 < 16) i3 = i11; else {
       i3 = i11;
       break;
      }
     }
    } else i2 = i9;
    HEAP32[i66 >> 2] = i2;
    if ((i2 & 255 | 0) != 8) {
     HEAP32[i21 >> 2] = 143608;
     HEAP32[i70 >> 2] = 29;
     i9 = i2;
     i10 = i4;
     i11 = i57;
     break L19;
    }
    if (i2 & 57344) {
     HEAP32[i21 >> 2] = 143664;
     HEAP32[i70 >> 2] = 29;
     i9 = i2;
     i10 = i4;
     i11 = i57;
     break L19;
    }
    i1 = HEAP32[i20 >> 2] | 0;
    if (i1) HEAP32[i1 >> 2] = i2 >>> 8 & 1;
    if (i2 & 512) {
     HEAP8[i56 >> 0] = i2;
     HEAP8[i19 >> 0] = i2 >>> 8;
     HEAP32[i68 >> 2] = _crc32(HEAP32[i68 >> 2] | 0, i56, 2) | 0;
    }
    HEAP32[i70 >> 2] = 2;
    i1 = 0;
    i2 = 0;
    i18 = 47;
    break;
   }
  case 22:
   {
    i2 = i9;
    i18 = 224;
    break;
   }
  case 5:
   {
    i2 = i9;
    i18 = 73;
    break;
   }
  case 27:
   {
    i2 = i9;
    i18 = 273;
    break;
   }
  case 6:
   {
    i2 = i9;
    i18 = 83;
    break;
   }
  case 7:
   {
    i2 = i9;
    i18 = 96;
    break;
   }
  case 8:
   {
    i2 = i9;
    i18 = 109;
    break;
   }
  case 16:
   {
    if (i1 >>> 0 < 14) {
     i2 = i9;
     i11 = i3;
     while (1) {
      if (!i5) {
       i5 = 0;
       i3 = i11;
       break L17;
      }
      i5 = i5 + -1 | 0;
      i3 = i11 + 1 | 0;
      i2 = (HEAPU8[i11 >> 0] << i1) + i2 | 0;
      i1 = i1 + 8 | 0;
      if (i1 >>> 0 < 14) i11 = i3; else break;
     }
    } else i2 = i9;
    i9 = (i2 & 31) + 257 | 0;
    HEAP32[i40 >> 2] = i9;
    i10 = (i2 >>> 5 & 31) + 1 | 0;
    HEAP32[i41 >> 2] = i10;
    HEAP32[i42 >> 2] = (i2 >>> 10 & 15) + 4;
    i2 = i2 >>> 14;
    i1 = i1 + -14 | 0;
    if (i9 >>> 0 > 286 | i10 >>> 0 > 30) {
     HEAP32[i21 >> 2] = 143776;
     HEAP32[i70 >> 2] = 29;
     i9 = i2;
     i10 = i4;
     i11 = i57;
     break L19;
    } else {
     HEAP32[i43 >> 2] = 0;
     HEAP32[i70 >> 2] = 17;
     i8 = 0;
     i18 = 154;
     break L19;
    }
   }
  case 12:
   {
    i2 = i9;
    i18 = 125;
    break;
   }
  case 17:
   {
    i2 = HEAP32[i43 >> 2] | 0;
    if (i2 >>> 0 < (HEAP32[i42 >> 2] | 0) >>> 0) {
     i8 = i2;
     i2 = i9;
     i18 = 154;
    } else {
     i8 = i2;
     i2 = i9;
     i18 = 158;
    }
    break;
   }
  case 19:
   {
    i2 = i9;
    i18 = 198;
    break;
   }
  case 20:
   {
    i2 = i9;
    i18 = 199;
    break;
   }
  case 11:
   {
    i2 = i9;
    i18 = 124;
    break;
   }
  case 2:
   {
    if (i1 >>> 0 < 32) {
     i2 = i9;
     i18 = 47;
    } else {
     i2 = i9;
     i18 = 49;
    }
    break;
   }
  case 18:
   {
    i12 = HEAP32[i43 >> 2] | 0;
    i2 = i9;
    i18 = 164;
    break;
   }
  case 23:
   {
    i13 = HEAP32[i33 >> 2] | 0;
    i2 = i9;
    i18 = 236;
    break;
   }
  case 3:
   {
    if (i1 >>> 0 < 16) {
     i2 = i9;
     i11 = i3;
     i18 = 55;
    } else {
     i2 = i9;
     i18 = 57;
    }
    break;
   }
  case 21:
   {
    i13 = HEAP32[i33 >> 2] | 0;
    i2 = i9;
    i18 = 217;
    break;
   }
  case 4:
   {
    i2 = i9;
    i18 = 62;
    break;
   }
  case 25:
   {
    if (!i4) {
     i2 = i9;
     i4 = 0;
     i18 = 281;
     break L17;
    }
    HEAP8[i57 >> 0] = HEAP32[i24 >> 2];
    HEAP32[i70 >> 2] = 20;
    i10 = i4 + -1 | 0;
    i11 = i57 + 1 | 0;
    break;
   }
  case 26:
   {
    if (HEAP32[i63 >> 2] | 0) {
     if (i1 >>> 0 < 32) {
      i2 = i9;
      i11 = i3;
      while (1) {
       if (!i5) {
        i5 = 0;
        i3 = i11;
        break L17;
       }
       i5 = i5 + -1 | 0;
       i3 = i11 + 1 | 0;
       i2 = (HEAPU8[i11 >> 0] << i1) + i2 | 0;
       i1 = i1 + 8 | 0;
       if (i1 >>> 0 < 32) i11 = i3; else break;
      }
     } else i2 = i9;
     i10 = i7 - i4 | 0;
     HEAP32[i64 >> 2] = (HEAP32[i64 >> 2] | 0) + i10;
     HEAP32[i65 >> 2] = (HEAP32[i65 >> 2] | 0) + i10;
     if ((i7 | 0) != (i4 | 0)) {
      i9 = HEAP32[i68 >> 2] | 0;
      i8 = i57 + (0 - i10) | 0;
      if (!(HEAP32[i66 >> 2] | 0)) i8 = _adler32(i9, i8, i10) | 0; else i8 = _crc32(i9, i8, i10) | 0;
      HEAP32[i68 >> 2] = i8;
      HEAP32[i69 >> 2] = i8;
     }
     if (!(HEAP32[i66 >> 2] | 0)) i8 = _llvm_bswap_i32(i2 | 0) | 0; else i8 = i2;
     if ((i8 | 0) == (HEAP32[i68 >> 2] | 0)) {
      i1 = 0;
      i2 = 0;
      i7 = i4;
     } else {
      HEAP32[i21 >> 2] = 144064;
      HEAP32[i70 >> 2] = 29;
      i9 = i2;
      i10 = i4;
      i7 = i4;
      i11 = i57;
      break L19;
     }
    } else i2 = i9;
    HEAP32[i70 >> 2] = 27;
    i18 = 273;
    break;
   }
  case 0:
   {
    i11 = HEAP32[i63 >> 2] | 0;
    if (!i11) {
     HEAP32[i70 >> 2] = 12;
     i10 = i4;
     i11 = i57;
     break L19;
    }
    if (i1 >>> 0 < 16) {
     i2 = i9;
     while (1) {
      if (!i5) {
       i5 = 0;
       break L17;
      }
      i5 = i5 + -1 | 0;
      i12 = i3 + 1 | 0;
      i2 = (HEAPU8[i3 >> 0] << i1) + i2 | 0;
      i1 = i1 + 8 | 0;
      if (i1 >>> 0 < 16) i3 = i12; else {
       i3 = i12;
       break;
      }
     }
    } else i2 = i9;
    if ((i11 & 2 | 0) != 0 & (i2 | 0) == 35615) {
     HEAP32[i68 >> 2] = _crc32(0, 0, 0) | 0;
     HEAP8[i56 >> 0] = 31;
     HEAP8[i19 >> 0] = -117;
     HEAP32[i68 >> 2] = _crc32(HEAP32[i68 >> 2] | 0, i56, 2) | 0;
     HEAP32[i70 >> 2] = 1;
     i1 = 0;
     i9 = 0;
     i10 = i4;
     i11 = i57;
     break L19;
    }
    HEAP32[i66 >> 2] = 0;
    i9 = HEAP32[i20 >> 2] | 0;
    if (i9) HEAP32[i9 + 48 >> 2] = -1;
    if ((i11 & 1 | 0) != 0 ? ((((i2 << 8 & 65280) + (i2 >>> 8) | 0) >>> 0) % 31 | 0 | 0) == 0 : 0) {
     if ((i2 & 15 | 0) != 8) {
      HEAP32[i21 >> 2] = 143608;
      HEAP32[i70 >> 2] = 29;
      i9 = i2;
      i10 = i4;
      i11 = i57;
      break L19;
     }
     i9 = i2 >>> 4;
     i1 = i1 + -4 | 0;
     i8 = (i9 & 15) + 8 | 0;
     i10 = HEAP32[i22 >> 2] | 0;
     if (i10) {
      if (i8 >>> 0 > i10 >>> 0) {
       HEAP32[i21 >> 2] = 143640;
       HEAP32[i70 >> 2] = 29;
       i10 = i4;
       i11 = i57;
       break L19;
      }
     } else HEAP32[i22 >> 2] = i8;
     HEAP32[i23 >> 2] = 1 << i8;
     i1 = _adler32(0, 0, 0) | 0;
     HEAP32[i68 >> 2] = i1;
     HEAP32[i69 >> 2] = i1;
     HEAP32[i70 >> 2] = i2 >>> 12 & 2 ^ 11;
     i1 = 0;
     i9 = 0;
     i10 = i4;
     i11 = i57;
     break L19;
    }
    HEAP32[i21 >> 2] = 143584;
    HEAP32[i70 >> 2] = 29;
    i9 = i2;
    i10 = i4;
    i11 = i57;
    break;
   }
  case 30:
   {
    i18 = 297;
    break L17;
   }
  case 28:
   {
    i2 = i9;
    i6 = 1;
    i18 = 281;
    break L17;
   }
  case 29:
   {
    i2 = i9;
    i6 = -3;
    break L17;
   }
  case 10:
   {
    i2 = i9;
    i18 = 121;
    break;
   }
  case 24:
   {
    i2 = i9;
    i18 = 242;
    break;
   }
  default:
   {
    i1 = -2;
    i18 = 298;
    break L17;
   }
  } while (0);
  if ((i18 | 0) == 47) while (1) {
   i18 = 0;
   if (!i5) {
    i5 = 0;
    break L17;
   }
   i5 = i5 + -1 | 0;
   i10 = i3 + 1 | 0;
   i2 = (HEAPU8[i3 >> 0] << i1) + i2 | 0;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= 32) {
    i3 = i10;
    i18 = 49;
    break;
   } else {
    i3 = i10;
    i18 = 47;
   }
  } else if ((i18 | 0) == 121) {
   if (!(HEAP32[i25 >> 2] | 0)) {
    i18 = 122;
    break;
   }
   i18 = _adler32(0, 0, 0) | 0;
   HEAP32[i68 >> 2] = i18;
   HEAP32[i69 >> 2] = i18;
   HEAP32[i70 >> 2] = 11;
   i18 = 124;
  } else if ((i18 | 0) == 143) {
   HEAP32[i70 >> 2] = 15;
   i18 = 144;
  } else if ((i18 | 0) == 154) while (1) {
   i18 = 0;
   if (i1 >>> 0 < 3) {
    i11 = i3;
    while (1) {
     if (!i5) {
      i5 = 0;
      i3 = i11;
      break L17;
     }
     i5 = i5 + -1 | 0;
     i3 = i11 + 1 | 0;
     i2 = (HEAPU8[i11 >> 0] << i1) + i2 | 0;
     i1 = i1 + 8 | 0;
     if (i1 >>> 0 < 3) i11 = i3; else break;
    }
   }
   HEAP32[i43 >> 2] = i8 + 1;
   HEAP16[i70 + (HEAPU16[143544 + (i8 << 1) >> 1] << 1) + 112 >> 1] = i2 & 7;
   i2 = i2 >>> 3;
   i1 = i1 + -3 | 0;
   i8 = HEAP32[i43 >> 2] | 0;
   if (i8 >>> 0 < (HEAP32[i42 >> 2] | 0) >>> 0) i18 = 154; else {
    i18 = 158;
    break;
   }
  } else if ((i18 | 0) == 273) {
   i18 = 0;
   if (!(HEAP32[i63 >> 2] | 0)) {
    i18 = 280;
    break;
   }
   if (!(HEAP32[i66 >> 2] | 0)) {
    i18 = 280;
    break;
   }
   if (i1 >>> 0 < 32) {
    i11 = i3;
    while (1) {
     if (!i5) {
      i5 = 0;
      i3 = i11;
      break L17;
     }
     i5 = i5 + -1 | 0;
     i3 = i11 + 1 | 0;
     i2 = (HEAPU8[i11 >> 0] << i1) + i2 | 0;
     i1 = i1 + 8 | 0;
     if (i1 >>> 0 < 32) i11 = i3; else break;
    }
   }
   if ((i2 | 0) == (HEAP32[i65 >> 2] | 0)) {
    i1 = 0;
    i2 = 0;
    i18 = 280;
    break;
   }
   HEAP32[i21 >> 2] = 144088;
   HEAP32[i70 >> 2] = 29;
   i9 = i2;
   i10 = i4;
   i11 = i57;
  }
  do if ((i18 | 0) == 49) {
   i1 = HEAP32[i20 >> 2] | 0;
   if (i1) HEAP32[i1 + 4 >> 2] = i2;
   if (HEAP32[i66 >> 2] & 512) {
    HEAP8[i56 >> 0] = i2;
    HEAP8[i19 >> 0] = i2 >>> 8;
    HEAP8[i49 >> 0] = i2 >>> 16;
    HEAP8[i50 >> 0] = i2 >>> 24;
    HEAP32[i68 >> 2] = _crc32(HEAP32[i68 >> 2] | 0, i56, 4) | 0;
   }
   HEAP32[i70 >> 2] = 3;
   i1 = 0;
   i2 = 0;
   i11 = i3;
   i18 = 55;
  } else if ((i18 | 0) == 124) if (i26) {
   i18 = 281;
   break L17;
  } else i18 = 125; else if ((i18 | 0) == 144) {
   i18 = 0;
   i8 = HEAP32[i24 >> 2] | 0;
   if (!i8) {
    HEAP32[i70 >> 2] = 11;
    i9 = i2;
    i10 = i4;
    i11 = i57;
    break;
   }
   i11 = i8 >>> 0 > i5 >>> 0 ? i5 : i8;
   i11 = i11 >>> 0 > i4 >>> 0 ? i4 : i11;
   if (!i11) {
    i18 = 281;
    break L17;
   }
   _memcpy(i57 | 0, i3 | 0, i11 | 0) | 0;
   HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) - i11;
   i5 = i5 - i11 | 0;
   i9 = i2;
   i10 = i4 - i11 | 0;
   i3 = i3 + i11 | 0;
   i11 = i57 + i11 | 0;
  } else if ((i18 | 0) == 158) {
   i18 = 0;
   if (i8 >>> 0 < 19) {
    do {
     HEAP16[i70 + (HEAPU16[143544 + (i8 << 1) >> 1] << 1) + 112 >> 1] = 0;
     i8 = i8 + 1 | 0;
    } while ((i8 | 0) != 19);
    HEAP32[i43 >> 2] = 19;
   }
   HEAP32[i45 >> 2] = i44;
   HEAP32[i27 >> 2] = i44;
   HEAP32[i28 >> 2] = 7;
   i6 = _inflate_table(0, i46, 19, i45, i28, i47) | 0;
   if (!i6) {
    HEAP32[i43 >> 2] = 0;
    HEAP32[i70 >> 2] = 18;
    i12 = 0;
    i6 = 0;
    i18 = 164;
    break;
   } else {
    HEAP32[i21 >> 2] = 143816;
    HEAP32[i70 >> 2] = 29;
    i9 = i2;
    i10 = i4;
    i11 = i57;
    break;
   }
  } while (0);
  L163 : do if ((i18 | 0) == 55) while (1) {
   i18 = 0;
   if (!i5) {
    i5 = 0;
    i3 = i11;
    break L17;
   }
   i5 = i5 + -1 | 0;
   i3 = i11 + 1 | 0;
   i2 = (HEAPU8[i11 >> 0] << i1) + i2 | 0;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= 16) {
    i18 = 57;
    break;
   } else {
    i11 = i3;
    i18 = 55;
   }
  } else if ((i18 | 0) == 125) {
   i18 = 0;
   if (HEAP32[i73 >> 2] | 0) {
    i9 = i1 & 7;
    HEAP32[i70 >> 2] = 26;
    i1 = i1 - i9 | 0;
    i9 = i2 >>> i9;
    i10 = i4;
    i11 = i57;
    break;
   }
   if (i1 >>> 0 < 3) {
    i11 = i3;
    while (1) {
     if (!i5) {
      i5 = 0;
      i3 = i11;
      break L17;
     }
     i5 = i5 + -1 | 0;
     i3 = i11 + 1 | 0;
     i2 = (HEAPU8[i11 >> 0] << i1) + i2 | 0;
     i1 = i1 + 8 | 0;
     if (i1 >>> 0 < 3) i11 = i3; else break;
    }
   }
   HEAP32[i73 >> 2] = i2 & 1;
   i8 = i2 >>> 1 & 3;
   if ((i8 | 0) == 2) HEAP32[i70 >> 2] = 16; else if ((i8 | 0) == 3) {
    HEAP32[i21 >> 2] = 143720;
    HEAP32[i70 >> 2] = 29;
   } else if (!i8) HEAP32[i70 >> 2] = 13; else if ((i8 | 0) == 1 ? (HEAP32[i27 >> 2] = 144112, HEAP32[i28 >> 2] = 9, HEAP32[i29 >> 2] = 146160, HEAP32[i30 >> 2] = 5, HEAP32[i70 >> 2] = 19, i31) : 0) {
    i18 = 133;
    break L17;
   }
   i1 = i1 + -3 | 0;
   i9 = i2 >>> 3;
   i10 = i4;
   i11 = i57;
  } else if ((i18 | 0) == 164) {
   i18 = 0;
   i10 = HEAP32[i40 >> 2] | 0;
   i11 = HEAP32[i41 >> 2] | 0;
   do if (i12 >>> 0 < (i11 + i10 | 0) >>> 0) {
    i17 = i12;
    i16 = i10;
    i15 = i11;
    L181 : while (1) {
     i9 = (1 << HEAP32[i28 >> 2]) + -1 | 0;
     i12 = i9 & i2;
     i13 = HEAP32[i27 >> 2] | 0;
     i11 = HEAPU8[i13 + (i12 << 2) + 1 >> 0] | 0;
     if (i1 >>> 0 < i11 >>> 0) while (1) {
      if (!i5) {
       i5 = 0;
       break L17;
      }
      i5 = i5 + -1 | 0;
      i8 = i3 + 1 | 0;
      i2 = (HEAPU8[i3 >> 0] << i1) + i2 | 0;
      i1 = i1 + 8 | 0;
      i12 = i9 & i2;
      i11 = HEAPU8[i13 + (i12 << 2) + 1 >> 0] | 0;
      if (i1 >>> 0 < i11 >>> 0) i3 = i8; else {
       i14 = i11;
       i3 = i8;
       break;
      }
     } else i14 = i11;
     i11 = HEAP16[i13 + (i12 << 2) + 2 >> 1] | 0;
     L188 : do if ((i11 & 65535) < 16) {
      HEAP32[i43 >> 2] = i17 + 1;
      HEAP16[i70 + (i17 << 1) + 112 >> 1] = i11;
      i1 = i1 - i14 | 0;
      i2 = i2 >>> i14;
     } else {
      if (i11 << 16 >> 16 == 16) {
       i11 = i14 + 2 | 0;
       if (i1 >>> 0 < i11 >>> 0) while (1) {
        if (!i5) {
         i5 = 0;
         break L17;
        }
        i5 = i5 + -1 | 0;
        i12 = i3 + 1 | 0;
        i2 = (HEAPU8[i3 >> 0] << i1) + i2 | 0;
        i1 = i1 + 8 | 0;
        if (i1 >>> 0 < i11 >>> 0) i3 = i12; else {
         i3 = i12;
         break;
        }
       }
       i9 = i2 >>> i14;
       i1 = i1 - i14 | 0;
       if (!i17) {
        i18 = 178;
        break L181;
       }
       i1 = i1 + -2 | 0;
       i10 = (i9 & 3) + 3 | 0;
       i2 = i9 >>> 2;
       i12 = HEAP16[i70 + (i17 + -1 << 1) + 112 >> 1] | 0;
      } else if (i11 << 16 >> 16 == 17) {
       i11 = i14 + 3 | 0;
       if (i1 >>> 0 < i11 >>> 0) {
        i12 = i3;
        while (1) {
         if (!i5) {
          i5 = 0;
          i3 = i12;
          break L17;
         }
         i5 = i5 + -1 | 0;
         i3 = i12 + 1 | 0;
         i2 = (HEAPU8[i12 >> 0] << i1) + i2 | 0;
         i1 = i1 + 8 | 0;
         if (i1 >>> 0 < i11 >>> 0) i12 = i3; else break;
        }
       }
       i2 = i2 >>> i14;
       i1 = -3 - i14 + i1 | 0;
       i10 = (i2 & 7) + 3 | 0;
       i2 = i2 >>> 3;
       i12 = 0;
      } else {
       i11 = i14 + 7 | 0;
       if (i1 >>> 0 < i11 >>> 0) while (1) {
        if (!i5) {
         i5 = 0;
         break L17;
        }
        i5 = i5 + -1 | 0;
        i12 = i3 + 1 | 0;
        i2 = (HEAPU8[i3 >> 0] << i1) + i2 | 0;
        i1 = i1 + 8 | 0;
        if (i1 >>> 0 < i11 >>> 0) i3 = i12; else {
         i3 = i12;
         break;
        }
       }
       i2 = i2 >>> i14;
       i1 = -7 - i14 + i1 | 0;
       i10 = (i2 & 127) + 11 | 0;
       i2 = i2 >>> 7;
       i12 = 0;
      }
      if ((i17 + i10 | 0) >>> 0 > (i15 + i16 | 0) >>> 0) {
       i18 = 187;
       break L181;
      } else i11 = i17;
      while (1) {
       i10 = i10 + -1 | 0;
       HEAP32[i43 >> 2] = i11 + 1;
       HEAP16[i70 + (i11 << 1) + 112 >> 1] = i12;
       if (!i10) break L188;
       i11 = HEAP32[i43 >> 2] | 0;
      }
     } while (0);
     i17 = HEAP32[i43 >> 2] | 0;
     i16 = HEAP32[i40 >> 2] | 0;
     i15 = HEAP32[i41 >> 2] | 0;
     if (i17 >>> 0 >= (i15 + i16 | 0) >>> 0) {
      i18 = 190;
      break;
     }
    }
    if ((i18 | 0) == 178) {
     i18 = 0;
     HEAP32[i21 >> 2] = 143848;
     HEAP32[i70 >> 2] = 29;
     i10 = i4;
     i11 = i57;
     break L163;
    } else if ((i18 | 0) == 187) {
     i18 = 0;
     HEAP32[i21 >> 2] = 143848;
     HEAP32[i70 >> 2] = 29;
     i9 = i2;
     i10 = i4;
     i11 = i57;
     break L163;
    } else if ((i18 | 0) == 190) {
     i18 = 0;
     if ((HEAP32[i70 >> 2] | 0) == 29) {
      i9 = i2;
      i10 = i4;
      i11 = i57;
      break L163;
     } else {
      i10 = i16;
      break;
     }
    }
   } while (0);
   if (!(HEAP16[i48 >> 1] | 0)) {
    HEAP32[i21 >> 2] = 143880;
    HEAP32[i70 >> 2] = 29;
    i9 = i2;
    i10 = i4;
    i11 = i57;
    break;
   }
   HEAP32[i45 >> 2] = i44;
   HEAP32[i27 >> 2] = i44;
   HEAP32[i28 >> 2] = 9;
   i6 = _inflate_table(1, i46, i10, i45, i28, i47) | 0;
   if (i6) {
    HEAP32[i21 >> 2] = 143920;
    HEAP32[i70 >> 2] = 29;
    i9 = i2;
    i10 = i4;
    i11 = i57;
    break;
   }
   HEAP32[i29 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i30 >> 2] = 6;
   i6 = _inflate_table(2, i70 + (HEAP32[i40 >> 2] << 1) + 112 | 0, HEAP32[i41 >> 2] | 0, i45, i30, i47) | 0;
   if (!i6) {
    HEAP32[i70 >> 2] = 19;
    if (i31) {
     i6 = 0;
     i18 = 281;
     break L17;
    } else {
     i6 = 0;
     i18 = 198;
     break;
    }
   } else {
    HEAP32[i21 >> 2] = 143952;
    HEAP32[i70 >> 2] = 29;
    i9 = i2;
    i10 = i4;
    i11 = i57;
    break;
   }
  } while (0);
  if ((i18 | 0) == 57) {
   i1 = HEAP32[i20 >> 2] | 0;
   if (i1) {
    HEAP32[i1 + 8 >> 2] = i2 & 255;
    HEAP32[i1 + 12 >> 2] = i2 >>> 8;
   }
   if (HEAP32[i66 >> 2] & 512) {
    HEAP8[i56 >> 0] = i2;
    HEAP8[i19 >> 0] = i2 >>> 8;
    HEAP32[i68 >> 2] = _crc32(HEAP32[i68 >> 2] | 0, i56, 2) | 0;
   }
   HEAP32[i70 >> 2] = 4;
   i1 = 0;
   i2 = 0;
   i18 = 62;
  } else if ((i18 | 0) == 198) {
   HEAP32[i70 >> 2] = 20;
   i18 = 199;
  }
  do if ((i18 | 0) == 62) {
   i18 = 0;
   i12 = HEAP32[i66 >> 2] | 0;
   if (!(i12 & 1024)) {
    i8 = HEAP32[i20 >> 2] | 0;
    if (i8) HEAP32[i8 + 16 >> 2] = 0;
   } else {
    if (i1 >>> 0 < 16) while (1) {
     if (!i5) {
      i5 = 0;
      break L17;
     }
     i5 = i5 + -1 | 0;
     i11 = i3 + 1 | 0;
     i2 = (HEAPU8[i3 >> 0] << i1) + i2 | 0;
     i1 = i1 + 8 | 0;
     if (i1 >>> 0 >= 16) {
      i3 = i11;
      break;
     } else i3 = i11;
    }
    HEAP32[i24 >> 2] = i2;
    i1 = HEAP32[i20 >> 2] | 0;
    if (i1) HEAP32[i1 + 20 >> 2] = i2;
    if (!(i12 & 512)) {
     i1 = 0;
     i2 = 0;
    } else {
     HEAP8[i56 >> 0] = i2;
     HEAP8[i19 >> 0] = i2 >>> 8;
     HEAP32[i68 >> 2] = _crc32(HEAP32[i68 >> 2] | 0, i56, 2) | 0;
     i1 = 0;
     i2 = 0;
    }
   }
   HEAP32[i70 >> 2] = 5;
   i18 = 73;
  } else if ((i18 | 0) == 199) {
   i18 = 0;
   if (i5 >>> 0 > 5 & i4 >>> 0 > 257) {
    HEAP32[i67 >> 2] = i57;
    HEAP32[i61 >> 2] = i4;
    HEAP32[i75 >> 2] = i3;
    HEAP32[i58 >> 2] = i5;
    HEAP32[i59 >> 2] = i2;
    HEAP32[i72 >> 2] = i1;
    _inflate_fast(i75, i7);
    i11 = HEAP32[i67 >> 2] | 0;
    i10 = HEAP32[i61 >> 2] | 0;
    i3 = HEAP32[i75 >> 2] | 0;
    i5 = HEAP32[i58 >> 2] | 0;
    i9 = HEAP32[i59 >> 2] | 0;
    i1 = HEAP32[i72 >> 2] | 0;
    if ((HEAP32[i70 >> 2] | 0) != 11) break;
    HEAP32[i32 >> 2] = -1;
    break;
   }
   HEAP32[i32 >> 2] = 0;
   i10 = (1 << HEAP32[i28 >> 2]) + -1 | 0;
   i9 = i10 & i2;
   i14 = HEAP32[i27 >> 2] | 0;
   i11 = HEAP8[i14 + (i9 << 2) + 1 >> 0] | 0;
   i8 = i11 & 255;
   if (i8 >>> 0 > i1 >>> 0) {
    i12 = i3;
    while (1) {
     if (!i5) {
      i5 = 0;
      i3 = i12;
      break L17;
     }
     i5 = i5 + -1 | 0;
     i3 = i12 + 1 | 0;
     i2 = (HEAPU8[i12 >> 0] << i1) + i2 | 0;
     i1 = i1 + 8 | 0;
     i9 = i10 & i2;
     i11 = HEAP8[i14 + (i9 << 2) + 1 >> 0] | 0;
     i8 = i11 & 255;
     if (i8 >>> 0 > i1 >>> 0) i12 = i3; else break;
    }
   }
   i12 = HEAP8[i14 + (i9 << 2) >> 0] | 0;
   i10 = HEAP16[i14 + (i9 << 2) + 2 >> 1] | 0;
   i9 = i12 & 255;
   if (i12 << 24 >> 24 != 0 & (i9 & 240 | 0) == 0) {
    i13 = i10 & 65535;
    i10 = (1 << i8 + i9) + -1 | 0;
    i9 = ((i2 & i10) >>> i8) + i13 | 0;
    i11 = HEAP8[i14 + (i9 << 2) + 1 >> 0] | 0;
    if (((i11 & 255) + i8 | 0) >>> 0 > i1 >>> 0) {
     i12 = i3;
     while (1) {
      if (!i5) {
       i5 = 0;
       i3 = i12;
       break L17;
      }
      i5 = i5 + -1 | 0;
      i3 = i12 + 1 | 0;
      i2 = (HEAPU8[i12 >> 0] << i1) + i2 | 0;
      i1 = i1 + 8 | 0;
      i9 = ((i2 & i10) >>> i8) + i13 | 0;
      i11 = HEAP8[i14 + (i9 << 2) + 1 >> 0] | 0;
      if (((i11 & 255) + i8 | 0) >>> 0 > i1 >>> 0) i12 = i3; else break;
     }
    }
    i10 = HEAP16[i14 + (i9 << 2) + 2 >> 1] | 0;
    i12 = HEAP8[i14 + (i9 << 2) >> 0] | 0;
    HEAP32[i32 >> 2] = i8;
    i13 = i8;
    i1 = i1 - i8 | 0;
    i2 = i2 >>> i8;
   } else i13 = 0;
   i9 = i11 & 255;
   i2 = i2 >>> i9;
   i1 = i1 - i9 | 0;
   HEAP32[i32 >> 2] = i13 + i9;
   HEAP32[i24 >> 2] = i10 & 65535;
   i9 = i12 & 255;
   if (!(i12 << 24 >> 24)) {
    HEAP32[i70 >> 2] = 25;
    i9 = i2;
    i10 = i4;
    i11 = i57;
    break;
   }
   if (i9 & 32) {
    HEAP32[i32 >> 2] = -1;
    HEAP32[i70 >> 2] = 11;
    i9 = i2;
    i10 = i4;
    i11 = i57;
    break;
   }
   if (!(i9 & 64)) {
    i13 = i9 & 15;
    HEAP32[i33 >> 2] = i13;
    HEAP32[i70 >> 2] = 21;
    i18 = 217;
    break;
   } else {
    HEAP32[i21 >> 2] = 143976;
    HEAP32[i70 >> 2] = 29;
    i9 = i2;
    i10 = i4;
    i11 = i57;
    break;
   }
  } while (0);
  if ((i18 | 0) == 73) {
   i8 = HEAP32[i66 >> 2] | 0;
   if (i8 & 1024) {
    i10 = HEAP32[i24 >> 2] | 0;
    i11 = i10 >>> 0 > i5 >>> 0 ? i5 : i10;
    if (i11) {
     i9 = HEAP32[i20 >> 2] | 0;
     if ((i9 | 0) != 0 ? (i51 = HEAP32[i9 + 16 >> 2] | 0, (i51 | 0) != 0) : 0) {
      i8 = (HEAP32[i9 + 20 >> 2] | 0) - i10 | 0;
      i10 = HEAP32[i9 + 24 >> 2] | 0;
      _memcpy(i51 + i8 | 0, i3 | 0, ((i8 + i11 | 0) >>> 0 > i10 >>> 0 ? i10 - i8 | 0 : i11) | 0) | 0;
      i8 = HEAP32[i66 >> 2] | 0;
     }
     if (i8 & 512) HEAP32[i68 >> 2] = _crc32(HEAP32[i68 >> 2] | 0, i3, i11) | 0;
     i10 = (HEAP32[i24 >> 2] | 0) - i11 | 0;
     HEAP32[i24 >> 2] = i10;
     i5 = i5 - i11 | 0;
     i3 = i3 + i11 | 0;
    }
    if (i10) {
     i18 = 281;
     break;
    }
   }
   HEAP32[i24 >> 2] = 0;
   HEAP32[i70 >> 2] = 6;
   i18 = 83;
  } else if ((i18 | 0) == 217) {
   i18 = 0;
   if (!i13) i12 = HEAP32[i24 >> 2] | 0; else {
    if (i1 >>> 0 < i13 >>> 0) {
     i11 = i3;
     while (1) {
      if (!i5) {
       i5 = 0;
       i3 = i11;
       break L17;
      }
      i5 = i5 + -1 | 0;
      i3 = i11 + 1 | 0;
      i2 = (HEAPU8[i11 >> 0] << i1) + i2 | 0;
      i1 = i1 + 8 | 0;
      if (i1 >>> 0 < i13 >>> 0) i11 = i3; else break;
     }
    }
    i12 = (HEAP32[i24 >> 2] | 0) + ((1 << i13) + -1 & i2) | 0;
    HEAP32[i24 >> 2] = i12;
    HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + i13;
    i1 = i1 - i13 | 0;
    i2 = i2 >>> i13;
   }
   HEAP32[i34 >> 2] = i12;
   HEAP32[i70 >> 2] = 22;
   i18 = 224;
  }
  do if ((i18 | 0) == 83) {
   if (!(HEAP32[i66 >> 2] & 2048)) {
    i8 = HEAP32[i20 >> 2] | 0;
    if (i8) HEAP32[i8 + 28 >> 2] = 0;
   } else {
    if (!i5) {
     i5 = 0;
     i18 = 281;
     break L17;
    } else i11 = 0;
    do {
     i8 = i11;
     i11 = i11 + 1 | 0;
     i8 = HEAP8[i3 + i8 >> 0] | 0;
     i9 = HEAP32[i20 >> 2] | 0;
     if (((i9 | 0) != 0 ? (i52 = HEAP32[i9 + 28 >> 2] | 0, (i52 | 0) != 0) : 0) ? (i53 = HEAP32[i24 >> 2] | 0, i53 >>> 0 < (HEAP32[i9 + 32 >> 2] | 0) >>> 0) : 0) {
      HEAP32[i24 >> 2] = i53 + 1;
      HEAP8[i52 + i53 >> 0] = i8;
     }
     i10 = i8 << 24 >> 24 != 0;
    } while (i10 & i5 >>> 0 > i11 >>> 0);
    if (HEAP32[i66 >> 2] & 512) HEAP32[i68 >> 2] = _crc32(HEAP32[i68 >> 2] | 0, i3, i11) | 0;
    i5 = i5 - i11 | 0;
    i3 = i3 + i11 | 0;
    if (i10) {
     i18 = 281;
     break L17;
    }
   }
   HEAP32[i24 >> 2] = 0;
   HEAP32[i70 >> 2] = 7;
   i18 = 96;
  } else if ((i18 | 0) == 224) {
   i18 = 0;
   i10 = (1 << HEAP32[i30 >> 2]) + -1 | 0;
   i9 = i10 & i2;
   i14 = HEAP32[i29 >> 2] | 0;
   i11 = HEAP8[i14 + (i9 << 2) + 1 >> 0] | 0;
   i8 = i11 & 255;
   if (i8 >>> 0 > i1 >>> 0) {
    i12 = i3;
    while (1) {
     if (!i5) {
      i5 = 0;
      i3 = i12;
      break L17;
     }
     i5 = i5 + -1 | 0;
     i3 = i12 + 1 | 0;
     i2 = (HEAPU8[i12 >> 0] << i1) + i2 | 0;
     i1 = i1 + 8 | 0;
     i9 = i10 & i2;
     i11 = HEAP8[i14 + (i9 << 2) + 1 >> 0] | 0;
     i8 = i11 & 255;
     if (i8 >>> 0 > i1 >>> 0) i12 = i3; else break;
    }
   }
   i12 = HEAP8[i14 + (i9 << 2) >> 0] | 0;
   i10 = HEAP16[i14 + (i9 << 2) + 2 >> 1] | 0;
   i9 = i12 & 255;
   if (!(i9 & 240)) {
    i13 = i10 & 65535;
    i10 = (1 << i8 + i9) + -1 | 0;
    i9 = ((i2 & i10) >>> i8) + i13 | 0;
    i11 = HEAP8[i14 + (i9 << 2) + 1 >> 0] | 0;
    if (((i11 & 255) + i8 | 0) >>> 0 > i1 >>> 0) {
     i12 = i3;
     while (1) {
      if (!i5) {
       i5 = 0;
       i3 = i12;
       break L17;
      }
      i5 = i5 + -1 | 0;
      i3 = i12 + 1 | 0;
      i2 = (HEAPU8[i12 >> 0] << i1) + i2 | 0;
      i1 = i1 + 8 | 0;
      i9 = ((i2 & i10) >>> i8) + i13 | 0;
      i11 = HEAP8[i14 + (i9 << 2) + 1 >> 0] | 0;
      if (((i11 & 255) + i8 | 0) >>> 0 > i1 >>> 0) i12 = i3; else break;
     }
    }
    i10 = HEAP16[i14 + (i9 << 2) + 2 >> 1] | 0;
    i12 = HEAP8[i14 + (i9 << 2) >> 0] | 0;
    i13 = (HEAP32[i32 >> 2] | 0) + i8 | 0;
    HEAP32[i32 >> 2] = i13;
    i1 = i1 - i8 | 0;
    i2 = i2 >>> i8;
   } else i13 = HEAP32[i32 >> 2] | 0;
   i9 = i11 & 255;
   i2 = i2 >>> i9;
   i1 = i1 - i9 | 0;
   HEAP32[i32 >> 2] = i13 + i9;
   i9 = i12 & 255;
   if (!(i9 & 64)) {
    HEAP32[i35 >> 2] = i10 & 65535;
    i13 = i9 & 15;
    HEAP32[i33 >> 2] = i13;
    HEAP32[i70 >> 2] = 23;
    i18 = 236;
    break;
   } else {
    HEAP32[i21 >> 2] = 144008;
    HEAP32[i70 >> 2] = 29;
    i9 = i2;
    i10 = i4;
    i11 = i57;
    break;
   }
  } while (0);
  if ((i18 | 0) == 96) {
   if (!(HEAP32[i66 >> 2] & 4096)) {
    i8 = HEAP32[i20 >> 2] | 0;
    if (i8) HEAP32[i8 + 36 >> 2] = 0;
   } else {
    if (!i5) {
     i5 = 0;
     i18 = 281;
     break;
    } else i11 = 0;
    do {
     i9 = i11;
     i11 = i11 + 1 | 0;
     i9 = HEAP8[i3 + i9 >> 0] | 0;
     i8 = HEAP32[i20 >> 2] | 0;
     if (((i8 | 0) != 0 ? (i54 = HEAP32[i8 + 36 >> 2] | 0, (i54 | 0) != 0) : 0) ? (i55 = HEAP32[i24 >> 2] | 0, i55 >>> 0 < (HEAP32[i8 + 40 >> 2] | 0) >>> 0) : 0) {
      HEAP32[i24 >> 2] = i55 + 1;
      HEAP8[i54 + i55 >> 0] = i9;
     }
     i10 = i9 << 24 >> 24 != 0;
    } while (i10 & i5 >>> 0 > i11 >>> 0);
    if (HEAP32[i66 >> 2] & 512) HEAP32[i68 >> 2] = _crc32(HEAP32[i68 >> 2] | 0, i3, i11) | 0;
    i5 = i5 - i11 | 0;
    i3 = i3 + i11 | 0;
    if (i10) {
     i18 = 281;
     break;
    }
   }
   HEAP32[i70 >> 2] = 8;
   i18 = 109;
  } else if ((i18 | 0) == 236) {
   i18 = 0;
   if (i13) {
    if (i1 >>> 0 < i13 >>> 0) {
     i11 = i3;
     while (1) {
      if (!i5) {
       i5 = 0;
       i3 = i11;
       break L17;
      }
      i5 = i5 + -1 | 0;
      i3 = i11 + 1 | 0;
      i2 = (HEAPU8[i11 >> 0] << i1) + i2 | 0;
      i1 = i1 + 8 | 0;
      if (i1 >>> 0 < i13 >>> 0) i11 = i3; else break;
     }
    }
    HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + ((1 << i13) + -1 & i2);
    HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + i13;
    i1 = i1 - i13 | 0;
    i2 = i2 >>> i13;
   }
   HEAP32[i70 >> 2] = 24;
   i18 = 242;
  }
  do if ((i18 | 0) == 109) {
   i18 = 0;
   i13 = HEAP32[i66 >> 2] | 0;
   if (i13 & 512) {
    if (i1 >>> 0 < 16) while (1) {
     if (!i5) {
      i5 = 0;
      break L17;
     }
     i5 = i5 + -1 | 0;
     i12 = i3 + 1 | 0;
     i2 = (HEAPU8[i3 >> 0] << i1) + i2 | 0;
     i1 = i1 + 8 | 0;
     if (i1 >>> 0 < 16) i3 = i12; else {
      i3 = i12;
      break;
     }
    }
    if ((i2 | 0) == (HEAP32[i68 >> 2] & 65535 | 0)) {
     i1 = 0;
     i2 = 0;
    } else {
     HEAP32[i21 >> 2] = 143696;
     HEAP32[i70 >> 2] = 29;
     i9 = i2;
     i10 = i4;
     i11 = i57;
     break;
    }
   }
   i9 = HEAP32[i20 >> 2] | 0;
   if (i9) {
    HEAP32[i9 + 44 >> 2] = i13 >>> 9 & 1;
    HEAP32[i9 + 48 >> 2] = 1;
   }
   i9 = _crc32(0, 0, 0) | 0;
   HEAP32[i68 >> 2] = i9;
   HEAP32[i69 >> 2] = i9;
   HEAP32[i70 >> 2] = 11;
   i9 = i2;
   i10 = i4;
   i11 = i57;
  } else if ((i18 | 0) == 242) {
   i18 = 0;
   if (!i4) {
    i4 = 0;
    i18 = 281;
    break L17;
   }
   i9 = i7 - i4 | 0;
   i10 = HEAP32[i35 >> 2] | 0;
   if (i10 >>> 0 > i9 >>> 0) {
    i10 = i10 - i9 | 0;
    if (i10 >>> 0 > (HEAP32[i36 >> 2] | 0) >>> 0 ? (HEAP32[i37 >> 2] | 0) != 0 : 0) {
     HEAP32[i21 >> 2] = 144032;
     HEAP32[i70 >> 2] = 29;
     i9 = i2;
     i10 = i4;
     i11 = i57;
     break;
    }
    i9 = HEAP32[i38 >> 2] | 0;
    if (i10 >>> 0 > i9 >>> 0) {
     i11 = i10 - i9 | 0;
     i8 = i11;
     i11 = (HEAP32[i39 >> 2] | 0) + ((HEAP32[i60 >> 2] | 0) - i11) | 0;
    } else {
     i8 = i10;
     i11 = (HEAP32[i39 >> 2] | 0) + (i9 - i10) | 0;
    }
    i10 = HEAP32[i24 >> 2] | 0;
    i9 = i10;
    i8 = i8 >>> 0 > i10 >>> 0 ? i10 : i8;
   } else {
    i8 = HEAP32[i24 >> 2] | 0;
    i9 = i8;
    i11 = i57 + (0 - i10) | 0;
   }
   i10 = i8 >>> 0 > i4 >>> 0 ? i4 : i8;
   HEAP32[i24 >> 2] = i9 - i10;
   i9 = ~i4;
   i12 = ~i8;
   i12 = i9 >>> 0 > i12 >>> 0 ? i9 : i12;
   i9 = i10;
   i8 = i57;
   while (1) {
    HEAP8[i8 >> 0] = HEAP8[i11 >> 0] | 0;
    i9 = i9 + -1 | 0;
    if (!i9) break; else {
     i11 = i11 + 1 | 0;
     i8 = i8 + 1 | 0;
    }
   }
   i10 = i4 - i10 | 0;
   i11 = i57 + ~i12 | 0;
   if (!(HEAP32[i24 >> 2] | 0)) {
    HEAP32[i70 >> 2] = 20;
    i9 = i2;
   } else i9 = i2;
  } while (0);
  i2 = HEAP32[i70 >> 2] | 0;
  i4 = i10;
  i57 = i11;
 }
 if ((i18 | 0) == 122) {
  HEAP32[i67 >> 2] = i57;
  HEAP32[i61 >> 2] = i4;
  HEAP32[i75 >> 2] = i3;
  HEAP32[i58 >> 2] = i5;
  HEAP32[i59 >> 2] = i2;
  HEAP32[i72 >> 2] = i1;
  i46 = 2;
  STACKTOP = i76;
  return i46 | 0;
 } else if ((i18 | 0) == 133) {
  i1 = i1 + -3 | 0;
  i2 = i2 >>> 3;
 } else if ((i18 | 0) == 280) {
  HEAP32[i70 >> 2] = 28;
  i6 = 1;
 } else if ((i18 | 0) != 281) if ((i18 | 0) == 297) {
  i46 = -4;
  STACKTOP = i76;
  return i46 | 0;
 } else if ((i18 | 0) == 298) {
  STACKTOP = i76;
  return i1 | 0;
 }
 HEAP32[i67 >> 2] = i57;
 HEAP32[i61 >> 2] = i4;
 HEAP32[i75 >> 2] = i3;
 HEAP32[i58 >> 2] = i5;
 HEAP32[i59 >> 2] = i2;
 HEAP32[i72 >> 2] = i1;
 if (!(HEAP32[i60 >> 2] | 0)) {
  if (((i7 | 0) != (i4 | 0) ? (i62 = HEAP32[i70 >> 2] | 0, i62 >>> 0 < 29) : 0) ? i62 >>> 0 < 26 | (i74 | 0) != 4 : 0) i18 = 286;
 } else i18 = 286;
 do if ((i18 | 0) == 286) {
  if (!(_updatewindow(i75, i57, i7 - i4 | 0) | 0)) {
   i5 = HEAP32[i58 >> 2] | 0;
   i4 = HEAP32[i61 >> 2] | 0;
   break;
  }
  HEAP32[i70 >> 2] = 30;
  i46 = -4;
  STACKTOP = i76;
  return i46 | 0;
 } while (0);
 i3 = i7 - i4 | 0;
 i46 = i75 + 8 | 0;
 HEAP32[i46 >> 2] = i71 - i5 + (HEAP32[i46 >> 2] | 0);
 HEAP32[i64 >> 2] = (HEAP32[i64 >> 2] | 0) + i3;
 HEAP32[i65 >> 2] = (HEAP32[i65 >> 2] | 0) + i3;
 if ((HEAP32[i63 >> 2] | 0) != 0 & (i7 | 0) != (i4 | 0)) {
  i1 = HEAP32[i68 >> 2] | 0;
  i2 = (HEAP32[i67 >> 2] | 0) + (0 - i3) | 0;
  if (!(HEAP32[i66 >> 2] | 0)) i2 = _adler32(i1, i2, i3) | 0; else i2 = _crc32(i1, i2, i3) | 0;
  HEAP32[i68 >> 2] = i2;
  HEAP32[i69 >> 2] = i2;
 }
 i1 = HEAP32[i70 >> 2] | 0;
 if ((i1 | 0) == 19) i2 = 256; else i2 = (i1 | 0) == 14 ? 256 : 0;
 HEAP32[i75 + 44 >> 2] = ((HEAP32[i73 >> 2] | 0) != 0 ? 64 : 0) + (HEAP32[i72 >> 2] | 0) + ((i1 | 0) == 11 ? 128 : 0) + i2;
 i46 = ((i71 | 0) == (i5 | 0) & (i7 | 0) == (i4 | 0) | (i74 | 0) == 4) & (i6 | 0) == 0 ? -5 : i6;
 STACKTOP = i76;
 return i46 | 0;
}

function __ZNK2cv13AlgorithmInfo3getEPKNS_9AlgorithmEPKciPv(i10, i68, i58, i49, i69) {
 i10 = i10 | 0;
 i68 = i68 | 0;
 i58 = i58 | 0;
 i49 = i49 | 0;
 i69 = i69 | 0;
 var i1 = 0, i2 = 0, i3 = 0, d4 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i70 = 0;
 i70 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 i2 = i70;
 i3 = i70 + 448 | 0;
 i35 = i70 + 440 | 0;
 i11 = i70 + 432 | 0;
 i19 = i70 + 424 | 0;
 i53 = i70 + 416 | 0;
 i36 = i70 + 408 | 0;
 i31 = i70 + 400 | 0;
 i32 = i70 + 392 | 0;
 i54 = i70 + 384 | 0;
 i43 = i70 + 376 | 0;
 i33 = i70 + 368 | 0;
 i34 = i70 + 360 | 0;
 i55 = i70 + 352 | 0;
 i44 = i70 + 344 | 0;
 i12 = i70 + 336 | 0;
 i13 = i70 + 328 | 0;
 i50 = i70 + 320 | 0;
 i45 = i70 + 312 | 0;
 i14 = i70 + 304 | 0;
 i15 = i70 + 296 | 0;
 i51 = i70 + 288 | 0;
 i46 = i70 + 280 | 0;
 i16 = i70 + 272 | 0;
 i17 = i70 + 264 | 0;
 i56 = i70 + 256 | 0;
 i37 = i70 + 248 | 0;
 i18 = i70 + 240 | 0;
 i20 = i70 + 232 | 0;
 i52 = i70 + 224 | 0;
 i47 = i70 + 216 | 0;
 i38 = i70 + 208 | 0;
 i21 = i70 + 200 | 0;
 i22 = i70 + 192 | 0;
 i48 = i70 + 184 | 0;
 i39 = i70 + 176 | 0;
 i23 = i70 + 168 | 0;
 i24 = i70 + 160 | 0;
 i62 = i70 + 104 | 0;
 i40 = i70 + 96 | 0;
 i25 = i70 + 88 | 0;
 i26 = i70 + 80 | 0;
 i67 = i70 + 64 | 0;
 i41 = i70 + 56 | 0;
 i27 = i70 + 48 | 0;
 i28 = i70 + 40 | 0;
 i6 = i70 + 32 | 0;
 i42 = i70 + 24 | 0;
 i29 = i70 + 16 | 0;
 i30 = i70 + 8 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i57 = (i58 | 0) == 0;
 if (!i57) {
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  if ((i9 | 0) == (i7 | 0)) {
   i8 = i9;
   i10 = 0;
  } else {
   i10 = 0;
   i8 = (i9 - i7 | 0) / 44 | 0;
   do {
    i59 = (i10 + i8 | 0) >>> 1;
    i60 = HEAP32[i7 + (i59 * 44 | 0) >> 2] | 0;
    i60 = (_strcmp((i60 | 0) == 0 ? 39376 : i60, i58) | 0) < 0;
    i10 = i60 ? i59 + 1 | 0 : i10;
    i8 = i60 ? i8 : i59;
   } while (i8 >>> 0 > i10 >>> 0);
   i8 = i9;
   i9 = i7;
  }
  if (i10 >>> 0 < ((i8 - i9 | 0) / 44 | 0) >>> 0 ? (i8 = HEAP32[i9 + (i10 * 44 | 0) >> 2] | 0, (_strcmp((i8 | 0) == 0 ? 39376 : i8, i58) | 0) == 0) : 0) i63 = i9 + (i10 * 44 | 0) + 8 | 0; else i1 = 8;
 } else i1 = 8;
 if ((i1 | 0) == 8) {
  HEAP32[i2 >> 2] = (i58 | 0) != 0 ? i58 : 38112;
  __ZN2cv6formatEPKcz(i3, 38080, i2);
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i3, 38280, 37992, 853);
  __ZN2cv6String10deallocateEv(i3);
  i63 = 0;
 }
 i7 = i63 + 12 | 0;
 i2 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
 i66 = i7 + 4 | 0;
 i66 = HEAPU8[i66 >> 0] | HEAPU8[i66 + 1 >> 0] << 8 | HEAPU8[i66 + 2 >> 0] << 16 | HEAPU8[i66 + 3 >> 0] << 24;
 i1 = (i49 | 0) == 0;
 i3 = (i49 | 0) == 1;
 i64 = (i49 | 0) == 2;
 i65 = (i49 | 0) == 7;
 i59 = (i49 | 0) == 8;
 i60 = (i49 | 0) == 9;
 i61 = (i49 | 0) == 11;
 switch (i49 | 0) {
 case 4:
  {
   if ((HEAP32[i63 >> 2] | 0) == 4) {
    i7 = i2;
    i6 = i66;
   } else {
    i47 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] & 127](i68) | 0) >> 2] | 0;
    i9 = HEAP32[i47 + 12 >> 2] | 0;
    HEAP32[i23 >> 2] = i9;
    HEAP32[i23 + 4 >> 2] = HEAP32[i47 + 16 >> 2];
    if (i9) {
     i47 = i9 + -4 | 0;
     HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
    }
    HEAP32[i24 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 0;
    if (!i57) {
     i47 = _strlen(i58 | 0) | 0;
     _memcpy(__ZN2cv6String8allocateEj(i24, i47) | 0, i58 | 0, i47 | 0) | 0;
    }
    __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i39, i23, i24, HEAP32[i63 >> 2] | 0, 4);
    __ZN2cv6String10deallocateEv(i24);
    __ZN2cv6String10deallocateEv(i23);
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i39, 38280, 37992, 1036);
    __ZN2cv6String10deallocateEv(i39);
    i6 = i7 + 4 | 0;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
   }
   do if (!(i6 & 1 | i7)) {
    i8 = HEAP32[i63 + 4 >> 2] | 0;
    i2 = i68 + i8 | 0;
    HEAP32[i62 >> 2] = HEAP32[i2 >> 2];
    i1 = i62 + 4 | 0;
    i6 = i68 + (i8 + 4) | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    HEAP32[i1 >> 2] = i7;
    i47 = i62 + 8 | 0;
    HEAP32[i47 >> 2] = HEAP32[i68 + (i8 + 8) >> 2];
    HEAP32[i62 + 12 >> 2] = HEAP32[i68 + (i8 + 12) >> 2];
    HEAP32[i62 + 16 >> 2] = HEAP32[i68 + (i8 + 16) >> 2];
    HEAP32[i62 + 20 >> 2] = HEAP32[i68 + (i8 + 20) >> 2];
    HEAP32[i62 + 24 >> 2] = HEAP32[i68 + (i8 + 24) >> 2];
    HEAP32[i62 + 28 >> 2] = HEAP32[i68 + (i8 + 28) >> 2];
    HEAP32[i62 + 32 >> 2] = HEAP32[i68 + (i8 + 32) >> 2];
    i3 = HEAP32[i68 + (i8 + 36) >> 2] | 0;
    HEAP32[i62 + 36 >> 2] = i3;
    HEAP32[i62 + 40 >> 2] = i47;
    i47 = i62 + 48 | 0;
    i9 = i62 + 44 | 0;
    HEAP32[i9 >> 2] = i47;
    HEAP32[i62 + 52 >> 2] = 0;
    HEAP32[i47 >> 2] = 0;
    if (i3) {
     i7 = i3 + 12 | 0;
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     i7 = HEAP32[i6 >> 2] | 0;
    }
    if ((i7 | 0) < 3) {
     i46 = HEAP32[i68 + (i8 + 44) >> 2] | 0;
     i47 = HEAP32[i9 >> 2] | 0;
     HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
     HEAP32[i47 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
     break;
    } else {
     HEAP32[i1 >> 2] = 0;
     __ZN2cv3Mat8copySizeERKS0_(i62, i2);
     break;
    }
   } else {
    i3 = i68 + (i66 >> 1) | 0;
    if (i66 & 1) i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + i2 >> 2] | 0;
    FUNCTION_TABLE_vii[i2 & 127](i62, i3);
   } while (0);
   __ZN2cv3MataSERKS0_(i69, i62) | 0;
   i1 = i62 + 36 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != 0 ? (i46 = i2 + 12 | 0, i47 = HEAP32[i46 >> 2] | 0, HEAP32[i46 >> 2] = i47 + -1, (i47 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i62);
   HEAP32[i1 >> 2] = 0;
   i47 = i62 + 16 | 0;
   i2 = i62 + 4 | 0;
   HEAP32[i47 + 0 >> 2] = 0;
   HEAP32[i47 + 4 >> 2] = 0;
   HEAP32[i47 + 8 >> 2] = 0;
   HEAP32[i47 + 12 >> 2] = 0;
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    i1 = HEAP32[i62 + 40 >> 2] | 0;
    i3 = 0;
    do {
     HEAP32[i1 + (i3 << 2) >> 2] = 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
   }
   i1 = HEAP32[i62 + 44 >> 2] | 0;
   if ((i1 | 0) == (i62 + 48 | 0)) {
    STACKTOP = i70;
    return;
   }
   __ZN2cv8fastFreeEPv(i1);
   STACKTOP = i70;
   return;
  }
 case 5:
  {
   if ((HEAP32[i63 >> 2] | 0) == 5) {
    i7 = i2;
    i6 = i66;
   } else {
    i47 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] & 127](i68) | 0) >> 2] | 0;
    i9 = HEAP32[i47 + 12 >> 2] | 0;
    HEAP32[i25 >> 2] = i9;
    HEAP32[i25 + 4 >> 2] = HEAP32[i47 + 16 >> 2];
    if (i9) {
     i47 = i9 + -4 | 0;
     HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
    }
    HEAP32[i26 >> 2] = 0;
    HEAP32[i26 + 4 >> 2] = 0;
    if (!i57) {
     i47 = _strlen(i58 | 0) | 0;
     _memcpy(__ZN2cv6String8allocateEj(i26, i47) | 0, i58 | 0, i47 | 0) | 0;
    }
    __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i40, i25, i26, HEAP32[i63 >> 2] | 0, 5);
    __ZN2cv6String10deallocateEv(i26);
    __ZN2cv6String10deallocateEv(i25);
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i40, 38280, 37992, 1047);
    __ZN2cv6String10deallocateEv(i40);
    i6 = i7 + 4 | 0;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
   }
   if (!(i6 & 1 | i7)) {
    i1 = HEAP32[i63 + 4 >> 2] | 0;
    i3 = i68 + i1 | 0;
    HEAP32[i67 >> 2] = 0;
    i10 = i67 + 4 | 0;
    HEAP32[i10 >> 2] = 0;
    i2 = i67 + 8 | 0;
    HEAP32[i2 >> 2] = 0;
    i1 = i68 + (i1 + 4) | 0;
    i46 = HEAP32[i1 >> 2] | 0;
    i47 = HEAP32[i3 >> 2] | 0;
    i7 = i46 - i47 | 0;
    i6 = (i7 | 0) / 56 | 0;
    if ((i46 | 0) != (i47 | 0)) {
     if (i6 >>> 0 > 76695844) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i67);
     i7 = __Znwj(i7) | 0;
     HEAP32[i10 >> 2] = i7;
     HEAP32[i67 >> 2] = i7;
     HEAP32[i2 >> 2] = i7 + (i6 * 56 | 0);
     i6 = HEAP32[i3 >> 2] | 0;
     i9 = HEAP32[i1 >> 2] | 0;
     if ((i6 | 0) != (i9 | 0)) do {
      do if (i7) {
       HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
       i3 = i7 + 4 | 0;
       i2 = i6 + 4 | 0;
       HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
       i47 = i7 + 8 | 0;
       HEAP32[i47 >> 2] = HEAP32[i6 + 8 >> 2];
       HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
       HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
       HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
       HEAP32[i7 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
       HEAP32[i7 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
       HEAP32[i7 + 32 >> 2] = HEAP32[i6 + 32 >> 2];
       i1 = HEAP32[i6 + 36 >> 2] | 0;
       HEAP32[i7 + 36 >> 2] = i1;
       HEAP32[i7 + 40 >> 2] = i47;
       i47 = i7 + 48 | 0;
       i8 = i7 + 44 | 0;
       HEAP32[i8 >> 2] = i47;
       HEAP32[i7 + 52 >> 2] = 0;
       HEAP32[i47 >> 2] = 0;
       if (i1) {
        i47 = i1 + 12 | 0;
        HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
       }
       if ((HEAP32[i2 >> 2] | 0) < 3) {
        i46 = HEAP32[i6 + 44 >> 2] | 0;
        i47 = HEAP32[i8 >> 2] | 0;
        HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
        HEAP32[i47 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
        break;
       } else {
        HEAP32[i3 >> 2] = 0;
        __ZN2cv3Mat8copySizeERKS0_(i7, i6);
        break;
       }
      } while (0);
      i7 = (HEAP32[i10 >> 2] | 0) + 56 | 0;
      HEAP32[i10 >> 2] = i7;
      i6 = i6 + 56 | 0;
     } while ((i6 | 0) != (i9 | 0));
    }
   } else {
    i3 = i68 + (i66 >> 1) | 0;
    if (i66 & 1) i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + i2 >> 2] | 0;
    FUNCTION_TABLE_vii[i2 & 127](i67, i3);
   }
   if ((i69 | 0) != (i67 | 0)) __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i69, HEAP32[i67 >> 2] | 0, HEAP32[i67 + 4 >> 2] | 0);
   i1 = HEAP32[i67 >> 2] | 0;
   if (!i1) {
    STACKTOP = i70;
    return;
   }
   i9 = i67 + 4 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    do {
     i6 = i2 + -56 | 0;
     HEAP32[i9 >> 2] = i6;
     i3 = i2 + -20 | 0;
     i7 = HEAP32[i3 >> 2] | 0;
     if ((i7 | 0) != 0 ? (i46 = i7 + 12 | 0, i47 = HEAP32[i46 >> 2] | 0, HEAP32[i46 >> 2] = i47 + -1, (i47 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i6);
     HEAP32[i3 >> 2] = 0;
     i47 = i2 + -40 | 0;
     i7 = i2 + -52 | 0;
     HEAP32[i47 + 0 >> 2] = 0;
     HEAP32[i47 + 4 >> 2] = 0;
     HEAP32[i47 + 8 >> 2] = 0;
     HEAP32[i47 + 12 >> 2] = 0;
     if ((HEAP32[i7 >> 2] | 0) > 0) {
      i6 = HEAP32[i2 + -16 >> 2] | 0;
      i3 = 0;
      do {
       HEAP32[i6 + (i3 << 2) >> 2] = 0;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) < (HEAP32[i7 >> 2] | 0));
     }
     i3 = HEAP32[i2 + -12 >> 2] | 0;
     if ((i3 | 0) != (i2 + -8 | 0)) __ZN2cv8fastFreeEPv(i3);
     i2 = HEAP32[i9 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i67 >> 2] | 0;
   }
   __ZdlPv(i1);
   STACKTOP = i70;
   return;
  }
 case 0:
 case 1:
 case 2:
 case 7:
 case 8:
 case 9:
 case 11:
  switch (HEAP32[i63 >> 2] | 0) {
  case 7:
   {
    if ((i49 | 0) == 2 | (i49 | 0) == 7) {
     i7 = i2;
     i6 = i66;
    } else {
     i47 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] & 127](i68) | 0) >> 2] | 0;
     i9 = HEAP32[i47 + 12 >> 2] | 0;
     HEAP32[i12 >> 2] = i9;
     HEAP32[i12 + 4 >> 2] = HEAP32[i47 + 16 >> 2];
     if (i9) {
      i47 = i9 + -4 | 0;
      HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
     }
     HEAP32[i13 >> 2] = 0;
     HEAP32[i13 + 4 >> 2] = 0;
     if (!i57) {
      i47 = _strlen(i58 | 0) | 0;
      _memcpy(__ZN2cv6String8allocateEj(i13, i47) | 0, i58 | 0, i47 | 0) | 0;
     }
     __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i44, i12, i13, HEAP32[i63 >> 2] | 0, i49);
     __ZN2cv6String10deallocateEv(i13);
     __ZN2cv6String10deallocateEv(i12);
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i44, 38280, 37992, 933);
     __ZN2cv6String10deallocateEv(i44);
     i6 = i7 + 4 | 0;
     i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
     i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
    }
    if (!(i6 & 1 | i7)) f5 = Math_fround(HEAPF32[i68 + (HEAP32[i63 + 4 >> 2] | 0) >> 2]); else {
     i7 = i68 + (i66 >> 1) | 0;
     if (i66 & 1) i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + i2 >> 2] | 0;
     f5 = Math_fround(FUNCTION_TABLE_fi[i2 & 0](i7));
    }
    if (i64) {
     HEAPF64[i69 >> 3] = +f5;
     STACKTOP = i70;
     return;
    }
    if (i65) {
     HEAPF32[i69 >> 2] = f5;
     STACKTOP = i70;
     return;
    } else {
     HEAP32[i50 >> 2] = 0;
     HEAP32[i50 + 4 >> 2] = 0;
     i9 = (__ZN2cv6String8allocateEj(i50, 19) | 0) + 0 | 0;
     i8 = 38288;
     i7 = i9 + 19 | 0;
     do {
      HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
      i9 = i9 + 1 | 0;
      i8 = i8 + 1 | 0;
     } while ((i9 | 0) < (i7 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i50, 38280, 37992, 942);
     __ZN2cv6String10deallocateEv(i50);
     STACKTOP = i70;
     return;
    }
   }
  case 9:
   {
    switch (i49 | 0) {
    case 0:
    case 2:
    case 7:
    case 8:
    case 9:
    case 11:
     {
      i8 = i66;
      i9 = i2;
      break;
     }
    default:
     {
      i47 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] & 127](i68) | 0) >> 2] | 0;
      i10 = HEAP32[i47 + 12 >> 2] | 0;
      HEAP32[i16 >> 2] = i10;
      HEAP32[i16 + 4 >> 2] = HEAP32[i47 + 16 >> 2];
      if (i10) {
       i47 = i10 + -4 | 0;
       HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
      }
      HEAP32[i17 >> 2] = 0;
      HEAP32[i17 + 4 >> 2] = 0;
      if (!i57) {
       i47 = _strlen(i58 | 0) | 0;
       _memcpy(__ZN2cv6String8allocateEj(i17, i47) | 0, i58 | 0, i47 | 0) | 0;
      }
      __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i46, i16, i17, HEAP32[i63 >> 2] | 0, i49);
      __ZN2cv6String10deallocateEv(i17);
      __ZN2cv6String10deallocateEv(i16);
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i46, 38280, 37992, 973);
      __ZN2cv6String10deallocateEv(i46);
      i8 = i7 + 4 | 0;
      i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
      i9 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
     }
    }
    if (!(i8 & 1 | i9)) {
     i6 = i68 + (HEAP32[i63 + 4 >> 2] | 0) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     i6 = HEAP32[i6 + 4 >> 2] | 0;
    } else {
     i9 = i68 + (i66 >> 1) | 0;
     if (i66 & 1) i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + i2 >> 2] | 0;
     i7 = FUNCTION_TABLE_ii[i2 & 127](i9) | 0;
     i6 = tempRet0;
    }
    if (i1) {
     HEAP32[i69 >> 2] = i7;
     STACKTOP = i70;
     return;
    }
    if (i64) {
     HEAPF64[i69 >> 3] = +(i7 >>> 0) + 4294967296.0 * +(i6 >>> 0);
     STACKTOP = i70;
     return;
    }
    if (i65) {
     HEAPF32[i69 >> 2] = Math_fround(+(i7 >>> 0) + 4294967296.0 * +(i6 >>> 0));
     STACKTOP = i70;
     return;
    }
    if (i59) {
     HEAP32[i69 >> 2] = i7;
     STACKTOP = i70;
     return;
    }
    if (i60) {
     i47 = i69;
     HEAP32[i47 >> 2] = i7;
     HEAP32[i47 + 4 >> 2] = i6;
     STACKTOP = i70;
     return;
    }
    if (i61) {
     HEAP8[i69 >> 0] = i7;
     STACKTOP = i70;
     return;
    } else {
     HEAP32[i56 >> 2] = 0;
     HEAP32[i56 + 4 >> 2] = 0;
     i9 = (__ZN2cv6String8allocateEj(i56, 19) | 0) + 0 | 0;
     i8 = 38288;
     i7 = i9 + 19 | 0;
     do {
      HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
      i9 = i9 + 1 | 0;
      i8 = i8 + 1 | 0;
     } while ((i9 | 0) < (i7 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i56, 38280, 37992, 990);
     __ZN2cv6String10deallocateEv(i56);
     STACKTOP = i70;
     return;
    }
   }
  case 11:
   {
    switch (i49 | 0) {
    case 0:
    case 2:
    case 7:
    case 8:
    case 9:
    case 11:
     {
      i9 = i2;
      i8 = i66;
      break;
     }
    default:
     {
      i47 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] & 127](i68) | 0) >> 2] | 0;
      i10 = HEAP32[i47 + 12 >> 2] | 0;
      HEAP32[i18 >> 2] = i10;
      HEAP32[i18 + 4 >> 2] = HEAP32[i47 + 16 >> 2];
      if (i10) {
       i47 = i10 + -4 | 0;
       HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
      }
      HEAP32[i20 >> 2] = 0;
      HEAP32[i20 + 4 >> 2] = 0;
      if (!i57) {
       i47 = _strlen(i58 | 0) | 0;
       _memcpy(__ZN2cv6String8allocateEj(i20, i47) | 0, i58 | 0, i47 | 0) | 0;
      }
      __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i37, i18, i20, HEAP32[i63 >> 2] | 0, i49);
      __ZN2cv6String10deallocateEv(i20);
      __ZN2cv6String10deallocateEv(i18);
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i37, 38280, 37992, 997);
      __ZN2cv6String10deallocateEv(i37);
      i8 = i7 + 4 | 0;
      i9 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
      i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
     }
    }
    if (!(i8 & 1 | i9)) i7 = HEAP8[i68 + (HEAP32[i63 + 4 >> 2] | 0) >> 0] | 0; else {
     i9 = i68 + (i66 >> 1) | 0;
     if (i66 & 1) i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + i2 >> 2] | 0;
     i7 = FUNCTION_TABLE_ii[i2 & 127](i9) | 0;
    }
    if (i1) {
     HEAP32[i69 >> 2] = i7 & 255;
     STACKTOP = i70;
     return;
    }
    if (i64) {
     HEAPF64[i69 >> 3] = +(i7 & 255);
     STACKTOP = i70;
     return;
    }
    if (i65) {
     HEAPF32[i69 >> 2] = Math_fround(i7 & 255);
     STACKTOP = i70;
     return;
    }
    if (i59) {
     HEAP32[i69 >> 2] = i7 & 255;
     STACKTOP = i70;
     return;
    }
    if (i60) {
     i47 = i69;
     HEAP32[i47 >> 2] = i7 & 255;
     HEAP32[i47 + 4 >> 2] = 0;
     STACKTOP = i70;
     return;
    }
    if (i61) {
     HEAP8[i69 >> 0] = i7;
     STACKTOP = i70;
     return;
    } else {
     HEAP32[i52 >> 2] = 0;
     HEAP32[i52 + 4 >> 2] = 0;
     i9 = (__ZN2cv6String8allocateEj(i52, 19) | 0) + 0 | 0;
     i8 = 38288;
     i7 = i9 + 19 | 0;
     do {
      HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
      i9 = i9 + 1 | 0;
      i8 = i8 + 1 | 0;
     } while ((i9 | 0) < (i7 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i52, 38280, 37992, 1014);
     __ZN2cv6String10deallocateEv(i52);
     STACKTOP = i70;
     return;
    }
   }
  case 1:
   {
    switch (i49 | 0) {
    case 0:
    case 1:
    case 2:
    case 7:
    case 8:
    case 9:
    case 11:
     {
      i9 = i2;
      i8 = i66;
      break;
     }
    default:
     {
      i47 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] & 127](i68) | 0) >> 2] | 0;
      i10 = HEAP32[i47 + 12 >> 2] | 0;
      HEAP32[i31 >> 2] = i10;
      HEAP32[i31 + 4 >> 2] = HEAP32[i47 + 16 >> 2];
      if (i10) {
       i47 = i10 + -4 | 0;
       HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
      }
      HEAP32[i32 >> 2] = 0;
      HEAP32[i32 + 4 >> 2] = 0;
      if (!i57) {
       i47 = _strlen(i58 | 0) | 0;
       _memcpy(__ZN2cv6String8allocateEj(i32, i47) | 0, i58 | 0, i47 | 0) | 0;
      }
      __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i36, i31, i32, HEAP32[i63 >> 2] | 0, i49);
      __ZN2cv6String10deallocateEv(i32);
      __ZN2cv6String10deallocateEv(i31);
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i36, 38280, 37992, 891);
      __ZN2cv6String10deallocateEv(i36);
      i8 = i7 + 4 | 0;
      i9 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
      i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
     }
    }
    if (!(i8 & 1 | i9)) i7 = (HEAP8[i68 + (HEAP32[i63 + 4 >> 2] | 0) >> 0] | 0) != 0; else {
     i9 = i68 + (i66 >> 1) | 0;
     if (i66 & 1) i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + i2 >> 2] | 0;
     i7 = FUNCTION_TABLE_ii[i2 & 127](i9) | 0;
    }
    if (i1) {
     HEAP32[i69 >> 2] = i7 & 1;
     STACKTOP = i70;
     return;
    }
    if (i3) {
     HEAP8[i69 >> 0] = i7 & 1;
     STACKTOP = i70;
     return;
    }
    if (i64) {
     HEAPF64[i69 >> 3] = +(i7 & 1 | 0);
     STACKTOP = i70;
     return;
    }
    if (i65) {
     HEAPF32[i69 >> 2] = Math_fround(i7 & 1 | 0);
     STACKTOP = i70;
     return;
    }
    if (i59) {
     HEAP32[i69 >> 2] = i7 & 1;
     STACKTOP = i70;
     return;
    }
    if (i60) {
     i47 = i69;
     HEAP32[i47 >> 2] = i7 & 1;
     HEAP32[i47 + 4 >> 2] = 0;
     STACKTOP = i70;
     return;
    }
    if (i61) {
     HEAP8[i69 >> 0] = i7 & 1;
     STACKTOP = i70;
     return;
    } else {
     HEAP32[i54 >> 2] = 0;
     HEAP32[i54 + 4 >> 2] = 0;
     i9 = (__ZN2cv6String8allocateEj(i54, 19) | 0) + 0 | 0;
     i8 = 38288;
     i7 = i9 + 19 | 0;
     do {
      HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
      i9 = i9 + 1 | 0;
      i8 = i8 + 1 | 0;
     } while ((i9 | 0) < (i7 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i54, 38280, 37992, 910);
     __ZN2cv6String10deallocateEv(i54);
     STACKTOP = i70;
     return;
    }
   }
  case 0:
   {
    switch (i49 | 0) {
    case 0:
    case 2:
    case 7:
    case 8:
    case 9:
    case 11:
     {
      i8 = i66;
      i9 = i2;
      break;
     }
    default:
     {
      i47 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] & 127](i68) | 0) >> 2] | 0;
      i10 = HEAP32[i47 + 12 >> 2] | 0;
      HEAP32[i11 >> 2] = i10;
      HEAP32[i11 + 4 >> 2] = HEAP32[i47 + 16 >> 2];
      if (i10) {
       i47 = i10 + -4 | 0;
       HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
      }
      HEAP32[i19 >> 2] = 0;
      HEAP32[i19 + 4 >> 2] = 0;
      if (!i57) {
       i47 = _strlen(i58 | 0) | 0;
       _memcpy(__ZN2cv6String8allocateEj(i19, i47) | 0, i58 | 0, i47 | 0) | 0;
      }
      __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i35, i11, i19, HEAP32[i63 >> 2] | 0, i49);
      __ZN2cv6String10deallocateEv(i19);
      __ZN2cv6String10deallocateEv(i11);
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i35, 38280, 37992, 866);
      __ZN2cv6String10deallocateEv(i35);
      i8 = i7 + 4 | 0;
      i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
      i9 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
     }
    }
    if (!(i8 & 1 | i9)) i7 = HEAP32[i68 + (HEAP32[i63 + 4 >> 2] | 0) >> 2] | 0; else {
     i9 = i68 + (i66 >> 1) | 0;
     if (i66 & 1) i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + i2 >> 2] | 0;
     i7 = FUNCTION_TABLE_ii[i2 & 127](i9) | 0;
    }
    if (i1) {
     HEAP32[i69 >> 2] = i7;
     STACKTOP = i70;
     return;
    }
    if (i64) {
     HEAPF64[i69 >> 3] = +(i7 | 0);
     STACKTOP = i70;
     return;
    }
    if (i65) {
     HEAPF32[i69 >> 2] = Math_fround(i7 | 0);
     STACKTOP = i70;
     return;
    }
    if (i59) {
     HEAP32[i69 >> 2] = i7;
     STACKTOP = i70;
     return;
    }
    if (i60) {
     i47 = i69;
     HEAP32[i47 >> 2] = i7;
     HEAP32[i47 + 4 >> 2] = ((i7 | 0) < 0) << 31 >> 31;
     STACKTOP = i70;
     return;
    }
    if (i61) {
     HEAP8[i69 >> 0] = i7;
     STACKTOP = i70;
     return;
    } else {
     HEAP32[i53 >> 2] = 0;
     HEAP32[i53 + 4 >> 2] = 0;
     i9 = (__ZN2cv6String8allocateEj(i53, 19) | 0) + 0 | 0;
     i8 = 38288;
     i7 = i9 + 19 | 0;
     do {
      HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
      i9 = i9 + 1 | 0;
      i8 = i8 + 1 | 0;
     } while ((i9 | 0) < (i7 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i53, 38280, 37992, 883);
     __ZN2cv6String10deallocateEv(i53);
     STACKTOP = i70;
     return;
    }
   }
  case 2:
   {
    if ((i49 | 0) == 2 | (i49 | 0) == 7) {
     i7 = i2;
     i6 = i66;
    } else {
     i47 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] & 127](i68) | 0) >> 2] | 0;
     i9 = HEAP32[i47 + 12 >> 2] | 0;
     HEAP32[i33 >> 2] = i9;
     HEAP32[i33 + 4 >> 2] = HEAP32[i47 + 16 >> 2];
     if (i9) {
      i47 = i9 + -4 | 0;
      HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
     }
     HEAP32[i34 >> 2] = 0;
     HEAP32[i34 + 4 >> 2] = 0;
     if (!i57) {
      i47 = _strlen(i58 | 0) | 0;
      _memcpy(__ZN2cv6String8allocateEj(i34, i47) | 0, i58 | 0, i47 | 0) | 0;
     }
     __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i43, i33, i34, HEAP32[i63 >> 2] | 0, i49);
     __ZN2cv6String10deallocateEv(i34);
     __ZN2cv6String10deallocateEv(i33);
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i43, 38280, 37992, 917);
     __ZN2cv6String10deallocateEv(i43);
     i6 = i7 + 4 | 0;
     i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
     i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
    }
    if (!(i6 & 1 | i7)) d4 = +HEAPF64[i68 + (HEAP32[i63 + 4 >> 2] | 0) >> 3]; else {
     i7 = i68 + (i66 >> 1) | 0;
     if (i66 & 1) i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + i2 >> 2] | 0;
     d4 = +FUNCTION_TABLE_di[i2 & 1](i7);
    }
    if (i64) {
     HEAPF64[i69 >> 3] = d4;
     STACKTOP = i70;
     return;
    }
    if (i65) {
     HEAPF32[i69 >> 2] = Math_fround(d4);
     STACKTOP = i70;
     return;
    } else {
     HEAP32[i55 >> 2] = 0;
     HEAP32[i55 + 4 >> 2] = 0;
     i9 = (__ZN2cv6String8allocateEj(i55, 19) | 0) + 0 | 0;
     i8 = 38288;
     i7 = i9 + 19 | 0;
     do {
      HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
      i9 = i9 + 1 | 0;
      i8 = i8 + 1 | 0;
     } while ((i9 | 0) < (i7 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i55, 38280, 37992, 926);
     __ZN2cv6String10deallocateEv(i55);
     STACKTOP = i70;
     return;
    }
   }
  case 8:
   {
    switch (i49 | 0) {
    case 0:
    case 2:
    case 7:
    case 8:
    case 9:
    case 11:
     {
      i9 = i2;
      i8 = i66;
      break;
     }
    default:
     {
      i47 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] & 127](i68) | 0) >> 2] | 0;
      i10 = HEAP32[i47 + 12 >> 2] | 0;
      HEAP32[i14 >> 2] = i10;
      HEAP32[i14 + 4 >> 2] = HEAP32[i47 + 16 >> 2];
      if (i10) {
       i47 = i10 + -4 | 0;
       HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
      }
      HEAP32[i15 >> 2] = 0;
      HEAP32[i15 + 4 >> 2] = 0;
      if (!i57) {
       i47 = _strlen(i58 | 0) | 0;
       _memcpy(__ZN2cv6String8allocateEj(i15, i47) | 0, i58 | 0, i47 | 0) | 0;
      }
      __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i45, i14, i15, HEAP32[i63 >> 2] | 0, i49);
      __ZN2cv6String10deallocateEv(i15);
      __ZN2cv6String10deallocateEv(i14);
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i45, 38280, 37992, 949);
      __ZN2cv6String10deallocateEv(i45);
      i8 = i7 + 4 | 0;
      i9 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
      i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
     }
    }
    if (!(i8 & 1 | i9)) i7 = HEAP32[i68 + (HEAP32[i63 + 4 >> 2] | 0) >> 2] | 0; else {
     i9 = i68 + (i66 >> 1) | 0;
     if (i66 & 1) i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + i2 >> 2] | 0;
     i7 = FUNCTION_TABLE_ii[i2 & 127](i9) | 0;
    }
    if (i1) {
     HEAP32[i69 >> 2] = i7;
     STACKTOP = i70;
     return;
    }
    if (i64) {
     HEAPF64[i69 >> 3] = +(i7 >>> 0);
     STACKTOP = i70;
     return;
    }
    if (i65) {
     HEAPF32[i69 >> 2] = Math_fround(i7 >>> 0);
     STACKTOP = i70;
     return;
    }
    if (i59) {
     HEAP32[i69 >> 2] = i7;
     STACKTOP = i70;
     return;
    }
    if (i60) {
     i47 = i69;
     HEAP32[i47 >> 2] = i7;
     HEAP32[i47 + 4 >> 2] = 0;
     STACKTOP = i70;
     return;
    }
    if (i61) {
     HEAP8[i69 >> 0] = i7;
     STACKTOP = i70;
     return;
    } else {
     HEAP32[i51 >> 2] = 0;
     HEAP32[i51 + 4 >> 2] = 0;
     i9 = (__ZN2cv6String8allocateEj(i51, 19) | 0) + 0 | 0;
     i8 = 38288;
     i7 = i9 + 19 | 0;
     do {
      HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
      i9 = i9 + 1 | 0;
      i8 = i8 + 1 | 0;
     } while ((i9 | 0) < (i7 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i51, 38280, 37992, 966);
     __ZN2cv6String10deallocateEv(i51);
     STACKTOP = i70;
     return;
    }
   }
  default:
   {
    HEAP32[i47 >> 2] = 0;
    HEAP32[i47 + 4 >> 2] = 0;
    i9 = (__ZN2cv6String8allocateEj(i47, 34) | 0) + 0 | 0;
    i8 = 38240;
    i7 = i9 + 34 | 0;
    do {
     HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
     i9 = i9 + 1 | 0;
     i8 = i8 + 1 | 0;
    } while ((i9 | 0) < (i7 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i47, 38280, 37992, 1018);
    __ZN2cv6String10deallocateEv(i47);
    STACKTOP = i70;
    return;
   }
  }
 case 6:
  {
   if ((HEAP32[i63 >> 2] | 0) == 6) {
    i7 = i2;
    i3 = i66;
   } else {
    i47 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] & 127](i68) | 0) >> 2] | 0;
    i9 = HEAP32[i47 + 12 >> 2] | 0;
    HEAP32[i27 >> 2] = i9;
    HEAP32[i27 + 4 >> 2] = HEAP32[i47 + 16 >> 2];
    if (i9) {
     i47 = i9 + -4 | 0;
     HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
    }
    HEAP32[i28 >> 2] = 0;
    HEAP32[i28 + 4 >> 2] = 0;
    if (!i57) {
     i47 = _strlen(i58 | 0) | 0;
     _memcpy(__ZN2cv6String8allocateEj(i28, i47) | 0, i58 | 0, i47 | 0) | 0;
    }
    __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i41, i27, i28, HEAP32[i63 >> 2] | 0, 6);
    __ZN2cv6String10deallocateEv(i28);
    __ZN2cv6String10deallocateEv(i27);
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i41, 38280, 37992, 1058);
    __ZN2cv6String10deallocateEv(i41);
    i3 = i7 + 4 | 0;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
   }
   if (!(i3 & 1 | i7)) {
    i47 = HEAP32[i63 + 4 >> 2] | 0;
    i3 = HEAP32[i68 + i47 >> 2] | 0;
    HEAP32[i6 >> 2] = i3;
    i2 = i6 + 4 | 0;
    HEAP32[i2 >> 2] = HEAP32[i68 + (i47 + 4) >> 2];
    if (!i3) i7 = i2; else {
     i7 = i3 + 4 | 0;
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     i7 = i2;
    }
   } else {
    i3 = i68 + (i66 >> 1) | 0;
    if (i66 & 1) i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + i2 >> 2] | 0;
    FUNCTION_TABLE_vii[i2 & 127](i6, i3);
    i7 = i6 + 4 | 0;
   }
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i3) {
    i47 = i3 + 4 | 0;
    HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
   }
   i1 = HEAP32[i69 >> 2] | 0;
   HEAP32[i69 >> 2] = i3;
   HEAP32[i69 + 4 >> 2] = i2;
   if ((i1 | 0) != 0 ? (i46 = i1 + 4 | 0, i47 = HEAP32[i46 >> 2] | 0, HEAP32[i46 >> 2] = i47 + -1, (i47 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) != 0 ? (i46 = i2 + 4 | 0, i47 = HEAP32[i46 >> 2] | 0, HEAP32[i46 >> 2] = i47 + -1, (i47 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] & 511](i2);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   STACKTOP = i70;
   return;
  }
 case 3:
  {
   if ((HEAP32[i63 >> 2] | 0) == 3) {
    i7 = i2;
    i6 = i66;
   } else {
    i47 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] & 127](i68) | 0) >> 2] | 0;
    i9 = HEAP32[i47 + 12 >> 2] | 0;
    HEAP32[i21 >> 2] = i9;
    HEAP32[i21 + 4 >> 2] = HEAP32[i47 + 16 >> 2];
    if (i9) {
     i47 = i9 + -4 | 0;
     HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
    }
    HEAP32[i22 >> 2] = 0;
    HEAP32[i22 + 4 >> 2] = 0;
    if (!i57) {
     i47 = _strlen(i58 | 0) | 0;
     _memcpy(__ZN2cv6String8allocateEj(i22, i47) | 0, i58 | 0, i47 | 0) | 0;
    }
    __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i38, i21, i22, HEAP32[i63 >> 2] | 0, 3);
    __ZN2cv6String10deallocateEv(i22);
    __ZN2cv6String10deallocateEv(i21);
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i38, 38280, 37992, 1025);
    __ZN2cv6String10deallocateEv(i38);
    i6 = i7 + 4 | 0;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
   }
   if (!(i6 & 1 | i7)) {
    i47 = HEAP32[i63 + 4 >> 2] | 0;
    i2 = HEAP32[i68 + i47 >> 2] | 0;
    HEAP32[i48 >> 2] = i2;
    HEAP32[i48 + 4 >> 2] = HEAP32[i68 + (i47 + 4) >> 2];
    if (i2) {
     i47 = i2 + -4 | 0;
     HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
    }
   } else {
    i3 = i68 + (i66 >> 1) | 0;
    if (i66 & 1) i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + i2 >> 2] | 0;
    FUNCTION_TABLE_vii[i2 & 127](i48, i3);
   }
   if ((i48 | 0) != (i69 | 0)) {
    __ZN2cv6String10deallocateEv(i69);
    i1 = HEAP32[i48 >> 2] | 0;
    if (!i1) i1 = 0; else {
     i1 = i1 + -4 | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     i1 = HEAP32[i48 >> 2] | 0;
    }
    HEAP32[i69 >> 2] = i1;
    HEAP32[i69 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
   }
   __ZN2cv6String10deallocateEv(i48);
   STACKTOP = i70;
   return;
  }
 default:
  {
   i47 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] & 127](i68) | 0) >> 2] | 0;
   i7 = HEAP32[i47 + 12 >> 2] | 0;
   HEAP32[i29 >> 2] = i7;
   HEAP32[i29 + 4 >> 2] = HEAP32[i47 + 16 >> 2];
   if (i7) {
    i47 = i7 + -4 | 0;
    HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
   }
   HEAP32[i30 >> 2] = 0;
   HEAP32[i30 + 4 >> 2] = 0;
   if (!i57) {
    i47 = _strlen(i58 | 0) | 0;
    _memcpy(__ZN2cv6String8allocateEj(i30, i47) | 0, i58 | 0, i47 | 0) | 0;
   }
   __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i42, i29, i30, HEAP32[i63 >> 2] | 0, i49);
   __ZN2cv6String10deallocateEv(i30);
   __ZN2cv6String10deallocateEv(i29);
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i42, 38280, 37992, 1067);
   __ZN2cv6String10deallocateEv(i42);
   STACKTOP = i70;
   return;
  }
 }
}

function _deflate(i41, i33) {
 i41 = i41 | 0;
 i33 = i33 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i42 = 0;
 i42 = STACKTOP;
 if (!i41) {
  i22 = -2;
  STACKTOP = i42;
  return i22 | 0;
 }
 i36 = i41 + 28 | 0;
 i37 = HEAP32[i36 >> 2] | 0;
 if ((i37 | 0) == 0 | (i33 | 0) > 5 | (i33 | 0) < 0) {
  i22 = -2;
  STACKTOP = i42;
  return i22 | 0;
 }
 i40 = i41 + 12 | 0;
 do if (HEAP32[i40 >> 2] | 0) {
  if ((HEAP32[i41 >> 2] | 0) == 0 ? (HEAP32[i41 + 4 >> 2] | 0) != 0 : 0) break;
  i32 = i37 + 4 | 0;
  i4 = HEAP32[i32 >> 2] | 0;
  i34 = (i33 | 0) != 4;
  if (!((i4 | 0) == 666 & i34)) {
   i39 = i41 + 16 | 0;
   if (!(HEAP32[i39 >> 2] | 0)) {
    HEAP32[i41 + 24 >> 2] = HEAP32[36703];
    i22 = -5;
    STACKTOP = i42;
    return i22 | 0;
   }
   HEAP32[i37 >> 2] = i41;
   i35 = i37 + 40 | 0;
   i23 = HEAP32[i35 >> 2] | 0;
   HEAP32[i35 >> 2] = i33;
   do if ((i4 | 0) == 42) {
    if ((HEAP32[i37 + 24 >> 2] | 0) != 2) {
     i4 = (HEAP32[i37 + 48 >> 2] << 12) + -30720 | 0;
     if ((HEAP32[i37 + 136 >> 2] | 0) <= 1 ? (i11 = HEAP32[i37 + 132 >> 2] | 0, (i11 | 0) >= 2) : 0) if ((i11 | 0) < 6) i5 = 64; else i5 = (i11 | 0) == 6 ? 128 : 192; else i5 = 0;
     i13 = i5 | i4;
     i14 = i37 + 108 | 0;
     i13 = (HEAP32[i14 >> 2] | 0) == 0 ? i13 : i13 | 32;
     HEAP32[i32 >> 2] = 113;
     i4 = i37 + 20 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i5 + 1;
     i3 = i37 + 8 | 0;
     HEAP8[(HEAP32[i3 >> 2] | 0) + i5 >> 0] = i13 >>> 8;
     i5 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i5 + 1;
     HEAP8[(HEAP32[i3 >> 2] | 0) + i5 >> 0] = (i13 | ((i13 >>> 0) % 31 | 0)) ^ 31;
     i5 = i41 + 48 | 0;
     if (HEAP32[i14 >> 2] | 0) {
      i14 = HEAP32[i5 >> 2] | 0;
      i13 = HEAP32[i4 >> 2] | 0;
      HEAP32[i4 >> 2] = i13 + 1;
      HEAP8[(HEAP32[i3 >> 2] | 0) + i13 >> 0] = i14 >>> 24;
      i13 = HEAP32[i4 >> 2] | 0;
      HEAP32[i4 >> 2] = i13 + 1;
      HEAP8[(HEAP32[i3 >> 2] | 0) + i13 >> 0] = i14 >>> 16;
      i13 = HEAP32[i5 >> 2] | 0;
      i14 = HEAP32[i4 >> 2] | 0;
      HEAP32[i4 >> 2] = i14 + 1;
      HEAP8[(HEAP32[i3 >> 2] | 0) + i14 >> 0] = i13 >>> 8;
      i14 = HEAP32[i4 >> 2] | 0;
      HEAP32[i4 >> 2] = i14 + 1;
      HEAP8[(HEAP32[i3 >> 2] | 0) + i14 >> 0] = i13;
     }
     HEAP32[i5 >> 2] = _adler32(0, 0, 0) | 0;
     i5 = HEAP32[i32 >> 2] | 0;
     i24 = 32;
     break;
    }
    i14 = i41 + 48 | 0;
    HEAP32[i14 >> 2] = _crc32(0, 0, 0) | 0;
    i1 = i37 + 20 | 0;
    i13 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i13 + 1;
    i2 = i37 + 8 | 0;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i13 >> 0] = 31;
    i13 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i13 + 1;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i13 >> 0] = -117;
    i13 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i13 + 1;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i13 >> 0] = 8;
    i13 = i37 + 28 | 0;
    i12 = HEAP32[i13 >> 2] | 0;
    if (!i12) {
     i4 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 0;
     i4 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 0;
     i4 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 0;
     i4 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 0;
     i4 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 0;
     i4 = HEAP32[i37 + 132 >> 2] | 0;
     if ((i4 | 0) != 9) if ((HEAP32[i37 + 136 >> 2] | 0) > 1) i4 = 4; else i4 = (i4 | 0) < 2 ? 4 : 0; else i4 = 2;
     i20 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i20 + 1;
     HEAP8[(HEAP32[i2 >> 2] | 0) + i20 >> 0] = i4;
     i20 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i20 + 1;
     HEAP8[(HEAP32[i2 >> 2] | 0) + i20 >> 0] = 3;
     HEAP32[i32 >> 2] = 113;
     break;
    }
    i12 = (((HEAP32[i12 + 44 >> 2] | 0) != 0 ? 2 : 0) | (HEAP32[i12 >> 2] | 0) != 0 | ((HEAP32[i12 + 16 >> 2] | 0) == 0 ? 0 : 4) | ((HEAP32[i12 + 28 >> 2] | 0) == 0 ? 0 : 8) | ((HEAP32[i12 + 36 >> 2] | 0) == 0 ? 0 : 16)) & 255;
    i11 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i11 + 1;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i11 >> 0] = i12;
    i11 = HEAP32[(HEAP32[i13 >> 2] | 0) + 4 >> 2] & 255;
    i12 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i12 + 1;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i12 >> 0] = i11;
    i12 = (HEAP32[(HEAP32[i13 >> 2] | 0) + 4 >> 2] | 0) >>> 8 & 255;
    i11 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i11 + 1;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i11 >> 0] = i12;
    i11 = (HEAP32[(HEAP32[i13 >> 2] | 0) + 4 >> 2] | 0) >>> 16 & 255;
    i12 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i12 + 1;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i12 >> 0] = i11;
    i12 = (HEAP32[(HEAP32[i13 >> 2] | 0) + 4 >> 2] | 0) >>> 24 & 255;
    i11 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i11 + 1;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i11 >> 0] = i12;
    i11 = HEAP32[i37 + 132 >> 2] | 0;
    if ((i11 | 0) != 9) if ((HEAP32[i37 + 136 >> 2] | 0) > 1) i11 = 4; else i11 = (i11 | 0) < 2 ? 4 : 0; else i11 = 2;
    i12 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i12 + 1;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i12 >> 0] = i11;
    i12 = HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] & 255;
    i11 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i11 + 1;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i11 >> 0] = i12;
    i11 = HEAP32[i13 >> 2] | 0;
    if (HEAP32[i11 + 16 >> 2] | 0) {
     i11 = HEAP32[i11 + 20 >> 2] & 255;
     i12 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i12 + 1;
     HEAP8[(HEAP32[i2 >> 2] | 0) + i12 >> 0] = i11;
     i12 = (HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0) >>> 8 & 255;
     i11 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i11 + 1;
     HEAP8[(HEAP32[i2 >> 2] | 0) + i11 >> 0] = i12;
     i11 = HEAP32[i13 >> 2] | 0;
    }
    if (HEAP32[i11 + 44 >> 2] | 0) HEAP32[i14 >> 2] = _crc32(HEAP32[i14 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
    HEAP32[i37 + 32 >> 2] = 0;
    HEAP32[i32 >> 2] = 69;
    i7 = i13;
    i24 = 34;
   } else {
    i5 = i4;
    i24 = 32;
   } while (0);
   if ((i24 | 0) == 32) if ((i5 | 0) == 69) {
    i7 = i37 + 28 | 0;
    i24 = 34;
   } else i24 = 55;
   do if ((i24 | 0) == 34) {
    i5 = HEAP32[i7 >> 2] | 0;
    if (!(HEAP32[i5 + 16 >> 2] | 0)) {
     HEAP32[i32 >> 2] = 73;
     i4 = i5;
     i24 = 57;
     break;
    }
    i6 = i37 + 20 | 0;
    i11 = HEAP32[i6 >> 2] | 0;
    i8 = i37 + 32 | 0;
    i14 = HEAP32[i8 >> 2] | 0;
    L55 : do if (i14 >>> 0 < (HEAP32[i5 + 20 >> 2] & 65535) >>> 0) {
     i1 = i37 + 12 | 0;
     i2 = i41 + 48 | 0;
     i3 = i37 + 8 | 0;
     i4 = i41 + 20 | 0;
     i13 = i11;
     while (1) {
      if ((i13 | 0) == (HEAP32[i1 >> 2] | 0)) {
       if ((HEAP32[i5 + 44 >> 2] | 0) != 0 & i13 >>> 0 > i11 >>> 0) HEAP32[i2 >> 2] = _crc32(HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) + i11 | 0, i13 - i11 | 0) | 0;
       i13 = HEAP32[i36 >> 2] | 0;
       __tr_flush_bits(i13);
       i12 = i13 + 20 | 0;
       i14 = HEAP32[i12 >> 2] | 0;
       i11 = HEAP32[i39 >> 2] | 0;
       i14 = i14 >>> 0 > i11 >>> 0 ? i11 : i14;
       if ((i14 | 0) != 0 ? (i20 = i13 + 16 | 0, _memcpy(HEAP32[i40 >> 2] | 0, HEAP32[i20 >> 2] | 0, i14 | 0) | 0, HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + i14, HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + i14, HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i14, HEAP32[i39 >> 2] = (HEAP32[i39 >> 2] | 0) - i14, i11 = HEAP32[i12 >> 2] | 0, HEAP32[i12 >> 2] = i11 - i14, (i11 | 0) == (i14 | 0)) : 0) HEAP32[i20 >> 2] = HEAP32[i13 + 8 >> 2];
       i11 = HEAP32[i6 >> 2] | 0;
       if ((i11 | 0) == (HEAP32[i1 >> 2] | 0)) break;
       i5 = HEAP32[i7 >> 2] | 0;
       i14 = HEAP32[i8 >> 2] | 0;
       i13 = i11;
      }
      i14 = HEAP8[(HEAP32[i5 + 16 >> 2] | 0) + i14 >> 0] | 0;
      HEAP32[i6 >> 2] = i13 + 1;
      HEAP8[(HEAP32[i3 >> 2] | 0) + i13 >> 0] = i14;
      i14 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
      HEAP32[i8 >> 2] = i14;
      i5 = HEAP32[i7 >> 2] | 0;
      if (i14 >>> 0 >= (HEAP32[i5 + 20 >> 2] & 65535) >>> 0) break L55;
      i13 = HEAP32[i6 >> 2] | 0;
     }
     i5 = HEAP32[i7 >> 2] | 0;
    } while (0);
    if ((HEAP32[i5 + 44 >> 2] | 0) != 0 ? (i19 = HEAP32[i6 >> 2] | 0, i19 >>> 0 > i11 >>> 0) : 0) {
     i5 = i41 + 48 | 0;
     HEAP32[i5 >> 2] = _crc32(HEAP32[i5 >> 2] | 0, (HEAP32[i37 + 8 >> 2] | 0) + i11 | 0, i19 - i11 | 0) | 0;
     i5 = HEAP32[i7 >> 2] | 0;
    }
    if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i5 + 20 >> 2] | 0)) {
     HEAP32[i8 >> 2] = 0;
     HEAP32[i32 >> 2] = 73;
     i4 = i5;
     i24 = 57;
     break;
    } else {
     i5 = HEAP32[i32 >> 2] | 0;
     i24 = 55;
     break;
    }
   } while (0);
   if ((i24 | 0) == 55) if ((i5 | 0) == 73) {
    i4 = HEAP32[i37 + 28 >> 2] | 0;
    i24 = 57;
   } else i24 = 75;
   do if ((i24 | 0) == 57) {
    i5 = i37 + 28 | 0;
    if (!(HEAP32[i4 + 28 >> 2] | 0)) {
     HEAP32[i32 >> 2] = 91;
     i24 = 77;
     break;
    }
    i3 = i37 + 20 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    i13 = i37 + 12 | 0;
    i4 = i41 + 48 | 0;
    i6 = i37 + 8 | 0;
    i2 = i41 + 20 | 0;
    i7 = i37 + 32 | 0;
    i12 = i1;
    while (1) {
     if ((i12 | 0) == (HEAP32[i13 >> 2] | 0)) {
      if (i12 >>> 0 > i1 >>> 0 ? (HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) HEAP32[i4 >> 2] = _crc32(HEAP32[i4 >> 2] | 0, (HEAP32[i6 >> 2] | 0) + i1 | 0, i12 - i1 | 0) | 0;
      i11 = HEAP32[i36 >> 2] | 0;
      __tr_flush_bits(i11);
      i1 = i11 + 20 | 0;
      i12 = HEAP32[i1 >> 2] | 0;
      i20 = HEAP32[i39 >> 2] | 0;
      i12 = i12 >>> 0 > i20 >>> 0 ? i20 : i12;
      if ((i12 | 0) != 0 ? (i18 = i11 + 16 | 0, _memcpy(HEAP32[i40 >> 2] | 0, HEAP32[i18 >> 2] | 0, i12 | 0) | 0, HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + i12, HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + i12, HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i12, HEAP32[i39 >> 2] = (HEAP32[i39 >> 2] | 0) - i12, i20 = HEAP32[i1 >> 2] | 0, HEAP32[i1 >> 2] = i20 - i12, (i20 | 0) == (i12 | 0)) : 0) HEAP32[i18 >> 2] = HEAP32[i11 + 8 >> 2];
      i1 = HEAP32[i3 >> 2] | 0;
      if ((i1 | 0) == (HEAP32[i13 >> 2] | 0)) {
       i11 = 1;
       break;
      } else i12 = i1;
     }
     i14 = HEAP32[i7 >> 2] | 0;
     HEAP32[i7 >> 2] = i14 + 1;
     i14 = HEAP8[(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0) + i14 >> 0] | 0;
     HEAP32[i3 >> 2] = i12 + 1;
     HEAP8[(HEAP32[i6 >> 2] | 0) + i12 >> 0] = i14;
     if (!(i14 << 24 >> 24)) {
      i11 = i14 & 255;
      break;
     }
     i12 = HEAP32[i3 >> 2] | 0;
    }
    if ((HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0) != 0 ? (i17 = HEAP32[i3 >> 2] | 0, i17 >>> 0 > i1 >>> 0) : 0) HEAP32[i4 >> 2] = _crc32(HEAP32[i4 >> 2] | 0, (HEAP32[i6 >> 2] | 0) + i1 | 0, i17 - i1 | 0) | 0;
    if (!i11) {
     HEAP32[i7 >> 2] = 0;
     HEAP32[i32 >> 2] = 91;
     i24 = 77;
     break;
    } else {
     i5 = HEAP32[i32 >> 2] | 0;
     i24 = 75;
     break;
    }
   } while (0);
   if ((i24 | 0) == 75) if ((i5 | 0) == 91) {
    i5 = i37 + 28 | 0;
    i24 = 77;
   } else i24 = 95;
   do if ((i24 | 0) == 77) {
    if (!(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0)) {
     HEAP32[i32 >> 2] = 103;
     i24 = 97;
     break;
    }
    i6 = i37 + 20 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    i14 = i37 + 12 | 0;
    i7 = i41 + 48 | 0;
    i8 = i37 + 8 | 0;
    i13 = i41 + 20 | 0;
    i4 = i37 + 32 | 0;
    i11 = i3;
    while (1) {
     if ((i11 | 0) == (HEAP32[i14 >> 2] | 0)) {
      if (i11 >>> 0 > i3 >>> 0 ? (HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) HEAP32[i7 >> 2] = _crc32(HEAP32[i7 >> 2] | 0, (HEAP32[i8 >> 2] | 0) + i3 | 0, i11 - i3 | 0) | 0;
      i1 = HEAP32[i36 >> 2] | 0;
      __tr_flush_bits(i1);
      i2 = i1 + 20 | 0;
      i11 = HEAP32[i2 >> 2] | 0;
      i20 = HEAP32[i39 >> 2] | 0;
      i11 = i11 >>> 0 > i20 >>> 0 ? i20 : i11;
      if ((i11 | 0) != 0 ? (i16 = i1 + 16 | 0, _memcpy(HEAP32[i40 >> 2] | 0, HEAP32[i16 >> 2] | 0, i11 | 0) | 0, HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + i11, HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + i11, HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i11, HEAP32[i39 >> 2] = (HEAP32[i39 >> 2] | 0) - i11, i20 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i20 - i11, (i20 | 0) == (i11 | 0)) : 0) HEAP32[i16 >> 2] = HEAP32[i1 + 8 >> 2];
      i3 = HEAP32[i6 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i14 >> 2] | 0)) {
       i4 = 1;
       break;
      } else i11 = i3;
     }
     i12 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i12 + 1;
     i12 = HEAP8[(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0) + i12 >> 0] | 0;
     HEAP32[i6 >> 2] = i11 + 1;
     HEAP8[(HEAP32[i8 >> 2] | 0) + i11 >> 0] = i12;
     if (!(i12 << 24 >> 24)) {
      i4 = i12 & 255;
      break;
     }
     i11 = HEAP32[i6 >> 2] | 0;
    }
    if ((HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0) != 0 ? (i15 = HEAP32[i6 >> 2] | 0, i15 >>> 0 > i3 >>> 0) : 0) HEAP32[i7 >> 2] = _crc32(HEAP32[i7 >> 2] | 0, (HEAP32[i8 >> 2] | 0) + i3 | 0, i15 - i3 | 0) | 0;
    if (!i4) {
     HEAP32[i32 >> 2] = 103;
     i24 = 97;
     break;
    } else {
     i5 = HEAP32[i32 >> 2] | 0;
     i24 = 95;
     break;
    }
   } while (0);
   if ((i24 | 0) == 95 ? (i5 | 0) == 103 : 0) {
    i5 = i37 + 28 | 0;
    i24 = 97;
   }
   do if ((i24 | 0) == 97) {
    if (!(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0)) {
     HEAP32[i32 >> 2] = 113;
     break;
    }
    i4 = i37 + 20 | 0;
    i3 = i37 + 12 | 0;
    if ((((HEAP32[i4 >> 2] | 0) + 2 | 0) >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0 ? (i10 = HEAP32[i36 >> 2] | 0, __tr_flush_bits(i10), i21 = i10 + 20 | 0, i9 = HEAP32[i21 >> 2] | 0, i20 = HEAP32[i39 >> 2] | 0, i9 = i9 >>> 0 > i20 >>> 0 ? i20 : i9, (i9 | 0) != 0) : 0) ? (i22 = i10 + 16 | 0, _memcpy(HEAP32[i40 >> 2] | 0, HEAP32[i22 >> 2] | 0, i9 | 0) | 0, HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + i9, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i9, i20 = i41 + 20 | 0, HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + i9, HEAP32[i39 >> 2] = (HEAP32[i39 >> 2] | 0) - i9, i20 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i20 - i9, (i20 | 0) == (i9 | 0)) : 0) HEAP32[i22 >> 2] = HEAP32[i10 + 8 >> 2];
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i5 + 2 | 0) >>> 0 <= (HEAP32[i3 >> 2] | 0) >>> 0) {
     i22 = i41 + 48 | 0;
     i19 = HEAP32[i22 >> 2] & 255;
     HEAP32[i4 >> 2] = i5 + 1;
     i20 = i37 + 8 | 0;
     HEAP8[(HEAP32[i20 >> 2] | 0) + i5 >> 0] = i19;
     i19 = (HEAP32[i22 >> 2] | 0) >>> 8 & 255;
     i21 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i21 + 1;
     HEAP8[(HEAP32[i20 >> 2] | 0) + i21 >> 0] = i19;
     HEAP32[i22 >> 2] = _crc32(0, 0, 0) | 0;
     HEAP32[i32 >> 2] = 113;
    }
   } while (0);
   i21 = i37 + 20 | 0;
   if (!(HEAP32[i21 >> 2] | 0)) {
    if ((HEAP32[i41 + 4 >> 2] | 0) == 0 ? ((i33 << 1) - ((i33 | 0) > 4 ? 9 : 0) | 0) <= ((i23 << 1) - ((i23 | 0) > 4 ? 9 : 0) | 0) & i34 : 0) {
     HEAP32[i41 + 24 >> 2] = HEAP32[36703];
     i22 = -5;
     STACKTOP = i42;
     return i22 | 0;
    }
   } else {
    i2 = HEAP32[i36 >> 2] | 0;
    __tr_flush_bits(i2);
    i1 = i2 + 20 | 0;
    i3 = HEAP32[i1 >> 2] | 0;
    i5 = HEAP32[i39 >> 2] | 0;
    i3 = i3 >>> 0 > i5 >>> 0 ? i5 : i3;
    if (i3) {
     i4 = i2 + 16 | 0;
     _memcpy(HEAP32[i40 >> 2] | 0, HEAP32[i4 >> 2] | 0, i3 | 0) | 0;
     HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + i3;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i3;
     i5 = i41 + 20 | 0;
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i3;
     i5 = (HEAP32[i39 >> 2] | 0) - i3 | 0;
     HEAP32[i39 >> 2] = i5;
     i22 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i22 - i3;
     if ((i22 | 0) == (i3 | 0)) HEAP32[i4 >> 2] = HEAP32[i2 + 8 >> 2];
    }
    if (!i5) {
     HEAP32[i35 >> 2] = -1;
     i22 = 0;
     STACKTOP = i42;
     return i22 | 0;
    }
   }
   i4 = (HEAP32[i32 >> 2] | 0) == 666;
   i5 = (HEAP32[i41 + 4 >> 2] | 0) == 0;
   if (i4) if (i5) i24 = 118; else {
    HEAP32[i41 + 24 >> 2] = HEAP32[36703];
    i22 = -5;
    STACKTOP = i42;
    return i22 | 0;
   } else if (i5) i24 = 118; else i24 = 119;
   if ((i24 | 0) == 118 ? !((HEAP32[i37 + 116 >> 2] | 0) == 0 & ((i33 | 0) == 0 | i4)) : 0) i24 = 119;
   do if ((i24 | 0) == 119) {
    i5 = HEAP32[i37 + 136 >> 2] | 0;
    L175 : do if ((i5 | 0) == 3) {
     i6 = i37 + 116 | 0;
     i7 = (i33 | 0) == 0;
     i8 = i37 + 96 | 0;
     i19 = i37 + 108 | 0;
     i9 = i37 + 5792 | 0;
     i10 = i37 + 5796 | 0;
     i15 = i37 + 5784 | 0;
     i16 = i37 + (HEAPU8[155136] << 2) + 2440 | 0;
     i17 = i37 + 5788 | 0;
     i18 = i37 + 56 | 0;
     i20 = i37 + 92 | 0;
     while (1) {
      i5 = HEAP32[i6 >> 2] | 0;
      if (i5 >>> 0 < 259) {
       _fill_window(i37);
       i5 = HEAP32[i6 >> 2] | 0;
       if (i5 >>> 0 < 259 & i7) {
        i24 = 193;
        break L175;
       }
       if (!i5) break;
       HEAP32[i8 >> 2] = 0;
       if (i5 >>> 0 > 2) i24 = 152; else {
        i5 = HEAP32[i19 >> 2] | 0;
        i24 = 167;
       }
      } else {
       HEAP32[i8 >> 2] = 0;
       i24 = 152;
      }
      if ((i24 | 0) == 152) {
       i24 = 0;
       i11 = HEAP32[i19 >> 2] | 0;
       if (i11) {
        i4 = HEAP32[i18 >> 2] | 0;
        i13 = HEAP8[i4 + (i11 + -1) >> 0] | 0;
        if ((i13 << 24 >> 24 == (HEAP8[i4 + i11 >> 0] | 0) ? i13 << 24 >> 24 == (HEAP8[i4 + (i11 + 1) >> 0] | 0) : 0) ? (i28 = i4 + (i11 + 2) | 0, i13 << 24 >> 24 == (HEAP8[i28 >> 0] | 0)) : 0) {
         i12 = i4 + (i11 + 258) | 0;
         i14 = i28;
         while (1) {
          i4 = i14 + 1 | 0;
          if (i13 << 24 >> 24 != (HEAP8[i4 >> 0] | 0)) break;
          i4 = i14 + 2 | 0;
          if (i13 << 24 >> 24 != (HEAP8[i4 >> 0] | 0)) break;
          i4 = i14 + 3 | 0;
          if (i13 << 24 >> 24 != (HEAP8[i4 >> 0] | 0)) break;
          i4 = i14 + 4 | 0;
          if (i13 << 24 >> 24 != (HEAP8[i4 >> 0] | 0)) break;
          i4 = i14 + 5 | 0;
          if (i13 << 24 >> 24 != (HEAP8[i4 >> 0] | 0)) break;
          i4 = i14 + 6 | 0;
          if (i13 << 24 >> 24 != (HEAP8[i4 >> 0] | 0)) break;
          i4 = i14 + 7 | 0;
          if (i13 << 24 >> 24 != (HEAP8[i4 >> 0] | 0)) break;
          i4 = i14 + 8 | 0;
          if (i4 >>> 0 < i12 >>> 0 ? i13 << 24 >> 24 == (HEAP8[i4 >> 0] | 0) : 0) i14 = i4; else break;
         }
         i22 = i4 - i12 + 258 | 0;
         i5 = i22 >>> 0 > i5 >>> 0 ? i5 : i22;
         HEAP32[i8 >> 2] = i5;
         if (i5 >>> 0 > 2) {
          i5 = i5 + 253 | 0;
          i3 = HEAP32[i9 >> 2] | 0;
          HEAP16[(HEAP32[i10 >> 2] | 0) + (i3 << 1) >> 1] = 1;
          HEAP32[i9 >> 2] = i3 + 1;
          HEAP8[(HEAP32[i15 >> 2] | 0) + i3 >> 0] = i5;
          i5 = i37 + ((HEAPU8[155648 + (i5 & 255) >> 0] | 256) + 1 << 2) + 148 | 0;
          HEAP16[i5 >> 1] = (HEAP16[i5 >> 1] | 0) + 1 << 16 >> 16;
          HEAP16[i16 >> 1] = (HEAP16[i16 >> 1] | 0) + 1 << 16 >> 16;
          i5 = (HEAP32[i9 >> 2] | 0) == ((HEAP32[i17 >> 2] | 0) + -1 | 0) & 1;
          i3 = HEAP32[i8 >> 2] | 0;
          HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - i3;
          i3 = (HEAP32[i19 >> 2] | 0) + i3 | 0;
          HEAP32[i19 >> 2] = i3;
          HEAP32[i8 >> 2] = 0;
         } else {
          i5 = i11;
          i24 = 167;
         }
        } else {
         i5 = i11;
         i24 = 167;
        }
       } else {
        i5 = 0;
        i24 = 167;
       }
      }
      if ((i24 | 0) == 167) {
       i24 = 0;
       i5 = HEAP8[(HEAP32[i18 >> 2] | 0) + i5 >> 0] | 0;
       i3 = HEAP32[i9 >> 2] | 0;
       HEAP16[(HEAP32[i10 >> 2] | 0) + (i3 << 1) >> 1] = 0;
       HEAP32[i9 >> 2] = i3 + 1;
       HEAP8[(HEAP32[i15 >> 2] | 0) + i3 >> 0] = i5;
       i5 = i37 + ((i5 & 255) << 2) + 148 | 0;
       HEAP16[i5 >> 1] = (HEAP16[i5 >> 1] | 0) + 1 << 16 >> 16;
       i5 = (HEAP32[i9 >> 2] | 0) == ((HEAP32[i17 >> 2] | 0) + -1 | 0) & 1;
       HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
       i3 = (HEAP32[i19 >> 2] | 0) + 1 | 0;
       HEAP32[i19 >> 2] = i3;
      }
      if (!i5) continue;
      i5 = HEAP32[i20 >> 2] | 0;
      if ((i5 | 0) > -1) i4 = (HEAP32[i18 >> 2] | 0) + i5 | 0; else i4 = 0;
      __tr_flush_block(i37, i4, i3 - i5 | 0, 0);
      HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
      i11 = HEAP32[i37 >> 2] | 0;
      i1 = HEAP32[i11 + 28 >> 2] | 0;
      __tr_flush_bits(i1);
      i2 = i1 + 20 | 0;
      i5 = HEAP32[i2 >> 2] | 0;
      i3 = i11 + 16 | 0;
      i22 = HEAP32[i3 >> 2] | 0;
      i5 = i5 >>> 0 > i22 >>> 0 ? i22 : i5;
      if ((i5 | 0) != 0 ? (i22 = i11 + 12 | 0, i29 = i1 + 16 | 0, _memcpy(HEAP32[i22 >> 2] | 0, HEAP32[i29 >> 2] | 0, i5 | 0) | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, HEAP32[i29 >> 2] = (HEAP32[i29 >> 2] | 0) + i5, i22 = i11 + 20 | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) - i5, i22 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i22 - i5, (i22 | 0) == (i5 | 0)) : 0) HEAP32[i29 >> 2] = HEAP32[i1 + 8 >> 2];
      if (!(HEAP32[(HEAP32[i37 >> 2] | 0) + 16 >> 2] | 0)) {
       i24 = 193;
       break L175;
      }
     }
     HEAP32[i37 + 5812 >> 2] = 0;
     if ((i33 | 0) == 4) {
      i4 = HEAP32[i20 >> 2] | 0;
      if ((i4 | 0) > -1) i5 = (HEAP32[i18 >> 2] | 0) + i4 | 0; else i5 = 0;
      __tr_flush_block(i37, i5, (HEAP32[i19 >> 2] | 0) - i4 | 0, 1);
      HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
      i4 = HEAP32[i37 >> 2] | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      __tr_flush_bits(i3);
      i2 = i3 + 20 | 0;
      i5 = HEAP32[i2 >> 2] | 0;
      i1 = i4 + 16 | 0;
      i22 = HEAP32[i1 >> 2] | 0;
      i5 = i5 >>> 0 > i22 >>> 0 ? i22 : i5;
      if ((i5 | 0) != 0 ? (i22 = i4 + 12 | 0, i30 = i3 + 16 | 0, _memcpy(HEAP32[i22 >> 2] | 0, HEAP32[i30 >> 2] | 0, i5 | 0) | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + i5, i22 = i4 + 20 | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - i5, i22 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i22 - i5, (i22 | 0) == (i5 | 0)) : 0) HEAP32[i30 >> 2] = HEAP32[i3 + 8 >> 2];
      i3 = (HEAP32[(HEAP32[i37 >> 2] | 0) + 16 >> 2] | 0) == 0 ? 2 : 3;
      i24 = 190;
      break;
     }
     if (HEAP32[i9 >> 2] | 0) {
      i4 = HEAP32[i20 >> 2] | 0;
      if ((i4 | 0) > -1) i5 = (HEAP32[i18 >> 2] | 0) + i4 | 0; else i5 = 0;
      __tr_flush_block(i37, i5, (HEAP32[i19 >> 2] | 0) - i4 | 0, 0);
      HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
      i4 = HEAP32[i37 >> 2] | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      __tr_flush_bits(i3);
      i2 = i3 + 20 | 0;
      i5 = HEAP32[i2 >> 2] | 0;
      i1 = i4 + 16 | 0;
      i22 = HEAP32[i1 >> 2] | 0;
      i5 = i5 >>> 0 > i22 >>> 0 ? i22 : i5;
      if ((i5 | 0) != 0 ? (i22 = i4 + 12 | 0, i31 = i3 + 16 | 0, _memcpy(HEAP32[i22 >> 2] | 0, HEAP32[i31 >> 2] | 0, i5 | 0) | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + i5, i22 = i4 + 20 | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - i5, i22 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i22 - i5, (i22 | 0) == (i5 | 0)) : 0) HEAP32[i31 >> 2] = HEAP32[i3 + 8 >> 2];
      if (!(HEAP32[(HEAP32[i37 >> 2] | 0) + 16 >> 2] | 0)) i24 = 193;
     }
    } else if ((i5 | 0) == 2) {
     i6 = i37 + 116 | 0;
     i7 = i37 + 96 | 0;
     i13 = i37 + 108 | 0;
     i12 = i37 + 56 | 0;
     i8 = i37 + 5792 | 0;
     i9 = i37 + 5796 | 0;
     i10 = i37 + 5784 | 0;
     i11 = i37 + 5788 | 0;
     i14 = i37 + 92 | 0;
     while (1) {
      if ((HEAP32[i6 >> 2] | 0) == 0 ? (_fill_window(i37), (HEAP32[i6 >> 2] | 0) == 0) : 0) break;
      HEAP32[i7 >> 2] = 0;
      i22 = HEAP8[(HEAP32[i12 >> 2] | 0) + (HEAP32[i13 >> 2] | 0) >> 0] | 0;
      i5 = HEAP32[i8 >> 2] | 0;
      HEAP16[(HEAP32[i9 >> 2] | 0) + (i5 << 1) >> 1] = 0;
      HEAP32[i8 >> 2] = i5 + 1;
      HEAP8[(HEAP32[i10 >> 2] | 0) + i5 >> 0] = i22;
      i22 = i37 + ((i22 & 255) << 2) + 148 | 0;
      HEAP16[i22 >> 1] = (HEAP16[i22 >> 1] | 0) + 1 << 16 >> 16;
      i22 = (HEAP32[i8 >> 2] | 0) == ((HEAP32[i11 >> 2] | 0) + -1 | 0);
      HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
      i5 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
      HEAP32[i13 >> 2] = i5;
      if (!i22) continue;
      i4 = HEAP32[i14 >> 2] | 0;
      if ((i4 | 0) > -1) i3 = (HEAP32[i12 >> 2] | 0) + i4 | 0; else i3 = 0;
      __tr_flush_block(i37, i3, i5 - i4 | 0, 0);
      HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
      i4 = HEAP32[i37 >> 2] | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      __tr_flush_bits(i3);
      i2 = i3 + 20 | 0;
      i5 = HEAP32[i2 >> 2] | 0;
      i1 = i4 + 16 | 0;
      i22 = HEAP32[i1 >> 2] | 0;
      i5 = i5 >>> 0 > i22 >>> 0 ? i22 : i5;
      if ((i5 | 0) != 0 ? (i22 = i4 + 12 | 0, i25 = i3 + 16 | 0, _memcpy(HEAP32[i22 >> 2] | 0, HEAP32[i25 >> 2] | 0, i5 | 0) | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + i5, i22 = i4 + 20 | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - i5, i22 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i22 - i5, (i22 | 0) == (i5 | 0)) : 0) HEAP32[i25 >> 2] = HEAP32[i3 + 8 >> 2];
      if (!(HEAP32[(HEAP32[i37 >> 2] | 0) + 16 >> 2] | 0)) {
       i24 = 193;
       break L175;
      }
     }
     if (i33) {
      HEAP32[i37 + 5812 >> 2] = 0;
      if ((i33 | 0) == 4) {
       i4 = HEAP32[i14 >> 2] | 0;
       if ((i4 | 0) > -1) i5 = (HEAP32[i12 >> 2] | 0) + i4 | 0; else i5 = 0;
       __tr_flush_block(i37, i5, (HEAP32[i13 >> 2] | 0) - i4 | 0, 1);
       HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
       i4 = HEAP32[i37 >> 2] | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       __tr_flush_bits(i3);
       i2 = i3 + 20 | 0;
       i5 = HEAP32[i2 >> 2] | 0;
       i1 = i4 + 16 | 0;
       i22 = HEAP32[i1 >> 2] | 0;
       i5 = i5 >>> 0 > i22 >>> 0 ? i22 : i5;
       if ((i5 | 0) != 0 ? (i22 = i4 + 12 | 0, i26 = i3 + 16 | 0, _memcpy(HEAP32[i22 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0) | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + i5, i22 = i4 + 20 | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - i5, i22 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i22 - i5, (i22 | 0) == (i5 | 0)) : 0) HEAP32[i26 >> 2] = HEAP32[i3 + 8 >> 2];
       i3 = (HEAP32[(HEAP32[i37 >> 2] | 0) + 16 >> 2] | 0) == 0 ? 2 : 3;
       i24 = 190;
       break;
      }
      if (HEAP32[i8 >> 2] | 0) {
       i4 = HEAP32[i14 >> 2] | 0;
       if ((i4 | 0) > -1) i5 = (HEAP32[i12 >> 2] | 0) + i4 | 0; else i5 = 0;
       __tr_flush_block(i37, i5, (HEAP32[i13 >> 2] | 0) - i4 | 0, 0);
       HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
       i4 = HEAP32[i37 >> 2] | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       __tr_flush_bits(i3);
       i2 = i3 + 20 | 0;
       i5 = HEAP32[i2 >> 2] | 0;
       i1 = i4 + 16 | 0;
       i22 = HEAP32[i1 >> 2] | 0;
       i5 = i5 >>> 0 > i22 >>> 0 ? i22 : i5;
       if ((i5 | 0) != 0 ? (i22 = i4 + 12 | 0, i27 = i3 + 16 | 0, _memcpy(HEAP32[i22 >> 2] | 0, HEAP32[i27 >> 2] | 0, i5 | 0) | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, HEAP32[i27 >> 2] = (HEAP32[i27 >> 2] | 0) + i5, i22 = i4 + 20 | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - i5, i22 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i22 - i5, (i22 | 0) == (i5 | 0)) : 0) HEAP32[i27 >> 2] = HEAP32[i3 + 8 >> 2];
       if (!(HEAP32[(HEAP32[i37 >> 2] | 0) + 16 >> 2] | 0)) i24 = 193;
      }
     } else i24 = 193;
    } else {
     i3 = FUNCTION_TABLE_iii[HEAP32[155016 + ((HEAP32[i37 + 132 >> 2] | 0) * 12 | 0) + 8 >> 2] & 127](i37, i33) | 0;
     i24 = 190;
    } while (0);
    if ((i24 | 0) == 190) {
     if ((i3 & -2 | 0) == 2) HEAP32[i32 >> 2] = 666;
     if (i3 & -3) {
      if ((i3 | 0) != 1) break;
     } else i24 = 193;
    }
    if ((i24 | 0) == 193) {
     if (HEAP32[i39 >> 2] | 0) {
      i22 = 0;
      STACKTOP = i42;
      return i22 | 0;
     }
     HEAP32[i35 >> 2] = -1;
     i22 = 0;
     STACKTOP = i42;
     return i22 | 0;
    }
    if ((i33 | 0) == 1) __tr_align(i37); else if (((i33 | 0) != 5 ? (__tr_stored_block(i37, 0, 0, 0), (i33 | 0) == 3) : 0) ? (i22 = HEAP32[i37 + 76 >> 2] | 0, i20 = HEAP32[i37 + 68 >> 2] | 0, HEAP16[i20 + (i22 + -1 << 1) >> 1] = 0, _memset(i20 | 0, 0, (i22 << 1) + -2 | 0) | 0, (HEAP32[i37 + 116 >> 2] | 0) == 0) : 0) {
     HEAP32[i37 + 108 >> 2] = 0;
     HEAP32[i37 + 92 >> 2] = 0;
     HEAP32[i37 + 5812 >> 2] = 0;
    }
    i4 = HEAP32[i36 >> 2] | 0;
    __tr_flush_bits(i4);
    i5 = i4 + 20 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i39 >> 2] | 0;
    i1 = i1 >>> 0 > i3 >>> 0 ? i3 : i1;
    if (i1) {
     i2 = i4 + 16 | 0;
     _memcpy(HEAP32[i40 >> 2] | 0, HEAP32[i2 >> 2] | 0, i1 | 0) | 0;
     HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + i1;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i1;
     i3 = i41 + 20 | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i1;
     i3 = (HEAP32[i39 >> 2] | 0) - i1 | 0;
     HEAP32[i39 >> 2] = i3;
     i22 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = i22 - i1;
     if ((i22 | 0) == (i1 | 0)) HEAP32[i2 >> 2] = HEAP32[i4 + 8 >> 2];
    }
    if (!i3) {
     HEAP32[i35 >> 2] = -1;
     i22 = 0;
     STACKTOP = i42;
     return i22 | 0;
    }
   } while (0);
   if (i34) {
    i22 = 0;
    STACKTOP = i42;
    return i22 | 0;
   }
   i5 = i37 + 24 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if ((i3 | 0) < 1) {
    i22 = 1;
    STACKTOP = i42;
    return i22 | 0;
   }
   i2 = i41 + 48 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == 2) {
    i18 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i18 + 1;
    i20 = i37 + 8 | 0;
    HEAP8[(HEAP32[i20 >> 2] | 0) + i18 >> 0] = i1;
    i18 = (HEAP32[i2 >> 2] | 0) >>> 8 & 255;
    i19 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i19 + 1;
    HEAP8[(HEAP32[i20 >> 2] | 0) + i19 >> 0] = i18;
    i19 = (HEAP32[i2 >> 2] | 0) >>> 16 & 255;
    i18 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i18 + 1;
    HEAP8[(HEAP32[i20 >> 2] | 0) + i18 >> 0] = i19;
    i18 = (HEAP32[i2 >> 2] | 0) >>> 24 & 255;
    i19 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i19 + 1;
    HEAP8[(HEAP32[i20 >> 2] | 0) + i19 >> 0] = i18;
    i19 = i41 + 8 | 0;
    i18 = HEAP32[i19 >> 2] & 255;
    i22 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i22 + 1;
    HEAP8[(HEAP32[i20 >> 2] | 0) + i22 >> 0] = i18;
    i22 = (HEAP32[i19 >> 2] | 0) >>> 8 & 255;
    i18 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i18 + 1;
    HEAP8[(HEAP32[i20 >> 2] | 0) + i18 >> 0] = i22;
    i18 = (HEAP32[i19 >> 2] | 0) >>> 16 & 255;
    i22 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i22 + 1;
    HEAP8[(HEAP32[i20 >> 2] | 0) + i22 >> 0] = i18;
    i19 = (HEAP32[i19 >> 2] | 0) >>> 24 & 255;
    i22 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i22 + 1;
    HEAP8[(HEAP32[i20 >> 2] | 0) + i22 >> 0] = i19;
   } else {
    i19 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i19 + 1;
    i20 = i37 + 8 | 0;
    HEAP8[(HEAP32[i20 >> 2] | 0) + i19 >> 0] = i1 >>> 24;
    i19 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i19 + 1;
    HEAP8[(HEAP32[i20 >> 2] | 0) + i19 >> 0] = i1 >>> 16;
    i19 = HEAP32[i2 >> 2] | 0;
    i22 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i22 + 1;
    HEAP8[(HEAP32[i20 >> 2] | 0) + i22 >> 0] = i19 >>> 8;
    i22 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i22 + 1;
    HEAP8[(HEAP32[i20 >> 2] | 0) + i22 >> 0] = i19;
   }
   i2 = HEAP32[i36 >> 2] | 0;
   __tr_flush_bits(i2);
   i3 = i2 + 20 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i22 = HEAP32[i39 >> 2] | 0;
   i1 = i1 >>> 0 > i22 >>> 0 ? i22 : i1;
   if ((i1 | 0) != 0 ? (i38 = i2 + 16 | 0, _memcpy(HEAP32[i40 >> 2] | 0, HEAP32[i38 >> 2] | 0, i1 | 0) | 0, HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + i1, HEAP32[i38 >> 2] = (HEAP32[i38 >> 2] | 0) + i1, i22 = i41 + 20 | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i1, HEAP32[i39 >> 2] = (HEAP32[i39 >> 2] | 0) - i1, i22 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i22 - i1, (i22 | 0) == (i1 | 0)) : 0) HEAP32[i38 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) > 0) HEAP32[i5 >> 2] = 0 - i1;
   i22 = (HEAP32[i21 >> 2] | 0) == 0 & 1;
   STACKTOP = i42;
   return i22 | 0;
  }
 } while (0);
 HEAP32[i41 + 24 >> 2] = HEAP32[36700];
 i22 = -2;
 STACKTOP = i42;
 return i22 | 0;
}

function __ZNK2cv11_InputArray12getMatVectorERNSt3__16vectorINS_3MatENS1_9allocatorIS3_EEEE(i37, i39) {
 i37 = i37 | 0;
 i39 = i39 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 i22 = i40 + 416 | 0;
 i34 = i40 + 408 | 0;
 i36 = i40 + 352 | 0;
 i38 = i40 + 296 | 0;
 i35 = i40 + 240 | 0;
 i29 = i40 + 184 | 0;
 i33 = i40 + 128 | 0;
 i25 = i40 + 72 | 0;
 i32 = i40 + 64 | 0;
 i28 = i40 + 8 | 0;
 i7 = i40;
 i8 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i37 >> 2] | 0) + 24 >> 2] & 127](i37) | 0;
 i31 = i37 + 4 | 0;
 i26 = HEAP32[i31 >> 2] | 0;
 i30 = i26 & 50331648;
 if ((i8 | 0) == 65536) {
  i29 = HEAP32[i37 + 8 >> 2] | 0;
  i30 = i29 + 40 | 0;
  i31 = HEAP32[HEAP32[i30 >> 2] >> 2] | 0;
  i1 = i39 + 4 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i39 >> 2] | 0;
  i2 = (i4 - i3 | 0) / 56 | 0;
  if (i31 >>> 0 <= i2 >>> 0) {
   if (i31 >>> 0 < i2 >>> 0 ? (i6 = i3 + (i31 * 56 | 0) | 0, (i4 | 0) != (i6 | 0)) : 0) do {
    i3 = i4 + -56 | 0;
    HEAP32[i1 >> 2] = i3;
    __ZN2cv3Mat7releaseEv(i3);
    i3 = HEAP32[i4 + -12 >> 2] | 0;
    if ((i3 | 0) != (i4 + -8 | 0)) __ZN2cv8fastFreeEPv(i3);
    i4 = HEAP32[i1 >> 2] | 0;
   } while ((i4 | 0) != (i6 | 0));
  } else __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE8__appendEj(i39, i31 - i2 | 0);
  if ((i31 | 0) <= 0) {
   STACKTOP = i40;
   return;
  }
  i25 = i29 + 4 | 0;
  i2 = i29 + 12 | 0;
  i1 = i29 + 16 | 0;
  i11 = i29 + 44 | 0;
  i12 = i36 + 4 | 0;
  i13 = i36 + 8 | 0;
  i14 = i36 + 12 | 0;
  i15 = i36 + 16 | 0;
  i16 = i36 + 20 | 0;
  i17 = i36 + 24 | 0;
  i18 = i36 + 28 | 0;
  i19 = i36 + 40 | 0;
  i20 = i36 + 48 | 0;
  i21 = i36 + 44 | 0;
  i22 = i36 + 52 | 0;
  i26 = i36 + 36 | 0;
  i27 = i36 + 32 | 0;
  i28 = 0;
  do {
   i23 = HEAP32[i39 >> 2] | 0;
   i10 = i23 + (i28 * 56 | 0) | 0;
   i8 = HEAP32[i25 >> 2] | 0;
   if ((i8 | 0) == 2) {
    i4 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i29 >> 2] | 0;
    i5 = HEAP32[i1 >> 2] | 0;
    i3 = Math_imul(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i28) | 0;
    i6 = i5 + i3 | 0;
    HEAP32[i12 >> 2] = 2;
    HEAP32[i13 >> 2] = 1;
    HEAP32[i14 >> 2] = i4;
    HEAP32[i15 >> 2] = i6;
    HEAP32[i16 >> 2] = i6;
    HEAP32[i17 + 0 >> 2] = 0;
    HEAP32[i17 + 4 >> 2] = 0;
    HEAP32[i17 + 8 >> 2] = 0;
    HEAP32[i17 + 12 >> 2] = 0;
    HEAP32[i19 >> 2] = i13;
    HEAP32[i21 >> 2] = i20;
    i6 = (i7 >>> 3 & 511) + 1 << (47696 >>> (i7 << 1 & 14) & 3);
    i4 = Math_imul(i6, i4) | 0;
    HEAP32[i36 >> 2] = i7 & 4095 | 1124024320;
    HEAP32[i20 >> 2] = i4;
    HEAP32[i22 >> 2] = i6;
    i3 = i5 + (i4 + i3) | 0;
    HEAP32[i18 >> 2] = i3;
    HEAP32[i17 >> 2] = i3;
   } else {
    i8 = i8 + -1 | 0;
    i7 = (HEAP32[i30 >> 2] | 0) + 4 | 0;
    i6 = HEAP32[i29 >> 2] & 4095;
    i4 = HEAP32[i11 >> 2] | 0;
    i5 = (HEAP32[i1 >> 2] | 0) + (Math_imul(HEAP32[i4 >> 2] | 0, i28) | 0) | 0;
    i4 = i4 + 4 | 0;
    i24 = i12 + 0 | 0;
    i9 = i24 + 36 | 0;
    do {
     HEAP32[i24 >> 2] = 0;
     i24 = i24 + 4 | 0;
    } while ((i24 | 0) < (i9 | 0));
    HEAP32[i19 >> 2] = i13;
    HEAP32[i21 >> 2] = i20;
    HEAP32[i22 >> 2] = 0;
    HEAP32[i20 >> 2] = 0;
    HEAP32[i36 >> 2] = i6 | 1124007936;
    HEAP32[i15 >> 2] = i5;
    HEAP32[i16 >> 2] = i5;
    __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i36, i8, i7, i4, 1);
    __ZN2cvL11finalizeHdrERNS_3MatE(i36);
   }
   if ((i10 | 0) != (i36 | 0)) {
    i8 = HEAP32[i26 >> 2] | 0;
    if (i8) {
     i3 = i8 + 12 | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
    }
    __ZN2cv3Mat7releaseEv(i10);
    HEAP32[i10 >> 2] = HEAP32[i36 >> 2];
    i3 = i23 + (i28 * 56 | 0) + 4 | 0;
    i8 = HEAP32[i12 >> 2] | 0;
    if (!((HEAP32[i3 >> 2] | 0) < 3 & (i8 | 0) < 3)) {
     __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i10, i8, 0, 0, 0);
     if ((HEAP32[i3 >> 2] | 0) > 0) {
      i8 = HEAP32[i19 >> 2] | 0;
      i7 = HEAP32[i23 + (i28 * 56 | 0) + 40 >> 2] | 0;
      i6 = HEAP32[i21 >> 2] | 0;
      i5 = HEAP32[i23 + (i28 * 56 | 0) + 44 >> 2] | 0;
      i4 = 0;
      do {
       HEAP32[i7 + (i4 << 2) >> 2] = HEAP32[i8 + (i4 << 2) >> 2];
       HEAP32[i5 + (i4 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) < (HEAP32[i3 >> 2] | 0));
     }
    } else {
     HEAP32[i3 >> 2] = i8;
     HEAP32[i23 + (i28 * 56 | 0) + 8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i23 + (i28 * 56 | 0) + 12 >> 2] = HEAP32[i14 >> 2];
     i4 = HEAP32[i21 >> 2] | 0;
     i3 = HEAP32[i23 + (i28 * 56 | 0) + 44 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    }
    HEAP32[i23 + (i28 * 56 | 0) + 16 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i23 + (i28 * 56 | 0) + 20 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i23 + (i28 * 56 | 0) + 24 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i23 + (i28 * 56 | 0) + 28 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i23 + (i28 * 56 | 0) + 32 >> 2] = HEAP32[i27 >> 2];
    HEAP32[i23 + (i28 * 56 | 0) + 36 >> 2] = HEAP32[i26 >> 2];
   }
   i8 = HEAP32[i26 >> 2] | 0;
   if ((i8 | 0) != 0 ? (i4 = i8 + 12 | 0, i3 = HEAP32[i4 >> 2] | 0, HEAP32[i4 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) {
    i7 = HEAP32[i26 >> 2] | 0;
    if (i7) {
     i8 = HEAP32[i7 + 4 >> 2] | 0;
     if (!i8) {
      i8 = HEAP32[i27 >> 2] | 0;
      if (!i8) {
       if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
        i3 = __Znwj(4) | 0;
        HEAP32[i3 >> 2] = 32784;
        HEAP32[6904] = i3;
        ___cxa_guard_release(27624);
       }
       i8 = HEAP32[6904] | 0;
       i7 = HEAP32[i26 >> 2] | 0;
      }
     }
     FUNCTION_TABLE_vii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8, i7);
    }
    HEAP32[i26 >> 2] = 0;
   }
   HEAP32[i26 >> 2] = 0;
   HEAP32[i15 + 0 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
   HEAP32[i15 + 12 >> 2] = 0;
   if ((HEAP32[i12 >> 2] | 0) > 0) {
    i8 = HEAP32[i19 >> 2] | 0;
    i7 = 0;
    do {
     HEAP32[i8 + (i7 << 2) >> 2] = 0;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) < (HEAP32[i12 >> 2] | 0));
   }
   i8 = HEAP32[i21 >> 2] | 0;
   if ((i8 | 0) != (i20 | 0)) __ZN2cv8fastFreeEPv(i8);
   i28 = i28 + 1 | 0;
  } while ((i28 | 0) < (i31 | 0));
  STACKTOP = i40;
  return;
 } else if ((i8 | 0) == 196608) {
  i27 = HEAP32[i37 + 8 >> 2] | 0;
  i4 = HEAP32[i27 + 4 >> 2] | 0;
  i3 = HEAP32[i27 >> 2] | 0;
  i25 = i4 - i3 | 0;
  i24 = (i26 >>> 3 & 511) + 1 | 0;
  i1 = i26 & 7;
  i2 = 47696 >>> (i1 << 1) & 3;
  i28 = i24 << i2;
  i5 = i39 + 4 | 0;
  i8 = HEAP32[i5 >> 2] | 0;
  i7 = HEAP32[i39 >> 2] | 0;
  i6 = (i8 - i7 | 0) / 56 | 0;
  if (i25 >>> 0 <= i6 >>> 0) {
   if (i25 >>> 0 < i6 >>> 0 ? (i20 = i7 + (i25 * 56 | 0) | 0, (i8 | 0) != (i20 | 0)) : 0) do {
    i7 = i8 + -56 | 0;
    HEAP32[i5 >> 2] = i7;
    __ZN2cv3Mat7releaseEv(i7);
    i7 = HEAP32[i8 + -12 >> 2] | 0;
    if ((i7 | 0) != (i8 + -8 | 0)) __ZN2cv8fastFreeEPv(i7);
    i8 = HEAP32[i5 >> 2] | 0;
   } while ((i8 | 0) != (i20 | 0));
  } else __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE8__appendEj(i39, i25 - i6 | 0);
  if ((i4 | 0) == (i3 | 0)) {
   STACKTOP = i40;
   return;
  }
  i12 = i33 + 4 | 0;
  i13 = i33 + 8 | 0;
  i14 = i33 + 12 | 0;
  i15 = i33 + 16 | 0;
  i16 = i33 + 20 | 0;
  i17 = i33 + 24 | 0;
  i18 = i33 + 28 | 0;
  i19 = i33 + 40 | 0;
  i20 = i33 + 48 | 0;
  i21 = i33 + 44 | 0;
  i22 = i33 + 52 | 0;
  i11 = 1 << i2;
  i23 = i1 | 1124024320;
  i10 = i33 + 36 | 0;
  i9 = i33 + 32 | 0;
  i1 = 0;
  do {
   i3 = HEAP32[i39 >> 2] | 0;
   i8 = i3 + (i1 * 56 | 0) | 0;
   i4 = HEAP32[i27 >> 2] | 0;
   i2 = Math_imul(i1, i28) | 0;
   i5 = i4 + i2 | 0;
   HEAP32[i12 >> 2] = 2;
   HEAP32[i13 >> 2] = 1;
   HEAP32[i14 >> 2] = i24;
   HEAP32[i15 >> 2] = i5;
   HEAP32[i16 >> 2] = i5;
   HEAP32[i17 + 0 >> 2] = 0;
   HEAP32[i17 + 4 >> 2] = 0;
   HEAP32[i17 + 8 >> 2] = 0;
   HEAP32[i17 + 12 >> 2] = 0;
   HEAP32[i19 >> 2] = i13;
   HEAP32[i21 >> 2] = i20;
   HEAP32[i33 >> 2] = i23;
   HEAP32[i20 >> 2] = i28;
   HEAP32[i22 >> 2] = i11;
   i2 = i4 + (i28 + i2) | 0;
   HEAP32[i18 >> 2] = i2;
   HEAP32[i17 >> 2] = i2;
   if ((i8 | 0) != (i33 | 0)) {
    __ZN2cv3Mat7releaseEv(i8);
    HEAP32[i8 >> 2] = HEAP32[i33 >> 2];
    i2 = i3 + (i1 * 56 | 0) + 4 | 0;
    i7 = HEAP32[i12 >> 2] | 0;
    if (!((HEAP32[i2 >> 2] | 0) < 3 & (i7 | 0) < 3)) {
     __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i8, i7, 0, 0, 0);
     if ((HEAP32[i2 >> 2] | 0) > 0) {
      i8 = HEAP32[i19 >> 2] | 0;
      i7 = HEAP32[i3 + (i1 * 56 | 0) + 40 >> 2] | 0;
      i6 = HEAP32[i21 >> 2] | 0;
      i5 = HEAP32[i3 + (i1 * 56 | 0) + 44 >> 2] | 0;
      i4 = 0;
      do {
       HEAP32[i7 + (i4 << 2) >> 2] = HEAP32[i8 + (i4 << 2) >> 2];
       HEAP32[i5 + (i4 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) < (HEAP32[i2 >> 2] | 0));
     }
    } else {
     HEAP32[i2 >> 2] = i7;
     HEAP32[i3 + (i1 * 56 | 0) + 8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + (i1 * 56 | 0) + 12 >> 2] = HEAP32[i14 >> 2];
     i4 = HEAP32[i21 >> 2] | 0;
     i2 = HEAP32[i3 + (i1 * 56 | 0) + 44 >> 2] | 0;
     HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    }
    HEAP32[i3 + (i1 * 56 | 0) + 16 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i3 + (i1 * 56 | 0) + 20 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i3 + (i1 * 56 | 0) + 24 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i3 + (i1 * 56 | 0) + 28 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i3 + (i1 * 56 | 0) + 32 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i3 + (i1 * 56 | 0) + 36 >> 2] = HEAP32[i10 >> 2];
    i8 = HEAP32[i10 >> 2] | 0;
    if ((i8 | 0) != 0 ? (i3 = i8 + 12 | 0, i2 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i2 + -1, (i2 | 0) == 1) : 0) {
     i7 = HEAP32[i10 >> 2] | 0;
     if (i7) {
      i8 = HEAP32[i7 + 4 >> 2] | 0;
      if (!i8) {
       i8 = HEAP32[i9 >> 2] | 0;
       if (!i8) {
        if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
         i2 = __Znwj(4) | 0;
         HEAP32[i2 >> 2] = 32784;
         HEAP32[6904] = i2;
         ___cxa_guard_release(27624);
        }
        i8 = HEAP32[6904] | 0;
        i7 = HEAP32[i10 >> 2] | 0;
       }
      }
      FUNCTION_TABLE_vii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8, i7);
     }
     HEAP32[i10 >> 2] = 0;
    }
   }
   HEAP32[i10 >> 2] = 0;
   HEAP32[i15 + 0 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
   HEAP32[i15 + 12 >> 2] = 0;
   if ((HEAP32[i12 >> 2] | 0) > 0) {
    i8 = HEAP32[i19 >> 2] | 0;
    i7 = 0;
    do {
     HEAP32[i8 + (i7 << 2) >> 2] = 0;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) < (HEAP32[i12 >> 2] | 0));
   }
   i8 = HEAP32[i21 >> 2] | 0;
   if ((i8 | 0) != (i20 | 0)) __ZN2cv8fastFreeEPv(i8);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i25 >>> 0);
  STACKTOP = i40;
  return;
 } else if ((i8 | 0) == 720896) {
  i24 = HEAP32[i37 + 8 >> 2] | 0;
  i8 = HEAP32[i24 + 4 >> 2] | 0;
  i7 = HEAP32[i24 >> 2] | 0;
  i23 = (i8 - i7 | 0) / 48 | 0;
  i2 = i39 + 4 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i6 = HEAP32[i39 >> 2] | 0;
  i5 = (i4 - i6 | 0) / 56 | 0;
  if (i23 >>> 0 <= i5 >>> 0) {
   if (i23 >>> 0 < i5 >>> 0 ? (i10 = i6 + (i23 * 56 | 0) | 0, (i4 | 0) != (i10 | 0)) : 0) do {
    i3 = i4 + -56 | 0;
    HEAP32[i2 >> 2] = i3;
    __ZN2cv3Mat7releaseEv(i3);
    i3 = HEAP32[i4 + -12 >> 2] | 0;
    if ((i3 | 0) != (i4 + -8 | 0)) __ZN2cv8fastFreeEPv(i3);
    i4 = HEAP32[i2 >> 2] | 0;
   } while ((i4 | 0) != (i10 | 0));
  } else __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE8__appendEj(i39, i23 - i5 | 0);
  if ((i8 | 0) == (i7 | 0)) {
   STACKTOP = i40;
   return;
  }
  i10 = i28 + 36 | 0;
  i9 = i28 + 16 | 0;
  i1 = i28 + 4 | 0;
  i11 = i28 + 40 | 0;
  i12 = i28 + 44 | 0;
  i13 = i28 + 48 | 0;
  i14 = i28 + 32 | 0;
  i15 = i28 + 8 | 0;
  i16 = i28 + 12 | 0;
  i17 = i28 + 20 | 0;
  i18 = i28 + 24 | 0;
  i19 = i28 + 28 | 0;
  i20 = 0;
  do {
   i2 = HEAP32[i39 >> 2] | 0;
   i7 = i2 + (i20 * 56 | 0) | 0;
   __ZNK2cv4UMat6getMatEi(i28, (HEAP32[i24 >> 2] | 0) + (i20 * 48 | 0) | 0, i30);
   if ((i7 | 0) != (i28 | 0)) {
    i8 = HEAP32[i10 >> 2] | 0;
    if (i8) {
     i22 = i8 + 12 | 0;
     HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
    }
    __ZN2cv3Mat7releaseEv(i7);
    HEAP32[i7 >> 2] = HEAP32[i28 >> 2];
    i3 = i2 + (i20 * 56 | 0) + 4 | 0;
    i8 = HEAP32[i1 >> 2] | 0;
    if (!((HEAP32[i3 >> 2] | 0) < 3 & (i8 | 0) < 3)) {
     __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i7, i8, 0, 0, 0);
     if ((HEAP32[i3 >> 2] | 0) > 0) {
      i8 = HEAP32[i11 >> 2] | 0;
      i7 = HEAP32[i2 + (i20 * 56 | 0) + 40 >> 2] | 0;
      i6 = HEAP32[i12 >> 2] | 0;
      i5 = HEAP32[i2 + (i20 * 56 | 0) + 44 >> 2] | 0;
      i4 = 0;
      do {
       HEAP32[i7 + (i4 << 2) >> 2] = HEAP32[i8 + (i4 << 2) >> 2];
       HEAP32[i5 + (i4 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) < (HEAP32[i3 >> 2] | 0));
     }
    } else {
     HEAP32[i3 >> 2] = i8;
     HEAP32[i2 + (i20 * 56 | 0) + 8 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i2 + (i20 * 56 | 0) + 12 >> 2] = HEAP32[i16 >> 2];
     i21 = HEAP32[i12 >> 2] | 0;
     i22 = HEAP32[i2 + (i20 * 56 | 0) + 44 >> 2] | 0;
     HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    }
    HEAP32[i2 + (i20 * 56 | 0) + 16 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i2 + (i20 * 56 | 0) + 20 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i2 + (i20 * 56 | 0) + 24 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i2 + (i20 * 56 | 0) + 28 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i2 + (i20 * 56 | 0) + 32 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i2 + (i20 * 56 | 0) + 36 >> 2] = HEAP32[i10 >> 2];
   }
   i8 = HEAP32[i10 >> 2] | 0;
   if ((i8 | 0) != 0 ? (i21 = i8 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) {
    i7 = HEAP32[i10 >> 2] | 0;
    if (i7) {
     i8 = HEAP32[i7 + 4 >> 2] | 0;
     if (!i8) {
      i8 = HEAP32[i14 >> 2] | 0;
      if (!i8) {
       if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
        i22 = __Znwj(4) | 0;
        HEAP32[i22 >> 2] = 32784;
        HEAP32[6904] = i22;
        ___cxa_guard_release(27624);
       }
       i8 = HEAP32[6904] | 0;
       i7 = HEAP32[i10 >> 2] | 0;
      }
     }
     FUNCTION_TABLE_vii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8, i7);
    }
    HEAP32[i10 >> 2] = 0;
   }
   HEAP32[i10 >> 2] = 0;
   HEAP32[i9 + 0 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   if ((HEAP32[i1 >> 2] | 0) > 0) {
    i8 = HEAP32[i11 >> 2] | 0;
    i7 = 0;
    do {
     HEAP32[i8 + (i7 << 2) >> 2] = 0;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) < (HEAP32[i1 >> 2] | 0));
   }
   i8 = HEAP32[i12 >> 2] | 0;
   if ((i8 | 0) != (i13 | 0)) __ZN2cv8fastFreeEPv(i8);
   i20 = i20 + 1 | 0;
  } while (i20 >>> 0 < i23 >>> 0);
  STACKTOP = i40;
  return;
 } else if ((i8 | 0) == 131072) {
  i25 = HEAP32[i37 + 16 >> 2] | 0;
  i24 = (i26 >>> 3 & 511) + 1 << (47696 >>> (i26 << 1 & 14) & 3);
  i6 = i39 + 4 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i39 >> 2] | 0;
  i2 = (i4 - i3 | 0) / 56 | 0;
  if (i25 >>> 0 <= i2 >>> 0) {
   if (i25 >>> 0 < i2 >>> 0 ? (i5 = i3 + (i25 * 56 | 0) | 0, (i4 | 0) != (i5 | 0)) : 0) do {
    i3 = i4 + -56 | 0;
    HEAP32[i6 >> 2] = i3;
    __ZN2cv3Mat7releaseEv(i3);
    i3 = HEAP32[i4 + -12 >> 2] | 0;
    if ((i3 | 0) != (i4 + -8 | 0)) __ZN2cv8fastFreeEPv(i3);
    i4 = HEAP32[i6 >> 2] | 0;
   } while ((i4 | 0) != (i5 | 0));
  } else __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE8__appendEj(i39, i25 - i2 | 0);
  if (!i25) {
   STACKTOP = i40;
   return;
  }
  i23 = i37 + 12 | 0;
  i20 = i37 + 8 | 0;
  i19 = i29 + 4 | 0;
  i18 = i29 + 8 | 0;
  i17 = i29 + 12 | 0;
  i16 = i29 + 16 | 0;
  i15 = i29 + 20 | 0;
  i14 = i29 + 24 | 0;
  i13 = i29 + 28 | 0;
  i12 = i29 + 40 | 0;
  i11 = i29 + 48 | 0;
  i1 = i29 + 44 | 0;
  i9 = i29 + 52 | 0;
  i10 = i29 + 36 | 0;
  i21 = i29 + 32 | 0;
  i22 = 0;
  do {
   i3 = HEAP32[i39 >> 2] | 0;
   i8 = i3 + (i22 * 56 | 0) | 0;
   i5 = HEAP32[i23 >> 2] | 0;
   i26 = HEAP32[i31 >> 2] | 0;
   i6 = HEAP32[i20 >> 2] | 0;
   i2 = Math_imul(i22, i24) | 0;
   i4 = i6 + (Math_imul(i2, i5) | 0) | 0;
   HEAP32[i19 >> 2] = 2;
   HEAP32[i18 >> 2] = 1;
   HEAP32[i17 >> 2] = i5;
   HEAP32[i16 >> 2] = i4;
   HEAP32[i15 >> 2] = i4;
   HEAP32[i14 + 0 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   HEAP32[i14 + 12 >> 2] = 0;
   HEAP32[i12 >> 2] = i18;
   HEAP32[i1 >> 2] = i11;
   i4 = (i26 >>> 3 & 511) + 1 << (47696 >>> (i26 << 1 & 14) & 3);
   i7 = Math_imul(i4, i5) | 0;
   HEAP32[i29 >> 2] = i26 & 4095 | 1124024320;
   HEAP32[i11 >> 2] = i7;
   HEAP32[i9 >> 2] = i4;
   i2 = i6 + (Math_imul(i5, i4 + i2 | 0) | 0) | 0;
   HEAP32[i13 >> 2] = i2;
   HEAP32[i14 >> 2] = i2;
   if ((i8 | 0) != (i29 | 0)) {
    __ZN2cv3Mat7releaseEv(i8);
    HEAP32[i8 >> 2] = HEAP32[i29 >> 2];
    i2 = i3 + (i22 * 56 | 0) + 4 | 0;
    i7 = HEAP32[i19 >> 2] | 0;
    if (!((HEAP32[i2 >> 2] | 0) < 3 & (i7 | 0) < 3)) {
     __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i8, i7, 0, 0, 0);
     if ((HEAP32[i2 >> 2] | 0) > 0) {
      i8 = HEAP32[i12 >> 2] | 0;
      i7 = HEAP32[i3 + (i22 * 56 | 0) + 40 >> 2] | 0;
      i6 = HEAP32[i1 >> 2] | 0;
      i5 = HEAP32[i3 + (i22 * 56 | 0) + 44 >> 2] | 0;
      i4 = 0;
      do {
       HEAP32[i7 + (i4 << 2) >> 2] = HEAP32[i8 + (i4 << 2) >> 2];
       HEAP32[i5 + (i4 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) < (HEAP32[i2 >> 2] | 0));
     }
    } else {
     HEAP32[i2 >> 2] = i7;
     HEAP32[i3 + (i22 * 56 | 0) + 8 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i3 + (i22 * 56 | 0) + 12 >> 2] = HEAP32[i17 >> 2];
     i4 = HEAP32[i1 >> 2] | 0;
     i2 = HEAP32[i3 + (i22 * 56 | 0) + 44 >> 2] | 0;
     HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    }
    HEAP32[i3 + (i22 * 56 | 0) + 16 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i3 + (i22 * 56 | 0) + 20 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i3 + (i22 * 56 | 0) + 24 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + (i22 * 56 | 0) + 28 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i3 + (i22 * 56 | 0) + 32 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i3 + (i22 * 56 | 0) + 36 >> 2] = HEAP32[i10 >> 2];
    i8 = HEAP32[i10 >> 2] | 0;
    if ((i8 | 0) != 0 ? (i3 = i8 + 12 | 0, i2 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i2 + -1, (i2 | 0) == 1) : 0) {
     i7 = HEAP32[i10 >> 2] | 0;
     if (i7) {
      i8 = HEAP32[i7 + 4 >> 2] | 0;
      if (!i8) {
       i8 = HEAP32[i21 >> 2] | 0;
       if (!i8) {
        if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
         i2 = __Znwj(4) | 0;
         HEAP32[i2 >> 2] = 32784;
         HEAP32[6904] = i2;
         ___cxa_guard_release(27624);
        }
        i8 = HEAP32[6904] | 0;
        i7 = HEAP32[i10 >> 2] | 0;
       }
      }
      FUNCTION_TABLE_vii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8, i7);
     }
     HEAP32[i10 >> 2] = 0;
    }
   }
   HEAP32[i10 >> 2] = 0;
   HEAP32[i16 + 0 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   HEAP32[i16 + 12 >> 2] = 0;
   if ((HEAP32[i19 >> 2] | 0) > 0) {
    i8 = HEAP32[i12 >> 2] | 0;
    i7 = 0;
    do {
     HEAP32[i8 + (i7 << 2) >> 2] = 0;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) < (HEAP32[i19 >> 2] | 0));
   }
   i8 = HEAP32[i1 >> 2] | 0;
   if ((i8 | 0) != (i11 | 0)) __ZN2cv8fastFreeEPv(i8);
   i22 = i22 + 1 | 0;
  } while (i22 >>> 0 < i25 >>> 0);
  STACKTOP = i40;
  return;
 } else if ((i8 | 0) == 393216) {
  i8 = HEAP32[i37 + 8 >> 2] | 0;
  HEAP32[i38 >> 2] = 1124007936;
  i27 = i38 + 4 | 0;
  i4 = i38 + 8 | 0;
  i30 = i38 + 40 | 0;
  i24 = i27 + 0 | 0;
  i9 = i24 + 36 | 0;
  do {
   HEAP32[i24 >> 2] = 0;
   i24 = i24 + 4 | 0;
  } while ((i24 | 0) < (i9 | 0));
  HEAP32[i30 >> 2] = i4;
  i29 = i38 + 48 | 0;
  i31 = i38 + 44 | 0;
  HEAP32[i31 >> 2] = i29;
  HEAP32[i38 + 52 >> 2] = 0;
  HEAP32[i29 >> 2] = 0;
  i28 = HEAP32[i8 >> 2] | 0;
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] & 63](i28, i8, i38, -1);
  i28 = HEAP32[HEAP32[i30 >> 2] >> 2] | 0;
  i5 = i39 + 4 | 0;
  i8 = HEAP32[i5 >> 2] | 0;
  i7 = HEAP32[i39 >> 2] | 0;
  i6 = (i8 - i7 | 0) / 56 | 0;
  if (i28 >>> 0 <= i6 >>> 0) {
   if (i28 >>> 0 < i6 >>> 0 ? (i19 = i7 + (i28 * 56 | 0) | 0, (i8 | 0) != (i19 | 0)) : 0) do {
    i7 = i8 + -56 | 0;
    HEAP32[i5 >> 2] = i7;
    __ZN2cv3Mat7releaseEv(i7);
    i7 = HEAP32[i8 + -12 >> 2] | 0;
    if ((i7 | 0) != (i8 + -8 | 0)) __ZN2cv8fastFreeEPv(i7);
    i8 = HEAP32[i5 >> 2] | 0;
   } while ((i8 | 0) != (i19 | 0));
  } else __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE8__appendEj(i39, i28 - i6 | 0);
  if ((i28 | 0) > 0) {
   i24 = i22 + 4 | 0;
   i23 = i34 + 4 | 0;
   i2 = i35 + 36 | 0;
   i1 = i35 + 16 | 0;
   i11 = i35 + 4 | 0;
   i12 = i35 + 40 | 0;
   i13 = i35 + 44 | 0;
   i14 = i35 + 48 | 0;
   i15 = i35 + 32 | 0;
   i16 = i35 + 8 | 0;
   i17 = i35 + 12 | 0;
   i18 = i35 + 20 | 0;
   i19 = i35 + 24 | 0;
   i20 = i35 + 28 | 0;
   i21 = 0;
   do {
    i9 = HEAP32[i39 >> 2] | 0;
    i7 = i9 + (i21 * 56 | 0) | 0;
    i3 = i21;
    i21 = i21 + 1 | 0;
    HEAP32[i22 >> 2] = i3;
    HEAP32[i24 >> 2] = i21;
    HEAP32[i34 >> 2] = -2147483648;
    HEAP32[i23 >> 2] = 2147483647;
    __ZN2cv3MatC2ERKS0_RKNS_5RangeES5_(i35, i38, i22, i34);
    if ((i7 | 0) != (i35 | 0)) {
     i8 = HEAP32[i2 >> 2] | 0;
     if (i8) {
      i4 = i8 + 12 | 0;
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     }
     __ZN2cv3Mat7releaseEv(i7);
     HEAP32[i7 >> 2] = HEAP32[i35 >> 2];
     i10 = i9 + (i3 * 56 | 0) + 4 | 0;
     i8 = HEAP32[i11 >> 2] | 0;
     if (!((HEAP32[i10 >> 2] | 0) < 3 & (i8 | 0) < 3)) {
      __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i7, i8, 0, 0, 0);
      if ((HEAP32[i10 >> 2] | 0) > 0) {
       i8 = HEAP32[i12 >> 2] | 0;
       i7 = HEAP32[i9 + (i3 * 56 | 0) + 40 >> 2] | 0;
       i6 = HEAP32[i13 >> 2] | 0;
       i5 = HEAP32[i9 + (i3 * 56 | 0) + 44 >> 2] | 0;
       i4 = 0;
       do {
        HEAP32[i7 + (i4 << 2) >> 2] = HEAP32[i8 + (i4 << 2) >> 2];
        HEAP32[i5 + (i4 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
        i4 = i4 + 1 | 0;
       } while ((i4 | 0) < (HEAP32[i10 >> 2] | 0));
      }
     } else {
      HEAP32[i10 >> 2] = i8;
      HEAP32[i9 + (i3 * 56 | 0) + 8 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i9 + (i3 * 56 | 0) + 12 >> 2] = HEAP32[i17 >> 2];
      i5 = HEAP32[i13 >> 2] | 0;
      i4 = HEAP32[i9 + (i3 * 56 | 0) + 44 >> 2] | 0;
      HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     }
     HEAP32[i9 + (i3 * 56 | 0) + 16 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i9 + (i3 * 56 | 0) + 20 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i9 + (i3 * 56 | 0) + 24 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i9 + (i3 * 56 | 0) + 28 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i9 + (i3 * 56 | 0) + 32 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i9 + (i3 * 56 | 0) + 36 >> 2] = HEAP32[i2 >> 2];
    }
    i8 = HEAP32[i2 >> 2] | 0;
    if ((i8 | 0) != 0 ? (i4 = i8 + 12 | 0, i3 = HEAP32[i4 >> 2] | 0, HEAP32[i4 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) {
     i7 = HEAP32[i2 >> 2] | 0;
     if (i7) {
      i8 = HEAP32[i7 + 4 >> 2] | 0;
      if (!i8) {
       i8 = HEAP32[i15 >> 2] | 0;
       if (!i8) {
        if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
         i3 = __Znwj(4) | 0;
         HEAP32[i3 >> 2] = 32784;
         HEAP32[6904] = i3;
         ___cxa_guard_release(27624);
        }
        i8 = HEAP32[6904] | 0;
        i7 = HEAP32[i2 >> 2] | 0;
       }
      }
      FUNCTION_TABLE_vii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8, i7);
     }
     HEAP32[i2 >> 2] = 0;
    }
    HEAP32[i2 >> 2] = 0;
    HEAP32[i1 + 0 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    if ((HEAP32[i11 >> 2] | 0) > 0) {
     i8 = HEAP32[i12 >> 2] | 0;
     i7 = 0;
     do {
      HEAP32[i8 + (i7 << 2) >> 2] = 0;
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) < (HEAP32[i11 >> 2] | 0));
    }
    i8 = HEAP32[i13 >> 2] | 0;
    if ((i8 | 0) != (i14 | 0)) __ZN2cv8fastFreeEPv(i8);
   } while ((i21 | 0) < (i28 | 0));
  }
  i2 = i38 + 36 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if ((i4 | 0) != 0 ? (i21 = i4 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3) {
    i4 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i4) {
     i4 = HEAP32[i38 + 32 >> 2] | 0;
     if (!i4) {
      if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
       i22 = __Znwj(4) | 0;
       HEAP32[i22 >> 2] = 32784;
       HEAP32[6904] = i22;
       ___cxa_guard_release(27624);
      }
      i4 = HEAP32[6904] | 0;
      i3 = HEAP32[i2 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] & 127](i4, i3);
   }
   HEAP32[i2 >> 2] = 0;
  }
  HEAP32[i2 >> 2] = 0;
  i22 = i38 + 16 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i27 >> 2] | 0) > 0) {
   i2 = HEAP32[i30 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i2 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i27 >> 2] | 0));
  }
  i1 = HEAP32[i31 >> 2] | 0;
  if ((i1 | 0) == (i29 | 0)) {
   STACKTOP = i40;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i40;
  return;
 } else if (!i8) {
  i4 = HEAP32[i39 >> 2] | 0;
  i3 = i39 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == (i4 | 0)) {
   STACKTOP = i40;
   return;
  }
  do {
   i2 = i1 + -56 | 0;
   HEAP32[i3 >> 2] = i2;
   __ZN2cv3Mat7releaseEv(i2);
   i2 = HEAP32[i1 + -12 >> 2] | 0;
   if ((i2 | 0) != (i1 + -8 | 0)) __ZN2cv8fastFreeEPv(i2);
   i1 = HEAP32[i3 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
  STACKTOP = i40;
  return;
 } else if ((i8 | 0) == 262144) {
  i28 = HEAP32[i37 + 8 >> 2] | 0;
  i4 = (HEAP32[i28 + 4 >> 2] | 0) - (HEAP32[i28 >> 2] | 0) | 0;
  i27 = (i4 | 0) / 12 | 0;
  i2 = i26 & 4095;
  i3 = i39 + 4 | 0;
  i6 = HEAP32[i3 >> 2] | 0;
  i8 = HEAP32[i39 >> 2] | 0;
  i7 = (i6 - i8 | 0) / 56 | 0;
  if (i27 >>> 0 <= i7 >>> 0) {
   if (i27 >>> 0 < i7 >>> 0 ? (i1 = i8 + (i27 * 56 | 0) | 0, (i6 | 0) != (i1 | 0)) : 0) do {
    i5 = i6 + -56 | 0;
    HEAP32[i3 >> 2] = i5;
    __ZN2cv3Mat7releaseEv(i5);
    i5 = HEAP32[i6 + -12 >> 2] | 0;
    if ((i5 | 0) != (i6 + -8 | 0)) __ZN2cv8fastFreeEPv(i5);
    i6 = HEAP32[i3 >> 2] | 0;
   } while ((i6 | 0) != (i1 | 0));
  } else __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE8__appendEj(i39, i27 - i7 | 0);
  if ((i4 | 0) <= 0) {
   STACKTOP = i40;
   return;
  }
  i12 = i25 + 4 | 0;
  i13 = i25 + 8 | 0;
  i14 = i32 + 4 | 0;
  i15 = i25 + 12 | 0;
  i16 = i25 + 16 | 0;
  i17 = i25 + 20 | 0;
  i18 = i25 + 24 | 0;
  i19 = i25 + 28 | 0;
  i20 = i25 + 40 | 0;
  i21 = i25 + 48 | 0;
  i22 = i25 + 44 | 0;
  i24 = i25 + 52 | 0;
  i11 = (i26 >>> 3 & 511) + 1 << (47696 >>> (i26 << 1 & 14) & 3);
  i23 = i2 | 1124024320;
  i10 = i25 + 36 | 0;
  i9 = i25 + 32 | 0;
  i1 = 0;
  do {
   i5 = HEAP32[i28 >> 2] | 0;
   i3 = HEAP32[i39 >> 2] | 0;
   i8 = i3 + (i1 * 56 | 0) | 0;
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] & 63](i32, i37, i1);
   i5 = HEAP32[i5 + (i1 * 12 | 0) >> 2] | 0;
   HEAP32[i12 >> 2] = 2;
   i4 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i4;
   i2 = HEAP32[i32 >> 2] | 0;
   HEAP32[i15 >> 2] = i2;
   HEAP32[i16 >> 2] = i5;
   HEAP32[i17 >> 2] = i5;
   HEAP32[i18 + 0 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   HEAP32[i18 + 12 >> 2] = 0;
   HEAP32[i20 >> 2] = i13;
   HEAP32[i22 >> 2] = i21;
   i2 = Math_imul(i2, i11) | 0;
   HEAP32[i25 >> 2] = i23;
   HEAP32[i21 >> 2] = i2;
   HEAP32[i24 >> 2] = i11;
   i2 = i5 + (Math_imul(i4, i2) | 0) | 0;
   HEAP32[i19 >> 2] = i2;
   HEAP32[i18 >> 2] = i2;
   if ((i8 | 0) != (i25 | 0)) {
    __ZN2cv3Mat7releaseEv(i8);
    HEAP32[i8 >> 2] = HEAP32[i25 >> 2];
    i2 = i3 + (i1 * 56 | 0) + 4 | 0;
    i7 = HEAP32[i12 >> 2] | 0;
    if (!((HEAP32[i2 >> 2] | 0) < 3 & (i7 | 0) < 3)) {
     __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i8, i7, 0, 0, 0);
     if ((HEAP32[i2 >> 2] | 0) > 0) {
      i8 = HEAP32[i20 >> 2] | 0;
      i7 = HEAP32[i3 + (i1 * 56 | 0) + 40 >> 2] | 0;
      i6 = HEAP32[i22 >> 2] | 0;
      i5 = HEAP32[i3 + (i1 * 56 | 0) + 44 >> 2] | 0;
      i4 = 0;
      do {
       HEAP32[i7 + (i4 << 2) >> 2] = HEAP32[i8 + (i4 << 2) >> 2];
       HEAP32[i5 + (i4 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) < (HEAP32[i2 >> 2] | 0));
     }
    } else {
     HEAP32[i2 >> 2] = i7;
     HEAP32[i3 + (i1 * 56 | 0) + 8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + (i1 * 56 | 0) + 12 >> 2] = HEAP32[i15 >> 2];
     i4 = HEAP32[i22 >> 2] | 0;
     i2 = HEAP32[i3 + (i1 * 56 | 0) + 44 >> 2] | 0;
     HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    }
    HEAP32[i3 + (i1 * 56 | 0) + 16 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i3 + (i1 * 56 | 0) + 20 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i3 + (i1 * 56 | 0) + 24 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i3 + (i1 * 56 | 0) + 28 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i3 + (i1 * 56 | 0) + 32 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i3 + (i1 * 56 | 0) + 36 >> 2] = HEAP32[i10 >> 2];
    i8 = HEAP32[i10 >> 2] | 0;
    if ((i8 | 0) != 0 ? (i3 = i8 + 12 | 0, i2 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i2 + -1, (i2 | 0) == 1) : 0) {
     i7 = HEAP32[i10 >> 2] | 0;
     if (i7) {
      i8 = HEAP32[i7 + 4 >> 2] | 0;
      if (!i8) {
       i8 = HEAP32[i9 >> 2] | 0;
       if (!i8) {
        if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
         i2 = __Znwj(4) | 0;
         HEAP32[i2 >> 2] = 32784;
         HEAP32[6904] = i2;
         ___cxa_guard_release(27624);
        }
        i8 = HEAP32[6904] | 0;
        i7 = HEAP32[i10 >> 2] | 0;
       }
      }
      FUNCTION_TABLE_vii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8, i7);
     }
     HEAP32[i10 >> 2] = 0;
    }
   }
   HEAP32[i10 >> 2] = 0;
   HEAP32[i16 + 0 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   HEAP32[i16 + 12 >> 2] = 0;
   if ((HEAP32[i12 >> 2] | 0) > 0) {
    i8 = HEAP32[i20 >> 2] | 0;
    i7 = 0;
    do {
     HEAP32[i8 + (i7 << 2) >> 2] = 0;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) < (HEAP32[i12 >> 2] | 0));
   }
   i8 = HEAP32[i22 >> 2] | 0;
   if ((i8 | 0) != (i21 | 0)) __ZN2cv8fastFreeEPv(i8);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i27 | 0));
  STACKTOP = i40;
  return;
 } else if ((i8 | 0) == 327680) {
  i7 = HEAP32[i37 + 8 >> 2] | 0;
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i8 = (i1 - i5 | 0) / 56 | 0;
  i6 = i39 + 4 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i39 >> 2] | 0;
  i2 = (i4 - i3 | 0) / 56 | 0;
  if (i8 >>> 0 <= i2 >>> 0) {
   if (i8 >>> 0 < i2 >>> 0 ? (i9 = i3 + (i8 * 56 | 0) | 0, (i4 | 0) != (i9 | 0)) : 0) do {
    i3 = i4 + -56 | 0;
    HEAP32[i6 >> 2] = i3;
    __ZN2cv3Mat7releaseEv(i3);
    i3 = HEAP32[i4 + -12 >> 2] | 0;
    if ((i3 | 0) != (i4 + -8 | 0)) __ZN2cv8fastFreeEPv(i3);
    i4 = HEAP32[i6 >> 2] | 0;
   } while ((i4 | 0) != (i9 | 0));
  } else __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE8__appendEj(i39, i8 - i2 | 0);
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i40;
   return;
  } else i2 = 0;
  do {
   __ZN2cv3MataSERKS0_((HEAP32[i39 >> 2] | 0) + (i2 * 56 | 0) | 0, (HEAP32[i7 >> 2] | 0) + (i2 * 56 | 0) | 0) | 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i8 >>> 0);
  STACKTOP = i40;
  return;
 } else {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i24 = (__ZN2cv6String8allocateEj(i7, 30) | 0) + 0 | 0;
  i2 = 28928;
  i9 = i24 + 30 | 0;
  do {
   HEAP8[i24 >> 0] = HEAP8[i2 >> 0] | 0;
   i24 = i24 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i24 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i7, 28968, 27528, 1336);
  __ZN2cv6String10deallocateEv(i7);
  STACKTOP = i40;
  return;
 }
}

function _cvSeqSort(i7, i56, i55) {
 i7 = i7 | 0;
 i56 = i56 | 0;
 i55 = i55 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0;
 i67 = STACKTOP;
 STACKTOP = STACKTOP + 1808 | 0;
 i57 = i67 + 1776 | 0;
 i60 = i67 + 1744 | 0;
 i63 = i67 + 208 | 0;
 i5 = i67 + 200 | 0;
 i6 = i67 + 192 | 0;
 i58 = i67 + 160 | 0;
 i59 = i67 + 128 | 0;
 i61 = i67 + 96 | 0;
 i62 = i67 + 64 | 0;
 i64 = i67 + 32 | 0;
 i65 = i67;
 i1 = (i7 | 0) != 0;
 if (!(i1 ? (HEAP32[i7 >> 2] & -65536 | 0) == 1117323264 : 0)) {
  i1 = i1 ? -5 : -27;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i5, 18) | 0) + 0 | 0;
  i3 = 40432 | 0;
  i4 = i2 + 18 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i1, i5, 40456, 39608, 1917);
  __ZN2cv6String10deallocateEv(i5);
 }
 if (!i56) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i6, 21) | 0) + 0 | 0;
  i3 = 40472 | 0;
  i4 = i2 + 21 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i6, 40456, 39608, 1920);
  __ZN2cv6String10deallocateEv(i6);
 }
 i52 = i7 + 24 | 0;
 if ((HEAP32[i52 >> 2] | 0) < 2) {
  STACKTOP = i67;
  return;
 }
 i53 = HEAP32[i7 + 28 >> 2] | 0;
 i54 = i53 * 7 | 0;
 _cvStartReadSeq(i7, i57, 0);
 HEAP32[i60 + 0 >> 2] = HEAP32[i57 + 0 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
 HEAP32[i60 + 16 >> 2] = HEAP32[i57 + 16 >> 2];
 HEAP32[i60 + 20 >> 2] = HEAP32[i57 + 20 >> 2];
 HEAP32[i60 + 24 >> 2] = HEAP32[i57 + 24 >> 2];
 HEAP32[i60 + 28 >> 2] = HEAP32[i57 + 28 >> 2];
 i45 = i57 + 8 | 0;
 i2 = HEAP32[i45 >> 2] | 0;
 HEAP32[i63 >> 2] = i2;
 i46 = i57 + 12 | 0;
 i1 = HEAP32[i46 >> 2] | 0;
 HEAP32[i63 + 4 >> 2] = i1;
 i47 = i57 + 16 | 0;
 i8 = HEAP32[i47 >> 2] | 0;
 HEAP32[i63 + 8 >> 2] = i8;
 i48 = i57 + 20 | 0;
 i9 = HEAP32[i48 >> 2] | 0;
 HEAP32[i63 + 12 >> 2] = i9;
 i49 = i60 + 12 | 0;
 i50 = 0 - i53 | 0;
 i5 = (HEAP32[i49 >> 2] | 0) + i50 | 0;
 HEAP32[i49 >> 2] = i5;
 i51 = i60 + 16 | 0;
 i4 = HEAP32[i51 >> 2] | 0;
 i7 = i60 + 8 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 if (i5 >>> 0 < i4 >>> 0) {
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  i4 = HEAP32[i6 + 16 >> 2] | 0;
  i3 = HEAP32[i6 + 12 >> 2] | 0;
  i44 = i60 + 4 | 0;
  i43 = HEAP32[(HEAP32[i44 >> 2] | 0) + 28 >> 2] | 0;
  i5 = i4 + (Math_imul(i43, i3 + -1 | 0) | 0) | 0;
  HEAP32[i49 >> 2] = i5;
  HEAP32[i51 >> 2] = i4;
  i3 = i4 + (Math_imul(i43, i3) | 0) | 0;
  HEAP32[i60 + 20 >> 2] = i3;
 } else {
  i44 = i60 + 4 | 0;
  i3 = HEAP32[i60 + 20 >> 2] | 0;
 }
 i16 = i60 + 8 | 0;
 HEAP32[i63 + 16 >> 2] = i6;
 HEAP32[i63 + 20 >> 2] = i5;
 HEAP32[i63 + 24 >> 2] = i4;
 i17 = i60 + 20 | 0;
 HEAP32[i63 + 28 >> 2] = i3;
 i18 = i64 + 12 | 0;
 i19 = i59 + 12 | 0;
 i20 = i59 + 20 | 0;
 i21 = i59 + 8 | 0;
 i12 = i59 + 4 | 0;
 i22 = i59 + 16 | 0;
 i23 = (i53 | 0) > 0;
 i13 = i57 + 4 | 0;
 i24 = i62 + 12 | 0;
 i25 = i62 + 16 | 0;
 i26 = i62 + 8 | 0;
 i27 = i62 + 4 | 0;
 i28 = i62 + 20 | 0;
 i29 = i64 + 20 | 0;
 i30 = i65 + 12 | 0;
 i31 = i65 + 20 | 0;
 i32 = i65 + 8 | 0;
 i15 = i65 + 4 | 0;
 i33 = i65 + 16 | 0;
 i34 = i64 + 8 | 0;
 i14 = i64 + 4 | 0;
 i35 = i64 + 16 | 0;
 i36 = i58 + 8 | 0;
 i37 = i58 + 12 | 0;
 i38 = i58 + 16 | 0;
 i39 = i58 + 20 | 0;
 i40 = i61 + 8 | 0;
 i41 = i61 + 12 | 0;
 i42 = i61 + 16 | 0;
 i43 = i61 + 20 | 0;
 i7 = 0;
 while (1) {
  HEAP32[i45 >> 2] = i2;
  HEAP32[i46 >> 2] = i1;
  HEAP32[i47 >> 2] = i8;
  HEAP32[i48 >> 2] = i9;
  HEAP32[i16 >> 2] = i6;
  HEAP32[i49 >> 2] = i5;
  HEAP32[i51 >> 2] = i4;
  HEAP32[i17 >> 2] = i3;
  i11 = i7 + -1 | 0;
  L18 : while (1) {
   while (1) {
    if ((HEAP32[i45 >> 2] | 0) == (HEAP32[i16 >> 2] | 0)) i7 = (HEAP32[i49 >> 2] | 0) + i53 - (HEAP32[i46 >> 2] | 0) | 0; else {
     i7 = _cvGetSeqReaderPos(i60) | 0;
     i7 = Math_imul(i7 + 1 - (_cvGetSeqReaderPos(i57) | 0) | 0, i53) | 0;
    }
    if ((i7 | 0) <= (i54 | 0)) {
     i66 = 19;
     break L18;
    };
    HEAP32[i64 + 0 >> 2] = HEAP32[i57 + 0 >> 2];
    HEAP32[i64 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
    HEAP32[i64 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
    HEAP32[i64 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
    HEAP32[i64 + 16 >> 2] = HEAP32[i57 + 16 >> 2];
    HEAP32[i64 + 20 >> 2] = HEAP32[i57 + 20 >> 2];
    HEAP32[i64 + 24 >> 2] = HEAP32[i57 + 24 >> 2];
    HEAP32[i64 + 28 >> 2] = HEAP32[i57 + 28 >> 2];
    HEAP32[i58 + 0 >> 2] = HEAP32[i57 + 0 >> 2];
    HEAP32[i58 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
    HEAP32[i58 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
    HEAP32[i58 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
    HEAP32[i58 + 16 >> 2] = HEAP32[i57 + 16 >> 2];
    HEAP32[i58 + 20 >> 2] = HEAP32[i57 + 20 >> 2];
    HEAP32[i58 + 24 >> 2] = HEAP32[i57 + 24 >> 2];
    HEAP32[i58 + 28 >> 2] = HEAP32[i57 + 28 >> 2];
    HEAP32[i62 + 0 >> 2] = HEAP32[i60 + 0 >> 2];
    HEAP32[i62 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
    HEAP32[i62 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
    HEAP32[i62 + 12 >> 2] = HEAP32[i60 + 12 >> 2];
    HEAP32[i62 + 16 >> 2] = HEAP32[i60 + 16 >> 2];
    HEAP32[i62 + 20 >> 2] = HEAP32[i60 + 20 >> 2];
    HEAP32[i62 + 24 >> 2] = HEAP32[i60 + 24 >> 2];
    HEAP32[i62 + 28 >> 2] = HEAP32[i60 + 28 >> 2];
    HEAP32[i61 + 0 >> 2] = HEAP32[i60 + 0 >> 2];
    HEAP32[i61 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
    HEAP32[i61 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
    HEAP32[i61 + 12 >> 2] = HEAP32[i60 + 12 >> 2];
    HEAP32[i61 + 16 >> 2] = HEAP32[i60 + 16 >> 2];
    HEAP32[i61 + 20 >> 2] = HEAP32[i60 + 20 >> 2];
    HEAP32[i61 + 24 >> 2] = HEAP32[i60 + 24 >> 2];
    HEAP32[i61 + 28 >> 2] = HEAP32[i60 + 28 >> 2];
    i9 = (i7 | 0) / (i53 | 0) | 0;
    do if ((i9 | 0) > 40) {
     i8 = (i9 | 0) / 8 | 0;
     i7 = HEAP32[i18 >> 2] | 0;
     _cvSetSeqReaderPos(i64, i8, 1);
     i6 = HEAP32[i18 >> 2] | 0;
     _cvSetSeqReaderPos(i64, i8, 1);
     i5 = HEAP32[i18 >> 2] | 0;
     i10 = (FUNCTION_TABLE_iiii[i56 & 63](i7, i6, i55) | 0) < 0;
     i4 = FUNCTION_TABLE_iiii[i56 & 63](i6, i5, i55) | 0;
     if (i10) if ((i4 | 0) < 0) i3 = i6; else {
      i3 = (FUNCTION_TABLE_iiii[i56 & 63](i7, i5, i55) | 0) < 0;
      i3 = i3 ? i5 : i7;
     } else if ((i4 | 0) > 0) i3 = i6; else {
      i3 = (FUNCTION_TABLE_iiii[i56 & 63](i7, i5, i55) | 0) < 0;
      i3 = i3 ? i7 : i5;
     }
     i2 = (i9 | 0) / 2 | 0;
     i1 = i8 * 3 | 0;
     _cvSetSeqReaderPos(i64, i2 - i1 | 0, 1);
     i7 = HEAP32[i18 >> 2] | 0;
     _cvSetSeqReaderPos(i64, i8, 1);
     i5 = HEAP32[i18 >> 2] | 0;
     _cvSetSeqReaderPos(i64, i8, 1);
     i6 = HEAP32[i18 >> 2] | 0;
     i10 = (FUNCTION_TABLE_iiii[i56 & 63](i7, i5, i55) | 0) < 0;
     i4 = FUNCTION_TABLE_iiii[i56 & 63](i5, i6, i55) | 0;
     if (i10) {
      if ((i4 | 0) >= 0) {
       i5 = (FUNCTION_TABLE_iiii[i56 & 63](i7, i6, i55) | 0) < 0;
       i5 = i5 ? i6 : i7;
      }
     } else if ((i4 | 0) <= 0) {
      i5 = (FUNCTION_TABLE_iiii[i56 & 63](i7, i6, i55) | 0) < 0;
      i5 = i5 ? i7 : i6;
     }
     _cvSetSeqReaderPos(i64, i9 + -1 - i1 - i2 | 0, 1);
     i2 = HEAP32[i18 >> 2] | 0;
     _cvSetSeqReaderPos(i64, i8, 1);
     i6 = HEAP32[i18 >> 2] | 0;
     _cvSetSeqReaderPos(i64, i8, 1);
     i4 = HEAP32[i18 >> 2] | 0;
     i10 = (FUNCTION_TABLE_iiii[i56 & 63](i2, i6, i55) | 0) < 0;
     i7 = FUNCTION_TABLE_iiii[i56 & 63](i6, i4, i55) | 0;
     if (i10) {
      if ((i7 | 0) < 0) break;
      i6 = (FUNCTION_TABLE_iiii[i56 & 63](i2, i4, i55) | 0) < 0;
      i6 = i6 ? i4 : i2;
      break;
     } else {
      if ((i7 | 0) > 0) break;
      i6 = (FUNCTION_TABLE_iiii[i56 & 63](i2, i4, i55) | 0) < 0;
      i6 = i6 ? i2 : i4;
      break;
     }
    } else {
     i3 = HEAP32[i18 >> 2] | 0;
     i6 = (i9 | 0) / 2 | 0;
     _cvSetSeqReaderPos(i64, i6, 1);
     i5 = HEAP32[i18 >> 2] | 0;
     _cvSetSeqReaderPos(i64, i9 + -1 - i6 | 0, 1);
     i6 = HEAP32[i18 >> 2] | 0;
    } while (0);
    i10 = (FUNCTION_TABLE_iiii[i56 & 63](i3, i5, i55) | 0) < 0;
    i7 = FUNCTION_TABLE_iiii[i56 & 63](i5, i6, i55) | 0;
    if (i10) {
     if ((i7 | 0) >= 0) {
      i5 = (FUNCTION_TABLE_iiii[i56 & 63](i3, i6, i55) | 0) < 0;
      i5 = i5 ? i6 : i3;
     }
    } else if ((i7 | 0) <= 0) {
     i5 = (FUNCTION_TABLE_iiii[i56 & 63](i3, i6, i55) | 0) < 0;
     i5 = i5 ? i3 : i6;
    };
    HEAP32[i57 + 0 >> 2] = HEAP32[i58 + 0 >> 2];
    HEAP32[i57 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
    HEAP32[i57 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
    HEAP32[i57 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
    HEAP32[i57 + 16 >> 2] = HEAP32[i58 + 16 >> 2];
    HEAP32[i57 + 20 >> 2] = HEAP32[i58 + 20 >> 2];
    HEAP32[i57 + 24 >> 2] = HEAP32[i58 + 24 >> 2];
    HEAP32[i57 + 28 >> 2] = HEAP32[i58 + 28 >> 2];
    i7 = HEAP32[i46 >> 2] | 0;
    if ((i5 | 0) == (i7 | 0) | i23 ^ 1) i10 = i7; else {
     i6 = 0;
     do {
      i9 = i5 + i6 | 0;
      i10 = HEAP8[i9 >> 0] | 0;
      HEAP8[i9 >> 0] = HEAP8[i7 + i6 >> 0] | 0;
      HEAP8[(HEAP32[i46 >> 2] | 0) + i6 >> 0] = i10;
      i6 = i6 + 1 | 0;
      i7 = HEAP32[i46 >> 2] | 0;
     } while ((i6 | 0) != (i53 | 0));
     i10 = i7;
    }
    i7 = i10 + i53 | 0;
    HEAP32[i46 >> 2] = i7;
    if (i7 >>> 0 >= (HEAP32[i48 >> 2] | 0) >>> 0) {
     i9 = HEAP32[(HEAP32[i45 >> 2] | 0) + 4 >> 2] | 0;
     HEAP32[i45 >> 2] = i9;
     i7 = HEAP32[i9 + 16 >> 2] | 0;
     HEAP32[i46 >> 2] = i7;
     i9 = HEAP32[i9 + 12 >> 2] | 0;
     i8 = HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0;
     HEAP32[i47 >> 2] = i7;
     HEAP32[i48 >> 2] = i7 + (Math_imul(i8, i9) | 0);
    };
    HEAP32[i59 + 0 >> 2] = HEAP32[i57 + 0 >> 2];
    HEAP32[i59 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
    HEAP32[i59 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
    HEAP32[i59 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
    HEAP32[i59 + 16 >> 2] = HEAP32[i57 + 16 >> 2];
    HEAP32[i59 + 20 >> 2] = HEAP32[i57 + 20 >> 2];
    HEAP32[i59 + 24 >> 2] = HEAP32[i57 + 24 >> 2];
    HEAP32[i59 + 28 >> 2] = HEAP32[i57 + 28 >> 2];
    i6 = 0;
    L61 : while (1) {
     if ((i7 | 0) == (HEAP32[i49 >> 2] | 0)) {
      i66 = 88;
      break;
     }
     i7 = FUNCTION_TABLE_iiii[i56 & 63](i7, i10, i55) | 0;
     if ((i7 | 0) < 1) {
      do if (!i7) {
       i7 = HEAP32[i19 >> 2] | 0;
       i6 = HEAP32[i46 >> 2] | 0;
       L68 : do if (!((i7 | 0) == (i6 | 0) | i23 ^ 1)) {
        i5 = 0;
        while (1) {
         i9 = i7 + i5 | 0;
         i7 = HEAP8[i9 >> 0] | 0;
         HEAP8[i9 >> 0] = HEAP8[i6 + i5 >> 0] | 0;
         HEAP8[(HEAP32[i46 >> 2] | 0) + i5 >> 0] = i7;
         i5 = i5 + 1 | 0;
         i7 = HEAP32[i19 >> 2] | 0;
         if ((i5 | 0) == (i53 | 0)) break L68;
         i6 = HEAP32[i46 >> 2] | 0;
        }
       } while (0);
       i9 = i7 + i53 | 0;
       HEAP32[i19 >> 2] = i9;
       if (i9 >>> 0 < (HEAP32[i20 >> 2] | 0) >>> 0) {
        i6 = 1;
        break;
       }
       i6 = HEAP32[(HEAP32[i21 >> 2] | 0) + 4 >> 2] | 0;
       HEAP32[i21 >> 2] = i6;
       i8 = HEAP32[i6 + 16 >> 2] | 0;
       HEAP32[i19 >> 2] = i8;
       i6 = HEAP32[i6 + 12 >> 2] | 0;
       i9 = HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0;
       HEAP32[i22 >> 2] = i8;
       HEAP32[i20 >> 2] = i8 + (Math_imul(i9, i6) | 0);
       i6 = 1;
      } while (0);
      i7 = (HEAP32[i46 >> 2] | 0) + i53 | 0;
      HEAP32[i46 >> 2] = i7;
      if (i7 >>> 0 < (HEAP32[i48 >> 2] | 0) >>> 0) continue;
      i9 = HEAP32[(HEAP32[i45 >> 2] | 0) + 4 >> 2] | 0;
      HEAP32[i45 >> 2] = i9;
      i7 = HEAP32[i9 + 16 >> 2] | 0;
      HEAP32[i46 >> 2] = i7;
      i9 = HEAP32[i9 + 12 >> 2] | 0;
      i8 = HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0;
      HEAP32[i47 >> 2] = i7;
      HEAP32[i48 >> 2] = i7 + (Math_imul(i8, i9) | 0);
      continue;
     }
     i7 = HEAP32[i49 >> 2] | 0;
     if ((HEAP32[i46 >> 2] | 0) == (i7 | 0)) {
      i66 = 88;
      break;
     }
     while (1) {
      i7 = FUNCTION_TABLE_iiii[i56 & 63](i7, i10, i55) | 0;
      if ((i7 | 0) <= -1) break;
      do if (!i7) {
       i7 = HEAP32[i24 >> 2] | 0;
       i6 = HEAP32[i49 >> 2] | 0;
       L82 : do if (!((i7 | 0) == (i6 | 0) | i23 ^ 1)) {
        i5 = 0;
        while (1) {
         i9 = i7 + i5 | 0;
         i7 = HEAP8[i9 >> 0] | 0;
         HEAP8[i9 >> 0] = HEAP8[i6 + i5 >> 0] | 0;
         HEAP8[(HEAP32[i49 >> 2] | 0) + i5 >> 0] = i7;
         i5 = i5 + 1 | 0;
         i7 = HEAP32[i24 >> 2] | 0;
         if ((i5 | 0) == (i53 | 0)) break L82;
         i6 = HEAP32[i49 >> 2] | 0;
        }
       } while (0);
       i9 = i7 + i50 | 0;
       HEAP32[i24 >> 2] = i9;
       if (i9 >>> 0 >= (HEAP32[i25 >> 2] | 0) >>> 0) {
        i6 = 1;
        break;
       }
       i6 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
       HEAP32[i26 >> 2] = i6;
       i8 = HEAP32[i6 + 16 >> 2] | 0;
       i6 = HEAP32[i6 + 12 >> 2] | 0;
       i9 = HEAP32[(HEAP32[i27 >> 2] | 0) + 28 >> 2] | 0;
       HEAP32[i24 >> 2] = i8 + (Math_imul(i9, i6 + -1 | 0) | 0);
       HEAP32[i25 >> 2] = i8;
       HEAP32[i28 >> 2] = i8 + (Math_imul(i9, i6) | 0);
       i6 = 1;
      } while (0);
      i7 = (HEAP32[i49 >> 2] | 0) + i50 | 0;
      HEAP32[i49 >> 2] = i7;
      if (i7 >>> 0 < (HEAP32[i51 >> 2] | 0) >>> 0) {
       i9 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
       HEAP32[i16 >> 2] = i9;
       i5 = HEAP32[i9 + 16 >> 2] | 0;
       i9 = HEAP32[i9 + 12 >> 2] | 0;
       i8 = HEAP32[(HEAP32[i44 >> 2] | 0) + 28 >> 2] | 0;
       i7 = i5 + (Math_imul(i8, i9 + -1 | 0) | 0) | 0;
       HEAP32[i49 >> 2] = i7;
       HEAP32[i51 >> 2] = i5;
       HEAP32[i17 >> 2] = i5 + (Math_imul(i8, i9) | 0);
      }
      if ((HEAP32[i46 >> 2] | 0) == (i7 | 0)) {
       i66 = 88;
       break L61;
      }
     }
     i7 = HEAP32[i46 >> 2] | 0;
     i5 = HEAP32[i49 >> 2] | 0;
     if ((i7 | 0) == (i5 | 0)) {
      i7 = i5;
      i66 = 88;
      break;
     }
     L94 : do if (i23) {
      i6 = 0;
      while (1) {
       i9 = i7 + i6 | 0;
       i7 = HEAP8[i9 >> 0] | 0;
       HEAP8[i9 >> 0] = HEAP8[i5 + i6 >> 0] | 0;
       HEAP8[(HEAP32[i49 >> 2] | 0) + i6 >> 0] = i7;
       i6 = i6 + 1 | 0;
       i7 = HEAP32[i46 >> 2] | 0;
       if ((i6 | 0) == (i53 | 0)) break L94;
       i5 = HEAP32[i49 >> 2] | 0;
      }
     } while (0);
     i7 = i7 + i53 | 0;
     HEAP32[i46 >> 2] = i7;
     if (i7 >>> 0 >= (HEAP32[i48 >> 2] | 0) >>> 0) {
      i9 = HEAP32[(HEAP32[i45 >> 2] | 0) + 4 >> 2] | 0;
      HEAP32[i45 >> 2] = i9;
      i7 = HEAP32[i9 + 16 >> 2] | 0;
      HEAP32[i46 >> 2] = i7;
      i9 = HEAP32[i9 + 12 >> 2] | 0;
      i8 = HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0;
      HEAP32[i47 >> 2] = i7;
      HEAP32[i48 >> 2] = i7 + (Math_imul(i8, i9) | 0);
     }
     i6 = HEAP32[i49 >> 2] | 0;
     i9 = i6 + i50 | 0;
     HEAP32[i49 >> 2] = i9;
     if (i9 >>> 0 < (HEAP32[i51 >> 2] | 0) >>> 0) {
      i9 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
      HEAP32[i16 >> 2] = i9;
      i5 = HEAP32[i9 + 16 >> 2] | 0;
      i9 = HEAP32[i9 + 12 >> 2] | 0;
      i8 = HEAP32[(HEAP32[i44 >> 2] | 0) + 28 >> 2] | 0;
      HEAP32[i49 >> 2] = i5 + (Math_imul(i8, i9 + -1 | 0) | 0);
      HEAP32[i51 >> 2] = i5;
      HEAP32[i17 >> 2] = i5 + (Math_imul(i8, i9) | 0);
     }
     if ((i7 | 0) == (i6 | 0)) break; else i6 = 1;
    }
    if ((i66 | 0) == 88) {
     i66 = 0;
     i4 = FUNCTION_TABLE_iiii[i56 & 63](i7, i10, i55) | 0;
     if (!i4) {
      i7 = HEAP32[i19 >> 2] | 0;
      i6 = HEAP32[i46 >> 2] | 0;
      L109 : do if (!((i7 | 0) == (i6 | 0) | i23 ^ 1)) {
       i5 = 0;
       while (1) {
        i10 = i7 + i5 | 0;
        i7 = HEAP8[i10 >> 0] | 0;
        HEAP8[i10 >> 0] = HEAP8[i6 + i5 >> 0] | 0;
        HEAP8[(HEAP32[i46 >> 2] | 0) + i5 >> 0] = i7;
        i5 = i5 + 1 | 0;
        i7 = HEAP32[i19 >> 2] | 0;
        if ((i5 | 0) == (i53 | 0)) break L109;
        i6 = HEAP32[i46 >> 2] | 0;
       }
      } while (0);
      i10 = i7 + i53 | 0;
      HEAP32[i19 >> 2] = i10;
      if (i10 >>> 0 < (HEAP32[i20 >> 2] | 0) >>> 0) i7 = 1; else {
       i7 = HEAP32[(HEAP32[i21 >> 2] | 0) + 4 >> 2] | 0;
       HEAP32[i21 >> 2] = i7;
       i9 = HEAP32[i7 + 16 >> 2] | 0;
       HEAP32[i19 >> 2] = i9;
       i7 = HEAP32[i7 + 12 >> 2] | 0;
       i10 = HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0;
       HEAP32[i22 >> 2] = i9;
       HEAP32[i20 >> 2] = i9 + (Math_imul(i10, i7) | 0);
       i7 = 1;
      }
     } else i7 = i6;
     if ((i4 | 0) < 1) {
      i10 = (HEAP32[i46 >> 2] | 0) + i53 | 0;
      HEAP32[i46 >> 2] = i10;
      if (i10 >>> 0 >= (HEAP32[i48 >> 2] | 0) >>> 0) {
       i10 = HEAP32[(HEAP32[i45 >> 2] | 0) + 4 >> 2] | 0;
       HEAP32[i45 >> 2] = i10;
       i8 = HEAP32[i10 + 16 >> 2] | 0;
       HEAP32[i46 >> 2] = i8;
       i10 = HEAP32[i10 + 12 >> 2] | 0;
       i9 = HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0;
       HEAP32[i47 >> 2] = i8;
       HEAP32[i48 >> 2] = i8 + (Math_imul(i9, i10) | 0);
      }
     } else {
      i10 = (HEAP32[i49 >> 2] | 0) + i50 | 0;
      HEAP32[i49 >> 2] = i10;
      if (i10 >>> 0 < (HEAP32[i51 >> 2] | 0) >>> 0) {
       i10 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
       HEAP32[i16 >> 2] = i10;
       i8 = HEAP32[i10 + 16 >> 2] | 0;
       i10 = HEAP32[i10 + 12 >> 2] | 0;
       i9 = HEAP32[(HEAP32[i44 >> 2] | 0) + 28 >> 2] | 0;
       HEAP32[i49 >> 2] = i8 + (Math_imul(i9, i10 + -1 | 0) | 0);
       HEAP32[i51 >> 2] = i8;
       HEAP32[i17 >> 2] = i8 + (Math_imul(i9, i10) | 0);
      }
     }
     if (!i7) {
      i66 = 107;
      break L18;
     }
    }
    i7 = _cvGetSeqReaderPos(i57) | 0;
    if (!i7) i7 = HEAP32[i52 >> 2] | 0;
    i4 = _cvGetSeqReaderPos(i58) | 0;
    i6 = _cvGetSeqReaderPos(i59) | 0;
    if (!i6) i6 = HEAP32[i52 >> 2] | 0;
    i8 = i7 - i6 | 0;
    i5 = i6 - i4 | 0;
    i5 = (i8 | 0) > (i5 | 0) ? i5 : i8;
    if ((i5 | 0) > 0) {
     HEAP32[i64 + 0 >> 2] = HEAP32[i58 + 0 >> 2];
     HEAP32[i64 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
     HEAP32[i64 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
     HEAP32[i64 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
     HEAP32[i64 + 16 >> 2] = HEAP32[i58 + 16 >> 2];
     HEAP32[i64 + 20 >> 2] = HEAP32[i58 + 20 >> 2];
     HEAP32[i64 + 24 >> 2] = HEAP32[i58 + 24 >> 2];
     HEAP32[i64 + 28 >> 2] = HEAP32[i58 + 28 >> 2];
     HEAP32[i65 + 0 >> 2] = HEAP32[i57 + 0 >> 2];
     HEAP32[i65 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
     HEAP32[i65 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
     HEAP32[i65 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
     HEAP32[i65 + 16 >> 2] = HEAP32[i57 + 16 >> 2];
     HEAP32[i65 + 20 >> 2] = HEAP32[i57 + 20 >> 2];
     HEAP32[i65 + 24 >> 2] = HEAP32[i57 + 24 >> 2];
     HEAP32[i65 + 28 >> 2] = HEAP32[i57 + 28 >> 2];
     _cvSetSeqReaderPos(i65, 0 - i5 | 0, 1);
     i4 = i4 + -1 - i6 | 0;
     i5 = i6 + -1 - i7 | 0;
     i5 = ~((i4 | 0) > (i5 | 0) ? i4 : i5);
     i7 = HEAP32[i18 >> 2] | 0;
     i4 = 0;
     do {
      if (i23) {
       i6 = 0;
       do {
        i10 = i7 + i6 | 0;
        i7 = HEAP8[i10 >> 0] | 0;
        HEAP8[i10 >> 0] = HEAP8[(HEAP32[i30 >> 2] | 0) + i6 >> 0] | 0;
        HEAP8[(HEAP32[i30 >> 2] | 0) + i6 >> 0] = i7;
        i6 = i6 + 1 | 0;
        i7 = HEAP32[i18 >> 2] | 0;
       } while ((i6 | 0) != (i53 | 0));
      }
      i7 = i7 + i53 | 0;
      HEAP32[i18 >> 2] = i7;
      if (i7 >>> 0 >= (HEAP32[i29 >> 2] | 0) >>> 0) {
       i10 = HEAP32[(HEAP32[i34 >> 2] | 0) + 4 >> 2] | 0;
       HEAP32[i34 >> 2] = i10;
       i7 = HEAP32[i10 + 16 >> 2] | 0;
       HEAP32[i18 >> 2] = i7;
       i10 = HEAP32[i10 + 12 >> 2] | 0;
       i9 = HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0;
       HEAP32[i35 >> 2] = i7;
       HEAP32[i29 >> 2] = i7 + (Math_imul(i9, i10) | 0);
      }
      i10 = (HEAP32[i30 >> 2] | 0) + i53 | 0;
      HEAP32[i30 >> 2] = i10;
      if (i10 >>> 0 >= (HEAP32[i31 >> 2] | 0) >>> 0) {
       i10 = HEAP32[(HEAP32[i32 >> 2] | 0) + 4 >> 2] | 0;
       HEAP32[i32 >> 2] = i10;
       i6 = HEAP32[i10 + 16 >> 2] | 0;
       HEAP32[i30 >> 2] = i6;
       i10 = HEAP32[i10 + 12 >> 2] | 0;
       i9 = HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0;
       HEAP32[i33 >> 2] = i6;
       HEAP32[i31 >> 2] = i6 + (Math_imul(i9, i10) | 0);
      }
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i5 | 0));
    }
    i6 = _cvGetSeqReaderPos(i60) | 0;
    i5 = _cvGetSeqReaderPos(i61) | 0;
    i4 = _cvGetSeqReaderPos(i62) | 0;
    i7 = i5 - i4 | 0;
    i9 = i4 - i6 | 0;
    i7 = (i7 | 0) > (i9 | 0) ? i9 : i7;
    if ((i7 | 0) > 0) {
     HEAP32[i64 + 0 >> 2] = HEAP32[i57 + 0 >> 2];
     HEAP32[i64 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
     HEAP32[i64 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
     HEAP32[i64 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
     HEAP32[i64 + 16 >> 2] = HEAP32[i57 + 16 >> 2];
     HEAP32[i64 + 20 >> 2] = HEAP32[i57 + 20 >> 2];
     HEAP32[i64 + 24 >> 2] = HEAP32[i57 + 24 >> 2];
     HEAP32[i64 + 28 >> 2] = HEAP32[i57 + 28 >> 2];
     HEAP32[i65 + 0 >> 2] = HEAP32[i61 + 0 >> 2];
     HEAP32[i65 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
     HEAP32[i65 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
     HEAP32[i65 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
     HEAP32[i65 + 16 >> 2] = HEAP32[i61 + 16 >> 2];
     HEAP32[i65 + 20 >> 2] = HEAP32[i61 + 20 >> 2];
     HEAP32[i65 + 24 >> 2] = HEAP32[i61 + 24 >> 2];
     HEAP32[i65 + 28 >> 2] = HEAP32[i61 + 28 >> 2];
     _cvSetSeqReaderPos(i65, 1 - i7 | 0, 1);
     i7 = i6 + -1 - i4 | 0;
     i5 = i4 + -1 - i5 | 0;
     i5 = ~((i7 | 0) > (i5 | 0) ? i7 : i5);
     i7 = HEAP32[i18 >> 2] | 0;
     i4 = 0;
     do {
      if (i23) {
       i6 = 0;
       do {
        i10 = i7 + i6 | 0;
        i7 = HEAP8[i10 >> 0] | 0;
        HEAP8[i10 >> 0] = HEAP8[(HEAP32[i30 >> 2] | 0) + i6 >> 0] | 0;
        HEAP8[(HEAP32[i30 >> 2] | 0) + i6 >> 0] = i7;
        i6 = i6 + 1 | 0;
        i7 = HEAP32[i18 >> 2] | 0;
       } while ((i6 | 0) != (i53 | 0));
      }
      i7 = i7 + i53 | 0;
      HEAP32[i18 >> 2] = i7;
      if (i7 >>> 0 >= (HEAP32[i29 >> 2] | 0) >>> 0) {
       i10 = HEAP32[(HEAP32[i34 >> 2] | 0) + 4 >> 2] | 0;
       HEAP32[i34 >> 2] = i10;
       i7 = HEAP32[i10 + 16 >> 2] | 0;
       HEAP32[i18 >> 2] = i7;
       i10 = HEAP32[i10 + 12 >> 2] | 0;
       i6 = HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0;
       HEAP32[i35 >> 2] = i7;
       HEAP32[i29 >> 2] = i7 + (Math_imul(i6, i10) | 0);
      }
      i10 = (HEAP32[i30 >> 2] | 0) + i53 | 0;
      HEAP32[i30 >> 2] = i10;
      if (i10 >>> 0 >= (HEAP32[i31 >> 2] | 0) >>> 0) {
       i10 = HEAP32[(HEAP32[i32 >> 2] | 0) + 4 >> 2] | 0;
       HEAP32[i32 >> 2] = i10;
       i3 = HEAP32[i10 + 16 >> 2] | 0;
       HEAP32[i30 >> 2] = i3;
       i10 = HEAP32[i10 + 12 >> 2] | 0;
       i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0;
       HEAP32[i33 >> 2] = i3;
       HEAP32[i31 >> 2] = i3 + (Math_imul(i6, i10) | 0);
      }
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i5 | 0));
    }
    i7 = (i9 | 0) > 1;
    if ((i8 | 0) > 1) {
     if (i7) break;
     HEAP32[i60 + 0 >> 2] = HEAP32[i58 + 0 >> 2];
     HEAP32[i60 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
     HEAP32[i60 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
     HEAP32[i60 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
     HEAP32[i60 + 16 >> 2] = HEAP32[i58 + 16 >> 2];
     HEAP32[i60 + 20 >> 2] = HEAP32[i58 + 20 >> 2];
     HEAP32[i60 + 24 >> 2] = HEAP32[i58 + 24 >> 2];
     HEAP32[i60 + 28 >> 2] = HEAP32[i58 + 28 >> 2];
     HEAP32[i57 + 0 >> 2] = HEAP32[i58 + 0 >> 2];
     HEAP32[i57 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
     HEAP32[i57 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
     HEAP32[i57 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
     HEAP32[i57 + 16 >> 2] = HEAP32[i58 + 16 >> 2];
     HEAP32[i57 + 20 >> 2] = HEAP32[i58 + 20 >> 2];
     HEAP32[i57 + 24 >> 2] = HEAP32[i58 + 24 >> 2];
     HEAP32[i57 + 28 >> 2] = HEAP32[i58 + 28 >> 2];
     _cvSetSeqReaderPos(i60, i8 + -1 | 0, 1);
     continue;
    } else {
     if (!i7) break L18;
     HEAP32[i60 + 0 >> 2] = HEAP32[i61 + 0 >> 2];
     HEAP32[i60 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
     HEAP32[i60 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
     HEAP32[i60 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
     HEAP32[i60 + 16 >> 2] = HEAP32[i61 + 16 >> 2];
     HEAP32[i60 + 20 >> 2] = HEAP32[i61 + 20 >> 2];
     HEAP32[i60 + 24 >> 2] = HEAP32[i61 + 24 >> 2];
     HEAP32[i60 + 28 >> 2] = HEAP32[i61 + 28 >> 2];
     HEAP32[i57 + 0 >> 2] = HEAP32[i61 + 0 >> 2];
     HEAP32[i57 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
     HEAP32[i57 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
     HEAP32[i57 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
     HEAP32[i57 + 16 >> 2] = HEAP32[i61 + 16 >> 2];
     HEAP32[i57 + 20 >> 2] = HEAP32[i61 + 20 >> 2];
     HEAP32[i57 + 24 >> 2] = HEAP32[i61 + 24 >> 2];
     HEAP32[i57 + 28 >> 2] = HEAP32[i61 + 28 >> 2];
     _cvSetSeqReaderPos(i57, 1 - i9 | 0, 1);
     continue;
    }
   }
   i7 = i11 + 1 | 0;
   if ((i8 | 0) > (i9 | 0)) {
    HEAP32[i63 + (i7 << 5) >> 2] = HEAP32[i36 >> 2];
    HEAP32[i63 + (i7 << 5) + 4 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i63 + (i7 << 5) + 8 >> 2] = HEAP32[i38 >> 2];
    HEAP32[i63 + (i7 << 5) + 12 >> 2] = HEAP32[i39 >> 2];
    _cvSetSeqReaderPos(i58, i8 + -1 | 0, 1);
    HEAP32[i63 + (i7 << 5) + 16 >> 2] = HEAP32[i36 >> 2];
    HEAP32[i63 + (i7 << 5) + 20 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i63 + (i7 << 5) + 24 >> 2] = HEAP32[i38 >> 2];
    HEAP32[i63 + (i7 << 5) + 28 >> 2] = HEAP32[i39 >> 2];
    HEAP32[i60 + 0 >> 2] = HEAP32[i61 + 0 >> 2];
    HEAP32[i60 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
    HEAP32[i60 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
    HEAP32[i60 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
    HEAP32[i60 + 16 >> 2] = HEAP32[i61 + 16 >> 2];
    HEAP32[i60 + 20 >> 2] = HEAP32[i61 + 20 >> 2];
    HEAP32[i60 + 24 >> 2] = HEAP32[i61 + 24 >> 2];
    HEAP32[i60 + 28 >> 2] = HEAP32[i61 + 28 >> 2];
    HEAP32[i57 + 0 >> 2] = HEAP32[i61 + 0 >> 2];
    HEAP32[i57 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
    HEAP32[i57 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
    HEAP32[i57 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
    HEAP32[i57 + 16 >> 2] = HEAP32[i61 + 16 >> 2];
    HEAP32[i57 + 20 >> 2] = HEAP32[i61 + 20 >> 2];
    HEAP32[i57 + 24 >> 2] = HEAP32[i61 + 24 >> 2];
    HEAP32[i57 + 28 >> 2] = HEAP32[i61 + 28 >> 2];
    _cvSetSeqReaderPos(i57, 1 - i9 | 0, 1);
    i11 = i7;
    continue;
   } else {
    HEAP32[i63 + (i7 << 5) + 16 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i63 + (i7 << 5) + 20 >> 2] = HEAP32[i41 >> 2];
    HEAP32[i63 + (i7 << 5) + 24 >> 2] = HEAP32[i42 >> 2];
    HEAP32[i63 + (i7 << 5) + 28 >> 2] = HEAP32[i43 >> 2];
    _cvSetSeqReaderPos(i61, 1 - i9 | 0, 1);
    HEAP32[i63 + (i7 << 5) >> 2] = HEAP32[i40 >> 2];
    HEAP32[i63 + (i7 << 5) + 4 >> 2] = HEAP32[i41 >> 2];
    HEAP32[i63 + (i7 << 5) + 8 >> 2] = HEAP32[i42 >> 2];
    HEAP32[i63 + (i7 << 5) + 12 >> 2] = HEAP32[i43 >> 2];
    HEAP32[i60 + 0 >> 2] = HEAP32[i58 + 0 >> 2];
    HEAP32[i60 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
    HEAP32[i60 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
    HEAP32[i60 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
    HEAP32[i60 + 16 >> 2] = HEAP32[i58 + 16 >> 2];
    HEAP32[i60 + 20 >> 2] = HEAP32[i58 + 20 >> 2];
    HEAP32[i60 + 24 >> 2] = HEAP32[i58 + 24 >> 2];
    HEAP32[i60 + 28 >> 2] = HEAP32[i58 + 28 >> 2];
    HEAP32[i57 + 0 >> 2] = HEAP32[i58 + 0 >> 2];
    HEAP32[i57 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
    HEAP32[i57 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
    HEAP32[i57 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
    HEAP32[i57 + 16 >> 2] = HEAP32[i58 + 16 >> 2];
    HEAP32[i57 + 20 >> 2] = HEAP32[i58 + 20 >> 2];
    HEAP32[i57 + 24 >> 2] = HEAP32[i58 + 24 >> 2];
    HEAP32[i57 + 28 >> 2] = HEAP32[i58 + 28 >> 2];
    _cvSetSeqReaderPos(i60, i8 + -1 | 0, 1);
    i11 = i7;
    continue;
   }
  }
  if ((i66 | 0) == 107) {
   HEAP32[i57 + 0 >> 2] = HEAP32[i58 + 0 >> 2];
   HEAP32[i57 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
   HEAP32[i57 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
   HEAP32[i57 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
   HEAP32[i57 + 16 >> 2] = HEAP32[i58 + 16 >> 2];
   HEAP32[i57 + 20 >> 2] = HEAP32[i58 + 20 >> 2];
   HEAP32[i57 + 24 >> 2] = HEAP32[i58 + 24 >> 2];
   HEAP32[i57 + 28 >> 2] = HEAP32[i58 + 28 >> 2];
   HEAP32[i60 + 0 >> 2] = HEAP32[i61 + 0 >> 2];
   HEAP32[i60 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
   HEAP32[i60 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
   HEAP32[i60 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
   HEAP32[i60 + 16 >> 2] = HEAP32[i61 + 16 >> 2];
   HEAP32[i60 + 20 >> 2] = HEAP32[i61 + 20 >> 2];
   HEAP32[i60 + 24 >> 2] = HEAP32[i61 + 24 >> 2];
   HEAP32[i60 + 28 >> 2] = HEAP32[i61 + 28 >> 2];
   i66 = 19;
  }
  L170 : do if ((i66 | 0) == 19) {
   i66 = 0;
   i3 = HEAP32[i13 >> 2] | 0;
   i4 = HEAP32[i45 >> 2] | 0;
   i5 = HEAP32[i47 >> 2] | 0;
   i7 = HEAP32[i48 >> 2] | 0;
   i6 = (HEAP32[i46 >> 2] | 0) + i53 | 0;
   if (i6 >>> 0 < i7 >>> 0) {
    i2 = i5;
    i1 = i4;
   } else {
    i1 = HEAP32[i4 + 4 >> 2] | 0;
    i6 = HEAP32[i1 + 16 >> 2] | 0;
    i7 = i6 + (Math_imul(HEAP32[i3 + 28 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0) | 0) | 0;
    i2 = i6;
   }
   i10 = (HEAP32[i49 >> 2] | 0) + i53 | 0;
   HEAP32[i49 >> 2] = i10;
   if (i10 >>> 0 >= (HEAP32[i17 >> 2] | 0) >>> 0) {
    i10 = HEAP32[(HEAP32[i16 >> 2] | 0) + 4 >> 2] | 0;
    HEAP32[i16 >> 2] = i10;
    i8 = HEAP32[i10 + 16 >> 2] | 0;
    HEAP32[i49 >> 2] = i8;
    i10 = HEAP32[i10 + 12 >> 2] | 0;
    i9 = HEAP32[(HEAP32[i44 >> 2] | 0) + 28 >> 2] | 0;
    HEAP32[i51 >> 2] = i8;
    HEAP32[i17 >> 2] = i8 + (Math_imul(i9, i10) | 0);
   }
   i10 = i3 + 28 | 0;
   i8 = i1;
   while (1) {
    do {
     if ((i6 | 0) == (HEAP32[i49 >> 2] | 0)) break L170;
     i5 = (i4 | 0) == (i8 | 0) ? i5 : i2;
     L183 : do if ((i6 | 0) == (HEAP32[i46 >> 2] | 0)) i4 = i8; else {
      if (i23) {
       i9 = i6;
       i4 = i8;
      } else {
       i1 = i6;
       i4 = i8;
       while (1) {
        i3 = i1 + i50 | 0;
        if (i3 >>> 0 < i5 >>> 0) {
         i4 = HEAP32[i4 >> 2] | 0;
         i5 = HEAP32[i4 + 16 >> 2] | 0;
         i3 = i5 + (Math_imul(HEAP32[i10 >> 2] | 0, (HEAP32[i4 + 12 >> 2] | 0) + -1 | 0) | 0) | 0;
        }
        i9 = (FUNCTION_TABLE_iiii[i56 & 63](i3, i1, i55) | 0) < 1;
        if (i9 | (i3 | 0) == (HEAP32[i46 >> 2] | 0)) break L183; else i1 = i3;
       }
      }
      while (1) {
       i3 = i9 + i50 | 0;
       if (i3 >>> 0 < i5 >>> 0) {
        i4 = HEAP32[i4 >> 2] | 0;
        i5 = HEAP32[i4 + 16 >> 2] | 0;
        i3 = i5 + (Math_imul(HEAP32[i10 >> 2] | 0, (HEAP32[i4 + 12 >> 2] | 0) + -1 | 0) | 0) | 0;
       }
       if ((FUNCTION_TABLE_iiii[i56 & 63](i3, i9, i55) | 0) < 1) break L183; else i1 = 0;
       do {
        i70 = i3 + i1 | 0;
        i69 = HEAP8[i70 >> 0] | 0;
        i68 = i9 + i1 | 0;
        HEAP8[i70 >> 0] = HEAP8[i68 >> 0] | 0;
        HEAP8[i68 >> 0] = i69;
        i1 = i1 + 1 | 0;
       } while ((i1 | 0) != (i53 | 0));
       if ((i3 | 0) == (HEAP32[i46 >> 2] | 0)) break; else i9 = i3;
      }
     } while (0);
     i6 = i6 + i53 | 0;
    } while (i6 >>> 0 < i7 >>> 0);
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    i6 = HEAP32[i9 + 16 >> 2] | 0;
    i7 = i6 + (Math_imul(HEAP32[i10 >> 2] | 0, HEAP32[i9 + 12 >> 2] | 0) | 0) | 0;
    i2 = i6;
    i8 = i9;
   }
  } while (0);
  if ((i11 | 0) <= -1) break;
  i2 = HEAP32[i63 + (i11 << 5) >> 2] | 0;
  i1 = HEAP32[i63 + (i11 << 5) + 4 >> 2] | 0;
  i8 = HEAP32[i63 + (i11 << 5) + 8 >> 2] | 0;
  i9 = HEAP32[i63 + (i11 << 5) + 12 >> 2] | 0;
  i6 = HEAP32[i63 + (i11 << 5) + 16 >> 2] | 0;
  i5 = HEAP32[i63 + (i11 << 5) + 20 >> 2] | 0;
  i4 = HEAP32[i63 + (i11 << 5) + 24 >> 2] | 0;
  i3 = HEAP32[i63 + (i11 << 5) + 28 >> 2] | 0;
  i7 = i11;
 }
 STACKTOP = i67;
 return;
}

function _malloc(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i36 = STACKTOP;
 do if (i9 >>> 0 < 245) {
  if (i9 >>> 0 < 11) i14 = 16; else i14 = i9 + 11 & -8;
  i9 = i14 >>> 3;
  i10 = HEAP32[242534] | 0;
  i8 = i10 >>> i9;
  if (i8 & 3) {
   i3 = (i8 & 1 ^ 1) + i9 | 0;
   i4 = i3 << 1;
   i1 = 970176 + (i4 << 2) | 0;
   i4 = 970176 + (i4 + 2 << 2) | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i5 + 8 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   do if ((i1 | 0) != (i7 | 0)) {
    if (i7 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
    i2 = i7 + 12 | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) {
     HEAP32[i2 >> 2] = i1;
     HEAP32[i4 >> 2] = i7;
     break;
    } else _abort();
   } else HEAP32[242534] = i10 & ~(1 << i3); while (0);
   i22 = i3 << 3;
   HEAP32[i5 + 4 >> 2] = i22 | 3;
   i22 = i5 + (i22 | 4) | 0;
   HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | 1;
   i22 = i6;
   STACKTOP = i36;
   return i22 | 0;
  }
  i7 = HEAP32[242536] | 0;
  if (i14 >>> 0 > i7 >>> 0) {
   if (i8) {
    i4 = 2 << i9;
    i4 = i8 << i9 & (i4 | 0 - i4);
    i4 = (i4 & 0 - i4) + -1 | 0;
    i9 = i4 >>> 12 & 16;
    i4 = i4 >>> i9;
    i3 = i4 >>> 5 & 8;
    i4 = i4 >>> i3;
    i2 = i4 >>> 2 & 4;
    i4 = i4 >>> i2;
    i5 = i4 >>> 1 & 2;
    i4 = i4 >>> i5;
    i6 = i4 >>> 1 & 1;
    i6 = (i3 | i9 | i2 | i5 | i6) + (i4 >>> i6) | 0;
    i4 = i6 << 1;
    i5 = 970176 + (i4 << 2) | 0;
    i4 = 970176 + (i4 + 2 << 2) | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    i9 = i2 + 8 | 0;
    i3 = HEAP32[i9 >> 2] | 0;
    do if ((i5 | 0) != (i3 | 0)) {
     if (i3 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
     i7 = i3 + 12 | 0;
     if ((HEAP32[i7 >> 2] | 0) == (i2 | 0)) {
      HEAP32[i7 >> 2] = i5;
      HEAP32[i4 >> 2] = i3;
      i11 = HEAP32[242536] | 0;
      break;
     } else _abort();
    } else {
     HEAP32[242534] = i10 & ~(1 << i6);
     i11 = i7;
    } while (0);
    i22 = i6 << 3;
    i1 = i22 - i14 | 0;
    HEAP32[i2 + 4 >> 2] = i14 | 3;
    i8 = i2 + i14 | 0;
    HEAP32[i2 + (i14 | 4) >> 2] = i1 | 1;
    HEAP32[i2 + i22 >> 2] = i1;
    if (i11) {
     i3 = HEAP32[242539] | 0;
     i5 = i11 >>> 3;
     i7 = i5 << 1;
     i4 = 970176 + (i7 << 2) | 0;
     i6 = HEAP32[242534] | 0;
     i5 = 1 << i5;
     if (i6 & i5) {
      i6 = 970176 + (i7 + 2 << 2) | 0;
      i7 = HEAP32[i6 >> 2] | 0;
      if (i7 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
       i12 = i6;
       i13 = i7;
      }
     } else {
      HEAP32[242534] = i6 | i5;
      i12 = 970176 + (i7 + 2 << 2) | 0;
      i13 = i4;
     }
     HEAP32[i12 >> 2] = i3;
     HEAP32[i13 + 12 >> 2] = i3;
     HEAP32[i3 + 8 >> 2] = i13;
     HEAP32[i3 + 12 >> 2] = i4;
    }
    HEAP32[242536] = i1;
    HEAP32[242539] = i8;
    i22 = i9;
    STACKTOP = i36;
    return i22 | 0;
   }
   i8 = HEAP32[242535] | 0;
   if (i8) {
    i10 = (i8 & 0 - i8) + -1 | 0;
    i21 = i10 >>> 12 & 16;
    i10 = i10 >>> i21;
    i20 = i10 >>> 5 & 8;
    i10 = i10 >>> i20;
    i22 = i10 >>> 2 & 4;
    i10 = i10 >>> i22;
    i7 = i10 >>> 1 & 2;
    i10 = i10 >>> i7;
    i11 = i10 >>> 1 & 1;
    i11 = HEAP32[970440 + ((i20 | i21 | i22 | i7 | i11) + (i10 >>> i11) << 2) >> 2] | 0;
    i10 = (HEAP32[i11 + 4 >> 2] & -8) - i14 | 0;
    i7 = i11;
    while (1) {
     i2 = HEAP32[i7 + 16 >> 2] | 0;
     if (!i2) {
      i2 = HEAP32[i7 + 20 >> 2] | 0;
      if (!i2) break;
     }
     i7 = (HEAP32[i2 + 4 >> 2] & -8) - i14 | 0;
     i22 = i7 >>> 0 < i10 >>> 0;
     i10 = i22 ? i7 : i10;
     i7 = i2;
     i11 = i22 ? i2 : i11;
    }
    i8 = HEAP32[242538] | 0;
    if (i11 >>> 0 < i8 >>> 0) _abort();
    i1 = i11 + i14 | 0;
    if (i11 >>> 0 >= i1 >>> 0) _abort();
    i9 = HEAP32[i11 + 24 >> 2] | 0;
    i5 = HEAP32[i11 + 12 >> 2] | 0;
    do if ((i5 | 0) == (i11 | 0)) {
     i6 = i11 + 20 | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (!i7) {
      i6 = i11 + 16 | 0;
      i7 = HEAP32[i6 >> 2] | 0;
      if (!i7) {
       i3 = 0;
       break;
      }
     }
     while (1) {
      i5 = i7 + 20 | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      if (i4) {
       i7 = i4;
       i6 = i5;
       continue;
      }
      i5 = i7 + 16 | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      if (!i4) break; else {
       i7 = i4;
       i6 = i5;
      }
     }
     if (i6 >>> 0 < i8 >>> 0) _abort(); else {
      HEAP32[i6 >> 2] = 0;
      i3 = i7;
      break;
     }
    } else {
     i4 = HEAP32[i11 + 8 >> 2] | 0;
     if (i4 >>> 0 < i8 >>> 0) _abort();
     i7 = i4 + 12 | 0;
     if ((HEAP32[i7 >> 2] | 0) != (i11 | 0)) _abort();
     i6 = i5 + 8 | 0;
     if ((HEAP32[i6 >> 2] | 0) == (i11 | 0)) {
      HEAP32[i7 >> 2] = i5;
      HEAP32[i6 >> 2] = i4;
      i3 = i5;
      break;
     } else _abort();
    } while (0);
    do if (i9) {
     i7 = HEAP32[i11 + 28 >> 2] | 0;
     i6 = 970440 + (i7 << 2) | 0;
     if ((i11 | 0) == (HEAP32[i6 >> 2] | 0)) {
      HEAP32[i6 >> 2] = i3;
      if (!i3) {
       HEAP32[242535] = HEAP32[242535] & ~(1 << i7);
       break;
      }
     } else {
      if (i9 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
      i7 = i9 + 16 | 0;
      if ((HEAP32[i7 >> 2] | 0) == (i11 | 0)) HEAP32[i7 >> 2] = i3; else HEAP32[i9 + 20 >> 2] = i3;
      if (!i3) break;
     }
     i6 = HEAP32[242538] | 0;
     if (i3 >>> 0 < i6 >>> 0) _abort();
     HEAP32[i3 + 24 >> 2] = i9;
     i7 = HEAP32[i11 + 16 >> 2] | 0;
     do if (i7) if (i7 >>> 0 < i6 >>> 0) _abort(); else {
      HEAP32[i3 + 16 >> 2] = i7;
      HEAP32[i7 + 24 >> 2] = i3;
      break;
     } while (0);
     i7 = HEAP32[i11 + 20 >> 2] | 0;
     if (i7) if (i7 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
      HEAP32[i3 + 20 >> 2] = i7;
      HEAP32[i7 + 24 >> 2] = i3;
      break;
     }
    } while (0);
    if (i10 >>> 0 < 16) {
     i22 = i10 + i14 | 0;
     HEAP32[i11 + 4 >> 2] = i22 | 3;
     i22 = i11 + (i22 + 4) | 0;
     HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | 1;
    } else {
     HEAP32[i11 + 4 >> 2] = i14 | 3;
     HEAP32[i11 + (i14 | 4) >> 2] = i10 | 1;
     HEAP32[i11 + (i10 + i14) >> 2] = i10;
     i2 = HEAP32[242536] | 0;
     if (i2) {
      i3 = HEAP32[242539] | 0;
      i5 = i2 >>> 3;
      i7 = i5 << 1;
      i4 = 970176 + (i7 << 2) | 0;
      i6 = HEAP32[242534] | 0;
      i5 = 1 << i5;
      if (i6 & i5) {
       i7 = 970176 + (i7 + 2 << 2) | 0;
       i6 = HEAP32[i7 >> 2] | 0;
       if (i6 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
        i16 = i7;
        i15 = i6;
       }
      } else {
       HEAP32[242534] = i6 | i5;
       i16 = 970176 + (i7 + 2 << 2) | 0;
       i15 = i4;
      }
      HEAP32[i16 >> 2] = i3;
      HEAP32[i15 + 12 >> 2] = i3;
      HEAP32[i3 + 8 >> 2] = i15;
      HEAP32[i3 + 12 >> 2] = i4;
     }
     HEAP32[242536] = i10;
     HEAP32[242539] = i1;
    }
    i22 = i11 + 8 | 0;
    STACKTOP = i36;
    return i22 | 0;
   }
  }
 } else if (i9 >>> 0 <= 4294967231) {
  i9 = i9 + 11 | 0;
  i14 = i9 & -8;
  i11 = HEAP32[242535] | 0;
  if (i11) {
   i7 = 0 - i14 | 0;
   i9 = i9 >>> 8;
   if (i9) if (i14 >>> 0 > 16777215) i10 = 31; else {
    i15 = (i9 + 1048320 | 0) >>> 16 & 8;
    i16 = i9 << i15;
    i13 = (i16 + 520192 | 0) >>> 16 & 4;
    i16 = i16 << i13;
    i10 = (i16 + 245760 | 0) >>> 16 & 2;
    i10 = 14 - (i13 | i15 | i10) + (i16 << i10 >>> 15) | 0;
    i10 = i14 >>> (i10 + 7 | 0) & 1 | i10 << 1;
   } else i10 = 0;
   i6 = HEAP32[970440 + (i10 << 2) >> 2] | 0;
   L9 : do if (!i6) {
    i9 = 0;
    i8 = 0;
   } else {
    if ((i10 | 0) == 31) i8 = 0; else i8 = 25 - (i10 >>> 1) | 0;
    i4 = i7;
    i9 = 0;
    i3 = i14 << i8;
    i8 = 0;
    while (1) {
     i5 = HEAP32[i6 + 4 >> 2] & -8;
     i7 = i5 - i14 | 0;
     if (i7 >>> 0 < i4 >>> 0) if ((i5 | 0) == (i14 | 0)) {
      i9 = i6;
      i8 = i6;
      break L9;
     } else i8 = i6; else i7 = i4;
     i16 = HEAP32[i6 + 20 >> 2] | 0;
     i6 = HEAP32[i6 + (i3 >>> 31 << 2) + 16 >> 2] | 0;
     i9 = (i16 | 0) == 0 | (i16 | 0) == (i6 | 0) ? i9 : i16;
     if (!i6) break; else {
      i4 = i7;
      i3 = i3 << 1;
     }
    }
   } while (0);
   if ((i9 | 0) == 0 & (i8 | 0) == 0) {
    i9 = 2 << i10;
    i9 = i11 & (i9 | 0 - i9);
    if (!i9) break;
    i16 = (i9 & 0 - i9) + -1 | 0;
    i12 = i16 >>> 12 & 16;
    i16 = i16 >>> i12;
    i11 = i16 >>> 5 & 8;
    i16 = i16 >>> i11;
    i13 = i16 >>> 2 & 4;
    i16 = i16 >>> i13;
    i15 = i16 >>> 1 & 2;
    i16 = i16 >>> i15;
    i9 = i16 >>> 1 & 1;
    i9 = HEAP32[970440 + ((i11 | i12 | i13 | i15 | i9) + (i16 >>> i9) << 2) >> 2] | 0;
   }
   if (!i9) {
    i12 = i7;
    i11 = i8;
   } else while (1) {
    i16 = (HEAP32[i9 + 4 >> 2] & -8) - i14 | 0;
    i6 = i16 >>> 0 < i7 >>> 0;
    i7 = i6 ? i16 : i7;
    i8 = i6 ? i9 : i8;
    i6 = HEAP32[i9 + 16 >> 2] | 0;
    if (i6) {
     i9 = i6;
     continue;
    }
    i9 = HEAP32[i9 + 20 >> 2] | 0;
    if (!i9) {
     i12 = i7;
     i11 = i8;
     break;
    }
   }
   if ((i11 | 0) != 0 ? i12 >>> 0 < ((HEAP32[242536] | 0) - i14 | 0) >>> 0 : 0) {
    i8 = HEAP32[242538] | 0;
    if (i11 >>> 0 < i8 >>> 0) _abort();
    i13 = i11 + i14 | 0;
    if (i11 >>> 0 >= i13 >>> 0) _abort();
    i9 = HEAP32[i11 + 24 >> 2] | 0;
    i5 = HEAP32[i11 + 12 >> 2] | 0;
    do if ((i5 | 0) == (i11 | 0)) {
     i6 = i11 + 20 | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (!i7) {
      i6 = i11 + 16 | 0;
      i7 = HEAP32[i6 >> 2] | 0;
      if (!i7) {
       i1 = 0;
       break;
      }
     }
     while (1) {
      i5 = i7 + 20 | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      if (i4) {
       i7 = i4;
       i6 = i5;
       continue;
      }
      i5 = i7 + 16 | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      if (!i4) break; else {
       i7 = i4;
       i6 = i5;
      }
     }
     if (i6 >>> 0 < i8 >>> 0) _abort(); else {
      HEAP32[i6 >> 2] = 0;
      i1 = i7;
      break;
     }
    } else {
     i4 = HEAP32[i11 + 8 >> 2] | 0;
     if (i4 >>> 0 < i8 >>> 0) _abort();
     i7 = i4 + 12 | 0;
     if ((HEAP32[i7 >> 2] | 0) != (i11 | 0)) _abort();
     i6 = i5 + 8 | 0;
     if ((HEAP32[i6 >> 2] | 0) == (i11 | 0)) {
      HEAP32[i7 >> 2] = i5;
      HEAP32[i6 >> 2] = i4;
      i1 = i5;
      break;
     } else _abort();
    } while (0);
    do if (i9) {
     i7 = HEAP32[i11 + 28 >> 2] | 0;
     i6 = 970440 + (i7 << 2) | 0;
     if ((i11 | 0) == (HEAP32[i6 >> 2] | 0)) {
      HEAP32[i6 >> 2] = i1;
      if (!i1) {
       HEAP32[242535] = HEAP32[242535] & ~(1 << i7);
       break;
      }
     } else {
      if (i9 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
      i7 = i9 + 16 | 0;
      if ((HEAP32[i7 >> 2] | 0) == (i11 | 0)) HEAP32[i7 >> 2] = i1; else HEAP32[i9 + 20 >> 2] = i1;
      if (!i1) break;
     }
     i6 = HEAP32[242538] | 0;
     if (i1 >>> 0 < i6 >>> 0) _abort();
     HEAP32[i1 + 24 >> 2] = i9;
     i7 = HEAP32[i11 + 16 >> 2] | 0;
     do if (i7) if (i7 >>> 0 < i6 >>> 0) _abort(); else {
      HEAP32[i1 + 16 >> 2] = i7;
      HEAP32[i7 + 24 >> 2] = i1;
      break;
     } while (0);
     i7 = HEAP32[i11 + 20 >> 2] | 0;
     if (i7) if (i7 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
      HEAP32[i1 + 20 >> 2] = i7;
      HEAP32[i7 + 24 >> 2] = i1;
      break;
     }
    } while (0);
    L87 : do if (i12 >>> 0 >= 16) {
     HEAP32[i11 + 4 >> 2] = i14 | 3;
     HEAP32[i11 + (i14 | 4) >> 2] = i12 | 1;
     HEAP32[i11 + (i12 + i14) >> 2] = i12;
     i7 = i12 >>> 3;
     if (i12 >>> 0 < 256) {
      i6 = i7 << 1;
      i4 = 970176 + (i6 << 2) | 0;
      i5 = HEAP32[242534] | 0;
      i7 = 1 << i7;
      do if (!(i5 & i7)) {
       HEAP32[242534] = i5 | i7;
       i2 = 970176 + (i6 + 2 << 2) | 0;
       i18 = i4;
      } else {
       i7 = 970176 + (i6 + 2 << 2) | 0;
       i6 = HEAP32[i7 >> 2] | 0;
       if (i6 >>> 0 >= (HEAP32[242538] | 0) >>> 0) {
        i2 = i7;
        i18 = i6;
        break;
       }
       _abort();
      } while (0);
      HEAP32[i2 >> 2] = i13;
      HEAP32[i18 + 12 >> 2] = i13;
      HEAP32[i11 + (i14 + 8) >> 2] = i18;
      HEAP32[i11 + (i14 + 12) >> 2] = i4;
      break;
     }
     i2 = i12 >>> 8;
     if (i2) if (i12 >>> 0 > 16777215) i4 = 31; else {
      i21 = (i2 + 1048320 | 0) >>> 16 & 8;
      i22 = i2 << i21;
      i19 = (i22 + 520192 | 0) >>> 16 & 4;
      i22 = i22 << i19;
      i4 = (i22 + 245760 | 0) >>> 16 & 2;
      i4 = 14 - (i19 | i21 | i4) + (i22 << i4 >>> 15) | 0;
      i4 = i12 >>> (i4 + 7 | 0) & 1 | i4 << 1;
     } else i4 = 0;
     i7 = 970440 + (i4 << 2) | 0;
     HEAP32[i11 + (i14 + 28) >> 2] = i4;
     HEAP32[i11 + (i14 + 20) >> 2] = 0;
     HEAP32[i11 + (i14 + 16) >> 2] = 0;
     i6 = HEAP32[242535] | 0;
     i5 = 1 << i4;
     if (!(i6 & i5)) {
      HEAP32[242535] = i6 | i5;
      HEAP32[i7 >> 2] = i13;
      HEAP32[i11 + (i14 + 24) >> 2] = i7;
      HEAP32[i11 + (i14 + 12) >> 2] = i13;
      HEAP32[i11 + (i14 + 8) >> 2] = i13;
      break;
     }
     i7 = HEAP32[i7 >> 2] | 0;
     if ((i4 | 0) == 31) i2 = 0; else i2 = 25 - (i4 >>> 1) | 0;
     L107 : do if ((HEAP32[i7 + 4 >> 2] & -8 | 0) != (i12 | 0)) {
      i4 = i12 << i2;
      while (1) {
       i5 = i7 + (i4 >>> 31 << 2) + 16 | 0;
       i6 = HEAP32[i5 >> 2] | 0;
       if (!i6) break;
       if ((HEAP32[i6 + 4 >> 2] & -8 | 0) == (i12 | 0)) {
        i20 = i6;
        break L107;
       } else {
        i4 = i4 << 1;
        i7 = i6;
       }
      }
      if (i5 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
       HEAP32[i5 >> 2] = i13;
       HEAP32[i11 + (i14 + 24) >> 2] = i7;
       HEAP32[i11 + (i14 + 12) >> 2] = i13;
       HEAP32[i11 + (i14 + 8) >> 2] = i13;
       break L87;
      }
     } else i20 = i7; while (0);
     i2 = i20 + 8 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     i22 = HEAP32[242538] | 0;
     if (i20 >>> 0 >= i22 >>> 0 & i1 >>> 0 >= i22 >>> 0) {
      HEAP32[i1 + 12 >> 2] = i13;
      HEAP32[i2 >> 2] = i13;
      HEAP32[i11 + (i14 + 8) >> 2] = i1;
      HEAP32[i11 + (i14 + 12) >> 2] = i20;
      HEAP32[i11 + (i14 + 24) >> 2] = 0;
      break;
     } else _abort();
    } else {
     i22 = i12 + i14 | 0;
     HEAP32[i11 + 4 >> 2] = i22 | 3;
     i22 = i11 + (i22 + 4) | 0;
     HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | 1;
    } while (0);
    i22 = i11 + 8 | 0;
    STACKTOP = i36;
    return i22 | 0;
   }
  }
 } else i14 = -1; while (0);
 i8 = HEAP32[242536] | 0;
 if (i8 >>> 0 >= i14 >>> 0) {
  i1 = i8 - i14 | 0;
  i2 = HEAP32[242539] | 0;
  if (i1 >>> 0 > 15) {
   HEAP32[242539] = i2 + i14;
   HEAP32[242536] = i1;
   HEAP32[i2 + (i14 + 4) >> 2] = i1 | 1;
   HEAP32[i2 + i8 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i14 | 3;
  } else {
   HEAP32[242536] = 0;
   HEAP32[242539] = 0;
   HEAP32[i2 + 4 >> 2] = i8 | 3;
   i22 = i2 + (i8 + 4) | 0;
   HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | 1;
  }
  i22 = i2 + 8 | 0;
  STACKTOP = i36;
  return i22 | 0;
 }
 i8 = HEAP32[242537] | 0;
 if (i8 >>> 0 > i14 >>> 0) {
  i21 = i8 - i14 | 0;
  HEAP32[242537] = i21;
  i22 = HEAP32[242540] | 0;
  HEAP32[242540] = i22 + i14;
  HEAP32[i22 + (i14 + 4) >> 2] = i21 | 1;
  HEAP32[i22 + 4 >> 2] = i14 | 3;
  i22 = i22 + 8 | 0;
  STACKTOP = i36;
  return i22 | 0;
 }
 do if (!(HEAP32[242652] | 0)) {
  i8 = _sysconf(30) | 0;
  if (!(i8 + -1 & i8)) {
   HEAP32[242654] = i8;
   HEAP32[242653] = i8;
   HEAP32[242655] = -1;
   HEAP32[242656] = -1;
   HEAP32[242657] = 0;
   HEAP32[242645] = 0;
   HEAP32[242652] = (_time(0) | 0) & -16 ^ 1431655768;
   break;
  } else _abort();
 } while (0);
 i10 = i14 + 48 | 0;
 i5 = HEAP32[242654] | 0;
 i4 = i14 + 47 | 0;
 i6 = i5 + i4 | 0;
 i5 = 0 - i5 | 0;
 i11 = i6 & i5;
 if (i11 >>> 0 <= i14 >>> 0) {
  i22 = 0;
  STACKTOP = i36;
  return i22 | 0;
 }
 i9 = HEAP32[242644] | 0;
 if ((i9 | 0) != 0 ? (i18 = HEAP32[242642] | 0, i20 = i18 + i11 | 0, i20 >>> 0 <= i18 >>> 0 | i20 >>> 0 > i9 >>> 0) : 0) {
  i22 = 0;
  STACKTOP = i36;
  return i22 | 0;
 }
 L266 : do if (!(HEAP32[242645] & 4)) {
  i7 = HEAP32[242540] | 0;
  L268 : do if (i7) {
   i9 = 970584 | 0;
   while (1) {
    i8 = HEAP32[i9 >> 2] | 0;
    if (i8 >>> 0 <= i7 >>> 0 ? (i17 = i9 + 4 | 0, (i8 + (HEAP32[i17 >> 2] | 0) | 0) >>> 0 > i7 >>> 0) : 0) break;
    i9 = HEAP32[i9 + 8 >> 2] | 0;
    if (!i9) {
     i25 = 181;
     break L268;
    }
   }
   if (i9) {
    i8 = i6 - (HEAP32[242537] | 0) & i5;
    if (i8 >>> 0 < 2147483647) {
     i7 = _sbrk(i8 | 0) | 0;
     if ((i7 | 0) == ((HEAP32[i9 >> 2] | 0) + (HEAP32[i17 >> 2] | 0) | 0)) i25 = 190; else i25 = 191;
    } else i8 = 0;
   } else i25 = 181;
  } else i25 = 181; while (0);
  do if ((i25 | 0) == 181) {
   i7 = _sbrk(0) | 0;
   if ((i7 | 0) != (-1 | 0)) {
    i9 = i7;
    i8 = HEAP32[242653] | 0;
    i6 = i8 + -1 | 0;
    if (!(i6 & i9)) i8 = i11; else i8 = i11 - i9 + (i6 + i9 & 0 - i8) | 0;
    i9 = HEAP32[242642] | 0;
    i6 = i9 + i8 | 0;
    if (i8 >>> 0 > i14 >>> 0 & i8 >>> 0 < 2147483647) {
     i20 = HEAP32[242644] | 0;
     if ((i20 | 0) != 0 ? i6 >>> 0 <= i9 >>> 0 | i6 >>> 0 > i20 >>> 0 : 0) {
      i8 = 0;
      break;
     }
     i6 = _sbrk(i8 | 0) | 0;
     if ((i6 | 0) == (i7 | 0)) i25 = 190; else {
      i7 = i6;
      i25 = 191;
     }
    } else i8 = 0;
   } else i8 = 0;
  } while (0);
  L288 : do if ((i25 | 0) == 190) {
   if ((i7 | 0) != (-1 | 0)) {
    i21 = i7;
    i17 = i8;
    i25 = 201;
    break L266;
   }
  } else if ((i25 | 0) == 191) {
   i6 = 0 - i8 | 0;
   do if ((i7 | 0) != (-1 | 0) & i8 >>> 0 < 2147483647 & i10 >>> 0 > i8 >>> 0 ? (i19 = HEAP32[242654] | 0, i19 = i4 - i8 + i19 & 0 - i19, i19 >>> 0 < 2147483647) : 0) if ((_sbrk(i19 | 0) | 0) == (-1 | 0)) {
    _sbrk(i6 | 0) | 0;
    i8 = 0;
    break L288;
   } else {
    i8 = i19 + i8 | 0;
    break;
   } while (0);
   if ((i7 | 0) == (-1 | 0)) i8 = 0; else {
    i21 = i7;
    i17 = i8;
    i25 = 201;
    break L266;
   }
  } while (0);
  HEAP32[242645] = HEAP32[242645] | 4;
  i25 = 198;
 } else {
  i8 = 0;
  i25 = 198;
 } while (0);
 if ((((i25 | 0) == 198 ? i11 >>> 0 < 2147483647 : 0) ? (i21 = _sbrk(i11 | 0) | 0, i22 = _sbrk(0) | 0, (i21 | 0) != (-1 | 0) & (i22 | 0) != (-1 | 0) & i21 >>> 0 < i22 >>> 0) : 0) ? (i23 = i22 - i21 | 0, i24 = i23 >>> 0 > (i14 + 40 | 0) >>> 0, i24) : 0) {
  i17 = i24 ? i23 : i8;
  i25 = 201;
 }
 if ((i25 | 0) == 201) {
  i7 = (HEAP32[242642] | 0) + i17 | 0;
  HEAP32[242642] = i7;
  if (i7 >>> 0 > (HEAP32[242643] | 0) >>> 0) HEAP32[242643] = i7;
  i13 = HEAP32[242540] | 0;
  L308 : do if (i13) {
   i4 = 970584 | 0;
   while (1) {
    i8 = HEAP32[i4 >> 2] | 0;
    i7 = i4 + 4 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    if ((i21 | 0) == (i8 + i6 | 0)) {
     i25 = 213;
     break;
    }
    i5 = HEAP32[i4 + 8 >> 2] | 0;
    if (!i5) break; else i4 = i5;
   }
   if (((i25 | 0) == 213 ? (HEAP32[i4 + 12 >> 2] & 8 | 0) == 0 : 0) ? i13 >>> 0 >= i8 >>> 0 & i13 >>> 0 < i21 >>> 0 : 0) {
    HEAP32[i7 >> 2] = i6 + i17;
    i1 = (HEAP32[242537] | 0) + i17 | 0;
    i2 = i13 + 8 | 0;
    if (!(i2 & 7)) i2 = 0; else i2 = 0 - i2 & 7;
    i22 = i1 - i2 | 0;
    HEAP32[242540] = i13 + i2;
    HEAP32[242537] = i22;
    HEAP32[i13 + (i2 + 4) >> 2] = i22 | 1;
    HEAP32[i13 + (i1 + 4) >> 2] = 40;
    HEAP32[242541] = HEAP32[242656];
    break;
   }
   i8 = HEAP32[242538] | 0;
   if (i21 >>> 0 < i8 >>> 0) {
    HEAP32[242538] = i21;
    i8 = i21;
   }
   i7 = i21 + i17 | 0;
   i5 = 970584 | 0;
   while (1) {
    if ((HEAP32[i5 >> 2] | 0) == (i7 | 0)) {
     i25 = 223;
     break;
    }
    i6 = HEAP32[i5 + 8 >> 2] | 0;
    if (!i6) break; else i5 = i6;
   }
   if ((i25 | 0) == 223 ? (HEAP32[i5 + 12 >> 2] & 8 | 0) == 0 : 0) {
    HEAP32[i5 >> 2] = i21;
    i7 = i5 + 4 | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i17;
    i7 = i21 + 8 | 0;
    if (!(i7 & 7)) i16 = 0; else i16 = 0 - i7 & 7;
    i7 = i21 + (i17 + 8) | 0;
    if (!(i7 & 7)) i1 = 0; else i1 = 0 - i7 & 7;
    i7 = i21 + (i1 + i17) | 0;
    i12 = i16 + i14 | 0;
    i15 = i21 + i12 | 0;
    i10 = i7 - (i21 + i16) - i14 | 0;
    HEAP32[i21 + (i16 + 4) >> 2] = i14 | 3;
    L335 : do if ((i7 | 0) != (i13 | 0)) {
     if ((i7 | 0) == (HEAP32[242539] | 0)) {
      i22 = (HEAP32[242536] | 0) + i10 | 0;
      HEAP32[242536] = i22;
      HEAP32[242539] = i15;
      HEAP32[i21 + (i12 + 4) >> 2] = i22 | 1;
      HEAP32[i21 + (i22 + i12) >> 2] = i22;
      break;
     }
     i2 = i17 + 4 | 0;
     i6 = HEAP32[i21 + (i2 + i1) >> 2] | 0;
     if ((i6 & 3 | 0) == 1) {
      i11 = i6 & -8;
      i3 = i6 >>> 3;
      L343 : do if (i6 >>> 0 >= 256) {
       i9 = HEAP32[i21 + ((i1 | 24) + i17) >> 2] | 0;
       i5 = HEAP32[i21 + (i17 + 12 + i1) >> 2] | 0;
       do if ((i5 | 0) == (i7 | 0)) {
        i5 = i1 | 16;
        i4 = i21 + (i2 + i5) | 0;
        i6 = HEAP32[i4 >> 2] | 0;
        if (!i6) {
         i5 = i21 + (i5 + i17) | 0;
         i6 = HEAP32[i5 >> 2] | 0;
         if (!i6) {
          i32 = 0;
          break;
         }
        } else i5 = i4;
        while (1) {
         i4 = i6 + 20 | 0;
         i3 = HEAP32[i4 >> 2] | 0;
         if (i3) {
          i6 = i3;
          i5 = i4;
          continue;
         }
         i4 = i6 + 16 | 0;
         i3 = HEAP32[i4 >> 2] | 0;
         if (!i3) break; else {
          i6 = i3;
          i5 = i4;
         }
        }
        if (i5 >>> 0 < i8 >>> 0) _abort(); else {
         HEAP32[i5 >> 2] = 0;
         i32 = i6;
         break;
        }
       } else {
        i4 = HEAP32[i21 + ((i1 | 8) + i17) >> 2] | 0;
        if (i4 >>> 0 < i8 >>> 0) _abort();
        i8 = i4 + 12 | 0;
        if ((HEAP32[i8 >> 2] | 0) != (i7 | 0)) _abort();
        i6 = i5 + 8 | 0;
        if ((HEAP32[i6 >> 2] | 0) == (i7 | 0)) {
         HEAP32[i8 >> 2] = i5;
         HEAP32[i6 >> 2] = i4;
         i32 = i5;
         break;
        } else _abort();
       } while (0);
       if (!i9) break;
       i8 = HEAP32[i21 + (i17 + 28 + i1) >> 2] | 0;
       i6 = 970440 + (i8 << 2) | 0;
       do if ((i7 | 0) != (HEAP32[i6 >> 2] | 0)) {
        if (i9 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
        i8 = i9 + 16 | 0;
        if ((HEAP32[i8 >> 2] | 0) == (i7 | 0)) HEAP32[i8 >> 2] = i32; else HEAP32[i9 + 20 >> 2] = i32;
        if (!i32) break L343;
       } else {
        HEAP32[i6 >> 2] = i32;
        if (i32) break;
        HEAP32[242535] = HEAP32[242535] & ~(1 << i8);
        break L343;
       } while (0);
       i6 = HEAP32[242538] | 0;
       if (i32 >>> 0 < i6 >>> 0) _abort();
       HEAP32[i32 + 24 >> 2] = i9;
       i8 = i1 | 16;
       i7 = HEAP32[i21 + (i8 + i17) >> 2] | 0;
       do if (i7) if (i7 >>> 0 < i6 >>> 0) _abort(); else {
        HEAP32[i32 + 16 >> 2] = i7;
        HEAP32[i7 + 24 >> 2] = i32;
        break;
       } while (0);
       i7 = HEAP32[i21 + (i2 + i8) >> 2] | 0;
       if (!i7) break;
       if (i7 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
        HEAP32[i32 + 20 >> 2] = i7;
        HEAP32[i7 + 24 >> 2] = i32;
        break;
       }
      } else {
       i5 = HEAP32[i21 + ((i1 | 8) + i17) >> 2] | 0;
       i4 = HEAP32[i21 + (i17 + 12 + i1) >> 2] | 0;
       i6 = 970176 + (i3 << 1 << 2) | 0;
       do if ((i5 | 0) != (i6 | 0)) {
        if (i5 >>> 0 < i8 >>> 0) _abort();
        if ((HEAP32[i5 + 12 >> 2] | 0) == (i7 | 0)) break;
        _abort();
       } while (0);
       if ((i4 | 0) == (i5 | 0)) {
        HEAP32[242534] = HEAP32[242534] & ~(1 << i3);
        break;
       }
       do if ((i4 | 0) == (i6 | 0)) i28 = i4 + 8 | 0; else {
        if (i4 >>> 0 < i8 >>> 0) _abort();
        i8 = i4 + 8 | 0;
        if ((HEAP32[i8 >> 2] | 0) == (i7 | 0)) {
         i28 = i8;
         break;
        }
        _abort();
       } while (0);
       HEAP32[i5 + 12 >> 2] = i4;
       HEAP32[i28 >> 2] = i5;
      } while (0);
      i7 = i21 + ((i11 | i1) + i17) | 0;
      i8 = i11 + i10 | 0;
     } else i8 = i10;
     i7 = i7 + 4 | 0;
     HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & -2;
     HEAP32[i21 + (i12 + 4) >> 2] = i8 | 1;
     HEAP32[i21 + (i8 + i12) >> 2] = i8;
     i7 = i8 >>> 3;
     if (i8 >>> 0 < 256) {
      i6 = i7 << 1;
      i4 = 970176 + (i6 << 2) | 0;
      i5 = HEAP32[242534] | 0;
      i7 = 1 << i7;
      do if (!(i5 & i7)) {
       HEAP32[242534] = i5 | i7;
       i33 = 970176 + (i6 + 2 << 2) | 0;
       i34 = i4;
      } else {
       i7 = 970176 + (i6 + 2 << 2) | 0;
       i6 = HEAP32[i7 >> 2] | 0;
       if (i6 >>> 0 >= (HEAP32[242538] | 0) >>> 0) {
        i33 = i7;
        i34 = i6;
        break;
       }
       _abort();
      } while (0);
      HEAP32[i33 >> 2] = i15;
      HEAP32[i34 + 12 >> 2] = i15;
      HEAP32[i21 + (i12 + 8) >> 2] = i34;
      HEAP32[i21 + (i12 + 12) >> 2] = i4;
      break;
     }
     i2 = i8 >>> 8;
     do if (!i2) i4 = 0; else {
      if (i8 >>> 0 > 16777215) {
       i4 = 31;
       break;
      }
      i20 = (i2 + 1048320 | 0) >>> 16 & 8;
      i22 = i2 << i20;
      i19 = (i22 + 520192 | 0) >>> 16 & 4;
      i22 = i22 << i19;
      i4 = (i22 + 245760 | 0) >>> 16 & 2;
      i4 = 14 - (i19 | i20 | i4) + (i22 << i4 >>> 15) | 0;
      i4 = i8 >>> (i4 + 7 | 0) & 1 | i4 << 1;
     } while (0);
     i7 = 970440 + (i4 << 2) | 0;
     HEAP32[i21 + (i12 + 28) >> 2] = i4;
     HEAP32[i21 + (i12 + 20) >> 2] = 0;
     HEAP32[i21 + (i12 + 16) >> 2] = 0;
     i6 = HEAP32[242535] | 0;
     i5 = 1 << i4;
     if (!(i6 & i5)) {
      HEAP32[242535] = i6 | i5;
      HEAP32[i7 >> 2] = i15;
      HEAP32[i21 + (i12 + 24) >> 2] = i7;
      HEAP32[i21 + (i12 + 12) >> 2] = i15;
      HEAP32[i21 + (i12 + 8) >> 2] = i15;
      break;
     }
     i6 = HEAP32[i7 >> 2] | 0;
     if ((i4 | 0) == 31) i7 = 0; else i7 = 25 - (i4 >>> 1) | 0;
     L432 : do if ((HEAP32[i6 + 4 >> 2] & -8 | 0) != (i8 | 0)) {
      i4 = i8 << i7;
      while (1) {
       i5 = i6 + (i4 >>> 31 << 2) + 16 | 0;
       i7 = HEAP32[i5 >> 2] | 0;
       if (!i7) break;
       if ((HEAP32[i7 + 4 >> 2] & -8 | 0) == (i8 | 0)) {
        i35 = i7;
        break L432;
       } else {
        i4 = i4 << 1;
        i6 = i7;
       }
      }
      if (i5 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
       HEAP32[i5 >> 2] = i15;
       HEAP32[i21 + (i12 + 24) >> 2] = i6;
       HEAP32[i21 + (i12 + 12) >> 2] = i15;
       HEAP32[i21 + (i12 + 8) >> 2] = i15;
       break L335;
      }
     } else i35 = i6; while (0);
     i2 = i35 + 8 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     i22 = HEAP32[242538] | 0;
     if (i35 >>> 0 >= i22 >>> 0 & i1 >>> 0 >= i22 >>> 0) {
      HEAP32[i1 + 12 >> 2] = i15;
      HEAP32[i2 >> 2] = i15;
      HEAP32[i21 + (i12 + 8) >> 2] = i1;
      HEAP32[i21 + (i12 + 12) >> 2] = i35;
      HEAP32[i21 + (i12 + 24) >> 2] = 0;
      break;
     } else _abort();
    } else {
     i22 = (HEAP32[242537] | 0) + i10 | 0;
     HEAP32[242537] = i22;
     HEAP32[242540] = i15;
     HEAP32[i21 + (i12 + 4) >> 2] = i22 | 1;
    } while (0);
    i22 = i21 + (i16 | 8) | 0;
    STACKTOP = i36;
    return i22 | 0;
   }
   i7 = 970584 | 0;
   while (1) {
    i6 = HEAP32[i7 >> 2] | 0;
    if (i6 >>> 0 <= i13 >>> 0 ? (i26 = HEAP32[i7 + 4 >> 2] | 0, i27 = i6 + i26 | 0, i27 >>> 0 > i13 >>> 0) : 0) break;
    i7 = HEAP32[i7 + 8 >> 2] | 0;
   }
   i7 = i6 + (i26 + -39) | 0;
   if (!(i7 & 7)) i7 = 0; else i7 = 0 - i7 & 7;
   i5 = i6 + (i26 + -47 + i7) | 0;
   i5 = i5 >>> 0 < (i13 + 16 | 0) >>> 0 ? i13 : i5;
   i6 = i5 + 8 | 0;
   i7 = i21 + 8 | 0;
   if (!(i7 & 7)) i7 = 0; else i7 = 0 - i7 & 7;
   i22 = i17 + -40 - i7 | 0;
   HEAP32[242540] = i21 + i7;
   HEAP32[242537] = i22;
   HEAP32[i21 + (i7 + 4) >> 2] = i22 | 1;
   HEAP32[i21 + (i17 + -36) >> 2] = 40;
   HEAP32[242541] = HEAP32[242656];
   HEAP32[i5 + 4 >> 2] = 27;
   HEAP32[i6 + 0 >> 2] = HEAP32[242646];
   HEAP32[i6 + 4 >> 2] = HEAP32[242647];
   HEAP32[i6 + 8 >> 2] = HEAP32[242648];
   HEAP32[i6 + 12 >> 2] = HEAP32[242649];
   HEAP32[242646] = i21;
   HEAP32[242647] = i17;
   HEAP32[242649] = 0;
   HEAP32[242648] = i6;
   i7 = i5 + 28 | 0;
   HEAP32[i7 >> 2] = 7;
   if ((i5 + 32 | 0) >>> 0 < i27 >>> 0) do {
    i22 = i7;
    i7 = i7 + 4 | 0;
    HEAP32[i7 >> 2] = 7;
   } while ((i22 + 8 | 0) >>> 0 < i27 >>> 0);
   if ((i5 | 0) != (i13 | 0)) {
    i8 = i5 - i13 | 0;
    i7 = i13 + (i8 + 4) | 0;
    HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & -2;
    HEAP32[i13 + 4 >> 2] = i8 | 1;
    HEAP32[i13 + i8 >> 2] = i8;
    i7 = i8 >>> 3;
    if (i8 >>> 0 < 256) {
     i6 = i7 << 1;
     i4 = 970176 + (i6 << 2) | 0;
     i5 = HEAP32[242534] | 0;
     i7 = 1 << i7;
     do if (!(i5 & i7)) {
      HEAP32[242534] = i5 | i7;
      i29 = 970176 + (i6 + 2 << 2) | 0;
      i30 = i4;
     } else {
      i2 = 970176 + (i6 + 2 << 2) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (i1 >>> 0 >= (HEAP32[242538] | 0) >>> 0) {
       i29 = i2;
       i30 = i1;
       break;
      }
      _abort();
     } while (0);
     HEAP32[i29 >> 2] = i13;
     HEAP32[i30 + 12 >> 2] = i13;
     HEAP32[i13 + 8 >> 2] = i30;
     HEAP32[i13 + 12 >> 2] = i4;
     break;
    }
    i2 = i8 >>> 8;
    if (i2) if (i8 >>> 0 > 16777215) i7 = 31; else {
     i21 = (i2 + 1048320 | 0) >>> 16 & 8;
     i22 = i2 << i21;
     i20 = (i22 + 520192 | 0) >>> 16 & 4;
     i22 = i22 << i20;
     i7 = (i22 + 245760 | 0) >>> 16 & 2;
     i7 = 14 - (i20 | i21 | i7) + (i22 << i7 >>> 15) | 0;
     i7 = i8 >>> (i7 + 7 | 0) & 1 | i7 << 1;
    } else i7 = 0;
    i2 = 970440 + (i7 << 2) | 0;
    HEAP32[i13 + 28 >> 2] = i7;
    HEAP32[i13 + 20 >> 2] = 0;
    HEAP32[i13 + 16 >> 2] = 0;
    i1 = HEAP32[242535] | 0;
    i3 = 1 << i7;
    if (!(i1 & i3)) {
     HEAP32[242535] = i1 | i3;
     HEAP32[i2 >> 2] = i13;
     HEAP32[i13 + 24 >> 2] = i2;
     HEAP32[i13 + 12 >> 2] = i13;
     HEAP32[i13 + 8 >> 2] = i13;
     break;
    }
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i7 | 0) == 31) i2 = 0; else i2 = 25 - (i7 >>> 1) | 0;
    L483 : do if ((HEAP32[i3 + 4 >> 2] & -8 | 0) != (i8 | 0)) {
     i7 = i8 << i2;
     while (1) {
      i1 = i3 + (i7 >>> 31 << 2) + 16 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) break;
      if ((HEAP32[i2 + 4 >> 2] & -8 | 0) == (i8 | 0)) {
       i31 = i2;
       break L483;
      } else {
       i7 = i7 << 1;
       i3 = i2;
      }
     }
     if (i1 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
      HEAP32[i1 >> 2] = i13;
      HEAP32[i13 + 24 >> 2] = i3;
      HEAP32[i13 + 12 >> 2] = i13;
      HEAP32[i13 + 8 >> 2] = i13;
      break L308;
     }
    } else i31 = i3; while (0);
    i2 = i31 + 8 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    i22 = HEAP32[242538] | 0;
    if (i31 >>> 0 >= i22 >>> 0 & i1 >>> 0 >= i22 >>> 0) {
     HEAP32[i1 + 12 >> 2] = i13;
     HEAP32[i2 >> 2] = i13;
     HEAP32[i13 + 8 >> 2] = i1;
     HEAP32[i13 + 12 >> 2] = i31;
     HEAP32[i13 + 24 >> 2] = 0;
     break;
    } else _abort();
   }
  } else {
   i22 = HEAP32[242538] | 0;
   if ((i22 | 0) == 0 | i21 >>> 0 < i22 >>> 0) HEAP32[242538] = i21;
   HEAP32[242646] = i21;
   HEAP32[242647] = i17;
   HEAP32[242649] = 0;
   HEAP32[242543] = HEAP32[242652];
   HEAP32[242542] = -1;
   i2 = 0;
   do {
    i22 = i2 << 1;
    i20 = 970176 + (i22 << 2) | 0;
    HEAP32[970176 + (i22 + 3 << 2) >> 2] = i20;
    HEAP32[970176 + (i22 + 2 << 2) >> 2] = i20;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 32);
   i2 = i21 + 8 | 0;
   if (!(i2 & 7)) i2 = 0; else i2 = 0 - i2 & 7;
   i22 = i17 + -40 - i2 | 0;
   HEAP32[242540] = i21 + i2;
   HEAP32[242537] = i22;
   HEAP32[i21 + (i2 + 4) >> 2] = i22 | 1;
   HEAP32[i21 + (i17 + -36) >> 2] = 40;
   HEAP32[242541] = HEAP32[242656];
  } while (0);
  i1 = HEAP32[242537] | 0;
  if (i1 >>> 0 > i14 >>> 0) {
   i21 = i1 - i14 | 0;
   HEAP32[242537] = i21;
   i22 = HEAP32[242540] | 0;
   HEAP32[242540] = i22 + i14;
   HEAP32[i22 + (i14 + 4) >> 2] = i21 | 1;
   HEAP32[i22 + 4 >> 2] = i14 | 3;
   i22 = i22 + 8 | 0;
   STACKTOP = i36;
   return i22 | 0;
  }
 }
 HEAP32[(___errno_location() | 0) >> 2] = 12;
 i22 = 0;
 STACKTOP = i36;
 return i22 | 0;
}

function __ZN2cv5solveERKNS_11_InputArrayES2_RKNS_12_OutputArrayEi(i6, i3, i30, i22) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i30 = i30 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, f4 = Math_fround(0), d5 = 0.0, d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0, d14 = 0.0, d15 = 0.0, d16 = 0.0, d17 = 0.0, d18 = 0.0, d19 = 0.0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, f80 = Math_fround(0), d81 = 0.0, d82 = 0.0, d83 = 0.0;
 i79 = STACKTOP;
 STACKTOP = STACKTOP + 2064 | 0;
 i78 = i79 + 2008 | 0;
 i77 = i79 + 1952 | 0;
 i2 = i79 + 1944 | 0;
 i21 = i79 + 1936 | 0;
 i76 = i79 + 1880 | 0;
 i74 = i79 + 840 | 0;
 i73 = i79 + 784 | 0;
 i29 = i79 + 776 | 0;
 i72 = i79 + 720 | 0;
 i31 = i79 + 696 | 0;
 i32 = i79 + 676 | 0;
 i33 = i79 + 656 | 0;
 i37 = i79 + 600 | 0;
 i38 = i79 + 580 | 0;
 i39 = i79 + 560 | 0;
 i40 = i79 + 540 | 0;
 i41 = i79 + 520 | 0;
 i42 = i79 + 500 | 0;
 i43 = i79 + 480 | 0;
 i45 = i79 + 424 | 0;
 i44 = i79 + 400 | 0;
 i51 = i79 + 344 | 0;
 i46 = i79 + 320 | 0;
 i47 = i79 + 300 | 0;
 i48 = i79 + 280 | 0;
 i50 = i79 + 224 | 0;
 i49 = i79 + 200 | 0;
 i63 = i79 + 144 | 0;
 i62 = i79 + 88 | 0;
 i60 = i79 + 32 | 0;
 i56 = i79;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i6 >> 2] >> 2] & 63](i78, i6, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i3 >> 2] >> 2] & 63](i77, i3, -1);
 i57 = HEAP32[i78 >> 2] | 0;
 i61 = i57 & 4095;
 i6 = i22 >>> 4;
 if (!((i61 + -5 | 0) >>> 0 < 2 ? (i61 | 0) == (HEAP32[i77 >> 2] & 4095 | 0) : 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i35 = (__ZN2cv6String8allocateEj(i2, 58) | 0) + 0 | 0;
  i28 = 4024 | 0;
  i36 = i35 + 58 | 0;
  do {
   HEAP8[i35 >> 0] = HEAP8[i28 >> 0] | 0;
   i35 = i35 + 1 | 0;
   i28 = i28 + 1 | 0;
  } while ((i35 | 0) < (i36 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 4088, 3856, 1199);
  __ZN2cv6String10deallocateEv(i2);
 }
 i20 = i22 & -17;
 if ((i22 | 0) == 0 | (i22 | 0) == 3 | (i22 | 0) == 16 | (i22 | 0) == 19) {
  i6 = i6 & 1;
  i3 = (i6 | 0) == 0;
  if (i3 ? (HEAP32[i78 + 8 >> 2] | 0) != (HEAP32[i78 + 12 >> 2] | 0) : 0) {
   HEAP32[i21 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   i35 = (__ZN2cv6String8allocateEj(i21, 87) | 0) + 0 | 0;
   i28 = 4096 | 0;
   i36 = i35 + 87 | 0;
   do {
    HEAP8[i35 >> 0] = HEAP8[i28 >> 0] | 0;
    i35 = i35 + 1 | 0;
    i28 = i28 + 1 | 0;
   } while ((i35 | 0) < (i36 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i21, 4088, 3856, 1203);
   __ZN2cv6String10deallocateEv(i21);
  }
  if ((i22 | 0) == 0 | (i22 | 0) == 3 | (i22 | 0) == 16 | (i22 | 0) == 19 ? i3 : 0) {
   i21 = i78 + 8 | 0;
   i6 = HEAP32[i21 >> 2] | 0;
   if (((i6 | 0) < 4 ? (i6 | 0) == (HEAP32[i78 + 12 >> 2] | 0) : 0) ? (HEAP32[i77 + 12 >> 2] | 0) == 1 : 0) {
    FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i30 >> 2] | 0) + 140 >> 2] & 63](i30, i6, 1, HEAP32[i78 >> 2] & 4095, -1, 0, 0);
    FUNCTION_TABLE_viii[HEAP32[HEAP32[i30 >> 2] >> 2] & 63](i76, i30, -1);
    i20 = HEAP32[i78 + 16 >> 2] | 0;
    i23 = HEAP32[i77 + 16 >> 2] | 0;
    i24 = i76 + 16 | 0;
    i1 = HEAP32[i24 >> 2] | 0;
    i26 = i76 + 44 | 0;
    i2 = HEAP32[i78 + 48 >> 2] | 0;
    i28 = HEAP32[i77 + 48 >> 2] | 0;
    i25 = i76 + 48 | 0;
    i27 = HEAP32[i25 >> 2] | 0;
    i3 = HEAP32[i21 >> 2] | 0;
    do if ((i3 | 0) == 2) if ((i61 | 0) == 5) {
     d10 = +Math_fround(HEAPF32[i20 >> 2]);
     d9 = +Math_fround(HEAPF32[i20 + (i2 + 4) >> 2]);
     d8 = +Math_fround(HEAPF32[i20 + 4 >> 2]);
     d7 = +Math_fround(HEAPF32[i20 + i2 >> 2]);
     d5 = d10 * d9 - d8 * d7;
     if (!(d5 != 0.0)) {
      i6 = 0;
      break;
     }
     d13 = 1.0 / d5;
     d15 = +Math_fround(HEAPF32[i23 >> 2]);
     d14 = +Math_fround(HEAPF32[i23 + i28 >> 2]);
     f4 = Math_fround(d13 * (d9 * d15 - d8 * d14));
     HEAPF32[i1 + i27 >> 2] = Math_fround(d13 * (d10 * d14 - d7 * d15));
     HEAPF32[i1 >> 2] = f4;
     i6 = 1;
     break;
    } else {
     d8 = +HEAPF64[i20 >> 3];
     d9 = +HEAPF64[i20 + (i2 + 8) >> 3];
     d10 = +HEAPF64[i20 + 8 >> 3];
     d5 = +HEAPF64[i20 + i2 >> 3];
     d7 = d8 * d9 - d10 * d5;
     if (!(d7 != 0.0)) {
      i6 = 0;
      break;
     }
     d13 = 1.0 / d7;
     d14 = +HEAPF64[i23 >> 3];
     d15 = +HEAPF64[i23 + i28 >> 3];
     HEAPF64[i1 + i27 >> 3] = d13 * (d8 * d15 - d5 * d14);
     HEAPF64[i1 >> 3] = d13 * (d9 * d14 - d10 * d15);
     i6 = 1;
     break;
    } else {
     i6 = (i61 | 0) == 5;
     if ((i3 | 0) == 3) if (i6) {
      d12 = +Math_fround(HEAPF32[i20 >> 2]);
      d13 = +Math_fround(HEAPF32[i20 + (i2 + 4) >> 2]);
      i61 = i2 << 1;
      f4 = Math_fround(HEAPF32[i20 + (i61 + 8) >> 2]);
      d14 = +f4;
      d15 = +Math_fround(HEAPF32[i20 + (i2 + 8) >> 2]);
      d16 = +Math_fround(HEAPF32[i20 + (i61 + 4) >> 2]);
      d17 = d13 * d14 - d15 * d16;
      d18 = +Math_fround(HEAPF32[i20 + 4 >> 2]);
      d7 = +Math_fround(HEAPF32[i20 + i2 >> 2]);
      d5 = +Math_fround(HEAPF32[i20 + i61 >> 2]);
      d11 = d14 * d7 - d15 * d5;
      d10 = +Math_fround(HEAPF32[i20 + 8 >> 2]);
      d9 = d16 * d7 - d13 * d5;
      d8 = d10 * d9 + (d12 * d17 - d18 * d11);
      if (!(d8 != 0.0)) {
       i6 = 0;
       break;
      }
      d81 = 1.0 / d8;
      d19 = +Math_fround(HEAPF32[i23 >> 2]);
      f80 = Math_fround(HEAPF32[i23 + i28 >> 2]);
      d8 = +f80;
      d82 = +Math_fround(HEAPF32[i23 + (i28 << 1) >> 2]);
      d15 = d15 * d82;
      d16 = d16 * d8;
      d13 = d13 * d82;
      d7 = d7 * d82 - d5 * d8;
      f80 = Math_fround(d81 * (d10 * d7 + (d12 * (+Math_fround(f4 * f80) - d15) - d11 * d19)));
      f4 = Math_fround(d81 * (d9 * d19 + (d12 * (d13 - d16) - d18 * d7)));
      HEAPF32[i1 >> 2] = Math_fround(d81 * (d10 * (d16 - d13) + (d17 * d19 - d18 * (d14 * d8 - d15))));
      HEAPF32[i1 + i27 >> 2] = f80;
      HEAPF32[i1 + (i27 << 1) >> 2] = f4;
      i6 = 1;
      break;
     } else {
      d18 = +HEAPF64[i20 >> 3];
      d17 = +HEAPF64[i20 + (i2 + 8) >> 3];
      i61 = i2 << 1;
      d16 = +HEAPF64[i20 + (i61 + 16) >> 3];
      d13 = +HEAPF64[i20 + (i2 + 16) >> 3];
      d14 = +HEAPF64[i20 + (i61 + 8) >> 3];
      d15 = d17 * d16 - d13 * d14;
      d19 = +HEAPF64[i20 + 8 >> 3];
      d11 = +HEAPF64[i20 + i2 >> 3];
      d7 = d16 * d11;
      d5 = +HEAPF64[i20 + i61 >> 3];
      d12 = d13 * d5;
      d10 = +HEAPF64[i20 + 16 >> 3];
      d9 = d14 * d11 - d17 * d5;
      d8 = d10 * d9 + (d18 * d15 - d19 * (d7 - d12));
      if (!(d8 != 0.0)) {
       i6 = 0;
       break;
      }
      d83 = 1.0 / d8;
      d8 = +HEAPF64[i23 >> 3];
      d81 = +HEAPF64[i23 + i28 >> 3];
      d82 = +HEAPF64[i23 + (i28 << 1) >> 3];
      HEAPF64[i1 >> 3] = d83 * (d15 * d8 + (d14 * d10 - d16 * d19) * d81 + (d13 * d19 - d17 * d10) * d82);
      HEAPF64[i1 + i27 >> 3] = d83 * ((d12 - d7) * d8 + (d18 * d16 - d5 * d10) * d81 + (d11 * d10 - d18 * d13) * d82);
      HEAPF64[i1 + (i27 << 1) >> 3] = d83 * (d9 * d8 + (d19 * d5 - d18 * d14) * d81 + (d18 * d17 - d19 * d11) * d82);
      i6 = 1;
      break;
     } else if (i6) {
      f4 = Math_fround(HEAPF32[i20 >> 2]);
      if (!(f4 != Math_fround(0.0))) {
       i6 = 0;
       break;
      }
      HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i23 >> 2]) / f4);
      i6 = 1;
      break;
     } else {
      d5 = +HEAPF64[i20 >> 3];
      if (!(d5 != 0.0)) {
       i6 = 0;
       break;
      }
      HEAPF64[i1 >> 3] = +HEAPF64[i23 >> 3] / d5;
      i6 = 1;
      break;
     }
    } while (0);
    i3 = i76 + 36 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if ((i2 | 0) != 0 ? (i60 = i2 + 12 | 0, i61 = HEAP32[i60 >> 2] | 0, HEAP32[i60 >> 2] = i61 + -1, (i61 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i76);
    HEAP32[i3 >> 2] = 0;
    i1 = i76 + 4 | 0;
    HEAP32[i24 + 0 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 0;
    HEAP32[i24 + 8 >> 2] = 0;
    HEAP32[i24 + 12 >> 2] = 0;
    if ((HEAP32[i1 >> 2] | 0) > 0) {
     i3 = HEAP32[i76 + 40 >> 2] | 0;
     i2 = 0;
     do {
      HEAP32[i3 + (i2 << 2) >> 2] = 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
    }
    i3 = HEAP32[i26 >> 2] | 0;
    if ((i3 | 0) != (i25 | 0)) __ZN2cv8fastFreeEPv(i3);
   } else {
    i6 = 0;
    i75 = 38;
   }
  } else i75 = 38;
 } else {
  i6 = i6 & 1;
  i75 = 38;
 }
 do if ((i75 | 0) == 38) {
  i26 = (i20 | 0) == 4 ? 1 : i20;
  i2 = HEAP32[i78 + 8 >> 2] | 0;
  i1 = i78 + 12 | 0;
  i58 = HEAP32[i1 >> 2] | 0;
  i59 = HEAP32[i77 + 12 >> 2] | 0;
  i53 = (i57 >>> 3 & 511) + 1 | 0;
  i54 = i53 << (47696 >>> (i61 << 1 & 14) & 3);
  i34 = Math_imul(i58, i54) | 0;
  i55 = i34 + 15 & -16;
  i3 = (i26 | 0) == 1;
  i24 = (i6 | 0) == 0;
  if (i3 & i24) i25 = (Math_imul(i2, i54) | 0) + 15 & -16; else i25 = i55;
  i70 = i74 + 8 | 0;
  HEAP32[i74 >> 2] = i70;
  i71 = i74 + 4 | 0;
  HEAP32[i71 >> 2] = 1032;
  HEAP32[i76 >> 2] = HEAP32[i77 >> 2];
  i67 = i76 + 4 | 0;
  i28 = i77 + 4 | 0;
  i22 = HEAP32[i28 >> 2] | 0;
  HEAP32[i67 >> 2] = i22;
  i69 = i76 + 8 | 0;
  HEAP32[i69 >> 2] = HEAP32[i77 + 8 >> 2];
  i23 = i76 + 12 | 0;
  HEAP32[i23 >> 2] = i59;
  i64 = i76 + 16 | 0;
  HEAP32[i64 >> 2] = HEAP32[i77 + 16 >> 2];
  HEAP32[i76 + 20 >> 2] = HEAP32[i77 + 20 >> 2];
  HEAP32[i76 + 24 >> 2] = HEAP32[i77 + 24 >> 2];
  HEAP32[i76 + 28 >> 2] = HEAP32[i77 + 28 >> 2];
  HEAP32[i76 + 32 >> 2] = HEAP32[i77 + 32 >> 2];
  i65 = i76 + 36 | 0;
  i27 = HEAP32[i77 + 36 >> 2] | 0;
  HEAP32[i65 >> 2] = i27;
  i66 = i76 + 40 | 0;
  HEAP32[i66 >> 2] = i69;
  i69 = i76 + 48 | 0;
  i68 = i76 + 44 | 0;
  HEAP32[i68 >> 2] = i69;
  HEAP32[i76 + 52 >> 2] = 0;
  HEAP32[i69 >> 2] = 0;
  if (i27) {
   i22 = i27 + 12 | 0;
   HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
   i22 = HEAP32[i28 >> 2] | 0;
  }
  if ((i22 | 0) < 3) {
   i22 = HEAP32[i77 + 44 >> 2] | 0;
   i52 = HEAP32[i68 >> 2] | 0;
   HEAP32[i52 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i52 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  } else {
   HEAP32[i67 >> 2] = 0;
   __ZN2cv3Mat8copySizeERKS0_(i76, i77);
  }
  FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i30 >> 2] | 0) + 140 >> 2] & 63](i30, HEAP32[i1 >> 2] | 0, HEAP32[i23 >> 2] | 0, HEAP32[i78 >> 2] & 4095, -1, 0, 0);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i30 >> 2] >> 2] & 63](i73, i30, -1);
  if ((i2 | 0) < (i58 | 0)) {
   HEAP32[i29 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   i35 = (__ZN2cv6String8allocateEj(i29, 58) | 0) + 0 | 0;
   i28 = 4184 | 0;
   i36 = i35 + 58 | 0;
   do {
    HEAP8[i35 >> 0] = HEAP8[i28 >> 0] | 0;
    i35 = i35 + 1 | 0;
    i28 = i28 + 1 | 0;
   } while ((i35 | 0) < (i36 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i29, 4088, 3856, 1352);
   __ZN2cv6String10deallocateEv(i29);
  }
  do if ((i2 | 0) != (i58 | 0)) if (i24) {
   i22 = Math_imul(i25, i3 ? i58 : i2) | 0;
   i29 = i22;
   i28 = i3;
   i22 = i22 + 32 | 0;
   i27 = 0;
   i52 = i2;
   break;
  } else {
   i22 = Math_imul(i25, i58) | 0;
   i26 = i3 ? 2 : i26;
   i29 = i22;
   i28 = 0;
   i22 = i22 + 32 + (Math_imul(i34, i59) | 0) | 0;
   i27 = 1;
   i52 = i58;
   break;
  } else {
   i22 = Math_imul(i25, i2) | 0;
   i29 = i22;
   i28 = i3;
   i22 = i22 + 32 | 0;
   i27 = 0;
   i52 = i2;
  } while (0);
  i30 = (i26 | 0) == 2;
  if ((i26 + -1 | 0) >>> 0 < 2) i21 = (i59 << 3) + 32 + i22 + (Math_imul(i55 + (i54 * 5 | 0) | 0, i58) | 0) | 0; else i21 = i22;
  if ((HEAP32[i71 >> 2] | 0) >>> 0 < i21 >>> 0) {
   i22 = HEAP32[i74 >> 2] | 0;
   if ((i22 | 0) != (i70 | 0)) {
    if (i22) __ZdaPv(i22);
    HEAP32[i74 >> 2] = i70;
    HEAP32[i71 >> 2] = 1032;
   }
   if (i21 >>> 0 > 1032) {
    i22 = __Znaj(i21) | 0;
    HEAP32[i74 >> 2] = i22;
    HEAP32[i71 >> 2] = i21;
   } else i22 = i70;
  } else {
   HEAP32[i71 >> 2] = i21;
   i22 = HEAP32[i74 >> 2] | 0;
  }
  i23 = i22 + 15 & -16;
  __ZN2cv3MatC2EiiiPvj(i72, i52, i58, i61, i23, i25);
  do if (i27) {
   HEAP32[i31 >> 2] = 32088;
   HEAP32[i31 + 12 >> 2] = 0;
   HEAP32[i31 + 16 >> 2] = 0;
   HEAP32[i31 + 4 >> 2] = 16842752;
   HEAP32[i31 + 8 >> 2] = i78;
   i75 = i32 + 4 | 0;
   HEAP32[i75 + 0 >> 2] = 0;
   HEAP32[i75 + 4 >> 2] = 0;
   HEAP32[i75 + 8 >> 2] = 0;
   HEAP32[i75 + 12 >> 2] = 0;
   HEAP32[i32 >> 2] = 32232;
   HEAP32[i75 >> 2] = 33619968;
   HEAP32[i32 + 8 >> 2] = i72;
   __ZN2cv13mulTransposedERKNS_11_InputArrayERKNS_12_OutputArrayEbS2_di(i31, i32, 1, __ZN2cv7noArrayEv() | 0, 1.0, -1);
   i75 = 75;
  } else {
   if (!i28) {
    i6 = i33 + 4 | 0;
    HEAP32[i6 + 0 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i6 + 8 >> 2] = 0;
    HEAP32[i6 + 12 >> 2] = 0;
    HEAP32[i33 >> 2] = 32232;
    HEAP32[i6 >> 2] = 33619968;
    HEAP32[i33 + 8 >> 2] = i72;
    __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i78, i33);
    i6 = i23 + i29 | 0;
    i75 = 76;
    break;
   }
   __ZN2cv3MatC2EiiiPvj(i37, i58, i52, i61, i23, i25);
   __ZN2cv3MataSERKS0_(i72, i37) | 0;
   i22 = i37 + 36 | 0;
   i21 = HEAP32[i22 >> 2] | 0;
   if ((i21 | 0) != 0 ? (i20 = i21 + 12 | 0, i21 = HEAP32[i20 >> 2] | 0, HEAP32[i20 >> 2] = i21 + -1, (i21 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i37);
   HEAP32[i22 >> 2] = 0;
   i21 = i37 + 16 | 0;
   i22 = i37 + 4 | 0;
   HEAP32[i21 + 0 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   HEAP32[i21 + 8 >> 2] = 0;
   HEAP32[i21 + 12 >> 2] = 0;
   if ((HEAP32[i22 >> 2] | 0) > 0) {
    i21 = HEAP32[i37 + 40 >> 2] | 0;
    i20 = 0;
    do {
     HEAP32[i21 + (i20 << 2) >> 2] = 0;
     i20 = i20 + 1 | 0;
    } while ((i20 | 0) < (HEAP32[i22 >> 2] | 0));
   }
   i22 = HEAP32[i37 + 44 >> 2] | 0;
   if ((i22 | 0) != (i37 + 48 | 0)) __ZN2cv8fastFreeEPv(i22);
   HEAP32[i38 >> 2] = 32088;
   HEAP32[i38 + 12 >> 2] = 0;
   HEAP32[i38 + 16 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 16842752;
   HEAP32[i38 + 8 >> 2] = i78;
   i75 = i39 + 4 | 0;
   HEAP32[i75 + 0 >> 2] = 0;
   HEAP32[i75 + 4 >> 2] = 0;
   HEAP32[i75 + 8 >> 2] = 0;
   HEAP32[i75 + 12 >> 2] = 0;
   HEAP32[i39 >> 2] = 32232;
   HEAP32[i75 >> 2] = 33619968;
   HEAP32[i39 + 8 >> 2] = i72;
   __ZN2cv9transposeERKNS_11_InputArrayERKNS_12_OutputArrayE(i38, i39);
   i75 = 75;
  } while (0);
  do if ((i75 | 0) == 75) {
   i6 = i23 + i29 | 0;
   if (i27) {
    if ((i26 | 0) == 0 | (i26 | 0) == 3) {
     HEAP32[i41 >> 2] = 32088;
     HEAP32[i41 + 12 >> 2] = 0;
     HEAP32[i41 + 16 >> 2] = 0;
     HEAP32[i41 + 4 >> 2] = 16842752;
     HEAP32[i41 + 8 >> 2] = i78;
     HEAP32[i42 >> 2] = 32088;
     HEAP32[i42 + 12 >> 2] = 0;
     HEAP32[i42 + 16 >> 2] = 0;
     HEAP32[i42 + 4 >> 2] = 16842752;
     HEAP32[i42 + 8 >> 2] = i76;
     HEAP32[i45 >> 2] = 1124007936;
     i22 = i45 + 4 | 0;
     i3 = i45 + 8 | 0;
     i20 = i45 + 40 | 0;
     i35 = i22 + 0 | 0;
     i36 = i35 + 36 | 0;
     do {
      HEAP32[i35 >> 2] = 0;
      i35 = i35 + 4 | 0;
     } while ((i35 | 0) < (i36 | 0));
     HEAP32[i20 >> 2] = i3;
     i21 = i45 + 48 | 0;
     i1 = i45 + 44 | 0;
     HEAP32[i1 >> 2] = i21;
     HEAP32[i45 + 52 >> 2] = 0;
     HEAP32[i21 >> 2] = 0;
     HEAP32[i43 >> 2] = 32088;
     HEAP32[i43 + 12 >> 2] = 0;
     HEAP32[i43 + 16 >> 2] = 0;
     HEAP32[i43 + 4 >> 2] = 16842752;
     HEAP32[i43 + 8 >> 2] = i45;
     i3 = i44 + 4 | 0;
     HEAP32[i3 + 0 >> 2] = 0;
     HEAP32[i3 + 4 >> 2] = 0;
     HEAP32[i3 + 8 >> 2] = 0;
     HEAP32[i3 + 12 >> 2] = 0;
     HEAP32[i44 >> 2] = 32232;
     HEAP32[i3 >> 2] = 33619968;
     HEAP32[i44 + 8 >> 2] = i73;
     __ZN2cv4gemmERKNS_11_InputArrayES2_dS2_dRKNS_12_OutputArrayEi(i41, i42, 1.0, i43, 0.0, i44, 1);
     i3 = i45 + 36 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if ((i2 | 0) != 0 ? (i47 = i2 + 12 | 0, i51 = HEAP32[i47 >> 2] | 0, HEAP32[i47 >> 2] = i51 + -1, (i51 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i45);
     HEAP32[i3 >> 2] = 0;
     i51 = i45 + 16 | 0;
     HEAP32[i51 + 0 >> 2] = 0;
     HEAP32[i51 + 4 >> 2] = 0;
     HEAP32[i51 + 8 >> 2] = 0;
     HEAP32[i51 + 12 >> 2] = 0;
     if ((HEAP32[i22 >> 2] | 0) > 0) {
      i3 = HEAP32[i20 >> 2] | 0;
      i2 = 0;
      do {
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) < (HEAP32[i22 >> 2] | 0));
     }
     i3 = HEAP32[i1 >> 2] | 0;
     if ((i3 | 0) == (i21 | 0)) break;
     __ZN2cv8fastFreeEPv(i3);
     break;
    }
    i24 = i51 + 4 | 0;
    HEAP32[i24 >> 2] = 2;
    i25 = i51 + 8 | 0;
    HEAP32[i25 >> 2] = i58;
    HEAP32[i51 + 12 >> 2] = i59;
    i27 = i51 + 16 | 0;
    HEAP32[i27 >> 2] = i6;
    HEAP32[i51 + 20 >> 2] = i6;
    i6 = i51 + 24 | 0;
    i28 = i51 + 40 | 0;
    HEAP32[i6 + 0 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i6 + 8 >> 2] = 0;
    HEAP32[i6 + 12 >> 2] = 0;
    HEAP32[i28 >> 2] = i25;
    i25 = i51 + 48 | 0;
    i1 = i51 + 44 | 0;
    HEAP32[i1 >> 2] = i25;
    i21 = i53 << (47696 >>> (i57 << 1 & 14) & 3);
    i22 = Math_imul(i59, i21) | 0;
    HEAP32[i51 >> 2] = i61 | 1124024320;
    HEAP32[i25 >> 2] = i22;
    HEAP32[i51 + 52 >> 2] = i21;
    i22 = i23 + ((Math_imul(i58, i22) | 0) + i29) | 0;
    HEAP32[i51 + 28 >> 2] = i22;
    HEAP32[i6 >> 2] = i22;
    i6 = i23 + (i29 + (Math_imul(i34, i59) | 0)) | 0;
    HEAP32[i46 >> 2] = 32088;
    HEAP32[i46 + 12 >> 2] = 0;
    HEAP32[i46 + 16 >> 2] = 0;
    HEAP32[i46 + 4 >> 2] = 16842752;
    HEAP32[i46 + 8 >> 2] = i78;
    HEAP32[i47 >> 2] = 32088;
    HEAP32[i47 + 12 >> 2] = 0;
    HEAP32[i47 + 16 >> 2] = 0;
    HEAP32[i47 + 4 >> 2] = 16842752;
    HEAP32[i47 + 8 >> 2] = i76;
    HEAP32[i50 >> 2] = 1124007936;
    i23 = i50 + 4 | 0;
    i22 = i50 + 8 | 0;
    i21 = i50 + 40 | 0;
    i35 = i23 + 0 | 0;
    i36 = i35 + 36 | 0;
    do {
     HEAP32[i35 >> 2] = 0;
     i35 = i35 + 4 | 0;
    } while ((i35 | 0) < (i36 | 0));
    HEAP32[i21 >> 2] = i22;
    i20 = i50 + 48 | 0;
    i22 = i50 + 44 | 0;
    HEAP32[i22 >> 2] = i20;
    HEAP32[i50 + 52 >> 2] = 0;
    HEAP32[i20 >> 2] = 0;
    HEAP32[i48 >> 2] = 32088;
    HEAP32[i48 + 12 >> 2] = 0;
    HEAP32[i48 + 16 >> 2] = 0;
    HEAP32[i48 + 4 >> 2] = 16842752;
    HEAP32[i48 + 8 >> 2] = i50;
    i3 = i49 + 4 | 0;
    HEAP32[i3 + 0 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    HEAP32[i3 + 12 >> 2] = 0;
    HEAP32[i49 >> 2] = 32232;
    HEAP32[i3 >> 2] = 33619968;
    HEAP32[i49 + 8 >> 2] = i51;
    __ZN2cv4gemmERKNS_11_InputArrayES2_dS2_dRKNS_12_OutputArrayEi(i46, i47, 1.0, i48, 0.0, i49, 1);
    i3 = i50 + 36 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if ((i2 | 0) != 0 ? (i46 = i2 + 12 | 0, i47 = HEAP32[i46 >> 2] | 0, HEAP32[i46 >> 2] = i47 + -1, (i47 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i50);
    HEAP32[i3 >> 2] = 0;
    i47 = i50 + 16 | 0;
    HEAP32[i47 + 0 >> 2] = 0;
    HEAP32[i47 + 4 >> 2] = 0;
    HEAP32[i47 + 8 >> 2] = 0;
    HEAP32[i47 + 12 >> 2] = 0;
    if ((HEAP32[i23 >> 2] | 0) > 0) {
     i3 = HEAP32[i21 >> 2] | 0;
     i2 = 0;
     do {
      HEAP32[i3 + (i2 << 2) >> 2] = 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (HEAP32[i23 >> 2] | 0));
    }
    i3 = HEAP32[i22 >> 2] | 0;
    if ((i3 | 0) != (i20 | 0)) __ZN2cv8fastFreeEPv(i3);
    __ZN2cv3MataSERKS0_(i76, i51) | 0;
    i3 = i51 + 36 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if ((i2 | 0) != 0 ? (i46 = i2 + 12 | 0, i47 = HEAP32[i46 >> 2] | 0, HEAP32[i46 >> 2] = i47 + -1, (i47 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i51);
    HEAP32[i3 >> 2] = 0;
    HEAP32[i27 + 0 >> 2] = 0;
    HEAP32[i27 + 4 >> 2] = 0;
    HEAP32[i27 + 8 >> 2] = 0;
    HEAP32[i27 + 12 >> 2] = 0;
    if ((HEAP32[i24 >> 2] | 0) > 0) {
     i3 = HEAP32[i28 >> 2] | 0;
     i2 = 0;
     do {
      HEAP32[i3 + (i2 << 2) >> 2] = 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (HEAP32[i24 >> 2] | 0));
    }
    i3 = HEAP32[i1 >> 2] | 0;
    if ((i3 | 0) != (i25 | 0)) __ZN2cv8fastFreeEPv(i3);
   } else i75 = 76;
  } while (0);
  if ((i75 | 0) == 76) if ((i26 | 0) == 0 | (i26 | 0) == 3) {
   i51 = i40 + 4 | 0;
   HEAP32[i51 + 0 >> 2] = 0;
   HEAP32[i51 + 4 >> 2] = 0;
   HEAP32[i51 + 8 >> 2] = 0;
   HEAP32[i51 + 12 >> 2] = 0;
   HEAP32[i40 >> 2] = 32232;
   HEAP32[i51 >> 2] = 33619968;
   HEAP32[i40 + 8 >> 2] = i73;
   __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i76, i40);
  }
  do if ((i26 | 0) == 3) {
   i6 = HEAP32[i72 + 16 >> 2] | 0;
   if ((i61 | 0) == 5) if (__ZN2cv8CholeskyEPfjiS0_ji(i6, HEAP32[i72 + 48 >> 2] | 0, i58, HEAP32[i73 + 16 >> 2] | 0, HEAP32[i73 + 48 >> 2] | 0, i59) | 0) {
    i6 = 1;
    break;
   } else {
    i75 = 146;
    break;
   } else if (__ZN2cv8CholeskyEPdjiS0_ji(i6, HEAP32[i72 + 48 >> 2] | 0, i58, HEAP32[i73 + 16 >> 2] | 0, HEAP32[i73 + 48 >> 2] | 0, i59) | 0) {
    i6 = 1;
    break;
   } else {
    i75 = 146;
    break;
   }
  } else if (!i26) {
   i6 = HEAP32[i72 + 16 >> 2] | 0;
   if ((i61 | 0) == 5) if (!(__ZN2cv2LUEPfjiS0_ji(i6, HEAP32[i72 + 48 >> 2] | 0, i58, HEAP32[i73 + 16 >> 2] | 0, HEAP32[i73 + 48 >> 2] | 0, i59) | 0)) {
    i75 = 146;
    break;
   } else {
    i6 = 1;
    break;
   } else if (!(__ZN2cv2LUEPdjiS0_ji(i6, HEAP32[i72 + 48 >> 2] | 0, i58, HEAP32[i73 + 16 >> 2] | 0, HEAP32[i73 + 48 >> 2] | 0, i59) | 0)) {
    i75 = 146;
    break;
   } else {
    i6 = 1;
    break;
   }
  } else {
   i3 = i6 + 15 & -16;
   __ZN2cv3MatC2EiiiPvj(i63, i58, i58, i61, i3, i55);
   i21 = i3 + (Math_imul(i55, i58) | 0) | 0;
   i26 = i62 + 4 | 0;
   HEAP32[i26 >> 2] = 2;
   i28 = i62 + 8 | 0;
   HEAP32[i28 >> 2] = i58;
   HEAP32[i62 + 12 >> 2] = 1;
   i24 = i62 + 16 | 0;
   HEAP32[i24 >> 2] = i21;
   HEAP32[i62 + 20 >> 2] = i21;
   i23 = i62 + 24 | 0;
   i25 = i62 + 40 | 0;
   HEAP32[i23 + 0 >> 2] = 0;
   HEAP32[i23 + 4 >> 2] = 0;
   HEAP32[i23 + 8 >> 2] = 0;
   HEAP32[i23 + 12 >> 2] = 0;
   HEAP32[i25 >> 2] = i28;
   i28 = i62 + 48 | 0;
   i27 = i62 + 44 | 0;
   HEAP32[i27 >> 2] = i28;
   i6 = i53 << (47696 >>> (i57 << 1 & 14) & 3);
   HEAP32[i62 >> 2] = i61 | 1124024320;
   HEAP32[i28 >> 2] = i6;
   HEAP32[i62 + 52 >> 2] = i6;
   i6 = i3 + (Math_imul(i58, i6 + i55 | 0) | 0) | 0;
   HEAP32[i62 + 28 >> 2] = i6;
   HEAP32[i23 >> 2] = i6;
   HEAP32[i60 >> 2] = 1124007936;
   i23 = i60 + 4 | 0;
   i6 = i60 + 8 | 0;
   i1 = i60 + 40 | 0;
   i35 = i23 + 0 | 0;
   i36 = i35 + 36 | 0;
   do {
    HEAP32[i35 >> 2] = 0;
    i35 = i35 + 4 | 0;
   } while ((i35 | 0) < (i36 | 0));
   HEAP32[i1 >> 2] = i6;
   i22 = i60 + 48 | 0;
   i20 = i60 + 44 | 0;
   HEAP32[i20 >> 2] = i22;
   HEAP32[i60 + 52 >> 2] = 0;
   HEAP32[i22 >> 2] = 0;
   i2 = i3 + (Math_imul(i55 + i54 | 0, i58) | 0) | 0;
   i3 = (i61 | 0) == 5;
   i6 = HEAP32[i72 + 16 >> 2] | 0;
   if (i30) {
    if (i3) __ZN2cv11JacobiImpl_IfEEbPT_jS2_S2_jiPh(i6, HEAP32[i72 + 48 >> 2] | 0, i21, HEAP32[i63 + 16 >> 2] | 0, HEAP32[i63 + 48 >> 2] | 0, i58, i2) | 0; else __ZN2cv11JacobiImpl_IdEEbPT_jS2_S2_jiPh(i6, HEAP32[i72 + 48 >> 2] | 0, i21, HEAP32[i63 + 16 >> 2] | 0, HEAP32[i63 + 48 >> 2] | 0, i58, i2) | 0;
    __ZN2cv3MataSERKS0_(i60, i63) | 0;
   } else {
    if (i3) {
     i61 = HEAP32[i63 + 16 >> 2] | 0;
     __ZN2cv14JacobiSVDImpl_IfEEvPT_jS2_S2_jiiidS1_(i6, HEAP32[i72 + 48 >> 2] | 0, i21, i61, HEAP32[i63 + 48 >> 2] | 0, i52, i58, (i61 | 0) == 0 ? 0 : i58, 1.1754943508222875e-38, Math_fround(2.38418579e-07));
    } else {
     i61 = HEAP32[i63 + 16 >> 2] | 0;
     __ZN2cv14JacobiSVDImpl_IdEEvPT_jS2_S2_jiiidS1_(i6, HEAP32[i72 + 48 >> 2] | 0, i21, i61, HEAP32[i63 + 48 >> 2] | 0, i52, i58, (i61 | 0) == 0 ? 0 : i58, 2.2250738585072014e-308, 2.220446049250313e-15);
    }
    __ZN2cv3MataSERKS0_(i60, i72) | 0;
   }
   i6 = HEAP32[i24 >> 2] | 0;
   if (i3) __ZN2cvL6SVBkSbEiiPKfjS1_jbS1_jbS1_jiPfjPh(i52, i58, i6, 0, HEAP32[i60 + 16 >> 2] | 0, HEAP32[i22 >> 2] | 0, 1, HEAP32[i63 + 16 >> 2] | 0, HEAP32[i63 + 48 >> 2] | 0, HEAP32[i64 >> 2] | 0, HEAP32[i69 >> 2] | 0, i59, HEAP32[i73 + 16 >> 2] | 0, HEAP32[i73 + 48 >> 2] | 0, i2); else __ZN2cvL6SVBkSbEiiPKdjS1_jbS1_jbS1_jiPdjPh(i52, i58, i6, 0, HEAP32[i60 + 16 >> 2] | 0, HEAP32[i22 >> 2] | 0, 1, HEAP32[i63 + 16 >> 2] | 0, HEAP32[i63 + 48 >> 2] | 0, HEAP32[i64 >> 2] | 0, HEAP32[i69 >> 2] | 0, i59, HEAP32[i73 + 16 >> 2] | 0, HEAP32[i73 + 48 >> 2] | 0, i2);
   i6 = i60 + 36 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if ((i3 | 0) != 0 ? (i59 = i3 + 12 | 0, i61 = HEAP32[i59 >> 2] | 0, HEAP32[i59 >> 2] = i61 + -1, (i61 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i60);
   HEAP32[i6 >> 2] = 0;
   i61 = i60 + 16 | 0;
   HEAP32[i61 + 0 >> 2] = 0;
   HEAP32[i61 + 4 >> 2] = 0;
   HEAP32[i61 + 8 >> 2] = 0;
   HEAP32[i61 + 12 >> 2] = 0;
   if ((HEAP32[i23 >> 2] | 0) > 0) {
    i6 = HEAP32[i1 >> 2] | 0;
    i3 = 0;
    do {
     HEAP32[i6 + (i3 << 2) >> 2] = 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (HEAP32[i23 >> 2] | 0));
   }
   i6 = HEAP32[i20 >> 2] | 0;
   if ((i6 | 0) != (i22 | 0)) __ZN2cv8fastFreeEPv(i6);
   i6 = i62 + 36 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if ((i3 | 0) != 0 ? (i60 = i3 + 12 | 0, i61 = HEAP32[i60 >> 2] | 0, HEAP32[i60 >> 2] = i61 + -1, (i61 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i62);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i24 + 0 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i24 + 12 >> 2] = 0;
   if ((HEAP32[i26 >> 2] | 0) > 0) {
    i6 = HEAP32[i25 >> 2] | 0;
    i3 = 0;
    do {
     HEAP32[i6 + (i3 << 2) >> 2] = 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (HEAP32[i26 >> 2] | 0));
   }
   i6 = HEAP32[i27 >> 2] | 0;
   if ((i6 | 0) != (i28 | 0)) __ZN2cv8fastFreeEPv(i6);
   i6 = i63 + 36 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   do if (i3) {
    i60 = i3 + 12 | 0;
    i61 = HEAP32[i60 >> 2] | 0;
    HEAP32[i60 >> 2] = i61 + -1;
    if ((i61 | 0) != 1) break;
    __ZN2cv3Mat10deallocateEv(i63);
   } while (0);
   HEAP32[i6 >> 2] = 0;
   i61 = i63 + 16 | 0;
   i6 = i63 + 4 | 0;
   HEAP32[i61 + 0 >> 2] = 0;
   HEAP32[i61 + 4 >> 2] = 0;
   HEAP32[i61 + 8 >> 2] = 0;
   HEAP32[i61 + 12 >> 2] = 0;
   if ((HEAP32[i6 >> 2] | 0) > 0) {
    i3 = HEAP32[i63 + 40 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i6 >> 2] | 0));
   }
   i6 = HEAP32[i63 + 44 >> 2] | 0;
   if ((i6 | 0) == (i63 + 48 | 0)) {
    i6 = 1;
    break;
   }
   __ZN2cv8fastFreeEPv(i6);
   i6 = 1;
  } while (0);
  if ((i75 | 0) == 146) {
   HEAP32[i56 + 0 >> 2] = 0;
   HEAP32[i56 + 4 >> 2] = 0;
   HEAP32[i56 + 8 >> 2] = 0;
   HEAP32[i56 + 12 >> 2] = 0;
   HEAP32[i56 + 16 >> 2] = 0;
   HEAP32[i56 + 20 >> 2] = 0;
   HEAP32[i56 + 24 >> 2] = 0;
   HEAP32[i56 + 28 >> 2] = 0;
   __ZN2cv3MataSERKNS_7Scalar_IdEE(i73, i56) | 0;
   i6 = 0;
  }
  i3 = i72 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i60 = i2 + 12 | 0, i61 = HEAP32[i60 >> 2] | 0, HEAP32[i60 >> 2] = i61 + -1, (i61 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i72);
  HEAP32[i3 >> 2] = 0;
  i61 = i72 + 16 | 0;
  i3 = i72 + 4 | 0;
  HEAP32[i61 + 0 >> 2] = 0;
  HEAP32[i61 + 4 >> 2] = 0;
  HEAP32[i61 + 8 >> 2] = 0;
  HEAP32[i61 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i72 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i3 = HEAP32[i72 + 44 >> 2] | 0;
  if ((i3 | 0) != (i72 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = i73 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i60 = i2 + 12 | 0, i61 = HEAP32[i60 >> 2] | 0, HEAP32[i60 >> 2] = i61 + -1, (i61 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i73);
  HEAP32[i3 >> 2] = 0;
  i61 = i73 + 16 | 0;
  i3 = i73 + 4 | 0;
  HEAP32[i61 + 0 >> 2] = 0;
  HEAP32[i61 + 4 >> 2] = 0;
  HEAP32[i61 + 8 >> 2] = 0;
  HEAP32[i61 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i73 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i3 = HEAP32[i73 + 44 >> 2] | 0;
  if ((i3 | 0) != (i73 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = HEAP32[i65 >> 2] | 0;
  if ((i3 | 0) != 0 ? (i60 = i3 + 12 | 0, i61 = HEAP32[i60 >> 2] | 0, HEAP32[i60 >> 2] = i61 + -1, (i61 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i76);
  HEAP32[i65 >> 2] = 0;
  HEAP32[i64 + 0 >> 2] = 0;
  HEAP32[i64 + 4 >> 2] = 0;
  HEAP32[i64 + 8 >> 2] = 0;
  HEAP32[i64 + 12 >> 2] = 0;
  if ((HEAP32[i67 >> 2] | 0) > 0) {
   i3 = HEAP32[i66 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i67 >> 2] | 0));
  }
  i3 = HEAP32[i68 >> 2] | 0;
  if ((i3 | 0) != (i69 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = HEAP32[i74 >> 2] | 0;
  if ((i3 | 0) == (i70 | 0)) break;
  if (i3) __ZdaPv(i3);
  HEAP32[i74 >> 2] = i70;
  HEAP32[i71 >> 2] = 1032;
 } while (0);
 i2 = i77 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i60 = i1 + 12 | 0, i61 = HEAP32[i60 >> 2] | 0, HEAP32[i60 >> 2] = i61 + -1, (i61 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i77);
 HEAP32[i2 >> 2] = 0;
 i61 = i77 + 16 | 0;
 i3 = i77 + 4 | 0;
 HEAP32[i61 + 0 >> 2] = 0;
 HEAP32[i61 + 4 >> 2] = 0;
 HEAP32[i61 + 8 >> 2] = 0;
 HEAP32[i61 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i77 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i77 + 44 >> 2] | 0;
 if ((i1 | 0) != (i77 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i78 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i60 = i2 + 12 | 0, i61 = HEAP32[i60 >> 2] | 0, HEAP32[i60 >> 2] = i61 + -1, (i61 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i78);
 HEAP32[i1 >> 2] = 0;
 i61 = i78 + 16 | 0;
 i2 = i78 + 4 | 0;
 HEAP32[i61 + 0 >> 2] = 0;
 HEAP32[i61 + 4 >> 2] = 0;
 HEAP32[i61 + 8 >> 2] = 0;
 HEAP32[i61 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i78 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i78 + 44 >> 2] | 0;
 if ((i1 | 0) == (i78 + 48 | 0)) {
  STACKTOP = i79;
  return i6 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i79;
 return i6 | 0;
}

function __ZN2cvL9arithm_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_iPPFvPKhjS7_jPhjNS_5Size_IiEEPvEbSB_i(i34, i31, i37, i45, i24, i48, i41, i74, i3) {
 i34 = i34 | 0;
 i31 = i31 | 0;
 i37 = i37 | 0;
 i45 = i45 | 0;
 i24 = i24 | 0;
 i48 = i48 | 0;
 i41 = i41 | 0;
 i74 = i74 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i38 = 0, i39 = 0, i40 = 0, i42 = 0, i43 = 0, i44 = 0, i46 = 0, i47 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i75 = 0, i76 = 0, i77 = 0, d78 = 0.0;
 i77 = STACKTOP;
 STACKTOP = STACKTOP + 1776 | 0;
 i19 = i77 + 1712 | 0;
 i16 = i77 + 1656 | 0;
 i32 = i77 + 1648 | 0;
 i29 = i77 + 1640 | 0;
 i40 = i77 + 1632 | 0;
 i4 = i77 + 1624 | 0;
 i33 = i77 + 1616 | 0;
 i76 = i77 + 1560 | 0;
 i14 = i77 + 1552 | 0;
 i13 = i77 + 1544 | 0;
 i18 = i77 + 1536 | 0;
 i38 = i77 + 1528 | 0;
 i44 = i77 + 1520 | 0;
 i43 = i77 + 1496 | 0;
 i42 = i77;
 i39 = i77 + 1476 | 0;
 i70 = i77 + 1472 | 0;
 i75 = i77 + 1416 | 0;
 i73 = i77 + 1360 | 0;
 i72 = i77 + 1304 | 0;
 i71 = i77 + 264 | 0;
 i46 = i77 + 240 | 0;
 i68 = i77 + 224 | 0;
 i67 = i77 + 192 | 0;
 i65 = i77 + 184 | 0;
 i66 = i77 + 176 | 0;
 i59 = i77 + 168 | 0;
 i60 = i77 + 160 | 0;
 i61 = i77 + 152 | 0;
 i62 = i77 + 144 | 0;
 i63 = i77 + 136 | 0;
 i64 = i77 + 128 | 0;
 i47 = i77 + 112 | 0;
 i58 = i77 + 96 | 0;
 i57 = i77 + 64 | 0;
 i50 = i77 + 56 | 0;
 i51 = i77 + 48 | 0;
 i52 = i77 + 40 | 0;
 i53 = i77 + 32 | 0;
 i54 = i77 + 24 | 0;
 i55 = i77 + 16 | 0;
 i56 = i77 + 8 | 0;
 i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i34 >> 2] | 0) + 24 >> 2] & 127](i34) | 0;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i31 >> 2] | 0) + 24 >> 2] & 127](i31) | 0;
 i69 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i45 >> 2] | 0) + 76 >> 2] & 127](i45) | 0;
 i15 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i34 >> 2] | 0) + 56 >> 2] & 127](i34, -1) | 0;
 i17 = i15 & 7;
 i26 = i15 >>> 3 & 511;
 i9 = i26 + 1 | 0;
 i10 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i31 >> 2] | 0) + 56 >> 2] & 127](i31, -1) | 0;
 i11 = i10 & 7;
 HEAP32[i40 >> 2] = i11;
 i3 = (i10 >>> 3 & 511) + 1 | 0;
 i25 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i34 >> 2] | 0) + 28 >> 2] & 127](i34, -1) | 0;
 i23 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i31 >> 2] | 0) + 28 >> 2] & 127](i31, -1) | 0;
 i8 = (i25 | 0) < 3;
 if (i8) FUNCTION_TABLE_viii[HEAP32[(HEAP32[i34 >> 2] | 0) + 40 >> 2] & 63](i4, i34, -1); else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
 }
 i7 = (i23 | 0) < 3;
 if (i7) FUNCTION_TABLE_viii[HEAP32[(HEAP32[i31 >> 2] | 0) + 40 >> 2] & 63](i33, i31, -1); else {
  HEAP32[i33 >> 2] = 0;
  HEAP32[i33 + 4 >> 2] = 0;
 }
 do if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i34 >> 2] | 0) + 28 >> 2] & 127](i34, -1) | 0) <= 2 ? FUNCTION_TABLE_iii[HEAP32[(HEAP32[i34 >> 2] | 0) + 68 >> 2] & 127](i34, -1) | 0 : 0) {
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i34 >> 2] | 0) + 40 >> 2] & 63](i29, i34, -1);
  i30 = HEAP32[i29 >> 2] | 0;
  i27 = (i30 | 0) == 1;
  if (!i27 ? (HEAP32[i29 + 4 >> 2] | 0) != 1 : 0) {
   i27 = 0;
   break;
  }
  if (!((i1 | 0) == 131072 & (i2 | 0) != 131072)) {
   if (i27 ? (i36 = HEAP32[i29 + 4 >> 2] | 0, (i36 | 0) == 1 | (i36 | 0) == (i3 | 0)) : 0) {
    i27 = 1;
    break;
   }
   if ((i30 | 0) == (i3 | 0)) {
    i28 = HEAP32[i29 + 4 >> 2] | 0;
    i30 = (i28 | 0) == 1;
    if (i30 | i27 ^ 1) {
     i27 = i30;
     break;
    }
   } else {
    if (!i27) {
     i27 = 0;
     break;
    }
    i28 = HEAP32[i29 + 4 >> 2] | 0;
   }
   if ((i28 | 0) == 4) i27 = (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i34 >> 2] | 0) + 56 >> 2] & 127](i34, -1) | 0) == 6 & i3 >>> 0 < 5; else i27 = 0;
  } else i27 = 0;
 } else i27 = 0; while (0);
 do if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i31 >> 2] | 0) + 28 >> 2] & 127](i31, -1) | 0) <= 2 ? FUNCTION_TABLE_iii[HEAP32[(HEAP32[i31 >> 2] | 0) + 68 >> 2] & 127](i31, -1) | 0 : 0) {
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i31 >> 2] | 0) + 40 >> 2] & 63](i32, i31, -1);
  i30 = HEAP32[i32 >> 2] | 0;
  i29 = (i30 | 0) == 1;
  if (!i29 ? (HEAP32[i32 + 4 >> 2] | 0) != 1 : 0) {
   i28 = 0;
   break;
  }
  if (!((i2 | 0) == 131072 & (i1 | 0) != 131072)) {
   if (i29 ? (i36 = HEAP32[i32 + 4 >> 2] | 0, (i36 | 0) == 1 | (i36 | 0) == (i9 | 0)) : 0) {
    i28 = 1;
    break;
   }
   if ((i30 | 0) == (i9 | 0)) {
    i28 = HEAP32[i32 + 4 >> 2] | 0;
    i30 = (i28 | 0) == 1;
    if (i30 | i29 ^ 1) {
     i28 = i30;
     break;
    }
   } else {
    if (!i29) {
     i28 = 0;
     break;
    }
    i28 = HEAP32[i32 + 4 >> 2] | 0;
   }
   if ((i28 | 0) == 4) i28 = (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i31 >> 2] | 0) + 56 >> 2] & 127](i31, -1) | 0) == 6 & i9 >>> 0 < 5; else i28 = 0;
  } else i28 = 0;
 } else i28 = 0; while (0);
 do if ((((i2 | 0) == (i1 | 0) | (i26 | 0) == 0 ? (HEAP32[i4 >> 2] | 0) == (HEAP32[i33 >> 2] | 0) : 0) ? (HEAP32[i4 + 4 >> 2] | 0) == (HEAP32[i33 + 4 >> 2] | 0) & i8 & i7 : 0) ? !((i15 | 0) != (i10 | 0) | i69 ^ 1) : 0) {
  if (!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i37 >> 2] | 0) + 108 >> 2] & 127](i37) | 0) ? (i24 | 0) < 0 | (i24 & 7 | 0) == (i17 | 0) : 0) {
   if (i27 ^ i28) break;
  } else {
   if (!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i37 >> 2] | 0) + 108 >> 2] & 127](i37) | 0)) break;
   if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i37 >> 2] | 0) + 56 >> 2] & 127](i37, -1) | 0) != (i15 | 0) | i27 ^ i28) break;
  }
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i37 >> 2] | 0) + 148 >> 2] & 63](i37, i34, i15);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i34 >> 2] >> 2] & 63](i76, i34, -1);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i31 >> 2] >> 2] & 63](i19, i31, -1);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i37 >> 2] >> 2] & 63](i16, i37, -1);
  i46 = HEAP32[i76 >> 2] | 0;
  i3 = (i46 >>> 3 & 511) + 1 | 0;
  i2 = HEAP32[i76 + 12 >> 2] | 0;
  if (!(i46 & 16384 & HEAP32[i19 >> 2] & HEAP32[i16 >> 2])) {
   i3 = Math_imul(i2, i3) | 0;
   i2 = HEAP32[i76 + 8 >> 2] | 0;
  } else {
   i3 = Math_imul(Math_imul(i2, i3) | 0, HEAP32[i76 + 8 >> 2] | 0) | 0;
   i2 = 1;
  }
  i40 = HEAP32[i48 + (i17 << 2) >> 2] | 0;
  i10 = i76 + 16 | 0;
  i41 = HEAP32[i10 >> 2] | 0;
  i11 = i76 + 44 | 0;
  i12 = i76 + 48 | 0;
  i42 = HEAP32[i12 >> 2] | 0;
  i7 = i19 + 16 | 0;
  i43 = HEAP32[i7 >> 2] | 0;
  i8 = i19 + 44 | 0;
  i9 = i19 + 48 | 0;
  i44 = HEAP32[i9 >> 2] | 0;
  i4 = i16 + 16 | 0;
  i45 = HEAP32[i4 >> 2] | 0;
  i5 = i16 + 44 | 0;
  i6 = i16 + 48 | 0;
  i46 = HEAP32[i6 >> 2] | 0;
  HEAP32[i14 >> 2] = i3;
  HEAP32[i14 + 4 >> 2] = i2;
  FUNCTION_TABLE_viiiiiiii[i40 & 255](i41, i42, i43, i44, i45, i46, i14, i74);
  i3 = i16 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i45 = i2 + 12 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i16);
  HEAP32[i3 >> 2] = 0;
  i1 = i16 + 4 | 0;
  HEAP32[i4 + 0 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  if ((HEAP32[i1 >> 2] | 0) > 0) {
   i3 = HEAP32[i16 + 40 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
  }
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i3 | 0) != (i6 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = i19 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i45 = i2 + 12 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i19);
  HEAP32[i3 >> 2] = 0;
  i1 = i19 + 4 | 0;
  HEAP32[i7 + 0 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  if ((HEAP32[i1 >> 2] | 0) > 0) {
   i3 = HEAP32[i19 + 40 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
  }
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i3 | 0) != (i9 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = i76 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i45 = i2 + 12 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i76);
  HEAP32[i3 >> 2] = 0;
  i1 = i76 + 4 | 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  if ((HEAP32[i1 >> 2] | 0) > 0) {
   i3 = HEAP32[i76 + 40 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
  }
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i1 | 0) == (i12 | 0)) {
   STACKTOP = i77;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i77;
  return;
 } while (0);
 do if ((i25 | 0) == (i23 | 0) ? (i6 = HEAP32[i4 >> 2] | 0, i5 = HEAP32[i4 + 4 >> 2] | 0, ((i6 | 0) == (HEAP32[i33 >> 2] | 0) ? (i5 | 0) == (HEAP32[i33 + 4 >> 2] | 0) : 0) & (i9 | 0) == (i3 | 0)) : 0) {
  if ((i2 | 0) == 131072 & (i6 | 0) == 1 ? (i5 | 0) == 1 | (i5 | 0) == 4 : 0) {
   i35 = 75;
   break;
  }
  if ((i1 | 0) == 131072 & (i6 | 0) == 1 ? (i5 | 0) == 1 | (i5 | 0) == 4 : 0) i35 = 75; else {
   i30 = i15;
   i23 = i17;
   i49 = i9;
   i32 = i34;
   i9 = 0;
   i36 = 0;
  }
 } else i35 = 75; while (0);
 do if ((i35 | 0) == 75) {
  L106 : do if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i34 >> 2] | 0) + 28 >> 2] & 127](i34, -1) | 0) <= 2 ? FUNCTION_TABLE_iii[HEAP32[(HEAP32[i34 >> 2] | 0) + 68 >> 2] & 127](i34, -1) | 0 : 0) {
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i34 >> 2] | 0) + 40 >> 2] & 63](i16, i34, -1);
   i21 = HEAP32[i16 >> 2] | 0;
   i23 = (i21 | 0) == 1;
   if (!i23 ? (HEAP32[i16 + 4 >> 2] | 0) != 1 : 0) {
    i35 = 90;
    break;
   }
   if (!((i1 | 0) == 131072 & (i2 | 0) != 131072)) {
    if (!(i23 ? (i36 = HEAP32[i16 + 4 >> 2] | 0, (i36 | 0) == 1 | (i36 | 0) == (i3 | 0)) : 0)) i35 = 82;
    do if ((i35 | 0) == 82) {
     if ((i21 | 0) == (i3 | 0)) {
      i21 = HEAP32[i16 + 4 >> 2] | 0;
      i20 = (i21 | 0) == 1;
      if (i20 | i23 ^ 1) if (i20) break; else {
       i35 = 90;
       break L106;
      }
     } else {
      if (!i23) {
       i35 = 90;
       break L106;
      }
      i21 = HEAP32[i16 + 4 >> 2] | 0;
     }
     if ((i21 | 0) != 4) {
      i35 = 90;
      break L106;
     }
     if (!((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i34 >> 2] | 0) + 56 >> 2] & 127](i34, -1) | 0) == 6 & i3 >>> 0 < 5)) {
      i35 = 90;
      break L106;
     }
    } while (0);
    i23 = HEAP32[i4 >> 2] | 0;
    i30 = i4 + 4 | 0;
    i9 = HEAP32[i30 >> 2] | 0;
    HEAP32[i4 >> 2] = HEAP32[i33 >> 2];
    i25 = i33 + 4 | 0;
    HEAP32[i30 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i33 >> 2] = i23;
    HEAP32[i25 >> 2] = i9;
    HEAP32[i40 >> 2] = i17;
    i25 = i15;
    i9 = i3;
    i23 = i11;
    i30 = i10;
    i32 = i31;
    i31 = i34;
    i29 = 1;
   } else i35 = 90;
  } else i35 = 90; while (0);
  L125 : do if ((i35 | 0) == 90) {
   do if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i31 >> 2] | 0) + 28 >> 2] & 127](i31, -1) | 0) <= 2 ? FUNCTION_TABLE_iii[HEAP32[(HEAP32[i31 >> 2] | 0) + 68 >> 2] & 127](i31, -1) | 0 : 0) {
    FUNCTION_TABLE_viii[HEAP32[(HEAP32[i31 >> 2] | 0) + 40 >> 2] & 63](i19, i31, -1);
    i12 = HEAP32[i19 >> 2] | 0;
    i16 = (i12 | 0) == 1;
    if (!i16 ? (HEAP32[i19 + 4 >> 2] | 0) != 1 : 0) break;
    if (!((i2 | 0) == 131072 & (i1 | 0) != 131072)) {
     if (i16 ? (i36 = HEAP32[i19 + 4 >> 2] | 0, (i36 | 0) == 1 | (i36 | 0) == (i9 | 0)) : 0) {
      i25 = i10;
      i23 = i17;
      i30 = i15;
      i32 = i34;
      i29 = 0;
      break L125;
     }
     if ((i12 | 0) == (i9 | 0)) {
      i12 = HEAP32[i19 + 4 >> 2] | 0;
      i11 = (i12 | 0) == 1;
      if (i11 | i16 ^ 1) if (i11) {
       i25 = i10;
       i23 = i17;
       i30 = i15;
       i32 = i34;
       i29 = 0;
       break L125;
      } else break;
     } else {
      if (!i16) break;
      i12 = HEAP32[i19 + 4 >> 2] | 0;
     }
     if ((i12 | 0) == 4 ? (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i31 >> 2] | 0) + 56 >> 2] & 127](i31, -1) | 0) == 6 & i9 >>> 0 < 5 : 0) {
      i25 = i10;
      i23 = i17;
      i30 = i15;
      i32 = i34;
      i29 = 0;
      break L125;
     }
    }
   } while (0);
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   _memcpy(__ZN2cv6String8allocateEj(i13, 153) | 0, 5400, 153) | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-209, i13, 5560, 4712, 1792);
   __ZN2cv6String10deallocateEv(i13);
   i25 = i10;
   i23 = i17;
   i30 = i15;
   i32 = i34;
   i29 = 0;
  } while (0);
  if (!((i25 | 0) == 6 ? (i36 = HEAP32[i33 + 4 >> 2] | 0, (i36 | 0) == 4 | (i36 | 0) == 1) : 0)) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   i28 = (__ZN2cv6String8allocateEj(i18, 55) | 0) + 0 | 0;
   i27 = 5576 | 0;
   i26 = i28 + 55 | 0;
   do {
    HEAP8[i28 >> 0] = HEAP8[i27 >> 0] | 0;
    i28 = i28 + 1 | 0;
    i27 = i27 + 1 | 0;
   } while ((i28 | 0) < (i26 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i18, 5560, 4712, 1794);
   __ZN2cv6String10deallocateEv(i18);
  }
  if (i41) {
   HEAP32[i40 >> 2] = 6;
   i10 = i25;
   i49 = i9;
   i9 = 1;
   i36 = i29 << 24 >> 24 != 0;
   break;
  }
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i31 >> 2] >> 2] & 63](i76, i31, -1);
  i22 = i76 + 16 | 0;
  i12 = HEAP32[i22 >> 2] | 0;
  i10 = i76 + 44 | 0;
  i1 = 0;
  i20 = -2147483648;
  i19 = 2147483647;
  while (1) {
   d78 = +HEAPF64[i12 + (i1 << 3) >> 3];
   i11 = _lrint(d78) | 0;
   if (+(i11 | 0) != d78) {
    i35 = 117;
    break;
   }
   i19 = (i19 | 0) > (i11 | 0) ? i11 : i19;
   i20 = (i20 | 0) < (i11 | 0) ? i11 : i20;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i9 | 0)) {
    i35 = 112;
    break;
   }
  }
  if ((i35 | 0) == 112) {
   i12 = (i19 | 0) > -1;
   if (!(i12 & (i20 | 0) < 256)) if (!((i19 | 0) > -129 & (i20 | 0) < 128)) if (!(i12 & (i20 | 0) < 65536)) if ((i19 | 0) > -32769) i12 = (i20 | 0) < 32768 ? 3 : 4; else i12 = 4; else i12 = 2; else i12 = 1; else i12 = 0;
  } else if ((i35 | 0) == 117) {
   HEAP32[i40 >> 2] = 6;
   i12 = i23 >>> 0 < 4 | (i23 | 0) == 5 ? 5 : 6;
  }
  HEAP32[i40 >> 2] = i12;
  i12 = i76 + 36 | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  if ((i11 | 0) != 0 ? (i35 = i11 + 12 | 0, i36 = HEAP32[i35 >> 2] | 0, HEAP32[i35 >> 2] = i36 + -1, (i36 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i76);
  HEAP32[i12 >> 2] = 0;
  i1 = i76 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i1 >> 2] | 0) > 0) {
   i12 = HEAP32[i76 + 40 >> 2] | 0;
   i11 = 0;
   do {
    HEAP32[i12 + (i11 << 2) >> 2] = 0;
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) < (HEAP32[i1 >> 2] | 0));
  }
  i12 = HEAP32[i10 >> 2] | 0;
  if ((i12 | 0) != (i76 + 48 | 0)) __ZN2cv8fastFreeEPv(i12);
  i10 = i25;
  i49 = i9;
  i9 = 1;
  i36 = i29 << 24 >> 24 != 0;
 } while (0);
 do if ((i24 | 0) < 0) {
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i37 >> 2] | 0) + 108 >> 2] & 127](i37) | 0) {
   i24 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i37 >> 2] | 0) + 56 >> 2] & 127](i37, -1) | 0;
   break;
  }
  if (i9 | (i30 | 0) == (i10 | 0)) i24 = i30; else {
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   _memcpy(__ZN2cv6String8allocateEj(i38, 136) | 0, 5632, 136) | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i38, 5560, 4712, 1816);
   __ZN2cv6String10deallocateEv(i38);
   i24 = i30;
  }
 } while (0);
 i1 = i24 & 7;
 i11 = HEAP32[i40 >> 2] | 0;
 do if (!((i23 | 0) == (i11 | 0) & (i1 | 0) == (i23 | 0))) {
  if (i41) {
   i12 = (i11 | 0) < 5 ? 5 : i11;
   i12 = (i23 | 0) < (i12 | 0) ? i12 : i23;
   i12 = (i12 | 0) < (i1 | 0) ? i1 : i12;
   break;
  }
  if (!((i23 | 0) < 2 & (i11 | 0) < 2)) if ((i23 | 0) < 5 & (i11 | 0) < 5) i12 = 4; else i12 = (i23 | 0) < (i11 | 0) ? i11 : i23; else i12 = 3;
  i12 = (i12 | 0) < (i1 | 0) ? i1 : i12;
  if (i1 >>> 0 < 5) i12 = (i23 | 0) < 5 | (i11 | 0) < 5 ? 4 : i12;
 } else i12 = i23; while (0);
 i21 = (i49 << 3) + -8 | 0;
 i11 = i1 | i21;
 i25 = i12 & 7;
 i29 = i25 | i21;
 i8 = i69 ^ 1;
 do if (i69) FUNCTION_TABLE_viii[HEAP32[(HEAP32[i37 >> 2] | 0) + 148 >> 2] & 63](i37, i32, i11); else {
  if (!((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i45 >> 2] | 0) + 56 >> 2] & 127](i45, -1) | 0) >>> 0 < 2 ? FUNCTION_TABLE_iii[HEAP32[(HEAP32[i45 >> 2] | 0) + 48 >> 2] & 127](i45, i32) | 0 : 0)) {
   HEAP32[i44 >> 2] = 0;
   HEAP32[i44 + 4 >> 2] = 0;
   i28 = (__ZN2cv6String8allocateEj(i44, 64) | 0) + 0 | 0;
   i27 = 5776 | 0;
   i26 = i28 + 64 | 0;
   do {
    HEAP8[i28 >> 0] = HEAP8[i27 >> 0] | 0;
    i28 = i28 + 1 | 0;
    i27 = i27 + 1 | 0;
   } while ((i28 | 0) < (i26 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i44, 5560, 4712, 1848);
   __ZN2cv6String10deallocateEv(i44);
  }
  if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i37 >> 2] | 0) + 48 >> 2] & 127](i37, i32) | 0) {
   i44 = (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i37 >> 2] | 0) + 56 >> 2] & 127](i37, -1) | 0) == (i11 | 0);
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i37 >> 2] | 0) + 148 >> 2] & 63](i37, i32, i11);
   if (i44) break;
  } else FUNCTION_TABLE_viii[HEAP32[(HEAP32[i37 >> 2] | 0) + 148 >> 2] & 63](i37, i32, i11);
  i44 = HEAP32[(HEAP32[i37 >> 2] | 0) + 160 >> 2] | 0;
  HEAPF64[i42 >> 3] = 0.0;
  HEAP32[i43 >> 2] = 32088;
  HEAP32[i43 + 4 >> 2] = -1056833530;
  HEAP32[i43 + 8 >> 2] = i42;
  HEAP32[i43 + 12 >> 2] = 1;
  HEAP32[i43 + 16 >> 2] = 1;
  HEAP32[i39 >> 2] = 32088;
  i42 = i39 + 4 | 0;
  HEAP32[i42 + 0 >> 2] = 0;
  HEAP32[i42 + 4 >> 2] = 0;
  HEAP32[i42 + 8 >> 2] = 0;
  HEAP32[i42 + 12 >> 2] = 0;
  FUNCTION_TABLE_viii[i44 & 63](i37, i43, i39);
 } while (0);
 if ((i30 | 0) == (i29 | 0)) i44 = 0; else i44 = __ZN2cv14getConvertFuncEii(i30, i29) | 0;
 if ((i10 | 0) != (i30 | 0)) if ((i10 | 0) == (i29 | 0)) i34 = 0; else i34 = __ZN2cv14getConvertFuncEii(i10, i29) | 0; else i34 = i44;
 if ((i11 | 0) == (i29 | 0)) i43 = 0; else i43 = __ZN2cv14getConvertFuncEii(i29, i11) | 0;
 i42 = (i30 >>> 3 & 511) + 1 << (47696 >>> (i30 << 1 & 14) & 3);
 i33 = (i10 >>> 3 & 511) + 1 << (47696 >>> (i10 << 1 & 14) & 3);
 i28 = (i21 >>> 3 & 511) + 1 | 0;
 i41 = i28 << (47696 >>> (i24 << 1 & 14) & 3);
 HEAP32[i70 >> 2] = i41;
 i28 = i28 << (47696 >>> (i12 << 1 & 14) & 3);
 i21 = ((i28 + 1023 | 0) >>> 0) / (i28 >>> 0) | 0;
 i41 = __ZN2cv15getCopyMaskFuncEj(i41) | 0;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i32 >> 2] >> 2] & 63](i75, i32, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i31 >> 2] >> 2] & 63](i76, i31, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i37 >> 2] >> 2] & 63](i73, i37, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i45 >> 2] >> 2] & 63](i72, i45, -1);
 i39 = i71 + 8 | 0;
 HEAP32[i71 >> 2] = i39;
 i40 = i71 + 4 | 0;
 HEAP32[i40 >> 2] = 1032;
 i37 = (i44 | 0) != 0;
 i23 = (i34 | 0) != 0;
 i38 = (i43 | 0) != 0;
 i12 = (i23 | i9 ? i28 : 0) + (i37 ? i28 : 0) + (i38 ? i28 : 0) + (i69 ? 0 : HEAP32[i70 >> 2] | 0) | 0;
 i35 = HEAP32[i48 + (i25 << 2) >> 2] | 0;
 L219 : do if (i9) {
  HEAP32[i47 >> 2] = i75;
  HEAP32[i47 + 4 >> 2] = i73;
  HEAP32[i47 + 8 >> 2] = i72;
  HEAP32[i47 + 12 >> 2] = 0;
  __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i57, i47, i58, -1);
  i27 = HEAP32[i57 + 20 >> 2] | 0;
  i24 = i21 >>> 0 < i27 >>> 0 ? i21 : i27;
  i12 = (Math_imul(i24, i12) | 0) + 64 | 0;
  if ((HEAP32[i40 >> 2] | 0) >>> 0 < i12 >>> 0) {
   i11 = HEAP32[i71 >> 2] | 0;
   if ((i11 | 0) != (i39 | 0)) {
    if (i11) __ZdaPv(i11);
    HEAP32[i71 >> 2] = i39;
    HEAP32[i40 >> 2] = 1032;
   }
   if (i12 >>> 0 > 1032) {
    i46 = __Znaj(i12) | 0;
    HEAP32[i71 >> 2] = i46;
    HEAP32[i40 >> 2] = i12;
    i12 = i46;
   } else i12 = i39;
  } else {
   HEAP32[i40 >> 2] = i12;
   i12 = HEAP32[i71 >> 2] | 0;
  }
  i11 = Math_imul(i24, i28) | 0;
  if (i37) i23 = i12 + i11 + 15 & -16; else {
   i23 = i12;
   i12 = 0;
  }
  i22 = i23 + i11 + 15 & -16;
  if (i38) i11 = i22 + i11 + 15 & -16; else i11 = i22;
  i21 = i69 ? i22 : i11;
  __ZN2cv22convertAndUnrollScalarERKNS_3MatEiPhj(i76, i29, i23, i24);
  i17 = i57 + 16 | 0;
  i18 = (i27 | 0) == 0;
  i19 = i58 + 4 | 0;
  i20 = i50 + 4 | 0;
  i16 = i38 | i8;
  i3 = i52 + 4 | 0;
  i4 = i53 + 4 | 0;
  i5 = i55 + 4 | 0;
  i6 = i58 + 8 | 0;
  i7 = i56 + 4 | 0;
  i8 = i54 + 4 | 0;
  i9 = i51 + 4 | 0;
  i14 = 0;
  while (1) {
   if (i14 >>> 0 >= (HEAP32[i17 >> 2] | 0) >>> 0) break L219;
   if (!i18) {
    i11 = HEAP32[i58 >> 2] | 0;
    i13 = HEAP32[i19 >> 2] | 0;
    i15 = 0;
    do {
     i2 = i27 - i15 | 0;
     i2 = i2 >>> 0 > i24 >>> 0 ? i24 : i2;
     i10 = Math_imul(i2, i49) | 0;
     if (i37) {
      HEAP32[i50 >> 2] = i10;
      HEAP32[i20 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i44 & 255](i11, 1, 0, 1, i12, 1, i50, 0);
      i11 = i12;
     }
     i1 = i36 ? i23 : i11;
     i11 = i36 ? i11 : i23;
     do if (i16) {
      HEAP32[i52 >> 2] = i10;
      HEAP32[i3 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i35 & 255](i1, 1, i11, 1, i22, 1, i52, i74);
      if (i69) {
       HEAP32[i53 >> 2] = i10;
       HEAP32[i4 >> 2] = 1;
       FUNCTION_TABLE_viiiiiiii[i43 & 255](i22, 1, 0, 1, i13, 1, i53, 0);
       break;
      }
      if (i38) {
       HEAP32[i55 >> 2] = i10;
       HEAP32[i5 >> 2] = 1;
       FUNCTION_TABLE_viiiiiiii[i43 & 255](i22, 1, 0, 1, i21, 1, i55, 0);
       i46 = HEAP32[i6 >> 2] | 0;
       HEAP32[i56 >> 2] = i2;
       HEAP32[i7 >> 2] = 1;
       FUNCTION_TABLE_viiiiiiii[i41 & 255](i21, 1, i46, 1, i13, 1, i56, i70);
       HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i2;
       break;
      } else {
       i46 = HEAP32[i6 >> 2] | 0;
       HEAP32[i54 >> 2] = i2;
       HEAP32[i8 >> 2] = 1;
       FUNCTION_TABLE_viiiiiiii[i41 & 255](i22, 1, i46, 1, i13, 1, i54, i70);
       HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i2;
       break;
      }
     } else {
      HEAP32[i51 >> 2] = i10;
      HEAP32[i9 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i35 & 255](i1, 1, i11, 1, i13, 1, i51, i74);
     } while (0);
     i11 = Math_imul(i2, i42) | 0;
     i11 = (HEAP32[i58 >> 2] | 0) + i11 | 0;
     HEAP32[i58 >> 2] = i11;
     i13 = Math_imul(HEAP32[i70 >> 2] | 0, i2) | 0;
     i13 = (HEAP32[i19 >> 2] | 0) + i13 | 0;
     HEAP32[i19 >> 2] = i13;
     i15 = i15 + i24 | 0;
    } while (i27 >>> 0 > i15 >>> 0);
   }
   __ZN2cv15NAryMatIteratorppEv(i57) | 0;
   i14 = i14 + 1 | 0;
  }
 } else {
  HEAP32[i46 >> 2] = i75;
  HEAP32[i46 + 4 >> 2] = i76;
  HEAP32[i46 + 8 >> 2] = i73;
  HEAP32[i46 + 12 >> 2] = i72;
  HEAP32[i46 + 16 >> 2] = 0;
  __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i67, i46, i68, -1);
  i32 = HEAP32[i67 + 20 >> 2] | 0;
  if (i37 | i8 | i23 | i38) i31 = i21 >>> 0 < i32 >>> 0 ? i21 : i32; else i31 = i32;
  i12 = (Math_imul(i31, i12) | 0) + 64 | 0;
  if ((HEAP32[i40 >> 2] | 0) >>> 0 < i12 >>> 0) {
   i11 = HEAP32[i71 >> 2] | 0;
   if ((i11 | 0) != (i39 | 0)) {
    if (i11) __ZdaPv(i11);
    HEAP32[i71 >> 2] = i39;
    HEAP32[i40 >> 2] = 1032;
   }
   if (i12 >>> 0 > 1032) {
    i46 = __Znaj(i12) | 0;
    HEAP32[i71 >> 2] = i46;
    HEAP32[i40 >> 2] = i12;
    i12 = i46;
   } else i12 = i39;
  } else {
   HEAP32[i40 >> 2] = i12;
   i12 = HEAP32[i71 >> 2] | 0;
  }
  if (i37) i11 = i12 + (Math_imul(i31, i28) | 0) + 15 & -16; else {
   i11 = i12;
   i12 = 0;
  }
  if (i23) {
   i30 = i11 + (Math_imul(i31, i28) | 0) + 15 & -16;
   i29 = i11;
  } else {
   i30 = i11;
   i29 = 0;
  }
  if (i38) i11 = i30 + (Math_imul(i31, i28) | 0) + 15 & -16; else i11 = i30;
  i28 = i69 ? i30 : i11;
  i24 = i67 + 16 | 0;
  i20 = (i32 | 0) == 0;
  i25 = i68 + 4 | 0;
  i26 = i68 + 8 | 0;
  i27 = i65 + 4 | 0;
  i19 = i23 ^ 1;
  i18 = i38 | i8;
  i6 = i60 + 4 | 0;
  i5 = i61 + 4 | 0;
  i4 = i63 + 4 | 0;
  i3 = i68 + 12 | 0;
  i2 = i64 + 4 | 0;
  i1 = i62 + 4 | 0;
  i11 = i59 + 4 | 0;
  i13 = i66 + 4 | 0;
  i16 = 0;
  while (1) {
   if (i16 >>> 0 >= (HEAP32[i24 >> 2] | 0) >>> 0) break L219;
   if (!i20) {
    i22 = HEAP32[i68 >> 2] | 0;
    i9 = HEAP32[i25 >> 2] | 0;
    i15 = HEAP32[i26 >> 2] | 0;
    i17 = 0;
    do {
     i7 = i32 - i17 | 0;
     i7 = i7 >>> 0 > i31 >>> 0 ? i31 : i7;
     i14 = Math_imul(i7, i49) | 0;
     if (i37) {
      HEAP32[i65 >> 2] = i14;
      HEAP32[i27 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i44 & 255](i22, 1, 0, 1, i12, 1, i65, 0);
      i23 = HEAP32[i68 >> 2] | 0;
      i10 = HEAP32[i25 >> 2] | 0;
      i8 = i12;
     } else {
      i23 = i22;
      i10 = i9;
      i8 = i22;
     }
     i21 = (i23 | 0) == (i10 | 0);
     if (i21 | i19) i21 = i21 ? i8 : i9; else {
      HEAP32[i66 >> 2] = i14;
      HEAP32[i13 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i34 & 255](i9, 1, 0, 1, i29, 1, i66, 0);
      i21 = i29;
     }
     do if (i18) {
      HEAP32[i60 >> 2] = i14;
      HEAP32[i6 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i35 & 255](i8, 1, i21, 1, i30, 0, i60, i74);
      if (i69) {
       HEAP32[i61 >> 2] = i14;
       HEAP32[i5 >> 2] = 1;
       FUNCTION_TABLE_viiiiiiii[i43 & 255](i30, 1, 0, 1, i15, 1, i61, 0);
       break;
      }
      if (i38) {
       HEAP32[i63 >> 2] = i14;
       HEAP32[i4 >> 2] = 1;
       FUNCTION_TABLE_viiiiiiii[i43 & 255](i30, 1, 0, 1, i28, 1, i63, 0);
       i46 = HEAP32[i3 >> 2] | 0;
       HEAP32[i64 >> 2] = i7;
       HEAP32[i2 >> 2] = 1;
       FUNCTION_TABLE_viiiiiiii[i41 & 255](i28, 1, i46, 1, i15, 1, i64, i70);
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i7;
       break;
      } else {
       i46 = HEAP32[i3 >> 2] | 0;
       HEAP32[i62 >> 2] = i7;
       HEAP32[i1 >> 2] = 1;
       FUNCTION_TABLE_viiiiiiii[i41 & 255](i30, 1, i46, 1, i15, 1, i62, i70);
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i7;
       break;
      }
     } else {
      HEAP32[i59 >> 2] = i14;
      HEAP32[i11 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i35 & 255](i8, 1, i21, 1, i15, 1, i59, i74);
     } while (0);
     i22 = Math_imul(i7, i42) | 0;
     i22 = (HEAP32[i68 >> 2] | 0) + i22 | 0;
     HEAP32[i68 >> 2] = i22;
     i9 = Math_imul(i7, i33) | 0;
     i9 = (HEAP32[i25 >> 2] | 0) + i9 | 0;
     HEAP32[i25 >> 2] = i9;
     i15 = Math_imul(HEAP32[i70 >> 2] | 0, i7) | 0;
     i15 = (HEAP32[i26 >> 2] | 0) + i15 | 0;
     HEAP32[i26 >> 2] = i15;
     i17 = i17 + i31 | 0;
    } while (i32 >>> 0 > i17 >>> 0);
   }
   __ZN2cv15NAryMatIteratorppEv(i67) | 0;
   i16 = i16 + 1 | 0;
  }
 } while (0);
 i3 = HEAP32[i71 >> 2] | 0;
 if ((i3 | 0) != (i39 | 0)) {
  if (i3) __ZdaPv(i3);
  HEAP32[i71 >> 2] = i39;
  HEAP32[i40 >> 2] = 1032;
 }
 i3 = i72 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i45 = i2 + 12 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i72);
 HEAP32[i3 >> 2] = 0;
 i46 = i72 + 16 | 0;
 i3 = i72 + 4 | 0;
 HEAP32[i46 + 0 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 HEAP32[i46 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i72 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i3 = HEAP32[i72 + 44 >> 2] | 0;
 if ((i3 | 0) != (i72 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
 i3 = i73 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i45 = i2 + 12 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i73);
 HEAP32[i3 >> 2] = 0;
 i46 = i73 + 16 | 0;
 i3 = i73 + 4 | 0;
 HEAP32[i46 + 0 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 HEAP32[i46 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i73 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i2 = HEAP32[i73 + 44 >> 2] | 0;
 if ((i2 | 0) != (i73 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i76 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (i1) {
  i45 = i1 + 12 | 0;
  i46 = HEAP32[i45 >> 2] | 0;
  HEAP32[i45 >> 2] = i46 + -1;
  if ((i46 | 0) != 1) break;
  __ZN2cv3Mat10deallocateEv(i76);
 } while (0);
 HEAP32[i2 >> 2] = 0;
 i46 = i76 + 16 | 0;
 i3 = i76 + 4 | 0;
 HEAP32[i46 + 0 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 HEAP32[i46 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i76 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i76 + 44 >> 2] | 0;
 if ((i1 | 0) != (i76 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i75 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (i2) {
  i45 = i2 + 12 | 0;
  i46 = HEAP32[i45 >> 2] | 0;
  HEAP32[i45 >> 2] = i46 + -1;
  if ((i46 | 0) != 1) break;
  __ZN2cv3Mat10deallocateEv(i75);
 } while (0);
 HEAP32[i1 >> 2] = 0;
 i46 = i75 + 16 | 0;
 i2 = i75 + 4 | 0;
 HEAP32[i46 + 0 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 HEAP32[i46 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i75 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i75 + 44 >> 2] | 0;
 if ((i1 | 0) == (i75 + 48 | 0)) {
  STACKTOP = i77;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i77;
 return;
}

function __ZN2cv6invertERKNS_11_InputArrayERKNS_12_OutputArrayEi(i26, i57, i6) {
 i26 = i26 | 0;
 i57 = i57 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, f3 = Math_fround(0), d4 = 0.0, i5 = 0, d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0, d14 = 0.0, d15 = 0.0, d16 = 0.0, d17 = 0.0, d18 = 0.0, d19 = 0.0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0;
 i65 = STACKTOP;
 STACKTOP = STACKTOP + 3856 | 0;
 i64 = i65 + 3792 | 0;
 i23 = i65 + 3784 | 0;
 i63 = i65 + 2744 | 0;
 i62 = i65 + 1704 | 0;
 i61 = i65 + 664 | 0;
 i58 = i65 + 608 | 0;
 i37 = i65 + 588 | 0;
 i38 = i65 + 568 | 0;
 i39 = i65 + 548 | 0;
 i40 = i65 + 528 | 0;
 i46 = i65 + 508 | 0;
 i47 = i65 + 488 | 0;
 i48 = i65 + 468 | 0;
 i49 = i65 + 448 | 0;
 i51 = i65 + 392 | 0;
 i1 = i65 + 384 | 0;
 i20 = i65 + 360 | 0;
 i25 = i65 + 340 | 0;
 i34 = i65 + 320 | 0;
 i35 = i65 + 300 | 0;
 i36 = i65 + 280 | 0;
 i42 = i65 + 260 | 0;
 i43 = i65 + 240 | 0;
 i44 = i65 + 220 | 0;
 i45 = i65 + 200 | 0;
 i50 = i65 + 144 | 0;
 i5 = i65 + 136 | 0;
 i41 = i65 + 64 | 0;
 i28 = i65 + 116 | 0;
 i29 = i65 + 96 | 0;
 i30 = i65 + 32 | 0;
 i31 = i65;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i26 >> 2] >> 2] & 63](i64, i26, -1);
 i52 = HEAP32[i64 >> 2] | 0;
 i53 = i52 & 4095;
 i59 = (i53 | 0) == 5;
 i27 = (i53 | 0) == 6;
 if ((i53 + -5 | 0) >>> 0 >= 2) {
  HEAP32[i23 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = 0;
  i54 = (__ZN2cv6String8allocateEj(i23, 32) | 0) + 0 | 0;
  i24 = 3912 | 0;
  i55 = i54 + 32 | 0;
  do {
   HEAP8[i54 >> 0] = HEAP8[i24 >> 0] | 0;
   i54 = i54 + 1 | 0;
   i24 = i24 + 1 | 0;
  } while ((i54 | 0) < (i55 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i23, 3952, 3856, 940);
  __ZN2cv6String10deallocateEv(i23);
 }
 i33 = (i52 >>> 3 & 511) + 1 | 0;
 i56 = i33 << (47696 >>> (i53 << 1 & 14) & 3);
 i24 = HEAP32[i64 + 8 >> 2] | 0;
 i60 = HEAP32[i64 + 12 >> 2] | 0;
 do if ((i6 | 0) == 1) {
  i23 = (i60 | 0) < (i24 | 0) ? i60 : i24;
  i26 = Math_imul(i23, i24) | 0;
  i6 = (Math_imul(i26 + i23 + (Math_imul(i23, i60) | 0) | 0, i56) | 0) + 8 | 0;
  i50 = i63 + 8 | 0;
  HEAP32[i63 >> 2] = i50;
  i44 = i63 + 4 | 0;
  HEAP32[i44 >> 2] = 1032;
  if (i6 >>> 0 > 1032) {
   i5 = __Znaj(i6) | 0;
   HEAP32[i63 >> 2] = i5;
  } else i5 = i50;
  HEAP32[i44 >> 2] = i6;
  i55 = i56 + -1 + i5 & 0 - i56;
  i41 = i62 + 4 | 0;
  HEAP32[i41 >> 2] = 2;
  i45 = i62 + 8 | 0;
  HEAP32[i45 >> 2] = i24;
  HEAP32[i62 + 12 >> 2] = i23;
  i34 = i62 + 16 | 0;
  HEAP32[i34 >> 2] = i55;
  HEAP32[i62 + 20 >> 2] = i55;
  i54 = i62 + 24 | 0;
  i35 = i62 + 40 | 0;
  HEAP32[i54 + 0 >> 2] = 0;
  HEAP32[i54 + 4 >> 2] = 0;
  HEAP32[i54 + 8 >> 2] = 0;
  HEAP32[i54 + 12 >> 2] = 0;
  HEAP32[i35 >> 2] = i45;
  i45 = i62 + 48 | 0;
  i36 = i62 + 44 | 0;
  HEAP32[i36 >> 2] = i45;
  i43 = i33 << (47696 >>> (i52 << 1 & 14) & 3);
  i2 = Math_imul(i23, i43) | 0;
  i42 = i53 | 1124024320;
  HEAP32[i62 >> 2] = i42;
  HEAP32[i45 >> 2] = i2;
  HEAP32[i62 + 52 >> 2] = i43;
  i24 = i55 + (Math_imul(i24, i2) | 0) | 0;
  HEAP32[i62 + 28 >> 2] = i24;
  HEAP32[i54 >> 2] = i24;
  i54 = Math_imul(i26, i56) | 0;
  i24 = i55 + i54 | 0;
  i32 = i61 + 4 | 0;
  HEAP32[i32 >> 2] = 2;
  i33 = i61 + 8 | 0;
  HEAP32[i33 >> 2] = i23;
  HEAP32[i61 + 12 >> 2] = 1;
  i31 = i61 + 16 | 0;
  HEAP32[i31 >> 2] = i24;
  HEAP32[i61 + 20 >> 2] = i24;
  i24 = i61 + 24 | 0;
  i30 = i61 + 40 | 0;
  HEAP32[i24 + 0 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  HEAP32[i24 + 12 >> 2] = 0;
  HEAP32[i30 >> 2] = i33;
  i33 = i61 + 48 | 0;
  i29 = i61 + 44 | 0;
  HEAP32[i29 >> 2] = i33;
  HEAP32[i61 >> 2] = i42;
  HEAP32[i33 >> 2] = i43;
  HEAP32[i61 + 52 >> 2] = i43;
  i2 = i55 + (i2 + i54) | 0;
  HEAP32[i61 + 28 >> 2] = i2;
  HEAP32[i24 >> 2] = i2;
  i24 = i55 + (Math_imul(i56, i26 + i23 | 0) | 0) | 0;
  i2 = i58 + 4 | 0;
  HEAP32[i2 >> 2] = 2;
  i28 = i58 + 8 | 0;
  HEAP32[i28 >> 2] = i23;
  HEAP32[i58 + 12 >> 2] = i60;
  i21 = i58 + 16 | 0;
  HEAP32[i21 >> 2] = i24;
  HEAP32[i58 + 20 >> 2] = i24;
  i24 = i58 + 24 | 0;
  i22 = i58 + 40 | 0;
  HEAP32[i24 + 0 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  HEAP32[i24 + 12 >> 2] = 0;
  HEAP32[i22 >> 2] = i28;
  i28 = i58 + 48 | 0;
  i27 = i58 + 44 | 0;
  HEAP32[i27 >> 2] = i28;
  i25 = Math_imul(i60, i43) | 0;
  HEAP32[i58 >> 2] = i42;
  HEAP32[i28 >> 2] = i25;
  HEAP32[i58 + 52 >> 2] = i43;
  i25 = i55 + (i54 + (Math_imul(i23, i25 + i56 | 0) | 0)) | 0;
  HEAP32[i58 + 28 >> 2] = i25;
  HEAP32[i24 >> 2] = i25;
  HEAP32[i37 >> 2] = 32088;
  HEAP32[i37 + 12 >> 2] = 0;
  HEAP32[i37 + 16 >> 2] = 0;
  HEAP32[i37 + 4 >> 2] = 16842752;
  HEAP32[i37 + 8 >> 2] = i64;
  i24 = i38 + 4 | 0;
  HEAP32[i24 + 0 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  HEAP32[i24 + 12 >> 2] = 0;
  HEAP32[i38 >> 2] = 32232;
  HEAP32[i24 >> 2] = 33619968;
  HEAP32[i38 + 8 >> 2] = i61;
  i24 = i39 + 4 | 0;
  HEAP32[i24 + 0 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  HEAP32[i24 + 12 >> 2] = 0;
  HEAP32[i39 >> 2] = 32232;
  HEAP32[i24 >> 2] = 33619968;
  HEAP32[i39 + 8 >> 2] = i62;
  i24 = i40 + 4 | 0;
  HEAP32[i24 + 0 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  HEAP32[i24 + 12 >> 2] = 0;
  HEAP32[i40 >> 2] = 32232;
  HEAP32[i24 >> 2] = 33619968;
  HEAP32[i40 + 8 >> 2] = i58;
  __ZN2cvL11_SVDcomputeERKNS_11_InputArrayERKNS_12_OutputArrayES5_S5_i(i37, i38, i39, i40, 0);
  HEAP32[i46 >> 2] = 32088;
  HEAP32[i46 + 12 >> 2] = 0;
  HEAP32[i46 + 16 >> 2] = 0;
  HEAP32[i46 + 4 >> 2] = 16842752;
  HEAP32[i46 + 8 >> 2] = i61;
  HEAP32[i47 >> 2] = 32088;
  HEAP32[i47 + 12 >> 2] = 0;
  HEAP32[i47 + 16 >> 2] = 0;
  HEAP32[i47 + 4 >> 2] = 16842752;
  HEAP32[i47 + 8 >> 2] = i62;
  HEAP32[i48 >> 2] = 32088;
  HEAP32[i48 + 12 >> 2] = 0;
  HEAP32[i48 + 16 >> 2] = 0;
  HEAP32[i48 + 4 >> 2] = 16842752;
  HEAP32[i48 + 8 >> 2] = i58;
  HEAP32[i51 >> 2] = 1124007936;
  i24 = i51 + 4 | 0;
  i25 = i51 + 8 | 0;
  i23 = i51 + 40 | 0;
  i54 = i24 + 0 | 0;
  i55 = i54 + 36 | 0;
  do {
   HEAP32[i54 >> 2] = 0;
   i54 = i54 + 4 | 0;
  } while ((i54 | 0) < (i55 | 0));
  HEAP32[i23 >> 2] = i25;
  i1 = i51 + 48 | 0;
  i26 = i51 + 44 | 0;
  HEAP32[i26 >> 2] = i1;
  HEAP32[i51 + 52 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i49 >> 2] = 32088;
  HEAP32[i49 + 12 >> 2] = 0;
  HEAP32[i49 + 16 >> 2] = 0;
  HEAP32[i49 + 4 >> 2] = 16842752;
  HEAP32[i49 + 8 >> 2] = i51;
  __ZN2cv3SVD9backSubstERKNS_11_InputArrayES3_S3_S3_RKNS_12_OutputArrayE(i46, i47, i48, i49, i57);
  i20 = i51 + 36 | 0;
  i6 = HEAP32[i20 >> 2] | 0;
  if ((i6 | 0) != 0 ? (i56 = i6 + 12 | 0, i57 = HEAP32[i56 >> 2] | 0, HEAP32[i56 >> 2] = i57 + -1, (i57 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i51);
  HEAP32[i20 >> 2] = 0;
  i57 = i51 + 16 | 0;
  HEAP32[i57 + 0 >> 2] = 0;
  HEAP32[i57 + 4 >> 2] = 0;
  HEAP32[i57 + 8 >> 2] = 0;
  HEAP32[i57 + 12 >> 2] = 0;
  if ((HEAP32[i24 >> 2] | 0) > 0) {
   i6 = HEAP32[i23 >> 2] | 0;
   i20 = 0;
   do {
    HEAP32[i6 + (i20 << 2) >> 2] = 0;
    i20 = i20 + 1 | 0;
   } while ((i20 | 0) < (HEAP32[i24 >> 2] | 0));
  }
  i6 = HEAP32[i26 >> 2] | 0;
  if ((i6 | 0) != (i1 | 0)) __ZN2cv8fastFreeEPv(i6);
  i6 = HEAP32[i31 >> 2] | 0;
  if (i59) {
   f3 = Math_fround(HEAPF32[i6 >> 2]);
   if (!(f3 >= Math_fround(1.1920929e-07))) d4 = 0.0; else d4 = +Math_fround(Math_fround(HEAPF32[i6 + (i60 + -1 << 2) >> 2]) / f3);
  } else {
   d19 = +HEAPF64[i6 >> 3];
   if (!(d19 >= 2.220446049250313e-16)) d4 = 0.0; else d4 = +HEAPF64[i6 + (i60 + -1 << 3) >> 3] / d19;
  }
  i6 = i58 + 36 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  if ((i5 | 0) != 0 ? (i59 = i5 + 12 | 0, i60 = HEAP32[i59 >> 2] | 0, HEAP32[i59 >> 2] = i60 + -1, (i60 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i58);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i21 + 0 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  HEAP32[i21 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i6 = HEAP32[i22 >> 2] | 0;
   i5 = 0;
   do {
    HEAP32[i6 + (i5 << 2) >> 2] = 0;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i6 = HEAP32[i27 >> 2] | 0;
  if ((i6 | 0) != (i28 | 0)) __ZN2cv8fastFreeEPv(i6);
  i6 = i61 + 36 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  if ((i5 | 0) != 0 ? (i59 = i5 + 12 | 0, i60 = HEAP32[i59 >> 2] | 0, HEAP32[i59 >> 2] = i60 + -1, (i60 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i61);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i31 + 0 >> 2] = 0;
  HEAP32[i31 + 4 >> 2] = 0;
  HEAP32[i31 + 8 >> 2] = 0;
  HEAP32[i31 + 12 >> 2] = 0;
  if ((HEAP32[i32 >> 2] | 0) > 0) {
   i6 = HEAP32[i30 >> 2] | 0;
   i5 = 0;
   do {
    HEAP32[i6 + (i5 << 2) >> 2] = 0;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < (HEAP32[i32 >> 2] | 0));
  }
  i6 = HEAP32[i29 >> 2] | 0;
  if ((i6 | 0) != (i33 | 0)) __ZN2cv8fastFreeEPv(i6);
  i6 = i62 + 36 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  if ((i5 | 0) != 0 ? (i60 = i5 + 12 | 0, i61 = HEAP32[i60 >> 2] | 0, HEAP32[i60 >> 2] = i61 + -1, (i61 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i62);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i34 + 0 >> 2] = 0;
  HEAP32[i34 + 4 >> 2] = 0;
  HEAP32[i34 + 8 >> 2] = 0;
  HEAP32[i34 + 12 >> 2] = 0;
  if ((HEAP32[i41 >> 2] | 0) > 0) {
   i6 = HEAP32[i35 >> 2] | 0;
   i5 = 0;
   do {
    HEAP32[i6 + (i5 << 2) >> 2] = 0;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < (HEAP32[i41 >> 2] | 0));
  }
  i5 = HEAP32[i36 >> 2] | 0;
  if ((i5 | 0) != (i45 | 0)) __ZN2cv8fastFreeEPv(i5);
  i5 = HEAP32[i63 >> 2] | 0;
  if ((i5 | 0) != (i50 | 0)) {
   if (i5) __ZdaPv(i5);
   HEAP32[i63 >> 2] = i50;
   HEAP32[i44 >> 2] = 1032;
  }
 } else {
  if ((i24 | 0) != (i60 | 0)) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i55 = __ZN2cv6String8allocateEj(i1, 6) | 0;
   HEAP8[i55 + 0 >> 0] = HEAP8[3960] | 0;
   HEAP8[i55 + 1 >> 0] = HEAP8[3961] | 0;
   HEAP8[i55 + 2 >> 0] = HEAP8[3962] | 0;
   HEAP8[i55 + 3 >> 0] = HEAP8[3963] | 0;
   HEAP8[i55 + 4 >> 0] = HEAP8[3964] | 0;
   HEAP8[i55 + 5 >> 0] = HEAP8[3965] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 3952, 3856, 964);
   __ZN2cv6String10deallocateEv(i1);
  }
  if ((i6 | 0) == 2) {
   i26 = Math_imul(i60, i60) | 0;
   i6 = (Math_imul((i26 << 1) + i60 | 0, i56) | 0) + 8 | 0;
   i47 = i62 + 8 | 0;
   HEAP32[i62 >> 2] = i47;
   i46 = i62 + 4 | 0;
   HEAP32[i46 >> 2] = 1032;
   if (i6 >>> 0 > 1032) {
    i5 = __Znaj(i6) | 0;
    HEAP32[i62 >> 2] = i5;
   } else i5 = i47;
   HEAP32[i46 >> 2] = i6;
   i55 = i56 + -1 + i5 & 0 - i56;
   i40 = i63 + 4 | 0;
   HEAP32[i40 >> 2] = 2;
   i41 = i63 + 8 | 0;
   HEAP32[i41 >> 2] = i60;
   HEAP32[i63 + 12 >> 2] = i60;
   i38 = i63 + 16 | 0;
   HEAP32[i38 >> 2] = i55;
   HEAP32[i63 + 20 >> 2] = i55;
   i54 = i63 + 24 | 0;
   i37 = i63 + 40 | 0;
   HEAP32[i54 + 0 >> 2] = 0;
   HEAP32[i54 + 4 >> 2] = 0;
   HEAP32[i54 + 8 >> 2] = 0;
   HEAP32[i54 + 12 >> 2] = 0;
   HEAP32[i37 >> 2] = i41;
   i41 = i63 + 48 | 0;
   i39 = i63 + 44 | 0;
   HEAP32[i39 >> 2] = i41;
   i51 = i33 << (47696 >>> (i52 << 1 & 14) & 3);
   i23 = Math_imul(i60, i51) | 0;
   i49 = i53 | 1124024320;
   HEAP32[i63 >> 2] = i49;
   HEAP32[i41 >> 2] = i23;
   HEAP32[i63 + 52 >> 2] = i51;
   i24 = i55 + (Math_imul(i60, i23) | 0) | 0;
   HEAP32[i63 + 28 >> 2] = i24;
   HEAP32[i54 >> 2] = i24;
   i54 = Math_imul(i26, i56) | 0;
   i24 = i55 + i54 | 0;
   i32 = i61 + 4 | 0;
   HEAP32[i32 >> 2] = 2;
   i33 = i61 + 8 | 0;
   HEAP32[i33 >> 2] = i60;
   HEAP32[i61 + 12 >> 2] = 1;
   i31 = i61 + 16 | 0;
   HEAP32[i31 >> 2] = i24;
   HEAP32[i61 + 20 >> 2] = i24;
   i24 = i61 + 24 | 0;
   i30 = i61 + 40 | 0;
   HEAP32[i24 + 0 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i24 + 12 >> 2] = 0;
   HEAP32[i30 >> 2] = i33;
   i33 = i61 + 48 | 0;
   i29 = i61 + 44 | 0;
   HEAP32[i29 >> 2] = i33;
   HEAP32[i61 >> 2] = i49;
   HEAP32[i33 >> 2] = i51;
   HEAP32[i61 + 52 >> 2] = i51;
   i27 = i55 + (i23 + i54) | 0;
   HEAP32[i61 + 28 >> 2] = i27;
   HEAP32[i24 >> 2] = i27;
   i24 = i55 + (Math_imul(i56, i26 + i60 | 0) | 0) | 0;
   i27 = i58 + 4 | 0;
   HEAP32[i27 >> 2] = 2;
   i28 = i58 + 8 | 0;
   HEAP32[i28 >> 2] = i60;
   HEAP32[i58 + 12 >> 2] = i60;
   i21 = i58 + 16 | 0;
   HEAP32[i21 >> 2] = i24;
   HEAP32[i58 + 20 >> 2] = i24;
   i24 = i58 + 24 | 0;
   i22 = i58 + 40 | 0;
   HEAP32[i24 + 0 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i24 + 12 >> 2] = 0;
   HEAP32[i22 >> 2] = i28;
   i28 = i58 + 48 | 0;
   i2 = i58 + 44 | 0;
   HEAP32[i2 >> 2] = i28;
   HEAP32[i58 >> 2] = i49;
   HEAP32[i28 >> 2] = i23;
   HEAP32[i58 + 52 >> 2] = i51;
   i23 = i55 + (i54 + (Math_imul(i60, i23 + i56 | 0) | 0)) | 0;
   HEAP32[i58 + 28 >> 2] = i23;
   HEAP32[i24 >> 2] = i23;
   HEAP32[i20 >> 2] = 32088;
   HEAP32[i20 + 12 >> 2] = 0;
   HEAP32[i20 + 16 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 16842752;
   HEAP32[i20 + 8 >> 2] = i64;
   i24 = i25 + 4 | 0;
   HEAP32[i24 + 0 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i24 + 12 >> 2] = 0;
   HEAP32[i25 >> 2] = 32232;
   HEAP32[i24 >> 2] = 33619968;
   HEAP32[i25 + 8 >> 2] = i61;
   i24 = i34 + 4 | 0;
   HEAP32[i24 + 0 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i24 + 12 >> 2] = 0;
   HEAP32[i34 >> 2] = 32232;
   HEAP32[i24 >> 2] = 33619968;
   HEAP32[i34 + 8 >> 2] = i58;
   __ZN2cv5eigenERKNS_11_InputArrayERKNS_12_OutputArrayES5_(i20, i25, i34) | 0;
   HEAP32[i35 >> 2] = 32088;
   HEAP32[i35 + 12 >> 2] = 0;
   HEAP32[i35 + 16 >> 2] = 0;
   HEAP32[i35 + 4 >> 2] = 16842752;
   HEAP32[i35 + 8 >> 2] = i58;
   i24 = i36 + 4 | 0;
   HEAP32[i24 + 0 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i24 + 12 >> 2] = 0;
   HEAP32[i36 >> 2] = 32232;
   HEAP32[i24 >> 2] = 33619968;
   HEAP32[i36 + 8 >> 2] = i63;
   __ZN2cv9transposeERKNS_11_InputArrayERKNS_12_OutputArrayE(i35, i36);
   HEAP32[i42 >> 2] = 32088;
   HEAP32[i42 + 12 >> 2] = 0;
   HEAP32[i42 + 16 >> 2] = 0;
   HEAP32[i42 + 4 >> 2] = 16842752;
   HEAP32[i42 + 8 >> 2] = i61;
   HEAP32[i43 >> 2] = 32088;
   HEAP32[i43 + 12 >> 2] = 0;
   HEAP32[i43 + 16 >> 2] = 0;
   HEAP32[i43 + 4 >> 2] = 16842752;
   HEAP32[i43 + 8 >> 2] = i63;
   HEAP32[i44 >> 2] = 32088;
   HEAP32[i44 + 12 >> 2] = 0;
   HEAP32[i44 + 16 >> 2] = 0;
   HEAP32[i44 + 4 >> 2] = 16842752;
   HEAP32[i44 + 8 >> 2] = i58;
   HEAP32[i50 >> 2] = 1124007936;
   i24 = i50 + 4 | 0;
   i25 = i50 + 8 | 0;
   i23 = i50 + 40 | 0;
   i54 = i24 + 0 | 0;
   i55 = i54 + 36 | 0;
   do {
    HEAP32[i54 >> 2] = 0;
    i54 = i54 + 4 | 0;
   } while ((i54 | 0) < (i55 | 0));
   HEAP32[i23 >> 2] = i25;
   i1 = i50 + 48 | 0;
   i26 = i50 + 44 | 0;
   HEAP32[i26 >> 2] = i1;
   HEAP32[i50 + 52 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i45 >> 2] = 32088;
   HEAP32[i45 + 12 >> 2] = 0;
   HEAP32[i45 + 16 >> 2] = 0;
   HEAP32[i45 + 4 >> 2] = 16842752;
   HEAP32[i45 + 8 >> 2] = i50;
   __ZN2cv3SVD9backSubstERKNS_11_InputArrayES3_S3_S3_RKNS_12_OutputArrayE(i42, i43, i44, i45, i57);
   i20 = i50 + 36 | 0;
   i6 = HEAP32[i20 >> 2] | 0;
   if ((i6 | 0) != 0 ? (i56 = i6 + 12 | 0, i57 = HEAP32[i56 >> 2] | 0, HEAP32[i56 >> 2] = i57 + -1, (i57 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i50);
   HEAP32[i20 >> 2] = 0;
   i57 = i50 + 16 | 0;
   HEAP32[i57 + 0 >> 2] = 0;
   HEAP32[i57 + 4 >> 2] = 0;
   HEAP32[i57 + 8 >> 2] = 0;
   HEAP32[i57 + 12 >> 2] = 0;
   if ((HEAP32[i24 >> 2] | 0) > 0) {
    i6 = HEAP32[i23 >> 2] | 0;
    i20 = 0;
    do {
     HEAP32[i6 + (i20 << 2) >> 2] = 0;
     i20 = i20 + 1 | 0;
    } while ((i20 | 0) < (HEAP32[i24 >> 2] | 0));
   }
   i6 = HEAP32[i26 >> 2] | 0;
   if ((i6 | 0) != (i1 | 0)) __ZN2cv8fastFreeEPv(i6);
   i6 = HEAP32[i31 >> 2] | 0;
   if (i59) {
    f3 = Math_fround(HEAPF32[i6 >> 2]);
    if (!(f3 >= Math_fround(1.1920929e-07))) d4 = 0.0; else d4 = +Math_fround(Math_fround(HEAPF32[i6 + (i60 + -1 << 2) >> 2]) / f3);
   } else {
    d19 = +HEAPF64[i6 >> 3];
    if (!(d19 >= 2.220446049250313e-16)) d4 = 0.0; else d4 = +HEAPF64[i6 + (i60 + -1 << 3) >> 3] / d19;
   }
   i6 = i58 + 36 | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   if ((i5 | 0) != 0 ? (i59 = i5 + 12 | 0, i60 = HEAP32[i59 >> 2] | 0, HEAP32[i59 >> 2] = i60 + -1, (i60 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i58);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i21 + 0 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   HEAP32[i21 + 8 >> 2] = 0;
   HEAP32[i21 + 12 >> 2] = 0;
   if ((HEAP32[i27 >> 2] | 0) > 0) {
    i6 = HEAP32[i22 >> 2] | 0;
    i5 = 0;
    do {
     HEAP32[i6 + (i5 << 2) >> 2] = 0;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) < (HEAP32[i27 >> 2] | 0));
   }
   i6 = HEAP32[i2 >> 2] | 0;
   if ((i6 | 0) != (i28 | 0)) __ZN2cv8fastFreeEPv(i6);
   i6 = i61 + 36 | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   if ((i5 | 0) != 0 ? (i59 = i5 + 12 | 0, i60 = HEAP32[i59 >> 2] | 0, HEAP32[i59 >> 2] = i60 + -1, (i60 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i61);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i31 + 0 >> 2] = 0;
   HEAP32[i31 + 4 >> 2] = 0;
   HEAP32[i31 + 8 >> 2] = 0;
   HEAP32[i31 + 12 >> 2] = 0;
   if ((HEAP32[i32 >> 2] | 0) > 0) {
    i6 = HEAP32[i30 >> 2] | 0;
    i5 = 0;
    do {
     HEAP32[i6 + (i5 << 2) >> 2] = 0;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) < (HEAP32[i32 >> 2] | 0));
   }
   i6 = HEAP32[i29 >> 2] | 0;
   if ((i6 | 0) != (i33 | 0)) __ZN2cv8fastFreeEPv(i6);
   i6 = i63 + 36 | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   if ((i5 | 0) != 0 ? (i60 = i5 + 12 | 0, i61 = HEAP32[i60 >> 2] | 0, HEAP32[i60 >> 2] = i61 + -1, (i61 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i63);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i38 + 0 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = 0;
   HEAP32[i38 + 12 >> 2] = 0;
   if ((HEAP32[i40 >> 2] | 0) > 0) {
    i6 = HEAP32[i37 >> 2] | 0;
    i5 = 0;
    do {
     HEAP32[i6 + (i5 << 2) >> 2] = 0;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) < (HEAP32[i40 >> 2] | 0));
   }
   i5 = HEAP32[i39 >> 2] | 0;
   if ((i5 | 0) != (i41 | 0)) __ZN2cv8fastFreeEPv(i5);
   i5 = HEAP32[i62 >> 2] | 0;
   if ((i5 | 0) == (i47 | 0)) break;
   if (i5) __ZdaPv(i5);
   HEAP32[i62 >> 2] = i47;
   HEAP32[i46 >> 2] = 1032;
   break;
  }
  i2 = (i6 | 0) == 0;
  i26 = (i6 | 0) == 3;
  if (!((i6 | 0) == 0 | (i6 | 0) == 3)) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i54 = (__ZN2cv6String8allocateEj(i5, 48) | 0) + 0 | 0;
   i24 = 3968 | 0;
   i55 = i54 + 48 | 0;
   do {
    HEAP8[i54 >> 0] = HEAP8[i24 >> 0] | 0;
    i54 = i54 + 1 | 0;
    i24 = i24 + 1 | 0;
   } while ((i54 | 0) < (i55 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 3952, 3856, 984);
   __ZN2cv6String10deallocateEv(i5);
  }
  FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i57 >> 2] | 0) + 140 >> 2] & 63](i57, i60, i60, i53, -1, 0, 0);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i57 >> 2] >> 2] & 63](i63, i57, -1);
  L76 : do if ((i60 | 0) >= 4) {
   i6 = Math_imul(Math_imul(i60, i56) | 0, i60) | 0;
   i24 = i61 + 8 | 0;
   HEAP32[i61 >> 2] = i24;
   i25 = i61 + 4 | 0;
   HEAP32[i25 >> 2] = 1032;
   if (i6 >>> 0 > 1032) {
    i5 = __Znaj(i6) | 0;
    HEAP32[i61 >> 2] = i5;
   } else i5 = i24;
   HEAP32[i25 >> 2] = i6;
   i21 = i62 + 4 | 0;
   HEAP32[i21 >> 2] = 2;
   i23 = i62 + 8 | 0;
   HEAP32[i23 >> 2] = i60;
   HEAP32[i62 + 12 >> 2] = i60;
   i1 = i62 + 16 | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i62 + 20 >> 2] = i5;
   i58 = i62 + 24 | 0;
   i20 = i62 + 40 | 0;
   HEAP32[i58 + 0 >> 2] = 0;
   HEAP32[i58 + 4 >> 2] = 0;
   HEAP32[i58 + 8 >> 2] = 0;
   HEAP32[i58 + 12 >> 2] = 0;
   HEAP32[i20 >> 2] = i23;
   i23 = i62 + 48 | 0;
   i22 = i62 + 44 | 0;
   HEAP32[i22 >> 2] = i23;
   i56 = i33 << (47696 >>> (i52 << 1 & 14) & 3);
   i57 = Math_imul(i60, i56) | 0;
   HEAP32[i62 >> 2] = i53 | 1124024320;
   HEAP32[i23 >> 2] = i57;
   HEAP32[i62 + 52 >> 2] = i56;
   i57 = i5 + (Math_imul(i60, i57) | 0) | 0;
   HEAP32[i62 + 28 >> 2] = i57;
   HEAP32[i58 >> 2] = i57;
   i58 = i28 + 4 | 0;
   HEAP32[i58 + 0 >> 2] = 0;
   HEAP32[i58 + 4 >> 2] = 0;
   HEAP32[i58 + 8 >> 2] = 0;
   HEAP32[i58 + 12 >> 2] = 0;
   HEAP32[i28 >> 2] = 32232;
   HEAP32[i58 >> 2] = 33619968;
   HEAP32[i28 + 8 >> 2] = i62;
   __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i64, i28);
   i58 = i29 + 4 | 0;
   HEAP32[i58 + 0 >> 2] = 0;
   HEAP32[i58 + 4 >> 2] = 0;
   HEAP32[i58 + 8 >> 2] = 0;
   HEAP32[i58 + 12 >> 2] = 0;
   HEAP32[i29 >> 2] = 3136;
   HEAP32[i58 >> 2] = 50397184;
   HEAP32[i29 + 8 >> 2] = i63;
   HEAPF64[i30 >> 3] = 1.0;
   i58 = i30 + 8 | 0;
   HEAP32[i58 + 0 >> 2] = 0;
   HEAP32[i58 + 4 >> 2] = 0;
   HEAP32[i58 + 8 >> 2] = 0;
   HEAP32[i58 + 12 >> 2] = 0;
   HEAP32[i58 + 16 >> 2] = 0;
   HEAP32[i58 + 20 >> 2] = 0;
   __ZN2cv11setIdentityERKNS_17_InputOutputArrayERKNS_7Scalar_IdEE(i29, i30);
   do if (i2 & i59) if (!(__ZN2cv2LUEPfjiS0_ji(HEAP32[i1 >> 2] | 0, HEAP32[i23 >> 2] | 0, i60, HEAP32[i63 + 16 >> 2] | 0, HEAP32[i63 + 48 >> 2] | 0, i60) | 0)) i32 = 122; else i6 = 1; else {
    if (i2 & i27) if (!(__ZN2cv2LUEPdjiS0_ji(HEAP32[i1 >> 2] | 0, HEAP32[i23 >> 2] | 0, i60, HEAP32[i63 + 16 >> 2] | 0, HEAP32[i63 + 48 >> 2] | 0, i60) | 0)) {
     i32 = 122;
     break;
    } else {
     i6 = 1;
     break;
    }
    i6 = HEAP32[i1 >> 2] | 0;
    if (i26 & i59) if (__ZN2cv8CholeskyEPfjiS0_ji(i6, HEAP32[i23 >> 2] | 0, i60, HEAP32[i63 + 16 >> 2] | 0, HEAP32[i63 + 48 >> 2] | 0, i60) | 0) {
     i6 = 1;
     break;
    } else {
     i32 = 122;
     break;
    } else if (__ZN2cv8CholeskyEPdjiS0_ji(i6, HEAP32[i23 >> 2] | 0, i60, HEAP32[i63 + 16 >> 2] | 0, HEAP32[i63 + 48 >> 2] | 0, i60) | 0) {
     i6 = 1;
     break;
    } else {
     i32 = 122;
     break;
    }
   } while (0);
   if ((i32 | 0) == 122) {
    HEAP32[i31 + 0 >> 2] = 0;
    HEAP32[i31 + 4 >> 2] = 0;
    HEAP32[i31 + 8 >> 2] = 0;
    HEAP32[i31 + 12 >> 2] = 0;
    HEAP32[i31 + 16 >> 2] = 0;
    HEAP32[i31 + 20 >> 2] = 0;
    HEAP32[i31 + 24 >> 2] = 0;
    HEAP32[i31 + 28 >> 2] = 0;
    __ZN2cv3MataSERKNS_7Scalar_IdEE(i63, i31) | 0;
    i6 = 0;
   }
   i5 = i62 + 36 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) != 0 ? (i59 = i2 + 12 | 0, i60 = HEAP32[i59 >> 2] | 0, HEAP32[i59 >> 2] = i60 + -1, (i60 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i62);
   HEAP32[i5 >> 2] = 0;
   HEAP32[i1 + 0 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   if ((HEAP32[i21 >> 2] | 0) > 0) {
    i5 = HEAP32[i20 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i5 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i21 >> 2] | 0));
   }
   i5 = HEAP32[i22 >> 2] | 0;
   if ((i5 | 0) != (i23 | 0)) __ZN2cv8fastFreeEPv(i5);
   i5 = HEAP32[i61 >> 2] | 0;
   if ((i5 | 0) != (i24 | 0)) {
    if (i5) __ZdaPv(i5);
    HEAP32[i61 >> 2] = i24;
    HEAP32[i25 >> 2] = 1032;
   }
  } else {
   i26 = HEAP32[i64 + 16 >> 2] | 0;
   i1 = HEAP32[i63 + 16 >> 2] | 0;
   i6 = HEAP32[i64 + 48 >> 2] | 0;
   i23 = HEAP32[i63 + 48 >> 2] | 0;
   do if ((i60 | 0) == 2) if (i59) {
    d8 = +Math_fround(HEAPF32[i26 >> 2]);
    i5 = i26 + i6 | 0;
    d7 = +Math_fround(HEAPF32[i26 + (i6 + 4) >> 2]);
    i6 = i26 + 4 | 0;
    d4 = +Math_fround(HEAPF32[i6 >> 2]);
    d4 = d8 * d7 - d4 * +Math_fround(HEAPF32[i5 >> 2]);
    if (!(d4 != 0.0)) break;
    d14 = 1.0 / d4;
    HEAPF32[i1 + (i23 + 4) >> 2] = Math_fround(d8 * d14);
    HEAPF32[i1 >> 2] = Math_fround(d7 * d14);
    d13 = d14 * +Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
    d14 = d14 * +Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
    HEAPF32[i1 + 4 >> 2] = Math_fround(d13);
    HEAPF32[i1 + i23 >> 2] = Math_fround(d14);
    i6 = 1;
    break L76;
   } else {
    d8 = +HEAPF64[i26 >> 3];
    i5 = i26 + i6 | 0;
    d7 = +HEAPF64[i26 + (i6 + 8) >> 3];
    i6 = i26 + 8 | 0;
    d4 = d8 * d7 - +HEAPF64[i6 >> 3] * +HEAPF64[i5 >> 3];
    if (!(d4 != 0.0)) break;
    d13 = 1.0 / d4;
    HEAPF64[i1 + (i23 + 8) >> 3] = d8 * d13;
    HEAPF64[i1 >> 3] = d7 * d13;
    d14 = -(d13 * +HEAPF64[i5 >> 3]);
    HEAPF64[i1 + 8 >> 3] = -(d13 * +HEAPF64[i6 >> 3]);
    HEAPF64[i1 + i23 >> 3] = d14;
    i6 = 1;
    break L76;
   } else if ((i60 | 0) == 3) if (i59) {
    d13 = +Math_fround(HEAPF32[i26 >> 2]);
    d14 = +Math_fround(HEAPF32[i26 + (i6 + 4) >> 2]);
    i61 = i6 << 1;
    d15 = +Math_fround(HEAPF32[i26 + (i61 + 8) >> 2]);
    d16 = +Math_fround(HEAPF32[i26 + (i6 + 8) >> 2]);
    d17 = +Math_fround(HEAPF32[i26 + (i61 + 4) >> 2]);
    d18 = d14 * d15 - d16 * d17;
    d19 = +Math_fround(HEAPF32[i26 + 4 >> 2]);
    d9 = +Math_fround(HEAPF32[i26 + i6 >> 2]);
    d10 = d15 * d9;
    d11 = +Math_fround(HEAPF32[i26 + i61 >> 2]);
    d12 = d16 * d11;
    d8 = +Math_fround(HEAPF32[i26 + 8 >> 2]);
    d7 = d17 * d9 - d14 * d11;
    d4 = d8 * d7 + (d13 * d18 - d19 * (d10 - d12));
    if (!(d4 != 0.0)) break;
    d4 = 1.0 / d4;
    HEAPF32[i1 >> 2] = Math_fround(d18 * d4);
    HEAPF32[i1 + 4 >> 2] = Math_fround((d17 * d8 - d15 * d19) * d4);
    HEAPF32[i1 + 8 >> 2] = Math_fround((d16 * d19 - d14 * d8) * d4);
    HEAPF32[i1 + i23 >> 2] = Math_fround((d12 - d10) * d4);
    HEAPF32[i1 + (i23 + 4) >> 2] = Math_fround((d13 * d15 - d11 * d8) * d4);
    HEAPF32[i1 + (i23 + 8) >> 2] = Math_fround((d9 * d8 - d13 * d16) * d4);
    i6 = i23 << 1;
    HEAPF32[i1 + i6 >> 2] = Math_fround(d7 * d4);
    HEAPF32[i1 + (i6 + 4) >> 2] = Math_fround((d19 * d11 - d13 * d17) * d4);
    HEAPF32[i1 + (i6 + 8) >> 2] = Math_fround((d13 * d14 - d19 * d9) * d4);
    i6 = 1;
    break L76;
   } else {
    d19 = +HEAPF64[i26 >> 3];
    d18 = +HEAPF64[i26 + (i6 + 8) >> 3];
    i61 = i6 << 1;
    d17 = +HEAPF64[i26 + (i61 + 16) >> 3];
    d16 = +HEAPF64[i26 + (i6 + 16) >> 3];
    d15 = +HEAPF64[i26 + (i61 + 8) >> 3];
    d13 = d18 * d17 - d16 * d15;
    d14 = +HEAPF64[i26 + 8 >> 3];
    d12 = +HEAPF64[i26 + i6 >> 3];
    d11 = d17 * d12;
    d10 = +HEAPF64[i26 + i61 >> 3];
    d9 = d16 * d10;
    d8 = +HEAPF64[i26 + 16 >> 3];
    d7 = d15 * d12 - d18 * d10;
    d4 = d8 * d7 + (d19 * d13 - d14 * (d11 - d9));
    if (!(d4 != 0.0)) break;
    d4 = 1.0 / d4;
    HEAPF64[i1 >> 3] = d13 * d4;
    HEAPF64[i1 + 8 >> 3] = (d15 * d8 - d17 * d14) * d4;
    HEAPF64[i1 + 16 >> 3] = (d16 * d14 - d18 * d8) * d4;
    HEAPF64[i1 + i23 >> 3] = (d9 - d11) * d4;
    HEAPF64[i1 + (i23 + 8) >> 3] = (d19 * d17 - d10 * d8) * d4;
    HEAPF64[i1 + (i23 + 16) >> 3] = (d12 * d8 - d19 * d16) * d4;
    i6 = i23 << 1;
    HEAPF64[i1 + i6 >> 3] = d7 * d4;
    HEAPF64[i1 + (i6 + 8) >> 3] = (d14 * d10 - d19 * d15) * d4;
    HEAPF64[i1 + (i6 + 16) >> 3] = (d19 * d18 - d14 * d12) * d4;
    i6 = 1;
    break L76;
   } else if (i59) {
    f3 = Math_fround(HEAPF32[i26 >> 2]);
    if (!(f3 != Math_fround(0.0))) break;
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(1.0) / f3);
    i6 = 1;
    break L76;
   } else {
    d4 = +HEAPF64[i26 >> 3];
    if (!(d4 != 0.0)) break;
    HEAPF64[i1 >> 3] = 1.0 / d4;
    i6 = 1;
    break L76;
   } while (0);
   HEAP32[i41 + 0 >> 2] = 0;
   HEAP32[i41 + 4 >> 2] = 0;
   HEAP32[i41 + 8 >> 2] = 0;
   HEAP32[i41 + 12 >> 2] = 0;
   HEAP32[i41 + 16 >> 2] = 0;
   HEAP32[i41 + 20 >> 2] = 0;
   HEAP32[i41 + 24 >> 2] = 0;
   HEAP32[i41 + 28 >> 2] = 0;
   __ZN2cv3MataSERKNS_7Scalar_IdEE(i63, i41) | 0;
   i6 = 0;
  } while (0);
  i2 = i63 + 36 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i60 = i1 + 12 | 0, i61 = HEAP32[i60 >> 2] | 0, HEAP32[i60 >> 2] = i61 + -1, (i61 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i63);
  HEAP32[i2 >> 2] = 0;
  i61 = i63 + 16 | 0;
  i5 = i63 + 4 | 0;
  HEAP32[i61 + 0 >> 2] = 0;
  HEAP32[i61 + 4 >> 2] = 0;
  HEAP32[i61 + 8 >> 2] = 0;
  HEAP32[i61 + 12 >> 2] = 0;
  if ((HEAP32[i5 >> 2] | 0) > 0) {
   i2 = HEAP32[i63 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i5 >> 2] | 0));
  }
  i1 = HEAP32[i63 + 44 >> 2] | 0;
  if ((i1 | 0) != (i63 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
  d4 = +(i6 & 1);
 } while (0);
 i1 = i64 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i60 = i2 + 12 | 0, i61 = HEAP32[i60 >> 2] | 0, HEAP32[i60 >> 2] = i61 + -1, (i61 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i64);
 HEAP32[i1 >> 2] = 0;
 i61 = i64 + 16 | 0;
 i2 = i64 + 4 | 0;
 HEAP32[i61 + 0 >> 2] = 0;
 HEAP32[i61 + 4 >> 2] = 0;
 HEAP32[i61 + 8 >> 2] = 0;
 HEAP32[i61 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i64 + 40 >> 2] | 0;
  i5 = 0;
  do {
   HEAP32[i1 + (i5 << 2) >> 2] = 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i64 + 44 >> 2] | 0;
 if ((i1 | 0) == (i64 + 48 | 0)) {
  STACKTOP = i65;
  return +d4;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i65;
 return +d4;
}

function __ZN2cv3RNG4fillERKNS_17_InputOutputArrayEiRKNS_11_InputArrayES6_b(i48, i8, i23, i7, i5, i35) {
 i48 = i48 | 0;
 i8 = i8 | 0;
 i23 = i23 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i35 = i35 | 0;
 var i1 = 0, i2 = 0, i3 = 0, d4 = 0.0, d6 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0, d14 = 0.0, i15 = 0, d16 = 0.0, d17 = 0.0, d18 = 0.0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 2768 | 0;
 i54 = i55 + 2712 | 0;
 i53 = i55 + 2656 | 0;
 i52 = i55 + 2600 | 0;
 i51 = i55 + 1096 | 0;
 i3 = i55 + 2592 | 0;
 i15 = i55 + 2584 | 0;
 i20 = i55 + 2528 | 0;
 i21 = i55 + 2504 | 0;
 i30 = i55 + 2448 | 0;
 i26 = i55 + 2424 | 0;
 i36 = i55 + 2416 | 0;
 i19 = i55 + 2360 | 0;
 i27 = i55 + 2336 | 0;
 i29 = i55 + 2280 | 0;
 i28 = i55 + 2256 | 0;
 i34 = i55 + 2248 | 0;
 i22 = i55 + 2240 | 0;
 i39 = i55 + 2232 | 0;
 i47 = i55 + 2224 | 0;
 i49 = i55 + 2192 | 0;
 i50 = i55;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i8 >> 2] >> 2] & 63](i54, i8, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i7 >> 2] >> 2] & 63](i53, i7, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i5 >> 2] >> 2] & 63](i52, i5, -1);
 i31 = HEAP32[i54 >> 2] | 0;
 i37 = i31 & 7;
 i41 = i31 >>> 3;
 i38 = i41 & 511;
 i43 = i38 + 1 | 0;
 i45 = i51 + 8 | 0;
 HEAP32[i51 >> 2] = i45;
 i46 = i51 + 4 | 0;
 HEAP32[i46 >> 2] = 136;
 i11 = HEAP32[i53 >> 2] | 0;
 do if (!(i11 & 4088)) {
  i9 = HEAP32[i53 + 8 >> 2] | 0;
  i10 = HEAP32[i53 + 12 >> 2] | 0;
  if ((i9 | 0) != 1) if ((i10 | 0) == 1) i10 = 1; else {
   i1 = 7;
   break;
  }
  i44 = i9 + -1 + i10 | 0;
  if (!((i44 | 0) == (i43 | 0) | (i44 | 0) == 1)) {
   i44 = HEAP32[i53 + 40 >> 2] | 0;
   if (!(((HEAP32[i44 >> 2] | 0) == 4 ? (HEAP32[i44 + 4 >> 2] | 0) == 1 : 0) ? (i11 & 4095 | 0) == 6 & i43 >>> 0 < 5 : 0)) i1 = 7;
  }
 } else i1 = 7; while (0);
 if ((i1 | 0) == 7) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  _memcpy(__ZN2cv6String8allocateEj(i3, 223) | 0, 47416, 223) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 47640, 47648, 493);
  __ZN2cv6String10deallocateEv(i3);
 }
 do if (!(HEAP32[i52 >> 2] & 4088)) {
  i11 = HEAP32[i52 + 8 >> 2] | 0;
  i10 = HEAP32[i52 + 12 >> 2] | 0;
  if ((i11 | 0) != 1) {
   if ((i10 | 0) == 1) {
    i10 = 1;
    i1 = 11;
   }
  } else i1 = 11;
  if ((i1 | 0) == 11) {
   i44 = i11 + -1 + i10 | 0;
   if ((i44 | 0) == (i43 | 0) | (i44 | 0) == 1) break;
   i44 = HEAP32[i53 + 40 >> 2] | 0;
   if (((HEAP32[i44 >> 2] | 0) == 4 ? (HEAP32[i44 + 4 >> 2] | 0) == 1 : 0) ? (i43 >>> 0 < 5 ? (HEAP32[i53 >> 2] & 4095 | 0) == 6 : 0) : 0) break;
  }
  if (!((i11 | 0) == (i43 | 0) ? (i10 | 0) == (i43 | 0) & (i23 | 0) == 1 : 0)) i1 = 16;
 } else i1 = 16; while (0);
 if ((i1 | 0) == 16) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  _memcpy(__ZN2cv6String8allocateEj(i15, 295) | 0, 47704, 295) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i15, 47640, 47648, 498);
  __ZN2cv6String10deallocateEv(i15);
 }
 i44 = i53 + 4 | 0;
 i11 = HEAP32[i44 >> 2] | 0;
 if ((i11 | 0) < 3) i25 = Math_imul(HEAP32[i53 + 12 >> 2] | 0, HEAP32[i53 + 8 >> 2] | 0) | 0; else {
  i9 = HEAP32[i53 + 40 >> 2] | 0;
  i8 = 0;
  i10 = 1;
  do {
   i10 = Math_imul(HEAP32[i9 + (i8 << 2) >> 2] | 0, i10) | 0;
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i11 | 0));
  i25 = i10;
 }
 i42 = i52 + 4 | 0;
 i11 = HEAP32[i42 >> 2] | 0;
 if ((i11 | 0) < 3) i8 = Math_imul(HEAP32[i52 + 12 >> 2] | 0, HEAP32[i52 + 8 >> 2] | 0) | 0; else {
  i10 = HEAP32[i52 + 40 >> 2] | 0;
  i9 = 0;
  i8 = 1;
  do {
   i8 = Math_imul(HEAP32[i10 + (i9 << 2) >> 2] | 0, i8) | 0;
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i11 | 0));
 }
 i40 = (i23 | 0) == 0;
 do if (i40) {
  i5 = i25 + (i43 << 3) + i8 | 0;
  if ((HEAP32[i46 >> 2] | 0) >>> 0 < i5 >>> 0) {
   i3 = HEAP32[i51 >> 2] | 0;
   if ((i3 | 0) != (i45 | 0)) {
    if (i3) __ZdaPv(i3);
    HEAP32[i51 >> 2] = i45;
    HEAP32[i46 >> 2] = 136;
   }
   if (i5 >>> 0 > 136) {
    i33 = __Znaj(i5 >>> 0 > 536870911 ? -1 : i5 << 3) | 0;
    HEAP32[i51 >> 2] = i33;
    HEAP32[i46 >> 2] = i5;
   } else i33 = i45;
  } else {
   HEAP32[i46 >> 2] = i5;
   i33 = HEAP32[i51 >> 2] | 0;
  }
  i1 = HEAP32[i52 + 16 >> 2] | 0;
  i34 = HEAP32[i53 >> 2] | 0;
  if ((i34 & 16384 | 0) != 0 ? (i34 & 4095 | 0) == 6 & (i25 | 0) == (i43 | 0) : 0) i27 = HEAP32[i53 + 16 >> 2] | 0; else {
   i10 = HEAP32[i53 + 40 >> 2] | 0;
   i32 = HEAP32[i10 + 4 >> 2] | 0;
   i10 = HEAP32[i10 >> 2] | 0;
   i11 = i20 + 4 | 0;
   HEAP32[i11 >> 2] = 2;
   i12 = i20 + 8 | 0;
   HEAP32[i12 >> 2] = i10;
   HEAP32[i20 + 12 >> 2] = i32;
   i5 = i20 + 16 | 0;
   HEAP32[i5 >> 2] = i33;
   HEAP32[i20 + 20 >> 2] = i33;
   i34 = i20 + 24 | 0;
   i3 = i20 + 40 | 0;
   HEAP32[i34 + 0 >> 2] = 0;
   HEAP32[i34 + 4 >> 2] = 0;
   HEAP32[i34 + 8 >> 2] = 0;
   HEAP32[i34 + 12 >> 2] = 0;
   HEAP32[i3 >> 2] = i12;
   i12 = i20 + 48 | 0;
   i2 = i20 + 44 | 0;
   HEAP32[i2 >> 2] = i12;
   i32 = i32 << 3;
   HEAP32[i20 >> 2] = 1124024326;
   HEAP32[i12 >> 2] = i32;
   HEAP32[i20 + 52 >> 2] = 8;
   i32 = i33 + (Math_imul(i10, i32) | 0) | 0;
   HEAP32[i20 + 28 >> 2] = i32;
   HEAP32[i34 >> 2] = i32;
   i34 = i21 + 4 | 0;
   HEAP32[i34 + 0 >> 2] = 0;
   HEAP32[i34 + 4 >> 2] = 0;
   HEAP32[i34 + 8 >> 2] = 0;
   HEAP32[i34 + 12 >> 2] = 0;
   HEAP32[i21 >> 2] = 32232;
   HEAP32[i34 >> 2] = 33619968;
   HEAP32[i21 + 8 >> 2] = i20;
   __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i53, i21, 6, 1.0, 0.0);
   if ((i25 | 0) < (i43 | 0)) {
    i10 = i41 & 511;
    i9 = i25;
    while (1) {
     HEAPF64[i33 + (i9 << 3) >> 3] = +HEAPF64[i33 + (i9 - i25 << 3) >> 3];
     if ((i9 | 0) == (i10 | 0)) break; else i9 = i9 + 1 | 0;
    }
   }
   i9 = i20 + 36 | 0;
   i7 = HEAP32[i9 >> 2] | 0;
   if ((i7 | 0) != 0 ? (i32 = i7 + 12 | 0, i34 = HEAP32[i32 >> 2] | 0, HEAP32[i32 >> 2] = i34 + -1, (i34 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i20);
   HEAP32[i9 >> 2] = 0;
   HEAP32[i5 + 0 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   if ((HEAP32[i11 >> 2] | 0) > 0) {
    i5 = HEAP32[i3 >> 2] | 0;
    i3 = 0;
    do {
     HEAP32[i5 + (i3 << 2) >> 2] = 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (HEAP32[i11 >> 2] | 0));
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (i12 | 0)) i27 = i33; else {
    __ZN2cv8fastFreeEPv(i3);
    i27 = i33;
   }
  }
  i34 = HEAP32[i52 >> 2] | 0;
  if ((i34 & 16384 | 0) != 0 ? (i34 & 4095 | 0) == 6 & (i43 | 0) == (i8 | 0) : 0) i11 = i1; else {
   i9 = HEAP32[i52 + 40 >> 2] | 0;
   i32 = HEAP32[i9 + 4 >> 2] | 0;
   i9 = HEAP32[i9 >> 2] | 0;
   i11 = i33 + (i43 << 3) | 0;
   i2 = i30 + 4 | 0;
   HEAP32[i2 >> 2] = 2;
   i12 = i30 + 8 | 0;
   HEAP32[i12 >> 2] = i9;
   HEAP32[i30 + 12 >> 2] = i32;
   i10 = i30 + 16 | 0;
   HEAP32[i10 >> 2] = i11;
   HEAP32[i30 + 20 >> 2] = i11;
   i34 = i30 + 24 | 0;
   i5 = i30 + 40 | 0;
   HEAP32[i34 + 0 >> 2] = 0;
   HEAP32[i34 + 4 >> 2] = 0;
   HEAP32[i34 + 8 >> 2] = 0;
   HEAP32[i34 + 12 >> 2] = 0;
   HEAP32[i5 >> 2] = i12;
   i12 = i30 + 48 | 0;
   i1 = i30 + 44 | 0;
   HEAP32[i1 >> 2] = i12;
   i32 = i32 << 3;
   HEAP32[i30 >> 2] = 1124024326;
   HEAP32[i12 >> 2] = i32;
   HEAP32[i30 + 52 >> 2] = 8;
   i32 = i11 + (Math_imul(i9, i32) | 0) | 0;
   HEAP32[i30 + 28 >> 2] = i32;
   HEAP32[i34 >> 2] = i32;
   i34 = i26 + 4 | 0;
   HEAP32[i34 + 0 >> 2] = 0;
   HEAP32[i34 + 4 >> 2] = 0;
   HEAP32[i34 + 8 >> 2] = 0;
   HEAP32[i34 + 12 >> 2] = 0;
   HEAP32[i26 >> 2] = 32232;
   HEAP32[i34 >> 2] = 33619968;
   HEAP32[i26 + 8 >> 2] = i30;
   __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i52, i26, 6, 1.0, 0.0);
   if ((i38 | 0) >= (i8 | 0)) {
    i9 = i43 - i8 | 0;
    i7 = i41 & 511;
    while (1) {
     HEAPF64[i33 + (i8 + i43 << 3) >> 3] = +HEAPF64[i33 + (i9 + i8 << 3) >> 3];
     if ((i8 | 0) == (i7 | 0)) break; else i8 = i8 + 1 | 0;
    }
   }
   i8 = i30 + 36 | 0;
   i7 = HEAP32[i8 >> 2] | 0;
   if ((i7 | 0) != 0 ? (i32 = i7 + 12 | 0, i34 = HEAP32[i32 >> 2] | 0, HEAP32[i32 >> 2] = i34 + -1, (i34 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i30);
   HEAP32[i8 >> 2] = 0;
   HEAP32[i10 + 0 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    i5 = HEAP32[i5 >> 2] | 0;
    i3 = 0;
    do {
     HEAP32[i5 + (i3 << 2) >> 2] = 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
   }
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) != (i12 | 0)) __ZN2cv8fastFreeEPv(i3);
  }
  if (i37 >>> 0 < 5) {
   i21 = i43 << 1;
   i22 = i33 + (i21 << 3) | 0;
   i15 = (i31 & 5 | 0) == 0;
   d16 = (i37 | 0) == 0 ? 256.0 : 65536.0;
   i1 = (i37 | 0) == 1;
   i19 = (i37 | 0) == 3;
   d17 = i19 ? 32768.0 : 2147483647.0;
   d18 = i19 ? -32768.0 : -2147483648.0;
   i19 = (i41 & 511) + 1 | 0;
   i23 = 1;
   i12 = 0;
   i9 = 1;
   do {
    d6 = +HEAPF64[i11 + (i12 << 3) >> 3];
    d14 = +HEAPF64[i27 + (i12 << 3) >> 3];
    d4 = d6 < d14 ? d6 : d14;
    d14 = d14 < d6 ? d6 : d14;
    if (i35) {
     d6 = i15 ? 0.0 : d18;
     if (i15 | i1 ^ 1) {
      d6 = d4 < d6 ? d6 : d4;
      if ((i37 | 0) == 0 | (i37 | 0) == 2) d13 = d16; else d13 = i1 ? 128.0 : d17;
     } else {
      d13 = 128.0;
      d6 = d4 < -128.0 ? -128.0 : d4;
     }
     d13 = d13 < d14 ? d13 : d14;
    } else {
     d6 = d4;
     d13 = d14;
    }
    i5 = ~~d6;
    i5 = (+(i5 | 0) < d6 & 1) + i5 | 0;
    i8 = i33 + (i12 + i21 << 3) | 0;
    i7 = i8 + 4 | 0;
    HEAP32[i7 >> 2] = i5;
    i10 = ~~d13;
    i5 = i10 - (+(i10 | 0) > d13 & 1) - i5 | 0;
    i10 = i5 + -1 | 0;
    HEAP32[i8 >> 2] = i10;
    d14 = d13 - d6;
    if (!(d14 <= 4294967296.0)) i10 = 0; else i10 = (i10 & i5 | 0) == 0;
    i23 = i10 & 1 & i23;
    i10 = (i23 | 0) == 0;
    if (i10) {
     if (d14 > 2147483647.0) HEAP32[i8 >> 2] = 2147483647;
     if (d6 < -1073741824.0) HEAP32[i7 >> 2] = -1073741824;
    } else i9 = (i5 | 0) < 257 & i9;
    i12 = i12 + 1 | 0;
   } while ((i12 | 0) != (i19 | 0));
   if (i10) {
    i1 = i33 + (i21 + i43 << 3) | 0;
    i7 = 0;
    do {
     i5 = i33 + (i7 + i21 << 3) | 0;
     HEAP32[i1 + (i7 * 20 | 0) + 16 >> 2] = HEAP32[i5 + 4 >> 2];
     i5 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
     HEAP32[i1 + (i7 * 20 | 0) >> 2] = i5;
     i8 = 0;
     while (1) {
      i3 = _bitshift64Shl(1, 0, i8 | 0) | 0;
      i2 = tempRet0;
      if (i2 >>> 0 < 0 | (i2 | 0) == 0 & i3 >>> 0 < i5 >>> 0) i8 = i8 + 1 | 0; else break;
     }
     i35 = _i64Subtract(i3 | 0, i2 | 0, i5 | 0, 0) | 0;
     i35 = ___udivdi3(0, i35 | 0, i5 | 0, 0) | 0;
     HEAP32[i1 + (i7 * 20 | 0) + 4 >> 2] = i35 + 1;
     HEAP32[i1 + (i7 * 20 | 0) + 8 >> 2] = (i8 | 0) > 1 ? 1 : i8;
     i35 = i8 + -1 | 0;
     HEAP32[i1 + (i7 * 20 | 0) + 12 >> 2] = (i35 | 0) < 0 ? 0 : i35;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i19 | 0));
   } else i1 = 0;
   i2 = 0;
   i10 = i1;
   i1 = 0;
   i3 = 48e3 + (i23 << 5) + (i37 << 2) | 0;
   i8 = i22;
  } else {
   d6 = (i37 | 0) == 6 ? 5.421010862427522e-20 : 2.3283064365386963e-10;
   d4 = i35 ? 3402823466385288598117041.0e14 : 1797693134862315708145274.0e284;
   i3 = i43 << 1;
   i1 = i33 + (i3 << 3) | 0;
   if ((i37 | 0) == 5) {
    i2 = i41 & 511;
    i5 = 0;
    while (1) {
     d13 = +HEAPF64[i11 + (i5 << 3) >> 3];
     d17 = +HEAPF64[i27 + (i5 << 3) >> 3];
     d14 = d13 - d17;
     i35 = i33 + (i5 + i3 << 3) | 0;
     HEAPF32[i35 >> 2] = Math_fround(d6 * (d14 < d4 ? d14 : d4));
     HEAPF32[i35 + 4 >> 2] = Math_fround((d13 + d17) * .5);
     if ((i5 | 0) == (i2 | 0)) break; else i5 = i5 + 1 | 0;
    }
    i2 = 0;
   } else {
    i2 = i41 & 511;
    i3 = 0;
    while (1) {
     i34 = i11 + (i3 << 3) | 0;
     i35 = i27 + (i3 << 3) | 0;
     d4 = +HEAPF64[i34 >> 3] - +HEAPF64[i35 >> 3];
     HEAPF64[i1 + (i3 << 4) >> 3] = d6 * (d4 < 1797693134862315708145274.0e284 ? d4 : 1797693134862315708145274.0e284);
     HEAPF64[i1 + (i3 << 4) + 8 >> 3] = (+HEAPF64[i34 >> 3] + +HEAPF64[i35 >> 3]) * .5;
     if ((i3 | 0) == (i2 | 0)) {
      i2 = i1;
      i1 = 0;
      break;
     } else i3 = i3 + 1 | 0;
    }
   }
   i10 = 0;
   i3 = 48e3 + (i37 << 2) | 0;
   i8 = 0;
   i9 = 1;
  }
  i3 = HEAP32[i3 >> 2] | 0;
  if (!i3) {
   HEAP32[i36 >> 2] = 0;
   HEAP32[i36 + 4 >> 2] = 0;
   i7 = (__ZN2cv6String8allocateEj(i36, 9) | 0) + 0 | 0;
   i5 = 48064 | 0;
   i3 = i7 + 9 | 0;
   do {
    HEAP8[i7 >> 0] = HEAP8[i5 >> 0] | 0;
    i7 = i7 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i7 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i36, 47640, 47648, 617);
   __ZN2cv6String10deallocateEv(i36);
   i3 = 0;
   i12 = i8;
   i26 = 0;
   i8 = 0;
   i21 = i9;
   i11 = 0;
   i25 = 0;
  } else {
   i12 = i8;
   i26 = 0;
   i8 = 0;
   i21 = i9;
   i11 = 0;
   i25 = 0;
  }
 } else {
  if ((i23 | 0) != 1) {
   HEAP32[i22 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   i7 = (__ZN2cv6String8allocateEj(i22, 25) | 0) + 0 | 0;
   i5 = 48128 | 0;
   i3 = i7 + 25 | 0;
   do {
    HEAP8[i7 >> 0] = HEAP8[i5 >> 0] | 0;
    i7 = i7 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i7 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i22, 47640, 47648, 658);
   __ZN2cv6String10deallocateEv(i22);
   i2 = 0;
   i10 = 0;
   i1 = 0;
   i3 = 0;
   i12 = 0;
   i26 = 0;
   i8 = 0;
   i21 = 1;
   i11 = 0;
   i25 = 0;
   break;
  }
  i23 = (i25 | 0) < (i43 | 0);
  i5 = ((i43 | 0) > (i8 | 0) ? i43 : i8) + (i23 ? i43 : i25) | 0;
  if ((HEAP32[i46 >> 2] | 0) >>> 0 < i5 >>> 0) {
   i3 = HEAP32[i51 >> 2] | 0;
   if ((i3 | 0) != (i45 | 0)) {
    if (i3) __ZdaPv(i3);
    HEAP32[i51 >> 2] = i45;
    HEAP32[i46 >> 2] = 136;
   }
   if (i5 >>> 0 > 136) {
    i2 = __Znaj(i5 >>> 0 > 536870911 ? -1 : i5 << 3) | 0;
    HEAP32[i51 >> 2] = i2;
    HEAP32[i46 >> 2] = i5;
   } else i2 = i45;
  } else {
   HEAP32[i46 >> 2] = i5;
   i2 = HEAP32[i51 >> 2] | 0;
  }
  i15 = (i37 | 0) == 6 ? 6 : 5;
  i20 = 47696 >>> (i15 << 1) & 3;
  i36 = HEAP32[i53 >> 2] | 0;
  if (!((i36 & 16384 | 0) != 0 & (i36 & 4095 | 0) == (i15 | 0))) {
   i36 = HEAP32[i53 + 40 >> 2] | 0;
   i9 = HEAP32[i36 + 4 >> 2] | 0;
   i36 = HEAP32[i36 >> 2] | 0;
   i11 = i19 + 4 | 0;
   HEAP32[i11 >> 2] = 2;
   i3 = i19 + 8 | 0;
   HEAP32[i3 >> 2] = i36;
   HEAP32[i19 + 12 >> 2] = i9;
   i8 = i19 + 16 | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i19 + 20 >> 2] = i2;
   i10 = i19 + 24 | 0;
   i7 = i19 + 40 | 0;
   HEAP32[i10 + 0 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i7 >> 2] = i3;
   i3 = i19 + 48 | 0;
   i5 = i19 + 44 | 0;
   HEAP32[i5 >> 2] = i3;
   i9 = i9 << i20;
   HEAP32[i19 >> 2] = i15 | 1124024320;
   HEAP32[i3 >> 2] = i9;
   HEAP32[i19 + 52 >> 2] = 1 << i20;
   i9 = i2 + (Math_imul(i36, i9) | 0) | 0;
   HEAP32[i19 + 28 >> 2] = i9;
   HEAP32[i10 >> 2] = i9;
   i10 = i27 + 4 | 0;
   HEAP32[i10 + 0 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i27 >> 2] = 32232;
   HEAP32[i10 >> 2] = 33619968;
   HEAP32[i27 + 8 >> 2] = i19;
   __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i53, i27, i15, 1.0, 0.0);
   i10 = i19 + 36 | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   if ((i9 | 0) != 0 ? (i35 = i9 + 12 | 0, i36 = HEAP32[i35 >> 2] | 0, HEAP32[i35 >> 2] = i36 + -1, (i36 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i19);
   HEAP32[i10 >> 2] = 0;
   HEAP32[i8 + 0 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   if ((HEAP32[i11 >> 2] | 0) > 0) {
    i10 = HEAP32[i7 >> 2] | 0;
    i9 = 0;
    do {
     HEAP32[i10 + (i9 << 2) >> 2] = 0;
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) < (HEAP32[i11 >> 2] | 0));
   }
   i8 = HEAP32[i5 >> 2] | 0;
   if ((i8 | 0) == (i3 | 0)) i19 = i2; else {
    __ZN2cv8fastFreeEPv(i8);
    i19 = i2;
   }
  } else i19 = HEAP32[i53 + 16 >> 2] | 0;
  if (i23 ? (i24 = i25 << i20, i12 = i43 << i20, (i24 | 0) < (i12 | 0)) : 0) {
   i8 = i24;
   do {
    HEAP8[i19 + i8 >> 0] = HEAP8[i19 + (i8 - i24) >> 0] | 0;
    i8 = i8 + 1 | 0;
   } while ((i8 | 0) != (i12 | 0));
  }
  i36 = HEAP32[i52 >> 2] | 0;
  if (!((i36 & 16384 | 0) != 0 & (i36 & 4095 | 0) == (i15 | 0))) {
   i36 = HEAP32[i52 + 40 >> 2] | 0;
   i8 = HEAP32[i36 + 4 >> 2] | 0;
   i36 = HEAP32[i36 >> 2] | 0;
   i11 = i2 + (i43 << 3) | 0;
   i2 = i29 + 4 | 0;
   HEAP32[i2 >> 2] = 2;
   i12 = i29 + 8 | 0;
   HEAP32[i12 >> 2] = i36;
   HEAP32[i29 + 12 >> 2] = i8;
   i10 = i29 + 16 | 0;
   HEAP32[i10 >> 2] = i11;
   HEAP32[i29 + 20 >> 2] = i11;
   i9 = i29 + 24 | 0;
   i7 = i29 + 40 | 0;
   HEAP32[i9 + 0 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i7 >> 2] = i12;
   i12 = i29 + 48 | 0;
   i1 = i29 + 44 | 0;
   HEAP32[i1 >> 2] = i12;
   i8 = i8 << i20;
   HEAP32[i29 >> 2] = i15 | 1124024320;
   HEAP32[i12 >> 2] = i8;
   HEAP32[i29 + 52 >> 2] = 1 << i20;
   i8 = i11 + (Math_imul(i36, i8) | 0) | 0;
   HEAP32[i29 + 28 >> 2] = i8;
   HEAP32[i9 >> 2] = i8;
   i9 = i28 + 4 | 0;
   HEAP32[i9 + 0 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i28 >> 2] = 32232;
   HEAP32[i9 >> 2] = 33619968;
   HEAP32[i28 + 8 >> 2] = i29;
   __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i52, i28, i15, 1.0, 0.0);
   i9 = i29 + 36 | 0;
   i8 = HEAP32[i9 >> 2] | 0;
   if ((i8 | 0) != 0 ? (i35 = i8 + 12 | 0, i36 = HEAP32[i35 >> 2] | 0, HEAP32[i35 >> 2] = i36 + -1, (i36 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i29);
   HEAP32[i9 >> 2] = 0;
   HEAP32[i10 + 0 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    i5 = HEAP32[i7 >> 2] | 0;
    i3 = 0;
    do {
     HEAP32[i5 + (i3 << 2) >> 2] = 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
   }
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) != (i12 | 0)) __ZN2cv8fastFreeEPv(i3);
  } else i11 = HEAP32[i52 + 16 >> 2] | 0;
  if (i23 ? (i32 = i25 << i20, i33 = i43 << i20, (i32 | 0) < (i33 | 0)) : 0) {
   i2 = i32;
   do {
    HEAP8[i11 + i2 >> 0] = HEAP8[i11 + (i2 - i32) >> 0] | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i33 | 0));
  }
  if ((HEAP32[i52 + 8 >> 2] | 0) == (i43 | 0)) i9 = (HEAP32[i52 + 12 >> 2] | 0) == (i43 | 0); else i9 = 0;
  i8 = HEAP32[48080 + (i37 << 2) >> 2] | 0;
  if ((i37 | 0) == 7) {
   HEAP32[i34 >> 2] = 0;
   HEAP32[i34 + 4 >> 2] = 0;
   i7 = (__ZN2cv6String8allocateEj(i34, 14) | 0) + 0 | 0;
   i5 = 48112 | 0;
   i3 = i7 + 14 | 0;
   do {
    HEAP8[i7 >> 0] = HEAP8[i5 >> 0] | 0;
    i7 = i7 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i7 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i34, 47640, 47648, 655);
   __ZN2cv6String10deallocateEv(i34);
   i2 = 0;
   i10 = 0;
   i1 = 0;
   i3 = 0;
   i12 = 0;
   i26 = i19;
   i21 = 1;
   i25 = i9;
  } else {
   i2 = 0;
   i10 = 0;
   i1 = 0;
   i3 = 0;
   i12 = 0;
   i26 = i19;
   i21 = 1;
   i25 = i9;
  }
 } while (0);
 HEAP32[i39 >> 2] = i54;
 HEAP32[i39 + 4 >> 2] = 0;
 __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i49, i39, i47, -1);
 i22 = HEAP32[i49 + 20 >> 2] | 0;
 i20 = ((i38 | 1024) >>> 0) / (i43 >>> 0) | 0;
 i20 = (i22 | 0) < (i20 | 0) ? i22 : i20;
 i27 = i54 + 4 | 0;
 i5 = HEAP32[i27 >> 2] | 0;
 if ((i5 | 0) > 0) i19 = HEAP32[(HEAP32[i54 + 44 >> 2] | 0) + (i5 + -1 << 2) >> 2] | 0; else i19 = 0;
 i23 = i50 + 8 | 0;
 HEAP32[i50 >> 2] = i23;
 i24 = i50 + 4 | 0;
 HEAP32[i24 >> 2] = 136;
 i15 = Math_imul(i20, i43) | 0;
 do if (i40) {
  i7 = i15 << 2;
  if (i7 >>> 0 > 136) {
   i9 = __Znaj(i7 >>> 0 > 536870911 ? -1 : i7 << 3) | 0;
   HEAP32[i50 >> 2] = i9;
  } else i9 = i23;
  HEAP32[i24 >> 2] = i7;
  if (!i12) if (!i1) {
   if ((i15 | 0) <= 0) {
    i1 = 0;
    break;
   }
   i7 = i41 & 511;
   i5 = 0;
   do {
    i1 = 0;
    while (1) {
     i41 = i9 + (i1 + i5 << 4) | 0;
     i39 = i2 + (i1 << 4) | 0;
     HEAP32[i41 + 0 >> 2] = HEAP32[i39 + 0 >> 2];
     HEAP32[i41 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
     HEAP32[i41 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
     HEAP32[i41 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
     if ((i1 | 0) == (i7 | 0)) break; else i1 = i1 + 1 | 0;
    }
    i5 = i5 + i43 | 0;
   } while ((i5 | 0) < (i15 | 0));
   i1 = 0;
  } else {
   if ((i15 | 0) <= 0) {
    i1 = 0;
    break;
   }
   i7 = i41 & 511;
   i5 = 0;
   do {
    i2 = 0;
    while (1) {
     i41 = i9 + (i2 + i5 << 3) | 0;
     i39 = i1 + (i2 << 3) | 0;
     HEAP32[tempDoublePtr >> 2] = HEAP32[i39 >> 2];
     HEAP32[tempDoublePtr + 4 >> 2] = HEAP32[i39 + 4 >> 2];
     HEAPF64[tempDoublePtr >> 3] = +HEAPF64[tempDoublePtr >> 3];
     HEAP32[i41 >> 2] = HEAP32[tempDoublePtr >> 2];
     HEAP32[i41 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
     if ((i2 | 0) == (i7 | 0)) break; else i2 = i2 + 1 | 0;
    }
    i5 = i5 + i43 | 0;
   } while ((i5 | 0) < (i15 | 0));
   i1 = 0;
  } else if (!i10) {
   if ((i15 | 0) <= 0) {
    i1 = 0;
    break;
   }
   i7 = i41 & 511;
   i5 = 0;
   do {
    i2 = 0;
    while (1) {
     i41 = i9 + (i2 + i5 << 3) | 0;
     i39 = i12 + (i2 << 3) | 0;
     HEAP32[tempDoublePtr >> 2] = HEAP32[i39 >> 2];
     HEAP32[tempDoublePtr + 4 >> 2] = HEAP32[i39 + 4 >> 2];
     HEAPF64[tempDoublePtr >> 3] = +HEAPF64[tempDoublePtr >> 3];
     HEAP32[i41 >> 2] = HEAP32[tempDoublePtr >> 2];
     HEAP32[i41 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
     if ((i2 | 0) == (i7 | 0)) break; else i2 = i2 + 1 | 0;
    }
    i5 = i5 + i43 | 0;
   } while ((i5 | 0) < (i15 | 0));
   i1 = 0;
  } else {
   if ((i15 | 0) <= 0) {
    i1 = 0;
    break;
   }
   i7 = i41 & 511;
   i5 = 0;
   do {
    i2 = 0;
    while (1) {
     i41 = i9 + ((i2 + i5 | 0) * 20 | 0) | 0;
     i39 = i10 + (i2 * 20 | 0) | 0;
     HEAP32[i41 + 0 >> 2] = HEAP32[i39 + 0 >> 2];
     HEAP32[i41 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
     HEAP32[i41 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
     HEAP32[i41 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
     HEAP32[i41 + 16 >> 2] = HEAP32[i39 + 16 >> 2];
     if ((i2 | 0) == (i7 | 0)) break; else i2 = i2 + 1 | 0;
    }
    i5 = i5 + i43 | 0;
   } while ((i5 | 0) < (i15 | 0));
   i1 = 0;
  }
 } else {
  i2 = (i15 + 1 | 0) / 2 | 0;
  if (i2 >>> 0 > 136) {
   i1 = __Znaj(i2 >>> 0 > 536870911 ? -1 : i2 << 3) | 0;
   HEAP32[i50 >> 2] = i1;
  } else i1 = i23;
  HEAP32[i24 >> 2] = i2;
  i9 = 0;
 } while (0);
 i10 = i49 + 16 | 0;
 i7 = (i21 | 0) != 0;
 L237 : do if ((i22 | 0) > 0) {
  i2 = 0;
  while (1) {
   if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break L237;
   if (i40) {
    i5 = 0;
    do {
     i41 = i22 - i5 | 0;
     i41 = (i20 | 0) < (i41 | 0) ? i20 : i41;
     i39 = Math_imul(i41, i43) | 0;
     FUNCTION_TABLE_viiiii[i3 & 31](HEAP32[i47 >> 2] | 0, i39, i48, i9, i7);
     HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + (Math_imul(i41, i19) | 0);
     i5 = i5 + i20 | 0;
    } while ((i22 | 0) > (i5 | 0));
   } else {
    i5 = 0;
    do {
     i41 = i22 - i5 | 0;
     i41 = (i20 | 0) < (i41 | 0) ? i20 : i41;
     __ZN2cvL13randn_0_1_32fEPfiPy(i1, Math_imul(i41, i43) | 0, i48);
     FUNCTION_TABLE_viiiiiii[i8 & 63](i1, HEAP32[i47 >> 2] | 0, i41, i43, i26, i11, i25);
     HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + (Math_imul(i41, i19) | 0);
     i5 = i5 + i20 | 0;
    } while ((i22 | 0) > (i5 | 0));
   }
   __ZN2cv15NAryMatIteratorppEv(i49) | 0;
   i2 = i2 + 1 | 0;
  }
 } else {
  i2 = 0;
  while (1) {
   if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break L237;
   __ZN2cv15NAryMatIteratorppEv(i49) | 0;
   i2 = i2 + 1 | 0;
  }
 } while (0);
 i2 = HEAP32[i50 >> 2] | 0;
 if ((i2 | 0) != (i23 | 0)) {
  if (i2) __ZdaPv(i2);
  HEAP32[i50 >> 2] = i23;
  HEAP32[i24 >> 2] = 136;
 }
 i2 = HEAP32[i51 >> 2] | 0;
 if ((i2 | 0) != (i45 | 0)) {
  if (i2) __ZdaPv(i2);
  HEAP32[i51 >> 2] = i45;
  HEAP32[i46 >> 2] = 136;
 }
 i2 = i52 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i47 = i1 + 12 | 0, i51 = HEAP32[i47 >> 2] | 0, HEAP32[i47 >> 2] = i51 + -1, (i51 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i52);
 HEAP32[i2 >> 2] = 0;
 i51 = i52 + 16 | 0;
 HEAP32[i51 + 0 >> 2] = 0;
 HEAP32[i51 + 4 >> 2] = 0;
 HEAP32[i51 + 8 >> 2] = 0;
 HEAP32[i51 + 12 >> 2] = 0;
 if ((HEAP32[i42 >> 2] | 0) > 0) {
  i2 = HEAP32[i52 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i42 >> 2] | 0));
 }
 i2 = HEAP32[i52 + 44 >> 2] | 0;
 if ((i2 | 0) != (i52 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i53 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i47 = i1 + 12 | 0, i51 = HEAP32[i47 >> 2] | 0, HEAP32[i47 >> 2] = i51 + -1, (i51 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i53);
 HEAP32[i2 >> 2] = 0;
 i51 = i53 + 16 | 0;
 HEAP32[i51 + 0 >> 2] = 0;
 HEAP32[i51 + 4 >> 2] = 0;
 HEAP32[i51 + 8 >> 2] = 0;
 HEAP32[i51 + 12 >> 2] = 0;
 if ((HEAP32[i44 >> 2] | 0) > 0) {
  i2 = HEAP32[i53 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i44 >> 2] | 0));
 }
 i1 = HEAP32[i53 + 44 >> 2] | 0;
 if ((i1 | 0) != (i53 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i54 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i51 = i2 + 12 | 0, i53 = HEAP32[i51 >> 2] | 0, HEAP32[i51 >> 2] = i53 + -1, (i53 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i54);
 HEAP32[i1 >> 2] = 0;
 i53 = i54 + 16 | 0;
 HEAP32[i53 + 0 >> 2] = 0;
 HEAP32[i53 + 4 >> 2] = 0;
 HEAP32[i53 + 8 >> 2] = 0;
 HEAP32[i53 + 12 >> 2] = 0;
 if ((HEAP32[i27 >> 2] | 0) > 0) {
  i2 = HEAP32[i54 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i27 >> 2] | 0));
 }
 i1 = HEAP32[i54 + 44 >> 2] | 0;
 if ((i1 | 0) == (i54 + 48 | 0)) {
  STACKTOP = i55;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i55;
 return;
}

function __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_(i41, i42, i3, i2, i6, i43, i35, i4, i38, i39, i5) {
 i41 = i41 | 0;
 i42 = i42 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i43 = i43 | 0;
 i35 = i35 | 0;
 i4 = i4 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 i5 = i5 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i40 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0;
 i52 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 i30 = i52 + 488 | 0;
 i11 = i52 + 88 | 0;
 i51 = i52 + 80 | 0;
 i34 = i52 + 76 | 0;
 i33 = i52 + 72 | 0;
 i36 = i52 + 68 | 0;
 i31 = i52 + 493 | 0;
 i37 = i52 + 492 | 0;
 i46 = i52 + 56 | 0;
 i50 = i52 + 44 | 0;
 i48 = i52 + 32 | 0;
 i47 = i52 + 20 | 0;
 i49 = i52 + 8 | 0;
 i32 = i52 + 4 | 0;
 i44 = i52;
 HEAP32[i30 >> 2] = i5;
 HEAP32[i51 >> 2] = i11;
 i45 = i51 + 4 | 0;
 HEAP32[i45 >> 2] = 384;
 HEAP32[i34 >> 2] = i11;
 HEAP32[i33 >> 2] = i11 + 400;
 HEAP32[i36 >> 2] = 0;
 HEAP32[i46 + 0 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 HEAP32[i50 + 0 >> 2] = 0;
 HEAP32[i50 + 4 >> 2] = 0;
 HEAP32[i50 + 8 >> 2] = 0;
 HEAP32[i48 + 0 >> 2] = 0;
 HEAP32[i48 + 4 >> 2] = 0;
 HEAP32[i48 + 8 >> 2] = 0;
 HEAP32[i47 + 0 >> 2] = 0;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 0;
 HEAP32[i49 + 0 >> 2] = 0;
 HEAP32[i49 + 4 >> 2] = 0;
 HEAP32[i49 + 8 >> 2] = 0;
 __ZNSt3__111__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri(i3, i2, i36, i31, i37, i46, i50, i48, i47, i32);
 HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
 i24 = i4 + 8 | 0;
 i25 = i47 + 1 | 0;
 i26 = i47 + 4 | 0;
 i27 = i47 + 8 | 0;
 i28 = i48 + 1 | 0;
 i29 = i48 + 4 | 0;
 i23 = i48 + 8 | 0;
 i13 = (i6 & 512 | 0) != 0;
 i14 = i50 + 1 | 0;
 i15 = i50 + 8 | 0;
 i16 = i50 + 4 | 0;
 i17 = i49 + 1 | 0;
 i18 = i49 + 8 | 0;
 i19 = i49 + 4 | 0;
 i20 = i36 + 3 | 0;
 i21 = i46 + 4 | 0;
 i22 = 0;
 i10 = 0;
 L1 : while (1) {
  i9 = HEAP32[i41 >> 2] | 0;
  do if (i9) {
   if ((HEAP32[i9 + 12 >> 2] | 0) == (HEAP32[i9 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0) == -1) {
    HEAP32[i41 >> 2] = 0;
    i9 = 0;
    break;
   } else {
    i9 = HEAP32[i41 >> 2] | 0;
    break;
   }
  } else i9 = 0; while (0);
  i9 = (i9 | 0) == 0;
  i2 = HEAP32[i42 >> 2] | 0;
  do if (i2) {
   if ((HEAP32[i2 + 12 >> 2] | 0) != (HEAP32[i2 + 16 >> 2] | 0)) if (i9) break; else {
    i40 = 250;
    break L1;
   }
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0) != -1) if (i9) break; else {
    i40 = 250;
    break L1;
   } else {
    HEAP32[i42 >> 2] = 0;
    i40 = 12;
    break;
   }
  } else i40 = 12; while (0);
  if ((i40 | 0) == 12) {
   i40 = 0;
   if (i9) {
    i2 = 0;
    i40 = 250;
    break;
   } else i2 = 0;
  }
  L21 : do switch (HEAP8[i36 + i22 >> 0] | 0) {
  case 4:
   {
    i12 = HEAP8[i37 >> 0] | 0;
    i3 = i2;
    i1 = i2;
    i9 = i11;
    i4 = 0;
    L23 : while (1) {
     i11 = HEAP32[i41 >> 2] | 0;
     do if (i11) {
      if ((HEAP32[i11 + 12 >> 2] | 0) == (HEAP32[i11 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] & 127](i11) | 0) == -1) {
       HEAP32[i41 >> 2] = 0;
       i11 = 0;
       break;
      } else {
       i11 = HEAP32[i41 >> 2] | 0;
       break;
      }
     } else i11 = 0; while (0);
     i11 = (i11 | 0) == 0;
     do if (i1) {
      if ((HEAP32[i1 + 12 >> 2] | 0) != (HEAP32[i1 + 16 >> 2] | 0)) if (i11) {
       i2 = i3;
       i5 = i1;
       break;
      } else {
       i2 = i3;
       break L23;
      }
      if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) != -1) if (i11 ^ (i3 | 0) == 0) {
       i2 = i3;
       i5 = i3;
       break;
      } else {
       i2 = i3;
       break L23;
      } else {
       HEAP32[i42 >> 2] = 0;
       i2 = 0;
       i40 = 175;
       break;
      }
     } else {
      i2 = i3;
      i40 = 175;
     } while (0);
     if ((i40 | 0) == 175) {
      i40 = 0;
      if (i11) break; else i5 = 0;
     }
     i11 = HEAP32[i41 >> 2] | 0;
     i1 = HEAP32[i11 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i11 + 16 >> 2] | 0)) i11 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] & 127](i11) | 0; else i11 = HEAPU8[i1 >> 0] | 0;
     i1 = i11 & 255;
     if (i1 << 24 >> 24 > -1 ? (HEAP16[(HEAP32[i24 >> 2] | 0) + (i11 << 24 >> 24 << 1) >> 1] & 2048) != 0 : 0) {
      i11 = HEAP32[i39 >> 2] | 0;
      if ((i11 | 0) == (HEAP32[i30 >> 2] | 0)) {
       __ZNSt3__119__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i38, i39, i30);
       i11 = HEAP32[i39 >> 2] | 0;
      }
      HEAP32[i39 >> 2] = i11 + 1;
      HEAP8[i11 >> 0] = i1;
      i4 = i4 + 1 | 0;
     } else {
      i11 = HEAP8[i46 >> 0] | 0;
      if (!(i11 & 1)) i11 = (i11 & 255) >>> 1; else i11 = HEAP32[i21 >> 2] | 0;
      if (!((i11 | 0) != 0 & (i4 | 0) != 0 & i1 << 24 >> 24 == i12 << 24 >> 24)) break;
      if ((i9 | 0) == (HEAP32[i33 >> 2] | 0)) {
       __ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i51, i34, i33);
       i9 = HEAP32[i34 >> 2] | 0;
      }
      i8 = i9 + 4 | 0;
      HEAP32[i34 >> 2] = i8;
      HEAP32[i9 >> 2] = i4;
      i9 = i8;
      i4 = 0;
     }
     i11 = HEAP32[i41 >> 2] | 0;
     i1 = i11 + 12 | 0;
     i3 = HEAP32[i1 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i11 + 16 >> 2] | 0)) {
      FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] & 127](i11) | 0;
      i3 = i2;
      i1 = i5;
      continue;
     } else {
      HEAP32[i1 >> 2] = i3 + 1;
      i3 = i2;
      i1 = i5;
      continue;
     }
    }
    if ((i4 | 0) != 0 ? (HEAP32[i51 >> 2] | 0) != (i9 | 0) : 0) {
     if ((i9 | 0) == (HEAP32[i33 >> 2] | 0)) {
      __ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i51, i34, i33);
      i9 = HEAP32[i34 >> 2] | 0;
     }
     i8 = i9 + 4 | 0;
     HEAP32[i34 >> 2] = i8;
     HEAP32[i9 >> 2] = i4;
     i9 = i8;
    }
    i4 = HEAP32[i32 >> 2] | 0;
    if ((i4 | 0) > 0) {
     i11 = HEAP32[i41 >> 2] | 0;
     do if (i11) {
      if ((HEAP32[i11 + 12 >> 2] | 0) == (HEAP32[i11 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] & 127](i11) | 0) == -1) {
       HEAP32[i41 >> 2] = 0;
       i11 = 0;
       break;
      } else {
       i11 = HEAP32[i41 >> 2] | 0;
       break;
      }
     } else i11 = 0; while (0);
     i11 = (i11 | 0) == 0;
     do if (i2) {
      if ((HEAP32[i2 + 12 >> 2] | 0) != (HEAP32[i2 + 16 >> 2] | 0)) if (i11) break; else {
       i40 = 216;
       break L1;
      }
      if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0) != -1) if (i11 ^ (i2 | 0) == 0) break; else {
       i40 = 216;
       break L1;
      } else {
       HEAP32[i42 >> 2] = 0;
       i40 = 210;
       break;
      }
     } else i40 = 210; while (0);
     if ((i40 | 0) == 210) {
      i40 = 0;
      if (i11) {
       i40 = 216;
       break L1;
      } else i2 = 0;
     }
     i11 = HEAP32[i41 >> 2] | 0;
     i1 = HEAP32[i11 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i11 + 16 >> 2] | 0)) i11 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] & 127](i11) | 0; else i11 = HEAPU8[i1 >> 0] | 0;
     if ((i11 & 255) << 24 >> 24 != (HEAP8[i31 >> 0] | 0)) {
      i40 = 216;
      break L1;
     }
     i11 = HEAP32[i41 >> 2] | 0;
     i1 = i11 + 12 | 0;
     i3 = HEAP32[i1 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i11 + 16 >> 2] | 0)) {
      FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] & 127](i11) | 0;
      i3 = i2;
      i1 = i2;
      i5 = i4;
     } else {
      HEAP32[i1 >> 2] = i3 + 1;
      i3 = i2;
      i1 = i2;
      i5 = i4;
     }
     while (1) {
      i11 = HEAP32[i41 >> 2] | 0;
      do if (i11) {
       if ((HEAP32[i11 + 12 >> 2] | 0) == (HEAP32[i11 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] & 127](i11) | 0) == -1) {
        HEAP32[i41 >> 2] = 0;
        i11 = 0;
        break;
       } else {
        i11 = HEAP32[i41 >> 2] | 0;
        break;
       }
      } else i11 = 0; while (0);
      i11 = (i11 | 0) == 0;
      do if (i1) {
       if ((HEAP32[i1 + 12 >> 2] | 0) != (HEAP32[i1 + 16 >> 2] | 0)) if (i11) {
        i2 = i3;
        i4 = i1;
        break;
       } else {
        i40 = 237;
        break L1;
       }
       if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) != -1) if (i11 ^ (i3 | 0) == 0) {
        i2 = i3;
        i4 = i3;
        break;
       } else {
        i40 = 237;
        break L1;
       } else {
        HEAP32[i42 >> 2] = 0;
        i2 = 0;
        i40 = 230;
        break;
       }
      } else {
       i2 = i3;
       i40 = 230;
      } while (0);
      if ((i40 | 0) == 230) {
       i40 = 0;
       if (i11) {
        i40 = 237;
        break L1;
       } else i4 = 0;
      }
      i11 = HEAP32[i41 >> 2] | 0;
      i1 = HEAP32[i11 + 12 >> 2] | 0;
      if ((i1 | 0) == (HEAP32[i11 + 16 >> 2] | 0)) i11 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] & 127](i11) | 0; else i11 = HEAPU8[i1 >> 0] | 0;
      if ((i11 & 255) << 24 >> 24 <= -1) {
       i40 = 237;
       break L1;
      }
      if (!(HEAP16[(HEAP32[i24 >> 2] | 0) + (i11 << 24 >> 24 << 1) >> 1] & 2048)) {
       i40 = 237;
       break L1;
      }
      if ((HEAP32[i39 >> 2] | 0) == (HEAP32[i30 >> 2] | 0)) __ZNSt3__119__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i38, i39, i30);
      i11 = HEAP32[i41 >> 2] | 0;
      i1 = HEAP32[i11 + 12 >> 2] | 0;
      if ((i1 | 0) == (HEAP32[i11 + 16 >> 2] | 0)) i11 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] & 127](i11) | 0; else i11 = HEAPU8[i1 >> 0] | 0;
      i1 = HEAP32[i39 >> 2] | 0;
      HEAP32[i39 >> 2] = i1 + 1;
      HEAP8[i1 >> 0] = i11;
      i5 = i5 + -1 | 0;
      HEAP32[i32 >> 2] = i5;
      i11 = HEAP32[i41 >> 2] | 0;
      i1 = i11 + 12 | 0;
      i3 = HEAP32[i1 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i11 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] & 127](i11) | 0; else HEAP32[i1 >> 2] = i3 + 1;
      if ((i5 | 0) <= 0) break; else {
       i3 = i2;
       i1 = i4;
      }
     }
    }
    if ((HEAP32[i39 >> 2] | 0) == (HEAP32[i38 >> 2] | 0)) {
     i40 = 248;
     break L1;
    }
    break;
   }
  case 0:
   {
    i40 = 27;
    break;
   }
  case 3:
   {
    i1 = HEAP8[i48 >> 0] | 0;
    i6 = (i1 & 1) == 0;
    if (i6) i4 = (i1 & 255) >>> 1; else i4 = HEAP32[i29 >> 2] | 0;
    i7 = HEAP8[i47 >> 0] | 0;
    i5 = (i7 & 1) == 0;
    if (i5) i3 = (i7 & 255) >>> 1; else i3 = HEAP32[i26 >> 2] | 0;
    if ((i4 | 0) == (0 - i3 | 0)) i9 = i11; else {
     if (i6) i3 = (i1 & 255) >>> 1; else i3 = HEAP32[i29 >> 2] | 0;
     if (i3) {
      if (i5) i3 = (i7 & 255) >>> 1; else i3 = HEAP32[i26 >> 2] | 0;
      if (i3) {
       i3 = HEAP32[i41 >> 2] | 0;
       i4 = HEAP32[i3 + 12 >> 2] | 0;
       if ((i4 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
        i7 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0;
        i1 = HEAP8[i48 >> 0] | 0;
       } else i7 = HEAPU8[i4 >> 0] | 0;
       i3 = HEAP32[i41 >> 2] | 0;
       i4 = i3 + 12 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       i6 = (i5 | 0) == (HEAP32[i3 + 16 >> 2] | 0);
       if ((i7 & 255) << 24 >> 24 == (HEAP8[((i1 & 1) == 0 ? i28 : HEAP32[i23 >> 2] | 0) >> 0] | 0)) {
        if (i6) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] & 127](i3) | 0; else HEAP32[i4 >> 2] = i5 + 1;
        i9 = HEAP8[i48 >> 0] | 0;
        if (!(i9 & 1)) i1 = (i9 & 255) >>> 1; else i1 = HEAP32[i29 >> 2] | 0;
        i9 = i11;
        i10 = i1 >>> 0 > 1 ? i48 : i10;
        break L21;
       }
       if (i6) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0; else i9 = HEAPU8[i5 >> 0] | 0;
       if ((i9 & 255) << 24 >> 24 != (HEAP8[((HEAP8[i47 >> 0] & 1) == 0 ? i25 : HEAP32[i27 >> 2] | 0) >> 0] | 0)) {
        i40 = 113;
        break L1;
       }
       i1 = HEAP32[i41 >> 2] | 0;
       i3 = i1 + 12 | 0;
       i4 = HEAP32[i3 >> 2] | 0;
       if ((i4 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0; else HEAP32[i3 >> 2] = i4 + 1;
       HEAP8[i35 >> 0] = 1;
       i9 = HEAP8[i47 >> 0] | 0;
       if (!(i9 & 1)) i1 = (i9 & 255) >>> 1; else i1 = HEAP32[i26 >> 2] | 0;
       i9 = i11;
       i10 = i1 >>> 0 > 1 ? i47 : i10;
       break L21;
      }
     }
     if (i6) i3 = (i1 & 255) >>> 1; else i3 = HEAP32[i29 >> 2] | 0;
     i4 = HEAP32[i41 >> 2] | 0;
     i5 = HEAP32[i4 + 12 >> 2] | 0;
     i6 = (i5 | 0) == (HEAP32[i4 + 16 >> 2] | 0);
     if (!i3) {
      if (i6) {
       i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0;
       i1 = HEAP8[i47 >> 0] | 0;
      } else {
       i3 = HEAPU8[i5 >> 0] | 0;
       i1 = i7;
      }
      if ((i3 & 255) << 24 >> 24 != (HEAP8[((i1 & 1) == 0 ? i25 : HEAP32[i27 >> 2] | 0) >> 0] | 0)) {
       i9 = i11;
       break L21;
      }
      i1 = HEAP32[i41 >> 2] | 0;
      i3 = i1 + 12 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i4 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0; else HEAP32[i3 >> 2] = i4 + 1;
      HEAP8[i35 >> 0] = 1;
      i9 = HEAP8[i47 >> 0] | 0;
      if (!(i9 & 1)) i1 = (i9 & 255) >>> 1; else i1 = HEAP32[i26 >> 2] | 0;
      i9 = i11;
      i10 = i1 >>> 0 > 1 ? i47 : i10;
      break L21;
     }
     if (i6) {
      i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0;
      i1 = HEAP8[i48 >> 0] | 0;
     } else i3 = HEAPU8[i5 >> 0] | 0;
     if ((i3 & 255) << 24 >> 24 != (HEAP8[((i1 & 1) == 0 ? i28 : HEAP32[i23 >> 2] | 0) >> 0] | 0)) {
      HEAP8[i35 >> 0] = 1;
      i9 = i11;
      break L21;
     }
     i1 = HEAP32[i41 >> 2] | 0;
     i3 = i1 + 12 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0; else HEAP32[i3 >> 2] = i4 + 1;
     i9 = HEAP8[i48 >> 0] | 0;
     if (!(i9 & 1)) i1 = (i9 & 255) >>> 1; else i1 = HEAP32[i29 >> 2] | 0;
     i9 = i11;
     i10 = i1 >>> 0 > 1 ? i48 : i10;
    }
    break;
   }
  case 1:
   {
    if ((i22 | 0) == 3) {
     i40 = 250;
     break L1;
    }
    i9 = HEAP32[i41 >> 2] | 0;
    i8 = HEAP32[i9 + 12 >> 2] | 0;
    if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i9 = HEAPU8[i8 >> 0] | 0;
    if ((i9 & 255) << 24 >> 24 <= -1) {
     i40 = 26;
     break L1;
    }
    if (!(HEAP16[(HEAP32[i24 >> 2] | 0) + (i9 << 24 >> 24 << 1) >> 1] & 8192)) {
     i40 = 26;
     break L1;
    }
    i1 = HEAP32[i41 >> 2] | 0;
    i3 = i1 + 12 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0; else {
     HEAP32[i3 >> 2] = i4 + 1;
     i9 = HEAPU8[i4 >> 0] | 0;
    }
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i49, i9 & 255);
    i40 = 27;
    break;
   }
  case 2:
   {
    if (!((i10 | 0) != 0 | i22 >>> 0 < 2)) {
     if ((i22 | 0) == 2) i9 = (HEAP8[i20 >> 0] | 0) != 0; else i9 = 0;
     if (!(i13 | i9)) {
      i9 = i11;
      i10 = 0;
      break L21;
     }
    }
    i7 = HEAP8[i50 >> 0] | 0;
    i9 = (i7 & 1) == 0;
    i1 = i9 ? i14 : HEAP32[i15 >> 2] | 0;
    L244 : do if ((i22 | 0) != 0 ? (HEAPU8[i36 + (i22 + -1) >> 0] | 0) < 2 : 0) {
     i3 = (i7 & 255) >>> 1;
     i12 = HEAP32[i15 >> 2] | 0;
     i4 = HEAP32[i16 >> 2] | 0;
     i8 = i1;
     while (1) {
      if ((i8 | 0) == ((i9 ? i14 : i12) + (i9 ? i3 : i4) | 0)) break;
      i1 = HEAP8[i8 >> 0] | 0;
      if (i1 << 24 >> 24 <= -1) break;
      if (!(HEAP16[(HEAP32[i24 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 8192)) break; else i8 = i8 + 1 | 0;
     }
     i5 = i8 - (i9 ? i14 : i12) | 0;
     i6 = HEAP8[i49 >> 0] | 0;
     i1 = (i6 & 1) == 0;
     if (i1) i3 = (i6 & 255) >>> 1; else i3 = HEAP32[i19 >> 2] | 0;
     L256 : do if (i5 >>> 0 <= i3 >>> 0) {
      if (i1) {
       i3 = i17;
       i4 = (i6 & 255) >>> 1;
       i1 = i49 + (((i6 & 255) >>> 1) - i5) + 1 | 0;
      } else {
       i6 = HEAP32[i18 >> 2] | 0;
       i1 = HEAP32[i19 >> 2] | 0;
       i3 = i6;
       i4 = i1;
       i1 = i6 + (i1 - i5) | 0;
      }
      i4 = i3 + i4 | 0;
      if ((i1 | 0) == (i4 | 0)) {
       i6 = i2;
       i4 = i7;
       i3 = i2;
       break L244;
      } else i3 = i9 ? i14 : i12;
      while (1) {
       if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) break L256;
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i4 | 0)) {
        i6 = i2;
        i4 = i7;
        i3 = i2;
        break L244;
       } else i3 = i3 + 1 | 0;
      }
     } while (0);
     i6 = i2;
     i4 = i7;
     i8 = i9 ? i14 : i12;
     i3 = i2;
    } else {
     i6 = i2;
     i4 = i7;
     i8 = i1;
     i3 = i2;
    } while (0);
    L266 : while (1) {
     if (!(i4 & 1)) {
      i2 = i14;
      i1 = (i4 & 255) >>> 1;
     } else {
      i2 = HEAP32[i15 >> 2] | 0;
      i1 = HEAP32[i16 >> 2] | 0;
     }
     if ((i8 | 0) == (i2 + i1 | 0)) {
      i2 = i6;
      break;
     }
     i1 = HEAP32[i41 >> 2] | 0;
     do if (i1) {
      if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1) {
       HEAP32[i41 >> 2] = 0;
       i1 = 0;
       break;
      } else {
       i1 = HEAP32[i41 >> 2] | 0;
       break;
      }
     } else i1 = 0; while (0);
     i1 = (i1 | 0) == 0;
     do if (i3) {
      if ((HEAP32[i3 + 12 >> 2] | 0) != (HEAP32[i3 + 16 >> 2] | 0)) if (i1) {
       i2 = i6;
       i5 = i3;
       break;
      } else {
       i2 = i6;
       break L266;
      }
      if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0) != -1) if (i1 ^ (i6 | 0) == 0) {
       i2 = i6;
       i5 = i6;
       break;
      } else {
       i2 = i6;
       break L266;
      } else {
       HEAP32[i42 >> 2] = 0;
       i2 = 0;
       i40 = 149;
       break;
      }
     } else {
      i2 = i6;
      i40 = 149;
     } while (0);
     if ((i40 | 0) == 149) {
      i40 = 0;
      if (i1) break; else i5 = 0;
     }
     i1 = HEAP32[i41 >> 2] | 0;
     i3 = HEAP32[i1 + 12 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i1 = HEAPU8[i3 >> 0] | 0;
     if ((i1 & 255) << 24 >> 24 != (HEAP8[i8 >> 0] | 0)) break;
     i1 = HEAP32[i41 >> 2] | 0;
     i3 = i1 + 12 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0; else HEAP32[i3 >> 2] = i4 + 1;
     i6 = i2;
     i4 = HEAP8[i50 >> 0] | 0;
     i8 = i8 + 1 | 0;
     i3 = i5;
    }
    if (i13) {
     i1 = HEAP8[i50 >> 0] | 0;
     if (!(i1 & 1)) {
      i3 = i14;
      i1 = (i1 & 255) >>> 1;
     } else {
      i3 = HEAP32[i15 >> 2] | 0;
      i1 = HEAP32[i16 >> 2] | 0;
     }
     if ((i8 | 0) != (i3 + i1 | 0)) {
      i40 = 164;
      break L1;
     } else i9 = i11;
    } else i9 = i11;
    break;
   }
  default:
   i9 = i11;
  } while (0);
  L306 : do if ((i40 | 0) == 27) {
   i40 = 0;
   if ((i22 | 0) == 3) {
    i40 = 250;
    break L1;
   } else {
    i4 = i2;
    i3 = i2;
   }
   while (1) {
    i1 = HEAP32[i41 >> 2] | 0;
    do if (i1) {
     if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1) {
      HEAP32[i41 >> 2] = 0;
      i1 = 0;
      break;
     } else {
      i1 = HEAP32[i41 >> 2] | 0;
      break;
     }
    } else i1 = 0; while (0);
    i1 = (i1 | 0) == 0;
    do if (i3) {
     if ((HEAP32[i3 + 12 >> 2] | 0) != (HEAP32[i3 + 16 >> 2] | 0)) if (i1) {
      i2 = i4;
      i5 = i3;
      break;
     } else {
      i2 = i4;
      i9 = i11;
      break L306;
     }
     if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0) != -1) if (i1 ^ (i4 | 0) == 0) {
      i2 = i4;
      i5 = i4;
      break;
     } else {
      i2 = i4;
      i9 = i11;
      break L306;
     } else {
      HEAP32[i42 >> 2] = 0;
      i2 = 0;
      i40 = 38;
      break;
     }
    } else {
     i2 = i4;
     i40 = 38;
    } while (0);
    if ((i40 | 0) == 38) {
     i40 = 0;
     if (i1) {
      i9 = i11;
      break L306;
     } else i5 = 0;
    }
    i1 = HEAP32[i41 >> 2] | 0;
    i3 = HEAP32[i1 + 12 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i1 = HEAPU8[i3 >> 0] | 0;
    if ((i1 & 255) << 24 >> 24 <= -1) {
     i9 = i11;
     break L306;
    }
    if (!(HEAP16[(HEAP32[i24 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 8192)) {
     i9 = i11;
     break L306;
    }
    i1 = HEAP32[i41 >> 2] | 0;
    i3 = i1 + 12 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0; else {
     HEAP32[i3 >> 2] = i4 + 1;
     i1 = HEAPU8[i4 >> 0] | 0;
    }
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i49, i1 & 255);
    i4 = i2;
    i3 = i5;
   }
  } while (0);
  i22 = i22 + 1 | 0;
  if (i22 >>> 0 >= 4) {
   i11 = i9;
   i40 = 250;
   break;
  } else i11 = i9;
 }
 L339 : do if ((i40 | 0) == 26) {
  HEAP32[i43 >> 2] = HEAP32[i43 >> 2] | 4;
  i2 = 0;
 } else if ((i40 | 0) == 113) {
  HEAP32[i43 >> 2] = HEAP32[i43 >> 2] | 4;
  i2 = 0;
 } else if ((i40 | 0) == 164) {
  HEAP32[i43 >> 2] = HEAP32[i43 >> 2] | 4;
  i2 = 0;
 } else if ((i40 | 0) == 216) {
  HEAP32[i43 >> 2] = HEAP32[i43 >> 2] | 4;
  i2 = 0;
 } else if ((i40 | 0) == 237) {
  HEAP32[i43 >> 2] = HEAP32[i43 >> 2] | 4;
  i2 = 0;
 } else if ((i40 | 0) == 248) {
  HEAP32[i43 >> 2] = HEAP32[i43 >> 2] | 4;
  i2 = 0;
 } else if ((i40 | 0) == 250) {
  L346 : do if (i10) {
   i7 = i10 + 1 | 0;
   i8 = i10 + 8 | 0;
   i9 = i10 + 4 | 0;
   i3 = i2;
   i4 = i2;
   i5 = 1;
   L348 : while (1) {
    i2 = HEAP8[i10 >> 0] | 0;
    if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i9 >> 2] | 0;
    if (i5 >>> 0 >= i2 >>> 0) break L346;
    i2 = HEAP32[i41 >> 2] | 0;
    do if (i2) {
     if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0) == -1) {
      HEAP32[i41 >> 2] = 0;
      i2 = 0;
      break;
     } else {
      i2 = HEAP32[i41 >> 2] | 0;
      break;
     }
    } else i2 = 0; while (0);
    i1 = (i2 | 0) == 0;
    do if (i4) {
     if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i1) {
      i2 = i3;
      i6 = i4;
      break;
     } else break L348;
     if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) != -1) if (i1 ^ (i3 | 0) == 0) {
      i2 = i3;
      i6 = i3;
      break;
     } else break L348; else {
      HEAP32[i42 >> 2] = 0;
      i2 = 0;
      i40 = 266;
      break;
     }
    } else {
     i2 = i3;
     i40 = 266;
    } while (0);
    if ((i40 | 0) == 266) {
     i40 = 0;
     if (i1) break; else i6 = 0;
    }
    i1 = HEAP32[i41 >> 2] | 0;
    i3 = HEAP32[i1 + 12 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i1 = HEAPU8[i3 >> 0] | 0;
    if (!(HEAP8[i10 >> 0] & 1)) i3 = i7; else i3 = HEAP32[i8 >> 2] | 0;
    if ((i1 & 255) << 24 >> 24 != (HEAP8[i3 + i5 >> 0] | 0)) break;
    i5 = i5 + 1 | 0;
    i3 = HEAP32[i41 >> 2] | 0;
    i1 = i3 + 12 | 0;
    i4 = HEAP32[i1 >> 2] | 0;
    if ((i4 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
     FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] & 127](i3) | 0;
     i3 = i2;
     i4 = i6;
     continue;
    } else {
     HEAP32[i1 >> 2] = i4 + 1;
     i3 = i2;
     i4 = i6;
     continue;
    }
   }
   HEAP32[i43 >> 2] = HEAP32[i43 >> 2] | 4;
   i2 = 0;
   break L339;
  } while (0);
  i2 = HEAP32[i51 >> 2] | 0;
  if ((i2 | 0) != (i11 | 0) ? (HEAP32[i44 >> 2] = 0, __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i46, i2, i11, i44), (HEAP32[i44 >> 2] | 0) != 0) : 0) {
   HEAP32[i43 >> 2] = HEAP32[i43 >> 2] | 4;
   i2 = 0;
  } else i2 = 1;
 } while (0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i49);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i47);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i48);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i50);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i46);
 i1 = HEAP32[i51 >> 2] | 0;
 HEAP32[i51 >> 2] = 0;
 if (!i1) {
  STACKTOP = i52;
  return i2 | 0;
 }
 FUNCTION_TABLE_vi[HEAP32[i45 >> 2] & 511](i1);
 STACKTOP = i52;
 return i2 | 0;
}
function __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_(i38, i39, i4, i3, i7, i40, i32, i27, i35, i36, i5) {
 i38 = i38 | 0;
 i39 = i39 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i40 = i40 | 0;
 i32 = i32 | 0;
 i27 = i27 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i37 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 i26 = i49 + 496 | 0;
 i11 = i49 + 96 | 0;
 i48 = i49 + 88 | 0;
 i31 = i49 + 84 | 0;
 i30 = i49 + 80 | 0;
 i33 = i49 + 76 | 0;
 i28 = i49 + 72 | 0;
 i34 = i49 + 68 | 0;
 i43 = i49 + 56 | 0;
 i47 = i49 + 44 | 0;
 i45 = i49 + 32 | 0;
 i44 = i49 + 20 | 0;
 i46 = i49 + 8 | 0;
 i29 = i49 + 4 | 0;
 i41 = i49;
 HEAP32[i26 >> 2] = i5;
 HEAP32[i48 >> 2] = i11;
 i42 = i48 + 4 | 0;
 HEAP32[i42 >> 2] = 384;
 HEAP32[i31 >> 2] = i11;
 HEAP32[i30 >> 2] = i11 + 400;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i43 + 0 >> 2] = 0;
 HEAP32[i43 + 4 >> 2] = 0;
 HEAP32[i43 + 8 >> 2] = 0;
 HEAP32[i47 + 0 >> 2] = 0;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 0;
 HEAP32[i45 + 0 >> 2] = 0;
 HEAP32[i45 + 4 >> 2] = 0;
 HEAP32[i45 + 8 >> 2] = 0;
 HEAP32[i44 + 0 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i46 + 0 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 __ZNSt3__111__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri(i4, i3, i33, i28, i34, i43, i47, i45, i44, i29);
 HEAP32[i36 >> 2] = HEAP32[i35 >> 2];
 i22 = i44 + 4 | 0;
 i23 = i44 + 8 | 0;
 i24 = i45 + 4 | 0;
 i25 = i45 + 8 | 0;
 i20 = (i7 & 512 | 0) != 0;
 i14 = i47 + 4 | 0;
 i15 = i47 + 8 | 0;
 i16 = i46 + 4 | 0;
 i17 = i46 + 8 | 0;
 i18 = i33 + 3 | 0;
 i19 = i43 + 4 | 0;
 i21 = 0;
 i10 = 0;
 L1 : while (1) {
  i7 = HEAP32[i38 >> 2] | 0;
  do if (i7) {
   i6 = HEAP32[i7 + 12 >> 2] | 0;
   if ((i6 | 0) == (HEAP32[i7 + 16 >> 2] | 0)) i7 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 127](i7) | 0; else i7 = HEAP32[i6 >> 2] | 0;
   if ((i7 | 0) == -1) {
    HEAP32[i38 >> 2] = 0;
    i8 = 1;
    break;
   } else {
    i8 = (HEAP32[i38 >> 2] | 0) == 0;
    break;
   }
  } else i8 = 1; while (0);
  i2 = HEAP32[i39 >> 2] | 0;
  do if (i2) {
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i9 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i9 = HEAP32[i9 >> 2] | 0;
   if ((i9 | 0) != -1) if (i8) {
    i13 = i2;
    break;
   } else {
    i37 = 267;
    break L1;
   } else {
    HEAP32[i39 >> 2] = 0;
    i37 = 15;
    break;
   }
  } else i37 = 15; while (0);
  if ((i37 | 0) == 15) {
   i37 = 0;
   if (i8) {
    i2 = 0;
    i37 = 267;
    break;
   } else i13 = 0;
  }
  L25 : do switch (HEAP8[i33 + i21 >> 0] | 0) {
  case 4:
   {
    i4 = HEAP32[i34 >> 2] | 0;
    i3 = i13;
    i1 = i13;
    i7 = i11;
    i12 = 0;
    L27 : while (1) {
     i9 = HEAP32[i38 >> 2] | 0;
     do if (i9) {
      i8 = HEAP32[i9 + 12 >> 2] | 0;
      if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i9 = HEAP32[i8 >> 2] | 0;
      if ((i9 | 0) == -1) {
       HEAP32[i38 >> 2] = 0;
       i8 = 1;
       break;
      } else {
       i8 = (HEAP32[i38 >> 2] | 0) == 0;
       break;
      }
     } else i8 = 1; while (0);
     do if (i1) {
      i9 = HEAP32[i1 + 12 >> 2] | 0;
      if ((i9 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i9 = HEAP32[i9 >> 2] | 0;
      if ((i9 | 0) != -1) if (i8 ^ (i3 | 0) == 0) {
       i2 = i3;
       i1 = i3;
       break;
      } else {
       i2 = i3;
       break L27;
      } else {
       HEAP32[i39 >> 2] = 0;
       i2 = 0;
       i37 = 188;
       break;
      }
     } else {
      i2 = i3;
      i37 = 188;
     } while (0);
     if ((i37 | 0) == 188) {
      i37 = 0;
      if (i8) break; else i1 = 0;
     }
     i9 = HEAP32[i38 >> 2] | 0;
     i8 = HEAP32[i9 + 12 >> 2] | 0;
     if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i11 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i11 = HEAP32[i8 >> 2] | 0;
     if (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i27 >> 2] | 0) + 12 >> 2] & 63](i27, 2048, i11) | 0) {
      i9 = HEAP32[i36 >> 2] | 0;
      if ((i9 | 0) == (HEAP32[i26 >> 2] | 0)) {
       __ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i35, i36, i26);
       i9 = HEAP32[i36 >> 2] | 0;
      }
      HEAP32[i36 >> 2] = i9 + 4;
      HEAP32[i9 >> 2] = i11;
      i11 = i12 + 1 | 0;
     } else {
      i9 = HEAP8[i43 >> 0] | 0;
      if (!(i9 & 1)) i9 = (i9 & 255) >>> 1; else i9 = HEAP32[i19 >> 2] | 0;
      if (!((i9 | 0) != 0 & (i12 | 0) != 0 & (i11 | 0) == (i4 | 0))) break;
      if ((i7 | 0) == (HEAP32[i30 >> 2] | 0)) {
       __ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i48, i31, i30);
       i7 = HEAP32[i31 >> 2] | 0;
      }
      i11 = i7 + 4 | 0;
      HEAP32[i31 >> 2] = i11;
      HEAP32[i7 >> 2] = i12;
      i7 = i11;
      i11 = 0;
     }
     i9 = HEAP32[i38 >> 2] | 0;
     i8 = i9 + 12 | 0;
     i6 = HEAP32[i8 >> 2] | 0;
     if ((i6 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) {
      FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] & 127](i9) | 0;
      i3 = i2;
      i12 = i11;
      continue;
     } else {
      HEAP32[i8 >> 2] = i6 + 4;
      i3 = i2;
      i12 = i11;
      continue;
     }
    }
    if ((i12 | 0) != 0 ? (HEAP32[i48 >> 2] | 0) != (i7 | 0) : 0) {
     if ((i7 | 0) == (HEAP32[i30 >> 2] | 0)) {
      __ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i48, i31, i30);
      i7 = HEAP32[i31 >> 2] | 0;
     }
     i9 = i7 + 4 | 0;
     HEAP32[i31 >> 2] = i9;
     HEAP32[i7 >> 2] = i12;
     i7 = i9;
    }
    i3 = HEAP32[i29 >> 2] | 0;
    if ((i3 | 0) > 0) {
     i9 = HEAP32[i38 >> 2] | 0;
     do if (i9) {
      i8 = HEAP32[i9 + 12 >> 2] | 0;
      if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i9 = HEAP32[i8 >> 2] | 0;
      if ((i9 | 0) == -1) {
       HEAP32[i38 >> 2] = 0;
       i8 = 1;
       break;
      } else {
       i8 = (HEAP32[i38 >> 2] | 0) == 0;
       break;
      }
     } else i8 = 1; while (0);
     do if (i2) {
      i9 = HEAP32[i2 + 12 >> 2] | 0;
      if ((i9 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i9 = HEAP32[i9 >> 2] | 0;
      if ((i9 | 0) != -1) if (i8) break; else {
       i37 = 231;
       break L1;
      } else {
       HEAP32[i39 >> 2] = 0;
       i37 = 225;
       break;
      }
     } else i37 = 225; while (0);
     if ((i37 | 0) == 225) {
      i37 = 0;
      if (i8) {
       i37 = 231;
       break L1;
      } else i2 = 0;
     }
     i9 = HEAP32[i38 >> 2] | 0;
     i8 = HEAP32[i9 + 12 >> 2] | 0;
     if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i9 = HEAP32[i8 >> 2] | 0;
     if ((i9 | 0) != (HEAP32[i28 >> 2] | 0)) {
      i37 = 231;
      break L1;
     }
     i9 = HEAP32[i38 >> 2] | 0;
     i8 = i9 + 12 | 0;
     i6 = HEAP32[i8 >> 2] | 0;
     if ((i6 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) {
      FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] & 127](i9) | 0;
      i1 = i2;
      i11 = i2;
     } else {
      HEAP32[i8 >> 2] = i6 + 4;
      i1 = i2;
      i11 = i2;
     }
     while (1) {
      i9 = HEAP32[i38 >> 2] | 0;
      do if (i9) {
       i8 = HEAP32[i9 + 12 >> 2] | 0;
       if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i9 = HEAP32[i8 >> 2] | 0;
       if ((i9 | 0) == -1) {
        HEAP32[i38 >> 2] = 0;
        i8 = 1;
        break;
       } else {
        i8 = (HEAP32[i38 >> 2] | 0) == 0;
        break;
       }
      } else i8 = 1; while (0);
      do if (i11) {
       i9 = HEAP32[i11 + 12 >> 2] | 0;
       if ((i9 | 0) == (HEAP32[i11 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] & 127](i11) | 0; else i9 = HEAP32[i9 >> 2] | 0;
       if ((i9 | 0) != -1) if (i8 ^ (i1 | 0) == 0) {
        i2 = i1;
        i11 = i1;
        break;
       } else {
        i37 = 254;
        break L1;
       } else {
        HEAP32[i39 >> 2] = 0;
        i2 = 0;
        i37 = 248;
        break;
       }
      } else {
       i2 = i1;
       i37 = 248;
      } while (0);
      if ((i37 | 0) == 248) {
       i37 = 0;
       if (i8) {
        i37 = 254;
        break L1;
       } else i11 = 0;
      }
      i9 = HEAP32[i38 >> 2] | 0;
      i8 = HEAP32[i9 + 12 >> 2] | 0;
      if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i9 = HEAP32[i8 >> 2] | 0;
      if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i27 >> 2] | 0) + 12 >> 2] & 63](i27, 2048, i9) | 0)) {
       i37 = 254;
       break L1;
      }
      if ((HEAP32[i36 >> 2] | 0) == (HEAP32[i26 >> 2] | 0)) __ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i35, i36, i26);
      i9 = HEAP32[i38 >> 2] | 0;
      i8 = HEAP32[i9 + 12 >> 2] | 0;
      if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i9 = HEAP32[i8 >> 2] | 0;
      i8 = HEAP32[i36 >> 2] | 0;
      HEAP32[i36 >> 2] = i8 + 4;
      HEAP32[i8 >> 2] = i9;
      i3 = i3 + -1 | 0;
      HEAP32[i29 >> 2] = i3;
      i9 = HEAP32[i38 >> 2] | 0;
      i8 = i9 + 12 | 0;
      i6 = HEAP32[i8 >> 2] | 0;
      if ((i6 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] & 127](i9) | 0; else HEAP32[i8 >> 2] = i6 + 4;
      if ((i3 | 0) <= 0) break; else i1 = i2;
     }
    }
    if ((HEAP32[i36 >> 2] | 0) == (HEAP32[i35 >> 2] | 0)) {
     i37 = 265;
     break L1;
    }
    break;
   }
  case 1:
   {
    if ((i21 | 0) == 3) {
     i2 = i13;
     i37 = 267;
     break L1;
    }
    i7 = HEAP32[i38 >> 2] | 0;
    i6 = HEAP32[i7 + 12 >> 2] | 0;
    if ((i6 | 0) == (HEAP32[i7 + 16 >> 2] | 0)) i7 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 127](i7) | 0; else i7 = HEAP32[i6 >> 2] | 0;
    if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i27 >> 2] | 0) + 12 >> 2] & 63](i27, 8192, i7) | 0)) {
     i37 = 28;
     break L1;
    }
    i9 = HEAP32[i38 >> 2] | 0;
    i8 = i9 + 12 | 0;
    i7 = HEAP32[i8 >> 2] | 0;
    if ((i7 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i7 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] & 127](i9) | 0; else {
     HEAP32[i8 >> 2] = i7 + 4;
     i7 = HEAP32[i7 >> 2] | 0;
    }
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw(i46, i7);
    i37 = 29;
    break;
   }
  case 3:
   {
    i9 = HEAP8[i45 >> 0] | 0;
    i1 = (i9 & 1) == 0;
    if (i1) i7 = (i9 & 255) >>> 1; else i7 = HEAP32[i24 >> 2] | 0;
    i2 = HEAP8[i44 >> 0] | 0;
    i6 = (i2 & 1) == 0;
    if (i6) i8 = (i2 & 255) >>> 1; else i8 = HEAP32[i22 >> 2] | 0;
    if ((i7 | 0) == (0 - i8 | 0)) {
     i2 = i13;
     i7 = i11;
    } else {
     if (i1) i8 = (i9 & 255) >>> 1; else i8 = HEAP32[i24 >> 2] | 0;
     if (i8) {
      if (i6) i8 = (i2 & 255) >>> 1; else i8 = HEAP32[i22 >> 2] | 0;
      if (i8) {
       i8 = HEAP32[i38 >> 2] | 0;
       i7 = HEAP32[i8 + 12 >> 2] | 0;
       if ((i7 | 0) == (HEAP32[i8 + 16 >> 2] | 0)) {
        i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] & 127](i8) | 0;
        i9 = HEAP8[i45 >> 0] | 0;
       } else i4 = HEAP32[i7 >> 2] | 0;
       i8 = HEAP32[i38 >> 2] | 0;
       i7 = i8 + 12 | 0;
       i6 = HEAP32[i7 >> 2] | 0;
       i5 = (i6 | 0) == (HEAP32[i8 + 16 >> 2] | 0);
       if ((i4 | 0) == (HEAP32[((i9 & 1) == 0 ? i24 : HEAP32[i25 >> 2] | 0) >> 2] | 0)) {
        if (i5) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] & 127](i8) | 0; else HEAP32[i7 >> 2] = i6 + 4;
        i7 = HEAP8[i45 >> 0] | 0;
        if (!(i7 & 1)) i9 = (i7 & 255) >>> 1; else i9 = HEAP32[i24 >> 2] | 0;
        i2 = i13;
        i7 = i11;
        i10 = i9 >>> 0 > 1 ? i45 : i10;
        break L25;
       }
       if (i5) i7 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] & 127](i8) | 0; else i7 = HEAP32[i6 >> 2] | 0;
       if ((i7 | 0) != (HEAP32[((HEAP8[i44 >> 0] & 1) == 0 ? i22 : HEAP32[i23 >> 2] | 0) >> 2] | 0)) {
        i37 = 117;
        break L1;
       }
       i9 = HEAP32[i38 >> 2] | 0;
       i8 = i9 + 12 | 0;
       i7 = HEAP32[i8 >> 2] | 0;
       if ((i7 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] & 127](i9) | 0; else HEAP32[i8 >> 2] = i7 + 4;
       HEAP8[i32 >> 0] = 1;
       i7 = HEAP8[i44 >> 0] | 0;
       if (!(i7 & 1)) i9 = (i7 & 255) >>> 1; else i9 = HEAP32[i22 >> 2] | 0;
       i2 = i13;
       i7 = i11;
       i10 = i9 >>> 0 > 1 ? i44 : i10;
       break L25;
      }
     }
     if (i1) i8 = (i9 & 255) >>> 1; else i8 = HEAP32[i24 >> 2] | 0;
     i7 = HEAP32[i38 >> 2] | 0;
     i6 = HEAP32[i7 + 12 >> 2] | 0;
     i5 = (i6 | 0) == (HEAP32[i7 + 16 >> 2] | 0);
     if (!i8) {
      if (i5) {
       i8 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 127](i7) | 0;
       i9 = HEAP8[i44 >> 0] | 0;
      } else {
       i8 = HEAP32[i6 >> 2] | 0;
       i9 = i2;
      }
      if ((i8 | 0) != (HEAP32[((i9 & 1) == 0 ? i22 : HEAP32[i23 >> 2] | 0) >> 2] | 0)) {
       i2 = i13;
       i7 = i11;
       break L25;
      }
      i9 = HEAP32[i38 >> 2] | 0;
      i8 = i9 + 12 | 0;
      i7 = HEAP32[i8 >> 2] | 0;
      if ((i7 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] & 127](i9) | 0; else HEAP32[i8 >> 2] = i7 + 4;
      HEAP8[i32 >> 0] = 1;
      i7 = HEAP8[i44 >> 0] | 0;
      if (!(i7 & 1)) i9 = (i7 & 255) >>> 1; else i9 = HEAP32[i22 >> 2] | 0;
      i2 = i13;
      i7 = i11;
      i10 = i9 >>> 0 > 1 ? i44 : i10;
      break L25;
     }
     if (i5) {
      i8 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 127](i7) | 0;
      i9 = HEAP8[i45 >> 0] | 0;
     } else i8 = HEAP32[i6 >> 2] | 0;
     if ((i8 | 0) != (HEAP32[((i9 & 1) == 0 ? i24 : HEAP32[i25 >> 2] | 0) >> 2] | 0)) {
      HEAP8[i32 >> 0] = 1;
      i2 = i13;
      i7 = i11;
      break L25;
     }
     i9 = HEAP32[i38 >> 2] | 0;
     i8 = i9 + 12 | 0;
     i7 = HEAP32[i8 >> 2] | 0;
     if ((i7 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] & 127](i9) | 0; else HEAP32[i8 >> 2] = i7 + 4;
     i7 = HEAP8[i45 >> 0] | 0;
     if (!(i7 & 1)) i9 = (i7 & 255) >>> 1; else i9 = HEAP32[i24 >> 2] | 0;
     i2 = i13;
     i7 = i11;
     i10 = i9 >>> 0 > 1 ? i45 : i10;
    }
    break;
   }
  case 2:
   {
    if (!((i10 | 0) != 0 | i21 >>> 0 < 2)) {
     if ((i21 | 0) == 2) i7 = (HEAP8[i18 >> 0] | 0) != 0; else i7 = 0;
     if (!(i20 | i7)) {
      i2 = i13;
      i7 = i11;
      i10 = 0;
      break L25;
     }
    }
    i9 = HEAP8[i47 >> 0] | 0;
    i8 = (i9 & 1) == 0 ? i14 : HEAP32[i15 >> 2] | 0;
    L256 : do if ((i21 | 0) != 0 ? (HEAPU8[i33 + (i21 + -1) >> 0] | 0) < 2 : 0) {
     i12 = i8;
     while (1) {
      if (!(i9 & 1)) {
       i8 = i14;
       i7 = (i9 & 255) >>> 1;
      } else {
       i8 = HEAP32[i15 >> 2] | 0;
       i7 = HEAP32[i14 >> 2] | 0;
      }
      if ((i12 | 0) == (i8 + (i7 << 2) | 0)) break;
      if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i27 >> 2] | 0) + 12 >> 2] & 63](i27, 8192, HEAP32[i12 >> 2] | 0) | 0)) {
       i37 = 129;
       break;
      }
      i9 = HEAP8[i47 >> 0] | 0;
      i12 = i12 + 4 | 0;
     }
     if ((i37 | 0) == 129) {
      i37 = 0;
      i9 = HEAP8[i47 >> 0] | 0;
     }
     i5 = (i9 & 1) == 0;
     i3 = i12 - (i5 ? i14 : HEAP32[i15 >> 2] | 0) >> 2;
     i4 = HEAP8[i46 >> 0] | 0;
     i8 = (i4 & 1) == 0;
     if (i8) i7 = (i4 & 255) >>> 1; else i7 = HEAP32[i16 >> 2] | 0;
     L273 : do if (i3 >>> 0 <= i7 >>> 0) {
      if (i8) {
       i1 = i16;
       i2 = (i4 & 255) >>> 1;
       i8 = i16 + (((i4 & 255) >>> 1) - i3 << 2) | 0;
      } else {
       i7 = HEAP32[i17 >> 2] | 0;
       i8 = HEAP32[i16 >> 2] | 0;
       i1 = i7;
       i2 = i8;
       i8 = i7 + (i8 - i3 << 2) | 0;
      }
      i6 = i1 + (i2 << 2) | 0;
      if ((i8 | 0) == (i6 | 0)) {
       i3 = i13;
       i1 = i13;
       break L256;
      } else i7 = i5 ? i14 : HEAP32[i15 >> 2] | 0;
      while (1) {
       if ((HEAP32[i8 >> 2] | 0) != (HEAP32[i7 >> 2] | 0)) break L273;
       i8 = i8 + 4 | 0;
       if ((i8 | 0) == (i6 | 0)) {
        i3 = i13;
        i1 = i13;
        break L256;
       } else i7 = i7 + 4 | 0;
      }
     } while (0);
     i3 = i13;
     i12 = i5 ? i14 : HEAP32[i15 >> 2] | 0;
     i1 = i13;
    } else {
     i3 = i13;
     i12 = i8;
     i1 = i13;
    } while (0);
    L283 : while (1) {
     if (!(i9 & 1)) {
      i8 = i14;
      i9 = (i9 & 255) >>> 1;
     } else {
      i8 = HEAP32[i15 >> 2] | 0;
      i9 = HEAP32[i14 >> 2] | 0;
     }
     if ((i12 | 0) == (i8 + (i9 << 2) | 0)) {
      i2 = i3;
      break;
     }
     i9 = HEAP32[i38 >> 2] | 0;
     do if (i9) {
      i8 = HEAP32[i9 + 12 >> 2] | 0;
      if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i9 = HEAP32[i8 >> 2] | 0;
      if ((i9 | 0) == -1) {
       HEAP32[i38 >> 2] = 0;
       i8 = 1;
       break;
      } else {
       i8 = (HEAP32[i38 >> 2] | 0) == 0;
       break;
      }
     } else i8 = 1; while (0);
     do if (i1) {
      i9 = HEAP32[i1 + 12 >> 2] | 0;
      if ((i9 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i9 = HEAP32[i9 >> 2] | 0;
      if ((i9 | 0) != -1) if (i8 ^ (i3 | 0) == 0) {
       i2 = i3;
       i1 = i3;
       break;
      } else {
       i2 = i3;
       break L283;
      } else {
       HEAP32[i39 >> 2] = 0;
       i2 = 0;
       i37 = 159;
       break;
      }
     } else {
      i2 = i3;
      i37 = 159;
     } while (0);
     if ((i37 | 0) == 159) {
      i37 = 0;
      if (i8) break; else i1 = 0;
     }
     i9 = HEAP32[i38 >> 2] | 0;
     i8 = HEAP32[i9 + 12 >> 2] | 0;
     if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i9 = HEAP32[i8 >> 2] | 0;
     if ((i9 | 0) != (HEAP32[i12 >> 2] | 0)) break;
     i9 = HEAP32[i38 >> 2] | 0;
     i8 = i9 + 12 | 0;
     i7 = HEAP32[i8 >> 2] | 0;
     if ((i7 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] & 127](i9) | 0; else HEAP32[i8 >> 2] = i7 + 4;
     i3 = i2;
     i9 = HEAP8[i47 >> 0] | 0;
     i12 = i12 + 4 | 0;
    }
    if (i20) {
     i9 = HEAP8[i47 >> 0] | 0;
     if (!(i9 & 1)) {
      i8 = i14;
      i9 = (i9 & 255) >>> 1;
     } else {
      i8 = HEAP32[i15 >> 2] | 0;
      i9 = HEAP32[i14 >> 2] | 0;
     }
     if ((i12 | 0) != (i8 + (i9 << 2) | 0)) {
      i37 = 174;
      break L1;
     } else i7 = i11;
    } else i7 = i11;
    break;
   }
  case 0:
   {
    i37 = 29;
    break;
   }
  default:
   {
    i2 = i13;
    i7 = i11;
   }
  } while (0);
  L327 : do if ((i37 | 0) == 29) {
   i37 = 0;
   if ((i21 | 0) == 3) {
    i2 = i13;
    i37 = 267;
    break L1;
   } else {
    i2 = i13;
    i7 = i13;
   }
   while (1) {
    i9 = HEAP32[i38 >> 2] | 0;
    do if (i9) {
     i8 = HEAP32[i9 + 12 >> 2] | 0;
     if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i9 = HEAP32[i8 >> 2] | 0;
     if ((i9 | 0) == -1) {
      HEAP32[i38 >> 2] = 0;
      i8 = 1;
      break;
     } else {
      i8 = (HEAP32[i38 >> 2] | 0) == 0;
      break;
     }
    } else i8 = 1; while (0);
    do if (i7) {
     i9 = HEAP32[i7 + 12 >> 2] | 0;
     if ((i9 | 0) == (HEAP32[i7 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 127](i7) | 0; else i9 = HEAP32[i9 >> 2] | 0;
     if ((i9 | 0) != -1) if (i8 ^ (i2 | 0) == 0) {
      i1 = i2;
      i3 = i2;
      break;
     } else {
      i7 = i11;
      break L327;
     } else {
      HEAP32[i39 >> 2] = 0;
      i2 = 0;
      i37 = 43;
      break;
     }
    } else i37 = 43; while (0);
    if ((i37 | 0) == 43) {
     i37 = 0;
     if (i8) {
      i7 = i11;
      break L327;
     } else {
      i1 = i2;
      i3 = 0;
     }
    }
    i9 = HEAP32[i38 >> 2] | 0;
    i8 = HEAP32[i9 + 12 >> 2] | 0;
    if ((i8 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i9 = HEAP32[i8 >> 2] | 0;
    if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i27 >> 2] | 0) + 12 >> 2] & 63](i27, 8192, i9) | 0)) {
     i2 = i1;
     i7 = i11;
     break L327;
    }
    i9 = HEAP32[i38 >> 2] | 0;
    i8 = i9 + 12 | 0;
    i7 = HEAP32[i8 >> 2] | 0;
    if ((i7 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i9 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] & 127](i9) | 0; else {
     HEAP32[i8 >> 2] = i7 + 4;
     i9 = HEAP32[i7 >> 2] | 0;
    }
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw(i46, i9);
    i2 = i1;
    i7 = i3;
   }
  } while (0);
  i21 = i21 + 1 | 0;
  if (i21 >>> 0 >= 4) {
   i11 = i7;
   i37 = 267;
   break;
  } else i11 = i7;
 }
 L363 : do if ((i37 | 0) == 28) {
  HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
  i2 = 0;
 } else if ((i37 | 0) == 117) {
  HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
  i2 = 0;
 } else if ((i37 | 0) == 174) {
  HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
  i2 = 0;
 } else if ((i37 | 0) == 231) {
  HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
  i2 = 0;
 } else if ((i37 | 0) == 254) {
  HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
  i2 = 0;
 } else if ((i37 | 0) == 265) {
  HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
  i2 = 0;
 } else if ((i37 | 0) == 267) {
  L369 : do if (i10) {
   i8 = i10 + 4 | 0;
   i9 = i10 + 8 | 0;
   i7 = i2;
   i3 = i2;
   i5 = 1;
   L371 : while (1) {
    i2 = HEAP8[i10 >> 0] | 0;
    if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i8 >> 2] | 0;
    if (i5 >>> 0 >= i2 >>> 0) break L369;
    i2 = HEAP32[i38 >> 2] | 0;
    do if (i2) {
     i1 = HEAP32[i2 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) == -1) {
      HEAP32[i38 >> 2] = 0;
      i4 = 1;
      break;
     } else {
      i4 = (HEAP32[i38 >> 2] | 0) == 0;
      break;
     }
    } else i4 = 1; while (0);
    do if (i3) {
     i2 = HEAP32[i3 + 12 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0; else i2 = HEAP32[i2 >> 2] | 0;
     if ((i2 | 0) != -1) if (i4 ^ (i7 | 0) == 0) {
      i2 = i7;
      i6 = i7;
      break;
     } else break L371; else {
      HEAP32[i39 >> 2] = 0;
      i2 = 0;
      i37 = 286;
      break;
     }
    } else {
     i2 = i7;
     i37 = 286;
    } while (0);
    if ((i37 | 0) == 286) {
     i37 = 0;
     if (i4) break; else i6 = 0;
    }
    i1 = HEAP32[i38 >> 2] | 0;
    i3 = HEAP32[i1 + 12 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i1 = HEAP32[i3 >> 2] | 0;
    if (!(HEAP8[i10 >> 0] & 1)) i3 = i8; else i3 = HEAP32[i9 >> 2] | 0;
    if ((i1 | 0) != (HEAP32[i3 + (i5 << 2) >> 2] | 0)) break;
    i5 = i5 + 1 | 0;
    i3 = HEAP32[i38 >> 2] | 0;
    i1 = i3 + 12 | 0;
    i4 = HEAP32[i1 >> 2] | 0;
    if ((i4 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
     FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] & 127](i3) | 0;
     i7 = i2;
     i3 = i6;
     continue;
    } else {
     HEAP32[i1 >> 2] = i4 + 4;
     i7 = i2;
     i3 = i6;
     continue;
    }
   }
   HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
   i2 = 0;
   break L363;
  } while (0);
  i2 = HEAP32[i48 >> 2] | 0;
  if ((i2 | 0) != (i11 | 0) ? (HEAP32[i41 >> 2] = 0, __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i43, i2, i11, i41), (HEAP32[i41 >> 2] | 0) != 0) : 0) {
   HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
   i2 = 0;
  } else i2 = 1;
 } while (0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i46);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i44);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i45);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i47);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i43);
 i1 = HEAP32[i48 >> 2] | 0;
 HEAP32[i48 >> 2] = 0;
 if (!i1) {
  STACKTOP = i49;
  return i2 | 0;
 }
 FUNCTION_TABLE_vi[HEAP32[i42 >> 2] & 511](i1);
 STACKTOP = i49;
 return i2 | 0;
}

function __ZN12_GLOBAL__N_110CLAHE_Impl5applyERKN2cv11_InputArrayERKNS1_12_OutputArrayE(i24, i22, i17) {
 i24 = i24 | 0;
 i22 = i22 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, d6 = 0.0, i7 = 0, f8 = Math_fround(0), i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = Math_fround(0);
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 i20 = i32 + 336 | 0;
 i11 = i32 + 328 | 0;
 i18 = i32 + 304 | 0;
 i1 = i32 + 296 | 0;
 i14 = i32 + 288 | 0;
 i12 = i32 + 280 | 0;
 i2 = i32 + 272 | 0;
 i3 = i32 + 248 | 0;
 i4 = i32 + 240 | 0;
 i5 = i32 + 232 | 0;
 i7 = i32;
 i31 = i32 + 176 | 0;
 i16 = i32 + 168 | 0;
 i30 = i32 + 112 | 0;
 i29 = i32 + 56 | 0;
 i19 = i32 + 48 | 0;
 i21 = i32 + 40 | 0;
 i28 = i32 + 32 | 0;
 if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i22 >> 2] | 0) + 56 >> 2] & 127](i22, -1) | 0) != 0 ? (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i22 >> 2] | 0) + 56 >> 2] & 127](i22, -1) | 0) != 2 : 0) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  i13 = (__ZN2cv6String8allocateEj(i11, 49) | 0) + 0 | 0;
  i9 = 181992 | 0;
  i10 = i13 + 49 | 0;
  do {
   HEAP8[i13 >> 0] = HEAP8[i9 >> 0] | 0;
   i13 = i13 + 1 | 0;
   i9 = i9 + 1 | 0;
  } while ((i13 | 0) < (i10 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i11, 182048, 182056, 360);
  __ZN2cv6String10deallocateEv(i11);
 }
 i9 = (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i22 >> 2] | 0) + 56 >> 2] & 127](i22, -1) | 0) == 0;
 i9 = i9 ? 256 : 4096;
 HEAP32[i18 >> 2] = 32088;
 i13 = i18 + 4 | 0;
 HEAP32[i13 + 0 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 FUNCTION_TABLE_viii[HEAP32[(HEAP32[i22 >> 2] | 0) + 40 >> 2] & 63](i1, i22, -1);
 i25 = i24 + 16 | 0;
 if (!((HEAP32[i1 >> 2] | 0) % (HEAP32[i25 >> 2] | 0) | 0)) {
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i22 >> 2] | 0) + 40 >> 2] & 63](i14, i22, -1);
  i10 = i24 + 20 | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  if (!((HEAP32[i14 + 4 >> 2] | 0) % (i11 | 0) | 0)) {
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i22 >> 2] | 0) + 40 >> 2] & 63](i12, i22, -1);
   i23 = HEAP32[i12 >> 2] | 0;
   i26 = HEAP32[i25 >> 2] | 0;
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i22 >> 2] | 0) + 40 >> 2] & 63](i2, i22, -1);
   i14 = (HEAP32[i2 + 4 >> 2] | 0) / (HEAP32[i10 >> 2] | 0) | 0;
   i12 = i22 + 4 | 0;
   i1 = HEAP32[i12 + 4 >> 2] | 0;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = i1;
   HEAP32[i18 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
   HEAP32[i18 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
   i26 = (i23 | 0) / (i26 | 0) | 0;
  } else i15 = 8;
 } else {
  i11 = HEAP32[i24 + 20 >> 2] | 0;
  i15 = 8;
 }
 if ((i15 | 0) == 8) {
  i15 = i24 + 24 | 0;
  i14 = i3 + 4 | 0;
  HEAP32[i14 + 0 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = 0;
  HEAP32[i3 >> 2] = 32232;
  HEAP32[i14 >> 2] = 33619968;
  HEAP32[i3 + 8 >> 2] = i15;
  i14 = i24 + 20 | 0;
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i22 >> 2] | 0) + 40 >> 2] & 63](i4, i22, -1);
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i22 >> 2] | 0) + 40 >> 2] & 63](i5, i22, -1);
  i26 = HEAP32[i5 >> 2] | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  HEAP32[i7 + 0 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAP32[i7 + 20 >> 2] = 0;
  HEAP32[i7 + 24 >> 2] = 0;
  HEAP32[i7 + 28 >> 2] = 0;
  HEAPF64[i7 >> 3] = 0.0;
  __ZN2cv14copyMakeBorderERKNS_11_InputArrayERKNS_12_OutputArrayEiiiiiRKNS_7Scalar_IdEE(i22, i3, 0, i11 - ((i2 | 0) % (i12 | 0) | 0) | 0, 0, i1 - ((i26 | 0) % (i23 | 0) | 0) | 0, 4, i7);
  i23 = HEAP32[i24 + 64 >> 2] | 0;
  i26 = (HEAP32[i23 + 4 >> 2] | 0) / (HEAP32[i25 >> 2] | 0) | 0;
  i14 = (HEAP32[i23 >> 2] | 0) / (HEAP32[i14 >> 2] | 0) | 0;
  i23 = i13;
  HEAP32[i23 >> 2] = 16842752;
  HEAP32[i23 + 4 >> 2] = i15;
  HEAP32[i18 + 12 >> 2] = 0;
  HEAP32[i18 + 16 >> 2] = 0;
 }
 i5 = Math_imul(i26, i14) | 0;
 f8 = Math_fround(Math_fround(i9 + -1 | 0) / Math_fround(i5 | 0));
 d6 = +HEAPF64[i24 + 8 >> 3];
 if (d6 > 0.0) {
  i15 = ~~(d6 * +(i5 | 0) / +(i9 | 0));
  i15 = (i15 | 0) < 1 ? 1 : i15;
 } else i15 = 0;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i22 >> 2] >> 2] & 63](i31, i22, -1);
 i11 = HEAP32[(HEAP32[i17 >> 2] | 0) + 136 >> 2] | 0;
 i27 = i31 + 40 | 0;
 i10 = HEAP32[i27 >> 2] | 0;
 i23 = HEAP32[i10 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i16 + 4 >> 2] = i23;
 FUNCTION_TABLE_viiiiii[i11 & 31](i17, i16, HEAP32[i31 >> 2] & 4095, -1, 0, 0);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i17 >> 2] >> 2] & 63](i30, i17, -1);
 __ZNK2cv11_InputArray6getMatEi(i29, i18, -1);
 i16 = i24 + 80 | 0;
 i11 = HEAP32[i25 >> 2] | 0;
 i23 = i24 + 20 | 0;
 i10 = HEAP32[i23 >> 2] | 0;
 i11 = Math_imul(i10, i11) | 0;
 i10 = (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i22 >> 2] | 0) + 56 >> 2] & 127](i22, -1) | 0) & 4095;
 i17 = i24 + 84 | 0;
 if (!(((((HEAP32[i17 >> 2] | 0) < 3 ? (HEAP32[i24 + 88 >> 2] | 0) == (i11 | 0) : 0) ? (HEAP32[i24 + 92 >> 2] | 0) == (i9 | 0) : 0) ? (HEAP32[i16 >> 2] & 4095 | 0) == (i10 | 0) : 0) ? (HEAP32[i24 + 96 >> 2] | 0) != 0 : 0)) {
  HEAP32[i20 >> 2] = i11;
  HEAP32[i20 + 4 >> 2] = i9;
  __ZN2cv3Mat6createEiPKii(i16, 2, i20, i10);
 }
 do if (!(FUNCTION_TABLE_iii[HEAP32[(HEAP32[i22 >> 2] | 0) + 56 >> 2] & 127](i22, -1) | 0)) {
  i2 = __Znwj(136) | 0;
  HEAP32[i2 >> 2] = 182848;
  i7 = i2 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i29 >> 2];
  i5 = i2 + 8 | 0;
  i10 = i29 + 4 | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP32[i5 >> 2] = i11;
  i20 = i2 + 12 | 0;
  HEAP32[i20 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i29 + 12 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i29 + 16 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i29 + 20 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i29 + 24 >> 2];
  HEAP32[i2 + 32 >> 2] = HEAP32[i29 + 28 >> 2];
  HEAP32[i2 + 36 >> 2] = HEAP32[i29 + 32 >> 2];
  i9 = HEAP32[i29 + 36 >> 2] | 0;
  HEAP32[i2 + 40 >> 2] = i9;
  HEAP32[i2 + 44 >> 2] = i20;
  i20 = i2 + 52 | 0;
  i4 = i2 + 48 | 0;
  HEAP32[i4 >> 2] = i20;
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i20 >> 2] = 0;
  if (i9) {
   i11 = i9 + 12 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i11 = HEAP32[i10 >> 2] | 0;
  }
  if ((i11 | 0) < 3) {
   i19 = HEAP32[i29 + 44 >> 2] | 0;
   i20 = HEAP32[i4 >> 2] | 0;
   HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  } else {
   HEAP32[i5 >> 2] = 0;
   __ZN2cv3Mat8copySizeERKS0_(i7, i29);
  }
  i9 = i2 + 60 | 0;
  HEAP32[i9 >> 2] = HEAP32[i16 >> 2];
  i7 = i2 + 64 | 0;
  i11 = HEAP32[i17 >> 2] | 0;
  HEAP32[i7 >> 2] = i11;
  i20 = i2 + 68 | 0;
  HEAP32[i20 >> 2] = HEAP32[i24 + 88 >> 2];
  HEAP32[i2 + 72 >> 2] = HEAP32[i24 + 92 >> 2];
  HEAP32[i2 + 76 >> 2] = HEAP32[i24 + 96 >> 2];
  HEAP32[i2 + 80 >> 2] = HEAP32[i24 + 100 >> 2];
  HEAP32[i2 + 84 >> 2] = HEAP32[i24 + 104 >> 2];
  HEAP32[i2 + 88 >> 2] = HEAP32[i24 + 108 >> 2];
  HEAP32[i2 + 92 >> 2] = HEAP32[i24 + 112 >> 2];
  i10 = HEAP32[i24 + 116 >> 2] | 0;
  HEAP32[i2 + 96 >> 2] = i10;
  HEAP32[i2 + 100 >> 2] = i20;
  i20 = i2 + 108 | 0;
  i5 = i2 + 104 | 0;
  HEAP32[i5 >> 2] = i20;
  HEAP32[i2 + 112 >> 2] = 0;
  HEAP32[i20 >> 2] = 0;
  if (i10) {
   i11 = i10 + 12 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i11 = HEAP32[i17 >> 2] | 0;
  }
  if ((i11 | 0) < 3) {
   i19 = HEAP32[i24 + 124 >> 2] | 0;
   i20 = HEAP32[i5 >> 2] | 0;
   HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  } else {
   HEAP32[i7 >> 2] = 0;
   __ZN2cv3Mat8copySizeERKS0_(i9, i16);
  }
  HEAP32[i2 + 116 >> 2] = i26;
  HEAP32[i2 + 120 >> 2] = i14;
  HEAP32[i2 + 124 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i2 + 128 >> 2] = i15;
  HEAPF32[i2 + 132 >> 2] = f8;
  i3 = __Znwj(16) | 0;
  i19 = i3 + 4 | 0;
  HEAP32[i19 >> 2] = 1;
  HEAP32[i3 >> 2] = 182944;
  HEAP32[i3 + 8 >> 2] = i2;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  i20 = HEAP32[i19 >> 2] | 0;
  HEAP32[i19 >> 2] = i20 + -1;
  if ((i20 | 0) == 1) {
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
   i20 = i3;
  } else i20 = i3;
 } else {
  if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i22 >> 2] | 0) + 56 >> 2] & 127](i22, -1) | 0) != 2) {
   HEAP32[i19 >> 2] = 0;
   HEAP32[i19 + 4 >> 2] = 0;
   i13 = (__ZN2cv6String8allocateEj(i19, 16) | 0) + 0 | 0;
   i9 = 182112 | 0;
   i10 = i13 + 16 | 0;
   do {
    HEAP8[i13 >> 0] = HEAP8[i9 >> 0] | 0;
    i13 = i13 + 1 | 0;
    i9 = i9 + 1 | 0;
   } while ((i13 | 0) < (i10 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i19, 182048, 182056, 425);
   __ZN2cv6String10deallocateEv(i19);
   i2 = 0;
   i20 = 0;
   break;
  }
  i2 = __Znwj(136) | 0;
  HEAP32[i2 >> 2] = 182608;
  i7 = i2 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i29 >> 2];
  i5 = i2 + 8 | 0;
  i10 = i29 + 4 | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP32[i5 >> 2] = i11;
  i20 = i2 + 12 | 0;
  HEAP32[i20 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i29 + 12 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i29 + 16 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i29 + 20 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i29 + 24 >> 2];
  HEAP32[i2 + 32 >> 2] = HEAP32[i29 + 28 >> 2];
  HEAP32[i2 + 36 >> 2] = HEAP32[i29 + 32 >> 2];
  i9 = HEAP32[i29 + 36 >> 2] | 0;
  HEAP32[i2 + 40 >> 2] = i9;
  HEAP32[i2 + 44 >> 2] = i20;
  i20 = i2 + 52 | 0;
  i4 = i2 + 48 | 0;
  HEAP32[i4 >> 2] = i20;
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i20 >> 2] = 0;
  if (i9) {
   i11 = i9 + 12 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i11 = HEAP32[i10 >> 2] | 0;
  }
  if ((i11 | 0) < 3) {
   i19 = HEAP32[i29 + 44 >> 2] | 0;
   i20 = HEAP32[i4 >> 2] | 0;
   HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  } else {
   HEAP32[i5 >> 2] = 0;
   __ZN2cv3Mat8copySizeERKS0_(i7, i29);
  }
  i9 = i2 + 60 | 0;
  HEAP32[i9 >> 2] = HEAP32[i16 >> 2];
  i7 = i2 + 64 | 0;
  i11 = HEAP32[i17 >> 2] | 0;
  HEAP32[i7 >> 2] = i11;
  i20 = i2 + 68 | 0;
  HEAP32[i20 >> 2] = HEAP32[i24 + 88 >> 2];
  HEAP32[i2 + 72 >> 2] = HEAP32[i24 + 92 >> 2];
  HEAP32[i2 + 76 >> 2] = HEAP32[i24 + 96 >> 2];
  HEAP32[i2 + 80 >> 2] = HEAP32[i24 + 100 >> 2];
  HEAP32[i2 + 84 >> 2] = HEAP32[i24 + 104 >> 2];
  HEAP32[i2 + 88 >> 2] = HEAP32[i24 + 108 >> 2];
  HEAP32[i2 + 92 >> 2] = HEAP32[i24 + 112 >> 2];
  i10 = HEAP32[i24 + 116 >> 2] | 0;
  HEAP32[i2 + 96 >> 2] = i10;
  HEAP32[i2 + 100 >> 2] = i20;
  i20 = i2 + 108 | 0;
  i5 = i2 + 104 | 0;
  HEAP32[i5 >> 2] = i20;
  HEAP32[i2 + 112 >> 2] = 0;
  HEAP32[i20 >> 2] = 0;
  if (i10) {
   i11 = i10 + 12 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i11 = HEAP32[i17 >> 2] | 0;
  }
  if ((i11 | 0) < 3) {
   i19 = HEAP32[i24 + 124 >> 2] | 0;
   i20 = HEAP32[i5 >> 2] | 0;
   HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  } else {
   HEAP32[i7 >> 2] = 0;
   __ZN2cv3Mat8copySizeERKS0_(i9, i16);
  }
  HEAP32[i2 + 116 >> 2] = i26;
  HEAP32[i2 + 120 >> 2] = i14;
  HEAP32[i2 + 124 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i2 + 128 >> 2] = i15;
  HEAPF32[i2 + 132 >> 2] = f8;
  i3 = __Znwj(16) | 0;
  i19 = i3 + 4 | 0;
  HEAP32[i19 >> 2] = 1;
  HEAP32[i3 >> 2] = 182704;
  HEAP32[i3 + 8 >> 2] = i2;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  i20 = HEAP32[i19 >> 2] | 0;
  HEAP32[i19 >> 2] = i20 + -1;
  if ((i20 | 0) == 1) {
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
   i20 = i3;
  } else i20 = i3;
 } while (0);
 i19 = Math_imul(HEAP32[i23 >> 2] | 0, HEAP32[i25 >> 2] | 0) | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = i19;
 __ZN2cv13parallel_for_ERKNS_5RangeERKNS_16ParallelLoopBodyEd(i21, i2, -1.0);
 do if (!(FUNCTION_TABLE_iii[HEAP32[(HEAP32[i22 >> 2] | 0) + 56 >> 2] & 127](i22, -1) | 0)) {
  i2 = __Znwj(1268) | 0;
  HEAP32[i2 >> 2] = 182376;
  i9 = i2 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i31 >> 2];
  i5 = i2 + 8 | 0;
  i11 = i31 + 4 | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i5 >> 2] = i7;
  i22 = i2 + 12 | 0;
  i1 = i31 + 8 | 0;
  HEAP32[i22 >> 2] = HEAP32[i1 >> 2];
  i18 = i31 + 12 | 0;
  HEAP32[i2 + 16 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i31 + 16 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i31 + 20 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i31 + 24 >> 2];
  HEAP32[i2 + 32 >> 2] = HEAP32[i31 + 28 >> 2];
  HEAP32[i2 + 36 >> 2] = HEAP32[i31 + 32 >> 2];
  i10 = HEAP32[i31 + 36 >> 2] | 0;
  HEAP32[i2 + 40 >> 2] = i10;
  HEAP32[i2 + 44 >> 2] = i22;
  i22 = i2 + 52 | 0;
  i4 = i2 + 48 | 0;
  HEAP32[i4 >> 2] = i22;
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  if (i10) {
   i7 = i10 + 12 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   i7 = HEAP32[i11 >> 2] | 0;
  }
  if ((i7 | 0) < 3) {
   i21 = HEAP32[i31 + 44 >> 2] | 0;
   i22 = HEAP32[i4 >> 2] | 0;
   HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  } else {
   HEAP32[i5 >> 2] = 0;
   __ZN2cv3Mat8copySizeERKS0_(i9, i31);
  }
  i9 = i2 + 60 | 0;
  HEAP32[i9 >> 2] = HEAP32[i30 >> 2];
  i5 = i2 + 64 | 0;
  i11 = i30 + 4 | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i5 >> 2] = i7;
  i22 = i2 + 68 | 0;
  HEAP32[i22 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i2 + 72 >> 2] = HEAP32[i30 + 12 >> 2];
  HEAP32[i2 + 76 >> 2] = HEAP32[i30 + 16 >> 2];
  HEAP32[i2 + 80 >> 2] = HEAP32[i30 + 20 >> 2];
  HEAP32[i2 + 84 >> 2] = HEAP32[i30 + 24 >> 2];
  HEAP32[i2 + 88 >> 2] = HEAP32[i30 + 28 >> 2];
  HEAP32[i2 + 92 >> 2] = HEAP32[i30 + 32 >> 2];
  i10 = HEAP32[i30 + 36 >> 2] | 0;
  HEAP32[i2 + 96 >> 2] = i10;
  HEAP32[i2 + 100 >> 2] = i22;
  i22 = i2 + 108 | 0;
  i4 = i2 + 104 | 0;
  HEAP32[i4 >> 2] = i22;
  HEAP32[i2 + 112 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  if (i10) {
   i7 = i10 + 12 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   i7 = HEAP32[i11 >> 2] | 0;
  }
  if ((i7 | 0) < 3) {
   i21 = HEAP32[i30 + 44 >> 2] | 0;
   i22 = HEAP32[i4 >> 2] | 0;
   HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  } else {
   HEAP32[i5 >> 2] = 0;
   __ZN2cv3Mat8copySizeERKS0_(i9, i30);
  }
  i10 = i2 + 116 | 0;
  HEAP32[i10 >> 2] = HEAP32[i16 >> 2];
  i9 = i2 + 120 | 0;
  i7 = HEAP32[i17 >> 2] | 0;
  HEAP32[i9 >> 2] = i7;
  i15 = i2 + 124 | 0;
  HEAP32[i15 >> 2] = HEAP32[i24 + 88 >> 2];
  HEAP32[i2 + 128 >> 2] = HEAP32[i24 + 92 >> 2];
  HEAP32[i2 + 132 >> 2] = HEAP32[i24 + 96 >> 2];
  HEAP32[i2 + 136 >> 2] = HEAP32[i24 + 100 >> 2];
  HEAP32[i2 + 140 >> 2] = HEAP32[i24 + 104 >> 2];
  HEAP32[i2 + 144 >> 2] = HEAP32[i24 + 108 >> 2];
  HEAP32[i2 + 148 >> 2] = HEAP32[i24 + 112 >> 2];
  i11 = HEAP32[i24 + 116 >> 2] | 0;
  HEAP32[i2 + 152 >> 2] = i11;
  HEAP32[i2 + 156 >> 2] = i15;
  i15 = i2 + 164 | 0;
  i5 = i2 + 160 | 0;
  HEAP32[i5 >> 2] = i15;
  HEAP32[i2 + 168 >> 2] = 0;
  HEAP32[i15 >> 2] = 0;
  if (i11) {
   i7 = i11 + 12 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   i7 = HEAP32[i17 >> 2] | 0;
  }
  if ((i7 | 0) < 3) {
   i21 = HEAP32[i24 + 124 >> 2] | 0;
   i22 = HEAP32[i5 >> 2] | 0;
   HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  } else {
   HEAP32[i9 >> 2] = 0;
   __ZN2cv3Mat8copySizeERKS0_(i10, i16);
  }
  HEAP32[i2 + 172 >> 2] = i26;
  HEAP32[i2 + 176 >> 2] = i14;
  i14 = i2 + 180 | 0;
  i12 = HEAP32[i25 >> 2] | 0;
  HEAP32[i14 >> 2] = i12;
  HEAP32[i2 + 184 >> 2] = HEAP32[i23 >> 2];
  i3 = i2 + 196 | 0;
  i4 = i2 + 188 | 0;
  HEAP32[i4 >> 2] = i3;
  i7 = i2 + 192 | 0;
  HEAP32[i7 >> 2] = 264;
  i13 = HEAP32[i18 >> 2] | 0;
  i5 = i13 << 2;
  if (i5 >>> 0 > 264) {
   i3 = __Znaj(i5 >>> 0 > 1073741823 ? -1 : i5 << 2) | 0;
   HEAP32[i4 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = i5;
  HEAP32[i2 + 1252 >> 2] = i3;
  HEAP32[i2 + 1256 >> 2] = i3 + (i13 << 2);
  i10 = i13 << 1;
  HEAP32[i2 + 1260 >> 2] = i3 + (i10 << 2);
  i11 = i10 + i13 | 0;
  HEAP32[i2 + 1264 >> 2] = i3 + (i11 << 2);
  i9 = HEAP32[i15 >> 2] | 0;
  f8 = Math_fround(Math_fround(1.0) / Math_fround(i26 | 0));
  L121 : do if ((i13 | 0) > 0) {
   i7 = i13 + -1 | 0;
   i5 = i12;
   i4 = 0;
   while (1) {
    f33 = Math_fround(Math_fround(f8 * Math_fround(i4 | 0)) + Math_fround(-.5));
    i21 = ~~f33;
    i21 = i21 - (+(i21 | 0) > +f33 & 1) | 0;
    i23 = i21 + 1 | 0;
    f33 = Math_fround(f33 - Math_fround(i21 | 0));
    HEAPF32[i3 + (i4 + i10 << 2) >> 2] = f33;
    HEAPF32[i3 + (i4 + i11 << 2) >> 2] = Math_fround(Math_fround(1.0) - f33);
    i22 = i5 + -1 | 0;
    HEAP32[i3 + (i4 << 2) >> 2] = Math_imul((i21 | 0) < 0 ? 0 : i21, i9) | 0;
    HEAP32[i3 + (i4 + i13 << 2) >> 2] = Math_imul((i22 | 0) < (i23 | 0) ? i22 : i23, i9) | 0;
    if ((i4 | 0) == (i7 | 0)) break L121;
    i5 = HEAP32[i14 >> 2] | 0;
    i4 = i4 + 1 | 0;
   }
  } while (0);
  i3 = __Znwj(16) | 0;
  i22 = i3 + 4 | 0;
  HEAP32[i22 >> 2] = 1;
  HEAP32[i3 >> 2] = 182464;
  HEAP32[i3 + 8 >> 2] = i2;
  HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
  i23 = HEAP32[i22 >> 2] | 0;
  HEAP32[i22 >> 2] = i23 + -1;
  if ((i23 | 0) == 1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
 } else {
  if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i22 >> 2] | 0) + 56 >> 2] & 127](i22, -1) | 0) != 2) {
   i1 = i31 + 8 | 0;
   i2 = 0;
   i3 = 0;
   break;
  }
  i2 = __Znwj(1268) | 0;
  HEAP32[i2 >> 2] = 182144;
  i7 = i2 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i31 >> 2];
  i5 = i2 + 8 | 0;
  i11 = i31 + 4 | 0;
  i9 = HEAP32[i11 >> 2] | 0;
  HEAP32[i5 >> 2] = i9;
  i22 = i2 + 12 | 0;
  i1 = i31 + 8 | 0;
  HEAP32[i22 >> 2] = HEAP32[i1 >> 2];
  i18 = i31 + 12 | 0;
  HEAP32[i2 + 16 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i31 + 16 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i31 + 20 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i31 + 24 >> 2];
  HEAP32[i2 + 32 >> 2] = HEAP32[i31 + 28 >> 2];
  HEAP32[i2 + 36 >> 2] = HEAP32[i31 + 32 >> 2];
  i10 = HEAP32[i31 + 36 >> 2] | 0;
  HEAP32[i2 + 40 >> 2] = i10;
  HEAP32[i2 + 44 >> 2] = i22;
  i22 = i2 + 52 | 0;
  i4 = i2 + 48 | 0;
  HEAP32[i4 >> 2] = i22;
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  if (i10) {
   i9 = i10 + 12 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   i9 = HEAP32[i11 >> 2] | 0;
  }
  if ((i9 | 0) < 3) {
   i21 = HEAP32[i31 + 44 >> 2] | 0;
   i22 = HEAP32[i4 >> 2] | 0;
   HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  } else {
   HEAP32[i5 >> 2] = 0;
   __ZN2cv3Mat8copySizeERKS0_(i7, i31);
  }
  i7 = i2 + 60 | 0;
  HEAP32[i7 >> 2] = HEAP32[i30 >> 2];
  i5 = i2 + 64 | 0;
  i11 = i30 + 4 | 0;
  i9 = HEAP32[i11 >> 2] | 0;
  HEAP32[i5 >> 2] = i9;
  i22 = i2 + 68 | 0;
  HEAP32[i22 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i2 + 72 >> 2] = HEAP32[i30 + 12 >> 2];
  HEAP32[i2 + 76 >> 2] = HEAP32[i30 + 16 >> 2];
  HEAP32[i2 + 80 >> 2] = HEAP32[i30 + 20 >> 2];
  HEAP32[i2 + 84 >> 2] = HEAP32[i30 + 24 >> 2];
  HEAP32[i2 + 88 >> 2] = HEAP32[i30 + 28 >> 2];
  HEAP32[i2 + 92 >> 2] = HEAP32[i30 + 32 >> 2];
  i10 = HEAP32[i30 + 36 >> 2] | 0;
  HEAP32[i2 + 96 >> 2] = i10;
  HEAP32[i2 + 100 >> 2] = i22;
  i22 = i2 + 108 | 0;
  i4 = i2 + 104 | 0;
  HEAP32[i4 >> 2] = i22;
  HEAP32[i2 + 112 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  if (i10) {
   i9 = i10 + 12 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   i9 = HEAP32[i11 >> 2] | 0;
  }
  if ((i9 | 0) < 3) {
   i21 = HEAP32[i30 + 44 >> 2] | 0;
   i22 = HEAP32[i4 >> 2] | 0;
   HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  } else {
   HEAP32[i5 >> 2] = 0;
   __ZN2cv3Mat8copySizeERKS0_(i7, i30);
  }
  i10 = i2 + 116 | 0;
  HEAP32[i10 >> 2] = HEAP32[i16 >> 2];
  i7 = i2 + 120 | 0;
  i9 = HEAP32[i17 >> 2] | 0;
  HEAP32[i7 >> 2] = i9;
  i15 = i2 + 124 | 0;
  HEAP32[i15 >> 2] = HEAP32[i24 + 88 >> 2];
  HEAP32[i2 + 128 >> 2] = HEAP32[i24 + 92 >> 2];
  HEAP32[i2 + 132 >> 2] = HEAP32[i24 + 96 >> 2];
  HEAP32[i2 + 136 >> 2] = HEAP32[i24 + 100 >> 2];
  HEAP32[i2 + 140 >> 2] = HEAP32[i24 + 104 >> 2];
  HEAP32[i2 + 144 >> 2] = HEAP32[i24 + 108 >> 2];
  HEAP32[i2 + 148 >> 2] = HEAP32[i24 + 112 >> 2];
  i11 = HEAP32[i24 + 116 >> 2] | 0;
  HEAP32[i2 + 152 >> 2] = i11;
  HEAP32[i2 + 156 >> 2] = i15;
  i15 = i2 + 164 | 0;
  i5 = i2 + 160 | 0;
  HEAP32[i5 >> 2] = i15;
  HEAP32[i2 + 168 >> 2] = 0;
  HEAP32[i15 >> 2] = 0;
  if (i11) {
   i9 = i11 + 12 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   i9 = HEAP32[i17 >> 2] | 0;
  }
  if ((i9 | 0) < 3) {
   i21 = HEAP32[i24 + 124 >> 2] | 0;
   i22 = HEAP32[i5 >> 2] | 0;
   HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  } else {
   HEAP32[i7 >> 2] = 0;
   __ZN2cv3Mat8copySizeERKS0_(i10, i16);
  }
  HEAP32[i2 + 172 >> 2] = i26;
  HEAP32[i2 + 176 >> 2] = i14;
  i14 = i2 + 180 | 0;
  i13 = HEAP32[i25 >> 2] | 0;
  HEAP32[i14 >> 2] = i13;
  HEAP32[i2 + 184 >> 2] = HEAP32[i23 >> 2];
  i5 = i2 + 196 | 0;
  i4 = i2 + 188 | 0;
  HEAP32[i4 >> 2] = i5;
  i7 = i2 + 192 | 0;
  HEAP32[i7 >> 2] = 264;
  i12 = HEAP32[i18 >> 2] | 0;
  i3 = i12 << 2;
  if (i3 >>> 0 > 264) {
   i5 = __Znaj(i3 >>> 0 > 1073741823 ? -1 : i3 << 2) | 0;
   HEAP32[i4 >> 2] = i5;
  }
  HEAP32[i7 >> 2] = i3;
  HEAP32[i2 + 1252 >> 2] = i5;
  HEAP32[i2 + 1256 >> 2] = i5 + (i12 << 2);
  i10 = i12 << 1;
  HEAP32[i2 + 1260 >> 2] = i5 + (i10 << 2);
  i11 = i10 + i12 | 0;
  HEAP32[i2 + 1264 >> 2] = i5 + (i11 << 2);
  i9 = (HEAP32[i15 >> 2] | 0) >>> 1;
  f8 = Math_fround(Math_fround(1.0) / Math_fround(i26 | 0));
  L89 : do if ((i12 | 0) > 0) {
   i7 = i12 + -1 | 0;
   i4 = i13;
   i3 = 0;
   while (1) {
    f33 = Math_fround(Math_fround(f8 * Math_fround(i3 | 0)) + Math_fround(-.5));
    i21 = ~~f33;
    i21 = i21 - (+(i21 | 0) > +f33 & 1) | 0;
    i23 = i21 + 1 | 0;
    f33 = Math_fround(f33 - Math_fround(i21 | 0));
    HEAPF32[i5 + (i3 + i10 << 2) >> 2] = f33;
    HEAPF32[i5 + (i3 + i11 << 2) >> 2] = Math_fround(Math_fround(1.0) - f33);
    i22 = i4 + -1 | 0;
    HEAP32[i5 + (i3 << 2) >> 2] = Math_imul((i21 | 0) < 0 ? 0 : i21, i9) | 0;
    HEAP32[i5 + (i3 + i12 << 2) >> 2] = Math_imul((i22 | 0) < (i23 | 0) ? i22 : i23, i9) | 0;
    if ((i3 | 0) == (i7 | 0)) break L89;
    i4 = HEAP32[i14 >> 2] | 0;
    i3 = i3 + 1 | 0;
   }
  } while (0);
  i3 = __Znwj(16) | 0;
  i22 = i3 + 4 | 0;
  HEAP32[i22 >> 2] = 1;
  HEAP32[i3 >> 2] = 182232;
  HEAP32[i3 + 8 >> 2] = i2;
  HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
  i23 = HEAP32[i22 >> 2] | 0;
  HEAP32[i22 >> 2] = i23 + -1;
  if ((i23 | 0) == 1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
 } while (0);
 i23 = HEAP32[i1 >> 2] | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = i23;
 __ZN2cv13parallel_for_ERKNS_5RangeERKNS_16ParallelLoopBodyEd(i28, i2, -1.0);
 if ((i3 | 0) != 0 ? (i22 = i3 + 4 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
 if ((i20 | 0) != 0 ? (i22 = i20 + 4 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i20 >> 2] | 0) + 8 >> 2] & 511](i20);
 i3 = i29 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i22 = i2 + 12 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i29);
 HEAP32[i3 >> 2] = 0;
 i23 = i29 + 16 | 0;
 i3 = i29 + 4 | 0;
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i29 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i2 = HEAP32[i29 + 44 >> 2] | 0;
 if ((i2 | 0) != (i29 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i30 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i22 = i1 + 12 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i30);
 HEAP32[i2 >> 2] = 0;
 i23 = i30 + 16 | 0;
 i3 = i30 + 4 | 0;
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i30 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i30 + 44 >> 2] | 0;
 if ((i1 | 0) != (i30 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i31 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i22 = i2 + 12 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i31);
 HEAP32[i1 >> 2] = 0;
 i23 = i31 + 16 | 0;
 i3 = i31 + 4 | 0;
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i27 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i31 + 44 >> 2] | 0;
 if ((i1 | 0) == (i31 + 48 | 0)) {
  STACKTOP = i32;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i32;
 return;
}

function __ZNK2cv13AlgorithmInfo3setEPNS_9AlgorithmEPKciPKvb(i5, i43, i37, i25, i42, i8) {
 i5 = i5 | 0;
 i43 = i43 | 0;
 i37 = i37 | 0;
 i25 = i25 | 0;
 i42 = i42 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, d6 = 0.0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i44 = 0, f45 = f0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i7 = i44;
 i10 = i44 + 208 | 0;
 i9 = i44 + 200 | 0;
 i26 = i44 + 192 | 0;
 i23 = i44 + 184 | 0;
 i24 = i44 + 176 | 0;
 i31 = i44 + 168 | 0;
 i32 = i44 + 160 | 0;
 i33 = i44 + 152 | 0;
 i34 = i44 + 144 | 0;
 i35 = i44 + 136 | 0;
 i36 = i44 + 128 | 0;
 i29 = i44 + 120 | 0;
 i30 = i44 + 112 | 0;
 i19 = i44 + 104 | 0;
 i11 = i44 + 96 | 0;
 i12 = i44 + 88 | 0;
 i20 = i44 + 80 | 0;
 i13 = i44 + 72 | 0;
 i14 = i44 + 64 | 0;
 i21 = i44 + 56 | 0;
 i15 = i44 + 48 | 0;
 i16 = i44 + 40 | 0;
 i22 = i44 + 32 | 0;
 i17 = i44 + 24 | 0;
 i18 = i44 + 16 | 0;
 i27 = i44 + 8 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i28 = (i37 | 0) == 0;
 if (!i28) {
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i4 | 0) == (i2 | 0)) {
   i3 = i4;
   i5 = 0;
  } else {
   i5 = 0;
   i3 = (i4 - i2 | 0) / 44 | 0;
   do {
    i1 = (i5 + i3 | 0) >>> 1;
    i38 = HEAP32[i2 + (i1 * 44 | 0) >> 2] | 0;
    i38 = (_strcmp((i38 | 0) == 0 ? 39376 : i38, i37) | 0) < 0;
    i5 = i38 ? i1 + 1 | 0 : i5;
    i3 = i38 ? i3 : i1;
   } while (i3 >>> 0 > i5 >>> 0);
   i3 = i4;
   i4 = i2;
  }
  if (i5 >>> 0 < ((i3 - i4 | 0) / 44 | 0) >>> 0 ? (i1 = HEAP32[i4 + (i5 * 44 | 0) >> 2] | 0, (_strcmp((i1 | 0) == 0 ? 39376 : i1, i37) | 0) == 0) : 0) i40 = i4 + (i5 * 44 | 0) + 8 | 0; else i39 = 8;
 } else i39 = 8;
 if ((i39 | 0) == 8) {
  HEAP32[i7 >> 2] = (i37 | 0) != 0 ? i37 : 38112;
  __ZN2cv6formatEPKcz(i10, 38080, i7);
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i10, 38120, 37992, 619);
  __ZN2cv6String10deallocateEv(i10);
  i40 = 0;
 }
 if (!i8 ? (HEAP8[i40 + 8 >> 0] | 0) != 0 : 0) {
  HEAP32[i7 >> 2] = i37;
  __ZN2cv6formatEPKcz(i9, 38128, i7);
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i9, 38120, 37992, 622);
  __ZN2cv6String10deallocateEv(i9);
 }
 i38 = i40 + 20 | 0;
 i1 = HEAPU8[i38 >> 0] | HEAPU8[i38 + 1 >> 0] << 8 | HEAPU8[i38 + 2 >> 0] << 16 | HEAPU8[i38 + 3 >> 0] << 24;
 i41 = i38 + 4 | 0;
 i41 = HEAPU8[i41 >> 0] | HEAPU8[i41 + 1 >> 0] << 8 | HEAPU8[i41 + 2 >> 0] << 16 | HEAPU8[i41 + 3 >> 0] << 24;
 i4 = (i25 | 0) == 0;
 i3 = (i25 | 0) == 1;
 i2 = (i25 | 0) == 2;
 i7 = (i25 | 0) == 7;
 i8 = (i25 | 0) == 8;
 i9 = (i25 | 0) == 9;
 i10 = (i25 | 0) == 11;
 switch (i25 | 0) {
 case 0:
 case 1:
 case 2:
 case 7:
 case 8:
 case 9:
 case 11:
  {
   i5 = HEAP32[i40 >> 2] | 0;
   switch (i5 | 0) {
   case 11:
   case 7:
   case 9:
   case 8:
   case 1:
   case 2:
   case 0:
    break;
   default:
    {
     i22 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i43 >> 2] | 0) + 16 >> 2] & 127](i43) | 0) >> 2] | 0;
     i5 = HEAP32[i22 + 12 >> 2] | 0;
     HEAP32[i23 >> 2] = i5;
     HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 16 >> 2];
     if (i5) {
      i22 = i5 + -4 | 0;
      HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
     }
     HEAP32[i24 >> 2] = 0;
     HEAP32[i24 + 4 >> 2] = 0;
     if (!i28) {
      i22 = _strlen(i37 | 0) | 0;
      _memcpy(__ZN2cv6String8allocateEj(i24, i22) | 0, i37 | 0, i22 | 0) | 0;
     }
     __ZN2cvL39getErrorMessageForWrongArgumentInSetterENS_6StringES0_ii(i26, i23, i24, HEAP32[i40 >> 2] | 0, i25);
     __ZN2cv6String10deallocateEv(i24);
     __ZN2cv6String10deallocateEv(i23);
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i26, 38120, 37992, 634);
     __ZN2cv6String10deallocateEv(i26);
     i5 = HEAP32[i40 >> 2] | 0;
    }
   }
   switch (i5 | 0) {
   case 7:
    {
     do if (!i4) {
      if (i3) {
       d6 = +((HEAP8[i42 >> 0] | 0) != 0 & 1);
       break;
      }
      if (i2) {
       d6 = +HEAPF64[i42 >> 3];
       break;
      }
      if (i7) {
       d6 = +Math_fround(HEAPF32[i42 >> 2]);
       break;
      }
      if (i8) {
       d6 = +((HEAP32[i42 >> 2] | 0) >>> 0);
       break;
      }
      if (i9) {
       i23 = i42;
       d6 = +((HEAP32[i23 >> 2] | 0) >>> 0) + 4294967296.0 * +((HEAP32[i23 + 4 >> 2] | 0) >>> 0);
       break;
      }
      if (i10) {
       d6 = +(HEAPU8[i42 >> 0] | 0);
       break;
      } else {
       HEAP32[i34 >> 2] = 0;
       HEAP32[i34 + 4 >> 2] = 0;
       i5 = (__ZN2cv6String8allocateEj(i34, 33) | 0) + 0 | 0;
       i4 = 38160;
       i3 = i5 + 33 | 0;
       do {
        HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
        i5 = i5 + 1 | 0;
        i4 = i4 + 1 | 0;
       } while ((i5 | 0) < (i3 | 0));
       __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i34, 38120, 37992, 716);
       __ZN2cv6String10deallocateEv(i34);
       d6 = 0.0;
       break;
      }
     } else d6 = +(HEAP32[i42 >> 2] | 0); while (0);
     i23 = i38 + 4 | 0;
     if (!((HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24) & 1 | (HEAPU8[i38 >> 0] | HEAPU8[i38 + 1 >> 0] << 8 | HEAPU8[i38 + 2 >> 0] << 16 | HEAPU8[i38 + 3 >> 0] << 24))) {
      f45 = Math_fround(d6);
      HEAPF32[i43 + (HEAP32[i40 + 4 >> 2] | 0) >> 2] = f45;
      STACKTOP = i44;
      return;
     }
     i2 = i43 + (i41 >> 1) | 0;
     if (i41 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
     f45 = Math_fround(d6);
     FUNCTION_TABLE_vif[i1 & 0](i2, f45);
     STACKTOP = i44;
     return;
    }
   case 8:
    {
     do if (!i4) {
      if (i3) {
       i5 = HEAPU8[i42 >> 0] | 0;
       break;
      }
      if (i2) {
       i5 = _lrint(+HEAPF64[i42 >> 3]) | 0;
       break;
      }
      if (i7) {
       i5 = _lrint(+Math_fround(HEAPF32[i42 >> 2])) | 0;
       break;
      }
      if (i8) {
       i5 = HEAP32[i42 >> 2] | 0;
       break;
      }
      if (i9) {
       i5 = HEAP32[i42 >> 2] | 0;
       break;
      }
      if (i10) {
       i5 = HEAPU8[i42 >> 0] | 0;
       break;
      } else {
       HEAP32[i35 >> 2] = 0;
       HEAP32[i35 + 4 >> 2] = 0;
       i5 = (__ZN2cv6String8allocateEj(i35, 33) | 0) + 0 | 0;
       i4 = 38160;
       i3 = i5 + 33 | 0;
       do {
        HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
        i5 = i5 + 1 | 0;
        i4 = i4 + 1 | 0;
       } while ((i5 | 0) < (i3 | 0));
       __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i35, 38120, 37992, 737);
       __ZN2cv6String10deallocateEv(i35);
       i5 = 0;
       break;
      }
     } else i5 = HEAP32[i42 >> 2] | 0; while (0);
     i23 = i38 + 4 | 0;
     if (!((HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24) & 1 | (HEAPU8[i38 >> 0] | HEAPU8[i38 + 1 >> 0] << 8 | HEAPU8[i38 + 2 >> 0] << 16 | HEAPU8[i38 + 3 >> 0] << 24))) {
      HEAP32[i43 + (HEAP32[i40 + 4 >> 2] | 0) >> 2] = i5;
      STACKTOP = i44;
      return;
     }
     i2 = i43 + (i41 >> 1) | 0;
     if (i41 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
     FUNCTION_TABLE_vii[i1 & 127](i2, i5);
     STACKTOP = i44;
     return;
    }
   case 0:
    {
     do if (!i4) {
      if (i3) {
       i5 = HEAPU8[i42 >> 0] | 0;
       break;
      }
      if (i2) {
       i5 = _lrint(+HEAPF64[i42 >> 3]) | 0;
       break;
      }
      if (i7) {
       i5 = _lrint(+Math_fround(HEAPF32[i42 >> 2])) | 0;
       break;
      }
      if (i8) {
       i5 = HEAP32[i42 >> 2] | 0;
       break;
      }
      if (i9) {
       i5 = HEAP32[i42 >> 2] | 0;
       break;
      }
      if (i10) {
       i5 = HEAPU8[i42 >> 0] | 0;
       break;
      } else {
       HEAP32[i31 >> 2] = 0;
       HEAP32[i31 + 4 >> 2] = 0;
       i5 = (__ZN2cv6String8allocateEj(i31, 33) | 0) + 0 | 0;
       i4 = 38160;
       i3 = i5 + 33 | 0;
       do {
        HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
        i5 = i5 + 1 | 0;
        i4 = i4 + 1 | 0;
       } while ((i5 | 0) < (i3 | 0));
       __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i31, 38120, 37992, 651);
       __ZN2cv6String10deallocateEv(i31);
       i5 = 0;
       break;
      }
     } else i5 = HEAP32[i42 >> 2] | 0; while (0);
     i23 = i38 + 4 | 0;
     if (!((HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24) & 1 | (HEAPU8[i38 >> 0] | HEAPU8[i38 + 1 >> 0] << 8 | HEAPU8[i38 + 2 >> 0] << 16 | HEAPU8[i38 + 3 >> 0] << 24))) {
      HEAP32[i43 + (HEAP32[i40 + 4 >> 2] | 0) >> 2] = i5;
      STACKTOP = i44;
      return;
     }
     i2 = i43 + (i41 >> 1) | 0;
     if (i41 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
     FUNCTION_TABLE_vii[i1 & 127](i2, i5);
     STACKTOP = i44;
     return;
    }
   case 11:
    {
     do if (!i4) {
      if (i3) {
       i3 = HEAPU8[i42 >> 0] | 0;
       i39 = 164;
       break;
      }
      if (i2) {
       i2 = _lrint(+HEAPF64[i42 >> 3]) | 0;
       if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
       i3 = i2 & 255;
       i39 = 164;
       break;
      }
      if (i7) {
       i2 = _lrint(+Math_fround(HEAPF32[i42 >> 2])) | 0;
       if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
       i3 = i2 & 255;
       i39 = 164;
       break;
      }
      if (i8) {
       i3 = HEAP32[i42 >> 2] & 255;
       i39 = 164;
       break;
      }
      if (i9) {
       i3 = HEAP32[i42 >> 2] & 255;
       i39 = 164;
       break;
      }
      if (i10) {
       i3 = HEAPU8[i42 >> 0] | 0;
       i39 = 164;
       break;
      } else {
       HEAP32[i29 >> 2] = 0;
       HEAP32[i29 + 4 >> 2] = 0;
       i5 = (__ZN2cv6String8allocateEj(i29, 33) | 0) + 0 | 0;
       i4 = 38160;
       i3 = i5 + 33 | 0;
       do {
        HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
        i5 = i5 + 1 | 0;
        i4 = i4 + 1 | 0;
       } while ((i5 | 0) < (i3 | 0));
       __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i29, 38120, 37992, 779);
       __ZN2cv6String10deallocateEv(i29);
       i5 = 0;
       break;
      }
     } else {
      i3 = HEAP32[i42 >> 2] & 255;
      i39 = 164;
     } while (0);
     if ((i39 | 0) == 164) i5 = i3 & 255;
     i23 = i38 + 4 | 0;
     if (!((HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24) & 1 | (HEAPU8[i38 >> 0] | HEAPU8[i38 + 1 >> 0] << 8 | HEAPU8[i38 + 2 >> 0] << 16 | HEAPU8[i38 + 3 >> 0] << 24))) {
      HEAP8[i43 + (HEAP32[i40 + 4 >> 2] | 0) >> 0] = i5;
      STACKTOP = i44;
      return;
     }
     i2 = i43 + (i41 >> 1) | 0;
     if (i41 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
     FUNCTION_TABLE_vii[i1 & 127](i2, i5);
     STACKTOP = i44;
     return;
    }
   case 2:
    {
     do if (!i4) {
      if (i3) {
       d6 = +((HEAP8[i42 >> 0] | 0) != 0 & 1);
       break;
      }
      if (i2) {
       d6 = +HEAPF64[i42 >> 3];
       break;
      }
      if (i7) {
       d6 = +Math_fround(HEAPF32[i42 >> 2]);
       break;
      }
      if (i8) {
       d6 = +((HEAP32[i42 >> 2] | 0) >>> 0);
       break;
      }
      if (i9) {
       i23 = i42;
       d6 = +((HEAP32[i23 >> 2] | 0) >>> 0) + 4294967296.0 * +((HEAP32[i23 + 4 >> 2] | 0) >>> 0);
       break;
      }
      if (i10) {
       d6 = +(HEAPU8[i42 >> 0] | 0);
       break;
      } else {
       HEAP32[i33 >> 2] = 0;
       HEAP32[i33 + 4 >> 2] = 0;
       i5 = (__ZN2cv6String8allocateEj(i33, 33) | 0) + 0 | 0;
       i4 = 38160;
       i3 = i5 + 33 | 0;
       do {
        HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
        i5 = i5 + 1 | 0;
        i4 = i4 + 1 | 0;
       } while ((i5 | 0) < (i3 | 0));
       __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i33, 38120, 37992, 695);
       __ZN2cv6String10deallocateEv(i33);
       d6 = 0.0;
       break;
      }
     } else d6 = +(HEAP32[i42 >> 2] | 0); while (0);
     i23 = i38 + 4 | 0;
     if (!((HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24) & 1 | (HEAPU8[i38 >> 0] | HEAPU8[i38 + 1 >> 0] << 8 | HEAPU8[i38 + 2 >> 0] << 16 | HEAPU8[i38 + 3 >> 0] << 24))) {
      HEAPF64[i43 + (HEAP32[i40 + 4 >> 2] | 0) >> 3] = d6;
      STACKTOP = i44;
      return;
     }
     i2 = i43 + (i41 >> 1) | 0;
     if (i41 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
     FUNCTION_TABLE_vid[i1 & 1](i2, d6);
     STACKTOP = i44;
     return;
    }
   case 9:
    {
     do if (!i4) {
      if (i3) {
       i5 = HEAPU8[i42 >> 0] | 0;
       i4 = 0;
       break;
      }
      if (i2) {
       d6 = +HEAPF64[i42 >> 3];
       i5 = ~~d6 >>> 0;
       i4 = +Math_abs(d6) >= 1.0 ? (d6 > 0.0 ? (Math_min(+Math_floor(d6 / 4294967296.0), 4294967295.0) | 0) >>> 0 : ~~+Math_ceil((d6 - +(~~d6 >>> 0)) / 4294967296.0) >>> 0) : 0;
       break;
      }
      if (i7) {
       f45 = Math_fround(HEAPF32[i42 >> 2]);
       i5 = ~~+f45 >>> 0;
       i4 = +Math_abs(+f45) >= 1.0 ? (+f45 > 0.0 ? (Math_min(+Math_floor(+f45 / 4294967296.0), 4294967295.0) | 0) >>> 0 : ~~+Math_ceil((+f45 - +(~~+f45 >>> 0)) / 4294967296.0) >>> 0) : 0;
       break;
      }
      if (i8) {
       i5 = HEAP32[i42 >> 2] | 0;
       i4 = 0;
       break;
      }
      if (i9) {
       i4 = i42;
       i5 = HEAP32[i4 >> 2] | 0;
       i4 = HEAP32[i4 + 4 >> 2] | 0;
       break;
      }
      if (i10) {
       i5 = HEAPU8[i42 >> 0] | 0;
       i4 = 0;
       break;
      } else {
       HEAP32[i36 >> 2] = 0;
       HEAP32[i36 + 4 >> 2] = 0;
       i5 = (__ZN2cv6String8allocateEj(i36, 33) | 0) + 0 | 0;
       i4 = 38160;
       i3 = i5 + 33 | 0;
       do {
        HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
        i5 = i5 + 1 | 0;
        i4 = i4 + 1 | 0;
       } while ((i5 | 0) < (i3 | 0));
       __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i36, 38120, 37992, 758);
       __ZN2cv6String10deallocateEv(i36);
       i5 = 0;
       i4 = 0;
       break;
      }
     } else {
      i4 = HEAP32[i42 >> 2] | 0;
      i5 = i4;
      i4 = ((i4 | 0) < 0) << 31 >> 31;
     } while (0);
     i23 = i38 + 4 | 0;
     if (!((HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24) & 1 | (HEAPU8[i38 >> 0] | HEAPU8[i38 + 1 >> 0] << 8 | HEAPU8[i38 + 2 >> 0] << 16 | HEAPU8[i38 + 3 >> 0] << 24))) {
      i23 = i43 + (HEAP32[i40 + 4 >> 2] | 0) | 0;
      HEAP32[i23 >> 2] = i5;
      HEAP32[i23 + 4 >> 2] = i4;
      STACKTOP = i44;
      return;
     }
     i2 = i43 + (i41 >> 1) | 0;
     if (i41 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
     FUNCTION_TABLE_viii[i1 & 63](i2, i5, i4);
     STACKTOP = i44;
     return;
    }
   case 1:
    {
     do if (!i4) {
      if (i3) {
       i5 = HEAPU8[i42 >> 0] | 0;
       break;
      }
      if (i2) {
       i5 = +HEAPF64[i42 >> 3] != 0.0 & 1;
       break;
      }
      if (i7) {
       i5 = Math_fround(HEAPF32[i42 >> 2]) != Math_fround(0.0) & 1;
       break;
      }
      if (i8) {
       i5 = (HEAP32[i42 >> 2] | 0) != 0 & 1;
       break;
      }
      if (i9) {
       i5 = i42;
       i5 = ((HEAP32[i5 >> 2] | 0) != 0 | (HEAP32[i5 + 4 >> 2] | 0) != 0) & 1;
       break;
      }
      if (i10) {
       i5 = (HEAP8[i42 >> 0] | 0) != 0 & 1;
       break;
      } else {
       HEAP32[i32 >> 2] = 0;
       HEAP32[i32 + 4 >> 2] = 0;
       i5 = (__ZN2cv6String8allocateEj(i32, 33) | 0) + 0 | 0;
       i4 = 38160;
       i3 = i5 + 33 | 0;
       do {
        HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
        i5 = i5 + 1 | 0;
        i4 = i4 + 1 | 0;
       } while ((i5 | 0) < (i3 | 0));
       __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i32, 38120, 37992, 673);
       __ZN2cv6String10deallocateEv(i32);
       i5 = 0;
       break;
      }
     } else i5 = (HEAP32[i42 >> 2] | 0) != 0 & 1; while (0);
     i23 = i38 + 4 | 0;
     if (!((HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24) & 1 | (HEAPU8[i38 >> 0] | HEAPU8[i38 + 1 >> 0] << 8 | HEAPU8[i38 + 2 >> 0] << 16 | HEAPU8[i38 + 3 >> 0] << 24))) {
      HEAP8[i43 + (HEAP32[i40 + 4 >> 2] | 0) >> 0] = i5;
      STACKTOP = i44;
      return;
     }
     i2 = i43 + (i41 >> 1) | 0;
     if (i41 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
     FUNCTION_TABLE_vii[i1 & 127](i2, (i5 | 0) != 0);
     STACKTOP = i44;
     return;
    }
   default:
    {
     HEAP32[i30 >> 2] = 0;
     HEAP32[i30 + 4 >> 2] = 0;
     i5 = (__ZN2cv6String8allocateEj(i30, 34) | 0) + 0 | 0;
     i4 = 38200;
     i3 = i5 + 34 | 0;
     do {
      HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
      i5 = i5 + 1 | 0;
      i4 = i4 + 1 | 0;
     } while ((i5 | 0) < (i3 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i30, 38120, 37992, 787);
     __ZN2cv6String10deallocateEv(i30);
     STACKTOP = i44;
     return;
    }
   }
  }
 case 6:
  {
   if ((HEAP32[i40 >> 2] | 0) == 6) {
    i3 = i1;
    i2 = i41;
   } else {
    i23 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i43 >> 2] | 0) + 16 >> 2] & 127](i43) | 0) >> 2] | 0;
    i5 = HEAP32[i23 + 12 >> 2] | 0;
    HEAP32[i17 >> 2] = i5;
    HEAP32[i17 + 4 >> 2] = HEAP32[i23 + 16 >> 2];
    if (i5) {
     i23 = i5 + -4 | 0;
     HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
    }
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    if (!i28) {
     i23 = _strlen(i37 | 0) | 0;
     _memcpy(__ZN2cv6String8allocateEj(i18, i23) | 0, i37 | 0, i23 | 0) | 0;
    }
    __ZN2cvL39getErrorMessageForWrongArgumentInSetterENS_6StringES0_ii(i22, i17, i18, HEAP32[i40 >> 2] | 0, 6);
    __ZN2cv6String10deallocateEv(i18);
    __ZN2cv6String10deallocateEv(i17);
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i22, 38120, 37992, 836);
    __ZN2cv6String10deallocateEv(i22);
    i2 = i38 + 4 | 0;
    i3 = HEAPU8[i38 >> 0] | HEAPU8[i38 + 1 >> 0] << 8 | HEAPU8[i38 + 2 >> 0] << 16 | HEAPU8[i38 + 3 >> 0] << 24;
    i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
   }
   if (i2 & 1 | i3) {
    i2 = i43 + (i41 >> 1) | 0;
    if (i41 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
    FUNCTION_TABLE_vii[i1 & 127](i2, i42);
    STACKTOP = i44;
    return;
   }
   i1 = HEAP32[i40 + 4 >> 2] | 0;
   i4 = i43 + i1 | 0;
   i5 = HEAP32[i42 >> 2] | 0;
   i3 = HEAP32[i42 + 4 >> 2] | 0;
   if (i5) {
    i23 = i5 + 4 | 0;
    HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
   }
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i5;
   HEAP32[i43 + (i1 + 4) >> 2] = i3;
   if (!i2) {
    STACKTOP = i44;
    return;
   }
   i22 = i2 + 4 | 0;
   i23 = HEAP32[i22 >> 2] | 0;
   HEAP32[i22 >> 2] = i23 + -1;
   if ((i23 | 0) != 1) {
    STACKTOP = i44;
    return;
   }
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] & 511](i2);
   STACKTOP = i44;
   return;
  }
 case 5:
  {
   if ((HEAP32[i40 >> 2] | 0) == 5) {
    i3 = i1;
    i2 = i41;
   } else {
    i23 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i43 >> 2] | 0) + 16 >> 2] & 127](i43) | 0) >> 2] | 0;
    i5 = HEAP32[i23 + 12 >> 2] | 0;
    HEAP32[i15 >> 2] = i5;
    HEAP32[i15 + 4 >> 2] = HEAP32[i23 + 16 >> 2];
    if (i5) {
     i23 = i5 + -4 | 0;
     HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
    }
    HEAP32[i16 >> 2] = 0;
    HEAP32[i16 + 4 >> 2] = 0;
    if (!i28) {
     i23 = _strlen(i37 | 0) | 0;
     _memcpy(__ZN2cv6String8allocateEj(i16, i23) | 0, i37 | 0, i23 | 0) | 0;
    }
    __ZN2cvL39getErrorMessageForWrongArgumentInSetterENS_6StringES0_ii(i21, i15, i16, HEAP32[i40 >> 2] | 0, 5);
    __ZN2cv6String10deallocateEv(i16);
    __ZN2cv6String10deallocateEv(i15);
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i21, 38120, 37992, 822);
    __ZN2cv6String10deallocateEv(i21);
    i2 = i38 + 4 | 0;
    i3 = HEAPU8[i38 >> 0] | HEAPU8[i38 + 1 >> 0] << 8 | HEAPU8[i38 + 2 >> 0] << 16 | HEAPU8[i38 + 3 >> 0] << 24;
    i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
   }
   if (!(i2 & 1 | i3)) {
    i1 = i43 + (HEAP32[i40 + 4 >> 2] | 0) | 0;
    if ((i1 | 0) == (i42 | 0)) {
     STACKTOP = i44;
     return;
    }
    __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i1, HEAP32[i42 >> 2] | 0, HEAP32[i42 + 4 >> 2] | 0);
    STACKTOP = i44;
    return;
   }
   i2 = i43 + (i41 >> 1) | 0;
   if (i41 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
   FUNCTION_TABLE_vii[i1 & 127](i2, i42);
   STACKTOP = i44;
   return;
  }
 case 3:
  {
   if ((HEAP32[i40 >> 2] | 0) == 3) {
    i3 = i1;
    i2 = i41;
   } else {
    i23 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i43 >> 2] | 0) + 16 >> 2] & 127](i43) | 0) >> 2] | 0;
    i5 = HEAP32[i23 + 12 >> 2] | 0;
    HEAP32[i11 >> 2] = i5;
    HEAP32[i11 + 4 >> 2] = HEAP32[i23 + 16 >> 2];
    if (i5) {
     i23 = i5 + -4 | 0;
     HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
    }
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    if (!i28) {
     i23 = _strlen(i37 | 0) | 0;
     _memcpy(__ZN2cv6String8allocateEj(i12, i23) | 0, i37 | 0, i23 | 0) | 0;
    }
    __ZN2cvL39getErrorMessageForWrongArgumentInSetterENS_6StringES0_ii(i19, i11, i12, HEAP32[i40 >> 2] | 0, 3);
    __ZN2cv6String10deallocateEv(i12);
    __ZN2cv6String10deallocateEv(i11);
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i19, 38120, 37992, 794);
    __ZN2cv6String10deallocateEv(i19);
    i2 = i38 + 4 | 0;
    i3 = HEAPU8[i38 >> 0] | HEAPU8[i38 + 1 >> 0] << 8 | HEAPU8[i38 + 2 >> 0] << 16 | HEAPU8[i38 + 3 >> 0] << 24;
    i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
   }
   if (i2 & 1 | i3) {
    i2 = i43 + (i41 >> 1) | 0;
    if (i41 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
    FUNCTION_TABLE_vii[i1 & 127](i2, i42);
    STACKTOP = i44;
    return;
   }
   i1 = HEAP32[i40 + 4 >> 2] | 0;
   i3 = i43 + i1 | 0;
   if ((i3 | 0) == (i42 | 0)) {
    STACKTOP = i44;
    return;
   }
   __ZN2cv6String10deallocateEv(i3);
   i2 = HEAP32[i42 >> 2] | 0;
   if (!i2) i2 = 0; else {
    i2 = i2 + -4 | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    i2 = HEAP32[i42 >> 2] | 0;
   }
   HEAP32[i3 >> 2] = i2;
   HEAP32[i43 + (i1 + 4) >> 2] = HEAP32[i42 + 4 >> 2];
   STACKTOP = i44;
   return;
  }
 case 4:
  {
   if ((HEAP32[i40 >> 2] | 0) == 4) {
    i3 = i1;
    i2 = i41;
   } else {
    i23 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i43 >> 2] | 0) + 16 >> 2] & 127](i43) | 0) >> 2] | 0;
    i5 = HEAP32[i23 + 12 >> 2] | 0;
    HEAP32[i13 >> 2] = i5;
    HEAP32[i13 + 4 >> 2] = HEAP32[i23 + 16 >> 2];
    if (i5) {
     i23 = i5 + -4 | 0;
     HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
    }
    HEAP32[i14 >> 2] = 0;
    HEAP32[i14 + 4 >> 2] = 0;
    if (!i28) {
     i23 = _strlen(i37 | 0) | 0;
     _memcpy(__ZN2cv6String8allocateEj(i14, i23) | 0, i37 | 0, i23 | 0) | 0;
    }
    __ZN2cvL39getErrorMessageForWrongArgumentInSetterENS_6StringES0_ii(i20, i13, i14, HEAP32[i40 >> 2] | 0, 4);
    __ZN2cv6String10deallocateEv(i14);
    __ZN2cv6String10deallocateEv(i13);
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i20, 38120, 37992, 808);
    __ZN2cv6String10deallocateEv(i20);
    i2 = i38 + 4 | 0;
    i3 = HEAPU8[i38 >> 0] | HEAPU8[i38 + 1 >> 0] << 8 | HEAPU8[i38 + 2 >> 0] << 16 | HEAPU8[i38 + 3 >> 0] << 24;
    i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
   }
   if (!(i2 & 1 | i3)) {
    __ZN2cv3MataSERKS0_(i43 + (HEAP32[i40 + 4 >> 2] | 0) | 0, i42) | 0;
    STACKTOP = i44;
    return;
   }
   i2 = i43 + (i41 >> 1) | 0;
   if (i41 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
   FUNCTION_TABLE_vii[i1 & 127](i2, i42);
   STACKTOP = i44;
   return;
  }
 default:
  {
   HEAP32[i27 >> 2] = 0;
   HEAP32[i27 + 4 >> 2] = 0;
   i5 = (__ZN2cv6String8allocateEj(i27, 34) | 0) + 0 | 0;
   i4 = 38240;
   i3 = i5 + 34 | 0;
   do {
    HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i5 = i5 + 1 | 0;
    i4 = i4 + 1 | 0;
   } while ((i5 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i27, 38120, 37992, 846);
   __ZN2cv6String10deallocateEv(i27);
   STACKTOP = i44;
   return;
  }
 }
}

function __ZN4perf8TestBase4InitERKNSt3__16vectorINS1_12basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEENS6_IS8_EEEEiPKPKc(i11, i1, i3) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var d2 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 i36 = i41;
 i35 = i41 + 280 | 0;
 i29 = i41 + 268 | 0;
 i30 = i41 + 264 | 0;
 i4 = i41 + 256 | 0;
 i38 = i41 + 240 | 0;
 i14 = i41 + 228 | 0;
 i37 = i41 + 224 | 0;
 i13 = i41 + 216 | 0;
 i12 = i41 + 208 | 0;
 i17 = i41 + 192 | 0;
 i18 = i41 + 184 | 0;
 i19 = i41 + 176 | 0;
 i40 = i41 + 160 | 0;
 i20 = i41 + 152 | 0;
 i21 = i41 + 144 | 0;
 i22 = i41 + 136 | 0;
 i5 = i41 + 128 | 0;
 i6 = i41 + 120 | 0;
 i7 = i41 + 112 | 0;
 i8 = i41 + 104 | 0;
 i15 = i41 + 96 | 0;
 i16 = i41 + 88 | 0;
 i23 = i41 + 80 | 0;
 i24 = i41 + 72 | 0;
 i25 = i41 + 64 | 0;
 i39 = i41 + 48 | 0;
 i28 = i41 + 40 | 0;
 i32 = i41 + 28 | 0;
 i33 = i41 + 16 | 0;
 i34 = i41 + 8 | 0;
 if ((i11 | 0) != 169648) __ZNSt3__16vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6assignIPS6_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(169648, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0);
 i10 = HEAP32[42412] | 0;
 HEAP32[i14 + 0 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i11 = HEAP8[i10 >> 0] | 0;
 if (!(i11 & 1)) i9 = (i11 & 255) >>> 1; else i9 = HEAP32[i10 + 4 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i14, 171792, 635, i9 + 635 | 0);
 if (!(HEAP8[i10 >> 0] & 1)) i11 = i10 + 1 | 0; else i11 = HEAP32[i10 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i14, i11, i9) | 0;
 HEAP32[i38 + 0 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 i11 = HEAP8[i14 >> 0] | 0;
 if (!(i11 & 1)) {
  i11 = (i11 & 255) >>> 1;
  i10 = i14 + 1 | 0;
 } else {
  i11 = HEAP32[i14 + 4 >> 2] | 0;
  i10 = HEAP32[i14 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i38, i10, i11, i11 + 764 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i38, 172432, 764) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i11 = HEAP8[i38 >> 0] | 0;
 i10 = (i11 & 1) == 0;
 if (i10) i9 = (i11 & 255) >>> 1; else i9 = HEAP32[i38 + 4 >> 2] | 0;
 if (i9) {
  if (i10) i11 = (i11 & 255) >>> 1; else i11 = HEAP32[i38 + 4 >> 2] | 0;
  i10 = __ZN2cv6String8allocateEj(i13, i11) | 0;
  if (!(HEAP8[i38 >> 0] & 1)) i9 = i38 + 1 | 0; else i9 = HEAP32[i38 + 8 >> 2] | 0;
  _memcpy(i10 | 0, i9 | 0, i11 | 0) | 0;
 }
 __ZN2cv17CommandLineParserC2EiPKPKcRKNS_6StringE(i37, i1, i3, i13);
 __ZN2cv6String10deallocateEv(i13);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i14 = __ZN2cv6String8allocateEj(i12, 4) | 0;
 HEAP8[i14 >> 0] = 104;
 HEAP8[i14 + 1 >> 0] = 101;
 HEAP8[i14 + 2 >> 0] = 108;
 HEAP8[i14 + 3 >> 0] = 112;
 i14 = __ZNK2cv17CommandLineParser3hasERKNS_6StringE(i37, i12) | 0;
 __ZN2cv6String10deallocateEv(i12);
 if (i14) {
  __ZNK2cv17CommandLineParser12printMessageEv(i37);
  __ZN2cv17CommandLineParserD2Ev(i37);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i38);
  STACKTOP = i41;
  return;
 }
 i11 = __Znwj(4) | 0;
 HEAP32[i11 >> 2] = 177840;
 __ZN7testing8UnitTest14AddEnvironmentEPNS_11EnvironmentE(__ZN7testing8UnitTest11GetInstanceEv() | 0, i11) | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i18, 12) | 0) + 0 | 0;
 i10 = 173200;
 i9 = i11 + 12 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 if (__ZNK2cv17CommandLineParser3hasERKNS_6StringE(i37, i18) | 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, 171784, 5);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(169664, i17) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
 } else {
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  i11 = (__ZN2cv6String8allocateEj(i19, 9) | 0) + 0 | 0;
  i10 = 173216;
  i9 = i11 + 9 | 0;
  do {
   HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
   i11 = i11 + 1 | 0;
   i10 = i10 + 1 | 0;
  } while ((i11 | 0) < (i9 | 0));
  HEAP32[i4 >> 2] = 0;
  i14 = i4 + 4 | 0;
  HEAP32[i14 >> 2] = 0;
  __ZNK2cv17CommandLineParser9getByNameERKNS_6StringEbiPv(i37, i19, 1, 3, i4);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, HEAP32[i4 >> 2] | 0, HEAP32[i14 >> 2] | 0);
  __ZN2cv6String10deallocateEv(i4);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(169664, i17) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
  __ZN2cv6String10deallocateEv(i19);
 }
 __ZN2cv6String10deallocateEv(i18);
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i20, 13) | 0) + 0 | 0;
 i10 = 173232;
 i9 = i11 + 13 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 HEAP32[i36 >> 2] = 0;
 i19 = i36 + 4 | 0;
 HEAP32[i19 >> 2] = 0;
 __ZNK2cv17CommandLineParser9getByNameERKNS_6StringEbiPv(i37, i20, 1, 3, i36);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i40, HEAP32[i36 >> 2] | 0, HEAP32[i19 >> 2] | 0);
 __ZN2cv6String10deallocateEv(i36);
 __ZN2cv6String10deallocateEv(i20);
 do if (__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i40, 173248) | 0) {
  if (!(__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i40, 173256) | 0)) {
   HEAP32[43316] = 0;
   break;
  }
  if (!(__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i40, 173272) | 0)) {
   HEAP32[43316] = 1;
   break;
  }
  if (!(HEAP8[i40 >> 0] & 1)) {
   i20 = i40 + 1 | 0;
   HEAP32[i36 >> 2] = i20;
   _printf(173280, i36 | 0) | 0;
   _exit(1);
  } else {
   i20 = HEAP32[i40 + 8 >> 2] | 0;
   HEAP32[i36 >> 2] = i20;
   _printf(173280, i36 | 0) | 0;
   _exit(1);
  }
 } while (0);
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i21, 17) | 0) + 0 | 0;
 i10 = 173304;
 i9 = i11 + 17 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 HEAPF64[i36 >> 3] = 0.0;
 __ZNK2cv17CommandLineParser9getByNameERKNS_6StringEbiPv(i37, i21, 1, 2, i36);
 d2 = +HEAPF64[i36 >> 3];
 d2 = d2 > 0.0 ? d2 : 0.0;
 HEAPF64[21666] = d2 < 100.0 ? d2 : 100.0;
 __ZN2cv6String10deallocateEv(i21);
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i22, 16) | 0) + 0 | 0;
 i10 = 173336;
 i9 = i11 + 16 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 HEAP32[i36 >> 2] = 0;
 __ZNK2cv17CommandLineParser9getByNameERKNS_6StringEbiPv(i37, i22, 1, 8, i36);
 i11 = HEAP32[i36 >> 2] | 0;
 HEAP32[43340] = i11 >>> 0 > 1 ? i11 : 1;
 __ZN2cv6String10deallocateEv(i22);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i5, 18) | 0) + 0 | 0;
 i10 = 173368;
 i9 = i11 + 18 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 HEAPF64[i36 >> 3] = 0.0;
 __ZNK2cv17CommandLineParser9getByNameERKNS_6StringEbiPv(i37, i5, 1, 2, i36);
 d2 = +HEAPF64[i36 >> 3];
 HEAPF64[21674] = d2 > 0.0 ? d2 : 0.0;
 __ZN2cv6String10deallocateEv(i5);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i6, 9) | 0) + 0 | 0;
 i10 = 173400;
 i9 = i11 + 9 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 HEAP32[i36 >> 2] = 0;
 __ZNK2cv17CommandLineParser9getByNameERKNS_6StringEbiPv(i37, i6, 1, 8, i36);
 i11 = 173416;
 HEAP32[i11 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i11 + 4 >> 2] = 0;
 __ZN2cv6String10deallocateEv(i6);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i7, 15) | 0) + 0 | 0;
 i10 = 173424;
 i9 = i11 + 15 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 HEAPF64[i36 >> 3] = 0.0;
 __ZNK2cv17CommandLineParser9getByNameERKNS_6StringEbiPv(i37, i7, 1, 2, i36);
 d2 = +HEAPF64[i36 >> 3];
 HEAPF64[21680] = d2 > 0.0 ? d2 : 0.0;
 __ZN2cv6String10deallocateEv(i7);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i8, 18) | 0) + 0 | 0;
 i10 = 173448;
 i9 = i11 + 18 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 HEAP32[i36 >> 2] = 0;
 __ZNK2cv17CommandLineParser9getByNameERKNS_6StringEbiPv(i37, i8, 1, 8, i36);
 HEAP32[43368] = HEAP32[i36 >> 2];
 __ZN2cv6String10deallocateEv(i8);
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i15, 17) | 0) + 0 | 0;
 i10 = 173480;
 i9 = i11 + 17 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 HEAP8[171672] = (__ZNK2cv17CommandLineParser3hasERKNS_6StringE(i37, i15) | 0) & 1;
 __ZN2cv6String10deallocateEv(i15);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i16, 18) | 0) + 0 | 0;
 i10 = 173504;
 i9 = i11 + 18 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 HEAP8[171680] = (__ZNK2cv17CommandLineParser3hasERKNS_6StringE(i37, i16) | 0) & 1;
 __ZN2cv6String10deallocateEv(i16);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i23, 14) | 0) + 0 | 0;
 i10 = 173528;
 i9 = i11 + 14 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 if (__ZNK2cv17CommandLineParser3hasERKNS_6StringE(i37, i23) | 0) i5 = 1; else i5 = (_getenv(173544) | 0) != 0 & 1;
 HEAP8[159104] = i5;
 __ZN2cv6String10deallocateEv(i23);
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i24, 12) | 0) + 0 | 0;
 i10 = 173568;
 i9 = i11 + 12 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 HEAP32[i36 >> 2] = 0;
 __ZNK2cv17CommandLineParser9getByNameERKNS_6StringEbiPv(i37, i24, 1, 0, i36);
 HEAP32[43396] = HEAP32[i36 >> 2];
 __ZN2cv6String10deallocateEv(i24);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i25, 15) | 0) + 0 | 0;
 i10 = 173592;
 i9 = i11 + 15 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 i23 = __ZNK2cv17CommandLineParser3hasERKNS_6StringE(i37, i25) | 0;
 __ZN2cv6String10deallocateEv(i25);
 if (i23) {
  i5 = HEAP32[_stdout >> 2] | 0;
  _fwrite(173608, 34, 1, i5 | 0) | 0;
  if ((HEAP32[42413] | 0) == (HEAP32[42412] | 0)) {
   _putchar(10) | 0;
   _exit(0);
  } else i26 = 0;
  do {
   _putchar(32) | 0;
   i3 = HEAP32[42412] | 0;
   i1 = i3 + (i26 * 12 | 0) | 0;
   if (!(HEAP8[i1 >> 0] & 1)) i3 = i1 + 1 | 0; else i3 = HEAP32[i3 + (i26 * 12 | 0) + 8 >> 2] | 0;
   _fputs(i3 | 0, i5 | 0) | 0;
   i26 = i26 + 1 | 0;
  } while (i26 >>> 0 < (((HEAP32[42413] | 0) - (HEAP32[42412] | 0) | 0) / 12 | 0) >>> 0);
  _putchar(10) | 0;
  _exit(0);
 }
 i6 = HEAP32[42412] | 0;
 i1 = HEAP32[42413] | 0;
 L68 : do if ((i6 | 0) == (i1 | 0)) i27 = i6; else {
  i8 = HEAP8[169664] | 0;
  i7 = (i8 & 1) == 0;
  i8 = (i8 & 255) >>> 1;
  i9 = i7 ? 169665 : HEAP32[42418] | 0;
  i10 = HEAP32[42417] | 0;
  i11 = i6;
  do {
   i5 = HEAP8[i11 >> 0] | 0;
   i4 = (i5 & 1) == 0;
   if (i4) i5 = (i5 & 255) >>> 1; else i5 = HEAP32[i11 + 4 >> 2] | 0;
   L76 : do if ((i5 | 0) == ((i7 ? i8 : i10) | 0)) {
    if (!i4) if (!(_memcmp(HEAP32[i11 + 8 >> 2] | 0, i9, i5) | 0)) {
     i27 = i11;
     break L68;
    } else break;
    if (!i5) {
     i27 = i11;
     break L68;
    } else {
     i4 = i11 + 1 | 0;
     i3 = i9;
    }
    while (1) {
     if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) break L76;
     i5 = i5 + -1 | 0;
     if (!i5) {
      i27 = i11;
      break L68;
     } else {
      i4 = i4 + 1 | 0;
      i3 = i3 + 1 | 0;
     }
    }
   } while (0);
   i11 = i11 + 12 | 0;
  } while ((i11 | 0) != (i1 | 0));
  i22 = HEAP8[169664] | 0;
  i22 = i22 & 1;
  i22 = i22 << 24 >> 24 == 0;
  i23 = HEAP32[42418] | 0;
  i23 = i22 ? 169665 : i23;
  HEAP32[i36 >> 2] = i23;
  _printf(173648, i36 | 0) | 0;
  _exit(1);
 } while (0);
 if ((i27 | 0) == (i1 | 0)) {
  i22 = HEAP8[169664] | 0;
  i22 = i22 & 1;
  i22 = i22 << 24 >> 24 == 0;
  i23 = HEAP32[42418] | 0;
  i23 = i22 ? 169665 : i23;
  HEAP32[i36 >> 2] = i23;
  _printf(173648, i36 | 0) | 0;
  _exit(1);
 }
 if (((i1 - i6 | 0) / 12 | 0) >>> 0 > 1) {
  HEAP32[i36 >> 2] = (HEAP8[169664] & 1) == 0 ? 169665 : HEAP32[42418] | 0;
  _printf(173680, i36 | 0) | 0;
  _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 }
 i3 = _getenv(173752) | 0;
 if (i3) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(171736, i3) | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i28, 28) | 0) + 0 | 0;
 i10 = 173784;
 i9 = i11 + 28 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 HEAP32[i36 >> 2] = 0;
 i1 = i36 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZNK2cv17CommandLineParser9getByNameERKNS_6StringEbiPv(i37, i28, 1, 3, i36);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i39, HEAP32[i36 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 __ZN2cv6String10deallocateEv(i36);
 __ZN2cv6String10deallocateEv(i28);
 i1 = HEAP8[i39 >> 0] | 0;
 i4 = (i1 & 1) == 0;
 if (i4) i3 = (i1 & 255) >>> 1; else i3 = HEAP32[i39 + 4 >> 2] | 0;
 if (i3) {
  HEAP8[173816] = 1;
  HEAP32[i32 + 0 >> 2] = 0;
  HEAP32[i32 + 4 >> 2] = 0;
  HEAP32[i32 + 8 >> 2] = 0;
  i3 = HEAP8[171736] | 0;
  i5 = (i3 & 1) == 0;
  if (i5) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[42935] | 0;
  if (i4) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i39 + 4 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i32, i5 ? 171737 : HEAP32[42936] | 0, i3, i1 + i3 | 0);
  if (!(HEAP8[i39 >> 0] & 1)) i3 = i39 + 1 | 0; else i3 = HEAP32[i39 + 8 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i32, i3, i1) | 0;
  __ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(171752, HEAP32[42939] | 0);
  HEAP32[42940] = 0;
  HEAP32[42938] = 171756;
  HEAP32[42939] = 0;
  if (!(HEAP8[i32 >> 0] & 1)) i1 = i32 + 1 | 0; else i1 = HEAP32[i32 + 8 >> 2] | 0;
  i12 = i35 + 108 | 0;
  i13 = i35 + 8 | 0;
  HEAP32[i35 >> 2] = 177740;
  i14 = i35 + 108 | 0;
  HEAP32[i14 >> 2] = 177760;
  HEAP32[i35 + 4 >> 2] = 0;
  __ZNSt3__18ios_base4initEPv(i35 + 108 | 0, i13);
  HEAP32[i35 + 180 >> 2] = 0;
  HEAP32[i35 + 184 >> 2] = -1;
  HEAP32[i35 >> 2] = 177684;
  HEAP32[i12 >> 2] = 177704;
  __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEEC2Ev(i13);
  i3 = i35 + 72 | 0;
  do if (!(HEAP32[i3 >> 2] | 0)) {
   i23 = _fopen(i1 | 0, 176312) | 0;
   HEAP32[i3 >> 2] = i23;
   if (!i23) {
    i31 = 84;
    break;
   }
   HEAP32[i35 + 96 >> 2] = 8;
  } else i31 = 84; while (0);
  if ((i31 | 0) == 84) {
   i23 = HEAP32[(HEAP32[i35 >> 2] | 0) + -12 >> 2] | 0;
   __ZNSt3__18ios_base5clearEj(i35 + i23 | 0, HEAP32[i35 + (i23 + 16) >> 2] | 4);
  }
  i11 = i29 + 1 | 0;
  i10 = i29 + 4 | 0;
  i9 = i29 + 8 | 0;
  i1 = i32 + 1 | 0;
  i8 = i32 + 8 | 0;
  i7 = i32 + 4 | 0;
  while (1) {
   if (HEAP32[i35 + ((HEAP32[(HEAP32[i35 >> 2] | 0) + -12 >> 2] | 0) + 16) >> 2] & 2) {
    i31 = 111;
    break;
   };
   HEAP32[i29 + 0 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   HEAP32[i29 + 8 >> 2] = 0;
   HEAPF32[i30 >> 2] = Math_fround(0.0);
   i23 = __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEErsERf(i35, i30) | 0;
   do if (!(HEAP32[i23 + ((HEAP32[(HEAP32[i23 >> 2] | 0) + -12 >> 2] | 0) + 16) >> 2] & 5)) {
    __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6ignoreEii(i35, 1, -1) | 0;
    __ZNKSt3__18ios_base6getlocEv(i36, i35 + (HEAP32[(HEAP32[i35 >> 2] | 0) + -12 >> 2] | 0) | 0);
    i23 = __ZNKSt3__16locale9use_facetERNS0_2idE(i36, 960728) | 0;
    i23 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i23 >> 2] | 0) + 28 >> 2] & 127](i23, 10) | 0;
    __ZNSt3__16localeD2Ev(i36);
    i23 = __ZNSt3__17getlineIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_13basic_istreamIT_T0_EES9_RNS_12basic_stringIS6_S7_T1_EES6_(i35, i29, i23) | 0;
    if (HEAP32[i23 + ((HEAP32[(HEAP32[i23 >> 2] | 0) + -12 >> 2] | 0) + 16) >> 2] & 5) {
     i4 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 177552, 54) | 0;
     i5 = HEAP8[i32 >> 0] | 0;
     if (!(i5 & 1)) {
      i3 = i1;
      i5 = (i5 & 255) >>> 1;
     } else {
      i3 = HEAP32[i8 >> 2] | 0;
      i5 = HEAP32[i7 >> 2] | 0;
     }
     i5 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, i3, i5) | 0, 177608, 1) | 0;
     __ZNKSt3__18ios_base6getlocEv(i36, i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) | 0);
     i23 = __ZNKSt3__16locale9use_facetERNS0_2idE(i36, 960728) | 0;
     i23 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i23 >> 2] | 0) + 28 >> 2] & 127](i23, 10) | 0;
     __ZNSt3__16localeD2Ev(i36);
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i5, i23) | 0;
     __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i5) | 0;
     i5 = 1;
     break;
    }
    i3 = HEAP8[i29 >> 0] | 0;
    i6 = (i3 & 1) == 0;
    if (i6) i5 = (i3 & 255) >>> 1; else i5 = HEAP32[i10 >> 2] | 0;
    do if (i5) {
     if (i6) {
      i5 = (i3 & 255) >>> 1;
      i4 = i11;
     } else {
      i5 = HEAP32[i10 >> 2] | 0;
      i4 = HEAP32[i9 >> 2] | 0;
     }
     if ((HEAP8[i4 + (i5 + -1) >> 0] | 0) != 13) break;
     if (i6) i5 = (i3 & 255) >>> 1; else i5 = HEAP32[i10 >> 2] | 0;
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i29, i5 + -1 | 0, 0);
    } while (0);
    f42 = Math_fround(HEAPF32[i30 >> 2]);
    HEAPF32[(__ZNSt3__13mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfNS_4lessIS6_EENS4_INS_4pairIKS6_fEEEEEixERSA_(171752, i29) | 0) >> 2] = f42;
    i5 = 0;
   } else {
    if (HEAP32[i35 + ((HEAP32[(HEAP32[i35 >> 2] | 0) + -12 >> 2] | 0) + 16) >> 2] & 2) {
     i5 = 3;
     break;
    }
    i4 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 177552, 54) | 0;
    i5 = HEAP8[i32 >> 0] | 0;
    if (!(i5 & 1)) {
     i3 = i1;
     i5 = (i5 & 255) >>> 1;
    } else {
     i3 = HEAP32[i8 >> 2] | 0;
     i5 = HEAP32[i7 >> 2] | 0;
    }
    i5 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, i3, i5) | 0, 177608, 1) | 0;
    __ZNKSt3__18ios_base6getlocEv(i36, i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) | 0);
    i23 = __ZNKSt3__16locale9use_facetERNS0_2idE(i36, 960728) | 0;
    i23 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i23 >> 2] | 0) + 28 >> 2] & 127](i23, 10) | 0;
    __ZNSt3__16localeD2Ev(i36);
    __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i5, i23) | 0;
    __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i5) | 0;
    i5 = 1;
   } while (0);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i29);
   if ((i5 | 0) == 3) {
    i31 = 111;
    break;
   } else if (i5) break;
  }
  if ((i31 | 0) == 111) {
   i4 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 177616, 43) | 0;
   i5 = HEAP8[i32 >> 0] | 0;
   if (!(i5 & 1)) i3 = (i5 & 255) >>> 1; else {
    i1 = HEAP32[i8 >> 2] | 0;
    i3 = HEAP32[i7 >> 2] | 0;
   }
   i23 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, i1, i3) | 0, 177664, 2) | 0;
   i23 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEj(i23, HEAP32[42940] | 0) | 0, 177240, 9) | 0;
   __ZNKSt3__18ios_base6getlocEv(i36, i23 + (HEAP32[(HEAP32[i23 >> 2] | 0) + -12 >> 2] | 0) | 0);
   i22 = __ZNKSt3__16locale9use_facetERNS0_2idE(i36, 960728) | 0;
   i22 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] & 127](i22, 10) | 0;
   __ZNSt3__16localeD2Ev(i36);
   __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i23, i22) | 0;
   __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i23) | 0;
  }
  HEAP32[i35 >> 2] = 177684;
  HEAP32[i14 >> 2] = 177704;
  __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev(i13);
  __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i12);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i32);
 }
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 i11 = (__ZN2cv6String8allocateEj(i34, 29) | 0) + 0 | 0;
 i10 = 173824;
 i9 = i11 + 29 | 0;
 do {
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i11 = i11 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i11 | 0) < (i9 | 0));
 HEAP32[i36 >> 2] = 0;
 i1 = i36 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZNK2cv17CommandLineParser9getByNameERKNS_6StringEbiPv(i37, i34, 1, 3, i36);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i33, HEAP32[i36 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 __ZN2cv6String10deallocateEv(i36);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(171768, i33) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i33);
 __ZN2cv6String10deallocateEv(i34);
 i1 = HEAP8[171768] | 0;
 if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[42943] | 0;
 if (i1) {
  HEAP8[173816] = 1;
  i23 = __Znwj(4) | 0;
  HEAP32[i23 >> 2] = 177096;
  __ZN7testing8UnitTest14AddEnvironmentEPNS_11EnvironmentE(__ZN7testing8UnitTest11GetInstanceEv() | 0, i23) | 0;
 }
 if (__ZNK2cv17CommandLineParser5checkEv(i37) | 0) {
  d2 = +HEAPF64[21680];
  if (d2 == 0.0) {
   i1 = 1;
   i3 = 0;
  } else {
   d2 = d2 * +__ZN2cv16getTickFrequencyEv();
   i1 = ~~d2 >>> 0;
   i3 = +Math_abs(d2) >= 1.0 ? (d2 > 0.0 ? (Math_min(+Math_floor(d2 / 4294967296.0), 4294967295.0) | 0) >>> 0 : ~~+Math_ceil((d2 - +(~~d2 >>> 0)) / 4294967296.0) >>> 0) : 0;
  }
  i22 = 169624;
  HEAP32[i22 >> 2] = i1;
  HEAP32[i22 + 4 >> 2] = i3;
  i22 = HEAP32[43368] | 0;
  HEAP32[42408] = (i22 | 0) == 0 ? -1 : i22;
  i22 = __ZN4perf8TestBase10_calibrateEv() | 0;
  i23 = 169640;
  HEAP32[i23 >> 2] = i22;
  HEAP32[i23 + 4 >> 2] = tempRet0;
 } else __ZNK2cv17CommandLineParser11printErrorsEv(i37);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i39);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i40);
 __ZN2cv17CommandLineParserD2Ev(i37);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i38);
 STACKTOP = i41;
 return;
}

function __ZNSt3__16__sortIRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEvT0_S9_T_(i9, i8, i57) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i57 = i57 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0;
 i70 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i69 = i70;
 i17 = i69 + 4 | 0;
 i18 = i69 + 8 | 0;
 i29 = i69 + 12 | 0;
 i40 = i69 + 16 | 0;
 i51 = i69 + 28 | 0;
 i52 = i69 + 16 | 0;
 i53 = i69 + 20 | 0;
 i54 = i69 + 8 | 0;
 i55 = i69 + 4 | 0;
 i56 = i69 + 8 | 0;
 i19 = i69 + 12 | 0;
 i20 = i69 + 16 | 0;
 i21 = i69 + 28 | 0;
 i22 = i69 + 16 | 0;
 i23 = i69 + 20 | 0;
 i24 = i69 + 8 | 0;
 i25 = i69 + 4 | 0;
 i26 = i69 + 8 | 0;
 i27 = i69 + 12 | 0;
 i28 = i69 + 16 | 0;
 i30 = i69 + 28 | 0;
 i31 = i69 + 16 | 0;
 i32 = i69 + 20 | 0;
 i33 = i69 + 8 | 0;
 i34 = i69 + 4 | 0;
 i35 = i69 + 8 | 0;
 i36 = i69 + 12 | 0;
 i37 = i69 + 16 | 0;
 i38 = i69 + 28 | 0;
 i39 = i69 + 16 | 0;
 i41 = i69 + 20 | 0;
 i42 = i69 + 8 | 0;
 i43 = i69 + 4 | 0;
 i44 = i69 + 8 | 0;
 i45 = i69 + 12 | 0;
 i46 = i69 + 16 | 0;
 i47 = i69 + 28 | 0;
 i48 = i69 + 16 | 0;
 i49 = i69 + 20 | 0;
 i50 = i69 + 8 | 0;
 L1 : while (1) {
  i15 = i8;
  i63 = i8 + -32 | 0;
  i68 = i8 + -4 | 0;
  i16 = (i69 | 0) == (i63 | 0);
  i64 = i8 + -28 | 0;
  i65 = i8 + -24 | 0;
  i66 = i8 + -20 | 0;
  i67 = i8 + -16 | 0;
  i60 = i8 + -24 | 0;
  i61 = i8 + -16 | 0;
  i62 = i8 + -12 | 0;
  i59 = i9;
  L3 : while (1) {
   i14 = i59;
   i7 = i15 - i14 | 0;
   i6 = i7 >> 5;
   switch (i6 | 0) {
   case 4:
    {
     i58 = 29;
     break L1;
    }
   case 3:
    {
     i58 = 28;
     break L1;
    }
   case 1:
   case 0:
    {
     i58 = 161;
     break L1;
    }
   case 5:
    {
     i58 = 30;
     break L1;
    }
   case 2:
    {
     i58 = 4;
     break L1;
    }
   default:
    {}
   }
   if ((i7 | 0) < 224) {
    i58 = 32;
    break L1;
   }
   i9 = (i6 | 0) / 2 | 0;
   i13 = i59 + (i9 << 5) | 0;
   if ((i7 | 0) > 31968) {
    i10 = (i6 | 0) / 4 | 0;
    i9 = __ZNSt3__17__sort5IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_S9_S9_T_(i59, i59 + (i10 << 5) | 0, i13, i59 + (i10 + i9 << 5) | 0, i63, i57) | 0;
   } else i9 = __ZNSt3__17__sort3IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_T_(i59, i13, i63, i57) | 0;
   do if (FUNCTION_TABLE_iii[HEAP32[i57 >> 2] & 127](i59, i13) | 0) i6 = i63; else {
    i10 = i63;
    while (1) {
     i1 = i10 + -32 | 0;
     if ((i59 | 0) == (i1 | 0)) break;
     if (FUNCTION_TABLE_iii[HEAP32[i57 >> 2] & 127](i1, i13) | 0) {
      i58 = 88;
      break;
     } else i10 = i1;
    }
    if ((i58 | 0) == 88) {
     i58 = 0;
     i7 = HEAP32[i59 >> 2] | 0;
     HEAP32[i69 >> 2] = i7;
     i6 = i59 + 4 | 0;
     HEAP32[i43 >> 2] = HEAP32[i6 >> 2];
     if (i7) {
      i7 = i7 + -4 | 0;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     }
     i7 = HEAP32[i59 + 8 >> 2] | 0;
     HEAP32[i44 >> 2] = i7;
     i3 = i59 + 12 | 0;
     HEAP32[i45 >> 2] = HEAP32[i3 >> 2];
     if (i7) {
      i7 = i7 + -4 | 0;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     }
     i4 = i59 + 16 | 0;
     __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i46, i4);
     i2 = i59 + 28 | 0;
     HEAP32[i47 >> 2] = HEAP32[i2 >> 2];
     __ZN2cv6String10deallocateEv(i59);
     i7 = HEAP32[i1 >> 2] | 0;
     if (!i7) i7 = 0; else {
      i7 = i7 + -4 | 0;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
      i7 = HEAP32[i1 >> 2] | 0;
     }
     HEAP32[i59 >> 2] = i7;
     HEAP32[i6 >> 2] = HEAP32[i10 + -28 >> 2];
     i5 = i59 + 8 | 0;
     __ZN2cv6String10deallocateEv(i5);
     i7 = i10 + -24 | 0;
     i6 = HEAP32[i7 >> 2] | 0;
     if (!i6) i7 = 0; else {
      i6 = i6 + -4 | 0;
      HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
      i7 = HEAP32[i7 >> 2] | 0;
     }
     HEAP32[i5 >> 2] = i7;
     HEAP32[i3 >> 2] = HEAP32[i10 + -20 >> 2];
     __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i4, HEAP32[i10 + -16 >> 2] | 0, HEAP32[i10 + -12 >> 2] | 0);
     i5 = i10 + -4 | 0;
     HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
     if ((i69 | 0) != (i1 | 0)) {
      __ZN2cv6String10deallocateEv(i1);
      i7 = HEAP32[i69 >> 2] | 0;
      if (!i7) i7 = 0; else {
       i7 = i7 + -4 | 0;
       HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
       i7 = HEAP32[i69 >> 2] | 0;
      }
      HEAP32[i1 >> 2] = i7;
      HEAP32[i10 + -28 >> 2] = HEAP32[i43 >> 2];
      i6 = i10 + -24 | 0;
      __ZN2cv6String10deallocateEv(i6);
      i7 = HEAP32[i50 >> 2] | 0;
      if (!i7) i7 = 0; else {
       i7 = i7 + -4 | 0;
       HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
       i7 = HEAP32[i50 >> 2] | 0;
      }
      HEAP32[i6 >> 2] = i7;
      HEAP32[i10 + -20 >> 2] = HEAP32[i45 >> 2];
      __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10 + -16 | 0, HEAP32[i48 >> 2] | 0, HEAP32[i49 >> 2] | 0);
     }
     HEAP32[i5 >> 2] = HEAP32[i47 >> 2];
     i7 = HEAP32[i48 >> 2] | 0;
     if (i7) {
      while (1) {
       i6 = HEAP32[i49 >> 2] | 0;
       if ((i6 | 0) == (i7 | 0)) break;
       i10 = i6 + -8 | 0;
       HEAP32[i49 >> 2] = i10;
       __ZN2cv6String10deallocateEv(i10);
      }
      __ZdlPv(HEAP32[i48 >> 2] | 0);
     }
     __ZN2cv6String10deallocateEv(i44);
     __ZN2cv6String10deallocateEv(i69);
     i6 = i1;
     i9 = i9 + 1 | 0;
     break;
    }
    i9 = i59 + 32 | 0;
    if (!(FUNCTION_TABLE_iii[HEAP32[i57 >> 2] & 127](i59, i63) | 0)) {
     if ((i9 | 0) == (i63 | 0)) {
      i58 = 161;
      break L1;
     }
     while (1) {
      i10 = i9 + 32 | 0;
      if (FUNCTION_TABLE_iii[HEAP32[i57 >> 2] & 127](i59, i9) | 0) break;
      if ((i10 | 0) == (i63 | 0)) {
       i58 = 161;
       break L1;
      } else i9 = i10;
     }
     i7 = HEAP32[i9 >> 2] | 0;
     HEAP32[i69 >> 2] = i7;
     i6 = i9 + 4 | 0;
     HEAP32[i34 >> 2] = HEAP32[i6 >> 2];
     if (i7) {
      i7 = i7 + -4 | 0;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     }
     i7 = HEAP32[i9 + 8 >> 2] | 0;
     HEAP32[i35 >> 2] = i7;
     i3 = i9 + 12 | 0;
     HEAP32[i36 >> 2] = HEAP32[i3 >> 2];
     if (i7) {
      i7 = i7 + -4 | 0;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     }
     i5 = i9 + 16 | 0;
     __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i37, i5);
     i4 = i9 + 28 | 0;
     HEAP32[i38 >> 2] = HEAP32[i4 >> 2];
     __ZN2cv6String10deallocateEv(i9);
     i7 = HEAP32[i63 >> 2] | 0;
     if (!i7) i7 = 0; else {
      i7 = i7 + -4 | 0;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
      i7 = HEAP32[i63 >> 2] | 0;
     }
     HEAP32[i9 >> 2] = i7;
     HEAP32[i6 >> 2] = HEAP32[i64 >> 2];
     i7 = i9 + 8 | 0;
     __ZN2cv6String10deallocateEv(i7);
     i9 = HEAP32[i60 >> 2] | 0;
     if (!i9) i9 = 0; else {
      i9 = i9 + -4 | 0;
      HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
      i9 = HEAP32[i60 >> 2] | 0;
     }
     HEAP32[i7 >> 2] = i9;
     HEAP32[i3 >> 2] = HEAP32[i66 >> 2];
     __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i5, HEAP32[i61 >> 2] | 0, HEAP32[i62 >> 2] | 0);
     HEAP32[i4 >> 2] = HEAP32[i68 >> 2];
     if (!i16) {
      __ZN2cv6String10deallocateEv(i63);
      i9 = HEAP32[i69 >> 2] | 0;
      if (!i9) i9 = 0; else {
       i9 = i9 + -4 | 0;
       HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
       i9 = HEAP32[i69 >> 2] | 0;
      }
      HEAP32[i63 >> 2] = i9;
      HEAP32[i64 >> 2] = HEAP32[i34 >> 2];
      __ZN2cv6String10deallocateEv(i65);
      i9 = HEAP32[i42 >> 2] | 0;
      if (!i9) i9 = 0; else {
       i9 = i9 + -4 | 0;
       HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
       i9 = HEAP32[i42 >> 2] | 0;
      }
      HEAP32[i65 >> 2] = i9;
      HEAP32[i66 >> 2] = HEAP32[i36 >> 2];
      __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i67, HEAP32[i39 >> 2] | 0, HEAP32[i41 >> 2] | 0);
     }
     HEAP32[i68 >> 2] = HEAP32[i38 >> 2];
     i9 = HEAP32[i39 >> 2] | 0;
     if (i9) {
      while (1) {
       i7 = HEAP32[i41 >> 2] | 0;
       if ((i7 | 0) == (i9 | 0)) break;
       i7 = i7 + -8 | 0;
       HEAP32[i41 >> 2] = i7;
       __ZN2cv6String10deallocateEv(i7);
      }
      __ZdlPv(HEAP32[i39 >> 2] | 0);
     }
     __ZN2cv6String10deallocateEv(i35);
     __ZN2cv6String10deallocateEv(i69);
     i9 = i10;
    }
    if ((i9 | 0) == (i63 | 0)) {
     i58 = 161;
     break L1;
    } else i7 = i63;
    while (1) {
     i4 = i9;
     while (1) {
      i9 = i4 + 32 | 0;
      if (FUNCTION_TABLE_iii[HEAP32[i57 >> 2] & 127](i59, i4) | 0) break; else i4 = i9;
     }
     while (1) {
      i10 = i7 + -32 | 0;
      if (FUNCTION_TABLE_iii[HEAP32[i57 >> 2] & 127](i59, i10) | 0) i7 = i10; else break;
     }
     if (i4 >>> 0 >= i10 >>> 0) {
      i59 = i4;
      continue L3;
     }
     i6 = HEAP32[i4 >> 2] | 0;
     HEAP32[i69 >> 2] = i6;
     i5 = i4 + 4 | 0;
     HEAP32[i25 >> 2] = HEAP32[i5 >> 2];
     if (i6) {
      i6 = i6 + -4 | 0;
      HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
     }
     i6 = HEAP32[i4 + 8 >> 2] | 0;
     HEAP32[i26 >> 2] = i6;
     i2 = i4 + 12 | 0;
     HEAP32[i27 >> 2] = HEAP32[i2 >> 2];
     if (i6) {
      i6 = i6 + -4 | 0;
      HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
     }
     i3 = i4 + 16 | 0;
     __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i28, i3);
     i1 = i4 + 28 | 0;
     HEAP32[i30 >> 2] = HEAP32[i1 >> 2];
     if ((i10 | 0) != (i4 | 0)) {
      __ZN2cv6String10deallocateEv(i4);
      i6 = HEAP32[i10 >> 2] | 0;
      if (!i6) i6 = 0; else {
       i6 = i6 + -4 | 0;
       HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
       i6 = HEAP32[i10 >> 2] | 0;
      }
      HEAP32[i4 >> 2] = i6;
      HEAP32[i5 >> 2] = HEAP32[i7 + -28 >> 2];
      i4 = i4 + 8 | 0;
      __ZN2cv6String10deallocateEv(i4);
      i6 = i7 + -24 | 0;
      i5 = HEAP32[i6 >> 2] | 0;
      if (!i5) i6 = 0; else {
       i5 = i5 + -4 | 0;
       HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
       i6 = HEAP32[i6 >> 2] | 0;
      }
      HEAP32[i4 >> 2] = i6;
      HEAP32[i2 >> 2] = HEAP32[i7 + -20 >> 2];
      __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i3, HEAP32[i7 + -16 >> 2] | 0, HEAP32[i7 + -12 >> 2] | 0);
     }
     i4 = i7 + -4 | 0;
     HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
     if ((i69 | 0) != (i10 | 0)) {
      __ZN2cv6String10deallocateEv(i10);
      i6 = HEAP32[i69 >> 2] | 0;
      if (!i6) i6 = 0; else {
       i6 = i6 + -4 | 0;
       HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
       i6 = HEAP32[i69 >> 2] | 0;
      }
      HEAP32[i10 >> 2] = i6;
      HEAP32[i7 + -28 >> 2] = HEAP32[i25 >> 2];
      i5 = i7 + -24 | 0;
      __ZN2cv6String10deallocateEv(i5);
      i6 = HEAP32[i33 >> 2] | 0;
      if (!i6) i6 = 0; else {
       i6 = i6 + -4 | 0;
       HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
       i6 = HEAP32[i33 >> 2] | 0;
      }
      HEAP32[i5 >> 2] = i6;
      HEAP32[i7 + -20 >> 2] = HEAP32[i27 >> 2];
      __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i7 + -16 | 0, HEAP32[i31 >> 2] | 0, HEAP32[i32 >> 2] | 0);
     }
     HEAP32[i4 >> 2] = HEAP32[i30 >> 2];
     i7 = HEAP32[i31 >> 2] | 0;
     if (i7) {
      while (1) {
       i6 = HEAP32[i32 >> 2] | 0;
       if ((i6 | 0) == (i7 | 0)) break;
       i6 = i6 + -8 | 0;
       HEAP32[i32 >> 2] = i6;
       __ZN2cv6String10deallocateEv(i6);
      }
      __ZdlPv(HEAP32[i31 >> 2] | 0);
     }
     __ZN2cv6String10deallocateEv(i26);
     __ZN2cv6String10deallocateEv(i69);
     i7 = i10;
    }
   } while (0);
   i7 = i59 + 32 | 0;
   L118 : do if (i7 >>> 0 < i6 >>> 0) while (1) {
    i12 = i7;
    while (1) {
     i7 = i12 + 32 | 0;
     if (FUNCTION_TABLE_iii[HEAP32[i57 >> 2] & 127](i12, i13) | 0) i12 = i7; else break;
    }
    while (1) {
     i11 = i6 + -32 | 0;
     if (FUNCTION_TABLE_iii[HEAP32[i57 >> 2] & 127](i11, i13) | 0) break; else i6 = i11;
    }
    if (i12 >>> 0 > i11 >>> 0) {
     i10 = i13;
     break L118;
    }
    i5 = HEAP32[i12 >> 2] | 0;
    HEAP32[i69 >> 2] = i5;
    i4 = i12 + 4 | 0;
    HEAP32[i55 >> 2] = HEAP32[i4 >> 2];
    if (i5) {
     i10 = i5 + -4 | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
    }
    i5 = HEAP32[i12 + 8 >> 2] | 0;
    HEAP32[i56 >> 2] = i5;
    i1 = i12 + 12 | 0;
    HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
    if (i5) {
     i10 = i5 + -4 | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
    }
    i2 = i12 + 16 | 0;
    __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i20, i2);
    i10 = i12 + 28 | 0;
    HEAP32[i21 >> 2] = HEAP32[i10 >> 2];
    if ((i11 | 0) != (i12 | 0)) {
     __ZN2cv6String10deallocateEv(i12);
     i5 = HEAP32[i11 >> 2] | 0;
     if (!i5) i5 = 0; else {
      i5 = i5 + -4 | 0;
      HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
      i5 = HEAP32[i11 >> 2] | 0;
     }
     HEAP32[i12 >> 2] = i5;
     HEAP32[i4 >> 2] = HEAP32[i6 + -28 >> 2];
     i3 = i12 + 8 | 0;
     __ZN2cv6String10deallocateEv(i3);
     i5 = i6 + -24 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     if (!i4) i5 = 0; else {
      i4 = i4 + -4 | 0;
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
      i5 = HEAP32[i5 >> 2] | 0;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i1 >> 2] = HEAP32[i6 + -20 >> 2];
     __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i2, HEAP32[i6 + -16 >> 2] | 0, HEAP32[i6 + -12 >> 2] | 0);
    }
    i3 = i6 + -4 | 0;
    HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
    if ((i69 | 0) != (i11 | 0)) {
     __ZN2cv6String10deallocateEv(i11);
     i5 = HEAP32[i69 >> 2] | 0;
     if (!i5) i5 = 0; else {
      i5 = i5 + -4 | 0;
      HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
      i5 = HEAP32[i69 >> 2] | 0;
     }
     HEAP32[i11 >> 2] = i5;
     HEAP32[i6 + -28 >> 2] = HEAP32[i55 >> 2];
     i4 = i6 + -24 | 0;
     __ZN2cv6String10deallocateEv(i4);
     i5 = HEAP32[i24 >> 2] | 0;
     if (!i5) i5 = 0; else {
      i5 = i5 + -4 | 0;
      HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
      i5 = HEAP32[i24 >> 2] | 0;
     }
     HEAP32[i4 >> 2] = i5;
     HEAP32[i6 + -20 >> 2] = HEAP32[i19 >> 2];
     __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i6 + -16 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i23 >> 2] | 0);
    }
    HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
    i6 = HEAP32[i22 >> 2] | 0;
    if (i6) {
     while (1) {
      i5 = HEAP32[i23 >> 2] | 0;
      if ((i5 | 0) == (i6 | 0)) break;
      i10 = i5 + -8 | 0;
      HEAP32[i23 >> 2] = i10;
      __ZN2cv6String10deallocateEv(i10);
     }
     __ZdlPv(HEAP32[i22 >> 2] | 0);
    }
    __ZN2cv6String10deallocateEv(i56);
    __ZN2cv6String10deallocateEv(i69);
    i6 = i11;
    i13 = (i13 | 0) == (i12 | 0) ? i11 : i13;
    i9 = i9 + 1 | 0;
   } else {
    i12 = i7;
    i10 = i13;
   } while (0);
   if ((i12 | 0) != (i10 | 0) ? FUNCTION_TABLE_iii[HEAP32[i57 >> 2] & 127](i10, i12) | 0 : 0) {
    i7 = HEAP32[i12 >> 2] | 0;
    HEAP32[i69 >> 2] = i7;
    i6 = i12 + 4 | 0;
    HEAP32[i17 >> 2] = HEAP32[i6 >> 2];
    if (i7) {
     i7 = i7 + -4 | 0;
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    }
    i7 = HEAP32[i12 + 8 >> 2] | 0;
    HEAP32[i18 >> 2] = i7;
    i3 = i12 + 12 | 0;
    HEAP32[i29 >> 2] = HEAP32[i3 >> 2];
    if (i7) {
     i7 = i7 + -4 | 0;
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    }
    i4 = i12 + 16 | 0;
    __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i40, i4);
    i2 = i12 + 28 | 0;
    HEAP32[i51 >> 2] = HEAP32[i2 >> 2];
    __ZN2cv6String10deallocateEv(i12);
    i7 = HEAP32[i10 >> 2] | 0;
    if (!i7) i7 = 0; else {
     i7 = i7 + -4 | 0;
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     i7 = HEAP32[i10 >> 2] | 0;
    }
    HEAP32[i12 >> 2] = i7;
    HEAP32[i6 >> 2] = HEAP32[i10 + 4 >> 2];
    i5 = i12 + 8 | 0;
    __ZN2cv6String10deallocateEv(i5);
    i7 = i10 + 8 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    if (!i6) i7 = 0; else {
     i6 = i6 + -4 | 0;
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
     i7 = HEAP32[i7 >> 2] | 0;
    }
    HEAP32[i5 >> 2] = i7;
    HEAP32[i3 >> 2] = HEAP32[i10 + 12 >> 2];
    __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i4, HEAP32[i10 + 16 >> 2] | 0, HEAP32[i10 + 20 >> 2] | 0);
    i5 = i10 + 28 | 0;
    HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
    if ((i69 | 0) != (i10 | 0)) {
     __ZN2cv6String10deallocateEv(i10);
     i7 = HEAP32[i69 >> 2] | 0;
     if (!i7) i7 = 0; else {
      i7 = i7 + -4 | 0;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
      i7 = HEAP32[i69 >> 2] | 0;
     }
     HEAP32[i10 >> 2] = i7;
     HEAP32[i10 + 4 >> 2] = HEAP32[i17 >> 2];
     i6 = i10 + 8 | 0;
     __ZN2cv6String10deallocateEv(i6);
     i7 = HEAP32[i54 >> 2] | 0;
     if (!i7) i7 = 0; else {
      i7 = i7 + -4 | 0;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
      i7 = HEAP32[i54 >> 2] | 0;
     }
     HEAP32[i6 >> 2] = i7;
     HEAP32[i10 + 12 >> 2] = HEAP32[i29 >> 2];
     __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10 + 16 | 0, HEAP32[i52 >> 2] | 0, HEAP32[i53 >> 2] | 0);
    }
    HEAP32[i5 >> 2] = HEAP32[i51 >> 2];
    i7 = HEAP32[i52 >> 2] | 0;
    if (i7) {
     while (1) {
      i6 = HEAP32[i53 >> 2] | 0;
      if ((i6 | 0) == (i7 | 0)) break;
      i10 = i6 + -8 | 0;
      HEAP32[i53 >> 2] = i10;
      __ZN2cv6String10deallocateEv(i10);
     }
     __ZdlPv(HEAP32[i52 >> 2] | 0);
    }
    __ZN2cv6String10deallocateEv(i18);
    __ZN2cv6String10deallocateEv(i69);
    i9 = i9 + 1 | 0;
   }
   if (!i9) {
    i9 = __ZNSt3__127__insertion_sort_incompleteIRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEbT0_S9_T_(i59, i12, i57) | 0;
    i7 = i12 + 32 | 0;
    if (__ZNSt3__127__insertion_sort_incompleteIRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEbT0_S9_T_(i7, i8, i57) | 0) {
     i58 = 156;
     break;
    }
    if (i9) {
     i59 = i7;
     continue;
    }
   }
   i10 = i12;
   if ((i10 - i14 | 0) >= (i15 - i10 | 0)) {
    i58 = 160;
    break;
   }
   __ZNSt3__16__sortIRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEvT0_S9_T_(i59, i12, i57);
   i59 = i12 + 32 | 0;
  }
  if ((i58 | 0) == 156) {
   i58 = 0;
   if (i9) {
    i58 = 161;
    break;
   } else {
    i9 = i59;
    i8 = i12;
    continue;
   }
  } else if ((i58 | 0) == 160) {
   i58 = 0;
   __ZNSt3__16__sortIRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEvT0_S9_T_(i12 + 32 | 0, i8, i57);
   i9 = i59;
   i8 = i12;
   continue;
  }
 }
 if ((i58 | 0) == 4) {
  if (!(FUNCTION_TABLE_iii[HEAP32[i57 >> 2] & 127](i63, i59) | 0)) {
   STACKTOP = i70;
   return;
  }
  i4 = HEAP32[i59 >> 2] | 0;
  HEAP32[i69 >> 2] = i4;
  i6 = i69 + 4 | 0;
  i3 = i59 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  if (i4) {
   i46 = i4 + -4 | 0;
   HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + 1;
  }
  i9 = i69 + 8 | 0;
  i4 = HEAP32[i59 + 8 >> 2] | 0;
  HEAP32[i9 >> 2] = i4;
  i7 = i69 + 12 | 0;
  i5 = i59 + 12 | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  if (i4) {
   i46 = i4 + -4 | 0;
   HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + 1;
  }
  i2 = i59 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i69 + 16 | 0, i2);
  i8 = i69 + 28 | 0;
  i1 = i59 + 28 | 0;
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  if ((i63 | 0) != (i59 | 0)) {
   __ZN2cv6String10deallocateEv(i59);
   i4 = HEAP32[i63 >> 2] | 0;
   if (!i4) i4 = 0; else {
    i4 = i4 + -4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    i4 = HEAP32[i63 >> 2] | 0;
   }
   HEAP32[i59 >> 2] = i4;
   HEAP32[i3 >> 2] = HEAP32[i64 >> 2];
   i3 = i59 + 8 | 0;
   __ZN2cv6String10deallocateEv(i3);
   i4 = HEAP32[i60 >> 2] | 0;
   if (!i4) i4 = 0; else {
    i4 = i4 + -4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    i4 = HEAP32[i60 >> 2] | 0;
   }
   HEAP32[i3 >> 2] = i4;
   HEAP32[i5 >> 2] = HEAP32[i66 >> 2];
   __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i2, HEAP32[i61 >> 2] | 0, HEAP32[i62 >> 2] | 0);
  }
  HEAP32[i1 >> 2] = HEAP32[i68 >> 2];
  if ((i69 | 0) == (i63 | 0)) i4 = i69 + 16 | 0; else {
   __ZN2cv6String10deallocateEv(i63);
   i4 = HEAP32[i69 >> 2] | 0;
   if (!i4) i4 = 0; else {
    i4 = i4 + -4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    i4 = HEAP32[i69 >> 2] | 0;
   }
   HEAP32[i63 >> 2] = i4;
   HEAP32[i64 >> 2] = HEAP32[i6 >> 2];
   __ZN2cv6String10deallocateEv(i65);
   i4 = i69 + 8 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i3) i4 = 0; else {
    i46 = i3 + -4 | 0;
    HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + 1;
    i4 = HEAP32[i4 >> 2] | 0;
   }
   HEAP32[i65 >> 2] = i4;
   HEAP32[i66 >> 2] = HEAP32[i7 >> 2];
   i4 = i69 + 16 | 0;
   __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i67, HEAP32[i4 >> 2] | 0, HEAP32[i69 + 20 >> 2] | 0);
  }
  HEAP32[i68 >> 2] = HEAP32[i8 >> 2];
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1) {
   i2 = i69 + 20 | 0;
   while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) == (i1 | 0)) break;
    i46 = i3 + -8 | 0;
    HEAP32[i2 >> 2] = i46;
    __ZN2cv6String10deallocateEv(i46);
   }
   __ZdlPv(HEAP32[i4 >> 2] | 0);
  }
  __ZN2cv6String10deallocateEv(i9);
  __ZN2cv6String10deallocateEv(i69);
  STACKTOP = i70;
  return;
 } else if ((i58 | 0) == 28) {
  __ZNSt3__17__sort3IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_T_(i59, i59 + 32 | 0, i63, i57) | 0;
  STACKTOP = i70;
  return;
 } else if ((i58 | 0) == 29) {
  __ZNSt3__17__sort4IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_S9_T_(i59, i59 + 32 | 0, i59 + 64 | 0, i63, i57) | 0;
  STACKTOP = i70;
  return;
 } else if ((i58 | 0) == 30) {
  __ZNSt3__17__sort5IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_S9_S9_T_(i59, i59 + 32 | 0, i59 + 64 | 0, i59 + 96 | 0, i63, i57) | 0;
  STACKTOP = i70;
  return;
 } else if ((i58 | 0) == 32) {
  __ZNSt3__118__insertion_sort_3IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEvT0_S9_T_(i59, i8, i57);
  STACKTOP = i70;
  return;
 } else if ((i58 | 0) == 161) {
  STACKTOP = i70;
  return;
 }
}

function __ZN2cvL18GEMMSingleMul_32fcEPKNS_7ComplexIfEEjS3_jS3_jPS1_jNS_5Size_IiEES6_ddi(i33, i18, i40, i23, i35, i3, i34, i4, i1, i2, d47, d48, i11) {
 i33 = i33 | 0;
 i18 = i18 | 0;
 i40 = i40 | 0;
 i23 = i23 | 0;
 i35 = i35 | 0;
 i3 = i3 | 0;
 i34 = i34 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d47 = +d47;
 d48 = +d48;
 i11 = i11 | 0;
 var d5 = 0.0, d6 = 0.0, d7 = 0.0, d8 = 0.0, i9 = 0, i10 = 0, d12 = 0.0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, d20 = 0.0, d21 = 0.0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, f53 = f0, d54 = 0.0, d55 = 0.0, d56 = 0.0, d57 = 0.0;
 i51 = STACKTOP;
 STACKTOP = STACKTOP + 3360 | 0;
 i50 = i51 + 2256 | 0;
 i32 = i51 + 1160 | 0;
 i28 = i51;
 i10 = HEAP32[i1 >> 2] | 0;
 i19 = HEAP32[i1 + 4 >> 2] | 0;
 i46 = HEAP32[i2 >> 2] | 0;
 i44 = HEAP32[i2 + 4 >> 2] | 0;
 i49 = i50 + 8 | 0;
 i2 = i50 + 1096 | 0;
 i1 = i49;
 do {
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i50 >> 2] = i49;
 i45 = i50 + 4 | 0;
 HEAP32[i45 >> 2] = 136;
 i17 = i18 >>> 3;
 i39 = i23 >>> 3;
 i3 = i3 >>> 3;
 i42 = i4 >>> 3;
 if (!i35) {
  i43 = 0;
  i41 = 0;
 } else {
  i41 = (i11 & 4 | 0) == 0;
  i43 = i41 ? i3 : 1;
  i41 = i41 ? 1 : i3;
 }
 do if (i11 & 1) if (i18 >>> 0 > 15 & (i19 | 0) > 1) {
  if (i19 >>> 0 <= 136) {
   HEAP32[i45 >> 2] = i19;
   i9 = i19;
   i3 = i49;
   i36 = i49;
   i37 = 1;
   i38 = i17;
   i10 = i19;
   break;
  }
  i1 = __Znaj(i19 >>> 0 > 536870911 ? -1 : i19 << 3) | 0;
  i3 = i1 + (i19 << 3) | 0;
  i2 = i1;
  do {
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
   i2 = i2 + 8 | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i50 >> 2] = i1;
  HEAP32[i45 >> 2] = i19;
  i9 = i19;
  i3 = i1;
  i36 = i1;
  i37 = 1;
  i38 = i17;
  i10 = i19;
 } else {
  i9 = 136;
  i3 = i49;
  i36 = 0;
  i37 = 1;
  i38 = i17;
  i10 = i19;
 } else {
  i9 = 136;
  i3 = i49;
  i36 = 0;
  i37 = i17;
  i38 = 1;
 } while (0);
 L17 : do if ((i10 | 0) == 1) {
  i25 = i32 + 8 | 0;
  i2 = i32 + 1096 | 0;
  i1 = i25;
  do {
   HEAPF32[i1 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i2 | 0));
  HEAP32[i32 >> 2] = i25;
  i24 = i32 + 4 | 0;
  HEAP32[i24 >> 2] = 136;
  if (i18 >>> 0 > 15 & (i19 | 0) > 1) {
   if (i9 >>> 0 < i44 >>> 0) {
    if ((i3 | 0) != (i49 | 0)) {
     __ZdaPv(i3);
     HEAP32[i50 >> 2] = i49;
     HEAP32[i45 >> 2] = 136;
    }
    if (i44 >>> 0 > 136) {
     i3 = __Znaj(i44 >>> 0 > 536870911 ? -1 : i44 << 3) | 0;
     i2 = i3 + (i44 << 3) | 0;
     i1 = i3;
     do {
      HEAPF32[i1 >> 2] = Math_fround(0.0);
      HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
      i1 = i1 + 8 | 0;
     } while ((i1 | 0) != (i2 | 0));
     HEAP32[i50 >> 2] = i3;
     HEAP32[i45 >> 2] = i44;
    } else i3 = i49;
   } else HEAP32[i45 >> 2] = i44;
   if ((i44 | 0) > 0) {
    i2 = 0;
    do {
     i28 = i33 + ((Math_imul(i2, i17) | 0) << 3) | 0;
     i29 = HEAP32[i28 + 4 >> 2] | 0;
     i30 = i3 + (i2 << 3) | 0;
     HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i30 + 4 >> 2] = i29;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i44 | 0));
    i22 = i3;
   } else i22 = i3;
  } else i22 = i33;
  if (i23 >>> 0 > 15) {
   if ((HEAP32[i24 >> 2] | 0) >>> 0 < i46 >>> 0) {
    i1 = HEAP32[i32 >> 2] | 0;
    if ((i1 | 0) != (i25 | 0)) {
     if (i1) __ZdaPv(i1);
     HEAP32[i32 >> 2] = i25;
     HEAP32[i24 >> 2] = 136;
    }
    if (i46 >>> 0 > 136) {
     i2 = __Znaj(i46 >>> 0 > 536870911 ? -1 : i46 << 3) | 0;
     i1 = i2 + (i46 << 3) | 0;
     i3 = i2;
     do {
      HEAPF32[i3 >> 2] = Math_fround(0.0);
      HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
      i3 = i3 + 8 | 0;
     } while ((i3 | 0) != (i1 | 0));
     HEAP32[i32 >> 2] = i2;
     HEAP32[i24 >> 2] = i46;
    } else i2 = i25;
   } else {
    HEAP32[i24 >> 2] = i46;
    i2 = HEAP32[i32 >> 2] | 0;
   }
   if ((i46 | 0) > 0) {
    i1 = 0;
    do {
     i28 = i40 + ((Math_imul(i1, i39) | 0) << 3) | 0;
     i29 = HEAP32[i28 + 4 >> 2] | 0;
     i30 = i2 + (i1 << 3) | 0;
     HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i30 + 4 >> 2] = i29;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i46 | 0));
   }
  } else i2 = i40;
  if ((i44 | 0) > 0) {
   i16 = i41 << 1;
   i17 = i46 + -2 | 0;
   i18 = (i17 | 0) < 0;
   i11 = i17 >>> 1;
   i19 = (i11 << 1) + 2 | 0;
   i10 = i34;
   i14 = i35;
   i15 = 0;
   i11 = i35 + (Math_imul(i41, (i11 << 4) + 16 | 0) | 0) | 0;
   while (1) {
    d12 = +Math_fround(HEAPF32[i22 + (i15 << 3) >> 2]);
    d12 = d12 * d47;
    d13 = +Math_fround(HEAPF32[i22 + (i15 << 3) + 4 >> 2]) * d47;
    if (i18) {
     i3 = i14;
     i4 = 0;
    } else {
     i4 = i14;
     i9 = 0;
     while (1) {
      d20 = +Math_fround(HEAPF32[i2 + (i9 << 3) >> 2]);
      d5 = +Math_fround(HEAPF32[i2 + (i9 << 3) + 4 >> 2]);
      d6 = d12 * d20 - d13 * d5;
      d5 = d13 * d20 + d12 * d5;
      i3 = i9 | 1;
      d20 = +Math_fround(HEAPF32[i2 + (i3 << 3) >> 2]);
      d8 = +Math_fround(HEAPF32[i2 + (i3 << 3) + 4 >> 2]);
      d7 = d12 * d20 - d13 * d8;
      d8 = d13 * d20 + d12 * d8;
      i1 = i10 + (i9 << 3) | 0;
      if (!i4) {
       f52 = Math_fround(d6);
       f53 = Math_fround(d5);
       f52 = Math_fround(f52);
       f53 = Math_fround(f53);
       i30 = i1;
       HEAPF32[i30 >> 2] = f52;
       HEAPF32[i30 + 4 >> 2] = f53;
       f53 = Math_fround(d7);
       f52 = Math_fround(d8);
       f53 = Math_fround(f53);
       f52 = Math_fround(f52);
       i30 = i10 + (i3 << 3) | 0;
       HEAPF32[i30 >> 2] = f53;
       HEAPF32[i30 + 4 >> 2] = f52;
      } else {
       d20 = +Math_fround(HEAPF32[i4 >> 2]);
       f52 = Math_fround(d6 + d20 * d48);
       f53 = Math_fround(d5 + +Math_fround(HEAPF32[i4 + 4 >> 2]) * d48);
       f52 = Math_fround(f52);
       f53 = Math_fround(f53);
       i30 = i1;
       HEAPF32[i30 >> 2] = f52;
       HEAPF32[i30 + 4 >> 2] = f53;
       d5 = +Math_fround(HEAPF32[i4 + (i41 << 3) >> 2]);
       f53 = Math_fround(d7 + d5 * d48);
       f52 = Math_fround(d8 + +Math_fround(HEAPF32[i4 + (i41 << 3) + 4 >> 2]) * d48);
       f53 = Math_fround(f53);
       f52 = Math_fround(f52);
       i30 = i10 + (i3 << 3) | 0;
       HEAPF32[i30 >> 2] = f53;
       HEAPF32[i30 + 4 >> 2] = f52;
      }
      i9 = i9 + 2 | 0;
      if ((i9 | 0) > (i17 | 0)) {
       i3 = i11;
       i4 = i19;
       break;
      } else i4 = i4 + (i16 << 3) | 0;
     }
    }
    if ((i4 | 0) < (i46 | 0)) while (1) {
     d7 = +Math_fround(HEAPF32[i2 + (i4 << 3) >> 2]);
     d6 = +Math_fround(HEAPF32[i2 + (i4 << 3) + 4 >> 2]);
     d5 = d12 * d7 - d13 * d6;
     d6 = d13 * d7 + d12 * d6;
     i1 = i10 + (i4 << 3) | 0;
     if (!i3) {
      f53 = Math_fround(d5);
      f52 = Math_fround(d6);
      f53 = Math_fround(f53);
      f52 = Math_fround(f52);
      i30 = i1;
      HEAPF32[i30 >> 2] = f53;
      HEAPF32[i30 + 4 >> 2] = f52;
     } else {
      d7 = +Math_fround(HEAPF32[i3 >> 2]);
      f53 = Math_fround(d5 + d7 * d48);
      f52 = Math_fround(d6 + +Math_fround(HEAPF32[i3 + 4 >> 2]) * d48);
      f53 = Math_fround(f53);
      f52 = Math_fround(f52);
      i30 = i1;
      HEAPF32[i30 >> 2] = f53;
      HEAPF32[i30 + 4 >> 2] = f52;
     }
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i46 | 0)) break; else i3 = i3 + (i41 << 3) | 0;
    }
    i15 = i15 + 1 | 0;
    if ((i15 | 0) == (i44 | 0)) break; else {
     i10 = i10 + (i42 << 3) | 0;
     i14 = i14 + (i43 << 3) | 0;
     i11 = i11 + (i43 << 3) | 0;
    }
   }
  }
  i1 = HEAP32[i32 >> 2] | 0;
  if ((i1 | 0) != (i25 | 0)) {
   if (i1) __ZdaPv(i1);
   HEAP32[i32 >> 2] = i25;
   HEAP32[i24 >> 2] = 136;
  }
 } else {
  if (i11 & 2) {
   if ((i44 | 0) <= 0) break;
   i26 = (i36 | 0) == 0;
   i3 = i10 + -4 | 0;
   i14 = (i3 | 0) < 0;
   i27 = i10 & -4;
   i9 = i26 | (i10 | 0) < 1;
   i15 = (i46 | 0) > 0;
   i2 = i34;
   i25 = i33;
   i24 = i35;
   i1 = 0;
   while (1) {
    if (i9) i22 = i26 ? i25 : i36; else {
     i4 = 0;
     do {
      i28 = i25 + ((Math_imul(i4, i38) | 0) << 3) | 0;
      i29 = HEAP32[i28 + 4 >> 2] | 0;
      i30 = i36 + (i4 << 3) | 0;
      HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
      HEAP32[i30 + 4 >> 2] = i29;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i10 | 0));
     i22 = i36;
    }
    if (i15) {
     i19 = i40;
     i18 = i24;
     i17 = 0;
     while (1) {
      if (i14) {
       d13 = 0.0;
       d8 = 0.0;
       d6 = 0.0;
       d7 = 0.0;
       d20 = 0.0;
       d5 = 0.0;
       d21 = 0.0;
       d12 = 0.0;
       i11 = 0;
      } else {
       d8 = 0.0;
       d13 = 0.0;
       d7 = 0.0;
       d6 = 0.0;
       d5 = 0.0;
       d20 = 0.0;
       d12 = 0.0;
       d21 = 0.0;
       i23 = 0;
       do {
        d55 = +Math_fround(HEAPF32[i22 + (i23 << 3) >> 2]);
        d57 = +Math_fround(HEAPF32[i22 + (i23 << 3) + 4 >> 2]);
        d56 = +Math_fround(HEAPF32[i19 + (i23 << 3) >> 2]);
        d54 = +Math_fround(HEAPF32[i19 + (i23 << 3) + 4 >> 2]);
        d8 = d8 + (d55 * d56 - d57 * d54);
        d13 = d13 + (d57 * d56 + d55 * d54);
        i30 = i23 | 1;
        d54 = +Math_fround(HEAPF32[i22 + (i30 << 3) >> 2]);
        d55 = +Math_fround(HEAPF32[i22 + (i30 << 3) + 4 >> 2]);
        d56 = +Math_fround(HEAPF32[i19 + (i30 << 3) >> 2]);
        d57 = +Math_fround(HEAPF32[i19 + (i30 << 3) + 4 >> 2]);
        d7 = d7 + (d54 * d56 - d55 * d57);
        d6 = d6 + (d55 * d56 + d54 * d57);
        i30 = i23 | 2;
        d57 = +Math_fround(HEAPF32[i22 + (i30 << 3) >> 2]);
        d54 = +Math_fround(HEAPF32[i22 + (i30 << 3) + 4 >> 2]);
        d56 = +Math_fround(HEAPF32[i19 + (i30 << 3) >> 2]);
        d55 = +Math_fround(HEAPF32[i19 + (i30 << 3) + 4 >> 2]);
        d5 = d5 + (d57 * d56 - d54 * d55);
        d20 = d20 + (d54 * d56 + d57 * d55);
        i30 = i23 | 3;
        d55 = +Math_fround(HEAPF32[i22 + (i30 << 3) >> 2]);
        d57 = +Math_fround(HEAPF32[i22 + (i30 << 3) + 4 >> 2]);
        d56 = +Math_fround(HEAPF32[i19 + (i30 << 3) >> 2]);
        d54 = +Math_fround(HEAPF32[i19 + (i30 << 3) + 4 >> 2]);
        d12 = d12 + (d55 * d56 - d57 * d54);
        d21 = d21 + (d57 * d56 + d55 * d54);
        i23 = i23 + 4 | 0;
       } while ((i23 | 0) <= (i3 | 0));
       i11 = i27;
      }
      if ((i11 | 0) < (i10 | 0)) do {
       d55 = +Math_fround(HEAPF32[i22 + (i11 << 3) >> 2]);
       d57 = +Math_fround(HEAPF32[i22 + (i11 << 3) + 4 >> 2]);
       d56 = +Math_fround(HEAPF32[i19 + (i11 << 3) >> 2]);
       d54 = +Math_fround(HEAPF32[i19 + (i11 << 3) + 4 >> 2]);
       d8 = d8 + (d55 * d56 - d57 * d54);
       d13 = d13 + (d57 * d56 + d55 * d54);
       i11 = i11 + 1 | 0;
      } while ((i11 | 0) != (i10 | 0));
      d7 = (d12 + (d5 + (d7 + d8))) * d47;
      d8 = (d21 + (d20 + (d6 + d13))) * d47;
      i4 = i2 + (i17 << 3) | 0;
      if (!i18) {
       f53 = Math_fround(d7);
       f52 = Math_fround(d8);
       f53 = Math_fround(f53);
       f52 = Math_fround(f52);
       i30 = i4;
       HEAPF32[i30 >> 2] = f53;
       HEAPF32[i30 + 4 >> 2] = f52;
      } else {
       d21 = +Math_fround(HEAPF32[i18 >> 2]);
       f53 = Math_fround(d7 + d21 * d48);
       f52 = Math_fround(d8 + +Math_fround(HEAPF32[i18 + 4 >> 2]) * d48);
       f53 = Math_fround(f53);
       f52 = Math_fround(f52);
       i30 = i4;
       HEAPF32[i30 >> 2] = f53;
       HEAPF32[i30 + 4 >> 2] = f52;
      }
      i17 = i17 + 1 | 0;
      if ((i17 | 0) == (i46 | 0)) break; else {
       i19 = i19 + (i39 << 3) | 0;
       i18 = i18 + (i41 << 3) | 0;
      }
     }
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i44 | 0)) break L17; else {
     i2 = i2 + (i42 << 3) | 0;
     i25 = i25 + (i37 << 3) | 0;
     i24 = i24 + (i43 << 3) | 0;
    }
   }
  }
  if (i46 << 3 >>> 0 < 1601) {
   if ((i44 | 0) <= 0) break;
   i26 = (i36 | 0) == 0;
   i14 = i46 + -4 | 0;
   i27 = (i14 | 0) < 0;
   i15 = (i10 | 0) > 0;
   i16 = i41 << 2;
   i29 = i41 << 1;
   i30 = i41 * 3 | 0;
   i17 = i14 >>> 2;
   i31 = (i17 << 2) + 4 | 0;
   i32 = i26 | i15 ^ 1;
   i2 = i34;
   i24 = i33;
   i1 = i35;
   i25 = 0;
   i17 = i35 + (Math_imul(i41, (i17 << 5) + 32 | 0) | 0) | 0;
   while (1) {
    if (i32) i28 = i26 ? i24 : i36; else {
     i4 = 0;
     do {
      i22 = i24 + ((Math_imul(i4, i38) | 0) << 3) | 0;
      i23 = HEAP32[i22 + 4 >> 2] | 0;
      i28 = i36 + (i4 << 3) | 0;
      HEAP32[i28 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i28 + 4 >> 2] = i23;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i10 | 0));
     i28 = i36;
    }
    if (i27) {
     i4 = i1;
     i9 = 0;
    } else {
     i19 = i1;
     i18 = 0;
     while (1) {
      if (i15) {
       d21 = 0.0;
       d20 = 0.0;
       d6 = 0.0;
       d5 = 0.0;
       d8 = 0.0;
       d7 = 0.0;
       d13 = 0.0;
       d12 = 0.0;
       i23 = i40 + (i18 << 3) | 0;
       i22 = 0;
       while (1) {
        d55 = +Math_fround(HEAPF32[i28 + (i22 << 3) >> 2]);
        d57 = +Math_fround(HEAPF32[i28 + (i22 << 3) + 4 >> 2]);
        d54 = +Math_fround(HEAPF32[i23 >> 2]);
        d56 = +Math_fround(HEAPF32[i23 + 4 >> 2]);
        d21 = d21 + (d55 * d54 - d57 * d56);
        d20 = d20 + (d57 * d54 + d55 * d56);
        d56 = +Math_fround(HEAPF32[i23 + 8 >> 2]);
        d54 = +Math_fround(HEAPF32[i23 + 12 >> 2]);
        d6 = d6 + (d55 * d56 - d57 * d54);
        d5 = d5 + (d57 * d56 + d55 * d54);
        d54 = +Math_fround(HEAPF32[i23 + 16 >> 2]);
        d56 = +Math_fround(HEAPF32[i23 + 20 >> 2]);
        d8 = d8 + (d55 * d54 - d57 * d56);
        d7 = d7 + (d57 * d54 + d55 * d56);
        d56 = +Math_fround(HEAPF32[i23 + 24 >> 2]);
        d54 = +Math_fround(HEAPF32[i23 + 28 >> 2]);
        d13 = d13 + (d55 * d56 - d57 * d54);
        d12 = d12 + (d57 * d56 + d55 * d54);
        i22 = i22 + 1 | 0;
        if ((i22 | 0) == (i10 | 0)) break; else i23 = i23 + (i39 << 3) | 0;
       }
      } else {
       d20 = 0.0;
       d21 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d7 = 0.0;
       d8 = 0.0;
       d12 = 0.0;
       d13 = 0.0;
      }
      if (!i19) {
       f52 = Math_fround(d21 * d47);
       f53 = Math_fround(d20 * d47);
       f52 = Math_fround(f52);
       f53 = Math_fround(f53);
       i23 = i2 + (i18 << 3) | 0;
       HEAPF32[i23 >> 2] = f52;
       HEAPF32[i23 + 4 >> 2] = f53;
       f53 = Math_fround(d6 * d47);
       f52 = Math_fround(d5 * d47);
       f53 = Math_fround(f53);
       f52 = Math_fround(f52);
       i23 = i2 + ((i18 | 1) << 3) | 0;
       HEAPF32[i23 >> 2] = f53;
       HEAPF32[i23 + 4 >> 2] = f52;
       f52 = Math_fround(d8 * d47);
       f53 = Math_fround(d7 * d47);
       f52 = Math_fround(f52);
       f53 = Math_fround(f53);
       i23 = i2 + ((i18 | 2) << 3) | 0;
       HEAPF32[i23 >> 2] = f52;
       HEAPF32[i23 + 4 >> 2] = f53;
       f53 = Math_fround(d13 * d47);
       f52 = Math_fround(d12 * d47);
       f53 = Math_fround(f53);
       f52 = Math_fround(f52);
       i23 = i2 + ((i18 | 3) << 3) | 0;
       HEAPF32[i23 >> 2] = f53;
       HEAPF32[i23 + 4 >> 2] = f52;
      } else {
       d54 = +Math_fround(HEAPF32[i19 >> 2]);
       f52 = Math_fround(d21 * d47 + d54 * d48);
       f53 = Math_fround(d20 * d47 + +Math_fround(HEAPF32[i19 + 4 >> 2]) * d48);
       f52 = Math_fround(f52);
       f53 = Math_fround(f53);
       i23 = i2 + (i18 << 3) | 0;
       HEAPF32[i23 >> 2] = f52;
       HEAPF32[i23 + 4 >> 2] = f53;
       d21 = +Math_fround(HEAPF32[i19 + (i41 << 3) >> 2]);
       f53 = Math_fround(d6 * d47 + d21 * d48);
       f52 = Math_fround(d5 * d47 + +Math_fround(HEAPF32[i19 + (i41 << 3) + 4 >> 2]) * d48);
       f53 = Math_fround(f53);
       f52 = Math_fround(f52);
       i23 = i2 + ((i18 | 1) << 3) | 0;
       HEAPF32[i23 >> 2] = f53;
       HEAPF32[i23 + 4 >> 2] = f52;
       d21 = +Math_fround(HEAPF32[i19 + (i29 << 3) >> 2]);
       f52 = Math_fround(d8 * d47 + d21 * d48);
       f53 = Math_fround(d7 * d47 + +Math_fround(HEAPF32[i19 + (i29 << 3) + 4 >> 2]) * d48);
       f52 = Math_fround(f52);
       f53 = Math_fround(f53);
       i23 = i2 + ((i18 | 2) << 3) | 0;
       HEAPF32[i23 >> 2] = f52;
       HEAPF32[i23 + 4 >> 2] = f53;
       d21 = +Math_fround(HEAPF32[i19 + (i30 << 3) >> 2]);
       f53 = Math_fround(d13 * d47 + d21 * d48);
       f52 = Math_fround(d12 * d47 + +Math_fround(HEAPF32[i19 + (i30 << 3) + 4 >> 2]) * d48);
       f53 = Math_fround(f53);
       f52 = Math_fround(f52);
       i23 = i2 + ((i18 | 3) << 3) | 0;
       HEAPF32[i23 >> 2] = f53;
       HEAPF32[i23 + 4 >> 2] = f52;
      }
      i18 = i18 + 4 | 0;
      if ((i18 | 0) > (i14 | 0)) {
       i4 = i17;
       i9 = i31;
       break;
      } else i19 = i19 + (i16 << 3) | 0;
     }
    }
    if ((i9 | 0) < (i46 | 0)) while (1) {
     if (i15) {
      d8 = 0.0;
      d7 = 0.0;
      i3 = i40 + (i9 << 3) | 0;
      i11 = 0;
      while (1) {
       d20 = +Math_fround(HEAPF32[i28 + (i11 << 3) >> 2]);
       d12 = +Math_fround(HEAPF32[i28 + (i11 << 3) + 4 >> 2]);
       d13 = +Math_fround(HEAPF32[i3 >> 2]);
       d21 = +Math_fround(HEAPF32[i3 + 4 >> 2]);
       d8 = d8 + (d20 * d13 - d12 * d21);
       d7 = d7 + (d12 * d13 + d20 * d21);
       i11 = i11 + 1 | 0;
       if ((i11 | 0) == (i10 | 0)) break; else i3 = i3 + (i39 << 3) | 0;
      }
     } else {
      d7 = 0.0;
      d8 = 0.0;
     }
     d6 = d8 * d47;
     d8 = d7 * d47;
     i3 = i2 + (i9 << 3) | 0;
     if (!i4) {
      f53 = Math_fround(d6);
      f52 = Math_fround(d8);
      f53 = Math_fround(f53);
      f52 = Math_fround(f52);
      i23 = i3;
      HEAPF32[i23 >> 2] = f53;
      HEAPF32[i23 + 4 >> 2] = f52;
     } else {
      d21 = +Math_fround(HEAPF32[i4 >> 2]);
      f53 = Math_fround(d6 + d21 * d48);
      f52 = Math_fround(d8 + +Math_fround(HEAPF32[i4 + 4 >> 2]) * d48);
      f53 = Math_fround(f53);
      f52 = Math_fround(f52);
      i23 = i3;
      HEAPF32[i23 >> 2] = f53;
      HEAPF32[i23 + 4 >> 2] = f52;
     }
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i46 | 0)) break; else i4 = i4 + (i41 << 3) | 0;
    }
    i25 = i25 + 1 | 0;
    if ((i25 | 0) == (i44 | 0)) break L17; else {
     i2 = i2 + (i42 << 3) | 0;
     i24 = i24 + (i37 << 3) | 0;
     i1 = i1 + (i43 << 3) | 0;
     i17 = i17 + (i43 << 3) | 0;
    }
   }
  }
  i27 = i28 + 8 | 0;
  i3 = i28 + 1160 | 0;
  i2 = i27;
  do {
   HEAP32[i2 + 0 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   i2 = i2 + 16 | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i28 >> 2] = i27;
  i26 = i28 + 4 | 0;
  HEAP32[i26 >> 2] = 72;
  if (i46 >>> 0 > 72) {
   i1 = __Znaj(i46 >>> 0 > 268435455 ? -1 : i46 << 4) | 0;
   i3 = i1 + (i46 << 4) | 0;
   i2 = i1;
   do {
    HEAP32[i2 + 0 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    i2 = i2 + 16 | 0;
   } while ((i2 | 0) != (i3 | 0));
   HEAP32[i28 >> 2] = i1;
  } else i1 = i27;
  HEAP32[i26 >> 2] = i46;
  if ((i44 | 0) > 0) {
   i14 = (i36 | 0) == 0;
   i15 = (i46 | 0) > 0;
   i16 = (i10 | 0) > 0;
   i22 = i46 + -4 | 0;
   i23 = (i22 | 0) < 0;
   i24 = i46 & -4;
   i25 = i14 | i16 ^ 1;
   i2 = i34;
   i17 = i33;
   i19 = i35;
   i18 = 0;
   while (1) {
    if (i25) i3 = i14 ? i17 : i36; else {
     i4 = 0;
     do {
      i3 = i17 + ((Math_imul(i4, i38) | 0) << 3) | 0;
      i29 = HEAP32[i3 + 4 >> 2] | 0;
      i30 = i36 + (i4 << 3) | 0;
      HEAP32[i30 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i30 + 4 >> 2] = i29;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i10 | 0));
     i3 = i36;
    }
    if (i15) {
     i9 = 0;
     do {
      i30 = i1 + (i9 << 4) | 0;
      i9 = i9 + 1 | 0;
      HEAP32[i30 + 0 >> 2] = 0;
      HEAP32[i30 + 4 >> 2] = 0;
      HEAP32[i30 + 8 >> 2] = 0;
      HEAP32[i30 + 12 >> 2] = 0;
     } while ((i9 | 0) != (i46 | 0));
    }
    if (i16) {
     i4 = i40;
     i11 = 0;
     while (1) {
      d8 = +Math_fround(HEAPF32[i3 + (i11 << 3) >> 2]);
      d7 = +Math_fround(HEAPF32[i3 + (i11 << 3) + 4 >> 2]);
      if (i23) i9 = 0; else {
       i9 = 0;
       do {
        d21 = +Math_fround(HEAPF32[i4 + (i9 << 3) >> 2]);
        d6 = +Math_fround(HEAPF32[i4 + (i9 << 3) + 4 >> 2]);
        i29 = i1 + (i9 << 4) | 0;
        i30 = i1 + (i9 << 4) + 8 | 0;
        d13 = +HEAPF64[i30 >> 3] + (d7 * d21 + d8 * d6);
        i31 = i9 | 1;
        d20 = +Math_fround(HEAPF32[i4 + (i31 << 3) >> 2]);
        d54 = +Math_fround(HEAPF32[i4 + (i31 << 3) + 4 >> 2]);
        i32 = i1 + (i31 << 4) | 0;
        i31 = i1 + (i31 << 4) + 8 | 0;
        d12 = +HEAPF64[i32 >> 3] + (d8 * d20 - d7 * d54);
        d54 = +HEAPF64[i31 >> 3] + (d7 * d20 + d8 * d54);
        HEAPF64[i29 >> 3] = +HEAPF64[i29 >> 3] + (d8 * d21 - d7 * d6);
        HEAPF64[i30 >> 3] = d13;
        HEAPF64[i32 >> 3] = d12;
        HEAPF64[i31 >> 3] = d54;
        i31 = i9 | 2;
        d54 = +Math_fround(HEAPF32[i4 + (i31 << 3) >> 2]);
        d12 = +Math_fround(HEAPF32[i4 + (i31 << 3) + 4 >> 2]);
        i32 = i1 + (i31 << 4) | 0;
        i31 = i1 + (i31 << 4) + 8 | 0;
        d13 = +HEAPF64[i31 >> 3] + (d7 * d54 + d8 * d12);
        i30 = i9 | 3;
        d6 = +Math_fround(HEAPF32[i4 + (i30 << 3) >> 2]);
        d21 = +Math_fround(HEAPF32[i4 + (i30 << 3) + 4 >> 2]);
        i29 = i1 + (i30 << 4) | 0;
        i30 = i1 + (i30 << 4) + 8 | 0;
        d20 = +HEAPF64[i29 >> 3] + (d8 * d6 - d7 * d21);
        d21 = +HEAPF64[i30 >> 3] + (d7 * d6 + d8 * d21);
        HEAPF64[i32 >> 3] = +HEAPF64[i32 >> 3] + (d8 * d54 - d7 * d12);
        HEAPF64[i31 >> 3] = d13;
        HEAPF64[i29 >> 3] = d20;
        HEAPF64[i30 >> 3] = d21;
        i9 = i9 + 4 | 0;
       } while ((i9 | 0) <= (i22 | 0));
       i9 = i24;
      }
      if ((i9 | 0) < (i46 | 0)) do {
       d20 = +Math_fround(HEAPF32[i4 + (i9 << 3) >> 2]);
       d21 = +Math_fround(HEAPF32[i4 + (i9 << 3) + 4 >> 2]);
       i30 = i1 + (i9 << 4) | 0;
       HEAPF64[i30 >> 3] = +HEAPF64[i30 >> 3] + (d8 * d20 - d7 * d21);
       i30 = i1 + (i9 << 4) + 8 | 0;
       HEAPF64[i30 >> 3] = +HEAPF64[i30 >> 3] + (d7 * d20 + d8 * d21);
       i9 = i9 + 1 | 0;
      } while ((i9 | 0) != (i46 | 0));
      i11 = i11 + 1 | 0;
      if ((i11 | 0) == (i10 | 0)) break; else i4 = i4 + (i39 << 3) | 0;
     }
    }
    if (!i19) {
     if (i15) {
      i4 = 0;
      do {
       f53 = Math_fround(+HEAPF64[i1 + (i4 << 4) >> 3] * d47);
       f52 = Math_fround(+HEAPF64[i1 + (i4 << 4) + 8 >> 3] * d47);
       f53 = Math_fround(f53);
       f52 = Math_fround(f52);
       i30 = i2 + (i4 << 3) | 0;
       HEAPF32[i30 >> 2] = f53;
       HEAPF32[i30 + 4 >> 2] = f52;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i46 | 0));
     }
    } else if (i15) {
     i4 = i19;
     i3 = 0;
     while (1) {
      d21 = +Math_fround(HEAPF32[i4 >> 2]);
      f53 = Math_fround(+HEAPF64[i1 + (i3 << 4) >> 3] * d47 + d21 * d48);
      f52 = Math_fround(+HEAPF64[i1 + (i3 << 4) + 8 >> 3] * d47 + +Math_fround(HEAPF32[i4 + 4 >> 2]) * d48);
      f53 = Math_fround(f53);
      f52 = Math_fround(f52);
      i30 = i2 + (i3 << 3) | 0;
      HEAPF32[i30 >> 2] = f53;
      HEAPF32[i30 + 4 >> 2] = f52;
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i46 | 0)) break; else i4 = i4 + (i41 << 3) | 0;
     }
    }
    i18 = i18 + 1 | 0;
    if ((i18 | 0) == (i44 | 0)) break; else {
     i2 = i2 + (i42 << 3) | 0;
     i17 = i17 + (i37 << 3) | 0;
     i19 = i19 + (i43 << 3) | 0;
    }
   }
   i1 = HEAP32[i28 >> 2] | 0;
  }
  if ((i1 | 0) != (i27 | 0)) {
   if (i1) __ZdaPv(i1);
   HEAP32[i28 >> 2] = i27;
   HEAP32[i26 >> 2] = 72;
  }
 } while (0);
 i1 = HEAP32[i50 >> 2] | 0;
 if ((i1 | 0) == (i49 | 0)) {
  STACKTOP = i51;
  return;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i50 >> 2] = i49;
 HEAP32[i45 >> 2] = 136;
 STACKTOP = i51;
 return;
}

function __ZN4perf10Regression6verifyEN2cv8FileNodeENS1_3MatEdNSt3__112basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS_10ERROR_TYPEE(i6, i58, i62, d12, i68, i1) {
 i6 = i6 | 0;
 i58 = i58 | 0;
 i62 = i62 | 0;
 d12 = +d12;
 i68 = i68 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, d10 = 0.0, d11 = 0.0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i59 = 0, i60 = 0, i61 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i69 = 0, i70 = 0, d71 = 0.0, d72 = 0.0;
 i70 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 i69 = i70 + 16 | 0;
 i30 = i70 + 312 | 0;
 i6 = i70 + 304 | 0;
 i4 = i70 + 296 | 0;
 i2 = i70 + 8 | 0;
 i13 = i70;
 i3 = i70 + 272 | 0;
 i14 = i70 + 264 | 0;
 i18 = i70 + 260 | 0;
 i19 = i70 + 256 | 0;
 i16 = i70 + 248 | 0;
 i24 = i70 + 244 | 0;
 i25 = i70 + 240 | 0;
 i37 = i70 + 232 | 0;
 i26 = i70 + 224 | 0;
 i23 = i70 + 216 | 0;
 i32 = i70 + 208 | 0;
 i20 = i70 + 200 | 0;
 i29 = i70 + 192 | 0;
 i33 = i70 + 188 | 0;
 i34 = i70 + 184 | 0;
 i36 = i70 + 176 | 0;
 i43 = i70 + 172 | 0;
 i44 = i70 + 168 | 0;
 i35 = i70 + 160 | 0;
 i42 = i70 + 152 | 0;
 i52 = i70 + 148 | 0;
 i53 = i70 + 144 | 0;
 i51 = i70 + 136 | 0;
 i41 = i70 + 128 | 0;
 i45 = i70 + 120 | 0;
 i47 = i70 + 112 | 0;
 i50 = i70 + 104 | 0;
 i55 = i70 + 96 | 0;
 i64 = i70 + 92 | 0;
 i65 = i70 + 88 | 0;
 i61 = i70 + 80 | 0;
 i54 = i70 + 72 | 0;
 i56 = i70 + 64 | 0;
 i59 = i70 + 56 | 0;
 i60 = i70 + 48 | 0;
 i63 = i70 + 40 | 0;
 i66 = i70 + 32 | 0;
 i67 = i70 + 28 | 0;
 if (HEAP32[i62 + 16 >> 2] | 0) {
  i5 = HEAP32[i62 + 4 >> 2] | 0;
  if ((i5 | 0) < 3) i9 = Math_imul(HEAP32[i62 + 12 >> 2] | 0, HEAP32[i62 + 8 >> 2] | 0) | 0; else {
   i8 = HEAP32[i62 + 40 >> 2] | 0;
   i7 = 0;
   i9 = 1;
   do {
    i9 = Math_imul(HEAP32[i8 + (i7 << 2) >> 2] | 0, i9) | 0;
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i5 | 0));
  }
  if ((i9 | 0) != 0 & (i5 | 0) < 2) {
   STACKTOP = i70;
   return;
  }
 }
 __ZNK2cv8FileNodeixEPKc(i6, i58, 170072);
 __ZN2cv4readERKNS_8FileNodeERdd(i6, i69, 0.0);
 d10 = +HEAPF64[i69 >> 3];
 __ZNK2cv8FileNodeixEPKc(i4, i58, 170080);
 __ZN2cv4readERKNS_8FileNodeERdd(i4, i69, 0.0);
 d11 = +HEAPF64[i69 >> 3];
 if ((i1 | 0) == 1) {
  d71 = +Math_abs(+d10);
  d72 = +Math_abs(+d11);
  d12 = (d71 < d72 ? d72 : d71) * d12;
 }
 HEAP32[i3 >> 2] = 32088;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 16842752;
 HEAP32[i3 + 8 >> 2] = i62;
 __ZN2cv9minMaxIdxERKNS_11_InputArrayEPdS3_PiS4_S2_(i3, i2, i13, 0, 0, __ZN2cv7noArrayEv() | 0);
 __ZN7testing8internal20DoubleNearPredFormatEPKcS2_S2_ddd(i14, 170144, 170160, 170176, d10, +HEAPF64[i2 >> 3], d12);
 i7 = i14 + 4 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i8 = (i9 | 0) == 0;
 if (!(HEAP8[i14 >> 0] | 0)) {
  do if (!i8) if (!(HEAP8[i9 >> 0] & 1)) {
   i2 = i9 + 1 | 0;
   break;
  } else {
   i2 = HEAP32[i9 + 8 >> 2] | 0;
   break;
  } else i2 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i18, 2, 170184, 355, i2);
  __ZN7testing7MessageC2Ev(i19);
  i2 = HEAP8[i68 >> 0] | 0;
  if (!(i2 & 1)) {
   i3 = i68 + 1 | 0;
   i2 = (i2 & 255) >>> 1;
  } else {
   i3 = HEAP32[i68 + 8 >> 2] | 0;
   i2 = HEAP32[i68 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i19 >> 2] | 0) + 8 | 0, i3, i2) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i19 >> 2] | 0) + 8 | 0, 170240, 29) | 0;
  i47 = (HEAP32[i19 >> 2] | 0) + 8 | 0;
  __ZNKSt3__18ios_base6getlocEv(i69, i47 + (HEAP32[(HEAP32[i47 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i46 = __ZNKSt3__16locale9use_facetERNS0_2idE(i69, 960728) | 0;
  i46 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i46 >> 2] | 0) + 28 >> 2] & 127](i46, 10) | 0;
  __ZNSt3__16localeD2Ev(i69);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i47, i46) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i47) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i18, i19);
  if (HEAP32[i19 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i21 = HEAP32[i19 >> 2] | 0, (i21 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i21 >> 2] | 0) + 4 >> 2] & 511](i21);
   HEAP32[i19 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i18);
  if (!(HEAP32[i7 >> 2] | 0)) {
   STACKTOP = i70;
   return;
  }
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i22 = HEAP32[i7 >> 2] | 0, (i22 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   __ZdlPv(i22);
  }
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i70;
  return;
 }
 if (!i8) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i15 = HEAP32[i7 >> 2] | 0, (i15 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
   __ZdlPv(i15);
  }
  HEAP32[i7 >> 2] = 0;
 }
 __ZN7testing8internal20DoubleNearPredFormatEPKcS2_S2_ddd(i16, 170272, 170288, 170176, d11, +HEAPF64[i13 >> 3], d12);
 i7 = i16 + 4 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i8 = (i9 | 0) == 0;
 if (!(HEAP8[i16 >> 0] | 0)) {
  do if (!i8) if (!(HEAP8[i9 >> 0] & 1)) {
   i1 = i9 + 1 | 0;
   break;
  } else {
   i1 = HEAP32[i9 + 8 >> 2] | 0;
   break;
  } else i1 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i24, 2, 170184, 357, i1);
  __ZN7testing7MessageC2Ev(i25);
  i2 = HEAP8[i68 >> 0] | 0;
  if (!(i2 & 1)) {
   i3 = i68 + 1 | 0;
   i1 = (i2 & 255) >>> 1;
  } else {
   i3 = HEAP32[i68 + 8 >> 2] | 0;
   i1 = HEAP32[i68 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i25 >> 2] | 0) + 8 | 0, i3, i1) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i25 >> 2] | 0) + 8 | 0, 170304, 29) | 0;
  i47 = (HEAP32[i25 >> 2] | 0) + 8 | 0;
  __ZNKSt3__18ios_base6getlocEv(i69, i47 + (HEAP32[(HEAP32[i47 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i46 = __ZNKSt3__16locale9use_facetERNS0_2idE(i69, 960728) | 0;
  i46 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i46 >> 2] | 0) + 28 >> 2] & 127](i46, 10) | 0;
  __ZNSt3__16localeD2Ev(i69);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i47, i46) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i47) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i24, i25);
  if (HEAP32[i25 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i27 = HEAP32[i25 >> 2] | 0, (i27 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i27 >> 2] | 0) + 4 >> 2] & 511](i27);
   HEAP32[i25 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i24);
  if (!(HEAP32[i7 >> 2] | 0)) {
   STACKTOP = i70;
   return;
  }
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i28 = HEAP32[i7 >> 2] | 0, (i28 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i28);
   __ZdlPv(i28);
  }
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i70;
  return;
 }
 if (!i8) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i17 = HEAP32[i7 >> 2] | 0, (i17 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
   __ZdlPv(i17);
  }
  HEAP32[i7 >> 2] = 0;
 }
 __ZNK2cv8FileNodeixEPKc(i37, i58, 170088);
 i6 = i62 + 40 | 0;
 i28 = HEAP32[i6 >> 2] | 0;
 d10 = +__ZN4perf10Regression7getElemERN2cv3MatEiii(i62, (HEAP32[i28 >> 2] | 0) + -1 | 0, (HEAP32[i28 + 4 >> 2] | 0) + -1 | 0, (HEAP32[i62 >> 2] | 0) >>> 3 & 511);
 __ZNK2cv8FileNodeixEPKc(i23, i37, 170096);
 __ZN2cv4readERKNS_8FileNodeERii(i23, i69, 0);
 i28 = (HEAP32[i69 >> 2] | 0) + 1 | 0;
 HEAP32[i26 >> 2] = i28;
 __ZNK2cv8FileNodeixEPKc(i20, i37, 170104);
 __ZN2cv4readERKNS_8FileNodeERii(i20, i69, 0);
 i7 = (HEAP32[i69 >> 2] | 0) + 1 | 0;
 HEAP32[i32 >> 2] = i7;
 i9 = (HEAP32[i6 >> 2] | 0) + 4 | 0;
 if ((i28 | 0) == (HEAP32[i9 >> 2] | 0)) __ZN7testing16AssertionSuccessEv(i29); else {
  __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i69, i26);
  __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i30, i9);
  __ZN7testing8internal9EqFailureEPKcS2_RKNSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEESB_b(i29, 170336, 170352, i69, i30, 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i30);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i69);
 }
 i5 = i29 + 4 | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = (i9 | 0) == 0;
 if (!(HEAP8[i29 >> 0] | 0)) {
  do if (!i8) if (!(HEAP8[i9 >> 0] & 1)) {
   i1 = i9 + 1 | 0;
   break;
  } else {
   i1 = HEAP32[i9 + 8 >> 2] | 0;
   break;
  } else i1 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i33, 2, 170184, 364, i1);
  __ZN7testing7MessageC2Ev(i34);
  i2 = HEAP8[i68 >> 0] | 0;
  if (!(i2 & 1)) {
   i3 = i68 + 1 | 0;
   i1 = (i2 & 255) >>> 1;
  } else {
   i3 = HEAP32[i68 + 8 >> 2] | 0;
   i1 = HEAP32[i68 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i34 >> 2] | 0) + 8 | 0, i3, i1) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i34 >> 2] | 0) + 8 | 0, 170376, 33) | 0;
  i47 = (HEAP32[i34 >> 2] | 0) + 8 | 0;
  __ZNKSt3__18ios_base6getlocEv(i69, i47 + (HEAP32[(HEAP32[i47 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i46 = __ZNKSt3__16locale9use_facetERNS0_2idE(i69, 960728) | 0;
  i46 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i46 >> 2] | 0) + 28 >> 2] & 127](i46, 10) | 0;
  __ZNSt3__16localeD2Ev(i69);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i47, i46) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i47) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i33, i34);
  if (HEAP32[i34 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i38 = HEAP32[i34 >> 2] | 0, (i38 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i38 >> 2] | 0) + 4 >> 2] & 511](i38);
   HEAP32[i34 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i33);
  if (!(HEAP32[i5 >> 2] | 0)) {
   STACKTOP = i70;
   return;
  }
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i40 = HEAP32[i5 >> 2] | 0, (i40 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i40);
   __ZdlPv(i40);
  }
  HEAP32[i5 >> 2] = 0;
  STACKTOP = i70;
  return;
 }
 if (!i8) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i31 = HEAP32[i5 >> 2] | 0, (i31 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i31);
   __ZdlPv(i31);
  }
  HEAP32[i5 >> 2] = 0;
 }
 i9 = HEAP32[i6 >> 2] | 0;
 if ((i7 | 0) == (HEAP32[i9 >> 2] | 0)) __ZN7testing16AssertionSuccessEv(i36); else {
  __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i69, i32);
  __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i30, i9);
  __ZN7testing8internal9EqFailureEPKcS2_RKNSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEESB_b(i36, 170416, 170432, i69, i30, 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i30);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i69);
 }
 i7 = i36 + 4 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i8 = (i9 | 0) == 0;
 if (!(HEAP8[i36 >> 0] | 0)) {
  do if (!i8) if (!(HEAP8[i9 >> 0] & 1)) {
   i1 = i9 + 1 | 0;
   break;
  } else {
   i1 = HEAP32[i9 + 8 >> 2] | 0;
   break;
  } else i1 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i43, 2, 170184, 366, i1);
  __ZN7testing7MessageC2Ev(i44);
  i2 = HEAP8[i68 >> 0] | 0;
  if (!(i2 & 1)) {
   i3 = i68 + 1 | 0;
   i1 = (i2 & 255) >>> 1;
  } else {
   i3 = HEAP32[i68 + 8 >> 2] | 0;
   i1 = HEAP32[i68 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i44 >> 2] | 0) + 8 | 0, i3, i1) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i44 >> 2] | 0) + 8 | 0, 170456, 30) | 0;
  i47 = (HEAP32[i44 >> 2] | 0) + 8 | 0;
  __ZNKSt3__18ios_base6getlocEv(i69, i47 + (HEAP32[(HEAP32[i47 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i46 = __ZNKSt3__16locale9use_facetERNS0_2idE(i69, 960728) | 0;
  i46 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i46 >> 2] | 0) + 28 >> 2] & 127](i46, 10) | 0;
  __ZNSt3__16localeD2Ev(i69);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i47, i46) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i47) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i43, i44);
  if (HEAP32[i44 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i48 = HEAP32[i44 >> 2] | 0, (i48 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i48 >> 2] | 0) + 4 >> 2] & 511](i48);
   HEAP32[i44 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i43);
  if (!(HEAP32[i7 >> 2] | 0)) {
   STACKTOP = i70;
   return;
  }
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i49 = HEAP32[i7 >> 2] | 0, (i49 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i49);
   __ZdlPv(i49);
  }
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i70;
  return;
 }
 if (!i8) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i39 = HEAP32[i7 >> 2] | 0, (i39 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i39);
   __ZdlPv(i39);
  }
  HEAP32[i7 >> 2] = 0;
 }
 __ZNK2cv8FileNodeixEPKc(i35, i37, 170112);
 __ZN2cv4readERKNS_8FileNodeERdd(i35, i69, 0.0);
 __ZN7testing8internal20DoubleNearPredFormatEPKcS2_S2_ddd(i42, 170488, 170504, 170176, +HEAPF64[i69 >> 3], d10, d12);
 i9 = i42 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i6 = (i7 | 0) == 0;
 if (!(HEAP8[i42 >> 0] | 0)) {
  do if (!i6) if (!(HEAP8[i7 >> 0] & 1)) {
   i1 = i7 + 1 | 0;
   break;
  } else {
   i1 = HEAP32[i7 + 8 >> 2] | 0;
   break;
  } else i1 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i52, 2, 170184, 370, i1);
  __ZN7testing7MessageC2Ev(i53);
  i1 = HEAP8[i68 >> 0] | 0;
  if (!(i1 & 1)) {
   i2 = i68 + 1 | 0;
   i1 = (i1 & 255) >>> 1;
  } else {
   i2 = HEAP32[i68 + 8 >> 2] | 0;
   i1 = HEAP32[i68 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i53 >> 2] | 0) + 8 | 0, i2, i1) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i53 >> 2] | 0) + 8 | 0, 170520, 41) | 0;
  i47 = (HEAP32[i53 >> 2] | 0) + 8 | 0;
  __ZNKSt3__18ios_base6getlocEv(i69, i47 + (HEAP32[(HEAP32[i47 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i46 = __ZNKSt3__16locale9use_facetERNS0_2idE(i69, 960728) | 0;
  i46 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i46 >> 2] | 0) + 28 >> 2] & 127](i46, 10) | 0;
  __ZNSt3__16localeD2Ev(i69);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i47, i46) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i47) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i52, i53);
  if (HEAP32[i53 >> 2] | 0) {
   do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
    i1 = HEAP32[i53 >> 2] | 0;
    if (!i1) break;
    FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
   } while (0);
   HEAP32[i53 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i52);
  if (!(HEAP32[i9 >> 2] | 0)) {
   STACKTOP = i70;
   return;
  }
  do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
   __ZdlPv(i1);
  } while (0);
  HEAP32[i9 >> 2] = 0;
  STACKTOP = i70;
  return;
 }
 if (!i6) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i46 = HEAP32[i9 >> 2] | 0, (i46 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i46);
   __ZdlPv(i46);
  }
  HEAP32[i9 >> 2] = 0;
 }
 __ZNK2cv8FileNodeixEPKc(i51, i58, 170120);
 __ZNK2cv8FileNodeixEPKc(i41, i51, 170096);
 __ZN2cv4readERKNS_8FileNodeERii(i41, i69, 0);
 i9 = HEAP32[i69 >> 2] | 0;
 __ZNK2cv8FileNodeixEPKc(i45, i51, 170104);
 __ZN2cv4readERKNS_8FileNodeERii(i45, i69, 0);
 i8 = HEAP32[i69 >> 2] | 0;
 __ZNK2cv8FileNodeixEPKc(i47, i51, 170128);
 __ZN2cv4readERKNS_8FileNodeERii(i47, i69, 0);
 i5 = HEAP32[i69 >> 2] | 0;
 __ZNK2cv8FileNodeixEPKc(i50, i51, 170112);
 __ZN2cv4readERKNS_8FileNodeERdd(i50, i69, 0.0);
 d10 = +HEAPF64[i69 >> 3];
 __ZN7testing8internal20DoubleNearPredFormatEPKcS2_S2_ddd(i55, 170568, 170584, 170176, d10, +__ZN4perf10Regression7getElemERN2cv3MatEiii(i62, i8, i9, i5), d12);
 i4 = i55 + 4 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i6 = (i7 | 0) == 0;
 if (!(HEAP8[i55 >> 0] | 0)) {
  do if (!i6) if (!(HEAP8[i7 >> 0] & 1)) {
   i2 = i7 + 1 | 0;
   break;
  } else {
   i2 = HEAP32[i7 + 8 >> 2] | 0;
   break;
  } else i2 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i64, 2, 170184, 383, i2);
  __ZN7testing7MessageC2Ev(i65);
  i3 = HEAP8[i68 >> 0] | 0;
  if (!(i3 & 1)) {
   i1 = i68 + 1 | 0;
   i2 = (i3 & 255) >>> 1;
  } else {
   i1 = HEAP32[i68 + 8 >> 2] | 0;
   i2 = HEAP32[i68 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i65 >> 2] | 0) + 8 | 0, i1, i2) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i65 >> 2] | 0) + 8 | 0, 170600, 30) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i65 >> 2] | 0) + 8 | 0, i9) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i65 >> 2] | 0) + 8 | 0, 170632, 1) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i65 >> 2] | 0) + 8 | 0, i8) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i65 >> 2] | 0) + 8 | 0, 170632, 1) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i65 >> 2] | 0) + 8 | 0, i5) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i65 >> 2] | 0) + 8 | 0, 170640, 9) | 0;
  i47 = (HEAP32[i65 >> 2] | 0) + 8 | 0;
  __ZNKSt3__18ios_base6getlocEv(i69, i47 + (HEAP32[(HEAP32[i47 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i46 = __ZNKSt3__16locale9use_facetERNS0_2idE(i69, 960728) | 0;
  i46 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i46 >> 2] | 0) + 28 >> 2] & 127](i46, 10) | 0;
  __ZNSt3__16localeD2Ev(i69);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i47, i46) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i47) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i64, i65);
  if (HEAP32[i65 >> 2] | 0) {
   do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
    i1 = HEAP32[i65 >> 2] | 0;
    if (!i1) break;
    FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
   } while (0);
   HEAP32[i65 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i64);
  if (!(HEAP32[i4 >> 2] | 0)) {
   STACKTOP = i70;
   return;
  }
  do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) break;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
   __ZdlPv(i1);
  } while (0);
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i70;
  return;
 }
 if (!i6) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i57 = HEAP32[i4 >> 2] | 0, (i57 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i57);
   __ZdlPv(i57);
  }
  HEAP32[i4 >> 2] = 0;
 }
 __ZNK2cv8FileNodeixEPKc(i61, i58, 170136);
 __ZNK2cv8FileNodeixEPKc(i54, i61, 170096);
 __ZN2cv4readERKNS_8FileNodeERii(i54, i69, 0);
 i7 = HEAP32[i69 >> 2] | 0;
 __ZNK2cv8FileNodeixEPKc(i56, i61, 170104);
 __ZN2cv4readERKNS_8FileNodeERii(i56, i69, 0);
 i6 = HEAP32[i69 >> 2] | 0;
 __ZNK2cv8FileNodeixEPKc(i59, i61, 170128);
 __ZN2cv4readERKNS_8FileNodeERii(i59, i69, 0);
 i5 = HEAP32[i69 >> 2] | 0;
 __ZNK2cv8FileNodeixEPKc(i60, i61, 170112);
 __ZN2cv4readERKNS_8FileNodeERdd(i60, i69, 0.0);
 d10 = +HEAPF64[i69 >> 3];
 __ZN7testing8internal20DoubleNearPredFormatEPKcS2_S2_ddd(i63, 170656, 170672, 170176, d10, +__ZN4perf10Regression7getElemERN2cv3MatEiii(i62, i6, i7, i5), d12);
 i4 = i63 + 4 | 0;
 if (!(HEAP8[i63 >> 0] | 0)) {
  i2 = HEAP32[i4 >> 2] | 0;
  do if (i2) if (!(HEAP8[i2 >> 0] & 1)) {
   i2 = i2 + 1 | 0;
   break;
  } else {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   break;
  } else i2 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i66, 2, 170184, 394, i2);
  __ZN7testing7MessageC2Ev(i67);
  i3 = HEAP8[i68 >> 0] | 0;
  if (!(i3 & 1)) {
   i1 = i68 + 1 | 0;
   i2 = (i3 & 255) >>> 1;
  } else {
   i1 = HEAP32[i68 + 8 >> 2] | 0;
   i2 = HEAP32[i68 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i67 >> 2] | 0) + 8 | 0, i1, i2) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i67 >> 2] | 0) + 8 | 0, 170600, 30) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i67 >> 2] | 0) + 8 | 0, i7) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i67 >> 2] | 0) + 8 | 0, 170632, 1) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i67 >> 2] | 0) + 8 | 0, i6) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i67 >> 2] | 0) + 8 | 0, 170632, 1) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i67 >> 2] | 0) + 8 | 0, i5) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i67 >> 2] | 0) + 8 | 0, 170640, 9) | 0;
  i47 = (HEAP32[i67 >> 2] | 0) + 8 | 0;
  __ZNKSt3__18ios_base6getlocEv(i69, i47 + (HEAP32[(HEAP32[i47 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i46 = __ZNKSt3__16locale9use_facetERNS0_2idE(i69, 960728) | 0;
  i46 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i46 >> 2] | 0) + 28 >> 2] & 127](i46, 10) | 0;
  __ZNSt3__16localeD2Ev(i69);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i47, i46) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i47) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i66, i67);
  if (HEAP32[i67 >> 2] | 0) {
   do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
    i1 = HEAP32[i67 >> 2] | 0;
    if (!i1) break;
    FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
   } while (0);
   HEAP32[i67 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i66);
 }
 if (!(HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i70;
  return;
 }
 do if (__ZN7testing8internal6IsTrueEb(1) | 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) break;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
  __ZdlPv(i1);
 } while (0);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i70;
 return;
}

function ___floatscan(i24, i3, i21) {
 i24 = i24 | 0;
 i3 = i3 | 0;
 i21 = i21 | 0;
 var d1 = 0.0, i2 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, d32 = 0.0, d33 = 0.0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 i27 = i31;
 if (!i3) {
  i30 = 24;
  i28 = -149;
 } else if ((i3 | 0) == 1) {
  i30 = 53;
  i28 = -1074;
 } else if ((i3 | 0) == 2) {
  i30 = 53;
  i28 = -1074;
 } else {
  d1 = 0.0;
  STACKTOP = i31;
  return +d1;
 }
 i23 = i24 + 4 | 0;
 i22 = i24 + 100 | 0;
 do {
  i5 = HEAP32[i23 >> 2] | 0;
  if (i5 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
   HEAP32[i23 >> 2] = i5 + 1;
   i5 = HEAPU8[i5 >> 0] | 0;
  } else i5 = ___shgetc(i24) | 0;
 } while ((_isspace(i5) | 0) != 0);
 do if ((i5 | 0) == 43 | (i5 | 0) == 45) {
  i3 = 1 - (((i5 | 0) == 45 & 1) << 1) | 0;
  i5 = HEAP32[i23 >> 2] | 0;
  if (i5 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
   HEAP32[i23 >> 2] = i5 + 1;
   i5 = HEAPU8[i5 >> 0] | 0;
   i29 = i3;
   break;
  } else {
   i5 = ___shgetc(i24) | 0;
   i29 = i3;
   break;
  }
 } else i29 = 1; while (0);
 i2 = 0;
 do {
  if ((i5 | 32 | 0) != (HEAP8[970912 + i2 >> 0] | 0)) break;
  do if (i2 >>> 0 < 7) {
   i5 = HEAP32[i23 >> 2] | 0;
   if (i5 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
    HEAP32[i23 >> 2] = i5 + 1;
    i5 = HEAPU8[i5 >> 0] | 0;
    break;
   } else {
    i5 = ___shgetc(i24) | 0;
    break;
   }
  } while (0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < 8);
 do if ((i2 | 0) == 3) i20 = 23; else if ((i2 | 0) != 8) {
  i12 = (i21 | 0) != 0;
  if (i2 >>> 0 > 3 & i12) if ((i2 | 0) == 8) break; else {
   i20 = 23;
   break;
  }
  L34 : do if (!i2) {
   i2 = 0;
   do {
    if ((i5 | 32 | 0) != (HEAP8[970928 + i2 >> 0] | 0)) break L34;
    do if (i2 >>> 0 < 2) {
     i6 = HEAP32[i23 >> 2] | 0;
     if (i6 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
      HEAP32[i23 >> 2] = i6 + 1;
      i5 = HEAPU8[i6 >> 0] | 0;
      break;
     } else {
      i5 = ___shgetc(i24) | 0;
      break;
     }
    } while (0);
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < 3);
  } while (0);
  if ((i2 | 0) == 3) {
   i3 = HEAP32[i23 >> 2] | 0;
   if (i3 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
    HEAP32[i23 >> 2] = i3 + 1;
    i3 = HEAPU8[i3 >> 0] | 0;
   } else i3 = ___shgetc(i24) | 0;
   if ((i3 | 0) == 40) i2 = 1; else {
    if (!(HEAP32[i22 >> 2] | 0)) {
     d1 = nan;
     STACKTOP = i31;
     return +d1;
    }
    HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
    d1 = nan;
    STACKTOP = i31;
    return +d1;
   }
   while (1) {
    i3 = HEAP32[i23 >> 2] | 0;
    if (i3 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
     HEAP32[i23 >> 2] = i3 + 1;
     i3 = HEAPU8[i3 >> 0] | 0;
    } else i3 = ___shgetc(i24) | 0;
    if (!((i3 + -48 | 0) >>> 0 < 10 | (i3 + -65 | 0) >>> 0 < 26) ? !((i3 + -97 | 0) >>> 0 < 26 | (i3 | 0) == 95) : 0) break;
    i2 = i2 + 1 | 0;
   }
   if ((i3 | 0) == 41) {
    d1 = nan;
    STACKTOP = i31;
    return +d1;
   }
   i3 = (HEAP32[i22 >> 2] | 0) == 0;
   if (!i3) HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
   if (!i12) {
    HEAP32[(___errno_location() | 0) >> 2] = 22;
    ___shlim(i24, 0);
    d1 = 0.0;
    STACKTOP = i31;
    return +d1;
   }
   if ((i2 | 0) == 0 | i3) {
    d1 = nan;
    STACKTOP = i31;
    return +d1;
   }
   do {
    i2 = i2 + -1 | 0;
    HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
   } while ((i2 | 0) != 0);
   d1 = nan;
   STACKTOP = i31;
   return +d1;
  } else if (!i2) {
   do if ((i5 | 0) == 48) {
    i5 = HEAP32[i23 >> 2] | 0;
    if (i5 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
     HEAP32[i23 >> 2] = i5 + 1;
     i5 = HEAPU8[i5 >> 0] | 0;
    } else i5 = ___shgetc(i24) | 0;
    if ((i5 | 32 | 0) != 120) {
     if (!(HEAP32[i22 >> 2] | 0)) {
      i5 = 48;
      break;
     }
     HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
     i5 = 48;
     break;
    }
    i5 = HEAP32[i23 >> 2] | 0;
    if (i5 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
     HEAP32[i23 >> 2] = i5 + 1;
     i7 = HEAPU8[i5 >> 0] | 0;
     i10 = 0;
    } else {
     i7 = ___shgetc(i24) | 0;
     i10 = 0;
    }
    while (1) {
     if ((i7 | 0) == 46) {
      i20 = 70;
      break;
     } else if ((i7 | 0) != 48) {
      i15 = 0;
      i5 = 0;
      i6 = 0;
      i3 = 0;
      i16 = 0;
      i17 = 0;
      d8 = 1.0;
      i2 = 0;
      d1 = 0.0;
      break;
     }
     i5 = HEAP32[i23 >> 2] | 0;
     if (i5 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
      HEAP32[i23 >> 2] = i5 + 1;
      i7 = HEAPU8[i5 >> 0] | 0;
      i10 = 1;
      continue;
     } else {
      i7 = ___shgetc(i24) | 0;
      i10 = 1;
      continue;
     }
    }
    if ((i20 | 0) == 70) {
     i5 = HEAP32[i23 >> 2] | 0;
     if (i5 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
      HEAP32[i23 >> 2] = i5 + 1;
      i7 = HEAPU8[i5 >> 0] | 0;
     } else i7 = ___shgetc(i24) | 0;
     if ((i7 | 0) == 48) {
      i6 = 0;
      i3 = 0;
      do {
       i5 = HEAP32[i23 >> 2] | 0;
       if (i5 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
        HEAP32[i23 >> 2] = i5 + 1;
        i7 = HEAPU8[i5 >> 0] | 0;
       } else i7 = ___shgetc(i24) | 0;
       i6 = _i64Add(i6 | 0, i3 | 0, -1, -1) | 0;
       i3 = tempRet0;
      } while ((i7 | 0) == 48);
      i15 = 0;
      i5 = 0;
      i10 = 1;
      i16 = 1;
      i17 = 0;
      d8 = 1.0;
      i2 = 0;
      d1 = 0.0;
     } else {
      i15 = 0;
      i5 = 0;
      i6 = 0;
      i3 = 0;
      i16 = 1;
      i17 = 0;
      d8 = 1.0;
      i2 = 0;
      d1 = 0.0;
     }
    }
    L114 : while (1) {
     i11 = i7 + -48 | 0;
     do if (i11 >>> 0 >= 10) {
      i9 = i7 | 32;
      i12 = (i7 | 0) == 46;
      if (!((i9 + -97 | 0) >>> 0 < 6 | i12)) break L114;
      if (i12) if (!i16) {
       i6 = i5;
       i3 = i15;
       i16 = 1;
       d13 = d8;
       break;
      } else {
       i7 = 46;
       break L114;
      } else {
       i11 = (i7 | 0) > 57 ? i9 + -87 | 0 : i11;
       i20 = 83;
       break;
      }
     } else i20 = 83; while (0);
     if ((i20 | 0) == 83) {
      i20 = 0;
      do if (!((i15 | 0) < 0 | (i15 | 0) == 0 & i5 >>> 0 < 8)) {
       if ((i15 | 0) < 0 | (i15 | 0) == 0 & i5 >>> 0 < 14) {
        d4 = d8 * .0625;
        i12 = i17;
        d13 = d4;
        d1 = d1 + d4 * +(i11 | 0);
        break;
       }
       if ((i11 | 0) == 0 | (i17 | 0) != 0) {
        i12 = i17;
        d13 = d8;
       } else {
        i12 = 1;
        d13 = d8;
        d1 = d1 + d8 * .5;
       }
      } else {
       i12 = i17;
       d13 = d8;
       i2 = i11 + (i2 << 4) | 0;
      } while (0);
      i5 = _i64Add(i5 | 0, i15 | 0, 1, 0) | 0;
      i15 = tempRet0;
      i10 = 1;
      i17 = i12;
     }
     i12 = HEAP32[i23 >> 2] | 0;
     if (i12 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
      HEAP32[i23 >> 2] = i12 + 1;
      i7 = HEAPU8[i12 >> 0] | 0;
      d8 = d13;
      continue;
     } else {
      i7 = ___shgetc(i24) | 0;
      d8 = d13;
      continue;
     }
    }
    if (!i10) {
     i3 = (HEAP32[i22 >> 2] | 0) == 0;
     if (!i3) HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
     if (i21) {
      if (!i3 ? (i19 = HEAP32[i23 >> 2] | 0, HEAP32[i23 >> 2] = i19 + -1, (i16 | 0) != 0) : 0) HEAP32[i23 >> 2] = i19 + -2;
     } else ___shlim(i24, 0);
     d1 = +(i29 | 0) * 0.0;
     STACKTOP = i31;
     return +d1;
    }
    i12 = (i16 | 0) == 0;
    i11 = i12 ? i5 : i6;
    i12 = i12 ? i15 : i3;
    if ((i15 | 0) < 0 | (i15 | 0) == 0 & i5 >>> 0 < 8) {
     i6 = i15;
     do {
      i2 = i2 << 4;
      i5 = _i64Add(i5 | 0, i6 | 0, 1, 0) | 0;
      i6 = tempRet0;
     } while ((i6 | 0) < 0 | (i6 | 0) == 0 & i5 >>> 0 < 8);
    }
    do if ((i7 | 32 | 0) == 112) {
     i3 = _scanexp(i24, i21) | 0;
     i5 = tempRet0;
     if ((i3 | 0) == 0 & (i5 | 0) == -2147483648) if (!i21) {
      ___shlim(i24, 0);
      d1 = 0.0;
      STACKTOP = i31;
      return +d1;
     } else {
      if (!(HEAP32[i22 >> 2] | 0)) {
       i3 = 0;
       i5 = 0;
       break;
      }
      HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
      i3 = 0;
      i5 = 0;
      break;
     }
    } else if (!(HEAP32[i22 >> 2] | 0)) {
     i3 = 0;
     i5 = 0;
    } else {
     HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
     i3 = 0;
     i5 = 0;
    } while (0);
    i24 = _bitshift64Shl(i11 | 0, i12 | 0, 2) | 0;
    i24 = _i64Add(i24 | 0, tempRet0 | 0, -32, -1) | 0;
    i3 = _i64Add(i24 | 0, tempRet0 | 0, i3 | 0, i5 | 0) | 0;
    i5 = tempRet0;
    if (!i2) {
     d1 = +(i29 | 0) * 0.0;
     STACKTOP = i31;
     return +d1;
    }
    if ((i5 | 0) > 0 | (i5 | 0) == 0 & i3 >>> 0 > (0 - i28 | 0) >>> 0) {
     HEAP32[(___errno_location() | 0) >> 2] = 34;
     d1 = +(i29 | 0) * 1797693134862315708145274.0e284 * 1797693134862315708145274.0e284;
     STACKTOP = i31;
     return +d1;
    }
    i24 = i28 + -106 | 0;
    i23 = ((i24 | 0) < 0) << 31 >> 31;
    if ((i5 | 0) < (i23 | 0) | (i5 | 0) == (i23 | 0) & i3 >>> 0 < i24 >>> 0) {
     HEAP32[(___errno_location() | 0) >> 2] = 34;
     d1 = +(i29 | 0) * 2.2250738585072014e-308 * 2.2250738585072014e-308;
     STACKTOP = i31;
     return +d1;
    }
    if ((i2 | 0) > -1) {
     do {
      i2 = i2 << 1;
      if (!(d1 >= .5)) d4 = d1; else {
       d4 = d1 + -1.0;
       i2 = i2 | 1;
      }
      d1 = d1 + d4;
      i3 = _i64Add(i3 | 0, i5 | 0, -1, -1) | 0;
      i5 = tempRet0;
     } while ((i2 | 0) > -1);
     i11 = i3;
     d8 = d1;
    } else {
     i11 = i3;
     d8 = d1;
    }
    i3 = _i64Subtract(32, 0, i28 | 0, ((i28 | 0) < 0) << 31 >> 31 | 0) | 0;
    i3 = _i64Add(i11 | 0, i5 | 0, i3 | 0, tempRet0 | 0) | 0;
    i24 = tempRet0;
    if (0 > (i24 | 0) | 0 == (i24 | 0) & i30 >>> 0 > i3 >>> 0) if ((i3 | 0) < 0) {
     i3 = 0;
     i20 = 126;
    } else i20 = 124; else {
     i3 = i30;
     i20 = 124;
    }
    if ((i20 | 0) == 124) if ((i3 | 0) < 53) i20 = 126; else {
     i5 = i3;
     d4 = +(i29 | 0);
     d1 = 0.0;
    }
    if ((i20 | 0) == 126) {
     d1 = +(i29 | 0);
     i5 = i3;
     d4 = d1;
     d1 = +_copysignl(+_scalbn(1.0, 84 - i3 | 0), d1);
    }
    i24 = (i5 | 0) < 32 & d8 != 0.0 & (i2 & 1 | 0) == 0;
    d1 = d4 * (i24 ? 0.0 : d8) + (d1 + d4 * +(((i24 & 1) + i2 | 0) >>> 0)) - d1;
    if (!(d1 != 0.0)) HEAP32[(___errno_location() | 0) >> 2] = 34;
    d1 = +_scalbnl(d1, i11);
    STACKTOP = i31;
    return +d1;
   } while (0);
   i25 = i28 + i30 | 0;
   i26 = 0 - i25 | 0;
   i10 = 0;
   while (1) {
    if ((i5 | 0) == 46) {
     i20 = 137;
     break;
    } else if ((i5 | 0) != 48) {
     i3 = 0;
     i7 = 0;
     i17 = 0;
     break;
    }
    i5 = HEAP32[i23 >> 2] | 0;
    if (i5 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
     HEAP32[i23 >> 2] = i5 + 1;
     i5 = HEAPU8[i5 >> 0] | 0;
     i10 = 1;
     continue;
    } else {
     i5 = ___shgetc(i24) | 0;
     i10 = 1;
     continue;
    }
   }
   if ((i20 | 0) == 137) {
    i5 = HEAP32[i23 >> 2] | 0;
    if (i5 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
     HEAP32[i23 >> 2] = i5 + 1;
     i5 = HEAPU8[i5 >> 0] | 0;
    } else i5 = ___shgetc(i24) | 0;
    if ((i5 | 0) == 48) {
     i3 = 0;
     i5 = 0;
     while (1) {
      i3 = _i64Add(i3 | 0, i5 | 0, -1, -1) | 0;
      i7 = tempRet0;
      i5 = HEAP32[i23 >> 2] | 0;
      if (i5 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
       HEAP32[i23 >> 2] = i5 + 1;
       i5 = HEAPU8[i5 >> 0] | 0;
      } else i5 = ___shgetc(i24) | 0;
      if ((i5 | 0) == 48) i5 = i7; else {
       i10 = 1;
       i17 = 1;
       break;
      }
     }
    } else {
     i3 = 0;
     i7 = 0;
     i17 = 1;
    }
   }
   HEAP32[i27 >> 2] = 0;
   i9 = i5 + -48 | 0;
   i11 = (i5 | 0) == 46;
   L216 : do if (i9 >>> 0 < 10 | i11) {
    i19 = i27 + 496 | 0;
    i15 = 0;
    i12 = 0;
    i16 = i11;
    i2 = i3;
    i18 = 0;
    i3 = 0;
    i11 = 0;
    L218 : while (1) {
     do if (i16) if (!i17) {
      i2 = i15;
      i7 = i12;
      i17 = 1;
     } else break L218; else {
      i16 = _i64Add(i15 | 0, i12 | 0, 1, 0) | 0;
      i6 = tempRet0;
      i14 = (i5 | 0) != 48;
      if ((i3 | 0) >= 125) {
       if (!i14) {
        i15 = i16;
        i12 = i6;
        break;
       }
       HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 1;
       i15 = i16;
       i12 = i6;
       break;
      }
      i12 = i27 + (i3 << 2) | 0;
      if (i18) i9 = i5 + -48 + ((HEAP32[i12 >> 2] | 0) * 10 | 0) | 0;
      HEAP32[i12 >> 2] = i9;
      i18 = i18 + 1 | 0;
      i20 = (i18 | 0) == 9;
      i15 = i16;
      i12 = i6;
      i10 = 1;
      i18 = i20 ? 0 : i18;
      i3 = (i20 & 1) + i3 | 0;
      i11 = i14 ? i16 : i11;
     } while (0);
     i9 = HEAP32[i23 >> 2] | 0;
     if (i9 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
      HEAP32[i23 >> 2] = i9 + 1;
      i5 = HEAPU8[i9 >> 0] | 0;
     } else i5 = ___shgetc(i24) | 0;
     i9 = i5 + -48 | 0;
     i16 = (i5 | 0) == 46;
     if (!(i9 >>> 0 < 10 | i16)) {
      i9 = i17;
      i20 = 160;
      break L216;
     }
    }
    i10 = (i10 | 0) != 0;
    i5 = i18;
    i20 = 168;
   } else {
    i2 = i3;
    i15 = 0;
    i12 = 0;
    i9 = i17;
    i18 = 0;
    i3 = 0;
    i11 = 0;
    i20 = 160;
   } while (0);
   do if ((i20 | 0) == 160) {
    i14 = (i9 | 0) == 0;
    i2 = i14 ? i15 : i2;
    i14 = i14 ? i12 : i7;
    i10 = (i10 | 0) != 0;
    if (!(i10 & (i5 | 32 | 0) == 101)) if ((i5 | 0) > -1) {
     i7 = i14;
     i5 = i18;
     i20 = 168;
     break;
    } else {
     i9 = i10;
     i10 = i2;
     i7 = i14;
     i5 = i18;
     i20 = 170;
     break;
    }
    i6 = _scanexp(i24, i21) | 0;
    i7 = tempRet0;
    do if ((i6 | 0) == 0 & (i7 | 0) == -2147483648) if (!i21) {
     ___shlim(i24, 0);
     d1 = 0.0;
     STACKTOP = i31;
     return +d1;
    } else {
     if (!(HEAP32[i22 >> 2] | 0)) {
      i6 = 0;
      i7 = 0;
      break;
     }
     HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
     i6 = 0;
     i7 = 0;
     break;
    } while (0);
    i19 = _i64Add(i6 | 0, i7 | 0, i2 | 0, i14 | 0) | 0;
    i7 = tempRet0;
    i5 = i18;
   } while (0);
   if ((i20 | 0) == 168) if (HEAP32[i22 >> 2] | 0) {
    HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
    if (i10) i19 = i2; else i20 = 171;
   } else {
    i9 = i10;
    i10 = i2;
    i20 = 170;
   }
   if ((i20 | 0) == 170) if (i9) i19 = i10; else i20 = 171;
   if ((i20 | 0) == 171) {
    HEAP32[(___errno_location() | 0) >> 2] = 22;
    ___shlim(i24, 0);
    d1 = 0.0;
    STACKTOP = i31;
    return +d1;
   }
   i6 = HEAP32[i27 >> 2] | 0;
   if (!i6) {
    d1 = +(i29 | 0) * 0.0;
    STACKTOP = i31;
    return +d1;
   }
   if ((i19 | 0) == (i15 | 0) & (i7 | 0) == (i12 | 0) & ((i12 | 0) < 0 | (i12 | 0) == 0 & i15 >>> 0 < 10) ? i30 >>> 0 > 30 | (i6 >>> i30 | 0) == 0 : 0) {
    d1 = +(i29 | 0) * +(i6 >>> 0);
    STACKTOP = i31;
    return +d1;
   }
   i24 = (i28 | 0) / -2 | 0;
   i23 = ((i24 | 0) < 0) << 31 >> 31;
   if ((i7 | 0) > (i23 | 0) | (i7 | 0) == (i23 | 0) & i19 >>> 0 > i24 >>> 0) {
    HEAP32[(___errno_location() | 0) >> 2] = 34;
    d1 = +(i29 | 0) * 1797693134862315708145274.0e284 * 1797693134862315708145274.0e284;
    STACKTOP = i31;
    return +d1;
   }
   i24 = i28 + -106 | 0;
   i23 = ((i24 | 0) < 0) << 31 >> 31;
   if ((i7 | 0) < (i23 | 0) | (i7 | 0) == (i23 | 0) & i19 >>> 0 < i24 >>> 0) {
    HEAP32[(___errno_location() | 0) >> 2] = 34;
    d1 = +(i29 | 0) * 2.2250738585072014e-308 * 2.2250738585072014e-308;
    STACKTOP = i31;
    return +d1;
   }
   if (i5) {
    if ((i5 | 0) < 9) {
     i2 = i27 + (i3 << 2) | 0;
     i6 = HEAP32[i2 >> 2] | 0;
     do {
      i6 = i6 * 10 | 0;
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != 9);
     HEAP32[i2 >> 2] = i6;
    }
    i3 = i3 + 1 | 0;
   }
   if ((i11 | 0) < 9 ? (i11 | 0) <= (i19 | 0) & (i19 | 0) < 18 : 0) {
    if ((i19 | 0) == 9) {
     d1 = +(i29 | 0) * +((HEAP32[i27 >> 2] | 0) >>> 0);
     STACKTOP = i31;
     return +d1;
    }
    if ((i19 | 0) < 9) {
     d1 = +(i29 | 0) * +((HEAP32[i27 >> 2] | 0) >>> 0) / +(HEAP32[970944 + (8 - i19 << 2) >> 2] | 0);
     STACKTOP = i31;
     return +d1;
    }
    i24 = i30 + 27 + (Math_imul(i19, -3) | 0) | 0;
    i5 = HEAP32[i27 >> 2] | 0;
    if ((i24 | 0) > 30 | (i5 >>> i24 | 0) == 0) {
     d1 = +(i29 | 0) * +(i5 >>> 0) * +(HEAP32[970944 + (i19 + -10 << 2) >> 2] | 0);
     STACKTOP = i31;
     return +d1;
    }
   }
   i5 = (i19 | 0) % 9 | 0;
   if (!i5) {
    i5 = 0;
    i2 = 0;
   } else {
    i11 = (i19 | 0) > -1 ? i5 : i5 + 9 | 0;
    i7 = HEAP32[970944 + (8 - i11 << 2) >> 2] | 0;
    if (i3) {
     i2 = 1e9 / (i7 | 0) | 0;
     i5 = 0;
     i9 = 0;
     i10 = 0;
     i6 = i19;
     do {
      i22 = i27 + (i10 << 2) | 0;
      i23 = HEAP32[i22 >> 2] | 0;
      i24 = ((i23 >>> 0) / (i7 >>> 0) | 0) + i9 | 0;
      HEAP32[i22 >> 2] = i24;
      i9 = Math_imul((i23 >>> 0) % (i7 >>> 0) | 0, i2) | 0;
      i23 = i10;
      i10 = i10 + 1 | 0;
      if ((i23 | 0) == (i5 | 0) & (i24 | 0) == 0) {
       i5 = i10 & 127;
       i6 = i6 + -9 | 0;
      }
     } while ((i10 | 0) != (i3 | 0));
     if (i9) {
      HEAP32[i27 + (i3 << 2) >> 2] = i9;
      i3 = i3 + 1 | 0;
     }
    } else {
     i5 = 0;
     i6 = i19;
     i3 = 0;
    }
    i2 = 0;
    i19 = 9 - i11 + i6 | 0;
   }
   L310 : while (1) {
    i12 = i27 + (i5 << 2) | 0;
    if ((i19 | 0) < 18) {
     do {
      i6 = 0;
      i7 = i3 + 127 | 0;
      while (1) {
       i11 = i7 & 127;
       i9 = i27 + (i11 << 2) | 0;
       i7 = _bitshift64Shl(HEAP32[i9 >> 2] | 0, 0, 29) | 0;
       i6 = _i64Add(i7 | 0, tempRet0 | 0, i6 | 0, 0) | 0;
       i7 = tempRet0;
       if (i7 >>> 0 > 0 | (i7 | 0) == 0 & i6 >>> 0 > 1e9) {
        i10 = ___udivdi3(i6 | 0, i7 | 0, 1e9, 0) | 0;
        i6 = ___uremdi3(i6 | 0, i7 | 0, 1e9, 0) | 0;
       } else i10 = 0;
       HEAP32[i9 >> 2] = i6;
       i7 = (i11 | 0) == (i5 | 0);
       if (!((i11 | 0) != (i3 + 127 & 127 | 0) | i7)) i3 = (i6 | 0) == 0 ? i11 : i3;
       if (i7) break; else {
        i6 = i10;
        i7 = i11 + -1 | 0;
       }
      }
      i2 = i2 + -29 | 0;
     } while ((i10 | 0) == 0);
     i7 = i10;
    } else {
     if ((i19 | 0) != 18) {
      i7 = i19;
      break;
     }
     while (1) {
      if ((HEAP32[i12 >> 2] | 0) >>> 0 >= 9007199) {
       i7 = 18;
       break L310;
      }
      i9 = 0;
      i7 = i3 + 127 | 0;
      while (1) {
       i11 = i7 & 127;
       i10 = i27 + (i11 << 2) | 0;
       i7 = _bitshift64Shl(HEAP32[i10 >> 2] | 0, 0, 29) | 0;
       i7 = _i64Add(i7 | 0, tempRet0 | 0, i9 | 0, 0) | 0;
       i6 = tempRet0;
       if (i6 >>> 0 > 0 | (i6 | 0) == 0 & i7 >>> 0 > 1e9) {
        i9 = ___udivdi3(i7 | 0, i6 | 0, 1e9, 0) | 0;
        i7 = ___uremdi3(i7 | 0, i6 | 0, 1e9, 0) | 0;
       } else i9 = 0;
       HEAP32[i10 >> 2] = i7;
       i6 = (i11 | 0) == (i5 | 0);
       if (!((i11 | 0) != (i3 + 127 & 127 | 0) | i6)) i3 = (i7 | 0) == 0 ? i11 : i3;
       if (i6) break; else i7 = i11 + -1 | 0;
      }
      i2 = i2 + -29 | 0;
      if (i9) {
       i7 = i9;
       break;
      }
     }
    }
    i5 = i5 + 127 & 127;
    if ((i5 | 0) == (i3 | 0)) {
     i24 = i3 + 127 & 127;
     i3 = i27 + ((i3 + 126 & 127) << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | HEAP32[i27 + (i24 << 2) >> 2];
     i3 = i24;
    }
    HEAP32[i27 + (i5 << 2) >> 2] = i7;
    i19 = i19 + 9 | 0;
   }
   L341 : while (1) {
    i17 = i3 + 1 & 127;
    i16 = i27 + ((i3 + 127 & 127) << 2) | 0;
    i14 = i7;
    while (1) {
     i12 = (i14 | 0) == 18;
     i15 = (i14 | 0) > 27 ? 9 : 1;
     i19 = i5;
     while (1) {
      i11 = 0;
      while (1) {
       i7 = i11 + i19 & 127;
       if ((i7 | 0) == (i3 | 0)) {
        i7 = 2;
        break;
       }
       i10 = HEAP32[i27 + (i7 << 2) >> 2] | 0;
       i9 = HEAP32[970936 + (i11 << 2) >> 2] | 0;
       if (i10 >>> 0 < i9 >>> 0) {
        i7 = 2;
        break;
       }
       i7 = i11 + 1 | 0;
       if (i10 >>> 0 > i9 >>> 0) {
        i7 = i11;
        break;
       }
       if ((i7 | 0) < 2) i11 = i7; else break;
      }
      if ((i7 | 0) == 2 & i12) break L341;
      i2 = i15 + i2 | 0;
      if ((i19 | 0) == (i3 | 0)) i19 = i3; else break;
     }
     i9 = (1 << i15) + -1 | 0;
     i6 = 1e9 >>> i15;
     i5 = i19;
     i11 = 0;
     i10 = i19;
     i7 = i14;
     do {
      i22 = i27 + (i10 << 2) | 0;
      i23 = HEAP32[i22 >> 2] | 0;
      i24 = (i23 >>> i15) + i11 | 0;
      HEAP32[i22 >> 2] = i24;
      i11 = Math_imul(i23 & i9, i6) | 0;
      i24 = (i10 | 0) == (i5 | 0) & (i24 | 0) == 0;
      i10 = i10 + 1 & 127;
      i7 = i24 ? i7 + -9 | 0 : i7;
      i5 = i24 ? i10 : i5;
     } while ((i10 | 0) != (i3 | 0));
     if (!i11) {
      i14 = i7;
      continue;
     }
     if ((i17 | 0) != (i5 | 0)) break;
     HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | 1;
     i14 = i7;
    }
    HEAP32[i27 + (i3 << 2) >> 2] = i11;
    i3 = i17;
   }
   i5 = i19 & 127;
   if ((i5 | 0) == (i3 | 0)) {
    HEAP32[i27 + (i17 + -1 << 2) >> 2] = 0;
    i3 = i17;
   }
   d4 = +((HEAP32[i27 + (i5 << 2) >> 2] | 0) >>> 0);
   i6 = i19 + 1 & 127;
   if ((i6 | 0) == (i3 | 0)) {
    i10 = i3 + 1 & 127;
    HEAP32[i27 + (i10 + -1 << 2) >> 2] = 0;
   } else i10 = i3;
   d13 = +(i29 | 0);
   d8 = d13 * (d4 * 1.0e9 + +((HEAP32[i27 + (i6 << 2) >> 2] | 0) >>> 0));
   i11 = i2 + 53 | 0;
   i12 = i11 - i28 | 0;
   if ((i12 | 0) < (i30 | 0)) if ((i12 | 0) < 0) {
    i5 = 0;
    i3 = 1;
    i20 = 244;
   } else {
    i5 = i12;
    i3 = 1;
    i20 = 243;
   } else {
    i5 = i30;
    i3 = 0;
    i20 = 243;
   }
   if ((i20 | 0) == 243) if ((i5 | 0) < 53) i20 = 244; else {
    d1 = 0.0;
    d4 = 0.0;
   }
   if ((i20 | 0) == 244) {
    d33 = +_copysignl(+_scalbn(1.0, 105 - i5 | 0), d8);
    d32 = +_fmodl(d8, +_scalbn(1.0, 53 - i5 | 0));
    d1 = d33;
    d4 = d32;
    d8 = d33 + (d8 - d32);
   }
   i7 = i19 + 2 & 127;
   do if ((i7 | 0) != (i10 | 0)) {
    i7 = HEAP32[i27 + (i7 << 2) >> 2] | 0;
    do if (i7 >>> 0 >= 5e8) {
     if (i7 >>> 0 > 5e8) {
      d4 = d13 * .75 + d4;
      break;
     }
     if ((i19 + 3 & 127 | 0) == (i10 | 0)) {
      d4 = d13 * .5 + d4;
      break;
     } else {
      d4 = d13 * .75 + d4;
      break;
     }
    } else {
     if ((i7 | 0) == 0 ? (i19 + 3 & 127 | 0) == (i10 | 0) : 0) break;
     d4 = d13 * .25 + d4;
    } while (0);
    if ((53 - i5 | 0) <= 1) break;
    if (+_fmodl(d4, 1.0) != 0.0) break;
    d4 = d4 + 1.0;
   } while (0);
   d1 = d8 + d4 - d1;
   do if ((i11 & 2147483647 | 0) > (-2 - i25 | 0)) {
    if (+Math_abs(+d1) >= 9007199254740992.0) {
     i3 = (i3 | 0) != 0 & (i5 | 0) == (i12 | 0) ? 0 : i3;
     i2 = i2 + 1 | 0;
     d1 = d1 * .5;
    }
    if ((i2 + 50 | 0) <= (i26 | 0) ? !((i3 | 0) != 0 & d4 != 0.0) : 0) break;
    HEAP32[(___errno_location() | 0) >> 2] = 34;
   } while (0);
   d1 = +_scalbnl(d1, i2);
   STACKTOP = i31;
   return +d1;
  } else {
   if (HEAP32[i22 >> 2] | 0) HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
   HEAP32[(___errno_location() | 0) >> 2] = 22;
   ___shlim(i24, 0);
   d1 = 0.0;
   STACKTOP = i31;
   return +d1;
  }
 } while (0);
 if ((i20 | 0) == 23) {
  i3 = (HEAP32[i22 >> 2] | 0) == 0;
  if (!i3) HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
  if (!(i2 >>> 0 < 4 | (i21 | 0) == 0 | i3)) do {
   HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
   i2 = i2 + -1 | 0;
  } while (i2 >>> 0 > 3);
 }
 d1 = +Math_fround(Math_fround(i29 | 0) * Math_fround(inf));
 STACKTOP = i31;
 return +d1;
}

function __ZN2cvL18GEMMSingleMul_64fcEPKNS_7ComplexIdEEjS3_jS3_jPS1_jNS_5Size_IiEES6_ddi(i17, i15, i40, i23, i35, i4, i34, i5, i1, i2, d47, d48, i11) {
 i17 = i17 | 0;
 i15 = i15 | 0;
 i40 = i40 | 0;
 i23 = i23 | 0;
 i35 = i35 | 0;
 i4 = i4 | 0;
 i34 = i34 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d47 = +d47;
 d48 = +d48;
 i11 = i11 | 0;
 var i3 = 0, d6 = 0.0, d7 = 0.0, i8 = 0, d9 = 0.0, d10 = 0.0, i12 = 0, d13 = 0.0, d14 = 0.0, i16 = 0, i18 = 0, i19 = 0, d20 = 0.0, d21 = 0.0, i22 = 0, i24 = 0, i25 = 0, d26 = 0.0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i49 = 0, i50 = 0, i51 = 0, d52 = 0.0, d53 = 0.0, d54 = 0.0;
 i51 = STACKTOP;
 STACKTOP = STACKTOP + 3488 | 0;
 i50 = i51 + 2320 | 0;
 i33 = i51 + 1160 | 0;
 i29 = i51;
 i8 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i46 = HEAP32[i2 >> 2] | 0;
 i44 = HEAP32[i2 + 4 >> 2] | 0;
 i49 = i50 + 8 | 0;
 i3 = i50 + 1160 | 0;
 i2 = i49;
 do {
  HEAP32[i2 + 0 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  i2 = i2 + 16 | 0;
 } while ((i2 | 0) != (i3 | 0));
 HEAP32[i50 >> 2] = i49;
 i45 = i50 + 4 | 0;
 HEAP32[i45 >> 2] = 72;
 i19 = i15 >>> 4;
 i39 = i23 >>> 4;
 i3 = i4 >>> 4;
 i42 = i5 >>> 4;
 if (!i35) {
  i43 = 0;
  i41 = 0;
 } else {
  i41 = (i11 & 4 | 0) == 0;
  i43 = i41 ? i3 : 1;
  i41 = i41 ? 1 : i3;
 }
 do if (i11 & 1) if (i15 >>> 0 > 31 & (i12 | 0) > 1) {
  if (i12 >>> 0 <= 72) {
   HEAP32[i45 >> 2] = i12;
   i36 = i49;
   i37 = 1;
   i38 = i19;
   i8 = i12;
   break;
  }
  i3 = __Znaj(i12 >>> 0 > 268435455 ? -1 : i12 << 4) | 0;
  i2 = i3 + (i12 << 4) | 0;
  i1 = i3;
  do {
   HEAP32[i1 + 0 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i2 | 0));
  HEAP32[i50 >> 2] = i3;
  HEAP32[i45 >> 2] = i12;
  i36 = i3;
  i37 = 1;
  i38 = i19;
  i8 = i12;
 } else {
  i36 = 0;
  i37 = 1;
  i38 = i19;
  i8 = i12;
 } else {
  i36 = 0;
  i37 = i19;
  i38 = 1;
 } while (0);
 L17 : do if ((i8 | 0) == 1) {
  i25 = i33 + 8 | 0;
  i3 = i33 + 1160 | 0;
  i2 = i25;
  do {
   HEAP32[i2 + 0 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   i2 = i2 + 16 | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i33 >> 2] = i25;
  i24 = i33 + 4 | 0;
  HEAP32[i24 >> 2] = 72;
  if (i15 >>> 0 > 31 & (i12 | 0) > 1) {
   if ((HEAP32[i45 >> 2] | 0) >>> 0 < i44 >>> 0) {
    i2 = HEAP32[i50 >> 2] | 0;
    if ((i2 | 0) != (i49 | 0)) {
     if (i2) __ZdaPv(i2);
     HEAP32[i50 >> 2] = i49;
     HEAP32[i45 >> 2] = 72;
    }
    if (i44 >>> 0 > 72) {
     i3 = __Znaj(i44 >>> 0 > 268435455 ? -1 : i44 << 4) | 0;
     i2 = i3 + (i44 << 4) | 0;
     i1 = i3;
     do {
      HEAP32[i1 + 0 >> 2] = 0;
      HEAP32[i1 + 4 >> 2] = 0;
      HEAP32[i1 + 8 >> 2] = 0;
      HEAP32[i1 + 12 >> 2] = 0;
      i1 = i1 + 16 | 0;
     } while ((i1 | 0) != (i2 | 0));
     HEAP32[i50 >> 2] = i3;
     HEAP32[i45 >> 2] = i44;
    } else i3 = i49;
   } else {
    HEAP32[i45 >> 2] = i44;
    i3 = HEAP32[i50 >> 2] | 0;
   }
   if ((i44 | 0) > 0) {
    i2 = 0;
    do {
     i30 = i3 + (i2 << 4) | 0;
     i29 = i17 + ((Math_imul(i2, i19) | 0) << 4) | 0;
     HEAP32[i30 + 0 >> 2] = HEAP32[i29 + 0 >> 2];
     HEAP32[i30 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
     HEAP32[i30 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
     HEAP32[i30 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i44 | 0));
    i22 = i3;
   } else i22 = i3;
  } else i22 = i17;
  if (i23 >>> 0 > 31) {
   if ((HEAP32[i24 >> 2] | 0) >>> 0 < i46 >>> 0) {
    i1 = HEAP32[i33 >> 2] | 0;
    if ((i1 | 0) != (i25 | 0)) {
     if (i1) __ZdaPv(i1);
     HEAP32[i33 >> 2] = i25;
     HEAP32[i24 >> 2] = 72;
    }
    if (i46 >>> 0 > 72) {
     i2 = __Znaj(i46 >>> 0 > 268435455 ? -1 : i46 << 4) | 0;
     i1 = i2 + (i46 << 4) | 0;
     i3 = i2;
     do {
      HEAP32[i3 + 0 >> 2] = 0;
      HEAP32[i3 + 4 >> 2] = 0;
      HEAP32[i3 + 8 >> 2] = 0;
      HEAP32[i3 + 12 >> 2] = 0;
      i3 = i3 + 16 | 0;
     } while ((i3 | 0) != (i1 | 0));
     HEAP32[i33 >> 2] = i2;
     HEAP32[i24 >> 2] = i46;
    } else i2 = i25;
   } else {
    HEAP32[i24 >> 2] = i46;
    i2 = HEAP32[i33 >> 2] | 0;
   }
   if ((i46 | 0) > 0) {
    i1 = 0;
    do {
     i30 = i2 + (i1 << 4) | 0;
     i29 = i40 + ((Math_imul(i1, i39) | 0) << 4) | 0;
     HEAP32[i30 + 0 >> 2] = HEAP32[i29 + 0 >> 2];
     HEAP32[i30 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
     HEAP32[i30 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
     HEAP32[i30 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i46 | 0));
   }
  } else i2 = i40;
  if ((i44 | 0) > 0) {
   i16 = i41 << 1;
   i17 = i46 + -2 | 0;
   i18 = (i17 | 0) < 0;
   i11 = i17 >>> 1;
   i19 = (i11 << 1) + 2 | 0;
   i12 = i34;
   i1 = i35;
   i15 = 0;
   i11 = i35 + (Math_imul(i41, (i11 << 5) + 32 | 0) | 0) | 0;
   while (1) {
    d13 = +HEAPF64[i22 + (i15 << 4) >> 3] * d47;
    d14 = +HEAPF64[i22 + (i15 << 4) + 8 >> 3] * d47;
    if (i18) {
     i4 = i1;
     i5 = 0;
    } else {
     i5 = i1;
     i3 = 0;
     while (1) {
      d26 = +HEAPF64[i2 + (i3 << 4) >> 3];
      d7 = +HEAPF64[i2 + (i3 << 4) + 8 >> 3];
      d10 = d13 * d26 - d14 * d7;
      d7 = d14 * d26 + d13 * d7;
      i8 = i3 | 1;
      d26 = +HEAPF64[i2 + (i8 << 4) >> 3];
      d9 = +HEAPF64[i2 + (i8 << 4) + 8 >> 3];
      d6 = d13 * d26 - d14 * d9;
      d9 = d14 * d26 + d13 * d9;
      i4 = i12 + (i3 << 4) | 0;
      if (!i5) {
       HEAPF64[i4 >> 3] = d10;
       HEAPF64[i12 + (i3 << 4) + 8 >> 3] = d7;
       HEAPF64[i12 + (i8 << 4) >> 3] = d6;
       HEAPF64[i12 + (i8 << 4) + 8 >> 3] = d9;
      } else {
       d26 = d7 + +HEAPF64[i5 + 8 >> 3] * d48;
       HEAPF64[i4 >> 3] = d10 + +HEAPF64[i5 >> 3] * d48;
       HEAPF64[i12 + (i3 << 4) + 8 >> 3] = d26;
       d26 = d9 + +HEAPF64[i5 + (i41 << 4) + 8 >> 3] * d48;
       HEAPF64[i12 + (i8 << 4) >> 3] = d6 + +HEAPF64[i5 + (i41 << 4) >> 3] * d48;
       HEAPF64[i12 + (i8 << 4) + 8 >> 3] = d26;
      }
      i3 = i3 + 2 | 0;
      if ((i3 | 0) > (i17 | 0)) {
       i4 = i11;
       i5 = i19;
       break;
      } else i5 = i5 + (i16 << 4) | 0;
     }
    }
    if ((i5 | 0) < (i46 | 0)) while (1) {
     d26 = +HEAPF64[i2 + (i5 << 4) >> 3];
     d7 = +HEAPF64[i2 + (i5 << 4) + 8 >> 3];
     d6 = d13 * d26 - d14 * d7;
     d7 = d14 * d26 + d13 * d7;
     i3 = i12 + (i5 << 4) | 0;
     if (!i4) {
      HEAPF64[i3 >> 3] = d6;
      HEAPF64[i12 + (i5 << 4) + 8 >> 3] = d7;
     } else {
      d26 = d7 + +HEAPF64[i4 + 8 >> 3] * d48;
      HEAPF64[i3 >> 3] = d6 + +HEAPF64[i4 >> 3] * d48;
      HEAPF64[i12 + (i5 << 4) + 8 >> 3] = d26;
     }
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i46 | 0)) break; else i4 = i4 + (i41 << 4) | 0;
    }
    i15 = i15 + 1 | 0;
    if ((i15 | 0) == (i44 | 0)) break; else {
     i12 = i12 + (i42 << 4) | 0;
     i1 = i1 + (i43 << 4) | 0;
     i11 = i11 + (i43 << 4) | 0;
    }
   }
  }
  i1 = HEAP32[i33 >> 2] | 0;
  if ((i1 | 0) != (i25 | 0)) {
   if (i1) __ZdaPv(i1);
   HEAP32[i33 >> 2] = i25;
   HEAP32[i24 >> 2] = 72;
  }
 } else {
  if (i11 & 2) {
   if ((i44 | 0) <= 0) break;
   i2 = (i36 | 0) == 0;
   i3 = i8 + -4 | 0;
   i27 = (i3 | 0) < 0;
   i4 = i8 & -4;
   i29 = i2 | (i8 | 0) < 1;
   i15 = (i46 | 0) > 0;
   i25 = i34;
   i1 = i35;
   i12 = 0;
   while (1) {
    if (i29) i22 = i2 ? i17 : i36; else {
     i5 = 0;
     do {
      i30 = i36 + (i5 << 4) | 0;
      i23 = i17 + ((Math_imul(i5, i38) | 0) << 4) | 0;
      HEAP32[i30 + 0 >> 2] = HEAP32[i23 + 0 >> 2];
      HEAP32[i30 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
      HEAP32[i30 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
      HEAP32[i30 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i8 | 0));
     i22 = i36;
    }
    if (i15) {
     i19 = i40;
     i18 = i1;
     i24 = 0;
     while (1) {
      if (i27) {
       d9 = 0.0;
       d10 = 0.0;
       d7 = 0.0;
       d13 = 0.0;
       d20 = 0.0;
       d6 = 0.0;
       d21 = 0.0;
       d14 = 0.0;
       i11 = 0;
      } else {
       d10 = 0.0;
       d9 = 0.0;
       d13 = 0.0;
       d7 = 0.0;
       d6 = 0.0;
       d20 = 0.0;
       d14 = 0.0;
       d21 = 0.0;
       i23 = 0;
       do {
        d52 = +HEAPF64[i22 + (i23 << 4) >> 3];
        d54 = +HEAPF64[i22 + (i23 << 4) + 8 >> 3];
        d53 = +HEAPF64[i19 + (i23 << 4) >> 3];
        d26 = +HEAPF64[i19 + (i23 << 4) + 8 >> 3];
        d10 = d10 + (d52 * d53 - d54 * d26);
        d9 = d9 + (d54 * d53 + d52 * d26);
        i30 = i23 | 1;
        d26 = +HEAPF64[i22 + (i30 << 4) >> 3];
        d52 = +HEAPF64[i22 + (i30 << 4) + 8 >> 3];
        d53 = +HEAPF64[i19 + (i30 << 4) >> 3];
        d54 = +HEAPF64[i19 + (i30 << 4) + 8 >> 3];
        d13 = d13 + (d26 * d53 - d52 * d54);
        d7 = d7 + (d52 * d53 + d26 * d54);
        i30 = i23 | 2;
        d54 = +HEAPF64[i22 + (i30 << 4) >> 3];
        d26 = +HEAPF64[i22 + (i30 << 4) + 8 >> 3];
        d53 = +HEAPF64[i19 + (i30 << 4) >> 3];
        d52 = +HEAPF64[i19 + (i30 << 4) + 8 >> 3];
        d6 = d6 + (d54 * d53 - d26 * d52);
        d20 = d20 + (d26 * d53 + d54 * d52);
        i30 = i23 | 3;
        d52 = +HEAPF64[i22 + (i30 << 4) >> 3];
        d54 = +HEAPF64[i22 + (i30 << 4) + 8 >> 3];
        d53 = +HEAPF64[i19 + (i30 << 4) >> 3];
        d26 = +HEAPF64[i19 + (i30 << 4) + 8 >> 3];
        d14 = d14 + (d52 * d53 - d54 * d26);
        d21 = d21 + (d54 * d53 + d52 * d26);
        i23 = i23 + 4 | 0;
       } while ((i23 | 0) <= (i3 | 0));
       i11 = i4;
      }
      if ((i11 | 0) < (i8 | 0)) do {
       d53 = +HEAPF64[i22 + (i11 << 4) >> 3];
       d54 = +HEAPF64[i22 + (i11 << 4) + 8 >> 3];
       d52 = +HEAPF64[i19 + (i11 << 4) >> 3];
       d26 = +HEAPF64[i19 + (i11 << 4) + 8 >> 3];
       d10 = d10 + (d53 * d52 - d54 * d26);
       d9 = d9 + (d54 * d52 + d53 * d26);
       i11 = i11 + 1 | 0;
      } while ((i11 | 0) != (i8 | 0));
      d10 = (d14 + (d6 + (d13 + d10))) * d47;
      d9 = (d21 + (d20 + (d7 + d9))) * d47;
      i5 = i25 + (i24 << 4) | 0;
      if (!i18) {
       HEAPF64[i5 >> 3] = d10;
       HEAPF64[i25 + (i24 << 4) + 8 >> 3] = d9;
      } else {
       d26 = d9 + +HEAPF64[i18 + 8 >> 3] * d48;
       HEAPF64[i5 >> 3] = d10 + +HEAPF64[i18 >> 3] * d48;
       HEAPF64[i25 + (i24 << 4) + 8 >> 3] = d26;
      }
      i24 = i24 + 1 | 0;
      if ((i24 | 0) == (i46 | 0)) break; else {
       i19 = i19 + (i39 << 4) | 0;
       i18 = i18 + (i41 << 4) | 0;
      }
     }
    }
    i12 = i12 + 1 | 0;
    if ((i12 | 0) == (i44 | 0)) break L17; else {
     i25 = i25 + (i42 << 4) | 0;
     i17 = i17 + (i37 << 4) | 0;
     i1 = i1 + (i43 << 4) | 0;
    }
   }
  }
  if (i46 << 4 >>> 0 < 1601) {
   if ((i44 | 0) <= 0) break;
   i2 = (i36 | 0) == 0;
   i27 = i46 + -4 | 0;
   i15 = (i27 | 0) < 0;
   i28 = (i8 | 0) > 0;
   i16 = i41 << 2;
   i30 = i41 << 1;
   i31 = i41 * 3 | 0;
   i24 = i27 >>> 2;
   i32 = (i24 << 2) + 4 | 0;
   i33 = i2 | i28 ^ 1;
   i25 = i34;
   i1 = i35;
   i12 = 0;
   i24 = i35 + (Math_imul(i41, (i24 << 6) + 64 | 0) | 0) | 0;
   while (1) {
    if (i33) i29 = i2 ? i17 : i36; else {
     i5 = 0;
     do {
      i29 = i36 + (i5 << 4) | 0;
      i23 = i17 + ((Math_imul(i5, i38) | 0) << 4) | 0;
      HEAP32[i29 + 0 >> 2] = HEAP32[i23 + 0 >> 2];
      HEAP32[i29 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
      HEAP32[i29 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
      HEAP32[i29 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i8 | 0));
     i29 = i36;
    }
    if (i15) {
     i5 = i1;
     i4 = 0;
    } else {
     i19 = i1;
     i18 = 0;
     while (1) {
      if (i28) {
       d14 = 0.0;
       d26 = 0.0;
       d21 = 0.0;
       d20 = 0.0;
       d7 = 0.0;
       d6 = 0.0;
       d10 = 0.0;
       d9 = 0.0;
       i23 = i40 + (i18 << 4) | 0;
       i22 = 0;
       while (1) {
        d53 = +HEAPF64[i29 + (i22 << 4) >> 3];
        d54 = +HEAPF64[i29 + (i22 << 4) + 8 >> 3];
        d13 = +HEAPF64[i23 >> 3];
        d52 = +HEAPF64[i23 + 8 >> 3];
        d14 = d14 + (d53 * d13 - d54 * d52);
        d26 = d26 + (d54 * d13 + d53 * d52);
        d52 = +HEAPF64[i23 + 16 >> 3];
        d13 = +HEAPF64[i23 + 24 >> 3];
        d21 = d21 + (d53 * d52 - d54 * d13);
        d20 = d20 + (d54 * d52 + d53 * d13);
        d13 = +HEAPF64[i23 + 32 >> 3];
        d52 = +HEAPF64[i23 + 40 >> 3];
        d7 = d7 + (d53 * d13 - d54 * d52);
        d6 = d6 + (d54 * d13 + d53 * d52);
        d52 = +HEAPF64[i23 + 48 >> 3];
        d13 = +HEAPF64[i23 + 56 >> 3];
        d10 = d10 + (d53 * d52 - d54 * d13);
        d9 = d9 + (d54 * d52 + d53 * d13);
        i22 = i22 + 1 | 0;
        if ((i22 | 0) == (i8 | 0)) break; else i23 = i23 + (i39 << 4) | 0;
       }
      } else {
       d26 = 0.0;
       d14 = 0.0;
       d20 = 0.0;
       d21 = 0.0;
       d6 = 0.0;
       d7 = 0.0;
       d9 = 0.0;
       d10 = 0.0;
      }
      d13 = d14 * d47;
      d14 = d26 * d47;
      if (!i19) {
       HEAPF64[i25 + (i18 << 4) >> 3] = d13;
       HEAPF64[i25 + (i18 << 4) + 8 >> 3] = d14;
       i23 = i18 | 1;
       HEAPF64[i25 + (i23 << 4) >> 3] = d21 * d47;
       HEAPF64[i25 + (i23 << 4) + 8 >> 3] = d20 * d47;
       i23 = i18 | 2;
       HEAPF64[i25 + (i23 << 4) >> 3] = d7 * d47;
       HEAPF64[i25 + (i23 << 4) + 8 >> 3] = d6 * d47;
       i23 = i18 | 3;
       HEAPF64[i25 + (i23 << 4) >> 3] = d10 * d47;
       HEAPF64[i25 + (i23 << 4) + 8 >> 3] = d9 * d47;
      } else {
       d26 = d14 + +HEAPF64[i19 + 8 >> 3] * d48;
       HEAPF64[i25 + (i18 << 4) >> 3] = d13 + +HEAPF64[i19 >> 3] * d48;
       HEAPF64[i25 + (i18 << 4) + 8 >> 3] = d26;
       i23 = i18 | 1;
       d26 = d20 * d47 + +HEAPF64[i19 + (i41 << 4) + 8 >> 3] * d48;
       HEAPF64[i25 + (i23 << 4) >> 3] = d21 * d47 + +HEAPF64[i19 + (i41 << 4) >> 3] * d48;
       HEAPF64[i25 + (i23 << 4) + 8 >> 3] = d26;
       i23 = i18 | 2;
       d26 = d6 * d47 + +HEAPF64[i19 + (i30 << 4) + 8 >> 3] * d48;
       HEAPF64[i25 + (i23 << 4) >> 3] = d7 * d47 + +HEAPF64[i19 + (i30 << 4) >> 3] * d48;
       HEAPF64[i25 + (i23 << 4) + 8 >> 3] = d26;
       i23 = i18 | 3;
       d26 = d9 * d47 + +HEAPF64[i19 + (i31 << 4) + 8 >> 3] * d48;
       HEAPF64[i25 + (i23 << 4) >> 3] = d10 * d47 + +HEAPF64[i19 + (i31 << 4) >> 3] * d48;
       HEAPF64[i25 + (i23 << 4) + 8 >> 3] = d26;
      }
      i18 = i18 + 4 | 0;
      if ((i18 | 0) > (i27 | 0)) {
       i5 = i24;
       i4 = i32;
       break;
      } else i19 = i19 + (i16 << 4) | 0;
     }
    }
    if ((i4 | 0) < (i46 | 0)) while (1) {
     if (i28) {
      d10 = 0.0;
      d9 = 0.0;
      i11 = i40 + (i4 << 4) | 0;
      i3 = 0;
      while (1) {
       d14 = +HEAPF64[i29 + (i3 << 4) >> 3];
       d21 = +HEAPF64[i29 + (i3 << 4) + 8 >> 3];
       d13 = +HEAPF64[i11 >> 3];
       d26 = +HEAPF64[i11 + 8 >> 3];
       d10 = d10 + (d14 * d13 - d21 * d26);
       d9 = d9 + (d21 * d13 + d14 * d26);
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i8 | 0)) break; else i11 = i11 + (i39 << 4) | 0;
      }
     } else {
      d9 = 0.0;
      d10 = 0.0;
     }
     d7 = d10 * d47;
     d10 = d9 * d47;
     i3 = i25 + (i4 << 4) | 0;
     if (!i5) {
      HEAPF64[i3 >> 3] = d7;
      HEAPF64[i25 + (i4 << 4) + 8 >> 3] = d10;
     } else {
      d26 = d10 + +HEAPF64[i5 + 8 >> 3] * d48;
      HEAPF64[i3 >> 3] = d7 + +HEAPF64[i5 >> 3] * d48;
      HEAPF64[i25 + (i4 << 4) + 8 >> 3] = d26;
     }
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i46 | 0)) break; else i5 = i5 + (i41 << 4) | 0;
    }
    i12 = i12 + 1 | 0;
    if ((i12 | 0) == (i44 | 0)) break L17; else {
     i25 = i25 + (i42 << 4) | 0;
     i17 = i17 + (i37 << 4) | 0;
     i1 = i1 + (i43 << 4) | 0;
     i24 = i24 + (i43 << 4) | 0;
    }
   }
  }
  i28 = i29 + 8 | 0;
  i3 = i29 + 1160 | 0;
  i2 = i28;
  do {
   HEAP32[i2 + 0 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   i2 = i2 + 16 | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i29 >> 2] = i28;
  i27 = i29 + 4 | 0;
  HEAP32[i27 >> 2] = 72;
  if (i46 >>> 0 > 72) {
   i1 = __Znaj(i46 >>> 0 > 268435455 ? -1 : i46 << 4) | 0;
   i3 = i1 + (i46 << 4) | 0;
   i2 = i1;
   do {
    HEAP32[i2 + 0 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    i2 = i2 + 16 | 0;
   } while ((i2 | 0) != (i3 | 0));
   HEAP32[i29 >> 2] = i1;
  } else i1 = i28;
  HEAP32[i27 >> 2] = i46;
  if ((i44 | 0) > 0) {
   i2 = (i36 | 0) == 0;
   i15 = (i46 | 0) > 0;
   i16 = (i8 | 0) > 0;
   i22 = i46 + -4 | 0;
   i23 = (i22 | 0) < 0;
   i24 = i46 & -4;
   i25 = i2 | i16 ^ 1;
   i12 = i34;
   i19 = i35;
   i18 = 0;
   while (1) {
    if (i25) i3 = i2 ? i17 : i36; else {
     i5 = 0;
     do {
      i30 = i36 + (i5 << 4) | 0;
      i3 = i17 + ((Math_imul(i5, i38) | 0) << 4) | 0;
      HEAP32[i30 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
      HEAP32[i30 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i30 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i30 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i8 | 0));
     i3 = i36;
    }
    if (i15) {
     i5 = 0;
     do {
      i30 = i1 + (i5 << 4) | 0;
      i5 = i5 + 1 | 0;
      HEAP32[i30 + 0 >> 2] = 0;
      HEAP32[i30 + 4 >> 2] = 0;
      HEAP32[i30 + 8 >> 2] = 0;
      HEAP32[i30 + 12 >> 2] = 0;
     } while ((i5 | 0) != (i46 | 0));
    }
    if (i16) {
     i5 = i40;
     i4 = 0;
     while (1) {
      d10 = +HEAPF64[i3 + (i4 << 4) >> 3];
      d9 = +HEAPF64[i3 + (i4 << 4) + 8 >> 3];
      if (i23) i11 = 0; else {
       i11 = 0;
       do {
        d26 = +HEAPF64[i5 + (i11 << 4) >> 3];
        d7 = +HEAPF64[i5 + (i11 << 4) + 8 >> 3];
        i31 = i1 + (i11 << 4) | 0;
        i30 = i1 + (i11 << 4) + 8 | 0;
        d13 = +HEAPF64[i30 >> 3] + (d9 * d26 + d10 * d7);
        i32 = i11 | 1;
        d14 = +HEAPF64[i5 + (i32 << 4) >> 3];
        d20 = +HEAPF64[i5 + (i32 << 4) + 8 >> 3];
        i33 = i1 + (i32 << 4) | 0;
        i32 = i1 + (i32 << 4) + 8 | 0;
        d21 = +HEAPF64[i33 >> 3] + (d10 * d14 - d9 * d20);
        d20 = +HEAPF64[i32 >> 3] + (d9 * d14 + d10 * d20);
        HEAPF64[i31 >> 3] = +HEAPF64[i31 >> 3] + (d10 * d26 - d9 * d7);
        HEAPF64[i30 >> 3] = d13;
        HEAPF64[i33 >> 3] = d21;
        HEAPF64[i32 >> 3] = d20;
        i32 = i11 | 2;
        d20 = +HEAPF64[i5 + (i32 << 4) >> 3];
        d21 = +HEAPF64[i5 + (i32 << 4) + 8 >> 3];
        i33 = i1 + (i32 << 4) | 0;
        i32 = i1 + (i32 << 4) + 8 | 0;
        d13 = +HEAPF64[i32 >> 3] + (d9 * d20 + d10 * d21);
        i30 = i11 | 3;
        d7 = +HEAPF64[i5 + (i30 << 4) >> 3];
        d26 = +HEAPF64[i5 + (i30 << 4) + 8 >> 3];
        i31 = i1 + (i30 << 4) | 0;
        i30 = i1 + (i30 << 4) + 8 | 0;
        d14 = +HEAPF64[i31 >> 3] + (d10 * d7 - d9 * d26);
        d26 = +HEAPF64[i30 >> 3] + (d9 * d7 + d10 * d26);
        HEAPF64[i33 >> 3] = +HEAPF64[i33 >> 3] + (d10 * d20 - d9 * d21);
        HEAPF64[i32 >> 3] = d13;
        HEAPF64[i31 >> 3] = d14;
        HEAPF64[i30 >> 3] = d26;
        i11 = i11 + 4 | 0;
       } while ((i11 | 0) <= (i22 | 0));
       i11 = i24;
      }
      if ((i11 | 0) < (i46 | 0)) do {
       d14 = +HEAPF64[i5 + (i11 << 4) >> 3];
       d26 = +HEAPF64[i5 + (i11 << 4) + 8 >> 3];
       i30 = i1 + (i11 << 4) | 0;
       HEAPF64[i30 >> 3] = +HEAPF64[i30 >> 3] + (d10 * d14 - d9 * d26);
       i30 = i1 + (i11 << 4) + 8 | 0;
       HEAPF64[i30 >> 3] = +HEAPF64[i30 >> 3] + (d9 * d14 + d10 * d26);
       i11 = i11 + 1 | 0;
      } while ((i11 | 0) != (i46 | 0));
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i8 | 0)) break; else i5 = i5 + (i39 << 4) | 0;
     }
    }
    if (!i19) {
     if (i15) {
      i5 = 0;
      do {
       d26 = +HEAPF64[i1 + (i5 << 4) + 8 >> 3] * d47;
       HEAPF64[i12 + (i5 << 4) >> 3] = +HEAPF64[i1 + (i5 << 4) >> 3] * d47;
       HEAPF64[i12 + (i5 << 4) + 8 >> 3] = d26;
       i5 = i5 + 1 | 0;
      } while ((i5 | 0) != (i46 | 0));
     }
    } else if (i15) {
     i5 = i19;
     i4 = 0;
     while (1) {
      d26 = +HEAPF64[i1 + (i4 << 4) + 8 >> 3] * d47 + +HEAPF64[i5 + 8 >> 3] * d48;
      HEAPF64[i12 + (i4 << 4) >> 3] = +HEAPF64[i1 + (i4 << 4) >> 3] * d47 + +HEAPF64[i5 >> 3] * d48;
      HEAPF64[i12 + (i4 << 4) + 8 >> 3] = d26;
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i46 | 0)) break; else i5 = i5 + (i41 << 4) | 0;
     }
    }
    i18 = i18 + 1 | 0;
    if ((i18 | 0) == (i44 | 0)) break; else {
     i12 = i12 + (i42 << 4) | 0;
     i17 = i17 + (i37 << 4) | 0;
     i19 = i19 + (i43 << 4) | 0;
    }
   }
   i1 = HEAP32[i29 >> 2] | 0;
  }
  if ((i1 | 0) != (i28 | 0)) {
   if (i1) __ZdaPv(i1);
   HEAP32[i29 >> 2] = i28;
   HEAP32[i27 >> 2] = 72;
  }
 } while (0);
 i1 = HEAP32[i50 >> 2] | 0;
 if ((i1 | 0) == (i49 | 0)) {
  STACKTOP = i51;
  return;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i50 >> 2] = i49;
 HEAP32[i45 >> 2] = 72;
 STACKTOP = i51;
 return;
}

function __ZN2cv10cvarrToMatEPKvbbiPNS_10AutoBufferIdLj136EEE(i32, i30, i28, i3, i8, i18) {
 i32 = i32 | 0;
 i30 = i30 | 0;
 i28 = i28 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i31 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 624 | 0;
 i31 = i33 + 488 | 0;
 i15 = i33 + 480 | 0;
 i16 = i33 + 472 | 0;
 i29 = i33 + 416 | 0;
 i25 = i33 + 392 | 0;
 i27 = i33 + 384 | 0;
 i1 = i33 + 256 | 0;
 i5 = i33 + 200 | 0;
 i14 = i33 + 176 | 0;
 i20 = i33 + 120 | 0;
 i6 = i33 + 96 | 0;
 i13 = i33 + 88 | 0;
 i2 = i33 + 80 | 0;
 i17 = i33 + 72 | 0;
 i19 = i33 + 16 | 0;
 i3 = i33 + 8 | 0;
 i11 = i33;
 if (!i30) {
  HEAP32[i32 >> 2] = 1124007936;
  i3 = i32 + 8 | 0;
  i2 = i32 + 40 | 0;
  i10 = i32 + 4 | 0;
  i23 = i10 + 36 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i23 | 0));
  HEAP32[i2 >> 2] = i3;
  i22 = i32 + 48 | 0;
  HEAP32[i32 + 44 >> 2] = i22;
  HEAP32[i32 + 52 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  STACKTOP = i33;
  return;
 }
 i21 = HEAP32[i30 >> 2] | 0;
 i10 = i21 & -65536;
 if ((i10 | 0) == 1111621632) {
  i12 = HEAP32[i30 + 24 >> 2] | 0;
  if ((i12 | 0) > -1 ? (i7 = HEAP32[i30 + 20 >> 2] | 0, (i7 | 0) > -1) : 0) {
   HEAP32[i32 >> 2] = 1124007936;
   i5 = i32 + 4 | 0;
   i4 = i32 + 8 | 0;
   i3 = i32 + 40 | 0;
   i10 = i5 + 0 | 0;
   i23 = i10 + 36 | 0;
   do {
    HEAP32[i10 >> 2] = 0;
    i10 = i10 + 4 | 0;
   } while ((i10 | 0) < (i23 | 0));
   HEAP32[i3 >> 2] = i4;
   i3 = i32 + 48 | 0;
   HEAP32[i32 + 44 >> 2] = i3;
   i2 = i32 + 52 | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   if (!i28) {
    HEAP32[i32 >> 2] = i21 & 20479 | 1124007936;
    HEAP32[i5 >> 2] = 2;
    HEAP32[i4 >> 2] = i7;
    HEAP32[i32 + 12 >> 2] = i12;
    i18 = HEAP32[i30 + 16 >> 2] | 0;
    HEAP32[i32 + 16 >> 2] = i18;
    HEAP32[i32 + 20 >> 2] = i18;
    i22 = (i21 >>> 3 & 511) + 1 << (47696 >>> (i21 << 1 & 14) & 3);
    i19 = Math_imul(i22, i12) | 0;
    i21 = HEAP32[i30 + 4 >> 2] | 0;
    i21 = (i21 | 0) == 0 ? i19 : i21;
    i20 = Math_imul(i21, i7) | 0;
    HEAP32[i32 + 28 >> 2] = i18 + i20;
    HEAP32[i32 + 24 >> 2] = i18 + (i19 - i21 + i20);
    HEAP32[i3 >> 2] = i21;
    HEAP32[i2 >> 2] = i22;
    STACKTOP = i33;
    return;
   }
   HEAP32[i32 + 16 >> 2] = 0;
   HEAP32[i32 + 24 >> 2] = 0;
   HEAP32[i32 + 20 >> 2] = 0;
   __ZN2cv3MatC2EiiiPvj(i20, i7, i12, i21, HEAP32[i30 + 16 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0);
   i3 = i6 + 4 | 0;
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i6 >> 2] = 32232;
   HEAP32[i3 >> 2] = 33619968;
   HEAP32[i6 + 8 >> 2] = i32;
   __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i20, i6);
   i3 = i20 + 36 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) {
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1) {
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i2) {
      i2 = HEAP32[i20 + 32 >> 2] | 0;
      if (!i2) {
       if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
        i22 = __Znwj(4) | 0;
        HEAP32[i22 >> 2] = 32784;
        HEAP32[6904] = i22;
        ___cxa_guard_release(27624);
       }
       i2 = HEAP32[6904] | 0;
       i1 = HEAP32[i3 >> 2] | 0;
      }
     }
     FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1);
    }
    HEAP32[i3 >> 2] = 0;
   }
   HEAP32[i3 >> 2] = 0;
   i22 = i20 + 16 | 0;
   i2 = i20 + 4 | 0;
   HEAP32[i22 + 0 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   HEAP32[i22 + 12 >> 2] = 0;
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    i1 = HEAP32[i20 + 40 >> 2] | 0;
    i3 = 0;
    do {
     HEAP32[i1 + (i3 << 2) >> 2] = 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
   }
   i1 = HEAP32[i20 + 44 >> 2] | 0;
   if ((i1 | 0) == (i20 + 48 | 0)) {
    STACKTOP = i33;
    return;
   }
   __ZN2cv8fastFreeEPv(i1);
   STACKTOP = i33;
   return;
  }
 } else if ((i10 | 0) == 1111687168 ? (i12 = HEAP32[i30 + 16 >> 2] | 0, (i12 | 0) != 0) : 0) {
  i3 = i32 + 8 | 0;
  i2 = i32 + 40 | 0;
  i10 = i32 + 4 | 0;
  i23 = i10 + 36 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i23 | 0));
  HEAP32[i2 >> 2] = i3;
  i3 = i32 + 48 | 0;
  HEAP32[i32 + 44 >> 2] = i3;
  HEAP32[i32 + 52 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i32 + 16 >> 2] = i12;
  HEAP32[i32 + 20 >> 2] = i12;
  HEAP32[i32 >> 2] = i21 & 4095 | 1124007936;
  i3 = HEAP32[i30 + 4 >> 2] | 0;
  if ((i3 | 0) > 0) {
   i2 = 0;
   do {
    HEAP32[i31 + (i2 << 2) >> 2] = HEAP32[i30 + (i2 << 3) + 20 >> 2];
    HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i30 + (i2 << 3) + 24 >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
  __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i32, i3, i31, i1, 0);
  __ZN2cvL11finalizeHdrERNS_3MatE(i32);
  if (!i28) {
   STACKTOP = i33;
   return;
  }
  __ZN2cv3MatC2ERKS0_(i5, i32);
  __ZN2cv3Mat7releaseEv(i32);
  i3 = i14 + 4 | 0;
  HEAP32[i3 + 0 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i14 >> 2] = 32232;
  HEAP32[i3 >> 2] = 33619968;
  HEAP32[i14 + 8 >> 2] = i32;
  __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i5, i14);
  i3 = i5 + 36 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) {
   i2 = HEAP32[i3 >> 2] | 0;
   if (i2) {
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) {
     i1 = HEAP32[i5 + 32 >> 2] | 0;
     if (!i1) {
      if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
       i22 = __Znwj(4) | 0;
       HEAP32[i22 >> 2] = 32784;
       HEAP32[6904] = i22;
       ___cxa_guard_release(27624);
      }
      i1 = HEAP32[6904] | 0;
      i2 = HEAP32[i3 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i2);
   }
   HEAP32[i3 >> 2] = 0;
  }
  HEAP32[i3 >> 2] = 0;
  i22 = i5 + 16 | 0;
  i2 = i5 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i5 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i1 = HEAP32[i5 + 44 >> 2] | 0;
  if ((i1 | 0) == (i5 + 48 | 0)) {
   STACKTOP = i33;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i33;
  return;
 }
 if ((i21 | 0) == 112 ? (i24 = i30 + 68 | 0, (HEAP32[i24 >> 2] | 0) != 0) : 0) {
  if (((i8 | 0) == 0 ? (i9 = HEAP32[i30 + 48 >> 2] | 0, (i9 | 0) != 0) : 0) ? (HEAP32[i9 >> 2] | 0) > 0 : 0) {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   i10 = (__ZN2cv6String8allocateEj(i13, 36) | 0) + 0 | 0;
   i12 = 28224;
   i23 = i10 + 36 | 0;
   do {
    HEAP8[i10 >> 0] = HEAP8[i12 >> 0] | 0;
    i10 = i10 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i10 | 0) < (i23 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-24, i13, 28264, 27528, 853);
   __ZN2cv6String10deallocateEv(i13);
  }
  HEAP32[i32 >> 2] = 1124007936;
  i20 = i32 + 4 | 0;
  i19 = i32 + 8 | 0;
  i5 = i32 + 40 | 0;
  i10 = i20 + 0 | 0;
  i23 = i10 + 36 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i23 | 0));
  HEAP32[i5 >> 2] = i19;
  i11 = i32 + 48 | 0;
  i13 = i32 + 44 | 0;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i32 + 52 >> 2] = 0;
  HEAP32[i20 >> 2] = 2;
  i9 = HEAP32[i30 + 16 >> 2] | 0;
  i9 = 1125516576 >>> ((i9 >>> 2 & 60) + (i9 >> 31 & 20) | 0);
  HEAP32[i11 >> 2] = HEAP32[i30 + 72 >> 2];
  i18 = i30 + 48 | 0;
  i6 = HEAP32[i18 >> 2] | 0;
  i17 = i30 + 28 | 0;
  i5 = (HEAP32[i17 >> 2] | 0) == 0;
  if (!i6) {
   if (i5) i6 = i11; else {
    HEAP32[i15 >> 2] = 0;
    HEAP32[i15 + 4 >> 2] = 0;
    i10 = (__ZN2cv6String8allocateEj(i15, 38) | 0) + 0 | 0;
    i12 = 32544;
    i23 = i10 + 38 | 0;
    do {
     HEAP8[i10 >> 0] = HEAP8[i12 >> 0] | 0;
     i10 = i10 + 1 | 0;
     i12 = i12 + 1 | 0;
    } while ((i10 | 0) < (i23 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i15, 32584, 27528, 624);
    __ZN2cv6String10deallocateEv(i15);
    i6 = HEAP32[i13 >> 2] | 0;
   }
   i4 = ((HEAP32[i30 + 8 >> 2] << 3) + -8 | i9 & 7) + 1124007936 | 0;
   HEAP32[i32 >> 2] = i4;
   i5 = HEAP32[i30 + 44 >> 2] | 0;
   HEAP32[i19 >> 2] = i5;
   i7 = HEAP32[i30 + 40 >> 2] | 0;
   HEAP32[i32 + 12 >> 2] = i7;
   i1 = HEAP32[i24 >> 2] | 0;
   HEAP32[i32 + 16 >> 2] = i1;
   HEAP32[i32 + 20 >> 2] = i1;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i4;
   i4 = (i4 >>> 3 & 511) + 1 << (47696 >>> (i4 << 1 & 14) & 3);
  } else {
   if (!i5 ? (HEAP32[i6 >> 2] | 0) == 0 : 0) {
    HEAP32[i16 >> 2] = 0;
    HEAP32[i16 + 4 >> 2] = 0;
    i10 = (__ZN2cv6String8allocateEj(i16, 60) | 0) + 0 | 0;
    i12 = 32600;
    i23 = i10 + 60 | 0;
    do {
     HEAP8[i10 >> 0] = HEAP8[i12 >> 0] | 0;
     i10 = i10 + 1 | 0;
     i12 = i12 + 1 | 0;
    } while ((i10 | 0) < (i23 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i16, 32584, 27528, 633);
    __ZN2cv6String10deallocateEv(i16);
    i2 = HEAP32[i18 >> 2] | 0;
   } else i2 = i6;
   i8 = HEAP32[i2 >> 2] | 0;
   if (i8) {
    i6 = i9 & 7;
    if ((HEAP32[i17 >> 2] | 0) == 1) {
     i5 = 0;
     i9 = 1;
    } else i22 = 61;
   } else {
    i6 = i9 & 7;
    i22 = 61;
   }
   if ((i22 | 0) == 61) {
    i5 = (HEAP32[i30 + 8 >> 2] << 3) + -8 | 0;
    i9 = 0;
   }
   i3 = i6 + 1124007936 + i5 | 0;
   HEAP32[i32 >> 2] = i3;
   i5 = HEAP32[i2 + 16 >> 2] | 0;
   HEAP32[i19 >> 2] = i5;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   HEAP32[i32 + 12 >> 2] = i7;
   i4 = (i3 >>> 3 & 511) + 1 << (47696 >>> (i3 << 1 & 14) & 3);
   if (i9) {
    i6 = Math_imul(HEAP32[i11 >> 2] | 0, i8 + -1 | 0) | 0;
    i6 = Math_imul(i6, HEAP32[i30 + 44 >> 2] | 0) | 0;
   } else i6 = 0;
   i22 = HEAP32[i13 >> 2] | 0;
   i21 = HEAP32[i22 >> 2] | 0;
   i1 = (Math_imul(i21, HEAP32[i2 + 8 >> 2] | 0) | 0) + i6 | 0;
   i1 = (HEAP32[i24 >> 2] | 0) + (i1 + (Math_imul(HEAP32[i2 + 4 >> 2] | 0, i4) | 0)) | 0;
   HEAP32[i32 + 16 >> 2] = i1;
   HEAP32[i32 + 20 >> 2] = i1;
   i2 = i21;
   i6 = i22;
  }
  HEAP32[i32 + 28 >> 2] = i1 + (Math_imul(i2, i5) | 0);
  i8 = i32 + 12 | 0;
  i22 = Math_imul(i4, i7) | 0;
  HEAP32[i32 + 24 >> 2] = i1 + (i22 + (Math_imul(i5 + -1 | 0, i2) | 0));
  if ((i22 | 0) == (i2 | 0)) i5 = 16384; else i5 = (i5 | 0) == 1 ? 16384 : 0;
  HEAP32[i32 >> 2] = i5 | i3;
  HEAP32[i6 + 4 >> 2] = i4;
  if (!i28) {
   STACKTOP = i33;
   return;
  }
  __ZN2cv3MatC2ERKS0_(i29, i32);
  __ZN2cv3Mat7releaseEv(i32);
  i3 = HEAP32[i18 >> 2] | 0;
  if (((i3 | 0) != 0 ? (i26 = HEAP32[i3 >> 2] | 0, (i26 | 0) != 0) : 0) ? (HEAP32[i17 >> 2] | 0) != 1 : 0) {
   HEAP32[i27 >> 2] = i26 + -1;
   HEAP32[i27 + 4 >> 2] = 0;
   i3 = HEAP32[i29 + 8 >> 2] | 0;
   i2 = HEAP32[i29 + 12 >> 2] | 0;
   i1 = HEAP32[i29 >> 2] & 4095;
   if (!(((((HEAP32[i20 >> 2] | 0) < 3 ? (HEAP32[i19 >> 2] | 0) == (i3 | 0) : 0) ? (HEAP32[i8 >> 2] | 0) == (i2 | 0) : 0) ? (HEAP32[i32 >> 2] & 4095 | 0) == (i1 | 0) : 0) ? (HEAP32[i32 + 16 >> 2] | 0) != 0 : 0)) {
    HEAP32[i31 >> 2] = i3;
    HEAP32[i31 + 4 >> 2] = i2;
    __ZN2cv3Mat6createEiPKii(i32, 2, i31, i1);
   }
   __ZN2cv11mixChannelsEPKNS_3MatEjPS0_jPKij(i29, 1, i32, 1, i27, 1);
  } else {
   i22 = i25 + 4 | 0;
   HEAP32[i22 + 0 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   HEAP32[i22 + 12 >> 2] = 0;
   HEAP32[i25 >> 2] = 32232;
   HEAP32[i22 >> 2] = 33619968;
   HEAP32[i25 + 8 >> 2] = i32;
   __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i29, i25);
  }
  i3 = i29 + 36 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1) {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i2) {
     i2 = HEAP32[i29 + 32 >> 2] | 0;
     if (!i2) {
      do if (!(HEAP8[27624] | 0)) {
       if (!(___cxa_guard_acquire(27624) | 0)) break;
       i22 = __Znwj(4) | 0;
       HEAP32[i22 >> 2] = 32784;
       HEAP32[6904] = i22;
       ___cxa_guard_release(27624);
      } while (0);
      i2 = HEAP32[6904] | 0;
      i1 = HEAP32[i3 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1);
   }
   HEAP32[i3 >> 2] = 0;
  }
  HEAP32[i3 >> 2] = 0;
  i22 = i29 + 16 | 0;
  i2 = i29 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i29 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i1 = HEAP32[i29 + 44 >> 2] | 0;
  if ((i1 | 0) == (i29 + 48 | 0)) {
   STACKTOP = i33;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i33;
  return;
 }
 if ((i10 | 0) != 1117323264) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  i10 = (__ZN2cv6String8allocateEj(i11, 18) | 0) + 0 | 0;
  i12 = 28328;
  i23 = i10 + 18 | 0;
  do {
   HEAP8[i10 >> 0] = HEAP8[i12 >> 0] | 0;
   i10 = i10 + 1 | 0;
   i12 = i12 + 1 | 0;
  } while ((i10 | 0) < (i23 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i11, 28264, 27528, 877);
  __ZN2cv6String10deallocateEv(i11);
  HEAP32[i32 >> 2] = 1124007936;
  i3 = i32 + 8 | 0;
  i2 = i32 + 40 | 0;
  i10 = i32 + 4 | 0;
  i23 = i10 + 36 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i23 | 0));
  HEAP32[i2 >> 2] = i3;
  i22 = i32 + 48 | 0;
  HEAP32[i32 + 44 >> 2] = i22;
  HEAP32[i32 + 52 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  STACKTOP = i33;
  return;
 }
 i9 = HEAP32[i30 + 24 >> 2] | 0;
 i8 = i21 & 4095;
 i5 = HEAP32[i30 + 28 >> 2] | 0;
 if (!i9) {
  HEAP32[i32 >> 2] = 1124007936;
  i3 = i32 + 8 | 0;
  i2 = i32 + 40 | 0;
  i10 = i32 + 4 | 0;
  i23 = i10 + 36 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i23 | 0));
  HEAP32[i2 >> 2] = i3;
  i22 = i32 + 48 | 0;
  HEAP32[i32 + 44 >> 2] = i22;
  HEAP32[i32 + 52 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  STACKTOP = i33;
  return;
 }
 if (!((i9 | 0) > 0 ? ((i21 >>> 3 & 511) + 1 << (47696 >>> (i21 << 1 & 14) & 3) | 0) == (i5 | 0) : 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i10 = (__ZN2cv6String8allocateEj(i2, 44) | 0) + 0 | 0;
  i12 = 28280;
  i23 = i10 + 44 | 0;
  do {
   HEAP8[i10 >> 0] = HEAP8[i12 >> 0] | 0;
   i10 = i10 + 1 | 0;
   i12 = i12 + 1 | 0;
  } while ((i10 | 0) < (i23 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 28264, 27528, 862);
  __ZN2cv6String10deallocateEv(i2);
 }
 if (!i28 ? (i4 = HEAP32[i30 + 52 >> 2] | 0, (HEAP32[i4 + 4 >> 2] | 0) == (i4 | 0)) : 0) {
  i20 = HEAP32[i4 + 16 >> 2] | 0;
  HEAP32[i32 + 4 >> 2] = 2;
  i19 = i32 + 8 | 0;
  HEAP32[i19 >> 2] = i9;
  HEAP32[i32 + 12 >> 2] = 1;
  HEAP32[i32 + 16 >> 2] = i20;
  HEAP32[i32 + 20 >> 2] = i20;
  i22 = i32 + 24 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  HEAP32[i32 + 40 >> 2] = i19;
  i19 = i32 + 48 | 0;
  HEAP32[i32 + 44 >> 2] = i19;
  i21 = (i21 >>> 3 & 511) + 1 << (47696 >>> (i21 << 1 & 14) & 3);
  HEAP32[i32 >> 2] = i8 | 1124024320;
  HEAP32[i19 >> 2] = i21;
  HEAP32[i32 + 52 >> 2] = i21;
  i21 = i20 + (Math_imul(i9, i21) | 0) | 0;
  HEAP32[i32 + 28 >> 2] = i21;
  HEAP32[i22 >> 2] = i21;
  STACKTOP = i33;
  return;
 }
 if (i18) {
  i1 = (Math_imul(i5, i9) | 0) + 7 | 0;
  i4 = i1 >>> 3;
  i5 = i18 + 4 | 0;
  if ((HEAP32[i5 >> 2] | 0) >>> 0 < i4 >>> 0) {
   i2 = HEAP32[i18 >> 2] | 0;
   i3 = i18 + 8 | 0;
   if ((i2 | 0) == (i3 | 0)) i3 = i2; else {
    if (i2) __ZdaPv(i2);
    HEAP32[i18 >> 2] = i3;
    HEAP32[i5 >> 2] = 136;
   }
   if (i1 >>> 0 > 1095) {
    i3 = __Znaj(i4 << 3) | 0;
    HEAP32[i18 >> 2] = i3;
    HEAP32[i5 >> 2] = i4;
   }
  } else {
   HEAP32[i5 >> 2] = i4;
   i3 = HEAP32[i18 >> 2] | 0;
  }
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 1073741823;
  HEAP32[i31 + 0 >> 2] = HEAP32[i17 + 0 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  _cvCvtSeqToArray(i30, i3, i31) | 0;
  HEAP32[i32 + 4 >> 2] = 2;
  i20 = i32 + 8 | 0;
  HEAP32[i20 >> 2] = i9;
  HEAP32[i32 + 12 >> 2] = 1;
  HEAP32[i32 + 16 >> 2] = i3;
  HEAP32[i32 + 20 >> 2] = i3;
  i22 = i32 + 24 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  HEAP32[i32 + 40 >> 2] = i20;
  i20 = i32 + 48 | 0;
  HEAP32[i32 + 44 >> 2] = i20;
  i21 = (i21 >>> 3 & 511) + 1 << (47696 >>> (i21 << 1 & 14) & 3);
  HEAP32[i32 >> 2] = i8 | 1124024320;
  HEAP32[i20 >> 2] = i21;
  HEAP32[i32 + 52 >> 2] = i21;
  i21 = i3 + (Math_imul(i9, i21) | 0) | 0;
  HEAP32[i32 + 28 >> 2] = i21;
  HEAP32[i22 >> 2] = i21;
  STACKTOP = i33;
  return;
 }
 HEAP32[i19 >> 2] = 1124007936;
 i14 = i19 + 4 | 0;
 i5 = i19 + 8 | 0;
 i11 = i19 + 40 | 0;
 i10 = i14 + 0 | 0;
 i23 = i10 + 36 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i23 | 0));
 HEAP32[i11 >> 2] = i5;
 i13 = i19 + 48 | 0;
 i12 = i19 + 44 | 0;
 HEAP32[i12 >> 2] = i13;
 HEAP32[i19 + 52 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i31 >> 2] = i9;
 HEAP32[i31 + 4 >> 2] = 1;
 __ZN2cv3Mat6createEiPKii(i19, 2, i31, i8);
 i10 = i19 + 16 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 1073741823;
 HEAP32[i31 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 _cvCvtSeqToArray(i30, i7, i31) | 0;
 HEAP32[i32 >> 2] = HEAP32[i19 >> 2];
 i7 = i32 + 4 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 HEAP32[i7 >> 2] = i3;
 i22 = i32 + 8 | 0;
 HEAP32[i22 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i32 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 HEAP32[i32 + 16 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i32 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
 HEAP32[i32 + 24 >> 2] = HEAP32[i19 + 24 >> 2];
 HEAP32[i32 + 28 >> 2] = HEAP32[i19 + 28 >> 2];
 i8 = i19 + 32 | 0;
 HEAP32[i32 + 32 >> 2] = HEAP32[i8 >> 2];
 i9 = i19 + 36 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 HEAP32[i32 + 36 >> 2] = i2;
 i5 = i32 + 40 | 0;
 HEAP32[i5 >> 2] = i22;
 i22 = i32 + 48 | 0;
 i6 = i32 + 44 | 0;
 HEAP32[i6 >> 2] = i22;
 HEAP32[i32 + 52 >> 2] = 0;
 HEAP32[i22 >> 2] = 0;
 if (i2) {
  i3 = i2 + 12 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = HEAP32[i14 >> 2] | 0;
 }
 if ((i3 | 0) >= 3) {
  HEAP32[i7 >> 2] = 0;
  __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i32, i3, 0, 0, 0);
  if ((HEAP32[i7 >> 2] | 0) > 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   i5 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
    HEAP32[i3 + (i2 << 2) >> 2] = HEAP32[i4 + (i2 << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i7 >> 2] | 0));
  }
 } else {
  i21 = HEAP32[i12 >> 2] | 0;
  i22 = HEAP32[i6 >> 2] | 0;
  HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 }
 i3 = HEAP32[i9 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i21 = i3 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) {
  i2 = HEAP32[i9 >> 2] | 0;
  if (i2) {
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i3) {
    i3 = HEAP32[i8 >> 2] | 0;
    if (!i3) {
     do if (!(HEAP8[27624] | 0)) {
      if (!(___cxa_guard_acquire(27624) | 0)) break;
      i22 = __Znwj(4) | 0;
      HEAP32[i22 >> 2] = 32784;
      HEAP32[6904] = i22;
      ___cxa_guard_release(27624);
     } while (0);
     i3 = HEAP32[6904] | 0;
     i2 = HEAP32[i9 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3, i2);
  }
  HEAP32[i9 >> 2] = 0;
 }
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i14 >> 2] | 0) > 0) {
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i14 >> 2] | 0));
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i33;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i33;
 return;
}

function __ZN2cvL9binary_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_PKPFvPKhjS7_jPhjNS_5Size_IiEEPvEbi(i16, i24, i31, i29, i3, i30, i5) {
 i16 = i16 | 0;
 i24 = i24 | 0;
 i31 = i31 | 0;
 i29 = i29 | 0;
 i3 = i3 | 0;
 i30 = i30 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 1664 | 0;
 i34 = i50 + 1600 | 0;
 i25 = i50 + 1544 | 0;
 i9 = i50 + 1536 | 0;
 i10 = i50 + 1528 | 0;
 i14 = i50 + 1520 | 0;
 i49 = i50 + 1464 | 0;
 i21 = i50 + 1456 | 0;
 i19 = i50 + 1448 | 0;
 i8 = i50 + 1440 | 0;
 i44 = i50 + 1432 | 0;
 i23 = i50 + 1424 | 0;
 i48 = i50 + 384 | 0;
 i26 = i50 + 364 | 0;
 i27 = i50;
 i28 = i50 + 344 | 0;
 i47 = i50 + 288 | 0;
 i46 = i50 + 232 | 0;
 i45 = i50 + 176 | 0;
 i32 = i50 + 152 | 0;
 i42 = i50 + 136 | 0;
 i41 = i50 + 104 | 0;
 i39 = i50 + 96 | 0;
 i40 = i50 + 88 | 0;
 i33 = i50 + 72 | 0;
 i38 = i50 + 56 | 0;
 i37 = i50 + 24 | 0;
 i35 = i50 + 16 | 0;
 i36 = i50 + 8 | 0;
 i6 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] & 127](i16) | 0;
 i17 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i24 >> 2] | 0) + 24 >> 2] & 127](i24) | 0;
 i20 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 56 >> 2] & 127](i16, -1) | 0;
 i22 = i20 & 7;
 i1 = (i20 >>> 3 & 511) + 1 | 0;
 i4 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i24 >> 2] | 0) + 56 >> 2] & 127](i24, -1) | 0;
 i2 = i4 & 7;
 i18 = (i4 >>> 3 & 511) + 1 | 0;
 i13 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 28 >> 2] & 127](i16, -1) | 0;
 i15 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i24 >> 2] | 0) + 28 >> 2] & 127](i24, -1) | 0;
 i13 = (i13 | 0) < 3;
 if (i13) FUNCTION_TABLE_viii[HEAP32[(HEAP32[i16 >> 2] | 0) + 40 >> 2] & 63](i9, i16, -1); else {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
 }
 i15 = (i15 | 0) < 3;
 if (i15) FUNCTION_TABLE_viii[HEAP32[(HEAP32[i24 >> 2] | 0) + 40 >> 2] & 63](i10, i24, -1); else {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
 }
 i43 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i29 >> 2] | 0) + 76 >> 2] & 127](i29) | 0;
 if (((i13 & i15 & (i6 | 0) == (i17 | 0) ? (i12 = HEAP32[i9 >> 2] | 0, (i12 | 0) == (HEAP32[i10 >> 2] | 0)) : 0) ? (i11 = HEAP32[i9 + 4 >> 2] | 0, (i11 | 0) == (HEAP32[i10 + 4 >> 2] | 0)) : 0) ? !((i20 | 0) != (i4 | 0) | i43 ^ 1) : 0) {
  i46 = HEAP32[(HEAP32[i31 >> 2] | 0) + 136 >> 2] | 0;
  HEAP32[i14 >> 2] = i12;
  HEAP32[i14 + 4 >> 2] = i11;
  FUNCTION_TABLE_viiiiii[i46 & 31](i31, i14, i20, -1, 0, 0);
  if (i30) i1 = i1 << (47696 >>> (i20 << 1 & 14) & 3); else i3 = i3 + (i22 << 2) | 0;
  i8 = HEAP32[i3 >> 2] | 0;
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i16 >> 2] >> 2] & 63](i49, i16, -1);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i24 >> 2] >> 2] & 63](i34, i24, -1);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i31 >> 2] >> 2] & 63](i25, i31, -1);
  i3 = HEAP32[i49 + 12 >> 2] | 0;
  i2 = HEAP32[i49 + 8 >> 2] | 0;
  if (!(HEAP32[i49 >> 2] & 16384 & HEAP32[i34 >> 2] & HEAP32[i25 >> 2])) i5 = i2; else {
   i5 = 1;
   i3 = Math_imul(i2, i3) | 0;
  }
  i42 = Math_imul(i3, i1) | 0;
  i12 = i49 + 16 | 0;
  i43 = HEAP32[i12 >> 2] | 0;
  i13 = i49 + 44 | 0;
  i14 = i49 + 48 | 0;
  i44 = HEAP32[i14 >> 2] | 0;
  i9 = i34 + 16 | 0;
  i45 = HEAP32[i9 >> 2] | 0;
  i10 = i34 + 44 | 0;
  i11 = i34 + 48 | 0;
  i46 = HEAP32[i11 >> 2] | 0;
  i4 = i25 + 16 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i6 = i25 + 44 | 0;
  i7 = i25 + 48 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  HEAP32[i21 >> 2] = i42;
  HEAP32[i21 + 4 >> 2] = i5;
  FUNCTION_TABLE_viiiiiiii[i8 & 255](i43, i44, i45, i46, i2, i3, i21, 0);
  i3 = i25 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i45 = i2 + 12 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i25);
  HEAP32[i3 >> 2] = 0;
  i1 = i25 + 4 | 0;
  HEAP32[i4 + 0 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  if ((HEAP32[i1 >> 2] | 0) > 0) {
   i3 = HEAP32[i25 + 40 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
  }
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) != (i7 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = i34 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i45 = i2 + 12 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i34);
  HEAP32[i3 >> 2] = 0;
  i1 = i34 + 4 | 0;
  HEAP32[i9 + 0 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  if ((HEAP32[i1 >> 2] | 0) > 0) {
   i3 = HEAP32[i34 + 40 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
  }
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 | 0) != (i11 | 0)) __ZN2cv8fastFreeEPv(i2);
  i2 = i49 + 36 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i45 = i1 + 12 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i49);
  HEAP32[i2 >> 2] = 0;
  i3 = i49 + 4 | 0;
  HEAP32[i12 + 0 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i1 = HEAP32[i49 + 40 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i1 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i1 = HEAP32[i13 >> 2] | 0;
  if ((i1 | 0) == (i14 | 0)) {
   STACKTOP = i50;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i50;
  return;
 }
 L59 : do if ((i5 | 0) == 12) {
  i4 = i20;
  i2 = i22;
  i12 = i16;
  i16 = i24;
  i11 = 1;
 } else {
  i11 = (i6 | 0) == 131072;
  i14 = (i17 | 0) == 131072;
  if (((i14 & 1) + (i11 & 1) | 0) != 1 ? (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 48 >> 2] & 127](i16, i24) | 0) & (i20 | 0) == (i4 | 0) : 0) {
   if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 48 >> 2] & 127](i16, i24) | 0) {
    i4 = i20;
    i2 = i22;
    i12 = i16;
    i16 = i24;
    i11 = 0;
    break;
   }
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i15 = (__ZN2cv6String8allocateEj(i8, 41) | 0) + 0 | 0;
   i14 = 6064 | 0;
   i13 = i15 + 41 | 0;
   do {
    HEAP8[i15 >> 0] = HEAP8[i14 >> 0] | 0;
    i15 = i15 + 1 | 0;
    i14 = i14 + 1 | 0;
   } while ((i15 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 6048, 4712, 1383);
   __ZN2cv6String10deallocateEv(i8);
   i4 = i20;
   i2 = i22;
   i12 = i16;
   i16 = i24;
   i11 = 0;
   break;
  }
  L66 : do if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 28 >> 2] & 127](i16, -1) | 0) <= 2 ? FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 68 >> 2] & 127](i16, -1) | 0 : 0) {
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i16 >> 2] | 0) + 40 >> 2] & 63](i25, i16, -1);
   i15 = HEAP32[i25 >> 2] | 0;
   i13 = (i15 | 0) == 1;
   if (i13) {
    if (i14 & (i6 | 0) != 131072) break;
    i8 = HEAP32[i25 + 4 >> 2] | 0;
    if (!((i8 | 0) == 1 | (i8 | 0) == (i18 | 0))) i7 = 49;
   } else if ((HEAP32[i25 + 4 >> 2] | 0) != 1 | i14 & (i6 | 0) != 131072) break; else i7 = 49;
   do if ((i7 | 0) == 49) {
    if ((i15 | 0) == (i18 | 0)) {
     i15 = HEAP32[i25 + 4 >> 2] | 0;
     i14 = (i15 | 0) == 1;
     if (i14 | i13 ^ 1) if (i14) break; else break L66;
    } else {
     if (!i13) break L66;
     i15 = HEAP32[i25 + 4 >> 2] | 0;
    }
    if ((i15 | 0) != 4) break L66;
    if (!((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 56 >> 2] & 127](i16, -1) | 0) == 6 & i18 >>> 0 < 5)) break L66;
   } while (0);
   i11 = HEAP32[i9 >> 2] | 0;
   i34 = i9 + 4 | 0;
   i12 = HEAP32[i34 >> 2] | 0;
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   i1 = i10 + 4 | 0;
   HEAP32[i34 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 >> 2] = i11;
   HEAP32[i1 >> 2] = i12;
   i1 = i18;
   i12 = i24;
   i11 = 1;
   break L59;
  } while (0);
  do if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i24 >> 2] | 0) + 28 >> 2] & 127](i24, -1) | 0) <= 2 ? FUNCTION_TABLE_iii[HEAP32[(HEAP32[i24 >> 2] | 0) + 68 >> 2] & 127](i24, -1) | 0 : 0) {
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i24 >> 2] | 0) + 40 >> 2] & 63](i34, i24, -1);
   i15 = HEAP32[i34 >> 2] | 0;
   i12 = (i15 | 0) == 1;
   if (i12) {
    if (i11 & (i17 | 0) != 131072) break;
    i25 = HEAP32[i34 + 4 >> 2] | 0;
    if ((i25 | 0) == 1 | (i25 | 0) == (i1 | 0)) {
     i4 = i20;
     i2 = i22;
     i12 = i16;
     i16 = i24;
     i11 = 1;
     break L59;
    }
   } else if ((HEAP32[i34 + 4 >> 2] | 0) != 1 | i11 & (i17 | 0) != 131072) break;
   if ((i15 | 0) == (i1 | 0)) {
    i13 = HEAP32[i34 + 4 >> 2] | 0;
    i14 = (i13 | 0) == 1;
    if (i14 | i12 ^ 1) if (i14) {
     i4 = i20;
     i2 = i22;
     i12 = i16;
     i16 = i24;
     i11 = 1;
     break L59;
    } else break;
   } else {
    if (!i12) break;
    i13 = HEAP32[i34 + 4 >> 2] | 0;
   }
   if ((i13 | 0) == 4 ? (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i24 >> 2] | 0) + 56 >> 2] & 127](i24, -1) | 0) == 6 & i1 >>> 0 < 5 : 0) {
    i4 = i20;
    i2 = i22;
    i12 = i16;
    i16 = i24;
    i11 = 1;
    break L59;
   }
  } while (0);
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  _memcpy(__ZN2cv6String8allocateEj(i19, 130) | 0, 5912, 130) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-209, i19, 6048, 4712, 1378);
  __ZN2cv6String10deallocateEv(i19);
  i4 = i20;
  i2 = i22;
  i12 = i16;
  i16 = i24;
  i11 = 1;
 } while (0);
 i6 = (i4 >>> 3 & 511) + 1 << (47696 >>> (i4 << 1 & 14) & 3);
 HEAP32[i44 >> 2] = i6;
 i6 = ((i6 + 1023 | 0) >>> 0) / (i6 >>> 0) | 0;
 if (!i43) {
  if (!((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i29 >> 2] | 0) + 56 >> 2] & 127](i29, -1) | 0) >>> 0 < 2 ? FUNCTION_TABLE_iii[HEAP32[(HEAP32[i29 >> 2] | 0) + 48 >> 2] & 127](i29, i12) | 0 : 0)) {
   HEAP32[i23 >> 2] = 0;
   HEAP32[i23 + 4 >> 2] = 0;
   i15 = (__ZN2cv6String8allocateEj(i23, 60) | 0) + 0 | 0;
   i14 = 6112 | 0;
   i13 = i15 + 60 | 0;
   do {
    HEAP8[i15 >> 0] = HEAP8[i14 >> 0] | 0;
    i15 = i15 + 1 | 0;
    i14 = i14 + 1 | 0;
   } while ((i15 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i23, 6048, 4712, 1394);
   __ZN2cv6String10deallocateEv(i23);
  }
  i13 = __ZN2cv15getCopyMaskFuncEj(HEAP32[i44 >> 2] | 0) | 0;
  if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i31 >> 2] | 0) + 48 >> 2] & 127](i31, i12) | 0) i15 = (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i31 >> 2] | 0) + 56 >> 2] & 127](i31, -1) | 0) == (i4 | 0); else i15 = 0;
 } else {
  i13 = 0;
  i15 = 1;
 }
 i34 = i48 + 8 | 0;
 HEAP32[i48 >> 2] = i34;
 i25 = i48 + 4 | 0;
 HEAP32[i25 >> 2] = 1032;
 FUNCTION_TABLE_viii[HEAP32[(HEAP32[i31 >> 2] | 0) + 148 >> 2] & 63](i31, i12, i4);
 if (!(i43 | i15)) {
  i24 = HEAP32[(HEAP32[i31 >> 2] | 0) + 160 >> 2] | 0;
  HEAPF64[i27 >> 3] = 0.0;
  HEAP32[i26 >> 2] = 32088;
  HEAP32[i26 + 4 >> 2] = -1056833530;
  HEAP32[i26 + 8 >> 2] = i27;
  HEAP32[i26 + 12 >> 2] = 1;
  HEAP32[i26 + 16 >> 2] = 1;
  HEAP32[i28 >> 2] = 32088;
  i27 = i28 + 4 | 0;
  HEAP32[i27 + 0 >> 2] = 0;
  HEAP32[i27 + 4 >> 2] = 0;
  HEAP32[i27 + 8 >> 2] = 0;
  HEAP32[i27 + 12 >> 2] = 0;
  FUNCTION_TABLE_viii[i24 & 63](i31, i26, i28);
 }
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i12 >> 2] >> 2] & 63](i49, i12, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i16 >> 2] >> 2] & 63](i47, i16, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i31 >> 2] >> 2] & 63](i46, i31, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i29 >> 2] >> 2] & 63](i45, i29, -1);
 if (i30) i1 = HEAP32[i44 >> 2] | 0; else i3 = i3 + (i2 << 2) | 0;
 i20 = HEAP32[i3 >> 2] | 0;
 L117 : do if (i11) {
  HEAP32[i33 >> 2] = i49;
  HEAP32[i33 + 4 >> 2] = i46;
  HEAP32[i33 + 8 >> 2] = i45;
  HEAP32[i33 + 12 >> 2] = 0;
  __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i37, i33, i38, -1);
  i15 = HEAP32[i37 + 20 >> 2] | 0;
  i14 = i6 >>> 0 < i15 >>> 0 ? i6 : i15;
  i6 = (Math_imul(Math_imul(HEAP32[i44 >> 2] | 0, i43 ? 1 : 2) | 0, i14) | 0) + 32 | 0;
  if ((HEAP32[i25 >> 2] | 0) >>> 0 < i6 >>> 0) {
   i5 = HEAP32[i48 >> 2] | 0;
   if ((i5 | 0) != (i34 | 0)) {
    if (i5) __ZdaPv(i5);
    HEAP32[i48 >> 2] = i34;
    HEAP32[i25 >> 2] = 1032;
   }
   if (i6 >>> 0 > 1032) {
    i12 = __Znaj(i6) | 0;
    HEAP32[i48 >> 2] = i12;
    HEAP32[i25 >> 2] = i6;
   } else i12 = i34;
  } else {
   HEAP32[i25 >> 2] = i6;
   i12 = HEAP32[i48 >> 2] | 0;
  }
  i3 = i12 + (Math_imul(HEAP32[i44 >> 2] | 0, i14) | 0) + 15 & -16;
  __ZN2cv22convertAndUnrollScalarERKNS_3MatEiPhj(i47, HEAP32[i49 >> 2] & 4095, i12, i14);
  i4 = i37 + 16 | 0;
  i5 = (i15 | 0) == 0;
  i6 = i38 + 4 | 0;
  i7 = i35 + 4 | 0;
  i8 = i38 + 8 | 0;
  i9 = i36 + 4 | 0;
  i10 = 0;
  while (1) {
   if (i10 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) break L117;
   if (!i5) {
    i11 = HEAP32[i38 >> 2] | 0;
    if (i43) {
     i2 = 0;
     do {
      i42 = i15 - i2 | 0;
      i42 = i42 >>> 0 > i14 >>> 0 ? i14 : i42;
      i41 = HEAP32[i6 >> 2] | 0;
      HEAP32[i35 >> 2] = Math_imul(i42, i1) | 0;
      HEAP32[i7 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i20 & 255](i11, 0, i12, 0, i41, 0, i35, 0);
      i41 = HEAP32[i6 >> 2] | 0;
      i42 = Math_imul(HEAP32[i44 >> 2] | 0, i42) | 0;
      i11 = (HEAP32[i38 >> 2] | 0) + i42 | 0;
      HEAP32[i38 >> 2] = i11;
      HEAP32[i6 >> 2] = i41 + i42;
      i2 = i2 + i14 | 0;
     } while (i15 >>> 0 > i2 >>> 0);
    } else {
     i2 = 0;
     do {
      i42 = i15 - i2 | 0;
      i42 = i42 >>> 0 > i14 >>> 0 ? i14 : i42;
      HEAP32[i35 >> 2] = Math_imul(i42, i1) | 0;
      HEAP32[i7 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i20 & 255](i11, 0, i12, 0, i3, 0, i35, 0);
      i40 = HEAP32[i8 >> 2] | 0;
      i41 = HEAP32[i6 >> 2] | 0;
      HEAP32[i36 >> 2] = i42;
      HEAP32[i9 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i13 & 255](i3, 0, i40, 0, i41, 0, i36, i44);
      HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i42;
      i42 = Math_imul(HEAP32[i44 >> 2] | 0, i42) | 0;
      i11 = (HEAP32[i38 >> 2] | 0) + i42 | 0;
      HEAP32[i38 >> 2] = i11;
      HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i42;
      i2 = i2 + i14 | 0;
     } while (i15 >>> 0 > i2 >>> 0);
    }
   }
   __ZN2cv15NAryMatIteratorppEv(i37) | 0;
   i10 = i10 + 1 | 0;
  }
 } else {
  HEAP32[i32 >> 2] = i49;
  HEAP32[i32 + 4 >> 2] = i47;
  HEAP32[i32 + 8 >> 2] = i46;
  HEAP32[i32 + 12 >> 2] = i45;
  HEAP32[i32 + 16 >> 2] = 0;
  __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i41, i32, i42, -1);
  i16 = HEAP32[i41 + 20 >> 2] | 0;
  if ((Math_imul(i16, i1) | 0) < 0) i5 = 2147483647 / (i1 | 0) | 0; else i5 = i16;
  do if (!i43) {
   i5 = i6 >>> 0 < i5 >>> 0 ? i6 : i5;
   i6 = Math_imul(HEAP32[i44 >> 2] | 0, i5) | 0;
   if ((HEAP32[i25 >> 2] | 0) >>> 0 >= i6 >>> 0) {
    HEAP32[i25 >> 2] = i6;
    i10 = HEAP32[i48 >> 2] | 0;
    break;
   }
   i4 = HEAP32[i48 >> 2] | 0;
   if ((i4 | 0) != (i34 | 0)) {
    if (i4) __ZdaPv(i4);
    HEAP32[i48 >> 2] = i34;
    HEAP32[i25 >> 2] = 1032;
   }
   if (i6 >>> 0 > 1032) {
    i10 = __Znaj(i6) | 0;
    HEAP32[i48 >> 2] = i10;
    HEAP32[i25 >> 2] = i6;
   } else i10 = i34;
  } else i10 = 0; while (0);
  i14 = i41 + 16 | 0;
  i3 = (i16 | 0) == 0;
  i4 = i42 + 4 | 0;
  i6 = i42 + 8 | 0;
  i7 = i39 + 4 | 0;
  i8 = i42 + 12 | 0;
  i9 = i40 + 4 | 0;
  i15 = 0;
  while (1) {
   if (i15 >>> 0 >= (HEAP32[i14 >> 2] | 0) >>> 0) break L117;
   if (!i3) {
    i11 = HEAP32[i42 >> 2] | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (i43) {
     i12 = 0;
     do {
      i38 = i16 - i12 | 0;
      i38 = i38 >>> 0 > i5 >>> 0 ? i5 : i38;
      i36 = HEAP32[i6 >> 2] | 0;
      HEAP32[i39 >> 2] = Math_imul(i38, i1) | 0;
      HEAP32[i7 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i20 & 255](i11, 0, i2, 0, i36, 0, i39, 0);
      i36 = HEAP32[i4 >> 2] | 0;
      i37 = HEAP32[i6 >> 2] | 0;
      i38 = Math_imul(HEAP32[i44 >> 2] | 0, i38) | 0;
      i11 = (HEAP32[i42 >> 2] | 0) + i38 | 0;
      HEAP32[i42 >> 2] = i11;
      i2 = i36 + i38 | 0;
      HEAP32[i4 >> 2] = i2;
      HEAP32[i6 >> 2] = i37 + i38;
      i12 = i12 + i5 | 0;
     } while (i16 >>> 0 > i12 >>> 0);
    } else {
     i12 = 0;
     do {
      i38 = i16 - i12 | 0;
      i38 = i38 >>> 0 > i5 >>> 0 ? i5 : i38;
      HEAP32[i39 >> 2] = Math_imul(i38, i1) | 0;
      HEAP32[i7 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i20 & 255](i11, 0, i2, 0, i10, 0, i39, 0);
      i36 = HEAP32[i8 >> 2] | 0;
      i37 = HEAP32[i6 >> 2] | 0;
      HEAP32[i40 >> 2] = i38;
      HEAP32[i9 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i13 & 255](i10, 0, i36, 0, i37, 0, i40, i44);
      HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i38;
      i38 = Math_imul(HEAP32[i44 >> 2] | 0, i38) | 0;
      i11 = (HEAP32[i42 >> 2] | 0) + i38 | 0;
      HEAP32[i42 >> 2] = i11;
      i2 = (HEAP32[i4 >> 2] | 0) + i38 | 0;
      HEAP32[i4 >> 2] = i2;
      HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i38;
      i12 = i12 + i5 | 0;
     } while (i16 >>> 0 > i12 >>> 0);
    }
   }
   __ZN2cv15NAryMatIteratorppEv(i41) | 0;
   i15 = i15 + 1 | 0;
  }
 } while (0);
 i3 = i45 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i43 = i2 + 12 | 0, i44 = HEAP32[i43 >> 2] | 0, HEAP32[i43 >> 2] = i44 + -1, (i44 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i45);
 HEAP32[i3 >> 2] = 0;
 i44 = i45 + 16 | 0;
 i3 = i45 + 4 | 0;
 HEAP32[i44 + 0 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i45 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i3 = HEAP32[i45 + 44 >> 2] | 0;
 if ((i3 | 0) != (i45 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
 i3 = i46 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i44 = i2 + 12 | 0, i45 = HEAP32[i44 >> 2] | 0, HEAP32[i44 >> 2] = i45 + -1, (i45 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i46);
 HEAP32[i3 >> 2] = 0;
 i45 = i46 + 16 | 0;
 i3 = i46 + 4 | 0;
 HEAP32[i45 + 0 >> 2] = 0;
 HEAP32[i45 + 4 >> 2] = 0;
 HEAP32[i45 + 8 >> 2] = 0;
 HEAP32[i45 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i46 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i3 = HEAP32[i46 + 44 >> 2] | 0;
 if ((i3 | 0) != (i46 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
 i3 = i47 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i45 = i2 + 12 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i47);
 HEAP32[i3 >> 2] = 0;
 i46 = i47 + 16 | 0;
 i3 = i47 + 4 | 0;
 HEAP32[i46 + 0 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 HEAP32[i46 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i47 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i2 = HEAP32[i47 + 44 >> 2] | 0;
 if ((i2 | 0) != (i47 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i49 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i45 = i1 + 12 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i49);
 HEAP32[i2 >> 2] = 0;
 i46 = i49 + 16 | 0;
 i3 = i49 + 4 | 0;
 HEAP32[i46 + 0 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 HEAP32[i46 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i49 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i49 + 44 >> 2] | 0;
 if ((i1 | 0) != (i49 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = HEAP32[i48 >> 2] | 0;
 if ((i1 | 0) == (i34 | 0)) {
  STACKTOP = i50;
  return;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i48 >> 2] = i34;
 HEAP32[i25 >> 2] = 1032;
 STACKTOP = i50;
 return;
}

function __ZN2cv7compareERKNS_11_InputArrayES2_RKNS_12_OutputArrayEi(i11, i17, i22, i9) {
 i11 = i11 | 0;
 i17 = i17 | 0;
 i22 = i22 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 1808 | 0;
 i15 = i44 + 1792 | 0;
 i12 = i44 + 1784 | 0;
 i40 = i44 + 1776 | 0;
 i6 = i44 + 1768 | 0;
 i16 = i44 + 1760 | 0;
 i43 = i44 + 1704 | 0;
 i42 = i44 + 1648 | 0;
 i10 = i44 + 1640 | 0;
 i20 = i44 + 1584 | 0;
 i18 = i44 + 1576 | 0;
 i19 = i44 + 1520 | 0;
 i21 = i44 + 1464 | 0;
 i41 = i44 + 1408 | 0;
 i23 = i44 + 1352 | 0;
 i24 = i44 + 1336 | 0;
 i30 = i44 + 1320 | 0;
 i29 = i44 + 1288 | 0;
 i26 = i44 + 1280 | 0;
 i25 = i44 + 1264 | 0;
 i38 = i44 + 1256 | 0;
 i37 = i44 + 1224 | 0;
 i39 = i44 + 184 | 0;
 i28 = i44 + 96 | 0;
 i27 = i44 + 176 | 0;
 i32 = i44 + 64 | 0;
 i33 = i44 + 32 | 0;
 i34 = i44 + 168 | 0;
 i31 = i44;
 i35 = i44 + 112 | 0;
 i36 = i44 + 104 | 0;
 HEAP32[i40 >> 2] = i9;
 if (i9 >>> 0 >= 6) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i9 = (__ZN2cv6String8allocateEj(i6, 92) | 0) + 0 | 0;
  i8 = 4768 | 0;
  i7 = i9 + 92 | 0;
  do {
   HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
   i9 = i9 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i9 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i6, 4864, 4712, 3772);
  __ZN2cv6String10deallocateEv(i6);
 }
 i3 = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] & 127](i11) | 0) == 131072 & 1;
 if (((((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] & 127](i17) | 0) == 131072 & 1) + i3 | 0) != 1 ? FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 48 >> 2] & 127](i11, i17) | 0 : 0) ? (i3 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] & 127](i11, -1) | 0, (i3 | 0) == (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i17 >> 2] | 0) + 56 >> 2] & 127](i17, -1) | 0)) : 0) i15 = 0; else i1 = 6;
 L7 : do if ((i1 | 0) == 6) {
  i9 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i17 >> 2] | 0) + 56 >> 2] & 127](i17, -1) | 0;
  i8 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] & 127](i11) | 0;
  i7 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] & 127](i17) | 0;
  L9 : do if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] & 127](i11, -1) | 0) <= 2 ? FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 68 >> 2] & 127](i11, -1) | 0 : 0) {
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] & 63](i12, i11, -1);
   i6 = HEAP32[i12 >> 2] | 0;
   i5 = (i6 | 0) == 1;
   if (!i5 ? (HEAP32[i12 + 4 >> 2] | 0) != 1 : 0) break;
   i3 = (i9 >>> 3 & 511) + 1 | 0;
   if (!((i7 | 0) == 131072 & (i8 | 0) != 131072)) {
    if (!(i5 ? (i7 = HEAP32[i12 + 4 >> 2] | 0, (i7 | 0) == 1 | (i7 | 0) == (i3 | 0)) : 0)) i1 = 13;
    do if ((i1 | 0) == 13) {
     if ((i6 | 0) == (i3 | 0)) {
      i9 = HEAP32[i12 + 4 >> 2] | 0;
      i8 = (i9 | 0) == 1;
      if (i8 | i5 ^ 1) if (i8) break; else break L9;
     } else {
      if (!i5) break L9;
      i9 = HEAP32[i12 + 4 >> 2] | 0;
     }
     if ((i9 | 0) != 4) break L9;
     if (!((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] & 127](i11, -1) | 0) == 6 & i3 >>> 0 < 5)) break L9;
    } while (0);
    i3 = HEAP32[i40 >> 2] | 0;
    if ((i3 | 0) != 3) if ((i3 | 0) != 4) if ((i3 | 0) == 2) i3 = 4; else i3 = (i3 | 0) == 1 ? 3 : i3; else i3 = 2; else i3 = 1;
    HEAP32[i40 >> 2] = i3;
    __ZN2cv7compareERKNS_11_InputArrayES2_RKNS_12_OutputArrayEi(i17, i11, i22, i3);
    STACKTOP = i44;
    return;
   }
  } while (0);
  i9 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] & 127](i11, -1) | 0;
  i8 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] & 127](i17) | 0;
  i7 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] & 127](i11) | 0;
  do if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i17 >> 2] | 0) + 28 >> 2] & 127](i17, -1) | 0) <= 2 ? FUNCTION_TABLE_iii[HEAP32[(HEAP32[i17 >> 2] | 0) + 68 >> 2] & 127](i17, -1) | 0 : 0) {
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i17 >> 2] | 0) + 40 >> 2] & 63](i15, i17, -1);
   i6 = HEAP32[i15 >> 2] | 0;
   i5 = (i6 | 0) == 1;
   if (!i5 ? (HEAP32[i15 + 4 >> 2] | 0) != 1 : 0) break;
   i3 = (i9 >>> 3 & 511) + 1 | 0;
   if (!((i7 | 0) == 131072 & (i8 | 0) != 131072)) {
    if (i5 ? (i12 = HEAP32[i15 + 4 >> 2] | 0, (i12 | 0) == 1 | (i12 | 0) == (i3 | 0)) : 0) {
     i15 = 1;
     break L7;
    }
    if ((i6 | 0) == (i3 | 0)) {
     i9 = HEAP32[i15 + 4 >> 2] | 0;
     i8 = (i9 | 0) == 1;
     if (i8 | i5 ^ 1) if (i8) {
      i15 = 1;
      break L7;
     } else break;
    } else {
     if (!i5) break;
     i9 = HEAP32[i15 + 4 >> 2] | 0;
    }
    if ((i9 | 0) == 4 ? (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i17 >> 2] | 0) + 56 >> 2] & 127](i17, -1) | 0) == 6 & i3 >>> 0 < 5 : 0) {
     i15 = 1;
     break L7;
    }
   }
  } while (0);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  _memcpy(__ZN2cv6String8allocateEj(i16, 139) | 0, 4872, 139) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-209, i16, 4864, 4712, 3791);
  __ZN2cv6String10deallocateEv(i16);
  i15 = 1;
 } while (0);
 i12 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] & 127](i11) | 0;
 i16 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] & 127](i17) | 0;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i11 >> 2] >> 2] & 63](i43, i11, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i17 >> 2] >> 2] & 63](i42, i17, -1);
 i9 = HEAP32[i43 + 4 >> 2] | 0;
 if ((((i12 | 0) == (i16 | 0) & (i9 | 0) < 3 ? (HEAP32[i42 + 4 >> 2] | 0) < 3 : 0) ? (i13 = HEAP32[i43 + 40 >> 2] | 0, i14 = HEAP32[i13 + 4 >> 2] | 0, i13 = HEAP32[i13 >> 2] | 0, i17 = HEAP32[i42 + 40 >> 2] | 0, (i13 | 0) == (HEAP32[i17 >> 2] | 0) ? (i14 | 0) == (HEAP32[i17 + 4 >> 2] | 0) : 0) : 0) ? (i2 = HEAP32[i43 >> 2] | 0, ((HEAP32[i42 >> 2] ^ i2) & 4095 | 0) == 0) : 0) {
  i1 = HEAP32[(HEAP32[i22 >> 2] | 0) + 136 >> 2] | 0;
  HEAP32[i10 >> 2] = i14;
  HEAP32[i10 + 4 >> 2] = i13;
  FUNCTION_TABLE_viiiiii[i1 & 31](i22, i10, i2 & 4088, -1, 0, 0);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i22 >> 2] >> 2] & 63](i20, i22, -1);
  i1 = HEAP32[i43 >> 2] | 0;
  i3 = (i1 >>> 3 & 511) + 1 | 0;
  i2 = HEAP32[i43 + 12 >> 2] | 0;
  if (!(i1 & 16384 & HEAP32[i42 >> 2] & HEAP32[i20 >> 2])) {
   i3 = Math_imul(i2, i3) | 0;
   i2 = HEAP32[i43 + 8 >> 2] | 0;
  } else {
   i3 = Math_imul(Math_imul(i2, i3) | 0, HEAP32[i43 + 8 >> 2] | 0) | 0;
   i2 = 1;
  }
  i15 = HEAP32[5144 + ((i1 & 7) << 2) >> 2] | 0;
  i16 = HEAP32[i43 + 16 >> 2] | 0;
  i17 = HEAP32[i43 + 48 >> 2] | 0;
  i19 = HEAP32[i42 + 16 >> 2] | 0;
  i21 = HEAP32[i42 + 48 >> 2] | 0;
  i5 = i20 + 16 | 0;
  i22 = HEAP32[i5 >> 2] | 0;
  i7 = i20 + 44 | 0;
  i6 = i20 + 48 | 0;
  i23 = HEAP32[i6 >> 2] | 0;
  HEAP32[i18 >> 2] = i3;
  HEAP32[i18 + 4 >> 2] = i2;
  FUNCTION_TABLE_viiiiiiii[i15 & 255](i16, i17, i19, i21, i22, i23, i18, i40);
  i3 = i20 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i22 = i2 + 12 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i20);
  HEAP32[i3 >> 2] = 0;
  i1 = i20 + 4 | 0;
  HEAP32[i5 + 0 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  if ((HEAP32[i1 >> 2] | 0) > 0) {
   i3 = HEAP32[i20 + 40 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
  }
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) != (i6 | 0)) __ZN2cv8fastFreeEPv(i2);
 } else {
  i8 = HEAP32[i43 >> 2] | 0;
  i17 = i8 & 7;
  i1 = HEAP32[i42 >> 2] & 7;
  i12 = i43 + 4 | 0;
  FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i22 >> 2] | 0) + 144 >> 2] & 63](i22, i9, HEAP32[i43 + 40 >> 2] | 0, i8 & 4088, -1, 0, 0);
  __ZNK2cv3Mat7reshapeEii(i19, i43, 1, 0);
  __ZN2cv3MataSERKS0_(i43, i19) | 0;
  i9 = i19 + 36 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  if ((i8 | 0) != 0 ? (i18 = i8 + 12 | 0, i20 = HEAP32[i18 >> 2] | 0, HEAP32[i18 >> 2] = i20 + -1, (i20 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i19);
  HEAP32[i9 >> 2] = 0;
  i20 = i19 + 16 | 0;
  i9 = i19 + 4 | 0;
  HEAP32[i20 + 0 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  HEAP32[i20 + 12 >> 2] = 0;
  if ((HEAP32[i9 >> 2] | 0) > 0) {
   i8 = HEAP32[i19 + 40 >> 2] | 0;
   i7 = 0;
   do {
    HEAP32[i8 + (i7 << 2) >> 2] = 0;
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) < (HEAP32[i9 >> 2] | 0));
  }
  i9 = HEAP32[i19 + 44 >> 2] | 0;
  if ((i9 | 0) != (i19 + 48 | 0)) __ZN2cv8fastFreeEPv(i9);
  __ZNK2cv3Mat7reshapeEii(i21, i42, 1, 0);
  __ZN2cv3MataSERKS0_(i42, i21) | 0;
  i9 = i21 + 36 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  if ((i8 | 0) != 0 ? (i19 = i8 + 12 | 0, i20 = HEAP32[i19 >> 2] | 0, HEAP32[i19 >> 2] = i20 + -1, (i20 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i21);
  HEAP32[i9 >> 2] = 0;
  i20 = i21 + 16 | 0;
  i9 = i21 + 4 | 0;
  HEAP32[i20 + 0 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  HEAP32[i20 + 12 >> 2] = 0;
  if ((HEAP32[i9 >> 2] | 0) > 0) {
   i8 = HEAP32[i21 + 40 >> 2] | 0;
   i7 = 0;
   do {
    HEAP32[i8 + (i7 << 2) >> 2] = 0;
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) < (HEAP32[i9 >> 2] | 0));
  }
  i9 = HEAP32[i21 + 44 >> 2] | 0;
  if ((i9 | 0) != (i21 + 48 | 0)) __ZN2cv8fastFreeEPv(i9);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i22 >> 2] >> 2] & 63](i23, i22, -1);
  __ZNK2cv3Mat7reshapeEii(i41, i23, 1, 0);
  i9 = i23 + 36 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  if ((i8 | 0) != 0 ? (i21 = i8 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i23);
  HEAP32[i9 >> 2] = 0;
  i22 = i23 + 16 | 0;
  i9 = i23 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i9 >> 2] | 0) > 0) {
   i8 = HEAP32[i23 + 40 >> 2] | 0;
   i7 = 0;
   do {
    HEAP32[i8 + (i7 << 2) >> 2] = 0;
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) < (HEAP32[i9 >> 2] | 0));
  }
  i9 = HEAP32[i23 + 44 >> 2] | 0;
  if ((i9 | 0) != (i23 + 48 | 0)) __ZN2cv8fastFreeEPv(i9);
  i9 = HEAP32[i12 >> 2] | 0;
  if ((i9 | 0) > 0) i13 = HEAP32[(HEAP32[i43 + 44 >> 2] | 0) + (i9 + -1 << 2) >> 2] | 0; else i13 = 0;
  i9 = ((i13 + 1023 | 0) >>> 0) / (i13 >>> 0) | 0;
  i16 = HEAP32[5144 + (i17 << 2) >> 2] | 0;
  L114 : do if (i15) {
   HEAP32[i25 >> 2] = i43;
   HEAP32[i25 + 4 >> 2] = i41;
   HEAP32[i25 + 8 >> 2] = 0;
   __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i37, i25, i38, -1);
   i12 = HEAP32[i37 + 20 >> 2] | 0;
   i10 = i9 >>> 0 < i12 >>> 0 ? i9 : i12;
   i9 = Math_imul(i10, i13) | 0;
   i14 = i39 + 8 | 0;
   HEAP32[i39 >> 2] = i14;
   i15 = i39 + 4 | 0;
   HEAP32[i15 >> 2] = 1032;
   if (i9 >>> 0 > 1032) {
    i11 = __Znaj(i9) | 0;
    HEAP32[i39 >> 2] = i11;
   } else i11 = i14;
   HEAP32[i15 >> 2] = i9;
   do if (i17 >>> 0 > 4) __ZN2cv22convertAndUnrollScalarERKNS_3MatEiPhj(i42, i17, i11, i10); else {
    HEAPF64[i28 >> 3] = 0.0;
    i22 = __ZN2cv14getConvertFuncEii(i1, 6) | 0;
    i23 = HEAP32[i42 + 16 >> 2] | 0;
    HEAP32[i27 >> 2] = 1;
    HEAP32[i27 + 4 >> 2] = 1;
    FUNCTION_TABLE_viiiiiiii[i22 & 255](i23, 1, 0, 1, i28, 1, i27, 0);
    d4 = +HEAPF64[i28 >> 3];
    if (d4 < +HEAPF64[5080 + (i17 << 3) >> 3]) {
     i3 = HEAP32[i40 >> 2] | 0;
     if ((i3 + -1 | 0) >>> 0 < 2) d4 = 255.0; else d4 = (i3 | 0) == 5 ? 255.0 : 0.0;
     i3 = i32;
     HEAP32[i3 >> 2] = 0;
     HEAP32[i3 + 4 >> 2] = 0;
     HEAPF64[i32 >> 3] = d4;
     HEAPF64[i32 + 8 >> 3] = d4;
     HEAPF64[i32 + 16 >> 3] = d4;
     HEAPF64[i32 + 24 >> 3] = d4;
     __ZN2cv3MataSERKNS_7Scalar_IdEE(i41, i32) | 0;
     i3 = HEAP32[i39 >> 2] | 0;
     if ((i3 | 0) == (i14 | 0)) break L114;
     if (i3) __ZdaPv(i3);
     HEAP32[i39 >> 2] = i14;
     HEAP32[i15 >> 2] = 1032;
     break L114;
    }
    if (d4 > +HEAPF64[5016 + (i17 << 3) >> 3]) {
     i3 = HEAP32[i40 >> 2] | 0;
     if ((i3 + -3 | 0) >>> 0 < 2) d4 = 255.0; else d4 = (i3 | 0) == 5 ? 255.0 : 0.0;
     i3 = i33;
     HEAP32[i3 >> 2] = 0;
     HEAP32[i3 + 4 >> 2] = 0;
     HEAPF64[i33 >> 3] = d4;
     HEAPF64[i33 + 8 >> 3] = d4;
     HEAPF64[i33 + 16 >> 3] = d4;
     HEAPF64[i33 + 24 >> 3] = d4;
     __ZN2cv3MataSERKNS_7Scalar_IdEE(i41, i33) | 0;
     i3 = HEAP32[i39 >> 2] | 0;
     if ((i3 | 0) == (i14 | 0)) break L114;
     if (i3) __ZdaPv(i3);
     HEAP32[i39 >> 2] = i14;
     HEAP32[i15 >> 2] = 1032;
     break L114;
    }
    i23 = _lrint(d4) | 0;
    HEAP32[i34 >> 2] = i23;
    do if (d4 != +(i23 | 0)) {
     i7 = HEAP32[i40 >> 2] | 0;
     if ((i7 & -2 | 0) == 2) {
      i23 = ~~d4;
      HEAP32[i34 >> 2] = (+(i23 | 0) < d4 & 1) + i23;
      break;
     }
     if ((i7 | 0) == 1 | (i7 | 0) == 4) {
      i23 = ~~d4;
      HEAP32[i34 >> 2] = i23 - (+(i23 | 0) > d4 & 1);
      break;
     }
     d4 = (i7 | 0) == 5 ? 255.0 : 0.0;
     i3 = i31;
     HEAP32[i3 >> 2] = 0;
     HEAP32[i3 + 4 >> 2] = 0;
     HEAPF64[i31 >> 3] = d4;
     HEAPF64[i31 + 8 >> 3] = d4;
     HEAPF64[i31 + 16 >> 3] = d4;
     HEAPF64[i31 + 24 >> 3] = d4;
     __ZN2cv3MataSERKNS_7Scalar_IdEE(i41, i31) | 0;
     i3 = HEAP32[i39 >> 2] | 0;
     if ((i3 | 0) == (i14 | 0)) break L114;
     if (i3) __ZdaPv(i3);
     HEAP32[i39 >> 2] = i14;
     HEAP32[i15 >> 2] = 1032;
     break L114;
    } while (0);
    i5 = i35 + 4 | 0;
    HEAP32[i5 >> 2] = 2;
    i2 = i35 + 8 | 0;
    HEAP32[i2 >> 2] = 1;
    HEAP32[i35 + 12 >> 2] = 1;
    i9 = i35 + 16 | 0;
    HEAP32[i9 >> 2] = i34;
    HEAP32[i35 + 20 >> 2] = i34;
    i7 = i35 + 24 | 0;
    i8 = i35 + 40 | 0;
    HEAP32[i7 + 0 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    HEAP32[i7 + 12 >> 2] = 0;
    HEAP32[i8 >> 2] = i2;
    i2 = i35 + 48 | 0;
    i3 = i35 + 44 | 0;
    HEAP32[i3 >> 2] = i2;
    HEAP32[i35 >> 2] = 1124024324;
    HEAP32[i2 >> 2] = 4;
    HEAP32[i35 + 52 >> 2] = 4;
    i6 = i34 + 4 | 0;
    HEAP32[i35 + 28 >> 2] = i6;
    HEAP32[i7 >> 2] = i6;
    __ZN2cv22convertAndUnrollScalarERKNS_3MatEiPhj(i35, i17, i11, i10);
    i7 = i35 + 36 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    do if (i6) {
     i22 = i6 + 12 | 0;
     i23 = HEAP32[i22 >> 2] | 0;
     HEAP32[i22 >> 2] = i23 + -1;
     if ((i23 | 0) != 1) break;
     __ZN2cv3Mat10deallocateEv(i35);
    } while (0);
    HEAP32[i7 >> 2] = 0;
    HEAP32[i9 + 0 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    HEAP32[i9 + 8 >> 2] = 0;
    HEAP32[i9 + 12 >> 2] = 0;
    if ((HEAP32[i5 >> 2] | 0) > 0) {
     i7 = HEAP32[i8 >> 2] | 0;
     i6 = 0;
     do {
      HEAP32[i7 + (i6 << 2) >> 2] = 0;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) < (HEAP32[i5 >> 2] | 0));
    }
    i7 = HEAP32[i3 >> 2] | 0;
    if ((i7 | 0) == (i2 | 0)) break;
    __ZN2cv8fastFreeEPv(i7);
   } while (0);
   i7 = i37 + 16 | 0;
   i6 = (i12 | 0) == 0;
   i5 = i38 + 4 | 0;
   i3 = i36 + 4 | 0;
   i8 = 0;
   while (1) {
    if (i8 >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) break;
    if (!i6) {
     i2 = HEAP32[i38 >> 2] | 0;
     i1 = HEAP32[i5 >> 2] | 0;
     i9 = 0;
     do {
      i23 = i12 - i9 | 0;
      i23 = i23 >>> 0 > i10 >>> 0 ? i10 : i23;
      HEAP32[i36 >> 2] = i23;
      HEAP32[i3 >> 2] = 1;
      FUNCTION_TABLE_viiiiiiii[i16 & 255](i2, 0, i11, 0, i1, 0, i36, i40);
      i22 = Math_imul(i23, i13) | 0;
      i2 = (HEAP32[i38 >> 2] | 0) + i22 | 0;
      HEAP32[i38 >> 2] = i2;
      i1 = (HEAP32[i5 >> 2] | 0) + i23 | 0;
      HEAP32[i5 >> 2] = i1;
      i9 = i9 + i10 | 0;
     } while (i12 >>> 0 > i9 >>> 0);
    }
    __ZN2cv15NAryMatIteratorppEv(i37) | 0;
    i8 = i8 + 1 | 0;
   }
   i3 = HEAP32[i39 >> 2] | 0;
   if ((i3 | 0) != (i14 | 0)) {
    if (i3) __ZdaPv(i3);
    HEAP32[i39 >> 2] = i14;
    HEAP32[i15 >> 2] = 1032;
   }
  } else {
   HEAP32[i24 >> 2] = i43;
   HEAP32[i24 + 4 >> 2] = i42;
   HEAP32[i24 + 8 >> 2] = i41;
   HEAP32[i24 + 12 >> 2] = 0;
   __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i29, i24, i30, -1);
   i5 = HEAP32[i29 + 20 >> 2] | 0;
   i3 = i29 + 16 | 0;
   i2 = i30 + 4 | 0;
   i1 = i30 + 8 | 0;
   i6 = i26 + 4 | 0;
   i7 = 0;
   while (1) {
    if (i7 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) break L114;
    i21 = HEAP32[i30 >> 2] | 0;
    i22 = HEAP32[i2 >> 2] | 0;
    i23 = HEAP32[i1 >> 2] | 0;
    HEAP32[i26 >> 2] = i5;
    HEAP32[i6 >> 2] = 1;
    FUNCTION_TABLE_viiiiiiii[i16 & 255](i21, 0, i22, 0, i23, 0, i26, i40);
    __ZN2cv15NAryMatIteratorppEv(i29) | 0;
    i7 = i7 + 1 | 0;
   }
  } while (0);
  i3 = i41 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i22 = i2 + 12 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i41);
  HEAP32[i3 >> 2] = 0;
  i23 = i41 + 16 | 0;
  i3 = i41 + 4 | 0;
  HEAP32[i23 + 0 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = 0;
  HEAP32[i23 + 8 >> 2] = 0;
  HEAP32[i23 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i41 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i2 = HEAP32[i41 + 44 >> 2] | 0;
  if ((i2 | 0) != (i41 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 }
 i2 = i42 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i22 = i1 + 12 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i42);
 HEAP32[i2 >> 2] = 0;
 i23 = i42 + 16 | 0;
 i3 = i42 + 4 | 0;
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i42 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i42 + 44 >> 2] | 0;
 if ((i1 | 0) != (i42 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i43 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i22 = i2 + 12 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i43);
 HEAP32[i1 >> 2] = 0;
 i23 = i43 + 16 | 0;
 i2 = i43 + 4 | 0;
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i43 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i43 + 44 >> 2] | 0;
 if ((i1 | 0) == (i43 + 48 | 0)) {
  STACKTOP = i44;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i44;
 return;
}

function _cvOpenFileStorage(i14, i3, i11, i20) {
 i14 = i14 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 1216 | 0;
 i28 = i30;
 i27 = i30 + 108 | 0;
 i21 = i30 + 80 | 0;
 i22 = i30 + 76 | 0;
 i23 = i30 + 72 | 0;
 i24 = i30 + 68 | 0;
 i29 = i30 + 64 | 0;
 i7 = i30 + 56 | 0;
 i4 = i30 + 48 | 0;
 i9 = i30 + 40 | 0;
 i10 = i30 + 104 | 0;
 i18 = i30 + 32 | 0;
 i19 = i30 + 24 | 0;
 i25 = i30 + 16 | 0;
 i13 = i30 + 88 | 0;
 HEAP32[i29 >> 2] = 0;
 i1 = i11 & 3;
 i16 = (i1 | 0) == 2;
 i5 = i11 >>> 2;
 i1 = (i1 | 0) != 0;
 i12 = (i14 | 0) != 0;
 if (i12 ? (HEAP8[i14 >> 0] | 0) != 0 : 0) {
  i6 = _strlen(i14 | 0) | 0;
  i15 = (i5 & 1 | 0) != 0;
 } else if (i1) {
  i6 = 0;
  i15 = 1;
 } else {
  i15 = (i5 & 1 | 0) != 0 ? 9312 : 9336;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i6 = _strlen(i15 | 0) | 0;
  _memcpy(__ZN2cv6String8allocateEj(i7, i6) | 0, i15 | 0, i6 | 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i7, 9360, 8960, 2665);
  __ZN2cv6String10deallocateEv(i7);
  i6 = 0;
  i15 = 1;
 }
 i17 = i16 ^ 1;
 if (!(i15 ^ 1 | i17)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i4, 68) | 0) + 0 | 0;
  i5 = 9384;
  i8 = i7 + 68 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i5 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i7 | 0) < (i8 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-206, i4, 9360, 8960, 2672);
  __ZN2cv6String10deallocateEv(i4);
 }
 i5 = _cvAlloc(276) | 0;
 HEAP32[i29 >> 2] = i5;
 _memset(i5 | 0, 0, 276) | 0;
 i5 = _cvCreateMemStorage(262144) | 0;
 HEAP32[(HEAP32[i29 >> 2] | 0) + 16 >> 2] = i5;
 i5 = HEAP32[i29 >> 2] | 0;
 if (!i3) i7 = HEAP32[i5 + 16 >> 2] | 0; else i7 = i3;
 HEAP32[i5 + 20 >> 2] = i7;
 i2 = HEAP32[i29 >> 2] | 0;
 HEAP32[i2 >> 2] = 1280131417;
 HEAP32[i2 + 8 >> 2] = i1 & 1;
 L14 : do if (!i15) {
  i5 = _cvMemStorageAlloc(HEAP32[i2 + 16 >> 2] | 0, i6 + 1 | 0) | 0;
  HEAP32[(HEAP32[i29 >> 2] | 0) + 60 >> 2] = i5;
  _strcpy(HEAP32[(HEAP32[i29 >> 2] | 0) + 60 >> 2] | 0, i14 | 0) | 0;
  i5 = HEAP32[i29 >> 2] | 0;
  i3 = HEAP32[i5 + 60 >> 2] | 0;
  i4 = _strrchr(i3, 46) | 0;
  do if (((i4 | 0) != 0 ? (HEAP8[i4 + 1 >> 0] | 0) == 103 : 0) ? (HEAP8[i4 + 2 >> 0] | 0) == 122 : 0) {
   i2 = i4 + 3 | 0;
   i7 = HEAP8[i2 >> 0] | 0;
   if (i7 << 24 >> 24) {
    if ((i7 + -48 << 24 >> 24 & 255) >= 10) break;
    if (HEAP8[i4 + 4 >> 0] | 0) break;
   }
   if (i16) {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    i7 = (__ZN2cv6String8allocateEj(i9, 52) | 0) + 0 | 0;
    i5 = 9456;
    i8 = i7 + 52 | 0;
    do {
     HEAP8[i7 >> 0] = HEAP8[i5 >> 0] | 0;
     i7 = i7 + 1 | 0;
     i5 = i5 + 1 | 0;
    } while ((i7 | 0) < (i8 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i9, 9360, 8960, 2695);
    __ZN2cv6String10deallocateEv(i9);
    i7 = HEAP8[i2 >> 0] | 0;
   }
   if (!(i7 << 24 >> 24)) i7 = 0; else {
    HEAP8[i2 >> 0] = 0;
    i6 = i6 + -1 | 0;
   }
   i2 = HEAP32[i29 >> 2] | 0;
   HEAP8[i10 >> 0] = (HEAP32[i2 + 8 >> 2] | 0) != 0 ? 119 : 114;
   HEAP8[i10 + 1 >> 0] = 98;
   HEAP8[i10 + 2 >> 0] = i7 << 24 >> 24 != 0 ? i7 : 51;
   HEAP8[i10 + 3 >> 0] = 0;
   i2 = _gzopen(HEAP32[i2 + 60 >> 2] | 0, i10) | 0;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 68 >> 2] = i2;
   i2 = HEAP32[i29 >> 2] | 0;
   if (!(HEAP32[i2 + 68 >> 2] | 0)) {
    i1 = 0;
    break L14;
   } else {
    i5 = i6;
    i4 = 1;
    i26 = 25;
    break L14;
   }
  } while (0);
  if (!(HEAP32[i5 + 8 >> 2] | 0)) i7 = 9512; else i7 = i16 ? 9528 : 9520;
  i2 = _fopen(i3 | 0, i7 | 0) | 0;
  HEAP32[(HEAP32[i29 >> 2] | 0) + 64 >> 2] = i2;
  i2 = HEAP32[i29 >> 2] | 0;
  if (!(HEAP32[i2 + 64 >> 2] | 0)) i1 = 0; else {
   i5 = i6;
   i4 = 0;
   i26 = 25;
  }
 } else {
  i5 = i6;
  i4 = 0;
  i26 = 25;
 } while (0);
 if ((i26 | 0) == 25) {
  HEAP32[i2 + 32 >> 2] = 0;
  i6 = HEAP32[i29 >> 2] | 0;
  HEAP32[i6 + 40 >> 2] = 0;
  HEAP32[i6 + 44 >> 2] = 0;
  HEAP32[i6 + 84 >> 2] = 71;
  do if (!(HEAP32[i6 + 8 >> 2] | 0)) {
   if (i15) {
    HEAP32[i6 + 256 >> 2] = i14;
    i6 = HEAP32[i29 >> 2] | 0;
    HEAP32[i6 + 260 >> 2] = i5;
   }
   __ZL7icvGetsP13CvFileStoragePci(i6, i13, 14) | 0;
   i20 = (_strncmp(i13, 9912, 6) | 0) == 0;
   i6 = HEAP32[i29 >> 2] | 0;
   HEAP32[i6 + 4 >> 2] = i20 ? 16 : 8;
   if (i4) {
    i5 = i6;
    i4 = 1048576;
   } else {
    if (i15) {
     i5 = i6;
     i6 = HEAP32[i6 + 260 >> 2] | 0;
    } else {
     _fseek(HEAP32[i6 + 64 >> 2] | 0, 0, 2) | 0;
     i6 = _ftell(HEAP32[(HEAP32[i29 >> 2] | 0) + 64 >> 2] | 0) | 0;
     i5 = HEAP32[i29 >> 2] | 0;
    }
    i4 = i6 >>> 0 > 1048576 ? 1048576 : i6;
    i4 = i4 >>> 0 < 9216 ? 9216 : i4;
   }
   i6 = HEAP32[i5 + 64 >> 2] | 0;
   if (!i6) {
    i6 = HEAP32[i5 + 68 >> 2] | 0;
    if (i6) _gzrewind(i6) | 0;
   } else _rewind(i6 | 0);
   HEAP32[i5 + 264 >> 2] = 0;
   i20 = HEAP32[(HEAP32[i29 >> 2] | 0) + 16 >> 2] | 0;
   i8 = _cvCreateSet(0, 72, 16, i20) | 0;
   HEAP32[i8 + 64 >> 2] = 256;
   i20 = _cvMemStorageAlloc(i20, 1024) | 0;
   HEAP32[i8 + 68 >> 2] = i20;
   _memset(i20 | 0, 0, 1024) | 0;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 28 >> 2] = i8;
   i8 = _cvCreateSeq(0, 56, 16, HEAP32[(HEAP32[i29 >> 2] | 0) + 16 >> 2] | 0) | 0;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 32 >> 2] = i8;
   i8 = _cvAlloc(i4 + 256 | 0) | 0;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 76 >> 2] = i8;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 72 >> 2] = i8;
   i8 = HEAP32[i29 >> 2] | 0;
   HEAP32[i8 + 80 >> 2] = (HEAP32[i8 + 76 >> 2] | 0) + i4;
   HEAP8[HEAP32[(HEAP32[i29 >> 2] | 0) + 72 >> 2] >> 0] = 10;
   HEAP8[(HEAP32[(HEAP32[i29 >> 2] | 0) + 72 >> 2] | 0) + 1 >> 0] = 0;
   i8 = HEAP32[i29 >> 2] | 0;
   L114 : do if ((HEAP32[i8 + 4 >> 2] | 0) == 8) {
    i6 = HEAP32[i8 + 76 >> 2] | 0;
    HEAP32[i21 >> 2] = 0;
    HEAP32[i22 >> 2] = 0;
    HEAP32[i23 >> 2] = 0;
    HEAP32[i24 >> 2] = 0;
    i6 = __ZL16icvXMLSkipSpacesP13CvFileStoragePci(i8, i6, 2) | 0;
    if (_memcmp(i6, 15584, 5) | 0) {
     i20 = HEAP32[i8 + 88 >> 2] | 0;
     HEAP32[i28 >> 2] = HEAP32[i8 + 60 >> 2];
     HEAP32[i28 + 4 >> 2] = i20;
     HEAP32[i28 + 8 >> 2] = 15608;
     _sprintf(i27, 17440, i28) | 0;
     _cvError(-212, 15592, i27, 8960, 2220);
    }
    i6 = __ZL14icvXMLParseTagP13CvFileStoragePcPP16CvStringHashNodePP10CvAttrListPi(i8, i6, i21, i23, i24) | 0;
    if (HEAP8[i6 >> 0] | 0) {
     i7 = i8 + 32 | 0;
     i5 = i8 + 60 | 0;
     i4 = i8 + 88 | 0;
     do {
      i6 = __ZL16icvXMLSkipSpacesP13CvFileStoragePci(i8, i6, 0) | 0;
      if (!(HEAP8[i6 >> 0] | 0)) break L114;
      i6 = __ZL14icvXMLParseTagP13CvFileStoragePcPP16CvStringHashNodePP10CvAttrListPi(i8, i6, i21, i23, i24) | 0;
      if (!((HEAP32[i24 >> 2] | 0) == 1 ? (_strcmp(HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0, 15656) | 0) == 0 : 0)) {
       i20 = HEAP32[i4 >> 2] | 0;
       HEAP32[i28 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i28 + 4 >> 2] = i20;
       HEAP32[i28 + 8 >> 2] = 15672;
       _sprintf(i27, 17440, i28) | 0;
       _cvError(-212, 15592, i27, 8960, 2249);
      }
      i6 = __ZL14icvXMLParseTagP13CvFileStoragePcPP16CvStringHashNodePP10CvAttrListPi(i8, __ZL16icvXMLParseValueP13CvFileStoragePcP10CvFileNodei(i8, i6, _cvSeqPush(HEAP32[i7 >> 2] | 0, 0) | 0, 0) | 0, i22, i23, i24) | 0;
      if (!((HEAP32[i24 >> 2] | 0) == 2 ? (HEAP32[i21 >> 2] | 0) == (HEAP32[i22 >> 2] | 0) : 0)) {
       i20 = HEAP32[i4 >> 2] | 0;
       HEAP32[i28 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i28 + 4 >> 2] = i20;
       HEAP32[i28 + 8 >> 2] = 15704;
       _sprintf(i27, 17440, i28) | 0;
       _cvError(-212, 15592, i27, 8960, 2255);
      }
      i6 = __ZL16icvXMLSkipSpacesP13CvFileStoragePci(i8, i6, 0) | 0;
     } while ((HEAP8[i6 >> 0] | 0) != 0);
    }
   } else {
    i6 = __ZL16icvYMLSkipSpacesP13CvFileStoragePcii(i8, HEAP32[i8 + 76 >> 2] | 0, 0) | 0;
    if (i6) {
     i7 = i8 + 92 | 0;
     i2 = i8 + 60 | 0;
     i1 = i8 + 88 | 0;
     i3 = i8 + 32 | 0;
     i4 = 1;
     while (1) {
      while (1) {
       i5 = HEAP8[i6 >> 0] | 0;
       if (i5 << 24 >> 24 == 37) {
        if ((_memcmp(i6, 9912, 6) | 0) == 0 ? (_memcmp(i6, 14576, 8) | 0) != 0 : 0) {
         i22 = HEAP32[i1 >> 2] | 0;
         HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
         HEAP32[i28 + 4 >> 2] = i22;
         HEAP32[i28 + 8 >> 2] = 14608;
         _sprintf(i27, 17440, i28) | 0;
         _cvError(-212, 14592, i27, 8960, 1360);
        }
        HEAP8[i6 >> 0] = 0;
       } else if (i5 << 24 >> 24 == 45) {
        i26 = 101;
        break;
       } else {
        if ((i5 + -48 << 24 >> 24 & 255) < 10 | (i5 + -97 << 24 >> 24 & 255) < 26 | (i5 + -65 << 24 >> 24 & 255) < 26 | i5 << 24 >> 24 == 95) {
         i26 = 105;
         break;
        }
        if (HEAP32[i7 >> 2] | 0) {
         i26 = 110;
         break;
        }
        i22 = HEAP32[i1 >> 2] | 0;
        HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i28 + 4 >> 2] = i22;
        HEAP32[i28 + 8 >> 2] = 14728;
        _sprintf(i27, 17440, i28) | 0;
        _cvError(-212, 14592, i27, 8960, 1382);
       }
       i6 = __ZL16icvYMLSkipSpacesP13CvFileStoragePcii(i8, i6, 0) | 0;
       if (!i6) break L114;
      }
      do if ((i26 | 0) == 101) {
       i26 = 0;
       if (_memcmp(i6, 14656, 3) | 0) if (!i4) break; else {
        i26 = 110;
        break;
       } else {
        i6 = i6 + 3 | 0;
        i26 = 110;
        break;
       }
      } else if ((i26 | 0) == 105) if (!i4) {
       i26 = HEAP32[i1 >> 2] | 0;
       HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i28 + 4 >> 2] = i26;
       HEAP32[i28 + 8 >> 2] = 14664;
       _sprintf(i27, 17440, i28) | 0;
       _cvError(-212, 14592, i27, 8960, 1376);
       i26 = 110;
      } else i26 = 110; while (0);
      if ((i26 | 0) == 110) {
       i6 = __ZL16icvYMLSkipSpacesP13CvFileStoragePcii(i8, i6, 0) | 0;
       if (_memcmp(i6, 14760, 3) | 0) {
        i22 = _cvSeqPush(HEAP32[i3 >> 2] | 0, 0) | 0;
        i6 = __ZL16icvYMLParseValueP13CvFileStoragePcP10CvFileNodeii(i8, i6, i22, 0, 0) | 0;
        if ((HEAP32[i22 >> 2] & 7) >>> 0 <= 4) {
         i22 = HEAP32[i1 >> 2] | 0;
         HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
         HEAP32[i28 + 4 >> 2] = i22;
         HEAP32[i28 + 8 >> 2] = 14768;
         _sprintf(i27, 17440, i28) | 0;
         _cvError(-212, 14592, i27, 8960, 1393);
        }
        i6 = __ZL16icvYMLSkipSpacesP13CvFileStoragePcii(i8, i6, 0) | 0;
        if (!i6) break L114;
       }
       if (HEAP32[i7 >> 2] | 0) break L114;
       i6 = i6 + 3 | 0;
      }
      i6 = __ZL16icvYMLSkipSpacesP13CvFileStoragePcii(i8, i6, 0) | 0;
      if (!i6) break; else i4 = 0;
     }
    }
   } while (0);
   _cvFree_(HEAP32[(HEAP32[i29 >> 2] | 0) + 76 >> 2] | 0);
   HEAP32[(HEAP32[i29 >> 2] | 0) + 76 >> 2] = 0;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 80 >> 2] = 0;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 72 >> 2] = 0;
   i1 = 0;
  } else {
   i7 = i11 & 56;
   if (i15) {
    i22 = __Znwj(24) | 0;
    HEAP32[i22 + 0 >> 2] = 0;
    HEAP32[i22 + 4 >> 2] = 0;
    HEAP32[i22 + 8 >> 2] = 0;
    HEAP32[i22 + 12 >> 2] = 0;
    HEAP32[i22 + 16 >> 2] = 0;
    HEAP32[i22 + 20 >> 2] = 0;
    HEAP32[i6 + 268 >> 2] = i22;
   }
   if ((i7 | 0) == 0 & i12) {
    i22 = (i4 ? -7 : -4) + i5 | 0;
    i6 = i14 + i22 | 0;
    if ((i22 | 0) > -1) if ((_memcmp(i6, 9536, 4) | 0) != 0 ? (_memcmp(i6, 9544, 4) | 0) != 0 : 0) {
     i6 = (_memcmp(i6, 9552, 4) | 0) == 0;
     i6 = i6 ? 8 : 16;
    } else i6 = 8; else i6 = 16;
    i5 = HEAP32[i29 >> 2] | 0;
    HEAP32[i5 + 4 >> 2] = i6;
   } else {
    i6 = (i7 | 0) != 0 ? i7 : 8;
    i5 = HEAP32[i29 >> 2] | 0;
    HEAP32[i5 + 4 >> 2] = i6;
   }
   i4 = (i6 | 0) == 8 ? 25600 : 17408;
   if (i16) {
    _fseek(HEAP32[i5 + 64 >> 2] | 0, 0, 2) | 0;
    i5 = HEAP32[i29 >> 2] | 0;
    i6 = HEAP32[i5 + 4 >> 2] | 0;
   }
   i5 = _cvCreateSeq(0, 56, (i6 | 0) == 8 ? 24 : 4, HEAP32[i5 + 16 >> 2] | 0) | 0;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 36 >> 2] = i5;
   i5 = HEAP32[i29 >> 2] | 0;
   HEAP32[i5 + 12 >> 2] = 1;
   HEAP32[i5 + 40 >> 2] = 0;
   HEAP32[i5 + 44 >> 2] = 32;
   i5 = _cvAlloc(i4 + 1024 | 0) | 0;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 72 >> 2] = i5;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 76 >> 2] = i5;
   i5 = HEAP32[i29 >> 2] | 0;
   HEAP32[i5 + 80 >> 2] = (HEAP32[i5 + 76 >> 2] | 0) + i4;
   i5 = HEAP32[i29 >> 2] | 0;
   if ((HEAP32[i5 + 4 >> 2] | 0) != 8) {
    if (i16) __ZL7icvPutsP13CvFileStoragePKc(i5, 9896); else __ZL7icvPutsP13CvFileStoragePKc(i5, 9880);
    HEAP32[(HEAP32[i29 >> 2] | 0) + 228 >> 2] = 41;
    HEAP32[(HEAP32[i29 >> 2] | 0) + 232 >> 2] = 349;
    HEAP32[(HEAP32[i29 >> 2] | 0) + 236 >> 2] = 49;
    HEAP32[(HEAP32[i29 >> 2] | 0) + 240 >> 2] = 2;
    HEAP32[(HEAP32[i29 >> 2] | 0) + 244 >> 2] = 42;
    HEAP32[(HEAP32[i29 >> 2] | 0) + 248 >> 2] = 50;
    HEAP32[(HEAP32[i29 >> 2] | 0) + 252 >> 2] = 350;
    i1 = 0;
    break;
   }
   i6 = HEAP32[i5 + 64 >> 2] | 0;
   if (!i6) {
    i6 = i5;
    i5 = 0;
   } else {
    i5 = _ftell(i6 | 0) | 0;
    i6 = HEAP32[i29 >> 2] | 0;
   }
   i22 = _cvCreateChildMemStorage(HEAP32[i6 + 16 >> 2] | 0) | 0;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 24 >> 2] = i22;
   if ((i5 | 0) == 0 | i17) {
    if (!i20) __ZL7icvPutsP13CvFileStoragePKc(HEAP32[i29 >> 2] | 0, 9712); else {
     if (!(((_strcmp(i20, 9560) | 0) != 0 ? (_strcmp(i20, 9568) | 0) != 0 : 0) ? (_strcmp(i20, 9576) | 0) != 0 : 0)) {
      HEAP32[i18 >> 2] = 0;
      HEAP32[i18 + 4 >> 2] = 0;
      i7 = (__ZN2cv6String8allocateEj(i18, 57) | 0) + 0 | 0;
      i5 = 9584;
      i8 = i7 + 57 | 0;
      do {
       HEAP8[i7 >> 0] = HEAP8[i5 >> 0] | 0;
       i7 = i7 + 1 | 0;
       i5 = i5 + 1 | 0;
      } while ((i7 | 0) < (i8 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i18, 9360, 8960, 2768);
      __ZN2cv6String10deallocateEv(i18);
     }
     if ((_strlen(i20 | 0) | 0) >>> 0 >= 1e3) {
      HEAP32[i19 >> 2] = 0;
      HEAP32[i19 + 4 >> 2] = 0;
      i7 = (__ZN2cv6String8allocateEj(i19, 23) | 0) + 0 | 0;
      i5 = 9648;
      i8 = i7 + 23 | 0;
      do {
       HEAP8[i7 >> 0] = HEAP8[i5 >> 0] | 0;
       i7 = i7 + 1 | 0;
       i5 = i5 + 1 | 0;
      } while ((i7 | 0) < (i8 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i19, 9360, 8960, 2770);
      __ZN2cv6String10deallocateEv(i19);
     }
     HEAP32[i28 >> 2] = i20;
     _sprintf(i27, 9672, i28) | 0;
     __ZL7icvPutsP13CvFileStoragePKc(HEAP32[i29 >> 2] | 0, i27);
    }
    __ZL7icvPutsP13CvFileStoragePKc(HEAP32[i29 >> 2] | 0, 9736);
    i1 = 0;
   } else {
    i7 = (i5 | 0) < 1024 ? i5 : 1024;
    _fseek(HEAP32[(HEAP32[i29 >> 2] | 0) + 64 >> 2] | 0, 0 - i7 | 0, 2) | 0;
    i1 = _cvAlloc(i7 + 2 | 0) | 0;
    i3 = _ftell(HEAP32[(HEAP32[i29 >> 2] | 0) + 64 >> 2] | 0) | 0;
    i2 = __ZL7icvGetsP13CvFileStoragePci(HEAP32[i29 >> 2] | 0, i1, i7) | 0;
    if (i2) {
     i4 = -1;
     do {
      i6 = _strstr(i2, 9760) | 0;
      if (i6) {
       i4 = i6;
       while (1) {
        i5 = _strstr(i4 + 17 | 0, 9760) | 0;
        if (!i5) break; else i4 = i5;
       }
       i4 = i3 - i2 + i4 | 0;
      }
      i3 = _ftell(HEAP32[(HEAP32[i29 >> 2] | 0) + 64 >> 2] | 0) | 0;
      i2 = __ZL7icvGetsP13CvFileStoragePci(HEAP32[i29 >> 2] | 0, i1, i7) | 0;
     } while ((i2 | 0) != 0);
     if ((i4 | 0) < 0) {
      i3 = i4;
      i26 = 58;
     }
    } else {
     i3 = -1;
     i26 = 58;
    }
    if ((i26 | 0) == 58) {
     HEAP32[i25 >> 2] = 0;
     HEAP32[i25 + 4 >> 2] = 0;
     i7 = (__ZN2cv6String8allocateEj(i25, 53) | 0) + 0 | 0;
     i5 = 9784;
     i8 = i7 + 53 | 0;
     do {
      HEAP8[i7 >> 0] = HEAP8[i5 >> 0] | 0;
      i7 = i7 + 1 | 0;
      i5 = i5 + 1 | 0;
     } while ((i7 | 0) < (i8 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i25, 9360, 8960, 2805);
     __ZN2cv6String10deallocateEv(i25);
     i4 = i3;
    }
    i5 = HEAP32[i29 >> 2] | 0;
    i6 = i5 + 64 | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    if (!i2) {
     i2 = i5 + 68 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if (i3) _gzclose(i3) | 0;
    } else {
     _fclose(i2 | 0) | 0;
     i2 = i5 + 68 | 0;
    }
    HEAP32[i6 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i5 + 256 >> 2] = 0;
    HEAP32[i5 + 264 >> 2] = 0;
    HEAP8[i5 + 272 >> 0] = 0;
    i22 = _fopen(HEAP32[(HEAP32[i29 >> 2] | 0) + 60 >> 2] | 0, 9840) | 0;
    HEAP32[(HEAP32[i29 >> 2] | 0) + 64 >> 2] = i22;
    _fseek(HEAP32[(HEAP32[i29 >> 2] | 0) + 64 >> 2] | 0, i4 | 0, 0) | 0;
    __ZL7icvPutsP13CvFileStoragePKc(HEAP32[i29 >> 2] | 0, 9848);
    _fseek(HEAP32[(HEAP32[i29 >> 2] | 0) + 64 >> 2] | 0, 0, 2) | 0;
    __ZL7icvPutsP13CvFileStoragePKc(HEAP32[i29 >> 2] | 0, 9872);
   }
   HEAP32[(HEAP32[i29 >> 2] | 0) + 228 >> 2] = 39;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 232 >> 2] = 347;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 236 >> 2] = 47;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 240 >> 2] = 1;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 244 >> 2] = 40;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 248 >> 2] = 48;
   HEAP32[(HEAP32[i29 >> 2] | 0) + 252 >> 2] = 348;
  } while (0);
  i2 = HEAP32[i29 >> 2] | 0;
  HEAP8[i2 + 272 >> 0] = 1;
 }
 if (!i2) {
  _cvFree_(i1);
  i22 = HEAP32[i29 >> 2] | 0;
  STACKTOP = i30;
  return i22 | 0;
 }
 do if ((_cvGetErrStatus() | 0) >= 0) {
  i6 = HEAP32[i29 >> 2] | 0;
  i5 = i6 + 64 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = (i2 | 0) == 0;
  if (((i3 ? (HEAP32[i6 + 68 >> 2] | 0) == 0 : 0) ? (HEAP32[i6 + 268 >> 2] | 0) == 0 : 0) ? (HEAP32[i6 + 256 >> 2] | 0) == 0 : 0) break;
  if (HEAP32[i6 + 8 >> 2] | 0) {
   _cvFree_(i1);
   i22 = HEAP32[i29 >> 2] | 0;
   STACKTOP = i30;
   return i22 | 0;
  }
  if (i3) {
   i2 = i6 + 68 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3) _gzclose(i3) | 0;
  } else {
   _fclose(i2 | 0) | 0;
   i2 = i6 + 68 | 0;
  }
  HEAP32[i5 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i6 + 256 >> 2] = 0;
  HEAP32[i6 + 264 >> 2] = 0;
  HEAP8[i6 + 272 >> 0] = 0;
  HEAP8[(HEAP32[i29 >> 2] | 0) + 272 >> 0] = 1;
  _cvFree_(i1);
  i22 = HEAP32[i29 >> 2] | 0;
  STACKTOP = i30;
  return i22 | 0;
 } while (0);
 _cvReleaseFileStorage(i29);
 _cvFree_(i1);
 i22 = HEAP32[i29 >> 2] | 0;
 STACKTOP = i30;
 return i22 | 0;
}

function __ZN4perf10Regression5writeEN2cv3MatE(i16, i17) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, d2 = 0.0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i18 = i19 + 56 | 0;
 i14 = i19 + 48 | 0;
 i9 = i19 + 40 | 0;
 i7 = i19 + 8 | 0;
 i8 = i19;
 i5 = i19 + 16 | 0;
 if (HEAP32[i17 + 16 >> 2] | 0) {
  i6 = HEAP32[i17 + 4 >> 2] | 0;
  if ((i6 | 0) < 3) i4 = Math_imul(HEAP32[i17 + 12 >> 2] | 0, HEAP32[i17 + 8 >> 2] | 0) | 0; else {
   i3 = HEAP32[i17 + 40 >> 2] | 0;
   i1 = 0;
   i4 = 1;
   do {
    i4 = Math_imul(HEAP32[i3 + (i1 << 2) >> 2] | 0, i4) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i6 | 0));
  }
  if ((i4 | 0) != 0 & (i6 | 0) < 2) {
   STACKTOP = i19;
   return;
  }
 }
 HEAP32[i5 >> 2] = 32088;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 16842752;
 HEAP32[i5 + 8 >> 2] = i17;
 __ZN2cv9minMaxIdxERKNS_11_InputArrayEPdS3_PiS4_S2_(i5, i7, i8, 0, 0, __ZN2cv7noArrayEv() | 0);
 i4 = __ZN4perf10Regression5writeEv(i16) | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 i11 = __ZN2cv6String8allocateEj(i18, 3) | 0;
 HEAP8[i11 + 0 >> 0] = HEAP8[170072] | 0;
 HEAP8[i11 + 1 >> 0] = HEAP8[170073] | 0;
 HEAP8[i11 + 2 >> 0] = HEAP8[170074] | 0;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4) | 0) {
  i3 = i4 + 32 | 0;
  if ((HEAP32[i3 >> 2] | 0) == 6) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i18, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i18, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i18);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEd(i4, i4 + 12 | 0, +HEAPF64[i7 >> 3]);
  if (HEAP32[i3 >> 2] & 4) HEAP32[i3 >> 2] = 6;
 }
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 i11 = __ZN2cv6String8allocateEj(i18, 3) | 0;
 HEAP8[i11 + 0 >> 0] = HEAP8[170080] | 0;
 HEAP8[i11 + 1 >> 0] = HEAP8[170081] | 0;
 HEAP8[i11 + 2 >> 0] = HEAP8[170082] | 0;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4) | 0) {
  i3 = i4 + 32 | 0;
  if ((HEAP32[i3 >> 2] | 0) == 6) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i18, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i18, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i18);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEd(i4, i4 + 12 | 0, +HEAPF64[i8 >> 3]);
  if (HEAP32[i3 >> 2] & 4) HEAP32[i3 >> 2] = 6;
 }
 i4 = __ZN4perf10Regression5writeEv(i16) | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 i5 = __ZN2cv6String8allocateEj(i18, 4) | 0;
 HEAP8[i5 >> 0] = 108;
 HEAP8[i5 + 1 >> 0] = 97;
 HEAP8[i5 + 2 >> 0] = 115;
 HEAP8[i5 + 3 >> 0] = 116;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP8[(__ZN2cv6String8allocateEj(i18, 1) | 0) >> 0] = 123;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP8[(__ZN2cv6String8allocateEj(i18, 1) | 0) >> 0] = 120;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 i5 = i17 + 40 | 0;
 i3 = (HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0) + -1 | 0;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4) | 0) {
  i1 = i4 + 32 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 6) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i18, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i18, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i18);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i4, i4 + 12 | 0, i3);
  if (HEAP32[i1 >> 2] & 4) HEAP32[i1 >> 2] = 6;
 }
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP8[(__ZN2cv6String8allocateEj(i18, 1) | 0) >> 0] = 121;
 i3 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 i1 = (HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + -1 | 0;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] & 127](i3) | 0) {
  i4 = i3 + 32 | 0;
  if ((HEAP32[i4 >> 2] | 0) == 6) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i18, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i18, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i18);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i3, i3 + 12 | 0, i1);
  if (HEAP32[i4 >> 2] & 4) HEAP32[i4 >> 2] = 6;
 }
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 i4 = __ZN2cv6String8allocateEj(i18, 3) | 0;
 HEAP8[i4 + 0 >> 0] = HEAP8[170112] | 0;
 HEAP8[i4 + 1 >> 0] = HEAP8[170113] | 0;
 HEAP8[i4 + 2 >> 0] = HEAP8[170114] | 0;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i3, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 i11 = HEAP32[i5 >> 2] | 0;
 d2 = +__ZN4perf10Regression7getElemERN2cv3MatEiii(i17, (HEAP32[i11 >> 2] | 0) + -1 | 0, (HEAP32[i11 + 4 >> 2] | 0) + -1 | 0, (HEAP32[i17 >> 2] | 0) >>> 3 & 511);
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4) | 0) {
  i3 = i4 + 32 | 0;
  if ((HEAP32[i3 >> 2] | 0) == 6) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i18, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i18, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i18);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEd(i4, i4 + 12 | 0, d2);
  if (HEAP32[i3 >> 2] & 4) HEAP32[i3 >> 2] = 6;
 }
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP8[(__ZN2cv6String8allocateEj(i18, 1) | 0) >> 0] = 125;
 __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i3) i8 = 0; else {
  i11 = i16;
  i8 = HEAP32[i11 + 4 >> 2] | 0;
  i11 = ___muldi3(HEAP32[i11 >> 2] | 0, 0, -130063606, 0) | 0;
  i8 = _i64Add(i11 | 0, tempRet0 | 0, i8 | 0, 0) | 0;
  i11 = i16;
  HEAP32[i11 >> 2] = i8;
  HEAP32[i11 + 4 >> 2] = tempRet0;
  i8 = (i8 >>> 0) % (i3 >>> 0) | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i3 = i16;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i7 = ___muldi3(i4 | 0, 0, -130063606, 0) | 0;
  i7 = _i64Add(i7 | 0, tempRet0 | 0, i3 | 0, 0) | 0;
  i3 = tempRet0;
  i4 = i16;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i4 + 4 >> 2] = i3;
  i4 = i7;
  i7 = (i7 >>> 0) % (i1 >>> 0) | 0;
 }
 i6 = ((HEAP32[i17 >> 2] | 0) >>> 3 & 511) + 1 | 0;
 i4 = ___muldi3(i4 | 0, 0, -130063606, 0) | 0;
 i4 = _i64Add(i4 | 0, tempRet0 | 0, i3 | 0, 0) | 0;
 i11 = i16;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i11 + 4 >> 2] = tempRet0;
 i6 = (i4 >>> 0) % (i6 >>> 0) | 0;
 i4 = __ZN4perf10Regression5writeEv(i16) | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 i11 = __ZN2cv6String8allocateEj(i18, 4) | 0;
 HEAP8[i11 >> 0] = 114;
 HEAP8[i11 + 1 >> 0] = 110;
 HEAP8[i11 + 2 >> 0] = 103;
 HEAP8[i11 + 3 >> 0] = 49;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP8[(__ZN2cv6String8allocateEj(i18, 1) | 0) >> 0] = 123;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP8[(__ZN2cv6String8allocateEj(i18, 1) | 0) >> 0] = 120;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4) | 0) {
  i3 = i4 + 32 | 0;
  if ((HEAP32[i3 >> 2] | 0) == 6) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i18, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i18, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i18);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i4, i4 + 12 | 0, i8);
  if (HEAP32[i3 >> 2] & 4) HEAP32[i3 >> 2] = 6;
 }
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP8[(__ZN2cv6String8allocateEj(i18, 1) | 0) >> 0] = 121;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4) | 0) {
  i3 = i4 + 32 | 0;
  if ((HEAP32[i3 >> 2] | 0) == 6) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i18, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i18, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i18);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i4, i4 + 12 | 0, i7);
  if (HEAP32[i3 >> 2] & 4) HEAP32[i3 >> 2] = 6;
 }
 if ((i6 | 0) != 0 ? (i10 = __ZN4perf10Regression5writeEv(i16) | 0, HEAP32[i18 >> 2] = 0, HEAP32[i18 + 4 >> 2] = 0, i11 = __ZN2cv6String8allocateEj(i18, 2) | 0, HEAP8[i11 >> 0] = 99, HEAP8[i11 + 1 >> 0] = 110, i10 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i10, i18) | 0, __ZN2cv6String10deallocateEv(i18), FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] & 127](i10) | 0) : 0) {
  i4 = i10 + 32 | 0;
  if ((HEAP32[i4 >> 2] | 0) == 6) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i9, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i9, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i9);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i10, i10 + 12 | 0, i6);
  if (HEAP32[i4 >> 2] & 4) HEAP32[i4 >> 2] = 6;
 }
 i3 = __ZN4perf10Regression5writeEv(i16) | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 i11 = __ZN2cv6String8allocateEj(i18, 3) | 0;
 HEAP8[i11 + 0 >> 0] = HEAP8[170112] | 0;
 HEAP8[i11 + 1 >> 0] = HEAP8[170113] | 0;
 HEAP8[i11 + 2 >> 0] = HEAP8[170114] | 0;
 i3 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i3, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 d2 = +__ZN4perf10Regression7getElemERN2cv3MatEiii(i17, i7, i8, i6);
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] & 127](i3) | 0) {
  i4 = i3 + 32 | 0;
  if ((HEAP32[i4 >> 2] | 0) == 6) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i18, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i18, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i18);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEd(i3, i3 + 12 | 0, d2);
  if (HEAP32[i4 >> 2] & 4) HEAP32[i4 >> 2] = 6;
 }
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP8[(__ZN2cv6String8allocateEj(i18, 1) | 0) >> 0] = 125;
 __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i3, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i11 = i16;
  i7 = HEAP32[i11 + 4 >> 2] | 0;
  i11 = ___muldi3(HEAP32[i11 >> 2] | 0, 0, -130063606, 0) | 0;
  i7 = _i64Add(i11 | 0, tempRet0 | 0, i7 | 0, 0) | 0;
  i11 = i16;
  HEAP32[i11 >> 2] = i7;
  HEAP32[i11 + 4 >> 2] = tempRet0;
  i7 = (i7 >>> 0) % (i1 >>> 0) | 0;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i16;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i4) i5 = 0; else {
  i5 = ___muldi3(i3 | 0, 0, -130063606, 0) | 0;
  i5 = _i64Add(i5 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  i3 = i16;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i3 + 4 >> 2] = i1;
  i3 = i5;
  i5 = (i5 >>> 0) % (i4 >>> 0) | 0;
 }
 i6 = ((HEAP32[i17 >> 2] | 0) >>> 3 & 511) + 1 | 0;
 i4 = ___muldi3(i3 | 0, 0, -130063606, 0) | 0;
 i4 = _i64Add(i4 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
 i11 = i16;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i11 + 4 >> 2] = tempRet0;
 i6 = (i4 >>> 0) % (i6 >>> 0) | 0;
 i4 = __ZN4perf10Regression5writeEv(i16) | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 i11 = __ZN2cv6String8allocateEj(i18, 4) | 0;
 HEAP8[i11 >> 0] = 114;
 HEAP8[i11 + 1 >> 0] = 110;
 HEAP8[i11 + 2 >> 0] = 103;
 HEAP8[i11 + 3 >> 0] = 50;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP8[(__ZN2cv6String8allocateEj(i18, 1) | 0) >> 0] = 123;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP8[(__ZN2cv6String8allocateEj(i18, 1) | 0) >> 0] = 120;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4) | 0) {
  i3 = i4 + 32 | 0;
  if ((HEAP32[i3 >> 2] | 0) == 6) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i18, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i18, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i18);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i4, i4 + 12 | 0, i7);
  if (HEAP32[i3 >> 2] & 4) HEAP32[i3 >> 2] = 6;
 }
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP8[(__ZN2cv6String8allocateEj(i18, 1) | 0) >> 0] = 121;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4) | 0) {
  i3 = i4 + 32 | 0;
  if ((HEAP32[i3 >> 2] | 0) == 6) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i18, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i18, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i18);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i4, i4 + 12 | 0, i5);
  if (HEAP32[i3 >> 2] & 4) HEAP32[i3 >> 2] = 6;
 }
 do if ((i6 | 0) != 0 ? (i15 = __ZN4perf10Regression5writeEv(i16) | 0, HEAP32[i18 >> 2] = 0, HEAP32[i18 + 4 >> 2] = 0, i11 = __ZN2cv6String8allocateEj(i18, 2) | 0, HEAP8[i11 >> 0] = 99, HEAP8[i11 + 1 >> 0] = 110, i15 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i15, i18) | 0, __ZN2cv6String10deallocateEv(i18), FUNCTION_TABLE_ii[HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] & 127](i15) | 0) : 0) {
  i4 = i15 + 32 | 0;
  if ((HEAP32[i4 >> 2] | 0) == 6) {
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i14, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i14, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i14);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i15, i15 + 12 | 0, i6);
  if (!(HEAP32[i4 >> 2] & 4)) break;
  HEAP32[i4 >> 2] = 6;
 } while (0);
 i4 = __ZN4perf10Regression5writeEv(i16) | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 i11 = __ZN2cv6String8allocateEj(i18, 3) | 0;
 HEAP8[i11 + 0 >> 0] = HEAP8[170112] | 0;
 HEAP8[i11 + 1 >> 0] = HEAP8[170113] | 0;
 HEAP8[i11 + 2 >> 0] = HEAP8[170114] | 0;
 i4 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 d2 = +__ZN4perf10Regression7getElemERN2cv3MatEiii(i17, i5, i7, i6);
 do if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4) | 0) {
  i1 = i4 + 32 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 6) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i18, 30) | 0) + 0 | 0;
   i12 = 176840 | 0;
   i13 = i11 + 30 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i12 = i12 + 1 | 0;
   } while ((i11 | 0) < (i13 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i18, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i18);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEd(i4, i4 + 12 | 0, d2);
  if (!(HEAP32[i1 >> 2] & 4)) break;
  HEAP32[i1 >> 2] = 6;
 } while (0);
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP8[(__ZN2cv6String8allocateEj(i18, 1) | 0) >> 0] = 125;
 __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i18) | 0;
 __ZN2cv6String10deallocateEv(i18);
 STACKTOP = i19;
 return;
}

function __ZN2cv17CommandLineParserC2EiPKPKcRKNS_6StringE(i34, i30, i31, i14) {
 i34 = i34 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i36 = i38;
 i2 = i38 + 208 | 0;
 i1 = i38 + 200 | 0;
 i9 = i38 + 192 | 0;
 i10 = i38 + 184 | 0;
 i17 = i38 + 176 | 0;
 i16 = i38 + 168 | 0;
 i15 = i38 + 160 | 0;
 i37 = i38 + 148 | 0;
 i20 = i38 + 136 | 0;
 i21 = i38 + 104 | 0;
 i18 = i38 + 88 | 0;
 i19 = i38 + 80 | 0;
 i33 = i38 + 72 | 0;
 i32 = i38 + 56 | 0;
 i24 = i38 + 48 | 0;
 i25 = i38 + 40 | 0;
 i26 = i38 + 32 | 0;
 i27 = i38 + 24 | 0;
 i28 = i38 + 16 | 0;
 i29 = i38 + 8 | 0;
 i5 = __Znwj(52) | 0;
 i8 = i5 + 4 | 0;
 i6 = i8 + 44 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i6 | 0));
 HEAP32[i34 >> 2] = i5;
 HEAP32[i5 + 48 >> 2] = 1;
 i5 = HEAP32[i31 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 L1 : do if ((i5 | 0) != 0 ? (i3 = _strlen(i5 | 0) | 0, _memcpy(__ZN2cv6String8allocateEj(i2, i3) | 0, i5 | 0, i3 | 0) | 0, i3 = HEAP32[i2 >> 2] | 0, i7 = (HEAP32[i4 >> 2] | 0) + -1 | 0, (i7 | 0) >= 0) : 0) {
  i5 = i3 + i7 | 0;
  L4 : while (1) {
   i7 = HEAP8[i5 >> 0] | 0;
   i6 = 47;
   i4 = 0;
   while (1) {
    i4 = i4 + 1 | 0;
    if (i6 << 24 >> 24 == i7 << 24 >> 24) break L4;
    if ((i4 | 0) == 2) break; else i6 = HEAP8[6224 + i4 >> 0] | 0;
   }
   i5 = i5 + -1 | 0;
   if (i5 >>> 0 < i3 >>> 0) {
    i8 = -1;
    break L1;
   }
  }
  i8 = i5 - i3 | 0;
 } else i8 = -1; while (0);
 __ZN2cv6String10deallocateEv(i2);
 i3 = HEAP32[i34 >> 2] | 0;
 i2 = i3 + 20 | 0;
 if ((i8 | 0) == -1) {
  __ZN2cv6String10deallocateEv(i2);
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  i4 = HEAP32[i34 >> 2] | 0;
  i3 = i4 + 28 | 0;
  i5 = HEAP32[i31 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  i2 = i1 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  if (i5) {
   i22 = _strlen(i5 | 0) | 0;
   _memcpy(__ZN2cv6String8allocateEj(i1, i22) | 0, i5 | 0, i22 | 0) | 0;
  }
  if ((i1 | 0) != (i3 | 0)) {
   __ZN2cv6String10deallocateEv(i3);
   i5 = HEAP32[i1 >> 2] | 0;
   if (!i5) i5 = 0; else {
    i5 = i5 + -4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i5 = HEAP32[i1 >> 2] | 0;
   }
   HEAP32[i3 >> 2] = i5;
   HEAP32[i4 + 32 >> 2] = HEAP32[i2 >> 2];
  }
  __ZN2cv6String10deallocateEv(i1);
 } else {
  i5 = HEAP32[i31 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  i7 = i10 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  if (!i5) i6 = 0; else {
   i6 = _strlen(i5 | 0) | 0;
   _memcpy(__ZN2cv6String8allocateEj(i10, i6) | 0, i5 | 0, i6 | 0) | 0;
   i6 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i9 >> 2] = 0;
  i4 = i9 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  i5 = i6 >>> 0 > i8 >>> 0 ? i8 : i6;
  do if (i5) if ((i5 | 0) == (i6 | 0)) {
   i22 = (HEAP32[i10 >> 2] | 0) + -4 | 0;
   HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
   break;
  } else {
   i22 = __ZN2cv6String8allocateEj(i9, i5) | 0;
   _memcpy(i22 | 0, HEAP32[i10 >> 2] | 0, i5 | 0) | 0;
   break;
  } while (0);
  if ((i9 | 0) != (i2 | 0)) {
   __ZN2cv6String10deallocateEv(i2);
   i5 = HEAP32[i9 >> 2] | 0;
   if (!i5) i5 = 0; else {
    i5 = i5 + -4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i5 = HEAP32[i9 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = i5;
   HEAP32[i3 + 24 >> 2] = HEAP32[i4 >> 2];
  }
  __ZN2cv6String10deallocateEv(i9);
  __ZN2cv6String10deallocateEv(i10);
  i2 = HEAP32[i34 >> 2] | 0;
  i1 = i2 + 28 | 0;
  i5 = HEAP32[i31 >> 2] | 0;
  HEAP32[i16 >> 2] = 0;
  i7 = i16 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  if (i5) {
   i4 = _strlen(i5 | 0) | 0;
   _memcpy(__ZN2cv6String8allocateEj(i16, i4) | 0, i5 | 0, i4 | 0) | 0;
   i5 = HEAP32[i31 >> 2] | 0;
   HEAP32[i15 >> 2] = 0;
   i4 = i15 + 4 | 0;
   HEAP32[i4 >> 2] = 0;
   if (!i5) i5 = 0; else {
    i22 = _strlen(i5 | 0) | 0;
    _memcpy(__ZN2cv6String8allocateEj(i15, i22) | 0, i5 | 0, i22 | 0) | 0;
    i5 = HEAP32[i4 >> 2] | 0;
   }
  } else {
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   i5 = 0;
  }
  i4 = i8 + 1 | 0;
  i22 = i5 - i8 | 0;
  HEAP32[i17 >> 2] = 0;
  i6 = i17 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i5 = i3 >>> 0 < i4 >>> 0 ? i3 : i4;
  i4 = i3 - i5 | 0;
  i4 = i4 >>> 0 > i22 >>> 0 ? i22 : i4;
  do if (i4) if ((i4 | 0) == (i3 | 0)) {
   i22 = (HEAP32[i16 >> 2] | 0) + -4 | 0;
   HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
   HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   break;
  } else {
   i22 = __ZN2cv6String8allocateEj(i17, i4) | 0;
   _memcpy(i22 | 0, (HEAP32[i16 >> 2] | 0) + i5 | 0, i4 | 0) | 0;
   break;
  } while (0);
  if ((i17 | 0) != (i1 | 0)) {
   __ZN2cv6String10deallocateEv(i1);
   i5 = HEAP32[i17 >> 2] | 0;
   if (!i5) i5 = 0; else {
    i5 = i5 + -4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i5 = HEAP32[i17 >> 2] | 0;
   }
   HEAP32[i1 >> 2] = i5;
   HEAP32[i2 + 32 >> 2] = HEAP32[i6 >> 2];
  }
  __ZN2cv6String10deallocateEv(i17);
  __ZN2cv6String10deallocateEv(i15);
  __ZN2cv6String10deallocateEv(i16);
 }
 i22 = HEAP32[i34 >> 2] | 0;
 HEAP8[i22 >> 0] = 0;
 i22 = i22 + 4 | 0;
 __ZN2cv6String10deallocateEv(i22);
 __ZN2cv6String8allocateEj(i22, 0) | 0;
 __ZNK2cv17CommandLineParser4Impl18split_range_stringERKNS_6StringEcc(i37, 0, i14, 123, 125);
 i22 = i37 + 4 | 0;
 i5 = HEAP32[i37 >> 2] | 0;
 if ((HEAP32[i22 >> 2] | 0) != (i5 | 0)) {
  i9 = i21 + 16 | 0;
  i3 = i18 + 4 | 0;
  i2 = i21 + 8 | 0;
  i1 = i19 + 4 | 0;
  i11 = i21 + 4 | 0;
  i12 = i21 + 28 | 0;
  i13 = i21 + 20 | 0;
  i14 = i21 + 16 | 0;
  i15 = i20 + 4 | 0;
  i16 = i21 + 8 | 0;
  i17 = i21 + 12 | 0;
  i10 = 0;
  i4 = 0;
  do {
   __ZNK2cv17CommandLineParser4Impl12split_stringERKNS_6StringEcb(i20, 0, i5 + (i10 << 3) | 0, 124, 1);
   HEAP32[i21 + 0 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   HEAP32[i21 + 8 >> 2] = 0;
   HEAP32[i21 + 12 >> 2] = 0;
   HEAP32[i21 + 16 >> 2] = 0;
   HEAP32[i21 + 20 >> 2] = 0;
   HEAP32[i21 + 24 >> 2] = 0;
   __ZNK2cv17CommandLineParser4Impl12split_stringERKNS_6StringEcb(i18, 0, HEAP32[i20 >> 2] | 0, 32, 0);
   __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i9, HEAP32[i18 >> 2] | 0, HEAP32[i3 >> 2] | 0);
   i7 = HEAP32[i18 >> 2] | 0;
   if (i7) {
    while (1) {
     i6 = HEAP32[i3 >> 2] | 0;
     if ((i6 | 0) == (i7 | 0)) break;
     i5 = i6 + -8 | 0;
     HEAP32[i3 >> 2] = i5;
     __ZN2cv6String10deallocateEv(i5);
    }
    __ZdlPv(HEAP32[i18 >> 2] | 0);
   }
   i7 = HEAP32[i20 >> 2] | 0;
   i6 = i7 + 8 | 0;
   if ((i6 | 0) != (i2 | 0)) {
    __ZN2cv6String10deallocateEv(i2);
    i5 = HEAP32[i6 >> 2] | 0;
    if (!i5) i6 = 0; else {
     i5 = i5 + -4 | 0;
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
     i6 = HEAP32[i6 >> 2] | 0;
    }
    HEAP32[i2 >> 2] = i6;
    HEAP32[i17 >> 2] = HEAP32[i7 + 12 >> 2];
    i7 = HEAP32[i20 >> 2] | 0;
   }
   __ZNK2cv17CommandLineParser4Impl10cat_stringERKNS_6StringE(i19, 0, i7 + 16 | 0);
   __ZN2cv6String10deallocateEv(i21);
   i7 = HEAP32[i19 >> 2] | 0;
   if (!i7) i7 = 0; else {
    i7 = i7 + -4 | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    i7 = HEAP32[i19 >> 2] | 0;
   }
   HEAP32[i21 >> 2] = i7;
   HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
   __ZN2cv6String10deallocateEv(i19);
   HEAP32[i12 >> 2] = -1;
   i7 = HEAP32[i9 >> 2] | 0;
   do if ((HEAP32[i13 >> 2] | 0) == (i7 | 0)) {
    i8 = HEAP32[i34 >> 2] | 0;
    HEAP8[i8 >> 0] = 1;
    i8 = i8 + 4 | 0;
    __ZN2cv6String10deallocateEv(i8);
    i8 = (__ZN2cv6String8allocateEj(i8, 30) | 0) + 0 | 0;
    i7 = 6240;
    i6 = i8 + 30 | 0;
    do {
     HEAP8[i8 >> 0] = HEAP8[i7 >> 0] | 0;
     i8 = i8 + 1 | 0;
     i7 = i7 + 1 | 0;
    } while ((i8 | 0) < (i6 | 0));
   } else {
    if ((HEAP8[HEAP32[i7 >> 2] >> 0] | 0) == 64) {
     HEAP32[i12 >> 2] = i4;
     i4 = i4 + 1 | 0;
    }
    i7 = HEAP32[i34 >> 2] | 0;
    i5 = i7 + 40 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    if ((i6 | 0) == (HEAP32[i7 + 44 >> 2] | 0)) {
     __ZNSt3__16vectorIN2cv23CommandLineParserParamsENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i7 + 36 | 0, i21);
     break;
    }
    if (!i6) i7 = 0; else {
     i7 = HEAP32[i21 >> 2] | 0;
     HEAP32[i6 >> 2] = i7;
     HEAP32[i6 + 4 >> 2] = HEAP32[i11 >> 2];
     if (i7) {
      i7 = i7 + -4 | 0;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     }
     i7 = HEAP32[i16 >> 2] | 0;
     HEAP32[i6 + 8 >> 2] = i7;
     HEAP32[i6 + 12 >> 2] = HEAP32[i17 >> 2];
     if (i7) {
      i7 = i7 + -4 | 0;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     }
     __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i6 + 16 | 0, i9);
     HEAP32[i6 + 28 >> 2] = HEAP32[i12 >> 2];
     i7 = HEAP32[i5 >> 2] | 0;
    }
    HEAP32[i5 >> 2] = i7 + 32;
   } while (0);
   i7 = HEAP32[i14 >> 2] | 0;
   if (i7) {
    while (1) {
     i6 = HEAP32[i13 >> 2] | 0;
     if ((i6 | 0) == (i7 | 0)) break;
     i5 = i6 + -8 | 0;
     HEAP32[i13 >> 2] = i5;
     __ZN2cv6String10deallocateEv(i5);
    }
    __ZdlPv(HEAP32[i14 >> 2] | 0);
   }
   __ZN2cv6String10deallocateEv(i2);
   __ZN2cv6String10deallocateEv(i21);
   i7 = HEAP32[i20 >> 2] | 0;
   if (i7) {
    while (1) {
     i6 = HEAP32[i15 >> 2] | 0;
     if ((i6 | 0) == (i7 | 0)) break;
     i5 = i6 + -8 | 0;
     HEAP32[i15 >> 2] = i5;
     __ZN2cv6String10deallocateEv(i5);
    }
    __ZdlPv(HEAP32[i20 >> 2] | 0);
   }
   i10 = i10 + 1 | 0;
   i5 = HEAP32[i37 >> 2] | 0;
  } while (i10 >>> 0 < (HEAP32[i22 >> 2] | 0) - i5 >> 3 >>> 0);
 }
 if ((i30 | 0) > 1) {
  i17 = i33 + 4 | 0;
  i16 = i25 + 4 | 0;
  i15 = i26 + 4 | 0;
  i14 = i27 + 4 | 0;
  i13 = i28 + 4 | 0;
  i12 = i29 + 4 | 0;
  i11 = i24 + 4 | 0;
  i8 = i32 + 4 | 0;
  i9 = 1;
  i5 = 0;
  do {
   i4 = HEAP32[i31 + (i9 << 2) >> 2] | 0;
   HEAP32[i33 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
   L112 : do if ((i4 | 0) != 0 ? (i23 = _strlen(i4 | 0) | 0, _memcpy(__ZN2cv6String8allocateEj(i33, i23) | 0, i4 | 0, i23 | 0) | 0, i23 = HEAP32[i17 >> 2] | 0, (i23 | 0) != 0) : 0) {
    i3 = HEAP32[i33 >> 2] | 0;
    i21 = i23 + -1 | 0;
    i7 = i3 + i21 | 0;
    L115 : do if ((i21 | 0) >= 0) {
     i4 = i3;
     while (1) {
      if ((HEAP8[i4 >> 0] | 0) == 61) break;
      i4 = i4 + 1 | 0;
      if (i4 >>> 0 > i7 >>> 0) break L115;
     }
     i2 = i3;
     if ((i4 - i2 | 0) != -1) {
      i4 = i3;
      while (1) {
       if ((HEAP8[i4 >> 0] | 0) == 61) break;
       i4 = i4 + 1 | 0;
       if (i4 >>> 0 > i7 >>> 0) break L115;
      }
      if ((i4 - i2 | 0) >>> 0 < i23 >>> 0) {
       __ZNK2cv17CommandLineParser4Impl12split_stringERKNS_6StringEcb(i32, 0, i33, 61, 1);
       i1 = 0;
       do {
        i7 = HEAP32[i32 >> 2] | 0;
        if ((HEAP8[HEAP32[i7 >> 2] >> 0] | 0) == 45) {
         i6 = i7 + 4 | 0;
         i21 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
         HEAP32[i24 >> 2] = 0;
         HEAP32[i11 >> 2] = 0;
         i4 = HEAP32[i6 >> 2] | 0;
         i3 = (i4 | 0) != 0 & 1;
         i2 = i4 - i3 | 0;
         i2 = i2 >>> 0 > i21 >>> 0 ? i21 : i2;
         do if (i2) if ((i2 | 0) == (i4 | 0)) {
          i21 = (HEAP32[i7 >> 2] | 0) + -4 | 0;
          HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
          HEAP32[i24 >> 2] = HEAP32[i7 >> 2];
          HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
          break;
         } else {
          i21 = __ZN2cv6String8allocateEj(i24, i2) | 0;
          _memcpy(i21 | 0, (HEAP32[i7 >> 2] | 0) + i3 | 0, i2 | 0) | 0;
          break;
         } while (0);
         if ((i24 | 0) != (i7 | 0)) {
          __ZN2cv6String10deallocateEv(i7);
          i4 = HEAP32[i24 >> 2] | 0;
          if (!i4) i4 = 0; else {
           i4 = i4 + -4 | 0;
           HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
           i4 = HEAP32[i24 >> 2] | 0;
          }
          HEAP32[i7 >> 2] = i4;
          HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
         }
         __ZN2cv6String10deallocateEv(i24);
        }
        i1 = i1 + 1 | 0;
       } while ((i1 | 0) < 2);
       i4 = HEAP32[i32 >> 2] | 0;
       __ZN2cv17CommandLineParser4Impl12apply_paramsERKNS_6StringES4_(HEAP32[i34 >> 2] | 0, i4, i4 + 8 | 0);
       i4 = HEAP32[i32 >> 2] | 0;
       if (!i4) break L112;
       while (1) {
        i3 = HEAP32[i8 >> 2] | 0;
        if ((i3 | 0) == (i4 | 0)) break;
        i21 = i3 + -8 | 0;
        HEAP32[i8 >> 2] = i21;
        __ZN2cv6String10deallocateEv(i21);
       }
       __ZdlPv(HEAP32[i32 >> 2] | 0);
       break L112;
      }
     }
    } while (0);
    if (i23 >>> 0 > 2) {
     i3 = HEAP32[i33 >> 2] | 0;
     if ((HEAP8[i3 >> 0] | 0) == 45) if ((HEAP8[i3 + 1 >> 0] | 0) == 45) {
      i4 = HEAP32[i34 >> 2] | 0;
      HEAP32[i25 >> 2] = 0;
      HEAP32[i16 >> 2] = 0;
      i2 = i23 >>> 0 < 2 ? i23 : 2;
      i1 = i23 - i2 | 0;
      do if ((i23 | 0) != (i2 | 0)) if (!i2) {
       i21 = i3 + -4 | 0;
       HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
       HEAP32[i25 >> 2] = HEAP32[i33 >> 2];
       HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
       break;
      } else {
       i21 = __ZN2cv6String8allocateEj(i25, i1) | 0;
       _memcpy(i21 | 0, (HEAP32[i33 >> 2] | 0) + i2 | 0, i1 | 0) | 0;
       break;
      } while (0);
      HEAP32[i26 >> 2] = 0;
      HEAP32[i15 >> 2] = 0;
      i21 = __ZN2cv6String8allocateEj(i26, 4) | 0;
      HEAP8[i21 >> 0] = 116;
      HEAP8[i21 + 1 >> 0] = 114;
      HEAP8[i21 + 2 >> 0] = 117;
      HEAP8[i21 + 3 >> 0] = 101;
      __ZN2cv17CommandLineParser4Impl12apply_paramsERKNS_6StringES4_(i4, i25, i26);
      __ZN2cv6String10deallocateEv(i26);
      __ZN2cv6String10deallocateEv(i25);
     } else {
      i4 = i23;
      i35 = 110;
     } else {
      i4 = i23;
      i35 = 111;
     }
    } else {
     i4 = i23;
     i35 = 102;
    }
   } else {
    i4 = 0;
    i35 = 102;
   } while (0);
   if ((i35 | 0) == 102) {
    i3 = HEAP32[i33 >> 2] | 0;
    i35 = 110;
   }
   if ((i35 | 0) == 110) if (i4 >>> 0 > 1) i35 = 111; else i35 = 117;
   if ((i35 | 0) == 111) {
    i35 = 0;
    if ((HEAP8[i3 >> 0] | 0) == 45) {
     i2 = HEAP32[i34 >> 2] | 0;
     HEAP32[i27 >> 2] = 0;
     HEAP32[i14 >> 2] = 0;
     i7 = (i4 | 0) != 0;
     i1 = i7 & 1;
     i6 = i4 - i1 | 0;
     do if ((i4 | 0) != (i1 | 0)) if (i7) {
      i21 = __ZN2cv6String8allocateEj(i27, i6) | 0;
      _memcpy(i21 | 0, (HEAP32[i33 >> 2] | 0) + i1 | 0, i6 | 0) | 0;
      break;
     } else {
      i21 = i3 + -4 | 0;
      HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
      HEAP32[i27 >> 2] = HEAP32[i33 >> 2];
      HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
      break;
     } while (0);
     HEAP32[i28 >> 2] = 0;
     HEAP32[i13 >> 2] = 0;
     i21 = __ZN2cv6String8allocateEj(i28, 4) | 0;
     HEAP8[i21 >> 0] = 116;
     HEAP8[i21 + 1 >> 0] = 114;
     HEAP8[i21 + 2 >> 0] = 117;
     HEAP8[i21 + 3 >> 0] = 101;
     __ZN2cv17CommandLineParser4Impl12apply_paramsERKNS_6StringES4_(i2, i27, i28);
     __ZN2cv6String10deallocateEv(i28);
     __ZN2cv6String10deallocateEv(i27);
    } else i35 = 117;
   }
   if ((i35 | 0) == 117) {
    i35 = 0;
    i2 = HEAP32[i34 >> 2] | 0;
    HEAP32[i29 >> 2] = i3;
    HEAP32[i12 >> 2] = i4;
    if (i3) {
     i21 = i3 + -4 | 0;
     HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
    }
    i4 = HEAP32[i2 + 40 >> 2] | 0;
    i6 = HEAP32[i2 + 36 >> 2] | 0;
    L175 : do if ((i4 | 0) != (i6 | 0)) {
     i4 = i4 - i6 >> 5;
     i7 = 0;
     while (1) {
      i3 = i7 + 1 | 0;
      if ((HEAP32[i6 + (i7 << 5) + 28 >> 2] | 0) == (i5 | 0)) break;
      if (i3 >>> 0 < i4 >>> 0) i7 = i3; else break L175;
     }
     i3 = i6 + (i7 << 5) + 8 | 0;
     if ((i3 | 0) != (i29 | 0)) {
      __ZN2cv6String10deallocateEv(i3);
      i4 = HEAP32[i29 >> 2] | 0;
      if (!i4) i4 = 0; else {
       i4 = i4 + -4 | 0;
       HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
       i4 = HEAP32[i29 >> 2] | 0;
      }
      HEAP32[i3 >> 2] = i4;
      HEAP32[i6 + (i7 << 5) + 12 >> 2] = HEAP32[i12 >> 2];
     }
    } while (0);
    __ZN2cv6String10deallocateEv(i29);
    i5 = i5 + 1 | 0;
   }
   __ZN2cv6String10deallocateEv(i33);
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) < (i30 | 0));
 }
 i5 = HEAP32[i34 >> 2] | 0;
 i4 = i5 + 40 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i5 = i5 + 36 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i3 | 0) == (i2 | 0)) {
  i1 = i3;
  i2 = i3;
 } else {
  i3 = 0;
  do {
   __ZNSt3__16__sortIRNS_6__lessIN2cv6StringES3_EEPS3_EEvT0_S7_T_(HEAP32[i2 + (i3 << 5) + 16 >> 2] | 0, HEAP32[i2 + (i3 << 5) + 20 >> 2] | 0, i36);
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  } while (i3 >>> 0 < i1 - i2 >> 5 >>> 0);
 }
 HEAP32[i36 >> 2] = 74;
 __ZNSt3__16__sortIRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEvT0_S9_T_(i2, i1, i36);
 i1 = HEAP32[i37 >> 2] | 0;
 if (!i1) {
  STACKTOP = i38;
  return;
 }
 while (1) {
  i2 = HEAP32[i22 >> 2] | 0;
  if ((i2 | 0) == (i1 | 0)) break;
  i21 = i2 + -8 | 0;
  HEAP32[i22 >> 2] = i21;
  __ZN2cv6String10deallocateEv(i21);
 }
 __ZdlPv(HEAP32[i37 >> 2] | 0);
 STACKTOP = i38;
 return;
}

function __ZN4perf8TestBase11warmup_implEN2cv3MatENS0_10WarmUpTypeE(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 960 | 0;
 i28 = i34 + 88 | 0;
 i33 = i34 + 896 | 0;
 i25 = i34 + 876 | 0;
 i26 = i34 + 856 | 0;
 i32 = i34 + 800 | 0;
 i27 = i34 + 776 | 0;
 i31 = i34 + 720 | 0;
 i19 = i34 + 80 | 0;
 i29 = i34 + 664 | 0;
 i16 = i34 + 644 | 0;
 i17 = i34 + 624 | 0;
 i24 = i34 + 568 | 0;
 i18 = i34 + 544 | 0;
 i22 = i34 + 488 | 0;
 i20 = i34 + 64 | 0;
 i30 = i34 + 432 | 0;
 i3 = i34 + 412 | 0;
 i14 = i34 + 392 | 0;
 i23 = i34 + 336 | 0;
 i15 = i34 + 312 | 0;
 i21 = i34 + 256 | 0;
 i12 = i34 + 232 | 0;
 i13 = i34 + 176 | 0;
 i4 = i34 + 120 | 0;
 i11 = i34 + 96 | 0;
 i1 = i34;
 if (!i2) {
  __ZNK2cv3Mat7reshapeEii(i13, i5, 1, 0);
  HEAP32[i12 >> 2] = 32088;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP32[i12 + 16 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 16842752;
  HEAP32[i12 + 8 >> 2] = i13;
  __ZN2cv3sumERKNS_11_InputArrayE(i34 + 32 | 0, i12);
  i1 = i13 + 36 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i13);
  HEAP32[i1 >> 2] = 0;
  i22 = i13 + 16 | 0;
  i2 = i13 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i13 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i1 = HEAP32[i13 + 44 >> 2] | 0;
  if ((i1 | 0) == (i13 + 48 | 0)) {
   STACKTOP = i34;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i34;
  return;
 } else if ((i2 | 0) == 1) {
  __ZNK2cv3Mat7reshapeEii(i4, i5, 1, 0);
  HEAP32[i1 + 0 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i11 >> 2] = 32088;
  HEAP32[i11 + 4 >> 2] = -1056833530;
  HEAP32[i11 + 8 >> 2] = i1;
  HEAP32[i11 + 12 >> 2] = 1;
  HEAP32[i11 + 16 >> 2] = 4;
  __ZN2cv3Mat5setToERKNS_11_InputArrayES3_(i4, i11, __ZN2cv7noArrayEv() | 0) | 0;
  i2 = i4 + 36 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i4);
  HEAP32[i2 >> 2] = 0;
  i22 = i4 + 16 | 0;
  i2 = i4 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i4 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i1 = HEAP32[i4 + 44 >> 2] | 0;
  if ((i1 | 0) == (i4 + 48 | 0)) {
   STACKTOP = i34;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i34;
  return;
 } else if ((i2 | 0) == 2) {
  i7 = HEAP32[i5 >> 2] & 7;
  if (i7 >>> 0 < 5) {
   i9 = i28;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 256;
   i9 = HEAP32[i5 + 8 >> 2] | 0;
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i3 | 0) > 0) {
    i2 = HEAP32[i5 + 44 >> 2] | 0;
    i3 = HEAP32[i2 + (i3 + -1 << 2) >> 2] | 0;
   } else {
    i3 = 0;
    i2 = HEAP32[i5 + 44 >> 2] | 0;
   }
   i7 = Math_imul(i3, HEAP32[i5 + 12 >> 2] | 0) | 0;
   i6 = HEAP32[i5 + 16 >> 2] | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i33 >> 2] = 1124007936;
   i19 = i33 + 4 | 0;
   HEAP32[i19 >> 2] = 2;
   i18 = i33 + 8 | 0;
   HEAP32[i18 >> 2] = i9;
   HEAP32[i33 + 12 >> 2] = i7;
   i21 = i33 + 16 | 0;
   HEAP32[i21 >> 2] = i6;
   HEAP32[i33 + 20 >> 2] = i6;
   i2 = i33 + 24 | 0;
   i22 = i33 + 40 | 0;
   HEAP32[i2 + 0 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP32[i22 >> 2] = i18;
   i18 = i33 + 48 | 0;
   i20 = i33 + 44 | 0;
   HEAP32[i20 >> 2] = i18;
   i1 = i33 + 52 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   if (!i3) {
    i3 = i7;
    i4 = 1124024320;
   } else {
    i4 = (i9 | 0) == 1 ? i7 : i3;
    i3 = i4;
    i4 = (i4 | 0) == (i7 | 0) ? 1124024320 : 1124007936;
   }
   HEAP32[i33 >> 2] = i4;
   HEAP32[i18 >> 2] = i3;
   HEAP32[i1 >> 2] = 1;
   i5 = Math_imul(i3, i9) | 0;
   HEAP32[i33 + 28 >> 2] = i6 + i5;
   HEAP32[i2 >> 2] = i6 + (i7 - i3 + i5);
   i5 = i25 + 4 | 0;
   HEAP32[i5 + 0 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i25 >> 2] = 3136;
   HEAP32[i5 >> 2] = 50397184;
   HEAP32[i25 + 8 >> 2] = i33;
   i5 = i32 + 4 | 0;
   HEAP32[i5 >> 2] = 2;
   i13 = i32 + 8 | 0;
   HEAP32[i13 >> 2] = 1;
   HEAP32[i32 + 12 >> 2] = 1;
   i12 = i32 + 16 | 0;
   HEAP32[i12 >> 2] = i28;
   HEAP32[i32 + 20 >> 2] = i28;
   i4 = i32 + 24 | 0;
   i1 = i32 + 40 | 0;
   HEAP32[i4 + 0 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i1 >> 2] = i13;
   i13 = i32 + 48 | 0;
   i10 = i32 + 44 | 0;
   HEAP32[i10 >> 2] = i13;
   HEAP32[i32 >> 2] = 1124024324;
   HEAP32[i13 >> 2] = 4;
   HEAP32[i32 + 52 >> 2] = 4;
   i9 = i28 + 4 | 0;
   HEAP32[i32 + 28 >> 2] = i9;
   HEAP32[i4 >> 2] = i9;
   HEAP32[i26 >> 2] = 32088;
   HEAP32[i26 + 12 >> 2] = 0;
   HEAP32[i26 + 16 >> 2] = 0;
   HEAP32[i26 + 4 >> 2] = 16842752;
   HEAP32[i26 + 8 >> 2] = i32;
   i4 = i28 + 4 | 0;
   i9 = i31 + 4 | 0;
   HEAP32[i9 >> 2] = 2;
   i11 = i31 + 8 | 0;
   HEAP32[i11 >> 2] = 1;
   HEAP32[i31 + 12 >> 2] = 1;
   i7 = i31 + 16 | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i31 + 20 >> 2] = i4;
   i4 = i31 + 24 | 0;
   i6 = i31 + 40 | 0;
   HEAP32[i4 + 0 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i6 >> 2] = i11;
   i11 = i31 + 48 | 0;
   i8 = i31 + 44 | 0;
   HEAP32[i8 >> 2] = i11;
   HEAP32[i31 >> 2] = 1124024324;
   HEAP32[i11 >> 2] = 4;
   HEAP32[i31 + 52 >> 2] = 4;
   i3 = i28 + 8 | 0;
   HEAP32[i31 + 28 >> 2] = i3;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i27 >> 2] = 32088;
   HEAP32[i27 + 12 >> 2] = 0;
   HEAP32[i27 + 16 >> 2] = 0;
   HEAP32[i27 + 4 >> 2] = 16842752;
   HEAP32[i27 + 8 >> 2] = i31;
   __ZN2cv5randuERKNS_17_InputOutputArrayERKNS_11_InputArrayES5_(i25, i26, i27);
   i4 = i31 + 36 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i3 | 0) != 0 ? (i16 = i3 + 12 | 0, i17 = HEAP32[i16 >> 2] | 0, HEAP32[i16 >> 2] = i17 + -1, (i17 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i31);
   HEAP32[i4 >> 2] = 0;
   HEAP32[i7 + 0 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   if ((HEAP32[i9 >> 2] | 0) > 0) {
    i3 = HEAP32[i6 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i9 >> 2] | 0));
   }
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i3 | 0) != (i11 | 0)) __ZN2cv8fastFreeEPv(i3);
   i3 = i32 + 36 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) != 0 ? (i16 = i2 + 12 | 0, i17 = HEAP32[i16 >> 2] | 0, HEAP32[i16 >> 2] = i17 + -1, (i17 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i32);
   HEAP32[i3 >> 2] = 0;
   HEAP32[i12 + 0 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 + 12 >> 2] = 0;
   if ((HEAP32[i5 >> 2] | 0) > 0) {
    i3 = HEAP32[i1 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i5 >> 2] | 0));
   }
   i3 = HEAP32[i10 >> 2] | 0;
   if ((i3 | 0) != (i13 | 0)) __ZN2cv8fastFreeEPv(i3);
   i3 = i33 + 36 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) != 0 ? (i16 = i2 + 12 | 0, i17 = HEAP32[i16 >> 2] | 0, HEAP32[i16 >> 2] = i17 + -1, (i17 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i33);
   HEAP32[i3 >> 2] = 0;
   HEAP32[i21 + 0 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   HEAP32[i21 + 8 >> 2] = 0;
   HEAP32[i21 + 12 >> 2] = 0;
   if ((HEAP32[i19 >> 2] | 0) > 0) {
    i3 = HEAP32[i22 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i19 >> 2] | 0));
   }
   i1 = HEAP32[i20 >> 2] | 0;
   if ((i1 | 0) == (i18 | 0)) {
    STACKTOP = i34;
    return;
   }
   __ZN2cv8fastFreeEPv(i1);
   STACKTOP = i34;
   return;
  }
  if ((i7 | 0) == 5) {
   i10 = i19;
   HEAP32[i10 >> 2] = -981471232;
   HEAP32[i10 + 4 >> 2] = 1166012416;
   __ZNK2cv3Mat7reshapeEii(i29, i5, 1, 0);
   i10 = i16 + 4 | 0;
   HEAP32[i10 + 0 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i16 >> 2] = 3136;
   HEAP32[i10 >> 2] = 50397184;
   HEAP32[i16 + 8 >> 2] = i29;
   i10 = i24 + 4 | 0;
   HEAP32[i10 >> 2] = 2;
   i12 = i24 + 8 | 0;
   HEAP32[i12 >> 2] = 1;
   HEAP32[i24 + 12 >> 2] = 1;
   i8 = i24 + 16 | 0;
   HEAP32[i8 >> 2] = i19;
   HEAP32[i24 + 20 >> 2] = i19;
   i3 = i24 + 24 | 0;
   i9 = i24 + 40 | 0;
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i9 >> 2] = i12;
   i12 = i24 + 48 | 0;
   i11 = i24 + 44 | 0;
   HEAP32[i11 >> 2] = i12;
   HEAP32[i24 >> 2] = 1124024325;
   HEAP32[i12 >> 2] = 4;
   HEAP32[i24 + 52 >> 2] = 4;
   i5 = i19 + 4 | 0;
   HEAP32[i24 + 28 >> 2] = i5;
   HEAP32[i3 >> 2] = i5;
   HEAP32[i17 >> 2] = 32088;
   HEAP32[i17 + 12 >> 2] = 0;
   HEAP32[i17 + 16 >> 2] = 0;
   HEAP32[i17 + 4 >> 2] = 16842752;
   HEAP32[i17 + 8 >> 2] = i24;
   i3 = i19 + 4 | 0;
   i5 = i22 + 4 | 0;
   HEAP32[i5 >> 2] = 2;
   i7 = i22 + 8 | 0;
   HEAP32[i7 >> 2] = 1;
   HEAP32[i22 + 12 >> 2] = 1;
   i1 = i22 + 16 | 0;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i22 + 20 >> 2] = i3;
   i3 = i22 + 24 | 0;
   i4 = i22 + 40 | 0;
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i4 >> 2] = i7;
   i7 = i22 + 48 | 0;
   i6 = i22 + 44 | 0;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i22 >> 2] = 1124024325;
   HEAP32[i7 >> 2] = 4;
   HEAP32[i22 + 52 >> 2] = 4;
   i2 = i19 + 8 | 0;
   HEAP32[i22 + 28 >> 2] = i2;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i18 >> 2] = 32088;
   HEAP32[i18 + 12 >> 2] = 0;
   HEAP32[i18 + 16 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 16842752;
   HEAP32[i18 + 8 >> 2] = i22;
   __ZN2cv5randuERKNS_17_InputOutputArrayERKNS_11_InputArrayES5_(i16, i17, i18);
   i3 = i22 + 36 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) != 0 ? (i20 = i2 + 12 | 0, i21 = HEAP32[i20 >> 2] | 0, HEAP32[i20 >> 2] = i21 + -1, (i21 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i22);
   HEAP32[i3 >> 2] = 0;
   HEAP32[i1 + 0 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   if ((HEAP32[i5 >> 2] | 0) > 0) {
    i3 = HEAP32[i4 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i5 >> 2] | 0));
   }
   i3 = HEAP32[i6 >> 2] | 0;
   if ((i3 | 0) != (i7 | 0)) __ZN2cv8fastFreeEPv(i3);
   i3 = i24 + 36 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i24);
   HEAP32[i3 >> 2] = 0;
   HEAP32[i8 + 0 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   if ((HEAP32[i10 >> 2] | 0) > 0) {
    i3 = HEAP32[i9 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i10 >> 2] | 0));
   }
   i2 = HEAP32[i11 >> 2] | 0;
   if ((i2 | 0) != (i12 | 0)) __ZN2cv8fastFreeEPv(i2);
   i2 = i29 + 36 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i29);
   HEAP32[i2 >> 2] = 0;
   i22 = i29 + 16 | 0;
   i2 = i29 + 4 | 0;
   HEAP32[i22 + 0 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   HEAP32[i22 + 12 >> 2] = 0;
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    i1 = HEAP32[i29 + 40 >> 2] | 0;
    i3 = 0;
    do {
     HEAP32[i1 + (i3 << 2) >> 2] = 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
   }
   i1 = HEAP32[i29 + 44 >> 2] | 0;
   if ((i1 | 0) == (i29 + 48 | 0)) {
    STACKTOP = i34;
    return;
   }
   __ZN2cv8fastFreeEPv(i1);
   STACKTOP = i34;
   return;
  } else {
   HEAP32[i20 + 0 >> 2] = HEAP32[44244];
   HEAP32[i20 + 4 >> 2] = HEAP32[44245];
   HEAP32[i20 + 8 >> 2] = HEAP32[44246];
   HEAP32[i20 + 12 >> 2] = HEAP32[44247];
   __ZNK2cv3Mat7reshapeEii(i30, i5, 1, 0);
   i11 = i3 + 4 | 0;
   HEAP32[i11 + 0 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i3 >> 2] = 3136;
   HEAP32[i11 >> 2] = 50397184;
   HEAP32[i3 + 8 >> 2] = i30;
   i11 = i23 + 4 | 0;
   HEAP32[i11 >> 2] = 2;
   i12 = i23 + 8 | 0;
   HEAP32[i12 >> 2] = 1;
   HEAP32[i23 + 12 >> 2] = 1;
   i9 = i23 + 16 | 0;
   HEAP32[i9 >> 2] = i20;
   HEAP32[i23 + 20 >> 2] = i20;
   i6 = i23 + 24 | 0;
   i8 = i23 + 40 | 0;
   HEAP32[i6 + 0 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   HEAP32[i8 >> 2] = i12;
   i12 = i23 + 48 | 0;
   i10 = i23 + 44 | 0;
   HEAP32[i10 >> 2] = i12;
   HEAP32[i23 >> 2] = 1124024326;
   HEAP32[i12 >> 2] = 8;
   HEAP32[i23 + 52 >> 2] = 8;
   i2 = i20 + 8 | 0;
   HEAP32[i23 + 28 >> 2] = i2;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i14 >> 2] = 32088;
   HEAP32[i14 + 12 >> 2] = 0;
   HEAP32[i14 + 16 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 16842752;
   HEAP32[i14 + 8 >> 2] = i23;
   i6 = i21 + 4 | 0;
   HEAP32[i6 >> 2] = 2;
   i7 = i21 + 8 | 0;
   HEAP32[i7 >> 2] = 1;
   HEAP32[i21 + 12 >> 2] = 1;
   i4 = i21 + 16 | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i21 + 20 >> 2] = i2;
   i2 = i21 + 24 | 0;
   i1 = i21 + 40 | 0;
   HEAP32[i2 + 0 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP32[i1 >> 2] = i7;
   i7 = i21 + 48 | 0;
   i5 = i21 + 44 | 0;
   HEAP32[i5 >> 2] = i7;
   HEAP32[i21 >> 2] = 1124024326;
   HEAP32[i7 >> 2] = 8;
   HEAP32[i21 + 52 >> 2] = 8;
   i22 = i20 + 16 | 0;
   HEAP32[i21 + 28 >> 2] = i22;
   HEAP32[i2 >> 2] = i22;
   HEAP32[i15 >> 2] = 32088;
   HEAP32[i15 + 12 >> 2] = 0;
   HEAP32[i15 + 16 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 16842752;
   HEAP32[i15 + 8 >> 2] = i21;
   __ZN2cv5randuERKNS_17_InputOutputArrayERKNS_11_InputArrayES5_(i3, i14, i15);
   i3 = i21 + 36 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) != 0 ? (i20 = i2 + 12 | 0, i22 = HEAP32[i20 >> 2] | 0, HEAP32[i20 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i21);
   HEAP32[i3 >> 2] = 0;
   HEAP32[i4 + 0 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   if ((HEAP32[i6 >> 2] | 0) > 0) {
    i3 = HEAP32[i1 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i6 >> 2] | 0));
   }
   i3 = HEAP32[i5 >> 2] | 0;
   if ((i3 | 0) != (i7 | 0)) __ZN2cv8fastFreeEPv(i3);
   i3 = i23 + 36 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i23);
   HEAP32[i3 >> 2] = 0;
   HEAP32[i9 + 0 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   if ((HEAP32[i11 >> 2] | 0) > 0) {
    i3 = HEAP32[i8 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i11 >> 2] | 0));
   }
   i2 = HEAP32[i10 >> 2] | 0;
   if ((i2 | 0) != (i12 | 0)) __ZN2cv8fastFreeEPv(i2);
   i2 = i30 + 36 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i30);
   HEAP32[i2 >> 2] = 0;
   i22 = i30 + 16 | 0;
   i2 = i30 + 4 | 0;
   HEAP32[i22 + 0 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   HEAP32[i22 + 12 >> 2] = 0;
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    i1 = HEAP32[i30 + 40 >> 2] | 0;
    i3 = 0;
    do {
     HEAP32[i1 + (i3 << 2) >> 2] = 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
   }
   i1 = HEAP32[i30 + 44 >> 2] | 0;
   if ((i1 | 0) == (i30 + 48 | 0)) {
    STACKTOP = i34;
    return;
   }
   __ZN2cv8fastFreeEPv(i1);
   STACKTOP = i34;
   return;
  }
 } else {
  STACKTOP = i34;
  return;
 }
}

function __ZNK2cv17CommandLineParser4Impl18split_range_stringERKNS_6StringEcc(i14, i1, i3, i61, i62) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i61 = i61 | 0;
 i62 = i62 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i63 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 i60 = i16 + 368 | 0;
 i15 = i16 + 360 | 0;
 i17 = i16 + 352 | 0;
 i18 = i16 + 344 | 0;
 i28 = i16 + 336 | 0;
 i38 = i16 + 328 | 0;
 i48 = i16 + 320 | 0;
 i54 = i16 + 312 | 0;
 i55 = i16 + 304 | 0;
 i56 = i16 + 296 | 0;
 i57 = i16 + 288 | 0;
 i58 = i16 + 280 | 0;
 i19 = i16 + 272 | 0;
 i20 = i16 + 264 | 0;
 i21 = i16 + 256 | 0;
 i22 = i16 + 248 | 0;
 i11 = i16 + 240 | 0;
 i23 = i16 + 232 | 0;
 i24 = i16 + 224 | 0;
 i25 = i16 + 216 | 0;
 i26 = i16 + 208 | 0;
 i27 = i16 + 200 | 0;
 i29 = i16 + 192 | 0;
 i30 = i16 + 184 | 0;
 i31 = i16 + 176 | 0;
 i32 = i16 + 168 | 0;
 i33 = i16 + 160 | 0;
 i34 = i16 + 152 | 0;
 i35 = i16 + 144 | 0;
 i36 = i16 + 136 | 0;
 i37 = i16 + 128 | 0;
 i12 = i16 + 120 | 0;
 i13 = i16 + 112 | 0;
 i39 = i16 + 104 | 0;
 i40 = i16 + 96 | 0;
 i41 = i16 + 88 | 0;
 i42 = i16 + 80 | 0;
 i43 = i16 + 72 | 0;
 i44 = i16 + 64 | 0;
 i45 = i16 + 56 | 0;
 i46 = i16 + 48 | 0;
 i47 = i16 + 40 | 0;
 i49 = i16 + 32 | 0;
 i50 = i16 + 24 | 0;
 i51 = i16 + 16 | 0;
 i52 = i16 + 8 | 0;
 i53 = i16;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i60 >> 2] = i2;
 i59 = i60 + 4 | 0;
 HEAP32[i59 >> 2] = HEAP32[i3 + 4 >> 2];
 if (i2) {
  i10 = i2 + -4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 HEAP32[i14 >> 2] = 0;
 i1 = i14 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i6 = i14 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 i7 = i15 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 __ZN2cv6String8allocateEj(i15, 0) | 0;
 i8 = i11 + 4 | 0;
 i9 = i13 + 4 | 0;
 i10 = i12 + 4 | 0;
 i4 = 0;
 L4 : while (1) {
  if (!(HEAP32[i59 >> 2] | 0)) {
   i2 = 35;
   break;
  }
  i5 = HEAP8[HEAP32[i60 >> 2] >> 0] | 0;
  if (i5 << 24 >> 24 == i61 << 24 >> 24) {
   if (i4) {
    i2 = 7;
    break;
   }
   __ZN2cv6String10deallocateEv(i15);
   __ZN2cv6String8allocateEj(i15, 0) | 0;
   i5 = HEAP32[i59 >> 2] | 0;
   i2 = i5 + -1 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   i4 = (i5 | 0) != 0 & 1;
   i3 = i5 - i4 | 0;
   i3 = i3 >>> 0 > i2 >>> 0 ? i2 : i3;
   do if (i3) if ((i3 | 0) == (i5 | 0)) {
    i5 = (HEAP32[i60 >> 2] | 0) + -4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    HEAP32[i11 >> 2] = HEAP32[i60 >> 2];
    HEAP32[i8 >> 2] = HEAP32[i59 >> 2];
    break;
   } else {
    i5 = __ZN2cv6String8allocateEj(i11, i3) | 0;
    _memcpy(i5 | 0, (HEAP32[i60 >> 2] | 0) + i4 | 0, i3 | 0) | 0;
    break;
   } while (0);
   __ZN2cv6String10deallocateEv(i60);
   i5 = HEAP32[i11 >> 2] | 0;
   if (!i5) i5 = 0; else {
    i5 = i5 + -4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i5 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i60 >> 2] = i5;
   HEAP32[i59 >> 2] = HEAP32[i8 >> 2];
   __ZN2cv6String10deallocateEv(i11);
   i5 = HEAP8[HEAP32[i60 >> 2] >> 0] | 0;
   i4 = 1;
  }
  do if (i5 << 24 >> 24 != i62 << 24 >> 24) if (i4) {
   HEAP32[i12 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   __ZN2cv6String8allocateEj(i12, (HEAP32[i7 >> 2] | 0) + 1 | 0) | 0;
   _memcpy(HEAP32[i12 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
   HEAP8[(HEAP32[i12 >> 2] | 0) + (HEAP32[i7 >> 2] | 0) >> 0] = i5;
   __ZN2cv6String10deallocateEv(i15);
   i5 = HEAP32[i12 >> 2] | 0;
   if (!i5) i5 = 0; else {
    i5 = i5 + -4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i5 = HEAP32[i12 >> 2] | 0;
   }
   HEAP32[i15 >> 2] = i5;
   HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
   __ZN2cv6String10deallocateEv(i12);
   i4 = 1;
  } else i4 = 0; else {
   if (!i4) {
    i2 = 17;
    break L4;
   }
   i5 = HEAP32[i1 >> 2] | 0;
   if ((i5 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i14, i15);
    i4 = 0;
    break;
   }
   if (i5) {
    i4 = HEAP32[i15 >> 2] | 0;
    HEAP32[i5 >> 2] = i4;
    HEAP32[i5 + 4 >> 2] = HEAP32[i7 >> 2];
    if (i4) {
     i5 = i4 + -4 | 0;
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
     i5 = HEAP32[i1 >> 2] | 0;
    }
   } else i5 = 0;
   HEAP32[i1 >> 2] = i5 + 8;
   i4 = 0;
  } while (0);
  i5 = HEAP32[i59 >> 2] | 0;
  i63 = i5 + -1 | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i3 = (i5 | 0) != 0 & 1;
  i2 = i5 - i3 | 0;
  i2 = i2 >>> 0 > i63 >>> 0 ? i63 : i2;
  do if (i2) if ((i2 | 0) == (i5 | 0)) {
   i5 = (HEAP32[i60 >> 2] | 0) + -4 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   HEAP32[i13 >> 2] = HEAP32[i60 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i59 >> 2];
   break;
  } else {
   i5 = __ZN2cv6String8allocateEj(i13, i2) | 0;
   _memcpy(i5 | 0, (HEAP32[i60 >> 2] | 0) + i3 | 0, i2 | 0) | 0;
   break;
  } while (0);
  __ZN2cv6String10deallocateEv(i60);
  i5 = HEAP32[i13 >> 2] | 0;
  if (!i5) i5 = 0; else {
   i5 = i5 + -4 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   i5 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i60 >> 2] = i5;
  HEAP32[i59 >> 2] = HEAP32[i9 >> 2];
  __ZN2cv6String10deallocateEv(i13);
 }
 if ((i2 | 0) == 7) {
  i2 = ___cxa_allocate_exception(44) | 0;
  HEAP32[i55 >> 2] = 0;
  i1 = i55 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i55, 28) | 0) + 0 | 0;
  i4 = 6376 | 0;
  i5 = i3 + 28 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  HEAP32[i54 >> 2] = 0;
  i4 = i54 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i54, (HEAP32[i59 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i54 >> 2] | 0, HEAP32[i55 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  _memcpy((HEAP32[i54 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0, HEAP32[i60 >> 2] | 0, HEAP32[i59 >> 2] | 0) | 0;
  HEAP32[i56 >> 2] = 0;
  i3 = i56 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i5 = __ZN2cv6String8allocateEj(i56, 2) | 0;
  HEAP8[i5 >> 0] = 44;
  HEAP8[i5 + 1 >> 0] = 32;
  HEAP32[i48 >> 2] = 0;
  i5 = i48 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  __ZN2cv6String8allocateEj(i48, (HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i48 >> 2] | 0, HEAP32[i54 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
  _memcpy((HEAP32[i48 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0, HEAP32[i56 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i57 >> 2] = 0;
  i3 = i57 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  _memset(__ZN2cv6String8allocateEj(i57, 1) | 0, i61 | 0, 1) | 0;
  HEAP32[i38 >> 2] = 0;
  i4 = i38 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i38, (HEAP32[i3 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i38 >> 2] | 0, HEAP32[i48 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  _memcpy((HEAP32[i38 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0, HEAP32[i57 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i58 >> 2] = 0;
  i3 = i58 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i5 = __ZN2cv6String8allocateEj(i58, 2) | 0;
  HEAP8[i5 >> 0] = 44;
  HEAP8[i5 + 1 >> 0] = 32;
  HEAP32[i28 >> 2] = 0;
  i5 = i28 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  __ZN2cv6String8allocateEj(i28, (HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i28 >> 2] | 0, HEAP32[i38 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
  _memcpy((HEAP32[i28 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0, HEAP32[i58 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i19 >> 2] = 0;
  i3 = i19 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  _memset(__ZN2cv6String8allocateEj(i19, 1) | 0, i62 | 0, 1) | 0;
  HEAP32[i18 >> 2] = 0;
  i4 = i18 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i18, (HEAP32[i3 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i18 >> 2] | 0, HEAP32[i28 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  _memcpy((HEAP32[i18 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0, HEAP32[i19 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i20 >> 2] = 0;
  i3 = i20 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP8[(__ZN2cv6String8allocateEj(i20, 1) | 0) >> 0] = 41;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i17, (HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i17 >> 2] | 0, HEAP32[i18 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
  _memcpy((HEAP32[i17 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0, HEAP32[i20 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i21, 0) | 0;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i22, 66) | 0) + 0 | 0;
  i4 = 6408 | 0;
  i5 = i3 + 66 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv9ExceptionC2EiRKNS_6StringES3_S3_i(i2, -212, i17, i21, i22, 442);
  ___cxa_throw(i2 | 0, 25504, 92);
 } else if ((i2 | 0) == 17) {
  i1 = ___cxa_allocate_exception(44) | 0;
  HEAP32[i30 >> 2] = 0;
  i2 = i30 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i30, 28) | 0) + 0 | 0;
  i4 = 6376 | 0;
  i5 = i3 + 28 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  HEAP32[i29 >> 2] = 0;
  i4 = i29 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i29, (HEAP32[i59 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i29 >> 2] | 0, HEAP32[i30 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  _memcpy((HEAP32[i29 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0, HEAP32[i60 >> 2] | 0, HEAP32[i59 >> 2] | 0) | 0;
  HEAP32[i31 >> 2] = 0;
  i3 = i31 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i5 = __ZN2cv6String8allocateEj(i31, 2) | 0;
  HEAP8[i5 >> 0] = 44;
  HEAP8[i5 + 1 >> 0] = 32;
  HEAP32[i27 >> 2] = 0;
  i5 = i27 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  __ZN2cv6String8allocateEj(i27, (HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i27 >> 2] | 0, HEAP32[i29 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
  _memcpy((HEAP32[i27 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0, HEAP32[i31 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i32 >> 2] = 0;
  i3 = i32 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  _memset(__ZN2cv6String8allocateEj(i32, 1) | 0, i61 | 0, 1) | 0;
  HEAP32[i26 >> 2] = 0;
  i4 = i26 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i26, (HEAP32[i3 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i26 >> 2] | 0, HEAP32[i27 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  _memcpy((HEAP32[i26 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0, HEAP32[i32 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i33 >> 2] = 0;
  i3 = i33 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i5 = __ZN2cv6String8allocateEj(i33, 2) | 0;
  HEAP8[i5 >> 0] = 44;
  HEAP8[i5 + 1 >> 0] = 32;
  HEAP32[i25 >> 2] = 0;
  i5 = i25 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  __ZN2cv6String8allocateEj(i25, (HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i25 >> 2] | 0, HEAP32[i26 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
  _memcpy((HEAP32[i25 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0, HEAP32[i33 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i34 >> 2] = 0;
  i3 = i34 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  _memset(__ZN2cv6String8allocateEj(i34, 1) | 0, i62 | 0, 1) | 0;
  HEAP32[i24 >> 2] = 0;
  i4 = i24 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i24, (HEAP32[i3 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i24 >> 2] | 0, HEAP32[i25 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  _memcpy((HEAP32[i24 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0, HEAP32[i34 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i35 >> 2] = 0;
  i3 = i35 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP8[(__ZN2cv6String8allocateEj(i35, 1) | 0) >> 0] = 41;
  HEAP32[i23 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i23, (HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i23 >> 2] | 0, HEAP32[i24 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
  _memcpy((HEAP32[i23 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0, HEAP32[i35 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i36 >> 2] = 0;
  HEAP32[i36 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i36, 0) | 0;
  HEAP32[i37 >> 2] = 0;
  HEAP32[i37 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i37, 66) | 0) + 0 | 0;
  i4 = 6408 | 0;
  i5 = i3 + 66 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv9ExceptionC2EiRKNS_6StringES3_S3_i(i1, -212, i23, i36, i37, 462);
  ___cxa_throw(i1 | 0, 25504, 92);
 } else if ((i2 | 0) == 35) if (i4) {
  i2 = ___cxa_allocate_exception(44) | 0;
  HEAP32[i45 >> 2] = 0;
  i1 = i45 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i45, 28) | 0) + 0 | 0;
  i4 = 6376 | 0;
  i5 = i3 + 28 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  HEAP32[i44 >> 2] = 0;
  i4 = i44 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i44, (HEAP32[i59 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i44 >> 2] | 0, HEAP32[i45 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  _memcpy((HEAP32[i44 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0, HEAP32[i60 >> 2] | 0, HEAP32[i59 >> 2] | 0) | 0;
  HEAP32[i46 >> 2] = 0;
  i3 = i46 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i5 = __ZN2cv6String8allocateEj(i46, 2) | 0;
  HEAP8[i5 >> 0] = 44;
  HEAP8[i5 + 1 >> 0] = 32;
  HEAP32[i43 >> 2] = 0;
  i5 = i43 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  __ZN2cv6String8allocateEj(i43, (HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i43 >> 2] | 0, HEAP32[i44 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
  _memcpy((HEAP32[i43 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0, HEAP32[i46 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i47 >> 2] = 0;
  i3 = i47 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  _memset(__ZN2cv6String8allocateEj(i47, 1) | 0, i61 | 0, 1) | 0;
  HEAP32[i42 >> 2] = 0;
  i4 = i42 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i42, (HEAP32[i3 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i42 >> 2] | 0, HEAP32[i43 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  _memcpy((HEAP32[i42 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0, HEAP32[i47 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i49 >> 2] = 0;
  i3 = i49 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i5 = __ZN2cv6String8allocateEj(i49, 2) | 0;
  HEAP8[i5 >> 0] = 44;
  HEAP8[i5 + 1 >> 0] = 32;
  HEAP32[i41 >> 2] = 0;
  i5 = i41 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  __ZN2cv6String8allocateEj(i41, (HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i41 >> 2] | 0, HEAP32[i42 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
  _memcpy((HEAP32[i41 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0, HEAP32[i49 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i50 >> 2] = 0;
  i3 = i50 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  _memset(__ZN2cv6String8allocateEj(i50, 1) | 0, i62 | 0, 1) | 0;
  HEAP32[i40 >> 2] = 0;
  i4 = i40 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i40, (HEAP32[i3 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i40 >> 2] | 0, HEAP32[i41 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  _memcpy((HEAP32[i40 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0, HEAP32[i50 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i51 >> 2] = 0;
  i3 = i51 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP8[(__ZN2cv6String8allocateEj(i51, 1) | 0) >> 0] = 41;
  HEAP32[i39 >> 2] = 0;
  HEAP32[i39 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i39, (HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i39 >> 2] | 0, HEAP32[i40 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
  _memcpy((HEAP32[i39 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0, HEAP32[i51 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i52 >> 2] = 0;
  HEAP32[i52 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i52, 0) | 0;
  HEAP32[i53 >> 2] = 0;
  HEAP32[i53 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i53, 66) | 0) + 0 | 0;
  i4 = 6408 | 0;
  i5 = i3 + 66 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv9ExceptionC2EiRKNS_6StringES3_S3_i(i2, -212, i39, i52, i53, 486);
  ___cxa_throw(i2 | 0, 25504, 92);
 } else {
  __ZN2cv6String10deallocateEv(i15);
  __ZN2cv6String10deallocateEv(i60);
  STACKTOP = i16;
  return;
 }
}

function _MUSL_vfscanf(i29, i3, i27) {
 i29 = i29 | 0;
 i3 = i3 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i28 = i34 + 16 | 0;
 i31 = i34 + 8 | 0;
 i30 = i34 + 33 | 0;
 i32 = i34;
 i17 = i34 + 32 | 0;
 i4 = HEAP8[i3 >> 0] | 0;
 if (!(i4 << 24 >> 24)) {
  i23 = 0;
  STACKTOP = i34;
  return i23 | 0;
 }
 i20 = i29 + 4 | 0;
 i21 = i29 + 100 | 0;
 i22 = i29 + 108 | 0;
 i23 = i29 + 8 | 0;
 i24 = i30 + 10 | 0;
 i25 = i30 + 33 | 0;
 i26 = i31 + 4 | 0;
 i18 = i30 + 46 | 0;
 i19 = i30 + 94 | 0;
 i1 = 0;
 i8 = i3;
 i10 = 0;
 i3 = 0;
 i2 = 0;
 L4 : while (1) {
  L6 : do if (!(_isspace(i4 & 255) | 0)) {
   i5 = (HEAP8[i8 >> 0] | 0) == 37;
   L21 : do if (i5) {
    i7 = i8 + 1 | 0;
    i4 = HEAP8[i7 >> 0] | 0;
    do if (i4 << 24 >> 24 == 37) break L21; else if (i4 << 24 >> 24 == 42) {
     i16 = 0;
     i7 = i8 + 2 | 0;
    } else {
     i5 = (i4 & 255) + -48 | 0;
     if (i5 >>> 0 < 10 ? (HEAP8[i8 + 2 >> 0] | 0) == 36 : 0) {
      HEAP32[i28 >> 2] = HEAP32[i27 >> 2];
      while (1) {
       i16 = HEAP32[i28 >> 2] | 0;
       i4 = HEAP32[i16 >> 2] | 0;
       HEAP32[i28 >> 2] = i16 + 4;
       if (i5 >>> 0 > 1) i5 = i5 + -1 | 0; else break;
      }
      i16 = i4;
      i7 = i8 + 3 | 0;
      break;
     }
     i15 = HEAP32[i27 >> 2] | 0;
     i16 = HEAP32[i15 >> 2] | 0;
     HEAP32[i27 >> 2] = i15 + 4;
    } while (0);
    i5 = HEAP8[i7 >> 0] | 0;
    i4 = i5 & 255;
    if ((i4 + -48 | 0) >>> 0 < 10) {
     i5 = 0;
     while (1) {
      i8 = (i5 * 10 | 0) + -48 + i4 | 0;
      i7 = i7 + 1 | 0;
      i5 = HEAP8[i7 >> 0] | 0;
      i4 = i5 & 255;
      if ((i4 + -48 | 0) >>> 0 >= 10) break; else i5 = i8;
     }
    } else i8 = 0;
    if (i5 << 24 >> 24 == 109) {
     i7 = i7 + 1 | 0;
     i9 = HEAP8[i7 >> 0] | 0;
     i4 = (i16 | 0) != 0 & 1;
     i3 = 0;
     i2 = 0;
    } else {
     i9 = i5;
     i4 = 0;
    }
    i5 = i7 + 1 | 0;
    switch (i9 & 255 | 0) {
    case 106:
     {
      i7 = 3;
      break;
     }
    case 110:
    case 112:
    case 67:
    case 83:
    case 91:
    case 99:
    case 115:
    case 88:
    case 71:
    case 70:
    case 69:
    case 65:
    case 103:
    case 102:
    case 101:
    case 97:
    case 120:
    case 117:
    case 111:
    case 105:
    case 100:
     {
      i5 = i7;
      i7 = 0;
      break;
     }
    case 76:
     {
      i7 = 2;
      break;
     }
    case 108:
     {
      i15 = (HEAP8[i5 >> 0] | 0) == 108;
      i5 = i15 ? i7 + 2 | 0 : i5;
      i7 = i15 ? 3 : 1;
      break;
     }
    case 116:
    case 122:
     {
      i7 = 1;
      break;
     }
    case 104:
     {
      i15 = (HEAP8[i5 >> 0] | 0) == 104;
      i5 = i15 ? i7 + 2 | 0 : i5;
      i7 = i15 ? -2 : -1;
      break;
     }
    default:
     {
      i33 = 162;
      break L4;
     }
    }
    i11 = HEAPU8[i5 >> 0] | 0;
    i12 = (i11 & 47 | 0) == 3;
    i11 = i12 ? i11 | 32 : i11;
    i12 = i12 ? 1 : i7;
    if ((i11 | 0) == 99) {
     i15 = i10;
     i14 = (i8 | 0) < 1 ? 1 : i8;
    } else if ((i11 | 0) == 110) {
     if (!i16) {
      i9 = i10;
      break L6;
     }
     switch (i12 | 0) {
     case 1:
      {
       HEAP32[i16 >> 2] = i10;
       i9 = i10;
       break L6;
      }
     case -2:
      {
       HEAP8[i16 >> 0] = i10;
       i9 = i10;
       break L6;
      }
     case -1:
      {
       HEAP16[i16 >> 1] = i10;
       i9 = i10;
       break L6;
      }
     case 0:
      {
       HEAP32[i16 >> 2] = i10;
       i9 = i10;
       break L6;
      }
     case 3:
      {
       i9 = i16;
       HEAP32[i9 >> 2] = i10;
       HEAP32[i9 + 4 >> 2] = ((i10 | 0) < 0) << 31 >> 31;
       i9 = i10;
       break L6;
      }
     default:
      {
       i9 = i10;
       break L6;
      }
     }
    } else if ((i11 | 0) == 91) {
     i15 = i10;
     i14 = i8;
    } else {
     ___shlim(i29, 0);
     do {
      i7 = HEAP32[i20 >> 2] | 0;
      if (i7 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
       HEAP32[i20 >> 2] = i7 + 1;
       i7 = HEAPU8[i7 >> 0] | 0;
      } else i7 = ___shgetc(i29) | 0;
     } while ((_isspace(i7) | 0) != 0);
     i7 = HEAP32[i20 >> 2] | 0;
     if (HEAP32[i21 >> 2] | 0) {
      i7 = i7 + -1 | 0;
      HEAP32[i20 >> 2] = i7;
     }
     i15 = (HEAP32[i22 >> 2] | 0) + i10 + i7 - (HEAP32[i23 >> 2] | 0) | 0;
     i14 = i8;
    }
    ___shlim(i29, i14);
    i7 = HEAP32[i20 >> 2] | 0;
    i8 = HEAP32[i21 >> 2] | 0;
    if (i7 >>> 0 < i8 >>> 0) HEAP32[i20 >> 2] = i7 + 1; else {
     if ((___shgetc(i29) | 0) < 0) {
      i33 = 162;
      break L4;
     }
     i8 = HEAP32[i21 >> 2] | 0;
    }
    if (i8) HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + -1;
    L78 : do switch (i11 | 0) {
    case 91:
    case 99:
    case 115:
     {
      i13 = (i11 | 0) == 99;
      L80 : do if ((i11 & 239 | 0) == 99) {
       _memset(i30 | 0, -1, 257) | 0;
       HEAP8[i30 >> 0] = 0;
       if ((i11 | 0) == 115) {
        HEAP8[i25 >> 0] = 0;
        HEAP8[i24 + 0 >> 0] = 0;
        HEAP8[i24 + 1 >> 0] = 0;
        HEAP8[i24 + 2 >> 0] = 0;
        HEAP8[i24 + 3 >> 0] = 0;
        HEAP8[i24 + 4 >> 0] = 0;
       }
      } else {
       i10 = i5 + 1 | 0;
       i7 = (HEAP8[i10 >> 0] | 0) == 94;
       i9 = i7 & 1;
       i5 = i7 ? i5 + 2 | 0 : i10;
       _memset(i30 | 0, i7 & 1 | 0, 257) | 0;
       HEAP8[i30 >> 0] = 0;
       i7 = HEAP8[i5 >> 0] | 0;
       if (i7 << 24 >> 24 == 45) {
        i11 = (i9 ^ 1) & 255;
        HEAP8[i18 >> 0] = i11;
        i5 = i5 + 1 | 0;
       } else if (i7 << 24 >> 24 == 93) {
        i11 = (i9 ^ 1) & 255;
        HEAP8[i19 >> 0] = i11;
        i5 = i5 + 1 | 0;
       } else i11 = (i9 ^ 1) & 255;
       while (1) {
        i7 = HEAP8[i5 >> 0] | 0;
        if (i7 << 24 >> 24 == 45) {
         i10 = i5 + 1 | 0;
         i7 = HEAP8[i10 >> 0] | 0;
         if (!(i7 << 24 >> 24 == 93 | i7 << 24 >> 24 == 0)) {
          i9 = HEAP8[i5 + -1 >> 0] | 0;
          if ((i9 & 255) < (i7 & 255)) {
           i9 = i9 & 255;
           do {
            i9 = i9 + 1 | 0;
            HEAP8[i30 + i9 >> 0] = i11;
            i7 = HEAP8[i10 >> 0] | 0;
           } while ((i9 | 0) < (i7 & 255 | 0));
           i5 = i10;
          } else i5 = i10;
         } else i7 = 45;
        } else if (i7 << 24 >> 24 == 93) break L80; else if (!(i7 << 24 >> 24)) {
         i33 = 162;
         break L4;
        }
        HEAP8[i30 + ((i7 & 255) + 1) >> 0] = i11;
        i5 = i5 + 1 | 0;
       }
      } while (0);
      i9 = i13 ? i14 + 1 | 0 : 31;
      i12 = (i12 | 0) == 1;
      i10 = (i4 | 0) != 0;
      L99 : do if (i12) {
       if (i10) {
        i2 = _malloc(i9 << 2) | 0;
        if (!i2) {
         i3 = 0;
         i33 = 162;
         break L4;
        }
       } else i2 = i16;
       HEAP32[i31 >> 2] = 0;
       HEAP32[i26 >> 2] = 0;
       i8 = 0;
       L105 : while (1) {
        if (!i2) while (1) {
         i7 = HEAP32[i20 >> 2] | 0;
         if (i7 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
          HEAP32[i20 >> 2] = i7 + 1;
          i7 = HEAPU8[i7 >> 0] | 0;
         } else i7 = ___shgetc(i29) | 0;
         if (!(HEAP8[i30 + (i7 + 1) >> 0] | 0)) {
          i2 = 0;
          break L105;
         }
         HEAP8[i17 >> 0] = i7;
         i7 = _mbrtowc(i32, i17, 1, i31) | 0;
         if ((i7 | 0) == -1) {
          i3 = 0;
          i2 = 0;
          i33 = 162;
          break L4;
         } else if ((i7 | 0) == -2) continue;
         if (i10 & (i8 | 0) == (i9 | 0)) break;
        } else {
         if (!i10) {
          i9 = i8;
          i33 = 98;
          break;
         }
         while (1) {
          while (1) {
           i7 = HEAP32[i20 >> 2] | 0;
           if (i7 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
            HEAP32[i20 >> 2] = i7 + 1;
            i7 = HEAPU8[i7 >> 0] | 0;
           } else i7 = ___shgetc(i29) | 0;
           if (!(HEAP8[i30 + (i7 + 1) >> 0] | 0)) break L105;
           HEAP8[i17 >> 0] = i7;
           i7 = _mbrtowc(i32, i17, 1, i31) | 0;
           if ((i7 | 0) == -1) {
            i3 = 0;
            i33 = 162;
            break L4;
           } else if ((i7 | 0) != -2) break;
          }
          HEAP32[i2 + (i8 << 2) >> 2] = HEAP32[i32 >> 2];
          i8 = i8 + 1 | 0;
          if ((i8 | 0) == (i9 | 0)) {
           i8 = i9;
           break;
          }
         }
        }
        i9 = i9 << 1 | 1;
        i7 = _realloc(i2, i9 << 2) | 0;
        if (!i7) {
         i3 = 0;
         i33 = 162;
         break L4;
        }
        i2 = i7;
       }
       L129 : do if ((i33 | 0) == 98) while (1) {
        i33 = 0;
        while (1) {
         i8 = HEAP32[i20 >> 2] | 0;
         if (i8 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
          HEAP32[i20 >> 2] = i8 + 1;
          i8 = HEAPU8[i8 >> 0] | 0;
         } else i8 = ___shgetc(i29) | 0;
         if (!(HEAP8[i30 + (i8 + 1) >> 0] | 0)) {
          i8 = i9;
          break L129;
         }
         HEAP8[i17 >> 0] = i8;
         i8 = _mbrtowc(i32, i17, 1, i31) | 0;
         if ((i8 | 0) == -1) {
          i4 = 0;
          i3 = 0;
          i33 = 162;
          break L4;
         } else if ((i8 | 0) != -2) break;
        }
        HEAP32[i2 + (i9 << 2) >> 2] = HEAP32[i32 >> 2];
        i9 = i9 + 1 | 0;
        i33 = 98;
       } while (0);
       if (!(_mbsinit(i31) | 0)) {
        i3 = 0;
        i33 = 162;
        break L4;
       } else i3 = 0;
      } else {
       if (i10) {
        i3 = _malloc(i9) | 0;
        if (!i3) {
         i3 = 0;
         i2 = 0;
         i33 = 162;
         break L4;
        } else i8 = 0;
        while (1) {
         do {
          i7 = HEAP32[i20 >> 2] | 0;
          if (i7 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
           HEAP32[i20 >> 2] = i7 + 1;
           i7 = HEAPU8[i7 >> 0] | 0;
          } else i7 = ___shgetc(i29) | 0;
          if (!(HEAP8[i30 + (i7 + 1) >> 0] | 0)) {
           i2 = 0;
           break L99;
          }
          HEAP8[i3 + i8 >> 0] = i7;
          i8 = i8 + 1 | 0;
         } while ((i8 | 0) != (i9 | 0));
         i8 = i9 << 1 | 1;
         i7 = _realloc(i3, i8) | 0;
         if (!i7) {
          i2 = 0;
          i33 = 162;
          break L4;
         } else {
          i2 = i9;
          i9 = i8;
          i3 = i7;
          i8 = i2;
         }
        }
       }
       if (!i16) {
        i3 = i8;
        while (1) {
         i7 = HEAP32[i20 >> 2] | 0;
         if (i7 >>> 0 < i3 >>> 0) {
          HEAP32[i20 >> 2] = i7 + 1;
          i7 = HEAPU8[i7 >> 0] | 0;
         } else i7 = ___shgetc(i29) | 0;
         if (!(HEAP8[i30 + (i7 + 1) >> 0] | 0)) {
          i8 = 0;
          i3 = 0;
          i2 = 0;
          break L99;
         }
         i3 = HEAP32[i21 >> 2] | 0;
        }
       } else {
        i9 = 0;
        while (1) {
         i7 = HEAP32[i20 >> 2] | 0;
         if (i7 >>> 0 < i8 >>> 0) {
          HEAP32[i20 >> 2] = i7 + 1;
          i7 = HEAPU8[i7 >> 0] | 0;
         } else i7 = ___shgetc(i29) | 0;
         if (!(HEAP8[i30 + (i7 + 1) >> 0] | 0)) {
          i8 = i9;
          i3 = i16;
          i2 = 0;
          break L99;
         }
         HEAP8[i16 + i9 >> 0] = i7;
         i8 = HEAP32[i21 >> 2] | 0;
         i9 = i9 + 1 | 0;
        }
       }
      } while (0);
      i7 = HEAP32[i20 >> 2] | 0;
      if (HEAP32[i21 >> 2] | 0) {
       i7 = i7 + -1 | 0;
       HEAP32[i20 >> 2] = i7;
      }
      i7 = i7 - (HEAP32[i23 >> 2] | 0) + (HEAP32[i22 >> 2] | 0) | 0;
      if (!i7) break L4;
      if (!((i7 | 0) == (i14 | 0) | i13 ^ 1)) break L4;
      do if (i10) if (i12) {
       HEAP32[i16 >> 2] = i2;
       break;
      } else {
       HEAP32[i16 >> 2] = i3;
       break;
      } while (0);
      if (!i13) {
       if (i2) HEAP32[i2 + (i8 << 2) >> 2] = 0;
       if (!i3) i3 = 0; else HEAP8[i3 + i8 >> 0] = 0;
      }
      break;
     }
    case 71:
    case 103:
    case 70:
    case 102:
    case 69:
    case 101:
    case 65:
    case 97:
     {
      d6 = +___floatscan(i29, i12, 0);
      if ((HEAP32[i22 >> 2] | 0) == ((HEAP32[i23 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0)) break L4;
      if (i16) if (!i12) {
       HEAPF32[i16 >> 2] = Math_fround(d6);
       break L78;
      } else if ((i12 | 0) == 1) {
       HEAPF64[i16 >> 3] = d6;
       break L78;
      } else if ((i12 | 0) == 2) {
       HEAPF64[i16 >> 3] = d6;
       break L78;
      } else break L78;
      break;
     }
    case 111:
     {
      i7 = 8;
      i33 = 144;
      break;
     }
    case 117:
    case 100:
     {
      i7 = 10;
      i33 = 144;
      break;
     }
    case 105:
     {
      i7 = 0;
      i33 = 144;
      break;
     }
    case 120:
    case 88:
    case 112:
     {
      i7 = 16;
      i33 = 144;
      break;
     }
    default:
     {}
    } while (0);
    L197 : do if ((i33 | 0) == 144) {
     i33 = 0;
     i7 = ___intscan(i29, i7, 0, -1, -1) | 0;
     if ((HEAP32[i22 >> 2] | 0) == ((HEAP32[i23 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0)) break L4;
     if ((i11 | 0) == 112 & (i16 | 0) != 0) {
      HEAP32[i16 >> 2] = i7;
      break;
     }
     if (i16) switch (i12 | 0) {
     case -2:
      {
       HEAP8[i16 >> 0] = i7;
       break L197;
      }
     case -1:
      {
       HEAP16[i16 >> 1] = i7;
       break L197;
      }
     case 0:
      {
       HEAP32[i16 >> 2] = i7;
       break L197;
      }
     case 1:
      {
       HEAP32[i16 >> 2] = i7;
       break L197;
      }
     case 3:
      {
       i14 = i16;
       HEAP32[i14 >> 2] = i7;
       HEAP32[i14 + 4 >> 2] = tempRet0;
       break L197;
      }
     default:
      break L197;
     }
    } while (0);
    i1 = ((i16 | 0) != 0 & 1) + i1 | 0;
    i9 = (HEAP32[i22 >> 2] | 0) + i15 + (HEAP32[i20 >> 2] | 0) - (HEAP32[i23 >> 2] | 0) | 0;
    break L6;
   } while (0);
   i5 = i8 + (i5 & 1) | 0;
   ___shlim(i29, 0);
   i4 = HEAP32[i20 >> 2] | 0;
   if (i4 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
    HEAP32[i20 >> 2] = i4 + 1;
    i4 = HEAPU8[i4 >> 0] | 0;
   } else i4 = ___shgetc(i29) | 0;
   if ((i4 | 0) != (HEAPU8[i5 >> 0] | 0)) {
    i33 = 19;
    break L4;
   }
   i9 = i10 + 1 | 0;
  } else {
   i5 = i8;
   while (1) {
    i4 = i5 + 1 | 0;
    if (!(_isspace(HEAPU8[i4 >> 0] | 0) | 0)) break; else i5 = i4;
   }
   ___shlim(i29, 0);
   do {
    i4 = HEAP32[i20 >> 2] | 0;
    if (i4 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
     HEAP32[i20 >> 2] = i4 + 1;
     i4 = HEAPU8[i4 >> 0] | 0;
    } else i4 = ___shgetc(i29) | 0;
   } while ((_isspace(i4) | 0) != 0);
   i4 = HEAP32[i20 >> 2] | 0;
   if (HEAP32[i21 >> 2] | 0) {
    i4 = i4 + -1 | 0;
    HEAP32[i20 >> 2] = i4;
   }
   i9 = (HEAP32[i22 >> 2] | 0) + i10 + i4 - (HEAP32[i23 >> 2] | 0) | 0;
  } while (0);
  i8 = i5 + 1 | 0;
  i4 = HEAP8[i8 >> 0] | 0;
  if (!(i4 << 24 >> 24)) {
   i33 = 166;
   break;
  } else i10 = i9;
 }
 if ((i33 | 0) == 19) {
  if (HEAP32[i21 >> 2] | 0) HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + -1;
  if ((i4 | 0) > -1 | (i1 | 0) != 0) {
   i23 = i1;
   STACKTOP = i34;
   return i23 | 0;
  } else {
   i1 = 0;
   i33 = 163;
  }
 } else if ((i33 | 0) == 162) {
  if (!i1) {
   i1 = i4;
   i33 = 163;
  }
 } else if ((i33 | 0) == 166) {
  STACKTOP = i34;
  return i1 | 0;
 }
 if ((i33 | 0) == 163) {
  i4 = i1;
  i1 = -1;
 }
 if (!i4) {
  i23 = i1;
  STACKTOP = i34;
  return i23 | 0;
 }
 _free(i3);
 _free(i2);
 i23 = i1;
 STACKTOP = i34;
 return i23 | 0;
}

function __ZN2cv10BmpDecoder8readDataERNS_3MatE(i30, i5) {
 i30 = i30 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 2464 | 0;
 i32 = i44 + 2184 | 0;
 i31 = i44 + 2200 | 0;
 i41 = i44 + 2176 | 0;
 i43 = i44 + 1136 | 0;
 i42 = i44 + 96 | 0;
 i11 = i44 + 88 | 0;
 i22 = i44 + 80 | 0;
 i20 = i44 + 72 | 0;
 i21 = i44 + 2192 | 0;
 i19 = i44 + 68 | 0;
 i25 = i44 + 64 | 0;
 i23 = i44 + 60 | 0;
 i24 = i44 + 56 | 0;
 i14 = i44 + 48 | 0;
 i15 = i44 + 40 | 0;
 i16 = i44 + 32 | 0;
 i17 = i44 + 24 | 0;
 i12 = i44 + 16 | 0;
 i18 = i44 + 8 | 0;
 i13 = i44;
 i2 = HEAP32[i5 + 16 >> 2] | 0;
 i7 = HEAP32[i5 + 48 >> 2] | 0;
 i34 = (((HEAP32[i5 >> 2] | 0) >>> 3 & 511) + 1 | 0) >>> 0 > 1;
 i26 = i30 + 4 | 0;
 i29 = HEAP32[i26 >> 2] | 0;
 i9 = i30 + 1156 | 0;
 i27 = HEAP32[i9 >> 2] | 0;
 i27 = (((Math_imul((i27 | 0) == 15 ? 16 : i27, i29) | 0) + 7 | 0) / 8 | 0) + 3 & -4;
 i28 = i34 ? 3 : 1;
 i29 = Math_imul(i28, i29) | 0;
 i6 = i30 + 1160 | 0;
 if ((HEAP32[i6 >> 2] | 0) < 0) {
  i22 = 0;
  STACKTOP = i44;
  return i22 | 0;
 }
 i36 = i30 + 92 | 0;
 if (!(__ZN2cv11RBaseStream8isOpenedEv(i36) | 0)) {
  i22 = 0;
  STACKTOP = i44;
  return i22 | 0;
 }
 if ((HEAP32[i30 + 1152 >> 2] | 0) == 1) {
  i2 = i2 + (Math_imul((HEAP32[i30 + 8 >> 2] | 0) + -1 | 0, i7) | 0) | 0;
  i35 = 0 - i7 | 0;
 } else i35 = i7;
 i39 = i43 + 8 | 0;
 HEAP32[i43 >> 2] = i39;
 i40 = i43 + 4 | 0;
 HEAP32[i40 >> 2] = 1032;
 i37 = i42 + 8 | 0;
 HEAP32[i42 >> 2] = i37;
 i38 = i42 + 4 | 0;
 HEAP32[i38 >> 2] = 1032;
 i8 = i27 + 32 | 0;
 if (i8 >>> 0 > 1032) HEAP32[i43 >> 2] = __Znaj(i8) | 0;
 HEAP32[i40 >> 2] = i8;
 do if (!i34) {
  i8 = HEAP32[i9 >> 2] | 0;
  if ((i8 | 0) < 9) {
   __Z16CvtPaletteToGrayPK12PaletteEntryPhi(i30 + 128 | 0, i31, 1 << i8);
   i8 = HEAP32[i38 >> 2] | 0;
  } else i8 = 1032;
  i7 = ((HEAP32[i26 >> 2] | 0) * 3 | 0) + 32 | 0;
  if (i8 >>> 0 >= i7 >>> 0) {
   HEAP32[i38 >> 2] = i7;
   i10 = HEAP32[i42 >> 2] | 0;
   break;
  }
  i8 = HEAP32[i42 >> 2] | 0;
  if ((i8 | 0) != (i37 | 0)) {
   if (i8) __ZdaPv(i8);
   HEAP32[i42 >> 2] = i37;
   HEAP32[i38 >> 2] = 1032;
  }
  if (i7 >>> 0 > 1032) {
   i10 = __Znaj(i7) | 0;
   HEAP32[i42 >> 2] = i10;
   HEAP32[i38 >> 2] = i7;
  } else i10 = i37;
 } else i10 = i37; while (0);
 i33 = HEAP32[i43 >> 2] | 0;
 __ZN2cv11RBaseStream6setPosEi(i36, HEAP32[i6 >> 2] | 0);
 L29 : do switch (HEAP32[i9 >> 2] | 0) {
 case 1:
  {
   HEAP32[i41 >> 2] = 0;
   i3 = i30 + 8 | 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i5 = i30 + 128 | 0;
    i4 = i11 + 4 | 0;
    if (i34) while (1) {
     __ZN2cv12RLByteStream8getBytesEPvi(i36, i33, i27) | 0;
     __Z13FillColorRow1PhS_iP12PaletteEntry(i2, i33, HEAP32[i26 >> 2] | 0, i5) | 0;
     i22 = HEAP32[i3 >> 2] | 0;
     i21 = (HEAP32[i41 >> 2] | 0) + 1 | 0;
     HEAP32[i41 >> 2] = i21;
     if ((i21 | 0) < (i22 | 0)) i2 = i2 + i35 | 0; else {
      i2 = 1;
      break;
     }
    } else while (1) {
     __ZN2cv12RLByteStream8getBytesEPvi(i36, i33, i27) | 0;
     __Z13FillColorRow1PhS_iP12PaletteEntry(i10, i33, HEAP32[i26 >> 2] | 0, i5) | 0;
     HEAP32[i11 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i4 >> 2] = 1;
     HEAP32[i32 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
     HEAP32[i32 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     __Z24icvCvt_BGR2Gray_8u_C3C1RPKhiPhi6CvSizei(i10, 0, i2, 0, i32, 0);
     i22 = (HEAP32[i41 >> 2] | 0) + 1 | 0;
     HEAP32[i41 >> 2] = i22;
     if ((i22 | 0) < (HEAP32[i3 >> 2] | 0)) i2 = i2 + i35 | 0; else {
      i2 = 1;
      break;
     }
    }
   } else i2 = 1;
   break;
  }
 case 24:
  {
   HEAP32[i41 >> 2] = 0;
   i4 = i30 + 8 | 0;
   if ((HEAP32[i4 >> 2] | 0) > 0) {
    i1 = i12 + 4 | 0;
    while (1) {
     __ZN2cv12RLByteStream8getBytesEPvi(i36, i33, i27) | 0;
     i3 = HEAP32[i26 >> 2] | 0;
     if (i34) _memcpy(i2 | 0, i33 | 0, i3 * 3 | 0) | 0; else {
      HEAP32[i12 >> 2] = i3;
      HEAP32[i1 >> 2] = 1;
      HEAP32[i32 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
      HEAP32[i32 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      __Z24icvCvt_BGR2Gray_8u_C3C1RPKhiPhi6CvSizei(i33, 0, i2, 0, i32, 0);
     }
     i22 = (HEAP32[i41 >> 2] | 0) + 1 | 0;
     HEAP32[i41 >> 2] = i22;
     if ((i22 | 0) < (HEAP32[i4 >> 2] | 0)) i2 = i2 + i35 | 0; else {
      i2 = 1;
      break;
     }
    }
   } else i2 = 1;
   break;
  }
 case 8:
  {
   i5 = HEAP32[i30 + 1164 >> 2] | 0;
   if (!i5) {
    HEAP32[i41 >> 2] = 0;
    i4 = i30 + 8 | 0;
    if ((HEAP32[i4 >> 2] | 0) <= 0) {
     i2 = 1;
     break L29;
    }
    i3 = i30 + 128 | 0;
    while (1) {
     __ZN2cv12RLByteStream8getBytesEPvi(i36, i33, i27) | 0;
     i1 = HEAP32[i26 >> 2] | 0;
     if (i34) __Z13FillColorRow8PhS_iP12PaletteEntry(i2, i33, i1, i3) | 0; else __Z12FillGrayRow8PhS_iS_(i2, i33, i1, i31) | 0;
     i22 = (HEAP32[i41 >> 2] | 0) + 1 | 0;
     HEAP32[i41 >> 2] = i22;
     if ((i22 | 0) < (HEAP32[i4 >> 2] | 0)) i2 = i2 + i35 | 0; else {
      i2 = 1;
      break L29;
     }
    }
   } else if ((i5 | 0) != 1) {
    i2 = 0;
    break L29;
   }
   HEAP32[i25 >> 2] = i2 + i29;
   HEAP32[i41 >> 2] = 0;
   i10 = i30 + 128 | 0;
   i9 = i30 + 8 | 0;
   i11 = i30 + 128 | 0;
   i3 = 0;
   while (1) {
    i7 = __ZN2cv12RLByteStream7getWordEv(i36) | 0;
    i5 = i7 & 255;
    i7 = i7 >> 8;
    if (i5) {
     i3 = HEAP32[i41 >> 2] | 0;
     i5 = Math_imul(i5, i28) | 0;
     if ((i2 + i5 | 0) >>> 0 > (HEAP32[i25 >> 2] | 0) >>> 0) {
      i2 = 0;
      break L29;
     }
     i4 = HEAP32[i9 >> 2] | 0;
     if (i34) {
      i22 = i30 + (i7 << 2) + 128 | 0;
      HEAP32[i23 >> 2] = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
      HEAP8[i32 + 0 >> 0] = HEAP8[i23 + 0 >> 0] | 0;
      HEAP8[i32 + 1 >> 0] = HEAP8[i23 + 1 >> 0] | 0;
      HEAP8[i32 + 2 >> 0] = HEAP8[i23 + 2 >> 0] | 0;
      HEAP8[i32 + 3 >> 0] = HEAP8[i23 + 3 >> 0] | 0;
      i2 = __Z12FillUniColorPhRS_iiRiii12PaletteEntry(i2, i25, i35, i29, i41, i4, i5, i32) | 0;
     } else i2 = __Z11FillUniGrayPhRS_iiRiiih(i2, i25, i35, i29, i41, i4, i5, HEAP8[i31 + i7 >> 0] | 0) | 0;
     i3 = (HEAP32[i41 >> 2] | 0) - i3 | 0;
     continue;
    }
    if ((i7 | 0) > 2) {
     i5 = HEAP32[i41 >> 2] | 0;
     i22 = i2 + (Math_imul(i7, i28) | 0) | 0;
     if (i22 >>> 0 > (HEAP32[i25 >> 2] | 0) >>> 0) {
      i2 = 0;
      break L29;
     }
     __ZN2cv12RLByteStream8getBytesEPvi(i36, i33, i7 + 1 & -2) | 0;
     if (i34) i2 = __Z13FillColorRow8PhS_iP12PaletteEntry(i2, i33, i7, i10) | 0; else i2 = __Z12FillGrayRow8PhS_iS_(i2, i33, i7, i31) | 0;
     i3 = (HEAP32[i41 >> 2] | 0) - i5 | 0;
     continue;
    }
    i1 = (HEAP32[i25 >> 2] | 0) - i2 | 0;
    i8 = (i7 | 0) == 0;
    i5 = HEAP32[i41 >> 2] | 0;
    i4 = HEAP32[i9 >> 2] | 0;
    if ((i1 | 0) < (i29 | 0) | i8 & (i3 | 0) != 0 ^ 1) {
     if ((i7 | 0) == 2) {
      i3 = __ZN2cv12RLByteStream7getByteEv(i36) | 0;
      i5 = __ZN2cv12RLByteStream7getByteEv(i36) | 0;
      i3 = Math_imul(i3, i28) | 0;
      i6 = HEAP32[i41 >> 2] | 0;
      i7 = HEAP32[i9 >> 2] | 0;
     } else {
      i6 = i5;
      i7 = i4;
      i3 = i1;
      i5 = i4 - i5 | 0;
     }
     i5 = Math_imul(i5, i29) | 0;
     i5 = (i8 ? 0 : i5) + i3 | 0;
     if ((i6 | 0) >= (i7 | 0)) {
      i2 = 1;
      break L29;
     }
     if (i34) {
      HEAP32[i24 >> 2] = HEAPU8[i11 >> 0] | HEAPU8[i11 + 1 >> 0] << 8 | HEAPU8[i11 + 2 >> 0] << 16 | HEAPU8[i11 + 3 >> 0] << 24;
      HEAP8[i32 + 0 >> 0] = HEAP8[i24 + 0 >> 0] | 0;
      HEAP8[i32 + 1 >> 0] = HEAP8[i24 + 1 >> 0] | 0;
      HEAP8[i32 + 2 >> 0] = HEAP8[i24 + 2 >> 0] | 0;
      HEAP8[i32 + 3 >> 0] = HEAP8[i24 + 3 >> 0] | 0;
      i2 = __Z12FillUniColorPhRS_iiRiii12PaletteEntry(i2, i25, i35, i29, i41, i7, i5, i32) | 0;
     } else i2 = __Z11FillUniGrayPhRS_iiRiiih(i2, i25, i35, i29, i41, i7, i5, HEAP8[i31 >> 0] | 0) | 0;
     i5 = HEAP32[i41 >> 2] | 0;
     i4 = HEAP32[i9 >> 2] | 0;
     if ((i5 | 0) >= (i4 | 0)) {
      i2 = 1;
      break L29;
     }
    }
    if ((i5 | 0) < (i4 | 0)) i3 = 0; else {
     i2 = 1;
     break;
    }
   }
   break;
  }
 case 15:
  {
   HEAP32[i41 >> 2] = 0;
   i3 = i30 + 8 | 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i1 = i15 + 4 | 0;
    i5 = i14 + 4 | 0;
    while (1) {
     __ZN2cv12RLByteStream8getBytesEPvi(i36, i33, i27) | 0;
     i4 = HEAP32[i26 >> 2] | 0;
     if (i34) {
      HEAP32[i15 >> 2] = i4;
      HEAP32[i1 >> 2] = 1;
      HEAP32[i32 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
      HEAP32[i32 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
      __Z26icvCvt_BGR5552BGR_8u_C2C3RPKhiPhi6CvSize(i33, 0, i2, 0, i32);
     } else {
      HEAP32[i14 >> 2] = i4;
      HEAP32[i5 >> 2] = 1;
      HEAP32[i32 + 0 >> 2] = HEAP32[i14 + 0 >> 2];
      HEAP32[i32 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      __Z27icvCvt_BGR5552Gray_8u_C2C1RPKhiPhi6CvSize(i33, 0, i2, 0, i32);
     }
     i22 = (HEAP32[i41 >> 2] | 0) + 1 | 0;
     HEAP32[i41 >> 2] = i22;
     if ((i22 | 0) < (HEAP32[i3 >> 2] | 0)) i2 = i2 + i35 | 0; else {
      i2 = 1;
      break;
     }
    }
   } else i2 = 1;
   break;
  }
 case 4:
  {
   i5 = HEAP32[i30 + 1164 >> 2] | 0;
   if (!i5) {
    HEAP32[i41 >> 2] = 0;
    i4 = i30 + 8 | 0;
    if ((HEAP32[i4 >> 2] | 0) <= 0) {
     i2 = 1;
     break L29;
    }
    i1 = i30 + 128 | 0;
    if (i34) while (1) {
     __ZN2cv12RLByteStream8getBytesEPvi(i36, i33, i27) | 0;
     __Z13FillColorRow4PhS_iP12PaletteEntry(i2, i33, HEAP32[i26 >> 2] | 0, i1) | 0;
     i22 = HEAP32[i4 >> 2] | 0;
     i21 = (HEAP32[i41 >> 2] | 0) + 1 | 0;
     HEAP32[i41 >> 2] = i21;
     if ((i21 | 0) < (i22 | 0)) i2 = i2 + i35 | 0; else {
      i2 = 1;
      break L29;
     }
    } else while (1) {
     __ZN2cv12RLByteStream8getBytesEPvi(i36, i33, i27) | 0;
     __Z12FillGrayRow4PhS_iS_(i2, i33, HEAP32[i26 >> 2] | 0, i31) | 0;
     i22 = HEAP32[i4 >> 2] | 0;
     i21 = (HEAP32[i41 >> 2] | 0) + 1 | 0;
     HEAP32[i41 >> 2] = i21;
     if ((i21 | 0) < (i22 | 0)) i2 = i2 + i35 | 0; else {
      i2 = 1;
      break L29;
     }
    }
   } else if ((i5 | 0) != 2) {
    i2 = 0;
    break L29;
   }
   HEAP32[i22 >> 2] = i2 + i29;
   HEAP32[i41 >> 2] = 0;
   i8 = i30 + 128 | 0;
   i6 = i30 + 8 | 0;
   i1 = i30 + 128 | 0;
   i9 = i20 + 4 | 0;
   i10 = i21 + 1 | 0;
   L103 : while (1) {
    i5 = __ZN2cv12RLByteStream7getWordEv(i36) | 0;
    i4 = i5 & 255;
    i3 = i5 >> 8;
    if (i4) {
     i18 = i5 >> 12;
     i7 = i30 + (i18 << 2) + 128 | 0;
     HEAP32[i20 >> 2] = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
     i7 = i3 & 15;
     i17 = i30 + (i7 << 2) + 128 | 0;
     HEAP32[i9 >> 2] = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
     HEAP8[i21 >> 0] = HEAP8[i31 + i18 >> 0] | 0;
     HEAP8[i10 >> 0] = HEAP8[i31 + i7 >> 0] | 0;
     i7 = i2 + (Math_imul(i4, i28) | 0) | 0;
     if (i7 >>> 0 > (HEAP32[i22 >> 2] | 0) >>> 0) {
      i2 = 0;
      break L29;
     }
     if (i34) {
      i5 = 0;
      while (1) {
       HEAP8[i2 >> 0] = HEAP8[i20 + (i5 << 2) >> 0] | 0;
       HEAP8[i2 + 1 >> 0] = HEAP8[i20 + (i5 << 2) + 1 >> 0] | 0;
       HEAP8[i2 + 2 >> 0] = HEAP8[i20 + (i5 << 2) + 2 >> 0] | 0;
       i2 = i2 + i28 | 0;
       if (i2 >>> 0 < i7 >>> 0) i5 = i5 ^ 1; else continue L103;
      }
     } else {
      i5 = 0;
      while (1) {
       HEAP8[i2 >> 0] = HEAP8[i21 + i5 >> 0] | 0;
       i2 = i2 + i28 | 0;
       if (i2 >>> 0 < i7 >>> 0) i5 = i5 ^ 1; else continue L103;
      }
     }
    }
    if ((i3 | 0) > 2) {
     i18 = i2 + (Math_imul(i3, i28) | 0) | 0;
     if (i18 >>> 0 > (HEAP32[i22 >> 2] | 0) >>> 0) {
      i2 = 0;
      break L29;
     }
     __ZN2cv12RLByteStream8getBytesEPvi(i36, i33, (i3 + 1 >> 1) + 1 & -2) | 0;
     if (i34) {
      i2 = __Z13FillColorRow4PhS_iP12PaletteEntry(i2, i33, i3, i8) | 0;
      continue;
     } else {
      i2 = __Z12FillGrayRow4PhS_iS_(i2, i33, i3, i31) | 0;
      continue;
     }
    }
    i5 = (HEAP32[i22 >> 2] | 0) - i2 | 0;
    if ((i3 | 0) == 2) {
     i5 = __ZN2cv12RLByteStream7getByteEv(i36) | 0;
     __ZN2cv12RLByteStream7getByteEv(i36) | 0;
     i5 = Math_imul(i5, i28) | 0;
    }
    i4 = HEAP32[i6 >> 2] | 0;
    if (i34) {
     HEAP32[i19 >> 2] = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
     HEAP8[i32 + 0 >> 0] = HEAP8[i19 + 0 >> 0] | 0;
     HEAP8[i32 + 1 >> 0] = HEAP8[i19 + 1 >> 0] | 0;
     HEAP8[i32 + 2 >> 0] = HEAP8[i19 + 2 >> 0] | 0;
     HEAP8[i32 + 3 >> 0] = HEAP8[i19 + 3 >> 0] | 0;
     i2 = __Z12FillUniColorPhRS_iiRiii12PaletteEntry(i2, i22, i35, i29, i41, i4, i5, i32) | 0;
    } else i2 = __Z11FillUniGrayPhRS_iiRiiih(i2, i22, i35, i29, i41, i4, i5, HEAP8[i31 >> 0] | 0) | 0;
    if ((HEAP32[i41 >> 2] | 0) >= (HEAP32[i6 >> 2] | 0)) {
     i2 = 1;
     break;
    }
   }
   break;
  }
 case 32:
  {
   HEAP32[i41 >> 2] = 0;
   i5 = i30 + 8 | 0;
   if ((HEAP32[i5 >> 2] | 0) > 0) {
    i3 = i13 + 4 | 0;
    i1 = i18 + 4 | 0;
    while (1) {
     __ZN2cv12RLByteStream8getBytesEPvi(i36, i33, i27) | 0;
     i4 = HEAP32[i26 >> 2] | 0;
     if (i34) {
      HEAP32[i13 >> 2] = i4;
      HEAP32[i3 >> 2] = 1;
      HEAP32[i32 + 0 >> 2] = HEAP32[i13 + 0 >> 2];
      HEAP32[i32 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      __Z24icvCvt_BGRA2BGR_8u_C4C3RPKhiPhi6CvSizei(i33, 0, i2, 0, i32, 0);
     } else {
      HEAP32[i18 >> 2] = i4;
      HEAP32[i1 >> 2] = 1;
      HEAP32[i32 + 0 >> 2] = HEAP32[i18 + 0 >> 2];
      HEAP32[i32 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
      __Z25icvCvt_BGRA2Gray_8u_C4C1RPKhiPhi6CvSizei(i33, 0, i2, 0, i32, 0);
     }
     i22 = (HEAP32[i41 >> 2] | 0) + 1 | 0;
     HEAP32[i41 >> 2] = i22;
     if ((i22 | 0) < (HEAP32[i5 >> 2] | 0)) i2 = i2 + i35 | 0; else {
      i2 = 1;
      break;
     }
    }
   } else i2 = 1;
   break;
  }
 case 16:
  {
   HEAP32[i41 >> 2] = 0;
   i5 = i30 + 8 | 0;
   if ((HEAP32[i5 >> 2] | 0) > 0) {
    i3 = i17 + 4 | 0;
    i1 = i16 + 4 | 0;
    while (1) {
     __ZN2cv12RLByteStream8getBytesEPvi(i36, i33, i27) | 0;
     i4 = HEAP32[i26 >> 2] | 0;
     if (i34) {
      HEAP32[i17 >> 2] = i4;
      HEAP32[i3 >> 2] = 1;
      HEAP32[i32 + 0 >> 2] = HEAP32[i17 + 0 >> 2];
      HEAP32[i32 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
      __Z26icvCvt_BGR5652BGR_8u_C2C3RPKhiPhi6CvSize(i33, 0, i2, 0, i32);
     } else {
      HEAP32[i16 >> 2] = i4;
      HEAP32[i1 >> 2] = 1;
      HEAP32[i32 + 0 >> 2] = HEAP32[i16 + 0 >> 2];
      HEAP32[i32 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
      __Z27icvCvt_BGR5652Gray_8u_C2C1RPKhiPhi6CvSize(i33, 0, i2, 0, i32);
     }
     i22 = (HEAP32[i41 >> 2] | 0) + 1 | 0;
     HEAP32[i41 >> 2] = i22;
     if ((i22 | 0) < (HEAP32[i5 >> 2] | 0)) i2 = i2 + i35 | 0; else {
      i2 = 1;
      break;
     }
    }
   } else i2 = 1;
   break;
  }
 default:
  i2 = 0;
 } while (0);
 i1 = HEAP32[i42 >> 2] | 0;
 if ((i1 | 0) != (i37 | 0)) {
  if (i1) __ZdaPv(i1);
  HEAP32[i42 >> 2] = i37;
  HEAP32[i38 >> 2] = 1032;
 }
 i1 = HEAP32[i43 >> 2] | 0;
 if ((i1 | 0) == (i39 | 0)) {
  i22 = i2;
  STACKTOP = i44;
  return i22 | 0;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i43 >> 2] = i39;
 HEAP32[i40 >> 2] = 1032;
 i22 = i2;
 STACKTOP = i44;
 return i22 | 0;
}

function __ZL16icvYMLParseValueP13CvFileStoragePcP10CvFileNodeii(i23, i1, i22, i6, i8) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, d25 = 0.0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 6192 | 0;
 i21 = i24 + 16 | 0;
 i5 = i24 + 5160 | 0;
 i17 = i24 + 40 | 0;
 i18 = i24 + 36 | 0;
 i16 = i24 + 8 | 0;
 i15 = i24 + 32 | 0;
 i10 = i24;
 i19 = i24 + 28 | 0;
 HEAP32[i18 >> 2] = 0;
 i3 = HEAP8[i1 >> 0] | 0;
 i4 = i1 + 1 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i7 = i6 & 8;
 i9 = (i7 | 0) != 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 do if (i3 << 24 >> 24 == 33) {
  if (i2 << 24 >> 24 == 94 | i2 << 24 >> 24 == 33) {
   i1 = i4;
   i3 = 16;
  } else i3 = 0;
  HEAP32[i18 >> 2] = i1;
  i4 = i1;
  while (1) {
   i11 = i4 + 1 | 0;
   HEAP32[i18 >> 2] = i11;
   i6 = HEAP8[i11 >> 0] | 0;
   if ((i6 & 255) < 33) break; else i4 = i11;
  }
  i14 = i1 + 1 | 0;
  i13 = i11 - i14 | 0;
  if ((i4 | 0) == (i1 | 0)) {
   i2 = HEAP32[i23 + 88 >> 2] | 0;
   HEAP32[i21 >> 2] = HEAP32[i23 + 60 >> 2];
   HEAP32[i21 + 4 >> 2] = i2;
   HEAP32[i21 + 8 >> 2] = 14856;
   _sprintf(i5, 17440, i21) | 0;
   _cvError(-212, 14832, i5, 8960, 1057);
   i2 = HEAP8[i11 >> 0] | 0;
  } else i2 = i6;
  HEAP8[i11 >> 0] = 0;
  i6 = (i3 | 0) == 0;
  L12 : do if ((i13 | 0) == 3 & i6) if (_memcmp(i14, 14872, 3) | 0) if (_memcmp(i14, 14880, 3) | 0) if (!(_memcmp(i14, 14888, 3) | 0)) i3 = 5; else {
   i3 = (_memcmp(i14, 14896, 3) | 0) == 0;
   i3 = i3 ? 6 : 0;
  } else i3 = 1; else i3 = 3; else {
   if ((i13 | 0) == 5 & i6) {
    i3 = (_memcmp(i14, 14904, 5) | 0) == 0;
    i3 = i3 ? 2 : 0;
    break;
   }
   if (i6) i3 = 0; else {
    i6 = HEAP32[2644] | 0;
    L18 : do if (i6) {
     while (1) {
      if (!(_strcmp(HEAP32[i6 + 16 >> 2] | 0, i14) | 0)) break;
      i6 = HEAP32[i6 + 12 >> 2] | 0;
      if (!i6) break L18;
     }
     HEAP32[i22 + 4 >> 2] = i6;
     break L12;
    } while (0);
    HEAP32[i22 + 4 >> 2] = 0;
    HEAP32[i22 >> 2] = HEAP32[i22 >> 2] & -17;
   }
  } while (0);
  HEAP8[HEAP32[i18 >> 2] >> 0] = i2;
  i1 = __ZL16icvYMLSkipSpacesP13CvFileStoragePcii(i23, HEAP32[i18 >> 2] | 0, i8) | 0;
  i6 = HEAP8[i1 >> 0] | 0;
  if (!(i3 & 16)) {
   if ((i3 | 0) == 2) {
    i20 = 33;
    break;
   } else if ((i3 | 0) == 1) {
    i20 = 34;
    break;
   } else if ((i3 | 0) != 3) {
    i20 = 24;
    break;
   }
   if (i6 << 24 >> 24 == 34 | i6 << 24 >> 24 == 39) {
    i3 = 3;
    i20 = 24;
   } else {
    i3 = 3;
    i20 = 91;
   }
  } else i20 = 24;
 } else {
  i6 = i3;
  i3 = 0;
  i20 = 24;
 } while (0);
 L31 : do if ((i20 | 0) == 24) {
  do if ((i6 + -48 << 24 >> 24 & 255) >= 10) {
   if (i6 << 24 >> 24 == 43 | i6 << 24 >> 24 == 45) {
    i4 = i2 + -48 << 24 >> 24;
    if ((i4 & 255) < 10 | i2 << 24 >> 24 == 46) break;
    if (i6 << 24 >> 24 == 46) {
     i12 = i4;
     i20 = 29;
    }
   } else if (i6 << 24 >> 24 == 46) {
    i12 = i2 + -48 << 24 >> 24;
    i20 = 29;
   }
   if ((i20 | 0) == 29 ? (i12 & 255) < 10 | (i2 + -97 << 24 >> 24 & 255) < 26 | (i2 + -65 << 24 >> 24 & 255) < 26 : 0) break;
   i4 = i6 << 24 >> 24 == 39;
   if (!(i6 << 24 >> 24 == 34 | i6 << 24 >> 24 == 39)) {
    i14 = i6 << 24 >> 24 == 91;
    if (!(i6 << 24 >> 24 == 91 | i6 << 24 >> 24 == 123)) {
     if (i6 << 24 >> 24 == 45 & (i9 ^ 1)) {
      i14 = 5;
      break L31;
     }
     if (i9) {
      i20 = 91;
      break L31;
     }
     if (i6 << 24 >> 24 == 62 | i6 << 24 >> 24 == 124) {
      i20 = HEAP32[i23 + 88 >> 2] | 0;
      HEAP32[i21 >> 2] = HEAP32[i23 + 60 >> 2];
      HEAP32[i21 + 4 >> 2] = i20;
      HEAP32[i21 + 8 >> 2] = 15128;
      _sprintf(i5, 17440, i21) | 0;
      _cvError(-212, 14832, i5, 8960, 1261);
      i20 = 91;
      break L31;
     } else if (i6 << 24 >> 24 == 63) {
      i20 = HEAP32[i23 + 88 >> 2] | 0;
      HEAP32[i21 >> 2] = HEAP32[i23 + 60 >> 2];
      HEAP32[i21 + 4 >> 2] = i20;
      HEAP32[i21 + 8 >> 2] = 15096;
      _sprintf(i5, 17440, i21) | 0;
      _cvError(-212, 14832, i5, 8960, 1259);
      i20 = 91;
      break L31;
     } else {
      i20 = 91;
      break L31;
     }
    }
    i10 = (i7 >>> 3 ^ 1) + i8 | 0;
    i6 = i6 << 24 >> 24 == 123 ? 14 : 13;
    i2 = i6 & 7;
    __ZL21icvFSCreateCollectionP13CvFileStorageiP10CvFileNode(i23, ((HEAP32[i22 + 4 >> 2] | 0) != 0 ? 16 : 0) | i2, i22);
    i11 = i22 + 8 | 0;
    i2 = (i2 | 0) == 6;
    i7 = i23 + 60 | 0;
    i8 = i23 + 88 | 0;
    i4 = i1 + 1 | 0;
    i9 = 1;
    while (1) {
     HEAP32[i15 >> 2] = 0;
     i1 = __ZL16icvYMLSkipSpacesP13CvFileStoragePcii(i23, i4, i10) | 0;
     i4 = HEAP8[i1 >> 0] | 0;
     if (i4 << 24 >> 24 == 93 | i4 << 24 >> 24 == 125) {
      i20 = 73;
      break;
     }
     if (HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] | 0) {
      if (i4 << 24 >> 24 != 44) {
       i19 = HEAP32[i8 >> 2] | 0;
       HEAP32[i21 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i21 + 4 >> 2] = i19;
       HEAP32[i21 + 8 >> 2] = 15064;
       _sprintf(i5, 17440, i21) | 0;
       _cvError(-212, 14832, i5, 8960, 1227);
      }
      i1 = __ZL16icvYMLSkipSpacesP13CvFileStoragePcii(i23, i1 + 1 | 0, i10) | 0;
     }
     if (i2) {
      i4 = __ZL16icvYMLSkipSpacesP13CvFileStoragePcii(i23, __ZL14icvYMLParseKeyP13CvFileStoragePcP10CvFileNodePS3_(i23, i1, i22, i15) | 0, i10) | 0;
      i19 = HEAP32[i15 >> 2] | 0;
      i4 = __ZL16icvYMLParseValueP13CvFileStoragePcP10CvFileNodeii(i23, i4, i19, i6, i10) | 0;
      i3 = HEAP32[i19 >> 2] | 64;
      HEAP32[i19 >> 2] = i3;
     } else {
      if ((HEAP8[i1 >> 0] | 0) == 93) break;
      i3 = _cvSeqPush(HEAP32[i11 >> 2] | 0, 0) | 0;
      HEAP32[i15 >> 2] = i3;
      i4 = __ZL16icvYMLParseValueP13CvFileStoragePcP10CvFileNodeii(i23, i1, i3, i6, i10) | 0;
      i3 = HEAP32[i3 >> 2] | 0;
     }
     i9 = (i3 & 7) >>> 0 < 5 & i9;
    }
    if ((i20 | 0) == 73) {
     if ((i4 << 24 >> 24 | 0) != ((i14 ? 93 : 125) | 0)) {
      i22 = HEAP32[i8 >> 2] | 0;
      HEAP32[i21 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i21 + 4 >> 2] = i22;
      HEAP32[i21 + 8 >> 2] = 15032;
      _sprintf(i5, 17440, i21) | 0;
      _cvError(-212, 14832, i5, 8960, 1219);
     }
     i1 = i1 + 1 | 0;
    }
    i22 = HEAP32[i11 >> 2] | 0;
    HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | ((i9 | 0) != 0 ? 256 : 0);
    i22 = i1;
    STACKTOP = i24;
    return i22 | 0;
   }
   HEAP32[i22 >> 2] = 3;
   i14 = i23 + 60 | 0;
   i13 = i23 + 88 | 0;
   L74 : do if (i4) {
    i2 = 0;
    while (1) {
     i3 = i1;
     while (1) {
      i1 = i3 + 1 | 0;
      i4 = HEAP8[i1 >> 0] | 0;
      if ((i4 + -48 << 24 >> 24 & 255) < 10 | (i4 + -97 << 24 >> 24 & 255) < 26 | (i4 + -65 << 24 >> 24 & 255) < 26) {
       i20 = 42;
       break;
      }
      if (i4 << 24 >> 24 != 39 & (i4 & 255) > 31) {
       i20 = 42;
       break;
      }
      if (i4 << 24 >> 24 == 39) {
       i20 = 45;
       break;
      }
      i3 = HEAP32[i13 >> 2] | 0;
      HEAP32[i21 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i21 + 4 >> 2] = i3;
      HEAP32[i21 + 8 >> 2] = 14984;
      _sprintf(i5, 17440, i21) | 0;
      _cvError(-212, 14832, i5, 8960, 1149);
      i3 = i1;
     }
     if ((i20 | 0) == 42) HEAP8[i17 + i2 >> 0] = i4; else if ((i20 | 0) == 45) {
      i1 = i3 + 2 | 0;
      if ((HEAP8[i1 >> 0] | 0) != 39) {
       i20 = 66;
       break L74;
      }
      HEAP8[i17 + i2 >> 0] = 39;
     }
     i2 = i2 + 1 | 0;
     if ((i2 | 0) >= 4096) {
      i3 = i14;
      i4 = i13;
      i20 = 68;
      break;
     }
    }
   } else {
    i2 = 0;
    L87 : while (1) {
     i4 = i1 + 1 | 0;
     i3 = HEAP8[i4 >> 0] | 0;
     L89 : do if ((i3 + -48 << 24 >> 24 & 255) < 10 | (i3 + -97 << 24 >> 24 & 255) < 26 | (i3 + -65 << 24 >> 24 & 255) < 26) i20 = 51; else {
      if (i3 << 24 >> 24 == 34) break L87; else if (i3 << 24 >> 24 != 92) {
       if ((i3 & 255) > 31) {
        i20 = 51;
        break;
       }
       i1 = HEAP32[i13 >> 2] | 0;
       HEAP32[i21 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i21 + 4 >> 2] = i1;
       HEAP32[i21 + 8 >> 2] = 14984;
       _sprintf(i5, 17440, i21) | 0;
       _cvError(-212, 14832, i5, 8960, 1192);
       i1 = i4;
       break;
      }
      i6 = i1 + 2 | 0;
      i3 = HEAP8[i6 >> 0] | 0;
      switch (i3 << 24 >> 24) {
      case 92:
      case 34:
       {
        HEAP8[i17 + i2 >> 0] = i3;
        i1 = i6;
        i2 = i2 + 1 | 0;
        break L89;
       }
      case 114:
       {
        HEAP8[i17 + i2 >> 0] = 13;
        i1 = i6;
        i2 = i2 + 1 | 0;
        break L89;
       }
      case 116:
       {
        HEAP8[i17 + i2 >> 0] = 9;
        i1 = i6;
        i2 = i2 + 1 | 0;
        break L89;
       }
      case 110:
       {
        HEAP8[i17 + i2 >> 0] = 10;
        i1 = i6;
        i2 = i2 + 1 | 0;
        break L89;
       }
      case 39:
       {
        HEAP8[i17 + i2 >> 0] = 39;
        i1 = i6;
        i2 = i2 + 1 | 0;
        break L89;
       }
      default:
       {
        i4 = i3 << 24 >> 24 == 120;
        if (!i4 ? !((i3 + -48 << 24 >> 24 & 255) < 10 & i3 << 24 >> 24 < 56) : 0) {
         i1 = i6;
         break L89;
        }
        i15 = i1 + 5 | 0;
        i12 = HEAP8[i15 >> 0] | 0;
        HEAP8[i15 >> 0] = 0;
        i19 = i1 + (i4 & 1 | 2) | 0;
        i4 = _strtol(i19, i18, i4 ? 8 : 16) | 0;
        HEAP8[i15 >> 0] = i12;
        i1 = HEAP32[i18 >> 2] | 0;
        if ((i1 | 0) == (i19 | 0)) {
         HEAP8[i17 + i2 >> 0] = 120;
         i1 = i6;
         i2 = i2 + 1 | 0;
         break L89;
        } else {
         HEAP8[i17 + i2 >> 0] = i4;
         i2 = i2 + 1 | 0;
         break L89;
        }
       }
      }
     } while (0);
     if ((i20 | 0) == 51) {
      i20 = 0;
      HEAP8[i17 + i2 >> 0] = i3;
      i1 = i4;
      i2 = i2 + 1 | 0;
     }
     if ((i2 | 0) >= 4096) {
      i3 = i14;
      i4 = i13;
      i20 = 68;
      break L74;
     }
    }
    i1 = i1 + 2 | 0;
    i20 = 66;
   } while (0);
   if ((i20 | 0) == 66) if ((i2 | 0) > 4095) {
    i3 = i23 + 60 | 0;
    i4 = i23 + 88 | 0;
    i20 = 68;
   }
   if ((i20 | 0) == 68) {
    i20 = HEAP32[i4 >> 2] | 0;
    HEAP32[i21 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i21 + 4 >> 2] = i20;
    HEAP32[i21 + 8 >> 2] = 15008;
    _sprintf(i5, 17440, i21) | 0;
    _cvError(-212, 14832, i5, 8960, 1196);
   }
   _cvMemStorageAllocString(i16, HEAP32[i23 + 16 >> 2] | 0, i17, i2);
   i22 = i22 + 8 | 0;
   HEAPF64[tempDoublePtr >> 3] = +HEAPF64[i16 >> 3];
   HEAP32[i22 >> 2] = HEAP32[tempDoublePtr >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
   i22 = i1;
   STACKTOP = i24;
   return i22 | 0;
  } while (0);
  i2 = i1 + ((i6 << 24 >> 24 == 45 | i6 << 24 >> 24 == 43) & 1) | 0;
  while (1) {
   HEAP32[i18 >> 2] = i2;
   i3 = HEAP8[i2 >> 0] | 0;
   if ((i3 + -48 << 24 >> 24 & 255) < 10) i2 = i2 + 1 | 0; else break;
  }
  if (i3 << 24 >> 24 == 101 | i3 << 24 >> 24 == 46) i20 = 33; else i20 = 34;
 } while (0);
 if ((i20 | 0) == 33) {
  d25 = +__ZL10icv_strtodP13CvFileStoragePcPS1_(i23, i1, i18);
  HEAP32[i22 >> 2] = 2;
  HEAPF64[i22 + 8 >> 3] = d25;
  i2 = i1;
  i20 = 35;
 } else if ((i20 | 0) == 34) {
  i2 = _strtol(i1, i18, 0) | 0;
  HEAP32[i22 >> 2] = 1;
  HEAP32[i22 + 8 >> 2] = i2;
  i2 = i1;
  i20 = 35;
 } else if ((i20 | 0) == 91) {
  HEAP32[i18 >> 2] = i1;
  i2 = HEAP8[i1 >> 0] | 0;
  if ((i2 & 255) > 31) {
   i3 = (i3 | 0) == 3;
   L129 : do if (i9) if (i3) {
    i3 = i1;
    do {
     if (i2 << 24 >> 24 == 93 | i2 << 24 >> 24 == 125 | i2 << 24 >> 24 == 44) break L129;
     i3 = i3 + 1 | 0;
     HEAP32[i18 >> 2] = i3;
     i2 = HEAP8[i3 >> 0] | 0;
    } while ((i2 & 255) > 31);
   } else {
    i3 = i1;
    do {
     if (i2 << 24 >> 24 == 93 | i2 << 24 >> 24 == 125 | i2 << 24 >> 24 == 44) break L129;
     i3 = i3 + 1 | 0;
     HEAP32[i18 >> 2] = i3;
     i2 = HEAP8[i3 >> 0] | 0;
    } while ((i2 & 255) > 31);
   } else {
    if (i3) {
     i3 = i1;
     while (1) {
      i3 = i3 + 1 | 0;
      HEAP32[i18 >> 2] = i3;
      i2 = HEAP8[i3 >> 0] | 0;
      if ((i2 & 255) <= 31) break L129;
     }
    } else i3 = i1;
    do {
     if (i2 << 24 >> 24 == 58) {
      i2 = 58;
      break L129;
     }
     i3 = i3 + 1 | 0;
     HEAP32[i18 >> 2] = i3;
     i2 = HEAP8[i3 >> 0] | 0;
    } while ((i2 & 255) > 31);
   } while (0);
   if ((i3 | 0) == (i1 | 0)) i20 = 103; else i4 = i3;
  } else {
   i3 = i1;
   i20 = 103;
  }
  if ((i20 | 0) == 103) {
   i4 = HEAP32[i23 + 88 >> 2] | 0;
   HEAP32[i21 >> 2] = HEAP32[i23 + 60 >> 2];
   HEAP32[i21 + 4 >> 2] = i4;
   HEAP32[i21 + 8 >> 2] = 14984;
   _sprintf(i5, 17440, i21) | 0;
   _cvError(-212, 14832, i5, 8960, 1273);
   i4 = i3;
  }
  if (i2 << 24 >> 24 == 58 & (i9 ^ 1)) i14 = 6; else {
   HEAP32[i22 >> 2] = 3;
   i3 = i4;
   while (1) {
    i2 = i3 + -1 | 0;
    if (i2 >>> 0 <= i1 >>> 0) break;
    if ((HEAP8[i2 >> 0] | 0) == 32) i3 = i2; else break;
   }
   _cvMemStorageAllocString(i10, HEAP32[i23 + 16 >> 2] | 0, i1, i3 - i1 | 0);
   i22 = i22 + 8 | 0;
   HEAPF64[tempDoublePtr >> 3] = +HEAPF64[i10 >> 3];
   HEAP32[i22 >> 2] = HEAP32[tempDoublePtr >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
   i22 = i4;
   STACKTOP = i24;
   return i22 | 0;
  }
 }
 if ((i20 | 0) == 35) {
  i1 = HEAP32[i18 >> 2] | 0;
  if (!((i1 | 0) == 0 | (i1 | 0) == (i2 | 0))) {
   i22 = i1;
   STACKTOP = i24;
   return i22 | 0;
  }
  i22 = HEAP32[i23 + 88 >> 2] | 0;
  HEAP32[i21 >> 2] = HEAP32[i23 + 60 >> 2];
  HEAP32[i21 + 4 >> 2] = i22;
  HEAP32[i21 + 8 >> 2] = 14912;
  _sprintf(i5, 17440, i21) | 0;
  _cvError(-212, 14832, i5, 8960, 1128);
  i22 = i1;
  STACKTOP = i24;
  return i22 | 0;
 }
 __ZL21icvFSCreateCollectionP13CvFileStorageiP10CvFileNode(i23, ((HEAP32[i22 + 4 >> 2] | 0) != 0 ? 16 : 0) | i14, i22);
 i11 = i23 + 76 | 0;
 i2 = i1 - (HEAP32[i11 >> 2] | 0) | 0;
 i7 = (i14 | 0) == 6;
 i8 = i2 + 1 | 0;
 i12 = i23 + 60 | 0;
 i13 = i23 + 88 | 0;
 i10 = i22 + 8 | 0;
 i9 = 1;
 do {
  HEAP32[i19 >> 2] = 0;
  if (i7) {
   i4 = __ZL14icvYMLParseKeyP13CvFileStoragePcP10CvFileNodePS3_(i23, i1, i22, i19) | 0;
   i6 = HEAP32[i19 >> 2] | 0;
  } else {
   if ((HEAP8[i1 >> 0] | 0) != 45) {
    i20 = HEAP32[i13 >> 2] | 0;
    HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i21 + 4 >> 2] = i20;
    HEAP32[i21 + 8 >> 2] = 15176;
    _sprintf(i5, 17440, i21) | 0;
    _cvError(-212, 14832, i5, 8960, 1310);
   }
   i6 = _cvSeqPush(HEAP32[i10 >> 2] | 0, 0) | 0;
   HEAP32[i19 >> 2] = i6;
   i4 = i1 + 1 | 0;
  }
  i3 = __ZL16icvYMLParseValueP13CvFileStoragePcP10CvFileNodeii(i23, __ZL16icvYMLSkipSpacesP13CvFileStoragePcii(i23, i4, i8) | 0, i6, i14, i8) | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  if (i7) {
   i4 = i4 | 64;
   HEAP32[i6 >> 2] = i4;
  }
  i9 = (i4 & 7) >>> 0 < 5 & i9;
  i1 = __ZL16icvYMLSkipSpacesP13CvFileStoragePcii(i23, i3, 0) | 0;
  i4 = i1 - (HEAP32[i11 >> 2] | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   if ((i4 | 0) < (i2 | 0)) break;
   i20 = HEAP32[i13 >> 2] | 0;
   HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i21 + 4 >> 2] = i20;
   HEAP32[i21 + 8 >> 2] = 15232;
   _sprintf(i5, 17440, i21) | 0;
   _cvError(-212, 14832, i5, 8960, 1327);
  }
 } while ((_memcmp(i1, 14760, 3) | 0) != 0);
 i22 = HEAP32[i10 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | ((i9 | 0) != 0 ? 256 : 0);
 i22 = i1;
 STACKTOP = i24;
 return i22 | 0;
}

function __ZNSt3__17__sort3IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_T_(i17, i18, i19, i16) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i20 = i21;
 i10 = FUNCTION_TABLE_iii[HEAP32[i16 >> 2] & 127](i18, i17) | 0;
 i3 = FUNCTION_TABLE_iii[HEAP32[i16 >> 2] & 127](i19, i18) | 0;
 if (!i10) {
  if (!i3) {
   i10 = 0;
   STACKTOP = i21;
   return i10 | 0;
  }
  i4 = HEAP32[i18 >> 2] | 0;
  HEAP32[i20 >> 2] = i4;
  i9 = i20 + 4 | 0;
  i12 = i18 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
  if (i4) {
   i10 = i4 + -4 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  i10 = i20 + 8 | 0;
  i11 = i18 + 8 | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = i4;
  i8 = i20 + 12 | 0;
  i14 = i18 + 12 | 0;
  HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
  if (i4) {
   i7 = i4 + -4 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  }
  i13 = i18 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i20 + 16 | 0, i13);
  i5 = i20 + 28 | 0;
  i15 = i18 + 28 | 0;
  HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
  if ((i19 | 0) != (i18 | 0)) {
   __ZN2cv6String10deallocateEv(i18);
   i4 = HEAP32[i19 >> 2] | 0;
   if (!i4) i4 = 0; else {
    i4 = i4 + -4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    i4 = HEAP32[i19 >> 2] | 0;
   }
   HEAP32[i18 >> 2] = i4;
   HEAP32[i12 >> 2] = HEAP32[i19 + 4 >> 2];
   i6 = i18 + 8 | 0;
   __ZN2cv6String10deallocateEv(i6);
   i4 = i19 + 8 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i3) i4 = 0; else {
    i7 = i3 + -4 | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    i4 = HEAP32[i4 >> 2] | 0;
   }
   HEAP32[i6 >> 2] = i4;
   HEAP32[i14 >> 2] = HEAP32[i19 + 12 >> 2];
   __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i13, HEAP32[i19 + 16 >> 2] | 0, HEAP32[i19 + 20 >> 2] | 0);
  }
  i7 = i19 + 28 | 0;
  HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
  if ((i20 | 0) == (i19 | 0)) i1 = i20 + 16 | 0; else {
   __ZN2cv6String10deallocateEv(i19);
   i4 = HEAP32[i20 >> 2] | 0;
   if (!i4) i4 = 0; else {
    i4 = i4 + -4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    i4 = HEAP32[i20 >> 2] | 0;
   }
   HEAP32[i19 >> 2] = i4;
   HEAP32[i19 + 4 >> 2] = HEAP32[i9 >> 2];
   i6 = i19 + 8 | 0;
   __ZN2cv6String10deallocateEv(i6);
   i4 = i20 + 8 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i3) i4 = 0; else {
    i9 = i3 + -4 | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
    i4 = HEAP32[i4 >> 2] | 0;
   }
   HEAP32[i6 >> 2] = i4;
   HEAP32[i19 + 12 >> 2] = HEAP32[i8 >> 2];
   i1 = i20 + 16 | 0;
   __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i19 + 16 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i20 + 20 >> 2] | 0);
  }
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  i4 = HEAP32[i1 >> 2] | 0;
  if (i4) {
   i3 = i20 + 20 | 0;
   while (1) {
    i2 = HEAP32[i3 >> 2] | 0;
    if ((i2 | 0) == (i4 | 0)) break;
    i9 = i2 + -8 | 0;
    HEAP32[i3 >> 2] = i9;
    __ZN2cv6String10deallocateEv(i9);
   }
   __ZdlPv(HEAP32[i1 >> 2] | 0);
  }
  __ZN2cv6String10deallocateEv(i10);
  __ZN2cv6String10deallocateEv(i20);
  if (!(FUNCTION_TABLE_iii[HEAP32[i16 >> 2] & 127](i18, i17) | 0)) {
   i10 = 1;
   STACKTOP = i21;
   return i10 | 0;
  }
  i4 = HEAP32[i17 >> 2] | 0;
  HEAP32[i20 >> 2] = i4;
  i9 = i20 + 4 | 0;
  i6 = i17 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  if (i4) {
   i10 = i4 + -4 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  i10 = i20 + 8 | 0;
  i4 = HEAP32[i17 + 8 >> 2] | 0;
  HEAP32[i10 >> 2] = i4;
  i8 = i20 + 12 | 0;
  i7 = i17 + 12 | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  if (i4) {
   i5 = i4 + -4 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  }
  i5 = i17 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i20 + 16 | 0, i5);
  i1 = i20 + 28 | 0;
  i2 = i17 + 28 | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  if ((i18 | 0) != (i17 | 0)) {
   __ZN2cv6String10deallocateEv(i17);
   i4 = HEAP32[i18 >> 2] | 0;
   if (!i4) i4 = 0; else {
    i4 = i4 + -4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    i4 = HEAP32[i18 >> 2] | 0;
   }
   HEAP32[i17 >> 2] = i4;
   HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
   i3 = i17 + 8 | 0;
   __ZN2cv6String10deallocateEv(i3);
   i4 = HEAP32[i11 >> 2] | 0;
   if (!i4) i4 = 0; else {
    i4 = i4 + -4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    i4 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i3 >> 2] = i4;
   HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
   __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i5, HEAP32[i18 + 16 >> 2] | 0, HEAP32[i18 + 20 >> 2] | 0);
  }
  HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
  if ((i20 | 0) == (i18 | 0)) i4 = i20 + 16 | 0; else {
   __ZN2cv6String10deallocateEv(i18);
   i4 = HEAP32[i20 >> 2] | 0;
   if (!i4) i4 = 0; else {
    i4 = i4 + -4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    i4 = HEAP32[i20 >> 2] | 0;
   }
   HEAP32[i18 >> 2] = i4;
   HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
   i2 = i18 + 8 | 0;
   __ZN2cv6String10deallocateEv(i2);
   i4 = i20 + 8 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i3) i4 = 0; else {
    i9 = i3 + -4 | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
    i4 = HEAP32[i4 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = i4;
   HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
   i4 = i20 + 16 | 0;
   __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i13, HEAP32[i4 >> 2] | 0, HEAP32[i20 + 20 >> 2] | 0);
  }
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1) {
   i2 = i20 + 20 | 0;
   while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) == (i1 | 0)) break;
    i9 = i3 + -8 | 0;
    HEAP32[i2 >> 2] = i9;
    __ZN2cv6String10deallocateEv(i9);
   }
   __ZdlPv(HEAP32[i4 >> 2] | 0);
  }
  __ZN2cv6String10deallocateEv(i10);
  __ZN2cv6String10deallocateEv(i20);
  i10 = 2;
  STACKTOP = i21;
  return i10 | 0;
 }
 if (i3) {
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP32[i20 >> 2] = i3;
  i7 = i20 + 4 | 0;
  i2 = i17 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  if (i3) {
   i10 = i3 + -4 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  i10 = i20 + 8 | 0;
  i4 = HEAP32[i17 + 8 >> 2] | 0;
  HEAP32[i10 >> 2] = i4;
  i8 = i20 + 12 | 0;
  i5 = i17 + 12 | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  if (i4) {
   i9 = i4 + -4 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  }
  i1 = i17 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i20 + 16 | 0, i1);
  i9 = i20 + 28 | 0;
  i6 = i17 + 28 | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  if ((i19 | 0) != (i17 | 0)) {
   __ZN2cv6String10deallocateEv(i17);
   i4 = HEAP32[i19 >> 2] | 0;
   if (!i4) i4 = 0; else {
    i4 = i4 + -4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    i4 = HEAP32[i19 >> 2] | 0;
   }
   HEAP32[i17 >> 2] = i4;
   HEAP32[i2 >> 2] = HEAP32[i19 + 4 >> 2];
   i2 = i17 + 8 | 0;
   __ZN2cv6String10deallocateEv(i2);
   i4 = i19 + 8 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i3) i4 = 0; else {
    i3 = i3 + -4 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
    i4 = HEAP32[i4 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = i4;
   HEAP32[i5 >> 2] = HEAP32[i19 + 12 >> 2];
   __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i1, HEAP32[i19 + 16 >> 2] | 0, HEAP32[i19 + 20 >> 2] | 0);
  }
  i1 = i19 + 28 | 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  if ((i20 | 0) == (i19 | 0)) i4 = i20 + 16 | 0; else {
   __ZN2cv6String10deallocateEv(i19);
   i4 = HEAP32[i20 >> 2] | 0;
   if (!i4) i4 = 0; else {
    i4 = i4 + -4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    i4 = HEAP32[i20 >> 2] | 0;
   }
   HEAP32[i19 >> 2] = i4;
   HEAP32[i19 + 4 >> 2] = HEAP32[i7 >> 2];
   i2 = i19 + 8 | 0;
   __ZN2cv6String10deallocateEv(i2);
   i4 = i20 + 8 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i3) i3 = 0; else {
    i3 = i3 + -4 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
    i3 = HEAP32[i4 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = i3;
   HEAP32[i19 + 12 >> 2] = HEAP32[i8 >> 2];
   i4 = i20 + 16 | 0;
   __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i19 + 16 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i20 + 20 >> 2] | 0);
  }
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3) {
   i2 = i20 + 20 | 0;
   while (1) {
    i1 = HEAP32[i2 >> 2] | 0;
    if ((i1 | 0) == (i3 | 0)) break;
    i9 = i1 + -8 | 0;
    HEAP32[i2 >> 2] = i9;
    __ZN2cv6String10deallocateEv(i9);
   }
   __ZdlPv(HEAP32[i4 >> 2] | 0);
  }
  __ZN2cv6String10deallocateEv(i10);
  __ZN2cv6String10deallocateEv(i20);
  i10 = 1;
  STACKTOP = i21;
  return i10 | 0;
 }
 i4 = HEAP32[i17 >> 2] | 0;
 HEAP32[i20 >> 2] = i4;
 i7 = i20 + 4 | 0;
 i3 = i17 + 4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 if (i4) {
  i10 = i4 + -4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 i10 = i20 + 8 | 0;
 i4 = HEAP32[i17 + 8 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 i9 = i20 + 12 | 0;
 i5 = i17 + 12 | 0;
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 if (i4) {
  i8 = i4 + -4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 i6 = i17 + 16 | 0;
 __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i20 + 16 | 0, i6);
 i8 = i20 + 28 | 0;
 i1 = i17 + 28 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 if ((i18 | 0) != (i17 | 0)) {
  __ZN2cv6String10deallocateEv(i17);
  i4 = HEAP32[i18 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i18 >> 2] | 0;
  }
  HEAP32[i17 >> 2] = i4;
  HEAP32[i3 >> 2] = HEAP32[i18 + 4 >> 2];
  i2 = i17 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i18 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i4 = 0; else {
   i3 = i3 + -4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i4 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i4;
  HEAP32[i5 >> 2] = HEAP32[i18 + 12 >> 2];
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i6, HEAP32[i18 + 16 >> 2] | 0, HEAP32[i18 + 20 >> 2] | 0);
 }
 i5 = i18 + 28 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 if ((i20 | 0) == (i18 | 0)) i1 = i20 + 16 | 0; else {
  __ZN2cv6String10deallocateEv(i18);
  i4 = HEAP32[i20 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i20 >> 2] | 0;
  }
  HEAP32[i18 >> 2] = i4;
  HEAP32[i18 + 4 >> 2] = HEAP32[i7 >> 2];
  i2 = i18 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i20 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i4 = 0; else {
   i7 = i3 + -4 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   i4 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i4;
  HEAP32[i18 + 12 >> 2] = HEAP32[i9 >> 2];
  i1 = i20 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i18 + 16 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i20 + 20 >> 2] | 0);
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i4 = HEAP32[i1 >> 2] | 0;
 if (i4) {
  i3 = i20 + 20 | 0;
  while (1) {
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0)) break;
   i9 = i2 + -8 | 0;
   HEAP32[i3 >> 2] = i9;
   __ZN2cv6String10deallocateEv(i9);
  }
  __ZdlPv(HEAP32[i1 >> 2] | 0);
 }
 __ZN2cv6String10deallocateEv(i10);
 __ZN2cv6String10deallocateEv(i20);
 if (!(FUNCTION_TABLE_iii[HEAP32[i16 >> 2] & 127](i19, i18) | 0)) {
  i10 = 1;
  STACKTOP = i21;
  return i10 | 0;
 }
 i3 = HEAP32[i18 >> 2] | 0;
 HEAP32[i20 >> 2] = i3;
 i7 = i20 + 4 | 0;
 i2 = i18 + 4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 if (i3) {
  i10 = i3 + -4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 i10 = i20 + 8 | 0;
 i4 = HEAP32[i18 + 8 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 i9 = i20 + 12 | 0;
 i6 = i18 + 12 | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 if (i4) {
  i8 = i4 + -4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 i1 = i18 + 16 | 0;
 __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i20 + 16 | 0, i1);
 i8 = i20 + 28 | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 if ((i19 | 0) != (i18 | 0)) {
  __ZN2cv6String10deallocateEv(i18);
  i4 = HEAP32[i19 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i19 >> 2] | 0;
  }
  HEAP32[i18 >> 2] = i4;
  HEAP32[i2 >> 2] = HEAP32[i19 + 4 >> 2];
  i2 = i18 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i19 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i4 = 0; else {
   i3 = i3 + -4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i4 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i4;
  HEAP32[i6 >> 2] = HEAP32[i19 + 12 >> 2];
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i1, HEAP32[i19 + 16 >> 2] | 0, HEAP32[i19 + 20 >> 2] | 0);
 }
 i1 = i19 + 28 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 if ((i20 | 0) == (i19 | 0)) i4 = i20 + 16 | 0; else {
  __ZN2cv6String10deallocateEv(i19);
  i4 = HEAP32[i20 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i20 >> 2] | 0;
  }
  HEAP32[i19 >> 2] = i4;
  HEAP32[i19 + 4 >> 2] = HEAP32[i7 >> 2];
  i2 = i19 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i20 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i3 = 0; else {
   i3 = i3 + -4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i3;
  HEAP32[i19 + 12 >> 2] = HEAP32[i9 >> 2];
  i4 = i20 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i19 + 16 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i20 + 20 >> 2] | 0);
 }
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i3 = HEAP32[i4 >> 2] | 0;
 if (i3) {
  i2 = i20 + 20 | 0;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) break;
   i9 = i1 + -8 | 0;
   HEAP32[i2 >> 2] = i9;
   __ZN2cv6String10deallocateEv(i9);
  }
  __ZdlPv(HEAP32[i4 >> 2] | 0);
 }
 __ZN2cv6String10deallocateEv(i10);
 __ZN2cv6String10deallocateEv(i20);
 i10 = 2;
 STACKTOP = i21;
 return i10 | 0;
}

function __ZNK2cv11_InputArray6getMatEi(i27, i24, i26) {
 i27 = i27 | 0;
 i24 = i24 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 i14 = i28 + 176 | 0;
 i15 = i28 + 168 | 0;
 i25 = i28 + 112 | 0;
 i7 = i28 + 104 | 0;
 i8 = i28 + 96 | 0;
 i9 = i28 + 88 | 0;
 i13 = i28 + 80 | 0;
 i21 = i28 + 72 | 0;
 i23 = i28 + 64 | 0;
 i20 = i28 + 56 | 0;
 i19 = i28 + 48 | 0;
 i3 = i28 + 40 | 0;
 i16 = i28 + 32 | 0;
 i4 = i28 + 24 | 0;
 i17 = i28 + 16 | 0;
 i5 = i28 + 8 | 0;
 i18 = i28;
 i6 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i24 >> 2] | 0) + 24 >> 2] & 127](i24) | 0;
 i10 = i24 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i22 = i1 & 50331648;
 do if ((i6 | 0) == 196608) {
  if ((i26 | 0) >= 0) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   i22 = __ZN2cv6String8allocateEj(i9, 5) | 0;
   HEAP8[i22 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i22 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i22 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i22 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i22 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i9, 28704, 27528, 1147);
   __ZN2cv6String10deallocateEv(i9);
  }
  i3 = HEAP32[i24 + 8 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   HEAP32[i27 >> 2] = 1124007936;
   i3 = i27 + 8 | 0;
   i2 = i27 + 40 | 0;
   i15 = i27 + 4 | 0;
   i14 = i15 + 36 | 0;
   do {
    HEAP32[i15 >> 2] = 0;
    i15 = i15 + 4 | 0;
   } while ((i15 | 0) < (i14 | 0));
   HEAP32[i2 >> 2] = i3;
   i22 = i27 + 48 | 0;
   HEAP32[i27 + 44 >> 2] = i22;
   HEAP32[i27 + 52 >> 2] = 0;
   HEAP32[i22 >> 2] = 0;
   STACKTOP = i28;
   return;
  } else {
   i16 = HEAP32[i10 >> 2] | 0;
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i24 >> 2] | 0) + 40 >> 2] & 63](i13, i24, -1);
   i19 = HEAP32[i3 >> 2] | 0;
   HEAP32[i27 + 4 >> 2] = 2;
   i17 = i27 + 8 | 0;
   i20 = HEAP32[i13 + 4 >> 2] | 0;
   HEAP32[i17 >> 2] = i20;
   i21 = HEAP32[i13 >> 2] | 0;
   HEAP32[i27 + 12 >> 2] = i21;
   HEAP32[i27 + 16 >> 2] = i19;
   HEAP32[i27 + 20 >> 2] = i19;
   i22 = i27 + 24 | 0;
   HEAP32[i22 + 0 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   HEAP32[i22 + 12 >> 2] = 0;
   HEAP32[i27 + 40 >> 2] = i17;
   i17 = i27 + 48 | 0;
   HEAP32[i27 + 44 >> 2] = i17;
   i18 = (i16 >>> 3 & 511) + 1 << (47696 >>> (i16 << 1 & 14) & 3);
   i21 = Math_imul(i21, i18) | 0;
   HEAP32[i27 >> 2] = i16 & 4095 | 1124024320;
   HEAP32[i17 >> 2] = i21;
   HEAP32[i27 + 52 >> 2] = i18;
   i21 = i19 + (Math_imul(i20, i21) | 0) | 0;
   HEAP32[i27 + 28 >> 2] = i21;
   HEAP32[i22 >> 2] = i21;
   STACKTOP = i28;
   return;
  }
 } else if ((i6 | 0) == 720896) {
  i3 = HEAP32[i24 + 8 >> 2] | 0;
  if ((i26 | 0) > -1 ? (i12 = HEAP32[i3 >> 2] | 0, (((HEAP32[i3 + 4 >> 2] | 0) - i12 | 0) / 48 | 0 | 0) > (i26 | 0)) : 0) i1 = i12; else {
   HEAP32[i19 >> 2] = 0;
   HEAP32[i19 + 4 >> 2] = 0;
   i15 = (__ZN2cv6String8allocateEj(i19, 27) | 0) + 0 | 0;
   i2 = 28744;
   i14 = i15 + 27 | 0;
   do {
    HEAP8[i15 >> 0] = HEAP8[i2 >> 0] | 0;
    i15 = i15 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i15 | 0) < (i14 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i19, 28704, 27528, 1178);
   __ZN2cv6String10deallocateEv(i19);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNK2cv4UMat6getMatEi(i27, i1 + (i26 * 48 | 0) | 0, i22);
  STACKTOP = i28;
  return;
 } else if ((i6 | 0) == 458752) {
  if ((i26 | 0) >= 0) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i22 = __ZN2cv6String8allocateEj(i3, 5) | 0;
   HEAP8[i22 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i22 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i22 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i22 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i22 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 28704, 27528, 1185);
   __ZN2cv6String10deallocateEv(i3);
  }
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  i15 = (__ZN2cv6String8allocateEj(i16, 75) | 0) + 0 | 0;
  i2 = 28776;
  i14 = i15 + 75 | 0;
  do {
   HEAP8[i15 >> 0] = HEAP8[i2 >> 0] | 0;
   i15 = i15 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i15 | 0) < (i14 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i16, 28704, 27528, 1186);
  __ZN2cv6String10deallocateEv(i16);
  HEAP32[i27 >> 2] = 1124007936;
  i3 = i27 + 8 | 0;
  i2 = i27 + 40 | 0;
  i15 = i27 + 4 | 0;
  i14 = i15 + 36 | 0;
  do {
   HEAP32[i15 >> 2] = 0;
   i15 = i15 + 4 | 0;
  } while ((i15 | 0) < (i14 | 0));
  HEAP32[i2 >> 2] = i3;
  i22 = i27 + 48 | 0;
  HEAP32[i27 + 44 >> 2] = i22;
  HEAP32[i27 + 52 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  STACKTOP = i28;
  return;
 } else if ((i6 | 0) == 655360) {
  i3 = HEAP32[i24 + 8 >> 2] | 0;
  if ((i26 | 0) < 0) {
   __ZNK2cv4UMat6getMatEi(i27, i3, i22);
   STACKTOP = i28;
   return;
  }
  __ZNK2cv4UMat6getMatEi(i25, i3, i22);
  HEAP32[i14 >> 2] = i26;
  HEAP32[i14 + 4 >> 2] = i26 + 1;
  HEAP32[i15 >> 2] = -2147483648;
  HEAP32[i15 + 4 >> 2] = 2147483647;
  __ZN2cv3MatC2ERKS0_RKNS_5RangeES5_(i27, i25, i14, i15);
  i3 = i25 + 36 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) {
   i2 = HEAP32[i3 >> 2] | 0;
   if (i2) {
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) {
     i1 = HEAP32[i25 + 32 >> 2] | 0;
     if (!i1) {
      if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
       i22 = __Znwj(4) | 0;
       HEAP32[i22 >> 2] = 32784;
       HEAP32[6904] = i22;
       ___cxa_guard_release(27624);
      }
      i1 = HEAP32[6904] | 0;
      i2 = HEAP32[i3 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i2);
   }
   HEAP32[i3 >> 2] = 0;
  }
  HEAP32[i3 >> 2] = 0;
  i22 = i25 + 16 | 0;
  i2 = i25 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i25 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i1 = HEAP32[i25 + 44 >> 2] | 0;
  if ((i1 | 0) == (i25 + 48 | 0)) {
   STACKTOP = i28;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i28;
  return;
 } else if ((i6 | 0) == 65536) {
  i3 = HEAP32[i24 + 8 >> 2] | 0;
  if ((i26 | 0) < 0) {
   __ZN2cv3MatC2ERKS0_(i27, i3);
   STACKTOP = i28;
   return;
  } else {
   HEAP32[i14 >> 2] = i26;
   HEAP32[i14 + 4 >> 2] = i26 + 1;
   HEAP32[i15 >> 2] = -2147483648;
   HEAP32[i15 + 4 >> 2] = 2147483647;
   __ZN2cv3MatC2ERKS0_RKNS_5RangeES5_(i27, i3, i14, i15);
   STACKTOP = i28;
   return;
  }
 } else if ((i6 | 0) == 393216) {
  if ((i26 | 0) >= 0) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i22 = __ZN2cv6String8allocateEj(i7, 5) | 0;
   HEAP8[i22 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i22 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i22 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i22 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i22 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 28704, 27528, 1135);
   __ZN2cv6String10deallocateEv(i7);
  }
  i3 = HEAP32[i24 + 8 >> 2] | 0;
  HEAP32[i27 >> 2] = 1124007936;
  i2 = i27 + 8 | 0;
  i1 = i27 + 40 | 0;
  i15 = i27 + 4 | 0;
  i14 = i15 + 36 | 0;
  do {
   HEAP32[i15 >> 2] = 0;
   i15 = i15 + 4 | 0;
  } while ((i15 | 0) < (i14 | 0));
  HEAP32[i1 >> 2] = i2;
  i22 = i27 + 48 | 0;
  HEAP32[i27 + 44 >> 2] = i22;
  HEAP32[i27 + 52 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  i22 = HEAP32[i3 >> 2] | 0;
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] & 63](i22, i3, i27, -1);
  STACKTOP = i28;
  return;
 } else if ((i6 | 0) == 131072) {
  if ((i26 | 0) >= 0) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i8, 5) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 28704, 27528, 1141);
   __ZN2cv6String10deallocateEv(i8);
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i20 = HEAP32[i24 + 12 >> 2] | 0;
  i21 = HEAP32[i24 + 16 >> 2] | 0;
  i19 = HEAP32[i24 + 8 >> 2] | 0;
  HEAP32[i27 + 4 >> 2] = 2;
  i17 = i27 + 8 | 0;
  HEAP32[i17 >> 2] = i21;
  HEAP32[i27 + 12 >> 2] = i20;
  HEAP32[i27 + 16 >> 2] = i19;
  HEAP32[i27 + 20 >> 2] = i19;
  i22 = i27 + 24 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  HEAP32[i27 + 40 >> 2] = i17;
  i17 = i27 + 48 | 0;
  HEAP32[i27 + 44 >> 2] = i17;
  i18 = (i1 >>> 3 & 511) + 1 << (47696 >>> (i1 << 1 & 14) & 3);
  i20 = Math_imul(i18, i20) | 0;
  HEAP32[i27 >> 2] = i1 & 4095 | 1124024320;
  HEAP32[i17 >> 2] = i20;
  HEAP32[i27 + 52 >> 2] = i18;
  i21 = i19 + (Math_imul(i20, i21) | 0) | 0;
  HEAP32[i27 + 28 >> 2] = i21;
  HEAP32[i22 >> 2] = i21;
  STACKTOP = i28;
  return;
 } else if ((i6 | 0) == 524288) {
  if ((i26 | 0) >= 0) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i22 = __ZN2cv6String8allocateEj(i5, 5) | 0;
   HEAP8[i22 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i22 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i22 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i22 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i22 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 28704, 27528, 1199);
   __ZN2cv6String10deallocateEv(i5);
  }
  i22 = HEAP32[i24 + 8 >> 2] | 0;
  i21 = HEAP32[i22 + 4 >> 2] | 0;
  HEAP32[i14 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i14 + 4 >> 2] = i21;
  __ZN2cv3MatC2ENS_5Size_IiEEiPvj(i27, i14, HEAP32[i22 >> 2] & 4095, HEAP32[i22 + 16 >> 2] | 0, HEAP32[i22 + 12 >> 2] | 0);
  STACKTOP = i28;
  return;
 } else if ((i6 | 0) == 262144) {
  i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i24 >> 2] | 0) + 56 >> 2] & 127](i24, i26) | 0;
  i3 = HEAP32[i24 + 8 >> 2] | 0;
  if (!((i26 | 0) > -1 ? (i2 = HEAP32[i3 >> 2] | 0, (((HEAP32[i3 + 4 >> 2] | 0) - i2 | 0) / 12 | 0 | 0) > (i26 | 0)) : 0)) {
   HEAP32[i21 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   i15 = (__ZN2cv6String8allocateEj(i21, 28) | 0) + 0 | 0;
   i2 = 28712;
   i14 = i15 + 28 | 0;
   do {
    HEAP8[i15 >> 0] = HEAP8[i2 >> 0] | 0;
    i15 = i15 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i15 | 0) < (i14 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i21, 28704, 27528, 1161);
   __ZN2cv6String10deallocateEv(i21);
   i2 = HEAP32[i3 >> 2] | 0;
  }
  i3 = i2 + (i26 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i2 + (i26 * 12 | 0) + 4 >> 2] | 0)) {
   HEAP32[i27 >> 2] = 1124007936;
   i3 = i27 + 8 | 0;
   i2 = i27 + 40 | 0;
   i15 = i27 + 4 | 0;
   i14 = i15 + 36 | 0;
   do {
    HEAP32[i15 >> 2] = 0;
    i15 = i15 + 4 | 0;
   } while ((i15 | 0) < (i14 | 0));
   HEAP32[i2 >> 2] = i3;
   i22 = i27 + 48 | 0;
   HEAP32[i27 + 44 >> 2] = i22;
   HEAP32[i27 + 52 >> 2] = 0;
   HEAP32[i22 >> 2] = 0;
   STACKTOP = i28;
   return;
  } else {
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i24 >> 2] | 0) + 40 >> 2] & 63](i23, i24, i26);
   i19 = HEAP32[i3 >> 2] | 0;
   HEAP32[i27 + 4 >> 2] = 2;
   i17 = i27 + 8 | 0;
   i20 = HEAP32[i23 + 4 >> 2] | 0;
   HEAP32[i17 >> 2] = i20;
   i21 = HEAP32[i23 >> 2] | 0;
   HEAP32[i27 + 12 >> 2] = i21;
   HEAP32[i27 + 16 >> 2] = i19;
   HEAP32[i27 + 20 >> 2] = i19;
   i22 = i27 + 24 | 0;
   HEAP32[i22 + 0 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   HEAP32[i22 + 12 >> 2] = 0;
   HEAP32[i27 + 40 >> 2] = i17;
   i17 = i27 + 48 | 0;
   HEAP32[i27 + 44 >> 2] = i17;
   i18 = (i1 >>> 3 & 511) + 1 << (47696 >>> (i1 << 1 & 14) & 3);
   i21 = Math_imul(i21, i18) | 0;
   HEAP32[i27 >> 2] = i1 & 4095 | 1124024320;
   HEAP32[i17 >> 2] = i21;
   HEAP32[i27 + 52 >> 2] = i18;
   i21 = i19 + (Math_imul(i20, i21) | 0) | 0;
   HEAP32[i27 + 28 >> 2] = i21;
   HEAP32[i22 >> 2] = i21;
   STACKTOP = i28;
   return;
  }
 } else if (!i6) {
  HEAP32[i27 >> 2] = 1124007936;
  i3 = i27 + 8 | 0;
  i2 = i27 + 40 | 0;
  i15 = i27 + 4 | 0;
  i14 = i15 + 36 | 0;
  do {
   HEAP32[i15 >> 2] = 0;
   i15 = i15 + 4 | 0;
  } while ((i15 | 0) < (i14 | 0));
  HEAP32[i2 >> 2] = i3;
  i22 = i27 + 48 | 0;
  HEAP32[i27 + 44 >> 2] = i22;
  HEAP32[i27 + 52 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  STACKTOP = i28;
  return;
 } else if ((i6 | 0) == 327680) {
  i3 = HEAP32[i24 + 8 >> 2] | 0;
  if ((i26 | 0) > -1 ? (i11 = HEAP32[i3 >> 2] | 0, (((HEAP32[i3 + 4 >> 2] | 0) - i11 | 0) / 56 | 0 | 0) > (i26 | 0)) : 0) i1 = i11; else {
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   i15 = (__ZN2cv6String8allocateEj(i20, 27) | 0) + 0 | 0;
   i2 = 28744;
   i14 = i15 + 27 | 0;
   do {
    HEAP8[i15 >> 0] = HEAP8[i2 >> 0] | 0;
    i15 = i15 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i15 | 0) < (i14 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i20, 28704, 27528, 1170);
   __ZN2cv6String10deallocateEv(i20);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZN2cv3MatC2ERKS0_(i27, i1 + (i26 * 56 | 0) | 0);
  STACKTOP = i28;
  return;
 } else if ((i6 | 0) == 589824) {
  if ((i26 | 0) >= 0) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i22 = __ZN2cv6String8allocateEj(i4, 5) | 0;
   HEAP8[i22 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i22 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i22 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i22 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i22 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 28704, 27528, 1192);
   __ZN2cv6String10deallocateEv(i4);
  }
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  i15 = (__ZN2cv6String8allocateEj(i17, 66) | 0) + 0 | 0;
  i2 = 28856;
  i14 = i15 + 66 | 0;
  do {
   HEAP8[i15 >> 0] = HEAP8[i2 >> 0] | 0;
   i15 = i15 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i15 | 0) < (i14 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i17, 28704, 27528, 1193);
  __ZN2cv6String10deallocateEv(i17);
  HEAP32[i27 >> 2] = 1124007936;
  i3 = i27 + 8 | 0;
  i2 = i27 + 40 | 0;
  i15 = i27 + 4 | 0;
  i14 = i15 + 36 | 0;
  do {
   HEAP32[i15 >> 2] = 0;
   i15 = i15 + 4 | 0;
  } while ((i15 | 0) < (i14 | 0));
  HEAP32[i2 >> 2] = i3;
  i22 = i27 + 48 | 0;
  HEAP32[i27 + 44 >> 2] = i22;
  HEAP32[i27 + 52 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  STACKTOP = i28;
  return;
 } else {
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  i15 = (__ZN2cv6String8allocateEj(i18, 30) | 0) + 0 | 0;
  i2 = 28928;
  i14 = i15 + 30 | 0;
  do {
   HEAP8[i15 >> 0] = HEAP8[i2 >> 0] | 0;
   i15 = i15 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i15 | 0) < (i14 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i18, 28704, 27528, 1206);
  __ZN2cv6String10deallocateEv(i18);
  HEAP32[i27 >> 2] = 1124007936;
  i3 = i27 + 8 | 0;
  i2 = i27 + 40 | 0;
  i15 = i27 + 4 | 0;
  i14 = i15 + 36 | 0;
  do {
   HEAP32[i15 >> 2] = 0;
   i15 = i15 + 4 | 0;
  } while ((i15 | 0) < (i14 | 0));
  HEAP32[i2 >> 2] = i3;
  i22 = i27 + 48 | 0;
  HEAP32[i27 + 44 >> 2] = i22;
  HEAP32[i27 + 52 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  STACKTOP = i28;
  return;
 } while (0);
}

function __ZN2cv15NAryMatIterator4initEPPKNS_3MatEPS1_PPhi(i45, i6, i5, i4, i1) {
 i45 = i45 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i46 = 0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i3 = i46 + 152 | 0;
 i2 = i46 + 144 | 0;
 i14 = i46 + 136 | 0;
 i15 = i46 + 128 | 0;
 i16 = i46 + 120 | 0;
 i42 = i46 + 112 | 0;
 i43 = i46 + 56 | 0;
 i44 = i46;
 if (!((i6 | 0) != 0 ? (i4 | 0) != 0 | (i5 | 0) != 0 : 0)) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i19 = (__ZN2cv6String8allocateEj(i3, 29) | 0) + 0 | 0;
  i18 = 31912;
  i20 = i19 + 29 | 0;
  do {
   HEAP8[i19 >> 0] = HEAP8[i18 >> 0] | 0;
   i19 = i19 + 1 | 0;
   i18 = i18 + 1 | 0;
  } while ((i19 | 0) < (i20 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 31944, 27528, 4237);
  __ZN2cv6String10deallocateEv(i3);
 }
 HEAP32[i45 >> 2] = i6;
 i13 = i45 + 8 | 0;
 HEAP32[i13 >> 2] = i4;
 i41 = i45 + 4 | 0;
 HEAP32[i41 >> 2] = i5;
 i39 = i45 + 12 | 0;
 HEAP32[i39 >> 2] = i1;
 i21 = i45 + 16 | 0;
 HEAP32[i21 >> 2] = 0;
 i40 = i45 + 20 | 0;
 HEAP32[i40 >> 2] = 0;
 if ((i1 | 0) < 0) {
  i1 = 0;
  while (1) if (!(HEAP32[i6 + (i1 << 2) >> 2] | 0)) break; else i1 = i1 + 1 | 0;
  HEAP32[i39 >> 2] = i1;
  if ((i1 | 0) >= 1001) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   i19 = (__ZN2cv6String8allocateEj(i2, 15) | 0) + 0 | 0;
   i18 = 31952;
   i20 = i19 + 15 | 0;
   do {
    HEAP8[i19 >> 0] = HEAP8[i18 >> 0] | 0;
    i19 = i19 + 1 | 0;
    i18 = i18 + 1 | 0;
   } while ((i19 | 0) < (i20 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 31944, 27528, 4252);
   __ZN2cv6String10deallocateEv(i2);
   i1 = HEAP32[i39 >> 2] | 0;
  }
 }
 i17 = i45 + 24 | 0;
 HEAP32[i17 >> 2] = 0;
 if ((i1 | 0) > 0) {
  i9 = i14 + 4 | 0;
  i10 = i16 + 4 | 0;
  i11 = i15 + 4 | 0;
  i6 = -1;
  i7 = 0;
  i12 = 0;
  i8 = -1;
  while (1) {
   i5 = HEAP32[(HEAP32[i45 >> 2] | 0) + (i12 << 2) >> 2] | 0;
   if (!i5) {
    HEAP32[i14 >> 2] = 0;
    HEAP32[i9 >> 2] = 0;
    i19 = (__ZN2cv6String8allocateEj(i14, 14) | 0) + 0 | 0;
    i18 = 31968;
    i20 = i19 + 14 | 0;
    do {
     HEAP8[i19 >> 0] = HEAP8[i18 >> 0] | 0;
     i19 = i19 + 1 | 0;
     i18 = i18 + 1 | 0;
    } while ((i19 | 0) < (i20 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i14, 31944, 27528, 4259);
    __ZN2cv6String10deallocateEv(i14);
    i5 = HEAP32[(HEAP32[i45 >> 2] | 0) + (i12 << 2) >> 2] | 0;
   }
   i3 = HEAP32[i13 >> 2] | 0;
   i4 = i5 + 16 | 0;
   if (i3) HEAP32[i3 + (i12 << 2) >> 2] = HEAP32[i4 >> 2];
   if (HEAP32[i4 >> 2] | 0) {
    L24 : do if ((i8 | 0) < 0) {
     i6 = HEAP32[i5 + 4 >> 2] | 0;
     if ((i6 | 0) > 0) {
      i4 = HEAP32[i5 + 40 >> 2] | 0;
      i2 = 0;
      while (1) {
       i3 = i2 + 1 | 0;
       if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) > 1) {
        i3 = i2;
        i8 = i12;
        break L24;
       }
       if ((i3 | 0) < (i6 | 0)) i2 = i3; else {
        i8 = i12;
        break;
       }
      }
     } else {
      i3 = 0;
      i8 = i12;
     }
    } else {
     i4 = HEAP32[i5 + 40 >> 2] | 0;
     i3 = HEAP32[i4 + -4 >> 2] | 0;
     i2 = HEAP32[(HEAP32[(HEAP32[i45 >> 2] | 0) + (i8 << 2) >> 2] | 0) + 40 >> 2] | 0;
     L26 : do if ((i3 | 0) == (HEAP32[i2 + -4 >> 2] | 0)) {
      if ((i3 | 0) == 2) {
       if ((HEAP32[i4 >> 2] | 0) != (HEAP32[i2 >> 2] | 0)) break;
       if ((HEAP32[i4 + 4 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
        i3 = i7;
        break L24;
       } else break;
      }
      if ((i3 | 0) > 0) i1 = 0; else {
       i3 = i7;
       break L24;
      }
      while (1) {
       if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) != (HEAP32[i2 + (i1 << 2) >> 2] | 0)) break L26;
       i1 = i1 + 1 | 0;
       if ((i1 | 0) >= (i3 | 0)) {
        i3 = i7;
        break L24;
       }
      }
     } while (0);
     HEAP32[i15 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     i19 = (__ZN2cv6String8allocateEj(i15, 26) | 0) + 0 | 0;
     i18 = 31984;
     i20 = i19 + 26 | 0;
     do {
      HEAP8[i19 >> 0] = HEAP8[i18 >> 0] | 0;
      i19 = i19 + 1 | 0;
      i18 = i18 + 1 | 0;
     } while ((i19 | 0) < (i20 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i15, 31944, 27528, 4279);
     __ZN2cv6String10deallocateEv(i15);
     i3 = i7;
    } while (0);
    if (!(HEAP32[i5 >> 2] & 16384)) {
     i4 = i6 + -1 | 0;
     i7 = i5 + 44 | 0;
     i1 = HEAP32[i7 >> 2] | 0;
     i2 = HEAP32[i5 + 4 >> 2] | 0;
     if ((i2 | 0) > 0) i2 = HEAP32[i1 + (i2 + -1 << 2) >> 2] | 0; else i2 = 0;
     if ((HEAP32[i1 + (i4 << 2) >> 2] | 0) != (i2 | 0)) {
      HEAP32[i16 >> 2] = 0;
      HEAP32[i10 >> 2] = 0;
      i19 = (__ZN2cv6String8allocateEj(i16, 27) | 0) + 0 | 0;
      i18 = 32016;
      i20 = i19 + 27 | 0;
      do {
       HEAP8[i19 >> 0] = HEAP8[i18 >> 0] | 0;
       i19 = i19 + 1 | 0;
       i18 = i18 + 1 | 0;
      } while ((i19 | 0) < (i20 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i16, 31944, 27528, 4283);
      __ZN2cv6String10deallocateEv(i16);
     }
     i2 = i5 + 40 | 0;
     while (1) {
      if ((i4 | 0) <= (i3 | 0)) break;
      i20 = HEAP32[i7 >> 2] | 0;
      i19 = Math_imul(HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] | 0, HEAP32[i20 + (i4 << 2) >> 2] | 0) | 0;
      i5 = i4 + -1 | 0;
      if (i19 >>> 0 < (HEAP32[i20 + (i5 << 2) >> 2] | 0) >>> 0) break; else i4 = i5;
     }
     i7 = HEAP32[i17 >> 2] | 0;
     HEAP32[i17 >> 2] = (i7 | 0) < (i4 | 0) ? i4 : i7;
     i7 = i3;
     i5 = i8;
    } else {
     i7 = i3;
     i5 = i8;
    }
   } else i5 = i8;
   i12 = i12 + 1 | 0;
   i1 = HEAP32[i39 >> 2] | 0;
   if ((i12 | 0) >= (i1 | 0)) break; else i8 = i5;
  }
  if ((i5 | 0) > -1) {
   i2 = i6 + -1 | 0;
   i6 = HEAP32[(HEAP32[(HEAP32[i45 >> 2] | 0) + (i5 << 2) >> 2] | 0) + 40 >> 2] | 0;
   i3 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
   HEAP32[i40 >> 2] = i3;
   i5 = HEAP32[i17 >> 2] | 0;
   L56 : do if ((i2 | 0) > (i5 | 0)) {
    i4 = i2;
    while (1) {
     i2 = i4 + -1 | 0;
     i20 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
     i3 = ___muldi3(i20 | 0, ((i20 | 0) < 0) << 31 >> 31 | 0, i3 | 0, 0) | 0;
     if (!((i3 | 0) == (i3 | 0) & (tempRet0 | 0) == (((i3 | 0) < 0) << 31 >> 31 | 0))) {
      i2 = i4;
      break L56;
     }
     HEAP32[i40 >> 2] = i3;
     if ((i2 | 0) <= (i5 | 0)) break; else i4 = i2;
    }
   } while (0);
   i2 = (i2 | 0) == (i7 | 0) ? 0 : i2;
   HEAP32[i17 >> 2] = i2;
   HEAP32[i21 >> 2] = 1;
   if ((i2 | 0) > 0) {
    i3 = 1;
    do {
     i2 = i2 + -1 | 0;
     i3 = Math_imul(i3, HEAP32[i6 + (i2 << 2) >> 2] | 0) | 0;
     HEAP32[i21 >> 2] = i3;
    } while ((i2 | 0) > 0);
   }
  } else i22 = 44;
 } else i22 = 44;
 if ((i22 | 0) == 44) HEAP32[i17 >> 2] = 0;
 HEAP32[i45 + 28 >> 2] = 0;
 if (!((HEAP32[i41 >> 2] | 0) != 0 & (i1 | 0) > 0)) {
  STACKTOP = i46;
  return;
 }
 i22 = i42 + 4 | 0;
 i21 = i43 + 4 | 0;
 i17 = i43 + 8 | 0;
 i16 = i43 + 40 | 0;
 i15 = i43 + 48 | 0;
 i14 = i43 + 44 | 0;
 i13 = i43 + 52 | 0;
 i11 = i43 + 36 | 0;
 i1 = i43 + 16 | 0;
 i2 = i43 + 32 | 0;
 i9 = i43 + 12 | 0;
 i10 = i43 + 20 | 0;
 i23 = i43 + 24 | 0;
 i24 = i43 + 28 | 0;
 i25 = i44 + 4 | 0;
 i26 = i44 + 8 | 0;
 i27 = i44 + 12 | 0;
 i28 = i44 + 16 | 0;
 i29 = i44 + 20 | 0;
 i30 = i44 + 24 | 0;
 i31 = i44 + 28 | 0;
 i32 = i44 + 40 | 0;
 i33 = i44 + 48 | 0;
 i34 = i44 + 44 | 0;
 i35 = i44 + 52 | 0;
 i36 = i44 + 36 | 0;
 i37 = i44 + 32 | 0;
 i38 = 0;
 do {
  i8 = HEAP32[(HEAP32[i45 >> 2] | 0) + (i38 << 2) >> 2] | 0;
  if (!i8) {
   HEAP32[i42 >> 2] = 0;
   HEAP32[i22 >> 2] = 0;
   i19 = (__ZN2cv6String8allocateEj(i42, 14) | 0) + 0 | 0;
   i18 = 31968;
   i20 = i19 + 14 | 0;
   do {
    HEAP8[i19 >> 0] = HEAP8[i18 >> 0] | 0;
    i19 = i19 + 1 | 0;
    i18 = i18 + 1 | 0;
   } while ((i19 | 0) < (i20 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i42, 31944, 27528, 4320);
   __ZN2cv6String10deallocateEv(i42);
   i8 = HEAP32[(HEAP32[i45 >> 2] | 0) + (i38 << 2) >> 2] | 0;
  }
  i7 = HEAP32[i8 + 16 >> 2] | 0;
  i12 = HEAP32[i41 >> 2] | 0;
  i6 = i12 + (i38 * 56 | 0) | 0;
  if (!i7) {
   HEAP32[i43 >> 2] = 1124007936;
   i19 = i21 + 0 | 0;
   i20 = i19 + 36 | 0;
   do {
    HEAP32[i19 >> 2] = 0;
    i19 = i19 + 4 | 0;
   } while ((i19 | 0) < (i20 | 0));
   HEAP32[i16 >> 2] = i17;
   HEAP32[i14 >> 2] = i15;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i15 >> 2] = 0;
   if ((i6 | 0) != (i43 | 0)) {
    __ZN2cv3Mat7releaseEv(i6);
    HEAP32[i6 >> 2] = HEAP32[i43 >> 2];
    i3 = i12 + (i38 * 56 | 0) + 4 | 0;
    i8 = HEAP32[i21 >> 2] | 0;
    if (!((HEAP32[i3 >> 2] | 0) < 3 & (i8 | 0) < 3)) {
     __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i6, i8, 0, 0, 0);
     if ((HEAP32[i3 >> 2] | 0) > 0) {
      i8 = HEAP32[i16 >> 2] | 0;
      i7 = HEAP32[i12 + (i38 * 56 | 0) + 40 >> 2] | 0;
      i6 = HEAP32[i14 >> 2] | 0;
      i5 = HEAP32[i12 + (i38 * 56 | 0) + 44 >> 2] | 0;
      i4 = 0;
      do {
       HEAP32[i7 + (i4 << 2) >> 2] = HEAP32[i8 + (i4 << 2) >> 2];
       HEAP32[i5 + (i4 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) < (HEAP32[i3 >> 2] | 0));
     }
    } else {
     HEAP32[i3 >> 2] = i8;
     HEAP32[i12 + (i38 * 56 | 0) + 8 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i12 + (i38 * 56 | 0) + 12 >> 2] = HEAP32[i9 >> 2];
     i19 = HEAP32[i14 >> 2] | 0;
     i20 = HEAP32[i12 + (i38 * 56 | 0) + 44 >> 2] | 0;
     HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    }
    HEAP32[i12 + (i38 * 56 | 0) + 16 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i12 + (i38 * 56 | 0) + 20 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + (i38 * 56 | 0) + 24 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i12 + (i38 * 56 | 0) + 28 >> 2] = HEAP32[i24 >> 2];
    HEAP32[i12 + (i38 * 56 | 0) + 32 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i12 + (i38 * 56 | 0) + 36 >> 2] = HEAP32[i11 >> 2];
    i8 = HEAP32[i11 >> 2] | 0;
    if ((i8 | 0) != 0 ? (i19 = i8 + 12 | 0, i20 = HEAP32[i19 >> 2] | 0, HEAP32[i19 >> 2] = i20 + -1, (i20 | 0) == 1) : 0) {
     i7 = HEAP32[i11 >> 2] | 0;
     if (i7) {
      i8 = HEAP32[i7 + 4 >> 2] | 0;
      if (!i8) {
       i8 = HEAP32[i2 >> 2] | 0;
       if (!i8) {
        do if (!(HEAP8[27624] | 0)) {
         if (!(___cxa_guard_acquire(27624) | 0)) break;
         i20 = __Znwj(4) | 0;
         HEAP32[i20 >> 2] = 32784;
         HEAP32[6904] = i20;
         ___cxa_guard_release(27624);
        } while (0);
        i8 = HEAP32[6904] | 0;
        i7 = HEAP32[i11 >> 2] | 0;
       }
      }
      FUNCTION_TABLE_vii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8, i7);
     }
     HEAP32[i11 >> 2] = 0;
    }
   }
   HEAP32[i11 >> 2] = 0;
   HEAP32[i1 + 0 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   if ((HEAP32[i21 >> 2] | 0) > 0) {
    i8 = HEAP32[i16 >> 2] | 0;
    i7 = 0;
    do {
     HEAP32[i8 + (i7 << 2) >> 2] = 0;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) < (HEAP32[i21 >> 2] | 0));
   }
   i8 = HEAP32[i14 >> 2] | 0;
   if ((i8 | 0) != (i15 | 0)) __ZN2cv8fastFreeEPv(i8);
  } else {
   i20 = HEAP32[i40 >> 2] | 0;
   i18 = HEAP32[i8 >> 2] | 0;
   HEAP32[i25 >> 2] = 2;
   HEAP32[i26 >> 2] = 1;
   HEAP32[i27 >> 2] = i20;
   HEAP32[i28 >> 2] = i7;
   HEAP32[i29 >> 2] = i7;
   HEAP32[i30 + 0 >> 2] = 0;
   HEAP32[i30 + 4 >> 2] = 0;
   HEAP32[i30 + 8 >> 2] = 0;
   HEAP32[i30 + 12 >> 2] = 0;
   HEAP32[i32 >> 2] = i26;
   HEAP32[i34 >> 2] = i33;
   i19 = (i18 >>> 3 & 511) + 1 << (47696 >>> (i18 << 1 & 14) & 3);
   i20 = Math_imul(i19, i20) | 0;
   HEAP32[i44 >> 2] = i18 & 4095 | 1124024320;
   HEAP32[i33 >> 2] = i20;
   HEAP32[i35 >> 2] = i19;
   i20 = i7 + i20 | 0;
   HEAP32[i31 >> 2] = i20;
   HEAP32[i30 >> 2] = i20;
   if ((i6 | 0) != (i44 | 0)) {
    __ZN2cv3Mat7releaseEv(i6);
    HEAP32[i6 >> 2] = HEAP32[i44 >> 2];
    i3 = i12 + (i38 * 56 | 0) + 4 | 0;
    i8 = HEAP32[i25 >> 2] | 0;
    if (!((HEAP32[i3 >> 2] | 0) < 3 & (i8 | 0) < 3)) {
     __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i6, i8, 0, 0, 0);
     if ((HEAP32[i3 >> 2] | 0) > 0) {
      i8 = HEAP32[i32 >> 2] | 0;
      i7 = HEAP32[i12 + (i38 * 56 | 0) + 40 >> 2] | 0;
      i6 = HEAP32[i34 >> 2] | 0;
      i5 = HEAP32[i12 + (i38 * 56 | 0) + 44 >> 2] | 0;
      i4 = 0;
      do {
       HEAP32[i7 + (i4 << 2) >> 2] = HEAP32[i8 + (i4 << 2) >> 2];
       HEAP32[i5 + (i4 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) < (HEAP32[i3 >> 2] | 0));
     }
    } else {
     HEAP32[i3 >> 2] = i8;
     HEAP32[i12 + (i38 * 56 | 0) + 8 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i12 + (i38 * 56 | 0) + 12 >> 2] = HEAP32[i27 >> 2];
     i19 = HEAP32[i34 >> 2] | 0;
     i20 = HEAP32[i12 + (i38 * 56 | 0) + 44 >> 2] | 0;
     HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    }
    HEAP32[i12 + (i38 * 56 | 0) + 16 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i12 + (i38 * 56 | 0) + 20 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i12 + (i38 * 56 | 0) + 24 >> 2] = HEAP32[i30 >> 2];
    HEAP32[i12 + (i38 * 56 | 0) + 28 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i12 + (i38 * 56 | 0) + 32 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i12 + (i38 * 56 | 0) + 36 >> 2] = HEAP32[i36 >> 2];
    i8 = HEAP32[i36 >> 2] | 0;
    if ((i8 | 0) != 0 ? (i19 = i8 + 12 | 0, i20 = HEAP32[i19 >> 2] | 0, HEAP32[i19 >> 2] = i20 + -1, (i20 | 0) == 1) : 0) {
     i7 = HEAP32[i36 >> 2] | 0;
     if (i7) {
      i8 = HEAP32[i7 + 4 >> 2] | 0;
      if (!i8) {
       i8 = HEAP32[i37 >> 2] | 0;
       if (!i8) {
        do if (!(HEAP8[27624] | 0)) {
         if (!(___cxa_guard_acquire(27624) | 0)) break;
         i20 = __Znwj(4) | 0;
         HEAP32[i20 >> 2] = 32784;
         HEAP32[6904] = i20;
         ___cxa_guard_release(27624);
        } while (0);
        i8 = HEAP32[6904] | 0;
        i7 = HEAP32[i36 >> 2] | 0;
       }
      }
      FUNCTION_TABLE_vii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8, i7);
     }
     HEAP32[i36 >> 2] = 0;
    }
   }
   HEAP32[i36 >> 2] = 0;
   HEAP32[i28 + 0 >> 2] = 0;
   HEAP32[i28 + 4 >> 2] = 0;
   HEAP32[i28 + 8 >> 2] = 0;
   HEAP32[i28 + 12 >> 2] = 0;
   if ((HEAP32[i25 >> 2] | 0) > 0) {
    i8 = HEAP32[i32 >> 2] | 0;
    i7 = 0;
    do {
     HEAP32[i8 + (i7 << 2) >> 2] = 0;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) < (HEAP32[i25 >> 2] | 0));
   }
   i8 = HEAP32[i34 >> 2] | 0;
   if ((i8 | 0) != (i33 | 0)) __ZN2cv8fastFreeEPv(i8);
  }
  i38 = i38 + 1 | 0;
 } while ((i38 | 0) < (HEAP32[i39 >> 2] | 0));
 STACKTOP = i46;
 return;
}

function __ZNK2cv9MatOp_Bin6assignERKNS_7MatExprERNS_3MatEi(i1, i47, i50, i49) {
 i1 = i1 | 0;
 i47 = i47 | 0;
 i50 = i50 | 0;
 i49 = i49 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i48 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, d57 = 0.0;
 i56 = STACKTOP;
 STACKTOP = STACKTOP + 896 | 0;
 i52 = i56 + 832 | 0;
 i1 = i56 + 812 | 0;
 i3 = i56 + 792 | 0;
 i14 = i56 + 772 | 0;
 i25 = i56 + 752 | 0;
 i36 = i56 + 732 | 0;
 i37 = i56 + 712 | 0;
 i38 = i56 + 692 | 0;
 i40 = i56 + 672 | 0;
 i41 = i56 + 652 | 0;
 i42 = i56 + 632 | 0;
 i4 = i56 + 612 | 0;
 i5 = i56 + 592 | 0;
 i6 = i56 + 572 | 0;
 i7 = i56 + 552 | 0;
 i8 = i56 + 532 | 0;
 i9 = i56 + 512 | 0;
 i10 = i56 + 492 | 0;
 i11 = i56 + 472 | 0;
 i12 = i56 + 452 | 0;
 i13 = i56 + 432 | 0;
 i15 = i56 + 412 | 0;
 i16 = i56 + 392 | 0;
 i17 = i56 + 372 | 0;
 i18 = i56 + 352 | 0;
 i19 = i56 + 332 | 0;
 i20 = i56 + 312 | 0;
 i21 = i56 + 292 | 0;
 i22 = i56 + 272 | 0;
 i23 = i56 + 252 | 0;
 i24 = i56 + 232 | 0;
 i26 = i56 + 212 | 0;
 i27 = i56 + 192 | 0;
 i28 = i56 + 172 | 0;
 i29 = i56 + 152 | 0;
 i30 = i56 + 132 | 0;
 i31 = i56 + 112 | 0;
 i32 = i56 + 92 | 0;
 i33 = i56 + 72 | 0;
 i34 = i56 + 52 | 0;
 i35 = i56 + 32 | 0;
 i45 = i56 + 24 | 0;
 i46 = i56;
 HEAP32[i52 >> 2] = 1124007936;
 i54 = i52 + 4 | 0;
 i2 = i52 + 8 | 0;
 i51 = i52 + 40 | 0;
 i43 = i54 + 0 | 0;
 i44 = i43 + 36 | 0;
 do {
  HEAP32[i43 >> 2] = 0;
  i43 = i43 + 4 | 0;
 } while ((i43 | 0) < (i44 | 0));
 HEAP32[i51 >> 2] = i2;
 i55 = i52 + 48 | 0;
 i53 = i52 + 44 | 0;
 HEAP32[i53 >> 2] = i55;
 HEAP32[i52 + 52 >> 2] = 0;
 HEAP32[i55 >> 2] = 0;
 if ((i49 | 0) != -1 ? (HEAP32[i47 + 8 >> 2] & 4095 | 0) != (i49 | 0) : 0) i39 = i52; else i39 = i50;
 i2 = HEAP32[i47 + 4 >> 2] | 0;
 L6 : do switch (i2 | 0) {
 case 94:
  {
   i48 = 18;
   break;
  }
 case 47:
  if (!(HEAP32[i47 + 80 >> 2] | 0)) {
   d57 = +HEAPF64[i47 + 176 >> 3];
   HEAP32[i38 >> 2] = 32088;
   HEAP32[i38 + 12 >> 2] = 0;
   HEAP32[i38 + 16 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 16842752;
   HEAP32[i38 + 8 >> 2] = i47 + 8;
   i45 = i40 + 4 | 0;
   HEAP32[i45 + 0 >> 2] = 0;
   HEAP32[i45 + 4 >> 2] = 0;
   HEAP32[i45 + 8 >> 2] = 0;
   HEAP32[i45 + 12 >> 2] = 0;
   HEAP32[i40 >> 2] = 32232;
   HEAP32[i45 >> 2] = 33619968;
   HEAP32[i40 + 8 >> 2] = i39;
   __ZN2cv6divideEdRKNS_11_InputArrayERKNS_12_OutputArrayEi(d57, i38, i40, -1);
   break L6;
  } else {
   HEAP32[i25 >> 2] = 32088;
   HEAP32[i25 + 12 >> 2] = 0;
   HEAP32[i25 + 16 >> 2] = 0;
   HEAP32[i25 + 4 >> 2] = 16842752;
   HEAP32[i25 + 8 >> 2] = i47 + 8;
   HEAP32[i36 >> 2] = 32088;
   HEAP32[i36 + 12 >> 2] = 0;
   HEAP32[i36 + 16 >> 2] = 0;
   HEAP32[i36 + 4 >> 2] = 16842752;
   HEAP32[i36 + 8 >> 2] = i47 + 64;
   i45 = i37 + 4 | 0;
   HEAP32[i45 + 0 >> 2] = 0;
   HEAP32[i45 + 4 >> 2] = 0;
   HEAP32[i45 + 8 >> 2] = 0;
   HEAP32[i45 + 12 >> 2] = 0;
   HEAP32[i37 >> 2] = 32232;
   HEAP32[i45 >> 2] = 33619968;
   HEAP32[i37 + 8 >> 2] = i39;
   __ZN2cv6divideERKNS_11_InputArrayES2_RKNS_12_OutputArrayEdi(i25, i36, i37, +HEAPF64[i47 + 176 >> 3], -1);
   break L6;
  }
 case 124:
  {
   if (HEAP32[i47 + 80 >> 2] | 0) {
    HEAP32[i8 >> 2] = 32088;
    HEAP32[i8 + 12 >> 2] = 0;
    HEAP32[i8 + 16 >> 2] = 0;
    HEAP32[i8 + 4 >> 2] = 16842752;
    HEAP32[i8 + 8 >> 2] = i47 + 8;
    HEAP32[i9 >> 2] = 32088;
    HEAP32[i9 + 12 >> 2] = 0;
    HEAP32[i9 + 16 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 16842752;
    HEAP32[i9 + 8 >> 2] = i47 + 64;
    i45 = i10 + 4 | 0;
    HEAP32[i45 + 0 >> 2] = 0;
    HEAP32[i45 + 4 >> 2] = 0;
    HEAP32[i45 + 8 >> 2] = 0;
    HEAP32[i45 + 12 >> 2] = 0;
    HEAP32[i10 >> 2] = 32232;
    HEAP32[i45 >> 2] = 33619968;
    HEAP32[i10 + 8 >> 2] = i39;
    __ZN2cv10bitwise_orERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_(i8, i9, i10, __ZN2cv7noArrayEv() | 0);
    break L6;
   }
   if (!(HEAP32[i47 + 80 >> 2] | 0)) {
    HEAP32[i11 >> 2] = 32088;
    HEAP32[i11 + 12 >> 2] = 0;
    HEAP32[i11 + 16 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 16842752;
    HEAP32[i11 + 8 >> 2] = i47 + 8;
    HEAP32[i12 >> 2] = 32088;
    HEAP32[i12 + 4 >> 2] = -1056833530;
    HEAP32[i12 + 8 >> 2] = i47 + 192;
    HEAP32[i12 + 12 >> 2] = 1;
    HEAP32[i12 + 16 >> 2] = 4;
    i45 = i13 + 4 | 0;
    HEAP32[i45 + 0 >> 2] = 0;
    HEAP32[i45 + 4 >> 2] = 0;
    HEAP32[i45 + 8 >> 2] = 0;
    HEAP32[i45 + 12 >> 2] = 0;
    HEAP32[i13 >> 2] = 32232;
    HEAP32[i45 >> 2] = 33619968;
    HEAP32[i13 + 8 >> 2] = i39;
    __ZN2cv10bitwise_orERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_(i11, i12, i13, __ZN2cv7noArrayEv() | 0);
    break L6;
   } else switch (i2 | 0) {
   case 94:
    {
     i48 = 18;
     break L6;
    }
   case 109:
    {
     i48 = 25;
     break L6;
    }
   case 126:
    {
     i48 = 23;
     break L6;
    }
   case 77:
    {
     i48 = 28;
     break L6;
    }
   case 97:
    {
     i48 = 32;
     break L6;
    }
   default:
    {
     i48 = 36;
     break L6;
    }
   }
  }
 case 42:
  {
   HEAP32[i1 >> 2] = 32088;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 16842752;
   HEAP32[i1 + 8 >> 2] = i47 + 8;
   HEAP32[i3 >> 2] = 32088;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 16842752;
   HEAP32[i3 + 8 >> 2] = i47 + 64;
   i45 = i14 + 4 | 0;
   HEAP32[i45 + 0 >> 2] = 0;
   HEAP32[i45 + 4 >> 2] = 0;
   HEAP32[i45 + 8 >> 2] = 0;
   HEAP32[i45 + 12 >> 2] = 0;
   HEAP32[i14 >> 2] = 32232;
   HEAP32[i45 >> 2] = 33619968;
   HEAP32[i14 + 8 >> 2] = i39;
   __ZN2cv8multiplyERKNS_11_InputArrayES2_RKNS_12_OutputArrayEdi(i1, i3, i14, +HEAPF64[i47 + 176 >> 3], -1);
   break;
  }
 case 38:
  {
   if (HEAP32[i47 + 80 >> 2] | 0) {
    HEAP32[i41 >> 2] = 32088;
    HEAP32[i41 + 12 >> 2] = 0;
    HEAP32[i41 + 16 >> 2] = 0;
    HEAP32[i41 + 4 >> 2] = 16842752;
    HEAP32[i41 + 8 >> 2] = i47 + 8;
    HEAP32[i42 >> 2] = 32088;
    HEAP32[i42 + 12 >> 2] = 0;
    HEAP32[i42 + 16 >> 2] = 0;
    HEAP32[i42 + 4 >> 2] = 16842752;
    HEAP32[i42 + 8 >> 2] = i47 + 64;
    i45 = i4 + 4 | 0;
    HEAP32[i45 + 0 >> 2] = 0;
    HEAP32[i45 + 4 >> 2] = 0;
    HEAP32[i45 + 8 >> 2] = 0;
    HEAP32[i45 + 12 >> 2] = 0;
    HEAP32[i4 >> 2] = 32232;
    HEAP32[i45 >> 2] = 33619968;
    HEAP32[i4 + 8 >> 2] = i39;
    __ZN2cv11bitwise_andERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_(i41, i42, i4, __ZN2cv7noArrayEv() | 0);
    break L6;
   }
   if (!(HEAP32[i47 + 80 >> 2] | 0)) {
    HEAP32[i5 >> 2] = 32088;
    HEAP32[i5 + 12 >> 2] = 0;
    HEAP32[i5 + 16 >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 16842752;
    HEAP32[i5 + 8 >> 2] = i47 + 8;
    HEAP32[i6 >> 2] = 32088;
    HEAP32[i6 + 4 >> 2] = -1056833530;
    HEAP32[i6 + 8 >> 2] = i47 + 192;
    HEAP32[i6 + 12 >> 2] = 1;
    HEAP32[i6 + 16 >> 2] = 4;
    i45 = i7 + 4 | 0;
    HEAP32[i45 + 0 >> 2] = 0;
    HEAP32[i45 + 4 >> 2] = 0;
    HEAP32[i45 + 8 >> 2] = 0;
    HEAP32[i45 + 12 >> 2] = 0;
    HEAP32[i7 >> 2] = 32232;
    HEAP32[i45 >> 2] = 33619968;
    HEAP32[i7 + 8 >> 2] = i39;
    __ZN2cv11bitwise_andERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_(i5, i6, i7, __ZN2cv7noArrayEv() | 0);
   } else i48 = 36;
   break;
  }
 case 109:
  {
   i48 = 25;
   break;
  }
 case 126:
  {
   i48 = 23;
   break;
  }
 case 77:
  {
   i48 = 28;
   break;
  }
 case 97:
  {
   i48 = 32;
   break;
  }
 default:
  i48 = 36;
 } while (0);
 do if ((i48 | 0) == 18) {
  if (HEAP32[i47 + 80 >> 2] | 0) {
   HEAP32[i15 >> 2] = 32088;
   HEAP32[i15 + 12 >> 2] = 0;
   HEAP32[i15 + 16 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 16842752;
   HEAP32[i15 + 8 >> 2] = i47 + 8;
   HEAP32[i16 >> 2] = 32088;
   HEAP32[i16 + 12 >> 2] = 0;
   HEAP32[i16 + 16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 16842752;
   HEAP32[i16 + 8 >> 2] = i47 + 64;
   i45 = i17 + 4 | 0;
   HEAP32[i45 + 0 >> 2] = 0;
   HEAP32[i45 + 4 >> 2] = 0;
   HEAP32[i45 + 8 >> 2] = 0;
   HEAP32[i45 + 12 >> 2] = 0;
   HEAP32[i17 >> 2] = 32232;
   HEAP32[i45 >> 2] = 33619968;
   HEAP32[i17 + 8 >> 2] = i39;
   __ZN2cv11bitwise_xorERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_(i15, i16, i17, __ZN2cv7noArrayEv() | 0);
   break;
  }
  if (HEAP32[i47 + 80 >> 2] | 0) if ((i2 | 0) == 109) {
   i48 = 25;
   break;
  } else if ((i2 | 0) == 126) {
   i48 = 23;
   break;
  } else if ((i2 | 0) == 77) {
   i48 = 28;
   break;
  } else if ((i2 | 0) == 97) {
   i48 = 32;
   break;
  } else {
   i48 = 36;
   break;
  } else {
   HEAP32[i18 >> 2] = 32088;
   HEAP32[i18 + 12 >> 2] = 0;
   HEAP32[i18 + 16 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 16842752;
   HEAP32[i18 + 8 >> 2] = i47 + 8;
   HEAP32[i19 >> 2] = 32088;
   HEAP32[i19 + 4 >> 2] = -1056833530;
   HEAP32[i19 + 8 >> 2] = i47 + 192;
   HEAP32[i19 + 12 >> 2] = 1;
   HEAP32[i19 + 16 >> 2] = 4;
   i45 = i20 + 4 | 0;
   HEAP32[i45 + 0 >> 2] = 0;
   HEAP32[i45 + 4 >> 2] = 0;
   HEAP32[i45 + 8 >> 2] = 0;
   HEAP32[i45 + 12 >> 2] = 0;
   HEAP32[i20 >> 2] = 32232;
   HEAP32[i45 >> 2] = 33619968;
   HEAP32[i20 + 8 >> 2] = i39;
   __ZN2cv11bitwise_xorERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_(i18, i19, i20, __ZN2cv7noArrayEv() | 0);
   break;
  }
 } while (0);
 do if ((i48 | 0) == 23) if (!(HEAP32[i47 + 80 >> 2] | 0)) {
  HEAP32[i21 >> 2] = 32088;
  HEAP32[i21 + 12 >> 2] = 0;
  HEAP32[i21 + 16 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 16842752;
  HEAP32[i21 + 8 >> 2] = i47 + 8;
  i45 = i22 + 4 | 0;
  HEAP32[i45 + 0 >> 2] = 0;
  HEAP32[i45 + 4 >> 2] = 0;
  HEAP32[i45 + 8 >> 2] = 0;
  HEAP32[i45 + 12 >> 2] = 0;
  HEAP32[i22 >> 2] = 32232;
  HEAP32[i45 >> 2] = 33619968;
  HEAP32[i22 + 8 >> 2] = i39;
  __ZN2cv11bitwise_notERKNS_11_InputArrayERKNS_12_OutputArrayES2_(i21, i22, __ZN2cv7noArrayEv() | 0);
 } else i48 = 36; else if ((i48 | 0) == 25) if (!(HEAP32[i47 + 80 >> 2] | 0)) {
  HEAP32[i23 >> 2] = 32088;
  HEAP32[i23 + 12 >> 2] = 0;
  HEAP32[i23 + 16 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = 16842752;
  HEAP32[i23 + 8 >> 2] = i47 + 8;
  HEAP32[i24 >> 2] = 32088;
  HEAP32[i24 + 4 >> 2] = -1056833530;
  HEAP32[i24 + 8 >> 2] = i47 + 192;
  HEAP32[i24 + 12 >> 2] = 1;
  HEAP32[i24 + 16 >> 2] = 1;
  i45 = i26 + 4 | 0;
  HEAP32[i45 + 0 >> 2] = 0;
  HEAP32[i45 + 4 >> 2] = 0;
  HEAP32[i45 + 8 >> 2] = 0;
  HEAP32[i45 + 12 >> 2] = 0;
  HEAP32[i26 >> 2] = 32232;
  HEAP32[i45 >> 2] = 33619968;
  HEAP32[i26 + 8 >> 2] = i39;
  __ZN2cv3minERKNS_11_InputArrayES2_RKNS_12_OutputArrayE(i23, i24, i26);
  break;
 } else {
  __ZN2cv3minERKNS_3MatES2_RS0_(i47 + 8 | 0, i47 + 64 | 0, i39);
  break;
 } else if ((i48 | 0) == 28) {
  if (HEAP32[i47 + 80 >> 2] | 0) {
   __ZN2cv3maxERKNS_3MatES2_RS0_(i47 + 8 | 0, i47 + 64 | 0, i39);
   break;
  }
  if (!(HEAP32[i47 + 80 >> 2] | 0)) {
   HEAP32[i27 >> 2] = 32088;
   HEAP32[i27 + 12 >> 2] = 0;
   HEAP32[i27 + 16 >> 2] = 0;
   HEAP32[i27 + 4 >> 2] = 16842752;
   HEAP32[i27 + 8 >> 2] = i47 + 8;
   HEAP32[i28 >> 2] = 32088;
   HEAP32[i28 + 4 >> 2] = -1056833530;
   HEAP32[i28 + 8 >> 2] = i47 + 192;
   HEAP32[i28 + 12 >> 2] = 1;
   HEAP32[i28 + 16 >> 2] = 1;
   i45 = i29 + 4 | 0;
   HEAP32[i45 + 0 >> 2] = 0;
   HEAP32[i45 + 4 >> 2] = 0;
   HEAP32[i45 + 8 >> 2] = 0;
   HEAP32[i45 + 12 >> 2] = 0;
   HEAP32[i29 >> 2] = 32232;
   HEAP32[i45 >> 2] = 33619968;
   HEAP32[i29 + 8 >> 2] = i39;
   __ZN2cv3maxERKNS_11_InputArrayES2_RKNS_12_OutputArrayE(i27, i28, i29);
  } else i48 = 36;
 } else if ((i48 | 0) == 32) {
  if (HEAP32[i47 + 80 >> 2] | 0) {
   HEAP32[i30 >> 2] = 32088;
   HEAP32[i30 + 12 >> 2] = 0;
   HEAP32[i30 + 16 >> 2] = 0;
   HEAP32[i30 + 4 >> 2] = 16842752;
   HEAP32[i30 + 8 >> 2] = i47 + 8;
   HEAP32[i31 >> 2] = 32088;
   HEAP32[i31 + 12 >> 2] = 0;
   HEAP32[i31 + 16 >> 2] = 0;
   HEAP32[i31 + 4 >> 2] = 16842752;
   HEAP32[i31 + 8 >> 2] = i47 + 64;
   i45 = i32 + 4 | 0;
   HEAP32[i45 + 0 >> 2] = 0;
   HEAP32[i45 + 4 >> 2] = 0;
   HEAP32[i45 + 8 >> 2] = 0;
   HEAP32[i45 + 12 >> 2] = 0;
   HEAP32[i32 >> 2] = 32232;
   HEAP32[i45 >> 2] = 33619968;
   HEAP32[i32 + 8 >> 2] = i39;
   __ZN2cv7absdiffERKNS_11_InputArrayES2_RKNS_12_OutputArrayE(i30, i31, i32);
   break;
  }
  if (!(HEAP32[i47 + 80 >> 2] | 0)) {
   HEAP32[i33 >> 2] = 32088;
   HEAP32[i33 + 12 >> 2] = 0;
   HEAP32[i33 + 16 >> 2] = 0;
   HEAP32[i33 + 4 >> 2] = 16842752;
   HEAP32[i33 + 8 >> 2] = i47 + 8;
   HEAP32[i34 >> 2] = 32088;
   HEAP32[i34 + 4 >> 2] = -1056833530;
   HEAP32[i34 + 8 >> 2] = i47 + 192;
   HEAP32[i34 + 12 >> 2] = 1;
   HEAP32[i34 + 16 >> 2] = 4;
   i45 = i35 + 4 | 0;
   HEAP32[i45 + 0 >> 2] = 0;
   HEAP32[i45 + 4 >> 2] = 0;
   HEAP32[i45 + 8 >> 2] = 0;
   HEAP32[i45 + 12 >> 2] = 0;
   HEAP32[i35 >> 2] = 32232;
   HEAP32[i45 >> 2] = 33619968;
   HEAP32[i35 + 8 >> 2] = i39;
   __ZN2cv7absdiffERKNS_11_InputArrayES2_RKNS_12_OutputArrayE(i33, i34, i35);
  } else i48 = 36;
 } while (0);
 if ((i48 | 0) == 36) {
  HEAP32[i45 >> 2] = 0;
  HEAP32[i45 + 4 >> 2] = 0;
  i43 = (__ZN2cv6String8allocateEj(i45, 17) | 0) + 0 | 0;
  i2 = 33280 | 0;
  i44 = i43 + 17 | 0;
  do {
   HEAP8[i43 >> 0] = HEAP8[i2 >> 0] | 0;
   i43 = i43 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i43 | 0) < (i44 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i45, 33216, 33224, 1353);
  __ZN2cv6String10deallocateEv(i45);
 }
 if ((HEAP32[i39 + 16 >> 2] | 0) != (HEAP32[i50 + 16 >> 2] | 0)) {
  i45 = i46 + 4 | 0;
  HEAP32[i45 + 0 >> 2] = 0;
  HEAP32[i45 + 4 >> 2] = 0;
  HEAP32[i45 + 8 >> 2] = 0;
  HEAP32[i45 + 12 >> 2] = 0;
  HEAP32[i46 >> 2] = 32232;
  HEAP32[i45 >> 2] = 33619968;
  HEAP32[i46 + 8 >> 2] = i50;
  __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i39, i46, i49, 1.0, 0.0);
 }
 i2 = i52 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i45 = i1 + 12 | 0, i46 = HEAP32[i45 >> 2] | 0, HEAP32[i45 >> 2] = i46 + -1, (i46 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i52);
 HEAP32[i2 >> 2] = 0;
 i46 = i52 + 16 | 0;
 HEAP32[i46 + 0 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 HEAP32[i46 + 12 >> 2] = 0;
 if ((HEAP32[i54 >> 2] | 0) > 0) {
  i1 = HEAP32[i51 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i54 >> 2] | 0));
 }
 i1 = HEAP32[i53 >> 2] | 0;
 if ((i1 | 0) == (i55 | 0)) {
  STACKTOP = i56;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i56;
 return;
}

function __ZN4perf8TestBase13reportMetricsEb(i30, i29) {
 i30 = i30 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, d35 = 0.0, d36 = 0.0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 i33 = i34;
 i3 = i34 + 312 | 0;
 i2 = i34 + 300 | 0;
 i13 = i34 + 288 | 0;
 i22 = i34 + 276 | 0;
 i23 = i34 + 264 | 0;
 i24 = i34 + 252 | 0;
 i25 = i34 + 240 | 0;
 i26 = i34 + 228 | 0;
 i27 = i34 + 216 | 0;
 i28 = i34 + 208 | 0;
 i1 = i34 + 196 | 0;
 i4 = i34 + 184 | 0;
 i5 = i34 + 176 | 0;
 i6 = i34 + 164 | 0;
 i7 = i34 + 152 | 0;
 i8 = i34 + 144 | 0;
 i9 = i34 + 132 | 0;
 i10 = i34 + 120 | 0;
 i11 = i34 + 112 | 0;
 i12 = i34 + 100 | 0;
 i14 = i34 + 88 | 0;
 i15 = i34 + 80 | 0;
 i16 = i34 + 68 | 0;
 i17 = i34 + 56 | 0;
 i18 = i34 + 48 | 0;
 i19 = i34 + 36 | 0;
 i20 = i34 + 24 | 0;
 i21 = i34 + 16 | 0;
 i32 = __ZN4perf8TestBase11calcMetricsEv(i30) | 0;
 i31 = i32 + 72 | 0;
 if ((HEAP32[i31 >> 2] | 0) == 4) {
  if (!i29) {
   STACKTOP = i34;
   return;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, 175248, 13);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, 175264, 7);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i3, i2);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
  STACKTOP = i34;
  return;
 }
 if (i29) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, 175272, 7);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEi(i13, HEAP32[i32 >> 2] | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, 175280, 8);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEi(i22, HEAP32[i32 + 4 >> 2] | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i23, 175296, 4);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEi(i23, HEAP32[i31 >> 2] | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i24, 175304, 7);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEi(i24, HEAP32[i32 + 8 >> 2] | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i25, 175312, 8);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEi(i25, HEAP32[i32 + 12 >> 2] | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i25);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, 175328, 9);
  HEAPF64[tempDoublePtr >> 3] = +HEAPF64[i32 + 64 >> 3];
  HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  __ZN2cv6formatEPKcz(i28, 175344, i33);
  i22 = HEAP32[i28 >> 2] | 0;
  i22 = (i22 | 0) == 0 ? 169928 : i22;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i27, i22, _strlen(i22 | 0) | 0);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i26, i27);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i27);
  __ZN2cv6String10deallocateEv(i28);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i26);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 170072, 3);
  HEAPF64[tempDoublePtr >> 3] = +HEAPF64[i32 + 56 >> 3];
  HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  __ZN2cv6formatEPKcz(i5, 175344, i33);
  i22 = HEAP32[i5 >> 2] | 0;
  i22 = (i22 | 0) == 0 ? 169928 : i22;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i22, _strlen(i22 | 0) | 0);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i1, i4);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
  __ZN2cv6String10deallocateEv(i5);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, 175352, 6);
  HEAPF64[tempDoublePtr >> 3] = +HEAPF64[i32 + 48 >> 3];
  HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  __ZN2cv6formatEPKcz(i8, 175344, i33);
  i22 = HEAP32[i8 >> 2] | 0;
  i22 = (i22 | 0) == 0 ? 169928 : i22;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i22, _strlen(i22 | 0) | 0);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i6, i7);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
  __ZN2cv6String10deallocateEv(i8);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, 175360, 5);
  HEAPF64[tempDoublePtr >> 3] = +HEAPF64[i32 + 16 >> 3];
  HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  __ZN2cv6formatEPKcz(i11, 175344, i33);
  i22 = HEAP32[i11 >> 2] | 0;
  i22 = (i22 | 0) == 0 ? 169928 : i22;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i22, _strlen(i22 | 0) | 0);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i9, i10);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
  __ZN2cv6String10deallocateEv(i11);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, 175368, 7);
  HEAPF64[tempDoublePtr >> 3] = +HEAPF64[i32 + 24 >> 3];
  HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  __ZN2cv6formatEPKcz(i15, 175376, i33);
  i22 = HEAP32[i15 >> 2] | 0;
  i22 = (i22 | 0) == 0 ? 169928 : i22;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, i22, _strlen(i22 | 0) | 0);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i12, i14);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
  __ZN2cv6String10deallocateEv(i15);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i16, 175384, 4);
  HEAPF64[tempDoublePtr >> 3] = +HEAPF64[i32 + 32 >> 3];
  HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  __ZN2cv6formatEPKcz(i18, 175344, i33);
  i22 = HEAP32[i18 >> 2] | 0;
  i22 = (i22 | 0) == 0 ? 169928 : i22;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i22, _strlen(i22 | 0) | 0);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i16, i17);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
  __ZN2cv6String10deallocateEv(i18);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i19, 175392, 6);
  HEAPF64[tempDoublePtr >> 3] = +HEAPF64[i32 + 40 >> 3];
  HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  __ZN2cv6formatEPKcz(i21, 175344, i33);
  i22 = HEAP32[i21 >> 2] | 0;
  i22 = (i22 | 0) == 0 ? 169928 : i22;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i20, i22, _strlen(i22 | 0) | 0);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i19, i20);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
  __ZN2cv6String10deallocateEv(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
  STACKTOP = i34;
  return;
 }
 i2 = __ZNK7testing8UnitTest17current_test_infoEv(__ZN7testing8UnitTest11GetInstanceEv() | 0) | 0;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 do if (i1) if (!(HEAP8[i1 >> 0] & 1)) {
  i3 = i1 + 1 | 0;
  break;
 } else {
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  break;
 } else i3 = 0; while (0);
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 do if (i1) if (!(HEAP8[i1 >> 0] & 1)) {
  i1 = i1 + 1 | 0;
  break;
 } else {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  break;
 } else i1 = 0; while (0);
 if (i3) {
  HEAP32[i33 >> 2] = i3;
  _printf(175400, i33 | 0) | 0;
  _putchar(10) | 0;
  _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 }
 if (i1) {
  HEAP32[i33 >> 2] = i1;
  _printf(175424, i33 | 0) | 0;
  _putchar(10) | 0;
  _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 }
 i1 = HEAP32[i31 >> 2] | 0;
 if (!i1) {
  _printf(175448, i33 | 0) | 0;
  _putchar(10) | 0;
  i2 = HEAP32[_stdout >> 2] | 0;
  _fflush(i2 | 0) | 0;
 } else if ((i1 | 0) == 2) {
  _printf(175552, i33 | 0) | 0;
  _putchar(10) | 0;
  i2 = HEAP32[_stdout >> 2] | 0;
  _fflush(i2 | 0) | 0;
 } else if ((i1 | 0) == 1) {
  _printf(175512, i33 | 0) | 0;
  _putchar(10) | 0;
  i2 = HEAP32[_stdout >> 2] | 0;
  _fflush(i2 | 0) | 0;
 } else if ((i1 | 0) == 3) {
  _printf(175624, i33 | 0) | 0;
  _putchar(10) | 0;
  i2 = HEAP32[_stdout >> 2] | 0;
  _fflush(i2 | 0) | 0;
 } else {
  _printf(175672, i33 | 0) | 0;
  _putchar(10) | 0;
  i2 = HEAP32[_stdout >> 2] | 0;
  _fflush(i2 | 0) | 0;
 }
 HEAP32[i33 >> 2] = HEAP32[i32 >> 2];
 _printf(175704, i33 | 0) | 0;
 _putchar(10) | 0;
 _fflush(i2 | 0) | 0;
 HEAP32[i33 >> 2] = HEAP32[i32 + 4 >> 2];
 _printf(175728, i33 | 0) | 0;
 _putchar(10) | 0;
 _fflush(i2 | 0) | 0;
 i1 = HEAP32[i30 + 76 >> 2] | 0;
 if ((i1 | 0) != -1 ? (HEAP32[i31 >> 2] | 0) != 0 : 0) {
  HEAP32[i33 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i33 + 4 >> 2] = i1;
  _printf(175768, i33 | 0) | 0;
  _putchar(10) | 0;
  _fflush(i2 | 0) | 0;
 } else {
  HEAP32[i33 >> 2] = HEAP32[i32 + 8 >> 2];
  _printf(175752, i33 | 0) | 0;
  _putchar(10) | 0;
  _fflush(i2 | 0) | 0;
 }
 HEAP32[i33 >> 2] = HEAP32[i32 + 12 >> 2];
 _printf(175792, i33 | 0) | 0;
 _putchar(10) | 0;
 _fflush(i2 | 0) | 0;
 i1 = i32 + 64 | 0;
 HEAPF64[tempDoublePtr >> 3] = +HEAPF64[i1 >> 3];
 HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 _printf(175808, i33 | 0) | 0;
 _putchar(10) | 0;
 _fflush(i2 | 0) | 0;
 if (!(HEAP32[i32 + 8 >> 2] | 0)) {
  STACKTOP = i34;
  return;
 }
 d35 = +HEAPF64[i32 + 56 >> 3];
 d36 = d35 * 1.0e3 / +HEAPF64[i1 >> 3];
 HEAPF64[tempDoublePtr >> 3] = d35;
 HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 i22 = i33 + 8 | 0;
 HEAPF64[tempDoublePtr >> 3] = d36;
 HEAP32[i22 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 _printf(175832, i33 | 0) | 0;
 _putchar(10) | 0;
 _fflush(i2 | 0) | 0;
 d36 = +HEAPF64[i32 + 48 >> 3];
 d35 = d36 * 1.0e3 / +HEAPF64[i1 >> 3];
 HEAPF64[tempDoublePtr >> 3] = d36;
 HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 i22 = i33 + 8 | 0;
 HEAPF64[tempDoublePtr >> 3] = d35;
 HEAP32[i22 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 _printf(175864, i33 | 0) | 0;
 _putchar(10) | 0;
 _fflush(i2 | 0) | 0;
 i22 = i32 + 16 | 0;
 d35 = +HEAPF64[i22 >> 3];
 d36 = d35 * 1.0e3 / +HEAPF64[i1 >> 3];
 HEAPF64[tempDoublePtr >> 3] = d35;
 HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 i21 = i33 + 8 | 0;
 HEAPF64[tempDoublePtr >> 3] = d36;
 HEAP32[i21 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 _printf(175896, i33 | 0) | 0;
 _putchar(10) | 0;
 _fflush(i2 | 0) | 0;
 d36 = +HEAPF64[i32 + 24 >> 3];
 d35 = +HEAPF64[i22 >> 3] * 2.0;
 d35 = d35 * +_sinh(d36 * 3.0) * 1.0e3;
 d35 = d35 / +HEAPF64[i1 >> 3];
 HEAPF64[tempDoublePtr >> 3] = d36;
 HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 i22 = i33 + 8 | 0;
 HEAPF64[tempDoublePtr >> 3] = d35;
 HEAP32[i22 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 _printf(175928, i33 | 0) | 0;
 _putchar(10) | 0;
 _fflush(i2 | 0) | 0;
 d35 = +HEAPF64[i32 + 32 >> 3];
 d36 = d35 * 1.0e3 / +HEAPF64[i1 >> 3];
 HEAPF64[tempDoublePtr >> 3] = d35;
 HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 i22 = i33 + 8 | 0;
 HEAPF64[tempDoublePtr >> 3] = d36;
 HEAP32[i22 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 _printf(175984, i33 | 0) | 0;
 _putchar(10) | 0;
 _fflush(i2 | 0) | 0;
 d36 = +HEAPF64[i32 + 40 >> 3];
 d35 = d36 * 1.0e3 / +HEAPF64[i1 >> 3];
 HEAPF64[tempDoublePtr >> 3] = d36;
 HEAP32[i33 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 i22 = i33 + 8 | 0;
 HEAPF64[tempDoublePtr >> 3] = d35;
 HEAP32[i22 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 _printf(176016, i33 | 0) | 0;
 _putchar(10) | 0;
 _fflush(i2 | 0) | 0;
 STACKTOP = i34;
 return;
}

function __ZN2cvL15transpose_32sC8EPKhjPhjNS_5Size_IiEE(i16, i17, i14, i15, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i18 = STACKTOP;
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i13 + -4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i8 = i12 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i12 & -4;
  i11 = 0;
  do {
   i5 = i14 + (Math_imul(i11, i15) | 0) | 0;
   i4 = i14 + (Math_imul(i11 | 1, i15) | 0) | 0;
   i3 = i14 + (Math_imul(i11 | 2, i15) | 0) | 0;
   i2 = i14 + (Math_imul(i11 | 3, i15) | 0) | 0;
   if (i9) i7 = 0; else {
    i7 = i11 << 5;
    i6 = 0;
    do {
     i26 = (Math_imul(i6, i17) | 0) + i7 | 0;
     i30 = i16 + i26 | 0;
     i23 = i6 | 1;
     i24 = (Math_imul(i23, i17) | 0) + i7 | 0;
     i29 = i16 + i24 | 0;
     i21 = i6 | 2;
     i22 = (Math_imul(i21, i17) | 0) + i7 | 0;
     i28 = i16 + i22 | 0;
     i19 = i6 | 3;
     i20 = (Math_imul(i19, i17) | 0) + i7 | 0;
     i27 = i16 + i20 | 0;
     i25 = i5 + (i6 << 5) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i30 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i30 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i30 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i30 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i30 + 28 >> 2];
     i25 = i5 + (i23 << 5) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i29 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i29 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i29 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i29 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i29 + 28 >> 2];
     i25 = i5 + (i21 << 5) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i28 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i28 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i28 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i28 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i28 + 28 >> 2];
     i25 = i5 + (i19 << 5) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i27 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i27 + 28 >> 2];
     i25 = i4 + (i6 << 5) | 0;
     i27 = i16 + (i26 + 32) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i27 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i27 + 28 >> 2];
     i25 = i4 + (i23 << 5) | 0;
     i27 = i16 + (i24 + 32) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i27 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i27 + 28 >> 2];
     i25 = i4 + (i21 << 5) | 0;
     i27 = i16 + (i22 + 32) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i27 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i27 + 28 >> 2];
     i25 = i4 + (i19 << 5) | 0;
     i27 = i16 + (i20 + 32) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i27 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i27 + 28 >> 2];
     i25 = i3 + (i6 << 5) | 0;
     i27 = i16 + (i26 + 64) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i27 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i27 + 28 >> 2];
     i25 = i3 + (i23 << 5) | 0;
     i27 = i16 + (i24 + 64) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i27 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i27 + 28 >> 2];
     i25 = i3 + (i21 << 5) | 0;
     i27 = i16 + (i22 + 64) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i27 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i27 + 28 >> 2];
     i25 = i3 + (i19 << 5) | 0;
     i27 = i16 + (i20 + 64) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i27 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i27 + 28 >> 2];
     i25 = i2 + (i6 << 5) | 0;
     i26 = i16 + (i26 + 96) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i26 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i26 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i26 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i26 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i26 + 28 >> 2];
     i23 = i2 + (i23 << 5) | 0;
     i24 = i16 + (i24 + 96) | 0;
     HEAP32[i23 + 0 >> 2] = HEAP32[i24 + 0 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     HEAP32[i23 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
     HEAP32[i23 + 16 >> 2] = HEAP32[i24 + 16 >> 2];
     HEAP32[i23 + 20 >> 2] = HEAP32[i24 + 20 >> 2];
     HEAP32[i23 + 24 >> 2] = HEAP32[i24 + 24 >> 2];
     HEAP32[i23 + 28 >> 2] = HEAP32[i24 + 28 >> 2];
     i21 = i2 + (i21 << 5) | 0;
     i22 = i16 + (i22 + 96) | 0;
     HEAP32[i21 + 0 >> 2] = HEAP32[i22 + 0 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
     HEAP32[i21 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
     HEAP32[i21 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
     HEAP32[i21 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
     HEAP32[i21 + 24 >> 2] = HEAP32[i22 + 24 >> 2];
     HEAP32[i21 + 28 >> 2] = HEAP32[i22 + 28 >> 2];
     i19 = i2 + (i19 << 5) | 0;
     i20 = i16 + (i20 + 96) | 0;
     HEAP32[i19 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i19 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i19 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i19 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i19 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i19 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i8 | 0));
    i7 = i10;
   }
   if ((i7 | 0) < (i12 | 0)) {
    i6 = i11 << 5;
    do {
     i21 = (Math_imul(i7, i17) | 0) + i6 | 0;
     i20 = i16 + i21 | 0;
     i22 = i5 + (i7 << 5) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i22 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i22 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i22 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i22 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
     i22 = i4 + (i7 << 5) | 0;
     i20 = i16 + (i21 + 32) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i22 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i22 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i22 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i22 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
     i22 = i3 + (i7 << 5) | 0;
     i20 = i16 + (i21 + 64) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i22 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i22 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i22 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i22 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
     i22 = i2 + (i7 << 5) | 0;
     i21 = i16 + (i21 + 96) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
     HEAP32[i22 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
     HEAP32[i22 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
     HEAP32[i22 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
     HEAP32[i22 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i12 | 0));
   }
   i11 = i11 + 4 | 0;
  } while ((i11 | 0) <= (i1 | 0));
  i1 = i13 & -4;
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i18;
  return;
 }
 i5 = i12 + -4 | 0;
 i6 = (i5 | 0) < 0;
 i7 = i12 & -4;
 do {
  i4 = i14 + (Math_imul(i1, i15) | 0) | 0;
  if (i6) i2 = 0; else {
   i2 = i1 << 5;
   i3 = 0;
   do {
    i10 = i16 + ((Math_imul(i3, i17) | 0) + i2) | 0;
    i11 = i3 | 1;
    i8 = i16 + ((Math_imul(i11, i17) | 0) + i2) | 0;
    i20 = i3 | 2;
    i19 = i16 + ((Math_imul(i20, i17) | 0) + i2) | 0;
    i22 = i3 | 3;
    i21 = i16 + ((Math_imul(i22, i17) | 0) + i2) | 0;
    i9 = i4 + (i3 << 5) | 0;
    HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
    HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
    HEAP32[i9 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
    HEAP32[i9 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
    i11 = i4 + (i11 << 5) | 0;
    HEAP32[i11 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i11 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    HEAP32[i11 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
    HEAP32[i11 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
    HEAP32[i11 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
    i20 = i4 + (i20 << 5) | 0;
    HEAP32[i20 + 0 >> 2] = HEAP32[i19 + 0 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i20 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    HEAP32[i20 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
    HEAP32[i20 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
    HEAP32[i20 + 24 >> 2] = HEAP32[i19 + 24 >> 2];
    HEAP32[i20 + 28 >> 2] = HEAP32[i19 + 28 >> 2];
    i22 = i4 + (i22 << 5) | 0;
    HEAP32[i22 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
    HEAP32[i22 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
    HEAP32[i22 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
    HEAP32[i22 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
    HEAP32[i22 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i5 | 0));
   i2 = i7;
  }
  if ((i2 | 0) < (i12 | 0)) {
   i3 = i1 << 5;
   do {
    i21 = i16 + ((Math_imul(i2, i17) | 0) + i3) | 0;
    i22 = i4 + (i2 << 5) | 0;
    HEAP32[i22 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
    HEAP32[i22 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
    HEAP32[i22 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
    HEAP32[i22 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
    HEAP32[i22 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i12 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i18;
 return;
}

function __ZN2cvL17GEMMSingleMul_32fEPKfjS1_jS1_jPfjNS_5Size_IiEES4_ddi(i18, i11, i34, i16, i29, i3, i28, i4, i1, i2, d42, d43, i8) {
 i18 = i18 | 0;
 i11 = i11 | 0;
 i34 = i34 | 0;
 i16 = i16 | 0;
 i29 = i29 | 0;
 i3 = i3 | 0;
 i28 = i28 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d42 = +d42;
 d43 = +d43;
 i8 = i8 | 0;
 var d5 = 0.0, d6 = 0.0, i7 = 0, d9 = 0.0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, d17 = 0.0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i44 = 0, i45 = 0, d46 = 0.0;
 i45 = STACKTOP;
 STACKTOP = STACKTOP + 3232 | 0;
 i44 = i45 + 2160 | 0;
 i26 = i45 + 1096 | 0;
 i27 = i45;
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i39 = HEAP32[i2 >> 2] | 0;
 i38 = HEAP32[i2 + 4 >> 2] | 0;
 i40 = i44 + 8 | 0;
 HEAP32[i44 >> 2] = i40;
 i41 = i44 + 4 | 0;
 HEAP32[i41 >> 2] = 264;
 i10 = i11 >>> 2;
 i33 = i16 >>> 2;
 i2 = i3 >>> 2;
 i36 = i4 >>> 2;
 if (!i29) {
  i37 = 0;
  i35 = 0;
 } else {
  i35 = (i8 & 4 | 0) == 0;
  i37 = i35 ? i2 : 1;
  i35 = i35 ? 1 : i2;
 }
 do if (i8 & 1) if (i11 >>> 0 > 7 & (i1 | 0) > 1) if (i1 >>> 0 > 264) {
  i30 = __Znaj(i1 >>> 0 > 1073741823 ? -1 : i1 << 2) | 0;
  HEAP32[i44 >> 2] = i30;
  HEAP32[i41 >> 2] = i1;
  i4 = i1;
  i2 = i30;
  i31 = 1;
  i32 = i10;
  i7 = i1;
  break;
 } else {
  HEAP32[i41 >> 2] = i1;
  i4 = i1;
  i2 = i40;
  i30 = i40;
  i31 = 1;
  i32 = i10;
  i7 = i1;
  break;
 } else {
  i4 = 264;
  i2 = i40;
  i30 = 0;
  i31 = 1;
  i32 = i10;
  i7 = i1;
 } else {
  i4 = 264;
  i2 = i40;
  i30 = 0;
  i31 = i10;
  i32 = 1;
 } while (0);
 L11 : do if ((i7 | 0) == 1) {
  i23 = i26 + 8 | 0;
  HEAP32[i26 >> 2] = i23;
  i22 = i26 + 4 | 0;
  HEAP32[i22 >> 2] = 264;
  if (i11 >>> 0 > 7 & (i1 | 0) > 1) {
   if (i4 >>> 0 < i38 >>> 0) {
    if ((i2 | 0) != (i40 | 0)) {
     __ZdaPv(i2);
     HEAP32[i44 >> 2] = i40;
     HEAP32[i41 >> 2] = 264;
    }
    if (i38 >>> 0 > 264) {
     i2 = __Znaj(i38 >>> 0 > 1073741823 ? -1 : i38 << 2) | 0;
     HEAP32[i44 >> 2] = i2;
     HEAP32[i41 >> 2] = i38;
    } else i2 = i40;
   } else HEAP32[i41 >> 2] = i38;
   if ((i38 | 0) > 0) {
    i1 = 0;
    do {
     HEAPF32[i2 + (i1 << 2) >> 2] = Math_fround(HEAPF32[i18 + ((Math_imul(i1, i10) | 0) << 2) >> 2]);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i38 | 0));
    i18 = i2;
   } else i18 = i2;
  }
  if (i16 >>> 0 > 7) {
   if ((HEAP32[i22 >> 2] | 0) >>> 0 < i39 >>> 0) {
    i1 = HEAP32[i26 >> 2] | 0;
    if ((i1 | 0) != (i23 | 0)) {
     if (i1) __ZdaPv(i1);
     HEAP32[i26 >> 2] = i23;
     HEAP32[i22 >> 2] = 264;
    }
    if (i39 >>> 0 > 264) {
     i2 = __Znaj(i39 >>> 0 > 1073741823 ? -1 : i39 << 2) | 0;
     HEAP32[i26 >> 2] = i2;
     HEAP32[i22 >> 2] = i39;
    } else i2 = i23;
   } else {
    HEAP32[i22 >> 2] = i39;
    i2 = HEAP32[i26 >> 2] | 0;
   }
   if ((i39 | 0) > 0) {
    i1 = 0;
    do {
     HEAPF32[i2 + (i1 << 2) >> 2] = Math_fround(HEAPF32[i34 + ((Math_imul(i1, i33) | 0) << 2) >> 2]);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i39 | 0));
   }
  } else i2 = i34;
  if ((i38 | 0) > 0) {
   i12 = i39 + -2 | 0;
   i13 = (i12 | 0) < 0;
   i14 = i35 << 1;
   i16 = (i12 | 0) > 1 ? i12 >>> 1 : 0;
   i15 = Math_imul(i14, i16) | 0;
   i16 = (i16 << 1) + 2 | 0;
   i7 = i28;
   i10 = i29;
   i11 = 0;
   i8 = i29 + (i14 << 2) | 0;
   while (1) {
    d9 = +Math_fround(HEAPF32[i18 + (i11 << 2) >> 2]) * d42;
    if (i13) {
     i4 = i10;
     i3 = 0;
    } else {
     i4 = i10;
     i1 = 0;
     while (1) {
      d5 = d9 * +Math_fround(HEAPF32[i2 + (i1 << 2) >> 2]);
      i3 = i1 | 1;
      d6 = d9 * +Math_fround(HEAPF32[i2 + (i3 << 2) >> 2]);
      if (!i4) {
       HEAPF32[i7 + (i1 << 2) >> 2] = Math_fround(d5);
       HEAPF32[i7 + (i3 << 2) >> 2] = Math_fround(d6);
      } else {
       HEAPF32[i7 + (i1 << 2) >> 2] = Math_fround(d5 + +Math_fround(HEAPF32[i4 >> 2]) * d43);
       HEAPF32[i7 + (i3 << 2) >> 2] = Math_fround(d6 + +Math_fround(HEAPF32[i4 + (i35 << 2) >> 2]) * d43);
      }
      i1 = i1 + 2 | 0;
      if ((i1 | 0) > (i12 | 0)) break; else i4 = i4 + (i14 << 2) | 0;
     }
     i4 = i8 + (i15 << 2) | 0;
     i3 = i16;
    }
    if ((i3 | 0) < (i39 | 0)) while (1) {
     d5 = d9 * +Math_fround(HEAPF32[i2 + (i3 << 2) >> 2]);
     if (!i4) HEAPF32[i7 + (i3 << 2) >> 2] = Math_fround(d5); else HEAPF32[i7 + (i3 << 2) >> 2] = Math_fround(d5 + +Math_fround(HEAPF32[i4 >> 2]) * d43);
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i39 | 0)) break; else i4 = i4 + (i35 << 2) | 0;
    }
    i11 = i11 + 1 | 0;
    if ((i11 | 0) == (i38 | 0)) break; else {
     i7 = i7 + (i36 << 2) | 0;
     i10 = i10 + (i37 << 2) | 0;
     i8 = i8 + (i37 << 2) | 0;
    }
   }
  }
  i1 = HEAP32[i26 >> 2] | 0;
  if ((i1 | 0) != (i23 | 0)) {
   if (i1) __ZdaPv(i1);
   HEAP32[i26 >> 2] = i23;
   HEAP32[i22 >> 2] = 264;
  }
 } else {
  if (i8 & 2) {
   if ((i38 | 0) <= 0) break;
   i24 = (i30 | 0) == 0;
   i1 = (i39 | 0) > 0;
   i12 = i7 + -4 | 0;
   i25 = (i12 | 0) < 0;
   i2 = i7 & -4;
   i13 = i24 | (i7 | 0) < 1;
   i14 = i28;
   i19 = i29;
   i15 = 0;
   while (1) {
    if (i13) i23 = i24 ? i18 : i30; else {
     i4 = 0;
     do {
      HEAPF32[i30 + (i4 << 2) >> 2] = Math_fround(HEAPF32[i18 + ((Math_imul(i4, i32) | 0) << 2) >> 2]);
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i7 | 0));
     i23 = i30;
    }
    if (i1) {
     i22 = i34;
     i21 = i19;
     i20 = 0;
     while (1) {
      if (i25) {
       i16 = 0;
       d6 = 0.0;
       d9 = 0.0;
       d5 = 0.0;
       d17 = 0.0;
      } else {
       i16 = 0;
       d6 = 0.0;
       d9 = 0.0;
       d5 = 0.0;
       d17 = 0.0;
       do {
        d46 = +Math_fround(HEAPF32[i23 + (i16 << 2) >> 2]);
        d6 = d6 + d46 * +Math_fround(HEAPF32[i22 + (i16 << 2) >> 2]);
        i26 = i16 | 1;
        d46 = +Math_fround(HEAPF32[i23 + (i26 << 2) >> 2]);
        d9 = d9 + d46 * +Math_fround(HEAPF32[i22 + (i26 << 2) >> 2]);
        i26 = i16 | 2;
        d46 = +Math_fround(HEAPF32[i23 + (i26 << 2) >> 2]);
        d5 = d5 + d46 * +Math_fround(HEAPF32[i22 + (i26 << 2) >> 2]);
        i26 = i16 | 3;
        d46 = +Math_fround(HEAPF32[i23 + (i26 << 2) >> 2]);
        d17 = d17 + d46 * +Math_fround(HEAPF32[i22 + (i26 << 2) >> 2]);
        i16 = i16 + 4 | 0;
       } while ((i16 | 0) <= (i12 | 0));
       i16 = i2;
      }
      if ((i16 | 0) < (i7 | 0)) do {
       d46 = +Math_fround(HEAPF32[i23 + (i16 << 2) >> 2]);
       d6 = d6 + d46 * +Math_fround(HEAPF32[i22 + (i16 << 2) >> 2]);
       i16 = i16 + 1 | 0;
      } while ((i16 | 0) != (i7 | 0));
      d6 = (d17 + (d5 + (d9 + d6))) * d42;
      if (!i21) HEAPF32[i14 + (i20 << 2) >> 2] = Math_fround(d6); else HEAPF32[i14 + (i20 << 2) >> 2] = Math_fround(d6 + +Math_fround(HEAPF32[i21 >> 2]) * d43);
      i20 = i20 + 1 | 0;
      if ((i20 | 0) == (i39 | 0)) break; else {
       i22 = i22 + (i33 << 2) | 0;
       i21 = i21 + (i35 << 2) | 0;
      }
     }
    }
    i15 = i15 + 1 | 0;
    if ((i15 | 0) == (i38 | 0)) break L11; else {
     i14 = i14 + (i36 << 2) | 0;
     i18 = i18 + (i31 << 2) | 0;
     i19 = i19 + (i37 << 2) | 0;
    }
   }
  }
  if (i39 << 2 >>> 0 < 1601) {
   if ((i38 | 0) <= 0) break;
   i10 = (i30 | 0) == 0;
   i3 = i39 + -4 | 0;
   i26 = (i3 | 0) < 0;
   i13 = (i7 | 0) > 0;
   i2 = i35 << 2;
   i25 = i35 << 1;
   i12 = i35 * 3 | 0;
   i20 = i3 >>> 2;
   i1 = (i20 << 2) + 4 | 0;
   i24 = i10 | i13 ^ 1;
   i11 = i28;
   i19 = i29;
   i27 = 0;
   i20 = i29 + (Math_imul(i35, (i20 << 4) + 16 | 0) | 0) | 0;
   while (1) {
    if (i24) i21 = i10 ? i18 : i30; else {
     i4 = 0;
     do {
      HEAPF32[i30 + (i4 << 2) >> 2] = Math_fround(HEAPF32[i18 + ((Math_imul(i4, i32) | 0) << 2) >> 2]);
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i7 | 0));
     i21 = i30;
    }
    if (i26) {
     i4 = i19;
     i8 = 0;
    } else {
     i23 = i19;
     i22 = 0;
     while (1) {
      if (i13) {
       i16 = i34 + (i22 << 2) | 0;
       i15 = 0;
       d9 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d17 = 0.0;
       while (1) {
        d46 = +Math_fround(HEAPF32[i21 + (i15 << 2) >> 2]);
        d9 = d9 + d46 * +Math_fround(HEAPF32[i16 >> 2]);
        d5 = d5 + d46 * +Math_fround(HEAPF32[i16 + 4 >> 2]);
        d6 = d6 + d46 * +Math_fround(HEAPF32[i16 + 8 >> 2]);
        d17 = d17 + d46 * +Math_fround(HEAPF32[i16 + 12 >> 2]);
        i15 = i15 + 1 | 0;
        if ((i15 | 0) == (i7 | 0)) break; else i16 = i16 + (i33 << 2) | 0;
       }
      } else {
       d9 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d17 = 0.0;
      }
      d9 = d9 * d42;
      if (!i23) {
       HEAPF32[i11 + (i22 << 2) >> 2] = Math_fround(d9);
       HEAPF32[i11 + ((i22 | 1) << 2) >> 2] = Math_fround(d5 * d42);
       HEAPF32[i11 + ((i22 | 2) << 2) >> 2] = Math_fround(d6 * d42);
       HEAPF32[i11 + ((i22 | 3) << 2) >> 2] = Math_fround(d17 * d42);
      } else {
       HEAPF32[i11 + (i22 << 2) >> 2] = Math_fround(d9 + +Math_fround(HEAPF32[i23 >> 2]) * d43);
       HEAPF32[i11 + ((i22 | 1) << 2) >> 2] = Math_fround(d5 * d42 + +Math_fround(HEAPF32[i23 + (i35 << 2) >> 2]) * d43);
       HEAPF32[i11 + ((i22 | 2) << 2) >> 2] = Math_fround(d6 * d42 + +Math_fround(HEAPF32[i23 + (i25 << 2) >> 2]) * d43);
       HEAPF32[i11 + ((i22 | 3) << 2) >> 2] = Math_fround(d17 * d42 + +Math_fround(HEAPF32[i23 + (i12 << 2) >> 2]) * d43);
      }
      i22 = i22 + 4 | 0;
      if ((i22 | 0) > (i3 | 0)) {
       i4 = i20;
       i8 = i1;
       break;
      } else i23 = i23 + (i2 << 2) | 0;
     }
    }
    if ((i8 | 0) < (i39 | 0)) while (1) {
     if (i13) {
      i16 = i34 + (i8 << 2) | 0;
      i15 = 0;
      d6 = 0.0;
      while (1) {
       d5 = +Math_fround(HEAPF32[i21 + (i15 << 2) >> 2]);
       d6 = d6 + d5 * +Math_fround(HEAPF32[i16 >> 2]);
       i15 = i15 + 1 | 0;
       if ((i15 | 0) == (i7 | 0)) break; else i16 = i16 + (i33 << 2) | 0;
      }
     } else d6 = 0.0;
     d6 = d6 * d42;
     if (!i4) HEAPF32[i11 + (i8 << 2) >> 2] = Math_fround(d6); else HEAPF32[i11 + (i8 << 2) >> 2] = Math_fround(d6 + +Math_fround(HEAPF32[i4 >> 2]) * d43);
     i8 = i8 + 1 | 0;
     if ((i8 | 0) == (i39 | 0)) break; else i4 = i4 + (i35 << 2) | 0;
    }
    i27 = i27 + 1 | 0;
    if ((i27 | 0) == (i38 | 0)) break L11; else {
     i11 = i11 + (i36 << 2) | 0;
     i18 = i18 + (i31 << 2) | 0;
     i19 = i19 + (i37 << 2) | 0;
     i20 = i20 + (i37 << 2) | 0;
    }
   }
  }
  i3 = i27 + 8 | 0;
  HEAP32[i27 >> 2] = i3;
  i10 = i27 + 4 | 0;
  HEAP32[i10 >> 2] = 136;
  if (i39 >>> 0 > 136) {
   i25 = __Znaj(i39 >>> 0 > 536870911 ? -1 : i39 << 3) | 0;
   HEAP32[i27 >> 2] = i25;
  } else i25 = i3;
  HEAP32[i10 >> 2] = i39;
  if ((i38 | 0) > 0) {
   i11 = (i30 | 0) == 0;
   i19 = (i39 | 0) > 0;
   i20 = (i7 | 0) > 0;
   i21 = i39 + -4 | 0;
   i22 = (i21 | 0) < 0;
   i23 = i39 << 3;
   i24 = i39 & -4;
   i26 = i11 | i20 ^ 1;
   i13 = i28;
   i12 = i29;
   i2 = 0;
   while (1) {
    if (i26) i14 = i11 ? i18 : i30; else {
     i4 = 0;
     do {
      HEAPF32[i30 + (i4 << 2) >> 2] = Math_fround(HEAPF32[i18 + ((Math_imul(i4, i32) | 0) << 2) >> 2]);
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i7 | 0));
     i14 = i30;
    }
    if (i19) _memset(i25 | 0, 0, i23 | 0) | 0;
    if (i20) {
     i15 = i34;
     i1 = 0;
     while (1) {
      d9 = +Math_fround(HEAPF32[i14 + (i1 << 2) >> 2]);
      if (i22) i16 = 0; else {
       i16 = 0;
       do {
        i8 = i25 + (i16 << 3) | 0;
        d5 = +HEAPF64[i8 >> 3] + d9 * +Math_fround(HEAPF32[i15 + (i16 << 2) >> 2]);
        i4 = i16 | 1;
        i28 = i25 + (i4 << 3) | 0;
        d6 = +HEAPF64[i28 >> 3] + d9 * +Math_fround(HEAPF32[i15 + (i4 << 2) >> 2]);
        HEAPF64[i8 >> 3] = d5;
        HEAPF64[i28 >> 3] = d6;
        i28 = i16 | 2;
        i8 = i25 + (i28 << 3) | 0;
        d6 = +HEAPF64[i8 >> 3] + d9 * +Math_fround(HEAPF32[i15 + (i28 << 2) >> 2]);
        i28 = i16 | 3;
        i4 = i25 + (i28 << 3) | 0;
        d5 = +HEAPF64[i4 >> 3] + d9 * +Math_fround(HEAPF32[i15 + (i28 << 2) >> 2]);
        HEAPF64[i8 >> 3] = d6;
        HEAPF64[i4 >> 3] = d5;
        i16 = i16 + 4 | 0;
       } while ((i16 | 0) <= (i21 | 0));
       i16 = i24;
      }
      if ((i16 | 0) < (i39 | 0)) do {
       d5 = d9 * +Math_fround(HEAPF32[i15 + (i16 << 2) >> 2]);
       i4 = i25 + (i16 << 3) | 0;
       HEAPF64[i4 >> 3] = +HEAPF64[i4 >> 3] + d5;
       i16 = i16 + 1 | 0;
      } while ((i16 | 0) != (i39 | 0));
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i7 | 0)) break; else i15 = i15 + (i33 << 2) | 0;
     }
    }
    if (!i12) {
     if (i19) {
      i4 = 0;
      do {
       HEAPF32[i13 + (i4 << 2) >> 2] = Math_fround(+HEAPF64[i25 + (i4 << 3) >> 3] * d42);
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i39 | 0));
     }
    } else if (i19) {
     i4 = i12;
     i8 = 0;
     while (1) {
      HEAPF32[i13 + (i8 << 2) >> 2] = Math_fround(+HEAPF64[i25 + (i8 << 3) >> 3] * d42 + +Math_fround(HEAPF32[i4 >> 2]) * d43);
      i8 = i8 + 1 | 0;
      if ((i8 | 0) == (i39 | 0)) break; else i4 = i4 + (i35 << 2) | 0;
     }
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i38 | 0)) break; else {
     i13 = i13 + (i36 << 2) | 0;
     i18 = i18 + (i31 << 2) | 0;
     i12 = i12 + (i37 << 2) | 0;
    }
   }
  }
  if ((i25 | 0) != (i3 | 0)) {
   __ZdaPv(i25);
   HEAP32[i27 >> 2] = i3;
   HEAP32[i10 >> 2] = 136;
  }
 } while (0);
 i1 = HEAP32[i44 >> 2] | 0;
 if ((i1 | 0) == (i40 | 0)) {
  STACKTOP = i45;
  return;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i44 >> 2] = i40;
 HEAP32[i41 >> 2] = 264;
 STACKTOP = i45;
 return;
}

function __ZN7testing8internal24XmlUnitTestResultPrinter17OutputXmlTestInfoEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEEPKcRKNS_8TestInfoE(i42, i15, i17) {
 i42 = i42 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0, i45 = 0;
 i45 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 i40 = i45 + 252 | 0;
 i1 = i45 + 240 | 0;
 i3 = i45 + 228 | 0;
 i4 = i45 + 216 | 0;
 i5 = i45 + 204 | 0;
 i9 = i45 + 192 | 0;
 i10 = i45 + 180 | 0;
 i11 = i45 + 168 | 0;
 i12 = i45 + 156 | 0;
 i13 = i45 + 144 | 0;
 i14 = i45 + 132 | 0;
 i6 = i45 + 120 | 0;
 i7 = i45 + 108 | 0;
 i16 = i45 + 96 | 0;
 i41 = i45 + 84 | 0;
 i43 = i45 + 72 | 0;
 i34 = i45 + 60 | 0;
 i35 = i45 + 48 | 0;
 i36 = i45 + 36 | 0;
 i39 = i45 + 24 | 0;
 i37 = i45 + 12 | 0;
 i38 = i45;
 i8 = i17 + 48 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i40, 163312, 8);
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i42, 163328, 13) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 163344, 4);
 i2 = i17 + 12 | 0;
 if (!(HEAP8[i2 >> 0] & 1)) i2 = i2 + 1 | 0; else i2 = HEAP32[i17 + 20 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i2, _strlen(i2 | 0) | 0);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i42, i40, i1, i3);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 i2 = i17 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (i1) {
  if ((HEAP8[i1 >> 0] & 1) != 0 ? (HEAP32[i1 + 8 >> 2] | 0) == 0 : 0) break;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, 163352, 11);
  i2 = HEAP32[i2 >> 2] | 0;
  do if (i2) if (!(HEAP8[i2 >> 0] & 1)) {
   i2 = i2 + 1 | 0;
   break;
  } else {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   break;
  } else i2 = 0; while (0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i2, _strlen(i2 | 0) | 0);
  __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i42, i40, i4, i5);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 } while (0);
 i2 = i17 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (i1) {
  if ((HEAP8[i1 >> 0] & 1) != 0 ? (HEAP32[i1 + 8 >> 2] | 0) == 0 : 0) break;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, 163368, 10);
  i2 = HEAP32[i2 >> 2] | 0;
  do if (i2) if (!(HEAP8[i2 >> 0] & 1)) {
   i2 = i2 + 1 | 0;
   break;
  } else {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   break;
  } else i2 = 0; while (0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i2, _strlen(i2 | 0) | 0);
  __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i42, i40, i9, i10);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 } while (0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, 163384, 6);
 i1 = (HEAP8[i17 + 36 >> 0] | 0) != 0 ? 163392 : 163400;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i1, _strlen(i1 | 0) | 0);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i42, i40, i11, i12);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, 163408, 4);
 i1 = i17 + 80 | 0;
 __ZN7testing8internal27FormatTimeInMillisAsSecondsEx(i14, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i42, i40, i13, i14);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, 163416, 9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i15, _strlen(i15 | 0) | 0);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i42, i40, i6, i7);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZN7testing8internal24XmlUnitTestResultPrinter29TestPropertiesAsXmlAttributesERKNS_10TestResultE(i16, i8);
 i1 = HEAP8[i16 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i16 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i16 + 8 >> 2] | 0;
  i1 = HEAP32[i16 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i42, i2, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16);
 i32 = i17 + 56 | 0;
 i33 = i17 + 52 | 0;
 i14 = HEAP32[i33 >> 2] | 0;
 i5 = (HEAP32[i32 >> 2] | 0) - i14 | 0;
 if ((i5 | 0) > 0) {
  i30 = i17 + 52 | 0;
  i31 = i41 + 1 | 0;
  i1 = i34 + 1 | 0;
  i2 = i43 + 1 | 0;
  i3 = i35 + 1 | 0;
  i4 = i37 + 1 | 0;
  i9 = i39 + 1 | 0;
  i11 = i39 + 8 | 0;
  i10 = i39 + 4 | 0;
  i19 = i38 + 1 | 0;
  i20 = i38 + 8 | 0;
  i21 = i37 + 4 | 0;
  i22 = i37 + 8 | 0;
  i23 = i41 + 4 | 0;
  i24 = i41 + 8 | 0;
  i25 = i35 + 8 | 0;
  i26 = i35 + 4 | 0;
  i27 = i43 + 8 | 0;
  i28 = i34 + 4 | 0;
  i29 = i34 + 8 | 0;
  i15 = (i5 | 0) / 44 | 0;
  i13 = 0;
  i17 = 0;
  while (1) {
   if (i15 >>> 0 <= i17 >>> 0) {
    i44 = 26;
    break;
   }
   if (!(HEAP32[i14 + (i17 * 44 | 0) >> 2] | 0)) i18 = i13; else {
    i18 = i13 + 1 | 0;
    if (!i13) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i42, 163432, 2) | 0;
    i13 = i14 + (i17 * 44 | 0) + 4 | 0;
    i15 = HEAP8[i13 >> 0] | 0;
    i12 = (i15 & 1) == 0;
    if (i12) i15 = (i15 & 255) >>> 1; else i15 = HEAP32[i14 + (i17 * 44 | 0) + 8 >> 2] | 0;
    do if (i15) if (i12) {
     i5 = i13 + 1 | 0;
     break;
    } else {
     i5 = HEAP32[i14 + (i17 * 44 | 0) + 12 >> 2] | 0;
     break;
    } else i5 = 0; while (0);
    __ZN7testing8internal37FormatCompilerIndependentFileLocationEPKci(i41, i5, HEAP32[i14 + (i17 * 44 | 0) + 16 >> 2] | 0);
    HEAP32[i34 + 0 >> 2] = 0;
    HEAP32[i34 + 4 >> 2] = 0;
    HEAP32[i34 + 8 >> 2] = 0;
    i5 = HEAP8[i41 >> 0] | 0;
    if (!(i5 & 1)) {
     i7 = (i5 & 255) >>> 1;
     i6 = i31;
    } else {
     i7 = HEAP32[i23 >> 2] | 0;
     i6 = HEAP32[i24 >> 2] | 0;
    }
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i34, i6, i7, i7 + 1 | 0);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, 160800, 1) | 0;
    i5 = i14 + (i17 * 44 | 0) + 20 | 0;
    if (!(HEAP8[i5 >> 0] & 1)) i16 = i5 + 1 | 0; else i16 = HEAP32[i14 + (i17 * 44 | 0) + 28 >> 2] | 0;
    HEAP32[i43 + 0 >> 2] = 0;
    HEAP32[i43 + 4 >> 2] = 0;
    HEAP32[i43 + 8 >> 2] = 0;
    i15 = HEAP8[i34 >> 0] | 0;
    if (!(i15 & 1)) {
     i12 = _strlen(i16 | 0) | 0;
     i15 = (i15 & 255) >>> 1;
     i13 = i1;
    } else {
     i15 = HEAP32[i28 >> 2] | 0;
     i12 = _strlen(i16 | 0) | 0;
     i13 = HEAP32[i29 >> 2] | 0;
    }
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i43, i13, i15, i15 + i12 | 0);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i43, i16, i12) | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i34);
    i13 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i42, 163440, 24) | 0;
    i15 = (HEAP8[i43 >> 0] & 1) == 0 ? i2 : HEAP32[i27 >> 2] | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i36, i15, _strlen(i15 | 0) | 0);
    __ZN7testing8internal24XmlUnitTestResultPrinter9EscapeXmlERKNSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEb(i35, i36, 1);
    i15 = HEAP8[i35 >> 0] | 0;
    if (!(i15 & 1)) {
     i12 = i3;
     i15 = (i15 & 255) >>> 1;
    } else {
     i12 = HEAP32[i25 >> 2] | 0;
     i15 = HEAP32[i26 >> 2] | 0;
    }
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i13, i12, i15) | 0, 163472, 10) | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i35);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i36);
    HEAP32[i37 + 0 >> 2] = 0;
    HEAP32[i37 + 4 >> 2] = 0;
    HEAP32[i37 + 8 >> 2] = 0;
    i5 = HEAP8[i41 >> 0] | 0;
    if (!(i5 & 1)) {
     i8 = (i5 & 255) >>> 1;
     i7 = i31;
    } else {
     i8 = HEAP32[i23 >> 2] | 0;
     i7 = HEAP32[i24 >> 2] | 0;
    }
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i37, i7, i8, i8 + 1 | 0);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i37, 160800, 1) | 0;
    i5 = i14 + (i17 * 44 | 0) + 32 | 0;
    if (!(HEAP8[i5 >> 0] & 1)) i13 = i5 + 1 | 0; else i13 = HEAP32[i14 + (i17 * 44 | 0) + 40 >> 2] | 0;
    HEAP32[i39 + 0 >> 2] = 0;
    HEAP32[i39 + 4 >> 2] = 0;
    HEAP32[i39 + 8 >> 2] = 0;
    i8 = HEAP8[i37 >> 0] | 0;
    if (!(i8 & 1)) {
     i12 = _strlen(i13 | 0) | 0;
     i15 = (i8 & 255) >>> 1;
     i14 = i4;
    } else {
     i15 = HEAP32[i21 >> 2] | 0;
     i12 = _strlen(i13 | 0) | 0;
     i14 = HEAP32[i22 >> 2] | 0;
    }
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i39, i14, i15, i15 + i12 | 0);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i39, i13, i12) | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i37);
    HEAP32[i38 + 0 >> 2] = 0;
    HEAP32[i38 + 4 >> 2] = 0;
    HEAP32[i38 + 8 >> 2] = 0;
    i5 = HEAP8[i39 >> 0] | 0;
    if (!(i5 & 1)) i5 = (i5 & 255) >>> 1; else i5 = HEAP32[i10 >> 2] | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i38, i5);
    i16 = HEAP8[i39 >> 0] | 0;
    i5 = i16;
    i16 = (i16 & 1) == 0 ? i9 : HEAP32[i11 >> 2] | 0;
    while (1) {
     if (!(i5 & 1)) {
      i15 = i9;
      i14 = (i5 & 255) >>> 1;
     } else {
      i15 = HEAP32[i11 >> 2] | 0;
      i14 = HEAP32[i10 >> 2] | 0;
     }
     if ((i16 | 0) == (i15 + i14 | 0)) break;
     i8 = HEAP8[i16 >> 0] | 0;
     if (!(!(i8 << 24 >> 24 == 13 | i8 << 24 >> 24 == 10 | i8 << 24 >> 24 == 9) ? i8 << 24 >> 24 <= 31 : 0)) {
      __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i38, i8);
      i5 = HEAP8[i39 >> 0] | 0;
     }
     i16 = i16 + 1 | 0;
    }
    __ZN7testing8internal24XmlUnitTestResultPrinter21OutputXmlCDataSectionEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEEPKc(i42, (HEAP8[i38 >> 0] & 1) == 0 ? i19 : HEAP32[i20 >> 2] | 0);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i38);
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i42, 163488, 11) | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i39);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i43);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i41);
    i14 = HEAP32[i33 >> 2] | 0;
   }
   i17 = i17 + 1 | 0;
   i15 = ((HEAP32[i32 >> 2] | 0) - i14 | 0) / 44 | 0;
   if ((i17 | 0) >= (i15 | 0)) break; else i13 = i18;
  }
  if ((i44 | 0) == 26) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i30);
  if (i18) {
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i42, 163512, 16) | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i40);
   STACKTOP = i45;
   return;
  }
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i42, 163504, 4) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i40);
 STACKTOP = i45;
 return;
}

function __ZNK2cv5MatOp3roiERKNS_7MatExprERKNS_5RangeES6_RS1_(i4, i34, i35, i33, i18) {
 i4 = i4 | 0;
 i34 = i34 | 0;
 i35 = i35 | 0;
 i33 = i33 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i36 = 0, i37 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 i9 = i37 + 536 | 0;
 i10 = i37 + 528 | 0;
 i32 = i37 + 520 | 0;
 i31 = i37 + 512 | 0;
 i29 = i37 + 504 | 0;
 i28 = i37 + 496 | 0;
 i26 = i37 + 488 | 0;
 i25 = i37 + 480 | 0;
 i5 = i37 + 256 | 0;
 i22 = i37 + 1048 | 0;
 i21 = i37 + 992 | 0;
 i15 = i37 + 936 | 0;
 i27 = i37 + 880 | 0;
 i30 = i37 + 824 | 0;
 i36 = i37 + 768 | 0;
 i19 = i37 + 712 | 0;
 i11 = i37 + 32 | 0;
 i20 = i37 + 656 | 0;
 i17 = i37 + 600 | 0;
 i12 = i37 + 544 | 0;
 i2 = i37;
 if (!(FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] & 127](i4, i34) | 0)) {
  HEAP32[i19 >> 2] = 1124007936;
  i15 = i19 + 4 | 0;
  i3 = i19 + 8 | 0;
  i13 = i19 + 40 | 0;
  i23 = i15 + 0 | 0;
  i24 = i23 + 36 | 0;
  do {
   HEAP32[i23 >> 2] = 0;
   i23 = i23 + 4 | 0;
  } while ((i23 | 0) < (i24 | 0));
  HEAP32[i13 >> 2] = i3;
  i16 = i19 + 48 | 0;
  i14 = i19 + 44 | 0;
  HEAP32[i14 >> 2] = i16;
  HEAP32[i19 + 52 >> 2] = 0;
  HEAP32[i16 >> 2] = 0;
  i22 = HEAP32[i34 >> 2] | 0;
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] & 63](i22, i34, i19, -1);
  i22 = i35;
  i24 = HEAP32[i22 + 4 >> 2] | 0;
  i7 = i33;
  i23 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i3 = i10;
  HEAP32[i3 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i3 + 4 >> 2] = i24;
  i3 = i9;
  HEAP32[i3 >> 2] = i23;
  HEAP32[i3 + 4 >> 2] = i7;
  __ZN2cv3MatC2ERKS0_RKNS_5RangeES5_(i20, i19, i10, i9);
  HEAP32[i17 >> 2] = 1124007936;
  i9 = i17 + 4 | 0;
  i3 = i17 + 8 | 0;
  i7 = i17 + 40 | 0;
  i23 = i9 + 0 | 0;
  i24 = i23 + 36 | 0;
  do {
   HEAP32[i23 >> 2] = 0;
   i23 = i23 + 4 | 0;
  } while ((i23 | 0) < (i24 | 0));
  HEAP32[i7 >> 2] = i3;
  i10 = i17 + 48 | 0;
  i8 = i17 + 44 | 0;
  HEAP32[i8 >> 2] = i10;
  HEAP32[i17 + 52 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i12 >> 2] = 1124007936;
  i5 = i12 + 4 | 0;
  i3 = i12 + 8 | 0;
  i1 = i12 + 40 | 0;
  i23 = i5 + 0 | 0;
  i24 = i23 + 36 | 0;
  do {
   HEAP32[i23 >> 2] = 0;
   i23 = i23 + 4 | 0;
  } while ((i23 | 0) < (i24 | 0));
  HEAP32[i1 >> 2] = i3;
  i6 = i12 + 48 | 0;
  i4 = i12 + 44 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i12 + 52 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i2 + 0 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAP32[i2 + 24 >> 2] = 0;
  HEAP32[i2 + 28 >> 2] = 0;
  HEAPF64[i2 >> 3] = 0.0;
  __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i11, 33104, 0, i20, i17, i12, 1.0, 1.0, i2);
  i22 = i11;
  i24 = HEAP32[i22 + 4 >> 2] | 0;
  i23 = i18;
  HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i23 + 4 >> 2] = i24;
  __ZN2cv3MataSERKS0_(i18 + 8 | 0, i11 + 8 | 0) | 0;
  __ZN2cv3MataSERKS0_(i18 + 64 | 0, i11 + 64 | 0) | 0;
  __ZN2cv3MataSERKS0_(i18 + 120 | 0, i11 + 120 | 0) | 0;
  i23 = i18 + 176 | 0;
  i18 = i11 + 176 | 0;
  i24 = i23 + 48 | 0;
  do {
   HEAP32[i23 >> 2] = HEAP32[i18 >> 2];
   i23 = i23 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i23 | 0) < (i24 | 0));
  __ZN2cv7MatExprD2Ev(i11);
  i3 = i12 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i12);
  HEAP32[i3 >> 2] = 0;
  i22 = i12 + 16 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i5 >> 2] | 0) > 0) {
   i3 = HEAP32[i1 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i5 >> 2] | 0));
  }
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) != (i6 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = i17 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i17);
  HEAP32[i3 >> 2] = 0;
  i22 = i17 + 16 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i9 >> 2] | 0) > 0) {
   i3 = HEAP32[i7 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i9 >> 2] | 0));
  }
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = i20 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i20);
  HEAP32[i3 >> 2] = 0;
  i22 = i20 + 16 | 0;
  i3 = i20 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i20 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i3 = HEAP32[i20 + 44 >> 2] | 0;
  if ((i3 | 0) != (i20 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = i19 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i19);
  HEAP32[i3 >> 2] = 0;
  i22 = i19 + 16 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i15 >> 2] | 0) > 0) {
   i3 = HEAP32[i13 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i15 >> 2] | 0));
  }
  i1 = HEAP32[i14 >> 2] | 0;
  if ((i1 | 0) == (i16 | 0)) {
   STACKTOP = i37;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i37;
  return;
 }
 i10 = HEAP32[i34 >> 2] | 0;
 i9 = HEAP32[i34 + 4 >> 2] | 0;
 HEAP32[i22 >> 2] = 1124007936;
 i19 = i22 + 4 | 0;
 i3 = i22 + 8 | 0;
 i17 = i22 + 40 | 0;
 i23 = i19 + 0 | 0;
 i24 = i23 + 36 | 0;
 do {
  HEAP32[i23 >> 2] = 0;
  i23 = i23 + 4 | 0;
 } while ((i23 | 0) < (i24 | 0));
 HEAP32[i17 >> 2] = i3;
 i20 = i22 + 48 | 0;
 i14 = i22 + 44 | 0;
 HEAP32[i14 >> 2] = i20;
 HEAP32[i22 + 52 >> 2] = 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i21 >> 2] = 1124007936;
 i13 = i21 + 4 | 0;
 i6 = i21 + 8 | 0;
 i12 = i21 + 40 | 0;
 i23 = i13 + 0 | 0;
 i24 = i23 + 36 | 0;
 do {
  HEAP32[i23 >> 2] = 0;
  i23 = i23 + 4 | 0;
 } while ((i23 | 0) < (i24 | 0));
 HEAP32[i12 >> 2] = i6;
 i1 = i21 + 48 | 0;
 i11 = i21 + 44 | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i21 + 52 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i15 >> 2] = 1124007936;
 i3 = i15 + 4 | 0;
 i8 = i15 + 8 | 0;
 i6 = i15 + 40 | 0;
 i23 = i3 + 0 | 0;
 i24 = i23 + 36 | 0;
 do {
  HEAP32[i23 >> 2] = 0;
  i23 = i23 + 4 | 0;
 } while ((i23 | 0) < (i24 | 0));
 HEAP32[i6 >> 2] = i8;
 i2 = i15 + 48 | 0;
 i4 = i15 + 44 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i15 + 52 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i5, i10, i9, i22, i21, i15, +HEAPF64[i34 + 176 >> 3], +HEAPF64[i34 + 184 >> 3], i34 + 192 | 0);
 i10 = i5;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i16 = i18;
 HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i16 + 4 >> 2] = i9;
 i16 = i18 + 8 | 0;
 __ZN2cv3MataSERKS0_(i16, i5 + 8 | 0) | 0;
 i9 = i18 + 64 | 0;
 __ZN2cv3MataSERKS0_(i9, i5 + 64 | 0) | 0;
 i10 = i18 + 120 | 0;
 __ZN2cv3MataSERKS0_(i10, i5 + 120 | 0) | 0;
 i23 = i18 + 176 | 0;
 i18 = i5 + 176 | 0;
 i24 = i23 + 48 | 0;
 do {
  HEAP32[i23 >> 2] = HEAP32[i18 >> 2];
  i23 = i23 + 4 | 0;
  i18 = i18 + 4 | 0;
 } while ((i23 | 0) < (i24 | 0));
 __ZN2cv7MatExprD2Ev(i5);
 i8 = i15 + 36 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if ((i7 | 0) != 0 ? (i5 = i7 + 12 | 0, i18 = HEAP32[i5 >> 2] | 0, HEAP32[i5 >> 2] = i18 + -1, (i18 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i15);
 HEAP32[i8 >> 2] = 0;
 i18 = i15 + 16 | 0;
 HEAP32[i18 + 0 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i6 = HEAP32[i6 >> 2] | 0;
  i5 = 0;
  do {
   HEAP32[i6 + (i5 << 2) >> 2] = 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i6 = HEAP32[i4 >> 2] | 0;
 if ((i6 | 0) != (i2 | 0)) __ZN2cv8fastFreeEPv(i6);
 i6 = i21 + 36 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 if ((i5 | 0) != 0 ? (i15 = i5 + 12 | 0, i18 = HEAP32[i15 >> 2] | 0, HEAP32[i15 >> 2] = i18 + -1, (i18 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i21);
 HEAP32[i6 >> 2] = 0;
 i21 = i21 + 16 | 0;
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 if ((HEAP32[i13 >> 2] | 0) > 0) {
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i13 >> 2] | 0));
 }
 i3 = HEAP32[i11 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) __ZN2cv8fastFreeEPv(i3);
 i3 = i22 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i18 = i2 + 12 | 0, i21 = HEAP32[i18 >> 2] | 0, HEAP32[i18 >> 2] = i21 + -1, (i21 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i22);
 HEAP32[i3 >> 2] = 0;
 i22 = i22 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i19 >> 2] | 0) > 0) {
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i19 >> 2] | 0));
 }
 i3 = HEAP32[i14 >> 2] | 0;
 if ((i3 | 0) != (i20 | 0)) __ZN2cv8fastFreeEPv(i3);
 if (HEAP32[i34 + 24 >> 2] | 0) {
  i20 = i35;
  i21 = HEAP32[i20 + 4 >> 2] | 0;
  i2 = i33;
  i22 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = i25;
  HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i3 + 4 >> 2] = i21;
  i3 = i26;
  HEAP32[i3 >> 2] = i22;
  HEAP32[i3 + 4 >> 2] = i2;
  __ZN2cv3MatC2ERKS0_RKNS_5RangeES5_(i27, i34 + 8 | 0, i25, i26);
  __ZN2cv3MataSERKS0_(i16, i27) | 0;
  i3 = i27 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i27);
  HEAP32[i3 >> 2] = 0;
  i22 = i27 + 16 | 0;
  i3 = i27 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i27 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i3 = HEAP32[i27 + 44 >> 2] | 0;
  if ((i3 | 0) != (i27 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
 }
 if (HEAP32[i34 + 80 >> 2] | 0) {
  i20 = i35;
  i21 = HEAP32[i20 + 4 >> 2] | 0;
  i2 = i33;
  i22 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = i28;
  HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i3 + 4 >> 2] = i21;
  i3 = i29;
  HEAP32[i3 >> 2] = i22;
  HEAP32[i3 + 4 >> 2] = i2;
  __ZN2cv3MatC2ERKS0_RKNS_5RangeES5_(i30, i34 + 64 | 0, i28, i29);
  __ZN2cv3MataSERKS0_(i9, i30) | 0;
  i3 = i30 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i30);
  HEAP32[i3 >> 2] = 0;
  i22 = i30 + 16 | 0;
  i3 = i30 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i30 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i3 = HEAP32[i30 + 44 >> 2] | 0;
  if ((i3 | 0) != (i30 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
 }
 if (!(HEAP32[i34 + 136 >> 2] | 0)) {
  STACKTOP = i37;
  return;
 }
 i20 = i35;
 i21 = HEAP32[i20 + 4 >> 2] | 0;
 i2 = i33;
 i22 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i31;
 HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i1 + 4 >> 2] = i21;
 i1 = i32;
 HEAP32[i1 >> 2] = i22;
 HEAP32[i1 + 4 >> 2] = i2;
 __ZN2cv3MatC2ERKS0_RKNS_5RangeES5_(i36, i34 + 120 | 0, i31, i32);
 __ZN2cv3MataSERKS0_(i10, i36) | 0;
 i1 = i36 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i36);
 HEAP32[i1 >> 2] = 0;
 i22 = i36 + 16 | 0;
 i2 = i36 + 4 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i36 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i36 + 44 >> 2] | 0;
 if ((i1 | 0) == (i36 + 48 | 0)) {
  STACKTOP = i37;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i37;
 return;
}
function __ZL16icvXMLParseValueP13CvFileStoragePcP10CvFileNodei(i25, i1, i29, i2) {
 i25 = i25 | 0;
 i1 = i1 | 0;
 i29 = i29 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, d31 = 0.0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 5184 | 0;
 i26 = i30 + 8 | 0;
 i24 = i30 + 4152 | 0;
 i15 = i30 + 36 | 0;
 i16 = i30 + 32 | 0;
 i17 = i30 + 28 | 0;
 i18 = i30 + 24 | 0;
 i19 = i30 + 20 | 0;
 i14 = i30 + 40 | 0;
 i13 = i30;
 i28 = i2 & 16;
 HEAP32[i29 + 0 >> 2] = 0;
 HEAP32[i29 + 4 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 HEAP32[i29 + 12 >> 2] = 0;
 i20 = i2 & 7;
 i21 = i25 + 60 | 0;
 i22 = i25 + 88 | 0;
 i9 = (i20 | 0) == 3;
 i10 = i25 + 16 | 0;
 i12 = i20 >>> 0 < 5 & (i20 | 0) != 0;
 i23 = i29 + 8 | 0;
 i11 = 1;
 L1 : while (1) {
  i3 = 1;
  L3 : while (1) {
   i4 = HEAP8[i1 >> 0] | 0;
   switch (i4 << 24 >> 24) {
   case 60:
    {
     i3 = HEAP8[i1 + 1 >> 0] | 0;
     if (i3 << 24 >> 24 != 33) {
      i2 = i1;
      i1 = 60;
      break L3;
     }
     if ((HEAP8[i1 + 2 >> 0] | 0) == 45) i27 = 7; else {
      i27 = 6;
      break L3;
     }
     break;
    }
   case 0:
   case 9:
   case 10:
   case 11:
   case 12:
   case 13:
   case 32:
    {
     i27 = 7;
     break;
    }
   default:
    {
     i2 = i1;
     i1 = i4;
     i4 = i3;
    }
   }
   if ((i27 | 0) == 7) {
    i27 = 0;
    i1 = __ZL16icvXMLSkipSpacesP13CvFileStoragePci(i25, i1, 0) | 0;
    i2 = i1;
    i1 = HEAP8[i1 >> 0] | 0;
    i4 = 1;
   }
   i3 = HEAP8[i2 + 1 >> 0] | 0;
   if (i1 << 24 >> 24 == 0 | i1 << 24 >> 24 == 60) break;
   if (!i4) {
    i4 = HEAP32[i22 >> 2] | 0;
    HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i26 + 4 >> 2] = i4;
    HEAP32[i26 + 8 >> 2] = 15904;
    _sprintf(i24, 17440, i26) | 0;
    _cvError(-212, 15744, i24, 8960, 1911);
   }
   i4 = HEAP32[i29 >> 2] | 0;
   if (!i4) i8 = i29; else {
    if ((i4 & 7) >>> 0 <= 4) {
     i4 = _cvCreateSeq(0, 56, 16, HEAP32[i10 >> 2] | 0) | 0;
     if (HEAP32[i29 >> 2] & 7) _cvSeqPush(i4, i29) | 0;
     HEAP32[i23 >> 2] = i4;
     HEAP32[i29 >> 2] = 5;
     _cvSetSeqBlockSize(i4, 8);
    }
    i8 = _cvSeqPush(HEAP32[i23 >> 2] | 0, 0) | 0;
    HEAP32[i8 + 4 >> 2] = 0;
   }
   L24 : do if (!i9) {
    do if ((i1 + -48 << 24 >> 24 & 255) >= 10) {
     if (i1 << 24 >> 24 == 43 | i1 << 24 >> 24 == 45) {
      i4 = i3 + -48 << 24 >> 24;
      if ((i4 & 255) < 10 | i3 << 24 >> 24 == 46) {
       i4 = i1;
       break;
      }
      if (i1 << 24 >> 24 != 46) {
       i27 = 61;
       break L24;
      }
     } else if (i1 << 24 >> 24 == 46) i4 = i3 + -48 << 24 >> 24; else {
      i27 = 61;
      break L24;
     }
     if (!((i4 & 255) < 10 | (i3 + -97 << 24 >> 24 & 255) < 26)) if ((i3 + -65 << 24 >> 24 & 255) < 26) i4 = i1; else {
      i27 = 61;
      break L24;
     } else i4 = 46;
    } else i4 = i1; while (0);
    i3 = i2 + ((i4 << 24 >> 24 == 45 | i1 << 24 >> 24 == 43) & 1) | 0;
    while (1) {
     HEAP32[i15 >> 2] = i3;
     i4 = HEAP8[i3 >> 0] | 0;
     if ((i4 + -48 << 24 >> 24 & 255) < 10) i3 = i3 + 1 | 0; else break;
    }
    if (i4 << 24 >> 24 == 101 | i4 << 24 >> 24 == 46) {
     d31 = +__ZL10icv_strtodP13CvFileStoragePcPS1_(i25, i2, i15);
     HEAP32[i8 >> 2] = 2;
     HEAPF64[i8 + 8 >> 3] = d31;
    } else {
     i1 = _strtol(i2, i15, 0) | 0;
     HEAP32[i8 >> 2] = 1;
     HEAP32[i8 + 8 >> 2] = i1;
    }
    i1 = HEAP32[i15 >> 2] | 0;
    if ((i1 | 0) == (i2 | 0)) {
     i2 = HEAP32[i22 >> 2] | 0;
     HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i26 + 4 >> 2] = i2;
     HEAP32[i26 + 8 >> 2] = 14912;
     _sprintf(i24, 17440, i26) | 0;
     _cvError(-212, 15744, i24, 8960, 1948);
     i2 = i1;
    } else i2 = i1;
   } else i27 = 61; while (0);
   if ((i27 | 0) == 61) {
    i27 = 0;
    HEAP32[i8 >> 2] = 3;
    i7 = i1 << 24 >> 24 == 34;
    i1 = i7 ? i2 : i2 + -1 | 0;
    i3 = 0;
    L45 : while (1) {
     i2 = i1 + 1 | 0;
     i4 = HEAP8[i2 >> 0] | 0;
     L47 : do if ((i4 + -48 << 24 >> 24 & 255) < 10 | (i4 + -97 << 24 >> 24 & 255) < 26 | (i4 + -65 << 24 >> 24 & 255) < 26) {
      i1 = i4;
      i4 = i3;
     } else {
      if (i4 << 24 >> 24 == 34) {
       i27 = 64;
       break L45;
      }
      if ((i4 & 255) < 32 | i4 << 24 >> 24 == 60) {
       i27 = 70;
       break L45;
      }
      if (i7) if (i4 << 24 >> 24 == 62 | i4 << 24 >> 24 == 39) i27 = 73; else if (i4 << 24 >> 24 != 38) {
       i1 = i4;
       i4 = i3;
       break;
      } else switch (i4 << 24 >> 24) {
      case 9:
      case 10:
      case 11:
      case 12:
      case 13:
      case 32:
       break L45;
      case 38:
       break;
      case 62:
      case 39:
       {
        i27 = 73;
        break;
       }
      default:
       {
        i1 = i4;
        i4 = i3;
        break L47;
       }
      }
      if ((i27 | 0) == 73) {
       i27 = 0;
       i1 = HEAP32[i22 >> 2] | 0;
       HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
       HEAP32[i26 + 4 >> 2] = i1;
       HEAP32[i26 + 8 >> 2] = 16024;
       _sprintf(i24, 17440, i26) | 0;
       _cvError(-212, 15744, i24, 8960, 1983);
       i1 = i4;
       i4 = i3;
       break;
      }
      i6 = i1 + 2 | 0;
      if ((HEAP8[i6 >> 0] | 0) == 35) {
       i2 = i1 + 3 | 0;
       i4 = (HEAP8[i2 >> 0] | 0) == 120;
       i4 = _strtol(i4 ? i1 + 4 | 0 : i2, i15, i4 ? 16 : 10) | 0;
       i2 = HEAP32[i15 >> 2] | 0;
       if (!(i4 >>> 0 < 256 & (i2 | 0) != 0 ? (HEAP8[i2 >> 0] | 0) == 59 : 0)) {
        i1 = HEAP32[i22 >> 2] | 0;
        HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
        HEAP32[i26 + 4 >> 2] = i1;
        HEAP32[i26 + 8 >> 2] = 16080;
        _sprintf(i24, 17440, i26) | 0;
        _cvError(-212, 15744, i24, 8960, 1999);
       }
       i1 = i4 & 255;
       i4 = i3;
       break;
      }
      HEAP32[i15 >> 2] = i6;
      i4 = i6;
      do {
       i4 = i4 + 1 | 0;
       i1 = HEAP8[i4 >> 0] | 0;
      } while ((i1 + -48 << 24 >> 24 & 255) < 10 | (i1 + -97 << 24 >> 24 & 255) < 26 | (i1 + -65 << 24 >> 24 & 255) < 26);
      HEAP32[i15 >> 2] = i4;
      if (i1 << 24 >> 24 != 59) {
       i5 = HEAP32[i22 >> 2] | 0;
       HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
       HEAP32[i26 + 4 >> 2] = i5;
       HEAP32[i26 + 8 >> 2] = 16120;
       _sprintf(i24, 17440, i26) | 0;
       _cvError(-212, 15744, i24, 8960, 2008);
      }
      i5 = i4 - i6 | 0;
      if ((i5 | 0) == 3) {
       if (!(_memcmp(i6, 16184, 3) | 0)) {
        i2 = i4;
        i1 = 38;
        i4 = i3;
        break;
       }
      } else if ((i5 | 0) == 4) {
       if (!(_memcmp(i6, 16192, 4) | 0)) {
        i2 = i4;
        i1 = 39;
        i4 = i3;
        break;
       }
       if (!(_memcmp(i6, 16200, 4) | 0)) {
        i2 = i4;
        i1 = 34;
        i4 = i3;
        break;
       }
      } else if ((i5 | 0) == 2) {
       if (!(_memcmp(i6, 16168, 2) | 0)) {
        i2 = i4;
        i1 = 60;
        i4 = i3;
        break;
       }
       if (!(_memcmp(i6, 16176, 2) | 0)) {
        i2 = i4;
        i1 = 62;
        i4 = i3;
        break;
       }
      }
      i5 = i5 + 2 | 0;
      _memcpy(i14 + i3 | 0, i2 | 0, i5 | 0) | 0;
      i2 = i4;
      i4 = i5 + i3 | 0;
     } while (0);
     i3 = i4 + 1 | 0;
     HEAP8[i14 + i4 >> 0] = i1;
     if ((i4 | 0) <= 4094) {
      i1 = i2;
      continue;
     }
     i1 = HEAP32[i22 >> 2] | 0;
     HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i26 + 4 >> 2] = i1;
     HEAP32[i26 + 8 >> 2] = 15008;
     _sprintf(i24, 17440, i26) | 0;
     _cvError(-212, 15744, i24, 8960, 2031);
     i1 = i2;
    }
    if ((i27 | 0) == 64) {
     i27 = 0;
     if (!i7) {
      i2 = HEAP32[i22 >> 2] | 0;
      HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i26 + 4 >> 2] = i2;
      HEAP32[i26 + 8 >> 2] = 15944;
      _sprintf(i24, 17440, i26) | 0;
      _cvError(-212, 15744, i24, 8960, 1971);
     }
     i2 = i1 + 2 | 0;
    } else if ((i27 | 0) == 70) {
     i27 = 0;
     if (i7) {
      i1 = HEAP32[i22 >> 2] | 0;
      HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i26 + 4 >> 2] = i1;
      HEAP32[i26 + 8 >> 2] = 16e3;
      _sprintf(i24, 17440, i26) | 0;
      _cvError(-212, 15744, i24, 8960, 1978);
     }
    }
    _cvMemStorageAllocString(i13, HEAP32[i10 >> 2] | 0, i14, i3);
    i1 = i8 + 8 | 0;
    HEAPF64[tempDoublePtr >> 3] = +HEAPF64[i13 >> 3];
    HEAP32[i1 >> 2] = HEAP32[tempDoublePtr >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
   }
   if (i12) break L1; else {
    i1 = i2;
    i3 = 0;
   }
  }
  if ((i27 | 0) == 6) {
   i27 = 0;
   i2 = i1;
   i3 = HEAP8[i1 + 1 >> 0] | 0;
   i1 = 60;
  }
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i18 >> 2] = 0;
  HEAP32[i19 >> 2] = 0;
  if (i3 << 24 >> 24 == 47 | i1 << 24 >> 24 == 0) break;
  i7 = __ZL14icvXMLParseTagP13CvFileStoragePcPP16CvStringHashNodePP10CvAttrListPi(i25, i2, i16, i18, i19) | 0;
  i2 = HEAP32[i19 >> 2] | 0;
  if ((i2 | 0) == 3) {
   i1 = HEAP32[i22 >> 2] | 0;
   HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i26 + 4 >> 2] = i1;
   HEAP32[i26 + 8 >> 2] = 15808;
   _sprintf(i24, 17440, i26) | 0;
   _cvError(-212, 15744, i24, 8960, 1863);
  } else if ((i2 | 0) == 5) {
   i1 = HEAP32[i22 >> 2] | 0;
   HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i26 + 4 >> 2] = i1;
   HEAP32[i26 + 8 >> 2] = 15768;
   _sprintf(i24, 17440, i26) | 0;
   _cvError(-212, 15744, i24, 8960, 1861);
  }
  i2 = HEAP32[i18 >> 2] | 0;
  L97 : do if (i2) {
   L98 : while (1) {
    i5 = HEAP32[i2 >> 2] | 0;
    if (!i5) {
     i1 = 0;
     i3 = 0;
     break L97;
    }
    i4 = HEAP32[i5 >> 2] | 0;
    if (i4) {
     i3 = 0;
     i1 = 0;
     do {
      i1 = i1 + 1 | 0;
      if (!(_strcmp(15840, i4) | 0)) break L98;
      i3 = i1 << 1;
      i4 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
     } while ((i4 | 0) != 0);
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) {
     i1 = 0;
     i3 = 0;
     break L97;
    }
   }
   i4 = HEAP32[i5 + ((i3 | 1) << 2) >> 2] | 0;
   if (i4) if (_strcmp(i4, 14872) | 0) if (_strcmp(i4, 14896) | 0) if (!(_strcmp(i4, 14888) | 0)) {
    i1 = 5;
    i3 = 0;
   } else {
    i3 = HEAP32[2644] | 0;
    L111 : do if (!i3) i3 = 0; else while (1) {
     if (!(_strcmp(HEAP32[i3 + 16 >> 2] | 0, i4) | 0)) break L111;
     i3 = HEAP32[i3 + 12 >> 2] | 0;
     if (!i3) {
      i3 = 0;
      break;
     }
    } while (0);
    i1 = (i3 | 0) == 0 ? 0 : 16;
   } else {
    i1 = 6;
    i3 = 0;
   } else {
    i1 = 3;
    i3 = 0;
   } else {
    i1 = 0;
    i3 = 0;
   }
  } else {
   i1 = 0;
   i3 = 0;
  } while (0);
  i6 = HEAP32[i16 >> 2] | 0;
  if ((HEAP32[i6 + 4 >> 2] | 0) == 1) i2 = (HEAP8[HEAP32[i6 + 8 >> 2] >> 0] | 0) == 95; else i2 = 0;
  i4 = HEAP32[i29 >> 2] & 7;
  if (i4 >>> 0 > 4) {
   if (i2 ^ (i4 | 0) == 5) {
    i4 = HEAP32[i22 >> 2] | 0;
    HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i26 + 4 >> 2] = i4;
    HEAP32[i26 + 8 >> 2] = i2 ? 15848 : 15360;
    _sprintf(i24, 17440, i26) | 0;
    _cvError(-212, 15744, i24, 8960, 1891);
   }
  } else __ZL21icvFSCreateCollectionP13CvFileStorageiP10CvFileNode(i25, i2 ? 5 : 6, i29);
  if (i2) {
   i5 = _cvSeqPush(HEAP32[i23 >> 2] | 0, 0) | 0;
   i2 = __ZL16icvXMLParseValueP13CvFileStoragePcP10CvFileNodei(i25, i7, i5, i1) | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i1 = i5;
  } else {
   i5 = _cvGetFileNode(i25, i29, i6, 1) | 0;
   i2 = __ZL16icvXMLParseValueP13CvFileStoragePcP10CvFileNodei(i25, i7, i5, i1) | 0;
   i4 = HEAP32[i5 >> 2] | 64;
   HEAP32[i5 >> 2] = i4;
   i1 = i5;
  }
  i4 = (i4 & 7) >>> 0 < 5 & i11;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = __ZL14icvXMLParseTagP13CvFileStoragePcPP16CvStringHashNodePP10CvAttrListPi(i25, i2, i17, i18, i19) | 0;
  if ((HEAP32[i19 >> 2] | 0) == 2 ? (HEAP32[i17 >> 2] | 0) == (i6 | 0) : 0) {
   i11 = i4;
   continue;
  }
  i11 = HEAP32[i22 >> 2] | 0;
  HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i26 + 4 >> 2] = i11;
  HEAP32[i26 + 8 >> 2] = 15880;
  _sprintf(i24, 17440, i26) | 0;
  _cvError(-212, 15744, i24, 8960, 1905);
  i11 = i4;
 }
 i1 = HEAP32[i29 >> 2] & 7;
 if (!i1) {
  if (i20 >>> 0 > 4) i27 = 97;
 } else if (i1 >>> 0 < 5 & (i1 | 0) != (i20 | 0) & i20 >>> 0 > 4) i27 = 97;
 if ((i27 | 0) == 97) __ZL21icvFSCreateCollectionP13CvFileStorageiP10CvFileNode(i25, (i20 | 0) == 6 ? 6 : 5, i29);
 if ((i20 | 0) != 0 ? (i20 | 0) != (HEAP32[i29 >> 2] & 7 | 0) : 0) {
  i22 = HEAP32[i22 >> 2] | 0;
  HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i26 + 4 >> 2] = i22;
  HEAP32[i26 + 8 >> 2] = 16208;
  _sprintf(i24, 17440, i26) | 0;
  _cvError(-212, 15744, i24, 8960, 2053);
 }
 i1 = HEAP32[i29 >> 2] | 0;
 if (!((i1 & 7) >>> 0 > 4 & (i11 | 0) != 0)) {
  i22 = i1 | i28;
  HEAP32[i29 >> 2] = i22;
  STACKTOP = i30;
  return i2 | 0;
 }
 i22 = HEAP32[i23 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | 256;
 i22 = i1 | i28;
 HEAP32[i29 >> 2] = i22;
 STACKTOP = i30;
 return i2 | 0;
}

function __ZN2cvL17GEMMSingleMul_64fEPKdjS1_jS1_jPdjNS_5Size_IiEES4_ddi(i18, i11, i34, i16, i29, i3, i28, i4, i1, i2, d42, d43, i8) {
 i18 = i18 | 0;
 i11 = i11 | 0;
 i34 = i34 | 0;
 i16 = i16 | 0;
 i29 = i29 | 0;
 i3 = i3 | 0;
 i28 = i28 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d42 = +d42;
 d43 = +d43;
 i8 = i8 | 0;
 var d5 = 0.0, d6 = 0.0, i7 = 0, d9 = 0.0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, d17 = 0.0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i44 = 0, i45 = 0, d46 = 0.0;
 i45 = STACKTOP;
 STACKTOP = STACKTOP + 3296 | 0;
 i44 = i45 + 2192 | 0;
 i26 = i45 + 1096 | 0;
 i27 = i45;
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i39 = HEAP32[i2 >> 2] | 0;
 i38 = HEAP32[i2 + 4 >> 2] | 0;
 i40 = i44 + 8 | 0;
 HEAP32[i44 >> 2] = i40;
 i41 = i44 + 4 | 0;
 HEAP32[i41 >> 2] = 136;
 i10 = i11 >>> 3;
 i33 = i16 >>> 3;
 i2 = i3 >>> 3;
 i36 = i4 >>> 3;
 if (!i29) {
  i37 = 0;
  i35 = 0;
 } else {
  i35 = (i8 & 4 | 0) == 0;
  i37 = i35 ? i2 : 1;
  i35 = i35 ? 1 : i2;
 }
 do if (i8 & 1) if (i11 >>> 0 > 15 & (i1 | 0) > 1) if (i1 >>> 0 > 136) {
  i30 = __Znaj(i1 >>> 0 > 536870911 ? -1 : i1 << 3) | 0;
  HEAP32[i44 >> 2] = i30;
  HEAP32[i41 >> 2] = i1;
  i4 = i1;
  i2 = i30;
  i31 = 1;
  i32 = i10;
  i7 = i1;
  break;
 } else {
  HEAP32[i41 >> 2] = i1;
  i4 = i1;
  i2 = i40;
  i30 = i40;
  i31 = 1;
  i32 = i10;
  i7 = i1;
  break;
 } else {
  i4 = 136;
  i2 = i40;
  i30 = 0;
  i31 = 1;
  i32 = i10;
  i7 = i1;
 } else {
  i4 = 136;
  i2 = i40;
  i30 = 0;
  i31 = i10;
  i32 = 1;
 } while (0);
 L11 : do if ((i7 | 0) == 1) {
  i23 = i26 + 8 | 0;
  HEAP32[i26 >> 2] = i23;
  i22 = i26 + 4 | 0;
  HEAP32[i22 >> 2] = 136;
  if (i11 >>> 0 > 15 & (i1 | 0) > 1) {
   if (i4 >>> 0 < i38 >>> 0) {
    if ((i2 | 0) != (i40 | 0)) {
     __ZdaPv(i2);
     HEAP32[i44 >> 2] = i40;
     HEAP32[i41 >> 2] = 136;
    }
    if (i38 >>> 0 > 136) {
     i2 = __Znaj(i38 >>> 0 > 536870911 ? -1 : i38 << 3) | 0;
     HEAP32[i44 >> 2] = i2;
     HEAP32[i41 >> 2] = i38;
    } else i2 = i40;
   } else HEAP32[i41 >> 2] = i38;
   if ((i38 | 0) > 0) {
    i1 = 0;
    do {
     HEAPF64[i2 + (i1 << 3) >> 3] = +HEAPF64[i18 + ((Math_imul(i1, i10) | 0) << 3) >> 3];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i38 | 0));
    i18 = i2;
   } else i18 = i2;
  }
  if (i16 >>> 0 > 15) {
   if ((HEAP32[i22 >> 2] | 0) >>> 0 < i39 >>> 0) {
    i1 = HEAP32[i26 >> 2] | 0;
    if ((i1 | 0) != (i23 | 0)) {
     if (i1) __ZdaPv(i1);
     HEAP32[i26 >> 2] = i23;
     HEAP32[i22 >> 2] = 136;
    }
    if (i39 >>> 0 > 136) {
     i2 = __Znaj(i39 >>> 0 > 536870911 ? -1 : i39 << 3) | 0;
     HEAP32[i26 >> 2] = i2;
     HEAP32[i22 >> 2] = i39;
    } else i2 = i23;
   } else {
    HEAP32[i22 >> 2] = i39;
    i2 = HEAP32[i26 >> 2] | 0;
   }
   if ((i39 | 0) > 0) {
    i1 = 0;
    do {
     HEAPF64[i2 + (i1 << 3) >> 3] = +HEAPF64[i34 + ((Math_imul(i1, i33) | 0) << 3) >> 3];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i39 | 0));
   }
  } else i2 = i34;
  if ((i38 | 0) > 0) {
   i12 = i39 + -2 | 0;
   i13 = (i12 | 0) < 0;
   i14 = i35 << 1;
   i16 = (i12 | 0) > 1 ? i12 >>> 1 : 0;
   i15 = Math_imul(i14, i16) | 0;
   i16 = (i16 << 1) + 2 | 0;
   i7 = i28;
   i10 = i29;
   i11 = 0;
   i8 = i29 + (i14 << 3) | 0;
   while (1) {
    d9 = +HEAPF64[i18 + (i11 << 3) >> 3] * d42;
    if (i13) {
     i4 = i10;
     i3 = 0;
    } else {
     i4 = i10;
     i1 = 0;
     while (1) {
      d5 = d9 * +HEAPF64[i2 + (i1 << 3) >> 3];
      i3 = i1 | 1;
      d6 = d9 * +HEAPF64[i2 + (i3 << 3) >> 3];
      if (!i4) {
       HEAPF64[i7 + (i1 << 3) >> 3] = d5;
       HEAPF64[i7 + (i3 << 3) >> 3] = d6;
      } else {
       HEAPF64[i7 + (i1 << 3) >> 3] = d5 + +HEAPF64[i4 >> 3] * d43;
       HEAPF64[i7 + (i3 << 3) >> 3] = d6 + +HEAPF64[i4 + (i35 << 3) >> 3] * d43;
      }
      i1 = i1 + 2 | 0;
      if ((i1 | 0) > (i12 | 0)) break; else i4 = i4 + (i14 << 3) | 0;
     }
     i4 = i8 + (i15 << 3) | 0;
     i3 = i16;
    }
    if ((i3 | 0) < (i39 | 0)) while (1) {
     d5 = d9 * +HEAPF64[i2 + (i3 << 3) >> 3];
     if (!i4) HEAPF64[i7 + (i3 << 3) >> 3] = d5; else HEAPF64[i7 + (i3 << 3) >> 3] = d5 + +HEAPF64[i4 >> 3] * d43;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i39 | 0)) break; else i4 = i4 + (i35 << 3) | 0;
    }
    i11 = i11 + 1 | 0;
    if ((i11 | 0) == (i38 | 0)) break; else {
     i7 = i7 + (i36 << 3) | 0;
     i10 = i10 + (i37 << 3) | 0;
     i8 = i8 + (i37 << 3) | 0;
    }
   }
  }
  i1 = HEAP32[i26 >> 2] | 0;
  if ((i1 | 0) != (i23 | 0)) {
   if (i1) __ZdaPv(i1);
   HEAP32[i26 >> 2] = i23;
   HEAP32[i22 >> 2] = 136;
  }
 } else {
  if (i8 & 2) {
   if ((i38 | 0) <= 0) break;
   i24 = (i30 | 0) == 0;
   i1 = (i39 | 0) > 0;
   i12 = i7 + -4 | 0;
   i25 = (i12 | 0) < 0;
   i2 = i7 & -4;
   i13 = i24 | (i7 | 0) < 1;
   i14 = i28;
   i19 = i29;
   i15 = 0;
   while (1) {
    if (i13) i23 = i24 ? i18 : i30; else {
     i4 = 0;
     do {
      HEAPF64[i30 + (i4 << 3) >> 3] = +HEAPF64[i18 + ((Math_imul(i4, i32) | 0) << 3) >> 3];
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i7 | 0));
     i23 = i30;
    }
    if (i1) {
     i22 = i34;
     i21 = i19;
     i20 = 0;
     while (1) {
      if (i25) {
       i16 = 0;
       d6 = 0.0;
       d9 = 0.0;
       d5 = 0.0;
       d17 = 0.0;
      } else {
       i16 = 0;
       d6 = 0.0;
       d9 = 0.0;
       d5 = 0.0;
       d17 = 0.0;
       do {
        d6 = d6 + +HEAPF64[i23 + (i16 << 3) >> 3] * +HEAPF64[i22 + (i16 << 3) >> 3];
        i26 = i16 | 1;
        d9 = d9 + +HEAPF64[i23 + (i26 << 3) >> 3] * +HEAPF64[i22 + (i26 << 3) >> 3];
        i26 = i16 | 2;
        d5 = d5 + +HEAPF64[i23 + (i26 << 3) >> 3] * +HEAPF64[i22 + (i26 << 3) >> 3];
        i26 = i16 | 3;
        d17 = d17 + +HEAPF64[i23 + (i26 << 3) >> 3] * +HEAPF64[i22 + (i26 << 3) >> 3];
        i16 = i16 + 4 | 0;
       } while ((i16 | 0) <= (i12 | 0));
       i16 = i2;
      }
      if ((i16 | 0) < (i7 | 0)) do {
       d6 = d6 + +HEAPF64[i23 + (i16 << 3) >> 3] * +HEAPF64[i22 + (i16 << 3) >> 3];
       i16 = i16 + 1 | 0;
      } while ((i16 | 0) != (i7 | 0));
      d6 = (d17 + (d5 + (d9 + d6))) * d42;
      if (!i21) HEAPF64[i14 + (i20 << 3) >> 3] = d6; else HEAPF64[i14 + (i20 << 3) >> 3] = d6 + +HEAPF64[i21 >> 3] * d43;
      i20 = i20 + 1 | 0;
      if ((i20 | 0) == (i39 | 0)) break; else {
       i22 = i22 + (i33 << 3) | 0;
       i21 = i21 + (i35 << 3) | 0;
      }
     }
    }
    i15 = i15 + 1 | 0;
    if ((i15 | 0) == (i38 | 0)) break L11; else {
     i14 = i14 + (i36 << 3) | 0;
     i18 = i18 + (i31 << 3) | 0;
     i19 = i19 + (i37 << 3) | 0;
    }
   }
  }
  i3 = i39 << 3;
  if (i3 >>> 0 < 1601) {
   if ((i38 | 0) <= 0) break;
   i10 = (i30 | 0) == 0;
   i3 = i39 + -4 | 0;
   i26 = (i3 | 0) < 0;
   i13 = (i7 | 0) > 0;
   i2 = i35 << 2;
   i25 = i35 << 1;
   i12 = i35 * 3 | 0;
   i20 = i3 >>> 2;
   i1 = (i20 << 2) + 4 | 0;
   i24 = i10 | i13 ^ 1;
   i11 = i28;
   i19 = i29;
   i27 = 0;
   i20 = i29 + (Math_imul(i35, (i20 << 5) + 32 | 0) | 0) | 0;
   while (1) {
    if (i24) i21 = i10 ? i18 : i30; else {
     i4 = 0;
     do {
      HEAPF64[i30 + (i4 << 3) >> 3] = +HEAPF64[i18 + ((Math_imul(i4, i32) | 0) << 3) >> 3];
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i7 | 0));
     i21 = i30;
    }
    if (i26) {
     i4 = i19;
     i8 = 0;
    } else {
     i23 = i19;
     i22 = 0;
     while (1) {
      if (i13) {
       i16 = i34 + (i22 << 3) | 0;
       i15 = 0;
       d9 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d17 = 0.0;
       while (1) {
        d46 = +HEAPF64[i21 + (i15 << 3) >> 3];
        d9 = d9 + d46 * +HEAPF64[i16 >> 3];
        d5 = d5 + d46 * +HEAPF64[i16 + 8 >> 3];
        d6 = d6 + d46 * +HEAPF64[i16 + 16 >> 3];
        d17 = d17 + d46 * +HEAPF64[i16 + 24 >> 3];
        i15 = i15 + 1 | 0;
        if ((i15 | 0) == (i7 | 0)) break; else i16 = i16 + (i33 << 3) | 0;
       }
      } else {
       d9 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d17 = 0.0;
      }
      d9 = d9 * d42;
      if (!i23) {
       HEAPF64[i11 + (i22 << 3) >> 3] = d9;
       HEAPF64[i11 + ((i22 | 1) << 3) >> 3] = d5 * d42;
       HEAPF64[i11 + ((i22 | 2) << 3) >> 3] = d6 * d42;
       HEAPF64[i11 + ((i22 | 3) << 3) >> 3] = d17 * d42;
      } else {
       HEAPF64[i11 + (i22 << 3) >> 3] = d9 + +HEAPF64[i23 >> 3] * d43;
       HEAPF64[i11 + ((i22 | 1) << 3) >> 3] = d5 * d42 + +HEAPF64[i23 + (i35 << 3) >> 3] * d43;
       HEAPF64[i11 + ((i22 | 2) << 3) >> 3] = d6 * d42 + +HEAPF64[i23 + (i25 << 3) >> 3] * d43;
       HEAPF64[i11 + ((i22 | 3) << 3) >> 3] = d17 * d42 + +HEAPF64[i23 + (i12 << 3) >> 3] * d43;
      }
      i22 = i22 + 4 | 0;
      if ((i22 | 0) > (i3 | 0)) {
       i4 = i20;
       i8 = i1;
       break;
      } else i23 = i23 + (i2 << 3) | 0;
     }
    }
    if ((i8 | 0) < (i39 | 0)) while (1) {
     if (i13) {
      i16 = i34 + (i8 << 3) | 0;
      i15 = 0;
      d6 = 0.0;
      while (1) {
       d6 = d6 + +HEAPF64[i21 + (i15 << 3) >> 3] * +HEAPF64[i16 >> 3];
       i15 = i15 + 1 | 0;
       if ((i15 | 0) == (i7 | 0)) break; else i16 = i16 + (i33 << 3) | 0;
      }
     } else d6 = 0.0;
     d6 = d6 * d42;
     if (!i4) HEAPF64[i11 + (i8 << 3) >> 3] = d6; else HEAPF64[i11 + (i8 << 3) >> 3] = d6 + +HEAPF64[i4 >> 3] * d43;
     i8 = i8 + 1 | 0;
     if ((i8 | 0) == (i39 | 0)) break; else i4 = i4 + (i35 << 3) | 0;
    }
    i27 = i27 + 1 | 0;
    if ((i27 | 0) == (i38 | 0)) break L11; else {
     i11 = i11 + (i36 << 3) | 0;
     i18 = i18 + (i31 << 3) | 0;
     i19 = i19 + (i37 << 3) | 0;
     i20 = i20 + (i37 << 3) | 0;
    }
   }
  }
  i10 = i27 + 8 | 0;
  HEAP32[i27 >> 2] = i10;
  i11 = i27 + 4 | 0;
  HEAP32[i11 >> 2] = 136;
  if (i39 >>> 0 > 136) {
   i25 = __Znaj(i39 >>> 0 > 536870911 ? -1 : i39 << 3) | 0;
   HEAP32[i27 >> 2] = i25;
  } else i25 = i10;
  HEAP32[i11 >> 2] = i39;
  if ((i38 | 0) > 0) {
   i19 = (i30 | 0) == 0;
   i20 = (i39 | 0) > 0;
   i21 = (i7 | 0) > 0;
   i22 = i39 + -4 | 0;
   i23 = (i22 | 0) < 0;
   i24 = i39 & -4;
   i26 = i19 | i21 ^ 1;
   i13 = i28;
   i12 = i29;
   i2 = 0;
   while (1) {
    if (i26) i14 = i19 ? i18 : i30; else {
     i4 = 0;
     do {
      HEAPF64[i30 + (i4 << 3) >> 3] = +HEAPF64[i18 + ((Math_imul(i4, i32) | 0) << 3) >> 3];
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i7 | 0));
     i14 = i30;
    }
    if (i20) _memset(i25 | 0, 0, i3 | 0) | 0;
    if (i21) {
     i15 = i34;
     i1 = 0;
     while (1) {
      d9 = +HEAPF64[i14 + (i1 << 3) >> 3];
      if (i23) i16 = 0; else {
       i16 = 0;
       do {
        i8 = i25 + (i16 << 3) | 0;
        i29 = i16 | 1;
        i28 = i25 + (i29 << 3) | 0;
        d5 = +HEAPF64[i28 >> 3] + d9 * +HEAPF64[i15 + (i29 << 3) >> 3];
        HEAPF64[i8 >> 3] = +HEAPF64[i8 >> 3] + d9 * +HEAPF64[i15 + (i16 << 3) >> 3];
        HEAPF64[i28 >> 3] = d5;
        i28 = i16 | 2;
        i8 = i25 + (i28 << 3) | 0;
        i29 = i16 | 3;
        i4 = i25 + (i29 << 3) | 0;
        d5 = +HEAPF64[i4 >> 3] + d9 * +HEAPF64[i15 + (i29 << 3) >> 3];
        HEAPF64[i8 >> 3] = +HEAPF64[i8 >> 3] + d9 * +HEAPF64[i15 + (i28 << 3) >> 3];
        HEAPF64[i4 >> 3] = d5;
        i16 = i16 + 4 | 0;
       } while ((i16 | 0) <= (i22 | 0));
       i16 = i24;
      }
      if ((i16 | 0) < (i39 | 0)) do {
       i4 = i25 + (i16 << 3) | 0;
       HEAPF64[i4 >> 3] = +HEAPF64[i4 >> 3] + d9 * +HEAPF64[i15 + (i16 << 3) >> 3];
       i16 = i16 + 1 | 0;
      } while ((i16 | 0) != (i39 | 0));
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i7 | 0)) break; else i15 = i15 + (i33 << 3) | 0;
     }
    }
    if (!i12) {
     if (i20) {
      i4 = 0;
      do {
       HEAPF64[i13 + (i4 << 3) >> 3] = +HEAPF64[i25 + (i4 << 3) >> 3] * d42;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i39 | 0));
     }
    } else if (i20) {
     i4 = i12;
     i8 = 0;
     while (1) {
      HEAPF64[i13 + (i8 << 3) >> 3] = +HEAPF64[i25 + (i8 << 3) >> 3] * d42 + +HEAPF64[i4 >> 3] * d43;
      i8 = i8 + 1 | 0;
      if ((i8 | 0) == (i39 | 0)) break; else i4 = i4 + (i35 << 3) | 0;
     }
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i38 | 0)) break; else {
     i13 = i13 + (i36 << 3) | 0;
     i18 = i18 + (i31 << 3) | 0;
     i12 = i12 + (i37 << 3) | 0;
    }
   }
  }
  if ((i25 | 0) != (i10 | 0)) {
   __ZdaPv(i25);
   HEAP32[i27 >> 2] = i10;
   HEAP32[i11 >> 2] = 136;
  }
 } while (0);
 i1 = HEAP32[i44 >> 2] | 0;
 if ((i1 | 0) == (i40 | 0)) {
  STACKTOP = i45;
  return;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i44 >> 2] = i40;
 HEAP32[i41 >> 2] = 136;
 STACKTOP = i45;
 return;
}

function __ZN2cv13mulTransposedERKNS_11_InputArrayERKNS_12_OutputArrayEbS2_di(i5, i8, i28, i6, d29, i4) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 i28 = i28 | 0;
 i6 = i6 | 0;
 d29 = +d29;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 608 | 0;
 i35 = i36 + 544 | 0;
 i34 = i36 + 488 | 0;
 i3 = i36 + 480 | 0;
 i2 = i36 + 472 | 0;
 i7 = i36 + 448 | 0;
 i33 = i36 + 392 | 0;
 i30 = i36 + 336 | 0;
 i15 = i36 + 312 | 0;
 i16 = i36 + 292 | 0;
 i17 = i36 + 272 | 0;
 i18 = i36 + 252 | 0;
 i19 = i36 + 232 | 0;
 i20 = i36 + 212 | 0;
 i21 = i36 + 192 | 0;
 i14 = i36 + 172 | 0;
 i22 = i36 + 152 | 0;
 i23 = i36 + 132 | 0;
 i24 = i36 + 112 | 0;
 i26 = i36 + 56 | 0;
 i25 = i36 + 32 | 0;
 i11 = i36 + 24 | 0;
 i12 = i36;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i5 >> 2] >> 2] & 63](i35, i5, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i6 >> 2] >> 2] & 63](i34, i6, -1);
 i1 = HEAP32[i35 >> 2] | 0;
 i10 = i1 & 4095;
 i9 = ((i4 | 0) > -1 ? i4 : i1) & 7;
 i4 = HEAP32[i34 >> 2] & 7;
 i9 = i9 >>> 0 < i4 >>> 0 ? i4 : i9;
 i9 = i9 >>> 0 < 5 ? 5 : i9;
 if (i1 & 4088) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i3, 19) | 0) + 0 | 0;
  i6 = 37632 | 0;
  i1 = i5 + 19 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 37656, 37256, 2772);
  __ZN2cv6String10deallocateEv(i3);
 }
 i32 = i34 + 16 | 0;
 if (HEAP32[i32 >> 2] | 0) {
  i6 = HEAP32[i34 + 4 >> 2] | 0;
  if ((i6 | 0) < 3) i5 = Math_imul(HEAP32[i34 + 12 >> 2] | 0, HEAP32[i34 + 8 >> 2] | 0) | 0; else {
   i4 = HEAP32[i34 + 40 >> 2] | 0;
   i3 = 0;
   i5 = 1;
   do {
    i5 = Math_imul(HEAP32[i4 + (i3 << 2) >> 2] | 0, i5) | 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i6 | 0));
  }
  if (i5) {
   i5 = HEAP32[i34 >> 2] | 0;
   if (!(((i5 & 4088 | 0) == 0 ? (i1 = HEAP32[i34 + 8 >> 2] | 0, (i1 | 0) == 1 ? 1 : (i1 | 0) == (HEAP32[i35 + 8 >> 2] | 0)) : 0) ? (i1 = HEAP32[i34 + 12 >> 2] | 0, (i1 | 0) == 1 ? 1 : (i1 | 0) == (HEAP32[i35 + 12 >> 2] | 0)) : 0)) {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    i5 = (__ZN2cv6String8allocateEj(i2, 115) | 0) + 0 | 0;
    i6 = 37672 | 0;
    i1 = i5 + 115 | 0;
    do {
     HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
     i5 = i5 + 1 | 0;
     i6 = i6 + 1 | 0;
    } while ((i5 | 0) < (i1 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 37656, 37256, 2778);
    __ZN2cv6String10deallocateEv(i2);
    i5 = HEAP32[i34 >> 2] | 0;
   }
   if ((i5 & 4095 | 0) != (i9 | 0)) {
    i1 = i7 + 4 | 0;
    HEAP32[i1 + 0 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i7 >> 2] = 32232;
    HEAP32[i1 >> 2] = 33619968;
    HEAP32[i7 + 8 >> 2] = i34;
    __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i34, i7, i9, 1.0, 0.0);
   }
  }
 }
 if (i28) i5 = HEAP32[i35 + 12 >> 2] | 0; else i5 = HEAP32[i35 + 8 >> 2] | 0;
 FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i8 >> 2] | 0) + 140 >> 2] & 63](i8, i5, i5, i9, -1, 0, 0);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i8 >> 2] >> 2] & 63](i33, i8, -1);
 i31 = i35 + 16 | 0;
 i27 = i33 + 16 | 0;
 do if ((HEAP32[i31 >> 2] | 0) == (HEAP32[i27 >> 2] | 0)) i13 = 24; else {
  if (((((i10 | 0) == (i9 | 0) ? (HEAP32[i33 + 12 >> 2] | 0) > 99 : 0) ? (HEAP32[i33 + 8 >> 2] | 0) > 99 : 0) ? (HEAP32[i35 + 12 >> 2] | 0) > 99 : 0) ? (HEAP32[i35 + 8 >> 2] | 0) > 99 : 0) {
   i13 = 24;
   break;
  }
  i3 = (i10 | 0) == 0;
  i1 = (i9 | 0) == 5;
  do if (!(i3 & i1)) {
   i2 = (i9 | 0) == 6;
   if (i3 & i2) {
    i3 = i28 ? 4 : 3;
    break;
   }
   i3 = (i10 | 0) == 2;
   if (i3 & i1) {
    i3 = i28 ? 6 : 5;
    break;
   }
   if (i3 & i2) {
    i3 = i28 ? 8 : 7;
    break;
   }
   i3 = (i10 | 0) == 3;
   if (i3 & i1) {
    i3 = i28 ? 10 : 9;
    break;
   }
   if (i3 & i2) {
    i3 = i28 ? 12 : 11;
    break;
   }
   i3 = (i10 | 0) == 5;
   if (i3 & i1) {
    i3 = i28 ? 14 : 13;
    break;
   }
   if (i3 & i2) {
    i3 = i28 ? 16 : 15;
    break;
   }
   if ((i10 | 0) == 6 & i2) {
    i3 = i28 ? 18 : 17;
    break;
   } else {
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    __ZN2cv6String8allocateEj(i11, 0) | 0;
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-210, i11, 37656, 37256, 2873);
    __ZN2cv6String10deallocateEv(i11);
    i3 = 0;
    break;
   }
  } else i3 = i28 ? 2 : 1; while (0);
  FUNCTION_TABLE_viiid[i3 & 31](i35, i33, i34, d29);
  i22 = i12 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  HEAP32[i12 >> 2] = 3136;
  HEAP32[i22 >> 2] = 50397184;
  HEAP32[i12 + 8 >> 2] = i33;
  __ZN2cv12completeSymmERKNS_17_InputOutputArrayEb(i12, 0);
 } while (0);
 if ((i13 | 0) == 24) {
  HEAP32[i30 >> 2] = 1124007936;
  i7 = i30 + 4 | 0;
  i3 = i30 + 8 | 0;
  i9 = i30 + 40 | 0;
  i5 = i7 + 0 | 0;
  i1 = i5 + 36 | 0;
  do {
   HEAP32[i5 >> 2] = 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) < (i1 | 0));
  HEAP32[i9 >> 2] = i3;
  i10 = i30 + 48 | 0;
  i8 = i30 + 44 | 0;
  HEAP32[i8 >> 2] = i10;
  HEAP32[i30 + 52 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  do if (HEAP32[i32 >> 2] | 0) {
   i6 = HEAP32[i34 + 4 >> 2] | 0;
   if ((i6 | 0) < 3) i3 = Math_imul(HEAP32[i34 + 12 >> 2] | 0, HEAP32[i34 + 8 >> 2] | 0) | 0; else {
    i5 = HEAP32[i34 + 40 >> 2] | 0;
    i4 = 0;
    i3 = 1;
    do {
     i3 = Math_imul(HEAP32[i5 + (i4 << 2) >> 2] | 0, i3) | 0;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i6 | 0));
   }
   if (i3) {
    i12 = HEAP32[i34 + 40 >> 2] | 0;
    i13 = HEAP32[i35 + 40 >> 2] | 0;
    if ((HEAP32[i12 >> 2] | 0) == (HEAP32[i13 >> 2] | 0) ? (HEAP32[i12 + 4 >> 2] | 0) == (HEAP32[i13 + 4 >> 2] | 0) : 0) {
     HEAP32[i15 >> 2] = 32088;
     HEAP32[i15 + 12 >> 2] = 0;
     HEAP32[i15 + 16 >> 2] = 0;
     HEAP32[i15 + 4 >> 2] = 16842752;
     HEAP32[i15 + 8 >> 2] = i35;
     HEAP32[i16 >> 2] = 32088;
     HEAP32[i16 + 12 >> 2] = 0;
     HEAP32[i16 + 16 >> 2] = 0;
     HEAP32[i16 + 4 >> 2] = 16842752;
     HEAP32[i16 + 8 >> 2] = i34;
     i3 = i17 + 4 | 0;
     HEAP32[i3 + 0 >> 2] = 0;
     HEAP32[i3 + 4 >> 2] = 0;
     HEAP32[i3 + 8 >> 2] = 0;
     HEAP32[i3 + 12 >> 2] = 0;
     HEAP32[i17 >> 2] = 32232;
     HEAP32[i3 >> 2] = 33619968;
     HEAP32[i17 + 8 >> 2] = i30;
     __ZN2cv8subtractERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i15, i16, i17, __ZN2cv7noArrayEv() | 0, -1);
     i3 = i30;
     break;
    } else {
     HEAP32[i18 >> 2] = 32088;
     HEAP32[i18 + 12 >> 2] = 0;
     HEAP32[i18 + 16 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 16842752;
     HEAP32[i18 + 8 >> 2] = i34;
     i15 = HEAP32[i35 + 8 >> 2] | 0;
     i16 = HEAP32[i34 + 8 >> 2] | 0;
     i17 = HEAP32[i35 + 12 >> 2] | 0;
     i3 = HEAP32[i34 + 12 >> 2] | 0;
     i13 = i19 + 4 | 0;
     HEAP32[i13 + 0 >> 2] = 0;
     HEAP32[i13 + 4 >> 2] = 0;
     HEAP32[i13 + 8 >> 2] = 0;
     HEAP32[i13 + 12 >> 2] = 0;
     HEAP32[i19 >> 2] = 32232;
     HEAP32[i13 >> 2] = 33619968;
     HEAP32[i19 + 8 >> 2] = i30;
     __ZN2cv6repeatERKNS_11_InputArrayEiiRKNS_12_OutputArrayE(i18, (i15 | 0) / (i16 | 0) | 0, (i17 | 0) / (i3 | 0) | 0, i19);
     HEAP32[i20 >> 2] = 32088;
     HEAP32[i20 + 12 >> 2] = 0;
     HEAP32[i20 + 16 >> 2] = 0;
     HEAP32[i20 + 4 >> 2] = 16842752;
     HEAP32[i20 + 8 >> 2] = i35;
     HEAP32[i21 >> 2] = 32088;
     HEAP32[i21 + 12 >> 2] = 0;
     HEAP32[i21 + 16 >> 2] = 0;
     HEAP32[i21 + 4 >> 2] = 16842752;
     HEAP32[i21 + 8 >> 2] = i30;
     i3 = i14 + 4 | 0;
     HEAP32[i3 + 0 >> 2] = 0;
     HEAP32[i3 + 4 >> 2] = 0;
     HEAP32[i3 + 8 >> 2] = 0;
     HEAP32[i3 + 12 >> 2] = 0;
     HEAP32[i14 >> 2] = 32232;
     HEAP32[i3 >> 2] = 33619968;
     HEAP32[i14 + 8 >> 2] = i30;
     __ZN2cv8subtractERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i20, i21, i14, __ZN2cv7noArrayEv() | 0, -1);
     i3 = i30;
     break;
    }
   } else i3 = i35;
  } else i3 = i35; while (0);
  HEAP32[i22 >> 2] = 32088;
  HEAP32[i22 + 12 >> 2] = 0;
  HEAP32[i22 + 16 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 16842752;
  HEAP32[i22 + 8 >> 2] = i3;
  HEAP32[i23 >> 2] = 32088;
  HEAP32[i23 + 12 >> 2] = 0;
  HEAP32[i23 + 16 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = 16842752;
  HEAP32[i23 + 8 >> 2] = i3;
  HEAP32[i26 >> 2] = 1124007936;
  i6 = i26 + 4 | 0;
  i3 = i26 + 8 | 0;
  i4 = i26 + 40 | 0;
  i5 = i6 + 0 | 0;
  i1 = i5 + 36 | 0;
  do {
   HEAP32[i5 >> 2] = 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) < (i1 | 0));
  HEAP32[i4 >> 2] = i3;
  i5 = i26 + 48 | 0;
  i1 = i26 + 44 | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i26 + 52 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i24 >> 2] = 32088;
  HEAP32[i24 + 12 >> 2] = 0;
  HEAP32[i24 + 16 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 16842752;
  HEAP32[i24 + 8 >> 2] = i26;
  i3 = i25 + 4 | 0;
  HEAP32[i3 + 0 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i25 >> 2] = 32232;
  HEAP32[i3 >> 2] = 33619968;
  HEAP32[i25 + 8 >> 2] = i33;
  __ZN2cv4gemmERKNS_11_InputArrayES2_dS2_dRKNS_12_OutputArrayEi(i22, i23, d29, i24, 0.0, i25, i28 ? 1 : 2);
  i3 = i26 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i26);
  HEAP32[i3 >> 2] = 0;
  i22 = i26 + 16 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   i3 = HEAP32[i4 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i6 >> 2] | 0));
  }
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i5 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = i30 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i30);
  HEAP32[i3 >> 2] = 0;
  i22 = i30 + 16 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i7 >> 2] | 0) > 0) {
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i7 >> 2] | 0));
  }
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) __ZN2cv8fastFreeEPv(i3);
 }
 i3 = i33 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i33);
 HEAP32[i3 >> 2] = 0;
 i1 = i33 + 4 | 0;
 HEAP32[i27 + 0 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 if ((HEAP32[i1 >> 2] | 0) > 0) {
  i3 = HEAP32[i33 + 40 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
 }
 i3 = HEAP32[i33 + 44 >> 2] | 0;
 if ((i3 | 0) != (i33 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
 i3 = i34 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i34);
 HEAP32[i3 >> 2] = 0;
 i1 = i34 + 4 | 0;
 HEAP32[i32 + 0 >> 2] = 0;
 HEAP32[i32 + 4 >> 2] = 0;
 HEAP32[i32 + 8 >> 2] = 0;
 HEAP32[i32 + 12 >> 2] = 0;
 if ((HEAP32[i1 >> 2] | 0) > 0) {
  i3 = HEAP32[i34 + 40 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
 }
 i1 = HEAP32[i34 + 44 >> 2] | 0;
 if ((i1 | 0) != (i34 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i35 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i35);
 HEAP32[i1 >> 2] = 0;
 i3 = i35 + 4 | 0;
 HEAP32[i31 + 0 >> 2] = 0;
 HEAP32[i31 + 4 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = 0;
 HEAP32[i31 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i35 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i35 + 44 >> 2] | 0;
 if ((i1 | 0) == (i35 + 48 | 0)) {
  STACKTOP = i36;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i36;
 return;
}

function __ZNK2cv11MatOp_AddEx6assignERKNS_7MatExprERNS_3MatEi(i1, i46, i47, i20) {
 i1 = i1 | 0;
 i46 = i46 | 0;
 i47 = i47 | 0;
 i20 = i20 | 0;
 var i2 = 0, d3 = 0.0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, d53 = 0.0;
 i52 = STACKTOP;
 STACKTOP = STACKTOP + 784 | 0;
 i50 = i52 + 720 | 0;
 i23 = i52 + 700 | 0;
 i24 = i52 + 680 | 0;
 i35 = i52 + 660 | 0;
 i37 = i52 + 640 | 0;
 i38 = i52 + 620 | 0;
 i39 = i52 + 600 | 0;
 i40 = i52 + 580 | 0;
 i41 = i52 + 560 | 0;
 i42 = i52 + 540 | 0;
 i43 = i52 + 520 | 0;
 i25 = i52 + 500 | 0;
 i26 = i52 + 480 | 0;
 i27 = i52 + 460 | 0;
 i28 = i52 + 440 | 0;
 i29 = i52 + 420 | 0;
 i30 = i52 + 400 | 0;
 i31 = i52 + 380 | 0;
 i32 = i52 + 360 | 0;
 i33 = i52 + 340 | 0;
 i34 = i52 + 320 | 0;
 i36 = i52 + 300 | 0;
 i7 = i52 + 280 | 0;
 i8 = i52 + 260 | 0;
 i9 = i52 + 240 | 0;
 i6 = i52 + 220 | 0;
 i10 = i52 + 200 | 0;
 i11 = i52 + 180 | 0;
 i12 = i52 + 160 | 0;
 i13 = i52 + 140 | 0;
 i14 = i52 + 120 | 0;
 i15 = i52 + 100 | 0;
 i16 = i52 + 80 | 0;
 i17 = i52 + 60 | 0;
 i18 = i52 + 40 | 0;
 i19 = i52 + 20 | 0;
 i44 = i52;
 HEAP32[i50 >> 2] = 1124007936;
 i51 = i50 + 4 | 0;
 i2 = i50 + 8 | 0;
 i48 = i50 + 40 | 0;
 i1 = i51 + 0 | 0;
 i5 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i5 | 0));
 HEAP32[i48 >> 2] = i2;
 i49 = i50 + 48 | 0;
 i45 = i50 + 44 | 0;
 HEAP32[i45 >> 2] = i49;
 HEAP32[i50 + 52 >> 2] = 0;
 HEAP32[i49 >> 2] = 0;
 if ((i20 | 0) != -1 ? (HEAP32[i46 + 8 >> 2] & 4095 | 0) != (i20 | 0) : 0) i21 = i50; else i21 = i47;
 i1 = i46 + 64 | 0;
 i5 = i46 + 192 | 0;
 L6 : do if (!(HEAP32[i46 + 80 >> 2] | 0)) {
  do if ((+HEAPF64[i46 + 200 >> 3] == 0.0 ? +HEAPF64[i46 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i46 + 216 >> 3] == 0.0 : 0) {
   d3 = +HEAPF64[i46 + 176 >> 3];
   if ((HEAP32[i21 + 16 >> 2] | 0) == (HEAP32[i47 + 16 >> 2] | 0) ? !(+Math_abs(+d3) != 1.0) : 0) break;
   i43 = i6 + 4 | 0;
   HEAP32[i43 + 0 >> 2] = 0;
   HEAP32[i43 + 4 >> 2] = 0;
   HEAP32[i43 + 8 >> 2] = 0;
   HEAP32[i43 + 12 >> 2] = 0;
   HEAP32[i6 >> 2] = 32232;
   HEAP32[i43 >> 2] = 33619968;
   HEAP32[i6 + 8 >> 2] = i47;
   __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i46 + 8 | 0, i6, i20, d3, +HEAPF64[i5 >> 3]);
   break L6;
  } while (0);
  d3 = +HEAPF64[i46 + 176 >> 3];
  if (d3 == 1.0) {
   HEAP32[i10 >> 2] = 32088;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i10 + 16 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 16842752;
   HEAP32[i10 + 8 >> 2] = i46 + 8;
   HEAP32[i11 >> 2] = 32088;
   HEAP32[i11 + 4 >> 2] = -1056833530;
   HEAP32[i11 + 8 >> 2] = i5;
   HEAP32[i11 + 12 >> 2] = 1;
   HEAP32[i11 + 16 >> 2] = 4;
   i22 = i12 + 4 | 0;
   HEAP32[i22 + 0 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   HEAP32[i22 + 12 >> 2] = 0;
   HEAP32[i12 >> 2] = 32232;
   HEAP32[i22 >> 2] = 33619968;
   HEAP32[i12 + 8 >> 2] = i21;
   __ZN2cv3addERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i10, i11, i12, __ZN2cv7noArrayEv() | 0, -1);
   i22 = 38;
   break;
  }
  if (d3 == -1.0) {
   HEAP32[i13 >> 2] = 32088;
   HEAP32[i13 + 4 >> 2] = -1056833530;
   HEAP32[i13 + 8 >> 2] = i5;
   HEAP32[i13 + 12 >> 2] = 1;
   HEAP32[i13 + 16 >> 2] = 4;
   HEAP32[i14 >> 2] = 32088;
   HEAP32[i14 + 12 >> 2] = 0;
   HEAP32[i14 + 16 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 16842752;
   HEAP32[i14 + 8 >> 2] = i46 + 8;
   i22 = i15 + 4 | 0;
   HEAP32[i22 + 0 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   HEAP32[i22 + 12 >> 2] = 0;
   HEAP32[i15 >> 2] = 32232;
   HEAP32[i22 >> 2] = 33619968;
   HEAP32[i15 + 8 >> 2] = i21;
   __ZN2cv8subtractERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i13, i14, i15, __ZN2cv7noArrayEv() | 0, -1);
   i22 = 38;
   break;
  } else {
   i22 = i46 + 8 | 0;
   i46 = i16 + 4 | 0;
   HEAP32[i46 + 0 >> 2] = 0;
   HEAP32[i46 + 4 >> 2] = 0;
   HEAP32[i46 + 8 >> 2] = 0;
   HEAP32[i46 + 12 >> 2] = 0;
   HEAP32[i16 >> 2] = 32232;
   HEAP32[i46 >> 2] = 33619968;
   HEAP32[i16 + 8 >> 2] = i21;
   __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i22, i16, HEAP32[i22 >> 2] & 4095, d3, 0.0);
   HEAP32[i17 >> 2] = 32088;
   HEAP32[i17 + 12 >> 2] = 0;
   HEAP32[i17 + 16 >> 2] = 0;
   HEAP32[i17 + 4 >> 2] = 16842752;
   HEAP32[i17 + 8 >> 2] = i21;
   HEAP32[i18 >> 2] = 32088;
   HEAP32[i18 + 4 >> 2] = -1056833530;
   HEAP32[i18 + 8 >> 2] = i5;
   HEAP32[i18 + 12 >> 2] = 1;
   HEAP32[i18 + 16 >> 2] = 4;
   i22 = i19 + 4 | 0;
   HEAP32[i22 + 0 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   HEAP32[i22 + 12 >> 2] = 0;
   HEAP32[i19 >> 2] = 32232;
   HEAP32[i22 >> 2] = 33619968;
   HEAP32[i19 + 8 >> 2] = i21;
   __ZN2cv3addERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i17, i18, i19, __ZN2cv7noArrayEv() | 0, -1);
   i22 = 38;
   break;
  }
 } else {
  d4 = +HEAPF64[i5 >> 3];
  d3 = +HEAPF64[i46 + 200 >> 3];
  if (d4 == 0.0 & d3 == 0.0 ? +HEAPF64[i46 + 208 >> 3] == 0.0 : 0) {
   if (d3 == 0.0 ? +HEAPF64[i46 + 216 >> 3] != 0.0 : 0) i22 = 9;
  } else i22 = 8;
  if ((i22 | 0) == 8 ? d3 == 0.0 : 0) i22 = 9;
  if (((i22 | 0) == 9 ? +HEAPF64[i46 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i46 + 216 >> 3] == 0.0 : 0) {
   HEAP32[i7 >> 2] = 32088;
   HEAP32[i7 + 12 >> 2] = 0;
   HEAP32[i7 + 16 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 16842752;
   HEAP32[i7 + 8 >> 2] = i46 + 8;
   d53 = +HEAPF64[i46 + 176 >> 3];
   HEAP32[i8 >> 2] = 32088;
   HEAP32[i8 + 12 >> 2] = 0;
   HEAP32[i8 + 16 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 16842752;
   HEAP32[i8 + 8 >> 2] = i1;
   d3 = +HEAPF64[i46 + 184 >> 3];
   i22 = i9 + 4 | 0;
   HEAP32[i22 + 0 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   HEAP32[i22 + 12 >> 2] = 0;
   HEAP32[i9 >> 2] = 32232;
   HEAP32[i22 >> 2] = 33619968;
   HEAP32[i9 + 8 >> 2] = i21;
   __ZN2cv11addWeightedERKNS_11_InputArrayEdS2_ddRKNS_12_OutputArrayEi(i7, d53, i8, d3, d4, i9, -1);
   i22 = 38;
   break;
  }
  d3 = +HEAPF64[i46 + 176 >> 3];
  d4 = +HEAPF64[i46 + 184 >> 3];
  i2 = d4 == 1.0;
  do if (d3 == 1.0) {
   if (i2) {
    HEAP32[i23 >> 2] = 32088;
    HEAP32[i23 + 12 >> 2] = 0;
    HEAP32[i23 + 16 >> 2] = 0;
    HEAP32[i23 + 4 >> 2] = 16842752;
    HEAP32[i23 + 8 >> 2] = i46 + 8;
    HEAP32[i24 >> 2] = 32088;
    HEAP32[i24 + 12 >> 2] = 0;
    HEAP32[i24 + 16 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 16842752;
    HEAP32[i24 + 8 >> 2] = i1;
    i43 = i35 + 4 | 0;
    HEAP32[i43 + 0 >> 2] = 0;
    HEAP32[i43 + 4 >> 2] = 0;
    HEAP32[i43 + 8 >> 2] = 0;
    HEAP32[i43 + 12 >> 2] = 0;
    HEAP32[i35 >> 2] = 32232;
    HEAP32[i43 >> 2] = 33619968;
    HEAP32[i35 + 8 >> 2] = i21;
    __ZN2cv3addERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i23, i24, i35, __ZN2cv7noArrayEv() | 0, -1);
    break;
   }
   if (d4 == -1.0) {
    HEAP32[i37 >> 2] = 32088;
    HEAP32[i37 + 12 >> 2] = 0;
    HEAP32[i37 + 16 >> 2] = 0;
    HEAP32[i37 + 4 >> 2] = 16842752;
    HEAP32[i37 + 8 >> 2] = i46 + 8;
    HEAP32[i38 >> 2] = 32088;
    HEAP32[i38 + 12 >> 2] = 0;
    HEAP32[i38 + 16 >> 2] = 0;
    HEAP32[i38 + 4 >> 2] = 16842752;
    HEAP32[i38 + 8 >> 2] = i1;
    i43 = i39 + 4 | 0;
    HEAP32[i43 + 0 >> 2] = 0;
    HEAP32[i43 + 4 >> 2] = 0;
    HEAP32[i43 + 8 >> 2] = 0;
    HEAP32[i43 + 12 >> 2] = 0;
    HEAP32[i39 >> 2] = 32232;
    HEAP32[i43 >> 2] = 33619968;
    HEAP32[i39 + 8 >> 2] = i21;
    __ZN2cv8subtractERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i37, i38, i39, __ZN2cv7noArrayEv() | 0, -1);
    break;
   } else {
    HEAP32[i40 >> 2] = 32088;
    HEAP32[i40 + 12 >> 2] = 0;
    HEAP32[i40 + 16 >> 2] = 0;
    HEAP32[i40 + 4 >> 2] = 16842752;
    HEAP32[i40 + 8 >> 2] = i1;
    HEAP32[i41 >> 2] = 32088;
    HEAP32[i41 + 12 >> 2] = 0;
    HEAP32[i41 + 16 >> 2] = 0;
    HEAP32[i41 + 4 >> 2] = 16842752;
    HEAP32[i41 + 8 >> 2] = i46 + 8;
    i43 = i42 + 4 | 0;
    HEAP32[i43 + 0 >> 2] = 0;
    HEAP32[i43 + 4 >> 2] = 0;
    HEAP32[i43 + 8 >> 2] = 0;
    HEAP32[i43 + 12 >> 2] = 0;
    HEAP32[i42 >> 2] = 32232;
    HEAP32[i43 >> 2] = 33619968;
    HEAP32[i42 + 8 >> 2] = i21;
    __ZN2cv8scaleAddERKNS_11_InputArrayEdS2_RKNS_12_OutputArrayE(i40, d4, i41, i42);
    break;
   }
  } else {
   if (!i2) {
    HEAP32[i30 >> 2] = 32088;
    HEAP32[i30 + 12 >> 2] = 0;
    HEAP32[i30 + 16 >> 2] = 0;
    HEAP32[i30 + 4 >> 2] = 16842752;
    HEAP32[i30 + 8 >> 2] = i46 + 8;
    HEAP32[i31 >> 2] = 32088;
    HEAP32[i31 + 12 >> 2] = 0;
    HEAP32[i31 + 16 >> 2] = 0;
    HEAP32[i31 + 4 >> 2] = 16842752;
    HEAP32[i31 + 8 >> 2] = i1;
    i43 = i32 + 4 | 0;
    HEAP32[i43 + 0 >> 2] = 0;
    HEAP32[i43 + 4 >> 2] = 0;
    HEAP32[i43 + 8 >> 2] = 0;
    HEAP32[i43 + 12 >> 2] = 0;
    HEAP32[i32 >> 2] = 32232;
    HEAP32[i43 >> 2] = 33619968;
    HEAP32[i32 + 8 >> 2] = i21;
    __ZN2cv11addWeightedERKNS_11_InputArrayEdS2_ddRKNS_12_OutputArrayEi(i30, d3, i31, d4, 0.0, i32, -1);
    break;
   }
   if (d3 == -1.0) {
    HEAP32[i43 >> 2] = 32088;
    HEAP32[i43 + 12 >> 2] = 0;
    HEAP32[i43 + 16 >> 2] = 0;
    HEAP32[i43 + 4 >> 2] = 16842752;
    HEAP32[i43 + 8 >> 2] = i1;
    HEAP32[i25 >> 2] = 32088;
    HEAP32[i25 + 12 >> 2] = 0;
    HEAP32[i25 + 16 >> 2] = 0;
    HEAP32[i25 + 4 >> 2] = 16842752;
    HEAP32[i25 + 8 >> 2] = i46 + 8;
    i42 = i26 + 4 | 0;
    HEAP32[i42 + 0 >> 2] = 0;
    HEAP32[i42 + 4 >> 2] = 0;
    HEAP32[i42 + 8 >> 2] = 0;
    HEAP32[i42 + 12 >> 2] = 0;
    HEAP32[i26 >> 2] = 32232;
    HEAP32[i42 >> 2] = 33619968;
    HEAP32[i26 + 8 >> 2] = i21;
    __ZN2cv8subtractERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i43, i25, i26, __ZN2cv7noArrayEv() | 0, -1);
    break;
   } else {
    HEAP32[i27 >> 2] = 32088;
    HEAP32[i27 + 12 >> 2] = 0;
    HEAP32[i27 + 16 >> 2] = 0;
    HEAP32[i27 + 4 >> 2] = 16842752;
    HEAP32[i27 + 8 >> 2] = i46 + 8;
    HEAP32[i28 >> 2] = 32088;
    HEAP32[i28 + 12 >> 2] = 0;
    HEAP32[i28 + 16 >> 2] = 0;
    HEAP32[i28 + 4 >> 2] = 16842752;
    HEAP32[i28 + 8 >> 2] = i1;
    i43 = i29 + 4 | 0;
    HEAP32[i43 + 0 >> 2] = 0;
    HEAP32[i43 + 4 >> 2] = 0;
    HEAP32[i43 + 8 >> 2] = 0;
    HEAP32[i43 + 12 >> 2] = 0;
    HEAP32[i29 >> 2] = 32232;
    HEAP32[i43 >> 2] = 33619968;
    HEAP32[i29 + 8 >> 2] = i21;
    __ZN2cv8scaleAddERKNS_11_InputArrayEdS2_RKNS_12_OutputArrayE(i27, d3, i28, i29);
    break;
   }
  } while (0);
  if ((+HEAPF64[i46 + 200 >> 3] == 0.0 ? +HEAPF64[i46 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i46 + 216 >> 3] == 0.0 : 0) {
   i22 = 38;
   break;
  }
  HEAP32[i33 >> 2] = 32088;
  HEAP32[i33 + 12 >> 2] = 0;
  HEAP32[i33 + 16 >> 2] = 0;
  HEAP32[i33 + 4 >> 2] = 16842752;
  HEAP32[i33 + 8 >> 2] = i21;
  HEAP32[i34 >> 2] = 32088;
  HEAP32[i34 + 4 >> 2] = -1056833530;
  HEAP32[i34 + 8 >> 2] = i5;
  HEAP32[i34 + 12 >> 2] = 1;
  HEAP32[i34 + 16 >> 2] = 4;
  i22 = i36 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  HEAP32[i36 >> 2] = 32232;
  HEAP32[i22 >> 2] = 33619968;
  HEAP32[i36 + 8 >> 2] = i21;
  __ZN2cv3addERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i33, i34, i36, __ZN2cv7noArrayEv() | 0, -1);
  i22 = 38;
 } while (0);
 if ((i22 | 0) == 38 ? (HEAP32[i21 + 16 >> 2] | 0) != (HEAP32[i47 + 16 >> 2] | 0) : 0) {
  i46 = i44 + 4 | 0;
  HEAP32[i46 + 0 >> 2] = 0;
  HEAP32[i46 + 4 >> 2] = 0;
  HEAP32[i46 + 8 >> 2] = 0;
  HEAP32[i46 + 12 >> 2] = 0;
  HEAP32[i44 >> 2] = 32232;
  HEAP32[i46 >> 2] = 33619968;
  HEAP32[i44 + 8 >> 2] = i47;
  __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i21, i44, HEAP32[i47 >> 2] & 4095, 1.0, 0.0);
 }
 i2 = i50 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i46 = i1 + 12 | 0, i47 = HEAP32[i46 >> 2] | 0, HEAP32[i46 >> 2] = i47 + -1, (i47 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i50);
 HEAP32[i2 >> 2] = 0;
 i47 = i50 + 16 | 0;
 HEAP32[i47 + 0 >> 2] = 0;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 0;
 HEAP32[i47 + 12 >> 2] = 0;
 if ((HEAP32[i51 >> 2] | 0) > 0) {
  i1 = HEAP32[i48 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i51 >> 2] | 0));
 }
 i1 = HEAP32[i45 >> 2] | 0;
 if ((i1 | 0) == (i49 | 0)) {
  STACKTOP = i52;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i52;
 return;
}

function __ZNSt3__17__sort5IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_S9_S9_T_(i23, i24, i21, i13, i1, i22) {
 i23 = i23 | 0;
 i24 = i24 | 0;
 i21 = i21 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i26 = i27;
 i25 = __ZNSt3__17__sort4IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_S9_T_(i23, i24, i21, i13, i22) | 0;
 if (!(FUNCTION_TABLE_iii[HEAP32[i22 >> 2] & 127](i1, i13) | 0)) {
  i22 = i25;
  STACKTOP = i27;
  return i22 | 0;
 }
 i4 = HEAP32[i13 >> 2] | 0;
 HEAP32[i26 >> 2] = i4;
 i6 = i26 + 4 | 0;
 i12 = i13 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
 if (i4) {
  i20 = i4 + -4 | 0;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
 }
 i9 = i26 + 8 | 0;
 i10 = i13 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = i4;
 i8 = i26 + 12 | 0;
 i16 = i13 + 12 | 0;
 HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
 if (i4) {
  i20 = i4 + -4 | 0;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
 }
 i14 = i13 + 16 | 0;
 __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i26 + 16 | 0, i14);
 i7 = i26 + 28 | 0;
 i17 = i13 + 28 | 0;
 HEAP32[i7 >> 2] = HEAP32[i17 >> 2];
 if ((i1 | 0) != (i13 | 0)) {
  __ZN2cv6String10deallocateEv(i13);
  i4 = HEAP32[i1 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i1 >> 2] | 0;
  }
  HEAP32[i13 >> 2] = i4;
  HEAP32[i12 >> 2] = HEAP32[i1 + 4 >> 2];
  i2 = i13 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i1 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i4 = 0; else {
   i20 = i3 + -4 | 0;
   HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
   i4 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i4;
  HEAP32[i16 >> 2] = HEAP32[i1 + 12 >> 2];
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i14, HEAP32[i1 + 16 >> 2] | 0, HEAP32[i1 + 20 >> 2] | 0);
 }
 i5 = i1 + 28 | 0;
 HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
 if ((i26 | 0) == (i1 | 0)) i1 = i26 + 16 | 0; else {
  __ZN2cv6String10deallocateEv(i1);
  i4 = HEAP32[i26 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i26 >> 2] | 0;
  }
  HEAP32[i1 >> 2] = i4;
  HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
  i2 = i1 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i26 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i4 = 0; else {
   i20 = i3 + -4 | 0;
   HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
   i4 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i4;
  HEAP32[i1 + 12 >> 2] = HEAP32[i8 >> 2];
  i20 = i26 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i1 + 16 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i26 + 20 >> 2] | 0);
  i1 = i20;
 }
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i4 = HEAP32[i1 >> 2] | 0;
 if (i4) {
  i3 = i26 + 20 | 0;
  while (1) {
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0)) break;
   i20 = i2 + -8 | 0;
   HEAP32[i3 >> 2] = i20;
   __ZN2cv6String10deallocateEv(i20);
  }
  __ZdlPv(HEAP32[i1 >> 2] | 0);
 }
 __ZN2cv6String10deallocateEv(i9);
 __ZN2cv6String10deallocateEv(i26);
 if (!(FUNCTION_TABLE_iii[HEAP32[i22 >> 2] & 127](i13, i21) | 0)) {
  i22 = i25 + 1 | 0;
  STACKTOP = i27;
  return i22 | 0;
 }
 i4 = HEAP32[i21 >> 2] | 0;
 HEAP32[i26 >> 2] = i4;
 i8 = i26 + 4 | 0;
 i15 = i21 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 if (i4) {
  i20 = i4 + -4 | 0;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
 }
 i6 = i26 + 8 | 0;
 i11 = i21 + 8 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i9 = i26 + 12 | 0;
 i19 = i21 + 12 | 0;
 HEAP32[i9 >> 2] = HEAP32[i19 >> 2];
 if (i4) {
  i20 = i4 + -4 | 0;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
 }
 i18 = i21 + 16 | 0;
 __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i26 + 16 | 0, i18);
 i7 = i26 + 28 | 0;
 i20 = i21 + 28 | 0;
 HEAP32[i7 >> 2] = HEAP32[i20 >> 2];
 if ((i13 | 0) != (i21 | 0)) {
  __ZN2cv6String10deallocateEv(i21);
  i4 = HEAP32[i13 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i21 >> 2] = i4;
  HEAP32[i15 >> 2] = HEAP32[i12 >> 2];
  i5 = i21 + 8 | 0;
  __ZN2cv6String10deallocateEv(i5);
  i4 = HEAP32[i10 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = i4;
  HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i18, HEAP32[i13 + 16 >> 2] | 0, HEAP32[i13 + 20 >> 2] | 0);
 }
 HEAP32[i20 >> 2] = HEAP32[i17 >> 2];
 if ((i26 | 0) == (i13 | 0)) i1 = i26 + 16 | 0; else {
  __ZN2cv6String10deallocateEv(i13);
  i4 = HEAP32[i26 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i26 >> 2] | 0;
  }
  HEAP32[i13 >> 2] = i4;
  HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
  i2 = i13 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i26 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i4 = 0; else {
   i13 = i3 + -4 | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   i4 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i4;
  HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
  i1 = i26 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i14, HEAP32[i1 >> 2] | 0, HEAP32[i26 + 20 >> 2] | 0);
 }
 HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
 i4 = HEAP32[i1 >> 2] | 0;
 if (i4) {
  i3 = i26 + 20 | 0;
  while (1) {
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0)) break;
   i17 = i2 + -8 | 0;
   HEAP32[i3 >> 2] = i17;
   __ZN2cv6String10deallocateEv(i17);
  }
  __ZdlPv(HEAP32[i1 >> 2] | 0);
 }
 __ZN2cv6String10deallocateEv(i6);
 __ZN2cv6String10deallocateEv(i26);
 if (!(FUNCTION_TABLE_iii[HEAP32[i22 >> 2] & 127](i21, i24) | 0)) {
  i22 = i25 + 2 | 0;
  STACKTOP = i27;
  return i22 | 0;
 }
 i4 = HEAP32[i24 >> 2] | 0;
 HEAP32[i26 >> 2] = i4;
 i6 = i26 + 4 | 0;
 i12 = i24 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
 if (i4) {
  i17 = i4 + -4 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 }
 i9 = i26 + 8 | 0;
 i10 = i24 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = i4;
 i8 = i26 + 12 | 0;
 i16 = i24 + 12 | 0;
 HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
 if (i4) {
  i17 = i4 + -4 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 }
 i13 = i24 + 16 | 0;
 __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i26 + 16 | 0, i13);
 i7 = i26 + 28 | 0;
 i14 = i24 + 28 | 0;
 HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
 if ((i21 | 0) != (i24 | 0)) {
  __ZN2cv6String10deallocateEv(i24);
  i4 = HEAP32[i21 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i21 >> 2] | 0;
  }
  HEAP32[i24 >> 2] = i4;
  HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
  i3 = i24 + 8 | 0;
  __ZN2cv6String10deallocateEv(i3);
  i4 = HEAP32[i11 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i4;
  HEAP32[i16 >> 2] = HEAP32[i19 >> 2];
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i13, HEAP32[i21 + 16 >> 2] | 0, HEAP32[i21 + 20 >> 2] | 0);
 }
 HEAP32[i14 >> 2] = HEAP32[i20 >> 2];
 if ((i26 | 0) == (i21 | 0)) i1 = i26 + 16 | 0; else {
  __ZN2cv6String10deallocateEv(i21);
  i4 = HEAP32[i26 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i26 >> 2] | 0;
  }
  HEAP32[i21 >> 2] = i4;
  HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
  i2 = i21 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i26 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i4 = 0; else {
   i21 = i3 + -4 | 0;
   HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
   i4 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i4;
  HEAP32[i19 >> 2] = HEAP32[i8 >> 2];
  i1 = i26 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i18, HEAP32[i1 >> 2] | 0, HEAP32[i26 + 20 >> 2] | 0);
 }
 HEAP32[i20 >> 2] = HEAP32[i7 >> 2];
 i4 = HEAP32[i1 >> 2] | 0;
 if (i4) {
  i3 = i26 + 20 | 0;
  while (1) {
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0)) break;
   i21 = i2 + -8 | 0;
   HEAP32[i3 >> 2] = i21;
   __ZN2cv6String10deallocateEv(i21);
  }
  __ZdlPv(HEAP32[i1 >> 2] | 0);
 }
 __ZN2cv6String10deallocateEv(i9);
 __ZN2cv6String10deallocateEv(i26);
 if (!(FUNCTION_TABLE_iii[HEAP32[i22 >> 2] & 127](i24, i23) | 0)) {
  i22 = i25 + 3 | 0;
  STACKTOP = i27;
  return i22 | 0;
 }
 i4 = HEAP32[i23 >> 2] | 0;
 HEAP32[i26 >> 2] = i4;
 i6 = i26 + 4 | 0;
 i3 = i23 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 if (i4) {
  i22 = i4 + -4 | 0;
  HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
 }
 i9 = i26 + 8 | 0;
 i4 = HEAP32[i23 + 8 >> 2] | 0;
 HEAP32[i9 >> 2] = i4;
 i7 = i26 + 12 | 0;
 i5 = i23 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 if (i4) {
  i22 = i4 + -4 | 0;
  HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
 }
 i2 = i23 + 16 | 0;
 __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i26 + 16 | 0, i2);
 i8 = i26 + 28 | 0;
 i1 = i23 + 28 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 if ((i24 | 0) != (i23 | 0)) {
  __ZN2cv6String10deallocateEv(i23);
  i4 = HEAP32[i24 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i24 >> 2] | 0;
  }
  HEAP32[i23 >> 2] = i4;
  HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
  i3 = i23 + 8 | 0;
  __ZN2cv6String10deallocateEv(i3);
  i4 = HEAP32[i10 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i4;
  HEAP32[i5 >> 2] = HEAP32[i16 >> 2];
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i2, HEAP32[i24 + 16 >> 2] | 0, HEAP32[i24 + 20 >> 2] | 0);
 }
 HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
 if ((i26 | 0) == (i24 | 0)) i4 = i26 + 16 | 0; else {
  __ZN2cv6String10deallocateEv(i24);
  i4 = HEAP32[i26 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i26 >> 2] | 0;
  }
  HEAP32[i24 >> 2] = i4;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  i2 = i24 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i26 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i4 = 0; else {
   i22 = i3 + -4 | 0;
   HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
   i4 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i4;
  HEAP32[i16 >> 2] = HEAP32[i7 >> 2];
  i4 = i26 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i13, HEAP32[i4 >> 2] | 0, HEAP32[i26 + 20 >> 2] | 0);
 }
 HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1) {
  i2 = i26 + 20 | 0;
  while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (i1 | 0)) break;
   i22 = i3 + -8 | 0;
   HEAP32[i2 >> 2] = i22;
   __ZN2cv6String10deallocateEv(i22);
  }
  __ZdlPv(HEAP32[i4 >> 2] | 0);
 }
 __ZN2cv6String10deallocateEv(i9);
 __ZN2cv6String10deallocateEv(i26);
 i22 = i25 + 4 | 0;
 STACKTOP = i27;
 return i22 | 0;
}

function __ZN4perf10Regression5writeERKN2cv11_InputArrayE(i13, i7) {
 i13 = i13 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i12 = i16 + 224 | 0;
 i15 = i16 + 168 | 0;
 i14 = i16 + 112 | 0;
 i6 = i16 + 56 | 0;
 i8 = i16;
 i1 = __ZN4perf10Regression5writeEv(i13) | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i3 = __ZN2cv6String8allocateEj(i12, 4) | 0;
 HEAP8[i3 >> 0] = 107;
 HEAP8[i3 + 1 >> 0] = 105;
 HEAP8[i3 + 2 >> 0] = 110;
 HEAP8[i3 + 3 >> 0] = 100;
 i1 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i1, i12) | 0;
 __ZN2cv6String10deallocateEv(i12);
 i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] & 127](i7) | 0;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 127](i1) | 0) {
  i2 = i1 + 32 | 0;
  if ((HEAP32[i2 >> 2] | 0) == 6) {
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   i5 = (__ZN2cv6String8allocateEj(i12, 30) | 0) + 0 | 0;
   i9 = 176840 | 0;
   i10 = i5 + 30 | 0;
   do {
    HEAP8[i5 >> 0] = HEAP8[i9 >> 0] | 0;
    i5 = i5 + 1 | 0;
    i9 = i9 + 1 | 0;
   } while ((i5 | 0) < (i10 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i12, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i12);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i1, i1 + 12 | 0, i3);
  if (HEAP32[i2 >> 2] & 4) HEAP32[i2 >> 2] = 6;
 }
 i3 = __ZN4perf10Regression5writeEv(i13) | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i2 = __ZN2cv6String8allocateEj(i12, 4) | 0;
 HEAP8[i2 >> 0] = 116;
 HEAP8[i2 + 1 >> 0] = 121;
 HEAP8[i2 + 2 >> 0] = 112;
 HEAP8[i2 + 3 >> 0] = 101;
 i3 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i3, i12) | 0;
 __ZN2cv6String10deallocateEv(i12);
 i2 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 56 >> 2] & 127](i7, -1) | 0;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] & 127](i3) | 0) {
  i1 = i3 + 32 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 6) {
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   i5 = (__ZN2cv6String8allocateEj(i12, 30) | 0) + 0 | 0;
   i9 = 176840 | 0;
   i10 = i5 + 30 | 0;
   do {
    HEAP8[i5 >> 0] = HEAP8[i9 >> 0] | 0;
    i5 = i5 + 1 | 0;
    i9 = i9 + 1 | 0;
   } while ((i5 | 0) < (i10 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i12, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i12);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i3, i3 + 12 | 0, i2);
  if (HEAP32[i1 >> 2] & 4) HEAP32[i1 >> 2] = 6;
 }
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] & 127](i7) | 0) != 327680 ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] & 127](i7) | 0) != 262144 : 0) i3 = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] & 127](i7) | 0) == 720896; else i3 = 1;
 i4 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2] & 127](i7, -1) | 0;
 if (!i3) {
  if ((Math_imul(FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 64 >> 2] & 127](i7, -1) | 0, i4) | 0) >>> 0 >= 26) {
   FUNCTION_TABLE_viii[HEAP32[HEAP32[i7 >> 2] >> 2] & 63](i8, i7, -1);
   __ZN4perf10Regression5writeEN2cv3MatE(i13, i8);
   i2 = i8 + 36 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i8);
   HEAP32[i2 >> 2] = 0;
   i10 = i8 + 16 | 0;
   i2 = i8 + 4 | 0;
   HEAP32[i10 + 0 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    i1 = HEAP32[i8 + 40 >> 2] | 0;
    i3 = 0;
    do {
     HEAP32[i1 + (i3 << 2) >> 2] = 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
   }
   i1 = HEAP32[i8 + 44 >> 2] | 0;
   if ((i1 | 0) == (i8 + 48 | 0)) {
    STACKTOP = i16;
    return;
   }
   __ZN2cv8fastFreeEPv(i1);
   STACKTOP = i16;
   return;
  }
  i2 = __ZN4perf10Regression5writeEv(i13) | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  i10 = __ZN2cv6String8allocateEj(i12, 3) | 0;
  HEAP8[i10 + 0 >> 0] = HEAP8[170112] | 0;
  HEAP8[i10 + 1 >> 0] = HEAP8[170113] | 0;
  HEAP8[i10 + 2 >> 0] = HEAP8[170114] | 0;
  i2 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i2, i12) | 0;
  __ZN2cv6String10deallocateEv(i12);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i7 >> 2] >> 2] & 63](i6, i7, -1);
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 127](i2) | 0) {
   i3 = i2 + 32 | 0;
   if ((HEAP32[i3 >> 2] | 0) == 6) {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    i5 = (__ZN2cv6String8allocateEj(i12, 30) | 0) + 0 | 0;
    i9 = 176840 | 0;
    i10 = i5 + 30 | 0;
    do {
     HEAP8[i5 >> 0] = HEAP8[i9 >> 0] | 0;
     i5 = i5 + 1 | 0;
     i9 = i9 + 1 | 0;
    } while ((i5 | 0) < (i10 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i12, 176872, 176888, 1062);
    __ZN2cv6String10deallocateEv(i12);
   }
   __ZN2cv5writeERNS_11FileStorageERKNS_6StringERKNS_3MatE(i2, i2 + 12 | 0, i6);
   if (HEAP32[i3 >> 2] & 4) HEAP32[i3 >> 2] = 6;
  }
  i1 = i6 + 36 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i9 = i2 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i6);
  HEAP32[i1 >> 2] = 0;
  i10 = i6 + 16 | 0;
  i2 = i6 + 4 | 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i6 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i1 = HEAP32[i6 + 44 >> 2] | 0;
  if ((i1 | 0) == (i6 + 48 | 0)) {
   STACKTOP = i16;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i16;
  return;
 }
 if (!i4) i1 = 0; else {
  i10 = i13;
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i10 = ___muldi3(HEAP32[i10 >> 2] | 0, 0, -130063606, 0) | 0;
  i1 = _i64Add(i10 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i10 = i13;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 4 >> 2] = tempRet0;
  i1 = (i1 >>> 0) % (i4 >>> 0) | 0;
 }
 i3 = __ZN4perf10Regression5writeEv(i13) | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i10 = __ZN2cv6String8allocateEj(i12, 3) | 0;
 HEAP8[i10 + 0 >> 0] = HEAP8[170704] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[170705] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[170706] | 0;
 i3 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i3, i12) | 0;
 __ZN2cv6String10deallocateEv(i12);
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] & 127](i3) | 0) {
  i2 = i3 + 32 | 0;
  if ((HEAP32[i2 >> 2] | 0) == 6) {
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   i5 = (__ZN2cv6String8allocateEj(i12, 30) | 0) + 0 | 0;
   i9 = 176840 | 0;
   i10 = i5 + 30 | 0;
   do {
    HEAP8[i5 >> 0] = HEAP8[i9 >> 0] | 0;
    i5 = i5 + 1 | 0;
    i9 = i9 + 1 | 0;
   } while ((i5 | 0) < (i10 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i12, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i12);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i3, i3 + 12 | 0, i4);
  if (HEAP32[i2 >> 2] & 4) HEAP32[i2 >> 2] = 6;
 }
 i3 = __ZN4perf10Regression5writeEv(i13) | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i10 = __ZN2cv6String8allocateEj(i12, 3) | 0;
 HEAP8[i10 + 0 >> 0] = HEAP8[170712] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[170713] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[170714] | 0;
 i3 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i3, i12) | 0;
 __ZN2cv6String10deallocateEv(i12);
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] & 127](i3) | 0) {
  i2 = i3 + 32 | 0;
  if ((HEAP32[i2 >> 2] | 0) == 6) {
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   i5 = (__ZN2cv6String8allocateEj(i12, 30) | 0) + 0 | 0;
   i9 = 176840 | 0;
   i10 = i5 + 30 | 0;
   do {
    HEAP8[i5 >> 0] = HEAP8[i9 >> 0] | 0;
    i5 = i5 + 1 | 0;
    i9 = i9 + 1 | 0;
   } while ((i5 | 0) < (i10 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i12, 176872, 176888, 1062);
   __ZN2cv6String10deallocateEv(i12);
  }
  __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i3, i3 + 12 | 0, i1);
  if (HEAP32[i2 >> 2] & 4) HEAP32[i2 >> 2] = 6;
 }
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i7 >> 2] >> 2] & 63](i15, i7, i1);
 i11 = i15 + 4 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 if ((i8 | 0) < 3) i3 = Math_imul(HEAP32[i15 + 12 >> 2] | 0, HEAP32[i15 + 8 >> 2] | 0) | 0; else {
  i2 = HEAP32[i15 + 40 >> 2] | 0;
  i1 = 0;
  i3 = 1;
  do {
   i3 = Math_imul(HEAP32[i2 + (i1 << 2) >> 2] | 0, i3) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
 }
 i2 = HEAP32[i15 >> 2] | 0;
 if ((Math_imul((i2 >>> 3 & 511) + 1 | 0, i3) | 0) >>> 0 < 26) {
  i3 = __ZN4perf10Regression5writeEv(i13) | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  i10 = __ZN2cv6String8allocateEj(i12, 3) | 0;
  HEAP8[i10 + 0 >> 0] = HEAP8[170112] | 0;
  HEAP8[i10 + 1 >> 0] = HEAP8[170113] | 0;
  HEAP8[i10 + 2 >> 0] = HEAP8[170114] | 0;
  i3 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i3, i12) | 0;
  __ZN2cv6String10deallocateEv(i12);
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] & 127](i3) | 0) {
   i2 = i3 + 32 | 0;
   if ((HEAP32[i2 >> 2] | 0) == 6) {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    i5 = (__ZN2cv6String8allocateEj(i12, 30) | 0) + 0 | 0;
    i9 = 176840 | 0;
    i10 = i5 + 30 | 0;
    do {
     HEAP8[i5 >> 0] = HEAP8[i9 >> 0] | 0;
     i5 = i5 + 1 | 0;
     i9 = i9 + 1 | 0;
    } while ((i5 | 0) < (i10 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i12, 176872, 176888, 1062);
    __ZN2cv6String10deallocateEv(i12);
   }
   __ZN2cv5writeERNS_11FileStorageERKNS_6StringERKNS_3MatE(i3, i3 + 12 | 0, i15);
   if (HEAP32[i2 >> 2] & 4) HEAP32[i2 >> 2] = 6;
  }
 } else {
  HEAP32[i14 >> 2] = i2;
  i5 = i14 + 4 | 0;
  HEAP32[i5 >> 2] = i8;
  i7 = i14 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  i2 = i14 + 16 | 0;
  HEAP32[i2 >> 2] = HEAP32[i15 + 16 >> 2];
  HEAP32[i14 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
  HEAP32[i14 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
  HEAP32[i14 + 28 >> 2] = HEAP32[i15 + 28 >> 2];
  HEAP32[i14 + 32 >> 2] = HEAP32[i15 + 32 >> 2];
  i1 = i14 + 36 | 0;
  i3 = HEAP32[i15 + 36 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  i4 = i14 + 40 | 0;
  HEAP32[i4 >> 2] = i7;
  i7 = i14 + 48 | 0;
  i6 = i14 + 44 | 0;
  HEAP32[i6 >> 2] = i7;
  HEAP32[i14 + 52 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  if (!i3) i3 = i8; else {
   i3 = i3 + 12 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = HEAP32[i11 >> 2] | 0;
  }
  if ((i3 | 0) < 3) {
   i9 = HEAP32[i15 + 44 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  } else {
   HEAP32[i5 >> 2] = 0;
   __ZN2cv3Mat8copySizeERKS0_(i14, i15);
  }
  __ZN4perf10Regression5writeEN2cv3MatE(i13, i14);
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != 0 ? (i9 = i3 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 + 0 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  if ((HEAP32[i5 >> 2] | 0) > 0) {
   i3 = HEAP32[i4 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i5 >> 2] | 0));
  }
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i7 | 0)) __ZN2cv8fastFreeEPv(i2);
 }
 i2 = i15 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i15);
 HEAP32[i2 >> 2] = 0;
 i10 = i15 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i11 >> 2] | 0) > 0) {
  i2 = HEAP32[i15 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i11 >> 2] | 0));
 }
 i1 = HEAP32[i15 + 44 >> 2] | 0;
 if ((i1 | 0) == (i15 + 48 | 0)) {
  STACKTOP = i16;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i16;
 return;
}

function __ZL12icvReadGraphP13CvFileStorageP10CvFileNode(i42, i13) {
 i42 = i42 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0;
 i45 = STACKTOP;
 STACKTOP = STACKTOP + 1280 | 0;
 i11 = i45;
 i12 = i45 + 632 | 0;
 i28 = i45 + 120 | 0;
 i8 = i45 + 112 | 0;
 i6 = i45 + 104 | 0;
 i4 = i45 + 96 | 0;
 i7 = i45 + 88 | 0;
 i23 = i45 + 1144 | 0;
 i29 = i45 + 80 | 0;
 i14 = i45 + 72 | 0;
 i15 = i45 + 64 | 0;
 i43 = i45 + 32 | 0;
 i44 = i45 + 28 | 0;
 i41 = i45 + 24 | 0;
 i39 = i45 + 16 | 0;
 i40 = i45 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 i1 = _cvGetFileNodeByName(i42, i13, 12488) | 0;
 if ((i1 | 0) != 0 ? (HEAP32[i1 >> 2] & 7 | 0) == 3 : 0) i5 = HEAP32[i1 + 12 >> 2] | 0; else i5 = 0;
 i1 = _cvGetFileNodeByName(i42, i13, 12536) | 0;
 if ((i1 | 0) != 0 ? (HEAP32[i1 >> 2] & 7 | 0) == 3 : 0) i38 = HEAP32[i1 + 12 >> 2] | 0; else i38 = 0;
 i1 = _cvGetFileNodeByName(i42, i13, 12568) | 0;
 if ((i1 | 0) != 0 ? (HEAP32[i1 >> 2] & 7 | 0) == 3 : 0) i37 = HEAP32[i1 + 12 >> 2] | 0; else i37 = 0;
 i1 = _cvGetFileNodeByName(i42, i13, 12520) | 0;
 do if (i1) {
  i2 = HEAP32[i1 >> 2] & 7;
  if ((i2 | 0) == 2) {
   i36 = _lrint(+HEAPF64[i1 + 8 >> 3]) | 0;
   break;
  } else if ((i2 | 0) == 1) {
   i36 = HEAP32[i1 + 8 >> 2] | 0;
   break;
  } else {
   i36 = 2147483647;
   break;
  }
 } else i36 = -1; while (0);
 i2 = _cvGetFileNodeByName(i42, i13, 12552) | 0;
 do if (i2) {
  i1 = HEAP32[i2 >> 2] & 7;
  if ((i1 | 0) == 1) {
   i35 = HEAP32[i2 + 8 >> 2] | 0;
   break;
  } else if ((i1 | 0) == 2) {
   i35 = _lrint(+HEAPF64[i2 + 8 >> 3]) | 0;
   break;
  } else {
   i35 = 2147483647;
   break;
  }
 } else i35 = -1; while (0);
 if (!((i37 | 0) != 0 & (((i5 | 0) == 0 | (i36 | 0) == -1 | (i35 | 0) == -1) ^ 1))) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i30 = (__ZN2cv6String8allocateEj(i6, 45) | 0) + 0 | 0;
  i31 = 12944;
  i32 = i30 + 45 | 0;
  do {
   HEAP8[i30 >> 0] = HEAP8[i31 >> 0] | 0;
   i30 = i30 + 1 | 0;
   i31 = i31 + 1 | 0;
  } while ((i30 | 0) < (i32 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i6, 12992, 8960, 4572);
  __ZN2cv6String10deallocateEv(i6);
 }
 if (!(_isxdigit(HEAP8[i5 >> 0] | 0) | 0)) i1 = (_strstr(i5, 12496) | 0) == 0; else {
  i2 = _strtol(i5, i8, 16) | 0;
  if (!((i2 & -65536 | 0) == 1117257728 ? (HEAP32[i8 >> 2] | 0) != (i5 | 0) : 0)) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i30 = (__ZN2cv6String8allocateEj(i4, 30) | 0) + 0 | 0;
   i31 = 13008;
   i32 = i30 + 30 | 0;
   do {
    HEAP8[i30 >> 0] = HEAP8[i31 >> 0] | 0;
    i30 = i30 + 1 | 0;
    i31 = i31 + 1 | 0;
   } while ((i30 | 0) < (i32 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i4, 12992, 8960, 4585);
   __ZN2cv6String10deallocateEv(i4);
  }
  i1 = (i2 & 4096 | 0) == 0;
 }
 i27 = i1 ? 1117261824 : 1117278208;
 i1 = _cvGetFileNodeByName(i42, i13, 12608) | 0;
 if ((i1 | 0) != 0 ? (HEAP32[i1 >> 2] & 7 | 0) == 3 : 0) i25 = HEAP32[i1 + 12 >> 2] | 0; else i25 = 0;
 i26 = _cvGetFileNodeByName(i42, i13, 12760) | 0;
 i4 = (i25 | 0) != 0;
 i24 = (i26 | 0) != 0;
 if (i4 ^ i24) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i30 = (__ZN2cv6String8allocateEj(i7, 74) | 0) + 0 | 0;
  i31 = 13040;
  i32 = i30 + 74 | 0;
  do {
   HEAP8[i30 >> 0] = HEAP8[i31 >> 0] | 0;
   i30 = i30 + 1 | 0;
   i31 = i31 + 1 | 0;
  } while ((i30 | 0) < (i32 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i7, 12992, 8960, 4600);
  __ZN2cv6String10deallocateEv(i7);
 }
 if (i4 ? (i22 = __ZL15icvDecodeFormatPKcPii(i25, i12) | 0, i3 = i22 << 1, (i22 | 0) > 0) : 0) {
  i1 = 0;
  i2 = 68;
  do {
   i22 = HEAP32[i12 + ((i1 | 1) << 2) >> 2] | 0;
   i22 = (i22 >>> 3 & 511) + 1 << (47696 >>> (i22 << 1 & 14) & 3);
   i2 = (i2 + -1 + i22 & 0 - i22) + (Math_imul(i22, HEAP32[i12 + (i1 << 2) >> 2] | 0) | 0) | 0;
   i1 = i1 + 2 | 0;
  } while ((i1 | 0) < (i3 | 0));
 } else i2 = 68;
 i9 = (i38 | 0) == 0;
 if (!i9) {
  i22 = __ZL15icvDecodeFormatPKcPii(i38, i12) | 0;
  i1 = i22 << 1;
  if ((i22 | 0) > 0) {
   i3 = 0;
   i4 = 0;
   do {
    i22 = HEAP32[i12 + ((i3 | 1) << 2) >> 2] | 0;
    i22 = (i22 >>> 3 & 511) + 1 << (47696 >>> (i22 << 1 & 14) & 3);
    i4 = (i4 + -1 + i22 & 0 - i22) + (Math_imul(i22, HEAP32[i12 + (i3 << 2) >> 2] | 0) | 0) | 0;
    i3 = i3 + 2 | 0;
   } while ((i3 | 0) < (i1 | 0));
   i1 = i4 + -1 | 0;
  } else i1 = -1;
  i7 = HEAP32[i12 + 4 >> 2] | 0;
  i7 = (i7 >>> 3 & 511) + 1 << (47696 >>> (i7 << 1 & 14) & 3);
  i7 = i1 + i7 & 0 - i7;
  i22 = __ZL15icvDecodeFormatPKcPii(i38, i12) | 0;
  i5 = i22 << 1;
  if ((i22 | 0) > 0) {
   i3 = 0;
   i4 = 8;
   do {
    i22 = HEAP32[i12 + ((i3 | 1) << 2) >> 2] | 0;
    i22 = (i22 >>> 3 & 511) + 1 << (47696 >>> (i22 << 1 & 14) & 3);
    i4 = (i4 + -1 + i22 & 0 - i22) + (Math_imul(i22, HEAP32[i12 + (i3 << 2) >> 2] | 0) | 0) | 0;
    i3 = i3 + 2 | 0;
   } while ((i3 | 0) < (i5 | 0));
  } else i4 = 8;
  i22 = __ZL15icvDecodeFormatPKcPii(i37, i28) | 0;
  i3 = i22 << 1;
  if ((i22 | 0) > 0) {
   i1 = 0;
   i5 = 0;
   do {
    i5 = (HEAP32[i28 + (i1 << 2) >> 2] | 0) + i5 | 0;
    i1 = i1 + 2 | 0;
   } while ((i1 | 0) < (i3 | 0));
   i6 = i28;
   i34 = i5;
  } else {
   i6 = i28;
   i34 = 0;
  }
 } else {
  i6 = i28;
  i7 = 0;
  i34 = 0;
  i4 = 8;
 }
 i5 = __ZL15icvDecodeFormatPKcPii(i37, i6) | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 if (!((((i5 | 0) > 1 & (i6 | 0) == 2 ? (HEAP32[i28 + 4 >> 2] | 0) == 4 : 0) ? (HEAP32[i28 + 8 >> 2] | 0) >= 1 : 0) ? (HEAP32[i28 + 12 >> 2] | 0) == 5 : 0)) {
  HEAP32[i29 >> 2] = 0;
  HEAP32[i29 + 4 >> 2] = 0;
  i30 = (__ZN2cv6String8allocateEj(i29, 52) | 0) + 0 | 0;
  i31 = 13120;
  i32 = i30 + 52 | 0;
  do {
   HEAP8[i30 >> 0] = HEAP8[i31 >> 0] | 0;
   i30 = i30 + 1 | 0;
   i31 = i31 + 1 | 0;
  } while ((i30 | 0) < (i32 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i29, 12992, 8960, 4626);
  __ZN2cv6String10deallocateEv(i29);
 }
 if ((i5 | 0) > 2) {
  i10 = HEAP32[i28 + 20 >> 2] | 0;
  i10 = ((i10 >>> 3 & 511) + 1 << (47696 >>> (i10 << 1 & 14) & 3) | 0) > 7 ? 8 : 4;
 } else i10 = 4;
 i1 = i5 << 1;
 L72 : do if ((i5 | 0) > 0) {
  i5 = 0;
  i3 = 2;
  while (1) {
   i5 = i6 + i5 | 0;
   if ((i3 | 0) >= (i1 | 0)) {
    i33 = i5;
    break L72;
   }
   i6 = HEAP32[i28 + (i3 << 2) >> 2] | 0;
   i3 = i3 + 2 | 0;
  }
 } else i33 = 0; while (0);
 i5 = i37 + 2 | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 if (i3 << 24 >> 24 == 49) if ((HEAP8[i37 + 3 >> 0] | 0) == 102) i6 = 54; else i6 = 55; else if (i3 << 24 >> 24 == 102) i6 = 54; else i6 = 55;
 if ((i6 | 0) == 54) i1 = i37 + ((i3 + -48 << 24 >> 24 & 255) < 10 ? 4 : 3) | 0; else if ((i6 | 0) == 55) {
  i22 = (_strtol(i5, i8, 10) | 0) + -1 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i11 >> 2] = i22;
  HEAP32[i11 + 4 >> 2] = i1;
  _sprintf(i23, 13176, i11) | 0;
  i1 = i23;
 }
 i22 = __ZL15icvDecodeFormatPKcPii(i1, i12) | 0;
 i3 = i22 << 1;
 if ((i22 | 0) > 0) {
  i5 = 0;
  i1 = 24;
  do {
   i22 = HEAP32[i12 + ((i5 | 1) << 2) >> 2] | 0;
   i22 = (i22 >>> 3 & 511) + 1 << (47696 >>> (i22 << 1 & 14) & 3);
   i1 = (i1 + -1 + i22 & 0 - i22) + (Math_imul(i22, HEAP32[i12 + (i5 << 2) >> 2] | 0) | 0) | 0;
   i5 = i5 + 2 | 0;
  } while ((i5 | 0) < (i3 | 0));
  i29 = i1;
 } else i29 = 24;
 i22 = __ZL15icvDecodeFormatPKcPii(i37, i12) | 0;
 i3 = i22 << 1;
 if ((i22 | 0) > 0) {
  i5 = 0;
  i1 = 0;
  do {
   i22 = HEAP32[i12 + ((i5 | 1) << 2) >> 2] | 0;
   i22 = (i22 >>> 3 & 511) + 1 << (47696 >>> (i22 << 1 & 14) & 3);
   i1 = (i1 + -1 + i22 & 0 - i22) + (Math_imul(i22, HEAP32[i12 + (i5 << 2) >> 2] | 0) | 0) | 0;
   i5 = i5 + 2 | 0;
  } while ((i5 | 0) < (i3 | 0));
  i1 = i1 + -1 | 0;
 } else i1 = -1;
 i28 = HEAP32[i12 + 4 >> 2] | 0;
 i28 = (i28 >>> 3 & 511) + 1 << (47696 >>> (i28 << 1 & 14) & 3);
 i28 = i1 + i28 & 0 - i28;
 i27 = _cvCreateGraph(i27, i2, i4, i29, HEAP32[i42 + 20 >> 2] | 0) | 0;
 if (i24) _cvReadRawData(i42, i26, i27 + 68 | 0, i25);
 i24 = i7 * 3 | 0;
 i24 = (i24 | 0) < 65536 ? 65536 : i24;
 i23 = i28 * 3 | 0;
 i23 = (i23 | 0) < (i24 | 0) ? i24 : i23;
 i24 = _cvAlloc(i23) | 0;
 i25 = _cvAlloc(i36 << 2) | 0;
 i26 = _cvGetFileNodeByName(i42, i13, 12584) | 0;
 i22 = _cvGetFileNodeByName(i42, i13, 12600) | 0;
 if (!i22) {
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  i30 = (__ZN2cv6String8allocateEj(i14, 13) | 0) + 0 | 0;
  i31 = 13184;
  i32 = i30 + 13 | 0;
  do {
   HEAP8[i30 >> 0] = HEAP8[i31 >> 0] | 0;
   i30 = i30 + 1 | 0;
   i31 = i31 + 1 | 0;
  } while ((i30 | 0) < (i32 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i14, 12992, 8960, 4662);
  __ZN2cv6String10deallocateEv(i14);
 }
 if (!(i9 | (i26 | 0) != 0)) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  i30 = (__ZN2cv6String8allocateEj(i15, 16) | 0) + 0 | 0;
  i31 = 13200;
  i32 = i30 + 16 | 0;
  do {
   HEAP8[i30 >> 0] = HEAP8[i31 >> 0] | 0;
   i30 = i30 + 1 | 0;
   i31 = i31 + 1 | 0;
  } while ((i30 | 0) < (i32 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i15, 12992, 8960, 4664);
  __ZN2cv6String10deallocateEv(i15);
 }
 i20 = i40 + 4 | 0;
 i21 = i10 + -1 | 0;
 i9 = 0 - i10 | 0;
 i10 = i39 + 4 | 0;
 i19 = 0;
 do {
  i11 = (i19 | 0) == 0;
  i12 = i11 ? i38 : i37;
  i6 = i11 ? i4 : i29;
  i13 = i11 ? i7 : i28;
  i14 = i11 ? i34 : i33;
  i15 = i11 ? i36 : i35;
  i16 = (i23 | 0) / (((i13 | 0) < 1 ? 1 : i13) | 0) | 0;
  i17 = (i12 | 0) != 0;
  if (i17) _cvStartReadRawData(i42, i11 ? i26 : i22, i43);
  if ((i15 | 0) > 0) {
   i18 = (i6 | 0) > 24;
   i1 = i6 + -24 | 0;
   i6 = i24;
   i8 = 0;
   i5 = 0;
   while (1) {
    if ((i5 | 0) == 0 & i17) {
     i5 = i15 - i8 | 0;
     i5 = Math_imul((i5 | 0) > (i16 | 0) ? i16 : i5, i14) | 0;
     _cvReadRawDataSlice(i42, i43, i5, i24, i12);
     i2 = i24;
    } else i2 = i6;
    do if (i11) {
     _cvGraphAddVtx(i27, 0, i44) | 0;
     HEAP32[i25 + (i8 << 2) >> 2] = HEAP32[i44 >> 2];
     if (!i17) break;
     _memcpy((HEAP32[i44 >> 2] | 0) + 8 | 0, i2 | 0, i13 | 0) | 0;
    } else {
     HEAP32[i41 >> 2] = 0;
     i6 = HEAP32[i2 >> 2] | 0;
     i3 = HEAP32[i2 + 4 >> 2] | 0;
     if (!(i6 >>> 0 < i36 >>> 0 & i3 >>> 0 < i36 >>> 0)) {
      HEAP32[i39 >> 2] = 0;
      HEAP32[i10 >> 2] = 0;
      i30 = (__ZN2cv6String8allocateEj(i39, 46) | 0) + 0 | 0;
      i31 = 13224;
      i32 = i30 + 46 | 0;
      do {
       HEAP8[i30 >> 0] = HEAP8[i31 >> 0] | 0;
       i30 = i30 + 1 | 0;
       i31 = i31 + 1 | 0;
      } while ((i30 | 0) < (i32 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i39, 12992, 8960, 4709);
      __ZN2cv6String10deallocateEv(i39);
     }
     if (!(_cvGraphAddEdgeByPtr(i27, HEAP32[i25 + (i6 << 2) >> 2] | 0, HEAP32[i25 + (i3 << 2) >> 2] | 0, 0, i41) | 0)) {
      HEAP32[i40 >> 2] = 0;
      HEAP32[i20 >> 2] = 0;
      i30 = (__ZN2cv6String8allocateEj(i40, 27) | 0) + 0 | 0;
      i31 = 13272;
      i32 = i30 + 27 | 0;
      do {
       HEAP8[i30 >> 0] = HEAP8[i31 >> 0] | 0;
       i30 = i30 + 1 | 0;
       i31 = i31 + 1 | 0;
      } while ((i30 | 0) < (i32 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i40, 12992, 8960, 4715);
      __ZN2cv6String10deallocateEv(i40);
     }
     f46 = Math_fround(HEAPF32[i2 + 8 >> 2]);
     i6 = HEAP32[i41 >> 2] | 0;
     HEAPF32[i6 + 4 >> 2] = f46;
     if (!i18) break;
     _memcpy(i6 + 24 | 0, i21 + (i2 + 12) & i9 | 0, i1 | 0) | 0;
    } while (0);
    i8 = i8 + 1 | 0;
    if ((i15 | 0) <= (i8 | 0)) break; else {
     i6 = i2 + i13 | 0;
     i5 = i5 + -1 | 0;
    }
   }
  }
  i19 = i19 + 1 | 0;
 } while ((i19 | 0) < 2);
 _cvFree_(i24);
 _cvFree_(i25);
 STACKTOP = i45;
 return i27 | 0;
}

function __ZNK2cv5MatOp4diagERKNS_7MatExprEiRS1_(i3, i28, i27, i22) {
 i3 = i3 | 0;
 i28 = i28 | 0;
 i27 = i27 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i1 = i30 + 256 | 0;
 i20 = i30 + 984 | 0;
 i18 = i30 + 928 | 0;
 i14 = i30 + 872 | 0;
 i25 = i30 + 816 | 0;
 i26 = i30 + 760 | 0;
 i29 = i30 + 704 | 0;
 i21 = i30 + 648 | 0;
 i11 = i30 + 32 | 0;
 i19 = i30 + 592 | 0;
 i13 = i30 + 536 | 0;
 i12 = i30 + 480 | 0;
 i2 = i30;
 if (!(FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 127](i3, i28) | 0)) {
  HEAP32[i21 >> 2] = 1124007936;
  i16 = i21 + 4 | 0;
  i3 = i21 + 8 | 0;
  i14 = i21 + 40 | 0;
  i23 = i16 + 0 | 0;
  i24 = i23 + 36 | 0;
  do {
   HEAP32[i23 >> 2] = 0;
   i23 = i23 + 4 | 0;
  } while ((i23 | 0) < (i24 | 0));
  HEAP32[i14 >> 2] = i3;
  i17 = i21 + 48 | 0;
  i15 = i21 + 44 | 0;
  HEAP32[i15 >> 2] = i17;
  HEAP32[i21 + 52 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
  i9 = HEAP32[i28 >> 2] | 0;
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] & 63](i9, i28, i21, -1);
  __ZNK2cv3Mat4diagEi(i19, i21, i27);
  HEAP32[i13 >> 2] = 1124007936;
  i9 = i13 + 4 | 0;
  i3 = i13 + 8 | 0;
  i7 = i13 + 40 | 0;
  i23 = i9 + 0 | 0;
  i24 = i23 + 36 | 0;
  do {
   HEAP32[i23 >> 2] = 0;
   i23 = i23 + 4 | 0;
  } while ((i23 | 0) < (i24 | 0));
  HEAP32[i7 >> 2] = i3;
  i10 = i13 + 48 | 0;
  i8 = i13 + 44 | 0;
  HEAP32[i8 >> 2] = i10;
  HEAP32[i13 + 52 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i12 >> 2] = 1124007936;
  i5 = i12 + 4 | 0;
  i3 = i12 + 8 | 0;
  i1 = i12 + 40 | 0;
  i23 = i5 + 0 | 0;
  i24 = i23 + 36 | 0;
  do {
   HEAP32[i23 >> 2] = 0;
   i23 = i23 + 4 | 0;
  } while ((i23 | 0) < (i24 | 0));
  HEAP32[i1 >> 2] = i3;
  i6 = i12 + 48 | 0;
  i4 = i12 + 44 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i12 + 52 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i2 + 0 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAP32[i2 + 24 >> 2] = 0;
  HEAP32[i2 + 28 >> 2] = 0;
  HEAPF64[i2 >> 3] = 0.0;
  __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i11, 33104, 0, i19, i13, i12, 1.0, 1.0, i2);
  i24 = i11;
  i2 = HEAP32[i24 + 4 >> 2] | 0;
  i23 = i22;
  HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i23 + 4 >> 2] = i2;
  __ZN2cv3MataSERKS0_(i22 + 8 | 0, i11 + 8 | 0) | 0;
  __ZN2cv3MataSERKS0_(i22 + 64 | 0, i11 + 64 | 0) | 0;
  __ZN2cv3MataSERKS0_(i22 + 120 | 0, i11 + 120 | 0) | 0;
  i23 = i22 + 176 | 0;
  i2 = i11 + 176 | 0;
  i24 = i23 + 48 | 0;
  do {
   HEAP32[i23 >> 2] = HEAP32[i2 >> 2];
   i23 = i23 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i23 | 0) < (i24 | 0));
  __ZN2cv7MatExprD2Ev(i11);
  i3 = i12 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i20 = i2 + 12 | 0, i22 = HEAP32[i20 >> 2] | 0, HEAP32[i20 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i12);
  HEAP32[i3 >> 2] = 0;
  i22 = i12 + 16 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i5 >> 2] | 0) > 0) {
   i3 = HEAP32[i1 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i5 >> 2] | 0));
  }
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) != (i6 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = i13 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i20 = i2 + 12 | 0, i22 = HEAP32[i20 >> 2] | 0, HEAP32[i20 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i13);
  HEAP32[i3 >> 2] = 0;
  i22 = i13 + 16 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i9 >> 2] | 0) > 0) {
   i3 = HEAP32[i7 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i9 >> 2] | 0));
  }
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = i19 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i20 = i2 + 12 | 0, i22 = HEAP32[i20 >> 2] | 0, HEAP32[i20 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i19);
  HEAP32[i3 >> 2] = 0;
  i22 = i19 + 16 | 0;
  i3 = i19 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i19 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i3 = HEAP32[i19 + 44 >> 2] | 0;
  if ((i3 | 0) != (i19 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
  i3 = i21 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i20 = i2 + 12 | 0, i22 = HEAP32[i20 >> 2] | 0, HEAP32[i20 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i21);
  HEAP32[i3 >> 2] = 0;
  i22 = i21 + 16 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i16 >> 2] | 0) > 0) {
   i3 = HEAP32[i14 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i16 >> 2] | 0));
  }
  i1 = HEAP32[i15 >> 2] | 0;
  if ((i1 | 0) == (i17 | 0)) {
   STACKTOP = i30;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i30;
  return;
 }
 i6 = HEAP32[i28 >> 2] | 0;
 i5 = HEAP32[i28 + 4 >> 2] | 0;
 HEAP32[i20 >> 2] = 1124007936;
 i17 = i20 + 4 | 0;
 i3 = i20 + 8 | 0;
 i15 = i20 + 40 | 0;
 i23 = i17 + 0 | 0;
 i24 = i23 + 36 | 0;
 do {
  HEAP32[i23 >> 2] = 0;
  i23 = i23 + 4 | 0;
 } while ((i23 | 0) < (i24 | 0));
 HEAP32[i15 >> 2] = i3;
 i19 = i20 + 48 | 0;
 i16 = i20 + 44 | 0;
 HEAP32[i16 >> 2] = i19;
 HEAP32[i20 + 52 >> 2] = 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i18 >> 2] = 1124007936;
 i4 = i18 + 4 | 0;
 i3 = i18 + 8 | 0;
 i12 = i18 + 40 | 0;
 i23 = i4 + 0 | 0;
 i24 = i23 + 36 | 0;
 do {
  HEAP32[i23 >> 2] = 0;
  i23 = i23 + 4 | 0;
 } while ((i23 | 0) < (i24 | 0));
 HEAP32[i12 >> 2] = i3;
 i13 = i18 + 48 | 0;
 i11 = i18 + 44 | 0;
 HEAP32[i11 >> 2] = i13;
 HEAP32[i18 + 52 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i14 >> 2] = 1124007936;
 i8 = i14 + 4 | 0;
 i3 = i14 + 8 | 0;
 i10 = i14 + 40 | 0;
 i23 = i8 + 0 | 0;
 i24 = i23 + 36 | 0;
 do {
  HEAP32[i23 >> 2] = 0;
  i23 = i23 + 4 | 0;
 } while ((i23 | 0) < (i24 | 0));
 HEAP32[i10 >> 2] = i3;
 i7 = i14 + 48 | 0;
 i9 = i14 + 44 | 0;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i1, i6, i5, i20, i18, i14, +HEAPF64[i28 + 176 >> 3], +HEAPF64[i28 + 184 >> 3], i28 + 192 | 0);
 i21 = i1;
 i6 = HEAP32[i21 + 4 >> 2] | 0;
 i5 = i22;
 HEAP32[i5 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = i22 + 8 | 0;
 __ZN2cv3MataSERKS0_(i5, i1 + 8 | 0) | 0;
 i6 = i22 + 64 | 0;
 __ZN2cv3MataSERKS0_(i6, i1 + 64 | 0) | 0;
 i21 = i22 + 120 | 0;
 __ZN2cv3MataSERKS0_(i21, i1 + 120 | 0) | 0;
 i23 = i22 + 176 | 0;
 i2 = i1 + 176 | 0;
 i24 = i23 + 48 | 0;
 do {
  HEAP32[i23 >> 2] = HEAP32[i2 >> 2];
  i23 = i23 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i23 | 0) < (i24 | 0));
 __ZN2cv7MatExprD2Ev(i1);
 i3 = i14 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i1 = i2 + 12 | 0, i22 = HEAP32[i1 >> 2] | 0, HEAP32[i1 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
 HEAP32[i3 >> 2] = 0;
 i22 = i14 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i8 >> 2] | 0) > 0) {
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i8 >> 2] | 0));
 }
 i3 = HEAP32[i9 >> 2] | 0;
 if ((i3 | 0) != (i7 | 0)) __ZN2cv8fastFreeEPv(i3);
 i3 = i18 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i14 = i2 + 12 | 0, i22 = HEAP32[i14 >> 2] | 0, HEAP32[i14 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i18);
 HEAP32[i3 >> 2] = 0;
 i22 = i18 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i4 >> 2] | 0) > 0) {
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i4 >> 2] | 0));
 }
 i3 = HEAP32[i11 >> 2] | 0;
 if ((i3 | 0) != (i13 | 0)) __ZN2cv8fastFreeEPv(i3);
 i3 = i20 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i18 = i2 + 12 | 0, i22 = HEAP32[i18 >> 2] | 0, HEAP32[i18 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i20);
 HEAP32[i3 >> 2] = 0;
 i22 = i20 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i17 >> 2] | 0) > 0) {
  i3 = HEAP32[i15 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i17 >> 2] | 0));
 }
 i3 = HEAP32[i16 >> 2] | 0;
 if ((i3 | 0) != (i19 | 0)) __ZN2cv8fastFreeEPv(i3);
 if (HEAP32[i28 + 24 >> 2] | 0) {
  __ZNK2cv3Mat4diagEi(i25, i28 + 8 | 0, i27);
  __ZN2cv3MataSERKS0_(i5, i25) | 0;
  i3 = i25 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i20 = i2 + 12 | 0, i22 = HEAP32[i20 >> 2] | 0, HEAP32[i20 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i25);
  HEAP32[i3 >> 2] = 0;
  i22 = i25 + 16 | 0;
  i3 = i25 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i25 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i3 = HEAP32[i25 + 44 >> 2] | 0;
  if ((i3 | 0) != (i25 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
 }
 if (HEAP32[i28 + 80 >> 2] | 0) {
  __ZNK2cv3Mat4diagEi(i26, i28 + 64 | 0, i27);
  __ZN2cv3MataSERKS0_(i6, i26) | 0;
  i3 = i26 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i20 = i2 + 12 | 0, i22 = HEAP32[i20 >> 2] | 0, HEAP32[i20 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i26);
  HEAP32[i3 >> 2] = 0;
  i22 = i26 + 16 | 0;
  i3 = i26 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i26 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i3 = HEAP32[i26 + 44 >> 2] | 0;
  if ((i3 | 0) != (i26 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
 }
 if (!(HEAP32[i28 + 136 >> 2] | 0)) {
  STACKTOP = i30;
  return;
 }
 __ZNK2cv3Mat4diagEi(i29, i28 + 120 | 0, i27);
 __ZN2cv3MataSERKS0_(i21, i29) | 0;
 i1 = i29 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i29);
 HEAP32[i1 >> 2] = 0;
 i22 = i29 + 16 | 0;
 i2 = i29 + 4 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i29 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i29 + 44 >> 2] | 0;
 if ((i1 | 0) == (i29 + 48 | 0)) {
  STACKTOP = i30;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i30;
 return;
}

function __ZN2cv14copyMakeBorderERKNS_11_InputArrayERKNS_12_OutputArrayEiiiiiRKNS_7Scalar_IdEE(i1, i13, i11, i4, i8, i3, i14, i16) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, d32 = 0.0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 2336 | 0;
 i28 = i31 + 1264 | 0;
 i2 = i31 + 1256 | 0;
 i30 = i31 + 1200 | 0;
 i6 = i31 + 1192 | 0;
 i5 = i31 + 1184 | 0;
 i29 = i31 + 1128 | 0;
 i12 = i31 + 1104 | 0;
 i26 = i31;
 i15 = i31 + 1096 | 0;
 if ((i4 | i11 | i8 | i3 | 0) <= -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i2, 50) | 0) + 0 | 0;
  i9 = 47072 | 0;
  i10 = i7 + 50 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i9 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i9 = i9 + 1 | 0;
  } while ((i7 | 0) < (i10 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 47128, 46680, 1149);
  __ZN2cv6String10deallocateEv(i2);
 }
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i1 >> 2] >> 2] & 63](i30, i1, -1);
 i7 = HEAP32[i30 >> 2] | 0;
 if ((i7 & 32768 | 0) != 0 & (i14 & 16 | 0) == 0) {
  HEAP32[i6 >> 2] = 0;
  i21 = i6 + 4 | 0;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i19 = i5 + 4 | 0;
  HEAP32[i19 >> 2] = 0;
  __ZNK2cv3Mat9locateROIERNS_5Size_IiEERNS_6Point_IiEE(i30, i6, i5);
  i19 = HEAP32[i19 >> 2] | 0;
  i22 = (i19 | 0) > (i11 | 0) ? i11 : i19;
  i1 = i30 + 8 | 0;
  i19 = (HEAP32[i21 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) - i19 | 0;
  i19 = (i19 | 0) > (i4 | 0) ? i4 : i19;
  i21 = HEAP32[i5 >> 2] | 0;
  i20 = (i21 | 0) > (i8 | 0) ? i8 : i21;
  i2 = i30 + 12 | 0;
  i21 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) - i21 | 0;
  i21 = (i21 | 0) > (i3 | 0) ? i3 : i21;
  __ZN2cv3Mat9adjustROIEiiii(i30, i22, i19, i20, i21) | 0;
  i4 = i4 - i19 | 0;
  i8 = i8 - i20 | 0;
  i3 = i3 - i21 | 0;
  i11 = i11 - i22 | 0;
 } else {
  i2 = i30 + 12 | 0;
  i1 = i30 + 8 | 0;
 }
 FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i13 >> 2] | 0) + 140 >> 2] & 63](i13, i4 + i11 + (HEAP32[i1 >> 2] | 0) | 0, i3 + i8 + (HEAP32[i2 >> 2] | 0) | 0, i7 & 4095, -1, 0, 0);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i13 >> 2] >> 2] & 63](i29, i13, -1);
 do if (i4 | i11 | i8 | i3) {
  i27 = i14 & -17;
  if (!i27) {
   i3 = HEAP32[i30 >> 2] | 0;
   i4 = (i3 >>> 3 & 511) + 1 | 0;
   i24 = i26 + 8 | 0;
   HEAP32[i26 >> 2] = i24;
   i25 = i26 + 4 | 0;
   HEAP32[i25 >> 2] = 136;
   if (i4 >>> 0 > 136) {
    i2 = __Znaj(i4 >>> 0 > 536870911 ? -1 : i4 << 3) | 0;
    HEAP32[i26 >> 2] = i2;
   } else i2 = i24;
   HEAP32[i25 >> 2] = i4;
   do if (i4 >>> 0 > 4) {
    d32 = +HEAPF64[i16 >> 3];
    if ((d32 == +HEAPF64[i16 + 8 >> 3] ? d32 == +HEAPF64[i16 + 16 >> 3] : 0) ? d32 == +HEAPF64[i16 + 24 >> 3] : 0) {
     i1 = 1;
     break;
    }
    HEAP32[i15 >> 2] = 0;
    HEAP32[i15 + 4 >> 2] = 0;
    i7 = (__ZN2cv6String8allocateEj(i15, 68) | 0) + 0 | 0;
    i9 = 47144 | 0;
    i10 = i7 + 68 | 0;
    do {
     HEAP8[i7 >> 0] = HEAP8[i9 >> 0] | 0;
     i7 = i7 + 1 | 0;
     i9 = i9 + 1 | 0;
    } while ((i7 | 0) < (i10 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i15, 47128, 46680, 1310);
    __ZN2cv6String10deallocateEv(i15);
    i3 = HEAP32[i30 >> 2] | 0;
    i2 = HEAP32[i26 >> 2] | 0;
    i1 = 1;
   } else i1 = i4; while (0);
   __ZN2cv15scalarToRawDataERKNS_7Scalar_IdEEPvii(i16, i2, i3 & 7 | (i1 << 3) + -8, i4);
   i7 = HEAP32[i30 + 16 >> 2] | 0;
   i16 = HEAP32[i30 + 48 >> 2] | 0;
   i15 = HEAP32[i30 + 40 >> 2] | 0;
   i4 = HEAP32[i15 + 4 >> 2] | 0;
   i15 = HEAP32[i15 >> 2] | 0;
   i20 = HEAP32[i29 + 16 >> 2] | 0;
   i21 = HEAP32[i29 + 48 >> 2] | 0;
   i6 = HEAP32[i29 + 40 >> 2] | 0;
   i5 = HEAP32[i6 + 4 >> 2] | 0;
   i6 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i30 + 4 >> 2] | 0;
   if ((i3 | 0) > 0) i3 = HEAP32[(HEAP32[i30 + 44 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0; else i3 = 0;
   i2 = HEAP32[i26 >> 2] | 0;
   i17 = Math_imul(i3, i5) | 0;
   i22 = i28 + 8 | 0;
   HEAP32[i28 >> 2] = i22;
   i23 = i28 + 4 | 0;
   HEAP32[i23 >> 2] = 1032;
   if (i17 >>> 0 > 1032) {
    i18 = __Znaj(i17) | 0;
    HEAP32[i28 >> 2] = i18;
   } else i18 = i22;
   HEAP32[i23 >> 2] = i17;
   i9 = i5 - (i4 + i8) | 0;
   i19 = i15 + i11 | 0;
   i10 = i6 - i19 | 0;
   if ((i5 | 0) > 0) {
    i14 = (i3 | 0) > 0;
    i12 = 0;
    do {
     if (i14) {
      i13 = Math_imul(i12, i3) | 0;
      i1 = 0;
      do {
       HEAP8[i18 + (i1 + i13) >> 0] = HEAP8[i2 + i1 >> 0] | 0;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i3 | 0));
     }
     i12 = i12 + 1 | 0;
    } while ((i12 | 0) != (i5 | 0));
   }
   i14 = Math_imul(i3, i4) | 0;
   i12 = Math_imul(i3, i8) | 0;
   i8 = Math_imul(i3, i9) | 0;
   if ((i15 | 0) > 0) {
    i4 = 0 - i12 | 0;
    i6 = i20 + (i12 + (Math_imul(i21, i11) | 0)) | 0;
    i5 = 0;
    while (1) {
     if ((i6 | 0) != (i7 | 0)) _memcpy(i6 | 0, i7 | 0, i14 | 0) | 0;
     _memcpy(i6 + i4 | 0, i18 | 0, i12 | 0) | 0;
     _memcpy(i6 + i14 | 0, i18 | 0, i8 | 0) | 0;
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i15 | 0)) break; else {
      i7 = i7 + i16 | 0;
      i6 = i6 + i21 | 0;
     }
    }
   }
   if ((i11 | 0) > 0) {
    i3 = 0;
    do {
     _memcpy(i20 + (Math_imul(i3, i21) | 0) | 0, i18 | 0, i17 | 0) | 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i11 | 0));
   }
   if ((i10 | 0) > 0) {
    i3 = 0;
    do {
     _memcpy(i20 + (Math_imul(i19 + i3 | 0, i21) | 0) | 0, i18 | 0, i17 | 0) | 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i10 | 0));
   }
   i3 = HEAP32[i28 >> 2] | 0;
   if ((i3 | 0) != (i22 | 0)) {
    if (i3) __ZdaPv(i3);
    HEAP32[i28 >> 2] = i22;
    HEAP32[i23 >> 2] = 1032;
   }
   i3 = HEAP32[i26 >> 2] | 0;
   if ((i3 | 0) == (i24 | 0)) break;
   if (i3) __ZdaPv(i3);
   HEAP32[i26 >> 2] = i24;
   HEAP32[i25 >> 2] = 136;
   break;
  }
  i13 = HEAP32[i30 + 16 >> 2] | 0;
  i19 = HEAP32[i30 + 48 >> 2] | 0;
  i25 = HEAP32[i30 + 40 >> 2] | 0;
  i14 = HEAP32[i25 + 4 >> 2] | 0;
  i25 = HEAP32[i25 >> 2] | 0;
  i24 = HEAP32[i29 + 16 >> 2] | 0;
  i26 = HEAP32[i29 + 48 >> 2] | 0;
  i7 = HEAP32[i29 + 40 >> 2] | 0;
  i20 = HEAP32[i7 + 4 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i30 + 4 >> 2] | 0;
  if ((i3 | 0) > 0) i3 = HEAP32[(HEAP32[i30 + 44 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0; else i3 = 0;
  if (!((i13 | i19 | i26 | i24 | i3) & 3)) {
   i3 = (i3 | 0) / 4 | 0;
   i16 = 4;
   i17 = 1;
  } else {
   i16 = 1;
   i17 = 0;
  }
  i6 = i20 - i14 | 0;
  i5 = Math_imul(i3, i6) | 0;
  i21 = i28 + 8 | 0;
  HEAP32[i28 >> 2] = i21;
  i22 = i28 + 4 | 0;
  HEAP32[i22 >> 2] = 264;
  if (i5 >>> 0 > 264) {
   i23 = __Znaj(i5 >>> 0 > 1073741823 ? -1 : i5 << 2) | 0;
   HEAP32[i28 >> 2] = i23;
  } else i23 = i21;
  HEAP32[i22 >> 2] = i5;
  i15 = i6 - i8 | 0;
  i18 = i7 - i11 - i25 | 0;
  if ((i8 | 0) > 0) {
   i10 = (i3 | 0) > 0;
   i6 = 0;
   do {
    i9 = Math_imul(__ZN2cv17borderInterpolateEiii(i6 - i8 | 0, i14, i27) | 0, i3) | 0;
    if (i10) {
     i7 = Math_imul(i6, i3) | 0;
     i5 = 0;
     do {
      HEAP32[i23 + (i5 + i7 << 2) >> 2] = i5 + i9;
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i3 | 0));
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) < (i8 | 0));
  }
  if ((i15 | 0) > 0) {
   i10 = (i3 | 0) > 0;
   i6 = 0;
   do {
    i9 = Math_imul(__ZN2cv17borderInterpolateEiii(i6 + i14 | 0, i14, i27) | 0, i3) | 0;
    if (i10) {
     i7 = Math_imul(i6 + i8 | 0, i3) | 0;
     i5 = 0;
     do {
      HEAP32[i23 + (i5 + i7 << 2) >> 2] = i5 + i9;
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i3 | 0));
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) < (i15 | 0));
  }
  i9 = Math_imul(i3, i14) | 0;
  i7 = Math_imul(i3, i8) | 0;
  i2 = Math_imul(i3, i15) | 0;
  if ((i25 | 0) > 0) {
   i4 = (i7 | 0) > 0;
   i5 = (i2 | 0) > 0;
   i6 = Math_imul(i9, i16) | 0;
   i12 = i24 + ((Math_imul(i7, i16) | 0) + (Math_imul(i26, i11) | 0)) | 0;
   i1 = 0;
   while (1) {
    if ((i12 | 0) != (i13 | 0)) _memcpy(i12 | 0, i13 | 0, i6 | 0) | 0;
    if (i17) {
     if (i4) {
      i14 = 0;
      do {
       HEAP32[i12 + (i14 - i7 << 2) >> 2] = HEAP32[i13 + (HEAP32[i23 + (i14 << 2) >> 2] << 2) >> 2];
       i14 = i14 + 1 | 0;
      } while ((i14 | 0) != (i7 | 0));
     }
     if (i5) {
      i14 = 0;
      do {
       HEAP32[i12 + (i14 + i9 << 2) >> 2] = HEAP32[i13 + (HEAP32[i23 + (i14 + i7 << 2) >> 2] << 2) >> 2];
       i14 = i14 + 1 | 0;
      } while ((i14 | 0) != (i2 | 0));
     }
    } else {
     if (i4) {
      i14 = 0;
      do {
       HEAP8[i12 + (i14 - i7) >> 0] = HEAP8[i13 + (HEAP32[i23 + (i14 << 2) >> 2] | 0) >> 0] | 0;
       i14 = i14 + 1 | 0;
      } while ((i14 | 0) != (i7 | 0));
     }
     if (i5) {
      i14 = 0;
      do {
       HEAP8[i12 + (i14 + i9) >> 0] = HEAP8[i13 + (HEAP32[i23 + (i14 + i7 << 2) >> 2] | 0) >> 0] | 0;
       i14 = i14 + 1 | 0;
      } while ((i14 | 0) != (i2 | 0));
     }
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i25 | 0)) break; else {
     i13 = i13 + i19 | 0;
     i12 = i12 + i26 | 0;
    }
   }
  }
  i1 = Math_imul(Math_imul(i16, i20) | 0, i3) | 0;
  if ((i11 | 0) > 0) {
   i3 = 0;
   do {
    _memcpy(i24 + (Math_imul(i3, i26) | 0) | 0, i24 + (Math_imul((__ZN2cv17borderInterpolateEiii(i3 - i11 | 0, i25, i27) | 0) + i11 | 0, i26) | 0) | 0, i1 | 0) | 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i11 | 0));
  }
  if ((i18 | 0) > 0) {
   i3 = i25 + i11 | 0;
   i2 = 0;
   do {
    _memcpy(i24 + (Math_imul(i3 + i2 | 0, i26) | 0) | 0, i24 + (Math_imul((__ZN2cv17borderInterpolateEiii(i2 + i25 | 0, i25, i27) | 0) + i11 | 0, i26) | 0) | 0, i1 | 0) | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (i18 | 0));
  }
  i3 = HEAP32[i28 >> 2] | 0;
  if ((i3 | 0) != (i21 | 0)) {
   if (i3) __ZdaPv(i3);
   HEAP32[i28 >> 2] = i21;
   HEAP32[i22 >> 2] = 264;
  }
 } else {
  if ((HEAP32[i30 + 16 >> 2] | 0) == (HEAP32[i29 + 16 >> 2] | 0) ? (HEAP32[i30 + 48 >> 2] | 0) == (HEAP32[i29 + 48 >> 2] | 0) : 0) break;
  i22 = i12 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  HEAP32[i12 >> 2] = 32232;
  HEAP32[i22 >> 2] = 33619968;
  HEAP32[i12 + 8 >> 2] = i29;
  __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i30, i12);
 } while (0);
 i2 = i29 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i29);
 HEAP32[i2 >> 2] = 0;
 i22 = i29 + 16 | 0;
 i3 = i29 + 4 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i29 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i29 + 44 >> 2] | 0;
 if ((i1 | 0) != (i29 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i30 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i30);
 HEAP32[i1 >> 2] = 0;
 i22 = i30 + 16 | 0;
 i2 = i30 + 4 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i30 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i30 + 44 >> 2] | 0;
 if ((i1 | 0) == (i30 + 48 | 0)) {
  STACKTOP = i31;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i31;
 return;
}

function __ZN2cvL15transpose_32sC6EPKhjPhjNS_5Size_IiEE(i16, i17, i14, i15, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i18 = STACKTOP;
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i13 + -4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i8 = i12 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i12 & -4;
  i11 = 0;
  do {
   i5 = i14 + (Math_imul(i11, i15) | 0) | 0;
   i4 = i14 + (Math_imul(i11 | 1, i15) | 0) | 0;
   i3 = i14 + (Math_imul(i11 | 2, i15) | 0) | 0;
   i2 = i14 + (Math_imul(i11 | 3, i15) | 0) | 0;
   if (i9) i7 = 0; else {
    i7 = i11 * 24 | 0;
    i6 = 0;
    do {
     i26 = (Math_imul(i6, i17) | 0) + i7 | 0;
     i30 = i16 + i26 | 0;
     i23 = i6 | 1;
     i24 = (Math_imul(i23, i17) | 0) + i7 | 0;
     i29 = i16 + i24 | 0;
     i21 = i6 | 2;
     i22 = (Math_imul(i21, i17) | 0) + i7 | 0;
     i28 = i16 + i22 | 0;
     i19 = i6 | 3;
     i20 = (Math_imul(i19, i17) | 0) + i7 | 0;
     i27 = i16 + i20 | 0;
     i25 = i5 + (i6 * 24 | 0) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i30 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i30 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i30 + 20 >> 2];
     i25 = i5 + (i23 * 24 | 0) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i29 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i29 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i29 + 20 >> 2];
     i25 = i5 + (i21 * 24 | 0) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i28 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i28 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i28 + 20 >> 2];
     i25 = i5 + (i19 * 24 | 0) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     i25 = i4 + (i6 * 24 | 0) | 0;
     i27 = i16 + (i26 + 24) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     i25 = i4 + (i23 * 24 | 0) | 0;
     i27 = i16 + (i24 + 24) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     i25 = i4 + (i21 * 24 | 0) | 0;
     i27 = i16 + (i22 + 24) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     i25 = i4 + (i19 * 24 | 0) | 0;
     i27 = i16 + (i20 + 24) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     i25 = i3 + (i6 * 24 | 0) | 0;
     i27 = i16 + (i26 + 48) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     i25 = i3 + (i23 * 24 | 0) | 0;
     i27 = i16 + (i24 + 48) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     i25 = i3 + (i21 * 24 | 0) | 0;
     i27 = i16 + (i22 + 48) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     i25 = i3 + (i19 * 24 | 0) | 0;
     i27 = i16 + (i20 + 48) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
     i25 = i2 + (i6 * 24 | 0) | 0;
     i26 = i16 + (i26 + 72) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i26 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i26 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i26 + 20 >> 2];
     i23 = i2 + (i23 * 24 | 0) | 0;
     i24 = i16 + (i24 + 72) | 0;
     HEAP32[i23 + 0 >> 2] = HEAP32[i24 + 0 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     HEAP32[i23 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
     HEAP32[i23 + 16 >> 2] = HEAP32[i24 + 16 >> 2];
     HEAP32[i23 + 20 >> 2] = HEAP32[i24 + 20 >> 2];
     i21 = i2 + (i21 * 24 | 0) | 0;
     i22 = i16 + (i22 + 72) | 0;
     HEAP32[i21 + 0 >> 2] = HEAP32[i22 + 0 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
     HEAP32[i21 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
     HEAP32[i21 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
     HEAP32[i21 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
     i19 = i2 + (i19 * 24 | 0) | 0;
     i20 = i16 + (i20 + 72) | 0;
     HEAP32[i19 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i19 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i19 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i19 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i8 | 0));
    i7 = i10;
   }
   if ((i7 | 0) < (i12 | 0)) {
    i6 = i11 * 24 | 0;
    do {
     i21 = (Math_imul(i7, i17) | 0) + i6 | 0;
     i20 = i16 + i21 | 0;
     i22 = i5 + (i7 * 24 | 0) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i22 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i22 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     i22 = i4 + (i7 * 24 | 0) | 0;
     i20 = i16 + (i21 + 24) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i22 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i22 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     i22 = i3 + (i7 * 24 | 0) | 0;
     i20 = i16 + (i21 + 48) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i22 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i22 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     i22 = i2 + (i7 * 24 | 0) | 0;
     i21 = i16 + (i21 + 72) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
     HEAP32[i22 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
     HEAP32[i22 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i12 | 0));
   }
   i11 = i11 + 4 | 0;
  } while ((i11 | 0) <= (i1 | 0));
  i1 = i13 & -4;
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i18;
  return;
 }
 i5 = i12 + -4 | 0;
 i6 = (i5 | 0) < 0;
 i7 = i12 & -4;
 do {
  i4 = i14 + (Math_imul(i1, i15) | 0) | 0;
  if (i6) i2 = 0; else {
   i2 = i1 * 24 | 0;
   i3 = 0;
   do {
    i10 = i16 + ((Math_imul(i3, i17) | 0) + i2) | 0;
    i11 = i3 | 1;
    i8 = i16 + ((Math_imul(i11, i17) | 0) + i2) | 0;
    i20 = i3 | 2;
    i19 = i16 + ((Math_imul(i20, i17) | 0) + i2) | 0;
    i22 = i3 | 3;
    i21 = i16 + ((Math_imul(i22, i17) | 0) + i2) | 0;
    i9 = i4 + (i3 * 24 | 0) | 0;
    HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
    HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
    i11 = i4 + (i11 * 24 | 0) | 0;
    HEAP32[i11 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i11 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    HEAP32[i11 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
    i20 = i4 + (i20 * 24 | 0) | 0;
    HEAP32[i20 + 0 >> 2] = HEAP32[i19 + 0 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i20 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    HEAP32[i20 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
    HEAP32[i20 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
    i22 = i4 + (i22 * 24 | 0) | 0;
    HEAP32[i22 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
    HEAP32[i22 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
    HEAP32[i22 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i5 | 0));
   i2 = i7;
  }
  if ((i2 | 0) < (i12 | 0)) {
   i3 = i1 * 24 | 0;
   do {
    i21 = i16 + ((Math_imul(i2, i17) | 0) + i3) | 0;
    i22 = i4 + (i2 * 24 | 0) | 0;
    HEAP32[i22 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
    HEAP32[i22 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
    HEAP32[i22 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i12 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i18;
 return;
}

function __ZN2cv21ImageCodecInitializerC2Ev(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i3 = i21 + 64 | 0;
 i7 = i21 + 56 | 0;
 i8 = i21 + 48 | 0;
 i9 = i21 + 40 | 0;
 i10 = i21 + 32 | 0;
 i11 = i21 + 24 | 0;
 i15 = i21 + 16 | 0;
 i16 = i21 + 8 | 0;
 i20 = i21;
 i14 = i13 + 4 | 0;
 i12 = i13 + 8 | 0;
 i17 = i13 + 12 | 0;
 i19 = i13 + 16 | 0;
 i18 = i13 + 20 | 0;
 HEAP32[i13 + 0 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = 0;
 HEAP32[i13 + 20 >> 2] = 0;
 i5 = __Znwj(1168) | 0;
 __ZN2cv10BmpDecoderC2Ev(i5);
 i2 = __Znwj(16) | 0;
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i2 >> 2] = 179016;
 HEAP32[i2 + 8 >> 2] = i5;
 HEAP32[i3 >> 2] = i2;
 i6 = i3 + 4 | 0;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i5 = HEAP32[i14 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i12 >> 2] | 0)) __ZNSt3__16vectorIN2cv3PtrINS1_16BaseImageDecoderEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i13, i3); else {
  if (i5) {
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = HEAP32[i6 >> 2];
   if (i4) {
    i5 = i4 + 4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i5 = HEAP32[i14 >> 2] | 0;
   }
  } else i5 = 0;
  HEAP32[i14 >> 2] = i5 + 8;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 if ((i5 | 0) != 0 ? (i22 = i5 + 4 | 0, i4 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i4 + -1, (i4 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 511](i5);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i6 + -1;
 if ((i6 | 0) == 1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] & 511](i2);
 i5 = __Znwj(36) | 0;
 __ZN2cv10BmpEncoderC2Ev(i5);
 i3 = __Znwj(16) | 0;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i3 >> 2] = 178904;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i7 >> 2] = i3;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i5 = HEAP32[i19 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i18 >> 2] | 0)) __ZNSt3__16vectorIN2cv3PtrINS1_16BaseImageEncoderEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i17, i7); else {
  if (i5) {
   i4 = HEAP32[i7 >> 2] | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   if (i4) {
    i5 = i4 + 4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i5 = HEAP32[i19 >> 2] | 0;
   }
  } else i5 = 0;
  HEAP32[i19 >> 2] = i5 + 8;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 if ((i5 | 0) != 0 ? (i4 = i5 + 4 | 0, i6 = HEAP32[i4 >> 2] | 0, HEAP32[i4 >> 2] = i6 + -1, (i6 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 511](i5);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7 + -1;
 if ((i7 | 0) == 1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
 i5 = __Znwj(104) | 0;
 __ZN2cv10HdrDecoderC2Ev(i5);
 i3 = __Znwj(16) | 0;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i3 >> 2] = 178792;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i8 >> 2] = i3;
 i1 = i8 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i5 = HEAP32[i14 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i12 >> 2] | 0)) __ZNSt3__16vectorIN2cv3PtrINS1_16BaseImageDecoderEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i13, i8); else {
  if (i5) {
   i4 = HEAP32[i8 >> 2] | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   if (i4) {
    i5 = i4 + 4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i5 = HEAP32[i14 >> 2] | 0;
   }
  } else i5 = 0;
  HEAP32[i14 >> 2] = i5 + 8;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 if ((i5 | 0) != 0 ? (i6 = i5 + 4 | 0, i7 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i7 + -1, (i7 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 511](i5);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i8 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i8 + -1;
 if ((i8 | 0) == 1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
 i5 = __Znwj(36) | 0;
 __ZN2cv10HdrEncoderC2Ev(i5);
 i3 = __Znwj(16) | 0;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i3 >> 2] = 178680;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i9 >> 2] = i3;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i5 = HEAP32[i19 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i18 >> 2] | 0)) __ZNSt3__16vectorIN2cv3PtrINS1_16BaseImageEncoderEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i17, i9); else {
  if (i5) {
   i4 = HEAP32[i9 >> 2] | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   if (i4) {
    i5 = i4 + 4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i5 = HEAP32[i19 >> 2] | 0;
   }
  } else i5 = 0;
  HEAP32[i19 >> 2] = i5 + 8;
 }
 i5 = HEAP32[i9 >> 2] | 0;
 if ((i5 | 0) != 0 ? (i7 = i5 + 4 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 511](i5);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i9 + -1;
 if ((i9 | 0) == 1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
 i5 = __Znwj(1172) | 0;
 __ZN2cv16SunRasterDecoderC2Ev(i5);
 i3 = __Znwj(16) | 0;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i3 >> 2] = 178560;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i10 >> 2] = i3;
 i1 = i10 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i5 = HEAP32[i14 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i12 >> 2] | 0)) __ZNSt3__16vectorIN2cv3PtrINS1_16BaseImageDecoderEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i13, i10); else {
  if (i5) {
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   if (i4) {
    i5 = i4 + 4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i5 = HEAP32[i14 >> 2] | 0;
   }
  } else i5 = 0;
  HEAP32[i14 >> 2] = i5 + 8;
 }
 i5 = HEAP32[i10 >> 2] | 0;
 if ((i5 | 0) != 0 ? (i8 = i5 + 4 | 0, i9 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 511](i5);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i10 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i10 + -1;
 if ((i10 | 0) == 1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
 i5 = __Znwj(36) | 0;
 __ZN2cv16SunRasterEncoderC2Ev(i5);
 i3 = __Znwj(16) | 0;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i3 >> 2] = 178440;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i11 >> 2] = i3;
 i1 = i11 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i5 = HEAP32[i19 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i18 >> 2] | 0)) __ZNSt3__16vectorIN2cv3PtrINS1_16BaseImageEncoderEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i17, i11); else {
  if (i5) {
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   if (i4) {
    i5 = i4 + 4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i5 = HEAP32[i19 >> 2] | 0;
   }
  } else i5 = 0;
  HEAP32[i19 >> 2] = i5 + 8;
 }
 i5 = HEAP32[i11 >> 2] | 0;
 if ((i5 | 0) != 0 ? (i9 = i5 + 4 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 511](i5);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i10 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i10 + -1;
 if ((i10 | 0) == 1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
 i2 = __Znwj(1168) | 0;
 __ZN2cv10PxMDecoderC2Ev(i2);
 i4 = __Znwj(16) | 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i4 >> 2] = 178328;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i15 >> 2] = i4;
 i1 = i15 + 4 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i12 >> 2] | 0)) __ZNSt3__16vectorIN2cv3PtrINS1_16BaseImageDecoderEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i13, i15); else {
  do if (!i2) i2 = 0; else {
   i5 = HEAP32[i15 >> 2] | 0;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
   if (!i5) break;
   i2 = i5 + 4 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   i2 = HEAP32[i14 >> 2] | 0;
  } while (0);
  HEAP32[i14 >> 2] = i2 + 8;
 }
 i2 = HEAP32[i15 >> 2] | 0;
 do if (i2) {
  i9 = i2 + 4 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i10 + -1;
  if ((i10 | 0) != 1) break;
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] & 511](i2);
 } while (0);
 HEAP32[i15 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i10 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i10 + -1;
 if ((i10 | 0) == 1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] & 511](i4);
 i2 = __Znwj(36) | 0;
 __ZN2cv10PxMEncoderC2Ev(i2);
 i5 = __Znwj(16) | 0;
 i4 = i5 + 4 | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i5 >> 2] = 178216;
 HEAP32[i5 + 8 >> 2] = i2;
 HEAP32[i16 >> 2] = i5;
 i3 = i16 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i2 = HEAP32[i19 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i18 >> 2] | 0)) __ZNSt3__16vectorIN2cv3PtrINS1_16BaseImageEncoderEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i17, i16); else {
  do if (!i2) i2 = 0; else {
   i1 = HEAP32[i16 >> 2] | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
   if (!i1) break;
   i2 = i1 + 4 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   i2 = HEAP32[i19 >> 2] | 0;
  } while (0);
  HEAP32[i19 >> 2] = i2 + 8;
 }
 i2 = HEAP32[i16 >> 2] | 0;
 do if (i2) {
  i9 = i2 + 4 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i10 + -1;
  if ((i10 | 0) != 1) break;
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] & 511](i2);
 } while (0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i10 + -1;
 if ((i10 | 0) == 1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 511](i5);
 i1 = __Znwj(36) | 0;
 __ZN2cv11TiffEncoderC2Ev(i1);
 i3 = __Znwj(16) | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i3 >> 2] = 178104;
 HEAP32[i3 + 8 >> 2] = i1;
 HEAP32[i20 >> 2] = i3;
 i5 = i20 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i1 = HEAP32[i19 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i18 >> 2] | 0)) __ZNSt3__16vectorIN2cv3PtrINS1_16BaseImageEncoderEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i17, i20); else {
  do if (!i1) i1 = 0; else {
   i2 = HEAP32[i20 >> 2] | 0;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
   if (!i2) break;
   i1 = i2 + 4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = HEAP32[i19 >> 2] | 0;
  } while (0);
  HEAP32[i19 >> 2] = i1 + 8;
 }
 i1 = HEAP32[i20 >> 2] | 0;
 do if (i1) {
  i9 = i1 + 4 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i10 + -1;
  if ((i10 | 0) != 1) break;
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 } while (0);
 HEAP32[i20 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i10 + -1;
 if ((i10 | 0) != 1) {
  STACKTOP = i21;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
 STACKTOP = i21;
 return;
}

function _build_tree(i21, i17) {
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i23 = i24;
 i22 = HEAP32[i17 >> 2] | 0;
 i18 = i17 + 8 | 0;
 i13 = HEAP32[i18 >> 2] | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 12 >> 2] | 0;
 i16 = i21 + 5200 | 0;
 HEAP32[i16 >> 2] = 0;
 i19 = i21 + 5204 | 0;
 HEAP32[i19 >> 2] = 573;
 if ((i13 | 0) > 0) {
  i3 = -1;
  i4 = 0;
  do {
   if (!(HEAP16[i22 + (i4 << 2) >> 1] | 0)) HEAP16[i22 + (i4 << 2) + 2 >> 1] = 0; else {
    i3 = (HEAP32[i16 >> 2] | 0) + 1 | 0;
    HEAP32[i16 >> 2] = i3;
    HEAP32[i21 + (i3 << 2) + 2908 >> 2] = i4;
    HEAP8[i21 + i4 + 5208 >> 0] = 0;
    i3 = i4;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i13 | 0));
  i4 = HEAP32[i16 >> 2] | 0;
  if ((i4 | 0) < 2) i7 = 3; else i20 = i3;
 } else {
  i4 = 0;
  i3 = -1;
  i7 = 3;
 }
 if ((i7 | 0) == 3) {
  i6 = i21 + 5800 | 0;
  i7 = i21 + 5804 | 0;
  if (!i8) {
   do {
    i15 = (i3 | 0) < 2;
    i20 = i3 + 1 | 0;
    i3 = i15 ? i20 : i3;
    i20 = i15 ? i20 : 0;
    i4 = i4 + 1 | 0;
    HEAP32[i16 >> 2] = i4;
    HEAP32[i21 + (i4 << 2) + 2908 >> 2] = i20;
    HEAP16[i22 + (i20 << 2) >> 1] = 1;
    HEAP8[i21 + i20 + 5208 >> 0] = 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    i4 = HEAP32[i16 >> 2] | 0;
   } while ((i4 | 0) < 2);
   i20 = i3;
  } else {
   do {
    i15 = (i3 | 0) < 2;
    i20 = i3 + 1 | 0;
    i3 = i15 ? i20 : i3;
    i20 = i15 ? i20 : 0;
    i4 = i4 + 1 | 0;
    HEAP32[i16 >> 2] = i4;
    HEAP32[i21 + (i4 << 2) + 2908 >> 2] = i20;
    HEAP16[i22 + (i20 << 2) >> 1] = 1;
    HEAP8[i21 + i20 + 5208 >> 0] = 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) - (HEAPU16[i8 + (i20 << 2) + 2 >> 1] | 0);
    i4 = HEAP32[i16 >> 2] | 0;
   } while ((i4 | 0) < 2);
   i20 = i3;
  }
 }
 i15 = i17 + 4 | 0;
 HEAP32[i15 >> 2] = i20;
 i7 = i4;
 i11 = (i4 | 0) / 2 | 0;
 do {
  i1 = HEAP32[i21 + (i11 << 2) + 2908 >> 2] | 0;
  i10 = i21 + i1 + 5208 | 0;
  i6 = i11 << 1;
  L19 : do if ((i6 | 0) > (i7 | 0)) i4 = i11; else {
   i8 = i22 + (i1 << 2) | 0;
   i9 = i11;
   while (1) {
    do if ((i6 | 0) < (i7 | 0)) {
     i4 = i6 | 1;
     i7 = HEAP32[i21 + (i4 << 2) + 2908 >> 2] | 0;
     i5 = HEAP16[i22 + (i7 << 2) >> 1] | 0;
     i3 = HEAP32[i21 + (i6 << 2) + 2908 >> 2] | 0;
     i2 = HEAP16[i22 + (i3 << 2) >> 1] | 0;
     if ((i5 & 65535) >= (i2 & 65535)) {
      if (i5 << 16 >> 16 != i2 << 16 >> 16) {
       i4 = i6;
       break;
      }
      if ((HEAPU8[i21 + i7 + 5208 >> 0] | 0) > (HEAPU8[i21 + i3 + 5208 >> 0] | 0)) {
       i4 = i6;
       break;
      }
     }
    } else i4 = i6; while (0);
    i7 = HEAP16[i8 >> 1] | 0;
    i6 = HEAP32[i21 + (i4 << 2) + 2908 >> 2] | 0;
    i5 = HEAP16[i22 + (i6 << 2) >> 1] | 0;
    if ((i7 & 65535) < (i5 & 65535)) {
     i4 = i9;
     break L19;
    }
    if (i7 << 16 >> 16 == i5 << 16 >> 16 ? (HEAPU8[i10 >> 0] | 0) <= (HEAPU8[i21 + i6 + 5208 >> 0] | 0) : 0) {
     i4 = i9;
     break L19;
    }
    HEAP32[i21 + (i9 << 2) + 2908 >> 2] = i6;
    i6 = i4 << 1;
    i7 = HEAP32[i16 >> 2] | 0;
    if ((i6 | 0) > (i7 | 0)) break; else i9 = i4;
   }
  } while (0);
  HEAP32[i21 + (i4 << 2) + 2908 >> 2] = i1;
  i11 = i11 + -1 | 0;
  i7 = HEAP32[i16 >> 2] | 0;
 } while ((i11 | 0) > 0);
 i14 = i21 + 2912 | 0;
 do {
  i12 = HEAP32[i14 >> 2] | 0;
  i6 = i7 + -1 | 0;
  HEAP32[i16 >> 2] = i6;
  i11 = HEAP32[i21 + (i7 << 2) + 2908 >> 2] | 0;
  HEAP32[i14 >> 2] = i11;
  i10 = i21 + i11 + 5208 | 0;
  L38 : do if ((i7 | 0) < 3) i4 = 1; else {
   i2 = i22 + (i11 << 2) | 0;
   i9 = 1;
   i8 = 2;
   while (1) {
    do if ((i8 | 0) < (i6 | 0)) {
     i4 = i8 | 1;
     i7 = HEAP32[i21 + (i4 << 2) + 2908 >> 2] | 0;
     i6 = HEAP16[i22 + (i7 << 2) >> 1] | 0;
     i5 = HEAP32[i21 + (i8 << 2) + 2908 >> 2] | 0;
     i3 = HEAP16[i22 + (i5 << 2) >> 1] | 0;
     if ((i6 & 65535) >= (i3 & 65535)) {
      if (i6 << 16 >> 16 != i3 << 16 >> 16) {
       i4 = i8;
       break;
      }
      if ((HEAPU8[i21 + i7 + 5208 >> 0] | 0) > (HEAPU8[i21 + i5 + 5208 >> 0] | 0)) {
       i4 = i8;
       break;
      }
     }
    } else i4 = i8; while (0);
    i7 = HEAP16[i2 >> 1] | 0;
    i6 = HEAP32[i21 + (i4 << 2) + 2908 >> 2] | 0;
    i5 = HEAP16[i22 + (i6 << 2) >> 1] | 0;
    if ((i7 & 65535) < (i5 & 65535)) {
     i4 = i9;
     break L38;
    }
    if (i7 << 16 >> 16 == i5 << 16 >> 16 ? (HEAPU8[i10 >> 0] | 0) <= (HEAPU8[i21 + i6 + 5208 >> 0] | 0) : 0) {
     i4 = i9;
     break L38;
    }
    HEAP32[i21 + (i9 << 2) + 2908 >> 2] = i6;
    i8 = i4 << 1;
    i6 = HEAP32[i16 >> 2] | 0;
    if ((i8 | 0) > (i6 | 0)) break; else i9 = i4;
   }
  } while (0);
  HEAP32[i21 + (i4 << 2) + 2908 >> 2] = i11;
  i11 = HEAP32[i14 >> 2] | 0;
  i1 = (HEAP32[i19 >> 2] | 0) + -1 | 0;
  HEAP32[i19 >> 2] = i1;
  HEAP32[i21 + (i1 << 2) + 2908 >> 2] = i12;
  i1 = (HEAP32[i19 >> 2] | 0) + -1 | 0;
  HEAP32[i19 >> 2] = i1;
  HEAP32[i21 + (i1 << 2) + 2908 >> 2] = i11;
  i1 = i22 + (i13 << 2) | 0;
  HEAP16[i1 >> 1] = (HEAPU16[i22 + (i11 << 2) >> 1] | 0) + (HEAPU16[i22 + (i12 << 2) >> 1] | 0);
  i6 = HEAP8[i21 + i12 + 5208 >> 0] | 0;
  i2 = HEAP8[i21 + i11 + 5208 >> 0] | 0;
  i9 = i21 + i13 + 5208 | 0;
  HEAP8[i9 >> 0] = (((i6 & 255) < (i2 & 255) ? i2 : i6) & 255) + 1;
  i6 = i13 & 65535;
  HEAP16[i22 + (i11 << 2) + 2 >> 1] = i6;
  HEAP16[i22 + (i12 << 2) + 2 >> 1] = i6;
  HEAP32[i14 >> 2] = i13;
  i6 = HEAP32[i16 >> 2] | 0;
  L54 : do if ((i6 | 0) < 2) i4 = 1; else {
   i2 = 1;
   i8 = 2;
   while (1) {
    do if ((i8 | 0) < (i6 | 0)) {
     i4 = i8 | 1;
     i7 = HEAP32[i21 + (i4 << 2) + 2908 >> 2] | 0;
     i6 = HEAP16[i22 + (i7 << 2) >> 1] | 0;
     i5 = HEAP32[i21 + (i8 << 2) + 2908 >> 2] | 0;
     i3 = HEAP16[i22 + (i5 << 2) >> 1] | 0;
     if ((i6 & 65535) >= (i3 & 65535)) {
      if (i6 << 16 >> 16 != i3 << 16 >> 16) {
       i4 = i8;
       break;
      }
      if ((HEAPU8[i21 + i7 + 5208 >> 0] | 0) > (HEAPU8[i21 + i5 + 5208 >> 0] | 0)) {
       i4 = i8;
       break;
      }
     }
    } else i4 = i8; while (0);
    i7 = HEAP16[i1 >> 1] | 0;
    i6 = HEAP32[i21 + (i4 << 2) + 2908 >> 2] | 0;
    i5 = HEAP16[i22 + (i6 << 2) >> 1] | 0;
    if ((i7 & 65535) < (i5 & 65535)) {
     i4 = i2;
     break L54;
    }
    if (i7 << 16 >> 16 == i5 << 16 >> 16 ? (HEAPU8[i9 >> 0] | 0) <= (HEAPU8[i21 + i6 + 5208 >> 0] | 0) : 0) {
     i4 = i2;
     break L54;
    }
    HEAP32[i21 + (i2 << 2) + 2908 >> 2] = i6;
    i8 = i4 << 1;
    i6 = HEAP32[i16 >> 2] | 0;
    if ((i8 | 0) > (i6 | 0)) break; else i2 = i4;
   }
  } while (0);
  HEAP32[i21 + (i4 << 2) + 2908 >> 2] = i13;
  i13 = i13 + 1 | 0;
  i7 = HEAP32[i16 >> 2] | 0;
 } while ((i7 | 0) > 1);
 i14 = HEAP32[i14 >> 2] | 0;
 i13 = (HEAP32[i19 >> 2] | 0) + -1 | 0;
 HEAP32[i19 >> 2] = i13;
 HEAP32[i21 + (i13 << 2) + 2908 >> 2] = i14;
 i13 = HEAP32[i17 >> 2] | 0;
 i14 = HEAP32[i15 >> 2] | 0;
 i4 = HEAP32[i18 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i9 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = HEAP32[i4 + 16 >> 2] | 0;
 i3 = i21 + 2876 | 0;
 i2 = i3 + 32 | 0;
 do {
  HEAP16[i3 >> 1] = 0;
  i3 = i3 + 2 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i3 = HEAP32[i19 >> 2] | 0;
 HEAP16[i13 + (HEAP32[i21 + (i3 << 2) + 2908 >> 2] << 2) + 2 >> 1] = 0;
 i3 = i3 + 1 | 0;
 L70 : do if ((i3 | 0) < 573) {
  i12 = i21 + 5800 | 0;
  i1 = i21 + 5804 | 0;
  if (!i8) {
   i7 = i3;
   i3 = 0;
   do {
    i2 = HEAP32[i21 + (i7 << 2) + 2908 >> 2] | 0;
    i19 = i13 + (i2 << 2) + 2 | 0;
    i5 = HEAPU16[i13 + (HEAPU16[i19 >> 1] << 2) + 2 >> 1] | 0;
    i18 = (i5 | 0) < (i4 | 0);
    i5 = i18 ? i5 + 1 | 0 : i4;
    i3 = (i18 & 1 ^ 1) + i3 | 0;
    HEAP16[i19 >> 1] = i5;
    if ((i2 | 0) <= (i14 | 0)) {
     i19 = i21 + (i5 << 1) + 2876 | 0;
     HEAP16[i19 >> 1] = (HEAP16[i19 >> 1] | 0) + 1 << 16 >> 16;
     if ((i2 | 0) < (i10 | 0)) i6 = 0; else i6 = HEAP32[i9 + (i2 - i10 << 2) >> 2] | 0;
     i19 = Math_imul(HEAPU16[i13 + (i2 << 2) >> 1] | 0, i6 + i5 | 0) | 0;
     HEAP32[i12 >> 2] = i19 + (HEAP32[i12 >> 2] | 0);
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != 573);
  } else {
   i2 = i3;
   i3 = 0;
   do {
    i5 = HEAP32[i21 + (i2 << 2) + 2908 >> 2] | 0;
    i19 = i13 + (i5 << 2) + 2 | 0;
    i6 = HEAPU16[i13 + (HEAPU16[i19 >> 1] << 2) + 2 >> 1] | 0;
    i18 = (i6 | 0) < (i4 | 0);
    i6 = i18 ? i6 + 1 | 0 : i4;
    i3 = (i18 & 1 ^ 1) + i3 | 0;
    HEAP16[i19 >> 1] = i6;
    if ((i5 | 0) <= (i14 | 0)) {
     i19 = i21 + (i6 << 1) + 2876 | 0;
     HEAP16[i19 >> 1] = (HEAP16[i19 >> 1] | 0) + 1 << 16 >> 16;
     if ((i5 | 0) < (i10 | 0)) i7 = 0; else i7 = HEAP32[i9 + (i5 - i10 << 2) >> 2] | 0;
     i19 = HEAPU16[i13 + (i5 << 2) >> 1] | 0;
     i18 = Math_imul(i19, i7 + i6 | 0) | 0;
     HEAP32[i12 >> 2] = i18 + (HEAP32[i12 >> 2] | 0);
     i19 = Math_imul((HEAPU16[i8 + (i5 << 2) + 2 >> 1] | 0) + i7 | 0, i19) | 0;
     HEAP32[i1 >> 2] = i19 + (HEAP32[i1 >> 2] | 0);
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 573);
  }
  if (i3) {
   i7 = i21 + (i4 << 1) + 2876 | 0;
   do {
    i6 = i4;
    while (1) {
     i5 = i6 + -1 | 0;
     i2 = i21 + (i5 << 1) + 2876 | 0;
     i1 = HEAP16[i2 >> 1] | 0;
     if (!(i1 << 16 >> 16)) i6 = i5; else break;
    }
    HEAP16[i2 >> 1] = i1 + -1 << 16 >> 16;
    i2 = i21 + (i6 << 1) + 2876 | 0;
    HEAP16[i2 >> 1] = (HEAPU16[i2 >> 1] | 0) + 2;
    i2 = (HEAP16[i7 >> 1] | 0) + -1 << 16 >> 16;
    HEAP16[i7 >> 1] = i2;
    i3 = i3 + -2 | 0;
   } while ((i3 | 0) > 0);
   if (i4) {
    i3 = 573;
    while (1) {
     i7 = i4 & 65535;
     if (i2 << 16 >> 16) {
      i6 = i2 & 65535;
      do {
       do {
        i3 = i3 + -1 | 0;
        i1 = HEAP32[i21 + (i3 << 2) + 2908 >> 2] | 0;
       } while ((i1 | 0) > (i14 | 0));
       i2 = i13 + (i1 << 2) + 2 | 0;
       i5 = HEAPU16[i2 >> 1] | 0;
       if ((i4 | 0) != (i5 | 0)) {
        i19 = Math_imul(HEAPU16[i13 + (i1 << 2) >> 1] | 0, i4 - i5 | 0) | 0;
        HEAP32[i12 >> 2] = i19 + (HEAP32[i12 >> 2] | 0);
        HEAP16[i2 >> 1] = i7;
       }
       i6 = i6 + -1 | 0;
      } while ((i6 | 0) != 0);
     }
     i4 = i4 + -1 | 0;
     if (!i4) break L70;
     i2 = HEAP16[i21 + (i4 << 1) + 2876 >> 1] | 0;
    }
   }
  }
 } while (0);
 i1 = 1;
 i2 = 0;
 do {
  i2 = (HEAPU16[i21 + (i1 + -1 << 1) + 2876 >> 1] | 0) + (i2 & 65534) << 1;
  HEAP16[i23 + (i1 << 1) >> 1] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 if ((i20 | 0) < 0) {
  STACKTOP = i24;
  return;
 } else i4 = 0;
 while (1) {
  i21 = HEAP16[i22 + (i4 << 2) + 2 >> 1] | 0;
  i1 = i21 & 65535;
  if (i21 << 16 >> 16) {
   i2 = i23 + (i1 << 1) | 0;
   i3 = HEAP16[i2 >> 1] | 0;
   HEAP16[i2 >> 1] = i3 + 1 << 16 >> 16;
   i3 = i3 & 65535;
   i2 = 0;
   while (1) {
    i2 = i2 | i3 & 1;
    i1 = i1 + -1 | 0;
    if ((i1 | 0) <= 0) break; else {
     i3 = i3 >>> 1;
     i2 = i2 << 1;
    }
   }
   HEAP16[i22 + (i4 << 2) >> 1] = i2;
  }
  if ((i4 | 0) == (i20 | 0)) break; else i4 = i4 + 1 | 0;
 }
 STACKTOP = i24;
 return;
}

function __ZL15countViolationsRKN2cv3MatES2_S2_dPdS3_(i5, i7, i1, d25, i30, i29) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 d25 = +d25;
 i30 = i30 | 0;
 i29 = i29 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 1152 | 0;
 i40 = i44 + 1096 | 0;
 i4 = i44 + 1040 | 0;
 i3 = i44 + 1016 | 0;
 i38 = i44 + 960 | 0;
 i6 = i44 + 232 | 0;
 i8 = i44 + 904 | 0;
 i37 = i44 + 848 | 0;
 i9 = i44 + 8 | 0;
 i10 = i44 + 792 | 0;
 i34 = i44 + 736 | 0;
 i31 = i44 + 680 | 0;
 i21 = i44 + 656 | 0;
 i22 = i44 + 636 | 0;
 i23 = i44;
 i24 = i44 + 616 | 0;
 i17 = i44 + 596 | 0;
 i18 = i44 + 576 | 0;
 i19 = i44 + 556 | 0;
 i20 = i44 + 536 | 0;
 i28 = i44 + 496 | 0;
 i26 = i44 + 476 | 0;
 i27 = i44 + 456 | 0;
 HEAP32[i40 >> 2] = 1124007936;
 i42 = i40 + 4 | 0;
 i2 = i40 + 8 | 0;
 i39 = i40 + 40 | 0;
 i11 = i42 + 0 | 0;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAP32[i39 >> 2] = i2;
 i43 = i40 + 48 | 0;
 i41 = i40 + 44 | 0;
 HEAP32[i41 >> 2] = i43;
 HEAP32[i40 + 52 >> 2] = 0;
 HEAP32[i43 >> 2] = 0;
 __ZNK2cv3Mat7reshapeEii(i4, i1, 1, 0);
 i2 = i3 + 4 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 32232;
 HEAP32[i2 >> 2] = 33619968;
 HEAP32[i3 + 8 >> 2] = i40;
 __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i4, i3, 6, 1.0, 0.0);
 i2 = i4 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i15 = i1 + 12 | 0, i16 = HEAP32[i15 >> 2] | 0, HEAP32[i15 >> 2] = i16 + -1, (i16 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i4);
 HEAP32[i2 >> 2] = 0;
 i16 = i4 + 16 | 0;
 i2 = i4 + 4 | 0;
 HEAP32[i16 + 0 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i4 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i2 = HEAP32[i4 + 44 >> 2] | 0;
 if ((i2 | 0) != (i4 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 __ZNK2cv3Mat7reshapeEii(i8, i5, 1, 0);
 __ZN2cv3absERKNS_3MatE(i6, i8);
 HEAP32[i38 >> 2] = 1124007936;
 i35 = i38 + 4 | 0;
 i2 = i38 + 8 | 0;
 i32 = i38 + 40 | 0;
 i11 = i35 + 0 | 0;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAP32[i32 >> 2] = i2;
 i36 = i38 + 48 | 0;
 i33 = i38 + 44 | 0;
 HEAP32[i33 >> 2] = i36;
 HEAP32[i38 + 52 >> 2] = 0;
 HEAP32[i36 >> 2] = 0;
 i2 = HEAP32[i6 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i6, i38, -1);
 __ZN2cv7MatExprD2Ev(i6);
 i2 = i8 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i15 = i1 + 12 | 0, i16 = HEAP32[i15 >> 2] | 0, HEAP32[i15 >> 2] = i16 + -1, (i16 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i8);
 HEAP32[i2 >> 2] = 0;
 i16 = i8 + 16 | 0;
 i3 = i8 + 4 | 0;
 HEAP32[i16 + 0 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i8 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i2 = HEAP32[i8 + 44 >> 2] | 0;
 if ((i2 | 0) != (i8 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 __ZNK2cv3Mat7reshapeEii(i10, i7, 1, 0);
 __ZN2cv3absERKNS_3MatE(i9, i10);
 HEAP32[i37 >> 2] = 1124007936;
 i15 = i37 + 4 | 0;
 i3 = i37 + 8 | 0;
 i13 = i37 + 40 | 0;
 i11 = i15 + 0 | 0;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAP32[i13 >> 2] = i3;
 i16 = i37 + 48 | 0;
 i14 = i37 + 44 | 0;
 HEAP32[i14 >> 2] = i16;
 HEAP32[i37 + 52 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 i3 = HEAP32[i9 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] & 63](i3, i9, i37, -1);
 __ZN2cv7MatExprD2Ev(i9);
 i3 = i10 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i11 = i2 + 12 | 0, i12 = HEAP32[i11 >> 2] | 0, HEAP32[i11 >> 2] = i12 + -1, (i12 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i10);
 HEAP32[i3 >> 2] = 0;
 i12 = i10 + 16 | 0;
 i3 = i10 + 4 | 0;
 HEAP32[i12 + 0 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i10 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i2 = HEAP32[i10 + 44 >> 2] | 0;
 if ((i2 | 0) != (i10 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 HEAP32[i34 >> 2] = 1124007936;
 i9 = i34 + 4 | 0;
 i3 = i34 + 8 | 0;
 i7 = i34 + 40 | 0;
 i11 = i9 + 0 | 0;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAP32[i7 >> 2] = i3;
 i10 = i34 + 48 | 0;
 i8 = i34 + 44 | 0;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i34 + 52 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i31 >> 2] = 1124007936;
 i6 = i31 + 4 | 0;
 i3 = i31 + 8 | 0;
 i4 = i31 + 40 | 0;
 i11 = i6 + 0 | 0;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAP32[i4 >> 2] = i3;
 i3 = i31 + 48 | 0;
 i5 = i31 + 44 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i31 + 52 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN2cv3maxERKNS_3MatES2_RS0_(i38, i37, i34);
 HEAP32[i21 >> 2] = 32088;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP32[i21 + 16 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 16842752;
 HEAP32[i21 + 8 >> 2] = i34;
 HEAPF64[i23 >> 3] = d25;
 HEAP32[i22 >> 2] = 32088;
 HEAP32[i22 + 4 >> 2] = -1056833530;
 HEAP32[i22 + 8 >> 2] = i23;
 HEAP32[i22 + 12 >> 2] = 1;
 HEAP32[i22 + 16 >> 2] = 1;
 i12 = i24 + 4 | 0;
 HEAP32[i12 + 0 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i24 >> 2] = 32232;
 HEAP32[i12 >> 2] = 33619968;
 HEAP32[i24 + 8 >> 2] = i34;
 __ZN2cv8multiplyERKNS_11_InputArrayES2_RKNS_12_OutputArrayEdi(i21, i22, i24, 6.0, -1);
 HEAP32[i17 >> 2] = 32088;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 16842752;
 HEAP32[i17 + 8 >> 2] = i40;
 HEAP32[i18 >> 2] = 32088;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 16842752;
 HEAP32[i18 + 8 >> 2] = i34;
 i12 = i19 + 4 | 0;
 HEAP32[i12 + 0 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i19 >> 2] = 32232;
 HEAP32[i12 >> 2] = 33619968;
 HEAP32[i19 + 8 >> 2] = i31;
 __ZN2cv7compareERKNS_11_InputArrayES2_RKNS_12_OutputArrayEi(i17, i18, i19, 1);
 HEAP32[i20 >> 2] = 32088;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAP32[i20 + 16 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 16842752;
 HEAP32[i20 + 8 >> 2] = i31;
 i12 = __ZN2cv12countNonZeroERKNS_11_InputArrayE(i20) | 0;
 if ((i12 | 0) > 0 & (i30 | 0) != 0 & (i29 | 0) != 0) {
  HEAP32[i26 >> 2] = 32088;
  HEAP32[i26 + 12 >> 2] = 0;
  HEAP32[i26 + 16 >> 2] = 0;
  HEAP32[i26 + 4 >> 2] = 16842752;
  HEAP32[i26 + 8 >> 2] = i34;
  HEAP32[i27 >> 2] = 32088;
  HEAP32[i27 + 12 >> 2] = 0;
  HEAP32[i27 + 16 >> 2] = 0;
  HEAP32[i27 + 4 >> 2] = 16842752;
  HEAP32[i27 + 8 >> 2] = i31;
  __ZN2cv9minMaxIdxERKNS_11_InputArrayEPdS3_PiS4_S2_(i26, 0, i29, 0, i28, i27);
  HEAPF64[i30 >> 3] = +HEAPF64[(HEAP32[i40 + 16 >> 2] | 0) + (Math_imul(HEAP32[HEAP32[i41 >> 2] >> 2] | 0, HEAP32[i28 + 4 >> 2] | 0) | 0) + (HEAP32[i28 >> 2] << 3) >> 3];
 }
 i2 = i31 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i31);
 HEAP32[i2 >> 2] = 0;
 i22 = i31 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i6 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i6 >> 2] | 0));
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i34 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i34);
 HEAP32[i2 >> 2] = 0;
 i22 = i34 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i9 >> 2] | 0) > 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i9 >> 2] | 0));
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i10 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i37 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i37);
 HEAP32[i2 >> 2] = 0;
 i22 = i37 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i15 >> 2] | 0) > 0) {
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i15 >> 2] | 0));
 }
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 | 0) != (i16 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i38 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (i1) {
  i21 = i1 + 12 | 0;
  i22 = HEAP32[i21 >> 2] | 0;
  HEAP32[i21 >> 2] = i22 + -1;
  if ((i22 | 0) != 1) break;
  __ZN2cv3Mat10deallocateEv(i38);
 } while (0);
 HEAP32[i2 >> 2] = 0;
 i22 = i38 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i35 >> 2] | 0) > 0) {
  i2 = HEAP32[i32 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i35 >> 2] | 0));
 }
 i2 = HEAP32[i33 >> 2] | 0;
 if ((i2 | 0) != (i36 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i40 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (i1) {
  i21 = i1 + 12 | 0;
  i22 = HEAP32[i21 >> 2] | 0;
  HEAP32[i21 >> 2] = i22 + -1;
  if ((i22 | 0) != 1) break;
  __ZN2cv3Mat10deallocateEv(i40);
 } while (0);
 HEAP32[i2 >> 2] = 0;
 i22 = i40 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i42 >> 2] | 0) > 0) {
  i1 = HEAP32[i39 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i42 >> 2] | 0));
 }
 i1 = HEAP32[i41 >> 2] | 0;
 if ((i1 | 0) == (i43 | 0)) {
  STACKTOP = i44;
  return i12 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i44;
 return i12 | 0;
}

function __ZN2cv14JacobiSVDImpl_IfEEvPT_jS2_S2_jiiidS1_(i33, i1, i28, i27, i3, i35, i37, i38, d36, f4) {
 i33 = i33 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 i27 = i27 | 0;
 i3 = i3 | 0;
 i35 = i35 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 d36 = +d36;
 f4 = Math_fround(f4);
 var d2 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d12 = 0.0, d13 = 0.0, d14 = 0.0, f15 = f0, d16 = 0.0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i39 = 0, f40 = f0, i41 = 0, f42 = f0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 i34 = i39;
 i30 = i34 + 8 | 0;
 HEAP32[i34 >> 2] = i30;
 i31 = i34 + 4 | 0;
 HEAP32[i31 >> 2] = 136;
 if (i37 >>> 0 > 136) {
  i32 = __Znaj(i37 >>> 0 > 536870911 ? -1 : i37 << 3) | 0;
  HEAP32[i34 >> 2] = i32;
 } else i32 = i30;
 HEAP32[i31 >> 2] = i37;
 i24 = (i35 | 0) < 30 ? 30 : i35;
 i29 = i1 >>> 2;
 i25 = i3 >>> 2;
 i26 = (i37 | 0) > 0;
 if (i26) {
  i5 = (i35 | 0) > 0;
  i3 = (i27 | 0) == 0;
  i1 = i37 << 2;
  i9 = 0;
  do {
   i8 = Math_imul(i25, i9) | 0;
   i10 = i27 + (i8 << 2) | 0;
   if (i5) {
    i7 = Math_imul(i9, i29) | 0;
    i6 = 0;
    d2 = 0.0;
    do {
     d13 = +Math_fround(HEAPF32[i33 + (i6 + i7 << 2) >> 2]);
     d2 = d2 + d13 * d13;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i35 | 0));
   } else d2 = 0.0;
   HEAPF64[i32 + (i9 << 3) >> 3] = d2;
   if (!i3) {
    _memset(i10 | 0, 0, i1 | 0) | 0;
    HEAPF32[i27 + (i8 + i9 << 2) >> 2] = Math_fround(1.0);
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i37 | 0));
 }
 L17 : do if ((i24 | 0) > 0) {
  i19 = i37 + -1 | 0;
  i20 = (i19 | 0) > 0;
  i21 = (i35 | 0) > 0;
  d16 = +f4;
  i1 = (i27 | 0) == 0;
  i18 = 0;
  do {
   if (i20) {
    i6 = 0;
    i17 = 0;
   } else break L17;
   do {
    i7 = i17;
    i17 = i17 + 1 | 0;
    if ((i17 | 0) < (i37 | 0)) {
     i5 = Math_imul(i7, i29) | 0;
     i3 = i32 + (i7 << 3) | 0;
     i7 = Math_imul(i7, i25) | 0;
     i8 = i17;
     do {
      i10 = Math_imul(i8, i29) | 0;
      d13 = +HEAPF64[i3 >> 3];
      i9 = i32 + (i8 << 3) | 0;
      d2 = +HEAPF64[i9 >> 3];
      if (i21) {
       i11 = 0;
       d12 = 0.0;
       do {
        d14 = +Math_fround(HEAPF32[i33 + (i11 + i5 << 2) >> 2]);
        d12 = d12 + d14 * +Math_fround(HEAPF32[i33 + (i11 + i10 << 2) >> 2]);
        i11 = i11 + 1 | 0;
       } while ((i11 | 0) != (i35 | 0));
      } else d12 = 0.0;
      if (!(+Math_abs(+d12) <= d16 * +Math_sqrt(+(d13 * d2)))) {
       d14 = d12 * 2.0;
       d13 = d13 - d2;
       d2 = +Math_abs(+d14);
       d12 = +Math_abs(+d13);
       if (!(d2 > d12)) if (d13 != d13 | 0.0 != 0.0 | d13 == 0.0) d2 = 0.0; else {
        d2 = d2 / d12;
        d2 = d12 * +Math_sqrt(+(d2 * d2 + 1.0));
       } else {
        d12 = d12 / d2;
        d2 = d2 * +Math_sqrt(+(d12 * d12 + 1.0));
       }
       if (d13 < 0.0) {
        f4 = Math_fround(+Math_sqrt(+((d2 - d13) * .5 / d2)));
        f15 = Math_fround(d14 / (d2 * +f4 * 2.0));
       } else {
        f4 = Math_fround(+Math_sqrt(+((d13 + d2) / (d2 * 2.0))));
        f15 = f4;
        f4 = Math_fround(d14 / (d2 * +f4 * 2.0));
       }
       if (i21) {
        d12 = 0.0;
        d2 = 0.0;
        i11 = 0;
        do {
         i41 = i33 + (i11 + i5 << 2) | 0;
         f22 = Math_fround(HEAPF32[i41 >> 2]);
         f40 = Math_fround(f15 * f22);
         i6 = i33 + (i11 + i10 << 2) | 0;
         f42 = Math_fround(HEAPF32[i6 >> 2]);
         f40 = Math_fround(f40 + Math_fround(f4 * f42));
         f22 = Math_fround(Math_fround(f15 * f42) - Math_fround(f4 * f22));
         HEAPF32[i41 >> 2] = f40;
         HEAPF32[i6 >> 2] = f22;
         d13 = +f40;
         d12 = d12 + d13 * d13;
         d13 = +f22;
         d2 = d2 + d13 * d13;
         i11 = i11 + 1 | 0;
        } while ((i11 | 0) != (i35 | 0));
       } else {
        d12 = 0.0;
        d2 = 0.0;
       }
       HEAPF64[i3 >> 3] = d12;
       HEAPF64[i9 >> 3] = d2;
       if (!i1 ? (i23 = Math_imul(i8, i25) | 0, i26) : 0) {
        i11 = 0;
        do {
         i9 = i27 + (i11 + i7 << 2) | 0;
         f22 = Math_fround(HEAPF32[i9 >> 2]);
         f42 = Math_fround(f15 * f22);
         i6 = i27 + (i11 + i23 << 2) | 0;
         f40 = Math_fround(HEAPF32[i6 >> 2]);
         f22 = Math_fround(Math_fround(f15 * f40) - Math_fround(f4 * f22));
         HEAPF32[i9 >> 2] = Math_fround(f42 + Math_fround(f4 * f40));
         HEAPF32[i6 >> 2] = f22;
         i11 = i11 + 1 | 0;
        } while ((i11 | 0) != (i37 | 0));
        i6 = 1;
       } else i6 = 1;
      }
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) != (i37 | 0));
    }
   } while ((i17 | 0) != (i19 | 0));
   i18 = i18 + 1 | 0;
  } while (i6 & (i18 | 0) < (i24 | 0));
 } while (0);
 if (i26) {
  i3 = (i35 | 0) > 0;
  i1 = 0;
  do {
   if (i3) {
    i6 = Math_imul(i1, i29) | 0;
    i5 = 0;
    d2 = 0.0;
    do {
     d13 = +Math_fround(HEAPF32[i33 + (i5 + i6 << 2) >> 2]);
     d2 = d2 + d13 * d13;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i35 | 0));
   } else d2 = 0.0;
   HEAPF64[i32 + (i1 << 3) >> 3] = +Math_sqrt(+d2);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i37 | 0));
 }
 i10 = i37 + -1 | 0;
 if ((i10 | 0) > 0) {
  i9 = (i27 | 0) == 0;
  i8 = (i35 | 0) > 0;
  i11 = 0;
  do {
   i7 = i11;
   i11 = i11 + 1 | 0;
   if ((i11 | 0) < (i37 | 0)) {
    i6 = i7;
    i5 = i11;
    do {
     i6 = +HEAPF64[i32 + (i6 << 3) >> 3] < +HEAPF64[i32 + (i5 << 3) >> 3] ? i5 : i6;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i37 | 0));
   } else i6 = i7;
   if ((i7 | 0) != (i6 | 0) ? (i21 = i32 + (i7 << 3) | 0, i23 = i32 + (i6 << 3) | 0, d2 = +HEAPF64[i21 >> 3], HEAPF64[i21 >> 3] = +HEAPF64[i23 >> 3], HEAPF64[i23 >> 3] = d2, !i9) : 0) {
    if (i8) {
     i5 = Math_imul(i7, i29) | 0;
     i3 = Math_imul(i6, i29) | 0;
     i1 = 0;
     do {
      i21 = i33 + (i1 + i5 << 2) | 0;
      i23 = i33 + (i1 + i3 << 2) | 0;
      f4 = Math_fround(HEAPF32[i21 >> 2]);
      HEAPF32[i21 >> 2] = Math_fround(HEAPF32[i23 >> 2]);
      HEAPF32[i23 >> 2] = f4;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i35 | 0));
    }
    if (i26) {
     i3 = Math_imul(i7, i25) | 0;
     i6 = Math_imul(i6, i25) | 0;
     i5 = 0;
     do {
      i21 = i27 + (i5 + i3 << 2) | 0;
      i23 = i27 + (i5 + i6 << 2) | 0;
      f4 = Math_fround(HEAPF32[i21 >> 2]);
      HEAPF32[i21 >> 2] = Math_fround(HEAPF32[i23 >> 2]);
      HEAPF32[i23 >> 2] = f4;
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i37 | 0));
    }
   }
  } while ((i11 | 0) != (i10 | 0));
 }
 if (i26) {
  i1 = 0;
  do {
   HEAPF32[i28 + (i1 << 2) >> 2] = Math_fround(+HEAPF64[i32 + (i1 << 3) >> 3]);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i37 | 0));
 }
 if ((i27 | 0) != 0 & (i38 | 0) > 0) {
  i21 = (i35 | 0) > 0;
  f15 = Math_fround(1.0 / +(i35 | 0));
  f22 = Math_fround(-f15);
  i1 = 305419896;
  i3 = 0;
  i20 = 0;
  do {
   if ((i20 | 0) < (i37 | 0)) d2 = +HEAPF64[i32 + (i20 << 3) >> 3]; else d2 = 0.0;
   if (d2 <= d36) {
    i11 = (i20 | 0) > 0;
    i10 = Math_imul(i20, i29) | 0;
    do {
     if (i21) {
      i6 = 0;
      do {
       i1 = ___muldi3(i1 | 0, 0, -130063606, 0) | 0;
       i1 = _i64Add(i1 | 0, tempRet0 | 0, i3 | 0, 0) | 0;
       i3 = tempRet0;
       HEAPF32[i33 + (i6 + i10 << 2) >> 2] = (i1 & 256 | 0) == 0 & 0 == 0 ? f22 : f15;
       i6 = i6 + 1 | 0;
      } while ((i6 | 0) != (i35 | 0));
     }
     if (i11) {
      i7 = 0;
      do {
       do if (i21) {
        i6 = Math_imul(i7, i29) | 0;
        i5 = 0;
        d2 = 0.0;
        do {
         f4 = Math_fround(HEAPF32[i33 + (i5 + i10 << 2) >> 2]);
         d2 = d2 + +Math_fround(f4 * Math_fround(HEAPF32[i33 + (i5 + i6 << 2) >> 2]));
         i5 = i5 + 1 | 0;
        } while ((i5 | 0) != (i35 | 0));
        if (i21) {
         i6 = Math_imul(i7, i29) | 0;
         f4 = Math_fround(0.0);
         i5 = 0;
         do {
          i27 = i33 + (i5 + i10 << 2) | 0;
          d13 = +Math_fround(HEAPF32[i27 >> 2]);
          f40 = Math_fround(d13 - d2 * +Math_fround(HEAPF32[i33 + (i5 + i6 << 2) >> 2]));
          HEAPF32[i27 >> 2] = f40;
          f4 = Math_fround(f4 + Math_fround(Math_abs(Math_fround(f40))));
          i5 = i5 + 1 | 0;
         } while ((i5 | 0) != (i35 | 0));
         if (f4 != Math_fround(0.0)) f4 = Math_fround(Math_fround(1.0) / f4); else f4 = Math_fround(0.0);
         if (i21) i6 = 0; else break;
         do {
          i27 = i33 + (i6 + i10 << 2) | 0;
          HEAPF32[i27 >> 2] = Math_fround(f4 * Math_fround(HEAPF32[i27 >> 2]));
          i6 = i6 + 1 | 0;
         } while ((i6 | 0) != (i35 | 0));
        }
       } while (0);
       i7 = i7 + 1 | 0;
      } while ((i7 | 0) != (i20 | 0));
      if (i11) {
       i7 = 0;
       do {
        do if (i21) {
         i6 = Math_imul(i7, i29) | 0;
         i5 = 0;
         d2 = 0.0;
         do {
          f4 = Math_fround(HEAPF32[i33 + (i5 + i10 << 2) >> 2]);
          d2 = d2 + +Math_fround(f4 * Math_fround(HEAPF32[i33 + (i5 + i6 << 2) >> 2]));
          i5 = i5 + 1 | 0;
         } while ((i5 | 0) != (i35 | 0));
         if (!i21) break;
         i6 = Math_imul(i7, i29) | 0;
         f4 = Math_fround(0.0);
         i5 = 0;
         do {
          i27 = i33 + (i5 + i10 << 2) | 0;
          d13 = +Math_fround(HEAPF32[i27 >> 2]);
          f40 = Math_fround(d13 - d2 * +Math_fround(HEAPF32[i33 + (i5 + i6 << 2) >> 2]));
          HEAPF32[i27 >> 2] = f40;
          f4 = Math_fround(f4 + Math_fround(Math_abs(Math_fround(f40))));
          i5 = i5 + 1 | 0;
         } while ((i5 | 0) != (i35 | 0));
         if (f4 != Math_fround(0.0)) f4 = Math_fround(Math_fround(1.0) / f4); else f4 = Math_fround(0.0);
         if (i21) i6 = 0; else break;
         do {
          i27 = i33 + (i6 + i10 << 2) | 0;
          HEAPF32[i27 >> 2] = Math_fround(f4 * Math_fround(HEAPF32[i27 >> 2]));
          i6 = i6 + 1 | 0;
         } while ((i6 | 0) != (i35 | 0));
        } while (0);
        i7 = i7 + 1 | 0;
       } while ((i7 | 0) != (i20 | 0));
      }
     }
     if (i21) {
      i6 = 0;
      d2 = 0.0;
      do {
       d13 = +Math_fround(HEAPF32[i33 + (i6 + i10 << 2) >> 2]);
       d2 = d2 + d13 * d13;
       i6 = i6 + 1 | 0;
      } while ((i6 | 0) != (i35 | 0));
     } else d2 = 0.0;
     d2 = +Math_sqrt(+d2);
    } while (d2 <= d36);
   }
   f4 = Math_fround(1.0 / d2);
   if (i21) {
    i5 = Math_imul(i20, i29) | 0;
    i6 = 0;
    do {
     i27 = i33 + (i6 + i5 << 2) | 0;
     HEAPF32[i27 >> 2] = Math_fround(f4 * Math_fround(HEAPF32[i27 >> 2]));
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i35 | 0));
   }
   i20 = i20 + 1 | 0;
  } while ((i20 | 0) != (i38 | 0));
 }
 if ((i32 | 0) == (i30 | 0)) {
  STACKTOP = i39;
  return;
 }
 __ZdaPv(i32);
 HEAP32[i34 >> 2] = i30;
 HEAP32[i31 >> 2] = 136;
 STACKTOP = i39;
 return;
}

function __ZN6cvtest16printVersionInfoEb(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i20 = i23 + 156 | 0;
 i1 = i23 + 144 | 0;
 i2 = i23 + 132 | 0;
 i21 = i23 + 120 | 0;
 i8 = i23 + 108 | 0;
 i7 = i23 + 96 | 0;
 i15 = i23 + 84 | 0;
 i12 = i23 + 72 | 0;
 i13 = i23 + 60 | 0;
 i14 = i23 + 48 | 0;
 i16 = i23 + 36 | 0;
 i17 = i23 + 24 | 0;
 i22 = i23 + 12 | 0;
 i18 = i23;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 159256, 10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, 159272, 9);
 __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i1, i2);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 if (i19) {
  i1 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 159288, 16) | 0, 159272, 9) | 0;
  __ZNKSt3__18ios_base6getlocEv(i20, i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i2 = __ZNKSt3__16locale9use_facetERNS0_2idE(i20, 960728) | 0;
  i2 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] & 127](i2, 10) | 0;
  __ZNSt3__16localeD2Ev(i20);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i1, i2) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i1) | 0;
 }
 i3 = __ZN2cv19getBuildInformationEv() | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0);
 i3 = HEAP8[i21 >> 0] | 0;
 if (!(i3 & 1)) {
  i2 = (i3 & 255) >>> 1;
  i3 = i21 + 1 | 0;
 } else {
  i2 = HEAP32[i21 + 4 >> 2] | 0;
  i3 = HEAP32[i21 + 8 >> 2] | 0;
 }
 L8 : do if ((i2 >>> 0 >= 15 ? (i4 = i3 + i2 | 0, i5 = i3, (i2 | 0) >= 15) : 0) ? (i1 = i2 + -14 | 0, i6 = i3 + i1 | 0, (i1 | 0) != 0) : 0) {
  L11 : while (1) {
   if ((HEAP8[i3 >> 0] | 0) == 86) {
    i2 = i3;
    i1 = 159312;
    do {
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 159327) break L11;
     i2 = i2 + 1 | 0;
    } while ((HEAP8[i2 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
   }
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i6 | 0)) {
    i3 = -1;
    break L8;
   }
  }
  if ((i3 | 0) != (i4 | 0)) i3 = i3 - i5 | 0; else i3 = -1;
 } else i3 = -1; while (0);
 i2 = __ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i21, 10, i3) | 0;
 if ((i3 | 0) != -1 & (i2 | 0) != -1) {
  i1 = (__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj(i21, 32, i2) | 0) + 1 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_jjRKS4_(i8, i21, i1, i2 - i1 | 0, i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, 159328, 14);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i7, i8);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
  if (i19) {
   i2 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 159344, 20) | 0;
   i3 = HEAP8[i8 >> 0] | 0;
   if (!(i3 & 1)) {
    i1 = i8 + 1 | 0;
    i3 = (i3 & 255) >>> 1;
   } else {
    i1 = HEAP32[i8 + 8 >> 2] | 0;
    i3 = HEAP32[i8 + 4 >> 2] | 0;
   }
   i1 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i1, i3) | 0;
   __ZNKSt3__18ios_base6getlocEv(i20, i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
   i2 = __ZNKSt3__16locale9use_facetERNS0_2idE(i20, 960728) | 0;
   i2 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] & 127](i2, 10) | 0;
   __ZNSt3__16localeD2Ev(i20);
   __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i1, i2) | 0;
   __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i1) | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
 }
 i3 = HEAP8[i21 >> 0] | 0;
 if (!(i3 & 1)) {
  i2 = (i3 & 255) >>> 1;
  i3 = i21 + 1 | 0;
 } else {
  i2 = HEAP32[i21 + 4 >> 2] | 0;
  i3 = HEAP32[i21 + 8 >> 2] | 0;
 }
 L35 : do if ((i2 >>> 0 >= 13 ? (i10 = i3 + i2 | 0, i11 = i3, (i2 | 0) >= 13) : 0) ? (i1 = i2 + -12 | 0, i9 = i3 + i1 | 0, (i1 | 0) != 0) : 0) {
  L38 : while (1) {
   if ((HEAP8[i3 >> 0] | 0) == 105) {
    i2 = i3;
    i1 = 159368;
    do {
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 159381) break L38;
     i2 = i2 + 1 | 0;
    } while ((HEAP8[i2 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
   }
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i9 | 0)) {
    i3 = -1;
    break L35;
   }
  }
  if ((i3 | 0) != (i10 | 0)) i3 = i3 - i11 | 0; else i3 = -1;
 } else i3 = -1; while (0);
 i2 = __ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i21, 10, i3) | 0;
 if ((i3 | 0) != -1 & (i2 | 0) != -1) {
  i11 = (__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj(i21, 32, i2) | 0) + 1 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_jjRKS4_(i15, i21, i11, i2 - i11 | 0, i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, 159384, 20);
  __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i12, i15);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
  if (i19) {
   i2 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 159408, 19) | 0;
   i3 = HEAP8[i15 >> 0] | 0;
   if (!(i3 & 1)) {
    i1 = i15 + 1 | 0;
    i3 = (i3 & 255) >>> 1;
   } else {
    i1 = HEAP32[i15 + 8 >> 2] | 0;
    i3 = HEAP32[i15 + 4 >> 2] | 0;
   }
   i12 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i1, i3) | 0;
   __ZNKSt3__18ios_base6getlocEv(i20, i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0);
   i11 = __ZNKSt3__16locale9use_facetERNS0_2idE(i20, 960728) | 0;
   i11 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] & 127](i11, 10) | 0;
   __ZNSt3__16localeD2Ev(i20);
   __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i12, i11) | 0;
   __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i12) | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, 159440, 13);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, 159432, 7);
 __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i13, i14);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
 if (i19) {
  i15 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 159456, 12) | 0, 159432, 7) | 0;
  __ZNKSt3__18ios_base6getlocEv(i20, i15 + (HEAP32[(HEAP32[i15 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i14 = __ZNKSt3__16locale9use_facetERNS0_2idE(i20, 960728) | 0;
  i14 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] & 127](i14, 10) | 0;
  __ZNSt3__16localeD2Ev(i20);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i15, i14) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i15) | 0;
 }
 i3 = __ZN2cv24currentParallelFrameworkEv() | 0;
 if ((i3 | 0) != 0 ? (__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i16, 159472, 21), __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i3, _strlen(i3 | 0) | 0), __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i16, i17), __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17), __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16), i19) : 0) {
  i17 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 159496, 20) | 0;
  i17 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i17, i3, _strlen(i3 | 0) | 0) | 0;
  __ZNKSt3__18ios_base6getlocEv(i20, i17 + (HEAP32[(HEAP32[i17 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i16 = __ZNKSt3__16locale9use_facetERNS0_2idE(i20, 960728) | 0;
  i16 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 28 >> 2] & 127](i16, 10) | 0;
  __ZNSt3__16localeD2Ev(i20);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i17, i16) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i17) | 0;
 };
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i22, 0, 1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, 159520, 15);
 __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i18, i22);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i18);
 if (!i19) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  STACKTOP = i23;
  return;
 }
 i2 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 159536, 14) | 0;
 i1 = HEAP8[i22 >> 0] | 0;
 if (!(i1 & 1)) {
  i3 = i22 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i3 = HEAP32[i22 + 8 >> 2] | 0;
  i1 = HEAP32[i22 + 4 >> 2] | 0;
 }
 i19 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i3, i1) | 0;
 __ZNKSt3__18ios_base6getlocEv(i20, i19 + (HEAP32[(HEAP32[i19 >> 2] | 0) + -12 >> 2] | 0) | 0);
 i18 = __ZNKSt3__16locale9use_facetERNS0_2idE(i20, 960728) | 0;
 i18 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i18 >> 2] | 0) + 28 >> 2] & 127](i18, 10) | 0;
 __ZNSt3__16localeD2Ev(i20);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i19, i18) | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i19) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 STACKTOP = i23;
 return;
}

function __ZN2cvL11_SVDcomputeERKNS_11_InputArrayERKNS_12_OutputArrayES5_S5_i(i3, i23, i26, i27, i4) {
 i3 = i3 | 0;
 i23 = i23 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 1520 | 0;
 i41 = i42 + 1464 | 0;
 i1 = i42 + 1456 | 0;
 i40 = i42 + 416 | 0;
 i39 = i42 + 360 | 0;
 i37 = i42 + 304 | 0;
 i34 = i42 + 248 | 0;
 i30 = i42 + 192 | 0;
 i13 = i42 + 136 | 0;
 i14 = i42;
 i15 = i42 + 112 | 0;
 i16 = i42 + 92 | 0;
 i17 = i42 + 72 | 0;
 i24 = i42 + 52 | 0;
 i25 = i42 + 32 | 0;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i3 >> 2] >> 2] & 63](i41, i3, -1);
 i5 = HEAP32[i41 + 8 >> 2] | 0;
 i6 = HEAP32[i41 + 12 >> 2] | 0;
 i9 = HEAP32[i41 >> 2] | 0;
 i10 = i9 & 4095;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i26 >> 2] | 0) + 112 >> 2] & 127](i26) | 0) i3 = 1; else i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i27 >> 2] | 0) + 112 >> 2] & 127](i27) | 0;
 i19 = (i10 | 0) == 5;
 if ((i10 + -5 | 0) >>> 0 >= 2) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i1, 32) | 0) + 0 | 0;
  i2 = 3912 | 0;
  i8 = i7 + 32 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i2 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i7 | 0) < (i8 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 4560, 3856, 1510);
  __ZN2cv6String10deallocateEv(i1);
 }
 if (!(i4 & 2)) {
  i22 = i3;
  i3 = (i4 & 4 | 0) != 0;
 } else {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i26 >> 2] | 0) + 152 >> 2] & 511](i26);
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i27 >> 2] | 0) + 152 >> 2] & 511](i27);
  i22 = 0;
  i3 = 0;
 }
 i21 = (i5 | 0) < (i6 | 0);
 i20 = i21 ? i6 : i5;
 i18 = i21 ? i5 : i6;
 i11 = i3 ? i20 : i18;
 i38 = i41 + 4 | 0;
 i3 = HEAP32[i38 >> 2] | 0;
 if ((i3 | 0) > 0) i3 = HEAP32[(HEAP32[i41 + 44 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0; else i3 = 0;
 i4 = (Math_imul(i3, i20) | 0) + 15 & -16;
 i3 = Math_imul(i3, i18) | 0;
 i2 = i3 + 15 & -16;
 i1 = Math_imul(i4, i11) | 0;
 i6 = i3 + 32 + (Math_imul(i2, i18) | 0) + i1 | 0;
 i35 = i40 + 8 | 0;
 HEAP32[i40 >> 2] = i35;
 i36 = i40 + 4 | 0;
 HEAP32[i36 >> 2] = 1032;
 if (i6 >>> 0 > 1032) {
  i5 = __Znaj(i6) | 0;
  HEAP32[i40 >> 2] = i5;
 } else i5 = i35;
 HEAP32[i36 >> 2] = i6;
 i5 = i5 + 15 & -16;
 __ZN2cv3MatC2EiiiPvj(i39, i18, i20, i10, i5, i4);
 i12 = i5 + i1 | 0;
 i31 = i37 + 4 | 0;
 HEAP32[i31 >> 2] = 2;
 i33 = i37 + 8 | 0;
 HEAP32[i33 >> 2] = i18;
 HEAP32[i37 + 12 >> 2] = 1;
 i28 = i37 + 16 | 0;
 HEAP32[i28 >> 2] = i12;
 HEAP32[i37 + 20 >> 2] = i12;
 i12 = i37 + 24 | 0;
 i29 = i37 + 40 | 0;
 HEAP32[i12 + 0 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i29 >> 2] = i33;
 i33 = i37 + 48 | 0;
 i32 = i37 + 44 | 0;
 HEAP32[i32 >> 2] = i33;
 i6 = (i9 >>> 3 & 511) + 1 << (47696 >>> (i9 << 1 & 14) & 3);
 HEAP32[i37 >> 2] = i10 | 1124024320;
 HEAP32[i33 >> 2] = i6;
 HEAP32[i37 + 52 >> 2] = i6;
 i6 = i5 + ((Math_imul(i18, i6) | 0) + i1) | 0;
 HEAP32[i37 + 28 >> 2] = i6;
 HEAP32[i12 >> 2] = i6;
 __ZN2cv3MatC2EiiiPvj(i34, i11, i20, i10, i5, i4);
 HEAP32[i30 >> 2] = 1124007936;
 i12 = i30 + 4 | 0;
 i6 = i30 + 8 | 0;
 i9 = i30 + 40 | 0;
 i7 = i12 + 0 | 0;
 i8 = i7 + 36 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAP32[i9 >> 2] = i6;
 i8 = i30 + 48 | 0;
 i7 = i30 + 44 | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i30 + 52 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 if (i22) {
  __ZN2cv3MatC2EiiiPvj(i13, i18, i18, i10, i5 + (i1 + i3) + 15 & -16, i2);
  __ZN2cv3MataSERKS0_(i30, i13) | 0;
  i6 = i13 + 36 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  if ((i5 | 0) != 0 ? (i2 = i5 + 12 | 0, i1 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i13);
  HEAP32[i6 >> 2] = 0;
  i1 = i13 + 16 | 0;
  i6 = i13 + 4 | 0;
  HEAP32[i1 + 0 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   i5 = HEAP32[i13 + 40 >> 2] | 0;
   i4 = 0;
   do {
    HEAP32[i5 + (i4 << 2) >> 2] = 0;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) < (HEAP32[i6 >> 2] | 0));
  }
  i6 = HEAP32[i13 + 44 >> 2] | 0;
  if ((i6 | 0) != (i13 + 48 | 0)) __ZN2cv8fastFreeEPv(i6);
 }
 if ((i11 | 0) > (i18 | 0)) {
  HEAP32[i14 + 0 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = 0;
  HEAP32[i14 + 16 >> 2] = 0;
  HEAP32[i14 + 20 >> 2] = 0;
  HEAP32[i14 + 24 >> 2] = 0;
  HEAP32[i14 + 28 >> 2] = 0;
  __ZN2cv3MataSERKNS_7Scalar_IdEE(i34, i14) | 0;
 }
 if (i21) {
  i16 = i17 + 4 | 0;
  HEAP32[i16 + 0 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  HEAP32[i16 + 12 >> 2] = 0;
  HEAP32[i17 >> 2] = 32232;
  HEAP32[i16 >> 2] = 33619968;
  HEAP32[i17 + 8 >> 2] = i39;
  __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i41, i17);
 } else {
  HEAP32[i15 >> 2] = 32088;
  HEAP32[i15 + 12 >> 2] = 0;
  HEAP32[i15 + 16 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 16842752;
  HEAP32[i15 + 8 >> 2] = i41;
  i17 = i16 + 4 | 0;
  HEAP32[i17 + 0 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  HEAP32[i17 + 12 >> 2] = 0;
  HEAP32[i16 >> 2] = 32232;
  HEAP32[i17 >> 2] = 33619968;
  HEAP32[i16 + 8 >> 2] = i39;
  __ZN2cv9transposeERKNS_11_InputArrayERKNS_12_OutputArrayE(i15, i16);
 }
 i10 = i39 + 16 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i19) {
  i5 = HEAP32[i30 + 16 >> 2] | 0;
  i6 = i22 ? i11 : 0;
  if (!i5) i6 = 0; else i6 = (i6 | 0) < 0 ? i18 : i6;
  __ZN2cv14JacobiSVDImpl_IfEEvPT_jS2_S2_jiiidS1_(i4, HEAP32[i34 + 48 >> 2] | 0, HEAP32[i28 >> 2] | 0, i5, HEAP32[i8 >> 2] | 0, i20, i18, i6, 1.1754943508222875e-38, Math_fround(2.38418579e-07));
 } else {
  i5 = HEAP32[i30 + 16 >> 2] | 0;
  i6 = i22 ? i11 : 0;
  if (!i5) i6 = 0; else i6 = (i6 | 0) < 0 ? i18 : i6;
  __ZN2cv14JacobiSVDImpl_IdEEvPT_jS2_S2_jiiidS1_(i4, HEAP32[i34 + 48 >> 2] | 0, HEAP32[i28 >> 2] | 0, i5, HEAP32[i8 >> 2] | 0, i20, i18, i6, 2.2250738585072014e-308, 2.220446049250313e-15);
 }
 __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i37, i23);
 do if (i22) {
  i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i26 >> 2] | 0) + 112 >> 2] & 127](i26) | 0;
  if (i21) {
   if (i3) {
    HEAP32[i25 >> 2] = 32088;
    HEAP32[i25 + 12 >> 2] = 0;
    HEAP32[i25 + 16 >> 2] = 0;
    HEAP32[i25 + 4 >> 2] = 16842752;
    HEAP32[i25 + 8 >> 2] = i30;
    __ZN2cv9transposeERKNS_11_InputArrayERKNS_12_OutputArrayE(i25, i26);
   }
   if (!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i27 >> 2] | 0) + 112 >> 2] & 127](i27) | 0)) break;
   __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i34, i27);
   break;
  } else {
   if (i3) {
    HEAP32[i24 >> 2] = 32088;
    HEAP32[i24 + 12 >> 2] = 0;
    HEAP32[i24 + 16 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 16842752;
    HEAP32[i24 + 8 >> 2] = i34;
    __ZN2cv9transposeERKNS_11_InputArrayERKNS_12_OutputArrayE(i24, i26);
   }
   if (!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i27 >> 2] | 0) + 112 >> 2] & 127](i27) | 0)) break;
   __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i30, i27);
   break;
  }
 } while (0);
 i3 = i30 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i30);
 HEAP32[i3 >> 2] = 0;
 i22 = i30 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 | 0) != (i8 | 0)) __ZN2cv8fastFreeEPv(i3);
 i3 = i34 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i34);
 HEAP32[i3 >> 2] = 0;
 i22 = i34 + 16 | 0;
 i3 = i34 + 4 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i34 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i3 = HEAP32[i34 + 44 >> 2] | 0;
 if ((i3 | 0) != (i34 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
 i3 = i37 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i37);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i28 + 0 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = 0;
 if ((HEAP32[i31 >> 2] | 0) > 0) {
  i3 = HEAP32[i29 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i31 >> 2] | 0));
 }
 i2 = HEAP32[i32 >> 2] | 0;
 if ((i2 | 0) != (i33 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i39 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (i1) {
  i21 = i1 + 12 | 0;
  i22 = HEAP32[i21 >> 2] | 0;
  HEAP32[i21 >> 2] = i22 + -1;
  if ((i22 | 0) != 1) break;
  __ZN2cv3Mat10deallocateEv(i39);
 } while (0);
 HEAP32[i2 >> 2] = 0;
 i3 = i39 + 4 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i39 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i2 = HEAP32[i39 + 44 >> 2] | 0;
 if ((i2 | 0) != (i39 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = HEAP32[i40 >> 2] | 0;
 if ((i2 | 0) != (i35 | 0)) {
  if (i2) __ZdaPv(i2);
  HEAP32[i40 >> 2] = i35;
  HEAP32[i36 >> 2] = 1032;
 }
 i1 = i41 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (i2) {
  i21 = i2 + 12 | 0;
  i22 = HEAP32[i21 >> 2] | 0;
  HEAP32[i21 >> 2] = i22 + -1;
  if ((i22 | 0) != 1) break;
  __ZN2cv3Mat10deallocateEv(i41);
 } while (0);
 HEAP32[i1 >> 2] = 0;
 i22 = i41 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i38 >> 2] | 0) > 0) {
  i2 = HEAP32[i41 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i38 >> 2] | 0));
 }
 i1 = HEAP32[i41 + 44 >> 2] | 0;
 if ((i1 | 0) == (i41 + 48 | 0)) {
  STACKTOP = i42;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i42;
 return;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter18OnTestIterationEndERKNS_8UnitTestEi(i2, i18, i1) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i19 = i20 + 8 | 0;
 i14 = i20 + 88 | 0;
 i15 = i20 + 76 | 0;
 i9 = i20 + 64 | 0;
 i1 = i20 + 52 | 0;
 i11 = i20 + 40 | 0;
 i10 = i20;
 i12 = i20 + 28 | 0;
 i16 = i20 + 16 | 0;
 __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(2, 162400, i19);
 i17 = i18 + 8 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i4 = HEAP32[i2 + 64 >> 2] | 0;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if ((i4 | 0) == (i2 | 0)) i6 = 0; else {
  i4 = i4 - i2 >> 2;
  i3 = 0;
  i8 = 0;
  do {
   i5 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
   i7 = HEAP32[i5 + 20 >> 2] | 0;
   i5 = HEAP32[i5 + 24 >> 2] | 0;
   if ((i7 | 0) == (i5 | 0)) i7 = 0; else {
    i6 = i7;
    i7 = 0;
    do {
     i7 = (HEAPU8[(HEAP32[i6 >> 2] | 0) + 36 >> 0] | 0) + i7 | 0;
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) != (i5 | 0));
   }
   i8 = i7 + i8 | 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i4 >>> 0);
  i6 = i8;
 }
 HEAP32[i19 >> 2] = i6;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i15, i19);
 HEAP32[i14 + 0 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i5 = HEAP8[i15 >> 0] | 0;
 if (!(i5 & 1)) {
  i8 = (i5 & 255) >>> 1;
  i7 = i15 + 1 | 0;
 } else {
  i8 = HEAP32[i15 + 4 >> 2] | 0;
  i7 = HEAP32[i15 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i14, i7, i8, i8 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i14, 163296, 1) | 0;
 i6 = (i6 | 0) == 1 ? 162456 : 162464;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i8 = HEAP8[i14 >> 0] | 0;
 if (!(i8 & 1)) {
  i5 = _strlen(i6 | 0) | 0;
  i8 = (i8 & 255) >>> 1;
  i7 = i14 + 1 | 0;
 } else {
  i8 = HEAP32[i14 + 4 >> 2] | 0;
  i5 = _strlen(i6 | 0) | 0;
  i7 = HEAP32[i14 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, i7, i8, i8 + i5 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, i6, i5) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
 if (!(HEAP8[i9 >> 0] & 1)) i3 = i9 + 1 | 0; else i3 = HEAP32[i9 + 8 >> 2] | 0;
 i6 = HEAP32[i17 >> 2] | 0;
 i8 = HEAP32[i6 + 60 >> 2] | 0;
 i6 = HEAP32[i6 + 64 >> 2] | 0;
 if ((i8 | 0) == (i6 | 0)) i7 = 0; else {
  i7 = 0;
  do {
   i7 = (HEAPU8[(HEAP32[i8 >> 2] | 0) + 52 >> 0] | 0) + i7 | 0;
   i8 = i8 + 4 | 0;
  } while ((i8 | 0) != (i6 | 0));
 }
 HEAP32[i19 >> 2] = i7;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i15, i19);
 HEAP32[i14 + 0 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i8 = HEAP8[i15 >> 0] | 0;
 if (!(i8 & 1)) {
  i8 = (i8 & 255) >>> 1;
  i6 = i15 + 1 | 0;
 } else {
  i8 = HEAP32[i15 + 4 >> 2] | 0;
  i6 = HEAP32[i15 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i14, i6, i8, i8 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i14, 163296, 1) | 0;
 i6 = (i7 | 0) == 1 ? 168920 : 168936;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i8 = HEAP8[i14 >> 0] | 0;
 if (!(i8 & 1)) {
  i5 = _strlen(i6 | 0) | 0;
  i8 = (i8 & 255) >>> 1;
  i7 = i14 + 1 | 0;
 } else {
  i8 = HEAP32[i14 + 4 >> 2] | 0;
  i5 = _strlen(i6 | 0) | 0;
  i7 = HEAP32[i14 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i1, i7, i8, i8 + i5 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, i6, i5) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
 if (!(HEAP8[i1 >> 0] & 1)) i4 = i1 + 1 | 0; else i4 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = i3;
 HEAP32[i19 + 4 >> 2] = i4;
 _printf(162632, i19 | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 if (HEAP8[159976] | 0) {
  i7 = (HEAP32[i17 >> 2] | 0) + 192 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i10;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __ZN7testing8internal18StreamableToStringIxEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i11, i10);
  if (!(HEAP8[i11 >> 0] & 1)) i2 = i11 + 1 | 0; else i2 = HEAP32[i11 + 8 >> 2] | 0;
  HEAP32[i19 >> 2] = i2;
  _printf(162648, i19 | 0) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
 }
 _putchar(10) | 0;
 __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(2, 162664, i19);
 i3 = __ZNK7testing8UnitTest21successful_test_countEv(i18) | 0;
 HEAP32[i19 >> 2] = i3;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i15, i19);
 HEAP32[i14 + 0 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i2 = HEAP8[i15 >> 0] | 0;
 if (!(i2 & 1)) {
  i2 = (i2 & 255) >>> 1;
  i1 = i15 + 1 | 0;
 } else {
  i2 = HEAP32[i15 + 4 >> 2] | 0;
  i1 = HEAP32[i15 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i14, i1, i2, i2 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i14, 163296, 1) | 0;
 i4 = (i3 | 0) == 1 ? 162456 : 162464;
 HEAP32[i12 + 0 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i2 = HEAP8[i14 >> 0] | 0;
 if (!(i2 & 1)) {
  i1 = _strlen(i4 | 0) | 0;
  i3 = (i2 & 255) >>> 1;
  i2 = i14 + 1 | 0;
 } else {
  i3 = HEAP32[i14 + 4 >> 2] | 0;
  i1 = _strlen(i4 | 0) | 0;
  i2 = HEAP32[i14 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i12, i2, i3, i3 + i1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, i4, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
 if (!(HEAP8[i12 >> 0] & 1)) i2 = i12 + 1 | 0; else i2 = HEAP32[i12 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = i2;
 _printf(162680, i19 | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
 i9 = __ZNK7testing8internal12UnitTestImpl17failed_test_countEv(HEAP32[i17 >> 2] | 0) | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 L57 : do if ((__ZNK7testing8internal12UnitTestImpl22failed_test_case_countEv(i3) | 0) <= 0) {
  i8 = i3 + 120 | 0;
  i4 = HEAP32[i3 + 116 >> 2] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) - i4 | 0;
  if ((i2 | 0) > 0) {
   i7 = i3 + 116 | 0;
   i3 = (i2 | 0) / 44 | 0;
   i2 = 0;
   while (1) {
    if (i3 >>> 0 <= i2 >>> 0) break;
    if (HEAP32[i4 + (i2 * 44 | 0) >> 2] | 0) {
     i13 = 47;
     break L57;
    }
    i2 = i2 + 1 | 0;
    i3 = ((HEAP32[i8 >> 2] | 0) - i4 | 0) / 44 | 0;
    if ((i2 | 0) >= (i3 | 0)) break L57;
   }
   __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i7);
  }
 } else i13 = 47; while (0);
 if ((i13 | 0) == 47) {
  i3 = __ZNK7testing8internal12UnitTestImpl17failed_test_countEv(HEAP32[i17 >> 2] | 0) | 0;
  __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(1, 162560, i19);
  HEAP32[i19 >> 2] = i3;
  __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i15, i19);
  HEAP32[i14 + 0 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  i2 = HEAP8[i15 >> 0] | 0;
  if (!(i2 & 1)) {
   i2 = (i2 & 255) >>> 1;
   i1 = i15 + 1 | 0;
  } else {
   i2 = HEAP32[i15 + 4 >> 2] | 0;
   i1 = HEAP32[i15 + 8 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i14, i1, i2, i2 + 1 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i14, 163296, 1) | 0;
  i1 = (i3 | 0) == 1 ? 162456 : 162464;
  HEAP32[i16 + 0 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  i2 = HEAP8[i14 >> 0] | 0;
  if (!(i2 & 1)) {
   i4 = _strlen(i1 | 0) | 0;
   i3 = (i2 & 255) >>> 1;
   i2 = i14 + 1 | 0;
  } else {
   i3 = HEAP32[i14 + 4 >> 2] | 0;
   i4 = _strlen(i1 | 0) | 0;
   i2 = HEAP32[i14 + 8 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, i2, i3, i3 + i4 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, i1, i4) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
  if (!(HEAP8[i16 >> 0] & 1)) i2 = i16 + 1 | 0; else i2 = HEAP32[i16 + 8 >> 2] | 0;
  HEAP32[i19 >> 2] = i2;
  _printf(162688, i19 | 0) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16);
  __ZN7testing8internal27PrettyUnitTestResultPrinter16PrintFailedTestsERKNS_8UnitTestE(i18);
  HEAP32[i19 >> 2] = i9;
  HEAP32[i19 + 4 >> 2] = (i9 | 0) == 1 ? 162728 : 162736;
  _printf(162712, i19 | 0) | 0;
 }
 i8 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i8 + 64 >> 2] | 0;
 i8 = HEAP32[i8 + 60 >> 2] | 0;
 if ((i2 | 0) == (i8 | 0)) {
  i10 = HEAP32[_stdout >> 2] | 0;
  _fflush(i10 | 0) | 0;
  STACKTOP = i20;
  return;
 }
 i5 = i2 - i8 >> 2;
 i6 = 0;
 i7 = 0;
 do {
  i3 = HEAP32[i8 + (i6 << 2) >> 2] | 0;
  i2 = HEAP32[i3 + 20 >> 2] | 0;
  i3 = HEAP32[i3 + 24 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) i2 = 0; else {
   i4 = i2;
   i2 = 0;
   do {
    i1 = HEAP32[i4 >> 2] | 0;
    if (!(HEAP8[i1 + 38 >> 0] | 0)) i1 = 0; else i1 = (HEAP8[i1 + 37 >> 0] | 0) != 0;
    i2 = (i1 & 1) + i2 | 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != (i3 | 0));
  }
  i7 = i2 + i7 | 0;
  i6 = i6 + 1 | 0;
 } while (i6 >>> 0 < i5 >>> 0);
 if (!((i7 | 0) != 0 & (HEAP8[159752] | 0) == 0)) {
  i10 = HEAP32[_stdout >> 2] | 0;
  _fflush(i10 | 0) | 0;
  STACKTOP = i20;
  return;
 }
 if (!i9) _putchar(10) | 0;
 HEAP32[i19 >> 2] = i7;
 HEAP32[i19 + 4 >> 2] = (i7 | 0) == 1 ? 162728 : 162736;
 __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(3, 162744, i19);
 i10 = HEAP32[_stdout >> 2] | 0;
 _fflush(i10 | 0) | 0;
 STACKTOP = i20;
 return;
}

function __ZNK2cv13AlgorithmInfo4readEPNS_9AlgorithmERKNS_8FileNodeE(i48, i38, i39) {
 i48 = i48 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0;
 i58 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 i57 = i58 + 16 | 0;
 i47 = i58 + 276 | 0;
 i41 = i58 + 232 | 0;
 i45 = i58 + 224 | 0;
 i49 = i58 + 216 | 0;
 i50 = i58 + 281 | 0;
 i51 = i58 + 8 | 0;
 i52 = i58 + 208 | 0;
 i42 = i58 + 152 | 0;
 i7 = i58 + 96 | 0;
 i44 = i58 + 80 | 0;
 i46 = i58 + 72 | 0;
 i8 = i58 + 64 | 0;
 i13 = i58 + 56 | 0;
 i24 = i58 + 48 | 0;
 i53 = i58 + 44 | 0;
 i54 = i58 + 40 | 0;
 i55 = i58;
 i56 = i58 + 280 | 0;
 i43 = i58 + 32 | 0;
 i35 = i58 + 24 | 0;
 i40 = HEAP32[i48 >> 2] | 0;
 i37 = HEAP32[i40 + 4 >> 2] | 0;
 i40 = HEAP32[i40 >> 2] | 0;
 i9 = (i37 - i40 | 0) / 44 | 0;
 i10 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i38 >> 2] | 0) + 16 >> 2] & 127](i38) | 0;
 if ((i37 | 0) == (i40 | 0)) {
  STACKTOP = i58;
  return;
 }
 i11 = i45 + 4 | 0;
 i12 = i35 + 4 | 0;
 i14 = i52 + 4 | 0;
 i15 = i42 + 4 | 0;
 i16 = i42 + 8 | 0;
 i17 = i42 + 40 | 0;
 i18 = i42 + 48 | 0;
 i19 = i42 + 44 | 0;
 i20 = i42 + 52 | 0;
 i21 = i7 + 4 | 0;
 i22 = i7 + 8 | 0;
 i23 = i7 + 40 | 0;
 i25 = i7 + 48 | 0;
 i26 = i7 + 44 | 0;
 i27 = i7 + 52 | 0;
 i28 = i7 + 36 | 0;
 i29 = i7 + 16 | 0;
 i30 = i42 + 36 | 0;
 i31 = i42 + 16 | 0;
 i32 = i44 + 4 | 0;
 i33 = i44 + 8 | 0;
 i34 = i8 + 4 | 0;
 i36 = i46 + 4 | 0;
 i37 = i24 + 4 | 0;
 i40 = 0;
 do {
  i3 = HEAP32[HEAP32[i48 >> 2] >> 2] | 0;
  i6 = i3 + (i40 * 44 | 0) | 0;
  __ZNK2cv8FileNodeixERKNS_6StringE(i45, i39, i6);
  i5 = HEAP32[i11 >> 2] | 0;
  L6 : do if (i5) {
   i1 = i3 + (i40 * 44 | 0) + 8 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   do switch (i3 | 0) {
   case 3:
    {
     HEAP32[i52 >> 2] = 0;
     HEAP32[i14 >> 2] = 0;
     __ZN2cv4readERKNS_8FileNodeERNS_6StringERKS3_(i45, i52, i52);
     i6 = HEAP32[i6 >> 2] | 0;
     __ZNK2cv13AlgorithmInfo3setEPNS_9AlgorithmEPKciPKvb(i10, i38, (i6 | 0) == 0 ? 39376 : i6, HEAP32[i1 >> 2] | 0, i52, 1);
     __ZN2cv6String10deallocateEv(i52);
     break L6;
    }
   case 8:
    {
     __ZN2cv4readERKNS_8FileNodeERii(i45, i57, 0);
     HEAP32[i54 >> 2] = HEAP32[i57 >> 2];
     i6 = HEAP32[i6 >> 2] | 0;
     __ZNK2cv13AlgorithmInfo3setEPNS_9AlgorithmEPKciPKvb(i10, i38, (i6 | 0) == 0 ? 39376 : i6, HEAP32[i1 >> 2] | 0, i54, 1);
     break L6;
    }
   case 0:
    {
     __ZN2cv4readERKNS_8FileNodeERii(i45, i57, 0);
     HEAP32[i49 >> 2] = HEAP32[i57 >> 2];
     i6 = HEAP32[i6 >> 2] | 0;
     __ZNK2cv13AlgorithmInfo3setEPNS_9AlgorithmEPKciPKvb(i10, i38, (i6 | 0) == 0 ? 39376 : i6, HEAP32[i1 >> 2] | 0, i49, 1);
     break L6;
    }
   case 6:
    {
     __ZNK2cv8FileNodeixEPKc(i13, i45, 37920);
     HEAP32[i8 >> 2] = 0;
     HEAP32[i34 >> 2] = 0;
     __ZN2cv4readERKNS_8FileNodeERNS_6StringERKS3_(i13, i8, i8);
     __ZN2cv9Algorithm7_createERKNS_6StringE(i46, i8);
     __ZN2cv6String10deallocateEv(i8);
     i3 = HEAP32[i36 >> 2] | 0;
     if (!i3) {
      HEAP32[i24 >> 2] = 0;
      HEAP32[i37 >> 2] = 0;
      i5 = (__ZN2cv6String8allocateEj(i24, 10) | 0) + 0 | 0;
      i4 = 38056 | 0;
      i3 = i5 + 10 | 0;
      do {
       HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
       i5 = i5 + 1 | 0;
       i4 = i4 + 1 | 0;
      } while ((i5 | 0) < (i3 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i24, 38072, 37992, 493);
      __ZN2cv6String10deallocateEv(i24);
      i3 = HEAP32[i36 >> 2] | 0;
     }
     FUNCTION_TABLE_vii[HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] & 127](i3, i45);
     i6 = HEAP32[i6 >> 2] | 0;
     __ZNK2cv13AlgorithmInfo3setEPNS_9AlgorithmEPKciPKvb(i10, i38, (i6 | 0) == 0 ? 39376 : i6, HEAP32[i1 >> 2] | 0, i46, 1);
     i1 = HEAP32[i46 >> 2] | 0;
     if ((i1 | 0) != 0 ? (i5 = i1 + 4 | 0, i6 = HEAP32[i5 >> 2] | 0, HEAP32[i5 >> 2] = i6 + -1, (i6 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
     HEAP32[i46 >> 2] = 0;
     HEAP32[i36 >> 2] = 0;
     break L6;
    }
   case 7:
    {
     __ZN2cv4readERKNS_8FileNodeERff(i45, i57, Math_fround(0.0));
     HEAPF32[i53 >> 2] = Math_fround(HEAPF32[i57 >> 2]);
     i6 = HEAP32[i6 >> 2] | 0;
     __ZNK2cv13AlgorithmInfo3setEPNS_9AlgorithmEPKciPKvb(i10, i38, (i6 | 0) == 0 ? 39376 : i6, HEAP32[i1 >> 2] | 0, i53, 1);
     break L6;
    }
   case 1:
    {
     __ZN2cv4readERKNS_8FileNodeERii(i45, i57, 0);
     HEAP8[i50 >> 0] = (HEAP32[i57 >> 2] | 0) != 0 & 1;
     i6 = HEAP32[i6 >> 2] | 0;
     __ZNK2cv13AlgorithmInfo3setEPNS_9AlgorithmEPKciPKvb(i10, i38, (i6 | 0) == 0 ? 39376 : i6, HEAP32[i1 >> 2] | 0, i50, 1);
     break L6;
    }
   case 4:
    {
     HEAP32[i42 >> 2] = 1124007936;
     i5 = i15 + 0 | 0;
     i3 = i5 + 36 | 0;
     do {
      HEAP32[i5 >> 2] = 0;
      i5 = i5 + 4 | 0;
     } while ((i5 | 0) < (i3 | 0));
     HEAP32[i17 >> 2] = i16;
     HEAP32[i19 >> 2] = i18;
     HEAP32[i20 >> 2] = 0;
     HEAP32[i18 >> 2] = 0;
     HEAP32[i7 >> 2] = 1124007936;
     i5 = i21 + 0 | 0;
     i3 = i5 + 36 | 0;
     do {
      HEAP32[i5 >> 2] = 0;
      i5 = i5 + 4 | 0;
     } while ((i5 | 0) < (i3 | 0));
     HEAP32[i23 >> 2] = i22;
     HEAP32[i26 >> 2] = i25;
     HEAP32[i27 >> 2] = 0;
     HEAP32[i25 >> 2] = 0;
     __ZN2cv4readERKNS_8FileNodeERNS_3MatERKS3_(i45, i42, i7);
     i3 = HEAP32[i28 >> 2] | 0;
     if ((i3 | 0) != 0 ? (i4 = i3 + 12 | 0, i5 = HEAP32[i4 >> 2] | 0, HEAP32[i4 >> 2] = i5 + -1, (i5 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i7);
     HEAP32[i28 >> 2] = 0;
     HEAP32[i29 + 0 >> 2] = 0;
     HEAP32[i29 + 4 >> 2] = 0;
     HEAP32[i29 + 8 >> 2] = 0;
     HEAP32[i29 + 12 >> 2] = 0;
     if ((HEAP32[i21 >> 2] | 0) > 0) {
      i3 = HEAP32[i23 >> 2] | 0;
      i2 = 0;
      do {
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) < (HEAP32[i21 >> 2] | 0));
     }
     i3 = HEAP32[i26 >> 2] | 0;
     if ((i3 | 0) != (i25 | 0)) __ZN2cv8fastFreeEPv(i3);
     i6 = HEAP32[i6 >> 2] | 0;
     __ZNK2cv13AlgorithmInfo3setEPNS_9AlgorithmEPKciPKvb(i10, i38, (i6 | 0) == 0 ? 39376 : i6, HEAP32[i1 >> 2] | 0, i42, 1);
     i1 = HEAP32[i30 >> 2] | 0;
     if ((i1 | 0) != 0 ? (i5 = i1 + 12 | 0, i6 = HEAP32[i5 >> 2] | 0, HEAP32[i5 >> 2] = i6 + -1, (i6 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i42);
     HEAP32[i30 >> 2] = 0;
     HEAP32[i31 + 0 >> 2] = 0;
     HEAP32[i31 + 4 >> 2] = 0;
     HEAP32[i31 + 8 >> 2] = 0;
     HEAP32[i31 + 12 >> 2] = 0;
     if ((HEAP32[i15 >> 2] | 0) > 0) {
      i2 = HEAP32[i17 >> 2] | 0;
      i1 = 0;
      do {
       HEAP32[i2 + (i1 << 2) >> 2] = 0;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) < (HEAP32[i15 >> 2] | 0));
     }
     i1 = HEAP32[i19 >> 2] | 0;
     if ((i1 | 0) == (i18 | 0)) break L6;
     __ZN2cv8fastFreeEPv(i1);
     break L6;
    }
   case 9:
    {
     __ZN2cv4readERKNS_8FileNodeERii(i45, i57, 0);
     i4 = HEAP32[i57 >> 2] | 0;
     i5 = i55;
     HEAP32[i5 >> 2] = i4;
     HEAP32[i5 + 4 >> 2] = ((i4 | 0) < 0) << 31 >> 31;
     i6 = HEAP32[i6 >> 2] | 0;
     __ZNK2cv13AlgorithmInfo3setEPNS_9AlgorithmEPKciPKvb(i10, i38, (i6 | 0) == 0 ? 39376 : i6, HEAP32[i1 >> 2] | 0, i55, 1);
     break L6;
    }
   case 5:
    {
     HEAP32[i44 >> 2] = 0;
     HEAP32[i32 >> 2] = 0;
     HEAP32[i33 >> 2] = 0;
     __ZN2cv16FileNodeIteratorC2EPK13CvFileStoragePK10CvFileNodej(i41, HEAP32[i45 >> 2] | 0, i5, 0);
     HEAP32[i47 >> 2] = i41;
     __ZNK2cv8internal14VecReaderProxyINS_3MatELi0EEclERNSt3__16vectorIS2_NS4_9allocatorIS2_EEEEj(i47, i44, 2147483647);
     i6 = HEAP32[i6 >> 2] | 0;
     __ZNK2cv13AlgorithmInfo3setEPNS_9AlgorithmEPKciPKvb(i10, i38, (i6 | 0) == 0 ? 39376 : i6, HEAP32[i1 >> 2] | 0, i44, 1);
     i1 = HEAP32[i44 >> 2] | 0;
     if (!i1) break L6;
     i2 = HEAP32[i32 >> 2] | 0;
     if ((i2 | 0) != (i1 | 0)) {
      do {
       i3 = i2 + -56 | 0;
       HEAP32[i32 >> 2] = i3;
       i4 = i2 + -20 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if ((i5 | 0) != 0 ? (i5 = i5 + 12 | 0, i6 = HEAP32[i5 >> 2] | 0, HEAP32[i5 >> 2] = i6 + -1, (i6 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
       HEAP32[i4 >> 2] = 0;
       i6 = i2 + -40 | 0;
       i5 = i2 + -52 | 0;
       HEAP32[i6 + 0 >> 2] = 0;
       HEAP32[i6 + 4 >> 2] = 0;
       HEAP32[i6 + 8 >> 2] = 0;
       HEAP32[i6 + 12 >> 2] = 0;
       if ((HEAP32[i5 >> 2] | 0) > 0) {
        i4 = HEAP32[i2 + -16 >> 2] | 0;
        i3 = 0;
        do {
         HEAP32[i4 + (i3 << 2) >> 2] = 0;
         i3 = i3 + 1 | 0;
        } while ((i3 | 0) < (HEAP32[i5 >> 2] | 0));
       }
       i3 = HEAP32[i2 + -12 >> 2] | 0;
       if ((i3 | 0) != (i2 + -8 | 0)) __ZN2cv8fastFreeEPv(i3);
       i2 = HEAP32[i32 >> 2] | 0;
      } while ((i2 | 0) != (i1 | 0));
      i1 = HEAP32[i44 >> 2] | 0;
     }
     __ZdlPv(i1);
     break L6;
    }
   case 11:
    {
     __ZN2cv4readERKNS_8FileNodeERii(i45, i57, 0);
     HEAP8[i56 >> 0] = HEAP32[i57 >> 2];
     i6 = HEAP32[i6 >> 2] | 0;
     __ZNK2cv13AlgorithmInfo3setEPNS_9AlgorithmEPKciPKvb(i10, i38, (i6 | 0) == 0 ? 39376 : i6, HEAP32[i1 >> 2] | 0, i56, 1);
     break L6;
    }
   case 2:
    {
     __ZN2cv4readERKNS_8FileNodeERdd(i45, i57, 0.0);
     HEAPF64[i51 >> 3] = +HEAPF64[i57 >> 3];
     i6 = HEAP32[i6 >> 2] | 0;
     __ZNK2cv13AlgorithmInfo3setEPNS_9AlgorithmEPKciPKvb(i10, i38, (i6 | 0) == 0 ? 39376 : i6, HEAP32[i1 >> 2] | 0, i51, 1);
     break L6;
    }
   default:
    {
     i5 = HEAP32[i6 >> 2] | 0;
     HEAP32[i57 >> 2] = (i5 | 0) == 0 ? 39376 : i5;
     HEAP32[i57 + 4 >> 2] = i3;
     __ZN2cv6formatEPKcz(i43, 37928, i57);
     i5 = HEAP32[i43 >> 2] | 0;
     i5 = (i5 | 0) == 0 ? 39376 : i5;
     HEAP32[i35 >> 2] = 0;
     HEAP32[i12 >> 2] = 0;
     i6 = _strlen(i5 | 0) | 0;
     _memcpy(__ZN2cv6String8allocateEj(i35, i6) | 0, i5 | 0, i6 | 0) | 0;
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-210, i35, 38072, 37992, 520);
     __ZN2cv6String10deallocateEv(i35);
     __ZN2cv6String10deallocateEv(i43);
     break L6;
    }
   } while (0);
  } while (0);
  i40 = i40 + 1 | 0;
 } while (i40 >>> 0 < i9 >>> 0);
 STACKTOP = i58;
 return;
}
function __ZNK2cv11_InputArray4sizeEi(i16, i14, i15) {
 i16 = i16 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i5 = i17 + 88 | 0;
 i4 = i17 + 80 | 0;
 i2 = i17 + 72 | 0;
 i1 = i17 + 64 | 0;
 i6 = i17 + 56 | 0;
 i13 = i17 + 48 | 0;
 i11 = i17 + 40 | 0;
 i12 = i17 + 32 | 0;
 i7 = i17 + 24 | 0;
 i8 = i17 + 16 | 0;
 i9 = i17 + 8 | 0;
 i10 = i17;
 i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] & 127](i14) | 0;
 do if ((i3 | 0) == 65536) {
  if ((i15 | 0) >= 0) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i5, 5) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 29200, 27528, 1450);
   __ZN2cv6String10deallocateEv(i5);
  }
  i9 = HEAP32[(HEAP32[i14 + 8 >> 2] | 0) + 40 >> 2] | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  HEAP32[i16 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i16 + 4 >> 2] = i10;
  STACKTOP = i17;
  return;
 } else if ((i3 | 0) == 262144) {
  i3 = i14 + 8 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i15 | 0) < 0) {
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if ((i2 | 0) == (i1 | 0)) {
    HEAP32[i16 >> 2] = 0;
    HEAP32[i16 + 4 >> 2] = 0;
    STACKTOP = i17;
    return;
   } else {
    HEAP32[i16 >> 2] = (i1 - i2 | 0) / 12 | 0;
    HEAP32[i16 + 4 >> 2] = 1;
    STACKTOP = i17;
    return;
   }
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if ((((HEAP32[i1 + 4 >> 2] | 0) - i2 | 0) / 12 | 0 | 0) <= (i15 | 0)) {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   i2 = (__ZN2cv6String8allocateEj(i13, 18) | 0) + 0 | 0;
   i4 = 29208 | 0;
   i5 = i2 + 18 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i4 = i4 + 1 | 0;
   } while ((i2 | 0) < (i5 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i13, 29200, 27528, 1489);
   __ZN2cv6String10deallocateEv(i13);
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  i2 = (HEAP32[i2 + (i15 * 12 | 0) + 4 >> 2] | 0) - (HEAP32[i2 + (i15 * 12 | 0) >> 2] | 0) | 0;
  i10 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == ((HEAP32[i10 + (i15 * 12 | 0) + 4 >> 2] | 0) - (HEAP32[i10 + (i15 * 12 | 0) >> 2] | 0) >> 2 | 0)) {
   HEAP32[i16 >> 2] = i2;
   HEAP32[i16 + 4 >> 2] = 1;
   STACKTOP = i17;
   return;
  } else {
   i10 = HEAP32[i14 + 4 >> 2] | 0;
   HEAP32[i16 >> 2] = (i2 >>> 0) / ((i10 >>> 3 & 511) + 1 << (47696 >>> (i10 << 1 & 14) & 3) >>> 0) | 0;
   HEAP32[i16 + 4 >> 2] = 1;
   STACKTOP = i17;
   return;
  }
 } else if ((i3 | 0) == 196608) {
  if ((i15 | 0) >= 0) {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i6, 5) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i6, 29200, 27528, 1474);
   __ZN2cv6String10deallocateEv(i6);
  }
  i10 = HEAP32[i14 + 8 >> 2] | 0;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i1 = i9 - i10 | 0;
  if ((i1 | 0) == (i9 - i10 >> 2 | 0)) {
   HEAP32[i16 >> 2] = i1;
   HEAP32[i16 + 4 >> 2] = 1;
   STACKTOP = i17;
   return;
  } else {
   i10 = HEAP32[i14 + 4 >> 2] | 0;
   HEAP32[i16 >> 2] = (i1 >>> 0) / ((i10 >>> 3 & 511) + 1 << (47696 >>> (i10 << 1 & 14) & 3) >>> 0) | 0;
   HEAP32[i16 + 4 >> 2] = 1;
   STACKTOP = i17;
   return;
  }
 } else if ((i3 | 0) == 131072) {
  if ((i15 | 0) >= 0) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i1, 5) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 29200, 27528, 1468);
   __ZN2cv6String10deallocateEv(i1);
  }
  HEAP32[i16 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 16 >> 2];
  STACKTOP = i17;
  return;
 } else if ((i3 | 0) == 458752) {
  if ((i15 | 0) >= 0) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i7, 5) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 29200, 27528, 1518);
   __ZN2cv6String10deallocateEv(i7);
  }
  i9 = HEAP32[i14 + 8 >> 2] | 0;
  i10 = HEAP32[i9 + 8 >> 2] | 0;
  HEAP32[i16 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i16 + 4 >> 2] = i10;
  STACKTOP = i17;
  return;
 } else if ((i3 | 0) == 327680) {
  i3 = HEAP32[i14 + 8 >> 2] | 0;
  if ((i15 | 0) >= 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   if ((((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 56 | 0 | 0) <= (i15 | 0)) {
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    i2 = (__ZN2cv6String8allocateEj(i11, 18) | 0) + 0 | 0;
    i4 = 29208 | 0;
    i5 = i2 + 18 | 0;
    do {
     HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
     i2 = i2 + 1 | 0;
     i4 = i4 + 1 | 0;
    } while ((i2 | 0) < (i5 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i11, 29200, 27528, 1501);
    __ZN2cv6String10deallocateEv(i11);
    i1 = HEAP32[i3 >> 2] | 0;
   }
   i9 = HEAP32[i1 + (i15 * 56 | 0) + 40 >> 2] | 0;
   i10 = HEAP32[i9 >> 2] | 0;
   HEAP32[i16 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i16 + 4 >> 2] = i10;
   STACKTOP = i17;
   return;
  }
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if ((i2 | 0) == (i1 | 0)) {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   STACKTOP = i17;
   return;
  } else {
   HEAP32[i16 >> 2] = (i1 - i2 | 0) / 56 | 0;
   HEAP32[i16 + 4 >> 2] = 1;
   STACKTOP = i17;
   return;
  }
 } else if ((i3 | 0) == 655360) {
  if ((i15 | 0) >= 0) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i2, 5) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 29200, 27528, 1462);
   __ZN2cv6String10deallocateEv(i2);
  }
  i9 = HEAP32[(HEAP32[i14 + 8 >> 2] | 0) + 32 >> 2] | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  HEAP32[i16 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i16 + 4 >> 2] = i10;
  STACKTOP = i17;
  return;
 } else if ((i3 | 0) == 393216) {
  if ((i15 | 0) >= 0) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i4, 5) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 29200, 27528, 1456);
   __ZN2cv6String10deallocateEv(i4);
  }
  __ZNK2cv7MatExpr4sizeEv(i16, HEAP32[i14 + 8 >> 2] | 0);
  STACKTOP = i17;
  return;
 } else if ((i3 | 0) == 589824) {
  if ((i15 | 0) >= 0) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i8, 5) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 29200, 27528, 1525);
   __ZN2cv6String10deallocateEv(i8);
  }
  i9 = HEAP32[i14 + 8 >> 2] | 0;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  HEAP32[i16 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i16 + 4 >> 2] = i10;
  STACKTOP = i17;
  return;
 } else if (!i3) {
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  STACKTOP = i17;
  return;
 } else if ((i3 | 0) == 720896) {
  i3 = HEAP32[i14 + 8 >> 2] | 0;
  if ((i15 | 0) >= 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   if ((((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 48 | 0 | 0) <= (i15 | 0)) {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    i2 = (__ZN2cv6String8allocateEj(i12, 18) | 0) + 0 | 0;
    i4 = 29208 | 0;
    i5 = i2 + 18 | 0;
    do {
     HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
     i2 = i2 + 1 | 0;
     i4 = i4 + 1 | 0;
    } while ((i2 | 0) < (i5 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i12, 29200, 27528, 1511);
    __ZN2cv6String10deallocateEv(i12);
    i1 = HEAP32[i3 >> 2] | 0;
   }
   i9 = HEAP32[i1 + (i15 * 48 | 0) + 32 >> 2] | 0;
   i10 = HEAP32[i9 >> 2] | 0;
   HEAP32[i16 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i16 + 4 >> 2] = i10;
   STACKTOP = i17;
   return;
  }
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if ((i2 | 0) == (i1 | 0)) {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   STACKTOP = i17;
   return;
  } else {
   HEAP32[i16 >> 2] = (i1 - i2 | 0) / 48 | 0;
   HEAP32[i16 + 4 >> 2] = 1;
   STACKTOP = i17;
   return;
  }
 } else if ((i3 | 0) != 524288) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i9, 13) | 0) + 0 | 0;
  i4 = 29232 | 0;
  i5 = i2 + 13 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i2 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i9, 29200, 27528, 1530);
  __ZN2cv6String10deallocateEv(i9);
 } while (0);
 if ((i15 | 0) >= 0) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i9 = __ZN2cv6String8allocateEj(i10, 5) | 0;
  HEAP8[i9 + 0 >> 0] = HEAP8[28696] | 0;
  HEAP8[i9 + 1 >> 0] = HEAP8[28697] | 0;
  HEAP8[i9 + 2 >> 0] = HEAP8[28698] | 0;
  HEAP8[i9 + 3 >> 0] = HEAP8[28699] | 0;
  HEAP8[i9 + 4 >> 0] = HEAP8[28700] | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 29200, 27528, 1533);
  __ZN2cv6String10deallocateEv(i10);
 }
 i9 = HEAP32[i14 + 8 >> 2] | 0;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i16 + 4 >> 2] = i10;
 STACKTOP = i17;
 return;
}

function __ZN7testing8internal24XmlUnitTestResultPrinter16PrintXmlUnitTestEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS_8UnitTestE(i30, i4) {
 i30 = i30 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i31 = i32 + 220 | 0;
 i1 = i32 + 208 | 0;
 i9 = i32 + 196 | 0;
 i10 = i32 + 192 | 0;
 i11 = i32 + 180 | 0;
 i12 = i32 + 168 | 0;
 i13 = i32 + 164 | 0;
 i22 = i32 + 152 | 0;
 i23 = i32 + 140 | 0;
 i24 = i32 + 136 | 0;
 i25 = i32 + 124 | 0;
 i14 = i32 + 112 | 0;
 i15 = i32 + 100 | 0;
 i16 = i32 + 88 | 0;
 i17 = i32 + 76 | 0;
 i18 = i32 + 64 | 0;
 i19 = i32 + 52 | 0;
 i20 = i32 + 40 | 0;
 i21 = i32 + 36 | 0;
 i26 = i32 + 24 | 0;
 i27 = i32 + 12 | 0;
 i28 = i32;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i31, 163616, 10);
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i30, 163632, 39) | 0;
 i6 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i30, 163672, 1) | 0;
 i7 = HEAP8[i31 >> 0] | 0;
 if (!(i7 & 1)) {
  i5 = i31 + 1 | 0;
  i7 = (i7 & 255) >>> 1;
 } else {
  i5 = HEAP32[i31 + 8 >> 2] | 0;
  i7 = HEAP32[i31 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i5, i7) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 162464, 5);
 i29 = i4 + 8 | 0;
 i2 = HEAP32[i29 >> 2] | 0;
 i7 = HEAP32[i2 + 64 >> 2] | 0;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if ((i7 | 0) == (i2 | 0)) i7 = 0; else {
  i4 = i7 - i2 >> 2;
  i3 = 0;
  i7 = 0;
  do {
   i8 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
   i6 = HEAP32[i8 + 20 >> 2] | 0;
   i8 = HEAP32[i8 + 24 >> 2] | 0;
   if ((i6 | 0) == (i8 | 0)) i6 = 0; else {
    i5 = i6;
    i6 = 0;
    do {
     i6 = (HEAPU8[(HEAP32[i5 >> 2] | 0) + 38 >> 0] | 0) + i6 | 0;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) != (i8 | 0));
   }
   i7 = i6 + i7 | 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i4 >>> 0);
 }
 HEAP32[i10 >> 2] = i7;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i9, i10);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i30, i31, i1, i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, 163560, 8);
 HEAP32[i13 >> 2] = __ZNK7testing8internal12UnitTestImpl17failed_test_countEv(HEAP32[i29 >> 2] | 0) | 0;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i12, i13);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i30, i31, i11, i12);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, 163576, 8);
 i8 = HEAP32[i29 >> 2] | 0;
 i7 = HEAP32[i8 + 64 >> 2] | 0;
 i8 = HEAP32[i8 + 60 >> 2] | 0;
 if ((i7 | 0) == (i8 | 0)) i7 = 0; else {
  i2 = i7 - i8 >> 2;
  i1 = 0;
  i7 = 0;
  do {
   i3 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
   i6 = HEAP32[i3 + 20 >> 2] | 0;
   i3 = HEAP32[i3 + 24 >> 2] | 0;
   if ((i6 | 0) == (i3 | 0)) i6 = 0; else {
    i4 = i6;
    i6 = 0;
    do {
     i5 = HEAP32[i4 >> 2] | 0;
     if (!(HEAP8[i5 + 38 >> 0] | 0)) i5 = 0; else i5 = (HEAP8[i5 + 37 >> 0] | 0) != 0;
     i6 = (i5 & 1) + i6 | 0;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) != (i3 | 0));
   }
   i7 = i6 + i7 | 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 HEAP32[i24 >> 2] = i7;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i23, i24);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i30, i31, i22, i23);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i25, 163592, 6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, 163600, 1);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i30, i31, i25, i14);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i25);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, 163680, 9);
 i22 = (HEAP32[i29 >> 2] | 0) + 184 | 0;
 __ZN7testing8internal32FormatEpochTimeInMillisAsIso8601Ex(i16, HEAP32[i22 >> 2] | 0, HEAP32[i22 + 4 >> 2] | 0);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i30, i31, i15, i16);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, 163408, 4);
 i22 = (HEAP32[i29 >> 2] | 0) + 192 | 0;
 __ZN7testing8internal27FormatTimeInMillisAsSecondsEx(i18, HEAP32[i22 >> 2] | 0, HEAP32[i22 + 4 >> 2] | 0);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i30, i31, i17, i18);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i18);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
 if (HEAP8[160040] | 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i19, 160008, 11);
  HEAP32[i21 >> 2] = HEAP32[(HEAP32[i29 >> 2] | 0) + 172 >> 2];
  __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i20, i21);
  __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i30, i31, i19, i20);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
 }
 __ZN7testing8internal24XmlUnitTestResultPrinter29TestPropertiesAsXmlAttributesERKNS_10TestResultE(i26, (HEAP32[i29 >> 2] | 0) + 112 | 0);
 i2 = HEAP8[i26 >> 0] | 0;
 if (!(i2 & 1)) {
  i1 = i26 + 1 | 0;
  i2 = (i2 & 255) >>> 1;
 } else {
  i1 = HEAP32[i26 + 8 >> 2] | 0;
  i2 = HEAP32[i26 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i30, i1, i2) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i26);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i27, 163344, 4);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i28, 163696, 8);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i30, i31, i27, i28);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i28);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i27);
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i30, 163432, 2) | 0;
 i1 = HEAP32[i29 >> 2] | 0;
 i2 = HEAP32[i1 + 60 >> 2] | 0;
 if (((HEAP32[i1 + 64 >> 2] | 0) - i2 | 0) > 0) {
  i7 = 0;
  do {
   i6 = HEAP32[i2 + (i7 << 2) >> 2] | 0;
   i3 = HEAP32[i6 + 20 >> 2] | 0;
   i5 = HEAP32[i6 + 24 >> 2] | 0;
   if ((i3 | 0) != (i5 | 0)) {
    i4 = 0;
    do {
     i4 = (HEAPU8[(HEAP32[i3 >> 2] | 0) + 38 >> 0] | 0) + i4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i5 | 0));
    if ((i4 | 0) > 0) {
     i2 = HEAP32[i1 + 72 >> 2] | 0;
     if (((HEAP32[i1 + 76 >> 2] | 0) - i2 >> 2 | 0) > (i7 | 0)) i2 = (HEAP32[i2 + (i7 << 2) >> 2] | 0) < 0 ? 0 : i6; else i2 = 0;
     __ZN7testing8internal24XmlUnitTestResultPrinter16PrintXmlTestCaseEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS_8TestCaseE(i30, i2);
     i2 = HEAP32[i29 >> 2] | 0;
     i1 = i2;
     i2 = HEAP32[i2 + 60 >> 2] | 0;
    }
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) < ((HEAP32[i1 + 64 >> 2] | 0) - i2 >> 2 | 0));
 }
 i1 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i30, 163712, 2) | 0;
 i2 = HEAP8[i31 >> 0] | 0;
 if (!(i2 & 1)) {
  i21 = i31 + 1 | 0;
  i22 = (i2 & 255) >>> 1;
  i22 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i21, i22) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i22, 163432, 2) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i31);
  STACKTOP = i32;
  return;
 } else {
  i21 = HEAP32[i31 + 8 >> 2] | 0;
  i22 = HEAP32[i31 + 4 >> 2] | 0;
  i22 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i21, i22) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i22, 163432, 2) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i31);
  STACKTOP = i32;
  return;
 }
}

function __ZN2cv11JacobiImpl_IfEEbPT_jS2_S2_jiPh(i23, i1, i27, i26, i2, i28, i4) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 i2 = i2 | 0;
 i28 = i28 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i29 = 0, i30 = 0, i31 = 0;
 i29 = STACKTOP;
 i22 = i1 >>> 2;
 i25 = (i26 | 0) != 0;
 if (i25) {
  i2 = i2 >>> 2;
  if ((i28 | 0) > 0) {
   i1 = i28 << 2;
   i3 = 0;
   do {
    i21 = Math_imul(i2, i3) | 0;
    _memset(i26 + (i21 << 2) | 0, 0, i1 | 0) | 0;
    HEAPF32[i26 + (i21 + i3 << 2) >> 2] = Math_fround(1.0);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i28 | 0));
  }
 }
 i21 = Math_imul(i28 * 30 | 0, i28) | 0;
 i20 = i4 + 3 & -4;
 i24 = (i28 | 0) > 0;
 L7 : do if (i24) {
  i1 = i22 + 1 | 0;
  i12 = i28 + -1 | 0;
  i14 = 0;
  do {
   HEAPF32[i27 + (i14 << 2) >> 2] = Math_fround(HEAPF32[i23 + ((Math_imul(i14, i1) | 0) << 2) >> 2]);
   if ((i14 | 0) < (i12 | 0)) {
    i6 = i14 + 1 | 0;
    i3 = Math_imul(i14, i22) | 0;
    i4 = i14 + 2 | 0;
    if ((i4 | 0) < (i28 | 0)) {
     i5 = i4;
     i4 = i6;
     f7 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + (i3 + i6 << 2) >> 2])));
     while (1) {
      f8 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + (i5 + i3 << 2) >> 2])));
      i6 = f7 < f8;
      i4 = i6 ? i5 : i4;
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i28 | 0)) break; else f7 = i6 ? f8 : f7;
     }
    } else i4 = i6;
    HEAP32[i20 + (i14 << 2) >> 2] = i4;
   }
   if ((i14 | 0) > 0) {
    if ((i14 | 0) > 1) {
     i5 = 1;
     i4 = 0;
     f8 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + (i14 << 2) >> 2])));
     while (1) {
      f7 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + ((Math_imul(i5, i22) | 0) + i14 << 2) >> 2])));
      i6 = f8 < f7;
      i4 = i6 ? i5 : i4;
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i14 | 0)) break; else f8 = i6 ? f7 : f8;
     }
    } else i4 = 0;
    HEAP32[i20 + (i14 + i28 << 2) >> 2] = i4;
   }
   i14 = i14 + 1 | 0;
  } while ((i14 | 0) != (i28 | 0));
  if ((i28 | 0) > 1 & (i21 | 0) > 0) {
   i17 = i28 + -1 | 0;
   i18 = (i17 | 0) > 1;
   i19 = 0;
   do {
    i6 = HEAP32[i20 >> 2] | 0;
    f8 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + (i6 << 2) >> 2])));
    if (i18) {
     i6 = 1;
     i5 = 0;
     do {
      i1 = Math_imul(i6, i22) | 0;
      f7 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + ((HEAP32[i20 + (i6 << 2) >> 2] | 0) + i1 << 2) >> 2])));
      i1 = f8 < f7;
      f8 = i1 ? f7 : f8;
      i5 = i1 ? i6 : i5;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i17 | 0));
     i4 = 1;
     i15 = i5;
     i16 = HEAP32[i20 + (i5 << 2) >> 2] | 0;
    } else {
     i4 = 1;
     i15 = 0;
     i16 = i6;
    }
    while (1) {
     i1 = HEAP32[i20 + (i4 + i28 << 2) >> 2] | 0;
     f7 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + ((Math_imul(i1, i22) | 0) + i4 << 2) >> 2])));
     i6 = f8 < f7;
     i16 = i6 ? i4 : i16;
     i15 = i6 ? i1 : i15;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i28 | 0)) break; else f8 = i6 ? f7 : f8;
    }
    i1 = Math_imul(i15, i22) | 0;
    i6 = i23 + (i1 + i16 << 2) | 0;
    f11 = Math_fround(HEAPF32[i6 >> 2]);
    f9 = Math_fround(Math_abs(Math_fround(f11)));
    if (f9 <= Math_fround(1.1920929e-07)) break L7;
    i5 = i27 + (i16 << 2) | 0;
    f13 = Math_fround(HEAPF32[i5 >> 2]);
    i4 = i27 + (i15 << 2) | 0;
    f13 = Math_fround(Math_fround(f13 - Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
    f7 = Math_fround(Math_abs(Math_fround(f13)));
    if (!(f9 > f7)) if (f13 != f13 | Math_fround(0.0) != Math_fround(0.0) | f13 == Math_fround(0.0)) f8 = Math_fround(0.0); else {
     f8 = Math_fround(f9 / f7);
     f8 = Math_fround(f7 * Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(1.0)))));
    } else {
     f8 = Math_fround(f7 / f9);
     f8 = Math_fround(f9 * Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(1.0)))));
    }
    f10 = Math_fround(f7 + f8);
    f8 = Math_fround(Math_abs(Math_fround(f10)));
    if (!(f9 > f8)) if (f10 != f10 | Math_fround(0.0) != Math_fround(0.0) | f10 == Math_fround(0.0)) f8 = Math_fround(0.0); else {
     f7 = Math_fround(f9 / f8);
     f8 = Math_fround(f8 * Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(1.0)))));
    } else {
     f8 = Math_fround(f8 / f9);
     f8 = Math_fround(f9 * Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(1.0)))));
    }
    f9 = Math_fround(f10 / f8);
    f7 = Math_fround(f11 / f8);
    f8 = Math_fround(f11 * Math_fround(f11 / f10));
    if (f13 < Math_fround(0.0)) {
     f7 = Math_fround(-f7);
     f8 = Math_fround(-f8);
    }
    HEAPF32[i6 >> 2] = Math_fround(0.0);
    HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
    HEAPF32[i5 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i5 >> 2]));
    i14 = (i15 | 0) > 0;
    if (i14) {
     i6 = 0;
     do {
      i12 = Math_imul(i6, i22) | 0;
      i3 = i23 + (i12 + i15 << 2) | 0;
      f10 = Math_fround(HEAPF32[i3 >> 2]);
      i12 = i23 + (i12 + i16 << 2) | 0;
      f8 = Math_fround(HEAPF32[i12 >> 2]);
      HEAPF32[i3 >> 2] = Math_fround(Math_fround(f9 * f10) - Math_fround(f7 * f8));
      HEAPF32[i12 >> 2] = Math_fround(Math_fround(f7 * f10) + Math_fround(f9 * f8));
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i15 | 0));
    }
    i3 = i15 + 1 | 0;
    if ((i3 | 0) < (i16 | 0)) {
     i6 = i3;
     do {
      i4 = i23 + (i6 + i1 << 2) | 0;
      f10 = Math_fround(HEAPF32[i4 >> 2]);
      i12 = i23 + ((Math_imul(i6, i22) | 0) + i16 << 2) | 0;
      f8 = Math_fround(HEAPF32[i12 >> 2]);
      HEAPF32[i4 >> 2] = Math_fround(Math_fround(f9 * f10) - Math_fround(f7 * f8));
      HEAPF32[i12 >> 2] = Math_fround(Math_fround(f7 * f10) + Math_fround(f9 * f8));
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i16 | 0));
    }
    i12 = i16 + 1 | 0;
    if ((i12 | 0) < (i28 | 0)) {
     i6 = Math_imul(i16, i22) | 0;
     i5 = i12;
     do {
      i30 = i23 + (i5 + i1 << 2) | 0;
      f10 = Math_fround(HEAPF32[i30 >> 2]);
      i4 = i23 + (i5 + i6 << 2) | 0;
      f8 = Math_fround(HEAPF32[i4 >> 2]);
      HEAPF32[i30 >> 2] = Math_fround(Math_fround(f9 * f10) - Math_fround(f7 * f8));
      HEAPF32[i4 >> 2] = Math_fround(Math_fround(f7 * f10) + Math_fround(f9 * f8));
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i28 | 0));
    }
    if (i25 & i24) {
     i6 = Math_imul(i15, i2) | 0;
     i5 = Math_imul(i16, i2) | 0;
     i4 = 0;
     do {
      i31 = i26 + (i4 + i6 << 2) | 0;
      f10 = Math_fround(HEAPF32[i31 >> 2]);
      i30 = i26 + (i4 + i5 << 2) | 0;
      f8 = Math_fround(HEAPF32[i30 >> 2]);
      HEAPF32[i31 >> 2] = Math_fround(Math_fround(f9 * f10) - Math_fround(f7 * f8));
      HEAPF32[i30 >> 2] = Math_fround(Math_fround(f7 * f10) + Math_fround(f9 * f8));
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i28 | 0));
    }
    if ((i15 | 0) < (i17 | 0)) {
     i6 = i15 + 2 | 0;
     if ((i6 | 0) < (i28 | 0)) {
      i4 = i6;
      i6 = i3;
      f7 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + (i1 + i3 << 2) >> 2])));
      while (1) {
       f8 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + (i4 + i1 << 2) >> 2])));
       i5 = f7 < f8;
       i6 = i5 ? i4 : i6;
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i28 | 0)) break; else f7 = i5 ? f8 : f7;
      }
     } else i6 = i3;
     HEAP32[i20 + (i15 << 2) >> 2] = i6;
    }
    if (i14) {
     if ((i15 | 0) > 1) {
      i4 = 1;
      i6 = 0;
      f7 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + (i15 << 2) >> 2])));
      while (1) {
       f8 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + ((Math_imul(i4, i22) | 0) + i15 << 2) >> 2])));
       i5 = f7 < f8;
       i6 = i5 ? i4 : i6;
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i15 | 0)) break; else f7 = i5 ? f8 : f7;
      }
     } else i6 = 0;
     HEAP32[i20 + (i15 + i28 << 2) >> 2] = i6;
    }
    if ((i16 | 0) < (i17 | 0)) {
     i3 = Math_imul(i16, i22) | 0;
     i6 = i16 + 2 | 0;
     if ((i6 | 0) < (i28 | 0)) {
      i4 = i12;
      f7 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + (i3 + i12 << 2) >> 2])));
      while (1) {
       f8 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + (i6 + i3 << 2) >> 2])));
       i5 = f7 < f8;
       i4 = i5 ? i6 : i4;
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i28 | 0)) break; else f7 = i5 ? f8 : f7;
      }
     } else i4 = i12;
     HEAP32[i20 + (i16 << 2) >> 2] = i4;
    }
    if ((i16 | 0) > 0) {
     if ((i16 | 0) > 1) {
      i5 = 1;
      i4 = 0;
      f7 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + (i16 << 2) >> 2])));
      while (1) {
       f8 = Math_fround(Math_abs(Math_fround(HEAPF32[i23 + ((Math_imul(i5, i22) | 0) + i16 << 2) >> 2])));
       i6 = f7 < f8;
       i4 = i6 ? i5 : i4;
       i5 = i5 + 1 | 0;
       if ((i5 | 0) == (i16 | 0)) break; else f7 = i6 ? f8 : f7;
      }
     } else i4 = 0;
     HEAP32[i20 + (i16 + i28 << 2) >> 2] = i4;
    }
    i19 = i19 + 1 | 0;
   } while ((i19 | 0) < (i21 | 0));
  }
 } while (0);
 i5 = i28 + -1 | 0;
 if ((i5 | 0) > 0) i6 = 0; else {
  STACKTOP = i29;
  return 1;
 }
 do {
  i1 = i6;
  i6 = i6 + 1 | 0;
  if ((i6 | 0) < (i28 | 0)) {
   i4 = i6;
   i3 = i1;
   do {
    f7 = Math_fround(HEAPF32[i27 + (i3 << 2) >> 2]);
    i23 = f7 < Math_fround(HEAPF32[i27 + (i4 << 2) >> 2]);
    i3 = i23 ? i4 : i3;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i28 | 0));
  } else i3 = i1;
  if ((i1 | 0) != (i3 | 0) ? (i22 = i27 + (i3 << 2) | 0, i23 = i27 + (i1 << 2) | 0, f7 = Math_fround(HEAPF32[i22 >> 2]), HEAPF32[i22 >> 2] = Math_fround(HEAPF32[i23 >> 2]), HEAPF32[i23 >> 2] = f7, i25 & i24) : 0) {
   i4 = Math_imul(i3, i2) | 0;
   i3 = Math_imul(i1, i2) | 0;
   i1 = 0;
   do {
    i22 = i26 + (i1 + i4 << 2) | 0;
    i23 = i26 + (i1 + i3 << 2) | 0;
    f7 = Math_fround(HEAPF32[i22 >> 2]);
    HEAPF32[i22 >> 2] = Math_fround(HEAPF32[i23 >> 2]);
    HEAPF32[i23 >> 2] = f7;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i28 | 0));
  }
 } while ((i6 | 0) != (i5 | 0));
 STACKTOP = i29;
 return 1;
}

function _free(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 if (!i15) {
  STACKTOP = i21;
  return;
 }
 i5 = i15 + -8 | 0;
 i6 = HEAP32[242538] | 0;
 if (i5 >>> 0 < i6 >>> 0) _abort();
 i4 = HEAP32[i15 + -4 >> 2] | 0;
 i3 = i4 & 3;
 if ((i3 | 0) == 1) _abort();
 i13 = i4 & -8;
 i16 = i15 + (i13 + -8) | 0;
 do if (!(i4 & 1)) {
  i5 = HEAP32[i5 >> 2] | 0;
  if (!i3) {
   STACKTOP = i21;
   return;
  }
  i7 = -8 - i5 | 0;
  i10 = i15 + i7 | 0;
  i11 = i5 + i13 | 0;
  if (i10 >>> 0 < i6 >>> 0) _abort();
  if ((i10 | 0) == (HEAP32[242539] | 0)) {
   i5 = i15 + (i13 + -4) | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   if ((i4 & 3 | 0) != 3) {
    i20 = i10;
    i9 = i11;
    break;
   }
   HEAP32[242536] = i11;
   HEAP32[i5 >> 2] = i4 & -2;
   HEAP32[i15 + (i7 + 4) >> 2] = i11 | 1;
   HEAP32[i16 >> 2] = i11;
   STACKTOP = i21;
   return;
  }
  i2 = i5 >>> 3;
  if (i5 >>> 0 < 256) {
   i3 = HEAP32[i15 + (i7 + 8) >> 2] | 0;
   i4 = HEAP32[i15 + (i7 + 12) >> 2] | 0;
   i5 = 970176 + (i2 << 1 << 2) | 0;
   if ((i3 | 0) != (i5 | 0)) {
    if (i3 >>> 0 < i6 >>> 0) _abort();
    if ((HEAP32[i3 + 12 >> 2] | 0) != (i10 | 0)) _abort();
   }
   if ((i4 | 0) == (i3 | 0)) {
    HEAP32[242534] = HEAP32[242534] & ~(1 << i2);
    i20 = i10;
    i9 = i11;
    break;
   }
   if ((i4 | 0) != (i5 | 0)) {
    if (i4 >>> 0 < i6 >>> 0) _abort();
    i5 = i4 + 8 | 0;
    if ((HEAP32[i5 >> 2] | 0) == (i10 | 0)) i1 = i5; else _abort();
   } else i1 = i4 + 8 | 0;
   HEAP32[i3 + 12 >> 2] = i4;
   HEAP32[i1 >> 2] = i3;
   i20 = i10;
   i9 = i11;
   break;
  }
  i1 = HEAP32[i15 + (i7 + 24) >> 2] | 0;
  i3 = HEAP32[i15 + (i7 + 12) >> 2] | 0;
  do if ((i3 | 0) == (i10 | 0)) {
   i4 = i15 + (i7 + 20) | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (!i5) {
    i4 = i15 + (i7 + 16) | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if (!i5) {
     i8 = 0;
     break;
    }
   }
   while (1) {
    i3 = i5 + 20 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2) {
     i5 = i2;
     i4 = i3;
     continue;
    }
    i3 = i5 + 16 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) break; else {
     i5 = i2;
     i4 = i3;
    }
   }
   if (i4 >>> 0 < i6 >>> 0) _abort(); else {
    HEAP32[i4 >> 2] = 0;
    i8 = i5;
    break;
   }
  } else {
   i2 = HEAP32[i15 + (i7 + 8) >> 2] | 0;
   if (i2 >>> 0 < i6 >>> 0) _abort();
   i5 = i2 + 12 | 0;
   if ((HEAP32[i5 >> 2] | 0) != (i10 | 0)) _abort();
   i4 = i3 + 8 | 0;
   if ((HEAP32[i4 >> 2] | 0) == (i10 | 0)) {
    HEAP32[i5 >> 2] = i3;
    HEAP32[i4 >> 2] = i2;
    i8 = i3;
    break;
   } else _abort();
  } while (0);
  if (i1) {
   i5 = HEAP32[i15 + (i7 + 28) >> 2] | 0;
   i4 = 970440 + (i5 << 2) | 0;
   if ((i10 | 0) == (HEAP32[i4 >> 2] | 0)) {
    HEAP32[i4 >> 2] = i8;
    if (!i8) {
     HEAP32[242535] = HEAP32[242535] & ~(1 << i5);
     i20 = i10;
     i9 = i11;
     break;
    }
   } else {
    if (i1 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
    i5 = i1 + 16 | 0;
    if ((HEAP32[i5 >> 2] | 0) == (i10 | 0)) HEAP32[i5 >> 2] = i8; else HEAP32[i1 + 20 >> 2] = i8;
    if (!i8) {
     i20 = i10;
     i9 = i11;
     break;
    }
   }
   i4 = HEAP32[242538] | 0;
   if (i8 >>> 0 < i4 >>> 0) _abort();
   HEAP32[i8 + 24 >> 2] = i1;
   i5 = HEAP32[i15 + (i7 + 16) >> 2] | 0;
   do if (i5) if (i5 >>> 0 < i4 >>> 0) _abort(); else {
    HEAP32[i8 + 16 >> 2] = i5;
    HEAP32[i5 + 24 >> 2] = i8;
    break;
   } while (0);
   i5 = HEAP32[i15 + (i7 + 20) >> 2] | 0;
   if (i5) if (i5 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
    HEAP32[i8 + 20 >> 2] = i5;
    HEAP32[i5 + 24 >> 2] = i8;
    i20 = i10;
    i9 = i11;
    break;
   } else {
    i20 = i10;
    i9 = i11;
   }
  } else {
   i20 = i10;
   i9 = i11;
  }
 } else {
  i20 = i5;
  i9 = i13;
 } while (0);
 if (i20 >>> 0 >= i16 >>> 0) _abort();
 i5 = i15 + (i13 + -4) | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (!(i4 & 1)) _abort();
 if (!(i4 & 2)) {
  if ((i16 | 0) == (HEAP32[242540] | 0)) {
   i10 = (HEAP32[242537] | 0) + i9 | 0;
   HEAP32[242537] = i10;
   HEAP32[242540] = i20;
   HEAP32[i20 + 4 >> 2] = i10 | 1;
   if ((i20 | 0) != (HEAP32[242539] | 0)) {
    STACKTOP = i21;
    return;
   }
   HEAP32[242539] = 0;
   HEAP32[242536] = 0;
   STACKTOP = i21;
   return;
  }
  if ((i16 | 0) == (HEAP32[242539] | 0)) {
   i10 = (HEAP32[242536] | 0) + i9 | 0;
   HEAP32[242536] = i10;
   HEAP32[242539] = i20;
   HEAP32[i20 + 4 >> 2] = i10 | 1;
   HEAP32[i20 + i10 >> 2] = i10;
   STACKTOP = i21;
   return;
  }
  i6 = (i4 & -8) + i9 | 0;
  i1 = i4 >>> 3;
  do if (i4 >>> 0 >= 256) {
   i1 = HEAP32[i15 + (i13 + 16) >> 2] | 0;
   i5 = HEAP32[i15 + (i13 | 4) >> 2] | 0;
   do if ((i5 | 0) == (i16 | 0)) {
    i4 = i15 + (i13 + 12) | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if (!i5) {
     i4 = i15 + (i13 + 8) | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     if (!i5) {
      i14 = 0;
      break;
     }
    }
    while (1) {
     i3 = i5 + 20 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (i2) {
      i5 = i2;
      i4 = i3;
      continue;
     }
     i3 = i5 + 16 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) break; else {
      i5 = i2;
      i4 = i3;
     }
    }
    if (i4 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
     HEAP32[i4 >> 2] = 0;
     i14 = i5;
     break;
    }
   } else {
    i4 = HEAP32[i15 + i13 >> 2] | 0;
    if (i4 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
    i3 = i4 + 12 | 0;
    if ((HEAP32[i3 >> 2] | 0) != (i16 | 0)) _abort();
    i2 = i5 + 8 | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i16 | 0)) {
     HEAP32[i3 >> 2] = i5;
     HEAP32[i2 >> 2] = i4;
     i14 = i5;
     break;
    } else _abort();
   } while (0);
   if (i1) {
    i5 = HEAP32[i15 + (i13 + 20) >> 2] | 0;
    i4 = 970440 + (i5 << 2) | 0;
    if ((i16 | 0) == (HEAP32[i4 >> 2] | 0)) {
     HEAP32[i4 >> 2] = i14;
     if (!i14) {
      HEAP32[242535] = HEAP32[242535] & ~(1 << i5);
      break;
     }
    } else {
     if (i1 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
     i5 = i1 + 16 | 0;
     if ((HEAP32[i5 >> 2] | 0) == (i16 | 0)) HEAP32[i5 >> 2] = i14; else HEAP32[i1 + 20 >> 2] = i14;
     if (!i14) break;
    }
    i5 = HEAP32[242538] | 0;
    if (i14 >>> 0 < i5 >>> 0) _abort();
    HEAP32[i14 + 24 >> 2] = i1;
    i4 = HEAP32[i15 + (i13 + 8) >> 2] | 0;
    do if (i4) if (i4 >>> 0 < i5 >>> 0) _abort(); else {
     HEAP32[i14 + 16 >> 2] = i4;
     HEAP32[i4 + 24 >> 2] = i14;
     break;
    } while (0);
    i2 = HEAP32[i15 + (i13 + 12) >> 2] | 0;
    if (i2) if (i2 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
     HEAP32[i14 + 20 >> 2] = i2;
     HEAP32[i2 + 24 >> 2] = i14;
     break;
    }
   }
  } else {
   i2 = HEAP32[i15 + i13 >> 2] | 0;
   i3 = HEAP32[i15 + (i13 | 4) >> 2] | 0;
   i5 = 970176 + (i1 << 1 << 2) | 0;
   if ((i2 | 0) != (i5 | 0)) {
    if (i2 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
    if ((HEAP32[i2 + 12 >> 2] | 0) != (i16 | 0)) _abort();
   }
   if ((i3 | 0) == (i2 | 0)) {
    HEAP32[242534] = HEAP32[242534] & ~(1 << i1);
    break;
   }
   if ((i3 | 0) != (i5 | 0)) {
    if (i3 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
    i4 = i3 + 8 | 0;
    if ((HEAP32[i4 >> 2] | 0) == (i16 | 0)) i12 = i4; else _abort();
   } else i12 = i3 + 8 | 0;
   HEAP32[i2 + 12 >> 2] = i3;
   HEAP32[i12 >> 2] = i2;
  } while (0);
  HEAP32[i20 + 4 >> 2] = i6 | 1;
  HEAP32[i20 + i6 >> 2] = i6;
  if ((i20 | 0) == (HEAP32[242539] | 0)) {
   HEAP32[242536] = i6;
   STACKTOP = i21;
   return;
  } else i5 = i6;
 } else {
  HEAP32[i5 >> 2] = i4 & -2;
  HEAP32[i20 + 4 >> 2] = i9 | 1;
  HEAP32[i20 + i9 >> 2] = i9;
  i5 = i9;
 }
 i4 = i5 >>> 3;
 if (i5 >>> 0 < 256) {
  i3 = i4 << 1;
  i5 = 970176 + (i3 << 2) | 0;
  i1 = HEAP32[242534] | 0;
  i2 = 1 << i4;
  if (i1 & i2) {
   i2 = 970176 + (i3 + 2 << 2) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
    i17 = i2;
    i18 = i1;
   }
  } else {
   HEAP32[242534] = i1 | i2;
   i17 = 970176 + (i3 + 2 << 2) | 0;
   i18 = i5;
  }
  HEAP32[i17 >> 2] = i20;
  HEAP32[i18 + 12 >> 2] = i20;
  HEAP32[i20 + 8 >> 2] = i18;
  HEAP32[i20 + 12 >> 2] = i5;
  STACKTOP = i21;
  return;
 }
 i1 = i5 >>> 8;
 if (i1) if (i5 >>> 0 > 16777215) i4 = 31; else {
  i9 = (i1 + 1048320 | 0) >>> 16 & 8;
  i10 = i1 << i9;
  i8 = (i10 + 520192 | 0) >>> 16 & 4;
  i10 = i10 << i8;
  i4 = (i10 + 245760 | 0) >>> 16 & 2;
  i4 = 14 - (i8 | i9 | i4) + (i10 << i4 >>> 15) | 0;
  i4 = i5 >>> (i4 + 7 | 0) & 1 | i4 << 1;
 } else i4 = 0;
 i2 = 970440 + (i4 << 2) | 0;
 HEAP32[i20 + 28 >> 2] = i4;
 HEAP32[i20 + 20 >> 2] = 0;
 HEAP32[i20 + 16 >> 2] = 0;
 i1 = HEAP32[242535] | 0;
 i3 = 1 << i4;
 L199 : do if (i1 & i3) {
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i4 | 0) == 31) i2 = 0; else i2 = 25 - (i4 >>> 1) | 0;
  L205 : do if ((HEAP32[i3 + 4 >> 2] & -8 | 0) != (i5 | 0)) {
   i4 = i5 << i2;
   while (1) {
    i1 = i3 + (i4 >>> 31 << 2) + 16 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break;
    if ((HEAP32[i2 + 4 >> 2] & -8 | 0) == (i5 | 0)) {
     i19 = i2;
     break L205;
    } else {
     i4 = i4 << 1;
     i3 = i2;
    }
   }
   if (i1 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
    HEAP32[i1 >> 2] = i20;
    HEAP32[i20 + 24 >> 2] = i3;
    HEAP32[i20 + 12 >> 2] = i20;
    HEAP32[i20 + 8 >> 2] = i20;
    break L199;
   }
  } else i19 = i3; while (0);
  i1 = i19 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[242538] | 0;
  if (i19 >>> 0 >= i10 >>> 0 & i2 >>> 0 >= i10 >>> 0) {
   HEAP32[i2 + 12 >> 2] = i20;
   HEAP32[i1 >> 2] = i20;
   HEAP32[i20 + 8 >> 2] = i2;
   HEAP32[i20 + 12 >> 2] = i19;
   HEAP32[i20 + 24 >> 2] = 0;
   break;
  } else _abort();
 } else {
  HEAP32[242535] = i1 | i3;
  HEAP32[i2 >> 2] = i20;
  HEAP32[i20 + 24 >> 2] = i2;
  HEAP32[i20 + 12 >> 2] = i20;
  HEAP32[i20 + 8 >> 2] = i20;
 } while (0);
 i10 = (HEAP32[242542] | 0) + -1 | 0;
 HEAP32[242542] = i10;
 if (!i10) i1 = 970592 | 0; else {
  STACKTOP = i21;
  return;
 }
 while (1) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) break; else i1 = i1 + 8 | 0;
 }
 HEAP32[242542] = -1;
 STACKTOP = i21;
 return;
}

function __ZL10icvReadSeqP13CvFileStorageP10CvFileNode(i24, i21) {
 i24 = i24 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 1120 | 0;
 i17 = i26 + 608 | 0;
 i8 = i26 + 600 | 0;
 i25 = i26 + 568 | 0;
 i19 = i26 + 56 | 0;
 i7 = i26 + 48 | 0;
 i1 = i26 + 40 | 0;
 i5 = i26 + 32 | 0;
 i11 = i26 + 24 | 0;
 i15 = i26 + 16 | 0;
 i22 = i26 + 8 | 0;
 i23 = i26;
 HEAP32[i7 >> 2] = 0;
 i3 = _cvGetFileNodeByName(i24, i21, 12488) | 0;
 if ((i3 | 0) != 0 ? (HEAP32[i3 >> 2] & 7 | 0) == 3 : 0) i6 = HEAP32[i3 + 12 >> 2] | 0; else i6 = 0;
 i3 = _cvGetFileNodeByName(i24, i21, 13600) | 0;
 do if (i3) {
  i2 = HEAP32[i3 >> 2] & 7;
  if ((i2 | 0) == 1) {
   i20 = HEAP32[i3 + 8 >> 2] | 0;
   break;
  } else if ((i2 | 0) == 2) {
   i20 = _lrint(+HEAPF64[i3 + 8 >> 3]) | 0;
   break;
  } else {
   i20 = 2147483647;
   break;
  }
 } else i20 = -1; while (0);
 i3 = _cvGetFileNodeByName(i24, i21, 11672) | 0;
 if ((i3 | 0) != 0 ? (HEAP32[i3 >> 2] & 7 | 0) == 3 : 0) {
  i3 = HEAP32[i3 + 12 >> 2] | 0;
  if ((i20 | 0) != -1 & (i6 | 0) != 0 & (i3 | 0) != 0) i18 = i3; else i4 = 11;
 } else {
  i3 = 0;
  i4 = 11;
 }
 if ((i4 | 0) == 11) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i12 = (__ZN2cv6String8allocateEj(i1, 48) | 0) + 0 | 0;
  i13 = 13608 | 0;
  i14 = i12 + 48 | 0;
  do {
   HEAP8[i12 >> 0] = HEAP8[i13 >> 0] | 0;
   i12 = i12 + 1 | 0;
   i13 = i13 + 1 | 0;
  } while ((i12 | 0) < (i14 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i1, 13664, 8960, 4203);
  __ZN2cv6String10deallocateEv(i1);
  i18 = i3;
 }
 if (((HEAP8[i6 >> 0] | 0) + -48 << 24 >> 24 & 255) >= 10) {
  i2 = (_strstr(i6, 13680) | 0) == 0;
  i2 = i2 ? 1117323264 : 1117327360;
  i16 = (_strstr(i6, 13688) | 0) == 0;
  i2 = i16 ? i2 : i2 | 16384;
  i16 = (_strstr(i6, 13696) | 0) == 0;
  i2 = i16 ? i2 : i2 | 32768;
  if (!(_strstr(i6, 13704) | 0)) {
   i16 = (__ZL15icvDecodeFormatPKcPii(i18, i17) | 0) != 1;
   i3 = HEAP32[i17 >> 2] | 0;
   if (i16 | (i3 | 0) > 4) {
    HEAP32[i8 >> 2] = 0;
    HEAP32[i8 + 4 >> 2] = 0;
    i12 = (__ZN2cv6String8allocateEj(i8, 33) | 0) + 0 | 0;
    i13 = 11936 | 0;
    i14 = i12 + 33 | 0;
    do {
     HEAP8[i12 >> 0] = HEAP8[i13 >> 0] | 0;
     i12 = i12 + 1 | 0;
     i13 = i13 + 1 | 0;
    } while ((i12 | 0) < (i14 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i8, 11976, 8960, 3068);
    __ZN2cv6String10deallocateEv(i8);
   }
   i10 = (i3 << 3) + -8 | i2 | HEAP32[i17 + 4 >> 2] & 7;
  } else i10 = i2;
 } else {
  i3 = _strtol(i6, i7, 16) | 0;
  if (!((i3 & -65536 | 0) == 1117323264 ? (HEAP32[i7 >> 2] | 0) != (i6 | 0) : 0)) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i12 = (__ZN2cv6String8allocateEj(i5, 30) | 0) + 0 | 0;
   i13 = 13008 | 0;
   i14 = i12 + 30 | 0;
   do {
    HEAP8[i12 >> 0] = HEAP8[i13 >> 0] | 0;
    i12 = i12 + 1 | 0;
    i13 = i13 + 1 | 0;
   } while ((i12 | 0) < (i14 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i5, 13664, 8960, 4220);
   __ZN2cv6String10deallocateEv(i5);
  }
  i10 = i3 & 33279 | i3 << 2 & 16384 | ((i3 & 3584 | 0) == 512 ? 1117327360 : 1117323264);
 }
 i2 = _cvGetFileNodeByName(i24, i21, 12608) | 0;
 if ((i2 | 0) != 0 ? (HEAP32[i2 >> 2] & 7 | 0) == 3 : 0) i5 = HEAP32[i2 + 12 >> 2] | 0; else i5 = 0;
 i6 = _cvGetFileNodeByName(i24, i21, 12760) | 0;
 i4 = (i5 | 0) != 0;
 i9 = (i6 | 0) != 0;
 i3 = i9 & 1;
 if (i4 ^ i9) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  i12 = (__ZN2cv6String8allocateEj(i11, 74) | 0) + 0 | 0;
  i13 = 13040 | 0;
  i14 = i12 + 74 | 0;
  do {
   HEAP8[i12 >> 0] = HEAP8[i13 >> 0] | 0;
   i12 = i12 + 1 | 0;
   i13 = i13 + 1 | 0;
  } while ((i12 | 0) < (i14 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i11, 13664, 8960, 4254);
  __ZN2cv6String10deallocateEv(i11);
 }
 i16 = _cvGetFileNodeByName(i24, i21, 12728) | 0;
 i11 = _cvGetFileNodeByName(i24, i21, 12120) | 0;
 i8 = (i16 | 0) != 0;
 i7 = (i11 | 0) != 0;
 if (((i8 & 1) + i3 + (i7 & 1) | 0) > 1) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  i12 = (__ZN2cv6String8allocateEj(i15, 66) | 0) + 0 | 0;
  i13 = 13712 | 0;
  i14 = i12 + 66 | 0;
  do {
   HEAP8[i12 >> 0] = HEAP8[i13 >> 0] | 0;
   i12 = i12 + 1 | 0;
   i13 = i13 + 1 | 0;
  } while ((i12 | 0) < (i14 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i15, 13664, 8960, 4260);
  __ZN2cv6String10deallocateEv(i15);
 }
 if (i4) {
  i15 = __ZL15icvDecodeFormatPKcPii(i5, i17) | 0;
  i3 = i15 << 1;
  if ((i15 | 0) > 0) {
   i2 = 0;
   i4 = 56;
   do {
    i15 = HEAP32[i17 + ((i2 | 1) << 2) >> 2] | 0;
    i15 = (i15 >>> 3 & 511) + 1 << (47696 >>> (i15 << 1 & 14) & 3);
    i4 = (i4 + -1 + i15 & 0 - i15) + (Math_imul(i15, HEAP32[i17 + (i2 << 2) >> 2] | 0) | 0) | 0;
    i2 = i2 + 2 | 0;
   } while ((i2 | 0) < (i3 | 0));
   i1 = i4;
  } else i1 = 56;
 } else if (i8) i1 = 88; else i1 = i7 ? 64 : 56;
 i15 = __ZL15icvDecodeFormatPKcPii(i18, i17) | 0;
 i4 = i15 << 1;
 if ((i15 | 0) > 0) {
  i3 = 0;
  i2 = 0;
  do {
   i15 = HEAP32[i17 + ((i3 | 1) << 2) >> 2] | 0;
   i15 = (i15 >>> 3 & 511) + 1 << (47696 >>> (i15 << 1 & 14) & 3);
   i2 = (i2 + -1 + i15 & 0 - i15) + (Math_imul(i15, HEAP32[i17 + (i3 << 2) >> 2] | 0) | 0) | 0;
   i3 = i3 + 2 | 0;
  } while ((i3 | 0) < (i4 | 0));
  i4 = i2 + -1 | 0;
 } else i4 = -1;
 i17 = HEAP32[i17 + 4 >> 2] | 0;
 i17 = (i17 >>> 3 & 511) + 1 << (47696 >>> (i17 << 1 & 14) & 3);
 i17 = _cvCreateSeq(i10, i1, i4 + i17 & 0 - i17, HEAP32[i24 + 20 >> 2] | 0) | 0;
 do if (i9) _cvReadRawData(i24, i6, i17 + 56 | 0, i5); else {
  if (!i8) {
   if (!i7) break;
   i2 = _cvGetFileNodeByName(i24, i11, 12200) | 0;
   do if (i2) {
    i1 = HEAP32[i2 >> 2] & 7;
    if ((i1 | 0) == 2) {
     i2 = _lrint(+HEAPF64[i2 + 8 >> 3]) | 0;
     break;
    } else if ((i1 | 0) == 1) {
     i2 = HEAP32[i2 + 8 >> 2] | 0;
     break;
    } else {
     i2 = 2147483647;
     break;
    }
   } else i2 = 0; while (0);
   HEAP32[i17 + 56 >> 2] = i2;
   i2 = _cvGetFileNodeByName(i24, i11, 12208) | 0;
   do if (i2) {
    i1 = HEAP32[i2 >> 2] & 7;
    if ((i1 | 0) == 1) {
     i2 = HEAP32[i2 + 8 >> 2] | 0;
     break;
    } else if ((i1 | 0) == 2) {
     i2 = _lrint(+HEAPF64[i2 + 8 >> 3]) | 0;
     break;
    } else {
     i2 = 2147483647;
     break;
    }
   } else i2 = 0; while (0);
   HEAP32[i17 + 60 >> 2] = i2;
   break;
  }
  i2 = _cvGetFileNodeByName(i24, i16, 12200) | 0;
  do if (i2) {
   i1 = HEAP32[i2 >> 2] & 7;
   if ((i1 | 0) == 2) {
    i2 = _lrint(+HEAPF64[i2 + 8 >> 3]) | 0;
    break;
   } else if ((i1 | 0) == 1) {
    i2 = HEAP32[i2 + 8 >> 2] | 0;
    break;
   } else {
    i2 = 2147483647;
    break;
   }
  } else i2 = 0; while (0);
  HEAP32[i17 + 56 >> 2] = i2;
  i2 = _cvGetFileNodeByName(i24, i16, 12208) | 0;
  do if (i2) {
   i1 = HEAP32[i2 >> 2] & 7;
   if ((i1 | 0) == 2) {
    i2 = _lrint(+HEAPF64[i2 + 8 >> 3]) | 0;
    break;
   } else if ((i1 | 0) == 1) {
    i2 = HEAP32[i2 + 8 >> 2] | 0;
    break;
   } else {
    i2 = 2147483647;
    break;
   }
  } else i2 = 0; while (0);
  HEAP32[i17 + 60 >> 2] = i2;
  i2 = _cvGetFileNodeByName(i24, i16, 12104) | 0;
  do if (i2) {
   i1 = HEAP32[i2 >> 2] & 7;
   if ((i1 | 0) == 2) {
    i2 = _lrint(+HEAPF64[i2 + 8 >> 3]) | 0;
    break;
   } else if ((i1 | 0) == 1) {
    i2 = HEAP32[i2 + 8 >> 2] | 0;
    break;
   } else {
    i2 = 2147483647;
    break;
   }
  } else i2 = 0; while (0);
  HEAP32[i17 + 64 >> 2] = i2;
  i2 = _cvGetFileNodeByName(i24, i16, 12112) | 0;
  do if (i2) {
   i1 = HEAP32[i2 >> 2] & 7;
   if ((i1 | 0) == 1) {
    i2 = HEAP32[i2 + 8 >> 2] | 0;
    break;
   } else if ((i1 | 0) == 2) {
    i2 = _lrint(+HEAPF64[i2 + 8 >> 3]) | 0;
    break;
   } else {
    i2 = 2147483647;
    break;
   }
  } else i2 = 0; while (0);
  HEAP32[i17 + 68 >> 2] = i2;
  i2 = _cvGetFileNodeByName(i24, i21, 12736) | 0;
  do if (i2) {
   i1 = HEAP32[i2 >> 2] & 7;
   if ((i1 | 0) == 1) {
    i2 = HEAP32[i2 + 8 >> 2] | 0;
    break;
   } else if ((i1 | 0) == 2) {
    i2 = _lrint(+HEAPF64[i2 + 8 >> 3]) | 0;
    break;
   } else {
    i2 = 2147483647;
    break;
   }
  } else i2 = 0; while (0);
  HEAP32[i17 + 72 >> 2] = i2;
 } while (0);
 _cvSeqPushMulti(i17, 0, i20, 0);
 i16 = __ZL15icvDecodeFormatPKcPii(i18, i19) | 0;
 i1 = i16 << 1;
 if ((i16 | 0) > 0) {
  i3 = 0;
  i2 = 0;
  do {
   i2 = (HEAP32[i19 + (i3 << 2) >> 2] | 0) + i2 | 0;
   i3 = i3 + 2 | 0;
  } while ((i3 | 0) < (i1 | 0));
  i4 = i2;
 } else i4 = 0;
 i3 = _cvGetFileNodeByName(i24, i21, 11680) | 0;
 if (!i3) {
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  i12 = (__ZN2cv6String8allocateEj(i22, 43) | 0) + 0 | 0;
  i13 = 12328 | 0;
  i14 = i12 + 43 | 0;
  do {
   HEAP8[i12 >> 0] = HEAP8[i13 >> 0] | 0;
   i12 = i12 + 1 | 0;
   i13 = i13 + 1 | 0;
  } while ((i12 | 0) < (i14 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i22, 13664, 8960, 4302);
  __ZN2cv6String10deallocateEv(i22);
 }
 i2 = HEAP32[i3 >> 2] & 7;
 if (i2 >>> 0 > 4) i2 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 24 >> 2] | 0; else i2 = (i2 | 0) != 0 & 1;
 if ((i2 | 0) != (Math_imul(i4, i20) | 0)) {
  HEAP32[i23 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = 0;
  i12 = (__ZN2cv6String8allocateEj(i23, 55) | 0) + 0 | 0;
  i13 = 13784 | 0;
  i14 = i12 + 55 | 0;
  do {
   HEAP8[i12 >> 0] = HEAP8[i13 >> 0] | 0;
   i12 = i12 + 1 | 0;
   i13 = i13 + 1 | 0;
  } while ((i12 | 0) < (i14 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i23, 13664, 8960, 4305);
  __ZN2cv6String10deallocateEv(i23);
 }
 _cvStartReadRawData(i24, i3, i25);
 i2 = i17 + 52 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i26;
  return i17 | 0;
 }
 while (1) {
  i22 = Math_imul(HEAP32[i1 + 12 >> 2] | 0, i4) | 0;
  _cvReadRawDataSlice(i24, i25, i22, HEAP32[i1 + 16 >> 2] | 0, i18);
  if ((i1 | 0) == (HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) {
   i4 = 81;
   break;
  }
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i1) {
   i4 = 81;
   break;
  }
 }
 if ((i4 | 0) == 81) {
  STACKTOP = i26;
  return i17 | 0;
 }
 return 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc(i49, i50, i45, i35, i47, i46, i48, i34, i1) {
 i49 = i49 | 0;
 i50 = i50 | 0;
 i45 = i45 | 0;
 i35 = i35 | 0;
 i47 = i47 | 0;
 i46 = i46 | 0;
 i48 = i48 | 0;
 i34 = i34 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i51 = 0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 i43 = i44 + 160 | 0;
 i42 = i44 + 156 | 0;
 i51 = i44 + 152 | 0;
 i11 = i44 + 148 | 0;
 i22 = i44 + 144 | 0;
 i39 = i44 + 140 | 0;
 i40 = i44 + 136 | 0;
 i41 = i44 + 132 | 0;
 i31 = i44 + 128 | 0;
 i32 = i44 + 124 | 0;
 i33 = i44 + 120 | 0;
 i4 = i44 + 116 | 0;
 i3 = i44 + 112 | 0;
 i2 = i44 + 108 | 0;
 i1 = i44 + 104 | 0;
 i5 = i44 + 100 | 0;
 i6 = i44 + 96 | 0;
 i7 = i44 + 92 | 0;
 i8 = i44 + 88 | 0;
 i9 = i44 + 84 | 0;
 i10 = i44 + 80 | 0;
 i12 = i44 + 76 | 0;
 i13 = i44 + 72 | 0;
 i14 = i44 + 68 | 0;
 i15 = i44 + 64 | 0;
 i16 = i44 + 60 | 0;
 i17 = i44 + 56 | 0;
 i18 = i44 + 52 | 0;
 i19 = i44 + 48 | 0;
 i20 = i44 + 44 | 0;
 i21 = i44 + 40 | 0;
 i23 = i44 + 36 | 0;
 i24 = i44 + 32 | 0;
 i25 = i44 + 28 | 0;
 i26 = i44 + 24 | 0;
 i36 = i44 + 20 | 0;
 i37 = i44 + 16 | 0;
 i38 = i44 + 12 | 0;
 i27 = i44 + 8 | 0;
 i28 = i44 + 4 | 0;
 i29 = i44;
 HEAP32[i46 >> 2] = 0;
 __ZNKSt3__18ios_base6getlocEv(i51, i47);
 i30 = __ZNKSt3__16locale9use_facetERNS0_2idE(i51, 960720) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i51 >> 2] | 0) | 0;
 do switch (i34 << 24 >> 24 | 0) {
 case 112:
  {
   HEAP32[i12 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48 + 8 | 0, i45, i43, i46, i30);
   break;
  }
 case 116:
 case 110:
  {
   HEAP32[i10 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE(i50, i45, i43, i46, i30);
   break;
  }
 case 104:
 case 66:
 case 98:
  {
   HEAP32[i22 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i22 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48 + 16 | 0, i45, i43, i46, i30);
   break;
  }
 case 72:
  {
   HEAP32[i5 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48 + 8 | 0, i45, i43, i46, i30);
   break;
  }
 case 121:
  {
   HEAP32[i27 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48 + 20 | 0, i45, i43, i46, i30);
   break;
  }
 case 114:
  {
   HEAP32[i14 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i42 + 0 >> 2] = HEAP32[i14 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i13, i50, i42, i43, i47, i46, i48, 959880, 959924 | 0);
   HEAP32[i45 >> 2] = HEAP32[i13 >> 2];
   break;
  }
 case 70:
  {
   HEAP32[i2 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i42 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i1 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i3, i50, i42, i43, i47, i46, i48, 959848, 959880 | 0);
   HEAP32[i45 >> 2] = HEAP32[i3 >> 2];
   break;
  }
 case 77:
  {
   HEAP32[i9 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48 + 4 | 0, i45, i43, i46, i30);
   break;
  }
 case 37:
  {
   HEAP32[i29 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i29 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE(i50, i45, i43, i46, i30);
   break;
  }
 case 83:
  {
   HEAP32[i19 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i19 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48, i45, i43, i46, i30);
   break;
  }
 case 106:
  {
   HEAP32[i7 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i7 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48 + 28 | 0, i45, i43, i46, i30);
   break;
  }
 case 65:
 case 97:
  {
   HEAP32[i11 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48 + 24 | 0, i45, i43, i46, i30);
   break;
  }
 case 119:
  {
   HEAP32[i24 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i24 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48 + 24 | 0, i45, i43, i46, i30);
   break;
  }
 case 89:
  {
   HEAP32[i28 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i28 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48 + 20 | 0, i45, i43, i46, i30);
   break;
  }
 case 82:
  {
   HEAP32[i17 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i42 + 0 >> 2] = HEAP32[i17 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i18 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i16, i50, i42, i43, i47, i46, i48, 959928, 959948 | 0);
   HEAP32[i45 >> 2] = HEAP32[i16 >> 2];
   break;
  }
 case 73:
  {
   HEAP32[i6 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48 + 8 | 0, i45, i43, i46, i30);
   break;
  }
 case 84:
  {
   HEAP32[i21 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i23 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i42 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i23 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i20, i50, i42, i43, i47, i46, i48, 959952, 959984 | 0);
   HEAP32[i45 >> 2] = HEAP32[i20 >> 2];
   break;
  }
 case 109:
  {
   HEAP32[i8 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48 + 16 | 0, i45, i43, i46, i30);
   break;
  }
 case 101:
 case 100:
  {
   HEAP32[i31 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i31 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIwEE(i50, i48 + 12 | 0, i45, i43, i46, i30);
   break;
  }
 case 68:
  {
   HEAP32[i33 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i42 + 0 >> 2] = HEAP32[i33 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i32, i50, i42, i43, i47, i46, i48, 959816, 959848 | 0);
   HEAP32[i45 >> 2] = HEAP32[i32 >> 2];
   break;
  }
 case 88:
  {
   i3 = i50 + 8 | 0;
   i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3) | 0;
   HEAP32[i37 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i38 >> 2] = HEAP32[i35 >> 2];
   i1 = HEAP8[i3 >> 0] | 0;
   if (!(i1 & 1)) {
    i4 = i3 + 4 | 0;
    i2 = (i1 & 255) >>> 1;
    i1 = i3 + 4 | 0;
   } else {
    i1 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i1;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
   }
   HEAP32[i42 + 0 >> 2] = HEAP32[i37 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i38 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i36, i50, i42, i43, i47, i46, i48, i1, i4 + (i2 << 2) | 0);
   HEAP32[i45 >> 2] = HEAP32[i36 >> 2];
   break;
  }
 case 99:
  {
   i4 = i50 + 8 | 0;
   i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4) | 0;
   HEAP32[i40 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i41 >> 2] = HEAP32[i35 >> 2];
   i1 = HEAP8[i4 >> 0] | 0;
   if (!(i1 & 1)) {
    i3 = i4 + 4 | 0;
    i2 = (i1 & 255) >>> 1;
    i1 = i4 + 4 | 0;
   } else {
    i1 = HEAP32[i4 + 8 >> 2] | 0;
    i3 = i1;
    i2 = HEAP32[i4 + 4 >> 2] | 0;
   }
   HEAP32[i42 + 0 >> 2] = HEAP32[i40 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i41 + 0 >> 2];
   __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i39, i50, i42, i43, i47, i46, i48, i1, i3 + (i2 << 2) | 0);
   HEAP32[i45 >> 2] = HEAP32[i39 >> 2];
   break;
  }
 case 120:
  {
   i41 = HEAP32[(HEAP32[i50 >> 2] | 0) + 20 >> 2] | 0;
   HEAP32[i25 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i26 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i42 + 0 >> 2] = HEAP32[i25 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i26 + 0 >> 2];
   FUNCTION_TABLE_viiiiiii[i41 & 63](i49, i50, i42, i43, i47, i46, i48);
   STACKTOP = i44;
   return;
  }
 default:
  HEAP32[i46 >> 2] = HEAP32[i46 >> 2] | 4;
 } while (0);
 HEAP32[i49 >> 2] = HEAP32[i45 >> 2];
 STACKTOP = i44;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc(i49, i50, i45, i35, i47, i46, i48, i34, i1) {
 i49 = i49 | 0;
 i50 = i50 | 0;
 i45 = i45 | 0;
 i35 = i35 | 0;
 i47 = i47 | 0;
 i46 = i46 | 0;
 i48 = i48 | 0;
 i34 = i34 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i51 = 0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 i43 = i44 + 160 | 0;
 i42 = i44 + 156 | 0;
 i51 = i44 + 152 | 0;
 i11 = i44 + 148 | 0;
 i22 = i44 + 144 | 0;
 i39 = i44 + 140 | 0;
 i40 = i44 + 136 | 0;
 i41 = i44 + 132 | 0;
 i31 = i44 + 128 | 0;
 i32 = i44 + 124 | 0;
 i33 = i44 + 120 | 0;
 i4 = i44 + 116 | 0;
 i3 = i44 + 112 | 0;
 i2 = i44 + 108 | 0;
 i1 = i44 + 104 | 0;
 i5 = i44 + 100 | 0;
 i6 = i44 + 96 | 0;
 i7 = i44 + 92 | 0;
 i8 = i44 + 88 | 0;
 i9 = i44 + 84 | 0;
 i10 = i44 + 80 | 0;
 i12 = i44 + 76 | 0;
 i13 = i44 + 72 | 0;
 i14 = i44 + 68 | 0;
 i15 = i44 + 64 | 0;
 i16 = i44 + 60 | 0;
 i17 = i44 + 56 | 0;
 i18 = i44 + 52 | 0;
 i19 = i44 + 48 | 0;
 i20 = i44 + 44 | 0;
 i21 = i44 + 40 | 0;
 i23 = i44 + 36 | 0;
 i24 = i44 + 32 | 0;
 i25 = i44 + 28 | 0;
 i26 = i44 + 24 | 0;
 i36 = i44 + 20 | 0;
 i37 = i44 + 16 | 0;
 i38 = i44 + 12 | 0;
 i27 = i44 + 8 | 0;
 i28 = i44 + 4 | 0;
 i29 = i44;
 HEAP32[i46 >> 2] = 0;
 __ZNKSt3__18ios_base6getlocEv(i51, i47);
 i30 = __ZNKSt3__16locale9use_facetERNS0_2idE(i51, 960728) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i51 >> 2] | 0) | 0;
 do switch (i34 << 24 >> 24 | 0) {
 case 114:
  {
   HEAP32[i14 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i42 + 0 >> 2] = HEAP32[i14 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i13, i50, i42, i43, i47, i46, i48, 959656, 959667 | 0);
   HEAP32[i45 >> 2] = HEAP32[i13 >> 2];
   break;
  }
 case 68:
  {
   HEAP32[i33 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i42 + 0 >> 2] = HEAP32[i33 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i32, i50, i42, i43, i47, i46, i48, 959640, 959648 | 0);
   HEAP32[i45 >> 2] = HEAP32[i32 >> 2];
   break;
  }
 case 106:
  {
   HEAP32[i7 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i7 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48 + 28 | 0, i45, i43, i46, i30);
   break;
  }
 case 73:
  {
   HEAP32[i6 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48 + 8 | 0, i45, i43, i46, i30);
   break;
  }
 case 89:
  {
   HEAP32[i28 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i28 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48 + 20 | 0, i45, i43, i46, i30);
   break;
  }
 case 70:
  {
   HEAP32[i2 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i42 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i1 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i3, i50, i42, i43, i47, i46, i48, 959648, 959656 | 0);
   HEAP32[i45 >> 2] = HEAP32[i3 >> 2];
   break;
  }
 case 77:
  {
   HEAP32[i9 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48 + 4 | 0, i45, i43, i46, i30);
   break;
  }
 case 82:
  {
   HEAP32[i17 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i42 + 0 >> 2] = HEAP32[i17 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i18 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i16, i50, i42, i43, i47, i46, i48, 959672, 959677 | 0);
   HEAP32[i45 >> 2] = HEAP32[i16 >> 2];
   break;
  }
 case 119:
  {
   HEAP32[i24 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i24 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48 + 24 | 0, i45, i43, i46, i30);
   break;
  }
 case 72:
  {
   HEAP32[i5 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48 + 8 | 0, i45, i43, i46, i30);
   break;
  }
 case 109:
  {
   HEAP32[i8 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48 + 16 | 0, i45, i43, i46, i30);
   break;
  }
 case 120:
  {
   i41 = HEAP32[(HEAP32[i50 >> 2] | 0) + 20 >> 2] | 0;
   HEAP32[i25 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i26 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i42 + 0 >> 2] = HEAP32[i25 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i26 + 0 >> 2];
   FUNCTION_TABLE_viiiiiii[i41 & 63](i49, i50, i42, i43, i47, i46, i48);
   STACKTOP = i44;
   return;
  }
 case 37:
  {
   HEAP32[i29 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i29 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE(i50, i45, i43, i46, i30);
   break;
  }
 case 65:
 case 97:
  {
   HEAP32[i11 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48 + 24 | 0, i45, i43, i46, i30);
   break;
  }
 case 121:
  {
   HEAP32[i27 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48 + 20 | 0, i45, i43, i46, i30);
   break;
  }
 case 112:
  {
   HEAP32[i12 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48 + 8 | 0, i45, i43, i46, i30);
   break;
  }
 case 116:
 case 110:
  {
   HEAP32[i10 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE(i50, i45, i43, i46, i30);
   break;
  }
 case 84:
  {
   HEAP32[i21 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i23 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i42 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i23 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i20, i50, i42, i43, i47, i46, i48, 959680, 959688 | 0);
   HEAP32[i45 >> 2] = HEAP32[i20 >> 2];
   break;
  }
 case 83:
  {
   HEAP32[i19 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i19 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48, i45, i43, i46, i30);
   break;
  }
 case 104:
 case 66:
 case 98:
  {
   HEAP32[i22 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i22 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48 + 16 | 0, i45, i43, i46, i30);
   break;
  }
 case 88:
  {
   i3 = i50 + 8 | 0;
   i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3) | 0;
   HEAP32[i37 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i38 >> 2] = HEAP32[i35 >> 2];
   i1 = HEAP8[i3 >> 0] | 0;
   if (!(i1 & 1)) {
    i4 = i3 + 1 | 0;
    i2 = (i1 & 255) >>> 1;
    i1 = i3 + 1 | 0;
   } else {
    i1 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i1;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
   }
   HEAP32[i42 + 0 >> 2] = HEAP32[i37 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i38 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i36, i50, i42, i43, i47, i46, i48, i1, i4 + i2 | 0);
   HEAP32[i45 >> 2] = HEAP32[i36 >> 2];
   break;
  }
 case 101:
 case 100:
  {
   HEAP32[i31 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i31 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIcEE(i50, i48 + 12 | 0, i45, i43, i46, i30);
   break;
  }
 case 99:
  {
   i4 = i50 + 8 | 0;
   i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4) | 0;
   HEAP32[i40 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i41 >> 2] = HEAP32[i35 >> 2];
   i1 = HEAP8[i4 >> 0] | 0;
   if (!(i1 & 1)) {
    i3 = i4 + 1 | 0;
    i2 = (i1 & 255) >>> 1;
    i1 = i4 + 1 | 0;
   } else {
    i1 = HEAP32[i4 + 8 >> 2] | 0;
    i3 = i1;
    i2 = HEAP32[i4 + 4 >> 2] | 0;
   }
   HEAP32[i42 + 0 >> 2] = HEAP32[i40 + 0 >> 2];
   HEAP32[i43 + 0 >> 2] = HEAP32[i41 + 0 >> 2];
   __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i39, i50, i42, i43, i47, i46, i48, i1, i3 + i2 | 0);
   HEAP32[i45 >> 2] = HEAP32[i39 >> 2];
   break;
  }
 default:
  HEAP32[i46 >> 2] = HEAP32[i46 >> 2] | 4;
 } while (0);
 HEAP32[i49 >> 2] = HEAP32[i45 >> 2];
 STACKTOP = i44;
 return;
}

function __ZN2cv11TiffEncoder5writeERKNS_3MatERKNSt3__16vectorIiNS4_9allocatorIiEEEE(i38, i11, i1) {
 i38 = i38 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 3232 | 0;
 i17 = i42 + 3224 | 0;
 i41 = i42 + 3184 | 0;
 i40 = i42 + 2120 | 0;
 i39 = i42 + 1072 | 0;
 i37 = i42 + 32 | 0;
 i18 = i42 + 24 | 0;
 i19 = i42 + 16 | 0;
 i20 = i42 + 8 | 0;
 i21 = i42;
 i1 = HEAP32[i11 >> 2] | 0;
 i22 = i1 >>> 3 & 511;
 i36 = i22 + 1 | 0;
 i33 = HEAP32[i11 + 12 >> 2] | 0;
 i34 = HEAP32[i11 + 8 >> 2] | 0;
 i1 = i1 & 7;
 if (!((i1 | 0) == 0 | (i1 | 0) == 2)) {
  i22 = 0;
  STACKTOP = i42;
  return i22 | 0;
 }
 i15 = (i1 | 0) == 0;
 i10 = i15 ? 1 : 2;
 i16 = Math_imul(Math_imul(i36, i33) | 0, i10) | 0;
 __ZN2cv11WBaseStreamC2Ev(i41);
 HEAP32[i41 >> 2] = 181080;
 i35 = i38 + 20 | 0;
 i5 = HEAP32[i35 >> 2] | 0;
 if (!i5) if (FUNCTION_TABLE_iii[HEAP32[181072 + 16 >> 2] & 127](i41, i38 + 12 | 0) | 0) i32 = 5; else i1 = 0; else if (FUNCTION_TABLE_iii[HEAP32[181072 + 20 >> 2] & 127](i41, i5) | 0) i32 = 5; else i1 = 0;
 if ((i32 | 0) == 5) {
  i30 = 8192 / (i16 | 0) | 0;
  i30 = (i30 | 0) < 1 ? 1 : i30;
  i30 = (i30 | 0) > (i34 | 0) ? i34 : i30;
  i31 = (i34 + -1 + i30 | 0) / (i30 | 0) | 0;
  i1 = HEAP32[i35 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i8 = (Math_imul(i16, i34) | 0) + 511 + (i31 << 3) & -256, i9 = i1 + 8 | 0, i7 = HEAP32[i1 >> 2] | 0, i4 = i7, ((HEAP32[i9 >> 2] | 0) - i4 | 0) >>> 0 < i8 >>> 0) : 0) {
   i6 = i1 + 4 | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   i3 = i5 - i4 | 0;
   if (!i8) {
    i2 = 0;
    i4 = i5;
    i5 = i7;
   } else {
    i2 = __Znwj(i8) | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = HEAP32[i1 >> 2] | 0;
   }
   i13 = i4 - i5 | 0;
   i14 = i2 + (i3 - i13) | 0;
   _memcpy(i14 | 0, i5 | 0, i13 | 0) | 0;
   HEAP32[i1 >> 2] = i14;
   HEAP32[i6 >> 2] = i2 + i3;
   HEAP32[i9 >> 2] = i2 + i8;
   if (i5) __ZdlPv(i5);
  }
  i28 = i40 + 8 | 0;
  HEAP32[i40 >> 2] = i28;
  i29 = i40 + 4 | 0;
  HEAP32[i29 >> 2] = 264;
  if (i31 >>> 0 > 264) HEAP32[i40 >> 2] = __Znaj(i31 >>> 0 > 1073741823 ? -1 : i31 << 2) | 0;
  HEAP32[i29 >> 2] = i31;
  i26 = i39 + 8 | 0;
  HEAP32[i39 >> 2] = i26;
  i27 = i39 + 4 | 0;
  HEAP32[i27 >> 2] = 520;
  if (i31 >>> 0 > 520) HEAP32[i39 >> 2] = __Znaj(i31 >>> 0 > 2147483647 ? -1 : i31 << 1) | 0;
  HEAP32[i27 >> 2] = i31;
  i5 = i16 + 32 | 0;
  i24 = i37 + 8 | 0;
  HEAP32[i37 >> 2] = i24;
  i25 = i37 + 4 | 0;
  HEAP32[i25 >> 2] = 1032;
  if (i5 >>> 0 > 1032) {
   i23 = __Znaj(i5) | 0;
   HEAP32[i37 >> 2] = i23;
  } else i23 = i24;
  HEAP32[i25 >> 2] = i5;
  i14 = i10 << 3;
  __ZN2cv12WLByteStream8putBytesEPKvi(i41, 180648, 4);
  __ZN2cv12WLByteStream8putDWordEi(i41, 0);
  i13 = (i31 | 0) > 0;
  do if (i13) {
   i7 = i36 >>> 0 > 1;
   i12 = i11 + 16 | 0;
   i11 = i11 + 44 | 0;
   i1 = i18 + 4 | 0;
   i2 = i19 + 4 | 0;
   i3 = i20 + 4 | 0;
   i4 = i21 + 4 | 0;
   i5 = (i22 | 0) == 2;
   i6 = 0;
   i9 = 0;
   do {
    i10 = i9 + i30 | 0;
    i10 = (i10 | 0) > (i34 | 0) ? i34 : i10;
    i8 = __ZN2cv11WBaseStream6getPosEv(i41) | 0;
    HEAP32[(HEAP32[i40 >> 2] | 0) + (i6 << 2) >> 2] = i8;
    L30 : do if ((i9 | 0) < (i10 | 0)) {
     if (i5) while (1) {
      i8 = (HEAP32[i12 >> 2] | 0) + (Math_imul(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i9) | 0) | 0;
      if (i15) {
       HEAP32[i18 >> 2] = i33;
       HEAP32[i1 >> 2] = 1;
       HEAP32[i17 + 0 >> 2] = HEAP32[i18 + 0 >> 2];
       HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
       __Z21icvCvt_BGR2RGB_8u_C3RPKhiPhi6CvSize(i8, 0, i23, 0, i17);
      } else {
       HEAP32[i19 >> 2] = i33;
       HEAP32[i2 >> 2] = 1;
       HEAP32[i17 + 0 >> 2] = HEAP32[i19 + 0 >> 2];
       HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
       __Z22icvCvt_BGR2RGB_16u_C3RPKtiPti6CvSize(i8, 0, i23, 0, i17);
      }
      if (i7) i8 = i23; else i8 = (HEAP32[i12 >> 2] | 0) + (Math_imul(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i9) | 0) | 0;
      __ZN2cv12WLByteStream8putBytesEPKvi(i41, i8, i16);
      i9 = i9 + 1 | 0;
      if ((i9 | 0) >= (i10 | 0)) break L30;
     }
     do {
      do if ((i22 | 0) == 3) {
       i8 = (HEAP32[i12 >> 2] | 0) + (Math_imul(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i9) | 0) | 0;
       if (i15) {
        HEAP32[i20 >> 2] = i33;
        HEAP32[i3 >> 2] = 1;
        HEAP32[i17 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
        HEAP32[i17 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
        __Z23icvCvt_BGRA2RGBA_8u_C4RPKhiPhi6CvSize(i8, 0, i23, 0, i17);
        break;
       } else {
        HEAP32[i21 >> 2] = i33;
        HEAP32[i4 >> 2] = 1;
        HEAP32[i17 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
        HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
        __Z24icvCvt_BGRA2RGBA_16u_C4RPKtiPti6CvSize(i8, 0, i23, 0, i17);
        break;
       }
      } while (0);
      if (i7) i8 = i23; else i8 = (HEAP32[i12 >> 2] | 0) + (Math_imul(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i9) | 0) | 0;
      __ZN2cv12WLByteStream8putBytesEPKvi(i41, i8, i16);
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) < (i10 | 0));
    } while (0);
    i8 = __ZN2cv11WBaseStream6getPosEv(i41) | 0;
    HEAP16[(HEAP32[i39 >> 2] | 0) + (i6 << 1) >> 1] = i8 - (HEAP32[(HEAP32[i40 >> 2] | 0) + (i6 << 2) >> 2] | 0);
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) < (i31 | 0));
   if ((i31 | 0) > 2) {
    i2 = __ZN2cv11WBaseStream6getPosEv(i41) | 0;
    if (i13) {
     i1 = 0;
     do {
      __ZN2cv12WLByteStream8putDWordEi(i41, HEAP32[(HEAP32[i40 >> 2] | 0) + (i1 << 2) >> 2] | 0);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (i31 | 0));
    }
    i3 = __ZN2cv11WBaseStream6getPosEv(i41) | 0;
    if (i13) i1 = 0; else break;
    do {
     __ZN2cv12WLByteStream7putWordEi(i41, HEAP16[(HEAP32[i39 >> 2] | 0) + (i1 << 1) >> 1] | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i31 | 0));
   } else {
    if ((i31 | 0) != 2) {
     i32 = 44;
     break;
    }
    i2 = __ZN2cv11WBaseStream6getPosEv(i41) | 0;
    i1 = 0;
    do {
     __ZN2cv12WLByteStream8putDWordEi(i41, HEAP32[(HEAP32[i40 >> 2] | 0) + (i1 << 2) >> 2] | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < 2);
    i3 = HEAP32[i39 >> 2] | 0;
    i3 = (HEAPU16[i3 + 2 >> 1] << 16) + (HEAP16[i3 >> 1] | 0) | 0;
    break;
   }
  } else i32 = 44; while (0);
  if ((i32 | 0) == 44) {
   i3 = HEAP16[HEAP32[i39 >> 2] >> 1] | 0;
   i2 = HEAP32[HEAP32[i40 >> 2] >> 2] | 0;
  }
  i5 = i36 >>> 0 > 1;
  if (i5) {
   i1 = __ZN2cv11WBaseStream6getPosEv(i41) | 0;
   __ZN2cv12WLByteStream7putWordEi(i41, i14);
   __ZN2cv12WLByteStream7putWordEi(i41, i14);
   __ZN2cv12WLByteStream7putWordEi(i41, i14);
   if ((i36 | 0) == 4) __ZN2cv12WLByteStream7putWordEi(i41, i14);
  } else i1 = i14;
  i4 = __ZN2cv11WBaseStream6getPosEv(i41) | 0;
  __ZN2cv12WLByteStream7putWordEi(i41, 9);
  __ZN2cv12WLByteStream7putWordEi(i41, 256);
  __ZN2cv12WLByteStream7putWordEi(i41, 4);
  __ZN2cv12WLByteStream8putDWordEi(i41, 1);
  __ZN2cv12WLByteStream8putDWordEi(i41, i33);
  __ZN2cv12WLByteStream7putWordEi(i41, 257);
  __ZN2cv12WLByteStream7putWordEi(i41, 4);
  __ZN2cv12WLByteStream8putDWordEi(i41, 1);
  __ZN2cv12WLByteStream8putDWordEi(i41, i34);
  __ZN2cv12WLByteStream7putWordEi(i41, 258);
  __ZN2cv12WLByteStream7putWordEi(i41, 3);
  __ZN2cv12WLByteStream8putDWordEi(i41, i36);
  __ZN2cv12WLByteStream8putDWordEi(i41, i1);
  __ZN2cv12WLByteStream7putWordEi(i41, 259);
  __ZN2cv12WLByteStream7putWordEi(i41, 4);
  __ZN2cv12WLByteStream8putDWordEi(i41, 1);
  __ZN2cv12WLByteStream8putDWordEi(i41, 1);
  __ZN2cv12WLByteStream7putWordEi(i41, 262);
  __ZN2cv12WLByteStream7putWordEi(i41, 3);
  __ZN2cv12WLByteStream8putDWordEi(i41, 1);
  __ZN2cv12WLByteStream8putDWordEi(i41, i5 ? 2 : 1);
  __ZN2cv12WLByteStream7putWordEi(i41, 273);
  __ZN2cv12WLByteStream7putWordEi(i41, 4);
  __ZN2cv12WLByteStream8putDWordEi(i41, i31);
  __ZN2cv12WLByteStream8putDWordEi(i41, i2);
  __ZN2cv12WLByteStream7putWordEi(i41, 277);
  __ZN2cv12WLByteStream7putWordEi(i41, 3);
  __ZN2cv12WLByteStream8putDWordEi(i41, 1);
  __ZN2cv12WLByteStream8putDWordEi(i41, i36);
  __ZN2cv12WLByteStream7putWordEi(i41, 278);
  __ZN2cv12WLByteStream7putWordEi(i41, 4);
  __ZN2cv12WLByteStream8putDWordEi(i41, 1);
  __ZN2cv12WLByteStream8putDWordEi(i41, i30);
  __ZN2cv12WLByteStream7putWordEi(i41, 279);
  __ZN2cv12WLByteStream7putWordEi(i41, (i31 | 0) > 1 ? 3 : 4);
  __ZN2cv12WLByteStream8putDWordEi(i41, i31);
  __ZN2cv12WLByteStream8putDWordEi(i41, i3);
  __ZN2cv12WLByteStream8putDWordEi(i41, 0);
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i41 >> 2] | 0) + 16 >> 2] & 511](i41);
  i1 = HEAP32[i35 >> 2] | 0;
  if (!i1) {
   i22 = HEAP32[i38 + 12 >> 2] | 0;
   i22 = _fopen(((i22 | 0) == 0 ? 180704 : i22) | 0, 180656) | 0;
   HEAP8[i23 >> 0] = i4;
   HEAP8[i23 + 1 >> 0] = i4 >>> 8;
   HEAP8[i23 + 2 >> 0] = i4 >>> 16;
   HEAP8[i23 + 3 >> 0] = i4 >>> 24;
   _fseek(i22 | 0, 4, 0) | 0;
   _fwrite(i23 | 0, 1, 4, i22 | 0) | 0;
   _fclose(i22 | 0) | 0;
  } else {
   HEAP8[(HEAP32[i1 >> 2] | 0) + 4 >> 0] = i4;
   HEAP8[(HEAP32[HEAP32[i35 >> 2] >> 2] | 0) + 5 >> 0] = i4 >>> 8;
   HEAP8[(HEAP32[HEAP32[i35 >> 2] >> 2] | 0) + 6 >> 0] = i4 >>> 16;
   HEAP8[(HEAP32[HEAP32[i35 >> 2] >> 2] | 0) + 7 >> 0] = i4 >>> 24;
  }
  i1 = HEAP32[i37 >> 2] | 0;
  if ((i1 | 0) != (i24 | 0)) {
   if (i1) __ZdaPv(i1);
   HEAP32[i37 >> 2] = i24;
   HEAP32[i25 >> 2] = 1032;
  }
  i1 = HEAP32[i39 >> 2] | 0;
  if ((i1 | 0) != (i26 | 0)) {
   if (i1) __ZdaPv(i1);
   HEAP32[i39 >> 2] = i26;
   HEAP32[i27 >> 2] = 520;
  }
  i1 = HEAP32[i40 >> 2] | 0;
  if ((i1 | 0) == (i28 | 0)) i1 = 1; else {
   if (i1) __ZdaPv(i1);
   HEAP32[i40 >> 2] = i28;
   HEAP32[i29 >> 2] = 264;
   i1 = 1;
  }
 }
 __ZN2cv11WBaseStreamD2Ev(i41);
 i22 = i1;
 STACKTOP = i42;
 return i22 | 0;
}

function __ZN2cv16SunRasterDecoder8readDataERNS_3MatE(i19, i1) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 2400 | 0;
 i20 = i34 + 2128 | 0;
 i22 = i34 + 2136 | 0;
 i29 = i34 + 2120 | 0;
 i33 = i34 + 1080 | 0;
 i32 = i34 + 40 | 0;
 i18 = i34 + 36 | 0;
 i16 = i34 + 32 | 0;
 i9 = i34 + 24 | 0;
 i8 = i34 + 16 | 0;
 i11 = i34 + 8 | 0;
 i12 = i34;
 i24 = (((HEAP32[i1 >> 2] | 0) >>> 3 & 511) + 1 | 0) >>> 0 > 1;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 i25 = HEAP32[i1 + 48 >> 2] | 0;
 i21 = i19 + 4 | 0;
 i15 = HEAP32[i21 >> 2] | 0;
 i6 = i19 + 1152 | 0;
 i14 = (((Math_imul(HEAP32[i6 >> 2] | 0, i15) | 0) + 7 | 0) / 8 | 0) + 1 & -2;
 i1 = i24 ? 3 : 1;
 i15 = Math_imul(i1, i15) | 0;
 i5 = i19 + 1156 | 0;
 if ((HEAP32[i5 >> 2] | 0) < 0) {
  i22 = 0;
  STACKTOP = i34;
  return i22 | 0;
 }
 i26 = i19 + 92 | 0;
 if (!(__ZN2cv11RBaseStream8isOpenedEv(i26) | 0)) {
  i22 = 0;
  STACKTOP = i34;
  return i22 | 0;
 }
 i7 = i14 + 32 | 0;
 i30 = i33 + 8 | 0;
 HEAP32[i33 >> 2] = i30;
 i31 = i33 + 4 | 0;
 HEAP32[i31 >> 2] = 1032;
 if (i7 >>> 0 > 1032) {
  i23 = __Znaj(i7) | 0;
  HEAP32[i33 >> 2] = i23;
 } else i23 = i30;
 HEAP32[i31 >> 2] = i7;
 i7 = ((HEAP32[i21 >> 2] | 0) * 3 | 0) + 32 | 0;
 i27 = i32 + 8 | 0;
 HEAP32[i32 >> 2] = i27;
 i28 = i32 + 4 | 0;
 HEAP32[i28 >> 2] = 1032;
 if (i7 >>> 0 > 1032) {
  i10 = __Znaj(i7) | 0;
  HEAP32[i32 >> 2] = i10;
 } else i10 = i27;
 HEAP32[i28 >> 2] = i7;
 if (!i24 ? (HEAP32[i19 + 1164 >> 2] | 0) == 1 : 0) __Z16CvtPaletteToGrayPK12PaletteEntryPhi(i19 + 128 | 0, i22, 1 << HEAP32[i6 >> 2]);
 __ZN2cv11RBaseStream6setPosEi(i26, HEAP32[i5 >> 2] | 0);
 i7 = HEAP32[i6 >> 2] | 0;
 L17 : do if ((i7 | 0) == 32) {
  HEAP32[i29 >> 2] = 0;
  i6 = i19 + 8 | 0;
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   i7 = i23 + 3 | 0;
   i1 = i23 + 4 | 0;
   i4 = i11 + 4 | 0;
   i3 = i19 + 12 | 0;
   i5 = i12 + 4 | 0;
   if (i24) while (1) {
    __ZN2cv12RLByteStream8getBytesEPvi(i26, i7, i14) | 0;
    HEAP32[i11 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i4 >> 2] = 1;
    i22 = (HEAP32[i3 >> 2] | 0) == 3 ? 2 : 0;
    HEAP32[i20 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    __Z24icvCvt_BGRA2BGR_8u_C4C3RPKhiPhi6CvSizei(i1, 0, i2, 0, i20, i22);
    i22 = HEAP32[i6 >> 2] | 0;
    i19 = (HEAP32[i29 >> 2] | 0) + 1 | 0;
    HEAP32[i29 >> 2] = i19;
    if ((i19 | 0) < (i22 | 0)) i2 = i2 + i25 | 0; else {
     i2 = 1;
     break;
    }
   } else while (1) {
    __ZN2cv12RLByteStream8getBytesEPvi(i26, i7, i14) | 0;
    HEAP32[i12 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i5 >> 2] = 1;
    i22 = (HEAP32[i3 >> 2] | 0) == 3 ? 2 : 0;
    HEAP32[i20 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    __Z25icvCvt_BGRA2Gray_8u_C4C1RPKhiPhi6CvSizei(i1, 0, i2, 0, i20, i22);
    i22 = HEAP32[i6 >> 2] | 0;
    i19 = (HEAP32[i29 >> 2] | 0) + 1 | 0;
    HEAP32[i29 >> 2] = i19;
    if ((i19 | 0) < (i22 | 0)) i2 = i2 + i25 | 0; else {
     i2 = 1;
     break;
    }
   }
  } else i2 = 1;
 } else if ((i7 | 0) == 1) {
  if ((HEAP32[i19 + 12 >> 2] | 0) != 2) {
   HEAP32[i29 >> 2] = 0;
   i3 = i19 + 8 | 0;
   if ((HEAP32[i3 >> 2] | 0) <= 0) {
    i2 = 1;
    break;
   }
   i1 = i19 + 128 | 0;
   if (i24) while (1) {
    __ZN2cv12RLByteStream8getBytesEPvi(i26, i23, i14) | 0;
    __Z13FillColorRow1PhS_iP12PaletteEntry(i2, i23, HEAP32[i21 >> 2] | 0, i1) | 0;
    i22 = HEAP32[i3 >> 2] | 0;
    i20 = (HEAP32[i29 >> 2] | 0) + 1 | 0;
    HEAP32[i29 >> 2] = i20;
    if ((i20 | 0) < (i22 | 0)) i2 = i2 + i25 | 0; else {
     i2 = 1;
     break L17;
    }
   } else while (1) {
    __ZN2cv12RLByteStream8getBytesEPvi(i26, i23, i14) | 0;
    __Z12FillGrayRow1PhS_iS_(i2, i23, HEAP32[i21 >> 2] | 0, i22) | 0;
    i20 = HEAP32[i3 >> 2] | 0;
    i19 = (HEAP32[i29 >> 2] | 0) + 1 | 0;
    HEAP32[i29 >> 2] = i19;
    if ((i19 | 0) < (i20 | 0)) i2 = i2 + i25 | 0; else {
     i2 = 1;
     break L17;
    }
   }
  }
  i8 = i23 + (((HEAP32[i21 >> 2] | 0) + 7 | 0) / 8 | 0) | 0;
  HEAP32[i29 >> 2] = 0;
  i9 = i8;
  i10 = i19 + 128 | 0;
  i6 = i19 + 8 | 0;
  while (1) {
   i3 = i23;
   do {
    i4 = i9 - i3 | 0;
    i7 = 0;
    while (1) {
     i5 = __ZN2cv12RLByteStream7getByteEv(i26) | 0;
     if ((i5 | 0) == 128 ? (i13 = __ZN2cv12RLByteStream7getByteEv(i26) | 0, (i13 | 0) != 0) : 0) {
      i4 = 27;
      break;
     }
     HEAP8[i3 + i7 >> 0] = i5;
     i5 = i7 + 1 | 0;
     if ((i5 | 0) < (i4 | 0)) i7 = i5; else {
      i4 = 26;
      break;
     }
    }
    if ((i4 | 0) == 26) i3 = i3 + i5 | 0; else if ((i4 | 0) == 27) {
     i5 = i3 + i7 | 0;
     if ((i13 | 0) > 0) {
      i4 = i13 + 1 | 0;
      i1 = __ZN2cv12RLByteStream7getByteEv(i26) | 0;
      if ((i13 | 0) >= (i9 - i5 | 0)) {
       i2 = 0;
       break L17;
      }
      _memset(i5 | 0, i1 & 255 | 0, i4 | 0) | 0;
      i3 = i3 + (i7 + i4) | 0;
     } else i3 = i5;
    }
   } while (i3 >>> 0 < i8 >>> 0);
   i3 = HEAP32[i21 >> 2] | 0;
   if (i24) __Z13FillColorRow1PhS_iP12PaletteEntry(i2, i23, i3, i10) | 0; else __Z12FillGrayRow1PhS_iS_(i2, i23, i3, i22) | 0;
   i20 = (HEAP32[i29 >> 2] | 0) + 1 | 0;
   HEAP32[i29 >> 2] = i20;
   if ((i20 | 0) < (HEAP32[i6 >> 2] | 0)) i2 = i2 + i25 | 0; else {
    i2 = 1;
    break;
   }
  }
 } else if ((i7 | 0) == 8) {
  if ((HEAP32[i19 + 12 >> 2] | 0) != 2) {
   HEAP32[i29 >> 2] = 0;
   i3 = i19 + 8 | 0;
   if ((HEAP32[i3 >> 2] | 0) <= 0) {
    i2 = 1;
    break;
   }
   i1 = i19 + 128 | 0;
   if (i24) while (1) {
    __ZN2cv12RLByteStream8getBytesEPvi(i26, i23, i14) | 0;
    __Z13FillColorRow8PhS_iP12PaletteEntry(i2, i23, HEAP32[i21 >> 2] | 0, i1) | 0;
    i22 = HEAP32[i3 >> 2] | 0;
    i20 = (HEAP32[i29 >> 2] | 0) + 1 | 0;
    HEAP32[i29 >> 2] = i20;
    if ((i20 | 0) < (i22 | 0)) i2 = i2 + i25 | 0; else {
     i2 = 1;
     break L17;
    }
   } else while (1) {
    __ZN2cv12RLByteStream8getBytesEPvi(i26, i23, i14) | 0;
    __Z12FillGrayRow8PhS_iS_(i2, i23, HEAP32[i21 >> 2] | 0, i22) | 0;
    i20 = HEAP32[i3 >> 2] | 0;
    i19 = (HEAP32[i29 >> 2] | 0) + 1 | 0;
    HEAP32[i29 >> 2] = i19;
    if ((i19 | 0) < (i20 | 0)) i2 = i2 + i25 | 0; else {
     i2 = 1;
     break L17;
    }
   }
  }
  i5 = i2 + i15 | 0;
  HEAP32[i18 >> 2] = i5;
  HEAP32[i29 >> 2] = 0;
  i9 = i23;
  i8 = i19 + 128 | 0;
  i3 = i19 + 8 | 0;
  i10 = i25 - i15 | 0;
  while (1) {
   i5 = i5 - i2 | 0;
   i4 = i23;
   while (1) {
    i6 = __ZN2cv12RLByteStream7getByteEv(i26) | 0;
    if ((i6 | 0) == 128 ? (i17 = __ZN2cv12RLByteStream7getByteEv(i26) | 0, (i17 | 0) != 0) : 0) {
     i6 = i17;
     i7 = i4;
     break;
    }
    i7 = i4 + 1 | 0;
    HEAP8[i4 >> 0] = i6;
    i5 = i5 - i1 | 0;
    if ((i5 | 0) <= 0) {
     i6 = 0;
     break;
    } else i4 = i7;
   }
   i5 = i7 - i9 | 0;
   if ((i5 | 0) > 0) {
    if (i24) __Z13FillColorRow8PhS_iP12PaletteEntry(i2, i23, i5, i8) | 0; else __Z12FillGrayRow8PhS_iS_(i2, i23, i5, i22) | 0;
    i2 = i2 + (Math_imul(i5, i1) | 0) | 0;
   }
   if ((i6 | 0) > 0) {
    i7 = Math_imul(i6 + 1 | 0, i1) | 0;
    i6 = __ZN2cv12RLByteStream7getByteEv(i26) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    if (i24) {
     i21 = i19 + (i6 << 2) + 128 | 0;
     HEAP32[i16 >> 2] = HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24;
     HEAP8[i20 + 0 >> 0] = HEAP8[i16 + 0 >> 0] | 0;
     HEAP8[i20 + 1 >> 0] = HEAP8[i16 + 1 >> 0] | 0;
     HEAP8[i20 + 2 >> 0] = HEAP8[i16 + 2 >> 0] | 0;
     HEAP8[i20 + 3 >> 0] = HEAP8[i16 + 3 >> 0] | 0;
     i2 = __Z12FillUniColorPhRS_iiRiii12PaletteEntry(i2, i18, i25, i15, i29, i5, i7, i20) | 0;
    } else i2 = __Z11FillUniGrayPhRS_iiRiiih(i2, i18, i25, i15, i29, i5, i7, HEAP8[i22 + i6 >> 0] | 0) | 0;
    if ((HEAP32[i29 >> 2] | 0) >= (HEAP32[i3 >> 2] | 0)) {
     i2 = 1;
     break L17;
    }
   }
   i5 = HEAP32[i18 >> 2] | 0;
   if ((i2 | 0) != (i5 | 0)) continue;
   if (__ZN2cv12RLByteStream7getByteEv(i26) | 0) {
    i2 = 0;
    break L17;
   }
   i4 = HEAP32[i18 >> 2] | 0;
   i5 = i4 + i25 | 0;
   HEAP32[i18 >> 2] = i5;
   i21 = (HEAP32[i29 >> 2] | 0) + 1 | 0;
   HEAP32[i29 >> 2] = i21;
   if ((i21 | 0) >= (HEAP32[i3 >> 2] | 0)) {
    i2 = 1;
    break;
   } else i2 = i4 + i10 | 0;
  }
 } else if ((i7 | 0) == 24) {
  HEAP32[i29 >> 2] = 0;
  i5 = i19 + 8 | 0;
  if ((HEAP32[i5 >> 2] | 0) > 0) {
   i3 = i19 + 12 | 0;
   i1 = i9 + 4 | 0;
   i4 = i8 + 4 | 0;
   while (1) {
    __ZN2cv12RLByteStream8getBytesEPvi(i26, i24 ? i2 : i10, i14) | 0;
    if (i24) {
     if ((HEAP32[i3 >> 2] | 0) == 3) {
      HEAP32[i9 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i1 >> 2] = 1;
      HEAP32[i20 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
      HEAP32[i20 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      __Z21icvCvt_BGR2RGB_8u_C3RPKhiPhi6CvSize(i2, 0, i2, 0, i20);
     }
    } else {
     HEAP32[i8 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i4 >> 2] = 1;
     i22 = (HEAP32[i3 >> 2] | 0) == 3 ? 2 : 0;
     HEAP32[i20 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     __Z24icvCvt_BGR2Gray_8u_C3C1RPKhiPhi6CvSizei(i10, 0, i2, 0, i20, i22);
    }
    i22 = (HEAP32[i29 >> 2] | 0) + 1 | 0;
    HEAP32[i29 >> 2] = i22;
    if ((i22 | 0) < (HEAP32[i5 >> 2] | 0)) i2 = i2 + i25 | 0; else {
     i2 = 1;
     break;
    }
   }
  } else i2 = 1;
 } else i2 = 0; while (0);
 i1 = HEAP32[i32 >> 2] | 0;
 if ((i1 | 0) != (i27 | 0)) {
  if (i1) __ZdaPv(i1);
  HEAP32[i32 >> 2] = i27;
  HEAP32[i28 >> 2] = 1032;
 }
 i1 = HEAP32[i33 >> 2] | 0;
 if ((i1 | 0) == (i30 | 0)) {
  i22 = i2;
  STACKTOP = i34;
  return i22 | 0;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i33 >> 2] = i30;
 HEAP32[i31 >> 2] = 1032;
 i22 = i2;
 STACKTOP = i34;
 return i22 | 0;
}

function __ZNK2cv13AlgorithmInfo5writeEPKNS_9AlgorithmERNS_11FileStorageE(i34, i30, i31) {
 i34 = i34 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i35 = i38;
 i37 = i38 + 144 | 0;
 i23 = i38 + 136 | 0;
 i1 = i38 + 128 | 0;
 i4 = i38 + 120 | 0;
 i25 = i38 + 112 | 0;
 i26 = i38 + 56 | 0;
 i27 = i38 + 44 | 0;
 i36 = i38 + 40 | 0;
 i28 = i38 + 32 | 0;
 i33 = i38 + 24 | 0;
 i32 = i38 + 16 | 0;
 i29 = i38 + 8 | 0;
 i3 = HEAP32[i34 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i24 = (i2 - i3 | 0) / 44 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i22 = __ZN2cv6String8allocateEj(i1, 4) | 0;
 HEAP8[i22 >> 0] = 110;
 HEAP8[i22 + 1 >> 0] = 97;
 HEAP8[i22 + 2 >> 0] = 109;
 HEAP8[i22 + 3 >> 0] = 101;
 i22 = HEAP32[(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] & 127](i30) | 0) >> 2] | 0;
 i5 = HEAP32[i22 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = HEAP32[i22 + 16 >> 2];
 if (i5) {
  i22 = i5 + -4 | 0;
  HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
 }
 __ZN2cv5writeERNS_11FileStorageERKNS_6StringES4_(i31, i1, i4);
 __ZN2cv6String10deallocateEv(i4);
 __ZN2cv6String10deallocateEv(i1);
 if ((i2 | 0) == (i3 | 0)) {
  STACKTOP = i38;
  return;
 }
 i6 = i29 + 4 | 0;
 i7 = i25 + 4 | 0;
 i8 = i26 + 4 | 0;
 i9 = i26 + 8 | 0;
 i10 = i26 + 40 | 0;
 i11 = i26 + 48 | 0;
 i12 = i26 + 44 | 0;
 i13 = i26 + 52 | 0;
 i14 = i26 + 36 | 0;
 i15 = i26 + 16 | 0;
 i16 = i27 + 4 | 0;
 i17 = i27 + 8 | 0;
 i18 = i23 + 4 | 0;
 i19 = i35 + 4 | 0;
 i20 = i28 + 4 | 0;
 i21 = i33 + 4 | 0;
 i22 = 0;
 do {
  i5 = HEAP32[HEAP32[i34 >> 2] >> 2] | 0;
  i3 = i5 + (i22 * 44 | 0) | 0;
  i5 = HEAP32[i5 + (i22 * 44 | 0) + 8 >> 2] | 0;
  do switch (i5 | 0) {
  case 3:
   {
    HEAP32[i25 >> 2] = 0;
    HEAP32[i7 >> 2] = 0;
    i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] & 127](i30) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    __ZNK2cv13AlgorithmInfo3getEPKNS_9AlgorithmEPKciPv(i2, i30, (i1 | 0) == 0 ? 39376 : i1, 3, i25);
    __ZN2cv5writeERNS_11FileStorageERKNS_6StringES4_(i31, i3, i25);
    __ZN2cv6String10deallocateEv(i25);
    break;
   }
  case 6:
   {
    HEAP32[i28 >> 2] = 0;
    HEAP32[i20 >> 2] = 0;
    __ZN2cv8internal18WriteStructContextC2ERNS_11FileStorageERKNS_6StringEiS6_(i36, i31, i3, 6, i28);
    __ZN2cv6String10deallocateEv(i28);
    HEAP32[i33 >> 2] = 0;
    HEAP32[i21 >> 2] = 0;
    i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] & 127](i30) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    __ZNK2cv13AlgorithmInfo3getEPKNS_9AlgorithmEPKciPv(i1, i30, (i5 | 0) == 0 ? 39376 : i5, 6, i33);
    i5 = HEAP32[i21 >> 2] | 0;
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 127](i5, i31);
    i5 = HEAP32[i33 >> 2] | 0;
    if ((i5 | 0) != 0 ? (i2 = i5 + 4 | 0, i1 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 511](i5);
    HEAP32[i33 >> 2] = 0;
    HEAP32[i21 >> 2] = 0;
    __ZN2cv8internal18WriteStructContextD2Ev(i36);
    break;
   }
  case 9:
   {
    i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] & 127](i30) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    __ZNK2cv13AlgorithmInfo3getEPKNS_9AlgorithmEPKciPv(i2, i30, (i1 | 0) == 0 ? 39376 : i1, 0, i35);
    __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i31, i3, HEAP32[i35 >> 2] | 0);
    break;
   }
  case 0:
   {
    i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] & 127](i30) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    __ZNK2cv13AlgorithmInfo3getEPKNS_9AlgorithmEPKciPv(i2, i30, (i1 | 0) == 0 ? 39376 : i1, 0, i35);
    __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i31, i3, HEAP32[i35 >> 2] | 0);
    break;
   }
  case 8:
   {
    i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] & 127](i30) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    __ZNK2cv13AlgorithmInfo3getEPKNS_9AlgorithmEPKciPv(i2, i30, (i1 | 0) == 0 ? 39376 : i1, 0, i35);
    __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i31, i3, HEAP32[i35 >> 2] | 0);
    break;
   }
  case 1:
   {
    i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] & 127](i30) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    __ZNK2cv13AlgorithmInfo3getEPKNS_9AlgorithmEPKciPv(i2, i30, (i1 | 0) == 0 ? 39376 : i1, 1, i35);
    __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i31, i3, HEAPU8[i35 >> 0] | 0);
    break;
   }
  case 4:
   {
    HEAP32[i26 >> 2] = 1124007936;
    i5 = i8 + 0 | 0;
    i4 = i5 + 36 | 0;
    do {
     HEAP32[i5 >> 2] = 0;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) < (i4 | 0));
    HEAP32[i10 >> 2] = i9;
    HEAP32[i12 >> 2] = i11;
    HEAP32[i13 >> 2] = 0;
    HEAP32[i11 >> 2] = 0;
    i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] & 127](i30) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    __ZNK2cv13AlgorithmInfo3getEPKNS_9AlgorithmEPKciPv(i1, i30, (i5 | 0) == 0 ? 39376 : i5, 4, i26);
    __ZN2cv5writeERNS_11FileStorageERKNS_6StringERKNS_3MatE(i31, i3, i26);
    i5 = HEAP32[i14 >> 2] | 0;
    if ((i5 | 0) != 0 ? (i2 = i5 + 12 | 0, i1 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i26);
    HEAP32[i14 >> 2] = 0;
    HEAP32[i15 + 0 >> 2] = 0;
    HEAP32[i15 + 4 >> 2] = 0;
    HEAP32[i15 + 8 >> 2] = 0;
    HEAP32[i15 + 12 >> 2] = 0;
    if ((HEAP32[i8 >> 2] | 0) > 0) {
     i5 = HEAP32[i10 >> 2] | 0;
     i4 = 0;
     do {
      HEAP32[i5 + (i4 << 2) >> 2] = 0;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) < (HEAP32[i8 >> 2] | 0));
    }
    i5 = HEAP32[i12 >> 2] | 0;
    if ((i5 | 0) != (i11 | 0)) __ZN2cv8fastFreeEPv(i5);
    break;
   }
  case 7:
   {
    i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] & 127](i30) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    __ZNK2cv13AlgorithmInfo3getEPKNS_9AlgorithmEPKciPv(i2, i30, (i1 | 0) == 0 ? 39376 : i1, 2, i35);
    __ZN2cv5writeERNS_11FileStorageERKNS_6StringEd(i31, i3, +HEAPF64[i35 >> 3]);
    break;
   }
  case 5:
   {
    HEAP32[i27 >> 2] = 0;
    HEAP32[i16 >> 2] = 0;
    HEAP32[i17 >> 2] = 0;
    i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] & 127](i30) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    __ZNK2cv13AlgorithmInfo3getEPKNS_9AlgorithmEPKciPv(i5, i30, (i1 | 0) == 0 ? 39376 : i1, 5, i27);
    HEAP32[i23 >> 2] = 0;
    HEAP32[i18 >> 2] = 0;
    __ZN2cv8internal18WriteStructContextC2ERNS_11FileStorageERKNS_6StringEiS6_(i37, i31, i3, 5, i23);
    __ZN2cv6String10deallocateEv(i23);
    i1 = HEAP32[i16 >> 2] | 0;
    i5 = HEAP32[i27 >> 2] | 0;
    i3 = (i1 - i5 | 0) / 56 | 0;
    L34 : do if ((i1 | 0) != (i5 | 0)) {
     i4 = 0;
     while (1) {
      HEAP32[i35 >> 2] = 0;
      HEAP32[i19 >> 2] = 0;
      __ZN2cv5writeERNS_11FileStorageERKNS_6StringERKNS_3MatE(i31, i35, i5 + (i4 * 56 | 0) | 0);
      __ZN2cv6String10deallocateEv(i35);
      i4 = i4 + 1 | 0;
      if (i4 >>> 0 >= i3 >>> 0) break L34;
      i5 = HEAP32[i27 >> 2] | 0;
     }
    } while (0);
    __ZN2cv8internal18WriteStructContextD2Ev(i37);
    i5 = HEAP32[i27 >> 2] | 0;
    if (i5) {
     i4 = HEAP32[i16 >> 2] | 0;
     if ((i4 | 0) != (i5 | 0)) {
      do {
       i3 = i4 + -56 | 0;
       HEAP32[i16 >> 2] = i3;
       i2 = i4 + -20 | 0;
       i1 = HEAP32[i2 >> 2] | 0;
       if ((i1 | 0) != 0 ? (i39 = i1 + 12 | 0, i1 = HEAP32[i39 >> 2] | 0, HEAP32[i39 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
       HEAP32[i2 >> 2] = 0;
       i1 = i4 + -40 | 0;
       i3 = i4 + -52 | 0;
       HEAP32[i1 + 0 >> 2] = 0;
       HEAP32[i1 + 4 >> 2] = 0;
       HEAP32[i1 + 8 >> 2] = 0;
       HEAP32[i1 + 12 >> 2] = 0;
       if ((HEAP32[i3 >> 2] | 0) > 0) {
        i2 = HEAP32[i4 + -16 >> 2] | 0;
        i1 = 0;
        do {
         HEAP32[i2 + (i1 << 2) >> 2] = 0;
         i1 = i1 + 1 | 0;
        } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
       }
       i3 = HEAP32[i4 + -12 >> 2] | 0;
       if ((i3 | 0) != (i4 + -8 | 0)) __ZN2cv8fastFreeEPv(i3);
       i4 = HEAP32[i16 >> 2] | 0;
      } while ((i4 | 0) != (i5 | 0));
      i5 = HEAP32[i27 >> 2] | 0;
     }
     __ZdlPv(i5);
    }
    break;
   }
  case 11:
   {
    i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] & 127](i30) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    __ZNK2cv13AlgorithmInfo3getEPKNS_9AlgorithmEPKciPv(i2, i30, (i1 | 0) == 0 ? 39376 : i1, 0, i35);
    __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i31, i3, HEAP32[i35 >> 2] | 0);
    break;
   }
  case 2:
   {
    i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] & 127](i30) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    __ZNK2cv13AlgorithmInfo3getEPKNS_9AlgorithmEPKciPv(i2, i30, (i1 | 0) == 0 ? 39376 : i1, 2, i35);
    __ZN2cv5writeERNS_11FileStorageERKNS_6StringEd(i31, i3, +HEAPF64[i35 >> 3]);
    break;
   }
  default:
   {
    i2 = HEAP32[i3 >> 2] | 0;
    HEAP32[i35 >> 2] = (i2 | 0) == 0 ? 39376 : i2;
    HEAP32[i35 + 4 >> 2] = i5;
    __ZN2cv6formatEPKcz(i32, 37928, i35);
    i2 = HEAP32[i32 >> 2] | 0;
    i2 = (i2 | 0) == 0 ? 39376 : i2;
    HEAP32[i29 >> 2] = 0;
    HEAP32[i6 >> 2] = 0;
    i1 = _strlen(i2 | 0) | 0;
    _memcpy(__ZN2cv6String8allocateEj(i29, i1) | 0, i2 | 0, i1 | 0) | 0;
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-210, i29, 37984, 37992, 441);
    __ZN2cv6String10deallocateEv(i29);
    __ZN2cv6String10deallocateEv(i32);
   }
  } while (0);
  i22 = i22 + 1 | 0;
 } while (i22 >>> 0 < i24 >>> 0);
 STACKTOP = i38;
 return;
}

function __ZN2cv10checkRangeERKNS_11_InputArrayEbPNS_6Point_IiEEdd(i6, i25, i24, d16, d17) {
 i6 = i6 | 0;
 i25 = i25 | 0;
 i24 = i24 | 0;
 d16 = +d16;
 d17 = +d17;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 i26 = i29 + 8 | 0;
 i28 = i29 + 200 | 0;
 i8 = i29 + 192 | 0;
 i14 = i29 + 160 | 0;
 i12 = i29 + 136 | 0;
 i22 = i29 + 128 | 0;
 i23 = i29;
 i15 = i29 + 72 | 0;
 i21 = i29 + 64 | 0;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i6 >> 2] >> 2] & 63](i28, i6, -1);
 i27 = i28 + 4 | 0;
 i9 = HEAP32[i27 >> 2] | 0;
 if ((i9 | 0) > 2) {
  HEAP32[i8 >> 2] = i28;
  HEAP32[i8 + 4 >> 2] = 0;
  i5 = i26 + 56 | 0;
  HEAP32[i26 >> 2] = 1124007936;
  i6 = i26 + 8 | 0;
  i4 = i26 + 40 | 0;
  i3 = i26 + 4 | 0;
  i2 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  HEAP32[i4 >> 2] = i6;
  i6 = i26 + 48 | 0;
  HEAP32[i26 + 44 >> 2] = i6;
  HEAP32[i26 + 52 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPS1_i(i14, i8, i26, -1);
  i6 = i14 + 16 | 0;
  i4 = i14 + 4 | 0;
  i3 = i12 + 12 | 0;
  i2 = i12 + 16 | 0;
  i1 = i12 + 4 | 0;
  i8 = i12 + 8 | 0;
  i9 = 0;
  while (1) {
   if (i9 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) {
    i3 = 1;
    break;
   }
   i23 = HEAP32[i4 >> 2] | 0;
   HEAP32[i12 >> 2] = 32088;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i1 >> 2] = 16842752;
   HEAP32[i8 >> 2] = i23;
   if (!(__ZN2cv10checkRangeERKNS_11_InputArrayEbPNS_6Point_IiEEdd(i12, i25, i24, d16, d17) | 0)) {
    i3 = 0;
    break;
   }
   __ZN2cv15NAryMatIteratorppEv(i14) | 0;
   i9 = i9 + 1 | 0;
  }
  do {
   i6 = i5;
   i5 = i5 + -56 | 0;
   i2 = i6 + -20 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) != 0 ? (i22 = i1 + 12 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i5);
   HEAP32[i2 >> 2] = 0;
   i23 = i6 + -40 | 0;
   i2 = i6 + -52 | 0;
   HEAP32[i23 + 0 >> 2] = 0;
   HEAP32[i23 + 4 >> 2] = 0;
   HEAP32[i23 + 8 >> 2] = 0;
   HEAP32[i23 + 12 >> 2] = 0;
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    i1 = HEAP32[i6 + -16 >> 2] | 0;
    i4 = 0;
    do {
     HEAP32[i1 + (i4 << 2) >> 2] = 0;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) < (HEAP32[i2 >> 2] | 0));
   }
   i2 = HEAP32[i6 + -12 >> 2] | 0;
   if ((i2 | 0) != (i6 + -8 | 0)) __ZN2cv8fastFreeEPv(i2);
  } while ((i5 | 0) != (i26 | 0));
 } else {
  i8 = HEAP32[i28 >> 2] | 0;
  i5 = i8 & 7;
  HEAP32[i22 >> 2] = -1;
  i20 = i22 + 4 | 0;
  HEAP32[i20 >> 2] = -1;
  HEAPF64[i23 >> 3] = 0.0;
  L23 : do if (i5 >>> 0 < 5) {
   if (d16 < -2147483648.0) i1 = -2147483648; else {
    i1 = ~~d16;
    i1 = i1 - (+(i1 | 0) > d16 & 1) | 0;
   }
   if (d17 > 2147483647.0) i2 = 2147483647; else {
    i2 = ~~d17;
    i2 = i2 + -1 + (+(i2 | 0) < d17 & 1) | 0;
   }
   i6 = HEAP32[18432 + (i5 << 2) >> 2] | 0;
   HEAP32[i15 >> 2] = i8;
   i11 = i15 + 4 | 0;
   HEAP32[i11 >> 2] = i9;
   i12 = i15 + 8 | 0;
   HEAP32[i12 >> 2] = HEAP32[i28 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
   i5 = i15 + 16 | 0;
   HEAP32[i5 >> 2] = HEAP32[i28 + 16 >> 2];
   HEAP32[i15 + 20 >> 2] = HEAP32[i28 + 20 >> 2];
   HEAP32[i15 + 24 >> 2] = HEAP32[i28 + 24 >> 2];
   HEAP32[i15 + 28 >> 2] = HEAP32[i28 + 28 >> 2];
   HEAP32[i15 + 32 >> 2] = HEAP32[i28 + 32 >> 2];
   i4 = i15 + 36 | 0;
   i8 = HEAP32[i28 + 36 >> 2] | 0;
   HEAP32[i4 >> 2] = i8;
   i3 = i15 + 40 | 0;
   HEAP32[i3 >> 2] = i12;
   i12 = i15 + 48 | 0;
   i10 = i15 + 44 | 0;
   HEAP32[i10 >> 2] = i12;
   HEAP32[i15 + 52 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
   if (i8) {
    i9 = i8 + 12 | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
    i9 = HEAP32[i27 >> 2] | 0;
   }
   if ((i9 | 0) < 3) {
    i18 = HEAP32[i28 + 44 >> 2] | 0;
    i19 = HEAP32[i10 >> 2] | 0;
    HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   } else {
    HEAP32[i11 >> 2] = 0;
    __ZN2cv3Mat8copySizeERKS0_(i15, i28);
   }
   FUNCTION_TABLE_iiiiii[i6 & 31](i15, i22, i1, i2, i23) | 0;
   i6 = HEAP32[i4 >> 2] | 0;
   if ((i6 | 0) != 0 ? (i18 = i6 + 12 | 0, i19 = HEAP32[i18 >> 2] | 0, HEAP32[i18 >> 2] = i19 + -1, (i19 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i15);
   HEAP32[i4 >> 2] = 0;
   HEAP32[i5 + 0 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   if ((HEAP32[i11 >> 2] | 0) > 0) {
    i6 = HEAP32[i3 >> 2] | 0;
    i5 = 0;
    do {
     HEAP32[i6 + (i5 << 2) >> 2] = 0;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) < (HEAP32[i11 >> 2] | 0));
   }
   i4 = HEAP32[i10 >> 2] | 0;
   if ((i4 | 0) == (i12 | 0)) i6 = 52; else {
    __ZN2cv8fastFreeEPv(i4);
    i6 = 52;
   }
  } else {
   i6 = (i8 >>> 3 & 511) + 1 | 0;
   i19 = HEAP32[i28 + 12 >> 2] | 0;
   if (!(i8 & 16384)) {
    i18 = Math_imul(i6, i19) | 0;
    i3 = HEAP32[i28 + 8 >> 2] | 0;
   } else {
    i18 = Math_imul(Math_imul(i6, i19) | 0, HEAP32[i28 + 8 >> 2] | 0) | 0;
    i3 = 1;
   }
   i12 = HEAP32[i28 + 16 >> 2] | 0;
   i6 = HEAP32[i28 + 48 >> 2] | 0;
   if ((i5 | 0) == 5) {
    i14 = i6 >>> 2;
    f7 = Math_fround(d16);
    i6 = d16 < -3402823466385288598117041.0e14 ? -8388609 : (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
    f7 = Math_fround(d17);
    i10 = d17 > 3402823466385288598117041.0e14 ? 2139095039 : (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = i6 >> 31 & 2147483647 ^ i6;
    i10 = i10 >> 31 & 2147483647 ^ i10;
    i11 = (i18 | 0) > 0;
    i1 = -1;
    i5 = i12;
    i4 = 0;
    while (1) {
     if (!i3) {
      i6 = 52;
      break L23;
     }
     i3 = i3 + -1 | 0;
     L58 : do if (i11) {
      i6 = 0;
      while (1) {
       i8 = HEAP32[i5 + (i6 << 2) >> 2] | 0;
       i15 = i8 >> 31 & 2147483647 ^ i8;
       i9 = i6 + 1 | 0;
       if (!((i15 | 0) >= (i2 | 0) & (i15 | 0) < (i10 | 0))) break;
       if ((i9 | 0) < (i18 | 0)) i6 = i9; else break L58;
      }
      f7 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i15 = i6 + i4 | 0;
      i1 = (i15 | 0) % (i19 | 0) | 0;
      HEAP32[i22 >> 2] = i1;
      HEAP32[i20 >> 2] = (i15 | 0) / (i19 | 0) | 0;
      HEAPF64[i23 >> 3] = +f7;
     } while (0);
     if ((i1 | 0) >= 0) {
      i6 = 53;
      break;
     } else {
      i5 = i5 + (i14 << 2) | 0;
      i4 = i4 + i18 | 0;
     }
    }
   } else {
    i15 = i6 >>> 3;
    HEAPF64[tempDoublePtr >> 3] = d16;
    i4 = HEAP32[tempDoublePtr >> 2] | 0;
    i5 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
    HEAPF64[tempDoublePtr >> 3] = d17;
    i6 = HEAP32[tempDoublePtr >> 2] | 0;
    i13 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
    i14 = _bitshift64Ashr(i4 | 0, i5 | 0, 63) | 0;
    i4 = i14 ^ i4;
    i5 = tempRet0 & 2147483647 ^ i5;
    i14 = _bitshift64Ashr(i6 | 0, i13 | 0, 63) | 0;
    i6 = i14 ^ i6;
    i13 = tempRet0 & 2147483647 ^ i13;
    i14 = (i18 | 0) > 0;
    i1 = -1;
    i2 = 0;
    while (1) {
     if (!i3) {
      i6 = 52;
      break L23;
     }
     i3 = i3 + -1 | 0;
     L68 : do if (i14) {
      i8 = 0;
      while (1) {
       i9 = i12 + (i8 << 3) | 0;
       i10 = HEAP32[i9 >> 2] | 0;
       i9 = HEAP32[i9 + 4 >> 2] | 0;
       i30 = _bitshift64Ashr(i10 | 0, i9 | 0, 63) | 0;
       i30 = i30 ^ i10;
       i31 = tempRet0 & 2147483647 ^ i9;
       i11 = i8 + 1 | 0;
       if (!(((i31 | 0) > (i5 | 0) | (i31 | 0) == (i5 | 0) & i30 >>> 0 >= i4 >>> 0) & ((i31 | 0) < (i13 | 0) | (i31 | 0) == (i13 | 0) & i30 >>> 0 < i6 >>> 0))) break;
       if ((i11 | 0) < (i18 | 0)) i8 = i11; else break L68;
      }
      HEAP32[tempDoublePtr >> 2] = i10;
      HEAP32[tempDoublePtr + 4 >> 2] = i9;
      d16 = +HEAPF64[tempDoublePtr >> 3];
      i8 = i8 + i2 | 0;
      i1 = (i8 | 0) % (i19 | 0) | 0;
      HEAP32[i22 >> 2] = i1;
      HEAP32[i20 >> 2] = (i8 | 0) / (i19 | 0) | 0;
      HEAPF64[i23 >> 3] = d16;
     } while (0);
     if ((i1 | 0) >= 0) {
      i6 = 53;
      break;
     } else {
      i12 = i12 + (i15 << 3) | 0;
      i2 = i2 + i18 | 0;
     }
    }
   }
  } while (0);
  if ((i6 | 0) == 52) {
   i1 = HEAP32[i22 >> 2] | 0;
   if ((i1 | 0) > -1) i6 = 53;
  }
  if ((i6 | 0) == 53) {
   if (i24) {
    HEAP32[i24 >> 2] = i1;
    HEAP32[i24 + 4 >> 2] = HEAP32[i20 >> 2];
   }
   if (!i25) {
    i20 = HEAP32[i20 >> 2] | 0;
    d16 = +HEAPF64[i23 >> 3];
    HEAP32[i26 >> 2] = i1;
    HEAP32[i26 + 4 >> 2] = i20;
    i1 = i26 + 8 | 0;
    HEAPF64[tempDoublePtr >> 3] = d16;
    HEAP32[i1 >> 2] = HEAP32[tempDoublePtr >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
    __ZN2cv6formatEPKcz(i21, 18456, i26);
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i21, 18504, 18368, 2867);
    __ZN2cv6String10deallocateEv(i21);
    i1 = HEAP32[i22 >> 2] | 0;
   }
  }
  i3 = (i1 | 0) < 0;
 }
 i1 = i28 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i22 = i2 + 12 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i28);
 HEAP32[i1 >> 2] = 0;
 i23 = i28 + 16 | 0;
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 if ((HEAP32[i27 >> 2] | 0) > 0) {
  i2 = HEAP32[i28 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i27 >> 2] | 0));
 }
 i1 = HEAP32[i28 + 44 >> 2] | 0;
 if ((i1 | 0) == (i28 + 48 | 0)) {
  STACKTOP = i29;
  return i3 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i29;
 return i3 | 0;
}

function _deflate_slow(i35, i29) {
 i35 = i35 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0;
 i36 = STACKTOP;
 i7 = i35 + 116 | 0;
 i8 = (i29 | 0) == 0;
 i18 = i35 + 72 | 0;
 i23 = i35 + 88 | 0;
 i32 = i35 + 108 | 0;
 i30 = i35 + 56 | 0;
 i24 = i35 + 84 | 0;
 i25 = i35 + 68 | 0;
 i26 = i35 + 52 | 0;
 i27 = i35 + 64 | 0;
 i9 = i35 + 96 | 0;
 i10 = i35 + 120 | 0;
 i11 = i35 + 112 | 0;
 i12 = i35 + 100 | 0;
 i28 = i35 + 5792 | 0;
 i13 = i35 + 5796 | 0;
 i14 = i35 + 5784 | 0;
 i16 = i35 + 5788 | 0;
 i17 = i35 + 104 | 0;
 i31 = i35 + 92 | 0;
 i19 = i35 + 128 | 0;
 i20 = i35 + 44 | 0;
 i21 = i35 + 136 | 0;
 L1 : while (1) {
  i5 = HEAP32[i7 >> 2] | 0;
  while (1) {
   if (i5 >>> 0 < 262) {
    _fill_window(i35);
    i5 = HEAP32[i7 >> 2] | 0;
    if (i5 >>> 0 < 262 & i8) {
     i1 = 0;
     i3 = 57;
     break L1;
    }
    if (!i5) {
     i3 = 40;
     break L1;
    }
    if (i5 >>> 0 <= 2) {
     HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i9 >> 2] = 2;
     i5 = 2;
     i3 = 16;
    } else i3 = 8;
   } else i3 = 8;
   do if ((i3 | 0) == 8) {
    i3 = 0;
    i2 = HEAP32[i32 >> 2] | 0;
    i4 = ((HEAPU8[(HEAP32[i30 >> 2] | 0) + (i2 + 2) >> 0] | 0) ^ HEAP32[i18 >> 2] << HEAP32[i23 >> 2]) & HEAP32[i24 >> 2];
    HEAP32[i18 >> 2] = i4;
    i4 = (HEAP32[i25 >> 2] | 0) + (i4 << 1) | 0;
    i1 = HEAP16[i4 >> 1] | 0;
    HEAP16[(HEAP32[i27 >> 2] | 0) + ((HEAP32[i26 >> 2] & i2) << 1) >> 1] = i1;
    i5 = i1 & 65535;
    HEAP16[i4 >> 1] = i2;
    i4 = HEAP32[i9 >> 2] | 0;
    HEAP32[i10 >> 2] = i4;
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i9 >> 2] = 2;
    if (i1 << 16 >> 16) if (i4 >>> 0 < (HEAP32[i19 >> 2] | 0) >>> 0) if (((HEAP32[i32 >> 2] | 0) - i5 | 0) >>> 0 <= ((HEAP32[i20 >> 2] | 0) + -262 | 0) >>> 0) {
     i5 = _longest_match(i35, i5) | 0;
     HEAP32[i9 >> 2] = i5;
     if (i5 >>> 0 < 6) {
      if ((HEAP32[i21 >> 2] | 0) != 1) {
       if ((i5 | 0) != 3) {
        i3 = 16;
        break;
       }
       if (((HEAP32[i32 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0) >>> 0 <= 4096) {
        i5 = 3;
        i3 = 16;
        break;
       }
      }
      HEAP32[i9 >> 2] = 2;
      i5 = 2;
      i3 = 16;
     } else i3 = 16;
    } else {
     i5 = 2;
     i3 = 16;
    } else i5 = 2; else {
     i5 = 2;
     i3 = 16;
    }
   } while (0);
   if ((i3 | 0) == 16) i4 = HEAP32[i10 >> 2] | 0;
   if (!(i4 >>> 0 < 3 | i5 >>> 0 > i4 >>> 0)) break;
   if (!(HEAP32[i17 >> 2] | 0)) {
    HEAP32[i17 >> 2] = 1;
    HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
    i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
    HEAP32[i7 >> 2] = i5;
    continue;
   }
   i1 = HEAP8[(HEAP32[i30 >> 2] | 0) + ((HEAP32[i32 >> 2] | 0) + -1) >> 0] | 0;
   i2 = HEAP32[i28 >> 2] | 0;
   HEAP16[(HEAP32[i13 >> 2] | 0) + (i2 << 1) >> 1] = 0;
   HEAP32[i28 >> 2] = i2 + 1;
   HEAP8[(HEAP32[i14 >> 2] | 0) + i2 >> 0] = i1;
   i1 = i35 + ((i1 & 255) << 2) + 148 | 0;
   HEAP16[i1 >> 1] = (HEAP16[i1 >> 1] | 0) + 1 << 16 >> 16;
   if ((HEAP32[i28 >> 2] | 0) == ((HEAP32[i16 >> 2] | 0) + -1 | 0)) {
    i5 = HEAP32[i31 >> 2] | 0;
    if ((i5 | 0) > -1) i4 = (HEAP32[i30 >> 2] | 0) + i5 | 0; else i4 = 0;
    __tr_flush_block(i35, i4, (HEAP32[i32 >> 2] | 0) - i5 | 0, 0);
    HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
    i4 = HEAP32[i35 >> 2] | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    __tr_flush_bits(i3);
    i2 = i3 + 20 | 0;
    i5 = HEAP32[i2 >> 2] | 0;
    i1 = i4 + 16 | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    i5 = i5 >>> 0 > i6 >>> 0 ? i6 : i5;
    if ((i5 | 0) != 0 ? (i6 = i4 + 12 | 0, i22 = i3 + 16 | 0, _memcpy(HEAP32[i6 >> 2] | 0, HEAP32[i22 >> 2] | 0, i5 | 0) | 0, HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i5, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i5, i4 = i4 + 20 | 0, HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i5, HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - i5, i1 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i1 - i5, (i1 | 0) == (i5 | 0)) : 0) HEAP32[i22 >> 2] = HEAP32[i3 + 8 >> 2];
   }
   HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
   i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
   HEAP32[i7 >> 2] = i5;
   if (!(HEAP32[(HEAP32[i35 >> 2] | 0) + 16 >> 2] | 0)) {
    i1 = 0;
    i3 = 57;
    break L1;
   }
  }
  i5 = HEAP32[i32 >> 2] | 0;
  i6 = i5 + -3 + (HEAP32[i7 >> 2] | 0) | 0;
  i1 = i4 + 253 | 0;
  i5 = i5 + 65535 - (HEAP32[i12 >> 2] | 0) | 0;
  i2 = HEAP32[i28 >> 2] | 0;
  HEAP16[(HEAP32[i13 >> 2] | 0) + (i2 << 1) >> 1] = i5;
  HEAP32[i28 >> 2] = i2 + 1;
  HEAP8[(HEAP32[i14 >> 2] | 0) + i2 >> 0] = i1;
  i1 = i35 + ((HEAPU8[155648 + (i1 & 255) >> 0] | 0 | 256) + 1 << 2) + 148 | 0;
  HEAP16[i1 >> 1] = (HEAP16[i1 >> 1] | 0) + 1 << 16 >> 16;
  i5 = i5 + 65535 & 65535;
  if (i5 >>> 0 >= 256) i5 = (i5 >>> 7) + 256 | 0;
  i2 = i35 + ((HEAPU8[155136 + i5 >> 0] | 0) << 2) + 2440 | 0;
  HEAP16[i2 >> 1] = (HEAP16[i2 >> 1] | 0) + 1 << 16 >> 16;
  i2 = HEAP32[i28 >> 2] | 0;
  i1 = (HEAP32[i16 >> 2] | 0) + -1 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 1 - i3 + (HEAP32[i7 >> 2] | 0);
  i3 = i3 + -2 | 0;
  HEAP32[i10 >> 2] = i3;
  i4 = HEAP32[i32 >> 2] | 0;
  while (1) {
   i5 = i4 + 1 | 0;
   HEAP32[i32 >> 2] = i5;
   if (i5 >>> 0 <= i6 >>> 0) {
    i37 = ((HEAPU8[(HEAP32[i30 >> 2] | 0) + (i4 + 3) >> 0] | 0) ^ HEAP32[i18 >> 2] << HEAP32[i23 >> 2]) & HEAP32[i24 >> 2];
    HEAP32[i18 >> 2] = i37;
    i37 = (HEAP32[i25 >> 2] | 0) + (i37 << 1) | 0;
    HEAP16[(HEAP32[i27 >> 2] | 0) + ((HEAP32[i26 >> 2] & i5) << 1) >> 1] = HEAP16[i37 >> 1] | 0;
    HEAP16[i37 >> 1] = i5;
   }
   i3 = i3 + -1 | 0;
   HEAP32[i10 >> 2] = i3;
   if (!i3) break; else i4 = i5;
  }
  HEAP32[i17 >> 2] = 0;
  HEAP32[i9 >> 2] = 2;
  i3 = i4 + 2 | 0;
  HEAP32[i32 >> 2] = i3;
  if ((i2 | 0) != (i1 | 0)) continue;
  i5 = HEAP32[i31 >> 2] | 0;
  if ((i5 | 0) > -1) i4 = (HEAP32[i30 >> 2] | 0) + i5 | 0; else i4 = 0;
  __tr_flush_block(i35, i4, i3 - i5 | 0, 0);
  HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
  i4 = HEAP32[i35 >> 2] | 0;
  i3 = HEAP32[i4 + 28 >> 2] | 0;
  __tr_flush_bits(i3);
  i2 = i3 + 20 | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  i1 = i4 + 16 | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = i5 >>> 0 > i6 >>> 0 ? i6 : i5;
  if ((i5 | 0) != 0 ? (i6 = i4 + 12 | 0, i15 = i3 + 16 | 0, _memcpy(HEAP32[i6 >> 2] | 0, HEAP32[i15 >> 2] | 0, i5 | 0) | 0, HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i5, HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + i5, i4 = i4 + 20 | 0, HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i5, HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - i5, i1 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i1 - i5, (i1 | 0) == (i5 | 0)) : 0) HEAP32[i15 >> 2] = HEAP32[i3 + 8 >> 2];
  if (!(HEAP32[(HEAP32[i35 >> 2] | 0) + 16 >> 2] | 0)) {
   i1 = 0;
   i3 = 57;
   break;
  }
 }
 if ((i3 | 0) == 40) {
  if (HEAP32[i17 >> 2] | 0) {
   i22 = HEAP8[(HEAP32[i30 >> 2] | 0) + ((HEAP32[i32 >> 2] | 0) + -1) >> 0] | 0;
   i21 = HEAP32[i28 >> 2] | 0;
   HEAP16[(HEAP32[i13 >> 2] | 0) + (i21 << 1) >> 1] = 0;
   HEAP32[i28 >> 2] = i21 + 1;
   HEAP8[(HEAP32[i14 >> 2] | 0) + i21 >> 0] = i22;
   i22 = i35 + ((i22 & 255) << 2) + 148 | 0;
   HEAP16[i22 >> 1] = (HEAP16[i22 >> 1] | 0) + 1 << 16 >> 16;
   HEAP32[i17 >> 2] = 0;
  }
  i3 = HEAP32[i32 >> 2] | 0;
  HEAP32[i35 + 5812 >> 2] = i3 >>> 0 < 2 ? i3 : 2;
  if ((i29 | 0) == 4) {
   i5 = HEAP32[i31 >> 2] | 0;
   if ((i5 | 0) > -1) i1 = (HEAP32[i30 >> 2] | 0) + i5 | 0; else i1 = 0;
   __tr_flush_block(i35, i1, i3 - i5 | 0, 1);
   HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
   i2 = HEAP32[i35 >> 2] | 0;
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   __tr_flush_bits(i3);
   i4 = i3 + 20 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i5 = i2 + 16 | 0;
   i22 = HEAP32[i5 >> 2] | 0;
   i1 = i1 >>> 0 > i22 >>> 0 ? i22 : i1;
   if ((i1 | 0) != 0 ? (i22 = i2 + 12 | 0, i33 = i3 + 16 | 0, _memcpy(HEAP32[i22 >> 2] | 0, HEAP32[i33 >> 2] | 0, i1 | 0) | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i1, HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + i1, i22 = i2 + 20 | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i1, HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i1, i22 = HEAP32[i4 >> 2] | 0, HEAP32[i4 >> 2] = i22 - i1, (i22 | 0) == (i1 | 0)) : 0) HEAP32[i33 >> 2] = HEAP32[i3 + 8 >> 2];
   i22 = (HEAP32[(HEAP32[i35 >> 2] | 0) + 16 >> 2] | 0) == 0 ? 2 : 3;
   STACKTOP = i36;
   return i22 | 0;
  }
  if (HEAP32[i28 >> 2] | 0) {
   i4 = HEAP32[i31 >> 2] | 0;
   if ((i4 | 0) > -1) i5 = (HEAP32[i30 >> 2] | 0) + i4 | 0; else i5 = 0;
   __tr_flush_block(i35, i5, i3 - i4 | 0, 0);
   HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
   i5 = HEAP32[i35 >> 2] | 0;
   i4 = HEAP32[i5 + 28 >> 2] | 0;
   __tr_flush_bits(i4);
   i3 = i4 + 20 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = i5 + 16 | 0;
   i22 = HEAP32[i2 >> 2] | 0;
   i1 = i1 >>> 0 > i22 >>> 0 ? i22 : i1;
   if ((i1 | 0) != 0 ? (i22 = i5 + 12 | 0, i34 = i4 + 16 | 0, _memcpy(HEAP32[i22 >> 2] | 0, HEAP32[i34 >> 2] | 0, i1 | 0) | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i1, HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i1, i22 = i5 + 20 | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i1, HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - i1, i22 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i22 - i1, (i22 | 0) == (i1 | 0)) : 0) HEAP32[i34 >> 2] = HEAP32[i4 + 8 >> 2];
   if (!(HEAP32[(HEAP32[i35 >> 2] | 0) + 16 >> 2] | 0)) {
    i22 = 0;
    STACKTOP = i36;
    return i22 | 0;
   }
  }
  i22 = 1;
  STACKTOP = i36;
  return i22 | 0;
 } else if ((i3 | 0) == 57) {
  STACKTOP = i36;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cv14JacobiSVDImpl_IdEEvPT_jS2_S2_jiiidS1_(i31, i1, i26, i25, i3, i33, i35, i36, d34, d22) {
 i31 = i31 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 i25 = i25 | 0;
 i3 = i3 | 0;
 i33 = i33 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 d34 = +d34;
 d22 = +d22;
 var d2 = 0.0, i4 = 0, i5 = 0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d12 = 0.0, d13 = 0.0, d14 = 0.0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i37 = 0, d38 = 0.0, i39 = 0, d40 = 0.0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 i32 = i37;
 i28 = i32 + 8 | 0;
 HEAP32[i32 >> 2] = i28;
 i29 = i32 + 4 | 0;
 HEAP32[i29 >> 2] = 136;
 if (i35 >>> 0 > 136) {
  i30 = __Znaj(i35 >>> 0 > 536870911 ? -1 : i35 << 3) | 0;
  HEAP32[i32 >> 2] = i30;
 } else i30 = i28;
 HEAP32[i29 >> 2] = i35;
 i20 = (i33 | 0) < 30 ? 30 : i33;
 i27 = i1 >>> 3;
 i23 = i3 >>> 3;
 i24 = (i35 | 0) > 0;
 if (i24) {
  i4 = (i33 | 0) > 0;
  i3 = (i25 | 0) == 0;
  i1 = i35 << 3;
  i9 = 0;
  do {
   i8 = Math_imul(i23, i9) | 0;
   i10 = i25 + (i8 << 3) | 0;
   if (i4) {
    i7 = Math_imul(i9, i27) | 0;
    i5 = 0;
    d2 = 0.0;
    do {
     d13 = +HEAPF64[i31 + (i5 + i7 << 3) >> 3];
     d2 = d2 + d13 * d13;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i33 | 0));
   } else d2 = 0.0;
   HEAPF64[i30 + (i9 << 3) >> 3] = d2;
   if (!i3) {
    _memset(i10 | 0, 0, i1 | 0) | 0;
    HEAPF64[i25 + (i8 + i9 << 3) >> 3] = 1.0;
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i35 | 0));
 }
 L17 : do if ((i20 | 0) > 0) {
  i1 = i35 + -1 | 0;
  i15 = (i1 | 0) > 0;
  i16 = (i33 | 0) > 0;
  i17 = (i25 | 0) == 0;
  i19 = 0;
  do {
   if (i15) {
    i5 = 0;
    i18 = 0;
   } else break L17;
   do {
    i7 = i18;
    i18 = i18 + 1 | 0;
    if ((i18 | 0) < (i35 | 0)) {
     i4 = Math_imul(i7, i27) | 0;
     i3 = i30 + (i7 << 3) | 0;
     i7 = Math_imul(i7, i23) | 0;
     i8 = i18;
     do {
      i10 = Math_imul(i8, i27) | 0;
      d12 = +HEAPF64[i3 >> 3];
      i9 = i30 + (i8 << 3) | 0;
      d2 = +HEAPF64[i9 >> 3];
      if (i16) {
       i11 = 0;
       d6 = 0.0;
       do {
        d6 = d6 + +HEAPF64[i31 + (i11 + i4 << 3) >> 3] * +HEAPF64[i31 + (i11 + i10 << 3) >> 3];
        i11 = i11 + 1 | 0;
       } while ((i11 | 0) != (i33 | 0));
      } else d6 = 0.0;
      if (!(+Math_abs(+d6) <= +Math_sqrt(+(d12 * d2)) * d22)) {
       d13 = d6 * 2.0;
       d12 = d12 - d2;
       d6 = +Math_abs(+d13);
       d2 = +Math_abs(+d12);
       if (!(d6 > d2)) if (d12 != d12 | 0.0 != 0.0 | d12 == 0.0) d6 = 0.0; else {
        d6 = d6 / d2;
        d6 = d2 * +Math_sqrt(+(d6 * d6 + 1.0));
       } else {
        d2 = d2 / d6;
        d6 = d6 * +Math_sqrt(+(d2 * d2 + 1.0));
       }
       if (d12 < 0.0) {
        d12 = +Math_sqrt(+((d6 - d12) * .5 / d6));
        d14 = d13 / (d6 * d12 * 2.0);
       } else {
        d12 = +Math_sqrt(+((d12 + d6) / (d6 * 2.0)));
        d14 = d12;
        d12 = d13 / (d6 * d12 * 2.0);
       }
       if (i16) {
        d2 = 0.0;
        d6 = 0.0;
        i11 = 0;
        do {
         i39 = i31 + (i11 + i4 << 3) | 0;
         d13 = +HEAPF64[i39 >> 3];
         i5 = i31 + (i11 + i10 << 3) | 0;
         d40 = +HEAPF64[i5 >> 3];
         d38 = d14 * d13 + d12 * d40;
         d13 = d14 * d40 - d12 * d13;
         HEAPF64[i39 >> 3] = d38;
         HEAPF64[i5 >> 3] = d13;
         d2 = d2 + d38 * d38;
         d6 = d6 + d13 * d13;
         i11 = i11 + 1 | 0;
        } while ((i11 | 0) != (i33 | 0));
       } else {
        d2 = 0.0;
        d6 = 0.0;
       }
       HEAPF64[i3 >> 3] = d2;
       HEAPF64[i9 >> 3] = d6;
       if (!i17 ? (i21 = Math_imul(i8, i23) | 0, i24) : 0) {
        i11 = 0;
        do {
         i9 = i25 + (i11 + i7 << 3) | 0;
         d2 = +HEAPF64[i9 >> 3];
         i5 = i25 + (i11 + i21 << 3) | 0;
         d13 = +HEAPF64[i5 >> 3];
         HEAPF64[i9 >> 3] = d14 * d2 + d12 * d13;
         HEAPF64[i5 >> 3] = d14 * d13 - d12 * d2;
         i11 = i11 + 1 | 0;
        } while ((i11 | 0) != (i35 | 0));
        i5 = 1;
       } else i5 = 1;
      }
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) != (i35 | 0));
    }
   } while ((i18 | 0) != (i1 | 0));
   i19 = i19 + 1 | 0;
  } while (i5 & (i19 | 0) < (i20 | 0));
 } while (0);
 if (i24) {
  i3 = (i33 | 0) > 0;
  i1 = 0;
  do {
   if (i3) {
    i5 = Math_imul(i1, i27) | 0;
    i4 = 0;
    d2 = 0.0;
    do {
     d13 = +HEAPF64[i31 + (i4 + i5 << 3) >> 3];
     d2 = d2 + d13 * d13;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i33 | 0));
   } else d2 = 0.0;
   HEAPF64[i30 + (i1 << 3) >> 3] = +Math_sqrt(+d2);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i35 | 0));
 }
 i10 = i35 + -1 | 0;
 if ((i10 | 0) > 0) {
  i9 = (i25 | 0) == 0;
  i8 = (i33 | 0) > 0;
  i11 = 0;
  do {
   i7 = i11;
   i11 = i11 + 1 | 0;
   if ((i11 | 0) < (i35 | 0)) {
    i5 = i7;
    i4 = i11;
    do {
     i5 = +HEAPF64[i30 + (i5 << 3) >> 3] < +HEAPF64[i30 + (i4 << 3) >> 3] ? i4 : i5;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i35 | 0));
   } else i5 = i7;
   if ((i7 | 0) != (i5 | 0) ? (i20 = i30 + (i7 << 3) | 0, i21 = i30 + (i5 << 3) | 0, d2 = +HEAPF64[i20 >> 3], HEAPF64[i20 >> 3] = +HEAPF64[i21 >> 3], HEAPF64[i21 >> 3] = d2, !i9) : 0) {
    if (i8) {
     i4 = Math_imul(i7, i27) | 0;
     i3 = Math_imul(i5, i27) | 0;
     i1 = 0;
     do {
      i20 = i31 + (i1 + i4 << 3) | 0;
      i21 = i31 + (i1 + i3 << 3) | 0;
      d2 = +HEAPF64[i20 >> 3];
      HEAPF64[i20 >> 3] = +HEAPF64[i21 >> 3];
      HEAPF64[i21 >> 3] = d2;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i33 | 0));
    }
    if (i24) {
     i3 = Math_imul(i7, i23) | 0;
     i5 = Math_imul(i5, i23) | 0;
     i4 = 0;
     do {
      i20 = i25 + (i4 + i3 << 3) | 0;
      i21 = i25 + (i4 + i5 << 3) | 0;
      d2 = +HEAPF64[i20 >> 3];
      HEAPF64[i20 >> 3] = +HEAPF64[i21 >> 3];
      HEAPF64[i21 >> 3] = d2;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i35 | 0));
    }
   }
  } while ((i11 | 0) != (i10 | 0));
 }
 if (i24) {
  i1 = 0;
  do {
   HEAPF64[i26 + (i1 << 3) >> 3] = +HEAPF64[i30 + (i1 << 3) >> 3];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i35 | 0));
 }
 if ((i25 | 0) != 0 & (i36 | 0) > 0) {
  i19 = (i33 | 0) > 0;
  d14 = 1.0 / +(i33 | 0);
  d12 = -d14;
  i1 = 305419896;
  i3 = 0;
  i18 = 0;
  do {
   if ((i18 | 0) < (i35 | 0)) d2 = +HEAPF64[i30 + (i18 << 3) >> 3]; else d2 = 0.0;
   if (d2 <= d34) {
    i11 = (i18 | 0) > 0;
    i10 = Math_imul(i18, i27) | 0;
    do {
     if (i19) {
      i5 = 0;
      do {
       i1 = ___muldi3(i1 | 0, 0, -130063606, 0) | 0;
       i1 = _i64Add(i1 | 0, tempRet0 | 0, i3 | 0, 0) | 0;
       i3 = tempRet0;
       HEAPF64[i31 + (i5 + i10 << 3) >> 3] = (i1 & 256 | 0) == 0 & 0 == 0 ? d12 : d14;
       i5 = i5 + 1 | 0;
      } while ((i5 | 0) != (i33 | 0));
     }
     if (i11) {
      i7 = 0;
      do {
       do if (i19) {
        i5 = Math_imul(i7, i27) | 0;
        i4 = 0;
        d6 = 0.0;
        do {
         d6 = d6 + +HEAPF64[i31 + (i4 + i10 << 3) >> 3] * +HEAPF64[i31 + (i4 + i5 << 3) >> 3];
         i4 = i4 + 1 | 0;
        } while ((i4 | 0) != (i33 | 0));
        if (i19) {
         i5 = Math_imul(i7, i27) | 0;
         d2 = 0.0;
         i4 = 0;
         do {
          i25 = i31 + (i4 + i10 << 3) | 0;
          d13 = +HEAPF64[i25 >> 3] - d6 * +HEAPF64[i31 + (i4 + i5 << 3) >> 3];
          HEAPF64[i25 >> 3] = d13;
          d2 = d2 + +Math_abs(+d13);
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) != (i33 | 0));
         if (d2 != 0.0) d2 = 1.0 / d2; else d2 = 0.0;
         if (i19) i5 = 0; else break;
         do {
          i25 = i31 + (i5 + i10 << 3) | 0;
          HEAPF64[i25 >> 3] = d2 * +HEAPF64[i25 >> 3];
          i5 = i5 + 1 | 0;
         } while ((i5 | 0) != (i33 | 0));
        }
       } while (0);
       i7 = i7 + 1 | 0;
      } while ((i7 | 0) != (i18 | 0));
      if (i11) {
       i7 = 0;
       do {
        do if (i19) {
         i5 = Math_imul(i7, i27) | 0;
         i4 = 0;
         d6 = 0.0;
         do {
          d6 = d6 + +HEAPF64[i31 + (i4 + i10 << 3) >> 3] * +HEAPF64[i31 + (i4 + i5 << 3) >> 3];
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) != (i33 | 0));
         if (!i19) break;
         i5 = Math_imul(i7, i27) | 0;
         d2 = 0.0;
         i4 = 0;
         do {
          i25 = i31 + (i4 + i10 << 3) | 0;
          d13 = +HEAPF64[i25 >> 3] - d6 * +HEAPF64[i31 + (i4 + i5 << 3) >> 3];
          HEAPF64[i25 >> 3] = d13;
          d2 = d2 + +Math_abs(+d13);
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) != (i33 | 0));
         if (d2 != 0.0) d2 = 1.0 / d2; else d2 = 0.0;
         if (i19) i5 = 0; else break;
         do {
          i25 = i31 + (i5 + i10 << 3) | 0;
          HEAPF64[i25 >> 3] = d2 * +HEAPF64[i25 >> 3];
          i5 = i5 + 1 | 0;
         } while ((i5 | 0) != (i33 | 0));
        } while (0);
        i7 = i7 + 1 | 0;
       } while ((i7 | 0) != (i18 | 0));
      }
     }
     if (i19) {
      i5 = 0;
      d2 = 0.0;
      do {
       d13 = +HEAPF64[i31 + (i5 + i10 << 3) >> 3];
       d2 = d2 + d13 * d13;
       i5 = i5 + 1 | 0;
      } while ((i5 | 0) != (i33 | 0));
     } else d2 = 0.0;
     d2 = +Math_sqrt(+d2);
    } while (d2 <= d34);
   }
   d2 = 1.0 / d2;
   if (i19) {
    i4 = Math_imul(i18, i27) | 0;
    i5 = 0;
    do {
     i25 = i31 + (i5 + i4 << 3) | 0;
     HEAPF64[i25 >> 3] = d2 * +HEAPF64[i25 >> 3];
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i33 | 0));
   }
   i18 = i18 + 1 | 0;
  } while ((i18 | 0) != (i36 | 0));
 }
 if ((i30 | 0) == (i28 | 0)) {
  STACKTOP = i37;
  return;
 }
 __ZdaPv(i30);
 HEAP32[i32 >> 2] = i28;
 HEAP32[i29 >> 2] = 136;
 STACKTOP = i37;
 return;
}

function _dispose_chunk(i14, i15) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 i16 = i14 + i15 | 0;
 i5 = HEAP32[i14 + 4 >> 2] | 0;
 do if (!(i5 & 1)) {
  i7 = HEAP32[i14 >> 2] | 0;
  if (!(i5 & 3)) {
   STACKTOP = i20;
   return;
  }
  i11 = i14 + (0 - i7) | 0;
  i10 = i7 + i15 | 0;
  i6 = HEAP32[242538] | 0;
  if (i11 >>> 0 < i6 >>> 0) _abort();
  if ((i11 | 0) == (HEAP32[242539] | 0)) {
   i4 = i14 + (i15 + 4) | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 & 3 | 0) != 3) {
    i19 = i11;
    i9 = i10;
    break;
   }
   HEAP32[242536] = i10;
   HEAP32[i4 >> 2] = i5 & -2;
   HEAP32[i14 + (4 - i7) >> 2] = i10 | 1;
   HEAP32[i16 >> 2] = i10;
   STACKTOP = i20;
   return;
  }
  i2 = i7 >>> 3;
  if (i7 >>> 0 < 256) {
   i3 = HEAP32[i14 + (8 - i7) >> 2] | 0;
   i4 = HEAP32[i14 + (12 - i7) >> 2] | 0;
   i5 = 970176 + (i2 << 1 << 2) | 0;
   if ((i3 | 0) != (i5 | 0)) {
    if (i3 >>> 0 < i6 >>> 0) _abort();
    if ((HEAP32[i3 + 12 >> 2] | 0) != (i11 | 0)) _abort();
   }
   if ((i4 | 0) == (i3 | 0)) {
    HEAP32[242534] = HEAP32[242534] & ~(1 << i2);
    i19 = i11;
    i9 = i10;
    break;
   }
   if ((i4 | 0) != (i5 | 0)) {
    if (i4 >>> 0 < i6 >>> 0) _abort();
    i5 = i4 + 8 | 0;
    if ((HEAP32[i5 >> 2] | 0) == (i11 | 0)) i1 = i5; else _abort();
   } else i1 = i4 + 8 | 0;
   HEAP32[i3 + 12 >> 2] = i4;
   HEAP32[i1 >> 2] = i3;
   i19 = i11;
   i9 = i10;
   break;
  }
  i1 = HEAP32[i14 + (24 - i7) >> 2] | 0;
  i3 = HEAP32[i14 + (12 - i7) >> 2] | 0;
  do if ((i3 | 0) == (i11 | 0)) {
   i4 = 16 - i7 | 0;
   i3 = i14 + (i4 + 4) | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   if (!i5) {
    i4 = i14 + i4 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if (!i5) {
     i8 = 0;
     break;
    }
   } else i4 = i3;
   while (1) {
    i3 = i5 + 20 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2) {
     i5 = i2;
     i4 = i3;
     continue;
    }
    i3 = i5 + 16 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) break; else {
     i5 = i2;
     i4 = i3;
    }
   }
   if (i4 >>> 0 < i6 >>> 0) _abort(); else {
    HEAP32[i4 >> 2] = 0;
    i8 = i5;
    break;
   }
  } else {
   i2 = HEAP32[i14 + (8 - i7) >> 2] | 0;
   if (i2 >>> 0 < i6 >>> 0) _abort();
   i5 = i2 + 12 | 0;
   if ((HEAP32[i5 >> 2] | 0) != (i11 | 0)) _abort();
   i4 = i3 + 8 | 0;
   if ((HEAP32[i4 >> 2] | 0) == (i11 | 0)) {
    HEAP32[i5 >> 2] = i3;
    HEAP32[i4 >> 2] = i2;
    i8 = i3;
    break;
   } else _abort();
  } while (0);
  if (i1) {
   i5 = HEAP32[i14 + (28 - i7) >> 2] | 0;
   i4 = 970440 + (i5 << 2) | 0;
   if ((i11 | 0) == (HEAP32[i4 >> 2] | 0)) {
    HEAP32[i4 >> 2] = i8;
    if (!i8) {
     HEAP32[242535] = HEAP32[242535] & ~(1 << i5);
     i19 = i11;
     i9 = i10;
     break;
    }
   } else {
    if (i1 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
    i5 = i1 + 16 | 0;
    if ((HEAP32[i5 >> 2] | 0) == (i11 | 0)) HEAP32[i5 >> 2] = i8; else HEAP32[i1 + 20 >> 2] = i8;
    if (!i8) {
     i19 = i11;
     i9 = i10;
     break;
    }
   }
   i3 = HEAP32[242538] | 0;
   if (i8 >>> 0 < i3 >>> 0) _abort();
   HEAP32[i8 + 24 >> 2] = i1;
   i5 = 16 - i7 | 0;
   i4 = HEAP32[i14 + i5 >> 2] | 0;
   do if (i4) if (i4 >>> 0 < i3 >>> 0) _abort(); else {
    HEAP32[i8 + 16 >> 2] = i4;
    HEAP32[i4 + 24 >> 2] = i8;
    break;
   } while (0);
   i5 = HEAP32[i14 + (i5 + 4) >> 2] | 0;
   if (i5) if (i5 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
    HEAP32[i8 + 20 >> 2] = i5;
    HEAP32[i5 + 24 >> 2] = i8;
    i19 = i11;
    i9 = i10;
    break;
   } else {
    i19 = i11;
    i9 = i10;
   }
  } else {
   i19 = i11;
   i9 = i10;
  }
 } else {
  i19 = i14;
  i9 = i15;
 } while (0);
 i6 = HEAP32[242538] | 0;
 if (i16 >>> 0 < i6 >>> 0) _abort();
 i5 = i14 + (i15 + 4) | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (!(i4 & 2)) {
  if ((i16 | 0) == (HEAP32[242540] | 0)) {
   i10 = (HEAP32[242537] | 0) + i9 | 0;
   HEAP32[242537] = i10;
   HEAP32[242540] = i19;
   HEAP32[i19 + 4 >> 2] = i10 | 1;
   if ((i19 | 0) != (HEAP32[242539] | 0)) {
    STACKTOP = i20;
    return;
   }
   HEAP32[242539] = 0;
   HEAP32[242536] = 0;
   STACKTOP = i20;
   return;
  }
  if ((i16 | 0) == (HEAP32[242539] | 0)) {
   i10 = (HEAP32[242536] | 0) + i9 | 0;
   HEAP32[242536] = i10;
   HEAP32[242539] = i19;
   HEAP32[i19 + 4 >> 2] = i10 | 1;
   HEAP32[i19 + i10 >> 2] = i10;
   STACKTOP = i20;
   return;
  }
  i7 = (i4 & -8) + i9 | 0;
  i1 = i4 >>> 3;
  do if (i4 >>> 0 >= 256) {
   i1 = HEAP32[i14 + (i15 + 24) >> 2] | 0;
   i3 = HEAP32[i14 + (i15 + 12) >> 2] | 0;
   do if ((i3 | 0) == (i16 | 0)) {
    i4 = i14 + (i15 + 20) | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if (!i5) {
     i4 = i14 + (i15 + 16) | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     if (!i5) {
      i13 = 0;
      break;
     }
    }
    while (1) {
     i3 = i5 + 20 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (i2) {
      i5 = i2;
      i4 = i3;
      continue;
     }
     i3 = i5 + 16 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) break; else {
      i5 = i2;
      i4 = i3;
     }
    }
    if (i4 >>> 0 < i6 >>> 0) _abort(); else {
     HEAP32[i4 >> 2] = 0;
     i13 = i5;
     break;
    }
   } else {
    i2 = HEAP32[i14 + (i15 + 8) >> 2] | 0;
    if (i2 >>> 0 < i6 >>> 0) _abort();
    i5 = i2 + 12 | 0;
    if ((HEAP32[i5 >> 2] | 0) != (i16 | 0)) _abort();
    i4 = i3 + 8 | 0;
    if ((HEAP32[i4 >> 2] | 0) == (i16 | 0)) {
     HEAP32[i5 >> 2] = i3;
     HEAP32[i4 >> 2] = i2;
     i13 = i3;
     break;
    } else _abort();
   } while (0);
   if (i1) {
    i5 = HEAP32[i14 + (i15 + 28) >> 2] | 0;
    i4 = 970440 + (i5 << 2) | 0;
    if ((i16 | 0) == (HEAP32[i4 >> 2] | 0)) {
     HEAP32[i4 >> 2] = i13;
     if (!i13) {
      HEAP32[242535] = HEAP32[242535] & ~(1 << i5);
      break;
     }
    } else {
     if (i1 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
     i4 = i1 + 16 | 0;
     if ((HEAP32[i4 >> 2] | 0) == (i16 | 0)) HEAP32[i4 >> 2] = i13; else HEAP32[i1 + 20 >> 2] = i13;
     if (!i13) break;
    }
    i3 = HEAP32[242538] | 0;
    if (i13 >>> 0 < i3 >>> 0) _abort();
    HEAP32[i13 + 24 >> 2] = i1;
    i4 = HEAP32[i14 + (i15 + 16) >> 2] | 0;
    do if (i4) if (i4 >>> 0 < i3 >>> 0) _abort(); else {
     HEAP32[i13 + 16 >> 2] = i4;
     HEAP32[i4 + 24 >> 2] = i13;
     break;
    } while (0);
    i3 = HEAP32[i14 + (i15 + 20) >> 2] | 0;
    if (i3) if (i3 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
     HEAP32[i13 + 20 >> 2] = i3;
     HEAP32[i3 + 24 >> 2] = i13;
     break;
    }
   }
  } else {
   i2 = HEAP32[i14 + (i15 + 8) >> 2] | 0;
   i3 = HEAP32[i14 + (i15 + 12) >> 2] | 0;
   i5 = 970176 + (i1 << 1 << 2) | 0;
   if ((i2 | 0) != (i5 | 0)) {
    if (i2 >>> 0 < i6 >>> 0) _abort();
    if ((HEAP32[i2 + 12 >> 2] | 0) != (i16 | 0)) _abort();
   }
   if ((i3 | 0) == (i2 | 0)) {
    HEAP32[242534] = HEAP32[242534] & ~(1 << i1);
    break;
   }
   if ((i3 | 0) != (i5 | 0)) {
    if (i3 >>> 0 < i6 >>> 0) _abort();
    i4 = i3 + 8 | 0;
    if ((HEAP32[i4 >> 2] | 0) == (i16 | 0)) i12 = i4; else _abort();
   } else i12 = i3 + 8 | 0;
   HEAP32[i2 + 12 >> 2] = i3;
   HEAP32[i12 >> 2] = i2;
  } while (0);
  HEAP32[i19 + 4 >> 2] = i7 | 1;
  HEAP32[i19 + i7 >> 2] = i7;
  if ((i19 | 0) == (HEAP32[242539] | 0)) {
   HEAP32[242536] = i7;
   STACKTOP = i20;
   return;
  } else i5 = i7;
 } else {
  HEAP32[i5 >> 2] = i4 & -2;
  HEAP32[i19 + 4 >> 2] = i9 | 1;
  HEAP32[i19 + i9 >> 2] = i9;
  i5 = i9;
 }
 i4 = i5 >>> 3;
 if (i5 >>> 0 < 256) {
  i2 = i4 << 1;
  i5 = 970176 + (i2 << 2) | 0;
  i1 = HEAP32[242534] | 0;
  i3 = 1 << i4;
  if (i1 & i3) {
   i3 = 970176 + (i2 + 2 << 2) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
    i17 = i3;
    i18 = i2;
   }
  } else {
   HEAP32[242534] = i1 | i3;
   i17 = 970176 + (i2 + 2 << 2) | 0;
   i18 = i5;
  }
  HEAP32[i17 >> 2] = i19;
  HEAP32[i18 + 12 >> 2] = i19;
  HEAP32[i19 + 8 >> 2] = i18;
  HEAP32[i19 + 12 >> 2] = i5;
  STACKTOP = i20;
  return;
 }
 i1 = i5 >>> 8;
 if (i1) if (i5 >>> 0 > 16777215) i4 = 31; else {
  i9 = (i1 + 1048320 | 0) >>> 16 & 8;
  i10 = i1 << i9;
  i8 = (i10 + 520192 | 0) >>> 16 & 4;
  i10 = i10 << i8;
  i4 = (i10 + 245760 | 0) >>> 16 & 2;
  i4 = 14 - (i8 | i9 | i4) + (i10 << i4 >>> 15) | 0;
  i4 = i5 >>> (i4 + 7 | 0) & 1 | i4 << 1;
 } else i4 = 0;
 i3 = 970440 + (i4 << 2) | 0;
 HEAP32[i19 + 28 >> 2] = i4;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP32[i19 + 16 >> 2] = 0;
 i2 = HEAP32[242535] | 0;
 i1 = 1 << i4;
 if (!(i2 & i1)) {
  HEAP32[242535] = i2 | i1;
  HEAP32[i3 >> 2] = i19;
  HEAP32[i19 + 24 >> 2] = i3;
  HEAP32[i19 + 12 >> 2] = i19;
  HEAP32[i19 + 8 >> 2] = i19;
  STACKTOP = i20;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == 31) i1 = 0; else i1 = 25 - (i4 >>> 1) | 0;
 L194 : do if ((HEAP32[i3 + 4 >> 2] & -8 | 0) != (i5 | 0)) {
  i4 = i5 << i1;
  i1 = i3;
  while (1) {
   i2 = i1 + (i4 >>> 31 << 2) + 16 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break;
   if ((HEAP32[i3 + 4 >> 2] & -8 | 0) == (i5 | 0)) break L194; else {
    i4 = i4 << 1;
    i1 = i3;
   }
  }
  if (i2 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
  HEAP32[i2 >> 2] = i19;
  HEAP32[i19 + 24 >> 2] = i1;
  HEAP32[i19 + 12 >> 2] = i19;
  HEAP32[i19 + 8 >> 2] = i19;
  STACKTOP = i20;
  return;
 } while (0);
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[242538] | 0;
 if (!(i3 >>> 0 >= i10 >>> 0 & i2 >>> 0 >= i10 >>> 0)) _abort();
 HEAP32[i2 + 12 >> 2] = i19;
 HEAP32[i1 >> 2] = i19;
 HEAP32[i19 + 8 >> 2] = i2;
 HEAP32[i19 + 12 >> 2] = i3;
 HEAP32[i19 + 24 >> 2] = 0;
 STACKTOP = i20;
 return;
}

function __ZN4perf8TestBase4nextEv(i18) {
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, d7 = 0.0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i16 = i20;
 i3 = i20 + 64 | 0;
 i2 = i20 + 60 | 0;
 i19 = i20 + 48 | 0;
 i6 = i20 + 36 | 0;
 i9 = i20 + 24 | 0;
 i10 = i20 + 20 | 0;
 i15 = i18 + 80 | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 if ((i5 | 0) != -1) {
  if ((i5 + 1 | 0) != ((HEAP32[i18 + 40 >> 2] | 0) - (HEAP32[i18 + 36 >> 2] | 0) >> 3 | 0)) {
   __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i3, 1, 170184, 1082, 171216);
   __ZN7testing7MessageC2Ev(i2);
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i2 >> 2] | 0) + 8 | 0, 174160, 37) | 0;
   __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i3, i2);
   if (HEAP32[i2 >> 2] | 0) {
    if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i1 = HEAP32[i2 >> 2] | 0, (i1 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
    HEAP32[i2 >> 2] = 0;
   }
   __ZN7testing8internal12AssertHelperD2Ev(i3);
  }
 } else {
  i3 = 174152;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i3 = i18 + 168 | 0;
  i5 = i18 + 96 | 0;
  i2 = i5 + 72 | 0;
  do {
   HEAP32[i5 >> 2] = 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) < (i2 | 0));
  HEAP32[i3 >> 2] = -1;
 }
 i8 = 173416;
 i5 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = __ZN2cv6theRNGEv() | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i8;
 i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
 HEAP32[i15 >> 2] = i2;
 L13 : do if (i2) {
  i3 = HEAP32[43316] | 0;
  if ((i3 | 0) == -1) {
   i3 = HEAP32[i18 + 32 >> 2] | 0;
   i3 = (i3 | 0) == -1 ? HEAP32[43474] | 0 : i3;
  }
  if (!i3) if (i2 >>> 0 < (HEAP32[i18 + 76 >> 2] | 0) >>> 0) {
   i8 = i18 + 56 | 0;
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   i3 = i18 + 64 | 0;
   i5 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = (i2 | 0) < (i5 | 0) | ((i2 | 0) == (i5 | 0) ? (HEAP32[i8 >> 2] | 0) >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0 : 0);
  } else i3 = 0; else {
   i3 = i18 + 56 | 0;
   i5 = i3;
   i8 = 174152;
   i8 = _i64Subtract(HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
   d4 = +(i8 >>> 0) + 4294967296.0 * +(tempRet0 | 0);
   if (d4 >= +__ZN2cv16getTickFrequencyEv() * 10.0) {
    HEAP8[i16 >> 0] = 46;
    i5 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, i16, 1) | 0;
    __ZNKSt3__18ios_base6getlocEv(i16, i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) | 0);
    i8 = __ZNKSt3__16locale9use_facetERNS0_2idE(i16, 960728) | 0;
    i8 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] & 127](i8, 10) | 0;
    __ZNSt3__16localeD2Ev(i16);
    __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i5, i8) | 0;
    __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i5) | 0;
    i5 = HEAP32[i3 + 4 >> 2] | 0;
    i8 = 174152;
    HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i8 + 4 >> 2] = i5;
   }
   i3 = HEAP32[i15 >> 2] | 0;
   if (i3 >>> 0 < (HEAP32[i18 + 76 >> 2] | 0) >>> 0) {
    if (i3 >>> 0 < (HEAP32[i18 + 72 >> 2] | 0) >>> 0) break;
    __ZN4perf8TestBase11calcMetricsEv(i18) | 0;
    d4 = +Math_abs(+(+HEAPF64[i18 + 128 >> 3]));
    if (!(d4 > 1.0e-06)) break;
    i3 = +HEAPF64[i18 + 136 >> 3] > d4 * .03;
   } else i3 = 0;
  }
  if ((HEAP8[173816] | 0) == 0 | i3) {
   if (i3) break; else i1 = 0;
   STACKTOP = i20;
   return i1 | 0;
  }
  __ZN4perf8TestBase11calcMetricsEv(i18) | 0;
  i8 = i18 + 96 | 0;
  d7 = +HEAPF64[i18 + 144 >> 3] * 1.0e3 / +HEAPF64[i18 + 160 >> 3];
  i2 = __ZNK7testing8UnitTest17current_test_infoEv(__ZN7testing8UnitTest11GetInstanceEv() | 0) | 0;
  if (!i2) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i19, 169928, 0); else {
   if (!(HEAP8[i2 >> 0] & 1)) i3 = i2 + 1 | 0; else i3 = HEAP32[i2 + 8 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i3, _strlen(i3 | 0) | 0);
   HEAP32[i6 + 0 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   i3 = HEAP8[i9 >> 0] | 0;
   if (!(i3 & 1)) {
    i5 = (i3 & 255) >>> 1;
    i3 = i9 + 1 | 0;
   } else {
    i5 = HEAP32[i9 + 4 >> 2] | 0;
    i3 = HEAP32[i9 + 8 >> 2] | 0;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, i3, i5, i5 + 2 | 0);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, 170064, 2) | 0;
   i3 = i2 + 12 | 0;
   if (!(HEAP8[i3 >> 0] & 1)) i2 = i3 + 1 | 0; else i2 = HEAP32[i2 + 20 >> 2] | 0;
   HEAP32[i19 + 0 >> 2] = 0;
   HEAP32[i19 + 4 >> 2] = 0;
   HEAP32[i19 + 8 >> 2] = 0;
   i5 = HEAP8[i6 >> 0] | 0;
   if (!(i5 & 1)) {
    i1 = _strlen(i2 | 0) | 0;
    i5 = (i5 & 255) >>> 1;
    i3 = i6 + 1 | 0;
   } else {
    i5 = HEAP32[i6 + 4 >> 2] | 0;
    i1 = _strlen(i2 | 0) | 0;
    i3 = HEAP32[i6 + 8 >> 2] | 0;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i19, i3, i5, i5 + i1 | 0);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i19, i2, i1) | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
  }
  L53 : do if (HEAP32[42940] | 0) {
   i3 = HEAP8[i19 >> 0] | 0;
   if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i19 + 4 >> 2] | 0;
   if (i3) {
    __ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i10, 171752, i19);
    i3 = HEAP32[i10 >> 2] | 0;
    if ((i3 | 0) == 171756) if (!(HEAP32[i18 + 88 >> 2] | 0)) {
     _puts(178032) | 0;
     i5 = 0;
     i3 = 0;
    } else {
     i5 = 0;
     i3 = 0;
    } else {
     d4 = +Math_fround(HEAPF32[i3 + 28 >> 2]);
     i3 = d7 > d4;
     if (+Math_abs(+(d7 - d4)) <= +Math_abs(+d7) * .03) {
      i1 = i19;
      break;
     }
     if (!(HEAP32[i18 + 88 >> 2] | 0)) {
      HEAP32[i16 >> 2] = (HEAP32[i18 + 40 >> 2] | 0) - (HEAP32[i18 + 36 >> 2] | 0) >> 3;
      i5 = i16 + 4 | 0;
      HEAPF64[tempDoublePtr >> 3] = d7;
      HEAP32[i5 >> 2] = HEAP32[tempDoublePtr >> 2];
      HEAP32[i5 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
      i5 = i16 + 12 | 0;
      HEAPF64[tempDoublePtr >> 3] = d4;
      HEAP32[i5 >> 2] = HEAP32[tempDoublePtr >> 2];
      HEAP32[i5 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
      _printf(174200, i16 | 0) | 0;
      i5 = 1;
     } else i5 = 1;
    }
    i6 = i18 + 88 | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    if (i2 >>> 0 >= 2) {
     HEAPF64[tempDoublePtr >> 3] = d7;
     HEAP32[i16 >> 2] = HEAP32[tempDoublePtr >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
     _printf(174368, i16 | 0) | 0;
     i1 = i19;
     break;
    }
    if (((i2 | 0) == 0 ? (i11 = HEAP32[i15 >> 2] | 0, i12 = i18 + 72 | 0, i13 = HEAP32[i12 >> 2] | 0, i11 >>> 0 <= (i13 * 3 | 0) >>> 0) : 0) ? i11 >>> 0 < (HEAP32[i18 + 76 >> 2] | 0) >>> 0 : 0) {
     i1 = i13 * 5 | 0;
     i11 = i11 * 3 | 0;
     i1 = i1 >>> 0 < i11 >>> 0 ? i11 : i1;
     HEAP32[i16 >> 2] = i13;
     HEAP32[i16 + 4 >> 2] = i1;
     _printf(174296, i16 | 0) | 0;
     HEAP32[i12 >> 2] = i1;
     i1 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
    } else i17 = 54;
    L74 : do if ((i17 | 0) == 54) {
     do if (i5 ? (i14 = i18 + 76 | 0, d7 > .1 ? (HEAP32[i15 >> 2] | 0) >>> 0 >= (HEAP32[i14 >> 2] | 0) >>> 0 : 0) : 0) {
      if (!i3 ? !(+HEAPF64[i18 + 136 >> 3] > +Math_abs(+(+HEAPF64[i18 + 128 >> 3])) * .03) : 0) break;
      _puts(177960) | 0;
      HEAP32[i16 >> 2] = 3e3;
      _printf(174336, i16 | 0) | 0;
      _usleep(3e6) | 0;
      i1 = i18 + 72 | 0;
      i2 = (HEAP32[i1 >> 2] | 0) * 5 | 0;
      i3 = HEAP32[i14 >> 2] | 0;
      HEAP32[i1 >> 2] = i3 >>> 0 < i2 >>> 0 ? i3 : i2;
      HEAP32[i15 >> 2] = 0;
      i1 = HEAP32[i18 + 36 >> 2] | 0;
      i2 = i18 + 40 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
      i3 = i18 + 168 | 0;
      i5 = i8 + 0 | 0;
      i2 = i5 + 72 | 0;
      do {
       HEAP32[i5 >> 2] = 0;
       i5 = i5 + 4 | 0;
      } while ((i5 | 0) < (i2 | 0));
      HEAP32[i3 >> 2] = -1;
      i1 = (HEAP32[i6 >> 2] | 0) + 2 | 0;
      break L74;
     } while (0);
     _puts(177920) | 0;
     i1 = i19;
     break L53;
    } while (0);
    HEAP32[i6 >> 2] = i1;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
    break L13;
   } else i17 = 63;
  } else i17 = 63; while (0);
  if ((i17 | 0) == 63) i1 = i19;
  i1 = HEAP8[i1 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i19 + 4 >> 2] | 0;
  if (!i1) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
   i11 = 0;
   STACKTOP = i20;
   return i11 | 0;
  } else {
   HEAPF32[(__ZNSt3__13mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfNS_4lessIS6_EENS4_INS_4pairIKS6_fEEEEEixERSA_(171752, i19) | 0) >> 2] = Math_fround(d7);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
   i11 = 0;
   STACKTOP = i20;
   return i11 | 0;
  }
 } while (0);
 i10 = __ZN2cv12getTickCountEv() | 0;
 i11 = i18 + 48 | 0;
 HEAP32[i11 >> 2] = i10;
 HEAP32[i11 + 4 >> 2] = tempRet0;
 i11 = 1;
 STACKTOP = i20;
 return i11 | 0;
}

function __ZNK2cv11_InputArray13getUMatVectorERNSt3__16vectorINS_4UMatENS1_9allocatorIS3_EEEE(i8, i19) {
 i8 = i8 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i16 = i20 + 56 | 0;
 i14 = i20 + 8 | 0;
 i6 = i20;
 i7 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8) | 0;
 i18 = HEAP32[i8 + 4 >> 2] & 50331648;
 if (!i7) {
  i3 = HEAP32[i19 >> 2] | 0;
  i1 = i19 + 4 | 0;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) == (i3 | 0)) break;
   i10 = i2 + -48 | 0;
   HEAP32[i1 >> 2] = i10;
   __ZN2cv4UMatD2Ev(i10);
  }
  STACKTOP = i20;
  return;
 } else if ((i7 | 0) == 65536) {
  i5 = HEAP32[i8 + 8 >> 2] | 0;
  i1 = i19 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i19 >> 2] | 0;
  i2 = (i3 - i4 | 0) / 48 | 0;
  if ((i3 | 0) != (i4 | 0)) {
   if (i2 >>> 0 > 1 ? (i9 = i4 + 48 | 0, (i3 | 0) != (i9 | 0)) : 0) do {
    i8 = i3 + -48 | 0;
    HEAP32[i1 >> 2] = i8;
    __ZN2cv4UMatD2Ev(i8);
    i3 = HEAP32[i1 >> 2] | 0;
   } while ((i3 | 0) != (i9 | 0));
  } else __ZNSt3__16vectorIN2cv4UMatENS_9allocatorIS2_EEE8__appendEj(i19, 1 - i2 | 0);
  i1 = HEAP32[i19 >> 2] | 0;
  __ZNK2cv3Mat7getUMatEiNS_14UMatUsageFlagsE(i14, i5, i18, 0);
  if ((i1 | 0) != (i14 | 0)) {
   i4 = i14 + 24 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (i3) {
    i9 = i3 + 8 | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   }
   i2 = i1 + 24 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != 0 ? (i8 = i3 + 8 | 0, i9 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) __ZN2cv4UMat10deallocateEv(i1);
   HEAP32[HEAP32[i1 + 32 >> 2] >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
   i3 = i1 + 4 | 0;
   if ((HEAP32[i3 >> 2] | 0) < 3 ? (i10 = HEAP32[i14 + 4 >> 2] | 0, (i10 | 0) < 3) : 0) {
    HEAP32[i3 >> 2] = i10;
    HEAP32[i1 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    i9 = HEAP32[i14 + 36 >> 2] | 0;
    i10 = HEAP32[i1 + 36 >> 2] | 0;
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   } else __ZN2cv4UMat8copySizeERKS0_(i1, i14);
   HEAP32[i1 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   i3 = i1 + 20 | 0;
   if (!(HEAP32[i3 >> 2] | 0)) HEAP32[i3 >> 2] = HEAP32[i14 + 20 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
  }
  __ZN2cv4UMatD2Ev(i14);
  STACKTOP = i20;
  return;
 } else if ((i7 | 0) == 327680) {
  i14 = HEAP32[i8 + 8 >> 2] | 0;
  i3 = HEAP32[i14 + 4 >> 2] | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  i15 = (i3 - i2 | 0) / 56 | 0;
  i1 = i19 + 4 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i19 >> 2] | 0;
  i5 = (i4 - i6 | 0) / 48 | 0;
  if (i15 >>> 0 <= i5 >>> 0) {
   if (i15 >>> 0 < i5 >>> 0 ? (i13 = i6 + (i15 * 48 | 0) | 0, (i4 | 0) != (i13 | 0)) : 0) do {
    i10 = i4 + -48 | 0;
    HEAP32[i1 >> 2] = i10;
    __ZN2cv4UMatD2Ev(i10);
    i4 = HEAP32[i1 >> 2] | 0;
   } while ((i4 | 0) != (i13 | 0));
  } else __ZNSt3__16vectorIN2cv4UMatENS_9allocatorIS2_EEE8__appendEj(i19, i15 - i5 | 0);
  if ((i3 | 0) == (i2 | 0)) {
   STACKTOP = i20;
   return;
  }
  i6 = i16 + 24 | 0;
  i5 = i16 + 4 | 0;
  i4 = i16 + 8 | 0;
  i3 = i16 + 12 | 0;
  i2 = i16 + 36 | 0;
  i1 = i16 + 16 | 0;
  i10 = i16 + 20 | 0;
  i11 = i16 + 28 | 0;
  i13 = 0;
  do {
   i12 = HEAP32[i19 >> 2] | 0;
   i9 = i12 + (i13 * 48 | 0) | 0;
   __ZNK2cv3Mat7getUMatEiNS_14UMatUsageFlagsE(i16, (HEAP32[i14 >> 2] | 0) + (i13 * 56 | 0) | 0, i18, 0);
   if ((i9 | 0) != (i16 | 0)) {
    i8 = HEAP32[i6 >> 2] | 0;
    if (i8) {
     i8 = i8 + 8 | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
    }
    i7 = i12 + (i13 * 48 | 0) + 24 | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    if ((i8 | 0) != 0 ? (i21 = i8 + 8 | 0, i8 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv4UMat10deallocateEv(i9);
    HEAP32[HEAP32[i12 + (i13 * 48 | 0) + 32 >> 2] >> 2] = 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i9 >> 2] = HEAP32[i16 >> 2];
    i8 = i12 + (i13 * 48 | 0) + 4 | 0;
    if ((HEAP32[i8 >> 2] | 0) < 3 ? (i17 = HEAP32[i5 >> 2] | 0, (i17 | 0) < 3) : 0) {
     HEAP32[i8 >> 2] = i17;
     HEAP32[i12 + (i13 * 48 | 0) + 8 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i12 + (i13 * 48 | 0) + 12 >> 2] = HEAP32[i3 >> 2];
     i8 = HEAP32[i2 >> 2] | 0;
     i9 = HEAP32[i12 + (i13 * 48 | 0) + 36 >> 2] | 0;
     HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    } else __ZN2cv4UMat8copySizeERKS0_(i9, i16);
    HEAP32[i12 + (i13 * 48 | 0) + 16 >> 2] = HEAP32[i1 >> 2];
    i8 = i12 + (i13 * 48 | 0) + 20 | 0;
    if (!(HEAP32[i8 >> 2] | 0)) HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i12 + (i13 * 48 | 0) + 28 >> 2] = HEAP32[i11 >> 2];
   }
   __ZN2cv4UMatD2Ev(i16);
   i13 = i13 + 1 | 0;
  } while (i13 >>> 0 < i15 >>> 0);
  STACKTOP = i20;
  return;
 } else if ((i7 | 0) == 655360) {
  i8 = HEAP32[i8 + 8 >> 2] | 0;
  i4 = i19 + 4 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i19 >> 2] | 0;
  i1 = (i3 - i2 | 0) / 48 | 0;
  if ((i3 | 0) != (i2 | 0)) {
   if (i1 >>> 0 > 1 ? (i5 = i2 + 48 | 0, (i3 | 0) != (i5 | 0)) : 0) do {
    i10 = i3 + -48 | 0;
    HEAP32[i4 >> 2] = i10;
    __ZN2cv4UMatD2Ev(i10);
    i3 = HEAP32[i4 >> 2] | 0;
   } while ((i3 | 0) != (i5 | 0));
  } else __ZNSt3__16vectorIN2cv4UMatENS_9allocatorIS2_EEE8__appendEj(i19, 1 - i1 | 0);
  i4 = HEAP32[i19 >> 2] | 0;
  if ((i4 | 0) == (i8 | 0)) {
   STACKTOP = i20;
   return;
  }
  i1 = i8 + 24 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3) {
   i10 = i3 + 8 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  i2 = i4 + 24 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != 0 ? (i9 = i3 + 8 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv4UMat10deallocateEv(i4);
  HEAP32[HEAP32[i4 + 32 >> 2] >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
  i3 = i4 + 4 | 0;
  if ((HEAP32[i3 >> 2] | 0) < 3 ? (i12 = HEAP32[i8 + 4 >> 2] | 0, (i12 | 0) < 3) : 0) {
   HEAP32[i3 >> 2] = i12;
   HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   i9 = HEAP32[i8 + 36 >> 2] | 0;
   i10 = HEAP32[i4 + 36 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  } else __ZN2cv4UMat8copySizeERKS0_(i4, i8);
  HEAP32[i4 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  i3 = i4 + 20 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) HEAP32[i3 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  STACKTOP = i20;
  return;
 } else if ((i7 | 0) == 720896) {
  i12 = HEAP32[i8 + 8 >> 2] | 0;
  i5 = HEAP32[i12 + 4 >> 2] | 0;
  i6 = HEAP32[i12 >> 2] | 0;
  i13 = (i5 - i6 | 0) / 48 | 0;
  i1 = i19 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i19 >> 2] | 0;
  i2 = (i3 - i4 | 0) / 48 | 0;
  if (i13 >>> 0 <= i2 >>> 0) {
   if (i13 >>> 0 < i2 >>> 0 ? (i11 = i4 + (i13 * 48 | 0) | 0, (i3 | 0) != (i11 | 0)) : 0) do {
    i10 = i3 + -48 | 0;
    HEAP32[i1 >> 2] = i10;
    __ZN2cv4UMatD2Ev(i10);
    i3 = HEAP32[i1 >> 2] | 0;
   } while ((i3 | 0) != (i11 | 0));
  } else __ZNSt3__16vectorIN2cv4UMatENS_9allocatorIS2_EEE8__appendEj(i19, i13 - i2 | 0);
  if ((i5 | 0) == (i6 | 0)) {
   STACKTOP = i20;
   return;
  } else i8 = 0;
  do {
   i2 = HEAP32[i19 >> 2] | 0;
   i6 = i2 + (i8 * 48 | 0) | 0;
   i1 = HEAP32[i12 >> 2] | 0;
   i5 = i1 + (i8 * 48 | 0) | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i7 = i1 + (i8 * 48 | 0) + 24 | 0;
    i4 = HEAP32[i7 >> 2] | 0;
    if (i4) {
     i10 = i4 + 8 | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
    }
    i3 = i2 + (i8 * 48 | 0) + 24 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 | 0) != 0 ? (i9 = i4 + 8 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv4UMat10deallocateEv(i6);
    HEAP32[HEAP32[i2 + (i8 * 48 | 0) + 32 >> 2] >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
    i4 = i2 + (i8 * 48 | 0) + 4 | 0;
    if ((HEAP32[i4 >> 2] | 0) < 3 ? (i15 = HEAP32[i1 + (i8 * 48 | 0) + 4 >> 2] | 0, (i15 | 0) < 3) : 0) {
     HEAP32[i4 >> 2] = i15;
     HEAP32[i2 + (i8 * 48 | 0) + 8 >> 2] = HEAP32[i1 + (i8 * 48 | 0) + 8 >> 2];
     HEAP32[i2 + (i8 * 48 | 0) + 12 >> 2] = HEAP32[i1 + (i8 * 48 | 0) + 12 >> 2];
     i9 = HEAP32[i1 + (i8 * 48 | 0) + 36 >> 2] | 0;
     i10 = HEAP32[i2 + (i8 * 48 | 0) + 36 >> 2] | 0;
     HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    } else __ZN2cv4UMat8copySizeERKS0_(i6, i5);
    HEAP32[i2 + (i8 * 48 | 0) + 16 >> 2] = HEAP32[i1 + (i8 * 48 | 0) + 16 >> 2];
    i4 = i2 + (i8 * 48 | 0) + 20 | 0;
    if (!(HEAP32[i4 >> 2] | 0)) HEAP32[i4 >> 2] = HEAP32[i1 + (i8 * 48 | 0) + 20 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i2 + (i8 * 48 | 0) + 28 >> 2] = HEAP32[i1 + (i8 * 48 | 0) + 28 >> 2];
   }
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < i13 >>> 0);
  STACKTOP = i20;
  return;
 } else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i6, 30) | 0) + 0 | 0;
  i2 = 28928 | 0;
  i1 = i3 + 30 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i6, 28984, 27528, 1387);
  __ZN2cv6String10deallocateEv(i6);
  STACKTOP = i20;
  return;
 }
}

function __ZN7testing8internal12UnitTestImpl11RunAllTestsEv(i34) {
 i34 = i34 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i35 = i37;
 if (!(HEAP32[40112] | 0)) {
  HEAP32[i35 >> 2] = 164048;
  _printf(163e3, i35 | 0) | 0;
  i22 = 0;
  STACKTOP = i37;
  return i22 | 0;
 }
 if (HEAP8[159744] | 0) {
  i22 = 1;
  STACKTOP = i37;
  return i22 | 0;
 }
 i1 = i34 + 168 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  HEAP8[i1 >> 0] = 1;
  i3 = i34 + 96 | 0;
  if (!(HEAP8[i3 >> 0] | 0)) {
   i2 = HEAP32[i34 + 84 >> 2] | 0;
   i1 = i34 + 88 | 0;
   if ((i2 | 0) != (HEAP32[i1 >> 2] | 0)) do {
    i22 = HEAP32[i2 >> 2] | 0;
    FUNCTION_TABLE_vi[HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] & 511](i22);
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) != (HEAP32[i1 >> 2] | 0));
   HEAP8[i3 >> 0] = 1;
  }
  __ZN7testing8internal12UnitTestImpl18ConfigureXmlOutputEv(i34);
 }
 i1 = _getenv(164160) | 0;
 do if (i1) {
  i2 = _fopen(i1 | 0, 162960) | 0;
  if (!i2) {
   HEAP32[i35 >> 2] = i1;
   HEAP32[i35 + 4 >> 2] = 164160;
   __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(1, 164184, i35);
   _fflush(HEAP32[_stdout >> 2] | 0) | 0;
   _exit(1);
  } else {
   _fclose(i2 | 0) | 0;
   break;
  }
 } while (0);
 i31 = (__ZN7testing8internal12UnitTestImpl11FilterTestsENS1_18ReactionToShardingE(i34, (__ZN7testing8internal11ShouldShardEPKcS2_b(162256, 162280, 0) | 0) & 1 ^ 1) | 0) > 0;
 if (HEAP8[159936] | 0) {
  __ZN7testing8internal12UnitTestImpl23ListTestsMatchingFilterEv(i34);
  i22 = 1;
  STACKTOP = i37;
  return i22 | 0;
 }
 if (!(HEAP8[160040] | 0)) i2 = 0; else {
  i2 = HEAP32[4e4] | 0;
  if (!i2) {
   _gettimeofday(i35 | 0, 0) | 0;
   i2 = ((HEAP32[i35 + 4 >> 2] | 0) / 1e3 | 0) + ((HEAP32[i35 >> 2] | 0) * 1e3 | 0) | 0;
  }
  i2 = (((i2 + -1 | 0) >>> 0) % 99999 | 0) + 1 | 0;
 }
 i26 = i34 + 172 | 0;
 HEAP32[i26 >> 2] = i2;
 i27 = HEAP32[i34 + 152 >> 2] | 0;
 _gettimeofday(i35 | 0, 0) | 0;
 i9 = HEAP32[i35 >> 2] | 0;
 i9 = ___muldi3(i9 | 0, ((i9 | 0) < 0) << 31 >> 31 | 0, 1e3, 0) | 0;
 i28 = (HEAP32[i35 + 4 >> 2] | 0) / 1e3 | 0;
 i9 = _i64Add(i28 | 0, ((i28 | 0) < 0) << 31 >> 31 | 0, i9 | 0, tempRet0 | 0) | 0;
 i28 = i34 + 184 | 0;
 HEAP32[i28 >> 2] = i9;
 HEAP32[i28 + 4 >> 2] = tempRet0;
 i28 = i34 + 4 | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] & 127](i27, HEAP32[i28 >> 2] | 0);
 i9 = HEAP32[40006] | 0;
 i10 = (i9 | 0) > -1;
 do if (i9) {
  i11 = i34 + 60 | 0;
  i12 = i34 + 64 | 0;
  i13 = i35 + 4 | 0;
  i8 = i31 ^ 1;
  i14 = i34 + 48 | 0;
  i15 = i34 + 52 | 0;
  i16 = i34 + 76 | 0;
  i17 = i34 + 72 | 0;
  i18 = i35 + 4 | 0;
  i19 = i34 + 192 | 0;
  i20 = i34 + 120 | 0;
  i21 = i34 + 116 | 0;
  i29 = i34 + 116 | 0;
  i22 = i34 + 176 | 0;
  i23 = i34 + 100 | 0;
  i24 = i34 + 72 | 0;
  i30 = 0;
  i25 = 0;
  L36 : while (1) {
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   if ((i3 | 0) != (i4 | 0)) do {
    i1 = HEAP32[i3 >> 2] | 0;
    __ZN7testing10TestResult5ClearEv(i1 + 64 | 0);
    i2 = HEAP32[i1 + 20 >> 2] | 0;
    i1 = HEAP32[i1 + 24 >> 2] | 0;
    if ((i2 | 0) != (i1 | 0)) do {
     __ZN7testing10TestResult5ClearEv((HEAP32[i2 >> 2] | 0) + 48 | 0);
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i1 | 0));
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) != (i4 | 0));
   _gettimeofday(i35 | 0, 0) | 0;
   i6 = HEAP32[i35 >> 2] | 0;
   i5 = ((i6 | 0) < 0) << 31 >> 31;
   i2 = (HEAP32[i13 >> 2] | 0) / 1e3 | 0;
   i1 = ((i2 | 0) < 0) << 31 >> 31;
   if (!((HEAP8[160040] | 0) == 0 | i8) ? (HEAP32[i22 >> 2] = HEAP32[i26 >> 2], __ZN7testing8internal12ShuffleRangeIiEEvPNS0_6RandomEiiPNSt3__16vectorIT_NS4_9allocatorIS6_EEEE(i22, 0, (HEAP32[i23 >> 2] | 0) + 1 | 0, i24), __ZN7testing8internal12ShuffleRangeIiEEvPNS0_6RandomEiiPNSt3__16vectorIT_NS4_9allocatorIS6_EEEE(i22, (HEAP32[i23 >> 2] | 0) + 1 | 0, (HEAP32[i12 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) >> 2, i24), i32 = HEAP32[i11 >> 2] | 0, (HEAP32[i12 >> 2] | 0) != (i32 | 0)) : 0) {
    i3 = i32;
    i4 = 0;
    do {
     i38 = HEAP32[i3 + (i4 << 2) >> 2] | 0;
     i7 = i38 + 32 | 0;
     __ZN7testing8internal12ShuffleRangeIiEEvPNS0_6RandomEiiPNSt3__16vectorIT_NS4_9allocatorIS6_EEEE(i22, 0, (HEAP32[i38 + 36 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) >> 2, i7);
     i4 = i4 + 1 | 0;
     i3 = HEAP32[i11 >> 2] | 0;
    } while (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) - i3 >> 2 >>> 0);
   }
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i27 >> 2] | 0) + 12 >> 2] & 63](i27, HEAP32[i28 >> 2] | 0, i25);
   if (i31) {
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i27 >> 2] | 0) + 16 >> 2] & 127](i27, HEAP32[i28 >> 2] | 0);
    i3 = HEAP32[i14 >> 2] | 0;
    i4 = HEAP32[i15 >> 2] | 0;
    if ((i3 | 0) != (i4 | 0)) do {
     i7 = HEAP32[i3 >> 2] | 0;
     FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] & 511](i7);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i4 | 0));
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i27 >> 2] | 0) + 20 >> 2] & 127](i27, HEAP32[i28 >> 2] | 0);
    if (!(__ZN7testing4Test15HasFatalFailureEv() | 0) ? (i33 = HEAP32[i11 >> 2] | 0, ((HEAP32[i12 >> 2] | 0) - i33 | 0) > 0) : 0) {
     i3 = i33;
     i7 = 0;
     do {
      i4 = HEAP32[i17 >> 2] | 0;
      do if (((HEAP32[i16 >> 2] | 0) - i4 >> 2 | 0) > (i7 | 0)) {
       i4 = HEAP32[i4 + (i7 << 2) >> 2] | 0;
       if ((i4 | 0) < 0) {
        i3 = 0;
        break;
       }
       i3 = HEAP32[i3 + (i4 << 2) >> 2] | 0;
      } else i3 = 0; while (0);
      __ZN7testing8TestCase3RunEv(i3);
      i7 = i7 + 1 | 0;
      i3 = HEAP32[i11 >> 2] | 0;
     } while ((i7 | 0) < ((HEAP32[i12 >> 2] | 0) - i3 >> 2 | 0));
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i27 >> 2] | 0) + 44 >> 2] & 127](i27, HEAP32[i28 >> 2] | 0);
    i3 = HEAP32[i15 >> 2] | 0;
    i4 = HEAP32[i14 >> 2] | 0;
    if ((i3 | 0) != (i4 | 0)) do {
     i3 = i3 + -4 | 0;
     i7 = HEAP32[i3 >> 2] | 0;
     FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] & 511](i7);
    } while ((i3 | 0) != (i4 | 0));
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i27 >> 2] | 0) + 48 >> 2] & 127](i27, HEAP32[i28 >> 2] | 0);
   }
   _gettimeofday(i35 | 0, 0) | 0;
   i7 = HEAP32[i35 >> 2] | 0;
   i7 = ___muldi3(i7 | 0, ((i7 | 0) < 0) << 31 >> 31 | 0, 1e3, 0) | 0;
   i4 = tempRet0;
   i3 = (HEAP32[i18 >> 2] | 0) / 1e3 | 0;
   i5 = ___muldi3(i6 | 0, i5 | 0, -1e3, -1) | 0;
   i2 = _i64Subtract(i5 | 0, tempRet0 | 0, i2 | 0, i1 | 0) | 0;
   i2 = _i64Add(i2 | 0, tempRet0 | 0, i7 | 0, i4 | 0) | 0;
   i2 = _i64Add(i2 | 0, tempRet0 | 0, i3 | 0, ((i3 | 0) < 0) << 31 >> 31 | 0) | 0;
   i1 = i19;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = tempRet0;
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i27 >> 2] | 0) + 52 >> 2] & 63](i27, HEAP32[i28 >> 2] | 0, i25);
   L71 : do if ((__ZNK7testing8internal12UnitTestImpl22failed_test_case_countEv(i34) | 0) <= 0) {
    i3 = HEAP32[i21 >> 2] | 0;
    i2 = (HEAP32[i20 >> 2] | 0) - i3 | 0;
    if ((i2 | 0) > 0) {
     i2 = (i2 | 0) / 44 | 0;
     i1 = 0;
     while (1) {
      if (i2 >>> 0 <= i1 >>> 0) {
       i1 = 46;
       break L36;
      }
      if (HEAP32[i3 + (i1 * 44 | 0) >> 2] | 0) {
       i3 = 1;
       break L71;
      }
      i1 = i1 + 1 | 0;
      i2 = ((HEAP32[i20 >> 2] | 0) - i3 | 0) / 44 | 0;
      if ((i1 | 0) >= (i2 | 0)) {
       i3 = 0;
       break;
      }
     }
    } else i3 = 0;
   } else i3 = 1; while (0);
   i30 = i30 | i3;
   i3 = HEAP32[i12 >> 2] | 0;
   i6 = HEAP32[i11 >> 2] | 0;
   if ((i3 | 0) != (i6 | 0)) {
    i7 = HEAP32[i17 >> 2] | 0;
    i2 = i3 - i6 >> 2;
    i5 = 0;
    do {
     i1 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
     i3 = HEAP32[i1 + 36 >> 2] | 0;
     i1 = HEAP32[i1 + 32 >> 2] | 0;
     if ((i3 | 0) != (i1 | 0)) {
      i4 = i3 - i1 >> 2;
      i3 = 0;
      do {
       HEAP32[i1 + (i3 << 2) >> 2] = i3;
       i3 = i3 + 1 | 0;
      } while (i3 >>> 0 < i4 >>> 0);
     }
     HEAP32[i7 + (i5 << 2) >> 2] = i5;
     i5 = i5 + 1 | 0;
    } while (i5 >>> 0 < i2 >>> 0);
   }
   if (HEAP8[160040] | 0) {
    i3 = HEAP32[i26 >> 2] | 0;
    if ((i3 + -1 | 0) >>> 0 >= 99999) {
     __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i35, 3, 160160, 559);
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 168792, 54) | 0, 168848, 20) | 0, i3) | 0, 168872, 18) | 0, 99999) | 0, 168584, 2) | 0;
     __ZN7testing8internal8GTestLogD2Ev(i35);
    }
    HEAP32[i26 >> 2] = (i3 | 0) > 99998 ? 1 : i3 + 1 | 0;
   }
   i25 = i25 + 1 | 0;
   if (i10 & (i25 | 0) == (i9 | 0)) {
    i1 = 59;
    break;
   }
  }
  if ((i1 | 0) == 46) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i29); else if ((i1 | 0) == 59) {
   i36 = i30 ^ 1;
   break;
  }
 } else i36 = 1; while (0);
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i27 >> 2] | 0) + 56 >> 2] & 127](i27, HEAP32[i28 >> 2] | 0);
 i22 = i36;
 STACKTOP = i37;
 return i22 | 0;
}

function __ZNSt3__17__sort4IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_S9_T_(i22, i23, i13, i1, i21) {
 i22 = i22 | 0;
 i23 = i23 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i25 = i26;
 i24 = __ZNSt3__17__sort3IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_T_(i22, i23, i13, i21) | 0;
 if (!(FUNCTION_TABLE_iii[HEAP32[i21 >> 2] & 127](i1, i13) | 0)) {
  i22 = i24;
  STACKTOP = i26;
  return i22 | 0;
 }
 i4 = HEAP32[i13 >> 2] | 0;
 HEAP32[i25 >> 2] = i4;
 i6 = i25 + 4 | 0;
 i12 = i13 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
 if (i4) {
  i20 = i4 + -4 | 0;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
 }
 i9 = i25 + 8 | 0;
 i10 = i13 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = i4;
 i8 = i25 + 12 | 0;
 i16 = i13 + 12 | 0;
 HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
 if (i4) {
  i20 = i4 + -4 | 0;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
 }
 i15 = i13 + 16 | 0;
 __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i25 + 16 | 0, i15);
 i7 = i25 + 28 | 0;
 i17 = i13 + 28 | 0;
 HEAP32[i7 >> 2] = HEAP32[i17 >> 2];
 if ((i1 | 0) != (i13 | 0)) {
  __ZN2cv6String10deallocateEv(i13);
  i4 = HEAP32[i1 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i1 >> 2] | 0;
  }
  HEAP32[i13 >> 2] = i4;
  HEAP32[i12 >> 2] = HEAP32[i1 + 4 >> 2];
  i2 = i13 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i1 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i4 = 0; else {
   i20 = i3 + -4 | 0;
   HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
   i4 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i4;
  HEAP32[i16 >> 2] = HEAP32[i1 + 12 >> 2];
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i15, HEAP32[i1 + 16 >> 2] | 0, HEAP32[i1 + 20 >> 2] | 0);
 }
 i5 = i1 + 28 | 0;
 HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
 if ((i25 | 0) == (i1 | 0)) i1 = i25 + 16 | 0; else {
  __ZN2cv6String10deallocateEv(i1);
  i4 = HEAP32[i25 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i25 >> 2] | 0;
  }
  HEAP32[i1 >> 2] = i4;
  HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
  i2 = i1 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i25 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i4 = 0; else {
   i20 = i3 + -4 | 0;
   HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
   i4 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i4;
  HEAP32[i1 + 12 >> 2] = HEAP32[i8 >> 2];
  i20 = i25 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i1 + 16 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i25 + 20 >> 2] | 0);
  i1 = i20;
 }
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i4 = HEAP32[i1 >> 2] | 0;
 if (i4) {
  i3 = i25 + 20 | 0;
  while (1) {
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0)) break;
   i20 = i2 + -8 | 0;
   HEAP32[i3 >> 2] = i20;
   __ZN2cv6String10deallocateEv(i20);
  }
  __ZdlPv(HEAP32[i1 >> 2] | 0);
 }
 __ZN2cv6String10deallocateEv(i9);
 __ZN2cv6String10deallocateEv(i25);
 if (!(FUNCTION_TABLE_iii[HEAP32[i21 >> 2] & 127](i13, i23) | 0)) {
  i22 = i24 + 1 | 0;
  STACKTOP = i26;
  return i22 | 0;
 }
 i4 = HEAP32[i23 >> 2] | 0;
 HEAP32[i25 >> 2] = i4;
 i8 = i25 + 4 | 0;
 i14 = i23 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
 if (i4) {
  i20 = i4 + -4 | 0;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
 }
 i9 = i25 + 8 | 0;
 i11 = i23 + 8 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i4;
 i7 = i25 + 12 | 0;
 i19 = i23 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i19 >> 2];
 if (i4) {
  i20 = i4 + -4 | 0;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
 }
 i18 = i23 + 16 | 0;
 __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i25 + 16 | 0, i18);
 i6 = i25 + 28 | 0;
 i20 = i23 + 28 | 0;
 HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
 if ((i13 | 0) != (i23 | 0)) {
  __ZN2cv6String10deallocateEv(i23);
  i4 = HEAP32[i13 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i23 >> 2] = i4;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  i3 = i23 + 8 | 0;
  __ZN2cv6String10deallocateEv(i3);
  i4 = HEAP32[i10 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i4;
  HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i18, HEAP32[i13 + 16 >> 2] | 0, HEAP32[i13 + 20 >> 2] | 0);
 }
 HEAP32[i20 >> 2] = HEAP32[i17 >> 2];
 if ((i25 | 0) == (i13 | 0)) i1 = i25 + 16 | 0; else {
  __ZN2cv6String10deallocateEv(i13);
  i4 = HEAP32[i25 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i25 >> 2] | 0;
  }
  HEAP32[i13 >> 2] = i4;
  HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
  i2 = i13 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i25 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i4 = 0; else {
   i13 = i3 + -4 | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   i4 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i4;
  HEAP32[i16 >> 2] = HEAP32[i7 >> 2];
  i1 = i25 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i15, HEAP32[i1 >> 2] | 0, HEAP32[i25 + 20 >> 2] | 0);
 }
 HEAP32[i17 >> 2] = HEAP32[i6 >> 2];
 i4 = HEAP32[i1 >> 2] | 0;
 if (i4) {
  i3 = i25 + 20 | 0;
  while (1) {
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0)) break;
   i17 = i2 + -8 | 0;
   HEAP32[i3 >> 2] = i17;
   __ZN2cv6String10deallocateEv(i17);
  }
  __ZdlPv(HEAP32[i1 >> 2] | 0);
 }
 __ZN2cv6String10deallocateEv(i9);
 __ZN2cv6String10deallocateEv(i25);
 if (!(FUNCTION_TABLE_iii[HEAP32[i21 >> 2] & 127](i23, i22) | 0)) {
  i22 = i24 + 2 | 0;
  STACKTOP = i26;
  return i22 | 0;
 }
 i4 = HEAP32[i22 >> 2] | 0;
 HEAP32[i25 >> 2] = i4;
 i6 = i25 + 4 | 0;
 i3 = i22 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 if (i4) {
  i21 = i4 + -4 | 0;
  HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
 }
 i9 = i25 + 8 | 0;
 i4 = HEAP32[i22 + 8 >> 2] | 0;
 HEAP32[i9 >> 2] = i4;
 i7 = i25 + 12 | 0;
 i5 = i22 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 if (i4) {
  i21 = i4 + -4 | 0;
  HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
 }
 i2 = i22 + 16 | 0;
 __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i25 + 16 | 0, i2);
 i8 = i25 + 28 | 0;
 i1 = i22 + 28 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 if ((i23 | 0) != (i22 | 0)) {
  __ZN2cv6String10deallocateEv(i22);
  i4 = HEAP32[i23 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i23 >> 2] | 0;
  }
  HEAP32[i22 >> 2] = i4;
  HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
  i3 = i22 + 8 | 0;
  __ZN2cv6String10deallocateEv(i3);
  i4 = HEAP32[i11 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i4;
  HEAP32[i5 >> 2] = HEAP32[i19 >> 2];
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i2, HEAP32[i23 + 16 >> 2] | 0, HEAP32[i23 + 20 >> 2] | 0);
 }
 HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
 if ((i25 | 0) == (i23 | 0)) i4 = i25 + 16 | 0; else {
  __ZN2cv6String10deallocateEv(i23);
  i4 = HEAP32[i25 >> 2] | 0;
  if (!i4) i4 = 0; else {
   i4 = i4 + -4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = HEAP32[i25 >> 2] | 0;
  }
  HEAP32[i23 >> 2] = i4;
  HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
  i2 = i23 + 8 | 0;
  __ZN2cv6String10deallocateEv(i2);
  i4 = i25 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i4 = 0; else {
   i22 = i3 + -4 | 0;
   HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
   i4 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i4;
  HEAP32[i19 >> 2] = HEAP32[i7 >> 2];
  i4 = i25 + 16 | 0;
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i18, HEAP32[i4 >> 2] | 0, HEAP32[i25 + 20 >> 2] | 0);
 }
 HEAP32[i20 >> 2] = HEAP32[i8 >> 2];
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1) {
  i2 = i25 + 20 | 0;
  while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (i1 | 0)) break;
   i22 = i3 + -8 | 0;
   HEAP32[i2 >> 2] = i22;
   __ZN2cv6String10deallocateEv(i22);
  }
  __ZdlPv(HEAP32[i4 >> 2] | 0);
 }
 __ZN2cv6String10deallocateEv(i9);
 __ZN2cv6String10deallocateEv(i25);
 i22 = i24 + 3 | 0;
 STACKTOP = i26;
 return i22 | 0;
}

function __ZN4perf10RegressionclERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKN2cv11_InputArrayEdNS_10ERROR_TYPEE(i25, i23, i22, d11, i12) {
 i25 = i25 | 0;
 i23 = i23 | 0;
 i22 = i22 | 0;
 d11 = +d11;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i21 = i26 + 96 | 0;
 i20 = i26 + 88 | 0;
 i19 = i26 + 80 | 0;
 i7 = i26 + 72 | 0;
 i6 = i26 + 68 | 0;
 i24 = i26 + 56 | 0;
 i13 = i26 + 48 | 0;
 i4 = i26 + 40 | 0;
 i8 = i26 + 36 | 0;
 i9 = i26 + 32 | 0;
 i14 = i26 + 24 | 0;
 i10 = i26 + 16 | 0;
 i17 = i26 + 12 | 0;
 i15 = i26 + 8 | 0;
 i1 = i26;
 if (__ZNK7testing10TestResult6FailedEv((__ZNK7testing8UnitTest17current_test_infoEv(__ZN7testing8UnitTest11GetInstanceEv() | 0) | 0) + 48 | 0) | 0) {
  STACKTOP = i26;
  return i25 | 0;
 }
 if (!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i22 >> 2] | 0) + 76 >> 2] & 127](i22) | 0) ? (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i22 >> 2] | 0) + 60 >> 2] & 127](i22, -1) | 0) == 7 : 0) {
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i7, 1, 170184, 585, 171216);
  __ZN7testing7MessageC2Ev(i6);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i6 >> 2] | 0) + 8 | 0, 171608, 57) | 0;
  i1 = HEAP8[i23 >> 0] | 0;
  if (!(i1 & 1)) {
   i2 = i23 + 1 | 0;
   i1 = (i1 & 255) >>> 1;
  } else {
   i2 = HEAP32[i23 + 8 >> 2] | 0;
   i1 = HEAP32[i23 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i6 >> 2] | 0) + 8 | 0, i2, i1) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i7, i6);
  if (HEAP32[i6 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i5 = HEAP32[i6 >> 2] | 0, (i5 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 511](i5);
   HEAP32[i6 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i7);
  STACKTOP = i26;
  return i25 | 0;
 }
 __ZN4perf10Regression22getCurrentTestNodeNameEv(i24);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i7 = HEAP8[i24 >> 0] | 0;
 i6 = (i7 & 1) == 0;
 if (i6) i5 = (i7 & 255) >>> 1; else i5 = HEAP32[i24 + 4 >> 2] | 0;
 if (i5) {
  if (i6) i7 = (i7 & 255) >>> 1; else i7 = HEAP32[i24 + 4 >> 2] | 0;
  i6 = __ZN2cv6String8allocateEj(i4, i7) | 0;
  if (!(HEAP8[i24 >> 0] & 1)) i5 = i24 + 1 | 0; else i5 = HEAP32[i24 + 8 >> 2] | 0;
  _memcpy(i6 | 0, i5 | 0, i7 | 0) | 0;
 }
 __ZNK2cv8FileNodeixERKNS_6StringE(i13, i25 + 104 | 0, i4);
 __ZN2cv6String10deallocateEv(i4);
 do if (!(__ZNK2cv8FileNode4typeEv(i13) | 0)) {
  if (!(HEAP8[171672] | 0)) {
   if (!(HEAP8[171680] | 0)) break;
   __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i8, 1, 170184, 611, 171216);
   __ZN7testing7MessageC2Ev(i9);
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i9 >> 2] | 0) + 8 | 0, 171688, 25) | 0;
   i1 = HEAP8[i23 >> 0] | 0;
   if (!(i1 & 1)) {
    i3 = i23 + 1 | 0;
    i1 = (i1 & 255) >>> 1;
   } else {
    i3 = HEAP32[i23 + 8 >> 2] | 0;
    i1 = HEAP32[i23 + 4 >> 2] | 0;
   }
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i9 >> 2] | 0) + 8 | 0, i3, i1) | 0;
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i9 >> 2] | 0) + 8 | 0, 171720, 9) | 0;
   __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i8, i9);
   if (HEAP32[i9 >> 2] | 0) {
    if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i9 >> 2] | 0, (i2 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
    HEAP32[i9 >> 2] = 0;
   }
   __ZN7testing8internal12AssertHelperD2Ev(i8);
   break;
  }
  i7 = i25 + 112 | 0;
  i3 = HEAP8[i24 >> 0] | 0;
  i1 = (i3 & 1) == 0;
  if (i1) i2 = (i3 & 255) >>> 1; else i2 = HEAP32[i24 + 4 >> 2] | 0;
  i5 = HEAP8[i7 >> 0] | 0;
  i6 = (i5 & 1) == 0;
  if (i6) i4 = (i5 & 255) >>> 1; else i4 = HEAP32[i25 + 116 >> 2] | 0;
  L90 : do if ((i2 | 0) == (i4 | 0)) {
   if (i1) i3 = i24 + 1 | 0; else i3 = HEAP32[i24 + 8 >> 2] | 0;
   if (i6) i4 = i7 + 1 | 0; else i4 = HEAP32[i25 + 120 >> 2] | 0;
   if (!i1) if (!(_memcmp(i3, i4, i2) | 0)) break; else {
    i18 = 44;
    break;
   }
   if (i2) while (1) {
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i4 >> 0] | 0)) {
     i18 = 44;
     break L90;
    }
    i2 = i2 + -1 | 0;
    if (!i2) break; else {
     i3 = i3 + 1 | 0;
     i4 = i4 + 1 | 0;
    }
   }
  } else i18 = 44; while (0);
  if ((i18 | 0) == 44) {
   if (i6) i2 = (i5 & 255) >>> 1; else i2 = HEAP32[i25 + 116 >> 2] | 0;
   if (i2) {
    i18 = __ZN4perf10Regression5writeEv(i25) | 0;
    HEAP32[i19 >> 2] = 0;
    HEAP32[i19 + 4 >> 2] = 0;
    HEAP8[(__ZN2cv6String8allocateEj(i19, 1) | 0) >> 0] = 125;
    __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i18, i19) | 0;
    __ZN2cv6String10deallocateEv(i19);
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i24) | 0;
   i4 = __ZN4perf10Regression5writeEv(i25) | 0;
   HEAP32[i21 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   i3 = HEAP8[i24 >> 0] | 0;
   i2 = (i3 & 1) == 0;
   if (i2) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i24 + 4 >> 2] | 0;
   if (i1) {
    if (i2) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i24 + 4 >> 2] | 0;
    i2 = __ZN2cv6String8allocateEj(i21, i3) | 0;
    if (!(HEAP8[i24 >> 0] & 1)) i1 = i24 + 1 | 0; else i1 = HEAP32[i24 + 8 >> 2] | 0;
    _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
   }
   i19 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i21) | 0;
   __ZN2cv6String10deallocateEv(i21);
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   HEAP8[(__ZN2cv6String8allocateEj(i20, 1) | 0) >> 0] = 123;
   __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i19, i20) | 0;
   __ZN2cv6String10deallocateEv(i20);
  }
  i4 = __ZN4perf10Regression5writeEv(i25) | 0;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  i2 = HEAP8[i23 >> 0] | 0;
  i1 = (i2 & 1) == 0;
  if (i1) i3 = (i2 & 255) >>> 1; else i3 = HEAP32[i23 + 4 >> 2] | 0;
  if (i3) {
   if (i1) i3 = (i2 & 255) >>> 1; else i3 = HEAP32[i23 + 4 >> 2] | 0;
   i2 = __ZN2cv6String8allocateEj(i21, i3) | 0;
   if (!(HEAP8[i23 >> 0] & 1)) i1 = i23 + 1 | 0; else i1 = HEAP32[i23 + 8 >> 2] | 0;
   _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
  }
  i23 = __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i21) | 0;
  __ZN2cv6String10deallocateEv(i21);
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP8[(__ZN2cv6String8allocateEj(i21, 1) | 0) >> 0] = 123;
  __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i23, i21) | 0;
  __ZN2cv6String10deallocateEv(i21);
  __ZN4perf10Regression5writeERKN2cv11_InputArrayE(i25, i22);
  i23 = __ZN4perf10Regression5writeEv(i25) | 0;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP8[(__ZN2cv6String8allocateEj(i21, 1) | 0) >> 0] = 125;
  __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i23, i21) | 0;
  __ZN2cv6String10deallocateEv(i21);
 } else {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i4 = HEAP8[i23 >> 0] | 0;
  i3 = (i4 & 1) == 0;
  if (i3) i2 = (i4 & 255) >>> 1; else i2 = HEAP32[i23 + 4 >> 2] | 0;
  if (i2) {
   if (i3) i4 = (i4 & 255) >>> 1; else i4 = HEAP32[i23 + 4 >> 2] | 0;
   i3 = __ZN2cv6String8allocateEj(i10, i4) | 0;
   if (!(HEAP8[i23 >> 0] & 1)) i2 = i23 + 1 | 0; else i2 = HEAP32[i23 + 8 >> 2] | 0;
   _memcpy(i3 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZNK2cv8FileNodeixERKNS_6StringE(i14, i13, i10);
  __ZN2cv6String10deallocateEv(i10);
  if ((__ZNK2cv8FileNode4typeEv(i14) | 0) == 6) {
   HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   __ZN4perf10Regression6verifyEN2cv8FileNodeERKNS1_11_InputArrayEdNS_10ERROR_TYPEE(0, i1, i22, d11, i12);
   break;
  }
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i17, 1, 170184, 618, 171216);
  __ZN7testing7MessageC2Ev(i15);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i15 >> 2] | 0) + 8 | 0, 171688, 25) | 0;
  i1 = HEAP8[i23 >> 0] | 0;
  if (!(i1 & 1)) {
   i3 = i23 + 1 | 0;
   i1 = (i1 & 255) >>> 1;
  } else {
   i3 = HEAP32[i23 + 8 >> 2] | 0;
   i1 = HEAP32[i23 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i15 >> 2] | 0) + 8 | 0, i3, i1) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i15 >> 2] | 0) + 8 | 0, 171720, 9) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i17, i15);
  if (HEAP32[i15 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i16 = HEAP32[i15 >> 2] | 0, (i16 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i16 >> 2] | 0) + 4 >> 2] & 511](i16);
   HEAP32[i15 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i17);
 } while (0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
 STACKTOP = i26;
 return i25 | 0;
}

function __ZN2cvL8from_strERKNS_6StringEiPv(i12, i17, i1) {
 i12 = i12 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 i7 = i8 + 104 | 0;
 i21 = i8 + 92 | 0;
 i3 = i8 + 80 | 0;
 i9 = i8 + 72 | 0;
 i10 = i8 + 64 | 0;
 i11 = i8 + 56 | 0;
 i20 = i8 + 48 | 0;
 i13 = i8 + 40 | 0;
 i14 = i8 + 32 | 0;
 i15 = i8 + 24 | 0;
 i16 = i8 + 16 | 0;
 i18 = i8 + 8 | 0;
 i19 = i8;
 i6 = HEAP32[i12 >> 2] | 0;
 i6 = (i6 | 0) == 0 ? 6232 : i6;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, i6, _strlen(i6 | 0) | 0);
 i6 = i7 + 64 | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = 2640;
 i4 = i7 + 12 | 0;
 HEAP32[i7 >> 2] = 2788;
 HEAP32[i6 >> 2] = 2808;
 HEAP32[i7 + 4 >> 2] = 0;
 __ZNSt3__18ios_base4initEPv(i7 + 64 | 0, i4);
 HEAP32[i7 + 136 >> 2] = 0;
 HEAP32[i7 + 140 >> 2] = -1;
 HEAP32[i7 >> 2] = 2620;
 HEAP32[i6 >> 2] = 2660;
 HEAP32[i5 >> 2] = 2640;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i4);
 HEAP32[i4 >> 2] = 2952;
 i2 = i7 + 44 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i7 + 60 >> 2] = 24;
 __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i4, i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 switch (i17 | 0) {
 case 8:
  {
   __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEErsERj(i7, i1) | 0;
   break;
  }
 case 1:
  {
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   __ZNSt3__1rsIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_13basic_istreamIT_T0_EES9_RNS_12basic_stringIS6_S7_T1_EE(i7, i3) | 0;
   HEAP8[i1 >> 0] = (__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i3, 6272) | 0) == 0 & 1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
   break;
  }
 case 7:
  {
   __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEErsERf(i7, i1) | 0;
   break;
  }
 case 9:
  {
   __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEErsERy(i7, i1) | 0;
   break;
  }
 case 3:
  {
   if ((i1 | 0) != (i12 | 0)) {
    __ZN2cv6String10deallocateEv(i1);
    i3 = HEAP32[i12 >> 2] | 0;
    if (!i3) i3 = 0; else {
     i3 = i3 + -4 | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i12 >> 2] | 0;
    }
    HEAP32[i1 >> 2] = i3;
    HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   }
   break;
  }
 case 0:
  {
   __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEErsERi(i7, i1) | 0;
   break;
  }
 case 2:
  {
   __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEErsERd(i7, i1) | 0;
   break;
  }
 default:
  {
   i1 = ___cxa_allocate_exception(44) | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   i4 = (__ZN2cv6String8allocateEj(i9, 34) | 0) + 0 | 0;
   i5 = 6480 | 0;
   i6 = i4 + 34 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i4 | 0) < (i6 | 0));
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   __ZN2cv6String8allocateEj(i10, 0) | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   i4 = (__ZN2cv6String8allocateEj(i11, 66) | 0) + 0 | 0;
   i5 = 6408 | 0;
   i6 = i4 + 66 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i4 | 0) < (i6 | 0));
   __ZN2cv9ExceptionC2EiRKNS_6StringES3_S3_i(i1, -5, i9, i10, i11, 81);
   ___cxa_throw(i1 | 0, 25504, 92);
  }
 }
 if (!(HEAP32[i7 + ((HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) + 16) >> 2] & 5)) {
  HEAP32[i7 >> 2] = 2620;
  HEAP32[i7 + 64 >> 2] = 2660;
  HEAP32[i5 >> 2] = 2640;
  HEAP32[i4 >> 2] = 2952;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
  __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i4);
  __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i6);
  STACKTOP = i8;
  return;
 }
 HEAP32[i15 >> 2] = 0;
 i3 = i15 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i12 + 4 | 0;
 __ZN2cv6String8allocateEj(i15, (HEAP32[i1 >> 2] | 0) + 18 | 0) | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i4 = i2 + 0 | 0;
 i5 = 6520 | 0;
 i6 = i4 + 18 | 0;
 do {
  HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
  i4 = i4 + 1 | 0;
  i5 = i5 + 1 | 0;
 } while ((i4 | 0) < (i6 | 0));
 _memcpy(i2 + 18 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
 HEAP32[i14 >> 2] = 0;
 i1 = i14 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN2cv6String8allocateEj(i14, (HEAP32[i3 >> 2] | 0) + 6 | 0) | 0;
 _memcpy(HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 i10 = (HEAP32[i14 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) | 0;
 HEAP8[i10 + 0 >> 0] = HEAP8[6544] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[6545] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[6546] | 0;
 HEAP8[i10 + 3 >> 0] = HEAP8[6547] | 0;
 HEAP8[i10 + 4 >> 0] = HEAP8[6548] | 0;
 HEAP8[i10 + 5 >> 0] = HEAP8[6549] | 0;
 switch (i17 | 0) {
 case 9:
  {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   i4 = (__ZN2cv6String8allocateEj(i16, 18) | 0) + 0 | 0;
   i5 = 6560 | 0;
   i6 = i4 + 18 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i4 | 0) < (i6 | 0));
   break;
  }
 case 8:
  {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i16, 8) | 0;
   i9 = i10;
   HEAP8[i9 >> 0] = 117;
   HEAP8[i9 + 1 >> 0] = 110;
   HEAP8[i9 + 2 >> 0] = 115;
   HEAP8[i9 + 3 >> 0] = 105;
   i10 = i10 + 4 | 0;
   HEAP8[i10 >> 0] = 103;
   HEAP8[i10 + 1 >> 0] = 110;
   HEAP8[i10 + 2 >> 0] = 101;
   HEAP8[i10 + 3 >> 0] = 100;
   break;
  }
 case 3:
  {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i16, 6) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[6600] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[6601] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[6602] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[6603] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[6604] | 0;
   HEAP8[i10 + 5 >> 0] = HEAP8[6605] | 0;
   break;
  }
 case 1:
  {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i16, 4) | 0;
   HEAP8[i10 >> 0] = 98;
   HEAP8[i10 + 1 >> 0] = 111;
   HEAP8[i10 + 2 >> 0] = 111;
   HEAP8[i10 + 3 >> 0] = 108;
   break;
  }
 case 0:
  {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i16, 3) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[6552] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[6553] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[6554] | 0;
   break;
  }
 case 2:
  {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i16, 6) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[6592] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[6593] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[6594] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[6595] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[6596] | 0;
   HEAP8[i10 + 5 >> 0] = HEAP8[6597] | 0;
   break;
  }
 case 7:
  {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i16, 5) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[6584] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[6585] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[6586] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[6587] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[6588] | 0;
   break;
  }
 default:
  {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i16, 7) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[6608] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[6609] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[6610] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[6611] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[6612] | 0;
   HEAP8[i10 + 5 >> 0] = HEAP8[6613] | 0;
   HEAP8[i10 + 6 >> 0] = HEAP8[6614] | 0;
  }
 }
 HEAP32[i13 >> 2] = 0;
 i4 = i13 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i16 + 4 | 0;
 __ZN2cv6String8allocateEj(i13, (HEAP32[i5 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0) | 0;
 _memcpy(HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
 _memcpy((HEAP32[i13 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0, HEAP32[i16 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 __ZN2cv6String8allocateEj(i20, (HEAP32[i4 >> 2] | 0) + 1 | 0) | 0;
 _memcpy(HEAP32[i20 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 HEAP8[(HEAP32[i20 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) >> 0] = 93;
 __ZN2cv6String10deallocateEv(i13);
 __ZN2cv6String10deallocateEv(i16);
 __ZN2cv6String10deallocateEv(i14);
 __ZN2cv6String10deallocateEv(i15);
 i1 = ___cxa_allocate_exception(44) | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 __ZN2cv6String8allocateEj(i18, 0) | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 i4 = (__ZN2cv6String8allocateEj(i19, 66) | 0) + 0 | 0;
 i5 = 6408 | 0;
 i6 = i4 + 66 | 0;
 do {
  HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
  i4 = i4 + 1 | 0;
  i5 = i5 + 1 | 0;
 } while ((i4 | 0) < (i6 | 0));
 __ZN2cv9ExceptionC2EiRKNS_6StringES3_S3_i(i1, -5, i20, i18, i19, 88);
 ___cxa_throw(i1 | 0, 25504, 92);
}

function _cvCopy(i17, i16, i14) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 i21 = i22 + 232 | 0;
 i7 = i22 + 224 | 0;
 i20 = i22 + 208 | 0;
 i19 = i22 + 152 | 0;
 i6 = i22 + 144 | 0;
 i9 = i22 + 136 | 0;
 i15 = i22 + 128 | 0;
 i10 = i22 + 120 | 0;
 i11 = i22 + 96 | 0;
 i12 = i22 + 76 | 0;
 i13 = i22 + 56 | 0;
 i18 = i22;
 i8 = (i17 | 0) != 0;
 if ((i8 ? ((i16 | 0) != 0 ? (HEAP32[i17 >> 2] & -65536 | 0) == 1111752704 : 0) : 0) ? (HEAP32[i16 >> 2] & -65536 | 0) == 1111752704 : 0) {
  if (i14) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i4 = (__ZN2cv6String8allocateEj(i7, 12) | 0) + 0 | 0;
   i2 = 47216 | 0;
   i1 = i4 + 12 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i4 | 0) < (i1 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 47232, 46680, 1326);
   __ZN2cv6String10deallocateEv(i7);
  }
  i15 = i17 + 4 | 0;
  HEAP32[i16 + 4 >> 2] = HEAP32[i15 >> 2];
  _memcpy(i16 + 36 | 0, i17 + 36 | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
  HEAP32[i16 + 28 >> 2] = HEAP32[i17 + 28 >> 2];
  HEAP32[i16 + 32 >> 2] = HEAP32[i17 + 32 >> 2];
  i15 = i16 + 16 | 0;
  _cvClearSet(HEAP32[i15 >> 2] | 0);
  i14 = i16 + 24 | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = i16 + 20 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[(HEAP32[i17 + 16 >> 2] | 0) + 60 >> 2] | 0) < (i2 * 3 | 0)) i3 = i1; else {
   _cvFree_(i1);
   HEAP32[i3 >> 2] = 0;
   i10 = HEAP32[i17 + 24 >> 2] | 0;
   HEAP32[i14 >> 2] = i10;
   i10 = _cvAlloc(i10 << 2) | 0;
   HEAP32[i3 >> 2] = i10;
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = i10;
  }
  i8 = i16 + 20 | 0;
  _memset(i3 | 0, 0, i2 << 2 | 0) | 0;
  i3 = _cvInitSparseMatIterator(i17, i20) | 0;
  if (!i3) {
   STACKTOP = i22;
   return;
  }
  i6 = i20 + 4 | 0;
  i7 = i20 + 8 | 0;
  L14 : while (1) {
   i1 = HEAP32[i15 >> 2] | 0;
   i4 = i1 + 56 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i21 >> 2] = i2;
   if (!i2) {
    _cvSetAdd(i1, 0, i21) | 0;
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = HEAP32[i21 >> 2] | 0;
   } else {
    HEAP32[i4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & 67108863;
    i10 = i1 + 60 | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   }
   i10 = (HEAP32[i14 >> 2] | 0) + -1 & HEAP32[i3 >> 2];
   _memcpy(i2 | 0, i3 | 0, HEAP32[i1 + 28 >> 2] | 0) | 0;
   i3 = (HEAP32[i8 >> 2] | 0) + (i10 << 2) | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i3 >> 2] = i2;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0;
   if (i3) {
    HEAP32[i6 >> 2] = i3;
    continue;
   }
   i4 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
   HEAP32[i7 >> 2] = i4;
   i3 = HEAP32[i20 >> 2] | 0;
   i5 = HEAP32[i3 + 24 >> 2] | 0;
   if ((i4 | 0) >= (i5 | 0)) {
    i1 = 72;
    break;
   }
   i1 = HEAP32[i3 + 20 >> 2] | 0;
   while (1) {
    i3 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
    i2 = i4 + 1 | 0;
    if (i3) break;
    if ((i2 | 0) < (i5 | 0)) i4 = i2; else {
     i1 = 72;
     break L14;
    }
   }
   HEAP32[i7 >> 2] = i4;
   HEAP32[i6 >> 2] = i3;
  }
  if ((i1 | 0) == 72) {
   STACKTOP = i22;
   return;
  }
 }
 __ZN2cv10cvarrToMatEPKvbbiPNS_10AutoBufferIdLj136EEE(i21, i17, 0, 1, 1, 0);
 __ZN2cv10cvarrToMatEPKvbbiPNS_10AutoBufferIdLj136EEE(i19, i16, 0, 1, 1, 0);
 L32 : do if (((HEAP32[i19 >> 2] ^ HEAP32[i21 >> 2]) & 7 | 0) == 0 ? (i2 = HEAP32[i21 + 40 >> 2] | 0, i4 = HEAP32[i2 + -4 >> 2] | 0, i3 = HEAP32[i19 + 40 >> 2] | 0, (i4 | 0) == (HEAP32[i3 + -4 >> 2] | 0)) : 0) {
  if ((i4 | 0) == 2) {
   if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) {
    i1 = 28;
    break;
   }
   if ((HEAP32[i2 + 4 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) break; else {
    i1 = 28;
    break;
   }
  }
  if ((i4 | 0) > 0) {
   i5 = 0;
   do {
    if ((HEAP32[i2 + (i5 << 2) >> 2] | 0) != (HEAP32[i3 + (i5 << 2) >> 2] | 0)) {
     i1 = 28;
     break L32;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < (i4 | 0));
  }
 } else i1 = 28; while (0);
 if ((i1 | 0) == 28) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i6, 50) | 0) + 0 | 0;
  i2 = 47240 | 0;
  i1 = i4 + 50 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i4 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i6, 47232, 46680, 1360);
  __ZN2cv6String10deallocateEv(i6);
 }
 if ((i8 ? (HEAP32[i17 >> 2] | 0) == 112 : 0) ? (HEAP32[i17 + 68 >> 2] | 0) != 0 : 0) i3 = _cvGetImageCOI(i17) | 0; else i3 = 0;
 if (((i16 | 0) != 0 ? (HEAP32[i16 >> 2] | 0) == 112 : 0) ? (HEAP32[i16 + 68 >> 2] | 0) != 0 : 0) i5 = _cvGetImageCOI(i16) | 0; else i5 = 0;
 i4 = (i5 | 0) == 0;
 do if (!(i5 | i3)) {
  if ((HEAP32[i19 >> 2] ^ HEAP32[i21 >> 2]) & 4088) {
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   i4 = (__ZN2cv6String8allocateEj(i10, 32) | 0) + 0 | 0;
   i2 = 47376 | 0;
   i1 = i4 + 32 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i4 | 0) < (i1 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 47232, 46680, 1378);
   __ZN2cv6String10deallocateEv(i10);
  }
  if (!i14) {
   i10 = i11 + 4 | 0;
   HEAP32[i10 + 0 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i11 >> 2] = 32232;
   HEAP32[i10 >> 2] = 33619968;
   HEAP32[i11 + 8 >> 2] = i19;
   __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i21, i11);
   break;
  }
  i3 = i12 + 4 | 0;
  HEAP32[i3 + 0 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i12 >> 2] = 32232;
  HEAP32[i3 >> 2] = 33619968;
  HEAP32[i12 + 8 >> 2] = i19;
  __ZN2cv10cvarrToMatEPKvbbiPNS_10AutoBufferIdLj136EEE(i18, i14, 0, 1, 0, 0);
  HEAP32[i13 >> 2] = 32088;
  HEAP32[i13 + 12 >> 2] = 0;
  HEAP32[i13 + 16 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 16842752;
  HEAP32[i13 + 8 >> 2] = i18;
  __ZNK2cv3Mat6copyToERKNS_12_OutputArrayERKNS_11_InputArrayE(i21, i12, i13);
  i3 = i18 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i9 = i2 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i18);
  HEAP32[i3 >> 2] = 0;
  i10 = i18 + 16 | 0;
  i3 = i18 + 4 | 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i18 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i2 = HEAP32[i18 + 44 >> 2] | 0;
  if ((i2 | 0) != (i18 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 } else {
  if ((i3 | 0) == 0 ? (HEAP32[i21 >> 2] & 4088 | 0) != 0 : 0) i1 = 42; else i1 = 40;
  if (((i1 | 0) == 40 ? i4 : 0) ? (HEAP32[i19 >> 2] & 4088 | 0) != 0 : 0) i1 = 42;
  if ((i1 | 0) == 42) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   i4 = (__ZN2cv6String8allocateEj(i9, 72) | 0) + 0 | 0;
   i2 = 47296 | 0;
   i1 = i4 + 72 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i4 | 0) < (i1 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i9, 47232, 46680, 1371);
   __ZN2cv6String10deallocateEv(i9);
  }
  i10 = i3 + -1 | 0;
  HEAP32[i15 >> 2] = (i10 | 0) < 0 ? 0 : i10;
  i10 = i5 + -1 | 0;
  HEAP32[i15 + 4 >> 2] = (i10 | 0) < 0 ? 0 : i10;
  __ZN2cv11mixChannelsEPKNS_3MatEjPS0_jPKij(i21, 1, i19, 1, i15, 1);
 } while (0);
 i2 = i19 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i19);
 HEAP32[i2 >> 2] = 0;
 i10 = i19 + 16 | 0;
 i3 = i19 + 4 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i19 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i19 + 44 >> 2] | 0;
 if ((i1 | 0) != (i19 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i21 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i9 = i2 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i21);
 HEAP32[i1 >> 2] = 0;
 i10 = i21 + 16 | 0;
 i2 = i21 + 4 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i21 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i21 + 44 >> 2] | 0;
 if ((i1 | 0) == (i21 + 48 | 0)) {
  STACKTOP = i22;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i22;
 return;
}

function __ZN7testing8internal11ShouldShardEPKcS2_b(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i17 = i13;
 i5 = i13 + 68 | 0;
 i4 = i13 + 64 | 0;
 i7 = i13 + 52 | 0;
 i9 = i13 + 48 | 0;
 i8 = i13 + 44 | 0;
 i12 = i13 + 32 | 0;
 i15 = i13 + 28 | 0;
 i14 = i13 + 24 | 0;
 i16 = i13 + 12 | 0;
 if (i3) {
  i10 = 0;
  STACKTOP = i13;
  return i10 | 0;
 }
 i11 = __ZN7testing8internal17Int32FromEnvOrDieEPKci(i2, -1) | 0;
 i10 = __ZN7testing8internal17Int32FromEnvOrDieEPKci(i1, -1) | 0;
 i6 = (i10 | 0) == -1;
 if ((i10 & i11 | 0) == -1) {
  i10 = 0;
  STACKTOP = i13;
  return i10 | 0;
 }
 if ((i11 | 0) == -1 & (i10 | 0) != -1) {
  __ZN7testing7MessageC2Ev(i4);
  i3 = HEAP32[i4 >> 2] | 0;
  i2 = i3 + 8 | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 164280, 40) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 162280, 17) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 164328, 3) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i2, i10) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 164336, 16) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 162256, 18) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 164360, 8) | 0;
  __ZN7testing7MessageC2ERKS0_(i5, i4);
  if (i3) {
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
   HEAP32[i4 >> 2] = 0;
  }
  __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i17, (HEAP32[i5 >> 2] | 0) + 12 | 0);
  i3 = HEAP8[i17 >> 0] | 0;
  if (!(i3 & 1)) {
   i2 = i17 + 1 | 0;
   i3 = (i3 & 255) >>> 1;
  } else {
   i2 = HEAP32[i17 + 8 >> 2] | 0;
   i3 = HEAP32[i17 + 4 >> 2] | 0;
  }
  i1 = i2 + i3 | 0;
  HEAP32[i7 + 0 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i7, i3 << 1);
  if (i3) do {
   i3 = HEAP8[i2 >> 0] | 0;
   if (!(i3 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, i3);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
  if (!(HEAP8[i7 >> 0] & 1)) {
   i5 = i7 + 1 | 0;
   __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(1, i5, i17);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
   i7 = HEAP32[_stdout >> 2] | 0;
   _fflush(i7 | 0) | 0;
   _exit(1);
  } else {
   i5 = HEAP32[i7 + 8 >> 2] | 0;
   __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(1, i5, i17);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
   i7 = HEAP32[_stdout >> 2] | 0;
   _fflush(i7 | 0) | 0;
   _exit(1);
  }
 }
 if ((i11 | 0) != -1 & i6) {
  __ZN7testing7MessageC2Ev(i8);
  i3 = HEAP32[i8 >> 2] | 0;
  i7 = i3 + 8 | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 164280, 40) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 162256, 18) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 164328, 3) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i7, i11) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 164336, 16) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 162280, 17) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 164360, 8) | 0;
  __ZN7testing7MessageC2ERKS0_(i9, i8);
  if (i3) {
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
   HEAP32[i8 >> 2] = 0;
  }
  __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i17, (HEAP32[i9 >> 2] | 0) + 12 | 0);
  i3 = HEAP8[i17 >> 0] | 0;
  if (!(i3 & 1)) {
   i2 = i17 + 1 | 0;
   i3 = (i3 & 255) >>> 1;
  } else {
   i2 = HEAP32[i17 + 8 >> 2] | 0;
   i3 = HEAP32[i17 + 4 >> 2] | 0;
  }
  i1 = i2 + i3 | 0;
  HEAP32[i12 + 0 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i12, i3 << 1);
  if (i3) do {
   i3 = HEAP8[i2 >> 0] | 0;
   if (!(i3 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i12, i3);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
  if (!(HEAP8[i12 >> 0] & 1)) {
   i9 = i12 + 1 | 0;
   __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(1, i9, i17);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
   i9 = HEAP32[_stdout >> 2] | 0;
   _fflush(i9 | 0) | 0;
   _exit(1);
  } else {
   i9 = HEAP32[i12 + 8 >> 2] | 0;
   __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(1, i9, i17);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
   i9 = HEAP32[_stdout >> 2] | 0;
   _fflush(i9 | 0) | 0;
   _exit(1);
  }
 }
 if ((i10 | 0) > -1 & (i10 | 0) < (i11 | 0)) {
  i10 = (i11 | 0) > 1;
  STACKTOP = i13;
  return i10 | 0;
 }
 __ZN7testing7MessageC2Ev(i14);
 i3 = HEAP32[i14 >> 2] | 0;
 i9 = i3 + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 164376, 47) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 162280, 17) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 164424, 3) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 162256, 18) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 164432, 15) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 162280, 17) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 163720, 1) | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i9, i10) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 164448, 2) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 162256, 18) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 163720, 1) | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i9, i11) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 161584, 2) | 0;
 __ZN7testing7MessageC2ERKS0_(i15, i14);
 if (i3) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
  HEAP32[i14 >> 2] = 0;
 }
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i17, (HEAP32[i15 >> 2] | 0) + 12 | 0);
 i1 = HEAP8[i17 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i17 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i17 + 8 >> 2] | 0;
  i1 = HEAP32[i17 + 4 >> 2] | 0;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i16 + 0 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i16, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i16, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
 if (!(HEAP8[i16 >> 0] & 1)) {
  i10 = i16 + 1 | 0;
  __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(1, i10, i17);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16);
  i10 = HEAP32[_stdout >> 2] | 0;
  _fflush(i10 | 0) | 0;
  _exit(1);
 } else {
  i10 = HEAP32[i16 + 8 >> 2] | 0;
  __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(1, i10, i17);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16);
  i10 = HEAP32[_stdout >> 2] | 0;
  _fflush(i10 | 0) | 0;
  _exit(1);
 }
 return 0;
}

function __ZNK2cv12_OutputArray6createENS_5Size_IiEEiibi(i17, i18, i20, i5, i2, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i20 = i20 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i19 = i21 + 88 | 0;
 i7 = i21 + 80 | 0;
 i12 = i21 + 72 | 0;
 i8 = i21 + 64 | 0;
 i13 = i21 + 56 | 0;
 i9 = i21 + 48 | 0;
 i14 = i21 + 40 | 0;
 i10 = i21 + 32 | 0;
 i15 = i21 + 24 | 0;
 i11 = i21 + 16 | 0;
 i16 = i21 + 8 | 0;
 i6 = i21;
 i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] & 127](i17) | 0;
 i3 = (i5 | 0) < 0;
 if ((i4 | 0) == 65536 & i3 ? (i1 | 0) == 0 & (i2 ^ 1) : 0) {
  do if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 104 >> 2] & 127](i17) | 0) {
   i10 = HEAP32[(HEAP32[i17 + 8 >> 2] | 0) + 40 >> 2] | 0;
   if ((HEAP32[i10 + 4 >> 2] | 0) == (HEAP32[i18 >> 2] | 0) ? (HEAP32[i10 >> 2] | 0) == (HEAP32[i18 + 4 >> 2] | 0) : 0) break;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i7, 53) | 0) + 0 | 0;
   i5 = 29400 | 0;
   i3 = i6 + 53 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 27672, 27528, 2086);
   __ZN2cv6String10deallocateEv(i7);
  } while (0);
  i4 = i17 + 8 | 0;
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 108 >> 2] & 127](i17) | 0 ? (HEAP32[HEAP32[i4 >> 2] >> 2] & 4095 | 0) != (i20 | 0) : 0) {
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i12, 44) | 0) + 0 | 0;
   i5 = 29456 | 0;
   i3 = i6 + 44 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i12, 27672, 27528, 2087);
   __ZN2cv6String10deallocateEv(i12);
  }
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i18 >> 2] | 0;
  i2 = HEAP32[i18 + 4 >> 2] | 0;
  i1 = i20 & 4095;
  if (((((HEAP32[i3 + 4 >> 2] | 0) < 3 ? (HEAP32[i3 + 8 >> 2] | 0) == (i2 | 0) : 0) ? (HEAP32[i3 + 12 >> 2] | 0) == (i4 | 0) : 0) ? (HEAP32[i3 >> 2] & 4095 | 0) == (i1 | 0) : 0) ? (HEAP32[i3 + 16 >> 2] | 0) != 0 : 0) {
   STACKTOP = i21;
   return;
  }
  HEAP32[i19 >> 2] = i2;
  HEAP32[i19 + 4 >> 2] = i4;
  __ZN2cv3Mat6createEiPKii(i3, 2, i19, i1);
  STACKTOP = i21;
  return;
 }
 if ((i4 | 0) == 655360 & i3 ? (i1 | 0) == 0 & (i2 ^ 1) : 0) {
  do if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 104 >> 2] & 127](i17) | 0) {
   i10 = HEAP32[(HEAP32[i17 + 8 >> 2] | 0) + 32 >> 2] | 0;
   if ((HEAP32[i10 + 4 >> 2] | 0) == (HEAP32[i18 >> 2] | 0) ? (HEAP32[i10 >> 2] | 0) == (HEAP32[i18 + 4 >> 2] | 0) : 0) break;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i8, 54) | 0) + 0 | 0;
   i5 = 29504 | 0;
   i3 = i6 + 54 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 27672, 27528, 2093);
   __ZN2cv6String10deallocateEv(i8);
  } while (0);
  i4 = i17 + 8 | 0;
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 108 >> 2] & 127](i17) | 0 ? (HEAP32[HEAP32[i4 >> 2] >> 2] & 4095 | 0) != (i20 | 0) : 0) {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i13, 45) | 0) + 0 | 0;
   i5 = 29560 | 0;
   i3 = i6 + 45 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i13, 27672, 27528, 2094);
   __ZN2cv6String10deallocateEv(i13);
  }
  i4 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i18 >> 2] | 0;
  i2 = HEAP32[i18 + 4 >> 2] | 0;
  i1 = i20 & 4095;
  if (((((HEAP32[i4 + 4 >> 2] | 0) < 3 ? (HEAP32[i4 + 8 >> 2] | 0) == (i2 | 0) : 0) ? (HEAP32[i4 + 12 >> 2] | 0) == (i3 | 0) : 0) ? (HEAP32[i4 >> 2] & 4095 | 0) == (i1 | 0) : 0) ? (HEAP32[i4 + 24 >> 2] | 0) != 0 : 0) {
   STACKTOP = i21;
   return;
  }
  HEAP32[i19 >> 2] = i2;
  HEAP32[i19 + 4 >> 2] = i3;
  __ZN2cv4UMat6createEiPKiiNS_14UMatUsageFlagsE(i4, 2, i19, i1, 0);
  STACKTOP = i21;
  return;
 }
 if ((i4 | 0) == 589824 & i3 ? (i1 | 0) == 0 & (i2 ^ 1) : 0) {
  do if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 104 >> 2] & 127](i17) | 0) {
   i10 = HEAP32[i17 + 8 >> 2] | 0;
   if ((HEAP32[i10 + 8 >> 2] | 0) == (HEAP32[i18 >> 2] | 0) ? (HEAP32[i10 + 4 >> 2] | 0) == (HEAP32[i18 + 4 >> 2] | 0) : 0) break;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i9, 51) | 0) + 0 | 0;
   i5 = 29608 | 0;
   i3 = i6 + 51 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i9, 27672, 27528, 2100);
   __ZN2cv6String10deallocateEv(i9);
  } while (0);
  i4 = i17 + 8 | 0;
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 108 >> 2] & 127](i17) | 0 ? (HEAP32[HEAP32[i4 >> 2] >> 2] & 4095 | 0) != (i20 | 0) : 0) {
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i14, 53) | 0) + 0 | 0;
   i5 = 29664 | 0;
   i3 = i6 + 53 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i14, 27672, 27528, 2101);
   __ZN2cv6String10deallocateEv(i14);
  }
  __ZN2cv4cuda6GpuMat6createEiii(HEAP32[i4 >> 2] | 0, HEAP32[i18 + 4 >> 2] | 0, HEAP32[i18 >> 2] | 0, i20);
  STACKTOP = i21;
  return;
 }
 if ((i4 | 0) == 458752 & i3 ? (i1 | 0) == 0 & (i2 ^ 1) : 0) {
  do if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 104 >> 2] & 127](i17) | 0) {
   i9 = HEAP32[i17 + 8 >> 2] | 0;
   if ((HEAP32[i9 + 12 >> 2] | 0) == (HEAP32[i18 >> 2] | 0) ? (HEAP32[i9 + 8 >> 2] | 0) == (HEAP32[i18 + 4 >> 2] | 0) : 0) break;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i10, 50) | 0) + 0 | 0;
   i5 = 29720 | 0;
   i3 = i6 + 50 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 27672, 27528, 2107);
   __ZN2cv6String10deallocateEv(i10);
  } while (0);
  i4 = i17 + 8 | 0;
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 108 >> 2] & 127](i17) | 0 ? (HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0) != (i20 | 0) : 0) {
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i15, 52) | 0) + 0 | 0;
   i5 = 29776 | 0;
   i3 = i6 + 52 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i15, 27672, 27528, 2108);
   __ZN2cv6String10deallocateEv(i15);
  }
  __ZN2cv3ogl6Buffer6createEiiiNS1_6TargetEb(HEAP32[i4 >> 2] | 0, HEAP32[i18 + 4 >> 2] | 0, HEAP32[i18 >> 2] | 0, i20, 34962, 0);
  STACKTOP = i21;
  return;
 }
 if ((i4 | 0) == 524288 & i3 ? (i1 | 0) == 0 & (i2 ^ 1) : 0) {
  do if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 104 >> 2] & 127](i17) | 0) {
   i10 = HEAP32[i17 + 8 >> 2] | 0;
   if ((HEAP32[i10 + 8 >> 2] | 0) == (HEAP32[i18 >> 2] | 0) ? (HEAP32[i10 + 4 >> 2] | 0) == (HEAP32[i18 + 4 >> 2] | 0) : 0) break;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i11, 52) | 0) + 0 | 0;
   i5 = 29832 | 0;
   i3 = i6 + 52 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i11, 27672, 27528, 2114);
   __ZN2cv6String10deallocateEv(i11);
  } while (0);
  i4 = i17 + 8 | 0;
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 108 >> 2] & 127](i17) | 0 ? (HEAP32[HEAP32[i4 >> 2] >> 2] & 4095 | 0) != (i20 | 0) : 0) {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i16, 54) | 0) + 0 | 0;
   i5 = 29888 | 0;
   i3 = i6 + 54 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i16, 27672, 27528, 2115);
   __ZN2cv6String10deallocateEv(i16);
  }
  __ZN2cv4cuda7CudaMem6createEiii(HEAP32[i4 >> 2] | 0, HEAP32[i18 + 4 >> 2] | 0, HEAP32[i18 >> 2] | 0, i20);
  STACKTOP = i21;
  return;
 }
 HEAP32[i6 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i18 >> 2];
 FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i17 >> 2] | 0) + 144 >> 2] & 63](i17, 2, i6, i20, i5, i2, i1);
 STACKTOP = i21;
 return;
}

function __ZN7testing8internal24XmlUnitTestResultPrinter16PrintXmlTestCaseEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS_8TestCaseE(i29, i25) {
 i29 = i29 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 i30 = i31 + 168 | 0;
 i7 = i31 + 156 | 0;
 i6 = i31 + 144 | 0;
 i5 = i31 + 132 | 0;
 i4 = i31 + 120 | 0;
 i3 = i31 + 116 | 0;
 i2 = i31 + 104 | 0;
 i12 = i31 + 92 | 0;
 i15 = i31 + 88 | 0;
 i22 = i31 + 76 | 0;
 i23 = i31 + 64 | 0;
 i17 = i31 + 60 | 0;
 i18 = i31 + 48 | 0;
 i19 = i31 + 36 | 0;
 i20 = i31 + 24 | 0;
 i21 = i31 + 12 | 0;
 i24 = i31;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i30, 163536, 9);
 i9 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i29, 163552, 3) | 0;
 i10 = HEAP8[i30 >> 0] | 0;
 if (!(i10 & 1)) {
  i8 = i30 + 1 | 0;
  i10 = (i10 & 255) >>> 1;
 } else {
  i8 = HEAP32[i30 + 8 >> 2] | 0;
  i10 = HEAP32[i30 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, i8, i10) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, 163344, 4);
 i28 = i25 + 4 | 0;
 if (!(HEAP8[i28 >> 0] & 1)) i10 = i28 + 1 | 0; else i10 = HEAP32[i25 + 12 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i10, _strlen(i10 | 0) | 0);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i29, i30, i7, i6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, 162464, 5);
 i26 = i25 + 20 | 0;
 i10 = HEAP32[i26 >> 2] | 0;
 i27 = i25 + 24 | 0;
 i8 = HEAP32[i27 >> 2] | 0;
 if ((i10 | 0) == (i8 | 0)) i10 = 0; else {
  i9 = i10;
  i10 = 0;
  do {
   i10 = (HEAPU8[(HEAP32[i9 >> 2] | 0) + 38 >> 0] | 0) + i10 | 0;
   i9 = i9 + 4 | 0;
  } while ((i9 | 0) != (i8 | 0));
 }
 HEAP32[i3 >> 2] = i10;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i4, i3);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i29, i30, i5, i4);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, 163560, 8);
 i9 = HEAP32[i26 >> 2] | 0;
 i10 = HEAP32[i27 >> 2] | 0;
 L13 : do if ((i9 | 0) == (i10 | 0)) i16 = 0; else {
  i8 = 0;
  L14 : while (1) {
   i7 = HEAP32[i9 >> 2] | 0;
   if ((HEAP8[i7 + 36 >> 0] | 0) != 0 ? (i1 = i7 + 52 | 0, i11 = i7 + 56 | 0, i13 = HEAP32[i11 >> 2] | 0, i14 = HEAP32[i1 >> 2] | 0, (i13 - i14 | 0) > 0) : 0) {
    i10 = i14;
    i7 = i13;
    i6 = 0;
    while (1) {
     if (((i7 - i10 | 0) / 44 | 0) >>> 0 <= i6 >>> 0) break L14;
     if (HEAP32[i10 + (i6 * 44 | 0) >> 2] | 0) {
      i10 = 1;
      break;
     }
     i6 = i6 + 1 | 0;
     i7 = HEAP32[i11 >> 2] | 0;
     if ((i6 | 0) >= ((i7 - i10 | 0) / 44 | 0 | 0)) {
      i10 = 0;
      break;
     }
    }
    i7 = i10;
    i10 = HEAP32[i27 >> 2] | 0;
   } else i7 = 0;
   i8 = i7 + i8 | 0;
   i9 = i9 + 4 | 0;
   if ((i9 | 0) == (i10 | 0)) {
    i16 = i8;
    break L13;
   }
  }
  __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i1);
 } while (0);
 HEAP32[i15 >> 2] = i16;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i12, i15);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i29, i30, i2, i12);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, 163576, 8);
 i5 = HEAP32[i26 >> 2] | 0;
 i10 = HEAP32[i27 >> 2] | 0;
 if ((i5 | 0) == (i10 | 0)) i2 = 0; else {
  i2 = 0;
  do {
   i4 = HEAP32[i5 >> 2] | 0;
   if (!(HEAP8[i4 + 38 >> 0] | 0)) i4 = 0; else i4 = (HEAP8[i4 + 37 >> 0] | 0) != 0;
   i2 = (i4 & 1) + i2 | 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) != (i10 | 0));
 }
 HEAP32[i17 >> 2] = i2;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i23, i17);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i29, i30, i22, i23);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, 163592, 6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i19, 163600, 1);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i29, i30, i18, i19);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i18);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i20, 163408, 4);
 i2 = i25 + 56 | 0;
 __ZN7testing8internal27FormatTimeInMillisAsSecondsEx(i21, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
 __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i29, i30, i20, i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
 __ZN7testing8internal24XmlUnitTestResultPrinter29TestPropertiesAsXmlAttributesERKNS_10TestResultE(i24, i25 + 64 | 0);
 i2 = HEAP8[i24 >> 0] | 0;
 if (!(i2 & 1)) {
  i1 = i24 + 1 | 0;
  i2 = (i2 & 255) >>> 1;
 } else {
  i1 = HEAP32[i24 + 8 >> 2] | 0;
  i2 = HEAP32[i24 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i29, i1, i2) | 0, 163432, 2) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
 i1 = HEAP32[i27 >> 2] | 0;
 i2 = HEAP32[i26 >> 2] | 0;
 if ((i1 - i2 | 0) > 0) {
  i8 = i25 + 32 | 0;
  i9 = i28 + 1 | 0;
  i10 = i25 + 36 | 0;
  i7 = i25 + 12 | 0;
  i6 = 0;
  do {
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i3 + (i6 << 2) >> 2] | 0;
   i5 = HEAP32[i2 + (i4 << 2) >> 2] | 0;
   if (HEAP8[i5 + 38 >> 0] | 0) {
    if (!(HEAP8[i28 >> 0] & 1)) i2 = i9; else i2 = HEAP32[i7 >> 2] | 0;
    __ZN7testing8internal24XmlUnitTestResultPrinter17OutputXmlTestInfoEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEEPKcRKNS_8TestInfoE(i29, i2, ((i4 | 0) < 0 ? 1 : ((HEAP32[i10 >> 2] | 0) - i3 >> 2 | 0) <= (i6 | 0)) ? 0 : i5);
    i1 = HEAP32[i27 >> 2] | 0;
    i2 = HEAP32[i26 >> 2] | 0;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) < (i1 - i2 >> 2 | 0));
 }
 i1 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i29, 163608, 4) | 0;
 i2 = HEAP8[i30 >> 0] | 0;
 if (!(i2 & 1)) {
  i21 = i30 + 1 | 0;
  i22 = (i2 & 255) >>> 1;
  i22 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i21, i22) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i22, 163432, 2) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i30);
  STACKTOP = i31;
  return;
 } else {
  i21 = HEAP32[i30 + 8 >> 2] | 0;
  i22 = HEAP32[i30 + 4 >> 2] | 0;
  i22 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i21, i22) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i22, 163432, 2) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i30);
  STACKTOP = i31;
  return;
 }
}

function __ZN2cvL15transpose_32sC4EPKhjPhjNS_5Size_IiEE(i16, i17, i14, i15, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i18 = STACKTOP;
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i13 + -4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i8 = i12 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i12 & -4;
  i11 = 0;
  do {
   i5 = i14 + (Math_imul(i11, i15) | 0) | 0;
   i4 = i14 + (Math_imul(i11 | 1, i15) | 0) | 0;
   i3 = i14 + (Math_imul(i11 | 2, i15) | 0) | 0;
   i2 = i14 + (Math_imul(i11 | 3, i15) | 0) | 0;
   if (i9) i7 = 0; else {
    i7 = i11 << 4;
    i6 = 0;
    do {
     i26 = (Math_imul(i6, i17) | 0) + i7 | 0;
     i30 = i16 + i26 | 0;
     i23 = i6 | 1;
     i24 = (Math_imul(i23, i17) | 0) + i7 | 0;
     i29 = i16 + i24 | 0;
     i21 = i6 | 2;
     i22 = (Math_imul(i21, i17) | 0) + i7 | 0;
     i28 = i16 + i22 | 0;
     i19 = i6 | 3;
     i20 = (Math_imul(i19, i17) | 0) + i7 | 0;
     i27 = i16 + i20 | 0;
     i25 = i5 + (i6 << 4) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i30 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
     i25 = i5 + (i23 << 4) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i29 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
     i25 = i5 + (i21 << 4) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i28 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
     i25 = i5 + (i19 << 4) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     i25 = i4 + (i6 << 4) | 0;
     i27 = i16 + (i26 + 16) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     i25 = i4 + (i23 << 4) | 0;
     i27 = i16 + (i24 + 16) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     i25 = i4 + (i21 << 4) | 0;
     i27 = i16 + (i22 + 16) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     i25 = i4 + (i19 << 4) | 0;
     i27 = i16 + (i20 + 16) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     i25 = i3 + (i6 << 4) | 0;
     i27 = i16 + (i26 + 32) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     i25 = i3 + (i23 << 4) | 0;
     i27 = i16 + (i24 + 32) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     i25 = i3 + (i21 << 4) | 0;
     i27 = i16 + (i22 + 32) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     i25 = i3 + (i19 << 4) | 0;
     i27 = i16 + (i20 + 32) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     i25 = i2 + (i6 << 4) | 0;
     i26 = i16 + (i26 + 48) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i26 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
     i23 = i2 + (i23 << 4) | 0;
     i24 = i16 + (i24 + 48) | 0;
     HEAP32[i23 + 0 >> 2] = HEAP32[i24 + 0 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     HEAP32[i23 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
     i21 = i2 + (i21 << 4) | 0;
     i22 = i16 + (i22 + 48) | 0;
     HEAP32[i21 + 0 >> 2] = HEAP32[i22 + 0 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
     HEAP32[i21 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
     i19 = i2 + (i19 << 4) | 0;
     i20 = i16 + (i20 + 48) | 0;
     HEAP32[i19 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i19 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i8 | 0));
    i7 = i10;
   }
   if ((i7 | 0) < (i12 | 0)) {
    i6 = i11 << 4;
    do {
     i21 = (Math_imul(i7, i17) | 0) + i6 | 0;
     i20 = i16 + i21 | 0;
     i22 = i5 + (i7 << 4) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     i22 = i4 + (i7 << 4) | 0;
     i20 = i16 + (i21 + 16) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     i22 = i3 + (i7 << 4) | 0;
     i20 = i16 + (i21 + 32) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     i22 = i2 + (i7 << 4) | 0;
     i21 = i16 + (i21 + 48) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i12 | 0));
   }
   i11 = i11 + 4 | 0;
  } while ((i11 | 0) <= (i1 | 0));
  i1 = i13 & -4;
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i18;
  return;
 }
 i5 = i12 + -4 | 0;
 i6 = (i5 | 0) < 0;
 i7 = i12 & -4;
 do {
  i4 = i14 + (Math_imul(i1, i15) | 0) | 0;
  if (i6) i2 = 0; else {
   i2 = i1 << 4;
   i3 = 0;
   do {
    i10 = i16 + ((Math_imul(i3, i17) | 0) + i2) | 0;
    i11 = i3 | 1;
    i8 = i16 + ((Math_imul(i11, i17) | 0) + i2) | 0;
    i20 = i3 | 2;
    i19 = i16 + ((Math_imul(i20, i17) | 0) + i2) | 0;
    i22 = i3 | 3;
    i21 = i16 + ((Math_imul(i22, i17) | 0) + i2) | 0;
    i9 = i4 + (i3 << 4) | 0;
    HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    i11 = i4 + (i11 << 4) | 0;
    HEAP32[i11 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    i20 = i4 + (i20 << 4) | 0;
    HEAP32[i20 + 0 >> 2] = HEAP32[i19 + 0 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i20 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    i22 = i4 + (i22 << 4) | 0;
    HEAP32[i22 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i5 | 0));
   i2 = i7;
  }
  if ((i2 | 0) < (i12 | 0)) {
   i3 = i1 << 4;
   do {
    i21 = i16 + ((Math_imul(i2, i17) | 0) + i3) | 0;
    i22 = i4 + (i2 << 4) | 0;
    HEAP32[i22 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i12 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i18;
 return;
}

function __ZNSt3__127__insertion_sort_incompleteIRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEbT0_S9_T_(i21, i22, i20) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i12 = i23 + 32 | 0;
 i19 = i23;
 switch (i22 - i21 >> 5 | 0) {
 case 2:
  {
   i8 = i22 + -32 | 0;
   if (!(FUNCTION_TABLE_iii[HEAP32[i20 >> 2] & 127](i8, i21) | 0)) {
    i22 = 1;
    STACKTOP = i23;
    return i22 | 0;
   }
   i3 = HEAP32[i21 >> 2] | 0;
   HEAP32[i12 >> 2] = i3;
   i7 = i12 + 4 | 0;
   i2 = i21 + 4 | 0;
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   if (i3) {
    i20 = i3 + -4 | 0;
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
   }
   i11 = i12 + 8 | 0;
   i4 = HEAP32[i21 + 8 >> 2] | 0;
   HEAP32[i11 >> 2] = i4;
   i9 = i12 + 12 | 0;
   i5 = i21 + 12 | 0;
   HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
   if (i4) {
    i20 = i4 + -4 | 0;
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
   }
   i1 = i21 + 16 | 0;
   __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i12 + 16 | 0, i1);
   i10 = i12 + 28 | 0;
   i6 = i21 + 28 | 0;
   HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
   if ((i8 | 0) != (i21 | 0)) {
    __ZN2cv6String10deallocateEv(i21);
    i4 = HEAP32[i8 >> 2] | 0;
    if (!i4) i4 = 0; else {
     i4 = i4 + -4 | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     i4 = HEAP32[i8 >> 2] | 0;
    }
    HEAP32[i21 >> 2] = i4;
    HEAP32[i2 >> 2] = HEAP32[i22 + -28 >> 2];
    i2 = i21 + 8 | 0;
    __ZN2cv6String10deallocateEv(i2);
    i4 = i22 + -24 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) i4 = 0; else {
     i21 = i3 + -4 | 0;
     HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
     i4 = HEAP32[i4 >> 2] | 0;
    }
    HEAP32[i2 >> 2] = i4;
    HEAP32[i5 >> 2] = HEAP32[i22 + -20 >> 2];
    __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i1, HEAP32[i22 + -16 >> 2] | 0, HEAP32[i22 + -12 >> 2] | 0);
   }
   i1 = i22 + -4 | 0;
   HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
   if ((i12 | 0) == (i8 | 0)) i4 = i12 + 16 | 0; else {
    __ZN2cv6String10deallocateEv(i8);
    i4 = HEAP32[i12 >> 2] | 0;
    if (!i4) i4 = 0; else {
     i4 = i4 + -4 | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     i4 = HEAP32[i12 >> 2] | 0;
    }
    HEAP32[i8 >> 2] = i4;
    HEAP32[i22 + -28 >> 2] = HEAP32[i7 >> 2];
    i2 = i22 + -24 | 0;
    __ZN2cv6String10deallocateEv(i2);
    i4 = i12 + 8 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) i3 = 0; else {
     i3 = i3 + -4 | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i4 >> 2] | 0;
    }
    HEAP32[i2 >> 2] = i3;
    HEAP32[i22 + -20 >> 2] = HEAP32[i9 >> 2];
    i4 = i12 + 16 | 0;
    __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i22 + -16 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i12 + 20 >> 2] | 0);
   }
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2) {
    i1 = i12 + 20 | 0;
    while (1) {
     i3 = HEAP32[i1 >> 2] | 0;
     if ((i3 | 0) == (i2 | 0)) break;
     i22 = i3 + -8 | 0;
     HEAP32[i1 >> 2] = i22;
     __ZN2cv6String10deallocateEv(i22);
    }
    __ZdlPv(HEAP32[i4 >> 2] | 0);
   }
   __ZN2cv6String10deallocateEv(i11);
   __ZN2cv6String10deallocateEv(i12);
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 5:
  {
   __ZNSt3__17__sort5IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_S9_S9_T_(i21, i21 + 32 | 0, i21 + 64 | 0, i21 + 96 | 0, i22 + -32 | 0, i20) | 0;
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 1:
 case 0:
  {
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 4:
  {
   __ZNSt3__17__sort4IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_S9_T_(i21, i21 + 32 | 0, i21 + 64 | 0, i22 + -32 | 0, i20) | 0;
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 3:
  {
   __ZNSt3__17__sort3IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_T_(i21, i21 + 32 | 0, i22 + -32 | 0, i20) | 0;
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 default:
  {
   i3 = i21 + 64 | 0;
   __ZNSt3__17__sort3IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_T_(i21, i21 + 32 | 0, i3, i20) | 0;
   i4 = i21 + 96 | 0;
   if ((i4 | 0) == (i22 | 0)) {
    i22 = 1;
    STACKTOP = i23;
    return i22 | 0;
   }
   i11 = i19 + 4 | 0;
   i10 = i19 + 8 | 0;
   i13 = i19 + 12 | 0;
   i14 = i19 + 16 | 0;
   i15 = i19 + 28 | 0;
   i16 = i19 + 16 | 0;
   i17 = i19 + 20 | 0;
   i18 = i19 + 8 | 0;
   i1 = 0;
   i12 = 0;
   i2 = i3;
   while (1) {
    if (FUNCTION_TABLE_iii[HEAP32[i20 >> 2] & 127](i4, i2) | 0) {
     i3 = HEAP32[i4 >> 2] | 0;
     HEAP32[i19 >> 2] = i3;
     HEAP32[i11 >> 2] = HEAP32[i4 + 4 >> 2];
     if (i3) {
      i3 = i3 + -4 | 0;
      HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     }
     i3 = HEAP32[i4 + 8 >> 2] | 0;
     HEAP32[i10 >> 2] = i3;
     HEAP32[i13 >> 2] = HEAP32[i4 + 12 >> 2];
     if (i3) {
      i3 = i3 + -4 | 0;
      HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     }
     __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i14, i4 + 16 | 0);
     HEAP32[i15 >> 2] = HEAP32[i4 + 28 >> 2];
     i9 = i4;
     while (1) {
      if ((i2 | 0) != (i9 | 0)) {
       __ZN2cv6String10deallocateEv(i9);
       i3 = HEAP32[i2 >> 2] | 0;
       if (!i3) i3 = 0; else {
        i3 = i3 + -4 | 0;
        HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
        i3 = HEAP32[i2 >> 2] | 0;
       }
       HEAP32[i9 >> 2] = i3;
       HEAP32[i9 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
       i7 = i9 + 8 | 0;
       __ZN2cv6String10deallocateEv(i7);
       i6 = i2 + 8 | 0;
       i5 = HEAP32[i6 >> 2] | 0;
       if (!i5) i3 = 0; else {
        i3 = i5 + -4 | 0;
        HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
        i3 = HEAP32[i6 >> 2] | 0;
       }
       HEAP32[i7 >> 2] = i3;
       HEAP32[i9 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
       __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i9 + 16 | 0, HEAP32[i2 + 16 >> 2] | 0, HEAP32[i2 + 20 >> 2] | 0);
      }
      i8 = i2 + 28 | 0;
      HEAP32[i9 + 28 >> 2] = HEAP32[i8 >> 2];
      if ((i2 | 0) == (i21 | 0)) {
       i2 = i21;
       break;
      }
      i3 = i2 + -32 | 0;
      if (FUNCTION_TABLE_iii[HEAP32[i20 >> 2] & 127](i19, i3) | 0) {
       i9 = i2;
       i2 = i3;
      } else break;
     }
     if ((i19 | 0) != (i2 | 0)) {
      __ZN2cv6String10deallocateEv(i2);
      i3 = HEAP32[i19 >> 2] | 0;
      if (!i3) i3 = 0; else {
       i3 = i3 + -4 | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       i3 = HEAP32[i19 >> 2] | 0;
      }
      HEAP32[i2 >> 2] = i3;
      HEAP32[i2 + 4 >> 2] = HEAP32[i11 >> 2];
      i6 = i2 + 8 | 0;
      __ZN2cv6String10deallocateEv(i6);
      i3 = HEAP32[i18 >> 2] | 0;
      if (!i3) i3 = 0; else {
       i3 = i3 + -4 | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       i3 = HEAP32[i18 >> 2] | 0;
      }
      HEAP32[i6 >> 2] = i3;
      HEAP32[i2 + 12 >> 2] = HEAP32[i13 >> 2];
      __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i2 + 16 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i17 >> 2] | 0);
     }
     HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
     i7 = i12 + 1 | 0;
     if ((i7 | 0) == 8) {
      i4 = i4 + 32 | 0;
      i6 = 1;
      i1 = (i4 | 0) == (i22 | 0);
     } else i6 = 0;
     i3 = HEAP32[i16 >> 2] | 0;
     if (i3) {
      while (1) {
       i2 = HEAP32[i17 >> 2] | 0;
       if ((i2 | 0) == (i3 | 0)) break;
       i12 = i2 + -8 | 0;
       HEAP32[i17 >> 2] = i12;
       __ZN2cv6String10deallocateEv(i12);
      }
      __ZdlPv(HEAP32[i16 >> 2] | 0);
     }
     __ZN2cv6String10deallocateEv(i10);
     __ZN2cv6String10deallocateEv(i19);
     if (i6) {
      i2 = 59;
      break;
     } else {
      i3 = i7;
      i2 = i4;
     }
    } else {
     i3 = i12;
     i2 = i4;
    }
    i4 = i2 + 32 | 0;
    if ((i4 | 0) == (i22 | 0)) {
     i1 = 1;
     i2 = 59;
     break;
    } else i12 = i3;
   }
   if ((i2 | 0) == 59) {
    STACKTOP = i23;
    return i1 | 0;
   }
  }
 }
 return 0;
}

function __ZN2cv11JacobiImpl_IdEEbPT_jS2_S2_jiPh(i23, i1, i27, i26, i2, i28, i4) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 i2 = i2 | 0;
 i28 = i28 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, i12 = 0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i29 = 0, i30 = 0, i31 = 0;
 i29 = STACKTOP;
 i22 = i1 >>> 3;
 i25 = (i26 | 0) != 0;
 if (i25) {
  i2 = i2 >>> 3;
  if ((i28 | 0) > 0) {
   i1 = i28 << 3;
   i3 = 0;
   do {
    i21 = Math_imul(i2, i3) | 0;
    _memset(i26 + (i21 << 3) | 0, 0, i1 | 0) | 0;
    HEAPF64[i26 + (i21 + i3 << 3) >> 3] = 1.0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i28 | 0));
  }
 }
 i21 = Math_imul(i28 * 30 | 0, i28) | 0;
 i20 = i4 + 3 & -4;
 i24 = (i28 | 0) > 0;
 L7 : do if (i24) {
  i1 = i22 + 1 | 0;
  i12 = i28 + -1 | 0;
  i14 = 0;
  do {
   HEAPF64[i27 + (i14 << 3) >> 3] = +HEAPF64[i23 + ((Math_imul(i14, i1) | 0) << 3) >> 3];
   if ((i14 | 0) < (i12 | 0)) {
    i6 = i14 + 1 | 0;
    i3 = Math_imul(i14, i22) | 0;
    i4 = i14 + 2 | 0;
    if ((i4 | 0) < (i28 | 0)) {
     i5 = i4;
     i4 = i6;
     d7 = +Math_abs(+(+HEAPF64[i23 + (i3 + i6 << 3) >> 3]));
     while (1) {
      d8 = +Math_abs(+(+HEAPF64[i23 + (i5 + i3 << 3) >> 3]));
      i6 = d7 < d8;
      i4 = i6 ? i5 : i4;
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i28 | 0)) break; else d7 = i6 ? d8 : d7;
     }
    } else i4 = i6;
    HEAP32[i20 + (i14 << 2) >> 2] = i4;
   }
   if ((i14 | 0) > 0) {
    if ((i14 | 0) > 1) {
     i5 = 1;
     i4 = 0;
     d8 = +Math_abs(+(+HEAPF64[i23 + (i14 << 3) >> 3]));
     while (1) {
      d7 = +Math_abs(+(+HEAPF64[i23 + ((Math_imul(i5, i22) | 0) + i14 << 3) >> 3]));
      i6 = d8 < d7;
      i4 = i6 ? i5 : i4;
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i14 | 0)) break; else d8 = i6 ? d7 : d8;
     }
    } else i4 = 0;
    HEAP32[i20 + (i14 + i28 << 2) >> 2] = i4;
   }
   i14 = i14 + 1 | 0;
  } while ((i14 | 0) != (i28 | 0));
  if ((i28 | 0) > 1 & (i21 | 0) > 0) {
   i17 = i28 + -1 | 0;
   i18 = (i17 | 0) > 1;
   i19 = 0;
   do {
    i6 = HEAP32[i20 >> 2] | 0;
    d8 = +Math_abs(+(+HEAPF64[i23 + (i6 << 3) >> 3]));
    if (i18) {
     i6 = 1;
     i5 = 0;
     do {
      i1 = Math_imul(i6, i22) | 0;
      d7 = +Math_abs(+(+HEAPF64[i23 + ((HEAP32[i20 + (i6 << 2) >> 2] | 0) + i1 << 3) >> 3]));
      i1 = d8 < d7;
      d8 = i1 ? d7 : d8;
      i5 = i1 ? i6 : i5;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i17 | 0));
     i4 = 1;
     i15 = i5;
     i16 = HEAP32[i20 + (i5 << 2) >> 2] | 0;
    } else {
     i4 = 1;
     i15 = 0;
     i16 = i6;
    }
    while (1) {
     i1 = HEAP32[i20 + (i4 + i28 << 2) >> 2] | 0;
     d7 = +Math_abs(+(+HEAPF64[i23 + ((Math_imul(i1, i22) | 0) + i4 << 3) >> 3]));
     i6 = d8 < d7;
     i16 = i6 ? i4 : i16;
     i15 = i6 ? i1 : i15;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i28 | 0)) break; else d8 = i6 ? d7 : d8;
    }
    i1 = Math_imul(i15, i22) | 0;
    i6 = i23 + (i1 + i16 << 3) | 0;
    d11 = +HEAPF64[i6 >> 3];
    d9 = +Math_abs(+d11);
    if (d9 <= 2.220446049250313e-16) break L7;
    i5 = i27 + (i16 << 3) | 0;
    i4 = i27 + (i15 << 3) | 0;
    d13 = (+HEAPF64[i5 >> 3] - +HEAPF64[i4 >> 3]) * .5;
    d7 = +Math_abs(+d13);
    if (!(d9 > d7)) if (d13 != d13 | 0.0 != 0.0 | d13 == 0.0) d8 = 0.0; else {
     d8 = d9 / d7;
     d8 = d7 * +Math_sqrt(+(d8 * d8 + 1.0));
    } else {
     d8 = d7 / d9;
     d8 = d9 * +Math_sqrt(+(d8 * d8 + 1.0));
    }
    d10 = d7 + d8;
    d8 = +Math_abs(+d10);
    if (!(d9 > d8)) if (d10 != d10 | 0.0 != 0.0 | d10 == 0.0) d8 = 0.0; else {
     d7 = d9 / d8;
     d8 = d8 * +Math_sqrt(+(d7 * d7 + 1.0));
    } else {
     d8 = d8 / d9;
     d8 = d9 * +Math_sqrt(+(d8 * d8 + 1.0));
    }
    d9 = d10 / d8;
    d7 = d11 / d8;
    d8 = d11 * (d11 / d10);
    if (d13 < 0.0) {
     d7 = -d7;
     d8 = -d8;
    }
    HEAPF64[i6 >> 3] = 0.0;
    HEAPF64[i4 >> 3] = +HEAPF64[i4 >> 3] - d8;
    HEAPF64[i5 >> 3] = d8 + +HEAPF64[i5 >> 3];
    i14 = (i15 | 0) > 0;
    if (i14) {
     i6 = 0;
     do {
      i12 = Math_imul(i6, i22) | 0;
      i3 = i23 + (i12 + i15 << 3) | 0;
      d10 = +HEAPF64[i3 >> 3];
      i12 = i23 + (i12 + i16 << 3) | 0;
      d8 = +HEAPF64[i12 >> 3];
      HEAPF64[i3 >> 3] = d9 * d10 - d7 * d8;
      HEAPF64[i12 >> 3] = d7 * d10 + d9 * d8;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i15 | 0));
    }
    i3 = i15 + 1 | 0;
    if ((i3 | 0) < (i16 | 0)) {
     i6 = i3;
     do {
      i4 = i23 + (i6 + i1 << 3) | 0;
      d10 = +HEAPF64[i4 >> 3];
      i12 = i23 + ((Math_imul(i6, i22) | 0) + i16 << 3) | 0;
      d8 = +HEAPF64[i12 >> 3];
      HEAPF64[i4 >> 3] = d9 * d10 - d7 * d8;
      HEAPF64[i12 >> 3] = d7 * d10 + d9 * d8;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i16 | 0));
    }
    i12 = i16 + 1 | 0;
    if ((i12 | 0) < (i28 | 0)) {
     i6 = Math_imul(i16, i22) | 0;
     i5 = i12;
     do {
      i30 = i23 + (i5 + i1 << 3) | 0;
      d10 = +HEAPF64[i30 >> 3];
      i4 = i23 + (i5 + i6 << 3) | 0;
      d8 = +HEAPF64[i4 >> 3];
      HEAPF64[i30 >> 3] = d9 * d10 - d7 * d8;
      HEAPF64[i4 >> 3] = d7 * d10 + d9 * d8;
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i28 | 0));
    }
    if (i25 & i24) {
     i6 = Math_imul(i15, i2) | 0;
     i5 = Math_imul(i16, i2) | 0;
     i4 = 0;
     do {
      i31 = i26 + (i4 + i6 << 3) | 0;
      d10 = +HEAPF64[i31 >> 3];
      i30 = i26 + (i4 + i5 << 3) | 0;
      d8 = +HEAPF64[i30 >> 3];
      HEAPF64[i31 >> 3] = d9 * d10 - d7 * d8;
      HEAPF64[i30 >> 3] = d7 * d10 + d9 * d8;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i28 | 0));
    }
    if ((i15 | 0) < (i17 | 0)) {
     i6 = i15 + 2 | 0;
     if ((i6 | 0) < (i28 | 0)) {
      i4 = i6;
      i6 = i3;
      d7 = +Math_abs(+(+HEAPF64[i23 + (i1 + i3 << 3) >> 3]));
      while (1) {
       d8 = +Math_abs(+(+HEAPF64[i23 + (i4 + i1 << 3) >> 3]));
       i5 = d7 < d8;
       i6 = i5 ? i4 : i6;
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i28 | 0)) break; else d7 = i5 ? d8 : d7;
      }
     } else i6 = i3;
     HEAP32[i20 + (i15 << 2) >> 2] = i6;
    }
    if (i14) {
     if ((i15 | 0) > 1) {
      i4 = 1;
      i6 = 0;
      d7 = +Math_abs(+(+HEAPF64[i23 + (i15 << 3) >> 3]));
      while (1) {
       d8 = +Math_abs(+(+HEAPF64[i23 + ((Math_imul(i4, i22) | 0) + i15 << 3) >> 3]));
       i5 = d7 < d8;
       i6 = i5 ? i4 : i6;
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i15 | 0)) break; else d7 = i5 ? d8 : d7;
      }
     } else i6 = 0;
     HEAP32[i20 + (i15 + i28 << 2) >> 2] = i6;
    }
    if ((i16 | 0) < (i17 | 0)) {
     i3 = Math_imul(i16, i22) | 0;
     i6 = i16 + 2 | 0;
     if ((i6 | 0) < (i28 | 0)) {
      i4 = i12;
      d7 = +Math_abs(+(+HEAPF64[i23 + (i3 + i12 << 3) >> 3]));
      while (1) {
       d8 = +Math_abs(+(+HEAPF64[i23 + (i6 + i3 << 3) >> 3]));
       i5 = d7 < d8;
       i4 = i5 ? i6 : i4;
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i28 | 0)) break; else d7 = i5 ? d8 : d7;
      }
     } else i4 = i12;
     HEAP32[i20 + (i16 << 2) >> 2] = i4;
    }
    if ((i16 | 0) > 0) {
     if ((i16 | 0) > 1) {
      i5 = 1;
      i4 = 0;
      d7 = +Math_abs(+(+HEAPF64[i23 + (i16 << 3) >> 3]));
      while (1) {
       d8 = +Math_abs(+(+HEAPF64[i23 + ((Math_imul(i5, i22) | 0) + i16 << 3) >> 3]));
       i6 = d7 < d8;
       i4 = i6 ? i5 : i4;
       i5 = i5 + 1 | 0;
       if ((i5 | 0) == (i16 | 0)) break; else d7 = i6 ? d8 : d7;
      }
     } else i4 = 0;
     HEAP32[i20 + (i16 + i28 << 2) >> 2] = i4;
    }
    i19 = i19 + 1 | 0;
   } while ((i19 | 0) < (i21 | 0));
  }
 } while (0);
 i5 = i28 + -1 | 0;
 if ((i5 | 0) > 0) i6 = 0; else {
  STACKTOP = i29;
  return 1;
 }
 do {
  i1 = i6;
  i6 = i6 + 1 | 0;
  if ((i6 | 0) < (i28 | 0)) {
   i4 = i6;
   i3 = i1;
   do {
    i3 = +HEAPF64[i27 + (i3 << 3) >> 3] < +HEAPF64[i27 + (i4 << 3) >> 3] ? i4 : i3;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i28 | 0));
  } else i3 = i1;
  if ((i1 | 0) != (i3 | 0) ? (i22 = i27 + (i3 << 3) | 0, i23 = i27 + (i1 << 3) | 0, d7 = +HEAPF64[i22 >> 3], HEAPF64[i22 >> 3] = +HEAPF64[i23 >> 3], HEAPF64[i23 >> 3] = d7, i25 & i24) : 0) {
   i4 = Math_imul(i3, i2) | 0;
   i3 = Math_imul(i1, i2) | 0;
   i1 = 0;
   do {
    i22 = i26 + (i1 + i4 << 3) | 0;
    i23 = i26 + (i1 + i3 << 3) | 0;
    d7 = +HEAPF64[i22 >> 3];
    HEAPF64[i22 >> 3] = +HEAPF64[i23 >> 3];
    HEAPF64[i23 >> 3] = d7;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i28 | 0));
  }
 } while ((i6 | 0) != (i5 | 0));
 STACKTOP = i29;
 return 1;
}

function __ZN4perf10Regression4initERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i20, i13, i18) {
 i20 = i20 | 0;
 i13 = i13 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i12 = i21 + 124 | 0;
 i6 = i21 + 112 | 0;
 i7 = i21 + 100 | 0;
 i8 = i21 + 88 | 0;
 i9 = i21 + 76 | 0;
 i10 = i21 + 64 | 0;
 i11 = i21 + 52 | 0;
 i5 = i21 + 40 | 0;
 i14 = i21 + 32 | 0;
 i15 = i21 + 24 | 0;
 i16 = i21;
 i17 = i21 + 12 | 0;
 i19 = i20 + 8 | 0;
 i4 = HEAP8[i19 >> 0] | 0;
 if (!(i4 & 1)) i4 = (i4 & 255) >>> 1; else i4 = HEAP32[i20 + 12 >> 2] | 0;
 if (i4) {
  _printf(169824, i21 + 8 | 0) | 0;
  _putchar(10) | 0;
  _fflush(HEAP32[_stdout >> 2] | 0) | 0;
  STACKTOP = i21;
  return;
 }
 i3 = _getenv(169888) | 0;
 if (!i3) {
  HEAP32[i5 + 0 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i3 = HEAP8[i13 >> 0] | 0;
  i2 = (i3 & 1) == 0;
  if (i2) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i13 + 4 >> 2] | 0;
  i3 = HEAP8[i18 >> 0] | 0;
  if (!(i3 & 1)) i4 = (i3 & 255) >>> 1; else i4 = HEAP32[i18 + 4 >> 2] | 0;
  if (i2) i3 = i13 + 1 | 0; else i3 = HEAP32[i13 + 8 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, i3, i1, i4 + i1 | 0);
  if (!(HEAP8[i18 >> 0] & 1)) i3 = i18 + 1 | 0; else i3 = HEAP32[i18 + 8 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, i3, i4) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i19, i5) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i20 + 20 | 0, i13) | 0;
 } else {
  i4 = (_strlen(i3 | 0) | 0) + -1 | 0;
  if (!(HEAP8[i3 >> 0] | 0)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, 169920, 1); else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i3, _strlen(i3 | 0) | 0);
  i5 = HEAP8[i3 + ((i4 | 0) < 0 ? 0 : i4) >> 0] | 0;
  if (i5 << 24 >> 24 == 92 | i5 << 24 >> 24 == 47) i2 = 169928; else i2 = 169912;
  HEAP32[i7 + 0 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  i4 = HEAP8[i8 >> 0] | 0;
  if (!(i4 & 1)) {
   i1 = _strlen(i2 | 0) | 0;
   i4 = (i4 & 255) >>> 1;
   i3 = i8 + 1 | 0;
  } else {
   i4 = HEAP32[i8 + 4 >> 2] | 0;
   i1 = _strlen(i2 | 0) | 0;
   i3 = HEAP32[i8 + 8 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i7, i3, i4, i4 + i1 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i2, i1) | 0;
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i4 = HEAP8[i7 >> 0] | 0;
  if (!(i4 & 1)) {
   i4 = (i4 & 255) >>> 1;
   i3 = i7 + 1 | 0;
  } else {
   i4 = HEAP32[i7 + 4 >> 2] | 0;
   i3 = HEAP32[i7 + 8 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, i3, i4, i4 + 4 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, 169936, 4) | 0;
  HEAP32[i12 + 0 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i4 = HEAP8[i6 >> 0] | 0;
  if (!(i4 & 1)) {
   i4 = (i4 & 255) >>> 1;
   i3 = i6 + 1 | 0;
  } else {
   i4 = HEAP32[i6 + 4 >> 2] | 0;
   i3 = HEAP32[i6 + 8 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i12, i3, i4, i4 + 1 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, 169912, 1) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i4 = HEAP8[i12 >> 0] | 0;
  i3 = (i4 & 1) == 0;
  if (i3) i2 = (i4 & 255) >>> 1; else i2 = HEAP32[i12 + 4 >> 2] | 0;
  i4 = HEAP8[i13 >> 0] | 0;
  if (!(i4 & 1)) i1 = (i4 & 255) >>> 1; else i1 = HEAP32[i13 + 4 >> 2] | 0;
  if (i3) i4 = i12 + 1 | 0; else i4 = HEAP32[i12 + 8 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, i4, i2, i1 + i2 | 0);
  if (!(HEAP8[i13 >> 0] & 1)) i3 = i13 + 1 | 0; else i3 = HEAP32[i13 + 8 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, i3, i1) | 0;
  HEAP32[i9 + 0 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i3 = HEAP8[i10 >> 0] | 0;
  i2 = (i3 & 1) == 0;
  if (i2) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i10 + 4 >> 2] | 0;
  i4 = HEAP8[i18 >> 0] | 0;
  if (!(i4 & 1)) i1 = (i4 & 255) >>> 1; else i1 = HEAP32[i18 + 4 >> 2] | 0;
  if (i2) i4 = i10 + 1 | 0; else i4 = HEAP32[i10 + 8 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, i4, i3, i1 + i3 | 0);
  if (!(HEAP8[i18 >> 0] & 1)) i3 = i18 + 1 | 0; else i3 = HEAP32[i18 + 8 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, i3, i1) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i19, i9) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
  HEAP32[i11 + 0 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i3 = HEAP8[i12 >> 0] | 0;
  i4 = (i3 & 1) == 0;
  if (i4) i2 = (i3 & 255) >>> 1; else i2 = HEAP32[i12 + 4 >> 2] | 0;
  i3 = HEAP8[i13 >> 0] | 0;
  if (!(i3 & 1)) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i13 + 4 >> 2] | 0;
  if (i4) i3 = i12 + 1 | 0; else i3 = HEAP32[i12 + 8 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i11, i3, i2, i1 + i2 | 0);
  if (!(HEAP8[i13 >> 0] & 1)) i3 = i13 + 1 | 0; else i3 = HEAP32[i13 + 8 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i11, i3, i1) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i20 + 20 | 0, i11) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i20 + 124 | 0, i13) | 0;
 i4 = i20 + 32 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 i3 = HEAP8[i19 >> 0] | 0;
 i2 = (i3 & 1) == 0;
 if (i2) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i20 + 12 >> 2] | 0;
 if (i1) {
  if (i2) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i20 + 12 >> 2] | 0;
  i2 = __ZN2cv6String8allocateEj(i14, i3) | 0;
  if (!(HEAP8[i19 >> 0] & 1)) i1 = i19 + 1 | 0; else i1 = HEAP32[i20 + 16 >> 2] | 0;
  _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
 }
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 i10 = __ZN2cv11FileStorage4openERKNS_6StringEiS3_(i4, i14, 0, i15) | 0;
 __ZN2cv6String10deallocateEv(i15);
 __ZN2cv6String10deallocateEv(i14);
 if (i10) {
  __ZNK2cv11FileStorage4rootEi(i16, i4, 0);
  i10 = i16;
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = i20 + 104 | 0;
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  i2 = HEAP8[i19 >> 0] | 0;
  i1 = (i2 & 1) == 0;
  if (i1) i3 = (i2 & 255) >>> 1; else i3 = HEAP32[i20 + 12 >> 2] | 0;
  if (i3 >>> 0 > 3) {
   if (i1) i1 = (i2 & 255) >>> 1; else i1 = HEAP32[i20 + 12 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_jjRKS4_(i17, i19, i1 + -3 | 0, -1, i19);
   i10 = __ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i17, 169944) | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
   if (!i10) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i20 + 20 | 0, 169952) | 0;
  }
  i1 = HEAP8[i18 >> 0] | 0;
  if (!(i1 & 1)) {
   i2 = i18 + 1 | 0;
   i1 = (i1 & 255) >>> 1;
  } else {
   i2 = HEAP32[i18 + 8 >> 2] | 0;
   i1 = HEAP32[i18 + 4 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i20 + 20 | 0, i2, i1) | 0;
 }
 if (__ZNK2cv11FileStorage8isOpenedEv(i4) | 0) {
  STACKTOP = i21;
  return;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i20 + 20 | 0, i19) | 0;
 STACKTOP = i21;
 return;
}

function _cvInitNArrayIterator(i35, i31, i33, i34, i36, i2) {
 i35 = i35 | 0;
 i31 = i31 | 0;
 i33 = i33 | 0;
 i34 = i34 | 0;
 i36 = i36 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i37 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i5 = i37 + 88 | 0;
 i4 = i37 + 80 | 0;
 i3 = i37 + 72 | 0;
 i23 = i37 + 64 | 0;
 i32 = i37 + 56 | 0;
 i24 = i37 + 48 | 0;
 i25 = i37 + 40 | 0;
 i26 = i37 + 32 | 0;
 i27 = i37 + 24 | 0;
 i28 = i37 + 16 | 0;
 i30 = i37 + 8 | 0;
 i22 = i37;
 if ((i35 + -1 | 0) >>> 0 > 9) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i8 = (__ZN2cv6String8allocateEj(i5, 26) | 0) + 0 | 0;
  i1 = 41528 | 0;
  i9 = i8 + 26 | 0;
  do {
   HEAP8[i8 >> 0] = HEAP8[i1 >> 0] | 0;
   i8 = i8 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i8 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i5, 41560, 40912, 393);
  __ZN2cv6String10deallocateEv(i5);
 }
 if (!((i31 | 0) != 0 & (i34 | 0) != 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i8 = (__ZN2cv6String8allocateEj(i4, 39) | 0) + 0 | 0;
  i1 = 41584 | 0;
  i9 = i8 + 39 | 0;
  do {
   HEAP8[i8 >> 0] = HEAP8[i1 >> 0] | 0;
   i8 = i8 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i8 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i4, 41560, 40912, 396);
  __ZN2cv6String10deallocateEv(i4);
 }
 if (!i36) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i8 = (__ZN2cv6String8allocateEj(i3, 24) | 0) + 0 | 0;
  i1 = 41624 | 0;
  i9 = i8 + 24 | 0;
  do {
   HEAP8[i8 >> 0] = HEAP8[i1 >> 0] | 0;
   i8 = i8 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i8 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i3, 41560, 40912, 399);
  __ZN2cv6String10deallocateEv(i3);
 }
 L10 : do if ((i35 | 0) >= 0) {
  i17 = i24 + 4 | 0;
  i18 = i2 & 3;
  i19 = i26 + 4 | 0;
  i20 = i27 + 4 | 0;
  i21 = i28 + 4 | 0;
  i11 = (i2 & 4 | 0) == 0;
  i12 = i22 + 4 | 0;
  i13 = i30 + 4 | 0;
  i14 = i25 + 4 | 0;
  i5 = -1;
  i4 = 0;
  i16 = 0;
  while (1) {
   i15 = (i16 | 0) < (i35 | 0);
   if (i15) i3 = HEAP32[i31 + (i16 << 2) >> 2] | 0; else i3 = i33;
   if (!i3) break;
   if (!((HEAP32[i3 >> 2] & -65536 | 0) == 1111687168 ? (HEAP32[i3 + 16 >> 2] | 0) != 0 : 0)) {
    HEAP32[i32 >> 2] = 0;
    i3 = __ZL10cvGetMatNDPKvP7CvMatNDPi(i3, i34 + (i16 * 276 | 0) | 0, i32) | 0;
    if (HEAP32[i32 >> 2] | 0) {
     HEAP32[i24 >> 2] = 0;
     HEAP32[i17 >> 2] = 0;
     i8 = (__ZN2cv6String8allocateEj(i24, 27) | 0) + 0 | 0;
     i1 = 41656 | 0;
     i9 = i8 + 27 | 0;
     do {
      HEAP8[i8 >> 0] = HEAP8[i1 >> 0] | 0;
      i8 = i8 + 1 | 0;
      i1 = i1 + 1 | 0;
     } while ((i8 | 0) < (i9 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-24, i24, 41560, 40912, 420);
     __ZN2cv6String10deallocateEv(i24);
    }
   }
   i10 = i36 + (i16 << 2) + 184 | 0;
   HEAP32[i10 >> 2] = i3;
   i7 = i3 + 4 | 0;
   if ((i16 | 0) > 0) {
    if ((HEAP32[i7 >> 2] | 0) != (HEAP32[i4 + 4 >> 2] | 0)) {
     HEAP32[i25 >> 2] = 0;
     HEAP32[i14 >> 2] = 0;
     i8 = (__ZN2cv6String8allocateEj(i25, 47) | 0) + 0 | 0;
     i1 = 41688 | 0;
     i9 = i8 + 47 | 0;
     do {
      HEAP8[i8 >> 0] = HEAP8[i1 >> 0] | 0;
      i8 = i8 + 1 | 0;
      i1 = i1 + 1 | 0;
     } while ((i8 | 0) < (i9 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-209, i25, 41560, 40912, 429);
     __ZN2cv6String10deallocateEv(i25);
    }
    do if (i15) if ((i18 | 0) == 1) {
     if (!((HEAP32[i4 >> 2] ^ HEAP32[i3 >> 2]) & 4088)) break;
     HEAP32[i27 >> 2] = 0;
     HEAP32[i20 >> 2] = 0;
     i8 = (__ZN2cv6String8allocateEj(i27, 49) | 0) + 0 | 0;
     i1 = 41784 | 0;
     i9 = i8 + 49 | 0;
     do {
      HEAP8[i8 >> 0] = HEAP8[i1 >> 0] | 0;
      i8 = i8 + 1 | 0;
      i1 = i1 + 1 | 0;
     } while ((i8 | 0) < (i9 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-205, i27, 41560, 40912, 443);
     __ZN2cv6String10deallocateEv(i27);
     break;
    } else if ((i18 | 0) == 2) {
     if (!((HEAP32[i4 >> 2] ^ HEAP32[i3 >> 2]) & 4088)) break;
     HEAP32[i28 >> 2] = 0;
     HEAP32[i21 >> 2] = 0;
     i8 = (__ZN2cv6String8allocateEj(i28, 36) | 0) + 0 | 0;
     i1 = 41840 | 0;
     i9 = i8 + 36 | 0;
     do {
      HEAP8[i8 >> 0] = HEAP8[i1 >> 0] | 0;
      i8 = i8 + 1 | 0;
      i1 = i1 + 1 | 0;
     } while ((i8 | 0) < (i9 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-205, i28, 41560, 40912, 448);
     __ZN2cv6String10deallocateEv(i28);
     break;
    } else if (!i18) {
     if (!((HEAP32[i4 >> 2] ^ HEAP32[i3 >> 2]) & 4095)) break;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i19 >> 2] = 0;
     i8 = (__ZN2cv6String8allocateEj(i26, 40) | 0) + 0 | 0;
     i1 = 41736 | 0;
     i9 = i8 + 40 | 0;
     do {
      HEAP8[i8 >> 0] = HEAP8[i1 >> 0] | 0;
      i8 = i8 + 1 | 0;
      i1 = i1 + 1 | 0;
     } while ((i8 | 0) < (i9 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-205, i26, 41560, 40912, 438);
     __ZN2cv6String10deallocateEv(i26);
     break;
    } else break; else if (HEAP32[i3 >> 2] & 4094) {
     HEAP32[i30 >> 2] = 0;
     HEAP32[i13 >> 2] = 0;
     i8 = (__ZN2cv6String8allocateEj(i30, 39) | 0) + 0 | 0;
     i1 = 41880 | 0;
     i9 = i8 + 39 | 0;
     do {
      HEAP8[i8 >> 0] = HEAP8[i1 >> 0] | 0;
      i8 = i8 + 1 | 0;
      i1 = i1 + 1 | 0;
     } while ((i8 | 0) < (i9 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-208, i30, 41560, 40912, 455);
     __ZN2cv6String10deallocateEv(i30);
    } while (0);
    if (i11 ? (i29 = HEAP32[i7 >> 2] | 0, (i29 | 0) > 0) : 0) {
     i2 = i29;
     i6 = 0;
     do {
      if ((HEAP32[i3 + (i6 << 3) + 20 >> 2] | 0) != (HEAP32[i4 + (i6 << 3) + 20 >> 2] | 0)) {
       HEAP32[i22 >> 2] = 0;
       HEAP32[i12 >> 2] = 0;
       i8 = (__ZN2cv6String8allocateEj(i22, 43) | 0) + 0 | 0;
       i1 = 41920 | 0;
       i9 = i8 + 43 | 0;
       do {
        HEAP8[i8 >> 0] = HEAP8[i1 >> 0] | 0;
        i8 = i8 + 1 | 0;
        i1 = i1 + 1 | 0;
       } while ((i8 | 0) < (i9 | 0));
       __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-209, i22, 41560, 40912, 463);
       __ZN2cv6String10deallocateEv(i22);
       i2 = HEAP32[i7 >> 2] | 0;
      }
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) < (i2 | 0));
    }
   } else i4 = i3;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = (i1 >>> 3 & 511) + 1 << (47696 >>> (i1 << 1 & 14) & 3);
   i6 = ((i1 | 0) < 0) << 31 >> 31;
   i7 = HEAP32[i7 >> 2] | 0;
   i2 = i7 + -1 | 0;
   L48 : do if ((i2 | 0) > (i5 | 0)) {
    i8 = i2;
    while (1) {
     i2 = HEAP32[i3 + (i8 << 3) + 24 >> 2] | 0;
     if (!((i1 | 0) == (i2 | 0) & (i6 | 0) == (((i2 | 0) < 0) << 31 >> 31 | 0))) {
      i2 = i8;
      break L48;
     }
     i2 = HEAP32[i3 + (i8 << 3) + 20 >> 2] | 0;
     i1 = ___muldi3(i2 | 0, ((i2 | 0) < 0) << 31 >> 31 | 0, i1 | 0, i6 | 0) | 0;
     i6 = tempRet0;
     i2 = i8 + -1 | 0;
     if ((i2 | 0) > (i5 | 0)) {
      i7 = i8;
      i8 = i2;
     } else {
      i7 = i8;
      break;
     }
    }
   } while (0);
   i1 = (i2 | 0) == (i5 | 0) & ((i6 | 0) > 0 | (i6 | 0) == 0 & i1 >>> 0 > 2147483647) ? i7 : i2;
   i5 = (i1 | 0) > (i5 | 0) ? i1 : i5;
   HEAP32[i10 >> 2] = i3;
   HEAP32[i36 + (i16 << 2) + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   if (i15) i16 = i16 + 1 | 0; else break L10;
  }
  if (i15) {
   HEAP32[i23 >> 2] = 0;
   HEAP32[i23 + 4 >> 2] = 0;
   i8 = (__ZN2cv6String8allocateEj(i23, 39) | 0) + 0 | 0;
   i1 = 41584 | 0;
   i9 = i8 + 39 | 0;
   do {
    HEAP8[i8 >> 0] = HEAP8[i1 >> 0] | 0;
    i8 = i8 + 1 | 0;
    i1 = i1 + 1 | 0;
   } while ((i8 | 0) < (i9 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i23, 41560, 40912, 409);
   __ZN2cv6String10deallocateEv(i23);
  }
 } else {
  i5 = -1;
  i4 = 0;
 } while (0);
 i1 = (HEAP32[i4 + 4 >> 2] | 0) + -1 | 0;
 if ((i1 | 0) > (i5 | 0)) {
  i2 = 1;
  do {
   i2 = Math_imul(HEAP32[i4 + (i1 << 3) + 20 >> 2] | 0, i2) | 0;
   i1 = i1 + -1 | 0;
  } while ((i1 | 0) > (i5 | 0));
  i1 = 1;
 } else {
  i2 = 1;
  i1 = 1;
 }
 i3 = i5 + 1 | 0;
 HEAP32[i36 + 4 >> 2] = i3;
 HEAP32[i36 >> 2] = i35;
 i22 = i36 + 8 | 0;
 HEAP32[i22 >> 2] = i2;
 HEAP32[i22 + 4 >> 2] = i1;
 if ((i5 | 0) > -1) i1 = 0; else {
  STACKTOP = i37;
  return i3 | 0;
 }
 do {
  HEAP32[i36 + (i1 << 2) + 56 >> 2] = HEAP32[i4 + (i1 << 3) + 20 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 STACKTOP = i37;
 return i3 | 0;
}

function __ZN2cv10PxMDecoder8readDataERNS_3MatE(i11, i28) {
 i11 = i11 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 3152 | 0;
 i21 = i42 + 2112 | 0;
 i10 = i42 + 2120 | 0;
 i41 = i42 + 1072 | 0;
 i38 = i42 + 32 | 0;
 i22 = i42 + 24 | 0;
 i23 = i42 + 16 | 0;
 i24 = i42 + 8 | 0;
 i26 = i42;
 i29 = (((HEAP32[i28 >> 2] | 0) >>> 3 & 511) + 1 | 0) >>> 0 > 1;
 i2 = HEAP32[i28 + 16 >> 2] | 0;
 i32 = HEAP32[i28 + 48 >> 2] | 0;
 i9 = HEAP32[i11 + 12 >> 2] | 0;
 i7 = 1212424721 >>> (i9 << 2 & 28) << 3 & 120;
 i33 = i11 + 4 | 0;
 i8 = HEAP32[i33 >> 2] | 0;
 i25 = i11 + 1152 | 0;
 i31 = (((Math_imul(Math_imul(HEAP32[i25 >> 2] | 0, i8) | 0, i7) | 0) / 8 | 0) + 7 | 0) / 8 | 0;
 i9 = i9 >>> 3;
 i27 = Math_imul((i9 & 511) + 1 | 0, i8) | 0;
 i6 = i11 + 1156 | 0;
 if ((HEAP32[i6 >> 2] | 0) < 0) {
  i22 = 0;
  STACKTOP = i42;
  return i22 | 0;
 }
 i34 = i11 + 92 | 0;
 if (!(__ZN2cv11RBaseStream8isOpenedEv(i34) | 0)) {
  i22 = 0;
  STACKTOP = i42;
  return i22 | 0;
 }
 i4 = i31 + 32 | 0;
 i39 = i41 + 8 | 0;
 HEAP32[i41 >> 2] = i39;
 i40 = i41 + 4 | 0;
 HEAP32[i40 >> 2] = 1032;
 if (i4 >>> 0 > 1032) {
  i35 = __Znaj(i4) | 0;
  HEAP32[i41 >> 2] = i35;
 } else i35 = i39;
 HEAP32[i40 >> 2] = i4;
 i36 = i38 + 8 | 0;
 HEAP32[i38 >> 2] = i36;
 i37 = i38 + 4 | 0;
 HEAP32[i37 >> 2] = 1032;
 i20 = (i7 | 0) == 8;
 if (i20) {
  i5 = i11 + 1164 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = i4 + 1 | 0;
  if (i3 >>> 0 > 1032) {
   i1 = __Znaj(i3) | 0;
   HEAP32[i38 >> 2] = i1;
  } else i1 = i36;
  HEAP32[i37 >> 2] = i3;
  if ((i4 | 0) >= 0) {
   i3 = 0;
   while (1) {
    HEAP8[i1 + i3 >> 0] = ((HEAP32[i25 >> 2] | 0) == 1 ? 255 : 0) ^ ((i3 * 255 | 0) / (i4 | 0) | 0);
    i4 = HEAP32[i5 >> 2] | 0;
    if ((i3 | 0) >= (i4 | 0)) break; else i3 = i3 + 1 | 0;
   }
  }
  i30 = (HEAP32[i25 >> 2] | 0) == 1;
  __Z15FillGrayPaletteP12PaletteEntryib(i10, i30 ? 1 : 8, i30);
  i30 = i1;
 } else i30 = i36;
 __ZN2cv11RBaseStream6setPosEi(i34, HEAP32[i6 >> 2] | 0);
 i4 = HEAP32[i25 >> 2] | 0;
 L20 : do if ((i4 | 0) == 24 | (i4 | 0) == 8) {
  i15 = i11 + 8 | 0;
  if ((HEAP32[i15 >> 2] | 0) > 0) {
   i16 = i11 + 1160 | 0;
   i17 = (i7 | 0) == 16;
   i18 = (i27 | 0) > 0;
   i7 = i7 >>> 3;
   i10 = i22 + 4 | 0;
   i12 = i23 + 4 | 0;
   i13 = i24 + 4 | 0;
   i14 = i26 + 4 | 0;
   i3 = i11 + 1164 | 0;
   i1 = Math_imul(i8, (i9 & 511) + 1 | 0) | 0;
   i11 = 0;
   while (1) {
    if (!(HEAP8[i16 >> 0] | 0)) if (i18) {
     i6 = 0;
     do {
      i5 = __ZN2cvL10ReadNumberERNS_12RLByteStreamEi(i34, 2147483647) | 0;
      i19 = HEAP32[i3 >> 2] | 0;
      i5 = i5 >>> 0 > i19 >>> 0 ? i19 : i5;
      if (i20) HEAP8[i35 + i6 >> 0] = HEAP8[i30 + i5 >> 0] | 0; else HEAP16[i35 + (i6 << 1) >> 1] = i5;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) < (i27 | 0));
     i19 = 44;
    } else i19 = 44; else {
     __ZN2cv12RLByteStream8getBytesEPvi(i34, i35, i31) | 0;
     if (i17) if (i18) {
      i5 = 0;
      do {
       i19 = i5 << 1;
       i6 = i35 + i19 | 0;
       i4 = HEAP8[i6 >> 0] | 0;
       i19 = i35 + (i19 | 1) | 0;
       HEAP8[i6 >> 0] = HEAP8[i19 >> 0] | 0;
       HEAP8[i19 >> 0] = i4;
       i5 = i5 + 1 | 0;
      } while ((i5 | 0) != (i1 | 0));
      i19 = 44;
     } else i19 = 44;
    }
    if ((i19 | 0) == 44 ? (i19 = 0, (HEAP32[i28 >> 2] & 7 | 0) == 0 & i17 & i18) : 0) {
     i6 = 0;
     do {
      HEAP8[i35 + i6 >> 0] = (HEAPU16[i35 + (i6 << 1) >> 1] | 0) >>> 8;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i1 | 0));
    }
    L42 : do if ((HEAP32[i25 >> 2] | 0) == 8) {
     if (!i29) {
      _memcpy(i2 | 0, i35 | 0, Math_imul(HEAP32[i33 >> 2] | 0, i7) | 0) | 0;
      break;
     }
     i6 = HEAP32[i33 >> 2] | 0;
     if (!(HEAP32[i28 >> 2] & 7)) {
      i4 = i35 + i6 | 0;
      if ((i6 | 0) > 0) {
       i6 = i2;
       i5 = i35;
      } else break;
      while (1) {
       i8 = HEAP8[i5 >> 0] | 0;
       HEAP8[i6 + 2 >> 0] = i8;
       HEAP8[i6 + 1 >> 0] = i8;
       HEAP8[i6 >> 0] = i8;
       i5 = i5 + 1 | 0;
       if (i5 >>> 0 >= i4 >>> 0) break L42; else i6 = i6 + 3 | 0;
      }
     }
     i6 = i35 + (i6 << 1) | 0;
     if (i35 >>> 0 < i6 >>> 0) {
      i5 = i2;
      i4 = i35;
      while (1) {
       i8 = HEAP16[i4 >> 1] | 0;
       HEAP16[i5 + 4 >> 1] = i8;
       HEAP16[i5 + 2 >> 1] = i8;
       HEAP16[i5 >> 1] = i8;
       i4 = i4 + 2 | 0;
       if (i4 >>> 0 >= i6 >>> 0) break; else i5 = i5 + 6 | 0;
      }
     }
    } else {
     i6 = (HEAP32[i28 >> 2] & 7 | 0) == 0;
     i5 = HEAP32[i33 >> 2] | 0;
     if (i29) if (i6) {
      HEAP32[i22 >> 2] = i5;
      HEAP32[i10 >> 2] = 1;
      HEAP32[i21 + 0 >> 2] = HEAP32[i22 + 0 >> 2];
      HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
      __Z21icvCvt_BGR2RGB_8u_C3RPKhiPhi6CvSize(i35, 0, i2, 0, i21);
      break;
     } else {
      HEAP32[i23 >> 2] = i5;
      HEAP32[i12 >> 2] = 1;
      HEAP32[i21 + 0 >> 2] = HEAP32[i23 + 0 >> 2];
      HEAP32[i21 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
      __Z22icvCvt_BGR2RGB_16u_C3RPKtiPti6CvSize(i35, 0, i2, 0, i21);
      break;
     } else if (i6) {
      HEAP32[i24 >> 2] = i5;
      HEAP32[i13 >> 2] = 1;
      HEAP32[i21 + 0 >> 2] = HEAP32[i24 + 0 >> 2];
      HEAP32[i21 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
      __Z24icvCvt_BGR2Gray_8u_C3C1RPKhiPhi6CvSizei(i35, 0, i2, 0, i21, 2);
      break;
     } else {
      HEAP32[i26 >> 2] = i5;
      HEAP32[i14 >> 2] = 1;
      HEAP32[i21 + 0 >> 2] = HEAP32[i26 + 0 >> 2];
      HEAP32[i21 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
      __Z26icvCvt_BGRA2Gray_16u_CnC1RPKtiPti6CvSizeii(i35, 0, i2, 0, i21, 3, 2);
      break;
     }
    } while (0);
    i11 = i11 + 1 | 0;
    if ((i11 | 0) >= (HEAP32[i15 >> 2] | 0)) {
     i2 = 1;
     break;
    } else i2 = i2 + i32 | 0;
   }
  } else i2 = 1;
 } else if ((i4 | 0) == 1) {
  i5 = i11 + 8 | 0;
  i1 = (HEAP32[i5 >> 2] | 0) > 0;
  if (HEAP8[i11 + 1160 >> 0] | 0) {
   if (!i1) {
    i2 = 1;
    break;
   }
   if (i29) {
    i1 = 0;
    while (1) {
     __ZN2cv12RLByteStream8getBytesEPvi(i34, i35, i31) | 0;
     __Z13FillColorRow1PhS_iP12PaletteEntry(i2, i35, HEAP32[i33 >> 2] | 0, i10) | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (HEAP32[i5 >> 2] | 0)) {
      i2 = 1;
      break L20;
     } else i2 = i2 + i32 | 0;
    }
   } else {
    i1 = 0;
    while (1) {
     __ZN2cv12RLByteStream8getBytesEPvi(i34, i35, i31) | 0;
     __Z12FillGrayRow1PhS_iS_(i2, i35, HEAP32[i33 >> 2] | 0, i30) | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (HEAP32[i5 >> 2] | 0)) {
      i2 = 1;
      break L20;
     } else i2 = i2 + i32 | 0;
    }
   }
  }
  if (i1) if (i29) {
   i3 = i2;
   i4 = 0;
   while (1) {
    i2 = HEAP32[i33 >> 2] | 0;
    if ((i2 | 0) > 0) {
     i1 = 0;
     do {
      HEAP8[i35 + i1 >> 0] = (__ZN2cvL10ReadNumberERNS_12RLByteStreamEi(i34, 1) | 0) != 0 & 1;
      i1 = i1 + 1 | 0;
      i2 = HEAP32[i33 >> 2] | 0;
     } while ((i1 | 0) < (i2 | 0));
    }
    __Z13FillColorRow8PhS_iP12PaletteEntry(i3, i35, i2, i10) | 0;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) >= (HEAP32[i5 >> 2] | 0)) {
     i2 = 1;
     break;
    } else i3 = i3 + i32 | 0;
   }
  } else {
   i3 = i2;
   i4 = 0;
   while (1) {
    i2 = HEAP32[i33 >> 2] | 0;
    if ((i2 | 0) > 0) {
     i1 = 0;
     do {
      HEAP8[i35 + i1 >> 0] = (__ZN2cvL10ReadNumberERNS_12RLByteStreamEi(i34, 1) | 0) != 0 & 1;
      i1 = i1 + 1 | 0;
      i2 = HEAP32[i33 >> 2] | 0;
     } while ((i1 | 0) < (i2 | 0));
    }
    __Z12FillGrayRow8PhS_iS_(i3, i35, i2, i30) | 0;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) >= (HEAP32[i5 >> 2] | 0)) {
     i2 = 1;
     break;
    } else i3 = i3 + i32 | 0;
   }
  } else i2 = 1;
 } else i2 = 0; while (0);
 i1 = HEAP32[i38 >> 2] | 0;
 if ((i1 | 0) != (i36 | 0)) {
  if (i1) __ZdaPv(i1);
  HEAP32[i38 >> 2] = i36;
  HEAP32[i37 >> 2] = 1032;
 }
 i1 = HEAP32[i41 >> 2] | 0;
 if ((i1 | 0) == (i39 | 0)) {
  i22 = i2;
  STACKTOP = i42;
  return i22 | 0;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i41 >> 2] = i39;
 HEAP32[i40 >> 2] = 1032;
 i22 = i2;
 STACKTOP = i42;
 return i22 | 0;
}

function __ZNK2cv12_OutputArray6createEiiiibi(i17, i21, i20, i19, i5, i3, i4) {
 i17 = i17 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i18 = i22 + 88 | 0;
 i7 = i22 + 80 | 0;
 i12 = i22 + 72 | 0;
 i8 = i22 + 64 | 0;
 i13 = i22 + 56 | 0;
 i9 = i22 + 48 | 0;
 i14 = i22 + 40 | 0;
 i10 = i22 + 32 | 0;
 i15 = i22 + 24 | 0;
 i11 = i22 + 16 | 0;
 i16 = i22 + 8 | 0;
 i6 = i22;
 i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] & 127](i17) | 0;
 i1 = (i5 | 0) < 0;
 if ((i2 | 0) == 65536 & i1 ? (i4 | 0) == 0 & (i3 ^ 1) : 0) {
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 104 >> 2] & 127](i17) | 0 ? (i10 = HEAP32[(HEAP32[i17 + 8 >> 2] | 0) + 40 >> 2] | 0, !((HEAP32[i10 >> 2] | 0) == (i21 | 0) ? (HEAP32[i10 + 4 >> 2] | 0) == (i20 | 0) : 0)) : 0) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i7, 68) | 0) + 0 | 0;
   i5 = 29944 | 0;
   i4 = i6 + 68 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 27672, 27528, 2128);
   __ZN2cv6String10deallocateEv(i7);
  }
  i2 = i17 + 8 | 0;
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 108 >> 2] & 127](i17) | 0 ? (HEAP32[HEAP32[i2 >> 2] >> 2] & 4095 | 0) != (i19 | 0) : 0) {
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i12, 44) | 0) + 0 | 0;
   i5 = 29456 | 0;
   i4 = i6 + 44 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i12, 27672, 27528, 2129);
   __ZN2cv6String10deallocateEv(i12);
  }
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = i19 & 4095;
  if (((((HEAP32[i2 + 4 >> 2] | 0) < 3 ? (HEAP32[i2 + 8 >> 2] | 0) == (i21 | 0) : 0) ? (HEAP32[i2 + 12 >> 2] | 0) == (i20 | 0) : 0) ? (HEAP32[i2 >> 2] & 4095 | 0) == (i1 | 0) : 0) ? (HEAP32[i2 + 16 >> 2] | 0) != 0 : 0) {
   STACKTOP = i22;
   return;
  }
  HEAP32[i18 >> 2] = i21;
  HEAP32[i18 + 4 >> 2] = i20;
  __ZN2cv3Mat6createEiPKii(i2, 2, i18, i1);
  STACKTOP = i22;
  return;
 }
 if ((i2 | 0) == 655360 & i1 ? (i4 | 0) == 0 & (i3 ^ 1) : 0) {
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 104 >> 2] & 127](i17) | 0 ? (i10 = HEAP32[(HEAP32[i17 + 8 >> 2] | 0) + 32 >> 2] | 0, !((HEAP32[i10 >> 2] | 0) == (i21 | 0) ? (HEAP32[i10 + 4 >> 2] | 0) == (i20 | 0) : 0)) : 0) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i8, 69) | 0) + 0 | 0;
   i5 = 30016 | 0;
   i4 = i6 + 69 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 27672, 27528, 2135);
   __ZN2cv6String10deallocateEv(i8);
  }
  i2 = i17 + 8 | 0;
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 108 >> 2] & 127](i17) | 0 ? (HEAP32[HEAP32[i2 >> 2] >> 2] & 4095 | 0) != (i19 | 0) : 0) {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i13, 45) | 0) + 0 | 0;
   i5 = 29560 | 0;
   i4 = i6 + 45 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i13, 27672, 27528, 2136);
   __ZN2cv6String10deallocateEv(i13);
  }
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = i19 & 4095;
  if (((((HEAP32[i2 + 4 >> 2] | 0) < 3 ? (HEAP32[i2 + 8 >> 2] | 0) == (i21 | 0) : 0) ? (HEAP32[i2 + 12 >> 2] | 0) == (i20 | 0) : 0) ? (HEAP32[i2 >> 2] & 4095 | 0) == (i1 | 0) : 0) ? (HEAP32[i2 + 24 >> 2] | 0) != 0 : 0) {
   STACKTOP = i22;
   return;
  }
  HEAP32[i18 >> 2] = i21;
  HEAP32[i18 + 4 >> 2] = i20;
  __ZN2cv4UMat6createEiPKiiNS_14UMatUsageFlagsE(i2, 2, i18, i1, 0);
  STACKTOP = i22;
  return;
 }
 if ((i2 | 0) == 589824 & i1 ? (i4 | 0) == 0 & (i3 ^ 1) : 0) {
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 104 >> 2] & 127](i17) | 0 ? (i10 = HEAP32[i17 + 8 >> 2] | 0, !((HEAP32[i10 + 8 >> 2] | 0) == (i20 | 0) ? (HEAP32[i10 + 4 >> 2] | 0) == (i21 | 0) : 0)) : 0) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i9, 66) | 0) + 0 | 0;
   i5 = 30088 | 0;
   i4 = i6 + 66 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i9, 27672, 27528, 2142);
   __ZN2cv6String10deallocateEv(i9);
  }
  i2 = i17 + 8 | 0;
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 108 >> 2] & 127](i17) | 0 ? (HEAP32[HEAP32[i2 >> 2] >> 2] & 4095 | 0) != (i19 | 0) : 0) {
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i14, 53) | 0) + 0 | 0;
   i5 = 29664 | 0;
   i4 = i6 + 53 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i14, 27672, 27528, 2143);
   __ZN2cv6String10deallocateEv(i14);
  }
  __ZN2cv4cuda6GpuMat6createEiii(HEAP32[i2 >> 2] | 0, i21, i20, i19);
  STACKTOP = i22;
  return;
 }
 if ((i2 | 0) == 458752 & i1 ? (i4 | 0) == 0 & (i3 ^ 1) : 0) {
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 104 >> 2] & 127](i17) | 0 ? (i9 = HEAP32[i17 + 8 >> 2] | 0, !((HEAP32[i9 + 12 >> 2] | 0) == (i20 | 0) ? (HEAP32[i9 + 8 >> 2] | 0) == (i21 | 0) : 0)) : 0) {
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i10, 65) | 0) + 0 | 0;
   i5 = 30160 | 0;
   i4 = i6 + 65 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 27672, 27528, 2149);
   __ZN2cv6String10deallocateEv(i10);
  }
  i2 = i17 + 8 | 0;
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 108 >> 2] & 127](i17) | 0 ? (HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0) != (i19 | 0) : 0) {
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i15, 52) | 0) + 0 | 0;
   i5 = 29776 | 0;
   i4 = i6 + 52 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i15, 27672, 27528, 2150);
   __ZN2cv6String10deallocateEv(i15);
  }
  __ZN2cv3ogl6Buffer6createEiiiNS1_6TargetEb(HEAP32[i2 >> 2] | 0, i21, i20, i19, 34962, 0);
  STACKTOP = i22;
  return;
 }
 if ((i2 | 0) == 524288 & i1 ? (i4 | 0) == 0 & (i3 ^ 1) : 0) {
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 104 >> 2] & 127](i17) | 0 ? (i10 = HEAP32[i17 + 8 >> 2] | 0, !((HEAP32[i10 + 8 >> 2] | 0) == (i20 | 0) ? (HEAP32[i10 + 4 >> 2] | 0) == (i21 | 0) : 0)) : 0) {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i11, 67) | 0) + 0 | 0;
   i5 = 30232 | 0;
   i4 = i6 + 67 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i11, 27672, 27528, 2156);
   __ZN2cv6String10deallocateEv(i11);
  }
  i2 = i17 + 8 | 0;
  if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 108 >> 2] & 127](i17) | 0 ? (HEAP32[HEAP32[i2 >> 2] >> 2] & 4095 | 0) != (i19 | 0) : 0) {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i16, 54) | 0) + 0 | 0;
   i5 = 29888 | 0;
   i4 = i6 + 54 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i16, 27672, 27528, 2157);
   __ZN2cv6String10deallocateEv(i16);
  }
  __ZN2cv4cuda7CudaMem6createEiii(HEAP32[i2 >> 2] | 0, i21, i20, i19);
  STACKTOP = i22;
  return;
 }
 HEAP32[i6 >> 2] = i21;
 HEAP32[i6 + 4 >> 2] = i20;
 FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i17 >> 2] | 0) + 144 >> 2] & 63](i17, 2, i6, i19, i5, i3, i4);
 STACKTOP = i22;
 return;
}

function _inflate_fast(i33, i5) {
 i33 = i33 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i39 = STACKTOP;
 i22 = HEAP32[i33 + 28 >> 2] | 0;
 i12 = HEAP32[i33 >> 2] | 0;
 i38 = i33 + 4 | 0;
 i31 = i12 + ((HEAP32[i38 >> 2] | 0) + -6) | 0;
 i32 = i33 + 12 | 0;
 i4 = HEAP32[i32 >> 2] | 0;
 i34 = i33 + 16 | 0;
 i13 = HEAP32[i34 >> 2] | 0;
 i35 = i4 + (i13 + -258) | 0;
 i23 = HEAP32[i22 + 44 >> 2] | 0;
 i24 = HEAP32[i22 + 48 >> 2] | 0;
 i25 = HEAP32[i22 + 52 >> 2] | 0;
 i36 = i22 + 56 | 0;
 i37 = i22 + 60 | 0;
 i26 = HEAP32[i22 + 76 >> 2] | 0;
 i27 = HEAP32[i22 + 80 >> 2] | 0;
 i28 = (1 << HEAP32[i22 + 84 >> 2]) + -1 | 0;
 i29 = (1 << HEAP32[i22 + 88 >> 2]) + -1 | 0;
 i13 = i4 + (i13 + ~i5) | 0;
 i14 = i22 + 7104 | 0;
 i15 = i25 + -1 | 0;
 i16 = (i24 | 0) == 0;
 i17 = (HEAP32[i22 + 40 >> 2] | 0) + -1 | 0;
 i18 = i17 + i24 | 0;
 i19 = i24 + -1 | 0;
 i20 = i13 + -1 | 0;
 i21 = i13 - i24 | 0;
 i3 = HEAP32[i37 >> 2] | 0;
 i2 = HEAP32[i36 >> 2] | 0;
 i5 = i12 + -1 | 0;
 i4 = i4 + -1 | 0;
 L1 : do {
  if (i3 >>> 0 < 15) {
   i12 = i5 + 2 | 0;
   i7 = i3 + 16 | 0;
   i2 = ((HEAPU8[i5 + 1 >> 0] | 0) << i3) + i2 + ((HEAPU8[i12 >> 0] | 0) << i3 + 8) | 0;
   i5 = i12;
  } else i7 = i3;
  i3 = i2 & i28;
  i6 = HEAP8[i26 + (i3 << 2) >> 0] | 0;
  i1 = HEAP16[i26 + (i3 << 2) + 2 >> 1] | 0;
  i3 = HEAPU8[i26 + (i3 << 2) + 1 >> 0] | 0;
  i2 = i2 >>> i3;
  i3 = i7 - i3 | 0;
  do if (i6 << 24 >> 24) {
   i10 = i6 & 255;
   while (1) {
    if (i10 & 16) break;
    if (i10 & 64) {
     i30 = 57;
     break L1;
    }
    i12 = (i2 & (1 << i10) + -1) + (i1 & 65535) | 0;
    i6 = HEAP8[i26 + (i12 << 2) >> 0] | 0;
    i1 = HEAP16[i26 + (i12 << 2) + 2 >> 1] | 0;
    i12 = HEAPU8[i26 + (i12 << 2) + 1 >> 0] | 0;
    i2 = i2 >>> i12;
    i3 = i3 - i12 | 0;
    if (!(i6 << 24 >> 24)) {
     i30 = 6;
     break;
    } else i10 = i6 & 255;
   }
   if ((i30 | 0) == 6) {
    i1 = i1 & 255;
    i30 = 7;
    break;
   }
   i7 = i1 & 65535;
   i8 = i10 & 15;
   if (!i8) {
    i9 = i2;
    i12 = i7;
   } else {
    if (i3 >>> 0 < i8 >>> 0) {
     i5 = i5 + 1 | 0;
     i6 = i3 + 8 | 0;
     i2 = ((HEAPU8[i5 >> 0] | 0) << i3) + i2 | 0;
    } else i6 = i3;
    i3 = i6 - i8 | 0;
    i9 = i2 >>> i8;
    i12 = (i2 & (1 << i8) + -1) + i7 | 0;
   }
   if (i3 >>> 0 < 15) {
    i11 = i5 + 2 | 0;
    i7 = i3 + 16 | 0;
    i3 = ((HEAPU8[i5 + 1 >> 0] | 0) << i3) + i9 + ((HEAPU8[i11 >> 0] | 0) << i3 + 8) | 0;
    i5 = i11;
   } else {
    i7 = i3;
    i3 = i9;
   }
   i6 = i3 & i29;
   i1 = HEAP16[i27 + (i6 << 2) + 2 >> 1] | 0;
   i11 = HEAPU8[i27 + (i6 << 2) + 1 >> 0] | 0;
   i2 = i3 >>> i11;
   i3 = i7 - i11 | 0;
   i6 = HEAPU8[i27 + (i6 << 2) >> 0] | 0;
   if (!(i6 & 16)) do {
    if (i6 & 64) {
     i30 = 54;
     break L1;
    }
    i6 = (i2 & (1 << i6) + -1) + (i1 & 65535) | 0;
    i1 = HEAP16[i27 + (i6 << 2) + 2 >> 1] | 0;
    i11 = HEAPU8[i27 + (i6 << 2) + 1 >> 0] | 0;
    i2 = i2 >>> i11;
    i3 = i3 - i11 | 0;
    i6 = HEAPU8[i27 + (i6 << 2) >> 0] | 0;
   } while ((i6 & 16 | 0) == 0);
   i10 = i1 & 65535;
   i8 = i6 & 15;
   if (i3 >>> 0 < i8 >>> 0) {
    i9 = i5 + 1 | 0;
    i2 = ((HEAPU8[i9 >> 0] | 0) << i3) + i2 | 0;
    i6 = i3 + 8 | 0;
    if (i6 >>> 0 < i8 >>> 0) {
     i5 = i5 + 2 | 0;
     i3 = i3 + 16 | 0;
     i2 = ((HEAPU8[i5 >> 0] | 0) << i6) + i2 | 0;
    } else {
     i3 = i6;
     i5 = i9;
    }
   }
   i11 = (i2 & (1 << i8) + -1) + i10 | 0;
   i2 = i2 >>> i8;
   i3 = i3 - i8 | 0;
   i10 = i4;
   i1 = i10 - i13 | 0;
   if (i11 >>> 0 <= i1 >>> 0) {
    i9 = 2 - i12 | 0;
    i9 = i12 + (i9 >>> 0 > 4294967293 ? i9 : -3) | 0;
    i9 = i9 - ((i9 >>> 0) % 3 | 0) | 0;
    i10 = i9 - i11 | 0;
    i7 = i4 + (0 - i11) | 0;
    i6 = i12;
    i1 = i4;
    do {
     HEAP8[i1 + 1 >> 0] = HEAP8[i7 + 1 >> 0] | 0;
     HEAP8[i1 + 2 >> 0] = HEAP8[i7 + 2 >> 0] | 0;
     i7 = i7 + 3 | 0;
     i1 = i1 + 3 | 0;
     HEAP8[i1 >> 0] = HEAP8[i7 >> 0] | 0;
     i6 = i6 + -3 | 0;
    } while (i6 >>> 0 > 2);
    i1 = i12 + -3 | 0;
    if ((i1 | 0) == (i9 | 0)) {
     i4 = i4 + (i9 + 3) | 0;
     break;
    }
    i7 = i4 + (i9 + 4) | 0;
    HEAP8[i7 >> 0] = HEAP8[i4 + (i10 + 4) >> 0] | 0;
    if ((i1 - i9 | 0) >>> 0 <= 1) {
     i4 = i7;
     break;
    }
    i12 = i4 + (i9 + 5) | 0;
    HEAP8[i12 >> 0] = HEAP8[i4 + (i10 + 5) >> 0] | 0;
    i4 = i12;
    break;
   }
   i6 = i11 - i1 | 0;
   if (i6 >>> 0 > i23 >>> 0 ? (HEAP32[i14 >> 2] | 0) != 0 : 0) {
    i30 = 22;
    break L1;
   }
   do if (i16) {
    i1 = i25 + (i17 - i6) | 0;
    if (i12 >>> 0 > i6 >>> 0) {
     i7 = i12 - i6 | 0;
     i10 = i11 - i10 | 0;
     i8 = i1;
     i1 = i4;
     do {
      i8 = i8 + 1 | 0;
      i1 = i1 + 1 | 0;
      HEAP8[i1 >> 0] = HEAP8[i8 >> 0] | 0;
      i6 = i6 + -1 | 0;
     } while ((i6 | 0) != 0);
     i8 = i4 + (i20 + i10 + (1 - i11)) | 0;
     i4 = i4 + (i13 + i10) | 0;
    } else {
     i8 = i1;
     i7 = i12;
    }
   } else {
    if (i6 >>> 0 <= i24 >>> 0) {
     i1 = i25 + (i19 - i6) | 0;
     if (i12 >>> 0 <= i6 >>> 0) {
      i8 = i1;
      i7 = i12;
      break;
     }
     i7 = i12 - i6 | 0;
     i10 = i11 - i10 | 0;
     i8 = i1;
     i1 = i4;
     do {
      i8 = i8 + 1 | 0;
      i1 = i1 + 1 | 0;
      HEAP8[i1 >> 0] = HEAP8[i8 >> 0] | 0;
      i6 = i6 + -1 | 0;
     } while ((i6 | 0) != 0);
     i8 = i4 + (i20 + i10 + (1 - i11)) | 0;
     i4 = i4 + (i13 + i10) | 0;
     break;
    }
    i8 = i25 + (i18 - i6) | 0;
    i6 = i6 - i24 | 0;
    if (i12 >>> 0 > i6 >>> 0) {
     i7 = i12 - i6 | 0;
     i10 = i11 - i10 | 0;
     i1 = i4;
     do {
      i8 = i8 + 1 | 0;
      i1 = i1 + 1 | 0;
      HEAP8[i1 >> 0] = HEAP8[i8 >> 0] | 0;
      i6 = i6 + -1 | 0;
     } while ((i6 | 0) != 0);
     i6 = i4 + (i21 + i10) | 0;
     if (i7 >>> 0 > i24 >>> 0) {
      i7 = i7 - i24 | 0;
      i8 = i15;
      i9 = i24;
      do {
       i8 = i8 + 1 | 0;
       i6 = i6 + 1 | 0;
       HEAP8[i6 >> 0] = HEAP8[i8 >> 0] | 0;
       i9 = i9 + -1 | 0;
      } while ((i9 | 0) != 0);
      i8 = i4 + (i20 + i10 + (1 - i11)) | 0;
      i4 = i4 + (i13 + i10) | 0;
     } else {
      i8 = i15;
      i4 = i6;
     }
    } else i7 = i12;
   } while (0);
   if (i7 >>> 0 > 2) {
    i10 = i7 + -3 | 0;
    i6 = (i10 >>> 0) % 3 | 0;
    i10 = i10 - i6 | 0;
    i9 = i8;
    i1 = i4;
    do {
     HEAP8[i1 + 1 >> 0] = HEAP8[i9 + 1 >> 0] | 0;
     HEAP8[i1 + 2 >> 0] = HEAP8[i9 + 2 >> 0] | 0;
     i9 = i9 + 3 | 0;
     i1 = i1 + 3 | 0;
     HEAP8[i1 >> 0] = HEAP8[i9 >> 0] | 0;
     i7 = i7 + -3 | 0;
    } while (i7 >>> 0 > 2);
    i8 = i8 + (i10 + 3) | 0;
    i7 = i4 + (i10 + 3) | 0;
   } else {
    i6 = i7;
    i7 = i4;
   }
   if (i6) {
    i4 = i7 + 1 | 0;
    HEAP8[i4 >> 0] = HEAP8[i8 + 1 >> 0] | 0;
    if (i6 >>> 0 > 1) {
     i4 = i7 + 2 | 0;
     HEAP8[i4 >> 0] = HEAP8[i8 + 2 >> 0] | 0;
    }
   } else i4 = i7;
  } else {
   i1 = i1 & 255;
   i30 = 7;
  } while (0);
  if ((i30 | 0) == 7) {
   i30 = 0;
   i4 = i4 + 1 | 0;
   HEAP8[i4 >> 0] = i1;
  }
 } while (i5 >>> 0 < i31 >>> 0 & i4 >>> 0 < i35 >>> 0);
 do if ((i30 | 0) == 22) {
  HEAP32[i33 + 24 >> 2] = 146544;
  HEAP32[i22 >> 2] = 29;
 } else if ((i30 | 0) == 54) {
  HEAP32[i33 + 24 >> 2] = 146576;
  HEAP32[i22 >> 2] = 29;
 } else if ((i30 | 0) == 57) if (!(i10 & 32)) {
  HEAP32[i33 + 24 >> 2] = 146600;
  HEAP32[i22 >> 2] = 29;
  break;
 } else {
  HEAP32[i22 >> 2] = 11;
  break;
 } while (0);
 i22 = i3 >>> 3;
 i1 = i5 + (0 - i22) | 0;
 i3 = i3 - (i22 << 3) | 0;
 i2 = (1 << i3) + -1 & i2;
 HEAP32[i33 >> 2] = i5 + (1 - i22);
 HEAP32[i32 >> 2] = i4 + 1;
 if (i1 >>> 0 < i31 >>> 0) i1 = i31 - i1 | 0; else i1 = i31 - i1 | 0;
 HEAP32[i38 >> 2] = i1 + 5;
 if (i4 >>> 0 < i35 >>> 0) {
  i22 = i35 - i4 | 0;
  i22 = i22 + 257 | 0;
  HEAP32[i34 >> 2] = i22;
  HEAP32[i36 >> 2] = i2;
  HEAP32[i37 >> 2] = i3;
  STACKTOP = i39;
  return;
 } else {
  i22 = i35 - i4 | 0;
  i22 = i22 + 257 | 0;
  HEAP32[i34 >> 2] = i22;
  HEAP32[i36 >> 2] = i2;
  HEAP32[i37 >> 2] = i3;
  STACKTOP = i39;
  return;
 }
}

function __ZN7testing8internal32FormatEpochTimeInMillisAsIso8601Ex(i21, i1, i2) {
 i21 = i21 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 i5 = i22 + 184 | 0;
 i13 = i22 + 172 | 0;
 i14 = i22 + 160 | 0;
 i15 = i22 + 148 | 0;
 i16 = i22 + 136 | 0;
 i17 = i22 + 124 | 0;
 i18 = i22 + 112 | 0;
 i19 = i22 + 100 | 0;
 i20 = i22 + 88 | 0;
 i6 = i22 + 76 | 0;
 i7 = i22 + 64 | 0;
 i3 = i22 + 60 | 0;
 i8 = i22 + 48 | 0;
 i9 = i22 + 36 | 0;
 i10 = i22 + 24 | 0;
 i11 = i22 + 12 | 0;
 i12 = i22;
 i4 = ___divdi3(i1 | 0, i2 | 0, 1e3, 0) | 0;
 HEAP32[i5 >> 2] = i4;
 i5 = _localtime(i5 | 0) | 0;
 if (!i5) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, 159968, 0);
  STACKTOP = i22;
  return;
 }
 HEAP32[i3 >> 2] = (HEAP32[i5 + 20 >> 2] | 0) + 1900;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i7, i3);
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = HEAP8[i7 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = (i1 & 255) >>> 1;
  i1 = i7 + 1 | 0;
 } else {
  i2 = HEAP32[i7 + 4 >> 2] | 0;
  i1 = HEAP32[i7 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, i1, i2, i2 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, 163064, 1) | 0;
 __ZN7testing8internal6String15FormatIntWidth2Ei(i8, (HEAP32[i5 + 16 >> 2] | 0) + 1 | 0);
 HEAP32[i20 + 0 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i4 = (i2 & 1) == 0;
 if (i4) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = HEAP8[i8 >> 0] | 0;
 if (!(i3 & 1)) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i8 + 4 >> 2] | 0;
 if (i4) i3 = i6 + 1 | 0; else i3 = HEAP32[i6 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i20, i3, i2, i1 + i2 | 0);
 if (!(HEAP8[i8 >> 0] & 1)) i2 = i8 + 1 | 0; else i2 = HEAP32[i8 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i20, i2, i1) | 0;
 HEAP32[i19 + 0 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 i1 = HEAP8[i20 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = (i1 & 255) >>> 1;
  i1 = i20 + 1 | 0;
 } else {
  i2 = HEAP32[i20 + 4 >> 2] | 0;
  i1 = HEAP32[i20 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i19, i1, i2, i2 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i19, 163064, 1) | 0;
 __ZN7testing8internal6String15FormatIntWidth2Ei(i9, HEAP32[i5 + 12 >> 2] | 0);
 HEAP32[i18 + 0 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i2 = HEAP8[i19 >> 0] | 0;
 i1 = (i2 & 1) == 0;
 if (i1) i4 = (i2 & 255) >>> 1; else i4 = HEAP32[i19 + 4 >> 2] | 0;
 i3 = HEAP8[i9 >> 0] | 0;
 if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i9 + 4 >> 2] | 0;
 if (i1) i2 = i19 + 1 | 0; else i2 = HEAP32[i19 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i18, i2, i4, i3 + i4 | 0);
 if (!(HEAP8[i9 >> 0] & 1)) i2 = i9 + 1 | 0; else i2 = HEAP32[i9 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i18, i2, i3) | 0;
 HEAP32[i17 + 0 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i1 = HEAP8[i18 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = (i1 & 255) >>> 1;
  i1 = i18 + 1 | 0;
 } else {
  i2 = HEAP32[i18 + 4 >> 2] | 0;
  i1 = HEAP32[i18 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i17, i1, i2, i2 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i17, 163072, 1) | 0;
 __ZN7testing8internal6String15FormatIntWidth2Ei(i10, HEAP32[i5 + 8 >> 2] | 0);
 HEAP32[i16 + 0 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i2 = HEAP8[i17 >> 0] | 0;
 i4 = (i2 & 1) == 0;
 if (i4) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i17 + 4 >> 2] | 0;
 i3 = HEAP8[i10 >> 0] | 0;
 if (!(i3 & 1)) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i10 + 4 >> 2] | 0;
 if (i4) i3 = i17 + 1 | 0; else i3 = HEAP32[i17 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, i3, i2, i1 + i2 | 0);
 if (!(HEAP8[i10 >> 0] & 1)) i2 = i10 + 1 | 0; else i2 = HEAP32[i10 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, i2, i1) | 0;
 HEAP32[i15 + 0 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 i1 = HEAP8[i16 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = (i1 & 255) >>> 1;
  i1 = i16 + 1 | 0;
 } else {
  i2 = HEAP32[i16 + 4 >> 2] | 0;
  i1 = HEAP32[i16 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i15, i1, i2, i2 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i15, 163080, 1) | 0;
 __ZN7testing8internal6String15FormatIntWidth2Ei(i11, HEAP32[i5 + 4 >> 2] | 0);
 HEAP32[i14 + 0 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i2 = HEAP8[i15 >> 0] | 0;
 i4 = (i2 & 1) == 0;
 if (i4) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i15 + 4 >> 2] | 0;
 i3 = HEAP8[i11 >> 0] | 0;
 if (!(i3 & 1)) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i11 + 4 >> 2] | 0;
 if (i4) i3 = i15 + 1 | 0; else i3 = HEAP32[i15 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i14, i3, i2, i1 + i2 | 0);
 if (!(HEAP8[i11 >> 0] & 1)) i2 = i11 + 1 | 0; else i2 = HEAP32[i11 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i14, i2, i1) | 0;
 HEAP32[i13 + 0 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i1 = HEAP8[i14 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = (i1 & 255) >>> 1;
  i1 = i14 + 1 | 0;
 } else {
  i2 = HEAP32[i14 + 4 >> 2] | 0;
  i1 = HEAP32[i14 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i13, i1, i2, i2 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i13, 163080, 1) | 0;
 __ZN7testing8internal6String15FormatIntWidth2Ei(i12, HEAP32[i5 >> 2] | 0);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 i1 = HEAP8[i13 >> 0] | 0;
 i3 = (i1 & 1) == 0;
 if (i3) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = HEAP8[i12 >> 0] | 0;
 if (!(i2 & 1)) i4 = (i2 & 255) >>> 1; else i4 = HEAP32[i12 + 4 >> 2] | 0;
 if (i3) i2 = i13 + 1 | 0; else i2 = HEAP32[i13 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i21, i2, i1, i4 + i1 | 0);
 if (!(HEAP8[i12 >> 0] & 1)) i1 = i12 + 1 | 0; else i1 = HEAP32[i12 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i21, i1, i4) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i18);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 STACKTOP = i22;
 return;
}

function _strstr(i5, i18) {
 i5 = i5 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 i17 = i21 + 1024 | 0;
 i20 = i21;
 i4 = HEAP8[i18 >> 0] | 0;
 if (!(i4 << 24 >> 24)) {
  i10 = i5;
  STACKTOP = i21;
  return i10 | 0;
 }
 i14 = _strchr(i5, i4 << 24 >> 24) | 0;
 if (!i14) {
  i10 = 0;
  STACKTOP = i21;
  return i10 | 0;
 }
 i5 = HEAP8[i18 + 1 >> 0] | 0;
 if (!(i5 << 24 >> 24)) {
  i10 = i14;
  STACKTOP = i21;
  return i10 | 0;
 }
 i2 = i14 + 1 | 0;
 i9 = HEAP8[i2 >> 0] | 0;
 if (!(i9 << 24 >> 24)) {
  i10 = 0;
  STACKTOP = i21;
  return i10 | 0;
 }
 i8 = HEAP8[i18 + 2 >> 0] | 0;
 if (!(i8 << 24 >> 24)) {
  i5 = i5 & 255 | (i4 & 255) << 8;
  i1 = i9;
  i3 = HEAPU8[i14 >> 0] << 8 | i9 & 255;
  while (1) {
   i3 = i3 & 65535;
   if ((i3 | 0) == (i5 | 0)) break;
   i2 = i2 + 1 | 0;
   i4 = HEAP8[i2 >> 0] | 0;
   if (!(i4 << 24 >> 24)) {
    i1 = 0;
    break;
   } else {
    i1 = i4;
    i3 = i4 & 255 | i3 << 8;
   }
  }
  i10 = i1 << 24 >> 24 == 0 ? 0 : i2 + -1 | 0;
  STACKTOP = i21;
  return i10 | 0;
 }
 i2 = i14 + 2 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 if (!(i3 << 24 >> 24)) {
  i10 = 0;
  STACKTOP = i21;
  return i10 | 0;
 }
 i7 = HEAP8[i18 + 3 >> 0] | 0;
 if (!(i7 << 24 >> 24)) {
  i5 = (i5 & 255) << 16 | (i4 & 255) << 24 | (i8 & 255) << 8;
  i1 = (i3 & 255) << 8 | (i9 & 255) << 16 | HEAPU8[i14 >> 0] << 24;
  if ((i1 | 0) == (i5 | 0)) i1 = 0; else {
   i3 = i1;
   do {
    i2 = i2 + 1 | 0;
    i1 = HEAP8[i2 >> 0] | 0;
    i3 = (i1 & 255 | i3) << 8;
    i1 = i1 << 24 >> 24 == 0;
   } while (!(i1 | (i3 | 0) == (i5 | 0)));
  }
  i10 = i1 ? 0 : i2 + -2 | 0;
  STACKTOP = i21;
  return i10 | 0;
 }
 i2 = i14 + 3 | 0;
 i6 = HEAP8[i2 >> 0] | 0;
 if (!(i6 << 24 >> 24)) {
  i10 = 0;
  STACKTOP = i21;
  return i10 | 0;
 }
 if (!(HEAP8[i18 + 4 >> 0] | 0)) {
  i5 = (i5 & 255) << 16 | (i4 & 255) << 24 | (i8 & 255) << 8 | i7 & 255;
  i1 = (i3 & 255) << 8 | (i9 & 255) << 16 | i6 & 255 | HEAPU8[i14 >> 0] << 24;
  if ((i1 | 0) == (i5 | 0)) i1 = 0; else {
   i3 = i1;
   do {
    i2 = i2 + 1 | 0;
    i1 = HEAP8[i2 >> 0] | 0;
    i3 = i1 & 255 | i3 << 8;
    i1 = i1 << 24 >> 24 == 0;
   } while (!(i1 | (i3 | 0) == (i5 | 0)));
  }
  i10 = i1 ? 0 : i2 + -3 | 0;
  STACKTOP = i21;
  return i10 | 0;
 };
 HEAP32[i17 + 0 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 HEAP32[i17 + 20 >> 2] = 0;
 HEAP32[i17 + 24 >> 2] = 0;
 HEAP32[i17 + 28 >> 2] = 0;
 i5 = i4;
 i13 = 0;
 while (1) {
  if (!(HEAP8[i14 + i13 >> 0] | 0)) {
   i1 = 0;
   i10 = 79;
   break;
  }
  i15 = i17 + (((i5 & 255) >>> 5 & 255) << 2) | 0;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 1 << (i5 & 31);
  i15 = i13 + 1 | 0;
  HEAP32[i20 + ((i5 & 255) << 2) >> 2] = i15;
  i5 = HEAP8[i18 + i15 >> 0] | 0;
  if (!(i5 << 24 >> 24)) break; else i13 = i15;
 }
 if ((i10 | 0) == 79) {
  STACKTOP = i21;
  return i1 | 0;
 }
 L49 : do if (i15 >>> 0 > 1) {
  i4 = 1;
  i8 = -1;
  i5 = 0;
  L50 : while (1) {
   i2 = 1;
   while (1) {
    L54 : while (1) {
     i6 = i4;
     i1 = 1;
     while (1) {
      i4 = HEAP8[i18 + (i1 + i8) >> 0] | 0;
      i3 = HEAP8[i18 + i6 >> 0] | 0;
      if (i4 << 24 >> 24 != i3 << 24 >> 24) break L54;
      if ((i1 | 0) == (i2 | 0)) break;
      i1 = i1 + 1 | 0;
      i4 = i1 + i5 | 0;
      if (i4 >>> 0 >= i15 >>> 0) {
       i5 = i8;
       break L50;
      } else i6 = i4;
     }
     i5 = i5 + i2 | 0;
     i4 = i5 + 1 | 0;
     if (i4 >>> 0 >= i15 >>> 0) {
      i5 = i8;
      break L50;
     }
    }
    i2 = i6 - i8 | 0;
    if ((i4 & 255) <= (i3 & 255)) break;
    i4 = i6 + 1 | 0;
    if (i4 >>> 0 >= i15 >>> 0) {
     i5 = i8;
     break L50;
    } else i5 = i6;
   }
   i4 = i5 + 2 | 0;
   if (i4 >>> 0 >= i15 >>> 0) {
    i2 = 1;
    break;
   } else {
    i8 = i5;
    i5 = i5 + 1 | 0;
   }
  }
  i4 = 1;
  i10 = -1;
  i3 = 0;
  while (1) {
   i6 = i4;
   i4 = 1;
   while (1) {
    i1 = i6;
    L69 : while (1) {
     i8 = 1;
     while (1) {
      i6 = HEAP8[i18 + (i8 + i10) >> 0] | 0;
      i7 = HEAP8[i18 + i1 >> 0] | 0;
      if (i6 << 24 >> 24 != i7 << 24 >> 24) break L69;
      if ((i8 | 0) == (i4 | 0)) break;
      i8 = i8 + 1 | 0;
      i1 = i8 + i3 | 0;
      if (i1 >>> 0 >= i15 >>> 0) {
       i3 = i10;
       break L49;
      }
     }
     i3 = i3 + i4 | 0;
     i1 = i3 + 1 | 0;
     if (i1 >>> 0 >= i15 >>> 0) {
      i3 = i10;
      break L49;
     }
    }
    i4 = i1 - i10 | 0;
    if ((i6 & 255) >= (i7 & 255)) break;
    i6 = i1 + 1 | 0;
    if (i6 >>> 0 >= i15 >>> 0) {
     i3 = i10;
     break L49;
    } else i3 = i1;
   }
   i4 = i3 + 2 | 0;
   if (i4 >>> 0 >= i15 >>> 0) {
    i4 = 1;
    break;
   } else {
    i10 = i3;
    i3 = i3 + 1 | 0;
   }
  }
 } else {
  i5 = -1;
  i3 = -1;
  i2 = 1;
  i4 = 1;
 } while (0);
 i12 = (i3 + 1 | 0) >>> 0 > (i5 + 1 | 0) >>> 0;
 i2 = i12 ? i4 : i2;
 i12 = i12 ? i3 : i5;
 i11 = i12 + 1 | 0;
 if (!(_memcmp(i18, i18 + i2 | 0, i11) | 0)) {
  i10 = i15 - i2 | 0;
  i9 = i15 | 63;
  if ((i15 | 0) != (i2 | 0)) {
   i1 = i14;
   i4 = 0;
   i8 = i14;
   L83 : while (1) {
    i7 = i1;
    do if ((i8 - i7 | 0) >>> 0 < i15 >>> 0) {
     i6 = _memchr(i8, 0, i9) | 0;
     if (i6) if ((i6 - i7 | 0) >>> 0 < i15 >>> 0) {
      i1 = 0;
      i10 = 79;
      break L83;
     } else {
      i8 = i6;
      break;
     } else {
      i8 = i8 + i9 | 0;
      break;
     }
    } while (0);
    i6 = HEAP8[i1 + i13 >> 0] | 0;
    if (!(1 << (i6 & 31) & HEAP32[i17 + (((i6 & 255) >>> 5 & 255) << 2) >> 2])) {
     i1 = i1 + i15 | 0;
     i4 = 0;
     continue;
    }
    i7 = HEAP32[i20 + ((i6 & 255) << 2) >> 2] | 0;
    i6 = i15 - i7 | 0;
    if ((i15 | 0) != (i7 | 0)) {
     i1 = i1 + ((i4 | 0) != 0 & i6 >>> 0 < i2 >>> 0 ? i10 : i6) | 0;
     i4 = 0;
     continue;
    }
    i6 = i11 >>> 0 > i4 >>> 0 ? i11 : i4;
    i7 = HEAP8[i18 + i6 >> 0] | 0;
    L97 : do if (!(i7 << 24 >> 24)) i6 = i11; else {
     while (1) {
      i5 = i6 + 1 | 0;
      if (i7 << 24 >> 24 != (HEAP8[i1 + i6 >> 0] | 0)) break;
      i7 = HEAP8[i18 + i5 >> 0] | 0;
      if (!(i7 << 24 >> 24)) {
       i6 = i11;
       break L97;
      } else i6 = i5;
     }
     i1 = i1 + (i6 - i12) | 0;
     i4 = 0;
     continue L83;
    } while (0);
    do {
     if (i6 >>> 0 <= i4 >>> 0) {
      i10 = 79;
      break L83;
     }
     i6 = i6 + -1 | 0;
    } while ((HEAP8[i18 + i6 >> 0] | 0) == (HEAP8[i1 + i6 >> 0] | 0));
    i1 = i1 + i2 | 0;
    i4 = i10;
   }
   if ((i10 | 0) == 79) {
    STACKTOP = i21;
    return i1 | 0;
   }
  } else {
   i16 = i9;
   i19 = i15;
  }
 } else {
  i19 = i15 - i12 + -1 | 0;
  i16 = i15 | 63;
  i19 = (i12 >>> 0 > i19 >>> 0 ? i12 : i19) + 1 | 0;
 }
 i7 = i18 + i11 | 0;
 i8 = i14;
 i3 = i14;
 L110 : while (1) {
  i5 = i8;
  do if ((i3 - i5 | 0) >>> 0 < i15 >>> 0) {
   i4 = _memchr(i3, 0, i16) | 0;
   if (i4) if ((i4 - i5 | 0) >>> 0 < i15 >>> 0) {
    i1 = 0;
    i10 = 79;
    break L110;
   } else break; else {
    i4 = i3 + i16 | 0;
    break;
   }
  } else i4 = i3; while (0);
  i5 = HEAP8[i8 + i13 >> 0] | 0;
  if (!(1 << (i5 & 31) & HEAP32[i17 + (((i5 & 255) >>> 5 & 255) << 2) >> 2])) {
   i8 = i8 + i15 | 0;
   i3 = i4;
   continue;
  }
  i5 = HEAP32[i20 + ((i5 & 255) << 2) >> 2] | 0;
  if ((i15 | 0) != (i5 | 0)) {
   i8 = i8 + (i15 - i5) | 0;
   i3 = i4;
   continue;
  }
  i5 = HEAP8[i7 >> 0] | 0;
  L124 : do if (!(i5 << 24 >> 24)) i5 = i11; else {
   i2 = i11;
   while (1) {
    i3 = i2 + 1 | 0;
    if (i5 << 24 >> 24 != (HEAP8[i8 + i2 >> 0] | 0)) break;
    i5 = HEAP8[i18 + i3 >> 0] | 0;
    if (!(i5 << 24 >> 24)) {
     i5 = i11;
     break L124;
    } else i2 = i3;
   }
   i8 = i8 + (i2 - i12) | 0;
   i3 = i4;
   continue L110;
  } while (0);
  do {
   if (!i5) {
    i1 = i8;
    i10 = 79;
    break L110;
   }
   i5 = i5 + -1 | 0;
  } while ((HEAP8[i18 + i5 >> 0] | 0) == (HEAP8[i8 + i5 >> 0] | 0));
  i8 = i8 + i19 | 0;
  i3 = i4;
 }
 if ((i10 | 0) == 79) {
  STACKTOP = i21;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cv3SVD9backSubstERKNS_11_InputArrayES3_S3_S3_RKNS_12_OutputArrayE(i4, i2, i1, i3, i15) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 1360 | 0;
 i26 = i27 + 1296 | 0;
 i25 = i27 + 1240 | 0;
 i23 = i27 + 1184 | 0;
 i22 = i27 + 1128 | 0;
 i21 = i27 + 88 | 0;
 i10 = i27 + 80 | 0;
 i11 = i27 + 72 | 0;
 i12 = i27 + 64 | 0;
 i20 = i27 + 8 | 0;
 i13 = i27;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i4 >> 2] >> 2] & 63](i26, i4, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i2 >> 2] >> 2] & 63](i25, i2, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i1 >> 2] >> 2] & 63](i23, i1, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i3 >> 2] >> 2] & 63](i22, i3, -1);
 i9 = HEAP32[i26 >> 2] & 4095;
 i24 = i26 + 4 | 0;
 i3 = HEAP32[i24 >> 2] | 0;
 if ((i3 | 0) > 0) i4 = HEAP32[(HEAP32[i26 + 44 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0; else i4 = 0;
 i5 = HEAP32[i25 + 8 >> 2] | 0;
 i6 = HEAP32[i23 + 12 >> 2] | 0;
 i19 = i22 + 16 | 0;
 if (!(HEAP32[i19 >> 2] | 0)) i8 = i5; else i8 = HEAP32[i22 + 12 >> 2] | 0;
 i7 = (i6 | 0) < (i5 | 0) ? i6 : i5;
 if ((HEAP32[i26 + 8 >> 2] | 0) != 1) i4 = ((HEAP32[i26 + 12 >> 2] | 0) == 1 ? 0 : i4) + (HEAP32[i26 + 48 >> 2] | 0) | 0;
 i3 = (i8 << 3) + 16 | 0;
 i17 = i21 + 8 | 0;
 HEAP32[i21 >> 2] = i17;
 i18 = i21 + 4 | 0;
 HEAP32[i18 >> 2] = 1032;
 if (i3 >>> 0 > 1032) HEAP32[i21 >> 2] = __Znaj(i3) | 0;
 HEAP32[i18 >> 2] = i3;
 if (!(((((i9 | 0) == (HEAP32[i25 >> 2] & 4095 | 0) ? (i9 | 0) == (HEAP32[i23 >> 2] & 4095 | 0) : 0) ? (HEAP32[i25 + 16 >> 2] | 0) != 0 : 0) ? (HEAP32[i23 + 16 >> 2] | 0) != 0 : 0) ? (HEAP32[i26 + 16 >> 2] | 0) != 0 : 0)) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i10, 76) | 0) + 0 | 0;
  i2 = 4280 | 0;
  i1 = i3 + 76 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 4360, 3856, 1594);
  __ZN2cv6String10deallocateEv(i10);
 }
 i3 = HEAP32[i25 + 12 >> 2] | 0;
 if ((i3 | 0) >= (i7 | 0) ? (i14 = HEAP32[i23 + 8 >> 2] | 0, (i14 | 0) >= (i7 | 0)) : 0) {
  i1 = HEAP32[i26 + 40 >> 2] | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  if ((!((i2 | 0) == (i7 | 0) & (i1 | 0) == 1) ? !((i2 | 0) == 1 & (i1 | 0) == (i7 | 0)) : 0) ? !((i2 | 0) == (i14 | 0) & (i1 | 0) == (i3 | 0)) : 0) i16 = 20;
 } else i16 = 20;
 if ((i16 | 0) == 20) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i11, 122) | 0) + 0 | 0;
  i2 = 4376 | 0;
  i1 = i3 + 122 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i11, 4360, 3856, 1596);
  __ZN2cv6String10deallocateEv(i11);
 }
 do if (HEAP32[i19 >> 2] | 0) {
  if ((HEAP32[i22 >> 2] & 4095 | 0) == (i9 | 0) ? (HEAP32[i22 + 8 >> 2] | 0) == (i5 | 0) : 0) break;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i12, 54) | 0) + 0 | 0;
  i2 = 4504 | 0;
  i1 = i3 + 54 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i12, 4360, 3856, 1597);
  __ZN2cv6String10deallocateEv(i12);
 } while (0);
 FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i15 >> 2] | 0) + 140 >> 2] & 63](i15, i6, i8, i9, -1, 0, 0);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i15 >> 2] >> 2] & 63](i20, i15, -1);
 if ((i9 | 0) == 5) __ZN2cvL6SVBkSbEiiPKfjS1_jbS1_jbS1_jiPfjPh(i5, i6, HEAP32[i26 + 16 >> 2] | 0, i4, HEAP32[i25 + 16 >> 2] | 0, HEAP32[i25 + 48 >> 2] | 0, 0, HEAP32[i23 + 16 >> 2] | 0, HEAP32[i23 + 48 >> 2] | 0, HEAP32[i19 >> 2] | 0, HEAP32[i22 + 48 >> 2] | 0, i8, HEAP32[i20 + 16 >> 2] | 0, HEAP32[i20 + 48 >> 2] | 0, HEAP32[i21 >> 2] | 0); else if ((i9 | 0) == 6) __ZN2cvL6SVBkSbEiiPKdjS1_jbS1_jbS1_jiPdjPh(i5, i6, HEAP32[i26 + 16 >> 2] | 0, i4, HEAP32[i25 + 16 >> 2] | 0, HEAP32[i25 + 48 >> 2] | 0, 0, HEAP32[i23 + 16 >> 2] | 0, HEAP32[i23 + 48 >> 2] | 0, HEAP32[i19 >> 2] | 0, HEAP32[i22 + 48 >> 2] | 0, i8, HEAP32[i20 + 16 >> 2] | 0, HEAP32[i20 + 48 >> 2] | 0, HEAP32[i21 >> 2] | 0); else {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i13, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-210, i13, 4360, 3856, 1610);
  __ZN2cv6String10deallocateEv(i13);
 }
 i3 = i20 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i15 = i2 + 12 | 0, i16 = HEAP32[i15 >> 2] | 0, HEAP32[i15 >> 2] = i16 + -1, (i16 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i20);
 HEAP32[i3 >> 2] = 0;
 i16 = i20 + 16 | 0;
 i3 = i20 + 4 | 0;
 HEAP32[i16 + 0 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i20 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i3 = HEAP32[i20 + 44 >> 2] | 0;
 if ((i3 | 0) != (i20 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
 i3 = HEAP32[i21 >> 2] | 0;
 if ((i3 | 0) != (i17 | 0)) {
  if (i3) __ZdaPv(i3);
  HEAP32[i21 >> 2] = i17;
  HEAP32[i18 >> 2] = 1032;
 }
 i3 = i22 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i20 = i2 + 12 | 0, i21 = HEAP32[i20 >> 2] | 0, HEAP32[i20 >> 2] = i21 + -1, (i21 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i22);
 HEAP32[i3 >> 2] = 0;
 i1 = i22 + 4 | 0;
 HEAP32[i19 + 0 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 if ((HEAP32[i1 >> 2] | 0) > 0) {
  i3 = HEAP32[i22 + 40 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
 }
 i2 = HEAP32[i22 + 44 >> 2] | 0;
 if ((i2 | 0) != (i22 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i23 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i23);
 HEAP32[i2 >> 2] = 0;
 i22 = i23 + 16 | 0;
 i3 = i23 + 4 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i23 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i2 = HEAP32[i23 + 44 >> 2] | 0;
 if ((i2 | 0) != (i23 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i25 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i25);
 HEAP32[i2 >> 2] = 0;
 i22 = i25 + 16 | 0;
 i2 = i25 + 4 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i25 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i25 + 44 >> 2] | 0;
 if ((i1 | 0) != (i25 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i26 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (i2) {
  i21 = i2 + 12 | 0;
  i22 = HEAP32[i21 >> 2] | 0;
  HEAP32[i21 >> 2] = i22 + -1;
  if ((i22 | 0) != 1) break;
  __ZN2cv3Mat10deallocateEv(i26);
 } while (0);
 HEAP32[i1 >> 2] = 0;
 i22 = i26 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i24 >> 2] | 0) > 0) {
  i2 = HEAP32[i26 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i24 >> 2] | 0));
 }
 i1 = HEAP32[i26 + 44 >> 2] | 0;
 if ((i1 | 0) == (i26 + 48 | 0)) {
  STACKTOP = i27;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i27;
 return;
}

function __ZN2cvL17GEMMBlockMul_32fcEPKNS_7ComplexIfEEjS3_jPNS0_IdEEjNS_5Size_IiEES7_i(i20, i3, i34, i4, i19, i5, i1, i2, i12) {
 i20 = i20 | 0;
 i3 = i3 | 0;
 i34 = i34 | 0;
 i4 = i4 | 0;
 i19 = i19 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i6 = 0, i7 = 0, d8 = 0.0, d9 = 0.0, i10 = 0, i11 = 0, d13 = 0.0, d14 = 0.0, d15 = 0.0, d16 = 0.0, d17 = 0.0, d18 = 0.0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, d37 = 0.0, d38 = 0.0, d39 = 0.0, d40 = 0.0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 i35 = i36;
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i1 + 4 >> 2] | 0;
 i32 = HEAP32[i2 >> 2] | 0;
 i31 = HEAP32[i2 + 4 >> 2] | 0;
 i33 = i35 + 8 | 0;
 i2 = i35 + 1096 | 0;
 i1 = i33;
 do {
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i35 >> 2] = i33;
 i30 = i35 + 4 | 0;
 HEAP32[i30 >> 2] = 136;
 i11 = i12 & 16;
 i6 = i3 >>> 3;
 i29 = i4 >>> 3;
 i28 = i5 >>> 4;
 do if (!(i12 & 1)) {
  i2 = 0;
  i27 = i6;
  i6 = 1;
 } else {
  if (i10 >>> 0 <= 136) {
   HEAP32[i30 >> 2] = i10;
   i2 = i33;
   i27 = 1;
   i7 = i10;
   break;
  }
  i2 = __Znaj(i10 >>> 0 > 536870911 ? -1 : i10 << 3) | 0;
  i1 = i2 + (i10 << 3) | 0;
  i3 = i2;
  do {
   HEAPF32[i3 >> 2] = Math_fround(0.0);
   HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
   i3 = i3 + 8 | 0;
  } while ((i3 | 0) != (i1 | 0));
  HEAP32[i35 >> 2] = i2;
  HEAP32[i30 >> 2] = i10;
  i27 = 1;
  i7 = i10;
 } while (0);
 i3 = (i31 | 0) > 0;
 if (!(i12 & 2)) {
  if (i3) {
   i26 = (i2 | 0) == 0;
   i3 = i32 + -4 | 0;
   i4 = (i3 | 0) < 0;
   i24 = (i11 | 0) == 0;
   i1 = (i7 | 0) > 0;
   i12 = i32 & -4;
   i25 = i26 | i1 ^ 1;
   i21 = 0;
   while (1) {
    if (i25) i22 = i26 ? i20 : i2; else {
     i5 = 0;
     do {
      i10 = i20 + ((Math_imul(i5, i6) | 0) << 3) | 0;
      i22 = HEAP32[i10 + 4 >> 2] | 0;
      i23 = i2 + (i5 << 3) | 0;
      HEAP32[i23 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i23 + 4 >> 2] = i22;
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i7 | 0));
     i22 = i2;
    }
    if (i4) i5 = 0; else {
     i23 = 0;
     do {
      if (i24) {
       d8 = 0.0;
       d14 = 0.0;
       d16 = 0.0;
       d18 = 0.0;
       d17 = 0.0;
       d15 = 0.0;
       d13 = 0.0;
       d9 = 0.0;
      } else {
       i11 = i23 | 1;
       i10 = i23 | 2;
       i5 = i23 | 3;
       d8 = +HEAPF64[i19 + (i23 << 4) >> 3];
       d14 = +HEAPF64[i19 + (i23 << 4) + 8 >> 3];
       d16 = +HEAPF64[i19 + (i11 << 4) >> 3];
       d18 = +HEAPF64[i19 + (i11 << 4) + 8 >> 3];
       d17 = +HEAPF64[i19 + (i10 << 4) >> 3];
       d15 = +HEAPF64[i19 + (i10 << 4) + 8 >> 3];
       d13 = +HEAPF64[i19 + (i5 << 4) >> 3];
       d9 = +HEAPF64[i19 + (i5 << 4) + 8 >> 3];
      }
      if (i1) {
       i11 = i34 + (i23 << 3) | 0;
       i10 = 0;
       while (1) {
        d38 = +Math_fround(HEAPF32[i22 + (i10 << 3) >> 2]);
        d40 = +Math_fround(HEAPF32[i22 + (i10 << 3) + 4 >> 2]);
        d37 = +Math_fround(HEAPF32[i11 >> 2]);
        d39 = +Math_fround(HEAPF32[i11 + 4 >> 2]);
        d8 = d8 + (d38 * d37 - d40 * d39);
        d14 = d14 + (d40 * d37 + d38 * d39);
        d39 = +Math_fround(HEAPF32[i11 + 8 >> 2]);
        d37 = +Math_fround(HEAPF32[i11 + 12 >> 2]);
        d16 = d16 + (d38 * d39 - d40 * d37);
        d18 = d18 + (d40 * d39 + d38 * d37);
        d37 = +Math_fround(HEAPF32[i11 + 16 >> 2]);
        d39 = +Math_fround(HEAPF32[i11 + 20 >> 2]);
        d17 = d17 + (d38 * d37 - d40 * d39);
        d15 = d15 + (d40 * d37 + d38 * d39);
        d39 = +Math_fround(HEAPF32[i11 + 24 >> 2]);
        d37 = +Math_fround(HEAPF32[i11 + 28 >> 2]);
        d13 = d13 + (d38 * d39 - d40 * d37);
        d9 = d9 + (d40 * d39 + d38 * d37);
        i10 = i10 + 1 | 0;
        if ((i10 | 0) == (i7 | 0)) break; else i11 = i11 + (i29 << 3) | 0;
       }
      }
      HEAPF64[i19 + (i23 << 4) >> 3] = d8;
      HEAPF64[i19 + (i23 << 4) + 8 >> 3] = d14;
      i5 = i23 | 1;
      HEAPF64[i19 + (i5 << 4) >> 3] = d16;
      HEAPF64[i19 + (i5 << 4) + 8 >> 3] = d18;
      i5 = i23 | 2;
      HEAPF64[i19 + (i5 << 4) >> 3] = d17;
      HEAPF64[i19 + (i5 << 4) + 8 >> 3] = d15;
      i5 = i23 | 3;
      HEAPF64[i19 + (i5 << 4) >> 3] = d13;
      HEAPF64[i19 + (i5 << 4) + 8 >> 3] = d9;
      i23 = i23 + 4 | 0;
     } while ((i23 | 0) <= (i3 | 0));
     i5 = i12;
    }
    if ((i5 | 0) < (i32 | 0)) do {
     if (i24) {
      d9 = 0.0;
      d8 = 0.0;
     } else {
      d9 = +HEAPF64[i19 + (i5 << 4) + 8 >> 3];
      d8 = +HEAPF64[i19 + (i5 << 4) >> 3];
     }
     if (i1) {
      i11 = i34 + (i5 << 3) | 0;
      i10 = 0;
      while (1) {
       d17 = +Math_fround(HEAPF32[i22 + (i10 << 3) >> 2]);
       d38 = +Math_fround(HEAPF32[i22 + (i10 << 3) + 4 >> 2]);
       d40 = +Math_fround(HEAPF32[i11 >> 2]);
       d18 = +Math_fround(HEAPF32[i11 + 4 >> 2]);
       d8 = d8 + (d17 * d40 - d38 * d18);
       d9 = d9 + (d38 * d40 + d17 * d18);
       i10 = i10 + 1 | 0;
       if ((i10 | 0) == (i7 | 0)) break; else i11 = i11 + (i29 << 3) | 0;
      }
     }
     HEAPF64[i19 + (i5 << 4) >> 3] = d8;
     HEAPF64[i19 + (i5 << 4) + 8 >> 3] = d9;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i32 | 0));
    i21 = i21 + 1 | 0;
    if ((i21 | 0) == (i31 | 0)) break; else {
     i19 = i19 + (i28 << 4) | 0;
     i20 = i20 + (i27 << 3) | 0;
    }
   }
  }
 } else if (i3) {
  i26 = (i2 | 0) == 0;
  i10 = (i11 | 0) == 0;
  i21 = i7 + -2 | 0;
  i22 = (i21 | 0) < 0;
  i23 = i7 & -2;
  i25 = i26 | (i7 | 0) < 1;
  i24 = (i32 | 0) > 0;
  i4 = 0;
  while (1) {
   if (i25) i1 = i26 ? i20 : i2; else {
    i5 = 0;
    do {
     i3 = i20 + ((Math_imul(i5, i6) | 0) << 3) | 0;
     i12 = HEAP32[i3 + 4 >> 2] | 0;
     i1 = i2 + (i5 << 3) | 0;
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 + 4 >> 2] = i12;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i7 | 0));
    i1 = i2;
   }
   if (i24) {
    i12 = i34;
    i3 = 0;
    while (1) {
     if (i10) {
      d8 = 0.0;
      d9 = 0.0;
     } else {
      d8 = +HEAPF64[i19 + (i3 << 4) + 8 >> 3];
      d9 = +HEAPF64[i19 + (i3 << 4) >> 3];
     }
     if (i22) {
      d13 = 0.0;
      d14 = 0.0;
      i11 = 0;
     } else {
      d14 = 0.0;
      d13 = 0.0;
      i11 = 0;
      do {
       d38 = +Math_fround(HEAPF32[i1 + (i11 << 3) >> 2]);
       d18 = +Math_fround(HEAPF32[i1 + (i11 << 3) + 4 >> 2]);
       d40 = +Math_fround(HEAPF32[i12 + (i11 << 3) >> 2]);
       d17 = +Math_fround(HEAPF32[i12 + (i11 << 3) + 4 >> 2]);
       d9 = d9 + (d38 * d40 - d18 * d17);
       d8 = d8 + (d18 * d40 + d38 * d17);
       i5 = i11 | 1;
       d17 = +Math_fround(HEAPF32[i1 + (i5 << 3) >> 2]);
       d38 = +Math_fround(HEAPF32[i1 + (i5 << 3) + 4 >> 2]);
       d40 = +Math_fround(HEAPF32[i12 + (i5 << 3) >> 2]);
       d18 = +Math_fround(HEAPF32[i12 + (i5 << 3) + 4 >> 2]);
       d14 = d14 + (d17 * d40 - d38 * d18);
       d13 = d13 + (d38 * d40 + d17 * d18);
       i11 = i11 + 2 | 0;
      } while ((i11 | 0) <= (i21 | 0));
      i11 = i23;
     }
     if ((i11 | 0) < (i7 | 0)) do {
      d17 = +Math_fround(HEAPF32[i1 + (i11 << 3) >> 2]);
      d38 = +Math_fround(HEAPF32[i1 + (i11 << 3) + 4 >> 2]);
      d40 = +Math_fround(HEAPF32[i12 + (i11 << 3) >> 2]);
      d18 = +Math_fround(HEAPF32[i12 + (i11 << 3) + 4 >> 2]);
      d9 = d9 + (d17 * d40 - d38 * d18);
      d8 = d8 + (d38 * d40 + d17 * d18);
      i11 = i11 + 1 | 0;
     } while ((i11 | 0) != (i7 | 0));
     HEAPF64[i19 + (i3 << 4) >> 3] = d14 + d9;
     HEAPF64[i19 + (i3 << 4) + 8 >> 3] = d13 + d8;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i32 | 0)) break; else i12 = i12 + (i29 << 3) | 0;
    }
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i31 | 0)) break; else {
    i19 = i19 + (i28 << 4) | 0;
    i20 = i20 + (i27 << 3) | 0;
   }
  }
 }
 i1 = HEAP32[i35 >> 2] | 0;
 if ((i1 | 0) == (i33 | 0)) {
  STACKTOP = i36;
  return;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i35 >> 2] = i33;
 HEAP32[i30 >> 2] = 136;
 STACKTOP = i36;
 return;
}

function __ZN2cv3MatC2ERKS0_RKNS_5RangeES5_(i21, i18, i10, i12) {
 i21 = i21 | 0;
 i18 = i18 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 1184 | 0;
 i3 = i27 + 1168 | 0;
 i26 = i27 + 72 | 0;
 i24 = i27 + 16 | 0;
 i1 = i27 + 8 | 0;
 i8 = i27;
 HEAP32[i21 >> 2] = 1124007936;
 i23 = i21 + 4 | 0;
 i19 = i21 + 8 | 0;
 i20 = i21 + 12 | 0;
 i25 = i21 + 16 | 0;
 i15 = i21 + 20 | 0;
 i16 = i21 + 24 | 0;
 i13 = i21 + 28 | 0;
 i14 = i21 + 32 | 0;
 i17 = i21 + 36 | 0;
 i11 = i21 + 40 | 0;
 i6 = i23 + 0 | 0;
 i4 = i6 + 36 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i4 | 0));
 HEAP32[i11 >> 2] = i19;
 i7 = i21 + 48 | 0;
 i22 = i21 + 44 | 0;
 HEAP32[i22 >> 2] = i7;
 HEAP32[i21 + 52 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i2 = i18 + 4 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 if ((i6 | 0) > 1) i3 = i6; else {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i6 = (__ZN2cv6String8allocateEj(i3, 11) | 0) + 0 | 0;
  i5 = 27736;
  i4 = i6 + 11 | 0;
  do {
   HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
   i6 = i6 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i6 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 27752, 27528, 438);
  __ZN2cv6String10deallocateEv(i3);
  i3 = HEAP32[i2 >> 2] | 0;
 }
 if ((i3 | 0) <= 2) {
  __ZN2cv3MataSERKS0_(i21, i18) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  if (!i2) {
   if ((HEAP32[i10 + 4 >> 2] | 0) != (HEAP32[i19 >> 2] | 0)) i9 = 46;
  } else if ((i2 | 0) == -2147483648) {
   if ((HEAP32[i10 + 4 >> 2] | 0) != 2147483647) i9 = 48;
  } else if ((i2 | 0) > -1) i9 = 46; else i9 = 48;
  if ((i9 | 0) == 46) {
   i3 = HEAP32[i10 + 4 >> 2] | 0;
   if ((i2 | 0) <= (i3 | 0) ? (i3 | 0) <= (HEAP32[i18 + 8 >> 2] | 0) : 0) i9 = 49; else i9 = 48;
  }
  if ((i9 | 0) == 48) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i1, 83) | 0) + 0 | 0;
   i5 = 27760;
   i4 = i6 + 83 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 27752, 27528, 453);
   __ZN2cv6String10deallocateEv(i1);
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = HEAP32[i10 + 4 >> 2] | 0;
   i9 = 49;
  }
  if ((i9 | 0) == 49) {
   HEAP32[i19 >> 2] = i3 - i2;
   i17 = Math_imul(i2, HEAP32[i7 >> 2] | 0) | 0;
   HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + i17;
   HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 32768;
  }
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 | 0) == -2147483648) {
   if ((HEAP32[i12 + 4 >> 2] | 0) != 2147483647) i9 = 56;
  } else if (!i2) {
   if ((HEAP32[i12 + 4 >> 2] | 0) != (HEAP32[i20 >> 2] | 0)) i9 = 54;
  } else if ((i2 | 0) > -1) i9 = 54; else i9 = 56;
  if ((i9 | 0) == 54) {
   i3 = HEAP32[i12 + 4 >> 2] | 0;
   if ((i2 | 0) <= (i3 | 0) ? (i3 | 0) <= (HEAP32[i18 + 12 >> 2] | 0) : 0) i9 = 57; else i9 = 56;
  }
  if ((i9 | 0) == 56) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i8, 83) | 0) + 0 | 0;
   i5 = 27848;
   i4 = i6 + 83 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i6 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 27752, 27528, 461);
   __ZN2cv6String10deallocateEv(i8);
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = HEAP32[i12 + 4 >> 2] | 0;
   i9 = 57;
  }
  if ((i9 | 0) == 57) {
   i1 = i3 - i2 | 0;
   HEAP32[i20 >> 2] = i1;
   i3 = HEAP32[i23 >> 2] | 0;
   if ((i3 | 0) > 0) i3 = HEAP32[(HEAP32[i22 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0; else i3 = 0;
   i22 = Math_imul(i3, i2) | 0;
   HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + i22;
   HEAP32[i21 >> 2] = ((i1 | 0) < (HEAP32[i18 + 12 >> 2] | 0) ? -49153 : -32769) & HEAP32[i21 >> 2] | 32768;
  }
  i1 = HEAP32[i19 >> 2] | 0;
  if ((i1 | 0) != 1) {
   if ((i1 | 0) >= 1) i9 = 63;
  } else {
   HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 16384;
   i9 = 63;
  }
  if ((i9 | 0) == 63 ? (HEAP32[i20 >> 2] | 0) >= 1 : 0) {
   STACKTOP = i27;
   return;
  }
  __ZN2cv3Mat7releaseEv(i21);
  HEAP32[i20 >> 2] = 0;
  HEAP32[i19 >> 2] = 0;
  STACKTOP = i27;
  return;
 }
 i8 = i26 + 8 | 0;
 i6 = i26 + 1096 | 0;
 i5 = i8;
 do {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i5 = i5 + 8 | 0;
 } while ((i5 | 0) != (i6 | 0));
 HEAP32[i26 >> 2] = i8;
 i7 = i26 + 4 | 0;
 HEAP32[i7 >> 2] = 136;
 if (i3 >>> 0 > 136) {
  i6 = __Znaj(i3 >>> 0 > 536870911 ? -1 : i3 << 3) | 0;
  i5 = i6 + (i3 << 3) | 0;
  i4 = i6;
  do {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i4 = i4 + 8 | 0;
  } while ((i4 | 0) != (i5 | 0));
  HEAP32[i26 >> 2] = i6;
 } else i6 = i8;
 HEAP32[i7 >> 2] = i3;
 i3 = i10;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i12;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i6 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = i12;
 i5 = 2;
 do {
  i12 = i6 + (i5 << 3) | 0;
  HEAP32[i12 >> 2] = -2147483648;
  HEAP32[i12 + 4 >> 2] = 2147483647;
  i5 = i5 + 1 | 0;
  i6 = HEAP32[i26 >> 2] | 0;
 } while ((i5 | 0) < (HEAP32[i2 >> 2] | 0));
 __ZN2cv3MatC2ERKS0_PKNS_5RangeE(i24, i18, i6);
 if ((i24 | 0) == (i21 | 0)) {
  i3 = i24 + 36 | 0;
  i1 = HEAP32[i17 >> 2] | 0;
 } else {
  i3 = i24 + 36 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4) {
   i18 = i4 + 12 | 0;
   HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
  }
  __ZN2cv3Mat7releaseEv(i21);
  HEAP32[i21 >> 2] = HEAP32[i24 >> 2];
  i4 = HEAP32[i24 + 4 >> 2] | 0;
  if (!((HEAP32[i23 >> 2] | 0) < 3 & (i4 | 0) < 3)) {
   __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i21, i4, 0, 0, 0);
   if ((HEAP32[i23 >> 2] | 0) > 0) {
    i6 = HEAP32[i24 + 40 >> 2] | 0;
    i5 = HEAP32[i11 >> 2] | 0;
    i4 = HEAP32[i24 + 44 >> 2] | 0;
    i2 = HEAP32[i22 >> 2] | 0;
    i1 = 0;
    do {
     HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i6 + (i1 << 2) >> 2];
     HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i23 >> 2] | 0));
   }
  } else {
   HEAP32[i23 >> 2] = i4;
   HEAP32[i19 >> 2] = HEAP32[i24 + 8 >> 2];
   HEAP32[i20 >> 2] = HEAP32[i24 + 12 >> 2];
   i21 = HEAP32[i24 + 44 >> 2] | 0;
   i22 = HEAP32[i22 >> 2] | 0;
   HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  }
  HEAP32[i25 >> 2] = HEAP32[i24 + 16 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i24 + 20 >> 2];
  HEAP32[i16 >> 2] = HEAP32[i24 + 24 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i24 + 28 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i24 + 32 >> 2];
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i17 >> 2] = i1;
 }
 if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2) {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i24 + 32 >> 2] | 0;
    if (!i1) {
     if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
      i22 = __Znwj(4) | 0;
      HEAP32[i22 >> 2] = 32784;
      HEAP32[6904] = i22;
      ___cxa_guard_release(27624);
     }
     i1 = HEAP32[6904] | 0;
     i2 = HEAP32[i3 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i2);
  }
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 i22 = i24 + 16 | 0;
 i2 = i24 + 4 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i24 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i24 + 44 >> 2] | 0;
 if ((i1 | 0) != (i24 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = HEAP32[i26 >> 2] | 0;
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i27;
  return;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i26 >> 2] = i8;
 HEAP32[i7 >> 2] = 136;
 STACKTOP = i27;
 return;
}

function __ZN4perf8TestBase15validateMetricsEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, d35 = 0.0, d36 = 0.0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i13 = i34 + 16 | 0;
 i6 = i34 + 128 | 0;
 i4 = i34 + 120 | 0;
 i7 = i34 + 116 | 0;
 i9 = i34 + 112 | 0;
 i11 = i34 + 104 | 0;
 i14 = i34 + 100 | 0;
 i15 = i34 + 96 | 0;
 i20 = i34 + 88 | 0;
 i18 = i34 + 8 | 0;
 i19 = i34;
 i26 = i34 + 84 | 0;
 i27 = i34 + 80 | 0;
 i29 = i34 + 72 | 0;
 i28 = i34 + 64 | 0;
 i21 = i34 + 60 | 0;
 i30 = i34 + 56 | 0;
 i31 = i34 + 52 | 0;
 i24 = __ZN4perf8TestBase11calcMetricsEv(i12) | 0;
 if (__ZN7testing4Test15HasFatalFailureEv() | 0) {
  STACKTOP = i34;
  return;
 }
 if (__ZN7testing4Test18HasNonfatalFailureEv() | 0) {
  STACKTOP = i34;
  return;
 }
 i25 = i24 + 8 | 0;
 HEAP32[i4 >> 2] = 1;
 __ZN7testing8internal11CmpHelperGEIjjEENS_15AssertionResultEPKcS4_RKT_RKT0_(i6, 174536, 174552, i25, i4);
 i5 = i6 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i2 = (i4 | 0) == 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  do if (!i2) if (!(HEAP8[i4 >> 0] & 1)) {
   i1 = i4 + 1 | 0;
   break;
  } else {
   i1 = HEAP32[i4 + 8 >> 2] | 0;
   break;
  } else i1 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i7, 2, 170184, 1401, i1);
  __ZN7testing7MessageC2Ev(i9);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i9 >> 2] | 0) + 8 | 0, 174560, 111) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i7, i9);
  if (HEAP32[i9 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i10 = HEAP32[i9 >> 2] | 0, (i10 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] & 511](i10);
   HEAP32[i9 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i7);
  if (!(HEAP32[i5 >> 2] | 0)) {
   STACKTOP = i34;
   return;
  }
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i8 = HEAP32[i5 >> 2] | 0, (i8 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
   __ZdlPv(i8);
  }
  HEAP32[i5 >> 2] = 0;
  STACKTOP = i34;
  return;
 }
 if (!i2) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i1 = HEAP32[i5 >> 2] | 0, (i1 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
   __ZdlPv(i1);
  }
  HEAP32[i5 >> 2] = 0;
 }
 i1 = HEAP32[43316] | 0;
 i4 = (i1 | 0) == -1;
 if (i4) {
  i2 = HEAP32[i12 + 32 >> 2] | 0;
  i2 = (i2 | 0) == -1 ? HEAP32[43474] | 0 : i2;
 } else i2 = i1;
 if (i2) {
  if (i4) {
   i1 = HEAP32[i12 + 32 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? HEAP32[43474] | 0 : i1;
  }
  if ((i1 | 0) != 1) {
   STACKTOP = i34;
   return;
  }
  d35 = +HEAPF64[i12 + 160 >> 3];
  d3 = +HEAPF64[i12 + 128 >> 3] * 1.0e3 / d35;
  d36 = +HEAPF64[i12 + 144 >> 3] * 1.0e3 / d35;
  d35 = +HEAPF64[i12 + 136 >> 3] * 1.0e3 / d35;
  HEAP32[i13 >> 2] = HEAP32[i12 + 104 >> 2];
  i23 = i13 + 4 | 0;
  HEAPF64[tempDoublePtr >> 3] = d3;
  HEAP32[i23 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i23 = i13 + 12 | 0;
  HEAPF64[tempDoublePtr >> 3] = d36;
  HEAP32[i23 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i23 = i13 + 20 | 0;
  HEAPF64[tempDoublePtr >> 3] = d35;
  HEAP32[i23 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i23 = i13 + 28 | 0;
  HEAPF64[tempDoublePtr >> 3] = d35 / d3 * 100.0;
  HEAP32[i23 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  _printf(175160, i13 | 0) | 0;
  STACKTOP = i34;
  return;
 }
 __ZN7testing8internal11CmpHelperGEIjjEENS_15AssertionResultEPKcS4_RKT_RKT0_(i11, 174536, 174672, i25, 173360);
 i1 = i11 + 4 | 0;
 if (!(HEAP8[i11 >> 0] | 0)) {
  i2 = HEAP32[i1 >> 2] | 0;
  do if (i2) if (!(HEAP8[i2 >> 0] & 1)) {
   i2 = i2 + 1 | 0;
   break;
  } else {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   break;
  } else i2 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i14, 1, 170184, 1406, i2);
  __ZN7testing7MessageC2Ev(i15);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i15 >> 2] | 0) + 8 | 0, 174696, 132) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i14, i15);
  if (HEAP32[i15 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i16 = HEAP32[i15 >> 2] | 0, (i16 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i16 >> 2] | 0) + 4 >> 2] & 511](i16);
   HEAP32[i15 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i14);
 }
 if (HEAP32[i1 >> 2] | 0) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i17 = HEAP32[i1 >> 2] | 0, (i17 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
   __ZdlPv(i17);
  }
  HEAP32[i1 >> 2] = 0;
 }
 d3 = +HEAPF64[i24 + 24 >> 3];
 if (d3 > 2.220446049250313e-16) {
  HEAPF64[i18 >> 3] = 1.0;
  HEAPF64[i19 >> 3] = +_sinh(d3 * +HEAPF64[21674]) * 2.0;
  __ZN7testing8internal11CmpHelperGTIddEENS_15AssertionResultEPKcS4_RKT_RKT0_(i20, 174832, 174840, i18, i19);
  i1 = i20 + 4 | 0;
  if (!(HEAP8[i20 >> 0] | 0)) {
   i2 = HEAP32[i1 >> 2] | 0;
   do if (i2) if (!(HEAP8[i2 >> 0] & 1)) {
    i2 = i2 + 1 | 0;
    break;
   } else {
    i2 = HEAP32[i2 + 8 >> 2] | 0;
    break;
   } else i2 = 169928; while (0);
   __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i26, 1, 170184, 1411, i2);
   __ZN7testing7MessageC2Ev(i27);
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i27 >> 2] | 0) + 8 | 0, 174888, 116) | 0;
   __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i26, i27);
   if (HEAP32[i27 >> 2] | 0) {
    if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i22 = HEAP32[i27 >> 2] | 0, (i22 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i22 >> 2] | 0) + 4 >> 2] & 511](i22);
    HEAP32[i27 >> 2] = 0;
   }
   __ZN7testing8internal12AssertHelperD2Ev(i26);
  }
  if (HEAP32[i1 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i23 = HEAP32[i1 >> 2] | 0, (i23 | 0) != 0) : 0) {
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
    __ZdlPv(i23);
   }
   HEAP32[i1 >> 2] = 0;
  }
 }
 d3 = +((HEAP32[i25 >> 2] | 0) >>> 0) * +HEAPF64[21666] / 100.0;
 i2 = ~~d3;
 i2 = (+(i2 | 0) < d3 & 1) + i2 | 0;
 HEAP32[i28 >> 2] = i2;
 HEAP32[i21 >> 2] = 1;
 __ZN7testing8internal11CmpHelperLEIjjEENS_15AssertionResultEPKcS4_RKT_RKT0_(i29, 175008, 175024, i24 + 12 | 0, (i2 | 0) == 0 ? i21 : i28);
 i2 = i29 + 4 | 0;
 if (!(HEAP8[i29 >> 0] | 0)) {
  i1 = HEAP32[i2 >> 2] | 0;
  do if (i1) if (!(HEAP8[i1 >> 0] & 1)) {
   i1 = i1 + 1 | 0;
   break;
  } else {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   break;
  } else i1 = 169928; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i30, 1, 170184, 1415, i1);
  __ZN7testing7MessageC2Ev(i31);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i31 >> 2] | 0) + 8 | 0, 175104, 52) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i30, i31);
  if (HEAP32[i31 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i32 = HEAP32[i31 >> 2] | 0, (i32 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i32 >> 2] | 0) + 4 >> 2] & 511](i32);
   HEAP32[i31 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i30);
 }
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i34;
  return;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i33 = HEAP32[i2 >> 2] | 0, (i33 | 0) != 0) : 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i33);
  __ZdlPv(i33);
 }
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i34;
 return;
}

function __ZN2cvL39getErrorMessageForWrongArgumentInGetterENS_6StringES0_ii(i24, i4, i3, i13, i19) {
 i24 = i24 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i5 = i25 + 104 | 0;
 i6 = i25 + 96 | 0;
 i7 = i25 + 88 | 0;
 i8 = i25 + 80 | 0;
 i9 = i25 + 72 | 0;
 i10 = i25 + 64 | 0;
 i11 = i25 + 56 | 0;
 i12 = i25 + 48 | 0;
 i14 = i25 + 40 | 0;
 i15 = i25 + 32 | 0;
 i20 = i25 + 24 | 0;
 i21 = i25 + 16 | 0;
 i22 = i25 + 8 | 0;
 i23 = i25;
 HEAP32[i11 >> 2] = 0;
 i2 = i11 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i16 = (__ZN2cv6String8allocateEj(i11, 26) | 0) + 0 | 0;
 i17 = 38832 | 0;
 i18 = i16 + 26 | 0;
 do {
  HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
  i16 = i16 + 1 | 0;
  i17 = i17 + 1 | 0;
 } while ((i16 | 0) < (i18 | 0));
 HEAP32[i10 >> 2] = 0;
 i1 = i10 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN2cv6String8allocateEj(i10, (HEAP32[i2 >> 2] | 0) + 38 | 0) | 0;
 _memcpy(HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 i16 = (HEAP32[i10 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) + 0 | 0;
 i17 = 38864 | 0;
 i18 = i16 + 38 | 0;
 do {
  HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
  i16 = i16 + 1 | 0;
  i17 = i17 + 1 | 0;
 } while ((i16 | 0) < (i18 | 0));
 HEAP32[i9 >> 2] = 0;
 i16 = i9 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 i2 = i3 + 4 | 0;
 __ZN2cv6String8allocateEj(i9, (HEAP32[i2 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0) | 0;
 _memcpy(HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
 _memcpy((HEAP32[i9 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0, HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 __ZN2cv6String8allocateEj(i8, (HEAP32[i16 >> 2] | 0) + 20 | 0) | 0;
 _memcpy(HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0, HEAP32[i16 >> 2] | 0) | 0;
 i16 = (HEAP32[i8 >> 2] | 0) + (HEAP32[i16 >> 2] | 0) + 0 | 0;
 i17 = 38904 | 0;
 i18 = i16 + 20 | 0;
 do {
  HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
  i16 = i16 + 1 | 0;
  i17 = i17 + 1 | 0;
 } while ((i16 | 0) < (i18 | 0));
 HEAP32[i7 >> 2] = 0;
 i16 = i7 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i4 + 4 | 0;
 __ZN2cv6String8allocateEj(i7, (HEAP32[i17 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0) | 0;
 _memcpy(HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 _memcpy((HEAP32[i7 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0, HEAP32[i4 >> 2] | 0, HEAP32[i17 >> 2] | 0) | 0;
 HEAP32[i6 >> 2] = 0;
 i2 = i6 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 __ZN2cv6String8allocateEj(i6, (HEAP32[i16 >> 2] | 0) + 21 | 0) | 0;
 _memcpy(HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i16 >> 2] | 0) | 0;
 i16 = (HEAP32[i6 >> 2] | 0) + (HEAP32[i16 >> 2] | 0) + 0 | 0;
 i17 = 38928 | 0;
 i18 = i16 + 21 | 0;
 do {
  HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
  i16 = i16 + 1 | 0;
  i17 = i17 + 1 | 0;
 } while ((i16 | 0) < (i18 | 0));
 __ZN2cvL13getNameOfTypeEi(i12, i13);
 HEAP32[i5 >> 2] = 0;
 i18 = i5 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 i3 = i12 + 4 | 0;
 __ZN2cv6String8allocateEj(i5, (HEAP32[i3 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0) | 0;
 _memcpy(HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 _memcpy((HEAP32[i5 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0, HEAP32[i12 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i24 >> 2] = 0;
 i3 = i24 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 __ZN2cv6String8allocateEj(i24, (HEAP32[i18 >> 2] | 0) + 7 | 0) | 0;
 _memcpy(HEAP32[i24 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i18 >> 2] | 0) | 0;
 i18 = (HEAP32[i24 >> 2] | 0) + (HEAP32[i18 >> 2] | 0) | 0;
 HEAP8[i18 + 0 >> 0] = HEAP8[38952] | 0;
 HEAP8[i18 + 1 >> 0] = HEAP8[38953] | 0;
 HEAP8[i18 + 2 >> 0] = HEAP8[38954] | 0;
 HEAP8[i18 + 3 >> 0] = HEAP8[38955] | 0;
 HEAP8[i18 + 4 >> 0] = HEAP8[38956] | 0;
 HEAP8[i18 + 5 >> 0] = HEAP8[38957] | 0;
 HEAP8[i18 + 6 >> 0] = HEAP8[38958] | 0;
 __ZN2cv6String10deallocateEv(i5);
 __ZN2cv6String10deallocateEv(i12);
 __ZN2cv6String10deallocateEv(i6);
 __ZN2cv6String10deallocateEv(i7);
 __ZN2cv6String10deallocateEv(i8);
 __ZN2cv6String10deallocateEv(i9);
 __ZN2cv6String10deallocateEv(i10);
 __ZN2cv6String10deallocateEv(i11);
 switch (i13 | 0) {
 case 1:
  {
   HEAP32[i14 >> 2] = 0;
   i1 = i14 + 4 | 0;
   HEAP32[i1 >> 2] = 0;
   __ZN2cv6String8allocateEj(i14, (HEAP32[i3 >> 2] | 0) + 105 | 0) | 0;
   _memcpy(HEAP32[i14 >> 2] | 0, HEAP32[i24 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   i16 = (HEAP32[i14 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) + 0 | 0;
   i17 = 38960 | 0;
   i18 = i16 + 105 | 0;
   do {
    HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
    i16 = i16 + 1 | 0;
    i17 = i17 + 1 | 0;
   } while ((i16 | 0) < (i18 | 0));
   if ((i14 | 0) != (i24 | 0)) {
    __ZN2cv6String10deallocateEv(i24);
    i2 = HEAP32[i14 >> 2] | 0;
    if (!i2) i2 = 0; else {
     i2 = i2 + -4 | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i14 >> 2] | 0;
    }
    HEAP32[i24 >> 2] = i2;
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   }
   __ZN2cv6String10deallocateEv(i14);
   break;
  }
 case 0:
 case 8:
 case 9:
 case 11:
  {
   HEAP32[i15 >> 2] = 0;
   i1 = i15 + 4 | 0;
   HEAP32[i1 >> 2] = 0;
   __ZN2cv6String8allocateEj(i15, (HEAP32[i3 >> 2] | 0) + 96 | 0) | 0;
   _memcpy(HEAP32[i15 >> 2] | 0, HEAP32[i24 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   i16 = (HEAP32[i15 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) + 0 | 0;
   i17 = 39072 | 0;
   i18 = i16 + 96 | 0;
   do {
    HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
    i16 = i16 + 1 | 0;
    i17 = i17 + 1 | 0;
   } while ((i16 | 0) < (i18 | 0));
   if ((i15 | 0) != (i24 | 0)) {
    __ZN2cv6String10deallocateEv(i24);
    i2 = HEAP32[i15 >> 2] | 0;
    if (!i2) i2 = 0; else {
     i2 = i2 + -4 | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i15 >> 2] | 0;
    }
    HEAP32[i24 >> 2] = i2;
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   }
   __ZN2cv6String10deallocateEv(i15);
   break;
  }
 default:
  {}
 }
 HEAP32[i22 >> 2] = 0;
 i2 = i22 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 __ZN2cv6String8allocateEj(i22, (HEAP32[i3 >> 2] | 0) + 35 | 0) | 0;
 _memcpy(HEAP32[i22 >> 2] | 0, HEAP32[i24 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 i16 = (HEAP32[i22 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) + 0 | 0;
 i17 = 39176 | 0;
 i18 = i16 + 35 | 0;
 do {
  HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
  i16 = i16 + 1 | 0;
  i17 = i17 + 1 | 0;
 } while ((i16 | 0) < (i18 | 0));
 __ZN2cvL13getNameOfTypeEi(i23, i19);
 HEAP32[i21 >> 2] = 0;
 i19 = i21 + 4 | 0;
 HEAP32[i19 >> 2] = 0;
 i18 = i23 + 4 | 0;
 __ZN2cv6String8allocateEj(i21, (HEAP32[i18 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0) | 0;
 _memcpy(HEAP32[i21 >> 2] | 0, HEAP32[i22 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 _memcpy((HEAP32[i21 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0, HEAP32[i23 >> 2] | 0, HEAP32[i18 >> 2] | 0) | 0;
 HEAP32[i20 >> 2] = 0;
 i2 = i20 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 __ZN2cv6String8allocateEj(i20, (HEAP32[i19 >> 2] | 0) + 6 | 0) | 0;
 _memcpy(HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] | 0, HEAP32[i19 >> 2] | 0) | 0;
 i19 = (HEAP32[i20 >> 2] | 0) + (HEAP32[i19 >> 2] | 0) | 0;
 HEAP8[i19 + 0 >> 0] = HEAP8[39216] | 0;
 HEAP8[i19 + 1 >> 0] = HEAP8[39217] | 0;
 HEAP8[i19 + 2 >> 0] = HEAP8[39218] | 0;
 HEAP8[i19 + 3 >> 0] = HEAP8[39219] | 0;
 HEAP8[i19 + 4 >> 0] = HEAP8[39220] | 0;
 HEAP8[i19 + 5 >> 0] = HEAP8[39221] | 0;
 if ((i20 | 0) == (i24 | 0)) {
  __ZN2cv6String10deallocateEv(i20);
  __ZN2cv6String10deallocateEv(i21);
  __ZN2cv6String10deallocateEv(i23);
  __ZN2cv6String10deallocateEv(i22);
  STACKTOP = i25;
  return;
 }
 __ZN2cv6String10deallocateEv(i24);
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i20 >> 2] | 0;
 }
 HEAP32[i24 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 __ZN2cv6String10deallocateEv(i20);
 __ZN2cv6String10deallocateEv(i21);
 __ZN2cv6String10deallocateEv(i23);
 __ZN2cv6String10deallocateEv(i22);
 STACKTOP = i25;
 return;
}

function __ZN2cvL14initInterTab2DEib(i3, i38) {
 i3 = i3 | 0;
 i38 = i38 | 0;
 var i1 = 0, i2 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, d9 = 0.0, d10 = 0.0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, f40 = f0, d41 = 0.0, i42 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 i4 = i39 + 1072 | 0;
 i2 = i39 + 1064 | 0;
 i37 = i39;
 if ((i3 | 0) == 1) {
  i2 = 201688;
  i32 = 2;
  i1 = 185304;
 } else if ((i3 | 0) == 2) {
  i2 = 275416;
  i32 = 4;
  i1 = 209880;
 } else if ((i3 | 0) == 4) {
  i2 = 570328;
  i32 = 8;
  i1 = 308184;
 } else {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i6 = (__ZN2cv6String8allocateEj(i2, 38) | 0) + 0 | 0;
  i7 = 701400;
  i8 = i6 + 38 | 0;
  do {
   HEAP8[i6 >> 0] = HEAP8[i7 >> 0] | 0;
   i6 = i6 + 1 | 0;
   i7 = i7 + 1 | 0;
  } while ((i6 | 0) < (i8 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i2, 701440, 183152, 227);
  __ZN2cv6String10deallocateEv(i2);
  i2 = 0;
  i32 = 0;
  i1 = 0;
 }
 i34 = 185296 + i3 | 0;
 if (!(HEAP8[i34 >> 0] | 0)) {
  i35 = i37 + 8 | 0;
  HEAP32[i37 >> 2] = i35;
  i36 = i37 + 4 | 0;
  HEAP32[i36 >> 2] = 256;
  if ((i3 | 0) == 2) {
   i3 = i35;
   i4 = 0;
   while (1) {
    f5 = Math_fround(Math_fround(i4 | 0) * Math_fround(.03125));
    f40 = Math_fround(f5 + Math_fround(1.0));
    f40 = Math_fround(Math_fround(f40 * Math_fround(Math_fround(f40 * Math_fround(Math_fround(f40 * Math_fround(-.75)) + Math_fround(3.75))) + Math_fround(-6.0))) + Math_fround(3.0));
    HEAPF32[i3 >> 2] = f40;
    f11 = Math_fround(Math_fround(f5 * Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(1.25)) + Math_fround(-2.25)))) + Math_fround(1.0));
    HEAPF32[i3 + 4 >> 2] = f11;
    f5 = Math_fround(Math_fround(1.0) - f5);
    f5 = Math_fround(Math_fround(f5 * Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(1.25)) + Math_fround(-2.25)))) + Math_fround(1.0));
    HEAPF32[i3 + 8 >> 2] = f5;
    HEAPF32[i3 + 12 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f40) - f11) - f5);
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == 32) break; else i3 = i3 + 16 | 0;
   }
  } else if ((i3 | 0) == 1) {
   i3 = i35;
   i4 = 0;
   while (1) {
    f5 = Math_fround(Math_fround(i4 | 0) * Math_fround(.03125));
    HEAPF32[i3 >> 2] = Math_fround(Math_fround(1.0) - f5);
    HEAPF32[i3 + 4 >> 2] = f5;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == 32) break; else i3 = i3 + 8 | 0;
   }
  } else if ((i3 | 0) == 4) {
   i7 = i35;
   i6 = 0;
   while (1) {
    f5 = Math_fround(Math_fround(i6 | 0) * Math_fround(.03125));
    if (f5 < Math_fround(1.1920929e-07)) {
     HEAP32[i7 + 0 >> 2] = 0;
     HEAP32[i7 + 4 >> 2] = 0;
     HEAP32[i7 + 8 >> 2] = 0;
     HEAP32[i7 + 12 >> 2] = 0;
     HEAP32[i7 + 16 >> 2] = 0;
     HEAP32[i7 + 20 >> 2] = 0;
     HEAP32[i7 + 24 >> 2] = 0;
     HEAP32[i7 + 28 >> 2] = 0;
     HEAPF32[i7 + 12 >> 2] = Math_fround(1.0);
    } else {
     f5 = Math_fround(f5 + Math_fround(3.0));
     d10 = +Math_fround(-f5) * 3.141592653589793 * .25;
     d9 = +Math_sin(+d10);
     d10 = +Math_cos(+d10);
     i8 = 0;
     f11 = Math_fround(0.0);
     do {
      d41 = +Math_fround(-Math_fround(f5 - Math_fround(i8 | 0))) * 3.141592653589793 * .25;
      f40 = Math_fround((d9 * +HEAPF64[701472 + (i8 << 4) >> 3] + d10 * +HEAPF64[701480 + (i8 << 4) >> 3]) / (d41 * d41));
      HEAPF32[i7 + (i8 << 2) >> 2] = f40;
      f11 = Math_fround(f11 + f40);
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) != 8);
     f5 = Math_fround(Math_fround(1.0) / f11);
     HEAPF32[i7 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i7 >> 2]));
     i23 = i7 + 4 | 0;
     HEAPF32[i23 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i23 >> 2]));
     i23 = i7 + 8 | 0;
     HEAPF32[i23 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i23 >> 2]));
     i23 = i7 + 12 | 0;
     HEAPF32[i23 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i23 >> 2]));
     i23 = i7 + 16 | 0;
     HEAPF32[i23 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i23 >> 2]));
     i23 = i7 + 20 | 0;
     HEAPF32[i23 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i23 >> 2]));
     i23 = i7 + 24 | 0;
     HEAPF32[i23 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i23 >> 2]));
     i23 = i7 + 28 | 0;
     HEAPF32[i23 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i23 >> 2]));
    }
    i6 = i6 + 1 | 0;
    if ((i6 | 0) == 32) break; else i7 = i7 + 32 | 0;
   }
  } else {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i4, 28) | 0) + 0 | 0;
   i7 = 183216;
   i8 = i6 + 28 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i7 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i7 = i7 + 1 | 0;
   } while ((i6 | 0) < (i8 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i4, 701456, 183152, 210);
   __ZN2cv6String10deallocateEv(i4);
  }
  i23 = (i32 | 0) == 0;
  i31 = HEAP32[i37 >> 2] | 0;
  i16 = Math_imul(i32, i32) | 0;
  i17 = i32 >>> 1;
  i18 = i17 + 2 | 0;
  i19 = i16 << 5;
  i30 = i16 * 1023 | 0;
  i24 = 0;
  i25 = i2;
  i28 = i1;
  while (1) {
   i20 = i24 << 5;
   i21 = (i24 | 0) < 16 & 1;
   i22 = Math_imul(i24, i32) | 0;
   i26 = i25;
   i25 = i25 + (i19 << 1) | 0;
   i27 = 0;
   i29 = i28;
   while (1) {
    i15 = i27 + i20 | 0;
    HEAP8[183248 + (i15 << 1) >> 0] = (i27 | 0) < 16 & 1;
    HEAP8[183249 + (i15 << 1) >> 0] = i21;
    if (!i23) {
     i3 = Math_imul(i27, i32) | 0;
     i8 = 0;
     i13 = 0;
     do {
      f11 = Math_fround(HEAPF32[i31 + (i13 + i22 << 2) >> 2]);
      i12 = Math_imul(i13, i32) | 0;
      i4 = 0;
      do {
       f5 = Math_fround(f11 * Math_fround(HEAPF32[i31 + (i4 + i3 << 2) >> 2]));
       i6 = i4 + i12 | 0;
       HEAPF32[i29 + (i6 << 2) >> 2] = f5;
       i7 = _lrint(+Math_fround(f5 * Math_fround(32768.0))) | 0;
       if ((i7 + 32768 | 0) >>> 0 >= 65536) i7 = (i7 | 0) > 0 ? 32767 : -32768;
       HEAP16[i26 + (i6 << 1) >> 1] = i7;
       i8 = (i7 << 16 >> 16) + i8 | 0;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) < (i32 | 0));
      i13 = i13 + 1 | 0;
     } while ((i13 | 0) < (i32 | 0));
     if ((i8 | 0) != 32768) i33 = 26;
    } else {
     i8 = 0;
     i33 = 26;
    }
    do if ((i33 | 0) == 26) {
     i33 = 0;
     i7 = i17;
     i6 = i17;
     i15 = i17;
     i4 = i17;
     i3 = i17;
     do {
      i14 = Math_imul(i15, i32) | 0;
      i13 = i7;
      i12 = i17;
      while (1) {
       i7 = HEAP16[i26 + (i12 + i14 << 1) >> 1] | 0;
       if (i7 << 16 >> 16 < (HEAP16[i26 + ((Math_imul(i4, i32) | 0) + i3 << 1) >> 1] | 0)) {
        i7 = i13;
        i4 = i15;
        i3 = i12;
       } else {
        i42 = i7 << 16 >> 16 > (HEAP16[i26 + ((Math_imul(i13, i32) | 0) + i6 << 1) >> 1] | 0);
        i7 = i42 ? i15 : i13;
        i6 = i42 ? i12 : i6;
       }
       i12 = i12 + 1 | 0;
       if ((i12 | 0) >= (i18 | 0)) break; else i13 = i7;
      }
      i15 = i15 + 1 | 0;
     } while ((i15 | 0) < (i18 | 0));
     i8 = i8 + -32768 | 0;
     if ((i8 | 0) < 0) {
      i15 = i26 + ((Math_imul(i7, i32) | 0) + i6 << 1) | 0;
      HEAP16[i15 >> 1] = (HEAPU16[i15 >> 1] | 0) - i8;
      break;
     } else {
      i15 = i26 + ((Math_imul(i4, i32) | 0) + i3 << 1) | 0;
      HEAP16[i15 >> 1] = (HEAPU16[i15 >> 1] | 0) - i8;
      break;
     }
    } while (0);
    i27 = i27 + 1 | 0;
    if ((i27 | 0) == 32) break; else {
     i26 = i26 + (i16 << 1) | 0;
     i29 = i29 + (i16 << 2) | 0;
    }
   }
   i24 = i24 + 1 | 0;
   if ((i24 | 0) == 32) break; else i28 = i28 + (i19 << 2) | 0;
  }
  i23 = i16 | (Math_imul(Math_imul(i32, -1024) | 0, i32) | 0);
  i1 = i1 + (i30 + i23 << 2) | 0;
  i2 = i2 + (i30 + i23 << 1) | 0;
  HEAP8[i34 >> 0] = 1;
  if ((i31 | 0) != (i35 | 0)) {
   if (i31) __ZdaPv(i31);
   HEAP32[i37 >> 2] = i35;
   HEAP32[i36 >> 2] = 264;
  }
 }
 if (i38) {
  i23 = i2;
  STACKTOP = i39;
  return i23 | 0;
 } else {
  i23 = i1;
  STACKTOP = i39;
  return i23 | 0;
 }
 return 0;
}

function __ZN2cvL17GEMMBlockMul_64fcEPKNS_7ComplexIdEEjS3_jPS1_jNS_5Size_IiEES6_i(i20, i3, i34, i4, i19, i5, i1, i2, i12) {
 i20 = i20 | 0;
 i3 = i3 | 0;
 i34 = i34 | 0;
 i4 = i4 | 0;
 i19 = i19 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i6 = 0, i7 = 0, d8 = 0.0, d9 = 0.0, i10 = 0, i11 = 0, d13 = 0.0, d14 = 0.0, d15 = 0.0, d16 = 0.0, d17 = 0.0, d18 = 0.0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, d37 = 0.0, d38 = 0.0, d39 = 0.0, d40 = 0.0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 1168 | 0;
 i35 = i36;
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i1 + 4 >> 2] | 0;
 i32 = HEAP32[i2 >> 2] | 0;
 i31 = HEAP32[i2 + 4 >> 2] | 0;
 i33 = i35 + 8 | 0;
 i2 = i35 + 1160 | 0;
 i1 = i33;
 do {
  HEAP32[i1 + 0 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i35 >> 2] = i33;
 i30 = i35 + 4 | 0;
 HEAP32[i30 >> 2] = 72;
 i11 = i12 & 16;
 i6 = i3 >>> 4;
 i29 = i4 >>> 4;
 i28 = i5 >>> 4;
 do if (!(i12 & 1)) {
  i2 = 0;
  i27 = i6;
  i6 = 1;
 } else {
  if (i10 >>> 0 <= 72) {
   HEAP32[i30 >> 2] = i10;
   i2 = i33;
   i27 = 1;
   i7 = i10;
   break;
  }
  i2 = __Znaj(i10 >>> 0 > 268435455 ? -1 : i10 << 4) | 0;
  i1 = i2 + (i10 << 4) | 0;
  i3 = i2;
  do {
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   i3 = i3 + 16 | 0;
  } while ((i3 | 0) != (i1 | 0));
  HEAP32[i35 >> 2] = i2;
  HEAP32[i30 >> 2] = i10;
  i27 = 1;
  i7 = i10;
 } while (0);
 i3 = (i31 | 0) > 0;
 if (!(i12 & 2)) {
  if (i3) {
   i26 = (i2 | 0) == 0;
   i3 = i32 + -4 | 0;
   i4 = (i3 | 0) < 0;
   i24 = (i11 | 0) == 0;
   i1 = (i7 | 0) > 0;
   i12 = i32 & -4;
   i25 = i26 | i1 ^ 1;
   i21 = 0;
   while (1) {
    if (i25) i22 = i26 ? i20 : i2; else {
     i5 = 0;
     do {
      i23 = i2 + (i5 << 4) | 0;
      i22 = i20 + ((Math_imul(i5, i6) | 0) << 4) | 0;
      HEAP32[i23 + 0 >> 2] = HEAP32[i22 + 0 >> 2];
      HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
      HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
      HEAP32[i23 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i7 | 0));
     i22 = i2;
    }
    if (i4) i5 = 0; else {
     i23 = 0;
     do {
      if (i24) {
       d8 = 0.0;
       d18 = 0.0;
       d17 = 0.0;
       d15 = 0.0;
       d14 = 0.0;
       d9 = 0.0;
       d13 = 0.0;
       d16 = 0.0;
      } else {
       i5 = i23 | 1;
       i11 = i23 | 2;
       i10 = i23 | 3;
       d8 = +HEAPF64[i19 + (i23 << 4) >> 3];
       d18 = +HEAPF64[i19 + (i5 << 4) + 8 >> 3];
       d17 = +HEAPF64[i19 + (i11 << 4) >> 3];
       d15 = +HEAPF64[i19 + (i11 << 4) + 8 >> 3];
       d14 = +HEAPF64[i19 + (i10 << 4) >> 3];
       d9 = +HEAPF64[i19 + (i10 << 4) + 8 >> 3];
       d13 = +HEAPF64[i19 + (i23 << 4) + 8 >> 3];
       d16 = +HEAPF64[i19 + (i5 << 4) >> 3];
      }
      if (i1) {
       i11 = i34 + (i23 << 4) | 0;
       i10 = 0;
       while (1) {
        d38 = +HEAPF64[i22 + (i10 << 4) >> 3];
        d40 = +HEAPF64[i22 + (i10 << 4) + 8 >> 3];
        d37 = +HEAPF64[i11 >> 3];
        d39 = +HEAPF64[i11 + 8 >> 3];
        d8 = d8 + (d38 * d37 - d40 * d39);
        d13 = d13 + (d40 * d37 + d38 * d39);
        d39 = +HEAPF64[i11 + 16 >> 3];
        d37 = +HEAPF64[i11 + 24 >> 3];
        d16 = d16 + (d38 * d39 - d40 * d37);
        d18 = d18 + (d40 * d39 + d38 * d37);
        d37 = +HEAPF64[i11 + 32 >> 3];
        d39 = +HEAPF64[i11 + 40 >> 3];
        d17 = d17 + (d38 * d37 - d40 * d39);
        d15 = d15 + (d40 * d37 + d38 * d39);
        d39 = +HEAPF64[i11 + 48 >> 3];
        d37 = +HEAPF64[i11 + 56 >> 3];
        d14 = d14 + (d38 * d39 - d40 * d37);
        d9 = d9 + (d40 * d39 + d38 * d37);
        i10 = i10 + 1 | 0;
        if ((i10 | 0) == (i7 | 0)) break; else i11 = i11 + (i29 << 4) | 0;
       }
      }
      HEAPF64[i19 + (i23 << 4) >> 3] = d8;
      HEAPF64[i19 + (i23 << 4) + 8 >> 3] = d13;
      i5 = i23 | 1;
      HEAPF64[i19 + (i5 << 4) >> 3] = d16;
      HEAPF64[i19 + (i5 << 4) + 8 >> 3] = d18;
      i5 = i23 | 2;
      HEAPF64[i19 + (i5 << 4) >> 3] = d17;
      HEAPF64[i19 + (i5 << 4) + 8 >> 3] = d15;
      i5 = i23 | 3;
      HEAPF64[i19 + (i5 << 4) >> 3] = d14;
      HEAPF64[i19 + (i5 << 4) + 8 >> 3] = d9;
      i23 = i23 + 4 | 0;
     } while ((i23 | 0) <= (i3 | 0));
     i5 = i12;
    }
    if ((i5 | 0) < (i32 | 0)) do {
     if (i24) {
      d9 = 0.0;
      d8 = 0.0;
     } else {
      d9 = +HEAPF64[i19 + (i5 << 4) + 8 >> 3];
      d8 = +HEAPF64[i19 + (i5 << 4) >> 3];
     }
     if (i1) {
      i11 = i34 + (i5 << 4) | 0;
      i10 = 0;
      while (1) {
       d17 = +HEAPF64[i22 + (i10 << 4) >> 3];
       d38 = +HEAPF64[i22 + (i10 << 4) + 8 >> 3];
       d40 = +HEAPF64[i11 >> 3];
       d18 = +HEAPF64[i11 + 8 >> 3];
       d8 = d8 + (d17 * d40 - d38 * d18);
       d9 = d9 + (d38 * d40 + d17 * d18);
       i10 = i10 + 1 | 0;
       if ((i10 | 0) == (i7 | 0)) break; else i11 = i11 + (i29 << 4) | 0;
      }
     }
     HEAPF64[i19 + (i5 << 4) >> 3] = d8;
     HEAPF64[i19 + (i5 << 4) + 8 >> 3] = d9;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i32 | 0));
    i21 = i21 + 1 | 0;
    if ((i21 | 0) == (i31 | 0)) break; else {
     i19 = i19 + (i28 << 4) | 0;
     i20 = i20 + (i27 << 4) | 0;
    }
   }
  }
 } else if (i3) {
  i26 = (i2 | 0) == 0;
  i10 = (i11 | 0) == 0;
  i21 = i7 + -2 | 0;
  i22 = (i21 | 0) < 0;
  i23 = i7 & -2;
  i25 = i26 | (i7 | 0) < 1;
  i24 = (i32 | 0) > 0;
  i4 = 0;
  while (1) {
   if (i25) i1 = i26 ? i20 : i2; else {
    i5 = 0;
    do {
     i1 = i2 + (i5 << 4) | 0;
     i12 = i20 + ((Math_imul(i5, i6) | 0) << 4) | 0;
     HEAP32[i1 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i7 | 0));
    i1 = i2;
   }
   if (i24) {
    i12 = i34;
    i3 = 0;
    while (1) {
     if (i10) {
      d9 = 0.0;
      d8 = 0.0;
     } else {
      d9 = +HEAPF64[i19 + (i3 << 4) + 8 >> 3];
      d8 = +HEAPF64[i19 + (i3 << 4) >> 3];
     }
     if (i22) {
      d14 = 0.0;
      d13 = 0.0;
      i11 = 0;
     } else {
      d13 = 0.0;
      d14 = 0.0;
      i11 = 0;
      do {
       d38 = +HEAPF64[i1 + (i11 << 4) >> 3];
       d18 = +HEAPF64[i1 + (i11 << 4) + 8 >> 3];
       d40 = +HEAPF64[i12 + (i11 << 4) >> 3];
       d17 = +HEAPF64[i12 + (i11 << 4) + 8 >> 3];
       d8 = d8 + (d38 * d40 - d18 * d17);
       d9 = d9 + (d18 * d40 + d38 * d17);
       i5 = i11 | 1;
       d17 = +HEAPF64[i1 + (i5 << 4) >> 3];
       d38 = +HEAPF64[i1 + (i5 << 4) + 8 >> 3];
       d40 = +HEAPF64[i12 + (i5 << 4) >> 3];
       d18 = +HEAPF64[i12 + (i5 << 4) + 8 >> 3];
       d13 = d13 + (d17 * d40 - d38 * d18);
       d14 = d14 + (d38 * d40 + d17 * d18);
       i11 = i11 + 2 | 0;
      } while ((i11 | 0) <= (i21 | 0));
      i11 = i23;
     }
     if ((i11 | 0) < (i7 | 0)) do {
      d17 = +HEAPF64[i1 + (i11 << 4) >> 3];
      d38 = +HEAPF64[i1 + (i11 << 4) + 8 >> 3];
      d40 = +HEAPF64[i12 + (i11 << 4) >> 3];
      d18 = +HEAPF64[i12 + (i11 << 4) + 8 >> 3];
      d8 = d8 + (d17 * d40 - d38 * d18);
      d9 = d9 + (d38 * d40 + d17 * d18);
      i11 = i11 + 1 | 0;
     } while ((i11 | 0) != (i7 | 0));
     HEAPF64[i19 + (i3 << 4) >> 3] = d13 + d8;
     HEAPF64[i19 + (i3 << 4) + 8 >> 3] = d14 + d9;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i32 | 0)) break; else i12 = i12 + (i29 << 4) | 0;
    }
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i31 | 0)) break; else {
    i19 = i19 + (i28 << 4) | 0;
    i20 = i20 + (i27 << 4) | 0;
   }
  }
 }
 i1 = HEAP32[i35 >> 2] | 0;
 if ((i1 | 0) == (i33 | 0)) {
  STACKTOP = i36;
  return;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i35 >> 2] = i33;
 HEAP32[i30 >> 2] = 72;
 STACKTOP = i36;
 return;
}
function _cvWriteRawData(i23, i20, i1, i6) {
 i23 = i23 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, d11 = 0.0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 1328 | 0;
 i24 = i25;
 i22 = i25 + 40 | 0;
 i21 = i25 + 1064 | 0;
 i3 = i25 + 32 | 0;
 i4 = i25 + 24 | 0;
 i5 = i25 + 16 | 0;
 i10 = i25 + 8 | 0;
 _memset(i21 | 0, 0, 256) | 0;
 i2 = (i23 | 0) != 0;
 if (!(i2 ? (HEAP32[i23 >> 2] | 0) == 1280131417 : 0)) {
  i2 = i2 ? -5 : -27;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i3, 31) | 0) + 0 | 0;
  i8 = 9096 | 0;
  i9 = i7 + 31 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i2, i3, 10056, 8960, 3084);
  __ZN2cv6String10deallocateEv(i3);
 }
 if (!(HEAP32[i23 + 8 >> 2] | 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i4, 38) | 0) + 0 | 0;
  i8 = 9944 | 0;
  i9 = i7 + 38 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i4, 10056, 8960, 3084);
  __ZN2cv6String10deallocateEv(i4);
 }
 if ((i1 | 0) < 0) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i5, 27) | 0) + 0 | 0;
  i8 = 10072 | 0;
  i9 = i7 + 27 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i5, 10056, 8960, 3087);
  __ZN2cv6String10deallocateEv(i5);
 }
 i19 = __ZL15icvDecodeFormatPKcPii(i6, i22) | 0;
 if (!i1) {
  STACKTOP = i25;
  return;
 }
 if (!i20) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i10, 17) | 0) + 0 | 0;
  i8 = 10104 | 0;
  i9 = i7 + 17 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i10, 10056, 8960, 3095);
  __ZN2cv6String10deallocateEv(i10);
 }
 if ((i19 | 0) != 1) {
  if (!i1) {
   STACKTOP = i25;
   return;
  }
 } else {
  HEAP32[i22 >> 2] = Math_imul(HEAP32[i22 >> 2] | 0, i1) | 0;
  i1 = 1;
 }
 i14 = (i19 | 0) > 0;
 i15 = i20;
 i16 = i21 + 23 | 0;
 i17 = i23 + 4 | 0;
 i18 = i21 + 1 | 0;
 i2 = 0;
 L23 : while (1) {
  i1 = i1 + -1 | 0;
  if (i14) {
   i13 = 0;
   do {
    i3 = i13 << 1;
    i4 = HEAP32[i22 + (i3 << 2) >> 2] | 0;
    i3 = HEAP32[i22 + ((i3 | 1) << 2) >> 2] | 0;
    i5 = (i3 >>> 3 & 511) + 1 << (47696 >>> (i3 << 1 & 14) & 3);
    i2 = i20 + (i2 + -1 + i5 & 0 - i5) | 0;
    L28 : do if ((i4 | 0) > 0) {
     i6 = i2;
     i5 = 0;
     while (1) {
      switch (i3 | 0) {
      case 6:
       {
        i2 = i6 + 8 | 0;
        i10 = __ZL17icvDoubleToStringPcd(i21, +HEAPF64[i6 >> 3]) | 0;
        break;
       }
      case 7:
       {
        i9 = HEAP32[i6 >> 2] | 0;
        HEAP8[i16 >> 0] = 0;
        i8 = i16;
        i7 = (i9 | 0) > -1 ? i9 : 0 - i9 | 0;
        while (1) {
         i2 = i7;
         i7 = (i7 >>> 0) / 10 | 0;
         i10 = i8 + -1 | 0;
         HEAP8[i10 >> 0] = i2 + 48 + (Math_imul(i7, -10) | 0);
         if (i2 >>> 0 <= 9) break; else i8 = i10;
        }
        if ((i9 | 0) < 0) {
         i10 = i8 + -2 | 0;
         HEAP8[i10 >> 0] = 45;
        }
        i2 = i6 + 4 | 0;
        break;
       }
      case 0:
       {
        i9 = HEAPU8[i6 >> 0] | 0;
        HEAP8[i16 >> 0] = 0;
        i10 = i16;
        do {
         i2 = i9;
         i9 = (i9 >>> 0) / 10 | 0;
         i10 = i10 + -1 | 0;
         HEAP8[i10 >> 0] = i2 + 48 + (Math_imul(i9, -10) | 0);
        } while (i2 >>> 0 > 9);
        i2 = i6 + 1 | 0;
        break;
       }
      case 2:
       {
        i9 = HEAPU16[i6 >> 1] | 0;
        HEAP8[i16 >> 0] = 0;
        i10 = i16;
        do {
         i2 = i9;
         i9 = (i9 >>> 0) / 10 | 0;
         i10 = i10 + -1 | 0;
         HEAP8[i10 >> 0] = i2 + 48 + (Math_imul(i9, -10) | 0);
        } while (i2 >>> 0 > 9);
        i2 = i6 + 2 | 0;
        break;
       }
      case 1:
       {
        i9 = HEAP8[i6 >> 0] | 0;
        i7 = i9 << 24 >> 24;
        HEAP8[i16 >> 0] = 0;
        i8 = i16;
        i7 = i9 << 24 >> 24 > -1 ? i7 : 0 - i7 | 0;
        while (1) {
         i2 = i7;
         i7 = (i7 >>> 0) / 10 | 0;
         i10 = i8 + -1 | 0;
         HEAP8[i10 >> 0] = i2 + 48 + (Math_imul(i7, -10) | 0);
         if (i2 >>> 0 <= 9) break; else i8 = i10;
        }
        if (i9 << 24 >> 24 < 0) {
         i10 = i8 + -2 | 0;
         HEAP8[i10 >> 0] = 45;
        }
        i2 = i6 + 1 | 0;
        break;
       }
      case 3:
       {
        i9 = HEAP16[i6 >> 1] | 0;
        i7 = i9 << 16 >> 16;
        HEAP8[i16 >> 0] = 0;
        i8 = i16;
        i7 = i9 << 16 >> 16 > -1 ? i7 : 0 - i7 | 0;
        while (1) {
         i2 = i7;
         i7 = (i7 >>> 0) / 10 | 0;
         i10 = i8 + -1 | 0;
         HEAP8[i10 >> 0] = i2 + 48 + (Math_imul(i7, -10) | 0);
         if (i2 >>> 0 <= 9) break; else i8 = i10;
        }
        if (i9 << 16 >> 16 < 0) {
         i10 = i8 + -2 | 0;
         HEAP8[i10 >> 0] = 45;
        }
        i2 = i6 + 2 | 0;
        break;
       }
      case 4:
       {
        i9 = HEAP32[i6 >> 2] | 0;
        HEAP8[i16 >> 0] = 0;
        i8 = i16;
        i7 = (i9 | 0) > -1 ? i9 : 0 - i9 | 0;
        while (1) {
         i2 = i7;
         i7 = (i7 >>> 0) / 10 | 0;
         i10 = i8 + -1 | 0;
         HEAP8[i10 >> 0] = i2 + 48 + (Math_imul(i7, -10) | 0);
         if (i2 >>> 0 <= 9) break; else i8 = i10;
        }
        if ((i9 | 0) < 0) {
         i10 = i8 + -2 | 0;
         HEAP8[i10 >> 0] = 45;
        }
        i2 = i6 + 4 | 0;
        break;
       }
      case 5:
       {
        f12 = Math_fround(HEAPF32[i6 >> 2]);
        i10 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
        do if ((i10 & 2139095040 | 0) == 2139095040) if ((i10 & 2147483647 | 0) == 2139095040) {
         _strcpy(i21 | 0, ((i10 | 0) < 0 ? 14464 : 14472) | 0) | 0;
         break;
        } else {
         HEAP8[i21 + 0 >> 0] = HEAP8[14456] | 0;
         HEAP8[i21 + 1 >> 0] = HEAP8[14457] | 0;
         HEAP8[i21 + 2 >> 0] = HEAP8[14458] | 0;
         HEAP8[i21 + 3 >> 0] = HEAP8[14459] | 0;
         HEAP8[i21 + 4 >> 0] = HEAP8[14460] | 0;
         break;
        } else {
         d11 = +f12;
         i10 = _lrint(d11) | 0;
         if (Math_fround(i10 | 0) == f12) {
          HEAP32[i24 >> 2] = i10;
          _sprintf(i21, 14440, i24) | 0;
          break;
         }
         HEAPF64[tempDoublePtr >> 3] = d11;
         HEAP32[i24 >> 2] = HEAP32[tempDoublePtr >> 2];
         HEAP32[i24 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
         _sprintf(i21, 14480, i24) | 0;
         i2 = HEAP8[i21 >> 0] | 0;
         if (i2 << 24 >> 24 == 45 | i2 << 24 >> 24 == 43) i9 = i18; else i9 = i21;
         while (1) {
          i10 = HEAP8[i9 >> 0] | 0;
          if ((i10 + -48 << 24 >> 24 & 255) < 10) i9 = i9 + 1 | 0; else break;
         }
         if (i10 << 24 >> 24 == 44) HEAP8[i9 >> 0] = 46;
        } while (0);
        i2 = i6 + 4 | 0;
        i10 = i21;
        break;
       }
      default:
       {
        i1 = 63;
        break L23;
       }
      }
      if ((HEAP32[i17 >> 2] | 0) == 8) __ZL17icvXMLWriteScalarP13CvFileStoragePKcS2_i(i23, 0, i10, _strlen(i10 | 0) | 0); else __ZL11icvYMLWriteP13CvFileStoragePKcS2_(i23, 0, i10);
      i5 = i5 + 1 | 0;
      if ((i5 | 0) >= (i4 | 0)) break L28; else i6 = i2;
     }
    } while (0);
    i2 = i2 - i15 | 0;
    i13 = i13 + 1 | 0;
   } while ((i13 | 0) < (i19 | 0));
  }
  if (!i1) {
   i1 = 63;
   break;
  }
 }
 if ((i1 | 0) == 63) {
  STACKTOP = i25;
  return;
 }
}

function __ZNK2cv11_InputArray4dimsEi(i9, i15) {
 i9 = i9 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i4 = i16 + 88 | 0;
 i3 = i16 + 80 | 0;
 i1 = i16 + 72 | 0;
 i5 = i16 + 64 | 0;
 i6 = i16 + 56 | 0;
 i12 = i16 + 48 | 0;
 i13 = i16 + 40 | 0;
 i14 = i16 + 32 | 0;
 i7 = i16 + 24 | 0;
 i8 = i16 + 16 | 0;
 i10 = i16 + 8 | 0;
 i11 = i16;
 i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] & 127](i9) | 0;
 do if ((i2 | 0) == 65536) {
  if ((i15 | 0) >= 0) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i4, 5) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 29256, 27528, 1637);
   __ZN2cv6String10deallocateEv(i4);
  }
  i10 = HEAP32[(HEAP32[i9 + 8 >> 2] | 0) + 4 >> 2] | 0;
  STACKTOP = i16;
  return i10 | 0;
 } else if ((i2 | 0) == 589824) {
  if ((i15 | 0) < 0) {
   i10 = 2;
   STACKTOP = i16;
   return i10 | 0;
  }
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i10 = __ZN2cv6String8allocateEj(i8, 5) | 0;
  HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
  HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
  HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
  HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
  HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 29256, 27528, 1705);
  __ZN2cv6String10deallocateEv(i8);
  i10 = 2;
  STACKTOP = i16;
  return i10 | 0;
 } else if ((i2 | 0) == 327680) {
  i2 = HEAP32[i9 + 8 >> 2] | 0;
  if ((i15 | 0) < 0) {
   i10 = 1;
   STACKTOP = i16;
   return i10 | 0;
  }
  i1 = HEAP32[i2 >> 2] | 0;
  if ((((HEAP32[i2 + 4 >> 2] | 0) - i1 | 0) / 56 | 0 | 0) <= (i15 | 0)) {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i13, 18) | 0) + 0 | 0;
   i3 = 29208 | 0;
   i4 = i1 + 18 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i1 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i13, 29256, 27528, 1682);
   __ZN2cv6String10deallocateEv(i13);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  i10 = HEAP32[i1 + (i15 * 56 | 0) + 4 >> 2] | 0;
  STACKTOP = i16;
  return i10 | 0;
 } else if ((i2 | 0) == 393216) {
  if ((i15 | 0) >= 0) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i3, 5) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 29256, 27528, 1643);
   __ZN2cv6String10deallocateEv(i3);
  }
  i10 = HEAP32[(HEAP32[i9 + 8 >> 2] | 0) + 12 >> 2] | 0;
  STACKTOP = i16;
  return i10 | 0;
 } else if ((i2 | 0) == 196608) {
  if ((i15 | 0) < 0) {
   i10 = 2;
   STACKTOP = i16;
   return i10 | 0;
  }
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i10 = __ZN2cv6String8allocateEj(i6, 5) | 0;
  HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
  HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
  HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
  HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
  HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i6, 29256, 27528, 1661);
  __ZN2cv6String10deallocateEv(i6);
  i10 = 2;
  STACKTOP = i16;
  return i10 | 0;
 } else if ((i2 | 0) == 720896) {
  i2 = HEAP32[i9 + 8 >> 2] | 0;
  if ((i15 | 0) < 0) {
   i10 = 1;
   STACKTOP = i16;
   return i10 | 0;
  }
  i1 = HEAP32[i2 >> 2] | 0;
  if ((((HEAP32[i2 + 4 >> 2] | 0) - i1 | 0) / 48 | 0 | 0) <= (i15 | 0)) {
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i14, 18) | 0) + 0 | 0;
   i3 = 29208 | 0;
   i4 = i1 + 18 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i1 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i14, 29256, 27528, 1692);
   __ZN2cv6String10deallocateEv(i14);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  i10 = HEAP32[i1 + (i15 * 48 | 0) + 4 >> 2] | 0;
  STACKTOP = i16;
  return i10 | 0;
 } else if ((i2 | 0) == 458752) {
  if ((i15 | 0) < 0) {
   i10 = 2;
   STACKTOP = i16;
   return i10 | 0;
  }
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i10 = __ZN2cv6String8allocateEj(i7, 5) | 0;
  HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
  HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
  HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
  HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
  HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 29256, 27528, 1699);
  __ZN2cv6String10deallocateEv(i7);
  i10 = 2;
  STACKTOP = i16;
  return i10 | 0;
 } else if (!i2) {
  i10 = 0;
  STACKTOP = i16;
  return i10 | 0;
 } else if ((i2 | 0) == 262144) {
  if ((i15 | 0) < 0) {
   i10 = 1;
   STACKTOP = i16;
   return i10 | 0;
  }
  i10 = HEAP32[i9 + 8 >> 2] | 0;
  if ((((HEAP32[i10 + 4 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) | 0) / 12 | 0 | 0) > (i15 | 0)) {
   i10 = 2;
   STACKTOP = i16;
   return i10 | 0;
  }
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i12, 18) | 0) + 0 | 0;
  i3 = 29208 | 0;
  i4 = i1 + 18 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i12, 29256, 27528, 1673);
  __ZN2cv6String10deallocateEv(i12);
  i10 = 2;
  STACKTOP = i16;
  return i10 | 0;
 } else if ((i2 | 0) == 655360) {
  if ((i15 | 0) >= 0) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i1, 5) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 29256, 27528, 1649);
   __ZN2cv6String10deallocateEv(i1);
  }
  i10 = HEAP32[(HEAP32[i9 + 8 >> 2] | 0) + 4 >> 2] | 0;
  STACKTOP = i16;
  return i10 | 0;
 } else if ((i2 | 0) == 131072) {
  if ((i15 | 0) < 0) {
   i10 = 2;
   STACKTOP = i16;
   return i10 | 0;
  }
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i10 = __ZN2cv6String8allocateEj(i5, 5) | 0;
  HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
  HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
  HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
  HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
  HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 29256, 27528, 1655);
  __ZN2cv6String10deallocateEv(i5);
  i10 = 2;
  STACKTOP = i16;
  return i10 | 0;
 } else if ((i2 | 0) != 524288) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i10, 13) | 0) + 0 | 0;
  i3 = 29232 | 0;
  i4 = i1 + 13 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 29256, 27528, 1709);
  __ZN2cv6String10deallocateEv(i10);
 } while (0);
 if ((i15 | 0) < 0) {
  i10 = 2;
  STACKTOP = i16;
  return i10 | 0;
 }
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 i10 = __ZN2cv6String8allocateEj(i11, 5) | 0;
 HEAP8[i10 + 0 >> 0] = HEAP8[28696] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[28697] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[28698] | 0;
 HEAP8[i10 + 3 >> 0] = HEAP8[28699] | 0;
 HEAP8[i10 + 4 >> 0] = HEAP8[28700] | 0;
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i11, 29256, 27528, 1712);
 __ZN2cv6String10deallocateEv(i11);
 i10 = 2;
 STACKTOP = i16;
 return i10 | 0;
}

function __ZN2cvL15transpose_16uC3EPKhjPhjNS_5Size_IiEE(i16, i17, i14, i15, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i18 = STACKTOP;
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i13 + -4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i8 = i12 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i12 & -4;
  i11 = 0;
  do {
   i5 = i14 + (Math_imul(i11, i15) | 0) | 0;
   i4 = i14 + (Math_imul(i11 | 1, i15) | 0) | 0;
   i3 = i14 + (Math_imul(i11 | 2, i15) | 0) | 0;
   i2 = i14 + (Math_imul(i11 | 3, i15) | 0) | 0;
   if (i9) i7 = 0; else {
    i7 = i11 * 6 | 0;
    i6 = 0;
    do {
     i26 = (Math_imul(i6, i17) | 0) + i7 | 0;
     i30 = i16 + i26 | 0;
     i23 = i6 | 1;
     i24 = (Math_imul(i23, i17) | 0) + i7 | 0;
     i29 = i16 + i24 | 0;
     i21 = i6 | 2;
     i22 = (Math_imul(i21, i17) | 0) + i7 | 0;
     i28 = i16 + i22 | 0;
     i19 = i6 | 3;
     i20 = (Math_imul(i19, i17) | 0) + i7 | 0;
     i27 = i16 + i20 | 0;
     i25 = i5 + (i6 * 6 | 0) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i30 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i30 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i30 + 4 >> 1] | 0;
     i25 = i5 + (i23 * 6 | 0) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i29 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i29 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i29 + 4 >> 1] | 0;
     i25 = i5 + (i21 * 6 | 0) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i28 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i28 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i28 + 4 >> 1] | 0;
     i25 = i5 + (i19 * 6 | 0) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i27 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i27 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i27 + 4 >> 1] | 0;
     i25 = i4 + (i6 * 6 | 0) | 0;
     i27 = i16 + (i26 + 6) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i27 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i27 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i27 + 4 >> 1] | 0;
     i25 = i4 + (i23 * 6 | 0) | 0;
     i27 = i16 + (i24 + 6) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i27 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i27 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i27 + 4 >> 1] | 0;
     i25 = i4 + (i21 * 6 | 0) | 0;
     i27 = i16 + (i22 + 6) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i27 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i27 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i27 + 4 >> 1] | 0;
     i25 = i4 + (i19 * 6 | 0) | 0;
     i27 = i16 + (i20 + 6) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i27 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i27 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i27 + 4 >> 1] | 0;
     i25 = i3 + (i6 * 6 | 0) | 0;
     i27 = i16 + (i26 + 12) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i27 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i27 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i27 + 4 >> 1] | 0;
     i25 = i3 + (i23 * 6 | 0) | 0;
     i27 = i16 + (i24 + 12) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i27 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i27 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i27 + 4 >> 1] | 0;
     i25 = i3 + (i21 * 6 | 0) | 0;
     i27 = i16 + (i22 + 12) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i27 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i27 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i27 + 4 >> 1] | 0;
     i25 = i3 + (i19 * 6 | 0) | 0;
     i27 = i16 + (i20 + 12) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i27 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i27 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i27 + 4 >> 1] | 0;
     i25 = i2 + (i6 * 6 | 0) | 0;
     i26 = i16 + (i26 + 18) | 0;
     HEAP16[i25 + 0 >> 1] = HEAP16[i26 + 0 >> 1] | 0;
     HEAP16[i25 + 2 >> 1] = HEAP16[i26 + 2 >> 1] | 0;
     HEAP16[i25 + 4 >> 1] = HEAP16[i26 + 4 >> 1] | 0;
     i23 = i2 + (i23 * 6 | 0) | 0;
     i24 = i16 + (i24 + 18) | 0;
     HEAP16[i23 + 0 >> 1] = HEAP16[i24 + 0 >> 1] | 0;
     HEAP16[i23 + 2 >> 1] = HEAP16[i24 + 2 >> 1] | 0;
     HEAP16[i23 + 4 >> 1] = HEAP16[i24 + 4 >> 1] | 0;
     i21 = i2 + (i21 * 6 | 0) | 0;
     i22 = i16 + (i22 + 18) | 0;
     HEAP16[i21 + 0 >> 1] = HEAP16[i22 + 0 >> 1] | 0;
     HEAP16[i21 + 2 >> 1] = HEAP16[i22 + 2 >> 1] | 0;
     HEAP16[i21 + 4 >> 1] = HEAP16[i22 + 4 >> 1] | 0;
     i19 = i2 + (i19 * 6 | 0) | 0;
     i20 = i16 + (i20 + 18) | 0;
     HEAP16[i19 + 0 >> 1] = HEAP16[i20 + 0 >> 1] | 0;
     HEAP16[i19 + 2 >> 1] = HEAP16[i20 + 2 >> 1] | 0;
     HEAP16[i19 + 4 >> 1] = HEAP16[i20 + 4 >> 1] | 0;
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i8 | 0));
    i7 = i10;
   }
   if ((i7 | 0) < (i12 | 0)) {
    i6 = i11 * 6 | 0;
    do {
     i21 = (Math_imul(i7, i17) | 0) + i6 | 0;
     i20 = i16 + i21 | 0;
     i22 = i5 + (i7 * 6 | 0) | 0;
     HEAP16[i22 + 0 >> 1] = HEAP16[i20 + 0 >> 1] | 0;
     HEAP16[i22 + 2 >> 1] = HEAP16[i20 + 2 >> 1] | 0;
     HEAP16[i22 + 4 >> 1] = HEAP16[i20 + 4 >> 1] | 0;
     i22 = i4 + (i7 * 6 | 0) | 0;
     i20 = i16 + (i21 + 6) | 0;
     HEAP16[i22 + 0 >> 1] = HEAP16[i20 + 0 >> 1] | 0;
     HEAP16[i22 + 2 >> 1] = HEAP16[i20 + 2 >> 1] | 0;
     HEAP16[i22 + 4 >> 1] = HEAP16[i20 + 4 >> 1] | 0;
     i22 = i3 + (i7 * 6 | 0) | 0;
     i20 = i16 + (i21 + 12) | 0;
     HEAP16[i22 + 0 >> 1] = HEAP16[i20 + 0 >> 1] | 0;
     HEAP16[i22 + 2 >> 1] = HEAP16[i20 + 2 >> 1] | 0;
     HEAP16[i22 + 4 >> 1] = HEAP16[i20 + 4 >> 1] | 0;
     i22 = i2 + (i7 * 6 | 0) | 0;
     i21 = i16 + (i21 + 18) | 0;
     HEAP16[i22 + 0 >> 1] = HEAP16[i21 + 0 >> 1] | 0;
     HEAP16[i22 + 2 >> 1] = HEAP16[i21 + 2 >> 1] | 0;
     HEAP16[i22 + 4 >> 1] = HEAP16[i21 + 4 >> 1] | 0;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i12 | 0));
   }
   i11 = i11 + 4 | 0;
  } while ((i11 | 0) <= (i1 | 0));
  i1 = i13 & -4;
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i18;
  return;
 }
 i5 = i12 + -4 | 0;
 i6 = (i5 | 0) < 0;
 i7 = i12 & -4;
 do {
  i4 = i14 + (Math_imul(i1, i15) | 0) | 0;
  if (i6) i2 = 0; else {
   i2 = i1 * 6 | 0;
   i3 = 0;
   do {
    i10 = i16 + ((Math_imul(i3, i17) | 0) + i2) | 0;
    i11 = i3 | 1;
    i8 = i16 + ((Math_imul(i11, i17) | 0) + i2) | 0;
    i20 = i3 | 2;
    i19 = i16 + ((Math_imul(i20, i17) | 0) + i2) | 0;
    i22 = i3 | 3;
    i21 = i16 + ((Math_imul(i22, i17) | 0) + i2) | 0;
    i9 = i4 + (i3 * 6 | 0) | 0;
    HEAP16[i9 + 0 >> 1] = HEAP16[i10 + 0 >> 1] | 0;
    HEAP16[i9 + 2 >> 1] = HEAP16[i10 + 2 >> 1] | 0;
    HEAP16[i9 + 4 >> 1] = HEAP16[i10 + 4 >> 1] | 0;
    i11 = i4 + (i11 * 6 | 0) | 0;
    HEAP16[i11 + 0 >> 1] = HEAP16[i8 + 0 >> 1] | 0;
    HEAP16[i11 + 2 >> 1] = HEAP16[i8 + 2 >> 1] | 0;
    HEAP16[i11 + 4 >> 1] = HEAP16[i8 + 4 >> 1] | 0;
    i20 = i4 + (i20 * 6 | 0) | 0;
    HEAP16[i20 + 0 >> 1] = HEAP16[i19 + 0 >> 1] | 0;
    HEAP16[i20 + 2 >> 1] = HEAP16[i19 + 2 >> 1] | 0;
    HEAP16[i20 + 4 >> 1] = HEAP16[i19 + 4 >> 1] | 0;
    i22 = i4 + (i22 * 6 | 0) | 0;
    HEAP16[i22 + 0 >> 1] = HEAP16[i21 + 0 >> 1] | 0;
    HEAP16[i22 + 2 >> 1] = HEAP16[i21 + 2 >> 1] | 0;
    HEAP16[i22 + 4 >> 1] = HEAP16[i21 + 4 >> 1] | 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i5 | 0));
   i2 = i7;
  }
  if ((i2 | 0) < (i12 | 0)) {
   i3 = i1 * 6 | 0;
   do {
    i21 = i16 + ((Math_imul(i2, i17) | 0) + i3) | 0;
    i22 = i4 + (i2 * 6 | 0) | 0;
    HEAP16[i22 + 0 >> 1] = HEAP16[i21 + 0 >> 1] | 0;
    HEAP16[i22 + 2 >> 1] = HEAP16[i21 + 2 >> 1] | 0;
    HEAP16[i22 + 4 >> 1] = HEAP16[i21 + 4 >> 1] | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i12 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i18;
 return;
}

function __ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri(i2, i18, i1, i19, i15, i22, i17, i21, i20, i16) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i15 = i15 | 0;
 i22 = i22 | 0;
 i17 = i17 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i3 = i23 + 108 | 0;
 i4 = i23 + 96 | 0;
 i7 = i23 + 92 | 0;
 i8 = i23 + 80 | 0;
 i9 = i23 + 68 | 0;
 i10 = i23 + 56 | 0;
 i11 = i23 + 52 | 0;
 i12 = i23 + 40 | 0;
 i13 = i23 + 36 | 0;
 i14 = i23 + 24 | 0;
 i5 = i23 + 12 | 0;
 i6 = i23;
 if (i2) {
  i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960296) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i18) {
   FUNCTION_TABLE_vii[HEAP32[i2 + 44 >> 2] & 127](i3, i1);
   i18 = HEAP32[i3 >> 2] | 0;
   HEAP8[i19 >> 0] = i18;
   HEAP8[i19 + 1 >> 0] = i18 >> 8;
   HEAP8[i19 + 2 >> 0] = i18 >> 16;
   HEAP8[i19 + 3 >> 0] = i18 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] & 127](i4, i1);
   if (!(HEAP8[i20 >> 0] & 1)) {
    HEAP32[i20 + 4 >> 2] = 0;
    HEAP8[i20 >> 0] = 0;
   } else {
    HEAP32[HEAP32[i20 + 8 >> 2] >> 2] = 0;
    HEAP32[i20 + 4 >> 2] = 0;
   }
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i20, 0);
   HEAP32[i20 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 + 0 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i4);
  } else {
   FUNCTION_TABLE_vii[HEAP32[i2 + 40 >> 2] & 127](i7, i1);
   i18 = HEAP32[i7 >> 2] | 0;
   HEAP8[i19 >> 0] = i18;
   HEAP8[i19 + 1 >> 0] = i18 >> 8;
   HEAP8[i19 + 2 >> 0] = i18 >> 16;
   HEAP8[i19 + 3 >> 0] = i18 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i8, i1);
   if (!(HEAP8[i20 >> 0] & 1)) {
    HEAP32[i20 + 4 >> 2] = 0;
    HEAP8[i20 >> 0] = 0;
   } else {
    HEAP32[HEAP32[i20 + 8 >> 2] >> 2] = 0;
    HEAP32[i20 + 4 >> 2] = 0;
   }
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i20, 0);
   HEAP32[i20 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i8 + 0 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i8);
  }
  HEAP32[i15 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 127](i1) | 0;
  HEAP32[i22 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 127](i1) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i9, i1);
  if (!(HEAP8[i17 >> 0] & 1)) {
   HEAP8[i17 + 1 >> 0] = 0;
   HEAP8[i17 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i17 + 8 >> 2] >> 0] = 0;
   HEAP32[i17 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i17, 0);
  HEAP32[i17 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i9 + 0 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i10, i1);
  if (!(HEAP8[i21 >> 0] & 1)) {
   HEAP32[i21 + 4 >> 2] = 0;
   HEAP8[i21 >> 0] = 0;
  } else {
   HEAP32[HEAP32[i21 + 8 >> 2] >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i21, 0);
  HEAP32[i21 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i10);
  i22 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0;
  HEAP32[i16 >> 2] = i22;
  STACKTOP = i23;
  return;
 } else {
  i2 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960232) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i18) {
   FUNCTION_TABLE_vii[HEAP32[i1 + 44 >> 2] & 127](i11, i2);
   i18 = HEAP32[i11 >> 2] | 0;
   HEAP8[i19 >> 0] = i18;
   HEAP8[i19 + 1 >> 0] = i18 >> 8;
   HEAP8[i19 + 2 >> 0] = i18 >> 16;
   HEAP8[i19 + 3 >> 0] = i18 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] & 127](i12, i2);
   if (!(HEAP8[i20 >> 0] & 1)) {
    HEAP32[i20 + 4 >> 2] = 0;
    HEAP8[i20 >> 0] = 0;
   } else {
    HEAP32[HEAP32[i20 + 8 >> 2] >> 2] = 0;
    HEAP32[i20 + 4 >> 2] = 0;
   }
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i20, 0);
   HEAP32[i20 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i12 + 0 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i12);
  } else {
   FUNCTION_TABLE_vii[HEAP32[i1 + 40 >> 2] & 127](i13, i2);
   i18 = HEAP32[i13 >> 2] | 0;
   HEAP8[i19 >> 0] = i18;
   HEAP8[i19 + 1 >> 0] = i18 >> 8;
   HEAP8[i19 + 2 >> 0] = i18 >> 16;
   HEAP8[i19 + 3 >> 0] = i18 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] & 127](i14, i2);
   if (!(HEAP8[i20 >> 0] & 1)) {
    HEAP32[i20 + 4 >> 2] = 0;
    HEAP8[i20 >> 0] = 0;
   } else {
    HEAP32[HEAP32[i20 + 8 >> 2] >> 2] = 0;
    HEAP32[i20 + 4 >> 2] = 0;
   }
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i20, 0);
   HEAP32[i20 + 0 >> 2] = HEAP32[i14 + 0 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i14 + 0 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i14);
  }
  HEAP32[i15 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 127](i2) | 0;
  HEAP32[i22 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] & 127](i2) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] & 127](i5, i2);
  if (!(HEAP8[i17 >> 0] & 1)) {
   HEAP8[i17 + 1 >> 0] = 0;
   HEAP8[i17 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i17 + 8 >> 2] >> 0] = 0;
   HEAP32[i17 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i17, 0);
  HEAP32[i17 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i5 + 0 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i6, i2);
  if (!(HEAP8[i21 >> 0] & 1)) {
   HEAP32[i21 + 4 >> 2] = 0;
   HEAP8[i21 >> 0] = 0;
  } else {
   HEAP32[HEAP32[i21 + 8 >> 2] >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i21, 0);
  HEAP32[i21 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i6);
  i22 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0;
  HEAP32[i16 >> 2] = i22;
  STACKTOP = i23;
  return;
 }
}

function __ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri(i2, i18, i1, i19, i15, i22, i17, i21, i20, i16) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i15 = i15 | 0;
 i22 = i22 | 0;
 i17 = i17 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i3 = i23 + 108 | 0;
 i4 = i23 + 96 | 0;
 i7 = i23 + 92 | 0;
 i8 = i23 + 80 | 0;
 i9 = i23 + 68 | 0;
 i10 = i23 + 56 | 0;
 i11 = i23 + 52 | 0;
 i12 = i23 + 40 | 0;
 i13 = i23 + 36 | 0;
 i14 = i23 + 24 | 0;
 i5 = i23 + 12 | 0;
 i6 = i23;
 if (i2) {
  i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960168) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i18) {
   FUNCTION_TABLE_vii[HEAP32[i2 + 44 >> 2] & 127](i3, i1);
   i18 = HEAP32[i3 >> 2] | 0;
   HEAP8[i19 >> 0] = i18;
   HEAP8[i19 + 1 >> 0] = i18 >> 8;
   HEAP8[i19 + 2 >> 0] = i18 >> 16;
   HEAP8[i19 + 3 >> 0] = i18 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] & 127](i4, i1);
   if (!(HEAP8[i20 >> 0] & 1)) {
    HEAP8[i20 + 1 >> 0] = 0;
    HEAP8[i20 >> 0] = 0;
   } else {
    HEAP8[HEAP32[i20 + 8 >> 2] >> 0] = 0;
    HEAP32[i20 + 4 >> 2] = 0;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i20, 0);
   HEAP32[i20 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 + 0 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
  } else {
   FUNCTION_TABLE_vii[HEAP32[i2 + 40 >> 2] & 127](i7, i1);
   i18 = HEAP32[i7 >> 2] | 0;
   HEAP8[i19 >> 0] = i18;
   HEAP8[i19 + 1 >> 0] = i18 >> 8;
   HEAP8[i19 + 2 >> 0] = i18 >> 16;
   HEAP8[i19 + 3 >> 0] = i18 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i8, i1);
   if (!(HEAP8[i20 >> 0] & 1)) {
    HEAP8[i20 + 1 >> 0] = 0;
    HEAP8[i20 >> 0] = 0;
   } else {
    HEAP8[HEAP32[i20 + 8 >> 2] >> 0] = 0;
    HEAP32[i20 + 4 >> 2] = 0;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i20, 0);
   HEAP32[i20 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i8 + 0 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
  }
  HEAP8[i15 >> 0] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 127](i1) | 0;
  HEAP8[i22 >> 0] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 127](i1) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i9, i1);
  if (!(HEAP8[i17 >> 0] & 1)) {
   HEAP8[i17 + 1 >> 0] = 0;
   HEAP8[i17 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i17 + 8 >> 2] >> 0] = 0;
   HEAP32[i17 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i17, 0);
  HEAP32[i17 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i9 + 0 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i10, i1);
  if (!(HEAP8[i21 >> 0] & 1)) {
   HEAP8[i21 + 1 >> 0] = 0;
   HEAP8[i21 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i21 + 8 >> 2] >> 0] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i21, 0);
  HEAP32[i21 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
  i22 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0;
  HEAP32[i16 >> 2] = i22;
  STACKTOP = i23;
  return;
 } else {
  i2 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960104) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i18) {
   FUNCTION_TABLE_vii[HEAP32[i1 + 44 >> 2] & 127](i11, i2);
   i18 = HEAP32[i11 >> 2] | 0;
   HEAP8[i19 >> 0] = i18;
   HEAP8[i19 + 1 >> 0] = i18 >> 8;
   HEAP8[i19 + 2 >> 0] = i18 >> 16;
   HEAP8[i19 + 3 >> 0] = i18 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] & 127](i12, i2);
   if (!(HEAP8[i20 >> 0] & 1)) {
    HEAP8[i20 + 1 >> 0] = 0;
    HEAP8[i20 >> 0] = 0;
   } else {
    HEAP8[HEAP32[i20 + 8 >> 2] >> 0] = 0;
    HEAP32[i20 + 4 >> 2] = 0;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i20, 0);
   HEAP32[i20 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i12 + 0 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
  } else {
   FUNCTION_TABLE_vii[HEAP32[i1 + 40 >> 2] & 127](i13, i2);
   i18 = HEAP32[i13 >> 2] | 0;
   HEAP8[i19 >> 0] = i18;
   HEAP8[i19 + 1 >> 0] = i18 >> 8;
   HEAP8[i19 + 2 >> 0] = i18 >> 16;
   HEAP8[i19 + 3 >> 0] = i18 >> 24;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] & 127](i14, i2);
   if (!(HEAP8[i20 >> 0] & 1)) {
    HEAP8[i20 + 1 >> 0] = 0;
    HEAP8[i20 >> 0] = 0;
   } else {
    HEAP8[HEAP32[i20 + 8 >> 2] >> 0] = 0;
    HEAP32[i20 + 4 >> 2] = 0;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i20, 0);
   HEAP32[i20 + 0 >> 2] = HEAP32[i14 + 0 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i14 + 0 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
  }
  HEAP8[i15 >> 0] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 127](i2) | 0;
  HEAP8[i22 >> 0] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] & 127](i2) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] & 127](i5, i2);
  if (!(HEAP8[i17 >> 0] & 1)) {
   HEAP8[i17 + 1 >> 0] = 0;
   HEAP8[i17 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i17 + 8 >> 2] >> 0] = 0;
   HEAP32[i17 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i17, 0);
  HEAP32[i17 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i5 + 0 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i6, i2);
  if (!(HEAP8[i21 >> 0] & 1)) {
   HEAP8[i21 + 1 >> 0] = 0;
   HEAP8[i21 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i21 + 8 >> 2] >> 0] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i21, 0);
  HEAP32[i21 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
  i22 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0;
  HEAP32[i16 >> 2] = i22;
  STACKTOP = i23;
  return;
 }
}

function __ZN2cv9transposeERKNS_11_InputArrayERKNS_12_OutputArrayE(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 i2 = i21 + 176 | 0;
 i20 = i21 + 120 | 0;
 i17 = i21 + 64 | 0;
 i9 = i21 + 56 | 0;
 i10 = i21 + 32 | 0;
 i12 = i21 + 24 | 0;
 i14 = i21 + 16 | 0;
 i13 = i21 + 8 | 0;
 i15 = i21;
 i11 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] & 127](i4, -1) | 0;
 i11 = (i11 >>> 3 & 511) + 1 << (47696 >>> (i11 << 1 & 14) & 3);
 if (!((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] & 127](i4, -1) | 0) < 3 & (i11 | 0) < 33)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i2, 29) | 0) + 0 | 0;
  i6 = 31440;
  i7 = i5 + 29 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 31472, 27528, 3045);
  __ZN2cv6String10deallocateEv(i2);
 }
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i4 >> 2] >> 2] & 63](i20, i4, -1);
 i19 = i20 + 16 | 0;
 if (HEAP32[i19 >> 2] | 0) {
  i4 = HEAP32[i20 + 4 >> 2] | 0;
  if ((i4 | 0) < 3) i2 = Math_imul(HEAP32[i20 + 12 >> 2] | 0, HEAP32[i20 + 8 >> 2] | 0) | 0; else {
   i1 = HEAP32[i20 + 40 >> 2] | 0;
   i5 = 0;
   i2 = 1;
   do {
    i2 = Math_imul(HEAP32[i1 + (i5 << 2) >> 2] | 0, i2) | 0;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i4 | 0));
  }
  if (i2) {
   i2 = i20 + 12 | 0;
   i5 = i20 + 8 | 0;
   FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i8 >> 2] | 0) + 140 >> 2] & 63](i8, HEAP32[i2 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i20 >> 2] & 4095, -1, 0, 0);
   FUNCTION_TABLE_viii[HEAP32[HEAP32[i8 >> 2] >> 2] & 63](i17, i8, -1);
   i5 = HEAP32[i5 >> 2] | 0;
   i1 = i17 + 12 | 0;
   do if ((i5 | 0) == (HEAP32[i1 >> 2] | 0) ? (i3 = HEAP32[i2 >> 2] | 0, i16 = i17 + 8 | 0, (i3 | 0) == (HEAP32[i16 >> 2] | 0)) : 0) {
    i8 = i17 + 16 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i19 >> 2] | 0;
    if ((i4 | 0) != (i2 | 0)) {
     i1 = HEAP32[31728 + (i11 << 2) >> 2] | 0;
     if (!i1) {
      HEAP32[i13 >> 2] = 0;
      HEAP32[i13 + 4 >> 2] = 0;
      i5 = (__ZN2cv6String8allocateEj(i13, 9) | 0) + 0 | 0;
      i6 = 31688;
      i7 = i5 + 9 | 0;
      do {
       HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
       i5 = i5 + 1 | 0;
       i6 = i6 + 1 | 0;
      } while ((i5 | 0) < (i7 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i13, 31472, 27528, 3149);
      __ZN2cv6String10deallocateEv(i13);
      i2 = HEAP32[i19 >> 2] | 0;
      i3 = HEAP32[i8 >> 2] | 0;
     } else i3 = i4;
     i9 = HEAP32[i20 + 48 >> 2] | 0;
     i10 = HEAP32[i17 + 48 >> 2] | 0;
     i7 = HEAP32[i20 + 40 >> 2] | 0;
     i8 = HEAP32[i7 >> 2] | 0;
     HEAP32[i15 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i15 + 4 >> 2] = i8;
     FUNCTION_TABLE_viiiii[i1 & 31](i2, i9, i3, i10, i15);
     break;
    }
    i4 = HEAP32[31552 + (i11 << 2) >> 2] | 0;
    if (!i4) {
     HEAP32[i12 >> 2] = 0;
     HEAP32[i12 + 4 >> 2] = 0;
     i5 = (__ZN2cv6String8allocateEj(i12, 9) | 0) + 0 | 0;
     i6 = 31688;
     i7 = i5 + 9 | 0;
     do {
      HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
      i5 = i5 + 1 | 0;
      i6 = i6 + 1 | 0;
     } while ((i5 | 0) < (i7 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i12, 31472, 27528, 3142);
     __ZN2cv6String10deallocateEv(i12);
     i2 = HEAP32[i1 >> 2] | 0;
     i3 = HEAP32[i16 >> 2] | 0;
    } else i2 = i5;
    if ((i2 | 0) != (i3 | 0)) {
     HEAP32[i14 >> 2] = 0;
     HEAP32[i14 + 4 >> 2] = 0;
     i5 = (__ZN2cv6String8allocateEj(i14, 20) | 0) + 0 | 0;
     i6 = 31704;
     i7 = i5 + 20 | 0;
     do {
      HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
      i5 = i5 + 1 | 0;
      i6 = i6 + 1 | 0;
     } while ((i5 | 0) < (i7 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i14, 31472, 27528, 3143);
     __ZN2cv6String10deallocateEv(i14);
     i3 = HEAP32[i16 >> 2] | 0;
    }
    FUNCTION_TABLE_viii[i4 & 63](HEAP32[i8 >> 2] | 0, HEAP32[i17 + 48 >> 2] | 0, i3);
   } else i18 = 12; while (0);
   if ((i18 | 0) == 12) {
    i7 = HEAP32[i20 + 40 >> 2] | 0;
    i8 = HEAP32[i17 + 40 >> 2] | 0;
    if (!(((HEAP32[i7 >> 2] | 0) == (HEAP32[i8 >> 2] | 0) ? (HEAP32[i7 + 4 >> 2] | 0) == (HEAP32[i8 + 4 >> 2] | 0) : 0) ? (HEAP32[i2 >> 2] | 0) == 1 | (i5 | 0) == 1 : 0)) {
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     i5 = (__ZN2cv6String8allocateEj(i9, 60) | 0) + 0 | 0;
     i6 = 31488;
     i7 = i5 + 60 | 0;
     do {
      HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
      i5 = i5 + 1 | 0;
      i6 = i6 + 1 | 0;
     } while ((i5 | 0) < (i7 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i9, 31472, 27528, 3063);
     __ZN2cv6String10deallocateEv(i9);
    }
    i9 = i10 + 4 | 0;
    HEAP32[i9 + 0 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    HEAP32[i9 + 8 >> 2] = 0;
    HEAP32[i9 + 12 >> 2] = 0;
    HEAP32[i10 >> 2] = 32232;
    HEAP32[i9 >> 2] = 33619968;
    HEAP32[i10 + 8 >> 2] = i17;
    __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i20, i10);
   }
   i1 = i17 + 36 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) != 0 ? (i9 = i3 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (i2) {
     i3 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i3) {
      i3 = HEAP32[i17 + 32 >> 2] | 0;
      if (!i3) {
       if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
        i10 = __Znwj(4) | 0;
        HEAP32[i10 >> 2] = 32784;
        HEAP32[6904] = i10;
        ___cxa_guard_release(27624);
       }
       i3 = HEAP32[6904] | 0;
       i2 = HEAP32[i1 >> 2] | 0;
      }
     }
     FUNCTION_TABLE_vii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3, i2);
    }
    HEAP32[i1 >> 2] = 0;
   }
   HEAP32[i1 >> 2] = 0;
   i10 = i17 + 16 | 0;
   i3 = i17 + 4 | 0;
   HEAP32[i10 + 0 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i2 = HEAP32[i17 + 40 >> 2] | 0;
    i1 = 0;
    do {
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
   }
   i2 = HEAP32[i17 + 44 >> 2] | 0;
   if ((i2 | 0) != (i17 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
  } else i18 = 9;
 } else i18 = 9;
 if ((i18 | 0) == 9) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 152 >> 2] & 511](i8);
 i3 = i20 + 36 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i20 + 32 >> 2] | 0;
    if (!i2) {
     if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
      i10 = __Znwj(4) | 0;
      HEAP32[i10 >> 2] = 32784;
      HEAP32[6904] = i10;
      ___cxa_guard_release(27624);
     }
     i2 = HEAP32[6904] | 0;
     i1 = HEAP32[i3 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1);
  }
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 i3 = i20 + 4 | 0;
 HEAP32[i19 + 0 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i1 = HEAP32[i20 + 40 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i20 + 44 >> 2] | 0;
 if ((i1 | 0) == (i20 + 48 | 0)) {
  STACKTOP = i21;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i21;
 return;
}

function __ZN7testing10TestResult20ValidateTestPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKNS_12TestPropertyE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i10 = i18 + 48 | 0;
 i11 = i18 + 44 | 0;
 i12 = i18 + 40 | 0;
 i13 = i18 + 36 | 0;
 i14 = i18 + 24 | 0;
 i16 = i18 + 12 | 0;
 i17 = i18;
 if (!(HEAP8[i3 >> 0] & 1)) i3 = i3 + 1 | 0; else i3 = HEAP32[i3 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i16, i3, _strlen(i3 | 0) | 0);
 __ZN7testingL31GetReservedAttributesForElementERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i17, i4);
 i4 = HEAP32[i17 >> 2] | 0;
 i15 = i17 + 4 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 L5 : do if ((i4 | 0) != (i8 | 0)) {
  i6 = i16 + 1 | 0;
  i7 = HEAP8[i16 >> 0] | 0;
  i1 = (i7 & 255) >>> 1;
  if (!(i7 & 1)) {
   i7 = (i1 | 0) == 0;
   while (1) {
    i5 = HEAP8[i4 >> 0] | 0;
    i3 = (i5 & 1) == 0;
    if (i3) i5 = (i5 & 255) >>> 1; else i5 = HEAP32[i4 + 4 >> 2] | 0;
    L32 : do if ((i5 | 0) == (i1 | 0)) {
     if (!i3) if (!(_memcmp(HEAP32[i4 + 8 >> 2] | 0, i6, i1) | 0)) {
      i9 = 30;
      break L5;
     } else break;
     if (i7) {
      i9 = 30;
      break L5;
     }
     i5 = i1;
     i3 = i4 + 1 | 0;
     i2 = i6;
     while (1) {
      if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) break L32;
      i5 = i5 + -1 | 0;
      if (!i5) {
       i9 = 30;
       break L5;
      } else {
       i3 = i3 + 1 | 0;
       i2 = i2 + 1 | 0;
      }
     }
    } while (0);
    i4 = i4 + 12 | 0;
    if ((i4 | 0) == (i8 | 0)) {
     i3 = 1;
     break;
    }
   }
  } else {
   i1 = HEAP32[i16 + 4 >> 2] | 0;
   i6 = HEAP32[i16 + 8 >> 2] | 0;
   while (1) {
    i5 = HEAP8[i4 >> 0] | 0;
    i3 = (i5 & 1) == 0;
    if (i3) i5 = (i5 & 255) >>> 1; else i5 = HEAP32[i4 + 4 >> 2] | 0;
    L15 : do if ((i5 | 0) == (i1 | 0)) {
     if (!i3) if (!(_memcmp(HEAP32[i4 + 8 >> 2] | 0, i6, i1) | 0)) {
      i9 = 30;
      break L5;
     } else break;
     if (!i1) {
      i9 = 30;
      break L5;
     }
     i5 = i1;
     i3 = i4 + 1 | 0;
     i2 = i6;
     while (1) {
      if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) break L15;
      i5 = i5 + -1 | 0;
      if (!i5) {
       i9 = 30;
       break L5;
      } else {
       i3 = i3 + 1 | 0;
       i2 = i2 + 1 | 0;
      }
     }
    } while (0);
    i4 = i4 + 12 | 0;
    if ((i4 | 0) == (i8 | 0)) {
     i3 = 1;
     break;
    }
   }
  }
 } else i9 = 30; while (0);
 if ((i9 | 0) == 30) if ((i4 | 0) != (i8 | 0)) {
  i3 = __Znwj(24) | 0;
  HEAP32[i3 >> 2] = 1;
  HEAP32[i3 + 4 >> 2] = 160160;
  HEAP32[i3 + 8 >> 2] = 3322;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3 + 12 | 0, 160840, 6);
  HEAP32[i12 >> 2] = i3;
  __ZN7testing7MessageC2Ev(i13);
  i3 = (HEAP32[i13 >> 2] | 0) + 8 | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 169304, 39) | 0;
  i4 = HEAP8[i16 >> 0] | 0;
  if (!(i4 & 1)) {
   i2 = i16 + 1 | 0;
   i4 = (i4 & 255) >>> 1;
  } else {
   i2 = HEAP32[i16 + 8 >> 2] | 0;
   i4 = HEAP32[i16 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, i2, i4) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 160648, 2) | 0;
  __ZN7testing7MessageC2Ev(i11);
  i2 = HEAP32[i15 >> 2] | 0;
  i4 = HEAP32[i17 >> 2] | 0;
  if ((i2 | 0) == (i4 | 0)) i3 = HEAP32[i11 >> 2] | 0; else {
   i3 = HEAP32[i11 >> 2] | 0;
   i6 = i3 + 8 | 0;
   i5 = (i2 - i4 | 0) / 12 | 0;
   i7 = 0;
   do {
    if ((i7 | 0) != 0 & i5 >>> 0 > 2) {
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, 164448, 2) | 0;
     i2 = HEAP32[i15 >> 2] | 0;
     i4 = HEAP32[i17 >> 2] | 0;
    }
    if ((i7 | 0) == (((i2 - i4 | 0) / 12 | 0) + -1 | 0)) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, 169368, 4) | 0;
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, 165832, 1) | 0;
    i2 = HEAP32[i17 >> 2] | 0;
    i4 = i2 + (i7 * 12 | 0) | 0;
    i1 = HEAP8[i4 >> 0] | 0;
    if (!(i1 & 1)) {
     i5 = i4 + 1 | 0;
     i4 = (i1 & 255) >>> 1;
    } else {
     i5 = HEAP32[i2 + (i7 * 12 | 0) + 8 >> 2] | 0;
     i4 = HEAP32[i2 + (i7 * 12 | 0) + 4 >> 2] | 0;
    }
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i5, i4) | 0;
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, 165832, 1) | 0;
    i7 = i7 + 1 | 0;
    i2 = HEAP32[i15 >> 2] | 0;
    i4 = HEAP32[i17 >> 2] | 0;
    i5 = (i2 - i4 | 0) / 12 | 0;
   } while (i7 >>> 0 < i5 >>> 0);
  }
  __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i10, i3 + 12 | 0);
  i3 = HEAP8[i10 >> 0] | 0;
  if (!(i3 & 1)) {
   i4 = i10 + 1 | 0;
   i3 = (i3 & 255) >>> 1;
  } else {
   i4 = HEAP32[i10 + 8 >> 2] | 0;
   i3 = HEAP32[i10 + 4 >> 2] | 0;
  }
  i2 = i4 + i3 | 0;
  HEAP32[i14 + 0 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i14, i3 << 1);
  if (i3) do {
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i14, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i14, i3);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i2 | 0));
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
  i3 = HEAP32[i11 >> 2] | 0;
  if (i3) {
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
   HEAP32[i11 >> 2] = 0;
  }
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2 + 8 | 0;
  i3 = HEAP8[i14 >> 0] | 0;
  if (!(i3 & 1)) {
   i4 = i14 + 1 | 0;
   i3 = (i3 & 255) >>> 1;
  } else {
   i4 = HEAP32[i14 + 8 >> 2] | 0;
   i3 = HEAP32[i14 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i4, i3) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 169344, 17) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 162208, 11) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 160656, 1) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i12, i13);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
  if (i2) {
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
   HEAP32[i13 >> 2] = 0;
  }
  i1 = HEAP32[i12 >> 2] | 0;
  if (!i1) i3 = 0; else {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 12 | 0);
   __ZdlPv(i1);
   i3 = 0;
  }
 } else i3 = 1;
 i1 = HEAP32[i17 >> 2] | 0;
 if (!i1) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16);
  STACKTOP = i18;
  return i3 | 0;
 }
 while (1) {
  i2 = HEAP32[i15 >> 2] | 0;
  if ((i2 | 0) == (i1 | 0)) break;
  i10 = i2 + -12 | 0;
  HEAP32[i15 >> 2] = i10;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
 }
 __ZdlPv(HEAP32[i17 >> 2] | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16);
 STACKTOP = i18;
 return i3 | 0;
}

function __ZN2cvL14transpose_8uC3EPKhjPhjNS_5Size_IiEE(i16, i17, i14, i15, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i18 = STACKTOP;
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i13 + -4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i8 = i12 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i12 & -4;
  i11 = 0;
  do {
   i5 = i14 + (Math_imul(i11, i15) | 0) | 0;
   i4 = i14 + (Math_imul(i11 | 1, i15) | 0) | 0;
   i3 = i14 + (Math_imul(i11 | 2, i15) | 0) | 0;
   i2 = i14 + (Math_imul(i11 | 3, i15) | 0) | 0;
   if (i9) i7 = 0; else {
    i7 = i11 * 3 | 0;
    i6 = 0;
    do {
     i26 = (Math_imul(i6, i17) | 0) + i7 | 0;
     i30 = i16 + i26 | 0;
     i23 = i6 | 1;
     i24 = (Math_imul(i23, i17) | 0) + i7 | 0;
     i29 = i16 + i24 | 0;
     i21 = i6 | 2;
     i22 = (Math_imul(i21, i17) | 0) + i7 | 0;
     i28 = i16 + i22 | 0;
     i19 = i6 | 3;
     i20 = (Math_imul(i19, i17) | 0) + i7 | 0;
     i27 = i16 + i20 | 0;
     i25 = i5 + (i6 * 3 | 0) | 0;
     HEAP8[i25 + 0 >> 0] = HEAP8[i30 + 0 >> 0] | 0;
     HEAP8[i25 + 1 >> 0] = HEAP8[i30 + 1 >> 0] | 0;
     HEAP8[i25 + 2 >> 0] = HEAP8[i30 + 2 >> 0] | 0;
     i25 = i5 + (i23 * 3 | 0) | 0;
     HEAP8[i25 + 0 >> 0] = HEAP8[i29 + 0 >> 0] | 0;
     HEAP8[i25 + 1 >> 0] = HEAP8[i29 + 1 >> 0] | 0;
     HEAP8[i25 + 2 >> 0] = HEAP8[i29 + 2 >> 0] | 0;
     i25 = i5 + (i21 * 3 | 0) | 0;
     HEAP8[i25 + 0 >> 0] = HEAP8[i28 + 0 >> 0] | 0;
     HEAP8[i25 + 1 >> 0] = HEAP8[i28 + 1 >> 0] | 0;
     HEAP8[i25 + 2 >> 0] = HEAP8[i28 + 2 >> 0] | 0;
     i25 = i5 + (i19 * 3 | 0) | 0;
     HEAP8[i25 + 0 >> 0] = HEAP8[i27 + 0 >> 0] | 0;
     HEAP8[i25 + 1 >> 0] = HEAP8[i27 + 1 >> 0] | 0;
     HEAP8[i25 + 2 >> 0] = HEAP8[i27 + 2 >> 0] | 0;
     i25 = i16 + (i26 | 3) | 0;
     i27 = i4 + (i6 * 3 | 0) | 0;
     HEAP8[i27 + 0 >> 0] = HEAP8[i25 + 0 >> 0] | 0;
     HEAP8[i27 + 1 >> 0] = HEAP8[i25 + 1 >> 0] | 0;
     HEAP8[i27 + 2 >> 0] = HEAP8[i25 + 2 >> 0] | 0;
     i27 = i16 + (i24 + 3) | 0;
     i25 = i4 + (i23 * 3 | 0) | 0;
     HEAP8[i25 + 0 >> 0] = HEAP8[i27 + 0 >> 0] | 0;
     HEAP8[i25 + 1 >> 0] = HEAP8[i27 + 1 >> 0] | 0;
     HEAP8[i25 + 2 >> 0] = HEAP8[i27 + 2 >> 0] | 0;
     i25 = i16 + (i22 + 3) | 0;
     i27 = i4 + (i21 * 3 | 0) | 0;
     HEAP8[i27 + 0 >> 0] = HEAP8[i25 + 0 >> 0] | 0;
     HEAP8[i27 + 1 >> 0] = HEAP8[i25 + 1 >> 0] | 0;
     HEAP8[i27 + 2 >> 0] = HEAP8[i25 + 2 >> 0] | 0;
     i27 = i16 + (i20 + 3) | 0;
     i25 = i4 + (i19 * 3 | 0) | 0;
     HEAP8[i25 + 0 >> 0] = HEAP8[i27 + 0 >> 0] | 0;
     HEAP8[i25 + 1 >> 0] = HEAP8[i27 + 1 >> 0] | 0;
     HEAP8[i25 + 2 >> 0] = HEAP8[i27 + 2 >> 0] | 0;
     i25 = i16 + (i26 + 6) | 0;
     i27 = i3 + (i6 * 3 | 0) | 0;
     HEAP8[i27 + 0 >> 0] = HEAP8[i25 + 0 >> 0] | 0;
     HEAP8[i27 + 1 >> 0] = HEAP8[i25 + 1 >> 0] | 0;
     HEAP8[i27 + 2 >> 0] = HEAP8[i25 + 2 >> 0] | 0;
     i27 = i16 + (i24 + 6) | 0;
     i25 = i3 + (i23 * 3 | 0) | 0;
     HEAP8[i25 + 0 >> 0] = HEAP8[i27 + 0 >> 0] | 0;
     HEAP8[i25 + 1 >> 0] = HEAP8[i27 + 1 >> 0] | 0;
     HEAP8[i25 + 2 >> 0] = HEAP8[i27 + 2 >> 0] | 0;
     i25 = i16 + (i22 + 6) | 0;
     i27 = i3 + (i21 * 3 | 0) | 0;
     HEAP8[i27 + 0 >> 0] = HEAP8[i25 + 0 >> 0] | 0;
     HEAP8[i27 + 1 >> 0] = HEAP8[i25 + 1 >> 0] | 0;
     HEAP8[i27 + 2 >> 0] = HEAP8[i25 + 2 >> 0] | 0;
     i27 = i16 + (i20 + 6) | 0;
     i25 = i3 + (i19 * 3 | 0) | 0;
     HEAP8[i25 + 0 >> 0] = HEAP8[i27 + 0 >> 0] | 0;
     HEAP8[i25 + 1 >> 0] = HEAP8[i27 + 1 >> 0] | 0;
     HEAP8[i25 + 2 >> 0] = HEAP8[i27 + 2 >> 0] | 0;
     i26 = i16 + (i26 + 9) | 0;
     i25 = i2 + (i6 * 3 | 0) | 0;
     HEAP8[i25 + 0 >> 0] = HEAP8[i26 + 0 >> 0] | 0;
     HEAP8[i25 + 1 >> 0] = HEAP8[i26 + 1 >> 0] | 0;
     HEAP8[i25 + 2 >> 0] = HEAP8[i26 + 2 >> 0] | 0;
     i24 = i16 + (i24 + 9) | 0;
     i23 = i2 + (i23 * 3 | 0) | 0;
     HEAP8[i23 + 0 >> 0] = HEAP8[i24 + 0 >> 0] | 0;
     HEAP8[i23 + 1 >> 0] = HEAP8[i24 + 1 >> 0] | 0;
     HEAP8[i23 + 2 >> 0] = HEAP8[i24 + 2 >> 0] | 0;
     i22 = i16 + (i22 + 9) | 0;
     i21 = i2 + (i21 * 3 | 0) | 0;
     HEAP8[i21 + 0 >> 0] = HEAP8[i22 + 0 >> 0] | 0;
     HEAP8[i21 + 1 >> 0] = HEAP8[i22 + 1 >> 0] | 0;
     HEAP8[i21 + 2 >> 0] = HEAP8[i22 + 2 >> 0] | 0;
     i20 = i16 + (i20 + 9) | 0;
     i19 = i2 + (i19 * 3 | 0) | 0;
     HEAP8[i19 + 0 >> 0] = HEAP8[i20 + 0 >> 0] | 0;
     HEAP8[i19 + 1 >> 0] = HEAP8[i20 + 1 >> 0] | 0;
     HEAP8[i19 + 2 >> 0] = HEAP8[i20 + 2 >> 0] | 0;
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i8 | 0));
    i7 = i10;
   }
   if ((i7 | 0) < (i12 | 0)) {
    i6 = i11 * 3 | 0;
    do {
     i21 = (Math_imul(i7, i17) | 0) + i6 | 0;
     i20 = i16 + i21 | 0;
     i22 = i5 + (i7 * 3 | 0) | 0;
     HEAP8[i22 + 0 >> 0] = HEAP8[i20 + 0 >> 0] | 0;
     HEAP8[i22 + 1 >> 0] = HEAP8[i20 + 1 >> 0] | 0;
     HEAP8[i22 + 2 >> 0] = HEAP8[i20 + 2 >> 0] | 0;
     i22 = i16 + (i21 + 3) | 0;
     i20 = i4 + (i7 * 3 | 0) | 0;
     HEAP8[i20 + 0 >> 0] = HEAP8[i22 + 0 >> 0] | 0;
     HEAP8[i20 + 1 >> 0] = HEAP8[i22 + 1 >> 0] | 0;
     HEAP8[i20 + 2 >> 0] = HEAP8[i22 + 2 >> 0] | 0;
     i20 = i16 + (i21 + 6) | 0;
     i22 = i3 + (i7 * 3 | 0) | 0;
     HEAP8[i22 + 0 >> 0] = HEAP8[i20 + 0 >> 0] | 0;
     HEAP8[i22 + 1 >> 0] = HEAP8[i20 + 1 >> 0] | 0;
     HEAP8[i22 + 2 >> 0] = HEAP8[i20 + 2 >> 0] | 0;
     i21 = i16 + (i21 + 9) | 0;
     i22 = i2 + (i7 * 3 | 0) | 0;
     HEAP8[i22 + 0 >> 0] = HEAP8[i21 + 0 >> 0] | 0;
     HEAP8[i22 + 1 >> 0] = HEAP8[i21 + 1 >> 0] | 0;
     HEAP8[i22 + 2 >> 0] = HEAP8[i21 + 2 >> 0] | 0;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i12 | 0));
   }
   i11 = i11 + 4 | 0;
  } while ((i11 | 0) <= (i1 | 0));
  i1 = i13 & -4;
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i18;
  return;
 }
 i5 = i12 + -4 | 0;
 i6 = (i5 | 0) < 0;
 i7 = i12 & -4;
 do {
  i4 = i14 + (Math_imul(i1, i15) | 0) | 0;
  if (i6) i2 = 0; else {
   i2 = i1 * 3 | 0;
   i3 = 0;
   do {
    i10 = i16 + ((Math_imul(i3, i17) | 0) + i2) | 0;
    i11 = i3 | 1;
    i8 = i16 + ((Math_imul(i11, i17) | 0) + i2) | 0;
    i20 = i3 | 2;
    i19 = i16 + ((Math_imul(i20, i17) | 0) + i2) | 0;
    i22 = i3 | 3;
    i21 = i16 + ((Math_imul(i22, i17) | 0) + i2) | 0;
    i9 = i4 + (i3 * 3 | 0) | 0;
    HEAP8[i9 + 0 >> 0] = HEAP8[i10 + 0 >> 0] | 0;
    HEAP8[i9 + 1 >> 0] = HEAP8[i10 + 1 >> 0] | 0;
    HEAP8[i9 + 2 >> 0] = HEAP8[i10 + 2 >> 0] | 0;
    i11 = i4 + (i11 * 3 | 0) | 0;
    HEAP8[i11 + 0 >> 0] = HEAP8[i8 + 0 >> 0] | 0;
    HEAP8[i11 + 1 >> 0] = HEAP8[i8 + 1 >> 0] | 0;
    HEAP8[i11 + 2 >> 0] = HEAP8[i8 + 2 >> 0] | 0;
    i20 = i4 + (i20 * 3 | 0) | 0;
    HEAP8[i20 + 0 >> 0] = HEAP8[i19 + 0 >> 0] | 0;
    HEAP8[i20 + 1 >> 0] = HEAP8[i19 + 1 >> 0] | 0;
    HEAP8[i20 + 2 >> 0] = HEAP8[i19 + 2 >> 0] | 0;
    i22 = i4 + (i22 * 3 | 0) | 0;
    HEAP8[i22 + 0 >> 0] = HEAP8[i21 + 0 >> 0] | 0;
    HEAP8[i22 + 1 >> 0] = HEAP8[i21 + 1 >> 0] | 0;
    HEAP8[i22 + 2 >> 0] = HEAP8[i21 + 2 >> 0] | 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i5 | 0));
   i2 = i7;
  }
  if ((i2 | 0) < (i12 | 0)) {
   i3 = i1 * 3 | 0;
   do {
    i21 = i16 + ((Math_imul(i2, i17) | 0) + i3) | 0;
    i22 = i4 + (i2 * 3 | 0) | 0;
    HEAP8[i22 + 0 >> 0] = HEAP8[i21 + 0 >> 0] | 0;
    HEAP8[i22 + 1 >> 0] = HEAP8[i21 + 1 >> 0] | 0;
    HEAP8[i22 + 2 >> 0] = HEAP8[i21 + 2 >> 0] | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i12 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i18;
 return;
}

function __ZN2cv5eigenERKNS_11_InputArrayERKNS_12_OutputArrayES5_(i2, i18, i6) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 1360 | 0;
 i28 = i29 + 1304 | 0;
 i3 = i29 + 1296 | 0;
 i1 = i29 + 1288 | 0;
 i27 = i29 + 1232 | 0;
 i7 = i29 + 1176 | 0;
 i26 = i29 + 136 | 0;
 i24 = i29 + 80 | 0;
 i19 = i29 + 24 | 0;
 i16 = i29;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i2 >> 2] >> 2] & 63](i28, i2, -1);
 i11 = HEAP32[i28 >> 2] | 0;
 i12 = i11 & 4095;
 i17 = HEAP32[i28 + 8 >> 2] | 0;
 if ((i17 | 0) != (HEAP32[i28 + 12 >> 2] | 0)) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i3, 20) | 0) + 0 | 0;
  i2 = 4248 | 0;
  i5 = i4 + 20 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i4 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 4272, 3856, 1474);
  __ZN2cv6String10deallocateEv(i3);
 }
 i15 = (i12 | 0) == 5;
 if ((i12 + -5 | 0) >>> 0 >= 2) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i1, 32) | 0) + 0 | 0;
  i2 = 3912 | 0;
  i5 = i4 + 32 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i4 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 4272, 3856, 1475);
  __ZN2cv6String10deallocateEv(i1);
 }
 HEAP32[i27 >> 2] = 1124007936;
 i25 = i27 + 4 | 0;
 i3 = i27 + 8 | 0;
 i22 = i27 + 40 | 0;
 i4 = i25 + 0 | 0;
 i5 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i22 >> 2] = i3;
 i23 = i27 + 48 | 0;
 i21 = i27 + 44 | 0;
 HEAP32[i21 >> 2] = i23;
 HEAP32[i27 + 52 >> 2] = 0;
 HEAP32[i23 >> 2] = 0;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 112 >> 2] & 127](i6) | 0) {
  FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i6 >> 2] | 0) + 140 >> 2] & 63](i6, i17, i17, i12, -1, 0, 0);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i6 >> 2] >> 2] & 63](i7, i6, -1);
  __ZN2cv3MataSERKS0_(i27, i7) | 0;
  i3 = i7 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i14 = i2 + 12 | 0, i20 = HEAP32[i14 >> 2] | 0, HEAP32[i14 >> 2] = i20 + -1, (i20 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i7);
  HEAP32[i3 >> 2] = 0;
  i20 = i7 + 16 | 0;
  i3 = i7 + 4 | 0;
  HEAP32[i20 + 0 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  HEAP32[i20 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i7 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i3 = HEAP32[i7 + 44 >> 2] | 0;
  if ((i3 | 0) != (i7 + 48 | 0)) __ZN2cv8fastFreeEPv(i3);
 }
 i20 = i28 + 4 | 0;
 i3 = HEAP32[i20 >> 2] | 0;
 if ((i3 | 0) > 0) i6 = HEAP32[(HEAP32[i28 + 44 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0; else i6 = 0;
 i2 = (Math_imul(i6, i17) | 0) + 15 & -16;
 i5 = Math_imul(i2, i17) | 0;
 i4 = (Math_imul(i17 * 5 | 0, i6) | 0) + 32 + i5 | 0;
 i13 = i26 + 8 | 0;
 HEAP32[i26 >> 2] = i13;
 i14 = i26 + 4 | 0;
 HEAP32[i14 >> 2] = 1032;
 if (i4 >>> 0 > 1032) {
  i3 = __Znaj(i4) | 0;
  HEAP32[i26 >> 2] = i3;
 } else i3 = i13;
 HEAP32[i14 >> 2] = i4;
 i4 = i3 + 15 & -16;
 __ZN2cv3MatC2EiiiPvj(i24, i17, i17, i12, i4, i2);
 i5 = i4 + i5 | 0;
 i8 = i19 + 4 | 0;
 HEAP32[i8 >> 2] = 2;
 i10 = i19 + 8 | 0;
 HEAP32[i10 >> 2] = i17;
 HEAP32[i19 + 12 >> 2] = 1;
 i7 = i19 + 16 | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i19 + 20 >> 2] = i5;
 i5 = i19 + 24 | 0;
 i1 = i19 + 40 | 0;
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = i10;
 i10 = i19 + 48 | 0;
 i9 = i19 + 44 | 0;
 HEAP32[i9 >> 2] = i10;
 i11 = (i11 >>> 3 & 511) + 1 << (47696 >>> (i11 << 1 & 14) & 3);
 HEAP32[i19 >> 2] = i12 | 1124024320;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i19 + 52 >> 2] = i11;
 i12 = i4 + (Math_imul(i17, i11 + i2 | 0) | 0) | 0;
 HEAP32[i19 + 28 >> 2] = i12;
 HEAP32[i5 >> 2] = i12;
 i4 = i4 + (Math_imul(i2 + i6 | 0, i17) | 0) | 0;
 i6 = i16 + 4 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i16 >> 2] = 32232;
 HEAP32[i6 >> 2] = 33619968;
 HEAP32[i16 + 8 >> 2] = i24;
 __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i28, i16);
 i6 = i24 + 16 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 if (i15) __ZN2cv11JacobiImpl_IfEEbPT_jS2_S2_jiPh(i5, HEAP32[i24 + 48 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i27 + 16 >> 2] | 0, HEAP32[i23 >> 2] | 0, i17, i4) | 0; else __ZN2cv11JacobiImpl_IdEEbPT_jS2_S2_jiPh(i5, HEAP32[i24 + 48 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i27 + 16 >> 2] | 0, HEAP32[i23 >> 2] | 0, i17, i4) | 0;
 __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i19, i18);
 i3 = i19 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i17 = i2 + 12 | 0, i18 = HEAP32[i17 >> 2] | 0, HEAP32[i17 >> 2] = i18 + -1, (i18 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i19);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 if ((HEAP32[i8 >> 2] | 0) > 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i8 >> 2] | 0));
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i10 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i24 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i18 = i1 + 12 | 0, i19 = HEAP32[i18 >> 2] | 0, HEAP32[i18 >> 2] = i19 + -1, (i19 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i24);
 HEAP32[i2 >> 2] = 0;
 i3 = i24 + 4 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i24 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i2 = HEAP32[i24 + 44 >> 2] | 0;
 if ((i2 | 0) != (i24 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = HEAP32[i26 >> 2] | 0;
 if ((i2 | 0) != (i13 | 0)) {
  if (i2) __ZdaPv(i2);
  HEAP32[i26 >> 2] = i13;
  HEAP32[i14 >> 2] = 1032;
 }
 i2 = i27 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i18 = i1 + 12 | 0, i19 = HEAP32[i18 >> 2] | 0, HEAP32[i18 >> 2] = i19 + -1, (i19 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i27);
 HEAP32[i2 >> 2] = 0;
 i19 = i27 + 16 | 0;
 HEAP32[i19 + 0 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 if ((HEAP32[i25 >> 2] | 0) > 0) {
  i2 = HEAP32[i22 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i25 >> 2] | 0));
 }
 i1 = HEAP32[i21 >> 2] | 0;
 if ((i1 | 0) != (i23 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i28 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i28);
 HEAP32[i1 >> 2] = 0;
 i22 = i28 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i20 >> 2] | 0) > 0) {
  i2 = HEAP32[i28 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i20 >> 2] | 0));
 }
 i1 = HEAP32[i28 + 44 >> 2] | 0;
 if ((i1 | 0) == (i28 + 48 | 0)) {
  STACKTOP = i29;
  return 1;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i29;
 return 1;
}
function __ZN2cvL15transpose_32sC3EPKhjPhjNS_5Size_IiEE(i16, i17, i14, i15, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i18 = STACKTOP;
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i13 + -4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i8 = i12 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i12 & -4;
  i11 = 0;
  do {
   i5 = i14 + (Math_imul(i11, i15) | 0) | 0;
   i4 = i14 + (Math_imul(i11 | 1, i15) | 0) | 0;
   i3 = i14 + (Math_imul(i11 | 2, i15) | 0) | 0;
   i2 = i14 + (Math_imul(i11 | 3, i15) | 0) | 0;
   if (i9) i7 = 0; else {
    i7 = i11 * 12 | 0;
    i6 = 0;
    do {
     i26 = (Math_imul(i6, i17) | 0) + i7 | 0;
     i30 = i16 + i26 | 0;
     i23 = i6 | 1;
     i24 = (Math_imul(i23, i17) | 0) + i7 | 0;
     i29 = i16 + i24 | 0;
     i21 = i6 | 2;
     i22 = (Math_imul(i21, i17) | 0) + i7 | 0;
     i28 = i16 + i22 | 0;
     i19 = i6 | 3;
     i20 = (Math_imul(i19, i17) | 0) + i7 | 0;
     i27 = i16 + i20 | 0;
     i25 = i5 + (i6 * 12 | 0) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i30 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
     i25 = i5 + (i23 * 12 | 0) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i29 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
     i25 = i5 + (i21 * 12 | 0) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i28 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
     i25 = i5 + (i19 * 12 | 0) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     i25 = i4 + (i6 * 12 | 0) | 0;
     i27 = i16 + (i26 + 12) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     i25 = i4 + (i23 * 12 | 0) | 0;
     i27 = i16 + (i24 + 12) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     i25 = i4 + (i21 * 12 | 0) | 0;
     i27 = i16 + (i22 + 12) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     i25 = i4 + (i19 * 12 | 0) | 0;
     i27 = i16 + (i20 + 12) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     i25 = i3 + (i6 * 12 | 0) | 0;
     i27 = i16 + (i26 + 24) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     i25 = i3 + (i23 * 12 | 0) | 0;
     i27 = i16 + (i24 + 24) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     i25 = i3 + (i21 * 12 | 0) | 0;
     i27 = i16 + (i22 + 24) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     i25 = i3 + (i19 * 12 | 0) | 0;
     i27 = i16 + (i20 + 24) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i27 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     i25 = i2 + (i6 * 12 | 0) | 0;
     i26 = i16 + (i26 + 36) | 0;
     HEAP32[i25 + 0 >> 2] = HEAP32[i26 + 0 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
     i23 = i2 + (i23 * 12 | 0) | 0;
     i24 = i16 + (i24 + 36) | 0;
     HEAP32[i23 + 0 >> 2] = HEAP32[i24 + 0 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     i21 = i2 + (i21 * 12 | 0) | 0;
     i22 = i16 + (i22 + 36) | 0;
     HEAP32[i21 + 0 >> 2] = HEAP32[i22 + 0 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
     i19 = i2 + (i19 * 12 | 0) | 0;
     i20 = i16 + (i20 + 36) | 0;
     HEAP32[i19 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i8 | 0));
    i7 = i10;
   }
   if ((i7 | 0) < (i12 | 0)) {
    i6 = i11 * 12 | 0;
    do {
     i21 = (Math_imul(i7, i17) | 0) + i6 | 0;
     i20 = i16 + i21 | 0;
     i22 = i5 + (i7 * 12 | 0) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     i22 = i4 + (i7 * 12 | 0) | 0;
     i20 = i16 + (i21 + 12) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     i22 = i3 + (i7 * 12 | 0) | 0;
     i20 = i16 + (i21 + 24) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i20 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     i22 = i2 + (i7 * 12 | 0) | 0;
     i21 = i16 + (i21 + 36) | 0;
     HEAP32[i22 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i12 | 0));
   }
   i11 = i11 + 4 | 0;
  } while ((i11 | 0) <= (i1 | 0));
  i1 = i13 & -4;
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i18;
  return;
 }
 i5 = i12 + -4 | 0;
 i6 = (i5 | 0) < 0;
 i7 = i12 & -4;
 do {
  i4 = i14 + (Math_imul(i1, i15) | 0) | 0;
  if (i6) i2 = 0; else {
   i2 = i1 * 12 | 0;
   i3 = 0;
   do {
    i10 = i16 + ((Math_imul(i3, i17) | 0) + i2) | 0;
    i11 = i3 | 1;
    i8 = i16 + ((Math_imul(i11, i17) | 0) + i2) | 0;
    i20 = i3 | 2;
    i19 = i16 + ((Math_imul(i20, i17) | 0) + i2) | 0;
    i22 = i3 | 3;
    i21 = i16 + ((Math_imul(i22, i17) | 0) + i2) | 0;
    i9 = i4 + (i3 * 12 | 0) | 0;
    HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    i11 = i4 + (i11 * 12 | 0) | 0;
    HEAP32[i11 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    i20 = i4 + (i20 * 12 | 0) | 0;
    HEAP32[i20 + 0 >> 2] = HEAP32[i19 + 0 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    i22 = i4 + (i22 * 12 | 0) | 0;
    HEAP32[i22 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i5 | 0));
   i2 = i7;
  }
  if ((i2 | 0) < (i12 | 0)) {
   i3 = i1 * 12 | 0;
   do {
    i21 = i16 + ((Math_imul(i2, i17) | 0) + i3) | 0;
    i22 = i4 + (i2 * 12 | 0) | 0;
    HEAP32[i22 + 0 >> 2] = HEAP32[i21 + 0 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i12 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i18;
 return;
}

function ___intscan(i12, i1, i8, i13, i14) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 if (i1 >>> 0 > 36) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i9 = 0;
  i10 = 0;
  tempRet0 = i9;
  STACKTOP = i17;
  return i10 | 0;
 }
 i16 = i12 + 4 | 0;
 i15 = i12 + 100 | 0;
 do {
  i2 = HEAP32[i16 >> 2] | 0;
  if (i2 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
   HEAP32[i16 >> 2] = i2 + 1;
   i2 = HEAPU8[i2 >> 0] | 0;
  } else i2 = ___shgetc(i12) | 0;
 } while ((_isspace(i2) | 0) != 0);
 do if ((i2 | 0) == 43 | (i2 | 0) == 45) {
  i4 = ((i2 | 0) == 45) << 31 >> 31;
  i2 = HEAP32[i16 >> 2] | 0;
  if (i2 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
   HEAP32[i16 >> 2] = i2 + 1;
   i2 = HEAPU8[i2 >> 0] | 0;
   i11 = i4;
   break;
  } else {
   i2 = ___shgetc(i12) | 0;
   i11 = i4;
   break;
  }
 } else i11 = 0; while (0);
 i3 = (i1 | 0) == 0;
 do if ((i1 & -17 | 0) == 0 & (i2 | 0) == 48) {
  i4 = HEAP32[i16 >> 2] | 0;
  if (i4 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
   HEAP32[i16 >> 2] = i4 + 1;
   i2 = HEAPU8[i4 >> 0] | 0;
  } else i2 = ___shgetc(i12) | 0;
  if ((i2 | 32 | 0) != 120) if (i3) {
   i1 = 8;
   i10 = 46;
   break;
  } else {
   i10 = 32;
   break;
  }
  i2 = HEAP32[i16 >> 2] | 0;
  if (i2 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
   HEAP32[i16 >> 2] = i2 + 1;
   i2 = HEAPU8[i2 >> 0] | 0;
  } else i2 = ___shgetc(i12) | 0;
  if ((HEAPU8[i2 + 970633 >> 0] | 0) > 15) {
   i1 = (HEAP32[i15 >> 2] | 0) == 0;
   if (!i1) HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
   if (!i8) {
    ___shlim(i12, 0);
    i9 = 0;
    i10 = 0;
    tempRet0 = i9;
    STACKTOP = i17;
    return i10 | 0;
   }
   if (i1) {
    i9 = 0;
    i10 = 0;
    tempRet0 = i9;
    STACKTOP = i17;
    return i10 | 0;
   }
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
   i9 = 0;
   i10 = 0;
   tempRet0 = i9;
   STACKTOP = i17;
   return i10 | 0;
  } else {
   i1 = 16;
   i10 = 46;
  }
 } else {
  i1 = i3 ? 10 : i1;
  if ((HEAPU8[i2 + 970633 >> 0] | 0) >>> 0 < i1 >>> 0) i10 = 32; else {
   if (HEAP32[i15 >> 2] | 0) HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
   ___shlim(i12, 0);
   HEAP32[(___errno_location() | 0) >> 2] = 22;
   i9 = 0;
   i10 = 0;
   tempRet0 = i9;
   STACKTOP = i17;
   return i10 | 0;
  }
 } while (0);
 if ((i10 | 0) == 32) if ((i1 | 0) == 10) {
  i1 = i2 + -48 | 0;
  if (i1 >>> 0 < 10) {
   i4 = 0;
   do {
    i4 = (i4 * 10 | 0) + i1 | 0;
    i2 = HEAP32[i16 >> 2] | 0;
    if (i2 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
     HEAP32[i16 >> 2] = i2 + 1;
     i2 = HEAPU8[i2 >> 0] | 0;
    } else i2 = ___shgetc(i12) | 0;
    i1 = i2 + -48 | 0;
   } while (i1 >>> 0 < 10 & i4 >>> 0 < 429496729);
   i1 = i4;
   i4 = 0;
  } else {
   i1 = 0;
   i4 = 0;
  }
  i3 = i2 + -48 | 0;
  if (i3 >>> 0 < 10) {
   while (1) {
    i5 = ___muldi3(i1 | 0, i4 | 0, 10, 0) | 0;
    i6 = tempRet0;
    i7 = ((i3 | 0) < 0) << 31 >> 31;
    i9 = ~i7;
    if (i6 >>> 0 > i9 >>> 0 | (i6 | 0) == (i9 | 0) & i5 >>> 0 > ~i3 >>> 0) {
     i5 = i1;
     break;
    }
    i1 = _i64Add(i5 | 0, i6 | 0, i3 | 0, i7 | 0) | 0;
    i4 = tempRet0;
    i2 = HEAP32[i16 >> 2] | 0;
    if (i2 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
     HEAP32[i16 >> 2] = i2 + 1;
     i2 = HEAPU8[i2 >> 0] | 0;
    } else i2 = ___shgetc(i12) | 0;
    i3 = i2 + -48 | 0;
    if (!(i3 >>> 0 < 10 & (i4 >>> 0 < 429496729 | (i4 | 0) == 429496729 & i1 >>> 0 < 2576980378))) {
     i5 = i1;
     break;
    }
   }
   if (i3 >>> 0 > 9) i2 = i5; else {
    i1 = 10;
    i10 = 72;
   }
  } else i2 = i1;
 } else i10 = 46;
 L69 : do if ((i10 | 0) == 46) {
  if (!(i1 + -1 & i1)) {
   i10 = HEAP8[970896 + ((i1 * 23 | 0) >>> 5 & 7) >> 0] | 0;
   i4 = HEAP8[i2 + 970633 >> 0] | 0;
   i3 = i4 & 255;
   if (i3 >>> 0 < i1 >>> 0) {
    i5 = 0;
    do {
     i5 = i3 | i5 << i10;
     i4 = HEAP32[i16 >> 2] | 0;
     if (i4 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
      HEAP32[i16 >> 2] = i4 + 1;
      i2 = HEAPU8[i4 >> 0] | 0;
     } else i2 = ___shgetc(i12) | 0;
     i4 = HEAP8[i2 + 970633 >> 0] | 0;
     i3 = i4 & 255;
    } while (i3 >>> 0 < i1 >>> 0 & i5 >>> 0 < 134217728);
    i3 = 0;
   } else {
    i3 = 0;
    i5 = 0;
   }
   i8 = _bitshift64Lshr(-1, -1, i10 | 0) | 0;
   i7 = tempRet0;
   if ((i4 & 255) >>> 0 >= i1 >>> 0 | (i3 >>> 0 > i7 >>> 0 | (i3 | 0) == (i7 | 0) & i5 >>> 0 > i8 >>> 0)) {
    i4 = i3;
    i10 = 72;
    break;
   }
   while (1) {
    i5 = _bitshift64Shl(i5 | 0, i3 | 0, i10 | 0) | 0;
    i3 = tempRet0;
    i5 = i4 & 255 | i5;
    i4 = HEAP32[i16 >> 2] | 0;
    if (i4 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
     HEAP32[i16 >> 2] = i4 + 1;
     i2 = HEAPU8[i4 >> 0] | 0;
    } else i2 = ___shgetc(i12) | 0;
    i4 = HEAP8[i2 + 970633 >> 0] | 0;
    if ((i4 & 255) >>> 0 >= i1 >>> 0 | (i3 >>> 0 > i7 >>> 0 | (i3 | 0) == (i7 | 0) & i5 >>> 0 > i8 >>> 0)) {
     i4 = i3;
     i10 = 72;
     break L69;
    }
   }
  }
  i3 = HEAP8[i2 + 970633 >> 0] | 0;
  i4 = i3 & 255;
  if (i4 >>> 0 < i1 >>> 0) {
   i5 = 0;
   do {
    i5 = i4 + (Math_imul(i5, i1) | 0) | 0;
    i2 = HEAP32[i16 >> 2] | 0;
    if (i2 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
     HEAP32[i16 >> 2] = i2 + 1;
     i2 = HEAPU8[i2 >> 0] | 0;
    } else i2 = ___shgetc(i12) | 0;
    i3 = HEAP8[i2 + 970633 >> 0] | 0;
    i4 = i3 & 255;
   } while (i4 >>> 0 < i1 >>> 0 & i5 >>> 0 < 119304647);
   i4 = 0;
  } else {
   i5 = 0;
   i4 = 0;
  }
  if ((i3 & 255) >>> 0 < i1 >>> 0) {
   i9 = ___udivdi3(-1, -1, i1 | 0, 0) | 0;
   i10 = tempRet0;
   while (1) {
    if (i4 >>> 0 > i10 >>> 0 | (i4 | 0) == (i10 | 0) & i5 >>> 0 > i9 >>> 0) {
     i10 = 72;
     break L69;
    }
    i6 = ___muldi3(i5 | 0, i4 | 0, i1 | 0, 0) | 0;
    i8 = tempRet0;
    i7 = i3 & 255;
    if (i8 >>> 0 > 4294967295 | (i8 | 0) == -1 & i6 >>> 0 > ~i7 >>> 0) {
     i10 = 72;
     break L69;
    }
    i5 = _i64Add(i7 | 0, 0, i6 | 0, i8 | 0) | 0;
    i4 = tempRet0;
    i3 = HEAP32[i16 >> 2] | 0;
    if (i3 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
     HEAP32[i16 >> 2] = i3 + 1;
     i2 = HEAPU8[i3 >> 0] | 0;
    } else i2 = ___shgetc(i12) | 0;
    i3 = HEAP8[i2 + 970633 >> 0] | 0;
    if ((i3 & 255) >>> 0 >= i1 >>> 0) {
     i10 = 72;
     break;
    }
   }
  } else i10 = 72;
 } while (0);
 if ((i10 | 0) == 72) if ((HEAPU8[i2 + 970633 >> 0] | 0) >>> 0 < i1 >>> 0) {
  do {
   i2 = HEAP32[i16 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
    HEAP32[i16 >> 2] = i2 + 1;
    i2 = HEAPU8[i2 >> 0] | 0;
   } else i2 = ___shgetc(i12) | 0;
  } while ((HEAPU8[i2 + 970633 >> 0] | 0) >>> 0 < i1 >>> 0);
  HEAP32[(___errno_location() | 0) >> 2] = 34;
  i4 = i14;
  i2 = i13;
 } else i2 = i5;
 if (HEAP32[i15 >> 2] | 0) HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
 if (!(i4 >>> 0 < i14 >>> 0 | (i4 | 0) == (i14 | 0) & i2 >>> 0 < i13 >>> 0)) {
  if (!((i13 & 1 | 0) != 0 | 0 != 0 | (i11 | 0) != 0)) {
   HEAP32[(___errno_location() | 0) >> 2] = 34;
   i10 = _i64Add(i13 | 0, i14 | 0, -1, -1) | 0;
   i9 = tempRet0;
   tempRet0 = i9;
   STACKTOP = i17;
   return i10 | 0;
  }
  if (i4 >>> 0 > i14 >>> 0 | (i4 | 0) == (i14 | 0) & i2 >>> 0 > i13 >>> 0) {
   HEAP32[(___errno_location() | 0) >> 2] = 34;
   i9 = i14;
   i10 = i13;
   tempRet0 = i9;
   STACKTOP = i17;
   return i10 | 0;
  }
 }
 i10 = ((i11 | 0) < 0) << 31 >> 31;
 i10 = _i64Subtract(i2 ^ i11 | 0, i4 ^ i10 | 0, i11 | 0, i10 | 0) | 0;
 i9 = tempRet0;
 tempRet0 = i9;
 STACKTOP = i17;
 return i10 | 0;
}

function _deflate_fast(i35, i29) {
 i35 = i35 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0;
 i36 = STACKTOP;
 i12 = i35 + 116 | 0;
 i13 = (i29 | 0) == 0;
 i22 = i35 + 72 | 0;
 i23 = i35 + 88 | 0;
 i32 = i35 + 108 | 0;
 i30 = i35 + 56 | 0;
 i24 = i35 + 84 | 0;
 i25 = i35 + 68 | 0;
 i26 = i35 + 52 | 0;
 i27 = i35 + 64 | 0;
 i14 = i35 + 44 | 0;
 i15 = i35 + 96 | 0;
 i16 = i35 + 112 | 0;
 i28 = i35 + 5792 | 0;
 i17 = i35 + 5796 | 0;
 i18 = i35 + 5784 | 0;
 i19 = i35 + 5788 | 0;
 i20 = i35 + 128 | 0;
 i31 = i35 + 92 | 0;
 while (1) {
  if ((HEAP32[i12 >> 2] | 0) >>> 0 < 262) {
   _fill_window(i35);
   i5 = HEAP32[i12 >> 2] | 0;
   if (i5 >>> 0 < 262 & i13) {
    i1 = 0;
    i4 = 41;
    break;
   }
   if (!i5) {
    i4 = 26;
    break;
   }
   if (i5 >>> 0 <= 2) i4 = 9; else i4 = 6;
  } else i4 = 6;
  if ((i4 | 0) == 6) {
   i4 = 0;
   i11 = HEAP32[i32 >> 2] | 0;
   i2 = ((HEAPU8[(HEAP32[i30 >> 2] | 0) + (i11 + 2) >> 0] | 0) ^ HEAP32[i22 >> 2] << HEAP32[i23 >> 2]) & HEAP32[i24 >> 2];
   HEAP32[i22 >> 2] = i2;
   i2 = (HEAP32[i25 >> 2] | 0) + (i2 << 1) | 0;
   i1 = HEAP16[i2 >> 1] | 0;
   HEAP16[(HEAP32[i27 >> 2] | 0) + ((HEAP32[i26 >> 2] & i11) << 1) >> 1] = i1;
   i5 = i1 & 65535;
   HEAP16[i2 >> 1] = i11;
   if (i1 << 16 >> 16 != 0 ? (i11 - i5 | 0) >>> 0 <= ((HEAP32[i14 >> 2] | 0) + -262 | 0) >>> 0 : 0) {
    i5 = _longest_match(i35, i5) | 0;
    HEAP32[i15 >> 2] = i5;
   } else i4 = 9;
  }
  if ((i4 | 0) == 9) i5 = HEAP32[i15 >> 2] | 0;
  do if (i5 >>> 0 > 2) {
   i11 = i5 + 253 | 0;
   i5 = (HEAP32[i32 >> 2] | 0) - (HEAP32[i16 >> 2] | 0) | 0;
   i1 = HEAP32[i28 >> 2] | 0;
   HEAP16[(HEAP32[i17 >> 2] | 0) + (i1 << 1) >> 1] = i5;
   HEAP32[i28 >> 2] = i1 + 1;
   HEAP8[(HEAP32[i18 >> 2] | 0) + i1 >> 0] = i11;
   i11 = i35 + ((HEAPU8[155648 + (i11 & 255) >> 0] | 0 | 256) + 1 << 2) + 148 | 0;
   HEAP16[i11 >> 1] = (HEAP16[i11 >> 1] | 0) + 1 << 16 >> 16;
   i5 = i5 + 65535 & 65535;
   if (i5 >>> 0 >= 256) i5 = (i5 >>> 7) + 256 | 0;
   i11 = i35 + ((HEAPU8[155136 + i5 >> 0] | 0) << 2) + 2440 | 0;
   HEAP16[i11 >> 1] = (HEAP16[i11 >> 1] | 0) + 1 << 16 >> 16;
   i11 = (HEAP32[i28 >> 2] | 0) == ((HEAP32[i19 >> 2] | 0) + -1 | 0) & 1;
   i5 = HEAP32[i15 >> 2] | 0;
   i1 = (HEAP32[i12 >> 2] | 0) - i5 | 0;
   HEAP32[i12 >> 2] = i1;
   if (!(i1 >>> 0 > 2 ? i5 >>> 0 <= (HEAP32[i20 >> 2] | 0) >>> 0 : 0)) {
    i3 = (HEAP32[i32 >> 2] | 0) + i5 | 0;
    HEAP32[i32 >> 2] = i3;
    HEAP32[i15 >> 2] = 0;
    i1 = HEAP32[i30 >> 2] | 0;
    i5 = HEAPU8[i1 + i3 >> 0] | 0;
    HEAP32[i22 >> 2] = i5;
    HEAP32[i22 >> 2] = ((HEAPU8[i1 + (i3 + 1) >> 0] | 0) ^ i5 << HEAP32[i23 >> 2]) & HEAP32[i24 >> 2];
    i5 = i11;
    break;
   }
   i7 = i5 + -1 | 0;
   HEAP32[i15 >> 2] = i7;
   i5 = HEAP32[i23 >> 2] | 0;
   i4 = HEAP32[i30 >> 2] | 0;
   i3 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i25 >> 2] | 0;
   i1 = HEAP32[i26 >> 2] | 0;
   i6 = HEAP32[i27 >> 2] | 0;
   i9 = HEAP32[i32 >> 2] | 0;
   i10 = HEAP32[i22 >> 2] | 0;
   while (1) {
    i8 = i9 + 1 | 0;
    HEAP32[i32 >> 2] = i8;
    i10 = ((HEAPU8[i4 + (i9 + 3) >> 0] | 0) ^ i10 << i5) & i3;
    HEAP32[i22 >> 2] = i10;
    i37 = i2 + (i10 << 1) | 0;
    HEAP16[i6 + ((i1 & i8) << 1) >> 1] = HEAP16[i37 >> 1] | 0;
    HEAP16[i37 >> 1] = i8;
    i7 = i7 + -1 | 0;
    HEAP32[i15 >> 2] = i7;
    if (!i7) break; else i9 = i8;
   }
   i3 = i9 + 2 | 0;
   HEAP32[i32 >> 2] = i3;
   i5 = i11;
  } else {
   i5 = HEAP8[(HEAP32[i30 >> 2] | 0) + (HEAP32[i32 >> 2] | 0) >> 0] | 0;
   i3 = HEAP32[i28 >> 2] | 0;
   HEAP16[(HEAP32[i17 >> 2] | 0) + (i3 << 1) >> 1] = 0;
   HEAP32[i28 >> 2] = i3 + 1;
   HEAP8[(HEAP32[i18 >> 2] | 0) + i3 >> 0] = i5;
   i5 = i35 + ((i5 & 255) << 2) + 148 | 0;
   HEAP16[i5 >> 1] = (HEAP16[i5 >> 1] | 0) + 1 << 16 >> 16;
   i5 = (HEAP32[i28 >> 2] | 0) == ((HEAP32[i19 >> 2] | 0) + -1 | 0) & 1;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
   i3 = (HEAP32[i32 >> 2] | 0) + 1 | 0;
   HEAP32[i32 >> 2] = i3;
  } while (0);
  if (!i5) continue;
  i5 = HEAP32[i31 >> 2] | 0;
  if ((i5 | 0) > -1) i4 = (HEAP32[i30 >> 2] | 0) + i5 | 0; else i4 = 0;
  __tr_flush_block(i35, i4, i3 - i5 | 0, 0);
  HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
  i4 = HEAP32[i35 >> 2] | 0;
  i3 = HEAP32[i4 + 28 >> 2] | 0;
  __tr_flush_bits(i3);
  i2 = i3 + 20 | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  i1 = i4 + 16 | 0;
  i11 = HEAP32[i1 >> 2] | 0;
  i5 = i5 >>> 0 > i11 >>> 0 ? i11 : i5;
  if ((i5 | 0) != 0 ? (i11 = i4 + 12 | 0, i21 = i3 + 16 | 0, _memcpy(HEAP32[i11 >> 2] | 0, HEAP32[i21 >> 2] | 0, i5 | 0) | 0, HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i5, HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + i5, i11 = i4 + 20 | 0, HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i5, HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - i5, i11 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i11 - i5, (i11 | 0) == (i5 | 0)) : 0) HEAP32[i21 >> 2] = HEAP32[i3 + 8 >> 2];
  if (!(HEAP32[(HEAP32[i35 >> 2] | 0) + 16 >> 2] | 0)) {
   i1 = 0;
   i4 = 41;
   break;
  }
 }
 if ((i4 | 0) == 26) {
  i3 = HEAP32[i32 >> 2] | 0;
  HEAP32[i35 + 5812 >> 2] = i3 >>> 0 < 2 ? i3 : 2;
  if ((i29 | 0) == 4) {
   i5 = HEAP32[i31 >> 2] | 0;
   if ((i5 | 0) > -1) i1 = (HEAP32[i30 >> 2] | 0) + i5 | 0; else i1 = 0;
   __tr_flush_block(i35, i1, i3 - i5 | 0, 1);
   HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
   i2 = HEAP32[i35 >> 2] | 0;
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   __tr_flush_bits(i3);
   i4 = i3 + 20 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i5 = i2 + 16 | 0;
   i22 = HEAP32[i5 >> 2] | 0;
   i1 = i1 >>> 0 > i22 >>> 0 ? i22 : i1;
   if ((i1 | 0) != 0 ? (i22 = i2 + 12 | 0, i33 = i3 + 16 | 0, _memcpy(HEAP32[i22 >> 2] | 0, HEAP32[i33 >> 2] | 0, i1 | 0) | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i1, HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + i1, i22 = i2 + 20 | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i1, HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i1, i22 = HEAP32[i4 >> 2] | 0, HEAP32[i4 >> 2] = i22 - i1, (i22 | 0) == (i1 | 0)) : 0) HEAP32[i33 >> 2] = HEAP32[i3 + 8 >> 2];
   i22 = (HEAP32[(HEAP32[i35 >> 2] | 0) + 16 >> 2] | 0) == 0 ? 2 : 3;
   STACKTOP = i36;
   return i22 | 0;
  }
  if (HEAP32[i28 >> 2] | 0) {
   i4 = HEAP32[i31 >> 2] | 0;
   if ((i4 | 0) > -1) i5 = (HEAP32[i30 >> 2] | 0) + i4 | 0; else i5 = 0;
   __tr_flush_block(i35, i5, i3 - i4 | 0, 0);
   HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
   i5 = HEAP32[i35 >> 2] | 0;
   i4 = HEAP32[i5 + 28 >> 2] | 0;
   __tr_flush_bits(i4);
   i3 = i4 + 20 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = i5 + 16 | 0;
   i22 = HEAP32[i2 >> 2] | 0;
   i1 = i1 >>> 0 > i22 >>> 0 ? i22 : i1;
   if ((i1 | 0) != 0 ? (i22 = i5 + 12 | 0, i34 = i4 + 16 | 0, _memcpy(HEAP32[i22 >> 2] | 0, HEAP32[i34 >> 2] | 0, i1 | 0) | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i1, HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i1, i22 = i5 + 20 | 0, HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i1, HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - i1, i22 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i22 - i1, (i22 | 0) == (i1 | 0)) : 0) HEAP32[i34 >> 2] = HEAP32[i4 + 8 >> 2];
   if (!(HEAP32[(HEAP32[i35 >> 2] | 0) + 16 >> 2] | 0)) {
    i22 = 0;
    STACKTOP = i36;
    return i22 | 0;
   }
  }
  i22 = 1;
  STACKTOP = i36;
  return i22 | 0;
 } else if ((i4 | 0) == 41) {
  STACKTOP = i36;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__16__sortIRNS_6__lessIN2cv6StringES3_EEPS3_EEvT0_S7_T_(i2, i1, i17) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 L1 : while (1) {
  i12 = i1;
  i15 = i1 + -8 | 0;
  i13 = i1 + -16 | 0;
  i16 = i1 + -4 | 0;
  i14 = i2;
  L3 : while (1) {
   i11 = i14;
   i2 = i12 - i11 | 0;
   i4 = i2 >> 3;
   switch (i4 | 0) {
   case 3:
    {
     i20 = 7;
     break L1;
    }
   case 5:
    {
     i20 = 9;
     break L1;
    }
   case 4:
    {
     i20 = 8;
     break L1;
    }
   case 2:
    {
     i20 = 4;
     break L1;
    }
   case 1:
   case 0:
    {
     i20 = 60;
     break L1;
    }
   default:
    {}
   }
   if ((i2 | 0) < 56) {
    i20 = 11;
    break L1;
   }
   i3 = (i4 | 0) / 2 | 0;
   i10 = i14 + (i3 << 3) | 0;
   if ((i2 | 0) > 7992) {
    i2 = (i4 | 0) / 4 | 0;
    i2 = __ZNSt3__17__sort5IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i14, i14 + (i2 << 3) | 0, i10, i14 + (i2 + i3 << 3) | 0, i15, i17) | 0;
   } else i2 = __ZNSt3__17__sort3IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_T_(i14, i10, i15, i17) | 0;
   i9 = HEAP32[i14 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   if ((i9 | 0) != (i4 | 0) ? (_strcmp((i9 | 0) == 0 ? 6176 : i9, (i4 | 0) == 0 ? 6176 : i4) | 0) < 0 : 0) i3 = i15; else i20 = 17;
   L13 : do if ((i20 | 0) == 17) {
    i20 = 0;
    L15 : do if ((i14 | 0) != (i13 | 0)) {
     i6 = (i4 | 0) == 0 ? 6176 : i4;
     i3 = i13;
     i7 = i15;
     while (1) {
      i8 = HEAP32[i3 >> 2] | 0;
      if ((i8 | 0) != (i4 | 0) ? (_strcmp((i8 | 0) == 0 ? 6176 : i8, i6) | 0) < 0 : 0) break;
      i5 = i3 + -8 | 0;
      if ((i14 | 0) == (i5 | 0)) break L15; else {
       i7 = i3;
       i3 = i5;
      }
     }
     HEAP32[i14 >> 2] = i8;
     HEAP32[i3 >> 2] = i9;
     i6 = i14 + 4 | 0;
     i9 = i7 + -4 | 0;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i9 >> 2] = i8;
     i2 = i2 + 1 | 0;
     break L13;
    } while (0);
    i2 = i14 + 8 | 0;
    i5 = HEAP32[i15 >> 2] | 0;
    if (!((i9 | 0) != (i5 | 0) ? (_strcmp((i9 | 0) == 0 ? 6176 : i9, (i5 | 0) == 0 ? 6176 : i5) | 0) < 0 : 0)) {
     if ((i2 | 0) == (i15 | 0)) {
      i20 = 60;
      break L1;
     }
     i3 = (i9 | 0) == 0 ? 6176 : i9;
     while (1) {
      i4 = HEAP32[i2 >> 2] | 0;
      if ((i9 | 0) != (i4 | 0) ? (_strcmp(i3, (i4 | 0) == 0 ? 6176 : i4) | 0) < 0 : 0) break;
      i2 = i2 + 8 | 0;
      if ((i2 | 0) == (i15 | 0)) {
       i20 = 60;
       break L1;
      }
     }
     HEAP32[i2 >> 2] = i5;
     HEAP32[i15 >> 2] = i4;
     i9 = i2 + 4 | 0;
     i10 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i16 >> 2] = i10;
     i2 = i2 + 8 | 0;
    }
    if ((i2 | 0) == (i15 | 0)) {
     i20 = 60;
     break L1;
    } else i4 = i15;
    while (1) {
     i8 = HEAP32[i14 >> 2] | 0;
     i7 = (i8 | 0) == 0 ? 6176 : i8;
     while (1) {
      i6 = HEAP32[i2 >> 2] | 0;
      if ((i8 | 0) != (i6 | 0) ? (_strcmp(i7, (i6 | 0) == 0 ? 6176 : i6) | 0) < 0 : 0) {
       i3 = i4;
       break;
      }
      i2 = i2 + 8 | 0;
     }
     while (1) {
      i4 = i3 + -8 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      if ((i8 | 0) == (i5 | 0)) break;
      if ((_strcmp(i7, (i5 | 0) == 0 ? 6176 : i5) | 0) < 0) i3 = i4; else break;
     }
     if (i2 >>> 0 >= i4 >>> 0) {
      i14 = i2;
      continue L3;
     }
     HEAP32[i2 >> 2] = i5;
     HEAP32[i4 >> 2] = i6;
     i8 = i2 + 4 | 0;
     i10 = i3 + -4 | 0;
     i9 = HEAP32[i8 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i10 >> 2] = i9;
     i2 = i2 + 8 | 0;
    }
   } while (0);
   i4 = i14 + 8 | 0;
   L49 : do if (i4 >>> 0 < i3 >>> 0) {
    i7 = i3;
    i3 = i10;
    while (1) {
     i6 = HEAP32[i4 >> 2] | 0;
     i9 = HEAP32[i3 >> 2] | 0;
     L52 : do if ((i6 | 0) == (i9 | 0)) i5 = i4; else while (1) {
      i5 = i4 + 8 | 0;
      if ((_strcmp((i6 | 0) == 0 ? 6176 : i6, (i9 | 0) == 0 ? 6176 : i9) | 0) >= 0) {
       i5 = i4;
       i6 = i9;
       break L52;
      }
      i6 = HEAP32[i5 >> 2] | 0;
      if ((i6 | 0) == (i9 | 0)) {
       i6 = i9;
       break;
      } else i4 = i5;
     } while (0);
     i4 = (i6 | 0) == 0 ? 6176 : i6;
     while (1) {
      i9 = i7 + -8 | 0;
      i8 = HEAP32[i9 >> 2] | 0;
      if ((i8 | 0) == (i6 | 0)) {
       i7 = i9;
       continue;
      }
      if ((_strcmp((i8 | 0) == 0 ? 6176 : i8, i4) | 0) < 0) break; else i7 = i9;
     }
     if (i5 >>> 0 > i9 >>> 0) {
      i4 = i5;
      break L49;
     }
     i10 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = i8;
     HEAP32[i9 >> 2] = i10;
     i10 = i5 + 4 | 0;
     i4 = i7 + -4 | 0;
     i7 = HEAP32[i10 >> 2] | 0;
     HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i7;
     i4 = i5 + 8 | 0;
     i7 = i9;
     i3 = (i3 | 0) == (i5 | 0) ? i9 : i3;
     i2 = i2 + 1 | 0;
    }
   } else i3 = i10; while (0);
   if (((i4 | 0) != (i3 | 0) ? (i18 = HEAP32[i3 >> 2] | 0, i19 = HEAP32[i4 >> 2] | 0, (i18 | 0) != (i19 | 0)) : 0) ? (_strcmp((i18 | 0) == 0 ? 6176 : i18, (i19 | 0) == 0 ? 6176 : i19) | 0) < 0 : 0) {
    HEAP32[i4 >> 2] = i18;
    HEAP32[i3 >> 2] = i19;
    i8 = i4 + 4 | 0;
    i10 = i3 + 4 | 0;
    i9 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i10 >> 2] = i9;
    i2 = i2 + 1 | 0;
   }
   if (!i2) {
    i2 = __ZNSt3__127__insertion_sort_incompleteIRNS_6__lessIN2cv6StringES3_EEPS3_EEbT0_S7_T_(i14, i4, i17) | 0;
    i3 = i4 + 8 | 0;
    if (__ZNSt3__127__insertion_sort_incompleteIRNS_6__lessIN2cv6StringES3_EEPS3_EEbT0_S7_T_(i3, i1, i17) | 0) {
     i20 = 55;
     break;
    }
    if (i2) {
     i14 = i3;
     continue;
    }
   }
   i10 = i4;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i20 = 59;
    break;
   }
   __ZNSt3__16__sortIRNS_6__lessIN2cv6StringES3_EEPS3_EEvT0_S7_T_(i14, i4, i17);
   i14 = i4 + 8 | 0;
  }
  if ((i20 | 0) == 55) {
   i20 = 0;
   if (i2) {
    i20 = 60;
    break;
   } else {
    i2 = i14;
    i1 = i4;
    continue;
   }
  } else if ((i20 | 0) == 59) {
   i20 = 0;
   __ZNSt3__16__sortIRNS_6__lessIN2cv6StringES3_EEPS3_EEvT0_S7_T_(i4 + 8 | 0, i1, i17);
   i2 = i14;
   i1 = i4;
   continue;
  }
 }
 if ((i20 | 0) == 4) {
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   STACKTOP = i21;
   return;
  }
  if ((_strcmp((i1 | 0) == 0 ? 6176 : i1, (i2 | 0) == 0 ? 6176 : i2) | 0) >= 0) {
   STACKTOP = i21;
   return;
  }
  HEAP32[i14 >> 2] = i1;
  HEAP32[i15 >> 2] = i2;
  i9 = i14 + 4 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i16 >> 2] = i10;
  STACKTOP = i21;
  return;
 } else if ((i20 | 0) == 7) {
  __ZNSt3__17__sort3IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_T_(i14, i14 + 8 | 0, i15, i17) | 0;
  STACKTOP = i21;
  return;
 } else if ((i20 | 0) == 8) {
  __ZNSt3__17__sort4IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_S7_T_(i14, i14 + 8 | 0, i14 + 16 | 0, i15, i17) | 0;
  STACKTOP = i21;
  return;
 } else if ((i20 | 0) == 9) {
  __ZNSt3__17__sort5IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i14, i14 + 8 | 0, i14 + 16 | 0, i14 + 24 | 0, i15, i17) | 0;
  STACKTOP = i21;
  return;
 } else if ((i20 | 0) == 11) {
  __ZNSt3__118__insertion_sort_3IRNS_6__lessIN2cv6StringES3_EEPS3_EEvT0_S7_T_(i14, i1, i17);
  STACKTOP = i21;
  return;
 } else if ((i20 | 0) == 60) {
  STACKTOP = i21;
  return;
 }
}

function _cvGetMat(i17, i1, i18, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i5 = i20 + 64 | 0;
 i6 = i20 + 56 | 0;
 i8 = i20 + 48 | 0;
 i11 = i20 + 40 | 0;
 i16 = i20 + 32 | 0;
 i12 = i20 + 24 | 0;
 i9 = i20 + 16 | 0;
 i10 = i20 + 8 | 0;
 i7 = i20;
 i4 = (i17 | 0) != 0;
 if (!((i1 | 0) != 0 & i4)) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i13 = (__ZN2cv6String8allocateEj(i5, 28) | 0) + 0 | 0;
  i14 = 42568 | 0;
  i15 = i13 + 28 | 0;
  do {
   HEAP8[i13 >> 0] = HEAP8[i14 >> 0] | 0;
   i13 = i13 + 1 | 0;
   i14 = i14 + 1 | 0;
  } while ((i13 | 0) < (i15 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i5, 42600, 40912, 2389);
  __ZN2cv6String10deallocateEv(i5);
 }
 do if (i4) {
  i3 = HEAP32[i17 >> 2] | 0;
  i4 = i3 & -65536;
  if (((i4 | 0) == 1111621632 ? (HEAP32[i17 + 24 >> 2] | 0) > 0 : 0) ? (HEAP32[i17 + 20 >> 2] | 0) > 0 : 0) {
   if (HEAP32[i17 + 16 >> 2] | 0) {
    i2 = 0;
    i1 = i17;
    break;
   }
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   i13 = (__ZN2cv6String8allocateEj(i6, 32) | 0) + 0 | 0;
   i14 = 42616 | 0;
   i15 = i13 + 32 | 0;
   do {
    HEAP8[i13 >> 0] = HEAP8[i14 >> 0] | 0;
    i13 = i13 + 1 | 0;
    i14 = i14 + 1 | 0;
   } while ((i13 | 0) < (i15 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i6, 42600, 40912, 2394);
   __ZN2cv6String10deallocateEv(i6);
   i2 = 0;
   i1 = i17;
   break;
  }
  if ((i3 | 0) != 112) {
   if (!((i2 | 0) != 0 & (i4 | 0) == 1111687168)) {
    i19 = 34;
    break;
   }
   i5 = i17 + 20 | 0;
   i7 = HEAP32[i5 >> 2] | 0;
   i6 = i17 + 16 | 0;
   if (!(HEAP32[i6 >> 2] | 0)) {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    i13 = (__ZN2cv6String8allocateEj(i9, 33) | 0) + 0 | 0;
    i14 = 42864 | 0;
    i15 = i13 + 33 | 0;
    do {
     HEAP8[i13 >> 0] = HEAP8[i14 >> 0] | 0;
     i13 = i13 + 1 | 0;
     i14 = i14 + 1 | 0;
    } while ((i13 | 0) < (i15 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i9, 42600, 40912, 2465);
    __ZN2cv6String10deallocateEv(i9);
    i3 = HEAP32[i17 >> 2] | 0;
   }
   if (!(i3 & 16384)) {
    HEAP32[i10 >> 2] = 0;
    HEAP32[i10 + 4 >> 2] = 0;
    i13 = (__ZN2cv6String8allocateEj(i10, 44) | 0) + 0 | 0;
    i14 = 42320 | 0;
    i15 = i13 + 44 | 0;
    do {
     HEAP8[i13 >> 0] = HEAP8[i14 >> 0] | 0;
     i13 = i13 + 1 | 0;
     i14 = i14 + 1 | 0;
    } while ((i13 | 0) < (i15 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i10, 42600, 40912, 2468);
    __ZN2cv6String10deallocateEv(i10);
   }
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   if ((i2 | 0) <= 2) if ((i2 | 0) == 1) i3 = 1; else i3 = HEAP32[i17 + 28 >> 2] | 0; else {
    i4 = 1;
    i3 = 1;
    do {
     i3 = Math_imul(HEAP32[i5 + (i4 << 3) >> 2] | 0, i3) | 0;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) < (i2 | 0));
   }
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i1 + 20 >> 2] = i7;
   HEAP32[i1 + 24 >> 2] = i3;
   i10 = HEAP32[i17 >> 2] | 0;
   i2 = i10 & 4095;
   HEAP32[i1 >> 2] = i2 | 1111638016;
   i10 = Math_imul((i10 >>> 3 & 511) + 1 << (47696 >>> (i10 << 1 & 14) & 3), i3) | 0;
   i10 = (i7 | 0) > 1 ? i10 : 0;
   HEAP32[i1 + 4 >> 2] = i10;
   i10 = ___muldi3(i10 | 0, ((i10 | 0) < 0) << 31 >> 31 | 0, i7 | 0, ((i7 | 0) < 0) << 31 >> 31 | 0) | 0;
   i9 = tempRet0;
   if (!((i9 | 0) > 0 | (i9 | 0) == 0 & i10 >>> 0 > 2147483647)) {
    i2 = 0;
    break;
   }
   HEAP32[i1 >> 2] = i2 | 1111621632;
   i2 = 0;
   break;
  }
  i10 = i17 + 68 | 0;
  if (!(HEAP32[i10 >> 2] | 0)) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i13 = (__ZN2cv6String8allocateEj(i8, 31) | 0) + 0 | 0;
   i14 = 42656 | 0;
   i15 = i13 + 31 | 0;
   do {
    HEAP8[i13 >> 0] = HEAP8[i14 >> 0] | 0;
    i13 = i13 + 1 | 0;
    i14 = i14 + 1 | 0;
   } while ((i13 | 0) < (i15 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i8, 42600, 40912, 2404);
   __ZN2cv6String10deallocateEv(i8);
  }
  i9 = HEAP32[i17 + 16 >> 2] | 0;
  i9 = 1125516576 >>> ((i9 >>> 2 & 60) + (i9 >> 31 & 20) | 0);
  i7 = i9 & 15;
  i3 = HEAP32[i17 + 8 >> 2] | 0;
  i4 = (i3 | 0) > 1 ? HEAP32[i17 + 28 >> 2] | 0 : 0;
  i8 = i17 + 48 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  if (!i6) {
   i3 = i9 & 7 | (i3 << 3) + -8;
   if (i4) {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    i13 = (__ZN2cv6String8allocateEj(i12, 40) | 0) + 0 | 0;
    i14 = 42816 | 0;
    i15 = i13 + 40 | 0;
    do {
     HEAP8[i13 >> 0] = HEAP8[i14 >> 0] | 0;
     i13 = i13 + 1 | 0;
     i14 = i14 + 1 | 0;
    } while ((i13 | 0) < (i15 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-206, i12, 42600, 40912, 2450);
    __ZN2cv6String10deallocateEv(i12);
   }
   _cvInitMatHeader(i1, HEAP32[i17 + 44 >> 2] | 0, HEAP32[i17 + 40 >> 2] | 0, i3, HEAP32[i10 >> 2] | 0, HEAP32[i17 + 72 >> 2] | 0) | 0;
   i2 = 0;
   break;
  }
  if ((i4 | 0) == 1) {
   i3 = HEAP32[i6 >> 2] | 0;
   if (!i3) {
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    i13 = (__ZN2cv6String8allocateEj(i11, 63) | 0) + 0 | 0;
    i14 = 42688 | 0;
    i15 = i13 + 63 | 0;
    do {
     HEAP8[i13 >> 0] = HEAP8[i14 >> 0] | 0;
     i13 = i13 + 1 | 0;
     i14 = i14 + 1 | 0;
    } while ((i13 | 0) < (i15 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-206, i11, 42600, 40912, 2420);
    __ZN2cv6String10deallocateEv(i11);
    i3 = HEAP32[i8 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 >> 2] | 0;
   } else i2 = i6;
   i6 = Math_imul(i3 + -1 | 0, HEAP32[i17 + 64 >> 2] | 0) | 0;
   i8 = HEAP32[i17 + 72 >> 2] | 0;
   i6 = (Math_imul(i8, HEAP32[i2 + 8 >> 2] | 0) | 0) + i6 | 0;
   _cvInitMatHeader(i1, HEAP32[i2 + 16 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0, i7, (HEAP32[i10 >> 2] | 0) + (i6 + (Math_imul(HEAP32[i2 + 4 >> 2] | 0, (i9 >>> 3 & 1) + 1 << (47696 >>> (i9 << 1 & 14) & 3)) | 0)) | 0, i8) | 0;
   i2 = 0;
   break;
  } else {
   i4 = (i3 << 3) + -8 | 0;
   i5 = i9 & 7 | i4;
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i3 | 0) > 512) {
    HEAP32[i16 >> 2] = 0;
    HEAP32[i16 + 4 >> 2] = 0;
    i13 = (__ZN2cv6String8allocateEj(i16, 56) | 0) + 0 | 0;
    i14 = 42752 | 0;
    i15 = i13 + 56 | 0;
    do {
     HEAP8[i13 >> 0] = HEAP8[i14 >> 0] | 0;
     i13 = i13 + 1 | 0;
     i14 = i14 + 1 | 0;
    } while ((i13 | 0) < (i15 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-15, i16, 42600, 40912, 2436);
    __ZN2cv6String10deallocateEv(i16);
    i3 = HEAP32[i8 >> 2] | 0;
   } else i3 = i6;
   i8 = HEAP32[i17 + 72 >> 2] | 0;
   i7 = Math_imul(i8, HEAP32[i3 + 8 >> 2] | 0) | 0;
   _cvInitMatHeader(i1, HEAP32[i3 + 16 >> 2] | 0, HEAP32[i3 + 12 >> 2] | 0, i5, (HEAP32[i10 >> 2] | 0) + ((Math_imul(HEAP32[i3 + 4 >> 2] | 0, (i4 >>> 3 & 511) + 1 << (47696 >>> (i9 << 1 & 14) & 3)) | 0) + i7) | 0, i8) | 0;
   break;
  }
 } else i19 = 34; while (0);
 if ((i19 | 0) == 34) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i13 = (__ZN2cv6String8allocateEj(i7, 38) | 0) + 0 | 0;
  i14 = 42904 | 0;
  i15 = i13 + 38 | 0;
  do {
   HEAP8[i13 >> 0] = HEAP8[i14 >> 0] | 0;
   i13 = i13 + 1 | 0;
   i14 = i14 + 1 | 0;
  } while ((i13 | 0) < (i15 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-206, i7, 42600, 40912, 2489);
  __ZN2cv6String10deallocateEv(i7);
  i2 = 0;
  i1 = 0;
 }
 if (!i18) {
  STACKTOP = i20;
  return i1 | 0;
 }
 HEAP32[i18 >> 2] = i2;
 STACKTOP = i20;
 return i1 | 0;
}

function __ZN2cv10PxMEncoder5writeERKNS_3MatERKNSt3__16vectorIiNS4_9allocatorIiEEEE(i8, i18, i2) {
 i8 = i8 | 0;
 i18 = i18 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 1120 | 0;
 i31 = i40;
 i39 = i40 + 1072 | 0;
 i38 = i40 + 32 | 0;
 i32 = i40 + 24 | 0;
 i33 = i40 + 16 | 0;
 i36 = HEAP32[i18 + 12 >> 2] | 0;
 i37 = HEAP32[i18 + 8 >> 2] | 0;
 i12 = HEAP32[i18 >> 2] | 0;
 i11 = i12 >>> 3 & 511;
 i23 = i11 + 1 | 0;
 i12 = 1212424721 >>> (i12 << 2 & 28) << 3 & 120;
 i34 = i23 >>> 0 > 1;
 i35 = i34 ? 3 : 1;
 i10 = i18 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) > 0) i1 = HEAP32[(HEAP32[i18 + 44 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0; else i1 = 0;
 i30 = Math_imul(i1, i36) | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) i29 = 1; else {
  i1 = i1 - i4 >> 2;
  i3 = 0;
  i2 = 1;
  do {
   if ((HEAP32[i4 + (i3 << 2) >> 2] | 0) == 32) i2 = (HEAP32[i4 + ((i3 | 1) << 2) >> 2] | 0) != 0;
   i3 = i3 + 2 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  i29 = i2;
 }
 __ZN2cv11WBaseStreamC2Ev(i39);
 HEAP32[i39 >> 2] = 181080;
 i2 = i8 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  if (!(FUNCTION_TABLE_iii[HEAP32[181072 + 16 >> 2] & 127](i39, i8 + 12 | 0) | 0)) {
   i22 = 0;
   __ZN2cv11WBaseStreamD2Ev(i39);
   STACKTOP = i40;
   return i22 | 0;
  }
 } else {
  if (!(FUNCTION_TABLE_iii[HEAP32[181072 + 20 >> 2] & 127](i39, i1) | 0)) {
   i22 = 0;
   __ZN2cv11WBaseStreamD2Ev(i39);
   STACKTOP = i40;
   return i22 | 0;
  }
  i1 = HEAP32[i18 >> 2] & 7 | (i35 << 3) + -8;
  i9 = HEAP32[i2 >> 2] | 0;
  if (i29) i1 = i30; else {
   if (i1) if ((i1 | 0) == 16) i1 = 14; else i1 = (i1 | 0) == 2 ? 6 : 20; else i1 = 4;
   i1 = Math_imul(i1, i36) | 0 | 1;
  }
  i6 = (Math_imul(i1, i37) | 0) + 511 & -256;
  i7 = i9 + 8 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = i2;
  if (((HEAP32[i7 >> 2] | 0) - i4 | 0) >>> 0 < i6 >>> 0) {
   i8 = i9 + 4 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i1 = i3 - i4 | 0;
   if (!i6) {
    i5 = 0;
    i4 = i2;
   } else {
    i5 = __Znwj(i6) | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i9 >> 2] | 0;
   }
   i21 = i3 - i4 | 0;
   i22 = i5 + (i1 - i21) | 0;
   _memcpy(i22 | 0, i4 | 0, i21 | 0) | 0;
   HEAP32[i9 >> 2] = i22;
   HEAP32[i8 >> 2] = i5 + i1;
   HEAP32[i7 >> 2] = i5 + i6;
   if (i4) __ZdlPv(i4);
  }
 }
 if (i29) {
  i1 = HEAP32[i10 >> 2] | 0;
  if ((i1 | 0) > 0) i1 = HEAP32[(HEAP32[i18 + 44 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0; else i1 = 0;
  i1 = Math_imul(i1, i36) | 0;
 } else i1 = (Math_imul((i35 * 6 | 0) + (i34 ? 2 : 0) | 0, i36) | 0) + 32 | 0;
 i1 = (i1 | 0) > 128 ? i1 : 128;
 i27 = i38 + 8 | 0;
 HEAP32[i38 >> 2] = i27;
 i28 = i38 + 4 | 0;
 HEAP32[i28 >> 2] = 1032;
 if (i1 >>> 0 > 1032) {
  i26 = __Znaj(i1) | 0;
  HEAP32[i38 >> 2] = i26;
 } else i26 = i27;
 HEAP32[i28 >> 2] = i1;
 HEAP32[i31 >> 2] = (i29 ? 3 : 0) + (i34 & 1 | 50);
 HEAP32[i31 + 4 >> 2] = i36;
 HEAP32[i31 + 8 >> 2] = i37;
 HEAP32[i31 + 12 >> 2] = (1 << i12) + -1;
 _sprintf(i26, 179792, i31) | 0;
 __ZN2cv12WLByteStream8putBytesEPKvi(i39, i26, _strlen(i26 | 0) | 0);
 if ((i37 | 0) > 0) {
  i25 = i18 + 16 | 0;
  i24 = i18 + 44 | 0;
  i19 = (i23 | 0) == 3;
  i20 = (i12 | 0) == 8;
  i21 = i32 + 4 | 0;
  i22 = i33 + 4 | 0;
  i23 = (i12 | 0) == 16;
  i16 = (i11 | 0) == 0;
  i17 = Math_imul(i36 << 1, i35) | 0;
  i18 = (i17 | 0) > 0;
  i12 = i34 | i12 >>> 0 > 8;
  i10 = Math_imul(i35, i36) | 0;
  i2 = (i10 | 0) > 0;
  i1 = i26;
  i11 = (i36 | 0) > 0;
  i13 = i26 + (i36 * 6 | 0) | 0;
  i14 = i26 + (i36 << 2) | 0;
  i15 = 0;
  do {
   i4 = HEAP32[i25 >> 2] | 0;
   i3 = Math_imul(HEAP32[HEAP32[i24 >> 2] >> 2] | 0, i15) | 0;
   i6 = i4 + i3 | 0;
   if (i29) {
    do if (i19) if (i20) {
     HEAP32[i32 >> 2] = i36;
     HEAP32[i21 >> 2] = 1;
     HEAP32[i31 + 0 >> 2] = HEAP32[i32 + 0 >> 2];
     HEAP32[i31 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
     __Z21icvCvt_BGR2RGB_8u_C3RPKhiPhi6CvSize(i6, 0, i26, 0, i31);
     break;
    } else {
     HEAP32[i33 >> 2] = i36;
     HEAP32[i22 >> 2] = 1;
     HEAP32[i31 + 0 >> 2] = HEAP32[i33 + 0 >> 2];
     HEAP32[i31 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
     __Z22icvCvt_BGR2RGB_16u_C3RPKtiPti6CvSize(i6, 0, i26, 0, i31);
     break;
    } while (0);
    if (i23) {
     if (i16) _memcpy(i26 | 0, i6 | 0, i30 | 0) | 0;
     if (i18) {
      i9 = 0;
      do {
       i5 = i26 + i9 | 0;
       i4 = HEAP8[i5 >> 0] | 0;
       i3 = i26 + (i9 | 1) | 0;
       HEAP8[i5 >> 0] = HEAP8[i3 >> 0] | 0;
       HEAP8[i3 >> 0] = i4;
       i9 = i9 + 2 | 0;
      } while ((i9 | 0) < (i17 | 0));
     }
    }
    __ZN2cv12WLByteStream8putBytesEPKvi(i39, i12 ? i26 : i6, i30);
   } else {
    L48 : do if (i34) if (i20) {
     if (!i2) {
      i9 = i26;
      break;
     }
     i8 = i3 + 2 | 0;
     i7 = i3 + 1 | 0;
     i6 = i26;
     i5 = 0;
     while (1) {
      HEAP32[i31 >> 2] = HEAPU8[i4 + (i8 + i5) >> 0];
      _sprintf(i6, 179808, i31) | 0;
      HEAP32[i31 >> 2] = HEAPU8[i4 + (i7 + i5) >> 0];
      _sprintf(i6 + 4 | 0, 179808, i31) | 0;
      HEAP32[i31 >> 2] = HEAPU8[i4 + (i5 + i3) >> 0];
      _sprintf(i6 + 8 | 0, 179808, i31) | 0;
      HEAP8[i6 + 12 >> 0] = 32;
      i9 = i6 + 14 | 0;
      HEAP8[i6 + 13 >> 0] = 32;
      i5 = i5 + i35 | 0;
      if ((i5 | 0) >= (i10 | 0)) break; else i6 = i9;
     }
    } else {
     if (!i2) {
      i9 = i26;
      break;
     }
     i8 = i26;
     i7 = 0;
     while (1) {
      HEAP32[i31 >> 2] = HEAPU16[i6 + (i7 + 2 << 1) >> 1];
      _sprintf(i8, 179816, i31) | 0;
      HEAP32[i31 >> 2] = HEAPU16[i6 + (i7 + 1 << 1) >> 1];
      _sprintf(i8 + 6 | 0, 179816, i31) | 0;
      HEAP32[i31 >> 2] = HEAPU16[i6 + (i7 << 1) >> 1];
      _sprintf(i8 + 12 | 0, 179816, i31) | 0;
      HEAP8[i8 + 18 >> 0] = 32;
      i9 = i8 + 20 | 0;
      HEAP8[i8 + 19 >> 0] = 32;
      i7 = i7 + i35 | 0;
      if ((i7 | 0) >= (i10 | 0)) break; else i8 = i9;
     }
    } else {
     if (i20) {
      if (i11) {
       i9 = i26;
       i8 = 0;
      } else {
       i9 = i26;
       break;
      }
      while (1) {
       HEAP32[i31 >> 2] = HEAPU8[i4 + (i8 + i3) >> 0];
       _sprintf(i9, 179808, i31) | 0;
       i8 = i8 + 1 | 0;
       if ((i8 | 0) == (i36 | 0)) {
        i9 = i14;
        break L48;
       } else i9 = i9 + 4 | 0;
      }
     }
     if (i11) {
      i9 = i26;
      i8 = 0;
      while (1) {
       HEAP32[i31 >> 2] = HEAPU16[i6 + (i8 << 1) >> 1];
       _sprintf(i9, 179816, i31) | 0;
       i8 = i8 + 1 | 0;
       if ((i8 | 0) == (i36 | 0)) {
        i9 = i13;
        break;
       } else i9 = i9 + 6 | 0;
      }
     } else i9 = i26;
    } while (0);
    HEAP8[i9 >> 0] = 10;
    __ZN2cv12WLByteStream8putBytesEPKvi(i39, i26, i9 + 1 - i1 | 0);
   }
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) < (i37 | 0));
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i39 >> 2] | 0) + 16 >> 2] & 511](i39);
 i1 = HEAP32[i38 >> 2] | 0;
 if ((i1 | 0) == (i27 | 0)) {
  i22 = 1;
  __ZN2cv11WBaseStreamD2Ev(i39);
  STACKTOP = i40;
  return i22 | 0;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i38 >> 2] = i27;
 HEAP32[i28 >> 2] = 1032;
 i22 = 1;
 __ZN2cv11WBaseStreamD2Ev(i39);
 STACKTOP = i40;
 return i22 | 0;
}

function __ZN2cv3Mat5setToERKNS_11_InputArrayES3_(i28, i14, i15) {
 i28 = i28 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 1232 | 0;
 i29 = i30 + 1176 | 0;
 i27 = i30 + 1120 | 0;
 i7 = i30 + 1112 | 0;
 i16 = i30 + 1104 | 0;
 i22 = i30 + 1100 | 0;
 i19 = i30 + 1088 | 0;
 i24 = i30;
 i23 = i30 + 1056 | 0;
 i25 = i30 + 16 | 0;
 i21 = i30 + 8 | 0;
 if (!(HEAP32[i28 + 16 >> 2] | 0)) {
  STACKTOP = i30;
  return i28 | 0;
 }
 i8 = i28 + 4 | 0;
 i13 = HEAP32[i8 >> 2] | 0;
 if ((i13 | 0) < 3) i4 = Math_imul(HEAP32[i28 + 12 >> 2] | 0, HEAP32[i28 + 8 >> 2] | 0) | 0; else {
  i11 = HEAP32[i28 + 40 >> 2] | 0;
  i12 = 0;
  i4 = 1;
  do {
   i4 = Math_imul(HEAP32[i11 + (i12 << 2) >> 2] | 0, i4) | 0;
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i13 | 0));
 }
 if (!i4) {
  STACKTOP = i30;
  return i28 | 0;
 }
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i14 >> 2] >> 2] & 63](i29, i14, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i15 >> 2] >> 2] & 63](i27, i15, -1);
 i4 = HEAP32[i28 >> 2] | 0;
 FUNCTION_TABLE_ii[HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] & 127](i14) | 0;
 i26 = i29 + 4 | 0;
 if (((HEAP32[i26 >> 2] | 0) <= 2 ? (i1 = HEAP32[i29 >> 2] | 0, (i1 & 16384 | 0) != 0) : 0) ? (i3 = HEAP32[i29 + 40 >> 2] | 0, i2 = HEAP32[i3 + 4 >> 2] | 0, i3 = HEAP32[i3 >> 2] | 0, i5 = (i2 | 0) == 1, i6 = (i3 | 0) == 1, i5 | i6) : 0) {
  i4 = (i4 >>> 3 & 511) + 1 | 0;
  if (!(i5 & (i6 | (i3 | 0) == (i4 | 0)) | (i2 | 0) == (i4 | 0) & i6)) if (!(i5 & (i3 | 0) == 4 ? (i1 & 4095 | 0) == 6 & i4 >>> 0 < 5 : 0)) i18 = 13;
 } else i18 = 13;
 if ((i18 | 0) == 13) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i7, 60) | 0) + 0 | 0;
  i3 = 46816 | 0;
  i2 = i4 + 60 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i4 | 0) < (i2 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 46880, 46680, 471);
  __ZN2cv6String10deallocateEv(i7);
 }
 i20 = i27 + 16 | 0;
 L22 : do if (HEAP32[i20 >> 2] | 0) {
  i3 = HEAP32[i27 + 4 >> 2] | 0;
  if ((i3 | 0) < 3) i4 = Math_imul(HEAP32[i27 + 12 >> 2] | 0, HEAP32[i27 + 8 >> 2] | 0) | 0; else {
   i2 = HEAP32[i27 + 40 >> 2] | 0;
   i1 = 0;
   i4 = 1;
   do {
    i4 = Math_imul(HEAP32[i2 + (i1 << 2) >> 2] | 0, i4) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  if (i4) {
   L31 : do if ((HEAP32[i27 >> 2] & 4095 | 0) == 0 ? (i9 = HEAP32[i28 + 40 >> 2] | 0, i10 = HEAP32[i9 + -4 >> 2] | 0, i17 = HEAP32[i27 + 40 >> 2] | 0, (i10 | 0) == (HEAP32[i17 + -4 >> 2] | 0)) : 0) {
    if ((i10 | 0) == 2) {
     if ((HEAP32[i9 >> 2] | 0) != (HEAP32[i17 >> 2] | 0)) break;
     if ((HEAP32[i9 + 4 >> 2] | 0) == (HEAP32[i17 + 4 >> 2] | 0)) break L22; else break;
    }
    if ((i10 | 0) > 0) i4 = 0; else break L22;
    while (1) {
     if ((HEAP32[i9 + (i4 << 2) >> 2] | 0) != (HEAP32[i17 + (i4 << 2) >> 2] | 0)) break L31;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) >= (i10 | 0)) break L22;
    }
   } while (0);
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   i4 = (__ZN2cv6String8allocateEj(i16, 59) | 0) + 0 | 0;
   i3 = 46888 | 0;
   i2 = i4 + 59 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i4 | 0) < (i2 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i16, 46880, 46680, 472);
   __ZN2cv6String10deallocateEv(i16);
  }
 } while (0);
 i3 = HEAP32[i8 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i3 = HEAP32[(HEAP32[i28 + 44 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0;
  HEAP32[i22 >> 2] = i3;
  if (i3 >>> 0 < 33) i18 = 32; else i16 = 195;
 } else {
  HEAP32[i22 >> 2] = 0;
  i3 = 0;
  i18 = 32;
 }
 if ((i18 | 0) == 32) {
  i16 = HEAP32[46504 + (i3 << 2) >> 2] | 0;
  i16 = (i16 | 0) == 0 ? 195 : i16;
 }
 HEAP32[i19 >> 2] = i28;
 if (!(HEAP32[i20 >> 2] | 0)) i3 = 0; else {
  i2 = HEAP32[i27 + 4 >> 2] | 0;
  if ((i2 | 0) < 3) i3 = Math_imul(HEAP32[i27 + 12 >> 2] | 0, HEAP32[i27 + 8 >> 2] | 0) | 0; else {
   i1 = HEAP32[i27 + 40 >> 2] | 0;
   i4 = 0;
   i3 = 1;
   do {
    i3 = Math_imul(HEAP32[i1 + (i4 << 2) >> 2] | 0, i3) | 0;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i2 | 0));
  }
  i3 = (i3 | 0) == 0 ? 0 : i27;
 }
 HEAP32[i19 + 4 >> 2] = i3;
 HEAP32[i19 + 8 >> 2] = 0;
 i12 = i24;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i23, i19, i24, -1);
 i12 = HEAP32[i23 + 20 >> 2] | 0;
 i3 = HEAP32[i22 >> 2] | 0;
 i13 = ((i3 + 1023 | 0) >>> 0) / (i3 >>> 0) | 0;
 i13 = (i13 | 0) < (i12 | 0) ? i13 : i12;
 i3 = (Math_imul(i13, i3) | 0) + 32 | 0;
 i14 = i25 + 8 | 0;
 HEAP32[i25 >> 2] = i14;
 i15 = i25 + 4 | 0;
 HEAP32[i15 >> 2] = 1032;
 if (i3 >>> 0 > 1032) {
  i2 = __Znaj(i3) | 0;
  HEAP32[i25 >> 2] = i2;
 } else i2 = i14;
 HEAP32[i15 >> 2] = i3;
 i4 = i2 + 7 & -8;
 __ZN2cv22convertAndUnrollScalarERKNS_3MatEiPhj(i29, HEAP32[i28 >> 2] & 4095, i4, i13);
 i3 = i23 + 16 | 0;
 i2 = (i12 | 0) > 0;
 i1 = i24 + 4 | 0;
 i5 = i21 + 4 | 0;
 i10 = 0;
 while (1) {
  if (i10 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) break;
  if (i2) {
   i9 = HEAP32[i24 >> 2] | 0;
   i11 = 0;
   do {
    i6 = i12 - i11 | 0;
    i6 = (i6 | 0) < (i13 | 0) ? i6 : i13;
    i7 = Math_imul(HEAP32[i22 >> 2] | 0, i6) | 0;
    i8 = HEAP32[i1 >> 2] | 0;
    if (!i8) _memcpy(i9 | 0, i4 | 0, i7 | 0) | 0; else {
     HEAP32[i21 >> 2] = i6;
     HEAP32[i5 >> 2] = 1;
     FUNCTION_TABLE_viiiiiiii[i16 & 255](i4, 0, i8, 0, i9, 0, i21, i22);
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i6;
    }
    i9 = (HEAP32[i24 >> 2] | 0) + i7 | 0;
    HEAP32[i24 >> 2] = i9;
    i11 = i11 + i13 | 0;
   } while ((i12 | 0) > (i11 | 0));
  }
  __ZN2cv15NAryMatIteratorppEv(i23) | 0;
  i10 = i10 + 1 | 0;
 }
 i3 = HEAP32[i25 >> 2] | 0;
 if ((i3 | 0) != (i14 | 0)) {
  if (i3) __ZdaPv(i3);
  HEAP32[i25 >> 2] = i14;
  HEAP32[i15 >> 2] = 1032;
 }
 i2 = i27 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i27);
 HEAP32[i2 >> 2] = 0;
 i3 = i27 + 4 | 0;
 HEAP32[i20 + 0 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i27 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i27 + 44 >> 2] | 0;
 if ((i1 | 0) != (i27 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i29 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i29);
 HEAP32[i1 >> 2] = 0;
 i22 = i29 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i26 >> 2] | 0) > 0) {
  i2 = HEAP32[i29 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i26 >> 2] | 0));
 }
 i1 = HEAP32[i29 + 44 >> 2] | 0;
 if ((i1 | 0) == (i29 + 48 | 0)) {
  STACKTOP = i30;
  return i28 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i30;
 return i28 | 0;
}

function __ZZN4perf8TestBase10_calibrateEvEN7_helper12PerfTestBodyEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, d7 = 0.0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, d25 = 0.0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 i6 = i24 + 200 | 0;
 i20 = i24 + 144 | 0;
 i1 = i24 + 32 | 0;
 i18 = i24 + 88 | 0;
 i3 = i24;
 i10 = i24 + 64 | 0;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] & 511](i14);
 HEAPF64[i1 >> 3] = 1.0;
 i23 = i1 + 8 | 0;
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 HEAP32[i23 + 16 >> 2] = 0;
 HEAP32[i23 + 20 >> 2] = 0;
 HEAP32[i20 >> 2] = 1124007936;
 i23 = i20 + 4 | 0;
 i2 = i20 + 8 | 0;
 i19 = i20 + 40 | 0;
 i5 = i23 + 0 | 0;
 i8 = i5 + 36 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i8 | 0));
 HEAP32[i19 >> 2] = i2;
 i22 = i20 + 48 | 0;
 i21 = i20 + 44 | 0;
 HEAP32[i21 >> 2] = i22;
 HEAP32[i20 + 52 >> 2] = 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i6 >> 2] = 2048;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = 2048;
 __ZN2cv3Mat6createEiPKii(i20, 2, i6, 4);
 __ZN2cv3MataSERKNS_7Scalar_IdEE(i20, i1) | 0;
 HEAPF64[i3 >> 3] = 2.0;
 i16 = i3 + 8 | 0;
 HEAP32[i16 + 0 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP32[i18 >> 2] = 1124007936;
 i16 = i18 + 4 | 0;
 i2 = i18 + 8 | 0;
 i13 = i18 + 40 | 0;
 i5 = i16 + 0 | 0;
 i8 = i5 + 36 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i8 | 0));
 HEAP32[i13 >> 2] = i2;
 i17 = i18 + 48 | 0;
 i15 = i18 + 44 | 0;
 HEAP32[i15 >> 2] = i17;
 HEAP32[i18 + 52 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i6 >> 2] = 2048;
 HEAP32[i4 >> 2] = 2048;
 __ZN2cv3Mat6createEiPKii(i18, 2, i6, 4);
 __ZN2cv3MataSERKNS_7Scalar_IdEE(i18, i3) | 0;
 i11 = i14 + 180 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 i3 = i2 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -8 - i1 | 0) >>> 3) << 3);
 HEAP32[i2 + 80 >> 2] = -1;
 d7 = +__ZN2cv16getTickFrequencyEv() * 30.0;
 i8 = +Math_abs(d7) >= 1.0 ? (d7 > 0.0 ? (Math_min(+Math_floor(d7 / 4294967296.0), 4294967295.0) | 0) >>> 0 : ~~+Math_ceil((d7 - +(~~d7 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i2 = i5 + 64 | 0;
 HEAP32[i2 >> 2] = ~~d7 >>> 0;
 HEAP32[i2 + 4 >> 2] = i8;
 i2 = i5 + 168 | 0;
 i5 = i5 + 96 | 0;
 i8 = i5 + 72 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i8 | 0));
 HEAP32[i2 >> 2] = -1;
 i6 = HEAP32[i11 >> 2] | 0;
 i2 = i6 + 36 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i1 = i6 + 40 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = i4;
 if ((i3 | 0) == (i4 | 0)) i3 = i4; else {
  i3 = i3 + (~((i3 + -8 - i5 | 0) >>> 3) << 3) | 0;
  HEAP32[i1 >> 2] = i3;
 }
 i4 = i6 + 44 | 0;
 if ((HEAP32[i4 >> 2] | 0) - i5 >> 3 >>> 0 < 20 ? (i5 = i3 - i5 >> 3, i3 = __Znwj(160) | 0, i9 = HEAP32[i2 >> 2] | 0, i8 = (HEAP32[i1 >> 2] | 0) - i9 | 0, i6 = i3 + (i5 - (i8 >> 3) << 3) | 0, _memcpy(i6 | 0, i9 | 0, i8 | 0) | 0, HEAP32[i2 >> 2] = i6, HEAP32[i1 >> 2] = i3 + (i5 << 3), HEAP32[i4 >> 2] = i3 + 160, (i9 | 0) != 0) : 0) __ZdlPv(i9);
 i2 = HEAP32[42408] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 HEAP32[i5 + 76 >> 2] = i2 >>> 0 < 20 ? i2 : 20;
 HEAP32[i5 + 80 >> 2] = -1;
 i2 = i5 + 168 | 0;
 i5 = i5 + 96 | 0;
 i8 = i5 + 72 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i8 | 0));
 HEAP32[i2 >> 2] = -1;
 i9 = i14 + 48 | 0;
 i4 = i10 + 12 | 0;
 i3 = i10 + 16 | 0;
 i2 = i10 + 4 | 0;
 i1 = i10 + 8 | 0;
 d7 = 0.0;
 while (1) {
  i6 = __ZN2cv12getTickCountEv() | 0;
  i5 = i9;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i5 + 4 >> 2] = tempRet0;
  if (!(__ZN4perf8TestBase4nextEv(i14) | 0)) break;
  HEAP32[i10 >> 2] = 32088;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 16842752;
  HEAP32[i1 >> 2] = i18;
  d25 = d7 + +__ZNK2cv3Mat3dotERKNS_11_InputArrayE(i20, i10);
  __ZN4perf8TestBase9stopTimerEv(i14);
  d7 = d25;
 }
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i4 + 36 >> 2] | 0;
 i1 = i4 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -8 - i3 | 0) >>> 3) << 3);
 HEAP32[i4 + 80 >> 2] = -1;
 d7 = d7 * +__ZN2cv16getTickFrequencyEv();
 i8 = +Math_abs(d7) >= 1.0 ? (d7 > 0.0 ? (Math_min(+Math_floor(d7 / 4294967296.0), 4294967295.0) | 0) >>> 0 : ~~+Math_ceil((d7 - +(~~d7 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i2 = i5 + 64 | 0;
 HEAP32[i2 >> 2] = ~~d7 >>> 0;
 HEAP32[i2 + 4 >> 2] = i8;
 i2 = i5 + 168 | 0;
 i5 = i5 + 96 | 0;
 i8 = i5 + 72 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i8 | 0));
 HEAP32[i2 >> 2] = -1;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] & 511](i14);
 i2 = HEAP32[i11 >> 2] | 0;
 i5 = i2 + 36 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + 40 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i1 = i4;
 if ((i3 | 0) != (i4 | 0)) {
  i4 = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3) | 0;
  HEAP32[i6 >> 2] = i4;
 }
 i2 = i2 + 44 | 0;
 if ((HEAP32[i2 >> 2] | 0) - i1 >> 3 >>> 0 < 1e3 ? (i3 = i4 - i1 >> 3, i1 = __Znwj(8e3) | 0, i12 = HEAP32[i5 >> 2] | 0, i8 = (HEAP32[i6 >> 2] | 0) - i12 | 0, i4 = i1 + (i3 - (i8 >> 3) << 3) | 0, _memcpy(i4 | 0, i12 | 0, i8 | 0) | 0, HEAP32[i5 >> 2] = i4, HEAP32[i6 >> 2] = i1 + (i3 << 3), HEAP32[i2 >> 2] = i1 + 8e3, (i12 | 0) != 0) : 0) __ZdlPv(i12);
 i2 = HEAP32[42408] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 HEAP32[i5 + 76 >> 2] = i2 >>> 0 < 1e3 ? i2 : 1e3;
 HEAP32[i5 + 80 >> 2] = -1;
 i2 = i5 + 168 | 0;
 i5 = i5 + 96 | 0;
 i8 = i5 + 72 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i8 | 0));
 HEAP32[i2 >> 2] = -1;
 while (1) {
  i1 = __ZN2cv12getTickCountEv() | 0;
  i12 = i9;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 4 >> 2] = tempRet0;
  if (!(__ZN4perf8TestBase4nextEv(i14) | 0)) break;
  __ZN4perf8TestBase9stopTimerEv(i14);
 }
 i2 = i18 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i12 = i1 + 12 | 0, i14 = HEAP32[i12 >> 2] | 0, HEAP32[i12 >> 2] = i14 + -1, (i14 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i18);
 HEAP32[i2 >> 2] = 0;
 i18 = i18 + 16 | 0;
 HEAP32[i18 + 0 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 if ((HEAP32[i16 >> 2] | 0) > 0) {
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i16 >> 2] | 0));
 }
 i2 = HEAP32[i15 >> 2] | 0;
 if ((i2 | 0) != (i17 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i20 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i17 = i1 + 12 | 0, i18 = HEAP32[i17 >> 2] | 0, HEAP32[i17 >> 2] = i18 + -1, (i18 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i20);
 HEAP32[i2 >> 2] = 0;
 i20 = i20 + 16 | 0;
 HEAP32[i20 + 0 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 if ((HEAP32[i23 >> 2] | 0) > 0) {
  i1 = HEAP32[i19 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i23 >> 2] | 0));
 }
 i1 = HEAP32[i21 >> 2] | 0;
 if ((i1 | 0) == (i22 | 0)) {
  STACKTOP = i24;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i24;
 return;
}

function __ZN2cv5mergeEPKNS_3MatEjRKNS_12_OutputArrayE(i24, i20, i18) {
 i24 = i24 | 0;
 i20 = i20 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 2240 | 0;
 i5 = i28 + 2232 | 0;
 i4 = i28 + 2224 | 0;
 i17 = i28 + 2216 | 0;
 i27 = i28 + 2160 | 0;
 i16 = i28 + 2136 | 0;
 i21 = i28 + 1072 | 0;
 i26 = i28 + 32 | 0;
 i25 = i28;
 if (!((i24 | 0) != 0 & (i20 | 0) != 0)) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i11 = (__ZN2cv6String8allocateEj(i5, 11) | 0) + 0 | 0;
  i1 = 43568 | 0;
  i2 = i11 + 11 | 0;
  do {
   HEAP8[i11 >> 0] = HEAP8[i1 >> 0] | 0;
   i11 = i11 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i11 | 0) < (i2 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 43584, 43512, 565);
  __ZN2cv6String10deallocateEv(i5);
 }
 i23 = HEAP32[i24 >> 2] & 7;
 i5 = (i20 | 0) == 0;
 if (!i5) {
  i15 = i24 + 40 | 0;
  i14 = i4 + 4 | 0;
  i6 = 1;
  i13 = 0;
  i12 = 0;
  while (1) {
   i3 = i24 + (i12 * 56 | 0) | 0;
   i10 = HEAP32[i24 + (i12 * 56 | 0) + 40 >> 2] | 0;
   i9 = HEAP32[i10 + -4 >> 2] | 0;
   i8 = HEAP32[i15 >> 2] | 0;
   L8 : do if ((i9 | 0) == (HEAP32[i8 + -4 >> 2] | 0)) {
    if ((i9 | 0) == 2) {
     if ((HEAP32[i10 >> 2] | 0) != (HEAP32[i8 >> 2] | 0)) {
      i19 = 13;
      break;
     }
     if ((HEAP32[i10 + 4 >> 2] | 0) != (HEAP32[i8 + 4 >> 2] | 0)) {
      i19 = 13;
      break;
     }
    } else if ((i9 | 0) > 0) {
     i7 = 0;
     do {
      if ((HEAP32[i10 + (i7 << 2) >> 2] | 0) != (HEAP32[i8 + (i7 << 2) >> 2] | 0)) {
       i19 = 13;
       break L8;
      }
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) < (i9 | 0));
    }
    if ((HEAP32[i3 >> 2] & 7 | 0) != (i23 | 0)) i19 = 13;
   } else i19 = 13; while (0);
   if ((i19 | 0) == 13) {
    i19 = 0;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i14 >> 2] = 0;
    i11 = (__ZN2cv6String8allocateEj(i4, 50) | 0) + 0 | 0;
    i1 = 43592 | 0;
    i2 = i11 + 50 | 0;
    do {
     HEAP8[i11 >> 0] = HEAP8[i1 >> 0] | 0;
     i11 = i11 + 1 | 0;
     i1 = i1 + 1 | 0;
    } while ((i11 | 0) < (i2 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 43584, 43512, 574);
    __ZN2cv6String10deallocateEv(i4);
   }
   i8 = HEAP32[i3 >> 2] | 0;
   if (i6) i6 = (i8 & 4088 | 0) == 0; else i6 = 0;
   i7 = i8 >>> 3 & 511;
   i8 = i13 + 1 + i7 | 0;
   i12 = i12 + 1 | 0;
   if (i12 >>> 0 >= i20 >>> 0) break; else i13 = i8;
  }
  if ((i13 + i7 | 0) >>> 0 < 512) i22 = i8; else i19 = 18;
 } else {
  i6 = 1;
  i8 = 0;
  i19 = 18;
 }
 if ((i19 | 0) == 18) {
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  i11 = (__ZN2cv6String8allocateEj(i17, 25) | 0) + 0 | 0;
  i1 = 43648 | 0;
  i2 = i11 + 25 | 0;
  do {
   HEAP8[i11 >> 0] = HEAP8[i1 >> 0] | 0;
   i11 = i11 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i11 | 0) < (i2 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i17, 43584, 43512, 579);
  __ZN2cv6String10deallocateEv(i17);
  i22 = i8;
 }
 FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i18 >> 2] | 0) + 144 >> 2] & 63](i18, HEAP32[i24 + 4 >> 2] | 0, HEAP32[i24 + 40 >> 2] | 0, (i22 << 3) + -8 | i23, -1, 0, 0);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i18 >> 2] >> 2] & 63](i27, i18, -1);
 do if ((i20 | 0) != 1) {
  if (!i6) {
   i3 = i22 << 1;
   i7 = i21 + 8 | 0;
   HEAP32[i21 >> 2] = i7;
   i8 = i21 + 4 | 0;
   HEAP32[i8 >> 2] = 264;
   if (i3 >>> 0 > 264) {
    i6 = __Znaj(i3 >>> 0 > 1073741823 ? -1 : i3 << 2) | 0;
    HEAP32[i21 >> 2] = i6;
   } else i6 = i7;
   HEAP32[i8 >> 2] = i3;
   if (!i5) {
    i1 = 0;
    i4 = 0;
    while (1) {
     i2 = (HEAP32[i24 + (i1 * 56 | 0) >> 2] | 0) >>> 3;
     i3 = i2 & 511;
     i2 = i2 & 511;
     i5 = 0;
     while (1) {
      i18 = i5 + i4 | 0;
      i19 = i18 << 1;
      HEAP32[i6 + (i19 << 2) >> 2] = i18;
      HEAP32[i6 + ((i19 | 1) << 2) >> 2] = i18;
      if ((i5 | 0) == (i2 | 0)) break; else i5 = i5 + 1 | 0;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i20 | 0)) break; else i4 = i3 + 1 + i4 | 0;
    }
   }
   __ZN2cv11mixChannelsEPKNS_3MatEjPS0_jPKij(i24, i20, i27, 1, i6, i22);
   i3 = HEAP32[i21 >> 2] | 0;
   if ((i3 | 0) == (i7 | 0)) break;
   if (i3) __ZdaPv(i3);
   HEAP32[i21 >> 2] = i7;
   HEAP32[i8 >> 2] = 264;
   break;
  }
  i3 = HEAP32[i27 + 4 >> 2] | 0;
  if ((i3 | 0) > 0) i15 = HEAP32[(HEAP32[i27 + 44 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0; else i15 = 0;
  i14 = 1212424721 >>> (HEAP32[i27 >> 2] << 2 & 28) & 15;
  i3 = ((i15 + 1023 | 0) >>> 0) / (i15 >>> 0) | 0;
  i6 = i22 + 1 | 0;
  i5 = (i6 << 3) + 16 | 0;
  i16 = i26 + 8 | 0;
  HEAP32[i26 >> 2] = i16;
  i17 = i26 + 4 | 0;
  HEAP32[i17 >> 2] = 1032;
  if (i5 >>> 0 > 1032) {
   i4 = __Znaj(i5) | 0;
   HEAP32[i26 >> 2] = i4;
  } else i4 = i16;
  HEAP32[i17 >> 2] = i5;
  i8 = i4 + (i6 << 2) + 15 & -16;
  i12 = i8;
  HEAP32[i4 >> 2] = i27;
  i13 = (i22 | 0) > 0;
  if (i13) {
   i7 = 0;
   do {
    i21 = i7;
    i7 = i7 + 1 | 0;
    HEAP32[i4 + (i7 << 2) >> 2] = i24 + (i21 * 56 | 0);
   } while ((i7 | 0) != (i22 | 0));
  }
  __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i25, i4, i8, i6);
  i11 = HEAP32[i25 + 20 >> 2] | 0;
  if ((i22 | 0) < 5) i10 = i11; else i10 = (i3 | 0) < (i11 | 0) ? i3 : i11;
  i6 = HEAP32[44408 + (i23 << 2) >> 2] | 0;
  i5 = i25 + 16 | 0;
  i4 = (i11 | 0) > 0;
  i3 = i12 + 4 | 0;
  i1 = 0;
  while (1) {
   if (i1 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) break;
   L64 : do if (i4) {
    i9 = 0;
    while (1) {
     i8 = i11 - i9 | 0;
     i8 = (i10 | 0) < (i8 | 0) ? i10 : i8;
     FUNCTION_TABLE_viiii[i6 & 63](i3, HEAP32[i12 >> 2] | 0, i8, i22);
     i9 = i9 + i10 | 0;
     i2 = (i9 | 0) < (i11 | 0);
     if (!i2) break L64;
     i21 = Math_imul(i8, i15) | 0;
     HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i21;
     if (!i13) continue;
     i8 = Math_imul(i8, i14) | 0;
     i7 = 0;
     do {
      i7 = i7 + 1 | 0;
      i21 = i12 + (i7 << 2) | 0;
      HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + i8;
     } while ((i7 | 0) != (i22 | 0));
     if (!i2) break;
    }
   } while (0);
   __ZN2cv15NAryMatIteratorppEv(i25) | 0;
   i1 = i1 + 1 | 0;
  }
  i3 = HEAP32[i26 >> 2] | 0;
  if ((i3 | 0) != (i16 | 0)) {
   if (i3) __ZdaPv(i3);
   HEAP32[i26 >> 2] = i16;
   HEAP32[i17 >> 2] = 1032;
  }
 } else {
  i22 = i16 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  HEAP32[i16 >> 2] = 32232;
  HEAP32[i22 >> 2] = 33619968;
  HEAP32[i16 + 8 >> 2] = i27;
  __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i24, i16);
 } while (0);
 i1 = i27 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i27);
 HEAP32[i1 >> 2] = 0;
 i22 = i27 + 16 | 0;
 i2 = i27 + 4 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i27 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i27 + 44 >> 2] | 0;
 if ((i1 | 0) == (i27 + 48 | 0)) {
  STACKTOP = i28;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i28;
 return;
}

function __ZN7testing8internal20DoubleNearPredFormatEPKcS2_S2_ddd(i22, i2, i1, i3, d5, d6, d4) {
 i22 = i22 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 d5 = +d5;
 d6 = +d6;
 d4 = +d4;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i13 = i23 + 68 | 0;
 i14 = i23 + 56 | 0;
 i15 = i23 + 52 | 0;
 i16 = i23 + 48 | 0;
 i17 = i23 + 44 | 0;
 i18 = i23 + 40 | 0;
 i19 = i23 + 24 | 0;
 i20 = i23 + 16 | 0;
 i21 = i23 + 8 | 0;
 i11 = i23;
 i10 = i23 + 32 | 0;
 HEAP32[i16 >> 2] = i2;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i18 >> 2] = i3;
 HEAPF64[i19 >> 3] = d5;
 HEAPF64[i20 >> 3] = d6;
 HEAPF64[i21 >> 3] = d4;
 d5 = +Math_abs(+(d5 - d6));
 HEAPF64[i11 >> 3] = d5;
 if (d5 <= d4) {
  HEAP8[i22 >> 0] = 1;
  HEAP32[i22 + 4 >> 2] = 0;
  STACKTOP = i23;
  return;
 }
 HEAP8[i10 >> 0] = 0;
 i12 = i10 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN7testing7MessageC2Ev(i15);
 i9 = HEAP32[i15 >> 2] | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9 + 8 | 0, 160664, 23) | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(12) | 0;
  HEAP32[i1 + 0 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i12 >> 2] = i1;
 }
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i13, i9 + 12 | 0);
 i2 = HEAP8[i13 >> 0] | 0;
 if (!(i2 & 1)) {
  i7 = i13 + 1 | 0;
  i3 = (i2 & 255) >>> 1;
 } else {
  i7 = HEAP32[i13 + 8 >> 2] | 0;
  i3 = HEAP32[i13 + 4 >> 2] | 0;
 }
 i8 = i7 + i3 | 0;
 HEAP32[i14 + 0 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i14, i3 << 1);
 if (i3) {
  i2 = i7;
  do {
   i3 = HEAP8[i2 >> 0] | 0;
   if (!(i3 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i14, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i14, i3);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i8 | 0));
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
 if (!(HEAP8[i14 >> 0] & 1)) i2 = i14 + 1 | 0; else i2 = HEAP32[i14 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, i2) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 if (i9) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] & 511](i9);
  HEAP32[i15 >> 2] = 0;
 }
 i9 = __ZN7testing15AssertionResultlsIdEERS0_RKT_(__ZN7testing15AssertionResultlsIA5_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(__ZN7testing15AssertionResultlsIA6_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(i10, i16) | 0, 160688) | 0, i17) | 0, 160696) | 0, i11) | 0;
 __ZN7testing7MessageC2Ev(i15);
 i8 = HEAP32[i15 >> 2] | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i8 + 8 | 0, 160704, 16) | 0;
 i1 = i9 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __Znwj(12) | 0;
  HEAP32[i2 + 0 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i2;
 }
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i13, i8 + 12 | 0);
 i1 = HEAP8[i13 >> 0] | 0;
 if (!(i1 & 1)) {
  i3 = i13 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i3 = HEAP32[i13 + 8 >> 2] | 0;
  i1 = HEAP32[i13 + 4 >> 2] | 0;
 }
 i7 = i3 + i1 | 0;
 HEAP32[i14 + 0 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i14, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i3 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i14, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i14, i1);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i7 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
 if (!(HEAP8[i14 >> 0] & 1)) i1 = i14 + 1 | 0; else i1 = HEAP32[i14 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i2, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 if (i8) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] & 511](i8);
  HEAP32[i15 >> 2] = 0;
 }
 i9 = __ZN7testing15AssertionResultlsIPKcEERS0_RKT_(i9, i18) | 0;
 __ZN7testing7MessageC2Ev(i15);
 i7 = HEAP32[i15 >> 2] | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7 + 8 | 0, 160728, 8) | 0;
 i2 = i9 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i8 = __Znwj(12) | 0;
  HEAP32[i8 + 0 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i2 >> 2] = i8;
 } else i8 = i1;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i13, i7 + 12 | 0);
 i2 = HEAP8[i13 >> 0] | 0;
 if (!(i2 & 1)) {
  i3 = i13 + 1 | 0;
  i2 = (i2 & 255) >>> 1;
 } else {
  i3 = HEAP32[i13 + 8 >> 2] | 0;
  i2 = HEAP32[i13 + 4 >> 2] | 0;
 }
 i1 = i3 + i2 | 0;
 HEAP32[i14 + 0 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i14, i2 << 1);
 if (i2) do {
  i2 = HEAP8[i3 >> 0] | 0;
  if (!(i2 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i14, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i14, i2);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i1 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
 if (!(HEAP8[i14 >> 0] & 1)) i1 = i14 + 1 | 0; else i1 = HEAP32[i14 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i8, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 if (i7) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] & 511](i7);
  HEAP32[i15 >> 2] = 0;
 }
 i1 = __ZN7testing15AssertionResultlsIA2_cEERS0_RKT_(__ZN7testing15AssertionResultlsIdEERS0_RKT_(__ZN7testing15AssertionResultlsIA15_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(__ZN7testing15AssertionResultlsIA7_cEERS0_RKT_(__ZN7testing15AssertionResultlsIdEERS0_RKT_(__ZN7testing15AssertionResultlsIA15_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(__ZN7testing15AssertionResultlsIA3_cEERS0_RKT_(__ZN7testing15AssertionResultlsIdEERS0_RKT_(__ZN7testing15AssertionResultlsIA15_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(i9, i16) | 0, 160744) | 0, i19) | 0, 160760) | 0, i17) | 0, 160744) | 0, i20) | 0, 160768) | 0, i18) | 0, 160744) | 0, i21) | 0, 160488) | 0;
 HEAP8[i22 >> 0] = HEAP8[i1 >> 0] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i11 = __Znwj(12) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i11, i1);
  i1 = i11;
 }
 HEAP32[i22 + 4 >> 2] = i1;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i23;
  return;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 __ZdlPv(i1);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i23;
 return;
}

function __ZN2cvL39getErrorMessageForWrongArgumentInSetterENS_6StringES0_ii(i23, i4, i3, i13, i18) {
 i23 = i23 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i5 = i24 + 96 | 0;
 i6 = i24 + 88 | 0;
 i7 = i24 + 80 | 0;
 i8 = i24 + 72 | 0;
 i9 = i24 + 64 | 0;
 i10 = i24 + 56 | 0;
 i11 = i24 + 48 | 0;
 i12 = i24 + 40 | 0;
 i17 = i24 + 32 | 0;
 i22 = i24 + 24 | 0;
 i19 = i24 + 16 | 0;
 i20 = i24 + 8 | 0;
 i21 = i24;
 HEAP32[i11 >> 2] = 0;
 i2 = i11 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i14 = (__ZN2cv6String8allocateEj(i11, 26) | 0) + 0 | 0;
 i15 = 39384 | 0;
 i16 = i14 + 26 | 0;
 do {
  HEAP8[i14 >> 0] = HEAP8[i15 >> 0] | 0;
  i14 = i14 + 1 | 0;
  i15 = i15 + 1 | 0;
 } while ((i14 | 0) < (i16 | 0));
 HEAP32[i10 >> 2] = 0;
 i1 = i10 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN2cv6String8allocateEj(i10, (HEAP32[i2 >> 2] | 0) + 38 | 0) | 0;
 _memcpy(HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 i14 = (HEAP32[i10 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) + 0 | 0;
 i15 = 38864 | 0;
 i16 = i14 + 38 | 0;
 do {
  HEAP8[i14 >> 0] = HEAP8[i15 >> 0] | 0;
  i14 = i14 + 1 | 0;
  i15 = i15 + 1 | 0;
 } while ((i14 | 0) < (i16 | 0));
 HEAP32[i9 >> 2] = 0;
 i14 = i9 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 i2 = i3 + 4 | 0;
 __ZN2cv6String8allocateEj(i9, (HEAP32[i2 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0) | 0;
 _memcpy(HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
 _memcpy((HEAP32[i9 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0, HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 __ZN2cv6String8allocateEj(i8, (HEAP32[i14 >> 2] | 0) + 20 | 0) | 0;
 _memcpy(HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
 i14 = (HEAP32[i8 >> 2] | 0) + (HEAP32[i14 >> 2] | 0) + 0 | 0;
 i15 = 38904 | 0;
 i16 = i14 + 20 | 0;
 do {
  HEAP8[i14 >> 0] = HEAP8[i15 >> 0] | 0;
  i14 = i14 + 1 | 0;
  i15 = i15 + 1 | 0;
 } while ((i14 | 0) < (i16 | 0));
 HEAP32[i7 >> 2] = 0;
 i14 = i7 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i4 + 4 | 0;
 __ZN2cv6String8allocateEj(i7, (HEAP32[i15 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0) | 0;
 _memcpy(HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 _memcpy((HEAP32[i7 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0, HEAP32[i4 >> 2] | 0, HEAP32[i15 >> 2] | 0) | 0;
 HEAP32[i6 >> 2] = 0;
 i2 = i6 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 __ZN2cv6String8allocateEj(i6, (HEAP32[i14 >> 2] | 0) + 21 | 0) | 0;
 _memcpy(HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
 i14 = (HEAP32[i6 >> 2] | 0) + (HEAP32[i14 >> 2] | 0) + 0 | 0;
 i15 = 38928 | 0;
 i16 = i14 + 21 | 0;
 do {
  HEAP8[i14 >> 0] = HEAP8[i15 >> 0] | 0;
  i14 = i14 + 1 | 0;
  i15 = i15 + 1 | 0;
 } while ((i14 | 0) < (i16 | 0));
 __ZN2cvL13getNameOfTypeEi(i12, i13);
 HEAP32[i5 >> 2] = 0;
 i16 = i5 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 i3 = i12 + 4 | 0;
 __ZN2cv6String8allocateEj(i5, (HEAP32[i3 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0) | 0;
 _memcpy(HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 _memcpy((HEAP32[i5 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0, HEAP32[i12 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i23 >> 2] = 0;
 i3 = i23 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 __ZN2cv6String8allocateEj(i23, (HEAP32[i16 >> 2] | 0) + 7 | 0) | 0;
 _memcpy(HEAP32[i23 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i16 >> 2] | 0) | 0;
 i16 = (HEAP32[i23 >> 2] | 0) + (HEAP32[i16 >> 2] | 0) | 0;
 HEAP8[i16 + 0 >> 0] = HEAP8[38952] | 0;
 HEAP8[i16 + 1 >> 0] = HEAP8[38953] | 0;
 HEAP8[i16 + 2 >> 0] = HEAP8[38954] | 0;
 HEAP8[i16 + 3 >> 0] = HEAP8[38955] | 0;
 HEAP8[i16 + 4 >> 0] = HEAP8[38956] | 0;
 HEAP8[i16 + 5 >> 0] = HEAP8[38957] | 0;
 HEAP8[i16 + 6 >> 0] = HEAP8[38958] | 0;
 __ZN2cv6String10deallocateEv(i5);
 __ZN2cv6String10deallocateEv(i12);
 __ZN2cv6String10deallocateEv(i6);
 __ZN2cv6String10deallocateEv(i7);
 __ZN2cv6String10deallocateEv(i8);
 __ZN2cv6String10deallocateEv(i9);
 __ZN2cv6String10deallocateEv(i10);
 __ZN2cv6String10deallocateEv(i11);
 switch (i13 | 0) {
 case 0:
 case 1:
 case 2:
 case 7:
 case 8:
 case 9:
 case 11:
  {
   HEAP32[i17 >> 2] = 0;
   i1 = i17 + 4 | 0;
   HEAP32[i1 >> 2] = 0;
   __ZN2cv6String8allocateEj(i17, (HEAP32[i3 >> 2] | 0) + 105 | 0) | 0;
   _memcpy(HEAP32[i17 >> 2] | 0, HEAP32[i23 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   i14 = (HEAP32[i17 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) + 0 | 0;
   i15 = 39416 | 0;
   i16 = i14 + 105 | 0;
   do {
    HEAP8[i14 >> 0] = HEAP8[i15 >> 0] | 0;
    i14 = i14 + 1 | 0;
    i15 = i15 + 1 | 0;
   } while ((i14 | 0) < (i16 | 0));
   if ((i17 | 0) != (i23 | 0)) {
    __ZN2cv6String10deallocateEv(i23);
    i2 = HEAP32[i17 >> 2] | 0;
    if (!i2) i2 = 0; else {
     i2 = i2 + -4 | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i17 >> 2] | 0;
    }
    HEAP32[i23 >> 2] = i2;
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   }
   __ZN2cv6String10deallocateEv(i17);
   break;
  }
 default:
  {}
 }
 HEAP32[i20 >> 2] = 0;
 i2 = i20 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 __ZN2cv6String8allocateEj(i20, (HEAP32[i3 >> 2] | 0) + 31 | 0) | 0;
 _memcpy(HEAP32[i20 >> 2] | 0, HEAP32[i23 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 i14 = (HEAP32[i20 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) + 0 | 0;
 i15 = 39528 | 0;
 i16 = i14 + 31 | 0;
 do {
  HEAP8[i14 >> 0] = HEAP8[i15 >> 0] | 0;
  i14 = i14 + 1 | 0;
  i15 = i15 + 1 | 0;
 } while ((i14 | 0) < (i16 | 0));
 __ZN2cvL13getNameOfTypeEi(i21, i18);
 HEAP32[i19 >> 2] = 0;
 i18 = i19 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 i17 = i21 + 4 | 0;
 __ZN2cv6String8allocateEj(i19, (HEAP32[i17 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0) | 0;
 _memcpy(HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 _memcpy((HEAP32[i19 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0, HEAP32[i21 >> 2] | 0, HEAP32[i17 >> 2] | 0) | 0;
 HEAP32[i22 >> 2] = 0;
 i2 = i22 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 __ZN2cv6String8allocateEj(i22, (HEAP32[i18 >> 2] | 0) + 6 | 0) | 0;
 _memcpy(HEAP32[i22 >> 2] | 0, HEAP32[i19 >> 2] | 0, HEAP32[i18 >> 2] | 0) | 0;
 i18 = (HEAP32[i22 >> 2] | 0) + (HEAP32[i18 >> 2] | 0) | 0;
 HEAP8[i18 + 0 >> 0] = HEAP8[39216] | 0;
 HEAP8[i18 + 1 >> 0] = HEAP8[39217] | 0;
 HEAP8[i18 + 2 >> 0] = HEAP8[39218] | 0;
 HEAP8[i18 + 3 >> 0] = HEAP8[39219] | 0;
 HEAP8[i18 + 4 >> 0] = HEAP8[39220] | 0;
 HEAP8[i18 + 5 >> 0] = HEAP8[39221] | 0;
 if ((i22 | 0) == (i23 | 0)) {
  __ZN2cv6String10deallocateEv(i22);
  __ZN2cv6String10deallocateEv(i19);
  __ZN2cv6String10deallocateEv(i21);
  __ZN2cv6String10deallocateEv(i20);
  STACKTOP = i24;
  return;
 }
 __ZN2cv6String10deallocateEv(i23);
 i1 = HEAP32[i22 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i22 >> 2] | 0;
 }
 HEAP32[i23 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 __ZN2cv6String10deallocateEv(i22);
 __ZN2cv6String10deallocateEv(i19);
 __ZN2cv6String10deallocateEv(i21);
 __ZN2cv6String10deallocateEv(i20);
 STACKTOP = i24;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i22, i18, i19, i20, i16, i21, i17, i4, i15) {
 i22 = i22 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i16 = i16 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 i4 = i4 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i10 = i24 + 20 | 0;
 i9 = i24 + 16 | 0;
 i1 = i24 + 12 | 0;
 i11 = i24 + 8 | 0;
 i12 = i24 + 4 | 0;
 i13 = i24;
 __ZNKSt3__18ios_base6getlocEv(i1, i16);
 i14 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960720) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
 HEAP32[i21 >> 2] = 0;
 L1 : do if ((i4 | 0) != (i15 | 0)) {
  i3 = 0;
  L3 : while (1) {
   while (1) {
    if (i3) {
     i23 = 64;
     break L1;
    }
    i2 = HEAP32[i19 >> 2] | 0;
    if (i2) {
     i3 = HEAP32[i2 + 12 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
     if ((i3 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i5 = 1;
      i2 = 0;
     } else i5 = 0;
    } else {
     i5 = 1;
     i2 = 0;
    }
    i1 = HEAP32[i20 >> 2] | 0;
    do if (i1) {
     i3 = HEAP32[i1 + 12 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i3 = HEAP32[i3 >> 2] | 0;
     if ((i3 | 0) != -1) if (i5) break; else {
      i23 = 19;
      break L3;
     } else {
      HEAP32[i20 >> 2] = 0;
      i23 = 17;
      break;
     }
    } else i23 = 17; while (0);
    if ((i23 | 0) == 17) {
     i23 = 0;
     if (i5) {
      i23 = 19;
      break L3;
     } else i1 = 0;
    }
    if ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] & 63](i14, HEAP32[i4 >> 2] | 0, 0) | 0) << 24 >> 24 == 37) {
     i23 = 21;
     break;
    }
    if (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] & 63](i14, 8192, HEAP32[i4 >> 2] | 0) | 0) {
     i23 = 31;
     break;
    }
    i5 = i2 + 12 | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    i1 = i2 + 16 | 0;
    if ((i3 | 0) == (HEAP32[i1 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
    i3 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] & 127](i14, i3) | 0;
    if ((i3 | 0) == (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] & 127](i14, HEAP32[i4 >> 2] | 0) | 0)) {
     i23 = 59;
     break;
    }
    HEAP32[i21 >> 2] = 4;
    i3 = 4;
   }
   L35 : do if ((i23 | 0) == 21) {
    i23 = 0;
    i3 = i4 + 4 | 0;
    if ((i3 | 0) == (i15 | 0)) {
     i23 = 22;
     break L3;
    }
    i6 = FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] & 63](i14, HEAP32[i3 >> 2] | 0, 0) | 0;
    if (i6 << 24 >> 24 == 48 | i6 << 24 >> 24 == 69) {
     i4 = i4 + 8 | 0;
     if ((i4 | 0) == (i15 | 0)) {
      i23 = 25;
      break L3;
     }
     i3 = i4;
     i5 = FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] & 63](i14, HEAP32[i4 >> 2] | 0, 0) | 0;
     i4 = i6;
    } else {
     i5 = i6;
     i4 = 0;
    }
    i6 = HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] | 0;
    HEAP32[i12 >> 2] = i2;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i9 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
    HEAP32[i10 + 0 >> 2] = HEAP32[i13 + 0 >> 2];
    FUNCTION_TABLE_viiiiiiiii[i6 & 7](i11, i18, i9, i10, i16, i21, i17, i5, i4);
    HEAP32[i19 >> 2] = HEAP32[i11 >> 2];
    i4 = i3 + 4 | 0;
   } else if ((i23 | 0) == 31) {
    while (1) {
     i23 = 0;
     i4 = i4 + 4 | 0;
     if ((i4 | 0) == (i15 | 0)) {
      i4 = i15;
      break;
     }
     if (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] & 63](i14, 8192, HEAP32[i4 >> 2] | 0) | 0) i23 = 31; else break;
    }
    i8 = i1;
    i5 = i1;
    while (1) {
     if (i2) {
      i3 = HEAP32[i2 + 12 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
      if ((i3 | 0) == -1) {
       HEAP32[i19 >> 2] = 0;
       i2 = 0;
       i6 = 1;
      } else i6 = 0;
     } else {
      i2 = 0;
      i6 = 1;
     }
     do if (i5) {
      i3 = HEAP32[i5 + 12 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i5 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] & 127](i5) | 0; else i3 = HEAP32[i3 >> 2] | 0;
      if ((i3 | 0) != -1) if (i6 ^ (i8 | 0) == 0) {
       i3 = i8;
       i7 = i8;
       break;
      } else break L35; else {
       HEAP32[i20 >> 2] = 0;
       i3 = 0;
       i23 = 46;
       break;
      }
     } else {
      i3 = i8;
      i23 = 46;
     } while (0);
     if ((i23 | 0) == 46) {
      i23 = 0;
      if (i6) break L35; else i7 = 0;
     }
     i6 = i2 + 12 | 0;
     i5 = HEAP32[i6 >> 2] | 0;
     i1 = i2 + 16 | 0;
     if ((i5 | 0) == (HEAP32[i1 >> 2] | 0)) i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i5 = HEAP32[i5 >> 2] | 0;
     if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] & 63](i14, 8192, i5) | 0)) break L35;
     i5 = HEAP32[i6 >> 2] | 0;
     if ((i5 | 0) == (HEAP32[i1 >> 2] | 0)) {
      FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
      i8 = i3;
      i5 = i7;
      continue;
     } else {
      HEAP32[i6 >> 2] = i5 + 4;
      i8 = i3;
      i5 = i7;
      continue;
     }
    }
   } else if ((i23 | 0) == 59) {
    i23 = 0;
    i3 = HEAP32[i5 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i1 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0; else HEAP32[i5 >> 2] = i3 + 4;
    i4 = i4 + 4 | 0;
   } while (0);
   if ((i4 | 0) == (i15 | 0)) {
    i23 = 64;
    break L1;
   }
   i3 = HEAP32[i21 >> 2] | 0;
  }
  if ((i23 | 0) == 19) {
   HEAP32[i21 >> 2] = 4;
   break;
  } else if ((i23 | 0) == 22) {
   HEAP32[i21 >> 2] = 4;
   break;
  } else if ((i23 | 0) == 25) {
   HEAP32[i21 >> 2] = 4;
   break;
  }
 } else i23 = 64; while (0);
 if ((i23 | 0) == 64) i2 = HEAP32[i19 >> 2] | 0;
 if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i19 >> 2] = 0;
   i2 = 0;
   i4 = 1;
  } else i4 = 0;
 } else {
  i2 = 0;
  i4 = 1;
 }
 i1 = HEAP32[i20 >> 2] | 0;
 do if (i1) {
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i20 >> 2] = 0;
   i23 = 77;
   break;
  }
  if (i4) {
   HEAP32[i22 >> 2] = i2;
   STACKTOP = i24;
   return;
  }
 } else i23 = 77; while (0);
 if ((i23 | 0) == 77 ? !i4 : 0) {
  HEAP32[i22 >> 2] = i2;
  STACKTOP = i24;
  return;
 }
 HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
 HEAP32[i22 >> 2] = i2;
 STACKTOP = i24;
 return;
}

function __ZNSt3__111__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri(i1, i2, i17, i13, i20, i15, i19, i18, i16, i14) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 i13 = i13 | 0;
 i20 = i20 | 0;
 i15 = i15 | 0;
 i19 = i19 | 0;
 i18 = i18 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i3 = i21 + 100 | 0;
 i4 = i21 + 88 | 0;
 i5 = i21 + 76 | 0;
 i6 = i21 + 64 | 0;
 i7 = i21 + 52 | 0;
 i8 = i21 + 48 | 0;
 i9 = i21 + 36 | 0;
 i10 = i21 + 24 | 0;
 i11 = i21 + 12 | 0;
 i12 = i21;
 if (i1) {
  i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 960296) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] & 127](i3, i1);
  i10 = HEAP32[i3 >> 2] | 0;
  HEAP8[i17 >> 0] = i10;
  HEAP8[i17 + 1 >> 0] = i10 >> 8;
  HEAP8[i17 + 2 >> 0] = i10 >> 16;
  HEAP8[i17 + 3 >> 0] = i10 >> 24;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] & 127](i4, i1);
  if (!(HEAP8[i16 >> 0] & 1)) {
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP8[i16 >> 0] = 0;
  } else {
   HEAP32[HEAP32[i16 + 8 >> 2] >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i16, 0);
  HEAP32[i16 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i4 + 0 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i4);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i5, i1);
  if (!(HEAP8[i18 >> 0] & 1)) {
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP8[i18 >> 0] = 0;
  } else {
   HEAP32[HEAP32[i18 + 8 >> 2] >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i18, 0);
  HEAP32[i18 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i5 + 0 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i5);
  HEAP32[i13 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 127](i1) | 0;
  HEAP32[i20 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 127](i1) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i6, i1);
  if (!(HEAP8[i15 >> 0] & 1)) {
   HEAP8[i15 + 1 >> 0] = 0;
   HEAP8[i15 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i15 + 8 >> 2] >> 0] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i15, 0);
  HEAP32[i15 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i7, i1);
  if (!(HEAP8[i19 >> 0] & 1)) {
   HEAP32[i19 + 4 >> 2] = 0;
   HEAP8[i19 >> 0] = 0;
  } else {
   HEAP32[HEAP32[i19 + 8 >> 2] >> 2] = 0;
   HEAP32[i19 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i19, 0);
  HEAP32[i19 + 0 >> 2] = HEAP32[i7 + 0 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i7 + 0 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i7);
  i10 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0;
  HEAP32[i14 >> 2] = i10;
  STACKTOP = i21;
  return;
 } else {
  i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 960232) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] & 127](i8, i1);
  i8 = HEAP32[i8 >> 2] | 0;
  HEAP8[i17 >> 0] = i8;
  HEAP8[i17 + 1 >> 0] = i8 >> 8;
  HEAP8[i17 + 2 >> 0] = i8 >> 16;
  HEAP8[i17 + 3 >> 0] = i8 >> 24;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] & 127](i9, i1);
  if (!(HEAP8[i16 >> 0] & 1)) {
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP8[i16 >> 0] = 0;
  } else {
   HEAP32[HEAP32[i16 + 8 >> 2] >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i16, 0);
  HEAP32[i16 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i9 + 0 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i9);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i10, i1);
  if (!(HEAP8[i18 >> 0] & 1)) {
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP8[i18 >> 0] = 0;
  } else {
   HEAP32[HEAP32[i18 + 8 >> 2] >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i18, 0);
  HEAP32[i18 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i10);
  HEAP32[i13 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 127](i1) | 0;
  HEAP32[i20 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 127](i1) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i11, i1);
  if (!(HEAP8[i15 >> 0] & 1)) {
   HEAP8[i15 + 1 >> 0] = 0;
   HEAP8[i15 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i15 + 8 >> 2] >> 0] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i15, 0);
  HEAP32[i15 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 + 0 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i12, i1);
  if (!(HEAP8[i19 >> 0] & 1)) {
   HEAP32[i19 + 4 >> 2] = 0;
   HEAP8[i19 >> 0] = 0;
  } else {
   HEAP32[HEAP32[i19 + 8 >> 2] >> 2] = 0;
   HEAP32[i19 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i19, 0);
  HEAP32[i19 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i12 + 0 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i12);
  i10 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0;
  HEAP32[i14 >> 2] = i10;
  STACKTOP = i21;
  return;
 }
}

function __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i18, i10) {
 i18 = i18 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 i5 = i19 + 360 | 0;
 i17 = i19 + 304 | 0;
 i16 = i19 + 176 | 0;
 i9 = i19 + 48 | 0;
 i12 = i19 + 40 | 0;
 i14 = i19 + 32 | 0;
 i13 = i19;
 i4 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i10 >> 2] | 0) + 56 >> 2] & 127](i10, -1) | 0;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 108 >> 2] & 127](i10) | 0 ? (i6 = HEAP32[i18 >> 2] | 0, (i4 | 0) != (i6 & 4095 | 0)) : 0) {
  if ((i6 ^ i4) & 4088) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i3 = (__ZN2cv6String8allocateEj(i5, 30) | 0) + 0 | 0;
   i2 = 46640 | 0;
   i1 = i3 + 30 | 0;
   do {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    i3 = i3 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i3 | 0) < (i1 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 46672, 46680, 280);
   __ZN2cv6String10deallocateEv(i5);
  }
  __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i18, i10, i4, 1.0, 0.0);
  STACKTOP = i19;
  return;
 }
 i11 = i18 + 16 | 0;
 if (HEAP32[i11 >> 2] | 0) {
  i15 = i18 + 4 | 0;
  i7 = HEAP32[i15 >> 2] | 0;
  if ((i7 | 0) < 3) i6 = Math_imul(HEAP32[i18 + 12 >> 2] | 0, HEAP32[i18 + 8 >> 2] | 0) | 0; else {
   i5 = HEAP32[i18 + 40 >> 2] | 0;
   i4 = 0;
   i6 = 1;
   do {
    i6 = Math_imul(HEAP32[i5 + (i4 << 2) >> 2] | 0, i6) | 0;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i7 | 0));
  }
  if (i6) {
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] & 127](i10) | 0) == 655360) {
    i5 = i18 + 40 | 0;
    FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i10 >> 2] | 0) + 144 >> 2] & 63](i10, HEAP32[i15 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i18 >> 2] & 4095, -1, 0, 0);
    FUNCTION_TABLE_viii[HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] & 63](i17, i10, -1);
    i6 = HEAP32[i15 >> 2] | 0;
    if ((i6 | 0) <= 0) if (!i6) {
     i3 = -1;
     i4 = 0;
    } else {
     i4 = 0;
     i8 = 17;
    } else {
     i4 = HEAP32[(HEAP32[i18 + 44 >> 2] | 0) + (i6 + -1 << 2) >> 2] | 0;
     i8 = 17;
    }
    if ((i8 | 0) == 17) {
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = 0;
     do {
      HEAP32[i16 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
      i2 = i2 + 1 | 0;
     } while (i2 >>> 0 < i6 >>> 0);
     i3 = i6 + -1 | 0;
    }
    i10 = i16 + (i3 << 2) | 0;
    HEAP32[i10 >> 2] = Math_imul(HEAP32[i10 >> 2] | 0, i4) | 0;
    __ZNK2cv4UMat8ndoffsetEPj(i17, i9);
    i10 = HEAP32[i15 >> 2] | 0;
    i8 = i9 + (i10 + -1 << 2) | 0;
    HEAP32[i8 >> 2] = Math_imul(HEAP32[i8 >> 2] | 0, i4) | 0;
    i8 = HEAP32[i17 + 24 >> 2] | 0;
    i7 = HEAP32[i8 + 4 >> 2] | 0;
    FUNCTION_TABLE_viiiiiiii[HEAP32[(HEAP32[i7 >> 2] | 0) + 32 >> 2] & 255](i7, i8, HEAP32[i11 >> 2] | 0, i10, i16, i9, HEAP32[i17 + 36 >> 2] | 0, HEAP32[i18 + 44 >> 2] | 0);
    __ZN2cv4UMatD2Ev(i17);
    STACKTOP = i19;
    return;
   }
   i5 = HEAP32[i15 >> 2] | 0;
   if ((i5 | 0) < 3) {
    i6 = i18 + 8 | 0;
    i5 = i18 + 12 | 0;
    FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i10 >> 2] | 0) + 140 >> 2] & 63](i10, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i18 >> 2] & 4095, -1, 0, 0);
    FUNCTION_TABLE_viii[HEAP32[HEAP32[i10 >> 2] >> 2] & 63](i17, i10, -1);
    i4 = HEAP32[i11 >> 2] | 0;
    i8 = i17 + 16 | 0;
    i7 = HEAP32[i8 >> 2] | 0;
    if (((i4 | 0) != (i7 | 0) ? (i2 = HEAP32[i6 >> 2] | 0, (i2 | 0) > 0) : 0) ? (i1 = HEAP32[i5 >> 2] | 0, (i1 | 0) > 0) : 0) {
     if (HEAP32[i18 >> 2] & 16384 & HEAP32[i17 >> 2]) {
      i1 = Math_imul(i1, i2) | 0;
      i2 = 1;
     }
     i3 = HEAP32[i15 >> 2] | 0;
     if ((i3 | 0) > 0) i3 = HEAP32[(HEAP32[i18 + 44 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0; else i3 = 0;
     i6 = Math_imul(i3, i1) | 0;
     if (i2) {
      i1 = i18 + 48 | 0;
      i5 = i17 + 48 | 0;
      i3 = i7;
      while (1) {
       i2 = i2 + -1 | 0;
       _memcpy(i3 | 0, i4 | 0, i6 | 0) | 0;
       if (!i2) break; else {
        i3 = i3 + (HEAP32[i5 >> 2] | 0) | 0;
        i4 = i4 + (HEAP32[i1 >> 2] | 0) | 0;
       }
      }
     }
    }
    i1 = i17 + 36 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != 0 ? (i9 = i2 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i17);
    HEAP32[i1 >> 2] = 0;
    i3 = i17 + 4 | 0;
    HEAP32[i8 + 0 >> 2] = 0;
    HEAP32[i8 + 4 >> 2] = 0;
    HEAP32[i8 + 8 >> 2] = 0;
    HEAP32[i8 + 12 >> 2] = 0;
    if ((HEAP32[i3 >> 2] | 0) > 0) {
     i2 = HEAP32[i17 + 40 >> 2] | 0;
     i1 = 0;
     do {
      HEAP32[i2 + (i1 << 2) >> 2] = 0;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
    }
    i1 = HEAP32[i17 + 44 >> 2] | 0;
    if ((i1 | 0) == (i17 + 48 | 0)) {
     STACKTOP = i19;
     return;
    }
    __ZN2cv8fastFreeEPv(i1);
    STACKTOP = i19;
    return;
   }
   i6 = i18 + 40 | 0;
   FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i10 >> 2] | 0) + 144 >> 2] & 63](i10, i5, HEAP32[i6 >> 2] | 0, HEAP32[i18 >> 2] & 4095, -1, 0, 0);
   FUNCTION_TABLE_viii[HEAP32[HEAP32[i10 >> 2] >> 2] & 63](i16, i10, -1);
   i8 = i16 + 16 | 0;
   L61 : do if ((HEAP32[i11 >> 2] | 0) != (HEAP32[i8 >> 2] | 0)) {
    i4 = HEAP32[i15 >> 2] | 0;
    if ((i4 | 0) < 3) i3 = Math_imul(HEAP32[i18 + 12 >> 2] | 0, HEAP32[i18 + 8 >> 2] | 0) | 0; else {
     i6 = HEAP32[i6 >> 2] | 0;
     i5 = 0;
     i3 = 1;
     do {
      i3 = Math_imul(HEAP32[i6 + (i5 << 2) >> 2] | 0, i3) | 0;
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i4 | 0));
    }
    if (i3) {
     HEAP32[i12 >> 2] = i18;
     HEAP32[i12 + 4 >> 2] = i16;
     __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i13, i12, i14, 2);
     i3 = HEAP32[i15 >> 2] | 0;
     if ((i3 | 0) > 0) i3 = HEAP32[(HEAP32[i18 + 44 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0; else i3 = 0;
     i3 = Math_imul(i3, HEAP32[i13 + 20 >> 2] | 0) | 0;
     i2 = i13 + 16 | 0;
     i1 = i14 + 4 | 0;
     i4 = 0;
     while (1) {
      if (i4 >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) break L61;
      _memcpy(HEAP32[i1 >> 2] | 0, HEAP32[i14 >> 2] | 0, i3 | 0) | 0;
      __ZN2cv15NAryMatIteratorppEv(i13) | 0;
      i4 = i4 + 1 | 0;
     }
    }
   } while (0);
   i2 = i16 + 36 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i16);
   HEAP32[i2 >> 2] = 0;
   i3 = i16 + 4 | 0;
   HEAP32[i8 + 0 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i2 = HEAP32[i16 + 40 >> 2] | 0;
    i1 = 0;
    do {
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
   }
   i1 = HEAP32[i16 + 44 >> 2] | 0;
   if ((i1 | 0) == (i16 + 48 | 0)) {
    STACKTOP = i19;
    return;
   }
   __ZN2cv8fastFreeEPv(i1);
   STACKTOP = i19;
   return;
  }
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i10 >> 2] | 0) + 152 >> 2] & 511](i10);
 STACKTOP = i19;
 return;
}

function __ZNSt3__111__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri(i1, i2, i17, i13, i20, i15, i19, i18, i16, i14) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 i13 = i13 | 0;
 i20 = i20 | 0;
 i15 = i15 | 0;
 i19 = i19 | 0;
 i18 = i18 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i3 = i21 + 100 | 0;
 i4 = i21 + 88 | 0;
 i5 = i21 + 76 | 0;
 i6 = i21 + 64 | 0;
 i7 = i21 + 52 | 0;
 i8 = i21 + 48 | 0;
 i9 = i21 + 36 | 0;
 i10 = i21 + 24 | 0;
 i11 = i21 + 12 | 0;
 i12 = i21;
 if (i1) {
  i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 960168) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] & 127](i3, i1);
  i10 = HEAP32[i3 >> 2] | 0;
  HEAP8[i17 >> 0] = i10;
  HEAP8[i17 + 1 >> 0] = i10 >> 8;
  HEAP8[i17 + 2 >> 0] = i10 >> 16;
  HEAP8[i17 + 3 >> 0] = i10 >> 24;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] & 127](i4, i1);
  if (!(HEAP8[i16 >> 0] & 1)) {
   HEAP8[i16 + 1 >> 0] = 0;
   HEAP8[i16 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i16 + 8 >> 2] >> 0] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i16, 0);
  HEAP32[i16 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i4 + 0 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i5, i1);
  if (!(HEAP8[i18 >> 0] & 1)) {
   HEAP8[i18 + 1 >> 0] = 0;
   HEAP8[i18 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i18 + 8 >> 2] >> 0] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i18, 0);
  HEAP32[i18 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i5 + 0 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
  HEAP8[i13 >> 0] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 127](i1) | 0;
  HEAP8[i20 >> 0] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 127](i1) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i6, i1);
  if (!(HEAP8[i15 >> 0] & 1)) {
   HEAP8[i15 + 1 >> 0] = 0;
   HEAP8[i15 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i15 + 8 >> 2] >> 0] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i15, 0);
  HEAP32[i15 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i7, i1);
  if (!(HEAP8[i19 >> 0] & 1)) {
   HEAP8[i19 + 1 >> 0] = 0;
   HEAP8[i19 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i19 + 8 >> 2] >> 0] = 0;
   HEAP32[i19 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i19, 0);
  HEAP32[i19 + 0 >> 2] = HEAP32[i7 + 0 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i7 + 0 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
  i10 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0;
  HEAP32[i14 >> 2] = i10;
  STACKTOP = i21;
  return;
 } else {
  i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 960104) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] & 127](i8, i1);
  i8 = HEAP32[i8 >> 2] | 0;
  HEAP8[i17 >> 0] = i8;
  HEAP8[i17 + 1 >> 0] = i8 >> 8;
  HEAP8[i17 + 2 >> 0] = i8 >> 16;
  HEAP8[i17 + 3 >> 0] = i8 >> 24;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] & 127](i9, i1);
  if (!(HEAP8[i16 >> 0] & 1)) {
   HEAP8[i16 + 1 >> 0] = 0;
   HEAP8[i16 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i16 + 8 >> 2] >> 0] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i16, 0);
  HEAP32[i16 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i9 + 0 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i10, i1);
  if (!(HEAP8[i18 >> 0] & 1)) {
   HEAP8[i18 + 1 >> 0] = 0;
   HEAP8[i18 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i18 + 8 >> 2] >> 0] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i18, 0);
  HEAP32[i18 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
  HEAP8[i13 >> 0] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 127](i1) | 0;
  HEAP8[i20 >> 0] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 127](i1) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i11, i1);
  if (!(HEAP8[i15 >> 0] & 1)) {
   HEAP8[i15 + 1 >> 0] = 0;
   HEAP8[i15 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i15 + 8 >> 2] >> 0] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i15, 0);
  HEAP32[i15 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 + 0 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i12, i1);
  if (!(HEAP8[i19 >> 0] & 1)) {
   HEAP8[i19 + 1 >> 0] = 0;
   HEAP8[i19 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i19 + 8 >> 2] >> 0] = 0;
   HEAP32[i19 + 4 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i19, 0);
  HEAP32[i19 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i12 + 0 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
  i10 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0;
  HEAP32[i14 >> 2] = i10;
  STACKTOP = i21;
  return;
 }
}

function __ZL12icvReadImageP13CvFileStorageP10CvFileNode(i20, i12) {
 i20 = i20 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 608 | 0;
 i16 = i22 + 96 | 0;
 i1 = i22 + 88 | 0;
 i21 = i22 + 56 | 0;
 i2 = i22 + 48 | 0;
 i8 = i22 + 40 | 0;
 i9 = i22 + 32 | 0;
 i10 = i22 + 24 | 0;
 i11 = i22 + 16 | 0;
 i19 = i22;
 i3 = _cvGetFileNodeByName(i20, i12, 12104) | 0;
 do if (i3) {
  i4 = HEAP32[i3 >> 2] & 7;
  if ((i4 | 0) == 1) {
   i17 = HEAP32[i3 + 8 >> 2] | 0;
   break;
  } else if ((i4 | 0) == 2) {
   i17 = _lrint(+HEAPF64[i3 + 8 >> 3]) | 0;
   break;
  } else {
   i17 = 2147483647;
   break;
  }
 } else i17 = 0; while (0);
 i4 = _cvGetFileNodeByName(i20, i12, 12112) | 0;
 do if (i4) {
  i5 = HEAP32[i4 >> 2] & 7;
  if ((i5 | 0) == 2) {
   i15 = _lrint(+HEAPF64[i4 + 8 >> 3]) | 0;
   break;
  } else if ((i5 | 0) == 1) {
   i15 = HEAP32[i4 + 8 >> 2] | 0;
   break;
  } else {
   i15 = 2147483647;
   break;
  }
 } else i15 = 0; while (0);
 i5 = _cvGetFileNodeByName(i20, i12, 11672) | 0;
 if ((i5 | 0) != 0 ? (HEAP32[i5 >> 2] & 7 | 0) == 3 : 0) i18 = HEAP32[i5 + 12 >> 2] | 0; else i18 = 0;
 i7 = _cvGetFileNodeByName(i20, i12, 12120) | 0;
 if (!(((i7 | 0) != 0 ? (HEAP32[i7 >> 2] & 7 | 0) == 3 : 0) ? !((i17 | 0) == 0 | (i15 | 0) == 0 | (i18 | 0) == 0 | (HEAP32[i7 + 12 >> 2] | 0) == 0) : 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i2, 45) | 0) + 0 | 0;
  i6 = 12224 | 0;
  i7 = i3 + 45 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i3 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i2, 12272, 8960, 3916);
  __ZN2cv6String10deallocateEv(i2);
 }
 i7 = (__ZL15icvDecodeFormatPKcPii(i18, i16) | 0) != 1;
 i5 = HEAP32[i16 >> 2] | 0;
 if (i7 | (i5 | 0) > 4) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i1, 33) | 0) + 0 | 0;
  i6 = 11936 | 0;
  i7 = i3 + 33 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i3 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i1, 11976, 8960, 3068);
  __ZN2cv6String10deallocateEv(i1);
 }
 i14 = HEAP32[i16 + 4 >> 2] | 0;
 i4 = (i5 << 3) + 4088 | 0;
 i5 = _cvGetFileNodeByName(i20, i12, 12160) | 0;
 if (i5) if ((HEAP32[i5 >> 2] & 7 | 0) == 3) i5 = HEAP32[i5 + 12 >> 2] | 0; else i5 = 0; else i5 = 12176;
 if (_strcmp(i5, 12176) | 0) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i8, 35) | 0) + 0 | 0;
  i6 = 12288 | 0;
  i7 = i3 + 35 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i3 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i8, 12272, 8960, 3921);
  __ZN2cv6String10deallocateEv(i8);
 }
 i13 = _cvGetFileNodeByName(i20, i12, 11680) | 0;
 if (!i13) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i9, 43) | 0) + 0 | 0;
  i6 = 12328 | 0;
  i7 = i3 + 43 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i3 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i9, 12272, 8960, 3925);
  __ZN2cv6String10deallocateEv(i9);
 }
 i5 = HEAP32[i13 >> 2] & 7;
 if (i5 >>> 0 > 4) i5 = HEAP32[(HEAP32[i13 + 8 >> 2] | 0) + 24 >> 2] | 0; else i5 = (i5 | 0) != 0 & 1;
 i9 = Math_imul(i15, i17) | 0;
 i8 = (i4 >>> 3 & 511) + 1 | 0;
 if ((i5 | 0) != (Math_imul(i8, i9) | 0)) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i10, 63) | 0) + 0 | 0;
  i6 = 11872 | 0;
  i7 = i3 + 63 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i3 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-209, i10, 12272, 8960, 3929);
  __ZN2cv6String10deallocateEv(i10);
 }
 i4 = i14 & 7;
 if ((i14 & 5 | 0) == 1) i5 = -2147483648; else i5 = (i4 | 0) == 4 ? -2147483648 : 0;
 HEAP32[i11 >> 2] = i17;
 HEAP32[i11 + 4 >> 2] = i15;
 HEAP32[i16 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 i10 = _cvCreateImage(i16, i5 | 1212424721 >>> (i4 << 2) << 3 & 120, i8) | 0;
 i6 = _cvGetFileNodeByName(i20, i12, 12192) | 0;
 if (i6) {
  i5 = _cvGetFileNodeByName(i20, i6, 12200) | 0;
  do if (i5) {
   i4 = HEAP32[i5 >> 2] & 7;
   if ((i4 | 0) == 2) {
    i1 = _lrint(+HEAPF64[i5 + 8 >> 3]) | 0;
    break;
   } else if ((i4 | 0) == 1) {
    i1 = HEAP32[i5 + 8 >> 2] | 0;
    break;
   } else {
    i1 = 2147483647;
    break;
   }
  } else i1 = 0; while (0);
  i5 = _cvGetFileNodeByName(i20, i6, 12208) | 0;
  do if (i5) {
   i4 = HEAP32[i5 >> 2] & 7;
   if ((i4 | 0) == 1) {
    i7 = HEAP32[i5 + 8 >> 2] | 0;
    break;
   } else if ((i4 | 0) == 2) {
    i7 = _lrint(+HEAPF64[i5 + 8 >> 3]) | 0;
    break;
   } else {
    i7 = 2147483647;
    break;
   }
  } else i7 = 0; while (0);
  i5 = _cvGetFileNodeByName(i20, i6, 12104) | 0;
  do if (i5) {
   i4 = HEAP32[i5 >> 2] & 7;
   if ((i4 | 0) == 1) {
    i2 = HEAP32[i5 + 8 >> 2] | 0;
    break;
   } else if ((i4 | 0) == 2) {
    i2 = _lrint(+HEAPF64[i5 + 8 >> 3]) | 0;
    break;
   } else {
    i2 = 2147483647;
    break;
   }
  } else i2 = 0; while (0);
  i5 = _cvGetFileNodeByName(i20, i6, 12112) | 0;
  do if (i5) {
   i4 = HEAP32[i5 >> 2] & 7;
   if ((i4 | 0) == 1) {
    i3 = HEAP32[i5 + 8 >> 2] | 0;
    break;
   } else if ((i4 | 0) == 2) {
    i3 = _lrint(+HEAPF64[i5 + 8 >> 3]) | 0;
    break;
   } else {
    i3 = 2147483647;
    break;
   }
  } else i3 = 0; while (0);
  i5 = _cvGetFileNodeByName(i20, i6, 12216) | 0;
  do if (i5) {
   i4 = HEAP32[i5 >> 2] & 7;
   if ((i4 | 0) == 2) {
    i5 = _lrint(+HEAPF64[i5 + 8 >> 3]) | 0;
    break;
   } else if ((i4 | 0) == 1) {
    i5 = HEAP32[i5 + 8 >> 2] | 0;
    break;
   } else {
    i5 = 2147483647;
    break;
   }
  } else i5 = 0; while (0);
  HEAP32[i19 >> 2] = i1;
  HEAP32[i19 + 4 >> 2] = i7;
  HEAP32[i19 + 8 >> 2] = i2;
  HEAP32[i19 + 12 >> 2] = i3;
  HEAP32[i16 + 0 >> 2] = HEAP32[i19 + 0 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  _cvSetImageROI(i10, i16);
  _cvSetImageCOI(i10, i5);
 }
 i3 = Math_imul(i8 << (47696 >>> (i14 << 1 & 14) & 3), i17) | 0;
 i5 = i10 + 72 | 0;
 i3 = (i3 | 0) == (HEAP32[i5 >> 2] | 0);
 i4 = i3 ? 1 : i15;
 i3 = Math_imul(i3 ? i9 : i17, i8) | 0;
 _cvStartReadRawData(i20, i13, i21);
 if ((i4 | 0) <= 0) {
  STACKTOP = i22;
  return i10 | 0;
 }
 i1 = i10 + 68 | 0;
 i2 = 0;
 do {
  _cvReadRawDataSlice(i20, i21, i3, (HEAP32[i1 >> 2] | 0) + (Math_imul(HEAP32[i5 >> 2] | 0, i2) | 0) | 0, i18);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i22;
 return i10 | 0;
}

function __ZN2cvL14MulTransposedRItfEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d28) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d28 = +d28;
 var d4 = 0.0, d5 = 0.0, d6 = 0.0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, f30 = f0, d31 = 0.0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i27 = i29;
 i25 = HEAP32[i3 + 16 >> 2] | 0;
 i18 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i26 = (HEAP32[i3 + 48 >> 2] | 0) >>> 1;
 i24 = (HEAP32[i1 + 48 >> 2] | 0) >>> 2;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i9 = (HEAP32[i2 + 48 >> 2] | 0) >>> 2; else i9 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i20 = HEAP32[i3 + 40 >> 2] | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = i27 + 8 | 0;
 HEAP32[i27 >> 2] = i21;
 i22 = i27 + 4 | 0;
 HEAP32[i22 >> 2] = 1032;
 i3 = (i7 | 0) != 0;
 i2 = (i2 | 0) < (i19 | 0);
 if (i3 & i2) i1 = i20 * 20 | 0; else i1 = i20 << 2;
 if (i1 >>> 0 > 1032) {
  i23 = __Znaj(i1) | 0;
  HEAP32[i27 >> 2] = i23;
 } else i23 = i21;
 HEAP32[i22 >> 2] = i1;
 do if (i3) {
  if (i2) {
   i2 = i23 + (i20 << 2) | 0;
   if ((i20 | 0) > 0) {
    i3 = 0;
    do {
     f30 = Math_fround(HEAPF32[i7 + ((Math_imul(i3, i9) | 0) << 2) >> 2]);
     i16 = i3 << 2;
     HEAPF32[i23 + ((i16 | 3) + i20 << 2) >> 2] = f30;
     HEAPF32[i23 + ((i16 | 2) + i20 << 2) >> 2] = f30;
     HEAPF32[i23 + ((i16 | 1) + i20 << 2) >> 2] = f30;
     HEAPF32[i23 + (i16 + i20 << 2) >> 2] = f30;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if (!i2) {
    i17 = 14;
    break;
   } else {
    i7 = i2;
    i16 = i2;
    i9 = (i9 | 0) != 0 ? 4 : 0;
   }
  } else i16 = 0;
  if ((i19 | 0) > 0) {
   i11 = (i16 | 0) != 0;
   i13 = (i20 | 0) > 0;
   i12 = i19 + -4 | 0;
   i14 = 0;
   i15 = i18;
   while (1) {
    if (i11) {
     if (i13) {
      i3 = 0;
      do {
       f30 = Math_fround(HEAPU16[i25 + ((Math_imul(i3, i26) | 0) + i14 << 1) >> 1] | 0 | 0);
       HEAPF32[i23 + (i3 << 2) >> 2] = Math_fround(f30 - Math_fround(HEAPF32[i16 + ((Math_imul(i3, i9) | 0) << 2) >> 2]));
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i20 | 0));
     }
    } else if (i13) {
     i3 = 0;
     do {
      f30 = Math_fround(HEAPU16[i25 + ((Math_imul(i3, i26) | 0) + i14 << 1) >> 1] | 0 | 0);
      HEAPF32[i23 + (i3 << 2) >> 2] = Math_fround(f30 - Math_fround(HEAPF32[i7 + ((Math_imul(i3, i9) | 0) + i14 << 2) >> 2]));
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i20 | 0));
    }
    if ((i14 | 0) > (i12 | 0)) i3 = i14; else {
     i3 = i14;
     do {
      if (i11) i2 = i16; else i2 = i7 + (i3 << 2) | 0;
      if (i13) {
       i10 = 0;
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
       i1 = i25 + (i3 << 1) | 0;
       while (1) {
        d31 = +Math_fround(HEAPF32[i23 + (i10 << 2) >> 2]);
        f30 = Math_fround(HEAPU16[i1 >> 1] | 0 | 0);
        d4 = d4 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 >> 2]));
        f30 = Math_fround(HEAPU16[i1 + 2 >> 1] | 0 | 0);
        d5 = d5 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 + 4 >> 2]));
        f30 = Math_fround(HEAPU16[i1 + 4 >> 1] | 0 | 0);
        d6 = d6 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 + 8 >> 2]));
        f30 = Math_fround(HEAPU16[i1 + 6 >> 1] | 0 | 0);
        d8 = d8 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 + 12 >> 2]));
        i10 = i10 + 1 | 0;
        if ((i10 | 0) == (i20 | 0)) break; else {
         i2 = i2 + (i9 << 2) | 0;
         i1 = i1 + (i26 << 1) | 0;
        }
       }
      } else {
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
      }
      HEAPF32[i15 + (i3 << 2) >> 2] = Math_fround(d4 * d28);
      HEAPF32[i15 + (i3 + 1 << 2) >> 2] = Math_fround(d5 * d28);
      HEAPF32[i15 + (i3 + 2 << 2) >> 2] = Math_fround(d6 * d28);
      HEAPF32[i15 + (i3 + 3 << 2) >> 2] = Math_fround(d8 * d28);
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i12 | 0));
    }
    if ((i3 | 0) < (i19 | 0)) do {
     if (i11) i2 = i16; else i2 = i7 + (i3 << 2) | 0;
     if (i13) {
      i1 = 0;
      d8 = 0.0;
      i10 = i25 + (i3 << 1) | 0;
      while (1) {
       d4 = +Math_fround(HEAPF32[i23 + (i1 << 2) >> 2]);
       f30 = Math_fround(HEAPU16[i10 >> 1] | 0 | 0);
       d8 = d8 + d4 * +Math_fround(f30 - Math_fround(HEAPF32[i2 >> 2]));
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i20 | 0)) break; else {
        i2 = i2 + (i9 << 2) | 0;
        i10 = i10 + (i26 << 1) | 0;
       }
      }
     } else d8 = 0.0;
     HEAPF32[i15 + (i3 << 2) >> 2] = Math_fround(d8 * d28);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i19 | 0));
    i14 = i14 + 1 | 0;
    if ((i14 | 0) == (i19 | 0)) break; else i15 = i15 + (i24 << 2) | 0;
   }
  }
 } else i17 = 14; while (0);
 if ((i17 | 0) == 14 ? (i19 | 0) > 0 : 0) {
  i11 = (i20 | 0) > 0;
  i12 = i19 + -4 | 0;
  i13 = 0;
  i10 = i18;
  while (1) {
   if (i11) {
    i3 = 0;
    do {
     HEAPF32[i23 + (i3 << 2) >> 2] = Math_fround(HEAPU16[i25 + ((Math_imul(i3, i26) | 0) + i13 << 1) >> 1] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if ((i13 | 0) > (i12 | 0)) i3 = i13; else {
    i3 = i13;
    do {
     if (i11) {
      i9 = 0;
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
      i7 = i25 + (i3 << 1) | 0;
      while (1) {
       d31 = +Math_fround(HEAPF32[i23 + (i9 << 2) >> 2]);
       d8 = d8 + d31 * +(HEAPU16[i7 >> 1] | 0 | 0);
       d6 = d6 + d31 * +(HEAPU16[i7 + 2 >> 1] | 0 | 0);
       d5 = d5 + d31 * +(HEAPU16[i7 + 4 >> 1] | 0 | 0);
       d4 = d4 + d31 * +(HEAPU16[i7 + 6 >> 1] | 0 | 0);
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == (i20 | 0)) break; else i7 = i7 + (i26 << 1) | 0;
      }
     } else {
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
     }
     HEAPF32[i10 + (i3 << 2) >> 2] = Math_fround(d8 * d28);
     HEAPF32[i10 + (i3 + 1 << 2) >> 2] = Math_fround(d6 * d28);
     HEAPF32[i10 + (i3 + 2 << 2) >> 2] = Math_fround(d5 * d28);
     HEAPF32[i10 + (i3 + 3 << 2) >> 2] = Math_fround(d4 * d28);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i12 | 0));
   }
   if ((i3 | 0) < (i19 | 0)) do {
    if (i11) {
     i2 = 0;
     d4 = 0.0;
     i1 = i25 + (i3 << 1) | 0;
     while (1) {
      d5 = +Math_fround(HEAPF32[i23 + (i2 << 2) >> 2]);
      d4 = d4 + d5 * +(HEAPU16[i1 >> 1] | 0 | 0);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break; else i1 = i1 + (i26 << 1) | 0;
     }
    } else d4 = 0.0;
    HEAPF32[i10 + (i3 << 2) >> 2] = Math_fround(d4 * d28);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i19 | 0));
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i19 | 0)) break; else i10 = i10 + (i24 << 2) | 0;
  }
 }
 if ((i23 | 0) == (i21 | 0)) {
  STACKTOP = i29;
  return;
 }
 __ZdaPv(i23);
 HEAP32[i27 >> 2] = i21;
 HEAP32[i22 >> 2] = 1032;
 STACKTOP = i29;
 return;
}

function __ZNSt3__16__sortIRNS_6__lessIxxEEPxEEvT0_S5_T_(i4, i3, i20) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 L1 : while (1) {
  i15 = i3;
  i23 = i3 + -8 | 0;
  i22 = i4;
  L3 : while (1) {
   i14 = i22;
   i4 = i15 - i14 | 0;
   i1 = i4 >> 3;
   switch (i1 | 0) {
   case 1:
   case 0:
    {
     i21 = 45;
     break L1;
    }
   case 5:
    {
     i21 = 8;
     break L1;
    }
   case 2:
    {
     i21 = 4;
     break L1;
    }
   case 4:
    {
     i21 = 7;
     break L1;
    }
   case 3:
    {
     i21 = 6;
     break L1;
    }
   default:
    {}
   }
   if ((i4 | 0) < 248) {
    i21 = 10;
    break L1;
   }
   i2 = (i1 | 0) / 2 | 0;
   i13 = i22 + (i2 << 3) | 0;
   if ((i4 | 0) > 7992) {
    i4 = (i1 | 0) / 4 | 0;
    i4 = __ZNSt3__17__sort5IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_S5_T_(i22, i22 + (i4 << 3) | 0, i13, i22 + (i4 + i2 << 3) | 0, i23, i20) | 0;
   } else i4 = __ZNSt3__17__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i22, i13, i23, i20) | 0;
   i11 = i22;
   i12 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i5 = i13;
   i6 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   do if ((i11 | 0) < (i5 | 0) | (i11 | 0) == (i5 | 0) & i12 >>> 0 < i6 >>> 0) i1 = i23; else {
    i1 = i23;
    while (1) {
     i1 = i1 + -8 | 0;
     if ((i22 | 0) == (i1 | 0)) break;
     i7 = i1;
     i8 = HEAP32[i7 >> 2] | 0;
     i7 = HEAP32[i7 + 4 >> 2] | 0;
     if ((i7 | 0) < (i5 | 0) | (i7 | 0) == (i5 | 0) & i8 >>> 0 < i6 >>> 0) {
      i21 = 28;
      break;
     }
    }
    if ((i21 | 0) == 28) {
     i21 = 0;
     i2 = i22;
     HEAP32[i2 >> 2] = i8;
     HEAP32[i2 + 4 >> 2] = i7;
     i2 = i1;
     HEAP32[i2 >> 2] = i12;
     HEAP32[i2 + 4 >> 2] = i11;
     i4 = i4 + 1 | 0;
     break;
    }
    i4 = i22 + 8 | 0;
    i7 = i23;
    i6 = HEAP32[i7 >> 2] | 0;
    i7 = HEAP32[i7 + 4 >> 2] | 0;
    if (!((i11 | 0) < (i7 | 0) | (i11 | 0) == (i7 | 0) & i12 >>> 0 < i6 >>> 0)) {
     if ((i4 | 0) == (i23 | 0)) {
      i21 = 45;
      break L1;
     } else i5 = i4;
     while (1) {
      i1 = i5;
      i2 = HEAP32[i1 >> 2] | 0;
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      i4 = i5 + 8 | 0;
      if ((i11 | 0) < (i1 | 0) | (i11 | 0) == (i1 | 0) & i12 >>> 0 < i2 >>> 0) break;
      if ((i4 | 0) == (i23 | 0)) {
       i21 = 45;
       break L1;
      } else i5 = i4;
     }
     i14 = i5;
     HEAP32[i14 >> 2] = i6;
     HEAP32[i14 + 4 >> 2] = i7;
     i14 = i23;
     HEAP32[i14 >> 2] = i2;
     HEAP32[i14 + 4 >> 2] = i1;
    }
    if ((i4 | 0) == (i23 | 0)) {
     i21 = 45;
     break L1;
    } else i5 = i23;
    while (1) {
     i10 = i22;
     i9 = HEAP32[i10 >> 2] | 0;
     i10 = HEAP32[i10 + 4 >> 2] | 0;
     while (1) {
      i6 = i4;
      i7 = HEAP32[i6 >> 2] | 0;
      i6 = HEAP32[i6 + 4 >> 2] | 0;
      i8 = i4 + 8 | 0;
      if ((i10 | 0) < (i6 | 0) | (i10 | 0) == (i6 | 0) & i9 >>> 0 < i7 >>> 0) break; else i4 = i8;
     }
     do {
      i5 = i5 + -8 | 0;
      i1 = i5;
      i2 = HEAP32[i1 >> 2] | 0;
      i1 = HEAP32[i1 + 4 >> 2] | 0;
     } while ((i10 | 0) < (i1 | 0) | (i10 | 0) == (i1 | 0) & i9 >>> 0 < i2 >>> 0);
     if (i4 >>> 0 >= i5 >>> 0) {
      i22 = i4;
      continue L3;
     }
     HEAP32[i4 >> 2] = i2;
     HEAP32[i4 + 4 >> 2] = i1;
     i4 = i5;
     HEAP32[i4 >> 2] = i7;
     HEAP32[i4 + 4 >> 2] = i6;
     i4 = i8;
    }
   } while (0);
   i2 = i22 + 8 | 0;
   L34 : do if (i2 >>> 0 < i1 >>> 0) while (1) {
    i5 = i13;
    i6 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    i11 = i2;
    while (1) {
     i7 = i11;
     i8 = HEAP32[i7 >> 2] | 0;
     i7 = HEAP32[i7 + 4 >> 2] | 0;
     i2 = i11 + 8 | 0;
     if ((i7 | 0) < (i5 | 0) | (i7 | 0) == (i5 | 0) & i8 >>> 0 < i6 >>> 0) i11 = i2; else {
      i12 = i1;
      break;
     }
    }
    do {
     i12 = i12 + -8 | 0;
     i9 = i12;
     i10 = HEAP32[i9 >> 2] | 0;
     i9 = HEAP32[i9 + 4 >> 2] | 0;
    } while (!((i9 | 0) < (i5 | 0) | (i9 | 0) == (i5 | 0) & i10 >>> 0 < i6 >>> 0));
    if (i11 >>> 0 > i12 >>> 0) {
     i10 = i11;
     i2 = i13;
     break L34;
    }
    i1 = i11;
    HEAP32[i1 >> 2] = i10;
    HEAP32[i1 + 4 >> 2] = i9;
    i1 = i12;
    HEAP32[i1 >> 2] = i8;
    HEAP32[i1 + 4 >> 2] = i7;
    i1 = i12;
    i13 = (i13 | 0) == (i11 | 0) ? i12 : i13;
    i4 = i4 + 1 | 0;
   } else {
    i10 = i2;
    i2 = i13;
   } while (0);
   if ((i10 | 0) != (i2 | 0) ? (i17 = i2, i16 = HEAP32[i17 >> 2] | 0, i17 = HEAP32[i17 + 4 >> 2] | 0, i19 = i10, i18 = HEAP32[i19 >> 2] | 0, i19 = HEAP32[i19 + 4 >> 2] | 0, (i17 | 0) < (i19 | 0) | (i17 | 0) == (i19 | 0) & i16 >>> 0 < i18 >>> 0) : 0) {
    i13 = i10;
    HEAP32[i13 >> 2] = i16;
    HEAP32[i13 + 4 >> 2] = i17;
    i13 = i2;
    HEAP32[i13 >> 2] = i18;
    HEAP32[i13 + 4 >> 2] = i19;
    i4 = i4 + 1 | 0;
   }
   if (!i4) {
    i4 = __ZNSt3__127__insertion_sort_incompleteIRNS_6__lessIxxEEPxEEbT0_S5_T_(i22, i10, i20) | 0;
    i2 = i10 + 8 | 0;
    if (__ZNSt3__127__insertion_sort_incompleteIRNS_6__lessIxxEEPxEEbT0_S5_T_(i2, i3, i20) | 0) {
     i21 = 40;
     break;
    }
    if (i4) {
     i22 = i2;
     continue;
    }
   }
   i13 = i10;
   if ((i13 - i14 | 0) >= (i15 - i13 | 0)) {
    i21 = 44;
    break;
   }
   __ZNSt3__16__sortIRNS_6__lessIxxEEPxEEvT0_S5_T_(i22, i10, i20);
   i22 = i10 + 8 | 0;
  }
  if ((i21 | 0) == 40) {
   i21 = 0;
   if (i4) {
    i21 = 45;
    break;
   } else {
    i4 = i22;
    i3 = i10;
    continue;
   }
  } else if ((i21 | 0) == 44) {
   i21 = 0;
   __ZNSt3__16__sortIRNS_6__lessIxxEEPxEEvT0_S5_T_(i10 + 8 | 0, i3, i20);
   i4 = i22;
   i3 = i10;
   continue;
  }
 }
 if ((i21 | 0) == 4) {
  i1 = i23;
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i22;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if (!((i1 | 0) < (i3 | 0) | (i1 | 0) == (i3 | 0) & i4 >>> 0 < i2 >>> 0)) {
   STACKTOP = i24;
   return;
  }
  HEAP32[i22 >> 2] = i4;
  HEAP32[i22 + 4 >> 2] = i1;
  i22 = i23;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i22 + 4 >> 2] = i3;
  STACKTOP = i24;
  return;
 } else if ((i21 | 0) == 6) {
  __ZNSt3__17__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i22, i22 + 8 | 0, i23, i20) | 0;
  STACKTOP = i24;
  return;
 } else if ((i21 | 0) == 7) {
  __ZNSt3__17__sort4IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_T_(i22, i22 + 8 | 0, i22 + 16 | 0, i23, i20) | 0;
  STACKTOP = i24;
  return;
 } else if ((i21 | 0) == 8) {
  __ZNSt3__17__sort5IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_S5_T_(i22, i22 + 8 | 0, i22 + 16 | 0, i22 + 24 | 0, i23, i20) | 0;
  STACKTOP = i24;
  return;
 } else if ((i21 | 0) == 10) {
  __ZNSt3__118__insertion_sort_3IRNS_6__lessIxxEEPxEEvT0_S5_T_(i22, i3, i20);
  STACKTOP = i24;
  return;
 } else if ((i21 | 0) == 45) {
  STACKTOP = i24;
  return;
 }
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i23, i19, i20, i21, i17, i22, i18, i3, i16) {
 i23 = i23 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 i22 = i22 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i9 = i25 + 20 | 0;
 i8 = i25 + 16 | 0;
 i15 = i25 + 12 | 0;
 i10 = i25 + 8 | 0;
 i11 = i25 + 4 | 0;
 i12 = i25;
 __ZNKSt3__18ios_base6getlocEv(i15, i17);
 i13 = __ZNKSt3__16locale9use_facetERNS0_2idE(i15, 960728) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i15 >> 2] | 0) | 0;
 HEAP32[i22 >> 2] = 0;
 L1 : do if ((i3 | 0) != (i16 | 0)) {
  i15 = i13 + 8 | 0;
  i2 = 0;
  L3 : while (1) {
   while (1) {
    if (i2) {
     i24 = 60;
     break L1;
    }
    i1 = HEAP32[i20 >> 2] | 0;
    if (i1) {
     if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
      HEAP32[i20 >> 2] = 0;
      i1 = 0;
     }
    } else i1 = 0;
    i2 = (i1 | 0) == 0;
    i4 = HEAP32[i21 >> 2] | 0;
    do if (i4) {
     if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i4 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1 : 0) {
      HEAP32[i21 >> 2] = 0;
      i24 = 14;
      break;
     }
     if (!i2) {
      i24 = 15;
      break L3;
     }
    } else i24 = 14; while (0);
    if ((i24 | 0) == 14) {
     i24 = 0;
     if (i2) {
      i24 = 15;
      break L3;
     } else i4 = 0;
    }
    if ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] & 63](i13, HEAP8[i3 >> 0] | 0, 0) | 0) << 24 >> 24 == 37) {
     i24 = 17;
     break;
    }
    i2 = HEAP8[i3 >> 0] | 0;
    if (i2 << 24 >> 24 > -1 ? (i14 = HEAP32[i15 >> 2] | 0, (HEAP16[i14 + (i2 << 24 >> 24 << 1) >> 1] & 8192) != 0) : 0) {
     i24 = 28;
     break;
    }
    i5 = i1 + 12 | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    i2 = i1 + 16 | 0;
    if ((i4 | 0) == (HEAP32[i2 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i4 = HEAPU8[i4 >> 0] | 0;
    i4 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] & 127](i13, i4 & 255) | 0;
    if (i4 << 24 >> 24 == (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] & 127](i13, HEAP8[i3 >> 0] | 0) | 0) << 24 >> 24) {
     i24 = 55;
     break;
    }
    HEAP32[i22 >> 2] = 4;
    i2 = 4;
   }
   L31 : do if ((i24 | 0) == 17) {
    i24 = 0;
    i2 = i3 + 1 | 0;
    if ((i2 | 0) == (i16 | 0)) {
     i24 = 18;
     break L3;
    }
    i6 = FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] & 63](i13, HEAP8[i2 >> 0] | 0, 0) | 0;
    if (i6 << 24 >> 24 == 48 | i6 << 24 >> 24 == 69) {
     i3 = i3 + 2 | 0;
     if ((i3 | 0) == (i16 | 0)) {
      i24 = 21;
      break L3;
     }
     i2 = i3;
     i5 = FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] & 63](i13, HEAP8[i3 >> 0] | 0, 0) | 0;
     i3 = i6;
    } else {
     i5 = i6;
     i3 = 0;
    }
    i6 = HEAP32[(HEAP32[i19 >> 2] | 0) + 36 >> 2] | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i12 >> 2] = i4;
    HEAP32[i8 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
    HEAP32[i9 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
    FUNCTION_TABLE_viiiiiiiii[i6 & 7](i10, i19, i8, i9, i17, i22, i18, i5, i3);
    HEAP32[i20 >> 2] = HEAP32[i10 >> 2];
    i3 = i2 + 1 | 0;
   } else if ((i24 | 0) == 28) {
    while (1) {
     i24 = 0;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i16 | 0)) {
      i3 = i16;
      break;
     }
     i2 = HEAP8[i3 >> 0] | 0;
     if (i2 << 24 >> 24 <= -1) break;
     if (!(HEAP16[i14 + (i2 << 24 >> 24 << 1) >> 1] & 8192)) break; else i24 = 28;
    }
    i6 = i4;
    i5 = i4;
    while (1) {
     if (i1) {
      if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
       HEAP32[i20 >> 2] = 0;
       i1 = 0;
      }
     } else i1 = 0;
     i4 = (i1 | 0) == 0;
     do if (i5) {
      if ((HEAP32[i5 + 12 >> 2] | 0) != (HEAP32[i5 + 16 >> 2] | 0)) if (i4) {
       i2 = i6;
       i7 = i5;
       break;
      } else break L31;
      if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] & 127](i5) | 0) != -1) if (i4 ^ (i6 | 0) == 0) {
       i2 = i6;
       i7 = i6;
       break;
      } else break L31; else {
       HEAP32[i21 >> 2] = 0;
       i2 = 0;
       i24 = 41;
       break;
      }
     } else {
      i2 = i6;
      i24 = 41;
     } while (0);
     if ((i24 | 0) == 41) {
      i24 = 0;
      if (i4) break L31; else i7 = 0;
     }
     i6 = i1 + 12 | 0;
     i5 = HEAP32[i6 >> 2] | 0;
     i4 = i1 + 16 | 0;
     if ((i5 | 0) == (HEAP32[i4 >> 2] | 0)) i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i5 = HEAPU8[i5 >> 0] | 0;
     if ((i5 & 255) << 24 >> 24 <= -1) break L31;
     if (!(HEAP16[(HEAP32[i15 >> 2] | 0) + (i5 << 24 >> 24 << 1) >> 1] & 8192)) break L31;
     i5 = HEAP32[i6 >> 2] | 0;
     if ((i5 | 0) == (HEAP32[i4 >> 2] | 0)) {
      FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0;
      i6 = i2;
      i5 = i7;
      continue;
     } else {
      HEAP32[i6 >> 2] = i5 + 1;
      i6 = i2;
      i5 = i7;
      continue;
     }
    }
   } else if ((i24 | 0) == 55) {
    i24 = 0;
    i4 = HEAP32[i5 >> 2] | 0;
    if ((i4 | 0) == (HEAP32[i2 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0; else HEAP32[i5 >> 2] = i4 + 1;
    i3 = i3 + 1 | 0;
   } while (0);
   if ((i3 | 0) == (i16 | 0)) {
    i24 = 60;
    break L1;
   }
   i2 = HEAP32[i22 >> 2] | 0;
  }
  if ((i24 | 0) == 15) {
   HEAP32[i22 >> 2] = 4;
   break;
  } else if ((i24 | 0) == 18) {
   HEAP32[i22 >> 2] = 4;
   break;
  } else if ((i24 | 0) == 21) {
   HEAP32[i22 >> 2] = 4;
   break;
  }
 } else i24 = 60; while (0);
 if ((i24 | 0) == 60) i1 = HEAP32[i20 >> 2] | 0;
 if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
   HEAP32[i20 >> 2] = 0;
   i1 = 0;
  }
 } else i1 = 0;
 i2 = (i1 | 0) == 0;
 i3 = HEAP32[i21 >> 2] | 0;
 do if (i3) {
  if ((HEAP32[i3 + 12 >> 2] | 0) == (HEAP32[i3 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0) == -1 : 0) {
   HEAP32[i21 >> 2] = 0;
   i24 = 70;
   break;
  }
  if (i2) {
   HEAP32[i23 >> 2] = i1;
   STACKTOP = i25;
   return;
  }
 } else i24 = 70; while (0);
 if ((i24 | 0) == 70 ? !i2 : 0) {
  HEAP32[i23 >> 2] = i1;
  STACKTOP = i25;
  return;
 }
 HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | 2;
 HEAP32[i23 >> 2] = i1;
 STACKTOP = i25;
 return;
}

function __ZN2cvL14MulTransposedRIffEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d28) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d28 = +d28;
 var d4 = 0.0, d5 = 0.0, d6 = 0.0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, f30 = f0, d31 = 0.0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i27 = i29;
 i25 = HEAP32[i3 + 16 >> 2] | 0;
 i18 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i26 = (HEAP32[i3 + 48 >> 2] | 0) >>> 2;
 i24 = (HEAP32[i1 + 48 >> 2] | 0) >>> 2;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i9 = (HEAP32[i2 + 48 >> 2] | 0) >>> 2; else i9 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i20 = HEAP32[i3 + 40 >> 2] | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = i27 + 8 | 0;
 HEAP32[i27 >> 2] = i21;
 i22 = i27 + 4 | 0;
 HEAP32[i22 >> 2] = 1032;
 i3 = (i7 | 0) != 0;
 i2 = (i2 | 0) < (i19 | 0);
 if (i3 & i2) i1 = i20 * 20 | 0; else i1 = i20 << 2;
 if (i1 >>> 0 > 1032) {
  i23 = __Znaj(i1) | 0;
  HEAP32[i27 >> 2] = i23;
 } else i23 = i21;
 HEAP32[i22 >> 2] = i1;
 do if (i3) {
  if (i2) {
   i2 = i23 + (i20 << 2) | 0;
   if ((i20 | 0) > 0) {
    i3 = 0;
    do {
     f30 = Math_fround(HEAPF32[i7 + ((Math_imul(i3, i9) | 0) << 2) >> 2]);
     i16 = i3 << 2;
     HEAPF32[i23 + ((i16 | 3) + i20 << 2) >> 2] = f30;
     HEAPF32[i23 + ((i16 | 2) + i20 << 2) >> 2] = f30;
     HEAPF32[i23 + ((i16 | 1) + i20 << 2) >> 2] = f30;
     HEAPF32[i23 + (i16 + i20 << 2) >> 2] = f30;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if (!i2) {
    i17 = 14;
    break;
   } else {
    i7 = i2;
    i16 = i2;
    i9 = (i9 | 0) != 0 ? 4 : 0;
   }
  } else i16 = 0;
  if ((i19 | 0) > 0) {
   i11 = (i16 | 0) != 0;
   i13 = (i20 | 0) > 0;
   i12 = i19 + -4 | 0;
   i14 = 0;
   i15 = i18;
   while (1) {
    if (i11) {
     if (i13) {
      i3 = 0;
      do {
       f30 = Math_fround(HEAPF32[i25 + ((Math_imul(i3, i26) | 0) + i14 << 2) >> 2]);
       HEAPF32[i23 + (i3 << 2) >> 2] = Math_fround(f30 - Math_fround(HEAPF32[i16 + ((Math_imul(i3, i9) | 0) << 2) >> 2]));
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i20 | 0));
     }
    } else if (i13) {
     i3 = 0;
     do {
      f30 = Math_fround(HEAPF32[i25 + ((Math_imul(i3, i26) | 0) + i14 << 2) >> 2]);
      HEAPF32[i23 + (i3 << 2) >> 2] = Math_fround(f30 - Math_fround(HEAPF32[i7 + ((Math_imul(i3, i9) | 0) + i14 << 2) >> 2]));
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i20 | 0));
    }
    if ((i14 | 0) > (i12 | 0)) i3 = i14; else {
     i3 = i14;
     do {
      if (i11) i2 = i16; else i2 = i7 + (i3 << 2) | 0;
      if (i13) {
       i10 = 0;
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
       i1 = i25 + (i3 << 2) | 0;
       while (1) {
        d31 = +Math_fround(HEAPF32[i23 + (i10 << 2) >> 2]);
        f30 = Math_fround(HEAPF32[i1 >> 2]);
        d4 = d4 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 >> 2]));
        f30 = Math_fround(HEAPF32[i1 + 4 >> 2]);
        d5 = d5 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 + 4 >> 2]));
        f30 = Math_fround(HEAPF32[i1 + 8 >> 2]);
        d6 = d6 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 + 8 >> 2]));
        f30 = Math_fround(HEAPF32[i1 + 12 >> 2]);
        d8 = d8 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 + 12 >> 2]));
        i10 = i10 + 1 | 0;
        if ((i10 | 0) == (i20 | 0)) break; else {
         i2 = i2 + (i9 << 2) | 0;
         i1 = i1 + (i26 << 2) | 0;
        }
       }
      } else {
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
      }
      HEAPF32[i15 + (i3 << 2) >> 2] = Math_fround(d4 * d28);
      HEAPF32[i15 + (i3 + 1 << 2) >> 2] = Math_fround(d5 * d28);
      HEAPF32[i15 + (i3 + 2 << 2) >> 2] = Math_fround(d6 * d28);
      HEAPF32[i15 + (i3 + 3 << 2) >> 2] = Math_fround(d8 * d28);
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i12 | 0));
    }
    if ((i3 | 0) < (i19 | 0)) do {
     if (i11) i2 = i16; else i2 = i7 + (i3 << 2) | 0;
     if (i13) {
      i1 = 0;
      d8 = 0.0;
      i10 = i25 + (i3 << 2) | 0;
      while (1) {
       d4 = +Math_fround(HEAPF32[i23 + (i1 << 2) >> 2]);
       f30 = Math_fround(HEAPF32[i10 >> 2]);
       d8 = d8 + d4 * +Math_fround(f30 - Math_fround(HEAPF32[i2 >> 2]));
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i20 | 0)) break; else {
        i2 = i2 + (i9 << 2) | 0;
        i10 = i10 + (i26 << 2) | 0;
       }
      }
     } else d8 = 0.0;
     HEAPF32[i15 + (i3 << 2) >> 2] = Math_fround(d8 * d28);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i19 | 0));
    i14 = i14 + 1 | 0;
    if ((i14 | 0) == (i19 | 0)) break; else i15 = i15 + (i24 << 2) | 0;
   }
  }
 } else i17 = 14; while (0);
 if ((i17 | 0) == 14 ? (i19 | 0) > 0 : 0) {
  i11 = (i20 | 0) > 0;
  i12 = i19 + -4 | 0;
  i13 = 0;
  i10 = i18;
  while (1) {
   if (i11) {
    i3 = 0;
    do {
     HEAPF32[i23 + (i3 << 2) >> 2] = Math_fround(HEAPF32[i25 + ((Math_imul(i3, i26) | 0) + i13 << 2) >> 2]);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if ((i13 | 0) > (i12 | 0)) i3 = i13; else {
    i3 = i13;
    do {
     if (i11) {
      i9 = 0;
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
      i7 = i25 + (i3 << 2) | 0;
      while (1) {
       d31 = +Math_fround(HEAPF32[i23 + (i9 << 2) >> 2]);
       d8 = d8 + d31 * +Math_fround(HEAPF32[i7 >> 2]);
       d6 = d6 + d31 * +Math_fround(HEAPF32[i7 + 4 >> 2]);
       d5 = d5 + d31 * +Math_fround(HEAPF32[i7 + 8 >> 2]);
       d4 = d4 + d31 * +Math_fround(HEAPF32[i7 + 12 >> 2]);
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == (i20 | 0)) break; else i7 = i7 + (i26 << 2) | 0;
      }
     } else {
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
     }
     HEAPF32[i10 + (i3 << 2) >> 2] = Math_fround(d8 * d28);
     HEAPF32[i10 + (i3 + 1 << 2) >> 2] = Math_fround(d6 * d28);
     HEAPF32[i10 + (i3 + 2 << 2) >> 2] = Math_fround(d5 * d28);
     HEAPF32[i10 + (i3 + 3 << 2) >> 2] = Math_fround(d4 * d28);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i12 | 0));
   }
   if ((i3 | 0) < (i19 | 0)) do {
    if (i11) {
     i2 = 0;
     d4 = 0.0;
     i1 = i25 + (i3 << 2) | 0;
     while (1) {
      d5 = +Math_fround(HEAPF32[i23 + (i2 << 2) >> 2]);
      d4 = d4 + d5 * +Math_fround(HEAPF32[i1 >> 2]);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break; else i1 = i1 + (i26 << 2) | 0;
     }
    } else d4 = 0.0;
    HEAPF32[i10 + (i3 << 2) >> 2] = Math_fround(d4 * d28);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i19 | 0));
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i19 | 0)) break; else i10 = i10 + (i24 << 2) | 0;
  }
 }
 if ((i23 | 0) == (i21 | 0)) {
  STACKTOP = i29;
  return;
 }
 __ZdaPv(i23);
 HEAP32[i27 >> 2] = i21;
 HEAP32[i22 >> 2] = 1032;
 STACKTOP = i29;
 return;
}

function __ZNK2cv4UMat6copyToERKNS_12_OutputArrayE(i18, i12) {
 i18 = i18 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 i5 = i19 + 488 | 0;
 i16 = i19 + 360 | 0;
 i7 = i19 + 232 | 0;
 i14 = i19 + 104 | 0;
 i17 = i19 + 56 | 0;
 i15 = i19;
 i6 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i12 >> 2] | 0) + 56 >> 2] & 127](i12, -1) | 0;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i12 >> 2] | 0) + 108 >> 2] & 127](i12) | 0 ? (i4 = HEAP32[i18 >> 2] | 0, (i6 | 0) != (i4 & 4095 | 0)) : 0) {
  if ((i4 ^ i6) & 4088) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i3 = (__ZN2cv6String8allocateEj(i5, 30) | 0) + 0 | 0;
   i2 = 18096 | 0;
   i1 = i3 + 30 | 0;
   do {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    i3 = i3 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i3 | 0) < (i1 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 18128, 17672, 626);
   __ZN2cv6String10deallocateEv(i5);
  }
  __ZNK2cv4UMat9convertToERKNS_12_OutputArrayEidd(i18, i12, i6, 1.0, 0.0);
  STACKTOP = i19;
  return;
 }
 i11 = i18 + 24 | 0;
 if (HEAP32[i11 >> 2] | 0) {
  i13 = i18 + 4 | 0;
  i9 = HEAP32[i13 >> 2] | 0;
  if ((i9 | 0) < 3) i4 = Math_imul(HEAP32[i18 + 12 >> 2] | 0, HEAP32[i18 + 8 >> 2] | 0) | 0; else {
   i6 = HEAP32[i18 + 32 >> 2] | 0;
   i5 = 0;
   i4 = 1;
   do {
    i4 = Math_imul(HEAP32[i6 + (i5 << 2) >> 2] | 0, i4) | 0;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  if (i4) {
   if ((i9 | 0) <= 0) if (!i9) {
    HEAP32[i16 + -4 >> 2] = 0;
    i10 = i7;
    i6 = 0;
    i9 = 0;
   } else {
    i3 = 0;
    i8 = 17;
   } else {
    i3 = HEAP32[(HEAP32[i18 + 36 >> 2] | 0) + (i9 + -1 << 2) >> 2] | 0;
    i8 = 17;
   }
   if ((i8 | 0) == 17) {
    i5 = HEAP32[i18 + 32 >> 2] | 0;
    i4 = 0;
    do {
     HEAP32[i16 + (i4 << 2) >> 2] = HEAP32[i5 + (i4 << 2) >> 2];
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < i9 >>> 0);
    i10 = i16 + (i9 + -1 << 2) | 0;
    HEAP32[i10 >> 2] = Math_imul(HEAP32[i10 >> 2] | 0, i3) | 0;
    if ((i9 | 0) > 0) {
     i6 = HEAP32[i18 + 36 >> 2] | 0;
     i5 = 0;
     i4 = HEAP32[i18 + 28 >> 2] | 0;
     do {
      i10 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
      i8 = (i4 >>> 0) / (i10 >>> 0) | 0;
      HEAP32[i7 + (i5 << 2) >> 2] = i8;
      i4 = i4 - (Math_imul(i8, i10) | 0) | 0;
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) < (i9 | 0));
     i10 = i7;
     i6 = i9;
     i9 = i3;
    } else {
     i10 = i7;
     i6 = i9;
     i9 = i3;
    }
   }
   i8 = i7 + (i6 + -1 << 2) | 0;
   HEAP32[i8 >> 2] = Math_imul(HEAP32[i8 >> 2] | 0, i9) | 0;
   FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i12 >> 2] | 0) + 144 >> 2] & 63](i12, i6, HEAP32[i18 + 32 >> 2] | 0, HEAP32[i18 >> 2] & 4095, -1, 0, 0);
   do if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i12 >> 2] | 0) + 24 >> 2] & 127](i12) | 0) == 655360) {
    FUNCTION_TABLE_viii[HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] & 63](i17, i12, -1);
    i1 = HEAP32[i11 >> 2] | 0;
    i8 = i17 + 24 | 0;
    i7 = HEAP32[i8 >> 2] | 0;
    if ((i1 | 0) == (i7 | 0) ? (HEAP32[i17 + 28 >> 2] | 0) == (HEAP32[i18 + 28 >> 2] | 0) : 0) {
     if ((i1 | 0) != 0 ? (i9 = i1 + 8 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) {
      i10 = HEAP32[i8 >> 2] | 0;
      i9 = HEAP32[i10 + 4 >> 2] | 0;
      FUNCTION_TABLE_vii[HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] & 127](i9, i10);
      HEAP32[i8 >> 2] = 0;
     }
     HEAP32[HEAP32[i17 + 32 >> 2] >> 2] = 0;
     HEAP32[i8 >> 2] = 0;
     i1 = HEAP32[i17 + 36 >> 2] | 0;
     if ((i1 | 0) == (i17 + 40 | 0)) {
      STACKTOP = i19;
      return;
     }
     __ZN2cv8fastFreeEPv(i1);
     STACKTOP = i19;
     return;
    }
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    if ((i2 | 0) != (HEAP32[i7 + 4 >> 2] | 0)) {
     if ((i7 | 0) != 0 ? (i7 = i7 + 8 | 0, i9 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) {
      i9 = HEAP32[i8 >> 2] | 0;
      i7 = HEAP32[i9 + 4 >> 2] | 0;
      FUNCTION_TABLE_vii[HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] & 127](i7, i9);
      HEAP32[i8 >> 2] = 0;
     }
     HEAP32[HEAP32[i17 + 32 >> 2] >> 2] = 0;
     HEAP32[i8 >> 2] = 0;
     i3 = HEAP32[i17 + 36 >> 2] | 0;
     if ((i3 | 0) == (i17 + 40 | 0)) break;
     __ZN2cv8fastFreeEPv(i3);
     break;
    }
    i6 = HEAP32[i17 + 4 >> 2] | 0;
    if ((i6 | 0) > 0) {
     i5 = HEAP32[i17 + 36 >> 2] | 0;
     i4 = 0;
     i3 = HEAP32[i17 + 28 >> 2] | 0;
     do {
      i11 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
      i12 = (i3 >>> 0) / (i11 >>> 0) | 0;
      HEAP32[i14 + (i4 << 2) >> 2] = i12;
      i3 = i3 - (Math_imul(i12, i11) | 0) | 0;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) < (i6 | 0));
    } else i5 = HEAP32[i17 + 36 >> 2] | 0;
    i6 = HEAP32[i13 >> 2] | 0;
    i4 = i14 + (i6 + -1 << 2) | 0;
    HEAP32[i4 >> 2] = Math_imul(HEAP32[i4 >> 2] | 0, i9) | 0;
    i4 = i17 + 36 | 0;
    FUNCTION_TABLE_viiiiiiiiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 1](i2, i1, i7, i6, i16, i10, HEAP32[i18 + 36 >> 2] | 0, i14, i5, 0);
    i1 = HEAP32[i8 >> 2] | 0;
    if ((i1 | 0) != 0 ? (i9 = i1 + 8 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) {
     i10 = HEAP32[i8 >> 2] | 0;
     i9 = HEAP32[i10 + 4 >> 2] | 0;
     FUNCTION_TABLE_vii[HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] & 127](i9, i10);
     HEAP32[i8 >> 2] = 0;
    }
    HEAP32[HEAP32[i17 + 32 >> 2] >> 2] = 0;
    HEAP32[i8 >> 2] = 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if ((i1 | 0) == (i17 + 40 | 0)) {
     STACKTOP = i19;
     return;
    }
    __ZN2cv8fastFreeEPv(i1);
    STACKTOP = i19;
    return;
   } while (0);
   FUNCTION_TABLE_viii[HEAP32[HEAP32[i12 >> 2] >> 2] & 63](i15, i12, -1);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i4 = i15 + 16 | 0;
   i5 = i15 + 44 | 0;
   FUNCTION_TABLE_viiiiiiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] & 255](i2, i1, HEAP32[i4 >> 2] | 0, HEAP32[i13 >> 2] | 0, i16, i10, HEAP32[i18 + 36 >> 2] | 0, HEAP32[i5 >> 2] | 0);
   i1 = i15 + 36 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != 0 ? (i9 = i2 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i15);
   HEAP32[i1 >> 2] = 0;
   i3 = i15 + 4 | 0;
   HEAP32[i4 + 0 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i2 = HEAP32[i15 + 40 >> 2] | 0;
    i1 = 0;
    do {
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
   }
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i15 + 48 | 0)) {
    STACKTOP = i19;
    return;
   }
   __ZN2cv8fastFreeEPv(i1);
   STACKTOP = i19;
   return;
  }
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i12 >> 2] | 0) + 152 >> 2] & 511](i12);
 STACKTOP = i19;
 return;
}

function __GLOBAL__I_a743() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i3;
 HEAP32[39888] = 320;
 HEAP32[39889] = 240;
 HEAP32[39890] = 640;
 HEAP32[39891] = 480;
 HEAP32[39892] = 800;
 HEAP32[39893] = 600;
 HEAP32[39894] = 1024;
 HEAP32[39895] = 768;
 HEAP32[39896] = 1280;
 HEAP32[39897] = 1024;
 HEAP32[39898] = 2560;
 HEAP32[39899] = 1440;
 HEAP32[39900] = 640;
 HEAP32[39901] = 360;
 HEAP32[39902] = 960;
 HEAP32[39903] = 540;
 HEAP32[39904] = HEAP32[39888];
 HEAP32[39905] = HEAP32[39889];
 HEAP32[39906] = 1280;
 HEAP32[39907] = 720;
 HEAP32[39908] = 1920;
 HEAP32[39909] = 1080;
 HEAP32[39910] = HEAP32[39898];
 HEAP32[39911] = HEAP32[39899];
 HEAP32[39912] = 3840;
 HEAP32[39913] = 2160;
 HEAP32[39914] = 7680;
 HEAP32[39915] = 4320;
 HEAP32[39916] = 2048;
 HEAP32[39917] = 1536;
 HEAP32[39918] = 2592;
 HEAP32[39919] = 1944;
 HEAP32[39920] = 2048;
 HEAP32[39921] = 2048;
 HEAP32[39922] = 127;
 HEAP32[39923] = 61;
 HEAP32[39924] = 24;
 HEAP32[39925] = 24;
 HEAP32[39926] = 32;
 HEAP32[39927] = 32;
 HEAP32[39928] = 64;
 HEAP32[39929] = 64;
 HEAP32[39930] = 128;
 HEAP32[39931] = 128;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 159760);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 if (!i1) i1 = 0; else i1 = (_strcmp(i1, 163600) | 0) != 0 & 1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 HEAP8[159752] = i1;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 159792);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 if (!i1) i1 = 0; else i1 = (_strcmp(i1, 163600) | 0) != 0 & 1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 HEAP8[159784] = i1;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 159824);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 if (!i1) i1 = 1; else i1 = (_strcmp(i1, 163600) | 0) != 0 & 1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 HEAP8[159816] = i1;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 159864);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 i1 = (i1 | 0) == 0 ? 159872 : i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(159848, i1, _strlen(i1 | 0) | 0);
 ___cxa_atexit(377, 159848, ___dso_handle | 0) | 0;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 159896);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 i1 = (i1 | 0) == 0 ? 160496 : i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(159880, i1, _strlen(i1 | 0) | 0);
 ___cxa_atexit(377, 159880, ___dso_handle | 0) | 0;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 159920);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 i1 = (i1 | 0) == 0 ? 160496 : i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(159904, i1, _strlen(i1 | 0) | 0);
 ___cxa_atexit(377, 159904, ___dso_handle | 0) | 0;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 159960);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 i1 = (i1 | 0) == 0 ? 159968 : i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(159944, i1, _strlen(i1 | 0) | 0);
 ___cxa_atexit(377, 159944, ___dso_handle | 0) | 0;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 159984);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 if (!i1) i1 = 1; else i1 = (_strcmp(i1, 163600) | 0) != 0 & 1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 HEAP8[159976] = i1;
 HEAP32[4e4] = __ZN7testing8internal17Int32FromGTestEnvEPKci(160008, 0) | 0;
 HEAP32[40006] = __ZN7testing8internal17Int32FromGTestEnvEPKci(160032, 1) | 0;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 160048);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 if (!i1) i1 = 0; else i1 = (_strcmp(i1, 163600) | 0) != 0 & 1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 HEAP8[160040] = i1;
 HEAP32[40014] = __ZN7testing8internal17Int32FromGTestEnvEPKci(160064, 100) | 0;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 160104);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 i1 = (i1 | 0) == 0 ? 159968 : i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(160088, i1, _strlen(i1 | 0) | 0);
 ___cxa_atexit(377, 160088, ___dso_handle | 0) | 0;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 160136);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 if (!i1) i1 = 0; else i1 = (_strcmp(i1, 163600) | 0) != 0 & 1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 HEAP8[160128] = i1;
 HEAP32[40114] = 0;
 HEAP32[40115] = 0;
 HEAP32[40116] = 0;
 ___cxa_atexit(377, 160456, ___dso_handle | 0) | 0;
 HEAP32[40126] = 168776;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 164608);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 i1 = (i1 | 0) == 0 ? 164632 : i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(164592, i1, _strlen(i1 | 0) | 0);
 ___cxa_atexit(377, 164592, ___dso_handle | 0) | 0;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i2, 164648);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = _getenv(i1 | 0) | 0;
 if (!i1) {
  i1 = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
  HEAP8[164640] = i1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(163824, 159968, 0);
  ___cxa_atexit(377, 163824, ___dso_handle | 0) | 0;
  STACKTOP = i3;
  return;
 }
 i1 = (_strcmp(i1, 163600) | 0) != 0 & 1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 HEAP8[164640] = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(163824, 159968, 0);
 ___cxa_atexit(377, 163824, ___dso_handle | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZN2cvL14MulTransposedRIsfEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d28) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d28 = +d28;
 var d4 = 0.0, d5 = 0.0, d6 = 0.0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, f30 = f0, d31 = 0.0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i27 = i29;
 i25 = HEAP32[i3 + 16 >> 2] | 0;
 i18 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i26 = (HEAP32[i3 + 48 >> 2] | 0) >>> 1;
 i24 = (HEAP32[i1 + 48 >> 2] | 0) >>> 2;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i9 = (HEAP32[i2 + 48 >> 2] | 0) >>> 2; else i9 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i20 = HEAP32[i3 + 40 >> 2] | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = i27 + 8 | 0;
 HEAP32[i27 >> 2] = i21;
 i22 = i27 + 4 | 0;
 HEAP32[i22 >> 2] = 1032;
 i3 = (i7 | 0) != 0;
 i2 = (i2 | 0) < (i19 | 0);
 if (i3 & i2) i1 = i20 * 20 | 0; else i1 = i20 << 2;
 if (i1 >>> 0 > 1032) {
  i23 = __Znaj(i1) | 0;
  HEAP32[i27 >> 2] = i23;
 } else i23 = i21;
 HEAP32[i22 >> 2] = i1;
 do if (i3) {
  if (i2) {
   i2 = i23 + (i20 << 2) | 0;
   if ((i20 | 0) > 0) {
    i3 = 0;
    do {
     f30 = Math_fround(HEAPF32[i7 + ((Math_imul(i3, i9) | 0) << 2) >> 2]);
     i16 = i3 << 2;
     HEAPF32[i23 + ((i16 | 3) + i20 << 2) >> 2] = f30;
     HEAPF32[i23 + ((i16 | 2) + i20 << 2) >> 2] = f30;
     HEAPF32[i23 + ((i16 | 1) + i20 << 2) >> 2] = f30;
     HEAPF32[i23 + (i16 + i20 << 2) >> 2] = f30;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if (!i2) {
    i17 = 14;
    break;
   } else {
    i7 = i2;
    i16 = i2;
    i9 = (i9 | 0) != 0 ? 4 : 0;
   }
  } else i16 = 0;
  if ((i19 | 0) > 0) {
   i11 = (i16 | 0) != 0;
   i13 = (i20 | 0) > 0;
   i12 = i19 + -4 | 0;
   i14 = 0;
   i15 = i18;
   while (1) {
    if (i11) {
     if (i13) {
      i3 = 0;
      do {
       f30 = Math_fround(HEAP16[i25 + ((Math_imul(i3, i26) | 0) + i14 << 1) >> 1] | 0);
       HEAPF32[i23 + (i3 << 2) >> 2] = Math_fround(f30 - Math_fround(HEAPF32[i16 + ((Math_imul(i3, i9) | 0) << 2) >> 2]));
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i20 | 0));
     }
    } else if (i13) {
     i3 = 0;
     do {
      f30 = Math_fround(HEAP16[i25 + ((Math_imul(i3, i26) | 0) + i14 << 1) >> 1] | 0);
      HEAPF32[i23 + (i3 << 2) >> 2] = Math_fround(f30 - Math_fround(HEAPF32[i7 + ((Math_imul(i3, i9) | 0) + i14 << 2) >> 2]));
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i20 | 0));
    }
    if ((i14 | 0) > (i12 | 0)) i3 = i14; else {
     i3 = i14;
     do {
      if (i11) i2 = i16; else i2 = i7 + (i3 << 2) | 0;
      if (i13) {
       i10 = 0;
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
       i1 = i25 + (i3 << 1) | 0;
       while (1) {
        d31 = +Math_fround(HEAPF32[i23 + (i10 << 2) >> 2]);
        f30 = Math_fround(HEAP16[i1 >> 1] | 0);
        d4 = d4 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 >> 2]));
        f30 = Math_fround(HEAP16[i1 + 2 >> 1] | 0);
        d5 = d5 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 + 4 >> 2]));
        f30 = Math_fround(HEAP16[i1 + 4 >> 1] | 0);
        d6 = d6 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 + 8 >> 2]));
        f30 = Math_fround(HEAP16[i1 + 6 >> 1] | 0);
        d8 = d8 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 + 12 >> 2]));
        i10 = i10 + 1 | 0;
        if ((i10 | 0) == (i20 | 0)) break; else {
         i2 = i2 + (i9 << 2) | 0;
         i1 = i1 + (i26 << 1) | 0;
        }
       }
      } else {
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
      }
      HEAPF32[i15 + (i3 << 2) >> 2] = Math_fround(d4 * d28);
      HEAPF32[i15 + (i3 + 1 << 2) >> 2] = Math_fround(d5 * d28);
      HEAPF32[i15 + (i3 + 2 << 2) >> 2] = Math_fround(d6 * d28);
      HEAPF32[i15 + (i3 + 3 << 2) >> 2] = Math_fround(d8 * d28);
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i12 | 0));
    }
    if ((i3 | 0) < (i19 | 0)) do {
     if (i11) i2 = i16; else i2 = i7 + (i3 << 2) | 0;
     if (i13) {
      i1 = 0;
      d8 = 0.0;
      i10 = i25 + (i3 << 1) | 0;
      while (1) {
       d4 = +Math_fround(HEAPF32[i23 + (i1 << 2) >> 2]);
       f30 = Math_fround(HEAP16[i10 >> 1] | 0);
       d8 = d8 + d4 * +Math_fround(f30 - Math_fround(HEAPF32[i2 >> 2]));
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i20 | 0)) break; else {
        i2 = i2 + (i9 << 2) | 0;
        i10 = i10 + (i26 << 1) | 0;
       }
      }
     } else d8 = 0.0;
     HEAPF32[i15 + (i3 << 2) >> 2] = Math_fround(d8 * d28);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i19 | 0));
    i14 = i14 + 1 | 0;
    if ((i14 | 0) == (i19 | 0)) break; else i15 = i15 + (i24 << 2) | 0;
   }
  }
 } else i17 = 14; while (0);
 if ((i17 | 0) == 14 ? (i19 | 0) > 0 : 0) {
  i11 = (i20 | 0) > 0;
  i12 = i19 + -4 | 0;
  i13 = 0;
  i10 = i18;
  while (1) {
   if (i11) {
    i3 = 0;
    do {
     HEAPF32[i23 + (i3 << 2) >> 2] = Math_fround(HEAP16[i25 + ((Math_imul(i3, i26) | 0) + i13 << 1) >> 1] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if ((i13 | 0) > (i12 | 0)) i3 = i13; else {
    i3 = i13;
    do {
     if (i11) {
      i9 = 0;
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
      i7 = i25 + (i3 << 1) | 0;
      while (1) {
       d31 = +Math_fround(HEAPF32[i23 + (i9 << 2) >> 2]);
       d8 = d8 + d31 * +(HEAP16[i7 >> 1] | 0);
       d6 = d6 + d31 * +(HEAP16[i7 + 2 >> 1] | 0);
       d5 = d5 + d31 * +(HEAP16[i7 + 4 >> 1] | 0);
       d4 = d4 + d31 * +(HEAP16[i7 + 6 >> 1] | 0);
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == (i20 | 0)) break; else i7 = i7 + (i26 << 1) | 0;
      }
     } else {
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
     }
     HEAPF32[i10 + (i3 << 2) >> 2] = Math_fround(d8 * d28);
     HEAPF32[i10 + (i3 + 1 << 2) >> 2] = Math_fround(d6 * d28);
     HEAPF32[i10 + (i3 + 2 << 2) >> 2] = Math_fround(d5 * d28);
     HEAPF32[i10 + (i3 + 3 << 2) >> 2] = Math_fround(d4 * d28);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i12 | 0));
   }
   if ((i3 | 0) < (i19 | 0)) do {
    if (i11) {
     i2 = 0;
     d4 = 0.0;
     i1 = i25 + (i3 << 1) | 0;
     while (1) {
      d5 = +Math_fround(HEAPF32[i23 + (i2 << 2) >> 2]);
      d4 = d4 + d5 * +(HEAP16[i1 >> 1] | 0);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break; else i1 = i1 + (i26 << 1) | 0;
     }
    } else d4 = 0.0;
    HEAPF32[i10 + (i3 << 2) >> 2] = Math_fround(d4 * d28);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i19 | 0));
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i19 | 0)) break; else i10 = i10 + (i24 << 2) | 0;
  }
 }
 if ((i23 | 0) == (i21 | 0)) {
  STACKTOP = i29;
  return;
 }
 __ZdaPv(i23);
 HEAP32[i27 >> 2] = i21;
 HEAP32[i22 >> 2] = 1032;
 STACKTOP = i29;
 return;
}
function __ZN2cvL14MulTransposedRIhfEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d28) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d28 = +d28;
 var d4 = 0.0, d5 = 0.0, d6 = 0.0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, f30 = f0, d31 = 0.0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i27 = i29;
 i25 = HEAP32[i3 + 16 >> 2] | 0;
 i18 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i26 = HEAP32[i3 + 48 >> 2] | 0;
 i24 = (HEAP32[i1 + 48 >> 2] | 0) >>> 2;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i9 = (HEAP32[i2 + 48 >> 2] | 0) >>> 2; else i9 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i20 = HEAP32[i3 + 40 >> 2] | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = i27 + 8 | 0;
 HEAP32[i27 >> 2] = i21;
 i22 = i27 + 4 | 0;
 HEAP32[i22 >> 2] = 1032;
 i3 = (i7 | 0) != 0;
 i2 = (i2 | 0) < (i19 | 0);
 if (i3 & i2) i1 = i20 * 20 | 0; else i1 = i20 << 2;
 if (i1 >>> 0 > 1032) {
  i23 = __Znaj(i1) | 0;
  HEAP32[i27 >> 2] = i23;
 } else i23 = i21;
 HEAP32[i22 >> 2] = i1;
 do if (i3) {
  if (i2) {
   i2 = i23 + (i20 << 2) | 0;
   if ((i20 | 0) > 0) {
    i3 = 0;
    do {
     f30 = Math_fround(HEAPF32[i7 + ((Math_imul(i3, i9) | 0) << 2) >> 2]);
     i16 = i3 << 2;
     HEAPF32[i23 + ((i16 | 3) + i20 << 2) >> 2] = f30;
     HEAPF32[i23 + ((i16 | 2) + i20 << 2) >> 2] = f30;
     HEAPF32[i23 + ((i16 | 1) + i20 << 2) >> 2] = f30;
     HEAPF32[i23 + (i16 + i20 << 2) >> 2] = f30;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if (!i2) {
    i17 = 14;
    break;
   } else {
    i7 = i2;
    i16 = i2;
    i9 = (i9 | 0) != 0 ? 4 : 0;
   }
  } else i16 = 0;
  if ((i19 | 0) > 0) {
   i11 = (i16 | 0) != 0;
   i13 = (i20 | 0) > 0;
   i12 = i19 + -4 | 0;
   i14 = 0;
   i15 = i18;
   while (1) {
    if (i11) {
     if (i13) {
      i3 = 0;
      do {
       f30 = Math_fround(HEAPU8[i25 + ((Math_imul(i3, i26) | 0) + i14) >> 0] | 0 | 0);
       HEAPF32[i23 + (i3 << 2) >> 2] = Math_fround(f30 - Math_fround(HEAPF32[i16 + ((Math_imul(i3, i9) | 0) << 2) >> 2]));
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i20 | 0));
     }
    } else if (i13) {
     i3 = 0;
     do {
      f30 = Math_fround(HEAPU8[i25 + ((Math_imul(i3, i26) | 0) + i14) >> 0] | 0 | 0);
      HEAPF32[i23 + (i3 << 2) >> 2] = Math_fround(f30 - Math_fround(HEAPF32[i7 + ((Math_imul(i3, i9) | 0) + i14 << 2) >> 2]));
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i20 | 0));
    }
    if ((i14 | 0) > (i12 | 0)) i3 = i14; else {
     i3 = i14;
     do {
      if (i11) i2 = i16; else i2 = i7 + (i3 << 2) | 0;
      if (i13) {
       i10 = 0;
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
       i1 = i25 + i3 | 0;
       while (1) {
        d31 = +Math_fround(HEAPF32[i23 + (i10 << 2) >> 2]);
        f30 = Math_fround(HEAPU8[i1 >> 0] | 0 | 0);
        d4 = d4 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 >> 2]));
        f30 = Math_fround(HEAPU8[i1 + 1 >> 0] | 0 | 0);
        d5 = d5 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 + 4 >> 2]));
        f30 = Math_fround(HEAPU8[i1 + 2 >> 0] | 0 | 0);
        d6 = d6 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 + 8 >> 2]));
        f30 = Math_fround(HEAPU8[i1 + 3 >> 0] | 0 | 0);
        d8 = d8 + d31 * +Math_fround(f30 - Math_fround(HEAPF32[i2 + 12 >> 2]));
        i10 = i10 + 1 | 0;
        if ((i10 | 0) == (i20 | 0)) break; else {
         i2 = i2 + (i9 << 2) | 0;
         i1 = i1 + i26 | 0;
        }
       }
      } else {
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
      }
      HEAPF32[i15 + (i3 << 2) >> 2] = Math_fround(d4 * d28);
      HEAPF32[i15 + (i3 + 1 << 2) >> 2] = Math_fround(d5 * d28);
      HEAPF32[i15 + (i3 + 2 << 2) >> 2] = Math_fround(d6 * d28);
      HEAPF32[i15 + (i3 + 3 << 2) >> 2] = Math_fround(d8 * d28);
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i12 | 0));
    }
    if ((i3 | 0) < (i19 | 0)) do {
     if (i11) i2 = i16; else i2 = i7 + (i3 << 2) | 0;
     if (i13) {
      i1 = 0;
      d8 = 0.0;
      i10 = i25 + i3 | 0;
      while (1) {
       d4 = +Math_fround(HEAPF32[i23 + (i1 << 2) >> 2]);
       f30 = Math_fround(HEAPU8[i10 >> 0] | 0 | 0);
       d8 = d8 + d4 * +Math_fround(f30 - Math_fround(HEAPF32[i2 >> 2]));
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i20 | 0)) break; else {
        i2 = i2 + (i9 << 2) | 0;
        i10 = i10 + i26 | 0;
       }
      }
     } else d8 = 0.0;
     HEAPF32[i15 + (i3 << 2) >> 2] = Math_fround(d8 * d28);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i19 | 0));
    i14 = i14 + 1 | 0;
    if ((i14 | 0) == (i19 | 0)) break; else i15 = i15 + (i24 << 2) | 0;
   }
  }
 } else i17 = 14; while (0);
 if ((i17 | 0) == 14 ? (i19 | 0) > 0 : 0) {
  i11 = (i20 | 0) > 0;
  i12 = i19 + -4 | 0;
  i13 = 0;
  i10 = i18;
  while (1) {
   if (i11) {
    i3 = 0;
    do {
     HEAPF32[i23 + (i3 << 2) >> 2] = Math_fround(HEAPU8[i25 + ((Math_imul(i3, i26) | 0) + i13) >> 0] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if ((i13 | 0) > (i12 | 0)) i3 = i13; else {
    i3 = i13;
    do {
     if (i11) {
      i9 = 0;
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
      i7 = i25 + i3 | 0;
      while (1) {
       d31 = +Math_fround(HEAPF32[i23 + (i9 << 2) >> 2]);
       d8 = d8 + d31 * +(HEAPU8[i7 >> 0] | 0 | 0);
       d6 = d6 + d31 * +(HEAPU8[i7 + 1 >> 0] | 0 | 0);
       d5 = d5 + d31 * +(HEAPU8[i7 + 2 >> 0] | 0 | 0);
       d4 = d4 + d31 * +(HEAPU8[i7 + 3 >> 0] | 0 | 0);
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == (i20 | 0)) break; else i7 = i7 + i26 | 0;
      }
     } else {
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
     }
     HEAPF32[i10 + (i3 << 2) >> 2] = Math_fround(d8 * d28);
     HEAPF32[i10 + (i3 + 1 << 2) >> 2] = Math_fround(d6 * d28);
     HEAPF32[i10 + (i3 + 2 << 2) >> 2] = Math_fround(d5 * d28);
     HEAPF32[i10 + (i3 + 3 << 2) >> 2] = Math_fround(d4 * d28);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i12 | 0));
   }
   if ((i3 | 0) < (i19 | 0)) do {
    if (i11) {
     i2 = 0;
     d4 = 0.0;
     i1 = i25 + i3 | 0;
     while (1) {
      d5 = +Math_fround(HEAPF32[i23 + (i2 << 2) >> 2]);
      d4 = d4 + d5 * +(HEAPU8[i1 >> 0] | 0 | 0);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break; else i1 = i1 + i26 | 0;
     }
    } else d4 = 0.0;
    HEAPF32[i10 + (i3 << 2) >> 2] = Math_fround(d4 * d28);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i19 | 0));
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i19 | 0)) break; else i10 = i10 + (i24 << 2) | 0;
  }
 }
 if ((i23 | 0) == (i21 | 0)) {
  STACKTOP = i29;
  return;
 }
 __ZdaPv(i23);
 HEAP32[i27 >> 2] = i21;
 HEAP32[i22 >> 2] = 1032;
 STACKTOP = i29;
 return;
}

function __ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i(i33, i35, i34, i32, i6, i20, i19, i24, i25, i21, i28, i23, i27, i26, i22) {
 i33 = i33 | 0;
 i35 = i35 | 0;
 i34 = i34 | 0;
 i32 = i32 | 0;
 i6 = i6 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i21 = i21 | 0;
 i28 = i28 | 0;
 i23 = i23 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i29 = 0, i30 = 0, i31 = 0, i36 = 0;
 i36 = STACKTOP;
 HEAP32[i34 >> 2] = i33;
 i31 = i26 + 4 | 0;
 i30 = i26 + 8 | 0;
 i12 = (i32 & 512 | 0) == 0;
 i13 = i27 + 4 | 0;
 i14 = i27 + 8 | 0;
 i15 = (i22 | 0) > 0;
 i16 = i23 + 1 | 0;
 i17 = i23 + 8 | 0;
 i18 = i23 + 4 | 0;
 i10 = 0;
 do {
  switch (HEAP8[i25 + i10 >> 0] | 0) {
  case 3:
   {
    i5 = HEAP8[i26 >> 0] | 0;
    i4 = (i5 & 1) == 0;
    if (i4) i5 = (i5 & 255) >>> 1; else i5 = HEAP32[i31 >> 2] | 0;
    if (i5) {
     if (i4) i5 = i31; else i5 = HEAP32[i30 >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     i1 = HEAP32[i34 >> 2] | 0;
     HEAP32[i34 >> 2] = i1 + 4;
     HEAP32[i1 >> 2] = i2;
    }
    break;
   }
  case 4:
   {
    i5 = HEAP32[i34 >> 2] | 0;
    i6 = i24 ? i6 + 4 | 0 : i6;
    L14 : do if (i6 >>> 0 < i20 >>> 0) {
     i3 = i6;
     while (1) {
      i4 = i3 + 4 | 0;
      if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] & 63](i19, 2048, HEAP32[i3 >> 2] | 0) | 0)) {
       i4 = i3;
       break L14;
      }
      if (i4 >>> 0 < i20 >>> 0) i3 = i4; else break;
     }
    } else i4 = i6; while (0);
    if (i15) {
     if (i4 >>> 0 > i6 >>> 0) {
      i2 = HEAP32[i34 >> 2] | 0;
      i1 = i22;
      do {
       i4 = i4 + -4 | 0;
       i3 = i2;
       i2 = i2 + 4 | 0;
       HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
       i1 = i1 + -1 | 0;
       i3 = (i1 | 0) > 0;
      } while (i4 >>> 0 > i6 >>> 0 & i3);
      HEAP32[i34 >> 2] = i2;
      if (i3) i29 = 33; else {
       i3 = HEAP32[i34 >> 2] | 0;
       HEAP32[i34 >> 2] = i3 + 4;
      }
     } else {
      i1 = i22;
      i29 = 33;
     }
     if ((i29 | 0) == 33) {
      i29 = 0;
      i8 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i19 >> 2] | 0) + 44 >> 2] & 127](i19, 48) | 0;
      i3 = HEAP32[i34 >> 2] | 0;
      i7 = i3 + 4 | 0;
      HEAP32[i34 >> 2] = i7;
      if ((i1 | 0) > 0) {
       i9 = i3;
       i2 = i1;
       while (1) {
        HEAP32[i9 >> 2] = i8;
        i2 = i2 + -1 | 0;
        if ((i2 | 0) <= 0) break; else {
         i9 = i7;
         i7 = i7 + 4 | 0;
        }
       }
       HEAP32[i34 >> 2] = i3 + (i1 + 1 << 2);
       i3 = i3 + (i1 << 2) | 0;
      }
     }
     HEAP32[i3 >> 2] = i21;
    }
    if ((i4 | 0) == (i6 | 0)) {
     i2 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i19 >> 2] | 0) + 44 >> 2] & 127](i19, 48) | 0;
     i1 = HEAP32[i34 >> 2] | 0;
     i4 = i1 + 4 | 0;
     HEAP32[i34 >> 2] = i4;
     HEAP32[i1 >> 2] = i2;
    } else {
     i3 = HEAP8[i23 >> 0] | 0;
     i2 = (i3 & 1) == 0;
     if (i2) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i18 >> 2] | 0;
     if (!i3) {
      i1 = i4;
      i2 = -1;
      i9 = 0;
      i8 = 0;
     } else {
      if (i2) i3 = i16; else i3 = HEAP32[i17 >> 2] | 0;
      i1 = i4;
      i2 = HEAP8[i3 >> 0] | 0;
      i9 = 0;
      i8 = 0;
     }
     while (1) {
      i4 = HEAP32[i34 >> 2] | 0;
      if ((i8 | 0) == (i2 | 0)) {
       i8 = i4 + 4 | 0;
       HEAP32[i34 >> 2] = i8;
       HEAP32[i4 >> 2] = i28;
       i9 = i9 + 1 | 0;
       i4 = HEAP8[i23 >> 0] | 0;
       i7 = (i4 & 1) == 0;
       if (i7) i4 = (i4 & 255) >>> 1; else i4 = HEAP32[i18 >> 2] | 0;
       if (i9 >>> 0 < i4 >>> 0) {
        if (i7) i4 = i16; else i4 = HEAP32[i17 >> 2] | 0;
        if ((HEAP8[i4 + i9 >> 0] | 0) == 127) {
         i3 = i8;
         i7 = -1;
         i8 = 0;
        } else {
         if (i7) i4 = i16; else i4 = HEAP32[i17 >> 2] | 0;
         i3 = i8;
         i7 = HEAP8[i4 + i9 >> 0] | 0;
         i8 = 0;
        }
       } else {
        i3 = i8;
        i7 = i2;
        i8 = 0;
       }
      } else {
       i3 = i4;
       i7 = i2;
      }
      i1 = i1 + -4 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      i4 = i3 + 4 | 0;
      HEAP32[i34 >> 2] = i4;
      HEAP32[i3 >> 2] = i2;
      if ((i1 | 0) == (i6 | 0)) break; else {
       i2 = i7;
       i8 = i8 + 1 | 0;
      }
     }
    }
    if ((i5 | 0) != (i4 | 0) ? (i11 = i4 + -4 | 0, i11 >>> 0 > i5 >>> 0) : 0) {
     i4 = i11;
     do {
      i1 = HEAP32[i5 >> 2] | 0;
      HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i4 >> 2] = i1;
      i5 = i5 + 4 | 0;
      i4 = i4 + -4 | 0;
     } while (i5 >>> 0 < i4 >>> 0);
    }
    break;
   }
  case 1:
   {
    HEAP32[i35 >> 2] = HEAP32[i34 >> 2];
    i2 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i19 >> 2] | 0) + 44 >> 2] & 127](i19, 32) | 0;
    i1 = HEAP32[i34 >> 2] | 0;
    HEAP32[i34 >> 2] = i1 + 4;
    HEAP32[i1 >> 2] = i2;
    break;
   }
  case 0:
   {
    HEAP32[i35 >> 2] = HEAP32[i34 >> 2];
    break;
   }
  case 2:
   {
    i3 = HEAP8[i27 >> 0] | 0;
    i5 = (i3 & 1) == 0;
    if (i5) i4 = (i3 & 255) >>> 1; else i4 = HEAP32[i13 >> 2] | 0;
    if (!((i4 | 0) == 0 | i12)) {
     if (i5) {
      i7 = i13;
      i4 = (i3 & 255) >>> 1;
     } else {
      i7 = HEAP32[i14 >> 2] | 0;
      i4 = HEAP32[i13 >> 2] | 0;
     }
     i1 = i7 + (i4 << 2) | 0;
     i5 = HEAP32[i34 >> 2] | 0;
     if ((i7 | 0) != (i1 | 0)) {
      i2 = (i7 + (i4 + -1 << 2) - i7 | 0) >>> 2;
      i3 = i5;
      i4 = i7;
      while (1) {
       HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
       i4 = i4 + 4 | 0;
       if ((i4 | 0) == (i1 | 0)) break; else i3 = i3 + 4 | 0;
      }
      i5 = i5 + (i2 + 1 << 2) | 0;
     }
     HEAP32[i34 >> 2] = i5;
    }
    break;
   }
  default:
   {}
  }
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != 4);
 i3 = HEAP8[i26 >> 0] | 0;
 i1 = (i3 & 1) == 0;
 if (i1) i2 = (i3 & 255) >>> 1; else i2 = HEAP32[i31 >> 2] | 0;
 if (i2 >>> 0 > 1) {
  if (i1) {
   i4 = i31;
   i2 = (i3 & 255) >>> 1;
  } else {
   i4 = HEAP32[i30 >> 2] | 0;
   i2 = HEAP32[i31 >> 2] | 0;
  }
  i5 = i4 + 4 | 0;
  i6 = i4 + (i2 << 2) | 0;
  i1 = HEAP32[i34 >> 2] | 0;
  if ((i5 | 0) != (i6 | 0)) {
   i4 = (i4 + (i2 + -1 << 2) - i5 | 0) >>> 2;
   i3 = i1;
   i2 = i5;
   while (1) {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    i2 = i2 + 4 | 0;
    if ((i2 | 0) == (i6 | 0)) break; else i3 = i3 + 4 | 0;
   }
   i1 = i1 + (i4 + 1 << 2) | 0;
  }
  HEAP32[i34 >> 2] = i1;
 }
 i1 = i32 & 176;
 if ((i1 | 0) == 16) {
  STACKTOP = i36;
  return;
 } else if ((i1 | 0) == 32) {
  HEAP32[i35 >> 2] = HEAP32[i34 >> 2];
  STACKTOP = i36;
  return;
 } else {
  HEAP32[i35 >> 2] = i33;
  STACKTOP = i36;
  return;
 }
}

function __ZN7testing4Test19HasSameFixtureClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i13 + 12 | 0;
 i11 = i13 + 8 | 0;
 i6 = i13 + 4 | 0;
 i9 = i13;
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i8 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i8, 163728);
  HEAP32[40934] = i8;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i3 = HEAP32[40934] | 0;
 i1 = HEAP32[HEAP32[(HEAP32[i3 + 104 >> 2] | 0) + 20 >> 2] >> 2] | 0;
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = i1 + 12 | 0;
 if (!(HEAP8[i2 >> 0] & 1)) i7 = i2 + 1 | 0; else i7 = HEAP32[i1 + 20 >> 2] | 0;
 i8 = HEAP32[i3 + 108 >> 2] | 0;
 i5 = HEAP32[i8 + 32 >> 2] | 0;
 i2 = i8 + 12 | 0;
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i8 + 20 >> 2] | 0;
 if ((i5 | 0) == (i4 | 0)) {
  i10 = 1;
  STACKTOP = i13;
  return i10 | 0;
 }
 i3 = (i4 | 0) == 168776;
 if (i3 | (i5 | 0) == 168776) {
  i6 = i3 ? i7 : i1;
  i3 = i3 ? i1 : i7;
  i1 = __Znwj(24) | 0;
  HEAP32[i1 >> 2] = 1;
  HEAP32[i1 + 4 >> 2] = 160160;
  HEAP32[i1 + 8 >> 2] = 3477;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1 + 12 | 0, 160840, 6);
  HEAP32[i10 >> 2] = i1;
  __ZN7testing7MessageC2Ev(i11);
  i4 = HEAP32[i11 >> 2] | 0;
  i5 = i4 + 8 | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 160848, 63) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 160912, 58) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 160976, 23) | 0;
  if (HEAP8[i8 >> 0] & 1) {
   i2 = HEAP32[i8 + 8 >> 2] | 0;
   if (!i2) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 160784, 6) | 0; else i12 = 16;
  } else {
   i2 = i8 + 1 | 0;
   i12 = 16;
  }
  if ((i12 | 0) == 16) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, i2, _strlen(i2 | 0) | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 160760, 2) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 161e3, 5) | 0;
  if (!i3) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, i3, _strlen(i3 | 0) | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 161008, 29) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 161e3, 5) | 0;
  if (!i6) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, i6, _strlen(i6 | 0) | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 161040, 38) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 161080, 61) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, 161144, 5) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i10, i11);
  if (i4) {
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 511](i4);
   HEAP32[i11 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 12 | 0);
  __ZdlPv(i1);
  i10 = 0;
  STACKTOP = i13;
  return i10 | 0;
 } else {
  i5 = __Znwj(24) | 0;
  HEAP32[i5 >> 2] = 1;
  HEAP32[i5 + 4 >> 2] = 160160;
  HEAP32[i5 + 8 >> 2] = 3489;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5 + 12 | 0, 160840, 6);
  HEAP32[i6 >> 2] = i5;
  __ZN7testing7MessageC2Ev(i9);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = i4 + 8 | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 160848, 63) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 161152, 30) | 0;
  if (HEAP8[i8 >> 0] & 1) {
   i2 = HEAP32[i8 + 8 >> 2] | 0;
   if (!i2) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 160784, 6) | 0; else i12 = 30;
  } else {
   i2 = i8 + 1 | 0;
   i12 = 30;
  }
  if ((i12 | 0) == 30) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, i2, _strlen(i2 | 0) | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 160760, 2) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 161184, 17) | 0;
  if (!i7) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, i7, _strlen(i7 | 0) | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 161208, 10) | 0;
  if (!i1) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, i1, _strlen(i1 | 0) | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 160800, 1) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 161224, 62) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 161288, 61) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 161352, 62) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 161416, 58) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i6, i9);
  if (i4) {
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 511](i4);
   HEAP32[i9 >> 2] = 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5 + 12 | 0);
  __ZdlPv(i5);
  i10 = 0;
  STACKTOP = i13;
  return i10 | 0;
 }
 return 0;
}

function __ZN2cv3Mat7reserveEj(i19, i8) {
 i19 = i19 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i9 = i21 + 152 | 0;
 i10 = i21 + 144 | 0;
 i2 = i21 + 136 | 0;
 i20 = i21 + 80 | 0;
 i12 = i21 + 24 | 0;
 i11 = i21;
 if ((i8 | 0) <= -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i2, 16) | 0) + 0 | 0;
  i1 = 28192;
  i7 = i4 + 16 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i4 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 28216, 27528, 739);
  __ZN2cv6String10deallocateEv(i2);
 }
 if ((HEAP32[i19 >> 2] & 32768 | 0) == 0 ? (i7 = (HEAP32[i19 + 16 >> 2] | 0) + (Math_imul(HEAP32[HEAP32[i19 + 44 >> 2] >> 2] | 0, i8) | 0) | 0, i7 >>> 0 <= (HEAP32[i19 + 28 >> 2] | 0) >>> 0) : 0) {
  STACKTOP = i21;
  return;
 }
 i17 = i19 + 40 | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i18 = HEAP32[i3 >> 2] | 0;
 if (i18 >>> 0 >= i8 >>> 0) {
  STACKTOP = i21;
  return;
 }
 HEAP32[i3 >> 2] = (i8 | 0) < 1 ? 1 : i8;
 i14 = i19 + 4 | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 if ((i6 | 0) < 3) i2 = Math_imul(HEAP32[i19 + 12 >> 2] | 0, HEAP32[i19 + 8 >> 2] | 0) | 0; else {
  i3 = HEAP32[i17 >> 2] | 0;
  i5 = 0;
  i2 = 1;
  do {
   i2 = Math_imul(HEAP32[i3 + (i5 << 2) >> 2] | 0, i2) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i6 | 0));
 }
 if ((i6 | 0) > 0) i1 = HEAP32[(HEAP32[i19 + 44 >> 2] | 0) + (i6 + -1 << 2) >> 2] | 0; else i1 = 0;
 i2 = Math_imul(i1, i2) | 0;
 if (i2 >>> 0 < 64) {
  HEAP32[i3 >> 2] = ((Math_imul(i2 + 63 | 0, i8) | 0) >>> 0) / (i2 >>> 0) | 0;
  i5 = HEAP32[i14 >> 2] | 0;
 } else i5 = i6;
 i6 = HEAP32[i19 >> 2] & 4095;
 HEAP32[i20 >> 2] = 1124007936;
 i16 = i20 + 4 | 0;
 i8 = i20 + 8 | 0;
 i13 = i20 + 40 | 0;
 i4 = i16 + 0 | 0;
 i7 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i7 | 0));
 HEAP32[i13 >> 2] = i8;
 i15 = i20 + 48 | 0;
 i7 = i20 + 44 | 0;
 HEAP32[i7 >> 2] = i15;
 HEAP32[i20 + 52 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 __ZN2cv3Mat6createEiPKii(i20, i5, i3, i6);
 HEAP32[HEAP32[i17 >> 2] >> 2] = i18;
 if ((i18 | 0) > 0) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = i18;
  HEAP32[i10 >> 2] = -2147483648;
  HEAP32[i10 + 4 >> 2] = 2147483647;
  __ZN2cv3MatC2ERKS0_RKNS_5RangeES5_(i12, i20, i9, i10);
  i6 = i11 + 4 | 0;
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i11 >> 2] = 32232;
  HEAP32[i6 >> 2] = 33619968;
  HEAP32[i11 + 8 >> 2] = i12;
  __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i19, i11);
  i6 = i12 + 36 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) != 0 ? (i9 = i3 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2) {
    i3 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i3) {
     i3 = HEAP32[i12 + 32 >> 2] | 0;
     if (!i3) {
      if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
       i10 = __Znwj(4) | 0;
       HEAP32[i10 >> 2] = 32784;
       HEAP32[6904] = i10;
       ___cxa_guard_release(27624);
      }
      i3 = HEAP32[6904] | 0;
      i2 = HEAP32[i6 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3, i2);
   }
   HEAP32[i6 >> 2] = 0;
  }
  HEAP32[i6 >> 2] = 0;
  i10 = i12 + 16 | 0;
  i3 = i12 + 4 | 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i12 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i2 = HEAP32[i12 + 44 >> 2] | 0;
  if ((i2 | 0) != (i12 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 }
 if ((i20 | 0) == (i19 | 0)) {
  i5 = i20 + 36 | 0;
  i2 = i19 + 24 | 0;
  i1 = HEAP32[i19 + 16 >> 2] | 0;
  i3 = HEAP32[i19 + 36 >> 2] | 0;
 } else {
  i6 = i20 + 36 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2) {
   i10 = i2 + 12 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  __ZN2cv3Mat7releaseEv(i19);
  HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
  i2 = HEAP32[i16 >> 2] | 0;
  if (!((HEAP32[i14 >> 2] | 0) < 3 & (i2 | 0) < 3)) {
   __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i19, i2, 0, 0, 0);
   if ((HEAP32[i14 >> 2] | 0) > 0) {
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = HEAP32[i17 >> 2] | 0;
    i1 = HEAP32[i7 >> 2] | 0;
    i4 = HEAP32[i19 + 44 >> 2] | 0;
    i5 = 0;
    do {
     HEAP32[i2 + (i5 << 2) >> 2] = HEAP32[i3 + (i5 << 2) >> 2];
     HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i1 + (i5 << 2) >> 2];
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) < (HEAP32[i14 >> 2] | 0));
   }
  } else {
   HEAP32[i14 >> 2] = i2;
   HEAP32[i19 + 8 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i19 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   i9 = HEAP32[i7 >> 2] | 0;
   i10 = HEAP32[i19 + 44 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  }
  i1 = HEAP32[i20 + 16 >> 2] | 0;
  HEAP32[i19 + 16 >> 2] = i1;
  HEAP32[i19 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
  i2 = i19 + 24 | 0;
  HEAP32[i2 >> 2] = HEAP32[i20 + 24 >> 2];
  HEAP32[i19 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
  HEAP32[i19 + 32 >> 2] = HEAP32[i20 + 32 >> 2];
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i19 + 36 >> 2] = i3;
  i5 = i6;
 }
 HEAP32[HEAP32[i17 >> 2] >> 2] = i18;
 HEAP32[i2 >> 2] = i1 + (Math_imul(HEAP32[HEAP32[i19 + 44 >> 2] >> 2] | 0, i18) | 0);
 if ((i3 | 0) != 0 ? (i9 = i3 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i20 + 32 >> 2] | 0;
    if (!i2) {
     if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
      i10 = __Znwj(4) | 0;
      HEAP32[i10 >> 2] = 32784;
      HEAP32[6904] = i10;
      ___cxa_guard_release(27624);
     }
     i2 = HEAP32[6904] | 0;
     i1 = HEAP32[i5 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1);
  }
  HEAP32[i5 >> 2] = 0;
 }
 HEAP32[i5 >> 2] = 0;
 i10 = i20 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i16 >> 2] | 0) > 0) {
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i16 >> 2] | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (i15 | 0)) {
  STACKTOP = i21;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i21;
 return;
}

function __ZL11icvYMLWriteP13CvFileStoragePKcS2_(i20, i4, i23) {
 i20 = i20 | 0;
 i4 = i4 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i6 = i24 + 32 | 0;
 i7 = i24 + 24 | 0;
 i3 = i24 + 16 | 0;
 i12 = i24 + 8 | 0;
 i17 = i24;
 i22 = i20 + 44 | 0;
 i5 = HEAP32[i22 >> 2] | 0;
 if (!i4) i16 = 0; else i16 = (HEAP8[i4 >> 0] | 0) == 0 ? 0 : i4;
 i4 = i5 & 7;
 if (i4 >>> 0 > 4) if ((i4 | 0) == 6 ^ (i16 | 0) != 0) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i6, 85) | 0) + 0 | 0;
  i8 = 13856;
  i9 = i2 + 85 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i8 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i2 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i6, 13944, 8960, 1430);
  __ZN2cv6String10deallocateEv(i6);
  i21 = i5;
 } else i21 = i5; else {
  HEAP32[i20 + 12 >> 2] = 0;
  i21 = (i16 | 0) != 0 ? 38 : 37;
 }
 i11 = (i16 | 0) != 0;
 if (i11) {
  i6 = _strlen(i16 | 0) | 0;
  if (!i6) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i2 = (__ZN2cv6String8allocateEj(i7, 19) | 0) + 0 | 0;
   i8 = 13960;
   i9 = i2 + 19 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i8 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i8 = i8 + 1 | 0;
   } while ((i2 | 0) < (i9 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i7, 13944, 8960, 1442);
   __ZN2cv6String10deallocateEv(i7);
  }
  if ((i6 | 0) > 4096) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i2 = (__ZN2cv6String8allocateEj(i3, 19) | 0) + 0 | 0;
   i8 = 13984;
   i9 = i2 + 19 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i8 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i8 = i8 + 1 | 0;
   } while ((i2 | 0) < (i9 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i3, 13944, 8960, 1445);
   __ZN2cv6String10deallocateEv(i3);
   i14 = i6;
  } else i14 = i6;
 } else i14 = 0;
 i15 = (i23 | 0) != 0;
 if (i15) i19 = _strlen(i23 | 0) | 0; else i19 = 0;
 i13 = (i21 & 8 | 0) == 0;
 i18 = i20 + 72 | 0;
 i7 = HEAP32[i18 >> 2] | 0;
 do if (i13) {
  i3 = i20 + 76 | 0;
  i6 = HEAP32[i3 >> 2] | 0;
  i2 = i20 + 56 | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  if (i7 >>> 0 > (i6 + i5 | 0) >>> 0) {
   HEAP8[i7 >> 0] = 10;
   HEAP8[i7 + 1 >> 0] = 0;
   __ZL7icvPutsP13CvFileStoragePKc(i20, HEAP32[i3 >> 2] | 0);
   i6 = HEAP32[i3 >> 2] | 0;
   HEAP32[i18 >> 2] = i6;
   i5 = HEAP32[i2 >> 2] | 0;
  }
  i4 = HEAP32[i20 + 40 >> 2] | 0;
  if ((i4 | 0) == (i5 | 0)) i4 = i5; else {
   if ((i4 | 0) > (i5 | 0)) {
    _memset(i6 + i5 | 0, 32, i4 - i5 | 0) | 0;
    i6 = HEAP32[i3 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = i4;
  }
  i5 = i6 + i4 | 0;
  HEAP32[i18 >> 2] = i5;
  if ((i21 & 7 | 0) != 6) {
   i1 = i6 + (i4 + 1) | 0;
   HEAP8[i5 >> 0] = 45;
   if (i15) {
    HEAP8[i1 >> 0] = 32;
    i1 = i6 + (i4 + 2) | 0;
   }
  } else i1 = i5;
 } else {
  if (!(i21 & 32)) {
   HEAP8[i7 >> 0] = 44;
   i7 = i7 + 1 | 0;
  }
  i4 = i20 + 76 | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  i5 = i19 + i14 + i7 - i6 | 0;
  if ((i5 | 0) > (HEAP32[i20 + 84 >> 2] | 0) ? (i1 = i20 + 40 | 0, i10 = HEAP32[i1 >> 2] | 0, (i5 - i10 | 0) > 10) : 0) {
   HEAP32[i18 >> 2] = i7;
   i3 = i20 + 56 | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   if (i7 >>> 0 > (i6 + i5 | 0) >>> 0) {
    HEAP8[i7 >> 0] = 10;
    HEAP8[i7 + 1 >> 0] = 0;
    __ZL7icvPutsP13CvFileStoragePKc(i20, HEAP32[i4 >> 2] | 0);
    i6 = HEAP32[i4 >> 2] | 0;
    HEAP32[i18 >> 2] = i6;
    i7 = HEAP32[i1 >> 2] | 0;
    i5 = HEAP32[i3 >> 2] | 0;
   } else i7 = i10;
   if ((i7 | 0) != (i5 | 0)) {
    if ((i7 | 0) > (i5 | 0)) {
     _memset(i6 + i5 | 0, 32, i7 - i5 | 0) | 0;
     i6 = HEAP32[i4 >> 2] | 0;
    }
    HEAP32[i3 >> 2] = i7;
   }
   i1 = i6 + i7 | 0;
   HEAP32[i18 >> 2] = i1;
   break;
  }
  HEAP8[i7 >> 0] = 32;
  i1 = i7 + 1 | 0;
 } while (0);
 if (i11) {
  i11 = HEAP8[i16 >> 0] | 0;
  if (!((i11 + -97 << 24 >> 24 & 255) < 26 | (i11 + -65 << 24 >> 24 & 255) < 26 | i11 << 24 >> 24 == 95)) {
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   i2 = (__ZN2cv6String8allocateEj(i12, 33) | 0) + 0 | 0;
   i8 = 14008;
   i9 = i2 + 33 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i8 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i8 = i8 + 1 | 0;
   } while ((i2 | 0) < (i9 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i12, 13944, 8960, 1480);
   __ZN2cv6String10deallocateEv(i12);
  }
  i7 = i20 + 80 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  if ((i1 + i14 | 0) >>> 0 < i6 >>> 0) i4 = i1; else {
   i2 = i20 + 76 | 0;
   i5 = HEAP32[i2 >> 2] | 0;
   i3 = i1 - i5 | 0;
   i5 = ((i6 - i5 | 0) * 3 | 0) / 2 | 0;
   i6 = i3 + i14 | 0;
   i6 = (i6 | 0) < (i5 | 0) ? i5 : i6;
   i5 = _cvAlloc(i6 + 256 | 0) | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   HEAP32[i18 >> 2] = i5 + ((HEAP32[i18 >> 2] | 0) - i4);
   if ((i3 | 0) > 0) _memcpy(i5 | 0, i4 | 0, i3 | 0) | 0;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i7 >> 2] = i5 + i6;
   i4 = i5 + i3 | 0;
  }
  if ((i14 | 0) > 0) {
   i6 = i17 + 4 | 0;
   i5 = 0;
   do {
    i12 = HEAP8[i16 + i5 >> 0] | 0;
    HEAP8[i4 + i5 >> 0] = i12;
    if (!((i12 + -48 << 24 >> 24 & 255) < 10 | (i12 + -97 << 24 >> 24 & 255) < 26 | (i12 + -65 << 24 >> 24 & 255) < 26) ? !(i12 << 24 >> 24 == 32 | i12 << 24 >> 24 == 45 | i12 << 24 >> 24 == 95) : 0) {
     HEAP32[i17 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
     i2 = (__ZN2cv6String8allocateEj(i17, 80) | 0) + 0 | 0;
     i8 = 14048;
     i9 = i2 + 80 | 0;
     do {
      HEAP8[i2 >> 0] = HEAP8[i8 >> 0] | 0;
      i2 = i2 + 1 | 0;
      i8 = i8 + 1 | 0;
     } while ((i2 | 0) < (i9 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i17, 13944, 8960, 1490);
     __ZN2cv6String10deallocateEv(i17);
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < (i14 | 0));
  }
  i1 = i4 + (i14 + 1) | 0;
  HEAP8[i4 + i14 >> 0] = 58;
  if (i13 & i15) {
   HEAP8[i1 >> 0] = 32;
   i1 = i4 + (i14 + 2) | 0;
  }
 }
 if (!i15) {
  i20 = i1;
  HEAP32[i18 >> 2] = i20;
  i21 = i21 & -33;
  HEAP32[i22 >> 2] = i21;
  STACKTOP = i24;
  return;
 }
 i6 = i20 + 80 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 + i19 | 0) >>> 0 >= i2 >>> 0) {
  i5 = i20 + 76 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i4 = i1 - i3 | 0;
  i2 = ((i2 - i3 | 0) * 3 | 0) / 2 | 0;
  i1 = i4 + i19 | 0;
  i1 = (i1 | 0) < (i2 | 0) ? i2 : i1;
  i2 = _cvAlloc(i1 + 256 | 0) | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  HEAP32[i18 >> 2] = i2 + ((HEAP32[i18 >> 2] | 0) - i3);
  if ((i4 | 0) > 0) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i6 >> 2] = i2 + i1;
  i1 = i2 + i4 | 0;
 }
 _memcpy(i1 | 0, i23 | 0, i19 | 0) | 0;
 i20 = i1 + i19 | 0;
 HEAP32[i18 >> 2] = i20;
 i21 = i21 & -33;
 HEAP32[i22 >> 2] = i21;
 STACKTOP = i24;
 return;
}

function __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i16, i14, i3, d6, d7) {
 i16 = i16 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 d6 = +d6;
 d7 = +d7;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 i30 = i32 + 216 | 0;
 i23 = i32;
 i11 = i32 + 208 | 0;
 i12 = i32 + 200 | 0;
 i22 = i32 + 144 | 0;
 i18 = i32 + 136 | 0;
 i24 = i32 + 80 | 0;
 i15 = i32 + 64 | 0;
 i21 = i32 + 56 | 0;
 i20 = i32 + 24 | 0;
 i19 = i32 + 16 | 0;
 if (+Math_abs(+(d6 + -1.0)) < 2.220446049250313e-16) i1 = +Math_abs(+d7) < 2.220446049250313e-16; else i1 = 0;
 do if ((i3 | 0) < 0) if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i14 >> 2] | 0) + 108 >> 2] & 127](i14) | 0) {
  i10 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i14 >> 2] | 0) + 56 >> 2] & 127](i14, -1) | 0;
  i4 = HEAP32[i16 >> 2] | 0;
  break;
 } else {
  i4 = HEAP32[i16 >> 2] | 0;
  i10 = i4 & 4095;
  break;
 } else {
  i4 = HEAP32[i16 >> 2] | 0;
  i10 = i4 & 4088 | i3 & 7;
 } while (0);
 i3 = i4 & 7;
 i2 = i10 & 7;
 if (!((i3 | 0) != (i2 | 0) | i1 ^ 1)) {
  __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i16, i14);
  STACKTOP = i32;
  return;
 }
 HEAP32[i30 >> 2] = HEAP32[i16 >> 2];
 i28 = i30 + 4 | 0;
 i8 = i16 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 HEAP32[i28 >> 2] = i5;
 i13 = i30 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i16 + 8 >> 2];
 i9 = i30 + 12 | 0;
 HEAP32[i9 >> 2] = HEAP32[i16 + 12 >> 2];
 i25 = i30 + 16 | 0;
 HEAP32[i25 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
 HEAP32[i30 + 32 >> 2] = HEAP32[i16 + 32 >> 2];
 i26 = i30 + 36 | 0;
 i4 = HEAP32[i16 + 36 >> 2] | 0;
 HEAP32[i26 >> 2] = i4;
 i27 = i30 + 40 | 0;
 HEAP32[i27 >> 2] = i13;
 i31 = i30 + 48 | 0;
 i29 = i30 + 44 | 0;
 HEAP32[i29 >> 2] = i31;
 HEAP32[i30 + 52 >> 2] = 0;
 HEAP32[i31 >> 2] = 0;
 if (i4) {
  i5 = i4 + 12 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  i5 = HEAP32[i8 >> 2] | 0;
 }
 if ((i5 | 0) < 3) {
  i4 = HEAP32[i16 + 44 >> 2] | 0;
  i17 = HEAP32[i29 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 } else {
  HEAP32[i28 >> 2] = 0;
  __ZN2cv3Mat8copySizeERKS0_(i30, i16);
 }
 i17 = HEAP32[(i1 ? 43848 : 44120) + (i2 << 5) + (i3 << 2) >> 2] | 0;
 HEAPF64[i23 >> 3] = d6;
 HEAPF64[i23 + 8 >> 3] = d7;
 i2 = ((HEAP32[i16 >> 2] | 0) >>> 3 & 511) + 1 | 0;
 if (!i17) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i11, 9) | 0) + 0 | 0;
  i4 = 43496 | 0;
  i3 = i5 + 9 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i5 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i11, 44104, 43512, 3384);
  __ZN2cv6String10deallocateEv(i11);
 }
 i5 = HEAP32[i8 >> 2] | 0;
 if ((i5 | 0) < 3) {
  i3 = HEAP32[(HEAP32[i14 >> 2] | 0) + 136 >> 2] | 0;
  i20 = HEAP32[i16 + 40 >> 2] | 0;
  i21 = HEAP32[i20 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i12 + 4 >> 2] = i21;
  FUNCTION_TABLE_viiiiii[i3 & 31](i14, i12, i10, -1, 0, 0);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i14 >> 2] >> 2] & 63](i22, i14, -1);
  i3 = HEAP32[i9 >> 2] | 0;
  if (!(HEAP32[i30 >> 2] & 16384 & HEAP32[i22 >> 2])) {
   i2 = Math_imul(i3, i2) | 0;
   i3 = HEAP32[i13 >> 2] | 0;
  } else {
   i2 = Math_imul(Math_imul(i3, i2) | 0, HEAP32[i13 >> 2] | 0) | 0;
   i3 = 1;
  }
  i16 = HEAP32[i25 >> 2] | 0;
  i19 = HEAP32[i31 >> 2] | 0;
  i4 = i22 + 16 | 0;
  i20 = HEAP32[i4 >> 2] | 0;
  i5 = i22 + 48 | 0;
  i21 = HEAP32[i5 >> 2] | 0;
  HEAP32[i18 >> 2] = i2;
  HEAP32[i18 + 4 >> 2] = i3;
  FUNCTION_TABLE_viiiiiiii[i17 & 255](i16, i19, 0, 0, i20, i21, i18, i23);
  i3 = i22 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i23 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i22);
  HEAP32[i3 >> 2] = 0;
  i1 = i22 + 4 | 0;
  HEAP32[i4 + 0 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  if ((HEAP32[i1 >> 2] | 0) > 0) {
   i3 = HEAP32[i22 + 40 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
  }
  i2 = HEAP32[i22 + 44 >> 2] | 0;
  if ((i2 | 0) != (i5 | 0)) __ZN2cv8fastFreeEPv(i2);
 } else {
  FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i14 >> 2] | 0) + 144 >> 2] & 63](i14, i5, HEAP32[i16 + 40 >> 2] | 0, i10, -1, 0, 0);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i14 >> 2] >> 2] & 63](i24, i14, -1);
  HEAP32[i15 >> 2] = i30;
  HEAP32[i15 + 4 >> 2] = i24;
  HEAP32[i15 + 8 >> 2] = 0;
  __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i20, i15, i21, -1);
  i4 = Math_imul(HEAP32[i20 + 20 >> 2] | 0, i2) | 0;
  i3 = i20 + 16 | 0;
  i2 = i21 + 4 | 0;
  i1 = i19 + 4 | 0;
  i5 = 0;
  while (1) {
   if (i5 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) break;
   i18 = HEAP32[i21 >> 2] | 0;
   i22 = HEAP32[i2 >> 2] | 0;
   HEAP32[i19 >> 2] = i4;
   HEAP32[i1 >> 2] = 1;
   FUNCTION_TABLE_viiiiiiii[i17 & 255](i18, 1, 0, 0, i22, 1, i19, i23);
   __ZN2cv15NAryMatIteratorppEv(i20) | 0;
   i5 = i5 + 1 | 0;
  }
  i2 = i24 + 36 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i22 = i1 + 12 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i24);
  HEAP32[i2 >> 2] = 0;
  i23 = i24 + 16 | 0;
  i2 = i24 + 4 | 0;
  HEAP32[i23 + 0 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = 0;
  HEAP32[i23 + 8 >> 2] = 0;
  HEAP32[i23 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i24 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i2 = HEAP32[i24 + 44 >> 2] | 0;
  if ((i2 | 0) != (i24 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 }
 i2 = HEAP32[i26 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i22 = i2 + 12 | 0, i23 = HEAP32[i22 >> 2] | 0, HEAP32[i22 >> 2] = i23 + -1, (i23 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i30);
 HEAP32[i26 >> 2] = 0;
 HEAP32[i25 + 0 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 if ((HEAP32[i28 >> 2] | 0) > 0) {
  i1 = HEAP32[i27 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i28 >> 2] | 0));
 }
 i1 = HEAP32[i29 >> 2] | 0;
 if ((i1 | 0) == (i31 | 0)) {
  STACKTOP = i32;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i32;
 return;
}

function _send_tree(i25, i26, i23) {
 i25 = i25 | 0;
 i26 = i26 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i27 = 0;
 i27 = STACKTOP;
 i24 = HEAP16[i26 + 2 >> 1] | 0;
 i5 = i24 << 16 >> 16 == 0;
 i17 = i25 + 2754 | 0;
 i18 = i25 + 5820 | 0;
 i19 = i25 + 2752 | 0;
 i20 = i25 + 5816 | 0;
 i21 = i25 + 20 | 0;
 i22 = i25 + 8 | 0;
 i12 = i25 + 2758 | 0;
 i13 = i25 + 2756 | 0;
 i14 = i25 + 2750 | 0;
 i15 = i25 + 2748 | 0;
 i6 = i5 ? 138 : 7;
 i5 = i5 ? 3 : 4;
 i1 = 0;
 i24 = i24 & 65535;
 i4 = -1;
 L1 : while (1) {
  i7 = 0;
  while (1) {
   if ((i1 | 0) > (i23 | 0)) break L1;
   i1 = i1 + 1 | 0;
   i10 = HEAP16[i26 + (i1 << 2) + 2 >> 1] | 0;
   i16 = i10 & 65535;
   i2 = i7 + 1 | 0;
   i11 = (i24 | 0) == (i16 | 0);
   if (!((i2 | 0) < (i6 | 0) & i11)) break; else i7 = i2;
  }
  do if ((i2 | 0) >= (i5 | 0)) {
   if (i24) {
    if ((i24 | 0) == (i4 | 0)) {
     i5 = HEAP16[i20 >> 1] | 0;
     i3 = HEAP32[i18 >> 2] | 0;
     i7 = i2;
    } else {
     i6 = HEAPU16[i25 + (i24 << 2) + 2686 >> 1] | 0;
     i2 = HEAP32[i18 >> 2] | 0;
     i4 = HEAPU16[i25 + (i24 << 2) + 2684 >> 1] | 0;
     i3 = HEAPU16[i20 >> 1] | 0 | i4 << i2;
     i5 = i3 & 65535;
     HEAP16[i20 >> 1] = i5;
     if ((i2 | 0) > (16 - i6 | 0)) {
      i5 = HEAP32[i21 >> 2] | 0;
      HEAP32[i21 >> 2] = i5 + 1;
      HEAP8[(HEAP32[i22 >> 2] | 0) + i5 >> 0] = i3;
      i5 = (HEAPU16[i20 >> 1] | 0) >>> 8 & 255;
      i3 = HEAP32[i21 >> 2] | 0;
      HEAP32[i21 >> 2] = i3 + 1;
      HEAP8[(HEAP32[i22 >> 2] | 0) + i3 >> 0] = i5;
      i3 = HEAP32[i18 >> 2] | 0;
      i5 = i4 >>> (16 - i3 | 0) & 65535;
      HEAP16[i20 >> 1] = i5;
      i3 = i6 + -16 + i3 | 0;
     } else i3 = i2 + i6 | 0;
     HEAP32[i18 >> 2] = i3;
    }
    i4 = HEAPU16[i14 >> 1] | 0;
    i6 = HEAPU16[i15 >> 1] | 0;
    i2 = i5 & 65535 | i6 << i3;
    HEAP16[i20 >> 1] = i2;
    if ((i3 | 0) > (16 - i4 | 0)) {
     i5 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i5 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i5 >> 0] = i2;
     i2 = (HEAPU16[i20 >> 1] | 0) >>> 8 & 255;
     i5 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i5 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i5 >> 0] = i2;
     i5 = HEAP32[i18 >> 2] | 0;
     i2 = i6 >>> (16 - i5 | 0);
     HEAP16[i20 >> 1] = i2;
     i5 = i4 + -16 + i5 | 0;
    } else i5 = i3 + i4 | 0;
    HEAP32[i18 >> 2] = i5;
    i3 = i7 + 65533 & 65535;
    i2 = i2 & 65535 | i3 << i5;
    HEAP16[i20 >> 1] = i2;
    if ((i5 | 0) > 14) {
     i4 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i4 >> 0] = i2;
     i4 = (HEAPU16[i20 >> 1] | 0) >>> 8 & 255;
     i2 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i2 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i2 >> 0] = i4;
     i2 = HEAP32[i18 >> 2] | 0;
     HEAP16[i20 >> 1] = i3 >>> (16 - i2 | 0);
     HEAP32[i18 >> 2] = i2 + -14;
     break;
    } else {
     HEAP32[i18 >> 2] = i5 + 2;
     break;
    }
   }
   if ((i2 | 0) < 11) {
    i3 = HEAPU16[i17 >> 1] | 0;
    i4 = HEAP32[i18 >> 2] | 0;
    i5 = HEAPU16[i19 >> 1] | 0;
    i2 = HEAPU16[i20 >> 1] | 0 | i5 << i4;
    HEAP16[i20 >> 1] = i2;
    if ((i4 | 0) > (16 - i3 | 0)) {
     i4 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i4 >> 0] = i2;
     i2 = (HEAPU16[i20 >> 1] | 0) >>> 8 & 255;
     i4 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i4 >> 0] = i2;
     i4 = HEAP32[i18 >> 2] | 0;
     i2 = i5 >>> (16 - i4 | 0);
     HEAP16[i20 >> 1] = i2;
     i5 = i3 + -16 + i4 | 0;
    } else i5 = i4 + i3 | 0;
    HEAP32[i18 >> 2] = i5;
    i3 = i7 + 65534 & 65535;
    i2 = i2 & 65535 | i3 << i5;
    HEAP16[i20 >> 1] = i2;
    if ((i5 | 0) > 13) {
     i4 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i4 >> 0] = i2;
     i4 = (HEAPU16[i20 >> 1] | 0) >>> 8 & 255;
     i2 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i2 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i2 >> 0] = i4;
     i2 = HEAP32[i18 >> 2] | 0;
     HEAP16[i20 >> 1] = i3 >>> (16 - i2 | 0);
     HEAP32[i18 >> 2] = i2 + -13;
     break;
    } else {
     HEAP32[i18 >> 2] = i5 + 3;
     break;
    }
   } else {
    i5 = HEAPU16[i12 >> 1] | 0;
    i4 = HEAP32[i18 >> 2] | 0;
    i3 = HEAPU16[i13 >> 1] | 0;
    i2 = HEAPU16[i20 >> 1] | 0 | i3 << i4;
    HEAP16[i20 >> 1] = i2;
    if ((i4 | 0) > (16 - i5 | 0)) {
     i4 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i4 >> 0] = i2;
     i2 = (HEAPU16[i20 >> 1] | 0) >>> 8 & 255;
     i4 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i4 >> 0] = i2;
     i4 = HEAP32[i18 >> 2] | 0;
     i2 = i3 >>> (16 - i4 | 0);
     HEAP16[i20 >> 1] = i2;
     i5 = i5 + -16 + i4 | 0;
    } else i5 = i4 + i5 | 0;
    HEAP32[i18 >> 2] = i5;
    i3 = i7 + 65526 & 65535;
    i2 = i2 & 65535 | i3 << i5;
    HEAP16[i20 >> 1] = i2;
    if ((i5 | 0) > 9) {
     i4 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i4 >> 0] = i2;
     i4 = (HEAPU16[i20 >> 1] | 0) >>> 8 & 255;
     i2 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i2 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i2 >> 0] = i4;
     i2 = HEAP32[i18 >> 2] | 0;
     HEAP16[i20 >> 1] = i3 >>> (16 - i2 | 0);
     HEAP32[i18 >> 2] = i2 + -9;
     break;
    } else {
     HEAP32[i18 >> 2] = i5 + 7;
     break;
    }
   }
  } else {
   i8 = i25 + (i24 << 2) + 2686 | 0;
   i9 = i25 + (i24 << 2) + 2684 | 0;
   i5 = HEAP32[i18 >> 2] | 0;
   i6 = HEAP16[i20 >> 1] | 0;
   do {
    i3 = HEAPU16[i8 >> 1] | 0;
    i7 = HEAPU16[i9 >> 1] | 0;
    i4 = i6 & 65535 | i7 << i5;
    i6 = i4 & 65535;
    HEAP16[i20 >> 1] = i6;
    if ((i5 | 0) > (16 - i3 | 0)) {
     i6 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i6 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i6 >> 0] = i4;
     i6 = (HEAPU16[i20 >> 1] | 0) >>> 8 & 255;
     i5 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i5 + 1;
     HEAP8[(HEAP32[i22 >> 2] | 0) + i5 >> 0] = i6;
     i5 = HEAP32[i18 >> 2] | 0;
     i6 = i7 >>> (16 - i5 | 0) & 65535;
     HEAP16[i20 >> 1] = i6;
     i5 = i3 + -16 + i5 | 0;
    } else i5 = i5 + i3 | 0;
    HEAP32[i18 >> 2] = i5;
    i2 = i2 + -1 | 0;
   } while ((i2 | 0) != 0);
  } while (0);
  if (!(i10 << 16 >> 16)) {
   i4 = i24;
   i6 = 138;
   i5 = 3;
   i24 = i16;
   continue;
  }
  i4 = i24;
  i6 = i11 ? 6 : 7;
  i5 = i11 ? 3 : 4;
  i24 = i16;
 }
 STACKTOP = i27;
 return;
}

function __tr_flush_block(i13, i6, i5, i12) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 if ((HEAP32[i13 + 132 >> 2] | 0) > 0) {
  i4 = (HEAP32[i13 >> 2] | 0) + 44 | 0;
  if ((HEAP32[i4 >> 2] | 0) == 2) {
   i3 = -201342849;
   i2 = 0;
   while (1) {
    if ((i3 & 1 | 0) != 0 ? (HEAP16[i13 + (i2 << 2) + 148 >> 1] | 0) != 0 : 0) {
     i3 = 0;
     break;
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= 32) {
     i1 = 6;
     break;
    } else i3 = i3 >>> 1;
   }
   L10 : do if ((i1 | 0) == 6) if (((HEAP16[i13 + 184 >> 1] | 0) == 0 ? (HEAP16[i13 + 188 >> 1] | 0) == 0 : 0) ? (HEAP16[i13 + 200 >> 1] | 0) == 0 : 0) {
    i3 = 32;
    while (1) {
     if (HEAP16[i13 + (i3 << 2) + 148 >> 1] | 0) {
      i3 = 1;
      break L10;
     }
     i3 = i3 + 1 | 0;
     if ((i3 | 0) >= 256) {
      i3 = 0;
      break;
     }
    }
   } else i3 = 1; while (0);
   HEAP32[i4 >> 2] = i3;
  }
  _build_tree(i13, i13 + 2840 | 0);
  _build_tree(i13, i13 + 2852 | 0);
  _scan_tree(i13, i13 + 148 | 0, HEAP32[i13 + 2844 >> 2] | 0);
  _scan_tree(i13, i13 + 2440 | 0, HEAP32[i13 + 2856 >> 2] | 0);
  _build_tree(i13, i13 + 2864 | 0);
  i3 = 18;
  while (1) {
   i2 = i3 + -1 | 0;
   if (HEAP16[i13 + (HEAPU8[157728 + i3 >> 0] << 2) + 2686 >> 1] | 0) break;
   if ((i2 | 0) > 2) i3 = i2; else {
    i3 = i2;
    break;
   }
  }
  i2 = i13 + 5800 | 0;
  i4 = (i3 * 3 | 0) + 17 + (HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  i4 = (i4 + 10 | 0) >>> 3;
  i2 = ((HEAP32[i13 + 5804 >> 2] | 0) + 10 | 0) >>> 3;
  i4 = i2 >>> 0 > i4 >>> 0 ? i4 : i2;
 } else {
  i2 = i5 + 5 | 0;
  i3 = 0;
  i4 = i2;
 }
 do if ((i5 + 4 | 0) >>> 0 <= i4 >>> 0 & (i6 | 0) != 0) __tr_stored_block(i13, i6, i5, i12); else {
  i11 = i13 + 5820 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i5 = (i6 | 0) > 13;
  if ((i2 | 0) == (i4 | 0) ? 1 : (HEAP32[i13 + 136 >> 2] | 0) == 4) {
   i3 = i12 + 2 & 65535;
   i2 = i13 + 5816 | 0;
   i1 = HEAPU16[i2 >> 1] | i3 << i6;
   HEAP16[i2 >> 1] = i1;
   if (i5) {
    i7 = i13 + 20 | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    HEAP32[i7 >> 2] = i8 + 1;
    i9 = i13 + 8 | 0;
    HEAP8[(HEAP32[i9 >> 2] | 0) + i8 >> 0] = i1;
    i8 = (HEAPU16[i2 >> 1] | 0) >>> 8 & 255;
    i10 = HEAP32[i7 >> 2] | 0;
    HEAP32[i7 >> 2] = i10 + 1;
    HEAP8[(HEAP32[i9 >> 2] | 0) + i10 >> 0] = i8;
    i10 = HEAP32[i11 >> 2] | 0;
    HEAP16[i2 >> 1] = i3 >>> (16 - i10 | 0);
    i2 = i10 + -13 | 0;
   } else i2 = i6 + 3 | 0;
   HEAP32[i11 >> 2] = i2;
   _compress_block(i13, 155976, 157128);
   break;
  }
  i1 = i12 + 4 & 65535;
  i10 = i13 + 5816 | 0;
  i2 = HEAPU16[i10 >> 1] | i1 << i6;
  HEAP16[i10 >> 1] = i2;
  if (i5) {
   i7 = i13 + 20 | 0;
   i9 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = i9 + 1;
   i8 = i13 + 8 | 0;
   HEAP8[(HEAP32[i8 >> 2] | 0) + i9 >> 0] = i2;
   i2 = (HEAPU16[i10 >> 1] | 0) >>> 8 & 255;
   i9 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = i9 + 1;
   HEAP8[(HEAP32[i8 >> 2] | 0) + i9 >> 0] = i2;
   i9 = HEAP32[i11 >> 2] | 0;
   i2 = i1 >>> (16 - i9 | 0);
   HEAP16[i10 >> 1] = i2;
   i1 = i9 + -13 | 0;
  } else i1 = i6 + 3 | 0;
  HEAP32[i11 >> 2] = i1;
  i8 = HEAP32[i13 + 2844 >> 2] | 0;
  i9 = HEAP32[i13 + 2856 >> 2] | 0;
  i4 = i8 + 65280 & 65535;
  i2 = i2 & 65535 | i4 << i1;
  HEAP16[i10 >> 1] = i2;
  if ((i1 | 0) > 11) {
   i6 = i13 + 20 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i1 + 1;
   i7 = i13 + 8 | 0;
   HEAP8[(HEAP32[i7 >> 2] | 0) + i1 >> 0] = i2;
   i2 = (HEAPU16[i10 >> 1] | 0) >>> 8 & 255;
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i1 + 1;
   HEAP8[(HEAP32[i7 >> 2] | 0) + i1 >> 0] = i2;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i4 >>> (16 - i1 | 0);
   HEAP16[i10 >> 1] = i2;
   i1 = i1 + -11 | 0;
  } else i1 = i1 + 5 | 0;
  HEAP32[i11 >> 2] = i1;
  i4 = i9 & 65535;
  i2 = i4 << i1 | i2 & 65535;
  HEAP16[i10 >> 1] = i2;
  if ((i1 | 0) > 11) {
   i6 = i13 + 20 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i1 + 1;
   i7 = i13 + 8 | 0;
   HEAP8[(HEAP32[i7 >> 2] | 0) + i1 >> 0] = i2;
   i2 = (HEAPU16[i10 >> 1] | 0) >>> 8 & 255;
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i1 + 1;
   HEAP8[(HEAP32[i7 >> 2] | 0) + i1 >> 0] = i2;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i4 >>> (16 - i1 | 0);
   HEAP16[i10 >> 1] = i2;
   i1 = i1 + -11 | 0;
  } else i1 = i1 + 5 | 0;
  HEAP32[i11 >> 2] = i1;
  i4 = i3 + 65533 & 65535;
  i2 = i4 << i1 | i2 & 65535;
  HEAP16[i10 >> 1] = i2;
  if ((i1 | 0) > 12) {
   i5 = i13 + 20 | 0;
   i7 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i7 + 1;
   i6 = i13 + 8 | 0;
   HEAP8[(HEAP32[i6 >> 2] | 0) + i7 >> 0] = i2;
   i2 = (HEAPU16[i10 >> 1] | 0) >>> 8 & 255;
   i7 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i7 + 1;
   HEAP8[(HEAP32[i6 >> 2] | 0) + i7 >> 0] = i2;
   i7 = HEAP32[i11 >> 2] | 0;
   i2 = i4 >>> (16 - i7 | 0);
   HEAP16[i10 >> 1] = i2;
   i4 = i7 + -12 | 0;
  } else i4 = i1 + 4 | 0;
  HEAP32[i11 >> 2] = i4;
  if ((i3 | 0) > -1) {
   i5 = i13 + 20 | 0;
   i7 = i13 + 8 | 0;
   i6 = 0;
   while (1) {
    i1 = HEAPU16[i13 + (HEAPU8[157728 + i6 >> 0] << 2) + 2686 >> 1] | 0;
    i2 = i1 << i4 | i2 & 65535;
    HEAP16[i10 >> 1] = i2;
    if ((i4 | 0) > 13) {
     i4 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i7 >> 2] | 0) + i4 >> 0] = i2;
     i2 = (HEAPU16[i10 >> 1] | 0) >>> 8 & 255;
     i4 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i7 >> 2] | 0) + i4 >> 0] = i2;
     i4 = HEAP32[i11 >> 2] | 0;
     i2 = i1 >>> (16 - i4 | 0);
     HEAP16[i10 >> 1] = i2;
     i4 = i4 + -13 | 0;
    } else i4 = i4 + 3 | 0;
    HEAP32[i11 >> 2] = i4;
    if ((i6 | 0) == (i3 | 0)) break; else i6 = i6 + 1 | 0;
   }
  }
  i7 = i13 + 148 | 0;
  _send_tree(i13, i7, i8);
  i10 = i13 + 2440 | 0;
  _send_tree(i13, i10, i9);
  _compress_block(i13, i7, i10);
 } while (0);
 _init_block(i13);
 if (!i12) {
  STACKTOP = i14;
  return;
 }
 i3 = i13 + 5820 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) <= 8) {
  i1 = i13 + 5816 | 0;
  if ((i2 | 0) > 0) {
   i9 = HEAP16[i1 >> 1] & 255;
   i8 = i13 + 20 | 0;
   i10 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = i10 + 1;
   HEAP8[(HEAP32[i13 + 8 >> 2] | 0) + i10 >> 0] = i9;
  }
 } else {
  i1 = i13 + 5816 | 0;
  i10 = HEAP16[i1 >> 1] & 255;
  i7 = i13 + 20 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i8 + 1;
  i9 = i13 + 8 | 0;
  HEAP8[(HEAP32[i9 >> 2] | 0) + i8 >> 0] = i10;
  i8 = (HEAPU16[i1 >> 1] | 0) >>> 8 & 255;
  i10 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i10 + 1;
  HEAP8[(HEAP32[i9 >> 2] | 0) + i10 >> 0] = i8;
 }
 HEAP16[i1 >> 1] = 0;
 HEAP32[i3 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __ZNK2cv11_InputArray7getUMatEi(i12, i5, i11) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i1 = i13 + 128 | 0;
 i7 = i13 + 120 | 0;
 i8 = i13 + 112 | 0;
 i10 = i13 + 56 | 0;
 i9 = i13;
 i6 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] & 127](i5) | 0;
 i2 = HEAP32[i5 + 4 >> 2] & 50331648;
 if ((i6 | 0) == 720896) {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  if (!((i11 | 0) > -1 ? (i3 = HEAP32[i1 >> 2] | 0, (((HEAP32[i1 + 4 >> 2] | 0) - i3 | 0) / 48 | 0 | 0) > (i11 | 0)) : 0)) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i4 = (__ZN2cv6String8allocateEj(i8, 27) | 0) + 0 | 0;
   i3 = 28744;
   i2 = i4 + 27 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i4 | 0) < (i2 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 28960, 27528, 1226);
   __ZN2cv6String10deallocateEv(i8);
   i3 = HEAP32[i1 >> 2] | 0;
  }
  i4 = i3 + (i11 * 48 | 0) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  i2 = i12 + 4 | 0;
  i1 = i3 + (i11 * 48 | 0) + 4 | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i10 = i12 + 8 | 0;
  HEAP32[i10 >> 2] = HEAP32[i3 + (i11 * 48 | 0) + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i3 + (i11 * 48 | 0) + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i3 + (i11 * 48 | 0) + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i3 + (i11 * 48 | 0) + 20 >> 2];
  i5 = HEAP32[i3 + (i11 * 48 | 0) + 24 >> 2] | 0;
  HEAP32[i12 + 24 >> 2] = i5;
  HEAP32[i12 + 28 >> 2] = HEAP32[i3 + (i11 * 48 | 0) + 28 >> 2];
  HEAP32[i12 + 32 >> 2] = i10;
  i10 = i12 + 40 | 0;
  i6 = i12 + 36 | 0;
  HEAP32[i6 >> 2] = i10;
  HEAP32[i12 + 44 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  if (i5) {
   i10 = i5 + 8 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  if ((HEAP32[i1 >> 2] | 0) < 3) {
   i9 = HEAP32[i3 + (i11 * 48 | 0) + 36 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   STACKTOP = i13;
   return;
  } else {
   HEAP32[i2 >> 2] = 0;
   __ZN2cv4UMat8copySizeERKS0_(i12, i4);
   STACKTOP = i13;
   return;
  }
 } else if ((i6 | 0) == 655360) {
  i6 = HEAP32[i5 + 8 >> 2] | 0;
  if ((i11 | 0) >= 0) {
   HEAP32[i1 >> 2] = i11;
   HEAP32[i1 + 4 >> 2] = i11 + 1;
   HEAP32[i7 >> 2] = -2147483648;
   HEAP32[i7 + 4 >> 2] = 2147483647;
   __ZN2cv4UMatC2ERKS0_RKNS_5RangeES5_(i12, i6, i1, i7);
   STACKTOP = i13;
   return;
  }
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  i3 = i12 + 4 | 0;
  i2 = i6 + 4 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  i10 = i12 + 8 | 0;
  HEAP32[i10 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  i1 = HEAP32[i6 + 24 >> 2] | 0;
  HEAP32[i12 + 24 >> 2] = i1;
  HEAP32[i12 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
  HEAP32[i12 + 32 >> 2] = i10;
  i10 = i12 + 40 | 0;
  i4 = i12 + 36 | 0;
  HEAP32[i4 >> 2] = i10;
  HEAP32[i12 + 44 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  if (i1) {
   i10 = i1 + 8 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  if ((HEAP32[i2 >> 2] | 0) < 3) {
   i9 = HEAP32[i6 + 36 >> 2] | 0;
   i10 = HEAP32[i4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   STACKTOP = i13;
   return;
  } else {
   HEAP32[i3 >> 2] = 0;
   __ZN2cv4UMat8copySizeERKS0_(i12, i6);
   STACKTOP = i13;
   return;
  }
 } else if ((i6 | 0) == 65536) {
  i4 = HEAP32[i5 + 8 >> 2] | 0;
  if ((i11 | 0) < 0) {
   __ZNK2cv3Mat7getUMatEiNS_14UMatUsageFlagsE(i12, i4, i2, 0);
   STACKTOP = i13;
   return;
  }
  HEAP32[i1 >> 2] = i11;
  HEAP32[i1 + 4 >> 2] = i11 + 1;
  HEAP32[i7 >> 2] = -2147483648;
  HEAP32[i7 + 4 >> 2] = 2147483647;
  __ZN2cv3MatC2ERKS0_RKNS_5RangeES5_(i10, i4, i1, i7);
  __ZNK2cv3Mat7getUMatEiNS_14UMatUsageFlagsE(i12, i10, i2, 0);
  i4 = i10 + 36 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i8 = i1 + 12 | 0, i9 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) {
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2) {
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) {
     i1 = HEAP32[i10 + 32 >> 2] | 0;
     if (!i1) {
      if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
       i9 = __Znwj(4) | 0;
       HEAP32[i9 >> 2] = 32784;
       HEAP32[6904] = i9;
       ___cxa_guard_release(27624);
      }
      i1 = HEAP32[6904] | 0;
      i2 = HEAP32[i4 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i2);
   }
   HEAP32[i4 >> 2] = 0;
  }
  HEAP32[i4 >> 2] = 0;
  i9 = i10 + 16 | 0;
  i2 = i10 + 4 | 0;
  HEAP32[i9 + 0 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i10 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i1 = HEAP32[i10 + 44 >> 2] | 0;
  if ((i1 | 0) == (i10 + 48 | 0)) {
   STACKTOP = i13;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i13;
  return;
 } else {
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i5 >> 2] >> 2] & 63](i9, i5, i11);
  __ZNK2cv3Mat7getUMatEiNS_14UMatUsageFlagsE(i12, i9, i2, 0);
  i4 = i9 + 36 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i8 = i1 + 12 | 0, i10 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1) {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i2) {
     i2 = HEAP32[i9 + 32 >> 2] | 0;
     if (!i2) {
      if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
       i10 = __Znwj(4) | 0;
       HEAP32[i10 >> 2] = 32784;
       HEAP32[6904] = i10;
       ___cxa_guard_release(27624);
      }
      i2 = HEAP32[6904] | 0;
      i1 = HEAP32[i4 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1);
   }
   HEAP32[i4 >> 2] = 0;
  }
  HEAP32[i4 >> 2] = 0;
  i10 = i9 + 16 | 0;
  i2 = i9 + 4 | 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i9 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i1 = HEAP32[i9 + 44 >> 2] | 0;
  if ((i1 | 0) == (i9 + 48 | 0)) {
   STACKTOP = i13;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i13;
  return;
 }
}

function __ZNK2cv3Mat6copyToERKNS_12_OutputArrayERKNS_11_InputArrayE(i14, i1, i6) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i21 = i22 + 248 | 0;
 i5 = i22 + 240 | 0;
 i18 = i22 + 232 | 0;
 i7 = i22 + 176 | 0;
 i19 = i22 + 120 | 0;
 i9 = i22;
 i10 = i22 + 112 | 0;
 i13 = i22 + 104 | 0;
 i11 = i22 + 88 | 0;
 i17 = i22 + 72 | 0;
 i16 = i22 + 40 | 0;
 i15 = i22 + 32 | 0;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i6 >> 2] >> 2] & 63](i21, i6, -1);
 i20 = i21 + 16 | 0;
 if (HEAP32[i20 >> 2] | 0) {
  i4 = HEAP32[i21 >> 2] | 0;
  i6 = i4 >>> 3 & 511;
  i8 = i6 + 1 | 0;
  if (!((i4 & 7 | 0) == 0 ? ((i6 | 0) == 0 ? 1 : (i6 | 0) == ((HEAP32[i14 >> 2] | 0) >>> 3 & 511 | 0)) : 0)) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i5, 48) | 0) + 0 | 0;
   i4 = 46736 | 0;
   i3 = i6 + 48 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i4 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i4 = i4 + 1 | 0;
   } while ((i6 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 46672, 46680, 366);
   __ZN2cv6String10deallocateEv(i5);
  }
  if (i8 >>> 0 <= 1) {
   i6 = HEAP32[i14 + 4 >> 2] | 0;
   if ((i6 | 0) > 0) {
    i6 = HEAP32[(HEAP32[i14 + 44 >> 2] | 0) + (i6 + -1 << 2) >> 2] | 0;
    HEAP32[i18 >> 2] = i6;
    if (i6 >>> 0 < 33) i2 = 11; else i12 = 195;
   } else {
    i6 = 0;
    i2 = 9;
   }
  } else {
   i6 = 1212424721 >>> (HEAP32[i14 >> 2] << 2 & 28) & 15;
   i2 = 9;
  }
  if ((i2 | 0) == 9) {
   HEAP32[i18 >> 2] = i6;
   i2 = 11;
  }
  if ((i2 | 0) == 11) {
   i12 = HEAP32[46504 + (i6 << 2) >> 2] | 0;
   i12 = (i12 | 0) == 0 ? 195 : i12;
  }
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i1 >> 2] >> 2] & 63](i7, i1, -1);
  i4 = i7 + 16 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i6 = i7 + 36 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  if ((i5 | 0) != 0 ? (i3 = i5 + 12 | 0, i5 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i5 + -1, (i5 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i7);
  HEAP32[i6 >> 2] = 0;
  i3 = i7 + 4 | 0;
  HEAP32[i4 + 0 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i6 = HEAP32[i7 + 40 >> 2] | 0;
   i5 = 0;
   do {
    HEAP32[i6 + (i5 << 2) >> 2] = 0;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i6 = HEAP32[i7 + 44 >> 2] | 0;
  if ((i6 | 0) != (i7 + 48 | 0)) __ZN2cv8fastFreeEPv(i6);
  i6 = i14 + 4 | 0;
  i5 = i14 + 40 | 0;
  FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] & 63](i1, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i14 >> 2] & 4095, -1, 0, 0);
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i1 >> 2] >> 2] & 63](i19, i1, -1);
  i7 = i19 + 16 | 0;
  if ((HEAP32[i7 >> 2] | 0) != (i2 | 0)) {
   HEAP32[i9 + 0 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i9 + 16 >> 2] = 0;
   HEAP32[i9 + 20 >> 2] = 0;
   HEAP32[i9 + 24 >> 2] = 0;
   HEAP32[i9 + 28 >> 2] = 0;
   __ZN2cv3MataSERKNS_7Scalar_IdEE(i19, i9) | 0;
  }
  L33 : do if ((HEAP32[i6 >> 2] | 0) < 3) {
   i6 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i21 + 40 >> 2] | 0;
   if (!((HEAP32[i6 >> 2] | 0) == (HEAP32[i9 >> 2] | 0) ? (HEAP32[i6 + 4 >> 2] | 0) == (HEAP32[i9 + 4 >> 2] | 0) : 0)) {
    HEAP32[i10 >> 2] = 0;
    HEAP32[i10 + 4 >> 2] = 0;
    i6 = (__ZN2cv6String8allocateEj(i10, 21) | 0) + 0 | 0;
    i4 = 46792 | 0;
    i3 = i6 + 21 | 0;
    do {
     HEAP8[i6 >> 0] = HEAP8[i4 >> 0] | 0;
     i6 = i6 + 1 | 0;
     i4 = i4 + 1 | 0;
    } while ((i6 | 0) < (i3 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 46672, 46680, 381);
    __ZN2cv6String10deallocateEv(i10);
   }
   i3 = HEAP32[i14 + 12 >> 2] | 0;
   if (!(HEAP32[i14 >> 2] & 16384 & HEAP32[i19 >> 2] & HEAP32[i21 >> 2])) {
    i3 = Math_imul(i3, i8) | 0;
    i2 = HEAP32[i14 + 8 >> 2] | 0;
   } else {
    i3 = Math_imul(Math_imul(i3, i8) | 0, HEAP32[i14 + 8 >> 2] | 0) | 0;
    i2 = 1;
   }
   i4 = HEAP32[i14 + 16 >> 2] | 0;
   i5 = HEAP32[i14 + 48 >> 2] | 0;
   i6 = HEAP32[i20 >> 2] | 0;
   i8 = HEAP32[i21 + 48 >> 2] | 0;
   i9 = HEAP32[i7 >> 2] | 0;
   i10 = HEAP32[i19 + 48 >> 2] | 0;
   HEAP32[i13 >> 2] = i3;
   HEAP32[i13 + 4 >> 2] = i2;
   FUNCTION_TABLE_viiiiiiii[i12 & 255](i4, i5, i6, i8, i9, i10, i13, i18);
  } else {
   HEAP32[i11 >> 2] = i14;
   HEAP32[i11 + 4 >> 2] = i19;
   HEAP32[i11 + 8 >> 2] = i21;
   HEAP32[i11 + 12 >> 2] = 0;
   __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i16, i11, i17, -1);
   i3 = Math_imul(HEAP32[i16 + 20 >> 2] | 0, i8) | 0;
   i2 = i16 + 16 | 0;
   i1 = i17 + 8 | 0;
   i4 = i17 + 4 | 0;
   i5 = i15 + 4 | 0;
   i6 = 0;
   while (1) {
    if (i6 >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) break L33;
    i8 = HEAP32[i17 >> 2] | 0;
    i9 = HEAP32[i1 >> 2] | 0;
    i10 = HEAP32[i4 >> 2] | 0;
    HEAP32[i15 >> 2] = i3;
    HEAP32[i5 >> 2] = 1;
    FUNCTION_TABLE_viiiiiiii[i12 & 255](i8, 0, i9, 0, i10, 0, i15, i18);
    __ZN2cv15NAryMatIteratorppEv(i16) | 0;
    i6 = i6 + 1 | 0;
   }
  } while (0);
  i3 = i19 + 36 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i9 = i2 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i19);
  HEAP32[i3 >> 2] = 0;
  i1 = i19 + 4 | 0;
  HEAP32[i7 + 0 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  if ((HEAP32[i1 >> 2] | 0) > 0) {
   i3 = HEAP32[i19 + 40 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
  }
  i1 = HEAP32[i19 + 44 >> 2] | 0;
  if ((i1 | 0) != (i19 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 } else __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i14, i1);
 i1 = i21 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i9 = i2 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i21);
 HEAP32[i1 >> 2] = 0;
 i3 = i21 + 4 | 0;
 HEAP32[i20 + 0 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i21 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i21 + 44 >> 2] | 0;
 if ((i1 | 0) == (i21 + 48 | 0)) {
  STACKTOP = i22;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i22;
 return;
}

function __ZNSt3__15dequeIcNS_9allocatorIcEEE19__add_back_capacityEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i15 + 20 | 0;
 i10 = i15;
 i1 = i14 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 4095) {
  HEAP32[i1 >> 2] = i2 + -4096;
  i7 = i14 + 4 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i9 = HEAP32[i3 >> 2] | 0;
  i2 = i3 + 4 | 0;
  HEAP32[i7 >> 2] = i2;
  i10 = i14 + 8 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i8 = i14 + 12 | 0;
  do if ((i1 | 0) == (HEAP32[i8 >> 2] | 0)) {
   i4 = HEAP32[i14 >> 2] | 0;
   if (i2 >>> 0 > i4 >>> 0) {
    i8 = i2;
    i4 = ((i8 - i4 >> 2) + 1 | 0) / -2 | 0;
    i1 = i1 - i8 | 0;
    _memmove(i3 + (i4 + 1 << 2) | 0, i2 | 0, i1 | 0) | 0;
    i1 = i3 + ((i1 >> 2) + 1 + i4 << 2) | 0;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i4 << 2);
    i4 = 12;
    break;
   }
   i2 = i1 - i4 >> 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   i6 = __Znwj(i2 << 2) | 0;
   i3 = i6 + (i2 >>> 2 << 2) | 0;
   i2 = i6 + (i2 << 2) | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   if ((i4 | 0) == (i5 | 0)) i1 = i3; else {
    i1 = i3;
    do {
     if (!i1) i1 = 0; else HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
     i1 = i1 + 4 | 0;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) != (i5 | 0));
   }
   i4 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = i6;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = i2;
   if (!i4) i4 = 11; else {
    __ZdlPv(i4);
    i1 = HEAP32[i10 >> 2] | 0;
    i4 = 11;
   }
  } else i4 = 11; while (0);
  if ((i4 | 0) == 11) if (!i1) i1 = 0; else i4 = 12;
  if ((i4 | 0) == 12) {
   HEAP32[i1 >> 2] = i9;
   i1 = HEAP32[i10 >> 2] | 0;
  }
  HEAP32[i10 >> 2] = i1 + 4;
  STACKTOP = i15;
  return;
 }
 i13 = i14 + 8 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i11 = i14 + 4 | 0;
 i6 = i3 - (HEAP32[i11 >> 2] | 0) >> 2;
 i12 = i14 + 12 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2 - (HEAP32[i14 >> 2] | 0) | 0;
 if (i6 >>> 0 >= i4 >> 2 >>> 0) {
  i9 = i4 >> 1;
  i9 = (i9 | 0) == 0 ? 1 : i9;
  i7 = i10 + 12 | 0;
  HEAP32[i10 + 16 >> 2] = i14 + 12;
  i3 = __Znwj(i9 << 2) | 0;
  HEAP32[i10 >> 2] = i3;
  i4 = i3 + (i6 << 2) | 0;
  i8 = i10 + 8 | 0;
  HEAP32[i8 >> 2] = i4;
  i1 = i10 + 4 | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3 + (i9 << 2);
  i2 = __Znwj(4096) | 0;
  do if ((i6 | 0) == (i9 | 0)) {
   i5 = i4 - i3 | 0;
   if (i4 >>> 0 > i3 >>> 0) {
    i4 = i3 + (i6 + (((i5 >> 2) + 1 | 0) / -2 | 0) << 2) | 0;
    HEAP32[i8 >> 2] = i4;
    HEAP32[i1 >> 2] = i4;
    break;
   }
   i9 = i5 >> 1;
   i9 = (i9 | 0) == 0 ? 1 : i9;
   i6 = __Znwj(i9 << 2) | 0;
   i4 = i6 + (i9 >>> 2 << 2) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i8 >> 2] = i4;
   HEAP32[i7 >> 2] = i6 + (i9 << 2);
   if (i3) __ZdlPv(i3);
  } while (0);
  if (!i4) i4 = 0; else HEAP32[i4 >> 2] = i2;
  HEAP32[i8 >> 2] = i4 + 4;
  i3 = HEAP32[i13 >> 2] | 0;
  while (1) {
   if ((i3 | 0) == (HEAP32[i11 >> 2] | 0)) break;
   i9 = i3 + -4 | 0;
   __ZNSt3__114__split_bufferIPcRNS_9allocatorIS1_EEE10push_frontERKS1_(i10, i9);
   i3 = i9;
  }
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i10 >> 2] = i4;
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i3;
  i2 = HEAP32[i13 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i2;
  i10 = HEAP32[i12 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i10;
  if ((i2 | 0) != (i3 | 0)) HEAP32[i8 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
  if (!i4) {
   STACKTOP = i15;
   return;
  }
  __ZdlPv(i4);
  STACKTOP = i15;
  return;
 }
 i9 = __Znwj(4096) | 0;
 if ((i2 | 0) == (i3 | 0)) {
  HEAP32[i5 >> 2] = i9;
  __ZNSt3__114__split_bufferIPcNS_9allocatorIS1_EEE10push_frontERKS1_(i14, i5);
  i3 = HEAP32[i11 >> 2] | 0;
  i8 = HEAP32[i3 >> 2] | 0;
  i2 = i3 + 4 | 0;
  HEAP32[i11 >> 2] = i2;
  i1 = HEAP32[i13 >> 2] | 0;
  do if ((i1 | 0) == (HEAP32[i12 >> 2] | 0)) {
   i4 = HEAP32[i14 >> 2] | 0;
   if (i2 >>> 0 > i4 >>> 0) {
    i10 = i2;
    i4 = ((i10 - i4 >> 2) + 1 | 0) / -2 | 0;
    i1 = i1 - i10 | 0;
    _memmove(i3 + (i4 + 1 << 2) | 0, i2 | 0, i1 | 0) | 0;
    i1 = i3 + ((i1 >> 2) + 1 + i4 << 2) | 0;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (i4 << 2);
    i4 = 38;
    break;
   }
   i2 = i1 - i4 >> 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   i6 = __Znwj(i2 << 2) | 0;
   i3 = i6 + (i2 >>> 2 << 2) | 0;
   i2 = i6 + (i2 << 2) | 0;
   i4 = HEAP32[i11 >> 2] | 0;
   i5 = HEAP32[i13 >> 2] | 0;
   if ((i4 | 0) == (i5 | 0)) i1 = i3; else {
    i1 = i3;
    do {
     if (!i1) i1 = 0; else HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
     i1 = i1 + 4 | 0;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) != (i5 | 0));
   }
   i4 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = i6;
   HEAP32[i11 >> 2] = i3;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i12 >> 2] = i2;
   if (!i4) i4 = 37; else {
    __ZdlPv(i4);
    i1 = HEAP32[i13 >> 2] | 0;
    i4 = 37;
   }
  } else i4 = 37; while (0);
  if ((i4 | 0) == 37) if (!i1) i1 = 0; else i4 = 38;
  if ((i4 | 0) == 38) {
   HEAP32[i1 >> 2] = i8;
   i1 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i13 >> 2] = i1 + 4;
  STACKTOP = i15;
  return;
 } else {
  i1 = HEAP32[i13 >> 2] | 0;
  do if ((i1 | 0) == (HEAP32[i12 >> 2] | 0)) {
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i14 >> 2] | 0;
   if (i2 >>> 0 > i3 >>> 0) {
    i8 = i2;
    i10 = ((i8 - i3 >> 2) + 1 | 0) / -2 | 0;
    i1 = i1 - i8 | 0;
    _memmove(i2 + (i10 << 2) | 0, i2 | 0, i1 | 0) | 0;
    i1 = i2 + (i10 + (i1 >> 2) << 2) | 0;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (i10 << 2);
    break;
   }
   i6 = i1 - i3 >> 1;
   i6 = (i6 | 0) == 0 ? 1 : i6;
   i3 = __Znwj(i6 << 2) | 0;
   i2 = i3 + (i6 >>> 2 << 2) | 0;
   i6 = i3 + (i6 << 2) | 0;
   i4 = HEAP32[i11 >> 2] | 0;
   i5 = HEAP32[i13 >> 2] | 0;
   if ((i4 | 0) == (i5 | 0)) i1 = i2; else {
    i1 = i2;
    do {
     if (!i1) i1 = 0; else HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
     i1 = i1 + 4 | 0;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) != (i5 | 0));
   }
   i4 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = i3;
   HEAP32[i11 >> 2] = i2;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i12 >> 2] = i6;
   if (i4) {
    __ZdlPv(i4);
    i1 = HEAP32[i13 >> 2] | 0;
   }
  } while (0);
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = i9;
   i1 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i13 >> 2] = i1 + 4;
  STACKTOP = i15;
  return;
 }
}

function __ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i(i37, i39, i38, i36, i4, i24, i23, i28, i29, i25, i32, i27, i31, i30, i26) {
 i37 = i37 | 0;
 i39 = i39 | 0;
 i38 = i38 | 0;
 i36 = i36 | 0;
 i4 = i4 | 0;
 i24 = i24 | 0;
 i23 = i23 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i25 = i25 | 0;
 i32 = i32 | 0;
 i27 = i27 | 0;
 i31 = i31 | 0;
 i30 = i30 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i33 = 0, i34 = 0, i35 = 0, i40 = 0;
 i40 = STACKTOP;
 HEAP32[i38 >> 2] = i37;
 i3 = i30 + 1 | 0;
 i34 = i30 + 8 | 0;
 i35 = i30 + 4 | 0;
 i17 = (i36 & 512 | 0) == 0;
 i18 = i31 + 1 | 0;
 i19 = i31 + 8 | 0;
 i20 = i31 + 4 | 0;
 i21 = (i26 | 0) > 0;
 i22 = i27 + 1 | 0;
 i12 = i27 + 8 | 0;
 i13 = i27 + 4 | 0;
 i14 = i23 + 8 | 0;
 i15 = 0 - i26 | 0;
 i11 = 0;
 do {
  switch (HEAP8[i29 + i11 >> 0] | 0) {
  case 2:
   {
    i5 = HEAP8[i31 >> 0] | 0;
    i2 = (i5 & 1) == 0;
    if (i2) i1 = (i5 & 255) >>> 1; else i1 = HEAP32[i20 >> 2] | 0;
    if (!((i1 | 0) == 0 | i17)) {
     if (i2) {
      i1 = i18;
      i2 = (i5 & 255) >>> 1;
     } else {
      i1 = HEAP32[i19 >> 2] | 0;
      i2 = HEAP32[i20 >> 2] | 0;
     }
     i6 = i1 + i2 | 0;
     i2 = HEAP32[i38 >> 2] | 0;
     if ((i1 | 0) != (i6 | 0)) {
      i5 = i1;
      do {
       HEAP8[i2 >> 0] = HEAP8[i5 >> 0] | 0;
       i5 = i5 + 1 | 0;
       i2 = i2 + 1 | 0;
      } while ((i5 | 0) != (i6 | 0));
     }
     HEAP32[i38 >> 2] = i2;
    }
    break;
   }
  case 4:
   {
    i2 = HEAP32[i38 >> 2] | 0;
    i4 = i28 ? i4 + 1 | 0 : i4;
    L19 : do if (i4 >>> 0 < i24 >>> 0) {
     i6 = i4;
     while (1) {
      i1 = HEAP8[i6 >> 0] | 0;
      if (i1 << 24 >> 24 <= -1) {
       i5 = i6;
       break L19;
      }
      i5 = i6 + 1 | 0;
      if (!(HEAP16[(HEAP32[i14 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 2048)) {
       i5 = i6;
       break L19;
      }
      if (i5 >>> 0 < i24 >>> 0) i6 = i5; else break;
     }
    } else i5 = i4; while (0);
    i1 = i5;
    if (i21) {
     if (i5 >>> 0 > i4 >>> 0) {
      i10 = i4 - i1 | 0;
      i10 = i10 >>> 0 < i15 >>> 0 ? i15 : i10;
      i6 = i10 + i26 | 0;
      i9 = i2;
      i1 = i5;
      i7 = i26;
      while (1) {
       i8 = i1 + -1 | 0;
       i1 = HEAP8[i8 >> 0] | 0;
       HEAP32[i38 >> 2] = i9 + 1;
       HEAP8[i9 >> 0] = i1;
       i7 = i7 + -1 | 0;
       i1 = (i7 | 0) > 0;
       if (!(i8 >>> 0 > i4 >>> 0 & i1)) break;
       i9 = HEAP32[i38 >> 2] | 0;
       i1 = i8;
      }
      i5 = i5 + i10 | 0;
      if (i1) i33 = 32; else i10 = 0;
     } else {
      i6 = i26;
      i33 = 32;
     }
     if ((i33 | 0) == 32) {
      i33 = 0;
      i10 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i23 >> 2] | 0) + 28 >> 2] & 127](i23, 48) | 0;
     }
     i1 = HEAP32[i38 >> 2] | 0;
     HEAP32[i38 >> 2] = i1 + 1;
     if ((i6 | 0) > 0) do {
      HEAP8[i1 >> 0] = i10;
      i6 = i6 + -1 | 0;
      i1 = HEAP32[i38 >> 2] | 0;
      HEAP32[i38 >> 2] = i1 + 1;
     } while ((i6 | 0) > 0);
     HEAP8[i1 >> 0] = i25;
    }
    if ((i5 | 0) == (i4 | 0)) {
     i5 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i23 >> 2] | 0) + 28 >> 2] & 127](i23, 48) | 0;
     i1 = HEAP32[i38 >> 2] | 0;
     HEAP32[i38 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i5;
    } else {
     i1 = HEAP8[i27 >> 0] | 0;
     i6 = (i1 & 1) == 0;
     if (i6) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i13 >> 2] | 0;
     if (!i1) {
      i7 = -1;
      i6 = 0;
      i1 = 0;
     } else {
      if (i6) i1 = i22; else i1 = HEAP32[i12 >> 2] | 0;
      i7 = HEAP8[i1 >> 0] | 0;
      i6 = 0;
      i1 = 0;
     }
     while (1) {
      if ((i1 | 0) == (i7 | 0)) {
       i9 = HEAP32[i38 >> 2] | 0;
       HEAP32[i38 >> 2] = i9 + 1;
       HEAP8[i9 >> 0] = i32;
       i9 = i6 + 1 | 0;
       i6 = HEAP8[i27 >> 0] | 0;
       i1 = (i6 & 1) == 0;
       if (i1) i6 = (i6 & 255) >>> 1; else i6 = HEAP32[i13 >> 2] | 0;
       if (i9 >>> 0 < i6 >>> 0) {
        if (i1) i6 = i22; else i6 = HEAP32[i12 >> 2] | 0;
        if ((HEAP8[i6 + i9 >> 0] | 0) == 127) {
         i7 = -1;
         i6 = i9;
         i1 = 0;
        } else {
         if (i1) i1 = i22; else i1 = HEAP32[i12 >> 2] | 0;
         i7 = HEAP8[i1 + i9 >> 0] | 0;
         i6 = i9;
         i1 = 0;
        }
       } else {
        i6 = i9;
        i1 = 0;
       }
      }
      i5 = i5 + -1 | 0;
      i9 = HEAP8[i5 >> 0] | 0;
      i8 = HEAP32[i38 >> 2] | 0;
      HEAP32[i38 >> 2] = i8 + 1;
      HEAP8[i8 >> 0] = i9;
      if ((i5 | 0) == (i4 | 0)) break; else i1 = i1 + 1 | 0;
     }
    }
    i1 = HEAP32[i38 >> 2] | 0;
    if ((i2 | 0) != (i1 | 0) ? (i16 = i1 + -1 | 0, i16 >>> 0 > i2 >>> 0) : 0) {
     i1 = i16;
     do {
      i5 = HEAP8[i2 >> 0] | 0;
      HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
      HEAP8[i1 >> 0] = i5;
      i2 = i2 + 1 | 0;
      i1 = i1 + -1 | 0;
     } while (i2 >>> 0 < i1 >>> 0);
    }
    break;
   }
  case 1:
   {
    HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
    i2 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i23 >> 2] | 0) + 28 >> 2] & 127](i23, 32) | 0;
    i1 = HEAP32[i38 >> 2] | 0;
    HEAP32[i38 >> 2] = i1 + 1;
    HEAP8[i1 >> 0] = i2;
    break;
   }
  case 3:
   {
    i2 = HEAP8[i30 >> 0] | 0;
    i1 = (i2 & 1) == 0;
    if (i1) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i35 >> 2] | 0;
    if (i2) {
     if (i1) i2 = i3; else i2 = HEAP32[i34 >> 2] | 0;
     i2 = HEAP8[i2 >> 0] | 0;
     i1 = HEAP32[i38 >> 2] | 0;
     HEAP32[i38 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i2;
    }
    break;
   }
  case 0:
   {
    HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
    break;
   }
  default:
   {}
  }
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) != 4);
 i4 = HEAP8[i30 >> 0] | 0;
 i2 = (i4 & 1) == 0;
 if (i2) i1 = (i4 & 255) >>> 1; else i1 = HEAP32[i35 >> 2] | 0;
 if (i1 >>> 0 > 1) {
  if (i2) i1 = (i4 & 255) >>> 1; else {
   i3 = HEAP32[i34 >> 2] | 0;
   i1 = HEAP32[i35 >> 2] | 0;
  }
  i2 = i3 + 1 | 0;
  i3 = i3 + i1 | 0;
  i1 = HEAP32[i38 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i38 >> 2] = i1;
 }
 i1 = i36 & 176;
 if ((i1 | 0) == 32) {
  HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
  STACKTOP = i40;
  return;
 } else if ((i1 | 0) == 16) {
  STACKTOP = i40;
  return;
 } else {
  HEAP32[i39 >> 2] = i37;
  STACKTOP = i40;
  return;
 }
}

function __ZN2cv11mixChannelsEPKNS_3MatEjPS0_jPKij(i20, i19, i16, i18, i17, i38) {
 i20 = i20 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 i38 = i38 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 i1 = i40 + 1088 | 0;
 i39 = i40 + 48 | 0;
 i13 = i40 + 40 | 0;
 i14 = i40 + 32 | 0;
 i37 = i40;
 if (!i38) {
  STACKTOP = i40;
  return;
 }
 i15 = (i18 | 0) != 0;
 if (!((i20 | 0) != 0 & (i19 | 0) != 0 & (i16 | 0) != 0 & i15 & (i17 | 0) != 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i8 = (__ZN2cv6String8allocateEj(i1, 60) | 0) + 0 | 0;
  i7 = 43680 | 0;
  i6 = i8 + 60 | 0;
  do {
   HEAP8[i8 >> 0] = HEAP8[i7 >> 0] | 0;
   i8 = i8 + 1 | 0;
   i7 = i7 + 1 | 0;
  } while ((i8 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 43744, 43512, 802);
  __ZN2cv6String10deallocateEv(i1);
 }
 i22 = HEAP32[i16 >> 2] | 0;
 i23 = 1212424721 >>> (i22 << 2 & 28) & 15;
 i22 = i22 & 7;
 i33 = i18 + i19 | 0;
 i1 = (i33 << 3) + 8 + (i38 << 5) | 0;
 i35 = i39 + 8 | 0;
 HEAP32[i39 >> 2] = i35;
 i36 = i39 + 4 | 0;
 HEAP32[i36 >> 2] = 1032;
 if (i1 >>> 0 > 1032) {
  i34 = __Znaj(i1) | 0;
  HEAP32[i39 >> 2] = i34;
 } else i34 = i35;
 HEAP32[i36 >> 2] = i1;
 i11 = i34 + (i33 << 2) | 0;
 i24 = i19 + 1 + i18 + i33 | 0;
 i29 = i34 + (i24 << 2) | 0;
 i25 = i24 + i38 | 0;
 i30 = i34 + (i25 << 2) | 0;
 i26 = i25 + i38 | 0;
 i27 = i26 + (i38 << 2) | 0;
 i31 = i34 + (i27 << 2) | 0;
 i28 = i27 + i38 | 0;
 i32 = i34 + (i28 << 2) | 0;
 i12 = (i19 | 0) == 0;
 if (!i12) {
  i10 = 0;
  do {
   HEAP32[i34 + (i10 << 2) >> 2] = i20 + (i10 * 56 | 0);
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i19 | 0));
 }
 if (i18) {
  i10 = 0;
  do {
   HEAP32[i34 + (i10 + i19 << 2) >> 2] = i16 + (i10 * 56 | 0);
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i18 | 0));
 }
 HEAP32[i34 + (i33 << 1 << 2) >> 2] = 0;
 i4 = i33;
 i3 = i13 + 4 | 0;
 i2 = i14 + 4 | 0;
 i1 = 0;
 do {
  i5 = i1 << 1;
  i10 = HEAP32[i17 + (i5 << 2) >> 2] | 0;
  i5 = HEAP32[i17 + ((i5 | 1) << 2) >> 2] | 0;
  if ((i10 | 0) > -1) {
   L22 : do if (!i12) {
    i9 = 0;
    while (1) {
     i8 = HEAP32[i20 + (i9 * 56 | 0) >> 2] | 0;
     i7 = (i8 >>> 3 & 511) + 1 | 0;
     if ((i10 | 0) < (i7 | 0)) break;
     i10 = i10 - i7 | 0;
     i9 = i9 + 1 | 0;
     if (i9 >>> 0 >= i19 >>> 0) {
      i21 = 16;
      break L22;
     }
    }
    if ((i8 & 7 | 0) != (i22 | 0)) i21 = 16;
   } else {
    i9 = 0;
    i21 = 16;
   } while (0);
   if ((i21 | 0) == 16) {
    i21 = 0;
    HEAP32[i13 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    i8 = (__ZN2cv6String8allocateEj(i13, 36) | 0) + 0 | 0;
    i7 = 43760 | 0;
    i6 = i8 + 36 | 0;
    do {
     HEAP8[i8 >> 0] = HEAP8[i7 >> 0] | 0;
     i8 = i8 + 1 | 0;
     i7 = i7 + 1 | 0;
    } while ((i8 | 0) < (i6 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i13, 43744, 43512, 829);
    __ZN2cv6String10deallocateEv(i13);
    i8 = HEAP32[i20 + (i9 * 56 | 0) >> 2] | 0;
   }
   i6 = i1 << 2;
   HEAP32[i34 + (i6 + i26 << 2) >> 2] = i9;
   HEAP32[i34 + ((i6 | 1) + i26 << 2) >> 2] = Math_imul(i10, i23) | 0;
   HEAP32[i34 + (i1 + i27 << 2) >> 2] = (i8 >>> 3 & 511) + 1;
  } else {
   i6 = i1 << 2;
   HEAP32[i34 + (i6 + i26 << 2) >> 2] = i4;
   HEAP32[i34 + ((i6 | 1) + i26 << 2) >> 2] = 0;
   HEAP32[i34 + (i1 + i27 << 2) >> 2] = 0;
  }
  L32 : do if (i15) {
   i10 = i5;
   i9 = 0;
   while (1) {
    i8 = HEAP32[i16 + (i9 * 56 | 0) >> 2] | 0;
    i7 = (i8 >>> 3 & 511) + 1 | 0;
    if ((i10 | 0) < (i7 | 0)) break;
    i10 = i10 - i7 | 0;
    i9 = i9 + 1 | 0;
    if (i9 >>> 0 >= i18 >>> 0) {
     i21 = 23;
     break L32;
    }
   }
   if (!((i10 | 0) > -1 & (i8 & 7 | 0) == (i22 | 0))) i21 = 23;
  } else {
   i10 = i5;
   i9 = 0;
   i21 = 23;
  } while (0);
  if ((i21 | 0) == 23) {
   i21 = 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   i8 = (__ZN2cv6String8allocateEj(i14, 47) | 0) + 0 | 0;
   i7 = 43800 | 0;
   i6 = i8 + 47 | 0;
   do {
    HEAP8[i8 >> 0] = HEAP8[i7 >> 0] | 0;
    i8 = i8 + 1 | 0;
    i7 = i7 + 1 | 0;
   } while ((i8 | 0) < (i6 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i14, 43744, 43512, 842);
   __ZN2cv6String10deallocateEv(i14);
   i8 = HEAP32[i16 + (i9 * 56 | 0) >> 2] | 0;
  }
  i5 = i1 << 2;
  HEAP32[i34 + ((i5 | 2) + i26 << 2) >> 2] = i9 + i19;
  HEAP32[i34 + ((i5 | 3) + i26 << 2) >> 2] = Math_imul(i10, i23) | 0;
  HEAP32[i34 + (i1 + i28 << 2) >> 2] = (i8 >>> 3 & 511) + 1;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i38 >>> 0);
 __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i37, i34, i11, i33);
 i9 = HEAP32[i37 + 20 >> 2] | 0;
 i10 = ((i23 + 1023 | 0) >>> 0) / (i23 >>> 0) | 0;
 i10 = (i10 | 0) < (i9 | 0) ? i10 : i9;
 i6 = HEAP32[44376 + (i22 << 2) >> 2] | 0;
 i7 = i37 + 16 | 0;
 i8 = (i9 | 0) > 0;
 i4 = Math_imul(i10, i23) | 0;
 i5 = 0;
 while (1) {
  if (i5 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) i1 = 0; else break;
  do {
   i22 = i1 << 2;
   HEAP32[i34 + (i1 + i24 << 2) >> 2] = (HEAP32[i34 + ((HEAP32[i34 + (i22 + i26 << 2) >> 2] | 0) + i33 << 2) >> 2] | 0) + (HEAP32[i34 + ((i22 | 1) + i26 << 2) >> 2] | 0);
   HEAP32[i34 + (i1 + i25 << 2) >> 2] = (HEAP32[i34 + ((HEAP32[i34 + ((i22 | 2) + i26 << 2) >> 2] | 0) + i33 << 2) >> 2] | 0) + (HEAP32[i34 + ((i22 | 3) + i26 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i38 | 0));
  L46 : do if (i8) {
   i3 = 0;
   do {
    i1 = i9 - i3 | 0;
    FUNCTION_TABLE_viiiiii[i6 & 31](i29, i31, i30, i32, (i10 | 0) < (i1 | 0) ? i10 : i1, i38);
    i3 = i3 + i10 | 0;
    i1 = (i3 | 0) < (i9 | 0);
    if (i1) i2 = 0; else break L46;
    do {
     i22 = Math_imul(i4, HEAP32[i34 + (i2 + i27 << 2) >> 2] | 0) | 0;
     i21 = i34 + (i2 + i24 << 2) | 0;
     HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + i22;
     i21 = Math_imul(i4, HEAP32[i34 + (i2 + i28 << 2) >> 2] | 0) | 0;
     i22 = i34 + (i2 + i25 << 2) | 0;
     HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i21;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i38 | 0));
   } while (i1);
  } while (0);
  __ZN2cv15NAryMatIteratorppEv(i37) | 0;
  i5 = i5 + 1 | 0;
 }
 i1 = HEAP32[i39 >> 2] | 0;
 if ((i1 | 0) == (i35 | 0)) {
  STACKTOP = i40;
  return;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i39 >> 2] = i35;
 HEAP32[i36 >> 2] = 1032;
 STACKTOP = i40;
 return;
}

function _cvReadRawDataSlice(i2, i22, i8, i20, i6) {
 i2 = i2 | 0;
 i22 = i22 | 0;
 i8 = i8 | 0;
 i20 = i20 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, d7 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 i21 = i24 + 40 | 0;
 i3 = i24 + 32 | 0;
 i4 = i24 + 24 | 0;
 i5 = i24 + 16 | 0;
 i19 = i24 + 8 | 0;
 i23 = i24;
 i1 = (i2 | 0) != 0;
 if (!(i1 ? (HEAP32[i2 >> 2] | 0) == 1280131417 : 0)) {
  i2 = i1 ? -5 : -27;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i9 = (__ZN2cv6String8allocateEj(i3, 31) | 0) + 0 | 0;
  i10 = 9096 | 0;
  i11 = i9 + 31 | 0;
  do {
   HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
   i9 = i9 + 1 | 0;
   i10 = i10 + 1 | 0;
  } while ((i9 | 0) < (i11 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i2, i3, 10264, 8960, 3210);
  __ZN2cv6String10deallocateEv(i3);
 }
 if (!((i22 | 0) != 0 & (i20 | 0) != 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i9 = (__ZN2cv6String8allocateEj(i4, 43) | 0) + 0 | 0;
  i10 = 10288 | 0;
  i11 = i9 + 43 | 0;
  do {
   HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
   i9 = i9 + 1 | 0;
   i10 = i10 + 1 | 0;
  } while ((i9 | 0) < (i11 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i4, 10264, 8960, 3213);
  __ZN2cv6String10deallocateEv(i4);
 }
 i18 = i22 + 4 | 0;
 if ((HEAP32[i18 >> 2] | 0) == 0 & (i8 | 0) != 1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i9 = (__ZN2cv6String8allocateEj(i5, 51) | 0) + 0 | 0;
  i10 = 10336 | 0;
  i11 = i9 + 51 | 0;
  do {
   HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
   i9 = i9 + 1 | 0;
   i10 = i10 + 1 | 0;
  } while ((i9 | 0) < (i11 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i5, 10264, 8960, 3216);
  __ZN2cv6String10deallocateEv(i5);
 }
 i16 = __ZL15icvDecodeFormatPKcPii(i6, i21) | 0;
 i13 = i20;
 i17 = i22 + 12 | 0;
 i14 = i19 + 4 | 0;
 i15 = i22 + 20 | 0;
 i1 = i8;
 i2 = 0;
 i6 = -1;
 L12 : while (1) {
  while (1) if ((i2 | 0) < (i16 | 0)) break; else i2 = 0;
  i12 = i2 << 1;
  i3 = HEAP32[i21 + ((i12 | 1) << 2) >> 2] | 0;
  i4 = (i3 >>> 3 & 511) + 1 << (47696 >>> (i3 << 1 & 14) & 3);
  i12 = HEAP32[i21 + (i12 << 2) >> 2] | 0;
  i4 = i20 + (i6 + i4 & 0 - i4) | 0;
  if ((i12 | 0) > 0) {
   i8 = 0;
   while (1) {
    i6 = HEAP32[i17 >> 2] | 0;
    i5 = HEAP32[i6 >> 2] & 7;
    L20 : do if ((i5 | 0) == 2) {
     d7 = +HEAPF64[i6 + 8 >> 3];
     switch (i3 | 0) {
     case 1:
      {
       i6 = _lrint(d7) | 0;
       if ((i6 + 128 | 0) >>> 0 >= 256) i6 = (i6 | 0) > 0 ? 127 : -128;
       HEAP8[i4 >> 0] = i6;
       i4 = i4 + 1 | 0;
       break L20;
      }
     case 0:
      {
       i6 = _lrint(d7) | 0;
       if (i6 >>> 0 >= 256) i6 = (i6 | 0) > 0 ? 255 : 0;
       HEAP8[i4 >> 0] = i6;
       i4 = i4 + 1 | 0;
       break L20;
      }
     case 2:
      {
       i6 = _lrint(d7) | 0;
       if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
       HEAP16[i4 >> 1] = i6;
       i4 = i4 + 2 | 0;
       break L20;
      }
     case 3:
      {
       i6 = _lrint(d7) | 0;
       if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
       HEAP16[i4 >> 1] = i6;
       i4 = i4 + 2 | 0;
       break L20;
      }
     case 4:
      {
       HEAP32[i4 >> 2] = _lrint(d7) | 0;
       i4 = i4 + 4 | 0;
       break L20;
      }
     case 5:
      {
       HEAPF32[i4 >> 2] = Math_fround(d7);
       i4 = i4 + 4 | 0;
       break L20;
      }
     case 6:
      {
       HEAPF64[i4 >> 3] = d7;
       i4 = i4 + 8 | 0;
       break L20;
      }
     case 7:
      {
       HEAP32[i4 >> 2] = _lrint(d7) | 0;
       i4 = i4 + 4 | 0;
       break L20;
      }
     default:
      {
       i1 = 57;
       break L12;
      }
     }
    } else if ((i5 | 0) == 1) {
     i6 = HEAP32[i6 + 8 >> 2] | 0;
     switch (i3 | 0) {
     case 2:
      {
       if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
       HEAP16[i4 >> 1] = i6;
       i4 = i4 + 2 | 0;
       break L20;
      }
     case 1:
      {
       if ((i6 + 128 | 0) >>> 0 >= 256) i6 = (i6 | 0) > 0 ? 127 : -128;
       HEAP8[i4 >> 0] = i6;
       i4 = i4 + 1 | 0;
       break L20;
      }
     case 3:
      {
       if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
       HEAP16[i4 >> 1] = i6;
       i4 = i4 + 2 | 0;
       break L20;
      }
     case 4:
      {
       HEAP32[i4 >> 2] = i6;
       i4 = i4 + 4 | 0;
       break L20;
      }
     case 5:
      {
       HEAPF32[i4 >> 2] = Math_fround(i6 | 0);
       i4 = i4 + 4 | 0;
       break L20;
      }
     case 6:
      {
       HEAPF64[i4 >> 3] = +(i6 | 0);
       i4 = i4 + 8 | 0;
       break L20;
      }
     case 7:
      {
       HEAP32[i4 >> 2] = i6;
       i4 = i4 + 4 | 0;
       break L20;
      }
     case 0:
      {
       if (i6 >>> 0 >= 256) i6 = (i6 | 0) > 0 ? 255 : 0;
       HEAP8[i4 >> 0] = i6;
       i4 = i4 + 1 | 0;
       break L20;
      }
     default:
      {
       i1 = 57;
       break L12;
      }
     }
    } else {
     HEAP32[i19 >> 2] = 0;
     HEAP32[i14 >> 2] = 0;
     i9 = (__ZN2cv6String8allocateEj(i19, 46) | 0) + 0 | 0;
     i10 = 10392 | 0;
     i11 = i9 + 46 | 0;
     do {
      HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
      i9 = i9 + 1 | 0;
      i10 = i10 + 1 | 0;
     } while ((i9 | 0) < (i11 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i19, 10264, 8960, 3330);
     __ZN2cv6String10deallocateEv(i19);
    } while (0);
    i5 = (HEAP32[i17 >> 2] | 0) + 16 | 0;
    HEAP32[i17 >> 2] = i5;
    if (i5 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) _cvChangeSeqBlock(i22, 1);
    i1 = i1 + -1 | 0;
    i6 = i8 + 1 | 0;
    if (!i1) {
     i1 = 53;
     break L12;
    }
    if ((i6 | 0) < (i12 | 0)) i8 = i6; else break;
   }
  }
  i2 = i2 + 1 | 0;
  i6 = i4 - i13 + -1 | 0;
 }
 if ((i1 | 0) == 53) {
  if (!((i8 | 0) == (i12 + -1 | 0) & (i2 | 0) == (i16 + -1 | 0))) {
   HEAP32[i23 >> 2] = 0;
   HEAP32[i23 + 4 >> 2] = 0;
   i9 = (__ZN2cv6String8allocateEj(i23, 60) | 0) + 0 | 0;
   i10 = 10440 | 0;
   i11 = i9 + 60 | 0;
   do {
    HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
    i9 = i9 + 1 | 0;
    i10 = i10 + 1 | 0;
   } while ((i9 | 0) < (i11 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i23, 10264, 8960, 3344);
   __ZN2cv6String10deallocateEv(i23);
  }
  if (HEAP32[i18 >> 2] | 0) {
   STACKTOP = i24;
   return;
  }
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -16;
  STACKTOP = i24;
  return;
 } else if ((i1 | 0) == 57) {
  STACKTOP = i24;
  return;
 }
}

function __ZN2cvL14MulTransposedRIfdEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d28) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d28 = +d28;
 var d4 = 0.0, d5 = 0.0, d6 = 0.0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, d30 = 0.0, d31 = 0.0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i27 = i29;
 i25 = HEAP32[i3 + 16 >> 2] | 0;
 i18 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i26 = (HEAP32[i3 + 48 >> 2] | 0) >>> 2;
 i24 = (HEAP32[i1 + 48 >> 2] | 0) >>> 3;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i9 = (HEAP32[i2 + 48 >> 2] | 0) >>> 3; else i9 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i20 = HEAP32[i3 + 40 >> 2] | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = i27 + 8 | 0;
 HEAP32[i27 >> 2] = i21;
 i22 = i27 + 4 | 0;
 HEAP32[i22 >> 2] = 1032;
 i3 = (i7 | 0) != 0;
 i2 = (i2 | 0) < (i19 | 0);
 if (i3 & i2) i1 = i20 * 40 | 0; else i1 = i20 << 3;
 if (i1 >>> 0 > 1032) {
  i23 = __Znaj(i1) | 0;
  HEAP32[i27 >> 2] = i23;
 } else i23 = i21;
 HEAP32[i22 >> 2] = i1;
 do if (i3) {
  if (i2) {
   i2 = i23 + (i20 << 3) | 0;
   if ((i20 | 0) > 0) {
    i3 = 0;
    do {
     d4 = +HEAPF64[i7 + ((Math_imul(i3, i9) | 0) << 3) >> 3];
     i16 = i3 << 2;
     HEAPF64[i23 + ((i16 | 3) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + ((i16 | 2) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + ((i16 | 1) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + (i16 + i20 << 3) >> 3] = d4;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if (!i2) {
    i17 = 14;
    break;
   } else {
    i7 = i2;
    i16 = i2;
    i9 = (i9 | 0) != 0 ? 4 : 0;
   }
  } else i16 = 0;
  if ((i19 | 0) > 0) {
   i11 = (i16 | 0) != 0;
   i13 = (i20 | 0) > 0;
   i12 = i19 + -4 | 0;
   i14 = 0;
   i15 = i18;
   while (1) {
    if (i11) {
     if (i13) {
      i3 = 0;
      do {
       d4 = +Math_fround(HEAPF32[i25 + ((Math_imul(i3, i26) | 0) + i14 << 2) >> 2]);
       HEAPF64[i23 + (i3 << 3) >> 3] = d4 - +HEAPF64[i16 + ((Math_imul(i3, i9) | 0) << 3) >> 3];
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i20 | 0));
     }
    } else if (i13) {
     i3 = 0;
     do {
      d4 = +Math_fround(HEAPF32[i25 + ((Math_imul(i3, i26) | 0) + i14 << 2) >> 2]);
      HEAPF64[i23 + (i3 << 3) >> 3] = d4 - +HEAPF64[i7 + ((Math_imul(i3, i9) | 0) + i14 << 3) >> 3];
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i20 | 0));
    }
    if ((i14 | 0) > (i12 | 0)) i3 = i14; else {
     i3 = i14;
     do {
      if (i11) i2 = i16; else i2 = i7 + (i3 << 3) | 0;
      if (i13) {
       i10 = 0;
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
       i1 = i25 + (i3 << 2) | 0;
       while (1) {
        d31 = +HEAPF64[i23 + (i10 << 3) >> 3];
        d30 = +Math_fround(HEAPF32[i1 >> 2]);
        d4 = d4 + d31 * (d30 - +HEAPF64[i2 >> 3]);
        d30 = +Math_fround(HEAPF32[i1 + 4 >> 2]);
        d5 = d5 + d31 * (d30 - +HEAPF64[i2 + 8 >> 3]);
        d30 = +Math_fround(HEAPF32[i1 + 8 >> 2]);
        d6 = d6 + d31 * (d30 - +HEAPF64[i2 + 16 >> 3]);
        d30 = +Math_fround(HEAPF32[i1 + 12 >> 2]);
        d8 = d8 + d31 * (d30 - +HEAPF64[i2 + 24 >> 3]);
        i10 = i10 + 1 | 0;
        if ((i10 | 0) == (i20 | 0)) break; else {
         i2 = i2 + (i9 << 3) | 0;
         i1 = i1 + (i26 << 2) | 0;
        }
       }
      } else {
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
      }
      HEAPF64[i15 + (i3 << 3) >> 3] = d4 * d28;
      HEAPF64[i15 + (i3 + 1 << 3) >> 3] = d5 * d28;
      HEAPF64[i15 + (i3 + 2 << 3) >> 3] = d6 * d28;
      HEAPF64[i15 + (i3 + 3 << 3) >> 3] = d8 * d28;
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i12 | 0));
    }
    if ((i3 | 0) < (i19 | 0)) do {
     if (i11) i2 = i16; else i2 = i7 + (i3 << 3) | 0;
     if (i13) {
      i1 = 0;
      d8 = 0.0;
      i10 = i25 + (i3 << 2) | 0;
      while (1) {
       d4 = +Math_fround(HEAPF32[i10 >> 2]);
       d8 = d8 + +HEAPF64[i23 + (i1 << 3) >> 3] * (d4 - +HEAPF64[i2 >> 3]);
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i20 | 0)) break; else {
        i2 = i2 + (i9 << 3) | 0;
        i10 = i10 + (i26 << 2) | 0;
       }
      }
     } else d8 = 0.0;
     HEAPF64[i15 + (i3 << 3) >> 3] = d8 * d28;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i19 | 0));
    i14 = i14 + 1 | 0;
    if ((i14 | 0) == (i19 | 0)) break; else i15 = i15 + (i24 << 3) | 0;
   }
  }
 } else i17 = 14; while (0);
 if ((i17 | 0) == 14 ? (i19 | 0) > 0 : 0) {
  i11 = (i20 | 0) > 0;
  i12 = i19 + -4 | 0;
  i13 = 0;
  i10 = i18;
  while (1) {
   if (i11) {
    i3 = 0;
    do {
     HEAPF64[i23 + (i3 << 3) >> 3] = +Math_fround(HEAPF32[i25 + ((Math_imul(i3, i26) | 0) + i13 << 2) >> 2]);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if ((i13 | 0) > (i12 | 0)) i3 = i13; else {
    i3 = i13;
    do {
     if (i11) {
      i9 = 0;
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
      i7 = i25 + (i3 << 2) | 0;
      while (1) {
       d30 = +HEAPF64[i23 + (i9 << 3) >> 3];
       d8 = d8 + d30 * +Math_fround(HEAPF32[i7 >> 2]);
       d6 = d6 + d30 * +Math_fround(HEAPF32[i7 + 4 >> 2]);
       d5 = d5 + d30 * +Math_fround(HEAPF32[i7 + 8 >> 2]);
       d4 = d4 + d30 * +Math_fround(HEAPF32[i7 + 12 >> 2]);
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == (i20 | 0)) break; else i7 = i7 + (i26 << 2) | 0;
      }
     } else {
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
     }
     HEAPF64[i10 + (i3 << 3) >> 3] = d8 * d28;
     HEAPF64[i10 + (i3 + 1 << 3) >> 3] = d6 * d28;
     HEAPF64[i10 + (i3 + 2 << 3) >> 3] = d5 * d28;
     HEAPF64[i10 + (i3 + 3 << 3) >> 3] = d4 * d28;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i12 | 0));
   }
   if ((i3 | 0) < (i19 | 0)) do {
    if (i11) {
     i2 = 0;
     d4 = 0.0;
     i1 = i25 + (i3 << 2) | 0;
     while (1) {
      d4 = d4 + +HEAPF64[i23 + (i2 << 3) >> 3] * +Math_fround(HEAPF32[i1 >> 2]);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break; else i1 = i1 + (i26 << 2) | 0;
     }
    } else d4 = 0.0;
    HEAPF64[i10 + (i3 << 3) >> 3] = d4 * d28;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i19 | 0));
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i19 | 0)) break; else i10 = i10 + (i24 << 3) | 0;
  }
 }
 if ((i23 | 0) == (i21 | 0)) {
  STACKTOP = i29;
  return;
 }
 __ZdaPv(i23);
 HEAP32[i27 >> 2] = i21;
 HEAP32[i22 >> 2] = 1032;
 STACKTOP = i29;
 return;
}

function __ZN7testing8internal15UnitTestOptions27GetAbsolutePathToOutputFileEv(i22) {
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 i18 = i23 + 192 | 0;
 i15 = i23 + 180 | 0;
 i5 = i23 + 168 | 0;
 i6 = i23 + 156 | 0;
 i7 = i23 + 144 | 0;
 i8 = i23 + 132 | 0;
 i9 = i23 + 120 | 0;
 i19 = i23 + 108 | 0;
 i3 = i23 + 96 | 0;
 i12 = i23 + 84 | 0;
 i13 = i23 + 72 | 0;
 i14 = i23 + 60 | 0;
 i10 = i23 + 48 | 0;
 i11 = i23 + 36 | 0;
 i20 = i23 + 24 | 0;
 i16 = i23 + 12 | 0;
 i17 = i23;
 i4 = (HEAP8[159944] & 1) == 0 ? 159945 : HEAP32[39988] | 0;
 if (!i4) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, 159968, 0);
  STACKTOP = i23;
  return;
 }
 i4 = _strchr(i4, 58) | 0;
 if (!i4) {
  if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
   HEAP32[40932] = 163936;
   i21 = __Znwj(216) | 0;
   __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i21, 163728);
   HEAP32[40934] = i21;
   ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
   ___cxa_guard_release(163744);
  }
  i1 = HEAP32[40934] | 0;
  i2 = i1 + 8 | 0;
  if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i1, _strlen(i1 | 0) | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i6, i7);
  __ZN7testing8internal8FilePath9NormalizeEv(i6);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, 160472, 15);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i8, i9);
  __ZN7testing8internal8FilePath9NormalizeEv(i8);
  __ZN7testing8internal8FilePath11ConcatPathsERKS1_S3_(i5, i6, i8);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i22, i5);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
  STACKTOP = i23;
  return;
 }
 i1 = i4 + 1 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i1, _strlen(i1 | 0) | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i19, i3);
 __ZN7testing8internal8FilePath9NormalizeEv(i19);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
 i2 = HEAP8[i19 >> 0] | 0;
 if (!(i2 & 1)) i4 = i19 + 1 | 0; else i4 = HEAP32[i19 + 8 >> 2] | 0;
 if ((HEAP8[i4 >> 0] | 0) != 47) {
  if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
   HEAP32[40932] = 163936;
   i2 = __Znwj(216) | 0;
   __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i2, 163728);
   HEAP32[40934] = i2;
   ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
   ___cxa_guard_release(163744);
  }
  i4 = HEAP32[40934] | 0;
  i3 = i4 + 8 | 0;
  if (!(HEAP8[i3 >> 0] & 1)) i4 = i3 + 1 | 0; else i4 = HEAP32[i4 + 16 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, i4, _strlen(i4 | 0) | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i13, i14);
  __ZN7testing8internal8FilePath9NormalizeEv(i13);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i1, _strlen(i1 | 0) | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i10, i11);
  __ZN7testing8internal8FilePath9NormalizeEv(i10);
  __ZN7testing8internal8FilePath11ConcatPathsERKS1_S3_(i12, i13, i10);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i19, i12) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
  i2 = HEAP8[i19 >> 0] | 0;
 }
 i1 = (i2 & 1) == 0;
 if (i1) i3 = (i2 & 255) >>> 1; else i3 = HEAP32[i19 + 4 >> 2] | 0;
 if (i3) {
  if (i1) {
   i2 = (i2 & 255) >>> 1;
   i1 = i19 + 1 | 0;
  } else {
   i2 = HEAP32[i19 + 4 >> 2] | 0;
   i1 = HEAP32[i19 + 8 >> 2] | 0;
  }
  if ((HEAP8[i1 + (i2 + -1) >> 0] | 0) == 47) {
   __ZN7testing8internal24GetCurrentExecutableNameEv(i16);
   i2 = (HEAP8[159944] & 1) == 0 ? 159945 : HEAP32[39988] | 0;
   do if (i2) {
    i1 = _strchr(i2, 58) | 0;
    if (!i1) {
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i2, _strlen(i2 | 0) | 0);
     break;
    } else {
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i2, i1 - i2 | 0);
     break;
    }
   } else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, 159968, 0); while (0);
   if (!(HEAP8[i17 >> 0] & 1)) i1 = i17 + 1 | 0; else i1 = HEAP32[i17 + 8 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i20, 159968, 0);
   i3 = i20 + 1 | 0;
   i2 = i20 + 8 | 0;
   i4 = 0;
   while (1) {
    __ZN7testing8internal8FilePath12MakeFileNameERKS1_S3_iPKc(i15, i19, i16, i4, i1);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i20, i15) | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
    if (!(_stat(((HEAP8[i20 >> 0] & 1) == 0 ? i3 : HEAP32[i2 >> 2] | 0) | 0, i18 | 0) | 0)) i4 = i4 + 1 | 0; else break;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i22, i20);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
  } else i21 = 30;
 } else i21 = 30;
 if ((i21 | 0) == 30) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i22, i19);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
 STACKTOP = i23;
 return;
}

function __Z20RGBE_WritePixels_RLEP8_IO_FILEPfii(i26, i3, i28, i2) {
 i26 = i26 | 0;
 i3 = i3 | 0;
 i28 = i28 | 0;
 i2 = i2 | 0;
 var i1 = 0, f4 = Math_fround(0), f5 = Math_fround(0), f6 = Math_fround(0), d7 = 0.0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = Math_fround(0);
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i29 = i31 + 8 | 0;
 i25 = i31 + 16 | 0;
 i27 = i31;
 if ((i28 + -8 | 0) >>> 0 > 32759) {
  i23 = __Z16RGBE_WritePixelsP8_IO_FILEPfi(i26, i3, Math_imul(i2, i28) | 0) | 0;
  STACKTOP = i31;
  return i23 | 0;
 }
 i30 = _malloc(i28 << 2) | 0;
 if (!i30) {
  i23 = __Z16RGBE_WritePixelsP8_IO_FILEPfi(i26, i3, Math_imul(i2, i28) | 0) | 0;
  STACKTOP = i31;
  return i23 | 0;
 }
 L9 : do if ((i2 | 0) > 0) {
  i24 = i27 + 1 | 0;
  i16 = i28 >>> 8 & 255;
  i17 = i27 + 2 | 0;
  i18 = i28 & 255;
  i19 = i27 + 3 | 0;
  i20 = (i28 | 0) > 0;
  i21 = i25 + 1 | 0;
  i22 = i28 << 1;
  i23 = i28 * 3 | 0;
  L11 : while (1) {
   i2 = i2 + -1 | 0;
   HEAP8[i27 >> 0] = 2;
   HEAP8[i24 >> 0] = 2;
   HEAP8[i17 >> 0] = i16;
   HEAP8[i19 >> 0] = i18;
   if (!(_fwrite(i27 | 0, 4, 1, i26 | 0) | 0)) {
    i1 = 10;
    break;
   }
   if (i20) {
    i11 = i3;
    i12 = 0;
    while (1) {
     f4 = Math_fround(HEAPF32[i11 + 8 >> 2]);
     f5 = Math_fround(HEAPF32[i11 + 4 >> 2]);
     f6 = Math_fround(HEAPF32[i11 >> 2]);
     f32 = f5 > f4 ? f5 : f4;
     d7 = +(f32 < f6 ? f6 : f32);
     if (d7 < 1.0e-32) {
      HEAP32[i27 >> 2] = 0;
      i1 = 0;
      i8 = 0;
      i9 = 0;
      i10 = 0;
     } else {
      f32 = Math_fround(+_frexp(d7, i29) * 256.0 / d7);
      i1 = ~~Math_fround(f4 * f32) & 255;
      HEAP8[i27 >> 0] = i1;
      i8 = ~~Math_fround(f5 * f32) & 255;
      HEAP8[i24 >> 0] = i8;
      i9 = ~~Math_fround(f6 * f32) & 255;
      HEAP8[i17 >> 0] = i9;
      i10 = (HEAP32[i29 >> 2] | 0) + 128 & 255;
      HEAP8[i19 >> 0] = i10;
     }
     HEAP8[i30 + i12 >> 0] = i1;
     HEAP8[i30 + (i12 + i28) >> 0] = i8;
     HEAP8[i30 + (i12 + i22) >> 0] = i9;
     HEAP8[i30 + (i12 + i23) >> 0] = i10;
     i12 = i12 + 1 | 0;
     if ((i12 | 0) == (i28 | 0)) break; else i11 = i11 + 12 | 0;
    }
    i3 = i3 + (i23 << 2) | 0;
   }
   i15 = 0;
   do {
    i14 = Math_imul(i15, i28) | 0;
    if (i20) {
     i1 = 0;
     do if ((i1 | 0) < (i28 | 0)) {
      i13 = i1;
      i12 = 0;
      while (1) {
       i13 = i13 + i12 | 0;
       i10 = i13 + 1 | 0;
       L31 : do if ((i10 | 0) < (i28 | 0)) {
        i11 = HEAP8[i30 + (i13 + i14) >> 0] | 0;
        i8 = 1;
        while (1) {
         i9 = i8 + 1 | 0;
         if (i11 << 24 >> 24 != (HEAP8[i30 + (i10 + i14) >> 0] | 0)) break L31;
         i10 = i9 + i13 | 0;
         if (!((i10 | 0) < (i28 | 0) & (i9 | 0) < 127)) {
          i8 = i9;
          break;
         } else i8 = i9;
        }
       } else i8 = 1; while (0);
       if (!((i8 | 0) < 4 & (i13 | 0) < (i28 | 0))) break; else i12 = i8;
      }
      if ((i12 | 0) > 1 & (i12 | 0) == (i13 - i1 | 0)) {
       HEAP8[i25 >> 0] = i12 + 128;
       HEAP8[i21 >> 0] = HEAP8[i30 + (i1 + i14) >> 0] | 0;
       if (!(_fwrite(i25 | 0, 2, 1, i26 | 0) | 0)) {
        i1 = 27;
        break L11;
       } else i1 = i13;
      } else if ((i13 | 0) > (i1 | 0)) {
       i9 = i1;
       while (1) {
        i10 = i13 - i9 | 0;
        i10 = (i10 | 0) > 128 ? 128 : i10;
        HEAP8[i25 >> 0] = i10;
        if (!(_fwrite(i25 | 0, 1, 1, i26 | 0) | 0)) {
         i1 = 30;
         break L11;
        }
        i1 = i10 + i9 | 0;
        if (!(_fwrite(i30 + (i9 + i14) | 0, i10 | 0, 1, i26 | 0) | 0)) {
         i1 = 32;
         break L11;
        }
        if ((i13 | 0) > (i1 | 0)) i9 = i1; else break;
       }
      }
      if ((i8 | 0) > 3) {
       HEAP8[i25 >> 0] = i8 + 128;
       HEAP8[i21 >> 0] = HEAP8[i30 + (i13 + i14) >> 0] | 0;
       if (!(_fwrite(i25 | 0, 2, 1, i26 | 0) | 0)) {
        i1 = 35;
        break L11;
       }
       i1 = i1 + i8 | 0;
      }
     } while ((i1 | 0) < (i28 | 0));
    }
    i15 = i15 + 1 | 0;
   } while ((i15 | 0) < 4);
   if ((i2 | 0) <= 0) break L9;
  }
  if ((i1 | 0) == 10) {
   _free(i30);
   HEAP32[i29 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i29, 16) | 0) + 0 | 0;
   i2 = 181784;
   i3 = i1 + 16 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i29, 181704, 181720, 93);
   __ZN2cv6String10deallocateEv(i29);
   i23 = -1;
   STACKTOP = i31;
   return i23 | 0;
  } else if ((i1 | 0) == 27) {
   HEAP32[i29 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i29, 16) | 0) + 0 | 0;
   i2 = 181784;
   i3 = i1 + 16 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i29, 181704, 181720, 93);
   __ZN2cv6String10deallocateEv(i29);
  } else if ((i1 | 0) == 30) {
   HEAP32[i29 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i29, 16) | 0) + 0 | 0;
   i2 = 181784;
   i3 = i1 + 16 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i29, 181704, 181720, 93);
   __ZN2cv6String10deallocateEv(i29);
  } else if ((i1 | 0) == 32) {
   HEAP32[i29 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i29, 16) | 0) + 0 | 0;
   i2 = 181784;
   i3 = i1 + 16 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i29, 181704, 181720, 93);
   __ZN2cv6String10deallocateEv(i29);
  } else if ((i1 | 0) == 35) {
   HEAP32[i29 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i29, 16) | 0) + 0 | 0;
   i2 = 181784;
   i3 = i1 + 16 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i29, 181704, 181720, 93);
   __ZN2cv6String10deallocateEv(i29);
  }
  _free(i30);
  i23 = -1;
  STACKTOP = i31;
  return i23 | 0;
 } while (0);
 _free(i30);
 i23 = 0;
 STACKTOP = i31;
 return i23 | 0;
}

function __ZN4perf8TestBase6warmupERKN2cv17_InputOutputArrayENS0_10WarmUpTypeE(i25, i24) {
 i25 = i25 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 i9 = i26 + 380 | 0;
 i8 = i26 + 72 | 0;
 i14 = i26 + 360 | 0;
 i15 = i26 + 64 | 0;
 i16 = i26 + 340 | 0;
 i17 = i26 + 56 | 0;
 i18 = i26 + 320 | 0;
 i19 = i26 + 48 | 0;
 i20 = i26 + 300 | 0;
 i21 = i26 + 40 | 0;
 i7 = i26 + 280 | 0;
 i6 = i26 + 32 | 0;
 i5 = i26 + 260 | 0;
 i4 = i26 + 24 | 0;
 i3 = i26 + 240 | 0;
 i2 = i26 + 16 | 0;
 i1 = i26 + 220 | 0;
 i11 = i26 + 8 | 0;
 i12 = i26 + 200 | 0;
 i13 = i26;
 i22 = i26 + 192 | 0;
 i10 = i26 + 136 | 0;
 i23 = i26 + 80 | 0;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i25 >> 2] | 0) + 76 >> 2] & 127](i25) | 0) {
  STACKTOP = i26;
  return;
 }
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i25 >> 2] | 0) + 24 >> 2] & 127](i25) | 0) == 655360) {
  if ((i24 + -1 | 0) >>> 0 >= 2) {
   STACKTOP = i26;
   return;
  }
  i10 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i25 >> 2] | 0) + 60 >> 2] & 127](i25, -1) | 0;
  if (!i10) {
   HEAPF64[i8 >> 3] = 0.0;
   HEAP32[i9 >> 2] = 32088;
   HEAP32[i9 + 4 >> 2] = -1056833530;
   HEAP32[i9 + 8 >> 2] = i8;
   HEAP32[i9 + 12 >> 2] = 1;
   HEAP32[i9 + 16 >> 2] = 1;
   HEAPF64[i15 >> 3] = 256.0;
   HEAP32[i14 >> 2] = 32088;
   HEAP32[i14 + 4 >> 2] = -1056833530;
   HEAP32[i14 + 8 >> 2] = i15;
   HEAP32[i14 + 12 >> 2] = 1;
   HEAP32[i14 + 16 >> 2] = 1;
   __ZN2cv5randuERKNS_17_InputOutputArrayERKNS_11_InputArrayES5_(i25, i9, i14);
   STACKTOP = i26;
   return;
  } else if ((i10 | 0) == 2) {
   HEAPF64[i21 >> 3] = 0.0;
   HEAP32[i20 >> 2] = 32088;
   HEAP32[i20 + 4 >> 2] = -1056833530;
   HEAP32[i20 + 8 >> 2] = i21;
   HEAP32[i20 + 12 >> 2] = 1;
   HEAP32[i20 + 16 >> 2] = 1;
   HEAPF64[i6 >> 3] = 1024.0;
   HEAP32[i7 >> 2] = 32088;
   HEAP32[i7 + 4 >> 2] = -1056833530;
   HEAP32[i7 + 8 >> 2] = i6;
   HEAP32[i7 + 12 >> 2] = 1;
   HEAP32[i7 + 16 >> 2] = 1;
   __ZN2cv5randuERKNS_17_InputOutputArrayERKNS_11_InputArrayES5_(i25, i20, i7);
   STACKTOP = i26;
   return;
  } else if ((i10 | 0) != 1) {
   if ((i10 + -5 | 0) >>> 0 < 2) {
    HEAPF64[i4 >> 3] = -1.0;
    HEAP32[i5 >> 2] = 32088;
    HEAP32[i5 + 4 >> 2] = -1056833530;
    HEAP32[i5 + 8 >> 2] = i4;
    HEAP32[i5 + 12 >> 2] = 1;
    HEAP32[i5 + 16 >> 2] = 1;
    HEAPF64[i2 >> 3] = 1.0;
    HEAP32[i3 >> 2] = 32088;
    HEAP32[i3 + 4 >> 2] = -1056833530;
    HEAP32[i3 + 8 >> 2] = i2;
    HEAP32[i3 + 12 >> 2] = 1;
    HEAP32[i3 + 16 >> 2] = 1;
    __ZN2cv5randuERKNS_17_InputOutputArrayERKNS_11_InputArrayES5_(i25, i5, i3);
    STACKTOP = i26;
    return;
   }
   if ((i10 + -3 | 0) >>> 0 < 2) {
    HEAPF64[i11 >> 3] = -4096.0;
    HEAP32[i1 >> 2] = 32088;
    HEAP32[i1 + 4 >> 2] = -1056833530;
    HEAP32[i1 + 8 >> 2] = i11;
    HEAP32[i1 + 12 >> 2] = 1;
    HEAP32[i1 + 16 >> 2] = 1;
    HEAPF64[i13 >> 3] = 4096.0;
    HEAP32[i12 >> 2] = 32088;
    HEAP32[i12 + 4 >> 2] = -1056833530;
    HEAP32[i12 + 8 >> 2] = i13;
    HEAP32[i12 + 12 >> 2] = 1;
    HEAP32[i12 + 16 >> 2] = 1;
    __ZN2cv5randuERKNS_17_InputOutputArrayERKNS_11_InputArrayES5_(i25, i1, i12);
    STACKTOP = i26;
    return;
   } else {
    HEAP32[i22 >> 2] = 0;
    HEAP32[i22 + 4 >> 2] = 0;
    i3 = (__ZN2cv6String8allocateEj(i22, 18) | 0) + 0 | 0;
    i2 = 174120 | 0;
    i1 = i3 + 18 | 0;
    do {
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     i3 = i3 + 1 | 0;
     i2 = i2 + 1 | 0;
    } while ((i3 | 0) < (i1 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-210, i22, 174144, 170184, 1032);
    __ZN2cv6String10deallocateEv(i22);
    STACKTOP = i26;
    return;
   }
  } else {
   HEAPF64[i17 >> 3] = -128.0;
   HEAP32[i16 >> 2] = 32088;
   HEAP32[i16 + 4 >> 2] = -1056833530;
   HEAP32[i16 + 8 >> 2] = i17;
   HEAP32[i16 + 12 >> 2] = 1;
   HEAP32[i16 + 16 >> 2] = 1;
   HEAPF64[i19 >> 3] = 128.0;
   HEAP32[i18 >> 2] = 32088;
   HEAP32[i18 + 4 >> 2] = -1056833530;
   HEAP32[i18 + 8 >> 2] = i19;
   HEAP32[i18 + 12 >> 2] = 1;
   HEAP32[i18 + 16 >> 2] = 1;
   __ZN2cv5randuERKNS_17_InputOutputArrayERKNS_11_InputArrayES5_(i25, i16, i18);
   STACKTOP = i26;
   return;
  }
 }
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i25 >> 2] | 0) + 24 >> 2] & 127](i25) | 0) != 327680 ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i25 >> 2] | 0) + 24 >> 2] & 127](i25) | 0) != 262144 : 0) {
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i25 >> 2] >> 2] & 63](i10, i25, -1);
  __ZN4perf8TestBase11warmup_implEN2cv3MatENS0_10WarmUpTypeE(i10, i24);
  i1 = i10 + 36 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i10);
  HEAP32[i1 >> 2] = 0;
  i22 = i10 + 16 | 0;
  i2 = i10 + 4 | 0;
  HEAP32[i22 + 0 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i10 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i1 = HEAP32[i10 + 44 >> 2] | 0;
  if ((i1 | 0) == (i10 + 48 | 0)) {
   STACKTOP = i26;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i26;
  return;
 }
 i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i25 >> 2] | 0) + 52 >> 2] & 127](i25, -1) | 0;
 if (!i1) {
  STACKTOP = i26;
  return;
 }
 i4 = i23 + 36 | 0;
 i5 = i23 + 16 | 0;
 i6 = i23 + 4 | 0;
 i7 = i23 + 40 | 0;
 i8 = i23 + 44 | 0;
 i9 = i23 + 48 | 0;
 i10 = 0;
 do {
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i25 >> 2] >> 2] & 63](i23, i25, i10);
  __ZN4perf8TestBase11warmup_implEN2cv3MatENS0_10WarmUpTypeE(i23, i24);
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) != 0 ? (i21 = i3 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i23);
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 + 0 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   i3 = HEAP32[i7 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i6 >> 2] | 0));
  }
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i3 | 0) != (i9 | 0)) __ZN2cv8fastFreeEPv(i3);
  i10 = i10 + 1 | 0;
 } while (i10 >>> 0 < i1 >>> 0);
 STACKTOP = i26;
 return;
}

function __ZL18icvXMLWriteCommentP13CvFileStoragePKci(i15, i8, i6) {
 i15 = i15 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i9 = i17;
 i4 = i17 + 16 | 0;
 i3 = i17 + 8 | 0;
 i11 = (i8 | 0) == 0;
 if (i11) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i4, 12) | 0) + 0 | 0;
  i1 = 16768 | 0;
  i5 = i2 + 12 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i4, 17104, 8960, 2586);
  __ZN2cv6String10deallocateEv(i4);
 }
 if (_strstr(i8, 17128) | 0) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i3, 49) | 0) + 0 | 0;
  i1 = 17136 | 0;
  i5 = i2 + 49 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i3, 17104, 8960, 2589);
  __ZN2cv6String10deallocateEv(i3);
 }
 i1 = _strlen(i8 | 0) | 0;
 i7 = _strchr(i8, 10) | 0;
 i10 = (i7 | 0) != 0;
 i16 = i15 + 72 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 if ((i6 | 0) != 0 & (i10 ^ 1) ? ((HEAP32[i15 + 80 >> 2] | 0) - i3 | 0) >= (i1 + 5 | 0) : 0) {
  if (i3 >>> 0 > ((HEAP32[i15 + 76 >> 2] | 0) + (HEAP32[i15 + 40 >> 2] | 0) | 0) >>> 0) {
   HEAP8[i3 >> 0] = 32;
   i3 = i3 + 1 | 0;
  }
 } else {
  i6 = i15 + 76 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i2 = i15 + 56 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (i3 >>> 0 > (i5 + i4 | 0) >>> 0) {
   HEAP8[i3 >> 0] = 10;
   HEAP8[i3 + 1 >> 0] = 0;
   __ZL7icvPutsP13CvFileStoragePKc(i15, HEAP32[i6 >> 2] | 0);
   i5 = HEAP32[i6 >> 2] | 0;
   HEAP32[i16 >> 2] = i5;
   i3 = HEAP32[i2 >> 2] | 0;
  } else i3 = i4;
  i4 = HEAP32[i15 + 40 >> 2] | 0;
  if ((i4 | 0) == (i3 | 0)) i4 = i3; else {
   if ((i4 | 0) > (i3 | 0)) {
    _memset(i5 + i3 | 0, 32, i4 - i3 | 0) | 0;
    i5 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = i4;
  }
  i3 = i5 + i4 | 0;
  HEAP32[i16 >> 2] = i3;
 }
 if (i10) {
  HEAP8[i3 + 0 >> 0] = HEAP8[17208] | 0;
  HEAP8[i3 + 1 >> 0] = HEAP8[17209] | 0;
  HEAP8[i3 + 2 >> 0] = HEAP8[17210] | 0;
  HEAP8[i3 + 3 >> 0] = HEAP8[17211] | 0;
  HEAP8[i3 + 4 >> 0] = HEAP8[17212] | 0;
  i6 = 4;
 } else {
  i5 = i1 + 9 | 0;
  i6 = i15 + 80 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i3 + i5 | 0) >>> 0 >= i4 >>> 0) {
   i1 = i15 + 76 | 0;
   i12 = HEAP32[i1 >> 2] | 0;
   i2 = i3 - i12 | 0;
   i4 = ((i4 - i12 | 0) * 3 | 0) / 2 | 0;
   i5 = i2 + i5 | 0;
   i5 = (i5 | 0) < (i4 | 0) ? i4 : i5;
   i4 = _cvAlloc(i5 + 256 | 0) | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   HEAP32[i16 >> 2] = i4 + ((HEAP32[i16 >> 2] | 0) - i3);
   if ((i2 | 0) > 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i6 >> 2] = i4 + i5;
   i3 = i4 + i2 | 0;
  }
  HEAP32[i9 >> 2] = i8;
  _sprintf(i3, 17192, i9) | 0;
  i6 = _strlen(i3 | 0) | 0;
 }
 i4 = i3 + i6 | 0;
 HEAP32[i16 >> 2] = i4;
 i13 = i15 + 76 | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i14 = i15 + 56 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 if (i4 >>> 0 > (i5 + i2 | 0) >>> 0) {
  HEAP8[i4 >> 0] = 10;
  HEAP8[i3 + (i6 + 1) >> 0] = 0;
  __ZL7icvPutsP13CvFileStoragePKc(i15, HEAP32[i13 >> 2] | 0);
  i5 = HEAP32[i13 >> 2] | 0;
  HEAP32[i16 >> 2] = i5;
  i2 = HEAP32[i14 >> 2] | 0;
 }
 i12 = i15 + 40 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if ((i4 | 0) == (i2 | 0)) i4 = i2; else {
  if ((i4 | 0) > (i2 | 0)) {
   _memset(i5 + i2 | 0, 32, i4 - i2 | 0) | 0;
   i5 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i14 >> 2] = i4;
 }
 i4 = i5 + i4 | 0;
 HEAP32[i16 >> 2] = i4;
 if (!i10) {
  STACKTOP = i17;
  return;
 }
 if (!i11) {
  i9 = i15 + 80 | 0;
  do {
   if (!i7) {
    i6 = _strlen(i8 | 0) | 0;
    i3 = HEAP32[i9 >> 2] | 0;
    if ((i4 + i6 | 0) >>> 0 >= i3 >>> 0) {
     i2 = i4 - i5 | 0;
     i4 = ((i3 - i5 | 0) * 3 | 0) / 2 | 0;
     i5 = i2 + i6 | 0;
     i5 = (i5 | 0) < (i4 | 0) ? i4 : i5;
     i4 = _cvAlloc(i5 + 256 | 0) | 0;
     i3 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i4 + ((HEAP32[i16 >> 2] | 0) - i3);
     if ((i2 | 0) > 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
     HEAP32[i13 >> 2] = i4;
     HEAP32[i9 >> 2] = i4 + i5;
     i4 = i4 + i2 | 0;
    }
    _memcpy(i4 | 0, i8 | 0, i6 | 0) | 0;
    i8 = 0;
    i7 = 0;
    i3 = i4 + i6 | 0;
   } else {
    i1 = i7 - i8 | 0;
    i6 = i1 + 1 | 0;
    i3 = HEAP32[i9 >> 2] | 0;
    if ((i4 + i6 | 0) >>> 0 >= i3 >>> 0) {
     i2 = i4 - i5 | 0;
     i4 = ((i3 - i5 | 0) * 3 | 0) / 2 | 0;
     i5 = i2 + i6 | 0;
     i5 = (i5 | 0) < (i4 | 0) ? i4 : i5;
     i4 = _cvAlloc(i5 + 256 | 0) | 0;
     i3 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i4 + ((HEAP32[i16 >> 2] | 0) - i3);
     if ((i2 | 0) > 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
     HEAP32[i13 >> 2] = i4;
     HEAP32[i9 >> 2] = i4 + i5;
     i4 = i4 + i2 | 0;
    }
    _memcpy(i4 | 0, i8 | 0, i6 | 0) | 0;
    i7 = i7 + 1 | 0;
    i8 = i7;
    i7 = _strchr(i7, 10) | 0;
    i3 = i4 + i1 | 0;
   }
   HEAP32[i16 >> 2] = i3;
   i4 = HEAP32[i13 >> 2] | 0;
   i5 = HEAP32[i14 >> 2] | 0;
   if (i3 >>> 0 > (i4 + i5 | 0) >>> 0) {
    HEAP8[i3 >> 0] = 10;
    HEAP8[i3 + 1 >> 0] = 0;
    __ZL7icvPutsP13CvFileStoragePKc(i15, HEAP32[i13 >> 2] | 0);
    i4 = HEAP32[i13 >> 2] | 0;
    HEAP32[i16 >> 2] = i4;
    i2 = HEAP32[i14 >> 2] | 0;
   } else i2 = i5;
   i3 = HEAP32[i12 >> 2] | 0;
   if ((i3 | 0) == (i2 | 0)) {
    i5 = i4;
    i4 = i2;
   } else {
    if ((i3 | 0) > (i2 | 0)) {
     _memset(i4 + i2 | 0, 32, i3 - i2 | 0) | 0;
     i4 = HEAP32[i13 >> 2] | 0;
    }
    HEAP32[i14 >> 2] = i3;
    i5 = i4;
    i4 = i3;
   }
   i4 = i5 + i4 | 0;
   HEAP32[i16 >> 2] = i4;
  } while ((i8 | 0) != 0);
 }
 HEAP8[i4 >> 0] = 45;
 HEAP8[i4 + 1 >> 0] = 45;
 HEAP8[i4 + 2 >> 0] = 62;
 HEAP8[i4 + 3 >> 0] = 0;
 i1 = i4 + 3 | 0;
 HEAP32[i16 >> 2] = i1;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 if (i1 >>> 0 > (i2 + i3 | 0) >>> 0) {
  HEAP8[i1 >> 0] = 10;
  HEAP8[i4 + 4 >> 0] = 0;
  __ZL7icvPutsP13CvFileStoragePKc(i15, HEAP32[i13 >> 2] | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  HEAP32[i16 >> 2] = i2;
  i3 = HEAP32[i14 >> 2] | 0;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) i1 = i3; else {
  if ((i1 | 0) > (i3 | 0)) {
   _memset(i2 + i3 | 0, 32, i1 - i3 | 0) | 0;
   i2 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i14 >> 2] = i1;
 }
 HEAP32[i16 >> 2] = i2 + i1;
 STACKTOP = i17;
 return;
}

function __ZN2cvL15transpose_32sC2EPKhjPhjNS_5Size_IiEE(i16, i17, i14, i15, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i18 = STACKTOP;
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i13 + -4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i8 = i12 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i12 & -4;
  i11 = 0;
  do {
   i5 = i14 + (Math_imul(i11, i15) | 0) | 0;
   i4 = i14 + (Math_imul(i11 | 1, i15) | 0) | 0;
   i3 = i14 + (Math_imul(i11 | 2, i15) | 0) | 0;
   i2 = i14 + (Math_imul(i11 | 3, i15) | 0) | 0;
   if (i9) i7 = 0; else {
    i7 = i11 << 3;
    i6 = 0;
    do {
     i27 = (Math_imul(i6, i17) | 0) + i7 | 0;
     i22 = i6 | 1;
     i25 = (Math_imul(i22, i17) | 0) + i7 | 0;
     i20 = i6 | 2;
     i23 = (Math_imul(i20, i17) | 0) + i7 | 0;
     i19 = i6 | 3;
     i21 = (Math_imul(i19, i17) | 0) + i7 | 0;
     i26 = i16 + i27 | 0;
     i24 = HEAP32[i26 + 4 >> 2] | 0;
     i28 = i5 + (i6 << 3) | 0;
     HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i28 + 4 >> 2] = i24;
     i28 = i16 + i25 | 0;
     i24 = HEAP32[i28 + 4 >> 2] | 0;
     i26 = i5 + (i22 << 3) | 0;
     HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i26 + 4 >> 2] = i24;
     i26 = i16 + i23 | 0;
     i24 = HEAP32[i26 + 4 >> 2] | 0;
     i28 = i5 + (i20 << 3) | 0;
     HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i28 + 4 >> 2] = i24;
     i28 = i16 + i21 | 0;
     i24 = HEAP32[i28 + 4 >> 2] | 0;
     i26 = i5 + (i19 << 3) | 0;
     HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i26 + 4 >> 2] = i24;
     i26 = i16 + (i27 + 8) | 0;
     i24 = HEAP32[i26 + 4 >> 2] | 0;
     i28 = i4 + (i6 << 3) | 0;
     HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i28 + 4 >> 2] = i24;
     i28 = i16 + (i25 + 8) | 0;
     i24 = HEAP32[i28 + 4 >> 2] | 0;
     i26 = i4 + (i22 << 3) | 0;
     HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i26 + 4 >> 2] = i24;
     i26 = i16 + (i23 + 8) | 0;
     i24 = HEAP32[i26 + 4 >> 2] | 0;
     i28 = i4 + (i20 << 3) | 0;
     HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i28 + 4 >> 2] = i24;
     i28 = i16 + (i21 + 8) | 0;
     i24 = HEAP32[i28 + 4 >> 2] | 0;
     i26 = i4 + (i19 << 3) | 0;
     HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i26 + 4 >> 2] = i24;
     i26 = i16 + (i27 + 16) | 0;
     i24 = HEAP32[i26 + 4 >> 2] | 0;
     i28 = i3 + (i6 << 3) | 0;
     HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i28 + 4 >> 2] = i24;
     i28 = i16 + (i25 + 16) | 0;
     i24 = HEAP32[i28 + 4 >> 2] | 0;
     i26 = i3 + (i22 << 3) | 0;
     HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i26 + 4 >> 2] = i24;
     i26 = i16 + (i23 + 16) | 0;
     i24 = HEAP32[i26 + 4 >> 2] | 0;
     i28 = i3 + (i20 << 3) | 0;
     HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i28 + 4 >> 2] = i24;
     i28 = i16 + (i21 + 16) | 0;
     i24 = HEAP32[i28 + 4 >> 2] | 0;
     i26 = i3 + (i19 << 3) | 0;
     HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i26 + 4 >> 2] = i24;
     i27 = i16 + (i27 + 24) | 0;
     i26 = HEAP32[i27 + 4 >> 2] | 0;
     i24 = i2 + (i6 << 3) | 0;
     HEAP32[i24 >> 2] = HEAP32[i27 >> 2];
     HEAP32[i24 + 4 >> 2] = i26;
     i25 = i16 + (i25 + 24) | 0;
     i24 = HEAP32[i25 + 4 >> 2] | 0;
     i22 = i2 + (i22 << 3) | 0;
     HEAP32[i22 >> 2] = HEAP32[i25 >> 2];
     HEAP32[i22 + 4 >> 2] = i24;
     i23 = i16 + (i23 + 24) | 0;
     i22 = HEAP32[i23 + 4 >> 2] | 0;
     i20 = i2 + (i20 << 3) | 0;
     HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i20 + 4 >> 2] = i22;
     i21 = i16 + (i21 + 24) | 0;
     i20 = HEAP32[i21 + 4 >> 2] | 0;
     i19 = i2 + (i19 << 3) | 0;
     HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i19 + 4 >> 2] = i20;
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i8 | 0));
    i7 = i10;
   }
   if ((i7 | 0) < (i12 | 0)) {
    i6 = i11 << 3;
    do {
     i20 = (Math_imul(i7, i17) | 0) + i6 | 0;
     i19 = i16 + i20 | 0;
     i22 = HEAP32[i19 + 4 >> 2] | 0;
     i21 = i5 + (i7 << 3) | 0;
     HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i21 + 4 >> 2] = i22;
     i21 = i16 + (i20 + 8) | 0;
     i22 = HEAP32[i21 + 4 >> 2] | 0;
     i19 = i4 + (i7 << 3) | 0;
     HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i19 + 4 >> 2] = i22;
     i19 = i16 + (i20 + 16) | 0;
     i22 = HEAP32[i19 + 4 >> 2] | 0;
     i21 = i3 + (i7 << 3) | 0;
     HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i21 + 4 >> 2] = i22;
     i20 = i16 + (i20 + 24) | 0;
     i21 = HEAP32[i20 + 4 >> 2] | 0;
     i22 = i2 + (i7 << 3) | 0;
     HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i22 + 4 >> 2] = i21;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i12 | 0));
   }
   i11 = i11 + 4 | 0;
  } while ((i11 | 0) <= (i1 | 0));
  i1 = i13 & -4;
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i18;
  return;
 }
 i5 = i12 + -4 | 0;
 i6 = (i5 | 0) < 0;
 i7 = i12 & -4;
 do {
  i4 = i14 + (Math_imul(i1, i15) | 0) | 0;
  if (i6) i2 = 0; else {
   i2 = i1 << 3;
   i3 = 0;
   do {
    i19 = i3 | 1;
    i9 = i16 + ((Math_imul(i19, i17) | 0) + i2) | 0;
    i21 = i3 | 2;
    i11 = i16 + ((Math_imul(i21, i17) | 0) + i2) | 0;
    i22 = i3 | 3;
    i20 = i16 + ((Math_imul(i22, i17) | 0) + i2) | 0;
    i23 = i16 + ((Math_imul(i3, i17) | 0) + i2) | 0;
    i10 = HEAP32[i23 + 4 >> 2] | 0;
    i8 = i4 + (i3 << 3) | 0;
    HEAP32[i8 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i8 + 4 >> 2] = i10;
    i8 = HEAP32[i9 + 4 >> 2] | 0;
    i19 = i4 + (i19 << 3) | 0;
    HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i19 + 4 >> 2] = i8;
    i19 = HEAP32[i11 + 4 >> 2] | 0;
    i21 = i4 + (i21 << 3) | 0;
    HEAP32[i21 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i21 + 4 >> 2] = i19;
    i21 = HEAP32[i20 + 4 >> 2] | 0;
    i22 = i4 + (i22 << 3) | 0;
    HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i22 + 4 >> 2] = i21;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i5 | 0));
   i2 = i7;
  }
  if ((i2 | 0) < (i12 | 0)) {
   i3 = i1 << 3;
   do {
    i20 = i16 + ((Math_imul(i2, i17) | 0) + i3) | 0;
    i21 = HEAP32[i20 + 4 >> 2] | 0;
    i22 = i4 + (i2 << 3) | 0;
    HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i22 + 4 >> 2] = i21;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i12 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i18;
 return;
}

function __Z19RGBE_ReadPixels_RLEP8_IO_FILEPfii(i23, i3, i24, i4) {
 i23 = i23 | 0;
 i3 = i3 | 0;
 i24 = i24 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0, f26 = Math_fround(0);
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i20 = i25;
 i17 = i25 + 12 | 0;
 i16 = i25 + 8 | 0;
 if ((i24 + -8 | 0) >>> 0 > 32759) {
  i22 = __Z15RGBE_ReadPixelsP8_IO_FILEPfi(i23, i3, Math_imul(i4, i24) | 0) | 0;
  STACKTOP = i25;
  return i22 | 0;
 }
 L5 : do if ((i4 | 0) > 0) {
  i21 = i17 + 1 | 0;
  i22 = i17 + 2 | 0;
  i19 = i17 + 3 | 0;
  i12 = i24 << 2;
  i13 = i16 + 1 | 0;
  i14 = (i24 | 0) > 0;
  i15 = i24 << 1;
  i11 = i24 * 3 | 0;
  i18 = i4;
  i10 = i3;
  i1 = 0;
  L7 : while (1) {
   if (!(_fread(i17 | 0, 4, 1, i23 | 0) | 0)) {
    i4 = 6;
    break;
   }
   i5 = HEAP8[i17 >> 0] | 0;
   if (!(i5 << 24 >> 24 == 2 & (HEAP8[i21 >> 0] | 0) == 2)) {
    i4 = 9;
    break;
   }
   i4 = HEAPU8[i22 >> 0] | 0;
   if (i4 & 128) {
    i4 = 9;
    break;
   }
   if ((HEAPU8[i19 >> 0] | i4 << 8 | 0) != (i24 | 0)) {
    i4 = 14;
    break;
   }
   if (!i1) {
    i1 = _malloc(i12) | 0;
    if (!i1) {
     i4 = 18;
     break;
    }
   }
   i9 = 0;
   i4 = i1;
   do {
    i9 = i9 + 1 | 0;
    i2 = i1 + (Math_imul(i9, i24) | 0) | 0;
    if (i4 >>> 0 < i2 >>> 0) {
     i8 = i2;
     i3 = i4;
     while (1) {
      if (!(_fread(i16 | 0, 2, 1, i23 | 0) | 0)) {
       i4 = 24;
       break L7;
      }
      i5 = HEAP8[i16 >> 0] | 0;
      i6 = i5 & 255;
      if ((i5 & 255) > 128) {
       i5 = i6 + -128 | 0;
       if (!i5) {
        i4 = 29;
        break L7;
       }
       if ((i5 | 0) > (i8 - i3 | 0)) {
        i4 = 29;
        break L7;
       }
       if ((i5 | 0) > 0) {
        i7 = i3;
        while (1) {
         i5 = i5 + -1 | 0;
         HEAP8[i7 >> 0] = HEAP8[i13 >> 0] | 0;
         if ((i5 | 0) <= 0) break; else i7 = i7 + 1 | 0;
        }
        i4 = i3 + (i6 + -128) | 0;
       } else i4 = i3;
      } else {
       if (!(i5 << 24 >> 24)) {
        i4 = 33;
        break L7;
       }
       if ((i6 | 0) > (i8 - i3 | 0)) {
        i4 = 33;
        break L7;
       }
       i4 = i3 + 1 | 0;
       HEAP8[i3 >> 0] = HEAP8[i13 >> 0] | 0;
       i7 = i6 + -1 | 0;
       if ((i7 | 0) > 0) {
        if (!(_fread(i4 | 0, i7 | 0, 1, i23 | 0) | 0)) {
         i4 = 37;
         break L7;
        }
        i4 = i3 + i6 | 0;
       }
      }
      if (i4 >>> 0 < i2 >>> 0) i3 = i4; else break;
     }
    }
   } while ((i9 | 0) < 4);
   if (i14) {
    i4 = i10;
    i7 = 0;
    while (1) {
     i6 = HEAP8[i1 + i7 >> 0] | 0;
     HEAP8[i17 >> 0] = i6;
     HEAP8[i21 >> 0] = HEAP8[i1 + (i7 + i24) >> 0] | 0;
     HEAP8[i22 >> 0] = HEAP8[i1 + (i7 + i15) >> 0] | 0;
     i3 = HEAP8[i1 + (i7 + i11) >> 0] | 0;
     HEAP8[i19 >> 0] = i3;
     i2 = i4 + 8 | 0;
     i5 = i4 + 4 | 0;
     if (!(i3 << 24 >> 24)) {
      HEAPF32[i4 >> 2] = Math_fround(0.0);
      HEAPF32[i5 >> 2] = Math_fround(0.0);
      HEAPF32[i2 >> 2] = Math_fround(0.0);
     } else {
      f26 = Math_fround(+_ldexp(1.0, (i3 & 255) + -136 | 0));
      HEAPF32[i2 >> 2] = Math_fround(f26 * Math_fround(i6 & 255 | 0));
      HEAPF32[i5 >> 2] = Math_fround(f26 * Math_fround(HEAPU8[i21 >> 0] | 0));
      HEAPF32[i4 >> 2] = Math_fround(f26 * Math_fround(HEAPU8[i22 >> 0] | 0));
     }
     i7 = i7 + 1 | 0;
     if ((i7 | 0) == (i24 | 0)) break; else i4 = i4 + 12 | 0;
    }
    i3 = i10 + (i11 << 2) | 0;
   } else i3 = i10;
   i4 = i18 + -1 | 0;
   if ((i4 | 0) > 0) {
    i18 = i4;
    i10 = i3;
   } else break L5;
  }
  if ((i4 | 0) == 6) {
   _free(i1);
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i20, 15) | 0) + 0 | 0;
   i2 = 181688;
   i3 = i1 + 15 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i20, 181704, 181720, 90);
   __ZN2cv6String10deallocateEv(i20);
   i22 = -1;
   STACKTOP = i25;
   return i22 | 0;
  } else if ((i4 | 0) == 9) {
   i2 = i10 + 8 | 0;
   i4 = i10 + 4 | 0;
   i3 = HEAP8[i19 >> 0] | 0;
   if (!(i3 << 24 >> 24)) {
    HEAPF32[i10 >> 2] = Math_fround(0.0);
    HEAPF32[i4 >> 2] = Math_fround(0.0);
    HEAPF32[i2 >> 2] = Math_fround(0.0);
   } else {
    f26 = Math_fround(+_ldexp(1.0, (i3 & 255) + -136 | 0));
    HEAPF32[i2 >> 2] = Math_fround(f26 * Math_fround(i5 & 255 | 0));
    HEAPF32[i4 >> 2] = Math_fround(f26 * Math_fround(HEAPU8[i21 >> 0] | 0));
    HEAPF32[i10 >> 2] = Math_fround(f26 * Math_fround(HEAPU8[i22 >> 0] | 0));
   }
   _free(i1);
   i22 = __Z15RGBE_ReadPixelsP8_IO_FILEPfi(i23, i10 + 12 | 0, (Math_imul(i18, i24) | 0) + -1 | 0) | 0;
   STACKTOP = i25;
   return i22 | 0;
  } else if ((i4 | 0) == 14) {
   _free(i1);
   __ZL10rgbe_erroriPKc(2, 181608);
   i22 = -1;
   STACKTOP = i25;
   return i22 | 0;
  } else if ((i4 | 0) == 18) {
   __ZL10rgbe_erroriPKc(3, 181632);
   i22 = -1;
   STACKTOP = i25;
   return i22 | 0;
  } else if ((i4 | 0) == 24) {
   _free(i1);
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i20, 15) | 0) + 0 | 0;
   i2 = 181688;
   i3 = i1 + 15 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i20, 181704, 181720, 90);
   __ZN2cv6String10deallocateEv(i20);
   i22 = -1;
   STACKTOP = i25;
   return i22 | 0;
  } else if ((i4 | 0) == 29) {
   _free(i1);
   __ZL10rgbe_erroriPKc(2, 181664);
   i22 = -1;
   STACKTOP = i25;
   return i22 | 0;
  } else if ((i4 | 0) == 33) {
   _free(i1);
   __ZL10rgbe_erroriPKc(2, 181664);
   i22 = -1;
   STACKTOP = i25;
   return i22 | 0;
  } else if ((i4 | 0) == 37) {
   _free(i1);
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i20, 15) | 0) + 0 | 0;
   i2 = 181688;
   i3 = i1 + 15 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i20, 181704, 181720, 90);
   __ZN2cv6String10deallocateEv(i20);
   i22 = -1;
   STACKTOP = i25;
   return i22 | 0;
  }
 } else i1 = 0; while (0);
 _free(i1);
 i22 = 0;
 STACKTOP = i25;
 return i22 | 0;
}

function __ZN7testing8internal28ParseGoogleTestFlagsOnlyImplIcEEvPiPPT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i11;
 if ((HEAP32[i9 >> 2] | 0) > 1) {
  i6 = i8 + 1 | 0;
  i7 = i8 + 8 | 0;
  i5 = 1;
  do {
   __ZN7testing8internal18StreamableToStringIPcEENSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEERKT_(i8, i10 + (i5 << 2) | 0);
   i3 = (HEAP8[i8 >> 0] & 1) == 0 ? i6 : HEAP32[i7 >> 2] | 0;
   i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 159760, 1) | 0;
   L5 : do if (!i1) {
    i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 159792, 1) | 0;
    if (i1) {
     i1 = HEAP8[i1 >> 0] | 0;
     if (i1 << 24 >> 24 == 102 | i1 << 24 >> 24 == 48) i1 = 0; else i1 = i1 << 24 >> 24 != 70 & 1;
     HEAP8[159784] = i1;
     i4 = 52;
     break;
    }
    i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 159824, 1) | 0;
    if (i1) {
     i1 = HEAP8[i1 >> 0] | 0;
     if (i1 << 24 >> 24 == 102 | i1 << 24 >> 24 == 48) i1 = 0; else i1 = i1 << 24 >> 24 != 70 & 1;
     HEAP8[159816] = i1;
     i4 = 52;
     break;
    }
    i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 159864, 0) | 0;
    if (i1) {
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(159848, i1) | 0;
     i4 = 52;
     break;
    }
    i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 164608, 0) | 0;
    if (i1) {
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(164592, i1) | 0;
     i4 = 52;
     break;
    }
    i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 164648, 1) | 0;
    if (i1) {
     i1 = HEAP8[i1 >> 0] | 0;
     if (i1 << 24 >> 24 == 102 | i1 << 24 >> 24 == 48) i1 = 0; else i1 = i1 << 24 >> 24 != 70 & 1;
     HEAP8[164640] = i1;
     i4 = 52;
     break;
    }
    i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 159896, 0) | 0;
    if (i1) {
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(159880, i1) | 0;
     i4 = 52;
     break;
    }
    i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 159920, 0) | 0;
    if (i1) {
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(159904, i1) | 0;
     i4 = 52;
     break;
    }
    i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 165848, 0) | 0;
    if (i1) {
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(163824, i1) | 0;
     i4 = 52;
     break;
    }
    i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 165872, 1) | 0;
    if (i1) {
     i1 = HEAP8[i1 >> 0] | 0;
     if (i1 << 24 >> 24 == 102 | i1 << 24 >> 24 == 48) i1 = 0; else i1 = i1 << 24 >> 24 != 70 & 1;
     HEAP8[159936] = i1;
     i4 = 52;
     break;
    }
    i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 159960, 0) | 0;
    if (i1) {
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(159944, i1) | 0;
     i4 = 52;
     break;
    }
    i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 159984, 1) | 0;
    if (i1) {
     i1 = HEAP8[i1 >> 0] | 0;
     if (i1 << 24 >> 24 == 102 | i1 << 24 >> 24 == 48) i1 = 0; else i1 = i1 << 24 >> 24 != 70 & 1;
     HEAP8[159976] = i1;
     i4 = 52;
     break;
    }
    if (!(__ZN7testing8internal14ParseInt32FlagEPKcS2_Pi(i3, 160008, 16e4) | 0) ? !(__ZN7testing8internal14ParseInt32FlagEPKcS2_Pi(i3, 160032, 160024) | 0) : 0) {
     i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 160048, 1) | 0;
     if (i1) {
      i1 = HEAP8[i1 >> 0] | 0;
      if (i1 << 24 >> 24 == 102 | i1 << 24 >> 24 == 48) i1 = 0; else i1 = i1 << 24 >> 24 != 70 & 1;
      HEAP8[160040] = i1;
      i4 = 52;
      break;
     }
     if (!(__ZN7testing8internal14ParseInt32FlagEPKcS2_Pi(i3, 160064, 160056) | 0)) {
      i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 160104, 0) | 0;
      if (i1) {
       __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(160088, i1) | 0;
       i4 = 52;
       break;
      }
      i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i3, 160136, 1) | 0;
      if (i1) {
       i1 = HEAP8[i1 >> 0] | 0;
       if (i1 << 24 >> 24 == 102 | i1 << 24 >> 24 == 48) i1 = 0; else i1 = i1 << 24 >> 24 != 70 & 1;
       HEAP8[160128] = i1;
       i4 = 52;
       break;
      }
      do if (__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i8, 165888) | 0) {
       if (!(__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i8, 165896) | 0)) break;
       if (!(__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i8, 165904) | 0)) break;
       if (!(__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i8, 165912) | 0)) break;
       do if (_strncmp(i3, 168440, 2) | 0) {
        i2 = HEAP8[i3 >> 0] | 0;
        if (i2 << 24 >> 24 == 47) {
         i1 = i3 + 1 | 0;
         break;
        } else if (i2 << 24 >> 24 == 45) {
         i1 = i3 + 1 | 0;
         break;
        } else {
         i1 = i5;
         break L5;
        }
       } else i1 = i3 + 2 | 0; while (0);
       if (!(_strncmp(i1, 168448, 15) | 0)) {
        i1 = i5;
        break L5;
       }
       if (!(_strncmp(i1, 168464, 6) | 0)) break;
       if (_strncmp(i1, 168472, 6) | 0) {
        i1 = i5;
        break L5;
       }
      } while (0);
      HEAP8[159744] = 1;
      i1 = i5;
     } else i4 = 52;
    } else i4 = 52;
   } else {
    i1 = HEAP8[i1 >> 0] | 0;
    if (i1 << 24 >> 24 == 102 | i1 << 24 >> 24 == 48) i1 = 0; else i1 = i1 << 24 >> 24 != 70 & 1;
    HEAP8[159752] = i1;
    i4 = 52;
   } while (0);
   if ((i4 | 0) == 52) {
    i4 = 0;
    i1 = HEAP32[i9 >> 2] | 0;
    if ((i5 | 0) == (i1 | 0)) i1 = i5; else {
     i2 = i5;
     do {
      i3 = i2;
      i2 = i2 + 1 | 0;
      HEAP32[i10 + (i3 << 2) >> 2] = HEAP32[i10 + (i2 << 2) >> 2];
     } while ((i2 | 0) != (i1 | 0));
    }
    HEAP32[i9 >> 2] = i1 + -1;
    i1 = i5 + -1 | 0;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
   i5 = i1 + 1 | 0;
  } while ((i5 | 0) < (HEAP32[i9 >> 2] | 0));
 }
 if (!(HEAP8[159744] | 0)) {
  STACKTOP = i11;
  return;
 }
 __ZN7testing8internalL17PrintColorEncodedEPKc();
 STACKTOP = i11;
 return;
}

function __ZN2cv4UMatC2ERKS0_RKNS_5RangeES5_(i23, i22, i14, i21) {
 i23 = i23 | 0;
 i22 = i22 | 0;
 i14 = i14 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 1168 | 0;
 i2 = i24 + 1160 | 0;
 i20 = i24 + 64 | 0;
 i15 = i24 + 16 | 0;
 i1 = i24 + 8 | 0;
 i8 = i24;
 HEAP32[i23 >> 2] = 1124007936;
 i9 = i23 + 4 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 12 | 0;
 i18 = i23 + 24 | 0;
 i13 = i23 + 28 | 0;
 i19 = i23 + 32 | 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i19 >> 2] = i16;
 i7 = i23 + 40 | 0;
 i10 = i23 + 36 | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i23 + 44 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i11 = i22 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if ((i3 | 0) > 1) i6 = i3; else {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i2, 11) | 0) + 0 | 0;
  i4 = 17784 | 0;
  i3 = i5 + 11 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i5 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 17800, 17672, 312);
  __ZN2cv6String10deallocateEv(i2);
  i6 = HEAP32[i11 >> 2] | 0;
 }
 if ((i6 | 0) > 2) {
  i5 = i20 + 8 | 0;
  i2 = i20 + 1096 | 0;
  i1 = i5;
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i2 | 0));
  HEAP32[i20 >> 2] = i5;
  i4 = i20 + 4 | 0;
  HEAP32[i4 >> 2] = 136;
  if (i6 >>> 0 > 136) {
   i2 = __Znaj(i6 >>> 0 > 536870911 ? -1 : i6 << 3) | 0;
   i1 = i2 + (i6 << 3) | 0;
   i3 = i2;
   do {
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    i3 = i3 + 8 | 0;
   } while ((i3 | 0) != (i1 | 0));
   HEAP32[i20 >> 2] = i2;
  } else i2 = i5;
  HEAP32[i4 >> 2] = i6;
  i18 = i14;
  i1 = HEAP32[i18 + 4 >> 2] | 0;
  i19 = i2;
  HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i19 + 4 >> 2] = i1;
  i19 = i21;
  i21 = HEAP32[i19 + 4 >> 2] | 0;
  i1 = i2 + 8 | 0;
  HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i1 + 4 >> 2] = i21;
  i1 = 2;
  do {
   i21 = i2 + (i1 << 3) | 0;
   HEAP32[i21 >> 2] = -2147483648;
   HEAP32[i21 + 4 >> 2] = 2147483647;
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i20 >> 2] | 0;
  } while ((i1 | 0) < (HEAP32[i11 >> 2] | 0));
  __ZN2cv4UMatC2ERKS0_PKNS_5RangeE(i15, i22, i2);
  __ZN2cv4UMataSERKS0_(i23, i15) | 0;
  i1 = i15 + 24 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i21 = i2 + 8 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) {
   i22 = HEAP32[i1 >> 2] | 0;
   i21 = HEAP32[i22 + 4 >> 2] | 0;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] & 127](i21, i22);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[HEAP32[i15 + 32 >> 2] >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[i15 + 36 >> 2] | 0;
  if ((i1 | 0) != (i15 + 40 | 0)) __ZN2cv8fastFreeEPv(i1);
  i1 = HEAP32[i20 >> 2] | 0;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i24;
   return;
  }
  if (i1) __ZdaPv(i1);
  HEAP32[i20 >> 2] = i5;
  HEAP32[i4 >> 2] = 136;
  STACKTOP = i24;
  return;
 }
 __ZN2cv4UMataSERKS0_(i23, i22) | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 | 0) == -2147483648) {
  if ((HEAP32[i14 + 4 >> 2] | 0) != 2147483647) i12 = 27;
 } else if (!i2) {
  if ((HEAP32[i14 + 4 >> 2] | 0) != (HEAP32[i16 >> 2] | 0)) i12 = 25;
 } else if ((i2 | 0) > -1) i12 = 25; else i12 = 27;
 if ((i12 | 0) == 25) {
  i3 = HEAP32[i14 + 4 >> 2] | 0;
  if ((i2 | 0) <= (i3 | 0) ? (i3 | 0) <= (HEAP32[i22 + 8 >> 2] | 0) : 0) i12 = 28; else i12 = 27;
 }
 if ((i12 | 0) == 27) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i1, 83) | 0) + 0 | 0;
  i4 = 17808 | 0;
  i3 = i5 + 83 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i5 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 17800, 17672, 327);
  __ZN2cv6String10deallocateEv(i1);
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i14 + 4 >> 2] | 0;
  i12 = 28;
 }
 if ((i12 | 0) == 28) {
  HEAP32[i16 >> 2] = i3 - i2;
  i20 = Math_imul(i2, HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i20;
  HEAP32[i23 >> 2] = HEAP32[i23 >> 2] | 32768;
 }
 i3 = HEAP32[i21 >> 2] | 0;
 if ((i3 | 0) == -2147483648) {
  if ((HEAP32[i21 + 4 >> 2] | 0) != 2147483647) i12 = 35;
 } else if (!i3) {
  if ((HEAP32[i21 + 4 >> 2] | 0) != (HEAP32[i17 >> 2] | 0)) i12 = 33;
 } else if ((i3 | 0) > -1) i12 = 33; else i12 = 35;
 if ((i12 | 0) == 33) {
  i2 = HEAP32[i21 + 4 >> 2] | 0;
  if ((i3 | 0) <= (i2 | 0) ? (i2 | 0) <= (HEAP32[i22 + 12 >> 2] | 0) : 0) i12 = 36; else i12 = 35;
 }
 if ((i12 | 0) == 35) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i8, 83) | 0) + 0 | 0;
  i4 = 17896 | 0;
  i3 = i5 + 83 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i5 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 17800, 17672, 335);
  __ZN2cv6String10deallocateEv(i8);
  i3 = HEAP32[i21 >> 2] | 0;
  i2 = HEAP32[i21 + 4 >> 2] | 0;
  i12 = 36;
 }
 if ((i12 | 0) == 36) {
  i1 = i2 - i3 | 0;
  HEAP32[i17 >> 2] = i1;
  i2 = HEAP32[i9 >> 2] | 0;
  if ((i2 | 0) > 0) i2 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 + -1 << 2) >> 2] | 0; else i2 = 0;
  i21 = Math_imul(i2, i3) | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i21;
  HEAP32[i23 >> 2] = ((i1 | 0) < (HEAP32[i22 + 12 >> 2] | 0) ? -49153 : -32769) & HEAP32[i23 >> 2] | 32768;
 }
 i2 = HEAP32[i16 >> 2] | 0;
 if ((i2 | 0) != 1) {
  if ((i2 | 0) >= 1) i12 = 42;
 } else {
  HEAP32[i23 >> 2] = HEAP32[i23 >> 2] | 16384;
  i12 = 42;
 }
 if ((i12 | 0) == 42 ? (HEAP32[i17 >> 2] | 0) >= 1 : 0) {
  STACKTOP = i24;
  return;
 }
 i1 = HEAP32[i18 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i21 = i1 + 8 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) {
  i22 = HEAP32[i18 >> 2] | 0;
  i21 = HEAP32[i22 + 4 >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] & 127](i21, i22);
  HEAP32[i18 >> 2] = 0;
 }
 HEAP32[HEAP32[i19 >> 2] >> 2] = 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i24;
 return;
}

function __ZN2cv9minMaxIdxERKNS_11_InputArrayEPdS3_PiS4_S2_(i3, i22, i21, i25, i26, i4) {
 i3 = i3 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i5 = i29 + 216 | 0;
 i28 = i29 + 160 | 0;
 i27 = i29 + 104 | 0;
 i7 = i29 + 96 | 0;
 i2 = i29 + 80 | 0;
 i13 = i29 + 72 | 0;
 i11 = i29 + 40 | 0;
 i12 = i29 + 36 | 0;
 i24 = i29 + 32 | 0;
 i18 = i29 + 28 | 0;
 i17 = i29 + 24 | 0;
 i16 = i29 + 20 | 0;
 i15 = i29 + 16 | 0;
 i20 = i29 + 8 | 0;
 i19 = i29;
 i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] & 127](i3, -1) | 0;
 i14 = i1 & 7;
 i1 = i1 >>> 3 & 511;
 i6 = i1 + 1 | 0;
 if (!i1) {
  if (!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 76 >> 2] & 127](i4) | 0) ? (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] & 127](i4, -1) | 0) != 0 : 0) i23 = 4;
 } else i23 = 4;
 do if ((i23 | 0) == 4) {
  if (i6 >>> 0 > 1 ? !((i25 | 0) != 0 | (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 76 >> 2] & 127](i4) | 0) ^ 1 | (i26 | 0) != 0) : 0) break;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i5, 104) | 0) + 0 | 0;
  i8 = 27256 | 0;
  i9 = i1 + 104 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i8 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i1 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 27368, 27160, 1913);
  __ZN2cv6String10deallocateEv(i5);
 } while (0);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i3 >> 2] >> 2] & 63](i28, i3, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i4 >> 2] >> 2] & 63](i27, i4, -1);
 i10 = HEAP32[27384 + (i14 << 2) >> 2] | 0;
 if ((i14 | 0) == 7) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i7, 9) | 0) + 0 | 0;
  i8 = 27240 | 0;
  i9 = i1 + 9 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i8 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i1 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 27368, 27160, 2013);
  __ZN2cv6String10deallocateEv(i7);
 }
 HEAP32[i2 >> 2] = i28;
 HEAP32[i2 + 4 >> 2] = i27;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i11, i2, i13, -1);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i18 >> 2] = 2147483647;
 HEAP32[i17 >> 2] = -2147483648;
 HEAPF32[i16 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i15 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF64[i20 >> 3] = 1797693134862315708145274.0e284;
 HEAPF64[i19 >> 3] = -1797693134862315708145274.0e284;
 i5 = Math_imul(HEAP32[i11 + 20 >> 2] | 0, i6) | 0;
 i9 = (i14 | 0) == 5;
 if (!i9) if ((i14 | 0) == 6) {
  i1 = i19;
  i6 = i20;
 } else {
  i1 = i17;
  i6 = i18;
 } else {
  i1 = i15;
  i6 = i16;
 }
 i4 = i11 + 16 | 0;
 do if (HEAP32[i4 >> 2] | 0) {
  i3 = i13 + 4 | 0;
  i2 = 0;
  i7 = 1;
  while (1) {
   FUNCTION_TABLE_viiiiiiii[i10 & 255](HEAP32[i13 >> 2] | 0, HEAP32[i3 >> 2] | 0, i6, i1, i12, i24, i5, i7);
   __ZN2cv15NAryMatIteratorppEv(i11) | 0;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) break; else i7 = i7 + i5 | 0;
  }
  i5 = HEAP32[i12 >> 2] | 0;
  i4 = (i5 | 0) == 0;
  if (!i4) {
   if (i9) {
    HEAPF64[i20 >> 3] = +Math_fround(HEAPF32[i16 >> 2]);
    HEAPF64[i19 >> 3] = +Math_fround(HEAPF32[i15 >> 2]);
    i4 = 0;
    break;
   }
   if (i14 >>> 0 < 5) {
    HEAPF64[i20 >> 3] = +(HEAP32[i18 >> 2] | 0);
    HEAPF64[i19 >> 3] = +(HEAP32[i17 >> 2] | 0);
   }
  } else i23 = 17;
 } else i23 = 17; while (0);
 if ((i23 | 0) == 17) {
  HEAPF64[i19 >> 3] = 0.0;
  HEAPF64[i20 >> 3] = 0.0;
  i4 = 1;
  i5 = 0;
 }
 if (i22) HEAPF64[i22 >> 3] = +HEAPF64[i20 >> 3];
 if (i21) HEAPF64[i21 >> 3] = +HEAPF64[i19 >> 3];
 L37 : do if (i25) {
  i3 = HEAP32[i28 + 4 >> 2] | 0;
  i2 = (i3 | 0) > 0;
  if (i4) {
   if (!i2) break;
   while (1) {
    i3 = i3 + -1 | 0;
    HEAP32[i25 + (i3 << 2) >> 2] = -1;
    if ((i3 | 0) <= 0) break L37;
   }
  }
  if (i2) {
   i1 = HEAP32[i28 + 40 >> 2] | 0;
   i4 = i5 + -1 | 0;
   while (1) {
    i3 = i3 + -1 | 0;
    i2 = HEAP32[i1 + (i3 << 2) >> 2] | 0;
    HEAP32[i25 + (i3 << 2) >> 2] = (i4 >>> 0) % (i2 >>> 0) | 0;
    if ((i3 | 0) <= 0) break; else i4 = (i4 >>> 0) / (i2 >>> 0) | 0;
   }
  }
 } while (0);
 L48 : do if (i26) {
  i1 = HEAP32[i24 >> 2] | 0;
  i3 = HEAP32[i28 + 4 >> 2] | 0;
  i2 = (i3 | 0) > 0;
  if (!i1) {
   if (!i2) break;
   while (1) {
    i3 = i3 + -1 | 0;
    HEAP32[i26 + (i3 << 2) >> 2] = -1;
    if ((i3 | 0) <= 0) break L48;
   }
  }
  if (i2) {
   i4 = HEAP32[i28 + 40 >> 2] | 0;
   i1 = i1 + -1 | 0;
   while (1) {
    i3 = i3 + -1 | 0;
    i2 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
    HEAP32[i26 + (i3 << 2) >> 2] = (i1 >>> 0) % (i2 >>> 0) | 0;
    if ((i3 | 0) <= 0) break; else i1 = (i1 >>> 0) / (i2 >>> 0) | 0;
   }
  }
 } while (0);
 i2 = i27 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i21 = i1 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i27);
 HEAP32[i2 >> 2] = 0;
 i22 = i27 + 16 | 0;
 i3 = i27 + 4 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i27 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i27 + 44 >> 2] | 0;
 if ((i1 | 0) != (i27 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i28 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i28);
 HEAP32[i1 >> 2] = 0;
 i22 = i28 + 16 | 0;
 i2 = i28 + 4 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i28 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i28 + 44 >> 2] | 0;
 if ((i1 | 0) == (i28 + 48 | 0)) {
  STACKTOP = i29;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i29;
 return;
}

function __ZL14icvXMLWriteTagP13CvFileStoragePKci10CvAttrList(i18, i1, i15, i2, i9) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i7 = i22 + 32 | 0;
 i13 = i22 + 24 | 0;
 i14 = i22 + 16 | 0;
 i16 = i22 + 8 | 0;
 i17 = i22;
 i20 = i18 + 72 | 0;
 i6 = HEAP32[i20 >> 2] | 0;
 i21 = i18 + 44 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 if (!i1) i12 = 0; else i12 = (HEAP8[i1 >> 0] | 0) == 0 ? 0 : i1;
 i19 = (i15 | 0) == 3;
 if ((i15 & -3 | 0) == 1) {
  i3 = i5 & 7;
  if (i3 >>> 0 > 4) if ((i3 | 0) == 6 ^ (i12 | 0) != 0) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i7, 85) | 0) + 0 | 0;
   i1 = 13856;
   i8 = i11 + 85 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i1 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i1 = i1 + 1 | 0;
   } while ((i11 | 0) < (i8 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i7, 14216, 8960, 2286);
   __ZN2cv6String10deallocateEv(i7);
   i10 = i5;
  } else i10 = i5; else {
   HEAP32[i18 + 12 >> 2] = 0;
   i10 = (i12 | 0) != 0 ? 38 : 37;
  }
  if (!(i10 & 32)) {
   i5 = HEAP32[i20 >> 2] | 0;
   i7 = i18 + 76 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i8 = i18 + 56 | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   if (i5 >>> 0 > (i1 + i4 | 0) >>> 0) {
    HEAP8[i5 >> 0] = 10;
    HEAP8[i5 + 1 >> 0] = 0;
    __ZL7icvPutsP13CvFileStoragePKc(i18, HEAP32[i7 >> 2] | 0);
    i1 = HEAP32[i7 >> 2] | 0;
    HEAP32[i20 >> 2] = i1;
    i4 = HEAP32[i8 >> 2] | 0;
   }
   i3 = HEAP32[i18 + 40 >> 2] | 0;
   if ((i3 | 0) == (i4 | 0)) i3 = i4; else {
    if ((i3 | 0) > (i4 | 0)) {
     _memset(i1 + i4 | 0, 32, i3 - i4 | 0) | 0;
     i1 = HEAP32[i7 >> 2] | 0;
    }
    HEAP32[i8 >> 2] = i3;
   }
   i6 = i1 + i3 | 0;
   HEAP32[i20 >> 2] = i6;
  }
 } else i10 = i5;
 if (i12) if ((HEAP8[i12 >> 0] | 0) == 95 ? (HEAP8[i12 + 1 >> 0] | 0) == 0 : 0) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  i11 = (__ZN2cv6String8allocateEj(i13, 33) | 0) + 0 | 0;
  i1 = 14232;
  i8 = i11 + 33 | 0;
  do {
   HEAP8[i11 >> 0] = HEAP8[i1 >> 0] | 0;
   i11 = i11 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i11 | 0) < (i8 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i13, 14216, 8960, 2301);
  __ZN2cv6String10deallocateEv(i13);
  i7 = i12;
 } else i7 = i12; else i7 = 9024;
 i12 = _strlen(i7 | 0) | 0;
 i5 = i6 + 1 | 0;
 HEAP8[i6 >> 0] = 60;
 if ((i15 | 0) == 2) {
  if (i2) {
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   i11 = (__ZN2cv6String8allocateEj(i14, 45) | 0) + 0 | 0;
   i1 = 14272;
   i8 = i11 + 45 | 0;
   do {
    HEAP8[i11 >> 0] = HEAP8[i1 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i1 = i1 + 1 | 0;
   } while ((i11 | 0) < (i8 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i14, 14216, 8960, 2308);
   __ZN2cv6String10deallocateEv(i14);
  }
  HEAP8[i5 >> 0] = 47;
  i5 = i6 + 2 | 0;
 }
 i8 = HEAP8[i7 >> 0] | 0;
 if (!((i8 + -97 << 24 >> 24 & 255) < 26 | (i8 + -65 << 24 >> 24 & 255) < 26 | i8 << 24 >> 24 == 95)) {
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  i11 = (__ZN2cv6String8allocateEj(i16, 35) | 0) + 0 | 0;
  i1 = 14320;
  i8 = i11 + 35 | 0;
  do {
   HEAP8[i11 >> 0] = HEAP8[i1 >> 0] | 0;
   i11 = i11 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i11 | 0) < (i8 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i16, 14216, 8960, 2313);
  __ZN2cv6String10deallocateEv(i16);
 }
 i16 = i18 + 80 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 if ((i5 + i12 | 0) >>> 0 >= i3 >>> 0) {
  i6 = i18 + 76 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i5 = i5 - i1 | 0;
  i1 = ((i3 - i1 | 0) * 3 | 0) / 2 | 0;
  i3 = i5 + i12 | 0;
  i3 = (i3 | 0) < (i1 | 0) ? i1 : i3;
  i1 = _cvAlloc(i3 + 256 | 0) | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i20 >> 2] = i1 + ((HEAP32[i20 >> 2] | 0) - i4);
  if ((i5 | 0) > 0) _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i16 >> 2] = i1 + i3;
  i5 = i1 + i5 | 0;
 }
 if ((i12 | 0) > 0) {
  i6 = i17 + 4 | 0;
  i3 = 0;
  do {
   i4 = HEAP8[i7 + i3 >> 0] | 0;
   if (!((i4 + -48 << 24 >> 24 & 255) < 10 | (i4 + -97 << 24 >> 24 & 255) < 26 | (i4 + -65 << 24 >> 24 & 255) < 26) ? !(i4 << 24 >> 24 == 45 | i4 << 24 >> 24 == 95) : 0) {
    HEAP32[i17 >> 2] = 0;
    HEAP32[i6 >> 2] = 0;
    i11 = (__ZN2cv6String8allocateEj(i17, 74) | 0) + 0 | 0;
    i1 = 14360;
    i8 = i11 + 74 | 0;
    do {
     HEAP8[i11 >> 0] = HEAP8[i1 >> 0] | 0;
     i11 = i11 + 1 | 0;
     i1 = i1 + 1 | 0;
    } while ((i11 | 0) < (i8 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i17, 14216, 8960, 2320);
    __ZN2cv6String10deallocateEv(i17);
   }
   HEAP8[i5 + i3 >> 0] = i4;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i12 | 0));
 }
 i11 = i18 + 76 | 0;
 i1 = i5 + i12 | 0;
 while (1) {
  L53 : do if (i2) {
   i8 = i2;
   while (1) {
    i2 = HEAP32[i8 >> 2] | 0;
    if (!i2) break L53;
    i6 = _strlen(i2 | 0) | 0;
    i5 = i8 + 4 | 0;
    i7 = _strlen(HEAP32[i5 >> 2] | 0) | 0;
    i2 = i6 + 4 + i7 | 0;
    i3 = HEAP32[i16 >> 2] | 0;
    if ((i1 + i2 | 0) >>> 0 >= i3 >>> 0) {
     i12 = HEAP32[i11 >> 2] | 0;
     i4 = i1 - i12 | 0;
     i3 = ((i3 - i12 | 0) * 3 | 0) / 2 | 0;
     i2 = i4 + i2 | 0;
     i2 = (i2 | 0) < (i3 | 0) ? i3 : i2;
     i3 = _cvAlloc(i2 + 256 | 0) | 0;
     i1 = HEAP32[i11 >> 2] | 0;
     HEAP32[i20 >> 2] = i3 + ((HEAP32[i20 >> 2] | 0) - i1);
     if ((i4 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i4 | 0) | 0;
     HEAP32[i11 >> 2] = i3;
     HEAP32[i16 >> 2] = i3 + i2;
     i1 = i3 + i4 | 0;
    }
    HEAP8[i1 >> 0] = 32;
    _memcpy(i1 + 1 | 0, HEAP32[i8 >> 2] | 0, i6 | 0) | 0;
    HEAP8[i1 + (i6 + 1) >> 0] = 61;
    i4 = i6 + 3 | 0;
    HEAP8[i1 + (i6 + 2) >> 0] = 34;
    _memcpy(i1 + i4 | 0, HEAP32[i5 >> 2] | 0, i7 | 0) | 0;
    i7 = i7 + i4 | 0;
    HEAP8[i1 + i7 >> 0] = 34;
    i8 = i8 + 8 | 0;
    i1 = i1 + (i7 + 1) | 0;
   }
  } while (0);
  if (!i9) break;
  i2 = i9;
  i9 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 if (!i19) {
  i8 = i1;
  i9 = i8 + 1 | 0;
  HEAP8[i8 >> 0] = 62;
  HEAP32[i20 >> 2] = i9;
  i10 = i10 & -33;
  HEAP32[i21 >> 2] = i10;
  STACKTOP = i22;
  return;
 }
 HEAP8[i1 >> 0] = 47;
 i8 = i1 + 1 | 0;
 i9 = i8 + 1 | 0;
 HEAP8[i8 >> 0] = 62;
 HEAP32[i20 >> 2] = i9;
 i10 = i10 & -33;
 HEAP32[i21 >> 2] = i10;
 STACKTOP = i22;
 return;
}

function __ZN2cvL14MulTransposedRItdEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d28) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d28 = +d28;
 var d4 = 0.0, d5 = 0.0, d6 = 0.0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, d30 = 0.0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i27 = i29;
 i25 = HEAP32[i3 + 16 >> 2] | 0;
 i18 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i26 = (HEAP32[i3 + 48 >> 2] | 0) >>> 1;
 i24 = (HEAP32[i1 + 48 >> 2] | 0) >>> 3;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i9 = (HEAP32[i2 + 48 >> 2] | 0) >>> 3; else i9 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i20 = HEAP32[i3 + 40 >> 2] | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = i27 + 8 | 0;
 HEAP32[i27 >> 2] = i21;
 i22 = i27 + 4 | 0;
 HEAP32[i22 >> 2] = 1032;
 i3 = (i7 | 0) != 0;
 i2 = (i2 | 0) < (i19 | 0);
 if (i3 & i2) i1 = i20 * 40 | 0; else i1 = i20 << 3;
 if (i1 >>> 0 > 1032) {
  i23 = __Znaj(i1) | 0;
  HEAP32[i27 >> 2] = i23;
 } else i23 = i21;
 HEAP32[i22 >> 2] = i1;
 do if (i3) {
  if (i2) {
   i2 = i23 + (i20 << 3) | 0;
   if ((i20 | 0) > 0) {
    i3 = 0;
    do {
     d4 = +HEAPF64[i7 + ((Math_imul(i3, i9) | 0) << 3) >> 3];
     i16 = i3 << 2;
     HEAPF64[i23 + ((i16 | 3) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + ((i16 | 2) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + ((i16 | 1) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + (i16 + i20 << 3) >> 3] = d4;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if (!i2) {
    i17 = 14;
    break;
   } else {
    i7 = i2;
    i16 = i2;
    i9 = (i9 | 0) != 0 ? 4 : 0;
   }
  } else i16 = 0;
  if ((i19 | 0) > 0) {
   i11 = (i16 | 0) != 0;
   i13 = (i20 | 0) > 0;
   i12 = i19 + -4 | 0;
   i14 = 0;
   i15 = i18;
   while (1) {
    if (i11) {
     if (i13) {
      i3 = 0;
      do {
       d4 = +(HEAPU16[i25 + ((Math_imul(i3, i26) | 0) + i14 << 1) >> 1] | 0 | 0);
       HEAPF64[i23 + (i3 << 3) >> 3] = d4 - +HEAPF64[i16 + ((Math_imul(i3, i9) | 0) << 3) >> 3];
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i20 | 0));
     }
    } else if (i13) {
     i3 = 0;
     do {
      d4 = +(HEAPU16[i25 + ((Math_imul(i3, i26) | 0) + i14 << 1) >> 1] | 0 | 0);
      HEAPF64[i23 + (i3 << 3) >> 3] = d4 - +HEAPF64[i7 + ((Math_imul(i3, i9) | 0) + i14 << 3) >> 3];
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i20 | 0));
    }
    if ((i14 | 0) > (i12 | 0)) i3 = i14; else {
     i3 = i14;
     do {
      if (i11) i2 = i16; else i2 = i7 + (i3 << 3) | 0;
      if (i13) {
       i10 = 0;
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
       i1 = i25 + (i3 << 1) | 0;
       while (1) {
        d30 = +HEAPF64[i23 + (i10 << 3) >> 3];
        d4 = d4 + d30 * (+(HEAPU16[i1 >> 1] | 0 | 0) - +HEAPF64[i2 >> 3]);
        d5 = d5 + d30 * (+(HEAPU16[i1 + 2 >> 1] | 0 | 0) - +HEAPF64[i2 + 8 >> 3]);
        d6 = d6 + d30 * (+(HEAPU16[i1 + 4 >> 1] | 0 | 0) - +HEAPF64[i2 + 16 >> 3]);
        d8 = d8 + d30 * (+(HEAPU16[i1 + 6 >> 1] | 0 | 0) - +HEAPF64[i2 + 24 >> 3]);
        i10 = i10 + 1 | 0;
        if ((i10 | 0) == (i20 | 0)) break; else {
         i2 = i2 + (i9 << 3) | 0;
         i1 = i1 + (i26 << 1) | 0;
        }
       }
      } else {
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
      }
      HEAPF64[i15 + (i3 << 3) >> 3] = d4 * d28;
      HEAPF64[i15 + (i3 + 1 << 3) >> 3] = d5 * d28;
      HEAPF64[i15 + (i3 + 2 << 3) >> 3] = d6 * d28;
      HEAPF64[i15 + (i3 + 3 << 3) >> 3] = d8 * d28;
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i12 | 0));
    }
    if ((i3 | 0) < (i19 | 0)) do {
     if (i11) i2 = i16; else i2 = i7 + (i3 << 3) | 0;
     if (i13) {
      i1 = 0;
      d8 = 0.0;
      i10 = i25 + (i3 << 1) | 0;
      while (1) {
       d8 = d8 + +HEAPF64[i23 + (i1 << 3) >> 3] * (+(HEAPU16[i10 >> 1] | 0 | 0) - +HEAPF64[i2 >> 3]);
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i20 | 0)) break; else {
        i2 = i2 + (i9 << 3) | 0;
        i10 = i10 + (i26 << 1) | 0;
       }
      }
     } else d8 = 0.0;
     HEAPF64[i15 + (i3 << 3) >> 3] = d8 * d28;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i19 | 0));
    i14 = i14 + 1 | 0;
    if ((i14 | 0) == (i19 | 0)) break; else i15 = i15 + (i24 << 3) | 0;
   }
  }
 } else i17 = 14; while (0);
 if ((i17 | 0) == 14 ? (i19 | 0) > 0 : 0) {
  i11 = (i20 | 0) > 0;
  i12 = i19 + -4 | 0;
  i13 = 0;
  i10 = i18;
  while (1) {
   if (i11) {
    i3 = 0;
    do {
     HEAPF64[i23 + (i3 << 3) >> 3] = +(HEAPU16[i25 + ((Math_imul(i3, i26) | 0) + i13 << 1) >> 1] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if ((i13 | 0) > (i12 | 0)) i3 = i13; else {
    i3 = i13;
    do {
     if (i11) {
      i9 = 0;
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
      i7 = i25 + (i3 << 1) | 0;
      while (1) {
       d30 = +HEAPF64[i23 + (i9 << 3) >> 3];
       d8 = d8 + d30 * +(HEAPU16[i7 >> 1] | 0 | 0);
       d6 = d6 + d30 * +(HEAPU16[i7 + 2 >> 1] | 0 | 0);
       d5 = d5 + d30 * +(HEAPU16[i7 + 4 >> 1] | 0 | 0);
       d4 = d4 + d30 * +(HEAPU16[i7 + 6 >> 1] | 0 | 0);
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == (i20 | 0)) break; else i7 = i7 + (i26 << 1) | 0;
      }
     } else {
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
     }
     HEAPF64[i10 + (i3 << 3) >> 3] = d8 * d28;
     HEAPF64[i10 + (i3 + 1 << 3) >> 3] = d6 * d28;
     HEAPF64[i10 + (i3 + 2 << 3) >> 3] = d5 * d28;
     HEAPF64[i10 + (i3 + 3 << 3) >> 3] = d4 * d28;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i12 | 0));
   }
   if ((i3 | 0) < (i19 | 0)) do {
    if (i11) {
     i2 = 0;
     d4 = 0.0;
     i1 = i25 + (i3 << 1) | 0;
     while (1) {
      d4 = d4 + +HEAPF64[i23 + (i2 << 3) >> 3] * +(HEAPU16[i1 >> 1] | 0 | 0);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break; else i1 = i1 + (i26 << 1) | 0;
     }
    } else d4 = 0.0;
    HEAPF64[i10 + (i3 << 3) >> 3] = d4 * d28;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i19 | 0));
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i19 | 0)) break; else i10 = i10 + (i24 << 3) | 0;
  }
 }
 if ((i23 | 0) == (i21 | 0)) {
  STACKTOP = i29;
  return;
 }
 __ZdaPv(i23);
 HEAP32[i27 >> 2] = i21;
 HEAP32[i22 >> 2] = 1032;
 STACKTOP = i29;
 return;
}

function __ZNK2cv17CommandLineParser12printMessageEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i17 = i18;
 i8 = i18 + 48 | 0;
 i11 = i18 + 40 | 0;
 i10 = i18 + 32 | 0;
 i15 = i18 + 24 | 0;
 i13 = i18 + 16 | 0;
 i14 = i18 + 8 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if ((i1 | 0) != 6232 ? (i3 = (i1 | 0) == 0 ? 6232 : i1, (HEAP8[i3 >> 0] | 0) != 0) : 0) {
  _puts(i3 | 0) | 0;
  i2 = HEAP32[i16 >> 2] | 0;
 }
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 HEAP32[i17 >> 2] = (i2 | 0) == 0 ? 6232 : i2;
 _printf(6296, i17 | 0) | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i3 = HEAP32[i2 + 36 >> 2] | 0;
 if ((HEAP32[i2 + 40 >> 2] | 0) != (i3 | 0)) {
  i7 = i8 + 4 | 0;
  i6 = 0;
  do {
   if ((HEAP32[i3 + (i6 << 5) + 28 >> 2] | 0) > -1) {
    i3 = HEAP32[i3 + (i6 << 5) + 16 >> 2] | 0;
    i2 = i3 + 4 | 0;
    i19 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
    HEAP32[i8 >> 2] = 0;
    HEAP32[i7 >> 2] = 0;
    i1 = HEAP32[i2 >> 2] | 0;
    i4 = (i1 | 0) != 0 & 1;
    i5 = i1 - i4 | 0;
    i5 = i5 >>> 0 > i19 >>> 0 ? i19 : i5;
    do if (i5) if ((i5 | 0) == (i1 | 0)) {
     i5 = (HEAP32[i3 >> 2] | 0) + -4 | 0;
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
     i3 = HEAP32[i3 >> 2] | 0;
     HEAP32[i8 >> 2] = i3;
     HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
     break;
    } else {
     i2 = __ZN2cv6String8allocateEj(i8, i5) | 0;
     _memcpy(i2 | 0, (HEAP32[i3 >> 2] | 0) + i4 | 0, i5 | 0) | 0;
     i3 = HEAP32[i8 >> 2] | 0;
     break;
    } else i3 = 0; while (0);
    HEAP32[i17 >> 2] = (i3 | 0) == 0 ? 6232 : i3;
    _printf(6320, i17 | 0) | 0;
    __ZN2cv6String10deallocateEv(i8);
    i2 = HEAP32[i16 >> 2] | 0;
   }
   i6 = i6 + 1 | 0;
   i3 = HEAP32[i2 + 36 >> 2] | 0;
  } while (i6 >>> 0 < (HEAP32[i2 + 40 >> 2] | 0) - i3 >> 5 >>> 0);
 }
 _puts(6616) | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i3 + 36 >> 2] | 0;
 if ((HEAP32[i3 + 40 >> 2] | 0) != (i2 | 0)) {
  i6 = i11 + 4 | 0;
  i7 = 0;
  do {
   if ((HEAP32[i2 + (i7 << 5) + 28 >> 2] | 0) == -1) {
    _putchar(9) | 0;
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0;
    i3 = HEAP32[i2 + (i7 << 5) + 16 >> 2] | 0;
    if ((HEAP32[i2 + (i7 << 5) + 20 >> 2] | 0) != (i3 | 0)) {
     i5 = 0;
     do {
      i2 = HEAP32[i3 + (i5 << 3) >> 2] | 0;
      HEAP32[i11 >> 2] = i2;
      i3 = HEAP32[i3 + (i5 << 3) + 4 >> 2] | 0;
      HEAP32[i6 >> 2] = i3;
      if (i2) {
       i3 = i2 + -4 | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       i3 = HEAP32[i6 >> 2] | 0;
      }
      if (i3 >>> 0 > 1) _printf(6328, i17 | 0) | 0; else _putchar(45) | 0;
      i8 = HEAP32[i11 >> 2] | 0;
      HEAP32[i17 >> 2] = (i8 | 0) == 0 ? 6232 : i8;
      _printf(6336, i17 | 0) | 0;
      i8 = HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0;
      if ((i5 | 0) != (((HEAP32[i8 + (i7 << 5) + 20 >> 2] | 0) - (HEAP32[i8 + (i7 << 5) + 16 >> 2] | 0) >> 3) + -1 | 0)) _printf(6344, i17 | 0) | 0;
      __ZN2cv6String10deallocateEv(i11);
      i5 = i5 + 1 | 0;
      i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0;
      i3 = HEAP32[i2 + (i7 << 5) + 16 >> 2] | 0;
     } while (i5 >>> 0 < (HEAP32[i2 + (i7 << 5) + 20 >> 2] | 0) - i3 >> 3 >>> 0);
    }
    __ZNK2cv17CommandLineParser4Impl10cat_stringERKNS_6StringE(i10, 0, i2 + (i7 << 5) + 8 | 0);
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i2 | 0) != 6232 ? (i9 = (i2 | 0) == 0 ? 6232 : i2, (HEAP8[i9 >> 0] | 0) != 0) : 0) {
     HEAP32[i17 >> 2] = i9;
     _printf(6352, i17 | 0) | 0;
    }
    i3 = HEAP32[(HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0) + (i7 << 5) >> 2] | 0;
    HEAP32[i17 >> 2] = (i3 | 0) == 0 ? 6232 : i3;
    _printf(6368, i17 | 0) | 0;
    __ZN2cv6String10deallocateEv(i10);
    i3 = HEAP32[i16 >> 2] | 0;
   }
   i7 = i7 + 1 | 0;
   i2 = HEAP32[i3 + 36 >> 2] | 0;
  } while (i7 >>> 0 < (HEAP32[i3 + 40 >> 2] | 0) - i2 >> 5 >>> 0);
 }
 _putchar(10) | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 if ((HEAP32[i2 + 40 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i18;
  return;
 }
 i6 = i15 + 4 | 0;
 i4 = i13 + 4 | 0;
 i5 = 0;
 do {
  if ((HEAP32[i1 + (i5 << 5) + 28 >> 2] | 0) != -1) {
   _putchar(9) | 0;
   i1 = HEAP32[(HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0) + (i5 << 5) + 16 >> 2] | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   HEAP32[i15 >> 2] = i2;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i6 >> 2] = i1;
   if (i2) {
    i1 = i2 + -4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i10 = i1 + -1 | 0;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   i2 = (i1 | 0) != 0 & 1;
   i3 = i1 - i2 | 0;
   i3 = i3 >>> 0 > i10 >>> 0 ? i10 : i3;
   do if (i3) if ((i3 | 0) == (i1 | 0)) {
    i10 = (HEAP32[i15 >> 2] | 0) + -4 | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
    HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
    break;
   } else {
    i10 = __ZN2cv6String8allocateEj(i13, i3) | 0;
    _memcpy(i10 | 0, (HEAP32[i15 >> 2] | 0) + i2 | 0, i3 | 0) | 0;
    break;
   } while (0);
   __ZN2cv6String10deallocateEv(i15);
   i1 = HEAP32[i13 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i1 = i1 + -4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = HEAP32[i13 >> 2] | 0;
   }
   HEAP32[i15 >> 2] = i1;
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   __ZN2cv6String10deallocateEv(i13);
   i1 = HEAP32[i15 >> 2] | 0;
   HEAP32[i17 >> 2] = (i1 | 0) == 0 ? 6232 : i1;
   _printf(6336, i17 | 0) | 0;
   __ZNK2cv17CommandLineParser4Impl10cat_stringERKNS_6StringE(i14, 0, (HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0) + (i5 << 5) + 8 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   if ((i1 | 0) != 6232 ? (i12 = (i1 | 0) == 0 ? 6232 : i1, (HEAP8[i12 >> 0] | 0) != 0) : 0) {
    HEAP32[i17 >> 2] = i12;
    _printf(6352, i17 | 0) | 0;
   }
   i2 = HEAP32[(HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0) + (i5 << 5) >> 2] | 0;
   HEAP32[i17 >> 2] = (i2 | 0) == 0 ? 6232 : i2;
   _printf(6368, i17 | 0) | 0;
   __ZN2cv6String10deallocateEv(i14);
   __ZN2cv6String10deallocateEv(i15);
   i2 = HEAP32[i16 >> 2] | 0;
  }
  i5 = i5 + 1 | 0;
  i1 = HEAP32[i2 + 36 >> 2] | 0;
 } while (i5 >>> 0 < (HEAP32[i2 + 40 >> 2] | 0) - i1 >> 5 >>> 0);
 STACKTOP = i18;
 return;
}

function __ZL14icvXMLParseTagP13CvFileStoragePcPP16CvStringHashNodePP10CvAttrListPi(i18, i3, i21, i20, i22) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 i24 = i25 + 16 | 0;
 i23 = i25 + 32 | 0;
 i19 = i25;
 i1 = HEAP8[i3 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  i1 = HEAP32[i18 + 88 >> 2] | 0;
  HEAP32[i24 >> 2] = HEAP32[i18 + 60 >> 2];
  HEAP32[i24 + 4 >> 2] = i1;
  HEAP32[i24 + 8 >> 2] = 16280;
  _sprintf(i23, 17440, i24) | 0;
  _cvError(-212, 16264, i23, 8960, 2077);
  i1 = HEAP8[i3 >> 0] | 0;
 }
 if (i1 << 24 >> 24 != 60) {
  i17 = HEAP32[i18 + 88 >> 2] | 0;
  HEAP32[i24 >> 2] = HEAP32[i18 + 60 >> 2];
  HEAP32[i24 + 4 >> 2] = i17;
  HEAP32[i24 + 8 >> 2] = 16312;
  _sprintf(i23, 17440, i24) | 0;
  _cvError(-212, 16264, i23, 8960, 2080);
 }
 i1 = i3 + 1 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 do if (!((i2 + -48 << 24 >> 24 & 255) < 10 | (i2 + -97 << 24 >> 24 & 255) < 26 | (i2 + -65 << 24 >> 24 & 255) < 26)) if (i2 << 24 >> 24 == 33) {
  i1 = i3 + 2 | 0;
  i17 = 5;
  break;
 } else if (i2 << 24 >> 24 == 47) {
  i1 = i3 + 2 | 0;
  i17 = 2;
  break;
 } else if (i2 << 24 >> 24 == 63) {
  i1 = i3 + 2 | 0;
  i17 = 4;
  break;
 } else if (i2 << 24 >> 24 == 95) {
  i17 = 1;
  break;
 } else {
  i17 = HEAP32[i18 + 88 >> 2] | 0;
  HEAP32[i24 >> 2] = HEAP32[i18 + 60 >> 2];
  HEAP32[i24 + 4 >> 2] = i17;
  HEAP32[i24 + 8 >> 2] = 16344;
  _sprintf(i23, 17440, i24) | 0;
  _cvError(-212, 16264, i23, 8960, 2102);
  i17 = 0;
  break;
 } else i17 = 1; while (0);
 i14 = (i17 | 0) == 4;
 i10 = (i17 | 0) == 1;
 i15 = i18 + 60 | 0;
 i16 = i18 + 88 | 0;
 i11 = i19 + 12 | 0;
 i12 = (i17 | 0) == 2;
 i13 = i18 + 16 | 0;
 i4 = 0;
 i5 = 0;
 i8 = 0;
 i9 = 0;
 L15 : while (1) {
  i2 = HEAP8[i1 >> 0] | 0;
  if (!((i2 + -97 << 24 >> 24 & 255) < 26 | (i2 + -65 << 24 >> 24 & 255) < 26 | i2 << 24 >> 24 == 95)) {
   i2 = HEAP32[i16 >> 2] | 0;
   HEAP32[i24 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i24 + 4 >> 2] = i2;
   HEAP32[i24 + 8 >> 2] = 16368;
   _sprintf(i23, 17440, i24) | 0;
   _cvError(-212, 16264, i23, 8960, 2109);
  }
  i3 = i1 + -1 | 0;
  while (1) {
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if ((i2 + -48 << 24 >> 24 & 255) < 10 | (i2 + -97 << 24 >> 24 & 255) < 26 | (i2 + -65 << 24 >> 24 & 255) < 26) continue;
   if (!(i2 << 24 >> 24 == 45 | i2 << 24 >> 24 == 95)) break;
  }
  i7 = _cvGetHashedKey(i18, i1, i3 - i1 | 0, 1) | 0;
  if (i9) {
   if (i12) {
    i1 = HEAP32[i16 >> 2] | 0;
    HEAP32[i24 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i24 + 4 >> 2] = i1;
    HEAP32[i24 + 8 >> 2] = 16416;
    _sprintf(i23, 17440, i24) | 0;
    _cvError(-212, 16264, i23, 8960, 2123);
   }
   i6 = (i8 | 0) != 0;
   if ((i4 | 0) > 3 | i6 ^ 1) {
    i2 = _cvMemStorageAlloc(HEAP32[i13 >> 2] | 0, 44) | 0;
    i4 = i2 + 0 | 0;
    i1 = i4 + 44 | 0;
    do {
     HEAP32[i4 >> 2] = 0;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) < (i1 | 0));
    HEAP32[i2 >> 2] = i2 + 8;
    if (i6) {
     HEAP32[i8 + 4 >> 2] = i2;
     i1 = 0;
    } else {
     i1 = 0;
     i5 = i2;
    }
   } else {
    i1 = i4;
    i2 = i8;
   }
   HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 1 << 2) >> 2] = HEAP32[i7 + 8 >> 2];
   i4 = i1;
   i8 = i2;
   i7 = i9;
  }
  if (!i8) i1 = i3; else {
   if ((HEAP8[i3 >> 0] | 0) != 61) {
    i3 = __ZL16icvXMLSkipSpacesP13CvFileStoragePci(i18, i3, 2) | 0;
    if ((HEAP8[i3 >> 0] | 0) != 61) {
     i1 = HEAP32[i16 >> 2] | 0;
     HEAP32[i24 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i24 + 4 >> 2] = i1;
     HEAP32[i24 + 8 >> 2] = 16464;
     _sprintf(i23, 17440, i24) | 0;
     _cvError(-212, 16264, i23, 8960, 2149);
    }
   }
   i3 = i3 + 1 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   if (!(i1 << 24 >> 24 == 39 | i1 << 24 >> 24 == 34)) {
    i3 = __ZL16icvXMLSkipSpacesP13CvFileStoragePci(i18, i3, 2) | 0;
    i1 = HEAP8[i3 >> 0] | 0;
    if (!(i1 << 24 >> 24 == 39 | i1 << 24 >> 24 == 34)) {
     i1 = HEAP32[i16 >> 2] | 0;
     HEAP32[i24 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i24 + 4 >> 2] = i1;
     HEAP32[i24 + 8 >> 2] = 16512;
     _sprintf(i23, 17440, i24) | 0;
     _cvError(-212, 16264, i23, 8960, 2157);
    }
   }
   i1 = __ZL16icvXMLParseValueP13CvFileStoragePcP10CvFileNodei(i18, i3, i19, 3) | 0;
   HEAP32[(HEAP32[i8 >> 2] | 0) + ((i4 << 1 | 1) << 2) >> 2] = HEAP32[i11 >> 2];
   i4 = i4 + 1 | 0;
  }
  i2 = HEAP8[i1 >> 0] | 0;
  if (i2 << 24 >> 24 == 62) {
   i3 = 34;
   break;
  }
  i1 = __ZL16icvXMLSkipSpacesP13CvFileStoragePci(i18, i1, 2) | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  if (i3 << 24 >> 24 == 62) {
   i3 = 34;
   break;
  }
  if (i3 << 24 >> 24 == 63 & i14) {
   i3 = 38;
   break;
  }
  if (i3 << 24 >> 24 == 47 ? (HEAP8[i1 + 1 >> 0] | 0) == 62 & i10 : 0) {
   i3 = 43;
   break;
  }
  switch (i2 << 24 >> 24) {
  case 0:
  case 9:
  case 10:
  case 11:
  case 12:
  case 13:
  case 32:
   {
    i9 = i7;
    continue L15;
   }
  default:
   {}
  }
  i9 = HEAP32[i16 >> 2] | 0;
  HEAP32[i24 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i24 + 4 >> 2] = i9;
  HEAP32[i24 + 8 >> 2] = 16616;
  _sprintf(i23, 17440, i24) | 0;
  _cvError(-212, 16264, i23, 8960, 2197);
  i9 = i7;
 }
 if ((i3 | 0) == 34) {
  if (i14) {
   i19 = HEAP32[i16 >> 2] | 0;
   HEAP32[i24 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i24 + 4 >> 2] = i19;
   HEAP32[i24 + 8 >> 2] = 16576;
   _sprintf(i23, 17440, i24) | 0;
   _cvError(-212, 16264, i23, 8960, 2178);
  }
  i19 = i1 + 1 | 0;
  i18 = i17;
  HEAP32[i21 >> 2] = i7;
  HEAP32[i22 >> 2] = i18;
  HEAP32[i20 >> 2] = i5;
  STACKTOP = i25;
  return i19 | 0;
 } else if ((i3 | 0) == 38) {
  if ((HEAP8[i1 + 1 >> 0] | 0) != 62) {
   i19 = HEAP32[i16 >> 2] | 0;
   HEAP32[i24 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i24 + 4 >> 2] = i19;
   HEAP32[i24 + 8 >> 2] = 16576;
   _sprintf(i23, 17440, i24) | 0;
   _cvError(-212, 16264, i23, 8960, 2185);
  }
  i19 = i1 + 2 | 0;
  i18 = 4;
  HEAP32[i21 >> 2] = i7;
  HEAP32[i22 >> 2] = i18;
  HEAP32[i20 >> 2] = i5;
  STACKTOP = i25;
  return i19 | 0;
 } else if ((i3 | 0) == 43) {
  i19 = i1 + 2 | 0;
  i18 = 3;
  HEAP32[i21 >> 2] = i7;
  HEAP32[i22 >> 2] = i18;
  HEAP32[i20 >> 2] = i5;
  STACKTOP = i25;
  return i19 | 0;
 }
 return 0;
}

function __ZN2cvL14MulTransposedRIsdEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d28) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d28 = +d28;
 var d4 = 0.0, d5 = 0.0, d6 = 0.0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, d30 = 0.0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i27 = i29;
 i25 = HEAP32[i3 + 16 >> 2] | 0;
 i18 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i26 = (HEAP32[i3 + 48 >> 2] | 0) >>> 1;
 i24 = (HEAP32[i1 + 48 >> 2] | 0) >>> 3;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i9 = (HEAP32[i2 + 48 >> 2] | 0) >>> 3; else i9 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i20 = HEAP32[i3 + 40 >> 2] | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = i27 + 8 | 0;
 HEAP32[i27 >> 2] = i21;
 i22 = i27 + 4 | 0;
 HEAP32[i22 >> 2] = 1032;
 i3 = (i7 | 0) != 0;
 i2 = (i2 | 0) < (i19 | 0);
 if (i3 & i2) i1 = i20 * 40 | 0; else i1 = i20 << 3;
 if (i1 >>> 0 > 1032) {
  i23 = __Znaj(i1) | 0;
  HEAP32[i27 >> 2] = i23;
 } else i23 = i21;
 HEAP32[i22 >> 2] = i1;
 do if (i3) {
  if (i2) {
   i2 = i23 + (i20 << 3) | 0;
   if ((i20 | 0) > 0) {
    i3 = 0;
    do {
     d4 = +HEAPF64[i7 + ((Math_imul(i3, i9) | 0) << 3) >> 3];
     i16 = i3 << 2;
     HEAPF64[i23 + ((i16 | 3) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + ((i16 | 2) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + ((i16 | 1) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + (i16 + i20 << 3) >> 3] = d4;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if (!i2) {
    i17 = 14;
    break;
   } else {
    i7 = i2;
    i16 = i2;
    i9 = (i9 | 0) != 0 ? 4 : 0;
   }
  } else i16 = 0;
  if ((i19 | 0) > 0) {
   i11 = (i16 | 0) != 0;
   i13 = (i20 | 0) > 0;
   i12 = i19 + -4 | 0;
   i14 = 0;
   i15 = i18;
   while (1) {
    if (i11) {
     if (i13) {
      i3 = 0;
      do {
       d4 = +(HEAP16[i25 + ((Math_imul(i3, i26) | 0) + i14 << 1) >> 1] | 0);
       HEAPF64[i23 + (i3 << 3) >> 3] = d4 - +HEAPF64[i16 + ((Math_imul(i3, i9) | 0) << 3) >> 3];
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i20 | 0));
     }
    } else if (i13) {
     i3 = 0;
     do {
      d4 = +(HEAP16[i25 + ((Math_imul(i3, i26) | 0) + i14 << 1) >> 1] | 0);
      HEAPF64[i23 + (i3 << 3) >> 3] = d4 - +HEAPF64[i7 + ((Math_imul(i3, i9) | 0) + i14 << 3) >> 3];
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i20 | 0));
    }
    if ((i14 | 0) > (i12 | 0)) i3 = i14; else {
     i3 = i14;
     do {
      if (i11) i2 = i16; else i2 = i7 + (i3 << 3) | 0;
      if (i13) {
       i10 = 0;
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
       i1 = i25 + (i3 << 1) | 0;
       while (1) {
        d30 = +HEAPF64[i23 + (i10 << 3) >> 3];
        d4 = d4 + d30 * (+(HEAP16[i1 >> 1] | 0) - +HEAPF64[i2 >> 3]);
        d5 = d5 + d30 * (+(HEAP16[i1 + 2 >> 1] | 0) - +HEAPF64[i2 + 8 >> 3]);
        d6 = d6 + d30 * (+(HEAP16[i1 + 4 >> 1] | 0) - +HEAPF64[i2 + 16 >> 3]);
        d8 = d8 + d30 * (+(HEAP16[i1 + 6 >> 1] | 0) - +HEAPF64[i2 + 24 >> 3]);
        i10 = i10 + 1 | 0;
        if ((i10 | 0) == (i20 | 0)) break; else {
         i2 = i2 + (i9 << 3) | 0;
         i1 = i1 + (i26 << 1) | 0;
        }
       }
      } else {
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
      }
      HEAPF64[i15 + (i3 << 3) >> 3] = d4 * d28;
      HEAPF64[i15 + (i3 + 1 << 3) >> 3] = d5 * d28;
      HEAPF64[i15 + (i3 + 2 << 3) >> 3] = d6 * d28;
      HEAPF64[i15 + (i3 + 3 << 3) >> 3] = d8 * d28;
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i12 | 0));
    }
    if ((i3 | 0) < (i19 | 0)) do {
     if (i11) i2 = i16; else i2 = i7 + (i3 << 3) | 0;
     if (i13) {
      i1 = 0;
      d8 = 0.0;
      i10 = i25 + (i3 << 1) | 0;
      while (1) {
       d8 = d8 + +HEAPF64[i23 + (i1 << 3) >> 3] * (+(HEAP16[i10 >> 1] | 0) - +HEAPF64[i2 >> 3]);
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i20 | 0)) break; else {
        i2 = i2 + (i9 << 3) | 0;
        i10 = i10 + (i26 << 1) | 0;
       }
      }
     } else d8 = 0.0;
     HEAPF64[i15 + (i3 << 3) >> 3] = d8 * d28;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i19 | 0));
    i14 = i14 + 1 | 0;
    if ((i14 | 0) == (i19 | 0)) break; else i15 = i15 + (i24 << 3) | 0;
   }
  }
 } else i17 = 14; while (0);
 if ((i17 | 0) == 14 ? (i19 | 0) > 0 : 0) {
  i11 = (i20 | 0) > 0;
  i12 = i19 + -4 | 0;
  i13 = 0;
  i10 = i18;
  while (1) {
   if (i11) {
    i3 = 0;
    do {
     HEAPF64[i23 + (i3 << 3) >> 3] = +(HEAP16[i25 + ((Math_imul(i3, i26) | 0) + i13 << 1) >> 1] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if ((i13 | 0) > (i12 | 0)) i3 = i13; else {
    i3 = i13;
    do {
     if (i11) {
      i9 = 0;
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
      i7 = i25 + (i3 << 1) | 0;
      while (1) {
       d30 = +HEAPF64[i23 + (i9 << 3) >> 3];
       d8 = d8 + d30 * +(HEAP16[i7 >> 1] | 0);
       d6 = d6 + d30 * +(HEAP16[i7 + 2 >> 1] | 0);
       d5 = d5 + d30 * +(HEAP16[i7 + 4 >> 1] | 0);
       d4 = d4 + d30 * +(HEAP16[i7 + 6 >> 1] | 0);
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == (i20 | 0)) break; else i7 = i7 + (i26 << 1) | 0;
      }
     } else {
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
     }
     HEAPF64[i10 + (i3 << 3) >> 3] = d8 * d28;
     HEAPF64[i10 + (i3 + 1 << 3) >> 3] = d6 * d28;
     HEAPF64[i10 + (i3 + 2 << 3) >> 3] = d5 * d28;
     HEAPF64[i10 + (i3 + 3 << 3) >> 3] = d4 * d28;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i12 | 0));
   }
   if ((i3 | 0) < (i19 | 0)) do {
    if (i11) {
     i2 = 0;
     d4 = 0.0;
     i1 = i25 + (i3 << 1) | 0;
     while (1) {
      d4 = d4 + +HEAPF64[i23 + (i2 << 3) >> 3] * +(HEAP16[i1 >> 1] | 0);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break; else i1 = i1 + (i26 << 1) | 0;
     }
    } else d4 = 0.0;
    HEAPF64[i10 + (i3 << 3) >> 3] = d4 * d28;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i19 | 0));
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i19 | 0)) break; else i10 = i10 + (i24 << 3) | 0;
  }
 }
 if ((i23 | 0) == (i21 | 0)) {
  STACKTOP = i29;
  return;
 }
 __ZdaPv(i23);
 HEAP32[i27 >> 2] = i21;
 HEAP32[i22 >> 2] = 1032;
 STACKTOP = i29;
 return;
}

function __ZN6cvtest2TS16set_gtest_statusEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i1 = i16;
 i4 = i16 + 80 | 0;
 i3 = i16 + 76 | 0;
 i9 = i16 + 88 | 0;
 i15 = i16 + 64 | 0;
 i5 = i16 + 52 | 0;
 i6 = i16 + 40 | 0;
 i7 = i16 + 28 | 0;
 i12 = i16 + 24 | 0;
 i13 = i16 + 20 | 0;
 i14 = i16 + 8 | 0;
 i8 = HEAP32[i10 + 20 >> 2] | 0;
 if ((i8 | 0) > -1) {
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i4, 0, 158640, 500, 158688);
  __ZN7testing7MessageC2Ev(i3);
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i4, i3);
  if (HEAP32[i3 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i3 >> 2] | 0, (i2 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
   HEAP32[i3 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i4);
  STACKTOP = i16;
  return;
 }
 i3 = i10 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 _sprintf(i9, 158704, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, 158192, 0);
 i1 = i10 + 88 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 i3 = (i4 & 1) == 0;
 if (i3) i2 = (i4 & 255) >>> 1; else i2 = HEAP32[i10 + 92 >> 2] | 0;
 if (i2) {
  HEAP32[i5 + 0 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  if (i3) i3 = (i4 & 255) >>> 1; else i3 = HEAP32[i10 + 92 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, 158720, 43, i3 + 43 | 0);
  if (!(HEAP8[i1 >> 0] & 1)) i2 = i1 + 1 | 0; else i2 = HEAP32[i10 + 96 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, i2, i3) | 0;
  i2 = HEAP8[i5 >> 0] | 0;
  if (!(i2 & 1)) {
   i3 = i5 + 1 | 0;
   i2 = (i2 & 255) >>> 1;
  } else {
   i3 = HEAP32[i5 + 8 >> 2] | 0;
   i2 = HEAP32[i5 + 4 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i15, i3, i2) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 }
 i4 = i10 + 100 | 0;
 i3 = HEAP8[i4 >> 0] | 0;
 i2 = (i3 & 1) == 0;
 if (i2) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i10 + 104 >> 2] | 0;
 if (i1) {
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  if (i2) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i10 + 104 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, 158768, 43, i1 + 43 | 0);
  if (!(HEAP8[i4 >> 0] & 1)) i2 = i4 + 1 | 0; else i2 = HEAP32[i10 + 108 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, i2, i1) | 0;
  i2 = HEAP8[i6 >> 0] | 0;
  if (!(i2 & 1)) {
   i1 = i6 + 1 | 0;
   i2 = (i2 & 255) >>> 1;
  } else {
   i1 = HEAP32[i6 + 8 >> 2] | 0;
   i2 = HEAP32[i6 + 4 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i15, i1, i2) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 }
 i4 = i10 + 124 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 i3 = (i1 & 1) == 0;
 if (i3) i2 = (i1 & 255) >>> 1; else i2 = HEAP32[i10 + 128 >> 2] | 0;
 if (i2) {
  HEAP32[i7 + 0 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  if (i3) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i10 + 128 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i7, 158816, 47, i1 + 47 | 0);
  if (!(HEAP8[i4 >> 0] & 1)) i2 = i4 + 1 | 0; else i2 = HEAP32[i10 + 132 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i2, i1) | 0;
  i2 = HEAP8[i7 >> 0] | 0;
  if (!(i2 & 1)) {
   i1 = i7 + 1 | 0;
   i2 = (i2 & 255) >>> 1;
  } else {
   i1 = HEAP32[i7 + 8 >> 2] | 0;
   i2 = HEAP32[i7 + 4 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i15, i1, i2) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i15, 158864) | 0;
 __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i12, 2, 158640, 515, 158904);
 __ZN7testing7MessageC2Ev(i13);
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i13 >> 2] | 0) + 8 | 0, 158912, 18) | 0;
 __ZN6cvtest2TS13str_from_codeENS0_11FailureCodeE(i14, i8);
 i2 = HEAP8[i14 >> 0] | 0;
 if (!(i2 & 1)) {
  i1 = i14 + 1 | 0;
  i2 = (i2 & 255) >>> 1;
 } else {
  i1 = HEAP32[i14 + 8 >> 2] | 0;
  i2 = HEAP32[i14 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i13 >> 2] | 0) + 8 | 0, i1, i2) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i13 >> 2] | 0) + 8 | 0, 158936, 13) | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i13 >> 2] | 0) + 8 | 0, HEAP32[i10 + 40 >> 2] | 0) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i13 >> 2] | 0) + 8 | 0, 158952, 8) | 0;
 i1 = (HEAP32[i13 >> 2] | 0) + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i9, _strlen(i9 | 0) | 0) | 0;
 i1 = HEAP8[i15 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i15 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i15 + 8 >> 2] | 0;
  i1 = HEAP32[i15 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i13 >> 2] | 0) + 8 | 0, i2, i1) | 0;
 __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i12, i13);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 if (HEAP32[i13 >> 2] | 0) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i11 = HEAP32[i13 >> 2] | 0, (i11 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i11 >> 2] | 0) + 4 >> 2] & 511](i11);
  HEAP32[i13 >> 2] = 0;
 }
 __ZN7testing8internal12AssertHelperD2Ev(i12);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
 STACKTOP = i16;
 return;
}

function __ZN2cvL14MulTransposedRIhdEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d28) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d28 = +d28;
 var d4 = 0.0, d5 = 0.0, d6 = 0.0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, d30 = 0.0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i27 = i29;
 i25 = HEAP32[i3 + 16 >> 2] | 0;
 i18 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i26 = HEAP32[i3 + 48 >> 2] | 0;
 i24 = (HEAP32[i1 + 48 >> 2] | 0) >>> 3;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i9 = (HEAP32[i2 + 48 >> 2] | 0) >>> 3; else i9 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i20 = HEAP32[i3 + 40 >> 2] | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = i27 + 8 | 0;
 HEAP32[i27 >> 2] = i21;
 i22 = i27 + 4 | 0;
 HEAP32[i22 >> 2] = 1032;
 i3 = (i7 | 0) != 0;
 i2 = (i2 | 0) < (i19 | 0);
 if (i3 & i2) i1 = i20 * 40 | 0; else i1 = i20 << 3;
 if (i1 >>> 0 > 1032) {
  i23 = __Znaj(i1) | 0;
  HEAP32[i27 >> 2] = i23;
 } else i23 = i21;
 HEAP32[i22 >> 2] = i1;
 do if (i3) {
  if (i2) {
   i2 = i23 + (i20 << 3) | 0;
   if ((i20 | 0) > 0) {
    i3 = 0;
    do {
     d4 = +HEAPF64[i7 + ((Math_imul(i3, i9) | 0) << 3) >> 3];
     i16 = i3 << 2;
     HEAPF64[i23 + ((i16 | 3) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + ((i16 | 2) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + ((i16 | 1) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + (i16 + i20 << 3) >> 3] = d4;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if (!i2) {
    i17 = 14;
    break;
   } else {
    i7 = i2;
    i16 = i2;
    i9 = (i9 | 0) != 0 ? 4 : 0;
   }
  } else i16 = 0;
  if ((i19 | 0) > 0) {
   i11 = (i16 | 0) != 0;
   i13 = (i20 | 0) > 0;
   i12 = i19 + -4 | 0;
   i14 = 0;
   i15 = i18;
   while (1) {
    if (i11) {
     if (i13) {
      i3 = 0;
      do {
       d4 = +(HEAPU8[i25 + ((Math_imul(i3, i26) | 0) + i14) >> 0] | 0 | 0);
       HEAPF64[i23 + (i3 << 3) >> 3] = d4 - +HEAPF64[i16 + ((Math_imul(i3, i9) | 0) << 3) >> 3];
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i20 | 0));
     }
    } else if (i13) {
     i3 = 0;
     do {
      d4 = +(HEAPU8[i25 + ((Math_imul(i3, i26) | 0) + i14) >> 0] | 0 | 0);
      HEAPF64[i23 + (i3 << 3) >> 3] = d4 - +HEAPF64[i7 + ((Math_imul(i3, i9) | 0) + i14 << 3) >> 3];
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i20 | 0));
    }
    if ((i14 | 0) > (i12 | 0)) i3 = i14; else {
     i3 = i14;
     do {
      if (i11) i2 = i16; else i2 = i7 + (i3 << 3) | 0;
      if (i13) {
       i10 = 0;
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
       i1 = i25 + i3 | 0;
       while (1) {
        d30 = +HEAPF64[i23 + (i10 << 3) >> 3];
        d4 = d4 + d30 * (+(HEAPU8[i1 >> 0] | 0 | 0) - +HEAPF64[i2 >> 3]);
        d5 = d5 + d30 * (+(HEAPU8[i1 + 1 >> 0] | 0 | 0) - +HEAPF64[i2 + 8 >> 3]);
        d6 = d6 + d30 * (+(HEAPU8[i1 + 2 >> 0] | 0 | 0) - +HEAPF64[i2 + 16 >> 3]);
        d8 = d8 + d30 * (+(HEAPU8[i1 + 3 >> 0] | 0 | 0) - +HEAPF64[i2 + 24 >> 3]);
        i10 = i10 + 1 | 0;
        if ((i10 | 0) == (i20 | 0)) break; else {
         i2 = i2 + (i9 << 3) | 0;
         i1 = i1 + i26 | 0;
        }
       }
      } else {
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
      }
      HEAPF64[i15 + (i3 << 3) >> 3] = d4 * d28;
      HEAPF64[i15 + (i3 + 1 << 3) >> 3] = d5 * d28;
      HEAPF64[i15 + (i3 + 2 << 3) >> 3] = d6 * d28;
      HEAPF64[i15 + (i3 + 3 << 3) >> 3] = d8 * d28;
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i12 | 0));
    }
    if ((i3 | 0) < (i19 | 0)) do {
     if (i11) i2 = i16; else i2 = i7 + (i3 << 3) | 0;
     if (i13) {
      i1 = 0;
      d8 = 0.0;
      i10 = i25 + i3 | 0;
      while (1) {
       d8 = d8 + +HEAPF64[i23 + (i1 << 3) >> 3] * (+(HEAPU8[i10 >> 0] | 0 | 0) - +HEAPF64[i2 >> 3]);
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i20 | 0)) break; else {
        i2 = i2 + (i9 << 3) | 0;
        i10 = i10 + i26 | 0;
       }
      }
     } else d8 = 0.0;
     HEAPF64[i15 + (i3 << 3) >> 3] = d8 * d28;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i19 | 0));
    i14 = i14 + 1 | 0;
    if ((i14 | 0) == (i19 | 0)) break; else i15 = i15 + (i24 << 3) | 0;
   }
  }
 } else i17 = 14; while (0);
 if ((i17 | 0) == 14 ? (i19 | 0) > 0 : 0) {
  i11 = (i20 | 0) > 0;
  i12 = i19 + -4 | 0;
  i13 = 0;
  i10 = i18;
  while (1) {
   if (i11) {
    i3 = 0;
    do {
     HEAPF64[i23 + (i3 << 3) >> 3] = +(HEAPU8[i25 + ((Math_imul(i3, i26) | 0) + i13) >> 0] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if ((i13 | 0) > (i12 | 0)) i3 = i13; else {
    i3 = i13;
    do {
     if (i11) {
      i9 = 0;
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
      i7 = i25 + i3 | 0;
      while (1) {
       d30 = +HEAPF64[i23 + (i9 << 3) >> 3];
       d8 = d8 + d30 * +(HEAPU8[i7 >> 0] | 0 | 0);
       d6 = d6 + d30 * +(HEAPU8[i7 + 1 >> 0] | 0 | 0);
       d5 = d5 + d30 * +(HEAPU8[i7 + 2 >> 0] | 0 | 0);
       d4 = d4 + d30 * +(HEAPU8[i7 + 3 >> 0] | 0 | 0);
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == (i20 | 0)) break; else i7 = i7 + i26 | 0;
      }
     } else {
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
     }
     HEAPF64[i10 + (i3 << 3) >> 3] = d8 * d28;
     HEAPF64[i10 + (i3 + 1 << 3) >> 3] = d6 * d28;
     HEAPF64[i10 + (i3 + 2 << 3) >> 3] = d5 * d28;
     HEAPF64[i10 + (i3 + 3 << 3) >> 3] = d4 * d28;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i12 | 0));
   }
   if ((i3 | 0) < (i19 | 0)) do {
    if (i11) {
     i2 = 0;
     d4 = 0.0;
     i1 = i25 + i3 | 0;
     while (1) {
      d4 = d4 + +HEAPF64[i23 + (i2 << 3) >> 3] * +(HEAPU8[i1 >> 0] | 0 | 0);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break; else i1 = i1 + i26 | 0;
     }
    } else d4 = 0.0;
    HEAPF64[i10 + (i3 << 3) >> 3] = d4 * d28;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i19 | 0));
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i19 | 0)) break; else i10 = i10 + (i24 << 3) | 0;
  }
 }
 if ((i23 | 0) == (i21 | 0)) {
  STACKTOP = i29;
  return;
 }
 __ZdaPv(i23);
 HEAP32[i27 >> 2] = i21;
 HEAP32[i22 >> 2] = 1032;
 STACKTOP = i29;
 return;
}

function __ZN2cvL14MulTransposedRIddEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d28) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d28 = +d28;
 var d4 = 0.0, d5 = 0.0, d6 = 0.0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, d30 = 0.0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i27 = i29;
 i25 = HEAP32[i3 + 16 >> 2] | 0;
 i18 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i26 = (HEAP32[i3 + 48 >> 2] | 0) >>> 3;
 i24 = (HEAP32[i1 + 48 >> 2] | 0) >>> 3;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i9 = (HEAP32[i2 + 48 >> 2] | 0) >>> 3; else i9 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i20 = HEAP32[i3 + 40 >> 2] | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = i27 + 8 | 0;
 HEAP32[i27 >> 2] = i21;
 i22 = i27 + 4 | 0;
 HEAP32[i22 >> 2] = 1032;
 i3 = (i7 | 0) != 0;
 i2 = (i2 | 0) < (i19 | 0);
 if (i3 & i2) i1 = i20 * 40 | 0; else i1 = i20 << 3;
 if (i1 >>> 0 > 1032) {
  i23 = __Znaj(i1) | 0;
  HEAP32[i27 >> 2] = i23;
 } else i23 = i21;
 HEAP32[i22 >> 2] = i1;
 do if (i3) {
  if (i2) {
   i2 = i23 + (i20 << 3) | 0;
   if ((i20 | 0) > 0) {
    i3 = 0;
    do {
     d4 = +HEAPF64[i7 + ((Math_imul(i3, i9) | 0) << 3) >> 3];
     i16 = i3 << 2;
     HEAPF64[i23 + ((i16 | 3) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + ((i16 | 2) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + ((i16 | 1) + i20 << 3) >> 3] = d4;
     HEAPF64[i23 + (i16 + i20 << 3) >> 3] = d4;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if (!i2) {
    i17 = 14;
    break;
   } else {
    i7 = i2;
    i16 = i2;
    i9 = (i9 | 0) != 0 ? 4 : 0;
   }
  } else i16 = 0;
  if ((i19 | 0) > 0) {
   i11 = (i16 | 0) != 0;
   i13 = (i20 | 0) > 0;
   i12 = i19 + -4 | 0;
   i14 = 0;
   i15 = i18;
   while (1) {
    if (i11) {
     if (i13) {
      i3 = 0;
      do {
       d4 = +HEAPF64[i25 + ((Math_imul(i3, i26) | 0) + i14 << 3) >> 3];
       HEAPF64[i23 + (i3 << 3) >> 3] = d4 - +HEAPF64[i16 + ((Math_imul(i3, i9) | 0) << 3) >> 3];
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i20 | 0));
     }
    } else if (i13) {
     i3 = 0;
     do {
      d4 = +HEAPF64[i25 + ((Math_imul(i3, i26) | 0) + i14 << 3) >> 3];
      HEAPF64[i23 + (i3 << 3) >> 3] = d4 - +HEAPF64[i7 + ((Math_imul(i3, i9) | 0) + i14 << 3) >> 3];
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i20 | 0));
    }
    if ((i14 | 0) > (i12 | 0)) i3 = i14; else {
     i3 = i14;
     do {
      if (i11) i2 = i16; else i2 = i7 + (i3 << 3) | 0;
      if (i13) {
       i10 = 0;
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
       i1 = i25 + (i3 << 3) | 0;
       while (1) {
        d30 = +HEAPF64[i23 + (i10 << 3) >> 3];
        d4 = d4 + d30 * (+HEAPF64[i1 >> 3] - +HEAPF64[i2 >> 3]);
        d5 = d5 + d30 * (+HEAPF64[i1 + 8 >> 3] - +HEAPF64[i2 + 8 >> 3]);
        d6 = d6 + d30 * (+HEAPF64[i1 + 16 >> 3] - +HEAPF64[i2 + 16 >> 3]);
        d8 = d8 + d30 * (+HEAPF64[i1 + 24 >> 3] - +HEAPF64[i2 + 24 >> 3]);
        i10 = i10 + 1 | 0;
        if ((i10 | 0) == (i20 | 0)) break; else {
         i2 = i2 + (i9 << 3) | 0;
         i1 = i1 + (i26 << 3) | 0;
        }
       }
      } else {
       d4 = 0.0;
       d5 = 0.0;
       d6 = 0.0;
       d8 = 0.0;
      }
      HEAPF64[i15 + (i3 << 3) >> 3] = d4 * d28;
      HEAPF64[i15 + (i3 + 1 << 3) >> 3] = d5 * d28;
      HEAPF64[i15 + (i3 + 2 << 3) >> 3] = d6 * d28;
      HEAPF64[i15 + (i3 + 3 << 3) >> 3] = d8 * d28;
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i12 | 0));
    }
    if ((i3 | 0) < (i19 | 0)) do {
     if (i11) i2 = i16; else i2 = i7 + (i3 << 3) | 0;
     if (i13) {
      i1 = 0;
      d8 = 0.0;
      i10 = i25 + (i3 << 3) | 0;
      while (1) {
       d8 = d8 + +HEAPF64[i23 + (i1 << 3) >> 3] * (+HEAPF64[i10 >> 3] - +HEAPF64[i2 >> 3]);
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i20 | 0)) break; else {
        i2 = i2 + (i9 << 3) | 0;
        i10 = i10 + (i26 << 3) | 0;
       }
      }
     } else d8 = 0.0;
     HEAPF64[i15 + (i3 << 3) >> 3] = d8 * d28;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i19 | 0));
    i14 = i14 + 1 | 0;
    if ((i14 | 0) == (i19 | 0)) break; else i15 = i15 + (i24 << 3) | 0;
   }
  }
 } else i17 = 14; while (0);
 if ((i17 | 0) == 14 ? (i19 | 0) > 0 : 0) {
  i11 = (i20 | 0) > 0;
  i12 = i19 + -4 | 0;
  i13 = 0;
  i10 = i18;
  while (1) {
   if (i11) {
    i3 = 0;
    do {
     HEAPF64[i23 + (i3 << 3) >> 3] = +HEAPF64[i25 + ((Math_imul(i3, i26) | 0) + i13 << 3) >> 3];
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   }
   if ((i13 | 0) > (i12 | 0)) i3 = i13; else {
    i3 = i13;
    do {
     if (i11) {
      i9 = 0;
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
      i7 = i25 + (i3 << 3) | 0;
      while (1) {
       d30 = +HEAPF64[i23 + (i9 << 3) >> 3];
       d8 = d8 + d30 * +HEAPF64[i7 >> 3];
       d6 = d6 + d30 * +HEAPF64[i7 + 8 >> 3];
       d5 = d5 + d30 * +HEAPF64[i7 + 16 >> 3];
       d4 = d4 + d30 * +HEAPF64[i7 + 24 >> 3];
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == (i20 | 0)) break; else i7 = i7 + (i26 << 3) | 0;
      }
     } else {
      d8 = 0.0;
      d6 = 0.0;
      d5 = 0.0;
      d4 = 0.0;
     }
     HEAPF64[i10 + (i3 << 3) >> 3] = d8 * d28;
     HEAPF64[i10 + (i3 + 1 << 3) >> 3] = d6 * d28;
     HEAPF64[i10 + (i3 + 2 << 3) >> 3] = d5 * d28;
     HEAPF64[i10 + (i3 + 3 << 3) >> 3] = d4 * d28;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i12 | 0));
   }
   if ((i3 | 0) < (i19 | 0)) do {
    if (i11) {
     i2 = 0;
     d4 = 0.0;
     i1 = i25 + (i3 << 3) | 0;
     while (1) {
      d4 = d4 + +HEAPF64[i23 + (i2 << 3) >> 3] * +HEAPF64[i1 >> 3];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break; else i1 = i1 + (i26 << 3) | 0;
     }
    } else d4 = 0.0;
    HEAPF64[i10 + (i3 << 3) >> 3] = d4 * d28;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i19 | 0));
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i19 | 0)) break; else i10 = i10 + (i24 << 3) | 0;
  }
 }
 if ((i23 | 0) == (i21 | 0)) {
  STACKTOP = i29;
  return;
 }
 __ZdaPv(i23);
 HEAP32[i27 >> 2] = i21;
 HEAP32[i22 >> 2] = 1032;
 STACKTOP = i29;
 return;
}

function __ZN7testing8internal25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE13RegisterTestsEv(i31) {
 i31 = i31 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i29 = i32 + 72 | 0;
 i27 = i32 + 64 | 0;
 i28 = i32 + 52 | 0;
 i9 = i32 + 40 | 0;
 i30 = i32 + 36 | 0;
 i10 = i32 + 24 | 0;
 i22 = i32 + 12 | 0;
 i24 = i32;
 i1 = HEAP32[i31 + 16 >> 2] | 0;
 i25 = i31 + 20 | 0;
 if ((i1 | 0) == (HEAP32[i25 >> 2] | 0)) {
  STACKTOP = i32;
  return;
 }
 i26 = i29 + 4 | 0;
 i11 = i31 + 28 | 0;
 i12 = i31 + 32 | 0;
 i13 = i28 + 1 | 0;
 i14 = i10 + 1 | 0;
 i15 = i22 + 1 | 0;
 i16 = i24 + 4 | 0;
 i18 = i24 + 8 | 0;
 i19 = i22 + 8 | 0;
 i20 = i10 + 8 | 0;
 i21 = i28 + 8 | 0;
 i23 = i27 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i29 >> 2] = i2;
  if (!i2) i2 = i26; else {
   i2 = i1 + 4 | 0;
   i4 = i2;
   while (1) {
    i3 = HEAP32[i4 >> 2] | 0;
    if ((i3 | 0) == (i2 | 0)) break; else i4 = i3;
   }
   HEAP32[i4 >> 2] = i26;
  }
  HEAP32[i26 >> 2] = i2;
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) != (HEAP32[i12 >> 2] | 0)) do {
   FUNCTION_TABLE_vi[HEAP32[i2 + 12 >> 2] & 511](i27);
   HEAP32[i28 + 0 >> 2] = 0;
   HEAP32[i28 + 4 >> 2] = 0;
   HEAP32[i28 + 8 >> 2] = 0;
   i3 = HEAP8[i2 >> 0] | 0;
   if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (i3) {
    HEAP32[i9 + 0 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    HEAP32[i9 + 8 >> 2] = 0;
    i3 = HEAP8[i2 >> 0] | 0;
    if (!(i3 & 1)) {
     i3 = (i3 & 255) >>> 1;
     i4 = i2 + 1 | 0;
    } else {
     i3 = HEAP32[i2 + 4 >> 2] | 0;
     i4 = HEAP32[i2 + 8 >> 2] | 0;
    }
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, i4, i3, i3 + 1 | 0);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, 2600, 1) | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i28, i9) | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
   }
   i4 = HEAP32[i29 >> 2] | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 & 1)) {
    i5 = i4 + 1 | 0;
    i4 = (i3 & 255) >>> 1;
   } else {
    i5 = HEAP32[i4 + 8 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i28, i5, i4) | 0;
   i8 = HEAP32[i27 >> 2] | 0;
   i8 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] & 127](i8) | 0;
   i7 = 0;
   while (1) {
    i4 = HEAP32[i27 >> 2] | 0;
    i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4) | 0;
    if ((i8 | 0) == (i4 | 0)) i5 = 0; else i5 = (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8, i4) | 0) ^ 1;
    if ((i4 | 0) != 0 ? __ZN7testing8internal6IsTrueEb(1) | 0 : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 511](i4);
    if (!i5) break;
    __ZN7testing7MessageC2Ev(i30);
    i3 = HEAP32[i29 >> 2] | 0;
    i5 = i3 + 12 | 0;
    i6 = HEAP8[i5 >> 0] | 0;
    if (!(i6 & 1)) {
     i4 = i5 + 1 | 0;
     i5 = (i6 & 255) >>> 1;
    } else {
     i4 = HEAP32[i3 + 20 >> 2] | 0;
     i5 = HEAP32[i3 + 16 >> 2] | 0;
    }
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i30 >> 2] | 0) + 8 | 0, i4, i5) | 0;
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i30 >> 2] | 0) + 8 | 0, 2600, 1) | 0;
    __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi((HEAP32[i30 >> 2] | 0) + 8 | 0, i7) | 0;
    i34 = (HEAP8[i28 >> 0] & 1) == 0 ? i13 : HEAP32[i21 >> 2] | 0;
    __ZNK7testing7Message9GetStringEv(i10, i30);
    i33 = (HEAP8[i10 >> 0] & 1) == 0 ? i14 : HEAP32[i20 >> 2] | 0;
    __ZN7testing13PrintToStringINSt3tr15tupleIN2cv5Size_IiEEN4perf7MatTypeEvvvvvvvvEEEENSt3__112basic_stringIcNS9_11char_traitsIcEENS9_9allocatorIcEEEERKT_(i22, FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] & 127](i8) | 0);
    i6 = (HEAP8[i22 >> 0] & 1) == 0 ? i15 : HEAP32[i19 >> 2] | 0;
    i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i31 >> 2] | 0) + 12 >> 2] & 127](i31) | 0;
    i3 = HEAP32[(HEAP32[i29 >> 2] | 0) + 24 >> 2] | 0;
    i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
    i35 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] & 127](i8) | 0;
    HEAP32[i24 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i16 >> 2] = HEAP32[i35 + 4 >> 2];
    HEAP32[i18 >> 2] = HEAP32[i35 + 8 >> 2];
    __ZN7testing8internal23MakeAndRegisterTestInfoEPKcS2_S2_S2_PKvPFvvES6_PNS0_15TestFactoryBaseE(i34, i33, 0, i6, i5, 3, 4, FUNCTION_TABLE_iii[i4 & 127](i3, i24) | 0) | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
    if (HEAP32[i30 >> 2] | 0) {
     if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i17 = HEAP32[i30 >> 2] | 0, (i17 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i17 >> 2] | 0) + 4 >> 2] & 511](i17);
     HEAP32[i30 >> 2] = 0;
    }
    FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] & 511](i8);
    i7 = i7 + 1 | 0;
   }
   if ((i8 | 0) != 0 ? __ZN7testing8internal6IsTrueEb(1) | 0 : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] & 511](i8);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i28);
   i4 = HEAP32[i23 >> 2] | 0;
   if ((i4 | 0) == (i23 | 0)) {
    i3 = HEAP32[i27 >> 2] | 0;
    if (i3) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
   } else {
    i5 = i4;
    while (1) {
     i3 = HEAP32[i5 >> 2] | 0;
     if ((i3 | 0) == (i23 | 0)) break; else i5 = i3;
    }
    HEAP32[i5 >> 2] = i4;
   }
   i2 = i2 + 16 | 0;
  } while ((i2 | 0) != (HEAP32[i12 >> 2] | 0));
  __ZN7testing8internal10linked_ptrINS0_25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE8TestInfoEED2Ev(i29);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (HEAP32[i25 >> 2] | 0));
 STACKTOP = i32;
 return;
}

function __ZN7testing8UnitTest17AddTestPartResultENS_14TestPartResult4TypeEPKciRKNSt3__112basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEESD_(i1, i19, i16, i17, i3, i12) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i20 = i23 + 72 | 0;
 i21 = i23 + 68 | 0;
 i9 = i23 + 56 | 0;
 i22 = i23 + 12 | 0;
 i18 = i23;
 __ZN7testing7MessageC2Ev(i21);
 i13 = HEAP32[i21 >> 2] | 0;
 i14 = i13 + 8 | 0;
 i4 = HEAP8[i3 >> 0] | 0;
 if (!(i4 & 1)) {
  i2 = i3 + 1 | 0;
  i4 = (i4 & 255) >>> 1;
 } else {
  i2 = HEAP32[i3 + 8 >> 2] | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, i2, i4) | 0;
 i15 = i1 + 8 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 L5 : do if ((HEAP32[i1 + 204 >> 2] | 0) != (HEAP32[i1 + 200 >> 2] | 0)) {
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, 160800, 1) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, 162208, 11) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, 163752, 7) | 0;
  i4 = HEAP32[i15 >> 2] | 0;
  i6 = i9 + 1 | 0;
  i7 = i9 + 8 | 0;
  i8 = i9 + 4 | 0;
  i4 = ((HEAP32[i4 + 204 >> 2] | 0) - (HEAP32[i4 + 200 >> 2] | 0) | 0) / 20 | 0;
  while (1) {
   if ((i4 | 0) <= 0) break L5;
   i4 = i4 + -1 | 0;
   i5 = HEAP32[(HEAP32[i15 >> 2] | 0) + 200 >> 2] | 0;
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, 160800, 1) | 0;
   __ZN7testing8internal18FormatFileLocationEPKci(i9, HEAP32[i5 + (i4 * 20 | 0) >> 2] | 0, HEAP32[i5 + (i4 * 20 | 0) + 4 >> 2] | 0);
   i3 = HEAP8[i9 >> 0] | 0;
   if (!(i3 & 1)) {
    i2 = i6;
    i3 = (i3 & 255) >>> 1;
   } else {
    i2 = HEAP32[i7 >> 2] | 0;
    i3 = HEAP32[i8 >> 2] | 0;
   }
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, i2, i3) | 0;
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, 163296, 1) | 0;
   i3 = i5 + (i4 * 20 | 0) + 8 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 & 1)) {
    i1 = i3 + 1 | 0;
    i3 = (i2 & 255) >>> 1;
   } else {
    i1 = HEAP32[i5 + (i4 * 20 | 0) + 16 >> 2] | 0;
    i3 = HEAP32[i5 + (i4 * 20 | 0) + 12 >> 2] | 0;
   }
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, i1, i3) | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
  }
 } while (0);
 i4 = HEAP8[i12 >> 0] | 0;
 if (i4 & 1) {
  if (HEAP32[i12 + 8 >> 2] | 0) {
   i10 = HEAP32[i12 + 4 >> 2] | 0;
   i11 = 18;
  }
 } else {
  i10 = (i4 & 255) >>> 1;
  i11 = 18;
 }
 if ((i11 | 0) == 18 ? (i10 | 0) != 0 : 0) {
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, 159728, 14) | 0;
  i4 = HEAP8[i12 >> 0] | 0;
  if (!(i4 & 1)) {
   i3 = i12 + 1 | 0;
   i4 = (i4 & 255) >>> 1;
  } else {
   i3 = HEAP32[i12 + 8 >> 2] | 0;
   i4 = HEAP32[i12 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, i3, i4) | 0;
 }
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i20, i13 + 12 | 0);
 i2 = HEAP8[i20 >> 0] | 0;
 if (!(i2 & 1)) {
  i1 = i20 + 1 | 0;
  i2 = (i2 & 255) >>> 1;
 } else {
  i1 = HEAP32[i20 + 8 >> 2] | 0;
  i2 = HEAP32[i20 + 4 >> 2] | 0;
 }
 i4 = i1 + i2 | 0;
 HEAP32[i18 + 0 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i18, i2 << 1);
 if (i2) do {
  i2 = HEAP8[i1 >> 0] | 0;
  if (!(i2 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i18, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i18, i2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
 if (!(HEAP8[i18 >> 0] & 1)) i4 = i18 + 1 | 0; else i4 = HEAP32[i18 + 8 >> 2] | 0;
 HEAP32[i22 >> 2] = i19;
 i3 = i22 + 4 | 0;
 i1 = (i16 | 0) == 0 ? 159968 : i16;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i1, _strlen(i1 | 0) | 0);
 HEAP32[i22 + 16 >> 2] = i17;
 i1 = i22 + 20 | 0;
 __ZN7testing14TestPartResult14ExtractSummaryEPKc(i1, i4);
 i2 = i22 + 32 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i4, _strlen(i4 | 0) | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i18);
 i18 = HEAP32[(HEAP32[i15 >> 2] | 0) + 44 >> 2] | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2] & 127](i18, i22);
 do if (i19) {
  if (HEAP8[159784] | 0) {
   HEAP32[0] = 1;
   abort();
  }
  if (HEAP8[160128] | 0) {
   i1 = ___cxa_allocate_exception(8) | 0;
   __ZN7testing8internalL27PrintTestPartResultToStringERKNS_14TestPartResultE(i20, i22);
   if (!(HEAP8[i20 >> 0] & 1)) {
    i22 = i20 + 1 | 0;
    __ZNSt13runtime_errorC2EPKc(i1, i22);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
    HEAP32[i1 >> 2] = 161488;
    ___cxa_throw(i1 | 0, 163808, 128);
   } else {
    i22 = HEAP32[i20 + 8 >> 2] | 0;
    __ZNSt13runtime_errorC2EPKc(i1, i22);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
    HEAP32[i1 >> 2] = 161488;
    ___cxa_throw(i1 | 0, 163808, 128);
   }
  }
 } while (0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
 i1 = HEAP32[i21 >> 2] | 0;
 if (!i1) {
  STACKTOP = i23;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 HEAP32[i21 >> 2] = 0;
 STACKTOP = i23;
 return;
}

function __ZN4perf8TestBase11calcMetricsEv(i18) {
 i18 = i18 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, d6 = 0.0, d7 = 0.0, d8 = 0.0, i9 = 0, d10 = 0.0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, d15 = 0.0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, d22 = 0.0, d23 = 0.0, d24 = 0.0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i13 = i19;
 i5 = i19 + 8 | 0;
 i17 = i18 + 96 | 0;
 i12 = i18 + 104 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i14 = i18 + 80 | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i5, 44) | 0) + 0 | 0;
  i3 = 174472 | 0;
  i2 = i4 + 44 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i4 | 0) < (i2 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 174520, 170184, 1289);
  __ZN2cv6String10deallocateEv(i5);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i14 >> 2] | 0;
 }
 if ((i3 | 0) == (i4 | 0)) {
  STACKTOP = i19;
  return i17 | 0;
 }
 i9 = i18 + 40 | 0;
 i11 = i18 + 36 | 0;
 if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i11 >> 2] | 0)) {
  STACKTOP = i19;
  return i17 | 0;
 }
 i4 = HEAP32[i18 + 8 >> 2] | 0;
 i3 = HEAP32[i18 + 12 >> 2] | 0;
 if ((i4 | 0) == (i3 | 0)) i4 = 0; else {
  i5 = i4;
  i4 = 0;
  do {
   i4 = (HEAP32[i5 >> 2] | 0) + i4 | 0;
   i5 = i5 + 12 | 0;
  } while ((i5 | 0) != (i3 | 0));
 }
 HEAP32[i17 >> 2] = i4;
 i4 = HEAP32[i18 + 20 >> 2] | 0;
 i3 = HEAP32[i18 + 24 >> 2] | 0;
 if ((i4 | 0) == (i3 | 0)) i4 = 0; else {
  i5 = i4;
  i4 = 0;
  do {
   i4 = (HEAP32[i5 >> 2] | 0) + i4 | 0;
   i5 = i5 + 12 | 0;
  } while ((i5 | 0) != (i3 | 0));
 }
 HEAP32[i18 + 100 >> 2] = i4;
 HEAPF64[i18 + 160 >> 3] = +__ZN2cv16getTickFrequencyEv();
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 >> 2] = i4 - i3 >> 3;
 i12 = i18 + 108 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i18 + 168 | 0;
 do if ((HEAP32[i5 >> 2] & -2 | 0) != 2) {
  if ((HEAP32[i14 >> 2] | 0) == (HEAP32[i18 + 76 >> 2] | 0)) {
   HEAP32[i5 >> 2] = 0;
   break;
  }
  i2 = i18 + 56 | 0;
  i21 = HEAP32[i2 + 4 >> 2] | 0;
  i14 = i18 + 64 | 0;
  i20 = HEAP32[i14 + 4 >> 2] | 0;
  if ((i21 | 0) < (i20 | 0) | ((i21 | 0) == (i20 | 0) ? (HEAP32[i2 >> 2] | 0) >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0 : 0)) {
   HEAP32[i5 >> 2] = -1;
   break;
  } else {
   HEAP32[i5 >> 2] = 1;
   break;
  }
 } while (0);
 __ZNSt3__16__sortIRNS_6__lessIxxEEPxEEvT0_S5_T_(i3, i4, i13);
 i13 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[43316] | 0;
 i3 = (i2 | 0) == -1;
 if (i3) {
  i4 = HEAP32[i18 + 32 >> 2] | 0;
  i4 = (i4 | 0) == -1 ? HEAP32[43474] | 0 : i4;
 } else i4 = i2;
 if (!i4) if ((i13 | 0) != (i11 | 0)) {
  d8 = +((HEAP32[i18 + 84 >> 2] | 0) >>> 0);
  i4 = i13;
  d7 = 0.0;
  d6 = 0.0;
  i5 = 0;
  do {
   i9 = i4;
   d1 = (+((HEAP32[i9 >> 2] | 0) >>> 0) + 4294967296.0 * +(HEAP32[i9 + 4 >> 2] | 0)) / d8;
   if (!(d1 < 2.220446049250313e-16)) {
    d10 = +Math_log(+d1);
    i5 = i5 + 1 | 0;
    d22 = d10 - d7;
    d1 = d7 + d22 / +(i5 | 0);
    d7 = d1;
    d6 = d6 + d22 * (d10 - d1);
   }
   i4 = i4 + 8 | 0;
  } while ((i4 | 0) != (i11 | 0));
  if ((i5 | 0) > 1 ? (d15 = +Math_sqrt(+(d6 / +(i5 + -1 | 0))), d15 > 2.220446049250313e-16) : 0) {
   d8 = d15 * 3.0;
   d1 = +Math_exp(+(d7 - d8));
   d6 = +((HEAP32[i18 + 84 >> 2] | 0) >>> 0);
   d1 = d1 * d6;
   d7 = +Math_exp(+(d7 + d8)) * d6;
   i9 = i13;
   i4 = HEAP32[i12 >> 2] | 0;
   if (+((HEAP32[i9 >> 2] | 0) >>> 0) + 4294967296.0 * +(HEAP32[i9 + 4 >> 2] | 0) < d1) {
    i3 = i13;
    do {
     i3 = i3 + 8 | 0;
     i4 = i4 + 1 | 0;
     i9 = i3;
    } while (+((HEAP32[i9 >> 2] | 0) >>> 0) + 4294967296.0 * +(HEAP32[i9 + 4 >> 2] | 0) < d1);
    HEAP32[i12 >> 2] = i4;
    i5 = i3;
   } else i5 = i13;
   i2 = i11;
   while (1) {
    i3 = i2 + -8 | 0;
    i11 = i3;
    if (+((HEAP32[i11 >> 2] | 0) >>> 0) + 4294967296.0 * +(HEAP32[i11 + 4 >> 2] | 0) > d7) {
     i2 = i3;
     i4 = i4 + 1 | 0;
    } else break;
   }
   HEAP32[i12 >> 2] = i4;
   i9 = i5;
  } else {
   i9 = i13;
   i2 = i11;
  }
 } else {
  i9 = i13;
  i2 = i11;
 } else {
  if (i3) {
   i2 = HEAP32[i18 + 32 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? HEAP32[43474] | 0 : i2;
  }
  if ((i2 | 0) == 1 ? (i16 = ~~(+HEAPF64[21666] * +(i11 - i13 >> 3 >>> 0) / 100.0), HEAP32[i12 >> 2] = i16, (i16 | 0) != 0) : 0) {
   i9 = i13;
   i2 = i11 + ((i16 >>> 0 > 1 ? 0 - i16 | 0 : -1) << 3) | 0;
  } else {
   i9 = i13;
   i2 = i11;
  }
 }
 i4 = i9;
 i14 = i4 - i13 >> 3;
 i3 = i9;
 i5 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 d15 = +((HEAP32[i18 + 84 >> 2] | 0) >>> 0);
 HEAPF64[i18 + 152 >> 3] = (+(i5 >>> 0) + 4294967296.0 * +(i3 | 0)) / d15;
 if ((i9 | 0) == (i2 | 0)) {
  d7 = 0.0;
  d8 = 0.0;
  i5 = 0;
  d1 = 0.0;
  i9 = 0;
  d6 = 0.0;
 } else {
  i12 = (i2 + -8 - i4 | 0) >>> 3;
  d7 = 0.0;
  d8 = 0.0;
  i4 = 0;
  d1 = 0.0;
  i11 = 1;
  d6 = 0.0;
  while (1) {
   d10 = (+(i5 >>> 0) + 4294967296.0 * +(i3 | 0)) / d15;
   if (d10 > 2.220446049250313e-16) {
    d23 = +Math_log(+d10);
    i4 = i4 + 1 | 0;
    d24 = d23 - d7;
    d22 = d7 + d24 / +(i4 >>> 0);
    d7 = d22;
    d8 = d8 + d24 * (d23 - d22);
   }
   d23 = d10 - d1;
   d1 = d1 + d23 / +(i11 >>> 0);
   d6 = d6 + d23 * (d10 - d1);
   i9 = i9 + 8 | 0;
   if ((i9 | 0) == (i2 | 0)) break;
   i5 = i9;
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   i5 = HEAP32[i5 >> 2] | 0;
   i11 = i11 + 1 | 0;
  }
  i5 = i4;
  i9 = i12 + 1 | 0;
 }
 HEAPF64[i18 + 128 >> 3] = d1;
 HEAPF64[i18 + 112 >> 3] = +Math_exp(+d7);
 if (i5 >>> 0 > 1) d1 = +Math_sqrt(+(d8 / +((i5 + -1 | 0) >>> 0))); else d1 = 0.0;
 HEAPF64[i18 + 120 >> 3] = d1;
 if (i9 >>> 0 > 1) d1 = +Math_sqrt(+(d6 / +((i9 + -1 | 0) >>> 0))); else d1 = 0.0;
 HEAPF64[i18 + 136 >> 3] = d1;
 i2 = (i9 >>> 1) + i14 | 0;
 i4 = i13 + (i2 << 3) | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!(i9 & 1)) {
  i12 = i13 + (i2 + -1 << 3) | 0;
  i12 = _i64Add(HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, i3 | 0, i4 | 0) | 0;
  d1 = (+(i12 >>> 0) + 4294967296.0 * +(tempRet0 | 0)) * .5;
 } else d1 = +(i3 >>> 0) + 4294967296.0 * +(i4 | 0);
 HEAPF64[i18 + 144 >> 3] = d1 / d15;
 STACKTOP = i19;
 return i17 | 0;
}

function __ZN2cv8scaleAddERKNS_11_InputArrayEdS2_RKNS_12_OutputArrayE(i4, d5, i3, i12) {
 i4 = i4 | 0;
 d5 = +d5;
 i3 = i3 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 i8 = i24;
 i6 = i24 + 256 | 0;
 i23 = i24 + 200 | 0;
 i22 = i24 + 144 | 0;
 i9 = i24 + 136 | 0;
 i20 = i24 + 80 | 0;
 i13 = i24 + 72 | 0;
 i14 = i24 + 56 | 0;
 i17 = i24 + 40 | 0;
 i16 = i24 + 8 | 0;
 HEAPF64[i8 >> 3] = d5;
 i10 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] & 127](i4, -1) | 0;
 i11 = i10 & 7;
 i15 = (i10 >>> 3 & 511) + 1 | 0;
 if ((i10 | 0) != (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] & 127](i3, -1) | 0)) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i6, 20) | 0) + 0 | 0;
  i1 = 37568 | 0;
  i7 = i2 + 20 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i6, 37592, 37256, 2307);
  __ZN2cv6String10deallocateEv(i6);
 }
 if (i11 >>> 0 < 5) {
  __ZN2cv11addWeightedERKNS_11_InputArrayEdS2_ddRKNS_12_OutputArrayEi(i4, +HEAPF64[i8 >> 3], i3, 1.0, 0.0, i12, i11);
  STACKTOP = i24;
  return;
 }
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i4 >> 2] >> 2] & 63](i23, i4, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i3 >> 2] >> 2] & 63](i22, i3, -1);
 i21 = i23 + 40 | 0;
 i6 = HEAP32[i21 >> 2] | 0;
 i4 = HEAP32[i6 + -4 >> 2] | 0;
 i19 = i22 + 40 | 0;
 i3 = HEAP32[i19 >> 2] | 0;
 L8 : do if ((i4 | 0) == (HEAP32[i3 + -4 >> 2] | 0)) {
  if ((i4 | 0) == 2) {
   if ((HEAP32[i6 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) {
    i18 = 12;
    break;
   }
   if ((HEAP32[i6 + 4 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) break; else {
    i18 = 12;
    break;
   }
  }
  if ((i4 | 0) > 0) {
   i2 = 0;
   do {
    if ((HEAP32[i6 + (i2 << 2) >> 2] | 0) != (HEAP32[i3 + (i2 << 2) >> 2] | 0)) {
     i18 = 12;
     break L8;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
  }
 } else i18 = 12; while (0);
 if ((i18 | 0) == 12) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i9, 22) | 0) + 0 | 0;
  i1 = 37608 | 0;
  i7 = i2 + 22 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i9, 37592, 37256, 2319);
  __ZN2cv6String10deallocateEv(i9);
  i6 = HEAP32[i21 >> 2] | 0;
 }
 i9 = i23 + 4 | 0;
 FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i12 >> 2] | 0) + 144 >> 2] & 63](i12, HEAP32[i9 >> 2] | 0, i6, i10, -1, 0, 0);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i12 >> 2] >> 2] & 63](i20, i12, -1);
 HEAPF32[i13 >> 2] = Math_fround(+HEAPF64[i8 >> 3]);
 i3 = (i11 | 0) == 5;
 if (i3) i8 = i13;
 i7 = i3 ? 28 : 27;
 if (((HEAP32[i23 >> 2] & 16384 | 0) != 0 ? (HEAP32[i22 >> 2] & 16384 | 0) != 0 : 0) ? (HEAP32[i20 >> 2] & 16384 | 0) != 0 : 0) {
  i2 = HEAP32[i9 >> 2] | 0;
  if ((i2 | 0) < 3) i3 = Math_imul(HEAP32[i23 + 12 >> 2] | 0, HEAP32[i23 + 8 >> 2] | 0) | 0; else {
   i1 = HEAP32[i21 >> 2] | 0;
   i6 = 0;
   i3 = 1;
   do {
    i3 = Math_imul(HEAP32[i1 + (i6 << 2) >> 2] | 0, i3) | 0;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i2 | 0));
  }
  i17 = Math_imul(i3, i15) | 0;
  FUNCTION_TABLE_viiiii[i7 & 31](HEAP32[i23 + 16 >> 2] | 0, HEAP32[i22 + 16 >> 2] | 0, HEAP32[i20 + 16 >> 2] | 0, i17, i8);
 } else i18 = 24;
 L34 : do if ((i18 | 0) == 24) {
  HEAP32[i14 >> 2] = i23;
  HEAP32[i14 + 4 >> 2] = i22;
  HEAP32[i14 + 8 >> 2] = i20;
  HEAP32[i14 + 12 >> 2] = 0;
  __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i16, i14, i17, -1);
  i1 = Math_imul(HEAP32[i16 + 20 >> 2] | 0, i15) | 0;
  i4 = i16 + 16 | 0;
  i3 = i17 + 4 | 0;
  i2 = i17 + 8 | 0;
  i6 = 0;
  while (1) {
   if (i6 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) break L34;
   FUNCTION_TABLE_viiiii[i7 & 31](HEAP32[i17 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] | 0, i1, i8);
   __ZN2cv15NAryMatIteratorppEv(i16) | 0;
   i6 = i6 + 1 | 0;
  }
 } while (0);
 i2 = i20 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i17 = i1 + 12 | 0, i18 = HEAP32[i17 >> 2] | 0, HEAP32[i17 >> 2] = i18 + -1, (i18 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i20);
 HEAP32[i2 >> 2] = 0;
 i18 = i20 + 16 | 0;
 i3 = i20 + 4 | 0;
 HEAP32[i18 + 0 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i20 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i2 = HEAP32[i20 + 44 >> 2] | 0;
 if ((i2 | 0) != (i20 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i22 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i18 = i1 + 12 | 0, i20 = HEAP32[i18 >> 2] | 0, HEAP32[i18 >> 2] = i20 + -1, (i20 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i22);
 HEAP32[i2 >> 2] = 0;
 i20 = i22 + 16 | 0;
 i3 = i22 + 4 | 0;
 HEAP32[i20 + 0 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i19 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i2 = HEAP32[i22 + 44 >> 2] | 0;
 if ((i2 | 0) != (i22 + 48 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i23 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i20 = i1 + 12 | 0, i22 = HEAP32[i20 >> 2] | 0, HEAP32[i20 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i23);
 HEAP32[i2 >> 2] = 0;
 i22 = i23 + 16 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i9 >> 2] | 0) > 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i9 >> 2] | 0));
 }
 i1 = HEAP32[i23 + 44 >> 2] | 0;
 if ((i1 | 0) == (i23 + 48 | 0)) {
  STACKTOP = i24;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i24;
 return;
}

function __ZN2cvL6SVBkSbEiiPKfjS1_jbS1_jbS1_jiPfjPh(i31, i32, i33, i1, i14, i2, i8, i12, i3, i30, i4, i9, i34, i5, i6) {
 i31 = i31 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i30 = i30 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i34 = i34 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var d7 = 0.0, i10 = 0, f11 = f0, d13 = 0.0, i15 = 0, i16 = 0, d17 = 0.0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i35 = 0, i36 = 0, i37 = 0, d38 = 0.0, i39 = 0, f40 = f0, f41 = f0;
 i35 = STACKTOP;
 i29 = (i1 | 0) == 0 ? 1 : i1 >>> 2;
 i21 = i2 >>> 2;
 i28 = i3 >>> 2;
 i27 = i4 >>> 2;
 i26 = i5 >>> 2;
 i25 = i6 + 7 & -8;
 i24 = i25;
 i23 = i8 ? i21 : 1;
 i21 = i8 ? 1 : i21;
 i5 = (i32 | 0) < (i31 | 0) ? i32 : i31;
 i22 = (i30 | 0) != 0;
 i20 = i22 ? i9 : i31;
 i19 = (i32 | 0) > 0;
 if (i19 ? (i10 = i20 << 2, (i20 | 0) > 0) : 0) {
  i6 = 0;
  do {
   _memset(i34 + ((Math_imul(i6, i26) | 0) << 2) | 0, 0, i10 | 0) | 0;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i32 | 0));
 }
 if ((i5 | 0) <= 0) {
  STACKTOP = i35;
  return;
 }
 i6 = ~i32;
 i18 = ~i31;
 i18 = ~((i6 | 0) > (i18 | 0) ? i6 : i18);
 i6 = 0;
 d7 = 0.0;
 do {
  d7 = d7 + +Math_fround(HEAPF32[i33 + ((Math_imul(i6, i29) | 0) << 2) >> 2]);
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i18 | 0));
 d17 = d7 * 4.440892098500626e-16;
 i2 = (i20 | 0) == 1;
 i3 = (i31 | 0) > 0;
 i4 = i20 + -4 | 0;
 i5 = (i4 | 0) < 0;
 i6 = i20 & -4;
 i15 = (i20 | 0) > 0;
 i16 = i20 << 3;
 i1 = 0;
 while (1) {
  f11 = Math_fround(HEAPF32[i33 + ((Math_imul(i1, i29) | 0) << 2) >> 2]);
  L14 : do if (!(+Math_fround(Math_abs(Math_fround(f11))) <= d17)) {
   d13 = 1.0 / +f11;
   if (i2) {
    if (i22) if (i3) {
     i10 = 0;
     d7 = 0.0;
     do {
      f11 = Math_fround(HEAPF32[i14 + ((Math_imul(i10, i21) | 0) << 2) >> 2]);
      d7 = d7 + +Math_fround(f11 * Math_fround(HEAPF32[i30 + ((Math_imul(i10, i27) | 0) << 2) >> 2]));
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) != (i31 | 0));
    } else d7 = 0.0; else d7 = +Math_fround(HEAPF32[i14 >> 2]);
    d7 = d13 * d7;
    if (i19) i10 = 0; else break;
    while (1) {
     i8 = i34 + ((Math_imul(i10, i26) | 0) << 2) | 0;
     d13 = +Math_fround(HEAPF32[i8 >> 2]);
     HEAPF32[i8 >> 2] = Math_fround(d13 + d7 * +Math_fround(HEAPF32[i12 + (i10 << 2) >> 2]));
     i10 = i10 + 1 | 0;
     if ((i10 | 0) == (i32 | 0)) break L14;
    }
   }
   if (i22) {
    if (i15) _memset(i25 | 0, 0, i16 | 0) | 0;
    if (i3) {
     i9 = i30;
     i8 = 0;
     while (1) {
      f11 = Math_fround(HEAPF32[i14 + ((Math_imul(i8, i21) | 0) << 2) >> 2]);
      if (i5) i10 = 0; else {
       i10 = 0;
       do {
        i37 = i24 + (i10 << 3) | 0;
        d7 = +HEAPF64[i37 >> 3] + +Math_fround(f11 * Math_fround(HEAPF32[i9 + (i10 << 2) >> 2]));
        i36 = i10 | 1;
        i39 = i24 + (i36 << 3) | 0;
        d38 = +HEAPF64[i39 >> 3] + +Math_fround(f11 * Math_fround(HEAPF32[i9 + (i36 << 2) >> 2]));
        HEAPF64[i37 >> 3] = d7;
        HEAPF64[i39 >> 3] = d38;
        i39 = i10 | 2;
        i37 = i24 + (i39 << 3) | 0;
        d38 = +HEAPF64[i37 >> 3] + +Math_fround(f11 * Math_fround(HEAPF32[i9 + (i39 << 2) >> 2]));
        i39 = i10 | 3;
        i36 = i24 + (i39 << 3) | 0;
        d7 = +HEAPF64[i36 >> 3] + +Math_fround(f11 * Math_fround(HEAPF32[i9 + (i39 << 2) >> 2]));
        HEAPF64[i37 >> 3] = d38;
        HEAPF64[i36 >> 3] = d7;
        i10 = i10 + 4 | 0;
       } while ((i10 | 0) <= (i4 | 0));
       i10 = i6;
      }
      if ((i10 | 0) < (i20 | 0)) do {
       i36 = i24 + (i10 << 3) | 0;
       HEAPF64[i36 >> 3] = +HEAPF64[i36 >> 3] + +Math_fround(f11 * Math_fround(HEAPF32[i9 + (i10 << 2) >> 2]));
       i10 = i10 + 1 | 0;
      } while ((i10 | 0) != (i20 | 0));
      i8 = i8 + 1 | 0;
      if ((i8 | 0) == (i31 | 0)) break; else i9 = i9 + (i27 << 2) | 0;
     }
    }
    if (i15) {
     i10 = 0;
     do {
      i8 = i24 + (i10 << 3) | 0;
      HEAPF64[i8 >> 3] = d13 * +HEAPF64[i8 >> 3];
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) != (i20 | 0));
    }
   } else if (i15) {
    i10 = 0;
    do {
     HEAPF64[i24 + (i10 << 3) >> 3] = d13 * +Math_fround(HEAPF32[i14 + ((Math_imul(i10, i21) | 0) << 2) >> 2]);
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i20 | 0));
   }
   if (i19) {
    i9 = i34;
    i8 = 0;
    while (1) {
     f11 = Math_fround(HEAPF32[i12 + (i8 << 2) >> 2]);
     if (i5) i10 = 0; else {
      d7 = +f11;
      i10 = 0;
      do {
       i37 = i9 + (i10 << 2) | 0;
       d13 = +Math_fround(HEAPF32[i37 >> 2]);
       f40 = Math_fround(d13 + d7 * +HEAPF64[i24 + (i10 << 3) >> 3]);
       i36 = i10 | 1;
       i39 = i9 + (i36 << 2) | 0;
       d13 = +Math_fround(HEAPF32[i39 >> 2]);
       f41 = Math_fround(d13 + d7 * +HEAPF64[i24 + (i36 << 3) >> 3]);
       HEAPF32[i37 >> 2] = f40;
       HEAPF32[i39 >> 2] = f41;
       i39 = i10 | 2;
       i37 = i9 + (i39 << 2) | 0;
       d13 = +Math_fround(HEAPF32[i37 >> 2]);
       f41 = Math_fround(d13 + d7 * +HEAPF64[i24 + (i39 << 3) >> 3]);
       i39 = i10 | 3;
       i36 = i9 + (i39 << 2) | 0;
       d13 = +Math_fround(HEAPF32[i36 >> 2]);
       f40 = Math_fround(d13 + d7 * +HEAPF64[i24 + (i39 << 3) >> 3]);
       HEAPF32[i37 >> 2] = f41;
       HEAPF32[i36 >> 2] = f40;
       i10 = i10 + 4 | 0;
      } while ((i10 | 0) <= (i4 | 0));
      i10 = i6;
     }
     if ((i10 | 0) < (i20 | 0)) {
      d7 = +f11;
      do {
       i36 = i9 + (i10 << 2) | 0;
       d13 = +Math_fround(HEAPF32[i36 >> 2]);
       HEAPF32[i36 >> 2] = Math_fround(d13 + d7 * +HEAPF64[i24 + (i10 << 3) >> 3]);
       i10 = i10 + 1 | 0;
      } while ((i10 | 0) != (i20 | 0));
     }
     i8 = i8 + 1 | 0;
     if ((i8 | 0) == (i32 | 0)) break; else i9 = i9 + (i26 << 2) | 0;
    }
   }
  } while (0);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i18 | 0)) break; else {
   i12 = i12 + (i28 << 2) | 0;
   i14 = i14 + (i23 << 2) | 0;
  }
 }
 STACKTOP = i35;
 return;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter20OnTestIterationStartERKNS_8UnitTestEi(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i13 = i14;
 i9 = i14 + 44 | 0;
 i10 = i14 + 32 | 0;
 i11 = i14 + 20 | 0;
 i12 = i14 + 8 | 0;
 if ((HEAP32[40006] | 0) != 1) {
  HEAP32[i13 >> 2] = i2 + 1;
  _printf(162136, i13 | 0) | 0;
 }
 i1 = (HEAP8[159880] & 1) == 0 ? 159881 : HEAP32[39972] | 0;
 if (!((i1 | 0) != 0 ? (_strcmp(i1, 160496) | 0) == 0 : 0)) {
  HEAP32[i13 >> 2] = 162208;
  HEAP32[i13 + 4 >> 2] = i1;
  __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(3, 162184, i13);
 }
 i1 = (HEAP8[159904] & 1) == 0 ? 159905 : HEAP32[39978] | 0;
 if (!((i1 | 0) != 0 ? (_strcmp(i1, 160496) | 0) == 0 : 0)) {
  HEAP32[i13 >> 2] = 162208;
  HEAP32[i13 + 4 >> 2] = i1;
  __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(3, 162224, i13);
 }
 if (__ZN7testing8internal11ShouldShardEPKcS2_b(162256, 162280, 0) | 0) {
  i7 = (__ZN7testing8internal17Int32FromEnvOrDieEPKci(162280, -1) | 0) + 1 | 0;
  i8 = _getenv(162256) | 0;
  HEAP32[i13 >> 2] = i7;
  HEAP32[i13 + 4 >> 2] = i8;
  __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(3, 162304, i13);
 }
 i8 = i4 + 8 | 0;
 if (HEAP8[160040] | 0) {
  HEAP32[i13 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + 172 >> 2];
  __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(3, 162344, i13);
 }
 __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(2, 162400, i13);
 i7 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 + 64 >> 2] | 0;
 i7 = HEAP32[i7 + 60 >> 2] | 0;
 if ((i1 | 0) == (i7 | 0)) i4 = 0; else {
  i5 = i1 - i7 >> 2;
  i6 = 0;
  i3 = 0;
  do {
   i1 = HEAP32[i7 + (i6 << 2) >> 2] | 0;
   i4 = HEAP32[i1 + 20 >> 2] | 0;
   i1 = HEAP32[i1 + 24 >> 2] | 0;
   if ((i4 | 0) == (i1 | 0)) i4 = 0; else {
    i2 = i4;
    i4 = 0;
    do {
     i4 = (HEAPU8[(HEAP32[i2 >> 2] | 0) + 36 >> 0] | 0) + i4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i1 | 0));
   }
   i3 = i4 + i3 | 0;
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i5 >>> 0);
  i4 = i3;
 }
 HEAP32[i13 >> 2] = i4;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i10, i13);
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = HEAP8[i10 >> 0] | 0;
 if (!(i1 & 1)) {
  i3 = (i1 & 255) >>> 1;
  i2 = i10 + 1 | 0;
 } else {
  i3 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = HEAP32[i10 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, i2, i3, i3 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, 163296, 1) | 0;
 i4 = (i4 | 0) == 1 ? 162456 : 162464;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i3 = HEAP8[i9 >> 0] | 0;
 if (!(i3 & 1)) {
  i1 = _strlen(i4 | 0) | 0;
  i3 = (i3 & 255) >>> 1;
  i2 = i9 + 1 | 0;
 } else {
  i3 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = _strlen(i4 | 0) | 0;
  i2 = HEAP32[i9 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i11, i2, i3, i3 + i1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i11, i4, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
 if (!(HEAP8[i11 >> 0] & 1)) i7 = i11 + 1 | 0; else i7 = HEAP32[i11 + 8 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i4 + 60 >> 2] | 0;
 i4 = HEAP32[i4 + 64 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) i2 = 0; else {
  i2 = 0;
  do {
   i2 = (HEAPU8[(HEAP32[i1 >> 2] | 0) + 52 >> 0] | 0) + i2 | 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i13 >> 2] = i2;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i10, i13);
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = HEAP8[i10 >> 0] | 0;
 if (!(i1 & 1)) {
  i1 = (i1 & 255) >>> 1;
  i3 = i10 + 1 | 0;
 } else {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i3 = HEAP32[i10 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, i3, i1, i1 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, 163296, 1) | 0;
 i4 = (i2 | 0) == 1 ? 168920 : 168936;
 HEAP32[i12 + 0 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i3 = HEAP8[i9 >> 0] | 0;
 if (!(i3 & 1)) {
  i1 = _strlen(i4 | 0) | 0;
  i3 = (i3 & 255) >>> 1;
  i2 = i9 + 1 | 0;
 } else {
  i3 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = _strlen(i4 | 0) | 0;
  i2 = HEAP32[i9 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i12, i2, i3, i3 + i1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, i4, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
 if (!(HEAP8[i12 >> 0] & 1)) {
  i9 = i12 + 1 | 0;
  HEAP32[i13 >> 2] = i7;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  _printf(162416, i13 | 0) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  i10 = HEAP32[_stdout >> 2] | 0;
  _fflush(i10 | 0) | 0;
  STACKTOP = i14;
  return;
 } else {
  i9 = HEAP32[i12 + 8 >> 2] | 0;
  HEAP32[i13 >> 2] = i7;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  _printf(162416, i13 | 0) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  i10 = HEAP32[_stdout >> 2] | 0;
  _fflush(i10 | 0) | 0;
  STACKTOP = i14;
  return;
 }
}

function __ZNK2cv12MatAllocator4copyEPNS_8UMatDataES2_iPKjS4_S4_S4_S4_b(i1, i3, i4, i20, i13, i12, i16, i11, i21, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i20 = i20 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i11 = i11 | 0;
 i21 = i21 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i19 = i26 + 168 | 0;
 i10 = i26 + 160 | 0;
 i25 = i26 + 104 | 0;
 i24 = i26 + 48 | 0;
 i18 = i26 + 40 | 0;
 i23 = i26 + 32 | 0;
 i22 = i26;
 if (!((i3 | 0) != 0 & (i4 | 0) != 0)) {
  STACKTOP = i26;
  return;
 }
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i4 = HEAP32[i4 + 16 >> 2] | 0;
 L4 : do if ((i20 | 0) > 0) {
  i9 = (i12 | 0) == 0;
  i6 = (i11 | 0) == 0;
  i7 = i20 + -2 | 0;
  i8 = i10 + 4 | 0;
  i5 = 0;
  while (1) {
   i2 = i13 + (i5 << 2) | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) <= -1) {
    HEAP32[i10 >> 2] = 0;
    HEAP32[i8 >> 2] = 0;
    i14 = (__ZN2cv6String8allocateEj(i10, 24) | 0) + 0 | 0;
    i3 = 27480;
    i15 = i14 + 24 | 0;
    do {
     HEAP8[i14 >> 0] = HEAP8[i3 >> 0] | 0;
     i14 = i14 + 1 | 0;
     i3 = i3 + 1 | 0;
    } while ((i14 | 0) < (i15 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 27592, 27528, 140);
    __ZN2cv6String10deallocateEv(i10);
    i3 = HEAP32[i2 >> 2] | 0;
   }
   if (!i3) break;
   if (!i9) {
    if ((i5 | 0) > (i7 | 0)) i2 = 1; else i2 = HEAP32[i16 + (i5 << 2) >> 2] | 0;
    i1 = i1 + (Math_imul(i2, HEAP32[i12 + (i5 << 2) >> 2] | 0) | 0) | 0;
   }
   if (!i6) {
    if ((i5 | 0) > (i7 | 0)) i2 = 1; else i2 = HEAP32[i21 + (i5 << 2) >> 2] | 0;
    i4 = i4 + (Math_imul(i2, HEAP32[i11 + (i5 << 2) >> 2] | 0) | 0) | 0;
   }
   HEAP32[i19 + (i5 << 2) >> 2] = i3;
   i5 = i5 + 1 | 0;
   if ((i5 | 0) >= (i20 | 0)) break L4;
  }
  STACKTOP = i26;
  return;
 } while (0);
 i5 = i25 + 4 | 0;
 i3 = i25 + 8 | 0;
 i13 = i25 + 16 | 0;
 i2 = i25 + 20 | 0;
 i12 = i25 + 40 | 0;
 i14 = i5 + 0 | 0;
 i15 = i14 + 36 | 0;
 do {
  HEAP32[i14 >> 2] = 0;
  i14 = i14 + 4 | 0;
 } while ((i14 | 0) < (i15 | 0));
 HEAP32[i12 >> 2] = i3;
 i17 = i25 + 48 | 0;
 i11 = i25 + 44 | 0;
 HEAP32[i11 >> 2] = i17;
 HEAP32[i25 + 52 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i25 >> 2] = 1124007936;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i25, i20, i19, i16, 1);
 __ZN2cvL11finalizeHdrERNS_3MatE(i25);
 i6 = i24 + 4 | 0;
 i3 = i24 + 8 | 0;
 i10 = i24 + 16 | 0;
 i2 = i24 + 20 | 0;
 i8 = i24 + 40 | 0;
 i14 = i6 + 0 | 0;
 i15 = i14 + 36 | 0;
 do {
  HEAP32[i14 >> 2] = 0;
  i14 = i14 + 4 | 0;
 } while ((i14 | 0) < (i15 | 0));
 HEAP32[i8 >> 2] = i3;
 i7 = i24 + 48 | 0;
 i9 = i24 + 44 | 0;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i24 + 52 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i24 >> 2] = 1124007936;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i2 >> 2] = i4;
 __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i24, i20, i19, i21, 1);
 __ZN2cvL11finalizeHdrERNS_3MatE(i24);
 HEAP32[i18 >> 2] = i25;
 HEAP32[i18 + 4 >> 2] = i24;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 HEAP32[i22 + 16 >> 2] = 0;
 HEAP32[i22 + 20 >> 2] = 0;
 HEAP32[i22 + 24 >> 2] = 0;
 HEAP32[i22 + 28 >> 2] = 0;
 __ZN2cv15NAryMatIterator4initEPPKNS_3MatEPS1_PPhi(i22, i18, 0, i23, 2);
 i3 = HEAP32[i22 + 20 >> 2] | 0;
 i2 = i22 + 16 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = i23 + 4 | 0;
  i4 = 0;
  do {
   _memcpy(HEAP32[i1 >> 2] | 0, HEAP32[i23 >> 2] | 0, i3 | 0) | 0;
   i4 = i4 + 1 | 0;
   __ZN2cv15NAryMatIteratorppEv(i22) | 0;
  } while (i4 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i4 = i24 + 36 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i21 = i3 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  if (i2) {
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i3) {
    i3 = HEAP32[i24 + 32 >> 2] | 0;
    if (!i3) {
     if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
      i22 = __Znwj(4) | 0;
      HEAP32[i22 >> 2] = 32784;
      HEAP32[6904] = i22;
      ___cxa_guard_release(27624);
     }
     i3 = HEAP32[6904] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3, i2);
  }
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i6 >> 2] | 0) > 0) {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i6 >> 2] | 0));
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i7 | 0)) __ZN2cv8fastFreeEPv(i2);
 i3 = i25 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i25 + 32 >> 2] | 0;
    if (!i2) {
     if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
      i22 = __Znwj(4) | 0;
      HEAP32[i22 >> 2] = 32784;
      HEAP32[6904] = i22;
      ___cxa_guard_release(27624);
     }
     i2 = HEAP32[6904] | 0;
     i1 = HEAP32[i3 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1);
  }
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i13 + 0 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 if ((HEAP32[i5 >> 2] | 0) > 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i5 >> 2] | 0));
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i17 | 0)) {
  STACKTOP = i26;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i26;
 return;
}

function __ZN12_GLOBAL__N_113FormattedImpl4nextEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i8;
 i6 = i7 + 108 | 0;
 do switch (HEAP32[i6 >> 2] | 0) {
 case 4:
  {
   HEAP32[i6 >> 2] = 9;
   i2 = i7 + 112 | 0;
   i1 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
   HEAP32[i2 >> 2] = i1;
   i2 = HEAP8[i7 + 141 >> 0] | 0;
   if (i2 << 24 >> 24) {
    i3 = i7 + 12 | 0;
    HEAP8[i3 >> 0] = i2;
    HEAP8[i7 + 13 >> 0] = (i1 | 0) < (HEAP32[i7 + 52 >> 2] | 0) ? 44 : 0;
    HEAP8[i7 + 14 >> 0] = 0;
    i1 = i3;
    STACKTOP = i8;
    return i1 | 0;
   }
   i2 = HEAP8[i7 + 142 >> 0] | 0;
   if (i2 << 24 >> 24 != 0 ? (i1 | 0) < (HEAP32[i7 + 52 >> 2] | 0) : 0) {
    i1 = i7 + 12 | 0;
    HEAP8[i1 >> 0] = i2;
    HEAP8[i7 + 13 >> 0] = 0;
    STACKTOP = i8;
    return i1 | 0;
   }
   i1 = FUNCTION_TABLE_ii[HEAP32[HEAP32[i7 >> 2] >> 2] & 127](i7) | 0;
   STACKTOP = i8;
   return i1 | 0;
  }
 case 9:
  if ((HEAP32[i7 + 112 >> 2] | 0) < (HEAP32[i7 + 52 >> 2] | 0)) {
   HEAP32[i6 >> 2] = 3;
   i1 = i7 + 12 | 0;
   HEAP8[i1 >> 0] = (HEAP8[i7 + 104 >> 0] | 0) != 0 ? 32 : 10;
   HEAP8[i7 + 13 >> 0] = 0;
   STACKTOP = i8;
   return i1 | 0;
  } else {
   HEAP32[i6 >> 2] = (HEAP8[i7 + 105 >> 0] | 0) == 0 ? 1 : 2;
   i1 = FUNCTION_TABLE_ii[HEAP32[HEAP32[i7 >> 2] >> 2] & 127](i7) | 0;
   STACKTOP = i8;
   return i1 | 0;
  }
 case 11:
  {
   HEAP32[i6 >> 2] = 7;
   i1 = i7 + 12 | 0;
   HEAP8[i1 >> 0] = 44;
   HEAP8[i7 + 13 >> 0] = 32;
   HEAP8[i7 + 14 >> 0] = 0;
   STACKTOP = i8;
   return i1 | 0;
  }
 case 7:
  {
   i3 = i7 + 148 | 0;
   i2 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
   i3 = i3 + 4 | 0;
   i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
   i1 = i7 + (i3 >> 1) | 0;
   if (i3 & 1) i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + i2 >> 2] | 0;
   FUNCTION_TABLE_vi[i2 & 511](i1);
   HEAP32[i6 >> 2] = 6;
   if (HEAP8[i7 + 105 >> 0] | 0) {
    i1 = i7 + 12 | 0;
    STACKTOP = i8;
    return i1 | 0;
   }
   i2 = i7 + 120 | 0;
   i1 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
   HEAP32[i2 >> 2] = i1;
   if ((i1 | 0) < (HEAP32[i7 + 100 >> 2] | 0)) HEAP32[i6 >> 2] = 11;
   i1 = i7 + 12 | 0;
   STACKTOP = i8;
   return i1 | 0;
  }
 case 10:
  {
   HEAP32[i6 >> 2] = 5;
   i1 = i7 + 12 | 0;
   HEAP8[i1 >> 0] = 44;
   HEAP8[i7 + 13 >> 0] = 32;
   HEAP8[i7 + 14 >> 0] = 0;
   STACKTOP = i8;
   return i1 | 0;
  }
 case 1:
  {
   HEAP32[i6 >> 2] = 8;
   i1 = HEAP32[i7 + 132 >> 2] | 0;
   i1 = (i1 | 0) == 0 ? 7280 : i1;
   STACKTOP = i8;
   return i1 | 0;
  }
 case 3:
  {
   HEAP32[i7 + 116 >> 2] = 0;
   HEAP32[i6 >> 2] = 5;
   if ((HEAP32[i7 + 112 >> 2] | 0) > 0 ? (i4 = i7 + 128 | 0, (HEAP32[i4 >> 2] | 0) != 0) : 0) {
    i2 = 0;
    while (1) {
     i1 = i2 + 1 | 0;
     HEAP8[i7 + i2 + 12 >> 0] = 32;
     if (i1 >>> 0 < 30 ? i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0 : 0) i2 = i1; else break;
    }
   } else i1 = 0;
   i2 = HEAP8[i7 + 140 >> 0] | 0;
   if (i2 << 24 >> 24) {
    HEAP8[i7 + i1 + 12 >> 0] = i2;
    i1 = i1 + 1 | 0;
   }
   if (!i1) {
    i1 = FUNCTION_TABLE_ii[HEAP32[HEAP32[i7 >> 2] >> 2] & 127](i7) | 0;
    STACKTOP = i8;
    return i1 | 0;
   } else {
    HEAP8[i7 + i1 + 12 >> 0] = 0;
    i1 = i7 + 12 | 0;
    STACKTOP = i8;
    return i1 | 0;
   }
  }
 case 0:
  {
   HEAP32[i7 + 112 >> 2] = 0;
   do if (HEAP32[i7 + 60 >> 2] | 0) {
    i3 = HEAP32[i7 + 48 >> 2] | 0;
    if ((i3 | 0) < 3) i2 = Math_imul(HEAP32[i7 + 56 >> 2] | 0, HEAP32[i7 + 52 >> 2] | 0) | 0; else {
     i1 = HEAP32[i7 + 84 >> 2] | 0;
     i4 = 0;
     i2 = 1;
     do {
      i2 = Math_imul(HEAP32[i1 + (i4 << 2) >> 2] | 0, i2) | 0;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i3 | 0));
    }
    if (i2) if (!(HEAP8[i7 + 105 >> 0] | 0)) {
     HEAP32[i6 >> 2] = 3;
     break;
    } else {
     HEAP32[i6 >> 2] = 2;
     break;
    } else i5 = 8;
   } else i5 = 8; while (0);
   if ((i5 | 0) == 8) HEAP32[i6 >> 2] = 1;
   i1 = HEAP32[i7 + 124 >> 2] | 0;
   i1 = (i1 | 0) == 0 ? 7280 : i1;
   STACKTOP = i8;
   return i1 | 0;
  }
 case 2:
  {
   HEAP32[i6 >> 2] = 3;
   i2 = i7 + 112 | 0;
   if ((HEAP32[i2 >> 2] | 0) < (HEAP32[i7 + 52 >> 2] | 0)) {
    i1 = i7 + 12 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i7 + 120 >> 2] | 0) + 1;
    _sprintf(i1, 7264, i3) | 0;
    STACKTOP = i8;
    return i1 | 0;
   }
   i5 = i7 + 120 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i4 = i1 + 1 | 0;
   HEAP32[i5 >> 2] = i4;
   if ((i4 | 0) < (HEAP32[i7 + 100 >> 2] | 0)) {
    HEAP32[i2 >> 2] = 0;
    i2 = i7 + 12 | 0;
    HEAP32[i3 >> 2] = i1 + 2;
    _sprintf(i2, 7248, i3) | 0;
    i1 = i2;
    STACKTOP = i8;
    return i1 | 0;
   } else {
    HEAP32[i6 >> 2] = 1;
    i1 = i7 + 12 | 0;
    HEAP8[i1 >> 0] = 0;
    STACKTOP = i8;
    return i1 | 0;
   }
  }
 case 5:
  {
   HEAP32[i6 >> 2] = 7;
   if (!(HEAP8[i7 + 105 >> 0] | 0)) HEAP32[i7 + 120 >> 2] = 0;
   if ((HEAP32[i7 + 100 >> 2] | 0) > 1 ? (i2 = HEAP8[i7 + 143 >> 0] | 0, i2 << 24 >> 24 != 0) : 0) {
    i1 = i7 + 12 | 0;
    HEAP8[i1 >> 0] = i2;
    HEAP8[i7 + 13 >> 0] = 0;
    STACKTOP = i8;
    return i1 | 0;
   }
   i1 = FUNCTION_TABLE_ii[HEAP32[HEAP32[i7 >> 2] >> 2] & 127](i7) | 0;
   STACKTOP = i8;
   return i1 | 0;
  }
 case 6:
  {
   i3 = i7 + 116 | 0;
   i2 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = (i2 | 0) < (HEAP32[i7 + 56 >> 2] | 0) ? 10 : 4;
   if ((HEAP32[i7 + 100 >> 2] | 0) > 1 ? (i1 = HEAP8[i7 + 144 >> 0] | 0, i1 << 24 >> 24 != 0) : 0) {
    i2 = i7 + 12 | 0;
    HEAP8[i2 >> 0] = i1;
    HEAP8[i7 + 13 >> 0] = 0;
    i1 = i2;
    STACKTOP = i8;
    return i1 | 0;
   }
   i1 = FUNCTION_TABLE_ii[HEAP32[HEAP32[i7 >> 2] >> 2] & 127](i7) | 0;
   STACKTOP = i8;
   return i1 | 0;
  }
 default:
  {
   i1 = 0;
   STACKTOP = i8;
   return i1 | 0;
  }
 } while (0);
 return 0;
}

function __ZN24Size_MatType_bitwise_not12PerfTestBodyEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i12 = i27 + 224 | 0;
 i23 = i27 + 168 | 0;
 i21 = i27 + 112 | 0;
 i8 = i27 + 92 | 0;
 i9 = i27 + 72 | 0;
 i13 = i27 + 52 | 0;
 i14 = i27 + 32 | 0;
 i17 = i27 + 20 | 0;
 i18 = i27;
 if (!(__ZN7testing8internal6IsTrueEb((HEAP32[172] | 0) != 0) | 0)) {
  __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i12, 3, 696, 19288);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 768, 37) | 0, 808, 64) | 0, 880, 52) | 0;
  __ZN7testing8internal8GTestLogD2Ev(i12);
 }
 i22 = HEAP32[172] | 0;
 i10 = HEAP32[i22 >> 2] | 0;
 i11 = HEAP32[i22 + 4 >> 2] | 0;
 if (!(__ZN7testing8internal6IsTrueEb((i22 | 0) != 0) | 0)) {
  __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i12, 3, 696, 19288);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 768, 37) | 0, 808, 64) | 0, 880, 52) | 0;
  __ZN7testing8internal8GTestLogD2Ev(i12);
 }
 i1 = HEAP32[(HEAP32[172] | 0) + 8 >> 2] | 0;
 HEAP32[i23 >> 2] = 1124007936;
 i25 = i23 + 4 | 0;
 i2 = i23 + 8 | 0;
 i22 = i23 + 40 | 0;
 i3 = i25 + 0 | 0;
 i7 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i7 | 0));
 HEAP32[i22 >> 2] = i2;
 i26 = i23 + 48 | 0;
 i24 = i23 + 44 | 0;
 HEAP32[i24 >> 2] = i26;
 HEAP32[i23 + 52 >> 2] = 0;
 HEAP32[i26 >> 2] = 0;
 i5 = i1 & 4095;
 HEAP32[i12 >> 2] = i11;
 i4 = i12 + 4 | 0;
 HEAP32[i4 >> 2] = i10;
 __ZN2cv3Mat6createEiPKii(i23, 2, i12, i5);
 HEAP32[i21 >> 2] = 1124007936;
 i20 = i21 + 4 | 0;
 i6 = i21 + 8 | 0;
 i15 = i21 + 40 | 0;
 i3 = i20 + 0 | 0;
 i7 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i7 | 0));
 HEAP32[i15 >> 2] = i6;
 i16 = i21 + 48 | 0;
 i7 = i21 + 44 | 0;
 HEAP32[i7 >> 2] = i16;
 HEAP32[i21 + 52 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i4 >> 2] = i10;
 __ZN2cv3Mat6createEiPKii(i21, 2, i12, i5);
 i2 = i19 + 180 | 0;
 i1 = i8 + 4 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i8 >> 2] = 3136;
 HEAP32[i1 >> 2] = 50397184;
 HEAP32[i8 + 8 >> 2] = i23;
 i1 = __ZN4perf8TestBase14_declareHelper2inERKN2cv17_InputOutputArrayENS0_10WarmUpTypeE(i2, i8, 2) | 0;
 i3 = i9 + 4 | 0;
 HEAP32[i3 + 0 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i9 >> 2] = 3136;
 HEAP32[i3 >> 2] = 50397184;
 HEAP32[i9 + 8 >> 2] = i21;
 __ZN4perf8TestBase14_declareHelper3outERKN2cv17_InputOutputArrayENS0_10WarmUpTypeE(i1, i9, 1) | 0;
 __ZN4perf8TestBase14_declareHelper10iterationsEj(i2, 200) | 0;
 i2 = i13 + 12 | 0;
 i1 = i13 + 16 | 0;
 i3 = i13 + 4 | 0;
 i4 = i13 + 8 | 0;
 i5 = i14 + 4 | 0;
 i6 = i14 + 8 | 0;
 while (1) {
  __ZN4perf8TestBase10startTimerEv(i19);
  if (!(__ZN4perf8TestBase4nextEv(i19) | 0)) break;
  HEAP32[i13 >> 2] = 32088;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 16842752;
  HEAP32[i4 >> 2] = i23;
  HEAP32[i5 + 0 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i14 >> 2] = 32232;
  HEAP32[i5 >> 2] = 33619968;
  HEAP32[i6 >> 2] = i21;
  __ZN2cv11bitwise_notERKNS_11_InputArrayERKNS_12_OutputArrayES2_(i13, i14, __ZN2cv7noArrayEv() | 0);
  __ZN4perf8TestBase9stopTimerEv(i19);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, 304, 1);
 HEAP32[i18 >> 2] = 32088;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 16842752;
 HEAP32[i18 + 8 >> 2] = i21;
 __ZN4perf10Regression3addEPNS_8TestBaseERKNSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEERKN2cv11_InputArrayEdNS_10ERROR_TYPEE(i19, i17, i18, 2.220446049250313e-16, 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
 i2 = i21 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i18 = i1 + 12 | 0, i19 = HEAP32[i18 >> 2] | 0, HEAP32[i18 >> 2] = i19 + -1, (i19 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i21);
 HEAP32[i2 >> 2] = 0;
 i21 = i21 + 16 | 0;
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 if ((HEAP32[i20 >> 2] | 0) > 0) {
  i2 = HEAP32[i15 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i20 >> 2] | 0));
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i16 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i23 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i20 = i1 + 12 | 0, i21 = HEAP32[i20 >> 2] | 0, HEAP32[i20 >> 2] = i21 + -1, (i21 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i23);
 HEAP32[i2 >> 2] = 0;
 i21 = i23 + 16 | 0;
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 if ((HEAP32[i25 >> 2] | 0) > 0) {
  i1 = HEAP32[i22 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i25 >> 2] | 0));
 }
 i1 = HEAP32[i24 >> 2] | 0;
 if ((i1 | 0) == (i26 | 0)) {
  STACKTOP = i27;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i27;
 return;
}

function __ZN2cvL6sum32fEPKfPKhPdii(i6, i12, i17, i16, i15) {
 i6 = i6 | 0;
 i12 = i12 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, d2 = 0.0, d3 = 0.0, i4 = 0, d5 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d13 = 0.0, i14 = 0, i18 = 0, f19 = f0, i20 = 0;
 i18 = STACKTOP;
 if (!i12) {
  i14 = (i15 | 0) % 4 | 0;
  if ((i14 | 0) == 1) {
   d2 = +HEAPF64[i17 >> 3];
   i9 = i16 + -4 | 0;
   if ((i9 | 0) < 0) {
    i1 = 0;
    i4 = i6;
   } else {
    i8 = i15 << 1;
    i7 = i15 * 3 | 0;
    i10 = i15 << 2;
    i11 = i9 >>> 2;
    i4 = i6 + (Math_imul((i11 << 4) + 16 | 0, i15) | 0) | 0;
    i12 = 0;
    i1 = i6;
    while (1) {
     f19 = Math_fround(HEAPF32[i1 >> 2]);
     f19 = Math_fround(f19 + Math_fround(HEAPF32[i1 + (i15 << 2) >> 2]));
     f19 = Math_fround(f19 + Math_fround(HEAPF32[i1 + (i8 << 2) >> 2]));
     d2 = d2 + +Math_fround(f19 + Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]));
     i12 = i12 + 4 | 0;
     if ((i12 | 0) > (i9 | 0)) break; else i1 = i1 + (i10 << 2) | 0;
    }
    i1 = (i11 << 2) + 4 | 0;
   }
   if ((i1 | 0) < (i16 | 0)) while (1) {
    d2 = d2 + +Math_fround(HEAPF32[i4 >> 2]);
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    } else i4 = i4 + (i15 << 2) | 0;
   }
   HEAPF64[i17 >> 3] = d2;
  } else if ((i14 | 0) == 3) {
   d3 = +HEAPF64[i17 >> 3];
   i9 = i17 + 8 | 0;
   d2 = +HEAPF64[i9 >> 3];
   i8 = i17 + 16 | 0;
   d5 = +HEAPF64[i8 >> 3];
   if ((i16 | 0) > 0) {
    i10 = 0;
    i11 = i6;
    while (1) {
     d3 = d3 + +Math_fround(HEAPF32[i11 >> 2]);
     d2 = d2 + +Math_fround(HEAPF32[i11 + 4 >> 2]);
     d5 = d5 + +Math_fround(HEAPF32[i11 + 8 >> 2]);
     i10 = i10 + 1 | 0;
     if ((i10 | 0) == (i16 | 0)) {
      i1 = i16;
      break;
     } else i11 = i11 + (i15 << 2) | 0;
    }
   } else i1 = 0;
   HEAPF64[i17 >> 3] = d3;
   HEAPF64[i9 >> 3] = d2;
   HEAPF64[i8 >> 3] = d5;
  } else if ((i14 | 0) == 2) {
   d3 = +HEAPF64[i17 >> 3];
   i11 = i17 + 8 | 0;
   d2 = +HEAPF64[i11 >> 3];
   if ((i16 | 0) > 0) {
    i1 = 0;
    i4 = i6;
    while (1) {
     d3 = d3 + +Math_fround(HEAPF32[i4 >> 2]);
     d2 = d2 + +Math_fround(HEAPF32[i4 + 4 >> 2]);
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i16 | 0)) {
      i1 = i16;
      break;
     } else i4 = i4 + (i15 << 2) | 0;
    }
   } else i1 = 0;
   HEAPF64[i17 >> 3] = d3;
   HEAPF64[i11 >> 3] = d2;
  } else i1 = 0;
  if ((i14 | 0) < (i15 | 0)) i12 = i14; else {
   i14 = i16;
   STACKTOP = i18;
   return i14 | 0;
  }
  do {
   i9 = i17 + (i12 << 3) | 0;
   d3 = +HEAPF64[i9 >> 3];
   i8 = i17 + (i12 + 1 << 3) | 0;
   d13 = +HEAPF64[i8 >> 3];
   i7 = i17 + (i12 + 2 << 3) | 0;
   d2 = +HEAPF64[i7 >> 3];
   i4 = i17 + (i12 + 3 << 3) | 0;
   d5 = +HEAPF64[i4 >> 3];
   if ((i1 | 0) < (i16 | 0)) {
    i10 = i1;
    i11 = i6 + ((Math_imul(i1, i15) | 0) + i12 << 2) | 0;
    while (1) {
     d3 = d3 + +Math_fround(HEAPF32[i11 >> 2]);
     d13 = d13 + +Math_fround(HEAPF32[i11 + 4 >> 2]);
     d2 = d2 + +Math_fround(HEAPF32[i11 + 8 >> 2]);
     d5 = d5 + +Math_fround(HEAPF32[i11 + 12 >> 2]);
     i10 = i10 + 1 | 0;
     if ((i10 | 0) == (i16 | 0)) {
      i1 = i16;
      break;
     } else i11 = i11 + (i15 << 2) | 0;
    }
   }
   HEAPF64[i9 >> 3] = d3;
   HEAPF64[i8 >> 3] = d13;
   HEAPF64[i7 >> 3] = d2;
   HEAPF64[i4 >> 3] = d5;
   i12 = i12 + 4 | 0;
  } while ((i12 | 0) < (i15 | 0));
  i1 = i16;
  STACKTOP = i18;
  return i1 | 0;
 }
 if ((i15 | 0) == 1) {
  d2 = +HEAPF64[i17 >> 3];
  if ((i16 | 0) > 0) {
   i4 = 0;
   i1 = 0;
   do {
    if (HEAP8[i12 + i4 >> 0] | 0) {
     i1 = i1 + 1 | 0;
     d2 = d2 + +Math_fround(HEAPF32[i6 + (i4 << 2) >> 2]);
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i16 | 0));
  } else i1 = 0;
  HEAPF64[i17 >> 3] = d2;
  i14 = i1;
  STACKTOP = i18;
  return i14 | 0;
 } else if ((i15 | 0) == 3) {
  d5 = +HEAPF64[i17 >> 3];
  i10 = i17 + 8 | 0;
  d3 = +HEAPF64[i10 >> 3];
  i9 = i17 + 16 | 0;
  d2 = +HEAPF64[i9 >> 3];
  if ((i16 | 0) > 0) {
   i11 = 0;
   i4 = 0;
   while (1) {
    if (HEAP8[i12 + i11 >> 0] | 0) {
     d5 = d5 + +Math_fround(HEAPF32[i6 >> 2]);
     d3 = d3 + +Math_fround(HEAPF32[i6 + 4 >> 2]);
     i4 = i4 + 1 | 0;
     d2 = d2 + +Math_fround(HEAPF32[i6 + 8 >> 2]);
    }
    i11 = i11 + 1 | 0;
    if ((i11 | 0) == (i16 | 0)) break; else i6 = i6 + 12 | 0;
   }
  } else i4 = 0;
  HEAPF64[i17 >> 3] = d5;
  HEAPF64[i10 >> 3] = d3;
  HEAPF64[i9 >> 3] = d2;
  i14 = i4;
  STACKTOP = i18;
  return i14 | 0;
 } else {
  if ((i16 | 0) <= 0) {
   i14 = 0;
   STACKTOP = i18;
   return i14 | 0;
  }
  i7 = i15 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i15 & -4;
  i11 = 0;
  i1 = 0;
  while (1) {
   if (HEAP8[i12 + i11 >> 0] | 0) {
    if (i8) i4 = 0; else {
     i4 = 0;
     do {
      i10 = i17 + (i4 << 3) | 0;
      d2 = +HEAPF64[i10 >> 3] + +Math_fround(HEAPF32[i6 + (i4 << 2) >> 2]);
      i14 = i4 | 1;
      i20 = i17 + (i14 << 3) | 0;
      d13 = +HEAPF64[i20 >> 3] + +Math_fround(HEAPF32[i6 + (i14 << 2) >> 2]);
      HEAPF64[i10 >> 3] = d2;
      HEAPF64[i20 >> 3] = d13;
      i20 = i4 | 2;
      i10 = i17 + (i20 << 3) | 0;
      d13 = +HEAPF64[i10 >> 3] + +Math_fround(HEAPF32[i6 + (i20 << 2) >> 2]);
      i20 = i4 | 3;
      i14 = i17 + (i20 << 3) | 0;
      d2 = +HEAPF64[i14 >> 3] + +Math_fround(HEAPF32[i6 + (i20 << 2) >> 2]);
      HEAPF64[i10 >> 3] = d13;
      HEAPF64[i14 >> 3] = d2;
      i4 = i4 + 4 | 0;
     } while ((i4 | 0) <= (i7 | 0));
     i4 = i9;
    }
    if ((i4 | 0) < (i15 | 0)) do {
     d2 = +Math_fround(HEAPF32[i6 + (i4 << 2) >> 2]);
     i14 = i17 + (i4 << 3) | 0;
     HEAPF64[i14 >> 3] = +HEAPF64[i14 >> 3] + d2;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i15 | 0));
    i1 = i1 + 1 | 0;
   }
   i11 = i11 + 1 | 0;
   if ((i11 | 0) == (i16 | 0)) break; else i6 = i6 + (i15 << 2) | 0;
  }
  STACKTOP = i18;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cv13sorted_vectorINS_6StringENS_5ParamEE3addERKS1_RKS2_(i14, i2, i1) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i13 = i18 + 52 | 0;
 i17 = i18 + 8 | 0;
 i16 = i18;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i17 >> 2] = i3;
 i7 = i17 + 4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 + 4 >> 2];
 if (i3) {
  i10 = i3 + -4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 i4 = i17 + 8 | 0;
 HEAP32[i4 + 0 >> 2] = HEAP32[i1 + 0 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 i5 = i17 + 36 | 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 i6 = i17 + 40 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 + 32 >> 2];
 if (i3) {
  i10 = i3 + -4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 i2 = i14 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i14 + 8 >> 2] | 0)) {
  __ZNSt3__16vectorINS_4pairIN2cv6StringENS2_5ParamEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i14, i17);
  i3 = HEAP32[i2 >> 2] | 0;
 } else {
  if (i1) {
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i1 + 4 >> 2] = HEAP32[i7 >> 2];
   if (i3) {
    i10 = i3 + -4 | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   }
   i3 = i1 + 8 | 0;
   HEAP32[i3 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
   i3 = HEAP32[i5 >> 2] | 0;
   HEAP32[i1 + 36 >> 2] = i3;
   HEAP32[i1 + 40 >> 2] = HEAP32[i6 >> 2];
   if (i3) {
    i10 = i3 + -4 | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   }
  }
  i3 = (HEAP32[i2 >> 2] | 0) + 44 | 0;
  HEAP32[i2 >> 2] = i3;
 }
 i10 = i13 + 28 | 0;
 i11 = i13 + 32 | 0;
 i12 = i13 + 28 | 0;
 i3 = (i3 - (HEAP32[i14 >> 2] | 0) | 0) / 44 | 0;
 while (1) {
  i9 = i3 + -1 | 0;
  if (!i9) {
   i15 = 28;
   break;
  }
  i8 = HEAP32[i14 >> 2] | 0;
  i7 = i3 + -2 | 0;
  i5 = i8 + (i9 * 44 | 0) | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = i8 + (i7 * 44 | 0) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) == (i2 | 0)) break;
  if ((_strcmp((i4 | 0) == 0 ? 39376 : i4, (i2 | 0) == 0 ? 39376 : i2) | 0) >= 0) {
   i15 = 26;
   break;
  }
  HEAP32[i3 >> 2] = i4;
  HEAP32[i5 >> 2] = i2;
  i5 = i8 + (i7 * 44 | 0) + 4 | 0;
  i6 = i8 + (i9 * 44 | 0) + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i1;
  i6 = i8 + (i7 * 44 | 0) + 8 | 0;
  i1 = i8 + (i9 * 44 | 0) + 8 | 0;
  HEAP32[i13 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i13 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i13 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
  i5 = HEAP32[i8 + (i7 * 44 | 0) + 36 >> 2] | 0;
  HEAP32[i10 >> 2] = i5;
  i4 = i8 + (i7 * 44 | 0) + 40 | 0;
  HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
  if (i5) {
   i5 = i5 + -4 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  };
  HEAP32[i6 + 0 >> 2] = HEAP32[i1 + 0 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i6 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  i7 = i8 + (i7 * 44 | 0) + 36 | 0;
  __ZN2cv6String10deallocateEv(i7);
  i6 = i8 + (i9 * 44 | 0) + 36 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  if (!i5) i3 = 0; else {
   i3 = i5 + -4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = i3;
  i7 = i8 + (i9 * 44 | 0) + 40 | 0;
  HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 0 >> 2] = HEAP32[i13 + 0 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
  i2 = i8 + (i9 * 44 | 0) + 36 | 0;
  if ((i13 | 0) != (i1 | 0)) {
   __ZN2cv6String10deallocateEv(i2);
   i3 = HEAP32[i10 >> 2] | 0;
   if (!i3) i3 = 0; else {
    i3 = i3 + -4 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
    i3 = HEAP32[i10 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = i3;
   HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
  }
  __ZN2cv6String10deallocateEv(i12);
  i3 = i9;
 }
 if ((i15 | 0) == 28) {
  i10 = i17 + 36 | 0;
  __ZN2cv6String10deallocateEv(i10);
  __ZN2cv6String10deallocateEv(i17);
  STACKTOP = i18;
  return;
 }
 if ((i15 | 0) == 26 ? (_strcmp((i4 | 0) == 0 ? 39376 : i4, (i2 | 0) == 0 ? 39376 : i2) | 0) != 0 : 0) {
  i10 = i17 + 36 | 0;
  __ZN2cv6String10deallocateEv(i10);
  __ZN2cv6String10deallocateEv(i17);
  STACKTOP = i18;
  return;
 }
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i1 = (__ZN2cv6String8allocateEj(i16, 40) | 0) + 0 | 0;
 i2 = 38664 | 0;
 i3 = i1 + 40 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i16, 38712, 37992, 63);
 __ZN2cv6String10deallocateEv(i16);
 i10 = i17 + 36 | 0;
 __ZN2cv6String10deallocateEv(i10);
 __ZN2cv6String10deallocateEv(i17);
 STACKTOP = i18;
 return;
}

function __ZNK2cv5MatOp6matmulERKNS_7MatExprES3_RS1_(i1, i4, i5, i11) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i2 = 0, d3 = 0.0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 i12 = i24 + 32 | 0;
 i10 = i24;
 i23 = i24 + 368 | 0;
 i18 = i24 + 312 | 0;
 i13 = i24 + 256 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] & 63](i2, i4, i5, i11);
  STACKTOP = i24;
  return;
 }
 HEAP32[i23 >> 2] = 1124007936;
 i21 = i23 + 4 | 0;
 i2 = i23 + 8 | 0;
 i19 = i23 + 40 | 0;
 i8 = i21 + 0 | 0;
 i9 = i8 + 36 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i19 >> 2] = i2;
 i22 = i23 + 48 | 0;
 i20 = i23 + 44 | 0;
 HEAP32[i20 >> 2] = i22;
 HEAP32[i23 + 52 >> 2] = 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i18 >> 2] = 1124007936;
 i16 = i18 + 4 | 0;
 i2 = i18 + 8 | 0;
 i14 = i18 + 40 | 0;
 i8 = i16 + 0 | 0;
 i9 = i8 + 36 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i14 >> 2] = i2;
 i17 = i18 + 48 | 0;
 i15 = i18 + 44 | 0;
 HEAP32[i15 >> 2] = i17;
 HEAP32[i18 + 52 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 L5 : do if ((i2 | 0) == 33152) {
  d3 = +HEAPF64[i4 + 176 >> 3];
  __ZN2cv3MataSERKS0_(i23, i4 + 8 | 0) | 0;
  i1 = 1;
 } else {
  do if ((i2 | 0) == 33112) {
   if ((HEAP32[i4 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i4 + 184 >> 3] == 0.0) : 0) break;
   if (((+HEAPF64[i4 + 192 >> 3] == 0.0 ? +HEAPF64[i4 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i4 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i4 + 216 >> 3] == 0.0 : 0) {
    d3 = +HEAPF64[i4 + 176 >> 3];
    __ZN2cv3MataSERKS0_(i23, i4 + 8 | 0) | 0;
    i1 = 0;
    break L5;
   }
  } while (0);
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i4, i23, -1);
  i1 = 0;
  d3 = 1.0;
 } while (0);
 i2 = HEAP32[i5 >> 2] | 0;
 L19 : do if ((i2 | 0) == 33152) {
  d3 = d3 * +HEAPF64[i5 + 176 >> 3];
  __ZN2cv3MataSERKS0_(i18, i5 + 8 | 0) | 0;
  i1 = i1 | 2;
 } else {
  do if ((i2 | 0) == 33112) {
   if ((HEAP32[i5 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i5 + 184 >> 3] == 0.0) : 0) break;
   if (((+HEAPF64[i5 + 192 >> 3] == 0.0 ? +HEAPF64[i5 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i5 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i5 + 216 >> 3] == 0.0 : 0) {
    d3 = d3 * +HEAPF64[i5 + 176 >> 3];
    __ZN2cv3MataSERKS0_(i18, i5 + 8 | 0) | 0;
    break L19;
   }
  } while (0);
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i5, i18, -1);
 } while (0);
 HEAP32[i13 >> 2] = 1124007936;
 i6 = i13 + 4 | 0;
 i2 = i13 + 8 | 0;
 i4 = i13 + 40 | 0;
 i8 = i6 + 0 | 0;
 i9 = i8 + 36 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i4 >> 2] = i2;
 i7 = i13 + 48 | 0;
 i5 = i13 + 44 | 0;
 HEAP32[i5 >> 2] = i7;
 HEAP32[i13 + 52 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 HEAP32[i10 + 28 >> 2] = 0;
 HEAPF64[i10 >> 3] = 0.0;
 __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i12, 33136, i1, i23, i18, i13, d3, 1.0, i10);
 i9 = i12;
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i11;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i2;
 __ZN2cv3MataSERKS0_(i11 + 8 | 0, i12 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i11 + 64 | 0, i12 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i11 + 120 | 0, i12 + 120 | 0) | 0;
 i8 = i11 + 176 | 0;
 i2 = i12 + 176 | 0;
 i9 = i8 + 48 | 0;
 do {
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  i8 = i8 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 __ZN2cv7MatExprD2Ev(i12);
 i2 = i13 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i1 = i1 + 12 | 0, i12 = HEAP32[i1 >> 2] | 0, HEAP32[i1 >> 2] = i12 + -1, (i12 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i13);
 HEAP32[i2 >> 2] = 0;
 i13 = i13 + 16 | 0;
 HEAP32[i13 + 0 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 if ((HEAP32[i6 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i6 >> 2] | 0));
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i7 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i18 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i12 = i1 + 12 | 0, i13 = HEAP32[i12 >> 2] | 0, HEAP32[i12 >> 2] = i13 + -1, (i13 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i18);
 HEAP32[i2 >> 2] = 0;
 i18 = i18 + 16 | 0;
 HEAP32[i18 + 0 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 if ((HEAP32[i16 >> 2] | 0) > 0) {
  i2 = HEAP32[i14 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i16 >> 2] | 0));
 }
 i2 = HEAP32[i15 >> 2] | 0;
 if ((i2 | 0) != (i17 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i23 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i17 = i1 + 12 | 0, i18 = HEAP32[i17 >> 2] | 0, HEAP32[i17 >> 2] = i18 + -1, (i18 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i23);
 HEAP32[i2 >> 2] = 0;
 i23 = i23 + 16 | 0;
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 if ((HEAP32[i21 >> 2] | 0) > 0) {
  i1 = HEAP32[i19 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i21 >> 2] | 0));
 }
 i1 = HEAP32[i20 >> 2] | 0;
 if ((i1 | 0) == (i22 | 0)) {
  STACKTOP = i24;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i24;
 return;
}

function __ZN2cvL14MulTransposedLIffEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d31) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d31 = +d31;
 var d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, d33 = 0.0, d34 = 0.0, f35 = f0, i36 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 i25 = i32 + 1040 | 0;
 i24 = i32;
 i29 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 16 >> 2] | 0;
 i30 = (HEAP32[i3 + 48 >> 2] | 0) >>> 2;
 i28 = (HEAP32[i1 + 48 >> 2] | 0) >>> 2;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i22 = (HEAP32[i2 + 48 >> 2] | 0) >>> 2; else i22 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i27 = HEAP32[i3 + 40 >> 2] | 0;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i27 = HEAP32[i27 >> 2] | 0;
 if (!i23) {
  if ((i27 | 0) <= 0) {
   STACKTOP = i32;
   return;
  }
  i7 = i26 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i26 & -4;
  i10 = 0;
  while (1) {
   i1 = Math_imul(i10, i30) | 0;
   i5 = i10;
   do {
    i2 = Math_imul(i5, i30) | 0;
    if (i8) {
     i3 = 0;
     d4 = 0.0;
    } else {
     i3 = 0;
     d4 = 0.0;
     do {
      d34 = +Math_fround(HEAPF32[i29 + (i3 + i1 << 2) >> 2]);
      d34 = d34 * +Math_fround(HEAPF32[i29 + (i3 + i2 << 2) >> 2]);
      i23 = i3 | 1;
      d33 = +Math_fround(HEAPF32[i29 + (i23 + i1 << 2) >> 2]);
      d33 = d34 + d33 * +Math_fround(HEAPF32[i29 + (i23 + i2 << 2) >> 2]);
      i23 = i3 | 2;
      d34 = +Math_fround(HEAPF32[i29 + (i23 + i1 << 2) >> 2]);
      d34 = d33 + d34 * +Math_fround(HEAPF32[i29 + (i23 + i2 << 2) >> 2]);
      i23 = i3 | 3;
      d33 = +Math_fround(HEAPF32[i29 + (i23 + i1 << 2) >> 2]);
      d4 = d4 + (d34 + d33 * +Math_fround(HEAPF32[i29 + (i23 + i2 << 2) >> 2]));
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i7 | 0));
     i3 = i9;
    }
    if ((i3 | 0) < (i26 | 0)) do {
     d33 = +Math_fround(HEAPF32[i29 + (i3 + i1 << 2) >> 2]);
     d4 = d4 + d33 * +Math_fround(HEAPF32[i29 + (i3 + i2 << 2) >> 2]);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i26 | 0));
    HEAPF32[i6 + (i5 << 2) >> 2] = Math_fround(d4 * d31);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 2) | 0;
  }
  STACKTOP = i32;
  return;
 }
 i19 = (i2 | 0) == (i26 | 0) ? 4 : 0;
 i3 = i26 << 2;
 i20 = i24 + 8 | 0;
 HEAP32[i24 >> 2] = i20;
 i21 = i24 + 4 | 0;
 HEAP32[i21 >> 2] = 1032;
 if (i3 >>> 0 > 1032) {
  i18 = __Znaj(i3) | 0;
  HEAP32[i24 >> 2] = i18;
 } else i18 = i20;
 HEAP32[i21 >> 2] = i3;
 if ((i27 | 0) > 0) {
  i1 = (i2 | 0) < (i26 | 0);
  i11 = (i26 | 0) > 0;
  i12 = i25 + 12 | 0;
  i13 = i25 + 8 | 0;
  i14 = i25 + 4 | 0;
  i15 = i26 + -4 | 0;
  i16 = (i15 | 0) < 0;
  i3 = i26 & -4;
  i2 = Math_imul(i19, i3) | 0;
  i17 = 0;
  while (1) {
   i7 = Math_imul(i17, i30) | 0;
   i9 = Math_imul(i17, i22) | 0;
   i8 = i23 + (i9 << 2) | 0;
   if (i1) if (i11) {
    i10 = 0;
    do {
     f35 = Math_fround(HEAPF32[i29 + (i10 + i7 << 2) >> 2]);
     HEAPF32[i18 + (i10 << 2) >> 2] = Math_fround(f35 - Math_fround(HEAPF32[i8 >> 2]));
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17; else if (i11) {
    i10 = 0;
    do {
     f35 = Math_fround(HEAPF32[i29 + (i10 + i7 << 2) >> 2]);
     HEAPF32[i18 + (i10 << 2) >> 2] = Math_fround(f35 - Math_fround(HEAPF32[i23 + (i10 + i9 << 2) >> 2]));
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17;
   do {
    i7 = Math_imul(i5, i30) | 0;
    i10 = i23 + ((Math_imul(i5, i22) | 0) << 2) | 0;
    if (i1) {
     f35 = Math_fround(HEAPF32[i10 >> 2]);
     HEAPF32[i12 >> 2] = f35;
     HEAPF32[i13 >> 2] = f35;
     HEAPF32[i14 >> 2] = f35;
     HEAPF32[i25 >> 2] = f35;
     i10 = i25;
    }
    if (i16) {
     i9 = 0;
     d4 = 0.0;
    } else {
     i8 = i10 + i2 | 0;
     i9 = 0;
     d4 = 0.0;
     while (1) {
      d34 = +Math_fround(HEAPF32[i18 + (i9 << 2) >> 2]);
      f35 = Math_fround(HEAPF32[i29 + (i9 + i7 << 2) >> 2]);
      d34 = d34 * +Math_fround(f35 - Math_fround(HEAPF32[i10 >> 2]));
      i36 = i9 | 1;
      d33 = +Math_fround(HEAPF32[i18 + (i36 << 2) >> 2]);
      f35 = Math_fround(HEAPF32[i29 + (i36 + i7 << 2) >> 2]);
      d33 = d34 + d33 * +Math_fround(f35 - Math_fround(HEAPF32[i10 + 4 >> 2]));
      i36 = i9 | 2;
      d34 = +Math_fround(HEAPF32[i18 + (i36 << 2) >> 2]);
      f35 = Math_fround(HEAPF32[i29 + (i36 + i7 << 2) >> 2]);
      d34 = d33 + d34 * +Math_fround(f35 - Math_fround(HEAPF32[i10 + 8 >> 2]));
      i36 = i9 | 3;
      d33 = +Math_fround(HEAPF32[i18 + (i36 << 2) >> 2]);
      f35 = Math_fround(HEAPF32[i29 + (i36 + i7 << 2) >> 2]);
      d4 = d4 + (d34 + d33 * +Math_fround(f35 - Math_fround(HEAPF32[i10 + 12 >> 2])));
      i9 = i9 + 4 | 0;
      if ((i9 | 0) > (i15 | 0)) break; else i10 = i10 + (i19 << 2) | 0;
     }
     i9 = i3;
     i10 = i8;
    }
    if ((i9 | 0) < (i26 | 0)) while (1) {
     d33 = +Math_fround(HEAPF32[i18 + (i9 << 2) >> 2]);
     f35 = Math_fround(HEAPF32[i29 + (i9 + i7 << 2) >> 2]);
     d4 = d4 + d33 * +Math_fround(f35 - Math_fround(HEAPF32[i10 >> 2]));
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i26 | 0)) break; else i10 = i10 + 4 | 0;
    }
    HEAPF32[i6 + (i5 << 2) >> 2] = Math_fround(d4 * d31);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i17 = i17 + 1 | 0;
   if ((i17 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 2) | 0;
  }
 }
 if ((i18 | 0) == (i20 | 0)) {
  STACKTOP = i32;
  return;
 }
 __ZdaPv(i18);
 HEAP32[i24 >> 2] = i20;
 HEAP32[i21 >> 2] = 1032;
 STACKTOP = i32;
 return;
}

function __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i17, i11) {
 i17 = i17 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i16 = i18;
 i4 = i18 + 64 | 0;
 i10 = i18 + 56 | 0;
 i13 = i18 + 48 | 0;
 i5 = i18 + 40 | 0;
 i14 = i18 + 32 | 0;
 i15 = i18 + 24 | 0;
 i8 = i18 + 16 | 0;
 i9 = i18 + 8 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i12 = (i12 | 0) == 0 ? 12512 : i12;
 if (!((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] & 127](i17) | 0) & (i12 | 0) != 0)) {
  STACKTOP = i18;
  return i17 | 0;
 }
 i2 = HEAP8[i12 >> 0] | 0;
 if (i2 << 24 >> 24 == 93 | i2 << 24 >> 24 == 125) {
  i6 = i17 + 20 | 0;
  i5 = i17 + 24 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((HEAP32[i6 >> 2] | 0) == (i1 | 0)) {
   HEAP32[i16 >> 2] = i2 << 24 >> 24;
   __ZN2cv6formatEPKcz(i4, 11328, i16);
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i4, 11352, 8960, 5191);
   __ZN2cv6String10deallocateEv(i4);
   i2 = HEAP8[i12 >> 0] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i3 = HEAP8[i1 + -1 >> 0] | 0;
  if (((i2 << 24 >> 24 == 93 ? 91 : 123) | 0) != (i3 | 0)) {
   HEAP32[i16 >> 2] = i2 << 24 >> 24;
   HEAP32[i16 + 4 >> 2] = i3;
   __ZN2cv6formatEPKcz(i10, 11368, i16);
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i10, 11352, 8960, 5194);
   __ZN2cv6String10deallocateEv(i10);
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i10 = i1 + -1 | 0;
  HEAP32[i5 >> 2] = i10;
  if ((HEAP32[i6 >> 2] | 0) == (i10 | 0)) i1 = 6; else i1 = (HEAP8[i1 + -2 >> 0] | 0) == 123 ? 6 : 1;
  HEAP32[i17 + 32 >> 2] = i1;
  _cvEndWriteStruct(HEAP32[i17 + 8 >> 2] | 0);
  i3 = i17 + 12 | 0;
  HEAP32[i13 >> 2] = 0;
  i2 = i13 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  if ((i13 | 0) != (i3 | 0)) {
   __ZN2cv6String10deallocateEv(i3);
   i1 = HEAP32[i13 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i1 = i1 + -4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = HEAP32[i13 >> 2] | 0;
   }
   HEAP32[i3 >> 2] = i1;
   HEAP32[i17 + 16 >> 2] = HEAP32[i2 >> 2];
  }
  __ZN2cv6String10deallocateEv(i13);
  STACKTOP = i18;
  return i17 | 0;
 }
 i4 = i17 + 32 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 if ((i6 | 0) == 6) {
  if (!((i2 + -97 << 24 >> 24 & 255) < 26 | (i2 + -65 << 24 >> 24 & 255) < 26)) {
   HEAP32[i16 >> 2] = i12;
   __ZN2cv6formatEPKcz(i5, 11424, i16);
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i5, 11352, 8960, 5204);
   __ZN2cv6String10deallocateEv(i5);
  }
  i3 = i17 + 12 | 0;
  if ((i3 | 0) != (i11 | 0)) {
   __ZN2cv6String10deallocateEv(i3);
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i1 = i1 + -4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i3 >> 2] = i1;
   HEAP32[i17 + 16 >> 2] = HEAP32[i11 + 4 >> 2];
  }
  HEAP32[i4 >> 2] = 5;
  STACKTOP = i18;
  return i17 | 0;
 }
 if ((i6 & 3 | 0) != 1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i9, 16) | 0) + 0 | 0;
  i2 = 11456;
  i3 = i1 + 16 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i9, 11352, 8960, 5234);
  __ZN2cv6String10deallocateEv(i9);
  STACKTOP = i18;
  return i17 | 0;
 }
 if (i2 << 24 >> 24 == 92) {
  i3 = i12 + 1 | 0;
  i10 = HEAP8[i3 >> 0] | 0;
  if (i10 << 24 >> 24 == 93 | i10 << 24 >> 24 == 91 | i10 << 24 >> 24 == 125 | i10 << 24 >> 24 == 123) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i10 = _strlen(i3 | 0) | 0;
   _memcpy(__ZN2cv6String8allocateEj(i8, i10) | 0, i3 | 0, i10 | 0) | 0;
  } else i7 = 40;
 } else if (i2 << 24 >> 24 == 91 | i2 << 24 >> 24 == 123) {
  i1 = i17 + 24 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i17 + 28 >> 2] | 0)) __ZNSt3__16vectorIcNS_9allocatorIcEEE21__push_back_slow_pathIKcEEvRT_(i17 + 20 | 0, i12); else {
   if (!i3) i3 = 0; else {
    HEAP8[i3 >> 0] = i2;
    i3 = HEAP32[i1 >> 2] | 0;
   }
   HEAP32[i1 >> 2] = i3 + 1;
  }
  i3 = i12 + 1 | 0;
  i10 = (HEAP8[i12 >> 0] | 0) == 123;
  i2 = i10 ? 6 : 5;
  HEAP32[i4 >> 2] = i10 ? 6 : 1;
  if ((HEAP8[i3 >> 0] | 0) == 58) {
   i3 = i12 + 2 | 0;
   i2 = i2 | 8;
  }
  i1 = HEAP32[i17 + 8 >> 2] | 0;
  i5 = i17 + 12 | 0;
  i6 = i17 + 16 | 0;
  if (!(HEAP32[i6 >> 2] | 0)) i4 = 0; else {
   i4 = HEAP32[i5 >> 2] | 0;
   i4 = (i4 | 0) == 0 ? 12512 : i4;
  }
  i10 = (HEAP8[i3 >> 0] | 0) != 0 ? i3 : 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i16 + 0 >> 2] = HEAP32[i14 + 0 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  _cvStartWriteStruct(i1, i4, i2, i10, i16);
  HEAP32[i15 >> 2] = 0;
  i2 = i15 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  if ((i15 | 0) != (i5 | 0)) {
   __ZN2cv6String10deallocateEv(i5);
   i3 = HEAP32[i15 >> 2] | 0;
   if (!i3) i3 = 0; else {
    i3 = i3 + -4 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
    i3 = HEAP32[i15 >> 2] | 0;
   }
   HEAP32[i5 >> 2] = i3;
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  }
  __ZN2cv6String10deallocateEv(i15);
  STACKTOP = i18;
  return i17 | 0;
 } else i7 = 40;
 if ((i7 | 0) == 40 ? (i1 = HEAP32[i11 >> 2] | 0, HEAP32[i8 >> 2] = i1, HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2], (i1 | 0) != 0) : 0) {
  i10 = i1 + -4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 if (!(HEAP32[i17 + 16 >> 2] | 0)) i1 = 0; else {
  i1 = HEAP32[i17 + 12 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? 12512 : i1;
 }
 i10 = HEAP32[i8 >> 2] | 0;
 _cvWriteString(HEAP32[i17 + 8 >> 2] | 0, i1, (i10 | 0) == 0 ? 12512 : i10, 0);
 __ZN2cv6String10deallocateEv(i8);
 if ((HEAP32[i4 >> 2] | 0) != 5) {
  STACKTOP = i18;
  return i17 | 0;
 }
 HEAP32[i4 >> 2] = 6;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZNK2cv12MatAllocator8downloadEPNS_8UMatDataEPviPKjS5_S5_S5_(i2, i3, i17, i16, i10, i9, i13, i18) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i18 = i18 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i15 = i27 + 168 | 0;
 i8 = i27 + 160 | 0;
 i26 = i27 + 104 | 0;
 i25 = i27 + 48 | 0;
 i14 = i27 + 40 | 0;
 i20 = i27 + 32 | 0;
 i19 = i27;
 if (!i3) {
  STACKTOP = i27;
  return;
 }
 i3 = HEAP32[i3 + 16 >> 2] | 0;
 L4 : do if ((i16 | 0) > 0) {
  i1 = (i9 | 0) == 0;
  i5 = i16 + -2 | 0;
  i6 = i8 + 4 | 0;
  i7 = 0;
  while (1) {
   i2 = i10 + (i7 << 2) | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   if ((i4 | 0) > -1) i2 = i4; else {
    HEAP32[i8 >> 2] = 0;
    HEAP32[i6 >> 2] = 0;
    i11 = (__ZN2cv6String8allocateEj(i8, 24) | 0) + 0 | 0;
    i4 = 27480;
    i12 = i11 + 24 | 0;
    do {
     HEAP8[i11 >> 0] = HEAP8[i4 >> 0] | 0;
     i11 = i11 + 1 | 0;
     i4 = i4 + 1 | 0;
    } while ((i11 | 0) < (i12 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 27512, 27528, 78);
    __ZN2cv6String10deallocateEv(i8);
    i2 = HEAP32[i2 >> 2] | 0;
   }
   if (!i2) break;
   if (!i1) {
    if ((i7 | 0) > (i5 | 0)) i4 = 1; else i4 = HEAP32[i13 + (i7 << 2) >> 2] | 0;
    i3 = i3 + (Math_imul(i4, HEAP32[i9 + (i7 << 2) >> 2] | 0) | 0) | 0;
   }
   HEAP32[i15 + (i7 << 2) >> 2] = i2;
   i7 = i7 + 1 | 0;
   if ((i7 | 0) >= (i16 | 0)) {
    i2 = i3;
    break L4;
   }
  }
  STACKTOP = i27;
  return;
 } else i2 = i3; while (0);
 i23 = i26 + 4 | 0;
 i3 = i26 + 8 | 0;
 i6 = i26 + 16 | 0;
 i4 = i26 + 20 | 0;
 i21 = i26 + 40 | 0;
 i11 = i23 + 0 | 0;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAP32[i21 >> 2] = i3;
 i24 = i26 + 48 | 0;
 i22 = i26 + 44 | 0;
 HEAP32[i22 >> 2] = i24;
 HEAP32[i26 + 52 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i26 >> 2] = 1124007936;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i4 >> 2] = i2;
 __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i26, i16, i15, i13, 1);
 __ZN2cvL11finalizeHdrERNS_3MatE(i26);
 i5 = i25 + 4 | 0;
 i4 = i25 + 8 | 0;
 i9 = i25 + 16 | 0;
 i3 = i25 + 20 | 0;
 i8 = i25 + 40 | 0;
 i11 = i5 + 0 | 0;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAP32[i8 >> 2] = i4;
 i7 = i25 + 48 | 0;
 i10 = i25 + 44 | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i25 + 52 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i25 >> 2] = 1124007936;
 HEAP32[i9 >> 2] = i17;
 HEAP32[i3 >> 2] = i17;
 __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i25, i16, i15, i18, 1);
 __ZN2cvL11finalizeHdrERNS_3MatE(i25);
 HEAP32[i14 >> 2] = i26;
 HEAP32[i14 + 4 >> 2] = i25;
 HEAP32[i19 + 0 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP32[i19 + 24 >> 2] = 0;
 HEAP32[i19 + 28 >> 2] = 0;
 __ZN2cv15NAryMatIterator4initEPPKNS_3MatEPS1_PPhi(i19, i14, 0, i20, 2);
 i3 = HEAP32[i19 + 20 >> 2] | 0;
 i2 = i19 + 16 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = i20 + 4 | 0;
  i4 = 0;
  do {
   _memcpy(HEAP32[i1 >> 2] | 0, HEAP32[i20 >> 2] | 0, i3 | 0) | 0;
   i4 = i4 + 1 | 0;
   __ZN2cv15NAryMatIteratorppEv(i19) | 0;
  } while (i4 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i4 = i25 + 36 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i19 = i3 + 12 | 0, i20 = HEAP32[i19 >> 2] | 0, HEAP32[i19 >> 2] = i20 + -1, (i20 | 0) == 1) : 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  if (i2) {
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i3) {
    i3 = HEAP32[i25 + 32 >> 2] | 0;
    if (!i3) {
     if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
      i20 = __Znwj(4) | 0;
      HEAP32[i20 >> 2] = 32784;
      HEAP32[6904] = i20;
      ___cxa_guard_release(27624);
     }
     i3 = HEAP32[6904] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3, i2);
  }
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 if ((HEAP32[i5 >> 2] | 0) > 0) {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i5 >> 2] | 0));
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i7 | 0)) __ZN2cv8fastFreeEPv(i2);
 i3 = i26 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i19 = i2 + 12 | 0, i20 = HEAP32[i19 >> 2] | 0, HEAP32[i19 >> 2] = i20 + -1, (i20 | 0) == 1) : 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2) {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i26 + 32 >> 2] | 0;
    if (!i1) {
     if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
      i20 = __Znwj(4) | 0;
      HEAP32[i20 >> 2] = 32784;
      HEAP32[6904] = i20;
      ___cxa_guard_release(27624);
     }
     i1 = HEAP32[6904] | 0;
     i2 = HEAP32[i3 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i2);
  }
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 if ((HEAP32[i23 >> 2] | 0) > 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i23 >> 2] | 0));
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if ((i1 | 0) == (i24 | 0)) {
  STACKTOP = i27;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i27;
 return;
}

function __ZN7testing8internal10ParseInt32ERKNS_7MessageEPKcPi(i4, i6, i3) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i11 = i12;
 i5 = i12 + 44 | 0;
 i9 = i12 + 40 | 0;
 i7 = i12 + 28 | 0;
 i10 = i12 + 24 | 0;
 i8 = i12 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i2 = _strtol(i6, i5, 10) | 0;
 if (HEAP8[HEAP32[i5 >> 2] >> 0] | 0) {
  __ZN7testing7MessageC2Ev(i9);
  i5 = HEAP32[i9 >> 2] | 0;
  i3 = i5 + 8 | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 164776, 9) | 0;
  __ZNK7testing7Message9GetStringEv(i11, i4);
  i2 = HEAP8[i11 >> 0] | 0;
  if (!(i2 & 1)) {
   i1 = i11 + 1 | 0;
   i2 = (i2 & 255) >>> 1;
  } else {
   i1 = HEAP32[i11 + 8 >> 2] | 0;
   i2 = HEAP32[i11 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, i1, i2) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 164792, 49) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 164848, 12) | 0;
  if (!i6) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, i6, _strlen(i6 | 0) | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 164864, 3) | 0;
  __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i11, i5 + 12 | 0);
  i1 = HEAP8[i11 >> 0] | 0;
  if (!(i1 & 1)) {
   i2 = i11 + 1 | 0;
   i1 = (i1 & 255) >>> 1;
  } else {
   i2 = HEAP32[i11 + 8 >> 2] | 0;
   i1 = HEAP32[i11 + 4 >> 2] | 0;
  }
  i3 = i2 + i1 | 0;
  HEAP32[i7 + 0 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i7, i1 << 1);
  if (i1) do {
   i1 = HEAP8[i2 >> 0] | 0;
   if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, i1);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  if (!(HEAP8[i7 >> 0] & 1)) i1 = i7 + 1 | 0; else i1 = HEAP32[i7 + 8 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  _printf(163e3, i11 | 0) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
  _fflush(HEAP32[_stdout >> 2] | 0) | 0;
  if (!i5) {
   i10 = 0;
   STACKTOP = i12;
   return i10 | 0;
  }
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 511](i5);
  HEAP32[i9 >> 2] = 0;
  i10 = 0;
  STACKTOP = i12;
  return i10 | 0;
 }
 if ((i2 + -2147483647 | 0) >>> 0 >= 2) {
  HEAP32[i3 >> 2] = i2;
  i10 = 1;
  STACKTOP = i12;
  return i10 | 0;
 }
 __ZN7testing7MessageC2Ev(i10);
 i5 = HEAP32[i10 >> 2] | 0;
 i1 = i5 + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 164776, 9) | 0;
 __ZNK7testing7Message9GetStringEv(i11, i4);
 i2 = HEAP8[i11 >> 0] | 0;
 if (!(i2 & 1)) {
  i3 = i11 + 1 | 0;
  i2 = (i2 & 255) >>> 1;
 } else {
  i3 = HEAP32[i11 + 8 >> 2] | 0;
  i2 = HEAP32[i11 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i3, i2) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 164792, 49) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 164872, 11) | 0;
 if (!i6) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i6, _strlen(i6 | 0) | 0) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 164888, 19) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i11, i5 + 12 | 0);
 i1 = HEAP8[i11 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i11 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i11 + 8 >> 2] | 0;
  i1 = HEAP32[i11 + 4 >> 2] | 0;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i8, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i8, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i8, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
 if (!(HEAP8[i8 >> 0] & 1)) i1 = i8 + 1 | 0; else i1 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 _printf(163e3, i11 | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
 _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 if (!i5) {
  i10 = 0;
  STACKTOP = i12;
  return i10 | 0;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 511](i5);
 HEAP32[i10 >> 2] = 0;
 i10 = 0;
 STACKTOP = i12;
 return i10 | 0;
}

function __ZNK2cv12MatAllocator6uploadEPNS_8UMatDataEPKviPKjS6_S6_S6_(i2, i3, i13, i17, i10, i9, i18, i14) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i17 = i17 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i16 = i27 + 168 | 0;
 i8 = i27 + 160 | 0;
 i26 = i27 + 104 | 0;
 i25 = i27 + 48 | 0;
 i15 = i27 + 40 | 0;
 i20 = i27 + 32 | 0;
 i19 = i27;
 if (!i3) {
  STACKTOP = i27;
  return;
 }
 i3 = HEAP32[i3 + 16 >> 2] | 0;
 L4 : do if ((i17 | 0) > 0) {
  i5 = (i9 | 0) == 0;
  i6 = i17 + -2 | 0;
  i7 = i8 + 4 | 0;
  i1 = 0;
  while (1) {
   i2 = i10 + (i1 << 2) | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   if ((i4 | 0) > -1) i2 = i4; else {
    HEAP32[i8 >> 2] = 0;
    HEAP32[i7 >> 2] = 0;
    i11 = (__ZN2cv6String8allocateEj(i8, 24) | 0) + 0 | 0;
    i4 = 27480;
    i12 = i11 + 24 | 0;
    do {
     HEAP8[i11 >> 0] = HEAP8[i4 >> 0] | 0;
     i11 = i11 + 1 | 0;
     i4 = i4 + 1 | 0;
    } while ((i11 | 0) < (i12 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 27584, 27528, 109);
    __ZN2cv6String10deallocateEv(i8);
    i2 = HEAP32[i2 >> 2] | 0;
   }
   if (!i2) break;
   if (!i5) {
    if ((i1 | 0) > (i6 | 0)) i4 = 1; else i4 = HEAP32[i18 + (i1 << 2) >> 2] | 0;
    i3 = i3 + (Math_imul(i4, HEAP32[i9 + (i1 << 2) >> 2] | 0) | 0) | 0;
   }
   HEAP32[i16 + (i1 << 2) >> 2] = i2;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i17 | 0)) break L4;
  }
  STACKTOP = i27;
  return;
 } while (0);
 i23 = i26 + 4 | 0;
 i2 = i26 + 8 | 0;
 i6 = i26 + 16 | 0;
 i4 = i26 + 20 | 0;
 i21 = i26 + 40 | 0;
 i11 = i23 + 0 | 0;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAP32[i21 >> 2] = i2;
 i24 = i26 + 48 | 0;
 i22 = i26 + 44 | 0;
 HEAP32[i22 >> 2] = i24;
 HEAP32[i26 + 52 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i26 >> 2] = 1124007936;
 HEAP32[i6 >> 2] = i13;
 HEAP32[i4 >> 2] = i13;
 __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i26, i17, i16, i14, 1);
 __ZN2cvL11finalizeHdrERNS_3MatE(i26);
 i5 = i25 + 4 | 0;
 i4 = i25 + 8 | 0;
 i9 = i25 + 16 | 0;
 i2 = i25 + 20 | 0;
 i8 = i25 + 40 | 0;
 i11 = i5 + 0 | 0;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAP32[i8 >> 2] = i4;
 i7 = i25 + 48 | 0;
 i10 = i25 + 44 | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i25 + 52 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i25 >> 2] = 1124007936;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i2 >> 2] = i3;
 __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i25, i17, i16, i18, 1);
 __ZN2cvL11finalizeHdrERNS_3MatE(i25);
 HEAP32[i15 >> 2] = i26;
 HEAP32[i15 + 4 >> 2] = i25;
 HEAP32[i19 + 0 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP32[i19 + 24 >> 2] = 0;
 HEAP32[i19 + 28 >> 2] = 0;
 __ZN2cv15NAryMatIterator4initEPPKNS_3MatEPS1_PPhi(i19, i15, 0, i20, 2);
 i3 = HEAP32[i19 + 20 >> 2] | 0;
 i2 = i19 + 16 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = i20 + 4 | 0;
  i4 = 0;
  do {
   _memcpy(HEAP32[i1 >> 2] | 0, HEAP32[i20 >> 2] | 0, i3 | 0) | 0;
   i4 = i4 + 1 | 0;
   __ZN2cv15NAryMatIteratorppEv(i19) | 0;
  } while (i4 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i4 = i25 + 36 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i19 = i3 + 12 | 0, i20 = HEAP32[i19 >> 2] | 0, HEAP32[i19 >> 2] = i20 + -1, (i20 | 0) == 1) : 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  if (i2) {
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i3) {
    i3 = HEAP32[i25 + 32 >> 2] | 0;
    if (!i3) {
     if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
      i20 = __Znwj(4) | 0;
      HEAP32[i20 >> 2] = 32784;
      HEAP32[6904] = i20;
      ___cxa_guard_release(27624);
     }
     i3 = HEAP32[6904] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3, i2);
  }
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 if ((HEAP32[i5 >> 2] | 0) > 0) {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i5 >> 2] | 0));
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i7 | 0)) __ZN2cv8fastFreeEPv(i2);
 i3 = i26 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i19 = i2 + 12 | 0, i20 = HEAP32[i19 >> 2] | 0, HEAP32[i19 >> 2] = i20 + -1, (i20 | 0) == 1) : 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2) {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i26 + 32 >> 2] | 0;
    if (!i1) {
     if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
      i20 = __Znwj(4) | 0;
      HEAP32[i20 >> 2] = 32784;
      HEAP32[6904] = i20;
      ___cxa_guard_release(27624);
     }
     i1 = HEAP32[6904] | 0;
     i2 = HEAP32[i3 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i2);
  }
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 if ((HEAP32[i23 >> 2] | 0) > 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i23 >> 2] | 0));
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if ((i1 | 0) == (i24 | 0)) {
  STACKTOP = i27;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i27;
 return;
}

function __ZN2cvL14MulTransposedLItfEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d31) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d31 = +d31;
 var d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, f33 = f0, d34 = 0.0, d35 = 0.0, i36 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 i25 = i32 + 1040 | 0;
 i24 = i32;
 i29 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 16 >> 2] | 0;
 i30 = (HEAP32[i3 + 48 >> 2] | 0) >>> 1;
 i28 = (HEAP32[i1 + 48 >> 2] | 0) >>> 2;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i22 = (HEAP32[i2 + 48 >> 2] | 0) >>> 2; else i22 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i27 = HEAP32[i3 + 40 >> 2] | 0;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i27 = HEAP32[i27 >> 2] | 0;
 if (!i23) {
  if ((i27 | 0) <= 0) {
   STACKTOP = i32;
   return;
  }
  i7 = i26 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i26 & -4;
  i10 = 0;
  while (1) {
   i1 = Math_imul(i10, i30) | 0;
   i5 = i10;
   do {
    i2 = Math_imul(i5, i30) | 0;
    if (i8) {
     i3 = 0;
     d4 = 0.0;
    } else {
     i3 = 0;
     d4 = 0.0;
     do {
      i21 = i3 | 1;
      i22 = i3 | 2;
      i23 = i3 | 3;
      d4 = d4 + (+(HEAPU16[i29 + (i3 + i1 << 1) >> 1] | 0) * +(HEAPU16[i29 + (i3 + i2 << 1) >> 1] | 0 | 0) + +(HEAPU16[i29 + (i21 + i1 << 1) >> 1] | 0) * +(HEAPU16[i29 + (i21 + i2 << 1) >> 1] | 0 | 0) + +(HEAPU16[i29 + (i22 + i1 << 1) >> 1] | 0) * +(HEAPU16[i29 + (i22 + i2 << 1) >> 1] | 0 | 0) + +(HEAPU16[i29 + (i23 + i1 << 1) >> 1] | 0) * +(HEAPU16[i29 + (i23 + i2 << 1) >> 1] | 0 | 0));
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i7 | 0));
     i3 = i9;
    }
    if ((i3 | 0) < (i26 | 0)) do {
     d4 = d4 + +(HEAPU16[i29 + (i3 + i1 << 1) >> 1] | 0) * +(HEAPU16[i29 + (i3 + i2 << 1) >> 1] | 0 | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i26 | 0));
    HEAPF32[i6 + (i5 << 2) >> 2] = Math_fround(d4 * d31);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 2) | 0;
  }
  STACKTOP = i32;
  return;
 }
 i19 = (i2 | 0) == (i26 | 0) ? 4 : 0;
 i3 = i26 << 2;
 i20 = i24 + 8 | 0;
 HEAP32[i24 >> 2] = i20;
 i21 = i24 + 4 | 0;
 HEAP32[i21 >> 2] = 1032;
 if (i3 >>> 0 > 1032) {
  i18 = __Znaj(i3) | 0;
  HEAP32[i24 >> 2] = i18;
 } else i18 = i20;
 HEAP32[i21 >> 2] = i3;
 if ((i27 | 0) > 0) {
  i15 = (i2 | 0) < (i26 | 0);
  i16 = (i26 | 0) > 0;
  i3 = i25 + 12 | 0;
  i2 = i25 + 8 | 0;
  i1 = i25 + 4 | 0;
  i11 = i26 + -4 | 0;
  i12 = (i11 | 0) < 0;
  i13 = i26 & -4;
  i14 = Math_imul(i19, i13) | 0;
  i17 = 0;
  while (1) {
   i7 = Math_imul(i17, i30) | 0;
   i9 = Math_imul(i17, i22) | 0;
   i8 = i23 + (i9 << 2) | 0;
   if (i15) if (i16) {
    i10 = 0;
    do {
     f33 = Math_fround(HEAPU16[i29 + (i10 + i7 << 1) >> 1] | 0 | 0);
     HEAPF32[i18 + (i10 << 2) >> 2] = Math_fround(f33 - Math_fround(HEAPF32[i8 >> 2]));
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17; else if (i16) {
    i10 = 0;
    do {
     f33 = Math_fround(HEAPU16[i29 + (i10 + i7 << 1) >> 1] | 0 | 0);
     HEAPF32[i18 + (i10 << 2) >> 2] = Math_fround(f33 - Math_fround(HEAPF32[i23 + (i10 + i9 << 2) >> 2]));
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17;
   do {
    i7 = Math_imul(i5, i30) | 0;
    i10 = i23 + ((Math_imul(i5, i22) | 0) << 2) | 0;
    if (i15) {
     f33 = Math_fround(HEAPF32[i10 >> 2]);
     HEAPF32[i3 >> 2] = f33;
     HEAPF32[i2 >> 2] = f33;
     HEAPF32[i1 >> 2] = f33;
     HEAPF32[i25 >> 2] = f33;
     i10 = i25;
    }
    if (i12) {
     i9 = 0;
     d4 = 0.0;
    } else {
     i8 = i10 + i14 | 0;
     i9 = 0;
     d4 = 0.0;
     while (1) {
      d35 = +Math_fround(HEAPF32[i18 + (i9 << 2) >> 2]);
      f33 = Math_fround(HEAPU16[i29 + (i9 + i7 << 1) >> 1] | 0 | 0);
      d35 = d35 * +Math_fround(f33 - Math_fround(HEAPF32[i10 >> 2]));
      i36 = i9 | 1;
      d34 = +Math_fround(HEAPF32[i18 + (i36 << 2) >> 2]);
      f33 = Math_fround(HEAPU16[i29 + (i36 + i7 << 1) >> 1] | 0 | 0);
      d34 = d35 + d34 * +Math_fround(f33 - Math_fround(HEAPF32[i10 + 4 >> 2]));
      i36 = i9 | 2;
      d35 = +Math_fround(HEAPF32[i18 + (i36 << 2) >> 2]);
      f33 = Math_fround(HEAPU16[i29 + (i36 + i7 << 1) >> 1] | 0 | 0);
      d35 = d34 + d35 * +Math_fround(f33 - Math_fround(HEAPF32[i10 + 8 >> 2]));
      i36 = i9 | 3;
      d34 = +Math_fround(HEAPF32[i18 + (i36 << 2) >> 2]);
      f33 = Math_fround(HEAPU16[i29 + (i36 + i7 << 1) >> 1] | 0 | 0);
      d4 = d4 + (d35 + d34 * +Math_fround(f33 - Math_fround(HEAPF32[i10 + 12 >> 2])));
      i9 = i9 + 4 | 0;
      if ((i9 | 0) > (i11 | 0)) break; else i10 = i10 + (i19 << 2) | 0;
     }
     i9 = i13;
     i10 = i8;
    }
    if ((i9 | 0) < (i26 | 0)) while (1) {
     d34 = +Math_fround(HEAPF32[i18 + (i9 << 2) >> 2]);
     f33 = Math_fround(HEAPU16[i29 + (i9 + i7 << 1) >> 1] | 0 | 0);
     d4 = d4 + d34 * +Math_fround(f33 - Math_fround(HEAPF32[i10 >> 2]));
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i26 | 0)) break; else i10 = i10 + 4 | 0;
    }
    HEAPF32[i6 + (i5 << 2) >> 2] = Math_fround(d4 * d31);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i17 = i17 + 1 | 0;
   if ((i17 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 2) | 0;
  }
 }
 if ((i18 | 0) == (i20 | 0)) {
  STACKTOP = i32;
  return;
 }
 __ZdaPv(i18);
 HEAP32[i24 >> 2] = i20;
 HEAP32[i21 >> 2] = 1032;
 STACKTOP = i32;
 return;
}

function _compress_block(i19, i18, i16) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i20 = 0;
 i20 = STACKTOP;
 i9 = i19 + 5792 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) {
  i6 = HEAP32[i19 + 5820 >> 2] | 0;
  i1 = HEAP16[i19 + 5816 >> 1] | 0;
 } else {
  i10 = i19 + 5796 | 0;
  i11 = i19 + 5784 | 0;
  i12 = i19 + 5820 | 0;
  i13 = i19 + 5816 | 0;
  i14 = i19 + 20 | 0;
  i15 = i19 + 8 | 0;
  i17 = 0;
  do {
   i6 = HEAP16[(HEAP32[i10 >> 2] | 0) + (i17 << 1) >> 1] | 0;
   i7 = i6 & 65535;
   i8 = HEAPU8[(HEAP32[i11 >> 2] | 0) + i17 >> 0] | 0;
   i17 = i17 + 1 | 0;
   do if (!(i6 << 16 >> 16)) {
    i4 = HEAPU16[i18 + (i8 << 2) + 2 >> 1] | 0;
    i3 = HEAP32[i12 >> 2] | 0;
    i6 = HEAPU16[i18 + (i8 << 2) >> 1] | 0;
    i5 = HEAPU16[i13 >> 1] | 0 | i6 << i3;
    i1 = i5 & 65535;
    HEAP16[i13 >> 1] = i1;
    if ((i3 | 0) > (16 - i4 | 0)) {
     i1 = HEAP32[i14 >> 2] | 0;
     HEAP32[i14 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i15 >> 2] | 0) + i1 >> 0] = i5;
     i1 = (HEAPU16[i13 >> 1] | 0) >>> 8 & 255;
     i8 = HEAP32[i14 >> 2] | 0;
     HEAP32[i14 >> 2] = i8 + 1;
     HEAP8[(HEAP32[i15 >> 2] | 0) + i8 >> 0] = i1;
     i8 = HEAP32[i12 >> 2] | 0;
     i1 = i6 >>> (16 - i8 | 0) & 65535;
     HEAP16[i13 >> 1] = i1;
     i6 = i4 + -16 + i8 | 0;
     HEAP32[i12 >> 2] = i6;
     break;
    } else {
     i6 = i3 + i4 | 0;
     HEAP32[i12 >> 2] = i6;
     break;
    }
   } else {
    i1 = HEAPU8[155648 + i8 >> 0] | 0;
    i6 = (i1 | 256) + 1 | 0;
    i3 = HEAPU16[i18 + (i6 << 2) + 2 >> 1] | 0;
    i2 = HEAP32[i12 >> 2] | 0;
    i6 = HEAPU16[i18 + (i6 << 2) >> 1] | 0;
    i5 = HEAPU16[i13 >> 1] | 0 | i6 << i2;
    i4 = i5 & 65535;
    HEAP16[i13 >> 1] = i4;
    if ((i2 | 0) > (16 - i3 | 0)) {
     i4 = HEAP32[i14 >> 2] | 0;
     HEAP32[i14 >> 2] = i4 + 1;
     HEAP8[(HEAP32[i15 >> 2] | 0) + i4 >> 0] = i5;
     i4 = (HEAPU16[i13 >> 1] | 0) >>> 8 & 255;
     i5 = HEAP32[i14 >> 2] | 0;
     HEAP32[i14 >> 2] = i5 + 1;
     HEAP8[(HEAP32[i15 >> 2] | 0) + i5 >> 0] = i4;
     i5 = HEAP32[i12 >> 2] | 0;
     i4 = i6 >>> (16 - i5 | 0) & 65535;
     HEAP16[i13 >> 1] = i4;
     i3 = i3 + -16 + i5 | 0;
    } else i3 = i2 + i3 | 0;
    HEAP32[i12 >> 2] = i3;
    i2 = HEAP32[157248 + (i1 << 2) >> 2] | 0;
    do if ((i1 + -8 | 0) >>> 0 < 20) {
     i5 = i8 - (HEAP32[157368 + (i1 << 2) >> 2] | 0) & 65535;
     i6 = i5 << i3 | i4 & 65535;
     i4 = i6 & 65535;
     HEAP16[i13 >> 1] = i4;
     if ((i3 | 0) > (16 - i2 | 0)) {
      i4 = HEAP32[i14 >> 2] | 0;
      HEAP32[i14 >> 2] = i4 + 1;
      HEAP8[(HEAP32[i15 >> 2] | 0) + i4 >> 0] = i6;
      i4 = (HEAPU16[i13 >> 1] | 0) >>> 8 & 255;
      i8 = HEAP32[i14 >> 2] | 0;
      HEAP32[i14 >> 2] = i8 + 1;
      HEAP8[(HEAP32[i15 >> 2] | 0) + i8 >> 0] = i4;
      i8 = HEAP32[i12 >> 2] | 0;
      i4 = i5 >>> (16 - i8 | 0) & 65535;
      HEAP16[i13 >> 1] = i4;
      i8 = i2 + -16 + i8 | 0;
      HEAP32[i12 >> 2] = i8;
      break;
     } else {
      i8 = i3 + i2 | 0;
      HEAP32[i12 >> 2] = i8;
      break;
     }
    } else i8 = i3; while (0);
    i7 = i7 + -1 | 0;
    if (i7 >>> 0 < 256) i6 = i7; else i6 = (i7 >>> 7) + 256 | 0;
    i2 = HEAPU8[155136 + i6 >> 0] | 0;
    i5 = HEAPU16[i16 + (i2 << 2) + 2 >> 1] | 0;
    i3 = HEAPU16[i16 + (i2 << 2) >> 1] | 0;
    i6 = i4 & 65535 | i3 << i8;
    i1 = i6 & 65535;
    HEAP16[i13 >> 1] = i1;
    if ((i8 | 0) > (16 - i5 | 0)) {
     i1 = HEAP32[i14 >> 2] | 0;
     HEAP32[i14 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i15 >> 2] | 0) + i1 >> 0] = i6;
     i1 = (HEAPU16[i13 >> 1] | 0) >>> 8 & 255;
     i6 = HEAP32[i14 >> 2] | 0;
     HEAP32[i14 >> 2] = i6 + 1;
     HEAP8[(HEAP32[i15 >> 2] | 0) + i6 >> 0] = i1;
     i6 = HEAP32[i12 >> 2] | 0;
     i1 = i3 >>> (16 - i6 | 0) & 65535;
     HEAP16[i13 >> 1] = i1;
     i6 = i5 + -16 + i6 | 0;
    } else i6 = i8 + i5 | 0;
    HEAP32[i12 >> 2] = i6;
    i3 = HEAP32[157488 + (i2 << 2) >> 2] | 0;
    if ((i2 + -4 | 0) >>> 0 < 26) {
     i4 = i7 - (HEAP32[157608 + (i2 << 2) >> 2] | 0) & 65535;
     i5 = i4 << i6 | i1 & 65535;
     i1 = i5 & 65535;
     HEAP16[i13 >> 1] = i1;
     if ((i6 | 0) > (16 - i3 | 0)) {
      i1 = HEAP32[i14 >> 2] | 0;
      HEAP32[i14 >> 2] = i1 + 1;
      HEAP8[(HEAP32[i15 >> 2] | 0) + i1 >> 0] = i5;
      i1 = (HEAPU16[i13 >> 1] | 0) >>> 8 & 255;
      i6 = HEAP32[i14 >> 2] | 0;
      HEAP32[i14 >> 2] = i6 + 1;
      HEAP8[(HEAP32[i15 >> 2] | 0) + i6 >> 0] = i1;
      i6 = HEAP32[i12 >> 2] | 0;
      i1 = i4 >>> (16 - i6 | 0) & 65535;
      HEAP16[i13 >> 1] = i1;
      i6 = i3 + -16 + i6 | 0;
      HEAP32[i12 >> 2] = i6;
      break;
     } else {
      i6 = i6 + i3 | 0;
      HEAP32[i12 >> 2] = i6;
      break;
     }
    }
   } while (0);
  } while (i17 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 i4 = HEAPU16[i18 + 1026 >> 1] | 0;
 i5 = i19 + 5820 | 0;
 i2 = HEAPU16[i18 + 1024 >> 1] | 0;
 i3 = i19 + 5816 | 0;
 i1 = i1 & 65535 | i2 << i6;
 HEAP16[i3 >> 1] = i1;
 if ((i6 | 0) > (16 - i4 | 0)) {
  i7 = i19 + 20 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i8 + 1;
  i9 = i19 + 8 | 0;
  HEAP8[(HEAP32[i9 >> 2] | 0) + i8 >> 0] = i1;
  i8 = (HEAPU16[i3 >> 1] | 0) >>> 8 & 255;
  i10 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i10 + 1;
  HEAP8[(HEAP32[i9 >> 2] | 0) + i10 >> 0] = i8;
  i10 = HEAP32[i5 >> 2] | 0;
  HEAP16[i3 >> 1] = i2 >>> (16 - i10 | 0);
  i10 = i4 + -16 + i10 | 0;
  HEAP32[i5 >> 2] = i10;
  STACKTOP = i20;
  return;
 } else {
  i10 = i6 + i4 | 0;
  HEAP32[i5 >> 2] = i10;
  STACKTOP = i20;
  return;
 }
}

function __ZL13icvWriteGraphP13CvFileStoragePKcPKv10CvAttrList(i30, i10, i31, i13) {
 i30 = i30 | 0;
 i10 = i10 | 0;
 i31 = i31 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 1456 | 0;
 i25 = i35;
 i34 = i35 + 1040 | 0;
 i14 = i35 + 1328 | 0;
 i11 = i35 + 1200 | 0;
 i28 = i35 + 1072 | 0;
 i2 = i35 + 1032 | 0;
 i29 = i35 + 520 | 0;
 i26 = i35 + 512 | 0;
 i8 = HEAP32[i31 + 60 >> 2] | 0;
 i27 = i31 + 64 | 0;
 i12 = HEAP32[(HEAP32[i27 >> 2] | 0) + 60 >> 2] | 0;
 i33 = _cvAlloc(i8 << 2) | 0;
 _cvStartReadSeq(i31, i34, 0);
 i32 = i31 + 24 | 0;
 if ((HEAP32[i32 >> 2] | 0) > 0) {
  i1 = i34 + 12 | 0;
  i5 = i31 + 28 | 0;
  i6 = i34 + 20 | 0;
  i9 = 0;
  i4 = 0;
  do {
   i7 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   if ((i3 | 0) > -1) {
    HEAP32[i33 + (i4 << 2) >> 2] = i3;
    HEAP32[i7 >> 2] = i4;
    i4 = i4 + 1 | 0;
   }
   i22 = i7 + (HEAP32[i5 >> 2] | 0) | 0;
   HEAP32[i1 >> 2] = i22;
   if (i22 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) _cvChangeSeqBlock(i34, 1);
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) < (HEAP32[i32 >> 2] | 0));
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i25 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 _cvStartWriteStruct(i30, i10, 6, 10656, i25);
 _cvWriteString(i30, 12488, (HEAP32[i31 >> 2] & 16384 | 0) != 0 ? 12496 : 12512, 1);
 _cvWriteInt(i30, 12520, i8);
 i20 = __ZL12icvGetFormatPK5CvSeqPKcP10CvAttrListiPc(i31, 12536, i13, 8, i11) | 0;
 if (i20) _cvWriteString(i30, 12536, i20, 0);
 _cvWriteInt(i30, 12552, i12);
 i21 = __ZL12icvGetFormatPK5CvSeqPKcP10CvAttrListiPc(HEAP32[i27 >> 2] | 0, 12568, i13, 24, i14) | 0;
 HEAP32[i25 >> 2] = (i21 | 0) != 0 ? i21 : 12512;
 _sprintf(i28, 12576, i25) | 0;
 _cvWriteString(i30, 12568, i28, 0);
 __ZL18icvWriteHeaderDataP13CvFileStoragePK5CvSeqP10CvAttrListi(i30, i31, i13, 68);
 i21 = i31 + 28 | 0;
 i22 = (HEAP32[i21 >> 2] | 0) * 3 | 0;
 i22 = (i22 | 0) < 65536 ? 65536 : i22;
 i8 = (HEAP32[(HEAP32[i27 >> 2] | 0) + 28 >> 2] | 0) * 3 | 0;
 i8 = (i8 | 0) < (i22 | 0) ? i22 : i8;
 i22 = _cvAlloc(i8) | 0;
 i9 = i25 + 4 | 0;
 i10 = i29 + 20 | 0;
 i15 = i26 + 4 | 0;
 i23 = i34 + 12 | 0;
 i24 = i34 + 20 | 0;
 i19 = 0;
 do {
  i16 = (i19 | 0) == 0;
  i17 = i16 ? i20 : i28;
  if (i17) {
   if (i16) i11 = i31; else i11 = HEAP32[i27 >> 2] | 0;
   i18 = i11 + 28 | 0;
   i1 = HEAP32[i18 >> 2] | 0;
   i13 = __ZL15icvDecodeFormatPKcPii(i17, i25) | 0;
   i14 = i13 << 1;
   if ((i13 | 0) > 0) {
    i13 = 0;
    i12 = 0;
    do {
     i2 = HEAP32[i25 + ((i13 | 1) << 2) >> 2] | 0;
     i2 = (i2 >>> 3 & 511) + 1 << (47696 >>> (i2 << 1 & 14) & 3);
     i12 = (i12 + -1 + i2 & 0 - i2) + (Math_imul(i2, HEAP32[i25 + (i13 << 2) >> 2] | 0) | 0) | 0;
     i13 = i13 + 2 | 0;
    } while ((i13 | 0) < (i14 | 0));
    i14 = i12 + -1 | 0;
   } else i14 = -1;
   i6 = HEAP32[i9 >> 2] | 0;
   i6 = (i6 >>> 3 & 511) + 1 << (47696 >>> (i6 << 1 & 14) & 3);
   i6 = i14 + i6 & 0 - i6;
   i7 = (i8 | 0) / (i6 | 0) | 0;
   if ((i19 | 0) == 1 ? (__ZL15icvDecodeFormatPKcPii(i17, i29) | 0) > 2 : 0) {
    i14 = HEAP32[i10 >> 2] | 0;
    i14 = ((i14 >>> 3 & 511) + 1 << (47696 >>> (i14 << 1 & 14) & 3) | 0) > 7 ? 8 : 4;
   } else i14 = 4;
   HEAP32[i26 >> 2] = 0;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i25 + 0 >> 2] = HEAP32[i26 + 0 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
   _cvStartWriteStruct(i30, i16 ? 12584 : 12600, 13, 0, i25);
   _cvStartReadSeq(i11, i34, 0);
   i3 = i11 + 24 | 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i4 = (i1 | 0) > 24;
    i5 = i14 + -1 | 0;
    i2 = 0 - i14 | 0;
    i11 = i1 + -24 | 0;
    i1 = 0;
    i14 = i22;
    i13 = 0;
    do {
     i12 = HEAP32[i23 >> 2] | 0;
     if ((HEAP32[i12 >> 2] | 0) > -1) {
      if (!i16) {
       i36 = i14 + 3 & -4;
       i14 = i36;
       HEAP32[i36 >> 2] = HEAP32[HEAP32[i12 + 16 >> 2] >> 2];
       HEAP32[i14 + 4 >> 2] = HEAP32[HEAP32[i12 + 20 >> 2] >> 2];
       HEAPF32[i14 + 8 >> 2] = Math_fround(HEAPF32[i12 + 4 >> 2]);
       if (i4) _memcpy(i5 + (i14 + 12) & i2 | 0, i12 + 24 | 0, i11 | 0) | 0;
      } else _memcpy(i14 | 0, i12 + 8 | 0, i6 | 0) | 0;
      i13 = i13 + 1 | 0;
      if ((i13 | 0) < (i7 | 0)) i14 = i14 + i6 | 0; else {
       _cvWriteRawData(i30, i22, i13, i17);
       i14 = i22;
       i13 = 0;
      }
     }
     i12 = (HEAP32[i23 >> 2] | 0) + (HEAP32[i18 >> 2] | 0) | 0;
     HEAP32[i23 >> 2] = i12;
     if (i12 >>> 0 >= (HEAP32[i24 >> 2] | 0) >>> 0) _cvChangeSeqBlock(i34, 1);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
    if ((i13 | 0) > 0) _cvWriteRawData(i30, i22, i13, i17);
   }
   _cvEndWriteStruct(i30);
  }
  i19 = i19 + 1 | 0;
 } while ((i19 | 0) != 2);
 _cvEndWriteStruct(i30);
 _cvStartReadSeq(i31, i34, 0);
 i1 = HEAP32[i32 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i4 = 0;
  i2 = 0;
 } else {
  _cvFree_(i22);
  _cvFree_(i33);
  STACKTOP = i35;
  return;
 }
 do {
  i3 = HEAP32[i23 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) > -1) {
   HEAP32[i3 >> 2] = HEAP32[i33 + (i2 << 2) >> 2];
   i2 = i2 + 1 | 0;
  }
  i20 = i3 + (HEAP32[i21 >> 2] | 0) | 0;
  HEAP32[i23 >> 2] = i20;
  if (i20 >>> 0 >= (HEAP32[i24 >> 2] | 0) >>> 0) {
   _cvChangeSeqBlock(i34, 1);
   i1 = HEAP32[i32 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i1 | 0));
 _cvFree_(i22);
 _cvFree_(i33);
 STACKTOP = i35;
 return;
}

function __ZN2cvL6sum16uEPKtPKhPiii(i14, i12, i16, i15, i13) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i17 = 0;
 i17 = STACKTOP;
 if (!i12) {
  i12 = (i13 | 0) % 4 | 0;
  if ((i12 | 0) == 1) {
   i1 = HEAP32[i16 >> 2] | 0;
   i6 = i15 + -4 | 0;
   if ((i6 | 0) < 0) {
    i2 = 0;
    i3 = i14;
   } else {
    i5 = i13 << 1;
    i2 = i13 * 3 | 0;
    i7 = i13 << 2;
    i8 = i6 >>> 2;
    i3 = i14 + (Math_imul((i8 << 3) + 8 | 0, i13) | 0) | 0;
    i9 = 0;
    i4 = i14;
    while (1) {
     i1 = (HEAPU16[i4 >> 1] | 0) + i1 + (HEAPU16[i4 + (i13 << 1) >> 1] | 0) + (HEAPU16[i4 + (i5 << 1) >> 1] | 0) + (HEAPU16[i4 + (i2 << 1) >> 1] | 0) | 0;
     i9 = i9 + 4 | 0;
     if ((i9 | 0) > (i6 | 0)) break; else i4 = i4 + (i7 << 1) | 0;
    }
    i2 = (i8 << 2) + 4 | 0;
   }
   if ((i2 | 0) < (i15 | 0)) while (1) {
    i1 = (HEAPU16[i3 >> 1] | 0) + i1 | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i15 | 0)) {
     i2 = i15;
     break;
    } else i3 = i3 + (i13 << 1) | 0;
   }
   HEAP32[i16 >> 2] = i1;
  } else if ((i12 | 0) == 3) {
   i1 = HEAP32[i16 >> 2] | 0;
   i7 = i16 + 4 | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i6 = i16 + 8 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if ((i15 | 0) > 0) {
    i8 = 0;
    i9 = i14;
    while (1) {
     i1 = (HEAPU16[i9 >> 1] | 0) + i1 | 0;
     i4 = (HEAPU16[i9 + 2 >> 1] | 0) + i4 | 0;
     i3 = (HEAPU16[i9 + 4 >> 1] | 0) + i3 | 0;
     i8 = i8 + 1 | 0;
     if ((i8 | 0) == (i15 | 0)) {
      i2 = i15;
      break;
     } else i9 = i9 + (i13 << 1) | 0;
    }
   } else i2 = 0;
   HEAP32[i16 >> 2] = i1;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i6 >> 2] = i3;
  } else if ((i12 | 0) == 2) {
   i3 = HEAP32[i16 >> 2] | 0;
   i9 = i16 + 4 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i15 | 0) > 0) {
    i4 = 0;
    i2 = i14;
    while (1) {
     i3 = (HEAPU16[i2 >> 1] | 0) + i3 | 0;
     i1 = (HEAPU16[i2 + 2 >> 1] | 0) + i1 | 0;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i15 | 0)) {
      i2 = i15;
      break;
     } else i2 = i2 + (i13 << 1) | 0;
    }
   } else i2 = 0;
   HEAP32[i16 >> 2] = i3;
   HEAP32[i9 >> 2] = i1;
  } else i2 = 0;
  if ((i12 | 0) >= (i13 | 0)) {
   i10 = i15;
   STACKTOP = i17;
   return i10 | 0;
  }
  do {
   i3 = i16 + (i12 << 2) | 0;
   i9 = HEAP32[i3 >> 2] | 0;
   i1 = i16 + (i12 + 1 << 2) | 0;
   i7 = HEAP32[i1 >> 2] | 0;
   i10 = i16 + (i12 + 2 << 2) | 0;
   i8 = HEAP32[i10 >> 2] | 0;
   i11 = i16 + (i12 + 3 << 2) | 0;
   i4 = HEAP32[i11 >> 2] | 0;
   if ((i2 | 0) < (i15 | 0)) {
    i5 = i2;
    i6 = i14 + ((Math_imul(i2, i13) | 0) + i12 << 1) | 0;
    while (1) {
     i9 = (HEAPU16[i6 >> 1] | 0) + i9 | 0;
     i7 = (HEAPU16[i6 + 2 >> 1] | 0) + i7 | 0;
     i8 = (HEAPU16[i6 + 4 >> 1] | 0) + i8 | 0;
     i4 = (HEAPU16[i6 + 6 >> 1] | 0) + i4 | 0;
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i15 | 0)) {
      i2 = i15;
      break;
     } else i6 = i6 + (i13 << 1) | 0;
    }
   }
   HEAP32[i3 >> 2] = i9;
   HEAP32[i1 >> 2] = i7;
   HEAP32[i10 >> 2] = i8;
   HEAP32[i11 >> 2] = i4;
   i12 = i12 + 4 | 0;
  } while ((i12 | 0) < (i13 | 0));
  i1 = i15;
  STACKTOP = i17;
  return i1 | 0;
 }
 if ((i13 | 0) == 1) {
  i1 = HEAP32[i16 >> 2] | 0;
  if ((i15 | 0) > 0) {
   i3 = 0;
   i2 = 0;
   do {
    if (HEAP8[i12 + i3 >> 0] | 0) {
     i2 = i2 + 1 | 0;
     i1 = (HEAPU16[i14 + (i3 << 1) >> 1] | 0) + i1 | 0;
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i15 | 0));
  } else i2 = 0;
  HEAP32[i16 >> 2] = i1;
  i10 = i2;
  STACKTOP = i17;
  return i10 | 0;
 } else if ((i13 | 0) == 3) {
  i3 = HEAP32[i16 >> 2] | 0;
  i7 = i16 + 4 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i6 = i16 + 8 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i15 | 0) > 0) {
   i8 = 0;
   i4 = 0;
   i9 = i14;
   while (1) {
    if (HEAP8[i12 + i8 >> 0] | 0) {
     i4 = i4 + 1 | 0;
     i3 = (HEAPU16[i9 >> 1] | 0) + i3 | 0;
     i1 = (HEAPU16[i9 + 2 >> 1] | 0) + i1 | 0;
     i2 = (HEAPU16[i9 + 4 >> 1] | 0) + i2 | 0;
    }
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i15 | 0)) break; else i9 = i9 + 6 | 0;
   }
  } else i4 = 0;
  HEAP32[i16 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
  i10 = i4;
  STACKTOP = i17;
  return i10 | 0;
 } else {
  if ((i15 | 0) <= 0) {
   i10 = 0;
   STACKTOP = i17;
   return i10 | 0;
  }
  i2 = i13 + -4 | 0;
  i5 = (i2 | 0) < 0;
  i6 = i13 & -4;
  i9 = 0;
  i1 = 0;
  i4 = i14;
  while (1) {
   if (HEAP8[i12 + i9 >> 0] | 0) {
    if (i5) i3 = 0; else {
     i3 = 0;
     do {
      i8 = i16 + (i3 << 2) | 0;
      i7 = i3 | 1;
      i11 = i16 + (i7 << 2) | 0;
      i7 = (HEAPU16[i4 + (i7 << 1) >> 1] | 0) + (HEAP32[i11 >> 2] | 0) | 0;
      HEAP32[i8 >> 2] = (HEAPU16[i4 + (i3 << 1) >> 1] | 0) + (HEAP32[i8 >> 2] | 0);
      HEAP32[i11 >> 2] = i7;
      i11 = i3 | 2;
      i7 = i16 + (i11 << 2) | 0;
      i8 = i3 | 3;
      i10 = i16 + (i8 << 2) | 0;
      i8 = (HEAPU16[i4 + (i8 << 1) >> 1] | 0) + (HEAP32[i10 >> 2] | 0) | 0;
      HEAP32[i7 >> 2] = (HEAPU16[i4 + (i11 << 1) >> 1] | 0) + (HEAP32[i7 >> 2] | 0);
      HEAP32[i10 >> 2] = i8;
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i2 | 0));
     i3 = i6;
    }
    if ((i3 | 0) < (i13 | 0)) do {
     i10 = i16 + (i3 << 2) | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + (HEAPU16[i4 + (i3 << 1) >> 1] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i13 | 0));
    i1 = i1 + 1 | 0;
   }
   i9 = i9 + 1 | 0;
   if ((i9 | 0) == (i15 | 0)) break; else i4 = i4 + (i13 << 1) | 0;
  }
  STACKTOP = i17;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cvL6sum32sEPKiPKhPdii(i6, i12, i17, i16, i15) {
 i6 = i6 | 0;
 i12 = i12 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, d2 = 0.0, d3 = 0.0, i4 = 0, d5 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d13 = 0.0, i14 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 if (!i12) {
  i14 = (i15 | 0) % 4 | 0;
  if ((i14 | 0) == 1) {
   d2 = +HEAPF64[i17 >> 3];
   i9 = i16 + -4 | 0;
   if ((i9 | 0) < 0) {
    i1 = 0;
    i4 = i6;
   } else {
    i8 = i15 << 1;
    i7 = i15 * 3 | 0;
    i10 = i15 << 2;
    i11 = i9 >>> 2;
    i4 = i6 + (Math_imul((i11 << 4) + 16 | 0, i15) | 0) | 0;
    i12 = 0;
    i1 = i6;
    while (1) {
     d2 = d2 + +((HEAP32[i1 + (i15 << 2) >> 2] | 0) + (HEAP32[i1 >> 2] | 0) + (HEAP32[i1 + (i8 << 2) >> 2] | 0) + (HEAP32[i1 + (i7 << 2) >> 2] | 0) | 0);
     i12 = i12 + 4 | 0;
     if ((i12 | 0) > (i9 | 0)) break; else i1 = i1 + (i10 << 2) | 0;
    }
    i1 = (i11 << 2) + 4 | 0;
   }
   if ((i1 | 0) < (i16 | 0)) while (1) {
    d2 = d2 + +(HEAP32[i4 >> 2] | 0);
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    } else i4 = i4 + (i15 << 2) | 0;
   }
   HEAPF64[i17 >> 3] = d2;
  } else if ((i14 | 0) == 3) {
   d3 = +HEAPF64[i17 >> 3];
   i9 = i17 + 8 | 0;
   d2 = +HEAPF64[i9 >> 3];
   i8 = i17 + 16 | 0;
   d5 = +HEAPF64[i8 >> 3];
   if ((i16 | 0) > 0) {
    i10 = 0;
    i11 = i6;
    while (1) {
     d3 = d3 + +(HEAP32[i11 >> 2] | 0);
     d2 = d2 + +(HEAP32[i11 + 4 >> 2] | 0);
     d5 = d5 + +(HEAP32[i11 + 8 >> 2] | 0);
     i10 = i10 + 1 | 0;
     if ((i10 | 0) == (i16 | 0)) {
      i1 = i16;
      break;
     } else i11 = i11 + (i15 << 2) | 0;
    }
   } else i1 = 0;
   HEAPF64[i17 >> 3] = d3;
   HEAPF64[i9 >> 3] = d2;
   HEAPF64[i8 >> 3] = d5;
  } else if ((i14 | 0) == 2) {
   d3 = +HEAPF64[i17 >> 3];
   i11 = i17 + 8 | 0;
   d2 = +HEAPF64[i11 >> 3];
   if ((i16 | 0) > 0) {
    i1 = 0;
    i4 = i6;
    while (1) {
     d3 = d3 + +(HEAP32[i4 >> 2] | 0);
     d2 = d2 + +(HEAP32[i4 + 4 >> 2] | 0);
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i16 | 0)) {
      i1 = i16;
      break;
     } else i4 = i4 + (i15 << 2) | 0;
    }
   } else i1 = 0;
   HEAPF64[i17 >> 3] = d3;
   HEAPF64[i11 >> 3] = d2;
  } else i1 = 0;
  if ((i14 | 0) < (i15 | 0)) i12 = i14; else {
   i14 = i16;
   STACKTOP = i18;
   return i14 | 0;
  }
  do {
   i9 = i17 + (i12 << 3) | 0;
   d3 = +HEAPF64[i9 >> 3];
   i8 = i17 + (i12 + 1 << 3) | 0;
   d13 = +HEAPF64[i8 >> 3];
   i7 = i17 + (i12 + 2 << 3) | 0;
   d2 = +HEAPF64[i7 >> 3];
   i4 = i17 + (i12 + 3 << 3) | 0;
   d5 = +HEAPF64[i4 >> 3];
   if ((i1 | 0) < (i16 | 0)) {
    i10 = i1;
    i11 = i6 + ((Math_imul(i1, i15) | 0) + i12 << 2) | 0;
    while (1) {
     d3 = d3 + +(HEAP32[i11 >> 2] | 0);
     d13 = d13 + +(HEAP32[i11 + 4 >> 2] | 0);
     d2 = d2 + +(HEAP32[i11 + 8 >> 2] | 0);
     d5 = d5 + +(HEAP32[i11 + 12 >> 2] | 0);
     i10 = i10 + 1 | 0;
     if ((i10 | 0) == (i16 | 0)) {
      i1 = i16;
      break;
     } else i11 = i11 + (i15 << 2) | 0;
    }
   }
   HEAPF64[i9 >> 3] = d3;
   HEAPF64[i8 >> 3] = d13;
   HEAPF64[i7 >> 3] = d2;
   HEAPF64[i4 >> 3] = d5;
   i12 = i12 + 4 | 0;
  } while ((i12 | 0) < (i15 | 0));
  i1 = i16;
  STACKTOP = i18;
  return i1 | 0;
 }
 if ((i15 | 0) == 1) {
  d2 = +HEAPF64[i17 >> 3];
  if ((i16 | 0) > 0) {
   i4 = 0;
   i1 = 0;
   do {
    if (HEAP8[i12 + i4 >> 0] | 0) {
     i1 = i1 + 1 | 0;
     d2 = d2 + +(HEAP32[i6 + (i4 << 2) >> 2] | 0);
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i16 | 0));
  } else i1 = 0;
  HEAPF64[i17 >> 3] = d2;
  i14 = i1;
  STACKTOP = i18;
  return i14 | 0;
 } else if ((i15 | 0) == 3) {
  d5 = +HEAPF64[i17 >> 3];
  i10 = i17 + 8 | 0;
  d3 = +HEAPF64[i10 >> 3];
  i9 = i17 + 16 | 0;
  d2 = +HEAPF64[i9 >> 3];
  if ((i16 | 0) > 0) {
   i11 = 0;
   i4 = 0;
   while (1) {
    if (HEAP8[i12 + i11 >> 0] | 0) {
     i4 = i4 + 1 | 0;
     d5 = d5 + +(HEAP32[i6 >> 2] | 0);
     d3 = d3 + +(HEAP32[i6 + 4 >> 2] | 0);
     d2 = d2 + +(HEAP32[i6 + 8 >> 2] | 0);
    }
    i11 = i11 + 1 | 0;
    if ((i11 | 0) == (i16 | 0)) break; else i6 = i6 + 12 | 0;
   }
  } else i4 = 0;
  HEAPF64[i17 >> 3] = d5;
  HEAPF64[i10 >> 3] = d3;
  HEAPF64[i9 >> 3] = d2;
  i14 = i4;
  STACKTOP = i18;
  return i14 | 0;
 } else {
  if ((i16 | 0) <= 0) {
   i14 = 0;
   STACKTOP = i18;
   return i14 | 0;
  }
  i7 = i15 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i15 & -4;
  i11 = 0;
  i1 = 0;
  while (1) {
   if (HEAP8[i12 + i11 >> 0] | 0) {
    if (i8) i4 = 0; else {
     i4 = 0;
     do {
      i10 = i17 + (i4 << 3) | 0;
      i20 = i4 | 1;
      i19 = i17 + (i20 << 3) | 0;
      d2 = +HEAPF64[i19 >> 3] + +(HEAP32[i6 + (i20 << 2) >> 2] | 0);
      HEAPF64[i10 >> 3] = +HEAPF64[i10 >> 3] + +(HEAP32[i6 + (i4 << 2) >> 2] | 0);
      HEAPF64[i19 >> 3] = d2;
      i19 = i4 | 2;
      i10 = i17 + (i19 << 3) | 0;
      i20 = i4 | 3;
      i14 = i17 + (i20 << 3) | 0;
      d2 = +HEAPF64[i14 >> 3] + +(HEAP32[i6 + (i20 << 2) >> 2] | 0);
      HEAPF64[i10 >> 3] = +HEAPF64[i10 >> 3] + +(HEAP32[i6 + (i19 << 2) >> 2] | 0);
      HEAPF64[i14 >> 3] = d2;
      i4 = i4 + 4 | 0;
     } while ((i4 | 0) <= (i7 | 0));
     i4 = i9;
    }
    if ((i4 | 0) < (i15 | 0)) do {
     i14 = i17 + (i4 << 3) | 0;
     HEAPF64[i14 >> 3] = +HEAPF64[i14 >> 3] + +(HEAP32[i6 + (i4 << 2) >> 2] | 0);
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i15 | 0));
    i1 = i1 + 1 | 0;
   }
   i11 = i11 + 1 | 0;
   if ((i11 | 0) == (i16 | 0)) break; else i6 = i6 + (i15 << 2) | 0;
  }
  STACKTOP = i18;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cvL14MulTransposedLIsfEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d31) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d31 = +d31;
 var d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, f33 = f0, d34 = 0.0, d35 = 0.0, i36 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 i25 = i32 + 1040 | 0;
 i24 = i32;
 i29 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 16 >> 2] | 0;
 i30 = (HEAP32[i3 + 48 >> 2] | 0) >>> 1;
 i28 = (HEAP32[i1 + 48 >> 2] | 0) >>> 2;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i22 = (HEAP32[i2 + 48 >> 2] | 0) >>> 2; else i22 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i27 = HEAP32[i3 + 40 >> 2] | 0;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i27 = HEAP32[i27 >> 2] | 0;
 if (!i23) {
  if ((i27 | 0) <= 0) {
   STACKTOP = i32;
   return;
  }
  i7 = i26 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i26 & -4;
  i10 = 0;
  while (1) {
   i1 = Math_imul(i10, i30) | 0;
   i5 = i10;
   do {
    i2 = Math_imul(i5, i30) | 0;
    if (i8) {
     i3 = 0;
     d4 = 0.0;
    } else {
     i3 = 0;
     d4 = 0.0;
     do {
      i21 = i3 | 1;
      i22 = i3 | 2;
      i23 = i3 | 3;
      d4 = d4 + (+(HEAP16[i29 + (i3 + i1 << 1) >> 1] | 0) * +(HEAP16[i29 + (i3 + i2 << 1) >> 1] | 0) + +(HEAP16[i29 + (i21 + i1 << 1) >> 1] | 0) * +(HEAP16[i29 + (i21 + i2 << 1) >> 1] | 0) + +(HEAP16[i29 + (i22 + i1 << 1) >> 1] | 0) * +(HEAP16[i29 + (i22 + i2 << 1) >> 1] | 0) + +(HEAP16[i29 + (i23 + i1 << 1) >> 1] | 0) * +(HEAP16[i29 + (i23 + i2 << 1) >> 1] | 0));
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i7 | 0));
     i3 = i9;
    }
    if ((i3 | 0) < (i26 | 0)) do {
     d4 = d4 + +(HEAP16[i29 + (i3 + i1 << 1) >> 1] | 0) * +(HEAP16[i29 + (i3 + i2 << 1) >> 1] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i26 | 0));
    HEAPF32[i6 + (i5 << 2) >> 2] = Math_fround(d4 * d31);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 2) | 0;
  }
  STACKTOP = i32;
  return;
 }
 i19 = (i2 | 0) == (i26 | 0) ? 4 : 0;
 i3 = i26 << 2;
 i20 = i24 + 8 | 0;
 HEAP32[i24 >> 2] = i20;
 i21 = i24 + 4 | 0;
 HEAP32[i21 >> 2] = 1032;
 if (i3 >>> 0 > 1032) {
  i18 = __Znaj(i3) | 0;
  HEAP32[i24 >> 2] = i18;
 } else i18 = i20;
 HEAP32[i21 >> 2] = i3;
 if ((i27 | 0) > 0) {
  i1 = (i2 | 0) < (i26 | 0);
  i11 = (i26 | 0) > 0;
  i12 = i25 + 12 | 0;
  i13 = i25 + 8 | 0;
  i14 = i25 + 4 | 0;
  i15 = i26 + -4 | 0;
  i16 = (i15 | 0) < 0;
  i3 = i26 & -4;
  i2 = Math_imul(i19, i3) | 0;
  i17 = 0;
  while (1) {
   i7 = Math_imul(i17, i30) | 0;
   i9 = Math_imul(i17, i22) | 0;
   i8 = i23 + (i9 << 2) | 0;
   if (i1) if (i11) {
    i10 = 0;
    do {
     f33 = Math_fround(HEAP16[i29 + (i10 + i7 << 1) >> 1] | 0);
     HEAPF32[i18 + (i10 << 2) >> 2] = Math_fround(f33 - Math_fround(HEAPF32[i8 >> 2]));
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17; else if (i11) {
    i10 = 0;
    do {
     f33 = Math_fround(HEAP16[i29 + (i10 + i7 << 1) >> 1] | 0);
     HEAPF32[i18 + (i10 << 2) >> 2] = Math_fround(f33 - Math_fround(HEAPF32[i23 + (i10 + i9 << 2) >> 2]));
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17;
   do {
    i7 = Math_imul(i5, i30) | 0;
    i10 = i23 + ((Math_imul(i5, i22) | 0) << 2) | 0;
    if (i1) {
     f33 = Math_fround(HEAPF32[i10 >> 2]);
     HEAPF32[i12 >> 2] = f33;
     HEAPF32[i13 >> 2] = f33;
     HEAPF32[i14 >> 2] = f33;
     HEAPF32[i25 >> 2] = f33;
     i10 = i25;
    }
    if (i16) {
     i9 = 0;
     d4 = 0.0;
    } else {
     i8 = i10 + i2 | 0;
     i9 = 0;
     d4 = 0.0;
     while (1) {
      d35 = +Math_fround(HEAPF32[i18 + (i9 << 2) >> 2]);
      f33 = Math_fround(HEAP16[i29 + (i9 + i7 << 1) >> 1] | 0);
      d35 = d35 * +Math_fround(f33 - Math_fround(HEAPF32[i10 >> 2]));
      i36 = i9 | 1;
      d34 = +Math_fround(HEAPF32[i18 + (i36 << 2) >> 2]);
      f33 = Math_fround(HEAP16[i29 + (i36 + i7 << 1) >> 1] | 0);
      d34 = d35 + d34 * +Math_fround(f33 - Math_fround(HEAPF32[i10 + 4 >> 2]));
      i36 = i9 | 2;
      d35 = +Math_fround(HEAPF32[i18 + (i36 << 2) >> 2]);
      f33 = Math_fround(HEAP16[i29 + (i36 + i7 << 1) >> 1] | 0);
      d35 = d34 + d35 * +Math_fround(f33 - Math_fround(HEAPF32[i10 + 8 >> 2]));
      i36 = i9 | 3;
      d34 = +Math_fround(HEAPF32[i18 + (i36 << 2) >> 2]);
      f33 = Math_fround(HEAP16[i29 + (i36 + i7 << 1) >> 1] | 0);
      d4 = d4 + (d35 + d34 * +Math_fround(f33 - Math_fround(HEAPF32[i10 + 12 >> 2])));
      i9 = i9 + 4 | 0;
      if ((i9 | 0) > (i15 | 0)) break; else i10 = i10 + (i19 << 2) | 0;
     }
     i9 = i3;
     i10 = i8;
    }
    if ((i9 | 0) < (i26 | 0)) while (1) {
     d34 = +Math_fround(HEAPF32[i18 + (i9 << 2) >> 2]);
     f33 = Math_fround(HEAP16[i29 + (i9 + i7 << 1) >> 1] | 0);
     d4 = d4 + d34 * +Math_fround(f33 - Math_fround(HEAPF32[i10 >> 2]));
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i26 | 0)) break; else i10 = i10 + 4 | 0;
    }
    HEAPF32[i6 + (i5 << 2) >> 2] = Math_fround(d4 * d31);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i17 = i17 + 1 | 0;
   if ((i17 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 2) | 0;
  }
 }
 if ((i18 | 0) == (i20 | 0)) {
  STACKTOP = i32;
  return;
 }
 __ZdaPv(i18);
 HEAP32[i24 >> 2] = i20;
 HEAP32[i21 >> 2] = 1032;
 STACKTOP = i32;
 return;
}

function __ZN2cvL6sum16sEPKsPKhPiii(i14, i12, i16, i15, i13) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i17 = 0;
 i17 = STACKTOP;
 if (!i12) {
  i12 = (i13 | 0) % 4 | 0;
  if ((i12 | 0) == 1) {
   i1 = HEAP32[i16 >> 2] | 0;
   i6 = i15 + -4 | 0;
   if ((i6 | 0) < 0) {
    i2 = 0;
    i3 = i14;
   } else {
    i5 = i13 << 1;
    i2 = i13 * 3 | 0;
    i7 = i13 << 2;
    i8 = i6 >>> 2;
    i3 = i14 + (Math_imul((i8 << 3) + 8 | 0, i13) | 0) | 0;
    i9 = 0;
    i4 = i14;
    while (1) {
     i1 = (HEAP16[i4 >> 1] | 0) + i1 + (HEAP16[i4 + (i13 << 1) >> 1] | 0) + (HEAP16[i4 + (i5 << 1) >> 1] | 0) + (HEAP16[i4 + (i2 << 1) >> 1] | 0) | 0;
     i9 = i9 + 4 | 0;
     if ((i9 | 0) > (i6 | 0)) break; else i4 = i4 + (i7 << 1) | 0;
    }
    i2 = (i8 << 2) + 4 | 0;
   }
   if ((i2 | 0) < (i15 | 0)) while (1) {
    i1 = (HEAP16[i3 >> 1] | 0) + i1 | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i15 | 0)) {
     i2 = i15;
     break;
    } else i3 = i3 + (i13 << 1) | 0;
   }
   HEAP32[i16 >> 2] = i1;
  } else if ((i12 | 0) == 3) {
   i1 = HEAP32[i16 >> 2] | 0;
   i7 = i16 + 4 | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i6 = i16 + 8 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if ((i15 | 0) > 0) {
    i8 = 0;
    i9 = i14;
    while (1) {
     i1 = (HEAP16[i9 >> 1] | 0) + i1 | 0;
     i4 = (HEAP16[i9 + 2 >> 1] | 0) + i4 | 0;
     i3 = (HEAP16[i9 + 4 >> 1] | 0) + i3 | 0;
     i8 = i8 + 1 | 0;
     if ((i8 | 0) == (i15 | 0)) {
      i2 = i15;
      break;
     } else i9 = i9 + (i13 << 1) | 0;
    }
   } else i2 = 0;
   HEAP32[i16 >> 2] = i1;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i6 >> 2] = i3;
  } else if ((i12 | 0) == 2) {
   i3 = HEAP32[i16 >> 2] | 0;
   i9 = i16 + 4 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i15 | 0) > 0) {
    i4 = 0;
    i2 = i14;
    while (1) {
     i3 = (HEAP16[i2 >> 1] | 0) + i3 | 0;
     i1 = (HEAP16[i2 + 2 >> 1] | 0) + i1 | 0;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i15 | 0)) {
      i2 = i15;
      break;
     } else i2 = i2 + (i13 << 1) | 0;
    }
   } else i2 = 0;
   HEAP32[i16 >> 2] = i3;
   HEAP32[i9 >> 2] = i1;
  } else i2 = 0;
  if ((i12 | 0) >= (i13 | 0)) {
   i10 = i15;
   STACKTOP = i17;
   return i10 | 0;
  }
  do {
   i3 = i16 + (i12 << 2) | 0;
   i9 = HEAP32[i3 >> 2] | 0;
   i1 = i16 + (i12 + 1 << 2) | 0;
   i7 = HEAP32[i1 >> 2] | 0;
   i10 = i16 + (i12 + 2 << 2) | 0;
   i8 = HEAP32[i10 >> 2] | 0;
   i11 = i16 + (i12 + 3 << 2) | 0;
   i4 = HEAP32[i11 >> 2] | 0;
   if ((i2 | 0) < (i15 | 0)) {
    i5 = i2;
    i6 = i14 + ((Math_imul(i2, i13) | 0) + i12 << 1) | 0;
    while (1) {
     i9 = (HEAP16[i6 >> 1] | 0) + i9 | 0;
     i7 = (HEAP16[i6 + 2 >> 1] | 0) + i7 | 0;
     i8 = (HEAP16[i6 + 4 >> 1] | 0) + i8 | 0;
     i4 = (HEAP16[i6 + 6 >> 1] | 0) + i4 | 0;
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i15 | 0)) {
      i2 = i15;
      break;
     } else i6 = i6 + (i13 << 1) | 0;
    }
   }
   HEAP32[i3 >> 2] = i9;
   HEAP32[i1 >> 2] = i7;
   HEAP32[i10 >> 2] = i8;
   HEAP32[i11 >> 2] = i4;
   i12 = i12 + 4 | 0;
  } while ((i12 | 0) < (i13 | 0));
  i1 = i15;
  STACKTOP = i17;
  return i1 | 0;
 }
 if ((i13 | 0) == 3) {
  i3 = HEAP32[i16 >> 2] | 0;
  i7 = i16 + 4 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i6 = i16 + 8 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i15 | 0) > 0) {
   i8 = 0;
   i4 = 0;
   i9 = i14;
   while (1) {
    if (HEAP8[i12 + i8 >> 0] | 0) {
     i4 = i4 + 1 | 0;
     i3 = (HEAP16[i9 >> 1] | 0) + i3 | 0;
     i1 = (HEAP16[i9 + 2 >> 1] | 0) + i1 | 0;
     i2 = (HEAP16[i9 + 4 >> 1] | 0) + i2 | 0;
    }
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i15 | 0)) break; else i9 = i9 + 6 | 0;
   }
  } else i4 = 0;
  HEAP32[i16 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
  i10 = i4;
  STACKTOP = i17;
  return i10 | 0;
 } else if ((i13 | 0) == 1) {
  i1 = HEAP32[i16 >> 2] | 0;
  if ((i15 | 0) > 0) {
   i3 = 0;
   i2 = 0;
   do {
    if (HEAP8[i12 + i3 >> 0] | 0) {
     i2 = i2 + 1 | 0;
     i1 = (HEAP16[i14 + (i3 << 1) >> 1] | 0) + i1 | 0;
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i15 | 0));
  } else i2 = 0;
  HEAP32[i16 >> 2] = i1;
  i10 = i2;
  STACKTOP = i17;
  return i10 | 0;
 } else {
  if ((i15 | 0) <= 0) {
   i10 = 0;
   STACKTOP = i17;
   return i10 | 0;
  }
  i2 = i13 + -4 | 0;
  i5 = (i2 | 0) < 0;
  i6 = i13 & -4;
  i9 = 0;
  i1 = 0;
  i4 = i14;
  while (1) {
   if (HEAP8[i12 + i9 >> 0] | 0) {
    if (i5) i3 = 0; else {
     i3 = 0;
     do {
      i8 = i16 + (i3 << 2) | 0;
      i7 = i3 | 1;
      i11 = i16 + (i7 << 2) | 0;
      i7 = (HEAP16[i4 + (i7 << 1) >> 1] | 0) + (HEAP32[i11 >> 2] | 0) | 0;
      HEAP32[i8 >> 2] = (HEAP16[i4 + (i3 << 1) >> 1] | 0) + (HEAP32[i8 >> 2] | 0);
      HEAP32[i11 >> 2] = i7;
      i11 = i3 | 2;
      i7 = i16 + (i11 << 2) | 0;
      i8 = i3 | 3;
      i10 = i16 + (i8 << 2) | 0;
      i8 = (HEAP16[i4 + (i8 << 1) >> 1] | 0) + (HEAP32[i10 >> 2] | 0) | 0;
      HEAP32[i7 >> 2] = (HEAP16[i4 + (i11 << 1) >> 1] | 0) + (HEAP32[i7 >> 2] | 0);
      HEAP32[i10 >> 2] = i8;
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i2 | 0));
     i3 = i6;
    }
    if ((i3 | 0) < (i13 | 0)) do {
     i10 = i16 + (i3 << 2) | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + (HEAP16[i4 + (i3 << 1) >> 1] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i13 | 0));
    i1 = i1 + 1 | 0;
   }
   i9 = i9 + 1 | 0;
   if ((i9 | 0) == (i15 | 0)) break; else i4 = i4 + (i13 << 1) | 0;
  }
  STACKTOP = i17;
  return i1 | 0;
 }
 return 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_(i28, i1, i22, i26, i3, i27, i21) {
 i28 = i28 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i26 = i26 | 0;
 i3 = i3 | 0;
 i27 = i27 | 0;
 i21 = i21 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 i13 = i25 + 208 | 0;
 i2 = i25 + 200 | 0;
 i4 = i25 + 196 | 0;
 i24 = i25 + 184 | 0;
 i23 = i25 + 172 | 0;
 i15 = i25 + 168 | 0;
 i17 = i25 + 8 | 0;
 i18 = i25 + 4 | 0;
 i16 = i25;
 i19 = i25 + 337 | 0;
 i14 = i25 + 336 | 0;
 __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_(i24, i3, i13, i2, i4);
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, 10, 0);
 if (!(HEAP8[i23 >> 0] & 1)) {
  i1 = i23 + 1 | 0;
  i10 = i1;
  i11 = i23 + 8 | 0;
 } else {
  i1 = i23 + 8 | 0;
  i10 = i23 + 1 | 0;
  i11 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i15 >> 2] = i1;
 HEAP32[i18 >> 2] = i17;
 HEAP32[i16 >> 2] = 0;
 HEAP8[i19 >> 0] = 1;
 HEAP8[i14 >> 0] = 69;
 i12 = i23 + 4 | 0;
 i9 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 L5 : while (1) {
  if (i2) {
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) == -1) {
    HEAP32[i22 >> 2] = 0;
    i5 = 1;
    i2 = 0;
   } else i5 = 0;
  } else {
   i5 = 1;
   i2 = 0;
  }
  i3 = HEAP32[i26 >> 2] | 0;
  do if (i3) {
   i4 = HEAP32[i3 + 12 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0; else i4 = HEAP32[i4 >> 2] | 0;
   if ((i4 | 0) != -1) if (i5) break; else {
    i4 = i3;
    break L5;
   } else {
    HEAP32[i26 >> 2] = 0;
    i29 = 17;
    break;
   }
  } else i29 = 17; while (0);
  if ((i29 | 0) == 17) {
   i29 = 0;
   if (i5) {
    i4 = 0;
    break;
   } else i3 = 0;
  }
  i6 = HEAP8[i23 >> 0] | 0;
  i4 = (i6 & 1) == 0;
  if (i4) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i12 >> 2] | 0;
  if ((HEAP32[i15 >> 2] | 0) == (i1 + i5 | 0)) {
   if (i4) {
    i4 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i12 >> 2] | 0;
    i4 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, i4 << 1, 0);
   if (!(HEAP8[i23 >> 0] & 1)) i4 = 10; else i4 = (HEAP32[i23 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, i4, 0);
   if (!(HEAP8[i23 >> 0] & 1)) i1 = i10; else i1 = HEAP32[i11 >> 2] | 0;
   HEAP32[i15 >> 2] = i1 + i5;
  }
  i6 = i2 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i2 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i4 = HEAP32[i5 >> 2] | 0;
  if (__ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw(i4, i19, i14, i1, i15, i9, i8, i24, i17, i18, i16, i13) | 0) {
   i4 = i3;
   break;
  }
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i4 + 4;
   continue;
  }
 }
 i3 = HEAP8[i24 >> 0] | 0;
 if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i24 + 4 >> 2] | 0;
 if (!((i3 | 0) == 0 | (HEAP8[i19 >> 0] | 0) == 0) ? (i20 = HEAP32[i18 >> 2] | 0, (i20 - i17 | 0) < 160) : 0) {
  i19 = HEAP32[i16 >> 2] | 0;
  HEAP32[i18 >> 2] = i20 + 4;
  HEAP32[i20 >> 2] = i19;
 }
 HEAPF32[i21 >> 2] = Math_fround(__ZNSt3__115__num_get_floatIfEET_PKcS3_Rj(i1, HEAP32[i15 >> 2] | 0, i27));
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i24, i17, HEAP32[i18 >> 2] | 0, i27);
 if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i22 >> 2] = 0;
   i2 = 0;
   i3 = 1;
  } else i3 = 0;
 } else {
  i2 = 0;
  i3 = 1;
 }
 do if (i4) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i26 >> 2] = 0;
   i29 = 56;
   break;
  }
  if (i3) {
   HEAP32[i28 >> 2] = i2;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
   STACKTOP = i25;
   return;
  }
 } else i29 = 56; while (0);
 if ((i29 | 0) == 56 ? !i3 : 0) {
  HEAP32[i28 >> 2] = i2;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
  STACKTOP = i25;
  return;
 }
 HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | 2;
 HEAP32[i28 >> 2] = i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
 STACKTOP = i25;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_(i28, i1, i22, i26, i3, i27, i21) {
 i28 = i28 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i26 = i26 | 0;
 i3 = i3 | 0;
 i27 = i27 | 0;
 i21 = i21 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 i13 = i25 + 208 | 0;
 i2 = i25 + 200 | 0;
 i4 = i25 + 196 | 0;
 i24 = i25 + 184 | 0;
 i23 = i25 + 172 | 0;
 i15 = i25 + 168 | 0;
 i17 = i25 + 8 | 0;
 i18 = i25 + 4 | 0;
 i16 = i25;
 i19 = i25 + 337 | 0;
 i14 = i25 + 336 | 0;
 __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_(i24, i3, i13, i2, i4);
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, 10, 0);
 if (!(HEAP8[i23 >> 0] & 1)) {
  i1 = i23 + 1 | 0;
  i10 = i1;
  i11 = i23 + 8 | 0;
 } else {
  i1 = i23 + 8 | 0;
  i10 = i23 + 1 | 0;
  i11 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i15 >> 2] = i1;
 HEAP32[i18 >> 2] = i17;
 HEAP32[i16 >> 2] = 0;
 HEAP8[i19 >> 0] = 1;
 HEAP8[i14 >> 0] = 69;
 i12 = i23 + 4 | 0;
 i9 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 L5 : while (1) {
  if (i2) {
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) == -1) {
    HEAP32[i22 >> 2] = 0;
    i5 = 1;
    i2 = 0;
   } else i5 = 0;
  } else {
   i5 = 1;
   i2 = 0;
  }
  i3 = HEAP32[i26 >> 2] | 0;
  do if (i3) {
   i4 = HEAP32[i3 + 12 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0; else i4 = HEAP32[i4 >> 2] | 0;
   if ((i4 | 0) != -1) if (i5) break; else {
    i4 = i3;
    break L5;
   } else {
    HEAP32[i26 >> 2] = 0;
    i29 = 17;
    break;
   }
  } else i29 = 17; while (0);
  if ((i29 | 0) == 17) {
   i29 = 0;
   if (i5) {
    i4 = 0;
    break;
   } else i3 = 0;
  }
  i6 = HEAP8[i23 >> 0] | 0;
  i4 = (i6 & 1) == 0;
  if (i4) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i12 >> 2] | 0;
  if ((HEAP32[i15 >> 2] | 0) == (i1 + i5 | 0)) {
   if (i4) {
    i4 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i12 >> 2] | 0;
    i4 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, i4 << 1, 0);
   if (!(HEAP8[i23 >> 0] & 1)) i4 = 10; else i4 = (HEAP32[i23 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, i4, 0);
   if (!(HEAP8[i23 >> 0] & 1)) i1 = i10; else i1 = HEAP32[i11 >> 2] | 0;
   HEAP32[i15 >> 2] = i1 + i5;
  }
  i6 = i2 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i2 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i4 = HEAP32[i5 >> 2] | 0;
  if (__ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw(i4, i19, i14, i1, i15, i9, i8, i24, i17, i18, i16, i13) | 0) {
   i4 = i3;
   break;
  }
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i4 + 4;
   continue;
  }
 }
 i3 = HEAP8[i24 >> 0] | 0;
 if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i24 + 4 >> 2] | 0;
 if (!((i3 | 0) == 0 | (HEAP8[i19 >> 0] | 0) == 0) ? (i20 = HEAP32[i18 >> 2] | 0, (i20 - i17 | 0) < 160) : 0) {
  i19 = HEAP32[i16 >> 2] | 0;
  HEAP32[i18 >> 2] = i20 + 4;
  HEAP32[i20 >> 2] = i19;
 }
 HEAPF64[i21 >> 3] = +__ZNSt3__115__num_get_floatIeEET_PKcS3_Rj(i1, HEAP32[i15 >> 2] | 0, i27);
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i24, i17, HEAP32[i18 >> 2] | 0, i27);
 if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i22 >> 2] = 0;
   i2 = 0;
   i3 = 1;
  } else i3 = 0;
 } else {
  i2 = 0;
  i3 = 1;
 }
 do if (i4) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i26 >> 2] = 0;
   i29 = 56;
   break;
  }
  if (i3) {
   HEAP32[i28 >> 2] = i2;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
   STACKTOP = i25;
   return;
  }
 } else i29 = 56; while (0);
 if ((i29 | 0) == 56 ? !i3 : 0) {
  HEAP32[i28 >> 2] = i2;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
  STACKTOP = i25;
  return;
 }
 HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | 2;
 HEAP32[i28 >> 2] = i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
 STACKTOP = i25;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_(i28, i1, i22, i26, i3, i27, i21) {
 i28 = i28 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i26 = i26 | 0;
 i3 = i3 | 0;
 i27 = i27 | 0;
 i21 = i21 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 i13 = i25 + 208 | 0;
 i2 = i25 + 200 | 0;
 i4 = i25 + 196 | 0;
 i24 = i25 + 184 | 0;
 i23 = i25 + 172 | 0;
 i15 = i25 + 168 | 0;
 i17 = i25 + 8 | 0;
 i18 = i25 + 4 | 0;
 i16 = i25;
 i19 = i25 + 337 | 0;
 i14 = i25 + 336 | 0;
 __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_(i24, i3, i13, i2, i4);
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, 10, 0);
 if (!(HEAP8[i23 >> 0] & 1)) {
  i1 = i23 + 1 | 0;
  i10 = i1;
  i11 = i23 + 8 | 0;
 } else {
  i1 = i23 + 8 | 0;
  i10 = i23 + 1 | 0;
  i11 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i15 >> 2] = i1;
 HEAP32[i18 >> 2] = i17;
 HEAP32[i16 >> 2] = 0;
 HEAP8[i19 >> 0] = 1;
 HEAP8[i14 >> 0] = 69;
 i12 = i23 + 4 | 0;
 i9 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 L5 : while (1) {
  if (i2) {
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) == -1) {
    HEAP32[i22 >> 2] = 0;
    i5 = 1;
    i2 = 0;
   } else i5 = 0;
  } else {
   i5 = 1;
   i2 = 0;
  }
  i3 = HEAP32[i26 >> 2] | 0;
  do if (i3) {
   i4 = HEAP32[i3 + 12 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0; else i4 = HEAP32[i4 >> 2] | 0;
   if ((i4 | 0) != -1) if (i5) break; else {
    i4 = i3;
    break L5;
   } else {
    HEAP32[i26 >> 2] = 0;
    i29 = 17;
    break;
   }
  } else i29 = 17; while (0);
  if ((i29 | 0) == 17) {
   i29 = 0;
   if (i5) {
    i4 = 0;
    break;
   } else i3 = 0;
  }
  i6 = HEAP8[i23 >> 0] | 0;
  i4 = (i6 & 1) == 0;
  if (i4) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i12 >> 2] | 0;
  if ((HEAP32[i15 >> 2] | 0) == (i1 + i5 | 0)) {
   if (i4) {
    i4 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i12 >> 2] | 0;
    i4 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, i4 << 1, 0);
   if (!(HEAP8[i23 >> 0] & 1)) i4 = 10; else i4 = (HEAP32[i23 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, i4, 0);
   if (!(HEAP8[i23 >> 0] & 1)) i1 = i10; else i1 = HEAP32[i11 >> 2] | 0;
   HEAP32[i15 >> 2] = i1 + i5;
  }
  i6 = i2 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i2 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i4 = HEAP32[i5 >> 2] | 0;
  if (__ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw(i4, i19, i14, i1, i15, i9, i8, i24, i17, i18, i16, i13) | 0) {
   i4 = i3;
   break;
  }
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i4 + 4;
   continue;
  }
 }
 i3 = HEAP8[i24 >> 0] | 0;
 if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i24 + 4 >> 2] | 0;
 if (!((i3 | 0) == 0 | (HEAP8[i19 >> 0] | 0) == 0) ? (i20 = HEAP32[i18 >> 2] | 0, (i20 - i17 | 0) < 160) : 0) {
  i19 = HEAP32[i16 >> 2] | 0;
  HEAP32[i18 >> 2] = i20 + 4;
  HEAP32[i20 >> 2] = i19;
 }
 HEAPF64[i21 >> 3] = +__ZNSt3__115__num_get_floatIdEET_PKcS3_Rj(i1, HEAP32[i15 >> 2] | 0, i27);
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i24, i17, HEAP32[i18 >> 2] | 0, i27);
 if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i22 >> 2] = 0;
   i2 = 0;
   i3 = 1;
  } else i3 = 0;
 } else {
  i2 = 0;
  i3 = 1;
 }
 do if (i4) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i26 >> 2] = 0;
   i29 = 56;
   break;
  }
  if (i3) {
   HEAP32[i28 >> 2] = i2;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
   STACKTOP = i25;
   return;
  }
 } else i29 = 56; while (0);
 if ((i29 | 0) == 56 ? !i3 : 0) {
  HEAP32[i28 >> 2] = i2;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
  STACKTOP = i25;
  return;
 }
 HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | 2;
 HEAP32[i28 >> 2] = i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
 STACKTOP = i25;
 return;
}

function __ZN2cvL14MulTransposedLIhfEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d31) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d31 = +d31;
 var d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, f33 = f0, d34 = 0.0, d35 = 0.0, i36 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 i25 = i32 + 1040 | 0;
 i24 = i32;
 i29 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 16 >> 2] | 0;
 i30 = HEAP32[i3 + 48 >> 2] | 0;
 i28 = (HEAP32[i1 + 48 >> 2] | 0) >>> 2;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i22 = (HEAP32[i2 + 48 >> 2] | 0) >>> 2; else i22 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i27 = HEAP32[i3 + 40 >> 2] | 0;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i27 = HEAP32[i27 >> 2] | 0;
 if (!i23) {
  if ((i27 | 0) <= 0) {
   STACKTOP = i32;
   return;
  }
  i7 = i26 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i26 & -4;
  i10 = 0;
  while (1) {
   i1 = Math_imul(i10, i30) | 0;
   i5 = i10;
   do {
    i2 = Math_imul(i5, i30) | 0;
    if (i8) {
     i3 = 0;
     d4 = 0.0;
    } else {
     i3 = 0;
     d4 = 0.0;
     do {
      i21 = i3 | 1;
      i22 = i3 | 2;
      i23 = i3 | 3;
      d4 = d4 + (+(HEAPU8[i29 + (i3 + i1) >> 0] | 0) * +(HEAPU8[i29 + (i3 + i2) >> 0] | 0 | 0) + +(HEAPU8[i29 + (i21 + i1) >> 0] | 0) * +(HEAPU8[i29 + (i21 + i2) >> 0] | 0 | 0) + +(HEAPU8[i29 + (i22 + i1) >> 0] | 0) * +(HEAPU8[i29 + (i22 + i2) >> 0] | 0 | 0) + +(HEAPU8[i29 + (i23 + i1) >> 0] | 0) * +(HEAPU8[i29 + (i23 + i2) >> 0] | 0 | 0));
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i7 | 0));
     i3 = i9;
    }
    if ((i3 | 0) < (i26 | 0)) do {
     d4 = d4 + +(HEAPU8[i29 + (i3 + i1) >> 0] | 0) * +(HEAPU8[i29 + (i3 + i2) >> 0] | 0 | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i26 | 0));
    HEAPF32[i6 + (i5 << 2) >> 2] = Math_fround(d4 * d31);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 2) | 0;
  }
  STACKTOP = i32;
  return;
 }
 i19 = (i2 | 0) == (i26 | 0) ? 4 : 0;
 i3 = i26 << 2;
 i20 = i24 + 8 | 0;
 HEAP32[i24 >> 2] = i20;
 i21 = i24 + 4 | 0;
 HEAP32[i21 >> 2] = 1032;
 if (i3 >>> 0 > 1032) {
  i18 = __Znaj(i3) | 0;
  HEAP32[i24 >> 2] = i18;
 } else i18 = i20;
 HEAP32[i21 >> 2] = i3;
 if ((i27 | 0) > 0) {
  i14 = (i2 | 0) < (i26 | 0);
  i15 = (i26 | 0) > 0;
  i16 = i25 + 12 | 0;
  i3 = i25 + 8 | 0;
  i2 = i25 + 4 | 0;
  i1 = i26 + -4 | 0;
  i11 = (i1 | 0) < 0;
  i12 = i26 & -4;
  i13 = Math_imul(i19, i12) | 0;
  i17 = 0;
  while (1) {
   i7 = Math_imul(i17, i30) | 0;
   i9 = Math_imul(i17, i22) | 0;
   i8 = i23 + (i9 << 2) | 0;
   if (i14) if (i15) {
    i10 = 0;
    do {
     f33 = Math_fround(HEAPU8[i29 + (i10 + i7) >> 0] | 0 | 0);
     HEAPF32[i18 + (i10 << 2) >> 2] = Math_fround(f33 - Math_fround(HEAPF32[i8 >> 2]));
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17; else if (i15) {
    i10 = 0;
    do {
     f33 = Math_fround(HEAPU8[i29 + (i10 + i7) >> 0] | 0 | 0);
     HEAPF32[i18 + (i10 << 2) >> 2] = Math_fround(f33 - Math_fround(HEAPF32[i23 + (i10 + i9 << 2) >> 2]));
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17;
   do {
    i7 = Math_imul(i5, i30) | 0;
    i10 = i23 + ((Math_imul(i5, i22) | 0) << 2) | 0;
    if (i14) {
     f33 = Math_fround(HEAPF32[i10 >> 2]);
     HEAPF32[i16 >> 2] = f33;
     HEAPF32[i3 >> 2] = f33;
     HEAPF32[i2 >> 2] = f33;
     HEAPF32[i25 >> 2] = f33;
     i10 = i25;
    }
    if (i11) {
     i9 = 0;
     d4 = 0.0;
    } else {
     i8 = i10 + i13 | 0;
     i9 = 0;
     d4 = 0.0;
     while (1) {
      d35 = +Math_fround(HEAPF32[i18 + (i9 << 2) >> 2]);
      f33 = Math_fround(HEAPU8[i29 + (i9 + i7) >> 0] | 0 | 0);
      d35 = d35 * +Math_fround(f33 - Math_fround(HEAPF32[i10 >> 2]));
      i36 = i9 | 1;
      d34 = +Math_fround(HEAPF32[i18 + (i36 << 2) >> 2]);
      f33 = Math_fround(HEAPU8[i29 + (i36 + i7) >> 0] | 0 | 0);
      d34 = d35 + d34 * +Math_fround(f33 - Math_fround(HEAPF32[i10 + 4 >> 2]));
      i36 = i9 | 2;
      d35 = +Math_fround(HEAPF32[i18 + (i36 << 2) >> 2]);
      f33 = Math_fround(HEAPU8[i29 + (i36 + i7) >> 0] | 0 | 0);
      d35 = d34 + d35 * +Math_fround(f33 - Math_fround(HEAPF32[i10 + 8 >> 2]));
      i36 = i9 | 3;
      d34 = +Math_fround(HEAPF32[i18 + (i36 << 2) >> 2]);
      f33 = Math_fround(HEAPU8[i29 + (i36 + i7) >> 0] | 0 | 0);
      d4 = d4 + (d35 + d34 * +Math_fround(f33 - Math_fround(HEAPF32[i10 + 12 >> 2])));
      i9 = i9 + 4 | 0;
      if ((i9 | 0) > (i1 | 0)) break; else i10 = i10 + (i19 << 2) | 0;
     }
     i9 = i12;
     i10 = i8;
    }
    if ((i9 | 0) < (i26 | 0)) while (1) {
     d34 = +Math_fround(HEAPF32[i18 + (i9 << 2) >> 2]);
     f33 = Math_fround(HEAPU8[i29 + (i9 + i7) >> 0] | 0 | 0);
     d4 = d4 + d34 * +Math_fround(f33 - Math_fround(HEAPF32[i10 >> 2]));
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i26 | 0)) break; else i10 = i10 + 4 | 0;
    }
    HEAPF32[i6 + (i5 << 2) >> 2] = Math_fround(d4 * d31);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i17 = i17 + 1 | 0;
   if ((i17 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 2) | 0;
  }
 }
 if ((i18 | 0) == (i20 | 0)) {
  STACKTOP = i32;
  return;
 }
 __ZdaPv(i18);
 HEAP32[i24 >> 2] = i20;
 HEAP32[i21 >> 2] = 1032;
 STACKTOP = i32;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_(i28, i1, i21, i26, i3, i27, i22) {
 i28 = i28 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 i26 = i26 | 0;
 i3 = i3 | 0;
 i27 = i27 | 0;
 i22 = i22 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i13 = i25 + 200 | 0;
 i4 = i25 + 199 | 0;
 i2 = i25 + 198 | 0;
 i24 = i25 + 184 | 0;
 i23 = i25 + 172 | 0;
 i15 = i25 + 168 | 0;
 i17 = i25 + 8 | 0;
 i18 = i25 + 4 | 0;
 i16 = i25;
 i19 = i25 + 197 | 0;
 i14 = i25 + 196 | 0;
 __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_(i24, i3, i13, i4, i2);
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, 10, 0);
 if (!(HEAP8[i23 >> 0] & 1)) {
  i3 = i23 + 1 | 0;
  i10 = i3;
  i11 = i23 + 8 | 0;
 } else {
  i3 = i23 + 8 | 0;
  i10 = i23 + 1 | 0;
  i11 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i15 >> 2] = i3;
 HEAP32[i18 >> 2] = i17;
 HEAP32[i16 >> 2] = 0;
 HEAP8[i19 >> 0] = 1;
 HEAP8[i14 >> 0] = 69;
 i12 = i23 + 4 | 0;
 i9 = HEAP8[i4 >> 0] | 0;
 i8 = HEAP8[i2 >> 0] | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 L5 : while (1) {
  if (i1) {
   if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
    HEAP32[i21 >> 2] = 0;
    i1 = 0;
   }
  } else i1 = 0;
  i2 = (i1 | 0) == 0;
  i4 = HEAP32[i26 >> 2] | 0;
  do if (i4) {
   if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else break L5;
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) != -1) if (i2) break; else break L5; else {
    HEAP32[i26 >> 2] = 0;
    i29 = 14;
    break;
   }
  } else i29 = 14; while (0);
  if ((i29 | 0) == 14) {
   i29 = 0;
   if (i2) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i23 >> 0] | 0;
  i2 = (i6 & 1) == 0;
  if (i2) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i12 >> 2] | 0;
  if ((HEAP32[i15 >> 2] | 0) == (i3 + i5 | 0)) {
   if (i2) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i12 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, i3 << 1, 0);
   if (!(HEAP8[i23 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i23 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, i3, 0);
   if (!(HEAP8[i23 >> 0] & 1)) i3 = i10; else i3 = HEAP32[i11 >> 2] | 0;
   HEAP32[i15 >> 2] = i3 + i5;
  }
  i6 = i1 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i1 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i2 = HEAPU8[i5 >> 0] | 0;
  if (__ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_(i2 & 255, i19, i14, i3, i15, i9, i8, i24, i17, i18, i16, i13) | 0) break;
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i4 + 1;
   continue;
  }
 }
 i2 = HEAP8[i24 >> 0] | 0;
 if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i24 + 4 >> 2] | 0;
 if (!((i2 | 0) == 0 | (HEAP8[i19 >> 0] | 0) == 0) ? (i20 = HEAP32[i18 >> 2] | 0, (i20 - i17 | 0) < 160) : 0) {
  i19 = HEAP32[i16 >> 2] | 0;
  HEAP32[i18 >> 2] = i20 + 4;
  HEAP32[i20 >> 2] = i19;
 }
 HEAPF32[i22 >> 2] = Math_fround(__ZNSt3__115__num_get_floatIfEET_PKcS3_Rj(i3, HEAP32[i15 >> 2] | 0, i27));
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i24, i17, HEAP32[i18 >> 2] | 0, i27);
 if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
   HEAP32[i21 >> 2] = 0;
   i1 = 0;
  }
 } else i1 = 0;
 i2 = (i1 | 0) == 0;
 do if (i4) {
  if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) {
   if (!i2) break;
   HEAP32[i28 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
   STACKTOP = i25;
   return;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
   HEAP32[i26 >> 2] = 0;
   i29 = 50;
   break;
  }
  if (i2 ^ (i4 | 0) == 0) {
   HEAP32[i28 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
   STACKTOP = i25;
   return;
  }
 } else i29 = 50; while (0);
 if ((i29 | 0) == 50 ? !i2 : 0) {
  HEAP32[i28 >> 2] = i1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
  STACKTOP = i25;
  return;
 }
 HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | 2;
 HEAP32[i28 >> 2] = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
 STACKTOP = i25;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_(i28, i1, i21, i26, i3, i27, i22) {
 i28 = i28 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 i26 = i26 | 0;
 i3 = i3 | 0;
 i27 = i27 | 0;
 i22 = i22 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i13 = i25 + 200 | 0;
 i4 = i25 + 199 | 0;
 i2 = i25 + 198 | 0;
 i24 = i25 + 184 | 0;
 i23 = i25 + 172 | 0;
 i15 = i25 + 168 | 0;
 i17 = i25 + 8 | 0;
 i18 = i25 + 4 | 0;
 i16 = i25;
 i19 = i25 + 197 | 0;
 i14 = i25 + 196 | 0;
 __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_(i24, i3, i13, i4, i2);
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, 10, 0);
 if (!(HEAP8[i23 >> 0] & 1)) {
  i3 = i23 + 1 | 0;
  i10 = i3;
  i11 = i23 + 8 | 0;
 } else {
  i3 = i23 + 8 | 0;
  i10 = i23 + 1 | 0;
  i11 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i15 >> 2] = i3;
 HEAP32[i18 >> 2] = i17;
 HEAP32[i16 >> 2] = 0;
 HEAP8[i19 >> 0] = 1;
 HEAP8[i14 >> 0] = 69;
 i12 = i23 + 4 | 0;
 i9 = HEAP8[i4 >> 0] | 0;
 i8 = HEAP8[i2 >> 0] | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 L5 : while (1) {
  if (i1) {
   if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
    HEAP32[i21 >> 2] = 0;
    i1 = 0;
   }
  } else i1 = 0;
  i2 = (i1 | 0) == 0;
  i4 = HEAP32[i26 >> 2] | 0;
  do if (i4) {
   if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else break L5;
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) != -1) if (i2) break; else break L5; else {
    HEAP32[i26 >> 2] = 0;
    i29 = 14;
    break;
   }
  } else i29 = 14; while (0);
  if ((i29 | 0) == 14) {
   i29 = 0;
   if (i2) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i23 >> 0] | 0;
  i2 = (i6 & 1) == 0;
  if (i2) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i12 >> 2] | 0;
  if ((HEAP32[i15 >> 2] | 0) == (i3 + i5 | 0)) {
   if (i2) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i12 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, i3 << 1, 0);
   if (!(HEAP8[i23 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i23 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, i3, 0);
   if (!(HEAP8[i23 >> 0] & 1)) i3 = i10; else i3 = HEAP32[i11 >> 2] | 0;
   HEAP32[i15 >> 2] = i3 + i5;
  }
  i6 = i1 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i1 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i2 = HEAPU8[i5 >> 0] | 0;
  if (__ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_(i2 & 255, i19, i14, i3, i15, i9, i8, i24, i17, i18, i16, i13) | 0) break;
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i4 + 1;
   continue;
  }
 }
 i2 = HEAP8[i24 >> 0] | 0;
 if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i24 + 4 >> 2] | 0;
 if (!((i2 | 0) == 0 | (HEAP8[i19 >> 0] | 0) == 0) ? (i20 = HEAP32[i18 >> 2] | 0, (i20 - i17 | 0) < 160) : 0) {
  i19 = HEAP32[i16 >> 2] | 0;
  HEAP32[i18 >> 2] = i20 + 4;
  HEAP32[i20 >> 2] = i19;
 }
 HEAPF64[i22 >> 3] = +__ZNSt3__115__num_get_floatIeEET_PKcS3_Rj(i3, HEAP32[i15 >> 2] | 0, i27);
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i24, i17, HEAP32[i18 >> 2] | 0, i27);
 if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
   HEAP32[i21 >> 2] = 0;
   i1 = 0;
  }
 } else i1 = 0;
 i2 = (i1 | 0) == 0;
 do if (i4) {
  if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) {
   if (!i2) break;
   HEAP32[i28 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
   STACKTOP = i25;
   return;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
   HEAP32[i26 >> 2] = 0;
   i29 = 50;
   break;
  }
  if (i2 ^ (i4 | 0) == 0) {
   HEAP32[i28 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
   STACKTOP = i25;
   return;
  }
 } else i29 = 50; while (0);
 if ((i29 | 0) == 50 ? !i2 : 0) {
  HEAP32[i28 >> 2] = i1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
  STACKTOP = i25;
  return;
 }
 HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | 2;
 HEAP32[i28 >> 2] = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
 STACKTOP = i25;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_(i28, i1, i21, i26, i3, i27, i22) {
 i28 = i28 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 i26 = i26 | 0;
 i3 = i3 | 0;
 i27 = i27 | 0;
 i22 = i22 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i13 = i25 + 200 | 0;
 i4 = i25 + 199 | 0;
 i2 = i25 + 198 | 0;
 i24 = i25 + 184 | 0;
 i23 = i25 + 172 | 0;
 i15 = i25 + 168 | 0;
 i17 = i25 + 8 | 0;
 i18 = i25 + 4 | 0;
 i16 = i25;
 i19 = i25 + 197 | 0;
 i14 = i25 + 196 | 0;
 __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_(i24, i3, i13, i4, i2);
 HEAP32[i23 + 0 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, 10, 0);
 if (!(HEAP8[i23 >> 0] & 1)) {
  i3 = i23 + 1 | 0;
  i10 = i3;
  i11 = i23 + 8 | 0;
 } else {
  i3 = i23 + 8 | 0;
  i10 = i23 + 1 | 0;
  i11 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i15 >> 2] = i3;
 HEAP32[i18 >> 2] = i17;
 HEAP32[i16 >> 2] = 0;
 HEAP8[i19 >> 0] = 1;
 HEAP8[i14 >> 0] = 69;
 i12 = i23 + 4 | 0;
 i9 = HEAP8[i4 >> 0] | 0;
 i8 = HEAP8[i2 >> 0] | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 L5 : while (1) {
  if (i1) {
   if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
    HEAP32[i21 >> 2] = 0;
    i1 = 0;
   }
  } else i1 = 0;
  i2 = (i1 | 0) == 0;
  i4 = HEAP32[i26 >> 2] | 0;
  do if (i4) {
   if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else break L5;
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) != -1) if (i2) break; else break L5; else {
    HEAP32[i26 >> 2] = 0;
    i29 = 14;
    break;
   }
  } else i29 = 14; while (0);
  if ((i29 | 0) == 14) {
   i29 = 0;
   if (i2) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i23 >> 0] | 0;
  i2 = (i6 & 1) == 0;
  if (i2) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i12 >> 2] | 0;
  if ((HEAP32[i15 >> 2] | 0) == (i3 + i5 | 0)) {
   if (i2) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i12 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, i3 << 1, 0);
   if (!(HEAP8[i23 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i23 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i23, i3, 0);
   if (!(HEAP8[i23 >> 0] & 1)) i3 = i10; else i3 = HEAP32[i11 >> 2] | 0;
   HEAP32[i15 >> 2] = i3 + i5;
  }
  i6 = i1 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i1 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i2 = HEAPU8[i5 >> 0] | 0;
  if (__ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_(i2 & 255, i19, i14, i3, i15, i9, i8, i24, i17, i18, i16, i13) | 0) break;
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i4 + 1;
   continue;
  }
 }
 i2 = HEAP8[i24 >> 0] | 0;
 if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i24 + 4 >> 2] | 0;
 if (!((i2 | 0) == 0 | (HEAP8[i19 >> 0] | 0) == 0) ? (i20 = HEAP32[i18 >> 2] | 0, (i20 - i17 | 0) < 160) : 0) {
  i19 = HEAP32[i16 >> 2] | 0;
  HEAP32[i18 >> 2] = i20 + 4;
  HEAP32[i20 >> 2] = i19;
 }
 HEAPF64[i22 >> 3] = +__ZNSt3__115__num_get_floatIdEET_PKcS3_Rj(i3, HEAP32[i15 >> 2] | 0, i27);
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i24, i17, HEAP32[i18 >> 2] | 0, i27);
 if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
   HEAP32[i21 >> 2] = 0;
   i1 = 0;
  }
 } else i1 = 0;
 i2 = (i1 | 0) == 0;
 do if (i4) {
  if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) {
   if (!i2) break;
   HEAP32[i28 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
   STACKTOP = i25;
   return;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
   HEAP32[i26 >> 2] = 0;
   i29 = 50;
   break;
  }
  if (i2 ^ (i4 | 0) == 0) {
   HEAP32[i28 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
   STACKTOP = i25;
   return;
  }
 } else i29 = 50; while (0);
 if ((i29 | 0) == 50 ? !i2 : 0) {
  HEAP32[i28 >> 2] = i1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
  STACKTOP = i25;
  return;
 }
 HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | 2;
 HEAP32[i28 >> 2] = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i23);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
 STACKTOP = i25;
 return;
}

function _cvPtr2D(i17, i16, i15, i18) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i7 = i19 + 48 | 0;
 i12 = i19 + 40 | 0;
 i13 = i19 + 32 | 0;
 i14 = i19 + 24 | 0;
 i9 = i19 + 16 | 0;
 i6 = i19 + 8 | 0;
 i10 = i19;
 do if (i17) {
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = i2 & -65536;
  if ((((i3 | 0) == 1111621632 ? (i5 = HEAP32[i17 + 24 >> 2] | 0, (i5 | 0) > 0) : 0) ? (i4 = HEAP32[i17 + 20 >> 2] | 0, (i4 | 0) > 0) : 0) ? (i8 = i17 + 16 | 0, (HEAP32[i8 >> 2] | 0) != 0) : 0) {
   if (!(i4 >>> 0 > i16 >>> 0 & i5 >>> 0 > i15 >>> 0)) {
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    i5 = (__ZN2cv6String8allocateEj(i7, 21) | 0) + 0 | 0;
    i2 = 42456 | 0;
    i11 = i5 + 21 | 0;
    do {
     HEAP8[i5 >> 0] = HEAP8[i2 >> 0] | 0;
     i5 = i5 + 1 | 0;
     i2 = i2 + 1 | 0;
    } while ((i5 | 0) < (i11 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i7, 42480, 40912, 1761);
    __ZN2cv6String10deallocateEv(i7);
    i2 = HEAP32[i17 >> 2] | 0;
   }
   if (i18) HEAP32[i18 >> 2] = i2 & 4095;
   i10 = (HEAP32[i8 >> 2] | 0) + ((Math_imul(HEAP32[i17 + 4 >> 2] | 0, i16) | 0) + (Math_imul((i2 >>> 3 & 511) + 1 << (47696 >>> (i2 << 1 & 14) & 3), i15) | 0)) | 0;
   STACKTOP = i19;
   return i10 | 0;
  }
  if ((i2 | 0) == 112 ? (i1 = HEAP32[i17 + 68 >> 2] | 0, (i1 | 0) != 0) : 0) {
   i9 = i17 + 16 | 0;
   i4 = (HEAP32[i9 >> 2] | 0) >>> 3 & 31;
   i5 = (HEAP32[i17 + 28 >> 2] | 0) == 0;
   if (i5) i4 = Math_imul(HEAP32[i17 + 8 >> 2] | 0, i4) | 0;
   i2 = HEAP32[i17 + 48 >> 2] | 0;
   if (i2) {
    i3 = HEAP32[i2 + 12 >> 2] | 0;
    i7 = HEAP32[i2 + 16 >> 2] | 0;
    i8 = Math_imul(HEAP32[i17 + 72 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0) | 0;
    i8 = (Math_imul(HEAP32[i2 + 4 >> 2] | 0, i4) | 0) + i8 | 0;
    if (i5) {
     i2 = i7;
     i1 = i1 + i8 | 0;
    } else {
     i6 = HEAP32[i2 >> 2] | 0;
     if (!i6) {
      HEAP32[i12 >> 2] = 0;
      HEAP32[i12 + 4 >> 2] = 0;
      i5 = (__ZN2cv6String8allocateEj(i12, 45) | 0) + 0 | 0;
      i2 = 42488 | 0;
      i11 = i5 + 45 | 0;
      do {
       HEAP8[i5 >> 0] = HEAP8[i2 >> 0] | 0;
       i5 = i5 + 1 | 0;
       i2 = i2 + 1 | 0;
      } while ((i5 | 0) < (i11 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-24, i12, 42480, 40912, 1792);
      __ZN2cv6String10deallocateEv(i12);
     }
     i2 = i7;
     i1 = i1 + ((Math_imul(HEAP32[i17 + 64 >> 2] | 0, i6 + -1 | 0) | 0) + i8) | 0;
    }
   } else {
    i2 = HEAP32[i17 + 44 >> 2] | 0;
    i3 = HEAP32[i17 + 40 >> 2] | 0;
   }
   if (!(i2 >>> 0 > i16 >>> 0 & i3 >>> 0 > i15 >>> 0)) {
    HEAP32[i13 >> 2] = 0;
    HEAP32[i13 + 4 >> 2] = 0;
    i5 = (__ZN2cv6String8allocateEj(i13, 21) | 0) + 0 | 0;
    i2 = 42456 | 0;
    i11 = i5 + 21 | 0;
    do {
     HEAP8[i5 >> 0] = HEAP8[i2 >> 0] | 0;
     i5 = i5 + 1 | 0;
     i2 = i2 + 1 | 0;
    } while ((i5 | 0) < (i11 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i13, 42480, 40912, 1804);
    __ZN2cv6String10deallocateEv(i13);
   }
   i4 = i1 + ((Math_imul(HEAP32[i17 + 72 >> 2] | 0, i16) | 0) + (Math_imul(i4, i15) | 0)) | 0;
   if (!i18) {
    i10 = i4;
    STACKTOP = i19;
    return i10 | 0;
   }
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i17 + 8 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 + -1 | 0) >>> 0 > 3) {
    HEAP32[i14 >> 2] = 0;
    HEAP32[i14 + 4 >> 2] = 0;
    __ZN2cv6String8allocateEj(i14, 0) | 0;
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-210, i14, 42480, 40912, 1812);
    __ZN2cv6String10deallocateEv(i14);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i18 >> 2] = (i1 << 3) + -8 | 1125516576 >>> ((i3 >>> 2 & 60) + (i3 >> 31 & 20) | 0) & 7;
   i10 = i4;
   STACKTOP = i19;
   return i10 | 0;
  }
  if ((i3 | 0) == 1111752704) {
   HEAP32[i6 >> 2] = i16;
   HEAP32[i6 + 4 >> 2] = i15;
   i10 = __ZL13icvGetNodePtrP11CvSparseMatPKiPiiPj(i17, i6, i18, 1, 0) | 0;
   STACKTOP = i19;
   return i10 | 0;
  } else if ((i3 | 0) != 1111687168) break;
  i4 = i17 + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1) {
   if (!(((HEAP32[i17 + 4 >> 2] | 0) == 2 ? (HEAP32[i17 + 20 >> 2] | 0) >>> 0 > i16 >>> 0 : 0) ? (HEAP32[i17 + 28 >> 2] | 0) >>> 0 > i15 >>> 0 : 0)) {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    i5 = (__ZN2cv6String8allocateEj(i9, 21) | 0) + 0 | 0;
    i2 = 42456 | 0;
    i11 = i5 + 21 | 0;
    do {
     HEAP8[i5 >> 0] = HEAP8[i2 >> 0] | 0;
     i5 = i5 + 1 | 0;
     i2 = i2 + 1 | 0;
    } while ((i5 | 0) < (i11 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i9, 42480, 40912, 1824);
    __ZN2cv6String10deallocateEv(i9);
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i10 = Math_imul(HEAP32[i17 + 24 >> 2] | 0, i16) | 0;
   i1 = i1 + ((Math_imul(HEAP32[i17 + 32 >> 2] | 0, i15) | 0) + i10) | 0;
   if (!i18) {
    i10 = i1;
    STACKTOP = i19;
    return i10 | 0;
   }
   HEAP32[i18 >> 2] = HEAP32[i17 >> 2] & 4095;
   i10 = i1;
   STACKTOP = i19;
   return i10 | 0;
  }
 } while (0);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i5 = (__ZN2cv6String8allocateEj(i10, 38) | 0) + 0 | 0;
 i2 = 42264 | 0;
 i11 = i5 + 38 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i2 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i5 | 0) < (i11 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i10, 42480, 40912, 1837);
 __ZN2cv6String10deallocateEv(i10);
 i10 = 0;
 STACKTOP = i19;
 return i10 | 0;
}

function _inflate_table(i7, i29, i5, i30, i27, i31) {
 i7 = i7 | 0;
 i29 = i29 | 0;
 i5 = i5 | 0;
 i30 = i30 | 0;
 i27 = i27 | 0;
 i31 = i31 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i28 = i33 + 32 | 0;
 i6 = i33;
 i1 = i28 + 0 | 0;
 i2 = i1 + 32 | 0;
 do {
  HEAP16[i1 >> 1] = 0;
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i4 = (i5 | 0) == 0;
 if (!i4) {
  i1 = 0;
  do {
   i22 = i28 + (HEAPU16[i29 + (i1 << 1) >> 1] << 1) | 0;
   HEAP16[i22 >> 1] = (HEAP16[i22 >> 1] | 0) + 1 << 16 >> 16;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 i2 = HEAP32[i27 >> 2] | 0;
 i25 = 15;
 while (1) {
  i1 = i25 + -1 | 0;
  if (HEAP16[i28 + (i25 << 1) >> 1] | 0) break;
  if (!i1) {
   i32 = 7;
   break;
  } else i25 = i1;
 }
 if ((i32 | 0) == 7) {
  i22 = HEAP32[i30 >> 2] | 0;
  HEAP32[i30 >> 2] = i22 + 4;
  HEAP8[i22 >> 0] = 64;
  HEAP8[i22 + 1 >> 0] = 1;
  HEAP16[i22 + 2 >> 1] = 0;
  i22 = HEAP32[i30 >> 2] | 0;
  HEAP32[i30 >> 2] = i22 + 4;
  HEAP8[i22 >> 0] = 64;
  HEAP8[i22 + 1 >> 0] = 1;
  HEAP16[i22 + 2 >> 1] = 0;
  HEAP32[i27 >> 2] = 1;
  i22 = 0;
  STACKTOP = i33;
  return i22 | 0;
 }
 i3 = i2 >>> 0 > i25 >>> 0 ? i25 : i2;
 L12 : do if (i25 >>> 0 > 1) {
  i1 = 1;
  while (1) {
   i2 = i1 + 1 | 0;
   if (HEAP16[i28 + (i1 << 1) >> 1] | 0) {
    i2 = i1;
    break L12;
   }
   if (i2 >>> 0 < i25 >>> 0) i1 = i2; else break;
  }
 } else i2 = 1; while (0);
 i24 = i3 >>> 0 < i2 >>> 0 ? i2 : i3;
 i3 = 1;
 i1 = 1;
 do {
  i3 = (i3 << 1) - (HEAPU16[i28 + (i1 << 1) >> 1] | 0) | 0;
  i1 = i1 + 1 | 0;
  if ((i3 | 0) < 0) {
   i26 = -1;
   i32 = 49;
   break;
  }
 } while (i1 >>> 0 < 16);
 if ((i32 | 0) == 49) {
  STACKTOP = i33;
  return i26 | 0;
 }
 if ((i3 | 0) > 0 ? (i7 | 0) == 0 | (i25 | 0) != 1 : 0) {
  i22 = -1;
  STACKTOP = i33;
  return i22 | 0;
 }
 HEAP16[i6 + 2 >> 1] = 0;
 i3 = 0;
 i1 = 1;
 do {
  i3 = (HEAPU16[i28 + (i1 << 1) >> 1] | 0) + (i3 & 65535) | 0;
  i1 = i1 + 1 | 0;
  HEAP16[i6 + (i1 << 1) >> 1] = i3;
 } while ((i1 | 0) != 15);
 if (!i4) {
  i3 = 0;
  do {
   i1 = HEAP16[i29 + (i3 << 1) >> 1] | 0;
   if (i1 << 16 >> 16) {
    i21 = i6 + ((i1 & 65535) << 1) | 0;
    i22 = HEAP16[i21 >> 1] | 0;
    HEAP16[i21 >> 1] = i22 + 1 << 16 >> 16;
    HEAP16[i31 + ((i22 & 65535) << 1) >> 1] = i3;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
 }
 if (!i7) {
  i1 = 0;
  i19 = 0;
  i21 = i31;
  i22 = 19;
  i23 = i31;
 } else if ((i7 | 0) == 1) if (i24 >>> 0 > 9) {
  i22 = 1;
  STACKTOP = i33;
  return i22 | 0;
 } else {
  i1 = 0;
  i19 = 1;
  i21 = 146288 + -514 | 0;
  i22 = 256;
  i23 = 146352 + -514 | 0;
 } else {
  i1 = (i7 | 0) == 2;
  if (i1 & i24 >>> 0 > 9) {
   i22 = 1;
   STACKTOP = i33;
   return i22 | 0;
  } else {
   i19 = 0;
   i21 = 146416;
   i22 = -1;
   i23 = 146480;
  }
 }
 i17 = 1 << i24;
 i18 = i17 + -1 | 0;
 i20 = i24 & 255;
 i4 = i24;
 i14 = 0;
 i8 = 0;
 i13 = -1;
 i16 = HEAP32[i30 >> 2] | 0;
 i6 = 0;
 L43 : while (1) {
  i10 = 1 << i4;
  while (1) {
   i4 = i2 - i14 | 0;
   i15 = i4 & 255;
   i7 = HEAP16[i31 + (i6 << 1) >> 1] | 0;
   i5 = i7 & 65535;
   if ((i5 | 0) >= (i22 | 0)) if ((i5 | 0) > (i22 | 0)) {
    i9 = HEAP16[i23 + (i5 << 1) >> 1] & 255;
    i7 = HEAP16[i21 + (i5 << 1) >> 1] | 0;
   } else {
    i9 = 96;
    i7 = 0;
   } else i9 = 0;
   i5 = 1 << i4;
   i4 = i8 >>> i14;
   i3 = i10;
   do {
    i12 = i3;
    i3 = i3 - i5 | 0;
    i11 = i3 + i4 | 0;
    HEAP8[i16 + (i11 << 2) >> 0] = i9;
    HEAP8[i16 + (i11 << 2) + 1 >> 0] = i15;
    HEAP16[i16 + (i11 << 2) + 2 >> 1] = i7;
   } while ((i12 | 0) != (i5 | 0));
   i4 = 1 << i2 + -1;
   while (1) if (!(i4 & i8)) break; else i4 = i4 >>> 1;
   if (!i4) i11 = 0; else i11 = (i4 + -1 & i8) + i4 | 0;
   i6 = i6 + 1 | 0;
   i3 = i28 + (i2 << 1) | 0;
   i12 = (HEAP16[i3 >> 1] | 0) + -1 << 16 >> 16;
   HEAP16[i3 >> 1] = i12;
   if (!(i12 << 16 >> 16)) {
    if ((i2 | 0) == (i25 | 0)) break L43;
    i2 = HEAPU16[i29 + (HEAPU16[i31 + (i6 << 1) >> 1] << 1) >> 1] | 0;
   }
   if (i2 >>> 0 <= i24 >>> 0) {
    i8 = i11;
    continue;
   }
   i12 = i11 & i18;
   if ((i12 | 0) != (i13 | 0)) break; else i8 = i11;
  }
  i9 = (i14 | 0) == 0 ? i24 : i14;
  i10 = i16 + (i10 << 2) | 0;
  i3 = i2 - i9 | 0;
  L66 : do if (i2 >>> 0 < i25 >>> 0) {
   i8 = i2;
   i4 = i3;
   i5 = 1 << i3;
   while (1) {
    i7 = i5 - (HEAPU16[i28 + (i8 << 1) >> 1] | 0) | 0;
    if ((i7 | 0) < 1) break L66;
    i4 = i4 + 1 | 0;
    i8 = i4 + i9 | 0;
    if (i8 >>> 0 >= i25 >>> 0) break; else i5 = i7 << 1;
   }
  } else i4 = i3; while (0);
  i7 = (1 << i4) + i17 | 0;
  if (i19 & i7 >>> 0 > 852 | i1 & i7 >>> 0 > 592) {
   i26 = 1;
   i32 = 49;
   break;
  }
  i14 = HEAP32[i30 >> 2] | 0;
  HEAP8[i14 + (i12 << 2) >> 0] = i4;
  HEAP8[i14 + (i12 << 2) + 1 >> 0] = i20;
  HEAP16[i14 + (i12 << 2) + 2 >> 1] = (i10 - i14 | 0) >>> 2;
  i14 = i9;
  i8 = i11;
  i13 = i12;
  i16 = i10;
  i17 = i7;
 }
 if ((i32 | 0) == 49) {
  STACKTOP = i33;
  return i26 | 0;
 }
 if (i11) {
  HEAP8[i16 + (i11 << 2) >> 0] = 64;
  HEAP8[i16 + (i11 << 2) + 1 >> 0] = i15;
  HEAP16[i16 + (i11 << 2) + 2 >> 1] = 0;
 }
 HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + (i17 << 2);
 HEAP32[i27 >> 2] = i24;
 i22 = 0;
 STACKTOP = i33;
 return i22 | 0;
}

function __ZN2cvL14GEMMStore_32fcEPKNS_7ComplexIfEEjPKNS0_IdEEjPS1_jNS_5Size_IiEEddi(i5, i2, i7, i3, i8, i4, i1, d19, d20, i6) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 d19 = +d19;
 d20 = +d20;
 i6 = i6 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, f22 = f0, f23 = f0, d24 = 0.0, d25 = 0.0, i26 = 0, i27 = 0, d28 = 0.0, d29 = 0.0;
 i21 = STACKTOP;
 i18 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i2 >>> 3;
 i17 = i3 >>> 4;
 i16 = i4 >>> 3;
 if (!i5) {
  i5 = 0;
  i15 = 0;
  i14 = 0;
 } else {
  i14 = (i6 & 4 | 0) == 0;
  i15 = i14 ? i2 : 1;
  i14 = i14 ? 1 : i2;
 }
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i2 = i14 << 1;
 i9 = i14 * 3 | 0;
 i10 = i14 << 2;
 i11 = i18 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i4 = i11 >>> 2;
 i13 = (i4 << 2) + 4 | 0;
 i3 = i5;
 i4 = i5 + (Math_imul(i14, (i4 << 5) + 32 | 0) | 0) | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  if (!i3) {
   if (i12) i6 = 0; else {
    i6 = 0;
    do {
     i26 = i6 | 1;
     d24 = +HEAPF64[i7 + (i26 << 4) >> 3] * d19;
     d25 = +HEAPF64[i7 + (i26 << 4) + 8 >> 3] * d19;
     f22 = Math_fround(+HEAPF64[i7 + (i6 << 4) >> 3] * d19);
     f23 = Math_fround(+HEAPF64[i7 + (i6 << 4) + 8 >> 3] * d19);
     f22 = Math_fround(f22);
     f23 = Math_fround(f23);
     i5 = i8 + (i6 << 3) | 0;
     HEAPF32[i5 >> 2] = f22;
     HEAPF32[i5 + 4 >> 2] = f23;
     f23 = Math_fround(d24);
     f22 = Math_fround(d25);
     f23 = Math_fround(f23);
     f22 = Math_fround(f22);
     i26 = i8 + (i26 << 3) | 0;
     HEAPF32[i26 >> 2] = f23;
     HEAPF32[i26 + 4 >> 2] = f22;
     i26 = i6 | 2;
     i5 = i6 | 3;
     d25 = +HEAPF64[i7 + (i5 << 4) >> 3] * d19;
     d24 = +HEAPF64[i7 + (i5 << 4) + 8 >> 3] * d19;
     f22 = Math_fround(+HEAPF64[i7 + (i26 << 4) >> 3] * d19);
     f23 = Math_fround(+HEAPF64[i7 + (i26 << 4) + 8 >> 3] * d19);
     f22 = Math_fround(f22);
     f23 = Math_fround(f23);
     i26 = i8 + (i26 << 3) | 0;
     HEAPF32[i26 >> 2] = f22;
     HEAPF32[i26 + 4 >> 2] = f23;
     f23 = Math_fround(d25);
     f22 = Math_fround(d24);
     f23 = Math_fround(f23);
     f22 = Math_fround(f22);
     i5 = i8 + (i5 << 3) | 0;
     HEAPF32[i5 >> 2] = f23;
     HEAPF32[i5 + 4 >> 2] = f22;
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i11 | 0));
    i6 = i13;
   }
   if ((i6 | 0) < (i18 | 0)) do {
    f23 = Math_fround(+HEAPF64[i7 + (i6 << 4) >> 3] * d19);
    f22 = Math_fround(+HEAPF64[i7 + (i6 << 4) + 8 >> 3] * d19);
    f23 = Math_fround(f23);
    f22 = Math_fround(f22);
    i5 = i8 + (i6 << 3) | 0;
    HEAPF32[i5 >> 2] = f23;
    HEAPF32[i5 + 4 >> 2] = f22;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i18 | 0));
  } else {
   if (i12) {
    i6 = i3;
    i5 = 0;
   } else {
    i6 = i3;
    i5 = 0;
    while (1) {
     i27 = i5 | 1;
     d24 = +Math_fround(HEAPF32[i6 >> 2]);
     d25 = +HEAPF64[i7 + (i5 << 4) + 8 >> 3] * d19 + +Math_fround(HEAPF32[i6 + 4 >> 2]) * d20;
     d28 = +Math_fround(HEAPF32[i6 + (i14 << 3) >> 2]);
     d28 = +HEAPF64[i7 + (i27 << 4) >> 3] * d19 + d28 * d20;
     d29 = +HEAPF64[i7 + (i27 << 4) + 8 >> 3] * d19 + +Math_fround(HEAPF32[i6 + (i14 << 3) + 4 >> 2]) * d20;
     f22 = Math_fround(+HEAPF64[i7 + (i5 << 4) >> 3] * d19 + d24 * d20);
     f23 = Math_fround(d25);
     f22 = Math_fround(f22);
     f23 = Math_fround(f23);
     i26 = i8 + (i5 << 3) | 0;
     HEAPF32[i26 >> 2] = f22;
     HEAPF32[i26 + 4 >> 2] = f23;
     f23 = Math_fround(d28);
     f22 = Math_fround(d29);
     f23 = Math_fround(f23);
     f22 = Math_fround(f22);
     i27 = i8 + (i27 << 3) | 0;
     HEAPF32[i27 >> 2] = f23;
     HEAPF32[i27 + 4 >> 2] = f22;
     i27 = i5 | 2;
     i26 = i5 | 3;
     d29 = +Math_fround(HEAPF32[i6 + (i2 << 3) >> 2]);
     d28 = +HEAPF64[i7 + (i27 << 4) + 8 >> 3] * d19 + +Math_fround(HEAPF32[i6 + (i2 << 3) + 4 >> 2]) * d20;
     d25 = +Math_fround(HEAPF32[i6 + (i9 << 3) >> 2]);
     d25 = +HEAPF64[i7 + (i26 << 4) >> 3] * d19 + d25 * d20;
     d24 = +HEAPF64[i7 + (i26 << 4) + 8 >> 3] * d19 + +Math_fround(HEAPF32[i6 + (i9 << 3) + 4 >> 2]) * d20;
     f22 = Math_fround(+HEAPF64[i7 + (i27 << 4) >> 3] * d19 + d29 * d20);
     f23 = Math_fround(d28);
     f22 = Math_fround(f22);
     f23 = Math_fround(f23);
     i27 = i8 + (i27 << 3) | 0;
     HEAPF32[i27 >> 2] = f22;
     HEAPF32[i27 + 4 >> 2] = f23;
     f23 = Math_fround(d25);
     f22 = Math_fround(d24);
     f23 = Math_fround(f23);
     f22 = Math_fround(f22);
     i26 = i8 + (i26 << 3) | 0;
     HEAPF32[i26 >> 2] = f23;
     HEAPF32[i26 + 4 >> 2] = f22;
     i5 = i5 + 4 | 0;
     if ((i5 | 0) > (i11 | 0)) {
      i6 = i4;
      i5 = i13;
      break;
     } else i6 = i6 + (i10 << 3) | 0;
    }
   }
   if ((i5 | 0) < (i18 | 0)) while (1) {
    d24 = +Math_fround(HEAPF32[i6 >> 2]);
    f23 = Math_fround(+HEAPF64[i7 + (i5 << 4) >> 3] * d19 + d24 * d20);
    f22 = Math_fround(+HEAPF64[i7 + (i5 << 4) + 8 >> 3] * d19 + +Math_fround(HEAPF32[i6 + 4 >> 2]) * d20);
    f23 = Math_fround(f23);
    f22 = Math_fround(f22);
    i27 = i8 + (i5 << 3) | 0;
    HEAPF32[i27 >> 2] = f23;
    HEAPF32[i27 + 4 >> 2] = f22;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i18 | 0)) break; else i6 = i6 + (i14 << 3) | 0;
   }
  }
  if (!i1) break; else {
   i7 = i7 + (i17 << 4) | 0;
   i8 = i8 + (i16 << 3) | 0;
   i3 = i3 + (i15 << 3) | 0;
   i4 = i4 + (i15 << 3) | 0;
  }
 }
 STACKTOP = i21;
 return;
}

function __ZN2cvL6sum64fEPKdPKhPdii(i6, i7, i17, i16, i15) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, d2 = 0.0, d3 = 0.0, i4 = 0, d5 = 0.0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0, i14 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 if (!i7) {
  i14 = (i15 | 0) % 4 | 0;
  if ((i14 | 0) == 3) {
   d3 = +HEAPF64[i17 >> 3];
   i9 = i17 + 8 | 0;
   d2 = +HEAPF64[i9 >> 3];
   i8 = i17 + 16 | 0;
   d5 = +HEAPF64[i8 >> 3];
   if ((i16 | 0) > 0) {
    i10 = 0;
    i11 = i6;
    while (1) {
     d3 = d3 + +HEAPF64[i11 >> 3];
     d2 = d2 + +HEAPF64[i11 + 8 >> 3];
     d5 = d5 + +HEAPF64[i11 + 16 >> 3];
     i10 = i10 + 1 | 0;
     if ((i10 | 0) == (i16 | 0)) {
      i1 = i16;
      break;
     } else i11 = i11 + (i15 << 3) | 0;
    }
   } else i1 = 0;
   HEAPF64[i17 >> 3] = d3;
   HEAPF64[i9 >> 3] = d2;
   HEAPF64[i8 >> 3] = d5;
  } else if ((i14 | 0) == 1) {
   d2 = +HEAPF64[i17 >> 3];
   i7 = i16 + -4 | 0;
   if ((i7 | 0) < 0) {
    i1 = 0;
    i4 = i6;
   } else {
    i8 = i15 << 1;
    i9 = i15 * 3 | 0;
    i10 = i15 << 2;
    i11 = i7 >>> 2;
    i4 = i6 + (Math_imul((i11 << 5) + 32 | 0, i15) | 0) | 0;
    i12 = 0;
    i1 = i6;
    while (1) {
     d2 = d2 + (+HEAPF64[i1 >> 3] + +HEAPF64[i1 + (i15 << 3) >> 3] + +HEAPF64[i1 + (i8 << 3) >> 3] + +HEAPF64[i1 + (i9 << 3) >> 3]);
     i12 = i12 + 4 | 0;
     if ((i12 | 0) > (i7 | 0)) break; else i1 = i1 + (i10 << 3) | 0;
    }
    i1 = (i11 << 2) + 4 | 0;
   }
   if ((i1 | 0) < (i16 | 0)) while (1) {
    d2 = d2 + +HEAPF64[i4 >> 3];
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    } else i4 = i4 + (i15 << 3) | 0;
   }
   HEAPF64[i17 >> 3] = d2;
  } else if ((i14 | 0) == 2) {
   d3 = +HEAPF64[i17 >> 3];
   i11 = i17 + 8 | 0;
   d2 = +HEAPF64[i11 >> 3];
   if ((i16 | 0) > 0) {
    i1 = 0;
    i4 = i6;
    while (1) {
     d3 = d3 + +HEAPF64[i4 >> 3];
     d2 = d2 + +HEAPF64[i4 + 8 >> 3];
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i16 | 0)) {
      i1 = i16;
      break;
     } else i4 = i4 + (i15 << 3) | 0;
    }
   } else i1 = 0;
   HEAPF64[i17 >> 3] = d3;
   HEAPF64[i11 >> 3] = d2;
  } else i1 = 0;
  if ((i14 | 0) < (i15 | 0)) i12 = i14; else {
   i14 = i16;
   STACKTOP = i18;
   return i14 | 0;
  }
  do {
   i9 = i17 + (i12 << 3) | 0;
   d3 = +HEAPF64[i9 >> 3];
   i8 = i17 + (i12 + 1 << 3) | 0;
   d13 = +HEAPF64[i8 >> 3];
   i7 = i17 + (i12 + 2 << 3) | 0;
   d2 = +HEAPF64[i7 >> 3];
   i4 = i17 + (i12 + 3 << 3) | 0;
   d5 = +HEAPF64[i4 >> 3];
   if ((i1 | 0) < (i16 | 0)) {
    i10 = i1;
    i11 = i6 + ((Math_imul(i1, i15) | 0) + i12 << 3) | 0;
    while (1) {
     d3 = d3 + +HEAPF64[i11 >> 3];
     d13 = d13 + +HEAPF64[i11 + 8 >> 3];
     d2 = d2 + +HEAPF64[i11 + 16 >> 3];
     d5 = d5 + +HEAPF64[i11 + 24 >> 3];
     i10 = i10 + 1 | 0;
     if ((i10 | 0) == (i16 | 0)) {
      i1 = i16;
      break;
     } else i11 = i11 + (i15 << 3) | 0;
    }
   }
   HEAPF64[i9 >> 3] = d3;
   HEAPF64[i8 >> 3] = d13;
   HEAPF64[i7 >> 3] = d2;
   HEAPF64[i4 >> 3] = d5;
   i12 = i12 + 4 | 0;
  } while ((i12 | 0) < (i15 | 0));
  i1 = i16;
  STACKTOP = i18;
  return i1 | 0;
 }
 if ((i15 | 0) == 1) {
  d2 = +HEAPF64[i17 >> 3];
  if ((i16 | 0) > 0) {
   i4 = 0;
   i1 = 0;
   do {
    if (HEAP8[i7 + i4 >> 0] | 0) {
     i1 = i1 + 1 | 0;
     d2 = d2 + +HEAPF64[i6 + (i4 << 3) >> 3];
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i16 | 0));
  } else i1 = 0;
  HEAPF64[i17 >> 3] = d2;
  i14 = i1;
  STACKTOP = i18;
  return i14 | 0;
 } else if ((i15 | 0) == 3) {
  d5 = +HEAPF64[i17 >> 3];
  i10 = i17 + 8 | 0;
  d3 = +HEAPF64[i10 >> 3];
  i9 = i17 + 16 | 0;
  d2 = +HEAPF64[i9 >> 3];
  if ((i16 | 0) > 0) {
   i11 = 0;
   i4 = 0;
   while (1) {
    if (HEAP8[i7 + i11 >> 0] | 0) {
     i4 = i4 + 1 | 0;
     d5 = d5 + +HEAPF64[i6 >> 3];
     d3 = d3 + +HEAPF64[i6 + 8 >> 3];
     d2 = d2 + +HEAPF64[i6 + 16 >> 3];
    }
    i11 = i11 + 1 | 0;
    if ((i11 | 0) == (i16 | 0)) break; else i6 = i6 + 24 | 0;
   }
  } else i4 = 0;
  HEAPF64[i17 >> 3] = d5;
  HEAPF64[i10 >> 3] = d3;
  HEAPF64[i9 >> 3] = d2;
  i14 = i4;
  STACKTOP = i18;
  return i14 | 0;
 } else {
  if ((i16 | 0) <= 0) {
   i14 = 0;
   STACKTOP = i18;
   return i14 | 0;
  }
  i11 = i15 + -4 | 0;
  i10 = (i11 | 0) < 0;
  i9 = i15 & -4;
  i8 = 0;
  i1 = 0;
  while (1) {
   if (HEAP8[i7 + i8 >> 0] | 0) {
    if (i10) i4 = 0; else {
     i4 = 0;
     do {
      i12 = i17 + (i4 << 3) | 0;
      i20 = i4 | 1;
      i19 = i17 + (i20 << 3) | 0;
      d2 = +HEAPF64[i19 >> 3] + +HEAPF64[i6 + (i20 << 3) >> 3];
      HEAPF64[i12 >> 3] = +HEAPF64[i12 >> 3] + +HEAPF64[i6 + (i4 << 3) >> 3];
      HEAPF64[i19 >> 3] = d2;
      i19 = i4 | 2;
      i12 = i17 + (i19 << 3) | 0;
      i20 = i4 | 3;
      i14 = i17 + (i20 << 3) | 0;
      d2 = +HEAPF64[i14 >> 3] + +HEAPF64[i6 + (i20 << 3) >> 3];
      HEAPF64[i12 >> 3] = +HEAPF64[i12 >> 3] + +HEAPF64[i6 + (i19 << 3) >> 3];
      HEAPF64[i14 >> 3] = d2;
      i4 = i4 + 4 | 0;
     } while ((i4 | 0) <= (i11 | 0));
     i4 = i9;
    }
    if ((i4 | 0) < (i15 | 0)) do {
     i14 = i17 + (i4 << 3) | 0;
     HEAPF64[i14 >> 3] = +HEAPF64[i6 + (i4 << 3) >> 3] + +HEAPF64[i14 >> 3];
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i15 | 0));
    i1 = i1 + 1 | 0;
   }
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i16 | 0)) break; else i6 = i6 + (i15 << 3) | 0;
  }
  STACKTOP = i18;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cv10HdrEncoder5writeERKNS_3MatERKNSt3__16vectorIiNS4_9allocatorIiEEEE(i13, i9, i15) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 i17 = i21 + 112 | 0;
 i5 = i21 + 104 | 0;
 i10 = i21 + 88 | 0;
 i6 = i21 + 68 | 0;
 i7 = i21 + 48 | 0;
 i8 = i21 + 28 | 0;
 i11 = i21 + 8 | 0;
 i12 = i21;
 HEAP32[i17 >> 2] = 1124007936;
 i19 = i17 + 4 | 0;
 i14 = i17 + 8 | 0;
 i16 = i17 + 40 | 0;
 i4 = i19 + 0 | 0;
 i1 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i1 | 0));
 HEAP32[i16 >> 2] = i14;
 i20 = i17 + 48 | 0;
 i18 = i17 + 44 | 0;
 HEAP32[i18 >> 2] = i20;
 HEAP32[i17 + 52 >> 2] = 0;
 HEAP32[i20 >> 2] = 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 >>> 3 & 511;
 if (!((i4 | 0) == 0 | (i4 | 0) == 2)) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i5, 54) | 0) + 0 | 0;
  i2 = 180280 | 0;
  i1 = i4 + 54 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i4 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 180336, 180344, 128);
  __ZN2cv6String10deallocateEv(i5);
  i3 = HEAP32[i9 >> 2] | 0;
 }
 if (!(i3 & 4088)) {
  __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEEC2EjRKS2_(i10, 3, i9);
  HEAP32[i6 >> 2] = 32088;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 17104896;
  HEAP32[i6 + 8 >> 2] = i10;
  i3 = i7 + 4 | 0;
  HEAP32[i3 + 0 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i7 >> 2] = 32232;
  HEAP32[i3 >> 2] = 33619968;
  HEAP32[i7 + 8 >> 2] = i17;
  __ZN2cv5mergeERKNS_11_InputArrayERKNS_12_OutputArrayE(i6, i7);
  i3 = HEAP32[i10 >> 2] | 0;
  if (i3) {
   i9 = i10 + 4 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) {
    do {
     i1 = i2 + -56 | 0;
     HEAP32[i9 >> 2] = i1;
     i4 = i2 + -20 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     if ((i5 | 0) != 0 ? (i7 = i5 + 12 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i1);
     HEAP32[i4 >> 2] = 0;
     i8 = i2 + -40 | 0;
     i5 = i2 + -52 | 0;
     HEAP32[i8 + 0 >> 2] = 0;
     HEAP32[i8 + 4 >> 2] = 0;
     HEAP32[i8 + 8 >> 2] = 0;
     HEAP32[i8 + 12 >> 2] = 0;
     if ((HEAP32[i5 >> 2] | 0) > 0) {
      i4 = HEAP32[i2 + -16 >> 2] | 0;
      i1 = 0;
      do {
       HEAP32[i4 + (i1 << 2) >> 2] = 0;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) < (HEAP32[i5 >> 2] | 0));
     }
     i1 = HEAP32[i2 + -12 >> 2] | 0;
     if ((i1 | 0) != (i2 + -8 | 0)) __ZN2cv8fastFreeEPv(i1);
     i2 = HEAP32[i9 >> 2] | 0;
    } while ((i2 | 0) != (i3 | 0));
    i3 = HEAP32[i10 >> 2] | 0;
   }
   __ZdlPv(i3);
  }
 } else {
  i10 = i8 + 4 | 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAP32[i8 >> 2] = 32232;
  HEAP32[i10 >> 2] = 33619968;
  HEAP32[i8 + 8 >> 2] = i17;
  __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i9, i8);
 }
 if ((HEAP32[i17 >> 2] & 7 | 0) != 5) {
  i10 = i11 + 4 | 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAP32[i11 >> 2] = 32232;
  HEAP32[i10 >> 2] = 33619968;
  HEAP32[i11 + 8 >> 2] = i17;
  __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i17, i11, 21, .003921568859368563, 0.0);
 }
 i10 = HEAP32[i15 >> 2] | 0;
 i3 = i15 + 4 | 0;
 if ((i10 | 0) != (HEAP32[i3 >> 2] | 0) ? (HEAP32[i10 >> 2] | 0) >>> 0 >= 2 : 0) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i12, 63) | 0) + 0 | 0;
  i2 = 180408 | 0;
  i1 = i4 + 63 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i4 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i12, 180336, 180344, 138);
  __ZN2cv6String10deallocateEv(i12);
 }
 i2 = HEAP32[i13 + 12 >> 2] | 0;
 i2 = _fopen(((i2 | 0) == 0 ? 180560 : i2) | 0, 180472) | 0;
 if (!i2) i3 = 0; else {
  i1 = i17 + 12 | 0;
  __Z16RGBE_WriteHeaderP8_IO_FILEiiP16rgbe_header_info(i2, HEAP32[i1 >> 2] | 0, HEAP32[i14 >> 2] | 0, 0) | 0;
  i10 = HEAP32[i15 >> 2] | 0;
  if ((i10 | 0) != (HEAP32[i3 >> 2] | 0) ? (HEAP32[i10 >> 2] | 0) != 1 : 0) __Z16RGBE_WritePixelsP8_IO_FILEPfi(i2, HEAP32[i17 + 16 >> 2] | 0, Math_imul(HEAP32[i14 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) | 0; else __Z20RGBE_WritePixels_RLEP8_IO_FILEPfii(i2, HEAP32[i17 + 16 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
  _fclose(i2 | 0) | 0;
  i3 = 1;
 }
 i2 = i17 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i17);
 HEAP32[i2 >> 2] = 0;
 i10 = i17 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i19 >> 2] | 0) > 0) {
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i19 >> 2] | 0));
 }
 i1 = HEAP32[i18 >> 2] | 0;
 if ((i1 | 0) == (i20 | 0)) {
  STACKTOP = i21;
  return i3 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i21;
 return i3 | 0;
}

function __ZN2cvL14MulTransposedLIfdEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d31) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d31 = +d31;
 var d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, d33 = 0.0, d34 = 0.0, i35 = 0, i36 = 0, d37 = 0.0, i38 = 0, d39 = 0.0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 i25 = i32;
 i24 = i32 + 32 | 0;
 i29 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 16 >> 2] | 0;
 i30 = (HEAP32[i3 + 48 >> 2] | 0) >>> 2;
 i28 = (HEAP32[i1 + 48 >> 2] | 0) >>> 3;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i22 = (HEAP32[i2 + 48 >> 2] | 0) >>> 3; else i22 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i27 = HEAP32[i3 + 40 >> 2] | 0;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i27 = HEAP32[i27 >> 2] | 0;
 if (!i23) {
  if ((i27 | 0) <= 0) {
   STACKTOP = i32;
   return;
  }
  i7 = i26 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i26 & -4;
  i10 = 0;
  while (1) {
   i1 = Math_imul(i10, i30) | 0;
   i5 = i10;
   do {
    i2 = Math_imul(i5, i30) | 0;
    if (i8) {
     i3 = 0;
     d4 = 0.0;
    } else {
     i3 = 0;
     d4 = 0.0;
     do {
      d34 = +Math_fround(HEAPF32[i29 + (i3 + i1 << 2) >> 2]);
      d34 = d34 * +Math_fround(HEAPF32[i29 + (i3 + i2 << 2) >> 2]);
      i23 = i3 | 1;
      d33 = +Math_fround(HEAPF32[i29 + (i23 + i1 << 2) >> 2]);
      d33 = d34 + d33 * +Math_fround(HEAPF32[i29 + (i23 + i2 << 2) >> 2]);
      i23 = i3 | 2;
      d34 = +Math_fround(HEAPF32[i29 + (i23 + i1 << 2) >> 2]);
      d34 = d33 + d34 * +Math_fround(HEAPF32[i29 + (i23 + i2 << 2) >> 2]);
      i23 = i3 | 3;
      d33 = +Math_fround(HEAPF32[i29 + (i23 + i1 << 2) >> 2]);
      d4 = d4 + (d34 + d33 * +Math_fround(HEAPF32[i29 + (i23 + i2 << 2) >> 2]));
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i7 | 0));
     i3 = i9;
    }
    if ((i3 | 0) < (i26 | 0)) do {
     d33 = +Math_fround(HEAPF32[i29 + (i3 + i1 << 2) >> 2]);
     d4 = d4 + d33 * +Math_fround(HEAPF32[i29 + (i3 + i2 << 2) >> 2]);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i26 | 0));
    HEAPF64[i6 + (i5 << 3) >> 3] = d4 * d31;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 3) | 0;
  }
  STACKTOP = i32;
  return;
 }
 i19 = (i2 | 0) == (i26 | 0) ? 4 : 0;
 i3 = i26 << 3;
 i20 = i24 + 8 | 0;
 HEAP32[i24 >> 2] = i20;
 i21 = i24 + 4 | 0;
 HEAP32[i21 >> 2] = 1032;
 if (i3 >>> 0 > 1032) {
  i18 = __Znaj(i3) | 0;
  HEAP32[i24 >> 2] = i18;
 } else i18 = i20;
 HEAP32[i21 >> 2] = i3;
 if ((i27 | 0) > 0) {
  i1 = (i2 | 0) < (i26 | 0);
  i11 = (i26 | 0) > 0;
  i12 = i25 + 24 | 0;
  i13 = i25 + 16 | 0;
  i14 = i25 + 8 | 0;
  i15 = i26 + -4 | 0;
  i16 = (i15 | 0) < 0;
  i2 = i15 >>> 2;
  i3 = Math_imul(i19, (i2 << 3) + 8 | 0) | 0;
  i2 = (i2 << 2) + 4 | 0;
  i17 = 0;
  while (1) {
   i7 = Math_imul(i17, i30) | 0;
   i9 = Math_imul(i17, i22) | 0;
   i8 = i23 + (i9 << 3) | 0;
   if (i1) if (i11) {
    i10 = 0;
    do {
     d4 = +Math_fround(HEAPF32[i29 + (i10 + i7 << 2) >> 2]);
     HEAPF64[i18 + (i10 << 3) >> 3] = d4 - +HEAPF64[i8 >> 3];
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17; else if (i11) {
    i10 = 0;
    do {
     d4 = +Math_fround(HEAPF32[i29 + (i10 + i7 << 2) >> 2]);
     HEAPF64[i18 + (i10 << 3) >> 3] = d4 - +HEAPF64[i23 + (i10 + i9 << 3) >> 3];
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17;
   do {
    i7 = Math_imul(i5, i30) | 0;
    i10 = i23 + ((Math_imul(i5, i22) | 0) << 3) | 0;
    if (i1) {
     d4 = +HEAPF64[i10 >> 3];
     HEAPF64[i12 >> 3] = d4;
     HEAPF64[i13 >> 3] = d4;
     HEAPF64[i14 >> 3] = d4;
     HEAPF64[i25 >> 3] = d4;
     i10 = i25;
    }
    if (i16) {
     i9 = 0;
     d4 = 0.0;
    } else {
     i8 = i10 + i3 | 0;
     i9 = 0;
     d4 = 0.0;
     while (1) {
      d39 = +Math_fround(HEAPF32[i29 + (i9 + i7 << 2) >> 2]);
      i38 = i9 | 1;
      d37 = +Math_fround(HEAPF32[i29 + (i38 + i7 << 2) >> 2]);
      i36 = i9 | 2;
      d34 = +Math_fround(HEAPF32[i29 + (i36 + i7 << 2) >> 2]);
      i35 = i9 | 3;
      d33 = +Math_fround(HEAPF32[i29 + (i35 + i7 << 2) >> 2]);
      d4 = d4 + (+HEAPF64[i18 + (i9 << 3) >> 3] * (d39 - +HEAPF64[i10 >> 3]) + +HEAPF64[i18 + (i38 << 3) >> 3] * (d37 - +HEAPF64[i10 + 8 >> 3]) + +HEAPF64[i18 + (i36 << 3) >> 3] * (d34 - +HEAPF64[i10 + 16 >> 3]) + +HEAPF64[i18 + (i35 << 3) >> 3] * (d33 - +HEAPF64[i10 + 24 >> 3]));
      i9 = i9 + 4 | 0;
      if ((i9 | 0) > (i15 | 0)) break; else i10 = i10 + (i19 << 3) | 0;
     }
     i9 = i2;
     i10 = i8;
    }
    if ((i9 | 0) < (i26 | 0)) while (1) {
     d37 = +Math_fround(HEAPF32[i29 + (i9 + i7 << 2) >> 2]);
     d4 = d4 + +HEAPF64[i18 + (i9 << 3) >> 3] * (d37 - +HEAPF64[i10 >> 3]);
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i26 | 0)) break; else i10 = i10 + 8 | 0;
    }
    HEAPF64[i6 + (i5 << 3) >> 3] = d4 * d31;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i17 = i17 + 1 | 0;
   if ((i17 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 3) | 0;
  }
 }
 if ((i18 | 0) == (i20 | 0)) {
  STACKTOP = i32;
  return;
 }
 __ZdaPv(i18);
 HEAP32[i24 >> 2] = i20;
 HEAP32[i21 >> 2] = 1032;
 STACKTOP = i32;
 return;
}

function __ZN2cvL5sum8uEPKhS1_Piii(i14, i12, i16, i15, i13) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i17 = 0;
 i17 = STACKTOP;
 if (!i12) {
  i12 = (i13 | 0) % 4 | 0;
  if ((i12 | 0) == 1) {
   i1 = HEAP32[i16 >> 2] | 0;
   i3 = i15 + -4 | 0;
   if ((i3 | 0) < 0) {
    i2 = 0;
    i3 = i14;
   } else {
    i2 = i13 << 1;
    i5 = i13 * 3 | 0;
    i6 = i13 << 2;
    i8 = i15 & -4;
    i7 = 0;
    i4 = i14;
    while (1) {
     i1 = (HEAPU8[i4 >> 0] | 0) + i1 + (HEAPU8[i4 + i13 >> 0] | 0) + (HEAPU8[i4 + i2 >> 0] | 0) + (HEAPU8[i4 + i5 >> 0] | 0) | 0;
     i7 = i7 + 4 | 0;
     if ((i7 | 0) > (i3 | 0)) break; else i4 = i4 + i6 | 0;
    }
    i2 = i8;
    i3 = i14 + (Math_imul(i8, i13) | 0) | 0;
   }
   if ((i2 | 0) < (i15 | 0)) while (1) {
    i1 = (HEAPU8[i3 >> 0] | 0) + i1 | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i15 | 0)) {
     i2 = i15;
     break;
    } else i3 = i3 + i13 | 0;
   }
   HEAP32[i16 >> 2] = i1;
  } else if ((i12 | 0) == 3) {
   i1 = HEAP32[i16 >> 2] | 0;
   i6 = i16 + 4 | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   i5 = i16 + 8 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if ((i15 | 0) > 0) {
    i8 = 0;
    i7 = i14;
    while (1) {
     i1 = (HEAPU8[i7 >> 0] | 0) + i1 | 0;
     i4 = (HEAPU8[i7 + 1 >> 0] | 0) + i4 | 0;
     i3 = (HEAPU8[i7 + 2 >> 0] | 0) + i3 | 0;
     i8 = i8 + 1 | 0;
     if ((i8 | 0) == (i15 | 0)) {
      i2 = i15;
      break;
     } else i7 = i7 + i13 | 0;
    }
   } else i2 = 0;
   HEAP32[i16 >> 2] = i1;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i5 >> 2] = i3;
  } else if ((i12 | 0) == 2) {
   i3 = HEAP32[i16 >> 2] | 0;
   i8 = i16 + 4 | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i15 | 0) > 0) {
    i7 = 0;
    i2 = i14;
    while (1) {
     i3 = (HEAPU8[i2 >> 0] | 0) + i3 | 0;
     i1 = (HEAPU8[i2 + 1 >> 0] | 0) + i1 | 0;
     i7 = i7 + 1 | 0;
     if ((i7 | 0) == (i15 | 0)) {
      i2 = i15;
      break;
     } else i2 = i2 + i13 | 0;
    }
   } else i2 = 0;
   HEAP32[i16 >> 2] = i3;
   HEAP32[i8 >> 2] = i1;
  } else i2 = 0;
  if ((i12 | 0) >= (i13 | 0)) {
   i10 = i15;
   STACKTOP = i17;
   return i10 | 0;
  }
  do {
   i1 = i16 + (i12 << 2) | 0;
   i6 = HEAP32[i1 >> 2] | 0;
   i9 = i16 + (i12 + 1 << 2) | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   i10 = i16 + (i12 + 2 << 2) | 0;
   i8 = HEAP32[i10 >> 2] | 0;
   i11 = i16 + (i12 + 3 << 2) | 0;
   i7 = HEAP32[i11 >> 2] | 0;
   if ((i2 | 0) < (i15 | 0)) {
    i3 = i2;
    i4 = i14 + ((Math_imul(i2, i13) | 0) + i12) | 0;
    while (1) {
     i6 = (HEAPU8[i4 >> 0] | 0) + i6 | 0;
     i5 = (HEAPU8[i4 + 1 >> 0] | 0) + i5 | 0;
     i8 = (HEAPU8[i4 + 2 >> 0] | 0) + i8 | 0;
     i7 = (HEAPU8[i4 + 3 >> 0] | 0) + i7 | 0;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i15 | 0)) {
      i2 = i15;
      break;
     } else i4 = i4 + i13 | 0;
    }
   }
   HEAP32[i1 >> 2] = i6;
   HEAP32[i9 >> 2] = i5;
   HEAP32[i10 >> 2] = i8;
   HEAP32[i11 >> 2] = i7;
   i12 = i12 + 4 | 0;
  } while ((i12 | 0) < (i13 | 0));
  i1 = i15;
  STACKTOP = i17;
  return i1 | 0;
 }
 if ((i13 | 0) == 1) {
  i1 = HEAP32[i16 >> 2] | 0;
  if ((i15 | 0) > 0) {
   i3 = 0;
   i2 = 0;
   do {
    if (HEAP8[i12 + i3 >> 0] | 0) {
     i2 = i2 + 1 | 0;
     i1 = (HEAPU8[i14 + i3 >> 0] | 0) + i1 | 0;
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i15 | 0));
  } else i2 = 0;
  HEAP32[i16 >> 2] = i1;
  i10 = i2;
  STACKTOP = i17;
  return i10 | 0;
 } else if ((i13 | 0) == 3) {
  i3 = HEAP32[i16 >> 2] | 0;
  i6 = i16 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i5 = i16 + 8 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i15 | 0) > 0) {
   i8 = 0;
   i4 = 0;
   i7 = i14;
   while (1) {
    if (HEAP8[i12 + i8 >> 0] | 0) {
     i4 = i4 + 1 | 0;
     i3 = (HEAPU8[i7 >> 0] | 0) + i3 | 0;
     i1 = (HEAPU8[i7 + 1 >> 0] | 0) + i1 | 0;
     i2 = (HEAPU8[i7 + 2 >> 0] | 0) + i2 | 0;
    }
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i15 | 0)) break; else i7 = i7 + 3 | 0;
   }
  } else i4 = 0;
  HEAP32[i16 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
  i10 = i4;
  STACKTOP = i17;
  return i10 | 0;
 } else {
  if ((i15 | 0) <= 0) {
   i10 = 0;
   STACKTOP = i17;
   return i10 | 0;
  }
  i6 = i13 + -4 | 0;
  i5 = (i6 | 0) < 0;
  i4 = i13 & -4;
  i2 = 0;
  i1 = 0;
  i7 = i14;
  while (1) {
   if (HEAP8[i12 + i2 >> 0] | 0) {
    if (i5) i3 = 0; else {
     i3 = 0;
     do {
      i9 = i16 + (i3 << 2) | 0;
      i8 = i3 | 1;
      i11 = i16 + (i8 << 2) | 0;
      i8 = (HEAPU8[i7 + i8 >> 0] | 0) + (HEAP32[i11 >> 2] | 0) | 0;
      HEAP32[i9 >> 2] = (HEAPU8[i7 + i3 >> 0] | 0) + (HEAP32[i9 >> 2] | 0);
      HEAP32[i11 >> 2] = i8;
      i11 = i3 | 2;
      i8 = i16 + (i11 << 2) | 0;
      i9 = i3 | 3;
      i10 = i16 + (i9 << 2) | 0;
      i9 = (HEAPU8[i7 + i9 >> 0] | 0) + (HEAP32[i10 >> 2] | 0) | 0;
      HEAP32[i8 >> 2] = (HEAPU8[i7 + i11 >> 0] | 0) + (HEAP32[i8 >> 2] | 0);
      HEAP32[i10 >> 2] = i9;
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i6 | 0));
     i3 = i4;
    }
    if ((i3 | 0) < (i13 | 0)) do {
     i10 = i16 + (i3 << 2) | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + (HEAPU8[i7 + i3 >> 0] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i13 | 0));
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i15 | 0)) break; else i7 = i7 + i13 | 0;
  }
  STACKTOP = i17;
  return i1 | 0;
 }
 return 0;
}

function _try_realloc_chunk(i15, i14) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 i12 = i15 + 4 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i7 = i13 & -8;
 i9 = i15 + i7 | 0;
 i6 = HEAP32[242538] | 0;
 i2 = i13 & 3;
 if (!((i2 | 0) != 1 & i15 >>> 0 >= i6 >>> 0 & i15 >>> 0 < i9 >>> 0)) _abort();
 i1 = i15 + (i7 | 4) | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!(i4 & 1)) _abort();
 if (!i2) {
  if (i14 >>> 0 < 256) {
   i10 = 0;
   STACKTOP = i16;
   return i10 | 0;
  }
  if (i7 >>> 0 >= (i14 + 4 | 0) >>> 0 ? (i7 - i14 | 0) >>> 0 <= HEAP32[242654] << 1 >>> 0 : 0) {
   i10 = i15;
   STACKTOP = i16;
   return i10 | 0;
  }
  i10 = 0;
  STACKTOP = i16;
  return i10 | 0;
 }
 if (i7 >>> 0 >= i14 >>> 0) {
  i2 = i7 - i14 | 0;
  if (i2 >>> 0 <= 15) {
   i10 = i15;
   STACKTOP = i16;
   return i10 | 0;
  }
  HEAP32[i12 >> 2] = i13 & 1 | i14 | 2;
  HEAP32[i15 + (i14 + 4) >> 2] = i2 | 3;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1;
  _dispose_chunk(i15 + i14 | 0, i2);
  i10 = i15;
  STACKTOP = i16;
  return i10 | 0;
 }
 if ((i9 | 0) == (HEAP32[242540] | 0)) {
  i2 = (HEAP32[242537] | 0) + i7 | 0;
  if (i2 >>> 0 <= i14 >>> 0) {
   i10 = 0;
   STACKTOP = i16;
   return i10 | 0;
  }
  i10 = i2 - i14 | 0;
  HEAP32[i12 >> 2] = i13 & 1 | i14 | 2;
  HEAP32[i15 + (i14 + 4) >> 2] = i10 | 1;
  HEAP32[242540] = i15 + i14;
  HEAP32[242537] = i10;
  i10 = i15;
  STACKTOP = i16;
  return i10 | 0;
 }
 if ((i9 | 0) == (HEAP32[242539] | 0)) {
  i2 = (HEAP32[242536] | 0) + i7 | 0;
  if (i2 >>> 0 < i14 >>> 0) {
   i10 = 0;
   STACKTOP = i16;
   return i10 | 0;
  }
  i1 = i2 - i14 | 0;
  if (i1 >>> 0 > 15) {
   HEAP32[i12 >> 2] = i13 & 1 | i14 | 2;
   HEAP32[i15 + (i14 + 4) >> 2] = i1 | 1;
   HEAP32[i15 + i2 >> 2] = i1;
   i2 = i15 + (i2 + 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -2;
   i2 = i15 + i14 | 0;
  } else {
   HEAP32[i12 >> 2] = i13 & 1 | i2 | 2;
   i2 = i15 + (i2 + 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
   i2 = 0;
   i1 = 0;
  }
  HEAP32[242536] = i1;
  HEAP32[242539] = i2;
  i10 = i15;
  STACKTOP = i16;
  return i10 | 0;
 }
 if (i4 & 2) {
  i10 = 0;
  STACKTOP = i16;
  return i10 | 0;
 }
 i10 = (i4 & -8) + i7 | 0;
 if (i10 >>> 0 < i14 >>> 0) {
  i10 = 0;
  STACKTOP = i16;
  return i10 | 0;
 }
 i11 = i10 - i14 | 0;
 i3 = i4 >>> 3;
 do if (i4 >>> 0 >= 256) {
  i5 = HEAP32[i15 + (i7 + 24) >> 2] | 0;
  i4 = HEAP32[i15 + (i7 + 12) >> 2] | 0;
  do if ((i4 | 0) == (i9 | 0)) {
   i1 = i15 + (i7 + 20) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i1 = i15 + (i7 + 16) | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i8 = 0;
     break;
    }
   }
   while (1) {
    i3 = i2 + 20 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4) {
     i2 = i4;
     i1 = i3;
     continue;
    }
    i4 = i2 + 16 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) break; else {
     i2 = i3;
     i1 = i4;
    }
   }
   if (i1 >>> 0 < i6 >>> 0) _abort(); else {
    HEAP32[i1 >> 2] = 0;
    i8 = i2;
    break;
   }
  } else {
   i3 = HEAP32[i15 + (i7 + 8) >> 2] | 0;
   if (i3 >>> 0 < i6 >>> 0) _abort();
   i2 = i3 + 12 | 0;
   if ((HEAP32[i2 >> 2] | 0) != (i9 | 0)) _abort();
   i1 = i4 + 8 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i9 | 0)) {
    HEAP32[i2 >> 2] = i4;
    HEAP32[i1 >> 2] = i3;
    i8 = i4;
    break;
   } else _abort();
  } while (0);
  if (i5) {
   i2 = HEAP32[i15 + (i7 + 28) >> 2] | 0;
   i1 = 970440 + (i2 << 2) | 0;
   if ((i9 | 0) == (HEAP32[i1 >> 2] | 0)) {
    HEAP32[i1 >> 2] = i8;
    if (!i8) {
     HEAP32[242535] = HEAP32[242535] & ~(1 << i2);
     break;
    }
   } else {
    if (i5 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort();
    i2 = i5 + 16 | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i9 | 0)) HEAP32[i2 >> 2] = i8; else HEAP32[i5 + 20 >> 2] = i8;
    if (!i8) break;
   }
   i1 = HEAP32[242538] | 0;
   if (i8 >>> 0 < i1 >>> 0) _abort();
   HEAP32[i8 + 24 >> 2] = i5;
   i2 = HEAP32[i15 + (i7 + 16) >> 2] | 0;
   do if (i2) if (i2 >>> 0 < i1 >>> 0) _abort(); else {
    HEAP32[i8 + 16 >> 2] = i2;
    HEAP32[i2 + 24 >> 2] = i8;
    break;
   } while (0);
   i2 = HEAP32[i15 + (i7 + 20) >> 2] | 0;
   if (i2) if (i2 >>> 0 < (HEAP32[242538] | 0) >>> 0) _abort(); else {
    HEAP32[i8 + 20 >> 2] = i2;
    HEAP32[i2 + 24 >> 2] = i8;
    break;
   }
  }
 } else {
  i4 = HEAP32[i15 + (i7 + 8) >> 2] | 0;
  i1 = HEAP32[i15 + (i7 + 12) >> 2] | 0;
  i2 = 970176 + (i3 << 1 << 2) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   if (i4 >>> 0 < i6 >>> 0) _abort();
   if ((HEAP32[i4 + 12 >> 2] | 0) != (i9 | 0)) _abort();
  }
  if ((i1 | 0) == (i4 | 0)) {
   HEAP32[242534] = HEAP32[242534] & ~(1 << i3);
   break;
  }
  if ((i1 | 0) != (i2 | 0)) {
   if (i1 >>> 0 < i6 >>> 0) _abort();
   i2 = i1 + 8 | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i9 | 0)) i5 = i2; else _abort();
  } else i5 = i1 + 8 | 0;
  HEAP32[i4 + 12 >> 2] = i1;
  HEAP32[i5 >> 2] = i4;
 } while (0);
 if (i11 >>> 0 < 16) {
  HEAP32[i12 >> 2] = i10 | i13 & 1 | 2;
  i10 = i15 + (i10 | 4) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1;
  i10 = i15;
  STACKTOP = i16;
  return i10 | 0;
 } else {
  HEAP32[i12 >> 2] = i13 & 1 | i14 | 2;
  HEAP32[i15 + (i14 + 4) >> 2] = i11 | 3;
  i10 = i15 + (i10 | 4) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1;
  _dispose_chunk(i15 + i14 | 0, i11);
  i10 = i15;
  STACKTOP = i16;
  return i10 | 0;
 }
 return 0;
}

function __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i17, i19, i3, i1, i16, i20, i15) {
 i17 = i17 | 0;
 i19 = i19 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i20 = i20 | 0;
 i15 = i15 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i5 = i23;
 i6 = (i1 - i3 | 0) / 12 | 0;
 if (i6 >>> 0 > 100) {
  i5 = _malloc(i6) | 0;
  if (!i5) __ZSt17__throw_bad_allocv(); else {
   i21 = i5;
   i2 = i5;
  }
 } else {
  i21 = 0;
  i2 = i5;
 }
 i18 = (i3 | 0) == (i1 | 0);
 if (i18) {
  i4 = 0;
  i5 = i6;
 } else {
  i8 = i3;
  i7 = 0;
  i5 = i6;
  i6 = i2;
  while (1) {
   i4 = HEAP8[i8 >> 0] | 0;
   if (!(i4 & 1)) i4 = (i4 & 255) >>> 1; else i4 = HEAP32[i8 + 4 >> 2] | 0;
   if (!i4) {
    HEAP8[i6 >> 0] = 2;
    i4 = i7 + 1 | 0;
    i5 = i5 + -1 | 0;
   } else {
    HEAP8[i6 >> 0] = 1;
    i4 = i7;
   }
   i8 = i8 + 12 | 0;
   if ((i8 | 0) == (i1 | 0)) break; else {
    i7 = i4;
    i6 = i6 + 1 | 0;
   }
  }
 }
 i14 = 0;
 i12 = i4;
 i10 = i5;
 L17 : while (1) {
  i5 = HEAP32[i17 >> 2] | 0;
  do if (i5) {
   i4 = HEAP32[i5 + 12 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i5 + 16 >> 2] | 0)) i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] & 127](i5) | 0; else i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) == -1) {
    HEAP32[i17 >> 2] = 0;
    i8 = 1;
    break;
   } else {
    i8 = (HEAP32[i17 >> 2] | 0) == 0;
    break;
   }
  } else i8 = 1; while (0);
  i4 = HEAP32[i19 >> 2] | 0;
  if (i4) {
   i6 = HEAP32[i4 + 12 >> 2] | 0;
   if ((i6 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i5 = HEAP32[i6 >> 2] | 0;
   if ((i5 | 0) == -1) {
    HEAP32[i19 >> 2] = 0;
    i9 = 0;
    i6 = 1;
   } else {
    i9 = i4;
    i6 = 0;
   }
  } else {
   i9 = 0;
   i6 = 1;
  }
  i7 = HEAP32[i17 >> 2] | 0;
  if (!((i8 ^ i6) & (i10 | 0) != 0)) break;
  i5 = HEAP32[i7 + 12 >> 2] | 0;
  if ((i5 | 0) == (HEAP32[i7 + 16 >> 2] | 0)) i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 127](i7) | 0; else i5 = HEAP32[i5 >> 2] | 0;
  if (!i15) i5 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 28 >> 2] & 127](i16, i5) | 0;
  i13 = i14 + 1 | 0;
  if (i18) {
   i14 = i13;
   continue;
  } else {
   i8 = 0;
   i11 = i3;
   i9 = i12;
   i4 = i10;
   i10 = i2;
  }
  while (1) {
   do if ((HEAP8[i10 >> 0] | 0) == 1) {
    if (!(HEAP8[i11 >> 0] & 1)) i7 = i11 + 4 | 0; else i7 = HEAP32[i11 + 8 >> 2] | 0;
    i7 = HEAP32[i7 + (i14 << 2) >> 2] | 0;
    if (!i15) i7 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i16 >> 2] | 0) + 28 >> 2] & 127](i16, i7) | 0;
    if ((i5 | 0) != (i7 | 0)) {
     HEAP8[i10 >> 0] = 0;
     i7 = i4 + -1 | 0;
     break;
    }
    i6 = HEAP8[i11 >> 0] | 0;
    if (!(i6 & 1)) i6 = (i6 & 255) >>> 1; else i6 = HEAP32[i11 + 4 >> 2] | 0;
    if ((i6 | 0) == (i13 | 0)) {
     HEAP8[i10 >> 0] = 2;
     i8 = 1;
     i9 = i9 + 1 | 0;
     i7 = i4 + -1 | 0;
    } else {
     i8 = 1;
     i7 = i4;
    }
   } else i7 = i4; while (0);
   i11 = i11 + 12 | 0;
   if ((i11 | 0) == (i1 | 0)) break; else {
    i4 = i7;
    i10 = i10 + 1 | 0;
   }
  }
  if (!i8) {
   i14 = i13;
   i12 = i9;
   i10 = i7;
   continue;
  }
  i6 = HEAP32[i17 >> 2] | 0;
  i5 = i6 + 12 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i6 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] & 127](i6) | 0; else HEAP32[i5 >> 2] = i4 + 4;
  if ((i9 + i7 | 0) >>> 0 < 2) {
   i14 = i13;
   i12 = i9;
   i10 = i7;
   continue;
  } else {
   i5 = i3;
   i6 = i9;
   i8 = i2;
  }
  while (1) {
   if ((HEAP8[i8 >> 0] | 0) == 2) {
    i4 = HEAP8[i5 >> 0] | 0;
    if (!(i4 & 1)) i4 = (i4 & 255) >>> 1; else i4 = HEAP32[i5 + 4 >> 2] | 0;
    if ((i4 | 0) != (i13 | 0)) {
     HEAP8[i8 >> 0] = 0;
     i6 = i6 + -1 | 0;
    }
   }
   i5 = i5 + 12 | 0;
   if ((i5 | 0) == (i1 | 0)) {
    i14 = i13;
    i12 = i6;
    i10 = i7;
    continue L17;
   } else i8 = i8 + 1 | 0;
  }
 }
 do if (i7) {
  i4 = HEAP32[i7 + 12 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 + 16 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 127](i7) | 0; else i4 = HEAP32[i4 >> 2] | 0;
  if ((i4 | 0) == -1) {
   HEAP32[i17 >> 2] = 0;
   i5 = 1;
   break;
  } else {
   i5 = (HEAP32[i17 >> 2] | 0) == 0;
   break;
  }
 } else i5 = 1; while (0);
 do if (i9) {
  i4 = HEAP32[i9 + 12 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] & 127](i9) | 0; else i4 = HEAP32[i4 >> 2] | 0;
  if ((i4 | 0) != -1) if (i5) break; else {
   i22 = 74;
   break;
  } else {
   HEAP32[i19 >> 2] = 0;
   i22 = 72;
   break;
  }
 } else i22 = 72; while (0);
 if ((i22 | 0) == 72 ? i5 : 0) i22 = 74;
 if ((i22 | 0) == 74) HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | 2;
 L106 : do if (i18) i22 = 78; else while (1) {
  if ((HEAP8[i2 >> 0] | 0) == 2) {
   i1 = i3;
   break L106;
  }
  i3 = i3 + 12 | 0;
  if ((i3 | 0) == (i1 | 0)) {
   i22 = 78;
   break;
  } else i2 = i2 + 1 | 0;
 } while (0);
 if ((i22 | 0) == 78) HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | 4;
 if (!i21) {
  STACKTOP = i23;
  return i1 | 0;
 }
 _free(i21);
 STACKTOP = i23;
 return i1 | 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_(i26, i1, i19, i24, i2, i25, i20) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i24 = i24 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i12 = i23 + 198 | 0;
 i1 = i23 + 196 | 0;
 i22 = i23 + 184 | 0;
 i21 = i23 + 172 | 0;
 i14 = i23 + 168 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 4 | 0;
 i15 = i23;
 i13 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i22, i2, i12, i1);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, 10, 0);
 if (!(HEAP8[i21 >> 0] & 1)) {
  i3 = i21 + 1 | 0;
  i9 = i3;
  i10 = i21 + 8 | 0;
 } else {
  i3 = i21 + 8 | 0;
  i9 = i21 + 1 | 0;
  i10 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i3;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i11 = i21 + 4 | 0;
 i8 = HEAP8[i1 >> 0] | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 L5 : while (1) {
  if (i1) {
   if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
    HEAP32[i19 >> 2] = 0;
    i1 = 0;
   }
  } else i1 = 0;
  i2 = (i1 | 0) == 0;
  i4 = HEAP32[i24 >> 2] | 0;
  do if (i4) {
   if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else break L5;
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) != -1) if (i2) break; else break L5; else {
    HEAP32[i24 >> 2] = 0;
    i27 = 14;
    break;
   }
  } else i27 = 14; while (0);
  if ((i27 | 0) == 14) {
   i27 = 0;
   if (i2) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i21 >> 0] | 0;
  i2 = (i6 & 1) == 0;
  if (i2) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i3 + i5 | 0)) {
   if (i2) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3 << 1, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i21 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = i9; else i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = i3 + i5;
  }
  i6 = i1 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i1 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i2 = HEAPU8[i5 >> 0] | 0;
  if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i2 & 255, i13, i3, i14, i15, i8, i22, i16, i17, i12) | 0) break;
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i4 + 1;
   continue;
  }
 }
 i2 = HEAP8[i22 >> 0] | 0;
 if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i18 = HEAP32[i17 >> 2] | 0, (i18 - i16 | 0) < 160) : 0) {
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i18 + 4;
  HEAP32[i18 >> 2] = i15;
 }
 i18 = __ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji(i3, HEAP32[i14 >> 2] | 0, i25, i13) | 0;
 HEAP32[i20 >> 2] = i18;
 HEAP32[i20 + 4 >> 2] = tempRet0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i16, HEAP32[i17 >> 2] | 0, i25);
 if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
   HEAP32[i19 >> 2] = 0;
   i1 = 0;
  }
 } else i1 = 0;
 i2 = (i1 | 0) == 0;
 do if (i4) {
  if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) {
   if (!i2) break;
   HEAP32[i26 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
   HEAP32[i24 >> 2] = 0;
   i27 = 50;
   break;
  }
  if (i2 ^ (i4 | 0) == 0) {
   HEAP32[i26 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
 } else i27 = 50; while (0);
 if ((i27 | 0) == 50 ? !i2 : 0) {
  HEAP32[i26 >> 2] = i1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  STACKTOP = i23;
  return;
 }
 HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 2;
 HEAP32[i26 >> 2] = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 STACKTOP = i23;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_(i26, i1, i19, i24, i2, i25, i20) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i24 = i24 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i12 = i23 + 198 | 0;
 i1 = i23 + 196 | 0;
 i22 = i23 + 184 | 0;
 i21 = i23 + 172 | 0;
 i14 = i23 + 168 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 4 | 0;
 i15 = i23;
 i13 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i22, i2, i12, i1);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, 10, 0);
 if (!(HEAP8[i21 >> 0] & 1)) {
  i3 = i21 + 1 | 0;
  i9 = i3;
  i10 = i21 + 8 | 0;
 } else {
  i3 = i21 + 8 | 0;
  i9 = i21 + 1 | 0;
  i10 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i3;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i11 = i21 + 4 | 0;
 i8 = HEAP8[i1 >> 0] | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 L5 : while (1) {
  if (i1) {
   if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
    HEAP32[i19 >> 2] = 0;
    i1 = 0;
   }
  } else i1 = 0;
  i2 = (i1 | 0) == 0;
  i4 = HEAP32[i24 >> 2] | 0;
  do if (i4) {
   if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else break L5;
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) != -1) if (i2) break; else break L5; else {
    HEAP32[i24 >> 2] = 0;
    i27 = 14;
    break;
   }
  } else i27 = 14; while (0);
  if ((i27 | 0) == 14) {
   i27 = 0;
   if (i2) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i21 >> 0] | 0;
  i2 = (i6 & 1) == 0;
  if (i2) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i3 + i5 | 0)) {
   if (i2) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3 << 1, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i21 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = i9; else i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = i3 + i5;
  }
  i6 = i1 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i1 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i2 = HEAPU8[i5 >> 0] | 0;
  if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i2 & 255, i13, i3, i14, i15, i8, i22, i16, i17, i12) | 0) break;
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i4 + 1;
   continue;
  }
 }
 i2 = HEAP8[i22 >> 0] | 0;
 if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i18 = HEAP32[i17 >> 2] | 0, (i18 - i16 | 0) < 160) : 0) {
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i18 + 4;
  HEAP32[i18 >> 2] = i15;
 }
 i18 = __ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji(i3, HEAP32[i14 >> 2] | 0, i25, i13) | 0;
 HEAP32[i20 >> 2] = i18;
 HEAP32[i20 + 4 >> 2] = tempRet0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i16, HEAP32[i17 >> 2] | 0, i25);
 if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
   HEAP32[i19 >> 2] = 0;
   i1 = 0;
  }
 } else i1 = 0;
 i2 = (i1 | 0) == 0;
 do if (i4) {
  if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) {
   if (!i2) break;
   HEAP32[i26 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
   HEAP32[i24 >> 2] = 0;
   i27 = 50;
   break;
  }
  if (i2 ^ (i4 | 0) == 0) {
   HEAP32[i26 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
 } else i27 = 50; while (0);
 if ((i27 | 0) == 50 ? !i2 : 0) {
  HEAP32[i26 >> 2] = i1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  STACKTOP = i23;
  return;
 }
 HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 2;
 HEAP32[i26 >> 2] = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 STACKTOP = i23;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_(i26, i1, i20, i24, i3, i25, i19) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i24 = i24 | 0;
 i3 = i3 | 0;
 i25 = i25 | 0;
 i19 = i19 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i12 = i23 + 200 | 0;
 i2 = i23 + 196 | 0;
 i22 = i23 + 184 | 0;
 i21 = i23 + 172 | 0;
 i14 = i23 + 168 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 4 | 0;
 i15 = i23;
 i13 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i3) | 0;
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i22, i3, i12, i2);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, 10, 0);
 if (!(HEAP8[i21 >> 0] & 1)) {
  i1 = i21 + 1 | 0;
  i9 = i1;
  i10 = i21 + 8 | 0;
 } else {
  i1 = i21 + 8 | 0;
  i9 = i21 + 1 | 0;
  i10 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i1;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i11 = i21 + 4 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 L5 : while (1) {
  if (i2) {
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) == -1) {
    HEAP32[i20 >> 2] = 0;
    i5 = 1;
    i2 = 0;
   } else i5 = 0;
  } else {
   i5 = 1;
   i2 = 0;
  }
  i4 = HEAP32[i24 >> 2] | 0;
  do if (i4) {
   i3 = HEAP32[i4 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) != -1) if (i5) break; else break L5; else {
    HEAP32[i24 >> 2] = 0;
    i27 = 17;
    break;
   }
  } else i27 = 17; while (0);
  if ((i27 | 0) == 17) {
   i27 = 0;
   if (i5) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i21 >> 0] | 0;
  i3 = (i6 & 1) == 0;
  if (i3) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i1 + i5 | 0)) {
   if (i3) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3 << 1, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i21 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i1 = i9; else i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = i1 + i5;
  }
  i6 = i2 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i2 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i5 >> 2] | 0;
  if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i3, i13, i1, i14, i15, i8, i22, i16, i17, i12) | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i3 + 4;
   continue;
  }
 }
 i3 = HEAP8[i22 >> 0] | 0;
 if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i18 = HEAP32[i17 >> 2] | 0, (i18 - i16 | 0) < 160) : 0) {
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i18 + 4;
  HEAP32[i18 >> 2] = i15;
 }
 i18 = __ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji(i1, HEAP32[i14 >> 2] | 0, i25, i13) | 0;
 HEAP32[i19 >> 2] = i18;
 HEAP32[i19 + 4 >> 2] = tempRet0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i16, HEAP32[i17 >> 2] | 0, i25);
 if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i20 >> 2] = 0;
   i2 = 0;
   i3 = 1;
  } else i3 = 0;
 } else {
  i2 = 0;
  i3 = 1;
 }
 do if (i4) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i24 >> 2] = 0;
   i27 = 56;
   break;
  }
  if (i3) {
   HEAP32[i26 >> 2] = i2;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
 } else i27 = 56; while (0);
 if ((i27 | 0) == 56 ? !i3 : 0) {
  HEAP32[i26 >> 2] = i2;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  STACKTOP = i23;
  return;
 }
 HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 2;
 HEAP32[i26 >> 2] = i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 STACKTOP = i23;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_(i26, i1, i20, i24, i3, i25, i19) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i24 = i24 | 0;
 i3 = i3 | 0;
 i25 = i25 | 0;
 i19 = i19 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i12 = i23 + 200 | 0;
 i2 = i23 + 196 | 0;
 i22 = i23 + 184 | 0;
 i21 = i23 + 172 | 0;
 i14 = i23 + 168 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 4 | 0;
 i15 = i23;
 i13 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i3) | 0;
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i22, i3, i12, i2);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, 10, 0);
 if (!(HEAP8[i21 >> 0] & 1)) {
  i1 = i21 + 1 | 0;
  i9 = i1;
  i10 = i21 + 8 | 0;
 } else {
  i1 = i21 + 8 | 0;
  i9 = i21 + 1 | 0;
  i10 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i1;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i11 = i21 + 4 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 L5 : while (1) {
  if (i2) {
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) == -1) {
    HEAP32[i20 >> 2] = 0;
    i5 = 1;
    i2 = 0;
   } else i5 = 0;
  } else {
   i5 = 1;
   i2 = 0;
  }
  i4 = HEAP32[i24 >> 2] | 0;
  do if (i4) {
   i3 = HEAP32[i4 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) != -1) if (i5) break; else break L5; else {
    HEAP32[i24 >> 2] = 0;
    i27 = 17;
    break;
   }
  } else i27 = 17; while (0);
  if ((i27 | 0) == 17) {
   i27 = 0;
   if (i5) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i21 >> 0] | 0;
  i3 = (i6 & 1) == 0;
  if (i3) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i1 + i5 | 0)) {
   if (i3) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3 << 1, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i21 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i1 = i9; else i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = i1 + i5;
  }
  i6 = i2 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i2 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i5 >> 2] | 0;
  if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i3, i13, i1, i14, i15, i8, i22, i16, i17, i12) | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i3 + 4;
   continue;
  }
 }
 i3 = HEAP8[i22 >> 0] | 0;
 if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i18 = HEAP32[i17 >> 2] | 0, (i18 - i16 | 0) < 160) : 0) {
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i18 + 4;
  HEAP32[i18 >> 2] = i15;
 }
 i18 = __ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji(i1, HEAP32[i14 >> 2] | 0, i25, i13) | 0;
 HEAP32[i19 >> 2] = i18;
 HEAP32[i19 + 4 >> 2] = tempRet0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i16, HEAP32[i17 >> 2] | 0, i25);
 if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i20 >> 2] = 0;
   i2 = 0;
   i3 = 1;
  } else i3 = 0;
 } else {
  i2 = 0;
  i3 = 1;
 }
 do if (i4) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i24 >> 2] = 0;
   i27 = 56;
   break;
  }
  if (i3) {
   HEAP32[i26 >> 2] = i2;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
 } else i27 = 56; while (0);
 if ((i27 | 0) == 56 ? !i3 : 0) {
  HEAP32[i26 >> 2] = i2;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  STACKTOP = i23;
  return;
 }
 HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 2;
 HEAP32[i26 >> 2] = i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 STACKTOP = i23;
 return;
}

function __ZN2cvL5sum8sEPKaPKhPiii(i14, i12, i16, i15, i13) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i17 = 0;
 i17 = STACKTOP;
 if (!i12) {
  i12 = (i13 | 0) % 4 | 0;
  if ((i12 | 0) == 1) {
   i1 = HEAP32[i16 >> 2] | 0;
   i3 = i15 + -4 | 0;
   if ((i3 | 0) < 0) {
    i2 = 0;
    i3 = i14;
   } else {
    i2 = i13 << 1;
    i5 = i13 * 3 | 0;
    i6 = i13 << 2;
    i8 = i15 & -4;
    i7 = 0;
    i4 = i14;
    while (1) {
     i1 = (HEAP8[i4 >> 0] | 0) + i1 + (HEAP8[i4 + i13 >> 0] | 0) + (HEAP8[i4 + i2 >> 0] | 0) + (HEAP8[i4 + i5 >> 0] | 0) | 0;
     i7 = i7 + 4 | 0;
     if ((i7 | 0) > (i3 | 0)) break; else i4 = i4 + i6 | 0;
    }
    i2 = i8;
    i3 = i14 + (Math_imul(i8, i13) | 0) | 0;
   }
   if ((i2 | 0) < (i15 | 0)) while (1) {
    i1 = (HEAP8[i3 >> 0] | 0) + i1 | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i15 | 0)) {
     i2 = i15;
     break;
    } else i3 = i3 + i13 | 0;
   }
   HEAP32[i16 >> 2] = i1;
  } else if ((i12 | 0) == 3) {
   i1 = HEAP32[i16 >> 2] | 0;
   i6 = i16 + 4 | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   i5 = i16 + 8 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if ((i15 | 0) > 0) {
    i8 = 0;
    i7 = i14;
    while (1) {
     i1 = (HEAP8[i7 >> 0] | 0) + i1 | 0;
     i4 = (HEAP8[i7 + 1 >> 0] | 0) + i4 | 0;
     i3 = (HEAP8[i7 + 2 >> 0] | 0) + i3 | 0;
     i8 = i8 + 1 | 0;
     if ((i8 | 0) == (i15 | 0)) {
      i2 = i15;
      break;
     } else i7 = i7 + i13 | 0;
    }
   } else i2 = 0;
   HEAP32[i16 >> 2] = i1;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i5 >> 2] = i3;
  } else if ((i12 | 0) == 2) {
   i3 = HEAP32[i16 >> 2] | 0;
   i8 = i16 + 4 | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i15 | 0) > 0) {
    i7 = 0;
    i2 = i14;
    while (1) {
     i3 = (HEAP8[i2 >> 0] | 0) + i3 | 0;
     i1 = (HEAP8[i2 + 1 >> 0] | 0) + i1 | 0;
     i7 = i7 + 1 | 0;
     if ((i7 | 0) == (i15 | 0)) {
      i2 = i15;
      break;
     } else i2 = i2 + i13 | 0;
    }
   } else i2 = 0;
   HEAP32[i16 >> 2] = i3;
   HEAP32[i8 >> 2] = i1;
  } else i2 = 0;
  if ((i12 | 0) >= (i13 | 0)) {
   i10 = i15;
   STACKTOP = i17;
   return i10 | 0;
  }
  do {
   i1 = i16 + (i12 << 2) | 0;
   i6 = HEAP32[i1 >> 2] | 0;
   i9 = i16 + (i12 + 1 << 2) | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   i10 = i16 + (i12 + 2 << 2) | 0;
   i8 = HEAP32[i10 >> 2] | 0;
   i11 = i16 + (i12 + 3 << 2) | 0;
   i7 = HEAP32[i11 >> 2] | 0;
   if ((i2 | 0) < (i15 | 0)) {
    i3 = i2;
    i4 = i14 + ((Math_imul(i2, i13) | 0) + i12) | 0;
    while (1) {
     i6 = (HEAP8[i4 >> 0] | 0) + i6 | 0;
     i5 = (HEAP8[i4 + 1 >> 0] | 0) + i5 | 0;
     i8 = (HEAP8[i4 + 2 >> 0] | 0) + i8 | 0;
     i7 = (HEAP8[i4 + 3 >> 0] | 0) + i7 | 0;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i15 | 0)) {
      i2 = i15;
      break;
     } else i4 = i4 + i13 | 0;
    }
   }
   HEAP32[i1 >> 2] = i6;
   HEAP32[i9 >> 2] = i5;
   HEAP32[i10 >> 2] = i8;
   HEAP32[i11 >> 2] = i7;
   i12 = i12 + 4 | 0;
  } while ((i12 | 0) < (i13 | 0));
  i1 = i15;
  STACKTOP = i17;
  return i1 | 0;
 }
 if ((i13 | 0) == 3) {
  i3 = HEAP32[i16 >> 2] | 0;
  i6 = i16 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i5 = i16 + 8 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i15 | 0) > 0) {
   i8 = 0;
   i4 = 0;
   i7 = i14;
   while (1) {
    if (HEAP8[i12 + i8 >> 0] | 0) {
     i4 = i4 + 1 | 0;
     i3 = (HEAP8[i7 >> 0] | 0) + i3 | 0;
     i1 = (HEAP8[i7 + 1 >> 0] | 0) + i1 | 0;
     i2 = (HEAP8[i7 + 2 >> 0] | 0) + i2 | 0;
    }
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i15 | 0)) break; else i7 = i7 + 3 | 0;
   }
  } else i4 = 0;
  HEAP32[i16 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
  i10 = i4;
  STACKTOP = i17;
  return i10 | 0;
 } else if ((i13 | 0) == 1) {
  i1 = HEAP32[i16 >> 2] | 0;
  if ((i15 | 0) > 0) {
   i3 = 0;
   i2 = 0;
   do {
    if (HEAP8[i12 + i3 >> 0] | 0) {
     i2 = i2 + 1 | 0;
     i1 = (HEAP8[i14 + i3 >> 0] | 0) + i1 | 0;
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i15 | 0));
  } else i2 = 0;
  HEAP32[i16 >> 2] = i1;
  i10 = i2;
  STACKTOP = i17;
  return i10 | 0;
 } else {
  if ((i15 | 0) <= 0) {
   i10 = 0;
   STACKTOP = i17;
   return i10 | 0;
  }
  i6 = i13 + -4 | 0;
  i5 = (i6 | 0) < 0;
  i4 = i13 & -4;
  i2 = 0;
  i1 = 0;
  i7 = i14;
  while (1) {
   if (HEAP8[i12 + i2 >> 0] | 0) {
    if (i5) i3 = 0; else {
     i3 = 0;
     do {
      i9 = i16 + (i3 << 2) | 0;
      i8 = i3 | 1;
      i11 = i16 + (i8 << 2) | 0;
      i8 = (HEAP8[i7 + i8 >> 0] | 0) + (HEAP32[i11 >> 2] | 0) | 0;
      HEAP32[i9 >> 2] = (HEAP8[i7 + i3 >> 0] | 0) + (HEAP32[i9 >> 2] | 0);
      HEAP32[i11 >> 2] = i8;
      i11 = i3 | 2;
      i8 = i16 + (i11 << 2) | 0;
      i9 = i3 | 3;
      i10 = i16 + (i9 << 2) | 0;
      i9 = (HEAP8[i7 + i9 >> 0] | 0) + (HEAP32[i10 >> 2] | 0) | 0;
      HEAP32[i8 >> 2] = (HEAP8[i7 + i11 >> 0] | 0) + (HEAP32[i8 >> 2] | 0);
      HEAP32[i10 >> 2] = i9;
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i6 | 0));
     i3 = i4;
    }
    if ((i3 | 0) < (i13 | 0)) do {
     i10 = i16 + (i3 << 2) | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + (HEAP8[i7 + i3 >> 0] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i13 | 0));
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i15 | 0)) break; else i7 = i7 + i13 | 0;
  }
  STACKTOP = i17;
  return i1 | 0;
 }
 return 0;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv(i24, i1, i18, i22, i3, i23, i17) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i22 = i22 | 0;
 i3 = i3 | 0;
 i23 = i23 | 0;
 i17 = i17 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i25 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 i16 = i21;
 i10 = i21 + 208 | 0;
 i20 = i21 + 196 | 0;
 i14 = i21 + 192 | 0;
 i19 = i21 + 180 | 0;
 i15 = i21 + 176 | 0;
 i12 = i21 + 16 | 0;
 i13 = i21 + 8 | 0;
 i11 = i21 + 4 | 0;
 HEAP32[i20 + 0 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 __ZNKSt3__18ios_base6getlocEv(i14, i3);
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i14, 960720) | 0;
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] & 7](i1, 959240, 959266 | 0, i10) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i14 >> 2] | 0) | 0;
 HEAP32[i19 + 0 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i19, 10, 0);
 if (!(HEAP8[i19 >> 0] & 1)) {
  i1 = i19 + 1 | 0;
  i3 = i1;
  i14 = i19 + 8 | 0;
 } else {
  i1 = i19 + 8 | 0;
  i3 = i19 + 1 | 0;
  i14 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i15 >> 2] = i1;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i11 >> 2] = 0;
 i9 = i19 + 4 | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 L5 : while (1) {
  if (i2) {
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i4 = HEAP32[i4 >> 2] | 0;
   if ((i4 | 0) == -1) {
    HEAP32[i18 >> 2] = 0;
    i6 = 1;
    i2 = 0;
   } else i6 = 0;
  } else {
   i6 = 1;
   i2 = 0;
  }
  i5 = HEAP32[i22 >> 2] | 0;
  do if (i5) {
   i4 = HEAP32[i5 + 12 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i5 + 16 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] & 127](i5) | 0; else i4 = HEAP32[i4 >> 2] | 0;
   if ((i4 | 0) != -1) if (i6) break; else {
    i4 = i5;
    break L5;
   } else {
    HEAP32[i22 >> 2] = 0;
    i25 = 17;
    break;
   }
  } else i25 = 17; while (0);
  if ((i25 | 0) == 17) {
   i25 = 0;
   if (i6) {
    i4 = 0;
    break;
   } else i5 = 0;
  }
  i7 = HEAP8[i19 >> 0] | 0;
  i4 = (i7 & 1) == 0;
  if (i4) i6 = (i7 & 255) >>> 1; else i6 = HEAP32[i9 >> 2] | 0;
  if ((HEAP32[i15 >> 2] | 0) == (i1 + i6 | 0)) {
   if (i4) {
    i4 = (i7 & 255) >>> 1;
    i6 = (i7 & 255) >>> 1;
   } else {
    i6 = HEAP32[i9 >> 2] | 0;
    i4 = i6;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i19, i4 << 1, 0);
   if (!(HEAP8[i19 >> 0] & 1)) i4 = 10; else i4 = (HEAP32[i19 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i19, i4, 0);
   if (!(HEAP8[i19 >> 0] & 1)) i1 = i3; else i1 = HEAP32[i14 >> 2] | 0;
   HEAP32[i15 >> 2] = i1 + i6;
  }
  i7 = i2 + 12 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i8 = i2 + 16 | 0;
  if ((i6 | 0) == (HEAP32[i8 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i4 = HEAP32[i6 >> 2] | 0;
  if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i4, 16, i1, i15, i11, 0, i20, i12, i13, i10) | 0) {
   i4 = i5;
   break;
  }
  i4 = HEAP32[i7 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i8 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   continue;
  } else {
   HEAP32[i7 >> 2] = i4 + 4;
   continue;
  }
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i19, (HEAP32[i15 >> 2] | 0) - i1 | 0, 0);
 if (HEAP8[i19 >> 0] & 1) i3 = HEAP32[i14 >> 2] | 0;
 i15 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i16 >> 2] = i17;
 if ((__ZNSt3__110__sscanf_lEPKcP15__locale_structS1_z(i3, i15, 959280, i16) | 0) != 1) HEAP32[i23 >> 2] = 4;
 if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i18 >> 2] = 0;
   i2 = 0;
   i3 = 1;
  } else i3 = 0;
 } else {
  i2 = 0;
  i3 = 1;
 }
 do if (i4) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i22 >> 2] = 0;
   i25 = 54;
   break;
  }
  if (i3) {
   HEAP32[i24 >> 2] = i2;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
   STACKTOP = i21;
   return;
  }
 } else i25 = 54; while (0);
 if ((i25 | 0) == 54 ? !i3 : 0) {
  HEAP32[i24 >> 2] = i2;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
  STACKTOP = i21;
  return;
 }
 HEAP32[i23 >> 2] = HEAP32[i23 >> 2] | 2;
 HEAP32[i24 >> 2] = i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
 STACKTOP = i21;
 return;
}

function __ZN2cv4UMat6createEiPKiiNS_14UMatUsageFlagsE(i14, i7, i1, i4, i3) {
 i14 = i14 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i16 + 16 | 0;
 i9 = i16 + 8 | 0;
 i11 = i16;
 i10 = i14 + 20 | 0;
 HEAP32[i10 >> 2] = i3;
 if (!(i7 >>> 0 < 33 & (i1 | 0) != 0)) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i6 = (__ZN2cv6String8allocateEj(i5, 35) | 0) + 0 | 0;
  i3 = 17624 | 0;
  i2 = i6 + 35 | 0;
  do {
   HEAP8[i6 >> 0] = HEAP8[i3 >> 0] | 0;
   i6 = i6 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i6 | 0) < (i2 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 17664, 17672, 240);
  __ZN2cv6String10deallocateEv(i5);
 }
 i8 = i4 & 4095;
 i13 = i14 + 24 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (i2) {
  i6 = HEAP32[i14 + 4 >> 2] | 0;
  if (!((i6 | 0) != (i7 | 0) ? !((i7 | 0) == 1 & (i6 | 0) < 3) : 0)) i15 = 6;
  if ((i15 | 0) == 6 ? (i8 | 0) == (HEAP32[i14 >> 2] & 4095 | 0) : 0) {
   if ((i7 | 0) == 2) if ((HEAP32[i14 + 8 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) if ((HEAP32[i14 + 12 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    STACKTOP = i16;
    return;
   } else i15 = 10; else i15 = 11; else i15 = 10;
   if ((i15 | 0) == 10) if ((i7 | 0) > 0) i15 = 11; else i4 = 0;
   L17 : do if ((i15 | 0) == 11) {
    i5 = HEAP32[i14 + 32 >> 2] | 0;
    i3 = 0;
    while (1) {
     i4 = i3 + 1 | 0;
     if ((HEAP32[i5 + (i3 << 2) >> 2] | 0) != (HEAP32[i1 + (i3 << 2) >> 2] | 0)) {
      i4 = i3;
      break L17;
     }
     if ((i4 | 0) < (i7 | 0)) i3 = i4; else break;
    }
   } while (0);
   if ((i4 | 0) == (i7 | 0)) {
    if ((i7 | 0) > 1) {
     STACKTOP = i16;
     return;
    }
    if ((HEAP32[(HEAP32[i14 + 32 >> 2] | 0) + 4 >> 2] | 0) == 1) {
     STACKTOP = i16;
     return;
    }
   }
  }
  i5 = i2 + 8 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = i6 + -1;
  if ((i6 | 0) == 1) {
   i6 = HEAP32[i13 >> 2] | 0;
   i5 = HEAP32[i6 + 4 >> 2] | 0;
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] & 127](i5, i6);
   HEAP32[i13 >> 2] = 0;
  }
 }
 i12 = i14 + 32 | 0;
 HEAP32[HEAP32[i12 >> 2] >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 if (!i7) {
  STACKTOP = i16;
  return;
 }
 HEAP32[i14 >> 2] = i8 | 1124007936;
 __ZN2cvL7setSizeERNS_4UMatEiPKiPKjb(i14, i7, i1, 0, 1);
 HEAP32[i14 + 28 >> 2] = 0;
 i1 = i14 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if ((i6 | 0) < 3) i3 = Math_imul(HEAP32[i14 + 12 >> 2] | 0, HEAP32[i14 + 8 >> 2] | 0) | 0; else {
  i5 = HEAP32[i12 >> 2] | 0;
  i4 = 0;
  i3 = 1;
  do {
   i3 = Math_imul(HEAP32[i5 + (i4 << 2) >> 2] | 0, i3) | 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i6 | 0));
 }
 if (i3) {
  i7 = HEAP32[i14 + 16 >> 2] | 0;
  i4 = __ZN2cv3Mat15getStdAllocatorEv() | 0;
  i7 = (i7 | 0) == 0 ? i4 : i7;
  i4 = i14 + 36 | 0;
  i10 = FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] & 15](i7, HEAP32[i1 >> 2] | 0, HEAP32[i12 >> 2] | 0, i8, 0, HEAP32[i4 >> 2] | 0, 0, HEAP32[i10 >> 2] | 0) | 0;
  HEAP32[i13 >> 2] = i10;
  if (!i10) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   i10 = __ZN2cv6String8allocateEj(i9, 6) | 0;
   HEAP8[i10 + 0 >> 0] = HEAP8[17728] | 0;
   HEAP8[i10 + 1 >> 0] = HEAP8[17729] | 0;
   HEAP8[i10 + 2 >> 0] = HEAP8[17730] | 0;
   HEAP8[i10 + 3 >> 0] = HEAP8[17731] | 0;
   HEAP8[i10 + 4 >> 0] = HEAP8[17732] | 0;
   HEAP8[i10 + 5 >> 0] = HEAP8[17733] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i9, 17664, 17672, 269);
   __ZN2cv6String10deallocateEv(i9);
  }
  i2 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[i14 >> 2] | 0;
  if ((HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 + -1 << 2) >> 2] | 0) == ((i10 >>> 3 & 511) + 1 << (47696 >>> (i10 << 1 & 14) & 3) | 0)) i6 = i2; else {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i11, 43) | 0) + 0 | 0;
   i3 = 17736 | 0;
   i2 = i6 + 43 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i3 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i6 | 0) < (i2 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i11, 17664, 17672, 277);
   __ZN2cv6String10deallocateEv(i11);
   i6 = HEAP32[i1 >> 2] | 0;
  }
 }
 L47 : do if ((i6 | 0) > 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  i3 = 0;
  while (1) {
   i2 = i3 + 1 | 0;
   if ((HEAP32[i1 + (i3 << 2) >> 2] | 0) > 1) {
    i2 = i3;
    break L47;
   }
   if ((i2 | 0) < (i6 | 0)) i3 = i2; else break;
  }
 } else i2 = 0; while (0);
 i4 = HEAP32[i14 + 36 >> 2] | 0;
 i5 = i6;
 do {
  i3 = i5;
  i5 = i5 + -1 | 0;
  if ((i5 | 0) <= (i2 | 0)) {
   i15 = 35;
   break;
  }
  i1 = HEAP32[i12 >> 2] | 0;
  i10 = Math_imul(HEAP32[i1 + (i5 << 2) >> 2] | 0, HEAP32[i4 + (i5 << 2) >> 2] | 0) | 0;
 } while (i10 >>> 0 >= (HEAP32[i4 + (i3 + -2 << 2) >> 2] | 0) >>> 0);
 if ((i15 | 0) == 35) i1 = HEAP32[i12 >> 2] | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i9 = ___muldi3(i9 | 0, ((i9 | 0) < 0) << 31 >> 31 | 0, HEAP32[i4 >> 2] | 0, 0) | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = (i5 | 0) <= (i2 | 0) & ((i9 | 0) == (i9 | 0) & (tempRet0 | 0) == 0) ? i10 | 16384 : i10 & -16385;
 if ((i6 | 0) > 2) {
  HEAP32[i14 + 12 >> 2] = -1;
  HEAP32[i14 + 8 >> 2] = -1;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 i10 = i1 + 8 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 STACKTOP = i16;
 return;
}

function __ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE(i17, i19, i18, i20, i22, i21, i2) {
 i17 = i17 | 0;
 i19 = i19 | 0;
 i18 = i18 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i16 = i23;
 i15 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 960720) | 0;
 i13 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 960880) | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] & 127](i16, i13);
 HEAP32[i21 >> 2] = i20;
 i3 = HEAP8[i17 >> 0] | 0;
 if (i3 << 24 >> 24 == 43 | i3 << 24 >> 24 == 45) {
  i14 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i15 >> 2] | 0) + 44 >> 2] & 127](i15, i3) | 0;
  i2 = HEAP32[i21 >> 2] | 0;
  HEAP32[i21 >> 2] = i2 + 4;
  HEAP32[i2 >> 2] = i14;
  i2 = i17 + 1 | 0;
 } else i2 = i17;
 i14 = i18;
 L4 : do if (((i14 - i2 | 0) > 1 ? (HEAP8[i2 >> 0] | 0) == 48 : 0) ? (i1 = i2 + 1 | 0, i12 = HEAP8[i1 >> 0] | 0, i12 << 24 >> 24 == 88 | i12 << 24 >> 24 == 120) : 0) {
  i3 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i15 >> 2] | 0) + 44 >> 2] & 127](i15, 48) | 0;
  i12 = HEAP32[i21 >> 2] | 0;
  HEAP32[i21 >> 2] = i12 + 4;
  HEAP32[i12 >> 2] = i3;
  i2 = i2 + 2 | 0;
  i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i15 >> 2] | 0) + 44 >> 2] & 127](i15, HEAP8[i1 >> 0] | 0) | 0;
  i12 = HEAP32[i21 >> 2] | 0;
  HEAP32[i21 >> 2] = i12 + 4;
  HEAP32[i12 >> 2] = i1;
  if (i2 >>> 0 < i18 >>> 0) {
   i3 = i2;
   while (1) {
    i12 = HEAP8[i3 >> 0] | 0;
    i1 = i3 + 1 | 0;
    if (!(_isxdigit_l(i12 << 24 >> 24, __ZNSt3__16__clocEv() | 0) | 0)) {
     i12 = i2;
     i1 = i3;
     break L4;
    }
    if (i1 >>> 0 < i18 >>> 0) i3 = i1; else {
     i12 = i2;
     break;
    }
   }
  } else {
   i12 = i2;
   i1 = i2;
  }
 } else i5 = 4; while (0);
 L11 : do if ((i5 | 0) == 4) if (i2 >>> 0 < i18 >>> 0) {
  i1 = i2;
  while (1) {
   i12 = HEAP8[i1 >> 0] | 0;
   i3 = i1 + 1 | 0;
   if (!(_isdigit_l(i12 << 24 >> 24, __ZNSt3__16__clocEv() | 0) | 0)) {
    i12 = i2;
    break L11;
   }
   if (i3 >>> 0 < i18 >>> 0) i1 = i3; else {
    i12 = i2;
    i1 = i3;
    break;
   }
  }
 } else {
  i12 = i2;
  i1 = i2;
 } while (0);
 i3 = HEAP8[i16 >> 0] | 0;
 if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i16 + 4 >> 2] | 0;
 if (i3) {
  if ((i12 | 0) != (i1 | 0) ? (i11 = i1 + -1 | 0, i11 >>> 0 > i12 >>> 0) : 0) {
   i2 = i12;
   i3 = i11;
   do {
    i11 = HEAP8[i2 >> 0] | 0;
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP8[i3 >> 0] = i11;
    i2 = i2 + 1 | 0;
    i3 = i3 + -1 | 0;
   } while (i2 >>> 0 < i3 >>> 0);
  }
  i7 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] & 127](i13) | 0;
  if (i12 >>> 0 < i1 >>> 0) {
   i8 = i16 + 1 | 0;
   i9 = i16 + 4 | 0;
   i10 = i16 + 8 | 0;
   i3 = 0;
   i5 = 0;
   i11 = i12;
   while (1) {
    i2 = (HEAP8[i16 >> 0] & 1) == 0;
    if ((HEAP8[(i2 ? i8 : HEAP32[i10 >> 2] | 0) + i5 >> 0] | 0) > 0 ? (i3 | 0) == (HEAP8[(i2 ? i8 : HEAP32[i10 >> 2] | 0) + i5 >> 0] | 0) : 0) {
     i3 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i3 + 4;
     HEAP32[i3 >> 2] = i7;
     i3 = HEAP8[i16 >> 0] | 0;
     if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i9 >> 2] | 0;
     i6 = 0;
     i5 = (i5 >>> 0 < (i3 + -1 | 0) >>> 0 & 1) + i5 | 0;
    } else i6 = i3;
    i24 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i15 >> 2] | 0) + 44 >> 2] & 127](i15, HEAP8[i11 >> 0] | 0) | 0;
    i3 = HEAP32[i21 >> 2] | 0;
    i2 = i3 + 4 | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i3 >> 2] = i24;
    i11 = i11 + 1 | 0;
    if (i11 >>> 0 >= i1 >>> 0) break; else i3 = i6 + 1 | 0;
   }
  } else i2 = HEAP32[i21 >> 2] | 0;
  i3 = i20 + (i12 - i17 << 2) | 0;
  if ((i3 | 0) != (i2 | 0) ? (i4 = i2 + -4 | 0, i4 >>> 0 > i3 >>> 0) : 0) do {
   i12 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i12;
   i3 = i3 + 4 | 0;
   i4 = i4 + -4 | 0;
  } while (i3 >>> 0 < i4 >>> 0);
 } else {
  FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i15 >> 2] | 0) + 48 >> 2] & 7](i15, i12, i1, HEAP32[i21 >> 2] | 0) | 0;
  i2 = (HEAP32[i21 >> 2] | 0) + (i1 - i12 << 2) | 0;
  HEAP32[i21 >> 2] = i2;
 }
 L47 : do if (i1 >>> 0 < i18 >>> 0) {
  while (1) {
   i2 = HEAP8[i1 >> 0] | 0;
   if (i2 << 24 >> 24 == 46) break;
   i11 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i15 >> 2] | 0) + 44 >> 2] & 127](i15, i2) | 0;
   i12 = HEAP32[i21 >> 2] | 0;
   i2 = i12 + 4 | 0;
   HEAP32[i21 >> 2] = i2;
   HEAP32[i12 >> 2] = i11;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i18 >>> 0) break L47;
  }
  i12 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] & 127](i13) | 0;
  i13 = HEAP32[i21 >> 2] | 0;
  i2 = i13 + 4 | 0;
  HEAP32[i21 >> 2] = i2;
  HEAP32[i13 >> 2] = i12;
  i1 = i1 + 1 | 0;
 } while (0);
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i15 >> 2] | 0) + 48 >> 2] & 7](i15, i1, i18, i2) | 0;
 i1 = (HEAP32[i21 >> 2] | 0) + (i14 - i1 << 2) | 0;
 HEAP32[i21 >> 2] = i1;
 if ((i19 | 0) == (i18 | 0)) {
  i21 = i1;
  HEAP32[i22 >> 2] = i21;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16);
  STACKTOP = i23;
  return;
 }
 i21 = i20 + (i19 - i17 << 2) | 0;
 HEAP32[i22 >> 2] = i21;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i16);
 STACKTOP = i23;
 return;
}

function __ZL16icvReadSparseMatP13CvFileStorageP10CvFileNode(i26, i7) {
 i26 = i26 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 8272 | 0;
 i25 = i28 + 4176 | 0;
 i6 = i28 + 4168 | 0;
 i27 = i28 + 4136 | 0;
 i9 = i28 + 40 | 0;
 i3 = i28 + 32 | 0;
 i4 = i28 + 24 | 0;
 i8 = i28 + 16 | 0;
 i22 = i28 + 8 | 0;
 i23 = i28;
 i5 = _cvGetFileNodeByName(i26, i7, 11656) | 0;
 i1 = _cvGetFileNodeByName(i26, i7, 11672) | 0;
 if ((i1 | 0) != 0 ? (HEAP32[i1 >> 2] & 7 | 0) == 3 : 0) {
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i5 | 0) != 0 & (i1 | 0) != 0) i21 = i1; else i2 = 4;
 } else {
  i1 = 0;
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i16 = (__ZN2cv6String8allocateEj(i3, 46) | 0) + 0 | 0;
  i17 = 11712 | 0;
  i18 = i16 + 46 | 0;
  do {
   HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
   i16 = i16 + 1 | 0;
   i17 = i17 + 1 | 0;
  } while ((i16 | 0) < (i18 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i3, 12376, 8960, 3776);
  __ZN2cv6String10deallocateEv(i3);
  i21 = i1;
 }
 i1 = HEAP32[i5 >> 2] & 7;
 if ((i1 | 0) == 5) i20 = HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 24 >> 2] | 0; else i20 = (i1 | 0) == 1 ? 1 : -1;
 i19 = i20 + -1 | 0;
 if (i19 >>> 0 > 1023) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i16 = (__ZN2cv6String8allocateEj(i4, 48) | 0) + 0 | 0;
  i17 = 12400 | 0;
  i18 = i16 + 48 | 0;
  do {
   HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
   i16 = i16 + 1 | 0;
   i17 = i17 + 1 | 0;
  } while ((i16 | 0) < (i18 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-212, i4, 12376, 8960, 3782);
  __ZN2cv6String10deallocateEv(i4);
 }
 _cvReadRawData(i26, i5, i9, 11664);
 i18 = (__ZL15icvDecodeFormatPKcPii(i21, i25) | 0) != 1;
 i1 = HEAP32[i25 >> 2] | 0;
 if (i18 | (i1 | 0) > 4) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i16 = (__ZN2cv6String8allocateEj(i6, 33) | 0) + 0 | 0;
  i17 = 11936 | 0;
  i18 = i16 + 33 | 0;
  do {
   HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
   i16 = i16 + 1 | 0;
   i17 = i17 + 1 | 0;
  } while ((i16 | 0) < (i18 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i6, 11976, 8960, 3068);
  __ZN2cv6String10deallocateEv(i6);
 }
 i3 = (i1 << 3) + -8 | 0;
 i2 = HEAP32[i25 + 4 >> 2] & 7 | i3;
 i4 = _cvGetFileNodeByName(i26, i7, 11680) | 0;
 if (!((i4 | 0) != 0 ? (HEAP32[i4 >> 2] & 7 | 0) == 5 : 0)) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i16 = (__ZN2cv6String8allocateEj(i8, 44) | 0) + 0 | 0;
  i17 = 11824 | 0;
  i18 = i16 + 44 | 0;
  do {
   HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
   i16 = i16 + 1 | 0;
   i17 = i17 + 1 | 0;
  } while ((i16 | 0) < (i18 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i8, 12376, 8960, 3789);
  __ZN2cv6String10deallocateEv(i8);
 }
 i1 = _cvCreateSparseMat(i20, i9, i2) | 0;
 i3 = i3 >>> 3 & 511;
 i15 = i3 + 1 | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 _cvStartReadRawData(i26, i4, i27);
 i12 = i2 + 24 | 0;
 if ((HEAP32[i12 >> 2] | 0) <= 0) {
  i22 = i1;
  STACKTOP = i28;
  return i22 | 0;
 }
 i13 = i27 + 12 | 0;
 i14 = i25 + (i19 << 2) | 0;
 i10 = i2 + 28 | 0;
 i11 = i27 + 20 | 0;
 i9 = i3 + 2 | 0;
 i7 = i23 + 4 | 0;
 i6 = i22 + 4 | 0;
 i3 = 0;
 do {
  i5 = HEAP32[i13 >> 2] | 0;
  if ((HEAP32[i5 >> 2] & 7 | 0) != 1) {
   HEAP32[i22 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   i16 = (__ZN2cv6String8allocateEj(i22, 31) | 0) + 0 | 0;
   i17 = 12456 | 0;
   i18 = i16 + 31 | 0;
   do {
    HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
    i16 = i16 + 1 | 0;
    i17 = i17 + 1 | 0;
   } while ((i16 | 0) < (i18 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-212, i22, 12376, 8960, 3804);
   __ZN2cv6String10deallocateEv(i22);
  }
  i4 = HEAP32[i5 + 8 >> 2] | 0;
  i2 = (i3 | 0) > 0;
  if (!(i2 & (i4 | 0) > -1)) {
   if (i2) i4 = i19 + i4 | 0; else {
    HEAP32[i25 >> 2] = i4;
    i4 = 1;
   }
   if ((i4 | 0) < (i20 | 0)) {
    i8 = i4;
    do {
     i4 = (HEAP32[i13 >> 2] | 0) + (HEAP32[i10 >> 2] | 0) | 0;
     HEAP32[i13 >> 2] = i4;
     if (i4 >>> 0 >= (HEAP32[i11 >> 2] | 0) >>> 0) {
      _cvChangeSeqBlock(i27, 1);
      i4 = HEAP32[i13 >> 2] | 0;
     }
     i3 = i3 + 1 | 0;
     if ((HEAP32[i4 >> 2] & 7 | 0) == 1 ? (i24 = HEAP32[i4 + 8 >> 2] | 0, (i24 | 0) >= 0) : 0) i4 = i24; else {
      HEAP32[i23 >> 2] = 0;
      HEAP32[i7 >> 2] = 0;
      i16 = (__ZN2cv6String8allocateEj(i23, 31) | 0) + 0 | 0;
      i17 = 12456 | 0;
      i18 = i16 + 31 | 0;
      do {
       HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
       i16 = i16 + 1 | 0;
       i17 = i17 + 1 | 0;
      } while ((i16 | 0) < (i18 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-212, i23, 12376, 8960, 3820);
      __ZN2cv6String10deallocateEv(i23);
      i4 = HEAP32[i4 + 8 >> 2] | 0;
     }
     HEAP32[i25 + (i8 << 2) >> 2] = i4;
     i8 = i8 + 1 | 0;
    } while ((i8 | 0) < (i20 | 0));
   }
  } else HEAP32[i14 >> 2] = i4;
  i18 = (HEAP32[i13 >> 2] | 0) + (HEAP32[i10 >> 2] | 0) | 0;
  HEAP32[i13 >> 2] = i18;
  if (i18 >>> 0 >= (HEAP32[i11 >> 2] | 0) >>> 0) _cvChangeSeqBlock(i27, 1);
  _cvReadRawDataSlice(i26, i27, i15, _cvPtrND(i1, i25, 0, 1, 0) | 0, i21);
  i3 = i9 + i3 | 0;
 } while ((i3 | 0) < (HEAP32[i12 >> 2] | 0));
 STACKTOP = i28;
 return i1 | 0;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_(i26, i1, i19, i24, i2, i25, i20) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i24 = i24 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i12 = i23 + 198 | 0;
 i1 = i23 + 196 | 0;
 i22 = i23 + 184 | 0;
 i21 = i23 + 172 | 0;
 i14 = i23 + 168 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 4 | 0;
 i15 = i23;
 i13 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i22, i2, i12, i1);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, 10, 0);
 if (!(HEAP8[i21 >> 0] & 1)) {
  i3 = i21 + 1 | 0;
  i9 = i3;
  i10 = i21 + 8 | 0;
 } else {
  i3 = i21 + 8 | 0;
  i9 = i21 + 1 | 0;
  i10 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i3;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i11 = i21 + 4 | 0;
 i8 = HEAP8[i1 >> 0] | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 L5 : while (1) {
  if (i1) {
   if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
    HEAP32[i19 >> 2] = 0;
    i1 = 0;
   }
  } else i1 = 0;
  i2 = (i1 | 0) == 0;
  i4 = HEAP32[i24 >> 2] | 0;
  do if (i4) {
   if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else break L5;
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) != -1) if (i2) break; else break L5; else {
    HEAP32[i24 >> 2] = 0;
    i27 = 14;
    break;
   }
  } else i27 = 14; while (0);
  if ((i27 | 0) == 14) {
   i27 = 0;
   if (i2) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i21 >> 0] | 0;
  i2 = (i6 & 1) == 0;
  if (i2) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i3 + i5 | 0)) {
   if (i2) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3 << 1, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i21 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = i9; else i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = i3 + i5;
  }
  i6 = i1 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i1 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i2 = HEAPU8[i5 >> 0] | 0;
  if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i2 & 255, i13, i3, i14, i15, i8, i22, i16, i17, i12) | 0) break;
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i4 + 1;
   continue;
  }
 }
 i2 = HEAP8[i22 >> 0] | 0;
 if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i18 = HEAP32[i17 >> 2] | 0, (i18 - i16 | 0) < 160) : 0) {
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i18 + 4;
  HEAP32[i18 >> 2] = i15;
 }
 HEAP16[i20 >> 1] = __ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji(i3, HEAP32[i14 >> 2] | 0, i25, i13) | 0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i16, HEAP32[i17 >> 2] | 0, i25);
 if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
   HEAP32[i19 >> 2] = 0;
   i1 = 0;
  }
 } else i1 = 0;
 i2 = (i1 | 0) == 0;
 do if (i4) {
  if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) {
   if (!i2) break;
   HEAP32[i26 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
   HEAP32[i24 >> 2] = 0;
   i27 = 50;
   break;
  }
  if (i2 ^ (i4 | 0) == 0) {
   HEAP32[i26 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
 } else i27 = 50; while (0);
 if ((i27 | 0) == 50 ? !i2 : 0) {
  HEAP32[i26 >> 2] = i1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  STACKTOP = i23;
  return;
 }
 HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 2;
 HEAP32[i26 >> 2] = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 STACKTOP = i23;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_(i26, i1, i19, i24, i2, i25, i20) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i24 = i24 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i12 = i23 + 198 | 0;
 i1 = i23 + 196 | 0;
 i22 = i23 + 184 | 0;
 i21 = i23 + 172 | 0;
 i14 = i23 + 168 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 4 | 0;
 i15 = i23;
 i13 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i22, i2, i12, i1);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, 10, 0);
 if (!(HEAP8[i21 >> 0] & 1)) {
  i3 = i21 + 1 | 0;
  i9 = i3;
  i10 = i21 + 8 | 0;
 } else {
  i3 = i21 + 8 | 0;
  i9 = i21 + 1 | 0;
  i10 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i3;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i11 = i21 + 4 | 0;
 i8 = HEAP8[i1 >> 0] | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 L5 : while (1) {
  if (i1) {
   if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
    HEAP32[i19 >> 2] = 0;
    i1 = 0;
   }
  } else i1 = 0;
  i2 = (i1 | 0) == 0;
  i4 = HEAP32[i24 >> 2] | 0;
  do if (i4) {
   if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else break L5;
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) != -1) if (i2) break; else break L5; else {
    HEAP32[i24 >> 2] = 0;
    i27 = 14;
    break;
   }
  } else i27 = 14; while (0);
  if ((i27 | 0) == 14) {
   i27 = 0;
   if (i2) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i21 >> 0] | 0;
  i2 = (i6 & 1) == 0;
  if (i2) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i3 + i5 | 0)) {
   if (i2) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3 << 1, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i21 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = i9; else i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = i3 + i5;
  }
  i6 = i1 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i1 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i2 = HEAPU8[i5 >> 0] | 0;
  if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i2 & 255, i13, i3, i14, i15, i8, i22, i16, i17, i12) | 0) break;
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i4 + 1;
   continue;
  }
 }
 i2 = HEAP8[i22 >> 0] | 0;
 if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i18 = HEAP32[i17 >> 2] | 0, (i18 - i16 | 0) < 160) : 0) {
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i18 + 4;
  HEAP32[i18 >> 2] = i15;
 }
 HEAP32[i20 >> 2] = __ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji(i3, HEAP32[i14 >> 2] | 0, i25, i13) | 0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i16, HEAP32[i17 >> 2] | 0, i25);
 if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
   HEAP32[i19 >> 2] = 0;
   i1 = 0;
  }
 } else i1 = 0;
 i2 = (i1 | 0) == 0;
 do if (i4) {
  if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) {
   if (!i2) break;
   HEAP32[i26 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
   HEAP32[i24 >> 2] = 0;
   i27 = 50;
   break;
  }
  if (i2 ^ (i4 | 0) == 0) {
   HEAP32[i26 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
 } else i27 = 50; while (0);
 if ((i27 | 0) == 50 ? !i2 : 0) {
  HEAP32[i26 >> 2] = i1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  STACKTOP = i23;
  return;
 }
 HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 2;
 HEAP32[i26 >> 2] = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 STACKTOP = i23;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_(i26, i1, i19, i24, i2, i25, i20) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i24 = i24 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i12 = i23 + 198 | 0;
 i1 = i23 + 196 | 0;
 i22 = i23 + 184 | 0;
 i21 = i23 + 172 | 0;
 i14 = i23 + 168 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 4 | 0;
 i15 = i23;
 i13 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i22, i2, i12, i1);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, 10, 0);
 if (!(HEAP8[i21 >> 0] & 1)) {
  i3 = i21 + 1 | 0;
  i9 = i3;
  i10 = i21 + 8 | 0;
 } else {
  i3 = i21 + 8 | 0;
  i9 = i21 + 1 | 0;
  i10 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i3;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i11 = i21 + 4 | 0;
 i8 = HEAP8[i1 >> 0] | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 L5 : while (1) {
  if (i1) {
   if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
    HEAP32[i19 >> 2] = 0;
    i1 = 0;
   }
  } else i1 = 0;
  i2 = (i1 | 0) == 0;
  i4 = HEAP32[i24 >> 2] | 0;
  do if (i4) {
   if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else break L5;
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) != -1) if (i2) break; else break L5; else {
    HEAP32[i24 >> 2] = 0;
    i27 = 14;
    break;
   }
  } else i27 = 14; while (0);
  if ((i27 | 0) == 14) {
   i27 = 0;
   if (i2) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i21 >> 0] | 0;
  i2 = (i6 & 1) == 0;
  if (i2) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i3 + i5 | 0)) {
   if (i2) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3 << 1, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i21 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = i9; else i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = i3 + i5;
  }
  i6 = i1 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i1 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i2 = HEAPU8[i5 >> 0] | 0;
  if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i2 & 255, i13, i3, i14, i15, i8, i22, i16, i17, i12) | 0) break;
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i4 + 1;
   continue;
  }
 }
 i2 = HEAP8[i22 >> 0] | 0;
 if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i18 = HEAP32[i17 >> 2] | 0, (i18 - i16 | 0) < 160) : 0) {
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i18 + 4;
  HEAP32[i18 >> 2] = i15;
 }
 HEAP32[i20 >> 2] = __ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji(i3, HEAP32[i14 >> 2] | 0, i25, i13) | 0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i16, HEAP32[i17 >> 2] | 0, i25);
 if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
   HEAP32[i19 >> 2] = 0;
   i1 = 0;
  }
 } else i1 = 0;
 i2 = (i1 | 0) == 0;
 do if (i4) {
  if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) {
   if (!i2) break;
   HEAP32[i26 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
   HEAP32[i24 >> 2] = 0;
   i27 = 50;
   break;
  }
  if (i2 ^ (i4 | 0) == 0) {
   HEAP32[i26 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
 } else i27 = 50; while (0);
 if ((i27 | 0) == 50 ? !i2 : 0) {
  HEAP32[i26 >> 2] = i1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  STACKTOP = i23;
  return;
 }
 HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 2;
 HEAP32[i26 >> 2] = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 STACKTOP = i23;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_(i26, i1, i19, i24, i2, i25, i20) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i24 = i24 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i12 = i23 + 198 | 0;
 i1 = i23 + 196 | 0;
 i22 = i23 + 184 | 0;
 i21 = i23 + 172 | 0;
 i14 = i23 + 168 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 4 | 0;
 i15 = i23;
 i13 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i22, i2, i12, i1);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, 10, 0);
 if (!(HEAP8[i21 >> 0] & 1)) {
  i3 = i21 + 1 | 0;
  i9 = i3;
  i10 = i21 + 8 | 0;
 } else {
  i3 = i21 + 8 | 0;
  i9 = i21 + 1 | 0;
  i10 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i3;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i11 = i21 + 4 | 0;
 i8 = HEAP8[i1 >> 0] | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 L5 : while (1) {
  if (i1) {
   if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
    HEAP32[i19 >> 2] = 0;
    i1 = 0;
   }
  } else i1 = 0;
  i2 = (i1 | 0) == 0;
  i4 = HEAP32[i24 >> 2] | 0;
  do if (i4) {
   if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else break L5;
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) != -1) if (i2) break; else break L5; else {
    HEAP32[i24 >> 2] = 0;
    i27 = 14;
    break;
   }
  } else i27 = 14; while (0);
  if ((i27 | 0) == 14) {
   i27 = 0;
   if (i2) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i21 >> 0] | 0;
  i2 = (i6 & 1) == 0;
  if (i2) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i3 + i5 | 0)) {
   if (i2) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3 << 1, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i21 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = i9; else i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = i3 + i5;
  }
  i6 = i1 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i1 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i2 = HEAPU8[i5 >> 0] | 0;
  if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i2 & 255, i13, i3, i14, i15, i8, i22, i16, i17, i12) | 0) break;
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i4 + 1;
   continue;
  }
 }
 i2 = HEAP8[i22 >> 0] | 0;
 if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i18 = HEAP32[i17 >> 2] | 0, (i18 - i16 | 0) < 160) : 0) {
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i18 + 4;
  HEAP32[i18 >> 2] = i15;
 }
 HEAP32[i20 >> 2] = __ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji(i3, HEAP32[i14 >> 2] | 0, i25, i13) | 0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i16, HEAP32[i17 >> 2] | 0, i25);
 if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
   HEAP32[i19 >> 2] = 0;
   i1 = 0;
  }
 } else i1 = 0;
 i2 = (i1 | 0) == 0;
 do if (i4) {
  if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) {
   if (!i2) break;
   HEAP32[i26 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
   HEAP32[i24 >> 2] = 0;
   i27 = 50;
   break;
  }
  if (i2 ^ (i4 | 0) == 0) {
   HEAP32[i26 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
 } else i27 = 50; while (0);
 if ((i27 | 0) == 50 ? !i2 : 0) {
  HEAP32[i26 >> 2] = i1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  STACKTOP = i23;
  return;
 }
 HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 2;
 HEAP32[i26 >> 2] = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 STACKTOP = i23;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_(i26, i1, i20, i24, i3, i25, i19) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i24 = i24 | 0;
 i3 = i3 | 0;
 i25 = i25 | 0;
 i19 = i19 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i12 = i23 + 200 | 0;
 i2 = i23 + 196 | 0;
 i22 = i23 + 184 | 0;
 i21 = i23 + 172 | 0;
 i14 = i23 + 168 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 4 | 0;
 i15 = i23;
 i13 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i3) | 0;
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i22, i3, i12, i2);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, 10, 0);
 if (!(HEAP8[i21 >> 0] & 1)) {
  i1 = i21 + 1 | 0;
  i9 = i1;
  i10 = i21 + 8 | 0;
 } else {
  i1 = i21 + 8 | 0;
  i9 = i21 + 1 | 0;
  i10 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i1;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i11 = i21 + 4 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 L5 : while (1) {
  if (i2) {
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) == -1) {
    HEAP32[i20 >> 2] = 0;
    i5 = 1;
    i2 = 0;
   } else i5 = 0;
  } else {
   i5 = 1;
   i2 = 0;
  }
  i4 = HEAP32[i24 >> 2] | 0;
  do if (i4) {
   i3 = HEAP32[i4 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) != -1) if (i5) break; else break L5; else {
    HEAP32[i24 >> 2] = 0;
    i27 = 17;
    break;
   }
  } else i27 = 17; while (0);
  if ((i27 | 0) == 17) {
   i27 = 0;
   if (i5) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i21 >> 0] | 0;
  i3 = (i6 & 1) == 0;
  if (i3) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i1 + i5 | 0)) {
   if (i3) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3 << 1, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i21 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i1 = i9; else i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = i1 + i5;
  }
  i6 = i2 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i2 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i5 >> 2] | 0;
  if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i3, i13, i1, i14, i15, i8, i22, i16, i17, i12) | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i3 + 4;
   continue;
  }
 }
 i3 = HEAP8[i22 >> 0] | 0;
 if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i18 = HEAP32[i17 >> 2] | 0, (i18 - i16 | 0) < 160) : 0) {
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i18 + 4;
  HEAP32[i18 >> 2] = i15;
 }
 HEAP16[i19 >> 1] = __ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji(i1, HEAP32[i14 >> 2] | 0, i25, i13) | 0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i16, HEAP32[i17 >> 2] | 0, i25);
 if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i20 >> 2] = 0;
   i2 = 0;
   i3 = 1;
  } else i3 = 0;
 } else {
  i2 = 0;
  i3 = 1;
 }
 do if (i4) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i24 >> 2] = 0;
   i27 = 56;
   break;
  }
  if (i3) {
   HEAP32[i26 >> 2] = i2;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
 } else i27 = 56; while (0);
 if ((i27 | 0) == 56 ? !i3 : 0) {
  HEAP32[i26 >> 2] = i2;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  STACKTOP = i23;
  return;
 }
 HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 2;
 HEAP32[i26 >> 2] = i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 STACKTOP = i23;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_(i26, i1, i20, i24, i3, i25, i19) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i24 = i24 | 0;
 i3 = i3 | 0;
 i25 = i25 | 0;
 i19 = i19 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i12 = i23 + 200 | 0;
 i2 = i23 + 196 | 0;
 i22 = i23 + 184 | 0;
 i21 = i23 + 172 | 0;
 i14 = i23 + 168 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 4 | 0;
 i15 = i23;
 i13 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i3) | 0;
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i22, i3, i12, i2);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, 10, 0);
 if (!(HEAP8[i21 >> 0] & 1)) {
  i1 = i21 + 1 | 0;
  i9 = i1;
  i10 = i21 + 8 | 0;
 } else {
  i1 = i21 + 8 | 0;
  i9 = i21 + 1 | 0;
  i10 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i1;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i11 = i21 + 4 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 L5 : while (1) {
  if (i2) {
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) == -1) {
    HEAP32[i20 >> 2] = 0;
    i5 = 1;
    i2 = 0;
   } else i5 = 0;
  } else {
   i5 = 1;
   i2 = 0;
  }
  i4 = HEAP32[i24 >> 2] | 0;
  do if (i4) {
   i3 = HEAP32[i4 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) != -1) if (i5) break; else break L5; else {
    HEAP32[i24 >> 2] = 0;
    i27 = 17;
    break;
   }
  } else i27 = 17; while (0);
  if ((i27 | 0) == 17) {
   i27 = 0;
   if (i5) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i21 >> 0] | 0;
  i3 = (i6 & 1) == 0;
  if (i3) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i1 + i5 | 0)) {
   if (i3) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3 << 1, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i21 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i1 = i9; else i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = i1 + i5;
  }
  i6 = i2 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i2 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i5 >> 2] | 0;
  if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i3, i13, i1, i14, i15, i8, i22, i16, i17, i12) | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i3 + 4;
   continue;
  }
 }
 i3 = HEAP8[i22 >> 0] | 0;
 if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i18 = HEAP32[i17 >> 2] | 0, (i18 - i16 | 0) < 160) : 0) {
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i18 + 4;
  HEAP32[i18 >> 2] = i15;
 }
 HEAP32[i19 >> 2] = __ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji(i1, HEAP32[i14 >> 2] | 0, i25, i13) | 0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i16, HEAP32[i17 >> 2] | 0, i25);
 if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i20 >> 2] = 0;
   i2 = 0;
   i3 = 1;
  } else i3 = 0;
 } else {
  i2 = 0;
  i3 = 1;
 }
 do if (i4) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i24 >> 2] = 0;
   i27 = 56;
   break;
  }
  if (i3) {
   HEAP32[i26 >> 2] = i2;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
 } else i27 = 56; while (0);
 if ((i27 | 0) == 56 ? !i3 : 0) {
  HEAP32[i26 >> 2] = i2;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  STACKTOP = i23;
  return;
 }
 HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 2;
 HEAP32[i26 >> 2] = i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 STACKTOP = i23;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_(i26, i1, i20, i24, i3, i25, i19) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i24 = i24 | 0;
 i3 = i3 | 0;
 i25 = i25 | 0;
 i19 = i19 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i12 = i23 + 200 | 0;
 i2 = i23 + 196 | 0;
 i22 = i23 + 184 | 0;
 i21 = i23 + 172 | 0;
 i14 = i23 + 168 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 4 | 0;
 i15 = i23;
 i13 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i3) | 0;
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i22, i3, i12, i2);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, 10, 0);
 if (!(HEAP8[i21 >> 0] & 1)) {
  i1 = i21 + 1 | 0;
  i9 = i1;
  i10 = i21 + 8 | 0;
 } else {
  i1 = i21 + 8 | 0;
  i9 = i21 + 1 | 0;
  i10 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i1;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i11 = i21 + 4 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 L5 : while (1) {
  if (i2) {
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) == -1) {
    HEAP32[i20 >> 2] = 0;
    i5 = 1;
    i2 = 0;
   } else i5 = 0;
  } else {
   i5 = 1;
   i2 = 0;
  }
  i4 = HEAP32[i24 >> 2] | 0;
  do if (i4) {
   i3 = HEAP32[i4 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) != -1) if (i5) break; else break L5; else {
    HEAP32[i24 >> 2] = 0;
    i27 = 17;
    break;
   }
  } else i27 = 17; while (0);
  if ((i27 | 0) == 17) {
   i27 = 0;
   if (i5) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i21 >> 0] | 0;
  i3 = (i6 & 1) == 0;
  if (i3) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i1 + i5 | 0)) {
   if (i3) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3 << 1, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i21 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i1 = i9; else i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = i1 + i5;
  }
  i6 = i2 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i2 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i5 >> 2] | 0;
  if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i3, i13, i1, i14, i15, i8, i22, i16, i17, i12) | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i3 + 4;
   continue;
  }
 }
 i3 = HEAP8[i22 >> 0] | 0;
 if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i18 = HEAP32[i17 >> 2] | 0, (i18 - i16 | 0) < 160) : 0) {
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i18 + 4;
  HEAP32[i18 >> 2] = i15;
 }
 HEAP32[i19 >> 2] = __ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji(i1, HEAP32[i14 >> 2] | 0, i25, i13) | 0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i16, HEAP32[i17 >> 2] | 0, i25);
 if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i20 >> 2] = 0;
   i2 = 0;
   i3 = 1;
  } else i3 = 0;
 } else {
  i2 = 0;
  i3 = 1;
 }
 do if (i4) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i24 >> 2] = 0;
   i27 = 56;
   break;
  }
  if (i3) {
   HEAP32[i26 >> 2] = i2;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
 } else i27 = 56; while (0);
 if ((i27 | 0) == 56 ? !i3 : 0) {
  HEAP32[i26 >> 2] = i2;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  STACKTOP = i23;
  return;
 }
 HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 2;
 HEAP32[i26 >> 2] = i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 STACKTOP = i23;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_(i26, i1, i20, i24, i3, i25, i19) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i24 = i24 | 0;
 i3 = i3 | 0;
 i25 = i25 | 0;
 i19 = i19 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i12 = i23 + 200 | 0;
 i2 = i23 + 196 | 0;
 i22 = i23 + 184 | 0;
 i21 = i23 + 172 | 0;
 i14 = i23 + 168 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 4 | 0;
 i15 = i23;
 i13 = __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i3) | 0;
 __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i22, i3, i12, i2);
 HEAP32[i21 + 0 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, 10, 0);
 if (!(HEAP8[i21 >> 0] & 1)) {
  i1 = i21 + 1 | 0;
  i9 = i1;
  i10 = i21 + 8 | 0;
 } else {
  i1 = i21 + 8 | 0;
  i9 = i21 + 1 | 0;
  i10 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i1;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i11 = i21 + 4 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 L5 : while (1) {
  if (i2) {
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) == -1) {
    HEAP32[i20 >> 2] = 0;
    i5 = 1;
    i2 = 0;
   } else i5 = 0;
  } else {
   i5 = 1;
   i2 = 0;
  }
  i4 = HEAP32[i24 >> 2] | 0;
  do if (i4) {
   i3 = HEAP32[i4 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) != -1) if (i5) break; else break L5; else {
    HEAP32[i24 >> 2] = 0;
    i27 = 17;
    break;
   }
  } else i27 = 17; while (0);
  if ((i27 | 0) == 17) {
   i27 = 0;
   if (i5) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i6 = HEAP8[i21 >> 0] | 0;
  i3 = (i6 & 1) == 0;
  if (i3) i5 = (i6 & 255) >>> 1; else i5 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i1 + i5 | 0)) {
   if (i3) {
    i3 = (i6 & 255) >>> 1;
    i5 = (i6 & 255) >>> 1;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i5;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3 << 1, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i3 = 10; else i3 = (HEAP32[i21 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i21, i3, 0);
   if (!(HEAP8[i21 >> 0] & 1)) i1 = i9; else i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = i1 + i5;
  }
  i6 = i2 + 12 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i2 + 16 | 0;
  if ((i5 | 0) == (HEAP32[i7 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i5 >> 2] | 0;
  if (__ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i3, i13, i1, i14, i15, i8, i22, i16, i17, i12) | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   continue;
  } else {
   HEAP32[i6 >> 2] = i3 + 4;
   continue;
  }
 }
 i3 = HEAP8[i22 >> 0] | 0;
 if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i18 = HEAP32[i17 >> 2] | 0, (i18 - i16 | 0) < 160) : 0) {
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i18 + 4;
  HEAP32[i18 >> 2] = i15;
 }
 HEAP32[i19 >> 2] = __ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji(i1, HEAP32[i14 >> 2] | 0, i25, i13) | 0;
 __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i16, HEAP32[i17 >> 2] | 0, i25);
 if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i20 >> 2] = 0;
   i2 = 0;
   i3 = 1;
  } else i3 = 0;
 } else {
  i2 = 0;
  i3 = 1;
 }
 do if (i4) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i24 >> 2] = 0;
   i27 = 56;
   break;
  }
  if (i3) {
   HEAP32[i26 >> 2] = i2;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
   STACKTOP = i23;
   return;
  }
 } else i27 = 56; while (0);
 if ((i27 | 0) == 56 ? !i3 : 0) {
  HEAP32[i26 >> 2] = i2;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
  STACKTOP = i23;
  return;
 }
 HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 2;
 HEAP32[i26 >> 2] = i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i22);
 STACKTOP = i23;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv(i24, i1, i17, i22, i3, i23, i18) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i22 = i22 | 0;
 i3 = i3 | 0;
 i23 = i23 | 0;
 i18 = i18 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i25 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i16 = i21;
 i10 = i21 + 208 | 0;
 i20 = i21 + 196 | 0;
 i14 = i21 + 192 | 0;
 i19 = i21 + 180 | 0;
 i15 = i21 + 176 | 0;
 i12 = i21 + 16 | 0;
 i13 = i21 + 8 | 0;
 i11 = i21 + 4 | 0;
 HEAP32[i20 + 0 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 __ZNKSt3__18ios_base6getlocEv(i14, i3);
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i14, 960728) | 0;
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] & 7](i1, 959240, 959266 | 0, i10) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i14 >> 2] | 0) | 0;
 HEAP32[i19 + 0 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i19, 10, 0);
 if (!(HEAP8[i19 >> 0] & 1)) {
  i3 = i19 + 1 | 0;
  i2 = i3;
  i14 = i19 + 8 | 0;
 } else {
  i3 = i19 + 8 | 0;
  i2 = i19 + 1 | 0;
  i14 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i15 >> 2] = i3;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i11 >> 2] = 0;
 i9 = i19 + 4 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 L5 : while (1) {
  if (i1) {
   if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
    HEAP32[i17 >> 2] = 0;
    i1 = 0;
   }
  } else i1 = 0;
  i5 = (i1 | 0) == 0;
  i4 = HEAP32[i22 >> 2] | 0;
  do if (i4) {
   if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i5) break; else break L5;
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) != -1) if (i5) break; else break L5; else {
    HEAP32[i22 >> 2] = 0;
    i25 = 14;
    break;
   }
  } else i25 = 14; while (0);
  if ((i25 | 0) == 14) {
   i25 = 0;
   if (i5) {
    i4 = 0;
    break;
   } else i4 = 0;
  }
  i7 = HEAP8[i19 >> 0] | 0;
  i5 = (i7 & 1) == 0;
  if (i5) i6 = (i7 & 255) >>> 1; else i6 = HEAP32[i9 >> 2] | 0;
  if ((HEAP32[i15 >> 2] | 0) == (i3 + i6 | 0)) {
   if (i5) {
    i5 = (i7 & 255) >>> 1;
    i6 = (i7 & 255) >>> 1;
   } else {
    i6 = HEAP32[i9 >> 2] | 0;
    i5 = i6;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i19, i5 << 1, 0);
   if (!(HEAP8[i19 >> 0] & 1)) i5 = 10; else i5 = (HEAP32[i19 >> 2] & -2) + -1 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i19, i5, 0);
   if (!(HEAP8[i19 >> 0] & 1)) i3 = i2; else i3 = HEAP32[i14 >> 2] | 0;
   HEAP32[i15 >> 2] = i3 + i6;
  }
  i7 = i1 + 12 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i8 = i1 + 16 | 0;
  if ((i6 | 0) == (HEAP32[i8 >> 2] | 0)) i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i5 = HEAPU8[i6 >> 0] | 0;
  if (__ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i5 & 255, 16, i3, i15, i11, 0, i20, i12, i13, i10) | 0) break;
  i5 = HEAP32[i7 >> 2] | 0;
  if ((i5 | 0) == (HEAP32[i8 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0;
   continue;
  } else {
   HEAP32[i7 >> 2] = i5 + 1;
   continue;
  }
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i19, (HEAP32[i15 >> 2] | 0) - i3 | 0, 0);
 if (HEAP8[i19 >> 0] & 1) i2 = HEAP32[i14 >> 2] | 0;
 i15 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i16 >> 2] = i18;
 if ((__ZNSt3__110__sscanf_lEPKcP15__locale_structS1_z(i2, i15, 959280, i16) | 0) != 1) HEAP32[i23 >> 2] = 4;
 if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
   HEAP32[i17 >> 2] = 0;
   i1 = 0;
  }
 } else i1 = 0;
 i2 = (i1 | 0) == 0;
 do if (i4) {
  if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) {
   if (!i2) break;
   HEAP32[i24 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
   STACKTOP = i21;
   return;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
   HEAP32[i22 >> 2] = 0;
   i25 = 48;
   break;
  }
  if (i2 ^ (i4 | 0) == 0) {
   HEAP32[i24 >> 2] = i1;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
   STACKTOP = i21;
   return;
  }
 } else i25 = 48; while (0);
 if ((i25 | 0) == 48 ? !i2 : 0) {
  HEAP32[i24 >> 2] = i1;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
  STACKTOP = i21;
  return;
 }
 HEAP32[i23 >> 2] = HEAP32[i23 >> 2] | 2;
 HEAP32[i24 >> 2] = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
 STACKTOP = i21;
 return;
}

function __ZN7testing8internal8FilePath12MakeFileNameERKS1_S3_iPKc(i14, i15, i5, i4, i16) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i1 = i18 + 108 | 0;
 i17 = i18 + 96 | 0;
 i6 = i18 + 84 | 0;
 i7 = i18 + 72 | 0;
 i8 = i18 + 60 | 0;
 i9 = i18 + 48 | 0;
 i10 = i18 + 36 | 0;
 i11 = i18 + 24 | 0;
 i12 = i18 + 12 | 0;
 i13 = i18;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i17 + 0 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 if (!i4) {
  HEAP32[i7 + 0 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  i1 = HEAP8[i5 >> 0] | 0;
  if (!(i1 & 1)) {
   i2 = (i1 & 255) >>> 1;
   i1 = i5 + 1 | 0;
  } else {
   i2 = HEAP32[i5 + 4 >> 2] | 0;
   i1 = HEAP32[i5 + 8 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i7, i1, i2, i2 + 1 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, 160488, 1) | 0;
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i1 = HEAP8[i7 >> 0] | 0;
  if (!(i1 & 1)) {
   i3 = _strlen(i16 | 0) | 0;
   i2 = (i1 & 255) >>> 1;
   i1 = i7 + 1 | 0;
  } else {
   i2 = HEAP32[i7 + 4 >> 2] | 0;
   i3 = _strlen(i16 | 0) | 0;
   i1 = HEAP32[i7 + 8 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, i1, i2, i2 + i3 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, i16, i3) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i17, i6) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i13, i17);
  __ZN7testing8internal8FilePath9NormalizeEv(i13);
  __ZN7testing8internal8FilePath11ConcatPathsERKS1_S3_(i14, i15, i13);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
  STACKTOP = i18;
  return;
 };
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i3 = HEAP8[i5 >> 0] | 0;
 if (!(i3 & 1)) {
  i2 = (i3 & 255) >>> 1;
  i3 = i5 + 1 | 0;
 } else {
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = HEAP32[i5 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i11, i3, i2, i2 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i11, 164680, 1) | 0;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i12, i1);
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i3 = HEAP8[i11 >> 0] | 0;
 i2 = (i3 & 1) == 0;
 if (i2) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = HEAP8[i12 >> 0] | 0;
 if (!(i3 & 1)) i4 = (i3 & 255) >>> 1; else i4 = HEAP32[i12 + 4 >> 2] | 0;
 if (i2) i3 = i11 + 1 | 0; else i3 = HEAP32[i11 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, i3, i1, i4 + i1 | 0);
 if (!(HEAP8[i12 >> 0] & 1)) i3 = i12 + 1 | 0; else i3 = HEAP32[i12 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, i3, i4) | 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i3 = HEAP8[i10 >> 0] | 0;
 if (!(i3 & 1)) {
  i3 = (i3 & 255) >>> 1;
  i2 = i10 + 1 | 0;
 } else {
  i3 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = HEAP32[i10 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, i2, i3, i3 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, 160488, 1) | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i3 = HEAP8[i9 >> 0] | 0;
 if (!(i3 & 1)) {
  i1 = _strlen(i16 | 0) | 0;
  i3 = (i3 & 255) >>> 1;
  i2 = i9 + 1 | 0;
 } else {
  i3 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = _strlen(i16 | 0) | 0;
  i2 = HEAP32[i9 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i2, i3, i3 + i1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, i16, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i17, i8) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i13, i17);
 __ZN7testing8internal8FilePath9NormalizeEv(i13);
 __ZN7testing8internal8FilePath11ConcatPathsERKS1_S3_(i14, i15, i13);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
 STACKTOP = i18;
 return;
}

function __ZL11icvReadHistP13CvFileStorageP10CvFileNode(i17, i13) {
 i17 = i17 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 i12 = i19 + 184 | 0;
 i15 = i19 + 56 | 0;
 i8 = i19 + 48 | 0;
 i7 = i19 + 40 | 0;
 i18 = i19 + 8 | 0;
 i14 = i19;
 i16 = _cvAlloc(544) | 0;
 i4 = _cvGetFileNodeByName(i17, i13, 702056) | 0;
 do if (i4) {
  i3 = HEAP32[i4 >> 2] & 7;
  if ((i3 | 0) == 2) {
   i2 = _lrint(+HEAPF64[i4 + 8 >> 3]) | 0;
   break;
  } else if ((i3 | 0) == 1) {
   i2 = HEAP32[i4 + 8 >> 2] | 0;
   break;
  } else {
   i2 = 2147483647;
   break;
  }
 } else i2 = 0; while (0);
 i5 = _cvGetFileNodeByName(i17, i13, 702064) | 0;
 do if (i5) {
  i4 = HEAP32[i5 >> 2] & 7;
  if ((i4 | 0) == 1) {
   i3 = HEAP32[i5 + 8 >> 2] | 0;
   break;
  } else if ((i4 | 0) == 2) {
   i3 = _lrint(+HEAPF64[i5 + 8 >> 3]) | 0;
   break;
  } else {
   i3 = 2147483647;
   break;
  }
 } else i3 = 0; while (0);
 i5 = _cvGetFileNodeByName(i17, i13, 702080) | 0;
 do if (i5) {
  i4 = HEAP32[i5 >> 2] & 7;
  if ((i4 | 0) == 1) {
   i5 = HEAP32[i5 + 8 >> 2] | 0;
   break;
  } else if ((i4 | 0) == 2) {
   i5 = _lrint(+HEAPF64[i5 + 8 >> 3]) | 0;
   break;
  } else {
   i5 = 2147483647;
   break;
  }
 } else i5 = 0; while (0);
 i11 = (i3 | 0) != 0;
 i9 = (i5 | 0) != 0;
 HEAP32[i16 >> 2] = i2 | (i11 ? 1024 : 0) | (i9 ? 2048 : 0) | 1111818240;
 do if (!i2) {
  i4 = _cvRead(i17, _cvGetFileNodeByName(i17, i13, 702096) | 0, 0) | 0;
  HEAP32[i12 >> 2] = i4;
  if (!(((i4 | 0) != 0 ? (HEAP32[i4 >> 2] & -65536 | 0) == 1111687168 : 0) ? (HEAP32[i4 + 16 >> 2] | 0) != 0 : 0)) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i5 = (__ZN2cv6String8allocateEj(i8, 16) | 0) + 0 | 0;
   i1 = 702128 | 0;
   i6 = i5 + 16 | 0;
   do {
    HEAP8[i5 >> 0] = HEAP8[i1 >> 0] | 0;
    i5 = i5 + 1 | 0;
    i1 = i1 + 1 | 0;
   } while ((i5 | 0) < (i6 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i8, 702152, 701600, 3620);
   __ZN2cv6String10deallocateEv(i8);
   i4 = HEAP32[i12 >> 2] | 0;
  }
  i2 = i4 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) > 0) {
   i5 = 0;
   do {
    HEAP32[i15 + (i5 << 2) >> 2] = HEAP32[i4 + (i5 << 3) + 20 >> 2];
    i5 = i5 + 1 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
   } while ((i5 | 0) < (i3 | 0));
  }
  i8 = i16 + 268 | 0;
  _cvInitMatNDHeader(i8, i3, i15, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 16 >> 2] | 0) | 0;
  HEAP32[i16 + 4 >> 2] = i8;
  HEAP32[i16 + 276 >> 2] = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2];
  i4 = HEAP32[i12 >> 2] | 0;
  do if (i4) {
   i3 = HEAP32[i4 >> 2] & -65536;
   if ((i3 | 0) == 1111687168) {
    if (!(HEAP32[i4 + 16 >> 2] | 0)) break;
    i2 = HEAP32[i4 + 8 >> 2] | 0;
    if (!i2) break;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   } else if ((i3 | 0) != 1111621632) break;
   if ((((HEAP32[i4 + 24 >> 2] | 0) > 0 ? (HEAP32[i4 + 20 >> 2] | 0) > 0 : 0) ? (HEAP32[i4 + 16 >> 2] | 0) != 0 : 0) ? (i10 = HEAP32[i4 + 8 >> 2] | 0, (i10 | 0) != 0) : 0) HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } while (0);
  _cvReleaseMat(i12);
 } else {
  i10 = _cvRead(i17, _cvGetFileNodeByName(i17, i13, 702104) | 0, 0) | 0;
  HEAP32[i16 + 4 >> 2] = i10;
  if ((i10 | 0) != 0 ? (HEAP32[i10 >> 2] & -65536 | 0) == 1111752704 : 0) break;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i7, 22) | 0) + 0 | 0;
  i1 = 702168 | 0;
  i6 = i5 + 22 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i1 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i5 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i7, 702152, 701600, 3641);
  __ZN2cv6String10deallocateEv(i7);
 } while (0);
 if (!i9) {
  STACKTOP = i19;
  return i16 | 0;
 }
 i8 = _cvGetDims(HEAP32[i16 + 4 >> 2] | 0, i15) | 0;
 i3 = (i8 | 0) > 0;
 if (i3) {
  i4 = 0;
  i2 = 0;
  do {
   i2 = i2 + 1 + (HEAP32[i15 + (i4 << 2) >> 2] | 0) | 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i8 | 0));
 } else i2 = 0;
 i4 = _cvGetFileNodeByName(i17, i13, 702112) | 0;
 if (!i4) {
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i14, 24) | 0) + 0 | 0;
  i1 = 702192 | 0;
  i6 = i5 + 24 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i1 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i5 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i14, 702152, 701600, 3658);
  __ZN2cv6String10deallocateEv(i14);
 }
 _cvStartReadRawData(i17, i4, i18);
 if (i11) {
  if (i3) {
   i1 = i16 + 8 | 0;
   i2 = 0;
   do {
    _cvReadRawDataSlice(i17, i18, 2, i1 + (i2 << 3) | 0, 702120);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i8 | 0));
  }
  HEAP32[i16 + 264 >> 2] = 0;
  STACKTOP = i19;
  return i16 | 0;
 }
 i2 = _cvAlloc(i2 + i8 << 2) | 0;
 i5 = i16 + 264 | 0;
 HEAP32[i5 >> 2] = i2;
 if (!i3) {
  STACKTOP = i19;
  return i16 | 0;
 }
 i4 = i2;
 i3 = i2 + (i8 << 2) | 0;
 i2 = 0;
 while (1) {
  HEAP32[i4 + (i2 << 2) >> 2] = i3;
  i1 = i15 + (i2 << 2) | 0;
  _cvReadRawDataSlice(i17, i18, (HEAP32[i1 >> 2] | 0) + 1 | 0, i3, 702120);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i8 | 0)) break;
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = i3 + ((HEAP32[i1 >> 2] | 0) + 1 << 2) | 0;
 }
 STACKTOP = i19;
 return i16 | 0;
}

function __ZN12_GLOBAL__N_113FormattedImplC2EN2cv6StringES2_NS1_3MatEPcbbi(i18, i10, i13, i14, i12, i15, i11, i17) {
 i18 = i18 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 i11 = i11 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i16 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i19 = i20;
 i3 = i20 + 8 | 0;
 HEAP32[i18 >> 2] = 7088;
 i16 = i18 + 44 | 0;
 HEAP32[i16 >> 2] = 1124007936;
 i1 = i18 + 52 | 0;
 i2 = i18 + 84 | 0;
 i6 = i18 + 48 | 0;
 i7 = i6 + 36 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP32[i2 >> 2] = i1;
 i4 = i18 + 92 | 0;
 HEAP32[i18 + 88 >> 2] = i4;
 HEAP32[i18 + 96 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i4 = i18 + 124 | 0;
 i5 = i18 + 128 | 0;
 i8 = i18 + 132 | 0;
 i9 = i18 + 136 | 0;
 HEAP32[i4 + 0 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 if ((HEAP32[i14 + 4 >> 2] | 0) >= 3) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i6 = (__ZN2cv6String8allocateEj(i3, 11) | 0) + 0 | 0;
  i2 = 7104 | 0;
  i7 = i6 + 11 | 0;
  do {
   HEAP8[i6 >> 0] = HEAP8[i2 >> 0] | 0;
   i6 = i6 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i6 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 7120, 7136, 86);
  __ZN2cv6String10deallocateEv(i3);
 }
 if ((i4 | 0) != (i10 | 0)) {
  __ZN2cv6String10deallocateEv(i4);
  i1 = HEAP32[i10 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i1 = i1 + -4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = HEAP32[i10 >> 2] | 0;
  }
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i10 + 4 >> 2];
 }
 if ((i8 | 0) != (i13 | 0)) {
  __ZN2cv6String10deallocateEv(i8);
  i1 = HEAP32[i13 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i1 = i1 + -4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = HEAP32[i13 + 4 >> 2];
 }
 __ZN2cv3MataSERKS0_(i16, i14) | 0;
 HEAP32[i18 + 100 >> 2] = ((HEAP32[i14 >> 2] | 0) >>> 3 & 511) + 1;
 i1 = i18 + 140 | 0;
 HEAP8[i1 + 0 >> 0] = HEAP8[i12 + 0 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[i12 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[i12 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[i12 + 3 >> 0] | 0;
 HEAP8[i1 + 4 >> 0] = HEAP8[i12 + 4 >> 0] | 0;
 HEAP32[i18 + 108 >> 2] = 0;
 HEAP8[i18 + 104 >> 0] = i15 & 1;
 HEAP8[i18 + 105 >> 0] = i11 & 1;
 HEAP32[i18 + 120 >> 2] = 0;
 HEAP32[i18 + 116 >> 2] = 0;
 HEAP32[i18 + 112 >> 2] = 0;
 i1 = i18 + 4 | 0;
 if ((i17 | 0) < 0) {
  HEAP8[i1 >> 0] = 37;
  HEAP8[i18 + 5 >> 0] = 97;
  HEAP8[i18 + 6 >> 0] = 0;
 } else {
  HEAP32[i19 >> 2] = (i17 | 0) > 20 ? 20 : i17;
  _sprintf(i1, 7192, i19) | 0;
 }
 switch (HEAP32[i16 >> 2] & 7 | 0) {
 case 1:
  {
   i10 = i18 + 148 | 0;
   HEAP8[i10 >> 0] = 109;
   HEAP8[i10 + 1 >> 0] = 1;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   i10 = i10 + 4 | 0;
   HEAP8[i10 >> 0] = 0;
   HEAP8[i10 + 1 >> 0] = 0;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   STACKTOP = i20;
   return;
  }
 case 6:
  {
   i10 = i18 + 148 | 0;
   HEAP8[i10 >> 0] = 114;
   HEAP8[i10 + 1 >> 0] = 1;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   i10 = i10 + 4 | 0;
   HEAP8[i10 >> 0] = 0;
   HEAP8[i10 + 1 >> 0] = 0;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   STACKTOP = i20;
   return;
  }
 case 2:
  {
   i10 = i18 + 148 | 0;
   HEAP8[i10 >> 0] = 110;
   HEAP8[i10 + 1 >> 0] = 1;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   i10 = i10 + 4 | 0;
   HEAP8[i10 >> 0] = 0;
   HEAP8[i10 + 1 >> 0] = 0;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   STACKTOP = i20;
   return;
  }
 case 0:
  {
   i10 = i18 + 148 | 0;
   HEAP8[i10 >> 0] = 108;
   HEAP8[i10 + 1 >> 0] = 1;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   i10 = i10 + 4 | 0;
   HEAP8[i10 >> 0] = 0;
   HEAP8[i10 + 1 >> 0] = 0;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   STACKTOP = i20;
   return;
  }
 case 5:
  {
   i10 = i18 + 148 | 0;
   HEAP8[i10 >> 0] = 113;
   HEAP8[i10 + 1 >> 0] = 1;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   i10 = i10 + 4 | 0;
   HEAP8[i10 >> 0] = 0;
   HEAP8[i10 + 1 >> 0] = 0;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   STACKTOP = i20;
   return;
  }
 case 4:
  {
   i10 = i18 + 148 | 0;
   HEAP8[i10 >> 0] = 112;
   HEAP8[i10 + 1 >> 0] = 1;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   i10 = i10 + 4 | 0;
   HEAP8[i10 >> 0] = 0;
   HEAP8[i10 + 1 >> 0] = 0;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   STACKTOP = i20;
   return;
  }
 case 3:
  {
   i10 = i18 + 148 | 0;
   HEAP8[i10 >> 0] = 111;
   HEAP8[i10 + 1 >> 0] = 1;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   i10 = i10 + 4 | 0;
   HEAP8[i10 >> 0] = 0;
   HEAP8[i10 + 1 >> 0] = 0;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   STACKTOP = i20;
   return;
  }
 default:
  {
   i10 = i18 + 148 | 0;
   HEAP8[i10 >> 0] = 115;
   HEAP8[i10 + 1 >> 0] = 1;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   i10 = i10 + 4 | 0;
   HEAP8[i10 >> 0] = 0;
   HEAP8[i10 + 1 >> 0] = 0;
   HEAP8[i10 + 2 >> 0] = 0;
   HEAP8[i10 + 3 >> 0] = 0;
   STACKTOP = i20;
   return;
  }
 }
}

function __ZNK2cv12_OutputArray5setToERKNS_11_InputArrayES3_(i11, i5, i12) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0, d18 = 0.0, d19 = 0.0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i15 = i16;
 i14 = i16 + 72 | 0;
 i10 = i16 + 64 | 0;
 i4 = i16 + 56 | 0;
 i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] & 127](i11) | 0;
 if ((i3 | 0) == 589824) {
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i5 >> 2] >> 2] & 63](i14, i5, -1);
  i4 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] & 127](i11, -1) | 0;
  FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] & 127](i5) | 0;
  i13 = i14 + 4 | 0;
  do if (((HEAP32[i13 >> 2] | 0) <= 2 ? (i2 = HEAP32[i14 >> 2] | 0, (i2 & 16384 | 0) != 0) : 0) ? (i6 = HEAP32[i14 + 40 >> 2] | 0, i1 = HEAP32[i6 + 4 >> 2] | 0, i6 = HEAP32[i6 >> 2] | 0, i7 = (i1 | 0) == 1, i8 = (i6 | 0) == 1, i7 | i8) : 0) {
   i3 = (i4 >>> 3 & 511) + 1 | 0;
   if (!i7) if ((i1 | 0) == (i3 | 0) & i8) break; else {
    i9 = 27;
    break;
   }
   if (!(i8 | (i6 | 0) == (i3 | 0))) if (!((i6 | 0) == 4 ? (i2 & 4095 | 0) == 6 & i3 >>> 0 < 5 : 0)) i9 = 27;
  } else i9 = 27; while (0);
  if ((i9 | 0) == 27) {
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   i3 = (__ZN2cv6String8allocateEj(i10, 60) | 0) + 0 | 0;
   i2 = 31312;
   i1 = i3 + 60 | 0;
   do {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    i3 = i3 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i3 | 0) < (i1 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 31376, 27528, 2620);
   __ZN2cv6String10deallocateEv(i10);
  }
  i1 = HEAP32[i11 + 8 >> 2] | 0;
  i4 = i14 + 16 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i5 = i14 + 44 | 0;
  d19 = +HEAPF64[i3 + 8 >> 3];
  d18 = +HEAPF64[i3 + 16 >> 3];
  d17 = +HEAPF64[i3 + 24 >> 3];
  HEAPF64[i15 >> 3] = +HEAPF64[i3 >> 3];
  HEAPF64[i15 + 8 >> 3] = d19;
  HEAPF64[i15 + 16 >> 3] = d18;
  HEAPF64[i15 + 24 >> 3] = d17;
  __ZN2cv4cuda6GpuMat5setToENS_7Scalar_IdEERKNS_11_InputArrayERNS0_6StreamE(i1, i15, i12, __ZN2cv4cuda6Stream4NullEv() | 0) | 0;
  i1 = i14 + 36 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != 0 ? (i9 = i3 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2) {
    i3 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i3) {
     i3 = HEAP32[i14 + 32 >> 2] | 0;
     if (!i3) {
      if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
       i10 = __Znwj(4) | 0;
       HEAP32[i10 >> 2] = 32784;
       HEAP32[6904] = i10;
       ___cxa_guard_release(27624);
      }
      i3 = HEAP32[6904] | 0;
      i2 = HEAP32[i1 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3, i2);
   }
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 + 0 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  if ((HEAP32[i13 >> 2] | 0) > 0) {
   i3 = HEAP32[i14 + 40 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i13 >> 2] | 0));
  }
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == (i14 + 48 | 0)) {
   STACKTOP = i16;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i16;
  return;
 } else if ((i3 | 0) == 655360) {
  __ZN2cv4UMat5setToERKNS_11_InputArrayES3_(HEAP32[i11 + 8 >> 2] | 0, i5, i12) | 0;
  STACKTOP = i16;
  return;
 } else if ((i3 | 0) == 65536 | (i3 | 0) == 131072 | (i3 | 0) == 196608) {
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i11 >> 2] >> 2] & 63](i15, i11, -1);
  __ZN2cv3Mat5setToERKNS_11_InputArrayES3_(i15, i5, i12) | 0;
  i3 = i15 + 36 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) {
   i2 = HEAP32[i3 >> 2] | 0;
   if (i2) {
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) {
     i1 = HEAP32[i15 + 32 >> 2] | 0;
     if (!i1) {
      if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
       i10 = __Znwj(4) | 0;
       HEAP32[i10 >> 2] = 32784;
       HEAP32[6904] = i10;
       ___cxa_guard_release(27624);
      }
      i1 = HEAP32[6904] | 0;
      i2 = HEAP32[i3 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i2);
   }
   HEAP32[i3 >> 2] = 0;
  }
  HEAP32[i3 >> 2] = 0;
  i10 = i15 + 16 | 0;
  i2 = i15 + 4 | 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i15 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i1 = HEAP32[i15 + 44 >> 2] | 0;
  if ((i1 | 0) == (i15 + 48 | 0)) {
   STACKTOP = i16;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i16;
  return;
 } else if (!i3) {
  STACKTOP = i16;
  return;
 } else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i4, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i4, 31376, 27528, 2624);
  __ZN2cv6String10deallocateEv(i4);
  STACKTOP = i16;
  return;
 }
}

function __ZN2cvL6SVBkSbEiiPKdjS1_jbS1_jbS1_jiPdjPh(i30, i31, i32, i1, i12, i2, i8, i11, i3, i29, i4, i9, i33, i5, i6) {
 i30 = i30 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i29 = i29 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i33 = i33 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var d7 = 0.0, d10 = 0.0, i13 = 0, i14 = 0, i15 = 0, d16 = 0.0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i34 = 0, d35 = 0.0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i34 = STACKTOP;
 i28 = (i1 | 0) == 0 ? 1 : i1 >>> 3;
 i20 = i2 >>> 3;
 i27 = i3 >>> 3;
 i26 = i4 >>> 3;
 i25 = i5 >>> 3;
 i24 = i6 + 7 & -8;
 i23 = i24;
 i22 = i8 ? i20 : 1;
 i20 = i8 ? 1 : i20;
 i8 = (i31 | 0) < (i30 | 0) ? i31 : i30;
 i21 = (i29 | 0) != 0;
 i19 = i21 ? i9 : i30;
 i18 = (i31 | 0) > 0;
 if (i18) {
  i6 = (i19 | 0) > 0;
  i5 = i19 << 3;
  i4 = 0;
  do {
   if (i6) _memset(i33 + ((Math_imul(i4, i25) | 0) << 3) | 0, 0, i5 | 0) | 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i31 | 0));
 }
 if ((i8 | 0) <= 0) {
  STACKTOP = i34;
  return;
 }
 i6 = ~i31;
 i17 = ~i30;
 i17 = ~((i6 | 0) > (i17 | 0) ? i6 : i17);
 i6 = 0;
 d7 = 0.0;
 do {
  d7 = d7 + +HEAPF64[i32 + ((Math_imul(i6, i28) | 0) << 3) >> 3];
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i17 | 0));
 d16 = d7 * 4.440892098500626e-16;
 i4 = (i19 | 0) == 1;
 i3 = (i30 | 0) > 0;
 i2 = i19 + -4 | 0;
 i1 = (i2 | 0) < 0;
 i13 = i19 & -4;
 i14 = (i19 | 0) > 0;
 i15 = i19 << 3;
 i5 = 0;
 while (1) {
  d7 = +HEAPF64[i32 + ((Math_imul(i5, i28) | 0) << 3) >> 3];
  L17 : do if (!(+Math_abs(+d7) <= d16)) {
   d10 = 1.0 / d7;
   if (i4) {
    if (i21) if (i3) {
     i9 = 0;
     d7 = 0.0;
     do {
      d35 = +HEAPF64[i12 + ((Math_imul(i9, i20) | 0) << 3) >> 3];
      d7 = d7 + d35 * +HEAPF64[i29 + ((Math_imul(i9, i26) | 0) << 3) >> 3];
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) != (i30 | 0));
    } else d7 = 0.0; else d7 = +HEAPF64[i12 >> 3];
    d7 = d10 * d7;
    if (i18) i9 = 0; else break;
    while (1) {
     i6 = i33 + ((Math_imul(i9, i25) | 0) << 3) | 0;
     HEAPF64[i6 >> 3] = +HEAPF64[i6 >> 3] + d7 * +HEAPF64[i11 + (i9 << 3) >> 3];
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i31 | 0)) break L17;
    }
   }
   if (i21) {
    if (i14) _memset(i24 | 0, 0, i15 | 0) | 0;
    if (i3) {
     i8 = i29;
     i6 = 0;
     while (1) {
      d7 = +HEAPF64[i12 + ((Math_imul(i6, i20) | 0) << 3) >> 3];
      if (i1) i9 = 0; else {
       i9 = 0;
       do {
        i37 = i23 + (i9 << 3) | 0;
        i39 = i9 | 1;
        i38 = i23 + (i39 << 3) | 0;
        d35 = +HEAPF64[i38 >> 3] + d7 * +HEAPF64[i8 + (i39 << 3) >> 3];
        HEAPF64[i37 >> 3] = +HEAPF64[i37 >> 3] + d7 * +HEAPF64[i8 + (i9 << 3) >> 3];
        HEAPF64[i38 >> 3] = d35;
        i38 = i9 | 2;
        i37 = i23 + (i38 << 3) | 0;
        i39 = i9 | 3;
        i36 = i23 + (i39 << 3) | 0;
        d35 = +HEAPF64[i36 >> 3] + d7 * +HEAPF64[i8 + (i39 << 3) >> 3];
        HEAPF64[i37 >> 3] = +HEAPF64[i37 >> 3] + d7 * +HEAPF64[i8 + (i38 << 3) >> 3];
        HEAPF64[i36 >> 3] = d35;
        i9 = i9 + 4 | 0;
       } while ((i9 | 0) <= (i2 | 0));
       i9 = i13;
      }
      if ((i9 | 0) < (i19 | 0)) do {
       i36 = i23 + (i9 << 3) | 0;
       HEAPF64[i36 >> 3] = +HEAPF64[i36 >> 3] + d7 * +HEAPF64[i8 + (i9 << 3) >> 3];
       i9 = i9 + 1 | 0;
      } while ((i9 | 0) != (i19 | 0));
      i6 = i6 + 1 | 0;
      if ((i6 | 0) == (i30 | 0)) break; else i8 = i8 + (i26 << 3) | 0;
     }
    }
    if (i14) {
     i9 = 0;
     do {
      i6 = i23 + (i9 << 3) | 0;
      HEAPF64[i6 >> 3] = d10 * +HEAPF64[i6 >> 3];
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) != (i19 | 0));
    }
   } else if (i14) {
    i9 = 0;
    do {
     HEAPF64[i23 + (i9 << 3) >> 3] = d10 * +HEAPF64[i12 + ((Math_imul(i9, i20) | 0) << 3) >> 3];
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) != (i19 | 0));
   }
   if (i18) {
    i8 = i33;
    i6 = 0;
    while (1) {
     d7 = +HEAPF64[i11 + (i6 << 3) >> 3];
     if (i1) i9 = 0; else {
      i9 = 0;
      do {
       i37 = i8 + (i9 << 3) | 0;
       i39 = i9 | 1;
       i38 = i8 + (i39 << 3) | 0;
       d10 = +HEAPF64[i38 >> 3] + d7 * +HEAPF64[i23 + (i39 << 3) >> 3];
       HEAPF64[i37 >> 3] = +HEAPF64[i37 >> 3] + d7 * +HEAPF64[i23 + (i9 << 3) >> 3];
       HEAPF64[i38 >> 3] = d10;
       i38 = i9 | 2;
       i37 = i8 + (i38 << 3) | 0;
       i39 = i9 | 3;
       i36 = i8 + (i39 << 3) | 0;
       d10 = +HEAPF64[i36 >> 3] + d7 * +HEAPF64[i23 + (i39 << 3) >> 3];
       HEAPF64[i37 >> 3] = +HEAPF64[i37 >> 3] + d7 * +HEAPF64[i23 + (i38 << 3) >> 3];
       HEAPF64[i36 >> 3] = d10;
       i9 = i9 + 4 | 0;
      } while ((i9 | 0) <= (i2 | 0));
      i9 = i13;
     }
     if ((i9 | 0) < (i19 | 0)) do {
      i36 = i8 + (i9 << 3) | 0;
      HEAPF64[i36 >> 3] = +HEAPF64[i36 >> 3] + d7 * +HEAPF64[i23 + (i9 << 3) >> 3];
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) != (i19 | 0));
     i6 = i6 + 1 | 0;
     if ((i6 | 0) == (i31 | 0)) break; else i8 = i8 + (i25 << 3) | 0;
    }
   }
  } while (0);
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == (i17 | 0)) break; else {
   i11 = i11 + (i27 << 3) | 0;
   i12 = i12 + (i22 << 3) | 0;
  }
 }
 STACKTOP = i34;
 return;
}

function __ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE(i16, i18, i17, i19, i21, i20, i1) {
 i16 = i16 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 i19 = i19 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i15 = i22;
 i14 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960728) | 0;
 i12 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960872) | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] & 127](i15, i12);
 HEAP32[i20 >> 2] = i19;
 i4 = HEAP8[i16 >> 0] | 0;
 if (i4 << 24 >> 24 == 43 | i4 << 24 >> 24 == 45) {
  i9 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] & 127](i14, i4) | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  HEAP32[i20 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = i9;
  i5 = i16 + 1 | 0;
 } else i5 = i16;
 i13 = i17;
 L4 : do if (((i13 - i5 | 0) > 1 ? (HEAP8[i5 >> 0] | 0) == 48 : 0) ? (i3 = i5 + 1 | 0, i9 = HEAP8[i3 >> 0] | 0, i9 << 24 >> 24 == 88 | i9 << 24 >> 24 == 120) : 0) {
  i9 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] & 127](i14, 48) | 0;
  i8 = HEAP32[i20 >> 2] | 0;
  HEAP32[i20 >> 2] = i8 + 1;
  HEAP8[i8 >> 0] = i9;
  i5 = i5 + 2 | 0;
  i8 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] & 127](i14, HEAP8[i3 >> 0] | 0) | 0;
  i9 = HEAP32[i20 >> 2] | 0;
  HEAP32[i20 >> 2] = i9 + 1;
  HEAP8[i9 >> 0] = i8;
  if (i5 >>> 0 < i17 >>> 0) {
   i4 = i5;
   while (1) {
    i9 = HEAP8[i4 >> 0] | 0;
    i1 = i4 + 1 | 0;
    if (!(_isxdigit_l(i9 << 24 >> 24, __ZNSt3__16__clocEv() | 0) | 0)) {
     i11 = i5;
     i1 = i4;
     break L4;
    }
    if (i1 >>> 0 < i17 >>> 0) i4 = i1; else {
     i11 = i5;
     break;
    }
   }
  } else {
   i11 = i5;
   i1 = i5;
  }
 } else i6 = 4; while (0);
 L11 : do if ((i6 | 0) == 4) if (i5 >>> 0 < i17 >>> 0) {
  i4 = i5;
  while (1) {
   i9 = HEAP8[i4 >> 0] | 0;
   i1 = i4 + 1 | 0;
   if (!(_isdigit_l(i9 << 24 >> 24, __ZNSt3__16__clocEv() | 0) | 0)) {
    i11 = i5;
    i1 = i4;
    break L11;
   }
   if (i1 >>> 0 < i17 >>> 0) i4 = i1; else {
    i11 = i5;
    break;
   }
  }
 } else {
  i11 = i5;
  i1 = i5;
 } while (0);
 i4 = HEAP8[i15 >> 0] | 0;
 if (!(i4 & 1)) i4 = (i4 & 255) >>> 1; else i4 = HEAP32[i15 + 4 >> 2] | 0;
 if (i4) {
  if ((i11 | 0) != (i1 | 0) ? (i10 = i1 + -1 | 0, i10 >>> 0 > i11 >>> 0) : 0) {
   i3 = i11;
   i4 = i10;
   do {
    i10 = HEAP8[i3 >> 0] | 0;
    HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
    HEAP8[i4 >> 0] = i10;
    i3 = i3 + 1 | 0;
    i4 = i4 + -1 | 0;
   } while (i3 >>> 0 < i4 >>> 0);
  }
  i6 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] & 127](i12) | 0;
  if (i11 >>> 0 < i1 >>> 0) {
   i7 = i15 + 1 | 0;
   i8 = i15 + 4 | 0;
   i9 = i15 + 8 | 0;
   i5 = 0;
   i4 = 0;
   i10 = i11;
   while (1) {
    i3 = (HEAP8[i15 >> 0] & 1) == 0;
    if ((HEAP8[(i3 ? i7 : HEAP32[i9 >> 2] | 0) + i4 >> 0] | 0) > 0 ? (i5 | 0) == (HEAP8[(i3 ? i7 : HEAP32[i9 >> 2] | 0) + i4 >> 0] | 0) : 0) {
     i5 = HEAP32[i20 >> 2] | 0;
     HEAP32[i20 >> 2] = i5 + 1;
     HEAP8[i5 >> 0] = i6;
     i5 = HEAP8[i15 >> 0] | 0;
     if (!(i5 & 1)) i5 = (i5 & 255) >>> 1; else i5 = HEAP32[i8 >> 2] | 0;
     i3 = 0;
     i4 = (i4 >>> 0 < (i5 + -1 | 0) >>> 0 & 1) + i4 | 0;
    } else i3 = i5;
    i23 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] & 127](i14, HEAP8[i10 >> 0] | 0) | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    HEAP32[i20 >> 2] = i5 + 1;
    HEAP8[i5 >> 0] = i23;
    i10 = i10 + 1 | 0;
    if (i10 >>> 0 >= i1 >>> 0) break; else i5 = i3 + 1 | 0;
   }
  }
  i3 = i19 + (i11 - i16) | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  if ((i3 | 0) != (i4 | 0) ? (i2 = i4 + -1 | 0, i2 >>> 0 > i3 >>> 0) : 0) do {
   i11 = HEAP8[i3 >> 0] | 0;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP8[i2 >> 0] = i11;
   i3 = i3 + 1 | 0;
   i2 = i2 + -1 | 0;
  } while (i3 >>> 0 < i2 >>> 0);
 } else {
  FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] & 7](i14, i11, i1, HEAP32[i20 >> 2] | 0) | 0;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + (i1 - i11);
 }
 L46 : do if (i1 >>> 0 < i17 >>> 0) {
  while (1) {
   i2 = HEAP8[i1 >> 0] | 0;
   if (i2 << 24 >> 24 == 46) break;
   i2 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] & 127](i14, i2) | 0;
   i11 = HEAP32[i20 >> 2] | 0;
   HEAP32[i20 >> 2] = i11 + 1;
   HEAP8[i11 >> 0] = i2;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i17 >>> 0) break L46;
  }
  i11 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] & 127](i12) | 0;
  i12 = HEAP32[i20 >> 2] | 0;
  HEAP32[i20 >> 2] = i12 + 1;
  HEAP8[i12 >> 0] = i11;
  i1 = i1 + 1 | 0;
 } while (0);
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] & 7](i14, i1, i17, HEAP32[i20 >> 2] | 0) | 0;
 i1 = (HEAP32[i20 >> 2] | 0) + (i13 - i1) | 0;
 HEAP32[i20 >> 2] = i1;
 if ((i18 | 0) == (i17 | 0)) {
  i20 = i1;
  HEAP32[i21 >> 2] = i20;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
  STACKTOP = i22;
  return;
 }
 i20 = i19 + (i18 - i16) | 0;
 HEAP32[i21 >> 2] = i20;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
 STACKTOP = i22;
 return;
}

function _deflate_stored(i17, i11) {
 i17 = i17 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 i6 = (HEAP32[i17 + 12 >> 2] | 0) + -5 | 0;
 i6 = i6 >>> 0 < 65535 ? i6 : 65535;
 i8 = i17 + 116 | 0;
 i13 = i17 + 108 | 0;
 i14 = i17 + 92 | 0;
 i9 = i17 + 44 | 0;
 i12 = i17 + 56 | 0;
 while (1) {
  i5 = HEAP32[i8 >> 2] | 0;
  if (i5 >>> 0 < 2) {
   _fill_window(i17);
   i5 = HEAP32[i8 >> 2] | 0;
   if (!(i5 | i11)) {
    i1 = 0;
    i5 = 35;
    break;
   }
   if (!i5) {
    i5 = 20;
    break;
   }
  }
  i5 = (HEAP32[i13 >> 2] | 0) + i5 | 0;
  HEAP32[i13 >> 2] = i5;
  HEAP32[i8 >> 2] = 0;
  i4 = HEAP32[i14 >> 2] | 0;
  i3 = i4 + i6 | 0;
  if (!((i5 | 0) != 0 & i5 >>> 0 < i3 >>> 0)) {
   HEAP32[i8 >> 2] = i5 - i3;
   HEAP32[i13 >> 2] = i3;
   if ((i4 | 0) > -1) i5 = (HEAP32[i12 >> 2] | 0) + i4 | 0; else i5 = 0;
   __tr_flush_block(i17, i5, i6, 0);
   HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
   i4 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i4 + 28 >> 2] | 0;
   __tr_flush_bits(i3);
   i2 = i3 + 20 | 0;
   i5 = HEAP32[i2 >> 2] | 0;
   i1 = i4 + 16 | 0;
   i19 = HEAP32[i1 >> 2] | 0;
   i5 = i5 >>> 0 > i19 >>> 0 ? i19 : i5;
   if ((i5 | 0) != 0 ? (i19 = i4 + 12 | 0, i7 = i3 + 16 | 0, _memcpy(HEAP32[i19 >> 2] | 0, HEAP32[i7 >> 2] | 0, i5 | 0) | 0, HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i5, HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i5, i4 = i4 + 20 | 0, HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i5, HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - i5, i4 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i4 - i5, (i4 | 0) == (i5 | 0)) : 0) HEAP32[i7 >> 2] = HEAP32[i3 + 8 >> 2];
   if (!(HEAP32[(HEAP32[i17 >> 2] | 0) + 16 >> 2] | 0)) {
    i1 = 0;
    i5 = 35;
    break;
   }
   i4 = HEAP32[i14 >> 2] | 0;
   i5 = HEAP32[i13 >> 2] | 0;
  }
  i3 = i5 - i4 | 0;
  if (i3 >>> 0 < ((HEAP32[i9 >> 2] | 0) + -262 | 0) >>> 0) continue;
  if ((i4 | 0) > -1) i5 = (HEAP32[i12 >> 2] | 0) + i4 | 0; else i5 = 0;
  __tr_flush_block(i17, i5, i3, 0);
  HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
  i4 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i4 + 28 >> 2] | 0;
  __tr_flush_bits(i3);
  i2 = i3 + 20 | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  i1 = i4 + 16 | 0;
  i19 = HEAP32[i1 >> 2] | 0;
  i5 = i5 >>> 0 > i19 >>> 0 ? i19 : i5;
  if ((i5 | 0) != 0 ? (i19 = i4 + 12 | 0, i10 = i3 + 16 | 0, _memcpy(HEAP32[i19 >> 2] | 0, HEAP32[i10 >> 2] | 0, i5 | 0) | 0, HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i5, HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i5, i4 = i4 + 20 | 0, HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i5, HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - i5, i4 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i4 - i5, (i4 | 0) == (i5 | 0)) : 0) HEAP32[i10 >> 2] = HEAP32[i3 + 8 >> 2];
  if (!(HEAP32[(HEAP32[i17 >> 2] | 0) + 16 >> 2] | 0)) {
   i1 = 0;
   i5 = 35;
   break;
  }
 }
 if ((i5 | 0) == 20) {
  HEAP32[i17 + 5812 >> 2] = 0;
  if ((i11 | 0) == 4) {
   i2 = HEAP32[i14 >> 2] | 0;
   if ((i2 | 0) > -1) i1 = (HEAP32[i12 >> 2] | 0) + i2 | 0; else i1 = 0;
   __tr_flush_block(i17, i1, (HEAP32[i13 >> 2] | 0) - i2 | 0, 1);
   HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   __tr_flush_bits(i3);
   i4 = i3 + 20 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i5 = i2 + 16 | 0;
   i10 = HEAP32[i5 >> 2] | 0;
   i1 = i1 >>> 0 > i10 >>> 0 ? i10 : i1;
   if ((i1 | 0) != 0 ? (i10 = i2 + 12 | 0, i15 = i3 + 16 | 0, _memcpy(HEAP32[i10 >> 2] | 0, HEAP32[i15 >> 2] | 0, i1 | 0) | 0, HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i1, HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + i1, i10 = i2 + 20 | 0, HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i1, HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i1, i10 = HEAP32[i4 >> 2] | 0, HEAP32[i4 >> 2] = i10 - i1, (i10 | 0) == (i1 | 0)) : 0) HEAP32[i15 >> 2] = HEAP32[i3 + 8 >> 2];
   i10 = (HEAP32[(HEAP32[i17 >> 2] | 0) + 16 >> 2] | 0) == 0 ? 2 : 3;
   STACKTOP = i18;
   return i10 | 0;
  }
  i4 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i14 >> 2] | 0;
  if ((i4 | 0) > (i3 | 0)) {
   if ((i3 | 0) > -1) i5 = (HEAP32[i12 >> 2] | 0) + i3 | 0; else i5 = 0;
   __tr_flush_block(i17, i5, i4 - i3 | 0, 0);
   HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
   i5 = HEAP32[i17 >> 2] | 0;
   i4 = HEAP32[i5 + 28 >> 2] | 0;
   __tr_flush_bits(i4);
   i3 = i4 + 20 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = i5 + 16 | 0;
   i10 = HEAP32[i2 >> 2] | 0;
   i1 = i1 >>> 0 > i10 >>> 0 ? i10 : i1;
   if ((i1 | 0) != 0 ? (i10 = i5 + 12 | 0, i16 = i4 + 16 | 0, _memcpy(HEAP32[i10 >> 2] | 0, HEAP32[i16 >> 2] | 0, i1 | 0) | 0, HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i1, HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + i1, i10 = i5 + 20 | 0, HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i1, HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - i1, i10 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i10 - i1, (i10 | 0) == (i1 | 0)) : 0) HEAP32[i16 >> 2] = HEAP32[i4 + 8 >> 2];
   if (!(HEAP32[(HEAP32[i17 >> 2] | 0) + 16 >> 2] | 0)) {
    i10 = 0;
    STACKTOP = i18;
    return i10 | 0;
   }
  }
  i10 = 1;
  STACKTOP = i18;
  return i10 | 0;
 } else if ((i5 | 0) == 35) {
  STACKTOP = i18;
  return i1 | 0;
 }
 return 0;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter16PrintFailedTestsERKNS_8UnitTestE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i29 = i30;
 i13 = i1 + 8 | 0;
 if (!(__ZNK7testing8internal12UnitTestImpl17failed_test_countEv(HEAP32[i13 >> 2] | 0) | 0)) {
  STACKTOP = i30;
  return;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 60 >> 2] | 0;
 if (((HEAP32[i1 + 64 >> 2] | 0) - i2 | 0) > 0) i12 = 0; else {
  STACKTOP = i30;
  return;
 }
 L6 : while (1) {
  i11 = HEAP32[i1 + 72 >> 2] | 0;
  if (((HEAP32[i1 + 76 >> 2] | 0) - i11 >> 2 | 0) > (i12 | 0) ? (HEAP32[i11 + (i12 << 2) >> 2] | 0) >= 0 : 0) i6 = HEAP32[i2 + (i12 << 2) >> 2] | 0; else i6 = 0;
  if ((HEAP8[i6 + 52 >> 0] | 0) != 0 ? (i19 = i6 + 20 | 0, i20 = HEAP32[i19 >> 2] | 0, i21 = i6 + 24 | 0, i22 = HEAP32[i21 >> 2] | 0, (i20 | 0) != (i22 | 0)) : 0) {
   i1 = i22;
   i4 = i20;
   i5 = 0;
   do {
    i2 = HEAP32[i4 >> 2] | 0;
    if ((HEAP8[i2 + 36 >> 0] | 0) != 0 ? (i23 = i2 + 52 | 0, i24 = i2 + 56 | 0, i25 = HEAP32[i24 >> 2] | 0, i26 = HEAP32[i23 >> 2] | 0, (i25 - i26 | 0) > 0) : 0) {
     i2 = i26;
     i1 = i25;
     i3 = 0;
     while (1) {
      if (((i1 - i2 | 0) / 44 | 0) >>> 0 <= i3 >>> 0) {
       i2 = 13;
       break L6;
      }
      if (HEAP32[i2 + (i3 * 44 | 0) >> 2] | 0) {
       i2 = 1;
       break;
      }
      i3 = i3 + 1 | 0;
      i1 = HEAP32[i24 >> 2] | 0;
      if ((i3 | 0) >= ((i1 - i2 | 0) / 44 | 0 | 0)) {
       i2 = 0;
       break;
      }
     }
     i1 = HEAP32[i21 >> 2] | 0;
    } else i2 = 0;
    i5 = i2 + i5 | 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != (i1 | 0));
   if ((i5 | 0) != 0 ? (i27 = HEAP32[i19 >> 2] | 0, (i1 - i27 | 0) > 0) : 0) {
    i8 = i6 + 4 | 0;
    i9 = i8 + 1 | 0;
    i10 = i6 + 12 | 0;
    i11 = i6 + 36 | 0;
    i1 = i6 + 32 | 0;
    i2 = i27;
    i7 = 0;
    do {
     i3 = HEAP32[i1 >> 2] | 0;
     if (((HEAP32[i11 >> 2] | 0) - i3 >> 2 | 0) > (i7 | 0) ? (i28 = HEAP32[i3 + (i7 << 2) >> 2] | 0, (i28 | 0) >= 0) : 0) i6 = HEAP32[i2 + (i28 << 2) >> 2] | 0; else i6 = 0;
     L34 : do if ((HEAP8[i6 + 36 >> 0] | 0) != 0 ? (i14 = i6 + 56 | 0, i15 = HEAP32[i6 + 52 >> 2] | 0, i16 = (HEAP32[i14 >> 2] | 0) - i15 | 0, (i16 | 0) > 0) : 0) {
      i4 = i6 + 52 | 0;
      i3 = i15;
      i2 = (i16 | 0) / 44 | 0;
      i5 = 0;
      while (1) {
       if (i2 >>> 0 <= i5 >>> 0) {
        i2 = 28;
        break L6;
       }
       if (HEAP32[i3 + (i5 * 44 | 0) >> 2] | 0) break;
       i5 = i5 + 1 | 0;
       i2 = ((HEAP32[i14 >> 2] | 0) - i3 | 0) / 44 | 0;
       if ((i5 | 0) >= (i2 | 0)) break L34;
      }
      __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(1, 162560, i29);
      if (!(HEAP8[i8 >> 0] & 1)) i2 = i9; else i2 = HEAP32[i10 >> 2] | 0;
      i3 = i6 + 12 | 0;
      if (!(HEAP8[i3 >> 0] & 1)) i3 = i3 + 1 | 0; else i3 = HEAP32[i6 + 20 >> 2] | 0;
      HEAP32[i29 >> 2] = i2;
      HEAP32[i29 + 4 >> 2] = i3;
      _printf(162624, i29 | 0) | 0;
      i3 = HEAP32[i6 + 24 >> 2] | 0;
      do if (i3) if (!(HEAP8[i3 >> 0] & 1)) {
       i5 = i3 + 1 | 0;
       break;
      } else {
       i5 = HEAP32[i3 + 8 >> 2] | 0;
       break;
      } else i5 = 0; while (0);
      i3 = HEAP32[i6 + 28 >> 2] | 0;
      do if (!i3) {
       i3 = 0;
       i2 = 44;
      } else {
       if (HEAP8[i3 >> 0] & 1) {
        i3 = HEAP32[i3 + 8 >> 2] | 0;
        i2 = 44;
        break;
       }
       i3 = i3 + 1 | 0;
       _printf(168896, i29 | 0) | 0;
       if (!i5) {
        i2 = 49;
        break;
       }
       HEAP32[i29 >> 2] = 162512;
       HEAP32[i29 + 4 >> 2] = i5;
       _printf(168912, i29 | 0) | 0;
       i2 = 47;
      } while (0);
      do if ((i2 | 0) == 44 ? (i2 = 0, i17 = (i5 | 0) != 0, i18 = (i3 | 0) != 0, i17 | i18) : 0) {
       _printf(168896, i29 | 0) | 0;
       if (i17) {
        HEAP32[i29 >> 2] = 162512;
        HEAP32[i29 + 4 >> 2] = i5;
        _printf(168912, i29 | 0) | 0;
        if (i18) {
         i2 = 47;
         break;
        } else break;
       } else if (i18) {
        i2 = 49;
        break;
       } else break;
      } while (0);
      if ((i2 | 0) == 47) {
       _printf(160688, i29 | 0) | 0;
       i2 = 49;
      }
      if ((i2 | 0) == 49) {
       HEAP32[i29 >> 2] = 164552;
       HEAP32[i29 + 4 >> 2] = i3;
       _printf(168912, i29 | 0) | 0;
      }
      _putchar(10) | 0;
     } while (0);
     i7 = i7 + 1 | 0;
     i2 = HEAP32[i19 >> 2] | 0;
    } while ((i7 | 0) < ((HEAP32[i21 >> 2] | 0) - i2 >> 2 | 0));
   }
  }
  i12 = i12 + 1 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i1 + 60 >> 2] | 0;
  if ((i12 | 0) >= ((HEAP32[i1 + 64 >> 2] | 0) - i2 >> 2 | 0)) {
   i2 = 53;
   break;
  }
 }
 if ((i2 | 0) == 13) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i23); else if ((i2 | 0) == 28) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i4); else if ((i2 | 0) == 53) {
  STACKTOP = i30;
  return;
 }
}

function __ZN2cvL16GEMMBlockMul_32fEPKfjS1_jPdjNS_5Size_IiEES4_i(i17, i3, i32, i4, i12, i5, i1, i2, i7) {
 i17 = i17 | 0;
 i3 = i3 | 0;
 i32 = i32 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i6 = 0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, d34 = 0.0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 i31 = i33;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i30 = HEAP32[i2 >> 2] | 0;
 i27 = HEAP32[i2 + 4 >> 2] | 0;
 i28 = i31 + 8 | 0;
 HEAP32[i31 >> 2] = i28;
 i29 = i31 + 4 | 0;
 HEAP32[i29 >> 2] = 264;
 i2 = i7 & 16;
 i3 = i3 >>> 2;
 i26 = i4 >>> 2;
 i22 = i5 >>> 3;
 do if (i7 & 1) if (i1 >>> 0 > 264) {
  i24 = __Znaj(i1 >>> 0 > 1073741823 ? -1 : i1 << 2) | 0;
  HEAP32[i31 >> 2] = i24;
  HEAP32[i29 >> 2] = i1;
  i23 = i24;
  i25 = 1;
  i21 = i3;
  break;
 } else {
  HEAP32[i29 >> 2] = i1;
  i23 = i28;
  i24 = i28;
  i25 = 1;
  i21 = i3;
  break;
 } else {
  i23 = i28;
  i24 = 0;
  i25 = i3;
  i21 = 1;
  i1 = i6;
 } while (0);
 i3 = (i27 | 0) > 0;
 if (!(i7 & 2)) {
  if (i3) {
   i3 = (i24 | 0) == 0;
   i14 = i30 + -4 | 0;
   i4 = (i14 | 0) < 0;
   i16 = (i2 | 0) == 0;
   i15 = (i1 | 0) > 0;
   i2 = i30 & -4;
   i13 = i3 | i15 ^ 1;
   i18 = 0;
   while (1) {
    if (i13) i19 = i3 ? i17 : i24; else {
     i6 = 0;
     do {
      HEAPF32[i24 + (i6 << 2) >> 2] = Math_fround(HEAPF32[i17 + ((Math_imul(i6, i21) | 0) << 2) >> 2]);
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i1 | 0));
     i19 = i24;
    }
    if (i4) i6 = 0; else {
     i20 = 0;
     do {
      if (i16) {
       d9 = 0.0;
       d11 = 0.0;
       d10 = 0.0;
       d8 = 0.0;
      } else {
       d9 = +HEAPF64[i12 + (i20 << 3) >> 3];
       d11 = +HEAPF64[i12 + ((i20 | 1) << 3) >> 3];
       d10 = +HEAPF64[i12 + ((i20 | 2) << 3) >> 3];
       d8 = +HEAPF64[i12 + ((i20 | 3) << 3) >> 3];
      }
      if (i15) {
       i7 = i32 + (i20 << 2) | 0;
       i6 = 0;
       while (1) {
        d34 = +Math_fround(HEAPF32[i19 + (i6 << 2) >> 2]);
        d9 = d9 + d34 * +Math_fround(HEAPF32[i7 >> 2]);
        d11 = d11 + d34 * +Math_fround(HEAPF32[i7 + 4 >> 2]);
        d10 = d10 + d34 * +Math_fround(HEAPF32[i7 + 8 >> 2]);
        d8 = d8 + d34 * +Math_fround(HEAPF32[i7 + 12 >> 2]);
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i1 | 0)) break; else i7 = i7 + (i26 << 2) | 0;
       }
      }
      HEAPF64[i12 + (i20 << 3) >> 3] = d9;
      HEAPF64[i12 + ((i20 | 1) << 3) >> 3] = d11;
      HEAPF64[i12 + ((i20 | 2) << 3) >> 3] = d10;
      HEAPF64[i12 + ((i20 | 3) << 3) >> 3] = d8;
      i20 = i20 + 4 | 0;
     } while ((i20 | 0) <= (i14 | 0));
     i6 = i2;
    }
    if ((i6 | 0) < (i30 | 0)) do {
     if (i16) d8 = 0.0; else d8 = +HEAPF64[i12 + (i6 << 3) >> 3];
     if (i15) {
      i7 = i32 + (i6 << 2) | 0;
      i5 = 0;
      while (1) {
       d9 = +Math_fround(HEAPF32[i19 + (i5 << 2) >> 2]);
       d8 = d8 + d9 * +Math_fround(HEAPF32[i7 >> 2]);
       i5 = i5 + 1 | 0;
       if ((i5 | 0) == (i1 | 0)) break; else i7 = i7 + (i26 << 2) | 0;
      }
     }
     HEAPF64[i12 + (i6 << 3) >> 3] = d8;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i30 | 0));
    i18 = i18 + 1 | 0;
    if ((i18 | 0) == (i27 | 0)) break; else {
     i12 = i12 + (i22 << 3) | 0;
     i17 = i17 + (i25 << 2) | 0;
    }
   }
  }
 } else if (i3) {
  i19 = (i24 | 0) == 0;
  i20 = (i30 | 0) > 0;
  i13 = (i2 | 0) == 0;
  i14 = i1 + -2 | 0;
  i15 = (i14 | 0) < 0;
  i16 = i1 & -2;
  i18 = i19 | (i1 | 0) < 1;
  i3 = i17;
  i2 = 0;
  while (1) {
   if (i18) i6 = i19 ? i3 : i24; else {
    i6 = 0;
    do {
     HEAPF32[i24 + (i6 << 2) >> 2] = Math_fround(HEAPF32[i3 + ((Math_imul(i6, i21) | 0) << 2) >> 2]);
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i1 | 0));
    i6 = i24;
   }
   if (i20) {
    i5 = i32;
    i4 = 0;
    while (1) {
     if (i13) d8 = 0.0; else d8 = +HEAPF64[i12 + (i4 << 3) >> 3];
     if (i15) {
      i7 = 0;
      d9 = 0.0;
     } else {
      i7 = 0;
      d9 = 0.0;
      do {
       d10 = +Math_fround(HEAPF32[i6 + (i7 << 2) >> 2]);
       d8 = d8 + d10 * +Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]);
       i17 = i7 | 1;
       d10 = +Math_fround(HEAPF32[i6 + (i17 << 2) >> 2]);
       d9 = d9 + d10 * +Math_fround(HEAPF32[i5 + (i17 << 2) >> 2]);
       i7 = i7 + 2 | 0;
      } while ((i7 | 0) <= (i14 | 0));
      i7 = i16;
     }
     if ((i7 | 0) < (i1 | 0)) do {
      d10 = +Math_fround(HEAPF32[i6 + (i7 << 2) >> 2]);
      d8 = d8 + d10 * +Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]);
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) != (i1 | 0));
     HEAPF64[i12 + (i4 << 3) >> 3] = d9 + d8;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i30 | 0)) break; else i5 = i5 + (i26 << 2) | 0;
    }
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i27 | 0)) break; else {
    i12 = i12 + (i22 << 3) | 0;
    i3 = i3 + (i25 << 2) | 0;
   }
  }
 }
 if ((i23 | 0) == (i28 | 0)) {
  STACKTOP = i33;
  return;
 }
 __ZdaPv(i23);
 HEAP32[i31 >> 2] = i28;
 HEAP32[i29 >> 2] = 264;
 STACKTOP = i33;
 return;
}

function __ZN7testing8internal12UnitTestImpl11FilterTestsENS1_18ReactionToShardingE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i20 = i27 + 24 | 0;
 i24 = i27 + 12 | 0;
 i25 = i27;
 if (!i2) {
  i21 = __ZN7testing8internal17Int32FromEnvOrDieEPKci(162256, -1) | 0;
  i22 = __ZN7testing8internal17Int32FromEnvOrDieEPKci(162280, -1) | 0;
 } else {
  i21 = -1;
  i22 = -1;
 }
 i23 = i1 + 64 | 0;
 i18 = i1 + 60 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 if ((HEAP32[i23 >> 2] | 0) == (i1 | 0)) {
  i22 = 0;
  STACKTOP = i27;
  return i22 | 0;
 }
 i19 = i20 + 1 | 0;
 i15 = i20 + 8 | 0;
 i16 = i25 + 1 | 0;
 i17 = i25 + 8 | 0;
 i12 = (i2 | 0) == 1;
 i13 = i24 + 1 | 0;
 i14 = i24 + 8 | 0;
 i2 = i1;
 i11 = 0;
 i3 = 0;
 i1 = 0;
 do {
  i4 = HEAP32[i2 + (i11 << 2) >> 2] | 0;
  i2 = i4 + 4 | 0;
  if (!(HEAP8[i2 >> 0] & 1)) i2 = i2 + 1 | 0; else i2 = HEAP32[i4 + 12 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i20, i2, _strlen(i2 | 0) | 0);
  i9 = i4 + 52 | 0;
  HEAP8[i9 >> 0] = 0;
  i10 = i4 + 24 | 0;
  i8 = i4 + 20 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  if ((HEAP32[i10 >> 2] | 0) != (i2 | 0)) {
   i7 = 0;
   do {
    i6 = HEAP32[i2 + (i7 << 2) >> 2] | 0;
    i4 = i6 + 12 | 0;
    if (!(HEAP8[i4 >> 0] & 1)) i4 = i4 + 1 | 0; else i4 = HEAP32[i6 + 20 >> 2] | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i24, i4, _strlen(i4 | 0) | 0);
    L20 : do if (!(HEAP8[i20 >> 0] & 1)) {
     i4 = 164496;
     while (1) {
      if (__ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i4, i19) | 0) {
       i5 = 1;
       break L20;
      }
      i4 = _strchr(i4, 58) | 0;
      if (!i4) {
       i26 = 18;
       break;
      } else i4 = i4 + 1 | 0;
     }
    } else {
     i2 = HEAP32[i15 >> 2] | 0;
     i4 = 164496;
     while (1) {
      if (__ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i4, i2) | 0) {
       i5 = 1;
       break L20;
      }
      i4 = _strchr(i4, 58) | 0;
      if (!i4) {
       i26 = 18;
       break;
      } else i4 = i4 + 1 | 0;
     }
    } while (0);
    L28 : do if ((i26 | 0) == 18) {
     i26 = 0;
     if (!(HEAP8[i24 >> 0] & 1)) {
      i4 = 164496;
      while (1) {
       if (__ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i4, i13) | 0) {
        i5 = 1;
        break L28;
       }
       i4 = _strchr(i4, 58) | 0;
       if (!i4) {
        i5 = 0;
        break L28;
       } else i4 = i4 + 1 | 0;
      }
     }
     i2 = HEAP32[i14 >> 2] | 0;
     i4 = 164496;
     while (1) {
      if (__ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i4, i2) | 0) {
       i5 = 1;
       break L28;
      }
      i4 = _strchr(i4, 58) | 0;
      if (!i4) {
       i5 = 0;
       break;
      } else i4 = i4 + 1 | 0;
     }
    } while (0);
    HEAP8[i6 + 37 >> 0] = i5 & 1;
    i4 = HEAP32[i6 + 28 >> 2] | 0;
    do if (i4) {
     if (!(HEAP8[i4 >> 0] & 1)) {
      i4 = i4 + 1 | 0;
      break;
     }
     if (HEAP32[i4 + 8 >> 2] | 0) i4 = HEAP32[i4 + 8 >> 2] | 0; else i4 = 159968;
    } else i4 = 159968; while (0);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i25, i4, _strlen(i4 | 0) | 0);
    L46 : do if (__ZN7testing8internal15UnitTestOptions17FilterMatchesTestERKNSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEESA_(i20, i24) | 0) {
     i4 = (HEAP8[159904] & 1) == 0 ? 159905 : HEAP32[39978] | 0;
     if (!(HEAP8[i25 >> 0] & 1)) while (1) {
      if (__ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i4, i16) | 0) {
       i4 = 1;
       break L46;
      }
      i4 = _strchr(i4, 58) | 0;
      if (!i4) {
       i4 = 0;
       break L46;
      } else i4 = i4 + 1 | 0;
     }
     i2 = HEAP32[i17 >> 2] | 0;
     while (1) {
      if (__ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i4, i2) | 0) {
       i4 = 1;
       break L46;
      }
      i4 = _strchr(i4, 58) | 0;
      if (!i4) {
       i4 = 0;
       break;
      } else i4 = i4 + 1 | 0;
     }
    } else i4 = 0; while (0);
    HEAP8[i6 + 38 >> 0] = i4 & 1;
    i4 = ((HEAP8[159752] | 0) != 0 | i5 ^ 1) & i4;
    if (i12 | i4 ^ 1) i2 = i4; else i2 = ((i3 | 0) % (i21 | 0) | 0 | 0) == (i22 | 0);
    i3 = (i4 & 1) + i3 | 0;
    i1 = (i2 & 1) + i1 | 0;
    HEAP8[i6 + 36 >> 0] = i2 & 1;
    HEAP8[i9 >> 0] = ((HEAP8[i9 >> 0] | 0) != 0 | i2) & 1;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i25);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i24);
    i7 = i7 + 1 | 0;
    i2 = HEAP32[i8 >> 2] | 0;
   } while (i7 >>> 0 < (HEAP32[i10 >> 2] | 0) - i2 >> 2 >>> 0);
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i20);
  i11 = i11 + 1 | 0;
  i2 = HEAP32[i18 >> 2] | 0;
 } while (i11 >>> 0 < (HEAP32[i23 >> 2] | 0) - i2 >> 2 >>> 0);
 STACKTOP = i27;
 return i1 | 0;
}

function __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i15, i18, i3, i1, i17, i19, i16) {
 i15 = i15 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i4 = i22;
 i6 = (i1 - i3 | 0) / 12 | 0;
 if (i6 >>> 0 > 100) {
  i4 = _malloc(i6) | 0;
  if (!i4) __ZSt17__throw_bad_allocv(); else {
   i20 = i4;
   i2 = i4;
  }
 } else {
  i20 = 0;
  i2 = i4;
 }
 i14 = (i3 | 0) == (i1 | 0);
 if (i14) {
  i5 = 0;
  i4 = i6;
 } else {
  i8 = i3;
  i7 = 0;
  i4 = i6;
  i6 = i2;
  while (1) {
   i5 = HEAP8[i8 >> 0] | 0;
   if (!(i5 & 1)) i5 = (i5 & 255) >>> 1; else i5 = HEAP32[i8 + 4 >> 2] | 0;
   if (!i5) {
    HEAP8[i6 >> 0] = 2;
    i5 = i7 + 1 | 0;
    i4 = i4 + -1 | 0;
   } else {
    HEAP8[i6 >> 0] = 1;
    i5 = i7;
   }
   i8 = i8 + 12 | 0;
   if ((i8 | 0) == (i1 | 0)) break; else {
    i7 = i5;
    i6 = i6 + 1 | 0;
   }
  }
 }
 i13 = 0;
 i6 = i5;
 i9 = i4;
 L17 : while (1) {
  i4 = HEAP32[i15 >> 2] | 0;
  do if (i4) {
   if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i4 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
    HEAP32[i15 >> 2] = 0;
    i4 = 0;
    break;
   } else {
    i4 = HEAP32[i15 >> 2] | 0;
    break;
   }
  } else i4 = 0; while (0);
  i7 = (i4 | 0) == 0;
  i5 = HEAP32[i18 >> 2] | 0;
  if (i5) {
   if ((HEAP32[i5 + 12 >> 2] | 0) == (HEAP32[i5 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] & 127](i5) | 0) == -1 : 0) {
    HEAP32[i18 >> 2] = 0;
    i5 = 0;
   }
  } else i5 = 0;
  i8 = (i5 | 0) == 0;
  i4 = HEAP32[i15 >> 2] | 0;
  if (!((i7 ^ i8) & (i9 | 0) != 0)) break;
  i5 = HEAP32[i4 + 12 >> 2] | 0;
  if ((i5 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i4 = HEAPU8[i5 >> 0] | 0;
  i4 = i4 & 255;
  if (!i16) i4 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] & 127](i17, i4) | 0;
  i12 = i13 + 1 | 0;
  if (i14) {
   i13 = i12;
   continue;
  } else {
   i5 = 0;
   i11 = i3;
   i10 = i2;
  }
  while (1) {
   do if ((HEAP8[i10 >> 0] | 0) == 1) {
    if (!(HEAP8[i11 >> 0] & 1)) i8 = i11 + 1 | 0; else i8 = HEAP32[i11 + 8 >> 2] | 0;
    i8 = HEAP8[i8 + i13 >> 0] | 0;
    if (!i16) i8 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] & 127](i17, i8) | 0;
    if (i4 << 24 >> 24 != i8 << 24 >> 24) {
     HEAP8[i10 >> 0] = 0;
     i8 = i5;
     i7 = i6;
     i9 = i9 + -1 | 0;
     break;
    }
    i7 = HEAP8[i11 >> 0] | 0;
    if (!(i7 & 1)) i7 = (i7 & 255) >>> 1; else i7 = HEAP32[i11 + 4 >> 2] | 0;
    if ((i7 | 0) == (i12 | 0)) {
     HEAP8[i10 >> 0] = 2;
     i8 = 1;
     i7 = i6 + 1 | 0;
     i9 = i9 + -1 | 0;
    } else {
     i8 = 1;
     i7 = i6;
    }
   } else {
    i8 = i5;
    i7 = i6;
   } while (0);
   i11 = i11 + 12 | 0;
   if ((i11 | 0) == (i1 | 0)) break; else {
    i5 = i8;
    i6 = i7;
    i10 = i10 + 1 | 0;
   }
  }
  if (!i8) {
   i13 = i12;
   i6 = i7;
   continue;
  }
  i6 = HEAP32[i15 >> 2] | 0;
  i4 = i6 + 12 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) == (HEAP32[i6 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] & 127](i6) | 0; else HEAP32[i4 >> 2] = i5 + 1;
  if ((i7 + i9 | 0) >>> 0 < 2) {
   i13 = i12;
   i6 = i7;
   continue;
  } else {
   i4 = i3;
   i6 = i7;
   i8 = i2;
  }
  while (1) {
   if ((HEAP8[i8 >> 0] | 0) == 2) {
    i5 = HEAP8[i4 >> 0] | 0;
    if (!(i5 & 1)) i5 = (i5 & 255) >>> 1; else i5 = HEAP32[i4 + 4 >> 2] | 0;
    if ((i5 | 0) != (i12 | 0)) {
     HEAP8[i8 >> 0] = 0;
     i6 = i6 + -1 | 0;
    }
   }
   i4 = i4 + 12 | 0;
   if ((i4 | 0) == (i1 | 0)) {
    i13 = i12;
    continue L17;
   } else i8 = i8 + 1 | 0;
  }
 }
 do if (i4) {
  if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i4 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
   HEAP32[i15 >> 2] = 0;
   i4 = 0;
   break;
  } else {
   i4 = HEAP32[i15 >> 2] | 0;
   break;
  }
 } else i4 = 0; while (0);
 i4 = (i4 | 0) == 0;
 do if (!i8) {
  if ((HEAP32[i5 + 12 >> 2] | 0) != (HEAP32[i5 + 16 >> 2] | 0)) if (i4) break; else {
   i21 = 67;
   break;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] & 127](i5) | 0) != -1) if (i4) break; else {
   i21 = 67;
   break;
  } else {
   HEAP32[i18 >> 2] = 0;
   i21 = 65;
   break;
  }
 } else i21 = 65; while (0);
 if ((i21 | 0) == 65 ? i4 : 0) i21 = 67;
 if ((i21 | 0) == 67) HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 2;
 L96 : do if (i14) i21 = 71; else while (1) {
  if ((HEAP8[i2 >> 0] | 0) == 2) {
   i1 = i3;
   break L96;
  }
  i3 = i3 + 12 | 0;
  if ((i3 | 0) == (i1 | 0)) {
   i21 = 71;
   break;
  } else i2 = i2 + 1 | 0;
 } while (0);
 if ((i21 | 0) == 71) HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 4;
 if (!i20) {
  STACKTOP = i22;
  return i1 | 0;
 }
 _free(i20);
 STACKTOP = i22;
 return i1 | 0;
}

function _cvSeqPopMulti(i9, i10, i6, i7) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i18 + 8 | 0;
 i2 = i18;
 if (!i9) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i1, 21) | 0) + 0 | 0;
  i4 = 40256 | 0;
  i5 = i3 + 21 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40336, 39608, 1527);
  __ZN2cv6String10deallocateEv(i1);
 }
 if ((i6 | 0) < 0) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i2, 38) | 0) + 0 | 0;
  i4 = 40296 | 0;
  i5 = i3 + 38 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i2, 40336, 39608, 1529);
  __ZN2cv6String10deallocateEv(i2);
 }
 i17 = i9 + 24 | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 i3 = (i4 | 0) < (i6 | 0) ? i4 : i6;
 if (!i7) {
  if (!i10) i7 = 0; else i7 = i10 + (Math_imul(HEAP32[i9 + 28 >> 2] | 0, i3) | 0) | 0;
  if ((i3 | 0) <= 0) {
   STACKTOP = i18;
   return;
  }
  i8 = i9 + 52 | 0;
  i12 = i9 + 28 | 0;
  i13 = i9 + 36 | 0;
  i14 = i9 + 32 | 0;
  i11 = i9 + 48 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i1 = HEAP32[i5 >> 2] | 0;
   i10 = i1 + 12 | 0;
   i6 = HEAP32[i10 >> 2] | 0;
   i2 = (i6 | 0) > (i3 | 0) ? i3 : i6;
   i6 = i6 - i2 | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i17 >> 2] = i4 - i2;
   i10 = i3 - i2 | 0;
   i4 = Math_imul(i2, HEAP32[i12 >> 2] | 0) | 0;
   i3 = 0 - i4 | 0;
   i2 = (HEAP32[i13 >> 2] | 0) + i3 | 0;
   HEAP32[i13 >> 2] = i2;
   if (!i7) i9 = 0; else {
    i9 = i7 + i3 | 0;
    _memcpy(i9 | 0, i2 | 0, i4 | 0) | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    i1 = i6;
    i6 = HEAP32[i6 + 12 >> 2] | 0;
   }
   i7 = i1 + 12 | 0;
   if (!i6) {
    i6 = HEAP32[i14 >> 2] | 0;
    if ((i5 | 0) == (i1 | 0)) {
     i5 = i1 + 16 | 0;
     i4 = (Math_imul(HEAP32[i12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0) | 0) + (i6 - (HEAP32[i5 >> 2] | 0)) | 0;
     HEAP32[i7 >> 2] = i4;
     HEAP32[i5 >> 2] = i6 + (0 - i4);
     HEAP32[i8 >> 2] = 0;
     HEAP32[i14 >> 2] = 0;
     HEAP32[i13 >> 2] = 0;
     HEAP32[i17 >> 2] = 0;
     i6 = i1 + 4 | 0;
     i5 = 0;
    } else {
     HEAP32[i7 >> 2] = i6 - (HEAP32[i13 >> 2] | 0);
     i7 = HEAP32[i1 >> 2] | 0;
     i6 = (HEAP32[i7 + 16 >> 2] | 0) + (Math_imul(HEAP32[i12 >> 2] | 0, HEAP32[i7 + 12 >> 2] | 0) | 0) | 0;
     HEAP32[i13 >> 2] = i6;
     HEAP32[i14 >> 2] = i6;
     i6 = i1 + 4 | 0;
     HEAP32[i7 + 4 >> 2] = HEAP32[i6 >> 2];
     HEAP32[HEAP32[i6 >> 2] >> 2] = i7;
    }
    HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i11 >> 2] = i1;
   }
   if ((i10 | 0) <= 0) break;
   i3 = i10;
   i4 = HEAP32[i17 >> 2] | 0;
   i7 = i9;
  }
  STACKTOP = i18;
  return;
 } else {
  if ((i3 | 0) <= 0) {
   STACKTOP = i18;
   return;
  }
  i13 = i9 + 52 | 0;
  i12 = i9 + 28 | 0;
  i15 = i9 + 32 | 0;
  i16 = i9 + 36 | 0;
  i14 = i9 + 48 | 0;
  i5 = HEAP32[i13 >> 2] | 0;
  i7 = i4;
  i4 = i10;
  while (1) {
   i9 = i5 + 12 | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   i10 = (i6 | 0) > (i3 | 0) ? i3 : i6;
   i6 = i6 - i10 | 0;
   HEAP32[i9 >> 2] = i6;
   HEAP32[i17 >> 2] = i7 - i10;
   i3 = i3 - i10 | 0;
   i9 = i5 + 8 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i10;
   i10 = Math_imul(HEAP32[i12 >> 2] | 0, i10) | 0;
   if (!i4) i11 = 0; else {
    _memcpy(i4 | 0, HEAP32[i5 + 16 >> 2] | 0, i10 | 0) | 0;
    i6 = HEAP32[i13 >> 2] | 0;
    i5 = i6;
    i6 = HEAP32[i6 + 12 >> 2] | 0;
    i11 = i4 + i10 | 0;
   }
   i1 = i5 + 16 | 0;
   i4 = HEAP32[i1 >> 2] | 0;
   i7 = i4 + i10 | 0;
   HEAP32[i1 >> 2] = i7;
   i2 = i5 + 12 | 0;
   if (!i6) {
    i9 = HEAP32[i5 >> 2] | 0;
    if ((i5 | 0) == (i9 | 0)) {
     i4 = HEAP32[i15 >> 2] | 0;
     i6 = (Math_imul(HEAP32[i12 >> 2] | 0, HEAP32[i5 + 8 >> 2] | 0) | 0) + (i4 - i7) | 0;
     HEAP32[i2 >> 2] = i6;
     HEAP32[i1 >> 2] = i4 + (0 - i6);
     HEAP32[i13 >> 2] = 0;
     HEAP32[i15 >> 2] = 0;
     HEAP32[i16 >> 2] = 0;
     HEAP32[i17 >> 2] = 0;
     i6 = i5 + 4 | 0;
     i4 = 0;
    } else {
     i6 = i5 + 8 | 0;
     i8 = HEAP32[i6 >> 2] | 0;
     i7 = Math_imul(HEAP32[i12 >> 2] | 0, i8) | 0;
     HEAP32[i2 >> 2] = i7;
     HEAP32[i1 >> 2] = i4 + (i10 - i7);
     HEAP32[i6 >> 2] = 0;
     i6 = i5 + 4 | 0;
     i4 = HEAP32[i6 >> 2] | 0;
     if ((i4 | 0) != (i5 | 0)) {
      i7 = i4;
      do {
       i10 = i7 + 8 | 0;
       HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) - i8;
       i7 = HEAP32[i7 + 4 >> 2] | 0;
      } while ((i7 | 0) != (i5 | 0));
     }
     HEAP32[i13 >> 2] = i4;
     HEAP32[i9 + 4 >> 2] = i4;
     HEAP32[HEAP32[i6 >> 2] >> 2] = i9;
    }
    HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i14 >> 2] = i5;
    i5 = i4;
   }
   if ((i3 | 0) <= 0) break;
   i7 = HEAP32[i17 >> 2] | 0;
   i4 = i11;
  }
  STACKTOP = i18;
  return;
 }
}

function __ZN2cv10BmpDecoder10readHeaderEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 768 | 0;
 i9 = i14;
 i5 = i13 + 32 | 0;
 if (HEAP32[i13 + 48 >> 2] | 0) {
  i3 = HEAP32[i13 + 36 >> 2] | 0;
  if ((i3 | 0) < 3) i4 = Math_imul(HEAP32[i13 + 44 >> 2] | 0, HEAP32[i13 + 40 >> 2] | 0) | 0; else {
   i2 = HEAP32[i13 + 72 >> 2] | 0;
   i1 = 0;
   i4 = 1;
   do {
    i4 = Math_imul(HEAP32[i2 + (i1 << 2) >> 2] | 0, i4) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  i3 = i13 + 92 | 0;
  if (i4) if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] & 127](i3, i5) | 0) {
   i12 = i3;
   i10 = i3;
  } else {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  } else {
   i4 = i3;
   i2 = i3;
   i11 = 9;
  }
 } else {
  i2 = i13 + 92 | 0;
  i4 = i2;
  i11 = 9;
 }
 if ((i11 | 0) == 9) if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] & 127](i2, i13 + 16 | 0) | 0) {
  i12 = i2;
  i10 = i4;
 } else {
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 __ZN2cv11RBaseStream4skipEi(i12, 10);
 HEAP32[i13 + 1160 >> 2] = __ZN2cv12RLByteStream8getDWordEv(i10) | 0;
 i2 = __ZN2cv12RLByteStream8getDWordEv(i10) | 0;
 L16 : do if ((i2 | 0) > 35) {
  i8 = i13 + 4 | 0;
  HEAP32[i8 >> 2] = __ZN2cv12RLByteStream8getDWordEv(i10) | 0;
  i9 = i13 + 8 | 0;
  HEAP32[i9 >> 2] = __ZN2cv12RLByteStream8getDWordEv(i10) | 0;
  i5 = i13 + 1156 | 0;
  HEAP32[i5 >> 2] = (__ZN2cv12RLByteStream8getDWordEv(i10) | 0) >> 16;
  i4 = i13 + 1164 | 0;
  HEAP32[i4 >> 2] = __ZN2cv12RLByteStream8getDWordEv(i10) | 0;
  __ZN2cv11RBaseStream4skipEi(i12, 12);
  i3 = __ZN2cv12RLByteStream8getDWordEv(i10) | 0;
  __ZN2cv11RBaseStream4skipEi(i12, i2 + -36 | 0);
  if ((HEAP32[i8 >> 2] | 0) > 0 ? (HEAP32[i9 >> 2] | 0) != 0 : 0) {
   i1 = HEAP32[i5 >> 2] | 0;
   L28 : do switch (i1 | 0) {
   case 16:
    {
     i11 = 16;
     break;
    }
   case 32:
   case 24:
   case 8:
   case 4:
   case 1:
    {
     do if (!(HEAP32[i4 >> 2] | 0)) {
      if ((i1 | 0) >= 9) if ((i1 | 0) == 16) break L28; else {
       i4 = 1;
       i2 = 1;
       break L16;
      }
     } else if ((i1 | 0) == 16) {
      i11 = 16;
      break L28;
     } else if ((i1 | 0) == 4) if ((HEAP32[i4 >> 2] | 0) == 2) {
      i1 = 4;
      break;
     } else {
      i4 = 0;
      i2 = 0;
      break L16;
     } else if ((i1 | 0) == 8 ? (HEAP32[i4 >> 2] | 0) == 1 : 0) {
      i1 = 8;
      break;
     } else {
      i4 = 0;
      i2 = 0;
      break L16;
     } while (0);
     i4 = i13 + 128 | 0;
     _memset(i4 | 0, 0, 1024) | 0;
     __ZN2cv12RLByteStream8getBytesEPvi(i10, i4, ((i3 | 0) == 0 ? 1 << i1 : i3) << 2) | 0;
     i4 = __Z14IsColorPaletteP12PaletteEntryi(i4, HEAP32[i5 >> 2] | 0) | 0;
     i2 = 1;
     break L16;
    }
   default:
    {
     i4 = 0;
     i2 = 0;
     break L16;
    }
   } while (0);
   do if ((i11 | 0) == 16) {
    i1 = HEAP32[i4 >> 2] | 0;
    if (!i1) break; else if ((i1 | 0) != 3) {
     i4 = 0;
     i2 = 0;
     break L16;
    }
    i2 = __ZN2cv12RLByteStream8getDWordEv(i10) | 0;
    i1 = __ZN2cv12RLByteStream8getDWordEv(i10) | 0;
    i3 = (__ZN2cv12RLByteStream8getDWordEv(i10) | 0) == 31;
    if (i3 & (i1 | 0) == 992 & (i2 | 0) == 31744) {
     HEAP32[i5 >> 2] = 15;
     i4 = 1;
     i2 = 1;
     break L16;
    } else {
     i4 = 1;
     i2 = i3 & (i1 | 0) == 2016 & (i2 | 0) == 63488;
     break L16;
    }
   } while (0);
   HEAP32[i5 >> 2] = 15;
   i4 = 1;
   i2 = 1;
  } else {
   i4 = 0;
   i2 = 0;
  }
 } else if (((i2 | 0) == 12 ? (i5 = i13 + 4 | 0, HEAP32[i5 >> 2] = __ZN2cv12RLByteStream7getWordEv(i10) | 0, i6 = i13 + 8 | 0, HEAP32[i6 >> 2] = __ZN2cv12RLByteStream7getWordEv(i10) | 0, i7 = (__ZN2cv12RLByteStream8getDWordEv(i10) | 0) >> 16, HEAP32[i13 + 1156 >> 2] = i7, HEAP32[i13 + 1164 >> 2] = 0, (HEAP32[i5 >> 2] | 0) > 0) : 0) ? (HEAP32[i6 >> 2] | 0) != 0 : 0) {
  switch (i7 | 0) {
  case 32:
  case 24:
  case 8:
  case 4:
  case 1:
   break;
  default:
   {
    i4 = 0;
    i2 = 0;
    break L16;
   }
  }
  if ((i7 | 0) < 9 ? (i8 = 1 << i7, __ZN2cv12RLByteStream8getBytesEPvi(i10, i9, 3 << i7) | 0, (i7 | 0) != 31) : 0) {
   i1 = 0;
   do {
    i7 = i1 * 3 | 0;
    HEAP8[i13 + (i1 << 2) + 128 >> 0] = HEAP8[i9 + i7 >> 0] | 0;
    HEAP8[i13 + (i1 << 2) + 129 >> 0] = HEAP8[i9 + (i7 + 1) >> 0] | 0;
    HEAP8[i13 + (i1 << 2) + 130 >> 0] = HEAP8[i9 + (i7 + 2) >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i8 | 0));
   i4 = 0;
   i2 = 1;
  } else {
   i4 = 0;
   i2 = 1;
  }
 } else {
  i4 = 0;
  i2 = 0;
 } while (0);
 HEAP32[i13 + 12 >> 2] = i4 ? 16 : 0;
 i1 = i13 + 8 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i13 + 1152 >> 2] = (i9 | 0) > 0 & 1;
 HEAP32[i1 >> 2] = (i9 | 0) > -1 ? i9 : 0 - i9 | 0;
 if (i2) {
  i10 = 1;
  STACKTOP = i14;
  return i10 | 0;
 }
 HEAP32[i13 + 1160 >> 2] = -1;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i13 + 4 >> 2] = -1;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] & 511](i12);
 i10 = 0;
 STACKTOP = i14;
 return i10 | 0;
}

function __ZN2cvL14MulTransposedLItdEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d31) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d31 = +d31;
 var d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 i25 = i32;
 i24 = i32 + 32 | 0;
 i29 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 16 >> 2] | 0;
 i30 = (HEAP32[i3 + 48 >> 2] | 0) >>> 1;
 i28 = (HEAP32[i1 + 48 >> 2] | 0) >>> 3;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i22 = (HEAP32[i2 + 48 >> 2] | 0) >>> 3; else i22 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i27 = HEAP32[i3 + 40 >> 2] | 0;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i27 = HEAP32[i27 >> 2] | 0;
 if (!i23) {
  if ((i27 | 0) <= 0) {
   STACKTOP = i32;
   return;
  }
  i7 = i26 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i26 & -4;
  i10 = 0;
  while (1) {
   i1 = Math_imul(i10, i30) | 0;
   i5 = i10;
   do {
    i2 = Math_imul(i5, i30) | 0;
    if (i8) {
     i3 = 0;
     d4 = 0.0;
    } else {
     i3 = 0;
     d4 = 0.0;
     do {
      i21 = i3 | 1;
      i22 = i3 | 2;
      i23 = i3 | 3;
      d4 = d4 + (+(HEAPU16[i29 + (i3 + i1 << 1) >> 1] | 0) * +(HEAPU16[i29 + (i3 + i2 << 1) >> 1] | 0 | 0) + +(HEAPU16[i29 + (i21 + i1 << 1) >> 1] | 0) * +(HEAPU16[i29 + (i21 + i2 << 1) >> 1] | 0 | 0) + +(HEAPU16[i29 + (i22 + i1 << 1) >> 1] | 0) * +(HEAPU16[i29 + (i22 + i2 << 1) >> 1] | 0 | 0) + +(HEAPU16[i29 + (i23 + i1 << 1) >> 1] | 0) * +(HEAPU16[i29 + (i23 + i2 << 1) >> 1] | 0 | 0));
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i7 | 0));
     i3 = i9;
    }
    if ((i3 | 0) < (i26 | 0)) do {
     d4 = d4 + +(HEAPU16[i29 + (i3 + i1 << 1) >> 1] | 0) * +(HEAPU16[i29 + (i3 + i2 << 1) >> 1] | 0 | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i26 | 0));
    HEAPF64[i6 + (i5 << 3) >> 3] = d4 * d31;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 3) | 0;
  }
  STACKTOP = i32;
  return;
 }
 i19 = (i2 | 0) == (i26 | 0) ? 4 : 0;
 i3 = i26 << 3;
 i20 = i24 + 8 | 0;
 HEAP32[i24 >> 2] = i20;
 i21 = i24 + 4 | 0;
 HEAP32[i21 >> 2] = 1032;
 if (i3 >>> 0 > 1032) {
  i18 = __Znaj(i3) | 0;
  HEAP32[i24 >> 2] = i18;
 } else i18 = i20;
 HEAP32[i21 >> 2] = i3;
 if ((i27 | 0) > 0) {
  i14 = (i2 | 0) < (i26 | 0);
  i15 = (i26 | 0) > 0;
  i16 = i25 + 24 | 0;
  i3 = i25 + 16 | 0;
  i2 = i25 + 8 | 0;
  i1 = i26 + -4 | 0;
  i11 = (i1 | 0) < 0;
  i13 = i1 >>> 2;
  i12 = Math_imul(i19, (i13 << 3) + 8 | 0) | 0;
  i13 = (i13 << 2) + 4 | 0;
  i17 = 0;
  while (1) {
   i7 = Math_imul(i17, i30) | 0;
   i9 = Math_imul(i17, i22) | 0;
   i8 = i23 + (i9 << 3) | 0;
   if (i14) if (i15) {
    i10 = 0;
    do {
     HEAPF64[i18 + (i10 << 3) >> 3] = +(HEAPU16[i29 + (i10 + i7 << 1) >> 1] | 0 | 0) - +HEAPF64[i8 >> 3];
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17; else if (i15) {
    i10 = 0;
    do {
     HEAPF64[i18 + (i10 << 3) >> 3] = +(HEAPU16[i29 + (i10 + i7 << 1) >> 1] | 0 | 0) - +HEAPF64[i23 + (i10 + i9 << 3) >> 3];
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17;
   do {
    i7 = Math_imul(i5, i30) | 0;
    i10 = i23 + ((Math_imul(i5, i22) | 0) << 3) | 0;
    if (i14) {
     d4 = +HEAPF64[i10 >> 3];
     HEAPF64[i16 >> 3] = d4;
     HEAPF64[i3 >> 3] = d4;
     HEAPF64[i2 >> 3] = d4;
     HEAPF64[i25 >> 3] = d4;
     i10 = i25;
    }
    if (i11) {
     i9 = 0;
     d4 = 0.0;
    } else {
     i8 = i10 + i12 | 0;
     i9 = 0;
     d4 = 0.0;
     while (1) {
      i35 = i9 | 1;
      i34 = i9 | 2;
      i33 = i9 | 3;
      d4 = d4 + (+HEAPF64[i18 + (i9 << 3) >> 3] * (+(HEAPU16[i29 + (i9 + i7 << 1) >> 1] | 0 | 0) - +HEAPF64[i10 >> 3]) + +HEAPF64[i18 + (i35 << 3) >> 3] * (+(HEAPU16[i29 + (i35 + i7 << 1) >> 1] | 0 | 0) - +HEAPF64[i10 + 8 >> 3]) + +HEAPF64[i18 + (i34 << 3) >> 3] * (+(HEAPU16[i29 + (i34 + i7 << 1) >> 1] | 0 | 0) - +HEAPF64[i10 + 16 >> 3]) + +HEAPF64[i18 + (i33 << 3) >> 3] * (+(HEAPU16[i29 + (i33 + i7 << 1) >> 1] | 0 | 0) - +HEAPF64[i10 + 24 >> 3]));
      i9 = i9 + 4 | 0;
      if ((i9 | 0) > (i1 | 0)) break; else i10 = i10 + (i19 << 3) | 0;
     }
     i9 = i13;
     i10 = i8;
    }
    if ((i9 | 0) < (i26 | 0)) while (1) {
     d4 = d4 + +HEAPF64[i18 + (i9 << 3) >> 3] * (+(HEAPU16[i29 + (i9 + i7 << 1) >> 1] | 0 | 0) - +HEAPF64[i10 >> 3]);
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i26 | 0)) break; else i10 = i10 + 8 | 0;
    }
    HEAPF64[i6 + (i5 << 3) >> 3] = d4 * d31;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i17 = i17 + 1 | 0;
   if ((i17 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 3) | 0;
  }
 }
 if ((i18 | 0) == (i20 | 0)) {
  STACKTOP = i32;
  return;
 }
 __ZdaPv(i18);
 HEAP32[i24 >> 2] = i20;
 HEAP32[i21 >> 2] = 1032;
 STACKTOP = i32;
 return;
}

function __ZNK2cv5MatOp8multiplyERKNS_7MatExprES3_RS1_d(i5, i6, i7, i10, d3) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 d3 = +d3;
 var i1 = 0, i2 = 0, i4 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i16 = i19 + 56 | 0;
 i13 = i19;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i5 | 0)) {
  FUNCTION_TABLE_viiiid[HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] & 3](i2, i6, i7, i10, d3);
  STACKTOP = i19;
  return;
 }
 HEAP32[i16 >> 2] = 1124007936;
 i17 = i16 + 4 | 0;
 i2 = i16 + 8 | 0;
 i14 = i16 + 40 | 0;
 i1 = i17 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i14 >> 2] = i2;
 i18 = i16 + 48 | 0;
 i15 = i16 + 44 | 0;
 HEAP32[i15 >> 2] = i18;
 HEAP32[i16 + 52 >> 2] = 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i13 >> 2] = 1124007936;
 i12 = i13 + 4 | 0;
 i2 = i13 + 8 | 0;
 i8 = i13 + 40 | 0;
 i1 = i12 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i8 >> 2] = i2;
 i9 = i13 + 48 | 0;
 i4 = i13 + 44 | 0;
 HEAP32[i4 >> 2] = i9;
 HEAP32[i13 + 52 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i2 = HEAP32[i6 >> 2] | 0;
 do if ((i2 | 0) == 33120 ? (HEAP32[i6 + 4 >> 2] | 0) == 47 : 0) {
  if ((HEAP32[i6 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i6 + 184 >> 3] == 0.0) : 0) {
   i11 = 16;
   break;
  }
  do if ((i5 | 0) == 33112) {
   if ((HEAP32[i7 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i7 + 184 >> 3] == 0.0) : 0) {
    i11 = 14;
    break;
   }
   if (((+HEAPF64[i7 + 192 >> 3] == 0.0 ? +HEAPF64[i7 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i7 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i7 + 216 >> 3] == 0.0 : 0) {
    d3 = +HEAPF64[i7 + 176 >> 3] * d3;
    __ZN2cv3MataSERKS0_(i13, i7 + 8 | 0) | 0;
   } else i11 = 14;
  } else i11 = 14; while (0);
  if ((i11 | 0) == 14) FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] & 63](i5, i7, i13, -1);
  __ZN2cv9MatOp_Bin8makeExprERNS_7MatExprEcRKNS_3MatES5_d(i10, 47, i13, i6 + 8 | 0, d3 / +HEAPF64[i6 + 176 >> 3]);
 } else i11 = 16; while (0);
 if ((i11 | 0) == 16) {
  do if ((i2 | 0) == 33112) {
   if ((HEAP32[i6 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i6 + 184 >> 3] == 0.0) : 0) {
    i11 = 24;
    break;
   }
   if (((+HEAPF64[i6 + 192 >> 3] == 0.0 ? +HEAPF64[i6 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i6 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i6 + 216 >> 3] == 0.0 : 0) {
    __ZN2cv3MataSERKS0_(i16, i6 + 8 | 0) | 0;
    d3 = +HEAPF64[i6 + 176 >> 3] * d3;
   } else i11 = 24;
  } else i11 = 24; while (0);
  if ((i11 | 0) == 24) FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i6, i16, -1);
  i2 = HEAP32[i7 >> 2] | 0;
  do if ((i2 | 0) == 33112) {
   if ((HEAP32[i7 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i7 + 184 >> 3] == 0.0) : 0) {
    i11 = 33;
    break;
   }
   if (((+HEAPF64[i7 + 192 >> 3] == 0.0 ? +HEAPF64[i7 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i7 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i7 + 216 >> 3] == 0.0 : 0) {
    __ZN2cv3MataSERKS0_(i13, i7 + 8 | 0) | 0;
    d3 = d3 * +HEAPF64[i7 + 176 >> 3];
    i2 = 42;
   } else i11 = 33;
  } else i11 = 33; while (0);
  L46 : do if ((i11 | 0) == 33) {
   do if ((i2 | 0) == 33120 ? (HEAP32[i7 + 4 >> 2] | 0) == 47 : 0) {
    if ((HEAP32[i7 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i7 + 184 >> 3] == 0.0) : 0) break;
    __ZN2cv3MataSERKS0_(i13, i7 + 8 | 0) | 0;
    d3 = d3 / +HEAPF64[i7 + 176 >> 3];
    i2 = 47;
    break L46;
   } while (0);
   FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i7, i13, -1);
   i2 = 42;
  } while (0);
  __ZN2cv9MatOp_Bin8makeExprERNS_7MatExprEcRKNS_3MatES5_d(i10, i2, i16, i13, d3);
 }
 i2 = i13 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i10 = i1 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i13);
 HEAP32[i2 >> 2] = 0;
 i11 = i13 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i9 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i16 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i10 = i1 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i16);
 HEAP32[i2 >> 2] = 0;
 i11 = i16 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i17 >> 2] | 0) > 0) {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i17 >> 2] | 0));
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) == (i18 | 0)) {
  STACKTOP = i19;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i19;
 return;
}

function _cvCloneGraph(i15, i1) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i20 = i21 + 24 | 0;
 i2 = i21 + 16 | 0;
 i6 = i21 + 8 | 0;
 i11 = i21 + 4 | 0;
 i14 = i21;
 if (!((i15 | 0) != 0 ? (HEAP32[i15 >> 2] & -53248 | 0) == 1117261824 : 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i2, 21) | 0) + 0 | 0;
  i4 = 40680 | 0;
  i5 = i3 + 21 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i2, 40704, 39608, 3257);
  __ZN2cv6String10deallocateEv(i2);
 }
 if (!i1) {
  i1 = HEAP32[i15 + 44 >> 2] | 0;
  if (!i1) {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   i3 = (__ZN2cv6String8allocateEj(i6, 20) | 0) + 0 | 0;
   i4 = 39744 | 0;
   i5 = i3 + 20 | 0;
   do {
    HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
    i3 = i3 + 1 | 0;
    i4 = i4 + 1 | 0;
   } while ((i3 | 0) < (i5 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i6, 40704, 39608, 3263);
   __ZN2cv6String10deallocateEv(i6);
   i1 = 0;
  }
 }
 i17 = HEAP32[i15 + 28 >> 2] | 0;
 i12 = i15 + 64 | 0;
 i13 = HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0;
 i10 = i15 + 24 | 0;
 i18 = _cvAlloc(HEAP32[i10 >> 2] << 2) | 0;
 i19 = _cvAlloc(HEAP32[i10 >> 2] << 2) | 0;
 i9 = i15 + 4 | 0;
 i16 = _cvCreateGraph(HEAP32[i15 >> 2] | 0, HEAP32[i9 >> 2] | 0, i17, i13, i1) | 0;
 _memcpy(i16 + 4624 | 0, i15 + 4624 | 0, (HEAP32[i9 >> 2] | 0) + -68 | 0) | 0;
 _cvStartReadSeq(i15, i20, 0);
 if ((HEAP32[i10 >> 2] | 0) > 0) {
  i6 = i20 + 12 | 0;
  i5 = i20 + 20 | 0;
  i4 = i20 + 8 | 0;
  i7 = i20 + 4 | 0;
  i3 = i20 + 16 | 0;
  i9 = HEAP32[i6 >> 2] | 0;
  i2 = 0;
  i8 = 0;
  do {
   if ((HEAP32[i9 >> 2] | 0) > -1) {
    HEAP32[i11 >> 2] = 0;
    _cvGraphAddVtx(i16, i9, i11) | 0;
    i22 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    HEAP32[i1 >> 2] = i22;
    HEAP32[i18 + (i8 << 2) >> 2] = i22;
    HEAP32[i9 >> 2] = i8;
    HEAP32[i19 + (i8 << 2) >> 2] = i1;
    i9 = HEAP32[i6 >> 2] | 0;
    i8 = i8 + 1 | 0;
   }
   i9 = i9 + i17 | 0;
   HEAP32[i6 >> 2] = i9;
   if (i9 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
    i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0;
    HEAP32[i4 >> 2] = i1;
    i9 = HEAP32[i1 + 16 >> 2] | 0;
    HEAP32[i6 >> 2] = i9;
    i1 = HEAP32[i1 + 12 >> 2] | 0;
    i22 = HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0;
    HEAP32[i3 >> 2] = i9;
    HEAP32[i5 >> 2] = i9 + (Math_imul(i22, i1) | 0);
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i10 >> 2] | 0));
 }
 _cvStartReadSeq(HEAP32[i12 >> 2] | 0, i20, 0);
 if ((HEAP32[(HEAP32[i12 >> 2] | 0) + 24 >> 2] | 0) > 0) {
  i8 = i20 + 12 | 0;
  i7 = i20 + 20 | 0;
  i5 = i20 + 8 | 0;
  i9 = i20 + 4 | 0;
  i4 = i20 + 16 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  i3 = 0;
  do {
   if ((HEAP32[i6 >> 2] | 0) > -1) {
    HEAP32[i14 >> 2] = 0;
    _cvGraphAddEdgeByPtr(i16, HEAP32[i19 + (HEAP32[HEAP32[i6 + 16 >> 2] >> 2] << 2) >> 2] | 0, HEAP32[i19 + (HEAP32[HEAP32[i6 + 20 >> 2] >> 2] << 2) >> 2] | 0, i6, i14) | 0;
    HEAP32[HEAP32[i14 >> 2] >> 2] = HEAP32[i6 >> 2];
    i6 = HEAP32[i8 >> 2] | 0;
   }
   i6 = i6 + i13 | 0;
   HEAP32[i8 >> 2] = i6;
   if (i6 >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) {
    i10 = HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0;
    HEAP32[i5 >> 2] = i10;
    i6 = HEAP32[i10 + 16 >> 2] | 0;
    HEAP32[i8 >> 2] = i6;
    i10 = HEAP32[i10 + 12 >> 2] | 0;
    i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0;
    HEAP32[i4 >> 2] = i6;
    HEAP32[i7 >> 2] = i6 + (Math_imul(i2, i10) | 0);
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[(HEAP32[i12 >> 2] | 0) + 24 >> 2] | 0));
 }
 _cvStartReadSeq(i15, i20, 0);
 i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + 24 >> 2] | 0;
 if ((i1 | 0) <= 0) {
  _cvFree_(i18);
  _cvFree_(i19);
  i10 = _cvGetErrStatus() | 0;
  i10 = (i10 | 0) < 0;
  i10 = i10 ? 0 : i16;
  STACKTOP = i21;
  return i10 | 0;
 }
 i7 = i20 + 12 | 0;
 i8 = i20 + 20 | 0;
 i9 = i20 + 8 | 0;
 i2 = i20 + 4 | 0;
 i4 = i20 + 16 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i3 = 0;
 i5 = 0;
 do {
  if ((HEAP32[i6 >> 2] | 0) > -1) {
   HEAP32[i6 >> 2] = HEAP32[i18 + (i5 << 2) >> 2];
   i5 = i5 + 1 | 0;
  }
  i6 = i6 + i17 | 0;
  HEAP32[i7 >> 2] = i6;
  if (i6 >>> 0 >= (HEAP32[i8 >> 2] | 0) >>> 0) {
   i10 = HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0;
   HEAP32[i9 >> 2] = i10;
   i6 = HEAP32[i10 + 16 >> 2] | 0;
   HEAP32[i7 >> 2] = i6;
   i10 = HEAP32[i10 + 12 >> 2] | 0;
   i11 = HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0;
   HEAP32[i4 >> 2] = i6;
   HEAP32[i8 >> 2] = i6 + (Math_imul(i11, i10) | 0);
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i1 | 0));
 _cvFree_(i18);
 _cvFree_(i19);
 i10 = _cvGetErrStatus() | 0;
 i10 = (i10 | 0) < 0;
 i10 = i10 ? 0 : i16;
 STACKTOP = i21;
 return i10 | 0;
}

function __ZN2cvL14MulTransposedLIsdEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d31) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d31 = +d31;
 var d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 i25 = i32;
 i24 = i32 + 32 | 0;
 i29 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 16 >> 2] | 0;
 i30 = (HEAP32[i3 + 48 >> 2] | 0) >>> 1;
 i28 = (HEAP32[i1 + 48 >> 2] | 0) >>> 3;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i22 = (HEAP32[i2 + 48 >> 2] | 0) >>> 3; else i22 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i27 = HEAP32[i3 + 40 >> 2] | 0;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i27 = HEAP32[i27 >> 2] | 0;
 if (!i23) {
  if ((i27 | 0) <= 0) {
   STACKTOP = i32;
   return;
  }
  i7 = i26 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i26 & -4;
  i10 = 0;
  while (1) {
   i1 = Math_imul(i10, i30) | 0;
   i5 = i10;
   do {
    i2 = Math_imul(i5, i30) | 0;
    if (i8) {
     i3 = 0;
     d4 = 0.0;
    } else {
     i3 = 0;
     d4 = 0.0;
     do {
      i21 = i3 | 1;
      i22 = i3 | 2;
      i23 = i3 | 3;
      d4 = d4 + (+(HEAP16[i29 + (i3 + i1 << 1) >> 1] | 0) * +(HEAP16[i29 + (i3 + i2 << 1) >> 1] | 0) + +(HEAP16[i29 + (i21 + i1 << 1) >> 1] | 0) * +(HEAP16[i29 + (i21 + i2 << 1) >> 1] | 0) + +(HEAP16[i29 + (i22 + i1 << 1) >> 1] | 0) * +(HEAP16[i29 + (i22 + i2 << 1) >> 1] | 0) + +(HEAP16[i29 + (i23 + i1 << 1) >> 1] | 0) * +(HEAP16[i29 + (i23 + i2 << 1) >> 1] | 0));
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i7 | 0));
     i3 = i9;
    }
    if ((i3 | 0) < (i26 | 0)) do {
     d4 = d4 + +(HEAP16[i29 + (i3 + i1 << 1) >> 1] | 0) * +(HEAP16[i29 + (i3 + i2 << 1) >> 1] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i26 | 0));
    HEAPF64[i6 + (i5 << 3) >> 3] = d4 * d31;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 3) | 0;
  }
  STACKTOP = i32;
  return;
 }
 i19 = (i2 | 0) == (i26 | 0) ? 4 : 0;
 i3 = i26 << 3;
 i20 = i24 + 8 | 0;
 HEAP32[i24 >> 2] = i20;
 i21 = i24 + 4 | 0;
 HEAP32[i21 >> 2] = 1032;
 if (i3 >>> 0 > 1032) {
  i18 = __Znaj(i3) | 0;
  HEAP32[i24 >> 2] = i18;
 } else i18 = i20;
 HEAP32[i21 >> 2] = i3;
 if ((i27 | 0) > 0) {
  i1 = (i2 | 0) < (i26 | 0);
  i11 = (i26 | 0) > 0;
  i12 = i25 + 24 | 0;
  i13 = i25 + 16 | 0;
  i14 = i25 + 8 | 0;
  i15 = i26 + -4 | 0;
  i16 = (i15 | 0) < 0;
  i2 = i15 >>> 2;
  i3 = Math_imul(i19, (i2 << 3) + 8 | 0) | 0;
  i2 = (i2 << 2) + 4 | 0;
  i17 = 0;
  while (1) {
   i7 = Math_imul(i17, i30) | 0;
   i9 = Math_imul(i17, i22) | 0;
   i8 = i23 + (i9 << 3) | 0;
   if (i1) if (i11) {
    i10 = 0;
    do {
     HEAPF64[i18 + (i10 << 3) >> 3] = +(HEAP16[i29 + (i10 + i7 << 1) >> 1] | 0) - +HEAPF64[i8 >> 3];
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17; else if (i11) {
    i10 = 0;
    do {
     HEAPF64[i18 + (i10 << 3) >> 3] = +(HEAP16[i29 + (i10 + i7 << 1) >> 1] | 0) - +HEAPF64[i23 + (i10 + i9 << 3) >> 3];
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17;
   do {
    i7 = Math_imul(i5, i30) | 0;
    i10 = i23 + ((Math_imul(i5, i22) | 0) << 3) | 0;
    if (i1) {
     d4 = +HEAPF64[i10 >> 3];
     HEAPF64[i12 >> 3] = d4;
     HEAPF64[i13 >> 3] = d4;
     HEAPF64[i14 >> 3] = d4;
     HEAPF64[i25 >> 3] = d4;
     i10 = i25;
    }
    if (i16) {
     i9 = 0;
     d4 = 0.0;
    } else {
     i8 = i10 + i3 | 0;
     i9 = 0;
     d4 = 0.0;
     while (1) {
      i35 = i9 | 1;
      i34 = i9 | 2;
      i33 = i9 | 3;
      d4 = d4 + (+HEAPF64[i18 + (i9 << 3) >> 3] * (+(HEAP16[i29 + (i9 + i7 << 1) >> 1] | 0) - +HEAPF64[i10 >> 3]) + +HEAPF64[i18 + (i35 << 3) >> 3] * (+(HEAP16[i29 + (i35 + i7 << 1) >> 1] | 0) - +HEAPF64[i10 + 8 >> 3]) + +HEAPF64[i18 + (i34 << 3) >> 3] * (+(HEAP16[i29 + (i34 + i7 << 1) >> 1] | 0) - +HEAPF64[i10 + 16 >> 3]) + +HEAPF64[i18 + (i33 << 3) >> 3] * (+(HEAP16[i29 + (i33 + i7 << 1) >> 1] | 0) - +HEAPF64[i10 + 24 >> 3]));
      i9 = i9 + 4 | 0;
      if ((i9 | 0) > (i15 | 0)) break; else i10 = i10 + (i19 << 3) | 0;
     }
     i9 = i2;
     i10 = i8;
    }
    if ((i9 | 0) < (i26 | 0)) while (1) {
     d4 = d4 + +HEAPF64[i18 + (i9 << 3) >> 3] * (+(HEAP16[i29 + (i9 + i7 << 1) >> 1] | 0) - +HEAPF64[i10 >> 3]);
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i26 | 0)) break; else i10 = i10 + 8 | 0;
    }
    HEAPF64[i6 + (i5 << 3) >> 3] = d4 * d31;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i17 = i17 + 1 | 0;
   if ((i17 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 3) | 0;
  }
 }
 if ((i18 | 0) == (i20 | 0)) {
  STACKTOP = i32;
  return;
 }
 __ZdaPv(i18);
 HEAP32[i24 >> 2] = i20;
 HEAP32[i21 >> 2] = 1032;
 STACKTOP = i32;
 return;
}

function __ZN2cv11setIdentityERKNS_17_InputOutputArrayERKNS_7Scalar_IdEE(i2, i9) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, f8 = Math_fround(0), i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i3 = i14 + 144 | 0;
 i13 = i14 + 88 | 0;
 i7 = i14;
 i12 = i14 + 32 | 0;
 if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] & 127](i2, -1) | 0) >= 3) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i6 = (__ZN2cv6String8allocateEj(i3, 14) | 0) + 0 | 0;
  i5 = 31408;
  i1 = i6 + 14 | 0;
  do {
   HEAP8[i6 >> 0] = HEAP8[i5 >> 0] | 0;
   i6 = i6 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i6 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 31424, 27528, 2797);
  __ZN2cv6String10deallocateEv(i3);
 }
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i2 >> 2] >> 2] & 63](i13, i2, -1);
 i10 = HEAP32[i13 + 8 >> 2] | 0;
 i11 = HEAP32[i13 + 12 >> 2] | 0;
 i3 = HEAP32[i13 >> 2] & 4095;
 L4 : do if ((i3 | 0) == 5) {
  i3 = HEAP32[i13 + 16 >> 2] | 0;
  f8 = Math_fround(+HEAPF64[i9 >> 3]);
  i7 = (HEAP32[i13 + 48 >> 2] | 0) >>> 2;
  if ((i10 | 0) > 0) {
   if ((i11 | 0) <= 0) {
    i2 = 0;
    while (1) {
     if ((i2 | 0) < (i11 | 0)) HEAPF32[i3 + (i2 << 2) >> 2] = f8;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i10 | 0)) break L4; else i3 = i3 + (i7 << 2) | 0;
    }
   }
   i6 = i7 << 2;
   i5 = i11 << 2;
   i2 = i3;
   i1 = 0;
   while (1) {
    _memset(i3 + (Math_imul(i6, i1) | 0) | 0, 0, i5 | 0) | 0;
    if ((i1 | 0) < (i11 | 0)) HEAPF32[i2 + (i1 << 2) >> 2] = f8;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i10 | 0)) break; else i2 = i2 + (i7 << 2) | 0;
   }
  }
 } else if ((i3 | 0) == 6) {
  d4 = +HEAPF64[i9 >> 3];
  i3 = (HEAP32[i13 + 48 >> 2] | 0) >>> 3;
  if ((i10 | 0) > 0) {
   i2 = (i11 | 0) > 0;
   i1 = HEAP32[i13 + 16 >> 2] | 0;
   i5 = 0;
   while (1) {
    if (i2) {
     i6 = 0;
     do {
      HEAPF64[i1 + (i6 << 3) >> 3] = (i6 | 0) == (i5 | 0) ? d4 : 0.0;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i11 | 0));
    }
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i10 | 0)) break; else i1 = i1 + (i3 << 3) | 0;
   }
  }
 } else {
  HEAP32[i7 + 0 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAP32[i7 + 20 >> 2] = 0;
  HEAP32[i7 + 24 >> 2] = 0;
  HEAP32[i7 + 28 >> 2] = 0;
  __ZN2cv3MataSERKNS_7Scalar_IdEE(i13, i7) | 0;
  __ZNK2cv3Mat4diagEi(i12, i13, 0);
  __ZN2cv3MataSERKNS_7Scalar_IdEE(i12, i9) | 0;
  i1 = i12 + 36 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i10 = i2 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2) {
    i3 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i3) {
     i3 = HEAP32[i12 + 32 >> 2] | 0;
     if (!i3) {
      if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
       i11 = __Znwj(4) | 0;
       HEAP32[i11 >> 2] = 32784;
       HEAP32[6904] = i11;
       ___cxa_guard_release(27624);
      }
      i3 = HEAP32[6904] | 0;
      i2 = HEAP32[i1 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3, i2);
   }
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  i11 = i12 + 16 | 0;
  i3 = i12 + 4 | 0;
  HEAP32[i11 + 0 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i12 + 40 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i1 = HEAP32[i12 + 44 >> 2] | 0;
  if ((i1 | 0) != (i12 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 } while (0);
 i3 = i13 + 36 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i10 = i1 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2) {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i13 + 32 >> 2] | 0;
    if (!i1) {
     if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
      i11 = __Znwj(4) | 0;
      HEAP32[i11 >> 2] = 32784;
      HEAP32[6904] = i11;
      ___cxa_guard_release(27624);
     }
     i1 = HEAP32[6904] | 0;
     i2 = HEAP32[i3 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i2);
  }
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 i11 = i13 + 16 | 0;
 i2 = i13 + 4 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i13 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i13 + 44 >> 2] | 0;
 if ((i1 | 0) == (i13 + 48 | 0)) {
  STACKTOP = i14;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i14;
 return;
}

function __ZNK12_GLOBAL__N_118CLAHE_CalcLut_BodyItLi4096ELi4EEclERKN2cv5RangeE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 16464 | 0;
 i31 = i32 + 16440 | 0;
 i29 = i32 + 16384 | 0;
 i30 = i32;
 i2 = HEAP32[i1 >> 2] | 0;
 i28 = (HEAP32[i3 + 108 >> 2] | 0) >>> 1;
 i27 = i1 + 4 | 0;
 if ((i2 | 0) >= (HEAP32[i27 >> 2] | 0)) {
  STACKTOP = i32;
  return;
 }
 i10 = Math_imul(HEAP32[HEAP32[i3 + 104 >> 2] >> 2] | 0, i2) | 0;
 i11 = i3 + 124 | 0;
 i12 = i3 + 116 | 0;
 i13 = i3 + 120 | 0;
 i14 = i31 + 4 | 0;
 i15 = i31 + 8 | 0;
 i16 = i31 + 12 | 0;
 i17 = i3 + 4 | 0;
 i18 = i3 + 52 | 0;
 i19 = i29 + 16 | 0;
 i20 = i29 + 44 | 0;
 i21 = i3 + 128 | 0;
 i22 = i3 + 132 | 0;
 i23 = i29 + 36 | 0;
 i24 = i29 + 4 | 0;
 i25 = i29 + 40 | 0;
 i26 = i29 + 48 | 0;
 i10 = (HEAP32[i3 + 76 >> 2] | 0) + i10 | 0;
 while (1) {
  i4 = HEAP32[i11 >> 2] | 0;
  HEAP32[i31 + 0 >> 2] = 0;
  HEAP32[i31 + 4 >> 2] = 0;
  HEAP32[i31 + 8 >> 2] = 0;
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i31 >> 2] = Math_imul(i1, (i2 | 0) % (i4 | 0) | 0) | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  HEAP32[i14 >> 2] = Math_imul(i3, (i2 | 0) / (i4 | 0) | 0) | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i16 >> 2] = i3;
  __ZN2cv3MatC2ERKS0_RKNS_5Rect_IiEE(i29, i17, i31);
  _memset(i30 | 0, 0, 16384) | 0;
  i3 = HEAP32[i16 >> 2] | 0;
  i1 = (HEAP32[i18 >> 2] | 0) >>> 1;
  i4 = HEAP32[i19 >> 2] | 0;
  i6 = i3 + -1 | 0;
  L6 : do if (i3) {
   i9 = HEAP32[i15 >> 2] | 0;
   i7 = i9 + -4 | 0;
   if ((i7 | 0) < 0) while (1) {
    if ((i9 | 0) > 0) {
     i3 = 0;
     do {
      i7 = i30 + ((HEAPU16[i4 + (i3 << 1) >> 1] | 0) >>> 4 << 2) | 0;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i9 | 0));
    }
    if (!i6) break L6; else {
     i6 = i6 + -1 | 0;
     i4 = i4 + (i1 << 1) | 0;
    }
   }
   i3 = i9 & -4;
   while (1) {
    i8 = 0;
    do {
     i33 = HEAPU16[i4 + ((i8 | 1) << 1) >> 1] | 0;
     i34 = i30 + ((HEAPU16[i4 + (i8 << 1) >> 1] | 0) >>> 4 << 2) | 0;
     HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 1;
     i33 = i30 + (i33 >>> 4 << 2) | 0;
     HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + 1;
     i33 = HEAPU16[i4 + ((i8 | 3) << 1) >> 1] | 0;
     i34 = i30 + ((HEAPU16[i4 + ((i8 | 2) << 1) >> 1] | 0) >>> 4 << 2) | 0;
     HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 1;
     i33 = i30 + (i33 >>> 4 << 2) | 0;
     HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + 1;
     i8 = i8 + 4 | 0;
    } while ((i8 | 0) <= (i7 | 0));
    if ((i3 | 0) < (i9 | 0)) {
     i8 = i3;
     do {
      i33 = i30 + ((HEAPU16[i4 + (i8 << 1) >> 1] | 0) >>> 4 << 2) | 0;
      HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + 1;
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) != (i9 | 0));
    }
    if (!i6) break; else {
     i6 = i6 + -1 | 0;
     i4 = i4 + (i1 << 1) | 0;
    }
   }
  } while (0);
  i6 = HEAP32[i21 >> 2] | 0;
  if ((i6 | 0) > 0) {
   i1 = 0;
   i8 = 0;
   while (1) {
    i4 = i30 + (i8 << 2) | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if ((i3 | 0) > (i6 | 0)) {
     HEAP32[i4 >> 2] = i6;
     i7 = i3 + i1 - i6 | 0;
    } else i7 = i1;
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == 4096) break; else i1 = i7;
   }
   i3 = (i7 | 0) / 4096 | 0;
   i1 = i3 << 12;
   i4 = 0;
   do {
    i6 = i30 + (i4 << 2) | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i3;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != 4096);
   if ((i7 - i1 | 0) > 0) {
    i1 = i7 - (i3 << 12) | 0;
    i3 = 0;
    do {
     i4 = i30 + (i3 << 2) | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i1 | 0));
   }
  }
  f5 = Math_fround(HEAPF32[i22 >> 2]);
  i4 = 0;
  i1 = 0;
  do {
   i1 = (HEAP32[i30 + (i4 << 2) >> 2] | 0) + i1 | 0;
   i3 = _lrint(+Math_fround(f5 * Math_fround(i1 | 0))) | 0;
   if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
   HEAP16[i10 + (i4 << 1) >> 1] = i3;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != 4096);
  i1 = HEAP32[i23 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i3 = i1 + 12 | 0, i1 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i29);
  HEAP32[i23 >> 2] = 0;
  HEAP32[i19 + 0 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  HEAP32[i19 + 12 >> 2] = 0;
  if ((HEAP32[i24 >> 2] | 0) > 0) {
   i1 = HEAP32[i25 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i24 >> 2] | 0));
  }
  i1 = HEAP32[i20 >> 2] | 0;
  if ((i1 | 0) != (i26 | 0)) __ZN2cv8fastFreeEPv(i1);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (HEAP32[i27 >> 2] | 0)) break; else i10 = i10 + (i28 << 1) | 0;
 }
 STACKTOP = i32;
 return;
}

function __ZN2cvL14MulTransposedLIhdEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d31) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d31 = +d31;
 var d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 i25 = i32;
 i24 = i32 + 32 | 0;
 i29 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 16 >> 2] | 0;
 i30 = HEAP32[i3 + 48 >> 2] | 0;
 i28 = (HEAP32[i1 + 48 >> 2] | 0) >>> 3;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i22 = (HEAP32[i2 + 48 >> 2] | 0) >>> 3; else i22 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i27 = HEAP32[i3 + 40 >> 2] | 0;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i27 = HEAP32[i27 >> 2] | 0;
 if (!i23) {
  if ((i27 | 0) <= 0) {
   STACKTOP = i32;
   return;
  }
  i7 = i26 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i26 & -4;
  i10 = 0;
  while (1) {
   i1 = Math_imul(i10, i30) | 0;
   i5 = i10;
   do {
    i2 = Math_imul(i5, i30) | 0;
    if (i8) {
     i3 = 0;
     d4 = 0.0;
    } else {
     i3 = 0;
     d4 = 0.0;
     do {
      i21 = i3 | 1;
      i22 = i3 | 2;
      i23 = i3 | 3;
      d4 = d4 + (+(HEAPU8[i29 + (i3 + i1) >> 0] | 0) * +(HEAPU8[i29 + (i3 + i2) >> 0] | 0 | 0) + +(HEAPU8[i29 + (i21 + i1) >> 0] | 0) * +(HEAPU8[i29 + (i21 + i2) >> 0] | 0 | 0) + +(HEAPU8[i29 + (i22 + i1) >> 0] | 0) * +(HEAPU8[i29 + (i22 + i2) >> 0] | 0 | 0) + +(HEAPU8[i29 + (i23 + i1) >> 0] | 0) * +(HEAPU8[i29 + (i23 + i2) >> 0] | 0 | 0));
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i7 | 0));
     i3 = i9;
    }
    if ((i3 | 0) < (i26 | 0)) do {
     d4 = d4 + +(HEAPU8[i29 + (i3 + i1) >> 0] | 0) * +(HEAPU8[i29 + (i3 + i2) >> 0] | 0 | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i26 | 0));
    HEAPF64[i6 + (i5 << 3) >> 3] = d4 * d31;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 3) | 0;
  }
  STACKTOP = i32;
  return;
 }
 i19 = (i2 | 0) == (i26 | 0) ? 4 : 0;
 i3 = i26 << 3;
 i20 = i24 + 8 | 0;
 HEAP32[i24 >> 2] = i20;
 i21 = i24 + 4 | 0;
 HEAP32[i21 >> 2] = 1032;
 if (i3 >>> 0 > 1032) {
  i18 = __Znaj(i3) | 0;
  HEAP32[i24 >> 2] = i18;
 } else i18 = i20;
 HEAP32[i21 >> 2] = i3;
 if ((i27 | 0) > 0) {
  i13 = (i2 | 0) < (i26 | 0);
  i14 = (i26 | 0) > 0;
  i15 = i25 + 24 | 0;
  i16 = i25 + 16 | 0;
  i3 = i25 + 8 | 0;
  i2 = i26 + -4 | 0;
  i1 = (i2 | 0) < 0;
  i12 = i2 >>> 2;
  i11 = Math_imul(i19, (i12 << 3) + 8 | 0) | 0;
  i12 = (i12 << 2) + 4 | 0;
  i17 = 0;
  while (1) {
   i7 = Math_imul(i17, i30) | 0;
   i9 = Math_imul(i17, i22) | 0;
   i8 = i23 + (i9 << 3) | 0;
   if (i13) if (i14) {
    i10 = 0;
    do {
     HEAPF64[i18 + (i10 << 3) >> 3] = +(HEAPU8[i29 + (i10 + i7) >> 0] | 0 | 0) - +HEAPF64[i8 >> 3];
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17; else if (i14) {
    i10 = 0;
    do {
     HEAPF64[i18 + (i10 << 3) >> 3] = +(HEAPU8[i29 + (i10 + i7) >> 0] | 0 | 0) - +HEAPF64[i23 + (i10 + i9 << 3) >> 3];
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17;
   do {
    i7 = Math_imul(i5, i30) | 0;
    i10 = i23 + ((Math_imul(i5, i22) | 0) << 3) | 0;
    if (i13) {
     d4 = +HEAPF64[i10 >> 3];
     HEAPF64[i15 >> 3] = d4;
     HEAPF64[i16 >> 3] = d4;
     HEAPF64[i3 >> 3] = d4;
     HEAPF64[i25 >> 3] = d4;
     i10 = i25;
    }
    if (i1) {
     i9 = 0;
     d4 = 0.0;
    } else {
     i8 = i10 + i11 | 0;
     i9 = 0;
     d4 = 0.0;
     while (1) {
      i35 = i9 | 1;
      i34 = i9 | 2;
      i33 = i9 | 3;
      d4 = d4 + (+HEAPF64[i18 + (i9 << 3) >> 3] * (+(HEAPU8[i29 + (i9 + i7) >> 0] | 0 | 0) - +HEAPF64[i10 >> 3]) + +HEAPF64[i18 + (i35 << 3) >> 3] * (+(HEAPU8[i29 + (i35 + i7) >> 0] | 0 | 0) - +HEAPF64[i10 + 8 >> 3]) + +HEAPF64[i18 + (i34 << 3) >> 3] * (+(HEAPU8[i29 + (i34 + i7) >> 0] | 0 | 0) - +HEAPF64[i10 + 16 >> 3]) + +HEAPF64[i18 + (i33 << 3) >> 3] * (+(HEAPU8[i29 + (i33 + i7) >> 0] | 0 | 0) - +HEAPF64[i10 + 24 >> 3]));
      i9 = i9 + 4 | 0;
      if ((i9 | 0) > (i2 | 0)) break; else i10 = i10 + (i19 << 3) | 0;
     }
     i9 = i12;
     i10 = i8;
    }
    if ((i9 | 0) < (i26 | 0)) while (1) {
     d4 = d4 + +HEAPF64[i18 + (i9 << 3) >> 3] * (+(HEAPU8[i29 + (i9 + i7) >> 0] | 0 | 0) - +HEAPF64[i10 >> 3]);
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i26 | 0)) break; else i10 = i10 + 8 | 0;
    }
    HEAPF64[i6 + (i5 << 3) >> 3] = d4 * d31;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i17 = i17 + 1 | 0;
   if ((i17 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 3) | 0;
  }
 }
 if ((i18 | 0) == (i20 | 0)) {
  STACKTOP = i32;
  return;
 }
 __ZdaPv(i18);
 HEAP32[i24 >> 2] = i20;
 HEAP32[i21 >> 2] = 1032;
 STACKTOP = i32;
 return;
}

function __ZN2cvL16GEMMBlockMul_64fEPKdjS1_jPdjNS_5Size_IiEES4_i(i17, i3, i32, i4, i12, i5, i1, i2, i7) {
 i17 = i17 | 0;
 i3 = i3 | 0;
 i32 = i32 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i6 = 0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, d34 = 0.0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 i31 = i33;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i30 = HEAP32[i2 >> 2] | 0;
 i27 = HEAP32[i2 + 4 >> 2] | 0;
 i28 = i31 + 8 | 0;
 HEAP32[i31 >> 2] = i28;
 i29 = i31 + 4 | 0;
 HEAP32[i29 >> 2] = 136;
 i2 = i7 & 16;
 i3 = i3 >>> 3;
 i26 = i4 >>> 3;
 i22 = i5 >>> 3;
 do if (i7 & 1) if (i1 >>> 0 > 136) {
  i24 = __Znaj(i1 >>> 0 > 536870911 ? -1 : i1 << 3) | 0;
  HEAP32[i31 >> 2] = i24;
  HEAP32[i29 >> 2] = i1;
  i23 = i24;
  i25 = 1;
  i21 = i3;
  break;
 } else {
  HEAP32[i29 >> 2] = i1;
  i23 = i28;
  i24 = i28;
  i25 = 1;
  i21 = i3;
  break;
 } else {
  i23 = i28;
  i24 = 0;
  i25 = i3;
  i21 = 1;
  i1 = i6;
 } while (0);
 i3 = (i27 | 0) > 0;
 if (!(i7 & 2)) {
  if (i3) {
   i3 = (i24 | 0) == 0;
   i14 = i30 + -4 | 0;
   i4 = (i14 | 0) < 0;
   i16 = (i2 | 0) == 0;
   i15 = (i1 | 0) > 0;
   i2 = i30 & -4;
   i13 = i3 | i15 ^ 1;
   i18 = 0;
   while (1) {
    if (i13) i19 = i3 ? i17 : i24; else {
     i6 = 0;
     do {
      HEAPF64[i24 + (i6 << 3) >> 3] = +HEAPF64[i17 + ((Math_imul(i6, i21) | 0) << 3) >> 3];
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i1 | 0));
     i19 = i24;
    }
    if (i4) i6 = 0; else {
     i20 = 0;
     do {
      if (i16) {
       d9 = 0.0;
       d11 = 0.0;
       d10 = 0.0;
       d8 = 0.0;
      } else {
       d9 = +HEAPF64[i12 + (i20 << 3) >> 3];
       d11 = +HEAPF64[i12 + ((i20 | 1) << 3) >> 3];
       d10 = +HEAPF64[i12 + ((i20 | 2) << 3) >> 3];
       d8 = +HEAPF64[i12 + ((i20 | 3) << 3) >> 3];
      }
      if (i15) {
       i7 = i32 + (i20 << 3) | 0;
       i6 = 0;
       while (1) {
        d34 = +HEAPF64[i19 + (i6 << 3) >> 3];
        d9 = d9 + d34 * +HEAPF64[i7 >> 3];
        d11 = d11 + d34 * +HEAPF64[i7 + 8 >> 3];
        d10 = d10 + d34 * +HEAPF64[i7 + 16 >> 3];
        d8 = d8 + d34 * +HEAPF64[i7 + 24 >> 3];
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i1 | 0)) break; else i7 = i7 + (i26 << 3) | 0;
       }
      }
      HEAPF64[i12 + (i20 << 3) >> 3] = d9;
      HEAPF64[i12 + ((i20 | 1) << 3) >> 3] = d11;
      HEAPF64[i12 + ((i20 | 2) << 3) >> 3] = d10;
      HEAPF64[i12 + ((i20 | 3) << 3) >> 3] = d8;
      i20 = i20 + 4 | 0;
     } while ((i20 | 0) <= (i14 | 0));
     i6 = i2;
    }
    if ((i6 | 0) < (i30 | 0)) do {
     if (i16) d8 = 0.0; else d8 = +HEAPF64[i12 + (i6 << 3) >> 3];
     if (i15) {
      i7 = i32 + (i6 << 3) | 0;
      i5 = 0;
      while (1) {
       d8 = d8 + +HEAPF64[i19 + (i5 << 3) >> 3] * +HEAPF64[i7 >> 3];
       i5 = i5 + 1 | 0;
       if ((i5 | 0) == (i1 | 0)) break; else i7 = i7 + (i26 << 3) | 0;
      }
     }
     HEAPF64[i12 + (i6 << 3) >> 3] = d8;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i30 | 0));
    i18 = i18 + 1 | 0;
    if ((i18 | 0) == (i27 | 0)) break; else {
     i12 = i12 + (i22 << 3) | 0;
     i17 = i17 + (i25 << 3) | 0;
    }
   }
  }
 } else if (i3) {
  i19 = (i24 | 0) == 0;
  i20 = (i30 | 0) > 0;
  i13 = (i2 | 0) == 0;
  i14 = i1 + -2 | 0;
  i15 = (i14 | 0) < 0;
  i16 = i1 & -2;
  i18 = i19 | (i1 | 0) < 1;
  i3 = i17;
  i2 = 0;
  while (1) {
   if (i18) i6 = i19 ? i3 : i24; else {
    i6 = 0;
    do {
     HEAPF64[i24 + (i6 << 3) >> 3] = +HEAPF64[i3 + ((Math_imul(i6, i21) | 0) << 3) >> 3];
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i1 | 0));
    i6 = i24;
   }
   if (i20) {
    i5 = i32;
    i4 = 0;
    while (1) {
     if (i13) d8 = 0.0; else d8 = +HEAPF64[i12 + (i4 << 3) >> 3];
     if (i15) {
      i7 = 0;
      d9 = 0.0;
     } else {
      i7 = 0;
      d9 = 0.0;
      do {
       d8 = d8 + +HEAPF64[i6 + (i7 << 3) >> 3] * +HEAPF64[i5 + (i7 << 3) >> 3];
       i17 = i7 | 1;
       d9 = d9 + +HEAPF64[i6 + (i17 << 3) >> 3] * +HEAPF64[i5 + (i17 << 3) >> 3];
       i7 = i7 + 2 | 0;
      } while ((i7 | 0) <= (i14 | 0));
      i7 = i16;
     }
     if ((i7 | 0) < (i1 | 0)) do {
      d8 = d8 + +HEAPF64[i6 + (i7 << 3) >> 3] * +HEAPF64[i5 + (i7 << 3) >> 3];
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) != (i1 | 0));
     HEAPF64[i12 + (i4 << 3) >> 3] = d9 + d8;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i30 | 0)) break; else i5 = i5 + (i26 << 3) | 0;
    }
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i27 | 0)) break; else {
    i12 = i12 + (i22 << 3) | 0;
    i3 = i3 + (i25 << 3) | 0;
   }
  }
 }
 if ((i23 | 0) == (i28 | 0)) {
  STACKTOP = i33;
  return;
 }
 __ZdaPv(i23);
 HEAP32[i31 >> 2] = i28;
 HEAP32[i29 >> 2] = 136;
 STACKTOP = i33;
 return;
}

function __ZNSt3__16locale5__impC2Ej(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 HEAP32[i4 + 4 >> 2] = i1 + -1;
 HEAP32[i4 >> 2] = 960648;
 i1 = i4 + 8 | 0;
 __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC2Ej(i1, 28);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4 + 144 | 0, 960632, 1);
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i4 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 HEAP32[241385] = 0;
 HEAP32[241384] = 959096;
 __ZNSt3__16locale5__imp7installINS_7collateIcEEEEvPT_(i4, 965536);
 HEAP32[241383] = 0;
 HEAP32[241382] = 959136;
 __ZNSt3__16locale5__imp7installINS_7collateIwEEEEvPT_(i4, 965528);
 __ZNSt3__15ctypeIcEC2EPKtbj(965512, 0, 0, 1);
 __ZNSt3__16locale5__imp7installINS_5ctypeIcEEEEvPT_(i4, 965512);
 HEAP32[241377] = 0;
 HEAP32[241376] = 961704;
 __ZNSt3__16locale5__imp7installINS_5ctypeIwEEEEvPT_(i4, 965504);
 HEAP32[241375] = 0;
 HEAP32[241374] = 961920;
 __ZNSt3__16locale5__imp7installINS_7codecvtIcc11__mbstate_tEEEEvPT_(i4, 965496);
 __ZNSt3__17codecvtIwc11__mbstate_tEC2Ej(965480, 1);
 __ZNSt3__16locale5__imp7installINS_7codecvtIwc11__mbstate_tEEEEvPT_(i4, 965480);
 HEAP32[241369] = 0;
 HEAP32[241368] = 962144;
 __ZNSt3__16locale5__imp7installINS_7codecvtIDsc11__mbstate_tEEEEvPT_(i4, 965472);
 HEAP32[241367] = 0;
 HEAP32[241366] = 962264;
 __ZNSt3__16locale5__imp7installINS_7codecvtIDic11__mbstate_tEEEEvPT_(i4, 965464);
 HEAP32[241361] = 0;
 HEAP32[241360] = 960896;
 HEAP8[965448] = 46;
 HEAP8[965449] = 44;
 HEAP32[241363] = 0;
 HEAP32[241364] = 0;
 HEAP32[241365] = 0;
 __ZNSt3__16locale5__imp7installINS_8numpunctIcEEEEvPT_(i4, 965440);
 HEAP32[241353] = 0;
 HEAP32[241352] = 960936;
 HEAP32[241354] = 46;
 HEAP32[241355] = 44;
 HEAP32[241356] = 0;
 HEAP32[241357] = 0;
 HEAP32[241358] = 0;
 __ZNSt3__16locale5__imp7installINS_8numpunctIwEEEEvPT_(i4, 965408);
 HEAP32[241351] = 0;
 HEAP32[241350] = 959176;
 __ZNSt3__16locale5__imp7installINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i4, 965400);
 HEAP32[241349] = 0;
 HEAP32[241348] = 959296;
 __ZNSt3__16locale5__imp7installINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i4, 965392);
 HEAP32[241347] = 0;
 HEAP32[241346] = 959368;
 __ZNSt3__16locale5__imp7installINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i4, 965384);
 HEAP32[241345] = 0;
 HEAP32[241344] = 959464;
 __ZNSt3__16locale5__imp7installINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i4, 965376);
 HEAP32[241343] = 0;
 HEAP32[241342] = 960056;
 __ZNSt3__16locale5__imp7installINS_10moneypunctIcLb0EEEEEvPT_(i4, 965368);
 HEAP32[241341] = 0;
 HEAP32[241340] = 960120;
 __ZNSt3__16locale5__imp7installINS_10moneypunctIcLb1EEEEEvPT_(i4, 965360);
 HEAP32[241339] = 0;
 HEAP32[241338] = 960184;
 __ZNSt3__16locale5__imp7installINS_10moneypunctIwLb0EEEEEvPT_(i4, 965352);
 HEAP32[241337] = 0;
 HEAP32[241336] = 960248;
 __ZNSt3__16locale5__imp7installINS_10moneypunctIwLb1EEEEEvPT_(i4, 965344);
 HEAP32[241335] = 0;
 HEAP32[241334] = 960312;
 __ZNSt3__16locale5__imp7installINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i4, 965336);
 HEAP32[241333] = 0;
 HEAP32[241332] = 960392;
 __ZNSt3__16locale5__imp7installINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i4, 965328);
 HEAP32[241331] = 0;
 HEAP32[241330] = 960448;
 __ZNSt3__16locale5__imp7installINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i4, 965320);
 HEAP32[241329] = 0;
 HEAP32[241328] = 960496;
 __ZNSt3__16locale5__imp7installINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i4, 965312);
 HEAP32[241325] = 0;
 HEAP32[241324] = 959544;
 HEAP32[241326] = 959592;
 __ZNSt3__16locale5__imp7installINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i4, 965296);
 HEAP32[241321] = 0;
 HEAP32[241320] = 959696;
 HEAP32[241322] = 959744;
 __ZNSt3__16locale5__imp7installINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i4, 965280);
 HEAP32[241317] = 0;
 HEAP32[241316] = 961640;
 HEAP32[241318] = __ZNSt3__16__clocEv() | 0;
 HEAP32[241316] = 959992;
 __ZNSt3__16locale5__imp7installINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i4, 965264);
 HEAP32[241313] = 0;
 HEAP32[241312] = 961640;
 HEAP32[241314] = __ZNSt3__16__clocEv() | 0;
 HEAP32[241312] = 960024;
 __ZNSt3__16locale5__imp7installINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i4, 965248);
 HEAP32[241311] = 0;
 HEAP32[241310] = 960536;
 __ZNSt3__16locale5__imp7installINS_8messagesIcEEEEvPT_(i4, 965240);
 HEAP32[241309] = 0;
 HEAP32[241308] = 960576;
 __ZNSt3__16locale5__imp7installINS_8messagesIwEEEEvPT_(i4, 965232);
 STACKTOP = i5;
 return;
}

function __ZN2cvL14MulTransposedLIddEEvRKNS_3MatERS1_S3_d(i3, i1, i2, d31) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d31 = +d31;
 var d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 i25 = i32;
 i24 = i32 + 32 | 0;
 i29 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 16 >> 2] | 0;
 i30 = (HEAP32[i3 + 48 >> 2] | 0) >>> 3;
 i28 = (HEAP32[i1 + 48 >> 2] | 0) >>> 3;
 if ((HEAP32[i2 + 8 >> 2] | 0) > 1) i22 = (HEAP32[i2 + 48 >> 2] | 0) >>> 3; else i22 = 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i27 = HEAP32[i3 + 40 >> 2] | 0;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i27 = HEAP32[i27 >> 2] | 0;
 if (!i23) {
  if ((i27 | 0) <= 0) {
   STACKTOP = i32;
   return;
  }
  i7 = i26 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i26 & -4;
  i10 = 0;
  while (1) {
   i1 = Math_imul(i10, i30) | 0;
   i5 = i10;
   do {
    i2 = Math_imul(i5, i30) | 0;
    if (i8) {
     i3 = 0;
     d4 = 0.0;
    } else {
     i3 = 0;
     d4 = 0.0;
     do {
      i21 = i3 | 1;
      i22 = i3 | 2;
      i23 = i3 | 3;
      d4 = d4 + (+HEAPF64[i29 + (i3 + i1 << 3) >> 3] * +HEAPF64[i29 + (i3 + i2 << 3) >> 3] + +HEAPF64[i29 + (i21 + i1 << 3) >> 3] * +HEAPF64[i29 + (i21 + i2 << 3) >> 3] + +HEAPF64[i29 + (i22 + i1 << 3) >> 3] * +HEAPF64[i29 + (i22 + i2 << 3) >> 3] + +HEAPF64[i29 + (i23 + i1 << 3) >> 3] * +HEAPF64[i29 + (i23 + i2 << 3) >> 3]);
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) <= (i7 | 0));
     i3 = i9;
    }
    if ((i3 | 0) < (i26 | 0)) do {
     d4 = d4 + +HEAPF64[i29 + (i3 + i1 << 3) >> 3] * +HEAPF64[i29 + (i3 + i2 << 3) >> 3];
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i26 | 0));
    HEAPF64[i6 + (i5 << 3) >> 3] = d4 * d31;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 3) | 0;
  }
  STACKTOP = i32;
  return;
 }
 i19 = (i2 | 0) == (i26 | 0) ? 4 : 0;
 i3 = i26 << 3;
 i20 = i24 + 8 | 0;
 HEAP32[i24 >> 2] = i20;
 i21 = i24 + 4 | 0;
 HEAP32[i21 >> 2] = 1032;
 if (i3 >>> 0 > 1032) {
  i18 = __Znaj(i3) | 0;
  HEAP32[i24 >> 2] = i18;
 } else i18 = i20;
 HEAP32[i21 >> 2] = i3;
 if ((i27 | 0) > 0) {
  i3 = (i2 | 0) < (i26 | 0);
  i2 = (i26 | 0) > 0;
  i1 = i25 + 24 | 0;
  i11 = i25 + 16 | 0;
  i12 = i25 + 8 | 0;
  i13 = i26 + -4 | 0;
  i14 = (i13 | 0) < 0;
  i16 = i13 >>> 2;
  i15 = Math_imul(i19, (i16 << 3) + 8 | 0) | 0;
  i16 = (i16 << 2) + 4 | 0;
  i17 = 0;
  while (1) {
   i7 = Math_imul(i17, i30) | 0;
   i9 = Math_imul(i17, i22) | 0;
   i8 = i23 + (i9 << 3) | 0;
   if (i3) if (i2) {
    i10 = 0;
    do {
     HEAPF64[i18 + (i10 << 3) >> 3] = +HEAPF64[i29 + (i10 + i7 << 3) >> 3] - +HEAPF64[i8 >> 3];
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17; else if (i2) {
    i10 = 0;
    do {
     HEAPF64[i18 + (i10 << 3) >> 3] = +HEAPF64[i29 + (i10 + i7 << 3) >> 3] - +HEAPF64[i23 + (i10 + i9 << 3) >> 3];
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i26 | 0));
    i5 = i17;
   } else i5 = i17;
   do {
    i7 = Math_imul(i5, i30) | 0;
    i10 = i23 + ((Math_imul(i5, i22) | 0) << 3) | 0;
    if (i3) {
     d4 = +HEAPF64[i10 >> 3];
     HEAPF64[i1 >> 3] = d4;
     HEAPF64[i11 >> 3] = d4;
     HEAPF64[i12 >> 3] = d4;
     HEAPF64[i25 >> 3] = d4;
     i10 = i25;
    }
    if (i14) {
     i9 = 0;
     d4 = 0.0;
    } else {
     i8 = i10 + i15 | 0;
     i9 = 0;
     d4 = 0.0;
     while (1) {
      i35 = i9 | 1;
      i34 = i9 | 2;
      i33 = i9 | 3;
      d4 = d4 + (+HEAPF64[i18 + (i9 << 3) >> 3] * (+HEAPF64[i29 + (i9 + i7 << 3) >> 3] - +HEAPF64[i10 >> 3]) + +HEAPF64[i18 + (i35 << 3) >> 3] * (+HEAPF64[i29 + (i35 + i7 << 3) >> 3] - +HEAPF64[i10 + 8 >> 3]) + +HEAPF64[i18 + (i34 << 3) >> 3] * (+HEAPF64[i29 + (i34 + i7 << 3) >> 3] - +HEAPF64[i10 + 16 >> 3]) + +HEAPF64[i18 + (i33 << 3) >> 3] * (+HEAPF64[i29 + (i33 + i7 << 3) >> 3] - +HEAPF64[i10 + 24 >> 3]));
      i9 = i9 + 4 | 0;
      if ((i9 | 0) > (i13 | 0)) break; else i10 = i10 + (i19 << 3) | 0;
     }
     i9 = i16;
     i10 = i8;
    }
    if ((i9 | 0) < (i26 | 0)) while (1) {
     d4 = d4 + +HEAPF64[i18 + (i9 << 3) >> 3] * (+HEAPF64[i29 + (i9 + i7 << 3) >> 3] - +HEAPF64[i10 >> 3]);
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i26 | 0)) break; else i10 = i10 + 8 | 0;
    }
    HEAPF64[i6 + (i5 << 3) >> 3] = d4 * d31;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i27 | 0));
   i17 = i17 + 1 | 0;
   if ((i17 | 0) == (i27 | 0)) break; else i6 = i6 + (i28 << 3) | 0;
  }
 }
 if ((i18 | 0) == (i20 | 0)) {
  STACKTOP = i32;
  return;
 }
 __ZdaPv(i18);
 HEAP32[i24 >> 2] = i20;
 HEAP32[i21 >> 2] = 1032;
 STACKTOP = i32;
 return;
}

function __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i11, i12, i13, i10, i6) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 i2 = HEAP32[i11 >> 2] | 0;
 do if (i2) {
  i3 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) == -1) {
   HEAP32[i11 >> 2] = 0;
   i1 = 1;
   break;
  } else {
   i1 = (HEAP32[i11 >> 2] | 0) == 0;
   break;
  }
 } else i1 = 1; while (0);
 i2 = HEAP32[i12 >> 2] | 0;
 do if (i2) {
  i3 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i3 >> 2] | 0;
  if ((i3 | 0) != -1) if (i1) {
   i5 = i2;
   break;
  } else {
   i14 = 16;
   break;
  } else {
   HEAP32[i12 >> 2] = 0;
   i14 = 14;
   break;
  }
 } else i14 = 14; while (0);
 if ((i14 | 0) == 14) if (i1) i14 = 16; else i5 = 0;
 if ((i14 | 0) == 16) {
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 6;
  i10 = 0;
  STACKTOP = i15;
  return i10 | 0;
 }
 i3 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0; else i2 = HEAP32[i2 >> 2] | 0;
 if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] & 63](i10, 2048, i2) | 0)) {
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 4;
  i10 = 0;
  STACKTOP = i15;
  return i10 | 0;
 }
 i3 = (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i10 >> 2] | 0) + 52 >> 2] & 63](i10, i2, 0) | 0) << 24 >> 24;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = i2 + 12 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
  FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
  i4 = i6;
  i7 = i5;
  i2 = i5;
 } else {
  HEAP32[i1 >> 2] = i4 + 4;
  i4 = i6;
  i7 = i5;
  i2 = i5;
 }
 while (1) {
  i1 = i3 + -48 | 0;
  i9 = i4 + -1 | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  do if (i4) {
   i3 = HEAP32[i4 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) == -1) {
    HEAP32[i11 >> 2] = 0;
    i5 = 1;
    break;
   } else {
    i5 = (HEAP32[i11 >> 2] | 0) == 0;
    break;
   }
  } else i5 = 1; while (0);
  do if (i2) {
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAP32[i4 >> 2] | 0;
   if ((i3 | 0) == -1) {
    HEAP32[i12 >> 2] = 0;
    i8 = 0;
    i6 = 0;
    i4 = 1;
    break;
   } else {
    i8 = i7;
    i6 = i7;
    i4 = (i7 | 0) == 0;
    break;
   }
  } else {
   i8 = i7;
   i6 = 0;
   i4 = 1;
  } while (0);
  i3 = HEAP32[i11 >> 2] | 0;
  if (!((i5 ^ i4) & (i9 | 0) > 0)) break;
  i4 = HEAP32[i3 + 12 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0; else i3 = HEAP32[i4 >> 2] | 0;
  if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] & 63](i10, 2048, i3) | 0)) {
   i14 = 63;
   break;
  }
  i3 = ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i10 >> 2] | 0) + 52 >> 2] & 63](i10, i3, 0) | 0) << 24 >> 24) + (i1 * 10 | 0) | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = i4 + 12 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] & 127](i4) | 0;
   i4 = i9;
   i7 = i8;
   i2 = i6;
   continue;
  } else {
   HEAP32[i2 >> 2] = i1 + 4;
   i4 = i9;
   i7 = i8;
   i2 = i6;
   continue;
  }
 }
 if ((i14 | 0) == 63) {
  STACKTOP = i15;
  return i1 | 0;
 }
 do if (i3) {
  i2 = HEAP32[i3 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0; else i2 = HEAP32[i2 >> 2] | 0;
  if ((i2 | 0) == -1) {
   HEAP32[i11 >> 2] = 0;
   i3 = 1;
   break;
  } else {
   i3 = (HEAP32[i11 >> 2] | 0) == 0;
   break;
  }
 } else i3 = 1; while (0);
 do if (i8) {
  i2 = HEAP32[i8 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i8 + 16 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] & 127](i8) | 0; else i2 = HEAP32[i2 >> 2] | 0;
  if ((i2 | 0) == -1) {
   HEAP32[i12 >> 2] = 0;
   i14 = 60;
   break;
  }
  if (i3) {
   i10 = i1;
   STACKTOP = i15;
   return i10 | 0;
  }
 } else i14 = 60; while (0);
 if ((i14 | 0) == 60 ? !i3 : 0) {
  i10 = i1;
  STACKTOP = i15;
  return i10 | 0;
 }
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 2;
 i10 = i1;
 STACKTOP = i15;
 return i10 | 0;
}
function __ZN7testing8internal15UnitTestOptions17FilterMatchesTestERKNSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEESA_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i9 = i12 + 60 | 0;
 i5 = i12 + 48 | 0;
 i11 = i12 + 36 | 0;
 i10 = i12 + 24 | 0;
 i6 = i12 + 12 | 0;
 i7 = i12;
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i2 = HEAP8[i3 >> 0] | 0;
 if (!(i2 & 1)) {
  i1 = (i2 & 255) >>> 1;
  i2 = i3 + 1 | 0;
 } else {
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i2 = HEAP32[i3 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, i2, i1, i1 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, 160488, 1) | 0;
 if (!(HEAP8[i4 >> 0] & 1)) i3 = i4 + 1 | 0; else i3 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i2 = HEAP8[i5 >> 0] | 0;
 if (!(i2 & 1)) {
  i4 = _strlen(i3 | 0) | 0;
  i2 = (i2 & 255) >>> 1;
  i1 = i5 + 1 | 0;
 } else {
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  i4 = _strlen(i3 | 0) | 0;
  i1 = HEAP32[i5 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, i1, i2, i2 + i4 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, i3, i4) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 i1 = (HEAP8[159880] & 1) == 0 ? 159881 | 0 : HEAP32[39972] | 0;
 i5 = _strchr(i1, 45) | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 if (i5) {
  i4 = i5 - i1 | 0;
  if (i4 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  if (i4 >>> 0 < 11) {
   HEAP8[i6 >> 0] = i4 << 1;
   i2 = i6 + 1 | 0;
  } else {
   i3 = i4 + 16 & -16;
   i2 = __Znwj(i3) | 0;
   HEAP32[i6 + 8 >> 2] = i2;
   HEAP32[i6 >> 2] = i3 | 1;
   HEAP32[i6 + 4 >> 2] = i4;
  }
  if ((i1 | 0) != (i5 | 0)) {
   i3 = i2;
   while (1) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) break; else i3 = i3 + 1 | 0;
   }
   i2 = i2 + i4 | 0;
  }
  HEAP8[i2 >> 0] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i11, i6) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
  i1 = i5 + 1 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i1, _strlen(i1 | 0) | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i10, i7) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
  i1 = HEAP8[i11 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i11 + 4 >> 2] | 0;
  if (!i1) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i11, 160496) | 0;
 } else {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i11, i1) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i10, 159968) | 0;
 }
 if (!(HEAP8[i11 >> 0] & 1)) i2 = i11 + 1 | 0; else i2 = HEAP32[i11 + 8 >> 2] | 0;
 i5 = (HEAP8[i9 >> 0] & 1) == 0;
 i3 = i9 + 1 | 0;
 i4 = i9 + 8 | 0;
 L38 : do if (i5) while (1) {
  if (__ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i2, i3) | 0) {
   i8 = 34;
   break L38;
  }
  i2 = _strchr(i2, 58) | 0;
  if (!i2) {
   i1 = 0;
   break;
  } else i2 = i2 + 1 | 0;
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  while (1) {
   if (__ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i2, i1) | 0) {
    i8 = 34;
    break L38;
   }
   i2 = _strchr(i2, 58) | 0;
   if (!i2) {
    i1 = 0;
    break;
   } else i2 = i2 + 1 | 0;
  }
 } while (0);
 L46 : do if ((i8 | 0) == 34) {
  if (!(HEAP8[i10 >> 0] & 1)) i1 = i10 + 1 | 0; else i1 = HEAP32[i10 + 8 >> 2] | 0;
  if (i5) while (1) {
   if (__ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i1, i3) | 0) {
    i1 = 0;
    break L46;
   }
   i1 = _strchr(i1, 58) | 0;
   if (!i1) {
    i1 = 1;
    break L46;
   } else i1 = i1 + 1 | 0;
  }
  i2 = HEAP32[i4 >> 2] | 0;
  while (1) {
   if (__ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i1, i2) | 0) {
    i1 = 0;
    break L46;
   }
   i1 = _strchr(i1, 58) | 0;
   if (!i1) {
    i1 = 1;
    break;
   } else i1 = i1 + 1 | 0;
  }
 } while (0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN2cv9Formatter3getEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 switch (i1 | 0) {
 case 5:
  {
   i5 = __Znwj(16) | 0;
   i1 = i5;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 8;
   HEAP32[i5 + 8 >> 2] = 16;
   HEAP32[i5 + 12 >> 2] = 1;
   HEAP32[i5 >> 2] = 6936;
   i1 = __Znwj(16) | 0;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i1 >> 2] = 7472;
   HEAP32[i1 + 8 >> 2] = i5;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i5;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i2 + -1;
   if ((i2 | 0) != 1) {
    STACKTOP = i3;
    return;
   }
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
   STACKTOP = i3;
   return;
  }
 case 2:
  {
   i5 = __Znwj(16) | 0;
   i1 = i5;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 8;
   HEAP32[i5 + 8 >> 2] = 16;
   HEAP32[i5 + 12 >> 2] = 1;
   HEAP32[i5 >> 2] = 8176;
   i1 = __Znwj(16) | 0;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i1 >> 2] = 8256;
   HEAP32[i1 + 8 >> 2] = i5;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i5;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i2 + -1;
   if ((i2 | 0) != 1) {
    STACKTOP = i3;
    return;
   }
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
   STACKTOP = i3;
   return;
  }
 case 0:
  {
   i5 = __Znwj(16) | 0;
   i1 = i5;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 8;
   HEAP32[i5 + 8 >> 2] = 16;
   HEAP32[i5 + 12 >> 2] = 1;
   HEAP32[i5 >> 2] = 8600;
   i1 = __Znwj(16) | 0;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i1 >> 2] = 8696;
   HEAP32[i1 + 8 >> 2] = i5;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i5;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i2 + -1;
   if ((i2 | 0) != 1) {
    STACKTOP = i3;
    return;
   }
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
   STACKTOP = i3;
   return;
  }
 case 3:
  {
   i5 = __Znwj(16) | 0;
   i1 = i5;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 8;
   HEAP32[i5 + 8 >> 2] = 16;
   HEAP32[i5 + 12 >> 2] = 1;
   HEAP32[i5 >> 2] = 7936;
   i1 = __Znwj(16) | 0;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i1 >> 2] = 8048;
   HEAP32[i1 + 8 >> 2] = i5;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i5;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i2 + -1;
   if ((i2 | 0) != 1) {
    STACKTOP = i3;
    return;
   }
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
   STACKTOP = i3;
   return;
  }
 case 1:
  {
   i5 = __Znwj(16) | 0;
   i1 = i5;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 8;
   HEAP32[i5 + 8 >> 2] = 16;
   HEAP32[i5 + 12 >> 2] = 1;
   HEAP32[i5 >> 2] = 8384;
   i1 = __Znwj(16) | 0;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i1 >> 2] = 8472;
   HEAP32[i1 + 8 >> 2] = i5;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i5;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i2 + -1;
   if ((i2 | 0) != 1) {
    STACKTOP = i3;
    return;
   }
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
   STACKTOP = i3;
   return;
  }
 case 4:
  {
   i5 = __Znwj(16) | 0;
   i1 = i5;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 8;
   HEAP32[i5 + 8 >> 2] = 16;
   HEAP32[i5 + 12 >> 2] = 1;
   HEAP32[i5 >> 2] = 7600;
   i1 = __Znwj(16) | 0;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i1 >> 2] = 7808;
   HEAP32[i1 + 8 >> 2] = i5;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i5;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i2 + -1;
   if ((i2 | 0) != 1) {
    STACKTOP = i3;
    return;
   }
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
   STACKTOP = i3;
   return;
  }
 default:
  {
   i5 = __Znwj(16) | 0;
   i1 = i5;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 8;
   HEAP32[i5 + 8 >> 2] = 16;
   HEAP32[i5 + 12 >> 2] = 1;
   HEAP32[i5 >> 2] = 8600;
   i1 = __Znwj(16) | 0;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i1 >> 2] = 8696;
   HEAP32[i1 + 8 >> 2] = i5;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i5;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i2 + -1;
   if ((i2 | 0) != 1) {
    STACKTOP = i3;
    return;
   }
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
   STACKTOP = i3;
   return;
  }
 }
}

function __ZN2cvL13getNameOfTypeEi(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i6;
 do switch (i1 | 0) {
 case 11:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i5, 13) | 0) + 0 | 0;
   i2 = 39344 | 0;
   i3 = i1 + 13 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   STACKTOP = i6;
   return;
  }
 case 6:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i5, 9) | 0) + 0 | 0;
   i2 = 39288 | 0;
   i3 = i1 + 9 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   STACKTOP = i6;
   return;
  }
 case 9:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i5, 14) | 0) + 0 | 0;
   i2 = 39328 | 0;
   i3 = i1 + 14 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   STACKTOP = i6;
   return;
  }
 case 8:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i5, 12) | 0) + 0 | 0;
   i2 = 39312 | 0;
   i3 = i1 + 12 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   STACKTOP = i6;
   return;
  }
 case 5:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i5, 20) | 0) + 0 | 0;
   i2 = 39264 | 0;
   i3 = i1 + 20 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   STACKTOP = i6;
   return;
  }
 case 0:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i5, 7) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[39224] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[39225] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[39226] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[39227] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[39228] | 0;
   HEAP8[i1 + 5 >> 0] = HEAP8[39229] | 0;
   HEAP8[i1 + 6 >> 0] = HEAP8[39230] | 0;
   STACKTOP = i6;
   return;
  }
 case 2:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i5, 6) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[39240] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[39241] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[39242] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[39243] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[39244] | 0;
   HEAP8[i1 + 5 >> 0] = HEAP8[39245] | 0;
   STACKTOP = i6;
   return;
  }
 case 3:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i5, 6) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[39248] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[39249] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[39250] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[39251] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[39252] | 0;
   HEAP8[i1 + 5 >> 0] = HEAP8[39253] | 0;
   STACKTOP = i6;
   return;
  }
 case 4:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i5, 7) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[39256] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[39257] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[39258] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[39259] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[39260] | 0;
   HEAP8[i1 + 5 >> 0] = HEAP8[39261] | 0;
   HEAP8[i1 + 6 >> 0] = HEAP8[39262] | 0;
   STACKTOP = i6;
   return;
  }
 case 1:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i5, 7) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[39232] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[39233] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[39234] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[39235] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[39236] | 0;
   HEAP8[i1 + 5 >> 0] = HEAP8[39237] | 0;
   HEAP8[i1 + 6 >> 0] = HEAP8[39238] | 0;
   STACKTOP = i6;
   return;
  }
 case 7:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i5, 5) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[39304] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[39305] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[39306] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[39307] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[39308] | 0;
   STACKTOP = i6;
   return;
  }
 default:
  {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i4, 19) | 0) + 0 | 0;
   i2 = 38288 | 0;
   i3 = i1 + 19 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i4, 39360, 37992, 574);
   __ZN2cv6String10deallocateEv(i4);
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   __ZN2cv6String8allocateEj(i5, 0) | 0;
   STACKTOP = i6;
   return;
  }
 } while (0);
}

function _cvCreateData(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i7 = i15 + 32 | 0;
 i13 = i15 + 24 | 0;
 i6 = i15 + 16 | 0;
 i10 = i15 + 8 | 0;
 i1 = i15;
 if (i14) {
  i2 = HEAP32[i14 >> 2] | 0;
  i5 = i2 & -65536;
  if (((i5 | 0) == 1111621632 ? (i8 = i14 + 24 | 0, i4 = HEAP32[i8 >> 2] | 0, (i4 | 0) > -1) : 0) ? (i9 = i14 + 20 | 0, i3 = HEAP32[i9 >> 2] | 0, (i3 | 0) > -1) : 0) {
   i2 = HEAP32[i14 + 4 >> 2] | 0;
   if ((i3 | 0) == 0 | (i4 | 0) == 0) {
    STACKTOP = i15;
    return;
   }
   i5 = i14 + 16 | 0;
   if (HEAP32[i5 >> 2] | 0) {
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    i3 = (__ZN2cv6String8allocateEj(i7, 25) | 0) + 0 | 0;
    i11 = 42184 | 0;
    i12 = i3 + 25 | 0;
    do {
     HEAP8[i3 >> 0] = HEAP8[i11 >> 0] | 0;
     i3 = i3 + 1 | 0;
     i11 = i11 + 1 | 0;
    } while ((i3 | 0) < (i12 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i7, 42216, 40912, 814);
    __ZN2cv6String10deallocateEv(i7);
   }
   if (!i2) {
    i2 = HEAP32[i14 >> 2] | 0;
    i2 = Math_imul((i2 >>> 3 & 511) + 1 << (47696 >>> (i2 << 1 & 14) & 3), HEAP32[i8 >> 2] | 0) | 0;
   }
   i4 = HEAP32[i9 >> 2] | 0;
   i4 = ___muldi3(i4 | 0, ((i4 | 0) < 0) << 31 >> 31 | 0, i2 | 0, 0) | 0;
   i4 = _i64Add(i4 | 0, tempRet0 | 0, 20, 0) | 0;
   if (!((i4 | 0) == (i4 | 0) & (tempRet0 | 0) == 0)) {
    HEAP32[i13 >> 2] = 0;
    HEAP32[i13 + 4 >> 2] = 0;
    i3 = (__ZN2cv6String8allocateEj(i13, 27) | 0) + 0 | 0;
    i11 = 42232 | 0;
    i12 = i3 + 27 | 0;
    do {
     HEAP8[i3 >> 0] = HEAP8[i11 >> 0] | 0;
     i3 = i3 + 1 | 0;
     i11 = i11 + 1 | 0;
    } while ((i3 | 0) < (i12 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-4, i13, 42216, 40912, 822);
    __ZN2cv6String10deallocateEv(i13);
   }
   i10 = _cvAlloc(i4) | 0;
   HEAP32[i14 + 8 >> 2] = i10;
   HEAP32[i5 >> 2] = i10 + 19 & -16;
   HEAP32[i10 >> 2] = 1;
   STACKTOP = i15;
   return;
  }
  if ((i2 | 0) == 112) {
   i4 = i14 + 68 | 0;
   if (HEAP32[i4 >> 2] | 0) {
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    i3 = (__ZN2cv6String8allocateEj(i6, 25) | 0) + 0 | 0;
    i11 = 42184 | 0;
    i12 = i3 + 25 | 0;
    do {
     HEAP8[i3 >> 0] = HEAP8[i11 >> 0] | 0;
     i3 = i3 + 1 | 0;
     i11 = i11 + 1 | 0;
    } while ((i3 | 0) < (i12 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i6, 42216, 40912, 832);
    __ZN2cv6String10deallocateEv(i6);
   }
   i5 = HEAP32[10244] | 0;
   if (!i5) {
    i10 = _cvAlloc(HEAP32[i14 + 64 >> 2] | 0) | 0;
    HEAP32[i14 + 108 >> 2] = i10;
    HEAP32[i4 >> 2] = i10;
    STACKTOP = i15;
    return;
   }
   i2 = i14 + 16 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = i14 + 40 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) == 64 | (i1 | 0) == 32) {
    HEAP32[i3 >> 2] = Math_imul((i1 | 0) == 32 ? 4 : 8, i4) | 0;
    HEAP32[i2 >> 2] = 8;
   }
   FUNCTION_TABLE_viii[i5 & 63](i14, 0, 0);
   HEAP32[i3 >> 2] = i4;
   HEAP32[i2 >> 2] = i1;
   STACKTOP = i15;
   return;
  }
  if ((i5 | 0) == 1111687168) {
   i1 = (i2 >>> 3 & 511) + 1 << (47696 >>> (i2 << 1 & 14) & 3);
   i5 = i14 + 20 | 0;
   if (!(HEAP32[i5 >> 2] | 0)) {
    STACKTOP = i15;
    return;
   }
   i4 = i14 + 16 | 0;
   if (HEAP32[i4 >> 2] | 0) {
    HEAP32[i10 >> 2] = 0;
    HEAP32[i10 + 4 >> 2] = 0;
    i3 = (__ZN2cv6String8allocateEj(i10, 25) | 0) + 0 | 0;
    i11 = 42184 | 0;
    i12 = i3 + 25 | 0;
    do {
     HEAP8[i3 >> 0] = HEAP8[i11 >> 0] | 0;
     i3 = i3 + 1 | 0;
     i11 = i11 + 1 | 0;
    } while ((i3 | 0) < (i12 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i10, 42216, 40912, 866);
    __ZN2cv6String10deallocateEv(i10);
    i2 = HEAP32[i14 >> 2] | 0;
   }
   if (!(i2 & 16384)) {
    i2 = HEAP32[i14 + 4 >> 2] | 0;
    if ((i2 | 0) > 0) do {
     i2 = i2 + -1 | 0;
     i10 = Math_imul(HEAP32[i5 + (i2 << 3) >> 2] | 0, HEAP32[i5 + (i2 << 3) + 4 >> 2] | 0) | 0;
     i1 = i1 >>> 0 < i10 >>> 0 ? i10 : i1;
    } while ((i2 | 0) > 0);
   } else {
    i10 = HEAP32[i14 + 24 >> 2] | 0;
    i1 = Math_imul((i10 | 0) == 0 ? i1 : i10, HEAP32[i5 >> 2] | 0) | 0;
   }
   i10 = _cvAlloc(i1 + 20 | 0) | 0;
   HEAP32[i14 + 8 >> 2] = i10;
   HEAP32[i4 >> 2] = i10 + 19 & -16;
   HEAP32[i10 >> 2] = 1;
   STACKTOP = i15;
   return;
  }
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i3 = (__ZN2cv6String8allocateEj(i1, 38) | 0) + 0 | 0;
 i11 = 42264 | 0;
 i12 = i3 + 38 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i11 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i3 | 0) < (i12 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i1, 42216, 40912, 890);
 __ZN2cv6String10deallocateEv(i1);
 STACKTOP = i15;
 return;
}

function __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i10, i12, i13, i11, i6) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0;
 i14 = STACKTOP;
 i2 = HEAP32[i10 >> 2] | 0;
 do if (i2) {
  if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0) == -1) {
   HEAP32[i10 >> 2] = 0;
   i2 = 0;
   break;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   break;
  }
 } else i2 = 0; while (0);
 i2 = (i2 | 0) == 0;
 i1 = HEAP32[i12 >> 2] | 0;
 do if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1 : 0) {
   HEAP32[i12 >> 2] = 0;
   i5 = 11;
   break;
  }
  if (!i2) i5 = 12;
 } else i5 = 11; while (0);
 if ((i5 | 0) == 11) if (i2) i5 = 12; else i1 = 0;
 if ((i5 | 0) == 12) {
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 6;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i2 = HEAPU8[i3 >> 0] | 0;
 i3 = i2 & 255;
 if (i3 << 24 >> 24 > -1 ? (i9 = i11 + 8 | 0, (HEAP16[(HEAP32[i9 >> 2] | 0) + (i2 << 24 >> 24 << 1) >> 1] & 2048) != 0) : 0) {
  i3 = (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] & 63](i11, i3, 0) | 0) << 24 >> 24;
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = i2 + 12 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   i5 = i6;
   i2 = i1;
   i4 = i1;
  } else {
   HEAP32[i4 >> 2] = i5 + 1;
   i5 = i6;
   i2 = i1;
   i4 = i1;
  }
  while (1) {
   i1 = i3 + -48 | 0;
   i7 = i5 + -1 | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   do if (i3) {
    if ((HEAP32[i3 + 12 >> 2] | 0) == (HEAP32[i3 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0) == -1) {
     HEAP32[i10 >> 2] = 0;
     i3 = 0;
     break;
    } else {
     i3 = HEAP32[i10 >> 2] | 0;
     break;
    }
   } else i3 = 0; while (0);
   i5 = (i3 | 0) == 0;
   if (i4) if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i4 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0) == -1) {
    HEAP32[i12 >> 2] = 0;
    i8 = 0;
    i6 = 0;
   } else {
    i8 = i2;
    i6 = i2;
   } else {
    i8 = i2;
    i6 = i4;
   } else {
    i8 = i2;
    i6 = 0;
   }
   i2 = HEAP32[i10 >> 2] | 0;
   if (!((i5 ^ (i6 | 0) == 0) & (i7 | 0) > 0)) {
    i5 = 40;
    break;
   }
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i5 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i3 = HEAPU8[i5 >> 0] | 0;
   i2 = i3 & 255;
   if (i2 << 24 >> 24 <= -1) {
    i5 = 52;
    break;
   }
   if (!(HEAP16[(HEAP32[i9 >> 2] | 0) + (i3 << 24 >> 24 << 1) >> 1] & 2048)) {
    i5 = 52;
    break;
   }
   i3 = ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] & 63](i11, i2, 0) | 0) << 24 >> 24) + (i1 * 10 | 0) | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   i4 = i5 + 12 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i5 + 16 >> 2] | 0)) {
    FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] & 127](i5) | 0;
    i5 = i7;
    i2 = i8;
    i4 = i6;
    continue;
   } else {
    HEAP32[i4 >> 2] = i2 + 1;
    i5 = i7;
    i2 = i8;
    i4 = i6;
    continue;
   }
  }
  if ((i5 | 0) == 40) {
   do if (i2) {
    if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0) == -1) {
     HEAP32[i10 >> 2] = 0;
     i2 = 0;
     break;
    } else {
     i2 = HEAP32[i10 >> 2] | 0;
     break;
    }
   } else i2 = 0; while (0);
   i2 = (i2 | 0) == 0;
   do if (i8) {
    if ((HEAP32[i8 + 12 >> 2] | 0) == (HEAP32[i8 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] & 127](i8) | 0) == -1 : 0) {
     HEAP32[i12 >> 2] = 0;
     i5 = 50;
     break;
    }
    if (i2) {
     i10 = i1;
     STACKTOP = i14;
     return i10 | 0;
    }
   } else i5 = 50; while (0);
   if ((i5 | 0) == 50 ? !i2 : 0) {
    i10 = i1;
    STACKTOP = i14;
    return i10 | 0;
   }
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 2;
   i10 = i1;
   STACKTOP = i14;
   return i10 | 0;
  } else if ((i5 | 0) == 52) {
   STACKTOP = i14;
   return i1 | 0;
  }
 }
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 4;
 i10 = 0;
 STACKTOP = i14;
 return i10 | 0;
}

function __ZNK2cv17CommandLineParser9getByNameERKNS_6StringEbiPv(i5, i12, i11, i21, i20) {
 i5 = i5 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i22 = i23 + 32 | 0;
 i19 = i23 + 24 | 0;
 i13 = i23 + 16 | 0;
 i14 = i23 + 8 | 0;
 i15 = i23;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = HEAP32[i9 + 40 >> 2] | 0;
 i10 = HEAP32[i9 + 36 >> 2] | 0;
 L1 : do if ((i8 | 0) != (i10 | 0)) {
  i6 = 0;
  L3 : while (1) {
   i4 = HEAP32[i10 + (i6 << 5) + 20 >> 2] | 0;
   i3 = HEAP32[i10 + (i6 << 5) + 16 >> 2] | 0;
   if ((i4 | 0) != (i3 | 0)) {
    i2 = HEAP32[i12 >> 2] | 0;
    i5 = (i2 | 0) == 0 ? 6232 : i2;
    i7 = 0;
    do {
     i1 = HEAP32[i3 + (i7 << 3) >> 2] | 0;
     if ((i2 | 0) == (i1 | 0)) break L3;
     i7 = i7 + 1 | 0;
     if (!(_strcmp(i5, (i1 | 0) == 0 ? 6232 : i1) | 0)) break L3;
    } while (i7 >>> 0 < i4 - i3 >> 3 >>> 0);
   }
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 >= i8 - i10 >> 5 >>> 0) break L1;
  }
  i4 = HEAP32[i10 + (i6 << 5) + 8 >> 2] | 0;
  HEAP32[i22 >> 2] = i4;
  i7 = i22 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i10 + (i6 << 5) + 12 >> 2];
  if (i4) {
   i15 = i4 + -4 | 0;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
  }
  if (i11) {
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i22 >> 2] | 0;
   L18 : do if ((i1 | 0) < 0) i4 = 0; else {
    i3 = 0;
    while (1) {
     i4 = i3 + 1 | 0;
     if ((HEAP8[i2 + i3 >> 0] | 0) != 32) {
      i4 = i3;
      break L18;
     }
     if ((i3 | 0) < (i1 | 0)) i3 = i4; else break;
    }
   } while (0);
   i6 = i1;
   while (1) {
    if ((i6 | 0) <= (i4 | 0)) {
     i5 = 17;
     break;
    }
    i3 = i6 + -1 | 0;
    if ((HEAP8[i2 + i3 >> 0] | 0) == 32) i6 = i3; else {
     i5 = 18;
     break;
    }
   }
   do if ((i5 | 0) == 17) {
    HEAP32[i19 >> 2] = 0;
    HEAP32[i19 + 4 >> 2] = 0;
    __ZN2cv6String8allocateEj(i19, 0) | 0;
   } else if ((i5 | 0) == 18 ? (i15 = i6 - i4 | 0, HEAP32[i19 >> 2] = 0, i16 = i19 + 4 | 0, HEAP32[i16 >> 2] = 0, i17 = i1 >>> 0 < i4 >>> 0 ? i1 : i4, i18 = i1 - i17 | 0, i18 = i18 >>> 0 > i15 >>> 0 ? i15 : i18, (i18 | 0) != 0) : 0) if ((i18 | 0) == (i1 | 0)) {
    i18 = i2 + -4 | 0;
    HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
    HEAP32[i19 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i16 >> 2] = HEAP32[i7 >> 2];
    break;
   } else {
    i16 = __ZN2cv6String8allocateEj(i19, i18) | 0;
    _memcpy(i16 | 0, (HEAP32[i22 >> 2] | 0) + i17 | 0, i18 | 0) | 0;
    break;
   } while (0);
   __ZN2cv6String10deallocateEv(i22);
   i1 = HEAP32[i19 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i1 = i1 + -4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = HEAP32[i19 >> 2] | 0;
   }
   HEAP32[i22 >> 2] = i1;
   HEAP32[i7 >> 2] = HEAP32[i19 + 4 >> 2];
   __ZN2cv6String10deallocateEv(i19);
  }
  __ZN2cvL8from_strERKNS_6StringEiPv(i22, i21, i20);
  __ZN2cv6String10deallocateEv(i22);
  STACKTOP = i23;
  return;
 } while (0);
 HEAP8[i9 >> 0] = 1;
 i6 = i9 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 i4 = i15 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i9 + 8 | 0;
 __ZN2cv6String8allocateEj(i15, (HEAP32[i5 >> 2] | 0) + 18 | 0) | 0;
 _memcpy(HEAP32[i15 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 i2 = (HEAP32[i15 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) + 0 | 0;
 i1 = 6184;
 i3 = i2 + 18 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i14 >> 2] = 0;
 i22 = i14 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i2 = i12 + 4 | 0;
 __ZN2cv6String8allocateEj(i14, (HEAP32[i2 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0) | 0;
 _memcpy(HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 _memcpy((HEAP32[i14 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0, HEAP32[i12 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 HEAP32[i13 >> 2] = 0;
 i2 = i13 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 __ZN2cv6String8allocateEj(i13, (HEAP32[i22 >> 2] | 0) + 1 | 0) | 0;
 _memcpy(HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0, HEAP32[i22 >> 2] | 0) | 0;
 HEAP8[(HEAP32[i13 >> 2] | 0) + (HEAP32[i22 >> 2] | 0) >> 0] = 10;
 if ((i13 | 0) != (i6 | 0)) {
  __ZN2cv6String10deallocateEv(i6);
  i1 = HEAP32[i13 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i1 = i1 + -4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 }
 __ZN2cv6String10deallocateEv(i13);
 __ZN2cv6String10deallocateEv(i14);
 __ZN2cv6String10deallocateEv(i15);
 STACKTOP = i23;
 return;
}

function __ZNK2cv5MatOp6divideERKNS_7MatExprES3_RS1_d(i1, i6, i7, i10, d3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 d3 = +d3;
 var i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i18 = i19 + 56 | 0;
 i13 = i19;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  FUNCTION_TABLE_viiiid[HEAP32[(HEAP32[i2 >> 2] | 0) + 76 >> 2] & 3](i2, i6, i7, i10, d3);
  STACKTOP = i19;
  return;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 do if ((i5 | 0) == 33120 ? (HEAP32[i6 + 4 >> 2] | 0) == 47 : 0) {
  if (!(HEAP32[i6 + 80 >> 2] | 0)) {
   if ((i1 | 0) != 33120) break;
  } else if (!((i1 | 0) == 33120 ? +HEAPF64[i6 + 184 >> 3] == 0.0 : 0)) break;
  if ((HEAP32[i7 + 4 >> 2] | 0) == 47) {
   if ((HEAP32[i7 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i7 + 184 >> 3] == 0.0) : 0) break;
   __ZN2cv9MatOp_Bin8makeExprERNS_7MatExprEcRKNS_3MatES5_d(i10, 47, i7 + 8 | 0, i6 + 8 | 0, +HEAPF64[i6 + 176 >> 3] / +HEAPF64[i7 + 176 >> 3]);
   STACKTOP = i19;
   return;
  }
 } while (0);
 HEAP32[i18 >> 2] = 1124007936;
 i16 = i18 + 4 | 0;
 i2 = i18 + 8 | 0;
 i14 = i18 + 40 | 0;
 i1 = i16 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i14 >> 2] = i2;
 i17 = i18 + 48 | 0;
 i15 = i18 + 44 | 0;
 HEAP32[i15 >> 2] = i17;
 HEAP32[i18 + 52 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i13 >> 2] = 1124007936;
 i12 = i13 + 4 | 0;
 i2 = i13 + 8 | 0;
 i8 = i13 + 40 | 0;
 i1 = i12 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i8 >> 2] = i2;
 i9 = i13 + 48 | 0;
 i4 = i13 + 44 | 0;
 HEAP32[i4 >> 2] = i9;
 HEAP32[i13 + 52 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 do if ((i5 | 0) == 33112) {
  if ((HEAP32[i6 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i6 + 184 >> 3] == 0.0) : 0) {
   i11 = 19;
   break;
  }
  if (((+HEAPF64[i6 + 192 >> 3] == 0.0 ? +HEAPF64[i6 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i6 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i6 + 216 >> 3] == 0.0 : 0) {
   __ZN2cv3MataSERKS0_(i18, i6 + 8 | 0) | 0;
   d3 = +HEAPF64[i6 + 176 >> 3] * d3;
  } else i11 = 19;
 } else i11 = 19; while (0);
 if ((i11 | 0) == 19) FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] & 63](i5, i6, i18, -1);
 i2 = HEAP32[i7 >> 2] | 0;
 do if ((i2 | 0) == 33112) {
  if ((HEAP32[i7 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i7 + 184 >> 3] == 0.0) : 0) {
   i11 = 28;
   break;
  }
  if (((+HEAPF64[i7 + 192 >> 3] == 0.0 ? +HEAPF64[i7 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i7 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i7 + 216 >> 3] == 0.0 : 0) {
   __ZN2cv3MataSERKS0_(i13, i7 + 8 | 0) | 0;
   d3 = d3 / +HEAPF64[i7 + 176 >> 3];
   i2 = 47;
  } else i11 = 28;
 } else i11 = 28; while (0);
 L39 : do if ((i11 | 0) == 28) {
  do if ((i2 | 0) == 33120 ? (HEAP32[i7 + 4 >> 2] | 0) == 47 : 0) {
   if ((HEAP32[i7 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i7 + 184 >> 3] == 0.0) : 0) break;
   __ZN2cv3MataSERKS0_(i13, i7 + 8 | 0) | 0;
   d3 = d3 / +HEAPF64[i7 + 176 >> 3];
   i2 = 42;
   break L39;
  } while (0);
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i7, i13, -1);
  i2 = 47;
 } while (0);
 __ZN2cv9MatOp_Bin8makeExprERNS_7MatExprEcRKNS_3MatES5_d(i10, i2, i18, i13, d3);
 i2 = i13 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i10 = i1 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i13);
 HEAP32[i2 >> 2] = 0;
 i11 = i13 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i9 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i18 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i10 = i1 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i18);
 HEAP32[i2 >> 2] = 0;
 i11 = i18 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i16 >> 2] | 0) > 0) {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i16 >> 2] | 0));
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) == (i17 | 0)) {
  STACKTOP = i19;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i19;
 return;
}

function __ZN7testing8internal24XmlUnitTestResultPrinter18OnTestIterationEndERKNS_8UnitTestEi(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 i15 = i14;
 i12 = i14 + 180 | 0;
 i11 = i14 + 168 | 0;
 i13 = i14 + 24 | 0;
 i10 = i14 + 12 | 0;
 i2 = i3 + 4 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i12, i2);
 __ZN7testing8internal8FilePath9NormalizeEv(i12);
 __ZNK7testing8internal8FilePath14RemoveFileNameEv(i11, i12);
 if (__ZNK7testing8internal8FilePath28CreateDirectoriesRecursivelyEv(i11) | 0) {
  if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i3 + 12 >> 2] | 0;
  i9 = _fopen(i1 | 0, 162960) | 0;
  if (i9) {
   i5 = i13 + 64 | 0;
   i6 = i13 + 8 | 0;
   HEAP32[i6 >> 2] = 2640;
   i7 = i13 + 12 | 0;
   HEAP32[i13 >> 2] = 2788;
   HEAP32[i5 >> 2] = 2808;
   HEAP32[i13 + 4 >> 2] = 0;
   __ZNSt3__18ios_base4initEPv(i13 + 64 | 0, i7);
   HEAP32[i13 + 136 >> 2] = 0;
   HEAP32[i13 + 140 >> 2] = -1;
   HEAP32[i13 >> 2] = 2620;
   HEAP32[i5 >> 2] = 2660;
   HEAP32[i6 >> 2] = 2640;
   __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i7);
   HEAP32[i7 >> 2] = 2952;
   i8 = i13 + 44 | 0;
   HEAP32[i8 + 0 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   HEAP32[i13 + 60 >> 2] = 24;
   HEAP32[i15 + 0 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
   __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i7, i15);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
   __ZN7testing8internal24XmlUnitTestResultPrinter16PrintXmlUnitTestEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS_8UnitTestE(i13 + 8 | 0, i4);
   __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i15, i7);
   i2 = HEAP8[i15 >> 0] | 0;
   if (!(i2 & 1)) {
    i1 = i15 + 1 | 0;
    i3 = (i2 & 255) >>> 1;
   } else {
    i1 = HEAP32[i15 + 8 >> 2] | 0;
    i3 = HEAP32[i15 + 4 >> 2] | 0;
   }
   i4 = i1 + i3 | 0;
   HEAP32[i10 + 0 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i10, i3 << 1);
   if (i3) {
    i2 = i1;
    do {
     i3 = HEAP8[i2 >> 0] | 0;
     if (!(i3 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i10, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i10, i3);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i4 | 0));
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
   if (!(HEAP8[i10 >> 0] & 1)) {
    i4 = i10 + 1 | 0;
    _fputs(i4 | 0, i9 | 0) | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
    _fclose(i9 | 0) | 0;
    HEAP32[i13 >> 2] = 2620;
    i10 = i13 + 64 | 0;
    HEAP32[i10 >> 2] = 2660;
    HEAP32[i6 >> 2] = 2640;
    HEAP32[i7 >> 2] = 2952;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
    __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i7);
    __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i5);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
    STACKTOP = i14;
    return;
   } else {
    i4 = HEAP32[i10 + 8 >> 2] | 0;
    _fputs(i4 | 0, i9 | 0) | 0;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
    _fclose(i9 | 0) | 0;
    HEAP32[i13 >> 2] = 2620;
    i10 = i13 + 64 | 0;
    HEAP32[i10 >> 2] = 2660;
    HEAP32[i6 >> 2] = 2640;
    HEAP32[i7 >> 2] = 2952;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
    __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i7);
    __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i5);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
    STACKTOP = i14;
    return;
   }
  }
 }
 i1 = HEAP32[_stderr >> 2] | 0;
 if (!(HEAP8[i2 >> 0] & 1)) {
  i10 = i2 + 1 | 0;
  HEAP32[i15 >> 2] = i10;
  _fprintf(i1 | 0, 162968, i15 | 0) | 0;
  _fflush(i1 | 0) | 0;
  _exit(1);
 } else {
  i10 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = i10;
  _fprintf(i1 | 0, 162968, i15 | 0) | 0;
  _fflush(i1 | 0) | 0;
  _exit(1);
 }
}

function __ZNK2cv11_InputArray5totalEi(i5, i8) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i4 = i9 + 32 | 0;
 i3 = i9 + 24 | 0;
 i6 = i9 + 16 | 0;
 i7 = i9 + 8 | 0;
 i2 = i9;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] & 127](i5) | 0;
 if ((i1 | 0) == 720896) {
  i4 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = ((HEAP32[i4 + 4 >> 2] | 0) - i1 | 0) / 48 | 0;
  if ((i8 | 0) < 0) {
   i1 = i2;
   STACKTOP = i9;
   return i1 | 0;
  }
  if ((i2 | 0) <= (i8 | 0)) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i5 = (__ZN2cv6String8allocateEj(i7, 18) | 0) + 0 | 0;
   i3 = 29208 | 0;
   i2 = i5 + 18 | 0;
   do {
    HEAP8[i5 >> 0] = HEAP8[i3 >> 0] | 0;
    i5 = i5 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i5 | 0) < (i2 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 29264, 27528, 1749);
   __ZN2cv6String10deallocateEv(i7);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i4 = HEAP32[i1 + (i8 * 48 | 0) + 4 >> 2] | 0;
  if ((i4 | 0) < 3) {
   i1 = Math_imul(HEAP32[i1 + (i8 * 48 | 0) + 12 >> 2] | 0, HEAP32[i1 + (i8 * 48 | 0) + 8 >> 2] | 0) | 0;
   STACKTOP = i9;
   return i1 | 0;
  }
  i2 = HEAP32[i1 + (i8 * 48 | 0) + 32 >> 2] | 0;
  i3 = 0;
  i1 = 1;
  do {
   i1 = Math_imul(HEAP32[i2 + (i3 << 2) >> 2] | 0, i1) | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
  STACKTOP = i9;
  return i1 | 0;
 } else if ((i1 | 0) == 65536) {
  if ((i8 | 0) >= 0) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i4, 5) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 29264, 27528, 1723);
   __ZN2cv6String10deallocateEv(i4);
  }
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if ((i4 | 0) < 3) {
   i1 = Math_imul(HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0) | 0;
   STACKTOP = i9;
   return i1 | 0;
  }
  i2 = HEAP32[i1 + 40 >> 2] | 0;
  i3 = 0;
  i1 = 1;
  do {
   i1 = Math_imul(HEAP32[i2 + (i3 << 2) >> 2] | 0, i1) | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
  STACKTOP = i9;
  return i1 | 0;
 } else if ((i1 | 0) == 327680) {
  i4 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = ((HEAP32[i4 + 4 >> 2] | 0) - i1 | 0) / 56 | 0;
  if ((i8 | 0) < 0) {
   i1 = i2;
   STACKTOP = i9;
   return i1 | 0;
  }
  if ((i2 | 0) <= (i8 | 0)) {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   i5 = (__ZN2cv6String8allocateEj(i6, 18) | 0) + 0 | 0;
   i3 = 29208 | 0;
   i2 = i5 + 18 | 0;
   do {
    HEAP8[i5 >> 0] = HEAP8[i3 >> 0] | 0;
    i5 = i5 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i5 | 0) < (i2 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i6, 29264, 27528, 1739);
   __ZN2cv6String10deallocateEv(i6);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i4 = HEAP32[i1 + (i8 * 56 | 0) + 4 >> 2] | 0;
  if ((i4 | 0) < 3) {
   i1 = Math_imul(HEAP32[i1 + (i8 * 56 | 0) + 12 >> 2] | 0, HEAP32[i1 + (i8 * 56 | 0) + 8 >> 2] | 0) | 0;
   STACKTOP = i9;
   return i1 | 0;
  }
  i2 = HEAP32[i1 + (i8 * 56 | 0) + 40 >> 2] | 0;
  i3 = 0;
  i1 = 1;
  do {
   i1 = Math_imul(HEAP32[i2 + (i3 << 2) >> 2] | 0, i1) | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
  STACKTOP = i9;
  return i1 | 0;
 } else if ((i1 | 0) == 655360) {
  if ((i8 | 0) >= 0) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i3, 5) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 29264, 27528, 1729);
   __ZN2cv6String10deallocateEv(i3);
  }
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if ((i4 | 0) < 3) {
   i1 = Math_imul(HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0) | 0;
   STACKTOP = i9;
   return i1 | 0;
  }
  i2 = HEAP32[i1 + 32 >> 2] | 0;
  i3 = 0;
  i1 = 1;
  do {
   i1 = Math_imul(HEAP32[i2 + (i3 << 2) >> 2] | 0, i1) | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
  STACKTOP = i9;
  return i1 | 0;
 } else {
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] & 63](i2, i5, i8);
  i1 = Math_imul(HEAP32[i2 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i22, i20, i21, i11, i17) {
 i22 = i22 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i11 = i11 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i1 = i23 + 24 | 0;
 i19 = i23 + 16 | 0;
 i10 = i23 + 8 | 0;
 i12 = i23;
 if (i20 >>> 0 >= 33) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i1, 33) | 0) + 0 | 0;
  i8 = 32664 | 0;
  i9 = i7 + 33 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 32704, 27528, 263);
  __ZN2cv6String10deallocateEv(i1);
 }
 i18 = i22 + 4 | 0;
 if ((HEAP32[i18 >> 2] | 0) != (i20 | 0)) {
  i1 = i22 + 44 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i22 + 48 | 0;
  if ((i2 | 0) != (i3 | 0)) {
   __ZN2cv8fastFreeEPv(i2);
   HEAP32[i1 >> 2] = i3;
   HEAP32[i22 + 40 >> 2] = i22 + 8;
  }
  if ((i20 | 0) > 2) {
   i16 = __ZN2cv10fastMallocEj(i20 << 3 | 4) | 0;
   HEAP32[i1 >> 2] = i16;
   HEAP32[i22 + 40 >> 2] = i16 + (i20 + 1 << 2);
   HEAP32[i16 + (i20 << 2) >> 2] = i20;
   HEAP32[i22 + 12 >> 2] = -1;
   HEAP32[i22 + 8 >> 2] = -1;
  }
 }
 HEAP32[i18 >> 2] = i20;
 if (!i21) {
  STACKTOP = i23;
  return;
 }
 i13 = HEAP32[i22 >> 2] | 0;
 i4 = i13 & 7;
 i13 = (i13 >>> 3 & 511) + 1 << (47696 >>> (i4 << 1) & 3);
 i4 = 1212424721 >>> (i4 << 2) & 15;
 i1 = i20 + -1 | 0;
 if ((i20 | 0) <= 0) {
  STACKTOP = i23;
  return;
 }
 i14 = i22 + 40 | 0;
 i15 = i22 + 44 | 0;
 i6 = i12 + 4 | 0;
 i5 = i10 + 4 | 0;
 i16 = i19 + 4 | 0;
 if (!i11) {
  i3 = i13;
  while (1) {
   i2 = HEAP32[i21 + (i1 << 2) >> 2] | 0;
   if ((i2 | 0) <= -1) {
    HEAP32[i19 >> 2] = 0;
    HEAP32[i16 >> 2] = 0;
    i11 = __ZN2cv6String8allocateEj(i19, 6) | 0;
    HEAP8[i11 + 0 >> 0] = HEAP8[32712] | 0;
    HEAP8[i11 + 1 >> 0] = HEAP8[32713] | 0;
    HEAP8[i11 + 2 >> 0] = HEAP8[32714] | 0;
    HEAP8[i11 + 3 >> 0] = HEAP8[32715] | 0;
    HEAP8[i11 + 4 >> 0] = HEAP8[32716] | 0;
    HEAP8[i11 + 5 >> 0] = HEAP8[32717] | 0;
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i19, 32704, 27528, 290);
    __ZN2cv6String10deallocateEv(i19);
   }
   HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] = i2;
   if (i17) {
    HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] = i3;
    i3 = ___muldi3(i2 | 0, ((i2 | 0) < 0) << 31 >> 31 | 0, i3 | 0, 0) | 0;
    if (!((i3 | 0) == (i3 | 0) & (tempRet0 | 0) == 0)) {
     HEAP32[i12 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
     i7 = (__ZN2cv6String8allocateEj(i12, 51) | 0) + 0 | 0;
     i8 = 32720 | 0;
     i9 = i7 + 51 | 0;
     do {
      HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
      i7 = i7 + 1 | 0;
      i8 = i8 + 1 | 0;
     } while ((i7 | 0) < (i9 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i12, 32704, 27528, 307);
     __ZN2cv6String10deallocateEv(i12);
    }
   }
   if ((i1 | 0) > 0) i1 = i1 + -1 | 0; else break;
  }
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i21 + (i2 << 2) >> 2] | 0;
   if ((i3 | 0) <= -1) {
    HEAP32[i19 >> 2] = 0;
    HEAP32[i16 >> 2] = 0;
    i17 = __ZN2cv6String8allocateEj(i19, 6) | 0;
    HEAP8[i17 + 0 >> 0] = HEAP8[32712] | 0;
    HEAP8[i17 + 1 >> 0] = HEAP8[32713] | 0;
    HEAP8[i17 + 2 >> 0] = HEAP8[32714] | 0;
    HEAP8[i17 + 3 >> 0] = HEAP8[32715] | 0;
    HEAP8[i17 + 4 >> 0] = HEAP8[32716] | 0;
    HEAP8[i17 + 5 >> 0] = HEAP8[32717] | 0;
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i19, 32704, 27528, 290);
    __ZN2cv6String10deallocateEv(i19);
   }
   HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] = i3;
   i3 = i11 + (i2 << 2) | 0;
   if (((HEAP32[i3 >> 2] | 0) >>> 0) % (i4 >>> 0) | 0) {
    HEAP32[i10 >> 2] = 0;
    HEAP32[i5 >> 2] = 0;
    i7 = (__ZN2cv6String8allocateEj(i10, 31) | 0) + 0 | 0;
    i8 = 32440 | 0;
    i9 = i7 + 31 | 0;
    do {
     HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
     i7 = i7 + 1 | 0;
     i8 = i8 + 1 | 0;
    } while ((i7 | 0) < (i9 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-13, i10, 32704, 27528, 297);
    __ZN2cv6String10deallocateEv(i10);
   }
   if ((i2 | 0) < (i1 | 0)) i3 = HEAP32[i3 >> 2] | 0; else i3 = i13;
   HEAP32[(HEAP32[i15 >> 2] | 0) + (i2 << 2) >> 2] = i3;
   if ((i2 | 0) > 0) i2 = i2 + -1 | 0; else break;
  }
 }
 if ((i20 | 0) != 1) {
  STACKTOP = i23;
  return;
 }
 HEAP32[i18 >> 2] = 2;
 HEAP32[i22 + 12 >> 2] = 1;
 HEAP32[(HEAP32[i22 + 44 >> 2] | 0) + 4 >> 2] = i13;
 STACKTOP = i23;
 return;
}

function __ZN2cv6repeatERKNS_11_InputArrayEiiRKNS_12_OutputArrayE(i7, i9, i8, i6) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i3 = i18 + 128 | 0;
 i2 = i18 + 120 | 0;
 i12 = i18 + 112 | 0;
 i17 = i18 + 56 | 0;
 i16 = i18;
 if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] & 127](i7, -1) | 0) >= 3) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i3, 16) | 0) + 0 | 0;
  i4 = 46952 | 0;
  i5 = i1 + 16 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i1 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 46976, 46680, 869);
  __ZN2cv6String10deallocateEv(i3);
 }
 if (!((i9 | 0) > 0 & (i8 | 0) > 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i2, 16) | 0) + 0 | 0;
  i4 = 46984 | 0;
  i5 = i1 + 16 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i1 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 46976, 46680, 870);
  __ZN2cv6String10deallocateEv(i2);
 }
 FUNCTION_TABLE_viii[HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] & 63](i12, i7, -1);
 i15 = HEAP32[(HEAP32[i6 >> 2] | 0) + 140 >> 2] | 0;
 i14 = i12 + 4 | 0;
 i2 = Math_imul(HEAP32[i14 >> 2] | 0, i9) | 0;
 i11 = Math_imul(HEAP32[i12 >> 2] | 0, i8) | 0;
 i13 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 56 >> 2] & 127](i7, -1) | 0;
 FUNCTION_TABLE_viiiiiii[i15 & 63](i6, i2, i11, i13, -1, 0, 0);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i7 >> 2] >> 2] & 63](i17, i7, -1);
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i6 >> 2] >> 2] & 63](i16, i6, -1);
 i13 = i16 + 40 | 0;
 i11 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i11 + 4 >> 2] | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i15 = i17 + 4 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 if ((i3 | 0) > 0) i3 = HEAP32[(HEAP32[i17 + 44 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0; else i3 = 0;
 i9 = Math_imul(HEAP32[i12 >> 2] | 0, i3) | 0;
 HEAP32[i12 >> 2] = i9;
 i10 = Math_imul(i3, i2) | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i7 = (i10 | 0) > 0;
  i6 = i16 + 16 | 0;
  i5 = i16 + 44 | 0;
  i4 = i17 + 16 | 0;
  i1 = i17 + 44 | 0;
  i3 = 0;
  do {
   if (i7) {
    i8 = 0;
    do {
     i2 = (HEAP32[i6 >> 2] | 0) + ((Math_imul(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i3) | 0) + i8) | 0;
     _memcpy(i2 | 0, (HEAP32[i4 >> 2] | 0) + (Math_imul(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i3) | 0) | 0, i9 | 0) | 0;
     i9 = HEAP32[i12 >> 2] | 0;
     i8 = i9 + i8 | 0;
    } while ((i8 | 0) < (i10 | 0));
    i2 = HEAP32[i14 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i2 | 0));
 } else i3 = 0;
 L20 : do if ((i3 | 0) < (i11 | 0)) {
  i9 = i16 + 16 | 0;
  i8 = i16 + 44 | 0;
  while (1) {
   i6 = HEAP32[i9 >> 2] | 0;
   i7 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
   _memcpy(i6 + (Math_imul(i7, i3) | 0) | 0, i6 + (Math_imul(i3 - i2 | 0, i7) | 0) | 0, i10 | 0) | 0;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i11 | 0)) break L20;
   i2 = HEAP32[i14 >> 2] | 0;
  }
 } while (0);
 i2 = i16 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i16);
 HEAP32[i2 >> 2] = 0;
 i10 = i16 + 16 | 0;
 i3 = i16 + 4 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i16 + 44 >> 2] | 0;
 if ((i1 | 0) != (i16 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i17 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i9 = i2 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i17);
 HEAP32[i1 >> 2] = 0;
 i10 = i17 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i15 >> 2] | 0) > 0) {
  i2 = HEAP32[i17 + 40 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i15 >> 2] | 0));
 }
 i1 = HEAP32[i17 + 44 >> 2] | 0;
 if ((i1 | 0) == (i17 + 48 | 0)) {
  STACKTOP = i18;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i18;
 return;
}

function __Z15RGBE_ReadHeaderP8_IO_FILEPiS1_P16rgbe_header_info(i6, i10, i7, i8) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i11 = i12;
 i5 = i12 + 16 | 0;
 i9 = i12 + 8 | 0;
 i4 = (i8 | 0) != 0;
 if (i4) {
  HEAP32[i8 >> 2] = 0;
  HEAP8[i8 + 4 >> 0] = 0;
  HEAPF32[i8 + 24 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 20 >> 2] = Math_fround(1.0);
 }
 if (!(_fgets(i5 | 0, 128, i6 | 0) | 0)) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i11, 15) | 0) + 0 | 0;
  i2 = 181688;
  i3 = i1 + 15 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i11, 181704, 181720, 90);
  __ZN2cv6String10deallocateEv(i11);
  i10 = -1;
  STACKTOP = i12;
  return i10 | 0;
 }
 i3 = HEAP8[i5 >> 0] | 0;
 if (i3 << 24 >> 24 == 35) if ((HEAP8[i5 + 1 >> 0] | 0) == 63 & i4) {
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1;
  i3 = 0;
  do {
   i2 = i5 + (i3 + 2) | 0;
   i1 = HEAP8[i2 >> 0] | 0;
   if (!(i1 << 24 >> 24)) break;
   if (_isspace(i1 << 24 >> 24) | 0) break;
   HEAP8[i8 + i3 + 4 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < 15);
  HEAP8[i8 + i3 + 4 >> 0] = 0;
  if (!(_fgets(i5 | 0, 128, i6 | 0) | 0)) {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i11, 15) | 0) + 0 | 0;
   i2 = 181688;
   i3 = i1 + 15 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i11, 181704, 181720, 90);
   __ZN2cv6String10deallocateEv(i11);
   i10 = -1;
   STACKTOP = i12;
   return i10 | 0;
  } else i2 = 13;
 } else i2 = 13;
 while (1) {
  if ((i2 | 0) == 13) i3 = HEAP8[i5 >> 0] | 0;
  if (i3 << 24 >> 24 == 10 | i3 << 24 >> 24 == 0) {
   i2 = 15;
   break;
  }
  if (!(_strcmp(i5, 181448) | 0)) {
   i2 = 24;
   break;
  }
  do if (i4) {
   HEAP32[i11 >> 2] = i9;
   if ((_sscanf(i5, 181472, i11) | 0) == 1) {
    HEAPF32[i8 + 20 >> 2] = Math_fround(HEAPF32[i9 >> 2]);
    HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
    break;
   }
   HEAP32[i11 >> 2] = i9;
   if ((_sscanf(i5, 181488, i11) | 0) == 1) {
    HEAPF32[i8 + 24 >> 2] = Math_fround(HEAPF32[i9 >> 2]);
    HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 4;
   }
  } while (0);
  if (!(_fgets(i5 | 0, 128, i6 | 0) | 0)) {
   i2 = 23;
   break;
  } else i2 = 13;
 }
 if ((i2 | 0) == 15) {
  __ZL10rgbe_erroriPKc(2, 181416);
  i10 = -1;
  STACKTOP = i12;
  return i10 | 0;
 } else if ((i2 | 0) == 23) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i11, 15) | 0) + 0 | 0;
  i2 = 181688;
  i3 = i1 + 15 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i11, 181704, 181720, 90);
  __ZN2cv6String10deallocateEv(i11);
  i10 = -1;
  STACKTOP = i12;
  return i10 | 0;
 } else if ((i2 | 0) == 24) {
  if (!(_fgets(i5 | 0, 128, i6 | 0) | 0)) {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i11, 15) | 0) + 0 | 0;
   i2 = 181688;
   i3 = i1 + 15 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i11, 181704, 181720, 90);
   __ZN2cv6String10deallocateEv(i11);
   i10 = -1;
   STACKTOP = i12;
   return i10 | 0;
  }
  if (_strcmp(i5, 181504) | 0) {
   __ZL10rgbe_erroriPKc(2, 181512);
   i10 = -1;
   STACKTOP = i12;
   return i10 | 0;
  }
  if (!(_fgets(i5 | 0, 128, i6 | 0) | 0)) {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i11, 15) | 0) + 0 | 0;
   i2 = 181688;
   i3 = i1 + 15 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i11, 181704, 181720, 90);
   __ZN2cv6String10deallocateEv(i11);
   i10 = -1;
   STACKTOP = i12;
   return i10 | 0;
  }
  HEAP32[i11 >> 2] = i7;
  HEAP32[i11 + 4 >> 2] = i10;
  if ((_sscanf(i5, 181560, i11) | 0) >= 2) {
   i10 = 0;
   STACKTOP = i12;
   return i10 | 0;
  }
  __ZL10rgbe_erroriPKc(2, 181576);
  i10 = -1;
  STACKTOP = i12;
  return i10 | 0;
 }
 return 0;
}

function __ZN7testing8internal24XmlUnitTestResultPrinter18OutputXmlAttributeEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEERKNS2_12basic_stringIcS5_NS2_9allocatorIcEEEESD_SD_(i14, i12, i15, i16) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i18 = i20 + 16 | 0;
 i13 = i20 + 12 | 0;
 i17 = i20;
 __ZN7testingL31GetReservedAttributesForElementERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i18, i12);
 i3 = HEAP32[i18 >> 2] | 0;
 i19 = i18 + 4 | 0;
 i11 = HEAP32[i19 >> 2] | 0;
 L1 : do if ((i3 | 0) == (i11 | 0)) i2 = 20; else {
  i8 = i15 + 1 | 0;
  i9 = i15 + 8 | 0;
  i10 = i15 + 4 | 0;
  i7 = HEAP8[i15 >> 0] | 0;
  i6 = (i7 & 1) == 0;
  i7 = (i7 & 255) >>> 1;
  while (1) {
   i2 = HEAP8[i3 >> 0] | 0;
   i5 = (i2 & 1) == 0;
   if (i5) i4 = (i2 & 255) >>> 1; else i4 = HEAP32[i3 + 4 >> 2] | 0;
   if (i6) i2 = i7; else i2 = HEAP32[i10 >> 2] | 0;
   L12 : do if ((i4 | 0) == (i2 | 0)) {
    if (i5) i1 = i3 + 1 | 0; else i1 = HEAP32[i3 + 8 >> 2] | 0;
    if (i6) i2 = i8; else i2 = HEAP32[i9 >> 2] | 0;
    if (!i5) if (!(_memcmp(i1, i2, i4) | 0)) {
     i2 = 20;
     break L1;
    } else break;
    if (!i4) {
     i2 = 20;
     break L1;
    }
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) break L12;
     i4 = i4 + -1 | 0;
     if (!i4) {
      i2 = 20;
      break L1;
     } else {
      i1 = i1 + 1 | 0;
      i2 = i2 + 1 | 0;
     }
    }
   } while (0);
   i3 = i3 + 12 | 0;
   if ((i3 | 0) == (i11 | 0)) {
    i2 = 21;
    break;
   }
  }
 } while (0);
 if ((i2 | 0) == 20 ? (i3 | 0) == (i11 | 0) : 0) i2 = 21;
 if ((i2 | 0) == 21) {
  __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i13, 3, 160160, 4782);
  i2 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 163136, 101) | 0, 163240, 10) | 0;
  i3 = HEAP8[i15 >> 0] | 0;
  if (!(i3 & 1)) {
   i1 = i15 + 1 | 0;
   i3 = (i3 & 255) >>> 1;
  } else {
   i1 = HEAP32[i15 + 8 >> 2] | 0;
   i3 = HEAP32[i15 + 4 >> 2] | 0;
  }
  i2 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i1, i3) | 0, 163256, 29) | 0;
  i3 = HEAP8[i12 >> 0] | 0;
  if (!(i3 & 1)) {
   i1 = i12 + 1 | 0;
   i3 = (i3 & 255) >>> 1;
  } else {
   i1 = HEAP32[i12 + 8 >> 2] | 0;
   i3 = HEAP32[i12 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i1, i3) | 0, 163288, 2) | 0;
  __ZN7testing8internal8GTestLogD2Ev(i13);
 }
 i3 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, 163296, 1) | 0;
 i2 = HEAP8[i15 >> 0] | 0;
 if (!(i2 & 1)) {
  i1 = i15 + 1 | 0;
  i2 = (i2 & 255) >>> 1;
 } else {
  i1 = HEAP32[i15 + 8 >> 2] | 0;
  i2 = HEAP32[i15 + 4 >> 2] | 0;
 }
 i3 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, i1, i2) | 0, 163304, 2) | 0;
 __ZN7testing8internal24XmlUnitTestResultPrinter9EscapeXmlERKNSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEb(i17, i16, 1);
 i2 = HEAP8[i17 >> 0] | 0;
 if (!(i2 & 1)) {
  i1 = i17 + 1 | 0;
  i2 = (i2 & 255) >>> 1;
 } else {
  i1 = HEAP32[i17 + 8 >> 2] | 0;
  i2 = HEAP32[i17 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, i1, i2) | 0, 160776, 1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
 i1 = HEAP32[i18 >> 2] | 0;
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 while (1) {
  i2 = HEAP32[i19 >> 2] | 0;
  if ((i2 | 0) == (i1 | 0)) break;
  i10 = i2 + -12 | 0;
  HEAP32[i19 >> 2] = i10;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
 }
 __ZdlPv(HEAP32[i18 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZL13icvGetNodePtrP11CvSparseMatPKiPiiPj(i21, i18, i20, i19, i1) {
 i21 = i21 | 0;
 i18 = i18 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i17 = i22 + 24 | 0;
 i10 = i22 + 16 | 0;
 i16 = i22;
 if (!i1) {
  i8 = i21 + 4 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i2 | 0) > 0) {
   i9 = i10 + 4 | 0;
   i3 = 0;
   i7 = 0;
   do {
    i6 = HEAP32[i18 + (i7 << 2) >> 2] | 0;
    if (i6 >>> 0 >= (HEAP32[i21 + (i7 << 2) + 36 >> 2] | 0) >>> 0) {
     HEAP32[i10 >> 2] = 0;
     HEAP32[i9 >> 2] = 0;
     i2 = (__ZN2cv6String8allocateEj(i10, 30) | 0) + 0 | 0;
     i1 = 43432 | 0;
     i5 = i2 + 30 | 0;
     do {
      HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
      i2 = i2 + 1 | 0;
      i1 = i1 + 1 | 0;
     } while ((i2 | 0) < (i5 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i10, 43464, 40912, 665);
     __ZN2cv6String10deallocateEv(i10);
     i2 = HEAP32[i8 >> 2] | 0;
    }
    i3 = i6 + (Math_imul(i3, 1540483477) | 0) | 0;
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) < (i2 | 0));
   i2 = i3;
  } else i2 = 0;
 } else i2 = HEAP32[i1 >> 2] | 0;
 i14 = i21 + 24 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i3 = i10 + -1 & i2;
 i15 = i2 & 2147483647;
 L11 : do if ((i19 | 0) > -2 ? (i4 = HEAP32[(HEAP32[i21 + 20 >> 2] | 0) + (i3 << 2) >> 2] | 0, (i4 | 0) != 0) : 0) {
  i8 = i21 + 32 | 0;
  i7 = i21 + 4 | 0;
  while (1) {
   if ((HEAP32[i4 >> 2] | 0) == (i15 | 0)) {
    i5 = i4 + (HEAP32[i8 >> 2] | 0) | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    L18 : do if ((i6 | 0) > 0) {
     i1 = 0;
     while (1) {
      i2 = i1 + 1 | 0;
      if ((HEAP32[i18 + (i1 << 2) >> 2] | 0) != (HEAP32[i5 + (i1 << 2) >> 2] | 0)) {
       i2 = i1;
       break L18;
      }
      if ((i2 | 0) < (i6 | 0)) i1 = i2; else break;
     }
    } else i2 = 0; while (0);
    if ((i2 | 0) == (i6 | 0)) break;
   }
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i4) {
    i1 = 0;
    break L11;
   }
  }
  i1 = i4 + (HEAP32[i21 + 28 >> 2] | 0) | 0;
 } else i1 = 0; while (0);
 if ((i1 | 0) == 0 & (i19 | 0) != 0) {
  i13 = i21 + 16 | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  if ((HEAP32[i2 + 60 >> 2] | 0) < (i10 * 3 | 0)) i4 = i2; else {
   i12 = i10 << 1;
   i12 = (i12 | 0) < 1024 ? 1024 : i12;
   i4 = i12 << 2;
   i7 = _cvAlloc(i4) | 0;
   _memset(i7 | 0, 0, i4 | 0) | 0;
   i4 = _cvInitSparseMatIterator(i21, i16) | 0;
   if (i4) {
    i2 = i16 + 4 | 0;
    i1 = i16 + 8 | 0;
    i11 = i12 + -1 | 0;
    while (1) {
     i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0;
     L34 : do if (!i3) {
      i5 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
      HEAP32[i1 >> 2] = i5;
      i6 = HEAP32[i16 >> 2] | 0;
      i10 = HEAP32[i6 + 24 >> 2] | 0;
      if ((i5 | 0) < (i10 | 0)) {
       i8 = HEAP32[i6 + 20 >> 2] | 0;
       while (1) {
        i3 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
        i9 = i5 + 1 | 0;
        if (i3) break;
        if ((i9 | 0) < (i10 | 0)) i5 = i9; else {
         i3 = 0;
         break L34;
        }
       }
       HEAP32[i1 >> 2] = i5;
       HEAP32[i2 >> 2] = i3;
      } else i3 = 0;
     } else HEAP32[i2 >> 2] = i3; while (0);
     i10 = i7 + ((HEAP32[i4 >> 2] & i11) << 2) | 0;
     HEAP32[i4 + 4 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i10 >> 2] = i4;
     if (!i3) break; else i4 = i3;
    }
   }
   i4 = i21 + 20 | 0;
   _cvFree_(HEAP32[i4 >> 2] | 0);
   HEAP32[i4 >> 2] = i7;
   HEAP32[i14 >> 2] = i12;
   i4 = HEAP32[i13 >> 2] | 0;
   i3 = i12 + 2147483647 & i15;
  }
  i2 = i4 + 56 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i17 >> 2] = i1;
  if (!i1) {
   _cvSetAdd(i4, 0, i17) | 0;
   i1 = HEAP32[i17 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 67108863;
   i10 = i4 + 60 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  HEAP32[i1 >> 2] = i15;
  i10 = (HEAP32[i21 + 20 >> 2] | 0) + (i3 << 2) | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i10 >> 2] = i1;
  _memcpy(i1 + (HEAP32[i21 + 32 >> 2] | 0) | 0, i18 | 0, HEAP32[i21 + 4 >> 2] << 2 | 0) | 0;
  i1 = i1 + (HEAP32[i21 + 28 >> 2] | 0) | 0;
  if ((i19 | 0) > 0) {
   i10 = HEAP32[i21 >> 2] | 0;
   _memset(i1 | 0, 0, (i10 >>> 3 & 511) + 1 << (47696 >>> (i10 << 1 & 14) & 3) | 0) | 0;
  }
 }
 if (!i20) {
  STACKTOP = i22;
  return i1 | 0;
 }
 HEAP32[i20 >> 2] = HEAP32[i21 >> 2] & 4095;
 STACKTOP = i22;
 return i1 | 0;
}

function __ZN2cv4UMatC2ERKS0_PKNS_5RangeE(i16, i9, i13) {
 i16 = i16 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i18 + 8 | 0;
 i8 = i18;
 HEAP32[i16 >> 2] = 1124007936;
 i11 = i16 + 4 | 0;
 i12 = i16 + 28 | 0;
 i15 = i16 + 32 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 HEAP32[i15 >> 2] = i16 + 8;
 i10 = i16 + 40 | 0;
 i14 = i16 + 36 | 0;
 HEAP32[i14 >> 2] = i10;
 HEAP32[i16 + 44 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 if (!i13) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i7 = __ZN2cv6String8allocateEj(i5, 6) | 0;
  HEAP8[i7 + 0 >> 0] = HEAP8[17984] | 0;
  HEAP8[i7 + 1 >> 0] = HEAP8[17985] | 0;
  HEAP8[i7 + 2 >> 0] = HEAP8[17986] | 0;
  HEAP8[i7 + 3 >> 0] = HEAP8[17987] | 0;
  HEAP8[i7 + 4 >> 0] = HEAP8[17988] | 0;
  HEAP8[i7 + 5 >> 0] = HEAP8[17989] | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 17800, 17672, 385);
  __ZN2cv6String10deallocateEv(i5);
 }
 i2 = (i10 | 0) > 0;
 if (i2) {
  i1 = i8 + 4 | 0;
  i6 = i9 + 32 | 0;
  i7 = 0;
  do {
   i4 = i13 + (i7 << 3) | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if ((i5 | 0) == -2147483648) {
    if ((i4 | 0) != 2147483647) i17 = 10;
   } else if (!((i5 | 0) > -1 & (i5 | 0) < (i4 | 0) ? (i4 | 0) <= (HEAP32[(HEAP32[i6 >> 2] | 0) + (i7 << 2) >> 2] | 0) : 0)) i17 = 10;
   if ((i17 | 0) == 10) {
    i17 = 0;
    HEAP32[i8 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    i5 = (__ZN2cv6String8allocateEj(i8, 76) | 0) + 0 | 0;
    i4 = 17992 | 0;
    i3 = i5 + 76 | 0;
    do {
     HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
     i5 = i5 + 1 | 0;
     i4 = i4 + 1 | 0;
    } while ((i5 | 0) < (i3 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 17800, 17672, 389);
    __ZN2cv6String10deallocateEv(i8);
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) < (i10 | 0));
  __ZN2cv4UMataSERKS0_(i16, i9) | 0;
  if (i2) {
   i2 = 0;
   do {
    i3 = i13 + (i2 << 3) | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if ((i4 | 0) == -2147483648) {
     if ((i3 | 0) != 2147483647) {
      i5 = HEAP32[i15 >> 2] | 0;
      i17 = 17;
     }
    } else {
     i5 = HEAP32[i15 >> 2] | 0;
     if ((i4 | 0) != 0 ? 1 : (i3 | 0) != (HEAP32[i5 + (i2 << 2) >> 2] | 0)) i17 = 17;
    }
    if ((i17 | 0) == 17) {
     i17 = 0;
     HEAP32[i5 + (i2 << 2) >> 2] = i3 - i4;
     i9 = Math_imul(HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] | 0, i4) | 0;
     HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i9;
     HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | 32768;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i10 | 0));
  }
 } else __ZN2cv4UMataSERKS0_(i16, i9) | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 L27 : do if ((i4 | 0) > 0) {
  i1 = HEAP32[i15 >> 2] | 0;
  i3 = 0;
  while (1) {
   i2 = i3 + 1 | 0;
   if ((HEAP32[i1 + (i3 << 2) >> 2] | 0) > 1) {
    i2 = i3;
    break L27;
   }
   if ((i2 | 0) < (i4 | 0)) i3 = i2; else break;
  }
 } else i2 = 0; while (0);
 i5 = HEAP32[i14 >> 2] | 0;
 while (1) {
  i3 = i4;
  i4 = i4 + -1 | 0;
  if ((i4 | 0) <= (i2 | 0)) break;
  i1 = HEAP32[i15 >> 2] | 0;
  i10 = Math_imul(HEAP32[i1 + (i4 << 2) >> 2] | 0, HEAP32[i5 + (i4 << 2) >> 2] | 0) | 0;
  if (i10 >>> 0 < (HEAP32[i5 + (i3 + -2 << 2) >> 2] | 0) >>> 0) {
   i17 = 27;
   break;
  }
 }
 if ((i17 | 0) == 27) {
  i10 = HEAP32[i5 >> 2] | 0;
  i9 = HEAP32[i1 >> 2] | 0;
  i8 = (i9 | 0) < 0;
  i8 = i8 << 31 >> 31;
  i10 = ___muldi3(i9 | 0, i8 | 0, i10 | 0, 0) | 0;
  i8 = tempRet0;
  i9 = (i4 | 0) <= (i2 | 0);
  i10 = (i10 | 0) == (i10 | 0);
  i8 = (i8 | 0) == 0;
  i8 = i10 & i8;
  i8 = i9 & i8;
  i9 = HEAP32[i16 >> 2] | 0;
  i10 = i9 & -16385;
  i9 = i9 | 16384;
  i10 = i8 ? i9 : i10;
  HEAP32[i16 >> 2] = i10;
  STACKTOP = i18;
  return;
 }
 i9 = HEAP32[i15 >> 2] | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i8 = (i9 | 0) < 0;
 i8 = i8 << 31 >> 31;
 i10 = ___muldi3(i9 | 0, i8 | 0, i10 | 0, 0) | 0;
 i8 = tempRet0;
 i9 = (i4 | 0) <= (i2 | 0);
 i10 = (i10 | 0) == (i10 | 0);
 i8 = (i8 | 0) == 0;
 i8 = i10 & i8;
 i8 = i9 & i8;
 i9 = HEAP32[i16 >> 2] | 0;
 i10 = i9 & -16385;
 i9 = i9 | 16384;
 i10 = i8 ? i9 : i10;
 HEAP32[i16 >> 2] = i10;
 STACKTOP = i18;
 return;
}

function _cvInitImageHeader(i14, i10, i13, i12, i15, i11) {
 i14 = i14 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i2 = i16 + 32 | 0;
 i6 = i16 + 24 | 0;
 i7 = i16 + 16 | 0;
 i8 = i16 + 8 | 0;
 i9 = i16;
 if (!i14) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i2, 22) | 0) + 0 | 0;
  i3 = 42944 | 0;
  i4 = i1 + 22 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-9, i2, 42968, 40912, 2915);
  __ZN2cv6String10deallocateEv(i2);
 }
 i1 = i14 + 0 | 0;
 i4 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i14 >> 2] = 112;
 i2 = i12 + -1 | 0;
 if (i2 >>> 0 < 4) {
  i1 = HEAP32[43368 + (i2 << 3) >> 2] | 0;
  i2 = HEAP32[43372 + (i2 << 3) >> 2] | 0;
 } else {
  i1 = 41088;
  i2 = 41088;
 }
 _strncpy(i14 + 20 | 0, i1 | 0, 4) | 0;
 _strncpy(i14 + 24 | 0, i2 | 0, 4) | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 if (!((i5 | 0) >= 0 ? (HEAP32[i10 + 4 >> 2] | 0) >= 0 : 0)) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i6, 13) | 0) + 0 | 0;
  i3 = 42992 | 0;
  i4 = i1 + 13 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-25, i6, 42968, 40912, 2925);
  __ZN2cv6String10deallocateEv(i6);
 }
 if ((i13 | 0) != 1 & (i13 | 0) != 8 & (i13 | 0) != -2147483640 & (i13 | 0) != 16 & (i13 | 0) != -2147483632 & (i13 | 0) != -2147483616 & (i13 | 0) != 32 & (i13 | 0) != 64 | (i12 | 0) < 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i7, 18) | 0) + 0 | 0;
  i3 = 43008 | 0;
  i4 = i1 + 18 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-17, i7, 42968, 40912, 2932);
  __ZN2cv6String10deallocateEv(i7);
 }
 if (i15 >>> 0 > 1) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i8, 16) | 0) + 0 | 0;
  i3 = 43032 | 0;
  i4 = i1 + 16 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-20, i8, 42968, 40912, 2934);
  __ZN2cv6String10deallocateEv(i8);
 }
 if (!((i11 | 0) == 4 | (i11 | 0) == 8)) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i9, 15) | 0) + 0 | 0;
  i3 = 43056 | 0;
  i4 = i1 + 15 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-21, i9, 42968, 40912, 2937);
  __ZN2cv6String10deallocateEv(i9);
 }
 HEAP32[i14 + 40 >> 2] = i5;
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i14 + 44 >> 2] = i1;
 i2 = HEAP32[i14 + 48 >> 2] | 0;
 if (!i2) {
  i9 = (i12 | 0) < 1;
  i9 = i9 ? 1 : i12;
  i10 = i14 + 8 | 0;
  HEAP32[i10 >> 2] = i9;
  i10 = i14 + 16 | 0;
  HEAP32[i10 >> 2] = i13;
  i10 = i14 + 36 | 0;
  HEAP32[i10 >> 2] = i11;
  i9 = Math_imul(i9, i5) | 0;
  i10 = i13 & 2147483647;
  i10 = Math_imul(i9, i10) | 0;
  i10 = i10 + 7 | 0;
  i10 = i10 >>> 3;
  i9 = i11 + -1 | 0;
  i10 = i9 + i10 | 0;
  i9 = 0 - i11 | 0;
  i9 = i10 & i9;
  i10 = i14 + 72 | 0;
  HEAP32[i10 >> 2] = i9;
  i10 = i14 + 32 | 0;
  HEAP32[i10 >> 2] = i15;
  i9 = Math_imul(i1, i9) | 0;
  i10 = i14 + 64 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i16;
  return i14 | 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = i5;
 HEAP32[i2 + 16 >> 2] = i1;
 i9 = (i12 | 0) < 1;
 i9 = i9 ? 1 : i12;
 i10 = i14 + 8 | 0;
 HEAP32[i10 >> 2] = i9;
 i10 = i14 + 16 | 0;
 HEAP32[i10 >> 2] = i13;
 i10 = i14 + 36 | 0;
 HEAP32[i10 >> 2] = i11;
 i9 = Math_imul(i9, i5) | 0;
 i10 = i13 & 2147483647;
 i10 = Math_imul(i9, i10) | 0;
 i10 = i10 + 7 | 0;
 i10 = i10 >>> 3;
 i9 = i11 + -1 | 0;
 i10 = i9 + i10 | 0;
 i9 = 0 - i11 | 0;
 i9 = i10 & i9;
 i10 = i14 + 72 | 0;
 HEAP32[i10 >> 2] = i9;
 i10 = i14 + 32 | 0;
 HEAP32[i10 >> 2] = i15;
 i9 = Math_imul(i1, i9) | 0;
 i10 = i14 + 64 | 0;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i16;
 return i14 | 0;
}

function __ZN25PerfValidationEnvironment8TearDownEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 i11 = i13 + 200 | 0;
 i12 = i13 + 16 | 0;
 i6 = i13;
 i4 = HEAP8[171768] | 0;
 i5 = (i4 & 1) == 0;
 if (i5) i1 = (i4 & 255) >>> 1; else i1 = HEAP32[42943] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 };
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = HEAP8[171736] | 0;
 i3 = (i1 & 1) == 0;
 if (i3) i2 = (i1 & 255) >>> 1; else i2 = HEAP32[42935] | 0;
 if (i5) i1 = (i4 & 255) >>> 1; else i1 = HEAP32[42943] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, i3 ? 171737 | 0 : HEAP32[42936] | 0, i2, i1 + i2 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, (HEAP8[171768] & 1) == 0 ? 171769 | 0 : HEAP32[42944] | 0, i1) | 0;
 if (!(HEAP8[i6 >> 0] & 1)) i2 = i6 + 1 | 0; else i2 = HEAP32[i6 + 8 >> 2] | 0;
 i7 = i12 + 104 | 0;
 i8 = i12 + 4 | 0;
 HEAP32[i12 >> 2] = 177324;
 i9 = i12 + 104 | 0;
 HEAP32[i9 >> 2] = 177344;
 __ZNSt3__18ios_base4initEPv(i12 + 104 | 0, i8);
 HEAP32[i12 + 176 >> 2] = 0;
 HEAP32[i12 + 180 >> 2] = -1;
 HEAP32[i12 >> 2] = 177268;
 HEAP32[i7 >> 2] = 177288;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEEC2Ev(i8);
 i10 = i12 + 68 | 0;
 if ((HEAP32[i10 >> 2] | 0) == 0 ? (i5 = _fopen(i2 | 0, 177544) | 0, HEAP32[i10 >> 2] = i5, (i5 | 0) != 0) : 0) HEAP32[i12 + 92 >> 2] = 16; else {
  i5 = HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0;
  __ZNSt3__18ios_base5clearEj(i12 + i5 | 0, HEAP32[i12 + (i5 + 16) >> 2] | 4);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 i1 = HEAP32[42938] | 0;
 if ((i1 | 0) != (171756 | 0)) do {
  i5 = __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEf(i12, Math_fround(HEAPF32[i1 + 28 >> 2])) | 0;
  HEAP8[i11 >> 0] = 59;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, i11, 1) | 0;
  i5 = i1 + 16 | 0;
  i4 = HEAP8[i5 >> 0] | 0;
  if (!(i4 & 1)) {
   i3 = i5 + 1 | 0;
   i5 = (i4 & 255) >>> 1;
  } else {
   i3 = HEAP32[i1 + 24 >> 2] | 0;
   i5 = HEAP32[i1 + 20 >> 2] | 0;
  }
  i2 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i12, i3, i5) | 0;
  __ZNKSt3__18ios_base6getlocEv(i11, i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i6 = __ZNKSt3__16locale9use_facetERNS0_2idE(i11, 960728) | 0;
  i6 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] & 127](i6, 10) | 0;
  __ZNSt3__16localeD2Ev(i11);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i2, i6) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i2) | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
    i1 = i2;
    break;
   } else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
  }
 } while ((i1 | 0) != (171756 | 0));
 i1 = HEAP32[i10 >> 2] | 0;
 if (!(((i1 | 0) != 0 ? (i14 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8) | 0, (_fclose(i1 | 0) | 0) == 0) : 0) ? (HEAP32[i10 >> 2] = 0, (i14 | 0) == 0) : 0)) {
  i10 = HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0;
  __ZNSt3__18ios_base5clearEj(i12 + i10 | 0, HEAP32[i12 + (i10 + 16) >> 2] | 4);
 }
 i10 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956152, 177200, 38) | 0;
 i10 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEj(i10, HEAP32[42940] | 0) | 0, 177240, 9) | 0;
 __ZNKSt3__18ios_base6getlocEv(i11, i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0);
 i6 = __ZNKSt3__16locale9use_facetERNS0_2idE(i11, 960728) | 0;
 i6 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] & 127](i6, 10) | 0;
 __ZNSt3__16localeD2Ev(i11);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i10, i6) | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i10) | 0;
 HEAP32[i12 >> 2] = 177268;
 HEAP32[i9 >> 2] = 177288;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev(i8);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i7);
 STACKTOP = i13;
 return;
}

function __ZNK2cv5MatOp8subtractERKNS_7MatExprES3_RS1_(i1, i6, i9, i10) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, d3 = 0.0, d4 = 0.0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i11 = i20;
 i19 = i20 + 88 | 0;
 i14 = i20 + 32 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] & 63](i2, i6, i9, i10);
  STACKTOP = i20;
  return;
 };
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 HEAP32[i11 + 28 >> 2] = 0;
 HEAPF64[i11 >> 3] = 0.0;
 HEAP32[i19 >> 2] = 1124007936;
 i17 = i19 + 4 | 0;
 i2 = i19 + 8 | 0;
 i15 = i19 + 40 | 0;
 i1 = i17 + 0 | 0;
 i5 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i5 | 0));
 HEAP32[i15 >> 2] = i2;
 i18 = i19 + 48 | 0;
 i16 = i19 + 44 | 0;
 HEAP32[i16 >> 2] = i18;
 HEAP32[i19 + 52 >> 2] = 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i14 >> 2] = 1124007936;
 i13 = i14 + 4 | 0;
 i2 = i14 + 8 | 0;
 i7 = i14 + 40 | 0;
 i1 = i13 + 0 | 0;
 i5 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i5 | 0));
 HEAP32[i7 >> 2] = i2;
 i8 = i14 + 48 | 0;
 i5 = i14 + 44 | 0;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i2 = HEAP32[i6 >> 2] | 0;
 do if ((i2 | 0) == 33112) {
  if ((HEAP32[i6 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i6 + 184 >> 3] == 0.0) : 0) {
   i12 = 6;
   break;
  }
  __ZN2cv3MataSERKS0_(i19, i6 + 8 | 0) | 0;
  d4 = +HEAPF64[i6 + 176 >> 3];
  i6 = i6 + 192 | 0;
  HEAP32[i11 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 } else i12 = 6; while (0);
 if ((i12 | 0) == 6) {
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i6, i19, -1);
  d4 = 1.0;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 do if ((i2 | 0) == 33112) {
  if ((HEAP32[i9 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i9 + 184 >> 3] == 0.0) : 0) {
   i12 = 11;
   break;
  }
  __ZN2cv3MataSERKS0_(i14, i9 + 8 | 0) | 0;
  d3 = -+HEAPF64[i9 + 176 >> 3];
  HEAPF64[i11 >> 3] = +HEAPF64[i11 >> 3] - +HEAPF64[i9 + 192 >> 3];
  i6 = i11 + 8 | 0;
  HEAPF64[i6 >> 3] = +HEAPF64[i6 >> 3] - +HEAPF64[i9 + 200 >> 3];
  i6 = i11 + 16 | 0;
  HEAPF64[i6 >> 3] = +HEAPF64[i6 >> 3] - +HEAPF64[i9 + 208 >> 3];
  i6 = i11 + 24 | 0;
  HEAPF64[i6 >> 3] = +HEAPF64[i6 >> 3] - +HEAPF64[i9 + 216 >> 3];
 } else i12 = 11; while (0);
 if ((i12 | 0) == 11) {
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i9, i14, -1);
  d3 = -1.0;
 }
 __ZN2cv11MatOp_AddEx8makeExprERNS_7MatExprERKNS_3MatES5_ddRKNS_7Scalar_IdEE(i10, i19, i14, d4, d3, i11);
 i2 = i14 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i10 = i1 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
 HEAP32[i2 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i13 >> 2] | 0) > 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i13 >> 2] | 0));
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i8 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i19 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i10 = i1 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i19);
 HEAP32[i2 >> 2] = 0;
 i11 = i19 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i17 >> 2] | 0) > 0) {
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i17 >> 2] | 0));
 }
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i18 | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i20;
 return;
}

function __ZN2cv3sumERKNS_11_InputArrayE(i19, i3) {
 i19 = i19 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 1184 | 0;
 i24 = i25 + 1120 | 0;
 i4 = i25 + 1112 | 0;
 i5 = i25 + 1104 | 0;
 i21 = i25 + 1096 | 0;
 i20 = i25 + 1064 | 0;
 i23 = i25;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i3 >> 2] >> 2] & 63](i24, i3, -1);
 i6 = HEAP32[i24 >> 2] | 0;
 i7 = i6 >>> 3;
 i17 = (i7 & 511) + 1 | 0;
 i6 = i6 & 7;
 i18 = HEAP32[27448 + (i6 << 2) >> 2] | 0;
 if (!(i17 >>> 0 < 5 & (i6 | 0) != 7)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i4, 20) | 0) + 0 | 0;
  i2 = 27128 | 0;
  i1 = i3 + 20 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 27152, 27160, 930);
  __ZN2cv6String10deallocateEv(i4);
 }
 HEAP32[i5 >> 2] = i24;
 HEAP32[i5 + 4 >> 2] = 0;
 __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i20, i5, i21, -1);
 HEAP32[i19 + 0 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP32[i19 + 24 >> 2] = 0;
 HEAP32[i19 + 28 >> 2] = 0;
 HEAPF64[i19 >> 3] = 0.0;
 i13 = HEAP32[i20 + 20 >> 2] | 0;
 i15 = i23 + 8 | 0;
 HEAP32[i23 >> 2] = i15;
 i16 = i23 + 4 | 0;
 HEAP32[i16 >> 2] = 264;
 i14 = i6 >>> 0 < 4;
 if (i14) {
  i6 = i6 >>> 0 < 2 ? 8388608 : 32768;
  i4 = (i6 | 0) < (i13 | 0) ? i6 : i13;
  if (i17 >>> 0 > 264) {
   i3 = __Znaj(i17 >>> 0 > 1073741823 ? -1 : i17 << 2) | 0;
   HEAP32[i23 >> 2] = i3;
  } else i3 = i15;
  HEAP32[i16 >> 2] = i17;
  i2 = i7 & 511;
  i5 = i2 + 1 | 0;
  _memset(i3 | 0, 0, (i2 << 2) + 4 | 0) | 0;
  i2 = HEAP32[i24 + 4 >> 2] | 0;
  if ((i2 | 0) > 0) i12 = HEAP32[(HEAP32[i24 + 44 >> 2] | 0) + (i2 + -1 << 2) >> 2] | 0; else i12 = 0;
 } else {
  i5 = (i7 & 511) + 1 | 0;
  i4 = i13;
  i6 = 0;
  i3 = i19;
  i12 = 0;
 }
 i10 = i20 + 16 | 0;
 i11 = (i13 | 0) > 0;
 i2 = 0;
 i1 = 0;
 while (1) {
  if (i1 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break;
  i1 = i1 + 1 | 0;
  L15 : do if (i11) {
   i7 = HEAP32[i21 >> 2] | 0;
   if (i14) i9 = 0; else {
    i8 = 0;
    while (1) {
     i9 = i13 - i8 | 0;
     i9 = (i4 | 0) < (i9 | 0) ? i4 : i9;
     FUNCTION_TABLE_iiiiii[i18 & 31](i7, 0, i3, i9, i17) | 0;
     i2 = i9 + i2 | 0;
     i9 = Math_imul(i9, i12) | 0;
     i7 = (HEAP32[i21 >> 2] | 0) + i9 | 0;
     HEAP32[i21 >> 2] = i7;
     i8 = i8 + i4 | 0;
     if ((i13 | 0) <= (i8 | 0)) break L15;
    }
   }
   do {
    i8 = i13 - i9 | 0;
    i8 = (i4 | 0) < (i8 | 0) ? i4 : i8;
    FUNCTION_TABLE_iiiiii[i18 & 31](i7, 0, i3, i8, i17) | 0;
    i2 = i8 + i2 | 0;
    if (!((i2 + i4 | 0) < (i6 | 0) ? ((i8 + i9 | 0) < (i13 | 0) ? 1 : i1 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) : 0)) {
     i7 = 0;
     i22 = 15;
    }
    if ((i22 | 0) == 15) while (1) {
     i22 = 0;
     i2 = i3 + (i7 << 2) | 0;
     i26 = i19 + (i7 << 3) | 0;
     HEAPF64[i26 >> 3] = +HEAPF64[i26 >> 3] + +(HEAP32[i2 >> 2] | 0);
     HEAP32[i2 >> 2] = 0;
     i7 = i7 + 1 | 0;
     if ((i7 | 0) == (i5 | 0)) {
      i2 = 0;
      break;
     } else i22 = 15;
    }
    i7 = Math_imul(i8, i12) | 0;
    i7 = (HEAP32[i21 >> 2] | 0) + i7 | 0;
    HEAP32[i21 >> 2] = i7;
    i9 = i9 + i4 | 0;
   } while ((i13 | 0) > (i9 | 0));
  } while (0);
  __ZN2cv15NAryMatIteratorppEv(i20) | 0;
 }
 i3 = HEAP32[i23 >> 2] | 0;
 if ((i3 | 0) != (i15 | 0)) {
  if (i3) __ZdaPv(i3);
  HEAP32[i23 >> 2] = i15;
  HEAP32[i16 >> 2] = 264;
 }
 i1 = i24 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i21 = i2 + 12 | 0, i22 = HEAP32[i21 >> 2] | 0, HEAP32[i21 >> 2] = i22 + -1, (i22 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i24);
 HEAP32[i1 >> 2] = 0;
 i22 = i24 + 16 | 0;
 i2 = i24 + 4 | 0;
 HEAP32[i22 + 0 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i24 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i24 + 44 >> 2] | 0;
 if ((i1 | 0) == (i24 + 48 | 0)) {
  STACKTOP = i25;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i25;
 return;
}

function __ZNK2cv5MatOp3addERKNS_7MatExprES3_RS1_(i1, i6, i9, i10) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, d3 = 0.0, d4 = 0.0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i11 = i20;
 i19 = i20 + 88 | 0;
 i14 = i20 + 32 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] & 63](i2, i6, i9, i10);
  STACKTOP = i20;
  return;
 };
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 HEAP32[i11 + 28 >> 2] = 0;
 HEAPF64[i11 >> 3] = 0.0;
 HEAP32[i19 >> 2] = 1124007936;
 i17 = i19 + 4 | 0;
 i2 = i19 + 8 | 0;
 i15 = i19 + 40 | 0;
 i1 = i17 + 0 | 0;
 i5 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i5 | 0));
 HEAP32[i15 >> 2] = i2;
 i18 = i19 + 48 | 0;
 i16 = i19 + 44 | 0;
 HEAP32[i16 >> 2] = i18;
 HEAP32[i19 + 52 >> 2] = 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i14 >> 2] = 1124007936;
 i13 = i14 + 4 | 0;
 i2 = i14 + 8 | 0;
 i7 = i14 + 40 | 0;
 i1 = i13 + 0 | 0;
 i5 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i5 | 0));
 HEAP32[i7 >> 2] = i2;
 i8 = i14 + 48 | 0;
 i5 = i14 + 44 | 0;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i2 = HEAP32[i6 >> 2] | 0;
 do if ((i2 | 0) == 33112) {
  if ((HEAP32[i6 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i6 + 184 >> 3] == 0.0) : 0) {
   i12 = 6;
   break;
  }
  __ZN2cv3MataSERKS0_(i19, i6 + 8 | 0) | 0;
  d4 = +HEAPF64[i6 + 176 >> 3];
  i6 = i6 + 192 | 0;
  HEAP32[i11 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 } else i12 = 6; while (0);
 if ((i12 | 0) == 6) {
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i6, i19, -1);
  d4 = 1.0;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 do if ((i2 | 0) == 33112) {
  if ((HEAP32[i9 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i9 + 184 >> 3] == 0.0) : 0) {
   i12 = 11;
   break;
  }
  __ZN2cv3MataSERKS0_(i14, i9 + 8 | 0) | 0;
  d3 = +HEAPF64[i9 + 176 >> 3];
  HEAPF64[i11 >> 3] = +HEAPF64[i9 + 192 >> 3] + +HEAPF64[i11 >> 3];
  i6 = i11 + 8 | 0;
  HEAPF64[i6 >> 3] = +HEAPF64[i9 + 200 >> 3] + +HEAPF64[i6 >> 3];
  i6 = i11 + 16 | 0;
  HEAPF64[i6 >> 3] = +HEAPF64[i9 + 208 >> 3] + +HEAPF64[i6 >> 3];
  i6 = i11 + 24 | 0;
  HEAPF64[i6 >> 3] = +HEAPF64[i9 + 216 >> 3] + +HEAPF64[i6 >> 3];
 } else i12 = 11; while (0);
 if ((i12 | 0) == 11) {
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i9, i14, -1);
  d3 = 1.0;
 }
 __ZN2cv11MatOp_AddEx8makeExprERNS_7MatExprERKNS_3MatES5_ddRKNS_7Scalar_IdEE(i10, i19, i14, d4, d3, i11);
 i2 = i14 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i10 = i1 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
 HEAP32[i2 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i13 >> 2] | 0) > 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i13 >> 2] | 0));
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i8 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i19 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i10 = i1 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i19);
 HEAP32[i2 >> 2] = 0;
 i11 = i19 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i17 >> 2] | 0) > 0) {
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i17 >> 2] | 0));
 }
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i18 | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i20;
 return;
}

function __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i12, i2, i1, i6, i7, i10, d8, d9, i11) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 d8 = +d8;
 d9 = +d9;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 HEAP32[i12 >> 2] = i2;
 HEAP32[i12 + 4 >> 2] = i1;
 i5 = i12 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i3 = i12 + 12 | 0;
 i1 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i14 = i12 + 16 | 0;
 HEAP32[i14 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i12 + 32 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i12 + 36 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i12 + 40 >> 2] = HEAP32[i6 + 32 >> 2];
 i4 = HEAP32[i6 + 36 >> 2] | 0;
 HEAP32[i12 + 44 >> 2] = i4;
 HEAP32[i12 + 48 >> 2] = i14;
 i14 = i12 + 56 | 0;
 i2 = i12 + 52 | 0;
 HEAP32[i2 >> 2] = i14;
 HEAP32[i12 + 60 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 if (i4) {
  i4 = i4 + 12 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 }
 if ((HEAP32[i1 >> 2] | 0) < 3) {
  i5 = HEAP32[i6 + 44 >> 2] | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 } else {
  HEAP32[i3 >> 2] = 0;
  __ZN2cv3Mat8copySizeERKS0_(i5, i6);
 }
 i5 = i12 + 64 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i4 = i12 + 68 | 0;
 i3 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 i6 = i12 + 72 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i12 + 76 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i12 + 80 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i12 + 84 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i12 + 88 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i12 + 92 >> 2] = HEAP32[i7 + 28 >> 2];
 HEAP32[i12 + 96 >> 2] = HEAP32[i7 + 32 >> 2];
 i2 = HEAP32[i7 + 36 >> 2] | 0;
 HEAP32[i12 + 100 >> 2] = i2;
 HEAP32[i12 + 104 >> 2] = i6;
 i6 = i12 + 112 | 0;
 i1 = i12 + 108 | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i12 + 116 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (i2) {
  i6 = i2 + 12 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 if ((HEAP32[i3 >> 2] | 0) < 3) {
  i6 = HEAP32[i7 + 44 >> 2] | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 } else {
  HEAP32[i4 >> 2] = 0;
  __ZN2cv3Mat8copySizeERKS0_(i5, i7);
 }
 i3 = i12 + 120 | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 i4 = i12 + 124 | 0;
 i5 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i7 = i12 + 128 | 0;
 HEAP32[i7 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i12 + 132 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i12 + 136 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i12 + 140 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i12 + 144 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i12 + 148 >> 2] = HEAP32[i10 + 28 >> 2];
 HEAP32[i12 + 152 >> 2] = HEAP32[i10 + 32 >> 2];
 i2 = HEAP32[i10 + 36 >> 2] | 0;
 HEAP32[i12 + 156 >> 2] = i2;
 HEAP32[i12 + 160 >> 2] = i7;
 i7 = i12 + 168 | 0;
 i1 = i12 + 164 | 0;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i12 + 172 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 if (i2) {
  i7 = i2 + 12 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 if ((HEAP32[i5 >> 2] | 0) < 3) {
  i7 = HEAP32[i10 + 44 >> 2] | 0;
  i10 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  i10 = i12 + 176 | 0;
  HEAPF64[i10 >> 3] = d8;
  i10 = i12 + 184 | 0;
  HEAPF64[i10 >> 3] = d9;
  d8 = +HEAPF64[i11 >> 3];
  i10 = i12 + 192 | 0;
  HEAPF64[i10 >> 3] = d8;
  i10 = i11 + 8 | 0;
  d8 = +HEAPF64[i10 >> 3];
  i10 = i12 + 200 | 0;
  HEAPF64[i10 >> 3] = d8;
  i10 = i11 + 16 | 0;
  d8 = +HEAPF64[i10 >> 3];
  i10 = i12 + 208 | 0;
  HEAPF64[i10 >> 3] = d8;
  i11 = i11 + 24 | 0;
  d8 = +HEAPF64[i11 >> 3];
  i11 = i12 + 216 | 0;
  HEAPF64[i11 >> 3] = d8;
  STACKTOP = i13;
  return;
 } else {
  HEAP32[i4 >> 2] = 0;
  __ZN2cv3Mat8copySizeERKS0_(i3, i10);
  i10 = i12 + 176 | 0;
  HEAPF64[i10 >> 3] = d8;
  i10 = i12 + 184 | 0;
  HEAPF64[i10 >> 3] = d9;
  d8 = +HEAPF64[i11 >> 3];
  i10 = i12 + 192 | 0;
  HEAPF64[i10 >> 3] = d8;
  i10 = i11 + 8 | 0;
  d8 = +HEAPF64[i10 >> 3];
  i10 = i12 + 200 | 0;
  HEAPF64[i10 >> 3] = d8;
  i10 = i11 + 16 | 0;
  d8 = +HEAPF64[i10 >> 3];
  i10 = i12 + 208 | 0;
  HEAPF64[i10 >> 3] = d8;
  i11 = i11 + 24 | 0;
  d8 = +HEAPF64[i11 >> 3];
  i11 = i12 + 216 | 0;
  HEAPF64[i11 >> 3] = d8;
  STACKTOP = i13;
  return;
 }
}

function __ZNK12_GLOBAL__N_118CLAHE_CalcLut_BodyIhLi256ELi0EEclERKN2cv5RangeE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 i29 = i30 + 1080 | 0;
 i27 = i30 + 1024 | 0;
 i28 = i30;
 i2 = HEAP32[i1 >> 2] | 0;
 i26 = HEAP32[i3 + 108 >> 2] | 0;
 i25 = i1 + 4 | 0;
 if ((i2 | 0) >= (HEAP32[i25 >> 2] | 0)) {
  STACKTOP = i30;
  return;
 }
 i8 = Math_imul(HEAP32[HEAP32[i3 + 104 >> 2] >> 2] | 0, i2) | 0;
 i9 = i3 + 124 | 0;
 i10 = i3 + 116 | 0;
 i11 = i3 + 120 | 0;
 i12 = i29 + 4 | 0;
 i13 = i29 + 8 | 0;
 i14 = i29 + 12 | 0;
 i15 = i3 + 4 | 0;
 i16 = i3 + 52 | 0;
 i17 = i27 + 16 | 0;
 i18 = i27 + 44 | 0;
 i19 = i3 + 128 | 0;
 i20 = i3 + 132 | 0;
 i21 = i27 + 36 | 0;
 i22 = i27 + 4 | 0;
 i23 = i27 + 40 | 0;
 i24 = i27 + 48 | 0;
 i8 = (HEAP32[i3 + 76 >> 2] | 0) + i8 | 0;
 while (1) {
  i1 = HEAP32[i9 >> 2] | 0;
  HEAP32[i29 + 0 >> 2] = 0;
  HEAP32[i29 + 4 >> 2] = 0;
  HEAP32[i29 + 8 >> 2] = 0;
  i5 = HEAP32[i10 >> 2] | 0;
  HEAP32[i29 >> 2] = Math_imul(i5, (i2 | 0) % (i1 | 0) | 0) | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP32[i12 >> 2] = Math_imul(i3, (i2 | 0) / (i1 | 0) | 0) | 0;
  HEAP32[i13 >> 2] = i5;
  HEAP32[i14 >> 2] = i3;
  __ZN2cv3MatC2ERKS0_RKNS_5Rect_IiEE(i27, i15, i29);
  _memset(i28 | 0, 0, 1024) | 0;
  i3 = HEAP32[i14 >> 2] | 0;
  i5 = HEAP32[i16 >> 2] | 0;
  if (i3) {
   i6 = HEAP32[i13 >> 2] | 0;
   i7 = HEAP32[i17 >> 2] | 0;
   while (1) {
    i3 = i3 + -1 | 0;
    if ((i6 + -4 | 0) < 0) i4 = 0; else {
     i4 = 0;
     do {
      i1 = HEAPU8[i7 + (i4 | 1) >> 0] | 0;
      i31 = i28 + ((HEAPU8[i7 + i4 >> 0] | 0) << 2) | 0;
      HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 1;
      i1 = i28 + (i1 << 2) | 0;
      HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
      i1 = HEAPU8[i7 + (i4 | 3) >> 0] | 0;
      i31 = i28 + ((HEAPU8[i7 + (i4 | 2) >> 0] | 0) << 2) | 0;
      HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 1;
      i1 = i28 + (i1 << 2) | 0;
      HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
      i4 = i4 + 4 | 0;
     } while ((i4 | 0) <= (i6 + -4 | 0));
    }
    if ((i4 | 0) < (i6 | 0)) do {
     i1 = i28 + ((HEAPU8[i7 + i4 >> 0] | 0) << 2) | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) < (i6 | 0));
    if (!i3) break; else i7 = i7 + i5 | 0;
   }
  }
  i5 = HEAP32[i19 >> 2] | 0;
  if ((i5 | 0) > 0) {
   i1 = 0;
   i7 = 0;
   while (1) {
    i4 = i28 + (i7 << 2) | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if ((i3 | 0) > (i5 | 0)) {
     HEAP32[i4 >> 2] = i5;
     i6 = i3 + i1 - i5 | 0;
    } else i6 = i1;
    i7 = i7 + 1 | 0;
    if ((i7 | 0) == 256) break; else i1 = i6;
   }
   i3 = (i6 | 0) / 256 | 0;
   i1 = i3 << 8;
   i4 = 0;
   do {
    i5 = i28 + (i4 << 2) | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i3;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != 256);
   if ((i6 - i1 | 0) > 0) {
    i1 = i6 - (i3 << 8) | 0;
    i3 = 0;
    do {
     i4 = i28 + (i3 << 2) | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i1 | 0));
    i4 = 0;
    i1 = 0;
   } else {
    i4 = 0;
    i1 = 0;
   }
  } else {
   i4 = 0;
   i1 = 0;
  }
  do {
   i1 = (HEAP32[i28 + (i4 << 2) >> 2] | 0) + i1 | 0;
   f32 = Math_fround(i1 | 0);
   i3 = _lrint(+Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f32)) | 0;
   if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
   HEAP8[i8 + i4 >> 0] = i3;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != 256);
  i1 = HEAP32[i21 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i3 = i1 + 12 | 0, i1 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i27);
  HEAP32[i21 >> 2] = 0;
  HEAP32[i17 + 0 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  HEAP32[i17 + 12 >> 2] = 0;
  if ((HEAP32[i22 >> 2] | 0) > 0) {
   i1 = HEAP32[i23 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i22 >> 2] | 0));
  }
  i1 = HEAP32[i18 >> 2] | 0;
  if ((i1 | 0) != (i24 | 0)) __ZN2cv8fastFreeEPv(i1);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (HEAP32[i25 >> 2] | 0)) break; else i8 = i8 + i26 | 0;
 }
 STACKTOP = i30;
 return;
}

function __ZN2cv3MatC2ERKS0_PKNS_5RangeE(i17, i10, i14) {
 i17 = i17 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i19 + 8 | 0;
 i9 = i19;
 HEAP32[i17 >> 2] = 1124007936;
 i12 = i17 + 4 | 0;
 i5 = i17 + 8 | 0;
 i13 = i17 + 16 | 0;
 i16 = i17 + 40 | 0;
 i7 = i12 + 0 | 0;
 i8 = i7 + 36 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAP32[i16 >> 2] = i5;
 i11 = i17 + 48 | 0;
 i15 = i17 + 44 | 0;
 HEAP32[i15 >> 2] = i11;
 HEAP32[i17 + 52 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 if (!i14) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i8 = __ZN2cv6String8allocateEj(i4, 6) | 0;
  HEAP8[i8 + 0 >> 0] = HEAP8[28080] | 0;
  HEAP8[i8 + 1 >> 0] = HEAP8[28081] | 0;
  HEAP8[i8 + 2 >> 0] = HEAP8[28082] | 0;
  HEAP8[i8 + 3 >> 0] = HEAP8[28083] | 0;
  HEAP8[i8 + 4 >> 0] = HEAP8[28084] | 0;
  HEAP8[i8 + 5 >> 0] = HEAP8[28085] | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 27752, 27528, 525);
  __ZN2cv6String10deallocateEv(i4);
 }
 i3 = (i11 | 0) > 0;
 if (i3) {
  i2 = i9 + 4 | 0;
  i1 = i10 + 40 | 0;
  i6 = 0;
  do {
   i4 = i14 + (i6 << 3) | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if ((i5 | 0) == -2147483648) {
    if ((i4 | 0) != 2147483647) i18 = 10;
   } else if (!((i5 | 0) > -1 & (i5 | 0) < (i4 | 0) ? (i4 | 0) <= (HEAP32[(HEAP32[i1 >> 2] | 0) + (i6 << 2) >> 2] | 0) : 0)) i18 = 10;
   if ((i18 | 0) == 10) {
    i18 = 0;
    HEAP32[i9 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    i7 = (__ZN2cv6String8allocateEj(i9, 76) | 0) + 0 | 0;
    i5 = 28088 | 0;
    i8 = i7 + 76 | 0;
    do {
     HEAP8[i7 >> 0] = HEAP8[i5 >> 0] | 0;
     i7 = i7 + 1 | 0;
     i5 = i5 + 1 | 0;
    } while ((i7 | 0) < (i8 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i9, 27752, 27528, 529);
    __ZN2cv6String10deallocateEv(i9);
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) < (i11 | 0));
  __ZN2cv3MataSERKS0_(i17, i10) | 0;
  if (i3) {
   i2 = 0;
   do {
    i3 = i14 + (i2 << 3) | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if ((i4 | 0) == -2147483648) {
     if ((i3 | 0) != 2147483647) {
      i5 = HEAP32[i16 >> 2] | 0;
      i18 = 17;
     }
    } else {
     i5 = HEAP32[i16 >> 2] | 0;
     if ((i4 | 0) != 0 ? 1 : (i3 | 0) != (HEAP32[i5 + (i2 << 2) >> 2] | 0)) i18 = 17;
    }
    if ((i18 | 0) == 17) {
     i18 = 0;
     HEAP32[i5 + (i2 << 2) >> 2] = i3 - i4;
     i10 = Math_imul(HEAP32[(HEAP32[i15 >> 2] | 0) + (i2 << 2) >> 2] | 0, i4) | 0;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i10;
     HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | 32768;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i11 | 0));
  }
 } else __ZN2cv3MataSERKS0_(i17, i10) | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 L27 : do if ((i4 | 0) > 0) {
  i1 = HEAP32[i16 >> 2] | 0;
  i3 = 0;
  while (1) {
   i2 = i3 + 1 | 0;
   if ((HEAP32[i1 + (i3 << 2) >> 2] | 0) > 1) {
    i2 = i3;
    break L27;
   }
   if ((i2 | 0) < (i4 | 0)) i3 = i2; else break;
  }
 } else i2 = 0; while (0);
 i5 = HEAP32[i15 >> 2] | 0;
 while (1) {
  i3 = i4;
  i4 = i4 + -1 | 0;
  if ((i4 | 0) <= (i2 | 0)) break;
  i1 = HEAP32[i16 >> 2] | 0;
  i10 = Math_imul(HEAP32[i1 + (i4 << 2) >> 2] | 0, HEAP32[i5 + (i4 << 2) >> 2] | 0) | 0;
  if (i10 >>> 0 < (HEAP32[i5 + (i3 + -2 << 2) >> 2] | 0) >>> 0) {
   i18 = 27;
   break;
  }
 }
 if ((i18 | 0) == 27) {
  i10 = HEAP32[i5 >> 2] | 0;
  i9 = HEAP32[i1 >> 2] | 0;
  i8 = (i9 | 0) < 0;
  i8 = i8 << 31 >> 31;
  i10 = ___muldi3(i9 | 0, i8 | 0, i10 | 0, 0) | 0;
  i8 = tempRet0;
  i9 = (i4 | 0) <= (i2 | 0);
  i10 = (i10 | 0) == (i10 | 0);
  i8 = (i8 | 0) == 0;
  i8 = i10 & i8;
  i8 = i9 & i8;
  i9 = HEAP32[i17 >> 2] | 0;
  i10 = i9 & -16385;
  i9 = i9 | 16384;
  i10 = i8 ? i9 : i10;
  HEAP32[i17 >> 2] = i10;
  STACKTOP = i19;
  return;
 }
 i9 = HEAP32[i16 >> 2] | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i8 = (i9 | 0) < 0;
 i8 = i8 << 31 >> 31;
 i10 = ___muldi3(i9 | 0, i8 | 0, i10 | 0, 0) | 0;
 i8 = tempRet0;
 i9 = (i4 | 0) <= (i2 | 0);
 i10 = (i10 | 0) == (i10 | 0);
 i8 = (i8 | 0) == 0;
 i8 = i10 & i8;
 i8 = i9 & i8;
 i9 = HEAP32[i17 >> 2] | 0;
 i10 = i9 & -16385;
 i9 = i9 | 16384;
 i10 = i8 ? i9 : i10;
 HEAP32[i17 >> 2] = i10;
 STACKTOP = i19;
 return;
}

function __ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i11, i15, i14, i18, i12) {
 i11 = i11 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i18 = i18 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i16 = 0, i17 = 0, i19 = 0;
 i19 = STACKTOP;
 if ((i11 | 0) == (HEAP32[i15 + 8 >> 2] | 0)) {
  if ((HEAP32[i15 + 4 >> 2] | 0) != (i14 | 0)) {
   STACKTOP = i19;
   return;
  }
  i1 = i15 + 28 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 1) {
   STACKTOP = i19;
   return;
  }
  HEAP32[i1 >> 2] = i18;
  STACKTOP = i19;
  return;
 }
 if ((i11 | 0) != (HEAP32[i15 >> 2] | 0)) {
  i10 = HEAP32[i11 + 12 >> 2] | 0;
  i9 = i11 + (i10 << 3) + 16 | 0;
  __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i11 + 16 | 0, i15, i14, i18, i12);
  i2 = i11 + 24 | 0;
  if ((i10 | 0) <= 1) {
   STACKTOP = i19;
   return;
  }
  i1 = HEAP32[i11 + 8 >> 2] | 0;
  if ((i1 & 2 | 0) == 0 ? (i5 = i15 + 36 | 0, (HEAP32[i5 >> 2] | 0) != 1) : 0) {
   if (!(i1 & 1)) {
    i1 = i15 + 54 | 0;
    i3 = i2;
    while (1) {
     if (HEAP8[i1 >> 0] | 0) {
      i3 = 43;
      break;
     }
     if ((HEAP32[i5 >> 2] | 0) == 1) {
      i3 = 43;
      break;
     }
     __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i3, i15, i14, i18, i12);
     i3 = i3 + 8 | 0;
     if (i3 >>> 0 >= i9 >>> 0) {
      i3 = 43;
      break;
     }
    }
    if ((i3 | 0) == 43) {
     STACKTOP = i19;
     return;
    }
   }
   i3 = i15 + 24 | 0;
   i1 = i15 + 54 | 0;
   i4 = i2;
   while (1) {
    if (HEAP8[i1 >> 0] | 0) {
     i3 = 43;
     break;
    }
    if ((HEAP32[i5 >> 2] | 0) == 1 ? (HEAP32[i3 >> 2] | 0) == 1 : 0) {
     i3 = 43;
     break;
    }
    __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i4, i15, i14, i18, i12);
    i4 = i4 + 8 | 0;
    if (i4 >>> 0 >= i9 >>> 0) {
     i3 = 43;
     break;
    }
   }
   if ((i3 | 0) == 43) {
    STACKTOP = i19;
    return;
   }
  }
  i1 = i15 + 54 | 0;
  while (1) {
   if (HEAP8[i1 >> 0] | 0) {
    i3 = 43;
    break;
   }
   __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i2, i15, i14, i18, i12);
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 >= i9 >>> 0) {
    i3 = 43;
    break;
   }
  }
  if ((i3 | 0) == 43) {
   STACKTOP = i19;
   return;
  }
 }
 if ((HEAP32[i15 + 16 >> 2] | 0) != (i14 | 0) ? (i13 = i15 + 20 | 0, (HEAP32[i13 >> 2] | 0) != (i14 | 0)) : 0) {
  HEAP32[i15 + 32 >> 2] = i18;
  i10 = i15 + 44 | 0;
  if ((HEAP32[i10 >> 2] | 0) == 4) {
   STACKTOP = i19;
   return;
  }
  i9 = HEAP32[i11 + 12 >> 2] | 0;
  i4 = i11 + (i9 << 3) + 16 | 0;
  L54 : do if ((i9 | 0) > 0) {
   i3 = i15 + 52 | 0;
   i6 = i15 + 53 | 0;
   i7 = i15 + 54 | 0;
   i8 = i11 + 8 | 0;
   i9 = i15 + 24 | 0;
   i2 = 0;
   i1 = 0;
   i5 = i11 + 16 | 0;
   L56 : do {
    HEAP8[i3 >> 0] = 0;
    HEAP8[i6 >> 0] = 0;
    __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i5, i15, i14, i14, 1, i12);
    if (HEAP8[i7 >> 0] | 0) break;
    do if (HEAP8[i6 >> 0] | 0) {
     if (!(HEAP8[i3 >> 0] | 0)) if (!(HEAP32[i8 >> 2] & 1)) {
      i1 = 1;
      break L56;
     } else {
      i1 = 1;
      break;
     }
     if ((HEAP32[i9 >> 2] | 0) == 1) {
      i3 = 25;
      break L54;
     }
     if (!(HEAP32[i8 >> 2] & 2)) {
      i3 = 25;
      break L54;
     } else {
      i2 = 1;
      i1 = 1;
     }
    } while (0);
    i5 = i5 + 8 | 0;
   } while (i5 >>> 0 < i4 >>> 0);
   if (i2) {
    i17 = i1;
    i3 = 24;
   } else {
    i16 = i1;
    i3 = 21;
   }
  } else {
   i16 = 0;
   i3 = 21;
  } while (0);
  if ((i3 | 0) == 21) {
   HEAP32[i13 >> 2] = i14;
   i9 = i15 + 40 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   if ((HEAP32[i15 + 36 >> 2] | 0) == 1 ? (HEAP32[i15 + 24 >> 2] | 0) == 2 : 0) {
    HEAP8[i15 + 54 >> 0] = 1;
    if (i16) i3 = 25; else i3 = 26;
   } else {
    i17 = i16;
    i3 = 24;
   }
  }
  if ((i3 | 0) == 24) if (i17) i3 = 25; else i3 = 26;
  if ((i3 | 0) == 25) {
   HEAP32[i10 >> 2] = 3;
   STACKTOP = i19;
   return;
  } else if ((i3 | 0) == 26) {
   HEAP32[i10 >> 2] = 4;
   STACKTOP = i19;
   return;
  }
 }
 if ((i18 | 0) != 1) {
  STACKTOP = i19;
  return;
 }
 HEAP32[i15 + 32 >> 2] = 1;
 STACKTOP = i19;
 return;
}

function __ZNK2cv11_InputArray6copyToERKNS_12_OutputArrayE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i7 = i10 + 64 | 0;
 i9 = i10 + 8 | 0;
 i3 = i10;
 i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1) | 0;
 if ((i2 | 0) == 393216) {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] & 127](i5) | 0) == 65536) {
   i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i5 >> 2] | 0) + 116 >> 2] & 127](i5, -1) | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i4, i1, -1);
   STACKTOP = i10;
   return;
  }
  HEAP32[i9 >> 2] = 1124007936;
  i8 = i9 + 4 | 0;
  i3 = i9 + 8 | 0;
  i6 = i9 + 40 | 0;
  i2 = i8 + 0 | 0;
  i1 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i1 | 0));
  HEAP32[i6 >> 2] = i3;
  i7 = i9 + 48 | 0;
  i1 = i9 + 44 | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i9 + 52 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i3 = HEAP32[i4 >> 2] | 0;
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] & 63](i3, i4, i9, -1);
  __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i9, i5);
  i4 = i9 + 36 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) != 0 ? (i3 = i3 + 12 | 0, i2 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i2 + -1, (i2 | 0) == 1) : 0) {
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2) {
    i3 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i3) {
     i3 = HEAP32[i9 + 32 >> 2] | 0;
     if (!i3) {
      if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
       i2 = __Znwj(4) | 0;
       HEAP32[i2 >> 2] = 32784;
       HEAP32[6904] = i2;
       ___cxa_guard_release(27624);
      }
      i3 = HEAP32[6904] | 0;
      i2 = HEAP32[i4 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3, i2);
   }
   HEAP32[i4 >> 2] = 0;
  }
  HEAP32[i4 >> 2] = 0;
  i2 = i9 + 16 | 0;
  HEAP32[i2 + 0 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  if ((HEAP32[i8 >> 2] | 0) > 0) {
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i8 >> 2] | 0));
  }
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == (i7 | 0)) {
   STACKTOP = i10;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i10;
  return;
 } else if (!i2) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 152 >> 2] & 511](i5);
  STACKTOP = i10;
  return;
 } else if ((i2 | 0) == 65536 | (i2 | 0) == 131072 | (i2 | 0) == 196608) {
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i1 >> 2] >> 2] & 63](i7, i1, -1);
  __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i7, i5);
  i3 = i7 + 36 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i2 = i1 + 12 | 0, i1 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) {
   i2 = HEAP32[i3 >> 2] | 0;
   if (i2) {
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) {
     i1 = HEAP32[i7 + 32 >> 2] | 0;
     if (!i1) {
      if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
       i1 = __Znwj(4) | 0;
       HEAP32[i1 >> 2] = 32784;
       HEAP32[6904] = i1;
       ___cxa_guard_release(27624);
      }
      i1 = HEAP32[6904] | 0;
      i2 = HEAP32[i3 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i2);
   }
   HEAP32[i3 >> 2] = 0;
  }
  HEAP32[i3 >> 2] = 0;
  i1 = i7 + 16 | 0;
  i2 = i7 + 4 | 0;
  HEAP32[i1 + 0 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i7 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i1 = HEAP32[i7 + 44 >> 2] | 0;
  if ((i1 | 0) == (i7 + 48 | 0)) {
   STACKTOP = i10;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i10;
  return;
 } else if ((i2 | 0) == 655360) {
  __ZNK2cv4UMat6copyToERKNS_12_OutputArrayE(HEAP32[i1 + 8 >> 2] | 0, i5);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i3, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i3, 29392, 27528, 2051);
  __ZN2cv6String10deallocateEv(i3);
  STACKTOP = i10;
  return;
 }
}

function __ZNK2cv11_InputArray4typeEi(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i8 = i12 + 32 | 0;
 i4 = i12 + 24 | 0;
 i9 = i12 + 16 | 0;
 i5 = i12 + 8 | 0;
 i3 = i12;
 i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] & 127](i10) | 0;
 do if ((i2 | 0) == 65536) {
  i10 = HEAP32[HEAP32[i10 + 8 >> 2] >> 2] & 4095;
  STACKTOP = i12;
  return i10 | 0;
 } else if ((i2 | 0) == 589824) {
  i10 = HEAP32[HEAP32[i10 + 8 >> 2] >> 2] & 4095;
  STACKTOP = i12;
  return i10 | 0;
 } else if ((i2 | 0) == 393216) {
  i10 = __ZNK2cv7MatExpr4typeEv(HEAP32[i10 + 8 >> 2] | 0) | 0;
  STACKTOP = i12;
  return i10 | 0;
 } else if ((i2 | 0) == 720896) {
  i3 = HEAP32[i10 + 8 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i2 = i10 + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) >= 0) {
    HEAP32[i8 >> 2] = 0;
    HEAP32[i8 + 4 >> 2] = 0;
    i1 = (__ZN2cv6String8allocateEj(i8, 25) | 0) + 0 | 0;
    i6 = 29272 | 0;
    i7 = i1 + 25 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i6 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i6 = i6 + 1 | 0;
    } while ((i1 | 0) < (i7 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 29304, 27528, 1780);
    __ZN2cv6String10deallocateEv(i8);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   i10 = i1 & 4095;
   STACKTOP = i12;
   return i10 | 0;
  } else {
   if (((i2 - i1 | 0) / 48 | 0 | 0) <= (i11 | 0)) {
    HEAP32[i4 >> 2] = 0;
    HEAP32[i4 + 4 >> 2] = 0;
    i1 = (__ZN2cv6String8allocateEj(i4, 18) | 0) + 0 | 0;
    i6 = 29208 | 0;
    i7 = i1 + 18 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i6 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i6 = i6 + 1 | 0;
    } while ((i1 | 0) < (i7 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 29304, 27528, 1783);
    __ZN2cv6String10deallocateEv(i4);
    i1 = HEAP32[i3 >> 2] | 0;
   }
   i10 = HEAP32[i1 + (((i11 | 0) < 0 ? 0 : i11) * 48 | 0) >> 2] & 4095;
   STACKTOP = i12;
   return i10 | 0;
  }
 } else if ((i2 | 0) == 327680) {
  i3 = HEAP32[i10 + 8 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i2 = i10 + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) >= 0) {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    i1 = (__ZN2cv6String8allocateEj(i9, 25) | 0) + 0 | 0;
    i6 = 29272 | 0;
    i7 = i1 + 25 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i6 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i6 = i6 + 1 | 0;
    } while ((i1 | 0) < (i7 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i9, 29304, 27528, 1792);
    __ZN2cv6String10deallocateEv(i9);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   i10 = i1 & 4095;
   STACKTOP = i12;
   return i10 | 0;
  } else {
   if (((i2 - i1 | 0) / 56 | 0 | 0) <= (i11 | 0)) {
    HEAP32[i5 >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
    i1 = (__ZN2cv6String8allocateEj(i5, 18) | 0) + 0 | 0;
    i6 = 29208 | 0;
    i7 = i1 + 18 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i6 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i6 = i6 + 1 | 0;
    } while ((i1 | 0) < (i7 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 29304, 27528, 1795);
    __ZN2cv6String10deallocateEv(i5);
    i1 = HEAP32[i3 >> 2] | 0;
   }
   i10 = HEAP32[i1 + (((i11 | 0) < 0 ? 0 : i11) * 56 | 0) >> 2] & 4095;
   STACKTOP = i12;
   return i10 | 0;
  }
 } else if ((i2 | 0) == 655360) {
  i10 = HEAP32[HEAP32[i10 + 8 >> 2] >> 2] & 4095;
  STACKTOP = i12;
  return i10 | 0;
 } else if ((i2 | 0) == 131072 | (i2 | 0) == 196608 | (i2 | 0) == 262144) {
  i10 = HEAP32[i10 + 4 >> 2] & 4095;
  STACKTOP = i12;
  return i10 | 0;
 } else if ((i2 | 0) == 458752) {
  i10 = HEAP32[(HEAP32[i10 + 8 >> 2] | 0) + 16 >> 2] | 0;
  STACKTOP = i12;
  return i10 | 0;
 } else if (!i2) {
  i10 = -1;
  STACKTOP = i12;
  return i10 | 0;
 } else if ((i2 | 0) != 524288) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i3, 13) | 0) + 0 | 0;
  i6 = 29232 | 0;
  i7 = i1 + 13 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i6 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i1 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 29304, 27528, 1805);
  __ZN2cv6String10deallocateEv(i3);
 } while (0);
 i10 = HEAP32[HEAP32[i10 + 8 >> 2] >> 2] & 4095;
 STACKTOP = i12;
 return i10 | 0;
}

function __ZN2cv15scalarToRawDataERKNS_7Scalar_IdEEPvii(i5, i7, i4, i8) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i9 + 8 | 0;
 i1 = i9;
 i3 = i4 >>> 3;
 i6 = (i3 & 511) + 1 | 0;
 if (i6 >>> 0 >= 5) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i10 = __ZN2cv6String8allocateEj(i2, 7) | 0;
  HEAP8[i10 + 0 >> 0] = HEAP8[28672] | 0;
  HEAP8[i10 + 1 >> 0] = HEAP8[28673] | 0;
  HEAP8[i10 + 2 >> 0] = HEAP8[28674] | 0;
  HEAP8[i10 + 3 >> 0] = HEAP8[28675] | 0;
  HEAP8[i10 + 4 >> 0] = HEAP8[28676] | 0;
  HEAP8[i10 + 5 >> 0] = HEAP8[28677] | 0;
  HEAP8[i10 + 6 >> 0] = HEAP8[28678] | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 28680, 27528, 1036);
  __ZN2cv6String10deallocateEv(i2);
 }
 switch (i4 & 7 | 0) {
 case 2:
  {
   i1 = (i3 & 511) + 1 | 0;
   i3 = 0;
   do {
    i2 = _lrint(+HEAPF64[i5 + (i3 << 3) >> 3]) | 0;
    if (i2 >>> 0 >= 65536) i2 = (i2 | 0) > 0 ? 65535 : 0;
    HEAP16[i7 + (i3 << 1) >> 1] = i2;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i1 | 0));
   if ((i1 | 0) >= (i8 | 0)) {
    STACKTOP = i9;
    return;
   }
   do {
    HEAP16[i7 + (i1 << 1) >> 1] = HEAP16[i7 + (i1 - i6 << 1) >> 1] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i8 | 0));
   STACKTOP = i9;
   return;
  }
 case 4:
  {
   i1 = (i3 & 511) + 1 | 0;
   i2 = 0;
   do {
    HEAP32[i7 + (i2 << 2) >> 2] = _lrint(+HEAPF64[i5 + (i2 << 3) >> 3]) | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
   if ((i1 | 0) >= (i8 | 0)) {
    STACKTOP = i9;
    return;
   }
   do {
    HEAP32[i7 + (i1 << 2) >> 2] = HEAP32[i7 + (i1 - i6 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i8 | 0));
   STACKTOP = i9;
   return;
  }
 case 6:
  {
   i1 = (i3 & 511) + 1 | 0;
   i2 = 0;
   do {
    HEAPF64[i7 + (i2 << 3) >> 3] = +HEAPF64[i5 + (i2 << 3) >> 3];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
   if ((i1 | 0) >= (i8 | 0)) {
    STACKTOP = i9;
    return;
   }
   do {
    HEAPF64[i7 + (i1 << 3) >> 3] = +HEAPF64[i7 + (i1 - i6 << 3) >> 3];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i8 | 0));
   STACKTOP = i9;
   return;
  }
 case 0:
  {
   i1 = (i3 & 511) + 1 | 0;
   i3 = 0;
   do {
    i2 = _lrint(+HEAPF64[i5 + (i3 << 3) >> 3]) | 0;
    if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i3 >> 0] = i2;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i1 | 0));
   if ((i1 | 0) >= (i8 | 0)) {
    STACKTOP = i9;
    return;
   }
   do {
    HEAP8[i7 + i1 >> 0] = HEAP8[i7 + (i1 - i6) >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i8 | 0));
   STACKTOP = i9;
   return;
  }
 case 1:
  {
   i1 = (i3 & 511) + 1 | 0;
   i3 = 0;
   do {
    i2 = _lrint(+HEAPF64[i5 + (i3 << 3) >> 3]) | 0;
    if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i3 >> 0] = i2;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i1 | 0));
   if ((i1 | 0) >= (i8 | 0)) {
    STACKTOP = i9;
    return;
   }
   do {
    HEAP8[i7 + i1 >> 0] = HEAP8[i7 + (i1 - i6) >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i8 | 0));
   STACKTOP = i9;
   return;
  }
 case 3:
  {
   i1 = (i3 & 511) + 1 | 0;
   i3 = 0;
   do {
    i2 = _lrint(+HEAPF64[i5 + (i3 << 3) >> 3]) | 0;
    if ((i2 + 32768 | 0) >>> 0 >= 65536) i2 = (i2 | 0) > 0 ? 32767 : -32768;
    HEAP16[i7 + (i3 << 1) >> 1] = i2;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i1 | 0));
   if ((i1 | 0) >= (i8 | 0)) {
    STACKTOP = i9;
    return;
   }
   do {
    HEAP16[i7 + (i1 << 1) >> 1] = HEAP16[i7 + (i1 - i6 << 1) >> 1] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i8 | 0));
   STACKTOP = i9;
   return;
  }
 case 5:
  {
   i1 = (i3 & 511) + 1 | 0;
   i2 = 0;
   do {
    HEAPF32[i7 + (i2 << 2) >> 2] = Math_fround(+HEAPF64[i5 + (i2 << 3) >> 3]);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
   if ((i1 | 0) >= (i8 | 0)) {
    STACKTOP = i9;
    return;
   }
   do {
    HEAPF32[i7 + (i1 << 2) >> 2] = Math_fround(HEAPF32[i7 + (i1 - i6 << 2) >> 2]);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i8 | 0));
   STACKTOP = i9;
   return;
  }
 default:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   __ZN2cv6String8allocateEj(i1, 0) | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-210, i1, 28680, 27528, 1103);
   __ZN2cv6String10deallocateEv(i1);
   STACKTOP = i9;
   return;
  }
 }
}

function __ZNK2cv11_InputArray6sizendEPii(i5, i9, i8) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i3 = i10 + 32 | 0;
 i2 = i10 + 24 | 0;
 i6 = i10 + 16 | 0;
 i7 = i10 + 8 | 0;
 i1 = i10;
 i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] & 127](i5) | 0;
 if ((i4 | 0) == 65536) {
  if ((i8 | 0) >= 0) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i3, 5) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 29248, 27528, 1547);
   __ZN2cv6String10deallocateEv(i3);
  }
  i2 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!((i9 | 0) != 0 & (i1 | 0) > 0)) {
   STACKTOP = i10;
   return i1 | 0;
  }
  i2 = HEAP32[i2 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i9 + (i3 << 2) >> 2] = HEAP32[i2 + (i3 << 2) >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i4 | 0) == 655360) {
  if ((i8 | 0) >= 0) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i2, 5) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 29248, 27528, 1556);
   __ZN2cv6String10deallocateEv(i2);
  }
  i2 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!((i9 | 0) != 0 & (i1 | 0) > 0)) {
   STACKTOP = i10;
   return i1 | 0;
  }
  i2 = HEAP32[i2 + 32 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i9 + (i3 << 2) >> 2] = HEAP32[i2 + (i3 << 2) >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
  STACKTOP = i10;
  return i1 | 0;
 } else if (!i4) {
  i1 = 0;
  STACKTOP = i10;
  return i1 | 0;
 } else {
  i3 = (i8 | 0) > -1;
  if ((i4 | 0) == 327680 & i3) {
   i3 = HEAP32[i5 + 8 >> 2] | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((((HEAP32[i3 + 4 >> 2] | 0) - i2 | 0) / 56 | 0 | 0) <= (i8 | 0)) {
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    i2 = (__ZN2cv6String8allocateEj(i6, 18) | 0) + 0 | 0;
    i1 = 29208 | 0;
    i4 = i2 + 18 | 0;
    do {
     HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
     i2 = i2 + 1 | 0;
     i1 = i1 + 1 | 0;
    } while ((i2 | 0) < (i4 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i6, 29248, 27528, 1566);
    __ZN2cv6String10deallocateEv(i6);
    i2 = HEAP32[i3 >> 2] | 0;
   }
   i1 = HEAP32[i2 + (i8 * 56 | 0) + 4 >> 2] | 0;
   if (!((i9 | 0) != 0 & (i1 | 0) > 0)) {
    STACKTOP = i10;
    return i1 | 0;
   }
   i2 = HEAP32[i2 + (i8 * 56 | 0) + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i9 + (i3 << 2) >> 2] = HEAP32[i2 + (i3 << 2) >> 2];
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i1 | 0));
   STACKTOP = i10;
   return i1 | 0;
  }
  if (!((i4 | 0) == 720896 & i3)) {
   FUNCTION_TABLE_viii[HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] & 63](i1, i5, i8);
   if (!i9) {
    i1 = 2;
    STACKTOP = i10;
    return i1 | 0;
   }
   HEAP32[i9 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i1 >> 2];
   i1 = 2;
   STACKTOP = i10;
   return i1 | 0;
  }
  i3 = HEAP32[i5 + 8 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((((HEAP32[i3 + 4 >> 2] | 0) - i2 | 0) / 48 | 0 | 0) <= (i8 | 0)) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i2 = (__ZN2cv6String8allocateEj(i7, 18) | 0) + 0 | 0;
   i1 = 29208 | 0;
   i4 = i2 + 18 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i1 = i1 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 29248, 27528, 1576);
   __ZN2cv6String10deallocateEv(i7);
   i2 = HEAP32[i3 >> 2] | 0;
  }
  i1 = HEAP32[i2 + (i8 * 48 | 0) + 4 >> 2] | 0;
  if (!((i9 | 0) != 0 & (i1 | 0) > 0)) {
   STACKTOP = i10;
   return i1 | 0;
  }
  i2 = HEAP32[i2 + (i8 * 48 | 0) + 32 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i9 + (i3 << 2) >> 2] = HEAP32[i2 + (i3 << 2) >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function _cvCloneMatND(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 i13 = i14 + 232 | 0;
 i3 = i14 + 224 | 0;
 i2 = i14 + 216 | 0;
 i8 = i14 + 88 | 0;
 i11 = i14 + 32 | 0;
 i7 = i14 + 8 | 0;
 i10 = i14;
 if (!((i9 | 0) != 0 ? (HEAP32[i9 >> 2] & -65536 | 0) == 1111687168 : 0)) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i3, 18) | 0) + 0 | 0;
  i5 = 41440 | 0;
  i6 = i1 + 18 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i3, 41464, 40912, 301);
  __ZN2cv6String10deallocateEv(i3);
 }
 i4 = i9 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if ((i3 | 0) < 33) i2 = i3; else {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i2, 23) | 0) + 0 | 0;
  i5 = 41480 | 0;
  i6 = i1 + 23 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 41464, 40912, 303);
  __ZN2cv6String10deallocateEv(i2);
  i2 = HEAP32[i4 >> 2] | 0;
 }
 if ((i2 | 0) > 0) {
  i3 = 0;
  do {
   HEAP32[i8 + (i3 << 2) >> 2] = HEAP32[i9 + (i3 << 3) + 20 >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i2 | 0));
 }
 i4 = HEAP32[i9 >> 2] | 0;
 if ((i2 + -1 | 0) >>> 0 > 31) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i13, 46) | 0) + 0 | 0;
  i5 = 41304 | 0;
  i6 = i1 + 46 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i13, 41416, 40912, 286);
  __ZN2cv6String10deallocateEv(i13);
 }
 i12 = _cvAlloc(276) | 0;
 _cvInitMatNDHeader(i12, i2, i8, i4, 0) | 0;
 HEAP32[i12 + 12 >> 2] = 1;
 if (!(HEAP32[i9 + 16 >> 2] | 0)) {
  STACKTOP = i14;
  return i12 | 0;
 }
 _cvCreateData(i12);
 __ZN2cv10cvarrToMatEPKvbbiPNS_10AutoBufferIdLj136EEE(i13, i9, 0, 1, 0, 0);
 __ZN2cv10cvarrToMatEPKvbbiPNS_10AutoBufferIdLj136EEE(i11, i12, 0, 1, 0, 0);
 i9 = HEAP32[i12 + 16 >> 2] | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 + 0 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i7 >> 2] = 32232;
 HEAP32[i4 >> 2] = 33619968;
 HEAP32[i7 + 8 >> 2] = i11;
 __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i13, i7);
 i4 = i11 + 16 | 0;
 if ((HEAP32[i4 >> 2] | 0) != (i9 | 0)) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i10, 18) | 0) + 0 | 0;
  i5 = 41504 | 0;
  i6 = i1 + 18 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 41464, 40912, 318);
  __ZN2cv6String10deallocateEv(i10);
 }
 i3 = i11 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i9 = i2 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i3 >> 2] = 0;
 i1 = i11 + 4 | 0;
 HEAP32[i4 + 0 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 if ((HEAP32[i1 >> 2] | 0) > 0) {
  i3 = HEAP32[i11 + 40 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i1 >> 2] | 0));
 }
 i1 = HEAP32[i11 + 44 >> 2] | 0;
 if ((i1 | 0) != (i11 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
 i1 = i13 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i9 = i2 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i13);
 HEAP32[i1 >> 2] = 0;
 i10 = i13 + 16 | 0;
 i2 = i13 + 4 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i13 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i13 + 44 >> 2] | 0;
 if ((i1 | 0) == (i13 + 48 | 0)) {
  STACKTOP = i14;
  return i12 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i14;
 return i12 | 0;
}

function _cvSetHistBinRanges(i18, i19, i5) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f6 = Math_fround(0), i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, f21 = Math_fround(0);
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 i16 = i20 + 40 | 0;
 i4 = i20 + 32 | 0;
 i3 = i20 + 24 | 0;
 i9 = i20 + 16 | 0;
 i14 = i20 + 8 | 0;
 i15 = i20;
 if (!i19) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i11 = (__ZN2cv6String8allocateEj(i4, 19) | 0) + 0 | 0;
  i12 = 701904 | 0;
  i13 = i11 + 19 | 0;
  do {
   HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
   i11 = i11 + 1 | 0;
   i12 = i12 + 1 | 0;
  } while ((i11 | 0) < (i13 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i4, 701928, 701600, 3022);
  __ZN2cv6String10deallocateEv(i4);
 }
 if (!(((i18 | 0) != 0 ? (HEAP32[i18 >> 2] & -65536 | 0) == 1111818240 : 0) ? (i1 = HEAP32[i18 + 4 >> 2] | 0, (i1 | 0) != 0) : 0)) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i11 = (__ZN2cv6String8allocateEj(i3, 24) | 0) + 0 | 0;
  i12 = 701784 | 0;
  i13 = i11 + 24 | 0;
  do {
   HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
   i11 = i11 + 1 | 0;
   i12 = i12 + 1 | 0;
  } while ((i11 | 0) < (i13 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i3, 701928, 701600, 3025);
  __ZN2cv6String10deallocateEv(i3);
  i1 = HEAP32[i18 + 4 >> 2] | 0;
 }
 i17 = _cvGetDims(i1, i16) | 0;
 i2 = (i17 | 0) > 0;
 if (i2) {
  i3 = 0;
  i1 = 0;
  do {
   i1 = i1 + 1 + (HEAP32[i16 + (i3 << 2) >> 2] | 0) | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i17 | 0));
  i4 = i1;
 } else i4 = 0;
 if (i5) {
  if (i2) {
   i3 = i9 + 4 | 0;
   i4 = 0;
   do {
    i2 = i19 + (i4 << 2) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) {
     HEAP32[i9 >> 2] = 0;
     HEAP32[i3 >> 2] = 0;
     i11 = (__ZN2cv6String8allocateEj(i9, 32) | 0) + 0 | 0;
     i12 = 701952 | 0;
     i13 = i11 + 32 | 0;
     do {
      HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
      i11 = i11 + 1 | 0;
      i12 = i12 + 1 | 0;
     } while ((i11 | 0) < (i13 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i9, 701928, 701600, 3036);
     __ZN2cv6String10deallocateEv(i9);
     i1 = HEAP32[i2 >> 2] | 0;
    }
    HEAPF32[i18 + (i4 << 3) + 8 >> 2] = Math_fround(HEAPF32[i1 >> 2]);
    HEAPF32[i18 + (i4 << 3) + 12 >> 2] = Math_fround(HEAPF32[i1 + 4 >> 2]);
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) < (i17 | 0));
  }
  HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | 3072;
  STACKTOP = i20;
  return;
 }
 i10 = i18 + 264 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i1 = _cvAlloc(i4 + i17 << 2) | 0;
  HEAP32[i10 >> 2] = i1;
 }
 if (i2) {
  i8 = i14 + 4 | 0;
  i9 = i15 + 4 | 0;
  i1 = i1 + (i17 << 2) | 0;
  i7 = 0;
  while (1) {
   i5 = i19 + (i7 << 2) | 0;
   if (!(HEAP32[i5 >> 2] | 0)) {
    HEAP32[i14 >> 2] = 0;
    HEAP32[i8 >> 2] = 0;
    i11 = (__ZN2cv6String8allocateEj(i14, 32) | 0) + 0 | 0;
    i12 = 701952 | 0;
    i13 = i11 + 32 | 0;
    do {
     HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
     i11 = i11 + 1 | 0;
     i12 = i12 + 1 | 0;
    } while ((i11 | 0) < (i13 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i14, 701928, 701600, 3060);
    __ZN2cv6String10deallocateEv(i14);
   }
   i2 = i16 + (i7 << 2) | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) >= 0) {
    i4 = 0;
    f6 = Math_fround(-3402823469999999843913219.0e14);
    while (1) {
     f21 = f6;
     f6 = Math_fround(HEAPF32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2]);
     if (f6 <= f21) {
      HEAP32[i15 >> 2] = 0;
      HEAP32[i9 >> 2] = 0;
      i11 = (__ZN2cv6String8allocateEj(i15, 39) | 0) + 0 | 0;
      i12 = 701992 | 0;
      i13 = i11 + 39 | 0;
      do {
       HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
       i11 = i11 + 1 | 0;
       i12 = i12 + 1 | 0;
      } while ((i11 | 0) < (i13 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i15, 701928, 701600, 3066);
      __ZN2cv6String10deallocateEv(i15);
      i3 = HEAP32[i2 >> 2] | 0;
     }
     HEAPF32[i1 + (i4 << 2) >> 2] = f6;
     if ((i4 | 0) >= (i3 | 0)) break; else i4 = i4 + 1 | 0;
    }
   }
   HEAP32[(HEAP32[i10 >> 2] | 0) + (i7 << 2) >> 2] = i1;
   i7 = i7 + 1 | 0;
   if ((i7 | 0) >= (i17 | 0)) break; else i1 = i1 + (i3 + 1 << 2) | 0;
  }
 }
 HEAP32[i18 >> 2] = HEAP32[i18 >> 2] & -3073 | 2048;
 STACKTOP = i20;
 return;
}

function __ZN7testing8internal24XmlUnitTestResultPrinter9EscapeXmlERKNSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEb(i19, i16, i15) {
 i19 = i19 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i17 = i21 + 16 | 0;
 i1 = i21 + 30 | 0;
 i7 = i21 + 29 | 0;
 i8 = i21 + 28 | 0;
 i20 = i21 + 12 | 0;
 i9 = i21;
 __ZN7testing7MessageC2Ev(i20);
 i10 = i16 + 1 | 0;
 i18 = HEAP32[i20 >> 2] | 0;
 i11 = i18 + 8 | 0;
 i12 = i9 + 1 | 0;
 i13 = i9 + 8 | 0;
 i4 = i9 + 4 | 0;
 i5 = i16 + 8 | 0;
 i6 = i16 + 4 | 0;
 i14 = 0;
 while (1) {
  i3 = HEAP8[i16 >> 0] | 0;
  i2 = (i3 & 1) == 0;
  if (i2) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i6 >> 2] | 0;
  if (i14 >>> 0 >= i3 >>> 0) break;
  if (i2) i3 = i10; else i3 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP8[i3 + i14 >> 0] | 0;
  L11 : do switch (i3 << 24 >> 24 | 0) {
  case 39:
   if (i15) {
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i11, 163032, 6) | 0;
    break L11;
   } else {
    HEAP8[i8 >> 0] = 39;
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i11, i8, 1) | 0;
    break L11;
   }
  case 34:
   if (i15) {
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i11, 163040, 6) | 0;
    break L11;
   } else {
    HEAP8[i7 >> 0] = 34;
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i11, i7, 1) | 0;
    break L11;
   }
  case 38:
   {
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i11, 163024, 5) | 0;
    break;
   }
  case 62:
   {
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i11, 163016, 4) | 0;
    break;
   }
  case 60:
   {
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i11, 163008, 4) | 0;
    break;
   }
  default:
   {
    if (!(i3 << 24 >> 24 == 13 | i3 << 24 >> 24 == 10 | i3 << 24 >> 24 == 9) ? i3 << 24 >> 24 <= 31 : 0) break L11;
    if (i15 ? i3 << 24 >> 24 == 13 | i3 << 24 >> 24 == 10 | i3 << 24 >> 24 == 9 : 0) {
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i11, 163048, 3) | 0;
     __ZN7testing8internal6String10FormatByteEh(i9, i3);
     i3 = HEAP8[i9 >> 0] | 0;
     if (!(i3 & 1)) {
      i2 = i12;
      i3 = (i3 & 255) >>> 1;
     } else {
      i2 = HEAP32[i13 >> 2] | 0;
      i3 = HEAP32[i4 >> 2] | 0;
     }
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i11, i2, i3) | 0;
     __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i11, 163056, 1) | 0;
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
     break L11;
    }
    HEAP8[i1 >> 0] = i3;
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i11, i1, 1) | 0;
   }
  } while (0);
  i14 = i14 + 1 | 0;
 }
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i17, i18 + 12 | 0);
 i1 = HEAP8[i17 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i17 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i17 + 8 >> 2] | 0;
  i1 = HEAP32[i17 + 4 >> 2] | 0;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i19 + 0 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i19, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i19, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i19, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
 if (!i18) {
  STACKTOP = i21;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i18 >> 2] | 0) + 4 >> 2] & 511](i18);
 HEAP32[i20 >> 2] = 0;
 STACKTOP = i21;
 return;
}

function __ZNK2cv11_InputArray8sameSizeERKS0_(i3, i7) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i9 + 8 | 0;
 i6 = i9;
 i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3) | 0;
 i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] & 127](i7) | 0;
 L1 : do if ((i4 | 0) == 65536) {
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  if ((i5 | 0) == 65536) {
   i4 = HEAP32[i1 + 40 >> 2] | 0;
   i3 = HEAP32[i4 + -4 >> 2] | 0;
   i1 = HEAP32[(HEAP32[i7 + 8 >> 2] | 0) + 40 >> 2] | 0;
   if ((i3 | 0) != (HEAP32[i1 + -4 >> 2] | 0)) {
    i1 = 0;
    break;
   }
   if ((i3 | 0) == 2) {
    if ((HEAP32[i4 >> 2] | 0) != (HEAP32[i1 >> 2] | 0)) {
     i1 = 0;
     break;
    }
    i1 = (HEAP32[i4 + 4 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0);
    break;
   }
   if ((i3 | 0) > 0) i2 = 0; else {
    i1 = 1;
    break;
   }
   while (1) {
    if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) != (HEAP32[i1 + (i2 << 2) >> 2] | 0)) {
     i1 = 0;
     break L1;
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i3 | 0)) {
     i1 = 1;
     break;
    }
   }
  } else if ((i5 | 0) == 655360) {
   i4 = HEAP32[i1 + 40 >> 2] | 0;
   i3 = HEAP32[i4 + -4 >> 2] | 0;
   i1 = HEAP32[(HEAP32[i7 + 8 >> 2] | 0) + 32 >> 2] | 0;
   if ((i3 | 0) != (HEAP32[i1 + -4 >> 2] | 0)) {
    i1 = 0;
    break;
   }
   if ((i3 | 0) == 2) {
    if ((HEAP32[i4 >> 2] | 0) != (HEAP32[i1 >> 2] | 0)) {
     i1 = 0;
     break;
    }
    i1 = (HEAP32[i4 + 4 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0);
    break;
   }
   if ((i3 | 0) > 0) i2 = 0; else {
    i1 = 1;
    break;
   }
   while (1) {
    if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) != (HEAP32[i1 + (i2 << 2) >> 2] | 0)) {
     i1 = 0;
     break L1;
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i3 | 0)) {
     i1 = 1;
     break;
    }
   }
  } else {
   if ((HEAP32[i1 + 4 >> 2] | 0) > 2) {
    i1 = 0;
    break;
   }
   i1 = HEAP32[i1 + 40 >> 2] | 0;
   i4 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   i8 = 37;
   break;
  }
 } else if ((i4 | 0) == 655360) {
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  if ((i5 | 0) == 655360) {
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i4 = HEAP32[i3 + -4 >> 2] | 0;
   i1 = HEAP32[(HEAP32[i7 + 8 >> 2] | 0) + 32 >> 2] | 0;
   if ((i4 | 0) != (HEAP32[i1 + -4 >> 2] | 0)) {
    i1 = 0;
    break;
   }
   if ((i4 | 0) == 2) {
    if ((HEAP32[i3 >> 2] | 0) != (HEAP32[i1 >> 2] | 0)) {
     i1 = 0;
     break;
    }
    i1 = (HEAP32[i3 + 4 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0);
    break;
   }
   if ((i4 | 0) > 0) i2 = 0; else {
    i1 = 1;
    break;
   }
   while (1) {
    if ((HEAP32[i3 + (i2 << 2) >> 2] | 0) != (HEAP32[i1 + (i2 << 2) >> 2] | 0)) {
     i1 = 0;
     break L1;
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i4 | 0)) {
     i1 = 1;
     break;
    }
   }
  } else if ((i5 | 0) == 65536) {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i3 = HEAP32[i4 + -4 >> 2] | 0;
   i1 = HEAP32[(HEAP32[i7 + 8 >> 2] | 0) + 40 >> 2] | 0;
   if ((i3 | 0) != (HEAP32[i1 + -4 >> 2] | 0)) {
    i1 = 0;
    break;
   }
   if ((i3 | 0) == 2) {
    if ((HEAP32[i4 >> 2] | 0) != (HEAP32[i1 >> 2] | 0)) {
     i1 = 0;
     break;
    }
    i1 = (HEAP32[i4 + 4 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0);
    break;
   }
   if ((i3 | 0) > 0) i2 = 0; else {
    i1 = 1;
    break;
   }
   while (1) {
    if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) != (HEAP32[i1 + (i2 << 2) >> 2] | 0)) {
     i1 = 0;
     break L1;
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i3 | 0)) {
     i1 = 1;
     break;
    }
   }
  } else {
   if ((HEAP32[i1 + 4 >> 2] | 0) > 2) {
    i1 = 0;
    break;
   }
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   i4 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   i8 = 37;
   break;
  }
 } else {
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] & 63](i2, i3, -1);
  i4 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = 37;
 } while (0);
 if ((i8 | 0) == 37) if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] & 127](i7, -1) | 0) <= 2 ? (FUNCTION_TABLE_viii[HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] & 63](i6, i7, -1), (i4 | 0) == (HEAP32[i6 >> 2] | 0)) : 0) i1 = (i1 | 0) == (HEAP32[i6 + 4 >> 2] | 0); else i1 = 0;
 STACKTOP = i9;
 return i1 | 0;
}

function _cvInitMatNDHeader(i17, i16, i13, i2, i15) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i3 = i18 + 40 | 0;
 i4 = i18 + 32 | 0;
 i5 = i18 + 24 | 0;
 i6 = i18 + 16 | 0;
 i11 = i18 + 8 | 0;
 i12 = i18;
 i14 = i2 & 4095;
 i1 = (i2 >>> 3 & 511) + 1 << (47696 >>> (i2 << 1 & 14) & 3);
 i2 = ((i1 | 0) < 0) << 31 >> 31;
 if (!i17) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i8 = (__ZN2cv6String8allocateEj(i3, 26) | 0) + 0 | 0;
  i9 = 41200 | 0;
  i10 = i8 + 26 | 0;
  do {
   HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
   i8 = i8 + 1 | 0;
   i9 = i9 + 1 | 0;
  } while ((i8 | 0) < (i10 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i3, 41232, 40912, 237);
  __ZN2cv6String10deallocateEv(i3);
 }
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i8 = (__ZN2cv6String8allocateEj(i4, 23) | 0) + 0 | 0;
  i9 = 41256 | 0;
  i10 = i8 + 23 | 0;
  do {
   HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
   i8 = i8 + 1 | 0;
   i9 = i9 + 1 | 0;
  } while ((i8 | 0) < (i10 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-210, i4, 41232, 40912, 240);
  __ZN2cv6String10deallocateEv(i4);
 }
 if (!i13) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i8 = (__ZN2cv6String8allocateEj(i5, 20) | 0) + 0 | 0;
  i9 = 41280 | 0;
  i10 = i8 + 20 | 0;
  do {
   HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
   i8 = i8 + 1 | 0;
   i9 = i9 + 1 | 0;
  } while ((i8 | 0) < (i10 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i5, 41232, 40912, 243);
  __ZN2cv6String10deallocateEv(i5);
 }
 if ((i16 + -1 | 0) >>> 0 > 31) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i8 = (__ZN2cv6String8allocateEj(i6, 46) | 0) + 0 | 0;
  i9 = 41304 | 0;
  i10 = i8 + 46 | 0;
  do {
   HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
   i8 = i8 + 1 | 0;
   i9 = i9 + 1 | 0;
  } while ((i8 | 0) < (i10 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i6, 41232, 40912, 247);
  __ZN2cv6String10deallocateEv(i6);
 }
 if ((i16 | 0) <= 0) {
  i8 = i2;
  i10 = i1;
  i9 = (i8 | 0) < 0;
  i10 = i10 >>> 0 < 2147483648;
  i8 = (i8 | 0) == 0;
  i10 = i8 & i10;
  i10 = i9 | i10;
  i10 = i10 ? 1111703552 : 1111687168;
  i10 = i10 | i14;
  HEAP32[i17 >> 2] = i10;
  i10 = i17 + 4 | 0;
  HEAP32[i10 >> 2] = i16;
  i10 = i17 + 16 | 0;
  HEAP32[i10 >> 2] = i15;
  i10 = i17 + 8 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = i17 + 12 | 0;
  HEAP32[i10 >> 2] = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 i4 = i11 + 4 | 0;
 i7 = i12 + 4 | 0;
 i5 = i16;
 do {
  i5 = i5 + -1 | 0;
  i6 = i13 + (i5 << 2) | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) < 0) {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   i8 = (__ZN2cv6String8allocateEj(i11, 37) | 0) + 0 | 0;
   i9 = 41352 | 0;
   i10 = i8 + 37 | 0;
   do {
    HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
    i8 = i8 + 1 | 0;
    i9 = i9 + 1 | 0;
   } while ((i8 | 0) < (i10 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i11, 41232, 40912, 252);
   __ZN2cv6String10deallocateEv(i11);
   i3 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i17 + (i5 << 3) + 20 >> 2] = i3;
  if ((i2 | 0) > 0 | (i2 | 0) == 0 & i1 >>> 0 > 2147483647) {
   HEAP32[i12 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   i8 = (__ZN2cv6String8allocateEj(i12, 20) | 0) + 0 | 0;
   i9 = 41392 | 0;
   i10 = i8 + 20 | 0;
   do {
    HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
    i8 = i8 + 1 | 0;
    i9 = i9 + 1 | 0;
   } while ((i8 | 0) < (i10 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i12, 41232, 40912, 255);
   __ZN2cv6String10deallocateEv(i12);
  }
  HEAP32[i17 + (i5 << 3) + 24 >> 2] = i1;
  i10 = HEAP32[i6 >> 2] | 0;
  i1 = ___muldi3(i10 | 0, ((i10 | 0) < 0) << 31 >> 31 | 0, i1 | 0, i2 | 0) | 0;
  i2 = tempRet0;
 } while ((i5 | 0) > 0);
 i9 = (i2 | 0) < 0;
 i10 = i1 >>> 0 < 2147483648;
 i8 = (i2 | 0) == 0;
 i10 = i8 & i10;
 i10 = i9 | i10;
 i10 = i10 ? 1111703552 : 1111687168;
 i10 = i10 | i14;
 HEAP32[i17 >> 2] = i10;
 i10 = i17 + 4 | 0;
 HEAP32[i10 >> 2] = i16;
 i10 = i17 + 16 | 0;
 HEAP32[i10 >> 2] = i15;
 i10 = i17 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 i10 = i17 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN2cvL6mul16sEPKsjS1_jPsjNS_5Size_IiEEPv(i7, i2, i6, i4, i8, i5, i3, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0;
 i18 = STACKTOP;
 f13 = Math_fround(+HEAPF64[i1 >> 3]);
 i17 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i16 = i2 >>> 1;
 i15 = i4 >>> 1;
 i14 = i5 >>> 1;
 i5 = i1 + -1 | 0;
 i1 = (i1 | 0) == 0;
 if (f13 == Math_fround(1.0)) {
  if (i1) {
   STACKTOP = i18;
   return;
  }
  i10 = i17 + -4 | 0;
  i11 = (i10 | 0) < 0;
  i12 = (i10 | 0) > 3 ? i17 & -4 : 4;
  i9 = i5;
  while (1) {
   if (i11) i4 = 0; else {
    i1 = 0;
    do {
     i5 = Math_imul(HEAP16[i6 + (i1 << 1) >> 1] | 0, HEAP16[i7 + (i1 << 1) >> 1] | 0) | 0;
     if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
     i3 = i1 | 1;
     i4 = Math_imul(HEAP16[i6 + (i3 << 1) >> 1] | 0, HEAP16[i7 + (i3 << 1) >> 1] | 0) | 0;
     if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
     HEAP16[i8 + (i1 << 1) >> 1] = i5;
     HEAP16[i8 + (i3 << 1) >> 1] = i4;
     i2 = i1 | 2;
     i5 = Math_imul(HEAP16[i6 + (i2 << 1) >> 1] | 0, HEAP16[i7 + (i2 << 1) >> 1] | 0) | 0;
     if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
     i3 = i1 | 3;
     i4 = Math_imul(HEAP16[i6 + (i3 << 1) >> 1] | 0, HEAP16[i7 + (i3 << 1) >> 1] | 0) | 0;
     if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
     HEAP16[i8 + (i2 << 1) >> 1] = i5;
     HEAP16[i8 + (i3 << 1) >> 1] = i4;
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) <= (i10 | 0));
    i4 = i12;
   }
   if ((i4 | 0) < (i17 | 0)) do {
    i5 = Math_imul(HEAP16[i6 + (i4 << 1) >> 1] | 0, HEAP16[i7 + (i4 << 1) >> 1] | 0) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i17 | 0));
   if (!i9) break; else {
    i6 = i6 + (i15 << 1) | 0;
    i7 = i7 + (i16 << 1) | 0;
    i8 = i8 + (i14 << 1) | 0;
    i9 = i9 + -1 | 0;
   }
  }
  STACKTOP = i18;
  return;
 } else {
  if (i1) {
   STACKTOP = i18;
   return;
  }
  i12 = i17 + -4 | 0;
  i11 = (i12 | 0) < 0;
  i10 = (i12 | 0) > 3 ? i17 & -4 : 4;
  i9 = i5;
  while (1) {
   if (i11) i5 = 0; else {
    i1 = 0;
    do {
     f19 = Math_fround(f13 * Math_fround(HEAP16[i7 + (i1 << 1) >> 1] | 0));
     i5 = _lrint(+Math_fround(f19 * Math_fround(HEAP16[i6 + (i1 << 1) >> 1] | 0))) | 0;
     if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
     i3 = i1 | 1;
     f19 = Math_fround(f13 * Math_fround(HEAP16[i7 + (i3 << 1) >> 1] | 0));
     i4 = _lrint(+Math_fround(f19 * Math_fround(HEAP16[i6 + (i3 << 1) >> 1] | 0))) | 0;
     if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
     HEAP16[i8 + (i1 << 1) >> 1] = i5;
     HEAP16[i8 + (i3 << 1) >> 1] = i4;
     i2 = i1 | 2;
     f19 = Math_fround(f13 * Math_fround(HEAP16[i7 + (i2 << 1) >> 1] | 0));
     i5 = _lrint(+Math_fround(f19 * Math_fround(HEAP16[i6 + (i2 << 1) >> 1] | 0))) | 0;
     if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
     i3 = i1 | 3;
     f19 = Math_fround(f13 * Math_fround(HEAP16[i7 + (i3 << 1) >> 1] | 0));
     i4 = _lrint(+Math_fround(f19 * Math_fround(HEAP16[i6 + (i3 << 1) >> 1] | 0))) | 0;
     if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
     HEAP16[i8 + (i2 << 1) >> 1] = i5;
     HEAP16[i8 + (i3 << 1) >> 1] = i4;
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) <= (i12 | 0));
    i5 = i10;
   }
   if ((i5 | 0) < (i17 | 0)) do {
    f19 = Math_fround(f13 * Math_fround(HEAP16[i7 + (i5 << 1) >> 1] | 0));
    i4 = _lrint(+Math_fround(f19 * Math_fround(HEAP16[i6 + (i5 << 1) >> 1] | 0))) | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i5 << 1) >> 1] = i4;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i17 | 0));
   if (!i9) break; else {
    i6 = i6 + (i15 << 1) | 0;
    i7 = i7 + (i16 << 1) | 0;
    i8 = i8 + (i14 << 1) | 0;
    i9 = i9 + -1 | 0;
   }
  }
  STACKTOP = i18;
  return;
 }
}

function _cvGetFileNodeByName(i8, i2, i11) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i14 + 16 | 0;
 i3 = i14 + 8 | 0;
 i12 = i14;
 if (!i8) {
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 if ((HEAP32[i8 >> 2] | 0) != 1280131417) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i4, 31) | 0) + 0 | 0;
  i5 = 9096 | 0;
  i6 = i1 + 31 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i4, 9240, 8960, 709);
  __ZN2cv6String10deallocateEv(i4);
 }
 if (!i11) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i3, 17) | 0) + 0 | 0;
  i5 = 9264 | 0;
  i6 = i1 + 17 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i3, 9240, 8960, 712);
  __ZN2cv6String10deallocateEv(i3);
 }
 i1 = HEAP8[i11 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  i10 = 0;
  i4 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  do {
   i3 = (i1 & 255) + (i3 * 33 | 0) | 0;
   i4 = i4 + 1 | 0;
   i1 = HEAP8[i11 + i4 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
  i10 = i3 & 2147483647;
 }
 i6 = (i2 | 0) != 0;
 L15 : do if (!i6) {
  i3 = HEAP32[i8 + 32 >> 2] | 0;
  if (!i3) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  i7 = HEAP32[i3 + 24 >> 2] | 0;
  if ((i7 | 0) <= 0) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  i9 = i8 + 32 | 0;
  if (i6) i13 = 13; else {
   i8 = 0;
   while (1) {
    i2 = _cvGetSeqElem(HEAP32[i9 >> 2] | 0, i8) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    i6 = i1 & 7;
    if ((i6 | 0) == 5) {
     i13 = 26;
     break L15;
    } else if ((i6 | 0) != 6) break L15;
    i2 = HEAP32[i2 + 8 >> 2] | 0;
    i6 = HEAP32[i2 + 64 >> 2] | 0;
    i5 = i6 + -1 | 0;
    if (!(i5 & i6)) i3 = i5 & i10; else i3 = (i10 >>> 0) % (i6 >>> 0) | 0;
    i1 = HEAP32[(HEAP32[i2 + 68 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    if (i1) do {
     i3 = HEAP32[i1 + 16 >> 2] | 0;
     if (((HEAP32[i3 >> 2] | 0) == (i10 | 0) ? (HEAP32[i3 + 4 >> 2] | 0) == (i4 | 0) : 0) ? (_memcmp(HEAP32[i3 + 8 >> 2] | 0, i11, i4) | 0) == 0 : 0) {
      i13 = 37;
      break L15;
     }
     i1 = HEAP32[i1 + 20 >> 2] | 0;
    } while ((i1 | 0) != 0);
    i8 = i8 + 1 | 0;
    if ((i8 | 0) >= (i7 | 0)) {
     i1 = 0;
     break;
    }
   }
   STACKTOP = i14;
   return i1 | 0;
  }
 } else {
  i7 = 1;
  i13 = 13;
 } while (0);
 L40 : do if ((i13 | 0) == 13) {
  i8 = 0;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = i1 & 7;
   if ((i3 | 0) == 5) {
    i13 = 26;
    break L40;
   } else if ((i3 | 0) != 6) break L40;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   i6 = HEAP32[i1 + 64 >> 2] | 0;
   i5 = i6 + -1 | 0;
   if (!(i5 & i6)) i3 = i5 & i10; else i3 = (i10 >>> 0) % (i6 >>> 0) | 0;
   i1 = HEAP32[(HEAP32[i1 + 68 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if (i1) do {
    i3 = HEAP32[i1 + 16 >> 2] | 0;
    if (((HEAP32[i3 >> 2] | 0) == (i10 | 0) ? (HEAP32[i3 + 4 >> 2] | 0) == (i4 | 0) : 0) ? (_memcmp(HEAP32[i3 + 8 >> 2] | 0, i11, i4) | 0) == 0 : 0) {
     i13 = 37;
     break L40;
    }
    i1 = HEAP32[i1 + 20 >> 2] | 0;
   } while ((i1 | 0) != 0);
   i8 = i8 + 1 | 0;
   if ((i8 | 0) >= (i7 | 0)) {
    i1 = 0;
    break;
   }
  }
  STACKTOP = i14;
  return i1 | 0;
 } while (0);
 if ((i13 | 0) == 26) {
  if (!(HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 24 >> 2] | 0)) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
 } else if ((i13 | 0) == 37) {
  i10 = i1;
  STACKTOP = i14;
  return i10 | 0;
 }
 if (!(i1 & 7)) {
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i1 = (__ZN2cv6String8allocateEj(i12, 49) | 0) + 0 | 0;
 i5 = 9168 | 0;
 i6 = i1 + 49 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i5 = i5 + 1 | 0;
 } while ((i1 | 0) < (i6 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i12, 9240, 8960, 739);
 __ZN2cv6String10deallocateEv(i12);
 i10 = 0;
 STACKTOP = i14;
 return i10 | 0;
}

function __ZNK2cv3Mat7reshapeEii(i16, i14, i6, i2) {
 i16 = i16 | 0;
 i14 = i14 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i5 = i17 + 32 | 0;
 i11 = i17 + 24 | 0;
 i12 = i17 + 16 | 0;
 i13 = i17 + 8 | 0;
 i15 = i17;
 i7 = ((HEAP32[i14 >> 2] | 0) >>> 3 & 511) + 1 | 0;
 __ZN2cv3MatC2ERKS0_(i16, i14);
 i4 = i14 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i8 = (i2 | 0) == 0;
 if ((i3 | 0) > 2 & i8 & (i6 | 0) != 0 ? (i1 = i3 + -1 | 0, ((Math_imul(HEAP32[(HEAP32[i14 + 40 >> 2] | 0) + (i1 << 2) >> 2] | 0, i7) | 0) % (i6 | 0) | 0 | 0) == 0) : 0) {
  i10 = HEAP32[i16 >> 2] | 0;
  i9 = (i6 << 3) + -8 | 0;
  HEAP32[i16 >> 2] = i10 & -4089 | i9;
  HEAP32[(HEAP32[i16 + 44 >> 2] | 0) + (i1 << 2) >> 2] = (i9 >>> 3 & 511) + 1 << (47696 >>> (i10 << 1 & 14) & 3);
  i10 = (HEAP32[i16 + 40 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) + -1 << 2) | 0;
  HEAP32[i10 >> 2] = (Math_imul(HEAP32[i10 >> 2] | 0, i7) | 0) / (i6 | 0) | 0;
  STACKTOP = i17;
  return;
 }
 if ((i3 | 0) >= 3) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i5, 9) | 0) + 0 | 0;
  i9 = 28168 | 0;
  i10 = i4 + 9 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i9 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i9 = i9 + 1 | 0;
  } while ((i4 | 0) < (i10 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 28416, 27528, 966);
  __ZN2cv6String10deallocateEv(i5);
 }
 i6 = (i6 | 0) == 0 ? i7 : i6;
 i1 = Math_imul(HEAP32[i14 + 12 >> 2] | 0, i7) | 0;
 if ((i6 | 0) > (i1 | 0)) if (i8) i3 = 9; else i3 = 11; else if (((i1 | 0) % (i6 | 0) | 0 | 0) != 0 & i8) i3 = 9; else i3 = 10;
 if ((i3 | 0) == 9) {
  i2 = (Math_imul(HEAP32[i14 + 8 >> 2] | 0, i1) | 0) / (i6 | 0) | 0;
  i3 = 10;
 }
 if ((i3 | 0) == 10) if (i2) i3 = 11;
 if ((i3 | 0) == 11) {
  i3 = HEAP32[i14 + 8 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i3 = Math_imul(i3, i1) | 0;
   if (!(HEAP32[i14 >> 2] & 16384)) {
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    i4 = (__ZN2cv6String8allocateEj(i11, 72) | 0) + 0 | 0;
    i9 = 28424 | 0;
    i10 = i4 + 72 | 0;
    do {
     HEAP8[i4 >> 0] = HEAP8[i9 >> 0] | 0;
     i4 = i4 + 1 | 0;
     i9 = i9 + 1 | 0;
    } while ((i4 | 0) < (i10 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-13, i11, 28416, 27528, 981);
    __ZN2cv6String10deallocateEv(i11);
   }
   if (i2 >>> 0 > i3 >>> 0) {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    i4 = (__ZN2cv6String8allocateEj(i12, 22) | 0) + 0 | 0;
    i9 = 28504 | 0;
    i10 = i4 + 22 | 0;
    do {
     HEAP8[i4 >> 0] = HEAP8[i9 >> 0] | 0;
     i4 = i4 + 1 | 0;
     i9 = i9 + 1 | 0;
    } while ((i4 | 0) < (i10 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i12, 28416, 27528, 984);
    __ZN2cv6String10deallocateEv(i12);
   }
   i1 = (i3 | 0) / (i2 | 0) | 0;
   if ((Math_imul(i1, i2) | 0) != (i3 | 0)) {
    HEAP32[i13 >> 2] = 0;
    HEAP32[i13 + 4 >> 2] = 0;
    i4 = (__ZN2cv6String8allocateEj(i13, 78) | 0) + 0 | 0;
    i9 = 28528 | 0;
    i10 = i4 + 78 | 0;
    do {
     HEAP8[i4 >> 0] = HEAP8[i9 >> 0] | 0;
     i4 = i4 + 1 | 0;
     i9 = i9 + 1 | 0;
    } while ((i4 | 0) < (i10 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i13, 28416, 27528, 990);
    __ZN2cv6String10deallocateEv(i13);
   }
   HEAP32[i16 + 8 >> 2] = i2;
   i10 = Math_imul(1212424721 >>> (HEAP32[i14 >> 2] << 2 & 28) & 15, i1) | 0;
   HEAP32[HEAP32[i16 + 44 >> 2] >> 2] = i10;
  }
 }
 i2 = (i1 | 0) / (i6 | 0) | 0;
 if ((Math_imul(i2, i6) | 0) != (i1 | 0)) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i15, 62) | 0) + 0 | 0;
  i9 = 28608 | 0;
  i10 = i4 + 62 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i9 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i9 = i9 + 1 | 0;
  } while ((i4 | 0) < (i10 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-15, i15, 28416, 27528, 1e3);
  __ZN2cv6String10deallocateEv(i15);
 }
 HEAP32[i16 + 12 >> 2] = i2;
 i10 = HEAP32[i16 >> 2] | 0;
 i9 = (i6 << 3) + -8 | 0;
 HEAP32[i16 >> 2] = i10 & -4089 | i9;
 HEAP32[(HEAP32[i16 + 44 >> 2] | 0) + 4 >> 2] = (i9 >>> 3 & 511) + 1 << (47696 >>> (i10 << 1 & 14) & 3);
 STACKTOP = i17;
 return;
}

function __ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe(i30, i1, i29, i7, i26, i25, d4) {
 i30 = i30 | 0;
 i1 = i1 | 0;
 i29 = i29 | 0;
 i7 = i7 | 0;
 i26 = i26 | 0;
 i25 = i25 | 0;
 d4 = +d4;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 992 | 0;
 i9 = i20;
 i1 = i20 + 884 | 0;
 i5 = i20 + 880 | 0;
 i3 = i20 + 480 | 0;
 i13 = i20 + 476 | 0;
 i16 = i20 + 472 | 0;
 i11 = i20 + 468 | 0;
 i19 = i20 + 464 | 0;
 i12 = i20 + 452 | 0;
 i18 = i20 + 440 | 0;
 i17 = i20 + 428 | 0;
 i6 = i20 + 424 | 0;
 i8 = i20 + 24 | 0;
 i15 = i20 + 16 | 0;
 i14 = i20 + 12 | 0;
 i10 = i20 + 8 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAPF64[tempDoublePtr >> 3] = d4;
 HEAP32[i9 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 i1 = _snprintf(i1, 100, 960480, i9) | 0;
 if (i1 >>> 0 > 99) {
  i1 = __ZNSt3__16__clocEv() | 0;
  HEAPF64[tempDoublePtr >> 3] = d4;
  HEAP32[i9 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i1 = __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz(i5, i1, 960480, i9) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (!i2) __ZSt17__throw_bad_allocv();
  i3 = _malloc(i1 << 2) | 0;
  if (!i3) __ZSt17__throw_bad_allocv(); else {
   i22 = i3;
   i23 = i2;
   i24 = i3;
   i28 = i1;
  }
 } else {
  i22 = 0;
  i23 = 0;
  i24 = i3;
  i28 = i1;
 }
 __ZNKSt3__18ios_base6getlocEv(i13, i26);
 i3 = __ZNKSt3__16locale9use_facetERNS0_2idE(i13, 960720) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] & 7](i3, i1, i1 + i28 | 0, i24) | 0;
 if (!i28) i5 = 0; else i5 = (HEAP8[HEAP32[i5 >> 2] >> 0] | 0) == 45;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i12 + 0 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i18 + 0 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i17 + 0 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 __ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri(i7, i5, i13, i16, i11, i19, i12, i18, i17, i6);
 i7 = HEAP32[i6 >> 2] | 0;
 if ((i28 | 0) > (i7 | 0)) {
  i1 = HEAP8[i17 >> 0] | 0;
  if (!(i1 & 1)) i2 = (i1 & 255) >>> 1; else i2 = HEAP32[i17 + 4 >> 2] | 0;
  i1 = HEAP8[i18 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i18 + 4 >> 2] | 0;
  i1 = i2 + (i28 - i7 << 1 | 1) + i1 | 0;
 } else {
  i1 = HEAP8[i17 >> 0] | 0;
  if (!(i1 & 1)) i2 = (i1 & 255) >>> 1; else i2 = HEAP32[i17 + 4 >> 2] | 0;
  i1 = HEAP8[i18 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i18 + 4 >> 2] | 0;
  i1 = i2 + 2 + i1 | 0;
 }
 i1 = i1 + i7 | 0;
 if (i1 >>> 0 > 100) {
  i1 = _malloc(i1 << 2) | 0;
  if (!i1) __ZSt17__throw_bad_allocv(); else {
   i21 = i1;
   i27 = i1;
  }
 } else {
  i21 = 0;
  i27 = i8;
 }
 __ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i(i27, i15, i14, HEAP32[i26 + 4 >> 2] | 0, i24, i24 + (i28 << 2) | 0, i3, i5, i16, HEAP32[i11 >> 2] | 0, HEAP32[i19 >> 2] | 0, i12, i18, i17, i7);
 HEAP32[i10 >> 2] = HEAP32[i29 >> 2];
 i16 = HEAP32[i15 >> 2] | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i30, i9, i27, i16, i19, i26, i25);
 if (i21) _free(i21);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i17);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i18);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i13 >> 2] | 0) | 0;
 if (!i22) {
  _free(i23);
  STACKTOP = i20;
  return;
 }
 _free(i22);
 _free(i23);
 STACKTOP = i20;
 return;
}

function __ZN2cv5errorERKNS_9ExceptionE(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 65568 | 0;
 i5 = i4;
 i4 = i4 + 24 | 0;
 i1 = HEAP32[6348] | 0;
 i6 = i7 + 12 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  do switch (i2 | 0) {
  case -214:
   {
    i2 = 26552;
    break;
   }
  case -215:
   {
    i2 = 26584;
    break;
   }
  case -8:
   {
    i2 = 25920;
    break;
   }
  case -17:
   {
    i2 = 26112;
    break;
   }
  case -205:
   {
    i2 = 26160;
    break;
   }
  case -1:
   {
    i2 = 25792;
    break;
   }
  case -5:
   {
    i2 = 25872;
    break;
   }
  case -3:
   {
    i2 = 25832;
    break;
   }
  case -209:
   {
    i2 = 26200;
    break;
   }
  case -211:
   {
    i2 = 26240;
    break;
   }
  case -218:
   {
    i2 = 26640;
    break;
   }
  case -219:
   {
    i2 = 26664;
    break;
   }
  case 0:
   {
    i2 = 25776;
    break;
   }
  case -201:
   {
    i2 = 25936;
    break;
   }
  case -27:
   {
    i2 = 25968;
    break;
   }
  case -4:
   {
    i2 = 25848;
    break;
   }
  case -203:
   {
    i2 = 26040;
    break;
   }
  case -204:
   {
    i2 = 26080;
    break;
   }
  case -202:
   {
    i2 = 25984;
    break;
   }
  case -13:
   {
    i2 = 26016;
    break;
   }
  case -207:
   {
    i2 = 26432;
    break;
   }
  case -208:
   {
    i2 = 26464;
    break;
   }
  case -216:
   {
    i2 = 26608;
    break;
   }
  case -217:
   {
    i2 = 26624;
    break;
   }
  case -212:
   {
    i2 = 26496;
    break;
   }
  case -213:
   {
    i2 = 26512;
    break;
   }
  case -2:
   {
    i2 = 25808;
    break;
   }
  case -210:
   {
    i2 = 26288;
    break;
   }
  case -24:
   {
    i2 = 26336;
    break;
   }
  case -7:
   {
    i2 = 25888;
    break;
   }
  case -15:
   {
    i2 = 26368;
    break;
   }
  case -206:
   {
    i2 = 26392;
    break;
   }
  default:
   {
    HEAP32[i5 >> 2] = (i2 | 0) > -1 ? 26704 : 26712;
    HEAP32[i5 + 4 >> 2] = i2;
    _sprintf(25520, 26680, i5) | 0;
    i2 = 25520;
   }
  } while (0);
  i1 = HEAP32[i7 + 16 >> 2] | 0;
  if (!(HEAP32[i7 + 28 >> 2] | 0)) i3 = 25456; else {
   i3 = HEAP32[i7 + 24 >> 2] | 0;
   i3 = (i3 | 0) == 0 ? 26888 : i3;
  }
  i9 = HEAP32[i7 + 32 >> 2] | 0;
  i8 = HEAP32[i7 + 40 >> 2] | 0;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 + 4 >> 2] = (i1 | 0) == 0 ? 26888 : i1;
  HEAP32[i5 + 8 >> 2] = i3;
  HEAP32[i5 + 12 >> 2] = (i9 | 0) == 0 ? 26888 : i9;
  HEAP32[i5 + 16 >> 2] = i8;
  _sprintf(i4, 25408, i5) | 0;
  i1 = HEAP32[_stderr >> 2] | 0;
  HEAP32[i5 >> 2] = i4;
  _fprintf(i1 | 0, 25480, i5 | 0) | 0;
  _fflush(i1 | 0) | 0;
 } else {
  i5 = HEAP32[i7 + 24 >> 2] | 0;
  i4 = HEAP32[i7 + 16 >> 2] | 0;
  i3 = HEAP32[i7 + 32 >> 2] | 0;
  FUNCTION_TABLE_iiiiiii[i1 & 1](i2, (i5 | 0) == 0 ? 26888 : i5, (i4 | 0) == 0 ? 26888 : i4, (i3 | 0) == 0 ? 26888 : i3, HEAP32[i7 + 40 >> 2] | 0, HEAP32[6350] | 0) | 0;
 }
 if (HEAP8[25384] | 0) {
  HEAP32[0] = 0;
  abort();
 }
 i3 = ___cxa_allocate_exception(44) | 0;
 HEAP32[i3 >> 2] = 18928;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 if (i1) {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 }
 i2 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 HEAP32[i3 + 16 >> 2] = i1;
 HEAP32[i3 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 if (i1) {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 }
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[i7 + 24 >> 2] | 0;
 HEAP32[i3 + 24 >> 2] = i1;
 HEAP32[i3 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 if (i1) {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 }
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[i7 + 32 >> 2] | 0;
 HEAP32[i3 + 32 >> 2] = i1;
 HEAP32[i3 + 36 >> 2] = HEAP32[i7 + 36 >> 2];
 if (!i1) {
  i1 = i3 + 40 | 0;
  i2 = i7 + 40 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i2;
  ___cxa_throw(i3 | 0, 25504, 92);
 }
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i3 + 40 | 0;
 i2 = i7 + 40 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 ___cxa_throw(i3 | 0, 25504, 92);
}

function __ZN2cvL6div16sEPKsjS1_jPsjNS_5Size_IiEEPv(i7, i3, i6, i4, i8, i5, i1, i2) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d9 = 0.0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, d24 = 0.0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, d32 = 0.0, d33 = 0.0;
 i31 = STACKTOP;
 i26 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 d24 = +HEAPF64[i2 >> 3];
 i23 = i3 >>> 1;
 i22 = i4 >>> 1;
 i19 = i5 >>> 1;
 if (!i1) {
  STACKTOP = i31;
  return;
 }
 i20 = i26 + -4 | 0;
 i21 = (i20 | 0) < 0;
 i18 = (i20 | 0) > 3 ? i26 & -4 : 4;
 while (1) {
  i1 = i1 + -1 | 0;
  if (i21) i4 = 0; else {
   i17 = 0;
   do {
    i5 = HEAP16[i6 + (i17 << 1) >> 1] | 0;
    i16 = i17 | 1;
    i4 = HEAP16[i6 + (i16 << 1) >> 1] | 0;
    do if (!(i5 << 16 >> 16)) {
     i15 = 0;
     i25 = 20;
    } else {
     if ((i4 << 16 >> 16 != 0 ? (i27 = i17 | 2, i28 = HEAP16[i6 + (i27 << 1) >> 1] | 0, i28 << 16 >> 16 != 0) : 0) ? (i29 = i17 | 3, i30 = HEAP16[i6 + (i29 << 1) >> 1] | 0, i30 << 16 >> 16 != 0) : 0) {
      d10 = +(i5 << 16 >> 16);
      d32 = +(i4 << 16 >> 16);
      d33 = d10 * d32;
      d12 = +(i28 << 16 >> 16);
      d11 = +(i30 << 16 >> 16);
      d9 = d12 * d11;
      d13 = d24 / (d33 * d9);
      d9 = d9 * d13;
      d13 = d33 * d13;
      i5 = _lrint(d32 * (d9 * +(HEAP16[i7 + (i17 << 1) >> 1] | 0))) | 0;
      if ((i5 + 32768 | 0) >>> 0 < 65536) i14 = i5; else i14 = (i5 | 0) > 0 ? 32767 : -32768;
      i5 = _lrint(d10 * (d9 * +(HEAP16[i7 + (i16 << 1) >> 1] | 0))) | 0;
      if ((i5 + 32768 | 0) >>> 0 < 65536) i3 = i5; else i3 = (i5 | 0) > 0 ? 32767 : -32768;
      i5 = _lrint(d11 * (d13 * +(HEAP16[i7 + (i27 << 1) >> 1] | 0))) | 0;
      if ((i5 + 32768 | 0) >>> 0 < 65536) i4 = i5; else i4 = (i5 | 0) > 0 ? 32767 : -32768;
      i5 = _lrint(d12 * (d13 * +(HEAP16[i7 + (i29 << 1) >> 1] | 0))) | 0;
      if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
      HEAP16[i8 + (i17 << 1) >> 1] = i14;
      HEAP16[i8 + (i16 << 1) >> 1] = i3;
      HEAP16[i8 + (i27 << 1) >> 1] = i4;
      HEAP16[i8 + (i29 << 1) >> 1] = i5;
      break;
     }
     i5 = _lrint(d24 * +(HEAP16[i7 + (i17 << 1) >> 1] | 0) / +(i5 << 16 >> 16)) | 0;
     if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
     i15 = i5 & 65535;
     i25 = 20;
    } while (0);
    if ((i25 | 0) == 20) {
     i25 = 0;
     if (!(i4 << 16 >> 16)) i14 = 0; else {
      i5 = _lrint(d24 * +(HEAP16[i7 + (i16 << 1) >> 1] | 0) / +(i4 << 16 >> 16)) | 0;
      if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
      i14 = i5 & 65535;
     }
     i2 = i17 | 2;
     i5 = HEAP16[i6 + (i2 << 1) >> 1] | 0;
     if (!(i5 << 16 >> 16)) i3 = 0; else {
      i5 = _lrint(d24 * +(HEAP16[i7 + (i2 << 1) >> 1] | 0) / +(i5 << 16 >> 16)) | 0;
      if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
      i3 = i5 & 65535;
     }
     i4 = i17 | 3;
     i5 = HEAP16[i6 + (i4 << 1) >> 1] | 0;
     if (!(i5 << 16 >> 16)) i5 = 0; else {
      i5 = _lrint(d24 * +(HEAP16[i7 + (i4 << 1) >> 1] | 0) / +(i5 << 16 >> 16)) | 0;
      if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
      i5 = i5 & 65535;
     }
     HEAP16[i8 + (i17 << 1) >> 1] = i15;
     HEAP16[i8 + (i16 << 1) >> 1] = i14;
     HEAP16[i8 + (i2 << 1) >> 1] = i3;
     HEAP16[i8 + (i4 << 1) >> 1] = i5;
    }
    i17 = i17 + 4 | 0;
   } while ((i17 | 0) <= (i20 | 0));
   i4 = i18;
  }
  if ((i4 | 0) < (i26 | 0)) do {
   i5 = HEAP16[i6 + (i4 << 1) >> 1] | 0;
   if (!(i5 << 16 >> 16)) i5 = 0; else {
    i5 = _lrint(d24 * +(HEAP16[i7 + (i4 << 1) >> 1] | 0) / +(i5 << 16 >> 16)) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i5 = i5 & 65535;
   }
   HEAP16[i8 + (i4 << 1) >> 1] = i5;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i26 | 0));
  if (!i1) break; else {
   i6 = i6 + (i22 << 1) | 0;
   i7 = i7 + (i23 << 1) | 0;
   i8 = i8 + (i19 << 1) | 0;
  }
 }
 STACKTOP = i31;
 return;
}

function __ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE(i27, i1, i26, i3, i24, i23, i11) {
 i27 = i27 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 i3 = i3 | 0;
 i24 = i24 | 0;
 i23 = i23 | 0;
 i11 = i11 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 i8 = i21 + 472 | 0;
 i14 = i21 + 468 | 0;
 i17 = i21 + 464 | 0;
 i12 = i21 + 460 | 0;
 i20 = i21 + 456 | 0;
 i13 = i21 + 444 | 0;
 i19 = i21 + 432 | 0;
 i18 = i21 + 420 | 0;
 i4 = i21 + 416 | 0;
 i7 = i21 + 16 | 0;
 i16 = i21 + 8 | 0;
 i15 = i21 + 4 | 0;
 i9 = i21;
 __ZNKSt3__18ios_base6getlocEv(i14, i24);
 i10 = __ZNKSt3__16locale9use_facetERNS0_2idE(i14, 960720) | 0;
 i1 = HEAP8[i11 >> 0] | 0;
 i2 = (i1 & 1) == 0;
 if (i2) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i11 + 4 >> 2] | 0;
 if (!i1) i6 = 0; else {
  if (i2) i1 = i11 + 4 | 0; else i1 = HEAP32[i11 + 8 >> 2] | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  i6 = (i6 | 0) == (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i10 >> 2] | 0) + 44 >> 2] & 127](i10, 45) | 0);
 }
 HEAP32[i17 >> 2] = 0;
 HEAP32[i13 + 0 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i19 + 0 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i18 + 0 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 __ZNSt3__111__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri(i3, i6, i14, i17, i12, i20, i13, i19, i18, i4);
 i5 = HEAP8[i11 >> 0] | 0;
 i2 = (i5 & 1) == 0;
 if (i2) i1 = (i5 & 255) >>> 1; else i1 = HEAP32[i11 + 4 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) > (i4 | 0)) {
  if (i2) i3 = (i5 & 255) >>> 1; else i3 = HEAP32[i11 + 4 >> 2] | 0;
  i2 = HEAP8[i18 >> 0] | 0;
  if (!(i2 & 1)) i1 = (i2 & 255) >>> 1; else i1 = HEAP32[i18 + 4 >> 2] | 0;
  i2 = HEAP8[i19 >> 0] | 0;
  if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i19 + 4 >> 2] | 0;
  i1 = i1 + (i3 - i4 << 1 | 1) + i2 | 0;
 } else {
  i1 = HEAP8[i18 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i18 + 4 >> 2] | 0;
  i2 = HEAP8[i19 >> 0] | 0;
  if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i19 + 4 >> 2] | 0;
  i1 = i1 + 2 + i2 | 0;
 }
 i1 = i1 + i4 | 0;
 if (i1 >>> 0 > 100) {
  i1 = _malloc(i1 << 2) | 0;
  if (!i1) __ZSt17__throw_bad_allocv(); else {
   i22 = i1;
   i25 = i1;
  }
 } else {
  i22 = 0;
  i25 = i7;
 }
 if (!(i5 & 1)) {
  i2 = i11 + 4 | 0;
  i1 = (i5 & 255) >>> 1;
 } else {
  i2 = HEAP32[i11 + 8 >> 2] | 0;
  i1 = HEAP32[i11 + 4 >> 2] | 0;
 }
 __ZNSt3__111__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i(i25, i16, i15, HEAP32[i24 + 4 >> 2] | 0, i2, i2 + (i1 << 2) | 0, i10, i6, i17, HEAP32[i12 >> 2] | 0, HEAP32[i20 >> 2] | 0, i13, i19, i18, i4);
 HEAP32[i9 >> 2] = HEAP32[i26 >> 2];
 i17 = HEAP32[i16 >> 2] | 0;
 i20 = HEAP32[i15 >> 2] | 0;
 HEAP32[i8 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i27, i8, i25, i17, i20, i24, i23);
 if (!i22) {
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i18);
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i19);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
  i22 = HEAP32[i14 >> 2] | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(i22) | 0;
  STACKTOP = i21;
  return;
 }
 _free(i22);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i18);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i19);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
 i22 = HEAP32[i14 >> 2] | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(i22) | 0;
 STACKTOP = i21;
 return;
}

function __ZN2cvL8merge64sEPPKxPxii(i12, i10, i11, i9) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i13 = STACKTOP;
 i7 = (i9 | 0) % 4 | 0;
 i7 = (i7 | 0) == 0 ? 4 : i7;
 do if ((i7 | 0) == 2) {
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  if ((i11 | 0) > 0) {
   i1 = 0;
   i4 = 0;
   while (1) {
    i8 = i3 + (i1 << 3) | 0;
    i6 = HEAP32[i8 + 4 >> 2] | 0;
    i5 = i10 + (i4 << 3) | 0;
    HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i5 + 4 >> 2] = i6;
    i5 = i2 + (i1 << 3) | 0;
    i6 = HEAP32[i5 + 4 >> 2] | 0;
    i8 = i10 + (i4 + 1 << 3) | 0;
    HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i8 + 4 >> 2] = i6;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i11 | 0)) break; else i4 = i4 + i9 | 0;
   }
  }
 } else if ((i7 | 0) == 1) {
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i11 | 0) > 0) {
   i2 = 0;
   i3 = 0;
   while (1) {
    i5 = i1 + (i2 << 3) | 0;
    i6 = HEAP32[i5 + 4 >> 2] | 0;
    i8 = i10 + (i3 << 3) | 0;
    HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i8 + 4 >> 2] = i6;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i11 | 0)) break; else i3 = i3 + i9 | 0;
   }
  }
 } else {
  i8 = HEAP32[i12 >> 2] | 0;
  i6 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = HEAP32[i12 + 8 >> 2] | 0;
  if ((i7 | 0) == 3) {
   if ((i11 | 0) > 0) {
    i4 = 0;
    i3 = 0;
   } else break;
   while (1) {
    i14 = i8 + (i4 << 3) | 0;
    i1 = HEAP32[i14 + 4 >> 2] | 0;
    i2 = i10 + (i3 << 3) | 0;
    HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i2 + 4 >> 2] = i1;
    i2 = i6 + (i4 << 3) | 0;
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    i14 = i10 + (i3 + 1 << 3) | 0;
    HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i14 + 4 >> 2] = i1;
    i14 = i5 + (i4 << 3) | 0;
    i1 = HEAP32[i14 + 4 >> 2] | 0;
    i2 = i10 + (i3 + 2 << 3) | 0;
    HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i2 + 4 >> 2] = i1;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i11 | 0)) break; else i3 = i3 + i9 | 0;
   }
  } else {
   i4 = HEAP32[i12 + 12 >> 2] | 0;
   if ((i11 | 0) > 0) {
    i3 = 0;
    i2 = 0;
   } else break;
   while (1) {
    i1 = i8 + (i3 << 3) | 0;
    i14 = HEAP32[i1 + 4 >> 2] | 0;
    i15 = i10 + (i2 << 3) | 0;
    HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i15 + 4 >> 2] = i14;
    i15 = i6 + (i3 << 3) | 0;
    i14 = HEAP32[i15 + 4 >> 2] | 0;
    i1 = i10 + (i2 + 1 << 3) | 0;
    HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i1 + 4 >> 2] = i14;
    i1 = i5 + (i3 << 3) | 0;
    i14 = HEAP32[i1 + 4 >> 2] | 0;
    i15 = i10 + (i2 + 2 << 3) | 0;
    HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i15 + 4 >> 2] = i14;
    i15 = i4 + (i3 << 3) | 0;
    i14 = HEAP32[i15 + 4 >> 2] | 0;
    i1 = i10 + (i2 + 3 << 3) | 0;
    HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i1 + 4 >> 2] = i14;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i11 | 0)) break; else i2 = i2 + i9 | 0;
   }
  }
 } while (0);
 if ((i7 | 0) >= (i9 | 0)) {
  STACKTOP = i13;
  return;
 }
 i8 = (i11 | 0) > 0;
 do {
  i4 = HEAP32[i12 + (i7 << 2) >> 2] | 0;
  i3 = HEAP32[i12 + (i7 + 1 << 2) >> 2] | 0;
  i2 = HEAP32[i12 + (i7 + 2 << 2) >> 2] | 0;
  i1 = HEAP32[i12 + (i7 + 3 << 2) >> 2] | 0;
  if (i8) {
   i5 = 0;
   i6 = i7;
   while (1) {
    i14 = i4 + (i5 << 3) | 0;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = i10 + (i6 << 3) | 0;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i16 = i3 + (i5 << 3) | 0;
    i15 = HEAP32[i16 + 4 >> 2] | 0;
    i14 = i10 + (i6 + 1 << 3) | 0;
    HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i14 + 4 >> 2] = i15;
    i14 = i2 + (i5 << 3) | 0;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = i10 + (i6 + 2 << 3) | 0;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i16 = i1 + (i5 << 3) | 0;
    i15 = HEAP32[i16 + 4 >> 2] | 0;
    i14 = i10 + (i6 + 3 << 3) | 0;
    HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i14 + 4 >> 2] = i15;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i11 | 0)) break; else i6 = i6 + i9 | 0;
   }
  }
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 STACKTOP = i13;
 return;
}

function ___udivmoddi4(i8, i7, i2, i12, i14) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0;
 i11 = i8;
 i9 = i7;
 i10 = i9;
 i6 = i2;
 i13 = i12;
 i4 = i13;
 if (!i10) {
  i1 = (i14 | 0) != 0;
  if (!i4) {
   if (i1) {
    HEAP32[i14 >> 2] = (i11 >>> 0) % (i6 >>> 0);
    HEAP32[i14 + 4 >> 2] = 0;
   }
   i9 = 0;
   i10 = (i11 >>> 0) / (i6 >>> 0) >>> 0;
   return (tempRet0 = i9, i10) | 0;
  } else {
   if (!i1) {
    i9 = 0;
    i10 = 0;
    return (tempRet0 = i9, i10) | 0;
   }
   HEAP32[i14 >> 2] = i8 | 0;
   HEAP32[i14 + 4 >> 2] = i7 & 0;
   i9 = 0;
   i10 = 0;
   return (tempRet0 = i9, i10) | 0;
  }
 }
 i5 = (i4 | 0) == 0;
 do if (i6) {
  if (!i5) {
   i3 = (_llvm_ctlz_i32(i4 | 0) | 0) - (_llvm_ctlz_i32(i10 | 0) | 0) | 0;
   if (i3 >>> 0 <= 31) {
    i1 = i3 + 1 | 0;
    i9 = 31 - i3 | 0;
    i6 = i3 - 31 >> 31;
    i4 = i1;
    i5 = i11 >>> (i1 >>> 0) & i6 | i10 << i9;
    i6 = i10 >>> (i1 >>> 0) & i6;
    i1 = 0;
    i3 = i11 << i9;
    break;
   }
   if (!i14) {
    i9 = 0;
    i10 = 0;
    return (tempRet0 = i9, i10) | 0;
   }
   HEAP32[i14 >> 2] = i8 | 0;
   HEAP32[i14 + 4 >> 2] = i9 | i7 & 0;
   i9 = 0;
   i10 = 0;
   return (tempRet0 = i9, i10) | 0;
  }
  i5 = i6 - 1 | 0;
  if (i5 & i6) {
   i3 = (_llvm_ctlz_i32(i6 | 0) | 0) + 33 - (_llvm_ctlz_i32(i10 | 0) | 0) | 0;
   i15 = 64 - i3 | 0;
   i9 = 32 - i3 | 0;
   i8 = i9 >> 31;
   i7 = i3 - 32 | 0;
   i6 = i7 >> 31;
   i4 = i3;
   i5 = i9 - 1 >> 31 & i10 >>> (i7 >>> 0) | (i10 << i9 | i11 >>> (i3 >>> 0)) & i6;
   i6 = i6 & i10 >>> (i3 >>> 0);
   i1 = i11 << i15 & i8;
   i3 = (i10 << i15 | i11 >>> (i7 >>> 0)) & i8 | i11 << i9 & i3 - 33 >> 31;
   break;
  }
  if (i14) {
   HEAP32[i14 >> 2] = i5 & i11;
   HEAP32[i14 + 4 >> 2] = 0;
  }
  if ((i6 | 0) == 1) {
   i9 = i9 | i7 & 0;
   i10 = i8 | 0 | 0;
   return (tempRet0 = i9, i10) | 0;
  } else {
   i8 = _llvm_cttz_i32(i6 | 0) | 0;
   i9 = i10 >>> (i8 >>> 0) | 0;
   i10 = i10 << 32 - i8 | i11 >>> (i8 >>> 0) | 0;
   return (tempRet0 = i9, i10) | 0;
  }
 } else {
  if (i5) {
   if (i14) {
    HEAP32[i14 >> 2] = (i10 >>> 0) % (i6 >>> 0);
    HEAP32[i14 + 4 >> 2] = 0;
   }
   i9 = 0;
   i10 = (i10 >>> 0) / (i6 >>> 0) >>> 0;
   return (tempRet0 = i9, i10) | 0;
  }
  if (!i11) {
   if (i14) {
    HEAP32[i14 >> 2] = 0;
    HEAP32[i14 + 4 >> 2] = (i10 >>> 0) % (i4 >>> 0);
   }
   i9 = 0;
   i10 = (i10 >>> 0) / (i4 >>> 0) >>> 0;
   return (tempRet0 = i9, i10) | 0;
  }
  i5 = i4 - 1 | 0;
  if (!(i5 & i4)) {
   if (i14) {
    HEAP32[i14 >> 2] = i8 | 0;
    HEAP32[i14 + 4 >> 2] = i5 & i10 | i7 & 0;
   }
   i9 = 0;
   i10 = i10 >>> ((_llvm_cttz_i32(i4 | 0) | 0) >>> 0);
   return (tempRet0 = i9, i10) | 0;
  }
  i3 = (_llvm_ctlz_i32(i4 | 0) | 0) - (_llvm_ctlz_i32(i10 | 0) | 0) | 0;
  if (i3 >>> 0 <= 30) {
   i6 = i3 + 1 | 0;
   i3 = 31 - i3 | 0;
   i4 = i6;
   i5 = i10 << i3 | i11 >>> (i6 >>> 0);
   i6 = i10 >>> (i6 >>> 0);
   i1 = 0;
   i3 = i11 << i3;
   break;
  }
  if (!i14) {
   i9 = 0;
   i10 = 0;
   return (tempRet0 = i9, i10) | 0;
  }
  HEAP32[i14 >> 2] = i8 | 0;
  HEAP32[i14 + 4 >> 2] = i9 | i7 & 0;
  i9 = 0;
  i10 = 0;
  return (tempRet0 = i9, i10) | 0;
 } while (0);
 if (!i4) {
  i9 = i3;
  i4 = 0;
  i3 = 0;
 } else {
  i10 = i2 | 0 | 0;
  i9 = i13 | i12 & 0;
  i7 = _i64Add(i10, i9, -1, -1) | 0;
  i8 = tempRet0;
  i2 = i3;
  i3 = 0;
  do {
   i15 = i2;
   i2 = i1 >>> 31 | i2 << 1;
   i1 = i3 | i1 << 1;
   i15 = i5 << 1 | i15 >>> 31 | 0;
   i13 = i5 >>> 31 | i6 << 1 | 0;
   _i64Subtract(i7, i8, i15, i13) | 0;
   i11 = tempRet0;
   i12 = i11 >> 31 | ((i11 | 0) < 0 ? -1 : 0) << 1;
   i3 = i12 & 1;
   i5 = _i64Subtract(i15, i13, i12 & i10, (((i11 | 0) < 0 ? -1 : 0) >> 31 | ((i11 | 0) < 0 ? -1 : 0) << 1) & i9) | 0;
   i6 = tempRet0;
   i4 = i4 - 1 | 0;
  } while ((i4 | 0) != 0);
  i9 = i2;
  i4 = 0;
 }
 i2 = 0;
 if (i14) {
  HEAP32[i14 >> 2] = i5;
  HEAP32[i14 + 4 >> 2] = i6;
 }
 i9 = (i1 | 0) >>> 31 | (i9 | i2) << 1 | (i2 << 1 | i1 >>> 31) & 0 | i4;
 i10 = (i1 << 1 | 0 >>> 31) & -2 | i3;
 return (tempRet0 = i9, i10) | 0;
}

function _fill_window(i21) {
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i26 = STACKTOP;
 i8 = i21 + 44 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i22 = i21 + 60 | 0;
 i23 = i21 + 116 | 0;
 i24 = i21 + 108 | 0;
 i17 = i9 + -262 | 0;
 i25 = i21 + 56 | 0;
 i18 = i21 + 5812 | 0;
 i19 = i21 + 72 | 0;
 i20 = i21 + 88 | 0;
 i10 = i21 + 84 | 0;
 i11 = i21 + 68 | 0;
 i12 = i21 + 52 | 0;
 i13 = i21 + 64 | 0;
 i14 = i21 + 112 | 0;
 i15 = i21 + 92 | 0;
 i16 = i21 + 76 | 0;
 i4 = HEAP32[i23 >> 2] | 0;
 i2 = i9;
 while (1) {
  i3 = HEAP32[i24 >> 2] | 0;
  i7 = (HEAP32[i22 >> 2] | 0) - i4 - i3 | 0;
  if (i3 >>> 0 < (i17 + i2 | 0) >>> 0) i2 = i7; else {
   i3 = HEAP32[i25 >> 2] | 0;
   _memcpy(i3 | 0, i3 + i9 | 0, i9 | 0) | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) - i9;
   i3 = (HEAP32[i24 >> 2] | 0) - i9 | 0;
   HEAP32[i24 >> 2] = i3;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) - i9;
   i1 = HEAP32[i16 >> 2] | 0;
   i2 = i1;
   i1 = (HEAP32[i11 >> 2] | 0) + (i1 << 1) | 0;
   do {
    i1 = i1 + -2 | 0;
    i4 = HEAPU16[i1 >> 1] | 0;
    if (i4 >>> 0 < i9 >>> 0) i4 = 0; else i4 = i4 - i9 & 65535;
    HEAP16[i1 >> 1] = i4;
    i2 = i2 + -1 | 0;
   } while ((i2 | 0) != 0);
   i2 = i9;
   i1 = (HEAP32[i13 >> 2] | 0) + (i9 << 1) | 0;
   do {
    i1 = i1 + -2 | 0;
    i4 = HEAPU16[i1 >> 1] | 0;
    if (i4 >>> 0 < i9 >>> 0) i4 = 0; else i4 = i4 - i9 & 65535;
    HEAP16[i1 >> 1] = i4;
    i2 = i2 + -1 | 0;
   } while ((i2 | 0) != 0);
   i2 = i7 + i9 | 0;
  }
  i7 = HEAP32[i21 >> 2] | 0;
  i5 = i7 + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) break;
  i4 = HEAP32[i23 >> 2] | 0;
  i6 = (HEAP32[i25 >> 2] | 0) + (i4 + i3) | 0;
  i3 = i1 >>> 0 > i2 >>> 0 ? i2 : i1;
  if (!i3) i3 = 0; else {
   HEAP32[i5 >> 2] = i1 - i3;
   _memcpy(i6 | 0, HEAP32[i7 >> 2] | 0, i3 | 0) | 0;
   i4 = HEAP32[(HEAP32[i7 + 28 >> 2] | 0) + 24 >> 2] | 0;
   if ((i4 | 0) == 2) {
    i1 = i7 + 48 | 0;
    HEAP32[i1 >> 2] = _crc32(HEAP32[i1 >> 2] | 0, i6, i3) | 0;
   } else if ((i4 | 0) == 1) {
    i1 = i7 + 48 | 0;
    HEAP32[i1 >> 2] = _adler32(HEAP32[i1 >> 2] | 0, i6, i3) | 0;
   }
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i3;
   i4 = i7 + 8 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i3;
   i4 = HEAP32[i23 >> 2] | 0;
  }
  i4 = i4 + i3 | 0;
  HEAP32[i23 >> 2] = i4;
  i3 = HEAP32[i18 >> 2] | 0;
  L26 : do if ((i4 + i3 | 0) >>> 0 > 2) {
   i1 = (HEAP32[i24 >> 2] | 0) - i3 | 0;
   i6 = HEAP32[i25 >> 2] | 0;
   i2 = HEAPU8[i6 + i1 >> 0] | 0;
   HEAP32[i19 >> 2] = i2;
   i7 = HEAP32[i20 >> 2] | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   i2 = ((HEAPU8[i6 + (i1 + 1) >> 0] | 0) ^ i2 << i7) & i5;
   HEAP32[i19 >> 2] = i2;
   while (1) {
    if (!i3) break L26;
    i2 = ((HEAPU8[i6 + (i1 + 2) >> 0] | 0) ^ i2 << i7) & i5;
    HEAP32[i19 >> 2] = i2;
    i27 = (HEAP32[i11 >> 2] | 0) + (i2 << 1) | 0;
    HEAP16[(HEAP32[i13 >> 2] | 0) + ((HEAP32[i12 >> 2] & i1) << 1) >> 1] = HEAP16[i27 >> 1] | 0;
    HEAP16[i27 >> 1] = i1;
    i3 = i3 + -1 | 0;
    HEAP32[i18 >> 2] = i3;
    if ((i4 + i3 | 0) >>> 0 < 3) break; else i1 = i1 + 1 | 0;
   }
  } while (0);
  if (i4 >>> 0 >= 262) break;
  if (!(HEAP32[(HEAP32[i21 >> 2] | 0) + 4 >> 2] | 0)) break;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i3 = i21 + 5824 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 if (i2 >>> 0 <= i4 >>> 0) {
  STACKTOP = i26;
  return;
 }
 i1 = (HEAP32[i23 >> 2] | 0) + (HEAP32[i24 >> 2] | 0) | 0;
 if (i4 >>> 0 < i1 >>> 0) {
  i22 = i2 - i1 | 0;
  i22 = i22 >>> 0 > 258 ? 258 : i22;
  _memset((HEAP32[i25 >> 2] | 0) + i1 | 0, 0, i22 | 0) | 0;
  HEAP32[i3 >> 2] = i22 + i1;
  STACKTOP = i26;
  return;
 }
 i1 = i1 + 258 | 0;
 if (i1 >>> 0 <= i4 >>> 0) {
  STACKTOP = i26;
  return;
 }
 i22 = i1 - i4 | 0;
 i21 = i2 - i4 | 0;
 i22 = i22 >>> 0 > i21 >>> 0 ? i21 : i22;
 _memset((HEAP32[i25 >> 2] | 0) + i4 | 0, 0, i22 | 0) | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i22;
 STACKTOP = i26;
 return;
}

function _cvGetFileNode(i7, i18, i20, i6) {
 i7 = i7 | 0;
 i18 = i18 | 0;
 i20 = i20 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 i21 = i23;
 i19 = i23 + 40 | 0;
 i1 = i23 + 32 | 0;
 i2 = i23 + 24 | 0;
 i17 = i23 + 16 | 0;
 if (!i7) {
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 if ((HEAP32[i7 >> 2] | 0) != 1280131417) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i1, 31) | 0) + 0 | 0;
  i4 = 9096 | 0;
  i5 = i3 + 31 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i1, 9128, 8960, 634);
  __ZN2cv6String10deallocateEv(i1);
 }
 if (!i20) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i2, 16) | 0) + 0 | 0;
  i4 = 9144 | 0;
  i5 = i3 + 16 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i2, 9128, 8960, 637);
  __ZN2cv6String10deallocateEv(i2);
 }
 i16 = (i18 | 0) != 0;
 if (i16) {
  i1 = HEAP32[i7 + 32 >> 2] | 0;
  if (!i1) {
   i22 = 0;
   STACKTOP = i23;
   return i22 | 0;
  }
  i1 = HEAP32[i1 + 24 >> 2] | 0;
  if ((i1 | 0) > 0) i14 = i1; else {
   i22 = 0;
   STACKTOP = i23;
   return i22 | 0;
  }
 } else i14 = 1;
 i12 = i14 + -1 | 0;
 i13 = (i6 | 0) != 0;
 i15 = i20;
 i9 = (i6 | 0) == 0;
 i10 = i7 + 60 | 0;
 i11 = i7 + 88 | 0;
 i2 = i7 + 32 | 0;
 i8 = 0;
 i1 = 0;
 L17 : while (1) {
  if (i16) i4 = i18; else i4 = _cvGetSeqElem(HEAP32[i2 >> 2] | 0, i8) | 0;
  i5 = HEAP32[i4 >> 2] & 7;
  if ((i5 | 0) == 5) {
   i22 = 13;
   break;
  } else if (!i5) {
   i1 = 0;
   i22 = 32;
   break;
  } else if ((i5 | 0) != 6) break;
  i3 = HEAP32[i4 + 8 >> 2] | 0;
  i6 = HEAP32[i3 + 64 >> 2] | 0;
  i5 = i6 + -1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  if (!(i5 & i6)) i5 = i4 & i5; else i5 = (i4 >>> 0) % (i6 >>> 0) | 0;
  i7 = i3 + 68 | 0;
  i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  L27 : do if (i6) {
   if (i9) while (1) {
    if ((HEAP32[i6 + 16 >> 2] | 0) == (i20 | 0)) {
     i22 = 23;
     break L17;
    }
    i6 = HEAP32[i6 + 20 >> 2] | 0;
    if (!i6) break L27;
   }
   do {
    if ((HEAP32[i6 + 16 >> 2] | 0) == (i20 | 0)) {
     i4 = HEAP32[i11 >> 2] | 0;
     HEAP32[i21 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i21 + 4 >> 2] = i4;
     HEAP32[i21 + 8 >> 2] = 9224;
     _sprintf(i19, 17440, i21) | 0;
     _cvError(-212, 9128, i19, 8960, 680);
    }
    i6 = HEAP32[i6 + 20 >> 2] | 0;
   } while ((i6 | 0) != 0);
  } while (0);
  if ((i8 | 0) == (i12 | 0) & i13) {
   i6 = i3 + 56 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i21 >> 2] = i1;
   if (!i1) {
    _cvSetAdd(i3, 0, i21) | 0;
    i1 = HEAP32[i21 >> 2] | 0;
   } else {
    HEAP32[i6 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 67108863;
    i3 = i3 + 60 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   }
   HEAP32[i1 + 16 >> 2] = i15;
   i3 = (HEAP32[i7 >> 2] | 0) + (i5 << 2) | 0;
   HEAP32[i1 + 20 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i3 >> 2] = i1;
  }
  i8 = i8 + 1 | 0;
  if ((i8 | 0) >= (i14 | 0)) {
   i22 = 32;
   break;
  }
 }
 if ((i22 | 0) == 13) {
  if (!(HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 24 >> 2] | 0)) {
   i22 = 0;
   STACKTOP = i23;
   return i22 | 0;
  }
 } else if ((i22 | 0) == 23) {
  i22 = i6;
  STACKTOP = i23;
  return i22 | 0;
 } else if ((i22 | 0) == 32) {
  STACKTOP = i23;
  return i1 | 0;
 }
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 i3 = (__ZN2cv6String8allocateEj(i17, 49) | 0) + 0 | 0;
 i4 = 9168 | 0;
 i5 = i3 + 49 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i17, 9128, 8960, 660);
 __ZN2cv6String10deallocateEv(i17);
 i22 = 0;
 STACKTOP = i23;
 return i22 | 0;
}

function _mbsrtowcs(i2, i9, i8, i4) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i4 | 0) != 0 ? (i5 = HEAP32[i4 >> 2] | 0, (i5 | 0) != 0) : 0) if (!i2) {
  i3 = i8;
  i4 = i1;
  i7 = 16;
 } else {
  HEAP32[i4 >> 2] = 0;
  i3 = i8;
  i6 = i1;
  i7 = 36;
 } else if (!i2) {
  i3 = i8;
  i7 = 7;
 } else {
  i3 = i8;
  i7 = 6;
 }
 L7 : while (1) if ((i7 | 0) == 6) {
  if (!i3) {
   i7 = 26;
   break;
  }
  while (1) {
   i4 = HEAP8[i1 >> 0] | 0;
   L33 : do if (((i4 & 255) + -1 | 0) >>> 0 < 127 ? (i1 & 3 | 0) == 0 & i3 >>> 0 > 4 : 0) {
    do {
     i4 = HEAP32[i1 >> 2] | 0;
     if ((i4 + -16843009 | i4) & -2139062144) {
      i4 = i4 & 255;
      break L33;
     }
     HEAP32[i2 >> 2] = i4 & 255;
     HEAP32[i2 + 4 >> 2] = HEAPU8[i1 + 1 >> 0];
     HEAP32[i2 + 8 >> 2] = HEAPU8[i1 + 2 >> 0];
     i5 = i1;
     i1 = i1 + 4 | 0;
     i4 = i2;
     i2 = i2 + 16 | 0;
     HEAP32[i4 + 12 >> 2] = HEAPU8[i5 + 3 >> 0];
     i3 = i3 + -4 | 0;
    } while (i3 >>> 0 > 4);
    i4 = HEAP8[i1 >> 0] | 0;
   } while (0);
   i4 = i4 & 255;
   if ((i4 + -1 | 0) >>> 0 >= 127) break;
   i1 = i1 + 1 | 0;
   HEAP32[i2 >> 2] = i4;
   i3 = i3 + -1 | 0;
   if (!i3) {
    i7 = 26;
    break L7;
   } else i2 = i2 + 4 | 0;
  }
  i4 = i4 + -194 | 0;
  if (i4 >>> 0 > 50) {
   i7 = 47;
   break;
  }
  i5 = HEAP32[968384 + (i4 << 2) >> 2] | 0;
  i6 = i1 + 1 | 0;
  i7 = 36;
  continue;
 } else if ((i7 | 0) == 7) {
  i4 = HEAP8[i1 >> 0] | 0;
  if (((i4 & 255) + -1 | 0) >>> 0 < 127 ? (i1 & 3 | 0) == 0 : 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   if (!((i4 + -16843009 | i4) & -2139062144)) do {
    i1 = i1 + 4 | 0;
    i3 = i3 + -4 | 0;
    i4 = HEAP32[i1 >> 2] | 0;
   } while (((i4 + -16843009 | i4) & -2139062144 | 0) == 0);
   i4 = i4 & 255;
  }
  i4 = i4 & 255;
  if ((i4 + -1 | 0) >>> 0 < 127) {
   i3 = i3 + -1 | 0;
   i1 = i1 + 1 | 0;
   i7 = 7;
   continue;
  }
  i4 = i4 + -194 | 0;
  if (i4 >>> 0 > 50) {
   i7 = 47;
   break;
  }
  i5 = HEAP32[968384 + (i4 << 2) >> 2] | 0;
  i4 = i1 + 1 | 0;
  i7 = 16;
  continue;
 } else if ((i7 | 0) == 16) {
  i1 = (HEAPU8[i4 >> 0] | 0) >>> 3;
  if ((i1 + -16 | i1 + (i5 >> 26)) >>> 0 > 7) {
   i7 = 17;
   break;
  }
  i1 = i4 + 1 | 0;
  if (i5 & 33554432) {
   if ((HEAP8[i1 >> 0] & -64) << 24 >> 24 != -128) {
    i7 = 20;
    break;
   }
   i1 = i4 + 2 | 0;
   if (i5 & 524288) {
    if ((HEAP8[i1 >> 0] & -64) << 24 >> 24 != -128) {
     i7 = 23;
     break;
    }
    i1 = i4 + 3 | 0;
   }
  }
  i3 = i3 + -1 | 0;
  i7 = 7;
  continue;
 } else if ((i7 | 0) == 36) {
  i4 = HEAPU8[i6 >> 0] | 0;
  i1 = i4 >>> 3;
  if ((i1 + -16 | i1 + (i5 >> 26)) >>> 0 > 7) {
   i7 = 37;
   break;
  }
  i1 = i6 + 1 | 0;
  i5 = i4 + -128 | i5 << 6;
  if ((i5 | 0) < 0) {
   i4 = HEAPU8[i1 >> 0] | 0;
   if ((i4 & 192 | 0) != 128) {
    i7 = 40;
    break;
   }
   i1 = i6 + 2 | 0;
   i5 = i4 + -128 | i5 << 6;
   if ((i5 | 0) < 0) {
    i4 = HEAPU8[i1 >> 0] | 0;
    if ((i4 & 192 | 0) != 128) {
     i7 = 43;
     break;
    }
    i5 = i4 + -128 | i5 << 6;
    i1 = i6 + 3 | 0;
   }
  }
  HEAP32[i2 >> 2] = i5;
  i2 = i2 + 4 | 0;
  i3 = i3 + -1 | 0;
  i7 = 6;
  continue;
 }
 if ((i7 | 0) == 17) {
  i1 = i4 + -1 | 0;
  i7 = 46;
 } else if ((i7 | 0) == 20) {
  i1 = i4 + -1 | 0;
  i7 = 46;
 } else if ((i7 | 0) == 23) {
  i1 = i4 + -1 | 0;
  i7 = 46;
 } else if ((i7 | 0) == 26) {
  HEAP32[i9 >> 2] = i1;
  i1 = i8;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i7 | 0) == 37) {
  i1 = i6 + -1 | 0;
  i7 = 46;
 } else if ((i7 | 0) == 40) {
  i1 = i6 + -1 | 0;
  i7 = 46;
 } else if ((i7 | 0) == 43) {
  i1 = i6 + -1 | 0;
  i7 = 46;
 }
 if ((i7 | 0) == 46) if (!i5) i7 = 47;
 if ((i7 | 0) == 47) if (!(HEAP8[i1 >> 0] | 0)) {
  if (i2) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
  }
  i1 = i8 - i3 | 0;
  STACKTOP = i10;
  return i1 | 0;
 }
 HEAP32[(___errno_location() | 0) >> 2] = 84;
 if (!i2) {
  i1 = -1;
  STACKTOP = i10;
  return i1 | 0;
 }
 HEAP32[i9 >> 2] = i1;
 i1 = -1;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNK2cv11_InputArray6offsetEi(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i4 = i10 + 40 | 0;
 i3 = i10 + 32 | 0;
 i7 = i10 + 24 | 0;
 i8 = i10 + 16 | 0;
 i2 = i10 + 8 | 0;
 i1 = i10;
 i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] & 127](i6) | 0;
 if ((i5 | 0) == 0 | (i5 | 0) == 131072 | (i5 | 0) == 196608 | (i5 | 0) == 262144 | (i5 | 0) == 393216) {
  i1 = 0;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i5 | 0) == 720896) {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((((HEAP32[i2 + 4 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0 <= i9 >>> 0) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i8, 21) | 0) + 0 | 0;
   i3 = 29320 | 0;
   i4 = i1 + 21 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i1 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 29376, 27528, 1969);
   __ZN2cv6String10deallocateEv(i8);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  i1 = HEAP32[i1 + (i9 * 48 | 0) + 28 >> 2] | 0;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i5 | 0) == 655360) {
  if ((i9 | 0) >= 0) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i3, 5) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 29376, 27528, 1949);
   __ZN2cv6String10deallocateEv(i3);
  }
  i1 = HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 28 >> 2] | 0;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i5 | 0) == 65536) {
  if ((i9 | 0) >= 0) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i4, 5) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 29376, 27528, 1942);
   __ZN2cv6String10deallocateEv(i4);
  }
  i1 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = (HEAP32[i1 + 16 >> 2] | 0) - (HEAP32[i1 + 20 >> 2] | 0) | 0;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i5 | 0) == 327680) {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  if ((i9 | 0) < 0) {
   i1 = 1;
   STACKTOP = i10;
   return i1 | 0;
  }
  i1 = HEAP32[i2 >> 2] | 0;
  if ((((HEAP32[i2 + 4 >> 2] | 0) - i1 | 0) / 56 | 0 | 0) <= (i9 | 0)) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i7, 18) | 0) + 0 | 0;
   i3 = 29208 | 0;
   i4 = i1 + 18 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i1 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 29376, 27528, 1961);
   __ZN2cv6String10deallocateEv(i7);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  i1 = (HEAP32[i1 + (i9 * 56 | 0) + 16 >> 2] | 0) - (HEAP32[i1 + (i9 * 56 | 0) + 20 >> 2] | 0) | 0;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i5 | 0) == 589824) {
  if ((i9 | 0) >= 0) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i2, 5) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 29376, 27528, 1975);
   __ZN2cv6String10deallocateEv(i2);
  }
  i1 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = (HEAP32[i1 + 16 >> 2] | 0) - (HEAP32[i1 + 24 >> 2] | 0) | 0;
  STACKTOP = i10;
  return i1 | 0;
 } else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i1, 29376, 27528, 1980);
  __ZN2cv6String10deallocateEv(i1);
  i1 = 0;
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function __ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce(i30, i1, i29, i7, i26, i25, d4) {
 i30 = i30 | 0;
 i1 = i1 | 0;
 i29 = i29 | 0;
 i7 = i7 | 0;
 i26 = i26 | 0;
 i25 = i25 | 0;
 d4 = +d4;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 i9 = i20;
 i1 = i20 + 276 | 0;
 i5 = i20 + 68 | 0;
 i3 = i20 + 176 | 0;
 i13 = i20 + 64 | 0;
 i16 = i20 + 60 | 0;
 i11 = i20 + 173 | 0;
 i19 = i20 + 172 | 0;
 i12 = i20 + 48 | 0;
 i18 = i20 + 36 | 0;
 i17 = i20 + 24 | 0;
 i6 = i20 + 20 | 0;
 i8 = i20 + 72 | 0;
 i15 = i20 + 16 | 0;
 i14 = i20 + 12 | 0;
 i10 = i20 + 8 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAPF64[tempDoublePtr >> 3] = d4;
 HEAP32[i9 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 i1 = _snprintf(i1, 100, 960480, i9) | 0;
 if (i1 >>> 0 > 99) {
  i1 = __ZNSt3__16__clocEv() | 0;
  HEAPF64[tempDoublePtr >> 3] = d4;
  HEAP32[i9 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i1 = __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz(i5, i1, 960480, i9) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (!i2) __ZSt17__throw_bad_allocv();
  i3 = _malloc(i1) | 0;
  if (!i3) __ZSt17__throw_bad_allocv(); else {
   i22 = i3;
   i23 = i2;
   i24 = i3;
   i28 = i1;
  }
 } else {
  i22 = 0;
  i23 = 0;
  i24 = i3;
  i28 = i1;
 }
 __ZNKSt3__18ios_base6getlocEv(i13, i26);
 i3 = __ZNKSt3__16locale9use_facetERNS0_2idE(i13, 960728) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] & 7](i3, i1, i1 + i28 | 0, i24) | 0;
 if (!i28) i5 = 0; else i5 = (HEAP8[HEAP32[i5 >> 2] >> 0] | 0) == 45;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i12 + 0 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i18 + 0 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i17 + 0 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 __ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri(i7, i5, i13, i16, i11, i19, i12, i18, i17, i6);
 i7 = HEAP32[i6 >> 2] | 0;
 if ((i28 | 0) > (i7 | 0)) {
  i1 = HEAP8[i17 >> 0] | 0;
  if (!(i1 & 1)) i2 = (i1 & 255) >>> 1; else i2 = HEAP32[i17 + 4 >> 2] | 0;
  i1 = HEAP8[i18 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i18 + 4 >> 2] | 0;
  i1 = i2 + (i28 - i7 << 1 | 1) + i1 | 0;
 } else {
  i1 = HEAP8[i17 >> 0] | 0;
  if (!(i1 & 1)) i2 = (i1 & 255) >>> 1; else i2 = HEAP32[i17 + 4 >> 2] | 0;
  i1 = HEAP8[i18 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i18 + 4 >> 2] | 0;
  i1 = i2 + 2 + i1 | 0;
 }
 i1 = i1 + i7 | 0;
 if (i1 >>> 0 > 100) {
  i1 = _malloc(i1) | 0;
  if (!i1) __ZSt17__throw_bad_allocv(); else {
   i21 = i1;
   i27 = i1;
  }
 } else {
  i21 = 0;
  i27 = i8;
 }
 __ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i(i27, i15, i14, HEAP32[i26 + 4 >> 2] | 0, i24, i24 + i28 | 0, i3, i5, i16, HEAP8[i11 >> 0] | 0, HEAP8[i19 >> 0] | 0, i12, i18, i17, i7);
 HEAP32[i10 >> 2] = HEAP32[i29 >> 2];
 i16 = HEAP32[i15 >> 2] | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i30, i9, i27, i16, i19, i26, i25);
 _free(i21);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i18);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i13 >> 2] | 0) | 0;
 _free(i22);
 _free(i23);
 STACKTOP = i20;
 return;
}

function __ZNSt3__1L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE(i2, i14, i11, i1, i12, i13, i10, i3) {
 i2 = i2 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i15 = 0;
 i15 = STACKTOP;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i13 >> 2] = i1;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((((i3 & 4 | 0) != 0 ? (i14 - i1 | 0) > 2 : 0) ? (HEAP8[i1 >> 0] | 0) == -17 : 0) ? (HEAP8[i1 + 1 >> 0] | 0) == -69 : 0) ? (HEAP8[i1 + 2 >> 0] | 0) == -65 : 0) {
  i1 = i1 + 3 | 0;
  HEAP32[i11 >> 2] = i1;
 }
 L8 : do if (i1 >>> 0 < i14 >>> 0) {
  i7 = i14;
  i8 = i12;
  i9 = HEAP32[i13 >> 2] | 0;
  L10 : while (1) {
   if (i9 >>> 0 >= i12 >>> 0) break L8;
   i3 = HEAP8[i1 >> 0] | 0;
   i4 = i3 & 255;
   if (i4 >>> 0 > i10 >>> 0) {
    i1 = 2;
    i2 = 41;
    break;
   }
   do if (i3 << 24 >> 24 > -1) {
    HEAP16[i9 >> 1] = i3 & 255;
    HEAP32[i11 >> 2] = i1 + 1;
   } else {
    if ((i3 & 255) < 194) {
     i1 = 2;
     i2 = 41;
     break L10;
    }
    if ((i3 & 255) < 224) {
     if ((i7 - i1 | 0) < 2) {
      i1 = 1;
      i2 = 41;
      break L10;
     }
     i3 = HEAPU8[i1 + 1 >> 0] | 0;
     if ((i3 & 192 | 0) != 128) {
      i1 = 2;
      i2 = 41;
      break L10;
     }
     i3 = i3 & 63 | i4 << 6 & 1984;
     if (i3 >>> 0 > i10 >>> 0) {
      i1 = 2;
      i2 = 41;
      break L10;
     }
     HEAP16[i9 >> 1] = i3;
     HEAP32[i11 >> 2] = i1 + 2;
     break;
    }
    if ((i3 & 255) < 240) {
     if ((i7 - i1 | 0) < 3) {
      i1 = 1;
      i2 = 41;
      break L10;
     }
     i2 = HEAP8[i1 + 1 >> 0] | 0;
     i3 = HEAP8[i1 + 2 >> 0] | 0;
     if ((i4 | 0) == 237) {
      if ((i2 & -32) << 24 >> 24 != -128) {
       i1 = 2;
       i2 = 41;
       break L10;
      }
     } else if ((i4 | 0) == 224) {
      if ((i2 & -32) << 24 >> 24 != -96) {
       i1 = 2;
       i2 = 41;
       break L10;
      }
     } else if ((i2 & -64) << 24 >> 24 != -128) {
      i1 = 2;
      i2 = 41;
      break L10;
     }
     i3 = i3 & 255;
     if ((i3 & 192 | 0) != 128) {
      i1 = 2;
      i2 = 41;
      break L10;
     }
     i3 = (i2 & 255) << 6 & 4032 | i4 << 12 | i3 & 63;
     if ((i3 & 65535) >>> 0 > i10 >>> 0) {
      i1 = 2;
      i2 = 41;
      break L10;
     }
     HEAP16[i9 >> 1] = i3;
     HEAP32[i11 >> 2] = i1 + 3;
     break;
    }
    if ((i3 & 255) >= 245) {
     i1 = 2;
     i2 = 41;
     break L10;
    }
    if ((i7 - i1 | 0) < 4) {
     i1 = 1;
     i2 = 41;
     break L10;
    }
    i5 = HEAP8[i1 + 1 >> 0] | 0;
    i3 = HEAP8[i1 + 2 >> 0] | 0;
    i2 = HEAP8[i1 + 3 >> 0] | 0;
    if ((i4 | 0) == 240) {
     if ((i5 + 112 << 24 >> 24 & 255) >= 48) {
      i1 = 2;
      i2 = 41;
      break L10;
     }
    } else if ((i4 | 0) == 244) {
     if ((i5 & -16) << 24 >> 24 != -128) {
      i1 = 2;
      i2 = 41;
      break L10;
     }
    } else if ((i5 & -64) << 24 >> 24 != -128) {
     i1 = 2;
     i2 = 41;
     break L10;
    }
    i6 = i3 & 255;
    if ((i6 & 192 | 0) != 128) {
     i1 = 2;
     i2 = 41;
     break L10;
    }
    i3 = i2 & 255;
    if ((i3 & 192 | 0) != 128) {
     i1 = 2;
     i2 = 41;
     break L10;
    }
    if ((i8 - i9 | 0) < 4) {
     i1 = 1;
     i2 = 41;
     break L10;
    }
    i4 = i4 & 7;
    i1 = i5 & 255;
    i2 = i6 << 6;
    i3 = i3 & 63;
    if ((i1 << 12 & 258048 | i4 << 18 | i2 & 4032 | i3) >>> 0 > i10 >>> 0) {
     i1 = 2;
     i2 = 41;
     break L10;
    }
    HEAP16[i9 >> 1] = i1 << 2 & 60 | i6 >>> 4 & 3 | ((i1 >>> 4 & 3 | i4 << 2) << 6) + 16320 | 55296;
    i9 = i9 + 2 | 0;
    HEAP32[i13 >> 2] = i9;
    HEAP16[i9 >> 1] = i3 | i2 & 960 | 56320;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 4;
   } while (0);
   i9 = (HEAP32[i13 >> 2] | 0) + 2 | 0;
   HEAP32[i13 >> 2] = i9;
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 >>> 0 >= i14 >>> 0) break L8;
  }
  if ((i2 | 0) == 41) {
   STACKTOP = i15;
   return i1 | 0;
  }
 } while (0);
 i10 = i1 >>> 0 < i14 >>> 0 & 1;
 STACKTOP = i15;
 return i10 | 0;
}

function __ZL16icvXMLSkipSpacesP13CvFileStoragePci(i16, i1, i2) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i19 = i21;
 i15 = i21 + 16 | 0;
 i8 = i16 + 80 | 0;
 i9 = i16 + 76 | 0;
 i17 = i16 + 60 | 0;
 i18 = i16 + 88 | 0;
 i10 = i16 + 256 | 0;
 i11 = i16 + 64 | 0;
 i12 = i16 + 68 | 0;
 i13 = i16 + 264 | 0;
 i14 = i16 + 260 | 0;
 i3 = 0;
 L1 : while (1) {
  i4 = i1 + -1 | 0;
  do if ((i2 | 0) == 1) {
   i2 = HEAP8[i1 >> 0] | 0;
   L5 : do if ((i2 & 255) > 31 | i2 << 24 >> 24 == 9) while (1) {
    if ((i2 << 24 >> 24 == 45 ? (HEAP8[i4 + 2 >> 0] | 0) == 45 : 0) ? (HEAP8[i4 + 3 >> 0] | 0) == 62 : 0) {
     i2 = 45;
     break L5;
    }
    i5 = i1 + 1 | 0;
    i2 = HEAP8[i5 >> 0] | 0;
    if ((i2 & 255) > 31 | i2 << 24 >> 24 == 9) {
     i4 = i1;
     i1 = i5;
    } else {
     i4 = i1;
     i1 = i5;
     break;
    }
   } while (0);
   i6 = i2 << 24 >> 24 == 45;
   i2 = i6 & 1 ^ 1;
   i1 = i6 ? i4 + 4 | 0 : i1;
   i6 = i3;
  } else if ((i2 | 0) == 3) {
   i1 = i4;
   while (1) {
    i1 = i1 + 1 | 0;
    i2 = HEAP8[i1 >> 0] | 0;
    i3 = (i2 << 24 >> 24 == 60 & 1) + i3 + ((i2 << 24 >> 24 == 62) << 31 >> 31) | 0;
    if ((i3 | 0) < 0) {
     i20 = 34;
     break L1;
    }
    if (!((i2 & 255) > 31 | i2 << 24 >> 24 == 9)) {
     i2 = 3;
     i6 = i3;
     break;
    }
   }
  } else {
   i5 = i4;
   while (1) {
    i1 = i5 + 1 | 0;
    i4 = HEAP8[i1 >> 0] | 0;
    if (i4 << 24 >> 24 == 60) break; else if (i4 << 24 >> 24 == 9 | i4 << 24 >> 24 == 32) i5 = i1; else {
     i20 = 18;
     break;
    }
   }
   if ((i20 | 0) == 18) {
    i20 = 0;
    if ((i4 & 255) > 31) {
     i20 = 34;
     break L1;
    } else {
     i6 = i3;
     break;
    }
   }
   if ((HEAP8[i5 + 2 >> 0] | 0) != 33) {
    i20 = 34;
    break L1;
   }
   if ((HEAP8[i5 + 3 >> 0] | 0) != 45) {
    i20 = 34;
    break L1;
   }
   if ((HEAP8[i5 + 4 >> 0] | 0) != 45) {
    i20 = 34;
    break L1;
   }
   if (i2) {
    i6 = HEAP32[i18 >> 2] | 0;
    HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i19 + 4 >> 2] = i6;
    HEAP32[i19 + 8 >> 2] = 16688;
    _sprintf(i15, 17440, i19) | 0;
    _cvError(-212, 16664, i15, 8960, 1782);
   }
   i2 = 1;
   i1 = i5 + 5 | 0;
   i6 = i3;
  } while (0);
  i5 = HEAP8[i1 >> 0] | 0;
  if ((i5 & 255) > 31) {
   i3 = i6;
   continue;
  }
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
  if (!(i5 << 24 >> 24 == 13 | i5 << 24 >> 24 == 10 | i5 << 24 >> 24 == 0)) {
   i1 = HEAP32[i18 >> 2] | 0;
   HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i19 + 4 >> 2] = i1;
   HEAP32[i19 + 8 >> 2] = 16720;
   _sprintf(i15, 17440, i19) | 0;
   _cvError(-212, 16664, i15, 8960, 1794);
   i1 = HEAP32[i9 >> 2] | 0;
  }
  i1 = __ZL7icvGetsP13CvFileStoragePci(i16, i1, i4) | 0;
  if (!i1) {
   i20 = 23;
   break;
  }
  i5 = HEAP8[i1 + ((_strlen(i1 | 0) | 0) + -1) >> 0] | 0;
  do if (!(i5 << 24 >> 24 == 13 | i5 << 24 >> 24 == 10)) {
   do if (!(HEAP32[i10 >> 2] | 0)) {
    i3 = HEAP32[i11 >> 2] | 0;
    if (i3) {
     i7 = _feof(i3 | 0) | 0;
     i20 = 31;
     break;
    }
    i3 = HEAP32[i12 >> 2] | 0;
    if (i3) {
     i7 = _gzeof(i3) | 0;
     i20 = 31;
    }
   } else {
    i7 = (HEAP32[i13 >> 2] | 0) >>> 0 >= (HEAP32[i14 >> 2] | 0) >>> 0 & 1;
    i20 = 31;
   } while (0);
   if ((i20 | 0) == 31 ? (i20 = 0, (i7 | 0) != 0) : 0) break;
   i5 = HEAP32[i18 >> 2] | 0;
   HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i19 + 4 >> 2] = i5;
   HEAP32[i19 + 8 >> 2] = 15504;
   _sprintf(i15, 17440, i19) | 0;
   _cvError(-212, 16664, i15, 8960, 1807);
  } while (0);
  HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
  i3 = i6;
 }
 if ((i20 | 0) == 23) {
  i10 = HEAP32[i9 >> 2] | 0;
  HEAP8[i10 >> 0] = 0;
  HEAP32[i16 + 92 >> 2] = 1;
  STACKTOP = i21;
  return i10 | 0;
 } else if ((i20 | 0) == 34) {
  STACKTOP = i21;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cv2LUEPfjiS0_ji(i18, i1, i20, i19, i2, i21) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = Math_fround(0), i8 = 0, i9 = 0, i10 = 0, f11 = Math_fround(0), i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i22 = 0, f23 = Math_fround(0);
 i22 = STACKTOP;
 i17 = i1 >>> 2;
 i16 = i2 >>> 2;
 if ((i20 | 0) <= 0) {
  i10 = 1;
  STACKTOP = i22;
  return i10 | 0;
 }
 i3 = (i21 | 0) > 0;
 i13 = (i19 | 0) == 0 | i3 ^ 1;
 i14 = 0;
 i1 = 1;
 while (1) {
  i12 = i14 + 1 | 0;
  i8 = (i12 | 0) < (i20 | 0);
  if (i8) {
   i4 = i12;
   i2 = i14;
   do {
    f7 = Math_fround(Math_abs(Math_fround(HEAPF32[i18 + ((Math_imul(i4, i17) | 0) + i14 << 2) >> 2])));
    i10 = f7 > Math_fround(Math_abs(Math_fround(HEAPF32[i18 + ((Math_imul(i2, i17) | 0) + i14 << 2) >> 2])));
    i2 = i10 ? i4 : i2;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i20 | 0));
  } else i2 = i14;
  i6 = Math_imul(i2, i17) | 0;
  if (Math_fround(Math_abs(Math_fround(HEAPF32[i18 + (i6 + i14 << 2) >> 2]))) < Math_fround(1.1920929e-07)) {
   i1 = 0;
   i15 = 28;
   break;
  }
  i4 = Math_imul(i14, i17) | 0;
  if ((i2 | 0) != (i14 | 0)) {
   i10 = i14;
   do {
    i5 = i18 + (i10 + i4 << 2) | 0;
    i9 = i18 + (i10 + i6 << 2) | 0;
    f7 = Math_fround(HEAPF32[i5 >> 2]);
    HEAPF32[i5 >> 2] = Math_fround(HEAPF32[i9 >> 2]);
    HEAPF32[i9 >> 2] = f7;
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) != (i20 | 0));
   if (!i13) {
    i9 = Math_imul(i14, i16) | 0;
    i6 = Math_imul(i2, i16) | 0;
    i10 = 0;
    do {
     i2 = i19 + (i10 + i9 << 2) | 0;
     i5 = i19 + (i10 + i6 << 2) | 0;
     f7 = Math_fround(HEAPF32[i2 >> 2]);
     HEAPF32[i2 >> 2] = Math_fround(HEAPF32[i5 >> 2]);
     HEAPF32[i5 >> 2] = f7;
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i21 | 0));
   }
   i1 = 0 - i1 | 0;
  }
  i5 = i18 + (i4 + i14 << 2) | 0;
  f11 = Math_fround(Math_fround(-1.0) / Math_fround(HEAPF32[i5 >> 2]));
  if (!i8) break;
  i8 = Math_imul(i14, i16) | 0;
  i6 = i12;
  do {
   i10 = Math_imul(i6, i17) | 0;
   f7 = Math_fround(f11 * Math_fround(HEAPF32[i18 + (i10 + i14 << 2) >> 2]));
   i9 = i12;
   do {
    f23 = Math_fround(f7 * Math_fround(HEAPF32[i18 + (i9 + i4 << 2) >> 2]));
    i2 = i18 + (i9 + i10 << 2) | 0;
    HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f23);
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) != (i20 | 0));
   if (!i13) {
    i10 = Math_imul(i6, i16) | 0;
    i9 = 0;
    do {
     f23 = Math_fround(f7 * Math_fround(HEAPF32[i19 + (i9 + i8 << 2) >> 2]));
     i2 = i19 + (i9 + i10 << 2) | 0;
     HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f23);
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) != (i21 | 0));
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i20 | 0));
  HEAPF32[i5 >> 2] = Math_fround(-f11);
  i14 = i12;
 }
 if ((i15 | 0) == 28) {
  STACKTOP = i22;
  return i1 | 0;
 }
 HEAPF32[i5 >> 2] = Math_fround(-f11);
 if ((i19 | 0) != 0 & i3) i10 = i20; else {
  i10 = i1;
  STACKTOP = i22;
  return i10 | 0;
 }
 do {
  i4 = i10;
  i10 = i10 + -1 | 0;
  i8 = Math_imul(i10, i16) | 0;
  i2 = Math_imul(i10, i17) | 0;
  i9 = i18 + (i2 + i10 << 2) | 0;
  if ((i4 | 0) < (i20 | 0)) {
   i5 = 0;
   do {
    i3 = i19 + (i5 + i8 << 2) | 0;
    i6 = i4;
    f7 = Math_fround(HEAPF32[i3 >> 2]);
    do {
     f11 = Math_fround(HEAPF32[i18 + (i6 + i2 << 2) >> 2]);
     f7 = Math_fround(f7 - Math_fround(f11 * Math_fround(HEAPF32[i19 + ((Math_imul(i6, i16) | 0) + i5 << 2) >> 2])));
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i20 | 0));
    HEAPF32[i3 >> 2] = Math_fround(f7 * Math_fround(HEAPF32[i9 >> 2]));
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i21 | 0));
  } else {
   i2 = 0;
   do {
    i6 = i19 + (i2 + i8 << 2) | 0;
    f7 = Math_fround(HEAPF32[i6 >> 2]);
    HEAPF32[i6 >> 2] = Math_fround(f7 * Math_fround(HEAPF32[i9 >> 2]));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i21 | 0));
  }
 } while ((i10 | 0) > 0);
 STACKTOP = i22;
 return i1 | 0;
}

function __ZN2cvL14GEMMStore_64fcEPKNS_7ComplexIdEEjS3_jPS1_jNS_5Size_IiEEddi(i5, i2, i7, i3, i8, i4, i1, d19, d20, i6) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 d19 = +d19;
 d20 = +d20;
 i6 = i6 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, d22 = 0.0, d23 = 0.0, i24 = 0, d25 = 0.0, i26 = 0;
 i21 = STACKTOP;
 i18 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i2 >>> 4;
 i17 = i3 >>> 4;
 i16 = i4 >>> 4;
 if (!i5) {
  i5 = 0;
  i15 = 0;
  i14 = 0;
 } else {
  i14 = (i6 & 4 | 0) == 0;
  i15 = i14 ? i2 : 1;
  i14 = i14 ? 1 : i2;
 }
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i2 = i14 << 1;
 i9 = i14 * 3 | 0;
 i10 = i14 << 2;
 i11 = i18 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i4 = i11 >>> 2;
 i13 = (i4 << 2) + 4 | 0;
 i3 = i5;
 i4 = i5 + (Math_imul(i14, (i4 << 6) + 64 | 0) | 0) | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  if (!i3) {
   if (i12) i6 = 0; else {
    i6 = 0;
    do {
     d22 = +HEAPF64[i7 + (i6 << 4) + 8 >> 3] * d19;
     i24 = i6 | 1;
     d23 = +HEAPF64[i7 + (i24 << 4) >> 3] * d19;
     d25 = +HEAPF64[i7 + (i24 << 4) + 8 >> 3] * d19;
     HEAPF64[i8 + (i6 << 4) >> 3] = +HEAPF64[i7 + (i6 << 4) >> 3] * d19;
     HEAPF64[i8 + (i6 << 4) + 8 >> 3] = d22;
     HEAPF64[i8 + (i24 << 4) >> 3] = d23;
     HEAPF64[i8 + (i24 << 4) + 8 >> 3] = d25;
     i24 = i6 | 2;
     d25 = +HEAPF64[i7 + (i24 << 4) + 8 >> 3] * d19;
     i5 = i6 | 3;
     d23 = +HEAPF64[i7 + (i5 << 4) >> 3] * d19;
     d22 = +HEAPF64[i7 + (i5 << 4) + 8 >> 3] * d19;
     HEAPF64[i8 + (i24 << 4) >> 3] = +HEAPF64[i7 + (i24 << 4) >> 3] * d19;
     HEAPF64[i8 + (i24 << 4) + 8 >> 3] = d25;
     HEAPF64[i8 + (i5 << 4) >> 3] = d23;
     HEAPF64[i8 + (i5 << 4) + 8 >> 3] = d22;
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i11 | 0));
    i6 = i13;
   }
   if ((i6 | 0) < (i18 | 0)) do {
    d22 = +HEAPF64[i7 + (i6 << 4) + 8 >> 3] * d19;
    HEAPF64[i8 + (i6 << 4) >> 3] = +HEAPF64[i7 + (i6 << 4) >> 3] * d19;
    HEAPF64[i8 + (i6 << 4) + 8 >> 3] = d22;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i18 | 0));
  } else {
   if (i12) {
    i6 = i3;
    i5 = 0;
   } else {
    i6 = i3;
    i5 = 0;
    while (1) {
     i26 = i5 | 1;
     d22 = +HEAPF64[i7 + (i5 << 4) + 8 >> 3] * d19 + +HEAPF64[i6 + 8 >> 3] * d20;
     d23 = +HEAPF64[i7 + (i26 << 4) >> 3] * d19 + +HEAPF64[i6 + (i14 << 4) >> 3] * d20;
     d25 = +HEAPF64[i7 + (i26 << 4) + 8 >> 3] * d19 + +HEAPF64[i6 + (i14 << 4) + 8 >> 3] * d20;
     HEAPF64[i8 + (i5 << 4) >> 3] = +HEAPF64[i7 + (i5 << 4) >> 3] * d19 + +HEAPF64[i6 >> 3] * d20;
     HEAPF64[i8 + (i5 << 4) + 8 >> 3] = d22;
     HEAPF64[i8 + (i26 << 4) >> 3] = d23;
     HEAPF64[i8 + (i26 << 4) + 8 >> 3] = d25;
     i26 = i5 | 2;
     i24 = i5 | 3;
     d25 = +HEAPF64[i7 + (i26 << 4) + 8 >> 3] * d19 + +HEAPF64[i6 + (i2 << 4) + 8 >> 3] * d20;
     d23 = +HEAPF64[i7 + (i24 << 4) >> 3] * d19 + +HEAPF64[i6 + (i9 << 4) >> 3] * d20;
     d22 = +HEAPF64[i7 + (i24 << 4) + 8 >> 3] * d19 + +HEAPF64[i6 + (i9 << 4) + 8 >> 3] * d20;
     HEAPF64[i8 + (i26 << 4) >> 3] = +HEAPF64[i7 + (i26 << 4) >> 3] * d19 + +HEAPF64[i6 + (i2 << 4) >> 3] * d20;
     HEAPF64[i8 + (i26 << 4) + 8 >> 3] = d25;
     HEAPF64[i8 + (i24 << 4) >> 3] = d23;
     HEAPF64[i8 + (i24 << 4) + 8 >> 3] = d22;
     i5 = i5 + 4 | 0;
     if ((i5 | 0) > (i11 | 0)) {
      i6 = i4;
      i5 = i13;
      break;
     } else i6 = i6 + (i10 << 4) | 0;
    }
   }
   if ((i5 | 0) < (i18 | 0)) while (1) {
    d22 = +HEAPF64[i7 + (i5 << 4) + 8 >> 3] * d19 + +HEAPF64[i6 + 8 >> 3] * d20;
    HEAPF64[i8 + (i5 << 4) >> 3] = +HEAPF64[i7 + (i5 << 4) >> 3] * d19 + +HEAPF64[i6 >> 3] * d20;
    HEAPF64[i8 + (i5 << 4) + 8 >> 3] = d22;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i18 | 0)) break; else i6 = i6 + (i14 << 4) | 0;
   }
  }
  if (!i1) break; else {
   i7 = i7 + (i17 << 4) | 0;
   i8 = i8 + (i16 << 4) | 0;
   i3 = i3 + (i15 << 4) | 0;
   i4 = i4 + (i15 << 4) | 0;
  }
 }
 STACKTOP = i21;
 return;
}

function __ZNK12_GLOBAL__N_114NumpyFormatter6formatERKN2cv3MatE(i19, i1, i11) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i20 = i21;
 i17 = i21 + 72 | 0;
 i14 = i21 + 16 | 0;
 i10 = i21 + 80 | 0;
 i18 = i21 + 8 | 0;
 HEAP8[i10 + 0 >> 0] = HEAP8[8016] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[8017] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[8018] | 0;
 HEAP8[i10 + 3 >> 0] = HEAP8[8019] | 0;
 HEAP8[i10 + 4 >> 0] = HEAP8[8020] | 0;
 i4 = i11 + 12 | 0;
 if ((HEAP32[i4 >> 2] | 0) == 1) {
  HEAP8[i10 + 1 >> 0] = 0;
  HEAP8[i10 >> 0] = 0;
 }
 HEAP32[i20 >> 2] = HEAP32[7680 + ((HEAP32[i11 >> 2] & 7) << 2) >> 2];
 __ZN2cv6formatEPKcz(i18, 7784, i20);
 i3 = i11 + 8 | 0;
 if ((HEAP32[i3 >> 2] | 0) == 1) i9 = 1; else i9 = (HEAP32[i1 + 12 >> 2] | 0) == 0 & 1;
 i5 = (HEAP32[i11 >> 2] & 7 | 0) == 6 ? i1 + 8 | 0 : i1 + 4 | 0;
 i16 = __Znwj(156) | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 i2 = __ZN2cv6String8allocateEj(i20, 7) | 0;
 HEAP8[i2 + 0 >> 0] = HEAP8[7776] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[7777] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[7778] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[7779] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[7780] | 0;
 HEAP8[i2 + 5 >> 0] = HEAP8[7781] | 0;
 HEAP8[i2 + 6 >> 0] = HEAP8[7782] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 HEAP32[i17 >> 2] = i2;
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 if (i2) {
  i8 = i2 + -4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
 i15 = i14 + 4 | 0;
 i2 = i11 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i15 >> 2] = i1;
 i13 = i14 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i4 >> 2];
 i6 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
 HEAP32[i14 + 32 >> 2] = HEAP32[i11 + 32 >> 2];
 i7 = i14 + 36 | 0;
 i4 = HEAP32[i11 + 36 >> 2] | 0;
 HEAP32[i7 >> 2] = i4;
 i8 = i14 + 40 | 0;
 HEAP32[i8 >> 2] = i13;
 i13 = i14 + 48 | 0;
 i12 = i14 + 44 | 0;
 HEAP32[i12 >> 2] = i13;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 if (!i4) i4 = i1; else {
  i4 = i4 + 12 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  i4 = HEAP32[i2 >> 2] | 0;
 }
 if ((i4 | 0) < 3) {
  i3 = HEAP32[i11 + 44 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 } else {
  HEAP32[i15 >> 2] = 0;
  __ZN2cv3Mat8copySizeERKS0_(i14, i11);
 }
 __ZN12_GLOBAL__N_113FormattedImplC2EN2cv6StringES2_NS1_3MatEPcbbi(i16, i20, i17, i14, i10, i9 << 24 >> 24 != 0, 0, HEAP32[i5 >> 2] | 0);
 i4 = __Znwj(16) | 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i4 >> 2] = 7312;
 HEAP32[i4 + 8 >> 2] = i16;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i9 = i2 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 if ((HEAP32[i15 >> 2] | 0) > 0) {
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i15 >> 2] | 0));
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) != (i13 | 0)) __ZN2cv8fastFreeEPv(i1);
 __ZN2cv6String10deallocateEv(i17);
 __ZN2cv6String10deallocateEv(i20);
 HEAP32[i19 >> 2] = i4;
 HEAP32[i19 + 4 >> 2] = i16;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i10 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i10 + -1;
 if ((i10 | 0) != 1) {
  __ZN2cv6String10deallocateEv(i18);
  STACKTOP = i21;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] & 511](i4);
 __ZN2cv6String10deallocateEv(i18);
 STACKTOP = i21;
 return;
}

function __ZN2cvL6div16uEPKtjS1_jPtjNS_5Size_IiEEPv(i7, i3, i6, i4, i8, i5, i1, i2) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d9 = 0.0, d10 = 0.0, d11 = 0.0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, d22 = 0.0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, d30 = 0.0, d31 = 0.0;
 i29 = STACKTOP;
 i24 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 d22 = +HEAPF64[i2 >> 3];
 i21 = i3 >>> 1;
 i20 = i4 >>> 1;
 i17 = i5 >>> 1;
 if (!i1) {
  STACKTOP = i29;
  return;
 }
 i18 = i24 + -4 | 0;
 i19 = (i18 | 0) < 0;
 i16 = (i18 | 0) > 3 ? i24 & -4 : 4;
 while (1) {
  i1 = i1 + -1 | 0;
  if (i19) i4 = 0; else {
   i15 = 0;
   do {
    i3 = HEAP16[i6 + (i15 << 1) >> 1] | 0;
    i14 = i15 | 1;
    i4 = HEAP16[i6 + (i14 << 1) >> 1] | 0;
    do if (!(i3 << 16 >> 16)) {
     i13 = 0;
     i23 = 20;
    } else {
     i5 = i4 & 65535;
     if ((i4 << 16 >> 16 != 0 ? (i25 = i15 | 2, i26 = HEAP16[i6 + (i25 << 1) >> 1] | 0, i26 << 16 >> 16 != 0) : 0) ? (i27 = i15 | 3, i28 = HEAP16[i6 + (i27 << 1) >> 1] | 0, i28 << 16 >> 16 != 0) : 0) {
      d30 = +(i5 | 0);
      d31 = +(i3 & 65535) * d30;
      d10 = +(i28 & 65535 | 0);
      d9 = +(i26 & 65535) * d10;
      d11 = d22 / (d31 * d9);
      d9 = d9 * d11;
      d11 = d31 * d11;
      i5 = _lrint(d30 * (d9 * +(HEAPU16[i7 + (i15 << 1) >> 1] | 0))) | 0;
      if (i5 >>> 0 < 65536) i2 = i5; else i2 = (i5 | 0) > 0 ? 65535 : 0;
      i5 = _lrint(+(i3 & 65535 | 0) * (d9 * +(HEAPU16[i7 + (i14 << 1) >> 1] | 0))) | 0;
      if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
      i4 = _lrint(d10 * (d11 * +(HEAPU16[i7 + (i25 << 1) >> 1] | 0))) | 0;
      if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
      i3 = _lrint(+(i26 & 65535 | 0) * (d11 * +(HEAPU16[i7 + (i27 << 1) >> 1] | 0))) | 0;
      if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
      HEAP16[i8 + (i15 << 1) >> 1] = i2;
      HEAP16[i8 + (i14 << 1) >> 1] = i5;
      HEAP16[i8 + (i25 << 1) >> 1] = i4;
      HEAP16[i8 + (i27 << 1) >> 1] = i3;
      break;
     }
     i5 = _lrint(d22 * +(HEAPU16[i7 + (i15 << 1) >> 1] | 0 | 0) / +(i3 & 65535 | 0)) | 0;
     if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
     i13 = i5 & 65535;
     i23 = 20;
    } while (0);
    if ((i23 | 0) == 20) {
     i23 = 0;
     if (!(i4 << 16 >> 16)) i12 = 0; else {
      i5 = _lrint(d22 * +(HEAPU16[i7 + (i14 << 1) >> 1] | 0 | 0) / +(i4 & 65535 | 0)) | 0;
      if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
      i12 = i5 & 65535;
     }
     i2 = i15 | 2;
     i5 = HEAP16[i6 + (i2 << 1) >> 1] | 0;
     if (!(i5 << 16 >> 16)) i3 = 0; else {
      i5 = _lrint(d22 * +(HEAPU16[i7 + (i2 << 1) >> 1] | 0 | 0) / +(i5 & 65535 | 0)) | 0;
      if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
      i3 = i5 & 65535;
     }
     i4 = i15 | 3;
     i5 = HEAP16[i6 + (i4 << 1) >> 1] | 0;
     if (!(i5 << 16 >> 16)) i5 = 0; else {
      i5 = _lrint(d22 * +(HEAPU16[i7 + (i4 << 1) >> 1] | 0 | 0) / +(i5 & 65535 | 0)) | 0;
      if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
      i5 = i5 & 65535;
     }
     HEAP16[i8 + (i15 << 1) >> 1] = i13;
     HEAP16[i8 + (i14 << 1) >> 1] = i12;
     HEAP16[i8 + (i2 << 1) >> 1] = i3;
     HEAP16[i8 + (i4 << 1) >> 1] = i5;
    }
    i15 = i15 + 4 | 0;
   } while ((i15 | 0) <= (i18 | 0));
   i4 = i16;
  }
  if ((i4 | 0) < (i24 | 0)) do {
   i5 = HEAP16[i6 + (i4 << 1) >> 1] | 0;
   if (!(i5 << 16 >> 16)) i5 = 0; else {
    i5 = _lrint(d22 * +(HEAPU16[i7 + (i4 << 1) >> 1] | 0 | 0) / +(i5 & 65535 | 0)) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i5 = i5 & 65535;
   }
   HEAP16[i8 + (i4 << 1) >> 1] = i5;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i24 | 0));
  if (!i1) break; else {
   i6 = i6 + (i20 << 1) | 0;
   i7 = i7 + (i21 << 1) | 0;
   i8 = i8 + (i17 << 1) | 0;
  }
 }
 STACKTOP = i29;
 return;
}

function __ZN2cv3Mat6createEiPKii(i11, i7, i6, i2) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i3 = i12 + 16 | 0;
 i9 = i12 + 8 | 0;
 i10 = i12;
 if (!(i7 >>> 0 < 33 & (i6 | 0) != 0)) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i3, 35) | 0) + 0 | 0;
  i1 = 27632;
  i5 = i4 + 35 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i4 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 27672, 27528, 370);
  __ZN2cv6String10deallocateEv(i3);
 }
 i8 = i2 & 4095;
 do if (HEAP32[i11 + 16 >> 2] | 0) {
  i5 = HEAP32[i11 + 4 >> 2] | 0;
  if ((i5 | 0) != (i7 | 0) ? !((i7 | 0) == 1 & (i5 | 0) < 3) : 0) break;
  if ((i8 | 0) == (HEAP32[i11 >> 2] & 4095 | 0)) {
   if ((i7 | 0) == 2) if ((HEAP32[i11 + 8 >> 2] | 0) == (HEAP32[i6 >> 2] | 0)) if ((HEAP32[i11 + 12 >> 2] | 0) == (HEAP32[i6 + 4 >> 2] | 0)) {
    STACKTOP = i12;
    return;
   } else i2 = 10; else i2 = 11; else i2 = 10;
   if ((i2 | 0) == 10) if ((i7 | 0) > 0) i2 = 11; else i1 = 0;
   L16 : do if ((i2 | 0) == 11) {
    i2 = HEAP32[i11 + 40 >> 2] | 0;
    i3 = 0;
    while (1) {
     i1 = i3 + 1 | 0;
     if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) != (HEAP32[i6 + (i3 << 2) >> 2] | 0)) {
      i1 = i3;
      break L16;
     }
     if ((i1 | 0) < (i7 | 0)) i3 = i1; else break;
    }
   } while (0);
   if ((i1 | 0) == (i7 | 0)) {
    if ((i7 | 0) > 1) {
     STACKTOP = i12;
     return;
    }
    if ((HEAP32[(HEAP32[i11 + 40 >> 2] | 0) + 4 >> 2] | 0) == 1) {
     STACKTOP = i12;
     return;
    }
   }
  }
 } while (0);
 __ZN2cv3Mat7releaseEv(i11);
 if (!i7) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i11 >> 2] = i8 | 1124007936;
 __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i11, i7, i6, 0, 1);
 i5 = i11 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i3 | 0) < 3) i1 = Math_imul(HEAP32[i11 + 12 >> 2] | 0, HEAP32[i11 + 8 >> 2] | 0) | 0; else {
  i2 = HEAP32[i11 + 40 >> 2] | 0;
  i4 = 0;
  i1 = 1;
  do {
   i1 = Math_imul(HEAP32[i2 + (i4 << 2) >> 2] | 0, i1) | 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i3 | 0));
 }
 if (i1) {
  i1 = HEAP32[i11 + 32 >> 2] | 0;
  if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
   i7 = __Znwj(4) | 0;
   HEAP32[i7 >> 2] = 32784;
   HEAP32[6904] = i7;
   ___cxa_guard_release(27624);
  }
  i7 = (i1 | 0) == 0 ? HEAP32[6904] | 0 : i1;
  i1 = i11 + 44 | 0;
  i8 = FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] & 15](i7, HEAP32[i5 >> 2] | 0, HEAP32[i11 + 40 >> 2] | 0, i8, 0, HEAP32[i1 >> 2] | 0, 0, 0) | 0;
  HEAP32[i11 + 36 >> 2] = i8;
  if (!i8) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   i8 = __ZN2cv6String8allocateEj(i9, 6) | 0;
   HEAP8[i8 + 0 >> 0] = HEAP8[27680] | 0;
   HEAP8[i8 + 1 >> 0] = HEAP8[27681] | 0;
   HEAP8[i8 + 2 >> 0] = HEAP8[27682] | 0;
   HEAP8[i8 + 3 >> 0] = HEAP8[27683] | 0;
   HEAP8[i8 + 4 >> 0] = HEAP8[27684] | 0;
   HEAP8[i8 + 5 >> 0] = HEAP8[27685] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i9, 27672, 27528, 402);
   __ZN2cv6String10deallocateEv(i9);
  }
  i9 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[(HEAP32[i1 >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) + -1 << 2) >> 2] | 0) != ((i9 >>> 3 & 511) + 1 << (47696 >>> (i9 << 1 & 14) & 3) | 0)) {
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   i4 = (__ZN2cv6String8allocateEj(i10, 43) | 0) + 0 | 0;
   i1 = 27688;
   i5 = i4 + 43 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i1 = i1 + 1 | 0;
   } while ((i4 | 0) < (i5 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 27672, 27528, 410);
   __ZN2cv6String10deallocateEv(i10);
  }
 }
 i1 = HEAP32[i11 + 36 >> 2] | 0;
 if (i1) {
  i10 = i1 + 12 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 __ZN2cvL11finalizeHdrERNS_3MatE(i11);
 STACKTOP = i12;
 return;
}

function __ZN7testing8internal24XmlUnitTestResultPrinter29TestPropertiesAsXmlAttributesERKNS_10TestResultE(i18, i3) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i17 = i20 + 28 | 0;
 i19 = i20 + 24 | 0;
 i11 = i20 + 12 | 0;
 i12 = i20;
 __ZN7testing7MessageC2Ev(i19);
 i13 = i3 + 20 | 0;
 i14 = i3 + 16 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = (HEAP32[i13 >> 2] | 0) - i1 | 0;
 L1 : do if ((i2 | 0) > 0) {
  i7 = i3 + 16 | 0;
  i8 = i11 + 1 | 0;
  i9 = i11 + 8 | 0;
  i10 = i11 + 4 | 0;
  i3 = (i2 | 0) / 24 | 0;
  i6 = 0;
  while (1) {
   if (i3 >>> 0 <= i6 >>> 0) break;
   i3 = i1 + (i6 * 24 | 0) | 0;
   i5 = HEAP32[i19 >> 2] | 0;
   i4 = i5 + 8 | 0;
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, 163296, 1) | 0;
   if (HEAP8[i3 >> 0] & 1) {
    i3 = HEAP32[i1 + (i6 * 24 | 0) + 8 >> 2] | 0;
    if (!i3) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, 160784, 6) | 0; else i16 = 10;
   } else {
    i3 = i3 + 1 | 0;
    i16 = 10;
   }
   if ((i16 | 0) == 10) {
    i16 = 0;
    __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, i3, _strlen(i3 | 0) | 0) | 0;
   }
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, 163720, 1) | 0;
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, 160776, 1) | 0;
   i3 = i1 + (i6 * 24 | 0) + 12 | 0;
   if (!(HEAP8[i3 >> 0] & 1)) i3 = i3 + 1 | 0; else i3 = HEAP32[i1 + (i6 * 24 | 0) + 20 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i3, _strlen(i3 | 0) | 0);
   __ZN7testing8internal24XmlUnitTestResultPrinter9EscapeXmlERKNSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEb(i11, i12, 1);
   i3 = HEAP8[i11 >> 0] | 0;
   if (!(i3 & 1)) {
    i2 = i8;
    i3 = (i3 & 255) >>> 1;
   } else {
    i2 = HEAP32[i9 >> 2] | 0;
    i3 = HEAP32[i10 >> 2] | 0;
   }
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, i2, i3) | 0;
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, 160776, 1) | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
   i6 = i6 + 1 | 0;
   i1 = HEAP32[i14 >> 2] | 0;
   i3 = ((HEAP32[i13 >> 2] | 0) - i1 | 0) / 24 | 0;
   if ((i6 | 0) >= (i3 | 0)) {
    i15 = i5;
    break L1;
   }
  }
  __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i7);
 } else i15 = HEAP32[i19 >> 2] | 0; while (0);
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i17, i15 + 12 | 0);
 i1 = HEAP8[i17 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i17 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i17 + 8 >> 2] | 0;
  i1 = HEAP32[i17 + 4 >> 2] | 0;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i18 + 0 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i18, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i18, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i18, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i17);
 i1 = HEAP32[i19 >> 2] | 0;
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 HEAP32[i19 >> 2] = 0;
 STACKTOP = i20;
 return;
}

function __ZL18icvWriteHeaderDataP13CvFileStoragePK5CvSeqP10CvAttrListi(i14, i15, i4, i9) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 672 | 0;
 i12 = i16;
 i8 = i16 + 544 | 0;
 i10 = i16 + 536 | 0;
 i6 = i16 + 528 | 0;
 i7 = i16 + 520 | 0;
 i13 = i16 + 512 | 0;
 L1 : do if (i4) {
  L2 : while (1) {
   i5 = HEAP32[i4 >> 2] | 0;
   if (!i5) {
    i11 = 14;
    break L1;
   }
   i3 = HEAP32[i5 >> 2] | 0;
   if (i3) {
    i2 = 0;
    i1 = 0;
    do {
     i1 = i1 + 1 | 0;
     if (!(_strcmp(12608, i3) | 0)) break L2;
     i2 = i1 << 1;
     i3 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
    } while ((i3 | 0) != 0);
   }
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i4) {
    i11 = 14;
    break L1;
   }
  }
  i1 = HEAP32[i5 + ((i2 | 1) << 2) >> 2] | 0;
  if (i1) {
   i8 = __ZL15icvDecodeFormatPKcPii(i1, i12) | 0;
   i4 = i8 << 1;
   if ((i8 | 0) > 0) {
    i3 = 0;
    i2 = i9;
    do {
     i8 = HEAP32[i12 + ((i3 | 1) << 2) >> 2] | 0;
     i8 = (i8 >>> 3 & 511) + 1 << (47696 >>> (i8 << 1 & 14) & 3);
     i2 = (i2 + -1 + i8 & 0 - i8) + (Math_imul(i8, HEAP32[i12 + (i3 << 2) >> 2] | 0) | 0) | 0;
     i3 = i3 + 2 | 0;
    } while ((i3 | 0) < (i4 | 0));
   } else i2 = i9;
   if (!i9) {
    i9 = HEAP32[i12 + 4 >> 2] | 0;
    i9 = (i9 >>> 3 & 511) + 1 << (47696 >>> (i9 << 1 & 14) & 3);
    i2 = i2 + -1 + i9 & 0 - i9;
   }
   if ((i2 | 0) > (HEAP32[i15 + 4 >> 2] | 0)) {
    HEAP32[i10 >> 2] = 0;
    HEAP32[i10 + 4 >> 2] = 0;
    i2 = (__ZN2cv6String8allocateEj(i10, 74) | 0) + 0 | 0;
    i3 = 12624 | 0;
    i4 = i2 + 74 | 0;
    do {
     HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
     i2 = i2 + 1 | 0;
     i3 = i3 + 1 | 0;
    } while ((i2 | 0) < (i4 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-209, i10, 12704, 8960, 4005);
    __ZN2cv6String10deallocateEv(i10);
   }
   if (!i1) {
    STACKTOP = i16;
    return;
   }
  } else i11 = 14;
 } else i11 = 14; while (0);
 do if ((i11 | 0) == 14) {
  i2 = HEAP32[i15 + 4 >> 2] | 0;
  if ((i2 | 0) <= (i9 | 0)) {
   STACKTOP = i16;
   return;
  }
  if (i15) {
   i1 = HEAP32[i15 >> 2] | 0;
   if (((i1 & -65536 | 0) == 1117323264 ? (i1 & 4094 | 0) == 12 & (i2 | 0) == 88 : 0) ? (HEAP32[i15 + 28 >> 2] | 0) == 8 : 0) {
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i12 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    _cvStartWriteStruct(i14, 12728, 14, 0, i12);
    _cvWriteInt(i14, 12200, HEAP32[i15 + 56 >> 2] | 0);
    _cvWriteInt(i14, 12208, HEAP32[i15 + 60 >> 2] | 0);
    _cvWriteInt(i14, 12104, HEAP32[i15 + 64 >> 2] | 0);
    _cvWriteInt(i14, 12112, HEAP32[i15 + 68 >> 2] | 0);
    _cvEndWriteStruct(i14);
    _cvWriteInt(i14, 12736, HEAP32[i15 + 72 >> 2] | 0);
    STACKTOP = i16;
    return;
   }
   if ((i1 & -53248 | 0) == 1117327360 ? ((i1 & 4095 | 0) == 0 ? (HEAP32[i15 + 28 >> 2] | 0) == 1 : 0) : 0) {
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i12 + 0 >> 2] = HEAP32[i7 + 0 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    _cvStartWriteStruct(i14, 12120, 14, 0, i12);
    _cvWriteInt(i14, 12200, HEAP32[i15 + 56 >> 2] | 0);
    _cvWriteInt(i14, 12208, HEAP32[i15 + 60 >> 2] | 0);
    _cvEndWriteStruct(i14);
    STACKTOP = i16;
    return;
   }
  }
  i1 = i2 - i9 | 0;
  if (!(i1 & 3)) {
   HEAP32[i12 >> 2] = i1 >>> 2;
   _sprintf(i8, 12744, i12) | 0;
   i1 = i8;
   break;
  } else {
   HEAP32[i12 >> 2] = i1;
   _sprintf(i8, 12752, i12) | 0;
   i1 = i8;
   break;
  }
 } while (0);
 _cvWriteString(i14, 12608, i1, 0);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i12 + 0 >> 2] = HEAP32[i13 + 0 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 _cvStartWriteStruct(i14, 12760, 13, 0, i12);
 _cvWriteRawData(i14, i15 + 56 | 0, 1, i1);
 _cvEndWriteStruct(i14);
 STACKTOP = i16;
 return;
}

function __ZN2cvL7setSizeERNS_4UMatEiPKiPKjb(i18, i16, i17, i7, i13) {
 i18 = i18 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i7 = i7 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i1 = i19 + 16 | 0;
 i15 = i19 + 8 | 0;
 i12 = i19;
 if (i16 >>> 0 >= 33) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i1, 33) | 0) + 0 | 0;
  i4 = 18136 | 0;
  i5 = i2 + 33 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i2 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 18176, 17672, 130);
  __ZN2cv6String10deallocateEv(i1);
 }
 i14 = i18 + 4 | 0;
 if ((HEAP32[i14 >> 2] | 0) != (i16 | 0)) {
  i3 = i18 + 36 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = i18 + 40 | 0;
  if ((i1 | 0) != (i2 | 0)) {
   __ZN2cv8fastFreeEPv(i1);
   HEAP32[i3 >> 2] = i2;
   HEAP32[i18 + 32 >> 2] = i18 + 8;
  }
  if ((i16 | 0) > 2) {
   i10 = __ZN2cv10fastMallocEj(i16 << 3 | 4) | 0;
   HEAP32[i3 >> 2] = i10;
   HEAP32[i18 + 32 >> 2] = i10 + (i16 + 1 << 2);
   HEAP32[i10 + (i16 << 2) >> 2] = i16;
   HEAP32[i18 + 12 >> 2] = -1;
   HEAP32[i18 + 8 >> 2] = -1;
  }
 }
 HEAP32[i14 >> 2] = i16;
 if (!i17) {
  STACKTOP = i19;
  return;
 }
 i8 = HEAP32[i18 >> 2] | 0;
 i8 = (i8 >>> 3 & 511) + 1 << (47696 >>> (i8 << 1 & 14) & 3);
 i1 = i16 + -1 | 0;
 if ((i16 | 0) <= 0) {
  STACKTOP = i19;
  return;
 }
 i9 = i18 + 32 | 0;
 i10 = i18 + 36 | 0;
 i6 = i12 + 4 | 0;
 i11 = i15 + 4 | 0;
 if (!i7) {
  i3 = i8;
  while (1) {
   i2 = HEAP32[i17 + (i1 << 2) >> 2] | 0;
   if ((i2 | 0) <= -1) {
    HEAP32[i15 >> 2] = 0;
    HEAP32[i11 >> 2] = 0;
    i7 = __ZN2cv6String8allocateEj(i15, 6) | 0;
    HEAP8[i7 + 0 >> 0] = HEAP8[18184] | 0;
    HEAP8[i7 + 1 >> 0] = HEAP8[18185] | 0;
    HEAP8[i7 + 2 >> 0] = HEAP8[18186] | 0;
    HEAP8[i7 + 3 >> 0] = HEAP8[18187] | 0;
    HEAP8[i7 + 4 >> 0] = HEAP8[18188] | 0;
    HEAP8[i7 + 5 >> 0] = HEAP8[18189] | 0;
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i15, 18176, 17672, 157);
    __ZN2cv6String10deallocateEv(i15);
   }
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = i2;
   if (i13) {
    HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] = i3;
    i3 = ___muldi3(i2 | 0, ((i2 | 0) < 0) << 31 >> 31 | 0, i3 | 0, 0) | 0;
    if (!((i3 | 0) == (i3 | 0) & (tempRet0 | 0) == 0)) {
     HEAP32[i12 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
     i2 = (__ZN2cv6String8allocateEj(i12, 51) | 0) + 0 | 0;
     i4 = 18192 | 0;
     i5 = i2 + 51 | 0;
     do {
      HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
      i2 = i2 + 1 | 0;
      i4 = i4 + 1 | 0;
     } while ((i2 | 0) < (i5 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i12, 18176, 17672, 167);
     __ZN2cv6String10deallocateEv(i12);
    }
   }
   if ((i1 | 0) > 0) i1 = i1 + -1 | 0; else break;
  }
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i17 + (i2 << 2) >> 2] | 0;
   if ((i3 | 0) <= -1) {
    HEAP32[i15 >> 2] = 0;
    HEAP32[i11 >> 2] = 0;
    i6 = __ZN2cv6String8allocateEj(i15, 6) | 0;
    HEAP8[i6 + 0 >> 0] = HEAP8[18184] | 0;
    HEAP8[i6 + 1 >> 0] = HEAP8[18185] | 0;
    HEAP8[i6 + 2 >> 0] = HEAP8[18186] | 0;
    HEAP8[i6 + 3 >> 0] = HEAP8[18187] | 0;
    HEAP8[i6 + 4 >> 0] = HEAP8[18188] | 0;
    HEAP8[i6 + 5 >> 0] = HEAP8[18189] | 0;
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i15, 18176, 17672, 157);
    __ZN2cv6String10deallocateEv(i15);
   }
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] = i3;
   if ((i2 | 0) < (i1 | 0)) i3 = HEAP32[i7 + (i2 << 2) >> 2] | 0; else i3 = i8;
   HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] = i3;
   if ((i2 | 0) > 0) i2 = i2 + -1 | 0; else break;
  }
 }
 if ((i16 | 0) != 1) {
  STACKTOP = i19;
  return;
 }
 HEAP32[i14 >> 2] = 2;
 HEAP32[i18 + 12 >> 2] = 1;
 HEAP32[(HEAP32[i18 + 36 >> 2] | 0) + 4 >> 2] = i8;
 STACKTOP = i19;
 return;
}

function __ZNK2cv11_InputArray4stepEi(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i4 = i10 + 40 | 0;
 i3 = i10 + 32 | 0;
 i7 = i10 + 24 | 0;
 i8 = i10 + 16 | 0;
 i2 = i10 + 8 | 0;
 i1 = i10;
 i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] & 127](i6) | 0;
 if ((i5 | 0) == 0 | (i5 | 0) == 131072 | (i5 | 0) == 196608 | (i5 | 0) == 262144 | (i5 | 0) == 393216) {
  i1 = 0;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i5 | 0) == 720896) {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((((HEAP32[i2 + 4 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0 <= i9 >>> 0) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i8, 21) | 0) + 0 | 0;
   i3 = 29320 | 0;
   i4 = i1 + 21 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i1 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 29384, 27528, 2015);
   __ZN2cv6String10deallocateEv(i8);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  i1 = HEAP32[i1 + (i9 * 48 | 0) + 40 >> 2] | 0;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i5 | 0) == 327680) {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  if ((i9 | 0) < 0) {
   i1 = 1;
   STACKTOP = i10;
   return i1 | 0;
  }
  i1 = HEAP32[i2 >> 2] | 0;
  if ((((HEAP32[i2 + 4 >> 2] | 0) - i1 | 0) / 56 | 0 | 0) <= (i9 | 0)) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i7, 18) | 0) + 0 | 0;
   i3 = 29208 | 0;
   i4 = i1 + 18 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i1 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 29384, 27528, 2008);
   __ZN2cv6String10deallocateEv(i7);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  i1 = HEAP32[i1 + (i9 * 56 | 0) + 48 >> 2] | 0;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i5 | 0) == 655360) {
  if ((i9 | 0) >= 0) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i3, 5) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 29384, 27528, 1996);
   __ZN2cv6String10deallocateEv(i3);
  }
  i1 = HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 40 >> 2] | 0;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i5 | 0) == 65536) {
  if ((i9 | 0) >= 0) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i4, 5) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 29384, 27528, 1990);
   __ZN2cv6String10deallocateEv(i4);
  }
  i1 = HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 48 >> 2] | 0;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i5 | 0) == 589824) {
  if ((i9 | 0) >= 0) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   i1 = __ZN2cv6String8allocateEj(i2, 5) | 0;
   HEAP8[i1 + 0 >> 0] = HEAP8[28696] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[28697] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[28698] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[28699] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[28700] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 29384, 27528, 2021);
   __ZN2cv6String10deallocateEv(i2);
  }
  i1 = HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 12 >> 2] | 0;
  STACKTOP = i10;
  return i1 | 0;
 } else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i1, 29384, 27528, 2025);
  __ZN2cv6String10deallocateEv(i1);
  i1 = 0;
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cvL6mul16uEPKtjS1_jPtjNS_5Size_IiEEPv(i10, i2, i9, i4, i11, i5, i3, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0;
 i18 = STACKTOP;
 f13 = Math_fround(+HEAPF64[i1 >> 3]);
 i17 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i16 = i2 >>> 1;
 i15 = i4 >>> 1;
 i14 = i5 >>> 1;
 i5 = i1 + -1 | 0;
 i1 = (i1 | 0) == 0;
 if (f13 == Math_fround(1.0)) {
  if (i1) {
   STACKTOP = i18;
   return;
  }
  i6 = i17 + -4 | 0;
  i7 = (i6 | 0) < 0;
  i8 = (i6 | 0) > 3 ? i17 & -4 : 4;
  i1 = i9;
  i2 = i10;
  i3 = i11;
  while (1) {
   if (i7) i4 = 0; else {
    i4 = 0;
    do {
     i10 = Math_imul(HEAPU16[i1 + (i4 << 1) >> 1] | 0, HEAPU16[i2 + (i4 << 1) >> 1] | 0) | 0;
     i11 = i4 | 1;
     i12 = Math_imul(HEAPU16[i1 + (i11 << 1) >> 1] | 0, HEAPU16[i2 + (i11 << 1) >> 1] | 0) | 0;
     HEAP16[i3 + (i4 << 1) >> 1] = i10 >>> 0 > 65535 ? -1 : i10 & 65535;
     HEAP16[i3 + (i11 << 1) >> 1] = i12 >>> 0 > 65535 ? -1 : i12 & 65535;
     i11 = i4 | 2;
     i12 = Math_imul(HEAPU16[i1 + (i11 << 1) >> 1] | 0, HEAPU16[i2 + (i11 << 1) >> 1] | 0) | 0;
     i10 = i4 | 3;
     i9 = Math_imul(HEAPU16[i1 + (i10 << 1) >> 1] | 0, HEAPU16[i2 + (i10 << 1) >> 1] | 0) | 0;
     HEAP16[i3 + (i11 << 1) >> 1] = i12 >>> 0 > 65535 ? -1 : i12 & 65535;
     HEAP16[i3 + (i10 << 1) >> 1] = i9 >>> 0 > 65535 ? -1 : i9 & 65535;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) <= (i6 | 0));
    i4 = i8;
   }
   if ((i4 | 0) < (i17 | 0)) do {
    i10 = Math_imul(HEAPU16[i1 + (i4 << 1) >> 1] | 0, HEAPU16[i2 + (i4 << 1) >> 1] | 0) | 0;
    HEAP16[i3 + (i4 << 1) >> 1] = i10 >>> 0 > 65535 ? -1 : i10 & 65535;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i17 | 0));
   if (!i5) break; else {
    i1 = i1 + (i15 << 1) | 0;
    i2 = i2 + (i16 << 1) | 0;
    i3 = i3 + (i14 << 1) | 0;
    i5 = i5 + -1 | 0;
   }
  }
  STACKTOP = i18;
  return;
 }
 if (i1) {
  STACKTOP = i18;
  return;
 }
 i2 = i17 + -4 | 0;
 i6 = (i2 | 0) < 0;
 i12 = (i2 | 0) > 3 ? i17 & -4 : 4;
 i1 = i5;
 while (1) {
  if (i6) i5 = 0; else {
   i7 = 0;
   do {
    f19 = Math_fround(f13 * Math_fround(HEAPU16[i10 + (i7 << 1) >> 1] | 0));
    i5 = _lrint(+Math_fround(f19 * Math_fround(HEAPU16[i9 + (i7 << 1) >> 1] | 0 | 0))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i3 = i7 | 1;
    f19 = Math_fround(f13 * Math_fround(HEAPU16[i10 + (i3 << 1) >> 1] | 0));
    i4 = _lrint(+Math_fround(f19 * Math_fround(HEAPU16[i9 + (i3 << 1) >> 1] | 0 | 0))) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    HEAP16[i11 + (i7 << 1) >> 1] = i5;
    HEAP16[i11 + (i3 << 1) >> 1] = i4;
    i8 = i7 | 2;
    f19 = Math_fround(f13 * Math_fround(HEAPU16[i10 + (i8 << 1) >> 1] | 0));
    i5 = _lrint(+Math_fround(f19 * Math_fround(HEAPU16[i9 + (i8 << 1) >> 1] | 0 | 0))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i3 = i7 | 3;
    f19 = Math_fround(f13 * Math_fround(HEAPU16[i10 + (i3 << 1) >> 1] | 0));
    i4 = _lrint(+Math_fround(f19 * Math_fround(HEAPU16[i9 + (i3 << 1) >> 1] | 0 | 0))) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    HEAP16[i11 + (i8 << 1) >> 1] = i5;
    HEAP16[i11 + (i3 << 1) >> 1] = i4;
    i7 = i7 + 4 | 0;
   } while ((i7 | 0) <= (i2 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i17 | 0)) do {
   f19 = Math_fround(f13 * Math_fround(HEAPU16[i10 + (i5 << 1) >> 1] | 0));
   i4 = _lrint(+Math_fround(f19 * Math_fround(HEAPU16[i9 + (i5 << 1) >> 1] | 0 | 0))) | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i11 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i17 | 0));
  if (!i1) break; else {
   i9 = i9 + (i15 << 1) | 0;
   i10 = i10 + (i16 << 1) | 0;
   i11 = i11 + (i14 << 1) | 0;
   i1 = i1 + -1 | 0;
  }
 }
 STACKTOP = i18;
 return;
}

function _gz_open(i12, i2, i3) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i13 = i18;
 if (!i12) {
  i10 = 0;
  STACKTOP = i18;
  return i10 | 0;
 }
 i16 = _malloc(140) | 0;
 if (!i16) {
  i10 = 0;
  STACKTOP = i18;
  return i10 | 0;
 }
 HEAP32[i16 + 24 >> 2] = 0;
 HEAP32[i16 + 28 >> 2] = 8192;
 i17 = i16 + 80 | 0;
 HEAP32[i17 >> 2] = 0;
 i14 = i16 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i9 = i16 + 60 | 0;
 HEAP32[i9 >> 2] = -1;
 i10 = i16 + 64 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i16 + 40 | 0;
 HEAP32[i11 >> 2] = 0;
 i1 = HEAP8[i3 >> 0] | 0;
 L7 : do if (i1 << 24 >> 24) {
  i6 = 0;
  i5 = 0;
  i7 = 0;
  i8 = 0;
  L8 : while (1) {
   i4 = i1 << 24 >> 24;
   L10 : do if ((i1 + -48 << 24 >> 24 & 255) < 10) {
    HEAP32[i9 >> 2] = i4 + -48;
    i4 = i6;
   } else do switch (i4 | 0) {
   case 120:
    {
     i4 = i6;
     i8 = 1;
     break L10;
    }
   case 70:
    {
     HEAP32[i10 >> 2] = 4;
     i4 = i6;
     break L10;
    }
   case 97:
    {
     HEAP32[i14 >> 2] = 1;
     i4 = i6;
     i5 = 1;
     break L10;
    }
   case 114:
    {
     HEAP32[i14 >> 2] = 7247;
     i4 = i6;
     i5 = 7247;
     break L10;
    }
   case 119:
    {
     HEAP32[i14 >> 2] = 31153;
     i4 = i6;
     i5 = 31153;
     break L10;
    }
   case 102:
    {
     HEAP32[i10 >> 2] = 1;
     i4 = i6;
     break L10;
    }
   case 104:
    {
     HEAP32[i10 >> 2] = 2;
     i4 = i6;
     break L10;
    }
   case 43:
    {
     i15 = 10;
     break L8;
    }
   case 82:
    {
     HEAP32[i10 >> 2] = 3;
     i4 = i6;
     break L10;
    }
   case 101:
    {
     i4 = i6;
     i7 = 1;
     break L10;
    }
   case 84:
    {
     HEAP32[i11 >> 2] = 1;
     i4 = 1;
     break L10;
    }
   default:
    {
     i4 = i6;
     break L10;
    }
   } while (0); while (0);
   i3 = i3 + 1 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   if (!(i1 << 24 >> 24)) break; else i6 = i4;
  }
  if ((i15 | 0) == 10) {
   _free(i16);
   i10 = 0;
   STACKTOP = i18;
   return i10 | 0;
  }
  do if (!i5) break L7; else if ((i5 | 0) == 7247) {
   if (!i4) {
    HEAP32[i11 >> 2] = 1;
    break;
   }
   _free(i16);
   i10 = 0;
   STACKTOP = i18;
   return i10 | 0;
  } while (0);
  i3 = (_strlen(i12 | 0) | 0) + 1 | 0;
  i1 = _malloc(i3) | 0;
  i4 = i16 + 20 | 0;
  HEAP32[i4 >> 2] = i1;
  if (!i1) {
   _free(i16);
   i10 = 0;
   STACKTOP = i18;
   return i10 | 0;
  }
  HEAP32[i13 >> 2] = i12;
  _snprintf(i1, i3, 143320, i13) | 0;
  i1 = HEAP32[i14 >> 2] | 0;
  if ((i1 | 0) == 7247) i3 = 0; else i3 = ((i1 | 0) == 31153 ? 512 : 1024) | ((i8 | 0) != 0 ? 193 : 65);
  do if ((i2 | 0) > -1) HEAP32[i16 + 16 >> 2] = i2; else {
   HEAP32[i13 >> 2] = 438;
   i2 = _open(i12 | 0, i3 | ((i7 | 0) != 0 ? 557056 : 32768) | 0, i13 | 0) | 0;
   HEAP32[i16 + 16 >> 2] = i2;
   if ((i2 | 0) != -1) {
    i1 = HEAP32[i14 >> 2] | 0;
    break;
   }
   _free(HEAP32[i4 >> 2] | 0);
   _free(i16);
   i10 = 0;
   STACKTOP = i18;
   return i10 | 0;
  } while (0);
  if ((i1 | 0) == 1) {
   HEAP32[i14 >> 2] = 31153;
   i15 = 35;
  } else if ((i1 | 0) == 7247) {
   i10 = _lseek(i2 | 0, 0, 1) | 0;
   HEAP32[i16 + 48 >> 2] = (i10 | 0) == -1 ? 0 : i10;
   i10 = HEAP32[i14 >> 2] | 0;
   HEAP32[i16 >> 2] = 0;
   if ((i10 | 0) == 7247) {
    HEAP32[i16 + 52 >> 2] = 0;
    HEAP32[i16 + 56 >> 2] = 0;
    HEAP32[i16 + 44 >> 2] = 0;
   }
  } else i15 = 35;
  if ((i15 | 0) == 35) HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 72 >> 2] = 0;
  i2 = HEAP32[i17 >> 2] | 0;
  i1 = i16 + 76 | 0;
  if (i2) {
   if ((HEAP32[i1 >> 2] | 0) != -4) _free(i2);
   HEAP32[i17 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  HEAP32[i16 + 88 >> 2] = 0;
  i10 = i16;
  STACKTOP = i18;
  return i10 | 0;
 } while (0);
 _free(i16);
 i10 = 0;
 STACKTOP = i18;
 return i10 | 0;
}

function __ZNK2cv17CommandLineParser4Impl12split_stringERKNS_6StringEcb(i14, i1, i2, i11, i13) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i15 = i17 + 24 | 0;
 i16 = i17 + 16 | 0;
 i6 = i17 + 8 | 0;
 i7 = i17;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i15 >> 2] = i1;
 i8 = i15 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i2 + 4 >> 2];
 if (i1) {
  i10 = i1 + -4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 HEAP32[i14 >> 2] = 0;
 i12 = i14 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i9 = i14 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 i10 = i16 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 __ZN2cv6String8allocateEj(i16, 0) | 0;
 i4 = i7 + 4 | 0;
 i5 = i6 + 4 | 0;
 while (1) {
  if (!(HEAP32[i8 >> 2] | 0)) break;
  i2 = HEAP8[HEAP32[i15 >> 2] >> 0] | 0;
  if (i2 << 24 >> 24 == i11 << 24 >> 24) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i1 | 0) != 0 | i13) {
    i2 = HEAP32[i12 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i14, i16); else {
     if (i2) {
      i3 = HEAP32[i16 >> 2] | 0;
      HEAP32[i2 >> 2] = i3;
      HEAP32[i2 + 4 >> 2] = i1;
      if (i3) {
       i2 = i3 + -4 | 0;
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
       i2 = HEAP32[i12 >> 2] | 0;
      }
     } else i2 = 0;
     HEAP32[i12 >> 2] = i2 + 8;
    }
    __ZN2cv6String10deallocateEv(i16);
    __ZN2cv6String8allocateEj(i16, 0) | 0;
   }
  } else {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   __ZN2cv6String8allocateEj(i6, (HEAP32[i10 >> 2] | 0) + 1 | 0) | 0;
   _memcpy(HEAP32[i6 >> 2] | 0, HEAP32[i16 >> 2] | 0, HEAP32[i10 >> 2] | 0) | 0;
   HEAP8[(HEAP32[i6 >> 2] | 0) + (HEAP32[i10 >> 2] | 0) >> 0] = i2;
   __ZN2cv6String10deallocateEv(i16);
   i2 = HEAP32[i6 >> 2] | 0;
   if (!i2) i2 = 0; else {
    i2 = i2 + -4 | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i2;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   __ZN2cv6String10deallocateEv(i6);
  }
  i3 = HEAP32[i8 >> 2] | 0;
  i18 = i3 + -1 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i2 = (i3 | 0) != 0 & 1;
  i1 = i3 - i2 | 0;
  i1 = i1 >>> 0 > i18 >>> 0 ? i18 : i1;
  do if (i1) if ((i1 | 0) == (i3 | 0)) {
   i3 = (HEAP32[i15 >> 2] | 0) + -4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   HEAP32[i7 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
   break;
  } else {
   i3 = __ZN2cv6String8allocateEj(i7, i1) | 0;
   _memcpy(i3 | 0, (HEAP32[i15 >> 2] | 0) + i2 | 0, i1 | 0) | 0;
   break;
  } while (0);
  __ZN2cv6String10deallocateEv(i15);
  i2 = HEAP32[i7 >> 2] | 0;
  if (!i2) i2 = 0; else {
   i2 = i2 + -4 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   i2 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i15 >> 2] = i2;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  __ZN2cv6String10deallocateEv(i7);
 }
 i2 = HEAP32[i16 >> 2] | 0;
 if ((i2 | 0) == 6232) i1 = 0; else i1 = (HEAP8[((i2 | 0) == 0 ? 6232 : i2) >> 0] | 0) != 0;
 if (!(i1 | i13)) {
  __ZN2cv6String10deallocateEv(i16);
  __ZN2cv6String10deallocateEv(i15);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i14, i16);
  __ZN2cv6String10deallocateEv(i16);
  __ZN2cv6String10deallocateEv(i15);
  STACKTOP = i17;
  return;
 }
 if (i1) {
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = HEAP32[i10 >> 2];
  if (i2) {
   i1 = i2 + -4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = HEAP32[i12 >> 2] | 0;
  }
 } else i1 = 0;
 HEAP32[i12 >> 2] = i1 + 8;
 __ZN2cv6String10deallocateEv(i16);
 __ZN2cv6String10deallocateEv(i15);
 STACKTOP = i17;
 return;
}

function __ZNSt3__118__insertion_sort_3IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEvT0_S9_T_(i16, i17, i15) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i18 = i19;
 i2 = i16 + 64 | 0;
 __ZNSt3__17__sort3IRPFbRKN2cv23CommandLineParserParamsES4_EPS2_EEjT0_S9_S9_T_(i16, i16 + 32 | 0, i2, i15) | 0;
 i1 = i16 + 96 | 0;
 if ((i1 | 0) == (i17 | 0)) {
  STACKTOP = i19;
  return;
 }
 i9 = i18 + 4 | 0;
 i10 = i18 + 8 | 0;
 i11 = i18 + 12 | 0;
 i12 = i18 + 16 | 0;
 i13 = i18 + 28 | 0;
 i14 = i18 + 16 | 0;
 i7 = i18 + 20 | 0;
 i8 = i18 + 8 | 0;
 while (1) {
  if (FUNCTION_TABLE_iii[HEAP32[i15 >> 2] & 127](i1, i2) | 0) {
   i3 = HEAP32[i1 >> 2] | 0;
   HEAP32[i18 >> 2] = i3;
   HEAP32[i9 >> 2] = HEAP32[i1 + 4 >> 2];
   if (i3) {
    i6 = i3 + -4 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   }
   i3 = HEAP32[i1 + 8 >> 2] | 0;
   HEAP32[i10 >> 2] = i3;
   HEAP32[i11 >> 2] = HEAP32[i1 + 12 >> 2];
   if (i3) {
    i6 = i3 + -4 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   }
   __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i12, i1 + 16 | 0);
   HEAP32[i13 >> 2] = HEAP32[i1 + 28 >> 2];
   i6 = i1;
   while (1) {
    __ZN2cv6String10deallocateEv(i6);
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) i3 = 0; else {
     i3 = i3 + -4 | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i2 >> 2] | 0;
    }
    HEAP32[i6 >> 2] = i3;
    HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    i5 = i6 + 8 | 0;
    __ZN2cv6String10deallocateEv(i5);
    i3 = i2 + 8 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) i3 = 0; else {
     i4 = i4 + -4 | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     i3 = HEAP32[i3 >> 2] | 0;
    }
    HEAP32[i5 >> 2] = i3;
    HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i6 + 16 | 0, HEAP32[i2 + 16 >> 2] | 0, HEAP32[i2 + 20 >> 2] | 0);
    i5 = i2 + 28 | 0;
    HEAP32[i6 + 28 >> 2] = HEAP32[i5 >> 2];
    if ((i2 | 0) == (i16 | 0)) {
     i2 = i16;
     break;
    }
    i3 = i2 + -32 | 0;
    if (FUNCTION_TABLE_iii[HEAP32[i15 >> 2] & 127](i18, i3) | 0) {
     i6 = i2;
     i2 = i3;
    } else break;
   }
   if ((i18 | 0) != (i2 | 0)) {
    __ZN2cv6String10deallocateEv(i2);
    i3 = HEAP32[i18 >> 2] | 0;
    if (!i3) i3 = 0; else {
     i3 = i3 + -4 | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i18 >> 2] | 0;
    }
    HEAP32[i2 >> 2] = i3;
    HEAP32[i2 + 4 >> 2] = HEAP32[i9 >> 2];
    i4 = i2 + 8 | 0;
    __ZN2cv6String10deallocateEv(i4);
    i3 = HEAP32[i8 >> 2] | 0;
    if (!i3) i3 = 0; else {
     i3 = i3 + -4 | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i8 >> 2] | 0;
    }
    HEAP32[i4 >> 2] = i3;
    HEAP32[i2 + 12 >> 2] = HEAP32[i11 >> 2];
    __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i2 + 16 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i7 >> 2] | 0);
   }
   HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
   i3 = HEAP32[i14 >> 2] | 0;
   if (i3) {
    while (1) {
     i2 = HEAP32[i7 >> 2] | 0;
     if ((i2 | 0) == (i3 | 0)) break;
     i6 = i2 + -8 | 0;
     HEAP32[i7 >> 2] = i6;
     __ZN2cv6String10deallocateEv(i6);
    }
    __ZdlPv(HEAP32[i14 >> 2] | 0);
   }
   __ZN2cv6String10deallocateEv(i10);
   __ZN2cv6String10deallocateEv(i18);
  }
  i2 = i1 + 32 | 0;
  if ((i2 | 0) == (i17 | 0)) break; else {
   i6 = i1;
   i1 = i2;
   i2 = i6;
  }
 }
 STACKTOP = i19;
 return;
}

function __ZNK2cv10MatOp_GEMM8subtractERKNS_7MatExprES3_RS1_(i5, i9, i10, i11) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, d7 = 0.0, d8 = 0.0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 i12 = i13 + 32 | 0;
 i6 = i13;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i1 | 0) == 33104;
 i4 = HEAP32[i10 >> 2] | 0;
 i2 = (i4 | 0) == 33104;
 if (i3) d8 = 1.0; else d8 = +HEAPF64[i9 + 176 >> 3];
 if (i2) d7 = 1.0; else d7 = +HEAPF64[i10 + 176 >> 3];
 L7 : do if ((i1 | 0) == 33136) {
  if ((HEAP32[i9 + 136 >> 2] | 0) != 0 ? !(+HEAPF64[i9 + 184 >> 3] == 0.0) : 0) break;
  L12 : do if (!i2) {
   do if ((i4 | 0) == 33112) {
    if ((HEAP32[i10 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i10 + 184 >> 3] == 0.0) : 0) break;
    if (((+HEAPF64[i10 + 192 >> 3] == 0.0 ? +HEAPF64[i10 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i10 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i10 + 216 >> 3] == 0.0 : 0) {
     i3 = 33112;
     break L12;
    }
   } while (0);
   if ((i4 | 0) == 33152) i3 = 33152; else break L7;
  } else i3 = 33104; while (0);
  i3 = ((i3 | 0) == 33152 ? 4 : 0) | HEAP32[i9 + 4 >> 2] & -5;
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = 0;
  HEAP32[i6 + 24 >> 2] = 0;
  HEAP32[i6 + 28 >> 2] = 0;
  HEAPF64[i6 >> 3] = 0.0;
  __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i12, 33136, i3, i9 + 8 | 0, i9 + 64 | 0, i10 + 8 | 0, d8, -d7, i6);
  i3 = i12;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = i11;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  __ZN2cv3MataSERKS0_(i11 + 8 | 0, i12 + 8 | 0) | 0;
  __ZN2cv3MataSERKS0_(i11 + 64 | 0, i12 + 64 | 0) | 0;
  __ZN2cv3MataSERKS0_(i11 + 120 | 0, i12 + 120 | 0) | 0;
  i1 = i11 + 176 | 0;
  i2 = i12 + 176 | 0;
  i3 = i1 + 48 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  __ZN2cv7MatExprD2Ev(i12);
  STACKTOP = i13;
  return;
 } while (0);
 L26 : do if ((i4 | 0) == 33136) {
  if ((HEAP32[i10 + 136 >> 2] | 0) != 0 ? !(+HEAPF64[i10 + 184 >> 3] == 0.0) : 0) break;
  L31 : do if (!i3) {
   do if ((i1 | 0) == 33112) {
    if ((HEAP32[i9 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i9 + 184 >> 3] == 0.0) : 0) break;
    if (((+HEAPF64[i9 + 192 >> 3] == 0.0 ? +HEAPF64[i9 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i9 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i9 + 216 >> 3] == 0.0 : 0) {
     i3 = 33112;
     break L31;
    }
   } while (0);
   if ((i1 | 0) == 33152) i3 = 33152; else break L26;
  } else i3 = 33104; while (0);
  i3 = ((i3 | 0) == 33152 ? 4 : 0) | HEAP32[i10 + 4 >> 2] & -5;
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = 0;
  HEAP32[i6 + 24 >> 2] = 0;
  HEAP32[i6 + 28 >> 2] = 0;
  HEAPF64[i6 >> 3] = 0.0;
  __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i12, 33136, i3, i10 + 8 | 0, i10 + 64 | 0, i9 + 8 | 0, -d7, d8, i6);
  i3 = i12;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = i11;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  __ZN2cv3MataSERKS0_(i11 + 8 | 0, i12 + 8 | 0) | 0;
  __ZN2cv3MataSERKS0_(i11 + 64 | 0, i12 + 64 | 0) | 0;
  __ZN2cv3MataSERKS0_(i11 + 120 | 0, i12 + 120 | 0) | 0;
  i1 = i11 + 176 | 0;
  i2 = i12 + 176 | 0;
  i3 = i1 + 48 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  __ZN2cv7MatExprD2Ev(i12);
  STACKTOP = i13;
  return;
 } while (0);
 if ((i5 | 0) == (i4 | 0)) {
  __ZNK2cv5MatOp8subtractERKNS_7MatExprES3_RS1_(i4, i9, i10, i11);
  STACKTOP = i13;
  return;
 } else {
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 60 >> 2] & 63](i4, i9, i10, i11);
  STACKTOP = i13;
  return;
 }
}

function __ZN2cvL5div8uEPKhjS1_jPhjNS_5Size_IiEEPv(i5, i27, i4, i28, i6, i26, i2, i3) {
 i5 = i5 | 0;
 i27 = i27 | 0;
 i4 = i4 | 0;
 i28 = i28 | 0;
 i6 = i6 | 0;
 i26 = i26 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, d7 = 0.0, d8 = 0.0, d9 = 0.0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, d16 = 0.0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0, d30 = 0.0, d31 = 0.0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i29;
 if (!i5) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN2cvL6recip_IhEEvPKT_jS3_jPS1_jNS_5Size_IiEEd(i4, i28, i6, i26, i1, +HEAPF64[i3 >> 3]);
  STACKTOP = i29;
  return;
 }
 i21 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 d16 = +HEAPF64[i3 >> 3];
 if (!i2) {
  STACKTOP = i29;
  return;
 }
 i17 = i21 + -4 | 0;
 i18 = (i17 | 0) < 0;
 i19 = i21 & -4;
 i15 = i2;
 while (1) {
  i15 = i15 + -1 | 0;
  if (i18) i3 = 0; else {
   i14 = 0;
   do {
    i1 = HEAP8[i4 + i14 >> 0] | 0;
    i13 = i14 | 1;
    i2 = HEAP8[i4 + i13 >> 0] | 0;
    do if (!(i1 << 24 >> 24)) {
     i12 = 0;
     i20 = 21;
    } else {
     i3 = i2 & 255;
     if ((i2 << 24 >> 24 != 0 ? (i22 = i14 | 2, i23 = HEAP8[i4 + i22 >> 0] | 0, i23 << 24 >> 24 != 0) : 0) ? (i24 = i14 | 3, i25 = HEAP8[i4 + i24 >> 0] | 0, i25 << 24 >> 24 != 0) : 0) {
      d30 = +(i3 | 0);
      d31 = +(i1 & 255) * d30;
      d8 = +(i25 & 255 | 0);
      d7 = +(i23 & 255) * d8;
      d9 = d16 / (d31 * d7);
      d7 = d7 * d9;
      d9 = d31 * d9;
      i3 = _lrint(d30 * (d7 * +(HEAPU8[i5 + i14 >> 0] | 0))) | 0;
      if (i3 >>> 0 < 256) i10 = i3; else i10 = (i3 | 0) > 0 ? 255 : 0;
      i3 = _lrint(+(i1 & 255 | 0) * (d7 * +(HEAPU8[i5 + i13 >> 0] | 0))) | 0;
      if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
      i2 = _lrint(d8 * (d9 * +(HEAPU8[i5 + i22 >> 0] | 0))) | 0;
      if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
      i1 = _lrint(+(i23 & 255 | 0) * (d9 * +(HEAPU8[i5 + i24 >> 0] | 0))) | 0;
      if (i1 >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 255 : 0;
      HEAP8[i6 + i14 >> 0] = i10;
      HEAP8[i6 + i13 >> 0] = i3;
      HEAP8[i6 + i22 >> 0] = i2;
      HEAP8[i6 + i24 >> 0] = i1;
      break;
     }
     i3 = _lrint(d16 * +(HEAPU8[i5 + i14 >> 0] | 0 | 0) / +(i1 & 255 | 0)) | 0;
     if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
     i12 = i3 & 255;
     i20 = 21;
    } while (0);
    if ((i20 | 0) == 21) {
     i20 = 0;
     if (!(i2 << 24 >> 24)) i11 = 0; else {
      i3 = _lrint(d16 * +(HEAPU8[i5 + i13 >> 0] | 0 | 0) / +(i2 & 255 | 0)) | 0;
      if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
      i11 = i3 & 255;
     }
     i10 = i14 | 2;
     i3 = HEAP8[i4 + i10 >> 0] | 0;
     if (!(i3 << 24 >> 24)) i1 = 0; else {
      i3 = _lrint(d16 * +(HEAPU8[i5 + i10 >> 0] | 0 | 0) / +(i3 & 255 | 0)) | 0;
      if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
      i1 = i3 & 255;
     }
     i2 = i14 | 3;
     i3 = HEAP8[i4 + i2 >> 0] | 0;
     if (!(i3 << 24 >> 24)) i3 = 0; else {
      i3 = _lrint(d16 * +(HEAPU8[i5 + i2 >> 0] | 0 | 0) / +(i3 & 255 | 0)) | 0;
      if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
      i3 = i3 & 255;
     }
     HEAP8[i6 + i14 >> 0] = i12;
     HEAP8[i6 + i13 >> 0] = i11;
     HEAP8[i6 + i10 >> 0] = i1;
     HEAP8[i6 + i2 >> 0] = i3;
    }
    i14 = i14 + 4 | 0;
   } while ((i14 | 0) <= (i17 | 0));
   i3 = i19;
  }
  if ((i3 | 0) < (i21 | 0)) do {
   i2 = HEAP8[i4 + i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) i2 = 0; else {
    i2 = _lrint(d16 * +(HEAPU8[i5 + i3 >> 0] | 0 | 0) / +(i2 & 255 | 0)) | 0;
    if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
    i2 = i2 & 255;
   }
   HEAP8[i6 + i3 >> 0] = i2;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i21 | 0));
  if (!i15) break; else {
   i4 = i4 + i28 | 0;
   i5 = i5 + i27 | 0;
   i6 = i6 + i26 | 0;
  }
 }
 STACKTOP = i29;
 return;
}

function __ZNK2cv10MatOp_GEMM3addERKNS_7MatExprES3_RS1_(i5, i9, i10, i11) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, d7 = 0.0, d8 = 0.0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 i12 = i13 + 32 | 0;
 i6 = i13;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i1 | 0) == 33104;
 i4 = HEAP32[i10 >> 2] | 0;
 i2 = (i4 | 0) == 33104;
 if (i3) d7 = 1.0; else d7 = +HEAPF64[i9 + 176 >> 3];
 if (i2) d8 = 1.0; else d8 = +HEAPF64[i10 + 176 >> 3];
 L7 : do if ((i1 | 0) == 33136) {
  if ((HEAP32[i9 + 136 >> 2] | 0) != 0 ? !(+HEAPF64[i9 + 184 >> 3] == 0.0) : 0) break;
  L12 : do if (!i2) {
   do if ((i4 | 0) == 33112) {
    if ((HEAP32[i10 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i10 + 184 >> 3] == 0.0) : 0) break;
    if (((+HEAPF64[i10 + 192 >> 3] == 0.0 ? +HEAPF64[i10 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i10 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i10 + 216 >> 3] == 0.0 : 0) {
     i3 = 33112;
     break L12;
    }
   } while (0);
   if ((i4 | 0) == 33152) i3 = 33152; else break L7;
  } else i3 = 33104; while (0);
  i3 = ((i3 | 0) == 33152 ? 4 : 0) | HEAP32[i9 + 4 >> 2] & -5;
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = 0;
  HEAP32[i6 + 24 >> 2] = 0;
  HEAP32[i6 + 28 >> 2] = 0;
  HEAPF64[i6 >> 3] = 0.0;
  __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i12, 33136, i3, i9 + 8 | 0, i9 + 64 | 0, i10 + 8 | 0, d7, d8, i6);
  i3 = i12;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = i11;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  __ZN2cv3MataSERKS0_(i11 + 8 | 0, i12 + 8 | 0) | 0;
  __ZN2cv3MataSERKS0_(i11 + 64 | 0, i12 + 64 | 0) | 0;
  __ZN2cv3MataSERKS0_(i11 + 120 | 0, i12 + 120 | 0) | 0;
  i1 = i11 + 176 | 0;
  i2 = i12 + 176 | 0;
  i3 = i1 + 48 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  __ZN2cv7MatExprD2Ev(i12);
  STACKTOP = i13;
  return;
 } while (0);
 L26 : do if ((i4 | 0) == 33136) {
  if ((HEAP32[i10 + 136 >> 2] | 0) != 0 ? !(+HEAPF64[i10 + 184 >> 3] == 0.0) : 0) break;
  L31 : do if (!i3) {
   do if ((i1 | 0) == 33112) {
    if ((HEAP32[i9 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i9 + 184 >> 3] == 0.0) : 0) break;
    if (((+HEAPF64[i9 + 192 >> 3] == 0.0 ? +HEAPF64[i9 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i9 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i9 + 216 >> 3] == 0.0 : 0) {
     i3 = 33112;
     break L31;
    }
   } while (0);
   if ((i1 | 0) == 33152) i3 = 33152; else break L26;
  } else i3 = 33104; while (0);
  i3 = ((i3 | 0) == 33152 ? 4 : 0) | HEAP32[i10 + 4 >> 2] & -5;
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = 0;
  HEAP32[i6 + 24 >> 2] = 0;
  HEAP32[i6 + 28 >> 2] = 0;
  HEAPF64[i6 >> 3] = 0.0;
  __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i12, 33136, i3, i10 + 8 | 0, i10 + 64 | 0, i9 + 8 | 0, d8, d7, i6);
  i3 = i12;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = i11;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  __ZN2cv3MataSERKS0_(i11 + 8 | 0, i12 + 8 | 0) | 0;
  __ZN2cv3MataSERKS0_(i11 + 64 | 0, i12 + 64 | 0) | 0;
  __ZN2cv3MataSERKS0_(i11 + 120 | 0, i12 + 120 | 0) | 0;
  i1 = i11 + 176 | 0;
  i2 = i12 + 176 | 0;
  i3 = i1 + 48 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  __ZN2cv7MatExprD2Ev(i12);
  STACKTOP = i13;
  return;
 } while (0);
 if ((i5 | 0) == (i4 | 0)) {
  __ZNK2cv5MatOp3addERKNS_7MatExprES3_RS1_(i4, i9, i10, i11);
  STACKTOP = i13;
  return;
 } else {
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] & 63](i4, i9, i10, i11);
  STACKTOP = i13;
  return;
 }
}

function __ZNK12_GLOBAL__N_110CLAHE_Impl4infoEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i4 = i19 + 216 | 0;
 i3 = i19 + 208 | 0;
 i17 = i19;
 i5 = i19 + 200 | 0;
 i6 = i19 + 192 | 0;
 i10 = i19 + 184 | 0;
 i11 = i19 + 176 | 0;
 i12 = i19 + 168 | 0;
 i13 = i19 + 160 | 0;
 i14 = i19 + 152 | 0;
 i15 = i19 + 144 | 0;
 i16 = i19 + 136 | 0;
 if (!(HEAP8[183080] | 0)) {
  HEAP8[183080] = 1;
  __ZN2cv9AlgorithmC2Ev(i17);
  HEAP32[i17 >> 2] = 181864;
  i7 = i17 + 8 | 0;
  HEAPF64[i7 >> 3] = 40.0;
  i8 = i17 + 16 | 0;
  HEAP32[i8 >> 2] = 8;
  i9 = i17 + 20 | 0;
  HEAP32[i9 >> 2] = 8;
  HEAP32[i17 + 24 >> 2] = 1124007936;
  i1 = i17 + 32 | 0;
  i2 = i17 + 64 | 0;
  i18 = i17 + 28 | 0;
  i20 = i18 + 36 | 0;
  do {
   HEAP32[i18 >> 2] = 0;
   i18 = i18 + 4 | 0;
  } while ((i18 | 0) < (i20 | 0));
  HEAP32[i2 >> 2] = i1;
  i2 = i17 + 72 | 0;
  HEAP32[i17 + 68 >> 2] = i2;
  HEAP32[i17 + 76 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i17 + 80 >> 2] = 1124007936;
  i2 = i17 + 88 | 0;
  i1 = i17 + 120 | 0;
  i18 = i17 + 84 | 0;
  i20 = i18 + 36 | 0;
  do {
   HEAP32[i18 >> 2] = 0;
   i18 = i18 + 4 | 0;
  } while ((i18 | 0) < (i20 | 0));
  HEAP32[i1 >> 2] = i2;
  i2 = i17 + 128 | 0;
  HEAP32[i17 + 124 >> 2] = i2;
  HEAP32[i17 + 132 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  __ZNK12_GLOBAL__N_110CLAHE_Impl4infoEv(i17) | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i3 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i4 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  __ZN2cv13AlgorithmInfo8addParamERNS_9AlgorithmEPKcRdbMS1_FdvEMS1_FvdERKNS_6StringE(183120, i17, 183088, i7, 0, i3, i4, i5);
  __ZN2cv6String10deallocateEv(i5);
  __ZNK12_GLOBAL__N_110CLAHE_Impl4infoEv(i17) | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i3 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i4 + 0 >> 2] = HEAP32[i13 + 0 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  __ZN2cv13AlgorithmInfo8addParamERNS_9AlgorithmEPKcRibMS1_FivEMS1_FviERKNS_6StringE(183120, i17, 183104, i8, 0, i3, i4, i11);
  __ZN2cv6String10deallocateEv(i11);
  __ZNK12_GLOBAL__N_110CLAHE_Impl4infoEv(i17) | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i3 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i4 + 0 >> 2] = HEAP32[i16 + 0 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  __ZN2cv13AlgorithmInfo8addParamERNS_9AlgorithmEPKcRibMS1_FivEMS1_FviERKNS_6StringE(183120, i17, 183112, i9, 0, i3, i4, i14);
  __ZN2cv6String10deallocateEv(i14);
  __ZN12_GLOBAL__N_110CLAHE_ImplD2Ev(i17);
 }
 if (HEAP8[183128] | 0) {
  STACKTOP = i19;
  return 183120;
 }
 if (!(___cxa_guard_acquire(183128) | 0)) {
  STACKTOP = i19;
  return 183120;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i10 = __ZN2cv6String8allocateEj(i4, 5) | 0;
 HEAP8[i10 + 0 >> 0] = HEAP8[183136] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[183137] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[183138] | 0;
 HEAP8[i10 + 3 >> 0] = HEAP8[183139] | 0;
 HEAP8[i10 + 4 >> 0] = HEAP8[183140] | 0;
 __ZN2cv13AlgorithmInfoC2ERKNS_6StringEPFPNS_9AlgorithmEvE(183120, i4, 1);
 __ZN2cv6String10deallocateEv(i4);
 ___cxa_atexit(382, 183120, ___dso_handle | 0) | 0;
 ___cxa_guard_release(183128);
 STACKTOP = i19;
 return 183120;
}

function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE9underflowEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i16 = i17 + 4 | 0;
 i13 = i17;
 i10 = i12 + 64 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  i10 = -1;
  STACKTOP = i17;
  return i10 | 0;
 }
 i1 = i12 + 92 | 0;
 if (!(HEAP32[i1 >> 2] & 8)) {
  HEAP32[i12 + 24 >> 2] = 0;
  HEAP32[i12 + 20 >> 2] = 0;
  HEAP32[i12 + 28 >> 2] = 0;
  if (!(HEAP8[i12 + 98 >> 0] | 0)) {
   i9 = HEAP32[i12 + 56 >> 2] | 0;
   i2 = i9 + (HEAP32[i12 + 60 >> 2] | 0) | 0;
   HEAP32[i12 + 8 >> 2] = i9;
   HEAP32[i12 + 12 >> 2] = i2;
   HEAP32[i12 + 16 >> 2] = i2;
  } else {
   i9 = HEAP32[i12 + 32 >> 2] | 0;
   i2 = i9 + (HEAP32[i12 + 52 >> 2] | 0) | 0;
   HEAP32[i12 + 8 >> 2] = i9;
   HEAP32[i12 + 12 >> 2] = i2;
   HEAP32[i12 + 16 >> 2] = i2;
  }
  HEAP32[i1 >> 2] = 8;
  i4 = 1;
  i15 = i12 + 12 | 0;
 } else {
  i2 = i12 + 12 | 0;
  i4 = 0;
  i15 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 if (!i2) {
  i1 = i16 + 1 | 0;
  HEAP32[i12 + 8 >> 2] = i16;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i12 + 16 >> 2] = i1;
 } else i1 = i2;
 i3 = HEAP32[i12 + 16 >> 2] | 0;
 if (i4) i11 = 0; else {
  i11 = (i3 - (HEAP32[i12 + 8 >> 2] | 0) | 0) / 2 | 0;
  i11 = i11 >>> 0 > 4 ? 4 : i11;
 }
 i14 = i12 + 16 | 0;
 do if ((i1 | 0) == (i3 | 0)) {
  i2 = i12 + 8 | 0;
  _memmove(HEAP32[i2 >> 2] | 0, i1 + (0 - i11) | 0, i11 | 0) | 0;
  if (HEAP8[i12 + 98 >> 0] | 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   i1 = _fread(i1 + i11 | 0, 1, (HEAP32[i14 >> 2] | 0) - i11 - i1 | 0, HEAP32[i10 >> 2] | 0) | 0;
   if (!i1) {
    i1 = -1;
    break;
   }
   i9 = HEAP32[i2 >> 2] | 0;
   i10 = i9 + i11 | 0;
   HEAP32[i15 >> 2] = i10;
   HEAP32[i14 >> 2] = i9 + (i1 + i11);
   i1 = HEAPU8[i10 >> 0] | 0;
   break;
  }
  i7 = i12 + 32 | 0;
  i8 = i12 + 36 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i9 = i12 + 40 | 0;
  _memmove(HEAP32[i7 >> 2] | 0, i4 | 0, (HEAP32[i9 >> 2] | 0) - i4 | 0) | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = i4 + ((HEAP32[i9 >> 2] | 0) - (HEAP32[i8 >> 2] | 0)) | 0;
  HEAP32[i8 >> 2] = i1;
  if ((i4 | 0) == (i12 + 44 | 0)) i3 = 8; else i3 = HEAP32[i12 + 52 >> 2] | 0;
  i4 = i4 + i3 | 0;
  HEAP32[i9 >> 2] = i4;
  i5 = i12 + 60 | 0;
  i3 = (HEAP32[i5 >> 2] | 0) - i11 | 0;
  i4 = i4 - i1 | 0;
  i6 = i12 + 72 | 0;
  i20 = i6;
  i19 = HEAP32[i20 + 4 >> 2] | 0;
  i18 = i12 + 80 | 0;
  HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i18 + 4 >> 2] = i19;
  i3 = _fread(i1 | 0, 1, (i4 >>> 0 < i3 >>> 0 ? i4 : i3) | 0, HEAP32[i10 >> 2] | 0) | 0;
  if (i3) {
   i4 = HEAP32[i12 + 68 >> 2] | 0;
   if (!i4) {
    i10 = ___cxa_allocate_exception(4) | 0;
    __ZNSt8bad_castC2Ev(i10);
    ___cxa_throw(i10 | 0, 969544, 335);
   }
   i3 = (HEAP32[i8 >> 2] | 0) + i3 | 0;
   HEAP32[i9 >> 2] = i3;
   i10 = HEAP32[i2 >> 2] | 0;
   if ((FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] & 15](i4, i6, HEAP32[i7 >> 2] | 0, i3, i8, i10 + i11 | 0, i10 + (HEAP32[i5 >> 2] | 0) | 0, i13) | 0) == 3) {
    i1 = HEAP32[i7 >> 2] | 0;
    i10 = HEAP32[i9 >> 2] | 0;
    HEAP32[i2 >> 2] = i1;
    HEAP32[i15 >> 2] = i1;
    HEAP32[i14 >> 2] = i10;
    i1 = HEAPU8[i1 >> 0] | 0;
    break;
   }
   i1 = HEAP32[i13 >> 2] | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = i3 + i11 | 0;
   if ((i1 | 0) != (i4 | 0)) {
    HEAP32[i2 >> 2] = i3;
    HEAP32[i15 >> 2] = i4;
    HEAP32[i14 >> 2] = i1;
    i1 = HEAPU8[i4 >> 0] | 0;
   } else i1 = -1;
  } else i1 = -1;
 } else {
  i2 = i12 + 8 | 0;
  i1 = HEAPU8[i1 >> 0] | 0;
 } while (0);
 if ((HEAP32[i2 >> 2] | 0) != (i16 | 0)) {
  i10 = i1;
  STACKTOP = i17;
  return i10 | 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 i10 = i1;
 STACKTOP = i17;
 return i10 | 0;
}

function __ZL18icvYMLWriteCommentP13CvFileStoragePKci(i14, i9, i5) {
 i14 = i14 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i15;
 i8 = (i9 | 0) == 0;
 if (i8) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i2, 12) | 0) + 0 | 0;
  i3 = 16768 | 0;
  i4 = i1 + 12 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i2, 16784, 8960, 1694);
  __ZN2cv6String10deallocateEv(i2);
 }
 i7 = _strchr(i9, 10) | 0;
 i13 = i14 + 72 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 if ((!((i5 | 0) == 0 | (i7 | 0) != 0) ? (i10 = _strlen(i9 | 0) | 0, ((HEAP32[i14 + 80 >> 2] | 0) - i3 | 0) >= (i10 | 0)) : 0) ? (i3 | 0) != (HEAP32[i14 + 76 >> 2] | 0) : 0) {
  HEAP8[i3 >> 0] = 32;
  i5 = i3 + 1 | 0;
 } else {
  i5 = i14 + 76 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i6 = i14 + 56 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  if (i3 >>> 0 > (i2 + i4 | 0) >>> 0) {
   HEAP8[i3 >> 0] = 10;
   HEAP8[i3 + 1 >> 0] = 0;
   __ZL7icvPutsP13CvFileStoragePKc(i14, HEAP32[i5 >> 2] | 0);
   i2 = HEAP32[i5 >> 2] | 0;
   HEAP32[i13 >> 2] = i2;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i1 = HEAP32[i14 + 40 >> 2] | 0;
  if ((i1 | 0) == (i4 | 0)) i1 = i4; else {
   if ((i1 | 0) > (i4 | 0)) {
    _memset(i2 + i4 | 0, 32, i1 - i4 | 0) | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   HEAP32[i6 >> 2] = i1;
  }
  i5 = i2 + i1 | 0;
  HEAP32[i13 >> 2] = i5;
 }
 if (i8) {
  STACKTOP = i15;
  return;
 }
 i8 = i14 + 80 | 0;
 i10 = i14 + 76 | 0;
 i11 = i14 + 56 | 0;
 i12 = i14 + 40 | 0;
 i3 = i5;
 while (1) {
  HEAP8[i3 >> 0] = 35;
  i4 = i3 + 2 | 0;
  HEAP8[i3 + 1 >> 0] = 32;
  if (!i7) {
   i6 = _strlen(i9 | 0) | 0;
   i5 = HEAP32[i8 >> 2] | 0;
   if ((i3 + (i6 + 2) | 0) >>> 0 >= i5 >>> 0) {
    i3 = HEAP32[i10 >> 2] | 0;
    i2 = i4 - i3 | 0;
    i4 = ((i5 - i3 | 0) * 3 | 0) / 2 | 0;
    i5 = i2 + i6 | 0;
    i5 = (i5 | 0) < (i4 | 0) ? i4 : i5;
    i4 = _cvAlloc(i5 + 256 | 0) | 0;
    i3 = HEAP32[i10 >> 2] | 0;
    HEAP32[i13 >> 2] = i4 + ((HEAP32[i13 >> 2] | 0) - i3);
    if ((i2 | 0) > 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
    HEAP32[i10 >> 2] = i4;
    HEAP32[i8 >> 2] = i4 + i5;
    i4 = i4 + i2 | 0;
   }
   _memcpy(i4 | 0, i9 | 0, i6 | 0) | 0;
   i2 = i4 + i6 | 0;
   HEAP32[i13 >> 2] = i2;
   i6 = 0;
   i7 = 0;
  } else {
   i2 = i7 - i9 | 0;
   i1 = i2 + 1 | 0;
   i6 = HEAP32[i8 >> 2] | 0;
   if ((i3 + (i2 + 3) | 0) >>> 0 >= i6 >>> 0) {
    i5 = HEAP32[i10 >> 2] | 0;
    i3 = i4 - i5 | 0;
    i6 = ((i6 - i5 | 0) * 3 | 0) / 2 | 0;
    i5 = i3 + i1 | 0;
    i5 = (i5 | 0) < (i6 | 0) ? i6 : i5;
    i6 = _cvAlloc(i5 + 256 | 0) | 0;
    i4 = HEAP32[i10 >> 2] | 0;
    HEAP32[i13 >> 2] = i6 + ((HEAP32[i13 >> 2] | 0) - i4);
    if ((i3 | 0) > 0) _memcpy(i6 | 0, i4 | 0, i3 | 0) | 0;
    HEAP32[i10 >> 2] = i6;
    HEAP32[i8 >> 2] = i6 + i5;
    i4 = i6 + i3 | 0;
   }
   _memcpy(i4 | 0, i9 | 0, i1 | 0) | 0;
   i2 = i4 + i2 | 0;
   HEAP32[i13 >> 2] = i2;
   i7 = i7 + 1 | 0;
   i6 = i7;
   i7 = _strchr(i7, 10) | 0;
  }
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  if (i2 >>> 0 > (i4 + i3 | 0) >>> 0) {
   HEAP8[i2 >> 0] = 10;
   HEAP8[i2 + 1 >> 0] = 0;
   __ZL7icvPutsP13CvFileStoragePKc(i14, HEAP32[i10 >> 2] | 0);
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i13 >> 2] = i4;
   i5 = HEAP32[i11 >> 2] | 0;
  } else i5 = i3;
  i3 = HEAP32[i12 >> 2] | 0;
  if ((i3 | 0) == (i5 | 0)) i3 = i5; else {
   if ((i3 | 0) > (i5 | 0)) {
    _memset(i4 + i5 | 0, 32, i3 - i5 | 0) | 0;
    i4 = HEAP32[i10 >> 2] | 0;
   }
   HEAP32[i11 >> 2] = i3;
  }
  i3 = i4 + i3 | 0;
  HEAP32[i13 >> 2] = i3;
  if (!i6) break; else i9 = i6;
 }
 STACKTOP = i15;
 return;
}

function __ZNK12_GLOBAL__N_112CSVFormatter6formatERKN2cv3MatE(i20, i2, i13) {
 i20 = i20 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i16 = i21 + 80 | 0;
 i17 = i21 + 72 | 0;
 i14 = i21 + 16 | 0;
 i12 = i21 + 88 | 0;
 i18 = i21 + 8 | 0;
 i19 = i21;
 HEAP8[i12 + 0 >> 0] = 0;
 HEAP8[i12 + 1 >> 0] = 0;
 HEAP8[i12 + 2 >> 0] = 0;
 HEAP8[i12 + 3 >> 0] = 0;
 HEAP8[i12 + 4 >> 0] = 0;
 HEAP32[i18 >> 2] = 0;
 i3 = i18 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i5 = i13 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i19 >> 2] = 0;
 i4 = i19 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 if ((i1 | 0) > 1) {
  HEAP8[(__ZN2cv6String8allocateEj(i19, 1) | 0) >> 0] = 10;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if ((i1 | 0) == 1) i11 = 1; else i11 = (HEAP32[i2 + 12 >> 2] | 0) == 0 & 1;
 i7 = (HEAP32[i13 >> 2] & 7 | 0) == 6 ? i2 + 8 | 0 : i2 + 4 | 0;
 i15 = __Znwj(156) | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 HEAP32[i16 >> 2] = i2;
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 >> 2];
 if (i2) {
  i10 = i2 + -4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 i2 = HEAP32[i19 >> 2] | 0;
 HEAP32[i17 >> 2] = i2;
 HEAP32[i17 + 4 >> 2] = HEAP32[i4 >> 2];
 if (i2) {
  i10 = i2 + -4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 i9 = i14 + 4 | 0;
 i2 = i13 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 >> 2] = i3;
 i10 = i14 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i5 = i14 + 16 | 0;
 HEAP32[i5 >> 2] = HEAP32[i13 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[i13 + 28 >> 2];
 HEAP32[i14 + 32 >> 2] = HEAP32[i13 + 32 >> 2];
 i1 = i14 + 36 | 0;
 i4 = HEAP32[i13 + 36 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 i6 = i14 + 40 | 0;
 HEAP32[i6 >> 2] = i10;
 i10 = i14 + 48 | 0;
 i8 = i14 + 44 | 0;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 if (i4) {
  i3 = i4 + 12 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = HEAP32[i2 >> 2] | 0;
 }
 if ((i3 | 0) < 3) {
  i3 = HEAP32[i13 + 44 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 } else {
  HEAP32[i9 >> 2] = 0;
  __ZN2cv3Mat8copySizeERKS0_(i14, i13);
 }
 __ZN12_GLOBAL__N_113FormattedImplC2EN2cv6StringES2_NS1_3MatEPcbbi(i15, i16, i17, i14, i12, i11 << 24 >> 24 != 0, 0, HEAP32[i7 >> 2] | 0);
 i3 = __Znwj(16) | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i3 >> 2] = 7312;
 HEAP32[i3 + 8 >> 2] = i15;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i2 = i2 + 12 | 0, i7 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i7 + -1, (i7 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 if ((HEAP32[i9 >> 2] | 0) > 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i9 >> 2] | 0));
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) != (i10 | 0)) __ZN2cv8fastFreeEPv(i1);
 __ZN2cv6String10deallocateEv(i17);
 __ZN2cv6String10deallocateEv(i16);
 HEAP32[i20 >> 2] = i3;
 HEAP32[i20 + 4 >> 2] = i15;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i10 + -1;
 if ((i10 | 0) != 1) {
  __ZN2cv6String10deallocateEv(i19);
  __ZN2cv6String10deallocateEv(i18);
  STACKTOP = i21;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
 __ZN2cv6String10deallocateEv(i19);
 __ZN2cv6String10deallocateEv(i18);
 STACKTOP = i21;
 return;
}

function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE8overflowEi(i7, i18) {
 i7 = i7 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i19 + 8 | 0;
 i16 = i19 + 4 | 0;
 i15 = i19;
 i17 = i7 + 64 | 0;
 if (!(HEAP32[i17 >> 2] | 0)) {
  i10 = -1;
  STACKTOP = i19;
  return i10 | 0;
 }
 i2 = i7 + 92 | 0;
 if (!(HEAP32[i2 >> 2] & 16)) {
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  i1 = HEAP32[i7 + 52 >> 2] | 0;
  do if (i1 >>> 0 > 8) if (!(HEAP8[i7 + 98 >> 0] | 0)) {
   i1 = HEAP32[i7 + 56 >> 2] | 0;
   i3 = i1 + ((HEAP32[i7 + 60 >> 2] | 0) + -1) | 0;
   HEAP32[i7 + 24 >> 2] = i1;
   HEAP32[i7 + 20 >> 2] = i1;
   HEAP32[i7 + 28 >> 2] = i3;
   break;
  } else {
   i10 = HEAP32[i7 + 32 >> 2] | 0;
   i3 = i10 + (i1 + -1) | 0;
   HEAP32[i7 + 24 >> 2] = i10;
   HEAP32[i7 + 20 >> 2] = i10;
   HEAP32[i7 + 28 >> 2] = i3;
   i1 = i10;
   break;
  } else {
   HEAP32[i7 + 24 >> 2] = 0;
   HEAP32[i7 + 20 >> 2] = 0;
   HEAP32[i7 + 28 >> 2] = 0;
   i3 = 0;
   i1 = 0;
  } while (0);
  HEAP32[i2 >> 2] = 16;
  i13 = i7 + 28 | 0;
  i14 = i7 + 20 | 0;
 } else {
  i1 = i7 + 20 | 0;
  i3 = i7 + 28 | 0;
  i13 = i3;
  i14 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 i12 = (i18 | 0) == -1;
 i4 = i7 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i12) i6 = i1; else {
  if (!i2) {
   HEAP32[i4 >> 2] = i5;
   HEAP32[i14 >> 2] = i5;
   HEAP32[i13 >> 2] = i5 + 1;
   i2 = i5;
  }
  HEAP8[i2 >> 0] = i18;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
  i6 = HEAP32[i14 >> 2] | 0;
 }
 i11 = i7 + 24 | 0;
 if ((i2 | 0) != (i6 | 0)) {
  L23 : do if (!(HEAP8[i7 + 98 >> 0] | 0)) {
   i8 = i7 + 32 | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   HEAP32[i16 >> 2] = i4;
   i9 = i7 + 68 | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   if (!i5) {
    i10 = ___cxa_allocate_exception(4) | 0;
    __ZNSt8bad_castC2Ev(i10);
    ___cxa_throw(i10 | 0, 969544, 335);
   }
   i10 = i7 + 72 | 0;
   i7 = i7 + 52 | 0;
   while (1) {
    i4 = FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] & 15](i5, i10, i6, i2, i15, i4, i4 + (HEAP32[i7 >> 2] | 0) | 0, i16) | 0;
    i5 = HEAP32[i14 >> 2] | 0;
    if ((HEAP32[i15 >> 2] | 0) == (i5 | 0)) {
     i1 = -1;
     i2 = 30;
     break;
    }
    if ((i4 | 0) == 3) {
     i2 = 22;
     break;
    }
    if (i4 >>> 0 >= 2) {
     i1 = -1;
     i2 = 30;
     break;
    }
    i5 = HEAP32[i8 >> 2] | 0;
    i6 = (HEAP32[i16 >> 2] | 0) - i5 | 0;
    if ((_fwrite(i5 | 0, 1, i6 | 0, HEAP32[i17 >> 2] | 0) | 0) != (i6 | 0)) {
     i1 = -1;
     i2 = 30;
     break;
    }
    if ((i4 | 0) != 1) break L23;
    i6 = HEAP32[i15 >> 2] | 0;
    i2 = HEAP32[i11 >> 2] | 0;
    HEAP32[i14 >> 2] = i6;
    HEAP32[i13 >> 2] = i2;
    i2 = i6 + (i2 - i6) | 0;
    HEAP32[i11 >> 2] = i2;
    i5 = HEAP32[i9 >> 2] | 0;
    if (!i5) {
     i2 = 19;
     break;
    }
    i4 = HEAP32[i8 >> 2] | 0;
   }
   if ((i2 | 0) == 19) {
    i10 = ___cxa_allocate_exception(4) | 0;
    __ZNSt8bad_castC2Ev(i10);
    ___cxa_throw(i10 | 0, 969544, 335);
   } else if ((i2 | 0) == 22) {
    i10 = (HEAP32[i11 >> 2] | 0) - i5 | 0;
    if ((_fwrite(i5 | 0, 1, i10 | 0, HEAP32[i17 >> 2] | 0) | 0) == (i10 | 0)) break; else i1 = -1;
    STACKTOP = i19;
    return i1 | 0;
   } else if ((i2 | 0) == 30) {
    STACKTOP = i19;
    return i1 | 0;
   }
  } else {
   i10 = i2 - i6 | 0;
   if ((_fwrite(i6 | 0, 1, i10 | 0, HEAP32[i17 >> 2] | 0) | 0) != (i10 | 0)) {
    i10 = -1;
    STACKTOP = i19;
    return i10 | 0;
   }
  } while (0);
  HEAP32[i11 >> 2] = i1;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i13 >> 2] = i3;
 }
 i10 = i12 ? 0 : i18;
 STACKTOP = i19;
 return i10 | 0;
}

function __ZN2cvL13transpose_16uEPKhjPhjNS_5Size_IiEE(i16, i17, i14, i15, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i13 + -4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i8 = i12 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i12 & -4;
  i11 = 0;
  do {
   i5 = i14 + (Math_imul(i11, i15) | 0) | 0;
   i4 = i14 + (Math_imul(i11 | 1, i15) | 0) | 0;
   i3 = i14 + (Math_imul(i11 | 2, i15) | 0) | 0;
   i2 = i14 + (Math_imul(i11 | 3, i15) | 0) | 0;
   if (i9) i7 = 0; else {
    i7 = i11 << 1;
    i6 = 0;
    do {
     i25 = (Math_imul(i6, i17) | 0) + i7 | 0;
     i23 = i6 | 1;
     i24 = (Math_imul(i23, i17) | 0) + i7 | 0;
     i21 = i6 | 2;
     i22 = (Math_imul(i21, i17) | 0) + i7 | 0;
     i19 = i6 | 3;
     i20 = (Math_imul(i19, i17) | 0) + i7 | 0;
     HEAP16[i5 + (i6 << 1) >> 1] = HEAP16[i16 + i25 >> 1] | 0;
     HEAP16[i5 + (i23 << 1) >> 1] = HEAP16[i16 + i24 >> 1] | 0;
     HEAP16[i5 + (i21 << 1) >> 1] = HEAP16[i16 + i22 >> 1] | 0;
     HEAP16[i5 + (i19 << 1) >> 1] = HEAP16[i16 + i20 >> 1] | 0;
     HEAP16[i4 + (i6 << 1) >> 1] = HEAP16[i16 + (i25 | 2) >> 1] | 0;
     HEAP16[i4 + (i23 << 1) >> 1] = HEAP16[i16 + (i24 + 2) >> 1] | 0;
     HEAP16[i4 + (i21 << 1) >> 1] = HEAP16[i16 + (i22 + 2) >> 1] | 0;
     HEAP16[i4 + (i19 << 1) >> 1] = HEAP16[i16 + (i20 + 2) >> 1] | 0;
     HEAP16[i3 + (i6 << 1) >> 1] = HEAP16[i16 + (i25 + 4) >> 1] | 0;
     HEAP16[i3 + (i23 << 1) >> 1] = HEAP16[i16 + (i24 + 4) >> 1] | 0;
     HEAP16[i3 + (i21 << 1) >> 1] = HEAP16[i16 + (i22 + 4) >> 1] | 0;
     HEAP16[i3 + (i19 << 1) >> 1] = HEAP16[i16 + (i20 + 4) >> 1] | 0;
     HEAP16[i2 + (i6 << 1) >> 1] = HEAP16[i16 + (i25 + 6) >> 1] | 0;
     HEAP16[i2 + (i23 << 1) >> 1] = HEAP16[i16 + (i24 + 6) >> 1] | 0;
     HEAP16[i2 + (i21 << 1) >> 1] = HEAP16[i16 + (i22 + 6) >> 1] | 0;
     HEAP16[i2 + (i19 << 1) >> 1] = HEAP16[i16 + (i20 + 6) >> 1] | 0;
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i8 | 0));
    i7 = i10;
   }
   if ((i7 | 0) < (i12 | 0)) {
    i6 = i11 << 1;
    do {
     i22 = (Math_imul(i7, i17) | 0) + i6 | 0;
     HEAP16[i5 + (i7 << 1) >> 1] = HEAP16[i16 + i22 >> 1] | 0;
     HEAP16[i4 + (i7 << 1) >> 1] = HEAP16[i16 + (i22 + 2) >> 1] | 0;
     HEAP16[i3 + (i7 << 1) >> 1] = HEAP16[i16 + (i22 + 4) >> 1] | 0;
     HEAP16[i2 + (i7 << 1) >> 1] = HEAP16[i16 + (i22 + 6) >> 1] | 0;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i12 | 0));
   }
   i11 = i11 + 4 | 0;
  } while ((i11 | 0) <= (i1 | 0));
  i1 = i13 & -4;
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i18;
  return;
 }
 i5 = i12 + -4 | 0;
 i6 = (i5 | 0) < 0;
 i7 = i12 & -4;
 do {
  i4 = i14 + (Math_imul(i1, i15) | 0) | 0;
  if (i6) i2 = 0; else {
   i2 = i1 << 1;
   i3 = 0;
   do {
    i11 = i3 | 1;
    i8 = i16 + ((Math_imul(i11, i17) | 0) + i2) | 0;
    i20 = i3 | 2;
    i19 = i16 + ((Math_imul(i20, i17) | 0) + i2) | 0;
    i22 = i3 | 3;
    i21 = i16 + ((Math_imul(i22, i17) | 0) + i2) | 0;
    HEAP16[i4 + (i3 << 1) >> 1] = HEAP16[i16 + ((Math_imul(i3, i17) | 0) + i2) >> 1] | 0;
    HEAP16[i4 + (i11 << 1) >> 1] = HEAP16[i8 >> 1] | 0;
    HEAP16[i4 + (i20 << 1) >> 1] = HEAP16[i19 >> 1] | 0;
    HEAP16[i4 + (i22 << 1) >> 1] = HEAP16[i21 >> 1] | 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i5 | 0));
   i2 = i7;
  }
  if ((i2 | 0) < (i12 | 0)) {
   i3 = i1 << 1;
   do {
    HEAP16[i4 + (i2 << 1) >> 1] = HEAP16[i16 + ((Math_imul(i2, i17) | 0) + i3) >> 1] | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i12 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i18;
 return;
}

function __ZN2cvL9randi_16sEPsiPyPKNS_9DivStructEb(i9, i10, i13, i11, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i14 = 0;
 i12 = STACKTOP;
 i1 = i13;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i10 + -4 | 0;
 if ((i8 | 0) < 0) i3 = 0; else {
  i7 = 0;
  do {
   i6 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i6 = _i64Add(i6 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i4 = tempRet0;
   i1 = ___muldi3(i6 | 0, 0, -130063606, 0) | 0;
   i4 = _i64Add(i1 | 0, tempRet0 | 0, i4 | 0, 0) | 0;
   i1 = tempRet0;
   ___muldi3(i6 | 0, 0, HEAP32[i11 + (i7 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
   i2 = tempRet0;
   i5 = i7 | 1;
   ___muldi3(i4 | 0, 0, HEAP32[i11 + (i5 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
   i3 = tempRet0;
   i2 = i6 - (Math_imul((((i6 - i2 | 0) >>> (HEAP32[i11 + (i7 * 20 | 0) + 8 >> 2] | 0)) + i2 | 0) >>> (HEAP32[i11 + (i7 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i7 * 20 | 0) >> 2] | 0) | 0) | 0;
   i2 = i2 + (HEAP32[i11 + (i7 * 20 | 0) + 16 >> 2] | 0) | 0;
   i3 = i4 - (Math_imul((((i4 - i3 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 8 >> 2] | 0)) + i3 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i5 * 20 | 0) >> 2] | 0) | 0) | 0;
   i3 = i3 + (HEAP32[i11 + (i5 * 20 | 0) + 16 >> 2] | 0) | 0;
   if ((i2 + 32768 | 0) >>> 0 >= 65536) i2 = (i2 | 0) > 0 ? 32767 : -32768;
   HEAP16[i9 + (i7 << 1) >> 1] = i2;
   if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
   HEAP16[i9 + (i5 << 1) >> 1] = i3;
   i14 = ___muldi3(i4 | 0, 0, -130063606, 0) | 0;
   i14 = _i64Add(i14 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i2 = tempRet0;
   i1 = ___muldi3(i14 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i1 | 0, tempRet0 | 0, i2 | 0, 0) | 0;
   i1 = tempRet0;
   i5 = i7 | 2;
   ___muldi3(HEAP32[i11 + (i5 * 20 | 0) + 4 >> 2] | 0, 0, i14 | 0, 0) | 0;
   i4 = tempRet0;
   i6 = i7 | 3;
   ___muldi3(HEAP32[i11 + (i6 * 20 | 0) + 4 >> 2] | 0, 0, i2 | 0, 0) | 0;
   i3 = tempRet0;
   i4 = i14 - (Math_imul((((i14 - i4 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 8 >> 2] | 0)) + i4 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i5 * 20 | 0) >> 2] | 0) | 0) | 0;
   i4 = i4 + (HEAP32[i11 + (i5 * 20 | 0) + 16 >> 2] | 0) | 0;
   i3 = i2 - (Math_imul((((i2 - i3 | 0) >>> (HEAP32[i11 + (i6 * 20 | 0) + 8 >> 2] | 0)) + i3 | 0) >>> (HEAP32[i11 + (i6 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i6 * 20 | 0) >> 2] | 0) | 0) | 0;
   i3 = i3 + (HEAP32[i11 + (i6 * 20 | 0) + 16 >> 2] | 0) | 0;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i9 + (i5 << 1) >> 1] = i4;
   if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
   HEAP16[i9 + (i6 << 1) >> 1] = i3;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) <= (i8 | 0));
  i3 = i10 & -4;
 }
 if ((i3 | 0) < (i10 | 0)) i4 = i3; else {
  i7 = i2;
  i9 = i1;
  i10 = i13;
  i8 = i10;
  HEAP32[i8 >> 2] = i7;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i12;
  return;
 }
 do {
  i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
  i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  ___muldi3(i2 | 0, 0, HEAP32[i11 + (i4 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
  i3 = tempRet0;
  i3 = i2 - (Math_imul((((i2 - i3 | 0) >>> (HEAP32[i11 + (i4 * 20 | 0) + 8 >> 2] | 0)) + i3 | 0) >>> (HEAP32[i11 + (i4 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i4 * 20 | 0) >> 2] | 0) | 0) | 0;
  i3 = i3 + (HEAP32[i11 + (i4 * 20 | 0) + 16 >> 2] | 0) | 0;
  if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
  HEAP16[i9 + (i4 << 1) >> 1] = i3;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i10 | 0));
 i10 = i13;
 i9 = i10;
 HEAP32[i9 >> 2] = i2;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZN2cvL5div8sEPKajS1_jPajNS_5Size_IiEEPv(i4, i29, i3, i30, i5, i28, i1, i2) {
 i4 = i4 | 0;
 i29 = i29 | 0;
 i3 = i3 | 0;
 i30 = i30 | 0;
 i5 = i5 | 0;
 i28 = i28 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d6 = 0.0, d7 = 0.0, i8 = 0, d9 = 0.0, d10 = 0.0, d11 = 0.0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, d18 = 0.0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i31 = 0, d32 = 0.0, d33 = 0.0;
 i31 = STACKTOP;
 i23 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 d18 = +HEAPF64[i2 >> 3];
 if (!i1) {
  STACKTOP = i31;
  return;
 }
 i19 = i23 + -4 | 0;
 i20 = (i19 | 0) < 0;
 i21 = i23 & -4;
 i17 = i1;
 while (1) {
  i17 = i17 + -1 | 0;
  if (i20) i2 = 0; else {
   i16 = 0;
   do {
    i2 = HEAP8[i3 + i16 >> 0] | 0;
    i15 = i16 | 1;
    i1 = HEAP8[i3 + i15 >> 0] | 0;
    do if (!(i2 << 24 >> 24)) {
     i14 = 0;
     i22 = 20;
    } else {
     if ((i1 << 24 >> 24 != 0 ? (i24 = i16 | 2, i25 = HEAP8[i3 + i24 >> 0] | 0, i25 << 24 >> 24 != 0) : 0) ? (i26 = i16 | 3, i27 = HEAP8[i3 + i26 >> 0] | 0, i27 << 24 >> 24 != 0) : 0) {
      d7 = +(i2 << 24 >> 24);
      d32 = +(i1 << 24 >> 24);
      d33 = d7 * d32;
      d10 = +(i25 << 24 >> 24);
      d9 = +(i27 << 24 >> 24);
      d6 = d10 * d9;
      d11 = d18 / (d33 * d6);
      d6 = d6 * d11;
      d11 = d33 * d11;
      i2 = _lrint(d32 * (d6 * +(HEAP8[i4 + i16 >> 0] | 0))) | 0;
      if ((i2 + 128 | 0) >>> 0 < 256) i13 = i2; else i13 = (i2 | 0) > 0 ? 127 : -128;
      i2 = _lrint(d7 * (d6 * +(HEAP8[i4 + i15 >> 0] | 0))) | 0;
      if ((i2 + 128 | 0) >>> 0 < 256) i8 = i2; else i8 = (i2 | 0) > 0 ? 127 : -128;
      i2 = _lrint(d9 * (d11 * +(HEAP8[i4 + i24 >> 0] | 0))) | 0;
      if ((i2 + 128 | 0) >>> 0 < 256) i1 = i2; else i1 = (i2 | 0) > 0 ? 127 : -128;
      i2 = _lrint(d10 * (d11 * +(HEAP8[i4 + i26 >> 0] | 0))) | 0;
      if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
      HEAP8[i5 + i16 >> 0] = i13;
      HEAP8[i5 + i15 >> 0] = i8;
      HEAP8[i5 + i24 >> 0] = i1;
      HEAP8[i5 + i26 >> 0] = i2;
      break;
     }
     i2 = _lrint(d18 * +(HEAP8[i4 + i16 >> 0] | 0) / +(i2 << 24 >> 24)) | 0;
     if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
     i14 = i2 & 255;
     i22 = 20;
    } while (0);
    if ((i22 | 0) == 20) {
     i22 = 0;
     if (!(i1 << 24 >> 24)) i13 = 0; else {
      i2 = _lrint(d18 * +(HEAP8[i4 + i15 >> 0] | 0) / +(i1 << 24 >> 24)) | 0;
      if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
      i13 = i2 & 255;
     }
     i12 = i16 | 2;
     i2 = HEAP8[i3 + i12 >> 0] | 0;
     if (!(i2 << 24 >> 24)) i8 = 0; else {
      i2 = _lrint(d18 * +(HEAP8[i4 + i12 >> 0] | 0) / +(i2 << 24 >> 24)) | 0;
      if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
      i8 = i2 & 255;
     }
     i1 = i16 | 3;
     i2 = HEAP8[i3 + i1 >> 0] | 0;
     if (!(i2 << 24 >> 24)) i2 = 0; else {
      i2 = _lrint(d18 * +(HEAP8[i4 + i1 >> 0] | 0) / +(i2 << 24 >> 24)) | 0;
      if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
      i2 = i2 & 255;
     }
     HEAP8[i5 + i16 >> 0] = i14;
     HEAP8[i5 + i15 >> 0] = i13;
     HEAP8[i5 + i12 >> 0] = i8;
     HEAP8[i5 + i1 >> 0] = i2;
    }
    i16 = i16 + 4 | 0;
   } while ((i16 | 0) <= (i19 | 0));
   i2 = i21;
  }
  if ((i2 | 0) < (i23 | 0)) do {
   i1 = HEAP8[i3 + i2 >> 0] | 0;
   if (!(i1 << 24 >> 24)) i1 = 0; else {
    i1 = _lrint(d18 * +(HEAP8[i4 + i2 >> 0] | 0) / +(i1 << 24 >> 24)) | 0;
    if ((i1 + 128 | 0) >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 127 : -128;
    i1 = i1 & 255;
   }
   HEAP8[i5 + i2 >> 0] = i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i23 | 0));
  if (!i17) break; else {
   i3 = i3 + i30 | 0;
   i4 = i4 + i29 | 0;
   i5 = i5 + i28 | 0;
  }
 }
 STACKTOP = i31;
 return;
}

function __ZN2cvL5mul8sEPKajS1_jPajNS_5Size_IiEEPv(i5, i16, i4, i17, i6, i15, i2, i1) {
 i5 = i5 | 0;
 i16 = i16 | 0;
 i4 = i4 | 0;
 i17 = i17 | 0;
 i6 = i6 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i18 = 0, f19 = f0;
 i18 = STACKTOP;
 i14 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 f13 = Math_fround(+HEAPF64[i1 >> 3]);
 i3 = i2 + -1 | 0;
 i2 = (i2 | 0) == 0;
 if (f13 == Math_fround(1.0)) {
  if (i2) {
   STACKTOP = i18;
   return;
  }
  i10 = i14 + -4 | 0;
  i11 = (i10 | 0) < 0;
  i12 = i14 & -4;
  i9 = i4;
  i8 = i3;
  while (1) {
   if (i11) i2 = 0; else {
    i7 = 0;
    do {
     i2 = Math_imul(HEAP8[i9 + i7 >> 0] | 0, HEAP8[i5 + i7 >> 0] | 0) | 0;
     if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
     i3 = i7 | 1;
     i1 = Math_imul(HEAP8[i9 + i3 >> 0] | 0, HEAP8[i5 + i3 >> 0] | 0) | 0;
     if ((i1 + 128 | 0) >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 127 : -128;
     HEAP8[i6 + i7 >> 0] = i2;
     HEAP8[i6 + i3 >> 0] = i1;
     i4 = i7 | 2;
     i2 = Math_imul(HEAP8[i9 + i4 >> 0] | 0, HEAP8[i5 + i4 >> 0] | 0) | 0;
     if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
     i1 = i7 | 3;
     i3 = Math_imul(HEAP8[i9 + i1 >> 0] | 0, HEAP8[i5 + i1 >> 0] | 0) | 0;
     if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
     HEAP8[i6 + i4 >> 0] = i2;
     HEAP8[i6 + i1 >> 0] = i3;
     i7 = i7 + 4 | 0;
    } while ((i7 | 0) <= (i10 | 0));
    i2 = i12;
   }
   if ((i2 | 0) < (i14 | 0)) do {
    i1 = Math_imul(HEAP8[i9 + i2 >> 0] | 0, HEAP8[i5 + i2 >> 0] | 0) | 0;
    if ((i1 + 128 | 0) >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 127 : -128;
    HEAP8[i6 + i2 >> 0] = i1;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i14 | 0));
   if (!i8) break; else {
    i9 = i9 + i17 | 0;
    i5 = i5 + i16 | 0;
    i6 = i6 + i15 | 0;
    i8 = i8 + -1 | 0;
   }
  }
  STACKTOP = i18;
  return;
 } else {
  if (i2) {
   STACKTOP = i18;
   return;
  }
  i11 = i14 + -4 | 0;
  i10 = (i11 | 0) < 0;
  i12 = i14 & -4;
  i9 = i5;
  i8 = i3;
  while (1) {
   if (i10) i2 = 0; else {
    i7 = 0;
    do {
     f19 = Math_fround(f13 * Math_fround(HEAP8[i9 + i7 >> 0] | 0));
     i2 = _lrint(+Math_fround(f19 * Math_fround(HEAP8[i4 + i7 >> 0] | 0))) | 0;
     if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
     i3 = i7 | 1;
     f19 = Math_fround(f13 * Math_fround(HEAP8[i9 + i3 >> 0] | 0));
     i1 = _lrint(+Math_fround(f19 * Math_fround(HEAP8[i4 + i3 >> 0] | 0))) | 0;
     if ((i1 + 128 | 0) >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 127 : -128;
     HEAP8[i6 + i7 >> 0] = i2;
     HEAP8[i6 + i3 >> 0] = i1;
     i5 = i7 | 2;
     f19 = Math_fround(f13 * Math_fround(HEAP8[i9 + i5 >> 0] | 0));
     i2 = _lrint(+Math_fround(f19 * Math_fround(HEAP8[i4 + i5 >> 0] | 0))) | 0;
     if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
     i1 = i7 | 3;
     f19 = Math_fround(f13 * Math_fround(HEAP8[i9 + i1 >> 0] | 0));
     i3 = _lrint(+Math_fround(f19 * Math_fround(HEAP8[i4 + i1 >> 0] | 0))) | 0;
     if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
     HEAP8[i6 + i5 >> 0] = i2;
     HEAP8[i6 + i1 >> 0] = i3;
     i7 = i7 + 4 | 0;
    } while ((i7 | 0) <= (i11 | 0));
    i2 = i12;
   }
   if ((i2 | 0) < (i14 | 0)) do {
    f19 = Math_fround(f13 * Math_fround(HEAP8[i9 + i2 >> 0] | 0));
    i1 = _lrint(+Math_fround(f19 * Math_fround(HEAP8[i4 + i2 >> 0] | 0))) | 0;
    if ((i1 + 128 | 0) >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 127 : -128;
    HEAP8[i6 + i2 >> 0] = i1;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i14 | 0));
   if (!i8) break; else {
    i4 = i4 + i17 | 0;
    i9 = i9 + i16 | 0;
    i6 = i6 + i15 | 0;
    i8 = i8 + -1 | 0;
   }
  }
  STACKTOP = i18;
  return;
 }
}

function __ZN7testing8internal12UnitTestImpl23ListTestsMatchingFilterEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i17 = i18;
 i16 = i1 + 64 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i15 = i1 + 60 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i10 = HEAP32[_stdout >> 2] | 0;
  _fflush(i10 | 0) | 0;
  STACKTOP = i18;
  return;
 } else i14 = 0;
 do {
  i3 = HEAP32[i1 + (i14 << 2) >> 2] | 0;
  i13 = i3 + 24 | 0;
  i4 = HEAP32[i13 >> 2] | 0;
  i12 = i3 + 20 | 0;
  i5 = HEAP32[i12 >> 2] | 0;
  if ((i4 | 0) != (i5 | 0)) {
   i9 = i3 + 4 | 0;
   i10 = i9 + 1 | 0;
   i11 = i3 + 16 | 0;
   i8 = i3 + 12 | 0;
   i3 = i5;
   i7 = 0;
   i5 = 0;
   do {
    i6 = HEAP32[i3 + (i7 << 2) >> 2] | 0;
    if (HEAP8[i6 + 38 >> 0] | 0) {
     if (!i5) {
      if (!(HEAP8[i9 >> 0] & 1)) i2 = i10; else i2 = HEAP32[i8 >> 2] | 0;
      HEAP32[i17 >> 2] = i2;
      _printf(164520, i17 | 0) | 0;
      i2 = HEAP32[i11 >> 2] | 0;
      L16 : do if (i2) {
       if ((HEAP8[i2 >> 0] & 1) != 0 ? (HEAP32[i2 + 8 >> 2] | 0) == 0 : 0) break;
       HEAP32[i17 >> 2] = 162512;
       _printf(164528, i17 | 0) | 0;
       i2 = HEAP32[i11 >> 2] | 0;
       if (i2) {
        if (HEAP8[i2 >> 0] & 1) {
         i2 = HEAP32[i2 + 8 >> 2] | 0;
         if (!i2) break;
        } else i2 = i2 + 1 | 0;
        i5 = HEAP8[i2 >> 0] | 0;
        if (i5 << 24 >> 24) {
         i1 = i5;
         i4 = i5 << 24 >> 24;
         i5 = 0;
         while (1) {
          if ((i5 | 0) > 249) break;
          if (i1 << 24 >> 24 == 10) {
           _printf(165840, i17 | 0) | 0;
           i3 = i5 + 2 | 0;
          } else {
           _putchar(i4 | 0) | 0;
           i3 = i5 + 1 | 0;
          }
          i2 = i2 + 1 | 0;
          i5 = HEAP8[i2 >> 0] | 0;
          if (!(i5 << 24 >> 24)) break L16; else {
           i1 = i5;
           i4 = i5 << 24 >> 24;
           i5 = i3;
          }
         }
         _printf(168784, i17 | 0) | 0;
        }
       }
      } while (0);
      _putchar(10) | 0;
     }
     i2 = i6 + 12 | 0;
     if (!(HEAP8[i2 >> 0] & 1)) i2 = i2 + 1 | 0; else i2 = HEAP32[i6 + 20 >> 2] | 0;
     HEAP32[i17 >> 2] = i2;
     _printf(164544, i17 | 0) | 0;
     i2 = i6 + 28 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     L41 : do if (i1) {
      if ((HEAP8[i1 >> 0] & 1) != 0 ? (HEAP32[i1 + 8 >> 2] | 0) == 0 : 0) break;
      HEAP32[i17 >> 2] = 164552;
      _printf(164528, i17 | 0) | 0;
      i2 = HEAP32[i2 >> 2] | 0;
      if (i2) {
       if (HEAP8[i2 >> 0] & 1) {
        i2 = HEAP32[i2 + 8 >> 2] | 0;
        if (!i2) break;
       } else i2 = i2 + 1 | 0;
       i3 = HEAP8[i2 >> 0] | 0;
       if (i3 << 24 >> 24) {
        i1 = i3;
        i5 = i3 << 24 >> 24;
        i4 = 0;
        while (1) {
         if ((i4 | 0) > 249) break;
         if (i1 << 24 >> 24 == 10) {
          _printf(165840, i17 | 0) | 0;
          i3 = i4 + 2 | 0;
         } else {
          _putchar(i5 | 0) | 0;
          i3 = i4 + 1 | 0;
         }
         i2 = i2 + 1 | 0;
         i4 = HEAP8[i2 >> 0] | 0;
         if (!(i4 << 24 >> 24)) break L41; else {
          i1 = i4;
          i5 = i4 << 24 >> 24;
          i4 = i3;
         }
        }
        _printf(168784, i17 | 0) | 0;
       }
      }
     } while (0);
     _putchar(10) | 0;
     i3 = HEAP32[i12 >> 2] | 0;
     i4 = HEAP32[i13 >> 2] | 0;
     i5 = 1;
    }
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < i4 - i3 >> 2 >>> 0);
   i2 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i15 >> 2] | 0;
  }
  i14 = i14 + 1 | 0;
 } while (i14 >>> 0 < i2 - i1 >> 2 >>> 0);
 i10 = HEAP32[_stdout >> 2] | 0;
 _fflush(i10 | 0) | 0;
 STACKTOP = i18;
 return;
}

function _cvSeqSlice(i11, i9, i1, i13) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i12 = i14 + 24 | 0;
 i3 = i14 + 16 | 0;
 i2 = i14 + 8 | 0;
 i10 = i14;
 if (!((i11 | 0) != 0 ? (HEAP32[i11 >> 2] & -65536 | 0) == 1117323264 : 0)) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i6 = (__ZN2cv6String8allocateEj(i3, 23) | 0) + 0 | 0;
  i4 = 40368 | 0;
  i7 = i6 + 23 | 0;
  do {
   HEAP8[i6 >> 0] = HEAP8[i4 >> 0] | 0;
   i6 = i6 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i6 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i3, 40392, 39608, 1609);
  __ZN2cv6String10deallocateEv(i3);
 }
 if (!i1) {
  i1 = HEAP32[i11 + 44 >> 2] | 0;
  if (!i1) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   i6 = (__ZN2cv6String8allocateEj(i2, 20) | 0) + 0 | 0;
   i4 = 39744 | 0;
   i7 = i6 + 20 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i4 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i4 = i4 + 1 | 0;
   } while ((i6 | 0) < (i7 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i2, 40392, 39608, 1615);
   __ZN2cv6String10deallocateEv(i2);
   i1 = 0;
  }
 }
 i8 = HEAP32[i11 + 28 >> 2] | 0;
 i2 = i9;
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i11 + 24 >> 2] | 0;
 i3 = i2 - i5 | 0;
 if ((i2 | 0) != (i5 | 0)) i3 = i3 + ((i5 | 0) < 0 ? 0 - i4 | 0 : 0) + ((i2 | 0) < 1 ? i4 : 0) | 0;
 while (1) if ((i3 | 0) < 0) i3 = i3 + i4 | 0; else break;
 i2 = (i3 | 0) > (i4 | 0) ? i4 : i3;
 if ((i5 | 0) >= 0) {
  if ((i5 | 0) >= (i4 | 0)) {
   i5 = i5 - i4 | 0;
   HEAP32[i9 >> 2] = i5;
  }
 } else {
  i5 = i4 + i5 | 0;
  HEAP32[i9 >> 2] = i5;
 }
 if (!(i2 >>> 0 <= i4 >>> 0 ? !(i5 >>> 0 >= i4 >>> 0 & (i2 | 0) != 0) : 0)) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i6 = (__ZN2cv6String8allocateEj(i10, 18) | 0) + 0 | 0;
  i4 = 40408 | 0;
  i7 = i6 + 18 | 0;
  do {
   HEAP8[i6 >> 0] = HEAP8[i4 >> 0] | 0;
   i6 = i6 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i6 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i10, 40392, 39608, 1626);
  __ZN2cv6String10deallocateEv(i10);
 }
 i9 = _cvCreateSeq(HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0, i8, i1) | 0;
 if ((i2 | 0) <= 0) {
  STACKTOP = i14;
  return i9 | 0;
 }
 _cvStartReadSeq(i11, i12, 0);
 _cvSetSeqReaderPos(i12, i5, 0);
 i11 = i12 + 12 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = ((HEAP32[i12 + 20 >> 2] | 0) - i3 | 0) / (i8 | 0) | 0;
 i7 = i9 + 52 | 0;
 i8 = i9 + 24 | 0;
 i10 = i12 + 8 | 0;
 if (!i13) {
  i5 = 0;
  i6 = 0;
 } else {
  i1 = i4;
  while (1) {
   i1 = (i1 | 0) > (i2 | 0) ? i2 : i1;
   _cvSeqPushMulti(i9, i3, i1, 0);
   i2 = i2 - i1 | 0;
   i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = i1;
   i3 = HEAP32[i1 + 16 >> 2] | 0;
   HEAP32[i11 >> 2] = i3;
   if ((i2 | 0) <= 0) break; else i1 = HEAP32[i1 + 12 >> 2] | 0;
  }
  STACKTOP = i14;
  return i9 | 0;
 }
 while (1) {
  i4 = (i4 | 0) > (i2 | 0) ? i2 : i4;
  i3 = i6;
  i6 = _cvMemStorageAlloc(i1, 20) | 0;
  if (!i5) {
   HEAP32[i6 + 4 >> 2] = i6;
   HEAP32[i6 >> 2] = i6;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i6 + 8 >> 2] = 0;
   i5 = i6;
  } else {
   HEAP32[i6 >> 2] = i3;
   HEAP32[i6 + 4 >> 2] = i5;
   HEAP32[i5 >> 2] = i6;
   HEAP32[i3 + 4 >> 2] = i6;
   HEAP32[i6 + 8 >> 2] = (HEAP32[i3 + 12 >> 2] | 0) + (HEAP32[i3 + 8 >> 2] | 0);
  }
  HEAP32[i6 + 16 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i6 + 12 >> 2] = i4;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i4;
  i2 = i2 - i4 | 0;
  i3 = HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i11 >> 2] = HEAP32[i3 + 16 >> 2];
  if ((i2 | 0) <= 0) break; else i4 = HEAP32[i3 + 12 >> 2] | 0;
 }
 STACKTOP = i14;
 return i9 | 0;
}

function __ZNSt3__127__insertion_sort_incompleteIRNS_6__lessIN2cv6StringES3_EEPS3_EEbT0_S7_T_(i11, i12, i3) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i13;
 switch (i12 - i11 >> 3 | 0) {
 case 2:
  {
   i1 = i12 + -8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i11 >> 2] | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i10 = 1;
    STACKTOP = i13;
    return i10 | 0;
   }
   if ((_strcmp((i2 | 0) == 0 ? 6176 : i2, (i3 | 0) == 0 ? 6176 : i3) | 0) >= 0) {
    i10 = 1;
    STACKTOP = i13;
    return i10 | 0;
   }
   HEAP32[i11 >> 2] = i2;
   HEAP32[i1 >> 2] = i3;
   i8 = i11 + 4 | 0;
   i10 = i12 + -4 | 0;
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i10 >> 2] = i9;
   i10 = 1;
   STACKTOP = i13;
   return i10 | 0;
  }
 case 5:
  {
   __ZNSt3__17__sort5IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i11, i11 + 8 | 0, i11 + 16 | 0, i11 + 24 | 0, i12 + -8 | 0, i3) | 0;
   i10 = 1;
   STACKTOP = i13;
   return i10 | 0;
  }
 case 1:
 case 0:
  {
   i10 = 1;
   STACKTOP = i13;
   return i10 | 0;
  }
 case 3:
  {
   __ZNSt3__17__sort3IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_T_(i11, i11 + 8 | 0, i12 + -8 | 0, i3) | 0;
   i10 = 1;
   STACKTOP = i13;
   return i10 | 0;
  }
 case 4:
  {
   __ZNSt3__17__sort4IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_S7_T_(i11, i11 + 8 | 0, i11 + 16 | 0, i12 + -8 | 0, i3) | 0;
   i10 = 1;
   STACKTOP = i13;
   return i10 | 0;
  }
 default:
  {
   i1 = i11 + 16 | 0;
   __ZNSt3__17__sort3IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_T_(i11, i11 + 8 | 0, i1, i3) | 0;
   i2 = i11 + 24 | 0;
   if ((i2 | 0) == (i12 | 0)) {
    i10 = 1;
    STACKTOP = i13;
    return i10 | 0;
   }
   i7 = i9 + 4 | 0;
   i3 = 0;
   while (1) {
    i4 = HEAP32[i2 >> 2] | 0;
    i5 = HEAP32[i1 >> 2] | 0;
    if ((i4 | 0) != (i5 | 0) ? (i8 = (i4 | 0) == 0, (_strcmp(i8 ? 6176 : i4, (i5 | 0) == 0 ? 6176 : i5) | 0) < 0) : 0) {
     HEAP32[i9 >> 2] = i4;
     HEAP32[i7 >> 2] = HEAP32[i2 + 4 >> 2];
     if (i8) i6 = i2; else {
      i6 = i4 + -4 | 0;
      HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
      i6 = i2;
     }
     while (1) {
      __ZN2cv6String10deallocateEv(i6);
      i4 = HEAP32[i1 >> 2] | 0;
      if (!i4) i4 = 0; else {
       i4 = i4 + -4 | 0;
       HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
       i4 = HEAP32[i1 >> 2] | 0;
      }
      HEAP32[i6 >> 2] = i4;
      HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      if ((i1 | 0) == (i11 | 0)) {
       i4 = i11;
       break;
      }
      i5 = i1 + -8 | 0;
      i4 = HEAP32[i9 >> 2] | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if ((i4 | 0) == (i6 | 0)) {
       i4 = i1;
       break;
      }
      if ((_strcmp((i4 | 0) == 0 ? 6176 : i4, (i6 | 0) == 0 ? 6176 : i6) | 0) < 0) {
       i6 = i1;
       i1 = i5;
      } else {
       i4 = i1;
       break;
      }
     }
     if ((i9 | 0) != (i4 | 0)) {
      __ZN2cv6String10deallocateEv(i4);
      i1 = HEAP32[i9 >> 2] | 0;
      if (!i1) i1 = 0; else {
       i1 = i1 + -4 | 0;
       HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
       i1 = HEAP32[i9 >> 2] | 0;
      }
      HEAP32[i4 >> 2] = i1;
      HEAP32[i4 + 4 >> 2] = HEAP32[i7 >> 2];
     }
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == 8) break;
     __ZN2cv6String10deallocateEv(i9);
    }
    i1 = i2 + 8 | 0;
    if ((i1 | 0) == (i12 | 0)) {
     i1 = 1;
     i10 = 27;
     break;
    } else {
     i6 = i2;
     i2 = i1;
     i1 = i6;
    }
   }
   if ((i10 | 0) == 27) {
    STACKTOP = i13;
    return i1 | 0;
   }
   __ZN2cv6String10deallocateEv(i9);
   i10 = (i2 + 8 | 0) == (i12 | 0);
   STACKTOP = i13;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE(i15, i17, i16, i18, i19, i13, i2) {
 i15 = i15 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i14 = i20;
 i12 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 960720) | 0;
 i4 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 960880) | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] & 127](i14, i4);
 i2 = HEAP8[i14 >> 0] | 0;
 if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i14 + 4 >> 2] | 0;
 if (i2) {
  HEAP32[i13 >> 2] = i18;
  i2 = HEAP8[i15 >> 0] | 0;
  if (i2 << 24 >> 24 == 43 | i2 << 24 >> 24 == 45) {
   i10 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] & 127](i12, i2) | 0;
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP32[i13 >> 2] = i2 + 4;
   HEAP32[i2 >> 2] = i10;
   i2 = i15 + 1 | 0;
  } else i2 = i15;
  if (((i16 - i2 | 0) > 1 ? (HEAP8[i2 >> 0] | 0) == 48 : 0) ? (i1 = i2 + 1 | 0, i10 = HEAP8[i1 >> 0] | 0, i10 << 24 >> 24 == 88 | i10 << 24 >> 24 == 120) : 0) {
   i11 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] & 127](i12, 48) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   HEAP32[i13 >> 2] = i10 + 4;
   HEAP32[i10 >> 2] = i11;
   i10 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] & 127](i12, HEAP8[i1 >> 0] | 0) | 0;
   i11 = HEAP32[i13 >> 2] | 0;
   HEAP32[i13 >> 2] = i11 + 4;
   HEAP32[i11 >> 2] = i10;
   i11 = i2 + 2 | 0;
  } else i11 = i2;
  if ((i11 | 0) != (i16 | 0) ? (i5 = i16 + -1 | 0, i5 >>> 0 > i11 >>> 0) : 0) {
   i1 = i11;
   i2 = i5;
   do {
    i10 = HEAP8[i1 >> 0] | 0;
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP8[i2 >> 0] = i10;
    i1 = i1 + 1 | 0;
    i2 = i2 + -1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  }
  i6 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] & 127](i4) | 0;
  if (i11 >>> 0 < i16 >>> 0) {
   i7 = i14 + 1 | 0;
   i8 = i14 + 4 | 0;
   i9 = i14 + 8 | 0;
   i2 = 0;
   i5 = 0;
   i10 = i11;
   while (1) {
    i4 = (HEAP8[i14 >> 0] & 1) == 0;
    if ((HEAP8[(i4 ? i7 : HEAP32[i9 >> 2] | 0) + i5 >> 0] | 0) != 0 ? (i2 | 0) == (HEAP8[(i4 ? i7 : HEAP32[i9 >> 2] | 0) + i5 >> 0] | 0) : 0) {
     i2 = HEAP32[i13 >> 2] | 0;
     HEAP32[i13 >> 2] = i2 + 4;
     HEAP32[i2 >> 2] = i6;
     i2 = HEAP8[i14 >> 0] | 0;
     if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i8 >> 2] | 0;
     i4 = 0;
     i5 = (i5 >>> 0 < (i2 + -1 | 0) >>> 0 & 1) + i5 | 0;
    } else i4 = i2;
    i21 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] & 127](i12, HEAP8[i10 >> 0] | 0) | 0;
    i2 = HEAP32[i13 >> 2] | 0;
    i1 = i2 + 4 | 0;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i2 >> 2] = i21;
    i10 = i10 + 1 | 0;
    if (i10 >>> 0 >= i16 >>> 0) break; else i2 = i4 + 1 | 0;
   }
  } else i1 = HEAP32[i13 >> 2] | 0;
  i2 = i18 + (i11 - i15 << 2) | 0;
  if ((i2 | 0) != (i1 | 0) ? (i3 = i1 + -4 | 0, i3 >>> 0 > i2 >>> 0) : 0) do {
   i10 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i3 >> 2] = i10;
   i2 = i2 + 4 | 0;
   i3 = i3 + -4 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 } else {
  FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i12 >> 2] | 0) + 48 >> 2] & 7](i12, i15, i16, i18) | 0;
  i1 = i18 + (i16 - i15 << 2) | 0;
  HEAP32[i13 >> 2] = i1;
 }
 if ((i17 | 0) == (i16 | 0)) {
  i10 = i1;
  HEAP32[i19 >> 2] = i10;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
  STACKTOP = i20;
  return;
 }
 i10 = i18 + (i17 - i15 << 2) | 0;
 HEAP32[i19 >> 2] = i10;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
 STACKTOP = i20;
 return;
}

function __ZL17icvWriteSparseMatP13CvFileStoragePKcPKv10CvAttrList(i18, i5, i12, i1) {
 i18 = i18 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i2 = i17;
 i15 = i17 + 92 | 0;
 i10 = i17 + 80 | 0;
 i16 = i17 + 48 | 0;
 i13 = i17 + 40 | 0;
 i14 = i17 + 96 | 0;
 i7 = i17 + 32 | 0;
 i8 = i17 + 24 | 0;
 i3 = i17 + 16 | 0;
 i9 = i17 + 8 | 0;
 i4 = _cvCreateMemStorage(0) | 0;
 HEAP32[i15 >> 2] = i4;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i2 + 0 >> 2] = HEAP32[i7 + 0 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 _cvStartWriteStruct(i18, i5, 6, 10680, i2);
 i7 = _cvGetDims(i12, 0) | 0;
 HEAP32[i13 >> 2] = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 _cvStartWriteStruct(i18, 11656, 13, 0, i2);
 _cvWriteRawData(i18, i12 + 36 | 0, i7, 11664);
 _cvEndWriteStruct(i18);
 i7 = HEAP32[i12 >> 2] | 0;
 i8 = HEAP8[11696 + (i7 & 7) >> 0] | 0;
 HEAP32[i2 >> 2] = (i7 >>> 3 & 511) + 1;
 HEAP32[i2 + 4 >> 2] = i8;
 _sprintf(i14, 11688, i2) | 0;
 if (!(HEAP8[i14 + 2 >> 0] | 0)) i1 = (HEAP8[i14 >> 0] | 0) == 49; else i1 = 0;
 _cvWriteString(i18, 11672, i14 + (i1 & 1) | 0, 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i2 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 _cvStartWriteStruct(i18, 11680, 13, 0, i2);
 i11 = _cvCreateSeq(7, 56, 4, i4) | 0;
 i2 = _cvInitSparseMatIterator(i12, i10) | 0;
 L4 : do if (i2) {
  i6 = i12 + 32 | 0;
  i7 = i10 + 4 | 0;
  i8 = i10 + 8 | 0;
  while (1) {
   HEAP32[i9 >> 2] = i2 + (HEAP32[i6 >> 2] | 0);
   _cvSeqPush(i11, i9) | 0;
   i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0;
   if (i2) {
    HEAP32[i7 >> 2] = i2;
    continue;
   }
   i4 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
   HEAP32[i8 >> 2] = i4;
   i5 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i5 + 24 >> 2] | 0;
   if ((i4 | 0) >= (i1 | 0)) break L4;
   i3 = HEAP32[i5 + 20 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i3 + (i4 << 2) >> 2] | 0;
    i5 = i4 + 1 | 0;
    if (i2) break;
    if ((i5 | 0) < (i1 | 0)) i4 = i5; else break L4;
   }
   HEAP32[i8 >> 2] = i4;
   HEAP32[i7 >> 2] = i2;
  }
 } while (0);
 _cvSeqSort(i11, 33, i13);
 _cvStartReadSeq(i11, i16, 0);
 i7 = i11 + 24 | 0;
 if ((HEAP32[i7 >> 2] | 0) <= 0) {
  _cvEndWriteStruct(i18);
  _cvEndWriteStruct(i18);
  _cvReleaseMemStorage(i15);
  STACKTOP = i17;
  return;
 }
 i8 = i16 + 12 | 0;
 i9 = i16 + 20 | 0;
 i10 = i18 + 236 | 0;
 i11 = i12 + 32 | 0;
 i2 = i12 + 28 | 0;
 i1 = 0;
 i6 = 0;
 do {
  i5 = HEAP32[i8 >> 2] | 0;
  i4 = i6;
  i6 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
  i5 = i5 + 4 | 0;
  HEAP32[i8 >> 2] = i5;
  if (i5 >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) _cvChangeSeqBlock(i16, 1);
  if ((i1 | 0) > 0) {
   i5 = 0;
   while (1) {
    i3 = i5 + 1 | 0;
    if ((HEAP32[i6 + (i5 << 2) >> 2] | 0) == (HEAP32[i4 + (i5 << 2) >> 2] | 0)) i5 = i3; else break;
   }
   i4 = HEAP32[i13 >> 2] | 0;
   if ((i5 | 0) < (i4 + -1 | 0)) FUNCTION_TABLE_viii[HEAP32[i10 >> 2] & 63](i18, 0, i3 - i4 | 0);
  } else i5 = 0;
  if ((i5 | 0) < (HEAP32[i13 >> 2] | 0)) do {
   FUNCTION_TABLE_viii[HEAP32[i10 >> 2] & 63](i18, 0, HEAP32[i6 + (i5 << 2) >> 2] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (HEAP32[i13 >> 2] | 0));
  _cvWriteRawData(i18, i6 + ((HEAP32[i2 >> 2] | 0) - (HEAP32[i11 >> 2] | 0)) | 0, 1, i14);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i7 >> 2] | 0));
 _cvEndWriteStruct(i18);
 _cvEndWriteStruct(i18);
 _cvReleaseMemStorage(i15);
 STACKTOP = i17;
 return;
}

function __Z13FillColorRow1PhS_iP12PaletteEntry(i8, i7, i1, i10) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 i6 = i1 * 3 | 0;
 i9 = i8 + i6 | 0;
 if ((i6 | 0) > 24) {
  i1 = i8 + 48 | 0;
  i1 = (((i9 >>> 0 > i1 >>> 0 ? i9 : i1) + (-25 - i8) | 0) >>> 0) / 24 | 0;
  i5 = i1 + 1 | 0;
  i1 = (i1 * 24 | 0) + 24 | 0;
  i3 = i8;
  i4 = i7;
  i2 = i8 + 24 | 0;
  while (1) {
   i12 = HEAPU8[i4 >> 0] | 0;
   i13 = i10 + (i12 >>> 7 << 2) | 0;
   i13 = HEAPU8[i13 >> 0] | HEAPU8[i13 + 1 >> 0] << 8 | HEAPU8[i13 + 2 >> 0] << 16 | HEAPU8[i13 + 3 >> 0] << 24;
   HEAP8[i3 >> 0] = i13;
   HEAP8[i3 + 1 >> 0] = i13 >> 8;
   HEAP8[i3 + 2 >> 0] = i13 >> 16;
   HEAP8[i3 + 3 >> 0] = i13 >> 24;
   i13 = i3 + 3 | 0;
   i14 = i10 + ((i12 >>> 6 & 1) << 2) | 0;
   i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24;
   HEAP8[i13 >> 0] = i14;
   HEAP8[i13 + 1 >> 0] = i14 >> 8;
   HEAP8[i13 + 2 >> 0] = i14 >> 16;
   HEAP8[i13 + 3 >> 0] = i14 >> 24;
   i13 = i3 + 6 | 0;
   i14 = i10 + ((i12 >>> 5 & 1) << 2) | 0;
   i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24;
   HEAP8[i13 >> 0] = i14;
   HEAP8[i13 + 1 >> 0] = i14 >> 8;
   HEAP8[i13 + 2 >> 0] = i14 >> 16;
   HEAP8[i13 + 3 >> 0] = i14 >> 24;
   i13 = i3 + 9 | 0;
   i14 = i10 + ((i12 >>> 4 & 1) << 2) | 0;
   i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24;
   HEAP8[i13 >> 0] = i14;
   HEAP8[i13 + 1 >> 0] = i14 >> 8;
   HEAP8[i13 + 2 >> 0] = i14 >> 16;
   HEAP8[i13 + 3 >> 0] = i14 >> 24;
   i13 = i3 + 12 | 0;
   i14 = i10 + ((i12 >>> 3 & 1) << 2) | 0;
   i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24;
   HEAP8[i13 >> 0] = i14;
   HEAP8[i13 + 1 >> 0] = i14 >> 8;
   HEAP8[i13 + 2 >> 0] = i14 >> 16;
   HEAP8[i13 + 3 >> 0] = i14 >> 24;
   i13 = i3 + 15 | 0;
   i14 = i10 + ((i12 >>> 2 & 1) << 2) | 0;
   i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24;
   HEAP8[i13 >> 0] = i14;
   HEAP8[i13 + 1 >> 0] = i14 >> 8;
   HEAP8[i13 + 2 >> 0] = i14 >> 16;
   HEAP8[i13 + 3 >> 0] = i14 >> 24;
   i13 = i3 + 18 | 0;
   i14 = i10 + ((i12 >>> 1 & 1) << 2) | 0;
   i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24;
   HEAP8[i13 >> 0] = i14;
   HEAP8[i13 + 1 >> 0] = i14 >> 8;
   HEAP8[i13 + 2 >> 0] = i14 >> 16;
   HEAP8[i13 + 3 >> 0] = i14 >> 24;
   i3 = i3 + 21 | 0;
   i12 = i10 + ((i12 & 1) << 2) | 0;
   i12 = HEAPU8[i12 >> 0] | HEAPU8[i12 + 1 >> 0] << 8 | HEAPU8[i12 + 2 >> 0] << 16 | HEAPU8[i12 + 3 >> 0] << 24;
   HEAP8[i3 >> 0] = i12;
   HEAP8[i3 + 1 >> 0] = i12 >> 8;
   HEAP8[i3 + 2 >> 0] = i12 >> 16;
   HEAP8[i3 + 3 >> 0] = i12 >> 24;
   i3 = i2 + 24 | 0;
   if (i3 >>> 0 < i9 >>> 0) {
    i12 = i2;
    i4 = i4 + 1 | 0;
    i2 = i3;
    i3 = i12;
   } else break;
  }
  i4 = i8 + i1 | 0;
  i1 = i7 + i5 | 0;
 } else {
  i4 = i8;
  i1 = i7;
 }
 if (i4 >>> 0 >= i9 >>> 0) {
  i10 = i4;
  STACKTOP = i11;
  return i10 | 0;
 }
 i3 = i8 + (i6 + -1 - i4) | 0;
 i3 = i3 - ((i3 >>> 0) % 3 | 0) + 3 | 0;
 i2 = i4;
 i1 = (HEAPU8[i1 >> 0] | 0) << 24;
 while (1) {
  i6 = i1 >>> 31;
  i7 = HEAP8[i10 + (i6 << 2) + 1 >> 0] | 0;
  i8 = HEAP8[i10 + (i6 << 2) + 2 >> 0] | 0;
  HEAP8[i2 >> 0] = HEAP8[i10 + (i6 << 2) >> 0] | 0;
  HEAP8[i2 + 1 >> 0] = i7;
  HEAP8[i2 + 2 >> 0] = i8;
  i2 = i2 + 3 | 0;
  if (i2 >>> 0 >= i9 >>> 0) break; else i1 = i1 << 1;
 }
 i10 = i4 + i3 | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN2cvL8recip16sEPKsjS1_jPsjNS_5Size_IiEEPv(i1, i2, i8, i5, i7, i6, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var d9 = 0.0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, d22 = 0.0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, d30 = 0.0, d31 = 0.0;
 i25 = STACKTOP;
 i23 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 d22 = +HEAPF64[i4 >> 3];
 i21 = i5 >>> 1;
 i18 = i6 >>> 1;
 if (!i3) {
  STACKTOP = i25;
  return;
 }
 i19 = i23 + -4 | 0;
 i20 = (i19 | 0) < 0;
 i17 = (i19 | 0) > 3 ? i23 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i20) i4 = 0; else {
   i16 = 0;
   do {
    i6 = HEAP16[i8 + (i16 << 1) >> 1] | 0;
    i15 = i16 | 1;
    i5 = HEAP16[i8 + (i15 << 1) >> 1] | 0;
    do if (!(i6 << 16 >> 16)) {
     i14 = 0;
     i24 = 20;
    } else {
     if ((i5 << 16 >> 16 != 0 ? (i26 = i16 | 2, i27 = HEAP16[i8 + (i26 << 1) >> 1] | 0, i27 << 16 >> 16 != 0) : 0) ? (i28 = i16 | 3, i29 = HEAP16[i8 + (i28 << 1) >> 1] | 0, i29 << 16 >> 16 != 0) : 0) {
      d10 = +(i6 << 16 >> 16);
      d30 = +(i5 << 16 >> 16);
      d31 = d10 * d30;
      d12 = +(i27 << 16 >> 16);
      d11 = +(i29 << 16 >> 16);
      d9 = d12 * d11;
      d13 = d22 / (d31 * d9);
      d9 = d9 * d13;
      d13 = d31 * d13;
      i6 = _lrint(d30 * d9) | 0;
      if ((i6 + 32768 | 0) >>> 0 < 65536) i2 = i6; else i2 = (i6 | 0) > 0 ? 32767 : -32768;
      i6 = _lrint(d10 * d9) | 0;
      if ((i6 + 32768 | 0) >>> 0 < 65536) i4 = i6; else i4 = (i6 | 0) > 0 ? 32767 : -32768;
      i6 = _lrint(d11 * d13) | 0;
      if ((i6 + 32768 | 0) >>> 0 < 65536) i5 = i6; else i5 = (i6 | 0) > 0 ? 32767 : -32768;
      i6 = _lrint(d12 * d13) | 0;
      if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
      HEAP16[i7 + (i16 << 1) >> 1] = i2;
      HEAP16[i7 + (i15 << 1) >> 1] = i4;
      HEAP16[i7 + (i26 << 1) >> 1] = i5;
      HEAP16[i7 + (i28 << 1) >> 1] = i6;
      break;
     }
     i6 = _lrint(d22 / +(i6 << 16 >> 16)) | 0;
     if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
     i14 = i6 & 65535;
     i24 = 20;
    } while (0);
    if ((i24 | 0) == 20) {
     i24 = 0;
     if (!(i5 << 16 >> 16)) i2 = 0; else {
      i6 = _lrint(d22 / +(i5 << 16 >> 16)) | 0;
      if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
      i2 = i6 & 65535;
     }
     i1 = i16 | 2;
     i6 = HEAP16[i8 + (i1 << 1) >> 1] | 0;
     if (!(i6 << 16 >> 16)) i4 = 0; else {
      i6 = _lrint(d22 / +(i6 << 16 >> 16)) | 0;
      if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
      i4 = i6 & 65535;
     }
     i5 = i16 | 3;
     i6 = HEAP16[i8 + (i5 << 1) >> 1] | 0;
     if (!(i6 << 16 >> 16)) i6 = 0; else {
      i6 = _lrint(d22 / +(i6 << 16 >> 16)) | 0;
      if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
      i6 = i6 & 65535;
     }
     HEAP16[i7 + (i16 << 1) >> 1] = i14;
     HEAP16[i7 + (i15 << 1) >> 1] = i2;
     HEAP16[i7 + (i1 << 1) >> 1] = i4;
     HEAP16[i7 + (i5 << 1) >> 1] = i6;
    }
    i16 = i16 + 4 | 0;
   } while ((i16 | 0) <= (i19 | 0));
   i4 = i17;
  }
  if ((i4 | 0) < (i23 | 0)) do {
   i5 = HEAP16[i8 + (i4 << 1) >> 1] | 0;
   if (!(i5 << 16 >> 16)) i5 = 0; else {
    i5 = _lrint(d22 / +(i5 << 16 >> 16)) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i5 = i5 & 65535;
   }
   HEAP16[i7 + (i4 << 1) >> 1] = i5;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i23 | 0));
  if (!i3) break; else {
   i7 = i7 + (i18 << 1) | 0;
   i8 = i8 + (i21 << 1) | 0;
  }
 }
 STACKTOP = i25;
 return;
}

function _adler32(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i10 = STACKTOP;
 i1 = i2 >>> 16;
 i2 = i2 & 65535;
 if ((i3 | 0) == 1) {
  i2 = (HEAPU8[i4 >> 0] | 0) + i2 | 0;
  i2 = i2 >>> 0 > 65520 ? i2 + -65521 | 0 : i2;
  i1 = i2 + i1 | 0;
  i1 = (i1 >>> 0 > 65520 ? i1 + 15 | 0 : i1) << 16 | i2;
  STACKTOP = i10;
  return i1 | 0;
 }
 if (!i4) {
  i1 = 1;
  STACKTOP = i10;
  return i1 | 0;
 }
 if (i3 >>> 0 < 16) {
  if (i3) while (1) {
   i3 = i3 + -1 | 0;
   i2 = (HEAPU8[i4 >> 0] | 0) + i2 | 0;
   i1 = i2 + i1 | 0;
   if (!i3) break; else i4 = i4 + 1 | 0;
  }
  i1 = ((i1 >>> 0) % 65521 | 0) << 16 | (i2 >>> 0 > 65520 ? i2 + -65521 | 0 : i2);
  STACKTOP = i10;
  return i1 | 0;
 }
 if (i3 >>> 0 > 5551) {
  i8 = i3 + -5552 | 0;
  i7 = (i8 >>> 0) % 5552 | 0;
  i8 = i4 + (i8 - i7 + 5552) | 0;
  while (1) {
   i3 = i3 + -5552 | 0;
   i6 = i4;
   i5 = 347;
   while (1) {
    i25 = (HEAPU8[i6 >> 0] | 0) + i2 | 0;
    i24 = i25 + (HEAPU8[i6 + 1 >> 0] | 0) | 0;
    i23 = i24 + (HEAPU8[i6 + 2 >> 0] | 0) | 0;
    i22 = i23 + (HEAPU8[i6 + 3 >> 0] | 0) | 0;
    i21 = i22 + (HEAPU8[i6 + 4 >> 0] | 0) | 0;
    i20 = i21 + (HEAPU8[i6 + 5 >> 0] | 0) | 0;
    i19 = i20 + (HEAPU8[i6 + 6 >> 0] | 0) | 0;
    i18 = i19 + (HEAPU8[i6 + 7 >> 0] | 0) | 0;
    i17 = i18 + (HEAPU8[i6 + 8 >> 0] | 0) | 0;
    i16 = i17 + (HEAPU8[i6 + 9 >> 0] | 0) | 0;
    i15 = i16 + (HEAPU8[i6 + 10 >> 0] | 0) | 0;
    i14 = i15 + (HEAPU8[i6 + 11 >> 0] | 0) | 0;
    i13 = i14 + (HEAPU8[i6 + 12 >> 0] | 0) | 0;
    i12 = i13 + (HEAPU8[i6 + 13 >> 0] | 0) | 0;
    i11 = i12 + (HEAPU8[i6 + 14 >> 0] | 0) | 0;
    i2 = i11 + (HEAPU8[i6 + 15 >> 0] | 0) | 0;
    i1 = i25 + i1 + i24 + i23 + i22 + i21 + i20 + i19 + i18 + i17 + i16 + i15 + i14 + i13 + i12 + i11 + i2 | 0;
    i5 = i5 + -1 | 0;
    if (!i5) break; else i6 = i6 + 16 | 0;
   }
   i2 = (i2 >>> 0) % 65521 | 0;
   i1 = (i1 >>> 0) % 65521 | 0;
   if (i3 >>> 0 <= 5551) break; else i4 = i4 + 5552 | 0;
  }
  if (i7) if (i7 >>> 0 > 15) {
   i3 = i7;
   i4 = i8;
   i9 = 15;
  } else {
   i6 = i8;
   i9 = 18;
  }
 } else i9 = 15;
 if ((i9 | 0) == 15) {
  i5 = i3 + -16 | 0;
  i7 = i5 & -16;
  i6 = i4 + (i7 + 16) | 0;
  while (1) {
   i3 = i3 + -16 | 0;
   i23 = (HEAPU8[i4 >> 0] | 0) + i2 | 0;
   i9 = i23 + (HEAPU8[i4 + 1 >> 0] | 0) | 0;
   i8 = i9 + (HEAPU8[i4 + 2 >> 0] | 0) | 0;
   i11 = i8 + (HEAPU8[i4 + 3 >> 0] | 0) | 0;
   i12 = i11 + (HEAPU8[i4 + 4 >> 0] | 0) | 0;
   i13 = i12 + (HEAPU8[i4 + 5 >> 0] | 0) | 0;
   i14 = i13 + (HEAPU8[i4 + 6 >> 0] | 0) | 0;
   i15 = i14 + (HEAPU8[i4 + 7 >> 0] | 0) | 0;
   i16 = i15 + (HEAPU8[i4 + 8 >> 0] | 0) | 0;
   i17 = i16 + (HEAPU8[i4 + 9 >> 0] | 0) | 0;
   i18 = i17 + (HEAPU8[i4 + 10 >> 0] | 0) | 0;
   i19 = i18 + (HEAPU8[i4 + 11 >> 0] | 0) | 0;
   i20 = i19 + (HEAPU8[i4 + 12 >> 0] | 0) | 0;
   i21 = i20 + (HEAPU8[i4 + 13 >> 0] | 0) | 0;
   i22 = i21 + (HEAPU8[i4 + 14 >> 0] | 0) | 0;
   i2 = i22 + (HEAPU8[i4 + 15 >> 0] | 0) | 0;
   i1 = i23 + i1 + i9 + i8 + i11 + i12 + i13 + i14 + i15 + i16 + i17 + i18 + i19 + i20 + i21 + i22 + i2 | 0;
   if (i3 >>> 0 <= 15) break; else i4 = i4 + 16 | 0;
  }
  if ((i5 | 0) == (i7 | 0)) i9 = 19; else {
   i7 = i5 - i7 | 0;
   i9 = 18;
  }
 }
 if ((i9 | 0) == 18) while (1) {
  i7 = i7 + -1 | 0;
  i2 = (HEAPU8[i6 >> 0] | 0) + i2 | 0;
  i1 = i2 + i1 | 0;
  if (!i7) {
   i9 = 19;
   break;
  } else {
   i6 = i6 + 1 | 0;
   i9 = 18;
  }
 }
 if ((i9 | 0) == 19) {
  i2 = (i2 >>> 0) % 65521 | 0;
  i1 = (i1 >>> 0) % 65521 | 0;
 }
 i22 = i1 << 16 | i2;
 STACKTOP = i10;
 return i22 | 0;
}

function __ZL8icvCloseP13CvFileStoragePN2cv6StringE(i9, i13) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i14 + 8 | 0;
 i12 = i14;
 i10 = (i13 | 0) != 0;
 if (i10) __ZN2cv6String10deallocateEv(i13);
 if (!i9) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i3, 35) | 0) + 0 | 0;
  i1 = 9032;
  i4 = i2 + 35 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i3, 17456, 8960, 519);
  __ZN2cv6String10deallocateEv(i3);
 }
 i8 = i9 + 272 | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i1 = i9 + 64 | 0;
  do if (HEAP32[i9 + 8 >> 2] | 0) {
   if (((HEAP32[i1 >> 2] | 0) == 0 ? (HEAP32[i9 + 68 >> 2] | 0) == 0 : 0) ? (HEAP32[i9 + 268 >> 2] | 0) == 0 : 0) break;
   i3 = i9 + 36 | 0;
   i7 = HEAP32[i3 >> 2] | 0;
   if ((i7 | 0) != 0 ? (HEAP32[i7 + 24 >> 2] | 0) > 0 : 0) do _cvEndWriteStruct(i9); while ((HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0) > 0);
   i5 = i9 + 72 | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i7 = i9 + 76 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i6 = i9 + 56 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i4 >>> 0 > (i3 + i2 | 0) >>> 0) {
    HEAP8[i4 >> 0] = 10;
    HEAP8[i4 + 1 >> 0] = 0;
    __ZL7icvPutsP13CvFileStoragePKc(i9, HEAP32[i7 >> 2] | 0);
    i3 = HEAP32[i7 >> 2] | 0;
    HEAP32[i5 >> 2] = i3;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   i4 = HEAP32[i9 + 40 >> 2] | 0;
   if ((i4 | 0) == (i2 | 0)) i4 = i2; else {
    if ((i4 | 0) > (i2 | 0)) {
     _memset(i3 + i2 | 0, 32, i4 - i2 | 0) | 0;
     i3 = HEAP32[i7 >> 2] | 0;
    }
    HEAP32[i6 >> 2] = i4;
   }
   HEAP32[i5 >> 2] = i3 + i4;
   if ((HEAP32[i9 + 4 >> 2] | 0) == 8) __ZL7icvPutsP13CvFileStoragePKc(i9, 17472);
  } while (0);
  i3 = HEAP32[i1 >> 2] | 0;
  if (!i3) {
   i2 = i9 + 68 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3) _gzclose(i3) | 0;
  } else {
   _fclose(i3 | 0) | 0;
   i2 = i9 + 68 | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i9 + 256 >> 2] = 0;
  HEAP32[i9 + 264 >> 2] = 0;
  HEAP8[i8 >> 0] = 0;
 }
 i1 = HEAP32[i9 + 268 >> 2] | 0;
 if (!((i1 | 0) != 0 & i10)) {
  STACKTOP = i14;
  return;
 }
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 i5 = i3 + (i2 >>> 12 << 2) | 0;
 if ((HEAP32[i1 + 8 >> 2] | 0) != (i3 | 0)) {
  i6 = (HEAP32[i5 >> 2] | 0) + (i2 & 4095) | 0;
  i7 = i2 + (HEAP32[i1 + 20 >> 2] | 0) | 0;
  i4 = i3 + (i7 >>> 12 << 2) | 0;
  i7 = (HEAP32[i4 >> 2] | 0) + (i7 & 4095) | 0;
  HEAP32[i12 >> 2] = 0;
  i2 = i12 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  if ((i7 | 0) == (i6 | 0)) {
   i1 = i12;
   i11 = 30;
  } else {
   i1 = i6;
   i3 = i5;
   i4 = __ZN2cv6String8allocateEj(i12, (i4 - i5 << 10) - i6 + i7 - (HEAP32[i4 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0) | 0;
   while (1) {
    HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
    i1 = i1 + 1 | 0;
    if ((i1 - (HEAP32[i3 >> 2] | 0) | 0) == 4096) {
     i3 = i3 + 4 | 0;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    if ((i1 | 0) == (i7 | 0)) {
     i3 = i12;
     break;
    } else i4 = i4 + 1 | 0;
   }
  }
 } else {
  HEAP32[i12 >> 2] = 0;
  i2 = i12 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  i1 = i12;
  i11 = 30;
 }
 if ((i11 | 0) == 30) {
  __ZN2cv6String8allocateEj(i12, 0) | 0;
  i3 = i1;
 }
 if ((i12 | 0) != (i13 | 0)) {
  __ZN2cv6String10deallocateEv(i13);
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i1 = i1 + -4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = HEAP32[i2 >> 2];
 }
 __ZN2cv6String10deallocateEv(i12);
 STACKTOP = i14;
 return;
}

function _deflateInit2_(i12, i4, i3, i5, i10, i11, i1, i2) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 if (!i1) {
  i10 = -6;
  STACKTOP = i13;
  return i10 | 0;
 }
 if ((HEAP8[i1 >> 0] | 0) != 49 | (i2 | 0) != 56) {
  i10 = -6;
  STACKTOP = i13;
  return i10 | 0;
 }
 if (!i12) {
  i10 = -2;
  STACKTOP = i13;
  return i10 | 0;
 }
 i9 = i12 + 24 | 0;
 HEAP32[i9 >> 2] = 0;
 i8 = i12 + 32 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i2) {
  HEAP32[i8 >> 2] = 32;
  HEAP32[i12 + 40 >> 2] = 0;
  i2 = 32;
 }
 i1 = i12 + 36 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 110;
 i7 = (i4 | 0) == -1 ? 6 : i4;
 if ((i5 | 0) < 0) {
  i1 = 0 - i5 | 0;
  i6 = 0;
 } else {
  i6 = (i5 | 0) > 15;
  i1 = i6 ? i5 + -16 | 0 : i5;
  i6 = i6 ? 2 : 1;
 }
 if ((i10 + -1 | 0) >>> 0 > 8 | (i3 | 0) != 8 | (i1 | 0) < 8 | (i1 | 0) > 15 | (i7 | 0) < 0 | (i7 | 0) > 9 | (i11 | 0) < 0 | (i11 | 0) > 4) {
  i10 = -2;
  STACKTOP = i13;
  return i10 | 0;
 }
 i1 = (i1 | 0) == 8 ? 9 : i1;
 i3 = i12 + 40 | 0;
 i4 = FUNCTION_TABLE_iiii[i2 & 63](HEAP32[i3 >> 2] | 0, 1, 5828) | 0;
 if (!i4) {
  i10 = -4;
  STACKTOP = i13;
  return i10 | 0;
 }
 i5 = i12 + 28 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i4 >> 2] = i12;
 HEAP32[i4 + 24 >> 2] = i6;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = i1;
 i14 = 1 << i1;
 i6 = i4 + 44 | 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i4 + 52 >> 2] = i14 + -1;
 i15 = i10 + 7 | 0;
 HEAP32[i4 + 80 >> 2] = i15;
 i15 = 1 << i15;
 i1 = i4 + 76 | 0;
 HEAP32[i1 >> 2] = i15;
 HEAP32[i4 + 84 >> 2] = i15 + -1;
 HEAP32[i4 + 88 >> 2] = ((i10 + 9 | 0) >>> 0) / 3 | 0;
 i15 = i4 + 56 | 0;
 HEAP32[i15 >> 2] = FUNCTION_TABLE_iiii[HEAP32[i8 >> 2] & 63](HEAP32[i3 >> 2] | 0, i14, 2) | 0;
 i14 = i4 + 64 | 0;
 HEAP32[i14 >> 2] = FUNCTION_TABLE_iiii[HEAP32[i8 >> 2] & 63](HEAP32[i3 >> 2] | 0, HEAP32[i6 >> 2] | 0, 2) | 0;
 i6 = i4 + 68 | 0;
 HEAP32[i6 >> 2] = FUNCTION_TABLE_iiii[HEAP32[i8 >> 2] & 63](HEAP32[i3 >> 2] | 0, HEAP32[i1 >> 2] | 0, 2) | 0;
 HEAP32[i4 + 5824 >> 2] = 0;
 i1 = 1 << i10 + 6;
 i2 = i4 + 5788 | 0;
 HEAP32[i2 >> 2] = i1;
 i1 = FUNCTION_TABLE_iiii[HEAP32[i8 >> 2] & 63](HEAP32[i3 >> 2] | 0, i1, 4) | 0;
 HEAP32[i4 + 8 >> 2] = i1;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 + 12 >> 2] = i2 << 2;
 if (((HEAP32[i15 >> 2] | 0) != 0 ? (HEAP32[i14 >> 2] | 0) != 0 : 0) ? !((HEAP32[i6 >> 2] | 0) == 0 | (i1 | 0) == 0) : 0) {
  HEAP32[i4 + 5796 >> 2] = i1 + (i2 >>> 1 << 1);
  HEAP32[i4 + 5784 >> 2] = i1 + (i2 * 3 | 0);
  HEAP32[i4 + 132 >> 2] = i7;
  HEAP32[i4 + 136 >> 2] = i11;
  HEAP8[i4 + 36 >> 0] = 8;
  i1 = _deflateResetKeep(i12) | 0;
  if (i1) {
   i10 = i1;
   STACKTOP = i13;
   return i10 | 0;
  }
  i10 = HEAP32[i5 >> 2] | 0;
  HEAP32[i10 + 60 >> 2] = HEAP32[i10 + 44 >> 2] << 1;
  i9 = HEAP32[i10 + 76 >> 2] | 0;
  i8 = HEAP32[i10 + 68 >> 2] | 0;
  HEAP16[i8 + (i9 + -1 << 1) >> 1] = 0;
  _memset(i8 | 0, 0, (i9 << 1) + -2 | 0) | 0;
  i9 = HEAP32[i10 + 132 >> 2] | 0;
  HEAP32[i10 + 128 >> 2] = HEAPU16[155018 + (i9 * 12 | 0) >> 1];
  HEAP32[i10 + 140 >> 2] = HEAPU16[155016 + (i9 * 12 | 0) >> 1];
  HEAP32[i10 + 144 >> 2] = HEAPU16[155020 + (i9 * 12 | 0) >> 1];
  HEAP32[i10 + 124 >> 2] = HEAPU16[155022 + (i9 * 12 | 0) >> 1];
  HEAP32[i10 + 108 >> 2] = 0;
  HEAP32[i10 + 92 >> 2] = 0;
  HEAP32[i10 + 116 >> 2] = 0;
  HEAP32[i10 + 5812 >> 2] = 0;
  HEAP32[i10 + 120 >> 2] = 2;
  HEAP32[i10 + 96 >> 2] = 2;
  HEAP32[i10 + 104 >> 2] = 0;
  HEAP32[i10 + 72 >> 2] = 0;
  i10 = 0;
  STACKTOP = i13;
  return i10 | 0;
 }
 HEAP32[i4 + 4 >> 2] = 666;
 HEAP32[i9 >> 2] = HEAP32[36702];
 _deflateEnd(i12) | 0;
 i10 = -4;
 STACKTOP = i13;
 return i10 | 0;
}

function __ZN2cvL8randi_8sEPaiPyPKNS_9DivStructEb(i9, i10, i13, i11, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i14 = 0;
 i12 = STACKTOP;
 i1 = i13;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i10 + -4 | 0;
 if ((i8 | 0) < 0) i3 = 0; else {
  i7 = 0;
  do {
   i6 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i6 = _i64Add(i6 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i4 = tempRet0;
   i1 = ___muldi3(i6 | 0, 0, -130063606, 0) | 0;
   i4 = _i64Add(i1 | 0, tempRet0 | 0, i4 | 0, 0) | 0;
   i1 = tempRet0;
   ___muldi3(i6 | 0, 0, HEAP32[i11 + (i7 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
   i2 = tempRet0;
   i5 = i7 | 1;
   ___muldi3(i4 | 0, 0, HEAP32[i11 + (i5 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
   i3 = tempRet0;
   i2 = i6 - (Math_imul((((i6 - i2 | 0) >>> (HEAP32[i11 + (i7 * 20 | 0) + 8 >> 2] | 0)) + i2 | 0) >>> (HEAP32[i11 + (i7 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i7 * 20 | 0) >> 2] | 0) | 0) | 0;
   i2 = i2 + (HEAP32[i11 + (i7 * 20 | 0) + 16 >> 2] | 0) | 0;
   i3 = i4 - (Math_imul((((i4 - i3 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 8 >> 2] | 0)) + i3 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i5 * 20 | 0) >> 2] | 0) | 0) | 0;
   i3 = i3 + (HEAP32[i11 + (i5 * 20 | 0) + 16 >> 2] | 0) | 0;
   if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
   HEAP8[i9 + i7 >> 0] = i2;
   if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
   HEAP8[i9 + i5 >> 0] = i3;
   i14 = ___muldi3(i4 | 0, 0, -130063606, 0) | 0;
   i14 = _i64Add(i14 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i2 = tempRet0;
   i1 = ___muldi3(i14 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i1 | 0, tempRet0 | 0, i2 | 0, 0) | 0;
   i1 = tempRet0;
   i5 = i7 | 2;
   ___muldi3(HEAP32[i11 + (i5 * 20 | 0) + 4 >> 2] | 0, 0, i14 | 0, 0) | 0;
   i4 = tempRet0;
   i6 = i7 | 3;
   ___muldi3(HEAP32[i11 + (i6 * 20 | 0) + 4 >> 2] | 0, 0, i2 | 0, 0) | 0;
   i3 = tempRet0;
   i4 = i14 - (Math_imul((((i14 - i4 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 8 >> 2] | 0)) + i4 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i5 * 20 | 0) >> 2] | 0) | 0) | 0;
   i4 = i4 + (HEAP32[i11 + (i5 * 20 | 0) + 16 >> 2] | 0) | 0;
   i3 = i2 - (Math_imul((((i2 - i3 | 0) >>> (HEAP32[i11 + (i6 * 20 | 0) + 8 >> 2] | 0)) + i3 | 0) >>> (HEAP32[i11 + (i6 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i6 * 20 | 0) >> 2] | 0) | 0) | 0;
   i3 = i3 + (HEAP32[i11 + (i6 * 20 | 0) + 16 >> 2] | 0) | 0;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i9 + i5 >> 0] = i4;
   if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
   HEAP8[i9 + i6 >> 0] = i3;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) <= (i8 | 0));
  i3 = i10 & -4;
 }
 if ((i3 | 0) < (i10 | 0)) i4 = i3; else {
  i7 = i2;
  i9 = i1;
  i10 = i13;
  i8 = i10;
  HEAP32[i8 >> 2] = i7;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i12;
  return;
 }
 do {
  i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
  i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  ___muldi3(i2 | 0, 0, HEAP32[i11 + (i4 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
  i3 = tempRet0;
  i3 = i2 - (Math_imul((((i2 - i3 | 0) >>> (HEAP32[i11 + (i4 * 20 | 0) + 8 >> 2] | 0)) + i3 | 0) >>> (HEAP32[i11 + (i4 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i4 * 20 | 0) >> 2] | 0) | 0) | 0;
  i3 = i3 + (HEAP32[i11 + (i4 * 20 | 0) + 16 >> 2] | 0) | 0;
  if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
  HEAP8[i9 + i4 >> 0] = i3;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i10 | 0));
 i10 = i13;
 i9 = i10;
 HEAP32[i9 >> 2] = i2;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE(i27, i1, i26, i3, i24, i23, i11) {
 i27 = i27 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 i3 = i3 | 0;
 i24 = i24 | 0;
 i23 = i23 | 0;
 i11 = i11 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 i8 = i21 + 60 | 0;
 i14 = i21 + 56 | 0;
 i17 = i21 + 52 | 0;
 i12 = i21 + 165 | 0;
 i20 = i21 + 164 | 0;
 i13 = i21 + 40 | 0;
 i19 = i21 + 28 | 0;
 i18 = i21 + 16 | 0;
 i4 = i21 + 12 | 0;
 i7 = i21 + 64 | 0;
 i16 = i21 + 8 | 0;
 i15 = i21 + 4 | 0;
 i9 = i21;
 __ZNKSt3__18ios_base6getlocEv(i14, i24);
 i10 = __ZNKSt3__16locale9use_facetERNS0_2idE(i14, 960728) | 0;
 i1 = HEAP8[i11 >> 0] | 0;
 i2 = (i1 & 1) == 0;
 if (i2) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i11 + 4 >> 2] | 0;
 if (!i1) i6 = 0; else {
  if (i2) i1 = i11 + 1 | 0; else i1 = HEAP32[i11 + 8 >> 2] | 0;
  i6 = HEAP8[i1 >> 0] | 0;
  i6 = i6 << 24 >> 24 == (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] & 127](i10, 45) | 0) << 24 >> 24;
 }
 HEAP32[i17 >> 2] = 0;
 HEAP32[i13 + 0 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i19 + 0 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i18 + 0 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 __ZNSt3__111__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri(i3, i6, i14, i17, i12, i20, i13, i19, i18, i4);
 i5 = HEAP8[i11 >> 0] | 0;
 i2 = (i5 & 1) == 0;
 if (i2) i1 = (i5 & 255) >>> 1; else i1 = HEAP32[i11 + 4 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) > (i4 | 0)) {
  if (i2) i3 = (i5 & 255) >>> 1; else i3 = HEAP32[i11 + 4 >> 2] | 0;
  i2 = HEAP8[i18 >> 0] | 0;
  if (!(i2 & 1)) i1 = (i2 & 255) >>> 1; else i1 = HEAP32[i18 + 4 >> 2] | 0;
  i2 = HEAP8[i19 >> 0] | 0;
  if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i19 + 4 >> 2] | 0;
  i1 = i1 + (i3 - i4 << 1 | 1) + i2 | 0;
 } else {
  i1 = HEAP8[i18 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i18 + 4 >> 2] | 0;
  i2 = HEAP8[i19 >> 0] | 0;
  if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i19 + 4 >> 2] | 0;
  i1 = i1 + 2 + i2 | 0;
 }
 i1 = i1 + i4 | 0;
 if (i1 >>> 0 > 100) {
  i1 = _malloc(i1) | 0;
  if (!i1) __ZSt17__throw_bad_allocv(); else {
   i22 = i1;
   i25 = i1;
  }
 } else {
  i22 = 0;
  i25 = i7;
 }
 if (!(i5 & 1)) {
  i2 = i11 + 1 | 0;
  i1 = (i5 & 255) >>> 1;
 } else {
  i2 = HEAP32[i11 + 8 >> 2] | 0;
  i1 = HEAP32[i11 + 4 >> 2] | 0;
 }
 __ZNSt3__111__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i(i25, i16, i15, HEAP32[i24 + 4 >> 2] | 0, i2, i2 + i1 | 0, i10, i6, i17, HEAP8[i12 >> 0] | 0, HEAP8[i20 >> 0] | 0, i13, i19, i18, i4);
 HEAP32[i9 >> 2] = HEAP32[i26 >> 2];
 i17 = HEAP32[i16 >> 2] | 0;
 i20 = HEAP32[i15 >> 2] | 0;
 HEAP32[i8 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i27, i8, i25, i17, i20, i24, i23);
 _free(i22);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i18);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i19);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i13);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i14 >> 2] | 0) | 0;
 STACKTOP = i21;
 return;
}

function __ZN7testing8internal12UnitTestImpl11GetTestCaseEPKcS3_PFvvES5_(i21, i11, i12, i9, i10) {
 i21 = i21 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i13 = i22 + 52 | 0;
 i7 = i22 + 40 | 0;
 i8 = i22 + 28 | 0;
 i20 = i22 + 24 | 0;
 i14 = i22 + 12 | 0;
 i15 = i22 + 8 | 0;
 i16 = i22 + 4 | 0;
 i19 = i22;
 i17 = i21 + 60 | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i18 = i21 + 64 | 0;
 i4 = HEAP32[i18 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i11, _strlen(i11 | 0) | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i7, i8);
 L1 : do if ((i3 | 0) == (i4 | 0)) i4 = i3; else {
  i5 = i7 + 1 | 0;
  i6 = HEAP32[i7 + 8 >> 2] | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   if (i2) {
    i1 = i2 + 4 | 0;
    if (!(HEAP8[i1 >> 0] & 1)) i2 = i1 + 1 | 0; else i2 = HEAP32[i2 + 12 >> 2] | 0;
    if (!(_strcmp(i2, (HEAP8[i7 >> 0] & 1) == 0 ? i5 : i6) | 0)) {
     i4 = i3;
     break L1;
    }
   }
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i4 | 0));
 } while (0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
 if ((i4 | 0) != (HEAP32[i18 >> 2] | 0)) {
  i10 = i4;
  i10 = HEAP32[i10 >> 2] | 0;
  STACKTOP = i22;
  return i10 | 0;
 }
 i3 = __Znwj(104) | 0;
 __ZN7testing8TestCaseC2EPKcS2_PFvvES4_(i3, i11, i12, i9, i10);
 HEAP32[i20 >> 2] = i3;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, i11, _strlen(i11 | 0) | 0);
 i3 = i14 + 1 | 0;
 L16 : do if (!(HEAP8[i14 >> 0] & 1)) {
  i4 = 164024;
  while (1) {
   if (__ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i4, i3) | 0) {
    i4 = 16;
    break L16;
   }
   i4 = _strchr(i4, 58) | 0;
   if (!i4) {
    i4 = 17;
    break;
   } else i4 = i4 + 1 | 0;
  }
 } else {
  i3 = HEAP32[i14 + 8 >> 2] | 0;
  i4 = 164024;
  while (1) {
   if (__ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i4, i3) | 0) {
    i4 = 16;
    break L16;
   }
   i4 = _strchr(i4, 58) | 0;
   if (!i4) {
    i4 = 17;
    break;
   } else i4 = i4 + 1 | 0;
  }
 } while (0);
 do if ((i4 | 0) == 16) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
  i9 = i21 + 100 | 0;
  i10 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i15 >> 2] = (HEAP32[i17 >> 2] | 0) + (i10 << 2);
  HEAP32[i13 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
  __ZNSt3__16vectorIPN7testing8TestCaseENS_9allocatorIS3_EEE6insertENS_11__wrap_iterIPKS3_EERS8_(i16, i17, i13, i20);
 } else if ((i4 | 0) == 17) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i14);
  i1 = HEAP32[i18 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i21 + 68 >> 2] | 0)) {
   __ZNSt3__16vectorIPN7testing8TestCaseENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i17, i20);
   break;
  }
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
   i1 = HEAP32[i18 >> 2] | 0;
  }
  HEAP32[i18 >> 2] = i1 + 4;
 } while (0);
 i1 = i21 + 72 | 0;
 i2 = i21 + 76 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 - (HEAP32[i1 >> 2] | 0) >> 2;
 HEAP32[i19 >> 2] = i4;
 if ((i3 | 0) == (HEAP32[i21 + 80 >> 2] | 0)) {
  __ZNSt3__16vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i1, i19);
  i10 = i20;
  i10 = HEAP32[i10 >> 2] | 0;
  STACKTOP = i22;
  return i10 | 0;
 }
 if (i3) HEAP32[i3 >> 2] = i4;
 HEAP32[i2 >> 2] = i3 + 4;
 i10 = i20;
 i10 = HEAP32[i10 >> 2] | 0;
 STACKTOP = i22;
 return i10 | 0;
}

function __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE(i13, i15, i14, i16, i18, i17, i3) {
 i13 = i13 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i12 = i19;
 i11 = __ZNKSt3__16locale9use_facetERNS0_2idE(i3, 960728) | 0;
 i4 = __ZNKSt3__16locale9use_facetERNS0_2idE(i3, 960872) | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] & 127](i12, i4);
 i3 = HEAP8[i12 >> 0] | 0;
 if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i12 + 4 >> 2] | 0;
 if (i3) {
  HEAP32[i17 >> 2] = i16;
  i3 = HEAP8[i13 >> 0] | 0;
  if (i3 << 24 >> 24 == 43 | i3 << 24 >> 24 == 45) {
   i10 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] & 127](i11, i3) | 0;
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP32[i17 >> 2] = i3 + 1;
   HEAP8[i3 >> 0] = i10;
   i3 = i13 + 1 | 0;
  } else i3 = i13;
  if (((i14 - i3 | 0) > 1 ? (HEAP8[i3 >> 0] | 0) == 48 : 0) ? (i2 = i3 + 1 | 0, i10 = HEAP8[i2 >> 0] | 0, i10 << 24 >> 24 == 88 | i10 << 24 >> 24 == 120) : 0) {
   i10 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] & 127](i11, 48) | 0;
   i9 = HEAP32[i17 >> 2] | 0;
   HEAP32[i17 >> 2] = i9 + 1;
   HEAP8[i9 >> 0] = i10;
   i9 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] & 127](i11, HEAP8[i2 >> 0] | 0) | 0;
   i10 = HEAP32[i17 >> 2] | 0;
   HEAP32[i17 >> 2] = i10 + 1;
   HEAP8[i10 >> 0] = i9;
   i10 = i3 + 2 | 0;
  } else i10 = i3;
  if ((i10 | 0) != (i14 | 0) ? (i5 = i14 + -1 | 0, i5 >>> 0 > i10 >>> 0) : 0) {
   i2 = i10;
   i3 = i5;
   do {
    i9 = HEAP8[i2 >> 0] | 0;
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP8[i3 >> 0] = i9;
    i2 = i2 + 1 | 0;
    i3 = i3 + -1 | 0;
   } while (i2 >>> 0 < i3 >>> 0);
  }
  i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] & 127](i4) | 0;
  if (i10 >>> 0 < i14 >>> 0) {
   i6 = i12 + 1 | 0;
   i7 = i12 + 4 | 0;
   i8 = i12 + 8 | 0;
   i3 = 0;
   i2 = 0;
   i9 = i10;
   while (1) {
    i5 = (HEAP8[i12 >> 0] & 1) == 0;
    if ((HEAP8[(i5 ? i6 : HEAP32[i8 >> 2] | 0) + i2 >> 0] | 0) != 0 ? (i3 | 0) == (HEAP8[(i5 ? i6 : HEAP32[i8 >> 2] | 0) + i2 >> 0] | 0) : 0) {
     i3 = HEAP32[i17 >> 2] | 0;
     HEAP32[i17 >> 2] = i3 + 1;
     HEAP8[i3 >> 0] = i4;
     i3 = HEAP8[i12 >> 0] | 0;
     if (!(i3 & 1)) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i7 >> 2] | 0;
     i5 = 0;
     i2 = (i2 >>> 0 < (i3 + -1 | 0) >>> 0 & 1) + i2 | 0;
    } else i5 = i3;
    i20 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] & 127](i11, HEAP8[i9 >> 0] | 0) | 0;
    i3 = HEAP32[i17 >> 2] | 0;
    HEAP32[i17 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i20;
    i9 = i9 + 1 | 0;
    if (i9 >>> 0 >= i14 >>> 0) break; else i3 = i5 + 1 | 0;
   }
  }
  i2 = i16 + (i10 - i13) | 0;
  i3 = HEAP32[i17 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0) ? (i1 = i3 + -1 | 0, i1 >>> 0 > i2 >>> 0) : 0) do {
   i10 = HEAP8[i2 >> 0] | 0;
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP8[i1 >> 0] = i10;
   i2 = i2 + 1 | 0;
   i1 = i1 + -1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 } else {
  FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i11 >> 2] | 0) + 32 >> 2] & 7](i11, i13, i14, i16) | 0;
  HEAP32[i17 >> 2] = i16 + (i14 - i13);
 }
 if ((i15 | 0) == (i14 | 0)) {
  i10 = HEAP32[i17 >> 2] | 0;
  HEAP32[i18 >> 2] = i10;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
  STACKTOP = i19;
  return;
 } else {
  i10 = i16 + (i15 - i13) | 0;
  HEAP32[i18 >> 2] = i10;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
  STACKTOP = i19;
  return;
 }
}

function __ZN2cvL13transpose_32sEPKhjPhjNS_5Size_IiEE(i16, i17, i14, i15, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i13 + -4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i8 = i12 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i12 & -4;
  i11 = 0;
  do {
   i5 = i14 + (Math_imul(i11, i15) | 0) | 0;
   i4 = i14 + (Math_imul(i11 | 1, i15) | 0) | 0;
   i3 = i14 + (Math_imul(i11 | 2, i15) | 0) | 0;
   i2 = i14 + (Math_imul(i11 | 3, i15) | 0) | 0;
   if (i9) i7 = 0; else {
    i7 = i11 << 2;
    i6 = 0;
    do {
     i25 = (Math_imul(i6, i17) | 0) + i7 | 0;
     i23 = i6 | 1;
     i24 = (Math_imul(i23, i17) | 0) + i7 | 0;
     i21 = i6 | 2;
     i22 = (Math_imul(i21, i17) | 0) + i7 | 0;
     i19 = i6 | 3;
     i20 = (Math_imul(i19, i17) | 0) + i7 | 0;
     HEAP32[i5 + (i6 << 2) >> 2] = HEAP32[i16 + i25 >> 2];
     HEAP32[i5 + (i23 << 2) >> 2] = HEAP32[i16 + i24 >> 2];
     HEAP32[i5 + (i21 << 2) >> 2] = HEAP32[i16 + i22 >> 2];
     HEAP32[i5 + (i19 << 2) >> 2] = HEAP32[i16 + i20 >> 2];
     HEAP32[i4 + (i6 << 2) >> 2] = HEAP32[i16 + (i25 + 4) >> 2];
     HEAP32[i4 + (i23 << 2) >> 2] = HEAP32[i16 + (i24 + 4) >> 2];
     HEAP32[i4 + (i21 << 2) >> 2] = HEAP32[i16 + (i22 + 4) >> 2];
     HEAP32[i4 + (i19 << 2) >> 2] = HEAP32[i16 + (i20 + 4) >> 2];
     HEAP32[i3 + (i6 << 2) >> 2] = HEAP32[i16 + (i25 + 8) >> 2];
     HEAP32[i3 + (i23 << 2) >> 2] = HEAP32[i16 + (i24 + 8) >> 2];
     HEAP32[i3 + (i21 << 2) >> 2] = HEAP32[i16 + (i22 + 8) >> 2];
     HEAP32[i3 + (i19 << 2) >> 2] = HEAP32[i16 + (i20 + 8) >> 2];
     HEAP32[i2 + (i6 << 2) >> 2] = HEAP32[i16 + (i25 + 12) >> 2];
     HEAP32[i2 + (i23 << 2) >> 2] = HEAP32[i16 + (i24 + 12) >> 2];
     HEAP32[i2 + (i21 << 2) >> 2] = HEAP32[i16 + (i22 + 12) >> 2];
     HEAP32[i2 + (i19 << 2) >> 2] = HEAP32[i16 + (i20 + 12) >> 2];
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i8 | 0));
    i7 = i10;
   }
   if ((i7 | 0) < (i12 | 0)) {
    i6 = i11 << 2;
    do {
     i22 = (Math_imul(i7, i17) | 0) + i6 | 0;
     HEAP32[i5 + (i7 << 2) >> 2] = HEAP32[i16 + i22 >> 2];
     HEAP32[i4 + (i7 << 2) >> 2] = HEAP32[i16 + (i22 + 4) >> 2];
     HEAP32[i3 + (i7 << 2) >> 2] = HEAP32[i16 + (i22 + 8) >> 2];
     HEAP32[i2 + (i7 << 2) >> 2] = HEAP32[i16 + (i22 + 12) >> 2];
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i12 | 0));
   }
   i11 = i11 + 4 | 0;
  } while ((i11 | 0) <= (i1 | 0));
  i1 = i13 & -4;
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i18;
  return;
 }
 i5 = i12 + -4 | 0;
 i6 = (i5 | 0) < 0;
 i7 = i12 & -4;
 do {
  i4 = i14 + (Math_imul(i1, i15) | 0) | 0;
  if (i6) i2 = 0; else {
   i2 = i1 << 2;
   i3 = 0;
   do {
    i11 = i3 | 1;
    i8 = i16 + ((Math_imul(i11, i17) | 0) + i2) | 0;
    i20 = i3 | 2;
    i19 = i16 + ((Math_imul(i20, i17) | 0) + i2) | 0;
    i22 = i3 | 3;
    i21 = i16 + ((Math_imul(i22, i17) | 0) + i2) | 0;
    HEAP32[i4 + (i3 << 2) >> 2] = HEAP32[i16 + ((Math_imul(i3, i17) | 0) + i2) >> 2];
    HEAP32[i4 + (i11 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i4 + (i20 << 2) >> 2] = HEAP32[i19 >> 2];
    HEAP32[i4 + (i22 << 2) >> 2] = HEAP32[i21 >> 2];
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i5 | 0));
   i2 = i7;
  }
  if ((i2 | 0) < (i12 | 0)) {
   i3 = i1 << 2;
   do {
    HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[i16 + ((Math_imul(i2, i17) | 0) + i3) >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i12 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i18;
 return;
}

function __ZN2cvL9randi_16uEPtiPyPKNS_9DivStructEb(i9, i10, i13, i11, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i14 = 0;
 i12 = STACKTOP;
 i1 = i13;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i10 + -4 | 0;
 if ((i8 | 0) < 0) i3 = 0; else {
  i7 = 0;
  do {
   i6 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i6 = _i64Add(i6 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i4 = tempRet0;
   i1 = ___muldi3(i6 | 0, 0, -130063606, 0) | 0;
   i4 = _i64Add(i1 | 0, tempRet0 | 0, i4 | 0, 0) | 0;
   i1 = tempRet0;
   ___muldi3(i6 | 0, 0, HEAP32[i11 + (i7 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
   i2 = tempRet0;
   i5 = i7 | 1;
   ___muldi3(i4 | 0, 0, HEAP32[i11 + (i5 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
   i3 = tempRet0;
   i2 = i6 - (Math_imul((((i6 - i2 | 0) >>> (HEAP32[i11 + (i7 * 20 | 0) + 8 >> 2] | 0)) + i2 | 0) >>> (HEAP32[i11 + (i7 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i7 * 20 | 0) >> 2] | 0) | 0) | 0;
   i2 = i2 + (HEAP32[i11 + (i7 * 20 | 0) + 16 >> 2] | 0) | 0;
   i3 = i4 - (Math_imul((((i4 - i3 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 8 >> 2] | 0)) + i3 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i5 * 20 | 0) >> 2] | 0) | 0) | 0;
   i3 = i3 + (HEAP32[i11 + (i5 * 20 | 0) + 16 >> 2] | 0) | 0;
   if (i2 >>> 0 >= 65536) i2 = (i2 | 0) > 0 ? 65535 : 0;
   HEAP16[i9 + (i7 << 1) >> 1] = i2;
   if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
   HEAP16[i9 + (i5 << 1) >> 1] = i3;
   i14 = ___muldi3(i4 | 0, 0, -130063606, 0) | 0;
   i14 = _i64Add(i14 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i2 = tempRet0;
   i1 = ___muldi3(i14 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i1 | 0, tempRet0 | 0, i2 | 0, 0) | 0;
   i1 = tempRet0;
   i5 = i7 | 2;
   ___muldi3(HEAP32[i11 + (i5 * 20 | 0) + 4 >> 2] | 0, 0, i14 | 0, 0) | 0;
   i4 = tempRet0;
   i6 = i7 | 3;
   ___muldi3(HEAP32[i11 + (i6 * 20 | 0) + 4 >> 2] | 0, 0, i2 | 0, 0) | 0;
   i3 = tempRet0;
   i4 = i14 - (Math_imul((((i14 - i4 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 8 >> 2] | 0)) + i4 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i5 * 20 | 0) >> 2] | 0) | 0) | 0;
   i4 = i4 + (HEAP32[i11 + (i5 * 20 | 0) + 16 >> 2] | 0) | 0;
   i3 = i2 - (Math_imul((((i2 - i3 | 0) >>> (HEAP32[i11 + (i6 * 20 | 0) + 8 >> 2] | 0)) + i3 | 0) >>> (HEAP32[i11 + (i6 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i6 * 20 | 0) >> 2] | 0) | 0) | 0;
   i3 = i3 + (HEAP32[i11 + (i6 * 20 | 0) + 16 >> 2] | 0) | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i9 + (i5 << 1) >> 1] = i4;
   if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
   HEAP16[i9 + (i6 << 1) >> 1] = i3;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) <= (i8 | 0));
  i3 = i10 & -4;
 }
 if ((i3 | 0) < (i10 | 0)) i4 = i3; else {
  i7 = i2;
  i9 = i1;
  i10 = i13;
  i8 = i10;
  HEAP32[i8 >> 2] = i7;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i12;
  return;
 }
 do {
  i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
  i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  ___muldi3(i2 | 0, 0, HEAP32[i11 + (i4 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
  i3 = tempRet0;
  i3 = i2 - (Math_imul((((i2 - i3 | 0) >>> (HEAP32[i11 + (i4 * 20 | 0) + 8 >> 2] | 0)) + i3 | 0) >>> (HEAP32[i11 + (i4 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i4 * 20 | 0) >> 2] | 0) | 0) | 0;
  i3 = i3 + (HEAP32[i11 + (i4 * 20 | 0) + 16 >> 2] | 0) | 0;
  if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
  HEAP16[i9 + (i4 << 1) >> 1] = i3;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i10 | 0));
 i10 = i13;
 i9 = i10;
 HEAP32[i9 >> 2] = i2;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZL12icvReadMatNDP13CvFileStorageP10CvFileNode(i16, i11) {
 i16 = i16 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 688 | 0;
 i10 = i18 + 168 | 0;
 i6 = i18 + 160 | 0;
 i17 = i18 + 32 | 0;
 i1 = i18 + 24 | 0;
 i4 = i18 + 16 | 0;
 i12 = i18 + 8 | 0;
 i15 = i18;
 i5 = _cvGetFileNodeByName(i16, i11, 11656) | 0;
 i2 = _cvGetFileNodeByName(i16, i11, 11672) | 0;
 if ((i2 | 0) != 0 ? (HEAP32[i2 >> 2] & 7 | 0) == 3 : 0) {
  i2 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i5 | 0) != 0 & (i2 | 0) != 0) i14 = i2; else i3 = 4;
 } else {
  i2 = 0;
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i1, 46) | 0) + 0 | 0;
  i8 = 11712 | 0;
  i9 = i7 + 46 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i1, 11760, 8960, 3623);
  __ZN2cv6String10deallocateEv(i1);
  i14 = i2;
 }
 i2 = HEAP32[i5 >> 2] & 7;
 if ((i2 | 0) == 5) i13 = HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 24 >> 2] | 0; else i13 = (i2 | 0) == 1 ? 1 : -1;
 if ((i13 + -1 | 0) >>> 0 > 31) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i4, 45) | 0) + 0 | 0;
  i8 = 11776 | 0;
  i9 = i7 + 45 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-212, i4, 11760, 8960, 3629);
  __ZN2cv6String10deallocateEv(i4);
 }
 _cvReadRawData(i16, i5, i17, 11664);
 i9 = (__ZL15icvDecodeFormatPKcPii(i14, i10) | 0) != 1;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i9 | (i2 | 0) > 4) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i6, 33) | 0) + 0 | 0;
  i8 = 11936 | 0;
  i9 = i7 + 33 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i6, 11976, 8960, 3068);
  __ZN2cv6String10deallocateEv(i6);
 }
 i3 = (i2 << 3) + -8 | 0;
 i6 = HEAP32[i10 + 4 >> 2] & 7 | i3;
 i4 = _cvGetFileNodeByName(i16, i11, 11680) | 0;
 if (!i4) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i12, 44) | 0) + 0 | 0;
  i8 = 11824 | 0;
  i9 = i7 + 44 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i12, 11760, 8960, 3636);
  __ZN2cv6String10deallocateEv(i12);
 }
 i1 = (i3 >>> 3 & 511) + 1 | 0;
 if ((i13 | 0) > 0) {
  i2 = 0;
  do {
   i1 = Math_imul(HEAP32[i17 + (i2 << 2) >> 2] | 0, i1) | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i13 | 0));
 }
 i2 = HEAP32[i4 >> 2] & 7;
 if (i2 >>> 0 > 4) i2 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 24 >> 2] | 0; else i2 = (i2 | 0) != 0 & 1;
 i3 = (i2 | 0) > 0;
 if (!((i2 | 0) == (i1 | 0) | i3 ^ 1)) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i15, 63) | 0) + 0 | 0;
  i8 = 11872 | 0;
  i9 = i7 + 63 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-209, i15, 11760, 8960, 3647);
  __ZN2cv6String10deallocateEv(i15);
 }
 if (i3) {
  i10 = _cvCreateMatND(i13, i17, i6) | 0;
  _cvReadRawData(i16, i4, HEAP32[i10 + 16 >> 2] | 0, i14);
  STACKTOP = i18;
  return i10 | 0;
 } else {
  i10 = _cvCreateMatNDHeader(i13, i17, i6) | 0;
  STACKTOP = i18;
  return i10 | 0;
 }
 return 0;
}

function _gz_comp(i13, i4) {
 i13 = i13 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 i12 = i13 + 84 | 0;
 i5 = i13 + 24 | 0;
 if ((HEAP32[i5 >> 2] | 0) == 0 ? (_gz_init(i13) | 0) == -1 : 0) {
  i10 = -1;
  STACKTOP = i14;
  return i10 | 0;
 }
 if (HEAP32[i13 + 40 >> 2] | 0) {
  i1 = i13 + 88 | 0;
  i10 = _write(HEAP32[i13 + 16 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  if ((i10 | 0) >= 0 ? (i10 | 0) == (HEAP32[i1 >> 2] | 0) : 0) {
   HEAP32[i1 >> 2] = 0;
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  _gz_error(i13, -1, _strerror(HEAP32[(___errno_location() | 0) >> 2] | 0) | 0);
  i10 = -1;
  STACKTOP = i14;
  return i10 | 0;
 }
 i11 = i13 + 100 | 0;
 i6 = i13 + 96 | 0;
 i7 = i13 + 4 | 0;
 i8 = i13 + 36 | 0;
 i9 = i13 + 16 | 0;
 i10 = (i4 | 0) == 4;
 i1 = HEAP32[i11 >> 2] | 0;
 L14 : do if (!i4) while (1) {
  if (!i1) {
   i4 = HEAP32[i6 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i4 - i1 | 0;
   if ((i4 | 0) != (i1 | 0)) {
    i4 = _write(HEAP32[i9 >> 2] | 0, i1 | 0, i2 | 0) | 0;
    if (!((i4 | 0) > -1 & (i4 | 0) == (i2 | 0))) {
     i3 = 31;
     break L14;
    }
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1) i2 = HEAP32[i6 >> 2] | 0; else i3 = 11;
   } else i3 = 11;
   if ((i3 | 0) == 11) {
    i3 = 0;
    i1 = HEAP32[i5 >> 2] | 0;
    HEAP32[i11 >> 2] = i1;
    i2 = HEAP32[i8 >> 2] | 0;
    HEAP32[i6 >> 2] = i2;
   }
   HEAP32[i7 >> 2] = i2;
   i2 = i1;
  } else i2 = i1;
  if ((_deflate(i12, 0) | 0) == -2) {
   i3 = 37;
   break L14;
  }
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) == (i1 | 0)) {
   i3 = 39;
   break;
  }
 } else {
  if (i10) {
   i3 = i1;
   i2 = 0;
  } else while (1) {
   i15 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = i15 - i2 | 0;
   if ((i15 | 0) != (i2 | 0)) {
    i2 = _write(HEAP32[i9 >> 2] | 0, i2 | 0, i3 | 0) | 0;
    if (!((i2 | 0) > -1 & (i2 | 0) == (i3 | 0))) {
     i3 = 31;
     break L14;
    }
    i1 = HEAP32[i11 >> 2] | 0;
   }
   if (!i1) {
    i2 = HEAP32[i5 >> 2] | 0;
    HEAP32[i11 >> 2] = i2;
    i3 = HEAP32[i8 >> 2] | 0;
    HEAP32[i6 >> 2] = i3;
   } else {
    i3 = HEAP32[i6 >> 2] | 0;
    i2 = i1;
   }
   HEAP32[i7 >> 2] = i3;
   if ((_deflate(i12, i4) | 0) == -2) {
    i3 = 37;
    break L14;
   }
   i1 = HEAP32[i11 >> 2] | 0;
   if ((i2 | 0) == (i1 | 0)) {
    i3 = 39;
    break L14;
   }
  }
  while (1) {
   if ((i3 | 0) == 0 | (i2 | 0) == 1) {
    i4 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    i1 = i4 - i2 | 0;
    if ((i4 | 0) == (i2 | 0)) i1 = i3; else {
     i4 = _write(HEAP32[i9 >> 2] | 0, i2 | 0, i1 | 0) | 0;
     if (!((i4 | 0) > -1 & (i4 | 0) == (i1 | 0))) {
      i3 = 31;
      break L14;
     }
     i1 = HEAP32[i11 >> 2] | 0;
    }
    if (!i1) {
     i1 = HEAP32[i5 >> 2] | 0;
     HEAP32[i11 >> 2] = i1;
     i2 = HEAP32[i8 >> 2] | 0;
     HEAP32[i6 >> 2] = i2;
    } else i2 = HEAP32[i6 >> 2] | 0;
    HEAP32[i7 >> 2] = i2;
   } else i1 = i3;
   i2 = _deflate(i12, 4) | 0;
   if ((i2 | 0) == -2) {
    i3 = 37;
    break L14;
   }
   i3 = HEAP32[i11 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) {
    i3 = 39;
    break;
   }
  }
 } while (0);
 if ((i3 | 0) == 31) {
  _gz_error(i13, -1, _strerror(HEAP32[(___errno_location() | 0) >> 2] | 0) | 0);
  i10 = -1;
  STACKTOP = i14;
  return i10 | 0;
 } else if ((i3 | 0) == 37) {
  _gz_error(i13, -2, 143480);
  i10 = -1;
  STACKTOP = i14;
  return i10 | 0;
 } else if ((i3 | 0) == 39) {
  if (!i10) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  _deflateReset(i12) | 0;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 return 0;
}

function __ZN2cvL8randi_8uEPhiPyPKNS_9DivStructEb(i9, i10, i13, i11, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i14 = 0;
 i12 = STACKTOP;
 i1 = i13;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i10 + -4 | 0;
 if ((i8 | 0) < 0) i3 = 0; else {
  i7 = 0;
  do {
   i6 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i6 = _i64Add(i6 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i4 = tempRet0;
   i1 = ___muldi3(i6 | 0, 0, -130063606, 0) | 0;
   i4 = _i64Add(i1 | 0, tempRet0 | 0, i4 | 0, 0) | 0;
   i1 = tempRet0;
   ___muldi3(i6 | 0, 0, HEAP32[i11 + (i7 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
   i2 = tempRet0;
   i5 = i7 | 1;
   ___muldi3(i4 | 0, 0, HEAP32[i11 + (i5 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
   i3 = tempRet0;
   i2 = i6 - (Math_imul((((i6 - i2 | 0) >>> (HEAP32[i11 + (i7 * 20 | 0) + 8 >> 2] | 0)) + i2 | 0) >>> (HEAP32[i11 + (i7 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i7 * 20 | 0) >> 2] | 0) | 0) | 0;
   i2 = i2 + (HEAP32[i11 + (i7 * 20 | 0) + 16 >> 2] | 0) | 0;
   i3 = i4 - (Math_imul((((i4 - i3 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 8 >> 2] | 0)) + i3 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i5 * 20 | 0) >> 2] | 0) | 0) | 0;
   i3 = i3 + (HEAP32[i11 + (i5 * 20 | 0) + 16 >> 2] | 0) | 0;
   if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
   HEAP8[i9 + i7 >> 0] = i2;
   if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
   HEAP8[i9 + i5 >> 0] = i3;
   i14 = ___muldi3(i4 | 0, 0, -130063606, 0) | 0;
   i14 = _i64Add(i14 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i2 = tempRet0;
   i1 = ___muldi3(i14 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i1 | 0, tempRet0 | 0, i2 | 0, 0) | 0;
   i1 = tempRet0;
   i5 = i7 | 2;
   ___muldi3(HEAP32[i11 + (i5 * 20 | 0) + 4 >> 2] | 0, 0, i14 | 0, 0) | 0;
   i4 = tempRet0;
   i6 = i7 | 3;
   ___muldi3(HEAP32[i11 + (i6 * 20 | 0) + 4 >> 2] | 0, 0, i2 | 0, 0) | 0;
   i3 = tempRet0;
   i4 = i14 - (Math_imul((((i14 - i4 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 8 >> 2] | 0)) + i4 | 0) >>> (HEAP32[i11 + (i5 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i5 * 20 | 0) >> 2] | 0) | 0) | 0;
   i4 = i4 + (HEAP32[i11 + (i5 * 20 | 0) + 16 >> 2] | 0) | 0;
   i3 = i2 - (Math_imul((((i2 - i3 | 0) >>> (HEAP32[i11 + (i6 * 20 | 0) + 8 >> 2] | 0)) + i3 | 0) >>> (HEAP32[i11 + (i6 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i6 * 20 | 0) >> 2] | 0) | 0) | 0;
   i3 = i3 + (HEAP32[i11 + (i6 * 20 | 0) + 16 >> 2] | 0) | 0;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i9 + i5 >> 0] = i4;
   if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
   HEAP8[i9 + i6 >> 0] = i3;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) <= (i8 | 0));
  i3 = i10 & -4;
 }
 if ((i3 | 0) < (i10 | 0)) i4 = i3; else {
  i7 = i2;
  i9 = i1;
  i10 = i13;
  i8 = i10;
  HEAP32[i8 >> 2] = i7;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i12;
  return;
 }
 do {
  i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
  i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  ___muldi3(i2 | 0, 0, HEAP32[i11 + (i4 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
  i3 = tempRet0;
  i3 = i2 - (Math_imul((((i2 - i3 | 0) >>> (HEAP32[i11 + (i4 * 20 | 0) + 8 >> 2] | 0)) + i3 | 0) >>> (HEAP32[i11 + (i4 * 20 | 0) + 12 >> 2] | 0), HEAP32[i11 + (i4 * 20 | 0) >> 2] | 0) | 0) | 0;
  i3 = i3 + (HEAP32[i11 + (i4 * 20 | 0) + 16 >> 2] | 0) | 0;
  if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
  HEAP8[i9 + i4 >> 0] = i3;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i10 | 0));
 i10 = i13;
 i9 = i10;
 HEAP32[i9 >> 2] = i2;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter9OnTestEndERKNS_8TestInfoE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i11 = i12 + 8 | 0;
 i9 = i12 + 16 | 0;
 i8 = i12;
 i6 = i10 + 56 | 0;
 i5 = i10 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = (HEAP32[i6 >> 2] | 0) - i1 | 0;
 L1 : do if ((i3 | 0) > 0) {
  i4 = i10 + 52 | 0;
  i3 = (i3 | 0) / 44 | 0;
  i2 = 0;
  while (1) {
   if (i3 >>> 0 <= i2 >>> 0) {
    i7 = 5;
    break;
   }
   if (HEAP32[i1 + (i2 * 44 | 0) >> 2] | 0) {
    i7 = 8;
    break;
   }
   i2 = i2 + 1 | 0;
   i3 = ((HEAP32[i6 >> 2] | 0) - i1 | 0) / 44 | 0;
   if ((i2 | 0) >= (i3 | 0)) {
    i7 = 7;
    break L1;
   }
  }
  if ((i7 | 0) == 5) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i4); else if ((i7 | 0) == 8) {
   __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(1, 162560, i11);
   break;
  }
 } else i7 = 7; while (0);
 if ((i7 | 0) == 7) __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(2, 162544, i11);
 if (!(HEAP8[i10 >> 0] & 1)) i3 = i10 + 1 | 0; else i3 = HEAP32[i10 + 8 >> 2] | 0;
 i1 = i10 + 12 | 0;
 if (!(HEAP8[i1 >> 0] & 1)) i1 = i1 + 1 | 0; else i1 = HEAP32[i10 + 20 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i11 + 4 >> 2] = i1;
 _printf(162624, i11 | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = (HEAP32[i6 >> 2] | 0) - i1 | 0;
 L21 : do if ((i3 | 0) > 0) {
  i4 = i10 + 52 | 0;
  i3 = (i3 | 0) / 44 | 0;
  i2 = 0;
  while (1) {
   if (i3 >>> 0 <= i2 >>> 0) {
    i7 = 19;
    break;
   }
   if (HEAP32[i1 + (i2 * 44 | 0) >> 2] | 0) break;
   i2 = i2 + 1 | 0;
   i3 = ((HEAP32[i6 >> 2] | 0) - i1 | 0) / 44 | 0;
   if ((i2 | 0) >= (i3 | 0)) break L21;
  }
  if ((i7 | 0) == 19) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i4);
  i1 = HEAP32[i10 + 24 >> 2] | 0;
  do if (i1) if (!(HEAP8[i1 >> 0] & 1)) {
   i4 = i1 + 1 | 0;
   break;
  } else {
   i4 = HEAP32[i1 + 8 >> 2] | 0;
   break;
  } else i4 = 0; while (0);
  i1 = HEAP32[i10 + 28 >> 2] | 0;
  do if (i1) {
   if (HEAP8[i1 >> 0] & 1) {
    i1 = HEAP32[i1 + 8 >> 2] | 0;
    i7 = 30;
    break;
   }
   i1 = i1 + 1 | 0;
   _printf(168896, i11 | 0) | 0;
   if (i4) {
    HEAP32[i11 >> 2] = 162512;
    HEAP32[i11 + 4 >> 2] = i4;
    _printf(168912, i11 | 0) | 0;
    i7 = 33;
   }
  } else {
   i1 = 0;
   i7 = 30;
  } while (0);
  do if ((i7 | 0) == 30) {
   i2 = (i4 | 0) != 0;
   i3 = (i1 | 0) != 0;
   if (!(i2 | i3)) break L21;
   _printf(168896, i11 | 0) | 0;
   if (i2) {
    HEAP32[i11 >> 2] = 162512;
    HEAP32[i11 + 4 >> 2] = i4;
    _printf(168912, i11 | 0) | 0;
    if (i3) {
     i7 = 33;
     break;
    } else break L21;
   } else if (i3) break; else break L21;
  } while (0);
  if ((i7 | 0) == 33) _printf(160688, i11 | 0) | 0;
  HEAP32[i11 >> 2] = 164552;
  HEAP32[i11 + 4 >> 2] = i1;
  _printf(168912, i11 | 0) | 0;
 } while (0);
 if (!(HEAP8[159976] | 0)) {
  _putchar(10) | 0;
  i10 = HEAP32[_stdout >> 2] | 0;
  _fflush(i10 | 0) | 0;
  STACKTOP = i12;
  return;
 }
 i6 = i10 + 80 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i8;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = i7;
 __ZN7testing8internal18StreamableToStringIxEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i9, i8);
 if (!(HEAP8[i9 >> 0] & 1)) i1 = i9 + 1 | 0; else i1 = HEAP32[i9 + 8 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 _printf(162576, i11 | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 i10 = HEAP32[_stdout >> 2] | 0;
 _fflush(i10 | 0) | 0;
 STACKTOP = i12;
 return;
}

function __ZN2cvL12randBits_16sEPsiPyPKNS_3VecIiLi2EEEb(i9, i10, i12, i11, i4) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 i13 = STACKTOP;
 i1 = i12;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i10 + -4 | 0;
 i3 = (i8 | 0) < 0;
 if (i4) if (i3) i3 = 0; else {
  i7 = 0;
  do {
   i3 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i3 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i1 = tempRet0;
   i3 = (i2 & HEAP32[i11 + (i7 << 3) >> 2]) + (HEAP32[i11 + (i7 << 3) + 4 >> 2] | 0) | 0;
   i5 = i7 | 1;
   i4 = (i2 >> 8 & HEAP32[i11 + (i5 << 3) >> 2]) + (HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0) | 0;
   if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
   HEAP16[i9 + (i7 << 1) >> 1] = i3;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i9 + (i5 << 1) >> 1] = i4;
   i5 = i7 | 2;
   i3 = (HEAP32[i11 + (i5 << 3) >> 2] & i2 >> 16) + (HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0) | 0;
   i6 = i7 | 3;
   i4 = (HEAP32[i11 + (i6 << 3) >> 2] & i2 >> 24) + (HEAP32[i11 + (i6 << 3) + 4 >> 2] | 0) | 0;
   if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
   HEAP16[i9 + (i5 << 1) >> 1] = i3;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i9 + (i6 << 1) >> 1] = i4;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) <= (i8 | 0));
  i3 = i10 & -4;
 } else if (i3) i3 = 0; else {
  i7 = 0;
  do {
   i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i5 = tempRet0;
   i3 = (i2 & HEAP32[i11 + (i7 << 3) >> 2]) + (HEAP32[i11 + (i7 << 3) + 4 >> 2] | 0) | 0;
   i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i5 = _i64Add(i2 | 0, tempRet0 | 0, i5 | 0, 0) | 0;
   i2 = tempRet0;
   i1 = i7 | 1;
   i4 = (i5 & HEAP32[i11 + (i1 << 3) >> 2]) + (HEAP32[i11 + (i1 << 3) + 4 >> 2] | 0) | 0;
   if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
   HEAP16[i9 + (i7 << 1) >> 1] = i3;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i9 + (i1 << 1) >> 1] = i4;
   i1 = ___muldi3(i5 | 0, 0, -130063606, 0) | 0;
   i1 = _i64Add(i1 | 0, tempRet0 | 0, i2 | 0, 0) | 0;
   i2 = tempRet0;
   i5 = i7 | 2;
   i3 = (HEAP32[i11 + (i5 << 3) >> 2] & i1) + (HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0) | 0;
   i1 = ___muldi3(i1 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i1 | 0, tempRet0 | 0, i2 | 0, 0) | 0;
   i1 = tempRet0;
   i6 = i7 | 3;
   i4 = (HEAP32[i11 + (i6 << 3) >> 2] & i2) + (HEAP32[i11 + (i6 << 3) + 4 >> 2] | 0) | 0;
   if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
   HEAP16[i9 + (i5 << 1) >> 1] = i3;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i9 + (i6 << 1) >> 1] = i4;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) <= (i8 | 0));
  i3 = i10 & -4;
 }
 if ((i3 | 0) < (i10 | 0)) i4 = i3; else {
  i7 = i2;
  i9 = i1;
  i10 = i12;
  i8 = i10;
  HEAP32[i8 >> 2] = i7;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i13;
  return;
 }
 do {
  i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
  i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  i3 = (i2 & HEAP32[i11 + (i4 << 3) >> 2]) + (HEAP32[i11 + (i4 << 3) + 4 >> 2] | 0) | 0;
  if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
  HEAP16[i9 + (i4 << 1) >> 1] = i3;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i10 | 0));
 i10 = i12;
 i9 = i10;
 HEAP32[i9 >> 2] = i2;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i13;
 return;
}

function __ZN7testing8internal25ReportInvalidTestCaseTypeEPKcS2_i(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i10 = i11;
 i9 = i11 + 36 | 0;
 i6 = i11 + 24 | 0;
 i7 = i11 + 12 | 0;
 __ZN7testing7MessageC2Ev(i9);
 i8 = HEAP32[i9 >> 2] | 0;
 i1 = i8 + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 161544, 36) | 0;
 i2 = (i3 | 0) == 0;
 if (i2) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i3, _strlen(i3 | 0) | 0) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 161584, 2) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 160848, 63) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 161152, 30) | 0;
 if (i2) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i3, _strlen(i3 | 0) | 0) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 161592, 12) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 161608, 62) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 161672, 61) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 161736, 61) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 161800, 67) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 161872, 11) | 0;
 i3 = HEAP32[_stderr >> 2] | 0;
 __ZN7testing8internal18FormatFileLocationEPKci(i6, i4, i5);
 if (!(HEAP8[i6 >> 0] & 1)) i4 = i6 + 1 | 0; else i4 = HEAP32[i6 + 8 >> 2] | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i10, i8 + 12 | 0);
 i1 = HEAP8[i10 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i10 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i10 + 8 >> 2] | 0;
  i1 = HEAP32[i10 + 4 >> 2] | 0;
 }
 i5 = i2 + i1 | 0;
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i7, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
 if (!(HEAP8[i7 >> 0] & 1)) i1 = i7 + 1 | 0; else i1 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i10 + 4 >> 2] = i1;
 _fprintf(i3 | 0, 161888, i10 | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 if (!i8) {
  STACKTOP = i11;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] & 511](i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN2cvL12transpose_8uEPKhjPhjNS_5Size_IiEE(i15, i16, i13, i14, i1) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i17 = STACKTOP;
 i12 = HEAP32[i1 >> 2] | 0;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i12 + -4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i7 = i11 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i11 & -4;
  i10 = 0;
  do {
   i5 = Math_imul(i10, i14) | 0;
   i4 = Math_imul(i10 | 1, i14) | 0;
   i3 = Math_imul(i10 | 2, i14) | 0;
   i2 = Math_imul(i10 | 3, i14) | 0;
   if (i8) i6 = 0; else {
    i6 = 0;
    do {
     i24 = (Math_imul(i6, i16) | 0) + i10 | 0;
     i22 = i6 | 1;
     i23 = (Math_imul(i22, i16) | 0) + i10 | 0;
     i20 = i6 | 2;
     i21 = (Math_imul(i20, i16) | 0) + i10 | 0;
     i18 = i6 | 3;
     i19 = (Math_imul(i18, i16) | 0) + i10 | 0;
     HEAP8[i13 + (i6 + i5) >> 0] = HEAP8[i15 + i24 >> 0] | 0;
     HEAP8[i13 + (i22 + i5) >> 0] = HEAP8[i15 + i23 >> 0] | 0;
     HEAP8[i13 + (i20 + i5) >> 0] = HEAP8[i15 + i21 >> 0] | 0;
     HEAP8[i13 + (i18 + i5) >> 0] = HEAP8[i15 + i19 >> 0] | 0;
     HEAP8[i13 + (i6 + i4) >> 0] = HEAP8[i15 + (i24 | 1) >> 0] | 0;
     HEAP8[i13 + (i22 + i4) >> 0] = HEAP8[i15 + (i23 + 1) >> 0] | 0;
     HEAP8[i13 + (i20 + i4) >> 0] = HEAP8[i15 + (i21 | 1) >> 0] | 0;
     HEAP8[i13 + (i18 + i4) >> 0] = HEAP8[i15 + (i19 + 1) >> 0] | 0;
     HEAP8[i13 + (i6 + i3) >> 0] = HEAP8[i15 + (i24 | 2) >> 0] | 0;
     HEAP8[i13 + (i22 + i3) >> 0] = HEAP8[i15 + (i23 + 2) >> 0] | 0;
     HEAP8[i13 + (i20 + i3) >> 0] = HEAP8[i15 + (i21 + 2) >> 0] | 0;
     HEAP8[i13 + (i18 + i3) >> 0] = HEAP8[i15 + (i19 + 2) >> 0] | 0;
     HEAP8[i13 + (i6 + i2) >> 0] = HEAP8[i15 + (i24 | 3) >> 0] | 0;
     HEAP8[i13 + (i22 + i2) >> 0] = HEAP8[i15 + (i23 + 3) >> 0] | 0;
     HEAP8[i13 + (i20 + i2) >> 0] = HEAP8[i15 + (i21 + 3) >> 0] | 0;
     HEAP8[i13 + (i18 + i2) >> 0] = HEAP8[i15 + (i19 + 3) >> 0] | 0;
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i7 | 0));
    i6 = i9;
   }
   if ((i6 | 0) < (i11 | 0)) do {
    i22 = (Math_imul(i6, i16) | 0) + i10 | 0;
    HEAP8[i13 + (i6 + i5) >> 0] = HEAP8[i15 + i22 >> 0] | 0;
    HEAP8[i13 + (i6 + i4) >> 0] = HEAP8[i15 + (i22 + 1) >> 0] | 0;
    HEAP8[i13 + (i6 + i3) >> 0] = HEAP8[i15 + (i22 + 2) >> 0] | 0;
    HEAP8[i13 + (i6 + i2) >> 0] = HEAP8[i15 + (i22 + 3) >> 0] | 0;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i11 | 0));
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) <= (i1 | 0));
  i1 = i12 & -4;
 }
 if ((i1 | 0) >= (i12 | 0)) {
  STACKTOP = i17;
  return;
 }
 i4 = i11 + -4 | 0;
 i5 = (i4 | 0) < 0;
 i6 = i11 & -4;
 do {
  i3 = Math_imul(i1, i14) | 0;
  if (i5) i2 = 0; else {
   i2 = 0;
   do {
    i18 = i2 | 1;
    i7 = i15 + ((Math_imul(i18, i16) | 0) + i1) | 0;
    i20 = i2 | 2;
    i19 = i15 + ((Math_imul(i20, i16) | 0) + i1) | 0;
    i22 = i2 | 3;
    i21 = i15 + ((Math_imul(i22, i16) | 0) + i1) | 0;
    HEAP8[i13 + (i2 + i3) >> 0] = HEAP8[i15 + ((Math_imul(i2, i16) | 0) + i1) >> 0] | 0;
    HEAP8[i13 + (i18 + i3) >> 0] = HEAP8[i7 >> 0] | 0;
    HEAP8[i13 + (i20 + i3) >> 0] = HEAP8[i19 >> 0] | 0;
    HEAP8[i13 + (i22 + i3) >> 0] = HEAP8[i21 >> 0] | 0;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) <= (i4 | 0));
   i2 = i6;
  }
  if ((i2 | 0) < (i11 | 0)) do {
   HEAP8[i13 + (i2 + i3) >> 0] = HEAP8[i15 + ((Math_imul(i2, i16) | 0) + i1) >> 0] | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i11 | 0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i12 | 0));
 STACKTOP = i17;
 return;
}

function __ZL10icvReadMatP13CvFileStorageP10CvFileNode(i14, i3) {
 i14 = i14 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 i4 = i15 + 32 | 0;
 i5 = i15 + 24 | 0;
 i6 = i15 + 16 | 0;
 i11 = i15 + 8 | 0;
 i13 = i15;
 i1 = _cvGetFileNodeByName(i14, i3, 12e3) | 0;
 do if (i1) {
  i2 = HEAP32[i1 >> 2] & 7;
  if ((i2 | 0) == 1) {
   i12 = HEAP32[i1 + 8 >> 2] | 0;
   break;
  } else if ((i2 | 0) == 2) {
   i12 = _lrint(+HEAPF64[i1 + 8 >> 3]) | 0;
   break;
  } else {
   i12 = 2147483647;
   break;
  }
 } else i12 = -1; while (0);
 i2 = _cvGetFileNodeByName(i14, i3, 12008) | 0;
 do if (i2) {
  i1 = HEAP32[i2 >> 2] & 7;
  if ((i1 | 0) == 2) {
   i10 = _lrint(+HEAPF64[i2 + 8 >> 3]) | 0;
   break;
  } else if ((i1 | 0) == 1) {
   i10 = HEAP32[i2 + 8 >> 2] | 0;
   break;
  } else {
   i10 = 2147483647;
   break;
  }
 } else i10 = -1; while (0);
 i2 = _cvGetFileNodeByName(i14, i3, 11672) | 0;
 if ((i2 | 0) != 0 ? (HEAP32[i2 >> 2] & 7 | 0) == 3 : 0) {
  i2 = HEAP32[i2 + 12 >> 2] | 0;
  i1 = i10 | i12;
  if ((i1 | 0) > -1 & (i2 | 0) != 0) i6 = i1; else i9 = 13;
 } else {
  i1 = i10 | i12;
  i2 = 0;
  i9 = 13;
 }
 if ((i9 | 0) == 13) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i6, 46) | 0) + 0 | 0;
  i8 = 11712 | 0;
  i9 = i7 + 46 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i6, 12016, 8960, 3538);
  __ZN2cv6String10deallocateEv(i6);
  i6 = i1;
 }
 i9 = (__ZL15icvDecodeFormatPKcPii(i2, i4) | 0) != 1;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i9 | (i1 | 0) > 4) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i5, 33) | 0) + 0 | 0;
  i8 = 11936 | 0;
  i9 = i7 + 33 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i5, 11976, 8960, 3068);
  __ZN2cv6String10deallocateEv(i5);
 }
 i5 = (i1 << 3) + -8 | 0;
 i4 = HEAP32[i4 + 4 >> 2] & 7 | i5;
 i3 = _cvGetFileNodeByName(i14, i3, 11680) | 0;
 if (!i3) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i11, 44) | 0) + 0 | 0;
  i8 = 11824 | 0;
  i9 = i7 + 44 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i11, 12016, 8960, 3544);
  __ZN2cv6String10deallocateEv(i11);
 }
 i1 = HEAP32[i3 >> 2] & 7;
 if (i1 >>> 0 > 4) i1 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 24 >> 2] | 0; else i1 = (i1 | 0) != 0 & 1;
 if ((i1 | 0) > 0) {
  if ((i1 | 0) != (Math_imul(Math_imul(i10, i12) | 0, (i5 >>> 3 & 511) + 1 | 0) | 0)) {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   i7 = (__ZN2cv6String8allocateEj(i13, 63) | 0) + 0 | 0;
   i8 = 11872 | 0;
   i9 = i7 + 63 | 0;
   do {
    HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
    i7 = i7 + 1 | 0;
    i8 = i8 + 1 | 0;
   } while ((i7 | 0) < (i9 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-209, i13, 12016, 8960, 3549);
   __ZN2cv6String10deallocateEv(i13);
  }
  i10 = _cvCreateMat(i12, i10, i4) | 0;
  _cvReadRawData(i14, i3, HEAP32[i10 + 16 >> 2] | 0, i2);
  STACKTOP = i15;
  return i10 | 0;
 }
 if (!i6) {
  i10 = _cvCreateMatHeader(0, 1, i4) | 0;
  STACKTOP = i15;
  return i10 | 0;
 } else {
  i10 = _cvCreateMatHeader(i12, i10, i4) | 0;
  STACKTOP = i15;
  return i10 | 0;
 }
 return 0;
}

function __ZN2cv4readERKNS_8FileNodeERNS_3MatERKS3_(i4, i7, i1) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 i3 = i12 + 172 | 0;
 i11 = i12 + 168 | 0;
 i9 = i12 + 112 | 0;
 i5 = i12 + 88 | 0;
 i10 = i12 + 32 | 0;
 i6 = i12 + 8 | 0;
 i8 = i12;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i2) {
  i10 = i3 + 4 | 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAP32[i3 >> 2] = 32232;
  HEAP32[i10 >> 2] = 33619968;
  HEAP32[i3 + 8 >> 2] = i7;
  __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i1, i3);
  STACKTOP = i12;
  return;
 }
 i3 = _cvRead(HEAP32[i4 >> 2] | 0, i2, 0) | 0;
 HEAP32[i11 >> 2] = i3;
 do if (i3) {
  i2 = HEAP32[i3 >> 2] & -65536;
  if ((i2 | 0) == 1111687168) {
   __ZN2cv10cvarrToMatEPKvbbiPNS_10AutoBufferIdLj136EEE(i10, i3, 0, 1, 0, 0);
   i2 = i6 + 4 | 0;
   HEAP32[i2 + 0 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP32[i6 >> 2] = 32232;
   HEAP32[i2 >> 2] = 33619968;
   HEAP32[i6 + 8 >> 2] = i7;
   __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i10, i6);
   i2 = i10 + 36 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) != 0 ? (i8 = i1 + 12 | 0, i9 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i10);
   HEAP32[i2 >> 2] = 0;
   i9 = i10 + 16 | 0;
   i3 = i10 + 4 | 0;
   HEAP32[i9 + 0 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i2 = HEAP32[i10 + 40 >> 2] | 0;
    i1 = 0;
    do {
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
   }
   i1 = HEAP32[i10 + 44 >> 2] | 0;
   if ((i1 | 0) != (i10 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
   _cvReleaseMat(i11);
   STACKTOP = i12;
   return;
  } else if ((i2 | 0) != 1111621632) break;
  if ((HEAP32[i3 + 24 >> 2] | 0) > -1 ? (HEAP32[i3 + 20 >> 2] | 0) > -1 : 0) {
   __ZN2cv10cvarrToMatEPKvbbiPNS_10AutoBufferIdLj136EEE(i9, i3, 0, 1, 0, 0);
   i1 = i5 + 4 | 0;
   HEAP32[i1 + 0 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i5 >> 2] = 32232;
   HEAP32[i1 >> 2] = 33619968;
   HEAP32[i5 + 8 >> 2] = i7;
   __ZNK2cv3Mat6copyToERKNS_12_OutputArrayE(i9, i5);
   i1 = i9 + 36 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != 0 ? (i8 = i2 + 12 | 0, i10 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i9);
   HEAP32[i1 >> 2] = 0;
   i10 = i9 + 16 | 0;
   i3 = i9 + 4 | 0;
   HEAP32[i10 + 0 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i2 = HEAP32[i9 + 40 >> 2] | 0;
    i1 = 0;
    do {
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
   }
   i1 = HEAP32[i9 + 44 >> 2] | 0;
   if ((i1 | 0) != (i9 + 48 | 0)) __ZN2cv8fastFreeEPv(i1);
   _cvReleaseMat(i11);
   STACKTOP = i12;
   return;
  }
 } while (0);
 _cvRelease(i11);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i8, 18) | 0) + 0 | 0;
 i1 = 11480 | 0;
 i3 = i2 + 18 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i8, 11504, 8960, 5533);
 __ZN2cv6String10deallocateEv(i8);
 STACKTOP = i12;
 return;
}

function __ZN2cvL6mul32fEPKfjS1_jPfjNS_5Size_IiEEPv(i9, i2, i10, i4, i12, i5, i3, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, f11 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0;
 i17 = STACKTOP;
 f11 = Math_fround(+HEAPF64[i1 >> 3]);
 i16 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i15 = i2 >>> 2;
 i14 = i4 >>> 2;
 i13 = i5 >>> 2;
 i5 = i1 + -1 | 0;
 i1 = (i1 | 0) == 0;
 if (f11 == Math_fround(1.0)) {
  if (i1) {
   STACKTOP = i17;
   return;
  }
  i6 = i16 + -4 | 0;
  i7 = (i6 | 0) < 0;
  i8 = (i6 | 0) > 3 ? i16 & -4 : 4;
  i1 = i9;
  i2 = i10;
  i3 = i12;
  while (1) {
   if (i7) i4 = 0; else {
    i4 = 0;
    do {
     f11 = Math_fround(HEAPF32[i1 + (i4 << 2) >> 2]);
     f11 = Math_fround(f11 * Math_fround(HEAPF32[i2 + (i4 << 2) >> 2]));
     i9 = i4 | 1;
     f18 = Math_fround(HEAPF32[i1 + (i9 << 2) >> 2]);
     f18 = Math_fround(f18 * Math_fround(HEAPF32[i2 + (i9 << 2) >> 2]));
     HEAPF32[i3 + (i4 << 2) >> 2] = f11;
     HEAPF32[i3 + (i9 << 2) >> 2] = f18;
     i9 = i4 | 2;
     f18 = Math_fround(HEAPF32[i1 + (i9 << 2) >> 2]);
     f18 = Math_fround(f18 * Math_fround(HEAPF32[i2 + (i9 << 2) >> 2]));
     i10 = i4 | 3;
     f11 = Math_fround(HEAPF32[i1 + (i10 << 2) >> 2]);
     f11 = Math_fround(f11 * Math_fround(HEAPF32[i2 + (i10 << 2) >> 2]));
     HEAPF32[i3 + (i9 << 2) >> 2] = f18;
     HEAPF32[i3 + (i10 << 2) >> 2] = f11;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) <= (i6 | 0));
    i4 = i8;
   }
   if ((i4 | 0) < (i16 | 0)) do {
    f11 = Math_fround(HEAPF32[i1 + (i4 << 2) >> 2]);
    HEAPF32[i3 + (i4 << 2) >> 2] = Math_fround(f11 * Math_fround(HEAPF32[i2 + (i4 << 2) >> 2]));
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i16 | 0));
   if (!i5) break; else {
    i1 = i1 + (i15 << 2) | 0;
    i2 = i2 + (i14 << 2) | 0;
    i3 = i3 + (i13 << 2) | 0;
    i5 = i5 + -1 | 0;
   }
  }
  STACKTOP = i17;
  return;
 } else {
  if (i1) {
   STACKTOP = i17;
   return;
  }
  i8 = i16 + -4 | 0;
  i7 = (i8 | 0) < 0;
  i6 = (i8 | 0) > 3 ? i16 & -4 : 4;
  i1 = i10;
  i2 = i9;
  i3 = i12;
  i4 = i5;
  while (1) {
   if (i7) i5 = 0; else {
    i5 = 0;
    do {
     f18 = Math_fround(f11 * Math_fround(HEAPF32[i2 + (i5 << 2) >> 2]));
     f18 = Math_fround(f18 * Math_fround(HEAPF32[i1 + (i5 << 2) >> 2]));
     i9 = i5 | 1;
     f19 = Math_fround(f11 * Math_fround(HEAPF32[i2 + (i9 << 2) >> 2]));
     f19 = Math_fround(f19 * Math_fround(HEAPF32[i1 + (i9 << 2) >> 2]));
     HEAPF32[i3 + (i5 << 2) >> 2] = f18;
     HEAPF32[i3 + (i9 << 2) >> 2] = f19;
     i9 = i5 | 2;
     f19 = Math_fround(f11 * Math_fround(HEAPF32[i2 + (i9 << 2) >> 2]));
     f19 = Math_fround(f19 * Math_fround(HEAPF32[i1 + (i9 << 2) >> 2]));
     i10 = i5 | 3;
     f18 = Math_fround(f11 * Math_fround(HEAPF32[i2 + (i10 << 2) >> 2]));
     f18 = Math_fround(f18 * Math_fround(HEAPF32[i1 + (i10 << 2) >> 2]));
     HEAPF32[i3 + (i9 << 2) >> 2] = f19;
     HEAPF32[i3 + (i10 << 2) >> 2] = f18;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) <= (i8 | 0));
    i5 = i6;
   }
   if ((i5 | 0) < (i16 | 0)) do {
    f18 = Math_fround(f11 * Math_fround(HEAPF32[i2 + (i5 << 2) >> 2]));
    HEAPF32[i3 + (i5 << 2) >> 2] = Math_fround(f18 * Math_fround(HEAPF32[i1 + (i5 << 2) >> 2]));
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i16 | 0));
   if (!i4) break; else {
    i1 = i1 + (i14 << 2) | 0;
    i2 = i2 + (i15 << 2) | 0;
    i3 = i3 + (i13 << 2) | 0;
    i4 = i4 + -1 | 0;
   }
  }
  STACKTOP = i17;
  return;
 }
}

function _fmod(d12, d6) {
 d12 = +d12;
 d6 = +d6;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 HEAPF64[tempDoublePtr >> 3] = d12;
 i8 = HEAP32[tempDoublePtr >> 2] | 0;
 i9 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 HEAPF64[tempDoublePtr >> 3] = d6;
 i10 = HEAP32[tempDoublePtr >> 2] | 0;
 i11 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i1 = _bitshift64Lshr(i8 | 0, i9 | 0, 52) | 0;
 i1 = i1 & 2047;
 i4 = _bitshift64Lshr(i10 | 0, i11 | 0, 52) | 0;
 i4 = i4 & 2047;
 i13 = i9 & -2147483648;
 i2 = _bitshift64Shl(i10 | 0, i11 | 0, 1) | 0;
 i7 = tempRet0;
 if (!((i2 | 0) == 0 & (i7 | 0) == 0) ? (i5 = i11 & 2147483647, !(i5 >>> 0 > 2146435072 | (i5 | 0) == 2146435072 & i10 >>> 0 > 0 | (i1 | 0) == 2047)) : 0) {
  i5 = _bitshift64Shl(i8 | 0, i9 | 0, 1) | 0;
  i3 = tempRet0;
  if (!(i3 >>> 0 > i7 >>> 0 | (i3 | 0) == (i7 | 0) & i5 >>> 0 > i2 >>> 0)) {
   if (!((i5 | 0) == (i2 | 0) & (i3 | 0) == (i7 | 0))) {
    d6 = d12;
    STACKTOP = i14;
    return +d6;
   }
   d6 = d12 * 0.0;
   STACKTOP = i14;
   return +d6;
  }
  if (!i1) {
   i3 = _bitshift64Shl(i8 | 0, i9 | 0, 12) | 0;
   i2 = tempRet0;
   if ((i2 | 0) > -1 | (i2 | 0) == -1 & i3 >>> 0 > 4294967295) {
    i1 = 0;
    do {
     i1 = i1 + -1 | 0;
     i3 = _bitshift64Shl(i3 | 0, i2 | 0, 1) | 0;
     i2 = tempRet0;
    } while ((i2 | 0) > -1 | (i2 | 0) == -1 & i3 >>> 0 > 4294967295);
   } else i1 = 0;
   i8 = _bitshift64Shl(i8 | 0, i9 | 0, 1 - i1 | 0) | 0;
   i7 = tempRet0;
  } else i7 = i9 & 1048575 | 1048576;
  if (!i4) {
   i3 = _bitshift64Shl(i10 | 0, i11 | 0, 12) | 0;
   i2 = tempRet0;
   if ((i2 | 0) > -1 | (i2 | 0) == -1 & i3 >>> 0 > 4294967295) {
    i4 = 0;
    do {
     i4 = i4 + -1 | 0;
     i3 = _bitshift64Shl(i3 | 0, i2 | 0, 1) | 0;
     i2 = tempRet0;
    } while ((i2 | 0) > -1 | (i2 | 0) == -1 & i3 >>> 0 > 4294967295);
   } else i4 = 0;
   i10 = _bitshift64Shl(i10 | 0, i11 | 0, 1 - i4 | 0) | 0;
   i11 = tempRet0;
  } else i11 = i11 & 1048575 | 1048576;
  i2 = _i64Subtract(i8 | 0, i7 | 0, i10 | 0, i11 | 0) | 0;
  i3 = tempRet0;
  i5 = (i3 | 0) > -1 | (i3 | 0) == -1 & i2 >>> 0 > 4294967295;
  L27 : do if ((i1 | 0) > (i4 | 0)) {
   while (1) {
    if (i5) {
     if ((i8 | 0) == (i10 | 0) & (i7 | 0) == (i11 | 0)) break;
    } else {
     i2 = i8;
     i3 = i7;
    }
    i8 = _bitshift64Shl(i2 | 0, i3 | 0, 1) | 0;
    i7 = tempRet0;
    i1 = i1 + -1 | 0;
    i2 = _i64Subtract(i8 | 0, i7 | 0, i10 | 0, i11 | 0) | 0;
    i3 = tempRet0;
    i5 = (i3 | 0) > -1 | (i3 | 0) == -1 & i2 >>> 0 > 4294967295;
    if ((i1 | 0) <= (i4 | 0)) break L27;
   }
   d6 = d12 * 0.0;
   STACKTOP = i14;
   return +d6;
  } while (0);
  if (i5) {
   if ((i8 | 0) == (i10 | 0) & (i7 | 0) == (i11 | 0)) {
    d6 = d12 * 0.0;
    STACKTOP = i14;
    return +d6;
   }
  } else {
   i3 = i7;
   i2 = i8;
  }
  if (i3 >>> 0 < 1048576 | (i3 | 0) == 1048576 & i2 >>> 0 < 0) do {
   i2 = _bitshift64Shl(i2 | 0, i3 | 0, 1) | 0;
   i3 = tempRet0;
   i1 = i1 + -1 | 0;
  } while (i3 >>> 0 < 1048576 | (i3 | 0) == 1048576 & i2 >>> 0 < 0);
  if ((i1 | 0) > 0) {
   i11 = _i64Add(i2 | 0, i3 | 0, 0, -1048576) | 0;
   i10 = tempRet0;
   i2 = _bitshift64Shl(i1 | 0, 0, 52) | 0;
   i1 = i10 | tempRet0;
   i2 = i11 | i2;
  } else {
   i2 = _bitshift64Lshr(i2 | 0, i3 | 0, 1 - i1 | 0) | 0;
   i1 = tempRet0;
  }
  HEAP32[tempDoublePtr >> 2] = i2;
  HEAP32[tempDoublePtr + 4 >> 2] = i1 | i13;
  d6 = +HEAPF64[tempDoublePtr >> 3];
  STACKTOP = i14;
  return +d6;
 }
 d6 = d12 * d6;
 d6 = d6 / d6;
 STACKTOP = i14;
 return +d6;
}
function __ZN2cvL6cmp32fEPKfjS1_jPhjNS_5Size_IiEEPv(i5, i3, i6, i4, i12, i16, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, f19 = f0;
 i17 = STACKTOP;
 i15 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = i3 >>> 2;
 i4 = i4 >>> 2;
 if ((i2 & -2 | 0) == 2) {
  i2 = (i2 | 0) == 2 ? 4 : 1;
  i11 = i6;
  i14 = i4;
  i4 = i3;
 } else {
  i11 = i5;
  i5 = i6;
  i14 = i3;
 }
 if ((i2 | 0) == 1 | (i2 | 0) == 4) {
  i7 = (i2 | 0) == 1 ? 0 : 255;
  if (!i13) {
   STACKTOP = i17;
   return;
  }
  i8 = i15 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i15 & -4;
  i1 = i12;
  i2 = i13;
  i6 = i11;
  while (1) {
   i2 = i2 + -1 | 0;
   if (i9) i3 = 0; else {
    i3 = 0;
    do {
     f19 = Math_fround(HEAPF32[i6 + (i3 << 2) >> 2]);
     i11 = (f19 > Math_fround(HEAPF32[i5 + (i3 << 2) >> 2])) << 31 >> 31 ^ i7;
     i13 = i3 | 1;
     f19 = Math_fround(HEAPF32[i6 + (i13 << 2) >> 2]);
     i18 = (f19 > Math_fround(HEAPF32[i5 + (i13 << 2) >> 2])) << 31 >> 31 ^ i7;
     HEAP8[i1 + i3 >> 0] = i11;
     HEAP8[i1 + i13 >> 0] = i18;
     i13 = i3 | 2;
     f19 = Math_fround(HEAPF32[i6 + (i13 << 2) >> 2]);
     i18 = (f19 > Math_fround(HEAPF32[i5 + (i13 << 2) >> 2])) << 31 >> 31 ^ i7;
     i11 = i3 | 3;
     f19 = Math_fround(HEAPF32[i6 + (i11 << 2) >> 2]);
     i12 = (f19 > Math_fround(HEAPF32[i5 + (i11 << 2) >> 2])) << 31 >> 31 ^ i7;
     HEAP8[i1 + i13 >> 0] = i18;
     HEAP8[i1 + i11 >> 0] = i12;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i8 | 0));
    i3 = i10;
   }
   if ((i3 | 0) < (i15 | 0)) do {
    f19 = Math_fround(HEAPF32[i6 + (i3 << 2) >> 2]);
    HEAP8[i1 + i3 >> 0] = (f19 > Math_fround(HEAPF32[i5 + (i3 << 2) >> 2])) << 31 >> 31 ^ i7;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i15 | 0));
   if (!i2) break; else {
    i1 = i1 + i16 | 0;
    i6 = i6 + (i14 << 2) | 0;
    i5 = i5 + (i4 << 2) | 0;
   }
  }
  STACKTOP = i17;
  return;
 }
 if (!((i2 | 0) == 0 | (i2 | 0) == 5)) {
  STACKTOP = i17;
  return;
 }
 i10 = (i2 | 0) == 0 ? 0 : 255;
 if (!i13) {
  STACKTOP = i17;
  return;
 }
 i9 = i15 + -4 | 0;
 i8 = (i9 | 0) < 0;
 i7 = i15 & -4;
 i1 = i12;
 i2 = i13;
 i6 = i11;
 while (1) {
  i2 = i2 + -1 | 0;
  if (i8) i3 = 0; else {
   i3 = 0;
   do {
    f19 = Math_fround(HEAPF32[i6 + (i3 << 2) >> 2]);
    i11 = (f19 == Math_fround(HEAPF32[i5 + (i3 << 2) >> 2])) << 31 >> 31 ^ i10;
    i13 = i3 | 1;
    f19 = Math_fround(HEAPF32[i6 + (i13 << 2) >> 2]);
    i18 = (f19 == Math_fround(HEAPF32[i5 + (i13 << 2) >> 2])) << 31 >> 31 ^ i10;
    HEAP8[i1 + i3 >> 0] = i11;
    HEAP8[i1 + i13 >> 0] = i18;
    i13 = i3 | 2;
    f19 = Math_fround(HEAPF32[i6 + (i13 << 2) >> 2]);
    i18 = (f19 == Math_fround(HEAPF32[i5 + (i13 << 2) >> 2])) << 31 >> 31 ^ i10;
    i11 = i3 | 3;
    f19 = Math_fround(HEAPF32[i6 + (i11 << 2) >> 2]);
    i12 = (f19 == Math_fround(HEAPF32[i5 + (i11 << 2) >> 2])) << 31 >> 31 ^ i10;
    HEAP8[i1 + i13 >> 0] = i18;
    HEAP8[i1 + i11 >> 0] = i12;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i9 | 0));
   i3 = i7;
  }
  if ((i3 | 0) < (i15 | 0)) do {
   f19 = Math_fround(HEAPF32[i6 + (i3 << 2) >> 2]);
   HEAP8[i1 + i3 >> 0] = (f19 == Math_fround(HEAPF32[i5 + (i3 << 2) >> 2])) << 31 >> 31 ^ i10;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i15 | 0));
  if (!i2) break; else {
   i1 = i1 + i16 | 0;
   i6 = i6 + (i14 << 2) | 0;
   i5 = i5 + (i4 << 2) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZNK2cv3Mat3dotERKNS_11_InputArrayE(i13, i5) {
 i13 = i13 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, d4 = 0.0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, d18 = 0.0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i16 = i17 + 64 | 0;
 i8 = i17 + 56 | 0;
 i9 = i17 + 40 | 0;
 i12 = i17 + 32 | 0;
 i11 = i17;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i5 >> 2] >> 2] & 63](i16, i5, -1);
 i3 = HEAP32[i13 >> 2] | 0;
 i10 = (i3 >>> 3 & 511) + 1 | 0;
 i7 = i3 & 7;
 i15 = HEAP32[37856 + (i7 << 2) >> 2] | 0;
 L1 : do if (((HEAP32[i16 >> 2] ^ i3) & 4095 | 0) == 0 ? (i2 = HEAP32[i16 + 40 >> 2] | 0, i1 = HEAP32[i2 + -4 >> 2] | 0, i6 = HEAP32[i13 + 40 >> 2] | 0, (i1 | 0) == (HEAP32[i6 + -4 >> 2] | 0)) : 0) {
  if ((i1 | 0) != 2) if ((i1 | 0) > 0) {
   i5 = 0;
   while (1) {
    if ((HEAP32[i2 + (i5 << 2) >> 2] | 0) != (HEAP32[i6 + (i5 << 2) >> 2] | 0)) {
     i14 = 10;
     break L1;
    }
    i5 = i5 + 1 | 0;
    if ((i5 | 0) >= (i1 | 0)) {
     i5 = 1;
     break;
    }
   }
  } else i5 = 1; else {
   if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i6 >> 2] | 0)) {
    i14 = 10;
    break;
   }
   i5 = (HEAP32[i2 + 4 >> 2] | 0) == (HEAP32[i6 + 4 >> 2] | 0);
  }
  if (!(i5 & (i7 | 0) != 7)) i14 = 10;
 } else i14 = 10; while (0);
 if ((i14 | 0) == 10) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i8, 53) | 0) + 0 | 0;
  i3 = 37792 | 0;
  i2 = i5 + 53 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i3 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i5 | 0) < (i2 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 37848, 37256, 3188);
  __ZN2cv6String10deallocateEv(i8);
  i3 = HEAP32[i13 >> 2] | 0;
 }
 if ((i3 & 16384 | 0) != 0 ? (HEAP32[i16 >> 2] & 16384 | 0) != 0 : 0) {
  i5 = HEAP32[i13 + 4 >> 2] | 0;
  if ((i5 | 0) < 3) i3 = Math_imul(HEAP32[i13 + 12 >> 2] | 0, HEAP32[i13 + 8 >> 2] | 0) | 0; else {
   i2 = HEAP32[i13 + 40 >> 2] | 0;
   i1 = 0;
   i3 = 1;
   do {
    i3 = Math_imul(HEAP32[i2 + (i1 << 2) >> 2] | 0, i3) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
  i11 = Math_imul(i3, i10) | 0;
  d4 = +FUNCTION_TABLE_diii[i15 & 7](HEAP32[i13 + 16 >> 2] | 0, HEAP32[i16 + 16 >> 2] | 0, i11);
 } else i14 = 18;
 L24 : do if ((i14 | 0) == 18) {
  HEAP32[i9 >> 2] = i13;
  HEAP32[i9 + 4 >> 2] = i16;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i11, i9, i12, -1);
  i3 = Math_imul(HEAP32[i11 + 20 >> 2] | 0, i10) | 0;
  i2 = i11 + 16 | 0;
  i1 = i12 + 4 | 0;
  i5 = 0;
  d4 = 0.0;
  while (1) {
   if (i5 >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) break L24;
   d18 = d4 + +FUNCTION_TABLE_diii[i15 & 7](HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, i3);
   __ZN2cv15NAryMatIteratorppEv(i11) | 0;
   i5 = i5 + 1 | 0;
   d4 = d18;
  }
 } while (0);
 i1 = i16 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i10 = i2 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i16);
 HEAP32[i1 >> 2] = 0;
 i11 = i16 + 16 | 0;
 i2 = i16 + 4 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i16 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i16 + 44 >> 2] | 0;
 if ((i1 | 0) == (i16 + 48 | 0)) {
  STACKTOP = i17;
  return +d4;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i17;
 return +d4;
}

function __ZN7testing8TestCase3RunEv(i18) {
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i14 = i19 + 16 | 0;
 i2 = i19 + 8 | 0;
 i15 = i19;
 if (!(HEAP8[i18 + 52 >> 0] | 0)) {
  STACKTOP = i19;
  return;
 }
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i10 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i10, 163728);
  HEAP32[40934] = i10;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i1 = HEAP32[40934] | 0;
 i16 = i1 + 104 | 0;
 HEAP32[i16 >> 2] = i18;
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i10 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i10, 163728);
  HEAP32[40934] = i10;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i17 = HEAP32[(HEAP32[40934] | 0) + 152 >> 2] | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] & 127](i17, i18);
 i12 = i1 + 164 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(12) | 0;
  HEAP32[i1 >> 2] = 165008;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i12 >> 2] = i1;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 511](i1);
 HEAP32[i2 >> 2] = 375;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i14 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN7testing8internal35HandleExceptionsInMethodIfSupportedINS_8TestCaseEvEET0_PT_MS4_FS3_vEPKc(i18, i14, 161976);
 _gettimeofday(i14 | 0, 0) | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 i5 = ((i4 | 0) < 0) << 31 >> 31;
 i6 = (HEAP32[i14 + 4 >> 2] | 0) / 1e3 | 0;
 i7 = ((i6 | 0) < 0) << 31 >> 31;
 i8 = i18 + 24 | 0;
 i9 = i18 + 20 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (((HEAP32[i8 >> 2] | 0) - i2 | 0) > 0) {
  i10 = i18 + 36 | 0;
  i11 = i18 + 32 | 0;
  i3 = 0;
  do {
   i1 = HEAP32[i11 >> 2] | 0;
   if (((HEAP32[i10 >> 2] | 0) - i1 >> 2 | 0) > (i3 | 0) ? (i13 = HEAP32[i1 + (i3 << 2) >> 2] | 0, (i13 | 0) >= 0) : 0) i2 = HEAP32[i2 + (i13 << 2) >> 2] | 0; else i2 = 0;
   __ZN7testing8TestInfo3RunEv(i2);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
  } while ((i3 | 0) < ((HEAP32[i8 >> 2] | 0) - i2 >> 2 | 0));
 }
 _gettimeofday(i14 | 0, 0) | 0;
 i9 = HEAP32[i14 >> 2] | 0;
 i9 = ___muldi3(i9 | 0, ((i9 | 0) < 0) << 31 >> 31 | 0, 1e3, 0) | 0;
 i1 = tempRet0;
 i10 = (HEAP32[i14 + 4 >> 2] | 0) / 1e3 | 0;
 i8 = ___muldi3(i4 | 0, i5 | 0, -1e3, -1) | 0;
 i8 = _i64Subtract(i8 | 0, tempRet0 | 0, i6 | 0, i7 | 0) | 0;
 i1 = _i64Add(i8 | 0, tempRet0 | 0, i9 | 0, i1 | 0) | 0;
 i10 = _i64Add(i1 | 0, tempRet0 | 0, i10 | 0, ((i10 | 0) < 0) << 31 >> 31 | 0) | 0;
 i1 = i18 + 56 | 0;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i1 + 4 >> 2] = tempRet0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(12) | 0;
  HEAP32[i1 >> 2] = 165008;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i12 >> 2] = i1;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 511](i1);
 HEAP32[i15 >> 2] = 376;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i14 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 __ZN7testing8internal35HandleExceptionsInMethodIfSupportedINS_8TestCaseEvEET0_PT_MS4_FS3_vEPKc(i18, i14, 161992);
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i17 >> 2] | 0) + 40 >> 2] & 127](i17, i18);
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i19;
 return;
}

function __ZL17icvXMLWriteStringP13CvFileStoragePKcS2_i(i11, i12, i9, i4) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 24624 | 0;
 i8 = i14;
 i10 = i14 + 24 | 0;
 i2 = i14 + 16 | 0;
 i1 = i14 + 8 | 0;
 if (!i9) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i2, 19) | 0) + 0 | 0;
  i5 = 16808;
  i6 = i3 + 19 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i3 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i2, 17216, 8960, 2503);
  __ZN2cv6String10deallocateEv(i2);
 }
 i7 = _strlen(i9 | 0) | 0;
 if ((i7 | 0) > 4096) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i1, 30) | 0) + 0 | 0;
  i5 = 16856;
  i6 = i3 + 30 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i3 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i1, 17216, 8960, 2507);
  __ZN2cv6String10deallocateEv(i1);
 }
 i2 = (i4 | 0) != 0 | (i7 | 0) == 0;
 if ((!i2 ? (HEAP8[i9 >> 0] | 0) == 34 : 0) ? (HEAP8[i9 + (i7 + -1) >> 0] | 0) == 34 : 0) {
  i10 = i7;
  __ZL17icvXMLWriteScalarP13CvFileStoragePKcS2_i(i11, i12, i9, i10);
  STACKTOP = i14;
  return;
 }
 i2 = i2 & 1;
 i1 = i10 + 1 | 0;
 HEAP8[i10 >> 0] = 34;
 if ((i7 | 0) > 0) {
  i6 = 0;
  do {
   i3 = HEAP8[i9 + i6 >> 0] | 0;
   i4 = i3 & 255;
   L15 : do if (i3 << 24 >> 24 < 0 | i3 << 24 >> 24 == 32) {
    HEAP8[i1 >> 0] = i3;
    i2 = 1;
   } else {
    L18 : do if ((i3 & 255) >= 32) {
     switch (i3 << 24 >> 24) {
     case 34:
     case 38:
     case 39:
     case 60:
     case 62:
      break L18;
     default:
      {}
     }
     HEAP8[i1 >> 0] = i3;
     break L15;
    } while (0);
    i2 = i1 + 1 | 0;
    HEAP8[i1 >> 0] = 38;
    switch (i3 << 24 >> 24) {
    case 39:
     {
      HEAP8[i2 >> 0] = 97;
      HEAP8[i2 + 1 >> 0] = 112;
      HEAP8[i2 + 2 >> 0] = 111;
      HEAP8[i2 + 3 >> 0] = 115;
      i1 = i1 + 5 | 0;
      break;
     }
    case 60:
     {
      HEAP8[i2 >> 0] = 108;
      HEAP8[i2 + 1 >> 0] = 116;
      i1 = i1 + 3 | 0;
      break;
     }
    case 34:
     {
      HEAP8[i2 >> 0] = 113;
      HEAP8[i2 + 1 >> 0] = 117;
      HEAP8[i2 + 2 >> 0] = 111;
      HEAP8[i2 + 3 >> 0] = 116;
      i1 = i1 + 5 | 0;
      break;
     }
    case 38:
     {
      HEAP8[i2 + 0 >> 0] = HEAP8[16184] | 0;
      HEAP8[i2 + 1 >> 0] = HEAP8[16185] | 0;
      HEAP8[i2 + 2 >> 0] = HEAP8[16186] | 0;
      i1 = i1 + 4 | 0;
      break;
     }
    case 62:
     {
      HEAP8[i2 >> 0] = 103;
      HEAP8[i2 + 1 >> 0] = 116;
      i1 = i1 + 3 | 0;
      break;
     }
    default:
     {
      HEAP32[i8 >> 2] = i4;
      _sprintf(i2, 17240, i8) | 0;
      i1 = i1 + 5 | 0;
     }
    }
    HEAP8[i1 >> 0] = 59;
    i2 = 1;
   } while (0);
   i1 = i1 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i7 | 0));
 }
 if (!i2) {
  i9 = HEAP8[i9 >> 0] | 0;
  if ((i9 + -48 << 24 >> 24 & 255) >= 10 ? !(i9 << 24 >> 24 == 46 | i9 << 24 >> 24 == 45 | i9 << 24 >> 24 == 43) : 0) i2 = 0; else {
   i2 = 1;
   i13 = 26;
  }
 } else i13 = 26;
 if ((i13 | 0) == 26) {
  HEAP8[i1 >> 0] = 34;
  i2 = (i2 | 0) != 0;
  i1 = i1 + 1 | 0;
 }
 i8 = i2 & 1 ^ 1;
 HEAP8[i1 >> 0] = 0;
 i9 = i10 + i8 | 0;
 i10 = i1 - i10 - i8 | 0;
 __ZL17icvXMLWriteScalarP13CvFileStoragePKcS2_i(i11, i12, i9, i10);
 STACKTOP = i14;
 return;
}

function __ZN2cvL8recip16uEPKtjS1_jPtjNS_5Size_IiEEPv(i1, i2, i8, i5, i7, i6, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var d9 = 0.0, d10 = 0.0, d11 = 0.0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, d20 = 0.0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, d28 = 0.0, d29 = 0.0;
 i23 = STACKTOP;
 i21 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 d20 = +HEAPF64[i4 >> 3];
 i19 = i5 >>> 1;
 i16 = i6 >>> 1;
 if (!i3) {
  STACKTOP = i23;
  return;
 }
 i17 = i21 + -4 | 0;
 i18 = (i17 | 0) < 0;
 i15 = (i17 | 0) > 3 ? i21 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i18) i4 = 0; else {
   i14 = 0;
   do {
    i4 = HEAP16[i8 + (i14 << 1) >> 1] | 0;
    i13 = i14 | 1;
    i5 = HEAP16[i8 + (i13 << 1) >> 1] | 0;
    do if (!(i4 << 16 >> 16)) {
     i12 = 0;
     i22 = 20;
    } else {
     i6 = i5 & 65535;
     if ((i5 << 16 >> 16 != 0 ? (i24 = i14 | 2, i25 = HEAP16[i8 + (i24 << 1) >> 1] | 0, i25 << 16 >> 16 != 0) : 0) ? (i26 = i14 | 3, i27 = HEAP16[i8 + (i26 << 1) >> 1] | 0, i27 << 16 >> 16 != 0) : 0) {
      d28 = +(i6 | 0);
      d29 = +(i4 & 65535) * d28;
      d10 = +(i27 & 65535 | 0);
      d9 = +(i25 & 65535) * d10;
      d11 = d20 / (d29 * d9);
      d9 = d9 * d11;
      d11 = d29 * d11;
      i6 = _lrint(d28 * d9) | 0;
      if (i6 >>> 0 < 65536) i2 = i6; else i2 = (i6 | 0) > 0 ? 65535 : 0;
      i6 = _lrint(+(i4 & 65535 | 0) * d9) | 0;
      if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
      i5 = _lrint(d10 * d11) | 0;
      if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
      i4 = _lrint(+(i25 & 65535 | 0) * d11) | 0;
      if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
      HEAP16[i7 + (i14 << 1) >> 1] = i2;
      HEAP16[i7 + (i13 << 1) >> 1] = i6;
      HEAP16[i7 + (i24 << 1) >> 1] = i5;
      HEAP16[i7 + (i26 << 1) >> 1] = i4;
      break;
     }
     i6 = _lrint(d20 / +(i4 & 65535 | 0)) | 0;
     if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
     i12 = i6 & 65535;
     i22 = 20;
    } while (0);
    if ((i22 | 0) == 20) {
     i22 = 0;
     if (!(i5 << 16 >> 16)) i2 = 0; else {
      i6 = _lrint(d20 / +(i5 & 65535 | 0)) | 0;
      if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
      i2 = i6 & 65535;
     }
     i1 = i14 | 2;
     i6 = HEAP16[i8 + (i1 << 1) >> 1] | 0;
     if (!(i6 << 16 >> 16)) i4 = 0; else {
      i6 = _lrint(d20 / +(i6 & 65535 | 0)) | 0;
      if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
      i4 = i6 & 65535;
     }
     i5 = i14 | 3;
     i6 = HEAP16[i8 + (i5 << 1) >> 1] | 0;
     if (!(i6 << 16 >> 16)) i6 = 0; else {
      i6 = _lrint(d20 / +(i6 & 65535 | 0)) | 0;
      if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
      i6 = i6 & 65535;
     }
     HEAP16[i7 + (i14 << 1) >> 1] = i12;
     HEAP16[i7 + (i13 << 1) >> 1] = i2;
     HEAP16[i7 + (i1 << 1) >> 1] = i4;
     HEAP16[i7 + (i5 << 1) >> 1] = i6;
    }
    i14 = i14 + 4 | 0;
   } while ((i14 | 0) <= (i17 | 0));
   i4 = i15;
  }
  if ((i4 | 0) < (i21 | 0)) do {
   i5 = HEAP16[i8 + (i4 << 1) >> 1] | 0;
   if (!(i5 << 16 >> 16)) i5 = 0; else {
    i5 = _lrint(d20 / +(i5 & 65535 | 0)) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i5 = i5 & 65535;
   }
   HEAP16[i7 + (i4 << 1) >> 1] = i5;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i21 | 0));
  if (!i3) break; else {
   i7 = i7 + (i16 << 1) | 0;
   i8 = i8 + (i19 << 1) | 0;
  }
 }
 STACKTOP = i23;
 return;
}

function __ZNK2cv4UMat6getMatEi(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i5 = i10 + 56 | 0;
 i9 = i10;
 i6 = i7 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i8 >> 2] = 1124007936;
  i2 = i8 + 8 | 0;
  i1 = i8 + 40 | 0;
  i4 = i8 + 4 | 0;
  i3 = i4 + 36 | 0;
  do {
   HEAP32[i4 >> 2] = 0;
   i4 = i4 + 4 | 0;
  } while ((i4 | 0) < (i3 | 0));
  HEAP32[i1 >> 2] = i2;
  i1 = i8 + 48 | 0;
  HEAP32[i8 + 44 >> 2] = i1;
  HEAP32[i8 + 52 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 FUNCTION_TABLE_viii[HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] & 63](i3, i2, i1 | 16777216);
 i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
 if (!i2) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i5, 12) | 0) + 0 | 0;
  i2 = 18072 | 0;
  i3 = i4 + 12 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i4 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 18088, 17672, 580);
  __ZN2cv6String10deallocateEv(i5);
  i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
 }
 i4 = i7 + 28 | 0;
 __ZN2cv3MatC2EiPKiiPvPKj(i9, HEAP32[i7 + 4 >> 2] | 0, HEAP32[i7 + 32 >> 2] | 0, HEAP32[i7 >> 2] & 4095, i2 + (HEAP32[i4 >> 2] | 0) | 0, HEAP32[i7 + 36 >> 2] | 0);
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 i3 = HEAP32[i6 >> 2] | 0;
 i5 = i9 + 36 | 0;
 HEAP32[i5 >> 2] = i3;
 i7 = HEAP32[i3 + 16 >> 2] | 0;
 i12 = i9 + 20 | 0;
 HEAP32[i12 >> 2] = i7;
 i6 = i9 + 16 | 0;
 HEAP32[i6 >> 2] = i7 + (HEAP32[i4 >> 2] | 0);
 i7 = i7 + (HEAP32[i3 + 24 >> 2] | 0) | 0;
 i4 = i9 + 24 | 0;
 HEAP32[i4 >> 2] = i7;
 i1 = i9 + 28 | 0;
 HEAP32[i1 >> 2] = i7;
 i3 = i3 + 12 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i3 = i8 + 4 | 0;
 i7 = i9 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 i11 = i8 + 8 | 0;
 HEAP32[i11 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 32 >> 2] = HEAP32[i9 + 32 >> 2];
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 + 36 >> 2] = i1;
 HEAP32[i8 + 40 >> 2] = i11;
 i11 = i8 + 48 | 0;
 i4 = i8 + 44 | 0;
 HEAP32[i4 >> 2] = i11;
 HEAP32[i8 + 52 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 if (i1) {
  i2 = i1 + 12 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i2 | 0) < 3) {
  i3 = HEAP32[i9 + 44 >> 2] | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 } else {
  HEAP32[i3 >> 2] = 0;
  __ZN2cv3Mat8copySizeERKS0_(i8, i9);
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i4 = i2 + 12 | 0, i8 = HEAP32[i4 >> 2] | 0, HEAP32[i4 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i9);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 if ((HEAP32[i7 >> 2] | 0) > 0) {
  i1 = HEAP32[i9 + 40 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i7 >> 2] | 0));
 }
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 if ((i1 | 0) == (i9 + 48 | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i10;
 return;
}
function __ZNSt3__1L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i2, i8, i9, i3, i4, i10, i7, i1) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i11 = 0;
 i11 = STACKTOP;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 do if (i1 & 2) if ((i4 - i3 | 0) < 3) {
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 } else {
  HEAP32[i10 >> 2] = i3 + 1;
  HEAP8[i3 >> 0] = -17;
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i6 + 1;
  HEAP8[i6 >> 0] = -69;
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i6 + 1;
  HEAP8[i6 >> 0] = -65;
  break;
 } while (0);
 i6 = i8;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 >= i8 >>> 0) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 L10 : while (1) {
  i3 = HEAP16[i2 >> 1] | 0;
  i5 = i3 & 65535;
  if (i5 >>> 0 > i7 >>> 0) {
   i1 = 2;
   i2 = 26;
   break;
  }
  do if ((i3 & 65535) < 128) {
   i2 = HEAP32[i10 >> 2] | 0;
   if ((i4 - i2 | 0) < 1) {
    i1 = 1;
    i2 = 26;
    break L10;
   }
   HEAP32[i10 >> 2] = i2 + 1;
   HEAP8[i2 >> 0] = i3;
  } else {
   if ((i3 & 65535) < 2048) {
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 - i2 | 0) < 2) {
     i1 = 1;
     i2 = 26;
     break L10;
    }
    HEAP32[i10 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i5 >>> 6 | 192;
    i3 = HEAP32[i10 >> 2] | 0;
    HEAP32[i10 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i5 & 63 | 128;
    break;
   }
   if ((i3 & 65535) < 55296) {
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 - i2 | 0) < 3) {
     i1 = 1;
     i2 = 26;
     break L10;
    }
    HEAP32[i10 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i5 >>> 12 | 224;
    i3 = HEAP32[i10 >> 2] | 0;
    HEAP32[i10 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i5 >>> 6 & 63 | 128;
    i3 = HEAP32[i10 >> 2] | 0;
    HEAP32[i10 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i5 & 63 | 128;
    break;
   }
   if ((i3 & 65535) >= 56320) {
    if ((i3 & 65535) < 57344) {
     i1 = 2;
     i2 = 26;
     break L10;
    }
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 - i2 | 0) < 3) {
     i1 = 1;
     i2 = 26;
     break L10;
    }
    HEAP32[i10 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i5 >>> 12 | 224;
    i3 = HEAP32[i10 >> 2] | 0;
    HEAP32[i10 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i5 >>> 6 & 63 | 128;
    i3 = HEAP32[i10 >> 2] | 0;
    HEAP32[i10 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i5 & 63 | 128;
    break;
   }
   if ((i6 - i2 | 0) < 4) {
    i1 = 1;
    i2 = 26;
    break L10;
   }
   i3 = i2 + 2 | 0;
   i2 = HEAPU16[i3 >> 1] | 0;
   if ((i2 & 64512 | 0) != 56320) {
    i1 = 2;
    i2 = 26;
    break L10;
   }
   if ((i4 - (HEAP32[i10 >> 2] | 0) | 0) < 4) {
    i1 = 1;
    i2 = 26;
    break L10;
   }
   i1 = i5 & 960;
   if (((i1 << 10) + 65536 | i5 << 10 & 64512 | i2 & 1023) >>> 0 > i7 >>> 0) {
    i1 = 2;
    i2 = 26;
    break L10;
   }
   HEAP32[i9 >> 2] = i3;
   i1 = (i1 >>> 6) + 1 | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = i3 + 1;
   HEAP8[i3 >> 0] = i1 >>> 2 | 240;
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = i3 + 1;
   HEAP8[i3 >> 0] = i5 >>> 2 & 15 | i1 << 4 & 48 | 128;
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = i3 + 1;
   HEAP8[i3 >> 0] = i5 << 4 & 48 | i2 >>> 6 & 15 | 128;
   i5 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = i5 + 1;
   HEAP8[i5 >> 0] = i2 & 63 | 128;
  } while (0);
  i2 = (HEAP32[i9 >> 2] | 0) + 2 | 0;
  HEAP32[i9 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) {
   i1 = 0;
   i2 = 26;
   break;
  }
 }
 if ((i2 | 0) == 26) {
  STACKTOP = i11;
  return i1 | 0;
 }
 return 0;
}

function __GLOBAL__I_a1585() {
 var i1 = 0;
 i1 = STACKTOP;
 __ZN2cv3ocl13ProgramSourceC2EPKc(704272, 702224);
 ___cxa_atexit(363, 704272, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(706872, 704280);
 ___cxa_atexit(363, 706872, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(708440, 706880);
 ___cxa_atexit(363, 708440, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(713184, 708448);
 ___cxa_atexit(363, 713184, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(715840, 713192);
 ___cxa_atexit(363, 715840, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(724360, 715848);
 ___cxa_atexit(363, 724360, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(728848, 724368);
 ___cxa_atexit(363, 728848, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(733944, 728856);
 ___cxa_atexit(363, 733944, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(741432, 733952);
 ___cxa_atexit(363, 741432, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(795256, 741440);
 ___cxa_atexit(363, 795256, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(800152, 795264);
 ___cxa_atexit(363, 800152, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(808600, 800160);
 ___cxa_atexit(363, 808600, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(810968, 808608);
 ___cxa_atexit(363, 810968, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(821232, 810976);
 ___cxa_atexit(363, 821232, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(825016, 821240);
 ___cxa_atexit(363, 825016, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(835936, 825024);
 ___cxa_atexit(363, 835936, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(838808, 835944);
 ___cxa_atexit(363, 838808, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(842464, 838816);
 ___cxa_atexit(363, 842464, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(850224, 842472);
 ___cxa_atexit(363, 850224, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(854816, 850232);
 ___cxa_atexit(363, 854816, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(859560, 854824);
 ___cxa_atexit(363, 859560, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(876536, 859568);
 ___cxa_atexit(363, 876536, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(888920, 876544);
 ___cxa_atexit(363, 888920, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(893296, 888928);
 ___cxa_atexit(363, 893296, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(897336, 893304);
 ___cxa_atexit(363, 897336, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(898712, 897344);
 ___cxa_atexit(363, 898712, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(906376, 898720);
 ___cxa_atexit(363, 906376, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(912272, 906384);
 ___cxa_atexit(363, 912272, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(929016, 912280);
 ___cxa_atexit(363, 929016, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(937408, 929024);
 ___cxa_atexit(363, 937408, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(938648, 937416);
 ___cxa_atexit(363, 938648, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(949880, 938656);
 ___cxa_atexit(363, 949880, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(956056, 949888);
 ___cxa_atexit(363, 956056, ___dso_handle | 0) | 0;
 STACKTOP = i1;
 return;
}

function _cvWrite(i13, i14, i15, i12) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i16 = i17 + 48 | 0;
 i1 = i17 + 40 | 0;
 i3 = i17 + 32 | 0;
 i4 = i17 + 24 | 0;
 i8 = i17 + 16 | 0;
 i10 = i17 + 8 | 0;
 i11 = i17;
 i2 = (i13 | 0) != 0;
 if (!(i2 ? (HEAP32[i13 >> 2] | 0) == 1280131417 : 0)) {
  i2 = i2 ? -5 : -27;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i1, 31) | 0) + 0 | 0;
  i6 = 9096 | 0;
  i7 = i5 + 31 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i2, i1, 11192, 8960, 4976);
  __ZN2cv6String10deallocateEv(i1);
 }
 if (!(HEAP32[i13 + 8 >> 2] | 0)) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i3, 38) | 0) + 0 | 0;
  i6 = 9944 | 0;
  i7 = i5 + 38 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i3, 11192, 8960, 4976);
  __ZN2cv6String10deallocateEv(i3);
 }
 L9 : do if (i15) {
  i1 = HEAP32[2644] | 0;
  if (!i1) i9 = 11; else while (1) {
   if (FUNCTION_TABLE_ii[HEAP32[i1 + 20 >> 2] & 127](i15) | 0) break L9;
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   if (!i1) {
    i9 = 11;
    break;
   }
  }
 } else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i4, 34) | 0) + 0 | 0;
  i6 = 11200 | 0;
  i7 = i5 + 34 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i4, 11192, 8960, 4979);
  __ZN2cv6String10deallocateEv(i4);
  i9 = 11;
 } while (0);
 if ((i9 | 0) == 11) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i8, 14) | 0) + 0 | 0;
  i6 = 11240 | 0;
  i7 = i5 + 14 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i8, 11192, 8960, 4983);
  __ZN2cv6String10deallocateEv(i8);
  i1 = 0;
 }
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1) {
  i10 = i1;
  i8 = i12;
  i6 = i8;
  i6 = HEAP32[i6 >> 2] | 0;
  i8 = i8 + 4 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i9 = i11;
  i7 = i9;
  HEAP32[i7 >> 2] = i6;
  i9 = i9 + 4 | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i16 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  FUNCTION_TABLE_viiii[i10 & 63](i13, i14, i15, i16);
  STACKTOP = i17;
  return;
 }
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i5 = (__ZN2cv6String8allocateEj(i10, 39) | 0) + 0 | 0;
 i6 = 11256 | 0;
 i7 = i5 + 39 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i6 = i6 + 1 | 0;
 } while ((i5 | 0) < (i7 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i10, 11192, 8960, 4986);
 __ZN2cv6String10deallocateEv(i10);
 i10 = HEAP32[i2 >> 2] | 0;
 i8 = i12;
 i6 = i8;
 i6 = HEAP32[i6 >> 2] | 0;
 i8 = i8 + 4 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i9 = i11;
 i7 = i9;
 HEAP32[i7 >> 2] = i6;
 i9 = i9 + 4 | 0;
 HEAP32[i9 >> 2] = i8;
 HEAP32[i16 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 FUNCTION_TABLE_viiii[i10 & 63](i13, i14, i15, i16);
 STACKTOP = i17;
 return;
}

function __ZN2cvL11randBits_8sEPaiPyPKNS_3VecIiLi2EEEb(i9, i10, i12, i11, i4) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 i13 = STACKTOP;
 i1 = i12;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i10 + -4 | 0;
 i3 = (i8 | 0) < 0;
 if (i4) if (i3) i3 = 0; else {
  i7 = 0;
  do {
   i3 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i3 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i1 = tempRet0;
   i3 = (i2 & HEAP32[i11 + (i7 << 3) >> 2]) + (HEAP32[i11 + (i7 << 3) + 4 >> 2] | 0) | 0;
   i5 = i7 | 1;
   i4 = (i2 >> 8 & HEAP32[i11 + (i5 << 3) >> 2]) + (HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0) | 0;
   if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
   HEAP8[i9 + i7 >> 0] = i3;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i9 + i5 >> 0] = i4;
   i5 = i7 | 2;
   i3 = (HEAP32[i11 + (i5 << 3) >> 2] & i2 >> 16) + (HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0) | 0;
   i6 = i7 | 3;
   i4 = (HEAP32[i11 + (i6 << 3) >> 2] & i2 >> 24) + (HEAP32[i11 + (i6 << 3) + 4 >> 2] | 0) | 0;
   if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
   HEAP8[i9 + i5 >> 0] = i3;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i9 + i6 >> 0] = i4;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) <= (i8 | 0));
  i3 = i10 & -4;
 } else if (i3) i3 = 0; else {
  i7 = 0;
  do {
   i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i5 = tempRet0;
   i3 = (i2 & HEAP32[i11 + (i7 << 3) >> 2]) + (HEAP32[i11 + (i7 << 3) + 4 >> 2] | 0) | 0;
   i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i5 = _i64Add(i2 | 0, tempRet0 | 0, i5 | 0, 0) | 0;
   i2 = tempRet0;
   i1 = i7 | 1;
   i4 = (i5 & HEAP32[i11 + (i1 << 3) >> 2]) + (HEAP32[i11 + (i1 << 3) + 4 >> 2] | 0) | 0;
   if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
   HEAP8[i9 + i7 >> 0] = i3;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i9 + i1 >> 0] = i4;
   i1 = ___muldi3(i5 | 0, 0, -130063606, 0) | 0;
   i1 = _i64Add(i1 | 0, tempRet0 | 0, i2 | 0, 0) | 0;
   i2 = tempRet0;
   i5 = i7 | 2;
   i3 = (HEAP32[i11 + (i5 << 3) >> 2] & i1) + (HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0) | 0;
   i1 = ___muldi3(i1 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i1 | 0, tempRet0 | 0, i2 | 0, 0) | 0;
   i1 = tempRet0;
   i6 = i7 | 3;
   i4 = (HEAP32[i11 + (i6 << 3) >> 2] & i2) + (HEAP32[i11 + (i6 << 3) + 4 >> 2] | 0) | 0;
   if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
   HEAP8[i9 + i5 >> 0] = i3;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i9 + i6 >> 0] = i4;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) <= (i8 | 0));
  i3 = i10 & -4;
 }
 if ((i3 | 0) < (i10 | 0)) i4 = i3; else {
  i7 = i2;
  i9 = i1;
  i10 = i12;
  i8 = i10;
  HEAP32[i8 >> 2] = i7;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i13;
  return;
 }
 do {
  i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
  i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  i3 = (i2 & HEAP32[i11 + (i4 << 3) >> 2]) + (HEAP32[i11 + (i4 << 3) + 4 >> 2] | 0) | 0;
  if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
  HEAP8[i9 + i4 >> 0] = i3;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i10 | 0));
 i10 = i12;
 i9 = i10;
 HEAP32[i9 >> 2] = i2;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i13;
 return;
}

function __ZN2cvL5mul8uEPKhjS1_jPhjNS_5Size_IiEEPv(i4, i17, i5, i18, i3, i16, i2, i1) {
 i4 = i4 | 0;
 i17 = i17 | 0;
 i5 = i5 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 i16 = i16 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i19 = 0, f20 = f0;
 i19 = STACKTOP;
 f14 = Math_fround(+HEAPF64[i1 >> 3]);
 i15 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = i1 + -1 | 0;
 i1 = (i1 | 0) == 0;
 if (f14 == Math_fround(1.0)) {
  if (i1) {
   STACKTOP = i19;
   return;
  }
  i6 = i15 + -4 | 0;
  i7 = (i6 | 0) < 0;
  i8 = i15 & -4;
  i1 = i2;
  while (1) {
   if (i7) i2 = 0; else {
    i2 = 0;
    do {
     i10 = Math_imul(HEAPU8[i5 + i2 >> 0] | 0, HEAPU8[i4 + i2 >> 0] | 0) | 0;
     i11 = i2 | 1;
     i12 = Math_imul(HEAPU8[i5 + i11 >> 0] | 0, HEAPU8[i4 + i11 >> 0] | 0) | 0;
     HEAP8[i3 + i2 >> 0] = i10 >>> 0 > 255 ? -1 : i10 & 255;
     HEAP8[i3 + i11 >> 0] = i12 >>> 0 > 255 ? -1 : i12 & 255;
     i11 = i2 | 2;
     i12 = Math_imul(HEAPU8[i5 + i11 >> 0] | 0, HEAPU8[i4 + i11 >> 0] | 0) | 0;
     i10 = i2 | 3;
     i9 = Math_imul(HEAPU8[i5 + i10 >> 0] | 0, HEAPU8[i4 + i10 >> 0] | 0) | 0;
     HEAP8[i3 + i11 >> 0] = i12 >>> 0 > 255 ? -1 : i12 & 255;
     HEAP8[i3 + i10 >> 0] = i9 >>> 0 > 255 ? -1 : i9 & 255;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) <= (i6 | 0));
    i2 = i8;
   }
   if ((i2 | 0) < (i15 | 0)) do {
    i10 = Math_imul(HEAPU8[i5 + i2 >> 0] | 0, HEAPU8[i4 + i2 >> 0] | 0) | 0;
    HEAP8[i3 + i2 >> 0] = i10 >>> 0 > 255 ? -1 : i10 & 255;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i15 | 0));
   if (!i1) break; else {
    i5 = i5 + i18 | 0;
    i4 = i4 + i17 | 0;
    i3 = i3 + i16 | 0;
    i1 = i1 + -1 | 0;
   }
  }
  STACKTOP = i19;
  return;
 }
 if (i1) {
  STACKTOP = i19;
  return;
 }
 i12 = i15 + -4 | 0;
 i13 = (i12 | 0) < 0;
 i11 = i15 & -4;
 i10 = i2;
 while (1) {
  if (i13) i2 = 0; else {
   i9 = 0;
   do {
    f20 = Math_fround(f14 * Math_fround(HEAPU8[i4 + i9 >> 0] | 0));
    i2 = _lrint(+Math_fround(f20 * Math_fround(HEAPU8[i5 + i9 >> 0] | 0 | 0))) | 0;
    if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
    i6 = i9 | 1;
    f20 = Math_fround(f14 * Math_fround(HEAPU8[i4 + i6 >> 0] | 0));
    i1 = _lrint(+Math_fround(f20 * Math_fround(HEAPU8[i5 + i6 >> 0] | 0 | 0))) | 0;
    if (i1 >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 255 : 0;
    HEAP8[i3 + i9 >> 0] = i2;
    HEAP8[i3 + i6 >> 0] = i1;
    i7 = i9 | 2;
    f20 = Math_fround(f14 * Math_fround(HEAPU8[i4 + i7 >> 0] | 0));
    i2 = _lrint(+Math_fround(f20 * Math_fround(HEAPU8[i5 + i7 >> 0] | 0 | 0))) | 0;
    if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
    i8 = i9 | 3;
    f20 = Math_fround(f14 * Math_fround(HEAPU8[i4 + i8 >> 0] | 0));
    i1 = _lrint(+Math_fround(f20 * Math_fround(HEAPU8[i5 + i8 >> 0] | 0 | 0))) | 0;
    if (i1 >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 255 : 0;
    HEAP8[i3 + i7 >> 0] = i2;
    HEAP8[i3 + i8 >> 0] = i1;
    i9 = i9 + 4 | 0;
   } while ((i9 | 0) <= (i12 | 0));
   i2 = i11;
  }
  if ((i2 | 0) < (i15 | 0)) do {
   f20 = Math_fround(f14 * Math_fround(HEAPU8[i4 + i2 >> 0] | 0));
   i1 = _lrint(+Math_fround(f20 * Math_fround(HEAPU8[i5 + i2 >> 0] | 0 | 0))) | 0;
   if (i1 >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 255 : 0;
   HEAP8[i3 + i2 >> 0] = i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i15 | 0));
  if (!i10) break; else {
   i5 = i5 + i18 | 0;
   i4 = i4 + i17 | 0;
   i3 = i3 + i16 | 0;
   i10 = i10 + -1 | 0;
  }
 }
 STACKTOP = i19;
 return;
}

function __ZN4perf10Regression22getCurrentTestNodeNameEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i10 = i11 + 24 | 0;
 i4 = i11 + 12 | 0;
 i3 = i11;
 i7 = __ZNK7testing8UnitTest17current_test_infoEv(__ZN7testing8UnitTest11GetInstanceEv() | 0) | 0;
 if (!i7) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, 170048, 9);
  STACKTOP = i11;
  return;
 }
 if (!(HEAP8[i7 >> 0] & 1)) i1 = i7 + 1 | 0; else i1 = HEAP32[i7 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i1, _strlen(i1 | 0) | 0);
 HEAP32[i4 + 0 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = HEAP8[i3 >> 0] | 0;
 if (!(i1 & 1)) {
  i1 = (i1 & 255) >>> 1;
  i2 = i3 + 1 | 0;
 } else {
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i2 = HEAP32[i3 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i4, i2, i1, i1 + 2 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i4, 170064, 2) | 0;
 i1 = i7 + 12 | 0;
 if (!(HEAP8[i1 >> 0] & 1)) i6 = i1 + 1 | 0; else i6 = HEAP32[i7 + 20 >> 2] | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i2 = HEAP8[i4 >> 0] | 0;
 if (!(i2 & 1)) {
  i5 = _strlen(i6 | 0) | 0;
  i2 = (i2 & 255) >>> 1;
  i1 = i4 + 1 | 0;
 } else {
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = _strlen(i6 | 0) | 0;
  i1 = HEAP32[i4 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, i1, i2, i2 + i5 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, i6, i5) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
 i1 = __ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i10, 47, 0) | 0;
 if ((i1 | 0) != -1) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i10, i1, -1) | 0;
 i1 = HEAP32[i7 + 24 >> 2] | 0;
 do if (i1) {
  if (HEAP8[i1 >> 0] & 1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i1) break;
  } else i1 = i1 + 1 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i10, 170064) | 0, i1) | 0;
 } while (0);
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 do if (i1) {
  if (HEAP8[i1 >> 0] & 1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i1) break;
  } else i1 = i1 + 1 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i10, 170064) | 0, i1) | 0;
 } while (0);
 i1 = i10 + 1 | 0;
 i3 = i10 + 8 | 0;
 i4 = i10 + 4 | 0;
 i6 = 0;
 while (1) {
  i2 = HEAP8[i10 >> 0] | 0;
  i5 = (i2 & 1) == 0;
  if (i5) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i4 >> 2] | 0;
  if (i6 >>> 0 >= i2 >>> 0) break;
  if ((_isalnum(HEAP8[(i5 ? i1 : HEAP32[i3 >> 2] | 0) + i6 >> 0] | 0) | 0) == 0 ? (i8 = (HEAP8[i10 >> 0] & 1) == 0, (HEAP8[(i8 ? i1 : HEAP32[i3 >> 2] | 0) + i6 >> 0] | 0) != 95) : 0) HEAP8[(i8 ? i1 : HEAP32[i3 >> 2] | 0) + i6 >> 0] = 45;
  i6 = i6 + 1 | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i9, i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
 STACKTOP = i11;
 return;
}

function __ZN2cvL7recip8sEPKajS1_jPajNS_5Size_IiEEPv(i1, i2, i6, i29, i5, i28, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i29 = i29 | 0;
 i5 = i5 | 0;
 i28 = i28 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, d30 = 0.0, d31 = 0.0;
 i23 = STACKTOP;
 i21 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 d17 = +HEAPF64[i4 >> 3];
 if (!i3) {
  STACKTOP = i23;
  return;
 }
 i18 = i21 + -4 | 0;
 i19 = (i18 | 0) < 0;
 i20 = i21 & -4;
 i16 = i3;
 while (1) {
  i16 = i16 + -1 | 0;
  if (i19) i4 = 0; else {
   i15 = 0;
   do {
    i4 = HEAP8[i6 + i15 >> 0] | 0;
    i14 = i15 | 1;
    i3 = HEAP8[i6 + i14 >> 0] | 0;
    do if (!(i4 << 24 >> 24)) {
     i13 = 0;
     i22 = 20;
    } else {
     if ((i3 << 24 >> 24 != 0 ? (i24 = i15 | 2, i25 = HEAP8[i6 + i24 >> 0] | 0, i25 << 24 >> 24 != 0) : 0) ? (i26 = i15 | 3, i27 = HEAP8[i6 + i26 >> 0] | 0, i27 << 24 >> 24 != 0) : 0) {
      d8 = +(i4 << 24 >> 24);
      d30 = +(i3 << 24 >> 24);
      d31 = d8 * d30;
      d10 = +(i25 << 24 >> 24);
      d9 = +(i27 << 24 >> 24);
      d7 = d10 * d9;
      d11 = d17 / (d31 * d7);
      d7 = d7 * d11;
      d11 = d31 * d11;
      i4 = _lrint(d30 * d7) | 0;
      if ((i4 + 128 | 0) >>> 0 < 256) i1 = i4; else i1 = (i4 | 0) > 0 ? 127 : -128;
      i4 = _lrint(d8 * d7) | 0;
      if ((i4 + 128 | 0) >>> 0 < 256) i2 = i4; else i2 = (i4 | 0) > 0 ? 127 : -128;
      i4 = _lrint(d9 * d11) | 0;
      if ((i4 + 128 | 0) >>> 0 < 256) i3 = i4; else i3 = (i4 | 0) > 0 ? 127 : -128;
      i4 = _lrint(d10 * d11) | 0;
      if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
      HEAP8[i5 + i15 >> 0] = i1;
      HEAP8[i5 + i14 >> 0] = i2;
      HEAP8[i5 + i24 >> 0] = i3;
      HEAP8[i5 + i26 >> 0] = i4;
      break;
     }
     i4 = _lrint(d17 / +(i4 << 24 >> 24)) | 0;
     if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
     i13 = i4 & 255;
     i22 = 20;
    } while (0);
    if ((i22 | 0) == 20) {
     i22 = 0;
     if (!(i3 << 24 >> 24)) i1 = 0; else {
      i4 = _lrint(d17 / +(i3 << 24 >> 24)) | 0;
      if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
      i1 = i4 & 255;
     }
     i12 = i15 | 2;
     i4 = HEAP8[i6 + i12 >> 0] | 0;
     if (!(i4 << 24 >> 24)) i3 = 0; else {
      i4 = _lrint(d17 / +(i4 << 24 >> 24)) | 0;
      if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
      i3 = i4 & 255;
     }
     i2 = i15 | 3;
     i4 = HEAP8[i6 + i2 >> 0] | 0;
     if (!(i4 << 24 >> 24)) i4 = 0; else {
      i4 = _lrint(d17 / +(i4 << 24 >> 24)) | 0;
      if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
      i4 = i4 & 255;
     }
     HEAP8[i5 + i15 >> 0] = i13;
     HEAP8[i5 + i14 >> 0] = i1;
     HEAP8[i5 + i12 >> 0] = i3;
     HEAP8[i5 + i2 >> 0] = i4;
    }
    i15 = i15 + 4 | 0;
   } while ((i15 | 0) <= (i18 | 0));
   i4 = i20;
  }
  if ((i4 | 0) < (i21 | 0)) do {
   i3 = HEAP8[i6 + i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) i3 = 0; else {
    i3 = _lrint(d17 / +(i3 << 24 >> 24)) | 0;
    if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
    i3 = i3 & 255;
   }
   HEAP8[i5 + i4 >> 0] = i3;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i21 | 0));
  if (!i16) break; else {
   i5 = i5 + i28 | 0;
   i6 = i6 + i29 | 0;
  }
 }
 STACKTOP = i23;
 return;
}

function __ZN2cvL12randBits_16uEPtiPyPKNS_3VecIiLi2EEEb(i9, i10, i12, i11, i4) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 i13 = STACKTOP;
 i1 = i12;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i10 + -4 | 0;
 i3 = (i8 | 0) < 0;
 if (i4) if (i3) i3 = 0; else {
  i7 = 0;
  do {
   i3 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i3 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i1 = tempRet0;
   i3 = (i2 & HEAP32[i11 + (i7 << 3) >> 2]) + (HEAP32[i11 + (i7 << 3) + 4 >> 2] | 0) | 0;
   i5 = i7 | 1;
   i4 = (i2 >> 8 & HEAP32[i11 + (i5 << 3) >> 2]) + (HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0) | 0;
   if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
   HEAP16[i9 + (i7 << 1) >> 1] = i3;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i9 + (i5 << 1) >> 1] = i4;
   i5 = i7 | 2;
   i3 = (HEAP32[i11 + (i5 << 3) >> 2] & i2 >> 16) + (HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0) | 0;
   i6 = i7 | 3;
   i4 = (HEAP32[i11 + (i6 << 3) >> 2] & i2 >> 24) + (HEAP32[i11 + (i6 << 3) + 4 >> 2] | 0) | 0;
   if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
   HEAP16[i9 + (i5 << 1) >> 1] = i3;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i9 + (i6 << 1) >> 1] = i4;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) <= (i8 | 0));
  i3 = i10 & -4;
 } else if (i3) i3 = 0; else {
  i7 = 0;
  do {
   i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i5 = tempRet0;
   i3 = (i2 & HEAP32[i11 + (i7 << 3) >> 2]) + (HEAP32[i11 + (i7 << 3) + 4 >> 2] | 0) | 0;
   i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i5 = _i64Add(i2 | 0, tempRet0 | 0, i5 | 0, 0) | 0;
   i2 = tempRet0;
   i1 = i7 | 1;
   i4 = (i5 & HEAP32[i11 + (i1 << 3) >> 2]) + (HEAP32[i11 + (i1 << 3) + 4 >> 2] | 0) | 0;
   if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
   HEAP16[i9 + (i7 << 1) >> 1] = i3;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i9 + (i1 << 1) >> 1] = i4;
   i1 = ___muldi3(i5 | 0, 0, -130063606, 0) | 0;
   i1 = _i64Add(i1 | 0, tempRet0 | 0, i2 | 0, 0) | 0;
   i2 = tempRet0;
   i5 = i7 | 2;
   i3 = (HEAP32[i11 + (i5 << 3) >> 2] & i1) + (HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0) | 0;
   i1 = ___muldi3(i1 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i1 | 0, tempRet0 | 0, i2 | 0, 0) | 0;
   i1 = tempRet0;
   i6 = i7 | 3;
   i4 = (HEAP32[i11 + (i6 << 3) >> 2] & i2) + (HEAP32[i11 + (i6 << 3) + 4 >> 2] | 0) | 0;
   if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
   HEAP16[i9 + (i5 << 1) >> 1] = i3;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i9 + (i6 << 1) >> 1] = i4;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) <= (i8 | 0));
  i3 = i10 & -4;
 }
 if ((i3 | 0) < (i10 | 0)) i4 = i3; else {
  i7 = i2;
  i9 = i1;
  i10 = i12;
  i8 = i10;
  HEAP32[i8 >> 2] = i7;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i13;
  return;
 }
 do {
  i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
  i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  i3 = (i2 & HEAP32[i11 + (i4 << 3) >> 2]) + (HEAP32[i11 + (i4 << 3) + 4 >> 2] | 0) | 0;
  if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
  HEAP16[i9 + (i4 << 1) >> 1] = i3;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i10 | 0));
 i10 = i12;
 i9 = i10;
 HEAP32[i9 >> 2] = i2;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i13;
 return;
}

function __ZL17icvYMLWriteStringP13CvFileStoragePKcS2_i(i12, i13, i10, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16432 | 0;
 i9 = i15;
 i11 = i15 + 24 | 0;
 i3 = i15 + 16 | 0;
 i2 = i15 + 8 | 0;
 if (!i10) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i3, 19) | 0) + 0 | 0;
  i5 = 16808;
  i6 = i4 + 19 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i3, 16832, 8960, 1632);
  __ZN2cv6String10deallocateEv(i3);
 }
 i8 = _strlen(i10 | 0) | 0;
 if ((i8 | 0) > 4096) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i2, 30) | 0) + 0 | 0;
  i5 = 16856;
  i6 = i4 + 30 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i2, 16832, 8960, 1636);
  __ZN2cv6String10deallocateEv(i2);
 }
 i2 = (i1 | 0) != 0 | (i8 | 0) == 0;
 if ((!i2 ? (i7 = HEAP8[i10 >> 0] | 0, i7 << 24 >> 24 == (HEAP8[i10 + (i8 + -1) >> 0] | 0)) : 0) ? i7 << 24 >> 24 == 39 | i7 << 24 >> 24 == 34 : 0) {
  __ZL11icvYMLWriteP13CvFileStoragePKcS2_(i12, i13, i10);
  STACKTOP = i15;
  return;
 }
 i2 = i2 & 1;
 i1 = i11 + 1 | 0;
 HEAP8[i11 >> 0] = 34;
 if ((i8 | 0) > 0) {
  i5 = 0;
  do {
   i6 = HEAP8[i10 + i5 >> 0] | 0;
   i7 = i6 + -48 << 24 >> 24;
   L15 : do if (!i2) {
    i3 = i6 + -97 << 24 >> 24;
    if ((i7 & 255) < 10 | (i3 & 255) < 26 | (i6 + -65 << 24 >> 24 & 255) < 26) i2 = 0; else {
     switch (i6 << 24 >> 24) {
     case 32:
     case 40:
     case 41:
     case 43:
     case 45:
     case 47:
     case 59:
     case 95:
      {
       i2 = 0;
       break L15;
      }
     default:
      {}
     }
     i2 = 1;
    }
   } else i3 = i6 + -97 << 24 >> 24; while (0);
   do if (!((i7 & 255) < 10 | (i3 & 255) < 26 | (i6 + -65 << 24 >> 24 & 255) < 26)) {
    if ((i6 & 255) > 31) {
     if (!(i6 << 24 >> 24 == 34 | i6 << 24 >> 24 == 39 | i6 << 24 >> 24 == 92)) {
      i14 = 23;
      break;
     }
     HEAP8[i1 >> 0] = 92;
     HEAP8[i1 + 1 >> 0] = i6;
     i1 = i1 + 2 | 0;
     break;
    }
    i3 = i1 + 1 | 0;
    HEAP8[i1 >> 0] = 92;
    if (i6 << 24 >> 24 == 13) {
     HEAP8[i3 >> 0] = 114;
     i1 = i1 + 2 | 0;
     break;
    } else if (i6 << 24 >> 24 == 9) {
     HEAP8[i3 >> 0] = 116;
     i1 = i1 + 2 | 0;
     break;
    } else if (i6 << 24 >> 24 == 10) {
     HEAP8[i3 >> 0] = 110;
     i1 = i1 + 2 | 0;
     break;
    } else {
     HEAP32[i9 >> 2] = i6 << 24 >> 24;
     _sprintf(i3, 16888, i9) | 0;
     i1 = i1 + 4 | 0;
     break;
    }
   } else i14 = 23; while (0);
   if ((i14 | 0) == 23) {
    i14 = 0;
    HEAP8[i1 >> 0] = i6;
    i1 = i1 + 1 | 0;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i8 | 0));
 }
 if (!i2) {
  i10 = HEAP8[i10 >> 0] | 0;
  if ((i10 + -48 << 24 >> 24 & 255) >= 10 ? !(i10 << 24 >> 24 == 46 | i10 << 24 >> 24 == 45 | i10 << 24 >> 24 == 43) : 0) i2 = 0; else {
   i2 = 1;
   i14 = 28;
  }
 } else i14 = 28;
 if ((i14 | 0) == 28) {
  HEAP8[i1 >> 0] = 34;
  i2 = (i2 | 0) != 0;
  i1 = i1 + 1 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i10 = i11 + (i2 & 1 ^ 1) | 0;
 __ZL11icvYMLWriteP13CvFileStoragePKcS2_(i12, i13, i10);
 STACKTOP = i15;
 return;
}

function __ZNK2cv12_OutputArray7releaseEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i8 + 16 | 0;
 i5 = i8 + 8 | 0;
 i6 = i8;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 104 >> 2] & 127](i7) | 0) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i4, 12) | 0) + 0 | 0;
  i2 = 31120 | 0;
  i1 = i3 + 12 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 31136, 27528, 2466);
  __ZN2cv6String10deallocateEv(i4);
 }
 i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] & 127](i7) | 0;
 do if ((i3 | 0) == 458752) {
  __ZN2cv3ogl6Buffer7releaseEv(HEAP32[i7 + 8 >> 2] | 0);
  STACKTOP = i8;
  return;
 } else if ((i3 | 0) == 524288) {
  STACKTOP = i8;
  return;
 } else if ((i3 | 0) == 262144) {
  i5 = HEAP32[i7 + 8 >> 2] | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i5 = i5 + 4 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i3 | 0) == (i6 | 0)) {
   STACKTOP = i8;
   return;
  }
  do {
   i2 = i3 + -12 | 0;
   HEAP32[i5 >> 2] = i2;
   i4 = HEAP32[i2 >> 2] | 0;
   if (!i4) i3 = i2; else {
    i3 = i3 + -8 | 0;
    if ((HEAP32[i3 >> 2] | 0) != (i4 | 0)) HEAP32[i3 >> 2] = i4;
    __ZdlPv(i4);
    i3 = HEAP32[i5 >> 2] | 0;
   }
  } while ((i3 | 0) != (i6 | 0));
  STACKTOP = i8;
  return;
 } else if ((i3 | 0) == 196608) {
  i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + 136 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  FUNCTION_TABLE_viiiiii[i1 & 31](i7, i5, HEAP32[i7 + 4 >> 2] & 4095, -1, 0, 0);
  STACKTOP = i8;
  return;
 } else if ((i3 | 0) == 720896) {
  i2 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i2 = i2 + 4 | 0;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) break;
   i1 = i1 + -48 | 0;
   HEAP32[i2 >> 2] = i1;
   __ZN2cv4UMatD2Ev(i1);
  }
  STACKTOP = i8;
  return;
 } else if (!i3) {
  STACKTOP = i8;
  return;
 } else if ((i3 | 0) == 327680) {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i4 = i4 + 4 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) == (i1 | 0)) {
   STACKTOP = i8;
   return;
  }
  do {
   i2 = i3 + -56 | 0;
   HEAP32[i4 >> 2] = i2;
   __ZN2cv3Mat7releaseEv(i2);
   i2 = HEAP32[i3 + -12 >> 2] | 0;
   if ((i2 | 0) != (i3 + -8 | 0)) __ZN2cv8fastFreeEPv(i2);
   i3 = HEAP32[i4 >> 2] | 0;
  } while ((i3 | 0) != (i1 | 0));
  STACKTOP = i8;
  return;
 } else if ((i3 | 0) == 65536) {
  __ZN2cv3Mat7releaseEv(HEAP32[i7 + 8 >> 2] | 0);
  STACKTOP = i8;
  return;
 } else if ((i3 | 0) == 655360) {
  i1 = HEAP32[i7 + 8 >> 2] | 0;
  i2 = i1 + 24 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != 0 ? (i4 = i3 + 8 | 0, i3 = HEAP32[i4 >> 2] | 0, HEAP32[i4 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv4UMat10deallocateEv(i1);
  HEAP32[HEAP32[i1 + 32 >> 2] >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i8;
  return;
 } else if ((i3 | 0) == 589824) {
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i6, 30) | 0) + 0 | 0;
  i2 = 28928 | 0;
  i1 = i3 + 30 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i6, 31136, 27528, 2527);
  __ZN2cv6String10deallocateEv(i6);
  STACKTOP = i8;
  return;
 } while (0);
}

function __ZN2cvL6div32fEPKfjS1_jPfjNS_5Size_IiEEPv(i8, i3, i9, i4, i10, i5, i1, i2) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f6 = f0, f7 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, d19 = 0.0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, f24 = f0, i25 = 0, i26 = 0, d27 = 0.0, d28 = 0.0, d29 = 0.0, d30 = 0.0, d31 = 0.0, d32 = 0.0, d33 = 0.0;
 i26 = STACKTOP;
 i20 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 d19 = +HEAPF64[i2 >> 3];
 i18 = i3 >>> 2;
 i17 = i4 >>> 2;
 i14 = i5 >>> 2;
 if (!i1) {
  STACKTOP = i26;
  return;
 }
 i15 = i20 + -4 | 0;
 i16 = (i15 | 0) < 0;
 i13 = (i15 | 0) > 3 ? i20 & -4 : 4;
 while (1) {
  i1 = i1 + -1 | 0;
  if (i16) i4 = 0; else {
   i2 = 0;
   do {
    f6 = Math_fround(HEAPF32[i9 + (i2 << 2) >> 2]);
    i3 = i2 | 1;
    i5 = i9 + (i3 << 2) | 0;
    do if (f6 != Math_fround(0.0)) {
     f7 = Math_fround(HEAPF32[i5 >> 2]);
     if ((f7 != Math_fround(0.0) ? (i21 = i2 | 2, f22 = Math_fround(HEAPF32[i9 + (i21 << 2) >> 2]), f22 != Math_fround(0.0)) : 0) ? (i23 = i2 | 3, f24 = Math_fround(HEAPF32[i9 + (i23 << 2) >> 2]), f24 != Math_fround(0.0)) : 0) {
      d31 = +f6;
      d32 = +f7;
      d33 = d31 * d32;
      d28 = +f22;
      d29 = +f24;
      d30 = d28 * d29;
      d27 = d19 / (d33 * d30);
      d30 = d30 * d27;
      d27 = d33 * d27;
      f12 = Math_fround(d32 * (d30 * +Math_fround(HEAPF32[i8 + (i2 << 2) >> 2])));
      f11 = Math_fround(d31 * (d30 * +Math_fround(HEAPF32[i8 + (i3 << 2) >> 2])));
      f7 = Math_fround(d29 * (d27 * +Math_fround(HEAPF32[i8 + (i21 << 2) >> 2])));
      f6 = Math_fround(d28 * (d27 * +Math_fround(HEAPF32[i8 + (i23 << 2) >> 2])));
      HEAPF32[i10 + (i2 << 2) >> 2] = f12;
      HEAPF32[i10 + (i3 << 2) >> 2] = f11;
      HEAPF32[i10 + (i21 << 2) >> 2] = f7;
      HEAPF32[i10 + (i23 << 2) >> 2] = f6;
      break;
     }
     f12 = Math_fround(d19 * +Math_fround(HEAPF32[i8 + (i2 << 2) >> 2]) / +f6);
     i25 = 10;
    } else {
     f12 = Math_fround(0.0);
     i25 = 10;
    } while (0);
    if ((i25 | 0) == 10) {
     i25 = 0;
     f6 = Math_fround(HEAPF32[i5 >> 2]);
     if (f6 != Math_fround(0.0)) f11 = Math_fround(d19 * +Math_fround(HEAPF32[i8 + (i3 << 2) >> 2]) / +f6); else f11 = Math_fround(0.0);
     i4 = i2 | 2;
     f7 = Math_fround(HEAPF32[i9 + (i4 << 2) >> 2]);
     if (f7 != Math_fround(0.0)) f6 = Math_fround(d19 * +Math_fround(HEAPF32[i8 + (i4 << 2) >> 2]) / +f7); else f6 = Math_fround(0.0);
     i5 = i2 | 3;
     f7 = Math_fround(HEAPF32[i9 + (i5 << 2) >> 2]);
     if (f7 != Math_fround(0.0)) f7 = Math_fround(d19 * +Math_fround(HEAPF32[i8 + (i5 << 2) >> 2]) / +f7); else f7 = Math_fround(0.0);
     HEAPF32[i10 + (i2 << 2) >> 2] = f12;
     HEAPF32[i10 + (i3 << 2) >> 2] = f11;
     HEAPF32[i10 + (i4 << 2) >> 2] = f6;
     HEAPF32[i10 + (i5 << 2) >> 2] = f7;
    }
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) <= (i15 | 0));
   i4 = i13;
  }
  if ((i4 | 0) < (i20 | 0)) do {
   f6 = Math_fround(HEAPF32[i9 + (i4 << 2) >> 2]);
   if (f6 != Math_fround(0.0)) f6 = Math_fround(d19 * +Math_fround(HEAPF32[i8 + (i4 << 2) >> 2]) / +f6); else f6 = Math_fround(0.0);
   HEAPF32[i10 + (i4 << 2) >> 2] = f6;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i20 | 0));
  if (!i1) break; else {
   i8 = i8 + (i18 << 2) | 0;
   i9 = i9 + (i17 << 2) | 0;
   i10 = i10 + (i14 << 2) | 0;
  }
 }
 STACKTOP = i26;
 return;
}

function __ZN2cv10BmpEncoder5writeERKNS_3MatERKNSt3__16vectorIiNS4_9allocatorIiEEEE(i3, i18, i1) {
 i3 = i3 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 i20 = i23 + 1064 | 0;
 i22 = i23;
 i14 = i23 + 40 | 0;
 i10 = HEAP32[i18 + 12 >> 2] | 0;
 i17 = HEAP32[i18 + 8 >> 2] | 0;
 i12 = (HEAP32[i18 >> 2] | 0) >>> 3 & 511;
 i13 = i12 + 1 | 0;
 i21 = Math_imul(i13, i10) | 0;
 i19 = i21 + 3 & -4;
 HEAP8[i20 + 0 >> 0] = 0;
 HEAP8[i20 + 1 >> 0] = 0;
 HEAP8[i20 + 2 >> 0] = 0;
 HEAP8[i20 + 3 >> 0] = 0;
 HEAP8[i20 + 4 >> 0] = 0;
 __ZN2cv11WBaseStreamC2Ev(i22);
 HEAP32[i22 >> 2] = 181080;
 i2 = i3 + 20 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if (!i4) {
  if (!(FUNCTION_TABLE_iii[HEAP32[181072 + 16 >> 2] & 127](i22, i3 + 12 | 0) | 0)) {
   i21 = 0;
   __ZN2cv11WBaseStreamD2Ev(i22);
   STACKTOP = i23;
   return i21 | 0;
  }
 } else if (!(FUNCTION_TABLE_iii[HEAP32[181072 + 20 >> 2] & 127](i22, i4) | 0)) {
  i21 = 0;
  __ZN2cv11WBaseStreamD2Ev(i22);
  STACKTOP = i23;
  return i21 | 0;
 }
 i8 = i13 >>> 0 > 1 ? 54 : 1078;
 i9 = (Math_imul(i19, i17) | 0) + i8 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 if ((i5 | 0) != 0 ? (i15 = i9 + 271 & -256, i16 = i5 + 8 | 0, i11 = HEAP32[i5 >> 2] | 0, i6 = i11, ((HEAP32[i16 >> 2] | 0) - i6 | 0) >>> 0 < i15 >>> 0) : 0) {
  i7 = i5 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = i4 - i6 | 0;
  if (!i15) {
   i1 = 0;
   i3 = i4;
   i4 = i11;
  } else {
   i1 = __Znwj(i15) | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i5 >> 2] | 0;
  }
  i3 = i3 - i4 | 0;
  i11 = i1 + (i2 - i3) | 0;
  _memcpy(i11 | 0, i4 | 0, i3 | 0) | 0;
  HEAP32[i5 >> 2] = i11;
  HEAP32[i7 >> 2] = i1 + i2;
  HEAP32[i16 >> 2] = i1 + i15;
  if (i4) __ZdlPv(i4);
 }
 __ZN2cv12WLByteStream8putBytesEPKvi(i22, 179328, 2);
 __ZN2cv12WLByteStream8putDWordEi(i22, i9);
 __ZN2cv12WLByteStream8putDWordEi(i22, 0);
 __ZN2cv12WLByteStream8putDWordEi(i22, i8);
 __ZN2cv12WLByteStream8putDWordEi(i22, 40);
 __ZN2cv12WLByteStream8putDWordEi(i22, i10);
 __ZN2cv12WLByteStream8putDWordEi(i22, i17);
 __ZN2cv12WLByteStream7putWordEi(i22, 1);
 __ZN2cv12WLByteStream7putWordEi(i22, i13 << 3);
 __ZN2cv12WLByteStream8putDWordEi(i22, 0);
 __ZN2cv12WLByteStream8putDWordEi(i22, 0);
 __ZN2cv12WLByteStream8putDWordEi(i22, 0);
 __ZN2cv12WLByteStream8putDWordEi(i22, 0);
 __ZN2cv12WLByteStream8putDWordEi(i22, 0);
 __ZN2cv12WLByteStream8putDWordEi(i22, 0);
 if (!i12) {
  __Z15FillGrayPaletteP12PaletteEntryib(i14, 8, 0);
  __ZN2cv12WLByteStream8putBytesEPKvi(i22, i14, 1024);
 }
 i1 = i17 + -1 | 0;
 if ((i17 | 0) > 0) {
  i4 = i18 + 16 | 0;
  i3 = i18 + 44 | 0;
  i2 = i19 - i21 | 0;
  if ((i19 | 0) > (i21 | 0)) while (1) {
   __ZN2cv12WLByteStream8putBytesEPKvi(i22, (HEAP32[i4 >> 2] | 0) + (Math_imul(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i1) | 0) | 0, i21);
   __ZN2cv12WLByteStream8putBytesEPKvi(i22, i20, i2);
   if ((i1 | 0) > 0) i1 = i1 + -1 | 0; else break;
  } else while (1) {
   __ZN2cv12WLByteStream8putBytesEPKvi(i22, (HEAP32[i4 >> 2] | 0) + (Math_imul(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i1) | 0) | 0, i21);
   if ((i1 | 0) > 0) i1 = i1 + -1 | 0; else break;
  }
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] & 511](i22);
 i21 = 1;
 __ZN2cv11WBaseStreamD2Ev(i22);
 STACKTOP = i23;
 return i21 | 0;
}

function __ZNSt3__1L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i1, i13, i10, i2, i11, i12, i9, i3) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i12 >> 2] = i2;
 i1 = HEAP32[i10 >> 2] | 0;
 if (((((i3 & 4 | 0) != 0 ? (i13 - i1 | 0) > 2 : 0) ? (HEAP8[i1 >> 0] | 0) == -17 : 0) ? (HEAP8[i1 + 1 >> 0] | 0) == -69 : 0) ? (HEAP8[i1 + 2 >> 0] | 0) == -65 : 0) {
  i1 = i1 + 3 | 0;
  HEAP32[i10 >> 2] = i1;
 }
 L8 : do if (i1 >>> 0 < i13 >>> 0) {
  i7 = i13;
  i8 = HEAP32[i12 >> 2] | 0;
  while (1) {
   if (i8 >>> 0 >= i11 >>> 0) {
    i14 = 39;
    break L8;
   }
   i3 = HEAP8[i1 >> 0] | 0;
   i6 = i3 & 255;
   do if (i3 << 24 >> 24 > -1) {
    if (i6 >>> 0 > i9 >>> 0) {
     i1 = 2;
     break L8;
    }
    HEAP32[i8 >> 2] = i6;
    HEAP32[i10 >> 2] = i1 + 1;
   } else {
    if ((i3 & 255) < 194) {
     i1 = 2;
     break L8;
    }
    if ((i3 & 255) < 224) {
     if ((i7 - i1 | 0) < 2) {
      i1 = 1;
      break L8;
     }
     i3 = HEAPU8[i1 + 1 >> 0] | 0;
     if ((i3 & 192 | 0) != 128) {
      i1 = 2;
      break L8;
     }
     i2 = i3 & 63 | i6 << 6 & 1984;
     if (i2 >>> 0 > i9 >>> 0) {
      i1 = 2;
      break L8;
     }
     HEAP32[i8 >> 2] = i2;
     HEAP32[i10 >> 2] = i1 + 2;
     break;
    }
    if ((i3 & 255) < 240) {
     if ((i7 - i1 | 0) < 3) {
      i1 = 1;
      break L8;
     }
     i2 = HEAP8[i1 + 1 >> 0] | 0;
     i3 = HEAP8[i1 + 2 >> 0] | 0;
     if ((i6 | 0) == 224) {
      if ((i2 & -32) << 24 >> 24 != -96) {
       i1 = 2;
       break L8;
      }
     } else if ((i6 | 0) == 237) {
      if ((i2 & -32) << 24 >> 24 != -128) {
       i1 = 2;
       break L8;
      }
     } else if ((i2 & -64) << 24 >> 24 != -128) {
      i1 = 2;
      break L8;
     }
     i3 = i3 & 255;
     if ((i3 & 192 | 0) != 128) {
      i1 = 2;
      break L8;
     }
     i2 = (i2 & 255) << 6 & 4032 | i6 << 12 & 61440 | i3 & 63;
     if (i2 >>> 0 > i9 >>> 0) {
      i1 = 2;
      break L8;
     }
     HEAP32[i8 >> 2] = i2;
     HEAP32[i10 >> 2] = i1 + 3;
     break;
    }
    if ((i3 & 255) >= 245) {
     i1 = 2;
     break L8;
    }
    if ((i7 - i1 | 0) < 4) {
     i1 = 1;
     break L8;
    }
    i5 = HEAP8[i1 + 1 >> 0] | 0;
    i3 = HEAP8[i1 + 2 >> 0] | 0;
    i2 = HEAP8[i1 + 3 >> 0] | 0;
    if ((i6 | 0) == 240) {
     if ((i5 + 112 << 24 >> 24 & 255) >= 48) {
      i1 = 2;
      break L8;
     }
    } else if ((i6 | 0) == 244) {
     if ((i5 & -16) << 24 >> 24 != -128) {
      i1 = 2;
      break L8;
     }
    } else if ((i5 & -64) << 24 >> 24 != -128) {
     i1 = 2;
     break L8;
    }
    i4 = i3 & 255;
    if ((i4 & 192 | 0) != 128) {
     i1 = 2;
     break L8;
    }
    i3 = i2 & 255;
    if ((i3 & 192 | 0) != 128) {
     i1 = 2;
     break L8;
    }
    i2 = (i5 & 255) << 12 & 258048 | i6 << 18 & 1835008 | i4 << 6 & 4032 | i3 & 63;
    if (i2 >>> 0 > i9 >>> 0) {
     i1 = 2;
     break L8;
    }
    HEAP32[i8 >> 2] = i2;
    HEAP32[i10 >> 2] = i1 + 4;
   } while (0);
   i8 = (HEAP32[i12 >> 2] | 0) + 4 | 0;
   HEAP32[i12 >> 2] = i8;
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 >>> 0 >= i13 >>> 0) {
    i14 = 39;
    break;
   }
  }
 } else i14 = 39; while (0);
 if ((i14 | 0) == 39) i1 = i1 >>> 0 < i13 >>> 0 & 1;
 STACKTOP = i15;
 return i1 | 0;
}

function __ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe(i19, i2, i15, i16, i1, i4, i17, i12) {
 i19 = i19 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 i9 = i21;
 i6 = i21 + 72 | 0;
 i18 = i21 + 64 | 0;
 i8 = i21 + 56 | 0;
 i13 = i21 + 52 | 0;
 i5 = i21 + 572 | 0;
 i22 = i21 + 48 | 0;
 i7 = i21 + 8 | 0;
 i10 = i21 + 472 | 0;
 HEAP32[i18 >> 2] = i6;
 i14 = i18 + 4 | 0;
 HEAP32[i14 >> 2] = 384;
 __ZNKSt3__18ios_base6getlocEv(i13, i4);
 i2 = __ZNKSt3__16locale9use_facetERNS0_2idE(i13, 960720) | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i9 + 0 >> 2] = HEAP32[i22 + 0 >> 2];
 do if (__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_(i15, i9, i1, i13, i4, i17, i5, i2, i18, i8, i6 + 400 | 0) | 0) {
  FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] & 7](i2, 960424, 960434, i7) | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i18 >> 2] | 0;
  i2 = i4 - i1 | 0;
  if ((i2 | 0) > 392) {
   i2 = _malloc((i2 >> 2) + 2 | 0) | 0;
   if (!i2) __ZSt17__throw_bad_allocv(); else {
    i11 = i2;
    i3 = i2;
   }
  } else {
   i11 = 0;
   i3 = i10;
  }
  if (HEAP8[i5 >> 0] | 0) {
   HEAP8[i3 >> 0] = 45;
   i3 = i3 + 1 | 0;
  }
  if (i1 >>> 0 < i4 >>> 0) {
   i5 = i7 + 40 | 0;
   i6 = i7;
   i4 = i1;
   do {
    i1 = HEAP32[i4 >> 2] | 0;
    i2 = i7;
    while (1) {
     if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break;
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i5 | 0)) {
      i2 = i5;
      break;
     }
    }
    HEAP8[i3 >> 0] = HEAP8[960424 + (i2 - i6 >> 2) >> 0] | 0;
    i4 = i4 + 4 | 0;
    i3 = i3 + 1 | 0;
   } while (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
  }
  HEAP8[i3 >> 0] = 0;
  HEAP32[i9 >> 2] = i12;
  if ((_sscanf(i10, 960360, i9) | 0) == 1) {
   _free(i11);
   break;
  } else __ZNSt3__121__throw_runtime_errorEPKc(960368);
 } while (0);
 i1 = HEAP32[i15 >> 2] | 0;
 do if (i1) {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i15 >> 2] = 0;
   i3 = 1;
   break;
  } else {
   i3 = (HEAP32[i15 >> 2] | 0) == 0;
   break;
  }
 } else i3 = 1; while (0);
 i2 = HEAP32[i16 >> 2] | 0;
 do if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != -1) if (i3) break; else {
   i20 = 31;
   break;
  } else {
   HEAP32[i16 >> 2] = 0;
   i20 = 29;
   break;
  }
 } else i20 = 29; while (0);
 if ((i20 | 0) == 29 ? i3 : 0) i20 = 31;
 if ((i20 | 0) == 31) HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | 2;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i13 >> 2] | 0) | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 HEAP32[i18 >> 2] = 0;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[i14 >> 2] & 511](i1);
 STACKTOP = i21;
 return;
}

function __ZN7testing8internalL12FlagToEnvVarEPKc(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i9 = i13 + 20 | 0;
 i12 = i13 + 8 | 0;
 i7 = i13 + 4 | 0;
 i11 = i13;
 __ZN7testing7MessageC2Ev(i7);
 i6 = HEAP32[i7 >> 2] | 0;
 i1 = i6 + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 168464, 6) | 0;
 if (!i2) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i2, _strlen(i2 | 0) | 0) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i9, i6 + 12 | 0);
 i1 = HEAP8[i9 >> 0] | 0;
 if (!(i1 & 1)) {
  i3 = i9 + 1 | 0;
  i2 = (i1 & 255) >>> 1;
 } else {
  i3 = HEAP32[i9 + 8 >> 2] | 0;
  i2 = HEAP32[i9 + 4 >> 2] | 0;
 }
 i4 = i3 + i2 | 0;
 HEAP32[i12 + 0 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i12, i2 << 1);
 if (i2) {
  i1 = i3;
  do {
   i2 = HEAP8[i1 >> 0] | 0;
   if (!(i2 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i12, i2);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 if (i6) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] & 511](i6);
  HEAP32[i7 >> 2] = 0;
 }
 __ZN7testing7MessageC2Ev(i11);
 i3 = i12 + 1 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i2 = i8 + 8 | 0;
 i1 = i12 + 8 | 0;
 i5 = i12 + 4 | 0;
 i7 = 0;
 while (1) {
  i4 = HEAP8[i12 >> 0] | 0;
  i6 = (i4 & 1) == 0;
  if (i6) i4 = (i4 & 255) >>> 1; else i4 = HEAP32[i5 >> 2] | 0;
  if ((i7 | 0) == (i4 | 0)) break;
  HEAP8[i9 >> 0] = _toupper(HEAPU8[(i6 ? i3 : HEAP32[i1 >> 2] | 0) + i7 >> 0] | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i9, 1) | 0;
  i7 = i7 + 1 | 0;
 }
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i9, i8 + 12 | 0);
 i1 = HEAP8[i9 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i9 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i9 + 8 >> 2] | 0;
  i1 = HEAP32[i9 + 4 >> 2] | 0;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i10, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i10, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i10, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 if (!i8) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
  STACKTOP = i13;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] & 511](i8);
 HEAP32[i11 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
 STACKTOP = i13;
 return;
}

function __ZN2cvL13copyMask32sC8EPKhjS1_jPhjNS_5Size_IiEEPv(i5, i14, i3, i13, i4, i12, i2, i1) {
 i5 = i5 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i11 = STACKTOP;
 i10 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = i10 & -4;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i2 = 0; else {
   i1 = 0;
   do {
    if (HEAP8[i3 + i1 >> 0] | 0) {
     i2 = i4 + (i1 << 5) | 0;
     i15 = i5 + (i1 << 5) | 0;
     HEAP32[i2 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
     HEAP32[i2 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
     HEAP32[i2 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
     HEAP32[i2 + 28 >> 2] = HEAP32[i15 + 28 >> 2];
    }
    i2 = i1 | 1;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 << 5) | 0;
     i2 = i5 + (i2 << 5) | 0;
     HEAP32[i15 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i15 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i15 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
     HEAP32[i15 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
     HEAP32[i15 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    }
    i2 = i1 | 2;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 << 5) | 0;
     i2 = i5 + (i2 << 5) | 0;
     HEAP32[i15 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i15 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i15 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
     HEAP32[i15 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
     HEAP32[i15 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    }
    i2 = i1 | 3;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 << 5) | 0;
     i2 = i5 + (i2 << 5) | 0;
     HEAP32[i15 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i15 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i15 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
     HEAP32[i15 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
     HEAP32[i15 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i7 | 0));
   i2 = i9;
  }
  if ((i2 | 0) < (i10 | 0)) do {
   if (HEAP8[i3 + i2 >> 0] | 0) {
    i1 = i4 + (i2 << 5) | 0;
    i15 = i5 + (i2 << 5) | 0;
    HEAP32[i1 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
    HEAP32[i1 + 28 >> 2] = HEAP32[i15 + 28 >> 2];
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
  if (!i6) break; else {
   i3 = i3 + i13 | 0;
   i4 = i4 + i12 | 0;
   i5 = i5 + i14 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZL10icvGrowSeqP5CvSeqi(i12, i11) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i13 + 8 | 0;
 i6 = i13;
 if (!i12) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40784, 39608, 636);
  __ZN2cv6String10deallocateEv(i1);
 }
 i1 = i12 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i8 = i12 + 28 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i7 = HEAP32[i12 + 40 >> 2] | 0;
  i10 = HEAP32[i12 + 44 >> 2] | 0;
  if ((HEAP32[i12 + 24 >> 2] | 0) >= (i7 << 2 | 0)) _cvSetSeqBlockSize(i12, i7 << 1);
  if (!i10) {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   i5 = (__ZN2cv6String8allocateEj(i6, 37) | 0) + 0 | 0;
   i4 = 40800 | 0;
   i3 = i5 + 37 | 0;
   do {
    HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i5 = i5 + 1 | 0;
    i4 = i4 + 1 | 0;
   } while ((i5 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i6, 40784, 39608, 649);
   __ZN2cv6String10deallocateEv(i6);
  }
  i6 = HEAP32[i10 + 8 >> 2] | 0;
  i5 = HEAP32[i10 + 16 >> 2] | 0;
  i4 = i10 + 20 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = i12 + 32 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i6 + (i5 - i1) - i2 | 0) >>> 0 < 8 ? !((i11 | 0) != 0 ? 1 : (i1 | 0) < (HEAP32[i8 >> 2] | 0)) : 0) {
   i10 = (i1 | 0) / (i9 | 0) | 0;
   i10 = i2 + (Math_imul((i10 | 0) > (i7 | 0) ? i7 : i10, i9) | 0) | 0;
   HEAP32[i3 >> 2] = i10;
   HEAP32[i4 >> 2] = i6 + i5 - i10 & -8;
   STACKTOP = i13;
   return;
  }
  i2 = (Math_imul(i7, i9) | 0) + 24 | 0;
  do if ((i1 | 0) < (i2 | 0)) {
   if ((i7 | 0) > 5) i3 = (i7 | 0) / 3 | 0; else i3 = 1;
   if ((i1 | 0) < ((Math_imul(i3, i9) | 0) + 32 | 0)) {
    __ZL17icvGoNextMemBlockP12CvMemStorage(i10);
    break;
   } else {
    i2 = i1 - ((i1 + -24 | 0) % (HEAP32[i8 >> 2] | 0) | 0) | 0;
    break;
   }
  } while (0);
  i10 = _cvMemStorageAlloc(i10, i2) | 0;
  HEAP32[i10 + 16 >> 2] = i10 + 27 & -8;
  HEAP32[i10 + 12 >> 2] = i2 + -24;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i2 = i10;
 } else HEAP32[i1 >> 2] = HEAP32[i2 + 4 >> 2];
 i5 = i12 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i2 + 4 >> 2] = i2;
  HEAP32[i2 >> 2] = i2;
  i1 = i2;
  i4 = i2;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  HEAP32[i1 >> 2] = i2;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 + 4 >> 2] = i2;
 }
 L32 : do if (!i11) {
  i10 = HEAP32[i2 + 16 >> 2] | 0;
  HEAP32[i12 + 36 >> 2] = i10;
  HEAP32[i12 + 32 >> 2] = i10 + (HEAP32[i2 + 12 >> 2] | 0);
  if ((i2 | 0) == (i4 | 0)) i1 = 0; else i1 = (HEAP32[i4 + 12 >> 2] | 0) + (HEAP32[i4 + 8 >> 2] | 0) | 0;
  HEAP32[i2 + 8 >> 2] = i1;
  i1 = i2;
 } else {
  i3 = HEAP32[i2 + 12 >> 2] | 0;
  i6 = (i3 | 0) / (HEAP32[i12 + 28 >> 2] | 0) | 0;
  i10 = i2 + 16 | 0;
  i3 = (HEAP32[i10 >> 2] | 0) + i3 | 0;
  HEAP32[i10 >> 2] = i3;
  if ((i2 | 0) == (i4 | 0)) {
   HEAP32[i12 + 36 >> 2] = i3;
   HEAP32[i12 + 32 >> 2] = i3;
  } else {
   HEAP32[i5 >> 2] = i2;
   i1 = i2;
  }
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = 0;
  while (1) {
   HEAP32[i2 + 8 >> 2] = i3 + i6;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if ((i2 | 0) == (i1 | 0)) break L32;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 } while (0);
 HEAP32[i1 + 12 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN2cvL9randi_32sEPiiPyPKNS_9DivStructEb(i5, i6, i9, i7, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i8 = STACKTOP;
 i1 = i9;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i6 + -4 | 0;
 if ((i4 | 0) < 0) i3 = 0; else {
  i3 = 0;
  do {
   i15 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i15 = _i64Add(i15 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i12 = tempRet0;
   i14 = ___muldi3(i15 | 0, 0, -130063606, 0) | 0;
   i12 = _i64Add(i14 | 0, tempRet0 | 0, i12 | 0, 0) | 0;
   i14 = tempRet0;
   ___muldi3(i15 | 0, 0, HEAP32[i7 + (i3 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
   i11 = tempRet0;
   i13 = i3 | 1;
   ___muldi3(i12 | 0, 0, HEAP32[i7 + (i13 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
   i10 = tempRet0;
   i11 = Math_imul((((i15 - i11 | 0) >>> (HEAP32[i7 + (i3 * 20 | 0) + 8 >> 2] | 0)) + i11 | 0) >>> (HEAP32[i7 + (i3 * 20 | 0) + 12 >> 2] | 0), HEAP32[i7 + (i3 * 20 | 0) >> 2] | 0) | 0;
   i10 = Math_imul((((i12 - i10 | 0) >>> (HEAP32[i7 + (i13 * 20 | 0) + 8 >> 2] | 0)) + i10 | 0) >>> (HEAP32[i7 + (i13 * 20 | 0) + 12 >> 2] | 0), HEAP32[i7 + (i13 * 20 | 0) >> 2] | 0) | 0;
   i10 = (HEAP32[i7 + (i13 * 20 | 0) + 16 >> 2] | 0) + i12 - i10 | 0;
   HEAP32[i5 + (i3 << 2) >> 2] = (HEAP32[i7 + (i3 * 20 | 0) + 16 >> 2] | 0) + i15 - i11;
   HEAP32[i5 + (i13 << 2) >> 2] = i10;
   i12 = ___muldi3(i12 | 0, 0, -130063606, 0) | 0;
   i14 = _i64Add(i12 | 0, tempRet0 | 0, i14 | 0, 0) | 0;
   i12 = tempRet0;
   i13 = ___muldi3(i14 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i13 | 0, tempRet0 | 0, i12 | 0, 0) | 0;
   i1 = tempRet0;
   i12 = i3 | 2;
   ___muldi3(HEAP32[i7 + (i12 * 20 | 0) + 4 >> 2] | 0, 0, i14 | 0, 0) | 0;
   i13 = tempRet0;
   i10 = i3 | 3;
   ___muldi3(HEAP32[i7 + (i10 * 20 | 0) + 4 >> 2] | 0, 0, i2 | 0, 0) | 0;
   i11 = tempRet0;
   i13 = Math_imul((((i14 - i13 | 0) >>> (HEAP32[i7 + (i12 * 20 | 0) + 8 >> 2] | 0)) + i13 | 0) >>> (HEAP32[i7 + (i12 * 20 | 0) + 12 >> 2] | 0), HEAP32[i7 + (i12 * 20 | 0) >> 2] | 0) | 0;
   i11 = Math_imul((((i2 - i11 | 0) >>> (HEAP32[i7 + (i10 * 20 | 0) + 8 >> 2] | 0)) + i11 | 0) >>> (HEAP32[i7 + (i10 * 20 | 0) + 12 >> 2] | 0), HEAP32[i7 + (i10 * 20 | 0) >> 2] | 0) | 0;
   i11 = (HEAP32[i7 + (i10 * 20 | 0) + 16 >> 2] | 0) + i2 - i11 | 0;
   HEAP32[i5 + (i12 << 2) >> 2] = (HEAP32[i7 + (i12 * 20 | 0) + 16 >> 2] | 0) + i14 - i13;
   HEAP32[i5 + (i10 << 2) >> 2] = i11;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i4 | 0));
  i3 = i6 & -4;
 }
 if ((i3 | 0) >= (i6 | 0)) {
  i6 = i2;
  i7 = i1;
  i10 = i9;
  i9 = i10;
  HEAP32[i9 >> 2] = i6;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
 do {
  i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
  i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  ___muldi3(i2 | 0, 0, HEAP32[i7 + (i3 * 20 | 0) + 4 >> 2] | 0, 0) | 0;
  i10 = tempRet0;
  i10 = Math_imul((((i2 - i10 | 0) >>> (HEAP32[i7 + (i3 * 20 | 0) + 8 >> 2] | 0)) + i10 | 0) >>> (HEAP32[i7 + (i3 * 20 | 0) + 12 >> 2] | 0), HEAP32[i7 + (i3 * 20 | 0) >> 2] | 0) | 0;
  HEAP32[i5 + (i3 << 2) >> 2] = (HEAP32[i7 + (i3 * 20 | 0) + 16 >> 2] | 0) + i2 - i10;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i6 | 0));
 i10 = i9;
 i9 = i10;
 HEAP32[i9 >> 2] = i2;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN2cv2LUEPdjiS0_ji(i21, i1, i23, i22, i2, i24) {
 i21 = i21 | 0;
 i1 = i1 | 0;
 i23 = i23 | 0;
 i22 = i22 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d12 = 0.0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i25 = 0;
 i25 = STACKTOP;
 i20 = i1 >>> 3;
 i18 = i2 >>> 3;
 if ((i23 | 0) <= 0) {
  i23 = 1;
  STACKTOP = i25;
  return i23 | 0;
 }
 i13 = (i22 | 0) == 0;
 i19 = (i24 | 0) > 0;
 i15 = i13 | i19 ^ 1;
 i16 = 0;
 i1 = 1;
 while (1) {
  i14 = i16 + 1 | 0;
  i11 = (i14 | 0) < (i23 | 0);
  if (i11) {
   i3 = i14;
   i2 = i16;
   do {
    d4 = +Math_abs(+(+HEAPF64[i21 + ((Math_imul(i3, i20) | 0) + i16 << 3) >> 3]));
    i5 = d4 > +Math_abs(+(+HEAPF64[i21 + ((Math_imul(i2, i20) | 0) + i16 << 3) >> 3]));
    i2 = i5 ? i3 : i2;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i23 | 0));
  } else i2 = i16;
  i3 = Math_imul(i2, i20) | 0;
  if (+Math_abs(+(+HEAPF64[i21 + (i3 + i16 << 3) >> 3])) < 2.220446049250313e-16) {
   i1 = 0;
   i17 = 28;
   break;
  }
  i7 = Math_imul(i16, i20) | 0;
  if ((i2 | 0) != (i16 | 0)) {
   i5 = i16;
   do {
    i8 = i21 + (i5 + i7 << 3) | 0;
    i6 = i21 + (i5 + i3 << 3) | 0;
    d4 = +HEAPF64[i8 >> 3];
    HEAPF64[i8 >> 3] = +HEAPF64[i6 >> 3];
    HEAPF64[i6 >> 3] = d4;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i23 | 0));
   if (!i15) {
    i6 = Math_imul(i16, i18) | 0;
    i3 = Math_imul(i2, i18) | 0;
    i5 = 0;
    do {
     i8 = i22 + (i5 + i6 << 3) | 0;
     i2 = i22 + (i5 + i3 << 3) | 0;
     d4 = +HEAPF64[i8 >> 3];
     HEAPF64[i8 >> 3] = +HEAPF64[i2 >> 3];
     HEAPF64[i2 >> 3] = d4;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i24 | 0));
   }
   i1 = 0 - i1 | 0;
  }
  i8 = i21 + (i7 + i16 << 3) | 0;
  d12 = -1.0 / +HEAPF64[i8 >> 3];
  if (!i11) break;
  i10 = Math_imul(i16, i18) | 0;
  i9 = i14;
  do {
   i6 = Math_imul(i9, i20) | 0;
   d4 = d12 * +HEAPF64[i21 + (i6 + i16 << 3) >> 3];
   i11 = i14;
   do {
    i2 = i21 + (i11 + i6 << 3) | 0;
    HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] + d4 * +HEAPF64[i21 + (i11 + i7 << 3) >> 3];
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) != (i23 | 0));
   if (!i15) {
    i6 = Math_imul(i9, i18) | 0;
    i11 = 0;
    do {
     i2 = i22 + (i11 + i6 << 3) | 0;
     HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] + d4 * +HEAPF64[i22 + (i11 + i10 << 3) >> 3];
     i11 = i11 + 1 | 0;
    } while ((i11 | 0) != (i24 | 0));
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i23 | 0));
  HEAPF64[i8 >> 3] = -d12;
  i16 = i14;
 }
 if ((i17 | 0) == 28) {
  STACKTOP = i25;
  return i1 | 0;
 }
 HEAPF64[i8 >> 3] = -d12;
 if (i13) {
  i23 = i1;
  STACKTOP = i25;
  return i23 | 0;
 } else i9 = i23;
 do {
  i10 = i9;
  i9 = i9 + -1 | 0;
  if (i19) {
   i5 = Math_imul(i9, i18) | 0;
   i3 = (i10 | 0) < (i23 | 0);
   i2 = Math_imul(i9, i20) | 0;
   i7 = i21 + (i2 + i9 << 3) | 0;
   i11 = 0;
   do {
    i8 = i22 + (i11 + i5 << 3) | 0;
    d4 = +HEAPF64[i8 >> 3];
    if (i3) {
     i6 = i10;
     do {
      d4 = d4 - +HEAPF64[i21 + (i6 + i2 << 3) >> 3] * +HEAPF64[i22 + ((Math_imul(i6, i18) | 0) + i11 << 3) >> 3];
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i23 | 0));
    }
    HEAPF64[i8 >> 3] = d4 * +HEAPF64[i7 >> 3];
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) != (i24 | 0));
  }
 } while ((i9 | 0) > 0);
 STACKTOP = i25;
 return i1 | 0;
}
function __ZN2cvL11randBits_8uEPhiPyPKNS_3VecIiLi2EEEb(i9, i10, i12, i11, i4) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 i13 = STACKTOP;
 i1 = i12;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i10 + -4 | 0;
 i3 = (i8 | 0) < 0;
 if (i4) if (i3) i3 = 0; else {
  i7 = 0;
  do {
   i3 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i3 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i1 = tempRet0;
   i3 = (i2 & HEAP32[i11 + (i7 << 3) >> 2]) + (HEAP32[i11 + (i7 << 3) + 4 >> 2] | 0) | 0;
   i5 = i7 | 1;
   i4 = (i2 >> 8 & HEAP32[i11 + (i5 << 3) >> 2]) + (HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0) | 0;
   if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
   HEAP8[i9 + i7 >> 0] = i3;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i9 + i5 >> 0] = i4;
   i5 = i7 | 2;
   i3 = (HEAP32[i11 + (i5 << 3) >> 2] & i2 >> 16) + (HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0) | 0;
   i6 = i7 | 3;
   i4 = (HEAP32[i11 + (i6 << 3) >> 2] & i2 >> 24) + (HEAP32[i11 + (i6 << 3) + 4 >> 2] | 0) | 0;
   if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
   HEAP8[i9 + i5 >> 0] = i3;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i9 + i6 >> 0] = i4;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) <= (i8 | 0));
  i3 = i10 & -4;
 } else if (i3) i3 = 0; else {
  i7 = 0;
  do {
   i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i5 = tempRet0;
   i3 = (i2 & HEAP32[i11 + (i7 << 3) >> 2]) + (HEAP32[i11 + (i7 << 3) + 4 >> 2] | 0) | 0;
   i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i5 = _i64Add(i2 | 0, tempRet0 | 0, i5 | 0, 0) | 0;
   i2 = tempRet0;
   i1 = i7 | 1;
   i4 = (i5 & HEAP32[i11 + (i1 << 3) >> 2]) + (HEAP32[i11 + (i1 << 3) + 4 >> 2] | 0) | 0;
   if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
   HEAP8[i9 + i7 >> 0] = i3;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i9 + i1 >> 0] = i4;
   i1 = ___muldi3(i5 | 0, 0, -130063606, 0) | 0;
   i1 = _i64Add(i1 | 0, tempRet0 | 0, i2 | 0, 0) | 0;
   i2 = tempRet0;
   i5 = i7 | 2;
   i3 = (HEAP32[i11 + (i5 << 3) >> 2] & i1) + (HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0) | 0;
   i1 = ___muldi3(i1 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i1 | 0, tempRet0 | 0, i2 | 0, 0) | 0;
   i1 = tempRet0;
   i6 = i7 | 3;
   i4 = (HEAP32[i11 + (i6 << 3) >> 2] & i2) + (HEAP32[i11 + (i6 << 3) + 4 >> 2] | 0) | 0;
   if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
   HEAP8[i9 + i5 >> 0] = i3;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i9 + i6 >> 0] = i4;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) <= (i8 | 0));
  i3 = i10 & -4;
 }
 if ((i3 | 0) < (i10 | 0)) i4 = i3; else {
  i7 = i2;
  i9 = i1;
  i10 = i12;
  i8 = i10;
  HEAP32[i8 >> 2] = i7;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i13;
  return;
 }
 do {
  i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
  i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  i3 = (i2 & HEAP32[i11 + (i4 << 3) >> 2]) + (HEAP32[i11 + (i4 << 3) + 4 >> 2] | 0) | 0;
  if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
  HEAP8[i9 + i4 >> 0] = i3;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i10 | 0));
 i10 = i12;
 i9 = i10;
 HEAP32[i9 >> 2] = i2;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i13;
 return;
}

function __ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe(i19, i2, i15, i16, i3, i1, i17, i12) {
 i19 = i19 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i9 = i21;
 i4 = i21 + 136 | 0;
 i18 = i21 + 16 | 0;
 i8 = i21 + 12 | 0;
 i13 = i21 + 8 | 0;
 i5 = i21 + 134 | 0;
 i22 = i21 + 4 | 0;
 i7 = i21 + 124 | 0;
 i10 = i21 + 24 | 0;
 HEAP32[i18 >> 2] = i4;
 i14 = i18 + 4 | 0;
 HEAP32[i14 >> 2] = 384;
 __ZNKSt3__18ios_base6getlocEv(i13, i1);
 i2 = __ZNKSt3__16locale9use_facetERNS0_2idE(i13, 960728) | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i9 + 0 >> 2] = HEAP32[i22 + 0 >> 2];
 do if (__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_(i15, i9, i3, i13, i1, i17, i5, i2, i18, i8, i4 + 100 | 0) | 0) {
  FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] & 7](i2, 960344, 960354, i7) | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i18 >> 2] | 0;
  i2 = i3 - i4 | 0;
  if ((i2 | 0) > 98) {
   i2 = _malloc(i2 + 2 | 0) | 0;
   if (!i2) __ZSt17__throw_bad_allocv(); else {
    i11 = i2;
    i6 = i2;
   }
  } else {
   i11 = 0;
   i6 = i10;
  }
  if (!(HEAP8[i5 >> 0] | 0)) i2 = i6; else {
   HEAP8[i6 >> 0] = 45;
   i2 = i6 + 1 | 0;
  }
  if (i4 >>> 0 < i3 >>> 0) {
   i5 = i7 + 10 | 0;
   i6 = i7;
   do {
    i3 = HEAP8[i4 >> 0] | 0;
    i1 = i7;
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == i3 << 24 >> 24) break;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i5 | 0)) {
      i1 = i5;
      break;
     }
    }
    HEAP8[i2 >> 0] = HEAP8[960344 + (i1 - i6) >> 0] | 0;
    i4 = i4 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
  }
  HEAP8[i2 >> 0] = 0;
  HEAP32[i9 >> 2] = i12;
  if ((_sscanf(i10, 960360, i9) | 0) == 1) {
   _free(i11);
   break;
  } else __ZNSt3__121__throw_runtime_errorEPKc(960368);
 } while (0);
 i1 = HEAP32[i15 >> 2] | 0;
 do if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1) {
   HEAP32[i15 >> 2] = 0;
   i1 = 0;
   break;
  } else {
   i1 = HEAP32[i15 >> 2] | 0;
   break;
  }
 } else i1 = 0; while (0);
 i1 = (i1 | 0) == 0;
 i2 = HEAP32[i16 >> 2] | 0;
 do if (i2) {
  if ((HEAP32[i2 + 12 >> 2] | 0) != (HEAP32[i2 + 16 >> 2] | 0)) if (i1) break; else {
   i20 = 28;
   break;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0) != -1) if (i1) break; else {
   i20 = 28;
   break;
  } else {
   HEAP32[i16 >> 2] = 0;
   i20 = 26;
   break;
  }
 } else i20 = 26; while (0);
 if ((i20 | 0) == 26 ? i1 : 0) i20 = 28;
 if ((i20 | 0) == 28) HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | 2;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i13 >> 2] | 0) | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 HEAP32[i18 >> 2] = 0;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[i14 >> 2] & 511](i1);
 STACKTOP = i21;
 return;
}

function __ZNK7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8Iterator6EqualsERKNS0_22ParamIteratorInterfaceINSt3tr15tupleIS4_S6_vvvvvvvvEEEE(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i9 + 4 | 0;
 i1 = i9;
 i6 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] & 127](i8) | 0;
 if (!(__ZN7testing8internal6IsTrueEb((i6 | 0) == (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 127](i3) | 0)) | 0)) {
  __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i1, 3, 696, 13889);
  i6 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 1328, 59) | 0, 1392, 43) | 0, 1440, 26) | 0;
  __ZNKSt3__18ios_base6getlocEv(i2, i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 960728) | 0;
  i7 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] & 127](i7, 10) | 0;
  __ZNSt3__16localeD2Ev(i2);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i6, i7) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i6) | 0;
  __ZN7testing8internal8GTestLogD2Ev(i1);
 }
 if (!(__ZN7testing8internal6IsTrueEb((HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + -4 >> 2] | 0) + 4 >> 2] | 0) == 2192) | 0)) {
  __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i2, 3, 696, 2305);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 1472, 51) | 0;
  __ZN7testing8internal8GTestLogD2Ev(i2);
 }
 i7 = ___dynamic_cast(i3, 2384, 2392, 0) | 0;
 i6 = i8 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i8 + 12 >> 2] | 0;
 if ((((i3 | 0) != (i2 | 0) ? !(FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3, i2) | 0) : 0) ? (i4 = HEAP32[i8 + 28 >> 2] | 0, i5 = HEAP32[i8 + 24 >> 2] | 0, (i4 | 0) != (i5 | 0)) : 0) ? !(FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] & 127](i4, i5) | 0) : 0) i2 = i7 + 16 | 0; else {
  i2 = i7 + 16 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i7 + 12 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   i1 = 1;
   STACKTOP = i9;
   return i1 | 0;
  }
  if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i3) | 0) {
   i1 = 1;
   STACKTOP = i9;
   return i1 | 0;
  }
  i3 = HEAP32[i7 + 28 >> 2] | 0;
  i1 = HEAP32[i7 + 24 >> 2] | 0;
  if ((i3 | 0) == (i1 | 0)) {
   i1 = 1;
   STACKTOP = i9;
   return i1 | 0;
  }
  if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3, i1) | 0) {
   i1 = 1;
   STACKTOP = i9;
   return i1 | 0;
  }
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0) ? !(FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i2) | 0) : 0) {
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 i2 = HEAP32[i8 + 28 >> 2] | 0;
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i1 = 1;
  STACKTOP = i9;
  return i1 | 0;
 }
 i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1) | 0;
 STACKTOP = i9;
 return i1 | 0;
}

function __Z16RGBE_WriteHeaderP8_IO_FILEiiP16rgbe_header_info(i1, i6, i4, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, d9 = 0.0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i8;
 i3 = (i5 | 0) != 0;
 if (i3 ? (HEAP32[i5 >> 2] & 1 | 0) != 0 : 0) i2 = i5 + 4 | 0; else i2 = 181320;
 HEAP32[i7 >> 2] = i2;
 if ((_fprintf(i1 | 0, 181328, i7 | 0) | 0) < 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i7, 16) | 0) + 0 | 0;
  i2 = 181784 | 0;
  i3 = i1 + 16 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i7, 181704, 181720, 93);
  __ZN2cv6String10deallocateEv(i7);
  i1 = -1;
  STACKTOP = i8;
  return i1 | 0;
 }
 if (i3) {
  i3 = HEAP32[i5 >> 2] | 0;
  do if (i3 & 2) {
   d9 = +Math_fround(HEAPF32[i5 + 20 >> 2]);
   HEAPF64[tempDoublePtr >> 3] = d9;
   HEAP32[i7 >> 2] = HEAP32[tempDoublePtr >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
   if ((_fprintf(i1 | 0, 181336, i7 | 0) | 0) >= 0) {
    i3 = HEAP32[i5 >> 2] | 0;
    break;
   }
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i7, 16) | 0) + 0 | 0;
   i2 = 181784 | 0;
   i3 = i1 + 16 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i7, 181704, 181720, 93);
   __ZN2cv6String10deallocateEv(i7);
   i1 = -1;
   STACKTOP = i8;
   return i1 | 0;
  } while (0);
  if ((i3 & 4 | 0) != 0 ? (d9 = +Math_fround(HEAPF32[i5 + 24 >> 2]), HEAPF64[tempDoublePtr >> 3] = d9, HEAP32[i7 >> 2] = HEAP32[tempDoublePtr >> 2], HEAP32[i7 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2], (_fprintf(i1 | 0, 181352, i7 | 0) | 0) < 0) : 0) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i7, 16) | 0) + 0 | 0;
   i2 = 181784 | 0;
   i3 = i1 + 16 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i7, 181704, 181720, 93);
   __ZN2cv6String10deallocateEv(i7);
   i1 = -1;
   STACKTOP = i8;
   return i1 | 0;
  }
 }
 if ((_fprintf(i1 | 0, 181368, i7 | 0) | 0) < 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i7, 16) | 0) + 0 | 0;
  i2 = 181784 | 0;
  i3 = i1 + 16 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i7, 181704, 181720, 93);
  __ZN2cv6String10deallocateEv(i7);
  i1 = -1;
  STACKTOP = i8;
  return i1 | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 if ((_fprintf(i1 | 0, 181400, i7 | 0) | 0) >= 0) {
  i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 }
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i1 = (__ZN2cv6String8allocateEj(i7, 16) | 0) + 0 | 0;
 i2 = 181784 | 0;
 i3 = i1 + 16 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i7, 181704, 181720, 93);
 __ZN2cv6String10deallocateEv(i7);
 i1 = -1;
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN2cvL6recip_IhEEvPKT_jS3_jPS1_jNS_5Size_IiEEd(i2, i23, i1, i22, i21, d20) {
 i2 = i2 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 d20 = +d20;
 var i3 = 0, i4 = 0, i5 = 0, d6 = 0.0, d7 = 0.0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i24 = 0, d25 = 0.0, d26 = 0.0;
 i24 = STACKTOP;
 i15 = i21 + 4 | 0;
 i11 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = i11 + -1;
 if (!i11) {
  STACKTOP = i24;
  return;
 }
 i13 = i2;
 i2 = HEAP32[i21 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i3 = 0; else {
   i3 = 0;
   do {
    i4 = HEAP8[i13 + i3 >> 0] | 0;
    i12 = i3 | 1;
    i5 = i13 + i12 | 0;
    do if (!(i4 << 24 >> 24)) {
     i11 = 0;
     i14 = 20;
    } else {
     i11 = HEAP8[i5 >> 0] | 0;
     i2 = i11 & 255;
     if ((i11 << 24 >> 24 != 0 ? (i16 = i3 | 2, i17 = HEAP8[i13 + i16 >> 0] | 0, i17 << 24 >> 24 != 0) : 0) ? (i18 = i3 | 3, i19 = HEAP8[i13 + i18 >> 0] | 0, i19 << 24 >> 24 != 0) : 0) {
      d25 = +(i2 | 0);
      d26 = +(i4 & 255) * d25;
      d7 = +(i19 & 255 | 0);
      d6 = +(i17 & 255) * d7;
      d8 = d20 / (d26 * d6);
      d6 = d6 * d8;
      d8 = d26 * d8;
      i5 = _lrint(d25 * d6) | 0;
      if (i5 >>> 0 < 256) i9 = i5; else i9 = (i5 | 0) > 0 ? 255 : 0;
      i2 = _lrint(d6 * +(i4 & 255 | 0)) | 0;
      if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
      i4 = _lrint(d8 * d7) | 0;
      if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
      i5 = _lrint(d8 * +(i17 & 255 | 0)) | 0;
      if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
      HEAP8[i1 + i3 >> 0] = i9;
      HEAP8[i1 + i12 >> 0] = i2;
      HEAP8[i1 + i16 >> 0] = i4;
      HEAP8[i1 + i18 >> 0] = i5;
      break;
     }
     i2 = _lrint(d20 / +(i4 & 255 | 0)) | 0;
     if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
     i11 = i2 & 255;
     i14 = 20;
    } while (0);
    if ((i14 | 0) == 20) {
     i14 = 0;
     i2 = HEAP8[i5 >> 0] | 0;
     if (!(i2 << 24 >> 24)) i9 = 0; else {
      i2 = _lrint(d20 / +(i2 & 255 | 0)) | 0;
      if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
      i9 = i2 & 255;
     }
     i10 = i3 | 2;
     i5 = HEAP8[i13 + i10 >> 0] | 0;
     if (!(i5 << 24 >> 24)) i2 = 0; else {
      i2 = _lrint(d20 / +(i5 & 255 | 0)) | 0;
      if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
      i2 = i2 & 255;
     }
     i4 = i3 | 3;
     i5 = HEAP8[i13 + i4 >> 0] | 0;
     if (!(i5 << 24 >> 24)) i5 = 0; else {
      i5 = _lrint(d20 / +(i5 & 255 | 0)) | 0;
      if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
      i5 = i5 & 255;
     }
     HEAP8[i1 + i3 >> 0] = i11;
     HEAP8[i1 + i12 >> 0] = i9;
     HEAP8[i1 + i10 >> 0] = i2;
     HEAP8[i1 + i4 >> 0] = i5;
    }
    i3 = i3 + 4 | 0;
    i2 = HEAP32[i21 >> 2] | 0;
   } while ((i3 | 0) <= (i2 + -4 | 0));
  }
  if ((i3 | 0) < (i2 | 0)) do {
   i2 = HEAP8[i13 + i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) i2 = 0; else {
    i2 = _lrint(d20 / +(i2 & 255 | 0)) | 0;
    if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
    i2 = i2 & 255;
   }
   HEAP8[i1 + i3 >> 0] = i2;
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i21 >> 2] | 0;
  } while ((i3 | 0) < (i2 | 0));
  i11 = HEAP32[i15 >> 2] | 0;
  HEAP32[i15 >> 2] = i11 + -1;
  if (!i11) break; else {
   i1 = i1 + i22 | 0;
   i13 = i13 + i23 | 0;
  }
 }
 STACKTOP = i24;
 return;
}

function __ZNSt3__16vectorINS_4pairIN2cv6StringENS2_5ParamEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i12, i7) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 i10 = i12 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = (((HEAP32[i10 >> 2] | 0) - i1 | 0) / 44 | 0) + 1 | 0;
 if (i3 >>> 0 > 97612893) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i11 = i12 + 8 | 0;
 i2 = ((HEAP32[i11 >> 2] | 0) - i1 | 0) / 44 | 0;
 if (i2 >>> 0 < 48806446) {
  i2 = i2 << 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i3 = ((HEAP32[i10 >> 2] | 0) - i1 | 0) / 44 | 0;
  if (!i2) {
   i1 = 0;
   i9 = 0;
   i4 = i3;
  } else i5 = 6;
 } else {
  i2 = 97612893;
  i3 = ((HEAP32[i10 >> 2] | 0) - i1 | 0) / 44 | 0;
  i5 = 6;
 }
 if ((i5 | 0) == 6) {
  i1 = i2;
  i9 = __Znwj(i2 * 44 | 0) | 0;
  i4 = i3;
 }
 i3 = i9 + (i4 * 44 | 0) | 0;
 i8 = i9 + (i1 * 44 | 0) | 0;
 if (i3) {
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 + (i4 * 44 | 0) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  if (i2) {
   i6 = i2 + -4 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  }
  i2 = i9 + (i4 * 44 | 0) + 8 | 0;
  i6 = i7 + 8 | 0;
  HEAP32[i2 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
  i2 = HEAP32[i7 + 36 >> 2] | 0;
  HEAP32[i9 + (i4 * 44 | 0) + 36 >> 2] = i2;
  HEAP32[i9 + (i4 * 44 | 0) + 40 >> 2] = HEAP32[i7 + 40 >> 2];
  if (i2) {
   i7 = i2 + -4 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  }
 }
 i7 = i9 + ((i4 + 1 | 0) * 44 | 0) | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i6 | 0)) {
  i2 = i6;
  i1 = i6;
 } else {
  i5 = i4 + -1 - (((i2 + -44 - i6 | 0) >>> 0) / 44 | 0) | 0;
  while (1) {
   i4 = i2;
   i2 = i2 + -44 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 + -44 >> 2] = i1;
   HEAP32[i3 + -40 >> 2] = HEAP32[i4 + -40 >> 2];
   if (i1) {
    i1 = i1 + -4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   }
   i1 = i3 + -36 | 0;
   i14 = i4 + -36 | 0;
   HEAP32[i1 + 0 >> 2] = HEAP32[i14 + 0 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
   i1 = HEAP32[i4 + -8 >> 2] | 0;
   HEAP32[i3 + -8 >> 2] = i1;
   HEAP32[i3 + -4 >> 2] = HEAP32[i4 + -4 >> 2];
   if (i1) {
    i4 = i1 + -4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   }
   if ((i2 | 0) == (i6 | 0)) break; else i3 = i3 + -44 | 0;
  }
  i3 = i9 + (i5 * 44 | 0) | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i3;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i11 >> 2] = i8;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) break;
  i10 = i1 + -44 | 0;
  __ZN2cv6String10deallocateEv(i1 + -8 | 0);
  __ZN2cv6String10deallocateEv(i10);
  i1 = i10;
 }
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i13;
 return;
}

function __ZL10rgbe_erroriPKc(i3, i13) {
 i3 = i3 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i2 = i14 + 56 | 0;
 i1 = i14 + 48 | 0;
 i7 = i14 + 40 | 0;
 i8 = i14 + 32 | 0;
 i9 = i14 + 24 | 0;
 i10 = i14 + 16 | 0;
 i11 = i14 + 8 | 0;
 i12 = i14;
 if (!i3) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i2, 15) | 0) + 0 | 0;
  i5 = 181688 | 0;
  i6 = i4 + 15 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i2, 181704, 181720, 90);
  __ZN2cv6String10deallocateEv(i2);
  STACKTOP = i14;
  return;
 } else if ((i3 | 0) == 2) {
  HEAP32[i8 >> 2] = 0;
  i3 = i8 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i8, 22) | 0) + 0 | 0;
  i5 = 181808 | 0;
  i6 = i4 + 22 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  HEAP32[i9 >> 2] = 0;
  i2 = i9 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  if (!i13) i1 = 0; else {
   i1 = _strlen(i13 | 0) | 0;
   _memcpy(__ZN2cv6String8allocateEj(i9, i1) | 0, i13 | 0, i1 | 0) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i7, i1 + (HEAP32[i3 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  _memcpy((HEAP32[i7 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i7, 181704, 181720, 97);
  __ZN2cv6String10deallocateEv(i7);
  __ZN2cv6String10deallocateEv(i9);
  __ZN2cv6String10deallocateEv(i8);
  STACKTOP = i14;
  return;
 } else if ((i3 | 0) == 1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i1, 16) | 0) + 0 | 0;
  i5 = 181784 | 0;
  i6 = i4 + 16 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i1, 181704, 181720, 93);
  __ZN2cv6String10deallocateEv(i1);
  STACKTOP = i14;
  return;
 } else {
  HEAP32[i11 >> 2] = 0;
  i3 = i11 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i11, 13) | 0) + 0 | 0;
  i5 = 181832 | 0;
  i6 = i4 + 13 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  HEAP32[i12 >> 2] = 0;
  i2 = i12 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  if (!i13) i1 = 0; else {
   i1 = _strlen(i13 | 0) | 0;
   _memcpy(__ZN2cv6String8allocateEj(i12, i1) | 0, i13 | 0, i1 | 0) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i10, i1 + (HEAP32[i3 >> 2] | 0) | 0) | 0;
  _memcpy(HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  _memcpy((HEAP32[i10 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) | 0, HEAP32[i12 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i10, 181704, 181720, 102);
  __ZN2cv6String10deallocateEv(i10);
  __ZN2cv6String10deallocateEv(i12);
  __ZN2cv6String10deallocateEv(i11);
  STACKTOP = i14;
  return;
 }
}

function _cvSeqPushMulti(i14, i2, i3, i8) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i15 + 8 | 0;
 i1 = i15;
 if (!i14) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i4, 21) | 0) + 0 | 0;
  i6 = 40256 | 0;
  i7 = i5 + 21 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i4, 40280, 39608, 1458);
  __ZN2cv6String10deallocateEv(i4);
 }
 if ((i3 | 0) < 0) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i1, 38) | 0) + 0 | 0;
  i6 = 40296 | 0;
  i7 = i5 + 38 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i1, 40280, 39608, 1460);
  __ZN2cv6String10deallocateEv(i1);
 }
 i13 = HEAP32[i14 + 28 >> 2] | 0;
 if (!i8) {
  if ((i3 | 0) <= 0) {
   STACKTOP = i15;
   return;
  }
  i6 = i14 + 32 | 0;
  i5 = i14 + 36 | 0;
  i9 = i14 + 52 | 0;
  i10 = i14 + 24 | 0;
  i1 = i3;
  while (1) {
   i4 = HEAP32[i5 >> 2] | 0;
   i8 = ((HEAP32[i6 >> 2] | 0) - i4 | 0) / (i13 | 0) | 0;
   i8 = (i8 | 0) > (i1 | 0) ? i1 : i8;
   if ((i8 | 0) > 0) {
    i7 = (HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + 12 | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i8;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i8;
    i7 = Math_imul(i8, i13) | 0;
    if (!i2) i2 = 0; else {
     _memcpy(i4 | 0, i2 | 0, i7 | 0) | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i2 = i2 + i7 | 0;
    }
    HEAP32[i5 >> 2] = i4 + i7;
    i1 = i1 - i8 | 0;
   }
   if ((i1 | 0) <= 0) break;
   __ZL10icvGrowSeqP5CvSeqi(i14, 0);
  }
  STACKTOP = i15;
  return;
 }
 i10 = i14 + 52 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i3 | 0) <= 0) {
  STACKTOP = i15;
  return;
 }
 i9 = i14 + 24 | 0;
 if (!i2) {
  do {
   if ((i1 | 0) != 0 ? (i11 = HEAP32[i1 + 8 >> 2] | 0, (i11 | 0) != 0) : 0) i2 = i11; else {
    __ZL10icvGrowSeqP5CvSeqi(i14, 1);
    i1 = HEAP32[i10 >> 2] | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
   }
   i7 = (i2 | 0) > (i3 | 0) ? i3 : i2;
   i3 = i3 - i7 | 0;
   HEAP32[i1 + 8 >> 2] = i2 - i7;
   i8 = i1 + 12 | 0;
   HEAP32[i8 >> 2] = i7 + (HEAP32[i8 >> 2] | 0);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i7;
   i7 = Math_imul(i7, i13) | 0;
   i8 = i1 + 16 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (0 - i7);
  } while ((i3 | 0) > 0);
  STACKTOP = i15;
  return;
 } else {
  do {
   if ((i1 | 0) != 0 ? (i12 = HEAP32[i1 + 8 >> 2] | 0, (i12 | 0) != 0) : 0) i4 = i12; else {
    __ZL10icvGrowSeqP5CvSeqi(i14, 1);
    i1 = HEAP32[i10 >> 2] | 0;
    i4 = HEAP32[i1 + 8 >> 2] | 0;
   }
   i8 = (i4 | 0) > (i3 | 0) ? i3 : i4;
   i3 = i3 - i8 | 0;
   HEAP32[i1 + 8 >> 2] = i4 - i8;
   i6 = i1 + 12 | 0;
   HEAP32[i6 >> 2] = i8 + (HEAP32[i6 >> 2] | 0);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i8;
   i8 = Math_imul(i8, i13) | 0;
   i6 = i1 + 16 | 0;
   i7 = (HEAP32[i6 >> 2] | 0) + (0 - i8) | 0;
   HEAP32[i6 >> 2] = i7;
   _memcpy(i7 | 0, i2 + (Math_imul(i3, i13) | 0) | 0, i8 | 0) | 0;
  } while ((i3 | 0) > 0);
  STACKTOP = i15;
  return;
 }
}

function __ZNSt3__16vectorIN2cv23CommandLineParserParamsENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i12, i5) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i11 = i13;
 i9 = i12 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = ((HEAP32[i9 >> 2] | 0) - i1 >> 5) + 1 | 0;
 if (i3 >>> 0 > 134217727) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i10 = i12 + 8 | 0;
 i2 = (HEAP32[i10 >> 2] | 0) - i1 | 0;
 if (i2 >> 5 >>> 0 < 67108863) {
  i8 = i2 >> 4;
  i3 = i8 >>> 0 < i3 >>> 0 ? i3 : i8;
 } else i3 = 134217727;
 i4 = (HEAP32[i9 >> 2] | 0) - i1 >> 5;
 i6 = i11 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = i12 + 8;
 if (!i3) i1 = 0; else i1 = __Znwj(i3 << 5) | 0;
 HEAP32[i11 >> 2] = i1;
 i2 = i1 + (i4 << 5) | 0;
 i7 = i11 + 8 | 0;
 HEAP32[i7 >> 2] = i2;
 i8 = i11 + 4 | 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i6 >> 2] = i1 + (i3 << 5);
 if (!i2) {
  i1 = 0;
  i2 = 0;
 } else {
  i3 = HEAP32[i5 >> 2] | 0;
  HEAP32[i2 >> 2] = i3;
  HEAP32[i1 + (i4 << 5) + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  if (i3) {
   i3 = i3 + -4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  }
  i3 = HEAP32[i5 + 8 >> 2] | 0;
  HEAP32[i1 + (i4 << 5) + 8 >> 2] = i3;
  HEAP32[i1 + (i4 << 5) + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  if (i3) {
   i3 = i3 + -4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  }
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i1 + (i4 << 5) + 16 | 0, i5 + 16 | 0);
  HEAP32[i1 + (i4 << 5) + 28 >> 2] = HEAP32[i5 + 28 >> 2];
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i3 = i2 + 32 | 0;
 HEAP32[i7 >> 2] = i3;
 i5 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) == (i5 | 0)) {
  i2 = i1;
  i4 = i5;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i5;
  i9 = HEAP32[i10 >> 2] | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  HEAP32[i10 >> 2] = i8;
  HEAP32[i6 >> 2] = i9;
  HEAP32[i11 >> 2] = i4;
  __ZNSt3__114__split_bufferIN2cv23CommandLineParserParamsERNS_9allocatorIS2_EEED2Ev(i11);
  STACKTOP = i13;
  return;
 } else i4 = i1;
 do {
  i1 = i2;
  i2 = i2 + -32 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 + -32 >> 2] = i3;
  HEAP32[i4 + -28 >> 2] = HEAP32[i1 + -28 >> 2];
  if (i3) {
   i3 = i3 + -4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  }
  i3 = HEAP32[i1 + -24 >> 2] | 0;
  HEAP32[i4 + -24 >> 2] = i3;
  HEAP32[i4 + -20 >> 2] = HEAP32[i1 + -20 >> 2];
  if (i3) {
   i3 = i3 + -4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  }
  __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i4 + -16 | 0, i1 + -16 | 0);
  HEAP32[i4 + -4 >> 2] = HEAP32[i1 + -4 >> 2];
  i4 = (HEAP32[i8 >> 2] | 0) + -32 | 0;
  HEAP32[i8 >> 2] = i4;
 } while ((i2 | 0) != (i5 | 0));
 i2 = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i12 >> 2] = i2;
 HEAP32[i8 >> 2] = i5;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i7 >> 2] = i4;
 i9 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i6 >> 2] = i9;
 HEAP32[i11 >> 2] = i5;
 __ZNSt3__114__split_bufferIN2cv23CommandLineParserParamsERNS_9allocatorIS2_EEED2Ev(i11);
 STACKTOP = i13;
 return;
}

function __GLOBAL__I_a() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i4 = i8 + 24 | 0;
 i5 = i8 + 12 | 0;
 i7 = i8;
 HEAP32[2] = 320;
 HEAP32[3] = 240;
 HEAP32[4] = 640;
 HEAP32[5] = 480;
 HEAP32[6] = 800;
 HEAP32[7] = 600;
 HEAP32[8] = 1024;
 HEAP32[9] = 768;
 HEAP32[10] = 1280;
 HEAP32[11] = 1024;
 HEAP32[12] = 2560;
 HEAP32[13] = 1440;
 HEAP32[14] = 640;
 HEAP32[15] = 360;
 HEAP32[16] = 960;
 HEAP32[17] = 540;
 HEAP32[18] = HEAP32[2];
 HEAP32[19] = HEAP32[3];
 HEAP32[20] = 1280;
 HEAP32[21] = 720;
 HEAP32[22] = 1920;
 HEAP32[23] = 1080;
 HEAP32[24] = HEAP32[12];
 HEAP32[25] = HEAP32[13];
 HEAP32[26] = 3840;
 HEAP32[27] = 2160;
 HEAP32[28] = 7680;
 HEAP32[29] = 4320;
 HEAP32[30] = 2048;
 HEAP32[31] = 1536;
 HEAP32[32] = 2592;
 HEAP32[33] = 1944;
 HEAP32[34] = 2048;
 HEAP32[35] = 2048;
 HEAP32[36] = 127;
 HEAP32[37] = 61;
 HEAP32[38] = 24;
 HEAP32[39] = 24;
 HEAP32[40] = 32;
 HEAP32[41] = 32;
 HEAP32[42] = 64;
 HEAP32[43] = 64;
 HEAP32[44] = 128;
 HEAP32[45] = 128;
 i2 = __ZN7testing8internal29ParameterizedTestCaseRegistry24GetTestCasePatternHolderI24Size_MatType_bitwise_notEEPNS0_25ParameterizedTestCaseInfoIT_EEPKcS9_i(__ZN7testing8UnitTest27parameterized_test_registryEv(__ZN7testing8UnitTest11GetInstanceEv() | 0) | 0, 200, 232, 26) | 0;
 i1 = __Znwj(4) | 0;
 HEAP32[i1 >> 2] = 3376;
 __ZN7testing8internal25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE14AddTestPatternEPKcS5_PNS0_19TestMetaFactoryBaseINSt3tr15tupleIN2cv5Size_IiEEN4perf7MatTypeEvvvvvvvvEEEE(i2, 200, 3352, i1);
 HEAP32[46] = 0;
 i1 = __ZN7testing8internal29ParameterizedTestCaseRegistry24GetTestCasePatternHolderI24Size_MatType_bitwise_notEEPNS0_25ParameterizedTestCaseInfoIT_EEPKcS9_i(__ZN7testing8UnitTest27parameterized_test_registryEv(__ZN7testing8UnitTest11GetInstanceEv() | 0) | 0, 200, 232, 26) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, 296, 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i5, i7);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i4, i5);
 i2 = i4 + 12 | 0;
 HEAP32[i2 >> 2] = 346;
 i6 = i1 + 32 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i1 + 36 >> 2] | 0)) {
  __ZNSt3__16vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPFN7testing8internal14ParamGeneratorINSt3tr15tupleIN2cv5Size_IiEEN4perf7MatTypeEvvvvvvvvEEEEvEEENS5_ISM_EEE21__push_back_slow_pathIKSM_EEvRT_(i1 + 28 | 0, i4);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
  HEAP32[48] = 0;
  STACKTOP = i8;
  return;
 }
 if (!i3) i1 = 0; else {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i3, i4);
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 >> 2];
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = i1 + 16;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 HEAP32[48] = 0;
 STACKTOP = i8;
 return;
}

function __ZN7testing8internal30GetBoolAssertionFailureMessageERKNS_15AssertionResultEPKcS5_S5_(i8, i2, i6, i4, i5) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i10 + 4 | 0;
 i9 = i10;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 do if (i2) if (!(HEAP8[i2 >> 0] & 1)) {
  i1 = i2 + 1 | 0;
  break;
 } else {
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  break;
 } else i1 = 159968; while (0);
 __ZN7testing7MessageC2Ev(i9);
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = i3 + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 160560, 10) | 0;
 if (!i6) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i6, _strlen(i6 | 0) | 0) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 160576, 11) | 0;
 if (!i4) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i4, _strlen(i4 | 0) | 0) | 0;
 if (HEAP8[i1 >> 0] | 0) {
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 160648, 2) | 0;
  if (!i1) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i1, _strlen(i1 | 0) | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 160656, 1) | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 160592, 11) | 0;
 if (!i5) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i5, _strlen(i5 | 0) | 0) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i7, i3 + 12 | 0);
 i1 = HEAP8[i7 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i7 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i7 + 8 >> 2] | 0;
  i1 = HEAP32[i7 + 4 >> 2] | 0;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i8, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i8, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i8, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZNK12_GLOBAL__N_115MatlabFormatter6formatERKN2cv3MatE(i19, i1, i8) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i17 = i20 + 64 | 0;
 i18 = i20 + 56 | 0;
 i12 = i20;
 i7 = i20 + 72 | 0;
 HEAP8[i7 + 0 >> 0] = HEAP8[8680] | 0;
 HEAP8[i7 + 1 >> 0] = HEAP8[8681] | 0;
 HEAP8[i7 + 2 >> 0] = HEAP8[8682] | 0;
 HEAP8[i7 + 3 >> 0] = HEAP8[8683] | 0;
 HEAP8[i7 + 4 >> 0] = HEAP8[8684] | 0;
 i2 = i8 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) == 1) i6 = 1; else i6 = (HEAP32[i1 + 12 >> 2] | 0) == 0 & 1;
 i5 = (HEAP32[i8 >> 2] & 7 | 0) == 6 ? i1 + 8 | 0 : i1 + 4 | 0;
 i16 = __Znwj(156) | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 __ZN2cv6String8allocateEj(i17, 0) | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 __ZN2cv6String8allocateEj(i18, 0) | 0;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 i14 = i12 + 4 | 0;
 i3 = i8 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = i1;
 i15 = i12 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i9 = i12 + 16 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 HEAP32[i12 + 32 >> 2] = HEAP32[i8 + 32 >> 2];
 i10 = i12 + 36 | 0;
 i4 = HEAP32[i8 + 36 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 i11 = i12 + 40 | 0;
 HEAP32[i11 >> 2] = i15;
 i15 = i12 + 48 | 0;
 i13 = i12 + 44 | 0;
 HEAP32[i13 >> 2] = i15;
 HEAP32[i12 + 52 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 if (!i4) i2 = i1; else {
  i2 = i4 + 12 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 if ((i2 | 0) < 3) {
  i4 = HEAP32[i8 + 44 >> 2] | 0;
  i8 = HEAP32[i13 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 } else {
  HEAP32[i14 >> 2] = 0;
  __ZN2cv3Mat8copySizeERKS0_(i12, i8);
 }
 __ZN12_GLOBAL__N_113FormattedImplC2EN2cv6StringES2_NS1_3MatEPcbbi(i16, i17, i18, i12, i7, i6 << 24 >> 24 != 0, 1, HEAP32[i5 >> 2] | 0);
 i3 = __Znwj(16) | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i3 >> 2] = 7312;
 HEAP32[i3 + 8 >> 2] = i16;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i7 = i2 + 12 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i12);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 if ((HEAP32[i14 >> 2] | 0) > 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i14 >> 2] | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) != (i15 | 0)) __ZN2cv8fastFreeEPv(i1);
 __ZN2cv6String10deallocateEv(i18);
 __ZN2cv6String10deallocateEv(i17);
 HEAP32[i19 >> 2] = i3;
 HEAP32[i19 + 4 >> 2] = i16;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i10 + -1;
 if ((i10 | 0) != 1) {
  STACKTOP = i20;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
 STACKTOP = i20;
 return;
}

function __ZNK2cv5MatOp17augAssignMultiplyERKNS_7MatExprERNS_3MatE(i1, i3, i10) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 i5 = i18 + 176 | 0;
 i6 = i18 + 156 | 0;
 i7 = i18 + 136 | 0;
 i12 = i18 + 80 | 0;
 i9 = i18 + 56 | 0;
 i14 = i18;
 HEAP32[i14 >> 2] = 1124007936;
 i16 = i14 + 4 | 0;
 i2 = i14 + 8 | 0;
 i13 = i14 + 40 | 0;
 i1 = i16 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i13 >> 2] = i2;
 i17 = i14 + 48 | 0;
 i15 = i14 + 44 | 0;
 HEAP32[i15 >> 2] = i17;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 i11 = HEAP32[i3 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] & 63](i11, i3, i14, -1);
 HEAP32[i5 >> 2] = 32088;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 16842752;
 HEAP32[i5 + 8 >> 2] = i10;
 HEAP32[i6 >> 2] = 32088;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 16842752;
 HEAP32[i6 + 8 >> 2] = i14;
 HEAP32[i12 >> 2] = 1124007936;
 i11 = i12 + 4 | 0;
 i2 = i12 + 8 | 0;
 i3 = i12 + 40 | 0;
 i1 = i11 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i3 >> 2] = i2;
 i8 = i12 + 48 | 0;
 i4 = i12 + 44 | 0;
 HEAP32[i4 >> 2] = i8;
 HEAP32[i12 + 52 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 >> 2] = 32088;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 16842752;
 HEAP32[i7 + 8 >> 2] = i12;
 i2 = i9 + 4 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i9 >> 2] = 32232;
 HEAP32[i2 >> 2] = 33619968;
 HEAP32[i9 + 8 >> 2] = i10;
 __ZN2cv4gemmERKNS_11_InputArrayES2_dS2_dRKNS_12_OutputArrayEi(i5, i6, 1.0, i7, 0.0, i9, 0);
 i2 = i12 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i12);
 HEAP32[i2 >> 2] = 0;
 i10 = i12 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i11 >> 2] | 0) > 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i11 >> 2] | 0));
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i8 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i14 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
 HEAP32[i2 >> 2] = 0;
 i10 = i14 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i16 >> 2] | 0) > 0) {
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i16 >> 2] | 0));
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) == (i17 | 0)) {
  STACKTOP = i18;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i18;
 return;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_(i5, i8, i1, i14, i13, i2, i9, i12) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i11 = i15;
 i4 = (i1 | 0) == (i14 | 0);
 L1 : do if (!i4) {
  i3 = i1;
  while (1) {
   if (!(HEAP8[i3 >> 0] | 0)) break;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i14 | 0)) {
    i3 = i14;
    break;
   }
  }
  HEAP32[i12 >> 2] = i2;
  HEAP32[i13 >> 2] = i1;
  if (!(i4 | (i2 | 0) == (i9 | 0))) {
   i7 = i9;
   i10 = i5 + 8 | 0;
   while (1) {
    i4 = i8;
    i5 = HEAP32[i4 + 4 >> 2] | 0;
    i6 = i11;
    HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i6 + 4 >> 2] = i5;
    i6 = i3;
    i5 = _uselocale(HEAP32[i10 >> 2] | 0) | 0;
    i4 = _mbsnrtowcs(i2, i13, i6 - i1 | 0, i7 - i2 >> 2, i8) | 0;
    if (i5) _uselocale(i5 | 0) | 0;
    if ((i4 | 0) == -1) {
     i5 = 10;
     break;
    } else if (!i4) {
     i1 = 2;
     i5 = 32;
     break;
    }
    i2 = (HEAP32[i12 >> 2] | 0) + (i4 << 2) | 0;
    HEAP32[i12 >> 2] = i2;
    if ((i2 | 0) == (i9 | 0)) {
     i5 = 30;
     break;
    }
    i1 = HEAP32[i13 >> 2] | 0;
    if ((i3 | 0) == (i14 | 0)) i3 = i14; else {
     i4 = _uselocale(HEAP32[i10 >> 2] | 0) | 0;
     i3 = _mbrtowc(i2, i1, 1, i8) | 0;
     if (i4) _uselocale(i4 | 0) | 0;
     if (i3) {
      i1 = 2;
      i5 = 32;
      break;
     }
     HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 4;
     i1 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
     HEAP32[i13 >> 2] = i1;
     L21 : do if ((i1 | 0) == (i14 | 0)) i3 = i14; else {
      i3 = i1;
      while (1) {
       if (!(HEAP8[i3 >> 0] | 0)) break L21;
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i14 | 0)) {
        i3 = i14;
        break;
       }
      }
     } while (0);
     i2 = HEAP32[i12 >> 2] | 0;
    }
    if ((i1 | 0) == (i14 | 0) | (i2 | 0) == (i9 | 0)) break L1;
   }
   if ((i5 | 0) == 10) {
    HEAP32[i12 >> 2] = i2;
    L29 : do if ((i1 | 0) != (HEAP32[i13 >> 2] | 0)) {
     while (1) {
      i3 = _uselocale(HEAP32[i10 >> 2] | 0) | 0;
      i2 = _mbrtowc(i2, i1, i6 - i1 | 0, i11) | 0;
      if (i3) _uselocale(i3 | 0) | 0;
      if (!i2) i1 = i1 + 1 | 0; else if ((i2 | 0) == -1) {
       i5 = 15;
       break;
      } else if ((i2 | 0) == -2) {
       i5 = 16;
       break;
      } else i1 = i1 + i2 | 0;
      i2 = (HEAP32[i12 >> 2] | 0) + 4 | 0;
      HEAP32[i12 >> 2] = i2;
      if ((i1 | 0) == (HEAP32[i13 >> 2] | 0)) break L29;
     }
     if ((i5 | 0) == 15) {
      HEAP32[i13 >> 2] = i1;
      i10 = 2;
      STACKTOP = i15;
      return i10 | 0;
     } else if ((i5 | 0) == 16) {
      HEAP32[i13 >> 2] = i1;
      i10 = 1;
      STACKTOP = i15;
      return i10 | 0;
     }
    } while (0);
    HEAP32[i13 >> 2] = i1;
    i10 = (i1 | 0) != (i14 | 0) & 1;
    STACKTOP = i15;
    return i10 | 0;
   } else if ((i5 | 0) == 30) {
    i1 = HEAP32[i13 >> 2] | 0;
    break;
   } else if ((i5 | 0) == 32) {
    STACKTOP = i15;
    return i1 | 0;
   }
  }
 } else {
  HEAP32[i12 >> 2] = i2;
  HEAP32[i13 >> 2] = i1;
 } while (0);
 i10 = (i1 | 0) != (i14 | 0) & 1;
 STACKTOP = i15;
 return i10 | 0;
}

function _gz_look(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 i12 = i13 + 84 | 0;
 i9 = i13 + 24 | 0;
 do if (!(HEAP32[i9 >> 2] | 0)) {
  i2 = HEAP32[i13 + 28 >> 2] | 0;
  i1 = _malloc(i2) | 0;
  i6 = i13 + 32 | 0;
  HEAP32[i6 >> 2] = i1;
  i4 = _malloc(i2 << 1) | 0;
  i5 = i13 + 36 | 0;
  HEAP32[i5 >> 2] = i4;
  i3 = (i4 | 0) == 0;
  if (!((i1 | 0) == 0 | i3)) {
   HEAP32[i9 >> 2] = i2;
   HEAP32[i13 + 116 >> 2] = 0;
   HEAP32[i13 + 120 >> 2] = 0;
   HEAP32[i13 + 124 >> 2] = 0;
   i3 = i13 + 88 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
   if (!(_inflateInit2_(i12, 31, 143344, 56) | 0)) {
    i10 = i3;
    break;
   }
   _free(HEAP32[i5 >> 2] | 0);
   _free(HEAP32[i6 >> 2] | 0);
   HEAP32[i9 >> 2] = 0;
   _gz_error(i13, -4, 143328);
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
  if (!i3) {
   _free(i4);
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (i1) _free(i1);
  _gz_error(i13, -4, 143328);
  i10 = -1;
  STACKTOP = i14;
  return i10 | 0;
 } else i10 = i13 + 88 | 0; while (0);
 i1 = HEAP32[i10 >> 2] | 0;
 do if (i1 >>> 0 < 2) {
  i8 = HEAP32[i13 + 76 >> 2] | 0;
  if (!((i8 | 0) == -5 | (i8 | 0) == 0)) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
  i7 = i13 + 52 | 0;
  if (!(HEAP32[i7 >> 2] | 0)) {
   i8 = i13 + 32 | 0;
   if (!i1) i2 = 0; else {
    i4 = HEAP32[i8 >> 2] | 0;
    i3 = HEAP32[i12 >> 2] | 0;
    while (1) {
     HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
     i1 = i1 + -1 | 0;
     if (!i1) break; else {
      i4 = i4 + 1 | 0;
      i3 = i3 + 1 | 0;
     }
    }
    i2 = HEAP32[i10 >> 2] | 0;
   }
   i3 = HEAP32[i8 >> 2] | 0;
   i5 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
   i4 = i13 + 16 | 0;
   i1 = 0;
   do {
    i6 = _read(HEAP32[i4 >> 2] | 0, i3 + (i1 + i2) | 0, i5 - i1 | 0) | 0;
    if ((i6 | 0) < 1) {
     i11 = 21;
     break;
    }
    i1 = i6 + i1 | 0;
   } while (i1 >>> 0 < i5 >>> 0);
   do if ((i11 | 0) == 21) {
    if ((i6 | 0) >= 0) {
     HEAP32[i7 >> 2] = 1;
     break;
    }
    _gz_error(i13, -1, _strerror(HEAP32[(___errno_location() | 0) >> 2] | 0) | 0);
    i10 = -1;
    STACKTOP = i14;
    return i10 | 0;
   } while (0);
   i1 = (HEAP32[i10 >> 2] | 0) + i1 | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
  }
  if (i1) if (i1 >>> 0 > 1) {
   i11 = 27;
   break;
  } else {
   i1 = 1;
   break;
  } else {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
 } else i11 = 27; while (0);
 if ((i11 | 0) == 27) {
  i9 = HEAP32[i12 >> 2] | 0;
  if ((HEAP8[i9 >> 0] | 0) == 31 ? (HEAP8[i9 + 1 >> 0] | 0) == -117 : 0) {
   _inflateReset(i12) | 0;
   HEAP32[i13 + 44 >> 2] = 2;
   HEAP32[i13 + 40 >> 2] = 0;
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
 }
 i2 = i13 + 40 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i13 + 52 >> 2] = 1;
  HEAP32[i13 >> 2] = 0;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 i3 = HEAP32[i13 + 36 >> 2] | 0;
 HEAP32[i13 + 4 >> 2] = i3;
 if (i1) {
  _memcpy(i3 | 0, HEAP32[i12 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i10 >> 2] = 0;
 }
 HEAP32[i13 + 44 >> 2] = 1;
 HEAP32[i2 >> 2] = 1;
 i10 = 0;
 STACKTOP = i14;
 return i10 | 0;
}

function _cvSetSeqReaderPos(i11, i1, i6) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i3 = i12 + 16 | 0;
 i4 = i12 + 8 | 0;
 i7 = i12;
 if (!((i11 | 0) != 0 ? (i2 = HEAP32[i11 + 4 >> 2] | 0, (i2 | 0) != 0) : 0)) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i3, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i3, 40200, 39608, 1044);
  __ZN2cv6String10deallocateEv(i3);
  i2 = HEAP32[i11 + 4 >> 2] | 0;
 }
 i5 = i11 + 4 | 0;
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 i10 = HEAP32[i2 + 28 >> 2] | 0;
 if (i6) {
  i9 = i11 + 12 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i6 = Math_imul(i10, i1) | 0;
  i8 = i11 + 8 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = i4 + i6 | 0;
  if ((i6 | 0) > 0) {
   i7 = i11 + 20 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i1 >>> 0 >= i2 >>> 0) {
    do {
     i6 = i6 + i4 - i2 | 0;
     i3 = HEAP32[i3 + 4 >> 2] | 0;
     i4 = HEAP32[i3 + 16 >> 2] | 0;
     i5 = Math_imul(HEAP32[i3 + 12 >> 2] | 0, i10) | 0;
     i2 = i4 + i5 | 0;
    } while ((i6 | 0) >= (i5 | 0));
    HEAP32[i8 >> 2] = i3;
    HEAP32[i11 + 16 >> 2] = i4;
    HEAP32[i7 >> 2] = i2;
    i1 = i4 + i6 | 0;
   }
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i12;
   return;
  } else {
   i7 = i11 + 16 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i1 >>> 0 < i2 >>> 0) {
    i5 = i3;
    do {
     i6 = i6 + i4 - i2 | 0;
     i5 = HEAP32[i5 >> 2] | 0;
     i2 = HEAP32[i5 + 16 >> 2] | 0;
     i3 = Math_imul(HEAP32[i5 + 12 >> 2] | 0, i10) | 0;
     i4 = i2 + i3 | 0;
     i3 = i3 + i6 | 0;
    } while ((i3 | 0) < 0);
    HEAP32[i8 >> 2] = i5;
    HEAP32[i7 >> 2] = i2;
    HEAP32[i11 + 20 >> 2] = i4;
    i1 = i2 + i3 | 0;
   }
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i12;
   return;
  }
 }
 if ((i1 | 0) >= 0) {
  if ((i3 | 0) <= (i1 | 0)) {
   i1 = i1 - i3 | 0;
   if ((i1 | 0) >= (i3 | 0)) {
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    __ZN2cv6String8allocateEj(i7, 0) | 0;
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i7, 40200, 39608, 1061);
    __ZN2cv6String10deallocateEv(i7);
   }
  }
 } else {
  if ((i1 | 0) < (0 - i3 | 0)) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   __ZN2cv6String8allocateEj(i4, 0) | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i4, 40200, 39608, 1054);
   __ZN2cv6String10deallocateEv(i4);
  }
  i1 = i3 + i1 | 0;
 }
 i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] | 0;
 i2 = HEAP32[i4 + 12 >> 2] | 0;
 L33 : do if ((i1 | 0) >= (i2 | 0)) {
  if ((i1 << 1 | 0) <= (i3 | 0)) {
   i3 = i4;
   while (1) {
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    i1 = i1 - i2 | 0;
    i2 = HEAP32[i3 + 12 >> 2] | 0;
    if ((i1 | 0) < (i2 | 0)) {
     i4 = i3;
     break L33;
    }
   }
  }
  do {
   i4 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i4 + 12 >> 2] | 0;
   i3 = i3 - i2 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i1 = i1 - i3 | 0;
 } while (0);
 i3 = HEAP32[i4 + 16 >> 2] | 0;
 HEAP32[i11 + 12 >> 2] = i3 + (Math_imul(i1, i10) | 0);
 i1 = i11 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i1 >> 2] = i4;
 HEAP32[i11 + 16 >> 2] = i3;
 HEAP32[i11 + 20 >> 2] = i3 + (Math_imul(i2, i10) | 0);
 STACKTOP = i12;
 return;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_(i5, i7, i1, i10, i14, i2, i9, i13) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i8 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i12 = i15;
 i8 = i15 + 8 | 0;
 i4 = (i1 | 0) == (i10 | 0);
 L1 : do if (!i4) {
  i3 = i1;
  while (1) {
   if (!(HEAP32[i3 >> 2] | 0)) break;
   i3 = i3 + 4 | 0;
   if ((i3 | 0) == (i10 | 0)) {
    i3 = i10;
    break;
   }
  }
  HEAP32[i13 >> 2] = i2;
  HEAP32[i14 >> 2] = i1;
  if (!(i4 | (i2 | 0) == (i9 | 0))) {
   i6 = i9;
   i11 = i5 + 8 | 0;
   while (1) {
    i16 = i7;
    i5 = HEAP32[i16 + 4 >> 2] | 0;
    i4 = i12;
    HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i4 + 4 >> 2] = i5;
    i4 = _uselocale(HEAP32[i11 >> 2] | 0) | 0;
    i5 = _wcsnrtombs(i2, i14, i3 - i1 >> 2, i6 - i2 | 0, i7) | 0;
    if (i4) _uselocale(i4 | 0) | 0;
    if ((i5 | 0) == -1) {
     i3 = 10;
     break;
    } else if (!i5) {
     i1 = 1;
     i3 = 33;
     break;
    }
    i2 = (HEAP32[i13 >> 2] | 0) + i5 | 0;
    HEAP32[i13 >> 2] = i2;
    if ((i2 | 0) == (i9 | 0)) {
     i3 = 31;
     break;
    }
    if ((i3 | 0) == (i10 | 0)) {
     i1 = HEAP32[i14 >> 2] | 0;
     i3 = i10;
    } else {
     i3 = _uselocale(HEAP32[i11 >> 2] | 0) | 0;
     i2 = _wcrtomb(i8, 0, i7) | 0;
     if (i3) _uselocale(i3 | 0) | 0;
     if ((i2 | 0) == -1) {
      i1 = 2;
      i3 = 33;
      break;
     }
     i3 = HEAP32[i13 >> 2] | 0;
     if (i2 >>> 0 > (i6 - i3 | 0) >>> 0) {
      i1 = 1;
      i3 = 33;
      break;
     }
     L23 : do if (i2) {
      i4 = i8;
      while (1) {
       i5 = HEAP8[i4 >> 0] | 0;
       HEAP32[i13 >> 2] = i3 + 1;
       HEAP8[i3 >> 0] = i5;
       i2 = i2 + -1 | 0;
       if (!i2) break L23;
       i3 = HEAP32[i13 >> 2] | 0;
       i4 = i4 + 1 | 0;
      }
     } while (0);
     i1 = (HEAP32[i14 >> 2] | 0) + 4 | 0;
     HEAP32[i14 >> 2] = i1;
     L28 : do if ((i1 | 0) == (i10 | 0)) i3 = i10; else {
      i3 = i1;
      while (1) {
       if (!(HEAP32[i3 >> 2] | 0)) break L28;
       i3 = i3 + 4 | 0;
       if ((i3 | 0) == (i10 | 0)) {
        i3 = i10;
        break;
       }
      }
     } while (0);
     i2 = HEAP32[i13 >> 2] | 0;
    }
    if ((i1 | 0) == (i10 | 0) | (i2 | 0) == (i9 | 0)) break L1;
   }
   if ((i3 | 0) == 10) {
    HEAP32[i13 >> 2] = i2;
    L37 : do if ((i1 | 0) != (HEAP32[i14 >> 2] | 0)) do {
     i10 = HEAP32[i1 >> 2] | 0;
     i3 = _uselocale(HEAP32[i11 >> 2] | 0) | 0;
     i2 = _wcrtomb(i2, i10, i12) | 0;
     if (i3) _uselocale(i3 | 0) | 0;
     if ((i2 | 0) == -1) break L37;
     i2 = (HEAP32[i13 >> 2] | 0) + i2 | 0;
     HEAP32[i13 >> 2] = i2;
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) != (HEAP32[i14 >> 2] | 0)); while (0);
    HEAP32[i14 >> 2] = i1;
    i10 = 2;
    STACKTOP = i15;
    return i10 | 0;
   } else if ((i3 | 0) == 31) {
    i1 = HEAP32[i14 >> 2] | 0;
    break;
   } else if ((i3 | 0) == 33) {
    STACKTOP = i15;
    return i1 | 0;
   }
  }
 } else {
  HEAP32[i13 >> 2] = i2;
  HEAP32[i14 >> 2] = i1;
 } while (0);
 i10 = (i1 | 0) != (i10 | 0) & 1;
 STACKTOP = i15;
 return i10 | 0;
}

function __ZNK2cv9MatOp_Cmp6assignERKNS_7MatExprERNS_3MatEi(i1, i13, i14, i12) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 i17 = i19 + 144 | 0;
 i4 = i19 + 120 | 0;
 i5 = i19 + 100 | 0;
 i6 = i19 + 80 | 0;
 i7 = i19 + 60 | 0;
 i8 = i19 + 40 | 0;
 i9 = i19 + 20 | 0;
 i10 = i19;
 HEAP32[i17 >> 2] = 1124007936;
 i18 = i17 + 4 | 0;
 i2 = i17 + 8 | 0;
 i16 = i17 + 40 | 0;
 i1 = i18 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i16 >> 2] = i2;
 i15 = i17 + 48 | 0;
 i11 = i17 + 44 | 0;
 HEAP32[i11 >> 2] = i15;
 HEAP32[i17 + 52 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 i3 = (i12 | 0) == -1 | (i12 | 0) == 0 ? i14 : i17;
 i2 = i13 + 8 | 0;
 if (!(HEAP32[i13 + 80 >> 2] | 0)) {
  HEAP32[i7 >> 2] = 32088;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 16842752;
  HEAP32[i7 + 8 >> 2] = i2;
  HEAP32[i8 >> 2] = 32088;
  HEAP32[i8 + 4 >> 2] = -1056833530;
  HEAP32[i8 + 8 >> 2] = i13 + 176;
  HEAP32[i8 + 12 >> 2] = 1;
  HEAP32[i8 + 16 >> 2] = 1;
  i6 = i9 + 4 | 0;
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i9 >> 2] = 32232;
  HEAP32[i6 >> 2] = 33619968;
  HEAP32[i9 + 8 >> 2] = i3;
  __ZN2cv7compareERKNS_11_InputArrayES2_RKNS_12_OutputArrayEi(i7, i8, i9, HEAP32[i13 + 4 >> 2] | 0);
 } else {
  HEAP32[i4 >> 2] = 32088;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 16842752;
  HEAP32[i4 + 8 >> 2] = i2;
  HEAP32[i5 >> 2] = 32088;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 16842752;
  HEAP32[i5 + 8 >> 2] = i13 + 64;
  i9 = i6 + 4 | 0;
  HEAP32[i9 + 0 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i6 >> 2] = 32232;
  HEAP32[i9 >> 2] = 33619968;
  HEAP32[i6 + 8 >> 2] = i3;
  __ZN2cv7compareERKNS_11_InputArrayES2_RKNS_12_OutputArrayEi(i4, i5, i6, HEAP32[i13 + 4 >> 2] | 0);
 }
 if ((HEAP32[i3 + 16 >> 2] | 0) != (HEAP32[i14 + 16 >> 2] | 0)) {
  i9 = i10 + 4 | 0;
  HEAP32[i9 + 0 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i10 >> 2] = 32232;
  HEAP32[i9 >> 2] = 33619968;
  HEAP32[i10 + 8 >> 2] = i14;
  __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i3, i10, i12, 1.0, 0.0);
 }
 i2 = i17 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i17);
 HEAP32[i2 >> 2] = 0;
 i10 = i17 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i18 >> 2] | 0) > 0) {
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i18 >> 2] | 0));
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i15 | 0)) {
  STACKTOP = i19;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i19;
 return;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe(i24, i1, i23, i21, i20, d5) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i23 = i23 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 d5 = +d5;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i25 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i8 = i15 + 8 | 0;
 i1 = i15;
 i6 = i15 + 272 | 0;
 i4 = i15 + 268 | 0;
 i7 = i15 + 40 | 0;
 i14 = i15 + 36 | 0;
 i13 = i15 + 32 | 0;
 i9 = i15 + 28 | 0;
 i10 = i15 + 24 | 0;
 i11 = i15 + 20 | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = 37;
 HEAP32[i2 + 4 >> 2] = 0;
 i2 = __ZNSt3__114__num_put_base14__format_floatEPcPKcj(i1 + 1 | 0, 959448, HEAP32[i21 + 4 >> 2] | 0) | 0;
 HEAP32[i4 >> 2] = i6;
 i3 = __ZNSt3__16__clocEv() | 0;
 if (i2) {
  HEAP32[i8 >> 2] = HEAP32[i21 + 8 >> 2];
  i25 = i8 + 4 | 0;
  HEAPF64[tempDoublePtr >> 3] = d5;
  HEAP32[i25 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i3 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i6, 30, i3, i1, i8) | 0;
 } else {
  HEAPF64[tempDoublePtr >> 3] = d5;
  HEAP32[i8 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i3 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i6, 30, i3, i1, i8) | 0;
 }
 if ((i3 | 0) > 29) {
  i3 = __ZNSt3__16__clocEv() | 0;
  if (i2) {
   HEAP32[i8 >> 2] = HEAP32[i21 + 8 >> 2];
   i2 = i8 + 4 | 0;
   HEAPF64[tempDoublePtr >> 3] = d5;
   HEAP32[i2 >> 2] = HEAP32[tempDoublePtr >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
   i3 = __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz(i4, i3, i1, i8) | 0;
  } else {
   HEAPF64[tempDoublePtr >> 3] = d5;
   HEAP32[i8 >> 2] = HEAP32[tempDoublePtr >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
   i3 = __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz(i4, i3, i1, i8) | 0;
  }
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) __ZSt17__throw_bad_allocv(); else {
   i16 = i1;
   i19 = i1;
   i12 = i3;
  }
 } else {
  i16 = HEAP32[i4 >> 2] | 0;
  i19 = 0;
  i12 = i3;
 }
 i2 = i16 + i12 | 0;
 i3 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i16, i2, i21) | 0;
 if ((i16 | 0) != (i6 | 0)) {
  i1 = _malloc(i12 << 3) | 0;
  if (!i1) __ZSt17__throw_bad_allocv(); else {
   i17 = i16;
   i18 = i1;
   i22 = i1;
  }
 } else {
  i17 = i6;
  i18 = 0;
  i22 = i7;
 }
 __ZNKSt3__18ios_base6getlocEv(i9, i21);
 __ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE(i17, i3, i2, i22, i14, i13, i9);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i9 >> 2] | 0) | 0;
 HEAP32[i11 >> 2] = HEAP32[i23 >> 2];
 i16 = HEAP32[i14 >> 2] | 0;
 i17 = HEAP32[i13 >> 2] | 0;
 HEAP32[i8 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i10, i8, i22, i16, i17, i21, i20);
 i22 = HEAP32[i10 >> 2] | 0;
 HEAP32[i23 >> 2] = i22;
 HEAP32[i24 >> 2] = i22;
 if (!i18) {
  _free(i19);
  STACKTOP = i15;
  return;
 }
 _free(i18);
 _free(i19);
 STACKTOP = i15;
 return;
}

function _cvRegisterType(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i11 + 24 | 0;
 i1 = i11 + 16 | 0;
 i3 = i11 + 8 | 0;
 i9 = i11;
 if (!((i10 | 0) != 0 ? (HEAP32[i10 + 4 >> 2] | 0) == 40 : 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i2, 17) | 0) + 0 | 0;
  i6 = 10784 | 0;
  i7 = i5 + 17 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i2, 10808, 8960, 4804);
  __ZN2cv6String10deallocateEv(i2);
 }
 if (!((((HEAP32[i10 + 20 >> 2] | 0) != 0 ? (HEAP32[i10 + 24 >> 2] | 0) != 0 : 0) ? (HEAP32[i10 + 28 >> 2] | 0) != 0 : 0) ? (HEAP32[i10 + 32 >> 2] | 0) != 0 : 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i1, 81) | 0) + 0 | 0;
  i6 = 10824 | 0;
  i7 = i5 + 81 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 10808, 8960, 4810);
  __ZN2cv6String10deallocateEv(i1);
 }
 i8 = i10 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP8[i1 >> 0] | 0;
 if ((i7 + -97 << 24 >> 24 & 255) >= 26 ? !((i7 + -65 << 24 >> 24 & 255) < 26 | i7 << 24 >> 24 == 95) : 0) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i3, 41) | 0) + 0 | 0;
  i6 = 10912 | 0;
  i7 = i5 + 41 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i3, 10808, 8960, 4814);
  __ZN2cv6String10deallocateEv(i3);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i4 = _strlen(i1 | 0) | 0;
 L17 : do if ((i4 | 0) > 0) {
  i3 = i9 + 4 | 0;
  i2 = 0;
  while (1) {
   i7 = HEAP8[i1 + i2 >> 0] | 0;
   if (!((i7 + -48 << 24 >> 24 & 255) < 10 | (i7 + -97 << 24 >> 24 & 255) < 26 | (i7 + -65 << 24 >> 24 & 255) < 26) ? !(i7 << 24 >> 24 == 45 | i7 << 24 >> 24 == 95) : 0) {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    i5 = (__ZN2cv6String8allocateEj(i9, 54) | 0) + 0 | 0;
    i6 = 10960 | 0;
    i7 = i5 + 54 | 0;
    do {
     HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
     i5 = i5 + 1 | 0;
     i6 = i6 + 1 | 0;
    } while ((i5 | 0) < (i7 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i9, 10808, 8960, 4823);
    __ZN2cv6String10deallocateEv(i9);
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= (i4 | 0)) break L17;
   i1 = HEAP32[i8 >> 2] | 0;
  }
 } while (0);
 i2 = _cvAlloc(i4 + 41 | 0) | 0;
 i5 = i2 + 0 | 0;
 i6 = i10 + 0 | 0;
 i7 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  i5 = i5 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 i1 = i2 + 40 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, i4 + 1 | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = HEAP32[2644];
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = HEAP32[2644] | 0;
 if (!i1) {
  HEAP32[2646] = i2;
  HEAP32[2644] = i2;
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[2644] = i2;
  STACKTOP = i11;
  return;
 }
}

function __ZN2cvL13randn_0_1_32fEPfiPy(i8, i9, i11) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, d4 = 0.0, f5 = f0, i6 = 0, i7 = 0, i10 = 0, i12 = 0, d13 = 0.0, f14 = f0, f15 = f0, i16 = 0;
 i12 = STACKTOP;
 i1 = i11;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!(HEAP8[49696] | 0)) {
  HEAP32[12040] = 1991057938;
  HEAP32[12041] = 0;
  HEAPF32[12168] = Math_fround(1.72904047e-09);
  HEAPF32[12295] = Math_fround(1.60309477e-09);
  HEAPF32[12296] = Math_fround(1.0);
  HEAPF32[12423] = Math_fround(.00266962918);
  i3 = 126;
  d4 = 3.442619855899;
  do {
   d13 = d4;
   d4 = +Math_sqrt(+(+Math_log(+(.00991256303526217 / d4 + +Math_exp(+(d4 * (d4 * -.5))))) * -2.0));
   HEAP32[48160 + (i3 + 1 << 2) >> 2] = ~~(d4 / d13 * 2147483648.0) >>> 0;
   HEAPF32[49184 + (i3 << 2) >> 2] = Math_fround(+Math_exp(+(d4 * (d4 * -.5))));
   HEAPF32[48672 + (i3 << 2) >> 2] = Math_fround(d4 * 4.656612873077393e-10);
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) > 0);
  HEAP8[49696] = 1;
 }
 if ((i9 | 0) > 0) i7 = 0; else {
  i6 = i2;
  i2 = i1;
  i1 = i11;
  i3 = i1;
  HEAP32[i3 >> 2] = i6;
  i1 = i1 + 4 | 0;
  HEAP32[i1 >> 2] = i2;
  STACKTOP = i12;
  return;
 }
 do {
  i6 = i2;
  while (1) {
   i2 = ___muldi3(i6 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i1 = tempRet0;
   i3 = i6 & 127;
   f5 = Math_fround(i6 | 0);
   f5 = Math_fround(Math_fround(HEAPF32[48672 + (i3 << 2) >> 2]) * f5);
   if (((i6 | 0) > -1 ? i6 : 0 - i6 | 0) >>> 0 < (HEAP32[48160 + (i3 << 2) >> 2] | 0) >>> 0) break;
   if (!i3) {
    i10 = 9;
    break;
   }
   f15 = Math_fround(Math_fround(i2 >>> 0) * Math_fround(2.32830644e-10));
   i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i1 = tempRet0;
   f14 = Math_fround(HEAPF32[49184 + (i3 << 2) >> 2]);
   d4 = +f5;
   if (+Math_fround(f14 + Math_fround(f15 * Math_fround(Math_fround(HEAPF32[49184 + (i3 + -1 << 2) >> 2]) - f14))) < +Math_exp(+(d4 * (d4 * -.5)))) break; else i6 = i2;
  }
  do if ((i10 | 0) == 9) {
   while (1) {
    i10 = 0;
    f5 = Math_fround(Math_fround(i2 >>> 0) * Math_fround(2.32830644e-10));
    i16 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
    i16 = _i64Add(i16 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
    i3 = tempRet0;
    f14 = Math_fround(Math_fround(i16 >>> 0) * Math_fround(2.32830644e-10));
    i16 = ___muldi3(i16 | 0, 0, -130063606, 0) | 0;
    i2 = _i64Add(i16 | 0, tempRet0 | 0, i3 | 0, 0) | 0;
    i1 = tempRet0;
    f5 = Math_fround(+Math_fround(-Math_fround(+Math_log(+Math_fround(f5 + Math_fround(1.17549435e-38))))) * .2904764);
    f14 = Math_fround(+Math_log(+Math_fround(f14 + Math_fround(1.17549435e-38))));
    if (!(Math_fround(Math_fround(-f14) - f14) < Math_fround(f5 * f5))) break; else i10 = 9;
   }
   if ((i6 | 0) > 0) {
    f5 = Math_fround(f5 + Math_fround(3.44262004));
    break;
   } else {
    f5 = Math_fround(Math_fround(-3.44262004) - f5);
    break;
   }
  } while (0);
  HEAPF32[i8 + (i7 << 2) >> 2] = f5;
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i9 | 0));
 i10 = i11;
 HEAP32[i10 >> 2] = i2;
 i11 = i11 + 4 | 0;
 HEAP32[i11 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZN2cv8CholeskyEPfjiS0_ji(i14, i1, i11, i15, i2, i16) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i17 = 0, f18 = Math_fround(0), d19 = 0.0;
 i17 = STACKTOP;
 i13 = i1 >>> 2;
 i12 = i2 >>> 2;
 if ((i11 | 0) > 0) i8 = 0; else {
  i11 = 1;
  STACKTOP = i17;
  return i11 | 0;
 }
 do {
  i9 = Math_imul(i8, i13) | 0;
  if ((i8 | 0) > 0) {
   i5 = 0;
   do {
    i1 = i14 + (i5 + i9 << 2) | 0;
    d3 = +Math_fround(HEAPF32[i1 >> 2]);
    i4 = Math_imul(i5, i13) | 0;
    if ((i5 | 0) > 0) {
     i2 = 0;
     do {
      f18 = Math_fround(HEAPF32[i14 + (i2 + i9 << 2) >> 2]);
      d3 = d3 - +Math_fround(f18 * Math_fround(HEAPF32[i14 + (i2 + i4 << 2) >> 2]));
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i5 | 0));
    }
    HEAPF32[i1 >> 2] = Math_fround(d3 * +Math_fround(HEAPF32[i14 + (i4 + i5 << 2) >> 2]));
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
   i2 = i14 + (i9 + i8 << 2) | 0;
   i1 = 0;
   d3 = +Math_fround(HEAPF32[i2 >> 2]);
   do {
    d19 = +Math_fround(HEAPF32[i14 + (i1 + i9 << 2) >> 2]);
    d3 = d3 - d19 * d19;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
  } else {
   i10 = i14 + (i9 + i8 << 2) | 0;
   i2 = i10;
   d3 = +Math_fround(HEAPF32[i10 >> 2]);
  }
  if (d3 < 1.1920928955078125e-07) {
   i1 = 0;
   i7 = 26;
   break;
  }
  HEAPF32[i2 >> 2] = Math_fround(1.0 / +Math_sqrt(+d3));
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i11 | 0));
 if ((i7 | 0) == 26) {
  STACKTOP = i17;
  return i1 | 0;
 }
 if (!i15) {
  i11 = 1;
  STACKTOP = i17;
  return i11 | 0;
 }
 i10 = (i16 | 0) > 0;
 i2 = 0;
 do {
  if (i10) {
   i8 = Math_imul(i2, i12) | 0;
   i7 = (i2 | 0) > 0;
   i6 = Math_imul(i2, i13) | 0;
   i5 = i14 + (i6 + i2 << 2) | 0;
   i1 = 0;
   do {
    i4 = i15 + (i1 + i8 << 2) | 0;
    d3 = +Math_fround(HEAPF32[i4 >> 2]);
    if (i7) {
     i9 = 0;
     do {
      f18 = Math_fround(HEAPF32[i14 + (i9 + i6 << 2) >> 2]);
      d3 = d3 - +Math_fround(f18 * Math_fround(HEAPF32[i15 + ((Math_imul(i9, i12) | 0) + i1 << 2) >> 2]));
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) != (i2 | 0));
    }
    HEAPF32[i4 >> 2] = Math_fround(d3 * +Math_fround(HEAPF32[i5 >> 2]));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i16 | 0));
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i11 | 0));
 i4 = i11 + -1 | 0;
 i8 = i4;
 while (1) {
  if (i10) {
   i2 = Math_imul(i8, i12) | 0;
   i1 = (i4 | 0) > (i8 | 0);
   i6 = i14 + ((Math_imul(i8, i13) | 0) + i8 << 2) | 0;
   i9 = 0;
   do {
    i7 = i15 + (i9 + i2 << 2) | 0;
    d3 = +Math_fround(HEAPF32[i7 >> 2]);
    if (i1) {
     i5 = i4;
     do {
      f18 = Math_fround(HEAPF32[i14 + ((Math_imul(i5, i13) | 0) + i8 << 2) >> 2]);
      d3 = d3 - +Math_fround(f18 * Math_fround(HEAPF32[i15 + ((Math_imul(i5, i12) | 0) + i9 << 2) >> 2]));
      i5 = i5 + -1 | 0;
     } while ((i5 | 0) > (i8 | 0));
    }
    HEAPF32[i7 >> 2] = Math_fround(d3 * +Math_fround(HEAPF32[i6 >> 2]));
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) != (i16 | 0));
  }
  if ((i8 | 0) > 0) i8 = i8 + -1 | 0; else {
   i1 = 1;
   break;
  }
 }
 STACKTOP = i17;
 return i1 | 0;
}

function __ZN2cv12MatOp_Invert8makeExprERNS_7MatExprEiRKNS_3MatE(i5, i4, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 i6 = i19 + 32 | 0;
 i14 = i19 + 312 | 0;
 i11 = i19 + 256 | 0;
 i1 = i19;
 HEAP32[i14 >> 2] = 1124007936;
 i17 = i14 + 4 | 0;
 i2 = i14 + 8 | 0;
 i15 = i14 + 40 | 0;
 i7 = i17 + 0 | 0;
 i8 = i7 + 36 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAP32[i15 >> 2] = i2;
 i18 = i14 + 48 | 0;
 i16 = i14 + 44 | 0;
 HEAP32[i16 >> 2] = i18;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i11 >> 2] = 1124007936;
 i12 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i9 = i11 + 40 | 0;
 i7 = i12 + 0 | 0;
 i8 = i7 + 36 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAP32[i9 >> 2] = i2;
 i13 = i11 + 48 | 0;
 i10 = i11 + 44 | 0;
 HEAP32[i10 >> 2] = i13;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAPF64[i1 >> 3] = 0.0;
 __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i6, 33144, i4, i3, i14, i11, 1.0, 0.0, i1);
 i8 = i6;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i2;
 __ZN2cv3MataSERKS0_(i5 + 8 | 0, i6 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i5 + 64 | 0, i6 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i5 + 120 | 0, i6 + 120 | 0) | 0;
 i7 = i5 + 176 | 0;
 i2 = i6 + 176 | 0;
 i8 = i7 + 48 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  i7 = i7 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 __ZN2cv7MatExprD2Ev(i6);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i7 = i1 + 12 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i13 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i14 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
 HEAP32[i2 >> 2] = 0;
 i10 = i14 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i17 >> 2] | 0) > 0) {
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i17 >> 2] | 0));
 }
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i18 | 0)) {
  STACKTOP = i19;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i19;
 return;
}

function __ZN2cv7MatOp_T8makeExprERNS_7MatExprERKNS_3MatEd(i5, i3, d4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 i6 = i19 + 32 | 0;
 i14 = i19 + 312 | 0;
 i11 = i19 + 256 | 0;
 i1 = i19;
 HEAP32[i14 >> 2] = 1124007936;
 i17 = i14 + 4 | 0;
 i2 = i14 + 8 | 0;
 i15 = i14 + 40 | 0;
 i7 = i17 + 0 | 0;
 i8 = i7 + 36 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAP32[i15 >> 2] = i2;
 i18 = i14 + 48 | 0;
 i16 = i14 + 44 | 0;
 HEAP32[i16 >> 2] = i18;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i11 >> 2] = 1124007936;
 i12 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i9 = i11 + 40 | 0;
 i7 = i12 + 0 | 0;
 i8 = i7 + 36 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAP32[i9 >> 2] = i2;
 i13 = i11 + 48 | 0;
 i10 = i11 + 44 | 0;
 HEAP32[i10 >> 2] = i13;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAPF64[i1 >> 3] = 0.0;
 __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i6, 33152, 0, i3, i14, i11, d4, 0.0, i1);
 i8 = i6;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i2;
 __ZN2cv3MataSERKS0_(i5 + 8 | 0, i6 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i5 + 64 | 0, i6 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i5 + 120 | 0, i6 + 120 | 0) | 0;
 i7 = i5 + 176 | 0;
 i2 = i6 + 176 | 0;
 i8 = i7 + 48 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  i7 = i7 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 __ZN2cv7MatExprD2Ev(i6);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i7 = i1 + 12 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i11 = i11 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i13 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i14 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i10 = i1 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
 HEAP32[i2 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i17 >> 2] | 0) > 0) {
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i17 >> 2] | 0));
 }
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i18 | 0)) {
  STACKTOP = i19;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i19;
 return;
}

function __ZN2cv14MatOp_Identity8makeExprERNS_7MatExprERKNS_3MatE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 i5 = i18 + 32 | 0;
 i13 = i18 + 312 | 0;
 i10 = i18 + 256 | 0;
 i1 = i18;
 HEAP32[i13 >> 2] = 1124007936;
 i16 = i13 + 4 | 0;
 i2 = i13 + 8 | 0;
 i14 = i13 + 40 | 0;
 i6 = i16 + 0 | 0;
 i7 = i6 + 36 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP32[i14 >> 2] = i2;
 i17 = i13 + 48 | 0;
 i15 = i13 + 44 | 0;
 HEAP32[i15 >> 2] = i17;
 HEAP32[i13 + 52 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i10 >> 2] = 1124007936;
 i11 = i10 + 4 | 0;
 i2 = i10 + 8 | 0;
 i8 = i10 + 40 | 0;
 i6 = i11 + 0 | 0;
 i7 = i6 + 36 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP32[i8 >> 2] = i2;
 i12 = i10 + 48 | 0;
 i9 = i10 + 44 | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i10 + 52 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAPF64[i1 >> 3] = 0.0;
 __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i5, 33104, 0, i3, i13, i10, 1.0, 0.0, i1);
 i7 = i5;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = i2;
 __ZN2cv3MataSERKS0_(i4 + 8 | 0, i5 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i4 + 64 | 0, i5 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i4 + 120 | 0, i5 + 120 | 0) | 0;
 i6 = i4 + 176 | 0;
 i2 = i5 + 176 | 0;
 i7 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  i6 = i6 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 __ZN2cv7MatExprD2Ev(i5);
 i2 = i10 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i7 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i7 + -1, (i7 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i10);
 HEAP32[i2 >> 2] = 0;
 i10 = i10 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i11 >> 2] | 0) > 0) {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i11 >> 2] | 0));
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i12 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i13 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i13);
 HEAP32[i2 >> 2] = 0;
 i10 = i13 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i16 >> 2] | 0) > 0) {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i16 >> 2] | 0));
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) == (i17 | 0)) {
  STACKTOP = i18;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i18;
 return;
}

function __ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE(i14, i1, i10, i11, i4, i5, i12, i6) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 i18 = i16 + 424 | 0;
 i17 = i16 + 24 | 0;
 i13 = i16 + 16 | 0;
 i1 = i16 + 8 | 0;
 i8 = i16 + 4 | 0;
 i2 = i16 + 428 | 0;
 i19 = i16;
 HEAP32[i13 >> 2] = i17;
 i9 = i13 + 4 | 0;
 HEAP32[i9 >> 2] = 384;
 __ZNKSt3__18ios_base6getlocEv(i8, i5);
 i3 = __ZNKSt3__16locale9use_facetERNS0_2idE(i8, 960720) | 0;
 HEAP8[i2 >> 0] = 0;
 i7 = HEAP32[i11 >> 2] | 0;
 HEAP32[i19 >> 2] = i7;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i18 + 0 >> 2] = HEAP32[i19 + 0 >> 2];
 if (__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_(i10, i18, i4, i8, i5, i12, i2, i3, i13, i1, i17 + 400 | 0) | 0) {
  if (!(HEAP8[i6 >> 0] & 1)) {
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP8[i6 >> 0] = 0;
  } else {
   HEAP32[HEAP32[i6 + 8 >> 2] >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
  }
  if (HEAP8[i2 >> 0] | 0) __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw(i6, FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] & 127](i3, 45) | 0);
  i5 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] & 127](i3, 48) | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = i4 + -4 | 0;
  L10 : do if (i3 >>> 0 < i1 >>> 0) while (1) {
   i2 = i3 + 4 | 0;
   if ((HEAP32[i3 >> 2] | 0) != (i5 | 0)) break L10;
   if (i2 >>> 0 < i1 >>> 0) i3 = i2; else {
    i3 = i2;
    break;
   }
  } while (0);
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_(i6, i3, i4) | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 do if (i1) {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i10 >> 2] = 0;
   i3 = 1;
   break;
  } else {
   i3 = (HEAP32[i10 >> 2] | 0) == 0;
   break;
  }
 } else i3 = 1; while (0);
 do if (i7) {
  i2 = HEAP32[i7 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i7 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 127](i7) | 0; else i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != -1) if (i3) break; else {
   i15 = 26;
   break;
  } else {
   HEAP32[i11 >> 2] = 0;
   i15 = 24;
   break;
  }
 } else i15 = 24; while (0);
 if ((i15 | 0) == 24 ? i3 : 0) i15 = 26;
 if ((i15 | 0) == 26) HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 2;
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i8 >> 2] | 0) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[i9 >> 2] & 511](i1);
 STACKTOP = i16;
 return;
}

function __ZN2cvL6cmp16uEPKtjS1_jPhjNS_5Size_IiEEPv(i5, i3, i6, i4, i12, i16, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 i15 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = i3 >>> 1;
 i4 = i4 >>> 1;
 if ((i2 & -2 | 0) == 2) {
  i2 = (i2 | 0) == 2 ? 4 : 1;
  i11 = i6;
  i14 = i4;
  i4 = i3;
 } else {
  i11 = i5;
  i5 = i6;
  i14 = i3;
 }
 if ((i2 | 0) == 1 | (i2 | 0) == 4) {
  i7 = (i2 | 0) == 1 ? 0 : 255;
  if (!i13) {
   STACKTOP = i17;
   return;
  }
  i8 = i15 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i15 & -4;
  i1 = i12;
  i2 = i13;
  i6 = i11;
  while (1) {
   i2 = i2 + -1 | 0;
   if (i9) i3 = 0; else {
    i3 = 0;
    do {
     i13 = i3 | 1;
     i11 = ((HEAPU16[i6 + (i13 << 1) >> 1] | 0) > (HEAPU16[i5 + (i13 << 1) >> 1] | 0)) << 31 >> 31 ^ i7;
     HEAP8[i1 + i3 >> 0] = ((HEAPU16[i6 + (i3 << 1) >> 1] | 0) > (HEAPU16[i5 + (i3 << 1) >> 1] | 0)) << 31 >> 31 ^ i7;
     HEAP8[i1 + i13 >> 0] = i11;
     i13 = i3 | 2;
     i11 = i3 | 3;
     i12 = ((HEAPU16[i6 + (i11 << 1) >> 1] | 0) > (HEAPU16[i5 + (i11 << 1) >> 1] | 0)) << 31 >> 31 ^ i7;
     HEAP8[i1 + i13 >> 0] = ((HEAPU16[i6 + (i13 << 1) >> 1] | 0) > (HEAPU16[i5 + (i13 << 1) >> 1] | 0)) << 31 >> 31 ^ i7;
     HEAP8[i1 + i11 >> 0] = i12;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i8 | 0));
    i3 = i10;
   }
   if ((i3 | 0) < (i15 | 0)) do {
    HEAP8[i1 + i3 >> 0] = ((HEAPU16[i6 + (i3 << 1) >> 1] | 0) > (HEAPU16[i5 + (i3 << 1) >> 1] | 0)) << 31 >> 31 ^ i7;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i15 | 0));
   if (!i2) break; else {
    i1 = i1 + i16 | 0;
    i6 = i6 + (i14 << 1) | 0;
    i5 = i5 + (i4 << 1) | 0;
   }
  }
  STACKTOP = i17;
  return;
 }
 if (!((i2 | 0) == 0 | (i2 | 0) == 5)) {
  STACKTOP = i17;
  return;
 }
 i10 = (i2 | 0) == 0 ? 0 : 255;
 if (!i13) {
  STACKTOP = i17;
  return;
 }
 i9 = i15 + -4 | 0;
 i8 = (i9 | 0) < 0;
 i7 = i15 & -4;
 i1 = i12;
 i2 = i13;
 i6 = i11;
 while (1) {
  i2 = i2 + -1 | 0;
  if (i8) i3 = 0; else {
   i3 = 0;
   do {
    i13 = i3 | 1;
    i11 = ((HEAP16[i6 + (i13 << 1) >> 1] | 0) == (HEAP16[i5 + (i13 << 1) >> 1] | 0)) << 31 >> 31 ^ i10;
    HEAP8[i1 + i3 >> 0] = ((HEAP16[i6 + (i3 << 1) >> 1] | 0) == (HEAP16[i5 + (i3 << 1) >> 1] | 0)) << 31 >> 31 ^ i10;
    HEAP8[i1 + i13 >> 0] = i11;
    i13 = i3 | 2;
    i11 = i3 | 3;
    i12 = ((HEAP16[i6 + (i11 << 1) >> 1] | 0) == (HEAP16[i5 + (i11 << 1) >> 1] | 0)) << 31 >> 31 ^ i10;
    HEAP8[i1 + i13 >> 0] = ((HEAP16[i6 + (i13 << 1) >> 1] | 0) == (HEAP16[i5 + (i13 << 1) >> 1] | 0)) << 31 >> 31 ^ i10;
    HEAP8[i1 + i11 >> 0] = i12;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i9 | 0));
   i3 = i7;
  }
  if ((i3 | 0) < (i15 | 0)) do {
   HEAP8[i1 + i3 >> 0] = ((HEAP16[i6 + (i3 << 1) >> 1] | 0) == (HEAP16[i5 + (i3 << 1) >> 1] | 0)) << 31 >> 31 ^ i10;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i15 | 0));
  if (!i2) break; else {
   i1 = i1 + i16 | 0;
   i6 = i6 + (i14 << 1) | 0;
   i5 = i5 + (i4 << 1) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZNSt3__1L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE(i12, i10, i11, i9, i1) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 i13 = STACKTOP;
 if ((((i1 & 4 | 0) != 0 ? (i10 - i12 | 0) > 2 : 0) ? (HEAP8[i12 >> 0] | 0) == -17 : 0) ? (HEAP8[i12 + 1 >> 0] | 0) == -69 : 0) i1 = (HEAP8[i12 + 2 >> 0] | 0) == -65 ? i12 + 3 | 0 : i12; else i1 = i12;
 L7 : do if (i1 >>> 0 < i10 >>> 0 & (i11 | 0) != 0) {
  i8 = i10;
  i2 = 0;
  L9 : while (1) {
   i3 = HEAP8[i1 >> 0] | 0;
   i7 = i3 & 255;
   if (i7 >>> 0 > i9 >>> 0) break L7;
   do if (i3 << 24 >> 24 > -1) i1 = i1 + 1 | 0; else {
    if ((i3 & 255) < 194) break L7;
    if ((i3 & 255) < 224) {
     if ((i8 - i1 | 0) < 2) break L7;
     i3 = HEAPU8[i1 + 1 >> 0] | 0;
     if ((i3 & 192 | 0) != 128) break L7;
     if ((i3 & 63 | i7 << 6 & 1984) >>> 0 > i9 >>> 0) break L7;
     i1 = i1 + 2 | 0;
     break;
    }
    if ((i3 & 255) < 240) {
     i4 = i1;
     if ((i8 - i4 | 0) < 3) break L7;
     i5 = HEAP8[i1 + 1 >> 0] | 0;
     i3 = HEAP8[i1 + 2 >> 0] | 0;
     if ((i7 | 0) == 237) {
      if ((i5 & -32) << 24 >> 24 != -128) {
       i2 = 23;
       break L9;
      }
     } else if ((i7 | 0) == 224) {
      if ((i5 & -32) << 24 >> 24 != -96) {
       i2 = 21;
       break L9;
      }
     } else if ((i5 & -64) << 24 >> 24 != -128) {
      i2 = 25;
      break L9;
     }
     i3 = i3 & 255;
     if ((i3 & 192 | 0) != 128) break L7;
     if (((i5 & 255) << 6 & 4032 | i7 << 12 & 61440 | i3 & 63) >>> 0 > i9 >>> 0) break L7;
     i1 = i1 + 3 | 0;
     break;
    }
    if ((i3 & 255) >= 245) break L7;
    i4 = i1;
    if ((i8 - i4 | 0) < 4 | (i11 - i2 | 0) >>> 0 < 2) break L7;
    i6 = HEAP8[i1 + 1 >> 0] | 0;
    i5 = HEAP8[i1 + 2 >> 0] | 0;
    i3 = HEAP8[i1 + 3 >> 0] | 0;
    if ((i7 | 0) == 240) {
     if ((i6 + 112 << 24 >> 24 & 255) >= 48) {
      i2 = 33;
      break L9;
     }
    } else if ((i7 | 0) == 244) {
     if ((i6 & -16) << 24 >> 24 != -128) {
      i2 = 35;
      break L9;
     }
    } else if ((i6 & -64) << 24 >> 24 != -128) {
     i2 = 37;
     break L9;
    }
    i5 = i5 & 255;
    if ((i5 & 192 | 0) != 128) break L7;
    i3 = i3 & 255;
    if ((i3 & 192 | 0) != 128) break L7;
    if (((i6 & 255) << 12 & 258048 | i7 << 18 & 1835008 | i5 << 6 & 4032 | i3 & 63) >>> 0 > i9 >>> 0) break L7;
    i1 = i1 + 4 | 0;
    i2 = i2 + 1 | 0;
   } while (0);
   i2 = i2 + 1 | 0;
   if (!(i1 >>> 0 < i10 >>> 0 & i2 >>> 0 < i11 >>> 0)) break L7;
  }
  if ((i2 | 0) == 21) {
   i10 = i4 - i12 | 0;
   STACKTOP = i13;
   return i10 | 0;
  } else if ((i2 | 0) == 23) {
   i10 = i4 - i12 | 0;
   STACKTOP = i13;
   return i10 | 0;
  } else if ((i2 | 0) == 25) {
   i10 = i4 - i12 | 0;
   STACKTOP = i13;
   return i10 | 0;
  } else if ((i2 | 0) == 33) {
   i10 = i4 - i12 | 0;
   STACKTOP = i13;
   return i10 | 0;
  } else if ((i2 | 0) == 35) {
   i10 = i4 - i12 | 0;
   STACKTOP = i13;
   return i10 | 0;
  } else if ((i2 | 0) == 37) {
   i10 = i4 - i12 | 0;
   STACKTOP = i13;
   return i10 | 0;
  }
 } while (0);
 i10 = i1 - i12 | 0;
 STACKTOP = i13;
 return i10 | 0;
}

function __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10, i4, i11) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 i5 = i4;
 i7 = i11 - i5 >> 3;
 i9 = i10 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i6 = i2;
 if (i7 >>> 0 > i3 - i6 >> 3 >>> 0) {
  if (i2) {
   i3 = i10 + 4 | 0;
   while (1) {
    i1 = HEAP32[i3 >> 2] | 0;
    if ((i1 | 0) == (i2 | 0)) break;
    i6 = i1 + -8 | 0;
    HEAP32[i3 >> 2] = i6;
    __ZN2cv6String10deallocateEv(i6);
   }
   __ZdlPv(HEAP32[i10 >> 2] | 0);
   HEAP32[i9 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   i3 = 0;
  }
  if (i7 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = i3 - 0 | 0;
  if (i3 >> 3 >>> 0 < 268435455) {
   i3 = i3 >> 2;
   i3 = i3 >>> 0 < i7 >>> 0 ? i7 : i3;
   if (i3 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10); else i8 = i3;
  } else i8 = 536870911;
  i1 = __Znwj(i8 << 3) | 0;
  i6 = i10 + 4 | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i9 >> 2] = i1 + (i8 << 3);
  if ((i4 | 0) == (i11 | 0)) {
   STACKTOP = i12;
   return;
  } else i3 = i4;
  do {
   if (i1) {
    i2 = HEAP32[i3 >> 2] | 0;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    if (i2) {
     i1 = i2 + -4 | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     i1 = HEAP32[i6 >> 2] | 0;
    }
   } else i1 = 0;
   i1 = i1 + 8 | 0;
   HEAP32[i6 >> 2] = i1;
   i3 = i3 + 8 | 0;
  } while ((i3 | 0) != (i11 | 0));
  STACKTOP = i12;
  return;
 }
 i10 = i10 + 4 | 0;
 i3 = (HEAP32[i10 >> 2] | 0) - i6 >> 3;
 if (i7 >>> 0 > i3 >>> 0) {
  i7 = 1;
  i3 = i4 + (i3 << 3) | 0;
 } else {
  i7 = 0;
  i3 = i11;
 }
 if ((i3 | 0) != (i4 | 0)) {
  i6 = i3 + -8 - i5 | 0;
  i5 = i2;
  while (1) {
   if ((i4 | 0) != (i5 | 0)) {
    __ZN2cv6String10deallocateEv(i5);
    i1 = HEAP32[i4 >> 2] | 0;
    if (!i1) i1 = 0; else {
     i1 = i1 + -4 | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    HEAP32[i5 >> 2] = i1;
    HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   }
   i4 = i4 + 8 | 0;
   if ((i4 | 0) == (i3 | 0)) break; else i5 = i5 + 8 | 0;
  }
  i2 = i2 + ((i6 >>> 3) + 1 << 3) | 0;
 }
 if (!i7) {
  while (1) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) break;
   i9 = i1 + -8 | 0;
   HEAP32[i10 >> 2] = i9;
   __ZN2cv6String10deallocateEv(i9);
  }
  STACKTOP = i12;
  return;
 }
 if ((i3 | 0) == (i11 | 0)) {
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 do {
  if (i1) {
   i2 = HEAP32[i3 >> 2] | 0;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   if (i2) {
    i1 = i2 + -4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = HEAP32[i10 >> 2] | 0;
   }
  } else i1 = 0;
  i1 = i1 + 8 | 0;
  HEAP32[i10 >> 2] = i1;
  i3 = i3 + 8 | 0;
 } while ((i3 | 0) != (i11 | 0));
 STACKTOP = i12;
 return;
}

function __ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE(i14, i1, i10, i11, i3, i4, i12, i6) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i6 = i6 | 0;
 var i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i18 = i16 + 24 | 0;
 i17 = i16 + 32 | 0;
 i13 = i16 + 16 | 0;
 i5 = i16 + 8 | 0;
 i8 = i16 + 4 | 0;
 i2 = i16 + 28 | 0;
 i19 = i16;
 HEAP32[i13 >> 2] = i17;
 i9 = i13 + 4 | 0;
 HEAP32[i9 >> 2] = 384;
 __ZNKSt3__18ios_base6getlocEv(i8, i4);
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i8, 960728) | 0;
 HEAP8[i2 >> 0] = 0;
 i7 = HEAP32[i11 >> 2] | 0;
 HEAP32[i19 >> 2] = i7;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i18 + 0 >> 2] = HEAP32[i19 + 0 >> 2];
 if (__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_(i10, i18, i3, i8, i4, i12, i2, i1, i13, i5, i17 + 100 | 0) | 0) {
  if (!(HEAP8[i6 >> 0] & 1)) {
   HEAP8[i6 + 1 >> 0] = 0;
   HEAP8[i6 >> 0] = 0;
  } else {
   HEAP8[HEAP32[i6 + 8 >> 2] >> 0] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
  }
  if (HEAP8[i2 >> 0] | 0) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i6, FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1, 45) | 0);
  i4 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1, 48) | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i3 = i5 + -1 | 0;
  L10 : do if (i1 >>> 0 < i3 >>> 0) {
   i2 = i1;
   while (1) {
    i1 = i2 + 1 | 0;
    if ((HEAP8[i2 >> 0] | 0) != i4 << 24 >> 24) {
     i1 = i2;
     break L10;
    }
    if (i1 >>> 0 < i3 >>> 0) i2 = i1; else break;
   }
  } while (0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_(i6, i1, i5) | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 do if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1) {
   HEAP32[i10 >> 2] = 0;
   i1 = 0;
   break;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   break;
  }
 } else i1 = 0; while (0);
 i1 = (i1 | 0) == 0;
 do if (i7) {
  if ((HEAP32[i7 + 12 >> 2] | 0) != (HEAP32[i7 + 16 >> 2] | 0)) if (i1) break; else {
   i15 = 23;
   break;
  }
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 127](i7) | 0) != -1) if (i1 ^ (i7 | 0) == 0) break; else {
   i15 = 23;
   break;
  } else {
   HEAP32[i11 >> 2] = 0;
   i15 = 21;
   break;
  }
 } else i15 = 21; while (0);
 if ((i15 | 0) == 21 ? i1 : 0) i15 = 23;
 if ((i15 | 0) == 23) HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 2;
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i8 >> 2] | 0) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[i9 >> 2] & 511](i1);
 STACKTOP = i16;
 return;
}

function __ZN2cvL6cmp32sEPKijS1_jPhjNS_5Size_IiEEPv(i5, i3, i6, i4, i12, i16, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 i15 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = i3 >>> 2;
 i4 = i4 >>> 2;
 if ((i2 & -2 | 0) == 2) {
  i2 = (i2 | 0) == 2 ? 4 : 1;
  i11 = i6;
  i14 = i4;
  i4 = i3;
 } else {
  i11 = i5;
  i5 = i6;
  i14 = i3;
 }
 if ((i2 | 0) == 1 | (i2 | 0) == 4) {
  i7 = (i2 | 0) == 1 ? 0 : 255;
  if (!i13) {
   STACKTOP = i17;
   return;
  }
  i8 = i15 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i15 & -4;
  i1 = i12;
  i2 = i13;
  i6 = i11;
  while (1) {
   i2 = i2 + -1 | 0;
   if (i9) i3 = 0; else {
    i3 = 0;
    do {
     i13 = i3 | 1;
     i11 = ((HEAP32[i6 + (i13 << 2) >> 2] | 0) > (HEAP32[i5 + (i13 << 2) >> 2] | 0)) << 31 >> 31 ^ i7;
     HEAP8[i1 + i3 >> 0] = ((HEAP32[i6 + (i3 << 2) >> 2] | 0) > (HEAP32[i5 + (i3 << 2) >> 2] | 0)) << 31 >> 31 ^ i7;
     HEAP8[i1 + i13 >> 0] = i11;
     i13 = i3 | 2;
     i11 = i3 | 3;
     i12 = ((HEAP32[i6 + (i11 << 2) >> 2] | 0) > (HEAP32[i5 + (i11 << 2) >> 2] | 0)) << 31 >> 31 ^ i7;
     HEAP8[i1 + i13 >> 0] = ((HEAP32[i6 + (i13 << 2) >> 2] | 0) > (HEAP32[i5 + (i13 << 2) >> 2] | 0)) << 31 >> 31 ^ i7;
     HEAP8[i1 + i11 >> 0] = i12;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i8 | 0));
    i3 = i10;
   }
   if ((i3 | 0) < (i15 | 0)) do {
    HEAP8[i1 + i3 >> 0] = ((HEAP32[i6 + (i3 << 2) >> 2] | 0) > (HEAP32[i5 + (i3 << 2) >> 2] | 0)) << 31 >> 31 ^ i7;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i15 | 0));
   if (!i2) break; else {
    i1 = i1 + i16 | 0;
    i6 = i6 + (i14 << 2) | 0;
    i5 = i5 + (i4 << 2) | 0;
   }
  }
  STACKTOP = i17;
  return;
 }
 if (!((i2 | 0) == 0 | (i2 | 0) == 5)) {
  STACKTOP = i17;
  return;
 }
 i10 = (i2 | 0) == 0 ? 0 : 255;
 if (!i13) {
  STACKTOP = i17;
  return;
 }
 i9 = i15 + -4 | 0;
 i8 = (i9 | 0) < 0;
 i7 = i15 & -4;
 i1 = i12;
 i2 = i13;
 i6 = i11;
 while (1) {
  i2 = i2 + -1 | 0;
  if (i8) i3 = 0; else {
   i3 = 0;
   do {
    i13 = i3 | 1;
    i11 = ((HEAP32[i6 + (i13 << 2) >> 2] | 0) == (HEAP32[i5 + (i13 << 2) >> 2] | 0)) << 31 >> 31 ^ i10;
    HEAP8[i1 + i3 >> 0] = ((HEAP32[i6 + (i3 << 2) >> 2] | 0) == (HEAP32[i5 + (i3 << 2) >> 2] | 0)) << 31 >> 31 ^ i10;
    HEAP8[i1 + i13 >> 0] = i11;
    i13 = i3 | 2;
    i11 = i3 | 3;
    i12 = ((HEAP32[i6 + (i11 << 2) >> 2] | 0) == (HEAP32[i5 + (i11 << 2) >> 2] | 0)) << 31 >> 31 ^ i10;
    HEAP8[i1 + i13 >> 0] = ((HEAP32[i6 + (i13 << 2) >> 2] | 0) == (HEAP32[i5 + (i13 << 2) >> 2] | 0)) << 31 >> 31 ^ i10;
    HEAP8[i1 + i11 >> 0] = i12;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i9 | 0));
   i3 = i7;
  }
  if ((i3 | 0) < (i15 | 0)) do {
   HEAP8[i1 + i3 >> 0] = ((HEAP32[i6 + (i3 << 2) >> 2] | 0) == (HEAP32[i5 + (i3 << 2) >> 2] | 0)) << 31 >> 31 ^ i10;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i15 | 0));
  if (!i2) break; else {
   i1 = i1 + i16 | 0;
   i6 = i6 + (i14 << 2) | 0;
   i5 = i5 + (i4 << 2) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE4syncEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i11 + 8 | 0;
 i7 = i11;
 i10 = i9 + 64 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = i9 + 68 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (!i4) {
  i10 = ___cxa_allocate_exception(4) | 0;
  __ZNSt8bad_castC2Ev(i10);
  ___cxa_throw(i10 | 0, 969544, 335);
 }
 i6 = i9 + 92 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 do if (!(i3 & 16)) {
  if (i3 & 8) {
   i2 = i9 + 80 | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i5 = i7;
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i5 + 4 >> 2] = i3;
   do if (!(HEAP8[i9 + 98 >> 0] | 0)) {
    i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] & 127](i4) | 0;
    i3 = i9 + 36 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    i2 = (HEAP32[i9 + 40 >> 2] | 0) - i1 | 0;
    if ((i4 | 0) > 0) {
     i2 = (Math_imul((HEAP32[i9 + 16 >> 2] | 0) - (HEAP32[i9 + 12 >> 2] | 0) | 0, i4) | 0) + i2 | 0;
     i1 = 0;
     break;
    }
    i4 = HEAP32[i9 + 12 >> 2] | 0;
    if ((i4 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i1 = 0; else {
     i5 = HEAP32[i8 >> 2] | 0;
     i8 = i9 + 32 | 0;
     i1 = FUNCTION_TABLE_iiiiii[HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] & 31](i5, i7, HEAP32[i8 >> 2] | 0, i1, i4 - (HEAP32[i9 + 8 >> 2] | 0) | 0) | 0;
     i2 = i2 - i1 + (HEAP32[i3 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0;
     i1 = 1;
    }
   } else {
    i2 = (HEAP32[i9 + 16 >> 2] | 0) - (HEAP32[i9 + 12 >> 2] | 0) | 0;
    i1 = 0;
   } while (0);
   if (_fseeko(HEAP32[i10 >> 2] | 0, 0 - i2 | 0, 1) | 0) {
    i10 = -1;
    STACKTOP = i11;
    return i10 | 0;
   }
   if (i1) {
    i8 = HEAP32[i7 + 4 >> 2] | 0;
    i10 = i9 + 72 | 0;
    HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i10 + 4 >> 2] = i8;
   }
   i10 = HEAP32[i9 + 32 >> 2] | 0;
   HEAP32[i9 + 40 >> 2] = i10;
   HEAP32[i9 + 36 >> 2] = i10;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i9 + 16 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
  }
 } else {
  if ((HEAP32[i9 + 24 >> 2] | 0) != (HEAP32[i9 + 20 >> 2] | 0) ? (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i9 >> 2] | 0) + 52 >> 2] & 127](i9, -1) | 0) == -1 : 0) {
   i10 = -1;
   STACKTOP = i11;
   return i10 | 0;
  }
  i3 = i9 + 72 | 0;
  i4 = i9 + 32 | 0;
  i2 = i9 + 52 | 0;
  while (1) {
   i7 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i1 = FUNCTION_TABLE_iiiiii[HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] & 31](i7, i3, i1, i1 + (HEAP32[i2 >> 2] | 0) | 0, i5) | 0;
   i7 = HEAP32[i4 >> 2] | 0;
   i9 = (HEAP32[i5 >> 2] | 0) - i7 | 0;
   if ((_fwrite(i7 | 0, 1, i9 | 0, HEAP32[i10 >> 2] | 0) | 0) != (i9 | 0)) {
    i1 = -1;
    i2 = 23;
    break;
   }
   if ((i1 | 0) == 2) {
    i1 = -1;
    i2 = 23;
    break;
   } else if ((i1 | 0) != 1) {
    i2 = 10;
    break;
   }
  }
  if ((i2 | 0) == 10) {
   if (!(_fflush(HEAP32[i10 >> 2] | 0) | 0)) break; else i1 = -1;
   STACKTOP = i11;
   return i1 | 0;
  } else if ((i2 | 0) == 23) {
   STACKTOP = i11;
   return i1 | 0;
  }
 } while (0);
 i10 = 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__127__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 i2 = (i1 | 0) == (i6 | 0);
 HEAP8[i1 + 12 >> 0] = i2 & 1;
 if (i2) {
  STACKTOP = i10;
  return;
 }
 while (1) {
  i7 = i1 + 8 | 0;
  i9 = HEAP32[i7 >> 2] | 0;
  i2 = i9 + 12 | 0;
  if (HEAP8[i2 >> 0] | 0) {
   i4 = 37;
   break;
  }
  i8 = i9 + 8 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) == (i9 | 0)) {
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i4) {
    i4 = 7;
    break;
   }
   i4 = i4 + 12 | 0;
   if (HEAP8[i4 >> 0] | 0) {
    i4 = 7;
    break;
   }
   HEAP8[i2 >> 0] = 1;
   HEAP8[i3 + 12 >> 0] = (i3 | 0) == (i6 | 0) & 1;
   HEAP8[i4 >> 0] = 1;
  } else {
   if (!i4) {
    i4 = 24;
    break;
   }
   i5 = i4 + 12 | 0;
   if (HEAP8[i5 >> 0] | 0) {
    i4 = 24;
    break;
   }
   HEAP8[i2 >> 0] = 1;
   HEAP8[i3 + 12 >> 0] = (i3 | 0) == (i6 | 0) & 1;
   HEAP8[i5 >> 0] = 1;
  }
  if ((i3 | 0) == (i6 | 0)) {
   i4 = 37;
   break;
  } else i1 = i3;
 }
 if ((i4 | 0) == 7) {
  if ((HEAP32[i9 >> 2] | 0) == (i1 | 0)) {
   i2 = i9;
   i5 = i3;
   i4 = i9;
  } else {
   i1 = i9 + 4 | 0;
   i4 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i1 >> 2] = i2;
   if (!i2) i2 = i3; else {
    HEAP32[i2 + 8 >> 2] = i9;
    i2 = HEAP32[i8 >> 2] | 0;
   }
   i3 = i4 + 8 | 0;
   HEAP32[i3 >> 2] = i2;
   i2 = HEAP32[i8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i9 | 0)) HEAP32[i2 >> 2] = i4; else HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i4 >> 2] = i9;
   HEAP32[i8 >> 2] = i4;
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = i4;
   i5 = i1;
   i4 = HEAP32[i1 >> 2] | 0;
  }
  HEAP8[i2 + 12 >> 0] = 1;
  HEAP8[i5 + 12 >> 0] = 0;
  i3 = i4 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  if (i1) HEAP32[i1 + 8 >> 2] = i5;
  i2 = i5 + 8 | 0;
  HEAP32[i4 + 8 >> 2] = HEAP32[i2 >> 2];
  i1 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) HEAP32[i1 >> 2] = i4; else HEAP32[i1 + 4 >> 2] = i4;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  STACKTOP = i10;
  return;
 } else if ((i4 | 0) == 24) {
  if ((HEAP32[i9 >> 2] | 0) == (i1 | 0)) {
   i5 = i1 + 4 | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i9 >> 2] = i4;
   if (i4) {
    HEAP32[i4 + 8 >> 2] = i9;
    i3 = HEAP32[i8 >> 2] | 0;
   }
   HEAP32[i7 >> 2] = i3;
   i3 = HEAP32[i8 >> 2] | 0;
   if ((HEAP32[i3 >> 2] | 0) == (i9 | 0)) HEAP32[i3 >> 2] = i1; else HEAP32[i3 + 4 >> 2] = i1;
   HEAP32[i5 >> 2] = i9;
   HEAP32[i8 >> 2] = i1;
   i4 = HEAP32[i7 >> 2] | 0;
  } else {
   i1 = i9;
   i4 = i3;
  }
  HEAP8[i1 + 12 >> 0] = 1;
  HEAP8[i4 + 12 >> 0] = 0;
  i2 = i4 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  if (i1) HEAP32[i1 + 8 >> 2] = i4;
  i1 = i4 + 8 | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 >> 2];
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) HEAP32[i2 >> 2] = i3; else HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i1 >> 2] = i3;
  STACKTOP = i10;
  return;
 } else if ((i4 | 0) == 37) {
  STACKTOP = i10;
  return;
 }
}

function __ZL13icvWriteImageP13CvFileStoragePKcPKv10CvAttrList(i14, i6, i12, i1) {
 i14 = i14 | 0;
 i6 = i6 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i10 = i13;
 i9 = i13 + 40 | 0;
 i5 = i13 + 32 | 0;
 i4 = i13 + 24 | 0;
 i8 = i13 + 16 | 0;
 i11 = i13 + 8 | 0;
 i7 = i12 + 28 | 0;
 if ((HEAP32[i7 >> 2] | 0) == 1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i5, 48) | 0) + 0 | 0;
  i2 = 12032;
  i1 = i3 + 48 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-210, i5, 12088, 8960, 3857);
  __ZN2cv6String10deallocateEv(i5);
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i10 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 _cvStartWriteStruct(i14, i6, 6, 10712, i10);
 i3 = i12 + 40 | 0;
 _cvWriteInt(i14, 12104, HEAP32[i3 >> 2] | 0);
 i6 = i12 + 44 | 0;
 _cvWriteInt(i14, 12112, HEAP32[i6 >> 2] | 0);
 _cvWriteString(i14, 12120, (HEAP32[i12 + 32 >> 2] | 0) == 0 ? 12128 : 12144, 0);
 _cvWriteString(i14, 12160, (HEAP32[i7 >> 2] | 0) == 1 ? 12168 : 12176, 0);
 i2 = i12 + 48 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i10 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  _cvStartWriteStruct(i14, 12192, 14, 0, i10);
  _cvWriteInt(i14, 12200, HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0);
  _cvWriteInt(i14, 12208, HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0);
  _cvWriteInt(i14, 12104, HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0);
  _cvWriteInt(i14, 12112, HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0);
  _cvWriteInt(i14, 12216, HEAP32[HEAP32[i2 >> 2] >> 2] | 0);
  _cvEndWriteStruct(i14);
 }
 i5 = HEAP32[i12 + 16 >> 2] | 0;
 i5 = 1125516576 >>> ((i5 >>> 2 & 60) + (i5 >> 31 & 20) | 0);
 i4 = i12 + 8 | 0;
 i8 = HEAP8[11696 + (i5 & 15) >> 0] | 0;
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = i8;
 _sprintf(i9, 11688, i10) | 0;
 if (!(HEAP8[i9 + 2 >> 0] | 0)) i2 = (HEAP8[i9 >> 0] | 0) == 49; else i2 = 0;
 i8 = i9 + (i2 & 1) | 0;
 _cvWriteString(i14, 11672, i8, 0);
 i3 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i9 = Math_imul(Math_imul(i3, (i5 >>> 3 & 1) + 1 << (47696 >>> (i5 << 1 & 14) & 3)) | 0, HEAP32[i4 >> 2] | 0) | 0;
 i4 = i12 + 72 | 0;
 if ((i9 | 0) == (HEAP32[i4 >> 2] | 0)) {
  i5 = 1;
  i3 = Math_imul(i2, i3) | 0;
 } else i5 = i2;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 _cvStartWriteStruct(i14, 11680, 13, 0, i10);
 if ((i5 | 0) <= 0) {
  _cvEndWriteStruct(i14);
  _cvEndWriteStruct(i14);
  STACKTOP = i13;
  return;
 }
 i1 = i12 + 68 | 0;
 i2 = 0;
 do {
  _cvWriteRawData(i14, (HEAP32[i1 >> 2] | 0) + (Math_imul(HEAP32[i4 >> 2] | 0, i2) | 0) | 0, i3, i8);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 _cvEndWriteStruct(i14);
 _cvEndWriteStruct(i14);
 STACKTOP = i13;
 return;
}

function __ZNSt3__1L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i12, i10, i11, i9, i1) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 i13 = STACKTOP;
 if ((((i1 & 4 | 0) != 0 ? (i10 - i12 | 0) > 2 : 0) ? (HEAP8[i12 >> 0] | 0) == -17 : 0) ? (HEAP8[i12 + 1 >> 0] | 0) == -69 : 0) i1 = (HEAP8[i12 + 2 >> 0] | 0) == -65 ? i12 + 3 | 0 : i12; else i1 = i12;
 L7 : do if (i1 >>> 0 < i10 >>> 0 & (i11 | 0) != 0) {
  i8 = i10;
  i7 = 0;
  L9 : while (1) {
   i2 = HEAP8[i1 >> 0] | 0;
   i6 = i2 & 255;
   do if (i2 << 24 >> 24 > -1) {
    if (i6 >>> 0 > i9 >>> 0) break L7;
    i1 = i1 + 1 | 0;
   } else {
    if ((i2 & 255) < 194) break L7;
    if ((i2 & 255) < 224) {
     if ((i8 - i1 | 0) < 2) break L7;
     i2 = HEAPU8[i1 + 1 >> 0] | 0;
     if ((i2 & 192 | 0) != 128) break L7;
     if ((i2 & 63 | i6 << 6 & 1984) >>> 0 > i9 >>> 0) break L7;
     i1 = i1 + 2 | 0;
     break;
    }
    if ((i2 & 255) < 240) {
     i3 = i1;
     if ((i8 - i3 | 0) < 3) break L7;
     i4 = HEAP8[i1 + 1 >> 0] | 0;
     i2 = HEAP8[i1 + 2 >> 0] | 0;
     if ((i6 | 0) == 237) {
      if ((i4 & -32) << 24 >> 24 != -128) {
       i2 = 23;
       break L9;
      }
     } else if ((i6 | 0) == 224) {
      if ((i4 & -32) << 24 >> 24 != -96) {
       i2 = 21;
       break L9;
      }
     } else if ((i4 & -64) << 24 >> 24 != -128) {
      i2 = 25;
      break L9;
     }
     i2 = i2 & 255;
     if ((i2 & 192 | 0) != 128) break L7;
     if (((i4 & 255) << 6 & 4032 | i6 << 12 & 61440 | i2 & 63) >>> 0 > i9 >>> 0) break L7;
     i1 = i1 + 3 | 0;
     break;
    }
    if ((i2 & 255) >= 245) break L7;
    i3 = i1;
    if ((i8 - i3 | 0) < 4) break L7;
    i5 = HEAP8[i1 + 1 >> 0] | 0;
    i4 = HEAP8[i1 + 2 >> 0] | 0;
    i2 = HEAP8[i1 + 3 >> 0] | 0;
    if ((i6 | 0) == 244) {
     if ((i5 & -16) << 24 >> 24 != -128) {
      i2 = 35;
      break L9;
     }
    } else if ((i6 | 0) == 240) {
     if ((i5 + 112 << 24 >> 24 & 255) >= 48) {
      i2 = 33;
      break L9;
     }
    } else if ((i5 & -64) << 24 >> 24 != -128) {
     i2 = 37;
     break L9;
    }
    i4 = i4 & 255;
    if ((i4 & 192 | 0) != 128) break L7;
    i2 = i2 & 255;
    if ((i2 & 192 | 0) != 128) break L7;
    if (((i5 & 255) << 12 & 258048 | i6 << 18 & 1835008 | i4 << 6 & 4032 | i2 & 63) >>> 0 > i9 >>> 0) break L7;
    i1 = i1 + 4 | 0;
   } while (0);
   i7 = i7 + 1 | 0;
   if (!(i1 >>> 0 < i10 >>> 0 & i7 >>> 0 < i11 >>> 0)) break L7;
  }
  if ((i2 | 0) == 21) {
   i10 = i3 - i12 | 0;
   STACKTOP = i13;
   return i10 | 0;
  } else if ((i2 | 0) == 23) {
   i10 = i3 - i12 | 0;
   STACKTOP = i13;
   return i10 | 0;
  } else if ((i2 | 0) == 25) {
   i10 = i3 - i12 | 0;
   STACKTOP = i13;
   return i10 | 0;
  } else if ((i2 | 0) == 33) {
   i10 = i3 - i12 | 0;
   STACKTOP = i13;
   return i10 | 0;
  } else if ((i2 | 0) == 35) {
   i10 = i3 - i12 | 0;
   STACKTOP = i13;
   return i10 | 0;
  } else if ((i2 | 0) == 37) {
   i10 = i3 - i12 | 0;
   STACKTOP = i13;
   return i10 | 0;
  }
 } while (0);
 i10 = i1 - i12 | 0;
 STACKTOP = i13;
 return i10 | 0;
}

function __ZL12icvGetFormatPK5CvSeqPKcP10CvAttrListiPc(i11, i6, i2, i8, i10) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 i12 = i13;
 i9 = i13 + 520 | 0;
 i7 = i13 + 512 | 0;
 L1 : do if (i2) {
  L2 : while (1) {
   i5 = HEAP32[i2 >> 2] | 0;
   if (!i5) break L1;
   i3 = HEAP32[i5 >> 2] | 0;
   if (i3) {
    i1 = 0;
    i4 = 0;
    do {
     i4 = i4 + 1 | 0;
     if (!(_strcmp(i6, i3) | 0)) break L2;
     i1 = i4 << 1;
     i3 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
    } while ((i3 | 0) != 0);
   }
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L1;
  }
  i6 = HEAP32[i5 + ((i1 | 1) << 2) >> 2] | 0;
  if (i6) {
   i10 = __ZL15icvDecodeFormatPKcPii(i6, i12) | 0;
   i2 = i10 << 1;
   if ((i10 | 0) > 0) {
    i3 = 0;
    i1 = i8;
    do {
     i10 = HEAP32[i12 + ((i3 | 1) << 2) >> 2] | 0;
     i10 = (i10 >>> 3 & 511) + 1 << (47696 >>> (i10 << 1 & 14) & 3);
     i1 = (i1 + -1 + i10 & 0 - i10) + (Math_imul(i10, HEAP32[i12 + (i3 << 2) >> 2] | 0) | 0) | 0;
     i3 = i3 + 2 | 0;
    } while ((i3 | 0) < (i2 | 0));
   } else i1 = i8;
   if (!i8) {
    i10 = HEAP32[i12 + 4 >> 2] | 0;
    i10 = (i10 >>> 3 & 511) + 1 << (47696 >>> (i10 << 1 & 14) & 3);
    i1 = i1 + -1 + i10 & 0 - i10;
   }
   if ((i1 | 0) == (HEAP32[i11 + 28 >> 2] | 0)) {
    i10 = i6;
    STACKTOP = i13;
    return i10 | 0;
   }
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   i3 = (__ZN2cv6String8allocateEj(i9, 71) | 0) + 0 | 0;
   i2 = 12784;
   i1 = i3 + 71 | 0;
   do {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    i3 = i3 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i3 | 0) < (i1 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-209, i9, 12856, 8960, 4069);
   __ZN2cv6String10deallocateEv(i9);
   i10 = i6;
   STACKTOP = i13;
   return i10 | 0;
  }
 } while (0);
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i11 + 28 >> 2] | 0;
 if (!(i1 & 4095)) if ((i2 | 0) != 1) {
  if ((i2 | 0) <= (i8 | 0)) {
   i10 = 0;
   STACKTOP = i13;
   return i10 | 0;
  }
  i1 = i2 - i8 | 0;
  if (!(i1 & 3)) {
   HEAP32[i12 >> 2] = i1 >>> 2;
   _sprintf(i10, 12744, i12) | 0;
   STACKTOP = i13;
   return i10 | 0;
  } else {
   HEAP32[i12 >> 2] = i1;
   _sprintf(i10, 12752, i12) | 0;
   STACKTOP = i13;
   return i10 | 0;
  }
 } else i2 = 1;
 if (((i1 >>> 3 & 511) + 1 << (47696 >>> (i1 << 1 & 14) & 3) | 0) != (i2 | 0)) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i7, 68) | 0) + 0 | 0;
  i2 = 12872;
  i1 = i3 + 68 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-209, i7, 12856, 8960, 4075);
  __ZN2cv6String10deallocateEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i9 = HEAP8[11696 + (i1 & 7) >> 0] | 0;
 HEAP32[i12 >> 2] = (i1 >>> 3 & 511) + 1;
 HEAP32[i12 + 4 >> 2] = i9;
 _sprintf(i10, 11688, i12) | 0;
 if (!(HEAP8[i10 + 2 >> 0] | 0)) i1 = (HEAP8[i10 >> 0] | 0) == 49; else i1 = 0;
 i10 = i10 + (i1 & 1) | 0;
 STACKTOP = i13;
 return i10 | 0;
}

function __ZN2cv3MatC2ERKS0_RKNS_5Rect_IiEE(i20, i19, i12) {
 i20 = i20 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i21 + 8 | 0;
 i7 = i21;
 i1 = HEAP32[i19 >> 2] | 0;
 HEAP32[i20 >> 2] = i1;
 HEAP32[i20 + 4 >> 2] = 2;
 i15 = i20 + 8 | 0;
 i16 = i12 + 12 | 0;
 HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
 i17 = i20 + 12 | 0;
 i18 = i12 + 8 | 0;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 i8 = i20 + 16 | 0;
 i9 = i12 + 4 | 0;
 i13 = i19 + 44 | 0;
 i2 = (HEAP32[i19 + 16 >> 2] | 0) + (Math_imul(HEAP32[HEAP32[i13 >> 2] >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0) | 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i20 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[i19 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[i19 + 28 >> 2];
 HEAP32[i20 + 32 >> 2] = HEAP32[i19 + 32 >> 2];
 i10 = i20 + 36 | 0;
 HEAP32[i10 >> 2] = HEAP32[i19 + 36 >> 2];
 HEAP32[i20 + 40 >> 2] = i15;
 i6 = i20 + 48 | 0;
 i14 = i20 + 44 | 0;
 HEAP32[i14 >> 2] = i6;
 HEAP32[i20 + 52 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if ((HEAP32[i19 + 4 >> 2] | 0) >= 3) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i3, 11) | 0) + 0 | 0;
  i1 = 27936 | 0;
  i4 = i2 + 11 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 27752, 27528, 485);
  __ZN2cv6String10deallocateEv(i3);
  i1 = HEAP32[i20 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i22 = HEAP32[i18 >> 2] | 0;
 i6 = i19 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 HEAP32[i20 >> 2] = ((i3 | 0) == 1 ? 16384 : 0) | ((i22 | 0) < (i4 | 0) ? -16385 : -1) & i1;
 i5 = (i1 >>> 3 & 511) + 1 << (47696 >>> (i1 << 1 & 14) & 3);
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i8 >> 2] = i2 + (Math_imul(i5, i1) | 0);
 if (!((!((i1 | i22 | 0) < 0 | (i22 + i1 | 0) > (i4 | 0)) ? (i11 = HEAP32[i9 >> 2] | 0, (i11 | i3 | 0) > -1) : 0) ? (i3 + i11 | 0) <= (HEAP32[i19 + 8 >> 2] | 0) : 0)) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i7, 124) | 0) + 0 | 0;
  i1 = 27952 | 0;
  i4 = i2 + 124 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 27752, 27528, 492);
  __ZN2cv6String10deallocateEv(i7);
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1) {
  i10 = i1 + 12 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 if (!((HEAP32[i18 >> 2] | 0) >= (HEAP32[i6 >> 2] | 0) ? (HEAP32[i16 >> 2] | 0) >= (HEAP32[i19 + 8 >> 2] | 0) : 0)) HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | 32768;
 i10 = HEAP32[i14 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[HEAP32[i13 >> 2] >> 2];
 HEAP32[i10 + 4 >> 2] = i5;
 if ((HEAP32[i15 >> 2] | 0) >= 1 ? (HEAP32[i17 >> 2] | 0) >= 1 : 0) {
  STACKTOP = i21;
  return;
 }
 __ZN2cv3Mat7releaseEv(i20);
 HEAP32[i17 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i21;
 return;
}

function __ZN2cvL13GEMMStore_32fEPKfjPKdjPfjNS_5Size_IiEEddi(i5, i2, i7, i3, i8, i4, i1, d21, d22, i6) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 d21 = +d21;
 d22 = +d22;
 i6 = i6 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, d24 = 0.0, i25 = 0, i26 = 0, d27 = 0.0;
 i23 = STACKTOP;
 i20 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i2 >>> 2;
 i19 = i3 >>> 3;
 i18 = i4 >>> 2;
 if (!i5) {
  i5 = 0;
  i17 = 0;
  i16 = 0;
 } else {
  i16 = (i6 & 4 | 0) == 0;
  i17 = i16 ? i2 : 1;
  i16 = i16 ? 1 : i2;
 }
 if (!i1) {
  STACKTOP = i23;
  return;
 }
 i2 = i16 << 1;
 i9 = i16 * 3 | 0;
 i10 = i16 << 2;
 i11 = i20 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i15 = (i11 | 0) > 3;
 i13 = i15 ? i20 & -4 : 4;
 i15 = i15 ? i11 >>> 2 : 0;
 i14 = Math_imul(i10, i15) | 0;
 i15 = (i15 << 2) + 4 | 0;
 i3 = i5;
 i4 = i5 + (i10 << 2) | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  if (!i3) {
   if (i12) i6 = 0; else {
    i6 = 0;
    do {
     i25 = i6 | 1;
     d24 = +HEAPF64[i7 + (i25 << 3) >> 3] * d21;
     HEAPF32[i8 + (i6 << 2) >> 2] = Math_fround(+HEAPF64[i7 + (i6 << 3) >> 3] * d21);
     HEAPF32[i8 + (i25 << 2) >> 2] = Math_fround(d24);
     i25 = i6 | 2;
     i5 = i6 | 3;
     d24 = +HEAPF64[i7 + (i5 << 3) >> 3] * d21;
     HEAPF32[i8 + (i25 << 2) >> 2] = Math_fround(+HEAPF64[i7 + (i25 << 3) >> 3] * d21);
     HEAPF32[i8 + (i5 << 2) >> 2] = Math_fround(d24);
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i11 | 0));
    i6 = i13;
   }
   if ((i6 | 0) < (i20 | 0)) do {
    HEAPF32[i8 + (i6 << 2) >> 2] = Math_fround(+HEAPF64[i7 + (i6 << 3) >> 3] * d21);
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i20 | 0));
  } else {
   if (i12) {
    i6 = i3;
    i5 = 0;
   } else {
    i6 = i3;
    i5 = 0;
    while (1) {
     i26 = i5 | 1;
     d24 = +HEAPF64[i7 + (i5 << 3) >> 3] * d21 + +Math_fround(HEAPF32[i6 >> 2]) * d22;
     d27 = +HEAPF64[i7 + (i26 << 3) >> 3] * d21 + +Math_fround(HEAPF32[i6 + (i16 << 2) >> 2]) * d22;
     HEAPF32[i8 + (i5 << 2) >> 2] = Math_fround(d24);
     HEAPF32[i8 + (i26 << 2) >> 2] = Math_fround(d27);
     i26 = i5 | 2;
     i25 = i5 | 3;
     d27 = +HEAPF64[i7 + (i26 << 3) >> 3] * d21 + +Math_fround(HEAPF32[i6 + (i2 << 2) >> 2]) * d22;
     d24 = +HEAPF64[i7 + (i25 << 3) >> 3] * d21 + +Math_fround(HEAPF32[i6 + (i9 << 2) >> 2]) * d22;
     HEAPF32[i8 + (i26 << 2) >> 2] = Math_fround(d27);
     HEAPF32[i8 + (i25 << 2) >> 2] = Math_fround(d24);
     i5 = i5 + 4 | 0;
     if ((i5 | 0) > (i11 | 0)) break; else i6 = i6 + (i10 << 2) | 0;
    }
    i6 = i4 + (i14 << 2) | 0;
    i5 = i15;
   }
   if ((i5 | 0) < (i20 | 0)) while (1) {
    HEAPF32[i8 + (i5 << 2) >> 2] = Math_fround(+HEAPF64[i7 + (i5 << 3) >> 3] * d21 + +Math_fround(HEAPF32[i6 >> 2]) * d22);
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i20 | 0)) break; else i6 = i6 + (i16 << 2) | 0;
   }
  }
  if (!i1) break; else {
   i7 = i7 + (i19 << 3) | 0;
   i8 = i8 + (i18 << 2) | 0;
   i3 = i3 + (i17 << 2) | 0;
   i4 = i4 + (i17 << 2) | 0;
  }
 }
 STACKTOP = i23;
 return;
}

function __ZNKSt3__18messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE(i16, i1, i7, i9, i8, i5) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 i13 = i17;
 i12 = i17 + 48 | 0;
 i11 = i17 + 40 | 0;
 i14 = i17 + 36 | 0;
 i15 = i17 + 24 | 0;
 i6 = i17 + 16 | 0;
 i10 = i17 + 8 | 0;
 HEAP32[i15 + 0 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 962384;
 i2 = HEAP8[i5 >> 0] | 0;
 if (!(i2 & 1)) {
  i3 = i5 + 4 | 0;
  i1 = (i2 & 255) >>> 1;
  i2 = i5 + 4 | 0;
 } else {
  i2 = HEAP32[i5 + 8 >> 2] | 0;
  i3 = i2;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
 }
 i5 = i3 + (i1 << 2) | 0;
 i4 = i13;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 L5 : do if (i2 >>> 0 < i5 >>> 0) {
  i4 = i12 + 32 | 0;
  i1 = 962384 | 0;
  while (1) {
   HEAP32[i14 >> 2] = i2;
   i3 = (FUNCTION_TABLE_iiiiiiiii[HEAP32[i1 + 12 >> 2] & 15](i6, i13, i2, i5, i14, i12, i4, i11) | 0) == 2;
   i1 = HEAP32[i14 >> 2] | 0;
   if (i3 | (i1 | 0) == (i2 | 0)) break;
   if (i12 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
    i2 = i12;
    do {
     __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i15, HEAP8[i2 >> 0] | 0);
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
    i2 = HEAP32[i14 >> 2] | 0;
   } else i2 = i1;
   if (i2 >>> 0 >= i5 >>> 0) break L5;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  __ZNSt3__121__throw_runtime_errorEPKc(961608);
 } while (0);
 if (!(HEAP8[i15 >> 0] & 1)) i1 = i15 + 1 | 0; else i1 = HEAP32[i15 + 8 >> 2] | 0;
 i1 = _catgets(((i7 | 0) == -1 ? -1 : i7 << 1) | 0, i9 | 0, i8 | 0, i1 | 0) | 0;
 HEAP32[i16 + 0 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 962488;
 i9 = _strlen(i1 | 0) | 0;
 i3 = i1 + i9 | 0;
 i8 = i13;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 if ((i9 | 0) <= 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
  STACKTOP = i17;
  return;
 }
 i4 = i3;
 i5 = i12 + 128 | 0;
 i2 = 962488 | 0;
 while (1) {
  HEAP32[i14 >> 2] = i1;
  i9 = (FUNCTION_TABLE_iiiiiiiii[HEAP32[i2 + 16 >> 2] & 15](i10, i13, i1, (i4 - i1 | 0) > 32 ? i1 + 32 | 0 : i3, i14, i12, i5, i11) | 0) == 2;
  i2 = HEAP32[i14 >> 2] | 0;
  if (i9 | (i2 | 0) == (i1 | 0)) {
   i1 = 20;
   break;
  }
  if (i12 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   i1 = i12;
   do {
    __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw(i16, HEAP32[i1 >> 2] | 0);
    i1 = i1 + 4 | 0;
   } while (i1 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
   i1 = HEAP32[i14 >> 2] | 0;
  } else i1 = i2;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 25;
   break;
  }
  i2 = HEAP32[i10 >> 2] | 0;
 }
 if ((i1 | 0) == 20) __ZNSt3__121__throw_runtime_errorEPKc(961608); else if ((i1 | 0) == 25) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i15);
  STACKTOP = i17;
  return;
 }
}

function __ZNSt3__19__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_(i3, i6, i7, i5, i10, i2, i1, i9, i12, i13, i11, i4) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i8 = 0, i14 = 0;
 i14 = STACKTOP;
 if (i3 << 24 >> 24 == i2 << 24 >> 24) {
  if (!(HEAP8[i6 >> 0] | 0)) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
  HEAP8[i6 >> 0] = 0;
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = 46;
  i1 = HEAP8[i9 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i9 + 4 >> 2] | 0;
  if (!i1) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  i1 = HEAP32[i13 >> 2] | 0;
  if ((i1 - i12 | 0) >= 160) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = i1 + 4;
  HEAP32[i1 >> 2] = i10;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 if (i3 << 24 >> 24 == i1 << 24 >> 24) {
  i1 = HEAP8[i9 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i9 + 4 >> 2] | 0;
  if (i1) {
   if (!(HEAP8[i6 >> 0] | 0)) {
    i10 = -1;
    STACKTOP = i14;
    return i10 | 0;
   }
   i1 = HEAP32[i13 >> 2] | 0;
   if ((i1 - i12 | 0) >= 160) {
    i10 = 0;
    STACKTOP = i14;
    return i10 | 0;
   }
   i10 = HEAP32[i11 >> 2] | 0;
   HEAP32[i13 >> 2] = i1 + 4;
   HEAP32[i1 >> 2] = i10;
   HEAP32[i11 >> 2] = 0;
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
 }
 i1 = i4 + 32 | 0;
 i2 = i4;
 do {
  if ((HEAP8[i2 >> 0] | 0) == i3 << 24 >> 24) {
   i1 = i2;
   break;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i2 = i1 - i4 | 0;
 if ((i2 | 0) > 31) {
  i10 = -1;
  STACKTOP = i14;
  return i10 | 0;
 }
 i3 = HEAP8[959240 + i2 >> 0] | 0;
 if ((i2 | 0) == 23 | (i2 | 0) == 22) {
  HEAP8[i7 >> 0] = 80;
  i9 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i9 + 1;
  HEAP8[i9 >> 0] = i3;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 } else if ((i2 | 0) == 24 | (i2 | 0) == 25) {
  i1 = HEAP32[i10 >> 2] | 0;
  if ((i1 | 0) != (i5 | 0) ? (HEAPU8[i1 + -1 >> 0] & 95 | 0) != (HEAPU8[i7 >> 0] & 127 | 0) : 0) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
  HEAP32[i10 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = i3;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 } else {
  i1 = i3 & 95;
  if ((i1 | 0) == (HEAP8[i7 >> 0] | 0) ? (HEAP8[i7 >> 0] = i1 | 128, (HEAP8[i6 >> 0] | 0) != 0) : 0) {
   HEAP8[i6 >> 0] = 0;
   i1 = HEAP8[i9 >> 0] | 0;
   if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i9 + 4 >> 2] | 0;
   if ((i1 | 0) != 0 ? (i8 = HEAP32[i13 >> 2] | 0, (i8 - i12 | 0) < 160) : 0) {
    i9 = HEAP32[i11 >> 2] | 0;
    HEAP32[i13 >> 2] = i8 + 4;
    HEAP32[i8 >> 2] = i9;
   }
  }
  i9 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i9 + 1;
  HEAP8[i9 >> 0] = i3;
  if ((i2 | 0) > 21) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 return 0;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce(i24, i1, i23, i21, i20, d5) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i23 = i23 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 d5 = +d5;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i25 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i8 = i15 + 8 | 0;
 i1 = i15;
 i6 = i15 + 102 | 0;
 i4 = i15 + 40 | 0;
 i7 = i15 + 44 | 0;
 i14 = i15 + 36 | 0;
 i13 = i15 + 32 | 0;
 i9 = i15 + 28 | 0;
 i10 = i15 + 24 | 0;
 i11 = i15 + 20 | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = 37;
 HEAP32[i2 + 4 >> 2] = 0;
 i2 = __ZNSt3__114__num_put_base14__format_floatEPcPKcj(i1 + 1 | 0, 959448, HEAP32[i21 + 4 >> 2] | 0) | 0;
 HEAP32[i4 >> 2] = i6;
 i3 = __ZNSt3__16__clocEv() | 0;
 if (i2) {
  HEAP32[i8 >> 2] = HEAP32[i21 + 8 >> 2];
  i25 = i8 + 4 | 0;
  HEAPF64[tempDoublePtr >> 3] = d5;
  HEAP32[i25 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i3 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i6, 30, i3, i1, i8) | 0;
 } else {
  HEAPF64[tempDoublePtr >> 3] = d5;
  HEAP32[i8 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i3 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i6, 30, i3, i1, i8) | 0;
 }
 if ((i3 | 0) > 29) {
  i3 = __ZNSt3__16__clocEv() | 0;
  if (i2) {
   HEAP32[i8 >> 2] = HEAP32[i21 + 8 >> 2];
   i2 = i8 + 4 | 0;
   HEAPF64[tempDoublePtr >> 3] = d5;
   HEAP32[i2 >> 2] = HEAP32[tempDoublePtr >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
   i3 = __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz(i4, i3, i1, i8) | 0;
  } else {
   HEAPF64[tempDoublePtr >> 3] = d5;
   HEAP32[i8 >> 2] = HEAP32[tempDoublePtr >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
   i3 = __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz(i4, i3, i1, i8) | 0;
  }
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) __ZSt17__throw_bad_allocv(); else {
   i16 = i1;
   i19 = i1;
   i12 = i3;
  }
 } else {
  i16 = HEAP32[i4 >> 2] | 0;
  i19 = 0;
  i12 = i3;
 }
 i2 = i16 + i12 | 0;
 i3 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i16, i2, i21) | 0;
 if ((i16 | 0) != (i6 | 0)) {
  i1 = _malloc(i12 << 1) | 0;
  if (!i1) __ZSt17__throw_bad_allocv(); else {
   i17 = i16;
   i18 = i1;
   i22 = i1;
  }
 } else {
  i17 = i6;
  i18 = 0;
  i22 = i7;
 }
 __ZNKSt3__18ios_base6getlocEv(i9, i21);
 __ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE(i17, i3, i2, i22, i14, i13, i9);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i9 >> 2] | 0) | 0;
 HEAP32[i11 >> 2] = HEAP32[i23 >> 2];
 i17 = HEAP32[i14 >> 2] | 0;
 i23 = HEAP32[i13 >> 2] | 0;
 HEAP32[i8 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i10, i8, i22, i17, i23, i21, i20);
 HEAP32[i24 >> 2] = HEAP32[i10 >> 2];
 _free(i18);
 _free(i19);
 STACKTOP = i15;
 return;
}

function __ZN2cvL6mul32sEPKijS1_jPijNS_5Size_IiEEPv(i9, i3, i10, i4, i12, i5, i2, i1) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, d11 = 0.0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 i16 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 d11 = +HEAPF64[i1 >> 3];
 i15 = i3 >>> 2;
 i14 = i4 >>> 2;
 i13 = i5 >>> 2;
 i5 = i2 + -1 | 0;
 i2 = (i2 | 0) == 0;
 if (d11 == 1.0) {
  if (i2) {
   STACKTOP = i17;
   return;
  }
  i6 = i16 + -4 | 0;
  i7 = (i6 | 0) < 0;
  i8 = i16 & -4;
  i1 = i9;
  i2 = i10;
  i3 = i12;
  while (1) {
   if (i7) i4 = 0; else {
    i4 = 0;
    do {
     i10 = Math_imul(HEAP32[i2 + (i4 << 2) >> 2] | 0, HEAP32[i1 + (i4 << 2) >> 2] | 0) | 0;
     i12 = i4 | 1;
     i18 = Math_imul(HEAP32[i2 + (i12 << 2) >> 2] | 0, HEAP32[i1 + (i12 << 2) >> 2] | 0) | 0;
     HEAP32[i3 + (i4 << 2) >> 2] = i10;
     HEAP32[i3 + (i12 << 2) >> 2] = i18;
     i12 = i4 | 2;
     i18 = Math_imul(HEAP32[i2 + (i12 << 2) >> 2] | 0, HEAP32[i1 + (i12 << 2) >> 2] | 0) | 0;
     i10 = i4 | 3;
     i9 = Math_imul(HEAP32[i2 + (i10 << 2) >> 2] | 0, HEAP32[i1 + (i10 << 2) >> 2] | 0) | 0;
     HEAP32[i3 + (i12 << 2) >> 2] = i18;
     HEAP32[i3 + (i10 << 2) >> 2] = i9;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) <= (i6 | 0));
    i4 = i8;
   }
   if ((i4 | 0) < (i16 | 0)) do {
    HEAP32[i3 + (i4 << 2) >> 2] = Math_imul(HEAP32[i2 + (i4 << 2) >> 2] | 0, HEAP32[i1 + (i4 << 2) >> 2] | 0) | 0;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i16 | 0));
   if (!i5) break; else {
    i1 = i1 + (i15 << 2) | 0;
    i2 = i2 + (i14 << 2) | 0;
    i3 = i3 + (i13 << 2) | 0;
    i5 = i5 + -1 | 0;
   }
  }
  STACKTOP = i17;
  return;
 } else {
  if (i2) {
   STACKTOP = i17;
   return;
  }
  i8 = i16 + -4 | 0;
  i7 = (i8 | 0) < 0;
  i6 = i16 & -4;
  i1 = i10;
  i2 = i9;
  i3 = i12;
  i4 = i5;
  while (1) {
   if (i7) i5 = 0; else {
    i5 = 0;
    do {
     i10 = _lrint(d11 * +(HEAP32[i2 + (i5 << 2) >> 2] | 0) * +(HEAP32[i1 + (i5 << 2) >> 2] | 0)) | 0;
     i12 = i5 | 1;
     i18 = _lrint(d11 * +(HEAP32[i2 + (i12 << 2) >> 2] | 0) * +(HEAP32[i1 + (i12 << 2) >> 2] | 0)) | 0;
     HEAP32[i3 + (i5 << 2) >> 2] = i10;
     HEAP32[i3 + (i12 << 2) >> 2] = i18;
     i12 = i5 | 2;
     i18 = _lrint(d11 * +(HEAP32[i2 + (i12 << 2) >> 2] | 0) * +(HEAP32[i1 + (i12 << 2) >> 2] | 0)) | 0;
     i10 = i5 | 3;
     i9 = _lrint(d11 * +(HEAP32[i2 + (i10 << 2) >> 2] | 0) * +(HEAP32[i1 + (i10 << 2) >> 2] | 0)) | 0;
     HEAP32[i3 + (i12 << 2) >> 2] = i18;
     HEAP32[i3 + (i10 << 2) >> 2] = i9;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) <= (i8 | 0));
    i5 = i6;
   }
   if ((i5 | 0) < (i16 | 0)) do {
    HEAP32[i3 + (i5 << 2) >> 2] = _lrint(d11 * +(HEAP32[i2 + (i5 << 2) >> 2] | 0) * +(HEAP32[i1 + (i5 << 2) >> 2] | 0)) | 0;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i16 | 0));
   if (!i4) break; else {
    i1 = i1 + (i14 << 2) | 0;
    i2 = i2 + (i15 << 2) | 0;
    i3 = i3 + (i13 << 2) | 0;
    i4 = i4 + -1 | 0;
   }
  }
  STACKTOP = i17;
  return;
 }
}

function __ZN2cvL6cmp64fEPKdjS1_jPhjNS_5Size_IiEEPv(i5, i3, i6, i4, i12, i16, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 i15 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = i3 >>> 3;
 i4 = i4 >>> 3;
 if ((i2 & -2 | 0) == 2) {
  i2 = (i2 | 0) == 2 ? 4 : 1;
  i11 = i6;
  i14 = i4;
  i4 = i3;
 } else {
  i11 = i5;
  i5 = i6;
  i14 = i3;
 }
 if ((i2 | 0) == 1 | (i2 | 0) == 4) {
  i7 = (i2 | 0) == 1 ? 0 : 255;
  if (!i13) {
   STACKTOP = i17;
   return;
  }
  i8 = i15 + -4 | 0;
  i9 = (i8 | 0) < 0;
  i10 = i15 & -4;
  i1 = i12;
  i2 = i13;
  i6 = i11;
  while (1) {
   i2 = i2 + -1 | 0;
   if (i9) i3 = 0; else {
    i3 = 0;
    do {
     i13 = i3 | 1;
     i11 = (+HEAPF64[i6 + (i13 << 3) >> 3] > +HEAPF64[i5 + (i13 << 3) >> 3]) << 31 >> 31 ^ i7;
     HEAP8[i1 + i3 >> 0] = (+HEAPF64[i6 + (i3 << 3) >> 3] > +HEAPF64[i5 + (i3 << 3) >> 3]) << 31 >> 31 ^ i7;
     HEAP8[i1 + i13 >> 0] = i11;
     i13 = i3 | 2;
     i11 = i3 | 3;
     i12 = (+HEAPF64[i6 + (i11 << 3) >> 3] > +HEAPF64[i5 + (i11 << 3) >> 3]) << 31 >> 31 ^ i7;
     HEAP8[i1 + i13 >> 0] = (+HEAPF64[i6 + (i13 << 3) >> 3] > +HEAPF64[i5 + (i13 << 3) >> 3]) << 31 >> 31 ^ i7;
     HEAP8[i1 + i11 >> 0] = i12;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) <= (i8 | 0));
    i3 = i10;
   }
   if ((i3 | 0) < (i15 | 0)) do {
    HEAP8[i1 + i3 >> 0] = (+HEAPF64[i6 + (i3 << 3) >> 3] > +HEAPF64[i5 + (i3 << 3) >> 3]) << 31 >> 31 ^ i7;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i15 | 0));
   if (!i2) break; else {
    i1 = i1 + i16 | 0;
    i6 = i6 + (i14 << 3) | 0;
    i5 = i5 + (i4 << 3) | 0;
   }
  }
  STACKTOP = i17;
  return;
 }
 if (!((i2 | 0) == 0 | (i2 | 0) == 5)) {
  STACKTOP = i17;
  return;
 }
 i10 = (i2 | 0) == 0 ? 0 : 255;
 if (!i13) {
  STACKTOP = i17;
  return;
 }
 i9 = i15 + -4 | 0;
 i8 = (i9 | 0) < 0;
 i7 = i15 & -4;
 i1 = i12;
 i2 = i13;
 i6 = i11;
 while (1) {
  i2 = i2 + -1 | 0;
  if (i8) i3 = 0; else {
   i3 = 0;
   do {
    i13 = i3 | 1;
    i11 = (+HEAPF64[i6 + (i13 << 3) >> 3] == +HEAPF64[i5 + (i13 << 3) >> 3]) << 31 >> 31 ^ i10;
    HEAP8[i1 + i3 >> 0] = (+HEAPF64[i6 + (i3 << 3) >> 3] == +HEAPF64[i5 + (i3 << 3) >> 3]) << 31 >> 31 ^ i10;
    HEAP8[i1 + i13 >> 0] = i11;
    i13 = i3 | 2;
    i11 = i3 | 3;
    i12 = (+HEAPF64[i6 + (i11 << 3) >> 3] == +HEAPF64[i5 + (i11 << 3) >> 3]) << 31 >> 31 ^ i10;
    HEAP8[i1 + i13 >> 0] = (+HEAPF64[i6 + (i13 << 3) >> 3] == +HEAPF64[i5 + (i13 << 3) >> 3]) << 31 >> 31 ^ i10;
    HEAP8[i1 + i11 >> 0] = i12;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i9 | 0));
   i3 = i7;
  }
  if ((i3 | 0) < (i15 | 0)) do {
   HEAP8[i1 + i3 >> 0] = (+HEAPF64[i6 + (i3 << 3) >> 3] == +HEAPF64[i5 + (i3 << 3) >> 3]) << 31 >> 31 ^ i10;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i15 | 0));
  if (!i2) break; else {
   i1 = i1 + i16 | 0;
   i6 = i6 + (i14 << 3) | 0;
   i5 = i5 + (i4 << 3) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZN7testing8TestInfo3RunEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i13 + 16 | 0;
 i2 = i13 + 8 | 0;
 i5 = i13;
 if (!(HEAP8[i12 + 36 >> 0] | 0)) {
  STACKTOP = i13;
  return;
 }
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i10 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i10, 163728);
  HEAP32[40934] = i10;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i1 = HEAP32[40934] | 0;
 i6 = i1 + 108 | 0;
 HEAP32[i6 >> 2] = i12;
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i10 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i10, 163728);
  HEAP32[40934] = i10;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i7 = HEAP32[(HEAP32[40934] | 0) + 152 >> 2] | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] & 127](i7, i12);
 _gettimeofday(i4 | 0, 0) | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i9 = ((i8 | 0) < 0) << 31 >> 31;
 i10 = (HEAP32[i4 + 4 >> 2] | 0) / 1e3 | 0;
 i11 = ((i10 | 0) < 0) << 31 >> 31;
 i3 = i1 + 164 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(12) | 0;
  HEAP32[i1 >> 2] = 165008;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i3 >> 2] = i1;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 511](i1);
 i1 = HEAP32[i12 + 40 >> 2] | 0;
 HEAP32[i2 >> 2] = 8;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i4 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 i2 = __ZN7testing8internal35HandleExceptionsInMethodIfSupportedINS0_15TestFactoryBaseEPNS_4TestEEET0_PT_MS6_FS5_vEPKc(i1, i4, 161896) | 0;
 if ((i2 | 0) != 0 ? !(__ZN7testing4Test15HasFatalFailureEv() | 0) : 0) __ZN7testing4Test3RunEv(i2);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(12) | 0;
  HEAP32[i1 >> 2] = 165008;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i3 >> 2] = i1;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 511](i1);
 HEAP32[i5 >> 2] = 374;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i4 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN7testing8internal35HandleExceptionsInMethodIfSupportedINS_4TestEvEET0_PT_MS4_FS3_vEPKc(i2, i4, 161928);
 _gettimeofday(i4 | 0, 0) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i2 = ___muldi3(i2 | 0, ((i2 | 0) < 0) << 31 >> 31 | 0, 1e3, 0) | 0;
 i3 = tempRet0;
 i5 = (HEAP32[i4 + 4 >> 2] | 0) / 1e3 | 0;
 i9 = ___muldi3(i8 | 0, i9 | 0, -1e3, -1) | 0;
 i9 = _i64Subtract(i9 | 0, tempRet0 | 0, i10 | 0, i11 | 0) | 0;
 i9 = _i64Add(i9 | 0, tempRet0 | 0, i2 | 0, i3 | 0) | 0;
 i9 = _i64Add(i9 | 0, tempRet0 | 0, i5 | 0, ((i5 | 0) < 0) << 31 >> 31 | 0) | 0;
 i10 = i12 + 80 | 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = tempRet0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] & 127](i7, i12);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN7testing8internal9EqFailureEPKcS2_RKNSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEESB_b(i9, i4, i2, i6, i3, i5) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i11 = i12 + 8 | 0;
 i8 = i12;
 __ZN7testing7MessageC2Ev(i11);
 i10 = HEAP32[i11 >> 2] | 0;
 i7 = i10 + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 160560, 10) | 0;
 if (!i2) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, i2, _strlen(i2 | 0) | 0) | 0;
 if (__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i3, i2) | 0) {
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 160576, 11) | 0;
  i2 = HEAP8[i3 >> 0] | 0;
  if (!(i2 & 1)) {
   i1 = i3 + 1 | 0;
   i2 = (i2 & 255) >>> 1;
  } else {
   i1 = HEAP32[i3 + 8 >> 2] | 0;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, i1, i2) | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 160592, 11) | 0;
 if (!i4) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, i4, _strlen(i4 | 0) | 0) | 0;
 if (i5) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 160608, 16) | 0;
 if (__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i6, i4) | 0) {
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, 160632, 11) | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if (!(i1 & 1)) {
   i2 = i6 + 1 | 0;
   i1 = (i1 & 255) >>> 1;
  } else {
   i2 = HEAP32[i6 + 8 >> 2] | 0;
   i1 = HEAP32[i6 + 4 >> 2] | 0;
  }
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i7, i2, i1) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 i2 = i8 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i1 = __ZN7testing15AssertionResultlsINS_7MessageEEERS0_RKT_(i8, i11) | 0;
 HEAP8[i9 >> 0] = HEAP8[i1 >> 0] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i8 = __Znwj(12) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i8, i1);
  i1 = i8;
 }
 HEAP32[i9 + 4 >> 2] = i1;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
  __ZdlPv(i1);
  HEAP32[i2 >> 2] = 0;
 }
 if (!i10) {
  STACKTOP = i12;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] & 511](i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function _crc32(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 if (!i3) {
  i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 }
 i1 = ~i1;
 L4 : do if (i2) {
  while (1) {
   if (!(i3 & 3)) break;
   i1 = HEAP32[146824 + (((HEAPU8[i3 >> 0] | 0) ^ i1 & 255) << 2) >> 2] ^ i1 >>> 8;
   i2 = i2 + -1 | 0;
   if (!i2) break L4; else i3 = i3 + 1 | 0;
  }
  if (i2 >>> 0 > 31) {
   i5 = i2 + -32 | 0;
   i6 = i5 & -32;
   i7 = i6 + 32 | 0;
   i4 = i3;
   while (1) {
    i9 = HEAP32[i4 >> 2] ^ i1;
    i9 = HEAP32[148872 + ((i9 >>> 8 & 255) << 2) >> 2] ^ HEAP32[149896 + ((i9 & 255) << 2) >> 2] ^ HEAP32[147848 + ((i9 >>> 16 & 255) << 2) >> 2] ^ HEAP32[146824 + (i9 >>> 24 << 2) >> 2] ^ HEAP32[i4 + 4 >> 2];
    i9 = HEAP32[148872 + ((i9 >>> 8 & 255) << 2) >> 2] ^ HEAP32[149896 + ((i9 & 255) << 2) >> 2] ^ HEAP32[147848 + ((i9 >>> 16 & 255) << 2) >> 2] ^ HEAP32[146824 + (i9 >>> 24 << 2) >> 2] ^ HEAP32[i4 + 8 >> 2];
    i9 = HEAP32[148872 + ((i9 >>> 8 & 255) << 2) >> 2] ^ HEAP32[149896 + ((i9 & 255) << 2) >> 2] ^ HEAP32[147848 + ((i9 >>> 16 & 255) << 2) >> 2] ^ HEAP32[146824 + (i9 >>> 24 << 2) >> 2] ^ HEAP32[i4 + 12 >> 2];
    i9 = HEAP32[148872 + ((i9 >>> 8 & 255) << 2) >> 2] ^ HEAP32[149896 + ((i9 & 255) << 2) >> 2] ^ HEAP32[147848 + ((i9 >>> 16 & 255) << 2) >> 2] ^ HEAP32[146824 + (i9 >>> 24 << 2) >> 2] ^ HEAP32[i4 + 16 >> 2];
    i9 = HEAP32[148872 + ((i9 >>> 8 & 255) << 2) >> 2] ^ HEAP32[149896 + ((i9 & 255) << 2) >> 2] ^ HEAP32[147848 + ((i9 >>> 16 & 255) << 2) >> 2] ^ HEAP32[146824 + (i9 >>> 24 << 2) >> 2] ^ HEAP32[i4 + 20 >> 2];
    i9 = HEAP32[148872 + ((i9 >>> 8 & 255) << 2) >> 2] ^ HEAP32[149896 + ((i9 & 255) << 2) >> 2] ^ HEAP32[147848 + ((i9 >>> 16 & 255) << 2) >> 2] ^ HEAP32[146824 + (i9 >>> 24 << 2) >> 2] ^ HEAP32[i4 + 24 >> 2];
    i9 = HEAP32[148872 + ((i9 >>> 8 & 255) << 2) >> 2] ^ HEAP32[149896 + ((i9 & 255) << 2) >> 2] ^ HEAP32[147848 + ((i9 >>> 16 & 255) << 2) >> 2] ^ HEAP32[146824 + (i9 >>> 24 << 2) >> 2] ^ HEAP32[i4 + 28 >> 2];
    i1 = HEAP32[148872 + ((i9 >>> 8 & 255) << 2) >> 2] ^ HEAP32[149896 + ((i9 & 255) << 2) >> 2] ^ HEAP32[147848 + ((i9 >>> 16 & 255) << 2) >> 2] ^ HEAP32[146824 + (i9 >>> 24 << 2) >> 2];
    i2 = i2 + -32 | 0;
    if (i2 >>> 0 <= 31) break; else i4 = i4 + 32 | 0;
   }
   i2 = i5 - i6 | 0;
   i3 = i3 + i7 | 0;
  }
  if (i2 >>> 0 > 3) {
   i6 = i2 + -4 | 0;
   i7 = i6 >>> 2;
   i5 = i7 << 2;
   i4 = i3;
   while (1) {
    i9 = HEAP32[i4 >> 2] ^ i1;
    i1 = HEAP32[148872 + ((i9 >>> 8 & 255) << 2) >> 2] ^ HEAP32[149896 + ((i9 & 255) << 2) >> 2] ^ HEAP32[147848 + ((i9 >>> 16 & 255) << 2) >> 2] ^ HEAP32[146824 + (i9 >>> 24 << 2) >> 2];
    i2 = i2 + -4 | 0;
    if (i2 >>> 0 <= 3) break; else i4 = i4 + 4 | 0;
   }
   i2 = i6 - i5 | 0;
   i3 = i3 + (i7 + 1 << 2) | 0;
  }
  if (i2) while (1) {
   i1 = HEAP32[146824 + (((HEAPU8[i3 >> 0] | 0) ^ i1 & 255) << 2) >> 2] ^ i1 >>> 8;
   i2 = i2 + -1 | 0;
   if (!i2) break; else i3 = i3 + 1 | 0;
  }
 } while (0);
 i1 = ~i1;
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN2cvL6div32sEPKijS1_jPijNS_5Size_IiEEPv(i6, i3, i7, i4, i8, i5, i1, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, d19 = 0.0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, d27 = 0.0, d28 = 0.0, d29 = 0.0, d30 = 0.0, d31 = 0.0, d32 = 0.0, d33 = 0.0;
 i26 = STACKTOP;
 i20 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 d19 = +HEAPF64[i2 >> 3];
 i18 = i3 >>> 2;
 i17 = i4 >>> 2;
 i14 = i5 >>> 2;
 if (!i1) {
  STACKTOP = i26;
  return;
 }
 i15 = i20 + -4 | 0;
 i16 = (i15 | 0) < 0;
 i13 = i20 & -4;
 while (1) {
  i1 = i1 + -1 | 0;
  if (i16) i4 = 0; else {
   i12 = 0;
   do {
    i5 = HEAP32[i7 + (i12 << 2) >> 2] | 0;
    i11 = i12 | 1;
    i4 = HEAP32[i7 + (i11 << 2) >> 2] | 0;
    do if (!i5) {
     i10 = 0;
     i25 = 10;
    } else {
     if (((i4 | 0) != 0 ? (i21 = i12 | 2, i22 = HEAP32[i7 + (i21 << 2) >> 2] | 0, (i22 | 0) != 0) : 0) ? (i23 = i12 | 3, i24 = HEAP32[i7 + (i23 << 2) >> 2] | 0, (i24 | 0) != 0) : 0) {
      d31 = +(i5 | 0);
      d32 = +(i4 | 0);
      d33 = d31 * d32;
      d28 = +(i22 | 0);
      d29 = +(i24 | 0);
      d30 = d28 * d29;
      d27 = d19 / (d33 * d30);
      d30 = d30 * d27;
      d27 = d33 * d27;
      i5 = _lrint(d32 * (d30 * +(HEAP32[i6 + (i12 << 2) >> 2] | 0))) | 0;
      i4 = _lrint(d31 * (d30 * +(HEAP32[i6 + (i11 << 2) >> 2] | 0))) | 0;
      i3 = _lrint(d29 * (d27 * +(HEAP32[i6 + (i21 << 2) >> 2] | 0))) | 0;
      i2 = _lrint(d28 * (d27 * +(HEAP32[i6 + (i23 << 2) >> 2] | 0))) | 0;
      HEAP32[i8 + (i12 << 2) >> 2] = i5;
      HEAP32[i8 + (i11 << 2) >> 2] = i4;
      HEAP32[i8 + (i21 << 2) >> 2] = i3;
      HEAP32[i8 + (i23 << 2) >> 2] = i2;
      break;
     }
     i10 = _lrint(d19 * +(HEAP32[i6 + (i12 << 2) >> 2] | 0) / +(i5 | 0)) | 0;
     i25 = 10;
    } while (0);
    if ((i25 | 0) == 10) {
     i25 = 0;
     if (!i4) i2 = 0; else i2 = _lrint(d19 * +(HEAP32[i6 + (i11 << 2) >> 2] | 0) / +(i4 | 0)) | 0;
     i9 = i12 | 2;
     i5 = HEAP32[i7 + (i9 << 2) >> 2] | 0;
     if (!i5) i4 = 0; else i4 = _lrint(d19 * +(HEAP32[i6 + (i9 << 2) >> 2] | 0) / +(i5 | 0)) | 0;
     i3 = i12 | 3;
     i5 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
     if (!i5) i5 = 0; else i5 = _lrint(d19 * +(HEAP32[i6 + (i3 << 2) >> 2] | 0) / +(i5 | 0)) | 0;
     HEAP32[i8 + (i12 << 2) >> 2] = i10;
     HEAP32[i8 + (i11 << 2) >> 2] = i2;
     HEAP32[i8 + (i9 << 2) >> 2] = i4;
     HEAP32[i8 + (i3 << 2) >> 2] = i5;
    }
    i12 = i12 + 4 | 0;
   } while ((i12 | 0) <= (i15 | 0));
   i4 = i13;
  }
  if ((i4 | 0) < (i20 | 0)) do {
   i5 = HEAP32[i7 + (i4 << 2) >> 2] | 0;
   if (!i5) i5 = 0; else i5 = _lrint(d19 * +(HEAP32[i6 + (i4 << 2) >> 2] | 0) / +(i5 | 0)) | 0;
   HEAP32[i8 + (i4 << 2) >> 2] = i5;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i20 | 0));
  if (!i1) break; else {
   i6 = i6 + (i18 << 2) | 0;
   i7 = i7 + (i17 << 2) | 0;
   i8 = i8 + (i14 << 2) | 0;
  }
 }
 STACKTOP = i26;
 return;
}

function __ZN7testing8internal18FormatFileLocationEPKci(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i4 = i10 + 48 | 0;
 i9 = i10 + 36 | 0;
 i5 = i10 + 24 | 0;
 i6 = i10 + 12 | 0;
 i7 = i10;
 HEAP32[i4 >> 2] = i1;
 i2 = (i2 | 0) == 0 ? 164688 : i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i2, _strlen(i2 | 0) | 0);
 if ((i1 | 0) < 0) {
  HEAP32[i8 + 0 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  i1 = HEAP8[i9 >> 0] | 0;
  if (!(i1 & 1)) {
   i1 = (i1 & 255) >>> 1;
   i2 = i9 + 1 | 0;
  } else {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   i2 = HEAP32[i9 + 8 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i2, i1, i1 + 1 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, 163080, 1) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
  STACKTOP = i10;
  return;
 };
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i2 = HEAP8[i9 >> 0] | 0;
 if (!(i2 & 1)) {
  i2 = (i2 & 255) >>> 1;
  i1 = i9 + 1 | 0;
 } else {
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = HEAP32[i9 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, i1, i2, i2 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, 163080, 1) | 0;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i7, i4);
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i1 = (i2 & 1) == 0;
 if (i1) i3 = (i2 & 255) >>> 1; else i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = HEAP8[i7 >> 0] | 0;
 if (!(i2 & 1)) i4 = (i2 & 255) >>> 1; else i4 = HEAP32[i7 + 4 >> 2] | 0;
 if (i1) i2 = i6 + 1 | 0; else i2 = HEAP32[i6 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, i2, i3, i4 + i3 | 0);
 if (!(HEAP8[i7 >> 0] & 1)) i2 = i7 + 1 | 0; else i2 = HEAP32[i7 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, i2, i4) | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i2 = HEAP8[i5 >> 0] | 0;
 if (!(i2 & 1)) {
  i2 = (i2 & 255) >>> 1;
  i1 = i5 + 1 | 0;
 } else {
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = HEAP32[i5 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i1, i2, i2 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, 163080, 1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 STACKTOP = i10;
 return;
}

function __ZN2cv7makePtrIN12_GLOBAL__N_113FormattedImplEA2_cS3_NS_3MatEPcbbiEENS_3PtrIT_EERKT0_RKT1_RKT2_RKT3_RKT4_RKT5_RKT6_(i13, i2, i1, i8, i9, i10, i11, i12) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i18 = i20 + 64 | 0;
 i19 = i20 + 56 | 0;
 i15 = i20;
 i7 = __Znwj(156) | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 if (i2) {
  i6 = _strlen(i2 | 0) | 0;
  _memcpy(__ZN2cv6String8allocateEj(i18, i6) | 0, i2 | 0, i6 | 0) | 0;
 }
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 if (i1) {
  i6 = _strlen(i1 | 0) | 0;
  _memcpy(__ZN2cv6String8allocateEj(i19, i6) | 0, i1 | 0, i6 | 0) | 0;
 }
 HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
 i14 = i15 + 4 | 0;
 i1 = i8 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = i2;
 i17 = i15 + 8 | 0;
 HEAP32[i17 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i4 = i15 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 HEAP32[i15 + 32 >> 2] = HEAP32[i8 + 32 >> 2];
 i5 = i15 + 36 | 0;
 i3 = HEAP32[i8 + 36 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 i6 = i15 + 40 | 0;
 HEAP32[i6 >> 2] = i17;
 i17 = i15 + 48 | 0;
 i16 = i15 + 44 | 0;
 HEAP32[i16 >> 2] = i17;
 HEAP32[i15 + 52 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 if (i3) {
  i2 = i3 + 12 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = HEAP32[i1 >> 2] | 0;
 }
 if ((i2 | 0) < 3) {
  i3 = HEAP32[i8 + 44 >> 2] | 0;
  i8 = HEAP32[i16 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 } else {
  HEAP32[i14 >> 2] = 0;
  __ZN2cv3Mat8copySizeERKS0_(i15, i8);
 }
 __ZN12_GLOBAL__N_113FormattedImplC2EN2cv6StringES2_NS1_3MatEPcbbi(i7, i18, i19, i15, HEAP32[i9 >> 2] | 0, (HEAP8[i10 >> 0] | 0) != 0, (HEAP8[i11 >> 0] | 0) != 0, HEAP32[i12 >> 2] | 0);
 i2 = __Znwj(16) | 0;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i2 >> 2] = 7312;
 HEAP32[i2 + 8 >> 2] = i7;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i13 + 4 >> 2] = i7;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i9 = i2 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i15);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 + 0 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 if ((HEAP32[i14 >> 2] | 0) > 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i14 >> 2] | 0));
 }
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i17 | 0)) {
  __ZN2cv6String10deallocateEv(i19);
  __ZN2cv6String10deallocateEv(i18);
  STACKTOP = i20;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 __ZN2cv6String10deallocateEv(i19);
 __ZN2cv6String10deallocateEv(i18);
 STACKTOP = i20;
 return;
}

function _cvCopyHist(i12, i10) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 i4 = i13 + 392 | 0;
 i7 = i13 + 384 | 0;
 i11 = i13 + 256 | 0;
 i9 = i13 + 128 | 0;
 i1 = i13;
 if (!i10) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i4, 34) | 0) + 0 | 0;
  i5 = 701848 | 0;
  i6 = i2 + 34 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i5 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i2 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i4, 701888, 701600, 2952);
  __ZN2cv6String10deallocateEv(i4);
 }
 i4 = HEAP32[i10 >> 2] | 0;
 do if (((i12 | 0) != 0 ? (HEAP32[i12 >> 2] & -65536 | 0) == 1111818240 : 0) ? (i3 = HEAP32[i12 + 4 >> 2] | 0, (i3 | 0) != 0) : 0) {
  if (!i4) {
   i2 = i12 + 4 | 0;
   i8 = 12;
   break;
  }
  if ((HEAP32[i4 >> 2] & -65536 | 0) == 1111818240 ? (HEAP32[i4 + 4 >> 2] | 0) != 0 : 0) i8 = 11; else i8 = 10;
 } else i8 = 10; while (0);
 if ((i8 | 0) == 10) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i7, 27) | 0) + 0 | 0;
  i5 = 701816 | 0;
  i6 = i2 + 27 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i5 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i2 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i7, 701888, 701600, 2957);
  __ZN2cv6String10deallocateEv(i7);
  i3 = HEAP32[i12 + 4 >> 2] | 0;
  i8 = 11;
 }
 if ((i8 | 0) == 11) {
  i2 = i12 + 4 | 0;
  if (!i3) {
   i7 = 0;
   i5 = i2;
  } else i8 = 12;
 }
 if ((i8 | 0) == 12) {
  i7 = (HEAP32[i3 >> 2] & -65536 | 0) == 1111752704;
  i5 = i2;
 }
 i6 = _cvGetDims(HEAP32[i5 >> 2] | 0, i11) | 0;
 do if (i4) {
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!i3) {
   if (i7) {
    i8 = 22;
    break;
   }
  } else if (i7 ^ (HEAP32[i3 >> 2] & -65536 | 0) == 1111752704) {
   i8 = 22;
   break;
  }
  if ((i6 | 0) == (_cvGetDims(i3, i9) | 0)) {
   L26 : do if ((i6 | 0) > 0) {
    i2 = 0;
    while (1) {
     i3 = i2 + 1 | 0;
     if ((HEAP32[i11 + (i2 << 2) >> 2] | 0) != (HEAP32[i9 + (i2 << 2) >> 2] | 0)) {
      i3 = i2;
      break L26;
     }
     if ((i3 | 0) < (i6 | 0)) i2 = i3; else break;
    }
   } else i3 = 0; while (0);
   if ((i3 | 0) != (i6 | 0)) i8 = 22;
  } else i8 = 22;
 } else i8 = 22; while (0);
 if ((i8 | 0) == 22) {
  _cvReleaseHist(i10);
  i4 = _cvCreateHist(i6, i11, i7 & 1, 0, 0) | 0;
  HEAP32[i10 >> 2] = i4;
 }
 i3 = HEAP32[i12 >> 2] | 0;
 if (!(i3 & 2048)) {
  i9 = HEAP32[i5 >> 2] | 0;
  i10 = i4 + 4 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  _cvCopy(i9, i10, 0);
  STACKTOP = i13;
  return;
 }
 if (!(i3 & 1024)) i1 = HEAP32[i12 + 264 >> 2] | 0; else if ((i6 | 0) > 0) {
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = i12 + (i2 << 3) + 8;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
 }
 _cvSetHistBinRanges(i4, i1, i3 >>> 10 & 1);
 i9 = HEAP32[i5 >> 2] | 0;
 i10 = i4 + 4 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 _cvCopy(i9, i10, 0);
 STACKTOP = i13;
 return;
}

function __ZNSt3__18ios_base4InitC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 i3 = HEAP32[_stdin >> 2] | 0;
 __ZNSt3__110__stdinbufIcEC2EP8_IO_FILEP11__mbstate_t(956776, i3, 956832);
 HEAP32[239016] = 958020;
 HEAP32[239018] = 958040;
 HEAP32[239017] = 0;
 i5 = HEAP32[239502] | 0;
 __ZNSt3__18ios_base4initEPv(956064 + i5 | 0, 956776);
 HEAP32[i5 + 956136 >> 2] = 0;
 HEAP32[i5 + 956140 >> 2] = -1;
 i5 = HEAP32[_stdout >> 2] | 0;
 __ZNSt3__111__stdoutbufIcEC2EP8_IO_FILEP11__mbstate_t(956880, i5, 956840 | 0);
 HEAP32[239038] = 958100;
 HEAP32[239039] = 958120;
 i8 = HEAP32[239522] | 0;
 __ZNSt3__18ios_base4initEPv(956152 + i8 | 0, 956880);
 i6 = i8 + 72 | 0;
 HEAP32[956152 + i6 >> 2] = 0;
 i2 = i8 + 76 | 0;
 HEAP32[956152 + i2 >> 2] = -1;
 i4 = HEAP32[_stderr >> 2] | 0;
 __ZNSt3__111__stdoutbufIcEC2EP8_IO_FILEP11__mbstate_t(956928, i4, 956848 | 0);
 HEAP32[239060] = 958100;
 HEAP32[239061] = 958120;
 __ZNSt3__18ios_base4initEPv(956240 + i8 | 0, 956928);
 HEAP32[956240 + i6 >> 2] = 0;
 HEAP32[956240 + i2 >> 2] = -1;
 i7 = HEAP32[(HEAP32[(HEAP32[239060] | 0) + -12 >> 2] | 0) + 956264 >> 2] | 0;
 HEAP32[239082] = 958100;
 HEAP32[239083] = 958120;
 __ZNSt3__18ios_base4initEPv(956328 + i8 | 0, i7);
 HEAP32[956328 + i6 >> 2] = 0;
 HEAP32[956328 + i2 >> 2] = -1;
 HEAP32[(HEAP32[(HEAP32[239016] | 0) + -12 >> 2] | 0) + 956136 >> 2] = 956152;
 i2 = (HEAP32[(HEAP32[239060] | 0) + -12 >> 2] | 0) + 956244 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 8192;
 HEAP32[(HEAP32[(HEAP32[239060] | 0) + -12 >> 2] | 0) + 956312 >> 2] = 956152;
 __ZNSt3__110__stdinbufIwEC2EP8_IO_FILEP11__mbstate_t(956976, i3, 956856 | 0);
 HEAP32[239104] = 958060;
 HEAP32[239106] = 958080;
 HEAP32[239105] = 0;
 i3 = HEAP32[239512] | 0;
 __ZNSt3__18ios_base4initEPv(956416 + i3 | 0, 956976);
 HEAP32[i3 + 956488 >> 2] = 0;
 HEAP32[i3 + 956492 >> 2] = -1;
 __ZNSt3__111__stdoutbufIwEC2EP8_IO_FILEP11__mbstate_t(957032, i5, 956864 | 0);
 HEAP32[239126] = 958140;
 HEAP32[239127] = 958160;
 i5 = HEAP32[239532] | 0;
 __ZNSt3__18ios_base4initEPv(956504 + i5 | 0, 957032);
 i3 = i5 + 72 | 0;
 HEAP32[956504 + i3 >> 2] = 0;
 i2 = i5 + 76 | 0;
 HEAP32[956504 + i2 >> 2] = -1;
 __ZNSt3__111__stdoutbufIwEC2EP8_IO_FILEP11__mbstate_t(957080, i4, 956872 | 0);
 HEAP32[239148] = 958140;
 HEAP32[239149] = 958160;
 __ZNSt3__18ios_base4initEPv(956592 + i5 | 0, 957080);
 HEAP32[956592 + i3 >> 2] = 0;
 HEAP32[956592 + i2 >> 2] = -1;
 i4 = HEAP32[(HEAP32[(HEAP32[239148] | 0) + -12 >> 2] | 0) + 956616 >> 2] | 0;
 HEAP32[239170] = 958140;
 HEAP32[239171] = 958160;
 __ZNSt3__18ios_base4initEPv(956680 + i5 | 0, i4);
 HEAP32[956680 + i3 >> 2] = 0;
 HEAP32[956680 + i2 >> 2] = -1;
 HEAP32[(HEAP32[(HEAP32[239104] | 0) + -12 >> 2] | 0) + 956488 >> 2] = 956504;
 i2 = (HEAP32[(HEAP32[239148] | 0) + -12 >> 2] | 0) + 956596 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 8192;
 HEAP32[(HEAP32[(HEAP32[239148] | 0) + -12 >> 2] | 0) + 956664 >> 2] = 956504;
 STACKTOP = i1;
 return;
}

function __ZL10cvGetMatNDPKvP7CvMatNDPi(i1, i13, i5) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i3 = i14 + 56 | 0;
 i4 = i14 + 48 | 0;
 i6 = i14 + 16 | 0;
 i7 = i14 + 8 | 0;
 i12 = i14;
 if (i5) HEAP32[i5 >> 2] = 0;
 i2 = (i1 | 0) != 0;
 if (!((i13 | 0) != 0 & i2)) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i8 = (__ZN2cv6String8allocateEj(i3, 28) | 0) + 0 | 0;
  i9 = 42568 | 0;
  i10 = i8 + 28 | 0;
  do {
   HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
   i8 = i8 + 1 | 0;
   i9 = i9 + 1 | 0;
  } while ((i8 | 0) < (i10 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i3, 43480, 40912, 335);
  __ZN2cv6String10deallocateEv(i3);
 }
 if (i2) {
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 & -65536 | 0) == 1111687168) {
   if (HEAP32[i1 + 16 >> 2] | 0) {
    i10 = i1;
    STACKTOP = i14;
    return i10 | 0;
   }
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i8 = (__ZN2cv6String8allocateEj(i4, 32) | 0) + 0 | 0;
   i9 = 42616 | 0;
   i10 = i8 + 32 | 0;
   do {
    HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
    i8 = i8 + 1 | 0;
    i9 = i9 + 1 | 0;
   } while ((i8 | 0) < (i10 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i4, 43480, 40912, 340);
   __ZN2cv6String10deallocateEv(i4);
   i10 = i1;
   STACKTOP = i14;
   return i10 | 0;
  }
  if ((i2 | 0) == 112) i1 = _cvGetMat(i1, i6, i5, 0) | 0;
  if (i1) if (((HEAP32[i1 >> 2] & -65536 | 0) == 1111621632 ? (HEAP32[i1 + 24 >> 2] | 0) > 0 : 0) ? (HEAP32[i1 + 20 >> 2] | 0) > 0 : 0) i3 = i1; else i11 = 15; else {
   i1 = 0;
   i11 = 15;
  }
 } else {
  i1 = 0;
  i11 = 15;
 }
 if ((i11 | 0) == 15) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i8 = (__ZN2cv6String8allocateEj(i7, 38) | 0) + 0 | 0;
  i9 = 42904 | 0;
  i10 = i8 + 38 | 0;
  do {
   HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
   i8 = i8 + 1 | 0;
   i9 = i9 + 1 | 0;
  } while ((i8 | 0) < (i10 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i7, 43480, 40912, 352);
  __ZN2cv6String10deallocateEv(i7);
  i3 = i1;
 }
 i2 = i3 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  i8 = (__ZN2cv6String8allocateEj(i12, 33) | 0) + 0 | 0;
  i9 = 42864 | 0;
  i10 = i8 + 33 | 0;
  do {
   HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
   i8 = i8 + 1 | 0;
   i9 = i9 + 1 | 0;
  } while ((i8 | 0) < (i10 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i12, 43480, 40912, 355);
  __ZN2cv6String10deallocateEv(i12);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i13 + 16 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i10 = HEAP32[i3 >> 2] | 0;
 HEAP32[i13 >> 2] = i10;
 HEAP32[i13 + 4 >> 2] = 2;
 HEAP32[i13 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i13 + 32 >> 2] = (i10 >>> 3 & 511) + 1 << (47696 >>> (i10 << 1 & 14) & 3);
 i10 = i13;
 STACKTOP = i14;
 return i10 | 0;
}
function __ZNSt3__13mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfNS_4lessIS6_EENS4_INS_4pairIKS6_fEEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_(i2, i11, i3) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  i10 = i2 + 4 | 0;
  HEAP32[i11 >> 2] = i10;
  STACKTOP = i13;
  return i10 | 0;
 }
 i6 = HEAP8[i3 >> 0] | 0;
 i7 = (i6 & 255) >>> 1;
 i8 = i3 + 1 | 0;
 i10 = i3 + 8 | 0;
 i9 = i3 + 4 | 0;
 L5 : do if (!(i6 & 1)) while (1) {
  i6 = i1 + 16 | 0;
  i4 = HEAP8[i6 >> 0] | 0;
  i2 = (i4 & 1) == 0;
  if (i2) {
   i5 = (i4 & 255) >>> 1;
   i3 = i6 + 1 | 0;
  } else {
   i5 = HEAP32[i1 + 20 >> 2] | 0;
   i3 = HEAP32[i1 + 24 >> 2] | 0;
  }
  i3 = _memcmp(i8, i3, i5 >>> 0 < i7 >>> 0 ? i5 : i7) | 0;
  if (!i3) {
   if (i7 >>> 0 < i5 >>> 0) i12 = 16;
  } else if ((i3 | 0) < 0) i12 = 16;
  if ((i12 | 0) == 16) {
   i12 = 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = i1;
    i12 = 24;
    break;
   } else {
    i1 = i2;
    continue;
   }
  }
  if (i2) {
   i3 = (i4 & 255) >>> 1;
   i2 = i6 + 1 | 0;
  } else {
   i3 = HEAP32[i1 + 20 >> 2] | 0;
   i2 = HEAP32[i1 + 24 >> 2] | 0;
  }
  i2 = _memcmp(i2, i8, i7 >>> 0 < i3 >>> 0 ? i7 : i3) | 0;
  if (!i2) {
   if (i3 >>> 0 >= i7 >>> 0) {
    i12 = 33;
    break L5;
   }
  } else if ((i2 | 0) >= 0) {
   i12 = 33;
   break L5;
  }
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i12 = 32;
   break;
  } else i1 = i3;
 } else while (1) {
  i7 = i1 + 16 | 0;
  i6 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP8[i7 >> 0] | 0;
  i3 = (i4 & 1) == 0;
  if (i3) {
   i2 = (i4 & 255) >>> 1;
   i5 = i7 + 1 | 0;
  } else {
   i2 = HEAP32[i1 + 20 >> 2] | 0;
   i5 = HEAP32[i1 + 24 >> 2] | 0;
  }
  i5 = _memcmp(HEAP32[i10 >> 2] | 0, i5, i2 >>> 0 < i6 >>> 0 ? i2 : i6) | 0;
  if (!i5) {
   if (i6 >>> 0 < i2 >>> 0) i12 = 23;
  } else if ((i5 | 0) < 0) i12 = 23;
  if ((i12 | 0) == 23) {
   i12 = 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = i1;
    i12 = 24;
    break;
   } else {
    i1 = i2;
    continue;
   }
  }
  if (i3) {
   i4 = (i4 & 255) >>> 1;
   i3 = i7 + 1 | 0;
  } else {
   i4 = HEAP32[i1 + 20 >> 2] | 0;
   i3 = HEAP32[i1 + 24 >> 2] | 0;
  }
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = _memcmp(i3, HEAP32[i10 >> 2] | 0, i2 >>> 0 < i4 >>> 0 ? i2 : i4) | 0;
  if (!i3) {
   if (i4 >>> 0 >= i2 >>> 0) {
    i12 = 33;
    break L5;
   }
  } else if ((i3 | 0) >= 0) {
   i12 = 33;
   break L5;
  }
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i12 = 32;
   break;
  } else i1 = i3;
 } while (0);
 if ((i12 | 0) == 24) {
  HEAP32[i11 >> 2] = i1;
  i10 = i2;
  STACKTOP = i13;
  return i10 | 0;
 } else if ((i12 | 0) == 32) {
  HEAP32[i11 >> 2] = i1;
  i10 = i2;
  STACKTOP = i13;
  return i10 | 0;
 } else if ((i12 | 0) == 33) {
  HEAP32[i11 >> 2] = i1;
  i10 = i11;
  STACKTOP = i13;
  return i10 | 0;
 }
 return 0;
}

function __ZN2cv9MatOp_Bin8makeExprERNS_7MatExprEcRKNS_3MatERKNS_7Scalar_IdEE(i4, i3, i1, i5) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 i6 = i19;
 i14 = i19 + 280 | 0;
 i11 = i19 + 224 | 0;
 HEAP32[i14 >> 2] = 1124007936;
 i17 = i14 + 4 | 0;
 i2 = i14 + 8 | 0;
 i15 = i14 + 40 | 0;
 i7 = i17 + 0 | 0;
 i8 = i7 + 36 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAP32[i15 >> 2] = i2;
 i18 = i14 + 48 | 0;
 i16 = i14 + 44 | 0;
 HEAP32[i16 >> 2] = i18;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i11 >> 2] = 1124007936;
 i13 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i9 = i11 + 40 | 0;
 i7 = i13 + 0 | 0;
 i8 = i7 + 36 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAP32[i9 >> 2] = i2;
 i12 = i11 + 48 | 0;
 i10 = i11 + 44 | 0;
 HEAP32[i10 >> 2] = i12;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i6, 33120, i3 << 24 >> 24, i1, i14, i11, 1.0, 0.0, i5);
 i8 = i6;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i2;
 __ZN2cv3MataSERKS0_(i4 + 8 | 0, i6 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i4 + 64 | 0, i6 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i4 + 120 | 0, i6 + 120 | 0) | 0;
 i7 = i4 + 176 | 0;
 i2 = i6 + 176 | 0;
 i8 = i7 + 48 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  i7 = i7 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 __ZN2cv7MatExprD2Ev(i6);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i7 = i1 + 12 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if ((HEAP32[i13 >> 2] | 0) > 0) {
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i13 >> 2] | 0));
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i12 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i14 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
 HEAP32[i2 >> 2] = 0;
 i10 = i14 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i17 >> 2] | 0) > 0) {
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i17 >> 2] | 0));
 }
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i18 | 0)) {
  STACKTOP = i19;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i19;
 return;
}

function __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekoffExNS_8ios_base7seekdirEj(i10, i11, i5, i6, i4, i9) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i12 = 0;
 i12 = STACKTOP;
 i1 = i11 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i7 = i11 + 24 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 < i8 >>> 0) {
  HEAP32[i1 >> 2] = i8;
  i2 = i8;
 }
 i1 = i9 & 24;
 if (!i1) {
  i9 = i10;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  i10 = i10 + 8 | 0;
  HEAP32[i10 >> 2] = -1;
  HEAP32[i10 + 4 >> 2] = -1;
  STACKTOP = i12;
  return;
 }
 if ((i1 | 0) == 24 & (i4 | 0) == 1) {
  i9 = i10;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  i10 = i10 + 8 | 0;
  HEAP32[i10 >> 2] = -1;
  HEAP32[i10 + 4 >> 2] = -1;
  STACKTOP = i12;
  return;
 }
 do if ((i4 | 0) == 1) if (!(i9 & 8)) {
  i3 = i8 - (HEAP32[i11 + 20 >> 2] | 0) | 0;
  i1 = i3;
  i3 = ((i3 | 0) < 0) << 31 >> 31;
  break;
 } else {
  i3 = (HEAP32[i11 + 12 >> 2] | 0) - (HEAP32[i11 + 8 >> 2] | 0) | 0;
  i1 = i3;
  i3 = ((i3 | 0) < 0) << 31 >> 31;
  break;
 } else if ((i4 | 0) == 2) {
  i1 = i11 + 32 | 0;
  if (!(HEAP8[i1 >> 0] & 1)) i1 = i1 + 1 | 0; else i1 = HEAP32[i11 + 40 >> 2] | 0;
  i3 = i2 - i1 | 0;
  i1 = i3;
  i3 = ((i3 | 0) < 0) << 31 >> 31;
 } else if (!i4) {
  i1 = 0;
  i3 = 0;
 } else {
  i9 = i10;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  i10 = i10 + 8 | 0;
  HEAP32[i10 >> 2] = -1;
  HEAP32[i10 + 4 >> 2] = -1;
  STACKTOP = i12;
  return;
 } while (0);
 i3 = _i64Add(i1 | 0, i3 | 0, i5 | 0, i6 | 0) | 0;
 i4 = tempRet0;
 if ((i4 | 0) >= 0) {
  i1 = i11 + 32 | 0;
  if (!(HEAP8[i1 >> 0] & 1)) i1 = i1 + 1 | 0; else i1 = HEAP32[i11 + 40 >> 2] | 0;
  i6 = i2 - i1 | 0;
  i5 = ((i6 | 0) < 0) << 31 >> 31;
  if (!((i5 | 0) < (i4 | 0) | (i5 | 0) == (i4 | 0) & i6 >>> 0 < i3 >>> 0)) {
   i1 = i9 & 8;
   if (!((i3 | 0) == 0 & (i4 | 0) == 0)) {
    if ((i1 | 0) != 0 ? (HEAP32[i11 + 12 >> 2] | 0) == 0 : 0) {
     i9 = i10;
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     i10 = i10 + 8 | 0;
     HEAP32[i10 >> 2] = -1;
     HEAP32[i10 + 4 >> 2] = -1;
     STACKTOP = i12;
     return;
    }
    if ((i9 & 16 | 0) != 0 & (i8 | 0) == 0) {
     i9 = i10;
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     i10 = i10 + 8 | 0;
     HEAP32[i10 >> 2] = -1;
     HEAP32[i10 + 4 >> 2] = -1;
     STACKTOP = i12;
     return;
    }
   }
   if (i1) {
    HEAP32[i11 + 12 >> 2] = (HEAP32[i11 + 8 >> 2] | 0) + i3;
    HEAP32[i11 + 16 >> 2] = i2;
   }
   if (i9 & 16) HEAP32[i7 >> 2] = (HEAP32[i11 + 20 >> 2] | 0) + i3;
   i9 = i10;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   i10 = i10 + 8 | 0;
   HEAP32[i10 >> 2] = i3;
   HEAP32[i10 + 4 >> 2] = i4;
   STACKTOP = i12;
   return;
  }
 }
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i10 = i10 + 8 | 0;
 HEAP32[i10 >> 2] = -1;
 HEAP32[i10 + 4 >> 2] = -1;
 STACKTOP = i12;
 return;
}

function __ZNKSt3__120__time_get_c_storageIwE8__monthsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = STACKTOP;
 if (HEAP8[961088] | 0) {
  i2 = HEAP32[240270] | 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 if (!(___cxa_guard_acquire(961088) | 0)) {
  i2 = HEAP32[240270] | 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 if ((HEAP8[966472] | 0) == 0 ? (___cxa_guard_acquire(966472) | 0) != 0 : 0) {
  _memset(966184, 0, 288) | 0;
  ___cxa_atexit(390, 0, ___dso_handle | 0) | 0;
  ___cxa_guard_release(966472);
 }
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966184, 966480) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966196, 966512) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966208, 966552) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966220, 966576) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966232, 966896) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966244, 966600) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966256, 966624) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966268, 966648) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966280, 966680) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966292, 966720) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966304, 966752) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966316, 966792) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966328, 966832) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966340, 966848) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966352, 966864) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966364, 966880) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966376, 966896) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966388, 966912) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966400, 966928) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966412, 966944) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966424, 966960) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966436, 966976) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966448, 966992) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(966460, 967008) | 0;
 HEAP32[240270] = 966184;
 ___cxa_guard_release(961088);
 i2 = HEAP32[240270] | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZNKSt3__120__time_get_c_storageIcE8__monthsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = STACKTOP;
 if (HEAP8[961072] | 0) {
  i2 = HEAP32[240266] | 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 if (!(___cxa_guard_acquire(961072) | 0)) {
  i2 = HEAP32[240266] | 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 if ((HEAP8[967312] | 0) == 0 ? (___cxa_guard_acquire(967312) | 0) != 0 : 0) {
  _memset(967024, 0, 288) | 0;
  ___cxa_atexit(389, 0, ___dso_handle | 0) | 0;
  ___cxa_guard_release(967312);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967024, 967320) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967036, 967328) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967048, 967344) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967060, 967352) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967072, 967360) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967084, 967368) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967096, 967376) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967108, 967384) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967120, 967392) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967132, 967408) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967144, 967416) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967156, 967432) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967168, 967448) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967180, 967456) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967192, 967464) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967204, 967472) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967216, 967360) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967228, 967480) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967240, 967488) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967252, 967496) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967264, 967504) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967276, 967512) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967288, 967520) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(967300, 967528) | 0;
 HEAP32[240266] = 967024;
 ___cxa_guard_release(961072);
 i2 = HEAP32[240266] | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZNK2cv11_InputArray5emptyEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i6;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] & 127](i5) | 0;
 do if ((i1 | 0) == 589824) {
  i1 = (HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 16 >> 2] | 0) == 0;
  STACKTOP = i6;
  return i1 | 0;
 } else if ((i1 | 0) == 458752) {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  if (!(HEAP32[i1 + 8 >> 2] | 0)) {
   i1 = 1;
   STACKTOP = i6;
   return i1 | 0;
  }
  i1 = (HEAP32[i1 + 12 >> 2] | 0) == 0;
  STACKTOP = i6;
  return i1 | 0;
 } else if ((i1 | 0) == 131072 | (i1 | 0) == 393216) {
  i1 = 0;
  STACKTOP = i6;
  return i1 | 0;
 } else if ((i1 | 0) == 262144) {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0);
  STACKTOP = i6;
  return i1 | 0;
 } else if ((i1 | 0) == 65536) {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  if (!(HEAP32[i1 + 16 >> 2] | 0)) {
   i1 = 1;
   STACKTOP = i6;
   return i1 | 0;
  }
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if ((i4 | 0) < 3) i1 = Math_imul(HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0) | 0; else {
   i2 = HEAP32[i1 + 40 >> 2] | 0;
   i3 = 0;
   i1 = 1;
   do {
    i1 = Math_imul(HEAP32[i2 + (i3 << 2) >> 2] | 0, i1) | 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i4 | 0));
  }
  i1 = (i1 | 0) == 0;
  STACKTOP = i6;
  return i1 | 0;
 } else if ((i1 | 0) == 720896) {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0);
  STACKTOP = i6;
  return i1 | 0;
 } else if ((i1 | 0) == 655360) {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  if (!(HEAP32[i1 + 24 >> 2] | 0)) {
   i1 = 1;
   STACKTOP = i6;
   return i1 | 0;
  }
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if ((i4 | 0) < 3) i1 = Math_imul(HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0) | 0; else {
   i2 = HEAP32[i1 + 32 >> 2] | 0;
   i3 = 0;
   i1 = 1;
   do {
    i1 = Math_imul(HEAP32[i2 + (i3 << 2) >> 2] | 0, i1) | 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i4 | 0));
  }
  i1 = (i1 | 0) == 0;
  STACKTOP = i6;
  return i1 | 0;
 } else if ((i1 | 0) == 196608) {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0);
  STACKTOP = i6;
  return i1 | 0;
 } else if ((i1 | 0) == 327680) {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0);
  STACKTOP = i6;
  return i1 | 0;
 } else if (!i1) {
  i1 = 1;
  STACKTOP = i6;
  return i1 | 0;
 } else if ((i1 | 0) != 524288) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i4, 13) | 0) + 0 | 0;
  i2 = 29232 | 0;
  i1 = i3 + 13 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 29312, 27528, 1869);
  __ZN2cv6String10deallocateEv(i4);
 } while (0);
 i1 = (HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 16 >> 2] | 0) == 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZL15icvDecodeFormatPKcPii(i16, i18) {
 i16 = i16 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i17 = i19 + 24 | 0;
 i8 = i19 + 16 | 0;
 i9 = i19 + 8 | 0;
 i12 = i19;
 if (!i16) {
  i10 = 0;
  STACKTOP = i19;
  return i10 | 0;
 }
 i13 = _strlen(i16 | 0) | 0;
 if (!i13) {
  i10 = 0;
  STACKTOP = i19;
  return i10 | 0;
 }
 HEAP32[i18 >> 2] = 0;
 if ((i13 | 0) > 0) {
  i14 = ~i16;
  i15 = i8 + 4 | 0;
  i10 = i9 + 4 | 0;
  i11 = i12 + 4 | 0;
  i1 = 0;
  i2 = 0;
  do {
   i3 = i16 + i2 | 0;
   i7 = HEAP8[i3 >> 0] | 0;
   i4 = i7 << 24 >> 24;
   if ((i7 + -48 << 24 >> 24 & 255) < 10) {
    if (((HEAP8[i16 + (i2 + 1) >> 0] | 0) + -48 << 24 >> 24 & 255) < 10) {
     HEAP32[i17 >> 2] = 0;
     i4 = _strtol(i3, i17, 10) | 0;
     i2 = (HEAP32[i17 >> 2] | 0) + i14 | 0;
    } else i4 = i4 + -48 | 0;
    if ((i4 | 0) < 1) {
     HEAP32[i8 >> 2] = 0;
     HEAP32[i15 >> 2] = 0;
     i3 = (__ZN2cv6String8allocateEj(i8, 31) | 0) + 0 | 0;
     i6 = 14488 | 0;
     i7 = i3 + 31 | 0;
     do {
      HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
      i3 = i3 + 1 | 0;
      i6 = i6 + 1 | 0;
     } while ((i3 | 0) < (i7 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i8, 14520, 8960, 3007);
     __ZN2cv6String10deallocateEv(i8);
    }
    HEAP32[i18 + (i1 << 2) >> 2] = i4;
   } else {
    i5 = _memchr(11696, i4, 9) | 0;
    if (!i5) {
     HEAP32[i9 >> 2] = 0;
     HEAP32[i10 >> 2] = 0;
     i3 = (__ZN2cv6String8allocateEj(i9, 31) | 0) + 0 | 0;
     i6 = 14488 | 0;
     i7 = i3 + 31 | 0;
     do {
      HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
      i3 = i3 + 1 | 0;
      i6 = i6 + 1 | 0;
     } while ((i3 | 0) < (i7 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i9, 14520, 8960, 3015);
     __ZN2cv6String10deallocateEv(i9);
    }
    i3 = i18 + (i1 << 2) | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) {
     HEAP32[i3 >> 2] = 1;
     i4 = 1;
    }
    i7 = i5 - 11696 | 0;
    HEAP32[i18 + (i1 + 1 << 2) >> 2] = i7;
    if ((i1 | 0) > 0 ? (i7 | 0) == (HEAP32[i18 + (i1 + -1 << 2) >> 2] | 0) : 0) {
     i7 = i18 + (i1 + -2 << 2) | 0;
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i4;
    } else {
     i1 = i1 + 2 | 0;
     if ((i1 | 0) > 255) {
      HEAP32[i12 >> 2] = 0;
      HEAP32[i11 >> 2] = 0;
      i3 = (__ZN2cv6String8allocateEj(i12, 32) | 0) + 0 | 0;
      i6 = 14536 | 0;
      i7 = i3 + 32 | 0;
      do {
       HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
       i3 = i3 + 1 | 0;
       i6 = i6 + 1 | 0;
      } while ((i3 | 0) < (i7 | 0));
      __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i12, 14520, 8960, 3025);
      __ZN2cv6String10deallocateEv(i12);
     }
    }
    HEAP32[i18 + (i1 << 2) >> 2] = 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i13 | 0));
 } else i1 = 0;
 i10 = (i1 | 0) / 2 | 0;
 STACKTOP = i19;
 return i10 | 0;
}

function __ZL11icvWriteSeqP13CvFileStoragePKcPKv10CvAttrListi(i10, i4, i9, i2, i1, i3) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 i7 = i11 + 24 | 0;
 i8 = i11;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i1;
 i5 = i11 + 160 | 0;
 i6 = i11 + 16 | 0;
 i1 = i11 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i7 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 _cvStartWriteStruct(i10, i4, 6, 10600, i7);
 if ((i3 | 0) > -1) _cvWriteInt(i10, 13448, i3);
 i6 = __ZL12icvGetFormatPK5CvSeqPKcP10CvAttrListiPc(i9, 11672, i8, 0, i11 + 32 | 0) | 0;
 HEAP8[i5 >> 0] = 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i2 & 16384) {
  i4 = i5 + (_strlen(i5 | 0) | 0) | 0;
  i3 = i4;
  HEAP8[i3 >> 0] = 32;
  HEAP8[i3 + 1 >> 0] = 99;
  HEAP8[i3 + 2 >> 0] = 108;
  HEAP8[i3 + 3 >> 0] = 111;
  i4 = i4 + 4 | 0;
  HEAP8[i4 >> 0] = 115;
  HEAP8[i4 + 1 >> 0] = 101;
  HEAP8[i4 + 2 >> 0] = 100;
  HEAP8[i4 + 3 >> 0] = 0;
 }
 if (i2 & 32768) {
  i4 = i5 + (_strlen(i5 | 0) | 0) | 0;
  HEAP8[i4 + 0 >> 0] = HEAP8[13568] | 0;
  HEAP8[i4 + 1 >> 0] = HEAP8[13569] | 0;
  HEAP8[i4 + 2 >> 0] = HEAP8[13570] | 0;
  HEAP8[i4 + 3 >> 0] = HEAP8[13571] | 0;
  HEAP8[i4 + 4 >> 0] = HEAP8[13572] | 0;
  HEAP8[i4 + 5 >> 0] = HEAP8[13573] | 0;
 }
 if ((i2 & 12288 | 0) == 4096) {
  i4 = i5 + (_strlen(i5 | 0) | 0) | 0;
  HEAP8[i4 + 0 >> 0] = HEAP8[13576] | 0;
  HEAP8[i4 + 1 >> 0] = HEAP8[13577] | 0;
  HEAP8[i4 + 2 >> 0] = HEAP8[13578] | 0;
  HEAP8[i4 + 3 >> 0] = HEAP8[13579] | 0;
  HEAP8[i4 + 4 >> 0] = HEAP8[13580] | 0;
  HEAP8[i4 + 5 >> 0] = HEAP8[13581] | 0;
  HEAP8[i4 + 6 >> 0] = HEAP8[13582] | 0;
 }
 if ((i2 & 4095 | 0) == 0 ? (HEAP32[i9 + 28 >> 2] | 0) != 1 : 0) {
  i4 = i5 + (_strlen(i5 | 0) | 0) + 0 | 0;
  i3 = 13584;
  i2 = i4 + 9 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i4 | 0) < (i2 | 0));
 }
 _cvWriteString(i10, 12488, i5 + ((HEAP8[i5 >> 0] | 0) != 0 & 1) | 0, 1);
 _cvWriteInt(i10, 13600, HEAP32[i9 + 24 >> 2] | 0);
 _cvWriteString(i10, 11672, i6, 0);
 __ZL18icvWriteHeaderDataP13CvFileStoragePK5CvSeqP10CvAttrListi(i10, i9, i8, 56);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i7 + 0 >> 2] = HEAP32[i1 + 0 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 _cvStartWriteStruct(i10, 11680, 13, 0, i7);
 i2 = i9 + 52 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  _cvEndWriteStruct(i10);
  _cvEndWriteStruct(i10);
  STACKTOP = i11;
  return;
 }
 while (1) {
  _cvWriteRawData(i10, HEAP32[i1 + 16 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0, i6);
  if ((i1 | 0) == (HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) {
   i1 = 15;
   break;
  }
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i1) {
   i1 = 15;
   break;
  }
 }
 if ((i1 | 0) == 15) {
  _cvEndWriteStruct(i10);
  _cvEndWriteStruct(i10);
  STACKTOP = i11;
  return;
 }
}

function _expm1(d8) {
 d8 = +d8;
 var d1 = 0.0, d2 = 0.0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, d9 = 0.0, i10 = 0, d11 = 0.0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i10;
 HEAPF64[tempDoublePtr >> 3] = d8;
 i3 = HEAP32[tempDoublePtr >> 2] | 0;
 i4 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = _bitshift64Lshr(i3 | 0, i4 | 0, 63) | 0;
 if (i5 >>> 0 > 1078159481) {
  i4 = i4 & 2147483647;
  if (i4 >>> 0 > 2146435072 | (i4 | 0) == 2146435072 & i3 >>> 0 > 0) {
   d1 = d8;
   STACKTOP = i10;
   return +d1;
  }
  if (i6) {
   d1 = -1.0;
   STACKTOP = i10;
   return +d1;
  }
  if (d8 > 709.782712893384) {
   d1 = d8 * 8988465674311579538646525.0e283;
   STACKTOP = i10;
   return +d1;
  }
 }
 if (i5 >>> 0 <= 1071001154) if (i5 >>> 0 < 1016070144) {
  if (i5 >>> 0 >= 1048576) {
   d1 = d8;
   STACKTOP = i10;
   return +d1;
  }
  HEAPF32[i7 >> 2] = Math_fround(d8);
  d1 = d8;
  STACKTOP = i10;
  return +d1;
 } else {
  d9 = d8;
  d8 = 0.0;
  i3 = 0;
 } else {
  do if (i5 >>> 0 < 1072734898) if (!i6) {
   d1 = d8 + -.6931471803691238;
   i3 = 1;
   d2 = 1.9082149292705877e-10;
   break;
  } else {
   d1 = d8 + .6931471803691238;
   i3 = -1;
   d2 = -1.9082149292705877e-10;
   break;
  } else {
   i3 = ~~(d8 * 1.4426950408889634 + ((i6 | 0) != 0 ? -.5 : .5));
   d2 = +(i3 | 0);
   d1 = d8 - d2 * .6931471803691238;
   d2 = d2 * 1.9082149292705877e-10;
  } while (0);
  d8 = d1 - d2;
  d9 = d8;
  d8 = d1 - d8 - d2;
 }
 d1 = d9 * .5;
 d2 = d9 * d1;
 d11 = d2 * (d2 * (d2 * (d2 * (d2 * -2.0109921818362437e-07 + 4.008217827329362e-06) + -7.93650757867488e-05) + 1.5873015872548146e-03) + -.03333333333333313) + 1.0;
 d1 = 3.0 - d1 * d11;
 d1 = d2 * ((d11 - d1) / (6.0 - d9 * d1));
 if (!i3) {
  d1 = d9 - (d9 * d1 - d2);
  STACKTOP = i10;
  return +d1;
 }
 d2 = d9 * (d1 - d8) - d8 - d2;
 if ((i3 | 0) == -1) {
  d1 = (d9 - d2) * .5 + -.5;
  STACKTOP = i10;
  return +d1;
 } else if ((i3 | 0) == 1) if (d9 < -.25) {
  d1 = (d2 - (d9 + .5)) * -2.0;
  STACKTOP = i10;
  return +d1;
 } else {
  d1 = (d9 - d2) * 2.0 + 1.0;
  STACKTOP = i10;
  return +d1;
 } else {
  i5 = _bitshift64Shl(i3 + 1023 | 0, 0, 52) | 0;
  i4 = tempRet0;
  HEAP32[tempDoublePtr >> 2] = i5;
  HEAP32[tempDoublePtr + 4 >> 2] = i4;
  d8 = +HEAPF64[tempDoublePtr >> 3];
  if (i3 >>> 0 > 56) {
   d1 = d9 - d2 + 1.0;
   if ((i3 | 0) == 1024) d1 = d1 * 2.0 * 8988465674311579538646525.0e283; else d1 = d8 * d1;
   d1 = d1 + -1.0;
   STACKTOP = i10;
   return +d1;
  } else {
   i6 = _bitshift64Shl(1023 - i3 | 0, 0, 52) | 0;
   i5 = tempRet0;
   if ((i3 | 0) < 20) {
    HEAP32[tempDoublePtr >> 2] = i6;
    HEAP32[tempDoublePtr + 4 >> 2] = i5;
    d1 = 1.0 - +HEAPF64[tempDoublePtr >> 3] + (d9 - d2);
   } else {
    HEAP32[tempDoublePtr >> 2] = i6;
    HEAP32[tempDoublePtr + 4 >> 2] = i5;
    d1 = d9 - (+HEAPF64[tempDoublePtr >> 3] + d2) + 1.0;
   }
   d1 = d8 * d1;
   STACKTOP = i10;
   return +d1;
  }
 }
 return 0.0;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd(i23, i1, i22, i20, i19, d4) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 d4 = +d4;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i24 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 i7 = i14 + 8 | 0;
 i2 = i14;
 i5 = i14 + 272 | 0;
 i1 = i14 + 268 | 0;
 i6 = i14 + 40 | 0;
 i13 = i14 + 36 | 0;
 i12 = i14 + 32 | 0;
 i8 = i14 + 28 | 0;
 i9 = i14 + 24 | 0;
 i10 = i14 + 20 | 0;
 i24 = i2;
 HEAP32[i24 >> 2] = 37;
 HEAP32[i24 + 4 >> 2] = 0;
 i24 = __ZNSt3__114__num_put_base14__format_floatEPcPKcj(i2 + 1 | 0, 959440, HEAP32[i20 + 4 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = i5;
 i3 = __ZNSt3__16__clocEv() | 0;
 if (i24) {
  HEAP32[i7 >> 2] = HEAP32[i20 + 8 >> 2];
  i24 = i7 + 4 | 0;
  HEAPF64[tempDoublePtr >> 3] = d4;
  HEAP32[i24 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i3 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i5, 30, i3, i2, i7) | 0;
 } else {
  HEAPF64[tempDoublePtr >> 3] = d4;
  HEAP32[i7 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i3 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i5, 30, i3, i2, i7) | 0;
 }
 if ((i3 | 0) > 29) {
  i3 = __ZNSt3__16__clocEv() | 0;
  HEAP32[i7 >> 2] = HEAP32[i20 + 8 >> 2];
  i24 = i7 + 4 | 0;
  HEAPF64[tempDoublePtr >> 3] = d4;
  HEAP32[i24 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i2 = __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz(i1, i3, i2, i7) | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) __ZSt17__throw_bad_allocv(); else {
   i15 = i1;
   i18 = i1;
   i11 = i2;
  }
 } else {
  i15 = HEAP32[i1 >> 2] | 0;
  i18 = 0;
  i11 = i3;
 }
 i2 = i15 + i11 | 0;
 i3 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i15, i2, i20) | 0;
 if ((i15 | 0) != (i5 | 0)) {
  i1 = _malloc(i11 << 3) | 0;
  if (!i1) __ZSt17__throw_bad_allocv(); else {
   i16 = i15;
   i17 = i1;
   i21 = i1;
  }
 } else {
  i16 = i5;
  i17 = 0;
  i21 = i6;
 }
 __ZNKSt3__18ios_base6getlocEv(i8, i20);
 __ZNSt3__19__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE(i16, i3, i2, i21, i13, i12, i8);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i8 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i22 >> 2];
 i15 = HEAP32[i13 >> 2] | 0;
 i16 = HEAP32[i12 >> 2] | 0;
 HEAP32[i7 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i9, i7, i21, i15, i16, i20, i19);
 i21 = HEAP32[i9 >> 2] | 0;
 HEAP32[i22 >> 2] = i21;
 HEAP32[i23 >> 2] = i21;
 if (!i17) {
  _free(i18);
  STACKTOP = i14;
  return;
 }
 _free(i17);
 _free(i18);
 STACKTOP = i14;
 return;
}

function __ZN2cvL8recip32fEPKfjS1_jPfjNS_5Size_IiEEPv(i1, i2, i10, i5, i9, i7, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f6 = f0, f8 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, f23 = f0, i24 = 0, d25 = 0.0, d26 = 0.0, d27 = 0.0, d28 = 0.0, d29 = 0.0, d30 = 0.0, d31 = 0.0;
 i19 = STACKTOP;
 i18 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 d17 = +HEAPF64[i4 >> 3];
 i16 = i5 >>> 2;
 i13 = i7 >>> 2;
 if (!i3) {
  STACKTOP = i19;
  return;
 }
 i14 = i18 + -4 | 0;
 i15 = (i14 | 0) < 0;
 i1 = (i14 | 0) > 3 ? i18 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i15) i4 = 0; else {
   i2 = 0;
   do {
    f6 = Math_fround(HEAPF32[i10 + (i2 << 2) >> 2]);
    i4 = i2 | 1;
    i7 = i10 + (i4 << 2) | 0;
    do if (f6 != Math_fround(0.0)) {
     f8 = Math_fround(HEAPF32[i7 >> 2]);
     if ((f8 != Math_fround(0.0) ? (i20 = i2 | 2, f21 = Math_fround(HEAPF32[i10 + (i20 << 2) >> 2]), f21 != Math_fround(0.0)) : 0) ? (i22 = i2 | 3, f23 = Math_fround(HEAPF32[i10 + (i22 << 2) >> 2]), f23 != Math_fround(0.0)) : 0) {
      d30 = +f6;
      d26 = +f8;
      d31 = d30 * d26;
      d28 = +f21;
      d29 = +f23;
      d25 = d28 * d29;
      d27 = d17 / (d31 * d25);
      d25 = d25 * d27;
      d27 = d31 * d27;
      f11 = Math_fround(d30 * d25);
      f8 = Math_fround(d29 * d27);
      f6 = Math_fround(d28 * d27);
      HEAPF32[i9 + (i2 << 2) >> 2] = Math_fround(d26 * d25);
      HEAPF32[i9 + (i4 << 2) >> 2] = f11;
      HEAPF32[i9 + (i20 << 2) >> 2] = f8;
      HEAPF32[i9 + (i22 << 2) >> 2] = f6;
      break;
     }
     f12 = Math_fround(d17 / +f6);
     i24 = 10;
    } else {
     f12 = Math_fround(0.0);
     i24 = 10;
    } while (0);
    if ((i24 | 0) == 10) {
     i24 = 0;
     f6 = Math_fround(HEAPF32[i7 >> 2]);
     if (f6 != Math_fround(0.0)) f11 = Math_fround(d17 / +f6); else f11 = Math_fround(0.0);
     i5 = i2 | 2;
     f8 = Math_fround(HEAPF32[i10 + (i5 << 2) >> 2]);
     if (f8 != Math_fround(0.0)) f6 = Math_fround(d17 / +f8); else f6 = Math_fround(0.0);
     i7 = i2 | 3;
     f8 = Math_fround(HEAPF32[i10 + (i7 << 2) >> 2]);
     if (f8 != Math_fround(0.0)) f8 = Math_fround(d17 / +f8); else f8 = Math_fround(0.0);
     HEAPF32[i9 + (i2 << 2) >> 2] = f12;
     HEAPF32[i9 + (i4 << 2) >> 2] = f11;
     HEAPF32[i9 + (i5 << 2) >> 2] = f6;
     HEAPF32[i9 + (i7 << 2) >> 2] = f8;
    }
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) <= (i14 | 0));
   i4 = i1;
  }
  if ((i4 | 0) < (i18 | 0)) do {
   f6 = Math_fround(HEAPF32[i10 + (i4 << 2) >> 2]);
   if (f6 != Math_fround(0.0)) f6 = Math_fround(d17 / +f6); else f6 = Math_fround(0.0);
   HEAPF32[i9 + (i4 << 2) >> 2] = f6;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i18 | 0));
  if (!i3) break; else {
   i9 = i9 + (i13 << 2) | 0;
   i10 = i10 + (i16 << 2) | 0;
  }
 }
 STACKTOP = i19;
 return;
}

function __ZNSt3__19__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw(i3, i6, i7, i5, i10, i2, i1, i9, i12, i13, i11, i4) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i8 = 0, i14 = 0;
 i14 = STACKTOP;
 if ((i3 | 0) == (i2 | 0)) {
  if (!(HEAP8[i6 >> 0] | 0)) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
  HEAP8[i6 >> 0] = 0;
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = 46;
  i1 = HEAP8[i9 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i9 + 4 >> 2] | 0;
  if (!i1) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  i1 = HEAP32[i13 >> 2] | 0;
  if ((i1 - i12 | 0) >= 160) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = i1 + 4;
  HEAP32[i1 >> 2] = i10;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 if ((i3 | 0) == (i1 | 0)) {
  i1 = HEAP8[i9 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i9 + 4 >> 2] | 0;
  if (i1) {
   if (!(HEAP8[i6 >> 0] | 0)) {
    i10 = -1;
    STACKTOP = i14;
    return i10 | 0;
   }
   i1 = HEAP32[i13 >> 2] | 0;
   if ((i1 - i12 | 0) >= 160) {
    i10 = 0;
    STACKTOP = i14;
    return i10 | 0;
   }
   i10 = HEAP32[i11 >> 2] | 0;
   HEAP32[i13 >> 2] = i1 + 4;
   HEAP32[i1 >> 2] = i10;
   HEAP32[i11 >> 2] = 0;
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
 }
 i1 = i4 + 128 | 0;
 i2 = i4;
 do {
  if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) {
   i1 = i2;
   break;
  }
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i2 = i1 - i4 | 0;
 i1 = i2 >> 2;
 if ((i2 | 0) > 124) {
  i10 = -1;
  STACKTOP = i14;
  return i10 | 0;
 }
 i3 = HEAP8[959240 + i1 >> 0] | 0;
 if ((i1 | 0) == 24 | (i1 | 0) == 25) {
  i1 = HEAP32[i10 >> 2] | 0;
  if ((i1 | 0) != (i5 | 0) ? (HEAPU8[i1 + -1 >> 0] & 95 | 0) != (HEAPU8[i7 >> 0] & 127 | 0) : 0) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
  HEAP32[i10 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = i3;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 } else if (!((i1 | 0) == 23 | (i1 | 0) == 22)) {
  i1 = i3 & 95;
  if ((i1 | 0) == (HEAP8[i7 >> 0] | 0) ? (HEAP8[i7 >> 0] = i1 | 128, (HEAP8[i6 >> 0] | 0) != 0) : 0) {
   HEAP8[i6 >> 0] = 0;
   i1 = HEAP8[i9 >> 0] | 0;
   if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i9 + 4 >> 2] | 0;
   if ((i1 | 0) != 0 ? (i8 = HEAP32[i13 >> 2] | 0, (i8 - i12 | 0) < 160) : 0) {
    i9 = HEAP32[i11 >> 2] | 0;
    HEAP32[i13 >> 2] = i8 + 4;
    HEAP32[i8 >> 2] = i9;
   }
  }
 } else HEAP8[i7 >> 0] = 80;
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i9 + 1;
 HEAP8[i9 >> 0] = i3;
 if ((i2 | 0) > 84) {
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i10 = 0;
 STACKTOP = i14;
 return i10 | 0;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd(i23, i1, i22, i20, i19, d4) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 d4 = +d4;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i24 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i7 = i14 + 8 | 0;
 i2 = i14;
 i5 = i14 + 102 | 0;
 i1 = i14 + 40 | 0;
 i6 = i14 + 44 | 0;
 i13 = i14 + 36 | 0;
 i12 = i14 + 32 | 0;
 i8 = i14 + 28 | 0;
 i9 = i14 + 24 | 0;
 i10 = i14 + 20 | 0;
 i24 = i2;
 HEAP32[i24 >> 2] = 37;
 HEAP32[i24 + 4 >> 2] = 0;
 i24 = __ZNSt3__114__num_put_base14__format_floatEPcPKcj(i2 + 1 | 0, 959440, HEAP32[i20 + 4 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = i5;
 i3 = __ZNSt3__16__clocEv() | 0;
 if (i24) {
  HEAP32[i7 >> 2] = HEAP32[i20 + 8 >> 2];
  i24 = i7 + 4 | 0;
  HEAPF64[tempDoublePtr >> 3] = d4;
  HEAP32[i24 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i3 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i5, 30, i3, i2, i7) | 0;
 } else {
  HEAPF64[tempDoublePtr >> 3] = d4;
  HEAP32[i7 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i3 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i5, 30, i3, i2, i7) | 0;
 }
 if ((i3 | 0) > 29) {
  i3 = __ZNSt3__16__clocEv() | 0;
  HEAP32[i7 >> 2] = HEAP32[i20 + 8 >> 2];
  i24 = i7 + 4 | 0;
  HEAPF64[tempDoublePtr >> 3] = d4;
  HEAP32[i24 >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
  i2 = __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz(i1, i3, i2, i7) | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) __ZSt17__throw_bad_allocv(); else {
   i15 = i1;
   i18 = i1;
   i11 = i2;
  }
 } else {
  i15 = HEAP32[i1 >> 2] | 0;
  i18 = 0;
  i11 = i3;
 }
 i2 = i15 + i11 | 0;
 i3 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i15, i2, i20) | 0;
 if ((i15 | 0) != (i5 | 0)) {
  i1 = _malloc(i11 << 1) | 0;
  if (!i1) __ZSt17__throw_bad_allocv(); else {
   i16 = i15;
   i17 = i1;
   i21 = i1;
  }
 } else {
  i16 = i5;
  i17 = 0;
  i21 = i6;
 }
 __ZNKSt3__18ios_base6getlocEv(i8, i20);
 __ZNSt3__19__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE(i16, i3, i2, i21, i13, i12, i8);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i8 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i22 >> 2];
 i15 = HEAP32[i13 >> 2] | 0;
 i16 = HEAP32[i12 >> 2] | 0;
 HEAP32[i7 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i9, i7, i21, i15, i16, i20, i19);
 i21 = HEAP32[i9 >> 2] | 0;
 HEAP32[i22 >> 2] = i21;
 HEAP32[i23 >> 2] = i21;
 if (i17) _free(i17);
 if (!i18) {
  STACKTOP = i14;
  return;
 }
 _free(i18);
 STACKTOP = i14;
 return;
}

function __ZN2cvL5cmp8sEPKajS1_jPhjNS_5Size_IiEEPv(i3, i5, i4, i6, i11, i16, i1, i2) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 i15 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 & -2 | 0) == 2) {
  i1 = (i1 | 0) == 2 ? 4 : 1;
  i13 = i4;
  i14 = i6;
 } else {
  i13 = i3;
  i3 = i4;
  i14 = i5;
  i5 = i6;
 }
 if ((i1 | 0) == 1 | (i1 | 0) == 4) {
  i10 = (i1 | 0) == 1 ? 0 : 255;
  if (!i12) {
   STACKTOP = i17;
   return;
  }
  i7 = i15 + -4 | 0;
  i8 = (i7 | 0) < 0;
  i9 = i15 & -4;
  i1 = i11;
  i2 = i12;
  i6 = i13;
  while (1) {
   i2 = i2 + -1 | 0;
   if (i8) i4 = 0; else {
    i4 = 0;
    do {
     i13 = i4 | 1;
     i11 = ((HEAP8[i6 + i13 >> 0] | 0) > (HEAP8[i3 + i13 >> 0] | 0)) << 31 >> 31 ^ i10;
     HEAP8[i1 + i4 >> 0] = ((HEAP8[i6 + i4 >> 0] | 0) > (HEAP8[i3 + i4 >> 0] | 0)) << 31 >> 31 ^ i10;
     HEAP8[i1 + i13 >> 0] = i11;
     i13 = i4 | 2;
     i11 = i4 | 3;
     i12 = ((HEAP8[i6 + i11 >> 0] | 0) > (HEAP8[i3 + i11 >> 0] | 0)) << 31 >> 31 ^ i10;
     HEAP8[i1 + i13 >> 0] = ((HEAP8[i6 + i13 >> 0] | 0) > (HEAP8[i3 + i13 >> 0] | 0)) << 31 >> 31 ^ i10;
     HEAP8[i1 + i11 >> 0] = i12;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) <= (i7 | 0));
    i4 = i9;
   }
   if ((i4 | 0) < (i15 | 0)) do {
    HEAP8[i1 + i4 >> 0] = ((HEAP8[i6 + i4 >> 0] | 0) > (HEAP8[i3 + i4 >> 0] | 0)) << 31 >> 31 ^ i10;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i15 | 0));
   if (!i2) break; else {
    i1 = i1 + i16 | 0;
    i6 = i6 + i14 | 0;
    i3 = i3 + i5 | 0;
   }
  }
  STACKTOP = i17;
  return;
 }
 if (!((i1 | 0) == 0 | (i1 | 0) == 5)) {
  STACKTOP = i17;
  return;
 }
 i9 = (i1 | 0) == 0 ? 0 : 255;
 if (!i12) {
  STACKTOP = i17;
  return;
 }
 i8 = i15 + -4 | 0;
 i7 = (i8 | 0) < 0;
 i10 = i15 & -4;
 i1 = i11;
 i2 = i12;
 i6 = i13;
 while (1) {
  i2 = i2 + -1 | 0;
  if (i7) i4 = 0; else {
   i4 = 0;
   do {
    i13 = i4 | 1;
    i11 = ((HEAP8[i6 + i13 >> 0] | 0) == (HEAP8[i3 + i13 >> 0] | 0)) << 31 >> 31 ^ i9;
    HEAP8[i1 + i4 >> 0] = ((HEAP8[i6 + i4 >> 0] | 0) == (HEAP8[i3 + i4 >> 0] | 0)) << 31 >> 31 ^ i9;
    HEAP8[i1 + i13 >> 0] = i11;
    i13 = i4 | 2;
    i11 = i4 | 3;
    i12 = ((HEAP8[i6 + i11 >> 0] | 0) == (HEAP8[i3 + i11 >> 0] | 0)) << 31 >> 31 ^ i9;
    HEAP8[i1 + i13 >> 0] = ((HEAP8[i6 + i13 >> 0] | 0) == (HEAP8[i3 + i13 >> 0] | 0)) << 31 >> 31 ^ i9;
    HEAP8[i1 + i11 >> 0] = i12;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) <= (i8 | 0));
   i4 = i10;
  }
  if ((i4 | 0) < (i15 | 0)) do {
   HEAP8[i1 + i4 >> 0] = ((HEAP8[i6 + i4 >> 0] | 0) == (HEAP8[i3 + i4 >> 0] | 0)) << 31 >> 31 ^ i9;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i15 | 0));
  if (!i2) break; else {
   i1 = i1 + i16 | 0;
   i6 = i6 + i14 | 0;
   i3 = i3 + i5 | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZL17icvXMLWriteScalarP13CvFileStoragePKcS2_i(i10, i8, i11, i12) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i13;
 i5 = i10 + 44 | 0;
 i2 = HEAP32[i5 >> 2] & 7;
 if ((i2 | 0) != 6 ? (i4 = (i8 | 0) != 0, !(i2 >>> 0 < 5 & i4)) : 0) {
  i9 = i10 + 72 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i8 = i10 + 76 | 0;
  i6 = i1 - (HEAP32[i8 >> 2] | 0) + i12 | 0;
  if (i4) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i4 = (__ZN2cv6String8allocateEj(i7, 49) | 0) + 0 | 0;
   i3 = 14136;
   i2 = i4 + 49 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i4 | 0) < (i2 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i7, 14192, 8960, 2459);
   __ZN2cv6String10deallocateEv(i7);
  }
  HEAP32[i5 >> 2] = 5;
  if ((i6 | 0) > (HEAP32[i10 + 84 >> 2] | 0) ? (i6 - (HEAP32[i10 + 40 >> 2] | 0) | 0) > 10 : 0) {
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = 15;
  } else i3 = 13;
  do if ((i3 | 0) == 13) {
   i2 = HEAP32[i8 >> 2] | 0;
   if (i1 >>> 0 > i2 >>> 0 ? (HEAP8[i1 + -1 >> 0] | 0) == 62 : 0) {
    i3 = 15;
    break;
   }
   if (i1 >>> 0 > (i2 + (HEAP32[i10 + 40 >> 2] | 0) | 0) >>> 0 ? (HEAP8[i1 + -1 >> 0] | 0) != 62 : 0) {
    HEAP8[i1 >> 0] = 32;
    i1 = i1 + 1 | 0;
   }
  } while (0);
  if ((i3 | 0) == 15) {
   i1 = HEAP32[i9 >> 2] | 0;
   i6 = i10 + 56 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if (i1 >>> 0 > (i2 + i3 | 0) >>> 0) {
    HEAP8[i1 >> 0] = 10;
    HEAP8[i1 + 1 >> 0] = 0;
    __ZL7icvPutsP13CvFileStoragePKc(i10, HEAP32[i8 >> 2] | 0);
    i2 = HEAP32[i8 >> 2] | 0;
    HEAP32[i9 >> 2] = i2;
    i3 = HEAP32[i6 >> 2] | 0;
   }
   i1 = HEAP32[i10 + 40 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) i1 = i3; else {
    if ((i1 | 0) > (i3 | 0)) {
     _memset(i2 + i3 | 0, 32, i1 - i3 | 0) | 0;
     i2 = HEAP32[i8 >> 2] | 0;
    }
    HEAP32[i6 >> 2] = i1;
   }
   i1 = i2 + i1 | 0;
   HEAP32[i9 >> 2] = i1;
  }
  _memcpy(i1 | 0, i11 | 0, i12 | 0) | 0;
  HEAP32[i9 >> 2] = i1 + i12;
  STACKTOP = i13;
  return;
 }
 __ZL14icvXMLWriteTagP13CvFileStoragePKci10CvAttrList(i10, i8, 1, 0, 0);
 i7 = i10 + 72 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i5 = i10 + 80 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i2 + i12 | 0) >>> 0 >= i3 >>> 0) {
  i6 = i10 + 76 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i4 = i2 - i1 | 0;
  i2 = ((i3 - i1 | 0) * 3 | 0) / 2 | 0;
  i3 = i4 + i12 | 0;
  i3 = (i3 | 0) < (i2 | 0) ? i2 : i3;
  i2 = _cvAlloc(i3 + 256 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i7 >> 2] = i2 + ((HEAP32[i7 >> 2] | 0) - i1);
  if ((i4 | 0) > 0) _memcpy(i2 | 0, i1 | 0, i4 | 0) | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i5 >> 2] = i2 + i3;
  i2 = i2 + i4 | 0;
 }
 _memcpy(i2 | 0, i11 | 0, i12 | 0) | 0;
 HEAP32[i7 >> 2] = i2 + i12;
 __ZL14icvXMLWriteTagP13CvFileStoragePKci10CvAttrList(i10, i8, 2, 0, 0);
 STACKTOP = i13;
 return;
}

function __ZN2cv16SunRasterDecoder10readHeaderEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 768 | 0;
 i10 = i13;
 i11 = i12 + 92 | 0;
 if (!(FUNCTION_TABLE_iii[HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] & 127](i11, i12 + 16 | 0) | 0)) {
  i10 = 0;
  STACKTOP = i13;
  return i10 | 0;
 }
 __ZN2cv11RBaseStream4skipEi(i11, 4);
 i7 = i12 + 4 | 0;
 HEAP32[i7 >> 2] = __ZN2cv12RMByteStream8getDWordEv(i11) | 0;
 i8 = i12 + 8 | 0;
 HEAP32[i8 >> 2] = __ZN2cv12RMByteStream8getDWordEv(i11) | 0;
 i1 = __ZN2cv12RMByteStream8getDWordEv(i11) | 0;
 i9 = i12 + 1152 | 0;
 HEAP32[i9 >> 2] = i1;
 i1 = 3 << i1;
 __ZN2cv11RBaseStream4skipEi(i11, 4);
 i4 = i12 + 1160 | 0;
 HEAP32[i4 >> 2] = __ZN2cv12RMByteStream8getDWordEv(i11) | 0;
 i2 = i12 + 1164 | 0;
 HEAP32[i2 >> 2] = __ZN2cv12RMByteStream8getDWordEv(i11) | 0;
 i5 = __ZN2cv12RMByteStream8getDWordEv(i11) | 0;
 i6 = i12 + 1168 | 0;
 HEAP32[i6 >> 2] = i5;
 L4 : do if (((HEAP32[i7 >> 2] | 0) > 0 ? (HEAP32[i8 >> 2] | 0) > 0 : 0) ? (i3 = HEAP32[i9 >> 2] | 0, (i3 | 0) == 32 | (i3 | 0) == 24 | (i3 | 0) == 8 | (i3 | 0) == 1) : 0) {
  do if ((HEAP32[i4 >> 2] | 0) >>> 0 >= 2) {
   i4 = HEAP32[i12 + 12 >> 2] | 0;
   if ((i4 | 0) == 3) break; else if ((i4 | 0) != 2) break L4;
   if ((i3 | 0) == 8) i3 = 8; else break L4;
  } while (0);
  i4 = HEAP32[i2 >> 2] | 0;
  if (!i4) {
   if (i5) break;
   i1 = i12 + 128 | 0;
   _memset(i1 | 0, 0, 1024) | 0;
  } else if ((i4 | 0) == 1) {
   if (!((i5 | 0) <= (i1 | 0) & (i3 | 0) < 9)) break;
   i1 = i12 + 128 | 0;
   _memset(i1 | 0, 0, 1024) | 0;
   if (i5) {
    i3 = __ZN2cv12RLByteStream8getBytesEPvi(i11, i10, i5) | 0;
    if ((i3 | 0) != (HEAP32[i6 >> 2] | 0)) break;
    i4 = (i3 | 0) / 3 | 0;
    if ((i3 | 0) > 2) {
     i2 = i4 << 1;
     i3 = 0;
     do {
      HEAP8[i12 + (i3 << 2) + 128 >> 0] = HEAP8[i10 + (i3 + i2) >> 0] | 0;
      HEAP8[i12 + (i3 << 2) + 129 >> 0] = HEAP8[i10 + (i3 + i4) >> 0] | 0;
      HEAP8[i12 + (i3 << 2) + 130 >> 0] = HEAP8[i10 + i3 >> 0] | 0;
      HEAP8[i12 + (i3 << 2) + 131 >> 0] = 0;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) < (i4 | 0));
    }
    i10 = __Z14IsColorPaletteP12PaletteEntryi(i1, HEAP32[i9 >> 2] | 0) | 0;
    HEAP32[i12 + 12 >> 2] = i10 ? 16 : 0;
    HEAP32[i12 + 1156 >> 2] = __ZN2cv11RBaseStream6getPosEv(i11) | 0;
    i10 = 1;
    STACKTOP = i13;
    return i10 | 0;
   }
  } else break;
  i10 = (i3 | 0) > 8 ? 16 : 0;
  HEAP32[i12 + 12 >> 2] = i10;
  if ((i10 >>> 3 | 1 | 0) == 1) __Z15FillGrayPaletteP12PaletteEntryib(i1, i3, 0);
  HEAP32[i12 + 1156 >> 2] = __ZN2cv11RBaseStream6getPosEv(i11) | 0;
  i10 = 1;
  STACKTOP = i13;
  return i10 | 0;
 } while (0);
 HEAP32[i12 + 1156 >> 2] = -1;
 HEAP32[i8 >> 2] = -1;
 HEAP32[i7 >> 2] = -1;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] & 511](i11);
 i10 = 0;
 STACKTOP = i13;
 return i10 | 0;
}

function __ZN7testing8internal17Int32FromGTestEnvEPKci(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i12 = i13;
 i11 = i13 + 36 | 0;
 i7 = i13 + 32 | 0;
 i6 = i13 + 28 | 0;
 i8 = i13 + 16 | 0;
 i9 = i13 + 12 | 0;
 __ZN7testing8internalL12FlagToEnvVarEPKc(i11, i1);
 if (!(HEAP8[i11 >> 0] & 1)) i1 = i11 + 1 | 0; else i1 = HEAP32[i11 + 8 >> 2] | 0;
 i2 = _getenv(i1 | 0) | 0;
 if (!i2) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  STACKTOP = i13;
  return i10 | 0;
 }
 HEAP32[i7 >> 2] = i10;
 __ZN7testing7MessageC2Ev(i6);
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = i5 + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 164912, 21) | 0;
 i3 = HEAP8[i11 >> 0] | 0;
 if (!(i3 & 1)) {
  i4 = i11 + 1 | 0;
  i3 = (i3 & 255) >>> 1;
 } else {
  i4 = HEAP32[i11 + 8 >> 2] | 0;
  i3 = HEAP32[i11 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i4, i3) | 0;
 i1 = __ZN7testing8internal10ParseInt32ERKNS_7MessageEPKcPi(i6, i2, i7) | 0;
 if (i5) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 511](i5);
  HEAP32[i6 >> 2] = 0;
 }
 if (i1) {
  i10 = HEAP32[i7 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  STACKTOP = i13;
  return i10 | 0;
 }
 __ZN7testing7MessageC2Ev(i9);
 i4 = HEAP32[i9 >> 2] | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i4 + 8 | 0, i10) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i12, i4 + 12 | 0);
 i1 = HEAP8[i12 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i12 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i12 + 8 >> 2] | 0;
  i1 = HEAP32[i12 + 4 >> 2] | 0;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i8, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i8, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i8, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
 if (!(HEAP8[i8 >> 0] & 1)) i1 = i8 + 1 | 0; else i1 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i12 >> 2] = i1;
 _printf(164936, i12 | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
 if (i4) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 511](i4);
  HEAP32[i9 >> 2] = 0;
 }
 _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
 STACKTOP = i13;
 return i10 | 0;
}

function __ZNSt3__16vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6assignIPS6_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 i1 = i9;
 i6 = (i10 - i1 | 0) / 12 | 0;
 i7 = i8 + 8 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3;
 if (i6 >>> 0 > ((i5 - i4 | 0) / 12 | 0) >>> 0) {
  if (!i3) i3 = i5; else {
   i5 = i8 + 4 | 0;
   while (1) {
    i4 = HEAP32[i5 >> 2] | 0;
    if ((i4 | 0) == (i3 | 0)) break;
    i4 = i4 + -12 | 0;
    HEAP32[i5 >> 2] = i4;
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
   }
   __ZdlPv(HEAP32[i8 >> 2] | 0);
   HEAP32[i7 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   i3 = 0;
  }
  if (i6 >>> 0 > 357913941) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = (i3 - 0 | 0) / 12 | 0;
  if (i3 >>> 0 < 178956970) {
   i3 = i3 << 1;
   i3 = i3 >>> 0 < i6 >>> 0 ? i6 : i3;
   if (i3 >>> 0 > 357913941) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i8); else i2 = i3;
  } else i2 = 357913941;
  i1 = __Znwj(i2 * 12 | 0) | 0;
  i5 = i8 + 4 | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i7 >> 2] = i1 + (i2 * 12 | 0);
  if ((i9 | 0) == (i10 | 0)) {
   STACKTOP = i11;
   return;
  } else i3 = i9;
  do {
   if (!i1) i1 = 0; else {
    __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1, i3);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i1 = i1 + 12 | 0;
   HEAP32[i5 >> 2] = i1;
   i3 = i3 + 12 | 0;
  } while ((i3 | 0) != (i10 | 0));
  STACKTOP = i11;
  return;
 }
 i8 = i8 + 4 | 0;
 i4 = ((HEAP32[i8 >> 2] | 0) - i4 | 0) / 12 | 0;
 if (i6 >>> 0 > i4 >>> 0) {
  i6 = 1;
  i2 = i9 + (i4 * 12 | 0) | 0;
 } else {
  i6 = 0;
  i2 = i10;
 }
 if ((i2 | 0) != (i9 | 0)) {
  i5 = i2 + -12 - i1 | 0;
  i1 = i9;
  i4 = i3;
  while (1) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i4, i1) | 0;
   i1 = i1 + 12 | 0;
   if ((i1 | 0) == (i2 | 0)) break; else i4 = i4 + 12 | 0;
  }
  i3 = i3 + ((((i5 >>> 0) / 12 | 0) + 1 | 0) * 12 | 0) | 0;
 }
 if (!i6) {
  while (1) {
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) break;
   i10 = i1 + -12 | 0;
   HEAP32[i8 >> 2] = i10;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
  }
  STACKTOP = i11;
  return;
 }
 if ((i2 | 0) == (i10 | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 do {
  if (!i1) i1 = 0; else {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1, i2);
   i1 = HEAP32[i8 >> 2] | 0;
  }
  i1 = i1 + 12 | 0;
  HEAP32[i8 >> 2] = i1;
  i2 = i2 + 12 | 0;
 } while ((i2 | 0) != (i10 | 0));
 STACKTOP = i11;
 return;
}

function __ZN2cvL13copyMask32sC6EPKhjS1_jPhjNS_5Size_IiEEPv(i5, i14, i3, i13, i4, i12, i2, i1) {
 i5 = i5 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i11 = STACKTOP;
 i10 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = i10 & -4;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i2 = 0; else {
   i1 = 0;
   do {
    if (HEAP8[i3 + i1 >> 0] | 0) {
     i2 = i4 + (i1 * 24 | 0) | 0;
     i15 = i5 + (i1 * 24 | 0) | 0;
     HEAP32[i2 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
     HEAP32[i2 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
    }
    i2 = i1 | 1;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 * 24 | 0) | 0;
     i2 = i5 + (i2 * 24 | 0) | 0;
     HEAP32[i15 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i15 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i15 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    }
    i2 = i1 | 2;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 * 24 | 0) | 0;
     i2 = i5 + (i2 * 24 | 0) | 0;
     HEAP32[i15 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i15 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i15 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    }
    i2 = i1 | 3;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 * 24 | 0) | 0;
     i2 = i5 + (i2 * 24 | 0) | 0;
     HEAP32[i15 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i15 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i15 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i7 | 0));
   i2 = i9;
  }
  if ((i2 | 0) < (i10 | 0)) do {
   if (HEAP8[i3 + i2 >> 0] | 0) {
    i1 = i4 + (i2 * 24 | 0) | 0;
    i15 = i5 + (i2 * 24 | 0) | 0;
    HEAP32[i1 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
  if (!i6) break; else {
   i3 = i3 + i13 | 0;
   i4 = i4 + i12 | 0;
   i5 = i5 + i14 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cvL13addWeighted8uEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i15, i2, i16, i4, i14, i13, i1) {
 i3 = i3 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 i4 = i4 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, i17 = 0, f18 = f0;
 i17 = STACKTOP;
 f11 = Math_fround(+HEAPF64[i1 >> 3]);
 f12 = Math_fround(+HEAPF64[i1 + 8 >> 3]);
 f9 = Math_fround(+HEAPF64[i1 + 16 >> 3]);
 i10 = i13 + 4 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i8 + -1;
 if (!i8) {
  STACKTOP = i17;
  return;
 }
 i8 = i4;
 i1 = HEAP32[i13 >> 2] | 0;
 while (1) {
  if ((i1 + -4 | 0) < 0) i4 = 0; else {
   i4 = 0;
   do {
    f18 = Math_fround(f11 * Math_fround(HEAPF32[34784 + ((HEAPU8[i3 + i4 >> 0] | 0) + 128 << 2) >> 2]));
    f18 = Math_fround(f9 + Math_fround(f18 + Math_fround(f12 * Math_fround(HEAPF32[34784 + ((HEAPU8[i2 + i4 >> 0] | 0) + 128 << 2) >> 2]))));
    i6 = i4 | 1;
    f5 = Math_fround(f11 * Math_fround(HEAPF32[34784 + ((HEAPU8[i3 + i6 >> 0] | 0) + 128 << 2) >> 2]));
    f5 = Math_fround(f9 + Math_fround(f5 + Math_fround(f12 * Math_fround(HEAPF32[34784 + ((HEAPU8[i2 + i6 >> 0] | 0) + 128 << 2) >> 2]))));
    i1 = _lrint(+f18) | 0;
    if (i1 >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 255 : 0;
    HEAP8[i8 + i4 >> 0] = i1;
    i1 = _lrint(+f5) | 0;
    if (i1 >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 255 : 0;
    HEAP8[i8 + i6 >> 0] = i1;
    i6 = i4 | 2;
    f18 = Math_fround(f11 * Math_fround(HEAPF32[34784 + ((HEAPU8[i3 + i6 >> 0] | 0) + 128 << 2) >> 2]));
    f18 = Math_fround(f9 + Math_fround(f18 + Math_fround(f12 * Math_fround(HEAPF32[34784 + ((HEAPU8[i2 + i6 >> 0] | 0) + 128 << 2) >> 2]))));
    i7 = i4 | 3;
    f5 = Math_fround(f11 * Math_fround(HEAPF32[34784 + ((HEAPU8[i3 + i7 >> 0] | 0) + 128 << 2) >> 2]));
    f5 = Math_fround(f9 + Math_fround(f5 + Math_fround(f12 * Math_fround(HEAPF32[34784 + ((HEAPU8[i2 + i7 >> 0] | 0) + 128 << 2) >> 2]))));
    i1 = _lrint(+f18) | 0;
    if (i1 >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 255 : 0;
    HEAP8[i8 + i6 >> 0] = i1;
    i1 = _lrint(+f5) | 0;
    if (i1 >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 255 : 0;
    HEAP8[i8 + i7 >> 0] = i1;
    i4 = i4 + 4 | 0;
    i1 = HEAP32[i13 >> 2] | 0;
   } while ((i4 | 0) <= (i1 + -4 | 0));
  }
  if ((i4 | 0) < (i1 | 0)) do {
   f5 = Math_fround(f11 * Math_fround(HEAPF32[34784 + ((HEAPU8[i3 + i4 >> 0] | 0) + 128 << 2) >> 2]));
   i1 = _lrint(+Math_fround(f9 + Math_fround(f5 + Math_fround(f12 * Math_fround(HEAPF32[34784 + ((HEAPU8[i2 + i4 >> 0] | 0) + 128 << 2) >> 2]))))) | 0;
   if (i1 >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 255 : 0;
   HEAP8[i8 + i4 >> 0] = i1;
   i4 = i4 + 1 | 0;
   i1 = HEAP32[i13 >> 2] | 0;
  } while ((i4 | 0) < (i1 | 0));
  i7 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i7 + -1;
  if (!i7) break; else {
   i2 = i2 + i16 | 0;
   i3 = i3 + i15 | 0;
   i8 = i8 + i14 | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter13OnTestCaseEndERKNS_8TestCaseE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i11 = i12 + 8 | 0;
 i5 = i12 + 56 | 0;
 i6 = i12 + 44 | 0;
 i9 = i12 + 32 | 0;
 i8 = i12 + 20 | 0;
 i7 = i12;
 if (!(HEAP8[159976] | 0)) {
  STACKTOP = i12;
  return;
 }
 i2 = HEAP32[i10 + 20 >> 2] | 0;
 i4 = HEAP32[i10 + 24 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) i3 = 0; else {
  i3 = 0;
  do {
   i3 = (HEAPU8[(HEAP32[i2 >> 2] | 0) + 36 >> 0] | 0) + i3 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 HEAP32[i11 >> 2] = i3;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i6, i11);
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i2 = HEAP8[i6 >> 0] | 0;
 if (!(i2 & 1)) {
  i2 = (i2 & 255) >>> 1;
  i1 = i6 + 1 | 0;
 } else {
  i2 = HEAP32[i6 + 4 >> 2] | 0;
  i1 = HEAP32[i6 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, i1, i2, i2 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, 163296, 1) | 0;
 i1 = (i3 | 0) == 1 ? 162456 : 162464;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i3 = HEAP8[i5 >> 0] | 0;
 if (!(i3 & 1)) {
  i4 = _strlen(i1 | 0) | 0;
  i3 = (i3 & 255) >>> 1;
  i2 = i5 + 1 | 0;
 } else {
  i3 = HEAP32[i5 + 4 >> 2] | 0;
  i4 = _strlen(i1 | 0) | 0;
  i2 = HEAP32[i5 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, i2, i3, i3 + i4 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, i1, i4) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(2, 162440, i11);
 if (!(HEAP8[i9 >> 0] & 1)) i3 = i9 + 1 | 0; else i3 = HEAP32[i9 + 8 >> 2] | 0;
 i1 = i10 + 4 | 0;
 if (!(HEAP8[i1 >> 0] & 1)) i2 = i1 + 1 | 0; else i2 = HEAP32[i10 + 12 >> 2] | 0;
 i5 = i10 + 56 | 0;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i10 = i7;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = i6;
 __ZN7testing8internal18StreamableToStringIxEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i8, i7);
 if (!(HEAP8[i8 >> 0] & 1)) i1 = i8 + 1 | 0; else i1 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i11 + 4 >> 2] = i2;
 HEAP32[i11 + 8 >> 2] = i1;
 _printf(162592, i11 | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
 _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 STACKTOP = i12;
 return;
}

function __ZN7testing8internalL27PrintTestPartResultToStringERKNS_14TestPartResultE(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i7 = i11 + 16 | 0;
 i10 = i11 + 12 | 0;
 i8 = i11;
 __ZN7testing7MessageC2Ev(i10);
 i3 = i5 + 4 | 0;
 i2 = HEAP8[i3 >> 0] | 0;
 i1 = (i2 & 1) == 0;
 if (i1) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i5 + 8 >> 2] | 0;
 do if (i2) if (i1) {
  i1 = i3 + 1 | 0;
  break;
 } else {
  i1 = HEAP32[i5 + 12 >> 2] | 0;
  break;
 } else i1 = 0; while (0);
 __ZN7testing8internal18FormatFileLocationEPKci(i8, i1, HEAP32[i5 + 16 >> 2] | 0);
 i1 = HEAP32[i10 >> 2] | 0;
 i4 = i1 + 8 | 0;
 i3 = HEAP8[i8 >> 0] | 0;
 if (!(i3 & 1)) {
  i2 = i8 + 1 | 0;
  i3 = (i3 & 255) >>> 1;
 } else {
  i2 = HEAP32[i8 + 8 >> 2] | 0;
  i3 = HEAP32[i8 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, i2, i3) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, 163296, 1) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == 2 | (i2 | 0) == 1) i2 = 169008; else if (!i2) i2 = 164968; else i2 = 169024;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, i2, _strlen(i2 | 0) | 0) | 0;
 i2 = i5 + 32 | 0;
 if (HEAP8[i2 >> 0] & 1) {
  i2 = HEAP32[i5 + 40 >> 2] | 0;
  if (!i2) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, 160784, 6) | 0; else i6 = 18;
 } else {
  i2 = i2 + 1 | 0;
  i6 = 18;
 }
 if ((i6 | 0) == 18) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, i2, _strlen(i2 | 0) | 0) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i7, i1 + 12 | 0);
 i1 = HEAP8[i7 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i7 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i7 + 8 >> 2] | 0;
  i1 = HEAP32[i7 + 4 >> 2] | 0;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i9, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i9, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i9, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN2cvL13GEMMStore_64fEPKdjS1_jPdjNS_5Size_IiEEddi(i5, i2, i7, i3, i8, i4, i1, d21, d22, i6) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 d21 = +d21;
 d22 = +d22;
 i6 = i6 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, d24 = 0.0, i25 = 0, i26 = 0;
 i23 = STACKTOP;
 i20 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i2 >>> 3;
 i19 = i3 >>> 3;
 i18 = i4 >>> 3;
 if (!i5) {
  i5 = 0;
  i17 = 0;
  i16 = 0;
 } else {
  i16 = (i6 & 4 | 0) == 0;
  i17 = i16 ? i2 : 1;
  i16 = i16 ? 1 : i2;
 }
 if (!i1) {
  STACKTOP = i23;
  return;
 }
 i2 = i16 << 1;
 i9 = i16 * 3 | 0;
 i10 = i16 << 2;
 i11 = i20 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i15 = (i11 | 0) > 3;
 i13 = i15 ? i20 & -4 : 4;
 i15 = i15 ? i11 >>> 2 : 0;
 i14 = Math_imul(i10, i15) | 0;
 i15 = (i15 << 2) + 4 | 0;
 i3 = i5;
 i4 = i5 + (i10 << 3) | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  if (!i3) {
   if (i12) i6 = 0; else {
    i6 = 0;
    do {
     i25 = i6 | 1;
     d24 = +HEAPF64[i7 + (i25 << 3) >> 3] * d21;
     HEAPF64[i8 + (i6 << 3) >> 3] = +HEAPF64[i7 + (i6 << 3) >> 3] * d21;
     HEAPF64[i8 + (i25 << 3) >> 3] = d24;
     i25 = i6 | 2;
     i5 = i6 | 3;
     d24 = +HEAPF64[i7 + (i5 << 3) >> 3] * d21;
     HEAPF64[i8 + (i25 << 3) >> 3] = +HEAPF64[i7 + (i25 << 3) >> 3] * d21;
     HEAPF64[i8 + (i5 << 3) >> 3] = d24;
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) <= (i11 | 0));
    i6 = i13;
   }
   if ((i6 | 0) < (i20 | 0)) do {
    HEAPF64[i8 + (i6 << 3) >> 3] = +HEAPF64[i7 + (i6 << 3) >> 3] * d21;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i20 | 0));
  } else {
   if (i12) {
    i6 = i3;
    i5 = 0;
   } else {
    i6 = i3;
    i5 = 0;
    while (1) {
     i26 = i5 | 1;
     d24 = +HEAPF64[i7 + (i26 << 3) >> 3] * d21 + +HEAPF64[i6 + (i16 << 3) >> 3] * d22;
     HEAPF64[i8 + (i5 << 3) >> 3] = +HEAPF64[i7 + (i5 << 3) >> 3] * d21 + +HEAPF64[i6 >> 3] * d22;
     HEAPF64[i8 + (i26 << 3) >> 3] = d24;
     i26 = i5 | 2;
     i25 = i5 | 3;
     d24 = +HEAPF64[i7 + (i25 << 3) >> 3] * d21 + +HEAPF64[i6 + (i9 << 3) >> 3] * d22;
     HEAPF64[i8 + (i26 << 3) >> 3] = +HEAPF64[i7 + (i26 << 3) >> 3] * d21 + +HEAPF64[i6 + (i2 << 3) >> 3] * d22;
     HEAPF64[i8 + (i25 << 3) >> 3] = d24;
     i5 = i5 + 4 | 0;
     if ((i5 | 0) > (i11 | 0)) break; else i6 = i6 + (i10 << 3) | 0;
    }
    i6 = i4 + (i14 << 3) | 0;
    i5 = i15;
   }
   if ((i5 | 0) < (i20 | 0)) while (1) {
    HEAPF64[i8 + (i5 << 3) >> 3] = +HEAPF64[i7 + (i5 << 3) >> 3] * d21 + +HEAPF64[i6 >> 3] * d22;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i20 | 0)) break; else i6 = i6 + (i16 << 3) | 0;
   }
  }
  if (!i1) break; else {
   i7 = i7 + (i19 << 3) | 0;
   i8 = i8 + (i18 << 3) | 0;
   i3 = i3 + (i17 << 3) | 0;
   i4 = i4 + (i17 << 3) | 0;
  }
 }
 STACKTOP = i23;
 return;
}

function __ZN2cvL12randBits_32sEPiiPyPKNS_3VecIiLi2EEEb(i6, i7, i9, i8, i4) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = STACKTOP;
 i1 = i9;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i7 + -4 | 0;
 i3 = (i5 | 0) < 0;
 if (i4) if (i3) i3 = 0; else {
  i3 = 0;
  do {
   i12 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i12 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i1 = tempRet0;
   i12 = i3 | 1;
   i4 = (i2 >> 8 & HEAP32[i8 + (i12 << 3) >> 2]) + (HEAP32[i8 + (i12 << 3) + 4 >> 2] | 0) | 0;
   HEAP32[i6 + (i3 << 2) >> 2] = (i2 & HEAP32[i8 + (i3 << 3) >> 2]) + (HEAP32[i8 + (i3 << 3) + 4 >> 2] | 0);
   HEAP32[i6 + (i12 << 2) >> 2] = i4;
   i12 = i3 | 2;
   i4 = i3 | 3;
   i11 = (HEAP32[i8 + (i4 << 3) >> 2] & i2 >> 24) + (HEAP32[i8 + (i4 << 3) + 4 >> 2] | 0) | 0;
   HEAP32[i6 + (i12 << 2) >> 2] = (HEAP32[i8 + (i12 << 3) >> 2] & i2 >> 16) + (HEAP32[i8 + (i12 << 3) + 4 >> 2] | 0);
   HEAP32[i6 + (i4 << 2) >> 2] = i11;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i5 | 0));
  i3 = i7 & -4;
 } else if (i3) i3 = 0; else {
  i3 = 0;
  do {
   i11 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i11 = _i64Add(i11 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i4 = tempRet0;
   i14 = (i11 & HEAP32[i8 + (i3 << 3) >> 2]) + (HEAP32[i8 + (i3 << 3) + 4 >> 2] | 0) | 0;
   i11 = ___muldi3(i11 | 0, 0, -130063606, 0) | 0;
   i4 = _i64Add(i11 | 0, tempRet0 | 0, i4 | 0, 0) | 0;
   i11 = tempRet0;
   i12 = i3 | 1;
   i13 = (i4 & HEAP32[i8 + (i12 << 3) >> 2]) + (HEAP32[i8 + (i12 << 3) + 4 >> 2] | 0) | 0;
   HEAP32[i6 + (i3 << 2) >> 2] = i14;
   HEAP32[i6 + (i12 << 2) >> 2] = i13;
   i4 = ___muldi3(i4 | 0, 0, -130063606, 0) | 0;
   i11 = _i64Add(i4 | 0, tempRet0 | 0, i11 | 0, 0) | 0;
   i4 = tempRet0;
   i12 = i3 | 2;
   i13 = (i11 & HEAP32[i8 + (i12 << 3) >> 2]) + (HEAP32[i8 + (i12 << 3) + 4 >> 2] | 0) | 0;
   i11 = ___muldi3(i11 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i11 | 0, tempRet0 | 0, i4 | 0, 0) | 0;
   i1 = tempRet0;
   i4 = i3 | 3;
   i11 = (i2 & HEAP32[i8 + (i4 << 3) >> 2]) + (HEAP32[i8 + (i4 << 3) + 4 >> 2] | 0) | 0;
   HEAP32[i6 + (i12 << 2) >> 2] = i13;
   HEAP32[i6 + (i4 << 2) >> 2] = i11;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i5 | 0));
  i3 = i7 & -4;
 }
 if ((i3 | 0) >= (i7 | 0)) {
  i6 = i2;
  i8 = i1;
  i7 = i9;
  HEAP32[i7 >> 2] = i6;
  i9 = i9 + 4 | 0;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i10;
  return;
 }
 do {
  i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
  i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  HEAP32[i6 + (i3 << 2) >> 2] = (i2 & HEAP32[i8 + (i3 << 3) >> 2]) + (HEAP32[i8 + (i3 << 3) + 4 >> 2] | 0);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i7 | 0));
 i8 = i9;
 HEAP32[i8 >> 2] = i2;
 i9 = i9 + 4 | 0;
 HEAP32[i9 >> 2] = i1;
 STACKTOP = i10;
 return;
}

function __ZN2cv12completeSymmERKNS_17_InputOutputArrayEb(i1, i13) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i14 = i17 + 8 | 0;
 i5 = i17;
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i1 >> 2] >> 2] & 63](i14, i1, -1);
 i16 = i14 + 48 | 0;
 i12 = HEAP32[i16 >> 2] | 0;
 i15 = i14 + 4 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i2 = HEAP32[(HEAP32[i14 + 44 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
  if ((i1 | 0) < 3) i4 = 3; else i4 = 4;
 } else {
  i2 = 0;
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  i1 = HEAP32[i14 + 8 >> 2] | 0;
  if ((i1 | 0) != (HEAP32[i14 + 12 >> 2] | 0)) i4 = 4;
 }
 if ((i4 | 0) == 4) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i5, 31) | 0) + 0 | 0;
  i3 = 31864;
  i4 = i1 + 31 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 31896, 27528, 3161);
  __ZN2cv6String10deallocateEv(i5);
  i1 = HEAP32[i14 + 8 >> 2] | 0;
 }
 i10 = i14 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i14 + 44 | 0;
 if ((i1 | 0) > 0) {
  i7 = 0;
  i8 = 0;
  i9 = i1;
  do {
   i4 = i7;
   i7 = i7 + 1 | 0;
   i8 = i13 ? i7 : i8;
   i9 = i13 ? i9 : i4;
   if ((i8 | 0) < (i9 | 0)) {
    i6 = Math_imul(i4, i12) | 0;
    i5 = Math_imul(i4, i2) | 0;
    i4 = i8;
    do {
     _memcpy(i3 + ((Math_imul(i4, i2) | 0) + i6) | 0, i3 + ((Math_imul(i4, i12) | 0) + i5) | 0, i2 | 0) | 0;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i9 | 0));
   }
  } while ((i7 | 0) != (i1 | 0));
 }
 i4 = i14 + 36 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i8 = i2 + 12 | 0, i9 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i14 + 32 >> 2] | 0;
    if (!i2) {
     if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
      i9 = __Znwj(4) | 0;
      HEAP32[i9 >> 2] = 32784;
      HEAP32[6904] = i9;
      ___cxa_guard_release(27624);
     }
     i2 = HEAP32[6904] | 0;
     i1 = HEAP32[i4 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1);
  }
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i15 >> 2] | 0) > 0) {
  i1 = HEAP32[i14 + 40 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i15 >> 2] | 0));
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i16 | 0)) {
  STACKTOP = i17;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i17;
 return;
}

function __ZN2cvL6mul64fEPKdjS1_jPdjNS_5Size_IiEEPv(i9, i3, i10, i4, i12, i5, i2, i1) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, d11 = 0.0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, d18 = 0.0;
 i17 = STACKTOP;
 i16 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 d11 = +HEAPF64[i1 >> 3];
 i15 = i3 >>> 3;
 i14 = i4 >>> 3;
 i13 = i5 >>> 3;
 i5 = i2 + -1 | 0;
 i2 = (i2 | 0) == 0;
 if (d11 == 1.0) {
  if (i2) {
   STACKTOP = i17;
   return;
  }
  i6 = i16 + -4 | 0;
  i7 = (i6 | 0) < 0;
  i8 = (i6 | 0) > 3 ? i16 & -4 : 4;
  i1 = i9;
  i2 = i10;
  i3 = i12;
  while (1) {
   if (i7) i4 = 0; else {
    i4 = 0;
    do {
     i9 = i4 | 1;
     d11 = +HEAPF64[i1 + (i9 << 3) >> 3] * +HEAPF64[i2 + (i9 << 3) >> 3];
     HEAPF64[i3 + (i4 << 3) >> 3] = +HEAPF64[i1 + (i4 << 3) >> 3] * +HEAPF64[i2 + (i4 << 3) >> 3];
     HEAPF64[i3 + (i9 << 3) >> 3] = d11;
     i9 = i4 | 2;
     i10 = i4 | 3;
     d11 = +HEAPF64[i1 + (i10 << 3) >> 3] * +HEAPF64[i2 + (i10 << 3) >> 3];
     HEAPF64[i3 + (i9 << 3) >> 3] = +HEAPF64[i1 + (i9 << 3) >> 3] * +HEAPF64[i2 + (i9 << 3) >> 3];
     HEAPF64[i3 + (i10 << 3) >> 3] = d11;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) <= (i6 | 0));
    i4 = i8;
   }
   if ((i4 | 0) < (i16 | 0)) do {
    HEAPF64[i3 + (i4 << 3) >> 3] = +HEAPF64[i1 + (i4 << 3) >> 3] * +HEAPF64[i2 + (i4 << 3) >> 3];
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i16 | 0));
   if (!i5) break; else {
    i1 = i1 + (i15 << 3) | 0;
    i2 = i2 + (i14 << 3) | 0;
    i3 = i3 + (i13 << 3) | 0;
    i5 = i5 + -1 | 0;
   }
  }
  STACKTOP = i17;
  return;
 } else {
  if (i2) {
   STACKTOP = i17;
   return;
  }
  i8 = i16 + -4 | 0;
  i7 = (i8 | 0) < 0;
  i6 = (i8 | 0) > 3 ? i16 & -4 : 4;
  i1 = i10;
  i2 = i9;
  i3 = i12;
  i4 = i5;
  while (1) {
   if (i7) i5 = 0; else {
    i5 = 0;
    do {
     i9 = i5 | 1;
     d18 = d11 * +HEAPF64[i2 + (i9 << 3) >> 3] * +HEAPF64[i1 + (i9 << 3) >> 3];
     HEAPF64[i3 + (i5 << 3) >> 3] = d11 * +HEAPF64[i2 + (i5 << 3) >> 3] * +HEAPF64[i1 + (i5 << 3) >> 3];
     HEAPF64[i3 + (i9 << 3) >> 3] = d18;
     i9 = i5 | 2;
     i10 = i5 | 3;
     d18 = d11 * +HEAPF64[i2 + (i10 << 3) >> 3] * +HEAPF64[i1 + (i10 << 3) >> 3];
     HEAPF64[i3 + (i9 << 3) >> 3] = d11 * +HEAPF64[i2 + (i9 << 3) >> 3] * +HEAPF64[i1 + (i9 << 3) >> 3];
     HEAPF64[i3 + (i10 << 3) >> 3] = d18;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) <= (i8 | 0));
    i5 = i6;
   }
   if ((i5 | 0) < (i16 | 0)) do {
    HEAPF64[i3 + (i5 << 3) >> 3] = d11 * +HEAPF64[i2 + (i5 << 3) >> 3] * +HEAPF64[i1 + (i5 << 3) >> 3];
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i16 | 0));
   if (!i4) break; else {
    i1 = i1 + (i14 << 3) | 0;
    i2 = i2 + (i15 << 3) | 0;
    i3 = i3 + (i13 << 3) | 0;
    i4 = i4 + -1 | 0;
   }
  }
  STACKTOP = i17;
  return;
 }
}

function _cvPtrND(i14, i12, i13, i1, i4) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i3 = i15 + 16 | 0;
 i11 = i15 + 8 | 0;
 i6 = i15;
 if (!i12) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i3, 23) | 0) + 0 | 0;
  i7 = 42536 | 0;
  i8 = i2 + 23 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i7 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i7 = i7 + 1 | 0;
  } while ((i2 | 0) < (i8 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i3, 42560, 40912, 1886);
  __ZN2cv6String10deallocateEv(i3);
 }
 do if (i14) {
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = i3 & -65536;
  if ((i2 | 0) == 1111752704) {
   i10 = __ZL13icvGetNodePtrP11CvSparseMatPKiPiiPj(i14, i12, i13, i1, i4) | 0;
   STACKTOP = i15;
   return i10 | 0;
  } else if ((i2 | 0) == 1111687168) {
   i1 = HEAP32[i14 + 16 >> 2] | 0;
   if (!i1) i5 = 16; else {
    i4 = i14 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if ((i2 | 0) > 0) {
     i9 = i14 + 20 | 0;
     i10 = i11 + 4 | 0;
     i6 = 0;
     do {
      i5 = i12 + (i6 << 2) | 0;
      i3 = HEAP32[i5 >> 2] | 0;
      if (i3 >>> 0 >= (HEAP32[i9 + (i6 << 3) >> 2] | 0) >>> 0) {
       HEAP32[i11 >> 2] = 0;
       HEAP32[i10 >> 2] = 0;
       i2 = (__ZN2cv6String8allocateEj(i11, 21) | 0) + 0 | 0;
       i7 = 42456 | 0;
       i8 = i2 + 21 | 0;
       do {
        HEAP8[i2 >> 0] = HEAP8[i7 >> 0] | 0;
        i2 = i2 + 1 | 0;
        i7 = i7 + 1 | 0;
       } while ((i2 | 0) < (i8 | 0));
       __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i11, 42560, 40912, 1900);
       __ZN2cv6String10deallocateEv(i11);
       i3 = HEAP32[i5 >> 2] | 0;
       i2 = HEAP32[i4 >> 2] | 0;
      }
      i1 = i1 + (Math_imul(HEAP32[i9 + (i6 << 3) + 4 >> 2] | 0, i3) | 0) | 0;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) < (i2 | 0));
    }
    if (!i13) {
     i10 = i1;
     STACKTOP = i15;
     return i10 | 0;
    }
    HEAP32[i13 >> 2] = HEAP32[i14 >> 2] & 4095;
    i10 = i1;
    STACKTOP = i15;
    return i10 | 0;
   }
  } else if ((i2 | 0) == 1111621632 ? (HEAP32[i14 + 24 >> 2] | 0) > 0 : 0) {
   if (!((HEAP32[i14 + 20 >> 2] | 0) > 0 | (i3 | 0) == 112)) break;
  } else i5 = 16;
  if ((i5 | 0) == 16 ? (i3 | 0) != 112 : 0) break;
  i10 = _cvPtr2D(i14, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, i13) | 0;
  STACKTOP = i15;
  return i10 | 0;
 } while (0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i6, 38) | 0) + 0 | 0;
 i7 = 42264 | 0;
 i8 = i2 + 38 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i7 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i7 = i7 + 1 | 0;
 } while ((i2 | 0) < (i8 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i6, 42560, 40912, 1910);
 __ZN2cv6String10deallocateEv(i6);
 i10 = 0;
 STACKTOP = i15;
 return i10 | 0;
}

function __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 i5 = i8;
 i1 = (i9 - i5 | 0) / 56 | 0;
 i2 = i10 + 8 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i4 = i7;
 if (i1 >>> 0 > (((HEAP32[i2 >> 2] | 0) - i4 | 0) / 56 | 0) >>> 0) {
  __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE10deallocateEv(i10);
  if (i1 >>> 0 > 76695844) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i4 = ((HEAP32[i2 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) | 0) / 56 | 0;
  if (i4 >>> 0 < 38347922) {
   i4 = i4 << 1;
   i4 = i4 >>> 0 < i1 >>> 0 ? i1 : i4;
   if (i4 >>> 0 > 76695844) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10); else i3 = i4;
  } else i3 = 76695844;
  i7 = __Znwj(i3 * 56 | 0) | 0;
  HEAP32[i10 + 4 >> 2] = i7;
  HEAP32[i10 >> 2] = i7;
  HEAP32[i2 >> 2] = i7 + (i3 * 56 | 0);
  __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE18__construct_at_endIPS2_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_(i10, i8, i9);
  STACKTOP = i12;
  return;
 }
 i11 = i10 + 4 | 0;
 i4 = ((HEAP32[i11 >> 2] | 0) - i4 | 0) / 56 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  i6 = 1;
  i1 = i8 + (i4 * 56 | 0) | 0;
 } else {
  i6 = 0;
  i1 = i9;
 }
 if ((i1 | 0) == (i8 | 0)) i5 = i7; else {
  i2 = i1 + -56 - i5 | 0;
  i4 = i8;
  i3 = i7;
  while (1) {
   __ZN2cv3MataSERKS0_(i3, i4) | 0;
   i4 = i4 + 56 | 0;
   if ((i4 | 0) == (i1 | 0)) break; else i3 = i3 + 56 | 0;
  }
  i5 = i7 + ((((i2 >>> 0) / 56 | 0) + 1 | 0) * 56 | 0) | 0;
 }
 if (i6) {
  __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE18__construct_at_endIPS2_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_(i10, i1, i9);
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i2 = i1 + -56 | 0;
  HEAP32[i11 >> 2] = i2;
  i3 = i1 + -20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != 0 ? (i9 = i4 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i2);
  HEAP32[i3 >> 2] = 0;
  i10 = i1 + -40 | 0;
  i4 = i1 + -52 | 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  if ((HEAP32[i4 >> 2] | 0) > 0) {
   i3 = HEAP32[i1 + -16 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i4 >> 2] | 0));
  }
  i2 = HEAP32[i1 + -12 >> 2] | 0;
  if ((i2 | 0) != (i1 + -8 | 0)) __ZN2cv8fastFreeEPv(i2);
  i1 = HEAP32[i11 >> 2] | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i12;
 return;
}

function __ZN2cv8CholeskyEPdjiS0_ji(i14, i1, i11, i15, i2, i16) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i17 = 0, d18 = 0.0;
 i17 = STACKTOP;
 i13 = i1 >>> 3;
 i12 = i2 >>> 3;
 if ((i11 | 0) > 0) i8 = 0; else {
  i11 = 1;
  STACKTOP = i17;
  return i11 | 0;
 }
 do {
  i9 = Math_imul(i8, i13) | 0;
  if ((i8 | 0) > 0) {
   i5 = 0;
   do {
    i4 = i14 + (i5 + i9 << 3) | 0;
    d3 = +HEAPF64[i4 >> 3];
    i1 = Math_imul(i5, i13) | 0;
    if ((i5 | 0) > 0) {
     i2 = 0;
     do {
      d3 = d3 - +HEAPF64[i14 + (i2 + i9 << 3) >> 3] * +HEAPF64[i14 + (i2 + i1 << 3) >> 3];
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i5 | 0));
    }
    HEAPF64[i4 >> 3] = d3 * +HEAPF64[i14 + (i1 + i5 << 3) >> 3];
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
   i2 = i14 + (i9 + i8 << 3) | 0;
   i1 = 0;
   d3 = +HEAPF64[i2 >> 3];
   do {
    d18 = +HEAPF64[i14 + (i1 + i9 << 3) >> 3];
    d3 = d3 - d18 * d18;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
  } else {
   i10 = i14 + (i9 + i8 << 3) | 0;
   i2 = i10;
   d3 = +HEAPF64[i10 >> 3];
  }
  if (d3 < 2.220446049250313e-16) {
   i1 = 0;
   i7 = 26;
   break;
  }
  HEAPF64[i2 >> 3] = 1.0 / +Math_sqrt(+d3);
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i11 | 0));
 if ((i7 | 0) == 26) {
  STACKTOP = i17;
  return i1 | 0;
 }
 if (!i15) {
  i11 = 1;
  STACKTOP = i17;
  return i11 | 0;
 }
 i10 = (i16 | 0) > 0;
 i2 = 0;
 do {
  if (i10) {
   i8 = Math_imul(i2, i12) | 0;
   i7 = (i2 | 0) > 0;
   i6 = Math_imul(i2, i13) | 0;
   i5 = i14 + (i6 + i2 << 3) | 0;
   i1 = 0;
   do {
    i4 = i15 + (i1 + i8 << 3) | 0;
    d3 = +HEAPF64[i4 >> 3];
    if (i7) {
     i9 = 0;
     do {
      d3 = d3 - +HEAPF64[i14 + (i9 + i6 << 3) >> 3] * +HEAPF64[i15 + ((Math_imul(i9, i12) | 0) + i1 << 3) >> 3];
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) != (i2 | 0));
    }
    HEAPF64[i4 >> 3] = d3 * +HEAPF64[i5 >> 3];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i16 | 0));
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i11 | 0));
 i4 = i11 + -1 | 0;
 i8 = i4;
 while (1) {
  if (i10) {
   i2 = Math_imul(i8, i12) | 0;
   i1 = (i4 | 0) > (i8 | 0);
   i6 = i14 + ((Math_imul(i8, i13) | 0) + i8 << 3) | 0;
   i9 = 0;
   do {
    i7 = i15 + (i9 + i2 << 3) | 0;
    d3 = +HEAPF64[i7 >> 3];
    if (i1) {
     i5 = i4;
     do {
      d18 = +HEAPF64[i14 + ((Math_imul(i5, i13) | 0) + i8 << 3) >> 3];
      d3 = d3 - d18 * +HEAPF64[i15 + ((Math_imul(i5, i12) | 0) + i9 << 3) >> 3];
      i5 = i5 + -1 | 0;
     } while ((i5 | 0) > (i8 | 0));
    }
    HEAPF64[i7 >> 3] = d3 * +HEAPF64[i6 >> 3];
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) != (i16 | 0));
  }
  if ((i8 | 0) > 0) i8 = i8 + -1 | 0; else {
   i1 = 1;
   break;
  }
 }
 STACKTOP = i17;
 return i1 | 0;
}

function __ZNK2cv11_InputArray9getGpuMatEv(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2) | 0;
 if ((i1 | 0) == 458752) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i4, 79) | 0) + 0 | 0;
  i1 = 29e3 | 0;
  i3 = i2 + 79 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i4, 29080, 27528, 1408);
  __ZN2cv6String10deallocateEv(i4);
  i1 = __ZN2cv4cuda6GpuMat16defaultAllocatorEv() | 0;
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = 0;
  HEAP32[i6 + 24 >> 2] = 0;
  HEAP32[i6 + 28 >> 2] = 0;
  HEAP32[i6 + 32 >> 2] = i1;
  STACKTOP = i7;
  return;
 } else if ((i1 | 0) == 589824) {
  i2 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  i1 = HEAP32[i2 + 20 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = i1;
  HEAP32[i6 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i6 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i6 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
  if (!i1) {
   STACKTOP = i7;
   return;
  }
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i7;
  return;
 } else if ((i1 | 0) == 524288) {
  __ZNK2cv4cuda7CudaMem18createGpuMatHeaderEv(i6, HEAP32[i2 + 8 >> 2] | 0);
  STACKTOP = i7;
  return;
 } else if (!i1) {
  i1 = __ZN2cv4cuda6GpuMat16defaultAllocatorEv() | 0;
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = 0;
  HEAP32[i6 + 24 >> 2] = 0;
  HEAP32[i6 + 28 >> 2] = 0;
  HEAP32[i6 + 32 >> 2] = i1;
  STACKTOP = i7;
  return;
 } else {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i5, 62) | 0) + 0 | 0;
  i1 = 29096 | 0;
  i3 = i2 + 62 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i5, 29080, 27528, 1415);
  __ZN2cv6String10deallocateEv(i5);
  i1 = __ZN2cv4cuda6GpuMat16defaultAllocatorEv() | 0;
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = 0;
  HEAP32[i6 + 24 >> 2] = 0;
  HEAP32[i6 + 28 >> 2] = 0;
  HEAP32[i6 + 32 >> 2] = i1;
  STACKTOP = i7;
  return;
 }
}

function __ZNK12_GLOBAL__N_124CLAHE_Interpolation_BodyIhEclERKN2cv5RangeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0;
 i28 = STACKTOP;
 f27 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i2 + 176 >> 2] | 0));
 i3 = HEAP32[i1 >> 2] | 0;
 i24 = i1 + 4 | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 if ((i3 | 0) >= (i1 | 0)) {
  STACKTOP = i28;
  return;
 }
 i25 = i2 + 20 | 0;
 i26 = i2 + 48 | 0;
 i14 = i2 + 76 | 0;
 i15 = i2 + 104 | 0;
 i16 = i2 + 184 | 0;
 i17 = i2 + 180 | 0;
 i18 = i2 + 132 | 0;
 i19 = i2 + 160 | 0;
 i20 = i2 + 16 | 0;
 i21 = i2 + 1252 | 0;
 i22 = i2 + 1256 | 0;
 i23 = i2 + 1264 | 0;
 i13 = i2 + 1260 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 do {
  i4 = HEAP32[i25 >> 2] | 0;
  i5 = Math_imul(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i3) | 0;
  i6 = HEAP32[i14 >> 2] | 0;
  i7 = Math_imul(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i3) | 0;
  f8 = Math_fround(Math_fround(f27 * Math_fround(i3 | 0)) + Math_fround(-.5));
  i11 = ~~f8;
  i11 = i11 - (+(i11 | 0) > +f8 & 1) | 0;
  i30 = i11 + 1 | 0;
  f8 = Math_fround(f8 - Math_fround(i11 | 0));
  f9 = Math_fround(Math_fround(1.0) - f8);
  i31 = (HEAP32[i16 >> 2] | 0) + -1 | 0;
  i29 = HEAP32[i17 >> 2] | 0;
  i11 = Math_imul(i29, (i11 | 0) < 0 ? 0 : i11) | 0;
  i10 = HEAP32[i18 >> 2] | 0;
  i12 = HEAP32[HEAP32[i19 >> 2] >> 2] | 0;
  i11 = Math_imul(i11, i12) | 0;
  i12 = Math_imul(Math_imul((i31 | 0) < (i30 | 0) ? i31 : i30, i29) | 0, i12) | 0;
  if ((i2 | 0) > 0) {
   i1 = 0;
   do {
    i2 = HEAPU8[i4 + (i1 + i5) >> 0] | 0;
    i29 = (HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] | 0) + i2 | 0;
    i2 = (HEAP32[(HEAP32[i22 >> 2] | 0) + (i1 << 2) >> 2] | 0) + i2 | 0;
    f35 = Math_fround(HEAPU8[i10 + (i29 + i11) >> 0] | 0 | 0);
    f33 = Math_fround(HEAPF32[(HEAP32[i23 >> 2] | 0) + (i1 << 2) >> 2]);
    f35 = Math_fround(f35 * f33);
    f34 = Math_fround(HEAPU8[i10 + (i2 + i11) >> 0] | 0 | 0);
    f32 = Math_fround(HEAPF32[(HEAP32[i13 >> 2] | 0) + (i1 << 2) >> 2]);
    f34 = Math_fround(f9 * Math_fround(f35 + Math_fround(f34 * f32)));
    f33 = Math_fround(f33 * Math_fround(HEAPU8[i10 + (i29 + i12) >> 0] | 0 | 0));
    i2 = _lrint(+Math_fround(f34 + Math_fround(f8 * Math_fround(f33 + Math_fround(f32 * Math_fround(HEAPU8[i10 + (i2 + i12) >> 0] | 0 | 0)))))) | 0;
    if (i2 >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 255 : 0;
    HEAP8[i6 + (i1 + i7) >> 0] = i2;
    i1 = i1 + 1 | 0;
    i2 = HEAP32[i20 >> 2] | 0;
   } while ((i1 | 0) < (i2 | 0));
   i1 = HEAP32[i24 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i1 | 0));
 STACKTOP = i28;
 return;
}

function _gzwrite(i12, i9, i13) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 if (!i12) {
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 i10 = i12 + 84 | 0;
 if ((HEAP32[i12 + 12 >> 2] | 0) != 31153) {
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 if (HEAP32[i12 + 76 >> 2] | 0) {
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 if ((i13 | 0) < 0) {
  _gz_error(i12, -3, 143440);
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 if (!i13) {
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 i11 = i12 + 24 | 0;
 if ((HEAP32[i11 >> 2] | 0) == 0 ? (_gz_init(i12) | 0) == -1 : 0) {
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 i1 = i12 + 72 | 0;
 L21 : do if (HEAP32[i1 >> 2] | 0) {
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[i12 + 68 >> 2] | 0;
  i4 = i12 + 88 | 0;
  if ((HEAP32[i4 >> 2] | 0) != 0 ? (_gz_comp(i12, 0) | 0) == -1 : 0) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  if (i1) {
   i5 = i12 + 32 | 0;
   i6 = i12 + 8 | 0;
   i7 = i12 + 84 | 0;
   i3 = 0;
   while (1) {
    i2 = HEAP32[i11 >> 2] | 0;
    i2 = (i2 | 0) < 0 | (i2 | 0) > (i1 | 0) ? i1 : i2;
    if (!i3) _memset(HEAP32[i5 >> 2] | 0, 0, i2 | 0) | 0;
    HEAP32[i4 >> 2] = i2;
    HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i2;
    if ((_gz_comp(i12, 0) | 0) == -1) {
     i1 = 0;
     break;
    }
    if ((i1 | 0) == (i2 | 0)) break L21; else {
     i1 = i1 - i2 | 0;
     i3 = 1;
    }
   }
   STACKTOP = i14;
   return i1 | 0;
  }
 } while (0);
 i6 = i12 + 88 | 0;
 L36 : do if ((HEAP32[i11 >> 2] | 0) >>> 0 <= i13 >>> 0) {
  if ((HEAP32[i6 >> 2] | 0) != 0 ? (_gz_comp(i12, 0) | 0) == -1 : 0) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  HEAP32[i6 >> 2] = i13;
  HEAP32[i10 >> 2] = i9;
  i10 = i12 + 8 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i13;
  if ((_gz_comp(i12, 0) | 0) == -1) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
 } else {
  i5 = i12 + 32 | 0;
  i8 = i12 + 8 | 0;
  i3 = i9;
  i4 = i13;
  while (1) {
   i2 = HEAP32[i6 >> 2] | 0;
   if (!i2) {
    i7 = HEAP32[i5 >> 2] | 0;
    HEAP32[i10 >> 2] = i7;
    i1 = i7;
   } else {
    i1 = HEAP32[i10 >> 2] | 0;
    i7 = HEAP32[i5 >> 2] | 0;
   }
   i9 = i1 + i2 - i7 | 0;
   i1 = (HEAP32[i11 >> 2] | 0) - i9 | 0;
   i1 = i1 >>> 0 > i4 >>> 0 ? i4 : i1;
   _memcpy(i7 + i9 | 0, i3 | 0, i1 | 0) | 0;
   HEAP32[i6 >> 2] = i1 + (HEAP32[i6 >> 2] | 0);
   HEAP32[i8 >> 2] = i1 + (HEAP32[i8 >> 2] | 0);
   if ((i4 | 0) == (i1 | 0)) break L36;
   if ((_gz_comp(i12, 0) | 0) == -1) {
    i1 = 0;
    break;
   } else {
    i3 = i3 + i1 | 0;
    i4 = i4 - i1 | 0;
   }
  }
  STACKTOP = i14;
  return i1 | 0;
 } while (0);
 i10 = i13;
 STACKTOP = i14;
 return i10 | 0;
}

function __ZN2cv13sorted_vectorINS_6StringEPFPNS_9AlgorithmEvEE3addERKS1_RKS5_(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i11 = i12 + 8 | 0;
 i10 = i12;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 + 4 >> 2];
 if (i3) {
  i7 = i3 + -4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 i6 = i11 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 i5 = i8 + 4 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (HEAP32[i8 + 8 >> 2] | 0)) {
  __ZNSt3__16vectorINS_4pairIN2cv6StringEPFPNS2_9AlgorithmEvEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i8, i11);
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  if (!i7) i3 = 0; else {
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i7 + 4 >> 2] = HEAP32[i4 >> 2];
   if (!i3) i3 = i7; else {
    i3 = i3 + -4 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
    i3 = HEAP32[i5 >> 2] | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i7 + 8 >> 2] = i2;
  }
  i3 = i3 + 12 | 0;
  HEAP32[i5 >> 2] = i3;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = (i3 - i2 | 0) / 12 | 0;
 i1 = i3 + -1 | 0;
 if (!i1) {
  __ZN2cv6String10deallocateEv(i11);
  STACKTOP = i12;
  return;
 }
 while (1) {
  i7 = i3 + -2 | 0;
  i3 = i2 + (i1 * 12 | 0) | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i2 + (i7 * 12 | 0) | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if ((i4 | 0) == (i6 | 0)) break;
  if ((_strcmp((i4 | 0) == 0 ? 39376 : i4, (i6 | 0) == 0 ? 39376 : i6) | 0) >= 0) {
   i9 = 15;
   break;
  }
  HEAP32[i5 >> 2] = i4;
  HEAP32[i3 >> 2] = i6;
  i5 = i2 + (i7 * 12 | 0) + 4 | 0;
  i6 = i2 + (i1 * 12 | 0) + 4 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i3;
  i6 = i2 + (i7 * 12 | 0) + 8 | 0;
  i3 = i2 + (i1 * 12 | 0) + 8 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i7;
  i3 = i1 + -1 | 0;
  if (!i3) {
   i9 = 17;
   break;
  }
  i7 = i1;
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i3;
  i3 = i7;
 }
 if ((i9 | 0) == 17) {
  __ZN2cv6String10deallocateEv(i11);
  STACKTOP = i12;
  return;
 }
 if ((i9 | 0) == 15 ? (_strcmp((i4 | 0) == 0 ? 39376 : i4, (i6 | 0) == 0 ? 39376 : i6) | 0) != 0 : 0) {
  __ZN2cv6String10deallocateEv(i11);
  STACKTOP = i12;
  return;
 }
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i1 = (__ZN2cv6String8allocateEj(i10, 40) | 0) + 0 | 0;
 i2 = 38664 | 0;
 i3 = i1 + 40 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 38712, 37992, 63);
 __ZN2cv6String10deallocateEv(i10);
 __ZN2cv6String10deallocateEv(i11);
 STACKTOP = i12;
 return;
}

function __ZNSt3__16vectorIPN7testing8TestCaseENS_9allocatorIS3_EEE6insertENS_11__wrap_iterIPKS3_EERS8_(i14, i11, i2, i1) {
 i14 = i14 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 i6 = HEAP32[i11 >> 2] | 0;
 i5 = i6;
 i2 = (HEAP32[i2 >> 2] | 0) - i5 >> 2;
 i12 = i6 + (i2 << 2) | 0;
 i13 = i11 + 4 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i10 = i11 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i7 >>> 0 < i3 >>> 0) {
  if ((i12 | 0) == (i7 | 0)) {
   if (!i12) i1 = 0; else {
    HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
    i1 = HEAP32[i13 >> 2] | 0;
   }
   HEAP32[i13 >> 2] = i1 + 4;
   i10 = i12;
   HEAP32[i14 >> 2] = i10;
   STACKTOP = i15;
   return;
  }
  i4 = i7 - (i6 + (i2 + 1 << 2)) | 0;
  i5 = i4 >> 2;
  i2 = i6 + (i5 + i2 << 2) | 0;
  if (i2 >>> 0 < i7 >>> 0) {
   i3 = i7;
   do {
    if (!i3) i3 = 0; else {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = HEAP32[i13 >> 2] | 0;
    }
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
    HEAP32[i13 >> 2] = i3;
   } while (i2 >>> 0 < i7 >>> 0);
  }
  _memmove(i7 + (0 - i5 << 2) | 0, i12 | 0, i4 | 0) | 0;
  if (i12 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i13 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 4 | 0 : i1;
  HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
  i10 = i12;
  HEAP32[i14 >> 2] = i10;
  STACKTOP = i15;
  return;
 }
 i4 = (i7 - i5 >> 2) + 1 | 0;
 if (i4 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i5 = i6;
 i3 = i3 - i5 | 0;
 if (i3 >> 2 >>> 0 < 536870911) {
  i3 = i3 >> 1;
  i3 = i3 >>> 0 < i4 >>> 0 ? i4 : i3;
  i4 = i12;
  i5 = i4 - i5 >> 2;
  if (!i3) {
   i6 = 0;
   i8 = 0;
   i7 = i4;
  } else i9 = 18;
 } else {
  i4 = i12;
  i3 = 1073741823;
  i5 = i4 - i5 >> 2;
  i9 = 18;
 }
 if ((i9 | 0) == 18) {
  i6 = i3;
  i8 = __Znwj(i3 << 2) | 0;
  i7 = i4;
 }
 i3 = i8 + (i5 << 2) | 0;
 i4 = i8 + (i6 << 2) | 0;
 do if ((i5 | 0) == (i6 | 0)) {
  if ((i5 | 0) > 0) {
   i3 = i8 + (((i5 + 1 | 0) / -2 | 0) + i5 << 2) | 0;
   break;
  }
  i2 = (i5 | 0) == 0 ? 1 : i5 << 1;
  i9 = __Znwj(i2 << 2) | 0;
  i3 = i9 + (i2 >>> 2 << 2) | 0;
  i2 = i9 + (i2 << 2) | 0;
  if (!i8) i4 = i2; else {
   __ZdlPv(i8);
   i4 = i2;
  }
 } while (0);
 if (!i3) i1 = 0; else {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i1 = i3;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = i7 - i2 | 0;
 i8 = i3 + (0 - (i9 >> 2) << 2) | 0;
 _memcpy(i8 | 0, i2 | 0, i9 | 0) | 0;
 i9 = (HEAP32[i13 >> 2] | 0) - i7 | 0;
 _memcpy(i1 + 4 | 0, i12 | 0, i9 | 0) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i13 >> 2] = i1 + ((i9 >> 2) + 1 << 2);
 HEAP32[i10 >> 2] = i4;
 if (!i2) {
  i10 = i3;
  HEAP32[i14 >> 2] = i10;
  STACKTOP = i15;
  return;
 }
 __ZdlPv(i2);
 i10 = i3;
 HEAP32[i14 >> 2] = i10;
 STACKTOP = i15;
 return;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter15OnTestCaseStartERKNS_8TestCaseE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i9 = i10;
 i5 = i10 + 32 | 0;
 i6 = i10 + 20 | 0;
 i8 = i10 + 8 | 0;
 i2 = HEAP32[i7 + 20 >> 2] | 0;
 i4 = HEAP32[i7 + 24 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) i1 = 0; else {
  i1 = 0;
  do {
   i1 = (HEAPU8[(HEAP32[i2 >> 2] | 0) + 36 >> 0] | 0) + i1 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 HEAP32[i9 >> 2] = i1;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i6, i9);
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i2 = HEAP8[i6 >> 0] | 0;
 if (!(i2 & 1)) {
  i2 = (i2 & 255) >>> 1;
  i3 = i6 + 1 | 0;
 } else {
  i2 = HEAP32[i6 + 4 >> 2] | 0;
  i3 = HEAP32[i6 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, i3, i2, i2 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, 163296, 1) | 0;
 i1 = (i1 | 0) == 1 ? 162456 : 162464;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i3 = HEAP8[i5 >> 0] | 0;
 if (!(i3 & 1)) {
  i4 = _strlen(i1 | 0) | 0;
  i3 = (i3 & 255) >>> 1;
  i2 = i5 + 1 | 0;
 } else {
  i3 = HEAP32[i5 + 4 >> 2] | 0;
  i4 = _strlen(i1 | 0) | 0;
  i2 = HEAP32[i5 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i2, i3, i3 + i4 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, i1, i4) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(2, 162440, i9);
 if (!(HEAP8[i8 >> 0] & 1)) i2 = i8 + 1 | 0; else i2 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = i7 + 4 | 0;
 if (!(HEAP8[i1 >> 0] & 1)) i1 = i1 + 1 | 0; else i1 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = i1;
 _printf(162472, i9 | 0) | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 do if (i1) {
  if (!(HEAP8[i1 >> 0] & 1)) i1 = i1 + 1 | 0; else {
   if (!(HEAP32[i1 + 8 >> 2] | 0)) break;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i9 >> 2] = 162512;
  HEAP32[i9 + 4 >> 2] = i1;
  _printf(162488, i9 | 0) | 0;
  i1 = HEAP32[_stdout >> 2] | 0;
  _fflush(i1 | 0) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
  STACKTOP = i10;
  return;
 } while (0);
 _putchar(10) | 0;
 i1 = HEAP32[_stdout >> 2] | 0;
 _fflush(i1 | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
 STACKTOP = i10;
 return;
}

function _cvCreateSparseMat(i12, i13, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i14 + 24 | 0;
 i3 = i14 + 16 | 0;
 i4 = i14 + 8 | 0;
 i8 = i14;
 i10 = i1 & 4095;
 i11 = 1212424721 >>> (i1 << 2 & 28) & 15;
 i9 = Math_imul(i11, (i1 >>> 3 & 511) + 1 | 0) | 0;
 if (!i9) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i2, 23) | 0) + 0 | 0;
  i6 = 41256 | 0;
  i7 = i5 + 23 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-210, i2, 41968, 40912, 545);
  __ZN2cv6String10deallocateEv(i2);
 }
 if ((i12 + -1 | 0) >>> 0 > 1023) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i3, 24) | 0) + 0 | 0;
  i6 = 41992 | 0;
  i7 = i5 + 24 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i3, 41968, 40912, 548);
  __ZN2cv6String10deallocateEv(i3);
 }
 if (!i13) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i4, 20) | 0) + 0 | 0;
  i6 = 41280 | 0;
  i7 = i5 + 20 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i4, 41968, 40912, 551);
  __ZN2cv6String10deallocateEv(i4);
 }
 if ((i12 | 0) > 0) {
  i1 = i8 + 4 | 0;
  i2 = 0;
  do {
   if ((HEAP32[i13 + (i2 << 2) >> 2] | 0) < 1) {
    HEAP32[i8 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    i5 = (__ZN2cv6String8allocateEj(i8, 37) | 0) + 0 | 0;
    i6 = 41352 | 0;
    i7 = i5 + 37 | 0;
    do {
     HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
     i5 = i5 + 1 | 0;
     i6 = i6 + 1 | 0;
    } while ((i5 | 0) < (i7 | 0));
    __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i8, 41968, 40912, 556);
    __ZN2cv6String10deallocateEv(i8);
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
 }
 i1 = i12 + -32 | 0;
 if ((i1 | 0) > 0) i1 = (i1 << 2) + 164 | 0; else i1 = 164;
 i8 = _cvAlloc(i1) | 0;
 HEAP32[i8 >> 2] = i10 | 1111752704;
 HEAP32[i8 + 4 >> 2] = i12;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 1;
 i7 = i12 << 2;
 _memcpy(i8 + 36 | 0, i13 | 0, i7 | 0) | 0;
 i10 = i11 + 7 & 0 - i11;
 HEAP32[i8 + 28 >> 2] = i10;
 i10 = i9 + 3 + i10 & -4;
 HEAP32[i8 + 32 >> 2] = i10;
 HEAP32[i8 + 16 >> 2] = _cvCreateSet(0, 64, i7 + 7 + i10 & -8, _cvCreateMemStorage(4096) | 0) | 0;
 HEAP32[i8 + 24 >> 2] = 1024;
 i10 = _cvAlloc(4096) | 0;
 HEAP32[i8 + 20 >> 2] = i10;
 _memset(i10 | 0, 0, 4096) | 0;
 STACKTOP = i14;
 return i8 | 0;
}

function __ZN2cvL6div64fEPKdjS1_jPdjNS_5Size_IiEEPv(i8, i3, i9, i4, i10, i5, i1, i2) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d6 = 0.0, d7 = 0.0, d11 = 0.0, d12 = 0.0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, d19 = 0.0, i20 = 0, i21 = 0, d22 = 0.0, i23 = 0, d24 = 0.0, i25 = 0, i26 = 0, d27 = 0.0, d28 = 0.0;
 i26 = STACKTOP;
 i20 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 d19 = +HEAPF64[i2 >> 3];
 i18 = i3 >>> 3;
 i17 = i4 >>> 3;
 i14 = i5 >>> 3;
 if (!i1) {
  STACKTOP = i26;
  return;
 }
 i15 = i20 + -4 | 0;
 i16 = (i15 | 0) < 0;
 i13 = (i15 | 0) > 3 ? i20 & -4 : 4;
 while (1) {
  i1 = i1 + -1 | 0;
  if (i16) i4 = 0; else {
   i2 = 0;
   do {
    d6 = +HEAPF64[i9 + (i2 << 3) >> 3];
    i3 = i2 | 1;
    i5 = i9 + (i3 << 3) | 0;
    do if (d6 != 0.0) {
     d7 = +HEAPF64[i5 >> 3];
     if ((d7 != 0.0 ? (i21 = i2 | 2, d22 = +HEAPF64[i9 + (i21 << 3) >> 3], d22 != 0.0) : 0) ? (i23 = i2 | 3, d24 = +HEAPF64[i9 + (i23 << 3) >> 3], d24 != 0.0) : 0) {
      d12 = d6 * d7;
      d27 = d22 * d24;
      d28 = d19 / (d12 * d27);
      d27 = d27 * d28;
      d28 = d12 * d28;
      d12 = d6 * (d27 * +HEAPF64[i8 + (i3 << 3) >> 3]);
      d11 = d24 * (d28 * +HEAPF64[i8 + (i21 << 3) >> 3]);
      d6 = d22 * (d28 * +HEAPF64[i8 + (i23 << 3) >> 3]);
      HEAPF64[i10 + (i2 << 3) >> 3] = d7 * (+HEAPF64[i8 + (i2 << 3) >> 3] * d27);
      HEAPF64[i10 + (i3 << 3) >> 3] = d12;
      HEAPF64[i10 + (i21 << 3) >> 3] = d11;
      HEAPF64[i10 + (i23 << 3) >> 3] = d6;
      break;
     }
     d12 = d19 * +HEAPF64[i8 + (i2 << 3) >> 3] / d6;
     i25 = 10;
    } else {
     d12 = 0.0;
     i25 = 10;
    } while (0);
    if ((i25 | 0) == 10) {
     i25 = 0;
     d6 = +HEAPF64[i5 >> 3];
     if (d6 != 0.0) d11 = d19 * +HEAPF64[i8 + (i3 << 3) >> 3] / d6; else d11 = 0.0;
     i4 = i2 | 2;
     d7 = +HEAPF64[i9 + (i4 << 3) >> 3];
     if (d7 != 0.0) d6 = d19 * +HEAPF64[i8 + (i4 << 3) >> 3] / d7; else d6 = 0.0;
     i5 = i2 | 3;
     d7 = +HEAPF64[i9 + (i5 << 3) >> 3];
     if (d7 != 0.0) d7 = d19 * +HEAPF64[i8 + (i5 << 3) >> 3] / d7; else d7 = 0.0;
     HEAPF64[i10 + (i2 << 3) >> 3] = d12;
     HEAPF64[i10 + (i3 << 3) >> 3] = d11;
     HEAPF64[i10 + (i4 << 3) >> 3] = d6;
     HEAPF64[i10 + (i5 << 3) >> 3] = d7;
    }
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) <= (i15 | 0));
   i4 = i13;
  }
  if ((i4 | 0) < (i20 | 0)) do {
   d6 = +HEAPF64[i9 + (i4 << 3) >> 3];
   if (d6 != 0.0) d6 = d19 * +HEAPF64[i8 + (i4 << 3) >> 3] / d6; else d6 = 0.0;
   HEAPF64[i10 + (i4 << 3) >> 3] = d6;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i20 | 0));
  if (!i1) break; else {
   i8 = i8 + (i18 << 3) | 0;
   i9 = i9 + (i17 << 3) | 0;
   i10 = i10 + (i14 << 3) | 0;
  }
 }
 STACKTOP = i26;
 return;
}

function __GLOBAL__I_a147() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 40;
 HEAP32[i2 + 16 >> 2] = 10600;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 113;
 HEAP32[i2 + 24 >> 2] = 353;
 HEAP32[i2 + 36 >> 2] = 114;
 HEAP32[i2 + 28 >> 2] = 75;
 HEAP32[i2 + 32 >> 2] = 43;
 _cvRegisterType(i2);
 HEAP32[2648] = HEAP32[2644];
 ___cxa_atexit(354, 10592, ___dso_handle | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 40;
 HEAP32[i2 + 16 >> 2] = 10624;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 113;
 HEAP32[i2 + 24 >> 2] = 353;
 HEAP32[i2 + 36 >> 2] = 114;
 HEAP32[i2 + 28 >> 2] = 76;
 HEAP32[i2 + 32 >> 2] = 43;
 _cvRegisterType(i2);
 HEAP32[2654] = HEAP32[2644];
 ___cxa_atexit(354, 10616, ___dso_handle | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 40;
 HEAP32[i2 + 16 >> 2] = 10656;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 115;
 HEAP32[i2 + 24 >> 2] = 355;
 HEAP32[i2 + 36 >> 2] = 116;
 HEAP32[i2 + 28 >> 2] = 77;
 HEAP32[i2 + 32 >> 2] = 44;
 _cvRegisterType(i2);
 HEAP32[2662] = HEAP32[2644];
 ___cxa_atexit(354, 10648, ___dso_handle | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 40;
 HEAP32[i2 + 16 >> 2] = 10680;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 117;
 HEAP32[i2 + 24 >> 2] = 356;
 HEAP32[i2 + 36 >> 2] = 118;
 HEAP32[i2 + 28 >> 2] = 78;
 HEAP32[i2 + 32 >> 2] = 45;
 _cvRegisterType(i2);
 HEAP32[2668] = HEAP32[2644];
 ___cxa_atexit(354, 10672, ___dso_handle | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 40;
 HEAP32[i2 + 16 >> 2] = 10712;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 119;
 HEAP32[i2 + 24 >> 2] = 357;
 HEAP32[i2 + 36 >> 2] = 120;
 HEAP32[i2 + 28 >> 2] = 79;
 HEAP32[i2 + 32 >> 2] = 46;
 _cvRegisterType(i2);
 HEAP32[2676] = HEAP32[2644];
 ___cxa_atexit(354, 10704, ___dso_handle | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 40;
 HEAP32[i2 + 16 >> 2] = 10736;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 121;
 HEAP32[i2 + 24 >> 2] = 358;
 HEAP32[i2 + 36 >> 2] = 122;
 HEAP32[i2 + 28 >> 2] = 80;
 HEAP32[i2 + 32 >> 2] = 47;
 _cvRegisterType(i2);
 HEAP32[2682] = HEAP32[2644];
 ___cxa_atexit(354, 10728, ___dso_handle | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 40;
 HEAP32[i2 + 16 >> 2] = 10760;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 123;
 HEAP32[i2 + 24 >> 2] = 359;
 HEAP32[i2 + 36 >> 2] = 124;
 HEAP32[i2 + 28 >> 2] = 81;
 HEAP32[i2 + 32 >> 2] = 48;
 _cvRegisterType(i2);
 HEAP32[2688] = HEAP32[2644];
 ___cxa_atexit(354, 10752, ___dso_handle | 0) | 0;
 STACKTOP = i1;
 return;
}

function __ZNK2cv17MatOp_Initializer6assignERKNS_7MatExprERNS_3MatEi(i1, i11, i12, i3) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i6 = i14 + 128 | 0;
 i7 = i14 + 104 | 0;
 i8 = i14 + 64 | 0;
 i9 = i14 + 32 | 0;
 i10 = i14;
 i13 = i14 + 96 | 0;
 if ((i3 | 0) == -1) i3 = HEAP32[i11 + 8 >> 2] & 4095;
 i5 = i11 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i11 + 48 >> 2] | 0;
 do if ((i2 | 0) < 3) {
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i3 & 4095;
  if (((((HEAP32[i12 + 4 >> 2] | 0) < 3 ? (HEAP32[i12 + 8 >> 2] | 0) == (i2 | 0) : 0) ? (HEAP32[i12 + 12 >> 2] | 0) == (i4 | 0) : 0) ? (HEAP32[i12 >> 2] & 4095 | 0) == (i3 | 0) : 0) ? (HEAP32[i12 + 16 >> 2] | 0) != 0 : 0) break;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i6 + 4 >> 2] = i4;
  __ZN2cv3Mat6createEiPKii(i12, 2, i6, i3);
 } else __ZN2cv3Mat6createEiPKii(i12, i2, i1, i3); while (0);
 i3 = HEAP32[i11 + 4 >> 2] | 0;
 if ((i3 | 0) == 73) {
  if ((HEAP32[i5 >> 2] | 0) < 3) {
   i10 = i7 + 4 | 0;
   HEAP32[i10 + 0 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i7 >> 2] = 3136;
   HEAP32[i10 >> 2] = 50397184;
   HEAP32[i7 + 8 >> 2] = i12;
   HEAPF64[i8 >> 3] = +HEAPF64[i11 + 176 >> 3];
   i10 = i8 + 8 | 0;
   HEAP32[i10 + 0 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i10 + 16 >> 2] = 0;
   HEAP32[i10 + 20 >> 2] = 0;
   __ZN2cv11setIdentityERKNS_17_InputOutputArrayERKNS_7Scalar_IdEE(i7, i8);
   STACKTOP = i14;
   return;
  }
 } else if ((i3 | 0) == 49) {
  HEAPF64[i10 >> 3] = +HEAPF64[i11 + 176 >> 3];
  i9 = i10 + 8 | 0;
  HEAP32[i9 + 0 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i9 + 16 >> 2] = 0;
  HEAP32[i9 + 20 >> 2] = 0;
  __ZN2cv3MataSERKNS_7Scalar_IdEE(i12, i10) | 0;
  STACKTOP = i14;
  return;
 } else if ((i3 | 0) == 48) {
  HEAP32[i9 + 0 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i9 + 16 >> 2] = 0;
  HEAP32[i9 + 20 >> 2] = 0;
  HEAP32[i9 + 24 >> 2] = 0;
  HEAP32[i9 + 28 >> 2] = 0;
  HEAPF64[i9 >> 3] = 0.0;
  __ZN2cv3MataSERKNS_7Scalar_IdEE(i12, i9) | 0;
  STACKTOP = i14;
  return;
 }
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i1 = (__ZN2cv6String8allocateEj(i13, 31) | 0) + 0 | 0;
 i2 = 33304 | 0;
 i3 = i1 + 31 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i13, 33216, 33224, 1572);
 __ZN2cv6String10deallocateEv(i13);
 STACKTOP = i14;
 return;
}
function __ZNSt3__127__insertion_sort_incompleteIRNS_6__lessIxxEEPxEEbT0_S5_T_(i11, i9, i1) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 switch (i9 - i11 >> 3 | 0) {
 case 5:
  {
   __ZNSt3__17__sort5IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_S5_T_(i11, i11 + 8 | 0, i11 + 16 | 0, i11 + 24 | 0, i9 + -8 | 0, i1) | 0;
   i10 = 1;
   STACKTOP = i12;
   return i10 | 0;
  }
 case 1:
 case 0:
  {
   i10 = 1;
   STACKTOP = i12;
   return i10 | 0;
  }
 case 3:
  {
   __ZNSt3__17__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i11, i11 + 8 | 0, i9 + -8 | 0, i1) | 0;
   i10 = 1;
   STACKTOP = i12;
   return i10 | 0;
  }
 case 2:
  {
   i4 = i9 + -8 | 0;
   i1 = i4;
   i5 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   i3 = i11;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   if (!((i1 | 0) < (i3 | 0) | (i1 | 0) == (i3 | 0) & i5 >>> 0 < i2 >>> 0)) {
    i10 = 1;
    STACKTOP = i12;
    return i10 | 0;
   }
   i10 = i11;
   HEAP32[i10 >> 2] = i5;
   HEAP32[i10 + 4 >> 2] = i1;
   i10 = i4;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i10 + 4 >> 2] = i3;
   i10 = 1;
   STACKTOP = i12;
   return i10 | 0;
  }
 case 4:
  {
   __ZNSt3__17__sort4IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_T_(i11, i11 + 8 | 0, i11 + 16 | 0, i9 + -8 | 0, i1) | 0;
   i10 = 1;
   STACKTOP = i12;
   return i10 | 0;
  }
 default:
  {
   i5 = i11 + 16 | 0;
   __ZNSt3__17__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i11, i11 + 8 | 0, i5, i1) | 0;
   i4 = i11 + 24 | 0;
   if ((i4 | 0) == (i9 | 0)) {
    i10 = 1;
    STACKTOP = i12;
    return i10 | 0;
   } else i1 = 0;
   while (1) {
    i8 = i4;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    i2 = i5;
    i3 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if ((i8 | 0) < (i2 | 0) | (i8 | 0) == (i2 | 0) & i7 >>> 0 < i3 >>> 0) {
     i6 = i4;
     while (1) {
      HEAP32[i6 >> 2] = i3;
      HEAP32[i6 + 4 >> 2] = i2;
      if ((i5 | 0) == (i11 | 0)) {
       i5 = i11;
       break;
      }
      i6 = i5 + -8 | 0;
      i2 = i6;
      i3 = HEAP32[i2 >> 2] | 0;
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!((i8 | 0) < (i2 | 0) | (i8 | 0) == (i2 | 0) & i7 >>> 0 < i3 >>> 0)) break; else {
       i13 = i5;
       i5 = i6;
       i6 = i13;
      }
     }
     i6 = i5;
     HEAP32[i6 >> 2] = i7;
     HEAP32[i6 + 4 >> 2] = i8;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) break;
    }
    i5 = i4 + 8 | 0;
    if ((i5 | 0) == (i9 | 0)) {
     i1 = 1;
     i10 = 14;
     break;
    } else {
     i8 = i4;
     i4 = i5;
     i5 = i8;
    }
   }
   if ((i10 | 0) == 14) {
    STACKTOP = i12;
    return i1 | 0;
   }
   i10 = (i4 + 8 | 0) == (i9 | 0);
   STACKTOP = i12;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZN4perf8TestBase8TearDownEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i8 = i9;
 i3 = i9 + 16 | 0;
 i2 = i9 + 12 | 0;
 i4 = i9 + 8 | 0;
 i6 = i9 + 4 | 0;
 do if ((HEAP32[i7 + 168 >> 2] | 0) == 4) {
  _printf(176048, i8 | 0) | 0;
  _putchar(10) | 0;
  _fflush(HEAP32[_stdout >> 2] | 0) | 0;
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i3, 0, 170184, 1583, 176072);
  __ZN7testing7MessageC2Ev(i2);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i2 >> 2] | 0) + 8 | 0, 176088, 16) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i3, i2);
  if (HEAP32[i2 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i1 = HEAP32[i2 >> 2] | 0, (i1 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
   HEAP32[i2 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i3);
 } else {
  if ((!(__ZN7testing4Test15HasFatalFailureEv() | 0) ? !(__ZN7testing4Test18HasNonfatalFailureEv() | 0) : 0) ? (HEAP8[i7 + 176 >> 0] | 0) == 0 : 0) {
   __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i4, 1, 170184, 1588, 171216);
   __ZN7testing7MessageC2Ev(i6);
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i6 >> 2] | 0) + 8 | 0, 176112, 97) | 0;
   __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i4, i6);
   if (HEAP32[i6 >> 2] | 0) {
    if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i5 = HEAP32[i6 >> 2] | 0, (i5 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 511](i5);
    HEAP32[i6 >> 2] = 0;
   }
   __ZN7testing8internal12AssertHelperD2Ev(i4);
  }
  __ZN4perf8TestBase15validateMetricsEv(i7);
  if (!(__ZN7testing4Test15HasFatalFailureEv() | 0) ? !(__ZN7testing4Test18HasNonfatalFailureEv() | 0) : 0) break;
  __ZN4perf8TestBase13reportMetricsEb(i7, 0);
  STACKTOP = i9;
  return;
 } while (0);
 i2 = __ZNK7testing8UnitTest17current_test_infoEv(__ZN7testing8UnitTest11GetInstanceEv() | 0) | 0;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 do if (i1) if (!(HEAP8[i1 >> 0] & 1)) {
  i3 = i1 + 1 | 0;
  break;
 } else {
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  break;
 } else i3 = 0; while (0);
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 do if (i1) {
  if (HEAP8[i1 >> 0] & 1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i1) break;
  } else i1 = i1 + 1 | 0;
  HEAP32[i8 >> 2] = i1;
  _printf(176216, i8 | 0) | 0;
  _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 } while (0);
 if (i3) {
  HEAP32[i8 >> 2] = i3;
  _printf(176240, i8 | 0) | 0;
  _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 }
 __ZN4perf8TestBase13reportMetricsEb(i7, 1);
 STACKTOP = i9;
 return;
}

function __ZNK2cv5MatOp8multiplyERKNS_7MatExprEdRS1_(i1, i3, d8, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 d8 = +d8;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i12 = i16 + 88 | 0;
 i9 = i16 + 32 | 0;
 i5 = i16;
 HEAP32[i12 >> 2] = 1124007936;
 i14 = i12 + 4 | 0;
 i2 = i12 + 8 | 0;
 i11 = i12 + 40 | 0;
 i1 = i14 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i11 >> 2] = i2;
 i15 = i12 + 48 | 0;
 i13 = i12 + 44 | 0;
 HEAP32[i13 >> 2] = i15;
 HEAP32[i12 + 52 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 i10 = HEAP32[i3 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] & 63](i10, i3, i12, -1);
 HEAP32[i9 >> 2] = 1124007936;
 i10 = i9 + 4 | 0;
 i2 = i9 + 8 | 0;
 i3 = i9 + 40 | 0;
 i1 = i10 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i3 >> 2] = i2;
 i6 = i9 + 48 | 0;
 i4 = i9 + 44 | 0;
 HEAP32[i4 >> 2] = i6;
 HEAP32[i9 + 52 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAPF64[i5 >> 3] = 0.0;
 __ZN2cv11MatOp_AddEx8makeExprERNS_7MatExprERKNS_3MatES5_ddRKNS_7Scalar_IdEE(i7, i12, i9, d8, 0.0, i5);
 i2 = i9 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i5 = i1 + 12 | 0, i7 = HEAP32[i5 >> 2] | 0, HEAP32[i5 >> 2] = i7 + -1, (i7 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i9);
 HEAP32[i2 >> 2] = 0;
 i9 = i9 + 16 | 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 if ((HEAP32[i10 >> 2] | 0) > 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i10 >> 2] | 0));
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i6 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i12 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i12);
 HEAP32[i2 >> 2] = 0;
 i10 = i12 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i14 >> 2] | 0) > 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i14 >> 2] | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i15 | 0)) {
  STACKTOP = i16;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i16;
 return;
}

function __ZNSt3__16vectorIN2cv3VecIiLi16EEENS_9allocatorIS3_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 i9 = i10 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i4 = i1;
 if (i5 - i4 >> 6 >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    i5 = i1 + 0 | 0;
    i6 = i5 + 64 | 0;
    do {
     HEAP32[i5 >> 2] = 0;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) < (i6 | 0));
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i1 = i1 + 64 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = (i4 - i3 >> 6) + i2 | 0;
 if (i4 >>> 0 > 67108863) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i1 = i5 - i3 | 0;
 if (i1 >> 6 >>> 0 < 33554431) {
  i1 = i1 >> 5;
  i1 = i1 >>> 0 < i4 >>> 0 ? i4 : i1;
  i3 = (HEAP32[i11 >> 2] | 0) - i3 >> 6;
  if (!i1) {
   i7 = 0;
   i8 = 0;
  } else i6 = 10;
 } else {
  i1 = 67108863;
  i3 = (HEAP32[i11 >> 2] | 0) - i3 >> 6;
  i6 = 10;
 }
 if ((i6 | 0) == 10) {
  i7 = i1;
  i8 = __Znwj(i1 << 6) | 0;
 }
 i1 = i8 + (i3 << 6) | 0;
 i4 = i1;
 do {
  if (!i4) i4 = 0; else {
   i5 = i4 + 0 | 0;
   i6 = i5 + 64 | 0;
   do {
    HEAP32[i5 >> 2] = 0;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) < (i6 | 0));
  }
  i4 = i4 + 64 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i7 = i8 + (i7 << 6) | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  i6 = i5 + -64 - i2 | 0;
  while (1) {
   i13 = i5;
   i5 = i5 + -64 | 0;
   HEAP32[i1 + -64 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + -60 >> 2] = HEAP32[i13 + -60 >> 2];
   HEAP32[i1 + -56 >> 2] = HEAP32[i13 + -56 >> 2];
   HEAP32[i1 + -52 >> 2] = HEAP32[i13 + -52 >> 2];
   HEAP32[i1 + -48 >> 2] = HEAP32[i13 + -48 >> 2];
   HEAP32[i1 + -44 >> 2] = HEAP32[i13 + -44 >> 2];
   HEAP32[i1 + -40 >> 2] = HEAP32[i13 + -40 >> 2];
   HEAP32[i1 + -36 >> 2] = HEAP32[i13 + -36 >> 2];
   HEAP32[i1 + -32 >> 2] = HEAP32[i13 + -32 >> 2];
   HEAP32[i1 + -28 >> 2] = HEAP32[i13 + -28 >> 2];
   HEAP32[i1 + -24 >> 2] = HEAP32[i13 + -24 >> 2];
   HEAP32[i1 + -20 >> 2] = HEAP32[i13 + -20 >> 2];
   HEAP32[i1 + -16 >> 2] = HEAP32[i13 + -16 >> 2];
   HEAP32[i1 + -12 >> 2] = HEAP32[i13 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i13 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i13 + -4 >> 2];
   if ((i5 | 0) == (i2 | 0)) break; else i1 = i1 + -64 | 0;
  }
  i1 = i8 + (i3 + ~(i6 >>> 6) << 6) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i9 >> 2] = i7;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i12;
 return;
}

function __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE8__appendEj(i11, i4) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 i10 = i11 + 8 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1;
 if (((i5 - i2 | 0) / 56 | 0) >>> 0 >= i4 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    HEAP32[i1 >> 2] = 1124007936;
    i3 = i1 + 8 | 0;
    i2 = i1 + 40 | 0;
    i6 = i1 + 4 | 0;
    i7 = i6 + 36 | 0;
    do {
     HEAP32[i6 >> 2] = 0;
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) < (i7 | 0));
    HEAP32[i2 >> 2] = i3;
    i10 = i1 + 48 | 0;
    HEAP32[i1 + 44 >> 2] = i10;
    HEAP32[i1 + 52 >> 2] = 0;
    HEAP32[i10 >> 2] = 0;
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i1 = i1 + 56 | 0;
   HEAP32[i12 >> 2] = i1;
   i4 = i4 + -1 | 0;
  } while ((i4 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i3 = HEAP32[i11 >> 2] | 0;
 i2 = ((i2 - i3 | 0) / 56 | 0) + i4 | 0;
 if (i2 >>> 0 > 76695844) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i1 = i3;
 i3 = (i5 - i1 | 0) / 56 | 0;
 if (i3 >>> 0 < 38347922) {
  i3 = i3 << 1;
  i3 = i3 >>> 0 < i2 >>> 0 ? i2 : i3;
  i2 = ((HEAP32[i12 >> 2] | 0) - i1 | 0) / 56 | 0;
  if (!i3) {
   i9 = 0;
   i1 = 0;
   i3 = i2;
  } else i8 = 10;
 } else {
  i3 = 76695844;
  i2 = ((HEAP32[i12 >> 2] | 0) - i1 | 0) / 56 | 0;
  i8 = 10;
 }
 if ((i8 | 0) == 10) {
  i9 = i3;
  i1 = __Znwj(i3 * 56 | 0) | 0;
  i3 = i2;
 }
 i8 = i1 + (i3 * 56 | 0) | 0;
 i3 = i8;
 do {
  if (!i3) i3 = 0; else {
   HEAP32[i3 >> 2] = 1124007936;
   i5 = i3 + 8 | 0;
   i2 = i3 + 40 | 0;
   i6 = i3 + 4 | 0;
   i7 = i6 + 36 | 0;
   do {
    HEAP32[i6 >> 2] = 0;
    i6 = i6 + 4 | 0;
   } while ((i6 | 0) < (i7 | 0));
   HEAP32[i2 >> 2] = i5;
   i7 = i3 + 48 | 0;
   HEAP32[i3 + 44 >> 2] = i7;
   HEAP32[i3 + 52 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
  i3 = i3 + 56 | 0;
  i4 = i4 + -1 | 0;
 } while ((i4 | 0) != 0);
 i5 = i1 + (i9 * 56 | 0) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i8;
  do {
   i4 = i4 + -56 | 0;
   i2 = i2 + -56 | 0;
   __ZN2cv3MatC2ERKS0_(i4, i2);
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  HEAP32[i11 >> 2] = i4;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i10 >> 2] = i5;
  if ((i2 | 0) != (i1 | 0)) do {
   i10 = i2;
   i2 = i2 + -56 | 0;
   __ZN2cv3Mat7releaseEv(i2);
   i3 = HEAP32[i10 + -12 >> 2] | 0;
   if ((i3 | 0) != (i10 + -8 | 0)) __ZN2cv8fastFreeEPv(i3);
  } while ((i2 | 0) != (i1 | 0));
 } else {
  HEAP32[i11 >> 2] = i8;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i10 >> 2] = i5;
 }
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i13;
 return;
}

function __ZNK2cv10MatOp_GEMM6assignERKNS_7MatExprERNS_3MatEi(i1, i10, i11, i9) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0, d18 = 0.0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i14 = i16 + 104 | 0;
 i4 = i16 + 80 | 0;
 i5 = i16 + 60 | 0;
 i6 = i16 + 40 | 0;
 i7 = i16 + 20 | 0;
 i8 = i16;
 HEAP32[i14 >> 2] = 1124007936;
 i15 = i14 + 4 | 0;
 i2 = i14 + 8 | 0;
 i12 = i14 + 40 | 0;
 i1 = i15 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i12 >> 2] = i2;
 i13 = i14 + 48 | 0;
 i3 = i14 + 44 | 0;
 HEAP32[i3 >> 2] = i13;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 if ((i9 | 0) != -1 ? (HEAP32[i10 + 8 >> 2] & 4095 | 0) != (i9 | 0) : 0) i2 = i14; else i2 = i11;
 HEAP32[i4 >> 2] = 32088;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 16842752;
 HEAP32[i4 + 8 >> 2] = i10 + 8;
 HEAP32[i5 >> 2] = 32088;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 16842752;
 HEAP32[i5 + 8 >> 2] = i10 + 64;
 d18 = +HEAPF64[i10 + 176 >> 3];
 HEAP32[i6 >> 2] = 32088;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 16842752;
 HEAP32[i6 + 8 >> 2] = i10 + 120;
 d17 = +HEAPF64[i10 + 184 >> 3];
 i1 = i7 + 4 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i7 >> 2] = 32232;
 HEAP32[i1 >> 2] = 33619968;
 HEAP32[i7 + 8 >> 2] = i2;
 __ZN2cv4gemmERKNS_11_InputArrayES2_dS2_dRKNS_12_OutputArrayEi(i4, i5, d18, i6, d17, i7, HEAP32[i10 + 4 >> 2] | 0);
 if ((HEAP32[i2 + 16 >> 2] | 0) != (HEAP32[i11 + 16 >> 2] | 0)) {
  i10 = i8 + 4 | 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAP32[i8 >> 2] = 32232;
  HEAP32[i10 >> 2] = 33619968;
  HEAP32[i8 + 8 >> 2] = i11;
  __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i2, i8, i9, 1.0, 0.0);
 }
 i2 = i14 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
 HEAP32[i2 >> 2] = 0;
 i10 = i14 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i15 >> 2] | 0) > 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i15 >> 2] | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i16;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i16;
 return;
}

function __ZNK2cv3Mat7getUMatEiNS_14UMatUsageFlagsE(i13, i14, i3, i4) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 HEAP32[i13 >> 2] = 1124007936;
 i2 = i13 + 4 | 0;
 i9 = i13 + 8 | 0;
 i10 = i13 + 24 | 0;
 i11 = i13 + 28 | 0;
 i8 = i13 + 32 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i8 >> 2] = i9;
 i12 = i13 + 40 | 0;
 i6 = i13 + 36 | 0;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 i12 = i14 + 16 | 0;
 if (!(HEAP32[i12 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i14 + 36 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i14 + 32 >> 2] | 0;
  i7 = __ZN2cv3Mat15getStdAllocatorEv() | 0;
  i1 = (i1 | 0) == 0 ? i7 : i1;
  i1 = FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 15](i1, HEAP32[i14 + 4 >> 2] | 0, HEAP32[i14 + 40 >> 2] | 0, HEAP32[i14 >> 2] & 4095, HEAP32[i12 >> 2] | 0, HEAP32[i14 + 44 >> 2] | 0, i3, i4) | 0;
  HEAP32[i1 + 12 >> 2] = 1;
 }
 i7 = __ZN2cv3Mat15getStdAllocatorEv() | 0;
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] & 7](i7, i1, i3, i4) | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 __ZN2cvL7setSizeERNS_4UMatEiPKiPKjb(i13, HEAP32[i14 + 4 >> 2] | 0, HEAP32[i14 + 40 >> 2] | 0, HEAP32[i14 + 44 >> 2] | 0, 0);
 i7 = HEAP32[i2 >> 2] | 0;
 L7 : do if ((i7 | 0) > 0) {
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = 0;
  while (1) {
   i3 = i4 + 1 | 0;
   if ((HEAP32[i2 + (i4 << 2) >> 2] | 0) > 1) {
    i3 = i4;
    break L7;
   }
   if ((i3 | 0) < (i7 | 0)) i4 = i3; else break;
  }
 } else i3 = 0; while (0);
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = i7;
 do {
  i4 = i6;
  i6 = i6 + -1 | 0;
  if ((i6 | 0) <= (i3 | 0)) {
   i15 = 10;
   break;
  }
  i2 = HEAP32[i8 >> 2] | 0;
  i17 = Math_imul(HEAP32[i2 + (i6 << 2) >> 2] | 0, HEAP32[i5 + (i6 << 2) >> 2] | 0) | 0;
 } while (i17 >>> 0 >= (HEAP32[i5 + (i4 + -2 << 2) >> 2] | 0) >>> 0);
 if ((i15 | 0) == 10) i2 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i5 = ___muldi3(i8 | 0, ((i8 | 0) < 0) << 31 >> 31 | 0, HEAP32[i5 >> 2] | 0, 0) | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = (i6 | 0) <= (i3 | 0) & ((i5 | 0) == (i5 | 0) & (tempRet0 | 0) == 0) ? i8 | 16384 : i8 & -16385;
 if ((i7 | 0) > 2) {
  HEAP32[i13 + 12 >> 2] = -1;
  HEAP32[i9 >> 2] = -1;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = (HEAP32[i12 >> 2] | 0) - (HEAP32[i14 + 20 >> 2] | 0);
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 i10 = i1 + 8 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 STACKTOP = i16;
 return;
}

function __ZL16icvYMLSkipSpacesP13CvFileStoragePcii(i12, i1, i15) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i16 = i18;
 i11 = i18 + 16 | 0;
 i13 = i12 + 60 | 0;
 i14 = i12 + 88 | 0;
 i4 = i12 + 80 | 0;
 i5 = i12 + 76 | 0;
 i6 = i12 + 256 | 0;
 i7 = i12 + 64 | 0;
 i8 = i12 + 68 | 0;
 i9 = i12 + 264 | 0;
 i10 = i12 + 260 | 0;
 L1 : while (1) {
  L3 : while (1) {
   i2 = HEAP8[i1 >> 0] | 0;
   while (1) {
    if (i2 << 24 >> 24 == 32) {
     i17 = 5;
     break L3;
    } else if (i2 << 24 >> 24 != 35) break;
    HEAP8[i1 >> 0] = 0;
    i2 = 0;
   }
   if ((i2 & 255) > 31) break L1;
   if (i2 << 24 >> 24 == 13 | i2 << 24 >> 24 == 10 | i2 << 24 >> 24 == 0) break;
   i19 = HEAP32[i14 >> 2] | 0;
   HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i16 + 4 >> 2] = i19;
   HEAP32[i16 + 8 >> 2] = i2 << 24 >> 24 == 9 ? 15552 : 14984;
   _sprintf(i11, 17440, i16) | 0;
   _cvError(-212, 15480, i11, 8960, 991);
  }
  if ((i17 | 0) == 5) {
   i17 = 0;
   i1 = i1 + 1 | 0;
   continue;
  }
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = __ZL7icvGetsP13CvFileStoragePci(i12, i1, (HEAP32[i4 >> 2] | 0) - i1 | 0) | 0;
  if (!i1) {
   i17 = 12;
   break;
  }
  i2 = HEAP8[i1 + ((_strlen(i1 | 0) | 0) + -1) >> 0] | 0;
  do if (!(i2 << 24 >> 24 == 13 | i2 << 24 >> 24 == 10)) {
   do if (!(HEAP32[i6 >> 2] | 0)) {
    i2 = HEAP32[i7 >> 2] | 0;
    if (i2) {
     i3 = _feof(i2 | 0) | 0;
     i17 = 20;
     break;
    }
    i2 = HEAP32[i8 >> 2] | 0;
    if (i2) {
     i3 = _gzeof(i2) | 0;
     i17 = 20;
    }
   } else {
    i3 = (HEAP32[i9 >> 2] | 0) >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0 & 1;
    i17 = 20;
   } while (0);
   if ((i17 | 0) == 20 ? (i17 = 0, (i3 | 0) != 0) : 0) break;
   i2 = HEAP32[i14 >> 2] | 0;
   HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i16 + 4 >> 2] = i2;
   HEAP32[i16 + 8 >> 2] = 15504;
   _sprintf(i11, 17440, i16) | 0;
   _cvError(-212, 15480, i11, 8960, 985);
  } while (0);
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
 }
 if ((i17 | 0) == 12) {
  i10 = HEAP32[i5 >> 2] | 0;
  HEAP8[i10 + 2 >> 0] = 46;
  HEAP8[i10 + 1 >> 0] = 46;
  HEAP8[i10 >> 0] = 46;
  HEAP8[i10 + 3 >> 0] = 0;
  HEAP32[i12 + 92 >> 2] = 1;
  STACKTOP = i18;
  return i10 | 0;
 }
 if ((i1 - (HEAP32[i5 >> 2] | 0) | 0) >= (i15 | 0)) {
  i10 = i1;
  STACKTOP = i18;
  return i10 | 0;
 }
 i10 = HEAP32[i14 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i16 + 4 >> 2] = i10;
 HEAP32[i16 + 8 >> 2] = 15232;
 _sprintf(i11, 17440, i16) | 0;
 _cvError(-212, 15480, i11, 8960, 965);
 i10 = i1;
 STACKTOP = i18;
 return i10 | 0;
}

function __ZN2cvL14addWeighted16sEPKsjS1_jPsjNS_5Size_IiEEPv(i7, i3, i6, i4, i8, i5, i1, i2) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, f21 = f0;
 i20 = STACKTOP;
 i19 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 f17 = Math_fround(+HEAPF64[i2 >> 3]);
 f18 = Math_fround(+HEAPF64[i2 + 8 >> 3]);
 f16 = Math_fround(+HEAPF64[i2 + 16 >> 3]);
 i15 = i3 >>> 1;
 i14 = i4 >>> 1;
 i10 = i5 >>> 1;
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 i11 = i19 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i13 = (i11 | 0) > 3 ? i19 & -4 : 4;
 while (1) {
  i1 = i1 + -1 | 0;
  if (i12) i5 = 0; else {
   i9 = 0;
   do {
    f21 = Math_fround(f17 * Math_fround(HEAP16[i7 + (i9 << 1) >> 1] | 0));
    i5 = _lrint(+Math_fround(f16 + Math_fround(f21 + Math_fround(f18 * Math_fround(HEAP16[i6 + (i9 << 1) >> 1] | 0))))) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i3 = i9 | 1;
    f21 = Math_fround(f17 * Math_fround(HEAP16[i7 + (i3 << 1) >> 1] | 0));
    i4 = _lrint(+Math_fround(f16 + Math_fround(f21 + Math_fround(f18 * Math_fround(HEAP16[i6 + (i3 << 1) >> 1] | 0))))) | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i9 << 1) >> 1] = i5;
    HEAP16[i8 + (i3 << 1) >> 1] = i4;
    i2 = i9 | 2;
    f21 = Math_fround(f17 * Math_fround(HEAP16[i7 + (i2 << 1) >> 1] | 0));
    i5 = _lrint(+Math_fround(f16 + Math_fround(f21 + Math_fround(f18 * Math_fround(HEAP16[i6 + (i2 << 1) >> 1] | 0))))) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i3 = i9 | 3;
    f21 = Math_fround(f17 * Math_fround(HEAP16[i7 + (i3 << 1) >> 1] | 0));
    i4 = _lrint(+Math_fround(f16 + Math_fround(f21 + Math_fround(f18 * Math_fround(HEAP16[i6 + (i3 << 1) >> 1] | 0))))) | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i2 << 1) >> 1] = i5;
    HEAP16[i8 + (i3 << 1) >> 1] = i4;
    i9 = i9 + 4 | 0;
   } while ((i9 | 0) <= (i11 | 0));
   i5 = i13;
  }
  if ((i5 | 0) < (i19 | 0)) do {
   f21 = Math_fround(f17 * Math_fround(HEAP16[i7 + (i5 << 1) >> 1] | 0));
   i4 = _lrint(+Math_fround(f16 + Math_fround(f21 + Math_fround(f18 * Math_fround(HEAP16[i6 + (i5 << 1) >> 1] | 0))))) | 0;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i19 | 0));
  if (!i1) break; else {
   i6 = i6 + (i14 << 1) | 0;
   i7 = i7 + (i15 << 1) | 0;
   i8 = i8 + (i10 << 1) | 0;
  }
 }
 STACKTOP = i20;
 return;
}

function __ZL14icvReadSeqTreeP13CvFileStorageP10CvFileNode(i17, i1) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i18 = i20 + 16 | 0;
 i2 = i20 + 8 | 0;
 i16 = i20;
 i1 = _cvGetFileNodeByName(i17, i1, 13320) | 0;
 if (!((i1 | 0) != 0 ? (HEAP32[i1 >> 2] & 7 | 0) == 5 : 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i2, 90) | 0) + 0 | 0;
  i5 = 13336 | 0;
  i6 = i4 + 90 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-212, i2, 13432, 8960, 4336);
  __ZN2cv6String10deallocateEv(i2);
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i13 = HEAP32[i1 + 24 >> 2] | 0;
 _cvStartReadSeq(i1, i18, 0);
 if ((i13 | 0) <= 0) {
  i10 = 0;
  STACKTOP = i20;
  return i10 | 0;
 }
 i14 = i18 + 12 | 0;
 i15 = i16 + 4 | 0;
 i8 = i1 + 28 | 0;
 i9 = i18 + 20 | 0;
 i10 = 0;
 i2 = 0;
 i7 = 0;
 i11 = 0;
 i12 = 0;
 while (1) {
  i3 = HEAP32[i14 >> 2] | 0;
  i1 = i11;
  i11 = _cvRead(i17, i3, 0) | 0;
  i3 = _cvGetFileNodeByName(i17, i3, 13448) | 0;
  do if (i3) {
   i4 = HEAP32[i3 >> 2] & 7;
   if ((i4 | 0) == 2) i3 = _lrint(+HEAPF64[i3 + 8 >> 3]) | 0; else if ((i4 | 0) == 1) i3 = HEAP32[i3 + 8 >> 2] | 0; else {
    i3 = 2147483647;
    break;
   }
   if ((i3 | 0) < 0) i19 = 11;
  } else {
   i3 = -1;
   i19 = 11;
  } while (0);
  if ((i19 | 0) == 11) {
   i19 = 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i15 >> 2] = 0;
   i4 = (__ZN2cv6String8allocateEj(i16, 56) | 0) + 0 | 0;
   i5 = 13456 | 0;
   i6 = i4 + 56 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i4 | 0) < (i6 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-212, i16, 13432, 8960, 4350);
   __ZN2cv6String10deallocateEv(i16);
  }
  i12 = (i12 | 0) == 0 ? i11 : i12;
  if ((i3 | 0) <= (i7 | 0)) {
   if ((i3 | 0) < (i7 | 0)) {
    i4 = i7;
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i4 | 0) > (i3 | 0)) {
      i4 = i4 + -1 | 0;
      i1 = i2;
     } else break;
    }
   }
   HEAP32[i11 + 8 >> 2] = i1;
   if (i1) HEAP32[i1 + 12 >> 2] = i11;
  } else {
   if (i1) HEAP32[i1 + 20 >> 2] = i11;
   HEAP32[i11 + 8 >> 2] = 0;
   i2 = i1;
  }
  HEAP32[i11 + 16 >> 2] = i2;
  i7 = (HEAP32[i14 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) | 0;
  HEAP32[i14 >> 2] = i7;
  if (i7 >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) _cvChangeSeqBlock(i18, 1);
  i10 = i10 + 1 | 0;
  if ((i10 | 0) >= (i13 | 0)) break; else i7 = i3;
 }
 i10 = i12;
 STACKTOP = i20;
 return i10 | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i8, i9, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i10 = 0;
 i7 = STACKTOP;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (i1) {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i6 >> 2] = 0;
   i1 = 1;
   break;
  } else {
   i1 = (HEAP32[i6 >> 2] | 0) == 0;
   break;
  }
 } else i1 = 1; while (0);
 i3 = HEAP32[i8 >> 2] | 0;
 do if (i3) {
  i2 = HEAP32[i3 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0; else i2 = HEAP32[i2 >> 2] | 0;
  if ((i2 | 0) != -1) if (i1) {
   i4 = i3;
   break;
  } else {
   i10 = 16;
   break;
  } else {
   HEAP32[i8 >> 2] = 0;
   i10 = 14;
   break;
  }
 } else i10 = 14; while (0);
 if ((i10 | 0) == 14) if (i1) i10 = 16; else i4 = 0;
 if ((i10 | 0) == 16) {
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 6;
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
 if ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] & 63](i5, i1, 0) | 0) << 24 >> 24 != 37) {
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 4;
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = i2 + 12 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
  FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else HEAP32[i1 >> 2] = i3 + 4;
 do if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i6 >> 2] = 0;
   i2 = 1;
   break;
  } else {
   i2 = (HEAP32[i6 >> 2] | 0) == 0;
   break;
  }
 } else i2 = 1; while (0);
 do if (i4) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 127](i4) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i8 >> 2] = 0;
   i10 = 38;
   break;
  }
  if (i2) {
   STACKTOP = i7;
   return;
  }
 } else i10 = 38; while (0);
 if ((i10 | 0) == 38 ? !i2 : 0) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 2;
 STACKTOP = i7;
 return;
}

function __ZN2cvL8merge16uEPPKtPtii(i12, i10, i11, i9) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 i13 = STACKTOP;
 i7 = (i9 | 0) % 4 | 0;
 i7 = (i7 | 0) == 0 ? 4 : i7;
 do if ((i7 | 0) == 2) {
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  if ((i11 | 0) > 0) {
   i1 = 0;
   i4 = 0;
   while (1) {
    HEAP16[i10 + (i4 << 1) >> 1] = HEAP16[i3 + (i1 << 1) >> 1] | 0;
    HEAP16[i10 + (i4 + 1 << 1) >> 1] = HEAP16[i2 + (i1 << 1) >> 1] | 0;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i11 | 0)) break; else i4 = i4 + i9 | 0;
   }
  }
 } else if ((i7 | 0) == 1) {
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i11 | 0) > 0) {
   i2 = 0;
   i3 = 0;
   while (1) {
    HEAP16[i10 + (i3 << 1) >> 1] = HEAP16[i1 + (i2 << 1) >> 1] | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i11 | 0)) break; else i3 = i3 + i9 | 0;
   }
  }
 } else {
  i6 = HEAP32[i12 >> 2] | 0;
  i5 = HEAP32[i12 + 4 >> 2] | 0;
  i1 = HEAP32[i12 + 8 >> 2] | 0;
  if ((i7 | 0) == 3) {
   if ((i11 | 0) > 0) {
    i4 = 0;
    i3 = 0;
   } else break;
   while (1) {
    HEAP16[i10 + (i3 << 1) >> 1] = HEAP16[i6 + (i4 << 1) >> 1] | 0;
    HEAP16[i10 + (i3 + 1 << 1) >> 1] = HEAP16[i5 + (i4 << 1) >> 1] | 0;
    HEAP16[i10 + (i3 + 2 << 1) >> 1] = HEAP16[i1 + (i4 << 1) >> 1] | 0;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i11 | 0)) break; else i3 = i3 + i9 | 0;
   }
  } else {
   i4 = HEAP32[i12 + 12 >> 2] | 0;
   if ((i11 | 0) > 0) {
    i3 = 0;
    i2 = 0;
   } else break;
   while (1) {
    HEAP16[i10 + (i2 << 1) >> 1] = HEAP16[i6 + (i3 << 1) >> 1] | 0;
    HEAP16[i10 + (i2 + 1 << 1) >> 1] = HEAP16[i5 + (i3 << 1) >> 1] | 0;
    HEAP16[i10 + (i2 + 2 << 1) >> 1] = HEAP16[i1 + (i3 << 1) >> 1] | 0;
    HEAP16[i10 + (i2 + 3 << 1) >> 1] = HEAP16[i4 + (i3 << 1) >> 1] | 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i11 | 0)) break; else i2 = i2 + i9 | 0;
   }
  }
 } while (0);
 if ((i7 | 0) >= (i9 | 0)) {
  STACKTOP = i13;
  return;
 }
 i8 = (i11 | 0) > 0;
 do {
  i4 = HEAP32[i12 + (i7 << 2) >> 2] | 0;
  i3 = HEAP32[i12 + (i7 + 1 << 2) >> 2] | 0;
  i2 = HEAP32[i12 + (i7 + 2 << 2) >> 2] | 0;
  i1 = HEAP32[i12 + (i7 + 3 << 2) >> 2] | 0;
  if (i8) {
   i5 = 0;
   i6 = i7;
   while (1) {
    HEAP16[i10 + (i6 << 1) >> 1] = HEAP16[i4 + (i5 << 1) >> 1] | 0;
    HEAP16[i10 + (i6 + 1 << 1) >> 1] = HEAP16[i3 + (i5 << 1) >> 1] | 0;
    HEAP16[i10 + (i6 + 2 << 1) >> 1] = HEAP16[i2 + (i5 << 1) >> 1] | 0;
    HEAP16[i10 + (i6 + 3 << 1) >> 1] = HEAP16[i1 + (i5 << 1) >> 1] | 0;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i11 | 0)) break; else i6 = i6 + i9 | 0;
   }
  }
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 STACKTOP = i13;
 return;
}

function __ZNK12_GLOBAL__N_124CLAHE_Interpolation_BodyItEclERKN2cv5RangeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, f34 = f0;
 i29 = STACKTOP;
 f28 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i2 + 176 >> 2] | 0));
 i3 = HEAP32[i1 >> 2] | 0;
 i26 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i3 | 0) >= (i26 | 0)) {
  STACKTOP = i29;
  return;
 }
 i27 = HEAP32[i2 + 20 >> 2] | 0;
 i15 = HEAP32[HEAP32[i2 + 48 >> 2] >> 2] | 0;
 i16 = HEAP32[i2 + 76 >> 2] | 0;
 i17 = HEAP32[HEAP32[i2 + 104 >> 2] >> 2] | 0;
 i18 = (HEAP32[i2 + 184 >> 2] | 0) + -1 | 0;
 i19 = HEAP32[i2 + 180 >> 2] | 0;
 i20 = HEAP32[i2 + 132 >> 2] | 0;
 i21 = HEAP32[HEAP32[i2 + 160 >> 2] >> 2] | 0;
 i22 = HEAP32[i2 + 16 >> 2] | 0;
 i23 = i2 + 1252 | 0;
 i24 = i2 + 1256 | 0;
 i25 = i2 + 1264 | 0;
 i14 = i2 + 1260 | 0;
 if ((i22 | 0) <= 0) {
  STACKTOP = i29;
  return;
 }
 do {
  i1 = i27 + (Math_imul(i15, i3) | 0) | 0;
  i12 = i16 + (Math_imul(i17, i3) | 0) | 0;
  f11 = Math_fround(Math_fround(f28 * Math_fround(i3 | 0)) + Math_fround(-.5));
  i6 = ~~f11;
  i6 = i6 - (+(i6 | 0) > +f11 & 1) | 0;
  i10 = i6 + 1 | 0;
  f11 = Math_fround(f11 - Math_fround(i6 | 0));
  f9 = Math_fround(Math_fround(1.0) - f11);
  i6 = i20 + (Math_imul(Math_imul(i19, (i6 | 0) < 0 ? 0 : i6) | 0, i21) | 0) | 0;
  i10 = i20 + (Math_imul(Math_imul((i18 | 0) < (i10 | 0) ? i18 : i10, i19) | 0, i21) | 0) | 0;
  i4 = HEAP32[i23 >> 2] | 0;
  i5 = HEAP32[i24 >> 2] | 0;
  i7 = HEAP32[i25 >> 2] | 0;
  i8 = HEAP32[i14 >> 2] | 0;
  i13 = 0;
  do {
   i2 = HEAPU16[i1 + (i13 << 1) >> 1] | 0;
   i33 = (HEAP32[i4 + (i13 << 2) >> 2] | 0) + i2 | 0;
   i2 = (HEAP32[i5 + (i13 << 2) >> 2] | 0) + i2 | 0;
   f34 = Math_fround(HEAPU16[i6 + (i33 << 1) >> 1] | 0 | 0);
   f31 = Math_fround(HEAPF32[i7 + (i13 << 2) >> 2]);
   f34 = Math_fround(f34 * f31);
   f32 = Math_fround(HEAPU16[i6 + (i2 << 1) >> 1] | 0 | 0);
   f30 = Math_fround(HEAPF32[i8 + (i13 << 2) >> 2]);
   f32 = Math_fround(f9 * Math_fround(f34 + Math_fround(f32 * f30)));
   f31 = Math_fround(f31 * Math_fround(HEAPU16[i10 + (i33 << 1) >> 1] | 0 | 0));
   i2 = _lrint(+Math_fround(f32 + Math_fround(f11 * Math_fround(f31 + Math_fround(f30 * Math_fround(HEAPU16[i10 + (i2 << 1) >> 1] | 0 | 0)))))) | 0;
   if (i2 >>> 0 >= 65536) i2 = (i2 | 0) > 0 ? 65535 : 0;
   HEAP16[i12 + (i13 << 1) >> 1] = i2;
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) < (i22 | 0));
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i26 | 0));
 STACKTOP = i29;
 return;
}

function __ZN2cv10HdrDecoder8readDataERNS_3MatE(i6, i10) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i5 = i17 + 96 | 0;
 i14 = i17 + 40 | 0;
 i8 = i17 + 20 | 0;
 i9 = i17;
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i14 >> 2] = 1124007936;
 i16 = i14 + 4 | 0;
 i7 = i14 + 8 | 0;
 i13 = i14 + 40 | 0;
 i3 = i16 + 0 | 0;
 i2 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 HEAP32[i13 >> 2] = i7;
 i15 = i14 + 48 | 0;
 i12 = i14 + 44 | 0;
 HEAP32[i12 >> 2] = i15;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i4;
 __ZN2cv3Mat6createEiPKii(i14, 2, i5, 21);
 i2 = i6 + 100 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 127](i6) | 0) {
  i3 = HEAP32[i2 >> 2] | 0;
  i11 = 4;
 } else i3 = 0; else i11 = 4;
 do if ((i11 | 0) == 4) {
  __Z19RGBE_ReadPixels_RLEP8_IO_FILEPfii(i3, HEAP32[i14 + 16 >> 2] | 0, HEAP32[i14 + 12 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  _fclose(HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = 0;
  i2 = HEAP32[i10 >> 2] | 0;
  if (!((HEAP32[i14 >> 2] ^ i2) & 7)) {
   i3 = i8 + 4 | 0;
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i8 >> 2] = 32232;
   HEAP32[i3 >> 2] = 33619968;
   HEAP32[i8 + 8 >> 2] = i10;
   __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i14, i8, i2 & 4095, 1.0, 0.0);
   i3 = 1;
   break;
  } else {
   i3 = i9 + 4 | 0;
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i9 >> 2] = 32232;
   HEAP32[i3 >> 2] = 33619968;
   HEAP32[i9 + 8 >> 2] = i10;
   __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i14, i9, i2 & 4095, 255.0, 0.0);
   i3 = 1;
   break;
  }
 } while (0);
 i2 = i14 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
 HEAP32[i2 >> 2] = 0;
 i10 = i14 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i16 >> 2] | 0) > 0) {
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i16 >> 2] | 0));
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i15 | 0)) {
  STACKTOP = i17;
  return i3 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i17;
 return i3 | 0;
}

function _longest_match(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 i8 = HEAP32[i3 + 124 >> 2] | 0;
 i14 = HEAP32[i3 + 56 >> 2] | 0;
 i20 = HEAP32[i3 + 108 >> 2] | 0;
 i21 = i14 + i20 | 0;
 i7 = HEAP32[i3 + 120 >> 2] | 0;
 i10 = HEAP32[i3 + 144 >> 2] | 0;
 i9 = (HEAP32[i3 + 44 >> 2] | 0) + -262 | 0;
 i9 = i20 >>> 0 > i9 >>> 0 ? i20 - i9 | 0 : 0;
 i11 = HEAP32[i3 + 64 >> 2] | 0;
 i12 = HEAP32[i3 + 52 >> 2] | 0;
 i13 = i14 + (i20 + 258) | 0;
 i22 = HEAP32[i3 + 116 >> 2] | 0;
 i10 = i10 >>> 0 > i22 >>> 0 ? i22 : i10;
 i15 = i3 + 112 | 0;
 i16 = i14 + (i20 + 1) | 0;
 i17 = i14 + (i20 + 2) | 0;
 i18 = i13;
 i19 = i20 + 257 | 0;
 i1 = i7;
 i8 = i7 >>> 0 < (HEAP32[i3 + 140 >> 2] | 0) >>> 0 ? i8 : i8 >>> 2;
 i4 = HEAP8[i14 + (i7 + i20) >> 0] | 0;
 i7 = HEAP8[i14 + (i20 + -1 + i7) >> 0] | 0;
 while (1) {
  i3 = i14 + i2 | 0;
  if ((((HEAP8[i14 + (i2 + i1) >> 0] | 0) == i4 << 24 >> 24 ? (HEAP8[i14 + (i1 + -1 + i2) >> 0] | 0) == i7 << 24 >> 24 : 0) ? (HEAP8[i3 >> 0] | 0) == (HEAP8[i21 >> 0] | 0) : 0) ? (HEAP8[i14 + (i2 + 1) >> 0] | 0) == (HEAP8[i16 >> 0] | 0) : 0) {
   i6 = i14 + (i2 + 2) | 0;
   i5 = i17;
   while (1) {
    i3 = i5 + 1 | 0;
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i6 + 1 >> 0] | 0)) break;
    i3 = i5 + 2 | 0;
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i6 + 2 >> 0] | 0)) break;
    i3 = i5 + 3 | 0;
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i6 + 3 >> 0] | 0)) break;
    i3 = i5 + 4 | 0;
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i6 + 4 >> 0] | 0)) break;
    i3 = i5 + 5 | 0;
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i6 + 5 >> 0] | 0)) break;
    i3 = i5 + 6 | 0;
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i6 + 6 >> 0] | 0)) break;
    i3 = i5 + 7 | 0;
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i6 + 7 >> 0] | 0)) break;
    i3 = i5 + 8 | 0;
    i6 = i6 + 8 | 0;
    if (!(i3 >>> 0 < i13 >>> 0 ? (HEAP8[i3 >> 0] | 0) == (HEAP8[i6 >> 0] | 0) : 0)) break; else i5 = i3;
   }
   i5 = i3 - i18 | 0;
   i3 = i5 + 258 | 0;
   if ((i3 | 0) > (i1 | 0)) {
    HEAP32[i15 >> 2] = i2;
    if ((i3 | 0) >= (i10 | 0)) {
     i1 = i3;
     i2 = 20;
     break;
    }
    i1 = i3;
    i4 = HEAP8[i14 + (i3 + i20) >> 0] | 0;
    i3 = HEAP8[i14 + (i19 + i5) >> 0] | 0;
   } else i3 = i7;
  } else i3 = i7;
  i2 = HEAPU16[i11 + ((i2 & i12) << 1) >> 1] | 0;
  if (i2 >>> 0 <= i9 >>> 0) {
   i2 = 20;
   break;
  }
  i8 = i8 + -1 | 0;
  if (!i8) {
   i2 = 20;
   break;
  } else i7 = i3;
 }
 if ((i2 | 0) == 20) {
  STACKTOP = i23;
  return (i1 >>> 0 > i22 >>> 0 ? i22 : i1) | 0;
 }
 return 0;
}

function __ZNSt3__110__stdinbufIcE9__getcharEb(i13, i17) {
 i13 = i13 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i18 = i19 + 16 | 0;
 i16 = i19 + 8 | 0;
 i11 = i19 + 4 | 0;
 i12 = i19;
 i3 = i13 + 52 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  i1 = i13 + 48 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i17) {
   i10 = i2;
   STACKTOP = i19;
   return i10 | 0;
  }
  HEAP32[i1 >> 2] = -1;
  HEAP8[i3 >> 0] = 0;
  i10 = i2;
  STACKTOP = i19;
  return i10 | 0;
 }
 i5 = HEAP32[i13 + 44 >> 2] | 0;
 i5 = (i5 | 0) > 1 ? i5 : 1;
 L8 : do if ((i5 | 0) > 0) {
  i3 = i13 + 32 | 0;
  i4 = 0;
  while (1) {
   i1 = _getc(HEAP32[i3 >> 2] | 0) | 0;
   if ((i1 | 0) == -1) {
    i14 = -1;
    break;
   }
   HEAP8[i18 + i4 >> 0] = i1;
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i5 | 0)) break L8;
  }
  STACKTOP = i19;
  return i14 | 0;
 } while (0);
 L15 : do if (!(HEAP8[i13 + 53 >> 0] | 0)) {
  i7 = i13 + 40 | 0;
  i8 = i13 + 36 | 0;
  i9 = i16 + 1 | 0;
  i10 = i13 + 32 | 0;
  while (1) {
   i1 = HEAP32[i7 >> 2] | 0;
   i3 = i1;
   i4 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i20 = HEAP32[i8 >> 2] | 0;
   i6 = i18 + i5 | 0;
   i1 = FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i20 >> 2] | 0) + 16 >> 2] & 15](i20, i1, i18, i6, i11, i16, i9, i12) | 0;
   if ((i1 | 0) == 2) {
    i14 = -1;
    i1 = 23;
    break;
   } else if ((i1 | 0) == 3) {
    i1 = 14;
    break;
   } else if ((i1 | 0) != 1) {
    i2 = i5;
    break L15;
   }
   i1 = HEAP32[i7 >> 2] | 0;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i1 + 4 >> 2] = i3;
   if ((i5 | 0) == 8) {
    i14 = -1;
    i1 = 23;
    break;
   }
   i4 = _getc(HEAP32[i10 >> 2] | 0) | 0;
   if ((i4 | 0) == -1) {
    i14 = -1;
    i1 = 23;
    break;
   }
   HEAP8[i6 >> 0] = i4;
   i5 = i5 + 1 | 0;
  }
  if ((i1 | 0) == 14) {
   HEAP8[i16 >> 0] = HEAP8[i18 >> 0] | 0;
   i2 = i5;
   break;
  } else if ((i1 | 0) == 23) {
   STACKTOP = i19;
   return i14 | 0;
  }
 } else {
  HEAP8[i16 >> 0] = HEAP8[i18 >> 0] | 0;
  i2 = i5;
 } while (0);
 do if (!i17) {
  i1 = i13 + 32 | 0;
  while (1) {
   if ((i2 | 0) <= 0) {
    i1 = 21;
    break;
   }
   i2 = i2 + -1 | 0;
   if ((_ungetc(HEAPU8[i18 + i2 >> 0] | 0, HEAP32[i1 >> 2] | 0) | 0) == -1) {
    i14 = -1;
    i1 = 23;
    break;
   }
  }
  if ((i1 | 0) == 21) {
   i15 = HEAP8[i16 >> 0] | 0;
   break;
  } else if ((i1 | 0) == 23) {
   STACKTOP = i19;
   return i14 | 0;
  }
 } else {
  i15 = HEAP8[i16 >> 0] | 0;
  HEAP32[i13 + 48 >> 2] = i15 & 255;
 } while (0);
 i10 = i15 & 255;
 STACKTOP = i19;
 return i10 | 0;
}

function __ZN2cvL14addWeighted16uEPKtjS1_jPtjNS_5Size_IiEEPv(i7, i3, i6, i4, i8, i5, i1, i2) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, f21 = f0;
 i20 = STACKTOP;
 i19 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 f17 = Math_fround(+HEAPF64[i2 >> 3]);
 f18 = Math_fround(+HEAPF64[i2 + 8 >> 3]);
 f16 = Math_fround(+HEAPF64[i2 + 16 >> 3]);
 i15 = i3 >>> 1;
 i14 = i4 >>> 1;
 i10 = i5 >>> 1;
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 i11 = i19 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i13 = (i11 | 0) > 3 ? i19 & -4 : 4;
 while (1) {
  i1 = i1 + -1 | 0;
  if (i12) i5 = 0; else {
   i9 = 0;
   do {
    f21 = Math_fround(f17 * Math_fround(HEAPU16[i7 + (i9 << 1) >> 1] | 0 | 0));
    i5 = _lrint(+Math_fround(f16 + Math_fround(f21 + Math_fround(f18 * Math_fround(HEAPU16[i6 + (i9 << 1) >> 1] | 0 | 0))))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i3 = i9 | 1;
    f21 = Math_fround(f17 * Math_fround(HEAPU16[i7 + (i3 << 1) >> 1] | 0 | 0));
    i4 = _lrint(+Math_fround(f16 + Math_fround(f21 + Math_fround(f18 * Math_fround(HEAPU16[i6 + (i3 << 1) >> 1] | 0 | 0))))) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i9 << 1) >> 1] = i5;
    HEAP16[i8 + (i3 << 1) >> 1] = i4;
    i2 = i9 | 2;
    f21 = Math_fround(f17 * Math_fround(HEAPU16[i7 + (i2 << 1) >> 1] | 0 | 0));
    i5 = _lrint(+Math_fround(f16 + Math_fround(f21 + Math_fround(f18 * Math_fround(HEAPU16[i6 + (i2 << 1) >> 1] | 0 | 0))))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i3 = i9 | 3;
    f21 = Math_fround(f17 * Math_fround(HEAPU16[i7 + (i3 << 1) >> 1] | 0 | 0));
    i4 = _lrint(+Math_fround(f16 + Math_fround(f21 + Math_fround(f18 * Math_fround(HEAPU16[i6 + (i3 << 1) >> 1] | 0 | 0))))) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i2 << 1) >> 1] = i5;
    HEAP16[i8 + (i3 << 1) >> 1] = i4;
    i9 = i9 + 4 | 0;
   } while ((i9 | 0) <= (i11 | 0));
   i5 = i13;
  }
  if ((i5 | 0) < (i19 | 0)) do {
   f21 = Math_fround(f17 * Math_fround(HEAPU16[i7 + (i5 << 1) >> 1] | 0 | 0));
   i4 = _lrint(+Math_fround(f16 + Math_fround(f21 + Math_fround(f18 * Math_fround(HEAPU16[i6 + (i5 << 1) >> 1] | 0 | 0))))) | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i19 | 0));
  if (!i1) break; else {
   i6 = i6 + (i14 << 1) | 0;
   i7 = i7 + (i15 << 1) | 0;
   i8 = i8 + (i10 << 1) | 0;
  }
 }
 STACKTOP = i20;
 return;
}

function __ZNK2cv11_InputArray12isContinuousEi(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i6 = i9 + 16 | 0;
 i7 = i9 + 8 | 0;
 i3 = i9;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2) | 0;
 if ((i1 | 0) == 327680) {
  i2 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((((HEAP32[i2 + 4 >> 2] | 0) - i1 | 0) / 56 | 0) >>> 0 <= i8 >>> 0) {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i6, 21) | 0) + 0 | 0;
   i4 = 29320 | 0;
   i5 = i1 + 21 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i4 = i4 + 1 | 0;
   } while ((i1 | 0) < (i5 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i6, 29344, 27528, 1890);
   __ZN2cv6String10deallocateEv(i6);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  i1 = (HEAP32[i1 + (i8 * 56 | 0) >> 2] & 16384 | 0) != 0;
  STACKTOP = i9;
  return i1 | 0;
 } else if ((i1 | 0) == 0 | (i1 | 0) == 131072 | (i1 | 0) == 196608 | (i1 | 0) == 262144 | (i1 | 0) == 393216) {
  i1 = 1;
  STACKTOP = i9;
  return i1 | 0;
 } else if ((i1 | 0) == 720896) {
  i2 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((((HEAP32[i2 + 4 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0 <= i8 >>> 0) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i7, 21) | 0) + 0 | 0;
   i4 = 29320 | 0;
   i5 = i1 + 21 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i4 = i4 + 1 | 0;
   } while ((i1 | 0) < (i5 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 29344, 27528, 1897);
   __ZN2cv6String10deallocateEv(i7);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  i1 = (HEAP32[i1 + (i8 * 48 | 0) >> 2] & 16384 | 0) != 0;
  STACKTOP = i9;
  return i1 | 0;
 } else if ((i1 | 0) == 65536) {
  if ((i8 | 0) >= 0) {
   i1 = 1;
   STACKTOP = i9;
   return i1 | 0;
  }
  i1 = (HEAP32[HEAP32[i2 + 8 >> 2] >> 2] & 16384 | 0) != 0;
  STACKTOP = i9;
  return i1 | 0;
 } else if ((i1 | 0) == 655360) {
  if ((i8 | 0) >= 0) {
   i1 = 1;
   STACKTOP = i9;
   return i1 | 0;
  }
  i1 = (HEAP32[HEAP32[i2 + 8 >> 2] >> 2] & 16384 | 0) != 0;
  STACKTOP = i9;
  return i1 | 0;
 } else {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i3, 30) | 0) + 0 | 0;
  i4 = 28928 | 0;
  i5 = i1 + 30 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i1 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i3, 29344, 27528, 1901);
  __ZN2cv6String10deallocateEv(i3);
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cv10PxMDecoder10readHeaderEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 i3 = i8 + 32 | 0;
 if (HEAP32[i8 + 48 >> 2] | 0) {
  i6 = HEAP32[i8 + 36 >> 2] | 0;
  if ((i6 | 0) < 3) i1 = Math_imul(HEAP32[i8 + 44 >> 2] | 0, HEAP32[i8 + 40 >> 2] | 0) | 0; else {
   i5 = HEAP32[i8 + 72 >> 2] | 0;
   i4 = 0;
   i1 = 1;
   do {
    i1 = Math_imul(HEAP32[i5 + (i4 << 2) >> 2] | 0, i1) | 0;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i6 | 0));
  }
  i4 = i8 + 92 | 0;
  if (i1) if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 127](i4, i3) | 0) {
   i1 = i4;
   i2 = i4;
  } else {
   i1 = 0;
   STACKTOP = i9;
   return i1 | 0;
  } else {
   i1 = i4;
   i2 = i4;
   i7 = 9;
  }
 } else {
  i2 = i8 + 92 | 0;
  i1 = i2;
  i7 = 9;
 }
 if ((i7 | 0) == 9) if (!(FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 127](i2, i8 + 16 | 0) | 0)) {
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((__ZN2cv12RLByteStream7getByteEv(i1) | 0) != 80) {
  i1 = ___cxa_allocate_exception(4) | 0;
  HEAP32[i1 >> 2] = -125;
  ___cxa_throw(i1 | 0, 179680, 0);
 }
 i3 = __ZN2cv12RLByteStream7getByteEv(i1) | 0;
 switch (i3 | 0) {
 case 53:
 case 50:
  {
   HEAP32[i8 + 1152 >> 2] = 8;
   i4 = 0;
   break;
  }
 case 52:
 case 49:
  {
   HEAP32[i8 + 1152 >> 2] = 1;
   i4 = 0;
   break;
  }
 case 54:
 case 51:
  {
   HEAP32[i8 + 1152 >> 2] = 24;
   i4 = 16;
   break;
  }
 default:
  {
   i1 = ___cxa_allocate_exception(4) | 0;
   HEAP32[i1 >> 2] = -125;
   ___cxa_throw(i1 | 0, 179680, 0);
  }
 }
 HEAP8[i8 + 1160 >> 0] = (i3 | 0) > 51 & 1;
 i6 = i8 + 12 | 0;
 HEAP32[i6 >> 2] = i4;
 i5 = i8 + 4 | 0;
 HEAP32[i5 >> 2] = __ZN2cvL10ReadNumberERNS_12RLByteStreamEi(i1, 2147483647) | 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = __ZN2cvL10ReadNumberERNS_12RLByteStreamEi(i1, 2147483647) | 0;
 if ((HEAP32[i8 + 1152 >> 2] | 0) != 1) {
  i4 = __ZN2cvL10ReadNumberERNS_12RLByteStreamEi(i1, 2147483647) | 0;
  HEAP32[i8 + 1164 >> 2] = i4;
  if ((i4 | 0) > 65535) {
   i1 = ___cxa_allocate_exception(4) | 0;
   HEAP32[i1 >> 2] = -125;
   ___cxa_throw(i1 | 0, 179680, 0);
  }
  if ((i4 | 0) > 255) HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & 4088 | 2;
 } else {
  HEAP32[i8 + 1164 >> 2] = 1;
  i4 = 1;
 }
 if ((HEAP32[i5 >> 2] | 0) > 0 ? (HEAP32[i3 >> 2] | 0) > 0 & (i4 + -1 | 0) >>> 0 < 65535 : 0) {
  HEAP32[i8 + 1156 >> 2] = __ZN2cv11RBaseStream6getPosEv(i2) | 0;
  i1 = 1;
  STACKTOP = i9;
  return i1 | 0;
 }
 HEAP32[i8 + 1156 >> 2] = -1;
 HEAP32[i3 >> 2] = -1;
 HEAP32[i5 >> 2] = -1;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 511](i2);
 i1 = 0;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNSt3__16vectorIN2cv3VecIiLi12EEENS_9allocatorIS3_EEE8__appendEj(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 i10 = i11 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = i1;
 if (((i4 - i3 | 0) / 48 | 0) >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    i5 = i1 + 0 | 0;
    i4 = i5 + 48 | 0;
    do {
     HEAP32[i5 >> 2] = 0;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) < (i4 | 0));
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i1 = i1 + 48 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = ((i3 - i1 | 0) / 48 | 0) + i2 | 0;
 if (i3 >>> 0 > 89478485) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i5 = i1;
 i1 = (i4 - i5 | 0) / 48 | 0;
 if (i1 >>> 0 < 44739242) {
  i1 = i1 << 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = ((HEAP32[i12 >> 2] | 0) - i5 | 0) / 48 | 0;
  if (!i1) {
   i6 = 0;
   i9 = 0;
   i8 = i3;
  } else i7 = 10;
 } else {
  i1 = 89478485;
  i3 = ((HEAP32[i12 >> 2] | 0) - i5 | 0) / 48 | 0;
  i7 = 10;
 }
 if ((i7 | 0) == 10) {
  i6 = i1;
  i9 = __Znwj(i1 * 48 | 0) | 0;
  i8 = i3;
 }
 i1 = i9 + (i8 * 48 | 0) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else {
   i5 = i3 + 0 | 0;
   i4 = i5 + 48 | 0;
   do {
    HEAP32[i5 >> 2] = 0;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) < (i4 | 0));
  }
  i3 = i3 + 48 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = i9 + (i6 * 48 | 0) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  i4 = i5 + -48 - i2 | 0;
  while (1) {
   i7 = i5;
   i5 = i5 + -48 | 0;
   HEAP32[i1 + -48 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + -44 >> 2] = HEAP32[i7 + -44 >> 2];
   HEAP32[i1 + -40 >> 2] = HEAP32[i7 + -40 >> 2];
   HEAP32[i1 + -36 >> 2] = HEAP32[i7 + -36 >> 2];
   HEAP32[i1 + -32 >> 2] = HEAP32[i7 + -32 >> 2];
   HEAP32[i1 + -28 >> 2] = HEAP32[i7 + -28 >> 2];
   HEAP32[i1 + -24 >> 2] = HEAP32[i7 + -24 >> 2];
   HEAP32[i1 + -20 >> 2] = HEAP32[i7 + -20 >> 2];
   HEAP32[i1 + -16 >> 2] = HEAP32[i7 + -16 >> 2];
   HEAP32[i1 + -12 >> 2] = HEAP32[i7 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i7 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i7 + -4 >> 2];
   if ((i5 | 0) == (i2 | 0)) break; else i1 = i1 + -48 | 0;
  }
  i1 = i9 + ((i8 + ~((i4 >>> 0) / 48 | 0) | 0) * 48 | 0) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i3;
 HEAP32[i10 >> 2] = i6;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i13;
 return;
}

function __ZN2cvL8merge32sEPPKiPiii(i12, i10, i11, i9) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 i13 = STACKTOP;
 i7 = (i9 | 0) % 4 | 0;
 i7 = (i7 | 0) == 0 ? 4 : i7;
 do if ((i7 | 0) == 2) {
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  if ((i11 | 0) > 0) {
   i1 = 0;
   i4 = 0;
   while (1) {
    HEAP32[i10 + (i4 << 2) >> 2] = HEAP32[i3 + (i1 << 2) >> 2];
    HEAP32[i10 + (i4 + 1 << 2) >> 2] = HEAP32[i2 + (i1 << 2) >> 2];
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i11 | 0)) break; else i4 = i4 + i9 | 0;
   }
  }
 } else if ((i7 | 0) == 1) {
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i11 | 0) > 0) {
   i2 = 0;
   i3 = 0;
   while (1) {
    HEAP32[i10 + (i3 << 2) >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i11 | 0)) break; else i3 = i3 + i9 | 0;
   }
  }
 } else {
  i6 = HEAP32[i12 >> 2] | 0;
  i5 = HEAP32[i12 + 4 >> 2] | 0;
  i1 = HEAP32[i12 + 8 >> 2] | 0;
  if ((i7 | 0) == 3) {
   if ((i11 | 0) > 0) {
    i4 = 0;
    i3 = 0;
   } else break;
   while (1) {
    HEAP32[i10 + (i3 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
    HEAP32[i10 + (i3 + 1 << 2) >> 2] = HEAP32[i5 + (i4 << 2) >> 2];
    HEAP32[i10 + (i3 + 2 << 2) >> 2] = HEAP32[i1 + (i4 << 2) >> 2];
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i11 | 0)) break; else i3 = i3 + i9 | 0;
   }
  } else {
   i4 = HEAP32[i12 + 12 >> 2] | 0;
   if ((i11 | 0) > 0) {
    i3 = 0;
    i2 = 0;
   } else break;
   while (1) {
    HEAP32[i10 + (i2 << 2) >> 2] = HEAP32[i6 + (i3 << 2) >> 2];
    HEAP32[i10 + (i2 + 1 << 2) >> 2] = HEAP32[i5 + (i3 << 2) >> 2];
    HEAP32[i10 + (i2 + 2 << 2) >> 2] = HEAP32[i1 + (i3 << 2) >> 2];
    HEAP32[i10 + (i2 + 3 << 2) >> 2] = HEAP32[i4 + (i3 << 2) >> 2];
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i11 | 0)) break; else i2 = i2 + i9 | 0;
   }
  }
 } while (0);
 if ((i7 | 0) >= (i9 | 0)) {
  STACKTOP = i13;
  return;
 }
 i8 = (i11 | 0) > 0;
 do {
  i4 = HEAP32[i12 + (i7 << 2) >> 2] | 0;
  i3 = HEAP32[i12 + (i7 + 1 << 2) >> 2] | 0;
  i2 = HEAP32[i12 + (i7 + 2 << 2) >> 2] | 0;
  i1 = HEAP32[i12 + (i7 + 3 << 2) >> 2] | 0;
  if (i8) {
   i5 = 0;
   i6 = i7;
   while (1) {
    HEAP32[i10 + (i6 << 2) >> 2] = HEAP32[i4 + (i5 << 2) >> 2];
    HEAP32[i10 + (i6 + 1 << 2) >> 2] = HEAP32[i3 + (i5 << 2) >> 2];
    HEAP32[i10 + (i6 + 2 << 2) >> 2] = HEAP32[i2 + (i5 << 2) >> 2];
    HEAP32[i10 + (i6 + 3 << 2) >> 2] = HEAP32[i1 + (i5 << 2) >> 2];
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i11 | 0)) break; else i6 = i6 + i9 | 0;
   }
  }
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 STACKTOP = i13;
 return;
}

function __ZN2cvL8recip32sEPKijS1_jPijNS_5Size_IiEEPv(i1, i2, i8, i5, i7, i6, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, d25 = 0.0, d26 = 0.0, d27 = 0.0, d28 = 0.0, d29 = 0.0, d30 = 0.0, d31 = 0.0;
 i19 = STACKTOP;
 i18 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 d17 = +HEAPF64[i4 >> 3];
 i16 = i5 >>> 2;
 i12 = i6 >>> 2;
 if (!i3) {
  STACKTOP = i19;
  return;
 }
 i13 = i18 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i15 = i18 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i14) i4 = 0; else {
   i11 = 0;
   do {
    i6 = HEAP32[i8 + (i11 << 2) >> 2] | 0;
    i10 = i11 | 1;
    i5 = HEAP32[i8 + (i10 << 2) >> 2] | 0;
    do if (!i6) {
     i9 = 0;
     i24 = 10;
    } else {
     if (((i5 | 0) != 0 ? (i20 = i11 | 2, i21 = HEAP32[i8 + (i20 << 2) >> 2] | 0, (i21 | 0) != 0) : 0) ? (i22 = i11 | 3, i23 = HEAP32[i8 + (i22 << 2) >> 2] | 0, (i23 | 0) != 0) : 0) {
      d29 = +(i6 | 0);
      d30 = +(i5 | 0);
      d31 = d29 * d30;
      d26 = +(i21 | 0);
      d27 = +(i23 | 0);
      d28 = d26 * d27;
      d25 = d17 / (d31 * d28);
      d28 = d28 * d25;
      d25 = d31 * d25;
      i5 = _lrint(d30 * d28) | 0;
      i4 = _lrint(d29 * d28) | 0;
      i2 = _lrint(d27 * d25) | 0;
      i1 = _lrint(d26 * d25) | 0;
      HEAP32[i7 + (i11 << 2) >> 2] = i5;
      HEAP32[i7 + (i10 << 2) >> 2] = i4;
      HEAP32[i7 + (i20 << 2) >> 2] = i2;
      HEAP32[i7 + (i22 << 2) >> 2] = i1;
      break;
     }
     i9 = _lrint(d17 / +(i6 | 0)) | 0;
     i24 = 10;
    } while (0);
    if ((i24 | 0) == 10) {
     i24 = 0;
     if (!i5) i1 = 0; else i1 = _lrint(d17 / +(i5 | 0)) | 0;
     i2 = i11 | 2;
     i6 = HEAP32[i8 + (i2 << 2) >> 2] | 0;
     if (!i6) i4 = 0; else i4 = _lrint(d17 / +(i6 | 0)) | 0;
     i5 = i11 | 3;
     i6 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
     if (!i6) i6 = 0; else i6 = _lrint(d17 / +(i6 | 0)) | 0;
     HEAP32[i7 + (i11 << 2) >> 2] = i9;
     HEAP32[i7 + (i10 << 2) >> 2] = i1;
     HEAP32[i7 + (i2 << 2) >> 2] = i4;
     HEAP32[i7 + (i5 << 2) >> 2] = i6;
    }
    i11 = i11 + 4 | 0;
   } while ((i11 | 0) <= (i13 | 0));
   i4 = i15;
  }
  if ((i4 | 0) < (i18 | 0)) do {
   i5 = HEAP32[i8 + (i4 << 2) >> 2] | 0;
   if (!i5) i5 = 0; else i5 = _lrint(d17 / +(i5 | 0)) | 0;
   HEAP32[i7 + (i4 << 2) >> 2] = i5;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i18 | 0));
  if (!i3) break; else {
   i7 = i7 + (i12 << 2) | 0;
   i8 = i8 + (i16 << 2) | 0;
  }
 }
 STACKTOP = i19;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE(i1, i5, i7, i8, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i9 = 0;
 i6 = STACKTOP;
 L1 : while (1) {
  i1 = HEAP32[i5 >> 2] | 0;
  do if (i1) {
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == -1) {
    HEAP32[i5 >> 2] = 0;
    i1 = 1;
    break;
   } else {
    i1 = (HEAP32[i5 >> 2] | 0) == 0;
    break;
   }
  } else i1 = 1; while (0);
  i3 = HEAP32[i7 >> 2] | 0;
  do if (i3) {
   i2 = HEAP32[i3 + 12 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0; else i2 = HEAP32[i2 >> 2] | 0;
   if ((i2 | 0) != -1) if (i1) break; else break L1; else {
    HEAP32[i7 >> 2] = 0;
    i9 = 15;
    break;
   }
  } else i9 = 15; while (0);
  if ((i9 | 0) == 15) {
   i9 = 0;
   if (i1) {
    i3 = 0;
    break;
   } else i3 = 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if (!(FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 63](i4, 8192, i1) | 0)) break;
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = i2 + 12 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   continue;
  } else {
   HEAP32[i1 >> 2] = i3 + 4;
   continue;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 do if (i2) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i5 >> 2] = 0;
   i2 = 1;
   break;
  } else {
   i2 = (HEAP32[i5 >> 2] | 0) == 0;
   break;
  }
 } else i2 = 1; while (0);
 do if (i3) {
  i1 = HEAP32[i3 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] & 127](i3) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i7 >> 2] = 0;
   i9 = 37;
   break;
  }
  if (i2) {
   STACKTOP = i6;
   return;
  }
 } else i9 = 37; while (0);
 if ((i9 | 0) == 37 ? !i2 : 0) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
 STACKTOP = i6;
 return;
}

function __ZNSt3__16vectorIN7testing14TestPartResultENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 i7 = i9 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (((HEAP32[i7 >> 2] | 0) - i1 | 0) / 44 | 0) + 1 | 0;
 if (i3 >>> 0 > 97612893) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i8 = i9 + 8 | 0;
 i2 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 44 | 0;
 if (i2 >>> 0 < 48806446) {
  i2 = i2 << 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i3 = ((HEAP32[i7 >> 2] | 0) - i1 | 0) / 44 | 0;
  if (!i2) {
   i4 = 0;
   i2 = 0;
  } else i6 = 6;
 } else {
  i2 = 97612893;
  i3 = ((HEAP32[i7 >> 2] | 0) - i1 | 0) / 44 | 0;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i4 = i2;
  i2 = __Znwj(i2 * 44 | 0) | 0;
 }
 i1 = i2 + (i3 * 44 | 0) | 0;
 i6 = i2 + (i4 * 44 | 0) | 0;
 if (i1) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i2 + (i3 * 44 | 0) + 4 | 0, i5 + 4 | 0);
  HEAP32[i2 + (i3 * 44 | 0) + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i2 + (i3 * 44 | 0) + 20 | 0, i5 + 20 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i2 + (i3 * 44 | 0) + 32 | 0, i5 + 32 | 0);
 }
 i5 = i2 + ((i3 + 1 | 0) * 44 | 0) | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) {
  i2 = i1;
  i3 = i4;
  i1 = i4;
 } else {
  do {
   i3 = i2;
   i2 = i2 + -44 | 0;
   HEAP32[i1 + -44 >> 2] = HEAP32[i2 >> 2];
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1 + -40 | 0, i3 + -40 | 0);
   HEAP32[i1 + -28 >> 2] = HEAP32[i3 + -28 >> 2];
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1 + -24 | 0, i3 + -24 | 0);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1 + -12 | 0, i3 + -12 | 0);
   i1 = i1 + -44 | 0;
  } while ((i2 | 0) != (i4 | 0));
  i2 = i1;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i8 >> 2] = i6;
 while (1) {
  if ((i1 | 0) == (i3 | 0)) break;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + -12 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + -24 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + -40 | 0);
  i1 = i1 + -44 | 0;
 }
 if (!i3) {
  STACKTOP = i10;
  return;
 }
 __ZdlPv(i3);
 STACKTOP = i10;
 return;
}

function __ZNSt3__110__stdinbufIwE9__getcharEb(i13, i16) {
 i13 = i13 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i17 = i19 + 16 | 0;
 i15 = i19 + 8 | 0;
 i11 = i19 + 4 | 0;
 i12 = i19;
 i3 = i13 + 52 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  i1 = i13 + 48 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i16) {
   i10 = i2;
   STACKTOP = i19;
   return i10 | 0;
  }
  HEAP32[i1 >> 2] = -1;
  HEAP8[i3 >> 0] = 0;
  i10 = i2;
  STACKTOP = i19;
  return i10 | 0;
 }
 i5 = HEAP32[i13 + 44 >> 2] | 0;
 i5 = (i5 | 0) > 1 ? i5 : 1;
 L8 : do if ((i5 | 0) > 0) {
  i3 = i13 + 32 | 0;
  i4 = 0;
  while (1) {
   i1 = _getc(HEAP32[i3 >> 2] | 0) | 0;
   if ((i1 | 0) == -1) {
    i14 = -1;
    break;
   }
   HEAP8[i17 + i4 >> 0] = i1;
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i5 | 0)) break L8;
  }
  STACKTOP = i19;
  return i14 | 0;
 } while (0);
 L15 : do if (!(HEAP8[i13 + 53 >> 0] | 0)) {
  i7 = i13 + 40 | 0;
  i8 = i13 + 36 | 0;
  i9 = i15 + 4 | 0;
  i10 = i13 + 32 | 0;
  while (1) {
   i1 = HEAP32[i7 >> 2] | 0;
   i3 = i1;
   i4 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i20 = HEAP32[i8 >> 2] | 0;
   i6 = i17 + i5 | 0;
   i1 = FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i20 >> 2] | 0) + 16 >> 2] & 15](i20, i1, i17, i6, i11, i15, i9, i12) | 0;
   if ((i1 | 0) == 2) {
    i14 = -1;
    i18 = 22;
    break;
   } else if ((i1 | 0) == 3) {
    i18 = 14;
    break;
   } else if ((i1 | 0) != 1) {
    i2 = i5;
    break L15;
   }
   i1 = HEAP32[i7 >> 2] | 0;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i1 + 4 >> 2] = i3;
   if ((i5 | 0) == 8) {
    i14 = -1;
    i18 = 22;
    break;
   }
   i4 = _getc(HEAP32[i10 >> 2] | 0) | 0;
   if ((i4 | 0) == -1) {
    i14 = -1;
    i18 = 22;
    break;
   }
   HEAP8[i6 >> 0] = i4;
   i5 = i5 + 1 | 0;
  }
  if ((i18 | 0) == 14) {
   HEAP32[i15 >> 2] = HEAP8[i17 >> 0];
   i2 = i5;
   break;
  } else if ((i18 | 0) == 22) {
   STACKTOP = i19;
   return i14 | 0;
  }
 } else {
  HEAP32[i15 >> 2] = HEAP8[i17 >> 0];
  i2 = i5;
 } while (0);
 if (i16) {
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP32[i13 + 48 >> 2] = i10;
  STACKTOP = i19;
  return i10 | 0;
 }
 i1 = i13 + 32 | 0;
 while (1) {
  if ((i2 | 0) <= 0) break;
  i2 = i2 + -1 | 0;
  if ((_ungetc(HEAP8[i17 + i2 >> 0] | 0, HEAP32[i1 >> 2] | 0) | 0) == -1) {
   i14 = -1;
   i18 = 22;
   break;
  }
 }
 if ((i18 | 0) == 22) {
  STACKTOP = i19;
  return i14 | 0;
 }
 i10 = HEAP32[i15 >> 2] | 0;
 STACKTOP = i19;
 return i10 | 0;
}

function __ZNSt3__16vectorIN2cv3VecIiLi8EEENS_9allocatorIS3_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 i9 = i10 + 8 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1;
 if (i4 - i3 >> 5 >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    HEAP32[i1 + 0 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 0;
    HEAP32[i1 + 20 >> 2] = 0;
    HEAP32[i1 + 24 >> 2] = 0;
    HEAP32[i1 + 28 >> 2] = 0;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i1 = i1 + 32 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = (i3 - i1 >> 5) + i2 | 0;
 if (i3 >>> 0 > 134217727) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i5 = i1;
 i1 = i4 - i5 | 0;
 if (i1 >> 5 >>> 0 < 67108863) {
  i1 = i1 >> 4;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = (HEAP32[i11 >> 2] | 0) - i5 >> 5;
  if (!i1) {
   i5 = 0;
   i8 = 0;
   i7 = i3;
  } else i6 = 10;
 } else {
  i1 = 134217727;
  i3 = (HEAP32[i11 >> 2] | 0) - i5 >> 5;
  i6 = 10;
 }
 if ((i6 | 0) == 10) {
  i5 = i1;
  i8 = __Znwj(i1 << 5) | 0;
  i7 = i3;
 }
 i1 = i8 + (i7 << 5) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else {
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
   HEAP32[i3 + 24 >> 2] = 0;
   HEAP32[i3 + 28 >> 2] = 0;
  }
  i3 = i3 + 32 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = i8 + (i5 << 5) | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  i4 = i5 + -32 - i2 | 0;
  while (1) {
   i13 = i5;
   i5 = i5 + -32 | 0;
   HEAP32[i1 + -32 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + -28 >> 2] = HEAP32[i13 + -28 >> 2];
   HEAP32[i1 + -24 >> 2] = HEAP32[i13 + -24 >> 2];
   HEAP32[i1 + -20 >> 2] = HEAP32[i13 + -20 >> 2];
   HEAP32[i1 + -16 >> 2] = HEAP32[i13 + -16 >> 2];
   HEAP32[i1 + -12 >> 2] = HEAP32[i13 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i13 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i13 + -4 >> 2];
   if ((i5 | 0) == (i2 | 0)) break; else i1 = i1 + -32 | 0;
  }
  i1 = i8 + (i7 + ~(i4 >>> 5) << 5) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i12;
 return;
}

function __ZN4perf10Regression5writeEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i12 = i13;
 i7 = i13 + 16 | 0;
 i8 = i13 + 8 | 0;
 i9 = i11 + 68 | 0;
 if (__ZNK2cv11FileStorage8isOpenedEv(i9) | 0) {
  STACKTOP = i13;
  return i9 | 0;
 }
 i10 = i11 + 20 | 0;
 i1 = HEAP8[i10 >> 0] | 0;
 if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i11 + 24 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return i9 | 0;
 }
 L11 : do if (__ZNK2cv11FileStorage8isOpenedEv(i11 + 32 | 0) | 0) {
  i2 = i11 + 8 | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  i6 = (i1 & 1) == 0;
  if (i6) i4 = (i1 & 255) >>> 1; else i4 = HEAP32[i11 + 12 >> 2] | 0;
  i1 = HEAP8[i10 >> 0] | 0;
  i5 = (i1 & 1) == 0;
  if (i5) i3 = (i1 & 255) >>> 1; else i3 = HEAP32[i11 + 24 >> 2] | 0;
  if ((i4 | 0) == (i3 | 0)) {
   if (i6) i2 = i2 + 1 | 0; else i2 = HEAP32[i11 + 16 >> 2] | 0;
   if (i5) i3 = i10 + 1 | 0; else i3 = HEAP32[i11 + 28 >> 2] | 0;
   if (!i6) {
    i5 = (_memcmp(i2, i3, i4) | 0) == 0;
    i5 = i5 ? 2 : 1;
    break;
   }
   if (!i4) i5 = 2; else while (1) {
    if ((HEAP8[i2 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) {
     i5 = 1;
     break L11;
    }
    i4 = i4 + -1 | 0;
    if (!i4) {
     i5 = 2;
     break;
    } else {
     i2 = i2 + 1 | 0;
     i3 = i3 + 1 | 0;
    }
   }
  } else i5 = 1;
 } else {
  i1 = HEAP8[i10 >> 0] | 0;
  i5 = 1;
 } while (0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i2 = (i1 & 1) == 0;
 if (i2) i3 = (i1 & 255) >>> 1; else i3 = HEAP32[i11 + 24 >> 2] | 0;
 if (i3) {
  if (i2) i3 = (i1 & 255) >>> 1; else i3 = HEAP32[i11 + 24 >> 2] | 0;
  i2 = __ZN2cv6String8allocateEj(i7, i3) | 0;
  if (!(HEAP8[i10 >> 0] & 1)) i1 = i10 + 1 | 0; else i1 = HEAP32[i11 + 28 >> 2] | 0;
  _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 __ZN2cv11FileStorage4openERKNS_6StringEiS3_(i9, i7, i5, i8) | 0;
 __ZN2cv6String10deallocateEv(i8);
 __ZN2cv6String10deallocateEv(i7);
 if (__ZNK2cv11FileStorage8isOpenedEv(i9) | 0) {
  STACKTOP = i13;
  return i9 | 0;
 }
 if (!(HEAP8[i10 >> 0] & 1)) i1 = i10 + 1 | 0; else i1 = HEAP32[i11 + 28 >> 2] | 0;
 HEAP32[i12 >> 2] = i1;
 _printf(170008, i12 | 0) | 0;
 _putchar(10) | 0;
 _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 if (!(HEAP8[i10 >> 0] & 1)) {
  HEAP8[i10 + 1 >> 0] = 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i13;
  return i9 | 0;
 } else {
  HEAP8[HEAP32[i11 + 28 >> 2] >> 0] = 0;
  HEAP32[i11 + 24 >> 2] = 0;
  STACKTOP = i13;
  return i9 | 0;
 }
 return 0;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE(i1, i5, i7, i8, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i9 = 0;
 i6 = STACKTOP;
 i4 = i2 + 8 | 0;
 L1 : while (1) {
  i1 = HEAP32[i5 >> 2] | 0;
  do if (i1) {
   if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1) {
    HEAP32[i5 >> 2] = 0;
    i1 = 0;
    break;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    break;
   }
  } else i1 = 0; while (0);
  i2 = (i1 | 0) == 0;
  i1 = HEAP32[i7 >> 2] | 0;
  do if (i1) {
   if ((HEAP32[i1 + 12 >> 2] | 0) != (HEAP32[i1 + 16 >> 2] | 0)) if (i2) break; else {
    i2 = i1;
    break L1;
   }
   if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) != -1) if (i2) break; else {
    i2 = i1;
    break L1;
   } else {
    HEAP32[i7 >> 2] = 0;
    i9 = 12;
    break;
   }
  } else i9 = 12; while (0);
  if ((i9 | 0) == 12) {
   i9 = 0;
   if (i2) {
    i2 = 0;
    break;
   } else i1 = 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0; else i2 = HEAPU8[i3 >> 0] | 0;
  if ((i2 & 255) << 24 >> 24 <= -1) {
   i2 = i1;
   break;
  }
  if (!(HEAP16[(HEAP32[i4 >> 2] | 0) + (i2 << 24 >> 24 << 1) >> 1] & 8192)) {
   i2 = i1;
   break;
  }
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = i3 + 12 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
   FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] & 127](i3) | 0;
   continue;
  } else {
   HEAP32[i2 >> 2] = i1 + 1;
   continue;
  }
 }
 i1 = HEAP32[i5 >> 2] | 0;
 do if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1) {
   HEAP32[i5 >> 2] = 0;
   i1 = 0;
   break;
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   break;
  }
 } else i1 = 0; while (0);
 i1 = (i1 | 0) == 0;
 do if (i2) {
  if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0) == -1 : 0) {
   HEAP32[i7 >> 2] = 0;
   i9 = 32;
   break;
  }
  if (i1) {
   STACKTOP = i6;
   return;
  }
 } else i9 = 32; while (0);
 if ((i9 | 0) == 32 ? !i1 : 0) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
 STACKTOP = i6;
 return;
}

function __ZNSt3__16vectorIN2cv4UMatENS_9allocatorIS2_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i9 = i10;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1;
 if (((i5 - i3 | 0) / 48 | 0) >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    HEAP32[i1 >> 2] = 1124007936;
    i3 = i1 + 4 | 0;
    HEAP32[i3 + 0 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    HEAP32[i3 + 12 >> 2] = 0;
    HEAP32[i3 + 16 >> 2] = 0;
    HEAP32[i3 + 20 >> 2] = 0;
    HEAP32[i3 + 24 >> 2] = 0;
    HEAP32[i1 + 32 >> 2] = i1 + 8;
    i3 = i1 + 40 | 0;
    HEAP32[i1 + 36 >> 2] = i3;
    HEAP32[i1 + 44 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i1 = i1 + 48 | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = ((i3 - i1 | 0) / 48 | 0) + i2 | 0;
 if (i3 >>> 0 > 89478485) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i8);
 i4 = i1;
 i1 = (i5 - i4 | 0) / 48 | 0;
 if (i1 >>> 0 < 44739242) {
  i5 = i1 << 1;
  i5 = i5 >>> 0 < i3 >>> 0 ? i3 : i5;
 } else i5 = 89478485;
 i1 = ((HEAP32[i7 >> 2] | 0) - i4 | 0) / 48 | 0;
 i4 = i9 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = i8 + 8;
 if (!i5) i3 = 0; else i3 = __Znwj(i5 * 48 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 i1 = i3 + (i1 * 48 | 0) | 0;
 i7 = i9 + 8 | 0;
 HEAP32[i7 >> 2] = i1;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i4 >> 2] = i3 + (i5 * 48 | 0);
 do {
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = 1124007936;
   i3 = i1 + 4 | 0;
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
   HEAP32[i3 + 24 >> 2] = 0;
   HEAP32[i1 + 32 >> 2] = i1 + 8;
   i3 = i1 + 40 | 0;
   HEAP32[i1 + 36 >> 2] = i3;
   HEAP32[i1 + 44 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
  }
  i1 = i1 + 48 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 HEAP32[i7 >> 2] = i1;
 __ZNSt3__16vectorIN2cv4UMatENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i8, i9);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 while (1) {
  if ((i2 | 0) == (i1 | 0)) break;
  i3 = i2 + -48 | 0;
  HEAP32[i7 >> 2] = i3;
  __ZN2cv4UMatD2Ev(i3);
  i2 = i3;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i10;
 return;
}

function _cvGraphAddEdgeByPtr(i8, i2, i3, i12, i13) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i11 = i14 + 16 | 0;
 i4 = i14 + 8 | 0;
 i7 = i14;
 if (!i8) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i4, 21) | 0) + 0 | 0;
  i5 = 40584 | 0;
  i6 = i1 + 21 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i4, 40608, 39608, 2757);
  __ZN2cv6String10deallocateEv(i4);
 }
 if (!(HEAP32[i8 >> 2] & 16384)) {
  i9 = (HEAP32[i2 >> 2] & 67108863) >>> 0 > (HEAP32[i3 >> 2] & 67108863) >>> 0;
  i10 = i9 ? i3 : i2;
  i9 = i9 ? i2 : i3;
 } else {
  i10 = i2;
  i9 = i3;
 }
 i2 = _cvFindGraphEdgeByPtr(i8, i10, i9) | 0;
 if (i2) {
  if (!i13) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  HEAP32[i13 >> 2] = i2;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 if ((i10 | 0) == (i9 | 0)) {
  i4 = (i9 | 0) != 0 ? -5 : -27;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i7, 41) | 0) + 0 | 0;
  i5 = 40632 | 0;
  i6 = i1 + 41 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i4, i7, 40608, 39608, 2777);
  __ZN2cv6String10deallocateEv(i7);
 }
 i4 = i8 + 64 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = i2 + 56 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 if (!i3) {
  _cvSetAdd(i2, 0, i11) | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & 67108863;
  i8 = i2 + 60 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 HEAP32[i3 + 16 >> 2] = i10;
 HEAP32[i3 + 20 >> 2] = i9;
 i1 = i10 + 4 | 0;
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 >> 2];
 i2 = i9 + 4 | 0;
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 HEAP32[i1 >> 2] = i3;
 i1 = (HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0) + -24 | 0;
 i2 = (i1 | 0) > 0;
 if (!i12) {
  if (i2) _memset(i3 + 24 | 0, 0, i1 | 0) | 0;
  HEAPF32[i3 + 4 >> 2] = Math_fround(1.0);
 } else {
  if (i2) _memcpy(i3 + 24 | 0, i12 + 24 | 0, i1 | 0) | 0;
  HEAPF32[i3 + 4 >> 2] = Math_fround(HEAPF32[i12 + 4 >> 2]);
 }
 if (!i13) {
  i10 = 1;
  STACKTOP = i14;
  return i10 | 0;
 }
 HEAP32[i13 >> 2] = i3;
 i10 = 1;
 STACKTOP = i14;
 return i10 | 0;
}

function __ZN2cv12countNonZeroERKNS_11_InputArrayE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i3 = i10 + 112 | 0;
 i9 = i10 + 56 | 0;
 i4 = i10 + 48 | 0;
 i5 = i10 + 40 | 0;
 i8 = i10 + 32 | 0;
 i7 = i10;
 if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] & 127](i2, -1) | 0) & 4088) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i1 = __ZN2cv6String8allocateEj(i3, 7) | 0;
  HEAP8[i1 + 0 >> 0] = HEAP8[27216] | 0;
  HEAP8[i1 + 1 >> 0] = HEAP8[27217] | 0;
  HEAP8[i1 + 2 >> 0] = HEAP8[27218] | 0;
  HEAP8[i1 + 3 >> 0] = HEAP8[27219] | 0;
  HEAP8[i1 + 4 >> 0] = HEAP8[27220] | 0;
  HEAP8[i1 + 5 >> 0] = HEAP8[27221] | 0;
  HEAP8[i1 + 6 >> 0] = HEAP8[27222] | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 27224, 27160, 1024);
  __ZN2cv6String10deallocateEv(i3);
 }
 FUNCTION_TABLE_viii[HEAP32[HEAP32[i2 >> 2] >> 2] & 63](i9, i2, -1);
 i1 = HEAP32[i9 >> 2] & 7;
 i6 = HEAP32[27416 + (i1 << 2) >> 2] | 0;
 if ((i1 | 0) == 7) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i4, 9) | 0) + 0 | 0;
  i2 = 27240 | 0;
  i1 = i3 + 9 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 27224, 27160, 1068);
  __ZN2cv6String10deallocateEv(i4);
 }
 HEAP32[i5 >> 2] = i9;
 HEAP32[i5 + 4 >> 2] = 0;
 __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i7, i5, i8, -1);
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i2 = i7 + 16 | 0;
 i1 = 0;
 i5 = 0;
 while (1) {
  if (i1 >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) break;
  i4 = (FUNCTION_TABLE_iii[i6 & 127](HEAP32[i8 >> 2] | 0, i3) | 0) + i5 | 0;
  __ZN2cv15NAryMatIteratorppEv(i7) | 0;
  i1 = i1 + 1 | 0;
  i5 = i4;
 }
 i1 = i9 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i3 = i2 + 12 | 0, i2 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i2 + -1, (i2 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i9);
 HEAP32[i1 >> 2] = 0;
 i1 = i9 + 16 | 0;
 i2 = i9 + 4 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i9 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 if ((i1 | 0) == (i9 + 48 | 0)) {
  STACKTOP = i10;
  return i5 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i10;
 return i5 | 0;
}

function __ZNSt3__16vectorIN2cv3VecIiLi9EEENS_9allocatorIS3_EEE8__appendEj(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 i10 = i11 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = i1;
 if (((i4 - i3 | 0) / 36 | 0) >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    i5 = i1 + 0 | 0;
    i4 = i5 + 36 | 0;
    do {
     HEAP32[i5 >> 2] = 0;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) < (i4 | 0));
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i1 = i1 + 36 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = ((i3 - i1 | 0) / 36 | 0) + i2 | 0;
 if (i3 >>> 0 > 119304647) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i5 = i1;
 i1 = (i4 - i5 | 0) / 36 | 0;
 if (i1 >>> 0 < 59652323) {
  i1 = i1 << 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = ((HEAP32[i12 >> 2] | 0) - i5 | 0) / 36 | 0;
  if (!i1) {
   i6 = 0;
   i9 = 0;
   i8 = i3;
  } else i7 = 10;
 } else {
  i1 = 119304647;
  i3 = ((HEAP32[i12 >> 2] | 0) - i5 | 0) / 36 | 0;
  i7 = 10;
 }
 if ((i7 | 0) == 10) {
  i6 = i1;
  i9 = __Znwj(i1 * 36 | 0) | 0;
  i8 = i3;
 }
 i1 = i9 + (i8 * 36 | 0) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else {
   i5 = i3 + 0 | 0;
   i4 = i5 + 36 | 0;
   do {
    HEAP32[i5 >> 2] = 0;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) < (i4 | 0));
  }
  i3 = i3 + 36 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = i9 + (i6 * 36 | 0) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  i4 = i5 + -36 - i2 | 0;
  while (1) {
   i7 = i5;
   i5 = i5 + -36 | 0;
   HEAP32[i1 + -36 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + -32 >> 2] = HEAP32[i7 + -32 >> 2];
   HEAP32[i1 + -28 >> 2] = HEAP32[i7 + -28 >> 2];
   HEAP32[i1 + -24 >> 2] = HEAP32[i7 + -24 >> 2];
   HEAP32[i1 + -20 >> 2] = HEAP32[i7 + -20 >> 2];
   HEAP32[i1 + -16 >> 2] = HEAP32[i7 + -16 >> 2];
   HEAP32[i1 + -12 >> 2] = HEAP32[i7 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i7 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i7 + -4 >> 2];
   if ((i5 | 0) == (i2 | 0)) break; else i1 = i1 + -36 | 0;
  }
  i1 = i9 + ((i8 + ~((i4 >>> 0) / 36 | 0) | 0) * 36 | 0) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i3;
 HEAP32[i10 >> 2] = i6;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i13;
 return;
}

function __ZN2cvL7merge8uEPPKhPhii(i12, i10, i11, i9) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 i13 = STACKTOP;
 i7 = (i9 | 0) % 4 | 0;
 i7 = (i7 | 0) == 0 ? 4 : i7;
 do if ((i7 | 0) == 2) {
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  if ((i11 | 0) > 0) {
   i1 = 0;
   i4 = 0;
   while (1) {
    HEAP8[i10 + i4 >> 0] = HEAP8[i3 + i1 >> 0] | 0;
    HEAP8[i10 + (i4 + 1) >> 0] = HEAP8[i2 + i1 >> 0] | 0;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i11 | 0)) break; else i4 = i4 + i9 | 0;
   }
  }
 } else if ((i7 | 0) == 1) {
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i11 | 0) > 0) {
   i2 = 0;
   i3 = 0;
   while (1) {
    HEAP8[i10 + i3 >> 0] = HEAP8[i1 + i2 >> 0] | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i11 | 0)) break; else i3 = i3 + i9 | 0;
   }
  }
 } else {
  i6 = HEAP32[i12 >> 2] | 0;
  i5 = HEAP32[i12 + 4 >> 2] | 0;
  i1 = HEAP32[i12 + 8 >> 2] | 0;
  if ((i7 | 0) == 3) {
   if ((i11 | 0) > 0) {
    i4 = 0;
    i3 = 0;
   } else break;
   while (1) {
    HEAP8[i10 + i3 >> 0] = HEAP8[i6 + i4 >> 0] | 0;
    HEAP8[i10 + (i3 + 1) >> 0] = HEAP8[i5 + i4 >> 0] | 0;
    HEAP8[i10 + (i3 + 2) >> 0] = HEAP8[i1 + i4 >> 0] | 0;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i11 | 0)) break; else i3 = i3 + i9 | 0;
   }
  } else {
   i4 = HEAP32[i12 + 12 >> 2] | 0;
   if ((i11 | 0) > 0) {
    i3 = 0;
    i2 = 0;
   } else break;
   while (1) {
    HEAP8[i10 + i2 >> 0] = HEAP8[i6 + i3 >> 0] | 0;
    HEAP8[i10 + (i2 + 1) >> 0] = HEAP8[i5 + i3 >> 0] | 0;
    HEAP8[i10 + (i2 + 2) >> 0] = HEAP8[i1 + i3 >> 0] | 0;
    HEAP8[i10 + (i2 + 3) >> 0] = HEAP8[i4 + i3 >> 0] | 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i11 | 0)) break; else i2 = i2 + i9 | 0;
   }
  }
 } while (0);
 if ((i7 | 0) >= (i9 | 0)) {
  STACKTOP = i13;
  return;
 }
 i8 = (i11 | 0) > 0;
 do {
  i4 = HEAP32[i12 + (i7 << 2) >> 2] | 0;
  i3 = HEAP32[i12 + (i7 + 1 << 2) >> 2] | 0;
  i2 = HEAP32[i12 + (i7 + 2 << 2) >> 2] | 0;
  i1 = HEAP32[i12 + (i7 + 3 << 2) >> 2] | 0;
  if (i8) {
   i5 = 0;
   i6 = i7;
   while (1) {
    HEAP8[i10 + i6 >> 0] = HEAP8[i4 + i5 >> 0] | 0;
    HEAP8[i10 + (i6 + 1) >> 0] = HEAP8[i3 + i5 >> 0] | 0;
    HEAP8[i10 + (i6 + 2) >> 0] = HEAP8[i2 + i5 >> 0] | 0;
    HEAP8[i10 + (i6 + 3) >> 0] = HEAP8[i1 + i5 >> 0] | 0;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i11 | 0)) break; else i6 = i6 + i9 | 0;
   }
  }
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 STACKTOP = i13;
 return;
}

function __ZN2cvL9randf_32fEPfiPyPKNS_3VecIfLi2EEEb(i5, i6, i9, i7, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0;
 i8 = STACKTOP;
 i1 = i9;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i6 + -4 | 0;
 if ((i4 | 0) < 0) i3 = 0; else {
  i3 = 0;
  do {
   i15 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i15 = _i64Add(i15 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i10 = tempRet0;
   f14 = Math_fround(i15 | 0);
   i15 = ___muldi3(i15 | 0, 0, -130063606, 0) | 0;
   i10 = _i64Add(i15 | 0, tempRet0 | 0, i10 | 0, 0) | 0;
   i15 = tempRet0;
   f13 = Math_fround(i10 | 0);
   i10 = ___muldi3(i10 | 0, 0, -130063606, 0) | 0;
   i15 = _i64Add(i10 | 0, tempRet0 | 0, i15 | 0, 0) | 0;
   i10 = tempRet0;
   f12 = Math_fround(i15 | 0);
   i15 = ___muldi3(i15 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i15 | 0, tempRet0 | 0, i10 | 0, 0) | 0;
   i1 = tempRet0;
   f11 = Math_fround(i2 | 0);
   f14 = Math_fround(f14 * Math_fround(HEAPF32[i7 + (i3 << 3) >> 2]));
   HEAPF32[i5 + (i3 << 2) >> 2] = Math_fround(f14 + Math_fround(HEAPF32[i7 + (i3 << 3) + 4 >> 2]));
   i10 = i3 | 1;
   f13 = Math_fround(f13 * Math_fround(HEAPF32[i7 + (i10 << 3) >> 2]));
   HEAPF32[i5 + (i10 << 2) >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i7 + (i10 << 3) + 4 >> 2]));
   i10 = i3 | 2;
   f12 = Math_fround(f12 * Math_fround(HEAPF32[i7 + (i10 << 3) >> 2]));
   HEAPF32[i5 + (i10 << 2) >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i7 + (i10 << 3) + 4 >> 2]));
   i10 = i3 | 3;
   f11 = Math_fround(f11 * Math_fround(HEAPF32[i7 + (i10 << 3) >> 2]));
   HEAPF32[i5 + (i10 << 2) >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i7 + (i10 << 3) + 4 >> 2]));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i4 | 0));
  i3 = i6 & -4;
 }
 if ((i3 | 0) >= (i6 | 0)) {
  i6 = i2;
  i7 = i1;
  i10 = i9;
  i9 = i10;
  HEAP32[i9 >> 2] = i6;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
 do {
  i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
  i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  f11 = Math_fround(i2 | 0);
  f11 = Math_fround(f11 * Math_fround(HEAPF32[i7 + (i3 << 3) >> 2]));
  HEAPF32[i5 + (i3 << 2) >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i7 + (i3 << 3) + 4 >> 2]));
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i6 | 0));
 i10 = i9;
 i9 = i10;
 HEAP32[i9 >> 2] = i2;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZNK2cv5MatOp8subtractERKNS_7Scalar_IdEERKNS_7MatExprERS5_(i1, i7, i3, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i11 = i15 + 56 | 0;
 i8 = i15;
 HEAP32[i11 >> 2] = 1124007936;
 i13 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i10 = i11 + 40 | 0;
 i1 = i13 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i10 >> 2] = i2;
 i14 = i11 + 48 | 0;
 i12 = i11 + 44 | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 i9 = HEAP32[i3 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] & 63](i9, i3, i11, -1);
 HEAP32[i8 >> 2] = 1124007936;
 i9 = i8 + 4 | 0;
 i2 = i8 + 8 | 0;
 i3 = i8 + 40 | 0;
 i1 = i9 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i3 >> 2] = i2;
 i5 = i8 + 48 | 0;
 i4 = i8 + 44 | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i8 + 52 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 __ZN2cv11MatOp_AddEx8makeExprERNS_7MatExprERKNS_3MatES5_ddRKNS_7Scalar_IdEE(i6, i11, i8, -1.0, 0.0, i7);
 i2 = i8 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i7 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i7 + -1, (i7 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i8);
 HEAP32[i2 >> 2] = 0;
 i8 = i8 + 16 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if ((HEAP32[i9 >> 2] | 0) > 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i9 >> 2] | 0));
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i5 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i8 = i1 + 12 | 0, i9 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 if ((HEAP32[i13 >> 2] | 0) > 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i13 >> 2] | 0));
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i14 | 0)) {
  STACKTOP = i15;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i15;
 return;
}

function __ZNSt3__1L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i2, i6, i7, i3, i4, i8, i5, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i9 = STACKTOP;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i8 >> 2] = i3;
 do if (i1 & 2) if ((i4 - i3 | 0) < 3) {
  i1 = 1;
  STACKTOP = i9;
  return i1 | 0;
 } else {
  HEAP32[i8 >> 2] = i3 + 1;
  HEAP8[i3 >> 0] = -17;
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = -69;
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = -65;
  break;
 } while (0);
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 >= i6 >>> 0) {
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 L10 : while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 & -2048 | 0) == 55296 | i3 >>> 0 > i5 >>> 0) {
   i1 = 2;
   i2 = 19;
   break;
  }
  do if (i3 >>> 0 >= 128) {
   if (i3 >>> 0 < 2048) {
    i2 = HEAP32[i8 >> 2] | 0;
    if ((i4 - i2 | 0) < 2) {
     i1 = 1;
     i2 = 19;
     break L10;
    }
    HEAP32[i8 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i3 >>> 6 | 192;
    i1 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = i1 + 1;
    HEAP8[i1 >> 0] = i3 & 63 | 128;
    break;
   }
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = i4 - i2 | 0;
   if (i3 >>> 0 < 65536) {
    if ((i1 | 0) < 3) {
     i1 = 1;
     i2 = 19;
     break L10;
    }
    HEAP32[i8 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i3 >>> 12 | 224;
    i1 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = i1 + 1;
    HEAP8[i1 >> 0] = i3 >>> 6 & 63 | 128;
    i1 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = i1 + 1;
    HEAP8[i1 >> 0] = i3 & 63 | 128;
    break;
   } else {
    if ((i1 | 0) < 4) {
     i1 = 1;
     i2 = 19;
     break L10;
    }
    HEAP32[i8 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i3 >>> 18 | 240;
    i1 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = i1 + 1;
    HEAP8[i1 >> 0] = i3 >>> 12 & 63 | 128;
    i1 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = i1 + 1;
    HEAP8[i1 >> 0] = i3 >>> 6 & 63 | 128;
    i1 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = i1 + 1;
    HEAP8[i1 >> 0] = i3 & 63 | 128;
    break;
   }
  } else {
   i2 = HEAP32[i8 >> 2] | 0;
   if ((i4 - i2 | 0) < 1) {
    i1 = 1;
    i2 = 19;
    break L10;
   }
   HEAP32[i8 >> 2] = i2 + 1;
   HEAP8[i2 >> 0] = i3;
  } while (0);
  i2 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
  HEAP32[i7 >> 2] = i2;
  if (i2 >>> 0 >= i6 >>> 0) {
   i1 = 0;
   i2 = 19;
   break;
  }
 }
 if ((i2 | 0) == 19) {
  STACKTOP = i9;
  return i1 | 0;
 }
 return 0;
}

function __ZNK2cv5MatOp3addERKNS_7MatExprERKNS_7Scalar_IdEERS1_(i1, i3, i7, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i11 = i15 + 56 | 0;
 i8 = i15;
 HEAP32[i11 >> 2] = 1124007936;
 i13 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i10 = i11 + 40 | 0;
 i1 = i13 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i10 >> 2] = i2;
 i14 = i11 + 48 | 0;
 i12 = i11 + 44 | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 i9 = HEAP32[i3 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] & 63](i9, i3, i11, -1);
 HEAP32[i8 >> 2] = 1124007936;
 i9 = i8 + 4 | 0;
 i2 = i8 + 8 | 0;
 i3 = i8 + 40 | 0;
 i1 = i9 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i3 >> 2] = i2;
 i5 = i8 + 48 | 0;
 i4 = i8 + 44 | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i8 + 52 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 __ZN2cv11MatOp_AddEx8makeExprERNS_7MatExprERKNS_3MatES5_ddRKNS_7Scalar_IdEE(i6, i11, i8, 1.0, 0.0, i7);
 i2 = i8 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i7 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i7 + -1, (i7 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i8);
 HEAP32[i2 >> 2] = 0;
 i8 = i8 + 16 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if ((HEAP32[i9 >> 2] | 0) > 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i9 >> 2] | 0));
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i5 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i8 = i1 + 12 | 0, i9 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 if ((HEAP32[i13 >> 2] | 0) > 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i13 >> 2] | 0));
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i14 | 0)) {
  STACKTOP = i15;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i15;
 return;
}

function __ZN7testing8internal12ShuffleRangeIiEEvPNS0_6RandomEiiPNSt3__16vectorIT_NS4_9allocatorIS6_EEEE(i6, i5, i4, i7) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i8 + 4 | 0;
 i1 = i8;
 i3 = (HEAP32[i7 + 4 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) >> 2;
 if (!((i5 | 0) > -1 & (i3 | 0) >= (i5 | 0))) {
  __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i2, 3, 160160, 724);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 168480, 46) | 0, 168528, 28) | 0, i5) | 0, 168560, 23) | 0, i3) | 0, 168584, 2) | 0;
  __ZN7testing8internal8GTestLogD2Ev(i2);
 }
 if (!((i3 | 0) >= (i4 | 0) & (i4 | 0) >= (i5 | 0))) {
  __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i1, 3, 160160, 727);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 168592, 46) | 0, 168640, 29) | 0, i4) | 0, 168672, 20) | 0, i5) | 0, 164448, 2) | 0, i3) | 0, 168584, 2) | 0;
  __ZN7testing8internal8GTestLogD2Ev(i1);
 }
 i1 = i4 - i5 | 0;
 if ((i1 | 0) <= 1) {
  STACKTOP = i8;
  return;
 }
 i2 = i5 + -1 | 0;
 do {
  i9 = (__ZN7testing8internal6Random8GenerateEj(i6, i1) | 0) + i5 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i9 = i3 + (i9 << 2) | 0;
  i3 = i3 + (i2 + i1 << 2) | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i4;
  i1 = i1 + -1 | 0;
 } while ((i1 | 0) > 1);
 STACKTOP = i8;
 return;
}

function __ZNK2cv11_InputArray11isSubmatrixEi(i3, i7) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i8 + 16 | 0;
 i6 = i8 + 8 | 0;
 i1 = i8;
 i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3) | 0;
 if ((i2 | 0) == 0 | (i2 | 0) == 131072 | (i2 | 0) == 196608 | (i2 | 0) == 262144 | (i2 | 0) == 393216) {
  i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 } else if ((i2 | 0) == 327680) {
  i3 = HEAP32[i3 + 8 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 56 | 0) >>> 0 <= i7 >>> 0) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i2 = (__ZN2cv6String8allocateEj(i5, 21) | 0) + 0 | 0;
   i1 = 29320 | 0;
   i4 = i2 + 21 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i1 = i1 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 29360, 27528, 1921);
   __ZN2cv6String10deallocateEv(i5);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  i1 = (HEAP32[i1 + (i7 * 56 | 0) >> 2] & 32768 | 0) != 0;
  STACKTOP = i8;
  return i1 | 0;
 } else if ((i2 | 0) == 720896) {
  i3 = HEAP32[i3 + 8 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0 <= i7 >>> 0) {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   i2 = (__ZN2cv6String8allocateEj(i6, 21) | 0) + 0 | 0;
   i1 = 29320 | 0;
   i4 = i2 + 21 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i1 = i1 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i6, 29360, 27528, 1928);
   __ZN2cv6String10deallocateEv(i6);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  i1 = (HEAP32[i1 + (i7 * 48 | 0) >> 2] & 32768 | 0) != 0;
  STACKTOP = i8;
  return i1 | 0;
 } else if ((i2 | 0) == 65536) {
  if ((i7 | 0) >= 0) {
   i1 = 0;
   STACKTOP = i8;
   return i1 | 0;
  }
  i1 = (HEAP32[HEAP32[i3 + 8 >> 2] >> 2] & 32768 | 0) != 0;
  STACKTOP = i8;
  return i1 | 0;
 } else if ((i2 | 0) == 655360) {
  if ((i7 | 0) >= 0) {
   i1 = 0;
   STACKTOP = i8;
   return i1 | 0;
  }
  i1 = (HEAP32[HEAP32[i3 + 8 >> 2] >> 2] & 32768 | 0) != 0;
  STACKTOP = i8;
  return i1 | 0;
 } else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i1, 29360, 27528, 1932);
  __ZN2cv6String10deallocateEv(i1);
  i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cvL13addWeighted8sEPKajS1_jPajNS_5Size_IiEEPv(i4, i18, i3, i19, i5, i17, i1, i2) {
 i4 = i4 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 i19 = i19 | 0;
 i5 = i5 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i20 = 0, f21 = f0;
 i20 = STACKTOP;
 i16 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i2 >> 3]);
 f15 = Math_fround(+HEAPF64[i2 + 8 >> 3]);
 f10 = Math_fround(+HEAPF64[i2 + 16 >> 3]);
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 i11 = i16 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i13 = i16 & -4;
 i9 = i1;
 while (1) {
  i9 = i9 + -1 | 0;
  if (i12) i2 = 0; else {
   i8 = 0;
   do {
    f21 = Math_fround(f14 * Math_fround(HEAP8[i4 + i8 >> 0] | 0));
    i2 = _lrint(+Math_fround(f10 + Math_fround(f21 + Math_fround(f15 * Math_fround(HEAP8[i3 + i8 >> 0] | 0))))) | 0;
    if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
    i6 = i8 | 1;
    f21 = Math_fround(f14 * Math_fround(HEAP8[i4 + i6 >> 0] | 0));
    i1 = _lrint(+Math_fround(f10 + Math_fround(f21 + Math_fround(f15 * Math_fround(HEAP8[i3 + i6 >> 0] | 0))))) | 0;
    if ((i1 + 128 | 0) >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 127 : -128;
    HEAP8[i5 + i8 >> 0] = i2;
    HEAP8[i5 + i6 >> 0] = i1;
    i7 = i8 | 2;
    f21 = Math_fround(f14 * Math_fround(HEAP8[i4 + i7 >> 0] | 0));
    i2 = _lrint(+Math_fround(f10 + Math_fround(f21 + Math_fround(f15 * Math_fround(HEAP8[i3 + i7 >> 0] | 0))))) | 0;
    if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
    i1 = i8 | 3;
    f21 = Math_fround(f14 * Math_fround(HEAP8[i4 + i1 >> 0] | 0));
    i6 = _lrint(+Math_fround(f10 + Math_fround(f21 + Math_fround(f15 * Math_fround(HEAP8[i3 + i1 >> 0] | 0))))) | 0;
    if ((i6 + 128 | 0) >>> 0 >= 256) i6 = (i6 | 0) > 0 ? 127 : -128;
    HEAP8[i5 + i7 >> 0] = i2;
    HEAP8[i5 + i1 >> 0] = i6;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i11 | 0));
   i2 = i13;
  }
  if ((i2 | 0) < (i16 | 0)) do {
   f21 = Math_fround(f14 * Math_fround(HEAP8[i4 + i2 >> 0] | 0));
   i1 = _lrint(+Math_fround(f10 + Math_fround(f21 + Math_fround(f15 * Math_fround(HEAP8[i3 + i2 >> 0] | 0))))) | 0;
   if ((i1 + 128 | 0) >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 127 : -128;
   HEAP8[i5 + i2 >> 0] = i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i16 | 0));
  if (!i9) break; else {
   i3 = i3 + i19 | 0;
   i4 = i4 + i18 | 0;
   i5 = i5 + i17 | 0;
  }
 }
 STACKTOP = i20;
 return;
}

function _wcsrtombs(i6, i11, i10, i1) {
 i6 = i6 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i9;
 if (!i6) {
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) {
   i10 = 0;
   STACKTOP = i9;
   return i10 | 0;
  } else i1 = 0;
  while (1) {
   if (i2 >>> 0 > 127) {
    i2 = _wcrtomb(i8, i2, 0) | 0;
    if ((i2 | 0) == -1) {
     i7 = -1;
     i5 = 26;
     break;
    }
   } else i2 = 1;
   i1 = i2 + i1 | 0;
   i3 = i3 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = i1;
    i5 = 26;
    break;
   }
  }
  if ((i5 | 0) == 26) {
   STACKTOP = i9;
   return i7 | 0;
  }
 }
 L14 : do if (i10 >>> 0 > 3) {
  i1 = i6;
  i2 = i10;
  i3 = HEAP32[i11 >> 2] | 0;
  while (1) {
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 + -1 | 0) >>> 0 > 126) {
    if (!i4) break;
    i4 = _wcrtomb(i1, i4, 0) | 0;
    if ((i4 | 0) == -1) {
     i7 = -1;
     i5 = 26;
     break;
    }
    i1 = i1 + i4 | 0;
    i2 = i2 - i4 | 0;
   } else {
    HEAP8[i1 >> 0] = i4;
    i1 = i1 + 1 | 0;
    i2 = i2 + -1 | 0;
    i3 = HEAP32[i11 >> 2] | 0;
   }
   i3 = i3 + 4 | 0;
   HEAP32[i11 >> 2] = i3;
   if (i2 >>> 0 <= 3) break L14;
  }
  if ((i5 | 0) == 26) {
   STACKTOP = i9;
   return i7 | 0;
  }
  HEAP8[i1 >> 0] = 0;
  HEAP32[i11 >> 2] = 0;
  i10 = i10 - i2 | 0;
  STACKTOP = i9;
  return i10 | 0;
 } else {
  i1 = i6;
  i2 = i10;
 } while (0);
 if (!i2) {
  STACKTOP = i9;
  return i10 | 0;
 }
 i6 = HEAP32[i11 >> 2] | 0;
 while (1) {
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 + -1 | 0) >>> 0 > 126) {
   if (!i3) {
    i5 = 19;
    break;
   }
   i4 = _wcrtomb(i8, i3, 0) | 0;
   if ((i4 | 0) == -1) {
    i7 = -1;
    i5 = 26;
    break;
   }
   if (i2 >>> 0 < i4 >>> 0) {
    i5 = 22;
    break;
   }
   _wcrtomb(i1, HEAP32[i6 >> 2] | 0, 0) | 0;
   i5 = i1 + i4 | 0;
   i3 = i2 - i4 | 0;
   i4 = i6;
  } else {
   HEAP8[i1 >> 0] = i3;
   i5 = i1 + 1 | 0;
   i3 = i2 + -1 | 0;
   i4 = HEAP32[i11 >> 2] | 0;
  }
  i6 = i4 + 4 | 0;
  HEAP32[i11 >> 2] = i6;
  if (!i3) {
   i7 = i10;
   i5 = 26;
   break;
  } else {
   i1 = i5;
   i2 = i3;
  }
 }
 if ((i5 | 0) == 19) {
  HEAP8[i1 >> 0] = 0;
  HEAP32[i11 >> 2] = 0;
  i10 = i10 - i2 | 0;
  STACKTOP = i9;
  return i10 | 0;
 } else if ((i5 | 0) == 22) {
  i10 = i10 - i2 | 0;
  STACKTOP = i9;
  return i10 | 0;
 } else if ((i5 | 0) == 26) {
  STACKTOP = i9;
  return i7 | 0;
 }
 return 0;
}

function _main(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i5 = i10 + 64 | 0;
 i11 = i10 + 60 | 0;
 i3 = i10 + 48 | 0;
 i4 = i10 + 36 | 0;
 i6 = i10 + 24 | 0;
 i7 = i10 + 12 | 0;
 i8 = i10;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i11 >> 2] = 3784;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, 3792, 4);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, 3800, 4);
 __ZN4perf10Regression4InitERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i3, i4);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
 i3 = i11 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = __Znwj(12) | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i1 >> 2] = i2 + 12;
 i1 = i11;
 do {
  if (!i2) i2 = 0; else {
   i11 = HEAP32[i1 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i11, _strlen(i11 | 0) | 0);
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i2 = i2 + 12 | 0;
  HEAP32[i4 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN4perf8TestBase4InitERKNSt3__16vectorINS1_12basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEENS6_IS8_EEEEiPKPKc(i6, HEAP32[i5 >> 2] | 0, i9);
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1) {
  while (1) {
   i2 = HEAP32[i4 >> 2] | 0;
   if ((i2 | 0) == (i1 | 0)) break;
   i3 = i2 + -12 | 0;
   HEAP32[i4 >> 2] = i3;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
  }
  __ZdlPv(HEAP32[i6 >> 2] | 0);
 }
 __ZN7testing14InitGoogleTestEPiPPc(i5, i9);
 __ZN6cvtest16printVersionInfoEb(1);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, 3808, 14);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, 3792, 4);
 __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i7, i8);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 __ZN4perf8TestBase19RecordRunParametersEv();
 i9 = __ZN7testing8UnitTest3RunEv(__ZN7testing8UnitTest11GetInstanceEv() | 0) | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZNK2cv5MatOp6divideEdRKNS_7MatExprERS1_(i1, d7, i3, i6) {
 i1 = i1 | 0;
 d7 = +d7;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i11 = i15 + 56 | 0;
 i8 = i15;
 HEAP32[i11 >> 2] = 1124007936;
 i13 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i10 = i11 + 40 | 0;
 i1 = i13 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i10 >> 2] = i2;
 i14 = i11 + 48 | 0;
 i12 = i11 + 44 | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 i9 = HEAP32[i3 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] & 63](i9, i3, i11, -1);
 HEAP32[i8 >> 2] = 1124007936;
 i9 = i8 + 4 | 0;
 i2 = i8 + 8 | 0;
 i3 = i8 + 40 | 0;
 i1 = i9 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i3 >> 2] = i2;
 i5 = i8 + 48 | 0;
 i4 = i8 + 44 | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i8 + 52 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 __ZN2cv9MatOp_Bin8makeExprERNS_7MatExprEcRKNS_3MatES5_d(i6, 47, i11, i8, d7);
 i2 = i8 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i1 = i1 + 12 | 0, i6 = HEAP32[i1 >> 2] | 0, HEAP32[i1 >> 2] = i6 + -1, (i6 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i8);
 HEAP32[i2 >> 2] = 0;
 i8 = i8 + 16 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if ((HEAP32[i9 >> 2] | 0) > 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i9 >> 2] | 0));
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i5 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i8 = i1 + 12 | 0, i9 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i11 = i11 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i13 >> 2] | 0) > 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i13 >> 2] | 0));
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i14 | 0)) {
  STACKTOP = i15;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i15;
 return;
}

function __ZNK2cv11MatOp_Solve6assignERKNS_7MatExprERNS_3MatEi(i1, i9, i10, i8) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i13 = i15 + 80 | 0;
 i4 = i15 + 60 | 0;
 i5 = i15 + 40 | 0;
 i6 = i15 + 20 | 0;
 i7 = i15;
 HEAP32[i13 >> 2] = 1124007936;
 i14 = i13 + 4 | 0;
 i2 = i13 + 8 | 0;
 i11 = i13 + 40 | 0;
 i1 = i14 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i11 >> 2] = i2;
 i12 = i13 + 48 | 0;
 i3 = i13 + 44 | 0;
 HEAP32[i3 >> 2] = i12;
 HEAP32[i13 + 52 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 if ((i8 | 0) != -1 ? (HEAP32[i9 + 8 >> 2] & 4095 | 0) != (i8 | 0) : 0) i2 = i13; else i2 = i10;
 HEAP32[i4 >> 2] = 32088;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 16842752;
 HEAP32[i4 + 8 >> 2] = i9 + 8;
 HEAP32[i5 >> 2] = 32088;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 16842752;
 HEAP32[i5 + 8 >> 2] = i9 + 64;
 i1 = i6 + 4 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = 32232;
 HEAP32[i1 >> 2] = 33619968;
 HEAP32[i6 + 8 >> 2] = i2;
 __ZN2cv5solveERKNS_11_InputArrayES2_RKNS_12_OutputArrayEi(i4, i5, i6, HEAP32[i9 + 4 >> 2] | 0) | 0;
 if ((HEAP32[i2 + 16 >> 2] | 0) != (HEAP32[i10 + 16 >> 2] | 0)) {
  i9 = i7 + 4 | 0;
  HEAP32[i9 + 0 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i7 >> 2] = 32232;
  HEAP32[i9 >> 2] = 33619968;
  HEAP32[i7 + 8 >> 2] = i10;
  __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i2, i7, i8, 1.0, 0.0);
 }
 i2 = i13 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i13);
 HEAP32[i2 >> 2] = 0;
 i10 = i13 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i14 >> 2] | 0) > 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i14 >> 2] | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i12 | 0)) {
  STACKTOP = i15;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i15;
 return;
}

function __ZNSt3__16vectorIN2cv3VecIiLi6EEENS_9allocatorIS3_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 i9 = i10 + 8 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1;
 if (((i4 - i3 | 0) / 24 | 0) >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    HEAP32[i1 + 0 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 0;
    HEAP32[i1 + 20 >> 2] = 0;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i1 = i1 + 24 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((i3 - i1 | 0) / 24 | 0) + i2 | 0;
 if (i3 >>> 0 > 178956970) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i5 = i1;
 i1 = (i4 - i5 | 0) / 24 | 0;
 if (i1 >>> 0 < 89478485) {
  i1 = i1 << 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = ((HEAP32[i11 >> 2] | 0) - i5 | 0) / 24 | 0;
  if (!i1) {
   i5 = 0;
   i8 = 0;
   i7 = i3;
  } else i6 = 10;
 } else {
  i1 = 178956970;
  i3 = ((HEAP32[i11 >> 2] | 0) - i5 | 0) / 24 | 0;
  i6 = 10;
 }
 if ((i6 | 0) == 10) {
  i5 = i1;
  i8 = __Znwj(i1 * 24 | 0) | 0;
  i7 = i3;
 }
 i1 = i8 + (i7 * 24 | 0) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else {
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
  }
  i3 = i3 + 24 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = i8 + (i5 * 24 | 0) | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  i4 = i5 + -24 - i2 | 0;
  while (1) {
   i13 = i5;
   i5 = i5 + -24 | 0;
   HEAP32[i1 + -24 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + -20 >> 2] = HEAP32[i13 + -20 >> 2];
   HEAP32[i1 + -16 >> 2] = HEAP32[i13 + -16 >> 2];
   HEAP32[i1 + -12 >> 2] = HEAP32[i13 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i13 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i13 + -4 >> 2];
   if ((i5 | 0) == (i2 | 0)) break; else i1 = i1 + -24 | 0;
  }
  i1 = i8 + ((i7 + ~((i4 >>> 0) / 24 | 0) | 0) * 24 | 0) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i12;
 return;
}

function __ZN2cv15NAryMatIteratorppEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 i2 = i12 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 >>> 0 >= ((HEAP32[i12 + 16 >> 2] | 0) + -1 | 0) >>> 0) {
  STACKTOP = i13;
  return i12 | 0;
 }
 i11 = i1 + 1 | 0;
 HEAP32[i2 >> 2] = i11;
 i10 = HEAP32[i12 + 24 >> 2] | 0;
 if ((i10 | 0) != 1) {
  i6 = HEAP32[i12 + 12 >> 2] | 0;
  if ((i6 | 0) <= 0) {
   STACKTOP = i13;
   return i12 | 0;
  }
  i7 = i12 + 8 | 0;
  i8 = i12 + 4 | 0;
  i9 = 0;
  do {
   i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   i3 = HEAP32[i4 + 16 >> 2] | 0;
   if (i3) {
    if ((i10 | 0) > 0 & (i11 | 0) > 0) {
     i5 = HEAP32[i4 + 40 >> 2] | 0;
     i2 = HEAP32[i4 + 44 >> 2] | 0;
     i1 = i11;
     i4 = i10;
     do {
      i4 = i4 + -1 | 0;
      i14 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
      i15 = i1;
      i1 = (i1 | 0) / (i14 | 0) | 0;
      i14 = i15 - (Math_imul(i1, i14) | 0) | 0;
      i3 = i3 + (Math_imul(i14, HEAP32[i2 + (i4 << 2) >> 2] | 0) | 0) | 0;
     } while ((i4 | 0) > 0 & (i1 | 0) > 0);
    }
    i4 = HEAP32[i7 >> 2] | 0;
    if (i4) HEAP32[i4 + (i9 << 2) >> 2] = i3;
    i4 = HEAP32[i8 >> 2] | 0;
    if (i4) HEAP32[i4 + (i9 * 56 | 0) + 16 >> 2] = i3;
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) < (i6 | 0));
  STACKTOP = i13;
  return i12 | 0;
 }
 i4 = i12 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 L25 : do if ((i2 | 0) != 0 ? (i3 = HEAP32[i12 + 12 >> 2] | 0, (i3 | 0) > 0) : 0) {
  i1 = 0;
  while (1) {
   i2 = i2 + (i1 << 2) | 0;
   if (HEAP32[i2 >> 2] | 0) {
    i10 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i10 + 16 >> 2] | 0) + (Math_imul(i11, HEAP32[HEAP32[i10 + 44 >> 2] >> 2] | 0) | 0);
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) break L25;
   i2 = HEAP32[i4 >> 2] | 0;
  }
 } while (0);
 i2 = HEAP32[i12 + 4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i13;
  return i12 | 0;
 }
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 if ((i1 | 0) <= 0) {
  STACKTOP = i13;
  return i12 | 0;
 }
 i4 = 0;
 do {
  i3 = i2 + (i4 * 56 | 0) + 16 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i10 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   HEAP32[i3 >> 2] = (HEAP32[i10 + 16 >> 2] | 0) + (Math_imul(i11, HEAP32[HEAP32[i10 + 44 >> 2] >> 2] | 0) | 0);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i1 | 0));
 STACKTOP = i13;
 return i12 | 0;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE(i1, i5, i7, i8, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i9 = 0;
 i6 = STACKTOP;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1) {
   HEAP32[i5 >> 2] = 0;
   i1 = 0;
   break;
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   break;
  }
 } else i1 = 0; while (0);
 i1 = (i1 | 0) == 0;
 i2 = HEAP32[i7 >> 2] | 0;
 do if (i2) {
  if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0) == -1 : 0) {
   HEAP32[i7 >> 2] = 0;
   i9 = 11;
   break;
  }
  if (!i1) i9 = 12;
 } else i9 = 11; while (0);
 if ((i9 | 0) == 11) if (i1) i9 = 12; else i2 = 0;
 if ((i9 | 0) == 12) {
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 6;
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0; else i1 = HEAPU8[i3 >> 0] | 0;
 if ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] & 63](i4, i1 & 255, 0) | 0) << 24 >> 24 != 37) {
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 4;
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
  FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] & 127](i1) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 } else HEAP32[i3 >> 2] = i4 + 1;
 do if (i1) {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1) {
   HEAP32[i5 >> 2] = 0;
   i1 = 0;
   break;
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   break;
  }
 } else i1 = 0; while (0);
 i1 = (i1 | 0) == 0;
 do if (i2) {
  if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0) == -1 : 0) {
   HEAP32[i7 >> 2] = 0;
   i9 = 31;
   break;
  }
  if (i1) {
   STACKTOP = i6;
   return;
  }
 } else i9 = 31; while (0);
 if ((i9 | 0) == 31 ? !i1 : 0) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
 STACKTOP = i6;
 return;
}

function __ZNK2cv5MatOp3absERKNS_7MatExprERS1_(i1, i3, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i10 = i14 + 56 | 0;
 i7 = i14;
 HEAP32[i10 >> 2] = 1124007936;
 i12 = i10 + 4 | 0;
 i2 = i10 + 8 | 0;
 i9 = i10 + 40 | 0;
 i1 = i12 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i9 >> 2] = i2;
 i13 = i10 + 48 | 0;
 i11 = i10 + 44 | 0;
 HEAP32[i11 >> 2] = i13;
 HEAP32[i10 + 52 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 i8 = HEAP32[i3 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] & 63](i8, i3, i10, -1);
 HEAP32[i7 >> 2] = 1124007936;
 i8 = i7 + 4 | 0;
 i2 = i7 + 8 | 0;
 i3 = i7 + 40 | 0;
 i1 = i8 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i3 >> 2] = i2;
 i5 = i7 + 48 | 0;
 i4 = i7 + 44 | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i7 + 52 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 __ZN2cv9MatOp_Bin8makeExprERNS_7MatExprEcRKNS_3MatES5_d(i6, 97, i10, i7, 1.0);
 i2 = i7 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i1 = i1 + 12 | 0, i6 = HEAP32[i1 >> 2] | 0, HEAP32[i1 >> 2] = i6 + -1, (i6 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i7);
 HEAP32[i2 >> 2] = 0;
 i7 = i7 + 16 | 0;
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 if ((HEAP32[i8 >> 2] | 0) > 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i8 >> 2] | 0));
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i5 | 0)) __ZN2cv8fastFreeEPv(i2);
 i2 = i10 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i7 = i1 + 12 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i10);
 HEAP32[i2 >> 2] = 0;
 i10 = i10 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i14;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i14;
 return;
}

function __ZL22icvXMLStartWriteStructP13CvFileStoragePKciS2_(i14, i15, i8, i2) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i7 = i16 + 56 | 0;
 i6 = i16 + 16 | 0;
 i1 = i16 + 8 | 0;
 i12 = i16;
 i13 = i8 & 15 | 32;
 if ((i8 & 7) >>> 0 <= 4) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i1, 66) | 0) + 0 | 0;
  i4 = 17296 | 0;
  i5 = i3 + 66 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i1, 17368, 8960, 2368);
  __ZN2cv6String10deallocateEv(i1);
 }
 if (!i2) i1 = 0; else {
  HEAP32[i6 >> 2] = 15840;
  HEAP32[i6 + 4 >> 2] = i2;
  i1 = 2;
 }
 HEAP32[i6 + (i1 << 2) >> 2] = 0;
 __ZL14icvXMLWriteTagP13CvFileStoragePKci10CvAttrList(i14, i15, 1, i6, 0);
 i9 = i14 + 44 | 0;
 HEAP32[i7 + 20 >> 2] = HEAP32[i9 >> 2] & -33;
 i3 = i14 + 40 | 0;
 HEAP32[i7 + 16 >> 2] = HEAP32[i3 >> 2];
 i10 = i14 + 48 | 0;
 i6 = i10;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = i7 + 8 | 0;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 4 >> 2] = i4;
 i11 = i14 + 24 | 0;
 _cvSaveMemStoragePos(HEAP32[i11 >> 2] | 0, i7);
 _cvSeqPush(HEAP32[i14 + 36 >> 2] | 0, i7) | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + 2 | 0;
 HEAP32[i3 >> 2] = i4;
 if (!(i8 & 8)) {
  i2 = i14 + 72 | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  i7 = i14 + 76 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i8 = i14 + 56 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  if (i5 >>> 0 > (i1 + i6 | 0) >>> 0) {
   HEAP8[i5 >> 0] = 10;
   HEAP8[i5 + 1 >> 0] = 0;
   __ZL7icvPutsP13CvFileStoragePKc(i14, HEAP32[i7 >> 2] | 0);
   i1 = HEAP32[i7 >> 2] | 0;
   HEAP32[i2 >> 2] = i1;
   i4 = HEAP32[i3 >> 2] | 0;
   i6 = HEAP32[i8 >> 2] | 0;
  }
  if ((i4 | 0) != (i6 | 0)) {
   if ((i4 | 0) > (i6 | 0)) {
    _memset(i1 + i6 | 0, 32, i4 - i6 | 0) | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   HEAP32[i8 >> 2] = i4;
  }
  HEAP32[i2 >> 2] = i1 + i4;
 }
 HEAP32[i9 >> 2] = i13;
 if (!i15) {
  HEAP32[i14 + 52 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  STACKTOP = i16;
  return;
 } else {
  _cvMemStorageAllocString(i12, HEAP32[i11 >> 2] | 0, i15, -1);
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  STACKTOP = i16;
  return;
 }
}

function __ZNSt3__16vectorIN7testing8internal10linked_ptrINS2_25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE8TestInfoEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i14, i7) {
 i14 = i14 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 i12 = i14 + 4 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i3 = ((HEAP32[i12 >> 2] | 0) - i1 >> 3) + 1 | 0;
 if (i3 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i14);
 i13 = i14 + 8 | 0;
 i2 = (HEAP32[i13 >> 2] | 0) - i1 | 0;
 if (i2 >> 3 >>> 0 < 268435455) {
  i2 = i2 >> 2;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = (HEAP32[i12 >> 2] | 0) - i1 >> 3;
  if (!i2) {
   i5 = 0;
   i11 = 0;
  } else i6 = 6;
 } else {
  i2 = 536870911;
  i1 = (HEAP32[i12 >> 2] | 0) - i1 >> 3;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i5 = i2;
  i11 = __Znwj(i2 << 3) | 0;
 }
 i2 = i11 + (i1 << 3) | 0;
 i10 = i11 + (i5 << 3) | 0;
 do if (i2) {
  i9 = HEAP32[i7 >> 2] | 0;
  HEAP32[i2 >> 2] = i9;
  i6 = i11 + (i1 << 3) + 4 | 0;
  if (!i9) {
   HEAP32[i6 >> 2] = i6;
   break;
  }
  i3 = i7 + 4 | 0;
  i5 = i3;
  while (1) {
   i4 = HEAP32[i5 >> 2] | 0;
   if ((i4 | 0) == (i3 | 0)) break; else i5 = i4;
  }
  HEAP32[i5 >> 2] = i6;
  HEAP32[i6 >> 2] = i3;
 } while (0);
 i9 = i11 + (i1 + 1 << 3) | 0;
 i8 = HEAP32[i14 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if ((i4 | 0) == (i8 | 0)) {
  i3 = i8;
  i1 = i8;
 } else {
  i7 = i1 + -1 - ((i4 + -8 - i8 | 0) >>> 3) | 0;
  while (1) {
   i5 = i4;
   i4 = i4 + -8 | 0;
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i2 + -8 >> 2] = i6;
   i1 = i2 + -4 | 0;
   if (!i6) HEAP32[i1 >> 2] = i1; else {
    i6 = i5 + -4 | 0;
    i3 = i6;
    while (1) {
     i5 = HEAP32[i3 >> 2] | 0;
     if ((i5 | 0) == (i6 | 0)) break; else i3 = i5;
    }
    HEAP32[i3 >> 2] = i1;
    HEAP32[i1 >> 2] = i6;
   }
   if ((i4 | 0) == (i8 | 0)) break; else i2 = i2 + -8 | 0;
  }
  i2 = i11 + (i7 << 3) | 0;
  i3 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i2;
 HEAP32[i12 >> 2] = i9;
 HEAP32[i13 >> 2] = i10;
 while (1) {
  if ((i1 | 0) == (i3 | 0)) break;
  i10 = i1 + -8 | 0;
  __ZN7testing8internal10linked_ptrINS0_25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE8TestInfoEED2Ev(i10);
  i1 = i10;
 }
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 __ZdlPv(i3);
 STACKTOP = i15;
 return;
}

function _cvReleaseFileStorage(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i12;
 if (!i5) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i2, 35) | 0) + 0 | 0;
  i3 = 9032 | 0;
  i4 = i1 + 35 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i2, 9072, 8960, 550);
  __ZN2cv6String10deallocateEv(i2);
 }
 i11 = HEAP32[i5 >> 2] | 0;
 if (!i11) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i5 >> 2] = 0;
 __ZL8icvCloseP13CvFileStoragePN2cv6StringE(i11, 0);
 _cvReleaseMemStorage(i11 + 24 | 0);
 i10 = i11 + 76 | 0;
 _cvFree_(HEAP32[i10 >> 2] | 0);
 HEAP32[i10 >> 2] = 0;
 _cvReleaseMemStorage(i11 + 16 | 0);
 i10 = HEAP32[i11 + 268 >> 2] | 0;
 if (i10) {
  i8 = i10 + 4 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i7 = i10 + 16 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i5 + (i4 >>> 12 << 2) | 0;
  i9 = i10 + 8 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if ((i2 | 0) == (i5 | 0)) {
   i1 = 0;
   i6 = i10 + 20 | 0;
   i4 = 0;
  } else {
   i6 = i10 + 20 | 0;
   i1 = (HEAP32[i6 >> 2] | 0) + i4 | 0;
   i1 = (HEAP32[i5 + (i1 >>> 12 << 2) >> 2] | 0) + (i1 & 4095) | 0;
   i4 = (HEAP32[i3 >> 2] | 0) + (i4 & 4095) | 0;
  }
  L13 : while (1) {
   do {
    if ((i4 | 0) == (i1 | 0)) break L13;
    i4 = i4 + 1 | 0;
   } while ((i4 - (HEAP32[i3 >> 2] | 0) | 0) != 4096);
   i13 = i3 + 4 | 0;
   i4 = HEAP32[i13 >> 2] | 0;
   i3 = i13;
  }
  HEAP32[i6 >> 2] = 0;
  i4 = i2 - i5 >> 2;
  if (i4 >>> 0 > 2) do {
   __ZdlPv(HEAP32[i5 >> 2] | 0);
   i5 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
   HEAP32[i8 >> 2] = i5;
   i4 = (HEAP32[i9 >> 2] | 0) - i5 >> 2;
  } while (i4 >>> 0 > 2);
  if ((i4 | 0) == 1) HEAP32[i7 >> 2] = 2048; else if ((i4 | 0) == 2) HEAP32[i7 >> 2] = 4096;
  i4 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  if ((i4 | 0) != (i5 | 0)) {
   do {
    __ZdlPv(HEAP32[i4 >> 2] | 0);
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != (i5 | 0));
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
  }
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1) __ZdlPv(i1);
  __ZdlPv(i10);
 }
 _memset(i11 | 0, 0, 276) | 0;
 _cvFree_(i11);
 STACKTOP = i12;
 return;
}

function __ZNSt3__16vectorIN2cv4UMatENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i13, i12) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 i9 = HEAP32[i13 >> 2] | 0;
 i10 = i13 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = i12 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i9 | 0)) {
  i7 = i2;
  i8 = i9;
  HEAP32[i13 >> 2] = i7;
  HEAP32[i11 >> 2] = i8;
  i8 = i12 + 8 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  HEAP32[i10 >> 2] = i7;
  HEAP32[i8 >> 2] = i9;
  i8 = i13 + 8 | 0;
  i10 = i12 + 12 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i10 >> 2] = i9;
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i12 >> 2] = i10;
  STACKTOP = i14;
  return;
 }
 do {
  i7 = i2 + -48 | 0;
  i3 = i1;
  i1 = i1 + -48 | 0;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i8 = i2 + -44 | 0;
  i4 = i3 + -44 | 0;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  i15 = i2 + -40 | 0;
  HEAP32[i15 >> 2] = HEAP32[i3 + -40 >> 2];
  HEAP32[i2 + -36 >> 2] = HEAP32[i3 + -36 >> 2];
  HEAP32[i2 + -32 >> 2] = HEAP32[i3 + -32 >> 2];
  HEAP32[i2 + -28 >> 2] = HEAP32[i3 + -28 >> 2];
  i5 = HEAP32[i3 + -24 >> 2] | 0;
  HEAP32[i2 + -24 >> 2] = i5;
  HEAP32[i2 + -20 >> 2] = HEAP32[i3 + -20 >> 2];
  HEAP32[i2 + -16 >> 2] = i15;
  i15 = i2 + -8 | 0;
  i6 = i2 + -12 | 0;
  HEAP32[i6 >> 2] = i15;
  HEAP32[i2 + -4 >> 2] = 0;
  HEAP32[i15 >> 2] = 0;
  if (i5) {
   i5 = i5 + 8 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  }
  if ((HEAP32[i4 >> 2] | 0) < 3) {
   i7 = HEAP32[i3 + -12 >> 2] | 0;
   i8 = HEAP32[i6 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  } else {
   HEAP32[i8 >> 2] = 0;
   __ZN2cv4UMat8copySizeERKS0_(i7, i1);
  }
  i2 = (HEAP32[i11 >> 2] | 0) + -48 | 0;
  HEAP32[i11 >> 2] = i2;
 } while ((i1 | 0) != (i9 | 0));
 i9 = i2;
 i8 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = i9;
 HEAP32[i11 >> 2] = i8;
 i8 = i12 + 8 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i9;
 i8 = i13 + 8 | 0;
 i10 = i12 + 12 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i10 >> 2] = i9;
 i10 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 >> 2] = i10;
 STACKTOP = i14;
 return;
}

function __ZNK7testing8internal23CartesianProductHolder2INS0_11ValueArray1IN2cv5Size_IiEEEENS0_11ValueArray4IiiiiEEEcvNS0_14ParamGeneratorINSt3tr15tupleIT_T0_vvvvvvvvEEEEIS5_N4perf7MatTypeEEEv(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i11 = i12 + 8 | 0;
 i7 = i12;
 i8 = __Znwj(20) | 0;
 i3 = __Znwj(16) | 0;
 HEAP32[i3 >> 2] = 1536;
 i6 = i3 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i2 = i3 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 i10 = i3 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i10 >> 2] = i1 + 8;
 if (i1) {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 }
 HEAP32[i2 >> 2] = i1 + (((i4 + 8 + -8 - i4 | 0) >>> 3) + 1 << 3);
 HEAP32[i11 >> 2] = i3;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = i10;
 __ZNK7testing8internal11ValueArray4IiiiiEcvNS0_14ParamGeneratorIT_EEIN4perf7MatTypeEEEv(i7, i4 + 8 | 0);
 HEAP32[i8 >> 2] = 1928;
 i6 = HEAP32[i11 >> 2] | 0;
 HEAP32[i8 + 4 >> 2] = i6;
 i3 = i8 + 8 | 0;
 if (!i6) HEAP32[i3 >> 2] = i3; else {
  i1 = i10;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) == (i10 | 0)) break; else i1 = i2;
  }
  HEAP32[i1 >> 2] = i3;
  HEAP32[i3 >> 2] = i10;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i8 + 12 >> 2] = i5;
 i6 = (i5 | 0) == 0;
 i1 = i8 + 16 | 0;
 if (i6) {
  HEAP32[i1 >> 2] = i1;
  i4 = i7 + 4 | 0;
 } else {
  i4 = i7 + 4 | 0;
  i2 = i4;
  while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (i4 | 0)) break; else i2 = i3;
  }
  HEAP32[i2 >> 2] = i1;
  HEAP32[i1 >> 2] = i4;
 }
 HEAP32[i9 >> 2] = i8;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  if (!i6) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 511](i5);
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (i4 | 0)) break; else i2 = i3;
  }
  HEAP32[i2 >> 2] = i1;
 }
 i3 = HEAP32[i10 >> 2] | 0;
 if ((i3 | 0) != (i10 | 0)) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == (i10 | 0)) break; else i2 = i1;
  }
  HEAP32[i2 >> 2] = i3;
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 STACKTOP = i12;
 return;
}

function _cvInitMatHeader(i11, i1, i7, i9, i8, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i3 = i12 + 16 | 0;
 i6 = i12 + 8 | 0;
 i10 = i12;
 if (!i11) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i3, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i3, 41096, 40912, 146);
  __ZN2cv6String10deallocateEv(i3);
 }
 if ((i1 | 0) < 0 | (i7 | 0) < 1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i6, 25) | 0) + 0 | 0;
  i3 = 41112 | 0;
  i5 = i4 + 25 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i4 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i6, 41096, 40912, 152);
  __ZN2cv6String10deallocateEv(i6);
 }
 i6 = i9 & 4095 | 1111621632;
 HEAP32[i11 >> 2] = i6;
 i3 = i11 + 20 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i11 + 24 >> 2] = i7;
 HEAP32[i11 + 16 >> 2] = i8;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 i4 = Math_imul((i9 >>> 3 & 511) + 1 << (47696 >>> (i9 << 1 & 14) & 3), i7) | 0;
 if ((i2 | 0) == 0 | (i2 | 0) == 2147483647) {
  HEAP32[i11 + 4 >> 2] = i4;
  i2 = i4;
 } else {
  if ((i4 | 0) > (i2 | 0)) {
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   __ZN2cv6String8allocateEj(i10, 0) | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-13, i10, 41096, 40912, 168);
   __ZN2cv6String10deallocateEv(i10);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i11 + 4 >> 2] = i2;
 }
 if ((i1 | 0) == 1) {
  i10 = 16384;
  i9 = (i2 | 0) < 0;
  i9 = i9 << 31 >> 31;
  i7 = (i1 | 0) < 0;
  i7 = i7 << 31 >> 31;
  i9 = ___muldi3(i1 | 0, i7 | 0, i2 | 0, i9 | 0) | 0;
  i7 = tempRet0;
  i8 = (i7 | 0) > 0;
  i9 = i9 >>> 0 > 2147483647;
  i7 = (i7 | 0) == 0;
  i9 = i7 & i9;
  i9 = i8 | i9;
  i10 = i9 ? 0 : i10;
  i10 = i6 | i10;
  HEAP32[i11 >> 2] = i10;
  STACKTOP = i12;
  return i11 | 0;
 }
 i10 = (i2 | 0) == (i4 | 0) ? 16384 : 0;
 i9 = (i2 | 0) < 0;
 i9 = i9 << 31 >> 31;
 i7 = (i1 | 0) < 0;
 i7 = i7 << 31 >> 31;
 i9 = ___muldi3(i1 | 0, i7 | 0, i2 | 0, i9 | 0) | 0;
 i7 = tempRet0;
 i8 = (i7 | 0) > 0;
 i9 = i9 >>> 0 > 2147483647;
 i7 = (i7 | 0) == 0;
 i9 = i7 & i9;
 i9 = i8 | i9;
 i10 = i9 ? 0 : i10;
 i10 = i6 | i10;
 HEAP32[i11 >> 2] = i10;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN7testing10TestResult14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKNS_12TestPropertyE(i8, i1, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i5 = i11 + 24 | 0;
 i6 = i11 + 12 | 0;
 i10 = i11;
 if (!(__ZN7testing10TestResult20ValidateTestPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKNS_12TestPropertyE(i1, i9) | 0)) {
  STACKTOP = i11;
  return;
 }
 i4 = i8 + 16 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i7 = i8 + 20 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP8[i9 >> 0] & 1)) i1 = i9 + 1 | 0; else i1 = HEAP32[i9 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i1, _strlen(i1 | 0) | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i5, i6);
 L8 : do if ((i2 | 0) != (i3 | 0)) {
  i1 = i2;
  while (1) {
   if (!(HEAP8[i1 >> 0] & 1)) i2 = i1 + 1 | 0; else i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!(__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i5, i2) | 0)) {
    i2 = i1;
    break L8;
   }
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i3 | 0)) {
    i2 = i3;
    break;
   }
  }
 } while (0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 if ((i2 | 0) != (HEAP32[i7 >> 2] | 0)) {
  i1 = i9 + 12 | 0;
  if (!(HEAP8[i1 >> 0] & 1)) i1 = i1 + 1 | 0; else i1 = HEAP32[i9 + 20 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i1, _strlen(i1 | 0) | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2 + 12 | 0, i10) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
  STACKTOP = i11;
  return;
 }
 if ((i2 | 0) == (HEAP32[i8 + 24 >> 2] | 0)) {
  __ZNSt3__16vectorIN7testing12TestPropertyENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i4, i9);
  STACKTOP = i11;
  return;
 }
 if (!i2) i1 = 0; else {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i2, i9);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i2 + 12 | 0, i9 + 12 | 0);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i1 + 24;
 STACKTOP = i11;
 return;
}

function _gz_decomp(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 i7 = i15 + 84 | 0;
 i8 = i15 + 100 | 0;
 i14 = HEAP32[i8 >> 2] | 0;
 i9 = i15 + 88 | 0;
 i10 = i15 + 76 | 0;
 i11 = i15 + 52 | 0;
 i6 = i15 + 32 | 0;
 i12 = i15 + 24 | 0;
 i13 = i15 + 16 | 0;
 i1 = 0;
 do {
  if (!(HEAP32[i9 >> 2] | 0)) {
   i5 = HEAP32[i10 >> 2] | 0;
   if (!((i5 | 0) == -5 | (i5 | 0) == 0)) {
    i1 = -1;
    i16 = 20;
    break;
   }
   if (HEAP32[i11 >> 2] | 0) {
    i16 = 12;
    break;
   }
   i4 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i12 >> 2] | 0;
   i2 = 0;
   do {
    i3 = _read(HEAP32[i13 >> 2] | 0, i4 + i2 | 0, i5 - i2 | 0) | 0;
    if ((i3 | 0) < 1) {
     i16 = 8;
     break;
    }
    i2 = i3 + i2 | 0;
   } while (i2 >>> 0 < i5 >>> 0);
   if ((i16 | 0) == 8) {
    i16 = 0;
    if ((i3 | 0) < 0) {
     i16 = 10;
     break;
    }
    HEAP32[i11 >> 2] = 1;
   }
   i5 = (HEAP32[i9 >> 2] | 0) + i2 | 0;
   HEAP32[i9 >> 2] = i5;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   if (!i5) {
    i16 = 12;
    break;
   }
  }
  i1 = _inflate(i7, 0) | 0;
  if ((i1 | 0) == -3) {
   i16 = 16;
   break;
  } else if ((i1 | 0) == 2 | (i1 | 0) == -2) {
   i16 = 14;
   break;
  } else if ((i1 | 0) == -4) {
   i16 = 15;
   break;
  }
  i2 = HEAP32[i8 >> 2] | 0;
 } while ((i2 | 0) != 0 & (i1 | 0) != 1);
 if ((i16 | 0) == 10) {
  _gz_error(i15, -1, _strerror(HEAP32[(___errno_location() | 0) >> 2] | 0) | 0);
  i10 = -1;
  STACKTOP = i17;
  return i10 | 0;
 } else if ((i16 | 0) == 12) {
  _gz_error(i15, -5, 143352);
  i2 = HEAP32[i8 >> 2] | 0;
 } else if ((i16 | 0) == 14) {
  _gz_error(i15, -2, 143376);
  i10 = -1;
  STACKTOP = i17;
  return i10 | 0;
 } else if ((i16 | 0) == 15) {
  _gz_error(i15, -4, 143328);
  i10 = -1;
  STACKTOP = i17;
  return i10 | 0;
 } else if ((i16 | 0) == 16) {
  i10 = HEAP32[i15 + 108 >> 2] | 0;
  _gz_error(i15, -3, (i10 | 0) == 0 ? 143416 : i10);
  i10 = -1;
  STACKTOP = i17;
  return i10 | 0;
 } else if ((i16 | 0) == 20) {
  STACKTOP = i17;
  return i1 | 0;
 }
 i10 = i14 - i2 | 0;
 HEAP32[i15 >> 2] = i10;
 HEAP32[i15 + 4 >> 2] = (HEAP32[i15 + 96 >> 2] | 0) + (0 - i10);
 if ((i1 | 0) != 1) {
  i10 = 0;
  STACKTOP = i17;
  return i10 | 0;
 }
 HEAP32[i15 + 44 >> 2] = 0;
 i10 = 0;
 STACKTOP = i17;
 return i10 | 0;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6sentryC2ERS3_b(i8, i7, i5) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i10;
 HEAP8[i8 >> 0] = 0;
 i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0;
 i2 = HEAP32[i7 + (i1 + 16) >> 2] | 0;
 if (i2) {
  __ZNSt3__18ios_base5clearEj(i7 + i1 | 0, i2 | 4);
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i7 + (i1 + 72) >> 2] | 0;
 if (i1) __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i1) | 0;
 do if (!i5 ? (i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0, (HEAP32[i7 + (i4 + 4) >> 2] & 4096 | 0) != 0) : 0) {
  __ZNSt3__16localeC2ERKS0_(i3, i7 + (i4 + 28) | 0);
  i5 = __ZNKSt3__16locale9use_facetERNS0_2idE(i3, 960728) | 0;
  __ZNSt3__16localeD2Ev(i3);
  i5 = i5 + 8 | 0;
  i1 = HEAP32[i7 + ((HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
  while (1) {
   if (!i1) break;
   if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    i2 = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1;
    i1 = i2 ? 0 : i1;
    if (!i1) break; else i6 = i1;
   } else i6 = i1;
   i4 = i6 + 12 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i3 = i6 + 16 | 0;
   if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] & 127](i6) | 0; else i1 = HEAPU8[i1 >> 0] | 0;
   if ((i1 & 255) << 24 >> 24 <= -1) {
    i9 = 18;
    break;
   }
   if (!(HEAP16[(HEAP32[i5 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 8192)) {
    i9 = 18;
    break;
   }
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
    FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] & 127](i6) | 0;
    i1 = i6;
    continue;
   } else {
    HEAP32[i4 >> 2] = i1 + 1;
    i1 = i6;
    continue;
   }
  }
  if ((i9 | 0) == 18 ? (i6 | 0) != 0 : 0) {
   if ((HEAP32[i6 + 12 >> 2] | 0) != (HEAP32[i6 + 16 >> 2] | 0)) break;
   if (!((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] & 127](i6) | 0) == -1 | (i6 | 0) == 0)) break;
  }
  i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0;
  __ZNSt3__18ios_base5clearEj(i7 + i1 | 0, HEAP32[i7 + (i1 + 16) >> 2] | 6);
 } while (0);
 HEAP8[i8 >> 0] = (HEAP32[i7 + ((HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) + 16) >> 2] | 0) == 0 & 1;
 STACKTOP = i10;
 return;
}

function __ZN2cvL13copyMask32sC4EPKhjS1_jPhjNS_5Size_IiEEPv(i5, i14, i3, i13, i4, i12, i2, i1) {
 i5 = i5 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i11 = STACKTOP;
 i10 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = i10 & -4;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i2 = 0; else {
   i1 = 0;
   do {
    if (HEAP8[i3 + i1 >> 0] | 0) {
     i2 = i4 + (i1 << 4) | 0;
     i15 = i5 + (i1 << 4) | 0;
     HEAP32[i2 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    }
    i2 = i1 | 1;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 << 4) | 0;
     i2 = i5 + (i2 << 4) | 0;
     HEAP32[i15 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    }
    i2 = i1 | 2;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 << 4) | 0;
     i2 = i5 + (i2 << 4) | 0;
     HEAP32[i15 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    }
    i2 = i1 | 3;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 << 4) | 0;
     i2 = i5 + (i2 << 4) | 0;
     HEAP32[i15 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i7 | 0));
   i2 = i9;
  }
  if ((i2 | 0) < (i10 | 0)) do {
   if (HEAP8[i3 + i2 >> 0] | 0) {
    i1 = i4 + (i2 << 4) | 0;
    i15 = i5 + (i2 << 4) | 0;
    HEAP32[i1 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
  if (!i6) break; else {
   i3 = i3 + i13 | 0;
   i4 = i4 + i12 | 0;
   i5 = i5 + i14 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN12_GLOBAL__N_124CLAHE_Interpolation_BodyItED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 182144;
 i1 = i4 + 188 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i4 + 196 | 0;
 if ((i2 | 0) != (i3 | 0)) {
  if (i2) __ZdaPv(i2);
  HEAP32[i1 >> 2] = i3;
  HEAP32[i4 + 192 >> 2] = 264;
 }
 i3 = i4 + 116 | 0;
 i2 = i4 + 152 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i1 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 132 | 0;
 i2 = i4 + 120 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i4 + 156 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 160 >> 2] | 0;
 if ((i1 | 0) != (i4 + 164 | 0)) __ZN2cv8fastFreeEPv(i1);
 i3 = i4 + 60 | 0;
 i2 = i4 + 96 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i1 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 76 | 0;
 i3 = i4 + 64 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 100 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 104 >> 2] | 0;
 if ((i1 | 0) != (i4 + 108 | 0)) __ZN2cv8fastFreeEPv(i1);
 i3 = i4 + 4 | 0;
 i2 = i4 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i1 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 20 | 0;
 i3 = i4 + 8 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 44 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 if ((i1 | 0) == (i4 + 52 | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i5;
 return;
}

function __ZN12_GLOBAL__N_124CLAHE_Interpolation_BodyIhED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 182376;
 i1 = i4 + 188 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i4 + 196 | 0;
 if ((i2 | 0) != (i3 | 0)) {
  if (i2) __ZdaPv(i2);
  HEAP32[i1 >> 2] = i3;
  HEAP32[i4 + 192 >> 2] = 264;
 }
 i3 = i4 + 116 | 0;
 i2 = i4 + 152 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i1 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 132 | 0;
 i2 = i4 + 120 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i4 + 156 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 160 >> 2] | 0;
 if ((i1 | 0) != (i4 + 164 | 0)) __ZN2cv8fastFreeEPv(i1);
 i3 = i4 + 60 | 0;
 i2 = i4 + 96 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i1 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 76 | 0;
 i3 = i4 + 64 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 100 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 104 >> 2] | 0;
 if ((i1 | 0) != (i4 + 108 | 0)) __ZN2cv8fastFreeEPv(i1);
 i3 = i4 + 4 | 0;
 i2 = i4 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i1 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 20 | 0;
 i3 = i4 + 8 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 44 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 if ((i1 | 0) == (i4 + 52 | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i5;
 return;
}

function __ZN2cvL8recip64fEPKdjS1_jPdjNS_5Size_IiEEPv(i1, i2, i10, i5, i9, i7, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var d6 = 0.0, d8 = 0.0, d11 = 0.0, d12 = 0.0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0, i18 = 0, i19 = 0, i20 = 0, d21 = 0.0, i22 = 0, d23 = 0.0, i24 = 0, d25 = 0.0;
 i19 = STACKTOP;
 i18 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 d17 = +HEAPF64[i4 >> 3];
 i16 = i5 >>> 3;
 i13 = i7 >>> 3;
 if (!i3) {
  STACKTOP = i19;
  return;
 }
 i14 = i18 + -4 | 0;
 i15 = (i14 | 0) < 0;
 i1 = (i14 | 0) > 3 ? i18 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i15) i4 = 0; else {
   i2 = 0;
   do {
    d6 = +HEAPF64[i10 + (i2 << 3) >> 3];
    i4 = i2 | 1;
    i7 = i10 + (i4 << 3) | 0;
    do if (d6 != 0.0) {
     d8 = +HEAPF64[i7 >> 3];
     if ((d8 != 0.0 ? (i20 = i2 | 2, d21 = +HEAPF64[i10 + (i20 << 3) >> 3], d21 != 0.0) : 0) ? (i22 = i2 | 3, d23 = +HEAPF64[i10 + (i22 << 3) >> 3], d23 != 0.0) : 0) {
      d25 = d6 * d8;
      d12 = d21 * d23;
      d11 = d17 / (d25 * d12);
      d12 = d12 * d11;
      d11 = d25 * d11;
      HEAPF64[i9 + (i2 << 3) >> 3] = d8 * d12;
      HEAPF64[i9 + (i4 << 3) >> 3] = d6 * d12;
      HEAPF64[i9 + (i20 << 3) >> 3] = d23 * d11;
      HEAPF64[i9 + (i22 << 3) >> 3] = d21 * d11;
      break;
     }
     d12 = d17 / d6;
     i24 = 10;
    } else {
     d12 = 0.0;
     i24 = 10;
    } while (0);
    if ((i24 | 0) == 10) {
     i24 = 0;
     d6 = +HEAPF64[i7 >> 3];
     if (d6 != 0.0) d11 = d17 / d6; else d11 = 0.0;
     i5 = i2 | 2;
     d8 = +HEAPF64[i10 + (i5 << 3) >> 3];
     if (d8 != 0.0) d6 = d17 / d8; else d6 = 0.0;
     i7 = i2 | 3;
     d8 = +HEAPF64[i10 + (i7 << 3) >> 3];
     if (d8 != 0.0) d8 = d17 / d8; else d8 = 0.0;
     HEAPF64[i9 + (i2 << 3) >> 3] = d12;
     HEAPF64[i9 + (i4 << 3) >> 3] = d11;
     HEAPF64[i9 + (i5 << 3) >> 3] = d6;
     HEAPF64[i9 + (i7 << 3) >> 3] = d8;
    }
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) <= (i14 | 0));
   i4 = i1;
  }
  if ((i4 | 0) < (i18 | 0)) do {
   d6 = +HEAPF64[i10 + (i4 << 3) >> 3];
   if (d6 != 0.0) d6 = d17 / d6; else d6 = 0.0;
   HEAPF64[i9 + (i4 << 3) >> 3] = d6;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i18 | 0));
  if (!i3) break; else {
   i9 = i9 + (i13 << 3) | 0;
   i10 = i10 + (i16 << 3) | 0;
  }
 }
 STACKTOP = i19;
 return;
}

function __ZN2cv3MatC2ENS_5Size_IiEEiPvj(i16, i2, i4, i8, i7) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i17;
 i5 = i4 & 4095;
 i1 = i5 | 1124007936;
 HEAP32[i16 >> 2] = i1;
 HEAP32[i16 + 4 >> 2] = 2;
 i15 = i16 + 8 | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = i6;
 i12 = HEAP32[i2 >> 2] | 0;
 HEAP32[i16 + 12 >> 2] = i12;
 HEAP32[i16 + 16 >> 2] = i8;
 i11 = i16 + 20 | 0;
 HEAP32[i11 >> 2] = i8;
 i13 = i16 + 24 | 0;
 i14 = i16 + 28 | 0;
 HEAP32[i13 + 0 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i16 + 40 >> 2] = i15;
 i3 = i16 + 48 | 0;
 i9 = i16 + 44 | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i16 + 52 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i2 = i4 & 7;
 i4 = (i4 >>> 3 & 511) + 1 << (47696 >>> (i2 << 1) & 3);
 i12 = Math_imul(i12, i4) | 0;
 if (!i7) {
  i7 = i12;
  i10 = i3;
  i9 = i8;
  i8 = i5 | 1124024320;
  HEAP32[i16 >> 2] = i8;
  HEAP32[i10 >> 2] = i7;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i4;
  i10 = HEAP32[i15 >> 2] | 0;
  i10 = Math_imul(i10, i7) | 0;
  i8 = i9 + i10 | 0;
  HEAP32[i14 >> 2] = i8;
  i8 = i12 - i7 | 0;
  i10 = i8 + i10 | 0;
  i10 = i9 + i10 | 0;
  HEAP32[i13 >> 2] = i10;
  STACKTOP = i17;
  return;
 }
 i7 = (i6 | 0) == 1 ? i12 : i7;
 if (!((i7 >>> 0) % ((1212424721 >>> (i2 << 2) & 15) >>> 0) | 0)) i2 = i8; else {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i10, 31) | 0) + 0 | 0;
  i2 = 32440 | 0;
  i1 = i3 + 31 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-13, i10, 27752, 32472, 422);
  __ZN2cv6String10deallocateEv(i10);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i16 >> 2] | 0;
 }
 i8 = i7;
 i10 = i3;
 i9 = i2;
 i7 = i1 | ((i7 | 0) == (i12 | 0) ? 16384 : 0);
 HEAP32[i16 >> 2] = i7;
 HEAP32[i10 >> 2] = i8;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i4;
 i10 = HEAP32[i15 >> 2] | 0;
 i10 = Math_imul(i10, i8) | 0;
 i7 = i9 + i10 | 0;
 HEAP32[i14 >> 2] = i7;
 i8 = i12 - i8 | 0;
 i10 = i8 + i10 | 0;
 i10 = i9 + i10 | 0;
 HEAP32[i13 >> 2] = i10;
 STACKTOP = i17;
 return;
}

function _scanexp(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 i6 = i8 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i8 + 100 | 0;
 if (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i6 >> 2] = i1 + 1;
  i1 = HEAPU8[i1 >> 0] | 0;
 } else i1 = ___shgetc(i8) | 0;
 if ((i1 | 0) == 43 | (i1 | 0) == 45) {
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = (i1 | 0) == 45 & 1;
  if (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP32[i6 >> 2] = i2 + 1;
   i1 = HEAPU8[i2 >> 0] | 0;
  } else i1 = ___shgetc(i8) | 0;
  if ((i1 + -48 | 0) >>> 0 > 9 & (i4 | 0) != 0 ? (HEAP32[i7 >> 2] | 0) != 0 : 0) HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 } else i3 = 0;
 if ((i1 + -48 | 0) >>> 0 > 9) {
  if (!(HEAP32[i7 >> 2] | 0)) {
   i2 = -2147483648;
   i1 = 0;
   tempRet0 = i2;
   STACKTOP = i9;
   return i1 | 0;
  }
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  i2 = -2147483648;
  i1 = 0;
  tempRet0 = i2;
  STACKTOP = i9;
  return i1 | 0;
 } else i4 = 0;
 do {
  i4 = i1 + -48 + (i4 * 10 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP32[i6 >> 2] = i1 + 1;
   i1 = HEAPU8[i1 >> 0] | 0;
  } else i1 = ___shgetc(i8) | 0;
 } while ((i1 + -48 | 0) >>> 0 < 10 & (i4 | 0) < 214748364);
 i2 = ((i4 | 0) < 0) << 31 >> 31;
 if ((i1 + -48 | 0) >>> 0 < 10) while (1) {
  i5 = ___muldi3(i4 | 0, i2 | 0, 10, 0) | 0;
  i4 = tempRet0;
  i2 = _i64Add(i1 | 0, ((i1 | 0) < 0) << 31 >> 31 | 0, -48, -1) | 0;
  i4 = _i64Add(i2 | 0, tempRet0 | 0, i5 | 0, i4 | 0) | 0;
  i5 = tempRet0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP32[i6 >> 2] = i2 + 1;
   i1 = HEAPU8[i2 >> 0] | 0;
  } else i1 = ___shgetc(i8) | 0;
  if ((i1 + -48 | 0) >>> 0 < 10 & ((i5 | 0) < 21474836 | (i5 | 0) == 21474836 & i4 >>> 0 < 2061584302)) i2 = i5; else break;
 } else i5 = i2;
 if ((i1 + -48 | 0) >>> 0 < 10) do {
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP32[i6 >> 2] = i2 + 1;
   i2 = HEAPU8[i2 >> 0] | 0;
  } else i2 = ___shgetc(i8) | 0;
 } while ((i2 + -48 | 0) >>> 0 < 10);
 if (HEAP32[i7 >> 2] | 0) HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 i3 = (i3 | 0) != 0;
 i1 = _i64Subtract(0, 0, i4 | 0, i5 | 0) | 0;
 i2 = i3 ? tempRet0 : i5;
 i1 = i3 ? i1 : i4;
 tempRet0 = i2;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNSt3__1rsIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_13basic_istreamIT_T0_EES9_RNS_12basic_stringIS6_S7_T1_EE(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i9 + 4 | 0;
 i2 = i9;
 __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6sentryC1ERS3_b(i1, i8, 0);
 if (!(HEAP8[i1 >> 0] | 0)) {
  i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
  __ZNSt3__18ios_base5clearEj(i8 + i1 | 0, HEAP32[i8 + (i1 + 16) >> 2] | 4);
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!(HEAP8[i7 >> 0] & 1)) {
  HEAP8[i7 + 1 >> 0] = 0;
  HEAP8[i7 >> 0] = 0;
 } else {
  HEAP8[HEAP32[i7 + 8 >> 2] >> 0] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
 }
 i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
 i6 = HEAP32[i8 + (i1 + 12) >> 2] | 0;
 i6 = (i6 | 0) < 1 ? 2147483647 : i6;
 __ZNKSt3__18ios_base6getlocEv(i2, i8 + i1 | 0);
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 960728) | 0;
 __ZNSt3__16localeD2Ev(i2);
 L9 : do if ((i6 | 0) > 0) {
  i5 = i1 + 8 | 0;
  i1 = 0;
  while (1) {
   i2 = HEAP32[i8 + ((HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
    i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2) | 0;
    if ((i2 | 0) == -1) {
     i2 = 2;
     break L9;
    }
   } else i2 = HEAPU8[i3 >> 0] | 0;
   i3 = i2 & 255;
   if (i3 << 24 >> 24 > -1 ? (HEAP16[(HEAP32[i5 >> 2] | 0) + (i2 << 24 >> 24 << 1) >> 1] & 8192) != 0 : 0) {
    i2 = 0;
    break L9;
   }
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, i3);
   i4 = HEAP32[i8 + ((HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
   i1 = i1 + 1 | 0;
   i3 = i4 + 12 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] & 127](i4) | 0; else HEAP32[i3 >> 2] = i2 + 1;
   if ((i1 | 0) >= (i6 | 0)) {
    i2 = 0;
    break;
   }
  }
 } else {
  i1 = 0;
  i2 = 0;
 } while (0);
 HEAP32[i8 + ((HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 12) >> 2] = 0;
 i3 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i8 + i3 | 0, HEAP32[i8 + (i3 + 16) >> 2] | ((i1 | 0) == 0 ? i2 | 4 : i2));
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN7testing8internalL25FormatCxxExceptionMessageEPKcS2_(i6, i3, i4) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i8 + 4 | 0;
 i7 = i8;
 __ZN7testing7MessageC2Ev(i7);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = i2 + 8 | 0;
 if (!i3) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 168736, 21) | 0; else {
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 168696, 32) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i3, _strlen(i3 | 0) | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 160776, 1) | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 168760, 11) | 0;
 if (!i4) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i4, _strlen(i4 | 0) | 0) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 160488, 1) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i5, i2 + 12 | 0);
 i1 = HEAP8[i5 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i5 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
 }
 i4 = i2 + i1 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i6, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i6, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i6, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN4perf8TestBase10_calibrateEv() {
 var d1 = 0.0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 i7 = i8 + 184 | 0;
 i6 = i8;
 i5 = i8 + 192 | 0;
 i2 = 169640;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 __ZN7testing4TestC2Ev(i6);
 i2 = i6 + 8 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i6 + 32 >> 2] = -1;
 HEAP32[i6 + 36 >> 2] = 0;
 HEAP32[i6 + 40 >> 2] = 0;
 HEAP32[i6 + 44 >> 2] = 0;
 i2 = i6 + 168 | 0;
 i3 = i6 + 96 | 0;
 i4 = i3 + 72 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = -1;
 HEAP32[i6 + 180 >> 2] = i6;
 i2 = i6 + 48 | 0;
 HEAP32[i6 + 84 >> 2] = 0;
 HEAP32[i6 + 80 >> 2] = 0;
 HEAP32[i6 + 76 >> 2] = 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i6 + 72 >> 2] = HEAP32[43340];
 HEAP8[i6 + 176 >> 0] = 0;
 HEAP32[i6 + 88 >> 2] = 0;
 HEAP32[i6 >> 2] = 177e3;
 __ZZN4perf8TestBase10_calibrateEvEN7_helper12PerfTestBodyEv(i6);
 d1 = +HEAPF64[(__ZN4perf8TestBase11calcMetricsEv(i6) | 0) + 56 >> 3];
 i2 = HEAP32[43316] | 0;
 if ((((i2 | 0) == -1 ? HEAP32[43474] | 0 : i2) | 0) == 1) if (d1 < +__ZN2cv16getTickFrequencyEv() * .01) d1 = 0.0; else {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i5, 44) | 0) + 0 | 0;
  i2 = 173904 | 0;
  i4 = i3 + 44 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 173952, 170184, 977);
  __ZN2cv6String10deallocateEv(i5);
  d1 = 0.0;
 }
 HEAPF64[tempDoublePtr >> 3] = d1;
 HEAP32[i7 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 _printf(173968, i7 | 0) | 0;
 _putchar(10) | 0;
 _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 i2 = +Math_abs(d1) >= 1.0 ? (d1 > 0.0 ? (Math_min(+Math_floor(d1 / 4294967296.0), 4294967295.0) | 0) >>> 0 : ~~+Math_ceil((d1 - +(~~d1 >>> 0)) / 4294967296.0) >>> 0) : 0;
 __ZN4perf8TestBaseD2Ev(i6);
 tempRet0 = i2;
 STACKTOP = i8;
 return ~~d1 >>> 0 | 0;
}

function __ZNK2cv7MatOp_T6assignERKNS_7MatExprERNS_3MatEi(i1, i8, i11, i10) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i14 = i16 + 64 | 0;
 i5 = i16 + 40 | 0;
 i6 = i16 + 20 | 0;
 i7 = i16;
 HEAP32[i14 >> 2] = 1124007936;
 i15 = i14 + 4 | 0;
 i2 = i14 + 8 | 0;
 i12 = i14 + 40 | 0;
 i1 = i15 + 0 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 HEAP32[i12 >> 2] = i2;
 i13 = i14 + 48 | 0;
 i9 = i14 + 44 | 0;
 HEAP32[i9 >> 2] = i13;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 if ((i10 | 0) != -1 ? (HEAP32[i8 + 8 >> 2] & 4095 | 0) != (i10 | 0) : 0) i4 = i14; else i4 = i11;
 HEAP32[i5 >> 2] = 32088;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 16842752;
 HEAP32[i5 + 8 >> 2] = i8 + 8;
 i2 = i6 + 4 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = 32232;
 HEAP32[i2 >> 2] = 33619968;
 HEAP32[i6 + 8 >> 2] = i4;
 __ZN2cv9transposeERKNS_11_InputArrayERKNS_12_OutputArrayE(i5, i6);
 d3 = +HEAPF64[i8 + 176 >> 3];
 if (d3 != 1.0 ? 1 : (HEAP32[i4 + 16 >> 2] | 0) != (HEAP32[i11 + 16 >> 2] | 0)) {
  i8 = i7 + 4 | 0;
  HEAP32[i8 + 0 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAP32[i7 >> 2] = 32232;
  HEAP32[i8 >> 2] = 33619968;
  HEAP32[i7 + 8 >> 2] = i11;
  __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i4, i7, i10, d3, 0.0);
 }
 i2 = i14 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i10 = i1 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i14);
 HEAP32[i2 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i15 >> 2] | 0) > 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i15 >> 2] | 0));
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i16;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i16;
 return;
}

function __ZN2cv17checkIntegerRangeILi3EEEbNS_3MatERNS_6Point_IiEEiiRd(i12, i8, i11, i10, i15) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i16 = i17;
 if ((i11 | 0) < -32768 & (i10 | 0) > 32767) {
  i11 = 1;
  STACKTOP = i17;
  return i11 | 0;
 }
 if ((i11 | 0) > 32767 | (i10 | 0) < -32768 | (i10 | 0) < (i11 | 0)) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i11 = 0;
  STACKTOP = i17;
  return i11 | 0;
 }
 __ZNK2cv3Mat7reshapeEii(i16, i12, 1, 0);
 i7 = HEAP32[i16 + 8 >> 2] | 0;
 L8 : do if ((i7 | 0) > 0) {
  i1 = HEAP32[i16 + 12 >> 2] | 0;
  i6 = (i1 | 0) > 0;
  i13 = HEAP32[i16 + 16 >> 2] | 0;
  i14 = HEAP32[i16 + 44 >> 2] | 0;
  i4 = 0;
  L10 : while (1) {
   if (i6) {
    i5 = i13 + (Math_imul(HEAP32[i14 >> 2] | 0, i4) | 0) | 0;
    i9 = 0;
    while (1) {
     i18 = HEAP16[i5 + (i9 << 1) >> 1] | 0;
     i2 = i9 + 1 | 0;
     if ((i18 | 0) < (i11 | 0) | (i18 | 0) > (i10 | 0)) break L10;
     if ((i2 | 0) < (i1 | 0)) i9 = i2; else break;
    }
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i7 | 0)) {
    i5 = 1;
    d3 = 0.0;
    break L8;
   }
  }
  HEAP32[i8 + 4 >> 2] = i4;
  HEAP32[i8 >> 2] = (i9 | 0) % (((HEAP32[i12 >> 2] | 0) >>> 3 & 511) + 1 | 0) | 0;
  i5 = 0;
  d3 = +(HEAP16[i13 + (Math_imul(HEAP32[i14 >> 2] | 0, i4) | 0) + (i9 << 1) >> 1] | 0);
 } else {
  i5 = 1;
  d3 = 0.0;
 } while (0);
 HEAPF64[i15 >> 3] = d3;
 i1 = i16 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i10 = i2 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i16);
 HEAP32[i1 >> 2] = 0;
 i11 = i16 + 16 | 0;
 i2 = i16 + 4 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i16 + 40 >> 2] | 0;
  i4 = 0;
  do {
   HEAP32[i1 + (i4 << 2) >> 2] = 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i16 + 44 >> 2] | 0;
 if ((i1 | 0) == (i16 + 48 | 0)) {
  i11 = i5;
  STACKTOP = i17;
  return i11 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 i11 = i5;
 STACKTOP = i17;
 return i11 | 0;
}

function __ZN6cvtest2TS13str_from_codeENS0_11FailureCodeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 do switch (i2 | 0) {
 case -13:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158536, 16);
   break;
  }
 case -4:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158320, 21);
   break;
  }
 case -9:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158456, 11);
   break;
  }
 case -8:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158424, 24);
   break;
  }
 case -3:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158304, 15);
   break;
  }
 case -6:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158368, 20);
   break;
  }
 case -12:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158520, 12);
   break;
  }
 case -2:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158264, 12);
   break;
  }
 case -7:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158392, 30);
   break;
  }
 case -10:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158472, 23);
   break;
  }
 case 0:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158240, 2);
   break;
  }
 case -11:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158496, 17);
   break;
  }
 case -1:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158248, 15);
   break;
  }
 case -5:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158344, 21);
   break;
  }
 case -14:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158560, 35);
   break;
  }
 case -15:
  {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158280, 17);
   break;
  }
 default:
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 158248, 15);
 } while (0);
 STACKTOP = i3;
 return;
}

function __ZN2cv17checkIntegerRangeILi2EEEbNS_3MatERNS_6Point_IiEEiiRd(i12, i8, i11, i10, i15) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i16 = i17;
 if ((i11 | 0) < 0 & (i10 | 0) > 65535) {
  i11 = 1;
  STACKTOP = i17;
  return i11 | 0;
 }
 if ((i11 | 0) > 65535 | (i10 | 0) < 0 | (i10 | 0) < (i11 | 0)) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i11 = 0;
  STACKTOP = i17;
  return i11 | 0;
 }
 __ZNK2cv3Mat7reshapeEii(i16, i12, 1, 0);
 i7 = HEAP32[i16 + 8 >> 2] | 0;
 L8 : do if ((i7 | 0) > 0) {
  i1 = HEAP32[i16 + 12 >> 2] | 0;
  i6 = (i1 | 0) > 0;
  i13 = HEAP32[i16 + 16 >> 2] | 0;
  i14 = HEAP32[i16 + 44 >> 2] | 0;
  i4 = 0;
  L10 : while (1) {
   if (i6) {
    i5 = i13 + (Math_imul(HEAP32[i14 >> 2] | 0, i4) | 0) | 0;
    i9 = 0;
    while (1) {
     i18 = HEAPU16[i5 + (i9 << 1) >> 1] | 0;
     i2 = i9 + 1 | 0;
     if ((i18 | 0) < (i11 | 0) | (i18 | 0) > (i10 | 0)) break L10;
     if ((i2 | 0) < (i1 | 0)) i9 = i2; else break;
    }
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i7 | 0)) {
    i5 = 1;
    d3 = 0.0;
    break L8;
   }
  }
  HEAP32[i8 + 4 >> 2] = i4;
  HEAP32[i8 >> 2] = (i9 | 0) % (((HEAP32[i12 >> 2] | 0) >>> 3 & 511) + 1 | 0) | 0;
  i5 = 0;
  d3 = +(HEAPU16[i13 + (Math_imul(HEAP32[i14 >> 2] | 0, i4) | 0) + (i9 << 1) >> 1] | 0);
 } else {
  i5 = 1;
  d3 = 0.0;
 } while (0);
 HEAPF64[i15 >> 3] = d3;
 i1 = i16 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i10 = i2 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i16);
 HEAP32[i1 >> 2] = 0;
 i11 = i16 + 16 | 0;
 i2 = i16 + 4 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i16 + 40 >> 2] | 0;
  i4 = 0;
  do {
   HEAP32[i1 + (i4 << 2) >> 2] = 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i16 + 44 >> 2] | 0;
 if ((i1 | 0) == (i16 + 48 | 0)) {
  i11 = i5;
  STACKTOP = i17;
  return i11 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 i11 = i5;
 STACKTOP = i17;
 return i11 | 0;
}

function __ZN2cv6vBinOpIsNS_9OpAbsDiffIsEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i6, i2, i5, i3, i7, i4, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 i17 = i1 + 4 | 0;
 i10 = HEAP32[i17 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i17 >> 2] = i8;
 if (!i10) {
  STACKTOP = i18;
  return;
 }
 i14 = HEAP32[i1 >> 2] | 0;
 i15 = i14 + -4 | 0;
 i16 = (i15 | 0) < 0;
 i13 = i2 >>> 1;
 i12 = i3 >>> 1;
 i11 = i4 >>> 1;
 while (1) {
  if (i16) i2 = 0; else {
   i9 = (i15 | 0) > 3;
   i10 = 0;
   do {
    i3 = (HEAP16[i6 + (i10 << 1) >> 1] | 0) - (HEAP16[i5 + (i10 << 1) >> 1] | 0) | 0;
    i3 = (i3 | 0) > -1 ? i3 : 0 - i3 | 0;
    if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
    i2 = i10 | 1;
    i4 = (HEAP16[i6 + (i2 << 1) >> 1] | 0) - (HEAP16[i5 + (i2 << 1) >> 1] | 0) | 0;
    i4 = (i4 | 0) > -1 ? i4 : 0 - i4 | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    HEAP16[i7 + (i10 << 1) >> 1] = i3;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i1 = i10 | 2;
    i4 = (HEAP16[i6 + (i1 << 1) >> 1] | 0) - (HEAP16[i5 + (i1 << 1) >> 1] | 0) | 0;
    i4 = (i4 | 0) > -1 ? i4 : 0 - i4 | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    i2 = i10 | 3;
    i3 = (HEAP16[i6 + (i2 << 1) >> 1] | 0) - (HEAP16[i5 + (i2 << 1) >> 1] | 0) | 0;
    i3 = (i3 | 0) > -1 ? i3 : 0 - i3 | 0;
    if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
    HEAP16[i7 + (i1 << 1) >> 1] = i4;
    HEAP16[i7 + (i2 << 1) >> 1] = i3;
    i10 = i10 + 4 | 0;
   } while ((i10 | 0) <= (i15 | 0));
   i2 = i9 ? i14 & -4 : 4;
  }
  if ((i2 | 0) < (i14 | 0)) do {
   i1 = (HEAP16[i6 + (i2 << 1) >> 1] | 0) - (HEAP16[i5 + (i2 << 1) >> 1] | 0) | 0;
   i1 = (i1 | 0) > -1 ? i1 : 0 - i1 | 0;
   if ((i1 + 32768 | 0) >>> 0 >= 65536) i1 = (i1 | 0) > 0 ? 32767 : -32768;
   HEAP16[i7 + (i2 << 1) >> 1] = i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i14 | 0));
  if (!i8) break; else {
   i5 = i5 + (i12 << 1) | 0;
   i6 = i6 + (i13 << 1) | 0;
   i7 = i7 + (i11 << 1) | 0;
   i8 = i8 + -1 | 0;
  }
 }
 HEAP32[i17 >> 2] = -1;
 STACKTOP = i18;
 return;
}

function __ZN2cv3MatC2EiiiPvj(i17, i7, i5, i4, i2, i8) {
 i17 = i17 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i18;
 i6 = i4 & 4095;
 i1 = i6 | 1124007936;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i17 + 4 >> 2] = 2;
 i14 = i17 + 8 | 0;
 HEAP32[i14 >> 2] = i7;
 HEAP32[i17 + 12 >> 2] = i5;
 HEAP32[i17 + 16 >> 2] = i2;
 i12 = i17 + 20 | 0;
 HEAP32[i12 >> 2] = i2;
 i15 = i17 + 24 | 0;
 i16 = i17 + 28 | 0;
 HEAP32[i15 + 0 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i17 + 40 >> 2] = i14;
 i3 = i17 + 48 | 0;
 i11 = i17 + 44 | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i17 + 52 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i9 = i4 & 7;
 i13 = (i4 >>> 3 & 511) + 1 << (47696 >>> (i9 << 1) & 3);
 i4 = Math_imul(i13, i5) | 0;
 if (!i8) {
  i8 = i4;
  i10 = i3;
  i9 = i2;
  i7 = i6 | 1124024320;
  HEAP32[i17 >> 2] = i7;
  HEAP32[i10 >> 2] = i8;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i13;
  i10 = HEAP32[i14 >> 2] | 0;
  i10 = Math_imul(i10, i8) | 0;
  i7 = i9 + i10 | 0;
  HEAP32[i16 >> 2] = i7;
  i8 = i4 - i8 | 0;
  i10 = i8 + i10 | 0;
  i10 = i9 + i10 | 0;
  HEAP32[i15 >> 2] = i10;
  STACKTOP = i18;
  return;
 }
 i8 = (i7 | 0) == 1 ? i4 : i8;
 if ((i8 >>> 0) % ((1212424721 >>> (i9 << 2) & 15) >>> 0) | 0) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i10, 31) | 0) + 0 | 0;
  i2 = 4576 | 0;
  i1 = i3 + 31 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-13, i10, 4608, 4616, 391);
  __ZN2cv6String10deallocateEv(i10);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i1 = HEAP32[i17 >> 2] | 0;
 }
 i7 = i8;
 i10 = i3;
 i9 = i2;
 i8 = i1 | ((i8 | 0) == (i4 | 0) ? 16384 : 0);
 HEAP32[i17 >> 2] = i8;
 HEAP32[i10 >> 2] = i7;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i13;
 i10 = HEAP32[i14 >> 2] | 0;
 i10 = Math_imul(i10, i7) | 0;
 i8 = i9 + i10 | 0;
 HEAP32[i16 >> 2] = i8;
 i8 = i4 - i7 | 0;
 i10 = i8 + i10 | 0;
 i10 = i9 + i10 | 0;
 HEAP32[i15 >> 2] = i10;
 STACKTOP = i18;
 return;
}

function __ZNSt3__16vectorIN2cv3PtrINS1_16BaseImageEncoderEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 i10 = i12 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i2 = ((HEAP32[i10 >> 2] | 0) - i4 >> 3) + 1 | 0;
 if (i2 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i11 = i12 + 8 | 0;
 i3 = (HEAP32[i11 >> 2] | 0) - i4 | 0;
 if (i3 >> 3 >>> 0 < 268435455) {
  i3 = i3 >> 2;
  i3 = i3 >>> 0 < i2 >>> 0 ? i2 : i3;
  i4 = (HEAP32[i10 >> 2] | 0) - i4 >> 3;
  if (!i3) {
   i2 = 0;
   i9 = 0;
  } else i7 = 6;
 } else {
  i3 = 536870911;
  i4 = (HEAP32[i10 >> 2] | 0) - i4 >> 3;
  i7 = 6;
 }
 if ((i7 | 0) == 6) {
  i2 = i3;
  i9 = __Znwj(i3 << 3) | 0;
 }
 i5 = i9 + (i4 << 3) | 0;
 i8 = i9 + (i2 << 3) | 0;
 if ((i5 | 0) != 0 ? (i6 = HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] = i6, HEAP32[i9 + (i4 << 3) + 4 >> 2] = HEAP32[i1 + 4 >> 2], (i6 | 0) != 0) : 0) {
  i7 = i6 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 i7 = i9 + (i4 + 1 << 3) | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i6 = i4 + -1 - ((i3 + -8 - i1 | 0) >>> 3) | 0;
  i4 = i5;
  while (1) {
   i5 = i3;
   i3 = i3 + -8 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   HEAP32[i4 + -8 >> 2] = i2;
   HEAP32[i4 + -4 >> 2] = HEAP32[i5 + -4 >> 2];
   if (i2) {
    i5 = i2 + 4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   }
   if ((i3 | 0) == (i1 | 0)) break; else i4 = i4 + -8 | 0;
  }
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  HEAP32[i12 >> 2] = i9 + (i6 << 3);
  HEAP32[i10 >> 2] = i7;
  HEAP32[i11 >> 2] = i8;
  if ((i2 | 0) != (i1 | 0)) do {
   i3 = i2;
   i2 = i2 + -8 | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   if ((i4 | 0) != 0 ? (i9 = i4 + 4 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] & 511](i4);
   HEAP32[i2 >> 2] = 0;
   HEAP32[i3 + -4 >> 2] = 0;
  } while ((i2 | 0) != (i1 | 0));
 } else {
  HEAP32[i12 >> 2] = i5;
  HEAP32[i10 >> 2] = i7;
  HEAP32[i11 >> 2] = i8;
 }
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i13;
 return;
}

function __ZNSt3__16vectorIN2cv3PtrINS1_16BaseImageDecoderEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 i10 = i12 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i2 = ((HEAP32[i10 >> 2] | 0) - i4 >> 3) + 1 | 0;
 if (i2 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i11 = i12 + 8 | 0;
 i3 = (HEAP32[i11 >> 2] | 0) - i4 | 0;
 if (i3 >> 3 >>> 0 < 268435455) {
  i3 = i3 >> 2;
  i3 = i3 >>> 0 < i2 >>> 0 ? i2 : i3;
  i4 = (HEAP32[i10 >> 2] | 0) - i4 >> 3;
  if (!i3) {
   i2 = 0;
   i9 = 0;
  } else i7 = 6;
 } else {
  i3 = 536870911;
  i4 = (HEAP32[i10 >> 2] | 0) - i4 >> 3;
  i7 = 6;
 }
 if ((i7 | 0) == 6) {
  i2 = i3;
  i9 = __Znwj(i3 << 3) | 0;
 }
 i5 = i9 + (i4 << 3) | 0;
 i8 = i9 + (i2 << 3) | 0;
 if ((i5 | 0) != 0 ? (i6 = HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] = i6, HEAP32[i9 + (i4 << 3) + 4 >> 2] = HEAP32[i1 + 4 >> 2], (i6 | 0) != 0) : 0) {
  i7 = i6 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 i7 = i9 + (i4 + 1 << 3) | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i6 = i4 + -1 - ((i3 + -8 - i1 | 0) >>> 3) | 0;
  i4 = i5;
  while (1) {
   i5 = i3;
   i3 = i3 + -8 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   HEAP32[i4 + -8 >> 2] = i2;
   HEAP32[i4 + -4 >> 2] = HEAP32[i5 + -4 >> 2];
   if (i2) {
    i5 = i2 + 4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   }
   if ((i3 | 0) == (i1 | 0)) break; else i4 = i4 + -8 | 0;
  }
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  HEAP32[i12 >> 2] = i9 + (i6 << 3);
  HEAP32[i10 >> 2] = i7;
  HEAP32[i11 >> 2] = i8;
  if ((i2 | 0) != (i1 | 0)) do {
   i3 = i2;
   i2 = i2 + -8 | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   if ((i4 | 0) != 0 ? (i9 = i4 + 4 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] & 511](i4);
   HEAP32[i2 >> 2] = 0;
   HEAP32[i3 + -4 >> 2] = 0;
  } while ((i2 | 0) != (i1 | 0));
 } else {
  HEAP32[i12 >> 2] = i5;
  HEAP32[i10 >> 2] = i7;
  HEAP32[i11 >> 2] = i8;
 }
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i13;
 return;
}

function __ZN2cv13AlgorithmInfo9addParam_ERNS_9AlgorithmEPKciPvbMS1_KFivEMS1_FviERKNS_6StringE(i4, i8, i5, i9, i12, i11, i1, i2, i15) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i10 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i3 = i16 + 48 | 0;
 i13 = i16 + 40 | 0;
 i14 = i16;
 i10 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
 i6 = i1 + 4 | 0;
 i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
 i7 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 i1 = i2 + 4 | 0;
 i1 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
 if (!(i9 >>> 0 < 10 | (i9 | 0) == 11)) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  _memcpy(__ZN2cv6String8allocateEj(i3, 308) | 0, 38312, 308) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 38624, 37992, 1106);
  __ZN2cv6String10deallocateEv(i3);
 }
 i4 = HEAP32[i4 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 if (i5) {
  i3 = _strlen(i5 | 0) | 0;
  _memcpy(__ZN2cv6String8allocateEj(i13, i3) | 0, i5 | 0, i3 | 0) | 0;
 }
 i2 = i14 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i14 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i14 >> 2] = i9;
 HEAP8[i14 + 8 >> 0] = i11 & 1;
 HEAP32[i14 + 4 >> 2] = i12 - i8;
 HEAP32[i14 + 12 >> 2] = i10;
 HEAP32[i14 + 16 >> 2] = i6;
 HEAP32[i14 + 20 >> 2] = i7;
 HEAP32[i14 + 24 >> 2] = i1;
 if ((i2 | 0) == (i15 | 0)) {
  __ZN2cv13sorted_vectorINS_6StringENS_5ParamEE3addERKS1_RKS2_(i4, i13, i14);
  __ZN2cv6String10deallocateEv(i2);
  __ZN2cv6String10deallocateEv(i13);
  STACKTOP = i16;
  return;
 }
 __ZN2cv6String10deallocateEv(i2);
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i15 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i15 + 4 >> 2];
 __ZN2cv13sorted_vectorINS_6StringENS_5ParamEE3addERKS1_RKS2_(i4, i13, i14);
 __ZN2cv6String10deallocateEv(i2);
 __ZN2cv6String10deallocateEv(i13);
 STACKTOP = i16;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb(i17, i12, i13, i9, i10, i15, i16) {
 i17 = i17 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i14 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i1 = i18 + 60 | 0;
 i2 = i18 + 56 | 0;
 i14 = i18 + 52 | 0;
 i3 = i18 + 48 | 0;
 i4 = i18 + 44 | 0;
 i5 = i18 + 40 | 0;
 i6 = i18 + 36 | 0;
 i7 = i18 + 32 | 0;
 i11 = i18 + 8 | 0;
 i8 = i18;
 if (HEAP32[i10 + 4 >> 2] & 1) {
  __ZNKSt3__18ios_base6getlocEv(i6, i10);
  i5 = __ZNKSt3__16locale9use_facetERNS0_2idE(i6, 960720) | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i6 >> 2] | 0) | 0;
  __ZNKSt3__18ios_base6getlocEv(i7, i10);
  i10 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 960880) | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i7 >> 2] | 0) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] & 127](i11, i10);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] & 127](i11 + 12 | 0, i10);
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
  HEAP8[i16 >> 0] = (__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i13, i1, i11, i11 + 24 | 0, i5, i15, 1) | 0) == (i11 | 0) & 1;
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i11 + 12 | 0);
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i11);
  STACKTOP = i18;
  return;
 }
 HEAP32[i14 >> 2] = -1;
 i8 = HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
 HEAP32[i1 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
 FUNCTION_TABLE_viiiiiii[i8 & 63](i3, i12, i2, i1, i10, i15, i14);
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i13 >> 2] = i2;
 i1 = HEAP32[i14 >> 2] | 0;
 if ((i1 | 0) == 1) HEAP8[i16 >> 0] = 1; else if (!i1) HEAP8[i16 >> 0] = 0; else {
  HEAP8[i16 >> 0] = 1;
  HEAP32[i15 >> 2] = 4;
 }
 HEAP32[i17 >> 2] = i2;
 STACKTOP = i18;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb(i17, i12, i13, i9, i10, i15, i16) {
 i17 = i17 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i14 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i1 = i18 + 60 | 0;
 i2 = i18 + 56 | 0;
 i14 = i18 + 52 | 0;
 i3 = i18 + 48 | 0;
 i4 = i18 + 44 | 0;
 i5 = i18 + 40 | 0;
 i6 = i18 + 36 | 0;
 i7 = i18 + 32 | 0;
 i11 = i18 + 8 | 0;
 i8 = i18;
 if (HEAP32[i10 + 4 >> 2] & 1) {
  __ZNKSt3__18ios_base6getlocEv(i6, i10);
  i5 = __ZNKSt3__16locale9use_facetERNS0_2idE(i6, 960728) | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i6 >> 2] | 0) | 0;
  __ZNKSt3__18ios_base6getlocEv(i7, i10);
  i10 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 960872) | 0;
  __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i7 >> 2] | 0) | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] & 127](i11, i10);
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] & 127](i11 + 12 | 0, i10);
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
  HEAP8[i16 >> 0] = (__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i13, i1, i11, i11 + 24 | 0, i5, i15, 1) | 0) == (i11 | 0) & 1;
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11 + 12 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  STACKTOP = i18;
  return;
 }
 HEAP32[i14 >> 2] = -1;
 i8 = HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
 HEAP32[i1 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
 FUNCTION_TABLE_viiiiiii[i8 & 63](i3, i12, i2, i1, i10, i15, i14);
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i13 >> 2] = i2;
 i1 = HEAP32[i14 >> 2] | 0;
 if ((i1 | 0) == 1) HEAP8[i16 >> 0] = 1; else if (!i1) HEAP8[i16 >> 0] = 0; else {
  HEAP8[i16 >> 0] = 1;
  HEAP32[i15 >> 2] = 4;
 }
 HEAP32[i17 >> 2] = i2;
 STACKTOP = i18;
 return;
}

function __ZN2cv17checkIntegerRangeILi1EEEbNS_3MatERNS_6Point_IiEEiiRd(i12, i8, i11, i10, i15) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i16 = i17;
 if ((i11 | 0) < -128 & (i10 | 0) > 127) {
  i11 = 1;
  STACKTOP = i17;
  return i11 | 0;
 }
 if ((i11 | 0) > 127 | (i10 | 0) < -128 | (i10 | 0) < (i11 | 0)) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i11 = 0;
  STACKTOP = i17;
  return i11 | 0;
 }
 __ZNK2cv3Mat7reshapeEii(i16, i12, 1, 0);
 i7 = HEAP32[i16 + 8 >> 2] | 0;
 L8 : do if ((i7 | 0) > 0) {
  i1 = HEAP32[i16 + 12 >> 2] | 0;
  i6 = (i1 | 0) > 0;
  i13 = HEAP32[i16 + 16 >> 2] | 0;
  i14 = HEAP32[i16 + 44 >> 2] | 0;
  i4 = 0;
  L10 : while (1) {
   if (i6) {
    i5 = Math_imul(HEAP32[i14 >> 2] | 0, i4) | 0;
    i9 = 0;
    while (1) {
     i18 = HEAP8[i13 + (i5 + i9) >> 0] | 0;
     i2 = i9 + 1 | 0;
     if ((i18 | 0) < (i11 | 0) | (i18 | 0) > (i10 | 0)) break L10;
     if ((i2 | 0) < (i1 | 0)) i9 = i2; else break;
    }
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i7 | 0)) {
    i5 = 1;
    d3 = 0.0;
    break L8;
   }
  }
  HEAP32[i8 + 4 >> 2] = i4;
  HEAP32[i8 >> 2] = (i9 | 0) % (((HEAP32[i12 >> 2] | 0) >>> 3 & 511) + 1 | 0) | 0;
  i5 = 0;
  d3 = +(HEAP8[i13 + ((Math_imul(HEAP32[i14 >> 2] | 0, i4) | 0) + i9) >> 0] | 0);
 } else {
  i5 = 1;
  d3 = 0.0;
 } while (0);
 HEAPF64[i15 >> 3] = d3;
 i1 = i16 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i10 = i2 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i16);
 HEAP32[i1 >> 2] = 0;
 i11 = i16 + 16 | 0;
 i2 = i16 + 4 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i16 + 40 >> 2] | 0;
  i4 = 0;
  do {
   HEAP32[i1 + (i4 << 2) >> 2] = 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i16 + 44 >> 2] | 0;
 if ((i1 | 0) == (i16 + 48 | 0)) {
  i11 = i5;
  STACKTOP = i17;
  return i11 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 i11 = i5;
 STACKTOP = i17;
 return i11 | 0;
}

function __ZN2cvL14randnScale_16sEPKfPsiiS1_S1_b(i9, i7, i14, i11, i12, i13, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i15 = 0;
 i15 = STACKTOP;
 if (i1) {
  if ((i14 | 0) <= 0) {
   STACKTOP = i15;
   return;
  }
  i10 = (i11 | 0) > 0;
  i8 = 0;
  while (1) {
   if (i10) {
    i1 = 0;
    do {
     i6 = Math_imul(i1, i11) | 0;
     i5 = 0;
     f4 = Math_fround(HEAPF32[i12 + (i1 << 2) >> 2]);
     do {
      f2 = Math_fround(HEAPF32[i9 + (i5 << 2) >> 2]);
      f4 = Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i13 + (i5 + i6 << 2) >> 2])));
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i11 | 0));
     i3 = _lrint(+f4) | 0;
     if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
     HEAP16[i7 + (i1 << 1) >> 1] = i3;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i11 | 0));
   }
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i14 | 0)) break; else {
    i9 = i9 + (i11 << 2) | 0;
    i7 = i7 + (i11 << 1) | 0;
   }
  }
  STACKTOP = i15;
  return;
 }
 if ((i11 | 0) == 1) {
  f4 = Math_fround(HEAPF32[i12 >> 2]);
  f2 = Math_fround(HEAPF32[i13 >> 2]);
  if ((i14 | 0) > 0) i3 = 0; else {
   STACKTOP = i15;
   return;
  }
  do {
   i1 = _lrint(+Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i9 + (i3 << 2) >> 2])))) | 0;
   if ((i1 + 32768 | 0) >>> 0 >= 65536) i1 = (i1 | 0) > 0 ? 32767 : -32768;
   HEAP16[i7 + (i3 << 1) >> 1] = i1;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i14 | 0));
  STACKTOP = i15;
  return;
 }
 if ((i14 | 0) <= 0) {
  STACKTOP = i15;
  return;
 }
 i8 = (i11 | 0) > 0;
 i1 = i9;
 i5 = 0;
 while (1) {
  if (i8) {
   i6 = 0;
   do {
    f2 = Math_fround(HEAPF32[i1 + (i6 << 2) >> 2]);
    f2 = Math_fround(f2 * Math_fround(HEAPF32[i13 + (i6 << 2) >> 2]));
    i3 = _lrint(+Math_fround(f2 + Math_fround(HEAPF32[i12 + (i6 << 2) >> 2]))) | 0;
    if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
    HEAP16[i7 + (i6 << 1) >> 1] = i3;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i11 | 0));
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == (i14 | 0)) break; else {
   i7 = i7 + (i11 << 1) | 0;
   i1 = i1 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN2cv17checkIntegerRangeILi0EEEbNS_3MatERNS_6Point_IiEEiiRd(i12, i8, i11, i10, i15) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i16 = i17;
 if ((i11 | 0) < 0 & (i10 | 0) > 255) {
  i11 = 1;
  STACKTOP = i17;
  return i11 | 0;
 }
 if ((i11 | 0) > 255 | (i10 | 0) < 0 | (i10 | 0) < (i11 | 0)) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i11 = 0;
  STACKTOP = i17;
  return i11 | 0;
 }
 __ZNK2cv3Mat7reshapeEii(i16, i12, 1, 0);
 i7 = HEAP32[i16 + 8 >> 2] | 0;
 L8 : do if ((i7 | 0) > 0) {
  i1 = HEAP32[i16 + 12 >> 2] | 0;
  i6 = (i1 | 0) > 0;
  i13 = HEAP32[i16 + 16 >> 2] | 0;
  i14 = HEAP32[i16 + 44 >> 2] | 0;
  i4 = 0;
  L10 : while (1) {
   if (i6) {
    i5 = Math_imul(HEAP32[i14 >> 2] | 0, i4) | 0;
    i9 = 0;
    while (1) {
     i18 = HEAPU8[i13 + (i5 + i9) >> 0] | 0;
     i2 = i9 + 1 | 0;
     if ((i18 | 0) < (i11 | 0) | (i18 | 0) > (i10 | 0)) break L10;
     if ((i2 | 0) < (i1 | 0)) i9 = i2; else break;
    }
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i7 | 0)) {
    i5 = 1;
    d3 = 0.0;
    break L8;
   }
  }
  HEAP32[i8 + 4 >> 2] = i4;
  HEAP32[i8 >> 2] = (i9 | 0) % (((HEAP32[i12 >> 2] | 0) >>> 3 & 511) + 1 | 0) | 0;
  i5 = 0;
  d3 = +(HEAPU8[i13 + ((Math_imul(HEAP32[i14 >> 2] | 0, i4) | 0) + i9) >> 0] | 0);
 } else {
  i5 = 1;
  d3 = 0.0;
 } while (0);
 HEAPF64[i15 >> 3] = d3;
 i1 = i16 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i10 = i2 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i16);
 HEAP32[i1 >> 2] = 0;
 i11 = i16 + 16 | 0;
 i2 = i16 + 4 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i16 + 40 >> 2] | 0;
  i4 = 0;
  do {
   HEAP32[i1 + (i4 << 2) >> 2] = 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i16 + 44 >> 2] | 0;
 if ((i1 | 0) == (i16 + 48 | 0)) {
  i11 = i5;
  STACKTOP = i17;
  return i11 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 i11 = i5;
 STACKTOP = i17;
 return i11 | 0;
}

function __ZN2cvL14mixChannels64sEPPKxPKiPPxS4_ii(i22, i21, i17, i16, i19, i20) {
 i22 = i22 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i23 = STACKTOP;
 if ((i20 | 0) <= 0) {
  STACKTOP = i23;
  return;
 }
 i12 = i19 + -2 | 0;
 i13 = (i12 | 0) < 0;
 i15 = i12 >>> 1;
 i14 = (i15 << 4) + 16 | 0;
 i15 = (i15 << 1) + 2 | 0;
 i18 = 0;
 do {
  i2 = HEAP32[i22 + (i18 << 2) >> 2] | 0;
  i1 = HEAP32[i17 + (i18 << 2) >> 2] | 0;
  i5 = HEAP32[i21 + (i18 << 2) >> 2] | 0;
  i11 = HEAP32[i16 + (i18 << 2) >> 2] | 0;
  if (!i2) {
   if (i13) i2 = 0; else {
    i3 = i11 << 1;
    i2 = Math_imul(i11, i14) | 0;
    i4 = i1;
    i5 = 0;
    while (1) {
     i6 = i4 + (i11 << 3) | 0;
     HEAP32[i6 >> 2] = 0;
     HEAP32[i6 + 4 >> 2] = 0;
     i6 = i4;
     HEAP32[i6 >> 2] = 0;
     HEAP32[i6 + 4 >> 2] = 0;
     i5 = i5 + 2 | 0;
     if ((i5 | 0) > (i12 | 0)) break; else i4 = i4 + (i3 << 3) | 0;
    }
    i1 = i1 + i2 | 0;
    i2 = i15;
   }
   if ((i2 | 0) < (i19 | 0)) {
    i11 = i1;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
   }
  } else {
   if (i13) i3 = 0; else {
    i4 = i5 << 1;
    i3 = i11 << 1;
    i6 = Math_imul(i11, i14) | 0;
    i10 = Math_imul(i5, i14) | 0;
    i7 = i1;
    i8 = 0;
    i9 = i2;
    while (1) {
     i28 = i9;
     i27 = HEAP32[i28 + 4 >> 2] | 0;
     i25 = i9 + (i5 << 3) | 0;
     i26 = HEAP32[i25 >> 2] | 0;
     i25 = HEAP32[i25 + 4 >> 2] | 0;
     i24 = i7;
     HEAP32[i24 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i24 + 4 >> 2] = i27;
     i24 = i7 + (i11 << 3) | 0;
     HEAP32[i24 >> 2] = i26;
     HEAP32[i24 + 4 >> 2] = i25;
     i8 = i8 + 2 | 0;
     if ((i8 | 0) > (i12 | 0)) break; else {
      i7 = i7 + (i3 << 3) | 0;
      i9 = i9 + (i4 << 3) | 0;
     }
    }
    i1 = i1 + i6 | 0;
    i3 = i15;
    i2 = i2 + i10 | 0;
   }
   if ((i3 | 0) < (i19 | 0)) {
    i3 = i2;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    i11 = i1;
    HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i11 + 4 >> 2] = i2;
   }
  }
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != (i20 | 0));
 STACKTOP = i23;
 return;
}

function __ZN2cv9MatOp_Bin8makeExprERNS_7MatExprEcRKNS_3MatES5_d(i6, i5, i3, i4, d7) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d7 = +d7;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 i8 = i16 + 32 | 0;
 i11 = i16 + 256 | 0;
 i1 = i16;
 HEAP32[i11 >> 2] = 1124007936;
 i14 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i12 = i11 + 40 | 0;
 i9 = i14 + 0 | 0;
 i10 = i9 + 36 | 0;
 do {
  HEAP32[i9 >> 2] = 0;
  i9 = i9 + 4 | 0;
 } while ((i9 | 0) < (i10 | 0));
 HEAP32[i12 >> 2] = i2;
 i15 = i11 + 48 | 0;
 i13 = i11 + 44 | 0;
 HEAP32[i13 >> 2] = i15;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 i10 = HEAP32[i4 + 16 >> 2] | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAPF64[i1 >> 3] = 0.0;
 __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i8, 33120, i5 << 24 >> 24, i3, i4, i11, d7, +((i10 | 0) != 0 | 0), i1);
 i10 = i8;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i2;
 __ZN2cv3MataSERKS0_(i6 + 8 | 0, i8 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i6 + 64 | 0, i8 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i6 + 120 | 0, i8 + 120 | 0) | 0;
 i9 = i6 + 176 | 0;
 i2 = i8 + 176 | 0;
 i10 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
  i9 = i9 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i9 | 0) < (i10 | 0));
 __ZN2cv7MatExprD2Ev(i8);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i11 = i11 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i14 >> 2] | 0) > 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i14 >> 2] | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i15 | 0)) {
  STACKTOP = i16;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i16;
 return;
}

function __ZN2cvL9randf_64fEPdiPyPKNS_3VecIdLi2EEEb(i5, i6, i9, i7, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i10 = 0, d11 = 0.0, i12 = 0, d13 = 0.0, i14 = 0;
 i8 = STACKTOP;
 i1 = i9;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i6 + -4 | 0;
 if ((i4 | 0) < 0) i3 = 0; else {
  i3 = 0;
  do {
   i14 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
   i14 = _i64Add(i14 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
   i10 = tempRet0;
   d11 = (+(i10 >>> 0) + 4294967296.0 * +(i14 | 0)) * +HEAPF64[i7 + (i3 << 4) >> 3] + +HEAPF64[i7 + (i3 << 4) + 8 >> 3];
   i14 = ___muldi3(i14 | 0, 0, -130063606, 0) | 0;
   i10 = _i64Add(i14 | 0, tempRet0 | 0, i10 | 0, 0) | 0;
   i14 = tempRet0;
   i12 = i3 | 1;
   d13 = (+(i14 >>> 0) + 4294967296.0 * +(i10 | 0)) * +HEAPF64[i7 + (i12 << 4) >> 3] + +HEAPF64[i7 + (i12 << 4) + 8 >> 3];
   HEAPF64[i5 + (i3 << 3) >> 3] = d11;
   HEAPF64[i5 + (i12 << 3) >> 3] = d13;
   i10 = ___muldi3(i10 | 0, 0, -130063606, 0) | 0;
   i14 = _i64Add(i10 | 0, tempRet0 | 0, i14 | 0, 0) | 0;
   i10 = tempRet0;
   i12 = i3 | 2;
   d13 = (+(i10 >>> 0) + 4294967296.0 * +(i14 | 0)) * +HEAPF64[i7 + (i12 << 4) >> 3] + +HEAPF64[i7 + (i12 << 4) + 8 >> 3];
   i14 = ___muldi3(i14 | 0, 0, -130063606, 0) | 0;
   i2 = _i64Add(i14 | 0, tempRet0 | 0, i10 | 0, 0) | 0;
   i1 = tempRet0;
   i10 = i3 | 3;
   d11 = (+(i1 >>> 0) + 4294967296.0 * +(i2 | 0)) * +HEAPF64[i7 + (i10 << 4) >> 3] + +HEAPF64[i7 + (i10 << 4) + 8 >> 3];
   HEAPF64[i5 + (i12 << 3) >> 3] = d13;
   HEAPF64[i5 + (i10 << 3) >> 3] = d11;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i4 | 0));
  i3 = i6 & -4;
 }
 if ((i3 | 0) >= (i6 | 0)) {
  i6 = i2;
  i7 = i1;
  i10 = i9;
  i9 = i10;
  HEAP32[i9 >> 2] = i6;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
 do {
  i2 = ___muldi3(i2 | 0, 0, -130063606, 0) | 0;
  i2 = _i64Add(i2 | 0, tempRet0 | 0, i1 | 0, 0) | 0;
  i1 = tempRet0;
  HEAPF64[i5 + (i3 << 3) >> 3] = (+(i1 >>> 0) + 4294967296.0 * +(i2 | 0)) * +HEAPF64[i7 + (i3 << 4) >> 3] + +HEAPF64[i7 + (i3 << 4) + 8 >> 3];
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i6 | 0));
 i10 = i9;
 i9 = i10;
 HEAP32[i9 >> 2] = i2;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function _gzgets(i9, i10, i8) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 if ((i9 | 0) == 0 | (i10 | 0) == 0 | (i8 | 0) < 1) {
  i10 = 0;
  STACKTOP = i12;
  return i10 | 0;
 }
 if ((HEAP32[i9 + 12 >> 2] | 0) != 7247) {
  i10 = 0;
  STACKTOP = i12;
  return i10 | 0;
 }
 i2 = HEAP32[i9 + 76 >> 2] | 0;
 if (!((i2 | 0) == -5 | (i2 | 0) == 0)) {
  i10 = 0;
  STACKTOP = i12;
  return i10 | 0;
 }
 i2 = i9 + 72 | 0;
 L10 : do if ((HEAP32[i2 >> 2] | 0) != 0 ? (HEAP32[i2 >> 2] = 0, i3 = HEAP32[i9 + 68 >> 2] | 0, i5 = i9 + 52 | 0, i4 = i9 + 88 | 0, i6 = i9 + 4 | 0, i7 = i9 + 8 | 0, (i3 | 0) != 0) : 0) {
  L12 : while (1) {
   while (1) {
    i2 = HEAP32[i9 >> 2] | 0;
    if (i2) break;
    if ((HEAP32[i5 >> 2] | 0) != 0 ? (HEAP32[i4 >> 2] | 0) == 0 : 0) break L10;
    if ((_gz_fetch(i9) | 0) == -1) {
     i1 = 0;
     break L12;
    }
   }
   i1 = (i2 | 0) < 0 | (i2 | 0) > (i3 | 0) ? i3 : i2;
   HEAP32[i9 >> 2] = i2 - i1;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i1;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i1;
   if ((i3 | 0) == (i1 | 0)) break L10; else i3 = i3 - i1 | 0;
  }
  STACKTOP = i12;
  return i1 | 0;
 } while (0);
 i3 = i8 + -1 | 0;
 if (!i3) {
  i10 = 0;
  STACKTOP = i12;
  return i10 | 0;
 }
 i7 = i9 + 4 | 0;
 i6 = i9 + 8 | 0;
 i1 = i10;
 i2 = HEAP32[i9 >> 2] | 0;
 while (1) {
  if (!i2) {
   if ((_gz_fetch(i9) | 0) == -1) {
    i1 = 0;
    i11 = 23;
    break;
   }
   i2 = HEAP32[i9 >> 2] | 0;
   if (!i2) {
    i11 = 17;
    break;
   }
  }
  i4 = i2 >>> 0 > i3 >>> 0 ? i3 : i2;
  i5 = HEAP32[i7 >> 2] | 0;
  i2 = _memchr(i5, 10, i4) | 0;
  i8 = (i2 | 0) == 0;
  if (!i8) i4 = 1 - i5 + i2 | 0;
  _memcpy(i1 | 0, i5 | 0, i4 | 0) | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i4 | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i4;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i4;
  i1 = i1 + i4 | 0;
  if (!((i3 | 0) != (i4 | 0) & i8)) break; else i3 = i3 - i4 | 0;
 }
 if ((i11 | 0) == 17) HEAP32[i9 + 56 >> 2] = 1; else if ((i11 | 0) == 23) {
  STACKTOP = i12;
  return i1 | 0;
 }
 if ((i1 | 0) == (i10 | 0)) {
  i10 = 0;
  STACKTOP = i12;
  return i10 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i12;
 return i10 | 0;
}

function __ZNK2cv11_InputArray6copyToERKNS_12_OutputArrayERKS0_(i5, i1, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i6 = i7 + 8 | 0;
 i3 = i7;
 i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] & 127](i5) | 0;
 if ((i2 | 0) == 655360) {
  __ZNK2cv4UMat6copyToERKNS_12_OutputArrayERKNS_11_InputArrayE(HEAP32[i5 + 8 >> 2] | 0, i1, i4);
  STACKTOP = i7;
  return;
 } else if (!i2) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] & 511](i1);
  STACKTOP = i7;
  return;
 } else if ((i2 | 0) == 65536 | (i2 | 0) == 131072 | (i2 | 0) == 196608) {
  FUNCTION_TABLE_viii[HEAP32[HEAP32[i5 >> 2] >> 2] & 63](i6, i5, -1);
  __ZNK2cv3Mat6copyToERKNS_12_OutputArrayERKNS_11_InputArrayE(i6, i1, i4);
  i5 = i6 + 36 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i2 = i1 + 12 | 0, i1 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) {
   i2 = HEAP32[i5 >> 2] | 0;
   if (i2) {
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) {
     i1 = HEAP32[i6 + 32 >> 2] | 0;
     if (!i1) {
      if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
       i1 = __Znwj(4) | 0;
       HEAP32[i1 >> 2] = 32784;
       HEAP32[6904] = i1;
       ___cxa_guard_release(27624);
      }
      i1 = HEAP32[6904] | 0;
      i2 = HEAP32[i5 >> 2] | 0;
     }
    }
    FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i2);
   }
   HEAP32[i5 >> 2] = 0;
  }
  HEAP32[i5 >> 2] = 0;
  i1 = i6 + 16 | 0;
  i2 = i6 + 4 | 0;
  HEAP32[i1 + 0 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = HEAP32[i6 + 40 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i1 = HEAP32[i6 + 44 >> 2] | 0;
  if ((i1 | 0) == (i6 + 48 | 0)) {
   STACKTOP = i7;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i7;
  return;
 } else {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i3, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-213, i3, 29392, 27528, 2068);
  __ZN2cv6String10deallocateEv(i3);
  STACKTOP = i7;
  return;
 }
}

function __ZNK2cv12MatOp_Invert6assignERKNS_7MatExprERNS_3MatEi(i1, i8, i9, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i12 = i14 + 64 | 0;
 i4 = i14 + 40 | 0;
 i5 = i14 + 20 | 0;
 i6 = i14;
 HEAP32[i12 >> 2] = 1124007936;
 i13 = i12 + 4 | 0;
 i2 = i12 + 8 | 0;
 i10 = i12 + 40 | 0;
 i1 = i13 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i10 >> 2] = i2;
 i11 = i12 + 48 | 0;
 i3 = i12 + 44 | 0;
 HEAP32[i3 >> 2] = i11;
 HEAP32[i12 + 52 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 if ((i7 | 0) != -1 ? (HEAP32[i8 + 8 >> 2] & 4095 | 0) != (i7 | 0) : 0) i2 = i12; else i2 = i9;
 HEAP32[i4 >> 2] = 32088;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 16842752;
 HEAP32[i4 + 8 >> 2] = i8 + 8;
 i1 = i5 + 4 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i5 >> 2] = 32232;
 HEAP32[i1 >> 2] = 33619968;
 HEAP32[i5 + 8 >> 2] = i2;
 +__ZN2cv6invertERKNS_11_InputArrayERKNS_12_OutputArrayEi(i4, i5, HEAP32[i8 + 4 >> 2] | 0);
 if ((HEAP32[i2 + 16 >> 2] | 0) != (HEAP32[i9 + 16 >> 2] | 0)) {
  i8 = i6 + 4 | 0;
  HEAP32[i8 + 0 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAP32[i6 >> 2] = 32232;
  HEAP32[i8 >> 2] = 33619968;
  HEAP32[i6 + 8 >> 2] = i9;
  __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i2, i6, i7, 1.0, 0.0);
 }
 i2 = i12 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i8 = i1 + 12 | 0, i9 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i12);
 HEAP32[i2 >> 2] = 0;
 i9 = i12 + 16 | 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 if ((HEAP32[i13 >> 2] | 0) > 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i13 >> 2] | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i11 | 0)) {
  STACKTOP = i14;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i14;
 return;
}

function __ZN7testing8internal12UnitTestImpl11AddTestInfoEPFvvES3_PNS_8TestInfoE(i7, i1, i6, i9) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i8 = i11 + 20 | 0;
 i10 = i11 + 16 | 0;
 i3 = i11 + 4 | 0;
 i5 = i11;
 i2 = i7 + 8 | 0;
 i4 = HEAP8[i2 >> 0] | 0;
 if (!(i4 & 1)) i4 = (i4 & 255) >>> 1; else i4 = HEAP32[i7 + 12 >> 2] | 0;
 if (!i4) {
  __ZN7testing8internal8FilePath13GetCurrentDirEv(i3);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i3) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
  i4 = HEAP8[i2 >> 0] | 0;
  if (!(i4 & 1)) i4 = (i4 & 255) >>> 1; else i4 = HEAP32[i7 + 12 >> 2] | 0;
  if (!i4) {
   __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i5, 3, 160160, 1076);
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 169048, 51) | 0, 169104, 44) | 0;
   __ZN7testing8internal8GTestLogD2Ev(i5);
  }
 }
 if (!(HEAP8[i9 >> 0] & 1)) i3 = i9 + 1 | 0; else i3 = HEAP32[i9 + 8 >> 2] | 0;
 i4 = HEAP32[i9 + 24 >> 2] | 0;
 do if (i4) if (!(HEAP8[i4 >> 0] & 1)) {
  i4 = i4 + 1 | 0;
  break;
 } else {
  i4 = HEAP32[i4 + 8 >> 2] | 0;
  break;
 } else i4 = 0; while (0);
 i5 = __ZN7testing8internal12UnitTestImpl11GetTestCaseEPKcS3_PFvvES5_(i7, i3, i4, i1, i6) | 0;
 HEAP32[i8 >> 2] = i9;
 i4 = i5 + 24 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i5 + 28 >> 2] | 0)) __ZNSt3__16vectorIPN7testing8TestInfoENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i5 + 20 | 0, i8); else {
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = i9;
   i1 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i4 >> 2] = i1 + 4;
 }
 i1 = i5 + 32 | 0;
 i2 = i5 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 - (HEAP32[i1 >> 2] | 0) >> 2;
 HEAP32[i10 >> 2] = i4;
 if ((i3 | 0) == (HEAP32[i5 + 40 >> 2] | 0)) {
  __ZNSt3__16vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i1, i10);
  STACKTOP = i11;
  return;
 }
 if (i3) HEAP32[i3 >> 2] = i4;
 HEAP32[i2 >> 2] = i3 + 4;
 STACKTOP = i11;
 return;
}

function __ZN2cv3Mat9adjustROIEiiii(i12, i10, i7, i8, i9) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i14 + 16 | 0;
 i13 = i14 + 8 | 0;
 i11 = i14;
 i6 = i12 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!((i1 | 0) < 3 ? (HEAP32[HEAP32[i12 + 44 >> 2] >> 2] | 0) != 0 : 0)) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i5, 24) | 0) + 0 | 0;
  i3 = 28352 | 0;
  i2 = i4 + 24 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i4 | 0) < (i2 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 28400, 27528, 904);
  __ZN2cv6String10deallocateEv(i5);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i13 >> 2] = 0;
 i3 = i13 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 if ((i1 | 0) > 0) {
  i6 = i12 + 44 | 0;
  i2 = i6;
  i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 } else {
  i2 = i12 + 44 | 0;
  i1 = 0;
 }
 __ZNK2cv3Mat9locateROIERNS_5Size_IiEERNS_6Point_IiEE(i12, i13, i11);
 i15 = HEAP32[i4 >> 2] | 0;
 i4 = i15 - i10 | 0;
 i4 = (i4 | 0) < 0 ? 0 : i4;
 i10 = i12 + 8 | 0;
 i7 = i15 + i7 + (HEAP32[i10 >> 2] | 0) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i6 = i11 - i8 | 0;
 i6 = (i6 | 0) < 0 ? 0 : i6;
 i8 = i12 + 12 | 0;
 i9 = i11 + i9 + (HEAP32[i8 >> 2] | 0) | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i13 = (Math_imul(i6 - i11 | 0, i1) | 0) + (Math_imul(HEAP32[i12 + 48 >> 2] | 0, i4 - i15 | 0) | 0) | 0;
 i11 = i12 + 16 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i13;
 i7 = ((i3 | 0) < (i7 | 0) ? i3 : i7) - i4 | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = ((i5 | 0) < (i9 | 0) ? i5 : i9) - i6;
 i9 = HEAP32[i12 + 40 >> 2] | 0;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 >> 2];
 i9 = Math_imul(HEAP32[i8 >> 2] | 0, i1) | 0;
 if ((i9 | 0) != (HEAP32[HEAP32[i2 >> 2] >> 2] | 0) ? (HEAP32[i10 >> 2] | 0) != 1 : 0) {
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & -16385;
  STACKTOP = i14;
  return i12 | 0;
 }
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 16384;
 STACKTOP = i14;
 return i12 | 0;
}

function __ZN4perf8TestBase12declareArrayERNSt3__16vectorINS1_4pairIiN2cv5Size_IiEEEENS1_9allocatorIS7_EEEERKNS4_17_InputOutputArrayENS0_10WarmUpTypeE(i9, i8, i10) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i7 = i11 + 16 | 0;
 i4 = i11 + 8 | 0;
 i1 = i11 + 4 | 0;
 i2 = i11;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 76 >> 2] & 127](i8) | 0) {
  if (!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8) | 0)) {
   STACKTOP = i11;
   return;
  }
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i1, 1, 170184, 1009, 171216);
  __ZN7testing7MessageC2Ev(i2);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i2 >> 2] | 0) + 8 | 0, 174040, 77) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i1, i2);
  if (HEAP32[i2 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i3 = HEAP32[i2 >> 2] | 0, (i3 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
   HEAP32[i2 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i1);
  STACKTOP = i11;
  return;
 }
 i6 = __ZN4perf8TestBase14getSizeInBytesERKN2cv11_InputArrayE(i8) | 0;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8) | 0) != 327680 ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] & 127](i8) | 0) != 262144 : 0) {
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] & 63](i4, i8, -1);
  i5 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i5 = 0;
  i3 = 0;
 }
 HEAP32[i7 >> 2] = i6;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = i3;
 i2 = i9 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i9 + 8 >> 2] | 0)) __ZNSt3__16vectorINS_4pairIiN2cv5Size_IiEEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i9, i7); else {
  if (i1) {
   HEAP32[i1 + 4 >> 2] = i5;
   HEAP32[i1 + 8 >> 2] = i3;
   HEAP32[i1 >> 2] = i6;
  }
  HEAP32[i2 >> 2] = i1 + 12;
 }
 __ZN4perf8TestBase6warmupERKN2cv17_InputOutputArrayENS0_10WarmUpTypeE(i8, i10);
 STACKTOP = i11;
 return;
}

function __ZNSt3__16vectorINS0_IhNS_9allocatorIhEEEENS1_IS3_EEE8__appendEj(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i10 = i11;
 i6 = HEAP32[i8 + 8 >> 2] | 0;
 i5 = i8 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = i3;
 if (((i6 - i1 | 0) / 12 | 0) >>> 0 >= i9 >>> 0) {
  i1 = i9;
  i2 = i3;
  while (1) {
   if (i2) {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
   }
   i1 = i1 + -1 | 0;
   if (!i1) break; else i2 = i2 + 12 | 0;
  }
  HEAP32[i5 >> 2] = i3 + (i9 * 12 | 0);
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = ((i1 - i2 | 0) / 12 | 0) + i9 | 0;
 if (i1 >>> 0 > 357913941) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i8);
 i3 = i2;
 i2 = (i6 - i3 | 0) / 12 | 0;
 if (i2 >>> 0 < 178956970) {
  i6 = i2 << 1;
  i6 = i6 >>> 0 < i1 >>> 0 ? i1 : i6;
 } else i6 = 357913941;
 i5 = ((HEAP32[i5 >> 2] | 0) - i3 | 0) / 12 | 0;
 i3 = i10 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = i8 + 8;
 if (!i6) i4 = 0; else i4 = __Znwj(i6 * 12 | 0) | 0;
 HEAP32[i10 >> 2] = i4;
 i12 = i4 + (i5 * 12 | 0) | 0;
 i7 = i10 + 8 | 0;
 HEAP32[i7 >> 2] = i12;
 i1 = i10 + 4 | 0;
 HEAP32[i1 >> 2] = i12;
 HEAP32[i3 >> 2] = i4 + (i6 * 12 | 0);
 i2 = i9;
 i3 = i12;
 while (1) {
  if (i3) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
  }
  i2 = i2 + -1 | 0;
  if (!i2) break; else i3 = i3 + 12 | 0;
 }
 HEAP32[i7 >> 2] = i4 + ((i5 + i9 | 0) * 12 | 0);
 __ZNSt3__16vectorINS0_IhNS_9allocatorIhEEEENS1_IS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS4_EE(i8, i10);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = ~(((i1 + -12 - i3 | 0) >>> 0) / 12 | 0);
  i5 = i1;
  do {
   i2 = i5;
   i5 = i5 + -12 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   if (i6) {
    i2 = i2 + -8 | 0;
    if ((HEAP32[i2 >> 2] | 0) != (i6 | 0)) HEAP32[i2 >> 2] = i6;
    __ZdlPv(i6);
   }
  } while ((i5 | 0) != (i3 | 0));
  HEAP32[i7 >> 2] = i1 + (i4 * 12 | 0);
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8IteratorC2EPKNS0_23ParamGeneratorInterfaceINSt3tr15tupleIS4_S6_vvvvvvvvEEEERKNS0_14ParamGeneratorIS4_EERKNS0_13ParamIteratorIS4_EERKNSG_IS6_EERKNSK_IS6_EE(i8, i1, i3, i2, i4, i5) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 HEAP32[i8 >> 2] = 2160;
 HEAP32[i8 + 4 >> 2] = i1;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 + 8 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] & 127](i6) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] & 127](i6) | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i9 = i8 + 16 | 0;
 HEAP32[i9 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] & 127](i6) | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 + 20 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] & 127](i6) | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i2 = i8 + 24 | 0;
 HEAP32[i2 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] & 127](i6) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i1 = i8 + 28 | 0;
 HEAP32[i1 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] & 127](i6) | 0;
 i6 = i8 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 36 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (i3 | 0)) {
  STACKTOP = i10;
  return;
 }
 if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] & 127](i4, i3) | 0) {
  STACKTOP = i10;
  return;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i4 | 0) == (i3 | 0)) {
  STACKTOP = i10;
  return;
 }
 if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] & 127](i4, i3) | 0) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i9 >> 2] | 0;
 i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] & 127](i3) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i1) | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i10;
 return;
}

function _cvReleaseData(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i6;
 do if (i5) {
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = i3 & -65536;
  do if ((i2 | 0) == 1111621632) if ((HEAP32[i5 + 24 >> 2] | 0) > 0) {
   if ((HEAP32[i5 + 20 >> 2] | 0) <= 0) if ((i2 | 0) == 1111687168) break; else {
    i1 = 19;
    break;
   }
   if ((i2 | 0) == 1111687168) break; else if ((i2 | 0) != 1111621632) {
    STACKTOP = i6;
    return;
   }
   if ((HEAP32[i5 + 24 >> 2] | 0) <= 0) {
    STACKTOP = i6;
    return;
   }
   if ((HEAP32[i5 + 20 >> 2] | 0) <= 0) {
    STACKTOP = i6;
    return;
   }
   i1 = i5 + 16 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    STACKTOP = i6;
    return;
   }
   HEAP32[i1 >> 2] = 0;
   i1 = i5 + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != 0 ? (i3 = (HEAP32[i2 >> 2] | 0) + -1 | 0, HEAP32[i2 >> 2] = i3, (i3 | 0) == 0) : 0) {
    _cvFree_(HEAP32[i1 >> 2] | 0);
    HEAP32[i1 >> 2] = 0;
   }
   HEAP32[i1 >> 2] = 0;
   STACKTOP = i6;
   return;
  } else i1 = 19; else if ((i2 | 0) != 1111687168) i1 = 19; while (0);
  if ((i1 | 0) == 19) {
   if ((i3 | 0) != 112) break;
   i2 = HEAP32[10246] | 0;
   if (!i2) {
    i2 = i5 + 108 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i5 + 68 >> 2] = 0;
    _cvFree_(i1);
    STACKTOP = i6;
    return;
   } else {
    FUNCTION_TABLE_vii[i2 & 127](i5, 2);
    STACKTOP = i6;
    return;
   }
  }
  i2 = i5 + 16 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   STACKTOP = i6;
   return;
  }
  HEAP32[i2 >> 2] = 0;
  i2 = i5 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i3 = (HEAP32[i1 >> 2] | 0) + -1 | 0, HEAP32[i1 >> 2] = i3, (i3 | 0) == 0) : 0) {
   _cvFree_(HEAP32[i2 >> 2] | 0);
   HEAP32[i2 >> 2] = 0;
  }
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i6;
  return;
 } while (0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i4, 38) | 0) + 0 | 0;
 i1 = 42264 | 0;
 i3 = i2 + 38 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i4, 42304, 40912, 1003);
 __ZN2cv6String10deallocateEv(i4);
 STACKTOP = i6;
 return;
}

function __ZN2cvL14randnScale_16uEPKfPtiiS1_S1_b(i9, i7, i14, i11, i12, i13, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i15 = 0;
 i15 = STACKTOP;
 if (i1) {
  if ((i14 | 0) <= 0) {
   STACKTOP = i15;
   return;
  }
  i10 = (i11 | 0) > 0;
  i8 = 0;
  while (1) {
   if (i10) {
    i1 = 0;
    do {
     i6 = Math_imul(i1, i11) | 0;
     i5 = 0;
     f4 = Math_fround(HEAPF32[i12 + (i1 << 2) >> 2]);
     do {
      f2 = Math_fround(HEAPF32[i9 + (i5 << 2) >> 2]);
      f4 = Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i13 + (i5 + i6 << 2) >> 2])));
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i11 | 0));
     i3 = _lrint(+f4) | 0;
     if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
     HEAP16[i7 + (i1 << 1) >> 1] = i3;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i11 | 0));
   }
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i14 | 0)) break; else {
    i9 = i9 + (i11 << 2) | 0;
    i7 = i7 + (i11 << 1) | 0;
   }
  }
  STACKTOP = i15;
  return;
 }
 if ((i11 | 0) == 1) {
  f4 = Math_fround(HEAPF32[i12 >> 2]);
  f2 = Math_fround(HEAPF32[i13 >> 2]);
  if ((i14 | 0) > 0) i3 = 0; else {
   STACKTOP = i15;
   return;
  }
  do {
   i1 = _lrint(+Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i9 + (i3 << 2) >> 2])))) | 0;
   if (i1 >>> 0 >= 65536) i1 = (i1 | 0) > 0 ? 65535 : 0;
   HEAP16[i7 + (i3 << 1) >> 1] = i1;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i14 | 0));
  STACKTOP = i15;
  return;
 }
 if ((i14 | 0) <= 0) {
  STACKTOP = i15;
  return;
 }
 i8 = (i11 | 0) > 0;
 i1 = i9;
 i5 = 0;
 while (1) {
  if (i8) {
   i6 = 0;
   do {
    f2 = Math_fround(HEAPF32[i1 + (i6 << 2) >> 2]);
    f2 = Math_fround(f2 * Math_fround(HEAPF32[i13 + (i6 << 2) >> 2]));
    i3 = _lrint(+Math_fround(f2 + Math_fround(HEAPF32[i12 + (i6 << 2) >> 2]))) | 0;
    if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
    HEAP16[i7 + (i6 << 1) >> 1] = i3;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i11 | 0));
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == (i14 | 0)) break; else {
   i7 = i7 + (i11 << 1) | 0;
   i1 = i1 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN2cvL11finalizeHdrERNS_3MatE(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i5 = i9 + 40 | 0;
 L1 : do if ((i7 | 0) > 0) {
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = 0;
  while (1) {
   i2 = i3 + 1 | 0;
   if ((HEAP32[i1 + (i3 << 2) >> 2] | 0) > 1) {
    i2 = i3;
    break L1;
   }
   if ((i2 | 0) < (i7 | 0)) i3 = i2; else break;
  }
 } else i2 = 0; while (0);
 i10 = HEAP32[i9 + 44 >> 2] | 0;
 i4 = i7;
 while (1) {
  i1 = i4;
  i4 = i4 + -1 | 0;
  if ((i4 | 0) <= (i2 | 0)) {
   i6 = 7;
   break;
  }
  i3 = HEAP32[i5 >> 2] | 0;
  i8 = Math_imul(HEAP32[i3 + (i4 << 2) >> 2] | 0, HEAP32[i10 + (i4 << 2) >> 2] | 0) | 0;
  if (i8 >>> 0 < (HEAP32[i10 + (i1 + -2 << 2) >> 2] | 0) >>> 0) {
   i8 = i3;
   break;
  }
 }
 if ((i6 | 0) == 7) i8 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i5 = ___muldi3(i5 | 0, ((i5 | 0) < 0) << 31 >> 31 | 0, HEAP32[i10 >> 2] | 0, 0) | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = (i4 | 0) <= (i2 | 0) & ((i5 | 0) == (i5 | 0) & (tempRet0 | 0) == 0) ? i6 | 16384 : i6 & -16385;
 if ((i7 | 0) > 2) {
  HEAP32[i9 + 12 >> 2] = -1;
  HEAP32[i9 + 8 >> 2] = -1;
 }
 i1 = HEAP32[i9 + 36 >> 2] | 0;
 if (!i1) i1 = i9 + 16 | 0; else {
  i6 = HEAP32[i1 + 16 >> 2] | 0;
  i1 = i9 + 16 | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i9 + 20 >> 2] = i6;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i9 + 28 >> 2] = 0;
  HEAP32[i9 + 24 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = (HEAP32[i9 + 20 >> 2] | 0) + (Math_imul(i1, i4) | 0) | 0;
 HEAP32[i9 + 28 >> 2] = i3;
 if ((i4 | 0) <= 0) {
  HEAP32[i9 + 24 >> 2] = i3;
  STACKTOP = i11;
  return;
 }
 i6 = i7 + -1 | 0;
 i3 = i2 + (Math_imul(HEAP32[i10 + (i6 << 2) >> 2] | 0, HEAP32[i8 + (i6 << 2) >> 2] | 0) | 0) | 0;
 i5 = i9 + 24 | 0;
 HEAP32[i5 >> 2] = i3;
 if ((i6 | 0) > 0) i2 = 1; else {
  STACKTOP = i11;
  return;
 }
 while (1) {
  i3 = i3 + (Math_imul(i1, i4 + -1 | 0) | 0) | 0;
  if ((i2 | 0) == (i6 | 0)) break;
  i4 = HEAP32[i8 + (i2 << 2) >> 2] | 0;
  i1 = HEAP32[i10 + (i2 << 2) >> 2] | 0;
  i2 = i2 + 1 | 0;
 }
 HEAP32[i5 >> 2] = i3;
 STACKTOP = i11;
 return;
}

function __ZN2cvL13randnScale_8sEPKfPaiiS1_S1_b(i9, i7, i14, i11, i12, i13, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i15 = 0;
 i15 = STACKTOP;
 if (i1) {
  if ((i14 | 0) <= 0) {
   STACKTOP = i15;
   return;
  }
  i10 = (i11 | 0) > 0;
  i8 = 0;
  while (1) {
   if (i10) {
    i1 = 0;
    do {
     i6 = Math_imul(i1, i11) | 0;
     i5 = 0;
     f4 = Math_fround(HEAPF32[i12 + (i1 << 2) >> 2]);
     do {
      f2 = Math_fround(HEAPF32[i9 + (i5 << 2) >> 2]);
      f4 = Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i13 + (i5 + i6 << 2) >> 2])));
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i11 | 0));
     i3 = _lrint(+f4) | 0;
     if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
     HEAP8[i7 + i1 >> 0] = i3;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i11 | 0));
   }
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i14 | 0)) break; else {
    i9 = i9 + (i11 << 2) | 0;
    i7 = i7 + i11 | 0;
   }
  }
  STACKTOP = i15;
  return;
 }
 if ((i11 | 0) == 1) {
  f4 = Math_fround(HEAPF32[i12 >> 2]);
  f2 = Math_fround(HEAPF32[i13 >> 2]);
  if ((i14 | 0) > 0) i3 = 0; else {
   STACKTOP = i15;
   return;
  }
  do {
   i1 = _lrint(+Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i9 + (i3 << 2) >> 2])))) | 0;
   if ((i1 + 128 | 0) >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 127 : -128;
   HEAP8[i7 + i3 >> 0] = i1;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i14 | 0));
  STACKTOP = i15;
  return;
 }
 if ((i14 | 0) <= 0) {
  STACKTOP = i15;
  return;
 }
 i8 = (i11 | 0) > 0;
 i1 = i9;
 i5 = 0;
 while (1) {
  if (i8) {
   i6 = 0;
   do {
    f2 = Math_fround(HEAPF32[i1 + (i6 << 2) >> 2]);
    f2 = Math_fround(f2 * Math_fround(HEAPF32[i13 + (i6 << 2) >> 2]));
    i3 = _lrint(+Math_fround(f2 + Math_fround(HEAPF32[i12 + (i6 << 2) >> 2]))) | 0;
    if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i6 >> 0] = i3;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i11 | 0));
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == (i14 | 0)) break; else {
   i7 = i7 + i11 | 0;
   i1 = i1 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN2cvL13copyMask16uC3EPKhjS1_jPhjNS_5Size_IiEEPv(i5, i14, i3, i13, i4, i12, i2, i1) {
 i5 = i5 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i11 = STACKTOP;
 i10 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = i10 & -4;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i2 = 0; else {
   i1 = 0;
   do {
    if (HEAP8[i3 + i1 >> 0] | 0) {
     i2 = i4 + (i1 * 6 | 0) | 0;
     i15 = i5 + (i1 * 6 | 0) | 0;
     HEAP16[i2 + 0 >> 1] = HEAP16[i15 + 0 >> 1] | 0;
     HEAP16[i2 + 2 >> 1] = HEAP16[i15 + 2 >> 1] | 0;
     HEAP16[i2 + 4 >> 1] = HEAP16[i15 + 4 >> 1] | 0;
    }
    i2 = i1 | 1;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 * 6 | 0) | 0;
     i2 = i5 + (i2 * 6 | 0) | 0;
     HEAP16[i15 + 0 >> 1] = HEAP16[i2 + 0 >> 1] | 0;
     HEAP16[i15 + 2 >> 1] = HEAP16[i2 + 2 >> 1] | 0;
     HEAP16[i15 + 4 >> 1] = HEAP16[i2 + 4 >> 1] | 0;
    }
    i2 = i1 | 2;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 * 6 | 0) | 0;
     i2 = i5 + (i2 * 6 | 0) | 0;
     HEAP16[i15 + 0 >> 1] = HEAP16[i2 + 0 >> 1] | 0;
     HEAP16[i15 + 2 >> 1] = HEAP16[i2 + 2 >> 1] | 0;
     HEAP16[i15 + 4 >> 1] = HEAP16[i2 + 4 >> 1] | 0;
    }
    i2 = i1 | 3;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 * 6 | 0) | 0;
     i2 = i5 + (i2 * 6 | 0) | 0;
     HEAP16[i15 + 0 >> 1] = HEAP16[i2 + 0 >> 1] | 0;
     HEAP16[i15 + 2 >> 1] = HEAP16[i2 + 2 >> 1] | 0;
     HEAP16[i15 + 4 >> 1] = HEAP16[i2 + 4 >> 1] | 0;
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i7 | 0));
   i2 = i9;
  }
  if ((i2 | 0) < (i10 | 0)) do {
   if (HEAP8[i3 + i2 >> 0] | 0) {
    i1 = i4 + (i2 * 6 | 0) | 0;
    i15 = i5 + (i2 * 6 | 0) | 0;
    HEAP16[i1 + 0 >> 1] = HEAP16[i15 + 0 >> 1] | 0;
    HEAP16[i1 + 2 >> 1] = HEAP16[i15 + 2 >> 1] | 0;
    HEAP16[i1 + 4 >> 1] = HEAP16[i15 + 4 >> 1] | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
  if (!i6) break; else {
   i3 = i3 + i13 | 0;
   i4 = i4 + i12 | 0;
   i5 = i5 + i14 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZNSt3__16vectorINS_4pairIN2cv6StringEPFPNS2_9AlgorithmEvEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i12, i7) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 i10 = i12 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = (((HEAP32[i10 >> 2] | 0) - i1 | 0) / 12 | 0) + 1 | 0;
 if (i3 >>> 0 > 357913941) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i11 = i12 + 8 | 0;
 i2 = ((HEAP32[i11 >> 2] | 0) - i1 | 0) / 12 | 0;
 if (i2 >>> 0 < 178956970) {
  i2 = i2 << 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i3 = ((HEAP32[i10 >> 2] | 0) - i1 | 0) / 12 | 0;
  if (!i2) {
   i1 = 0;
   i9 = 0;
   i4 = i3;
  } else i5 = 6;
 } else {
  i2 = 357913941;
  i3 = ((HEAP32[i10 >> 2] | 0) - i1 | 0) / 12 | 0;
  i5 = 6;
 }
 if ((i5 | 0) == 6) {
  i1 = i2;
  i9 = __Znwj(i2 * 12 | 0) | 0;
  i4 = i3;
 }
 i3 = i9 + (i4 * 12 | 0) | 0;
 i8 = i9 + (i1 * 12 | 0) | 0;
 if (i3) {
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 + (i4 * 12 | 0) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  if (i2) {
   i6 = i2 + -4 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  }
  HEAP32[i9 + (i4 * 12 | 0) + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 }
 i7 = i9 + ((i4 + 1 | 0) * 12 | 0) | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i6 | 0)) {
  i2 = i6;
  i1 = i6;
 } else {
  i5 = i4 + -1 - (((i2 + -12 - i6 | 0) >>> 0) / 12 | 0) | 0;
  while (1) {
   i1 = i2;
   i2 = i2 + -12 | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 + -12 >> 2] = i4;
   HEAP32[i3 + -8 >> 2] = HEAP32[i1 + -8 >> 2];
   if (i4) {
    i4 = i4 + -4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   }
   HEAP32[i3 + -4 >> 2] = HEAP32[i1 + -4 >> 2];
   if ((i2 | 0) == (i6 | 0)) break; else i3 = i3 + -12 | 0;
  }
  i3 = i9 + (i5 * 12 | 0) | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i3;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i11 >> 2] = i8;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) break;
  i10 = i1 + -12 | 0;
  __ZN2cv6String10deallocateEv(i10);
  i1 = i10;
 }
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i13;
 return;
}

function __ZL20icvYMLEndWriteStructP13CvFileStorage(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i13 + 8 | 0;
 i4 = i13;
 HEAP32[i10 >> 2] = 0;
 i11 = i12 + 44 | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 i5 = i12 + 36 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!(HEAP32[i1 + 24 >> 2] | 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i4, 44) | 0) + 0 | 0;
  i1 = 16896 | 0;
  i3 = i2 + 44 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i4, 16944, 8960, 1563);
  __ZN2cv6String10deallocateEv(i4);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 _cvSeqPop(i1, i10);
 i8 = i9 & 8;
 if (!i8) {
  if (i9 & 32) {
   i7 = i12 + 72 | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   i3 = i12 + 76 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i6 = i12 + 56 | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   if (i5 >>> 0 > (i1 + i4 | 0) >>> 0) {
    HEAP8[i5 >> 0] = 10;
    HEAP8[i5 + 1 >> 0] = 0;
    __ZL7icvPutsP13CvFileStoragePKc(i12, HEAP32[i3 >> 2] | 0);
    i1 = HEAP32[i3 >> 2] | 0;
    HEAP32[i7 >> 2] = i1;
    i4 = HEAP32[i6 >> 2] | 0;
   }
   i2 = HEAP32[i12 + 40 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0)) i2 = i4; else {
    if ((i2 | 0) > (i4 | 0)) {
     _memset(i1 + i4 | 0, 32, i2 - i4 | 0) | 0;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    HEAP32[i6 >> 2] = i2;
   }
   i6 = i1 + i2 | 0;
   i9 = (i9 & 7 | 0) == 6 ? 32123 : 23899;
   HEAP8[i6 >> 0] = i9;
   HEAP8[i6 + 1 >> 0] = i9 >> 8;
   HEAP32[i7 >> 2] = i1 + (i2 + 2);
  }
 } else {
  i2 = i12 + 72 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i9 & 32 | 0) == 0 ? i1 >>> 0 > ((HEAP32[i12 + 76 >> 2] | 0) + (HEAP32[i12 + 40 >> 2] | 0) | 0) >>> 0 : 0) {
   HEAP8[i1 >> 0] = 32;
   i1 = i1 + 1 | 0;
  }
  HEAP8[i1 >> 0] = (i9 & 7 | 0) == 6 ? 125 : 93;
  HEAP32[i2 >> 2] = i1 + 1;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 & 8) {
  HEAP32[i11 >> 2] = i1;
  STACKTOP = i13;
  return;
 }
 i10 = i12 + 40 | 0;
 HEAP32[i10 >> 2] = -3 - (i8 >>> 3) + (HEAP32[i10 >> 2] | 0);
 HEAP32[i11 >> 2] = i1;
 STACKTOP = i13;
 return;
}

function __ZN7testingL31GetReservedAttributesForElementERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i7;
 if (!(__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i2, 163616) | 0)) {
  __ZNSt3__16vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEC2IPKPKcEET_NS_9enable_ifIXaasr21__is_forward_iteratorISE_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISE_E9referenceEEE5valueESE_E4typeE(i6, 169152, 169184 | 0);
  STACKTOP = i7;
  return;
 }
 if (!(__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i2, 163536) | 0)) {
  __ZNSt3__16vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEC2IPKPKcEET_NS_9enable_ifIXaasr21__is_forward_iteratorISE_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISE_E9referenceEEE5valueESE_E4typeE(i6, 169184, 169208 | 0);
  STACKTOP = i7;
  return;
 }
 if (!(__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i2, 163312) | 0)) {
  __ZNSt3__16vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEC2IPKPKcEET_NS_9enable_ifIXaasr21__is_forward_iteratorISE_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISE_E9referenceEEE5valueESE_E4typeE(i6, 169208, 169232 | 0);
  STACKTOP = i7;
  return;
 }
 __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i3, 3, 160160, 3298);
 i5 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 169232, 24) | 0, 169264, 35) | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 if (!(i1 & 1)) {
  i4 = i2 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i4 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, i4, i1) | 0;
 __ZN7testing8internal8GTestLogD2Ev(i3);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN7testing8internal12UnitTestImplD2Ev(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 HEAP32[i9 >> 2] = 163952;
 i6 = i9 + 60 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i8 = i9 + 64 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) do {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i3 | 0));
 i5 = i9 + 48 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i7 = i9 + 52 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) do {
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i2 = HEAP32[i9 + 164 >> 2] | 0;
 if (i2) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 i3 = i9 + 200 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2) {
  i1 = i9 + 204 | 0;
  while (1) {
   i4 = HEAP32[i1 >> 2] | 0;
   if ((i4 | 0) == (i2 | 0)) break;
   HEAP32[i1 >> 2] = i4 + -20;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4 + -12 | 0);
  }
  __ZdlPv(HEAP32[i3 >> 2] | 0);
 }
 i2 = HEAP32[i9 + 152 >> 2] | 0;
 if (i2) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 __ZN7testing10TestResultD2Ev(i9 + 112 | 0);
 __ZN7testing8internal29ParameterizedTestCaseRegistryD2Ev(i9 + 84 | 0);
 i3 = HEAP32[i9 + 72 >> 2] | 0;
 if (i3) {
  i2 = i9 + 76 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) HEAP32[i2 >> 2] = i1 + (~((i1 + -4 - i3 | 0) >>> 2) << 2);
  __ZdlPv(i3);
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2) {
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) HEAP32[i8 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = i9 + 8 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 i1 = i9 + 8 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 STACKTOP = i10;
 return;
}

function __ZN2cv11MatOp_Solve8makeExprERNS_7MatExprEiRKNS_3MatES5_(i6, i5, i3, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 i7 = i15 + 32 | 0;
 i10 = i15 + 256 | 0;
 i1 = i15;
 HEAP32[i10 >> 2] = 1124007936;
 i13 = i10 + 4 | 0;
 i2 = i10 + 8 | 0;
 i11 = i10 + 40 | 0;
 i8 = i13 + 0 | 0;
 i9 = i8 + 36 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i11 >> 2] = i2;
 i14 = i10 + 48 | 0;
 i12 = i10 + 44 | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i10 + 52 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAPF64[i1 >> 3] = 0.0;
 __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i7, 33160, i5, i3, i4, i10, 1.0, 1.0, i1);
 i9 = i7;
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i2;
 __ZN2cv3MataSERKS0_(i6 + 8 | 0, i7 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i6 + 64 | 0, i7 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i6 + 120 | 0, i7 + 120 | 0) | 0;
 i8 = i6 + 176 | 0;
 i2 = i7 + 176 | 0;
 i9 = i8 + 48 | 0;
 do {
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  i8 = i8 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 __ZN2cv7MatExprD2Ev(i7);
 i2 = i10 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i8 = i1 + 12 | 0, i9 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i10);
 HEAP32[i2 >> 2] = 0;
 i10 = i10 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i13 >> 2] | 0) > 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i13 >> 2] | 0));
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i14 | 0)) {
  STACKTOP = i15;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i15;
 return;
}

function __ZN7testing8internalL17PrintColorEncodedEPKc() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i11 = i13;
 i7 = i13 + 4 | 0;
 i8 = i7 + 1 | 0;
 i9 = i7 + 8 | 0;
 i10 = i7 + 4 | 0;
 i2 = 165920;
 i3 = 166064;
 i1 = 0;
 L1 : while (1) {
  i6 = i3;
  L3 : while (1) {
   i4 = i6 - i2 | 0;
   if (i4 >>> 0 > 4294967279) {
    i12 = 5;
    break L1;
   }
   if (i4 >>> 0 < 11) {
    HEAP8[i7 >> 0] = i4 << 1;
    i5 = i8;
   } else {
    i3 = i4 + 16 & -16;
    i5 = __Znwj(i3) | 0;
    HEAP32[i9 >> 2] = i5;
    HEAP32[i7 >> 2] = i3 | 1;
    HEAP32[i10 >> 2] = i4;
   }
   if ((i2 | 0) == (i6 | 0)) i2 = i5; else {
    i3 = i5;
    while (1) {
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i6 | 0)) break; else i3 = i3 + 1 | 0;
    }
    i2 = i5 + i4 | 0;
   }
   HEAP8[i2 >> 0] = 0;
   HEAP32[i11 >> 2] = (HEAP8[i7 >> 0] & 1) == 0 ? i8 : HEAP32[i9 >> 2] | 0;
   __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(i1, 163e3, i11);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
   i3 = i6 + 1 | 0;
   i2 = i6 + 2 | 0;
   switch (HEAP8[i3 >> 0] | 0) {
   case 82:
    {
     i12 = 14;
     break L3;
    }
   case 68:
    {
     i1 = 0;
     break L3;
    }
   case 89:
    {
     i12 = 17;
     break L3;
    }
   case 71:
    {
     i12 = 16;
     break L3;
    }
   case 64:
    {
     __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(i1, 168432, i11);
     break;
    }
   default:
    i2 = i3;
   }
   i6 = _strchr(i2, 64) | 0;
   if (!i6) {
    i12 = 3;
    break L1;
   }
  }
  if ((i12 | 0) == 14) {
   i12 = 0;
   i1 = 1;
  } else if ((i12 | 0) == 16) {
   i12 = 0;
   i1 = 2;
  } else if ((i12 | 0) == 17) {
   i12 = 0;
   i1 = 3;
  }
  i3 = _strchr(i2, 64) | 0;
  if (!i3) {
   i12 = 3;
   break;
  }
 }
 if ((i12 | 0) == 3) {
  HEAP32[i11 >> 2] = i2;
  __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(i1, 163e3, i11);
  STACKTOP = i13;
  return;
 } else if ((i12 | 0) == 5) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i7);
}

function __ZN2cv8internal18WriteStructContextC2ERNS_11FileStorageERKNS_6StringEiS6_(i8, i4, i3, i9, i1) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i12 + 16 | 0;
 i6 = i12 + 8 | 0;
 i7 = i12;
 i10 = i12 + 25 | 0;
 i11 = i12 + 24 | 0;
 HEAP32[i8 >> 2] = i4;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!(HEAP32[i3 + 4 >> 2] | 0)) i4 = 0; else {
  i4 = HEAP32[i3 >> 2] | 0;
  i4 = (i4 | 0) == 0 ? 12512 : i4;
 }
 if (!(HEAP32[i1 + 4 >> 2] | 0)) i3 = 0; else {
  i3 = HEAP32[i1 >> 2] | 0;
  i3 = (i3 | 0) == 0 ? 12512 : i3;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i5 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 _cvStartWriteStruct(i2, i4, i9, i3, i5);
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 if ((i7 | 0) != (i1 | 0)) {
  __ZN2cv6String10deallocateEv(i1);
  i2 = HEAP32[i7 >> 2] | 0;
  if (!i2) i2 = 0; else {
   i2 = i2 + -4 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   i2 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i1 >> 2] = i2;
  HEAP32[i3 + 16 >> 2] = HEAP32[i4 >> 2];
 }
 __ZN2cv6String10deallocateEv(i7);
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = i3 + 32 | 0;
 if ((i9 & 7 | 0) == 5) {
  HEAP32[i1 >> 2] = 1;
  HEAP8[i10 >> 0] = 91;
  i2 = i3 + 24 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i3 + 28 >> 2] | 0)) {
   __ZNSt3__16vectorIcNS_9allocatorIcEEE21__push_back_slow_pathIKcEEvRT_(i3 + 20 | 0, i10);
   STACKTOP = i12;
   return;
  }
  if (!i1) i1 = 0; else {
   HEAP8[i1 >> 0] = 91;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i1 + 1;
  STACKTOP = i12;
  return;
 } else {
  HEAP32[i1 >> 2] = 6;
  HEAP8[i11 >> 0] = 123;
  i2 = i3 + 24 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i3 + 28 >> 2] | 0)) {
   __ZNSt3__16vectorIcNS_9allocatorIcEEE21__push_back_slow_pathIKcEEvRT_(i3 + 20 | 0, i11);
   STACKTOP = i12;
   return;
  }
  if (!i1) i1 = 0; else {
   HEAP8[i1 >> 0] = 123;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i1 + 1;
  STACKTOP = i12;
  return;
 }
}

function __ZNSt3__19__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i6, i12, i10, i11, i13, i3, i1, i4, i5, i7) {
 i6 = i6 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i2 = 0, i8 = 0, i9 = 0, i14 = 0;
 i14 = STACKTOP;
 i8 = HEAP32[i11 >> 2] | 0;
 i9 = (i8 | 0) == (i10 | 0);
 do if (i9) {
  i2 = (HEAP8[i7 + 24 >> 0] | 0) == i6 << 24 >> 24;
  if (!i2 ? (HEAP8[i7 + 25 >> 0] | 0) != i6 << 24 >> 24 : 0) break;
  HEAP32[i11 >> 2] = i10 + 1;
  HEAP8[i10 >> 0] = i2 ? 43 : 45;
  HEAP32[i13 >> 2] = 0;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 } while (0);
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i2 | 0) != 0 ? i6 << 24 >> 24 == i3 << 24 >> 24 : 0) {
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 - i4 | 0) >= 160) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  i10 = HEAP32[i13 >> 2] | 0;
  HEAP32[i5 >> 2] = i1 + 4;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i13 >> 2] = 0;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 i1 = i7 + 26 | 0;
 i2 = i7;
 do {
  if ((HEAP8[i2 >> 0] | 0) == i6 << 24 >> 24) {
   i1 = i2;
   break;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i1 = i1 - i7 | 0;
 if ((i1 | 0) > 23) {
  i10 = -1;
  STACKTOP = i14;
  return i10 | 0;
 }
 if ((i12 | 0) == 10 | (i12 | 0) == 8) {
  if ((i1 | 0) >= (i12 | 0)) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
 } else if ((i12 | 0) == 16 ? (i1 | 0) >= 22 : 0) {
  if (i9) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
  if ((i8 - i10 | 0) >= 3) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
  if ((HEAP8[i8 + -1 >> 0] | 0) != 48) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
  HEAP32[i13 >> 2] = 0;
  i10 = HEAP8[959240 + i1 >> 0] | 0;
  HEAP32[i11 >> 2] = i8 + 1;
  HEAP8[i8 >> 0] = i10;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 i10 = HEAP8[959240 + i1 >> 0] | 0;
 HEAP32[i11 >> 2] = i8 + 1;
 HEAP8[i8 >> 0] = i10;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 i10 = 0;
 STACKTOP = i14;
 return i10 | 0;
}

function __ZN2cvL12copyMask8uC3EPKhjS1_jPhjNS_5Size_IiEEPv(i5, i14, i3, i13, i4, i12, i2, i1) {
 i5 = i5 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i11 = STACKTOP;
 i10 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = i10 & -4;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i2 = 0; else {
   i1 = 0;
   do {
    if (HEAP8[i3 + i1 >> 0] | 0) {
     i2 = i4 + (i1 * 3 | 0) | 0;
     i15 = i5 + (i1 * 3 | 0) | 0;
     HEAP8[i2 + 0 >> 0] = HEAP8[i15 + 0 >> 0] | 0;
     HEAP8[i2 + 1 >> 0] = HEAP8[i15 + 1 >> 0] | 0;
     HEAP8[i2 + 2 >> 0] = HEAP8[i15 + 2 >> 0] | 0;
    }
    i2 = i1 | 1;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 * 3 | 0) | 0;
     i2 = i5 + (i2 * 3 | 0) | 0;
     HEAP8[i15 + 0 >> 0] = HEAP8[i2 + 0 >> 0] | 0;
     HEAP8[i15 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
     HEAP8[i15 + 2 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
    }
    i2 = i1 | 2;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 * 3 | 0) | 0;
     i2 = i5 + (i2 * 3 | 0) | 0;
     HEAP8[i15 + 0 >> 0] = HEAP8[i2 + 0 >> 0] | 0;
     HEAP8[i15 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
     HEAP8[i15 + 2 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
    }
    i2 = i1 | 3;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 * 3 | 0) | 0;
     i2 = i5 + (i2 * 3 | 0) | 0;
     HEAP8[i15 + 0 >> 0] = HEAP8[i2 + 0 >> 0] | 0;
     HEAP8[i15 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
     HEAP8[i15 + 2 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i7 | 0));
   i2 = i9;
  }
  if ((i2 | 0) < (i10 | 0)) do {
   if (HEAP8[i3 + i2 >> 0] | 0) {
    i1 = i4 + (i2 * 3 | 0) | 0;
    i15 = i5 + (i2 * 3 | 0) | 0;
    HEAP8[i1 + 0 >> 0] = HEAP8[i15 + 0 >> 0] | 0;
    HEAP8[i1 + 1 >> 0] = HEAP8[i15 + 1 >> 0] | 0;
    HEAP8[i1 + 2 >> 0] = HEAP8[i15 + 2 >> 0] | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
  if (!i6) break; else {
   i3 = i3 + i13 | 0;
   i4 = i4 + i12 | 0;
   i5 = i5 + i14 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __tr_stored_block(i7, i1, i2, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 i8 = i7 + 5820 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i3 & 65535;
 i6 = i7 + 5816 | 0;
 i3 = HEAPU16[i6 >> 1] | 0 | i4 << i5;
 HEAP16[i6 >> 1] = i3;
 if ((i5 | 0) > 13) {
  i11 = i7 + 20 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  HEAP32[i11 >> 2] = i5 + 1;
  i10 = i7 + 8 | 0;
  HEAP8[(HEAP32[i10 >> 2] | 0) + i5 >> 0] = i3;
  i3 = (HEAPU16[i6 >> 1] | 0) >>> 8 & 255;
  i5 = HEAP32[i11 >> 2] | 0;
  HEAP32[i11 >> 2] = i5 + 1;
  HEAP8[(HEAP32[i10 >> 2] | 0) + i5 >> 0] = i3;
  i5 = HEAP32[i8 >> 2] | 0;
  i3 = i4 >>> (16 - i5 | 0);
  HEAP16[i6 >> 1] = i3;
  i5 = i5 + -13 | 0;
 } else i5 = i5 + 3 | 0;
 i3 = i3 & 255;
 HEAP32[i8 >> 2] = i5;
 do if ((i5 | 0) <= 8) {
  i4 = i7 + 20 | 0;
  if ((i5 | 0) > 0) {
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i5 + 1;
   i10 = i7 + 8 | 0;
   HEAP8[(HEAP32[i10 >> 2] | 0) + i5 >> 0] = i3;
   i3 = i10;
   break;
  } else {
   i3 = i7 + 8 | 0;
   break;
  }
 } else {
  i4 = i7 + 20 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i5 + 1;
  i10 = i7 + 8 | 0;
  HEAP8[(HEAP32[i10 >> 2] | 0) + i5 >> 0] = i3;
  i7 = (HEAPU16[i6 >> 1] | 0) >>> 8 & 255;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i3 + 1;
  HEAP8[(HEAP32[i10 >> 2] | 0) + i3 >> 0] = i7;
  i3 = i10;
 } while (0);
 HEAP16[i6 >> 1] = 0;
 HEAP32[i8 >> 2] = 0;
 i8 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i8 + 1;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i8 >> 0] = i2;
 i8 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i8 + 1;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i8 >> 0] = i2 >>> 8;
 i8 = i2 & 65535 ^ 65535;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i10 + 1;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i10 >> 0] = i8;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i10 + 1;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i10 >> 0] = i8 >>> 8;
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 while (1) {
  i2 = i2 + -1 | 0;
  i8 = HEAP8[i1 >> 0] | 0;
  i10 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i10 + 1;
  HEAP8[(HEAP32[i3 >> 2] | 0) + i10 >> 0] = i8;
  if (!i2) break; else i1 = i1 + 1 | 0;
 }
 STACKTOP = i9;
 return;
}

function __ZN2cvL13randnScale_8uEPKfPhiiS1_S1_b(i9, i7, i14, i11, i12, i13, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i15 = 0;
 i15 = STACKTOP;
 if (i1) {
  if ((i14 | 0) <= 0) {
   STACKTOP = i15;
   return;
  }
  i10 = (i11 | 0) > 0;
  i8 = 0;
  while (1) {
   if (i10) {
    i1 = 0;
    do {
     i6 = Math_imul(i1, i11) | 0;
     i5 = 0;
     f4 = Math_fround(HEAPF32[i12 + (i1 << 2) >> 2]);
     do {
      f2 = Math_fround(HEAPF32[i9 + (i5 << 2) >> 2]);
      f4 = Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i13 + (i5 + i6 << 2) >> 2])));
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i11 | 0));
     i3 = _lrint(+f4) | 0;
     if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
     HEAP8[i7 + i1 >> 0] = i3;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i11 | 0));
   }
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i14 | 0)) break; else {
    i9 = i9 + (i11 << 2) | 0;
    i7 = i7 + i11 | 0;
   }
  }
  STACKTOP = i15;
  return;
 }
 if ((i11 | 0) == 1) {
  f4 = Math_fround(HEAPF32[i12 >> 2]);
  f2 = Math_fround(HEAPF32[i13 >> 2]);
  if ((i14 | 0) > 0) i3 = 0; else {
   STACKTOP = i15;
   return;
  }
  do {
   i1 = _lrint(+Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i9 + (i3 << 2) >> 2])))) | 0;
   if (i1 >>> 0 >= 256) i1 = (i1 | 0) > 0 ? 255 : 0;
   HEAP8[i7 + i3 >> 0] = i1;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i14 | 0));
  STACKTOP = i15;
  return;
 }
 if ((i14 | 0) <= 0) {
  STACKTOP = i15;
  return;
 }
 i8 = (i11 | 0) > 0;
 i1 = i9;
 i5 = 0;
 while (1) {
  if (i8) {
   i6 = 0;
   do {
    f2 = Math_fround(HEAPF32[i1 + (i6 << 2) >> 2]);
    f2 = Math_fround(f2 * Math_fround(HEAPF32[i13 + (i6 << 2) >> 2]));
    i3 = _lrint(+Math_fround(f2 + Math_fround(HEAPF32[i12 + (i6 << 2) >> 2]))) | 0;
    if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i6 >> 0] = i3;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i11 | 0));
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == (i14 | 0)) break; else {
   i7 = i7 + i11 | 0;
   i1 = i1 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN7testing15AssertionResultlsINS_7MessageEEERS0_RKT_(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i10 + 16 | 0;
 i6 = i10 + 4 | 0;
 i7 = i10;
 __ZN7testing7MessageC2Ev(i7);
 i8 = HEAP32[i7 >> 2] | 0;
 __ZNK7testing7Message9GetStringEv(i5, i1);
 i2 = HEAP8[i5 >> 0] | 0;
 if (!(i2 & 1)) {
  i3 = i5 + 1 | 0;
  i1 = (i2 & 255) >>> 1;
 } else {
  i3 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i8 + 8 | 0, i3, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 i1 = i9 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __Znwj(12) | 0;
  HEAP32[i2 + 0 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i2;
 }
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i5, i8 + 12 | 0);
 i3 = HEAP8[i5 >> 0] | 0;
 if (!(i3 & 1)) {
  i1 = i5 + 1 | 0;
  i3 = (i3 & 255) >>> 1;
 } else {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i3 = HEAP32[i5 + 4 >> 2] | 0;
 }
 i4 = i1 + i3 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i6, i3 << 1);
 if (i3) do {
  i3 = HEAP8[i1 >> 0] | 0;
  if (!(i3 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i6, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i6, i3);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 if (!(HEAP8[i6 >> 0] & 1)) i1 = i6 + 1 | 0; else i1 = HEAP32[i6 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i2, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 if (!i8) {
  STACKTOP = i10;
  return i9 | 0;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] & 511](i8);
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN2cv17checkIntegerRangeILi4EEEbNS_3MatERNS_6Point_IiEEiiRd(i12, i8, i11, i10, i15) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i16 = i17;
 if ((i10 | 0) < (i11 | 0)) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i11 = 0;
  STACKTOP = i17;
  return i11 | 0;
 }
 __ZNK2cv3Mat7reshapeEii(i16, i12, 1, 0);
 i1 = HEAP32[i16 + 8 >> 2] | 0;
 L5 : do if ((i1 | 0) > 0) {
  i6 = HEAP32[i16 + 12 >> 2] | 0;
  i7 = (i6 | 0) > 0;
  i14 = HEAP32[i16 + 16 >> 2] | 0;
  i13 = HEAP32[i16 + 44 >> 2] | 0;
  i4 = 0;
  L7 : while (1) {
   if (i7) {
    i5 = i14 + (Math_imul(HEAP32[i13 >> 2] | 0, i4) | 0) | 0;
    i9 = 0;
    while (1) {
     i18 = HEAP32[i5 + (i9 << 2) >> 2] | 0;
     i2 = i9 + 1 | 0;
     if ((i18 | 0) < (i11 | 0) | (i18 | 0) > (i10 | 0)) break L7;
     if ((i2 | 0) < (i6 | 0)) i9 = i2; else break;
    }
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i1 | 0)) {
    i5 = 1;
    d3 = 0.0;
    break L5;
   }
  }
  HEAP32[i8 + 4 >> 2] = i4;
  HEAP32[i8 >> 2] = (i9 | 0) % (((HEAP32[i12 >> 2] | 0) >>> 3 & 511) + 1 | 0) | 0;
  i5 = 0;
  d3 = +(HEAP32[i14 + (Math_imul(HEAP32[i13 >> 2] | 0, i4) | 0) + (i9 << 2) >> 2] | 0);
 } else {
  i5 = 1;
  d3 = 0.0;
 } while (0);
 HEAPF64[i15 >> 3] = d3;
 i1 = i16 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i10 = i2 + 12 | 0, i11 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i11 + -1, (i11 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i16);
 HEAP32[i1 >> 2] = 0;
 i11 = i16 + 16 | 0;
 i2 = i16 + 4 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i16 + 40 >> 2] | 0;
  i4 = 0;
  do {
   HEAP32[i1 + (i4 << 2) >> 2] = 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i16 + 44 >> 2] | 0;
 if ((i1 | 0) == (i16 + 48 | 0)) {
  i11 = i5;
  STACKTOP = i17;
  return i11 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 i11 = i5;
 STACKTOP = i17;
 return i11 | 0;
}

function __ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8Iterator6EqualsERKNS0_22ParamIteratorInterfaceIS3_EE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5 + 4 | 0;
 i2 = i5;
 i6 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] & 127](i4) | 0;
 if (!(__ZN7testing8internal6IsTrueEb((i6 | 0) == (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 127](i3) | 0)) | 0)) {
  __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i2, 3, 696, 10377);
  i6 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 1328, 59) | 0, 1392, 43) | 0, 1440, 26) | 0;
  __ZNKSt3__18ios_base6getlocEv(i1, i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960728) | 0;
  i7 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] & 127](i7, 10) | 0;
  __ZNSt3__16localeD2Ev(i1);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i6, i7) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i6) | 0;
  __ZN7testing8internal8GTestLogD2Ev(i2);
 }
 if (__ZN7testing8internal6IsTrueEb((HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + -4 >> 2] | 0) + 4 >> 2] | 0) == 1160) | 0) {
  i1 = ___dynamic_cast(i3, 1304, 1312, 0) | 0;
  i1 = i1 + 8 | 0;
  i2 = i4 + 8 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = (i2 | 0) == (i1 | 0);
  STACKTOP = i5;
  return i1 | 0;
 }
 __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i1, 3, 696, 2305);
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 1472, 51) | 0;
 __ZN7testing8internal8GTestLogD2Ev(i1);
 i1 = ___dynamic_cast(i3, 1304, 1312, 0) | 0;
 i1 = i1 + 8 | 0;
 i2 = i4 + 8 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i1 = (i2 | 0) == (i1 | 0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt3__19__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i6, i12, i10, i11, i13, i3, i1, i4, i5, i7) {
 i6 = i6 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i2 = 0, i8 = 0, i9 = 0, i14 = 0;
 i14 = STACKTOP;
 i8 = HEAP32[i11 >> 2] | 0;
 i9 = (i8 | 0) == (i10 | 0);
 do if (i9) {
  i2 = (HEAP32[i7 + 96 >> 2] | 0) == (i6 | 0);
  if (!i2 ? (HEAP32[i7 + 100 >> 2] | 0) != (i6 | 0) : 0) break;
  HEAP32[i11 >> 2] = i10 + 1;
  HEAP8[i10 >> 0] = i2 ? 43 : 45;
  HEAP32[i13 >> 2] = 0;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 } while (0);
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i2 | 0) != 0 & (i6 | 0) == (i3 | 0)) {
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 - i4 | 0) >= 160) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  i10 = HEAP32[i13 >> 2] | 0;
  HEAP32[i5 >> 2] = i1 + 4;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i13 >> 2] = 0;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 i1 = i7 + 104 | 0;
 i2 = i7;
 do {
  if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) {
   i1 = i2;
   break;
  }
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i1 = i1 - i7 | 0;
 i2 = i1 >> 2;
 if ((i1 | 0) > 92) {
  i10 = -1;
  STACKTOP = i14;
  return i10 | 0;
 }
 if ((i12 | 0) == 10 | (i12 | 0) == 8) {
  if ((i2 | 0) >= (i12 | 0)) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
 } else if ((i12 | 0) == 16 ? (i1 | 0) >= 88 : 0) {
  if (i9) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
  if ((i8 - i10 | 0) >= 3) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
  if ((HEAP8[i8 + -1 >> 0] | 0) != 48) {
   i10 = -1;
   STACKTOP = i14;
   return i10 | 0;
  }
  HEAP32[i13 >> 2] = 0;
  i10 = HEAP8[959240 + i2 >> 0] | 0;
  HEAP32[i11 >> 2] = i8 + 1;
  HEAP8[i8 >> 0] = i10;
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 i10 = HEAP8[959240 + i2 >> 0] | 0;
 HEAP32[i11 >> 2] = i8 + 1;
 HEAP8[i8 >> 0] = i10;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 i10 = 0;
 STACKTOP = i14;
 return i10 | 0;
}

function __ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8Iterator6EqualsERKNS0_22ParamIteratorInterfaceIS4_EE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5 + 4 | 0;
 i2 = i5;
 i6 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] & 127](i4) | 0;
 if (!(__ZN7testing8internal6IsTrueEb((i6 | 0) == (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 127](i3) | 0)) | 0)) {
  __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i2, 3, 696, 10377);
  i6 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 1328, 59) | 0, 1392, 43) | 0, 1440, 26) | 0;
  __ZNKSt3__18ios_base6getlocEv(i1, i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960728) | 0;
  i7 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] & 127](i7, 10) | 0;
  __ZNSt3__16localeD2Ev(i1);
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i6, i7) | 0;
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i6) | 0;
  __ZN7testing8internal8GTestLogD2Ev(i2);
 }
 if (__ZN7testing8internal6IsTrueEb((HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + -4 >> 2] | 0) + 4 >> 2] | 0) == 1752) | 0) {
  i1 = ___dynamic_cast(i3, 1896, 1904, 0) | 0;
  i1 = i1 + 8 | 0;
  i2 = i4 + 8 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = (i2 | 0) == (i1 | 0);
  STACKTOP = i5;
  return i1 | 0;
 }
 __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i1, 3, 696, 2305);
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 1472, 51) | 0;
 __ZN7testing8internal8GTestLogD2Ev(i1);
 i1 = ___dynamic_cast(i3, 1896, 1904, 0) | 0;
 i1 = i1 + 8 | 0;
 i2 = i4 + 8 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i1 = (i2 | 0) == (i1 | 0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt3__17__sort5IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i9, i10, i7, i6, i2, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 i8 = __ZNSt3__17__sort4IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_S7_T_(i9, i10, i7, i6, i1) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if ((i4 | 0) == (i3 | 0)) {
  i10 = i8;
  STACKTOP = i11;
  return i10 | 0;
 }
 if ((_strcmp((i4 | 0) == 0 ? 6176 : i4, (i3 | 0) == 0 ? 6176 : i3) | 0) >= 0) {
  i10 = i8;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i6 >> 2] = i4;
 HEAP32[i2 >> 2] = i3;
 i5 = i6 + 4 | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i3;
 i4 = i8 + 1 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i3 | 0) == (i2 | 0)) {
  i10 = i4;
  STACKTOP = i11;
  return i10 | 0;
 }
 if ((_strcmp((i3 | 0) == 0 ? 6176 : i3, (i2 | 0) == 0 ? 6176 : i2) | 0) >= 0) {
  i10 = i4;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i7 >> 2] = i3;
 HEAP32[i6 >> 2] = i2;
 i1 = i7 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i3;
 i3 = i8 + 2 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i4 | 0) == (i2 | 0)) {
  i10 = i3;
  STACKTOP = i11;
  return i10 | 0;
 }
 if ((_strcmp((i4 | 0) == 0 ? 6176 : i4, (i2 | 0) == 0 ? 6176 : i2) | 0) >= 0) {
  i10 = i3;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i10 >> 2] = i4;
 HEAP32[i7 >> 2] = i2;
 i4 = i10 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 i1 = i8 + 3 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 }
 if ((_strcmp((i2 | 0) == 0 ? 6176 : i2, (i3 | 0) == 0 ? 6176 : i3) | 0) >= 0) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 i9 = i9 + 4 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i10;
 i10 = i8 + 4 | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN2cvL13copyMask32sC3EPKhjS1_jPhjNS_5Size_IiEEPv(i5, i14, i3, i13, i4, i12, i2, i1) {
 i5 = i5 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i11 = STACKTOP;
 i10 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = i10 & -4;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i2 = 0; else {
   i1 = 0;
   do {
    if (HEAP8[i3 + i1 >> 0] | 0) {
     i2 = i4 + (i1 * 12 | 0) | 0;
     i15 = i5 + (i1 * 12 | 0) | 0;
     HEAP32[i2 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    }
    i2 = i1 | 1;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 * 12 | 0) | 0;
     i2 = i5 + (i2 * 12 | 0) | 0;
     HEAP32[i15 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    }
    i2 = i1 | 2;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 * 12 | 0) | 0;
     i2 = i5 + (i2 * 12 | 0) | 0;
     HEAP32[i15 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    }
    i2 = i1 | 3;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i15 = i4 + (i2 * 12 | 0) | 0;
     i2 = i5 + (i2 * 12 | 0) | 0;
     HEAP32[i15 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i7 | 0));
   i2 = i9;
  }
  if ((i2 | 0) < (i10 | 0)) do {
   if (HEAP8[i3 + i2 >> 0] | 0) {
    i1 = i4 + (i2 * 12 | 0) | 0;
    i15 = i5 + (i2 * 12 | 0) | 0;
    HEAP32[i1 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
  if (!i6) break; else {
   i3 = i3 + i13 | 0;
   i4 = i4 + i12 | 0;
   i5 = i5 + i14 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cv4swapERNS_3MatES1_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i3;
 i3 = i5 + 4 | 0;
 i4 = i6 + 4 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i11;
 i4 = i5 + 8 | 0;
 i11 = i6 + 8 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i3;
 i3 = i5 + 12 | 0;
 i2 = i6 + 12 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i7;
 i2 = i5 + 16 | 0;
 i7 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i3;
 i7 = i5 + 20 | 0;
 i3 = i6 + 20 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i2;
 i3 = i5 + 24 | 0;
 i2 = i6 + 24 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i7;
 i2 = i5 + 28 | 0;
 i7 = i6 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i3;
 i7 = i5 + 32 | 0;
 i3 = i6 + 32 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i2;
 i3 = i5 + 36 | 0;
 i2 = i6 + 36 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i7;
 i2 = i5 + 40 | 0;
 i7 = i6 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i3;
 i3 = i5 + 44 | 0;
 i8 = i6 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i9 = i5 + 48 | 0;
 i10 = i6 + 48 | 0;
 i13 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i13;
 i13 = i5 + 52 | 0;
 i6 = i6 + 52 | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i5;
 if ((HEAP32[i3 >> 2] | 0) == (i10 | 0)) {
  HEAP32[i3 >> 2] = i9;
  HEAP32[i2 >> 2] = i4;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) != (i9 | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i8 >> 2] = i10;
 HEAP32[i7 >> 2] = i11;
 STACKTOP = i12;
 return;
}

function __ZNSt3__16vectorIN2cv3VecIiLi4EEENS_9allocatorIS3_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 i9 = i10 + 8 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1;
 if (i4 - i3 >> 4 >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    HEAP32[i1 + 0 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i1 = i1 + 16 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = (i3 - i1 >> 4) + i2 | 0;
 if (i3 >>> 0 > 268435455) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i5 = i1;
 i1 = i4 - i5 | 0;
 if (i1 >> 4 >>> 0 < 134217727) {
  i1 = i1 >> 3;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = (HEAP32[i11 >> 2] | 0) - i5 >> 4;
  if (!i1) {
   i5 = 0;
   i8 = 0;
   i7 = i3;
  } else i6 = 10;
 } else {
  i1 = 268435455;
  i3 = (HEAP32[i11 >> 2] | 0) - i5 >> 4;
  i6 = 10;
 }
 if ((i6 | 0) == 10) {
  i5 = i1;
  i8 = __Znwj(i1 << 4) | 0;
  i7 = i3;
 }
 i1 = i8 + (i7 << 4) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else {
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
  }
  i3 = i3 + 16 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = i8 + (i5 << 4) | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  i4 = i5 + -16 - i2 | 0;
  while (1) {
   i13 = i5;
   i5 = i5 + -16 | 0;
   HEAP32[i1 + -16 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + -12 >> 2] = HEAP32[i13 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i13 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i13 + -4 >> 2];
   if ((i5 | 0) == (i2 | 0)) break; else i1 = i1 + -16 | 0;
  }
  i1 = i8 + (i7 + ~(i4 >>> 4) << 4) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i12;
 return;
}

function __ZN2cvL14cvtScale16u16sEPKtjPKhjPsjNS_5Size_IiEEPd(i7, i5, i1, i2, i8, i6, i3, i4) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 i16 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f15 = Math_fround(+HEAPF64[i4 >> 3]);
 f14 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i13 = i5 >>> 1;
 i9 = i6 >>> 1;
 if (!i3) {
  STACKTOP = i17;
  return;
 }
 i10 = i16 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = (i10 | 0) > 3 ? i16 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPU16[i7 + (i1 << 1) >> 1] | 0 | 0)))) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i4 = i1 | 1;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPU16[i7 + (i4 << 1) >> 1] | 0 | 0)))) | 0;
    if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i1 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i2 = i1 | 2;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPU16[i7 + (i2 << 1) >> 1] | 0 | 0)))) | 0;
    if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
    i4 = i1 | 3;
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPU16[i7 + (i4 << 1) >> 1] | 0 | 0)))) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i2 << 1) >> 1] = i6;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i16 | 0)) do {
   i4 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPU16[i7 + (i5 << 1) >> 1] | 0 | 0)))) | 0;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i16 | 0));
  if (!i3) break; else {
   i7 = i7 + (i13 << 1) | 0;
   i8 = i8 + (i9 << 1) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZN7testing13PrintToStringINSt3tr15tupleIN2cv5Size_IiEEN4perf7MatTypeEvvvvvvvvEEEENSt3__112basic_stringIcNS9_11char_traitsIcEENS9_9allocatorIcEEEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i9 = i3 + 144 | 0;
 i8 = i3;
 i4 = i8 + 64 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i7 >> 2] = 2640;
 i5 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = 2788;
 HEAP32[i4 >> 2] = 2808;
 HEAP32[i8 + 4 >> 2] = 0;
 __ZNSt3__18ios_base4initEPv(i8 + 64 | 0, i5);
 HEAP32[i8 + 136 >> 2] = 0;
 HEAP32[i8 + 140 >> 2] = -1;
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i4 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i5);
 HEAP32[i5 >> 2] = 2952;
 i6 = i8 + 44 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 24;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i5, i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 i9 = i8 + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 3096, 1) | 0;
 __ZN2cv7PrintToERKNS_5Size_IiEEPNSt3__113basic_ostreamIcNS4_11char_traitsIcEEEE(i2, i9);
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 3112, 2) | 0;
 __ZN4perf7PrintToERKNS_7MatTypeEPNSt3__113basic_ostreamIcNS3_11char_traitsIcEEEE(i2 + 8 | 0, i9);
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, 3104, 1) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i1, i5);
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i8 + 64 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 HEAP32[i5 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i5);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZN7testing4Test3RunEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i8 + 24 | 0;
 i2 = i8 + 16 | 0;
 i3 = i8 + 8 | 0;
 i6 = i8;
 if (!(__ZN7testing4Test19HasSameFixtureClassEv() | 0)) {
  STACKTOP = i8;
  return;
 }
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i1 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i1, 163728);
  HEAP32[40934] = i1;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i4 = (HEAP32[40934] | 0) + 164 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(12) | 0;
  HEAP32[i1 >> 2] = 165008;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i1;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 511](i1);
 HEAP32[i2 >> 2] = 8;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i5 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN7testing8internal35HandleExceptionsInMethodIfSupportedINS_4TestEvEET0_PT_MS4_FS3_vEPKc(i7, i5, 161504);
 if (!(__ZN7testing4Test15HasFatalFailureEv() | 0)) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   i1 = __Znwj(12) | 0;
   HEAP32[i1 >> 2] = 165008;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i4 >> 2] = i1;
  }
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 511](i1);
  HEAP32[i3 >> 2] = 16;
  HEAP32[i3 + 4 >> 2] = 1;
  HEAP32[i5 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN7testing8internal35HandleExceptionsInMethodIfSupportedINS_4TestEvEET0_PT_MS4_FS3_vEPKc(i7, i5, 161512);
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(12) | 0;
  HEAP32[i1 >> 2] = 165008;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i1;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 511](i1);
 HEAP32[i6 >> 2] = 12;
 HEAP32[i6 + 4 >> 2] = 1;
 HEAP32[i5 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7testing8internal35HandleExceptionsInMethodIfSupportedINS_4TestEvEET0_PT_MS4_FS3_vEPKc(i7, i5, 161528);
 STACKTOP = i8;
 return;
}

function __ZN2cv7MatExprD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 i1 = i4 + 120 | 0;
 i2 = i4 + 156 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i1);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 136 | 0;
 i3 = i4 + 124 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 160 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 164 >> 2] | 0;
 if ((i1 | 0) != (i4 + 168 | 0)) __ZN2cv8fastFreeEPv(i1);
 i3 = i4 + 64 | 0;
 i2 = i4 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i1 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 80 | 0;
 i3 = i4 + 68 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 104 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 108 >> 2] | 0;
 if ((i1 | 0) != (i4 + 112 | 0)) __ZN2cv8fastFreeEPv(i1);
 i3 = i4 + 8 | 0;
 i2 = i4 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i1 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 24 | 0;
 i3 = i4 + 12 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 48 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 if ((i1 | 0) == (i4 + 56 | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i5;
 return;
}

function __ZN7testing8internal37FormatCompilerIndependentFileLocationEPKci(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i4 = i9 + 36 | 0;
 i8 = i9 + 24 | 0;
 i5 = i9 + 12 | 0;
 i6 = i9;
 HEAP32[i4 >> 2] = i1;
 i2 = (i2 | 0) == 0 ? 164688 : i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i2, _strlen(i2 | 0) | 0);
 if ((i1 | 0) < 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i7, i8);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
  STACKTOP = i9;
  return;
 };
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = HEAP8[i8 >> 0] | 0;
 if (!(i1 & 1)) {
  i1 = (i1 & 255) >>> 1;
  i2 = i8 + 1 | 0;
 } else {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = HEAP32[i8 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, i2, i1, i1 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, 163080, 1) | 0;
 __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i6, i4);
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i3 = (i1 & 1) == 0;
 if (i3) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 if (!(i2 & 1)) i4 = (i2 & 255) >>> 1; else i4 = HEAP32[i6 + 4 >> 2] | 0;
 if (i3) i2 = i5 + 1 | 0; else i2 = HEAP32[i5 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i7, i2, i1, i4 + i1 | 0);
 if (!(HEAP8[i6 >> 0] & 1)) i1 = i6 + 1 | 0; else i1 = HEAP32[i6 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i1, i4) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
 STACKTOP = i9;
 return;
}

function __ZN4perf8TestBase9stopTimerEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i10 + 4 | 0;
 i2 = i10;
 i6 = __ZN2cv12getTickCountEv() | 0;
 i7 = tempRet0;
 i8 = i9 + 48 | 0;
 i1 = i8;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i4 | 0) == 0 & (i1 | 0) == 0) {
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i3, 1, 170184, 1278, 171216);
  __ZN7testing7MessageC2Ev(i2);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i2 >> 2] | 0) + 8 | 0, 174416, 50) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i3, i2);
  if (HEAP32[i2 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i5 = HEAP32[i2 >> 2] | 0, (i5 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 511](i5);
   HEAP32[i2 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i3);
  i1 = i8;
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i3 = _i64Subtract(i6 | 0, i7 | 0, i4 | 0, i1 | 0) | 0;
 i2 = tempRet0;
 i1 = i8;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i9 + 56 | 0;
 i4 = i1;
 i4 = _i64Add(HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, i3 | 0, i2 | 0) | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = tempRet0;
 i1 = 169640;
 i1 = _i64Subtract(i3 | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0;
 i2 = tempRet0;
 i3 = (i2 | 0) < 0;
 i1 = i3 ? 0 : i1;
 i2 = i3 ? 0 : i2;
 i3 = i8;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = i9 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i9 + 44 >> 2] | 0)) {
  __ZNSt3__16vectorIxNS_9allocatorIxEEE21__push_back_slow_pathIKxEEvRT_(i9 + 36 | 0, i8);
  i1 = i8;
  i2 = i1;
  HEAP32[i2 >> 2] = 0;
  i1 = i1 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i10;
  return;
 }
 if (i4) {
  i5 = i4;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 4 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i4 + 8;
 i1 = i8;
 i2 = i1;
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZNSt3__16vectorIN2cv3VecIiLi32EEENS_9allocatorIS3_EEE8__appendEj(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 i10 = i11 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = i1;
 if (i4 - i3 >> 7 >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    i5 = i1 + 0 | 0;
    i4 = i5 + 128 | 0;
    do {
     HEAP32[i5 >> 2] = 0;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) < (i4 | 0));
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i1 = i1 + 128 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = (i3 - i1 >> 7) + i2 | 0;
 if (i3 >>> 0 > 33554431) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i5 = i1;
 i1 = i4 - i5 | 0;
 if (i1 >> 7 >>> 0 < 16777215) {
  i1 = i1 >> 6;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = (HEAP32[i12 >> 2] | 0) - i5 >> 7;
  if (!i1) {
   i7 = 0;
   i9 = 0;
   i8 = i3;
  } else i6 = 10;
 } else {
  i1 = 33554431;
  i3 = (HEAP32[i12 >> 2] | 0) - i5 >> 7;
  i6 = 10;
 }
 if ((i6 | 0) == 10) {
  i7 = i1;
  i9 = __Znwj(i1 << 7) | 0;
  i8 = i3;
 }
 i1 = i9 + (i8 << 7) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else {
   i5 = i3 + 0 | 0;
   i4 = i5 + 128 | 0;
   do {
    HEAP32[i5 >> 2] = 0;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) < (i4 | 0));
  }
  i3 = i3 + 128 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i7 = i9 + (i7 << 7) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  i6 = i5 + -128 - i2 | 0;
  while (1) {
   i4 = 0;
   do {
    HEAP32[i1 + (i4 << 2) + -128 >> 2] = HEAP32[i5 + (i4 << 2) + -128 >> 2];
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != 32);
   i5 = i5 + -128 | 0;
   if ((i5 | 0) == (i2 | 0)) break; else i1 = i1 + -128 | 0;
  }
  i1 = i9 + (i8 + ~(i6 >>> 7) << 7) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i3;
 HEAP32[i10 >> 2] = i7;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i13;
 return;
}

function __GLOBAL__I_a1405() {
 var i1 = 0;
 i1 = STACKTOP;
 __ZN2cv3ocl13ProgramSourceC2EPKc(61376, 49704);
 ___cxa_atexit(363, 61376, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(62336, 61384);
 ___cxa_atexit(363, 62336, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(64792, 62344);
 ___cxa_atexit(363, 64792, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(67176, 64800);
 ___cxa_atexit(363, 67176, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(89280, 67184);
 ___cxa_atexit(363, 89280, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(92800, 89288);
 ___cxa_atexit(363, 92800, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(95144, 92808);
 ___cxa_atexit(363, 95144, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(97656, 95152);
 ___cxa_atexit(363, 97656, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(101040, 97664);
 ___cxa_atexit(363, 101040, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(104048, 101048);
 ___cxa_atexit(363, 104048, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(111584, 104056);
 ___cxa_atexit(363, 111584, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(112592, 111592);
 ___cxa_atexit(363, 112592, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(113824, 112600);
 ___cxa_atexit(363, 113824, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(115504, 113832);
 ___cxa_atexit(363, 115504, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(131968, 115512);
 ___cxa_atexit(363, 131968, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(136424, 131976);
 ___cxa_atexit(363, 136424, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(137584, 136432);
 ___cxa_atexit(363, 137584, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(138896, 137592);
 ___cxa_atexit(363, 138896, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(140832, 138904);
 ___cxa_atexit(363, 140832, ___dso_handle | 0) | 0;
 __ZN2cv3ocl13ProgramSourceC2EPKc(143296, 140840);
 ___cxa_atexit(363, 143296, ___dso_handle | 0) | 0;
 STACKTOP = i1;
 return;
}

function __ZN2cvL14cvtScale32s16sEPKijPKhjPsjNS_5Size_IiEEPd(i7, i5, i1, i2, i8, i6, i3, i4) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 i16 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f15 = Math_fround(+HEAPF64[i4 >> 3]);
 f14 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i13 = i5 >>> 2;
 i9 = i6 >>> 1;
 if (!i3) {
  STACKTOP = i17;
  return;
 }
 i10 = i16 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = (i10 | 0) > 3 ? i16 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP32[i7 + (i1 << 2) >> 2] | 0)))) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i4 = i1 | 1;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP32[i7 + (i4 << 2) >> 2] | 0)))) | 0;
    if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i1 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i2 = i1 | 2;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP32[i7 + (i2 << 2) >> 2] | 0)))) | 0;
    if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
    i4 = i1 | 3;
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP32[i7 + (i4 << 2) >> 2] | 0)))) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i2 << 1) >> 1] = i6;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i16 | 0)) do {
   i4 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP32[i7 + (i5 << 2) >> 2] | 0)))) | 0;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i16 | 0));
  if (!i3) break; else {
   i7 = i7 + (i13 << 2) | 0;
   i8 = i8 + (i9 << 1) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function _cvGetHashedKey(i1, i11, i2, i7) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i12 + 8 | 0;
 i10 = i12;
 if (!i1) {
  i10 = 0;
  STACKTOP = i12;
  return i10 | 0;
 }
 i8 = HEAP32[i1 + 28 >> 2] | 0;
 if ((i2 | 0) < 0) {
  i1 = HEAP8[i11 >> 0] | 0;
  if (!(i1 << 24 >> 24)) {
   i2 = 0;
   i1 = 0;
  } else {
   i3 = 0;
   i2 = 0;
   do {
    i3 = (i1 & 255) + (i3 * 33 | 0) | 0;
    i2 = i2 + 1 | 0;
    i1 = HEAP8[i11 + i2 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i3;
  }
 } else if ((i2 | 0) > 0) {
  i1 = 0;
  i3 = 0;
  do {
   i1 = (HEAPU8[i11 + i3 >> 0] | 0) + (i1 * 33 | 0) | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i2 | 0));
 } else {
  i2 = 0;
  i1 = 0;
 }
 i6 = i1 & 2147483647;
 i1 = HEAP32[i8 + 64 >> 2] | 0;
 i3 = i1 + -1 | 0;
 if (!(i3 & i1)) i5 = i3 & i6; else i5 = (i6 >>> 0) % (i1 >>> 0) | 0;
 i4 = i8 + 68 | 0;
 i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i5 << 2) >> 2] | 0;
 L16 : do if (i1) {
  while (1) {
   if (((HEAP32[i1 >> 2] | 0) == (i6 | 0) ? (HEAP32[i1 + 4 >> 2] | 0) == (i2 | 0) : 0) ? (_memcmp(HEAP32[i1 + 8 >> 2] | 0, i11, i2) | 0) == 0 : 0) break;
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    break L16;
   }
  }
  STACKTOP = i12;
  return i1 | 0;
 } while (0);
 if (!i7) {
  i10 = i1;
  STACKTOP = i12;
  return i10 | 0;
 }
 i3 = i8 + 56 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 if (!i1) {
  _cvSetAdd(i8, 0, i9) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 67108863;
  i9 = i8 + 60 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 HEAP32[i1 >> 2] = i6;
 _cvMemStorageAllocString(i10, HEAP32[i8 + 44 >> 2] | 0, i11, i2);
 i8 = i10;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i1 + 4 | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 i10 = (HEAP32[i4 >> 2] | 0) + (i5 << 2) | 0;
 HEAP32[i1 + 12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i1;
 i10 = i1;
 STACKTOP = i12;
 return i10 | 0;
}

function __ZNSt3__16vectorIN2cv3VecIiLi3EEENS_9allocatorIS3_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 i9 = i10 + 8 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1;
 if (((i4 - i3 | 0) / 12 | 0) >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    HEAP32[i1 + 0 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i1 = i1 + 12 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((i3 - i1 | 0) / 12 | 0) + i2 | 0;
 if (i3 >>> 0 > 357913941) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i5 = i1;
 i1 = (i4 - i5 | 0) / 12 | 0;
 if (i1 >>> 0 < 178956970) {
  i1 = i1 << 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = ((HEAP32[i11 >> 2] | 0) - i5 | 0) / 12 | 0;
  if (!i1) {
   i5 = 0;
   i8 = 0;
   i7 = i3;
  } else i6 = 10;
 } else {
  i1 = 357913941;
  i3 = ((HEAP32[i11 >> 2] | 0) - i5 | 0) / 12 | 0;
  i6 = 10;
 }
 if ((i6 | 0) == 10) {
  i5 = i1;
  i8 = __Znwj(i1 * 12 | 0) | 0;
  i7 = i3;
 }
 i1 = i8 + (i7 * 12 | 0) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else {
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
  }
  i3 = i3 + 12 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = i8 + (i5 * 12 | 0) | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  i4 = i5 + -12 - i2 | 0;
  while (1) {
   i13 = i5;
   i5 = i5 + -12 | 0;
   HEAP32[i1 + -12 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i13 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i13 + -4 >> 2];
   if ((i5 | 0) == (i2 | 0)) break; else i1 = i1 + -12 | 0;
  }
  i1 = i8 + ((i7 + ~((i4 >>> 0) / 12 | 0) | 0) * 12 | 0) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i12;
 return;
}

function __ZNSt3__16vectorIN2cv3VecIsLi3EEENS_9allocatorIS3_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 i9 = i10 + 8 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1;
 if (((i4 - i3 | 0) / 6 | 0) >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    HEAP16[i1 + 0 >> 1] = 0;
    HEAP16[i1 + 2 >> 1] = 0;
    HEAP16[i1 + 4 >> 1] = 0;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i1 = i1 + 6 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((i3 - i1 | 0) / 6 | 0) + i2 | 0;
 if (i3 >>> 0 > 715827882) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i5 = i1;
 i1 = (i4 - i5 | 0) / 6 | 0;
 if (i1 >>> 0 < 357913941) {
  i1 = i1 << 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = ((HEAP32[i11 >> 2] | 0) - i5 | 0) / 6 | 0;
  if (!i1) {
   i5 = 0;
   i8 = 0;
   i7 = i3;
  } else i6 = 10;
 } else {
  i1 = 715827882;
  i3 = ((HEAP32[i11 >> 2] | 0) - i5 | 0) / 6 | 0;
  i6 = 10;
 }
 if ((i6 | 0) == 10) {
  i5 = i1;
  i8 = __Znwj(i1 * 6 | 0) | 0;
  i7 = i3;
 }
 i1 = i8 + (i7 * 6 | 0) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else {
   HEAP16[i3 + 0 >> 1] = 0;
   HEAP16[i3 + 2 >> 1] = 0;
   HEAP16[i3 + 4 >> 1] = 0;
  }
  i3 = i3 + 6 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = i8 + (i5 * 6 | 0) | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  i4 = i5 + -6 - i2 | 0;
  while (1) {
   i13 = i5;
   i5 = i5 + -6 | 0;
   HEAP16[i1 + -6 >> 1] = HEAP16[i5 >> 1] | 0;
   HEAP16[i1 + -4 >> 1] = HEAP16[i13 + -4 >> 1] | 0;
   HEAP16[i1 + -2 >> 1] = HEAP16[i13 + -2 >> 1] | 0;
   if ((i5 | 0) == (i2 | 0)) break; else i1 = i1 + -6 | 0;
  }
  i1 = i8 + ((i7 + ~((i4 >>> 0) / 6 | 0) | 0) * 6 | 0) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i12;
 return;
}

function _cvStartReadRawData(i2, i9, i8) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i10 + 16 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10;
 i1 = (i2 | 0) != 0;
 if (!(i1 ? (HEAP32[i2 >> 2] | 0) == 1280131417 : 0)) {
  i2 = i1 ? -5 : -27;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i5, 31) | 0) + 0 | 0;
  i3 = 9096 | 0;
  i4 = i1 + 31 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i2, i5, 10128, 8960, 3175);
  __ZN2cv6String10deallocateEv(i5);
 }
 if (!((i9 | 0) != 0 & (i8 | 0) != 0)) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i6, 42) | 0) + 0 | 0;
  i3 = 10152 | 0;
  i4 = i1 + 42 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i6, 10128, 8960, 3178);
  __ZN2cv6String10deallocateEv(i6);
 }
 i1 = HEAP32[i9 >> 2] & 7;
 if ((i1 + -1 | 0) >>> 0 < 2) {
  HEAP32[i8 + 12 >> 2] = i9;
  HEAP32[i8 + 20 >> 2] = i9 + 32;
  HEAP32[i8 + 16 >> 2] = i9;
  HEAP32[i8 + 4 >> 2] = 0;
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) == 5) {
  _cvStartReadSeq(HEAP32[i9 + 8 >> 2] | 0, i8, 0);
  STACKTOP = i10;
  return;
 } else if (!i1) {
  HEAP32[i8 + 0 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i8 + 20 >> 2] = 0;
  HEAP32[i8 + 24 >> 2] = 0;
  HEAP32[i8 + 28 >> 2] = 0;
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i7, 56) | 0) + 0 | 0;
  i3 = 10200 | 0;
  i4 = i1 + 56 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i7, 10128, 8960, 3198);
  __ZN2cv6String10deallocateEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN2cvL14cvtScale32f16sEPKfjPKhjPsjNS_5Size_IiEEPd(i7, i5, i1, i2, i8, i6, i3, i4) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 i16 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f15 = Math_fround(+HEAPF64[i4 >> 3]);
 f14 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i13 = i5 >>> 2;
 i9 = i6 >>> 1;
 if (!i3) {
  STACKTOP = i17;
  return;
 }
 i10 = i16 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = (i10 | 0) > 3 ? i16 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i7 + (i1 << 2) >> 2])))) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i4 = i1 | 1;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i7 + (i4 << 2) >> 2])))) | 0;
    if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i1 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i2 = i1 | 2;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i7 + (i2 << 2) >> 2])))) | 0;
    if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
    i4 = i1 | 3;
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i7 + (i4 << 2) >> 2])))) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i2 << 1) >> 1] = i6;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i16 | 0)) do {
   i4 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i7 + (i5 << 2) >> 2])))) | 0;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i16 | 0));
  if (!i3) break; else {
   i7 = i7 + (i13 << 2) | 0;
   i8 = i8 + (i9 << 1) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZNSt3__16vectorIN2cv3VecIhLi3EEENS_9allocatorIS3_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 i9 = i10 + 8 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1;
 if (((i4 - i3 | 0) / 3 | 0) >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    HEAP8[i1 + 0 >> 0] = 0;
    HEAP8[i1 + 1 >> 0] = 0;
    HEAP8[i1 + 2 >> 0] = 0;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i1 = i1 + 3 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((i3 - i1 | 0) / 3 | 0) + i2 | 0;
 if (i3 >>> 0 > 1431655765) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i5 = i1;
 i1 = (i4 - i5 | 0) / 3 | 0;
 if (i1 >>> 0 < 715827882) {
  i1 = i1 << 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = ((HEAP32[i11 >> 2] | 0) - i5 | 0) / 3 | 0;
  if (!i1) {
   i5 = 0;
   i8 = 0;
   i6 = i3;
  } else i7 = 10;
 } else {
  i1 = 1431655765;
  i3 = ((HEAP32[i11 >> 2] | 0) - i5 | 0) / 3 | 0;
  i7 = 10;
 }
 if ((i7 | 0) == 10) {
  i5 = i1;
  i8 = __Znwj(i1 * 3 | 0) | 0;
  i6 = i3;
 }
 i1 = i8 + (i6 * 3 | 0) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else {
   HEAP8[i3 + 0 >> 0] = 0;
   HEAP8[i3 + 1 >> 0] = 0;
   HEAP8[i3 + 2 >> 0] = 0;
  }
  i3 = i3 + 3 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i7 = i8 + (i5 * 3 | 0) | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if ((i4 | 0) != (i2 | 0)) {
  i5 = i6 + -1 - (((i4 + (0 - i2) + -3 | 0) >>> 0) / 3 | 0) | 0;
  while (1) {
   i6 = i4;
   i4 = i4 + -3 | 0;
   HEAP8[i1 + -3 >> 0] = HEAP8[i4 >> 0] | 0;
   HEAP8[i1 + -2 >> 0] = HEAP8[i6 + -2 >> 0] | 0;
   HEAP8[i1 + -1 >> 0] = HEAP8[i6 + -1 >> 0] | 0;
   if ((i4 | 0) == (i2 | 0)) break; else i1 = i1 + -3 | 0;
  }
  i1 = i8 + (i5 * 3 | 0) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i9 >> 2] = i7;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i12;
 return;
}

function __ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8IteratorC2ERKS8_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 HEAP32[i2 >> 2] = 2160;
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i2 + 8 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] & 127](i6) | 0;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 i10 = i2 + 12 | 0;
 HEAP32[i10 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] & 127](i6) | 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i8 = i2 + 16 | 0;
 HEAP32[i8 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] & 127](i6) | 0;
 i6 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i2 + 20 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] & 127](i6) | 0;
 i6 = HEAP32[i1 + 24 >> 2] | 0;
 i4 = i2 + 24 | 0;
 HEAP32[i4 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] & 127](i6) | 0;
 i6 = HEAP32[i1 + 28 >> 2] | 0;
 i5 = i2 + 28 | 0;
 HEAP32[i5 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] & 127](i6) | 0;
 i6 = i2 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i2 + 36 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i2 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i9;
  return;
 }
 if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1) | 0) {
  STACKTOP = i9;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i9;
  return;
 }
 if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1) | 0) {
  STACKTOP = i9;
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] & 127](i4) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i1) | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 STACKTOP = i9;
 return;
}

function ___cxx_global_array_dtor1954(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965820 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965808 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965796 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965784 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965772 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965760 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965748 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965736 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965724 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965712 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965700 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965688 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965676 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965664 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965652 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965640 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965628 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965616 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965604 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965592 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965580 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965568 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965556 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(965544);
 STACKTOP = i1;
 return;
}

function __ZL12icvWriteHistP13CvFileStoragePKcPKv10CvAttrList(i12, i2, i9, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 i6 = i11 + 160 | 0;
 i10 = i11 + 32 | 0;
 i13 = i11 + 24 | 0;
 i4 = i11 + 16 | 0;
 i5 = i11 + 8 | 0;
 i7 = i11;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i6 + 0 >> 2] = HEAP32[i13 + 0 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 _cvStartWriteStruct(i12, i2, 6, 702040, i6);
 i13 = HEAP32[i9 >> 2] | 0;
 i3 = i13 & 1024;
 i8 = (i3 | 0) == 0;
 i1 = i13 & 2048;
 i2 = (i1 | 0) == 0;
 _cvWriteInt(i12, 702056, i13 & 1);
 _cvWriteInt(i12, 702064, i3 >>> 10);
 _cvWriteInt(i12, 702080, i1 >>> 11);
 i1 = i9 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) != 0 ? (HEAP32[i3 >> 2] & -65536 | 0) == 1111752704 : 0) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i6 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  _cvWrite(i12, 702104, i3, i6);
 } else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i6 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  _cvWrite(i12, 702096, i9 + 268 | 0, i6);
 }
 if (i2) {
  _cvEndWriteStruct(i12);
  STACKTOP = i11;
  return;
 }
 i4 = _cvGetDims(HEAP32[i1 >> 2] | 0, i10) | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i6 + 0 >> 2] = HEAP32[i7 + 0 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 _cvStartWriteStruct(i12, 702112, 13, 0, i6);
 i2 = (i4 | 0) > 0;
 if (i8) {
  if (i2) {
   i2 = i9 + 264 | 0;
   i1 = 0;
   do {
    _cvWriteRawData(i12, HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, (HEAP32[i10 + (i1 << 2) >> 2] | 0) + 1 | 0, 702120);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
 } else if (i2) {
  i1 = i9 + 8 | 0;
  i2 = 0;
  do {
   _cvWriteRawData(i12, i1 + (i2 << 3) | 0, 2, 702120);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 _cvEndWriteStruct(i12);
 _cvEndWriteStruct(i12);
 STACKTOP = i11;
 return;
}

function ___cxx_global_array_dtor73(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967300 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967288 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967276 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967264 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967252 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967240 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967228 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967216 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967204 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967192 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967180 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967168 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967156 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967144 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967132 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967120 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967108 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967096 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967084 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967072 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967060 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967048 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967036 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(967024);
 STACKTOP = i1;
 return;
}

function ___cxx_global_array_dtor48(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966460 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966448 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966436 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966424 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966412 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966400 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966388 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966376 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966364 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966352 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966340 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966328 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966316 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966304 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966292 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966280 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966268 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966256 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966244 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966232 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966220 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966208 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966196 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(966184);
 STACKTOP = i1;
 return;
}

function ___cxx_global_array_dtor45(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966148 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966136 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966124 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966112 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966100 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966088 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966076 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966064 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966052 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966040 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966028 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966016 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(966004 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(965992 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(965980 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(965968 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(965956 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(965944 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(965932 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(965920 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(965908 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(965896 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(965884 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(965872);
 STACKTOP = i1;
 return;
}

function __ZN2cv6vBinOpIsNS_5OpSubIsssEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i6, i2, i5, i3, i7, i4, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 i17 = i1 + 4 | 0;
 i10 = HEAP32[i17 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i17 >> 2] = i8;
 if (!i10) {
  STACKTOP = i18;
  return;
 }
 i14 = HEAP32[i1 >> 2] | 0;
 i15 = i14 + -4 | 0;
 i16 = (i15 | 0) < 0;
 i13 = i2 >>> 1;
 i12 = i3 >>> 1;
 i11 = i4 >>> 1;
 while (1) {
  if (i16) i2 = 0; else {
   i9 = (i15 | 0) > 3;
   i10 = 0;
   do {
    i3 = (HEAP16[i6 + (i10 << 1) >> 1] | 0) - (HEAP16[i5 + (i10 << 1) >> 1] | 0) | 0;
    if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
    i2 = i10 | 1;
    i4 = (HEAP16[i6 + (i2 << 1) >> 1] | 0) - (HEAP16[i5 + (i2 << 1) >> 1] | 0) | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    HEAP16[i7 + (i10 << 1) >> 1] = i3;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i1 = i10 | 2;
    i4 = (HEAP16[i6 + (i1 << 1) >> 1] | 0) - (HEAP16[i5 + (i1 << 1) >> 1] | 0) | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    i2 = i10 | 3;
    i3 = (HEAP16[i6 + (i2 << 1) >> 1] | 0) - (HEAP16[i5 + (i2 << 1) >> 1] | 0) | 0;
    if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
    HEAP16[i7 + (i1 << 1) >> 1] = i4;
    HEAP16[i7 + (i2 << 1) >> 1] = i3;
    i10 = i10 + 4 | 0;
   } while ((i10 | 0) <= (i15 | 0));
   i2 = i9 ? i14 & -4 : 4;
  }
  if ((i2 | 0) < (i14 | 0)) do {
   i1 = (HEAP16[i6 + (i2 << 1) >> 1] | 0) - (HEAP16[i5 + (i2 << 1) >> 1] | 0) | 0;
   if ((i1 + 32768 | 0) >>> 0 >= 65536) i1 = (i1 | 0) > 0 ? 32767 : -32768;
   HEAP16[i7 + (i2 << 1) >> 1] = i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i14 | 0));
  if (!i8) break; else {
   i5 = i5 + (i12 << 1) | 0;
   i6 = i6 + (i13 << 1) | 0;
   i7 = i7 + (i11 << 1) | 0;
   i8 = i8 + -1 | 0;
  }
 }
 HEAP32[i17 >> 2] = -1;
 STACKTOP = i18;
 return;
}

function __ZN2cv6vBinOpIsNS_5OpAddIsssEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i6, i2, i5, i3, i7, i4, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 i17 = i1 + 4 | 0;
 i10 = HEAP32[i17 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i17 >> 2] = i8;
 if (!i10) {
  STACKTOP = i18;
  return;
 }
 i14 = HEAP32[i1 >> 2] | 0;
 i15 = i14 + -4 | 0;
 i16 = (i15 | 0) < 0;
 i13 = i2 >>> 1;
 i12 = i3 >>> 1;
 i11 = i4 >>> 1;
 while (1) {
  if (i16) i2 = 0; else {
   i9 = (i15 | 0) > 3;
   i10 = 0;
   do {
    i3 = (HEAP16[i5 + (i10 << 1) >> 1] | 0) + (HEAP16[i6 + (i10 << 1) >> 1] | 0) | 0;
    if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
    i2 = i10 | 1;
    i4 = (HEAP16[i5 + (i2 << 1) >> 1] | 0) + (HEAP16[i6 + (i2 << 1) >> 1] | 0) | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    HEAP16[i7 + (i10 << 1) >> 1] = i3;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i1 = i10 | 2;
    i4 = (HEAP16[i5 + (i1 << 1) >> 1] | 0) + (HEAP16[i6 + (i1 << 1) >> 1] | 0) | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    i2 = i10 | 3;
    i3 = (HEAP16[i5 + (i2 << 1) >> 1] | 0) + (HEAP16[i6 + (i2 << 1) >> 1] | 0) | 0;
    if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
    HEAP16[i7 + (i1 << 1) >> 1] = i4;
    HEAP16[i7 + (i2 << 1) >> 1] = i3;
    i10 = i10 + 4 | 0;
   } while ((i10 | 0) <= (i15 | 0));
   i2 = i9 ? i14 & -4 : 4;
  }
  if ((i2 | 0) < (i14 | 0)) do {
   i1 = (HEAP16[i5 + (i2 << 1) >> 1] | 0) + (HEAP16[i6 + (i2 << 1) >> 1] | 0) | 0;
   if ((i1 + 32768 | 0) >>> 0 >= 65536) i1 = (i1 | 0) > 0 ? 32767 : -32768;
   HEAP16[i7 + (i2 << 1) >> 1] = i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i14 | 0));
  if (!i8) break; else {
   i5 = i5 + (i12 << 1) | 0;
   i6 = i6 + (i13 << 1) | 0;
   i7 = i7 + (i11 << 1) | 0;
   i8 = i8 + -1 | 0;
  }
 }
 HEAP32[i17 >> 2] = -1;
 STACKTOP = i18;
 return;
}

function __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE8overflowEi(i15, i14) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 if ((i14 | 0) == -1) {
  i10 = 0;
  STACKTOP = i16;
  return i10 | 0;
 }
 i10 = i15 + 12 | 0;
 i11 = i15 + 8 | 0;
 i12 = (HEAP32[i10 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0;
 i13 = i15 + 24 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i9 = i15 + 28 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i6 | 0) == (i1 | 0)) {
  i3 = i15 + 48 | 0;
  if (!(HEAP32[i3 >> 2] & 16)) {
   i10 = -1;
   STACKTOP = i16;
   return i10 | 0;
  }
  i2 = i15 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i7 = i15 + 44 | 0;
  i8 = (HEAP32[i7 >> 2] | 0) - i1 | 0;
  i4 = i15 + 32 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i4, 0);
  if (!(HEAP8[i4 >> 0] & 1)) i5 = 10; else i5 = (HEAP32[i4 >> 2] & -2) + -1 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i4, i5, 0);
  i5 = HEAP8[i4 >> 0] | 0;
  if (!(i5 & 1)) {
   i4 = i4 + 1 | 0;
   i5 = (i5 & 255) >>> 1;
  } else {
   i4 = HEAP32[i15 + 40 >> 2] | 0;
   i5 = HEAP32[i15 + 36 >> 2] | 0;
  }
  i5 = i4 + i5 | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i9 >> 2] = i5;
  i6 = i4 + (i6 - i1) | 0;
  HEAP32[i13 >> 2] = i6;
  i2 = i4 + i8 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  i3 = i15 + 48 | 0;
  i2 = HEAP32[i15 + 44 >> 2] | 0;
  i5 = i1;
 }
 i4 = i6 + 1 | 0;
 i2 = i4 >>> 0 < i2 >>> 0 ? i2 : i4;
 HEAP32[i15 + 44 >> 2] = i2;
 if (HEAP32[i3 >> 2] & 8) {
  i1 = i15 + 32 | 0;
  if (!(HEAP8[i1 >> 0] & 1)) i1 = i1 + 1 | 0; else i1 = HEAP32[i15 + 40 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1 + i12;
  HEAP32[i15 + 16 >> 2] = i2;
 }
 if ((i6 | 0) == (i5 | 0)) {
  i10 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i15 >> 2] | 0) + 52 >> 2] & 127](i15, i14 & 255) | 0;
  STACKTOP = i16;
  return i10 | 0;
 } else {
  HEAP32[i13 >> 2] = i4;
  HEAP8[i6 >> 0] = i14;
  i10 = i14 & 255;
  STACKTOP = i16;
  return i10 | 0;
 }
 return 0;
}

function __ZN2cvL14addWeighted32fEPKfjS1_jPfjNS_5Size_IiEEPv(i12, i3, i6, i4, i7, i5, i1, i2) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, d15 = 0.0, d16 = 0.0, d17 = 0.0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, d22 = 0.0;
 i19 = STACKTOP;
 i18 = HEAP32[i1 >> 2] | 0;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 d16 = +HEAPF64[i2 >> 3];
 d17 = +HEAPF64[i2 + 8 >> 3];
 d15 = +HEAPF64[i2 + 16 >> 3];
 i14 = i3 >>> 2;
 i13 = i4 >>> 2;
 i1 = i5 >>> 2;
 if (!i11) {
  STACKTOP = i19;
  return;
 }
 i8 = i18 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i10 = (i8 | 0) > 3 ? i18 & -4 : 4;
 i2 = i7;
 i3 = i12;
 i4 = i11;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    d22 = d16 * +Math_fround(HEAPF32[i3 + (i5 << 2) >> 2]);
    f20 = Math_fround(d15 + (d22 + d17 * +Math_fround(HEAPF32[i6 + (i5 << 2) >> 2])));
    i11 = i5 | 1;
    d22 = d16 * +Math_fround(HEAPF32[i3 + (i11 << 2) >> 2]);
    f21 = Math_fround(d15 + (d22 + d17 * +Math_fround(HEAPF32[i6 + (i11 << 2) >> 2])));
    HEAPF32[i2 + (i5 << 2) >> 2] = f20;
    HEAPF32[i2 + (i11 << 2) >> 2] = f21;
    i11 = i5 | 2;
    d22 = d16 * +Math_fround(HEAPF32[i3 + (i11 << 2) >> 2]);
    f21 = Math_fround(d15 + (d22 + d17 * +Math_fround(HEAPF32[i6 + (i11 << 2) >> 2])));
    i7 = i5 | 3;
    d22 = d16 * +Math_fround(HEAPF32[i3 + (i7 << 2) >> 2]);
    f20 = Math_fround(d15 + (d22 + d17 * +Math_fround(HEAPF32[i6 + (i7 << 2) >> 2])));
    HEAPF32[i2 + (i11 << 2) >> 2] = f21;
    HEAPF32[i2 + (i7 << 2) >> 2] = f20;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i18 | 0)) do {
   d22 = d16 * +Math_fround(HEAPF32[i3 + (i5 << 2) >> 2]);
   HEAPF32[i2 + (i5 << 2) >> 2] = Math_fround(d15 + (d22 + d17 * +Math_fround(HEAPF32[i6 + (i5 << 2) >> 2])));
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i18 | 0));
  if (!i4) break; else {
   i6 = i6 + (i13 << 2) | 0;
   i2 = i2 + (i1 << 2) | 0;
   i3 = i3 + (i14 << 2) | 0;
  }
 }
 STACKTOP = i19;
 return;
}

function __ZNSt3__16vectorIN7testing12TestPropertyENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 i7 = i9 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (((HEAP32[i7 >> 2] | 0) - i1 | 0) / 24 | 0) + 1 | 0;
 if (i3 >>> 0 > 178956970) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i8 = i9 + 8 | 0;
 i2 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 24 | 0;
 if (i2 >>> 0 < 89478485) {
  i2 = i2 << 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = ((HEAP32[i7 >> 2] | 0) - i1 | 0) / 24 | 0;
  if (!i2) {
   i4 = 0;
   i2 = 0;
   i3 = i1;
  } else i6 = 6;
 } else {
  i2 = 178956970;
  i1 = ((HEAP32[i7 >> 2] | 0) - i1 | 0) / 24 | 0;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i4 = i2;
  i2 = __Znwj(i2 * 24 | 0) | 0;
  i3 = i1;
 }
 i1 = i2 + (i3 * 24 | 0) | 0;
 i6 = i2 + (i4 * 24 | 0) | 0;
 if (i1) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1, i5);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i2 + (i3 * 24 | 0) + 12 | 0, i5 + 12 | 0);
 }
 i5 = i2 + ((i3 + 1 | 0) * 24 | 0) | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) {
  i2 = i1;
  i3 = i4;
  i1 = i4;
 } else {
  do {
   i3 = i2;
   i2 = i2 + -24 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1 + -24 | 0, i2);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1 + -12 | 0, i3 + -12 | 0);
   i1 = i1 + -24 | 0;
  } while ((i2 | 0) != (i4 | 0));
  i2 = i1;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i8 >> 2] = i6;
 while (1) {
  if ((i1 | 0) == (i3 | 0)) break;
  i2 = i1 + -24 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + -12 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
  i1 = i2;
 }
 if (!i3) {
  STACKTOP = i10;
  return;
 }
 __ZdlPv(i3);
 STACKTOP = i10;
 return;
}

function _cvSetImageROI(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i12 + 8 | 0;
 i3 = i12;
 if (!i10) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-9, i2, 43088, 40912, 3007);
  __ZN2cv6String10deallocateEv(i2);
 }
 i9 = i11 + 8 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 if ((((((i8 | 0) > -1 ? (i7 = HEAP32[i11 + 12 >> 2] | 0, (i7 | 0) > -1) : 0) ? (i1 = HEAP32[i11 >> 2] | 0, i5 = HEAP32[i10 + 40 >> 2] | 0, (i1 | 0) < (i5 | 0)) : 0) ? (i4 = HEAP32[i11 + 4 >> 2] | 0, i6 = HEAP32[i10 + 44 >> 2] | 0, (i4 | 0) < (i6 | 0)) : 0) ? (i1 + i8 | 0) >= ((i8 | 0) > 0 | 0) : 0) ? (i4 + i7 | 0) >= ((i7 | 0) > 0 | 0) : 0) {
  i3 = i7;
  i2 = i5;
 } else {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  _memcpy(__ZN2cv6String8allocateEj(i3, 184) | 0, 43104, 184) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 43088, 40912, 3013);
  __ZN2cv6String10deallocateEv(i3);
  i1 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i11 + 4 >> 2] | 0;
  i3 = HEAP32[i11 + 12 >> 2] | 0;
  i2 = HEAP32[i10 + 40 >> 2] | 0;
  i6 = HEAP32[i10 + 44 >> 2] | 0;
 }
 i8 = i8 + i1 | 0;
 i3 = i3 + i4 | 0;
 i7 = (i1 | 0) < 0 ? 0 : i1;
 HEAP32[i11 >> 2] = i7;
 i5 = (i4 | 0) < 0 ? 0 : i4;
 HEAP32[i11 + 4 >> 2] = i5;
 i4 = ((i2 | 0) < (i8 | 0) ? i2 : i8) - i7 | 0;
 HEAP32[i9 >> 2] = i4;
 i3 = ((i6 | 0) < (i3 | 0) ? i6 : i3) - i5 | 0;
 HEAP32[i11 + 12 >> 2] = i3;
 i2 = i10 + 48 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1) {
  HEAP32[i1 + 4 >> 2] = i7;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i1 + 12 >> 2] = i4;
  HEAP32[i1 + 16 >> 2] = i3;
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[10248] | 0;
 if (!i1) {
  i1 = _cvAlloc(20) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = i7;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i1 + 12 >> 2] = i4;
  HEAP32[i1 + 16 >> 2] = i3;
 } else i1 = FUNCTION_TABLE_iiiiii[i1 & 31](0, i7, i5, i4, i3) | 0;
 HEAP32[i2 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZN2cvL13cvtScale8u16sEPKhjS1_jPsjNS_5Size_IiEEPd(i6, i17, i1, i2, i7, i5, i3, i4) {
 i6 = i6 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 1;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU8[i6 + i8 >> 0] | 0 | 0)))) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i2 = i8 | 1;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU8[i6 + i2 >> 0] | 0 | 0)))) | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    HEAP16[i7 + (i8 << 1) >> 1] = i5;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i1 = i8 | 2;
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU8[i6 + i1 >> 0] | 0 | 0)))) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i2 = i8 | 3;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU8[i6 + i2 >> 0] | 0 | 0)))) | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    HEAP16[i7 + (i1 << 1) >> 1] = i5;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU8[i6 + i5 >> 0] | 0 | 0)))) | 0;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i7 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + i17 | 0;
   i7 = i7 + (i9 << 1) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN4perf10Regression7getElemERN2cv3MatEiii(i2, i4, i3, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, d6 = 0.0, i7 = 0;
 i5 = STACKTOP;
 switch (HEAP32[i2 >> 2] & 7 | 0) {
 case 2:
  {
   i7 = HEAP32[i2 + 44 >> 2] | 0;
   i4 = Math_imul(HEAP32[i7 >> 2] | 0, i4) | 0;
   d6 = +(HEAPU16[(HEAP32[i2 + 16 >> 2] | 0) + ((Math_imul(HEAP32[i7 + 4 >> 2] | 0, i3) | 0) + i4) + (i1 << 1) >> 1] | 0);
   STACKTOP = i5;
   return +d6;
  }
 case 6:
  {
   i7 = HEAP32[i2 + 44 >> 2] | 0;
   i4 = Math_imul(HEAP32[i7 >> 2] | 0, i4) | 0;
   d6 = +HEAPF64[(HEAP32[i2 + 16 >> 2] | 0) + ((Math_imul(HEAP32[i7 + 4 >> 2] | 0, i3) | 0) + i4) + (i1 << 3) >> 3];
   STACKTOP = i5;
   return +d6;
  }
 case 4:
  {
   i7 = HEAP32[i2 + 44 >> 2] | 0;
   i4 = Math_imul(HEAP32[i7 >> 2] | 0, i4) | 0;
   d6 = +(HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + ((Math_imul(HEAP32[i7 + 4 >> 2] | 0, i3) | 0) + i4) + (i1 << 2) >> 2] | 0);
   STACKTOP = i5;
   return +d6;
  }
 case 1:
  {
   i7 = HEAP32[i2 + 44 >> 2] | 0;
   i4 = Math_imul(HEAP32[i7 >> 2] | 0, i4) | 0;
   d6 = +(HEAP8[(HEAP32[i2 + 16 >> 2] | 0) + (i4 + i1 + (Math_imul(HEAP32[i7 + 4 >> 2] | 0, i3) | 0)) >> 0] | 0);
   STACKTOP = i5;
   return +d6;
  }
 case 5:
  {
   i7 = HEAP32[i2 + 44 >> 2] | 0;
   i4 = Math_imul(HEAP32[i7 >> 2] | 0, i4) | 0;
   d6 = +Math_fround(HEAPF32[(HEAP32[i2 + 16 >> 2] | 0) + ((Math_imul(HEAP32[i7 + 4 >> 2] | 0, i3) | 0) + i4) + (i1 << 2) >> 2]);
   STACKTOP = i5;
   return +d6;
  }
 case 3:
  {
   i7 = HEAP32[i2 + 44 >> 2] | 0;
   i4 = Math_imul(HEAP32[i7 >> 2] | 0, i4) | 0;
   d6 = +(HEAP16[(HEAP32[i2 + 16 >> 2] | 0) + ((Math_imul(HEAP32[i7 + 4 >> 2] | 0, i3) | 0) + i4) + (i1 << 1) >> 1] | 0);
   STACKTOP = i5;
   return +d6;
  }
 case 0:
  {
   i7 = HEAP32[i2 + 44 >> 2] | 0;
   i4 = Math_imul(HEAP32[i7 >> 2] | 0, i4) | 0;
   d6 = +(HEAPU8[(HEAP32[i2 + 16 >> 2] | 0) + (i4 + i1 + (Math_imul(HEAP32[i7 + 4 >> 2] | 0, i3) | 0)) >> 0] | 0);
   STACKTOP = i5;
   return +d6;
  }
 default:
  {
   d6 = 0.0;
   STACKTOP = i5;
   return +d6;
  }
 }
 return 0.0;
}

function __ZNK2cv5MatOp17augAssignSubtractERKNS_7MatExprERNS_3MatE(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i4 = i13 + 96 | 0;
 i5 = i13 + 76 | 0;
 i6 = i13 + 56 | 0;
 i11 = i13;
 HEAP32[i11 >> 2] = 1124007936;
 i12 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i9 = i11 + 40 | 0;
 i1 = i12 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i9 >> 2] = i2;
 i10 = i11 + 48 | 0;
 i3 = i11 + 44 | 0;
 HEAP32[i3 >> 2] = i10;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i2 = HEAP32[i7 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i7, i11, -1);
 HEAP32[i4 >> 2] = 32088;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 16842752;
 HEAP32[i4 + 8 >> 2] = i8;
 HEAP32[i5 >> 2] = 32088;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 16842752;
 HEAP32[i5 + 8 >> 2] = i11;
 i2 = i6 + 4 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = 32232;
 HEAP32[i2 >> 2] = 33619968;
 HEAP32[i6 + 8 >> 2] = i8;
 __ZN2cv8subtractERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i4, i5, i6, __ZN2cv7noArrayEv() | 0, -1);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i7 = i1 + 12 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i10 | 0)) {
  STACKTOP = i13;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i13;
 return;
}

function __ZNSt3__17__sort3IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_T_(i6, i9, i7, i1) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) i3 = 0; else i3 = (_strcmp((i1 | 0) == 0 ? 6176 : i1, (i5 | 0) == 0 ? 6176 : i5) | 0) < 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if ((i4 | 0) == (i1 | 0)) i2 = 0; else i2 = (_strcmp((i4 | 0) == 0 ? 6176 : i4, (i1 | 0) == 0 ? 6176 : i1) | 0) < 0;
 if (!i3) {
  if (!i2) {
   i1 = 0;
   STACKTOP = i8;
   return i1 | 0;
  }
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i1;
  i3 = i9 + 4 | 0;
  i1 = i7 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 1;
   STACKTOP = i8;
   return i1 | 0;
  }
  if ((_strcmp((i1 | 0) == 0 ? 6176 : i1, (i2 | 0) == 0 ? 6176 : i2) | 0) >= 0) {
   i1 = 1;
   STACKTOP = i8;
   return i1 | 0;
  }
  HEAP32[i6 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i2 = i6 + 4 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i1;
  i1 = 2;
  STACKTOP = i8;
  return i1 | 0;
 }
 if (i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i7 >> 2] = i5;
  i3 = i6 + 4 | 0;
  i1 = i7 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i2;
  i1 = 1;
  STACKTOP = i8;
  return i1 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 HEAP32[i9 >> 2] = i5;
 i3 = i6 + 4 | 0;
 i2 = i9 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 | 0) == (i5 | 0)) {
  i1 = 1;
  STACKTOP = i8;
  return i1 | 0;
 }
 if ((_strcmp((i3 | 0) == 0 ? 6176 : i3, (i5 | 0) == 0 ? 6176 : i5) | 0) >= 0) {
  i1 = 1;
  STACKTOP = i8;
  return i1 | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i7 >> 2] = i5;
 i3 = i7 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i1;
 i1 = 2;
 STACKTOP = i8;
 return i1 | 0;
}

function __ZNK2cv5MatOp12augAssignXorERKNS_7MatExprERNS_3MatE(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i4 = i13 + 96 | 0;
 i5 = i13 + 76 | 0;
 i6 = i13 + 56 | 0;
 i11 = i13;
 HEAP32[i11 >> 2] = 1124007936;
 i12 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i9 = i11 + 40 | 0;
 i1 = i12 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i9 >> 2] = i2;
 i10 = i11 + 48 | 0;
 i3 = i11 + 44 | 0;
 HEAP32[i3 >> 2] = i10;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i2 = HEAP32[i7 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i7, i11, -1);
 HEAP32[i4 >> 2] = 32088;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 16842752;
 HEAP32[i4 + 8 >> 2] = i8;
 HEAP32[i5 >> 2] = 32088;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 16842752;
 HEAP32[i5 + 8 >> 2] = i11;
 i2 = i6 + 4 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = 32232;
 HEAP32[i2 >> 2] = 33619968;
 HEAP32[i6 + 8 >> 2] = i8;
 __ZN2cv11bitwise_xorERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_(i4, i5, i6, __ZN2cv7noArrayEv() | 0);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i7 = i1 + 12 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i10 | 0)) {
  STACKTOP = i13;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i13;
 return;
}

function __ZNK2cv5MatOp12augAssignAndERKNS_7MatExprERNS_3MatE(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i4 = i13 + 96 | 0;
 i5 = i13 + 76 | 0;
 i6 = i13 + 56 | 0;
 i11 = i13;
 HEAP32[i11 >> 2] = 1124007936;
 i12 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i9 = i11 + 40 | 0;
 i1 = i12 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i9 >> 2] = i2;
 i10 = i11 + 48 | 0;
 i3 = i11 + 44 | 0;
 HEAP32[i3 >> 2] = i10;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i2 = HEAP32[i7 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i7, i11, -1);
 HEAP32[i4 >> 2] = 32088;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 16842752;
 HEAP32[i4 + 8 >> 2] = i8;
 HEAP32[i5 >> 2] = 32088;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 16842752;
 HEAP32[i5 + 8 >> 2] = i11;
 i2 = i6 + 4 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = 32232;
 HEAP32[i2 >> 2] = 33619968;
 HEAP32[i6 + 8 >> 2] = i8;
 __ZN2cv11bitwise_andERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_(i4, i5, i6, __ZN2cv7noArrayEv() | 0);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i7 = i1 + 12 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i10 | 0)) {
  STACKTOP = i13;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i13;
 return;
}

function __ZNK2cv5MatOp11augAssignOrERKNS_7MatExprERNS_3MatE(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i4 = i13 + 96 | 0;
 i5 = i13 + 76 | 0;
 i6 = i13 + 56 | 0;
 i11 = i13;
 HEAP32[i11 >> 2] = 1124007936;
 i12 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i9 = i11 + 40 | 0;
 i1 = i12 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i9 >> 2] = i2;
 i10 = i11 + 48 | 0;
 i3 = i11 + 44 | 0;
 HEAP32[i3 >> 2] = i10;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i2 = HEAP32[i7 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i7, i11, -1);
 HEAP32[i4 >> 2] = 32088;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 16842752;
 HEAP32[i4 + 8 >> 2] = i8;
 HEAP32[i5 >> 2] = 32088;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 16842752;
 HEAP32[i5 + 8 >> 2] = i11;
 i2 = i6 + 4 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = 32232;
 HEAP32[i2 >> 2] = 33619968;
 HEAP32[i6 + 8 >> 2] = i8;
 __ZN2cv10bitwise_orERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_(i4, i5, i6, __ZN2cv7noArrayEv() | 0);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i7 = i1 + 12 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i10 | 0)) {
  STACKTOP = i13;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i13;
 return;
}

function __ZN2cvL11cvtScale16uEPKtjPKhjPtjNS_5Size_IiEEPd(i7, i5, i1, i2, i8, i6, i3, i4) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 i16 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f15 = Math_fround(+HEAPF64[i4 >> 3]);
 f14 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i13 = i5 >>> 1;
 i9 = i6 >>> 1;
 if (!i3) {
  STACKTOP = i17;
  return;
 }
 i10 = i16 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = (i10 | 0) > 3 ? i16 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPU16[i7 + (i1 << 1) >> 1] | 0 | 0)))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i4 = i1 | 1;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPU16[i7 + (i4 << 1) >> 1] | 0 | 0)))) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i1 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i2 = i1 | 2;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPU16[i7 + (i2 << 1) >> 1] | 0 | 0)))) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    i4 = i1 | 3;
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPU16[i7 + (i4 << 1) >> 1] | 0 | 0)))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i2 << 1) >> 1] = i6;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i16 | 0)) do {
   i4 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPU16[i7 + (i5 << 1) >> 1] | 0 | 0)))) | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i16 | 0));
  if (!i3) break; else {
   i7 = i7 + (i13 << 1) | 0;
   i8 = i8 + (i9 << 1) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZNK2cv5MatOp12augAssignAddERKNS_7MatExprERNS_3MatE(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i4 = i13 + 96 | 0;
 i5 = i13 + 76 | 0;
 i6 = i13 + 56 | 0;
 i11 = i13;
 HEAP32[i11 >> 2] = 1124007936;
 i12 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i9 = i11 + 40 | 0;
 i1 = i12 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i9 >> 2] = i2;
 i10 = i11 + 48 | 0;
 i3 = i11 + 44 | 0;
 HEAP32[i3 >> 2] = i10;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i2 = HEAP32[i7 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i7, i11, -1);
 HEAP32[i4 >> 2] = 32088;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 16842752;
 HEAP32[i4 + 8 >> 2] = i8;
 HEAP32[i5 >> 2] = 32088;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 16842752;
 HEAP32[i5 + 8 >> 2] = i11;
 i2 = i6 + 4 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = 32232;
 HEAP32[i2 >> 2] = 33619968;
 HEAP32[i6 + 8 >> 2] = i8;
 __ZN2cv3addERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i4, i5, i6, __ZN2cv7noArrayEv() | 0, -1);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i7 = i1 + 12 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i10 | 0)) {
  STACKTOP = i13;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i13;
 return;
}

function __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEEC2EjRKS2_(i2, i3, i17) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i17 = i17 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 HEAP32[i2 >> 2] = 0;
 i16 = i2 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 i1 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 if (!i3) {
  STACKTOP = i18;
  return;
 }
 if (i3 >>> 0 > 76695844) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i2);
 i5 = __Znwj(i3 * 56 | 0) | 0;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i1 >> 2] = i5 + (i3 * 56 | 0);
 i13 = i17 + 4 | 0;
 i14 = i17 + 8 | 0;
 i15 = i17 + 12 | 0;
 i6 = i17 + 16 | 0;
 i7 = i17 + 20 | 0;
 i8 = i17 + 24 | 0;
 i9 = i17 + 28 | 0;
 i10 = i17 + 32 | 0;
 i11 = i17 + 36 | 0;
 i12 = i17 + 44 | 0;
 i2 = i5;
 do {
  do if (i2) {
   HEAP32[i2 >> 2] = HEAP32[i17 >> 2];
   i1 = i2 + 4 | 0;
   HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
   i19 = i2 + 8 | 0;
   HEAP32[i19 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i2 + 28 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i2 + 32 >> 2] = HEAP32[i10 >> 2];
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP32[i2 + 36 >> 2] = i4;
   HEAP32[i2 + 40 >> 2] = i19;
   i19 = i2 + 48 | 0;
   i5 = i2 + 44 | 0;
   HEAP32[i5 >> 2] = i19;
   HEAP32[i2 + 52 >> 2] = 0;
   HEAP32[i19 >> 2] = 0;
   if (i4) {
    i4 = i4 + 12 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   }
   if ((HEAP32[i13 >> 2] | 0) < 3) {
    i4 = HEAP32[i12 >> 2] | 0;
    i5 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    break;
   } else {
    HEAP32[i1 >> 2] = 0;
    __ZN2cv3Mat8copySizeERKS0_(i2, i17);
    break;
   }
  } while (0);
  i2 = (HEAP32[i16 >> 2] | 0) + 56 | 0;
  HEAP32[i16 >> 2] = i2;
  i3 = i3 + -1 | 0;
 } while ((i3 | 0) != 0);
 STACKTOP = i18;
 return;
}

function __ZN2cvL13cvtScale8s16sEPKajPKhjPsjNS_5Size_IiEEPd(i6, i17, i1, i2, i7, i5, i3, i4) {
 i6 = i6 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 1;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP8[i6 + i8 >> 0] | 0)))) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i2 = i8 | 1;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP8[i6 + i2 >> 0] | 0)))) | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    HEAP16[i7 + (i8 << 1) >> 1] = i5;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i1 = i8 | 2;
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP8[i6 + i1 >> 0] | 0)))) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i2 = i8 | 3;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP8[i6 + i2 >> 0] | 0)))) | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    HEAP16[i7 + (i1 << 1) >> 1] = i5;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP8[i6 + i5 >> 0] | 0)))) | 0;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i7 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + i17 | 0;
   i7 = i7 + (i9 << 1) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN7testing8internal8FilePath11ConcatPathsERKS1_S3_(i8, i3, i5) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i9 = i10 + 24 | 0;
 i6 = i10 + 12 | 0;
 i7 = i10;
 i1 = HEAP8[i3 >> 0] | 0;
 if (!(i1 & 1)) i2 = (i1 & 255) >>> 1; else i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i8, i5);
  STACKTOP = i10;
  return;
 }
 __ZNK7testing8internal8FilePath27RemoveTrailingPathSeparatorEv(i9, i3);
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = HEAP8[i9 >> 0] | 0;
 if (!(i1 & 1)) {
  i1 = (i1 & 255) >>> 1;
  i2 = i9 + 1 | 0;
 } else {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  i2 = HEAP32[i9 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i7, i2, i1, i1 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, 47);
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i2 = HEAP8[i7 >> 0] | 0;
 i3 = (i2 & 1) == 0;
 if (i3) i1 = (i2 & 255) >>> 1; else i1 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 if (!(i2 & 1)) i4 = (i2 & 255) >>> 1; else i4 = HEAP32[i5 + 4 >> 2] | 0;
 if (i3) i2 = i7 + 1 | 0; else i2 = HEAP32[i7 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, i2, i1, i4 + i1 | 0);
 if (!(HEAP8[i5 >> 0] & 1)) i1 = i5 + 1 | 0; else i1 = HEAP32[i5 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, i1, i4) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i8, i6);
 __ZN7testing8internal8FilePath9NormalizeEv(i8);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 STACKTOP = i10;
 return;
}

function _cvMemStorageAlloc(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i1 = i10 + 16 | 0;
 i2 = i10 + 8 | 0;
 i7 = i10;
 if (!i9) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i1, 20) | 0) + 0 | 0;
  i5 = 39744 | 0;
  i6 = i4 + 20 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 39768, 39608, 327);
  __ZN2cv6String10deallocateEv(i1);
 }
 if ((i8 | 0) < 0) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i2, 35) | 0) + 0 | 0;
  i5 = 39792 | 0;
  i6 = i4 + 35 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i2, 39768, 39608, 330);
  __ZN2cv6String10deallocateEv(i2);
 }
 i3 = i9 + 20 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i9 + 16 | 0;
 if (i1 >>> 0 >= i8 >>> 0) {
  i4 = i1;
  i5 = i9 + 8 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = i1 - i4 | 0;
  i1 = i5 + i1 | 0;
  i2 = i4 - i8 | 0;
  i2 = i2 & -8;
  HEAP32[i3 >> 2] = i2;
  STACKTOP = i10;
  return i1 | 0;
 }
 if (((HEAP32[i2 >> 2] | 0) + -8 & -8) >>> 0 < i8 >>> 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i7, 37) | 0) + 0 | 0;
  i5 = 39832 | 0;
  i6 = i4 + 37 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i7, 39768, 39608, 338);
  __ZN2cv6String10deallocateEv(i7);
 }
 __ZL17icvGoNextMemBlockP12CvMemStorage(i9);
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i9 + 8 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = i1 - i4 | 0;
 i1 = i5 + i1 | 0;
 i2 = i4 - i8 | 0;
 i2 = i2 & -8;
 HEAP32[i3 >> 2] = i2;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN2cv8vBinOp32IfNS_9OpAbsDiffIfEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 2;
 i10 = i3 >>> 2;
 i9 = i4 >>> 2;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    f17 = Math_fround(HEAPF32[i1 + (i3 << 2) >> 2]);
    f17 = Math_fround(Math_abs(Math_fround(f17 - Math_fround(HEAPF32[i5 + (i3 << 2) >> 2]))));
    i7 = i3 | 1;
    f18 = Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]);
    f18 = Math_fround(Math_abs(Math_fround(f18 - Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]))));
    HEAPF32[i6 + (i3 << 2) >> 2] = f17;
    HEAPF32[i6 + (i7 << 2) >> 2] = f18;
    i7 = i3 | 2;
    f18 = Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]);
    f18 = Math_fround(Math_abs(Math_fround(f18 - Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]))));
    i8 = i3 | 3;
    f17 = Math_fround(HEAPF32[i1 + (i8 << 2) >> 2]);
    f17 = Math_fround(Math_abs(Math_fround(f17 - Math_fround(HEAPF32[i5 + (i8 << 2) >> 2]))));
    HEAPF32[i6 + (i7 << 2) >> 2] = f18;
    HEAPF32[i6 + (i8 << 2) >> 2] = f17;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   f17 = Math_fround(HEAPF32[i1 + (i2 << 2) >> 2]);
   HEAPF32[i6 + (i2 << 2) >> 2] = Math_fround(Math_abs(Math_fround(f17 - Math_fround(HEAPF32[i5 + (i2 << 2) >> 2]))));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 2) | 0;
   i6 = i6 + (i9 << 2) | 0;
   i1 = i1 + (i11 << 2) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZNK2cv5MatOp15augAssignDivideERKNS_7MatExprERNS_3MatE(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i4 = i13 + 96 | 0;
 i5 = i13 + 76 | 0;
 i6 = i13 + 56 | 0;
 i11 = i13;
 HEAP32[i11 >> 2] = 1124007936;
 i12 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i9 = i11 + 40 | 0;
 i1 = i12 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i9 >> 2] = i2;
 i10 = i11 + 48 | 0;
 i3 = i11 + 44 | 0;
 HEAP32[i3 >> 2] = i10;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i2 = HEAP32[i7 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i7, i11, -1);
 HEAP32[i4 >> 2] = 32088;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 16842752;
 HEAP32[i4 + 8 >> 2] = i8;
 HEAP32[i5 >> 2] = 32088;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 16842752;
 HEAP32[i5 + 8 >> 2] = i11;
 i2 = i6 + 4 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = 32232;
 HEAP32[i2 >> 2] = 33619968;
 HEAP32[i6 + 8 >> 2] = i8;
 __ZN2cv6divideERKNS_11_InputArrayES2_RKNS_12_OutputArrayEdi(i4, i5, i6, 1.0, -1);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i7 = i1 + 12 | 0, i8 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i8 + -1, (i8 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i10 | 0)) {
  STACKTOP = i13;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i13;
 return;
}

function __ZN2cvL14cvtScale32s16uEPKijPKhjPtjNS_5Size_IiEEPd(i7, i5, i1, i2, i8, i6, i3, i4) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 i16 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f15 = Math_fround(+HEAPF64[i4 >> 3]);
 f14 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i13 = i5 >>> 2;
 i9 = i6 >>> 1;
 if (!i3) {
  STACKTOP = i17;
  return;
 }
 i10 = i16 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = (i10 | 0) > 3 ? i16 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP32[i7 + (i1 << 2) >> 2] | 0)))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i4 = i1 | 1;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP32[i7 + (i4 << 2) >> 2] | 0)))) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i1 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i2 = i1 | 2;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP32[i7 + (i2 << 2) >> 2] | 0)))) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    i4 = i1 | 3;
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP32[i7 + (i4 << 2) >> 2] | 0)))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i2 << 1) >> 1] = i6;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i16 | 0)) do {
   i4 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP32[i7 + (i5 << 2) >> 2] | 0)))) | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i16 | 0));
  if (!i3) break; else {
   i7 = i7 + (i13 << 2) | 0;
   i8 = i8 + (i9 << 1) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZN2cvL14cvtScale16s16uEPKsjPKhjPtjNS_5Size_IiEEPd(i7, i5, i1, i2, i8, i6, i3, i4) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 i16 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f15 = Math_fround(+HEAPF64[i4 >> 3]);
 f14 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i13 = i5 >>> 1;
 i9 = i6 >>> 1;
 if (!i3) {
  STACKTOP = i17;
  return;
 }
 i10 = i16 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = (i10 | 0) > 3 ? i16 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP16[i7 + (i1 << 1) >> 1] | 0)))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i4 = i1 | 1;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP16[i7 + (i4 << 1) >> 1] | 0)))) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i1 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i2 = i1 | 2;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP16[i7 + (i2 << 1) >> 1] | 0)))) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    i4 = i1 | 3;
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP16[i7 + (i4 << 1) >> 1] | 0)))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i2 << 1) >> 1] = i6;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i16 | 0)) do {
   i4 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAP16[i7 + (i5 << 1) >> 1] | 0)))) | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i16 | 0));
  if (!i3) break; else {
   i7 = i7 + (i13 << 1) | 0;
   i8 = i8 + (i9 << 1) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZN7testing8internal29ParameterizedTestCaseRegistry24GetTestCasePatternHolderI24Size_MatType_bitwise_notEEPNS0_25ParameterizedTestCaseInfoIT_EEPKcS9_i(i7, i5, i3, i4) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i9;
 i1 = HEAP32[i7 >> 2] | 0;
 i8 = i7 + 4 | 0;
 L1 : do if ((i1 | 0) != (HEAP32[i8 >> 2] | 0)) {
  while (1) {
   i10 = HEAP32[i1 >> 2] | 0;
   i2 = i1 + 4 | 0;
   if (!(__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] & 127](i10) | 0, i5) | 0)) break;
   if ((i2 | 0) == (HEAP32[i8 >> 2] | 0)) break L1; else i1 = i2;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 127](i2) | 0) != 3120) {
   __ZN7testing8internal25ReportInvalidTestCaseTypeEPKcS2_i(i5, i3, i4);
   __ZN7testing8internal5posix5AbortEv();
  }
  i1 = __ZN7testing8internal27CheckedDowncastToActualTypeINS0_25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notEENS0_29ParameterizedTestCaseInfoBaseEEEPT_PT0_(HEAP32[i1 >> 2] | 0) | 0;
  if (i1) {
   STACKTOP = i9;
   return i1 | 0;
  }
 } while (0);
 i2 = __Znwj(40) | 0;
 HEAP32[i2 >> 2] = 2416;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2 + 4 | 0, i5, _strlen(i5 | 0) | 0);
 i1 = i2 + 16 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i6 >> 2] = i2;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 + 8 >> 2] | 0)) {
  __ZNSt3__16vectorIPN7testing8internal29ParameterizedTestCaseInfoBaseENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i7, i6);
  i1 = i2;
  STACKTOP = i9;
  return i1 | 0;
 }
 if (!i1) i1 = 0; else {
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i1 + 4;
 i1 = i2;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN2cvL13cvtScale16u8sEPKtjPKhjPajNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i17, i3, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 1;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i6 + (i8 << 1) >> 1] | 0 | 0)))) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i2 = i8 | 1;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i6 + (i2 << 1) >> 1] | 0 | 0)))) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i8 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i1 = i8 | 2;
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i6 + (i1 << 1) >> 1] | 0 | 0)))) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i2 = i8 | 3;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i6 + (i2 << 1) >> 1] | 0 | 0)))) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i6 + (i5 << 1) >> 1] | 0 | 0)))) | 0;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + (i9 << 1) | 0;
   i7 = i7 + i17 | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i8, i6, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i9 = i10 + 24 | 0;
 i4 = i10 + 12 | 0;
 i5 = i10;
 if ((i8 | 0) == 0 | (i6 | 0) == 0) {
  i1 = 0;
  STACKTOP = i10;
  return i1 | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, 168440, 2);
 HEAP32[i4 + 0 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i2 = HEAP8[i5 >> 0] | 0;
 if (!(i2 & 1)) {
  i3 = (i2 & 255) >>> 1;
  i2 = i5 + 1 | 0;
 } else {
  i3 = HEAP32[i5 + 4 >> 2] | 0;
  i2 = HEAP32[i5 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i4, i2, i3, i3 + 6 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i4, 168464, 6) | 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i3 = HEAP8[i4 >> 0] | 0;
 if (!(i3 & 1)) {
  i1 = _strlen(i6 | 0) | 0;
  i3 = (i3 & 255) >>> 1;
  i2 = i4 + 1 | 0;
 } else {
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i1 = _strlen(i6 | 0) | 0;
  i2 = HEAP32[i4 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, i2, i3, i3 + i1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, i6, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 i1 = HEAP8[i9 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i9 + 1 | 0;
  i3 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i9 + 8 >> 2] | 0;
  i3 = HEAP32[i9 + 4 >> 2] | 0;
 }
 if (!(_strncmp(i8, i2, i3) | 0)) {
  i1 = i8 + i3 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
  if (!(i2 << 24 >> 24 == 0 & i7)) if (i2 << 24 >> 24 == 61) i1 = i8 + (i3 + 1) | 0; else i1 = 0;
 } else i1 = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN2cv6vBinOpIaNS_9OpAbsDiffIaEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i2, i11, i1, i12, i3, i10, i13) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0;
 i14 = STACKTOP;
 i9 = i13 + 4 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i8 + -1;
 if (!i8) {
  STACKTOP = i14;
  return;
 }
 i8 = i2;
 i2 = HEAP32[i13 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i4 = 0;
   do {
    i2 = (HEAP8[i8 + i4 >> 0] | 0) - (HEAP8[i1 + i4 >> 0] | 0) | 0;
    i2 = (i2 | 0) > -1 ? i2 : 0 - i2 | 0;
    if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
    i6 = i4 | 1;
    i5 = (HEAP8[i8 + i6 >> 0] | 0) - (HEAP8[i1 + i6 >> 0] | 0) | 0;
    i5 = (i5 | 0) > -1 ? i5 : 0 - i5 | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    HEAP8[i3 + i4 >> 0] = i2;
    HEAP8[i3 + i6 >> 0] = i5;
    i7 = i4 | 2;
    i2 = (HEAP8[i8 + i7 >> 0] | 0) - (HEAP8[i1 + i7 >> 0] | 0) | 0;
    i2 = (i2 | 0) > -1 ? i2 : 0 - i2 | 0;
    if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
    i5 = i4 | 3;
    i6 = (HEAP8[i8 + i5 >> 0] | 0) - (HEAP8[i1 + i5 >> 0] | 0) | 0;
    i6 = (i6 | 0) > -1 ? i6 : 0 - i6 | 0;
    if ((i6 + 128 | 0) >>> 0 >= 256) i6 = (i6 | 0) > 0 ? 127 : -128;
    HEAP8[i3 + i7 >> 0] = i2;
    HEAP8[i3 + i5 >> 0] = i6;
    i4 = i4 + 4 | 0;
    i2 = HEAP32[i13 >> 2] | 0;
   } while ((i4 | 0) <= (i2 + -4 | 0));
  }
  if ((i4 | 0) < (i2 | 0)) do {
   i2 = (HEAP8[i8 + i4 >> 0] | 0) - (HEAP8[i1 + i4 >> 0] | 0) | 0;
   i2 = (i2 | 0) > -1 ? i2 : 0 - i2 | 0;
   if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
   HEAP8[i3 + i4 >> 0] = i2;
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i13 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i7 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i7 + -1;
  if (!i7) break; else {
   i1 = i1 + i12 | 0;
   i8 = i8 + i11 | 0;
   i3 = i3 + i10 | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZNSt3__118__insertion_sort_3IRNS_6__lessIN2cv6StringES3_EEPS3_EEvT0_S7_T_(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i11;
 i2 = i8 + 16 | 0;
 __ZNSt3__17__sort3IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_T_(i8, i8 + 8 | 0, i2, i1) | 0;
 i1 = i8 + 24 | 0;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i11;
  return;
 }
 i6 = i10 + 4 | 0;
 while (1) {
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i4 | 0) ? (i7 = (i3 | 0) == 0, (_strcmp(i7 ? 6176 : i3, (i4 | 0) == 0 ? 6176 : i4) | 0) < 0) : 0) {
   HEAP32[i10 >> 2] = i3;
   HEAP32[i6 >> 2] = HEAP32[i1 + 4 >> 2];
   if (i7) i5 = i1; else {
    i5 = i3 + -4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i5 = i1;
   }
   while (1) {
    __ZN2cv6String10deallocateEv(i5);
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) i3 = 0; else {
     i3 = i3 + -4 | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i2 >> 2] | 0;
    }
    HEAP32[i5 >> 2] = i3;
    HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    if ((i2 | 0) == (i8 | 0)) {
     i3 = i8;
     break;
    }
    i4 = i2 + -8 | 0;
    i3 = HEAP32[i10 >> 2] | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i3 | 0) == (i5 | 0)) {
     i3 = i2;
     break;
    }
    if ((_strcmp((i3 | 0) == 0 ? 6176 : i3, (i5 | 0) == 0 ? 6176 : i5) | 0) < 0) {
     i5 = i2;
     i2 = i4;
    } else {
     i3 = i2;
     break;
    }
   }
   if ((i10 | 0) != (i3 | 0)) {
    __ZN2cv6String10deallocateEv(i3);
    i2 = HEAP32[i10 >> 2] | 0;
    if (!i2) i2 = 0; else {
     i2 = i2 + -4 | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i10 >> 2] | 0;
    }
    HEAP32[i3 >> 2] = i2;
    HEAP32[i3 + 4 >> 2] = HEAP32[i6 >> 2];
   }
   __ZN2cv6String10deallocateEv(i10);
  }
  i2 = i1 + 8 | 0;
  if ((i2 | 0) == (i9 | 0)) break; else {
   i5 = i1;
   i1 = i2;
   i2 = i5;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZL15icvWriteSeqTreeP13CvFileStoragePKcPKv10CvAttrList(i15, i11, i12, i14) {
 i15 = i15 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i5 = i17 + 32 | 0;
 i16 = i17 + 16 | 0;
 i6 = i17 + 8 | 0;
 i7 = i17;
 i4 = i14;
 L1 : do {
  i9 = HEAP32[i4 >> 2] | 0;
  if (!i9) break;
  i2 = HEAP32[i9 >> 2] | 0;
  if (i2) {
   i8 = 0;
   i3 = 0;
   while (1) {
    i3 = i3 + 1 | 0;
    if (!(_strcmp(13520, i2) | 0)) {
     i13 = 7;
     break L1;
    }
    i1 = i3 << 1;
    i2 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
    if (!i2) break; else i8 = i1;
   }
  }
  i4 = HEAP32[i4 + 4 >> 2] | 0;
 } while ((i4 | 0) != 0);
 if ((((((i13 | 0) == 7 ? (i10 = HEAP32[i9 + ((i8 | 1) << 2) >> 2] | 0, (i10 | 0) != 0) : 0) ? (_strcmp(i10, 13536) | 0) != 0 : 0) ? (_strcmp(i10, 13544) | 0) != 0 : 0) ? (_strcmp(i10, 13552) | 0) != 0 : 0) ? (_strcmp(i10, 13560) | 0) != 0 : 0) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i5 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  _cvStartWriteStruct(i15, i11, 6, 10624, i5);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i5 + 0 >> 2] = HEAP32[i7 + 0 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  _cvStartWriteStruct(i15, 13320, 5, 0, i5);
  _cvInitTreeNodeIterator(i16, i12, 2147483647);
  i1 = HEAP32[i16 >> 2] | 0;
  if (i1) {
   i2 = i16 + 4 | 0;
   do {
    i10 = i14;
    __ZL11icvWriteSeqP13CvFileStoragePKcPKv10CvAttrListi(i15, 0, i1, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0);
    _cvNextTreeNode(i16) | 0;
    i1 = HEAP32[i16 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  _cvEndWriteStruct(i15);
  _cvEndWriteStruct(i15);
  STACKTOP = i17;
  return;
 }
 i10 = i14;
 __ZL11icvWriteSeqP13CvFileStoragePKcPKv10CvAttrListi(i15, i11, i12, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, -1);
 STACKTOP = i17;
 return;
}

function __ZN2cvL14cvtScale32f16uEPKfjPKhjPtjNS_5Size_IiEEPd(i7, i5, i1, i2, i8, i6, i3, i4) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 i16 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f15 = Math_fround(+HEAPF64[i4 >> 3]);
 f14 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i13 = i5 >>> 2;
 i9 = i6 >>> 1;
 if (!i3) {
  STACKTOP = i17;
  return;
 }
 i10 = i16 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = (i10 | 0) > 3 ? i16 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i7 + (i1 << 2) >> 2])))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i4 = i1 | 1;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i7 + (i4 << 2) >> 2])))) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i1 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i2 = i1 | 2;
    i6 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i7 + (i2 << 2) >> 2])))) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    i4 = i1 | 3;
    i5 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i7 + (i4 << 2) >> 2])))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i2 << 1) >> 1] = i6;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i16 | 0)) do {
   i4 = _lrint(+Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i7 + (i5 << 2) >> 2])))) | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i16 | 0));
  if (!i3) break; else {
   i7 = i7 + (i13 << 2) | 0;
   i8 = i8 + (i9 << 1) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZN2cvL6cmp16sEPKsjS1_jPhjNS_5Size_IiEEPv(i4, i2, i5, i3, i6, i13, i12, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i2 >>> 1;
 i3 = i3 >>> 1;
 if ((i1 & -2 | 0) == 2) {
  i1 = (i1 | 0) == 2 ? 4 : 1;
  i9 = i5;
  i11 = i3;
  i10 = i2;
 } else {
  i9 = i4;
  i4 = i5;
  i11 = i2;
  i10 = i3;
 }
 if ((i1 | 0) == 1 | (i1 | 0) == 4) {
  i8 = (i1 | 0) == 1 ? 0 : 255;
  i7 = i12 + 4 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i3 = i5 + -1 | 0;
  HEAP32[i7 >> 2] = i3;
  if (!i5) {
   STACKTOP = i14;
   return;
  }
  i2 = HEAP32[i12 >> 2] | 0;
  i1 = i9;
  while (1) {
   if ((i2 | 0) > 0) {
    i3 = 0;
    do {
     HEAP8[i6 + i3 >> 0] = ((HEAP16[i1 + (i3 << 1) >> 1] | 0) > (HEAP16[i4 + (i3 << 1) >> 1] | 0)) << 31 >> 31 ^ i8;
     i3 = i3 + 1 | 0;
     i2 = HEAP32[i12 >> 2] | 0;
    } while ((i3 | 0) < (i2 | 0));
    i5 = HEAP32[i7 >> 2] | 0;
   } else i5 = i3;
   i3 = i5 + -1 | 0;
   HEAP32[i7 >> 2] = i3;
   if (!i5) break; else {
    i6 = i6 + i13 | 0;
    i1 = i1 + (i11 << 1) | 0;
    i4 = i4 + (i10 << 1) | 0;
   }
  }
  STACKTOP = i14;
  return;
 }
 if (!((i1 | 0) == 0 | (i1 | 0) == 5)) {
  STACKTOP = i14;
  return;
 }
 i7 = (i1 | 0) == 0 ? 0 : 255;
 i8 = i12 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i3 = i5 + -1 | 0;
 HEAP32[i8 >> 2] = i3;
 if (!i5) {
  STACKTOP = i14;
  return;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = i9;
 while (1) {
  if ((i2 | 0) > 0) {
   i3 = 0;
   do {
    HEAP8[i6 + i3 >> 0] = ((HEAP16[i1 + (i3 << 1) >> 1] | 0) == (HEAP16[i4 + (i3 << 1) >> 1] | 0)) << 31 >> 31 ^ i7;
    i3 = i3 + 1 | 0;
    i2 = HEAP32[i12 >> 2] | 0;
   } while ((i3 | 0) < (i2 | 0));
   i5 = HEAP32[i8 >> 2] | 0;
  } else i5 = i3;
  i3 = i5 + -1 | 0;
  HEAP32[i8 >> 2] = i3;
  if (!i5) break; else {
   i6 = i6 + i13 | 0;
   i1 = i1 + (i11 << 1) | 0;
   i4 = i4 + (i10 << 1) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZNK2cv8internal14VecReaderProxyINS_3MatELi0EEclERNSt3__16vectorIS2_NS4_9allocatorIS2_EEEEj(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i15 = i19 + 56 | 0;
 i16 = i19;
 i11 = HEAP32[(HEAP32[i17 >> 2] | 0) + 40 >> 2] | 0;
 i11 = i11 >>> 0 < i1 >>> 0 ? i11 : i1;
 __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE6resizeEj(i18, i11);
 if (!i11) {
  STACKTOP = i19;
  return;
 }
 i12 = i15 + 4 | 0;
 i13 = i16 + 4 | 0;
 i4 = i16 + 8 | 0;
 i5 = i16 + 40 | 0;
 i6 = i16 + 48 | 0;
 i7 = i16 + 44 | 0;
 i8 = i16 + 52 | 0;
 i9 = i16 + 36 | 0;
 i10 = i16 + 16 | 0;
 i14 = 0;
 do {
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = HEAP32[i1 + 20 >> 2] | 0;
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
  i2 = (HEAP32[i18 >> 2] | 0) + (i14 * 56 | 0) | 0;
  HEAP32[i16 >> 2] = 1124007936;
  i1 = i13 + 0 | 0;
  i3 = i1 + 36 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  HEAP32[i5 >> 2] = i4;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  __ZN2cv4readERKNS_8FileNodeERNS_3MatERKS3_(i15, i2, i16);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i2 = i1 + 12 | 0, i3 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i16);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  if ((HEAP32[i13 >> 2] | 0) > 0) {
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i1 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i13 >> 2] | 0));
  }
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) != (i6 | 0)) __ZN2cv8fastFreeEPv(i1);
  i14 = i14 + 1 | 0;
  __ZN2cv16FileNodeIteratorppEv(HEAP32[i17 >> 2] | 0) | 0;
 } while (i14 >>> 0 < i11 >>> 0);
 STACKTOP = i19;
 return;
}

function __ZN2cv6vBinOpItNS_5OpSubItttEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i6, i2, i5, i3, i7, i4, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 i17 = i1 + 4 | 0;
 i10 = HEAP32[i17 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i17 >> 2] = i8;
 if (!i10) {
  STACKTOP = i18;
  return;
 }
 i14 = HEAP32[i1 >> 2] | 0;
 i15 = i14 + -4 | 0;
 i16 = (i15 | 0) < 0;
 i13 = i2 >>> 1;
 i12 = i3 >>> 1;
 i11 = i4 >>> 1;
 while (1) {
  if (i16) i2 = 0; else {
   i9 = (i15 | 0) > 3;
   i10 = 0;
   do {
    i3 = (HEAPU16[i6 + (i10 << 1) >> 1] | 0) - (HEAPU16[i5 + (i10 << 1) >> 1] | 0) | 0;
    if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
    i2 = i10 | 1;
    i4 = (HEAPU16[i6 + (i2 << 1) >> 1] | 0) - (HEAPU16[i5 + (i2 << 1) >> 1] | 0) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    HEAP16[i7 + (i10 << 1) >> 1] = i3;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i1 = i10 | 2;
    i4 = (HEAPU16[i6 + (i1 << 1) >> 1] | 0) - (HEAPU16[i5 + (i1 << 1) >> 1] | 0) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    i2 = i10 | 3;
    i3 = (HEAPU16[i6 + (i2 << 1) >> 1] | 0) - (HEAPU16[i5 + (i2 << 1) >> 1] | 0) | 0;
    if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
    HEAP16[i7 + (i1 << 1) >> 1] = i4;
    HEAP16[i7 + (i2 << 1) >> 1] = i3;
    i10 = i10 + 4 | 0;
   } while ((i10 | 0) <= (i15 | 0));
   i2 = i9 ? i14 & -4 : 4;
  }
  if ((i2 | 0) < (i14 | 0)) do {
   i1 = (HEAPU16[i6 + (i2 << 1) >> 1] | 0) - (HEAPU16[i5 + (i2 << 1) >> 1] | 0) | 0;
   if (i1 >>> 0 >= 65536) i1 = (i1 | 0) > 0 ? 65535 : 0;
   HEAP16[i7 + (i2 << 1) >> 1] = i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i14 | 0));
  if (!i8) break; else {
   i5 = i5 + (i12 << 1) | 0;
   i6 = i6 + (i13 << 1) | 0;
   i7 = i7 + (i11 << 1) | 0;
   i8 = i8 + -1 | 0;
  }
 }
 HEAP32[i17 >> 2] = -1;
 STACKTOP = i18;
 return;
}

function __ZN2cv6vBinOpItNS_5OpAddItttEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i6, i2, i5, i3, i7, i4, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 i17 = i1 + 4 | 0;
 i10 = HEAP32[i17 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i17 >> 2] = i8;
 if (!i10) {
  STACKTOP = i18;
  return;
 }
 i14 = HEAP32[i1 >> 2] | 0;
 i15 = i14 + -4 | 0;
 i16 = (i15 | 0) < 0;
 i13 = i2 >>> 1;
 i12 = i3 >>> 1;
 i11 = i4 >>> 1;
 while (1) {
  if (i16) i2 = 0; else {
   i9 = (i15 | 0) > 3;
   i10 = 0;
   do {
    i3 = (HEAPU16[i5 + (i10 << 1) >> 1] | 0) + (HEAPU16[i6 + (i10 << 1) >> 1] | 0) | 0;
    if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
    i2 = i10 | 1;
    i4 = (HEAPU16[i5 + (i2 << 1) >> 1] | 0) + (HEAPU16[i6 + (i2 << 1) >> 1] | 0) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    HEAP16[i7 + (i10 << 1) >> 1] = i3;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i1 = i10 | 2;
    i4 = (HEAPU16[i5 + (i1 << 1) >> 1] | 0) + (HEAPU16[i6 + (i1 << 1) >> 1] | 0) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    i2 = i10 | 3;
    i3 = (HEAPU16[i5 + (i2 << 1) >> 1] | 0) + (HEAPU16[i6 + (i2 << 1) >> 1] | 0) | 0;
    if (i3 >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 65535 : 0;
    HEAP16[i7 + (i1 << 1) >> 1] = i4;
    HEAP16[i7 + (i2 << 1) >> 1] = i3;
    i10 = i10 + 4 | 0;
   } while ((i10 | 0) <= (i15 | 0));
   i2 = i9 ? i14 & -4 : 4;
  }
  if ((i2 | 0) < (i14 | 0)) do {
   i1 = (HEAPU16[i5 + (i2 << 1) >> 1] | 0) + (HEAPU16[i6 + (i2 << 1) >> 1] | 0) | 0;
   if (i1 >>> 0 >= 65536) i1 = (i1 | 0) > 0 ? 65535 : 0;
   HEAP16[i7 + (i2 << 1) >> 1] = i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i14 | 0));
  if (!i8) break; else {
   i5 = i5 + (i12 << 1) | 0;
   i6 = i6 + (i13 << 1) | 0;
   i7 = i7 + (i11 << 1) | 0;
   i8 = i8 + -1 | 0;
  }
 }
 HEAP32[i17 >> 2] = -1;
 STACKTOP = i18;
 return;
}

function __ZN2cvL14randnScale_32sEPKfPiiiS1_S1_b(i8, i6, i13, i10, i11, i12, i2) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i14 = 0;
 i14 = STACKTOP;
 if (i2) {
  if ((i13 | 0) <= 0) {
   STACKTOP = i14;
   return;
  }
  i9 = (i10 | 0) > 0;
  i5 = 0;
  while (1) {
   if (i9) {
    i4 = 0;
    do {
     i7 = Math_imul(i4, i10) | 0;
     i2 = 0;
     f3 = Math_fround(HEAPF32[i11 + (i4 << 2) >> 2]);
     do {
      f1 = Math_fround(HEAPF32[i8 + (i2 << 2) >> 2]);
      f3 = Math_fround(f3 + Math_fround(f1 * Math_fround(HEAPF32[i12 + (i2 + i7 << 2) >> 2])));
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i10 | 0));
     HEAP32[i6 + (i4 << 2) >> 2] = _lrint(+f3) | 0;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i10 | 0));
   }
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i13 | 0)) break; else {
    i8 = i8 + (i10 << 2) | 0;
    i6 = i6 + (i10 << 2) | 0;
   }
  }
  STACKTOP = i14;
  return;
 }
 if ((i10 | 0) == 1) {
  f3 = Math_fround(HEAPF32[i11 >> 2]);
  f1 = Math_fround(HEAPF32[i12 >> 2]);
  if ((i13 | 0) > 0) i2 = 0; else {
   STACKTOP = i14;
   return;
  }
  do {
   HEAP32[i6 + (i2 << 2) >> 2] = _lrint(+Math_fround(f3 + Math_fround(f1 * Math_fround(HEAPF32[i8 + (i2 << 2) >> 2])))) | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i13 | 0));
  STACKTOP = i14;
  return;
 }
 if ((i13 | 0) <= 0) {
  STACKTOP = i14;
  return;
 }
 i7 = (i10 | 0) > 0;
 i2 = i8;
 i4 = 0;
 while (1) {
  if (i7) {
   i5 = 0;
   do {
    f1 = Math_fround(HEAPF32[i2 + (i5 << 2) >> 2]);
    f1 = Math_fround(f1 * Math_fround(HEAPF32[i12 + (i5 << 2) >> 2]));
    HEAP32[i6 + (i5 << 2) >> 2] = _lrint(+Math_fround(f1 + Math_fround(HEAPF32[i11 + (i5 << 2) >> 2]))) | 0;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i10 | 0));
  }
  i4 = i4 + 1 | 0;
  if ((i4 | 0) == (i13 | 0)) break; else {
   i6 = i6 + (i10 << 2) | 0;
   i2 = i2 + (i10 << 2) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cvL13cvtScale32s8sEPKijPKhjPajNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i17, i3, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 2;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP32[i6 + (i8 << 2) >> 2] | 0)))) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i2 = i8 | 1;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP32[i6 + (i2 << 2) >> 2] | 0)))) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i8 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i1 = i8 | 2;
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP32[i6 + (i1 << 2) >> 2] | 0)))) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i2 = i8 | 3;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP32[i6 + (i2 << 2) >> 2] | 0)))) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP32[i6 + (i5 << 2) >> 2] | 0)))) | 0;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + (i9 << 2) | 0;
   i7 = i7 + i17 | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cvL13cvtScale16s8sEPKsjPKhjPajNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i17, i3, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 1;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i6 + (i8 << 1) >> 1] | 0)))) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i2 = i8 | 1;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i6 + (i2 << 1) >> 1] | 0)))) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i8 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i1 = i8 | 2;
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i6 + (i1 << 1) >> 1] | 0)))) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i2 = i8 | 3;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i6 + (i2 << 1) >> 1] | 0)))) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i6 + (i5 << 1) >> 1] | 0)))) | 0;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + (i9 << 1) | 0;
   i7 = i7 + i17 | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZNKSt3__120__time_get_c_storageIwE7__weeksEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = STACKTOP;
 if (HEAP8[961056] | 0) {
  i2 = HEAP32[240262] | 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 if (!(___cxa_guard_acquire(961056) | 0)) {
  i2 = HEAP32[240262] | 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 if ((HEAP8[967704] | 0) == 0 ? (___cxa_guard_acquire(967704) | 0) != 0 : 0) {
  _memset(967536, 0, 168) | 0;
  ___cxa_atexit(388, 0, ___dso_handle | 0) | 0;
  ___cxa_guard_release(967704);
 }
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967536, 967712) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967548, 967744) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967560, 967776) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967572, 967808) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967584, 967848) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967596, 967888) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967608, 967920) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967620, 967960) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967632, 967976) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967644, 967992) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967656, 968008) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967668, 968024) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967680, 968040) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(967692, 968056) | 0;
 HEAP32[240262] = 967536;
 ___cxa_guard_release(961056);
 i2 = HEAP32[240262] | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZNKSt3__120__time_get_c_storageIcE7__weeksEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = STACKTOP;
 if (HEAP8[961040] | 0) {
  i2 = HEAP32[240258] | 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 if (!(___cxa_guard_acquire(961040) | 0)) {
  i2 = HEAP32[240258] | 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 if ((HEAP8[968240] | 0) == 0 ? (___cxa_guard_acquire(968240) | 0) != 0 : 0) {
  _memset(968072, 0, 168) | 0;
  ___cxa_atexit(387, 0, ___dso_handle | 0) | 0;
  ___cxa_guard_release(968240);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968072, 968248) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968084, 968256) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968096, 968264) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968108, 968272) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968120, 968288) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968132, 968304) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968144, 968312) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968156, 968328) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968168, 968336) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968180, 968344) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968192, 968352) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968204, 968360) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968216, 968368) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(968228, 968376) | 0;
 HEAP32[240258] = 968072;
 ___cxa_guard_release(961040);
 i2 = HEAP32[240258] | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZN2cv17borderInterpolateEiii(i1, i6, i3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7;
 if (i1 >>> 0 < i6 >>> 0) {
  STACKTOP = i7;
  return i1 | 0;
 }
 if ((i3 | 0) == 1) {
  i1 = (i1 | 0) < 0 ? 0 : i6 + -1 | 0;
  STACKTOP = i7;
  return i1 | 0;
 }
 i2 = (i3 | 0) == 4;
 if ((i3 | 0) == 3) {
  if ((i6 | 0) <= 0) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i2 = __ZN2cv6String8allocateEj(i4, 7) | 0;
   HEAP8[i2 + 0 >> 0] = HEAP8[47008] | 0;
   HEAP8[i2 + 1 >> 0] = HEAP8[47009] | 0;
   HEAP8[i2 + 2 >> 0] = HEAP8[47010] | 0;
   HEAP8[i2 + 3 >> 0] = HEAP8[47011] | 0;
   HEAP8[i2 + 4 >> 0] = HEAP8[47012] | 0;
   HEAP8[i2 + 5 >> 0] = HEAP8[47013] | 0;
   HEAP8[i2 + 6 >> 0] = HEAP8[47014] | 0;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 47016, 46680, 940);
   __ZN2cv6String10deallocateEv(i4);
  }
  if ((i1 | 0) < 0) {
   i2 = i1 - i6 | 0;
   i1 = ~i2 + i1 + ((i2 + 1 | 0) % (i6 | 0) | 0) | 0;
  }
  if ((i1 | 0) < (i6 | 0)) {
   STACKTOP = i7;
   return i1 | 0;
  }
  i1 = (i1 | 0) % (i6 | 0) | 0;
  STACKTOP = i7;
  return i1 | 0;
 } else if (!i3) {
  i1 = -1;
  STACKTOP = i7;
  return i1 | 0;
 } else if ((i3 | 0) == 2 | (i3 | 0) == 4) {
  i3 = i2 & 1;
  if ((i6 | 0) == 1) {
   i1 = 0;
   STACKTOP = i7;
   return i1 | 0;
  }
  i5 = i6 << 1;
  i4 = (i2 << 31 >> 31) + -1 | 0;
  do if ((i1 | 0) < 0) i1 = i3 + ~i1 | 0; else i1 = i4 - i1 + i5 | 0; while (i1 >>> 0 >= i6 >>> 0);
  STACKTOP = i7;
  return i1 | 0;
 } else {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i5, 31) | 0) + 0 | 0;
  i3 = 47040 | 0;
  i4 = i2 + 31 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i5, 47016, 46680, 949);
  __ZN2cv6String10deallocateEv(i5);
  STACKTOP = i7;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cvL13cvtScale32f8sEPKfjPKhjPajNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i17, i3, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 2;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i8 << 2) >> 2])))) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i2 = i8 | 1;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i2 << 2) >> 2])))) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i8 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i1 = i8 | 2;
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i1 << 2) >> 2])))) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i2 = i8 | 3;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i2 << 2) >> 2])))) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i5 << 2) >> 2])))) | 0;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + (i9 << 2) | 0;
   i7 = i7 + i17 | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cv11MatOp_AddEx8makeExprERNS_7MatExprERKNS_3MatES5_ddRKNS_7Scalar_IdEE(i6, i1, i4, d3, d5, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 d3 = +d3;
 d5 = +d5;
 i7 = i7 | 0;
 var i2 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 i8 = i16;
 i11 = i16 + 224 | 0;
 HEAP32[i11 >> 2] = 1124007936;
 i14 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i12 = i11 + 40 | 0;
 i9 = i14 + 0 | 0;
 i10 = i9 + 36 | 0;
 do {
  HEAP32[i9 >> 2] = 0;
  i9 = i9 + 4 | 0;
 } while ((i9 | 0) < (i10 | 0));
 HEAP32[i12 >> 2] = i2;
 i15 = i11 + 48 | 0;
 i13 = i11 + 44 | 0;
 HEAP32[i13 >> 2] = i15;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 __ZN2cv7MatExprC2EPKNS_5MatOpEiRKNS_3MatES6_S6_ddRKNS_7Scalar_IdEE(i8, 33112, 0, i1, i4, i11, d3, d5, i7);
 i10 = i8;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i2;
 __ZN2cv3MataSERKS0_(i6 + 8 | 0, i8 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i6 + 64 | 0, i8 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i6 + 120 | 0, i8 + 120 | 0) | 0;
 i9 = i6 + 176 | 0;
 i2 = i8 + 176 | 0;
 i10 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
  i9 = i9 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i9 | 0) < (i10 | 0));
 __ZN2cv7MatExprD2Ev(i8);
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i9 = i1 + 12 | 0, i10 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i10 + -1, (i10 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i11);
 HEAP32[i2 >> 2] = 0;
 i11 = i11 + 16 | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if ((HEAP32[i14 >> 2] | 0) > 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i14 >> 2] | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i15 | 0)) {
  STACKTOP = i16;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i16;
 return;
}

function __ZL13icvWriteMatNDP13CvFileStoragePKcPKv10CvAttrList(i11, i5, i9, i1) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 688 | 0;
 i2 = i10;
 i4 = i10 + 660 | 0;
 i8 = i10 + 160 | 0;
 i12 = i10 + 32 | 0;
 i7 = i10 + 664 | 0;
 i1 = i10 + 24 | 0;
 i13 = i10 + 16 | 0;
 i3 = i10 + 8 | 0;
 HEAP32[i4 >> 2] = i9;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i2 + 0 >> 2] = HEAP32[i1 + 0 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 _cvStartWriteStruct(i11, i5, 6, 10760, i2);
 i1 = _cvGetDims(i9, i12) | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i2 + 0 >> 2] = HEAP32[i13 + 0 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 _cvStartWriteStruct(i11, 11656, 13, 0, i2);
 _cvWriteRawData(i11, i12, i1, 11664);
 _cvEndWriteStruct(i11);
 i1 = _cvGetElemType(i9) | 0;
 i5 = HEAP8[11696 + (i1 & 7) >> 0] | 0;
 HEAP32[i2 >> 2] = (i1 >>> 3 & 511) + 1;
 HEAP32[i2 + 4 >> 2] = i5;
 _sprintf(i7, 11688, i2) | 0;
 if (!(HEAP8[i7 + 2 >> 0] | 0)) i1 = (HEAP8[i7 >> 0] | 0) == 49; else i1 = 0;
 _cvWriteString(i11, 11672, i7 + (i1 & 1) | 0, 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i2 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 _cvStartWriteStruct(i11, 11680, 13, 0, i2);
 if ((HEAP32[i9 + 20 >> 2] | 0) <= 0) {
  _cvEndWriteStruct(i11);
  _cvEndWriteStruct(i11);
  STACKTOP = i10;
  return;
 }
 if (!(HEAP32[i9 + 16 >> 2] | 0)) {
  _cvEndWriteStruct(i11);
  _cvEndWriteStruct(i11);
  STACKTOP = i10;
  return;
 }
 _cvInitNArrayIterator(1, i4, 0, i10 + 384 | 0, i8, 0) | 0;
 i1 = i8 + 16 | 0;
 do _cvWriteRawData(i11, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0, i7); while ((_cvNextNArraySlice(i8) | 0) != 0);
 _cvEndWriteStruct(i11);
 _cvEndWriteStruct(i11);
 STACKTOP = i10;
 return;
}

function __ZN7testing8internal6String10FormatByteEh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i9 = i3 + 144 | 0;
 i8 = i3;
 i4 = i8 + 64 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i7 >> 2] = 2640;
 i5 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = 2788;
 HEAP32[i4 >> 2] = 2808;
 HEAP32[i8 + 4 >> 2] = 0;
 __ZNSt3__18ios_base4initEPv(i8 + 64 | 0, i5);
 HEAP32[i8 + 136 >> 2] = 0;
 HEAP32[i8 + 140 >> 2] = -1;
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i4 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i5);
 HEAP32[i5 >> 2] = 2952;
 i6 = i8 + 44 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 24;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i5, i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 i9 = i8 + 8 | 0;
 HEAP32[i9 + ((HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 76) >> 2] = 48;
 HEAP32[i9 + ((HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 12) >> 2] = 2;
 i10 = i9 + ((HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 4) | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -75 | 8;
 i10 = i9 + ((HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 4) | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 16384;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEj(i9, i2 & 255) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i1, i5);
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i8 + 64 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 HEAP32[i5 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i5);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZN2cvL12cvtScale8u8sEPKhjS1_jPajNS_5Size_IiEEPd(i5, i17, i1, i2, i6, i16, i3, i4) {
 i5 = i5 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i16 = i16 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 i14 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f13 = Math_fround(+HEAPF64[i4 >> 3]);
 f12 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 i9 = i14 + -4 | 0;
 i10 = (i9 | 0) < 0;
 i11 = i14 & -4;
 i8 = i3;
 while (1) {
  i8 = i8 + -1 | 0;
  if (i10) i4 = 0; else {
   i7 = 0;
   do {
    i4 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i5 + i7 >> 0] | 0 | 0)))) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    i2 = i7 | 1;
    i3 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i5 + i2 >> 0] | 0 | 0)))) | 0;
    if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
    HEAP8[i6 + i7 >> 0] = i4;
    HEAP8[i6 + i2 >> 0] = i3;
    i1 = i7 | 2;
    i4 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i5 + i1 >> 0] | 0 | 0)))) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    i2 = i7 | 3;
    i3 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i5 + i2 >> 0] | 0 | 0)))) | 0;
    if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
    HEAP8[i6 + i1 >> 0] = i4;
    HEAP8[i6 + i2 >> 0] = i3;
    i7 = i7 + 4 | 0;
   } while ((i7 | 0) <= (i9 | 0));
   i4 = i11;
  }
  if ((i4 | 0) < (i14 | 0)) do {
   i3 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i5 + i4 >> 0] | 0 | 0)))) | 0;
   if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
   HEAP8[i6 + i4 >> 0] = i3;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i14 | 0));
  if (!i8) break; else {
   i5 = i5 + i17 | 0;
   i6 = i6 + i16 | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN2cvL13cvtScale8u16uEPKhjS1_jPtjNS_5Size_IiEEPd(i6, i17, i1, i2, i7, i5, i3, i4) {
 i6 = i6 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 1;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU8[i6 + i8 >> 0] | 0 | 0)))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i2 = i8 | 1;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU8[i6 + i2 >> 0] | 0 | 0)))) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    HEAP16[i7 + (i8 << 1) >> 1] = i5;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i1 = i8 | 2;
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU8[i6 + i1 >> 0] | 0 | 0)))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i2 = i8 | 3;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU8[i6 + i2 >> 0] | 0 | 0)))) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    HEAP16[i7 + (i1 << 1) >> 1] = i5;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU8[i6 + i5 >> 0] | 0 | 0)))) | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i7 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + i17 | 0;
   i7 = i7 + (i9 << 1) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i11, i4) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 i9 = i11 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = ((HEAP32[i9 >> 2] | 0) - i1 >> 3) + 1 | 0;
 if (i3 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i10 = i11 + 8 | 0;
 i2 = (HEAP32[i10 >> 2] | 0) - i1 | 0;
 if (i2 >> 3 >>> 0 < 268435455) {
  i2 = i2 >> 2;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i3 = (HEAP32[i9 >> 2] | 0) - i1 >> 3;
  if (!i2) {
   i1 = 0;
   i8 = 0;
  } else i6 = 6;
 } else {
  i2 = 536870911;
  i3 = (HEAP32[i9 >> 2] | 0) - i1 >> 3;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i1 = i2;
  i8 = __Znwj(i2 << 3) | 0;
 }
 i2 = i8 + (i3 << 3) | 0;
 i7 = i8 + (i1 << 3) | 0;
 if ((i2 | 0) != 0 ? (i5 = HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] = i5, HEAP32[i8 + (i3 << 3) + 4 >> 2] = HEAP32[i4 + 4 >> 2], (i5 | 0) != 0) : 0) {
  i6 = i5 + -4 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 i6 = i8 + (i3 + 1 << 3) | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i3 = i5;
  i1 = i5;
 } else {
  i4 = i3 + -1 - ((i1 + -8 - i5 | 0) >>> 3) | 0;
  while (1) {
   i13 = i1;
   i1 = i1 + -8 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   HEAP32[i2 + -8 >> 2] = i3;
   HEAP32[i2 + -4 >> 2] = HEAP32[i13 + -4 >> 2];
   if (i3) {
    i3 = i3 + -4 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   }
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + -8 | 0;
  }
  i2 = i8 + (i4 << 3) | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i2;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i10 >> 2] = i7;
 while (1) {
  if ((i1 | 0) == (i3 | 0)) break;
  i10 = i1 + -8 | 0;
  __ZN2cv6String10deallocateEv(i10);
  i1 = i10;
 }
 if (!i3) {
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i3);
 STACKTOP = i12;
 return;
}

function __ZNK2cv9MatOp_Bin6divideEdRKNS_7MatExprERS1_(i1, d7, i5, i6) {
 i1 = i1 | 0;
 d7 = +d7;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i8 = i12 + 32 | 0;
 i4 = i12;
 do if ((HEAP32[i5 + 4 >> 2] | 0) == 47) {
  if ((HEAP32[i5 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i5 + 184 >> 3] == 0.0) : 0) break;
  HEAP32[i8 >> 2] = 1124007936;
  i11 = i8 + 4 | 0;
  i2 = i8 + 8 | 0;
  i9 = i8 + 40 | 0;
  i1 = i11 + 0 | 0;
  i3 = i1 + 36 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  HEAP32[i9 >> 2] = i2;
  i10 = i8 + 48 | 0;
  i3 = i8 + 44 | 0;
  HEAP32[i3 >> 2] = i10;
  HEAP32[i8 + 52 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  d13 = +HEAPF64[i5 + 176 >> 3];
  HEAP32[i4 + 0 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i4 + 24 >> 2] = 0;
  HEAP32[i4 + 28 >> 2] = 0;
  HEAPF64[i4 >> 3] = 0.0;
  __ZN2cv11MatOp_AddEx8makeExprERNS_7MatExprERKNS_3MatES5_ddRKNS_7Scalar_IdEE(i6, i5 + 8 | 0, i8, d7 / d13, 0.0, i4);
  i2 = i8 + 36 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i5 = i1 + 12 | 0, i6 = HEAP32[i5 >> 2] | 0, HEAP32[i5 >> 2] = i6 + -1, (i6 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i8);
  HEAP32[i2 >> 2] = 0;
  i8 = i8 + 16 | 0;
  HEAP32[i8 + 0 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  if ((HEAP32[i11 >> 2] | 0) > 0) {
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i1 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i11 >> 2] | 0));
  }
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == (i10 | 0)) {
   STACKTOP = i12;
   return;
  }
  __ZN2cv8fastFreeEPv(i1);
  STACKTOP = i12;
  return;
 } while (0);
 __ZNK2cv5MatOp6divideEdRKNS_7MatExprERS1_(0, d7, i5, i6);
 STACKTOP = i12;
 return;
}

function __ZN2cvL14randnScale_32fEPKfPfiiS1_S1_b(i8, i6, i13, i10, i11, i12, i2) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i14 = 0;
 i14 = STACKTOP;
 if (i2) {
  if ((i13 | 0) <= 0) {
   STACKTOP = i14;
   return;
  }
  i9 = (i10 | 0) > 0;
  i5 = 0;
  while (1) {
   if (i9) {
    i4 = 0;
    do {
     i7 = Math_imul(i4, i10) | 0;
     i2 = 0;
     f3 = Math_fround(HEAPF32[i11 + (i4 << 2) >> 2]);
     do {
      f1 = Math_fround(HEAPF32[i8 + (i2 << 2) >> 2]);
      f3 = Math_fround(f3 + Math_fround(f1 * Math_fround(HEAPF32[i12 + (i2 + i7 << 2) >> 2])));
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i10 | 0));
     HEAPF32[i6 + (i4 << 2) >> 2] = f3;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i10 | 0));
   }
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i13 | 0)) break; else {
    i8 = i8 + (i10 << 2) | 0;
    i6 = i6 + (i10 << 2) | 0;
   }
  }
  STACKTOP = i14;
  return;
 }
 if ((i10 | 0) == 1) {
  f3 = Math_fround(HEAPF32[i11 >> 2]);
  f1 = Math_fround(HEAPF32[i12 >> 2]);
  if ((i13 | 0) > 0) i2 = 0; else {
   STACKTOP = i14;
   return;
  }
  do {
   HEAPF32[i6 + (i2 << 2) >> 2] = Math_fround(f3 + Math_fround(f1 * Math_fround(HEAPF32[i8 + (i2 << 2) >> 2])));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i13 | 0));
  STACKTOP = i14;
  return;
 }
 if ((i13 | 0) <= 0) {
  STACKTOP = i14;
  return;
 }
 i7 = (i10 | 0) > 0;
 i2 = i8;
 i4 = 0;
 while (1) {
  if (i7) {
   i5 = 0;
   do {
    f1 = Math_fround(HEAPF32[i2 + (i5 << 2) >> 2]);
    f1 = Math_fround(f1 * Math_fround(HEAPF32[i12 + (i5 << 2) >> 2]));
    HEAPF32[i6 + (i5 << 2) >> 2] = Math_fround(f1 + Math_fround(HEAPF32[i11 + (i5 << 2) >> 2]));
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i10 | 0));
  }
  i4 = i4 + 1 | 0;
  if ((i4 | 0) == (i13 | 0)) break; else {
   i6 = i6 + (i10 << 2) | 0;
   i2 = i2 + (i10 << 2) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb(i12, i5, i11, i4, i3, i7) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i13 + 20 | 0;
 i1 = i13 + 16 | 0;
 i6 = i13 + 12 | 0;
 i10 = i13;
 if (!(HEAP32[i4 + 4 >> 2] & 1)) {
  i10 = HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i2 + 0 >> 2] = HEAP32[i1 + 0 >> 2];
  FUNCTION_TABLE_viiiiii[i10 & 31](i12, i5, i2, i4, i3, i7 & 1);
  STACKTOP = i13;
  return;
 }
 __ZNKSt3__18ios_base6getlocEv(i6, i4);
 i2 = __ZNKSt3__16locale9use_facetERNS0_2idE(i6, 960872) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i6 >> 2] | 0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i7) FUNCTION_TABLE_vii[HEAP32[i1 + 24 >> 2] & 127](i10, i2); else FUNCTION_TABLE_vii[HEAP32[i1 + 28 >> 2] & 127](i10, i2);
 i2 = HEAP8[i10 >> 0] | 0;
 if (!(i2 & 1)) {
  i7 = i10 + 1 | 0;
  i1 = i7;
  i8 = i10 + 8 | 0;
 } else {
  i8 = i10 + 8 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i7 = i10 + 1 | 0;
 }
 i9 = i10 + 4 | 0;
 while (1) {
  if (!(i2 & 1)) {
   i3 = i7;
   i2 = (i2 & 255) >>> 1;
  } else {
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
  }
  if ((i1 | 0) == (i3 + i2 | 0)) break;
  i6 = HEAP8[i1 >> 0] | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  do if (i5) {
   i4 = i5 + 24 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i3 | 0) != (HEAP32[i5 + 28 >> 2] | 0)) {
    HEAP32[i4 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i6;
    break;
   }
   if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] & 127](i5, i6 & 255) | 0) == -1) HEAP32[i11 >> 2] = 0;
  } while (0);
  i2 = HEAP8[i10 >> 0] | 0;
  i1 = i1 + 1 | 0;
 }
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
 STACKTOP = i13;
 return;
}

function __ZN7testing8internal11CmpHelperLEIjjEENS_15AssertionResultEPKcS4_RKT_RKT0_(i6, i7, i8, i9, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i1 = i12 + 36 | 0;
 i2 = i12 + 32 | 0;
 i3 = i12 + 24 | 0;
 i4 = i12 + 12 | 0;
 i5 = i12;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i2 >> 2] = i8;
 if ((HEAP32[i9 >> 2] | 0) >>> 0 <= (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN7testing16AssertionSuccessEv(i6);
  STACKTOP = i12;
  return;
 }
 __ZN7testing16AssertionFailureEv(i3);
 i1 = __ZN7testing15AssertionResultlsIA12_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(__ZN7testing15AssertionResultlsIA7_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(__ZN7testing15AssertionResultlsIA12_cEERS0_RKT_(i3, 176776) | 0, i1) | 0, 176832) | 0, i2) | 0, 176800) | 0;
 __ZN7testing13PrintToStringIjEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i4, i9);
 i1 = __ZN7testing15AssertionResultlsIA5_cEERS0_RKT_(__ZN7testing15AssertionResultlsINSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEEERS0_RKT_(i1, i4) | 0, 176816) | 0;
 __ZN7testing13PrintToStringIjEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i5, i10);
 __ZN7testing15AssertionResultC2ERKS0_(i6, __ZN7testing15AssertionResultlsINSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEEERS0_RKT_(i1, i5) | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 i1 = i3 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i11 = HEAP32[i1 >> 2] | 0, (i11 | 0) != 0) : 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  __ZdlPv(i11);
 }
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN7testing8internal11CmpHelperGEIjjEENS_15AssertionResultEPKcS4_RKT_RKT0_(i6, i7, i8, i9, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i1 = i12 + 36 | 0;
 i2 = i12 + 32 | 0;
 i3 = i12 + 24 | 0;
 i4 = i12 + 12 | 0;
 i5 = i12;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i2 >> 2] = i8;
 if ((HEAP32[i9 >> 2] | 0) >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN7testing16AssertionSuccessEv(i6);
  STACKTOP = i12;
  return;
 }
 __ZN7testing16AssertionFailureEv(i3);
 i1 = __ZN7testing15AssertionResultlsIA12_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(__ZN7testing15AssertionResultlsIA7_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(__ZN7testing15AssertionResultlsIA12_cEERS0_RKT_(i3, 176776) | 0, i1) | 0, 176824) | 0, i2) | 0, 176800) | 0;
 __ZN7testing13PrintToStringIjEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i4, i9);
 i1 = __ZN7testing15AssertionResultlsIA5_cEERS0_RKT_(__ZN7testing15AssertionResultlsINSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEEERS0_RKT_(i1, i4) | 0, 176816) | 0;
 __ZN7testing13PrintToStringIjEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i5, i10);
 __ZN7testing15AssertionResultC2ERKS0_(i6, __ZN7testing15AssertionResultlsINSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEEERS0_RKT_(i1, i5) | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 i1 = i3 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i11 = HEAP32[i1 >> 2] | 0, (i11 | 0) != 0) : 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  __ZdlPv(i11);
 }
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZNSt3__16vectorINS0_IhNS_9allocatorIhEEEENS1_IS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS4_EE(i14, i13) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 i8 = HEAP32[i14 >> 2] | 0;
 i9 = i14 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i10 = i13 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 do if ((i1 | 0) != (i8 | 0)) {
  while (1) {
   i6 = i2 + -12 | 0;
   HEAP32[i6 >> 2] = 0;
   i7 = i2 + -8 | 0;
   HEAP32[i7 >> 2] = 0;
   i4 = i2 + -4 | 0;
   HEAP32[i4 >> 2] = 0;
   i5 = i1 + -8 | 0;
   i1 = i1 + -12 | 0;
   i16 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = i16 - i2 | 0;
   if ((i16 | 0) != (i2 | 0)) {
    if ((i3 | 0) < 0) {
     i1 = 4;
     break;
    }
    i2 = __Znwj(i3) | 0;
    HEAP32[i7 >> 2] = i2;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i4 >> 2] = i2 + i3;
    i3 = HEAP32[i1 >> 2] | 0;
    i5 = HEAP32[i5 >> 2] | 0;
    if ((i3 | 0) != (i5 | 0)) do {
     if (!i2) i2 = 0; else {
      HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
      i2 = HEAP32[i7 >> 2] | 0;
     }
     i2 = i2 + 1 | 0;
     HEAP32[i7 >> 2] = i2;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i5 | 0));
   }
   i2 = (HEAP32[i10 >> 2] | 0) + -12 | 0;
   HEAP32[i10 >> 2] = i2;
   if ((i1 | 0) == (i8 | 0)) {
    i1 = 10;
    break;
   }
  }
  if ((i1 | 0) == 4) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i6); else if ((i1 | 0) == 10) {
   i11 = i2;
   i12 = HEAP32[i14 >> 2] | 0;
   break;
  }
 } else {
  i11 = i2;
  i12 = i8;
 } while (0);
 HEAP32[i14 >> 2] = i11;
 HEAP32[i10 >> 2] = i12;
 i7 = i13 + 8 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i8;
 i7 = i14 + 8 | 0;
 i9 = i13 + 12 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i8;
 HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
 STACKTOP = i15;
 return;
}

function _cvSeqPop(i11, i3) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i12 + 8 | 0;
 i2 = i12;
 if (!i11) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40240, 39608, 1168);
  __ZN2cv6String10deallocateEv(i1);
 }
 i10 = i11 + 24 | 0;
 if ((HEAP32[i10 >> 2] | 0) < 1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i2, 40240, 39608, 1170);
  __ZN2cv6String10deallocateEv(i2);
 }
 i9 = i11 + 28 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i7 = i11 + 36 | 0;
 i8 = (HEAP32[i7 >> 2] | 0) + (0 - i2) | 0;
 HEAP32[i7 >> 2] = i8;
 if (i3) _memcpy(i3 | 0, i8 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
 i3 = i11 + 52 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i1 + 12 | 0;
 i6 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 HEAP32[i4 >> 2] = i6;
 if (i6) {
  STACKTOP = i12;
  return;
 }
 i5 = i11 + 32 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i1 = i2 + 16 | 0;
  i9 = (Math_imul(HEAP32[i9 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0) | 0) + (i6 - (HEAP32[i1 >> 2] | 0)) | 0;
  HEAP32[i2 + 12 >> 2] = i9;
  HEAP32[i1 >> 2] = i6 + (0 - i9);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i1 = i2;
 } else {
  HEAP32[i4 >> 2] = i6 - i8;
  i8 = HEAP32[i1 >> 2] | 0;
  i10 = (HEAP32[i8 + 16 >> 2] | 0) + (Math_imul(HEAP32[i9 >> 2] | 0, HEAP32[i8 + 12 >> 2] | 0) | 0) | 0;
  HEAP32[i7 >> 2] = i10;
  HEAP32[i5 >> 2] = i10;
  i10 = i1 + 4 | 0;
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[HEAP32[i10 >> 2] >> 2] = i8;
 }
 i10 = i11 + 48 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZN2cvL13cvtScale16u8uEPKtjPKhjPhjNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i17, i3, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 1;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i6 + (i8 << 1) >> 1] | 0 | 0)))) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i2 = i8 | 1;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i6 + (i2 << 1) >> 1] | 0 | 0)))) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i8 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i1 = i8 | 2;
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i6 + (i1 << 1) >> 1] | 0 | 0)))) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i2 = i8 | 3;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i6 + (i2 << 1) >> 1] | 0 | 0)))) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i6 + (i5 << 1) >> 1] | 0 | 0)))) | 0;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + (i9 << 1) | 0;
   i7 = i7 + i17 | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZNSt3__16vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPFN7testing8internal14ParamGeneratorINSt3tr15tupleIN2cv5Size_IiEEN4perf7MatTypeEvvvvvvvvEEEEvEEENS5_ISM_EEE21__push_back_slow_pathIKSM_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 i7 = i9 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((HEAP32[i7 >> 2] | 0) - i1 >> 4) + 1 | 0;
 if (i3 >>> 0 > 268435455) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i8 = i9 + 8 | 0;
 i2 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 if (i2 >> 4 >>> 0 < 134217727) {
  i2 = i2 >> 3;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = (HEAP32[i7 >> 2] | 0) - i1 >> 4;
  if (!i2) {
   i4 = 0;
   i2 = 0;
   i3 = i1;
  } else i6 = 6;
 } else {
  i2 = 268435455;
  i1 = (HEAP32[i7 >> 2] | 0) - i1 >> 4;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i4 = i2;
  i2 = __Znwj(i2 << 4) | 0;
  i3 = i1;
 }
 i1 = i2 + (i3 << 4) | 0;
 i6 = i2 + (i4 << 4) | 0;
 if (i1) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1, i5);
  HEAP32[i2 + (i3 << 4) + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 }
 i5 = i2 + (i3 + 1 << 4) | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) {
  i2 = i1;
  i3 = i4;
  i1 = i4;
 } else {
  do {
   i3 = i2;
   i2 = i2 + -16 | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1 + -16 | 0, i2);
   HEAP32[i1 + -4 >> 2] = HEAP32[i3 + -4 >> 2];
   i1 = i1 + -16 | 0;
  } while ((i2 | 0) != (i4 | 0));
  i2 = i1;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i8 >> 2] = i6;
 while (1) {
  if ((i1 | 0) == (i3 | 0)) break;
  i2 = i1 + -16 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
  i1 = i2;
 }
 if (!i3) {
  STACKTOP = i10;
  return;
 }
 __ZdlPv(i3);
 STACKTOP = i10;
 return;
}

function __ZN2cv3oclL5crc64EPKhjy(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 if (!(HEAP8[46496] | 0)) {
  i1 = 0;
  do {
   i7 = (i1 & 1 | 0) != 0 | 0 != 0;
   i2 = _bitshift64Lshr(i1 | 0, ((i1 | 0) < 0) << 31 >> 31 | 0, 1) | 0;
   i3 = (i2 & 1 | 0) != 0 | 0 != 0;
   i7 = _bitshift64Lshr((i7 ? -679014590 : 0) ^ i2 | 0, (i7 ? -915646571 : 0) ^ tempRet0 | 0, 1) | 0;
   i2 = (i7 & 1 | 0) != 0 | 0 != 0;
   i3 = _bitshift64Lshr((i3 ? -679014590 : 0) ^ i7 | 0, (i3 ? -915646571 : 0) ^ tempRet0 | 0, 1) | 0;
   i7 = (i3 & 1 | 0) != 0 | 0 != 0;
   i2 = _bitshift64Lshr((i2 ? -679014590 : 0) ^ i3 | 0, (i2 ? -915646571 : 0) ^ tempRet0 | 0, 1) | 0;
   i3 = (i2 & 1 | 0) != 0 | 0 != 0;
   i7 = _bitshift64Lshr((i7 ? -679014590 : 0) ^ i2 | 0, (i7 ? -915646571 : 0) ^ tempRet0 | 0, 1) | 0;
   i2 = (i7 & 1 | 0) != 0 | 0 != 0;
   i3 = _bitshift64Lshr((i3 ? -679014590 : 0) ^ i7 | 0, (i3 ? -915646571 : 0) ^ tempRet0 | 0, 1) | 0;
   i7 = (i3 & 1 | 0) != 0 | 0 != 0;
   i2 = _bitshift64Lshr((i2 ? -679014590 : 0) ^ i3 | 0, (i2 ? -915646571 : 0) ^ tempRet0 | 0, 1) | 0;
   i3 = (i2 & 1 | 0) != 0 | 0 != 0;
   i7 = _bitshift64Lshr((i7 ? -679014590 : 0) ^ i2 | 0, (i7 ? -915646571 : 0) ^ tempRet0 | 0, 1) | 0;
   i2 = 44448 + (i1 << 3) | 0;
   HEAP32[i2 >> 2] = (i3 ? -679014590 : 0) ^ i7;
   HEAP32[i2 + 4 >> 2] = (i3 ? -915646571 : 0) ^ tempRet0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 256);
  HEAP8[46496] = 1;
 }
 if (!i5) {
  i2 = 0;
  i1 = 0;
  tempRet0 = i2;
  STACKTOP = i6;
  return i1 | 0;
 } else {
  i1 = -1;
  i2 = -1;
  i3 = 0;
 }
 do {
  i7 = 44448 + ((HEAPU8[i4 + i3 >> 0] ^ i2 & 255) << 3) | 0;
  i9 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i8 = _bitshift64Lshr(i2 | 0, i1 | 0, 8) | 0;
  i2 = i9 ^ i8;
  i1 = i7 ^ tempRet0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i5 | 0));
 i3 = ~i1;
 i1 = ~i2;
 tempRet0 = i3;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN2cv6vBinOpIsNS_5OpMinIsEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 1;
 i10 = i3 >>> 1;
 i9 = i4 >>> 1;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    i8 = HEAP16[i1 + (i3 << 1) >> 1] | 0;
    i7 = HEAP16[i5 + (i3 << 1) >> 1] | 0;
    i18 = i3 | 1;
    i19 = HEAP16[i1 + (i18 << 1) >> 1] | 0;
    i20 = HEAP16[i5 + (i18 << 1) >> 1] | 0;
    HEAP16[i6 + (i3 << 1) >> 1] = i7 << 16 >> 16 < i8 << 16 >> 16 ? i7 : i8;
    HEAP16[i6 + (i18 << 1) >> 1] = i20 << 16 >> 16 < i19 << 16 >> 16 ? i20 : i19;
    i18 = i3 | 2;
    i19 = HEAP16[i1 + (i18 << 1) >> 1] | 0;
    i20 = HEAP16[i5 + (i18 << 1) >> 1] | 0;
    i8 = i3 | 3;
    i7 = HEAP16[i1 + (i8 << 1) >> 1] | 0;
    i17 = HEAP16[i5 + (i8 << 1) >> 1] | 0;
    HEAP16[i6 + (i18 << 1) >> 1] = i20 << 16 >> 16 < i19 << 16 >> 16 ? i20 : i19;
    HEAP16[i6 + (i8 << 1) >> 1] = i17 << 16 >> 16 < i7 << 16 >> 16 ? i17 : i7;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   i8 = HEAP16[i1 + (i2 << 1) >> 1] | 0;
   i7 = HEAP16[i5 + (i2 << 1) >> 1] | 0;
   HEAP16[i6 + (i2 << 1) >> 1] = i7 << 16 >> 16 < i8 << 16 >> 16 ? i7 : i8;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 1) | 0;
   i6 = i6 + (i9 << 1) | 0;
   i1 = i1 + (i11 << 1) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZN2cv6vBinOpIsNS_5OpMaxIsEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 1;
 i10 = i3 >>> 1;
 i9 = i4 >>> 1;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    i8 = HEAP16[i1 + (i3 << 1) >> 1] | 0;
    i7 = HEAP16[i5 + (i3 << 1) >> 1] | 0;
    i18 = i3 | 1;
    i19 = HEAP16[i1 + (i18 << 1) >> 1] | 0;
    i20 = HEAP16[i5 + (i18 << 1) >> 1] | 0;
    HEAP16[i6 + (i3 << 1) >> 1] = i8 << 16 >> 16 < i7 << 16 >> 16 ? i7 : i8;
    HEAP16[i6 + (i18 << 1) >> 1] = i19 << 16 >> 16 < i20 << 16 >> 16 ? i20 : i19;
    i18 = i3 | 2;
    i19 = HEAP16[i1 + (i18 << 1) >> 1] | 0;
    i20 = HEAP16[i5 + (i18 << 1) >> 1] | 0;
    i8 = i3 | 3;
    i7 = HEAP16[i1 + (i8 << 1) >> 1] | 0;
    i17 = HEAP16[i5 + (i8 << 1) >> 1] | 0;
    HEAP16[i6 + (i18 << 1) >> 1] = i19 << 16 >> 16 < i20 << 16 >> 16 ? i20 : i19;
    HEAP16[i6 + (i8 << 1) >> 1] = i7 << 16 >> 16 < i17 << 16 >> 16 ? i17 : i7;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   i8 = HEAP16[i1 + (i2 << 1) >> 1] | 0;
   i7 = HEAP16[i5 + (i2 << 1) >> 1] | 0;
   HEAP16[i6 + (i2 << 1) >> 1] = i8 << 16 >> 16 < i7 << 16 >> 16 ? i7 : i8;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 1) | 0;
   i6 = i6 + (i9 << 1) | 0;
   i1 = i1 + (i11 << 1) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZN2cvL13cvtScale8s16uEPKajPKhjPtjNS_5Size_IiEEPd(i6, i17, i1, i2, i7, i5, i3, i4) {
 i6 = i6 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 1;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP8[i6 + i8 >> 0] | 0)))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i2 = i8 | 1;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP8[i6 + i2 >> 0] | 0)))) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    HEAP16[i7 + (i8 << 1) >> 1] = i5;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i1 = i8 | 2;
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP8[i6 + i1 >> 0] | 0)))) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i2 = i8 | 3;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP8[i6 + i2 >> 0] | 0)))) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    HEAP16[i7 + (i1 << 1) >> 1] = i5;
    HEAP16[i7 + (i2 << 1) >> 1] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP8[i6 + i5 >> 0] | 0)))) | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i7 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + i17 | 0;
   i7 = i7 + (i9 << 1) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cvL13copyMask32sC2EPKhjS1_jPhjNS_5Size_IiEEPv(i5, i14, i3, i13, i4, i12, i2, i1) {
 i5 = i5 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 i10 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = i10 & -4;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i2 = 0; else {
   i1 = 0;
   do {
    if (HEAP8[i3 + i1 >> 0] | 0) {
     i16 = i5 + (i1 << 3) | 0;
     i15 = HEAP32[i16 + 4 >> 2] | 0;
     i2 = i4 + (i1 << 3) | 0;
     HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i2 + 4 >> 2] = i15;
    }
    i2 = i1 | 1;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i16 = i5 + (i2 << 3) | 0;
     i15 = HEAP32[i16 + 4 >> 2] | 0;
     i2 = i4 + (i2 << 3) | 0;
     HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i2 + 4 >> 2] = i15;
    }
    i2 = i1 | 2;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i16 = i5 + (i2 << 3) | 0;
     i15 = HEAP32[i16 + 4 >> 2] | 0;
     i2 = i4 + (i2 << 3) | 0;
     HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i2 + 4 >> 2] = i15;
    }
    i2 = i1 | 3;
    if (HEAP8[i3 + i2 >> 0] | 0) {
     i16 = i5 + (i2 << 3) | 0;
     i15 = HEAP32[i16 + 4 >> 2] | 0;
     i2 = i4 + (i2 << 3) | 0;
     HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i2 + 4 >> 2] = i15;
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i7 | 0));
   i2 = i9;
  }
  if ((i2 | 0) < (i10 | 0)) do {
   if (HEAP8[i3 + i2 >> 0] | 0) {
    i16 = i5 + (i2 << 3) | 0;
    i15 = HEAP32[i16 + 4 >> 2] | 0;
    i1 = i4 + (i2 << 3) | 0;
    HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i1 + 4 >> 2] = i15;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
  if (!i6) break; else {
   i3 = i3 + i13 | 0;
   i4 = i4 + i12 | 0;
   i5 = i5 + i14 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cv8vBinOp32IfNS_5OpMinIfEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 2;
 i10 = i3 >>> 2;
 i9 = i4 >>> 2;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    f17 = Math_fround(HEAPF32[i1 + (i3 << 2) >> 2]);
    f18 = Math_fround(HEAPF32[i5 + (i3 << 2) >> 2]);
    i7 = i3 | 1;
    f19 = Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]);
    f20 = Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]);
    HEAPF32[i6 + (i3 << 2) >> 2] = f18 < f17 ? f18 : f17;
    HEAPF32[i6 + (i7 << 2) >> 2] = f20 < f19 ? f20 : f19;
    i7 = i3 | 2;
    f19 = Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]);
    f20 = Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]);
    i8 = i3 | 3;
    f17 = Math_fround(HEAPF32[i1 + (i8 << 2) >> 2]);
    f18 = Math_fround(HEAPF32[i5 + (i8 << 2) >> 2]);
    HEAPF32[i6 + (i7 << 2) >> 2] = f20 < f19 ? f20 : f19;
    HEAPF32[i6 + (i8 << 2) >> 2] = f18 < f17 ? f18 : f17;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   f17 = Math_fround(HEAPF32[i1 + (i2 << 2) >> 2]);
   f18 = Math_fround(HEAPF32[i5 + (i2 << 2) >> 2]);
   HEAPF32[i6 + (i2 << 2) >> 2] = f18 < f17 ? f18 : f17;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 2) | 0;
   i6 = i6 + (i9 << 2) | 0;
   i1 = i1 + (i11 << 2) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZN2cv8vBinOp32IfNS_5OpMaxIfEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 2;
 i10 = i3 >>> 2;
 i9 = i4 >>> 2;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    f17 = Math_fround(HEAPF32[i1 + (i3 << 2) >> 2]);
    f18 = Math_fround(HEAPF32[i5 + (i3 << 2) >> 2]);
    i7 = i3 | 1;
    f19 = Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]);
    f20 = Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]);
    HEAPF32[i6 + (i3 << 2) >> 2] = f17 < f18 ? f18 : f17;
    HEAPF32[i6 + (i7 << 2) >> 2] = f19 < f20 ? f20 : f19;
    i7 = i3 | 2;
    f19 = Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]);
    f20 = Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]);
    i8 = i3 | 3;
    f17 = Math_fround(HEAPF32[i1 + (i8 << 2) >> 2]);
    f18 = Math_fround(HEAPF32[i5 + (i8 << 2) >> 2]);
    HEAPF32[i6 + (i7 << 2) >> 2] = f19 < f20 ? f20 : f19;
    HEAPF32[i6 + (i8 << 2) >> 2] = f17 < f18 ? f18 : f17;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   f17 = Math_fround(HEAPF32[i1 + (i2 << 2) >> 2]);
   f18 = Math_fround(HEAPF32[i5 + (i2 << 2) >> 2]);
   HEAPF32[i6 + (i2 << 2) >> 2] = f17 < f18 ? f18 : f17;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 2) | 0;
   i6 = i6 + (i9 << 2) | 0;
   i1 = i1 + (i11 << 2) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZN2cv3MataSERKNS_7Scalar_IdEE(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 i1 = i9 + 132 | 0;
 i6 = i9 + 128 | 0;
 i7 = i9 + 96 | 0;
 i4 = i9;
 HEAP32[i1 >> 2] = i8;
 __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i7, i1, i6, 1);
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 if ((i1 | 0) > 0) i1 = HEAP32[(HEAP32[i8 + 44 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0; else i1 = 0;
 i5 = Math_imul(i1, HEAP32[i7 + 20 >> 2] | 0) | 0;
 i1 = i2;
 if ((((HEAP32[i1 >> 2] | 0) == 0 & (HEAP32[i1 + 4 >> 2] | 0) == 0 ? (i1 = i2 + 8 | 0, (HEAP32[i1 >> 2] | 0) == 0 & (HEAP32[i1 + 4 >> 2] | 0) == 0) : 0) ? (i1 = i2 + 16 | 0, (HEAP32[i1 >> 2] | 0) == 0 & (HEAP32[i1 + 4 >> 2] | 0) == 0) : 0) ? (i1 = i2 + 24 | 0, (HEAP32[i1 >> 2] | 0) == 0 & (HEAP32[i1 + 4 >> 2] | 0) == 0) : 0) {
  i1 = i7 + 16 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   STACKTOP = i9;
   return i8 | 0;
  } else i2 = 0;
  do {
   _memset(HEAP32[i6 >> 2] | 0, 0, i5 | 0) | 0;
   i2 = i2 + 1 | 0;
   __ZN2cv15NAryMatIteratorppEv(i7) | 0;
  } while (i2 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i7 + 16 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i9;
  return i8 | 0;
 }
 __ZN2cv15scalarToRawDataERKNS_7Scalar_IdEEPvii(i2, i4, HEAP32[i8 >> 2] & 4095, 12);
 i2 = (1212424721 >>> (HEAP32[i8 >> 2] << 2 & 28) & 15) * 12 | 0;
 if (i5) {
  i1 = 0;
  do {
   i10 = i5 - i1 | 0;
   _memcpy((HEAP32[i6 >> 2] | 0) + i1 | 0, i4 | 0, (i2 >>> 0 > i10 >>> 0 ? i10 : i2) | 0) | 0;
   i1 = i1 + i2 | 0;
  } while (i5 >>> 0 > i1 >>> 0);
 }
 if ((HEAP32[i3 >> 2] | 0) >>> 0 <= 1) {
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = i8 + 16 | 0;
 i1 = 1;
 do {
  __ZN2cv15NAryMatIteratorppEv(i7) | 0;
  _memcpy(HEAP32[i6 >> 2] | 0, HEAP32[i2 >> 2] | 0, i5 | 0) | 0;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN7testing8internal11CmpHelperLEIiiEENS_15AssertionResultEPKcS4_RKT_RKT0_(i6, i7, i8, i9, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i1 = i12 + 36 | 0;
 i2 = i12 + 32 | 0;
 i3 = i12 + 24 | 0;
 i4 = i12 + 12 | 0;
 i5 = i12;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i2 >> 2] = i8;
 if ((HEAP32[i9 >> 2] | 0) <= (HEAP32[i10 >> 2] | 0)) {
  __ZN7testing16AssertionSuccessEv(i6);
  STACKTOP = i12;
  return;
 }
 __ZN7testing16AssertionFailureEv(i3);
 i1 = __ZN7testing15AssertionResultlsIA12_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(__ZN7testing15AssertionResultlsIA7_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(__ZN7testing15AssertionResultlsIA12_cEERS0_RKT_(i3, 159152) | 0, i1) | 0, 159168) | 0, i2) | 0, 159176) | 0;
 __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i4, i9);
 i1 = __ZN7testing15AssertionResultlsIA5_cEERS0_RKT_(__ZN7testing15AssertionResultlsINSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEEERS0_RKT_(i1, i4) | 0, 159192) | 0;
 __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i5, i10);
 __ZN7testing15AssertionResultC2ERKS0_(i6, __ZN7testing15AssertionResultlsINSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEEERS0_RKT_(i1, i5) | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 i1 = i3 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i11 = HEAP32[i1 >> 2] | 0, (i11 | 0) != 0) : 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  __ZdlPv(i11);
 }
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN2cvL10cvtScale8sEPKajPKhjPajNS_5Size_IiEEPd(i5, i17, i1, i2, i6, i16, i3, i4) {
 i5 = i5 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i16 = i16 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 i14 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f13 = Math_fround(+HEAPF64[i4 >> 3]);
 f12 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 i9 = i14 + -4 | 0;
 i10 = (i9 | 0) < 0;
 i11 = i14 & -4;
 i8 = i3;
 while (1) {
  i8 = i8 + -1 | 0;
  if (i10) i4 = 0; else {
   i7 = 0;
   do {
    i4 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i5 + i7 >> 0] | 0)))) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    i2 = i7 | 1;
    i3 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i5 + i2 >> 0] | 0)))) | 0;
    if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
    HEAP8[i6 + i7 >> 0] = i4;
    HEAP8[i6 + i2 >> 0] = i3;
    i1 = i7 | 2;
    i4 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i5 + i1 >> 0] | 0)))) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    i2 = i7 | 3;
    i3 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i5 + i2 >> 0] | 0)))) | 0;
    if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
    HEAP8[i6 + i1 >> 0] = i4;
    HEAP8[i6 + i2 >> 0] = i3;
    i7 = i7 + 4 | 0;
   } while ((i7 | 0) <= (i9 | 0));
   i4 = i11;
  }
  if ((i4 | 0) < (i14 | 0)) do {
   i3 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i5 + i4 >> 0] | 0)))) | 0;
   if ((i3 + 128 | 0) >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 127 : -128;
   HEAP8[i6 + i4 >> 0] = i3;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i14 | 0));
  if (!i8) break; else {
   i5 = i5 + i17 | 0;
   i6 = i6 + i16 | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZNSt3__17__sort5IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_S5_T_(i9, i10, i7, i6, i5, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 i8 = __ZNSt3__17__sort4IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_T_(i9, i10, i7, i6, i1) | 0;
 i2 = i5;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!((i2 | 0) < (i4 | 0) | (i2 | 0) == (i4 | 0) & i3 >>> 0 < i1 >>> 0)) {
  i10 = i8;
  STACKTOP = i11;
  return i10 | 0;
 }
 i12 = i6;
 HEAP32[i12 >> 2] = i3;
 HEAP32[i12 + 4 >> 2] = i2;
 i3 = i5;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i6;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i7;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!((i3 | 0) < (i1 | 0) | (i3 | 0) == (i1 | 0) & i4 >>> 0 < i2 >>> 0)) {
  i10 = i8 + 1 | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i5 = i7;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i5 + 4 >> 2] = i3;
 i3 = i6;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i1;
 i3 = i7;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!((i3 | 0) < (i1 | 0) | (i3 | 0) == (i1 | 0) & i4 >>> 0 < i2 >>> 0)) {
  i10 = i8 + 2 | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i6 = i10;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i6 + 4 >> 2] = i3;
 i4 = i7;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i1;
 i2 = i10;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i9;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!((i2 | 0) < (i4 | 0) | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0)) {
  i10 = i8 + 3 | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 4 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i10 + 4 >> 2] = i4;
 i10 = i8 + 4 | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN7testing8internal11CmpHelperGTIddEENS_15AssertionResultEPKcS4_RKT_RKT0_(i6, i7, i8, i9, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i1 = i12 + 36 | 0;
 i2 = i12 + 32 | 0;
 i3 = i12 + 24 | 0;
 i4 = i12 + 12 | 0;
 i5 = i12;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i2 >> 2] = i8;
 if (+HEAPF64[i9 >> 3] > +HEAPF64[i10 >> 3]) {
  __ZN7testing16AssertionSuccessEv(i6);
  STACKTOP = i12;
  return;
 }
 __ZN7testing16AssertionFailureEv(i3);
 i1 = __ZN7testing15AssertionResultlsIA12_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(__ZN7testing15AssertionResultlsIA6_cEERS0_RKT_(__ZN7testing15AssertionResultlsIPKcEERS0_RKT_(__ZN7testing15AssertionResultlsIA12_cEERS0_RKT_(i3, 176776) | 0, i1) | 0, 176792) | 0, i2) | 0, 176800) | 0;
 __ZN7testing13PrintToStringIdEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i4, i9);
 i1 = __ZN7testing15AssertionResultlsIA5_cEERS0_RKT_(__ZN7testing15AssertionResultlsINSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEEERS0_RKT_(i1, i4) | 0, 176816) | 0;
 __ZN7testing13PrintToStringIdEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i5, i10);
 __ZN7testing15AssertionResultC2ERKS0_(i6, __ZN7testing15AssertionResultlsINSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEEERS0_RKT_(i1, i5) | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 i1 = i3 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i11 = HEAP32[i1 >> 2] | 0, (i11 | 0) != 0) : 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
  __ZdlPv(i11);
 }
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function _cvCreateHist(i7, i9, i10, i8, i11) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i1 = i12 + 16 | 0;
 i2 = i12 + 8 | 0;
 i6 = i12;
 if (i7 >>> 0 > 32) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i1, 36) | 0) + 0 | 0;
  i4 = 701664 | 0;
  i5 = i3 + 36 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-19, i1, 701704, 701600, 2503);
  __ZN2cv6String10deallocateEv(i1);
 }
 if (!i9) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i2, 20) | 0) + 0 | 0;
  i4 = 701720 | 0;
  i5 = i3 + 20 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-9, i2, 701704, 701600, 2506);
  __ZN2cv6String10deallocateEv(i2);
 }
 i2 = _cvAlloc(544) | 0;
 HEAP32[i2 >> 2] = ((i11 | 0) == 0 ? 1111818240 : 1111819264) | i10 & 1;
 HEAP32[i2 + 264 >> 2] = 0;
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 if ((i10 | 0) == 1) HEAP32[i1 >> 2] = _cvCreateSparseMat(i7, i9, 5) | 0; else if (!i10) {
  i10 = _cvInitMatNDHeader(i2 + 268 | 0, i7, i9, 5, 0) | 0;
  HEAP32[i1 >> 2] = i10;
  _cvCreateData(i10);
 } else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i6, 22) | 0) + 0 | 0;
  i4 = 701744 | 0;
  i5 = i3 + 22 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i6, 701704, 701600, 2522);
  __ZN2cv6String10deallocateEv(i6);
 }
 if (!i8) {
  STACKTOP = i12;
  return i2 | 0;
 }
 _cvSetHistBinRanges(i2, i8, i11);
 STACKTOP = i12;
 return i2 | 0;
}

function __ZNSt3__16vectorIN2cv3VecIiLi2EEENS_9allocatorIS3_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 i9 = i10 + 8 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1;
 if (i4 - i3 >> 3 >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i1 = i1 + 8 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = (i3 - i1 >> 3) + i2 | 0;
 if (i3 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i5 = i1;
 i1 = i4 - i5 | 0;
 if (i1 >> 3 >>> 0 < 268435455) {
  i1 = i1 >> 2;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = (HEAP32[i11 >> 2] | 0) - i5 >> 3;
  if (!i1) {
   i5 = 0;
   i8 = 0;
   i7 = i3;
  } else i6 = 10;
 } else {
  i1 = 536870911;
  i3 = (HEAP32[i11 >> 2] | 0) - i5 >> 3;
  i6 = 10;
 }
 if ((i6 | 0) == 10) {
  i5 = i1;
  i8 = __Znwj(i1 << 3) | 0;
  i7 = i3;
 }
 i1 = i8 + (i7 << 3) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else {
   i6 = i3;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
  }
  i3 = i3 + 8 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = i8 + (i5 << 3) | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  i4 = i5 + -8 - i2 | 0;
  while (1) {
   i13 = i5;
   i5 = i5 + -8 | 0;
   HEAP32[i1 + -8 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i13 + -4 >> 2];
   if ((i5 | 0) == (i2 | 0)) break; else i1 = i1 + -8 | 0;
  }
  i1 = i8 + (i7 + ~(i4 >>> 3) << 3) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i12;
 return;
}

function __ZN7testing4TestC2Ev(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 HEAP32[i9 >> 2] = 160816;
 i1 = __Znwj(120) | 0;
 i2 = i1 + 4 | 0;
 i3 = i1 + 16 | 0;
 i4 = i1 + 32 | 0;
 i5 = i1 + 44 | 0;
 i6 = i1 + 56 | 0;
 i7 = i1 + 72 | 0;
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i8 = i1 + 104 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 i10 = i4 + 0 | 0;
 i12 = i10 + 36 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP8[i1 >> 0] = HEAP8[159752] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[159784] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[159816] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, 159848) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, 164592) | 0;
 HEAP8[i1 + 28 >> 0] = HEAP8[164640] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i4, 159880) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5, 159904) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i6, 163824) | 0;
 HEAP8[i1 + 68 >> 0] = HEAP8[159936] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, 159944) | 0;
 HEAP8[i1 + 84 >> 0] = HEAP8[159976] | 0;
 HEAP32[i1 + 88 >> 2] = HEAP32[4e4];
 HEAP32[i1 + 92 >> 2] = HEAP32[40006];
 HEAP8[i1 + 96 >> 0] = HEAP8[160040] | 0;
 HEAP32[i1 + 100 >> 2] = HEAP32[40014];
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8, 160088) | 0;
 HEAP8[i1 + 116 >> 0] = HEAP8[160128] | 0;
 HEAP32[i9 + 4 >> 2] = i1;
 STACKTOP = i11;
 return;
}

function __ZN7testing8internal14GTestFlagSaverD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = STACKTOP;
 HEAP8[159752] = HEAP8[i1 >> 0] | 0;
 HEAP8[159784] = HEAP8[i1 + 1 >> 0] | 0;
 HEAP8[159816] = HEAP8[i1 + 2 >> 0] | 0;
 i3 = i1 + 4 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(159848, i3) | 0;
 i4 = i1 + 16 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(164592, i4) | 0;
 HEAP8[164640] = HEAP8[i1 + 28 >> 0] | 0;
 i5 = i1 + 32 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(159880, i5) | 0;
 i6 = i1 + 44 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(159904, i6) | 0;
 i7 = i1 + 56 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(163824, i7) | 0;
 HEAP8[159936] = HEAP8[i1 + 68 >> 0] | 0;
 i8 = i1 + 72 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(159944, i8) | 0;
 HEAP8[159976] = HEAP8[i1 + 84 >> 0] | 0;
 HEAP32[4e4] = HEAP32[i1 + 88 >> 2];
 HEAP32[40006] = HEAP32[i1 + 92 >> 2];
 HEAP8[160040] = HEAP8[i1 + 96 >> 0] | 0;
 HEAP32[40014] = HEAP32[i1 + 100 >> 2];
 i9 = i1 + 104 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(160088, i9) | 0;
 HEAP8[160128] = HEAP8[i1 + 116 >> 0] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZN2cv6vBinOpItNS_5OpMinItEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 1;
 i10 = i3 >>> 1;
 i9 = i4 >>> 1;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    i8 = HEAP16[i1 + (i3 << 1) >> 1] | 0;
    i7 = HEAP16[i5 + (i3 << 1) >> 1] | 0;
    i18 = i3 | 1;
    i19 = HEAP16[i1 + (i18 << 1) >> 1] | 0;
    i20 = HEAP16[i5 + (i18 << 1) >> 1] | 0;
    HEAP16[i6 + (i3 << 1) >> 1] = (i7 & 65535) < (i8 & 65535) ? i7 : i8;
    HEAP16[i6 + (i18 << 1) >> 1] = (i20 & 65535) < (i19 & 65535) ? i20 : i19;
    i18 = i3 | 2;
    i19 = HEAP16[i1 + (i18 << 1) >> 1] | 0;
    i20 = HEAP16[i5 + (i18 << 1) >> 1] | 0;
    i8 = i3 | 3;
    i7 = HEAP16[i1 + (i8 << 1) >> 1] | 0;
    i17 = HEAP16[i5 + (i8 << 1) >> 1] | 0;
    HEAP16[i6 + (i18 << 1) >> 1] = (i20 & 65535) < (i19 & 65535) ? i20 : i19;
    HEAP16[i6 + (i8 << 1) >> 1] = (i17 & 65535) < (i7 & 65535) ? i17 : i7;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   i8 = HEAP16[i1 + (i2 << 1) >> 1] | 0;
   i7 = HEAP16[i5 + (i2 << 1) >> 1] | 0;
   HEAP16[i6 + (i2 << 1) >> 1] = (i7 & 65535) < (i8 & 65535) ? i7 : i8;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 1) | 0;
   i6 = i6 + (i9 << 1) | 0;
   i1 = i1 + (i11 << 1) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZN2cv6vBinOpItNS_5OpMaxItEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 1;
 i10 = i3 >>> 1;
 i9 = i4 >>> 1;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    i8 = HEAP16[i1 + (i3 << 1) >> 1] | 0;
    i7 = HEAP16[i5 + (i3 << 1) >> 1] | 0;
    i18 = i3 | 1;
    i19 = HEAP16[i1 + (i18 << 1) >> 1] | 0;
    i20 = HEAP16[i5 + (i18 << 1) >> 1] | 0;
    HEAP16[i6 + (i3 << 1) >> 1] = (i8 & 65535) < (i7 & 65535) ? i7 : i8;
    HEAP16[i6 + (i18 << 1) >> 1] = (i19 & 65535) < (i20 & 65535) ? i20 : i19;
    i18 = i3 | 2;
    i19 = HEAP16[i1 + (i18 << 1) >> 1] | 0;
    i20 = HEAP16[i5 + (i18 << 1) >> 1] | 0;
    i8 = i3 | 3;
    i7 = HEAP16[i1 + (i8 << 1) >> 1] | 0;
    i17 = HEAP16[i5 + (i8 << 1) >> 1] | 0;
    HEAP16[i6 + (i18 << 1) >> 1] = (i19 & 65535) < (i20 & 65535) ? i20 : i19;
    HEAP16[i6 + (i8 << 1) >> 1] = (i7 & 65535) < (i17 & 65535) ? i17 : i7;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   i8 = HEAP16[i1 + (i2 << 1) >> 1] | 0;
   i7 = HEAP16[i5 + (i2 << 1) >> 1] | 0;
   HEAP16[i6 + (i2 << 1) >> 1] = (i8 & 65535) < (i7 & 65535) ? i7 : i8;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 1) | 0;
   i6 = i6 + (i9 << 1) | 0;
   i1 = i1 + (i11 << 1) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZN2cv6formatEPKcz(i10, i7, i9) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 i13 = i14 + 16 | 0;
 i8 = i14;
 i11 = i13 + 8 | 0;
 HEAP32[i13 >> 2] = i11;
 i12 = i13 + 4 | 0;
 HEAP32[i12 >> 2] = 1024;
 HEAP32[i8 >> 2] = i9;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = _vsnprintf(HEAP32[i13 >> 2] | 0, i1, i7, i8) | 0;
 if (!((i2 | 0) > -1 & (i2 | 0) < (i1 | 0))) do {
  i4 = i1 << 1;
  i2 = i2 + 1 | 0;
  i4 = (i4 | 0) < (i2 | 0) ? i2 : i4;
  i2 = HEAP32[i12 >> 2] | 0;
  if (i2 >>> 0 < i4 >>> 0) {
   i5 = HEAP32[i13 >> 2] | 0;
   if (i4 >>> 0 > 1024) i1 = __Znaj(i4) | 0; else i1 = i11;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i12 >> 2] = i4;
   L10 : do if (!((i1 | 0) == (i5 | 0) | ((i2 >>> 0 > i4 >>> 0 ? i4 : i2) | 0) == 0) ? (i6 = ~i2, i3 = ~i4, i3 = i6 >>> 0 > i3 >>> 0 ? i6 : i3, i6 = ~i3, HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0, (i3 | 0) != -2) : 0) {
    i3 = 1;
    while (1) {
     HEAP8[i1 + i3 >> 0] = HEAP8[i5 + i3 >> 0] | 0;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i6 | 0)) break L10;
     i1 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   do {
    HEAP8[(HEAP32[i13 >> 2] | 0) + i2 >> 0] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i4 | 0));
   if (!((i5 | 0) == (i11 | 0) | (i5 | 0) == 0)) __ZdaPv(i5);
  } else HEAP32[i12 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = _vsnprintf(HEAP32[i13 >> 2] | 0, i1, i7, i8) | 0;
 } while (!((i2 | 0) > -1 & (i2 | 0) < (i1 | 0)));
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 if (i2) {
  _memcpy(__ZN2cv6String8allocateEj(i10, i2) | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 if ((i1 | 0) == (i11 | 0)) {
  STACKTOP = i14;
  return;
 }
 if (i1) __ZdaPv(i1);
 HEAP32[i13 >> 2] = i11;
 HEAP32[i12 >> 2] = 1024;
 STACKTOP = i14;
 return;
}

function __ZN2cvL13cvtScale32s8uEPKijPKhjPhjNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i17, i3, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 2;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP32[i6 + (i8 << 2) >> 2] | 0)))) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i2 = i8 | 1;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP32[i6 + (i2 << 2) >> 2] | 0)))) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i8 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i1 = i8 | 2;
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP32[i6 + (i1 << 2) >> 2] | 0)))) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i2 = i8 | 3;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP32[i6 + (i2 << 2) >> 2] | 0)))) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP32[i6 + (i5 << 2) >> 2] | 0)))) | 0;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + (i9 << 2) | 0;
   i7 = i7 + i17 | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cvL13cvtScale16s8uEPKsjPKhjPhjNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i17, i3, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 1;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i6 + (i8 << 1) >> 1] | 0)))) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i2 = i8 | 1;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i6 + (i2 << 1) >> 1] | 0)))) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i8 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i1 = i8 | 2;
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i6 + (i1 << 1) >> 1] | 0)))) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i2 = i8 | 3;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i6 + (i2 << 1) >> 1] | 0)))) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i6 + (i5 << 1) >> 1] | 0)))) | 0;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + (i9 << 1) | 0;
   i7 = i7 + i17 | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZNSt3__16vectorIN2cv3VecIiLi64EEENS_9allocatorIS3_EEE8__appendEj(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 i10 = i11 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = i1;
 if (i4 - i3 >> 8 >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    _memset(i1 | 0, 0, 256) | 0;
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i1 = i1 + 256 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = (i3 - i1 >> 8) + i2 | 0;
 if (i3 >>> 0 > 16777215) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i5 = i1;
 i1 = i4 - i5 | 0;
 if (i1 >> 8 >>> 0 < 8388607) {
  i1 = i1 >> 7;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = (HEAP32[i12 >> 2] | 0) - i5 >> 8;
  if (!i1) {
   i6 = 0;
   i9 = 0;
   i8 = i3;
  } else i7 = 10;
 } else {
  i1 = 16777215;
  i3 = (HEAP32[i12 >> 2] | 0) - i5 >> 8;
  i7 = 10;
 }
 if ((i7 | 0) == 10) {
  i6 = i1;
  i9 = __Znwj(i1 << 8) | 0;
  i8 = i3;
 }
 i1 = i9 + (i8 << 8) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else _memset(i3 | 0, 0, 256) | 0;
  i3 = i3 + 256 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i7 = i9 + (i6 << 8) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  i6 = i5 + -256 - i2 | 0;
  while (1) {
   i4 = 0;
   do {
    HEAP32[i1 + (i4 << 2) + -256 >> 2] = HEAP32[i5 + (i4 << 2) + -256 >> 2];
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != 64);
   i5 = i5 + -256 | 0;
   if ((i5 | 0) == (i2 | 0)) break; else i1 = i1 + -256 | 0;
  }
  i1 = i9 + (i8 + ~(i6 >>> 8) << 8) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i3;
 HEAP32[i10 >> 2] = i7;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i13;
 return;
}

function __ZNSt3__16vectorIN2cv3VecIiLi128EEENS_9allocatorIS3_EEE8__appendEj(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 i10 = i11 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = i1;
 if (i4 - i3 >> 9 >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    _memset(i1 | 0, 0, 512) | 0;
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i1 = i1 + 512 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = (i3 - i1 >> 9) + i2 | 0;
 if (i3 >>> 0 > 8388607) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i5 = i1;
 i1 = i4 - i5 | 0;
 if (i1 >> 9 >>> 0 < 4194303) {
  i1 = i1 >> 8;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = (HEAP32[i12 >> 2] | 0) - i5 >> 9;
  if (!i1) {
   i6 = 0;
   i9 = 0;
   i8 = i3;
  } else i7 = 10;
 } else {
  i1 = 8388607;
  i3 = (HEAP32[i12 >> 2] | 0) - i5 >> 9;
  i7 = 10;
 }
 if ((i7 | 0) == 10) {
  i6 = i1;
  i9 = __Znwj(i1 << 9) | 0;
  i8 = i3;
 }
 i1 = i9 + (i8 << 9) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else _memset(i3 | 0, 0, 512) | 0;
  i3 = i3 + 512 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i7 = i9 + (i6 << 9) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  i6 = i5 + -512 - i2 | 0;
  while (1) {
   i4 = 0;
   do {
    HEAP32[i1 + (i4 << 2) + -512 >> 2] = HEAP32[i5 + (i4 << 2) + -512 >> 2];
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != 128);
   i5 = i5 + -512 | 0;
   if ((i5 | 0) == (i2 | 0)) break; else i1 = i1 + -512 | 0;
  }
  i1 = i9 + (i8 + ~(i6 >>> 9) << 9) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i3;
 HEAP32[i10 >> 2] = i7;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i13;
 return;
}

function __ZN2cv8vBinOp32IfNS_5OpSubIfffEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 2;
 i10 = i3 >>> 2;
 i9 = i4 >>> 2;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    f17 = Math_fround(HEAPF32[i1 + (i3 << 2) >> 2]);
    f17 = Math_fround(f17 - Math_fround(HEAPF32[i5 + (i3 << 2) >> 2]));
    i7 = i3 | 1;
    f18 = Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]);
    f18 = Math_fround(f18 - Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]));
    HEAPF32[i6 + (i3 << 2) >> 2] = f17;
    HEAPF32[i6 + (i7 << 2) >> 2] = f18;
    i7 = i3 | 2;
    f18 = Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]);
    f18 = Math_fround(f18 - Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]));
    i8 = i3 | 3;
    f17 = Math_fround(HEAPF32[i1 + (i8 << 2) >> 2]);
    f17 = Math_fround(f17 - Math_fround(HEAPF32[i5 + (i8 << 2) >> 2]));
    HEAPF32[i6 + (i7 << 2) >> 2] = f18;
    HEAPF32[i6 + (i8 << 2) >> 2] = f17;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   f17 = Math_fround(HEAPF32[i1 + (i2 << 2) >> 2]);
   HEAPF32[i6 + (i2 << 2) >> 2] = Math_fround(f17 - Math_fround(HEAPF32[i5 + (i2 << 2) >> 2]));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 2) | 0;
   i6 = i6 + (i9 << 2) | 0;
   i1 = i1 + (i11 << 2) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZN2cv8vBinOp32IfNS_5OpAddIfffEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 2;
 i10 = i3 >>> 2;
 i9 = i4 >>> 2;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    f17 = Math_fround(HEAPF32[i1 + (i3 << 2) >> 2]);
    f17 = Math_fround(f17 + Math_fround(HEAPF32[i5 + (i3 << 2) >> 2]));
    i7 = i3 | 1;
    f18 = Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]);
    f18 = Math_fround(f18 + Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]));
    HEAPF32[i6 + (i3 << 2) >> 2] = f17;
    HEAPF32[i6 + (i7 << 2) >> 2] = f18;
    i7 = i3 | 2;
    f18 = Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]);
    f18 = Math_fround(f18 + Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]));
    i8 = i3 | 3;
    f17 = Math_fround(HEAPF32[i1 + (i8 << 2) >> 2]);
    f17 = Math_fround(f17 + Math_fround(HEAPF32[i5 + (i8 << 2) >> 2]));
    HEAPF32[i6 + (i7 << 2) >> 2] = f18;
    HEAPF32[i6 + (i8 << 2) >> 2] = f17;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   f17 = Math_fround(HEAPF32[i1 + (i2 << 2) >> 2]);
   HEAPF32[i6 + (i2 << 2) >> 2] = Math_fround(f17 + Math_fround(HEAPF32[i5 + (i2 << 2) >> 2]));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 2) | 0;
   i6 = i6 + (i9 << 2) | 0;
   i1 = i1 + (i11 << 2) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZN7testing8internal17AppendUserMessageERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKNS_7MessageE(i6, i4, i1) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i7 = i8 + 12 | 0;
 i5 = i8;
 __ZNK7testing7Message9GetStringEv(i7, i1);
 i1 = HEAP8[i7 >> 0] | 0;
 if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i7 + 4 >> 2] | 0;
 if (!i1) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i6, i4);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
  STACKTOP = i8;
  return;
 };
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = HEAP8[i4 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = (i1 & 255) >>> 1;
  i1 = i4 + 1 | 0;
 } else {
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i1 = HEAP32[i4 + 8 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, i1, i2, i2 + 1 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, 160800, 1) | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i3 = (i1 & 1) == 0;
 if (i3) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = HEAP8[i7 >> 0] | 0;
 if (!(i2 & 1)) i4 = (i2 & 255) >>> 1; else i4 = HEAP32[i7 + 4 >> 2] | 0;
 if (i3) i2 = i5 + 1 | 0; else i2 = HEAP32[i5 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, i2, i1, i4 + i1 | 0);
 if (!(HEAP8[i7 >> 0] & 1)) i1 = i7 + 1 | 0; else i1 = HEAP32[i7 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, i1, i4) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 STACKTOP = i8;
 return;
}

function __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEi(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i4 = i10 + 28 | 0;
 i9 = i10 + 24 | 0;
 i5 = i10 + 12 | 0;
 i6 = i10;
 __ZN7testing7MessageC2Ev(i9);
 i7 = HEAP32[i9 >> 2] | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i7 + 8 | 0, i1) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i4, i7 + 12 | 0);
 i1 = HEAP8[i4 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i4 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i4 + 8 >> 2] | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i6, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i6, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i6, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 if (!(HEAP8[i6 >> 0] & 1)) i1 = i6 + 1 | 0; else i1 = HEAP32[i6 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i1, _strlen(i1 | 0) | 0);
 __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i8, i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] & 511](i7);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN2cvL14cvtScale64f16sEPKdjPKhjPsjNS_5Size_IiEEPd(i7, i4, i1, i2, i8, i5, i3, i6) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var d9 = 0.0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 i16 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i15 = i4 >>> 3;
 i14 = i5 >>> 1;
 if (!i3) {
  STACKTOP = i17;
  return;
 }
 i11 = i16 + -4 | 0;
 i12 = (i11 | 0) < 0;
 d13 = +Math_fround(+HEAPF64[i6 >> 3]);
 d9 = +Math_fround(+HEAPF64[i6 + 8 >> 3]);
 i10 = (i11 | 0) > 3 ? i16 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i12) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(d9 + d13 * +HEAPF64[i7 + (i1 << 3) >> 3]) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i6 = i1 | 1;
    i4 = _lrint(d9 + d13 * +HEAPF64[i7 + (i6 << 3) >> 3]) | 0;
    if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i1 << 1) >> 1] = i5;
    HEAP16[i8 + (i6 << 1) >> 1] = i4;
    i2 = i1 | 2;
    i5 = _lrint(d9 + d13 * +HEAPF64[i7 + (i2 << 3) >> 3]) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i4 = i1 | 3;
    i6 = _lrint(d9 + d13 * +HEAPF64[i7 + (i4 << 3) >> 3]) | 0;
    if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i2 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i11 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i16 | 0)) do {
   i4 = _lrint(d9 + d13 * +HEAPF64[i7 + (i5 << 3) >> 3]) | 0;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i16 | 0));
  if (!i3) break; else {
   i7 = i7 + (i15 << 3) | 0;
   i8 = i8 + (i14 << 1) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZN2cvL13cvtScale32f8uEPKfjPKhjPhjNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i17, i3, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 2;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i8 << 2) >> 2])))) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i2 = i8 | 1;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i2 << 2) >> 2])))) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i8 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i1 = i8 | 2;
    i5 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i1 << 2) >> 2])))) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i2 = i8 | 3;
    i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i2 << 2) >> 2])))) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i5 << 2) >> 2])))) | 0;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + (i9 << 2) | 0;
   i7 = i7 + i17 | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZL11icvWriteMatP13CvFileStoragePKcPKv10CvAttrList(i10, i5, i7, i1) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i2 = i9 + 8 | 0;
 i8 = i9 + 32 | 0;
 i1 = i9 + 24 | 0;
 i3 = i9 + 16 | 0;
 i4 = i9;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i2 + 0 >> 2] = HEAP32[i1 + 0 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 _cvStartWriteStruct(i10, i5, 6, 10736, i2);
 _cvWriteInt(i10, 12e3, HEAP32[i7 + 20 >> 2] | 0);
 _cvWriteInt(i10, 12008, HEAP32[i7 + 24 >> 2] | 0);
 i5 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP8[11696 + (i5 & 7) >> 0] | 0;
 HEAP32[i2 >> 2] = (i5 >>> 3 & 511) + 1;
 HEAP32[i2 + 4 >> 2] = i1;
 _sprintf(i8, 11688, i2) | 0;
 if (!(HEAP8[i8 + 2 >> 0] | 0)) i1 = (HEAP8[i8 >> 0] | 0) == 49; else i1 = 0;
 _cvWriteString(i10, 11672, i8 + (i1 & 1) | 0, 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i2 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 _cvStartWriteStruct(i10, 11680, 13, 0, i2);
 _cvGetSize(i4, i7);
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!((i4 | 0) > 0 & (i1 | 0) > 0)) {
  _cvEndWriteStruct(i10);
  _cvEndWriteStruct(i10);
  STACKTOP = i9;
  return;
 }
 i6 = i7 + 16 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 if (!i5) {
  _cvEndWriteStruct(i10);
  _cvEndWriteStruct(i10);
  STACKTOP = i9;
  return;
 }
 if (!(HEAP32[i7 >> 2] & 16384)) {
  if ((i4 | 0) <= 0) {
   _cvEndWriteStruct(i10);
   _cvEndWriteStruct(i10);
   STACKTOP = i9;
   return;
  }
 } else {
  i1 = Math_imul(i4, i1) | 0;
  i4 = 1;
 }
 i2 = i7 + 4 | 0;
 i3 = 0;
 while (1) {
  _cvWriteRawData(i10, i5 + (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) | 0, i1, i8);
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i4 | 0)) break;
  i5 = HEAP32[i6 >> 2] | 0;
 }
 _cvEndWriteStruct(i10);
 _cvEndWriteStruct(i10);
 STACKTOP = i9;
 return;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb(i10, i5, i9, i3, i4, i7) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i11 + 20 | 0;
 i1 = i11 + 16 | 0;
 i6 = i11 + 12 | 0;
 i8 = i11;
 if (!(HEAP32[i3 + 4 >> 2] & 1)) {
  i8 = HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i2 + 0 >> 2] = HEAP32[i1 + 0 >> 2];
  FUNCTION_TABLE_viiiiii[i8 & 31](i10, i5, i2, i3, i4, i7 & 1);
  STACKTOP = i11;
  return;
 }
 __ZNKSt3__18ios_base6getlocEv(i6, i3);
 i2 = __ZNKSt3__16locale9use_facetERNS0_2idE(i6, 960880) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i6 >> 2] | 0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i7) FUNCTION_TABLE_vii[HEAP32[i1 + 24 >> 2] & 127](i8, i2); else FUNCTION_TABLE_vii[HEAP32[i1 + 28 >> 2] & 127](i8, i2);
 i2 = HEAP8[i8 >> 0] | 0;
 if (!(i2 & 1)) {
  i5 = i8 + 4 | 0;
  i1 = i5;
  i6 = i8 + 8 | 0;
 } else {
  i6 = i8 + 8 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i5 = i8 + 4 | 0;
 }
 i7 = i1;
 while (1) {
  if (!(i2 & 1)) {
   i1 = i5;
   i2 = (i2 & 255) >>> 1;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  }
  if ((i7 | 0) == (i1 + (i2 << 2) | 0)) break;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if (i2) {
   i3 = i2 + 24 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i2 + 28 >> 2] | 0)) i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] & 127](i2, i1) | 0; else {
    HEAP32[i3 >> 2] = i4 + 4;
    HEAP32[i4 >> 2] = i1;
   }
   if ((i1 | 0) == -1) HEAP32[i9 >> 2] = 0;
  }
  i2 = HEAP8[i8 >> 0] | 0;
  i7 = i7 + 4 | 0;
 }
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i8);
 STACKTOP = i11;
 return;
}

function __ZNSt3__16vectorIN2cv3VecIhLi2EEENS_9allocatorIS3_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 i9 = i10 + 8 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1;
 if (i4 - i3 >> 1 >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    HEAP8[i1 >> 0] = 0;
    HEAP8[i1 + 1 >> 0] = 0;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i1 = i1 + 2 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = (i3 - i1 >> 1) + i2 | 0;
 if ((i3 | 0) < 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i5 = i1;
 i1 = i4 - i5 | 0;
 if (i1 >> 1 >>> 0 < 1073741823) {
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = (HEAP32[i11 >> 2] | 0) - i5 >> 1;
  if (!i1) {
   i5 = 0;
   i8 = 0;
   i6 = i3;
  } else i7 = 10;
 } else {
  i1 = 2147483647;
  i3 = (HEAP32[i11 >> 2] | 0) - i5 >> 1;
  i7 = 10;
 }
 if ((i7 | 0) == 10) {
  i5 = i1;
  i8 = __Znwj(i1 << 1) | 0;
  i6 = i3;
 }
 i1 = i8 + (i6 << 1) | 0;
 i3 = i1;
 do {
  if (!i3) i3 = 0; else {
   HEAP8[i3 >> 0] = 0;
   HEAP8[i3 + 1 >> 0] = 0;
  }
  i3 = i3 + 2 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i7 = i8 + (i5 << 1) | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if ((i4 | 0) != (i2 | 0)) {
  i5 = i6 + -1 - ((i4 + (0 - i2) + -2 | 0) >>> 1) | 0;
  while (1) {
   i6 = i4;
   i4 = i4 + -2 | 0;
   HEAP8[i1 + -2 >> 0] = HEAP8[i4 >> 0] | 0;
   HEAP8[i1 + -1 >> 0] = HEAP8[i6 + -1 >> 0] | 0;
   if ((i4 | 0) == (i2 | 0)) break; else i1 = i1 + -2 | 0;
  }
  i1 = i8 + (i5 << 1) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i9 >> 2] = i7;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i12;
 return;
}

function __ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i14, i1, i3) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i13 = i1 + 4 | 0;
 do if (i4) {
  i6 = HEAP8[i3 >> 0] | 0;
  i12 = (i6 & 1) == 0;
  i6 = (i6 & 255) >>> 1;
  i2 = i3 + 1 | 0;
  i11 = i3 + 8 | 0;
  i10 = i3 + 4 | 0;
  i7 = i13;
  i3 = i4;
  L3 : while (1) {
   i1 = i3;
   while (1) {
    i3 = i1 + 16 | 0;
    i4 = HEAP8[i3 >> 0] | 0;
    i5 = (i4 & 1) == 0;
    if (i5) i9 = (i4 & 255) >>> 1; else i9 = HEAP32[i1 + 20 >> 2] | 0;
    if (i12) i8 = i6; else i8 = HEAP32[i10 >> 2] | 0;
    if (i5) i4 = i3 + 1 | 0; else i4 = HEAP32[i1 + 24 >> 2] | 0;
    if (i12) i3 = i2; else i3 = HEAP32[i11 >> 2] | 0;
    i4 = _memcmp(i4, i3, i8 >>> 0 < i9 >>> 0 ? i8 : i9) | 0;
    if (!i4) {
     if (i9 >>> 0 >= i8 >>> 0) break;
    } else if ((i4 | 0) >= 0) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L3;
   }
   i3 = HEAP32[i1 >> 2] | 0;
   if (!i3) {
    i7 = i1;
    break;
   } else i7 = i1;
  }
  if ((i7 | 0) != (i13 | 0)) {
   i5 = i7 + 16 | 0;
   if (!i12) i6 = HEAP32[i10 >> 2] | 0;
   i3 = HEAP8[i5 >> 0] | 0;
   i4 = (i3 & 1) == 0;
   if (i4) i3 = (i3 & 255) >>> 1; else i3 = HEAP32[i7 + 20 >> 2] | 0;
   if (!i12) i2 = HEAP32[i11 >> 2] | 0;
   if (i4) i1 = i5 + 1 | 0; else i1 = HEAP32[i7 + 24 >> 2] | 0;
   i1 = _memcmp(i2, i1, i3 >>> 0 < i6 >>> 0 ? i3 : i6) | 0;
   if (!i1) {
    if (i6 >>> 0 < i3 >>> 0) break;
   } else if ((i1 | 0) < 0) break;
   HEAP32[i14 >> 2] = i7;
   STACKTOP = i15;
   return;
  }
 } while (0);
 HEAP32[i14 >> 2] = i13;
 STACKTOP = i15;
 return;
}

function __ZN7testing15AssertionResultlsIA15_cEERS0_RKT_(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i10 + 16 | 0;
 i6 = i10 + 4 | 0;
 i7 = i10;
 __ZN7testing7MessageC2Ev(i7);
 i8 = HEAP32[i7 >> 2] | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i8 + 8 | 0, i1, _strlen(i1 | 0) | 0) | 0;
 i1 = i9 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __Znwj(12) | 0;
  HEAP32[i2 + 0 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i2;
 }
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i5, i8 + 12 | 0);
 i1 = HEAP8[i5 >> 0] | 0;
 if (!(i1 & 1)) {
  i3 = i5 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i3 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
 }
 i4 = i3 + i1 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i6, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i3 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i6, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i6, i1);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i4 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 if (!(HEAP8[i6 >> 0] & 1)) i1 = i6 + 1 | 0; else i1 = HEAP32[i6 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i2, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 if (!i8) {
  STACKTOP = i10;
  return i9 | 0;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] & 511](i8);
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZL17icvGoNextMemBlockP12CvMemStorage(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i9 + 8 | 0;
 i6 = i9;
 if (!i8) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i2, 40840, 39608, 218);
  __ZN2cv6String10deallocateEv(i2);
 }
 i7 = i8 + 8 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!((i2 | 0) != 0 ? (i1 = HEAP32[i2 + 4 >> 2] | 0, (i1 | 0) != 0) : 0)) i5 = 5;
 do if ((i5 | 0) == 5) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  do if (i1) {
   i3 = i1 + 8 | 0;
   HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
   i4 = i1 + 20 | 0;
   HEAP32[i6 + 4 >> 2] = HEAP32[i4 >> 2];
   __ZL17icvGoNextMemBlockP12CvMemStorage(i1);
   i2 = HEAP32[i3 >> 2] | 0;
   _cvRestoreMemStoragePos(i1, i6);
   i5 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) == (i5 | 0)) {
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i4 >> 2] = 0;
    break;
   }
   i1 = i2 + 4 | 0;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1) HEAP32[i1 >> 2] = i5;
  } else i2 = _cvAlloc(HEAP32[i8 + 16 >> 2] | 0) | 0; while (0);
  HEAP32[i2 + 4 >> 2] = 0;
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  if (!i1) {
   HEAP32[i8 + 4 >> 2] = i2;
   HEAP32[i7 >> 2] = i2;
   i2 = i8 + 16 | 0;
   i2 = HEAP32[i2 >> 2] | 0;
   i2 = i2 + -8 | 0;
   i1 = i8 + 20 | 0;
   HEAP32[i1 >> 2] = i2;
   STACKTOP = i9;
   return;
  } else {
   HEAP32[i1 + 4 >> 2] = i2;
   if (i2) {
    i1 = i2;
    break;
   }
   i2 = i8 + 16 | 0;
   i2 = HEAP32[i2 >> 2] | 0;
   i2 = i2 + -8 | 0;
   i1 = i8 + 20 | 0;
   HEAP32[i1 >> 2] = i2;
   STACKTOP = i9;
   return;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 i2 = i8 + 16 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i2 = i2 + -8 | 0;
 i1 = i8 + 20 | 0;
 HEAP32[i1 >> 2] = i2;
 STACKTOP = i9;
 return;
}

function __ZN2cvL10cvtScale8uEPKhjS1_jPhjNS_5Size_IiEEPd(i5, i17, i1, i2, i6, i16, i3, i4) {
 i5 = i5 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i16 = i16 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 i14 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f13 = Math_fround(+HEAPF64[i4 >> 3]);
 f12 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 i9 = i14 + -4 | 0;
 i10 = (i9 | 0) < 0;
 i11 = i14 & -4;
 i8 = i3;
 while (1) {
  i8 = i8 + -1 | 0;
  if (i10) i4 = 0; else {
   i7 = 0;
   do {
    i4 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i5 + i7 >> 0] | 0 | 0)))) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    i2 = i7 | 1;
    i3 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i5 + i2 >> 0] | 0 | 0)))) | 0;
    if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
    HEAP8[i6 + i7 >> 0] = i4;
    HEAP8[i6 + i2 >> 0] = i3;
    i1 = i7 | 2;
    i4 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i5 + i1 >> 0] | 0 | 0)))) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    i2 = i7 | 3;
    i3 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i5 + i2 >> 0] | 0 | 0)))) | 0;
    if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
    HEAP8[i6 + i1 >> 0] = i4;
    HEAP8[i6 + i2 >> 0] = i3;
    i7 = i7 + 4 | 0;
   } while ((i7 | 0) <= (i9 | 0));
   i4 = i11;
  }
  if ((i4 | 0) < (i14 | 0)) do {
   i3 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i5 + i4 >> 0] | 0 | 0)))) | 0;
   if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
   HEAP8[i6 + i4 >> 0] = i3;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i14 | 0));
  if (!i8) break; else {
   i5 = i5 + i17 | 0;
   i6 = i6 + i16 | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZNK2cv12_OutputArray9getMatRefEi(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i1 = i9 + 16 | 0;
 i5 = i9 + 8 | 0;
 i7 = i9;
 i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] & 127](i6) | 0;
 if ((i8 | 0) < 0) {
  if ((i2 | 0) != 65536) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i2 = __ZN2cv6String8allocateEj(i1, 8) | 0;
   i3 = i2;
   HEAP8[i3 >> 0] = 107;
   HEAP8[i3 + 1 >> 0] = 32;
   HEAP8[i3 + 2 >> 0] = 61;
   HEAP8[i3 + 3 >> 0] = 61;
   i2 = i2 + 4 | 0;
   HEAP8[i2 >> 0] = 32;
   HEAP8[i2 + 1 >> 0] = 77;
   HEAP8[i2 + 2 >> 0] = 65;
   HEAP8[i2 + 3 >> 0] = 84;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 31152, 27528, 2554);
   __ZN2cv6String10deallocateEv(i1);
  }
  i1 = HEAP32[i6 + 8 >> 2] | 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((i2 | 0) != 327680) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i5, 19) | 0) + 0 | 0;
  i3 = 31168 | 0;
  i4 = i1 + 19 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 31152, 27528, 2559);
  __ZN2cv6String10deallocateEv(i5);
 }
 i2 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((((HEAP32[i2 + 4 >> 2] | 0) - i1 | 0) / 56 | 0 | 0) <= (i8 | 0)) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i7, 17) | 0) + 0 | 0;
  i3 = 31096 | 0;
  i4 = i1 + 17 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 31152, 27528, 2561);
  __ZN2cv6String10deallocateEv(i7);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i1 = i1 + (i8 * 56 | 0) | 0;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN2cv6vBinOpItNS_9OpAbsDiffItEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i6, i2, i5, i3, i7, i4, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 1;
 i10 = i3 >>> 1;
 i9 = i4 >>> 1;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    i8 = (HEAPU16[i6 + (i3 << 1) >> 1] | 0) - (HEAPU16[i5 + (i3 << 1) >> 1] | 0) | 0;
    i17 = i3 | 1;
    i18 = (HEAPU16[i6 + (i17 << 1) >> 1] | 0) - (HEAPU16[i5 + (i17 << 1) >> 1] | 0) | 0;
    HEAP16[i1 + (i3 << 1) >> 1] = (i8 | 0) > -1 ? i8 : 0 - i8 | 0;
    HEAP16[i1 + (i17 << 1) >> 1] = (i18 | 0) > -1 ? i18 : 0 - i18 | 0;
    i17 = i3 | 2;
    i18 = (HEAPU16[i6 + (i17 << 1) >> 1] | 0) - (HEAPU16[i5 + (i17 << 1) >> 1] | 0) | 0;
    i8 = i3 | 3;
    i7 = (HEAPU16[i6 + (i8 << 1) >> 1] | 0) - (HEAPU16[i5 + (i8 << 1) >> 1] | 0) | 0;
    HEAP16[i1 + (i17 << 1) >> 1] = (i18 | 0) > -1 ? i18 : 0 - i18 | 0;
    HEAP16[i1 + (i8 << 1) >> 1] = (i7 | 0) > -1 ? i7 : 0 - i7 | 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   i8 = (HEAPU16[i6 + (i2 << 1) >> 1] | 0) - (HEAPU16[i5 + (i2 << 1) >> 1] | 0) | 0;
   HEAP16[i1 + (i2 << 1) >> 1] = (i8 | 0) > -1 ? i8 : 0 - i8 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 1) | 0;
   i6 = i6 + (i11 << 1) | 0;
   i1 = i1 + (i9 << 1) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZN2cv4UMataSERKS0_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 if ((i10 | 0) == (i9 | 0)) {
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = i9 + 24 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1) {
  i7 = i1 + 8 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 i7 = i10 + 24 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i5 = i1 + 8 | 0, i6 = HEAP32[i5 >> 2] | 0, HEAP32[i5 >> 2] = i6 + -1, (i6 | 0) == 1) : 0) {
  i6 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] & 127](i5, i6);
  HEAP32[i7 >> 2] = 0;
 }
 i2 = i10 + 32 | 0;
 HEAP32[HEAP32[i2 >> 2] >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 i6 = i10 + 4 | 0;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 if (!((HEAP32[i6 >> 2] | 0) < 3 & (i1 | 0) < 3)) {
  __ZN2cvL7setSizeERNS_4UMatEiPKiPKjb(i10, i1, 0, 0, 0);
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   i5 = HEAP32[i9 + 32 >> 2] | 0;
   i2 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i9 + 36 >> 2] | 0;
   i3 = HEAP32[i10 + 36 >> 2] | 0;
   i4 = 0;
   do {
    HEAP32[i2 + (i4 << 2) >> 2] = HEAP32[i5 + (i4 << 2) >> 2];
    HEAP32[i3 + (i4 << 2) >> 2] = HEAP32[i1 + (i4 << 2) >> 2];
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) < (HEAP32[i6 >> 2] | 0));
  }
 } else {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  i6 = HEAP32[i10 + 36 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 }
 HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 i1 = i10 + 20 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__16vectorINS_4pairIiN2cv5Size_IiEEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 i9 = i11 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = (((HEAP32[i9 >> 2] | 0) - i1 | 0) / 12 | 0) + 1 | 0;
 if (i3 >>> 0 > 357913941) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i10 = i11 + 8 | 0;
 i2 = ((HEAP32[i10 >> 2] | 0) - i1 | 0) / 12 | 0;
 if (i2 >>> 0 < 178956970) {
  i2 = i2 << 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = ((HEAP32[i9 >> 2] | 0) - i1 | 0) / 12 | 0;
  if (!i2) {
   i3 = 0;
   i8 = 0;
   i6 = i1;
  } else i7 = 6;
 } else {
  i2 = 357913941;
  i1 = ((HEAP32[i9 >> 2] | 0) - i1 | 0) / 12 | 0;
  i7 = 6;
 }
 if ((i7 | 0) == 6) {
  i3 = i2;
  i8 = __Znwj(i2 * 12 | 0) | 0;
  i6 = i1;
 }
 i2 = i8 + (i6 * 12 | 0) | 0;
 i7 = i8 + (i3 * 12 | 0) | 0;
 if (i2) {
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i8 + (i6 * 12 | 0) + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 >> 2] = i4;
 }
 i5 = i8 + ((i6 + 1 | 0) * 12 | 0) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i4 = i3 + -12 - i1 | 0;
  while (1) {
   i14 = i3;
   i3 = i3 + -12 | 0;
   i13 = i2 + -12 | 0;
   HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + -8 >> 2] = HEAP32[i14 + -8 >> 2];
   HEAP32[i2 + -4 >> 2] = HEAP32[i14 + -4 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
   if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 + -12 | 0;
  }
  i2 = i8 + ((i6 + ~((i4 >>> 0) / 12 | 0) | 0) * 12 | 0) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i2;
 HEAP32[i9 >> 2] = i5;
 HEAP32[i10 >> 2] = i7;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i12;
 return;
}

function __ZN2cvL14addWeighted32sEPKijS1_jPijNS_5Size_IiEEPv(i12, i3, i6, i4, i7, i5, i1, i2) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, d15 = 0.0, d16 = 0.0, d17 = 0.0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 i18 = HEAP32[i1 >> 2] | 0;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 d16 = +HEAPF64[i2 >> 3];
 d17 = +HEAPF64[i2 + 8 >> 3];
 d15 = +HEAPF64[i2 + 16 >> 3];
 i14 = i3 >>> 2;
 i13 = i4 >>> 2;
 i1 = i5 >>> 2;
 if (!i11) {
  STACKTOP = i19;
  return;
 }
 i8 = i18 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i10 = i18 & -4;
 i2 = i7;
 i3 = i12;
 i4 = i11;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i7 = _lrint(d15 + (d16 * +(HEAP32[i3 + (i5 << 2) >> 2] | 0) + d17 * +(HEAP32[i6 + (i5 << 2) >> 2] | 0))) | 0;
    i12 = i5 | 1;
    i20 = _lrint(d15 + (d16 * +(HEAP32[i3 + (i12 << 2) >> 2] | 0) + d17 * +(HEAP32[i6 + (i12 << 2) >> 2] | 0))) | 0;
    HEAP32[i2 + (i5 << 2) >> 2] = i7;
    HEAP32[i2 + (i12 << 2) >> 2] = i20;
    i12 = i5 | 2;
    i20 = _lrint(d15 + (d16 * +(HEAP32[i3 + (i12 << 2) >> 2] | 0) + d17 * +(HEAP32[i6 + (i12 << 2) >> 2] | 0))) | 0;
    i7 = i5 | 3;
    i11 = _lrint(d15 + (d16 * +(HEAP32[i3 + (i7 << 2) >> 2] | 0) + d17 * +(HEAP32[i6 + (i7 << 2) >> 2] | 0))) | 0;
    HEAP32[i2 + (i12 << 2) >> 2] = i20;
    HEAP32[i2 + (i7 << 2) >> 2] = i11;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i18 | 0)) do {
   HEAP32[i2 + (i5 << 2) >> 2] = _lrint(d15 + (d16 * +(HEAP32[i3 + (i5 << 2) >> 2] | 0) + d17 * +(HEAP32[i6 + (i5 << 2) >> 2] | 0))) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i18 | 0));
  if (!i4) break; else {
   i6 = i6 + (i13 << 2) | 0;
   i2 = i2 + (i1 << 2) | 0;
   i3 = i3 + (i14 << 2) | 0;
  }
 }
 STACKTOP = i19;
 return;
}

function __ZN2cv22convertAndUnrollScalarERKNS_3MatEiPhj(i8, i7, i10, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i11 + 8 | 0;
 i6 = i11;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 if ((i1 | 0) < 3) i2 = Math_imul(HEAP32[i8 + 12 >> 2] | 0, HEAP32[i8 + 8 >> 2] | 0) | 0; else {
  i3 = HEAP32[i8 + 40 >> 2] | 0;
  i4 = 0;
  i2 = 1;
  do {
   i2 = Math_imul(HEAP32[i3 + (i4 << 2) >> 2] | 0, i2) | 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i1 | 0));
 }
 i12 = (i7 >>> 3 & 511) + 1 | 0;
 i1 = i7 & 7;
 i4 = i12 << (47696 >>> (i1 << 1) & 3);
 i3 = __ZN2cv14getConvertFuncEii(HEAP32[i8 >> 2] & 7, i7) | 0;
 i7 = HEAP32[i8 + 16 >> 2] | 0;
 i8 = (i2 | 0) < (i12 | 0);
 HEAP32[i5 >> 2] = i8 ? i2 : i12;
 HEAP32[i5 + 4 >> 2] = 1;
 FUNCTION_TABLE_viiiiiiii[i3 & 255](i7, 1, 0, 1, i10, 1, i5, 0);
 if (i8) {
  if ((i2 | 0) != 1) {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   i8 = __ZN2cv6String8allocateEj(i6, 8) | 0;
   i7 = i8;
   HEAP8[i7 >> 0] = 115;
   HEAP8[i7 + 1 >> 0] = 99;
   HEAP8[i7 + 2 >> 0] = 110;
   HEAP8[i7 + 3 >> 0] = 32;
   i8 = i8 + 4 | 0;
   HEAP8[i8 >> 0] = 61;
   HEAP8[i8 + 1 >> 0] = 61;
   HEAP8[i8 + 2 >> 0] = 32;
   HEAP8[i8 + 3 >> 0] = 49;
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i6, 4688, 4712, 1221);
   __ZN2cv6String10deallocateEv(i6);
  }
  i2 = 1212424721 >>> (i1 << 2) & 15;
  if (i2 >>> 0 < i4 >>> 0) {
   i1 = i2;
   do {
    HEAP8[i10 + i1 >> 0] = HEAP8[i10 + (i1 - i2) >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
 }
 i1 = Math_imul(i4, i9) | 0;
 if (i4 >>> 0 < i1 >>> 0) i2 = i4; else {
  STACKTOP = i11;
  return;
 }
 do {
  HEAP8[i10 + i2 >> 0] = HEAP8[i10 + (i2 - i4) >> 0] | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 STACKTOP = i11;
 return;
}

function __ZN2cvL5cmp8uEPKhjS1_jPhjNS_5Size_IiEEPv(i2, i4, i3, i5, i7, i12, i11, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i6 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 & -2 | 0) == 2) {
  i1 = (i1 | 0) == 2 ? 4 : 1;
  i6 = i3;
  i10 = i5;
 } else {
  i6 = i2;
  i2 = i3;
  i10 = i4;
  i4 = i5;
 }
 if ((i1 | 0) == 1 | (i1 | 0) == 4) {
  i9 = (i1 | 0) == 1 ? 0 : 255;
  i8 = i11 + 4 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i3 = i5 + -1 | 0;
  HEAP32[i8 >> 2] = i3;
  if (!i5) {
   STACKTOP = i13;
   return;
  }
  i1 = HEAP32[i11 >> 2] | 0;
  while (1) {
   if ((i1 | 0) > 0) {
    i3 = 0;
    do {
     HEAP8[i7 + i3 >> 0] = ((HEAPU8[i6 + i3 >> 0] | 0) > (HEAPU8[i2 + i3 >> 0] | 0)) << 31 >> 31 ^ i9;
     i3 = i3 + 1 | 0;
     i1 = HEAP32[i11 >> 2] | 0;
    } while ((i3 | 0) < (i1 | 0));
    i5 = HEAP32[i8 >> 2] | 0;
   } else i5 = i3;
   i3 = i5 + -1 | 0;
   HEAP32[i8 >> 2] = i3;
   if (!i5) break; else {
    i7 = i7 + i12 | 0;
    i6 = i6 + i10 | 0;
    i2 = i2 + i4 | 0;
   }
  }
  STACKTOP = i13;
  return;
 }
 if (!((i1 | 0) == 0 | (i1 | 0) == 5)) {
  STACKTOP = i13;
  return;
 }
 i8 = (i1 | 0) == 0 ? 0 : 255;
 i9 = i11 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i3 = i5 + -1 | 0;
 HEAP32[i9 >> 2] = i3;
 if (!i5) {
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 while (1) {
  if ((i1 | 0) > 0) {
   i3 = 0;
   do {
    HEAP8[i7 + i3 >> 0] = ((HEAP8[i6 + i3 >> 0] | 0) == (HEAP8[i2 + i3 >> 0] | 0)) << 31 >> 31 ^ i8;
    i3 = i3 + 1 | 0;
    i1 = HEAP32[i11 >> 2] | 0;
   } while ((i3 | 0) < (i1 | 0));
   i5 = HEAP32[i9 >> 2] | 0;
  } else i5 = i3;
  i3 = i5 + -1 | 0;
  HEAP32[i9 >> 2] = i3;
  if (!i5) break; else {
   i7 = i7 + i12 | 0;
   i6 = i6 + i10 | 0;
   i2 = i2 + i4 | 0;
  }
 }
 STACKTOP = i13;
 return;
}

function __ZN2cvL12cvtScale8s8uEPKajPKhjPhjNS_5Size_IiEEPd(i5, i17, i1, i2, i6, i16, i3, i4) {
 i5 = i5 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i16 = i16 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 i14 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f13 = Math_fround(+HEAPF64[i4 >> 3]);
 f12 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 i9 = i14 + -4 | 0;
 i10 = (i9 | 0) < 0;
 i11 = i14 & -4;
 i8 = i3;
 while (1) {
  i8 = i8 + -1 | 0;
  if (i10) i4 = 0; else {
   i7 = 0;
   do {
    i4 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i5 + i7 >> 0] | 0)))) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    i2 = i7 | 1;
    i3 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i5 + i2 >> 0] | 0)))) | 0;
    if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
    HEAP8[i6 + i7 >> 0] = i4;
    HEAP8[i6 + i2 >> 0] = i3;
    i1 = i7 | 2;
    i4 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i5 + i1 >> 0] | 0)))) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    i2 = i7 | 3;
    i3 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i5 + i2 >> 0] | 0)))) | 0;
    if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
    HEAP8[i6 + i1 >> 0] = i4;
    HEAP8[i6 + i2 >> 0] = i3;
    i7 = i7 + 4 | 0;
   } while ((i7 | 0) <= (i9 | 0));
   i4 = i11;
  }
  if ((i4 | 0) < (i14 | 0)) do {
   i3 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i5 + i4 >> 0] | 0)))) | 0;
   if (i3 >>> 0 >= 256) i3 = (i3 | 0) > 0 ? 255 : 0;
   HEAP8[i6 + i4 >> 0] = i3;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i14 | 0));
  if (!i8) break; else {
   i5 = i5 + i17 | 0;
   i6 = i6 + i16 | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZNK2cv17CommandLineParser3hasERKNS_6StringE(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i10;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 if ((HEAP32[i2 + 40 >> 2] | 0) == (i1 | 0)) {
  i1 = 0;
  STACKTOP = i10;
  return i1 | 0;
 }
 i6 = i9 + 4 | 0;
 i5 = 0;
 L4 : while (1) {
  i3 = HEAP32[i1 + (i5 << 5) + 16 >> 2] | 0;
  if ((HEAP32[i1 + (i5 << 5) + 20 >> 2] | 0) != (i3 | 0)) {
   i4 = 0;
   do {
    i1 = HEAP32[i7 >> 2] | 0;
    i3 = HEAP32[i3 + (i4 << 3) >> 2] | 0;
    if (!((i1 | 0) != (i3 | 0) ? (_strcmp((i1 | 0) == 0 ? 6232 : i1, (i3 | 0) == 0 ? 6232 : i3) | 0) != 0 : 0)) {
     HEAP32[i9 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
     i3 = __ZN2cv6String8allocateEj(i9, 4) | 0;
     HEAP8[i3 >> 0] = 116;
     HEAP8[i3 + 1 >> 0] = 114;
     HEAP8[i3 + 2 >> 0] = 117;
     HEAP8[i3 + 3 >> 0] = 101;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = HEAP32[(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0) + (i5 << 5) + 8 >> 2] | 0;
     if ((i3 | 0) == (i2 | 0)) {
      i2 = 7;
      break L4;
     }
     i1 = (_strcmp((i3 | 0) == 0 ? 6232 : i3, (i2 | 0) == 0 ? 6232 : i2) | 0) == 0;
     __ZN2cv6String10deallocateEv(i9);
     if (i1) {
      i1 = 1;
      i2 = 12;
      break L4;
     }
     i2 = HEAP32[i8 >> 2] | 0;
    }
    i4 = i4 + 1 | 0;
    i1 = HEAP32[i2 + 36 >> 2] | 0;
    i3 = HEAP32[i1 + (i5 << 5) + 16 >> 2] | 0;
   } while (i4 >>> 0 < (HEAP32[i1 + (i5 << 5) + 20 >> 2] | 0) - i3 >> 3 >>> 0);
  }
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= (HEAP32[i2 + 40 >> 2] | 0) - i1 >> 5 >>> 0) {
   i1 = 0;
   i2 = 12;
   break;
  }
 }
 if ((i2 | 0) == 7) {
  __ZN2cv6String10deallocateEv(i9);
  i1 = 1;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i2 | 0) == 12) {
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function __ZNK2cv11MatOp_AddEx6divideEdRKNS_7MatExprERS1_(i1, d7, i5, i6) {
 i1 = i1 | 0;
 d7 = +d7;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i8 = i12;
 do if ((HEAP32[i5 >> 2] | 0) == 33112) {
  if ((HEAP32[i5 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i5 + 184 >> 3] == 0.0) : 0) break;
  if (((+HEAPF64[i5 + 192 >> 3] == 0.0 ? +HEAPF64[i5 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i5 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i5 + 216 >> 3] == 0.0 : 0) {
   i4 = i5 + 8 | 0;
   HEAP32[i8 >> 2] = 1124007936;
   i11 = i8 + 4 | 0;
   i2 = i8 + 8 | 0;
   i9 = i8 + 40 | 0;
   i1 = i11 + 0 | 0;
   i3 = i1 + 36 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i9 >> 2] = i2;
   i10 = i8 + 48 | 0;
   i3 = i8 + 44 | 0;
   HEAP32[i3 >> 2] = i10;
   HEAP32[i8 + 52 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   __ZN2cv9MatOp_Bin8makeExprERNS_7MatExprEcRKNS_3MatES5_d(i6, 47, i4, i8, d7 / +HEAPF64[i5 + 176 >> 3]);
   i2 = i8 + 36 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) != 0 ? (i5 = i1 + 12 | 0, i6 = HEAP32[i5 >> 2] | 0, HEAP32[i5 >> 2] = i6 + -1, (i6 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i8);
   HEAP32[i2 >> 2] = 0;
   i8 = i8 + 16 | 0;
   HEAP32[i8 + 0 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   if ((HEAP32[i11 >> 2] | 0) > 0) {
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i1 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i11 >> 2] | 0));
   }
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) == (i10 | 0)) {
    STACKTOP = i12;
    return;
   }
   __ZN2cv8fastFreeEPv(i1);
   STACKTOP = i12;
   return;
  }
 } while (0);
 __ZNK2cv5MatOp6divideEdRKNS_7MatExprERS1_(0, d7, i5, i6);
 STACKTOP = i12;
 return;
}

function __ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8Iterator7AdvanceEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 i5 = i6 + 28 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 511](i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i6 + 24 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0) ? !(FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1) | 0) : 0) i3 = i6 + 16 | 0; else {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 127](i1) | 0;
  if ((HEAP32[i5 >> 2] | 0) != (i1 | 0)) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i3 = HEAP32[i5 >> 2] | 0, (i3 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
   HEAP32[i5 >> 2] = i1;
  }
  i3 = i6 + 16 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 511](i1);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i6 + 12 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i7;
  return;
 }
 if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1, i2) | 0) {
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i7;
  return;
 }
 if (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1) | 0) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] & 127](i3) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i1) | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 + 32 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 36 >> 2] = i2;
 HEAP32[i6 + 40 >> 2] = i1;
 STACKTOP = i7;
 return;
}

function __Z13FillColorRow4PhS_iP12PaletteEntry(i9, i8, i1, i11) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 i7 = i1 * 3 | 0;
 i10 = i9 + i7 | 0;
 i2 = i9 + 6 | 0;
 if ((i7 | 0) > 6) {
  i6 = i9 + 12 | 0;
  i6 = (((i10 >>> 0 > i6 >>> 0 ? i10 : i6) + (-7 - i9) | 0) >>> 0) / 6 | 0;
  i5 = i6 * 6 | 0;
  i7 = i5 + 12 | 0;
  i6 = i6 + 1 | 0;
  i5 = i5 + 6 | 0;
  i4 = i8;
  i3 = i9;
  while (1) {
   i13 = HEAPU8[i4 >> 0] | 0;
   i1 = i11 + (i13 >>> 4 << 2) | 0;
   i1 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
   HEAP8[i3 >> 0] = i1;
   HEAP8[i3 + 1 >> 0] = i1 >> 8;
   HEAP8[i3 + 2 >> 0] = i1 >> 16;
   HEAP8[i3 + 3 >> 0] = i1 >> 24;
   i1 = i3 + 3 | 0;
   i3 = i11 + ((i13 & 15) << 2) | 0;
   i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
   HEAP8[i1 >> 0] = i3;
   HEAP8[i1 + 1 >> 0] = i3 >> 8;
   HEAP8[i1 + 2 >> 0] = i3 >> 16;
   HEAP8[i1 + 3 >> 0] = i3 >> 24;
   i1 = i2 + 6 | 0;
   if (i1 >>> 0 < i10 >>> 0) {
    i3 = i2;
    i4 = i4 + 1 | 0;
    i2 = i1;
   } else break;
  }
  i3 = i9 + i5 | 0;
  i1 = i8 + i6 | 0;
  i2 = i9 + i7 | 0;
 } else {
  i3 = i9;
  i1 = i8;
 }
 i1 = HEAPU8[i1 >> 0] | 0;
 i7 = i1 >>> 4;
 i8 = HEAP8[i11 + (i7 << 2) + 1 >> 0] | 0;
 i9 = HEAP8[i11 + (i7 << 2) + 2 >> 0] | 0;
 HEAP8[i3 >> 0] = HEAP8[i11 + (i7 << 2) >> 0] | 0;
 HEAP8[i3 + 1 >> 0] = i8;
 HEAP8[i3 + 2 >> 0] = i9;
 if ((i2 | 0) != (i10 | 0)) {
  STACKTOP = i12;
  return i10 | 0;
 }
 i7 = i1 & 15;
 i8 = HEAP8[i11 + (i7 << 2) + 1 >> 0] | 0;
 i9 = HEAP8[i11 + (i7 << 2) + 2 >> 0] | 0;
 HEAP8[i3 + 3 >> 0] = HEAP8[i11 + (i7 << 2) >> 0] | 0;
 HEAP8[i3 + 4 >> 0] = i8;
 HEAP8[i3 + 5 >> 0] = i9;
 STACKTOP = i12;
 return i10 | 0;
}

function __ZL7icvPutsP13CvFileStoragePKc(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i14;
 i12 = HEAP32[i3 + 268 >> 2] | 0;
 if (!i12) {
  i1 = HEAP32[i3 + 64 >> 2] | 0;
  if (i1) {
   _fputs(i2 | 0, i1 | 0) | 0;
   STACKTOP = i14;
   return;
  }
  i1 = HEAP32[i3 + 68 >> 2] | 0;
  if (!i1) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i4, 25) | 0) + 0 | 0;
   i2 = 17392 | 0;
   i3 = i1 + 25 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i4, 17432, 8960, 256);
   __ZN2cv6String10deallocateEv(i4);
   STACKTOP = i14;
   return;
  } else {
   _gzputs(i1, i2) | 0;
   STACKTOP = i14;
   return;
  }
 }
 i10 = _strlen(i2 | 0) | 0;
 i8 = i2 + i10 | 0;
 if (!i10) {
  STACKTOP = i14;
  return;
 }
 i9 = i12 + 8 | 0;
 i10 = i12 + 4 | 0;
 i11 = i12 + 16 | 0;
 i7 = i12 + 20 | 0;
 do {
  i5 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i10 >> 2] | 0;
  if ((i5 | 0) == (i6 | 0)) i1 = 0; else i1 = (i5 - i6 << 10) + -1 | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i1 - i4 | 0) == (i3 | 0)) {
   __ZNSt3__15dequeIcNS_9allocatorIcEEE19__add_back_capacityEv(i12);
   i4 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } else i1 = i6;
  i4 = i3 + i4 | 0;
  if ((i5 | 0) != (i1 | 0) ? (i13 = (HEAP32[i1 + (i4 >>> 12 << 2) >> 2] | 0) + (i4 & 4095) | 0, (i13 | 0) != 0) : 0) {
   HEAP8[i13 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = i3 + 1;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i8 | 0));
 STACKTOP = i14;
 return;
}

function __ZNSt3__17__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i9, i11, i8, i1) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 i5 = i11;
 i3 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i6 = i9;
 i7 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i8;
 i4 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = (i2 | 0) < (i5 | 0) | (i2 | 0) == (i5 | 0) & i4 >>> 0 < i3 >>> 0;
 if (!((i5 | 0) < (i6 | 0) | (i5 | 0) == (i6 | 0) & i3 >>> 0 < i7 >>> 0)) {
  if (!i1) {
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
  i1 = i11;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i1 + 4 >> 2] = i2;
  i2 = i8;
  HEAP32[i2 >> 2] = i3;
  HEAP32[i2 + 4 >> 2] = i5;
  i2 = i11;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i9;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if (!((i2 | 0) < (i4 | 0) | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0)) {
   i9 = 1;
   STACKTOP = i10;
   return i9 | 0;
  }
  HEAP32[i9 >> 2] = i1;
  HEAP32[i9 + 4 >> 2] = i2;
  i9 = i11;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i9 + 4 >> 2] = i4;
  i9 = 2;
  STACKTOP = i10;
  return i9 | 0;
 }
 if (i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i9 + 4 >> 2] = i2;
  i9 = i8;
  HEAP32[i9 >> 2] = i7;
  HEAP32[i9 + 4 >> 2] = i6;
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = i9;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i4 + 4 >> 2] = i5;
 i3 = i11;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i3 + 4 >> 2] = i6;
 i3 = i8;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if (!((i3 | 0) < (i6 | 0) | (i3 | 0) == (i6 | 0) & i4 >>> 0 < i7 >>> 0)) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i9 = i11;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i9 + 4 >> 2] = i3;
 i9 = i8;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i6;
 i9 = 2;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZL10icv_strtodP13CvFileStoragePcPS1_(i7, i5, i9) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, d4 = 0.0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i8 = i11;
 i6 = i11 + 16 | 0;
 d1 = +_strtod(i5, i9);
 i3 = HEAP32[i9 >> 2] | 0;
 if ((HEAP8[i3 >> 0] | 0) == 46) {
  HEAP8[i3 >> 0] = 44;
  d4 = +_strtod(i5, i9);
  HEAP8[i3 >> 0] = 46;
  i2 = HEAP32[i9 >> 2] | 0;
  if (i2 >>> 0 > i3 >>> 0) d1 = d4; else {
   HEAP32[i9 >> 2] = i3;
   i2 = i3;
  }
 } else i2 = i3;
 if ((i2 | 0) != (i5 | 0) ? (i2 = HEAP8[i2 >> 0] | 0, !((i2 + -97 << 24 >> 24 & 255) < 26 | (i2 + -65 << 24 >> 24 & 255) < 26)) : 0) {
  STACKTOP = i11;
  return +d1;
 }
 i2 = HEAP8[i5 >> 0] | 0;
 if (i2 << 24 >> 24 == 43 | i2 << 24 >> 24 == 45) {
  i3 = i5 + 1 | 0;
  i5 = i3;
  i3 = HEAP8[i3 >> 0] | 0;
  d1 = i2 << 24 >> 24 == 45 ? -inf : inf;
 } else {
  i3 = i2;
  d1 = inf;
 }
 if (i3 << 24 >> 24 != 46) {
  i2 = HEAP32[i7 + 88 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 + 60 >> 2];
  HEAP32[i8 + 4 >> 2] = i2;
  HEAP32[i8 + 8 >> 2] = 15440;
  _sprintf(i6, 17440, i8) | 0;
  _cvError(-212, 15416, i6, 8960, 907);
 }
 i2 = i5 + 1 | 0;
 if (!(((_toupper(HEAP8[i2 >> 0] | 0) | 0) == 73 ? (_toupper(HEAP8[i5 + 2 >> 0] | 0) | 0) == 78 : 0) ? (_toupper(HEAP8[i5 + 3 >> 0] | 0) | 0) == 70 : 0)) i10 = 13;
 do if ((i10 | 0) == 13) {
  if (((_toupper(HEAP8[i2 >> 0] | 0) | 0) == 78 ? (_toupper(HEAP8[i5 + 2 >> 0] | 0) | 0) == 65 : 0) ? (_toupper(HEAP8[i5 + 3 >> 0] | 0) | 0) == 78 : 0) {
   d1 = nan;
   break;
  }
  i2 = HEAP32[i7 + 88 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 + 60 >> 2];
  HEAP32[i8 + 4 >> 2] = i2;
  HEAP32[i8 + 8 >> 2] = 15440;
  _sprintf(i6, 17440, i8) | 0;
  _cvError(-212, 15416, i6, 8960, 916);
  d1 = 0.0;
 } while (0);
 HEAP32[i9 >> 2] = i5 + 4;
 STACKTOP = i11;
 return +d1;
}

function __ZN7testing13PrintToStringIN2cv5Size_IiEEEENSt3__112basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i9 = i3 + 144 | 0;
 i8 = i3;
 i4 = i8 + 64 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i7 >> 2] = 2640;
 i5 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = 2788;
 HEAP32[i4 >> 2] = 2808;
 HEAP32[i8 + 4 >> 2] = 0;
 __ZNSt3__18ios_base4initEPv(i8 + 64 | 0, i5);
 HEAP32[i8 + 136 >> 2] = 0;
 HEAP32[i8 + 140 >> 2] = -1;
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i4 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i5);
 HEAP32[i5 >> 2] = 2952;
 i6 = i8 + 44 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 24;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i5, i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 i9 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i8 + 8 | 0, HEAP32[i2 >> 2] | 0) | 0, 170096, 1) | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i9, HEAP32[i2 + 4 >> 2] | 0) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i1, i5);
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i8 + 64 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 HEAP32[i5 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i5);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function _cvCloneImage(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i11;
 if (!((i10 | 0) != 0 ? (HEAP32[i10 >> 2] | 0) == 112 : 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i1, 16) | 0) + 0 | 0;
  i3 = 43328 | 0;
  i4 = i2 + 16 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i1, 43352, 40912, 3115);
  __ZN2cv6String10deallocateEv(i1);
 }
 i1 = HEAP32[10250] | 0;
 if (i1) {
  i10 = FUNCTION_TABLE_ii[i1 & 127](i10) | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i9 = _cvAlloc(112) | 0;
 i2 = i9 + 0 | 0;
 i3 = i10 + 0 | 0;
 i4 = i2 + 108 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP32[i9 + 108 >> 2] = 0;
 i8 = i9 + 68 | 0;
 HEAP32[i8 >> 2] = 0;
 i7 = i9 + 48 | 0;
 HEAP32[i7 >> 2] = 0;
 i4 = HEAP32[i10 + 48 >> 2] | 0;
 if (i4) {
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = HEAP32[i4 + 8 >> 2] | 0;
  i6 = HEAP32[i4 + 12 >> 2] | 0;
  i4 = HEAP32[i4 + 16 >> 2] | 0;
  i3 = HEAP32[10248] | 0;
  if (!i3) {
   i3 = _cvAlloc(20) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i3 + 4 >> 2] = i1;
   HEAP32[i3 + 8 >> 2] = i5;
   HEAP32[i3 + 12 >> 2] = i6;
   HEAP32[i3 + 16 >> 2] = i4;
   i1 = i3;
  } else i1 = FUNCTION_TABLE_iiiiii[i3 & 31](i2, i1, i5, i6, i4) | 0;
  HEAP32[i7 >> 2] = i1;
 }
 i1 = i10 + 68 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i10 = i9;
  STACKTOP = i11;
  return i10 | 0;
 }
 i10 = HEAP32[i10 + 64 >> 2] | 0;
 _cvCreateData(i9);
 _memcpy(HEAP32[i8 >> 2] | 0, HEAP32[i1 >> 2] | 0, i10 | 0) | 0;
 i10 = i9;
 STACKTOP = i11;
 return i10 | 0;
}

function __tr_align(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 i3 = i5 + 5820 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = i5 + 5816 | 0;
 i1 = HEAPU16[i4 >> 1] | 0 | 2 << i2;
 HEAP16[i4 >> 1] = i1;
 if ((i2 | 0) > 13) {
  i8 = i5 + 20 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = i2 + 1;
  i7 = i5 + 8 | 0;
  HEAP8[(HEAP32[i7 >> 2] | 0) + i2 >> 0] = i1;
  i1 = (HEAPU16[i4 >> 1] | 0) >>> 8 & 255;
  i2 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = i2 + 1;
  HEAP8[(HEAP32[i7 >> 2] | 0) + i2 >> 0] = i1;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = 2 >>> (16 - i2 | 0);
  HEAP16[i4 >> 1] = i1;
  i2 = i2 + -13 | 0;
 } else i2 = i2 + 3 | 0;
 i1 = i1 & 255;
 HEAP32[i3 >> 2] = i2;
 if ((i2 | 0) > 9) {
  i8 = i5 + 20 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = i7 + 1;
  i2 = i5 + 8 | 0;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i7 >> 0] = i1;
  i7 = (HEAPU16[i4 >> 1] | 0) >>> 8 & 255;
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = i1 + 1;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i1 >> 0] = i7;
  HEAP16[i4 >> 1] = 0;
  i1 = 0;
  i2 = (HEAP32[i3 >> 2] | 0) + -9 | 0;
 } else i2 = i2 + 7 | 0;
 HEAP32[i3 >> 2] = i2;
 if ((i2 | 0) == 16) {
  i7 = i5 + 20 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i8 + 1;
  i2 = i5 + 8 | 0;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i8 >> 0] = i1;
  i5 = (HEAPU16[i4 >> 1] | 0) >>> 8 & 255;
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i1 + 1;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i1 >> 0] = i5;
  HEAP16[i4 >> 1] = 0;
  HEAP32[i3 >> 2] = 0;
  STACKTOP = i6;
  return;
 }
 if ((i2 | 0) <= 7) {
  STACKTOP = i6;
  return;
 }
 i7 = i5 + 20 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 1;
 HEAP8[(HEAP32[i5 + 8 >> 2] | 0) + i2 >> 0] = i1;
 HEAP16[i4 >> 1] = (HEAPU16[i4 >> 1] | 0) >>> 8;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -8;
 STACKTOP = i6;
 return;
}

function __ZN7testing8internal12UnitTestImpl18ConfigureXmlOutputEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i3 = i7;
 i6 = i7 + 16 | 0;
 i4 = i7 + 4 | 0;
 i2 = (HEAP8[159944] & 1) == 0 ? 159945 | 0 : HEAP32[39988] | 0;
 do if (i2) {
  i1 = _strchr(i2, 58) | 0;
  if (!i1) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i2, _strlen(i2 | 0) | 0);
   break;
  } else {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i2, i1 - i2 | 0);
   break;
  }
 } else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, 159968, 0); while (0);
 if (!(__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i6, 163960) | 0)) {
  i1 = __Znwj(16) | 0;
  __ZN7testing8internal15UnitTestOptions27GetAbsolutePathToOutputFileEv(i4);
  if (!(HEAP8[i4 >> 0] & 1)) i2 = i4 + 1 | 0; else i2 = HEAP32[i4 + 8 >> 2] | 0;
  __ZN7testing8internal24XmlUnitTestResultPrinterC2EPKc(i1, i2);
  __ZN7testing18TestEventListeners22SetDefaultXmlGeneratorEPNS_17TestEventListenerE(i5 + 152 | 0, i1);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
  STACKTOP = i7;
  return;
 }
 if (!(__ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i6, 159968) | 0)) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i6 >> 0] & 1)) i1 = i6 + 1 | 0; else i1 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 _printf(163968, i3 | 0) | 0;
 _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 STACKTOP = i7;
 return;
}

function __ZN2cv11RBaseStream4openERKNS_3MatE(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i11;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] & 511](i10);
 i7 = i9 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = i9 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) < 3) i2 = Math_imul(HEAP32[i9 + 12 >> 2] | 0, HEAP32[i9 + 8 >> 2] | 0) | 0; else {
  i4 = HEAP32[i9 + 40 >> 2] | 0;
  i5 = 0;
  i2 = 1;
  do {
   i2 = Math_imul(HEAP32[i4 + (i5 << 2) >> 2] | 0, i2) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i1 | 0));
 }
 if (!i2) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (!(HEAP32[i9 >> 2] & 16384)) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i6, 18) | 0) + 0 | 0;
  i2 = 180784 | 0;
  i1 = i3 + 18 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i6, 180808, 180816, 133);
  __ZN2cv6String10deallocateEv(i6);
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i10 + 8 >> 2] = i3;
 i2 = Math_imul(HEAP32[i9 + 8 >> 2] | 0, HEAP32[i9 + 12 >> 2] | 0) | 0;
 if ((i1 | 0) > 0) i1 = HEAP32[(HEAP32[i9 + 44 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0; else i1 = 0;
 HEAP32[i10 + 12 >> 2] = i3 + (Math_imul(i2, i1) | 0);
 HEAP8[i10 + 4 >> 0] = 0;
 HEAP8[i10 + 32 >> 0] = 1;
 if (!(HEAP32[i10 + 20 >> 2] | 0)) {
  HEAP32[i10 + 16 >> 2] = i3;
  HEAP32[i10 + 28 >> 2] = 0;
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 } else {
  HEAP32[i10 + 28 >> 2] = 0;
  HEAP32[i10 + 16 >> 2] = i3;
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 return 0;
}

function __ZN4perf7PrintToERKNS_7MatTypeEPNSt3__113basic_ostreamIcNS3_11char_traitsIcEEEE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i4;
 switch (HEAP32[i3 >> 2] & 7 | 0) {
 case 0:
  {
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 176648, 2) | 0;
   break;
  }
 case 2:
  {
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 176664, 3) | 0;
   break;
  }
 case 3:
  {
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 176672, 3) | 0;
   break;
  }
 case 7:
  {
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 176704, 8) | 0;
   break;
  }
 case 6:
  {
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 176696, 3) | 0;
   break;
  }
 case 5:
  {
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 176688, 3) | 0;
   break;
  }
 case 1:
  {
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 176656, 2) | 0;
   break;
  }
 case 4:
  {
   __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 176680, 3) | 0;
   break;
  }
 default:
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 176720, 12) | 0;
 }
 HEAP8[i1 >> 0] = 67;
 i1 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i1, 1) | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i1, ((HEAP32[i3 >> 2] | 0) >>> 3 & 511) + 1 | 0) | 0;
 STACKTOP = i4;
 return;
}

function __ZN2cv8vBinOp64IdNS_5OpMinIdEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0, d18 = 0.0, d19 = 0.0, d20 = 0.0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 3;
 i10 = i3 >>> 3;
 i9 = i4 >>> 3;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    d17 = +HEAPF64[i1 + (i3 << 3) >> 3];
    d18 = +HEAPF64[i5 + (i3 << 3) >> 3];
    i7 = i3 | 1;
    d19 = +HEAPF64[i1 + (i7 << 3) >> 3];
    d20 = +HEAPF64[i5 + (i7 << 3) >> 3];
    HEAPF64[i6 + (i3 << 3) >> 3] = d18 < d17 ? d18 : d17;
    HEAPF64[i6 + (i7 << 3) >> 3] = d20 < d19 ? d20 : d19;
    i7 = i3 | 2;
    d19 = +HEAPF64[i1 + (i7 << 3) >> 3];
    d20 = +HEAPF64[i5 + (i7 << 3) >> 3];
    i8 = i3 | 3;
    d17 = +HEAPF64[i1 + (i8 << 3) >> 3];
    d18 = +HEAPF64[i5 + (i8 << 3) >> 3];
    HEAPF64[i6 + (i7 << 3) >> 3] = d20 < d19 ? d20 : d19;
    HEAPF64[i6 + (i8 << 3) >> 3] = d18 < d17 ? d18 : d17;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   d17 = +HEAPF64[i1 + (i2 << 3) >> 3];
   d18 = +HEAPF64[i5 + (i2 << 3) >> 3];
   HEAPF64[i6 + (i2 << 3) >> 3] = d18 < d17 ? d18 : d17;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 3) | 0;
   i6 = i6 + (i9 << 3) | 0;
   i1 = i1 + (i11 << 3) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZN2cv8vBinOp64IdNS_5OpMaxIdEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0, d18 = 0.0, d19 = 0.0, d20 = 0.0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 3;
 i10 = i3 >>> 3;
 i9 = i4 >>> 3;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    d17 = +HEAPF64[i1 + (i3 << 3) >> 3];
    d18 = +HEAPF64[i5 + (i3 << 3) >> 3];
    i7 = i3 | 1;
    d19 = +HEAPF64[i1 + (i7 << 3) >> 3];
    d20 = +HEAPF64[i5 + (i7 << 3) >> 3];
    HEAPF64[i6 + (i3 << 3) >> 3] = d17 < d18 ? d18 : d17;
    HEAPF64[i6 + (i7 << 3) >> 3] = d19 < d20 ? d20 : d19;
    i7 = i3 | 2;
    d19 = +HEAPF64[i1 + (i7 << 3) >> 3];
    d20 = +HEAPF64[i5 + (i7 << 3) >> 3];
    i8 = i3 | 3;
    d17 = +HEAPF64[i1 + (i8 << 3) >> 3];
    d18 = +HEAPF64[i5 + (i8 << 3) >> 3];
    HEAPF64[i6 + (i7 << 3) >> 3] = d19 < d20 ? d20 : d19;
    HEAPF64[i6 + (i8 << 3) >> 3] = d17 < d18 ? d18 : d17;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   d17 = +HEAPF64[i1 + (i2 << 3) >> 3];
   d18 = +HEAPF64[i5 + (i2 << 3) >> 3];
   HEAPF64[i6 + (i2 << 3) >> 3] = d17 < d18 ? d18 : d17;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 3) | 0;
   i6 = i6 + (i9 << 3) | 0;
   i1 = i1 + (i11 << 3) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZNK2cv3Mat4diagEi(i7, i8, i6) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i9;
 i1 = i8 + 4 | 0;
 if ((HEAP32[i1 >> 2] | 0) >= 3) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i2, 9) | 0) + 0 | 0;
  i4 = 28168 | 0;
  i5 = i3 + 9 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 28184, 27528, 668);
  __ZN2cv6String10deallocateEv(i2);
 }
 __ZN2cv3MatC2ERKS0_(i7, i8);
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) > 0) i2 = HEAP32[(HEAP32[i8 + 44 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0; else i2 = 0;
 if ((i6 | 0) > -1) {
  i1 = (HEAP32[i8 + 12 >> 2] | 0) - i6 | 0;
  i3 = HEAP32[i8 + 8 >> 2] | 0;
  i5 = Math_imul(i2, i6) | 0;
  i4 = i7 + 16 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i5;
  i1 = (i3 | 0) < (i1 | 0) ? i3 : i1;
 } else {
  i1 = (HEAP32[i8 + 8 >> 2] | 0) + i6 | 0;
  i3 = HEAP32[i8 + 12 >> 2] | 0;
  i4 = i7 + 16 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + (Math_imul(HEAP32[HEAP32[i8 + 44 >> 2] >> 2] | 0, 0 - i6 | 0) | 0);
  i1 = (i3 | 0) < (i1 | 0) ? i3 : i1;
 }
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = i1;
 i4 = HEAP32[i7 + 40 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i7 + 12 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = 1;
 i4 = HEAP32[i7 + 44 >> 2] | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + ((i1 | 0) > 1 ? i2 : 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i3 >> 2] | 0) > 1 ? i1 & -16385 : i1 | 16384;
 HEAP32[i7 >> 2] = i1;
 i2 = HEAP32[i8 + 40 >> 2] | 0;
 if (!((HEAP32[i2 >> 2] | 0) != 1 ? 1 : (HEAP32[i2 + 4 >> 2] | 0) != 1)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i7 >> 2] = i1 | 32768;
 STACKTOP = i9;
 return;
}

function __ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i3, i7, i6, i2, i4) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 if ((i3 | 0) == (HEAP32[i7 + 8 >> 2] | 0)) {
  if ((HEAP32[i7 + 4 >> 2] | 0) != (i6 | 0)) {
   STACKTOP = i9;
   return;
  }
  i1 = i7 + 28 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 1) {
   STACKTOP = i9;
   return;
  }
  HEAP32[i1 >> 2] = i2;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) != (HEAP32[i7 >> 2] | 0)) {
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  FUNCTION_TABLE_viiiii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 31](i1, i7, i6, i2, i4);
  STACKTOP = i9;
  return;
 }
 if ((HEAP32[i7 + 16 >> 2] | 0) != (i6 | 0) ? (i5 = i7 + 20 | 0, (HEAP32[i5 >> 2] | 0) != (i6 | 0)) : 0) {
  HEAP32[i7 + 32 >> 2] = i2;
  i2 = i7 + 44 | 0;
  if ((HEAP32[i2 >> 2] | 0) == 4) {
   STACKTOP = i9;
   return;
  }
  i1 = i7 + 52 | 0;
  HEAP8[i1 >> 0] = 0;
  i10 = i7 + 53 | 0;
  HEAP8[i10 >> 0] = 0;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
  FUNCTION_TABLE_viiiiii[HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] & 31](i3, i7, i6, i6, 1, i4);
  if (HEAP8[i10 >> 0] | 0) {
   if (!(HEAP8[i1 >> 0] | 0)) {
    i1 = 1;
    i8 = 13;
   }
  } else {
   i1 = 0;
   i8 = 13;
  }
  do if ((i8 | 0) == 13) {
   HEAP32[i5 >> 2] = i6;
   i3 = i7 + 40 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   if ((HEAP32[i7 + 36 >> 2] | 0) == 1 ? (HEAP32[i7 + 24 >> 2] | 0) == 2 : 0) {
    HEAP8[i7 + 54 >> 0] = 1;
    if (i1) break;
   } else i8 = 16;
   if ((i8 | 0) == 16 ? i1 : 0) break;
   HEAP32[i2 >> 2] = 4;
   STACKTOP = i9;
   return;
  } while (0);
  HEAP32[i2 >> 2] = 3;
  STACKTOP = i9;
  return;
 }
 if ((i2 | 0) != 1) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i7 + 32 >> 2] = 1;
 STACKTOP = i9;
 return;
}

function _cvRelease(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i9 + 16 | 0;
 i5 = i9 + 8 | 0;
 i7 = i9;
 if (!i8) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i2, 19) | 0) + 0 | 0;
  i3 = 11016 | 0;
  i4 = i1 + 19 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i2, 11040, 8960, 4913);
  __ZN2cv6String10deallocateEv(i2);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[2644] | 0;
 L7 : do if (!i1) i6 = 7; else while (1) {
  if (FUNCTION_TABLE_ii[HEAP32[i1 + 20 >> 2] & 127](i2) | 0) break L7;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  if (!i1) {
   i6 = 7;
   break;
  }
 } while (0);
 if ((i6 | 0) == 7) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i5, 19) | 0) + 0 | 0;
  i3 = 11056 | 0;
  i4 = i1 + 19 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i5, 11040, 8960, 4919);
  __ZN2cv6String10deallocateEv(i5);
  i1 = 0;
 }
 i2 = i1 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i7, 32) | 0) + 0 | 0;
  i3 = 11080 | 0;
  i4 = i1 + 32 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i7, 11040, 8960, 4921);
  __ZN2cv6String10deallocateEv(i7);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 FUNCTION_TABLE_vi[i1 & 511](i8);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z14checkIppStatusv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i2 = i9 + 32 | 0;
 i3 = i9 + 24 | 0;
 i1 = i9 + 16 | 0;
 i4 = i9 + 12 | 0;
 i5 = i9 + 8 | 0;
 i7 = i9;
 if (!(HEAP8[159104] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i2 >> 2] = __ZN2cv3ipp12getIppStatusEv() | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN7testing8internal11CmpHelperLEIiiEENS_15AssertionResultEPKcS4_RKT_RKT0_(i3, 159112, 159120, i1, i2);
 i2 = i3 + 4 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i1 = HEAP32[i2 >> 2] | 0;
  do if (i1) if (!(HEAP8[i1 >> 0] & 1)) {
   i1 = i1 + 1 | 0;
   break;
  } else {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   break;
  } else i1 = 158192; while (0);
  __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i4, 1, 158640, 668, i1);
  __ZN7testing7MessageC2Ev(i5);
  __ZN2cv3ipp19getIppErrorLocationEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? 158192 : i1;
  i3 = (HEAP32[i5 >> 2] | 0) + 8 | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, i1, _strlen(i1 | 0) | 0) | 0;
  __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i4, i5);
  __ZN2cv6String10deallocateEv(i7);
  if (HEAP32[i5 >> 2] | 0) {
   if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i6 = HEAP32[i5 >> 2] | 0, (i6 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] & 511](i6);
   HEAP32[i5 >> 2] = 0;
  }
  __ZN7testing8internal12AssertHelperD2Ev(i4);
 }
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i8 = HEAP32[i2 >> 2] | 0, (i8 | 0) != 0) : 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
  __ZdlPv(i8);
 }
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZNK2cv12_OutputArray10getUMatRefEi(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i9 + 16 | 0;
 i3 = i9 + 8 | 0;
 i7 = i9;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] & 127](i4) | 0;
 if ((i8 | 0) < 0) {
  if ((i1 | 0) != 655360) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   i1 = (__ZN2cv6String8allocateEj(i2, 9) | 0) + 0 | 0;
   i5 = 31192 | 0;
   i6 = i1 + 9 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i1 | 0) < (i6 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 31208, 27528, 2571);
   __ZN2cv6String10deallocateEv(i2);
  }
  i1 = HEAP32[i4 + 8 >> 2] | 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((i1 | 0) != 720896) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i3, 20) | 0) + 0 | 0;
  i5 = 31224 | 0;
  i6 = i1 + 20 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i3, 31208, 27528, 2576);
  __ZN2cv6String10deallocateEv(i3);
 }
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((((HEAP32[i2 + 4 >> 2] | 0) - i1 | 0) / 48 | 0 | 0) <= (i8 | 0)) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i7, 17) | 0) + 0 | 0;
  i5 = 31096 | 0;
  i6 = i1 + 17 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i7, 31208, 27528, 2578);
  __ZN2cv6String10deallocateEv(i7);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i1 = i1 + (i8 * 48 | 0) | 0;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN2cvL14cvtScale64f16uEPKdjPKhjPtjNS_5Size_IiEEPd(i7, i4, i1, i2, i8, i5, i3, i6) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var d9 = 0.0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 i16 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i15 = i4 >>> 3;
 i14 = i5 >>> 1;
 if (!i3) {
  STACKTOP = i17;
  return;
 }
 i11 = i16 + -4 | 0;
 i12 = (i11 | 0) < 0;
 d13 = +Math_fround(+HEAPF64[i6 >> 3]);
 d9 = +Math_fround(+HEAPF64[i6 + 8 >> 3]);
 i10 = (i11 | 0) > 3 ? i16 & -4 : 4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i12) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(d9 + d13 * +HEAPF64[i7 + (i1 << 3) >> 3]) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i6 = i1 | 1;
    i4 = _lrint(d9 + d13 * +HEAPF64[i7 + (i6 << 3) >> 3]) | 0;
    if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i1 << 1) >> 1] = i5;
    HEAP16[i8 + (i6 << 1) >> 1] = i4;
    i2 = i1 | 2;
    i5 = _lrint(d9 + d13 * +HEAPF64[i7 + (i2 << 3) >> 3]) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i4 = i1 | 3;
    i6 = _lrint(d9 + d13 * +HEAPF64[i7 + (i4 << 3) >> 3]) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i2 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i11 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i16 | 0)) do {
   i4 = _lrint(d9 + d13 * +HEAPF64[i7 + (i5 << 3) >> 3]) | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i16 | 0));
  if (!i3) break; else {
   i7 = i7 + (i15 << 3) | 0;
   i8 = i8 + (i14 << 1) | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZN2cv8vBinOp32IiNS_5OpMinIiEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i6, i1, i4, i2, i5, i3, i10) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 i9 = i10 + 4 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i8 + -1;
 if (!i8) {
  STACKTOP = i11;
  return;
 }
 i8 = i1 >>> 2;
 i7 = i2 >>> 2;
 i3 = i3 >>> 2;
 i1 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i1 + -4 | 0) < 0) i2 = 0; else {
   i2 = 0;
   do {
    i1 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
    i12 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    i14 = i2 | 1;
    i15 = HEAP32[i6 + (i14 << 2) >> 2] | 0;
    i16 = HEAP32[i4 + (i14 << 2) >> 2] | 0;
    HEAP32[i5 + (i2 << 2) >> 2] = (i12 | 0) < (i1 | 0) ? i12 : i1;
    HEAP32[i5 + (i14 << 2) >> 2] = (i16 | 0) < (i15 | 0) ? i16 : i15;
    i14 = i2 | 2;
    i15 = HEAP32[i6 + (i14 << 2) >> 2] | 0;
    i16 = HEAP32[i4 + (i14 << 2) >> 2] | 0;
    i1 = i2 | 3;
    i12 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
    i13 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
    HEAP32[i5 + (i14 << 2) >> 2] = (i16 | 0) < (i15 | 0) ? i16 : i15;
    HEAP32[i5 + (i1 << 2) >> 2] = (i13 | 0) < (i12 | 0) ? i13 : i12;
    i2 = i2 + 4 | 0;
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i2 | 0) <= (i1 + -4 | 0));
  }
  if ((i2 | 0) < (i1 | 0)) do {
   i1 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
   i12 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
   HEAP32[i5 + (i2 << 2) >> 2] = (i12 | 0) < (i1 | 0) ? i12 : i1;
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } while ((i2 | 0) < (i1 | 0));
  i2 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i2 + -1;
  if (!i2) break; else {
   i4 = i4 + (i7 << 2) | 0;
   i5 = i5 + (i3 << 2) | 0;
   i6 = i6 + (i8 << 2) | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cv8vBinOp32IiNS_5OpMaxIiEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i6, i1, i4, i2, i5, i3, i10) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 i9 = i10 + 4 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i8 + -1;
 if (!i8) {
  STACKTOP = i11;
  return;
 }
 i8 = i1 >>> 2;
 i7 = i2 >>> 2;
 i3 = i3 >>> 2;
 i1 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i1 + -4 | 0) < 0) i2 = 0; else {
   i2 = 0;
   do {
    i1 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
    i12 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    i14 = i2 | 1;
    i15 = HEAP32[i6 + (i14 << 2) >> 2] | 0;
    i16 = HEAP32[i4 + (i14 << 2) >> 2] | 0;
    HEAP32[i5 + (i2 << 2) >> 2] = (i1 | 0) < (i12 | 0) ? i12 : i1;
    HEAP32[i5 + (i14 << 2) >> 2] = (i15 | 0) < (i16 | 0) ? i16 : i15;
    i14 = i2 | 2;
    i15 = HEAP32[i6 + (i14 << 2) >> 2] | 0;
    i16 = HEAP32[i4 + (i14 << 2) >> 2] | 0;
    i1 = i2 | 3;
    i12 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
    i13 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
    HEAP32[i5 + (i14 << 2) >> 2] = (i15 | 0) < (i16 | 0) ? i16 : i15;
    HEAP32[i5 + (i1 << 2) >> 2] = (i12 | 0) < (i13 | 0) ? i13 : i12;
    i2 = i2 + 4 | 0;
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i2 | 0) <= (i1 + -4 | 0));
  }
  if ((i2 | 0) < (i1 | 0)) do {
   i1 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
   i12 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
   HEAP32[i5 + (i2 << 2) >> 2] = (i1 | 0) < (i12 | 0) ? i12 : i1;
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } while ((i2 | 0) < (i1 | 0));
  i2 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i2 + -1;
  if (!i2) break; else {
   i4 = i4 + (i7 << 2) | 0;
   i5 = i5 + (i3 << 2) | 0;
   i6 = i6 + (i8 << 2) | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cvL14randnScale_64fEPKfPdiiPKdS4_b(i8, i6, i13, i10, i11, i12, i2) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var d1 = 0.0, d3 = 0.0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i14 = 0;
 i14 = STACKTOP;
 if (i2) {
  if ((i13 | 0) <= 0) {
   STACKTOP = i14;
   return;
  }
  i9 = (i10 | 0) > 0;
  i5 = 0;
  while (1) {
   if (i9) {
    i4 = 0;
    do {
     i7 = Math_imul(i4, i10) | 0;
     i2 = 0;
     d3 = +HEAPF64[i11 + (i4 << 3) >> 3];
     do {
      d1 = +Math_fround(HEAPF32[i8 + (i2 << 2) >> 2]);
      d3 = d3 + d1 * +HEAPF64[i12 + (i2 + i7 << 3) >> 3];
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i10 | 0));
     HEAPF64[i6 + (i4 << 3) >> 3] = d3;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i10 | 0));
   }
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i13 | 0)) break; else {
    i8 = i8 + (i10 << 2) | 0;
    i6 = i6 + (i10 << 3) | 0;
   }
  }
  STACKTOP = i14;
  return;
 }
 if ((i10 | 0) == 1) {
  d3 = +HEAPF64[i11 >> 3];
  d1 = +HEAPF64[i12 >> 3];
  if ((i13 | 0) > 0) i2 = 0; else {
   STACKTOP = i14;
   return;
  }
  do {
   HEAPF64[i6 + (i2 << 3) >> 3] = d3 + d1 * +Math_fround(HEAPF32[i8 + (i2 << 2) >> 2]);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i13 | 0));
  STACKTOP = i14;
  return;
 }
 if ((i13 | 0) <= 0) {
  STACKTOP = i14;
  return;
 }
 i7 = (i10 | 0) > 0;
 i2 = i8;
 i4 = 0;
 while (1) {
  if (i7) {
   i5 = 0;
   do {
    d1 = +Math_fround(HEAPF32[i2 + (i5 << 2) >> 2]);
    HEAPF64[i6 + (i5 << 3) >> 3] = d1 * +HEAPF64[i12 + (i5 << 3) >> 3] + +HEAPF64[i11 + (i5 << 3) >> 3];
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i10 | 0));
  }
  i4 = i4 + 1 | 0;
  if ((i4 | 0) == (i13 | 0)) break; else {
   i6 = i6 + (i10 << 3) | 0;
   i2 = i2 + (i10 << 2) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cv6vBinOpIaNS_5OpSubIaaaEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i2, i11, i1, i12, i3, i10, i13) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0;
 i14 = STACKTOP;
 i9 = i13 + 4 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i8 + -1;
 if (!i8) {
  STACKTOP = i14;
  return;
 }
 i8 = i2;
 i2 = HEAP32[i13 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i4 = 0;
   do {
    i2 = (HEAP8[i8 + i4 >> 0] | 0) - (HEAP8[i1 + i4 >> 0] | 0) | 0;
    if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
    i6 = i4 | 1;
    i5 = (HEAP8[i8 + i6 >> 0] | 0) - (HEAP8[i1 + i6 >> 0] | 0) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    HEAP8[i3 + i4 >> 0] = i2;
    HEAP8[i3 + i6 >> 0] = i5;
    i7 = i4 | 2;
    i2 = (HEAP8[i8 + i7 >> 0] | 0) - (HEAP8[i1 + i7 >> 0] | 0) | 0;
    if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
    i5 = i4 | 3;
    i6 = (HEAP8[i8 + i5 >> 0] | 0) - (HEAP8[i1 + i5 >> 0] | 0) | 0;
    if ((i6 + 128 | 0) >>> 0 >= 256) i6 = (i6 | 0) > 0 ? 127 : -128;
    HEAP8[i3 + i7 >> 0] = i2;
    HEAP8[i3 + i5 >> 0] = i6;
    i4 = i4 + 4 | 0;
    i2 = HEAP32[i13 >> 2] | 0;
   } while ((i4 | 0) <= (i2 + -4 | 0));
  }
  if ((i4 | 0) < (i2 | 0)) do {
   i2 = (HEAP8[i8 + i4 >> 0] | 0) - (HEAP8[i1 + i4 >> 0] | 0) | 0;
   if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
   HEAP8[i3 + i4 >> 0] = i2;
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i13 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i7 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i7 + -1;
  if (!i7) break; else {
   i1 = i1 + i12 | 0;
   i8 = i8 + i11 | 0;
   i3 = i3 + i10 | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cv6vBinOpIaNS_5OpAddIaaaEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i2, i11, i1, i12, i3, i10, i13) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0;
 i14 = STACKTOP;
 i9 = i13 + 4 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i8 + -1;
 if (!i8) {
  STACKTOP = i14;
  return;
 }
 i8 = i2;
 i2 = HEAP32[i13 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i4 = 0;
   do {
    i2 = (HEAP8[i1 + i4 >> 0] | 0) + (HEAP8[i8 + i4 >> 0] | 0) | 0;
    if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
    i6 = i4 | 1;
    i5 = (HEAP8[i1 + i6 >> 0] | 0) + (HEAP8[i8 + i6 >> 0] | 0) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    HEAP8[i3 + i4 >> 0] = i2;
    HEAP8[i3 + i6 >> 0] = i5;
    i7 = i4 | 2;
    i2 = (HEAP8[i1 + i7 >> 0] | 0) + (HEAP8[i8 + i7 >> 0] | 0) | 0;
    if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
    i5 = i4 | 3;
    i6 = (HEAP8[i1 + i5 >> 0] | 0) + (HEAP8[i8 + i5 >> 0] | 0) | 0;
    if ((i6 + 128 | 0) >>> 0 >= 256) i6 = (i6 | 0) > 0 ? 127 : -128;
    HEAP8[i3 + i7 >> 0] = i2;
    HEAP8[i3 + i5 >> 0] = i6;
    i4 = i4 + 4 | 0;
    i2 = HEAP32[i13 >> 2] | 0;
   } while ((i4 | 0) <= (i2 + -4 | 0));
  }
  if ((i4 | 0) < (i2 | 0)) do {
   i2 = (HEAP8[i1 + i4 >> 0] | 0) + (HEAP8[i8 + i4 >> 0] | 0) | 0;
   if ((i2 + 128 | 0) >>> 0 >= 256) i2 = (i2 | 0) > 0 ? 127 : -128;
   HEAP8[i3 + i4 >> 0] = i2;
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i13 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i7 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i7 + -1;
  if (!i7) break; else {
   i1 = i1 + i12 | 0;
   i8 = i8 + i11 | 0;
   i3 = i3 + i10 | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZNK2cv7MatOp_T9transposeERKNS_7MatExprERS1_(i1, i2, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, d6 = 0.0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i10 = i12 + 32 | 0;
 i5 = i12;
 d6 = +HEAPF64[i2 + 176 >> 3];
 i4 = i2 + 8 | 0;
 if (d6 == 1.0) {
  __ZN2cv14MatOp_Identity8makeExprERNS_7MatExprERKNS_3MatE(i9, i4);
  STACKTOP = i12;
  return;
 }
 HEAP32[i10 >> 2] = 1124007936;
 i11 = i10 + 4 | 0;
 i2 = i10 + 8 | 0;
 i7 = i10 + 40 | 0;
 i1 = i11 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i7 >> 2] = i2;
 i8 = i10 + 48 | 0;
 i3 = i10 + 44 | 0;
 HEAP32[i3 >> 2] = i8;
 HEAP32[i10 + 52 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAPF64[i5 >> 3] = 0.0;
 __ZN2cv11MatOp_AddEx8makeExprERNS_7MatExprERKNS_3MatES5_ddRKNS_7Scalar_IdEE(i9, i4, i10, d6, 0.0, i5);
 i2 = i10 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i5 = i1 + 12 | 0, i9 = HEAP32[i5 >> 2] | 0, HEAP32[i5 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i10);
 HEAP32[i2 >> 2] = 0;
 i10 = i10 + 16 | 0;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i11 >> 2] | 0) > 0) {
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i11 >> 2] | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i12;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i12;
 return;
}

function __ZN2cv8vBinOp32IiNS_9OpAbsDiffIiEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i5, i1, i4, i2, i6, i3, i10) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 i9 = i10 + 4 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i8 + -1;
 if (!i8) {
  STACKTOP = i11;
  return;
 }
 i8 = i1 >>> 2;
 i7 = i2 >>> 2;
 i3 = i3 >>> 2;
 i1 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i1 + -4 | 0) < 0) i2 = 0; else {
   i2 = 0;
   do {
    i1 = (HEAP32[i5 + (i2 << 2) >> 2] | 0) - (HEAP32[i4 + (i2 << 2) >> 2] | 0) | 0;
    i13 = i2 | 1;
    i14 = (HEAP32[i5 + (i13 << 2) >> 2] | 0) - (HEAP32[i4 + (i13 << 2) >> 2] | 0) | 0;
    HEAP32[i6 + (i2 << 2) >> 2] = (i1 | 0) > -1 ? i1 : 0 - i1 | 0;
    HEAP32[i6 + (i13 << 2) >> 2] = (i14 | 0) > -1 ? i14 : 0 - i14 | 0;
    i13 = i2 | 2;
    i14 = (HEAP32[i5 + (i13 << 2) >> 2] | 0) - (HEAP32[i4 + (i13 << 2) >> 2] | 0) | 0;
    i1 = i2 | 3;
    i12 = (HEAP32[i5 + (i1 << 2) >> 2] | 0) - (HEAP32[i4 + (i1 << 2) >> 2] | 0) | 0;
    HEAP32[i6 + (i13 << 2) >> 2] = (i14 | 0) > -1 ? i14 : 0 - i14 | 0;
    HEAP32[i6 + (i1 << 2) >> 2] = (i12 | 0) > -1 ? i12 : 0 - i12 | 0;
    i2 = i2 + 4 | 0;
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i2 | 0) <= (i1 + -4 | 0));
  }
  if ((i2 | 0) < (i1 | 0)) do {
   i1 = (HEAP32[i5 + (i2 << 2) >> 2] | 0) - (HEAP32[i4 + (i2 << 2) >> 2] | 0) | 0;
   HEAP32[i6 + (i2 << 2) >> 2] = (i1 | 0) > -1 ? i1 : 0 - i1 | 0;
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } while ((i2 | 0) < (i1 | 0));
  i2 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i2 + -1;
  if (!i2) break; else {
   i4 = i4 + (i7 << 2) | 0;
   i5 = i5 + (i8 << 2) | 0;
   i6 = i6 + (i3 << 2) | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function _cvGetDims(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i8;
 do if (i5) {
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = i3 & -65536;
  if (((i2 | 0) == 1111621632 ? (i1 = i5 + 24 | 0, (HEAP32[i1 >> 2] | 0) > 0) : 0) ? (i4 = HEAP32[i5 + 20 >> 2] | 0, (i4 | 0) > 0) : 0) {
   if (!i7) {
    i1 = 2;
    STACKTOP = i8;
    return i1 | 0;
   }
   HEAP32[i7 >> 2] = i4;
   HEAP32[i7 + 4 >> 2] = HEAP32[i1 >> 2];
   i1 = 2;
   STACKTOP = i8;
   return i1 | 0;
  }
  if ((i3 | 0) == 112 ? (HEAP32[i5 + 68 >> 2] | 0) != 0 : 0) {
   if (!i7) {
    i1 = 2;
    STACKTOP = i8;
    return i1 | 0;
   }
   HEAP32[i7 >> 2] = HEAP32[i5 + 44 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 40 >> 2];
   i1 = 2;
   STACKTOP = i8;
   return i1 | 0;
  }
  if ((i2 | 0) == 1111752704) {
   i1 = HEAP32[i5 + 4 >> 2] | 0;
   if (!i7) {
    STACKTOP = i8;
    return i1 | 0;
   }
   _memcpy(i7 | 0, i5 + 36 | 0, i1 << 2 | 0) | 0;
   STACKTOP = i8;
   return i1 | 0;
  } else if ((i2 | 0) != 1111687168) break;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  if (!((i7 | 0) != 0 & (i1 | 0) > 0)) {
   STACKTOP = i8;
   return i1 | 0;
  }
  i2 = i5 + 20 | 0;
  i3 = 0;
  do {
   HEAP32[i7 + (i3 << 2) >> 2] = HEAP32[i2 + (i3 << 3) >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
  STACKTOP = i8;
  return i1 | 0;
 } while (0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i3 = (__ZN2cv6String8allocateEj(i6, 38) | 0) + 0 | 0;
 i2 = 42264 | 0;
 i1 = i3 + 38 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i3 | 0) < (i1 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i6, 42384, 40912, 1147);
 __ZN2cv6String10deallocateEv(i6);
 i1 = -1;
 STACKTOP = i8;
 return i1 | 0;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6ignoreEii(i8, i5, i7) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i9;
 i6 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6sentryC2ERS3_b(i1, i8, 1);
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return i8 | 0;
 }
 L4 : do if ((i5 | 0) == 2147483647) while (1) {
  i2 = HEAP32[i8 + ((HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
  i3 = i2 + 12 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
   i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   if ((i1 | 0) == -1) {
    i1 = 2;
    break L4;
   }
  } else {
   HEAP32[i3 >> 2] = i1 + 1;
   i1 = HEAPU8[i1 >> 0] | 0;
  }
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  if ((i1 | 0) == (i7 | 0)) {
   i1 = 0;
   break;
  }
 } else {
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   if ((i2 | 0) >= (i5 | 0)) {
    i1 = 0;
    break L4;
   }
   i3 = HEAP32[i8 + ((HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
   i1 = i3 + 12 | 0;
   i4 = HEAP32[i1 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
    i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] & 127](i3) | 0;
    if ((i1 | 0) == -1) {
     i1 = 2;
     break L4;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   } else {
    HEAP32[i1 >> 2] = i4 + 1;
    i1 = HEAPU8[i4 >> 0] | 0;
   }
   i2 = i2 + 1 | 0;
   HEAP32[i6 >> 2] = i2;
   if ((i1 | 0) == (i7 | 0)) {
    i1 = 0;
    break;
   }
  }
 } while (0);
 i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i8 + i2 | 0, HEAP32[i8 + (i2 + 16) >> 2] | i1);
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNK7testing8UnitTest21successful_test_countEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 i12 = HEAP32[i1 + 8 >> 2] | 0;
 i11 = i12 + 64 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i12 + 60 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i10 = 0;
  STACKTOP = i13;
  return i10 | 0;
 } else {
  i5 = i1;
  i10 = 0;
  i1 = 0;
 }
 L3 : while (1) {
  i9 = HEAP32[i5 + (i10 << 2) >> 2] | 0;
  i3 = HEAP32[i9 + 20 >> 2] | 0;
  i9 = i9 + 24 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  if ((i3 | 0) == (i4 | 0)) {
   i4 = i5;
   i3 = 0;
  } else {
   i8 = i3;
   i3 = 0;
   do {
    i2 = HEAP32[i8 >> 2] | 0;
    if (HEAP8[i2 + 36 >> 0] | 0) {
     i7 = i2 + 52 | 0;
     i6 = i2 + 56 | 0;
     i2 = HEAP32[i6 >> 2] | 0;
     i5 = HEAP32[i7 >> 2] | 0;
     if ((i2 - i5 | 0) > 0) {
      i4 = i2;
      i2 = 0;
      while (1) {
       if (((i4 - i5 | 0) / 44 | 0) >>> 0 <= i2 >>> 0) {
        i2 = 8;
        break L3;
       }
       if (HEAP32[i5 + (i2 * 44 | 0) >> 2] | 0) {
        i2 = 0;
        break;
       }
       i2 = i2 + 1 | 0;
       i4 = HEAP32[i6 >> 2] | 0;
       if ((i2 | 0) >= ((i4 - i5 | 0) / 44 | 0 | 0)) {
        i2 = 1;
        break;
       }
      }
      i4 = HEAP32[i9 >> 2] | 0;
     } else i2 = 1;
    } else i2 = 0;
    i3 = i2 + i3 | 0;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) != (i4 | 0));
   i2 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i12 >> 2] | 0;
  }
  i1 = i3 + i1 | 0;
  i10 = i10 + 1 | 0;
  if (i10 >>> 0 >= i2 - i4 >> 2 >>> 0) {
   i2 = 14;
   break;
  } else i5 = i4;
 }
 if ((i2 | 0) == 8) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i7); else if ((i2 | 0) == 14) {
  STACKTOP = i13;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cvL13cvtScale64f8sEPKdjPKhjPajNS_5Size_IiEEPd(i6, i4, i1, i2, i7, i17, i3, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, d9 = 0.0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i14 = i4 >>> 3;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 d13 = +Math_fround(+HEAPF64[i5 >> 3]);
 d9 = +Math_fround(+HEAPF64[i5 + 8 >> 3]);
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(d9 + d13 * +HEAPF64[i6 + (i8 << 3) >> 3]) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i2 = i8 | 1;
    i4 = _lrint(d9 + d13 * +HEAPF64[i6 + (i2 << 3) >> 3]) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i8 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i1 = i8 | 2;
    i5 = _lrint(d9 + d13 * +HEAPF64[i6 + (i1 << 3) >> 3]) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i2 = i8 | 3;
    i4 = _lrint(d9 + d13 * +HEAPF64[i6 + (i2 << 3) >> 3]) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(d9 + d13 * +HEAPF64[i6 + (i5 << 3) >> 3]) | 0;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + (i14 << 3) | 0;
   i7 = i7 + i17 | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cvL14mixChannels16uEPPKtPKiPPtS4_ii(i22, i21, i17, i16, i19, i20) {
 i22 = i22 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 if ((i20 | 0) <= 0) {
  STACKTOP = i23;
  return;
 }
 i12 = i19 + -2 | 0;
 i13 = (i12 | 0) < 0;
 i15 = i12 >>> 1;
 i14 = (i15 << 2) + 4 | 0;
 i15 = (i15 << 1) + 2 | 0;
 i18 = 0;
 do {
  i2 = HEAP32[i22 + (i18 << 2) >> 2] | 0;
  i1 = HEAP32[i17 + (i18 << 2) >> 2] | 0;
  i5 = HEAP32[i21 + (i18 << 2) >> 2] | 0;
  i11 = HEAP32[i16 + (i18 << 2) >> 2] | 0;
  if (!i2) {
   if (i13) i2 = 0; else {
    i3 = i11 << 1;
    i2 = Math_imul(i11, i14) | 0;
    i4 = i1;
    i5 = 0;
    while (1) {
     HEAP16[i4 + (i11 << 1) >> 1] = 0;
     HEAP16[i4 >> 1] = 0;
     i5 = i5 + 2 | 0;
     if ((i5 | 0) > (i12 | 0)) break; else i4 = i4 + (i3 << 1) | 0;
    }
    i1 = i1 + i2 | 0;
    i2 = i15;
   }
   if ((i2 | 0) < (i19 | 0)) HEAP16[i1 >> 1] = 0;
  } else {
   if (i13) i3 = 0; else {
    i4 = i5 << 1;
    i3 = i11 << 1;
    i6 = Math_imul(i11, i14) | 0;
    i10 = Math_imul(i5, i14) | 0;
    i7 = i1;
    i8 = 0;
    i9 = i2;
    while (1) {
     i24 = HEAP16[i9 + (i5 << 1) >> 1] | 0;
     HEAP16[i7 >> 1] = HEAP16[i9 >> 1] | 0;
     HEAP16[i7 + (i11 << 1) >> 1] = i24;
     i8 = i8 + 2 | 0;
     if ((i8 | 0) > (i12 | 0)) break; else {
      i7 = i7 + (i3 << 1) | 0;
      i9 = i9 + (i4 << 1) | 0;
     }
    }
    i1 = i1 + i6 | 0;
    i3 = i15;
    i2 = i2 + i10 | 0;
   }
   if ((i3 | 0) < (i19 | 0)) HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
  }
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != (i20 | 0));
 STACKTOP = i23;
 return;
}

function __ZNK2cv3Mat9locateROIERNS_5Size_IiEERNS_6Point_IiEE(i7, i8, i6) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i9;
 i5 = i7 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!((i1 | 0) < 3 ? (HEAP32[HEAP32[i7 + 44 >> 2] >> 2] | 0) != 0 : 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i4, 24) | 0) + 0 | 0;
  i2 = 28352 | 0;
  i1 = i3 + 24 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i4, 28384, 27528, 883);
  __ZN2cv6String10deallocateEv(i4);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if ((i1 | 0) > 0) i4 = HEAP32[(HEAP32[i7 + 44 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0; else i4 = 0;
 i3 = HEAP32[i7 + 16 >> 2] | 0;
 i2 = HEAP32[i7 + 20 >> 2] | 0;
 i5 = i2;
 i1 = i3 - i5 | 0;
 i5 = (HEAP32[i7 + 24 >> 2] | 0) - i5 | 0;
 if ((i3 | 0) == (i2 | 0)) {
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  i1 = 0;
  i2 = HEAP32[i7 + 44 >> 2] | 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i7 + 44 >> 2] | 0;
  i3 = (i1 >>> 0) / ((HEAP32[i2 >> 2] | 0) >>> 0) | 0;
  HEAP32[i6 + 4 >> 2] = i3;
  i1 = ((i1 - (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) | 0) >>> 0) / (i4 >>> 0) | 0;
  HEAP32[i6 >> 2] = i1;
 }
 i6 = (HEAP32[i7 + 12 >> 2] | 0) + i1 | 0;
 i1 = i5 - (Math_imul(i6, i4) | 0) | 0;
 i1 = ((i1 >>> 0) / ((HEAP32[i2 >> 2] | 0) >>> 0) | 0) + 1 | 0;
 i2 = (HEAP32[i7 + 8 >> 2] | 0) + i3 | 0;
 i1 = (i1 | 0) < (i2 | 0) ? i2 : i1;
 HEAP32[i8 + 4 >> 2] = i1;
 i1 = ((i5 - (Math_imul(i1 + -1 | 0, HEAP32[i7 + 48 >> 2] | 0) | 0) | 0) >>> 0) / (i4 >>> 0) | 0;
 HEAP32[i8 >> 2] = (i1 | 0) < (i6 | 0) ? i6 : i1;
 STACKTOP = i9;
 return;
}

function __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (i1 & 16) {
  i2 = i5 + 44 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i5 + 24 >> 2] | 0;
  if (i1 >>> 0 < i3 >>> 0) HEAP32[i2 >> 2] = i3; else i3 = i1;
  i2 = HEAP32[i5 + 20 >> 2] | 0;
  i5 = i3 - i2 | 0;
  if (i5 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  if (i5 >>> 0 < 11) {
   HEAP8[i6 >> 0] = i5 << 1;
   i1 = i6 + 1 | 0;
  } else {
   i4 = i5 + 16 & -16;
   i1 = __Znwj(i4) | 0;
   HEAP32[i6 + 8 >> 2] = i1;
   HEAP32[i6 >> 2] = i4 | 1;
   HEAP32[i6 + 4 >> 2] = i5;
  }
  if ((i2 | 0) != (i3 | 0)) {
   i4 = i1;
   while (1) {
    HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) break; else i4 = i4 + 1 | 0;
   }
   i1 = i1 + i5 | 0;
  }
  HEAP8[i1 >> 0] = 0;
  STACKTOP = i7;
  return;
 }
 if (!(i1 & 8)) {
  HEAP32[i6 + 0 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 i4 = i5 - i2 | 0;
 if (i4 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i6);
 if (i4 >>> 0 < 11) {
  HEAP8[i6 >> 0] = i4 << 1;
  i1 = i6 + 1 | 0;
 } else {
  i3 = i4 + 16 & -16;
  i1 = __Znwj(i3) | 0;
  HEAP32[i6 + 8 >> 2] = i1;
  HEAP32[i6 >> 2] = i3 | 1;
  HEAP32[i6 + 4 >> 2] = i4;
 }
 if ((i2 | 0) != (i5 | 0)) {
  i3 = i1;
  while (1) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i5 | 0)) break; else i3 = i3 + 1 | 0;
  }
  i1 = i1 + i4 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function _init_block(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = 0;
 do {
  HEAP16[i2 + (i1 << 2) + 148 >> 1] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 286);
 HEAP16[i2 + 2440 >> 1] = 0;
 HEAP16[i2 + 2444 >> 1] = 0;
 HEAP16[i2 + 2448 >> 1] = 0;
 HEAP16[i2 + 2452 >> 1] = 0;
 HEAP16[i2 + 2456 >> 1] = 0;
 HEAP16[i2 + 2460 >> 1] = 0;
 HEAP16[i2 + 2464 >> 1] = 0;
 HEAP16[i2 + 2468 >> 1] = 0;
 HEAP16[i2 + 2472 >> 1] = 0;
 HEAP16[i2 + 2476 >> 1] = 0;
 HEAP16[i2 + 2480 >> 1] = 0;
 HEAP16[i2 + 2484 >> 1] = 0;
 HEAP16[i2 + 2488 >> 1] = 0;
 HEAP16[i2 + 2492 >> 1] = 0;
 HEAP16[i2 + 2496 >> 1] = 0;
 HEAP16[i2 + 2500 >> 1] = 0;
 HEAP16[i2 + 2504 >> 1] = 0;
 HEAP16[i2 + 2508 >> 1] = 0;
 HEAP16[i2 + 2512 >> 1] = 0;
 HEAP16[i2 + 2516 >> 1] = 0;
 HEAP16[i2 + 2520 >> 1] = 0;
 HEAP16[i2 + 2524 >> 1] = 0;
 HEAP16[i2 + 2528 >> 1] = 0;
 HEAP16[i2 + 2532 >> 1] = 0;
 HEAP16[i2 + 2536 >> 1] = 0;
 HEAP16[i2 + 2540 >> 1] = 0;
 HEAP16[i2 + 2544 >> 1] = 0;
 HEAP16[i2 + 2548 >> 1] = 0;
 HEAP16[i2 + 2552 >> 1] = 0;
 HEAP16[i2 + 2556 >> 1] = 0;
 HEAP16[i2 + 2684 >> 1] = 0;
 HEAP16[i2 + 2688 >> 1] = 0;
 HEAP16[i2 + 2692 >> 1] = 0;
 HEAP16[i2 + 2696 >> 1] = 0;
 HEAP16[i2 + 2700 >> 1] = 0;
 HEAP16[i2 + 2704 >> 1] = 0;
 HEAP16[i2 + 2708 >> 1] = 0;
 HEAP16[i2 + 2712 >> 1] = 0;
 HEAP16[i2 + 2716 >> 1] = 0;
 HEAP16[i2 + 2720 >> 1] = 0;
 HEAP16[i2 + 2724 >> 1] = 0;
 HEAP16[i2 + 2728 >> 1] = 0;
 HEAP16[i2 + 2732 >> 1] = 0;
 HEAP16[i2 + 2736 >> 1] = 0;
 HEAP16[i2 + 2740 >> 1] = 0;
 HEAP16[i2 + 2744 >> 1] = 0;
 HEAP16[i2 + 2748 >> 1] = 0;
 HEAP16[i2 + 2752 >> 1] = 0;
 HEAP16[i2 + 2756 >> 1] = 0;
 HEAP16[i2 + 1172 >> 1] = 1;
 HEAP32[i2 + 5804 >> 2] = 0;
 HEAP32[i2 + 5800 >> 2] = 0;
 HEAP32[i2 + 5808 >> 2] = 0;
 HEAP32[i2 + 5792 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN2cvL14mixChannels32sEPPKiS1_PPiS1_ii(i22, i21, i17, i16, i19, i20) {
 i22 = i22 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 if ((i20 | 0) <= 0) {
  STACKTOP = i23;
  return;
 }
 i12 = i19 + -2 | 0;
 i13 = (i12 | 0) < 0;
 i15 = i12 >>> 1;
 i14 = (i15 << 3) + 8 | 0;
 i15 = (i15 << 1) + 2 | 0;
 i18 = 0;
 do {
  i2 = HEAP32[i22 + (i18 << 2) >> 2] | 0;
  i1 = HEAP32[i17 + (i18 << 2) >> 2] | 0;
  i5 = HEAP32[i21 + (i18 << 2) >> 2] | 0;
  i11 = HEAP32[i16 + (i18 << 2) >> 2] | 0;
  if (!i2) {
   if (i13) i2 = 0; else {
    i3 = i11 << 1;
    i2 = Math_imul(i11, i14) | 0;
    i4 = i1;
    i5 = 0;
    while (1) {
     HEAP32[i4 + (i11 << 2) >> 2] = 0;
     HEAP32[i4 >> 2] = 0;
     i5 = i5 + 2 | 0;
     if ((i5 | 0) > (i12 | 0)) break; else i4 = i4 + (i3 << 2) | 0;
    }
    i1 = i1 + i2 | 0;
    i2 = i15;
   }
   if ((i2 | 0) < (i19 | 0)) HEAP32[i1 >> 2] = 0;
  } else {
   if (i13) i3 = 0; else {
    i4 = i5 << 1;
    i3 = i11 << 1;
    i6 = Math_imul(i11, i14) | 0;
    i10 = Math_imul(i5, i14) | 0;
    i7 = i1;
    i8 = 0;
    i9 = i2;
    while (1) {
     i24 = HEAP32[i9 + (i5 << 2) >> 2] | 0;
     HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i7 + (i11 << 2) >> 2] = i24;
     i8 = i8 + 2 | 0;
     if ((i8 | 0) > (i12 | 0)) break; else {
      i7 = i7 + (i3 << 2) | 0;
      i9 = i9 + (i4 << 2) | 0;
     }
    }
    i1 = i1 + i6 | 0;
    i3 = i15;
    i2 = i2 + i10 | 0;
   }
   if ((i3 | 0) < (i19 | 0)) HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  }
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != (i20 | 0));
 STACKTOP = i23;
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEx(i12, i6, i7) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i13 + 20 | 0;
 i9 = i13 + 16 | 0;
 i11 = i13 + 8 | 0;
 i1 = i13 + 4 | 0;
 i10 = i13;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i11, i12);
 if (!(HEAP8[i11 >> 0] | 0)) {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i11);
  STACKTOP = i13;
  return i12 | 0;
 }
 __ZNSt3__16localeC2ERKS0_(i1, i12 + ((HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) + 28) | 0);
 i8 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 959416) | 0;
 __ZNSt3__16localeD2Ev(i1);
 i3 = HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0;
 i4 = HEAP32[i12 + (i3 + 24) >> 2] | 0;
 i2 = i12 + (i3 + 76) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  __ZNSt3__16localeC2ERKS0_(i5, i12 + (i3 + 28) | 0);
  i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i5, 960728) | 0;
  i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1, 32) | 0;
  __ZNSt3__16localeD2Ev(i5);
  i1 = i1 << 24 >> 24;
  HEAP32[i2 >> 2] = i1;
 }
 i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i5 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
 FUNCTION_TABLE_viiiiiii[i2 & 63](i10, i8, i5, i12 + i3 | 0, i1 & 255, i6, i7);
 if (HEAP32[i10 >> 2] | 0) {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i11);
  STACKTOP = i13;
  return i12 | 0;
 }
 i10 = HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i12 + i10 | 0, HEAP32[i12 + (i10 + 16) >> 2] | 5);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i11);
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN2cvL14cvtScale16u32sEPKtjPKhjPijNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i11 = i5 >>> 1;
 i1 = i6 >>> 2;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i7 = i15 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = i15 & -4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i5 = 0; else {
   i5 = 0;
   do {
    i10 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i4 + (i5 << 1) >> 1] | 0 | 0)))) | 0;
    i12 = i5 | 1;
    i17 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i4 + (i12 << 1) >> 1] | 0 | 0)))) | 0;
    HEAP32[i3 + (i5 << 2) >> 2] = i10;
    HEAP32[i3 + (i12 << 2) >> 2] = i17;
    i12 = i5 | 2;
    i17 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i4 + (i12 << 1) >> 1] | 0 | 0)))) | 0;
    i10 = i5 | 3;
    i2 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i4 + (i10 << 1) >> 1] | 0 | 0)))) | 0;
    HEAP32[i3 + (i12 << 2) >> 2] = i17;
    HEAP32[i3 + (i10 << 2) >> 2] = i2;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i7 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAP32[i3 + (i5 << 2) >> 2] = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i4 + (i5 << 1) >> 1] | 0 | 0)))) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i1 << 2) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cv3MataSERKS0_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 if ((i9 | 0) == (i8 | 0)) {
  STACKTOP = i10;
  return i9 | 0;
 }
 i7 = i8 + 36 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1) {
  i1 = i1 + 12 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 }
 i6 = i9 + 36 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i2 = i1 + 12 | 0, i1 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i9);
 HEAP32[i6 >> 2] = 0;
 i4 = i9 + 16 | 0;
 i5 = i9 + 4 | 0;
 HEAP32[i4 + 0 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 if ((HEAP32[i5 >> 2] | 0) > 0) {
  i2 = HEAP32[i9 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i2 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i3 | 0) < (i1 | 0));
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  if ((i1 | 0) < 3) i2 = 12; else i2 = 14;
 } else {
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  i2 = 12;
 }
 if ((i2 | 0) == 12) {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  if ((i1 | 0) < 3) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   i3 = HEAP32[i8 + 44 >> 2] | 0;
   i1 = HEAP32[i9 + 44 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  } else i2 = 14;
 }
 if ((i2 | 0) == 14) __ZN2cv3Mat8copySizeERKS0_(i9, i8);
 HEAP32[i4 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 HEAP32[i9 + 32 >> 2] = HEAP32[i8 + 32 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN2cvL14addWeighted64fEPKdjS1_jPdjNS_5Size_IiEEPv(i12, i3, i6, i4, i7, i5, i1, i2) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, d15 = 0.0, d16 = 0.0, d17 = 0.0, i18 = 0, i19 = 0, d20 = 0.0;
 i19 = STACKTOP;
 i18 = HEAP32[i1 >> 2] | 0;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 d16 = +HEAPF64[i2 >> 3];
 d17 = +HEAPF64[i2 + 8 >> 3];
 d15 = +HEAPF64[i2 + 16 >> 3];
 i14 = i3 >>> 3;
 i13 = i4 >>> 3;
 i1 = i5 >>> 3;
 if (!i11) {
  STACKTOP = i19;
  return;
 }
 i8 = i18 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i10 = (i8 | 0) > 3 ? i18 & -4 : 4;
 i2 = i7;
 i3 = i12;
 i4 = i11;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i11 = i5 | 1;
    d20 = d15 + (d16 * +HEAPF64[i3 + (i11 << 3) >> 3] + d17 * +HEAPF64[i6 + (i11 << 3) >> 3]);
    HEAPF64[i2 + (i5 << 3) >> 3] = d15 + (d16 * +HEAPF64[i3 + (i5 << 3) >> 3] + d17 * +HEAPF64[i6 + (i5 << 3) >> 3]);
    HEAPF64[i2 + (i11 << 3) >> 3] = d20;
    i11 = i5 | 2;
    i7 = i5 | 3;
    d20 = d15 + (d16 * +HEAPF64[i3 + (i7 << 3) >> 3] + d17 * +HEAPF64[i6 + (i7 << 3) >> 3]);
    HEAPF64[i2 + (i11 << 3) >> 3] = d15 + (d16 * +HEAPF64[i3 + (i11 << 3) >> 3] + d17 * +HEAPF64[i6 + (i11 << 3) >> 3]);
    HEAPF64[i2 + (i7 << 3) >> 3] = d20;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i18 | 0)) do {
   HEAPF64[i2 + (i5 << 3) >> 3] = d15 + (d16 * +HEAPF64[i3 + (i5 << 3) >> 3] + d17 * +HEAPF64[i6 + (i5 << 3) >> 3]);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i18 | 0));
  if (!i4) break; else {
   i6 = i6 + (i13 << 3) | 0;
   i2 = i2 + (i1 << 3) | 0;
   i3 = i3 + (i14 << 3) | 0;
  }
 }
 STACKTOP = i19;
 return;
}

function _cvErrorStr(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i3;
 do switch (i1 | 0) {
 case -13:
  {
   i1 = 26016;
   break;
  }
 case -15:
  {
   i1 = 26368;
   break;
  }
 case -206:
  {
   i1 = 26392;
   break;
  }
 case -3:
  {
   i1 = 25832;
   break;
  }
 case -27:
  {
   i1 = 25968;
   break;
  }
 case -7:
  {
   i1 = 25888;
   break;
  }
 case -202:
  {
   i1 = 25984;
   break;
  }
 case -210:
  {
   i1 = 26288;
   break;
  }
 case -24:
  {
   i1 = 26336;
   break;
  }
 case -214:
  {
   i1 = 26552;
   break;
  }
 case -215:
  {
   i1 = 26584;
   break;
  }
 case -1:
  {
   i1 = 25792;
   break;
  }
 case -212:
  {
   i1 = 26496;
   break;
  }
 case -213:
  {
   i1 = 26512;
   break;
  }
 case -2:
  {
   i1 = 25808;
   break;
  }
 case -203:
  {
   i1 = 26040;
   break;
  }
 case -204:
  {
   i1 = 26080;
   break;
  }
 case -8:
  {
   i1 = 25920;
   break;
  }
 case -17:
  {
   i1 = 26112;
   break;
  }
 case -205:
  {
   i1 = 26160;
   break;
  }
 case -4:
  {
   i1 = 25848;
   break;
  }
 case -207:
  {
   i1 = 26432;
   break;
  }
 case -208:
  {
   i1 = 26464;
   break;
  }
 case -209:
  {
   i1 = 26200;
   break;
  }
 case -211:
  {
   i1 = 26240;
   break;
  }
 case -5:
  {
   i1 = 25872;
   break;
  }
 case -216:
  {
   i1 = 26608;
   break;
  }
 case -217:
  {
   i1 = 26624;
   break;
  }
 case -201:
  {
   i1 = 25936;
   break;
  }
 case -218:
  {
   i1 = 26640;
   break;
  }
 case -219:
  {
   i1 = 26664;
   break;
  }
 case 0:
  {
   i1 = 25776;
   break;
  }
 default:
  {
   HEAP32[i2 >> 2] = (i1 | 0) > -1 ? 26704 : 26712;
   HEAP32[i2 + 4 >> 2] = i1;
   _sprintf(25520, 26680, i2) | 0;
   i1 = 25520;
  }
 } while (0);
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNK7testing8internal8FilePath28CreateDirectoriesRecursivelyEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 i8 = i10 + 100 | 0;
 i6 = i10 + 24 | 0;
 i9 = i10 + 12 | 0;
 i5 = i10;
 i3 = HEAP8[i7 >> 0] | 0;
 i4 = (i3 & 1) == 0;
 if (i4) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i7 + 4 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  STACKTOP = i10;
  return i1 | 0;
 }
 if (i4) {
  i1 = (i3 & 255) >>> 1;
  i2 = i7 + 1 | 0;
 } else {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = HEAP32[i7 + 8 >> 2] | 0;
 }
 if ((HEAP8[i2 + (i1 + -1) >> 0] | 0) != 47) {
  i1 = 0;
  STACKTOP = i10;
  return i1 | 0;
 }
 if (i4) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i7 + 4 >> 2] | 0;
 if (!i1) {
  i1 = 1;
  STACKTOP = i10;
  return i1 | 0;
 }
 if (i4) i1 = i7 + 1 | 0; else i1 = HEAP32[i7 + 8 >> 2] | 0;
 if ((_stat(i1 | 0, i6 | 0) | 0) == 0 ? (HEAP32[i6 + 12 >> 2] & 61440 | 0) == 16384 : 0) {
  i1 = 1;
  STACKTOP = i10;
  return i1 | 0;
 }
 __ZNK7testing8internal8FilePath27RemoveTrailingPathSeparatorEv(i5, i7);
 __ZNK7testing8internal8FilePath14RemoveFileNameEv(i9, i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 if (__ZNK7testing8internal8FilePath28CreateDirectoriesRecursivelyEv(i9) | 0) {
  if (!(HEAP8[i7 >> 0] & 1)) i1 = i7 + 1 | 0; else i1 = HEAP32[i7 + 8 >> 2] | 0;
  if ((_mkdir(i1 | 0, 511) | 0) == -1) {
   if (!(HEAP8[i7 >> 0] & 1)) i1 = i7 + 1 | 0; else i1 = HEAP32[i7 + 8 >> 2] | 0;
   if (!(_stat(i1 | 0, i8 | 0) | 0)) i1 = (HEAP32[i8 + 12 >> 2] & 61440 | 0) == 16384; else i1 = 0;
  } else i1 = 1;
 } else i1 = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEf(i11, f9) {
 i11 = i11 | 0;
 f9 = Math_fround(f9);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i12 + 20 | 0;
 i6 = i12 + 16 | 0;
 i10 = i12 + 8 | 0;
 i1 = i12 + 4 | 0;
 i7 = i12;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i10, i11);
 if (!(HEAP8[i10 >> 0] | 0)) {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
  STACKTOP = i12;
  return i11 | 0;
 }
 __ZNSt3__16localeC2ERKS0_(i1, i11 + ((HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) + 28) | 0);
 i8 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 959416) | 0;
 __ZNSt3__16localeD2Ev(i1);
 i3 = HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0;
 i4 = HEAP32[i11 + (i3 + 24) >> 2] | 0;
 i2 = i11 + (i3 + 76) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  __ZNSt3__16localeC2ERKS0_(i5, i11 + (i3 + 28) | 0);
  i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i5, 960728) | 0;
  i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1, 32) | 0;
  __ZNSt3__16localeD2Ev(i5);
  i1 = i1 << 24 >> 24;
  HEAP32[i2 >> 2] = i1;
 }
 i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i5 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
 FUNCTION_TABLE_viiiiid[i2 & 7](i7, i8, i5, i11 + i3 | 0, i1 & 255, +f9);
 if (HEAP32[i7 >> 2] | 0) {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
  STACKTOP = i12;
  return i11 | 0;
 }
 i8 = HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i11 + i8 | 0, HEAP32[i11 + (i8 + 16) >> 2] | 5);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN2cvL9cvt64f16sEPKdjPKhjPsjNS_5Size_IiEEPd(i7, i5, i1, i2, i8, i6, i4, i3) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 i14 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i13 = i5 >>> 3;
 i11 = i6 >>> 1;
 if (!i4) {
  STACKTOP = i15;
  return;
 }
 i12 = i14 + -4 | 0;
 i9 = (i12 | 0) < 0;
 i10 = (i12 | 0) > 3 ? i14 & -4 : 4;
 i1 = i4;
 while (1) {
  i1 = i1 + -1 | 0;
  if (i9) i5 = 0; else {
   i2 = 0;
   do {
    i5 = _lrint(+HEAPF64[i7 + (i2 << 3) >> 3]) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i4 = i2 | 1;
    i6 = _lrint(+HEAPF64[i7 + (i4 << 3) >> 3]) | 0;
    if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i2 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i3 = i2 | 2;
    i6 = _lrint(+HEAPF64[i7 + (i3 << 3) >> 3]) | 0;
    if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
    i4 = i2 | 3;
    i5 = _lrint(+HEAPF64[i7 + (i4 << 3) >> 3]) | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i3 << 1) >> 1] = i6;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) <= (i12 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i14 | 0)) do {
   i4 = _lrint(+HEAPF64[i7 + (i5 << 3) >> 3]) | 0;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if (!i1) break; else {
   i7 = i7 + (i13 << 3) | 0;
   i8 = i8 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function _mbsnrtowcs(i2, i13, i5, i1, i10) {
 i2 = i2 | 0;
 i13 = i13 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i8 = i14 + 8 | 0;
 i12 = i14;
 i4 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i4;
 i11 = (i2 | 0) != 0;
 i1 = i11 ? i1 : 256;
 i3 = i11 ? i2 : i8;
 L1 : do if ((i4 | 0) != 0 & (i1 | 0) != 0) {
  i6 = i1;
  i7 = i5;
  i1 = 0;
  while (1) {
   i2 = i7 >>> 2;
   i5 = i2 >>> 0 >= i6 >>> 0;
   if (!(i5 | i7 >>> 0 > 131)) {
    i5 = i7;
    i9 = 7;
    break L1;
   }
   i5 = i5 ? i6 : i2;
   i2 = i7 - i5 | 0;
   i5 = _mbsrtowcs(i3, i12, i5, i10) | 0;
   if ((i5 | 0) == -1) {
    i1 = -1;
    break L1;
   }
   if ((i3 | 0) == (i8 | 0)) i3 = i8; else {
    i6 = i6 - i5 | 0;
    i3 = i3 + (i5 << 2) | 0;
   }
   i1 = i5 + i1 | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   if ((i4 | 0) != 0 & (i6 | 0) != 0) i7 = i2; else {
    i5 = i2;
    i9 = 7;
    break;
   }
  }
 } else {
  i6 = i1;
  i1 = 0;
  i9 = 7;
 } while (0);
 L9 : do if ((i9 | 0) == 7) if ((i4 | 0) != 0 & (i6 | 0) != 0 & (i5 | 0) != 0) {
  while (1) {
   i2 = _mbrtowc(i3, i4, i5, i10) | 0;
   if ((i2 + 2 | 0) >>> 0 < 3) break;
   i4 = (HEAP32[i12 >> 2] | 0) + i2 | 0;
   HEAP32[i12 >> 2] = i4;
   i6 = i6 + -1 | 0;
   i1 = i1 + 1 | 0;
   if (!((i6 | 0) != 0 & (i5 | 0) != (i2 | 0))) break L9; else {
    i5 = i5 - i2 | 0;
    i3 = i3 + 4 | 0;
   }
  }
  if (!i2) {
   HEAP32[i12 >> 2] = 0;
   break;
  } else if ((i2 | 0) == -1) {
   i1 = -1;
   break;
  } else {
   HEAP32[i10 >> 2] = 0;
   break;
  }
 } while (0);
 if (!i11) {
  STACKTOP = i14;
  return i1 | 0;
 }
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 STACKTOP = i14;
 return i1 | 0;
}

function __ZNK7testing8internal12UnitTestImpl17failed_test_countEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 i10 = i2 + 64 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i9 = i2 + 60 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i10 = 0;
  STACKTOP = i15;
  return i10 | 0;
 } else {
  i5 = i1;
  i8 = 0;
  i1 = 0;
 }
 L3 : while (1) {
  i7 = HEAP32[i2 + (i8 << 2) >> 2] | 0;
  i3 = HEAP32[i7 + 20 >> 2] | 0;
  i7 = i7 + 24 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if ((i3 | 0) == (i4 | 0)) {
   i4 = i5;
   i3 = 0;
  } else {
   i6 = i3;
   i3 = 0;
   do {
    i2 = HEAP32[i6 >> 2] | 0;
    if ((HEAP8[i2 + 36 >> 0] | 0) != 0 ? (i14 = i2 + 52 | 0, i11 = i2 + 56 | 0, i12 = HEAP32[i11 >> 2] | 0, i13 = HEAP32[i14 >> 2] | 0, (i12 - i13 | 0) > 0) : 0) {
     i4 = i13;
     i2 = i12;
     i5 = 0;
     while (1) {
      if (((i2 - i4 | 0) / 44 | 0) >>> 0 <= i5 >>> 0) {
       i2 = 8;
       break L3;
      }
      if (HEAP32[i4 + (i5 * 44 | 0) >> 2] | 0) {
       i2 = 1;
       break;
      }
      i5 = i5 + 1 | 0;
      i2 = HEAP32[i11 >> 2] | 0;
      if ((i5 | 0) >= ((i2 - i4 | 0) / 44 | 0 | 0)) {
       i2 = 0;
       break;
      }
     }
     i4 = HEAP32[i7 >> 2] | 0;
    } else i2 = 0;
    i3 = i2 + i3 | 0;
    i6 = i6 + 4 | 0;
   } while ((i6 | 0) != (i4 | 0));
   i4 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
  }
  i1 = i3 + i1 | 0;
  i8 = i8 + 1 | 0;
  if (i8 >>> 0 >= i4 - i2 >> 2 >>> 0) {
   i2 = 14;
   break;
  } else i5 = i4;
 }
 if ((i2 | 0) == 8) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i14); else if ((i2 | 0) == 14) {
  STACKTOP = i15;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEj(i11, i9) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i12 + 20 | 0;
 i6 = i12 + 16 | 0;
 i10 = i12 + 8 | 0;
 i1 = i12 + 4 | 0;
 i7 = i12;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i10, i11);
 if (!(HEAP8[i10 >> 0] | 0)) {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
  STACKTOP = i12;
  return i11 | 0;
 }
 __ZNSt3__16localeC2ERKS0_(i1, i11 + ((HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) + 28) | 0);
 i8 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 959416) | 0;
 __ZNSt3__16localeD2Ev(i1);
 i3 = HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0;
 i4 = HEAP32[i11 + (i3 + 24) >> 2] | 0;
 i2 = i11 + (i3 + 76) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  __ZNSt3__16localeC2ERKS0_(i5, i11 + (i3 + 28) | 0);
  i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i5, 960728) | 0;
  i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1, 32) | 0;
  __ZNSt3__16localeD2Ev(i5);
  i1 = i1 << 24 >> 24;
  HEAP32[i2 >> 2] = i1;
 }
 i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i5 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
 FUNCTION_TABLE_viiiiii[i2 & 31](i7, i8, i5, i11 + i3 | 0, i1 & 255, i9);
 if (HEAP32[i7 >> 2] | 0) {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
  STACKTOP = i12;
  return i11 | 0;
 }
 i9 = HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i11 + i9 | 0, HEAP32[i11 + (i9 + 16) >> 2] | 5);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i11, i9) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i12 + 20 | 0;
 i6 = i12 + 16 | 0;
 i10 = i12 + 8 | 0;
 i1 = i12 + 4 | 0;
 i7 = i12;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i10, i11);
 if (!(HEAP8[i10 >> 0] | 0)) {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
  STACKTOP = i12;
  return i11 | 0;
 }
 __ZNSt3__16localeC2ERKS0_(i1, i11 + ((HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) + 28) | 0);
 i8 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 959416) | 0;
 __ZNSt3__16localeD2Ev(i1);
 i3 = HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0;
 i4 = HEAP32[i11 + (i3 + 24) >> 2] | 0;
 i2 = i11 + (i3 + 76) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  __ZNSt3__16localeC2ERKS0_(i5, i11 + (i3 + 28) | 0);
  i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i5, 960728) | 0;
  i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1, 32) | 0;
  __ZNSt3__16localeD2Ev(i5);
  i1 = i1 << 24 >> 24;
  HEAP32[i2 >> 2] = i1;
 }
 i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i5 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
 FUNCTION_TABLE_viiiiii[i2 & 31](i7, i8, i5, i11 + i3 | 0, i1 & 255, i9);
 if (HEAP32[i7 >> 2] | 0) {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
  STACKTOP = i12;
  return i11 | 0;
 }
 i9 = HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i11 + i9 | 0, HEAP32[i11 + (i9 + 16) >> 2] | 5);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN2cvL8cvt16s8sEPKsjPKhjPajNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i16, i4, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i16 = i16 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 i14 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 1;
 if (!i4) {
  STACKTOP = i15;
  return;
 }
 i12 = i14 + -4 | 0;
 i13 = (i12 | 0) < 0;
 i10 = i14 & -4;
 i9 = i4;
 while (1) {
  i9 = i9 + -1 | 0;
  if (i13) i5 = 0; else {
   i8 = 0;
   do {
    i5 = HEAP16[i6 + (i8 << 1) >> 1] | 0;
    i4 = i5 << 16 >> 16;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = i5 << 16 >> 16 > 0 ? 127 : -128;
    i2 = i8 | 1;
    i3 = HEAP16[i6 + (i2 << 1) >> 1] | 0;
    i5 = i3 << 16 >> 16;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = i3 << 16 >> 16 > 0 ? 127 : -128;
    HEAP8[i7 + i8 >> 0] = i4;
    HEAP8[i7 + i2 >> 0] = i5;
    i1 = i8 | 2;
    i5 = HEAP16[i6 + (i1 << 1) >> 1] | 0;
    i4 = i5 << 16 >> 16;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = i5 << 16 >> 16 > 0 ? 127 : -128;
    i2 = i8 | 3;
    i3 = HEAP16[i6 + (i2 << 1) >> 1] | 0;
    i5 = i3 << 16 >> 16;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = i3 << 16 >> 16 > 0 ? 127 : -128;
    HEAP8[i7 + i1 >> 0] = i4;
    HEAP8[i7 + i2 >> 0] = i5;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i12 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i14 | 0)) do {
   i3 = HEAP16[i6 + (i5 << 1) >> 1] | 0;
   i4 = i3 << 16 >> 16;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = i3 << 16 >> 16 > 0 ? 127 : -128;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if (!i9) break; else {
   i6 = i6 + (i11 << 1) | 0;
   i7 = i7 + i16 | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN2cv16FileNodeIteratorC2EPK13CvFileStoragePK10CvFileNodej(i7, i2, i4, i6) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 if ((i2 | 0) != 0 & (i4 | 0) != 0 ? (i1 = HEAP32[i4 >> 2] | 0, i3 = i1 & 7, (i3 | 0) != 0) : 0) {
  HEAP32[i7 >> 2] = i2;
  i5 = i7 + 4 | 0;
  HEAP32[i5 >> 2] = i4;
  if ((i1 & 16 | 0) == 0 & (i3 + -5 | 0) >>> 0 < 2) {
   i2 = i4 + 8 | 0;
   _cvStartReadSeq(HEAP32[i2 >> 2] | 0, i7 + 8 | 0, 0);
   i1 = HEAP32[i4 >> 2] & 7;
   if ((i1 | 0) == 6) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0; else if (!i1) i1 = 0; else if ((i1 | 0) == 5) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0; else i1 = 1;
   HEAP32[i7 + 40 >> 2] = i1;
   i3 = i1;
  } else {
   HEAP32[i7 + 20 >> 2] = i4;
   HEAP32[i7 + 12 >> 2] = 0;
   HEAP32[i7 + 40 >> 2] = 1;
   i3 = 1;
  }
  if (!i6) {
   STACKTOP = i8;
   return;
  }
  if ((i6 | 0) > 0) i1 = (i3 | 0) < (i6 | 0) ? i3 : i6; else {
   i1 = HEAP32[i5 >> 2] | 0;
   do if (i1) {
    i2 = HEAP32[i1 >> 2] & 7;
    if ((i2 | 0) == 6) {
     i1 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 60 >> 2] | 0;
     break;
    } else if ((i2 | 0) == 5) {
     i1 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 24 >> 2] | 0;
     break;
    } else if (!i2) {
     i1 = 0;
     break;
    } else {
     i1 = 1;
     break;
    }
   } else i1 = 0; while (0);
   i2 = i3 - i6 | 0;
   i1 = i3 - (i1 >>> 0 < i2 >>> 0 ? i1 : i2) | 0;
  }
  HEAP32[i7 + 40 >> 2] = i3 - i1;
  if (!(HEAP32[i7 + 12 >> 2] | 0)) {
   STACKTOP = i8;
   return;
  }
  _cvSetSeqReaderPos(i7 + 8 | 0, i1, 1);
  STACKTOP = i8;
  return;
 }
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 40 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function _cvReleaseMat(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i7 + 8 | 0;
 i1 = i7;
 if (!i3) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-9, i2, 41144, 40912, 189);
  __ZN2cv6String10deallocateEv(i2);
 }
 i6 = HEAP32[i3 >> 2] | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[i6 >> 2] & -65536;
 if ((i2 | 0) == 1111621632) {
  if (!((HEAP32[i6 + 24 >> 2] | 0) > -1 ? (HEAP32[i6 + 20 >> 2] | 0) > -1 : 0)) i4 = 7;
 } else if ((i2 | 0) != 1111687168) i4 = 7;
 if ((i4 | 0) == 7) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-206, i1, 41144, 40912, 196);
  __ZN2cv6String10deallocateEv(i1);
 }
 HEAP32[i3 >> 2] = 0;
 i1 = HEAP32[i6 >> 2] & -65536;
 if ((i1 | 0) == 1111687168) {
  i1 = i6 + 16 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   HEAP32[i1 >> 2] = 0;
   i2 = i6 + 8 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) != 0 ? (i3 = (HEAP32[i1 >> 2] | 0) + -1 | 0, HEAP32[i1 >> 2] = i3, (i3 | 0) == 0) : 0) {
    _cvFree_(HEAP32[i2 >> 2] | 0);
    HEAP32[i2 >> 2] = 0;
   }
   HEAP32[i2 >> 2] = 0;
  }
 } else if ((((i1 | 0) == 1111621632 ? (HEAP32[i6 + 24 >> 2] | 0) > 0 : 0) ? (HEAP32[i6 + 20 >> 2] | 0) > 0 : 0) ? (i5 = i6 + 16 | 0, (HEAP32[i5 >> 2] | 0) != 0) : 0) {
  HEAP32[i5 >> 2] = 0;
  i1 = i6 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i3 = (HEAP32[i2 >> 2] | 0) + -1 | 0, HEAP32[i2 >> 2] = i3, (i3 | 0) == 0) : 0) {
   _cvFree_(HEAP32[i1 >> 2] | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
 }
 _cvFree_(i6);
 STACKTOP = i7;
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd(i11, d9) {
 i11 = i11 | 0;
 d9 = +d9;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i12 + 20 | 0;
 i6 = i12 + 16 | 0;
 i10 = i12 + 8 | 0;
 i1 = i12 + 4 | 0;
 i7 = i12;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i10, i11);
 if (!(HEAP8[i10 >> 0] | 0)) {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
  STACKTOP = i12;
  return i11 | 0;
 }
 __ZNSt3__16localeC2ERKS0_(i1, i11 + ((HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) + 28) | 0);
 i8 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 959416) | 0;
 __ZNSt3__16localeD2Ev(i1);
 i3 = HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0;
 i4 = HEAP32[i11 + (i3 + 24) >> 2] | 0;
 i2 = i11 + (i3 + 76) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  __ZNSt3__16localeC2ERKS0_(i5, i11 + (i3 + 28) | 0);
  i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i5, 960728) | 0;
  i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1, 32) | 0;
  __ZNSt3__16localeD2Ev(i5);
  i1 = i1 << 24 >> 24;
  HEAP32[i2 >> 2] = i1;
 }
 i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i5 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
 FUNCTION_TABLE_viiiiid[i2 & 7](i7, i8, i5, i11 + i3 | 0, i1 & 255, d9);
 if (HEAP32[i7 >> 2] | 0) {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
  STACKTOP = i12;
  return i11 | 0;
 }
 i8 = HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i11 + i8 | 0, HEAP32[i11 + (i8 + 16) >> 2] | 5);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN7testing7MessageC2ERKS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i7 = i5 + 12 | 0;
 i3 = i5;
 i6 = __Znwj(144) | 0;
 i9 = i6 + 64 | 0;
 i4 = i6 + 8 | 0;
 HEAP32[i4 >> 2] = 2640;
 i8 = i6 + 12 | 0;
 HEAP32[i6 >> 2] = 2788;
 HEAP32[i9 >> 2] = 2808;
 HEAP32[i6 + 4 >> 2] = 0;
 __ZNSt3__18ios_base4initEPv(i9, i8);
 HEAP32[i6 + 136 >> 2] = 0;
 HEAP32[i6 + 140 >> 2] = -1;
 HEAP32[i6 >> 2] = 2620;
 HEAP32[i9 >> 2] = 2660;
 HEAP32[i4 >> 2] = 2640;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i8);
 HEAP32[i8 >> 2] = 2952;
 i9 = i6 + 44 | 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i6 + 60 >> 2] = 24;
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i8, i7);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 HEAP32[i2 >> 2] = i6;
 __ZNK7testing7Message9GetStringEv(i3, i1);
 i1 = HEAP8[i3 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i3 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, i2, i1) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
  STACKTOP = i5;
  return;
 } else {
  i2 = HEAP32[i3 + 8 >> 2] | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i4, i2, i1) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN2cvL14cvtScale16u32fEPKtjPKhjPfjNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i11 = i5 >>> 1;
 i1 = i6 >>> 2;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i7 = i15 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = (i7 | 0) > 3 ? i15 & -4 : 4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i5 = 0; else {
   i5 = 0;
   do {
    f17 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i4 + (i5 << 1) >> 1] | 0 | 0)));
    i2 = i5 | 1;
    f18 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i4 + (i2 << 1) >> 1] | 0 | 0)));
    HEAPF32[i3 + (i5 << 2) >> 2] = f17;
    HEAPF32[i3 + (i2 << 2) >> 2] = f18;
    i2 = i5 | 2;
    f18 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i4 + (i2 << 1) >> 1] | 0 | 0)));
    i10 = i5 | 3;
    f17 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i4 + (i10 << 1) >> 1] | 0 | 0)));
    HEAPF32[i3 + (i2 << 2) >> 2] = f18;
    HEAPF32[i3 + (i10 << 2) >> 2] = f17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i7 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAPF32[i3 + (i5 << 2) >> 2] = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPU16[i4 + (i5 << 1) >> 1] | 0 | 0)));
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i1 << 2) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cvL16transposeI_32sC8EPhji(i3, i7, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) > 0) i4 = 0; else {
  STACKTOP = i8;
  return;
 }
 do {
  i1 = i3 + (Math_imul(i4, i7) | 0) | 0;
  i2 = i4 << 5;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) < (i6 | 0)) {
   i5 = i4;
   do {
    i19 = i1 + (i5 << 5) | 0;
    i9 = (Math_imul(i5, i7) | 0) + i2 | 0;
    i17 = i3 + i9 | 0;
    i18 = HEAP32[i19 >> 2] | 0;
    i16 = HEAP32[i1 + (i5 << 5) + 4 >> 2] | 0;
    i15 = HEAP32[i1 + (i5 << 5) + 8 >> 2] | 0;
    i14 = HEAP32[i1 + (i5 << 5) + 12 >> 2] | 0;
    i13 = HEAP32[i1 + (i5 << 5) + 16 >> 2] | 0;
    i12 = HEAP32[i1 + (i5 << 5) + 20 >> 2] | 0;
    i11 = HEAP32[i1 + (i5 << 5) + 24 >> 2] | 0;
    i10 = HEAP32[i1 + (i5 << 5) + 28 >> 2] | 0;
    HEAP32[i19 + 0 >> 2] = HEAP32[i17 + 0 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
    HEAP32[i19 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
    HEAP32[i19 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
    HEAP32[i19 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
    HEAP32[i19 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
    HEAP32[i19 + 24 >> 2] = HEAP32[i17 + 24 >> 2];
    HEAP32[i19 + 28 >> 2] = HEAP32[i17 + 28 >> 2];
    HEAP32[i17 >> 2] = i18;
    HEAP32[i3 + (i9 + 4) >> 2] = i16;
    HEAP32[i3 + (i9 + 8) >> 2] = i15;
    HEAP32[i3 + (i9 + 12) >> 2] = i14;
    HEAP32[i3 + (i9 + 16) >> 2] = i13;
    HEAP32[i3 + (i9 + 20) >> 2] = i12;
    HEAP32[i3 + (i9 + 24) >> 2] = i11;
    HEAP32[i3 + (i9 + 28) >> 2] = i10;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
  }
 } while ((i4 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZN2cvL14cvtScale32f32sEPKfjPKhjPijNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i11 = i5 >>> 2;
 i1 = i6 >>> 2;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i7 = i15 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = i15 & -4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i5 = 0; else {
   i5 = 0;
   do {
    i10 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i4 + (i5 << 2) >> 2])))) | 0;
    i12 = i5 | 1;
    i17 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i4 + (i12 << 2) >> 2])))) | 0;
    HEAP32[i3 + (i5 << 2) >> 2] = i10;
    HEAP32[i3 + (i12 << 2) >> 2] = i17;
    i12 = i5 | 2;
    i17 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i4 + (i12 << 2) >> 2])))) | 0;
    i10 = i5 | 3;
    i2 = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i4 + (i10 << 2) >> 2])))) | 0;
    HEAP32[i3 + (i12 << 2) >> 2] = i17;
    HEAP32[i3 + (i10 << 2) >> 2] = i2;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i7 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAP32[i3 + (i5 << 2) >> 2] = _lrint(+Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i4 + (i5 << 2) >> 2])))) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i1 << 2) | 0;
   i4 = i4 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cv8vBinOp64IdNS_9OpAbsDiffIdEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0, d18 = 0.0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 3;
 i10 = i3 >>> 3;
 i9 = i4 >>> 3;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    d17 = +Math_abs(+(+HEAPF64[i1 + (i3 << 3) >> 3] - +HEAPF64[i5 + (i3 << 3) >> 3]));
    i7 = i3 | 1;
    d18 = +Math_abs(+(+HEAPF64[i1 + (i7 << 3) >> 3] - +HEAPF64[i5 + (i7 << 3) >> 3]));
    HEAPF64[i6 + (i3 << 3) >> 3] = d17;
    HEAPF64[i6 + (i7 << 3) >> 3] = d18;
    i7 = i3 | 2;
    d18 = +Math_abs(+(+HEAPF64[i1 + (i7 << 3) >> 3] - +HEAPF64[i5 + (i7 << 3) >> 3]));
    i8 = i3 | 3;
    d17 = +Math_abs(+(+HEAPF64[i1 + (i8 << 3) >> 3] - +HEAPF64[i5 + (i8 << 3) >> 3]));
    HEAPF64[i6 + (i7 << 3) >> 3] = d18;
    HEAPF64[i6 + (i8 << 3) >> 3] = d17;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   HEAPF64[i6 + (i2 << 3) >> 3] = +Math_abs(+(+HEAPF64[i1 + (i2 << 3) >> 3] - +HEAPF64[i5 + (i2 << 3) >> 3]));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 3) | 0;
   i6 = i6 + (i9 << 3) | 0;
   i1 = i1 + (i11 << 3) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZNK7testing8internal12UnitTestImpl22failed_test_case_countEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i1 = HEAP32[i2 + 60 >> 2] | 0;
 i8 = i2 + 64 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i10 = 0;
  STACKTOP = i16;
  return i10 | 0;
 } else {
  i7 = i1;
  i1 = 0;
 }
 L3 : while (1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((HEAP8[i3 + 52 >> 0] | 0) != 0 ? (i9 = HEAP32[i3 + 20 >> 2] | 0, i10 = i3 + 24 | 0, i11 = HEAP32[i10 >> 2] | 0, (i9 | 0) != (i11 | 0)) : 0) {
   i5 = i9;
   i2 = i11;
   i6 = 0;
   do {
    i3 = HEAP32[i5 >> 2] | 0;
    if ((HEAP8[i3 + 36 >> 0] | 0) != 0 ? (i15 = i3 + 52 | 0, i12 = i3 + 56 | 0, i13 = HEAP32[i12 >> 2] | 0, i14 = HEAP32[i15 >> 2] | 0, (i13 - i14 | 0) > 0) : 0) {
     i3 = i14;
     i2 = i13;
     i4 = 0;
     while (1) {
      if (((i2 - i3 | 0) / 44 | 0) >>> 0 <= i4 >>> 0) {
       i2 = 9;
       break L3;
      }
      if (HEAP32[i3 + (i4 * 44 | 0) >> 2] | 0) {
       i3 = 1;
       break;
      }
      i4 = i4 + 1 | 0;
      i2 = HEAP32[i12 >> 2] | 0;
      if ((i4 | 0) >= ((i2 - i3 | 0) / 44 | 0 | 0)) {
       i3 = 0;
       break;
      }
     }
     i2 = HEAP32[i10 >> 2] | 0;
    } else i3 = 0;
    i6 = i3 + i6 | 0;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) != (i2 | 0));
   i3 = (i6 | 0) > 0;
   i2 = HEAP32[i8 >> 2] | 0;
  } else i3 = 0;
  i1 = (i3 & 1) + i1 | 0;
  i7 = i7 + 4 | 0;
  if ((i7 | 0) == (i2 | 0)) {
   i2 = 15;
   break;
  }
 }
 if ((i2 | 0) == 9) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i15); else if ((i2 | 0) == 15) {
  STACKTOP = i16;
  return i1 | 0;
 }
 return 0;
}

function __ZN7testing8internal6Random8GenerateEj(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5 + 4 | 0;
 i2 = i5;
 HEAP32[i4 >> 2] = (Math_imul(HEAP32[i4 >> 2] | 0, 1103515245) | 0) + 12345 & 2147483647;
 if (!i3) {
  __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i1, 3, 160160, 1795);
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 160216, 28) | 0, 160248, 45) | 0;
  __ZN7testing8internal8GTestLogD2Ev(i1);
 }
 if (i3 >>> 0 < 2147483649) {
  i1 = HEAP32[i4 >> 2] | 0;
  i1 = (i1 >>> 0) % (i3 >>> 0) | 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i2, 3, 160160, 1797);
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEj(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEj(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 160296, 37) | 0, 160336, 30) | 0, i3) | 0, 160368, 17) | 0, 160392, 42) | 0, -2147483648) | 0, 160440, 2) | 0;
 __ZN7testing8internal8GTestLogD2Ev(i2);
 i1 = HEAP32[i4 >> 2] | 0;
 i1 = (i1 >>> 0) % (i3 >>> 0) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN2cv6vBinOpIhNS_5OpMinIhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i8, i1, i9, i2, i7, i10) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 i6 = i10 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5 + -1;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i5 = i2;
 i2 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i2 = 0;
   while (1) {
    i4 = HEAPU8[i3 + i2 >> 0] | 0;
    i13 = i2 | 1;
    i14 = HEAPU8[i3 + i13 >> 0] | 0;
    i14 = i14 - (HEAPU8[36320 + ((i14 | 256) - (HEAPU8[i1 + i13 >> 0] | 0)) >> 0] | 0) & 255;
    HEAP8[i5 + i2 >> 0] = i4 - (HEAPU8[36320 + ((i4 | 256) - (HEAPU8[i1 + i2 >> 0] | 0)) >> 0] | 0);
    HEAP8[i5 + i13 >> 0] = i14;
    i13 = i2 | 2;
    i14 = HEAPU8[i3 + i13 >> 0] | 0;
    i4 = i2 | 3;
    i12 = HEAPU8[i3 + i4 >> 0] | 0;
    i12 = i12 - (HEAPU8[36320 + ((i12 | 256) - (HEAPU8[i1 + i4 >> 0] | 0)) >> 0] | 0) & 255;
    HEAP8[i5 + i13 >> 0] = i14 - (HEAPU8[36320 + ((i14 | 256) - (HEAPU8[i1 + i13 >> 0] | 0)) >> 0] | 0);
    HEAP8[i5 + i4 >> 0] = i12;
    i4 = i2 + 4 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) > (i2 + -4 | 0)) break; else i2 = i4;
   }
  }
  if ((i4 | 0) < (i2 | 0)) do {
   i2 = HEAPU8[i3 + i4 >> 0] | 0;
   HEAP8[i5 + i4 >> 0] = i2 - (HEAPU8[36320 + ((i2 | 256) - (HEAPU8[i1 + i4 >> 0] | 0)) >> 0] | 0);
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + -1;
  if (!i4) break; else {
   i1 = i1 + i9 | 0;
   i5 = i5 + i7 | 0;
   i3 = i3 + i8 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cv4cuda6Stream4NullEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i8;
 __ZN2cv5Mutex4lockEv(18520);
 if (HEAP8[18536] | 0) {
  i1 = HEAP32[4633] | 0;
  __ZN2cv5Mutex6unlockEv(18520);
  STACKTOP = i8;
  return i1 | 0;
 }
 i7 = __Znwj(8) | 0;
 i6 = __Znwj(1) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i3 = (__ZN2cv6String8allocateEj(i1, 44) | 0) + 0 | 0;
 i2 = 18776;
 i4 = i3 + 44 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-216, i1, 18824, 18840, 87);
 __ZN2cv6String10deallocateEv(i1);
 i4 = __Znwj(16) | 0;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = 1;
 HEAP32[i4 >> 2] = 18664;
 HEAP32[i4 + 8 >> 2] = i6;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i1 = __Znwj(16) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i1 >> 2] = 18552;
 HEAP32[i1 + 8 >> 2] = i7;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i3 = HEAP32[4632] | 0;
 HEAP32[4632] = i1;
 HEAP32[4633] = i7;
 if ((i3 | 0) != 0 ? (i7 = i3 + 4 | 0, i6 = HEAP32[i7 >> 2] | 0, HEAP32[i7 >> 2] = i6 + -1, (i6 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 511](i3);
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i3 + -1;
 if ((i3 | 0) == 1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i1 + -1;
 if ((i1 | 0) == 1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] & 511](i4);
 HEAP8[18536] = 1;
 i1 = HEAP32[4633] | 0;
 __ZN2cv5Mutex6unlockEv(18520);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN7testing8internal6String15FormatIntWidth2Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i9 = i3 + 144 | 0;
 i8 = i3;
 i4 = i8 + 64 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i7 >> 2] = 2640;
 i5 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = 2788;
 HEAP32[i4 >> 2] = 2808;
 HEAP32[i8 + 4 >> 2] = 0;
 __ZNSt3__18ios_base4initEPv(i8 + 64 | 0, i5);
 HEAP32[i8 + 136 >> 2] = 0;
 HEAP32[i8 + 140 >> 2] = -1;
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i4 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i5);
 HEAP32[i5 >> 2] = 2952;
 i6 = i8 + 44 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 24;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i5, i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 i9 = i8 + 8 | 0;
 HEAP32[i9 + ((HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 76) >> 2] = 48;
 HEAP32[i9 + ((HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 12) >> 2] = 2;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i9, i2) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i1, i5);
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i8 + 64 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 HEAP32[i5 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i5);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i12, i11, i7, i10, i1, i2, i6) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i13;
 i9 = HEAP32[i11 >> 2] | 0;
 if (!i9) {
  HEAP32[i12 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 i14 = i7;
 i4 = i1 - i14 >> 2;
 i5 = i2 + 12 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = (i3 | 0) > (i4 | 0) ? i3 - i4 | 0 : 0;
 i3 = i10;
 i14 = i3 - i14 | 0;
 i2 = i14 >> 2;
 if ((i14 | 0) > 0 ? (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] & 63](i9, i7, i2) | 0) != (i2 | 0) : 0) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 do if ((i4 | 0) > 0) {
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i8, i4, i6);
  if (!(HEAP8[i8 >> 0] & 1)) i2 = i8 + 4 | 0; else i2 = HEAP32[i8 + 8 >> 2] | 0;
  if ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] & 63](i9, i2, i4) | 0) == (i4 | 0)) {
   __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i8);
   break;
  }
  HEAP32[i11 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i8);
  STACKTOP = i13;
  return;
 } while (0);
 i8 = i1 - i3 | 0;
 i1 = i8 >> 2;
 if ((i8 | 0) > 0 ? (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] & 63](i9, i10, i1) | 0) != (i1 | 0) : 0) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i12 >> 2] = i9;
 STACKTOP = i13;
 return;
}

function __ZN2cvL9cvt32f16uEPKfjPKhjPtjNS_5Size_IiEEPd(i7, i5, i1, i2, i8, i6, i4, i3) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 i14 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i13 = i5 >>> 2;
 i11 = i6 >>> 1;
 if (!i4) {
  STACKTOP = i15;
  return;
 }
 i12 = i14 + -4 | 0;
 i9 = (i12 | 0) < 0;
 i10 = (i12 | 0) > 3 ? i14 & -4 : 4;
 i1 = i4;
 while (1) {
  i1 = i1 + -1 | 0;
  if (i9) i5 = 0; else {
   i2 = 0;
   do {
    i5 = _lrint(+Math_fround(HEAPF32[i7 + (i2 << 2) >> 2])) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i4 = i2 | 1;
    i6 = _lrint(+Math_fround(HEAPF32[i7 + (i4 << 2) >> 2])) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i2 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i3 = i2 | 2;
    i6 = _lrint(+Math_fround(HEAPF32[i7 + (i3 << 2) >> 2])) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    i4 = i2 | 3;
    i5 = _lrint(+Math_fround(HEAPF32[i7 + (i4 << 2) >> 2])) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i3 << 1) >> 1] = i6;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) <= (i12 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i14 | 0)) do {
   i4 = _lrint(+Math_fround(HEAPF32[i7 + (i5 << 2) >> 2])) | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if (!i1) break; else {
   i7 = i7 + (i13 << 2) | 0;
   i8 = i8 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN2cv6vBinOpIaNS_5OpMinIaEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i8, i1, i9, i2, i7, i10) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 i6 = i10 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5 + -1;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i5 = i2;
 i2 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i2 = 0;
   while (1) {
    i4 = HEAP8[i3 + i2 >> 0] | 0;
    i12 = HEAP8[i1 + i2 >> 0] | 0;
    i14 = i2 | 1;
    i15 = HEAP8[i3 + i14 >> 0] | 0;
    i16 = HEAP8[i1 + i14 >> 0] | 0;
    HEAP8[i5 + i2 >> 0] = i12 << 24 >> 24 < i4 << 24 >> 24 ? i12 : i4;
    HEAP8[i5 + i14 >> 0] = i16 << 24 >> 24 < i15 << 24 >> 24 ? i16 : i15;
    i14 = i2 | 2;
    i15 = HEAP8[i3 + i14 >> 0] | 0;
    i16 = HEAP8[i1 + i14 >> 0] | 0;
    i4 = i2 | 3;
    i12 = HEAP8[i3 + i4 >> 0] | 0;
    i13 = HEAP8[i1 + i4 >> 0] | 0;
    HEAP8[i5 + i14 >> 0] = i16 << 24 >> 24 < i15 << 24 >> 24 ? i16 : i15;
    HEAP8[i5 + i4 >> 0] = i13 << 24 >> 24 < i12 << 24 >> 24 ? i13 : i12;
    i4 = i2 + 4 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) > (i2 + -4 | 0)) break; else i2 = i4;
   }
  }
  if ((i4 | 0) < (i2 | 0)) do {
   i2 = HEAP8[i3 + i4 >> 0] | 0;
   i12 = HEAP8[i1 + i4 >> 0] | 0;
   HEAP8[i5 + i4 >> 0] = i12 << 24 >> 24 < i2 << 24 >> 24 ? i12 : i2;
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + -1;
  if (!i4) break; else {
   i1 = i1 + i9 | 0;
   i5 = i5 + i7 | 0;
   i3 = i3 + i8 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cv6vBinOpIaNS_5OpMaxIaEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i8, i1, i9, i2, i7, i10) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 i6 = i10 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5 + -1;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i5 = i2;
 i2 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i2 = 0;
   while (1) {
    i4 = HEAP8[i3 + i2 >> 0] | 0;
    i12 = HEAP8[i1 + i2 >> 0] | 0;
    i14 = i2 | 1;
    i15 = HEAP8[i3 + i14 >> 0] | 0;
    i16 = HEAP8[i1 + i14 >> 0] | 0;
    HEAP8[i5 + i2 >> 0] = i4 << 24 >> 24 < i12 << 24 >> 24 ? i12 : i4;
    HEAP8[i5 + i14 >> 0] = i15 << 24 >> 24 < i16 << 24 >> 24 ? i16 : i15;
    i14 = i2 | 2;
    i15 = HEAP8[i3 + i14 >> 0] | 0;
    i16 = HEAP8[i1 + i14 >> 0] | 0;
    i4 = i2 | 3;
    i12 = HEAP8[i3 + i4 >> 0] | 0;
    i13 = HEAP8[i1 + i4 >> 0] | 0;
    HEAP8[i5 + i14 >> 0] = i15 << 24 >> 24 < i16 << 24 >> 24 ? i16 : i15;
    HEAP8[i5 + i4 >> 0] = i12 << 24 >> 24 < i13 << 24 >> 24 ? i13 : i12;
    i4 = i2 + 4 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) > (i2 + -4 | 0)) break; else i2 = i4;
   }
  }
  if ((i4 | 0) < (i2 | 0)) do {
   i2 = HEAP8[i3 + i4 >> 0] | 0;
   i12 = HEAP8[i1 + i4 >> 0] | 0;
   HEAP8[i5 + i4 >> 0] = i2 << 24 >> 24 < i12 << 24 >> 24 ? i12 : i2;
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + -1;
  if (!i4) break; else {
   i1 = i1 + i9 | 0;
   i5 = i5 + i7 | 0;
   i3 = i3 + i8 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cv11WBaseStreamD2Ev(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 HEAP32[i14 >> 2] = 180888;
 i13 = i14 + 28 | 0;
 if ((HEAP8[i13 >> 0] | 0) != 0 ? (i10 = i14 + 12 | 0, i9 = HEAP32[i10 >> 2] | 0, i11 = i14 + 4 | 0, i2 = HEAP32[i11 >> 2] | 0, i12 = i9 - i2 | 0, (i9 | 0) != (i2 | 0)) : 0) {
  i4 = i14 + 32 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if (!i5) _fwrite(i2 | 0, 1, i12 | 0, HEAP32[i14 + 24 >> 2] | 0) | 0; else {
   i7 = i5 + 4 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i9 = i3 - i1 | 0;
   i6 = i9 + i12 | 0;
   if (i9 >>> 0 >= i6 >>> 0) {
    if (i9 >>> 0 > i6 >>> 0 ? (i8 = i1 + i6 | 0, (i3 | 0) != (i8 | 0)) : 0) {
     do i3 = i3 + -1 | 0; while ((i3 | 0) != (i8 | 0));
     HEAP32[i7 >> 2] = i8;
    }
   } else {
    __ZNSt3__16vectorIhNS_9allocatorIhEEE8__appendEj(i5, i12);
    i1 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
    i2 = HEAP32[i11 >> 2] | 0;
   }
   _memcpy(i1 + i9 | 0, i2 | 0, i12 | 0) | 0;
  }
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i14 + 20 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i12;
 }
 i1 = i14 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i10 = i14 + 32 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP8[i13 >> 0] = 0;
  i10 = HEAP32[i14 >> 2] | 0;
  i10 = i10 + 24 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  FUNCTION_TABLE_vi[i10 & 511](i14);
  STACKTOP = i15;
  return;
 }
 _fclose(i2 | 0) | 0;
 HEAP32[i1 >> 2] = 0;
 i10 = i14 + 32 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP8[i13 >> 0] = 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i10 = i10 + 24 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 FUNCTION_TABLE_vi[i10 & 511](i14);
 STACKTOP = i15;
 return;
}

function __ZN2cv6vBinOpIhNS_5OpMaxIhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i2, i8, i1, i9, i3, i7, i10) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 i6 = i10 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5 + -1;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i5 = i2;
 i2 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i2 = 0;
   while (1) {
    i4 = HEAPU8[i5 + i2 >> 0] | 0;
    i13 = i2 | 1;
    i14 = HEAPU8[i5 + i13 >> 0] | 0;
    i14 = (HEAPU8[36320 + (256 - i14 + (HEAPU8[i1 + i13 >> 0] | 0)) >> 0] | 0) + i14 & 255;
    HEAP8[i3 + i2 >> 0] = (HEAPU8[36320 + (256 - i4 + (HEAPU8[i1 + i2 >> 0] | 0)) >> 0] | 0) + i4;
    HEAP8[i3 + i13 >> 0] = i14;
    i13 = i2 | 2;
    i14 = HEAPU8[i5 + i13 >> 0] | 0;
    i4 = i2 | 3;
    i12 = HEAPU8[i5 + i4 >> 0] | 0;
    i12 = (HEAPU8[36320 + (256 - i12 + (HEAPU8[i1 + i4 >> 0] | 0)) >> 0] | 0) + i12 & 255;
    HEAP8[i3 + i13 >> 0] = (HEAPU8[36320 + (256 - i14 + (HEAPU8[i1 + i13 >> 0] | 0)) >> 0] | 0) + i14;
    HEAP8[i3 + i4 >> 0] = i12;
    i4 = i2 + 4 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) > (i2 + -4 | 0)) break; else i2 = i4;
   }
  }
  if ((i4 | 0) < (i2 | 0)) do {
   i2 = HEAPU8[i5 + i4 >> 0] | 0;
   HEAP8[i3 + i4 >> 0] = (HEAPU8[36320 + (256 - i2 + (HEAPU8[i1 + i4 >> 0] | 0)) >> 0] | 0) + i2;
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + -1;
  if (!i4) break; else {
   i1 = i1 + i9 | 0;
   i5 = i5 + i8 | 0;
   i3 = i3 + i7 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cvL14cvtScale16s32fEPKsjPKhjPfjNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i11 = i5 >>> 1;
 i1 = i6 >>> 2;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i7 = i15 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = (i7 | 0) > 3 ? i15 & -4 : 4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i5 = 0; else {
   i5 = 0;
   do {
    f17 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i4 + (i5 << 1) >> 1] | 0)));
    i2 = i5 | 1;
    f18 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i4 + (i2 << 1) >> 1] | 0)));
    HEAPF32[i3 + (i5 << 2) >> 2] = f17;
    HEAPF32[i3 + (i2 << 2) >> 2] = f18;
    i2 = i5 | 2;
    f18 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i4 + (i2 << 1) >> 1] | 0)));
    i10 = i5 | 3;
    f17 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i4 + (i10 << 1) >> 1] | 0)));
    HEAPF32[i3 + (i2 << 2) >> 2] = f18;
    HEAPF32[i3 + (i10 << 2) >> 2] = f17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i7 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAPF32[i3 + (i5 << 2) >> 2] = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAP16[i4 + (i5 << 1) >> 1] | 0)));
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i1 << 2) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cvL13cvtScale64f8uEPKdjPKhjPhjNS_5Size_IiEEPd(i6, i4, i1, i2, i7, i17, i3, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, d9 = 0.0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i14 = i4 >>> 3;
 if (!i3) {
  STACKTOP = i16;
  return;
 }
 d13 = +Math_fround(+HEAPF64[i5 >> 3]);
 d9 = +Math_fround(+HEAPF64[i5 + 8 >> 3]);
 i10 = i15 + -4 | 0;
 i11 = (i10 | 0) < 0;
 i12 = i15 & -4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i11) i5 = 0; else {
   i8 = 0;
   do {
    i5 = _lrint(d9 + d13 * +HEAPF64[i6 + (i8 << 3) >> 3]) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i2 = i8 | 1;
    i4 = _lrint(d9 + d13 * +HEAPF64[i6 + (i2 << 3) >> 3]) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i8 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i1 = i8 | 2;
    i5 = _lrint(d9 + d13 * +HEAPF64[i6 + (i1 << 3) >> 3]) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i2 = i8 | 3;
    i4 = _lrint(d9 + d13 * +HEAPF64[i6 + (i2 << 3) >> 3]) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i2 >> 0] = i4;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) <= (i10 | 0));
   i5 = i12;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   i4 = _lrint(d9 + d13 * +HEAPF64[i6 + (i5 << 3) >> 3]) | 0;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i3) break; else {
   i6 = i6 + (i14 << 3) | 0;
   i7 = i7 + i17 | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cv5writeERNS_11FileStorageERKNS_6StringERKNS_3MatE(i4, i9, i6) {
 i4 = i4 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 i10 = i11 + 328 | 0;
 i8 = i11 + 296 | 0;
 i7 = i11 + 288 | 0;
 i5 = i11 + 8 | 0;
 i3 = i11;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 if ((i2 | 0) >= 3) {
  __ZN7CvMatNDC2ERKN2cv3MatE(i5, i6);
  i2 = HEAP32[i4 + 8 >> 2] | 0;
  if (!(HEAP32[i9 + 4 >> 2] | 0)) i1 = 0; else {
   i1 = HEAP32[i9 >> 2] | 0;
   i1 = (i1 | 0) == 0 ? 12512 : i1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i10 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  _cvWrite(i2, i1, i5, i10);
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 if ((i2 | 0) == 1) i2 = 1; else i2 = HEAP32[i6 + 12 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = i5 & 4095;
 i12 = HEAP32[i6 + 16 >> 2] | 0;
 i13 = Math_imul((i5 >>> 3 & 511) + 1 << (47696 >>> (i3 << 1 & 14) & 3), i2) | 0;
 HEAP32[i8 >> 2] = i3 | 1111638016;
 i3 = i8 + 4 | 0;
 HEAP32[i3 >> 2] = i13;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = i12;
 HEAP32[i8 + 20 >> 2] = i1;
 HEAP32[i8 + 24 >> 2] = i2;
 HEAP32[i3 >> 2] = HEAP32[HEAP32[i6 + 44 >> 2] >> 2];
 HEAP32[i8 >> 2] = i5 & 20479 | 1111621632;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!(HEAP32[i9 + 4 >> 2] | 0)) i1 = 0; else {
  i1 = HEAP32[i9 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? 12512 : i1;
 }
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i10 + 0 >> 2] = HEAP32[i7 + 0 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 _cvWrite(i2, i1, i8, i10);
 STACKTOP = i11;
 return;
}

function __ZN2cvL13cvtScale8u32sEPKhjS1_jPijNS_5Size_IiEEPd(i11, i16, i1, i2, i6, i5, i3, i4) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i17 = 0;
 i15 = STACKTOP;
 i14 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 f13 = Math_fround(+HEAPF64[i4 >> 3]);
 f12 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i7 = i5 >>> 2;
 if (!i2) {
  STACKTOP = i15;
  return;
 }
 i8 = i14 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i10 = i14 & -4;
 i1 = i6;
 i3 = i11;
 i4 = i2;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i6 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i3 + i5 >> 0] | 0 | 0)))) | 0;
    i11 = i5 | 1;
    i17 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i3 + i11 >> 0] | 0 | 0)))) | 0;
    HEAP32[i1 + (i5 << 2) >> 2] = i6;
    HEAP32[i1 + (i11 << 2) >> 2] = i17;
    i11 = i5 | 2;
    i17 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i3 + i11 >> 0] | 0 | 0)))) | 0;
    i6 = i5 | 3;
    i2 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i3 + i6 >> 0] | 0 | 0)))) | 0;
    HEAP32[i1 + (i11 << 2) >> 2] = i17;
    HEAP32[i1 + (i6 << 2) >> 2] = i2;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i14 | 0)) do {
   HEAP32[i1 + (i5 << 2) >> 2] = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i3 + i5 >> 0] | 0 | 0)))) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if (!i4) break; else {
   i1 = i1 + (i7 << 2) | 0;
   i3 = i3 + i16 | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN2cvL9cvt32s16sEPKijPKhjPsjNS_5Size_IiEEPd(i7, i5, i1, i2, i8, i6, i4, i3) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 i14 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i13 = i5 >>> 2;
 i11 = i6 >>> 1;
 if (!i4) {
  STACKTOP = i15;
  return;
 }
 i12 = i14 + -4 | 0;
 i9 = (i12 | 0) < 0;
 i10 = (i12 | 0) > 3 ? i14 & -4 : 4;
 i1 = i4;
 while (1) {
  i1 = i1 + -1 | 0;
  if (i9) i5 = 0; else {
   i2 = 0;
   do {
    i5 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    i4 = i2 | 1;
    i6 = HEAP32[i7 + (i4 << 2) >> 2] | 0;
    if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i2 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i3 = i2 | 2;
    i6 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
    if ((i6 + 32768 | 0) >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 32767 : -32768;
    i4 = i2 | 3;
    i5 = HEAP32[i7 + (i4 << 2) >> 2] | 0;
    if ((i5 + 32768 | 0) >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 32767 : -32768;
    HEAP16[i8 + (i3 << 1) >> 1] = i6;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) <= (i12 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i14 | 0)) do {
   i4 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
   if ((i4 + 32768 | 0) >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 32767 : -32768;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if (!i1) break; else {
   i7 = i7 + (i13 << 2) | 0;
   i8 = i8 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8IteratorD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 HEAP32[i7 >> 2] = 2160;
 i1 = i7 + 28 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 24 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i3 = HEAP32[i1 >> 2] | 0, (i3 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 20 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i4 = HEAP32[i1 >> 2] | 0, (i4 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 511](i4);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 16 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i5 = HEAP32[i1 >> 2] | 0, (i5 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 511](i5);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 12 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i6 = HEAP32[i1 >> 2] | 0, (i6 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] & 511](i6);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i8 = HEAP32[i1 >> 2] | 0, (i8 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] & 511](i8);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj(i8, i9, i4, i5, i7, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 i1 = HEAP32[i9 + 68 >> 2] | 0;
 if (!i1) {
  i1 = ___cxa_allocate_exception(4) | 0;
  __ZNSt8bad_castC2Ev(i1);
  ___cxa_throw(i1 | 0, 969544, 335);
 }
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1) | 0;
 i2 = i9 + 64 | 0;
 if (((HEAP32[i2 >> 2] | 0) != 0 ? !((i1 | 0) < 1 & ((i4 | 0) != 0 | (i5 | 0) != 0)) : 0) ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] & 127](i9) | 0) == 0 : 0) {
  if (i7 >>> 0 >= 3) {
   i1 = i8;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = i8 + 8 | 0;
   HEAP32[i1 >> 2] = -1;
   HEAP32[i1 + 4 >> 2] = -1;
   STACKTOP = i6;
   return;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) > 0) i1 = ___muldi3(i1 | 0, ((i1 | 0) < 0) << 31 >> 31 | 0, i4 | 0, i5 | 0) | 0; else i1 = 0;
  if (!(_fseeko(i3 | 0, i1 | 0, i7 | 0) | 0)) {
   i2 = _ftello(HEAP32[i2 >> 2] | 0) | 0;
   i4 = i9 + 72 | 0;
   i3 = HEAP32[i4 + 4 >> 2] | 0;
   i1 = i8;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = i8 + 8 | 0;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = ((i2 | 0) < 0) << 31 >> 31;
   STACKTOP = i6;
   return;
  } else {
   i1 = i8;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = i8 + 8 | 0;
   HEAP32[i1 >> 2] = -1;
   HEAP32[i1 + 4 >> 2] = -1;
   STACKTOP = i6;
   return;
  }
 }
 i1 = i8;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = -1;
 STACKTOP = i6;
 return;
}

function __ZN2cvL11cvtScale32fEPKfjPKhjPfjNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 f14 = Math_fround(+HEAPF64[i4 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i11 = i5 >>> 2;
 i1 = i6 >>> 2;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i7 = i15 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = (i7 | 0) > 3 ? i15 & -4 : 4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i5 = 0; else {
   i5 = 0;
   do {
    f17 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i4 + (i5 << 2) >> 2])));
    i2 = i5 | 1;
    f18 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i4 + (i2 << 2) >> 2])));
    HEAPF32[i3 + (i5 << 2) >> 2] = f17;
    HEAPF32[i3 + (i2 << 2) >> 2] = f18;
    i2 = i5 | 2;
    f18 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i4 + (i2 << 2) >> 2])));
    i10 = i5 | 3;
    f17 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i4 + (i10 << 2) >> 2])));
    HEAPF32[i3 + (i2 << 2) >> 2] = f18;
    HEAPF32[i3 + (i10 << 2) >> 2] = f17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i7 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAPF32[i3 + (i5 << 2) >> 2] = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i4 + (i5 << 2) >> 2])));
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i1 << 2) | 0;
   i4 = i4 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __GLOBAL__I_a325() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = STACKTOP;
 HEAP32[39458] = 320;
 HEAP32[39459] = 240;
 HEAP32[39460] = 640;
 HEAP32[39461] = 480;
 HEAP32[39462] = 800;
 HEAP32[39463] = 600;
 HEAP32[39464] = 1024;
 HEAP32[39465] = 768;
 HEAP32[39466] = 1280;
 HEAP32[39467] = 1024;
 HEAP32[39468] = 2560;
 HEAP32[39469] = 1440;
 HEAP32[39470] = 640;
 HEAP32[39471] = 360;
 HEAP32[39472] = 960;
 HEAP32[39473] = 540;
 HEAP32[39474] = HEAP32[39458];
 HEAP32[39475] = HEAP32[39459];
 HEAP32[39476] = 1280;
 HEAP32[39477] = 720;
 HEAP32[39478] = 1920;
 HEAP32[39479] = 1080;
 HEAP32[39480] = HEAP32[39468];
 HEAP32[39481] = HEAP32[39469];
 HEAP32[39482] = 3840;
 HEAP32[39483] = 2160;
 HEAP32[39484] = 7680;
 HEAP32[39485] = 4320;
 HEAP32[39486] = 2048;
 HEAP32[39487] = 1536;
 HEAP32[39488] = 2592;
 HEAP32[39489] = 1944;
 HEAP32[39490] = 2048;
 HEAP32[39491] = 2048;
 HEAP32[39492] = 127;
 HEAP32[39493] = 61;
 HEAP32[39494] = 24;
 HEAP32[39495] = 24;
 HEAP32[39496] = 32;
 HEAP32[39497] = 32;
 HEAP32[39498] = 64;
 HEAP32[39499] = 64;
 HEAP32[39500] = 128;
 HEAP32[39501] = 128;
 HEAP32[39742] = 158208;
 i1 = 158976 | 0;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[39746] = 0;
 HEAP32[39747] = 0;
 HEAP32[39748] = 0;
 HEAP32[39749] = 0;
 HEAP32[39750] = 0;
 HEAP32[39751] = 0;
 HEAP32[39752] = -1;
 HEAP32[39754] = 0;
 HEAP32[39755] = 0;
 HEAP32[39756] = 0;
 i1 = 159032 | 0;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = -1;
 HEAP8[159040] = 1;
 HEAPF64[19881] = 1.0;
 i1 = 159056 | 0;
 i3 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 ___cxa_atexit(118, 158968, ___dso_handle | 0) | 0;
 STACKTOP = i2;
 return;
}

function _cvError(i4, i2, i1, i5, i11) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i10 = i9 + 24 | 0;
 i3 = i9 + 16 | 0;
 i6 = i9 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 i7 = i3 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 if (i1) {
  i8 = _strlen(i1 | 0) | 0;
  _memcpy(__ZN2cv6String8allocateEj(i3, i8) | 0, i1 | 0, i8 | 0) | 0;
 }
 HEAP32[i6 >> 2] = 0;
 i8 = i6 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 if (i2) {
  i1 = _strlen(i2 | 0) | 0;
  _memcpy(__ZN2cv6String8allocateEj(i6, i1) | 0, i2 | 0, i1 | 0) | 0;
 }
 HEAP32[i9 >> 2] = 0;
 i2 = i9 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 if (i5) {
  i1 = _strlen(i5 | 0) | 0;
  _memcpy(__ZN2cv6String8allocateEj(i9, i1) | 0, i5 | 0, i1 | 0) | 0;
 }
 HEAP32[i10 >> 2] = 18928;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = i4;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i10 + 16 >> 2] = i1;
 HEAP32[i10 + 20 >> 2] = HEAP32[i7 >> 2];
 if (i1) {
  i7 = i1 + -4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i10 + 24 >> 2] = i1;
 HEAP32[i10 + 28 >> 2] = HEAP32[i8 >> 2];
 if (i1) {
  i8 = i1 + -4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 + 32 >> 2] = i1;
 HEAP32[i10 + 36 >> 2] = HEAP32[i2 >> 2];
 if (!i1) {
  i9 = i10 + 40 | 0;
  HEAP32[i9 >> 2] = i11;
  __ZN2cv9Exception13formatMessageEv(i10);
  __ZN2cv5errorERKNS_9ExceptionE(i10);
 }
 i9 = i1 + -4 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i9 = i10 + 40 | 0;
 HEAP32[i9 >> 2] = i11;
 __ZN2cv9Exception13formatMessageEv(i10);
 __ZN2cv5errorERKNS_9ExceptionE(i10);
}

function __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i9, i11, i8) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i12 + 16 | 0;
 i10 = i12 + 8 | 0;
 i5 = i12 + 4 | 0;
 i6 = i12;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC1ERS3_(i10, i9);
 if (!(HEAP8[i10 >> 0] | 0)) {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD1Ev(i10);
  STACKTOP = i12;
  return i9 | 0;
 }
 i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 + (i1 + 24) >> 2];
 if ((HEAP32[i9 + (i1 + 4) >> 2] & 176 | 0) == 32) i7 = i11 + i8 | 0; else i7 = i11;
 i2 = i9 + i1 | 0;
 i3 = i9 + (i1 + 76) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == -1) {
  __ZNKSt3__18ios_base6getlocEv(i4, i2);
  i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i4, 960728) | 0;
  i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1, 32) | 0;
  __ZNSt3__16localeD2Ev(i4);
  i1 = i1 << 24 >> 24;
  HEAP32[i3 >> 2] = i1;
 }
 HEAP32[i4 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i4, i11, i7, i11 + i8 | 0, i2, i1 & 255);
 if (HEAP32[i6 >> 2] | 0) {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD1Ev(i10);
  STACKTOP = i12;
  return i9 | 0;
 }
 i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i9 + i8 | 0, HEAP32[i9 + (i8 + 16) >> 2] | 5);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD1Ev(i10);
 STACKTOP = i12;
 return i9 | 0;
}

function __ZN2cvL8cvt32f8sEPKfjPKhjPajNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i15, i4, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = i5 >>> 2;
 if (!i4) {
  STACKTOP = i14;
  return;
 }
 i11 = i13 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i9 = i13 & -4;
 i8 = i4;
 while (1) {
  i8 = i8 + -1 | 0;
  if (i12) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(+Math_fround(HEAPF32[i6 + (i1 << 2) >> 2])) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i3 = i1 | 1;
    i4 = _lrint(+Math_fround(HEAPF32[i6 + (i3 << 2) >> 2])) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i3 >> 0] = i4;
    i2 = i1 | 2;
    i5 = _lrint(+Math_fround(HEAPF32[i6 + (i2 << 2) >> 2])) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i3 = i1 | 3;
    i4 = _lrint(+Math_fround(HEAPF32[i6 + (i3 << 2) >> 2])) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i2 >> 0] = i5;
    HEAP8[i7 + i3 >> 0] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i11 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   i4 = _lrint(+Math_fround(HEAPF32[i6 + (i5 << 2) >> 2])) | 0;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i8) break; else {
   i6 = i6 + (i10 << 2) | 0;
   i7 = i7 + i15 | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function _cvInitSparseMatIterator(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i10 + 8 | 0;
 i1 = i10;
 if (!((i7 | 0) != 0 ? (HEAP32[i7 >> 2] & -65536 | 0) == 1111752704 : 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i2, 28) | 0) + 0 | 0;
  i3 = 42104 | 0;
  i5 = i4 + 28 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i4 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i2, 42136, 40912, 628);
  __ZN2cv6String10deallocateEv(i2);
 }
 if (!i8) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i1, 21) | 0) + 0 | 0;
  i3 = 42160 | 0;
  i5 = i4 + 21 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i4 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 42136, 40912, 631);
  __ZN2cv6String10deallocateEv(i1);
 }
 HEAP32[i8 >> 2] = i7;
 i5 = i8 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = HEAP32[i7 + 24 >> 2] | 0;
 if ((i6 | 0) <= 0) {
  i3 = 0;
  i1 = 0;
  i2 = i8 + 8 | 0;
  HEAP32[i2 >> 2] = i3;
  STACKTOP = i10;
  return i1 | 0;
 }
 i2 = HEAP32[i7 + 20 >> 2] | 0;
 i4 = 0;
 while (1) {
  i3 = HEAP32[i2 + (i4 << 2) >> 2] | 0;
  i1 = i4 + 1 | 0;
  if (i3) break;
  if ((i1 | 0) < (i6 | 0)) i4 = i1; else {
   i2 = 0;
   i9 = 11;
   break;
  }
 }
 if ((i9 | 0) == 11) {
  i3 = i8 + 8 | 0;
  HEAP32[i3 >> 2] = i1;
  STACKTOP = i10;
  return i2 | 0;
 }
 HEAP32[i5 >> 2] = i3;
 i1 = i3;
 i2 = i8 + 8 | 0;
 HEAP32[i2 >> 2] = i4;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i12, i11, i7, i10, i1, i2, i6) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i13;
 i9 = HEAP32[i11 >> 2] | 0;
 if (!i9) {
  HEAP32[i12 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 i14 = i7;
 i4 = i1 - i14 | 0;
 i5 = i2 + 12 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = (i3 | 0) > (i4 | 0) ? i3 - i4 | 0 : 0;
 i3 = i10;
 i2 = i3 - i14 | 0;
 if ((i2 | 0) > 0 ? (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] & 63](i9, i7, i2) | 0) != (i2 | 0) : 0) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 do if ((i4 | 0) > 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i8, i4, i6);
  if (!(HEAP8[i8 >> 0] & 1)) i2 = i8 + 1 | 0; else i2 = HEAP32[i8 + 8 >> 2] | 0;
  if ((FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] & 63](i9, i2, i4) | 0) == (i4 | 0)) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
   break;
  }
  HEAP32[i11 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i8);
  STACKTOP = i13;
  return;
 } while (0);
 i1 = i1 - i3 | 0;
 if ((i1 | 0) > 0 ? (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] & 63](i9, i10, i1) | 0) != (i1 | 0) : 0) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i12 >> 2] = i9;
 STACKTOP = i13;
 return;
}

function __ZN7testing18TestEventListeners22SetDefaultXmlGeneratorEPNS_17TestEventListenerE(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i12;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if ((i8 | 0) == (i11 | 0)) {
  STACKTOP = i12;
  return;
 }
 i2 = i9 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) HEAP32[i2 >> 2] = 0; else HEAP32[i7 >> 2] = 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 L8 : do if ((i3 | 0) != (i5 | 0)) {
  i2 = i3 - i5 >> 2;
  i4 = 0;
  while (1) {
   i1 = i4 + 1 | 0;
   if ((HEAP32[i5 + (i4 << 2) >> 2] | 0) == (i8 | 0)) break;
   if (i1 >>> 0 < i2 >>> 0) i4 = i1; else break L8;
  }
  i2 = i4 << 2 >> 2;
  i4 = i5 + (i2 + 1 << 2) | 0;
  i3 = i3 - i4 | 0;
  _memmove(i5 + (i2 << 2) | 0, i4 | 0, i3 | 0) | 0;
  i3 = i5 + ((i3 >> 2) + i2 << 2) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) HEAP32[i6 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
  if (i8) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] & 511](i8);
 } while (0);
 HEAP32[i7 >> 2] = i11;
 if (!i11) {
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = i11;
 i3 = i1 + 12 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
  __ZNSt3__16vectorIPN7testing17TestEventListenerENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i1 + 8 | 0, i10);
  STACKTOP = i12;
  return;
 }
 if (!i2) i1 = 0; else {
  HEAP32[i2 >> 2] = i11;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 4;
 STACKTOP = i12;
 return;
}

function __ZNK2cv15StdMatAllocator8allocateEiPKiiPvPjiNS_14UMatUsageFlagsE(i15, i5, i12, i1, i2, i13, i4, i3) {
 i15 = i15 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i14;
 i4 = (i1 >>> 3 & 511) + 1 << (47696 >>> (i1 << 1 & 14) & 3);
 if ((i5 | 0) > 0) {
  i7 = (i13 | 0) == 0;
  i8 = (i2 | 0) == 0;
  i9 = i10 + 4 | 0;
  do {
   i5 = i5 + -1 | 0;
   do if (!i7) {
    i6 = i13 + (i5 << 2) | 0;
    if (!i8 ? (i11 = HEAP32[i6 >> 2] | 0, (i11 | 0) != 2147483647) : 0) {
     if (i4 >>> 0 <= i11 >>> 0) {
      i4 = i11;
      break;
     }
     HEAP32[i10 >> 2] = 0;
     HEAP32[i9 >> 2] = 0;
     i4 = (__ZN2cv6String8allocateEj(i10, 16) | 0) + 0 | 0;
     i3 = 32936 | 0;
     i1 = i4 + 16 | 0;
     do {
      HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
      i4 = i4 + 1 | 0;
      i3 = i3 + 1 | 0;
     } while ((i4 | 0) < (i1 | 0));
     __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i10, 32960, 27528, 181);
     __ZN2cv6String10deallocateEv(i10);
     i4 = HEAP32[i6 >> 2] | 0;
     break;
    }
    HEAP32[i6 >> 2] = i4;
   } while (0);
   i4 = Math_imul(HEAP32[i12 + (i5 << 2) >> 2] | 0, i4) | 0;
  } while ((i5 | 0) > 0);
 }
 i3 = (i2 | 0) != 0;
 if (!i3) i2 = __ZN2cv10fastMallocEj(i4) | 0;
 i1 = __Znwj(48) | 0;
 __ZN2cv8UMatDataC2EPKNS_12MatAllocatorE(i1, i15);
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP32[i1 + 16 >> 2] = i2;
 HEAP32[i1 + 24 >> 2] = i4;
 if (!i3) {
  STACKTOP = i14;
  return i1 | 0;
 }
 i10 = i1 + 32 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 32;
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN2cvL8cvt16s8uEPKsjPKhjPhjNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i15, i4, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = i5 >>> 1;
 if (!i4) {
  STACKTOP = i14;
  return;
 }
 i11 = i13 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i9 = i13 & -4;
 i8 = i4;
 while (1) {
  i8 = i8 + -1 | 0;
  if (i12) i5 = 0; else {
   i1 = 0;
   do {
    i5 = HEAP16[i6 + (i1 << 1) >> 1] | 0;
    if ((i5 & 65535) < 256) i4 = i5 << 16 >> 16; else i4 = i5 << 16 >> 16 > 0 ? 255 : 0;
    i3 = i1 | 1;
    i5 = HEAP16[i6 + (i3 << 1) >> 1] | 0;
    if ((i5 & 65535) < 256) i5 = i5 << 16 >> 16; else i5 = i5 << 16 >> 16 > 0 ? 255 : 0;
    HEAP8[i7 + i1 >> 0] = i4;
    HEAP8[i7 + i3 >> 0] = i5;
    i2 = i1 | 2;
    i5 = HEAP16[i6 + (i2 << 1) >> 1] | 0;
    if ((i5 & 65535) < 256) i4 = i5 << 16 >> 16; else i4 = i5 << 16 >> 16 > 0 ? 255 : 0;
    i3 = i1 | 3;
    i5 = HEAP16[i6 + (i3 << 1) >> 1] | 0;
    if ((i5 & 65535) < 256) i5 = i5 << 16 >> 16; else i5 = i5 << 16 >> 16 > 0 ? 255 : 0;
    HEAP8[i7 + i2 >> 0] = i4;
    HEAP8[i7 + i3 >> 0] = i5;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i11 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   i4 = HEAP16[i6 + (i5 << 1) >> 1] | 0;
   if ((i4 & 65535) < 256) i4 = i4 << 16 >> 16; else i4 = i4 << 16 >> 16 > 0 ? 255 : 0;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i8) break; else {
   i6 = i6 + (i10 << 1) | 0;
   i7 = i7 + i15 | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cvL13cvtScale8s32sEPKajPKhjPijNS_5Size_IiEEPd(i11, i16, i1, i2, i6, i5, i3, i4) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i17 = 0;
 i15 = STACKTOP;
 i14 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 f13 = Math_fround(+HEAPF64[i4 >> 3]);
 f12 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i7 = i5 >>> 2;
 if (!i2) {
  STACKTOP = i15;
  return;
 }
 i8 = i14 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i10 = i14 & -4;
 i1 = i6;
 i3 = i11;
 i4 = i2;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i6 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i3 + i5 >> 0] | 0)))) | 0;
    i11 = i5 | 1;
    i17 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i3 + i11 >> 0] | 0)))) | 0;
    HEAP32[i1 + (i5 << 2) >> 2] = i6;
    HEAP32[i1 + (i11 << 2) >> 2] = i17;
    i11 = i5 | 2;
    i17 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i3 + i11 >> 0] | 0)))) | 0;
    i6 = i5 | 3;
    i2 = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i3 + i6 >> 0] | 0)))) | 0;
    HEAP32[i1 + (i11 << 2) >> 2] = i17;
    HEAP32[i1 + (i6 << 2) >> 2] = i2;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i14 | 0)) do {
   HEAP32[i1 + (i5 << 2) >> 2] = _lrint(+Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i3 + i5 >> 0] | 0)))) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if (!i4) break; else {
   i1 = i1 + (i7 << 2) | 0;
   i3 = i3 + i16 | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __GLOBAL__I_a1055() {
 var i1 = 0;
 i1 = STACKTOP;
 HEAP32[42362] = 320;
 HEAP32[42363] = 240;
 HEAP32[42364] = 640;
 HEAP32[42365] = 480;
 HEAP32[42366] = 800;
 HEAP32[42367] = 600;
 HEAP32[42368] = 1024;
 HEAP32[42369] = 768;
 HEAP32[42370] = 1280;
 HEAP32[42371] = 1024;
 HEAP32[42372] = 2560;
 HEAP32[42373] = 1440;
 HEAP32[42374] = 640;
 HEAP32[42375] = 360;
 HEAP32[42376] = 960;
 HEAP32[42377] = 540;
 HEAP32[42378] = HEAP32[42362];
 HEAP32[42379] = HEAP32[42363];
 HEAP32[42380] = 1280;
 HEAP32[42381] = 720;
 HEAP32[42382] = 1920;
 HEAP32[42383] = 1080;
 HEAP32[42384] = HEAP32[42372];
 HEAP32[42385] = HEAP32[42373];
 HEAP32[42386] = 3840;
 HEAP32[42387] = 2160;
 HEAP32[42388] = 7680;
 HEAP32[42389] = 4320;
 HEAP32[42390] = 2048;
 HEAP32[42391] = 1536;
 HEAP32[42392] = 2592;
 HEAP32[42393] = 1944;
 HEAP32[42394] = 2048;
 HEAP32[42395] = 2048;
 HEAP32[42396] = 127;
 HEAP32[42397] = 61;
 HEAP32[42398] = 24;
 HEAP32[42399] = 24;
 HEAP32[42400] = 32;
 HEAP32[42401] = 32;
 HEAP32[42402] = 64;
 HEAP32[42403] = 64;
 HEAP32[42404] = 128;
 HEAP32[42405] = 128;
 HEAP32[42412] = 0;
 HEAP32[42413] = 0;
 HEAP32[42414] = 0;
 ___cxa_atexit(379, 169648, ___dso_handle | 0) | 0;
 HEAP32[42416] = 0;
 HEAP32[42417] = 0;
 HEAP32[42418] = 0;
 ___cxa_atexit(377, 169664, ___dso_handle | 0) | 0;
 HEAP32[42934] = 0;
 HEAP32[42935] = 0;
 HEAP32[42936] = 0;
 ___cxa_atexit(377, 171736, ___dso_handle | 0) | 0;
 HEAP32[42939] = 0;
 HEAP32[42940] = 0;
 HEAP32[42938] = 171756;
 ___cxa_atexit(380, 171752, ___dso_handle | 0) | 0;
 HEAP32[42942] = 0;
 HEAP32[42943] = 0;
 HEAP32[42944] = 0;
 ___cxa_atexit(377, 171768, ___dso_handle | 0) | 0;
 STACKTOP = i1;
 return;
}

function __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 HEAP32[i5 >> 2] = 163952;
 HEAP32[i5 + 4 >> 2] = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5 + 8 | 0, 159968, 0);
 i2 = i5 + 20 | 0;
 HEAP32[i2 >> 2] = 160520;
 HEAP32[i5 + 24 >> 2] = i5;
 i1 = i5 + 28 | 0;
 HEAP32[i1 >> 2] = 160544;
 HEAP32[i5 + 32 >> 2] = i5;
 HEAP32[i5 + 36 >> 2] = i2;
 HEAP32[i5 + 44 >> 2] = i1;
 i1 = i5 + 48 | 0;
 i2 = i5 + 100 | 0;
 i3 = i1 + 0 | 0;
 i4 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 + 48 >> 0] = 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i5 + 104 >> 2] = 0;
 HEAP32[i5 + 108 >> 2] = 0;
 i3 = i5 + 116 | 0;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i2 = i5 + 152 | 0;
 i3 = __Znwj(20) | 0;
 HEAP32[i3 >> 2] = 162784;
 HEAP8[i3 + 4 >> 0] = 1;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i5 + 156 | 0;
 HEAP32[i5 + 172 >> 2] = 0;
 HEAP32[i5 + 176 >> 2] = 0;
 i1 = i5 + 184 | 0;
 HEAP32[i3 + 0 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP8[i1 + 28 >> 0] = 0;
 i1 = __Znwj(4) | 0;
 HEAP32[i1 >> 2] = 165400;
 __ZN7testing18TestEventListeners23SetDefaultResultPrinterEPNS_17TestEventListenerE(i2, i1);
 STACKTOP = i6;
 return;
}

function __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 i6 = i8 + 32 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i6, i1) | 0;
 i5 = i8 + 44 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i8 + 48 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i4 & 8) {
  i1 = HEAP8[i6 >> 0] | 0;
  if (!(i1 & 1)) {
   i3 = i6 + ((i1 & 255) >>> 1) + 1 | 0;
   HEAP32[i5 >> 2] = i3;
   i2 = i6 + 1 | 0;
   i1 = i6 + 1 | 0;
  } else {
   i3 = (HEAP32[i8 + 40 >> 2] | 0) + (HEAP32[i8 + 36 >> 2] | 0) | 0;
   HEAP32[i5 >> 2] = i3;
   i1 = HEAP32[i8 + 40 >> 2] | 0;
   i2 = i1;
  }
  HEAP32[i8 + 8 >> 2] = i2;
  HEAP32[i8 + 12 >> 2] = i1;
  HEAP32[i8 + 16 >> 2] = i3;
 }
 if (!(i4 & 16)) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP8[i6 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = (i1 & 255) >>> 1;
  HEAP32[i5 >> 2] = i6 + i2 + 1;
  i1 = 10;
  i5 = i2;
 } else {
  i2 = HEAP32[i8 + 36 >> 2] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i8 + 40 >> 2] | 0) + i2;
  i1 = (HEAP32[i6 >> 2] & -2) + -1 | 0;
  i5 = i2;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i6, i1, 0);
 i1 = HEAP8[i6 >> 0] | 0;
 if (!(i1 & 1)) {
  i4 = i6 + 1 | 0;
  i3 = (i1 & 255) >>> 1;
  i2 = i6 + 1 | 0;
 } else {
  i2 = HEAP32[i8 + 40 >> 2] | 0;
  i4 = i2;
  i3 = HEAP32[i8 + 36 >> 2] | 0;
 }
 i1 = i8 + 24 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i8 + 20 >> 2] = i2;
 HEAP32[i8 + 28 >> 2] = i4 + i3;
 if (!(HEAP32[i7 >> 2] & 3)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i1 >> 2] = i2 + i5;
 STACKTOP = i9;
 return;
}

function ___dynamic_cast(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i13 = i14;
 i12 = HEAP32[i2 >> 2] | 0;
 i11 = i2 + (HEAP32[i12 + -8 >> 2] | 0) | 0;
 i12 = HEAP32[i12 + -4 >> 2] | 0;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i13 + 4 >> 2] = i2;
 HEAP32[i13 + 8 >> 2] = i3;
 HEAP32[i13 + 12 >> 2] = i1;
 i5 = i13 + 16 | 0;
 i6 = i13 + 20 | 0;
 i7 = i13 + 24 | 0;
 i8 = i13 + 28 | 0;
 i9 = i13 + 32 | 0;
 i10 = i13 + 40 | 0;
 i3 = (i12 | 0) == (i4 | 0);
 i2 = i5 + 0 | 0;
 i1 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i1 | 0));
 HEAP16[i5 + 36 >> 1] = 0;
 HEAP8[i5 + 38 >> 0] = 0;
 if (i3) {
  HEAP32[i13 + 48 >> 2] = 1;
  FUNCTION_TABLE_viiiiii[HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] & 31](i12, i13, i11, i11, 1, 0);
  i10 = (HEAP32[i7 >> 2] | 0) == 1 ? i11 : 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 FUNCTION_TABLE_viiiii[HEAP32[(HEAP32[i12 >> 2] | 0) + 24 >> 2] & 31](i12, i13, i11, 1, 0);
 i1 = HEAP32[i13 + 36 >> 2] | 0;
 if (!i1) {
  i10 = (HEAP32[i10 >> 2] | 0) == 1 & (HEAP32[i8 >> 2] | 0) == 1 & (HEAP32[i9 >> 2] | 0) == 1 ? HEAP32[i6 >> 2] | 0 : 0;
  STACKTOP = i14;
  return i10 | 0;
 } else if ((i1 | 0) == 1) {
  if ((HEAP32[i7 >> 2] | 0) != 1 ? !((HEAP32[i10 >> 2] | 0) == 0 & (HEAP32[i8 >> 2] | 0) == 1 & (HEAP32[i9 >> 2] | 0) == 1) : 0) {
   i10 = 0;
   STACKTOP = i14;
   return i10 | 0;
  }
  i10 = HEAP32[i5 >> 2] | 0;
  STACKTOP = i14;
  return i10 | 0;
 } else {
  i10 = 0;
  STACKTOP = i14;
  return i10 | 0;
 }
 return 0;
}

function __ZN2cvL9cvt64f16uEPKdjPKhjPtjNS_5Size_IiEEPd(i7, i5, i1, i2, i8, i6, i4, i3) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 i14 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i13 = i5 >>> 3;
 i11 = i6 >>> 1;
 if (!i4) {
  STACKTOP = i15;
  return;
 }
 i12 = i14 + -4 | 0;
 i9 = (i12 | 0) < 0;
 i10 = (i12 | 0) > 3 ? i14 & -4 : 4;
 i1 = i4;
 while (1) {
  i1 = i1 + -1 | 0;
  if (i9) i5 = 0; else {
   i2 = 0;
   do {
    i5 = _lrint(+HEAPF64[i7 + (i2 << 3) >> 3]) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i4 = i2 | 1;
    i6 = _lrint(+HEAPF64[i7 + (i4 << 3) >> 3]) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i2 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i3 = i2 | 2;
    i6 = _lrint(+HEAPF64[i7 + (i3 << 3) >> 3]) | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    i4 = i2 | 3;
    i5 = _lrint(+HEAPF64[i7 + (i4 << 3) >> 3]) | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i3 << 1) >> 1] = i6;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) <= (i12 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i14 | 0)) do {
   i4 = _lrint(+HEAPF64[i7 + (i5 << 3) >> 3]) | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if (!i1) break; else {
   i7 = i7 + (i13 << 3) | 0;
   i8 = i8 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function _gz_fetch(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 i1 = i9 + 44 | 0;
 i7 = i9 + 52 | 0;
 i3 = i9 + 88 | 0;
 i6 = i9 + 24 | 0;
 i2 = i9 + 100 | 0;
 i8 = i9 + 36 | 0;
 i4 = i9 + 96 | 0;
 while (1) {
  i5 = HEAP32[i1 >> 2] | 0;
  if ((i5 | 0) == 2) {
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2] << 1;
   HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
   if ((_gz_decomp(i9) | 0) == -1) {
    i1 = -1;
    i4 = 16;
    break;
   }
  } else if (!i5) {
   if ((_gz_look(i9) | 0) == -1) {
    i1 = -1;
    i4 = 16;
    break;
   }
   if (!(HEAP32[i1 >> 2] | 0)) {
    i1 = 0;
    i4 = 16;
    break;
   }
  } else if ((i5 | 0) == 1) {
   i4 = 5;
   break;
  }
  if (HEAP32[i9 >> 2] | 0) {
   i1 = 0;
   i4 = 16;
   break;
  }
  if (!(HEAP32[i7 >> 2] | 0)) continue;
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i4 = 16;
   break;
  }
 }
 if ((i4 | 0) == 5) {
  i5 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] << 1;
  HEAP32[i9 >> 2] = 0;
  i3 = i9 + 16 | 0;
  i1 = 0;
  do {
   i1 = _read(HEAP32[i3 >> 2] | 0, i5 + i1 | 0, i2 - i1 | 0) | 0;
   if ((i1 | 0) < 1) {
    i4 = 8;
    break;
   }
   i1 = (HEAP32[i9 >> 2] | 0) + i1 | 0;
   HEAP32[i9 >> 2] = i1;
  } while (i1 >>> 0 < i2 >>> 0);
  do if ((i4 | 0) == 8) {
   if ((i1 | 0) >= 0) {
    HEAP32[i7 >> 2] = 1;
    break;
   }
   _gz_error(i9, -1, _strerror(HEAP32[(___errno_location() | 0) >> 2] | 0) | 0);
   i1 = -1;
   STACKTOP = i10;
   return i1 | 0;
  } while (0);
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 >> 2];
  i1 = 0;
  STACKTOP = i10;
  return i1 | 0;
 } else if ((i4 | 0) == 16) {
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cv6vBinOpIhNS_9OpAbsDiffIhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i2, i8, i1, i9, i3, i7, i10) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 i6 = i10 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5 + -1;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i5 = i2;
 i2 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i2 = 0;
   while (1) {
    i4 = (HEAPU8[i5 + i2 >> 0] | 0) - (HEAPU8[i1 + i2 >> 0] | 0) | 0;
    i13 = i2 | 1;
    i14 = (HEAPU8[i5 + i13 >> 0] | 0) - (HEAPU8[i1 + i13 >> 0] | 0) | 0;
    HEAP8[i3 + i2 >> 0] = (i4 | 0) > -1 ? i4 : 0 - i4 | 0;
    HEAP8[i3 + i13 >> 0] = (i14 | 0) > -1 ? i14 : 0 - i14 | 0;
    i13 = i2 | 2;
    i14 = (HEAPU8[i5 + i13 >> 0] | 0) - (HEAPU8[i1 + i13 >> 0] | 0) | 0;
    i4 = i2 | 3;
    i12 = (HEAPU8[i5 + i4 >> 0] | 0) - (HEAPU8[i1 + i4 >> 0] | 0) | 0;
    HEAP8[i3 + i13 >> 0] = (i14 | 0) > -1 ? i14 : 0 - i14 | 0;
    HEAP8[i3 + i4 >> 0] = (i12 | 0) > -1 ? i12 : 0 - i12 | 0;
    i4 = i2 + 4 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) > (i2 + -4 | 0)) break; else i2 = i4;
   }
  }
  if ((i4 | 0) < (i2 | 0)) do {
   i2 = (HEAPU8[i5 + i4 >> 0] | 0) - (HEAPU8[i1 + i4 >> 0] | 0) | 0;
   HEAP8[i3 + i4 >> 0] = (i2 | 0) > -1 ? i2 : 0 - i2 | 0;
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + -1;
  if (!i4) break; else {
   i1 = i1 + i9 | 0;
   i5 = i5 + i8 | 0;
   i3 = i3 + i7 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cvL13cvtScale8u32fEPKhjS1_jPfjNS_5Size_IiEEPd(i11, i16, i1, i2, i6, i5, i3, i4) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, f17 = f0, f18 = f0;
 i15 = STACKTOP;
 i14 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 f13 = Math_fround(+HEAPF64[i4 >> 3]);
 f12 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i7 = i5 >>> 2;
 if (!i2) {
  STACKTOP = i15;
  return;
 }
 i8 = i14 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i10 = i14 & -4;
 i1 = i6;
 i3 = i11;
 i4 = i2;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    f17 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i3 + i5 >> 0] | 0 | 0)));
    i2 = i5 | 1;
    f18 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i3 + i2 >> 0] | 0 | 0)));
    HEAPF32[i1 + (i5 << 2) >> 2] = f17;
    HEAPF32[i1 + (i2 << 2) >> 2] = f18;
    i2 = i5 | 2;
    f18 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i3 + i2 >> 0] | 0 | 0)));
    i6 = i5 | 3;
    f17 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i3 + i6 >> 0] | 0 | 0)));
    HEAPF32[i1 + (i2 << 2) >> 2] = f18;
    HEAPF32[i1 + (i6 << 2) >> 2] = f17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i14 | 0)) do {
   HEAPF32[i1 + (i5 << 2) >> 2] = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPU8[i3 + i5 >> 0] | 0 | 0)));
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if (!i4) break; else {
   i1 = i1 + (i7 << 2) | 0;
   i3 = i3 + i16 | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN2cv10TLSStorageD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i9;
 i8 = i7 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2;
 if ((i1 - i3 | 0) > 0) {
  i5 = 0;
  do {
   i4 = i2 + (i5 << 2) | 0;
   if (HEAP32[i4 >> 2] | 0) {
    if ((HEAP8[27120] | 0) == 0 ? (___cxa_guard_acquire(27120) | 0) != 0 : 0) {
     i1 = __Znwj(16) | 0;
     i2 = __Znwj(28) | 0;
     _pthread_mutexattr_init(i6 | 0) | 0;
     _pthread_mutexattr_settype(i6 | 0, 1) | 0;
     _pthread_mutex_init(i2 | 0, i6 | 0) | 0;
     _pthread_mutexattr_destroy(i6 | 0) | 0;
     HEAP32[i2 + 24 >> 2] = 1;
     HEAP32[i1 >> 2] = i2;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = 0;
     HEAP32[i1 + 12 >> 2] = 0;
     HEAP32[6778] = i1;
     ___cxa_guard_release(27120);
    }
    i3 = HEAP32[6778] | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    _pthread_mutex_lock(HEAP32[i3 >> 2] | 0) | 0;
    i1 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    if (i1) FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 127](i1, i2);
    _pthread_mutex_unlock(HEAP32[i3 >> 2] | 0) | 0;
    HEAP32[i4 >> 2] = 0;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i7 >> 2] | 0;
   }
   i5 = i5 + 1 | 0;
   i3 = i2;
  } while ((i5 | 0) < (i1 - i3 >> 2 | 0));
 }
 if ((i1 | 0) != (i2 | 0)) {
  i1 = i1 + (~((i1 + -4 - i3 | 0) >>> 2) << 2) | 0;
  HEAP32[i8 >> 2] = i1;
 }
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) != (i2 | 0)) HEAP32[i8 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
 __ZdlPv(i2);
 STACKTOP = i9;
 return;
}

function __ZN7testing8internal18StreamableToStringIPcEENSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEERKT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i8 + 4 | 0;
 i6 = i8;
 __ZN7testing7MessageC2Ev(i6);
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i2 = i4 + 8 | 0;
 if (!i1) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i1, _strlen(i1 | 0) | 0) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i5, i4 + 12 | 0);
 i2 = HEAP8[i5 >> 0] | 0;
 if (!(i2 & 1)) {
  i1 = i5 + 1 | 0;
  i2 = (i2 & 255) >>> 1;
 } else {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i2 = HEAP32[i5 + 4 >> 2] | 0;
 }
 i3 = i1 + i2 | 0;
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i7, i2 << 1);
 if (i2) do {
  i2 = HEAP8[i1 >> 0] | 0;
  if (!(i2 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, i2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 if (!i4) {
  STACKTOP = i8;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 511](i4);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function _saveSetjmp(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 setjmpId = setjmpId + 1 | 0;
 HEAP32[i1 >> 2] = setjmpId;
 while ((i2 | 0) < 20) {
  if (!(HEAP32[i4 + (i2 << 3) >> 2] | 0)) {
   HEAP32[i4 + (i2 << 3) >> 2] = setjmpId;
   HEAP32[i4 + ((i2 << 3) + 4) >> 2] = i3;
   HEAP32[i4 + ((i2 << 3) + 8) >> 2] = 0;
   return 0;
  }
  i2 = i2 + 1 | 0;
 }
 _putchar(116);
 _putchar(111);
 _putchar(111);
 _putchar(32);
 _putchar(109);
 _putchar(97);
 _putchar(110);
 _putchar(121);
 _putchar(32);
 _putchar(115);
 _putchar(101);
 _putchar(116);
 _putchar(106);
 _putchar(109);
 _putchar(112);
 _putchar(115);
 _putchar(32);
 _putchar(105);
 _putchar(110);
 _putchar(32);
 _putchar(97);
 _putchar(32);
 _putchar(102);
 _putchar(117);
 _putchar(110);
 _putchar(99);
 _putchar(116);
 _putchar(105);
 _putchar(111);
 _putchar(110);
 _putchar(32);
 _putchar(99);
 _putchar(97);
 _putchar(108);
 _putchar(108);
 _putchar(44);
 _putchar(32);
 _putchar(98);
 _putchar(117);
 _putchar(105);
 _putchar(108);
 _putchar(100);
 _putchar(32);
 _putchar(119);
 _putchar(105);
 _putchar(116);
 _putchar(104);
 _putchar(32);
 _putchar(97);
 _putchar(32);
 _putchar(104);
 _putchar(105);
 _putchar(103);
 _putchar(104);
 _putchar(101);
 _putchar(114);
 _putchar(32);
 _putchar(118);
 _putchar(97);
 _putchar(108);
 _putchar(117);
 _putchar(101);
 _putchar(32);
 _putchar(102);
 _putchar(111);
 _putchar(114);
 _putchar(32);
 _putchar(77);
 _putchar(65);
 _putchar(88);
 _putchar(95);
 _putchar(83);
 _putchar(69);
 _putchar(84);
 _putchar(74);
 _putchar(77);
 _putchar(80);
 _putchar(83);
 _putchar(10);
 abort(0);
 return 0;
}

function _cvCreateMatHeader(i9, i8, i2) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i10 + 8 | 0;
 i3 = i10;
 i7 = i2 & 4095;
 if ((i9 | 0) < 0 | (i8 | 0) < 1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i1, 28) | 0) + 0 | 0;
  i5 = 41008 | 0;
  i6 = i4 + 28 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i1, 41040, 40912, 119);
  __ZN2cv6String10deallocateEv(i1);
 }
 i2 = Math_imul((i2 >>> 3 & 511) + 1 << (47696 >>> (i2 << 1 & 14) & 3), i8) | 0;
 if ((i2 | 0) < 1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i4 = (__ZN2cv6String8allocateEj(i3, 19) | 0) + 0 | 0;
  i5 = 41064 | 0;
  i6 = i4 + 19 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-210, i3, 41040, 40912, 123);
  __ZN2cv6String10deallocateEv(i3);
 }
 i1 = _cvAlloc(28) | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = i7 | 1111638016;
 HEAP32[i1 + 20 >> 2] = i9;
 HEAP32[i1 + 24 >> 2] = i8;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 i2 = ___muldi3(i9 | 0, ((i9 | 0) < 0) << 31 >> 31 | 0, i2 | 0, ((i2 | 0) < 0) << 31 >> 31 | 0) | 0;
 i3 = tempRet0;
 if (!((i3 | 0) > 0 | (i3 | 0) == 0 & i2 >>> 0 > 2147483647)) {
  STACKTOP = i10;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = i7 | 1111621632;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE18__construct_at_endIPS2_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_(i1, i2, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 if ((i2 | 0) == (i8 | 0)) {
  STACKTOP = i9;
  return;
 }
 i7 = i1 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do {
  do if (i1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i5 = i1 + 4 | 0;
   i6 = i2 + 4 | 0;
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   i10 = i1 + 8 | 0;
   HEAP32[i10 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   i3 = HEAP32[i2 + 36 >> 2] | 0;
   HEAP32[i1 + 36 >> 2] = i3;
   HEAP32[i1 + 40 >> 2] = i10;
   i10 = i1 + 48 | 0;
   i4 = i1 + 44 | 0;
   HEAP32[i4 >> 2] = i10;
   HEAP32[i1 + 52 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   if (i3) {
    i3 = i3 + 12 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   }
   if ((HEAP32[i6 >> 2] | 0) < 3) {
    i3 = HEAP32[i2 + 44 >> 2] | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    break;
   } else {
    HEAP32[i5 >> 2] = 0;
    __ZN2cv3Mat8copySizeERKS0_(i1, i2);
    break;
   }
  } while (0);
  i1 = (HEAP32[i7 >> 2] | 0) + 56 | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i2 + 56 | 0;
 } while ((i2 | 0) != (i8 | 0));
 STACKTOP = i9;
 return;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm(i5, i6, i3, i2, i1, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i8 = i6;
 i13 = i6 + 116 | 0;
 i14 = i6 + 104 | 0;
 i7 = i6 + 20 | 0;
 i11 = i6 + 16 | 0;
 i10 = i6 + 12 | 0;
 i12 = i6 + 8 | 0;
 i9 = i6 + 4 | 0;
 HEAP8[i13 + 0 >> 0] = HEAP8[959520] | 0;
 HEAP8[i13 + 1 >> 0] = HEAP8[959521] | 0;
 HEAP8[i13 + 2 >> 0] = HEAP8[959522] | 0;
 HEAP8[i13 + 3 >> 0] = HEAP8[959523] | 0;
 HEAP8[i13 + 4 >> 0] = HEAP8[959524] | 0;
 HEAP8[i13 + 5 >> 0] = HEAP8[959525] | 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i13 + 1 | 0, 959424, 0, HEAP32[i2 + 4 >> 2] | 0);
 i15 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i8 >> 2] = i4;
 i4 = i14 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i14, 12, i15, i13, i8) | 0) | 0;
 i13 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i14, i4, i2) | 0;
 __ZNKSt3__18ios_base6getlocEv(i12, i2);
 __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE(i14, i13, i4, i7, i11, i10, i12);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i12 >> 2] | 0) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i5, i8, i7, i4, i3, i2, i1);
 STACKTOP = i6;
 return;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl(i5, i6, i3, i2, i1, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i8 = i6;
 i13 = i6 + 116 | 0;
 i14 = i6 + 104 | 0;
 i7 = i6 + 20 | 0;
 i11 = i6 + 16 | 0;
 i10 = i6 + 12 | 0;
 i12 = i6 + 8 | 0;
 i9 = i6 + 4 | 0;
 HEAP8[i13 + 0 >> 0] = HEAP8[959520] | 0;
 HEAP8[i13 + 1 >> 0] = HEAP8[959521] | 0;
 HEAP8[i13 + 2 >> 0] = HEAP8[959522] | 0;
 HEAP8[i13 + 3 >> 0] = HEAP8[959523] | 0;
 HEAP8[i13 + 4 >> 0] = HEAP8[959524] | 0;
 HEAP8[i13 + 5 >> 0] = HEAP8[959525] | 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i13 + 1 | 0, 959424, 1, HEAP32[i2 + 4 >> 2] | 0);
 i15 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i8 >> 2] = i4;
 i4 = i14 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i14, 12, i15, i13, i8) | 0) | 0;
 i13 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i14, i4, i2) | 0;
 __ZNKSt3__18ios_base6getlocEv(i12, i2);
 __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE(i14, i13, i4, i7, i11, i10, i12);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i12 >> 2] | 0) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i5, i8, i7, i4, i3, i2, i1);
 STACKTOP = i6;
 return;
}

function __ZNSt3__17__sort4IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_S7_T_(i7, i8, i5, i4, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 i6 = __ZNSt3__17__sort3IRNS_6__lessIN2cv6StringES3_EEPS3_EEjT0_S7_S7_T_(i7, i8, i5, i1) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i1 = i6;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((_strcmp((i1 | 0) == 0 ? 6176 : i1, (i2 | 0) == 0 ? 6176 : i2) | 0) >= 0) {
  i1 = i6;
  STACKTOP = i9;
  return i1 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = i2;
 i1 = i5 + 4 | 0;
 i4 = i4 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i3;
 i4 = i6 + 1 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i3 | 0) == (i2 | 0)) {
  i1 = i4;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((_strcmp((i3 | 0) == 0 ? 6176 : i3, (i2 | 0) == 0 ? 6176 : i2) | 0) >= 0) {
  i1 = i4;
  STACKTOP = i9;
  return i1 | 0;
 }
 HEAP32[i8 >> 2] = i3;
 HEAP32[i5 >> 2] = i2;
 i4 = i8 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 i1 = i6 + 2 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((_strcmp((i2 | 0) == 0 ? 6176 : i2, (i3 | 0) == 0 ? 6176 : i3) | 0) >= 0) {
  STACKTOP = i9;
  return i1 | 0;
 }
 HEAP32[i7 >> 2] = i2;
 HEAP32[i8 >> 2] = i3;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i6 + 3 | 0;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN2cvL13mixChannels8uEPPKhPKiPPhS4_ii(i20, i19, i15, i14, i17, i18) {
 i20 = i20 | 0;
 i19 = i19 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 if ((i18 | 0) <= 0) {
  STACKTOP = i21;
  return;
 }
 i11 = i17 + -2 | 0;
 i12 = (i11 | 0) < 0;
 i13 = i17 & -2;
 i16 = 0;
 do {
  i2 = HEAP32[i20 + (i16 << 2) >> 2] | 0;
  i1 = HEAP32[i15 + (i16 << 2) >> 2] | 0;
  i9 = HEAP32[i19 + (i16 << 2) >> 2] | 0;
  i10 = HEAP32[i14 + (i16 << 2) >> 2] | 0;
  if (!i2) {
   if (i12) i2 = 0; else {
    i2 = i10 << 1;
    i3 = i1;
    i4 = 0;
    while (1) {
     HEAP8[i3 + i10 >> 0] = 0;
     HEAP8[i3 >> 0] = 0;
     i4 = i4 + 2 | 0;
     if ((i4 | 0) > (i11 | 0)) break; else i3 = i3 + i2 | 0;
    }
    i1 = i1 + (Math_imul(i10, i13) | 0) | 0;
    i2 = i13;
   }
   if ((i2 | 0) < (i17 | 0)) HEAP8[i1 >> 0] = 0;
  } else {
   if (i12) i3 = 0; else {
    i4 = i9 << 1;
    i3 = i10 << 1;
    i5 = Math_imul(i10, i13) | 0;
    i6 = i1;
    i7 = 0;
    i8 = i2;
    while (1) {
     i22 = HEAP8[i8 + i9 >> 0] | 0;
     HEAP8[i6 >> 0] = HEAP8[i8 >> 0] | 0;
     HEAP8[i6 + i10 >> 0] = i22;
     i7 = i7 + 2 | 0;
     if ((i7 | 0) > (i11 | 0)) break; else {
      i6 = i6 + i3 | 0;
      i8 = i8 + i4 | 0;
     }
    }
    i1 = i1 + i5 | 0;
    i3 = i13;
    i2 = i2 + (Math_imul(i9, i13) | 0) | 0;
   }
   if ((i3 | 0) < (i17 | 0)) HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  }
  i16 = i16 + 1 | 0;
 } while ((i16 | 0) != (i18 | 0));
 STACKTOP = i21;
 return;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm(i5, i6, i3, i2, i1, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i8 = i6;
 i13 = i6 + 56 | 0;
 i14 = i6 + 44 | 0;
 i7 = i6 + 20 | 0;
 i11 = i6 + 16 | 0;
 i10 = i6 + 12 | 0;
 i12 = i6 + 8 | 0;
 i9 = i6 + 4 | 0;
 HEAP8[i13 + 0 >> 0] = HEAP8[959520] | 0;
 HEAP8[i13 + 1 >> 0] = HEAP8[959521] | 0;
 HEAP8[i13 + 2 >> 0] = HEAP8[959522] | 0;
 HEAP8[i13 + 3 >> 0] = HEAP8[959523] | 0;
 HEAP8[i13 + 4 >> 0] = HEAP8[959524] | 0;
 HEAP8[i13 + 5 >> 0] = HEAP8[959525] | 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i13 + 1 | 0, 959424, 0, HEAP32[i2 + 4 >> 2] | 0);
 i15 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i8 >> 2] = i4;
 i4 = i14 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i14, 12, i15, i13, i8) | 0) | 0;
 i13 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i14, i4, i2) | 0;
 __ZNKSt3__18ios_base6getlocEv(i12, i2);
 __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE(i14, i13, i4, i7, i11, i10, i12);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i12 >> 2] | 0) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i5, i8, i7, i4, i3, i2, i1);
 STACKTOP = i6;
 return;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl(i5, i6, i3, i2, i1, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i8 = i6;
 i13 = i6 + 56 | 0;
 i14 = i6 + 44 | 0;
 i7 = i6 + 20 | 0;
 i11 = i6 + 16 | 0;
 i10 = i6 + 12 | 0;
 i12 = i6 + 8 | 0;
 i9 = i6 + 4 | 0;
 HEAP8[i13 + 0 >> 0] = HEAP8[959520] | 0;
 HEAP8[i13 + 1 >> 0] = HEAP8[959521] | 0;
 HEAP8[i13 + 2 >> 0] = HEAP8[959522] | 0;
 HEAP8[i13 + 3 >> 0] = HEAP8[959523] | 0;
 HEAP8[i13 + 4 >> 0] = HEAP8[959524] | 0;
 HEAP8[i13 + 5 >> 0] = HEAP8[959525] | 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i13 + 1 | 0, 959424, 1, HEAP32[i2 + 4 >> 2] | 0);
 i15 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i8 >> 2] = i4;
 i4 = i14 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i14, 12, i15, i13, i8) | 0) | 0;
 i13 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i14, i4, i2) | 0;
 __ZNKSt3__18ios_base6getlocEv(i12, i2);
 __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE(i14, i13, i4, i7, i11, i10, i12);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i12 >> 2] | 0) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i5, i8, i7, i4, i3, i2, i1);
 STACKTOP = i6;
 return;
}

function __ZN7testing8internal27FormatTimeInMillisAsSecondsEx(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i10 = i4 + 144 | 0;
 i9 = i4;
 i5 = i9 + 64 | 0;
 i8 = i9 + 8 | 0;
 HEAP32[i8 >> 2] = 2640;
 i6 = i9 + 12 | 0;
 HEAP32[i9 >> 2] = 2788;
 HEAP32[i5 >> 2] = 2808;
 HEAP32[i9 + 4 >> 2] = 0;
 __ZNSt3__18ios_base4initEPv(i9 + 64 | 0, i6);
 HEAP32[i9 + 136 >> 2] = 0;
 HEAP32[i9 + 140 >> 2] = -1;
 HEAP32[i9 >> 2] = 2620;
 HEAP32[i5 >> 2] = 2660;
 HEAP32[i8 >> 2] = 2640;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i6);
 HEAP32[i6 >> 2] = 2952;
 i7 = i9 + 44 | 0;
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i9 + 60 >> 2] = 24;
 HEAP32[i10 + 0 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i6, i10);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i10);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd(i9 + 8 | 0, (+(i1 >>> 0) + 4294967296.0 * +(i2 | 0)) / 1.0e3) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i3, i6);
 HEAP32[i9 >> 2] = 2620;
 HEAP32[i9 + 64 >> 2] = 2660;
 HEAP32[i8 >> 2] = 2640;
 HEAP32[i6 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i6);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i5);
 STACKTOP = i4;
 return;
}

function __ZN2cvL8cvt64f8sEPKdjPKhjPajNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i15, i4, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = i5 >>> 3;
 if (!i4) {
  STACKTOP = i14;
  return;
 }
 i11 = i13 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i9 = i13 & -4;
 i8 = i4;
 while (1) {
  i8 = i8 + -1 | 0;
  if (i12) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(+HEAPF64[i6 + (i1 << 3) >> 3]) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i3 = i1 | 1;
    i4 = _lrint(+HEAPF64[i6 + (i3 << 3) >> 3]) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i3 >> 0] = i4;
    i2 = i1 | 2;
    i5 = _lrint(+HEAPF64[i6 + (i2 << 3) >> 3]) | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i3 = i1 | 3;
    i4 = _lrint(+HEAPF64[i6 + (i3 << 3) >> 3]) | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i2 >> 0] = i5;
    HEAP8[i7 + i3 >> 0] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i11 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   i4 = _lrint(+HEAPF64[i6 + (i5 << 3) >> 3]) | 0;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i8) break; else {
   i6 = i6 + (i10 << 3) | 0;
   i7 = i7 + i15 | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] & 127](i7) | 0;
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960792) | 0;
 HEAP32[i7 + 68 >> 2] = i1;
 i3 = i7 + 98 | 0;
 i2 = HEAP8[i3 >> 0] | 0;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1) | 0;
 HEAP8[i3 >> 0] = i1 & 1;
 if ((i2 & 255 | 0) == (i1 & 1 | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = i7 + 8 | 0;
 i2 = i7 + 96 | 0;
 HEAP32[i3 + 0 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 i3 = (HEAP8[i2 >> 0] | 0) != 0;
 if (i1) {
  i1 = i7 + 32 | 0;
  if (i3 ? (i6 = HEAP32[i1 >> 2] | 0, (i6 | 0) != 0) : 0) __ZdaPv(i6);
  i3 = i7 + 97 | 0;
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i4 = i7 + 60 | 0;
  HEAP32[i7 + 52 >> 2] = HEAP32[i4 >> 2];
  i2 = i7 + 56 | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i3 >> 0] = 0;
  STACKTOP = i8;
  return;
 }
 if (!i3 ? (i4 = i7 + 32 | 0, i5 = HEAP32[i4 >> 2] | 0, (i5 | 0) != (i7 + 44 | 0)) : 0) {
  i1 = HEAP32[i7 + 52 >> 2] | 0;
  HEAP32[i7 + 60 >> 2] = i1;
  HEAP32[i7 + 56 >> 2] = i5;
  HEAP8[i7 + 97 >> 0] = 0;
  HEAP32[i4 >> 2] = __Znaj(i1) | 0;
  HEAP8[i2 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i7 + 52 >> 2] | 0;
 HEAP32[i7 + 60 >> 2] = i1;
 HEAP32[i7 + 56 >> 2] = __Znaj(i1) | 0;
 HEAP8[i7 + 97 >> 0] = 1;
 STACKTOP = i8;
 return;
}

function __ZN2cvL13cvtScale8s32fEPKajPKhjPfjNS_5Size_IiEEPd(i11, i16, i1, i2, i6, i5, i3, i4) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, f17 = f0, f18 = f0;
 i15 = STACKTOP;
 i14 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 f13 = Math_fround(+HEAPF64[i4 >> 3]);
 f12 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i7 = i5 >>> 2;
 if (!i2) {
  STACKTOP = i15;
  return;
 }
 i8 = i14 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i10 = i14 & -4;
 i1 = i6;
 i3 = i11;
 i4 = i2;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    f17 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i3 + i5 >> 0] | 0)));
    i2 = i5 | 1;
    f18 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i3 + i2 >> 0] | 0)));
    HEAPF32[i1 + (i5 << 2) >> 2] = f17;
    HEAPF32[i1 + (i2 << 2) >> 2] = f18;
    i2 = i5 | 2;
    f18 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i3 + i2 >> 0] | 0)));
    i6 = i5 | 3;
    f17 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i3 + i6 >> 0] | 0)));
    HEAPF32[i1 + (i2 << 2) >> 2] = f18;
    HEAPF32[i1 + (i6 << 2) >> 2] = f17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i14 | 0)) do {
   HEAPF32[i1 + (i5 << 2) >> 2] = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAP8[i3 + i5 >> 0] | 0)));
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if (!i4) break; else {
   i1 = i1 + (i7 << 2) | 0;
   i3 = i3 + i16 | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN7testing13PrintToStringIjEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i9 = i3 + 144 | 0;
 i8 = i3;
 i4 = i8 + 64 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i7 >> 2] = 2640;
 i5 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = 2788;
 HEAP32[i4 >> 2] = 2808;
 HEAP32[i8 + 4 >> 2] = 0;
 __ZNSt3__18ios_base4initEPv(i8 + 64 | 0, i5);
 HEAP32[i8 + 136 >> 2] = 0;
 HEAP32[i8 + 140 >> 2] = -1;
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i4 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i5);
 HEAP32[i5 >> 2] = 2952;
 i6 = i8 + 44 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 24;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i5, i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEj(i8 + 8 | 0, HEAP32[i2 >> 2] | 0) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i1, i5);
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i8 + 64 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 HEAP32[i5 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i5);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZN7testing13PrintToStringIiEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i9 = i3 + 144 | 0;
 i8 = i3;
 i4 = i8 + 64 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i7 >> 2] = 2640;
 i5 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = 2788;
 HEAP32[i4 >> 2] = 2808;
 HEAP32[i8 + 4 >> 2] = 0;
 __ZNSt3__18ios_base4initEPv(i8 + 64 | 0, i5);
 HEAP32[i8 + 136 >> 2] = 0;
 HEAP32[i8 + 140 >> 2] = -1;
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i4 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i5);
 HEAP32[i5 >> 2] = 2952;
 i6 = i8 + 44 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 24;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i5, i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i8 + 8 | 0, HEAP32[i2 >> 2] | 0) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i1, i5);
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i8 + 64 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 HEAP32[i5 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i5);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZN7testing13PrintToStringIdEENSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 i9 = i3 + 144 | 0;
 i8 = i3;
 i4 = i8 + 64 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i7 >> 2] = 2640;
 i5 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = 2788;
 HEAP32[i4 >> 2] = 2808;
 HEAP32[i8 + 4 >> 2] = 0;
 __ZNSt3__18ios_base4initEPv(i8 + 64 | 0, i5);
 HEAP32[i8 + 136 >> 2] = 0;
 HEAP32[i8 + 140 >> 2] = -1;
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i4 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i5);
 HEAP32[i5 >> 2] = 2952;
 i6 = i8 + 44 | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 24;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i5, i9);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd(i8 + 8 | 0, +HEAPF64[i2 >> 3]) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i1, i5);
 HEAP32[i8 >> 2] = 2620;
 HEAP32[i8 + 64 >> 2] = 2660;
 HEAP32[i7 >> 2] = 2640;
 HEAP32[i5 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i5);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZN6cvtest2TS4initERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i7, i3) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 i8 = i9;
 i6 = i9 + 24 | 0;
 i4 = i9 + 12 | 0;
 i5 = _getenv(158600) | 0;
 if (i5) {
  i1 = _strlen(i5 | 0) | 0;
  if (i1) {
   i1 = HEAP8[i5 + (i1 + -1) >> 0] | 0;
   if (i1 << 24 >> 24 == 47) i2 = 158192; else i2 = i1 << 24 >> 24 == 92 ? 158192 : 158632;
  } else i2 = 158632;
  if (!(HEAP8[i3 >> 0] & 1)) i1 = i3 + 1 | 0; else i1 = HEAP32[i3 + 8 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i8 + 4 >> 2] = i2;
  HEAP32[i8 + 8 >> 2] = i1;
  _sprintf(i6, 158624, i8) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i6, _strlen(i6 | 0) | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7 + 48 | 0, i4) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 }
 __ZN2cv13redirectErrorEPFiiPKcS1_S1_iPvES2_PS2_(1, i7, 0) | 0;
 if (!(HEAP8[159816] | 0)) {
  _signal(11, 0) | 0;
  _signal(7, 0) | 0;
  _signal(8, 0) | 0;
  _signal(4, 0) | 0;
  _signal(6, 0) | 0;
 } else {
  _signal(11, 373) | 0;
  _signal(7, 373) | 0;
  _signal(8, 373) | 0;
  _signal(4, 373) | 0;
  _signal(6, 373) | 0;
 }
 if (!(HEAP8[i7 + 72 >> 0] | 0)) __ZN2cv15setUseOptimizedEb(0);
 i2 = i7 + 64 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = (i4 | 0) != 0 | (i2 | 0) != 0;
 i1 = i7 + 8 | 0;
 HEAP32[i1 >> 2] = i3 ? i4 : -1;
 HEAP32[i1 + 4 >> 2] = i3 ? i2 : 0;
 STACKTOP = i9;
 return;
}

function __ZN2cv9Exception13formatMessageEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i5 = i10;
 i6 = i10 + 32 | 0;
 i7 = i10 + 24 | 0;
 i8 = i9 + 4 | 0;
 i1 = HEAP32[i9 + 32 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? 26888 : i1;
 i3 = HEAP32[i9 + 40 >> 2] | 0;
 i4 = HEAP32[i9 + 12 >> 2] | 0;
 i2 = HEAP32[i9 + 16 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? 26888 : i2;
 if (!(HEAP32[i9 + 28 >> 2] | 0)) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 4 >> 2] = i3;
  HEAP32[i5 + 8 >> 2] = i4;
  HEAP32[i5 + 12 >> 2] = i2;
  __ZN2cv6formatEPKcz(i7, 18984, i5);
  if ((i7 | 0) != (i8 | 0)) {
   __ZN2cv6String10deallocateEv(i8);
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i1 = i1 + -4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 4 >> 2];
  }
  __ZN2cv6String10deallocateEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i7 = HEAP32[i9 + 24 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 4 >> 2] = i3;
  HEAP32[i5 + 8 >> 2] = i4;
  HEAP32[i5 + 12 >> 2] = i2;
  HEAP32[i5 + 16 >> 2] = (i7 | 0) == 0 ? 26888 : i7;
  __ZN2cv6formatEPKcz(i6, 18944, i5);
  if ((i6 | 0) != (i8 | 0)) {
   __ZN2cv6String10deallocateEv(i8);
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i1 = i1 + -4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 + 8 >> 2] = HEAP32[i6 + 4 >> 2];
  }
  __ZN2cv6String10deallocateEv(i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN2cvL8cvt32f8uEPKfjPKhjPhjNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i15, i4, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = i5 >>> 2;
 if (!i4) {
  STACKTOP = i14;
  return;
 }
 i11 = i13 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i9 = i13 & -4;
 i8 = i4;
 while (1) {
  i8 = i8 + -1 | 0;
  if (i12) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(+Math_fround(HEAPF32[i6 + (i1 << 2) >> 2])) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i3 = i1 | 1;
    i4 = _lrint(+Math_fround(HEAPF32[i6 + (i3 << 2) >> 2])) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i3 >> 0] = i4;
    i2 = i1 | 2;
    i5 = _lrint(+Math_fround(HEAPF32[i6 + (i2 << 2) >> 2])) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i3 = i1 | 3;
    i4 = _lrint(+Math_fround(HEAPF32[i6 + (i3 << 2) >> 2])) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i2 >> 0] = i5;
    HEAP8[i7 + i3 >> 0] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i11 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   i4 = _lrint(+Math_fround(HEAPF32[i6 + (i5 << 2) >> 2])) | 0;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i8) break; else {
   i6 = i6 + (i10 << 2) | 0;
   i7 = i7 + i15 | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZL14icvYMLParseKeyP13CvFileStoragePcP10CvFileNodePS3_(i5, i7, i6, i8) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i9 = i10;
 i4 = i10 + 16 | 0;
 i1 = i7 + -1 | 0;
 if ((HEAP8[i7 >> 0] | 0) == 45) {
  i2 = HEAP32[i5 + 88 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 + 60 >> 2];
  HEAP32[i9 + 4 >> 2] = i2;
  HEAP32[i9 + 8 >> 2] = 15272;
  _sprintf(i4, 17440, i9) | 0;
  _cvError(-212, 15256, i4, 8960, 1007);
 }
 while (1) {
  i2 = i1 + 1 | 0;
  i11 = HEAP8[i2 >> 0] | 0;
  i3 = i11 << 24 >> 24 == 58;
  if ((i11 & 255) < 32 | i3) break; else i1 = i2;
 }
 if (!i3) {
  i3 = HEAP32[i5 + 88 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 + 60 >> 2];
  HEAP32[i9 + 4 >> 2] = i3;
  HEAP32[i9 + 8 >> 2] = 15304;
  _sprintf(i4, 17440, i9) | 0;
  _cvError(-212, 15256, i4, 8960, 1013);
 }
 while (1) {
  i3 = i2 + -1 | 0;
  if ((HEAP8[i3 >> 0] | 0) == 32) i2 = i3; else break;
 }
 i1 = i1 + 2 | 0;
 if ((i2 | 0) != (i7 | 0)) {
  i4 = i2;
  i9 = i7;
  i9 = i4 - i9 | 0;
  i9 = _cvGetHashedKey(i5, i7, i9, 1) | 0;
  i9 = _cvGetFileNode(i5, i6, i9, 1) | 0;
  HEAP32[i8 >> 2] = i9;
  STACKTOP = i10;
  return i1 | 0;
 }
 i3 = HEAP32[i5 + 88 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i5 + 60 >> 2];
 HEAP32[i9 + 4 >> 2] = i3;
 HEAP32[i9 + 8 >> 2] = 15320;
 _sprintf(i4, 17440, i9) | 0;
 _cvError(-212, 15256, i4, 8960, 1021);
 i4 = i2;
 i9 = i7;
 i9 = i4 - i9 | 0;
 i9 = _cvGetHashedKey(i5, i7, i9, 1) | 0;
 i9 = _cvGetFileNode(i5, i6, i9, 1) | 0;
 HEAP32[i8 >> 2] = i9;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN2cv16TLSDataContainerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i9;
 HEAP32[i2 >> 2] = 26736;
 if ((HEAP8[27120] | 0) == 0 ? (___cxa_guard_acquire(27120) | 0) != 0 : 0) {
  i1 = __Znwj(16) | 0;
  i3 = __Znwj(28) | 0;
  _pthread_mutexattr_init(i8 | 0) | 0;
  _pthread_mutexattr_settype(i8 | 0, 1) | 0;
  _pthread_mutex_init(i3 | 0, i8 | 0) | 0;
  _pthread_mutexattr_destroy(i8 | 0) | 0;
  HEAP32[i3 + 24 >> 2] = 1;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[6778] = i1;
  ___cxa_guard_release(27120);
 }
 i4 = HEAP32[6778] | 0;
 i5 = i2 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 _pthread_mutex_lock(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i4 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i1 + (i6 << 2) >> 2] | 0) == (i2 | 0)) {
  i1 = i1 + (i6 << 2) | 0;
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[i4 >> 2] | 0;
  _pthread_mutex_unlock(i1 | 0) | 0;
  HEAP32[i5 >> 2] = -1;
  STACKTOP = i9;
  return;
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i8, 32) | 0) + 0 | 0;
 i1 = 27056;
 i3 = i2 + 32 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i8, 27096, 26776, 990);
 __ZN2cv6String10deallocateEv(i8);
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = i1 + (i6 << 2) | 0;
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 _pthread_mutex_unlock(i1 | 0) | 0;
 HEAP32[i5 >> 2] = -1;
 STACKTOP = i9;
 return;
}

function __ZN2cv8vBinOp64IdNS_5OpSubIdddEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 3;
 i10 = i3 >>> 3;
 i9 = i4 >>> 3;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    i7 = i3 | 1;
    d17 = +HEAPF64[i1 + (i7 << 3) >> 3] - +HEAPF64[i5 + (i7 << 3) >> 3];
    HEAPF64[i6 + (i3 << 3) >> 3] = +HEAPF64[i1 + (i3 << 3) >> 3] - +HEAPF64[i5 + (i3 << 3) >> 3];
    HEAPF64[i6 + (i7 << 3) >> 3] = d17;
    i7 = i3 | 2;
    i8 = i3 | 3;
    d17 = +HEAPF64[i1 + (i8 << 3) >> 3] - +HEAPF64[i5 + (i8 << 3) >> 3];
    HEAPF64[i6 + (i7 << 3) >> 3] = +HEAPF64[i1 + (i7 << 3) >> 3] - +HEAPF64[i5 + (i7 << 3) >> 3];
    HEAPF64[i6 + (i8 << 3) >> 3] = d17;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   HEAPF64[i6 + (i2 << 3) >> 3] = +HEAPF64[i1 + (i2 << 3) >> 3] - +HEAPF64[i5 + (i2 << 3) >> 3];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 3) | 0;
   i6 = i6 + (i9 << 3) | 0;
   i1 = i1 + (i11 << 3) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function __ZN2cv8vBinOp64IdNS_5OpAddIdddEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i7, i2, i5, i3, i6, i4, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0;
 i16 = STACKTOP;
 i15 = i1 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i8 = i10 + -1 | 0;
 HEAP32[i15 >> 2] = i8;
 if (!i10) {
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i12 + -4 | 0;
 i14 = (i13 | 0) < 0;
 i11 = i2 >>> 3;
 i10 = i3 >>> 3;
 i9 = i4 >>> 3;
 i1 = i7;
 i4 = i8;
 while (1) {
  if (i14) i2 = 0; else {
   i2 = (i13 | 0) > 3;
   i3 = 0;
   do {
    i7 = i3 | 1;
    d17 = +HEAPF64[i1 + (i7 << 3) >> 3] + +HEAPF64[i5 + (i7 << 3) >> 3];
    HEAPF64[i6 + (i3 << 3) >> 3] = +HEAPF64[i1 + (i3 << 3) >> 3] + +HEAPF64[i5 + (i3 << 3) >> 3];
    HEAPF64[i6 + (i7 << 3) >> 3] = d17;
    i7 = i3 | 2;
    i8 = i3 | 3;
    d17 = +HEAPF64[i1 + (i8 << 3) >> 3] + +HEAPF64[i5 + (i8 << 3) >> 3];
    HEAPF64[i6 + (i7 << 3) >> 3] = +HEAPF64[i1 + (i7 << 3) >> 3] + +HEAPF64[i5 + (i7 << 3) >> 3];
    HEAPF64[i6 + (i8 << 3) >> 3] = d17;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) <= (i13 | 0));
   i2 = i2 ? i12 & -4 : 4;
  }
  if ((i2 | 0) < (i12 | 0)) do {
   HEAPF64[i6 + (i2 << 3) >> 3] = +HEAPF64[i1 + (i2 << 3) >> 3] + +HEAPF64[i5 + (i2 << 3) >> 3];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i12 | 0));
  if (!i4) break; else {
   i5 = i5 + (i10 << 3) | 0;
   i6 = i6 + (i9 << 3) | 0;
   i1 = i1 + (i11 << 3) | 0;
   i4 = i4 + -1 | 0;
  }
 }
 HEAP32[i15 >> 2] = -1;
 STACKTOP = i16;
 return;
}

function _wcsnrtombs(i3, i12, i5, i2, i1) {
 i3 = i3 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 i7 = i11 + 8 | 0;
 i10 = i11;
 i4 = HEAP32[i12 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 i9 = (i3 | 0) != 0;
 i2 = i9 ? i2 : 256;
 i3 = i9 ? i3 : i7;
 L1 : do if ((i4 | 0) != 0 & (i2 | 0) != 0) {
  i6 = i2;
  i1 = 0;
  while (1) {
   i2 = i5 >>> 0 >= i6 >>> 0;
   if (!(i2 | i5 >>> 0 > 32)) {
    i2 = i6;
    i8 = 7;
    break L1;
   }
   i4 = i2 ? i6 : i5;
   i5 = i5 - i4 | 0;
   i4 = _wcsrtombs(i3, i10, i4, 0) | 0;
   if ((i4 | 0) == -1) {
    i1 = -1;
    break L1;
   }
   if ((i3 | 0) == (i7 | 0)) {
    i2 = i6;
    i3 = i7;
   } else {
    i2 = i6 - i4 | 0;
    i3 = i3 + i4 | 0;
   }
   i1 = i4 + i1 | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   if ((i4 | 0) != 0 & (i2 | 0) != 0) i6 = i2; else {
    i8 = 7;
    break;
   }
  }
 } else {
  i1 = 0;
  i8 = 7;
 } while (0);
 L9 : do if ((i8 | 0) == 7) if ((i4 | 0) != 0 & (i2 | 0) != 0 & (i5 | 0) != 0) {
  i6 = i5;
  i5 = i2;
  while (1) {
   i2 = _wcrtomb(i3, HEAP32[i4 >> 2] | 0, 0) | 0;
   if ((i2 + 1 | 0) >>> 0 < 2) break;
   i4 = (HEAP32[i10 >> 2] | 0) + 4 | 0;
   HEAP32[i10 >> 2] = i4;
   i6 = i6 + -1 | 0;
   i1 = i1 + 1 | 0;
   if (!((i5 | 0) != (i2 | 0) & (i6 | 0) != 0)) break L9; else {
    i5 = i5 - i2 | 0;
    i3 = i3 + i2 | 0;
   }
  }
  if (!i2) HEAP32[i10 >> 2] = 0; else i1 = -1;
 } while (0);
 if (!i9) {
  STACKTOP = i11;
  return i1 | 0;
 }
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 STACKTOP = i11;
 return i1 | 0;
}

function __ZNSt3__111__stdoutbufIwE8overflowEj(i2, i14) {
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i12 = i15 + 16 | 0;
 i1 = i15 + 8 | 0;
 i11 = i15 + 4 | 0;
 i10 = i15;
 i13 = (i14 | 0) == -1;
 L1 : do if (!i13) {
  HEAP32[i1 >> 2] = i14;
  if (HEAP8[i2 + 44 >> 0] | 0) {
   if ((_fwrite(i1 | 0, 4, 1, HEAP32[i2 + 32 >> 2] | 0) | 0) == 1) break; else i1 = -1;
   STACKTOP = i15;
   return i1 | 0;
  }
  HEAP32[i11 >> 2] = i12;
  i8 = i1 + 4 | 0;
  i9 = i2 + 36 | 0;
  i4 = i2 + 40 | 0;
  i5 = i12 + 8 | 0;
  i6 = i12;
  i7 = i2 + 32 | 0;
  while (1) {
   i2 = HEAP32[i9 >> 2] | 0;
   i2 = FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 15](i2, HEAP32[i4 >> 2] | 0, i1, i8, i10, i12, i5, i11) | 0;
   if ((HEAP32[i10 >> 2] | 0) == (i1 | 0)) {
    i1 = -1;
    i2 = 12;
    break;
   }
   if ((i2 | 0) == 3) {
    i2 = 7;
    break;
   }
   i3 = (i2 | 0) == 1;
   if (i2 >>> 0 >= 2) {
    i1 = -1;
    i2 = 12;
    break;
   }
   i2 = (HEAP32[i11 >> 2] | 0) - i6 | 0;
   if ((_fwrite(i12 | 0, 1, i2 | 0, HEAP32[i7 >> 2] | 0) | 0) != (i2 | 0)) {
    i1 = -1;
    i2 = 12;
    break;
   }
   if (i3) i1 = i3 ? HEAP32[i10 >> 2] | 0 : i1; else break L1;
  }
  if ((i2 | 0) == 7) {
   if ((_fwrite(i1 | 0, 1, 1, HEAP32[i7 >> 2] | 0) | 0) == 1) break; else i1 = -1;
   STACKTOP = i15;
   return i1 | 0;
  } else if ((i2 | 0) == 12) {
   STACKTOP = i15;
   return i1 | 0;
  }
 } while (0);
 i10 = i13 ? 0 : i14;
 STACKTOP = i15;
 return i10 | 0;
}

function __ZNSt3__111__stdoutbufIcE8overflowEi(i2, i14) {
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i12 = i15 + 16 | 0;
 i1 = i15 + 8 | 0;
 i11 = i15 + 4 | 0;
 i10 = i15;
 i13 = (i14 | 0) == -1;
 L1 : do if (!i13) {
  HEAP8[i1 >> 0] = i14;
  if (HEAP8[i2 + 44 >> 0] | 0) {
   if ((_fwrite(i1 | 0, 1, 1, HEAP32[i2 + 32 >> 2] | 0) | 0) == 1) break; else i1 = -1;
   STACKTOP = i15;
   return i1 | 0;
  }
  HEAP32[i11 >> 2] = i12;
  i9 = i1 + 1 | 0;
  i4 = i2 + 36 | 0;
  i5 = i2 + 40 | 0;
  i6 = i12 + 8 | 0;
  i7 = i12;
  i8 = i2 + 32 | 0;
  while (1) {
   i2 = HEAP32[i4 >> 2] | 0;
   i2 = FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 15](i2, HEAP32[i5 >> 2] | 0, i1, i9, i10, i12, i6, i11) | 0;
   if ((HEAP32[i10 >> 2] | 0) == (i1 | 0)) {
    i1 = -1;
    i2 = 12;
    break;
   }
   if ((i2 | 0) == 3) {
    i2 = 7;
    break;
   }
   i3 = (i2 | 0) == 1;
   if (i2 >>> 0 >= 2) {
    i1 = -1;
    i2 = 12;
    break;
   }
   i2 = (HEAP32[i11 >> 2] | 0) - i7 | 0;
   if ((_fwrite(i12 | 0, 1, i2 | 0, HEAP32[i8 >> 2] | 0) | 0) != (i2 | 0)) {
    i1 = -1;
    i2 = 12;
    break;
   }
   if (i3) i1 = i3 ? HEAP32[i10 >> 2] | 0 : i1; else break L1;
  }
  if ((i2 | 0) == 7) {
   if ((_fwrite(i1 | 0, 1, 1, HEAP32[i8 >> 2] | 0) | 0) == 1) break; else i1 = -1;
   STACKTOP = i15;
   return i1 | 0;
  } else if ((i2 | 0) == 12) {
   STACKTOP = i15;
   return i1 | 0;
  }
 } while (0);
 i10 = i13 ? 0 : i14;
 STACKTOP = i15;
 return i10 | 0;
}

function _gzclose_w(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 if (!i9) {
  i1 = -2;
  STACKTOP = i10;
  return i1 | 0;
 }
 if ((HEAP32[i9 + 12 >> 2] | 0) != 31153) {
  i1 = -2;
  STACKTOP = i10;
  return i1 | 0;
 }
 i1 = i9 + 72 | 0;
 L7 : do if (!(HEAP32[i1 >> 2] | 0)) i1 = 0; else {
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[i9 + 68 >> 2] | 0;
  i8 = i9 + 88 | 0;
  if (!((HEAP32[i8 >> 2] | 0) != 0 ? (_gz_comp(i9, 0) | 0) == -1 : 0)) i2 = 6;
  L11 : do if ((i2 | 0) == 6) {
   if (!i1) {
    i1 = 0;
    break L7;
   }
   i4 = i9 + 24 | 0;
   i5 = i9 + 32 | 0;
   i6 = i9 + 8 | 0;
   i7 = i9 + 84 | 0;
   i3 = 0;
   while (1) {
    i2 = HEAP32[i4 >> 2] | 0;
    i2 = (i2 | 0) < 0 | (i2 | 0) > (i1 | 0) ? i1 : i2;
    if (!i3) _memset(HEAP32[i5 >> 2] | 0, 0, i2 | 0) | 0;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i2;
    if ((_gz_comp(i9, 0) | 0) == -1) break L11;
    if ((i1 | 0) == (i2 | 0)) {
     i1 = 0;
     break L7;
    } else {
     i1 = i1 - i2 | 0;
     i3 = 1;
    }
   }
  } while (0);
  i1 = HEAP32[i9 + 76 >> 2] | 0;
 } while (0);
 if ((_gz_comp(i9, 4) | 0) == -1) i1 = HEAP32[i9 + 76 >> 2] | 0;
 if (HEAP32[i9 + 24 >> 2] | 0) {
  if (!(HEAP32[i9 + 40 >> 2] | 0)) {
   _deflateEnd(i9 + 84 | 0) | 0;
   _free(HEAP32[i9 + 36 >> 2] | 0);
  }
  _free(HEAP32[i9 + 32 >> 2] | 0);
 }
 _gz_error(i9, 0, 0);
 _free(HEAP32[i9 + 20 >> 2] | 0);
 i2 = (_close(HEAP32[i9 + 16 >> 2] | 0) | 0) == -1;
 _free(i9);
 i1 = i2 ? -1 : i1;
 STACKTOP = i10;
 return i1 | 0;
}

function _cvSetAdd(i12, i10, i11) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i13;
 if (!i12) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40512, 39608, 2503);
  __ZN2cv6String10deallocateEv(i1);
 }
 i9 = i12 + 56 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  i7 = i12 + 24 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i8 = HEAP32[i12 + 28 >> 2] | 0;
  __ZL10icvGrowSeqP5CvSeqi(i12, 0);
  i5 = i12 + 36 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  i1 = i2 + i8 | 0;
  i6 = HEAP32[i12 + 32 >> 2] | 0;
  if (i1 >>> 0 > i6 >>> 0) i1 = i2; else {
   i4 = i2;
   while (1) {
    HEAP32[i4 >> 2] = i3 | -2147483648;
    HEAP32[i4 + 4 >> 2] = i1;
    i3 = i3 + 1 | 0;
    i4 = i1 + i8 | 0;
    if (i4 >>> 0 > i6 >>> 0) break; else {
     i14 = i1;
     i1 = i4;
     i4 = i14;
    }
   }
  }
  HEAP32[i1 + (4 - i8) >> 2] = 0;
  i8 = (HEAP32[HEAP32[i12 + 52 >> 2] >> 2] | 0) + 12 | 0;
  HEAP32[i8 >> 2] = i3 - (HEAP32[i7 >> 2] | 0) + (HEAP32[i8 >> 2] | 0);
  HEAP32[i7 >> 2] = i3;
  HEAP32[i5 >> 2] = i6;
 } else i2 = i1;
 HEAP32[i9 >> 2] = HEAP32[i2 + 4 >> 2];
 i1 = HEAP32[i2 >> 2] & 67108863;
 if (i10) _memcpy(i2 | 0, i10 | 0, HEAP32[i12 + 28 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = i1;
 i10 = i12 + 60 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 if (!i11) {
  STACKTOP = i13;
  return i1 | 0;
 }
 HEAP32[i11 >> 2] = i2;
 STACKTOP = i13;
 return i1 | 0;
}

function __ZN7testing18TestEventListeners23SetDefaultResultPrinterEPNS_17TestEventListenerE(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i12;
 i6 = i9 + 4 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if ((i7 | 0) == (i11 | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i8 = i5 + 12 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 L4 : do if ((i3 | 0) != (i5 | 0)) {
  i2 = i3 - i5 >> 2;
  i4 = 0;
  while (1) {
   i1 = i4 + 1 | 0;
   if ((HEAP32[i5 + (i4 << 2) >> 2] | 0) == (i7 | 0)) break;
   if (i1 >>> 0 < i2 >>> 0) i4 = i1; else break L4;
  }
  i2 = i4 << 2 >> 2;
  i4 = i5 + (i2 + 1 << 2) | 0;
  i3 = i3 - i4 | 0;
  _memmove(i5 + (i2 << 2) | 0, i4 | 0, i3 | 0) | 0;
  i3 = i5 + ((i3 >> 2) + i2 << 2) | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) HEAP32[i8 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
  if (i7) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] & 511](i7);
 } while (0);
 HEAP32[i6 >> 2] = i11;
 if (!i11) {
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = i11;
 i3 = i1 + 12 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
  __ZNSt3__16vectorIPN7testing17TestEventListenerENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i1 + 8 | 0, i10);
  STACKTOP = i12;
  return;
 }
 if (!i2) i1 = 0; else {
  HEAP32[i2 >> 2] = i11;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 4;
 STACKTOP = i12;
 return;
}

function __ZN2cvL9cvt32s16uEPKijPKhjPtjNS_5Size_IiEEPd(i7, i5, i1, i2, i8, i6, i4, i3) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 i14 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i13 = i5 >>> 2;
 i11 = i6 >>> 1;
 if (!i4) {
  STACKTOP = i15;
  return;
 }
 i12 = i14 + -4 | 0;
 i9 = (i12 | 0) < 0;
 i10 = (i12 | 0) > 3 ? i14 & -4 : 4;
 i1 = i4;
 while (1) {
  i1 = i1 + -1 | 0;
  if (i9) i5 = 0; else {
   i2 = 0;
   do {
    i5 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    i4 = i2 | 1;
    i6 = HEAP32[i7 + (i4 << 2) >> 2] | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i2 << 1) >> 1] = i5;
    HEAP16[i8 + (i4 << 1) >> 1] = i6;
    i3 = i2 | 2;
    i6 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
    if (i6 >>> 0 >= 65536) i6 = (i6 | 0) > 0 ? 65535 : 0;
    i4 = i2 | 3;
    i5 = HEAP32[i7 + (i4 << 2) >> 2] | 0;
    if (i5 >>> 0 >= 65536) i5 = (i5 | 0) > 0 ? 65535 : 0;
    HEAP16[i8 + (i3 << 1) >> 1] = i6;
    HEAP16[i8 + (i4 << 1) >> 1] = i5;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) <= (i12 | 0));
   i5 = i10;
  }
  if ((i5 | 0) < (i14 | 0)) do {
   i4 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
   if (i4 >>> 0 >= 65536) i4 = (i4 | 0) > 0 ? 65535 : 0;
   HEAP16[i8 + (i5 << 1) >> 1] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if (!i1) break; else {
   i7 = i7 + (i13 << 2) | 0;
   i8 = i8 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZNK2cv16TLSDataContainer7getDataEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i12 + 8 | 0;
 i1 = i12;
 i7 = i5 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i1, 9) | 0) + 0 | 0;
  i3 = 26752 | 0;
  i4 = i2 + 9 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 26768, 26776, 1034);
  __ZN2cv6String10deallocateEv(i1);
 }
 i8 = __ZN2cv10TLSStorage3getEv() | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (((HEAP32[i9 >> 2] | 0) - i1 >> 2 | 0) > (i2 | 0) ? (i6 = HEAP32[i1 + (i2 << 2) >> 2] | 0, (i6 | 0) != 0) : 0) {
  i10 = i6;
  STACKTOP = i12;
  return i10 | 0;
 }
 i6 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 127](i5) | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i4 - i1 >> 2;
 do if ((i3 | 0) <= (i5 | 0)) {
  i2 = i5 + 1 | 0;
  HEAP32[i10 >> 2] = 0;
  if (i2 >>> 0 > i3 >>> 0) {
   __ZNSt3__16vectorIPvNS_9allocatorIS1_EEE8__appendEjRKS1_(i8, i2 - i3 | 0, i10);
   i1 = HEAP32[i8 >> 2] | 0;
   break;
  }
  if (i2 >>> 0 < i3 >>> 0 ? (i11 = i1 + (i2 << 2) | 0, (i4 | 0) != (i11 | 0)) : 0) HEAP32[i9 >> 2] = i4 + (~((i4 + -4 - i11 | 0) >>> 2) << 2);
 } while (0);
 HEAP32[i1 + (i5 << 2) >> 2] = i6;
 i10 = i6;
 STACKTOP = i12;
 return i10 | 0;
}

function __ZNKSt3__18messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i11, i2, i5, i7, i6, i4) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i10;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i2 = HEAP8[i4 >> 0] | 0;
 if (!(i2 & 1)) {
  i3 = i4 + 1 | 0;
  i1 = (i2 & 255) >>> 1;
  i2 = i4 + 1 | 0;
 } else {
  i2 = HEAP32[i4 + 8 >> 2] | 0;
  i3 = i2;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
 }
 i1 = i3 + i1 | 0;
 if (i2 >>> 0 < i1 >>> 0) {
  do {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i9, HEAP8[i2 >> 0] | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
  i2 = (i5 | 0) == -1 ? -1 : i5 << 1;
  if (!(HEAP8[i9 >> 0] & 1)) i8 = 9; else i1 = HEAP32[i9 + 8 >> 2] | 0;
 } else {
  i2 = (i5 | 0) == -1 ? -1 : i5 << 1;
  i8 = 9;
 }
 if ((i8 | 0) == 9) i1 = i9 + 1 | 0;
 i1 = _catgets(i2 | 0, i7 | 0, i6 | 0, i1 | 0) | 0;
 HEAP32[i11 + 0 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i8 = _strlen(i1 | 0) | 0;
 i2 = i1 + i8 | 0;
 if ((i8 | 0) <= 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
  STACKTOP = i10;
  return;
 }
 do {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i11, HEAP8[i1 >> 0] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i9);
 STACKTOP = i10;
 return;
}

function __ZN2cv3absERKNS_3MatE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i3 = i7;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 1124007936;
 i2 = i5 + 16 | 0;
 i1 = i5 + 48 | 0;
 i6 = i5 + 12 | 0;
 i8 = i6 + 36 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 HEAP32[i1 >> 2] = i2;
 i1 = i5 + 56 | 0;
 HEAP32[i5 + 52 >> 2] = i1;
 HEAP32[i5 + 60 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 + 64 >> 2] = 1124007936;
 i1 = i5 + 72 | 0;
 i2 = i5 + 104 | 0;
 i6 = i5 + 68 | 0;
 i8 = i6 + 36 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 HEAP32[i2 >> 2] = i1;
 i2 = i5 + 112 | 0;
 HEAP32[i5 + 108 >> 2] = i2;
 HEAP32[i5 + 116 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i5 + 120 >> 2] = 1124007936;
 i2 = i5 + 128 | 0;
 i1 = i5 + 160 | 0;
 i6 = i5 + 124 | 0;
 i8 = i6 + 36 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 HEAP32[i1 >> 2] = i2;
 i6 = i5 + 168 | 0;
 HEAP32[i5 + 164 >> 2] = i6;
 i6 = i6 + 0 | 0;
 i8 = i6 + 56 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 HEAP32[i3 + 0 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAPF64[i3 >> 3] = 0.0;
 __ZN2cv9MatOp_Bin8makeExprERNS_7MatExprEcRKNS_3MatERKNS_7Scalar_IdEE(i5, 97, i4, i3);
 STACKTOP = i7;
 return;
}

function __ZN2cv3MatC2ERKS0_(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 i8 = i3 + 4 | 0;
 i2 = i6 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i3 + 32 >> 2] = HEAP32[i6 + 32 >> 2];
 i1 = HEAP32[i6 + 36 >> 2] | 0;
 HEAP32[i3 + 36 >> 2] = i1;
 i4 = i3 + 40 | 0;
 HEAP32[i4 >> 2] = i5;
 i5 = i3 + 48 | 0;
 i7 = i3 + 44 | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i3 + 52 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 if (i1) {
  i1 = i1 + 12 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 }
 if ((HEAP32[i2 >> 2] | 0) < 3) {
  i2 = HEAP32[i6 + 44 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  STACKTOP = i9;
  return;
 }
 HEAP32[i8 >> 2] = 0;
 __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i3, HEAP32[i2 >> 2] | 0, 0, 0, 0);
 if ((HEAP32[i8 >> 2] | 0) <= 0) {
  STACKTOP = i9;
  return;
 }
 i5 = HEAP32[i6 + 40 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i6 + 44 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = 0;
 do {
  HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
  HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (HEAP32[i8 >> 2] | 0));
 STACKTOP = i9;
 return;
}

function __ZN2cv6vBinOpIhNS_5OpSubIhhhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i8, i1, i9, i2, i7, i10) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 i6 = i10 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5 + -1;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i5 = i2;
 i2 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i2 = 0;
   while (1) {
    i13 = i2 | 1;
    i4 = HEAP8[36320 + ((HEAPU8[i3 + i13 >> 0] | 0 | 256) - (HEAPU8[i1 + i13 >> 0] | 0)) >> 0] | 0;
    HEAP8[i5 + i2 >> 0] = HEAP8[36320 + ((HEAPU8[i3 + i2 >> 0] | 0 | 256) - (HEAPU8[i1 + i2 >> 0] | 0)) >> 0] | 0;
    HEAP8[i5 + i13 >> 0] = i4;
    i13 = i2 | 2;
    i4 = i2 | 3;
    i12 = HEAP8[36320 + ((HEAPU8[i3 + i4 >> 0] | 0 | 256) - (HEAPU8[i1 + i4 >> 0] | 0)) >> 0] | 0;
    HEAP8[i5 + i13 >> 0] = HEAP8[36320 + ((HEAPU8[i3 + i13 >> 0] | 0 | 256) - (HEAPU8[i1 + i13 >> 0] | 0)) >> 0] | 0;
    HEAP8[i5 + i4 >> 0] = i12;
    i4 = i2 + 4 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) > (i2 + -4 | 0)) break; else i2 = i4;
   }
  }
  if ((i4 | 0) < (i2 | 0)) do {
   HEAP8[i5 + i4 >> 0] = HEAP8[36320 + ((HEAPU8[i3 + i4 >> 0] | 0 | 256) - (HEAPU8[i1 + i4 >> 0] | 0)) >> 0] | 0;
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + -1;
  if (!i4) break; else {
   i1 = i1 + i9 | 0;
   i5 = i5 + i7 | 0;
   i3 = i3 + i8 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cv6vBinOpIhNS_5OpAddIhhhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i8, i1, i9, i2, i7, i10) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 i6 = i10 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5 + -1;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i5 = i2;
 i2 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i2 = 0;
   while (1) {
    i13 = i2 | 1;
    i4 = HEAP8[36320 + ((HEAPU8[i3 + i13 >> 0] | 0 | 256) + (HEAPU8[i1 + i13 >> 0] | 0)) >> 0] | 0;
    HEAP8[i5 + i2 >> 0] = HEAP8[36320 + ((HEAPU8[i3 + i2 >> 0] | 0 | 256) + (HEAPU8[i1 + i2 >> 0] | 0)) >> 0] | 0;
    HEAP8[i5 + i13 >> 0] = i4;
    i13 = i2 | 2;
    i4 = i2 | 3;
    i12 = HEAP8[36320 + ((HEAPU8[i3 + i4 >> 0] | 0 | 256) + (HEAPU8[i1 + i4 >> 0] | 0)) >> 0] | 0;
    HEAP8[i5 + i13 >> 0] = HEAP8[36320 + ((HEAPU8[i3 + i13 >> 0] | 0 | 256) + (HEAPU8[i1 + i13 >> 0] | 0)) >> 0] | 0;
    HEAP8[i5 + i4 >> 0] = i12;
    i4 = i2 + 4 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) > (i2 + -4 | 0)) break; else i2 = i4;
   }
  }
  if ((i4 | 0) < (i2 | 0)) do {
   HEAP8[i5 + i4 >> 0] = HEAP8[36320 + ((HEAPU8[i3 + i4 >> 0] | 0 | 256) + (HEAPU8[i1 + i4 >> 0] | 0)) >> 0] | 0;
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + -1;
  if (!i4) break; else {
   i1 = i1 + i9 | 0;
   i5 = i5 + i7 | 0;
   i3 = i3 + i8 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function _mbrtowc(i3, i4, i7, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = i3;
 i6 = (i1 | 0) == 0 ? 968600 : i1;
 i1 = HEAP32[i6 >> 2] | 0;
 L1 : do if (!i4) {
  if (!i1) {
   i1 = 0;
   STACKTOP = i8;
   return i1 | 0;
  }
 } else {
  if (!i3) {
   HEAP32[i2 >> 2] = i2;
   i3 = i2;
  }
  if (!i7) {
   i1 = -2;
   STACKTOP = i8;
   return i1 | 0;
  }
  do if (!i1) {
   i1 = HEAP8[i4 >> 0] | 0;
   i2 = i1 & 255;
   if (i1 << 24 >> 24 > -1) {
    HEAP32[i3 >> 2] = i2;
    i1 = i1 << 24 >> 24 != 0 & 1;
    STACKTOP = i8;
    return i1 | 0;
   } else {
    i1 = i2 + -194 | 0;
    if (i1 >>> 0 > 50) break L1;
    i5 = i7 + -1 | 0;
    i1 = HEAP32[968384 + (i1 << 2) >> 2] | 0;
    i2 = i4 + 1 | 0;
    break;
   }
  } else {
   i5 = i7;
   i2 = i4;
  } while (0);
  L19 : do if (i5) {
   i4 = HEAP8[i2 >> 0] | 0;
   i9 = (i4 & 255) >>> 3;
   if ((i9 + -16 | i9 + (i1 >> 26)) >>> 0 > 7) break L1;
   while (1) {
    i2 = i2 + 1 | 0;
    i1 = (i4 & 255) + -128 | i1 << 6;
    i5 = i5 + -1 | 0;
    if ((i1 | 0) >= 0) break;
    if (!i5) break L19;
    i4 = HEAP8[i2 >> 0] | 0;
    if ((i4 & -64) << 24 >> 24 != -128) break L1;
   }
   HEAP32[i6 >> 2] = 0;
   HEAP32[i3 >> 2] = i1;
   i1 = i7 - i5 | 0;
   STACKTOP = i8;
   return i1 | 0;
  } while (0);
  HEAP32[i6 >> 2] = i1;
  i1 = -2;
  STACKTOP = i8;
  return i1 | 0;
 } while (0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[(___errno_location() | 0) >> 2] = 84;
 i1 = -1;
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN2cv16TLSDataContainerC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i8;
 HEAP32[i3 >> 2] = 26736;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = -1;
 if ((HEAP8[27120] | 0) == 0 ? (___cxa_guard_acquire(27120) | 0) != 0 : 0) {
  i1 = __Znwj(16) | 0;
  i5 = __Znwj(28) | 0;
  _pthread_mutexattr_init(i2 | 0) | 0;
  _pthread_mutexattr_settype(i2 | 0, 1) | 0;
  _pthread_mutex_init(i5 | 0, i2 | 0) | 0;
  _pthread_mutexattr_destroy(i2 | 0) | 0;
  HEAP32[i5 + 24 >> 2] = 1;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[6778] = i1;
  ___cxa_guard_release(27120);
 }
 i5 = HEAP32[6778] | 0;
 HEAP32[i2 >> 2] = i3;
 _pthread_mutex_lock(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i5 + 4 | 0;
 i7 = i5 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i5 + 12 >> 2] | 0)) {
  __ZNSt3__16vectorIPN2cv16TLSDataContainerENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6, i2);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i1 = i2 - i1 | 0;
  i1 = i1 >> 2;
  i1 = i1 + -1 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  _pthread_mutex_unlock(i2 | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  STACKTOP = i8;
  return;
 }
 if (!i1) i1 = 0; else {
  HEAP32[i1 >> 2] = i3;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i2 = i1 + 4 | 0;
 HEAP32[i7 >> 2] = i2;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = i2 - i1 | 0;
 i1 = i1 >> 2;
 i1 = i1 + -1 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 _pthread_mutex_unlock(i2 | 0) | 0;
 HEAP32[i4 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __Z15RGBE_ReadPixelsP8_IO_FILEPfi(i9, i3, i2) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = Math_fround(0);
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i12 = i13;
 i10 = i13 + 8 | 0;
 if ((i2 | 0) <= 0) {
  i10 = 0;
  STACKTOP = i13;
  return i10 | 0;
 }
 i6 = i10 + 3 | 0;
 i7 = i10 + 1 | 0;
 i8 = i10 + 2 | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  if (!(_fread(i10 | 0, 4, 1, i9 | 0) | 0)) break;
  i1 = i3 + 8 | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP8[i6 >> 0] | 0;
  if (!(i5 << 24 >> 24)) {
   HEAPF32[i3 >> 2] = Math_fround(0.0);
   HEAPF32[i4 >> 2] = Math_fround(0.0);
   HEAPF32[i1 >> 2] = Math_fround(0.0);
  } else {
   f14 = Math_fround(+_ldexp(1.0, (i5 & 255) + -136 | 0));
   HEAPF32[i1 >> 2] = Math_fround(f14 * Math_fround(HEAPU8[i10 >> 0] | 0 | 0));
   HEAPF32[i4 >> 2] = Math_fround(f14 * Math_fround(HEAPU8[i7 >> 0] | 0 | 0));
   HEAPF32[i3 >> 2] = Math_fround(f14 * Math_fround(HEAPU8[i8 >> 0] | 0 | 0));
  }
  if ((i2 | 0) <= 0) {
   i1 = 0;
   i11 = 9;
   break;
  } else i3 = i3 + 12 | 0;
 }
 if ((i11 | 0) == 9) {
  STACKTOP = i13;
  return i1 | 0;
 }
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i1 = (__ZN2cv6String8allocateEj(i12, 15) | 0) + 0 | 0;
 i2 = 181688 | 0;
 i3 = i1 + 15 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i12, 181704, 181720, 90);
 __ZN2cv6String10deallocateEv(i12);
 i10 = -1;
 STACKTOP = i13;
 return i10 | 0;
}

function __ZN2cv8vBinOp32IiNS_5OpSubIiiiEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i6, i1, i4, i2, i5, i3, i10) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 i9 = i10 + 4 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i8 + -1;
 if (!i8) {
  STACKTOP = i11;
  return;
 }
 i8 = i1 >>> 2;
 i7 = i2 >>> 2;
 i3 = i3 >>> 2;
 i1 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i1 + -4 | 0) < 0) i2 = 0; else {
   i2 = 0;
   do {
    i13 = i2 | 1;
    i1 = (HEAP32[i6 + (i13 << 2) >> 2] | 0) - (HEAP32[i4 + (i13 << 2) >> 2] | 0) | 0;
    HEAP32[i5 + (i2 << 2) >> 2] = (HEAP32[i6 + (i2 << 2) >> 2] | 0) - (HEAP32[i4 + (i2 << 2) >> 2] | 0);
    HEAP32[i5 + (i13 << 2) >> 2] = i1;
    i13 = i2 | 2;
    i1 = i2 | 3;
    i12 = (HEAP32[i6 + (i1 << 2) >> 2] | 0) - (HEAP32[i4 + (i1 << 2) >> 2] | 0) | 0;
    HEAP32[i5 + (i13 << 2) >> 2] = (HEAP32[i6 + (i13 << 2) >> 2] | 0) - (HEAP32[i4 + (i13 << 2) >> 2] | 0);
    HEAP32[i5 + (i1 << 2) >> 2] = i12;
    i2 = i2 + 4 | 0;
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i2 | 0) <= (i1 + -4 | 0));
  }
  if ((i2 | 0) < (i1 | 0)) do {
   HEAP32[i5 + (i2 << 2) >> 2] = (HEAP32[i6 + (i2 << 2) >> 2] | 0) - (HEAP32[i4 + (i2 << 2) >> 2] | 0);
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } while ((i2 | 0) < (i1 | 0));
  i2 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i2 + -1;
  if (!i2) break; else {
   i4 = i4 + (i7 << 2) | 0;
   i5 = i5 + (i3 << 2) | 0;
   i6 = i6 + (i8 << 2) | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cv8vBinOp32IiNS_5OpAddIiiiEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i6, i1, i4, i2, i5, i3, i10) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 i9 = i10 + 4 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i8 + -1;
 if (!i8) {
  STACKTOP = i11;
  return;
 }
 i8 = i1 >>> 2;
 i7 = i2 >>> 2;
 i3 = i3 >>> 2;
 i1 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i1 + -4 | 0) < 0) i2 = 0; else {
   i2 = 0;
   do {
    i13 = i2 | 1;
    i1 = (HEAP32[i4 + (i13 << 2) >> 2] | 0) + (HEAP32[i6 + (i13 << 2) >> 2] | 0) | 0;
    HEAP32[i5 + (i2 << 2) >> 2] = (HEAP32[i4 + (i2 << 2) >> 2] | 0) + (HEAP32[i6 + (i2 << 2) >> 2] | 0);
    HEAP32[i5 + (i13 << 2) >> 2] = i1;
    i13 = i2 | 2;
    i1 = i2 | 3;
    i12 = (HEAP32[i4 + (i1 << 2) >> 2] | 0) + (HEAP32[i6 + (i1 << 2) >> 2] | 0) | 0;
    HEAP32[i5 + (i13 << 2) >> 2] = (HEAP32[i4 + (i13 << 2) >> 2] | 0) + (HEAP32[i6 + (i13 << 2) >> 2] | 0);
    HEAP32[i5 + (i1 << 2) >> 2] = i12;
    i2 = i2 + 4 | 0;
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i2 | 0) <= (i1 + -4 | 0));
  }
  if ((i2 | 0) < (i1 | 0)) do {
   HEAP32[i5 + (i2 << 2) >> 2] = (HEAP32[i4 + (i2 << 2) >> 2] | 0) + (HEAP32[i6 + (i2 << 2) >> 2] | 0);
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } while ((i2 | 0) < (i1 | 0));
  i2 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i2 + -1;
  if (!i2) break; else {
   i4 = i4 + (i7 << 2) | 0;
   i5 = i5 + (i3 << 2) | 0;
   i6 = i6 + (i8 << 2) | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv(i11, i1, i10, i9, i8, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 i4 = i7;
 i12 = i7 + 180 | 0;
 i3 = i7 + 160 | 0;
 i6 = i7 + 12 | 0;
 i14 = i7 + 8 | 0;
 i5 = i7 + 4 | 0;
 HEAP8[i12 + 0 >> 0] = HEAP8[959528] | 0;
 HEAP8[i12 + 1 >> 0] = HEAP8[959529] | 0;
 HEAP8[i12 + 2 >> 0] = HEAP8[959530] | 0;
 HEAP8[i12 + 3 >> 0] = HEAP8[959531] | 0;
 HEAP8[i12 + 4 >> 0] = HEAP8[959532] | 0;
 HEAP8[i12 + 5 >> 0] = HEAP8[959533] | 0;
 i1 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i4 >> 2] = i2;
 i2 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i3, 20, i1, i12, i4) | 0;
 i12 = i3 + i2 | 0;
 i1 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i3, i12, i9) | 0;
 __ZNKSt3__18ios_base6getlocEv(i14, i9);
 i13 = __ZNKSt3__16locale9use_facetERNS0_2idE(i14, 960720) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i14 >> 2] | 0) | 0;
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i13 >> 2] | 0) + 48 >> 2] & 7](i13, i3, i12, i6) | 0;
 i2 = i6 + (i2 << 2) | 0;
 if ((i1 | 0) == (i12 | 0)) i1 = i2; else i1 = i6 + (i1 - i3 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i4 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i11, i4, i6, i1, i2, i9, i8);
 STACKTOP = i7;
 return;
}

function __ZN2cv12WLByteStream8putDWordEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 i4 = i6 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 3 | 0;
 i5 = i6 + 8 | 0;
 i3 = i7 & 255;
 if (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i1 >> 0] = i3;
  HEAP8[i1 + 1 >> 0] = i7 >>> 8;
  HEAP8[i1 + 2 >> 0] = i7 >>> 16;
  HEAP8[i2 >> 0] = i7 >>> 24;
  i1 = i1 + 4 | 0;
  HEAP32[i4 >> 2] = i1;
  if ((i1 | 0) != (HEAP32[i5 >> 2] | 0)) {
   STACKTOP = i8;
   return;
  }
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
  STACKTOP = i8;
  return;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i3;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i7 >>> 8;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i7 >>> 16;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i7 >>> 24;
 if ((HEAP32[i4 >> 2] | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  STACKTOP = i8;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
 STACKTOP = i8;
 return;
}

function __ZN2cvL8cvt32s8sEPKijPKhjPajNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i15, i4, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = i5 >>> 2;
 if (!i4) {
  STACKTOP = i14;
  return;
 }
 i11 = i13 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i9 = i13 & -4;
 i8 = i4;
 while (1) {
  i8 = i8 + -1 | 0;
  if (i12) i5 = 0; else {
   i1 = 0;
   do {
    i5 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i3 = i1 | 1;
    i4 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i3 >> 0] = i4;
    i2 = i1 | 2;
    i5 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
    if ((i5 + 128 | 0) >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 127 : -128;
    i3 = i1 | 3;
    i4 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
    if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
    HEAP8[i7 + i2 >> 0] = i5;
    HEAP8[i7 + i3 >> 0] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i11 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   i4 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
   if ((i4 + 128 | 0) >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 127 : -128;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i8) break; else {
   i6 = i6 + (i10 << 2) | 0;
   i7 = i7 + i15 | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN7testing8internal18InitGoogleTestImplIcEEvPiPPT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5;
 i4 = HEAP32[40112] | 0;
 HEAP32[40112] = i4 + 1;
 if (i4) {
  STACKTOP = i5;
  return;
 }
 if ((HEAP32[i2 >> 2] | 0) < 1) {
  STACKTOP = i5;
  return;
 }
 __ZN7testing8internal18StreamableToStringIPcEENSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEERKT_(i1, i3);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(160456, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 __ZN7testing8internal28ParseGoogleTestFlagsOnlyImplIcEEvPiPPT_(i2, i3);
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i1 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i1, 163728);
  HEAP32[40934] = i1;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i4 = HEAP32[40934] | 0;
 i1 = i4 + 168 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  STACKTOP = i5;
  return;
 }
 HEAP8[i1 >> 0] = 1;
 i2 = i4 + 96 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i3 = HEAP32[i4 + 84 >> 2] | 0;
  i1 = i4 + 88 | 0;
  if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) do {
   i6 = HEAP32[i3 >> 2] | 0;
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] & 511](i6);
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (HEAP32[i1 >> 2] | 0));
  HEAP8[i2 >> 0] = 1;
 }
 __ZN7testing8internal12UnitTestImpl18ConfigureXmlOutputEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN2cvL14cvtScale32s32fEPKijPKhjPfjNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, d13 = 0.0, d14 = 0.0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 d14 = +HEAPF64[i4 >> 3];
 d13 = +HEAPF64[i4 + 8 >> 3];
 i11 = i5 >>> 2;
 i9 = i6 >>> 2;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i1 = i15 + -4 | 0;
 i7 = (i1 | 0) < 0;
 i8 = (i1 | 0) > 3 ? i15 & -4 : 4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i7) i5 = 0; else {
   i5 = 0;
   do {
    f17 = Math_fround(d13 + d14 * +(HEAP32[i4 + (i5 << 2) >> 2] | 0));
    i2 = i5 | 1;
    f18 = Math_fround(d13 + d14 * +(HEAP32[i4 + (i2 << 2) >> 2] | 0));
    HEAPF32[i3 + (i5 << 2) >> 2] = f17;
    HEAPF32[i3 + (i2 << 2) >> 2] = f18;
    i2 = i5 | 2;
    f18 = Math_fround(d13 + d14 * +(HEAP32[i4 + (i2 << 2) >> 2] | 0));
    i10 = i5 | 3;
    f17 = Math_fround(d13 + d14 * +(HEAP32[i4 + (i10 << 2) >> 2] | 0));
    HEAPF32[i3 + (i2 << 2) >> 2] = f18;
    HEAPF32[i3 + (i10 << 2) >> 2] = f17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i1 | 0));
   i5 = i8;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAPF32[i3 + (i5 << 2) >> 2] = Math_fround(d13 + d14 * +(HEAP32[i4 + (i5 << 2) >> 2] | 0));
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i9 << 2) | 0;
   i4 = i4 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cv12WMByteStream8putDWordEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 i4 = i6 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 3 | 0;
 i5 = i6 + 8 | 0;
 i3 = i7 >>> 24 & 255;
 if (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i1 >> 0] = i3;
  HEAP8[i1 + 1 >> 0] = i7 >>> 16;
  HEAP8[i1 + 2 >> 0] = i7 >>> 8;
  HEAP8[i2 >> 0] = i7;
  i1 = i1 + 4 | 0;
  HEAP32[i4 >> 2] = i1;
  if ((i1 | 0) != (HEAP32[i5 >> 2] | 0)) {
   STACKTOP = i8;
   return;
  }
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
  STACKTOP = i8;
  return;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i3;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i7 >>> 16;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i7 >>> 8;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i7;
 if ((HEAP32[i4 >> 2] | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  STACKTOP = i8;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
 STACKTOP = i8;
 return;
}

function _cvStartReadSeq(i4, i11, i10) {
 i4 = i4 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i12;
 if (!((i11 | 0) != 0 ? (i1 = i11 + 4 | 0, HEAP32[i1 + 0 >> 2] = 0, HEAP32[i1 + 4 >> 2] = 0, HEAP32[i1 + 8 >> 2] = 0, HEAP32[i1 + 12 >> 2] = 0, HEAP32[i1 + 16 >> 2] = 0, (i4 | 0) != 0) : 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i2, 40136, 39608, 944);
  __ZN2cv6String10deallocateEv(i2);
  i1 = i11 + 4 | 0;
 }
 HEAP32[i11 >> 2] = 32;
 HEAP32[i1 >> 2] = i4;
 i9 = HEAP32[i4 + 52 >> 2] | 0;
 if (!i9) {
  i10 = i11 + 8 | 0;
  HEAP32[i10 + 0 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAP32[i10 + 16 >> 2] = 0;
  HEAP32[i10 + 20 >> 2] = 0;
  STACKTOP = i12;
  return;
 }
 i7 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i9 + 16 >> 2] | 0;
 i6 = i11 + 12 | 0;
 HEAP32[i6 >> 2] = i5;
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 i8 = HEAP32[i4 + 28 >> 2] | 0;
 i3 = i2 + (Math_imul(i1 + -1 | 0, i8) | 0) | 0;
 i4 = i11 + 28 | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i11 + 24 >> 2] = HEAP32[i9 + 8 >> 2];
 if (!i10) {
  HEAP32[i11 + 8 >> 2] = i9;
  i2 = i5;
  i1 = HEAP32[i9 + 12 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = i3;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i11 + 8 >> 2] = i7;
 }
 HEAP32[i11 + 16 >> 2] = i2;
 HEAP32[i11 + 20 >> 2] = i2 + (Math_imul(i8, i1) | 0);
 STACKTOP = i12;
 return;
}

function __ZNSt3__16vectorIPvNS_9allocatorIS1_EEE8__appendEjRKS1_(i8, i2, i9) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 i7 = i8 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i1;
 if (i4 - i3 >> 2 >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
    i1 = HEAP32[i10 >> 2] | 0;
   }
   i1 = i1 + 4 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = (i3 - i1 >> 2) + i2 | 0;
 if (i3 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i8);
 i5 = i1;
 i1 = i4 - i5 | 0;
 if (i1 >> 2 >>> 0 < 536870911) {
  i1 = i1 >> 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = (HEAP32[i10 >> 2] | 0) - i5 >> 2;
  if (!i1) {
   i4 = 0;
   i5 = 0;
  } else i6 = 10;
 } else {
  i1 = 1073741823;
  i3 = (HEAP32[i10 >> 2] | 0) - i5 >> 2;
  i6 = 10;
 }
 if ((i6 | 0) == 10) {
  i4 = i1;
  i5 = __Znwj(i1 << 2) | 0;
 }
 i1 = i5 + (i3 << 2) | 0;
 do {
  if (!i1) i1 = 0; else HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = (HEAP32[i10 >> 2] | 0) - i2 | 0;
 i9 = i5 + (i3 - (i6 >> 2) << 2) | 0;
 _memcpy(i9 | 0, i2 | 0, i6 | 0) | 0;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i7 >> 2] = i5 + (i4 << 2);
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i11;
 return;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv(i11, i1, i10, i9, i8, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 i4 = i7;
 i12 = i7 + 72 | 0;
 i3 = i7 + 52 | 0;
 i6 = i7 + 12 | 0;
 i14 = i7 + 8 | 0;
 i5 = i7 + 4 | 0;
 HEAP8[i12 + 0 >> 0] = HEAP8[959528] | 0;
 HEAP8[i12 + 1 >> 0] = HEAP8[959529] | 0;
 HEAP8[i12 + 2 >> 0] = HEAP8[959530] | 0;
 HEAP8[i12 + 3 >> 0] = HEAP8[959531] | 0;
 HEAP8[i12 + 4 >> 0] = HEAP8[959532] | 0;
 HEAP8[i12 + 5 >> 0] = HEAP8[959533] | 0;
 i1 = __ZNSt3__16__clocEv() | 0;
 HEAP32[i4 >> 2] = i2;
 i2 = __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i3, 20, i1, i12, i4) | 0;
 i12 = i3 + i2 | 0;
 i1 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i3, i12, i9) | 0;
 __ZNKSt3__18ios_base6getlocEv(i14, i9);
 i13 = __ZNKSt3__16locale9use_facetERNS0_2idE(i14, 960728) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i14 >> 2] | 0) | 0;
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] & 7](i13, i3, i12, i6) | 0;
 i2 = i6 + i2 | 0;
 if ((i1 | 0) == (i12 | 0)) i1 = i2; else i1 = i6 + (i1 - i3) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i4 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i11, i4, i6, i1, i2, i9, i8);
 STACKTOP = i7;
 return;
}

function __ZN2cvL8cvt64f8uEPKdjPKhjPhjNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i15, i4, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = i5 >>> 3;
 if (!i4) {
  STACKTOP = i14;
  return;
 }
 i11 = i13 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i9 = i13 & -4;
 i8 = i4;
 while (1) {
  i8 = i8 + -1 | 0;
  if (i12) i5 = 0; else {
   i1 = 0;
   do {
    i5 = _lrint(+HEAPF64[i6 + (i1 << 3) >> 3]) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i3 = i1 | 1;
    i4 = _lrint(+HEAPF64[i6 + (i3 << 3) >> 3]) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i3 >> 0] = i4;
    i2 = i1 | 2;
    i5 = _lrint(+HEAPF64[i6 + (i2 << 3) >> 3]) | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i3 = i1 | 3;
    i4 = _lrint(+HEAPF64[i6 + (i3 << 3) >> 3]) | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i2 >> 0] = i5;
    HEAP8[i7 + i3 >> 0] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i11 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   i4 = _lrint(+HEAPF64[i6 + (i5 << 3) >> 3]) | 0;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i8) break; else {
   i6 = i6 + (i10 << 3) | 0;
   i7 = i7 + i15 | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cvL14cvtScale32f64fEPKfjPKhjPdjNS_5Size_IiEES4_(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, d13 = 0.0, d14 = 0.0, i15 = 0, i16 = 0, d17 = 0.0, d18 = 0.0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 d14 = +HEAPF64[i4 >> 3];
 d13 = +HEAPF64[i4 + 8 >> 3];
 i11 = i5 >>> 2;
 i9 = i6 >>> 3;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i1 = i15 + -4 | 0;
 i7 = (i1 | 0) < 0;
 i8 = (i1 | 0) > 3 ? i15 & -4 : 4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i7) i5 = 0; else {
   i5 = 0;
   do {
    d17 = d13 + d14 * +Math_fround(HEAPF32[i4 + (i5 << 2) >> 2]);
    i2 = i5 | 1;
    d18 = d13 + d14 * +Math_fround(HEAPF32[i4 + (i2 << 2) >> 2]);
    HEAPF64[i3 + (i5 << 3) >> 3] = d17;
    HEAPF64[i3 + (i2 << 3) >> 3] = d18;
    i2 = i5 | 2;
    d18 = d13 + d14 * +Math_fround(HEAPF32[i4 + (i2 << 2) >> 2]);
    i10 = i5 | 3;
    d17 = d13 + d14 * +Math_fround(HEAPF32[i4 + (i10 << 2) >> 2]);
    HEAPF64[i3 + (i2 << 3) >> 3] = d18;
    HEAPF64[i3 + (i10 << 3) >> 3] = d17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i1 | 0));
   i5 = i8;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAPF64[i3 + (i5 << 3) >> 3] = d13 + d14 * +Math_fround(HEAPF32[i4 + (i5 << 2) >> 2]);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i9 << 3) | 0;
   i4 = i4 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function _inflateReset2(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 if (!i8) {
  i1 = -2;
  STACKTOP = i9;
  return i1 | 0;
 }
 i6 = i8 + 28 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if (!i7) {
  i1 = -2;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((i2 | 0) < 0) {
  i5 = 0 - i2 | 0;
  i4 = 0;
 } else {
  i5 = (i2 | 0) < 48 ? i2 & 15 : i2;
  i4 = (i2 >> 4) + 1 | 0;
 }
 if (!((i5 | 0) == 0 | (i5 & -8 | 0) == 8)) {
  i1 = -2;
  STACKTOP = i9;
  return i1 | 0;
 }
 i1 = i7 + 52 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = i7 + 36 | 0;
 if ((i3 | 0) != 0 ? (HEAP32[i2 >> 2] | 0) != (i5 | 0) : 0) {
  FUNCTION_TABLE_vii[HEAP32[i8 + 36 >> 2] & 127](HEAP32[i8 + 40 >> 2] | 0, i3);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i7 + 8 >> 2] = i4;
 HEAP32[i2 >> 2] = i5;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i1 = -2;
  STACKTOP = i9;
  return i1 | 0;
 }
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2) HEAP32[i8 + 48 >> 2] = i2 & 1;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 32768;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 i2 = i1 + 1328 | 0;
 HEAP32[i1 + 108 >> 2] = i2;
 HEAP32[i1 + 80 >> 2] = i2;
 HEAP32[i1 + 76 >> 2] = i2;
 HEAP32[i1 + 7104 >> 2] = 1;
 HEAP32[i1 + 7108 >> 2] = -1;
 i1 = 0;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN2cvL14cvtScale64f32fEPKdjPKhjPfjNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, d13 = 0.0, d14 = 0.0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 d14 = +HEAPF64[i4 >> 3];
 d13 = +HEAPF64[i4 + 8 >> 3];
 i11 = i5 >>> 3;
 i9 = i6 >>> 2;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i1 = i15 + -4 | 0;
 i7 = (i1 | 0) < 0;
 i8 = (i1 | 0) > 3 ? i15 & -4 : 4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i7) i5 = 0; else {
   i5 = 0;
   do {
    f17 = Math_fround(d13 + d14 * +HEAPF64[i4 + (i5 << 3) >> 3]);
    i2 = i5 | 1;
    f18 = Math_fround(d13 + d14 * +HEAPF64[i4 + (i2 << 3) >> 3]);
    HEAPF32[i3 + (i5 << 2) >> 2] = f17;
    HEAPF32[i3 + (i2 << 2) >> 2] = f18;
    i2 = i5 | 2;
    f18 = Math_fround(d13 + d14 * +HEAPF64[i4 + (i2 << 3) >> 3]);
    i10 = i5 | 3;
    f17 = Math_fround(d13 + d14 * +HEAPF64[i4 + (i10 << 3) >> 3]);
    HEAPF32[i3 + (i2 << 2) >> 2] = f18;
    HEAPF32[i3 + (i10 << 2) >> 2] = f17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i1 | 0));
   i5 = i8;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAPF32[i3 + (i5 << 2) >> 2] = Math_fround(d13 + d14 * +HEAPF64[i4 + (i5 << 3) >> 3]);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i9 << 2) | 0;
   i4 = i4 + (i11 << 3) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1, i12, i11, i10, i13, i14) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i15 = 0;
 i15 = STACKTOP;
 if ((i1 | 0) == (HEAP32[i12 + 8 >> 2] | 0)) {
  __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i(0, i12, i11, i10, i13);
  STACKTOP = i15;
  return;
 }
 i6 = i12 + 52 | 0;
 i7 = HEAP8[i6 >> 0] | 0;
 i8 = i12 + 53 | 0;
 i9 = HEAP8[i8 >> 0] | 0;
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 i2 = i1 + (i5 << 3) + 16 | 0;
 HEAP8[i6 >> 0] = 0;
 HEAP8[i8 >> 0] = 0;
 __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1 + 16 | 0, i12, i11, i10, i13, i14);
 L5 : do if ((i5 | 0) > 1) {
  i3 = i12 + 24 | 0;
  i4 = i1 + 8 | 0;
  i5 = i12 + 54 | 0;
  i1 = i1 + 24 | 0;
  do {
   if (HEAP8[i5 >> 0] | 0) break L5;
   if (!(HEAP8[i6 >> 0] | 0)) {
    if ((HEAP8[i8 >> 0] | 0) != 0 ? (HEAP32[i4 >> 2] & 1 | 0) == 0 : 0) break L5;
   } else {
    if ((HEAP32[i3 >> 2] | 0) == 1) break L5;
    if (!(HEAP32[i4 >> 2] & 2)) break L5;
   }
   HEAP8[i6 >> 0] = 0;
   HEAP8[i8 >> 0] = 0;
   __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1, i12, i11, i10, i13, i14);
   i1 = i1 + 8 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 } while (0);
 HEAP8[i6 >> 0] = i7;
 HEAP8[i8 >> 0] = i9;
 STACKTOP = i15;
 return;
}

function __ZL20icvDestroyMemStorageP12CvMemStorage(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i12;
 if (!i11) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40864, 39608, 140);
  __ZN2cv6String10deallocateEv(i1);
 }
 i9 = i11 + 12 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i2) i4 = 0; else i4 = HEAP32[i2 + 8 >> 2] | 0;
 i10 = i11 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (!i3) {
  i9 = i11 + 20 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = i11 + 8 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  STACKTOP = i12;
  return;
 }
 i8 = i11 + 16 | 0;
 i1 = i11 + 20 | 0;
 L11 : while (1) {
  i7 = i3;
  while (1) {
   i6 = i7 + 4 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if (i2) break;
   _cvFree_(i7);
   if (!i3) {
    i2 = 18;
    break L11;
   }
   i2 = HEAP32[i9 >> 2] | 0;
   i7 = i3;
  }
  if (!i4) {
   HEAP32[i2 + 8 >> 2] = i7;
   HEAP32[i2 + 4 >> 2] = i7;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i1 >> 2] = (HEAP32[i8 >> 2] | 0) + -8;
  } else {
   HEAP32[i7 >> 2] = i4;
   i4 = i4 + 4 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 >> 2] = i5;
   if (i5) HEAP32[i5 >> 2] = i7;
   HEAP32[i4 >> 2] = i7;
  }
  if (!i3) {
   i2 = 18;
   break;
  } else i4 = i7;
 }
 if ((i2 | 0) == 18) {
  HEAP32[i10 >> 2] = 0;
  i10 = i11 + 8 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i12;
  return;
 }
}

function __ZN7testing8internal25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE14AddTestPatternEPKcS5_PNS0_19TestMetaFactoryBaseINSt3tr15tupleIN2cv5Size_IiEEN4perf7MatTypeEvvvvvvvvEEEE(i8, i3, i2, i1) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i10;
 i4 = __Znwj(28) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i3, _strlen(i3 | 0) | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4 + 12 | 0, i2, _strlen(i2 | 0) | 0);
 HEAP32[i4 + 24 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 i5 = i9 + 4 | 0;
 HEAP32[i5 >> 2] = i5;
 i6 = i8 + 20 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if ((i7 | 0) == (HEAP32[i8 + 24 >> 2] | 0)) {
  __ZNSt3__16vectorIN7testing8internal10linked_ptrINS2_25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE8TestInfoEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i8 + 16 | 0, i9);
  __ZN7testing8internal10linked_ptrINS0_25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE8TestInfoEED2Ev(i9);
  STACKTOP = i10;
  return;
 }
 if (i7) {
  HEAP32[i7 >> 2] = i4;
  i3 = i7 + 4 | 0;
  i2 = i5;
  i1 = i5;
  while (1) {
   if ((i2 | 0) == (i5 | 0)) break;
   i1 = i2;
   i2 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i1 >> 2] = i3;
  HEAP32[i3 >> 2] = i5;
 }
 HEAP32[i6 >> 2] = i7 + 8;
 __ZN7testing8internal10linked_ptrINS0_25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE8TestInfoEED2Ev(i9);
 STACKTOP = i10;
 return;
}

function __ZNSt3__16vectorIiNS_9allocatorIiEEE8__appendEj(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 i7 = i8 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = i3;
 if (i4 - i1 >> 2 >>> 0 >= i10 >>> 0) {
  i1 = i10;
  i2 = i3;
  while (1) {
   if (i2) HEAP32[i2 >> 2] = 0;
   i1 = i1 + -1 | 0;
   if (!i1) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i9 >> 2] = i3 + (i10 << 2);
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = (i1 - i2 >> 2) + i10 | 0;
 if (i1 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i8);
 i3 = i2;
 i2 = i4 - i3 | 0;
 if (i2 >> 2 >>> 0 < 536870911) {
  i2 = i2 >> 1;
  i2 = i2 >>> 0 < i1 >>> 0 ? i1 : i2;
  i1 = (HEAP32[i9 >> 2] | 0) - i3 >> 2;
  if (!i2) {
   i5 = 0;
   i3 = 0;
   i4 = i1;
  } else i6 = 11;
 } else {
  i2 = 1073741823;
  i1 = (HEAP32[i9 >> 2] | 0) - i3 >> 2;
  i6 = 11;
 }
 if ((i6 | 0) == 11) {
  i5 = i2;
  i3 = __Znwj(i2 << 2) | 0;
  i4 = i1;
 }
 i2 = i10;
 i1 = i3 + (i4 << 2) | 0;
 while (1) {
  if (i1) HEAP32[i1 >> 2] = 0;
  i2 = i2 + -1 | 0;
  if (!i2) break; else i1 = i1 + 4 | 0;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i6 = i3 + (i4 - (i1 >> 2) << 2) | 0;
 _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
 HEAP32[i8 >> 2] = i6;
 HEAP32[i9 >> 2] = i3 + (i4 + i10 << 2);
 HEAP32[i7 >> 2] = i3 + (i5 << 2);
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i11;
 return;
}

function __ZNSt3__116__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i4, i8, i6, i9) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 i1 = HEAP8[i4 >> 0] | 0;
 if (!(i1 & 1)) i3 = (i1 & 255) >>> 1; else i3 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i3) {
  STACKTOP = i10;
  return;
 }
 if ((i8 | 0) != (i6 | 0) ? (i2 = i6 + -4 | 0, i2 >>> 0 > i8 >>> 0) : 0) {
  i1 = i8;
  do {
   i3 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i3;
   i1 = i1 + 4 | 0;
   i2 = i2 + -4 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  i2 = HEAP8[i4 >> 0] | 0;
 } else i2 = i1;
 if (!(i2 & 1)) {
  i5 = i4 + 1 | 0;
  i3 = (i2 & 255) >>> 1;
 } else {
  i5 = HEAP32[i4 + 8 >> 2] | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
 }
 i7 = i6 + -4 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 1 | i2 << 24 >> 24 == 127;
 L18 : do if (i7 >>> 0 > i8 >>> 0) {
  i6 = i5 + i3 | 0;
  i4 = i5;
  i3 = i8;
  while (1) {
   if (!i1 ? (i2 << 24 >> 24 | 0) != (HEAP32[i3 >> 2] | 0) : 0) break;
   i4 = (i6 - i4 | 0) > 1 ? i4 + 1 | 0 : i4;
   i3 = i3 + 4 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i1 = i2 << 24 >> 24 < 1 | i2 << 24 >> 24 == 127;
   if (i3 >>> 0 >= i7 >>> 0) break L18;
  }
  HEAP32[i9 >> 2] = 4;
  STACKTOP = i10;
  return;
 } while (0);
 if (i1) {
  STACKTOP = i10;
  return;
 }
 if (((HEAP32[i7 >> 2] | 0) + -1 | 0) >>> 0 < i2 << 24 >> 24 >>> 0) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i9 >> 2] = 4;
 STACKTOP = i10;
 return;
}

function _cvCvtSeqToArray(i9, i1, i3) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i7 = i11 + 8 | 0;
 i2 = i11;
 if (!((i9 | 0) != 0 & (i1 | 0) != 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i2, 40120, 39608, 550);
  __ZN2cv6String10deallocateEv(i2);
 }
 i10 = HEAP32[i9 + 28 >> 2] | 0;
 i2 = i3;
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i9 + 24 >> 2] | 0;
 i3 = i2 - i5 | 0;
 if ((i2 | 0) != (i5 | 0)) i3 = i3 + ((i5 | 0) < 0 ? 0 - i4 | 0 : 0) + ((i2 | 0) < 1 ? i4 : 0) | 0;
 while (1) if ((i3 | 0) < 0) i3 = i3 + i4 | 0; else break;
 i4 = Math_imul((i3 | 0) > (i4 | 0) ? i4 : i3, i10) | 0;
 if (!i4) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 _cvStartReadSeq(i9, i7, 0);
 _cvSetSeqReaderPos(i7, i5, 0);
 i8 = i7 + 20 | 0;
 i9 = i7 + 12 | 0;
 i3 = i7 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i7 = i1;
 i5 = i4;
 while (1) {
  i4 = i2 - i6 | 0;
  i4 = (i4 | 0) > (i5 | 0) ? i5 : i4;
  _memcpy(i7 | 0, i6 | 0, i4 | 0) | 0;
  i12 = HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = i12;
  i6 = HEAP32[i12 + 16 >> 2] | 0;
  HEAP32[i9 >> 2] = i6;
  i2 = i6 + (Math_imul(HEAP32[i12 + 12 >> 2] | 0, i10) | 0) | 0;
  HEAP32[i8 >> 2] = i2;
  i5 = i5 - i4 | 0;
  if ((i5 | 0) <= 0) break; else i7 = i7 + i4 | 0;
 }
 STACKTOP = i11;
 return i1 | 0;
}

function __ZNK2cv4UMat9convertToERKNS_12_OutputArrayEidd(i7, i4, i3, d5, d6) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 d5 = +d5;
 d6 = +d6;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i8 = i9;
 if (+Math_abs(+(d5 + -1.0)) < 2.220446049250313e-16) i2 = !(+Math_abs(+d6) < 2.220446049250313e-16); else i2 = 1;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i3 | 0) < 0) if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 108 >> 2] & 127](i4) | 0) i3 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] & 127](i4, -1) | 0; else i3 = i1 & 4095; else i3 = i1 & 4088 | i3 & 7;
 if (!(((i3 ^ i1) & 7 | 0) != 0 | i2)) {
  __ZNK2cv4UMat6copyToERKNS_12_OutputArrayE(i7, i4);
  STACKTOP = i9;
  return;
 }
 __ZNK2cv4UMat6getMatEi(i8, i7, 16777216);
 __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i8, i4, i3, d5, d6);
 i1 = i8 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i3 = i2 + 12 | 0, i2 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i2 + -1, (i2 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i8);
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 16 | 0;
 i2 = i8 + 4 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i8 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 if ((i1 | 0) == (i8 + 48 | 0)) {
  STACKTOP = i9;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i9;
 return;
}

function __ZN12_GLOBAL__N_118CLAHE_CalcLut_BodyItLi4096ELi4EED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 182608;
 i1 = i4 + 60 | 0;
 i2 = i4 + 96 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i1);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 76 | 0;
 i3 = i4 + 64 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 100 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 104 >> 2] | 0;
 if ((i1 | 0) != (i4 + 108 | 0)) __ZN2cv8fastFreeEPv(i1);
 i3 = i4 + 4 | 0;
 i2 = i4 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i1 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 20 | 0;
 i3 = i4 + 8 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 44 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 if ((i1 | 0) == (i4 + 52 | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i5;
 return;
}

function __ZN12_GLOBAL__N_118CLAHE_CalcLut_BodyIhLi256ELi0EED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 182848;
 i1 = i4 + 60 | 0;
 i2 = i4 + 96 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i1);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 76 | 0;
 i3 = i4 + 64 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 100 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 104 >> 2] | 0;
 if ((i1 | 0) != (i4 + 108 | 0)) __ZN2cv8fastFreeEPv(i1);
 i3 = i4 + 4 | 0;
 i2 = i4 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i1 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 20 | 0;
 i3 = i4 + 8 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 44 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 if ((i1 | 0) == (i4 + 52 | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i5;
 return;
}

function __ZN2cv5mergeERKNS_11_InputArrayERKNS_12_OutputArrayE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 i6 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 127](i1, i7);
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 __ZN2cv5mergeEPKNS_3MatEjRKNS_12_OutputArrayE((i1 | 0) == (i3 | 0) ? 0 : i1, (i3 - i1 | 0) / 56 | 0, i2);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -56 | 0;
   HEAP32[i6 >> 2] = i3;
   i4 = i2 + -20 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != 0 ? (i9 = i5 + 12 | 0, i5 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i5 + -1, (i5 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
   HEAP32[i4 >> 2] = 0;
   i3 = i2 + -40 | 0;
   i5 = i2 + -52 | 0;
   HEAP32[i3 + 0 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   if ((HEAP32[i5 >> 2] | 0) > 0) {
    i4 = HEAP32[i2 + -16 >> 2] | 0;
    i3 = 0;
    do {
     HEAP32[i4 + (i3 << 2) >> 2] = 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (HEAP32[i5 >> 2] | 0));
   }
   i3 = HEAP32[i2 + -12 >> 2] | 0;
   if ((i3 | 0) != (i2 + -8 | 0)) __ZN2cv8fastFreeEPv(i3);
   i2 = HEAP32[i6 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZN2cvL11cvtScale32sEPKijPKhjPijNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, d13 = 0.0, d14 = 0.0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 d14 = +HEAPF64[i4 >> 3];
 d13 = +HEAPF64[i4 + 8 >> 3];
 i11 = i5 >>> 2;
 i9 = i6 >>> 2;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i1 = i15 + -4 | 0;
 i7 = (i1 | 0) < 0;
 i8 = i15 & -4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i7) i5 = 0; else {
   i5 = 0;
   do {
    i10 = _lrint(d13 + d14 * +(HEAP32[i4 + (i5 << 2) >> 2] | 0)) | 0;
    i12 = i5 | 1;
    i17 = _lrint(d13 + d14 * +(HEAP32[i4 + (i12 << 2) >> 2] | 0)) | 0;
    HEAP32[i3 + (i5 << 2) >> 2] = i10;
    HEAP32[i3 + (i12 << 2) >> 2] = i17;
    i12 = i5 | 2;
    i17 = _lrint(d13 + d14 * +(HEAP32[i4 + (i12 << 2) >> 2] | 0)) | 0;
    i10 = i5 | 3;
    i2 = _lrint(d13 + d14 * +(HEAP32[i4 + (i10 << 2) >> 2] | 0)) | 0;
    HEAP32[i3 + (i12 << 2) >> 2] = i17;
    HEAP32[i3 + (i10 << 2) >> 2] = i2;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i1 | 0));
   i5 = i8;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAP32[i3 + (i5 << 2) >> 2] = _lrint(d13 + d14 * +(HEAP32[i4 + (i5 << 2) >> 2] | 0)) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i9 << 2) | 0;
   i4 = i4 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function _cvSetSeqBlockSize(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i6 + 16 | 0;
 i3 = i6 + 8 | 0;
 i4 = i6;
 if (!((i5 | 0) != 0 ? (HEAP32[i5 + 44 >> 2] | 0) != 0 : 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i2, 4e4, 39608, 414);
  __ZN2cv6String10deallocateEv(i2);
 }
 if ((i1 | 0) < 0) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i3, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i3, 4e4, 39608, 416);
  __ZN2cv6String10deallocateEv(i3);
 }
 i3 = (HEAP32[(HEAP32[i5 + 44 >> 2] | 0) + 16 >> 2] | 0) + -28 & -8;
 i2 = HEAP32[i5 + 28 >> 2] | 0;
 if (!i1) {
  i1 = 1024 / (i2 | 0) | 0;
  i1 = (i1 | 0) < 1 ? 1 : i1;
 }
 if ((Math_imul(i1, i2) | 0) <= (i3 | 0)) {
  i2 = i1;
  i1 = i5 + 40 | 0;
  HEAP32[i1 >> 2] = i2;
  STACKTOP = i6;
  return;
 }
 i1 = (i3 | 0) / (i2 | 0) | 0;
 if (i1) {
  i2 = i1;
  i1 = i5 + 40 | 0;
  HEAP32[i1 >> 2] = i2;
  STACKTOP = i6;
  return;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i3 = (__ZN2cv6String8allocateEj(i4, 60) | 0) + 0 | 0;
 i2 = 40024 | 0;
 i1 = i3 + 60 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i3 | 0) < (i1 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i4, 4e4, 39608, 432);
 __ZN2cv6String10deallocateEv(i4);
 i2 = 0;
 i1 = i5 + 40 | 0;
 HEAP32[i1 >> 2] = i2;
 STACKTOP = i6;
 return;
}

function __ZNK7testing8internal12AssertHelperaSERKNS_7MessageE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i7 + 12 | 0;
 i5 = i7;
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i2 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i2, 163728);
  HEAP32[40934] = i2;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i8 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 __ZN7testing8internal17AppendUserMessageERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKNS_7MessageE(i4, i8 + 12 | 0, i6);
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i6 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i6, 163728);
  HEAP32[40934] = i6;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 __ZN7testing8internal12UnitTestImpl28CurrentOsStackTraceExceptTopEi(i5, 0, 0);
 __ZN7testing8UnitTest17AddTestPartResultENS_14TestPartResult4TypeEPKciRKNSt3__112basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEESD_(163728, i3, i1, i2, i4, i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 STACKTOP = i7;
 return;
}

function __ZL22icvYMLStartWriteStructP13CvFileStoragePKciS2_(i12, i13, i5, i10) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 5152 | 0;
 i11 = i15;
 i14 = i15 + 16 | 0;
 i1 = i15 + 24 | 0;
 i3 = i15 + 8 | 0;
 i9 = i5 & 15;
 i2 = i9 | 32;
 i4 = i5 & 7;
 if (i4 >>> 0 <= 4) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i6 = (__ZN2cv6String8allocateEj(i3, 68) | 0) + 0 | 0;
  i7 = 16968 | 0;
  i8 = i6 + 68 | 0;
  do {
   HEAP8[i6 >> 0] = HEAP8[i7 >> 0] | 0;
   i6 = i6 + 1 | 0;
   i7 = i7 + 1 | 0;
  } while ((i6 | 0) < (i8 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i3, 17040, 8960, 1522);
  __ZN2cv6String10deallocateEv(i3);
 }
 do if (!(i5 & 8)) if (!i10) i1 = 0; else {
  HEAP32[i11 >> 2] = i10;
  _sprintf(i1, 17072, i11) | 0;
 } else {
  i3 = (i4 | 0) == 6 ? 123 : 91;
  i2 = i9 | 40;
  if (!i10) {
   HEAP8[i1 >> 0] = i3;
   HEAP8[i1 + 1 >> 0] = 0;
   break;
  } else {
   HEAP32[i11 >> 2] = i10;
   HEAP32[i11 + 4 >> 2] = i3 & 255;
   _sprintf(i1, 17064, i11) | 0;
   break;
  }
 } while (0);
 __ZL11icvYMLWriteP13CvFileStoragePKcS2_(i12, i13, i1);
 i10 = i12 + 44 | 0;
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 _cvSeqPush(HEAP32[i12 + 36 >> 2] | 0, i14) | 0;
 HEAP32[i10 >> 2] = i2;
 if (HEAP32[i14 >> 2] & 8) {
  STACKTOP = i15;
  return;
 }
 i10 = i12 + 40 | 0;
 HEAP32[i10 >> 2] = (i2 >>> 3 & 1) + 3 + (HEAP32[i10 >> 2] | 0);
 STACKTOP = i15;
 return;
}

function __ZNSt3__17getlineIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_13basic_istreamIT_T0_EES9_RNS_12basic_stringIS6_S7_T1_EES6_(i8, i7, i6) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i9;
 __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6sentryC1ERS3_b(i1, i8, 1);
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!(HEAP8[i7 >> 0] & 1)) {
  HEAP8[i7 + 1 >> 0] = 0;
  HEAP8[i7 >> 0] = 0;
  i5 = i7 + 4 | 0;
 } else {
  HEAP8[HEAP32[i7 + 8 >> 2] >> 0] = 0;
  i5 = i7 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
 }
 i1 = 0;
 while (1) {
  i2 = HEAP32[i8 + ((HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
  i3 = i2 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
   i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2) | 0;
   if ((i2 | 0) == -1) {
    i2 = 2;
    break;
   }
  } else {
   HEAP32[i3 >> 2] = i4 + 1;
   i2 = HEAPU8[i4 >> 0] | 0;
  }
  i1 = i1 + 1 | 0;
  i2 = i2 & 255;
  if (i2 << 24 >> 24 == i6 << 24 >> 24) {
   i2 = 0;
   break;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, i2);
  if (!(HEAP8[i7 >> 0] & 1)) continue;
  if ((HEAP32[i5 >> 2] | 0) == -17) {
   i2 = 4;
   break;
  }
 }
 i3 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i8 + i3 | 0, HEAP32[i8 + (i3 + 16) >> 2] | ((i1 | 0) == 0 ? i2 | 4 : i2));
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN7testing8UnitTest14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i6 = i7 + 24 | 0;
 i5 = i7;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i5, i2);
 i2 = i5 + 12 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i2, i3);
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = i4 + 108 | 0;
 do if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = i4 + 104 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6, 163616) | 0;
   i1 = i4 + 112 | 0;
   break;
  } else {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6, 163536) | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + 64 | 0;
   break;
  }
 } else {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6, 163312) | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + 48 | 0;
 } while (0);
 __ZN7testing10TestResult14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKNS_12TestPropertyE(i1, i6, i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 STACKTOP = i7;
 return;
}

function __Z16RGBE_WritePixelsP8_IO_FILEPfi(i10, i2, i3) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, f4 = Math_fround(0), d5 = 0.0, f6 = Math_fround(0), f7 = Math_fround(0), i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = Math_fround(0);
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i13 = i14 + 8 | 0;
 i11 = i14;
 i1 = i11 + 1 | 0;
 i8 = i11 + 2 | 0;
 i9 = i11 + 3 | 0;
 while (1) {
  if ((i3 | 0) <= 0) {
   i1 = 0;
   i12 = 8;
   break;
  }
  f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i2 >> 2]);
  f15 = f7 > f6 ? f7 : f6;
  d5 = +(f15 < f4 ? f4 : f15);
  if (d5 < 1.0e-32) HEAP32[i11 >> 2] = 0; else {
   f15 = Math_fround(+_frexp(d5, i13) * 256.0 / d5);
   HEAP8[i11 >> 0] = ~~Math_fround(f6 * f15);
   HEAP8[i1 >> 0] = ~~Math_fround(f7 * f15);
   HEAP8[i8 >> 0] = ~~Math_fround(f4 * f15);
   HEAP8[i9 >> 0] = (HEAP32[i13 >> 2] | 0) + 128;
  }
  if (!(_fwrite(i11 | 0, 4, 1, i10 | 0) | 0)) break; else {
   i3 = i3 + -1 | 0;
   i2 = i2 + 12 | 0;
  }
 }
 if ((i12 | 0) == 8) {
  STACKTOP = i14;
  return i1 | 0;
 }
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i1 = (__ZN2cv6String8allocateEj(i13, 16) | 0) + 0 | 0;
 i2 = 181784 | 0;
 i3 = i1 + 16 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i13, 181704, 181720, 93);
 __ZN2cv6String10deallocateEv(i13);
 i1 = -1;
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN12_GLOBAL__N_110CLAHE_ImplD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 181864;
 i1 = i4 + 80 | 0;
 i2 = i4 + 116 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i1);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 96 | 0;
 i3 = i4 + 84 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 120 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 124 >> 2] | 0;
 if ((i1 | 0) != (i4 + 128 | 0)) __ZN2cv8fastFreeEPv(i1);
 i3 = i4 + 24 | 0;
 i2 = i4 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i6 = i1 + 12 | 0, i1 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 40 | 0;
 i3 = i4 + 28 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 64 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 68 >> 2] | 0;
 if ((i1 | 0) == (i4 + 72 | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i5;
 return;
}

function _updatewindow(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 i5 = HEAP32[i1 + 28 >> 2] | 0;
 i6 = i5 + 52 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i2 = FUNCTION_TABLE_iiii[HEAP32[i1 + 32 >> 2] & 63](HEAP32[i1 + 40 >> 2] | 0, 1 << HEAP32[i5 + 36 >> 2], 1) | 0;
  HEAP32[i6 >> 2] = i2;
  if (!i2) {
   i1 = 1;
   STACKTOP = i9;
   return i1 | 0;
  }
 }
 i4 = i5 + 40 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = 1 << HEAP32[i5 + 36 >> 2];
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 + 48 >> 2] = 0;
  HEAP32[i5 + 44 >> 2] = 0;
 }
 if (i1 >>> 0 <= i8 >>> 0) {
  _memcpy(i2 | 0, i7 + (0 - i1) | 0, i1 | 0) | 0;
  HEAP32[i5 + 48 >> 2] = 0;
  HEAP32[i5 + 44 >> 2] = HEAP32[i4 >> 2];
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 i3 = i5 + 48 | 0;
 i10 = HEAP32[i3 >> 2] | 0;
 i1 = i1 - i10 | 0;
 i1 = i1 >>> 0 > i8 >>> 0 ? i8 : i1;
 _memcpy(i2 + i10 | 0, i7 + (0 - i8) | 0, i1 | 0) | 0;
 i2 = i8 - i1 | 0;
 if ((i1 | 0) != (i8 | 0)) {
  _memcpy(HEAP32[i6 >> 2] | 0, i7 + (0 - i2) | 0, i2 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 + 44 >> 2] = HEAP32[i4 >> 2];
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 i1 = (HEAP32[i3 >> 2] | 0) + i8 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 HEAP32[i3 >> 2] = (i1 | 0) == (i4 | 0) ? 0 : i1;
 i1 = i5 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 >= i4 >>> 0) {
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = i2 + i8;
 i1 = 0;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy(i6, i7, i5, i4, i3, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 i9 = i7 + 8 | 0;
 i15 = i7;
 i14 = i7 + 204 | 0;
 i8 = i7 + 32 | 0;
 i12 = i7 + 28 | 0;
 i11 = i7 + 24 | 0;
 i13 = i7 + 20 | 0;
 i10 = i7 + 16 | 0;
 i16 = i15;
 HEAP32[i16 >> 2] = 37;
 HEAP32[i16 + 4 >> 2] = 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i15 + 1 | 0, 959432, 0, HEAP32[i4 + 4 >> 2] | 0);
 i16 = __ZNSt3__16__clocEv() | 0;
 i17 = i9;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i17 + 4 >> 2] = i2;
 i2 = i14 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i14, 23, i16, i15, i9) | 0) | 0;
 i1 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i14, i2, i4) | 0;
 __ZNKSt3__18ios_base6getlocEv(i13, i4);
 __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE(i14, i1, i2, i8, i12, i11, i13);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i13 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i9, i8, i2, i1, i4, i3);
 STACKTOP = i7;
 return;
}

function __ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx(i6, i7, i5, i4, i3, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i9 = i7 + 8 | 0;
 i15 = i7;
 i14 = i7 + 196 | 0;
 i8 = i7 + 32 | 0;
 i12 = i7 + 28 | 0;
 i11 = i7 + 24 | 0;
 i13 = i7 + 20 | 0;
 i10 = i7 + 16 | 0;
 i16 = i15;
 HEAP32[i16 >> 2] = 37;
 HEAP32[i16 + 4 >> 2] = 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i15 + 1 | 0, 959432, 1, HEAP32[i4 + 4 >> 2] | 0);
 i16 = __ZNSt3__16__clocEv() | 0;
 i17 = i9;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i17 + 4 >> 2] = i2;
 i2 = i14 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i14, 22, i16, i15, i9) | 0) | 0;
 i1 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i14, i2, i4) | 0;
 __ZNKSt3__18ios_base6getlocEv(i13, i4);
 __ZNSt3__19__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE(i14, i1, i2, i8, i12, i11, i13);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i13 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i9, i8, i2, i1, i4, i3);
 STACKTOP = i7;
 return;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy(i6, i7, i5, i4, i3, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i9 = i7 + 8 | 0;
 i15 = i7;
 i14 = i7 + 75 | 0;
 i8 = i7 + 32 | 0;
 i12 = i7 + 28 | 0;
 i11 = i7 + 24 | 0;
 i13 = i7 + 20 | 0;
 i10 = i7 + 16 | 0;
 i16 = i15;
 HEAP32[i16 >> 2] = 37;
 HEAP32[i16 + 4 >> 2] = 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i15 + 1 | 0, 959432, 0, HEAP32[i4 + 4 >> 2] | 0);
 i16 = __ZNSt3__16__clocEv() | 0;
 i17 = i9;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i17 + 4 >> 2] = i2;
 i2 = i14 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i14, 23, i16, i15, i9) | 0) | 0;
 i1 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i14, i2, i4) | 0;
 __ZNKSt3__18ios_base6getlocEv(i13, i4);
 __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE(i14, i1, i2, i8, i12, i11, i13);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i13 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i9, i8, i2, i1, i4, i3);
 STACKTOP = i7;
 return;
}

function __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i7 + 12 | 0;
 i6 = i7;
 HEAP32[i1 >> 2] = i2;
 if (i2) if ((i2 | 0) == 1) i1 = 164720; else i1 = (i2 | 0) == 2 ? 164736 : 164752; else i1 = 164704;
 __ZNKSt3__18ios_base6getlocEv(i3, 956240 + (HEAP32[(HEAP32[239060] | 0) + -12 >> 2] | 0) | 0);
 i2 = __ZNKSt3__16locale9use_facetERNS0_2idE(i3, 960728) | 0;
 i2 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] & 127](i2, 10) | 0;
 __ZNSt3__16localeD2Ev(i3);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(956240, i2) | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(956240) | 0;
 i2 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, i1, 9) | 0, 163296, 1) | 0;
 __ZN7testing8internal18FormatFileLocationEPKci(i6, i4, i5);
 if (!(HEAP8[i6 >> 0] & 1)) i1 = i6 + 1 | 0; else i1 = HEAP32[i6 + 8 >> 2] | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i1, _strlen(i1 | 0) | 0) | 0, 164768, 2) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 STACKTOP = i7;
 return;
}

function __ZL7icvGetsP13CvFileStoragePci(i2, i9, i4) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i10;
 i7 = HEAP32[i2 + 256 >> 2] | 0;
 if (i7) {
  i8 = i2 + 264 | 0;
  i6 = HEAP32[i2 + 260 >> 2] | 0;
  i5 = i4 + -1 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = 0;
  while (1) {
   if (!(i2 >>> 0 < i6 >>> 0 & (i4 | 0) < (i5 | 0))) {
    i3 = i2;
    i1 = i4;
    break;
   }
   i3 = i2 + 1 | 0;
   i2 = HEAP8[i7 + i2 >> 0] | 0;
   if (!(i2 << 24 >> 24)) {
    i1 = i4;
    break;
   }
   i1 = i4 + 1 | 0;
   HEAP8[i9 + i4 >> 0] = i2;
   if (i2 << 24 >> 24 == 10) break; else {
    i2 = i3;
    i4 = i1;
   }
  }
  HEAP8[i9 + i1 >> 0] = 0;
  HEAP32[i8 >> 2] = i3;
  i1 = (i1 | 0) > 0 ? i9 : 0;
  STACKTOP = i10;
  return i1 | 0;
 }
 i3 = HEAP32[i2 + 64 >> 2] | 0;
 if (i3) {
  i1 = _fgets(i9 | 0, i4 | 0, i3 | 0) | 0;
  STACKTOP = i10;
  return i1 | 0;
 }
 i1 = HEAP32[i2 + 68 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i5, 25) | 0) + 0 | 0;
  i2 = 17392 | 0;
  i3 = i1 + 25 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i5, 17424, 8960, 285);
  __ZN2cv6String10deallocateEv(i5);
  i1 = 0;
  STACKTOP = i10;
  return i1 | 0;
 } else {
  i1 = _gzgets(i1, i9, i4) | 0;
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function __ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx(i6, i7, i5, i4, i3, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 i9 = i7 + 8 | 0;
 i15 = i7;
 i14 = i7 + 74 | 0;
 i8 = i7 + 32 | 0;
 i12 = i7 + 28 | 0;
 i11 = i7 + 24 | 0;
 i13 = i7 + 20 | 0;
 i10 = i7 + 16 | 0;
 i16 = i15;
 HEAP32[i16 >> 2] = 37;
 HEAP32[i16 + 4 >> 2] = 0;
 __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i15 + 1 | 0, 959432, 1, HEAP32[i4 + 4 >> 2] | 0);
 i16 = __ZNSt3__16__clocEv() | 0;
 i17 = i9;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i17 + 4 >> 2] = i2;
 i2 = i14 + (__ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i14, 22, i16, i15, i9) | 0) | 0;
 i1 = __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i14, i2, i4) | 0;
 __ZNKSt3__18ios_base6getlocEv(i13, i4);
 __ZNSt3__19__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE(i14, i1, i2, i8, i12, i11, i13);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i13 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNSt3__116__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i9, i8, i2, i1, i4, i3);
 STACKTOP = i7;
 return;
}

function __ZN2cvL14cvtScale64f32sEPKdjPKhjPijNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, d13 = 0.0, d14 = 0.0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 d14 = +HEAPF64[i4 >> 3];
 d13 = +HEAPF64[i4 + 8 >> 3];
 i11 = i5 >>> 3;
 i9 = i6 >>> 2;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i1 = i15 + -4 | 0;
 i7 = (i1 | 0) < 0;
 i8 = i15 & -4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i7) i5 = 0; else {
   i5 = 0;
   do {
    i10 = _lrint(d13 + d14 * +HEAPF64[i4 + (i5 << 3) >> 3]) | 0;
    i12 = i5 | 1;
    i17 = _lrint(d13 + d14 * +HEAPF64[i4 + (i12 << 3) >> 3]) | 0;
    HEAP32[i3 + (i5 << 2) >> 2] = i10;
    HEAP32[i3 + (i12 << 2) >> 2] = i17;
    i12 = i5 | 2;
    i17 = _lrint(d13 + d14 * +HEAPF64[i4 + (i12 << 3) >> 3]) | 0;
    i10 = i5 | 3;
    i2 = _lrint(d13 + d14 * +HEAPF64[i4 + (i10 << 3) >> 3]) | 0;
    HEAP32[i3 + (i12 << 2) >> 2] = i17;
    HEAP32[i3 + (i10 << 2) >> 2] = i2;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i1 | 0));
   i5 = i8;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAP32[i3 + (i5 << 2) >> 2] = _lrint(d13 + d14 * +HEAPF64[i4 + (i5 << 3) >> 3]) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i9 << 2) | 0;
   i4 = i4 + (i11 << 3) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i2, i5, i1, i3, i10) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i9 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 i7 = i4 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 if (i1) {
  i8 = _strlen(i1 | 0) | 0;
  _memcpy(__ZN2cv6String8allocateEj(i4, i8) | 0, i1 | 0, i8 | 0) | 0;
 }
 HEAP32[i6 >> 2] = 0;
 i8 = i6 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 if (i3) {
  i1 = _strlen(i3 | 0) | 0;
  _memcpy(__ZN2cv6String8allocateEj(i6, i1) | 0, i3 | 0, i1 | 0) | 0;
 }
 HEAP32[i9 >> 2] = 18928;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = i2;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 + 16 >> 2] = i1;
 HEAP32[i9 + 20 >> 2] = HEAP32[i5 + 4 >> 2];
 if (i1) {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i9 + 24 >> 2] = i1;
 HEAP32[i9 + 28 >> 2] = HEAP32[i7 >> 2];
 if (i1) {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i9 + 32 >> 2] = i1;
 HEAP32[i9 + 36 >> 2] = HEAP32[i8 >> 2];
 if (!i1) {
  i2 = i9 + 40 | 0;
  HEAP32[i2 >> 2] = i10;
  __ZN2cv9Exception13formatMessageEv(i9);
  __ZN2cv5errorERKNS_9ExceptionE(i9);
 }
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i9 + 40 | 0;
 HEAP32[i1 >> 2] = i10;
 __ZN2cv9Exception13formatMessageEv(i9);
 __ZN2cv5errorERKNS_9ExceptionE(i9);
}

function __ZNSt3__17__sort4IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_T_(i8, i9, i6, i5, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 i7 = __ZNSt3__17__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i8, i9, i6, i1) | 0;
 i2 = i5;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!((i2 | 0) < (i4 | 0) | (i2 | 0) == (i4 | 0) & i3 >>> 0 < i1 >>> 0)) {
  i1 = i7;
  STACKTOP = i10;
  return i1 | 0;
 }
 i11 = i6;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i11 + 4 >> 2] = i2;
 i3 = i5;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i6;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i9;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!((i3 | 0) < (i1 | 0) | (i3 | 0) == (i1 | 0) & i4 >>> 0 < i2 >>> 0)) {
  i9 = i7 + 1 | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i5 = i9;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i5 + 4 >> 2] = i3;
 i4 = i6;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i1;
 i2 = i9;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i8;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!((i2 | 0) < (i4 | 0) | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0)) {
  i9 = i7 + 2 | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i9 + 4 >> 2] = i4;
 i9 = i7 + 3 | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN2cvL8cvt32s8uEPKijPKhjPhjNS_5Size_IiEEPd(i6, i5, i1, i2, i7, i15, i4, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = i5 >>> 2;
 if (!i4) {
  STACKTOP = i14;
  return;
 }
 i11 = i13 + -4 | 0;
 i12 = (i11 | 0) < 0;
 i9 = i13 & -4;
 i8 = i4;
 while (1) {
  i8 = i8 + -1 | 0;
  if (i12) i5 = 0; else {
   i1 = 0;
   do {
    i5 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i3 = i1 | 1;
    i4 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i1 >> 0] = i5;
    HEAP8[i7 + i3 >> 0] = i4;
    i2 = i1 | 2;
    i5 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
    if (i5 >>> 0 >= 256) i5 = (i5 | 0) > 0 ? 255 : 0;
    i3 = i1 | 3;
    i4 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
    if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
    HEAP8[i7 + i2 >> 0] = i5;
    HEAP8[i7 + i3 >> 0] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i11 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   i4 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
   if (i4 >>> 0 >= 256) i4 = (i4 | 0) > 0 ? 255 : 0;
   HEAP8[i7 + i5 >> 0] = i4;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i8) break; else {
   i6 = i6 + (i10 << 2) | 0;
   i7 = i7 + i15 | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function _cvCreateSeq(i4, i3, i7, i8) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i1 = i9 + 16 | 0;
 i2 = i9 + 8 | 0;
 i6 = i9;
 if (!i8) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 39872, 39608, 376);
  __ZN2cv6String10deallocateEv(i1);
 }
 if (i3 >>> 0 < 56 | (i7 | 0) == 0) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i2, 39872, 39608, 378);
  __ZN2cv6String10deallocateEv(i2);
 }
 i5 = _cvMemStorageAlloc(i8, i3) | 0;
 _memset(i5 | 0, 0, i3 | 0) | 0;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 >> 2] = i4 & 65535 | 1117323264;
 i1 = (i4 >>> 3 & 511) + 1 << (47696 >>> (i4 << 1 & 14) & 3);
 if (((i1 | 0) != 0 ? (i2 = i4 & 4095, !((i2 | 0) == 0 | (i2 | 0) == 7)) : 0) ? (i1 | 0) != (i7 | 0) : 0) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i6, 110) | 0) + 0 | 0;
  i1 = 39888 | 0;
  i3 = i2 + 110 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i6, 39872, 39608, 394);
  __ZN2cv6String10deallocateEv(i6);
 }
 HEAP32[i5 + 28 >> 2] = i7;
 HEAP32[i5 + 44 >> 2] = i8;
 _cvSetSeqBlockSize(i5, 1024 / (i7 >>> 0) | 0);
 STACKTOP = i9;
 return i5 | 0;
}

function __ZN2cvL9cvt16u16sEPKtjPKhjPsjNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 1;
 i8 = i6 >>> 1;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = (i9 | 0) > 3 ? i13 & -4 : 4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    i10 = HEAP16[i4 + (i5 << 1) >> 1] | 0;
    i12 = i5 | 1;
    i15 = HEAP16[i4 + (i12 << 1) >> 1] | 0;
    HEAP16[i2 + (i5 << 1) >> 1] = i10 << 16 >> 16 < 0 ? 32767 : i10;
    HEAP16[i2 + (i12 << 1) >> 1] = i15 << 16 >> 16 < 0 ? 32767 : i15;
    i12 = i5 | 2;
    i15 = HEAP16[i4 + (i12 << 1) >> 1] | 0;
    i10 = i5 | 3;
    i3 = HEAP16[i4 + (i10 << 1) >> 1] | 0;
    HEAP16[i2 + (i12 << 1) >> 1] = i15 << 16 >> 16 < 0 ? 32767 : i15;
    HEAP16[i2 + (i10 << 1) >> 1] = i3 << 16 >> 16 < 0 ? 32767 : i3;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   i10 = HEAP16[i4 + (i5 << 1) >> 1] | 0;
   HEAP16[i2 + (i5 << 1) >> 1] = i10 << 16 >> 16 < 0 ? 32767 : i10;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 1) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cvL14cvtScale16u64fEPKtjPKhjPdjNS_5Size_IiEES4_(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, d13 = 0.0, d14 = 0.0, i15 = 0, i16 = 0, d17 = 0.0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 d14 = +HEAPF64[i4 >> 3];
 d13 = +HEAPF64[i4 + 8 >> 3];
 i11 = i5 >>> 1;
 i9 = i6 >>> 3;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i1 = i15 + -4 | 0;
 i7 = (i1 | 0) < 0;
 i8 = (i1 | 0) > 3 ? i15 & -4 : 4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i7) i5 = 0; else {
   i5 = 0;
   do {
    i2 = i5 | 1;
    d17 = d13 + d14 * +(HEAPU16[i4 + (i2 << 1) >> 1] | 0 | 0);
    HEAPF64[i3 + (i5 << 3) >> 3] = d13 + d14 * +(HEAPU16[i4 + (i5 << 1) >> 1] | 0 | 0);
    HEAPF64[i3 + (i2 << 3) >> 3] = d17;
    i2 = i5 | 2;
    i10 = i5 | 3;
    d17 = d13 + d14 * +(HEAPU16[i4 + (i10 << 1) >> 1] | 0 | 0);
    HEAPF64[i3 + (i2 << 3) >> 3] = d13 + d14 * +(HEAPU16[i4 + (i2 << 1) >> 1] | 0 | 0);
    HEAPF64[i3 + (i10 << 3) >> 3] = d17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i1 | 0));
   i5 = i8;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAPF64[i3 + (i5 << 3) >> 3] = d13 + d14 * +(HEAPU16[i4 + (i5 << 1) >> 1] | 0 | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i9 << 3) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cvL12scaleAdd_32fEPKfS1_PfiS2_(i6, i7, i4, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, f12 = f0;
 i8 = STACKTOP;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i1 = i5 + -4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i2 = 0;
  do {
   f10 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i2 << 2) >> 2]));
   f10 = Math_fround(f10 + Math_fround(HEAPF32[i7 + (i2 << 2) >> 2]));
   i11 = i2 | 1;
   f12 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i11 << 2) >> 2]));
   f12 = Math_fround(f12 + Math_fround(HEAPF32[i7 + (i11 << 2) >> 2]));
   HEAPF32[i4 + (i2 << 2) >> 2] = f10;
   HEAPF32[i4 + (i11 << 2) >> 2] = f12;
   i11 = i2 | 2;
   f12 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i11 << 2) >> 2]));
   f12 = Math_fround(f12 + Math_fround(HEAPF32[i7 + (i11 << 2) >> 2]));
   i9 = i2 | 3;
   f10 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i9 << 2) >> 2]));
   f10 = Math_fround(f10 + Math_fround(HEAPF32[i7 + (i9 << 2) >> 2]));
   HEAPF32[i4 + (i11 << 2) >> 2] = f12;
   HEAPF32[i4 + (i9 << 2) >> 2] = f10;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) <= (i1 | 0));
  i1 = i5 & -4;
 }
 if ((i1 | 0) >= (i5 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  f10 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i1 << 2) >> 2]));
  HEAPF32[i4 + (i1 << 2) >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i7 + (i1 << 2) >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i8;
 return;
}

function __ZN2cvL9cvt16s16uEPKsjPKhjPtjNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 1;
 i8 = i6 >>> 1;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = (i9 | 0) > 3 ? i13 & -4 : 4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    i10 = HEAP16[i4 + (i5 << 1) >> 1] | 0;
    i12 = i5 | 1;
    i15 = HEAP16[i4 + (i12 << 1) >> 1] | 0;
    HEAP16[i2 + (i5 << 1) >> 1] = i10 << 16 >> 16 < 0 ? 0 : i10;
    HEAP16[i2 + (i12 << 1) >> 1] = i15 << 16 >> 16 < 0 ? 0 : i15;
    i12 = i5 | 2;
    i15 = HEAP16[i4 + (i12 << 1) >> 1] | 0;
    i10 = i5 | 3;
    i3 = HEAP16[i4 + (i10 << 1) >> 1] | 0;
    HEAP16[i2 + (i12 << 1) >> 1] = i15 << 16 >> 16 < 0 ? 0 : i15;
    HEAP16[i2 + (i10 << 1) >> 1] = i3 << 16 >> 16 < 0 ? 0 : i3;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   i10 = HEAP16[i4 + (i5 << 1) >> 1] | 0;
   HEAP16[i2 + (i5 << 1) >> 1] = i10 << 16 >> 16 < 0 ? 0 : i10;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 1) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function _cvRead(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i11 + 8 | 0;
 i7 = i11;
 i2 = (i8 | 0) != 0;
 if (!(i2 ? (HEAP32[i8 >> 2] | 0) == 1280131417 : 0)) {
  i2 = i2 ? -5 : -27;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i6, 31) | 0) + 0 | 0;
  i4 = 9096 | 0;
  i5 = i3 + 31 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i2, i6, 11120, 8960, 4953);
  __ZN2cv6String10deallocateEv(i6);
 }
 if (!i9) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (!((HEAP32[i9 >> 2] & 16 | 0) != 0 ? (i1 = HEAP32[i9 + 4 >> 2] | 0, (i1 | 0) != 0) : 0)) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i7, 57) | 0) + 0 | 0;
  i4 = 11128 | 0;
  i5 = i3 + 57 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i7, 11120, 8960, 4959);
  __ZN2cv6String10deallocateEv(i7);
  i1 = HEAP32[i9 + 4 >> 2] | 0;
 }
 i1 = FUNCTION_TABLE_iii[HEAP32[i1 + 28 >> 2] & 127](i8, i9) | 0;
 if (!i10) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN2cvL14cvtScale32s64fEPKijPKhjPdjNS_5Size_IiEES4_(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, d13 = 0.0, d14 = 0.0, i15 = 0, i16 = 0, d17 = 0.0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 d14 = +HEAPF64[i4 >> 3];
 d13 = +HEAPF64[i4 + 8 >> 3];
 i11 = i5 >>> 2;
 i9 = i6 >>> 3;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i1 = i15 + -4 | 0;
 i7 = (i1 | 0) < 0;
 i8 = (i1 | 0) > 3 ? i15 & -4 : 4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i7) i5 = 0; else {
   i5 = 0;
   do {
    i2 = i5 | 1;
    d17 = d13 + d14 * +(HEAP32[i4 + (i2 << 2) >> 2] | 0);
    HEAPF64[i3 + (i5 << 3) >> 3] = d13 + d14 * +(HEAP32[i4 + (i5 << 2) >> 2] | 0);
    HEAPF64[i3 + (i2 << 3) >> 3] = d17;
    i2 = i5 | 2;
    i10 = i5 | 3;
    d17 = d13 + d14 * +(HEAP32[i4 + (i10 << 2) >> 2] | 0);
    HEAPF64[i3 + (i2 << 3) >> 3] = d13 + d14 * +(HEAP32[i4 + (i2 << 2) >> 2] | 0);
    HEAPF64[i3 + (i10 << 3) >> 3] = d17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i1 | 0));
   i5 = i8;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAPF64[i3 + (i5 << 3) >> 3] = d13 + d14 * +(HEAP32[i4 + (i5 << 2) >> 2] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i9 << 3) | 0;
   i4 = i4 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cvL14cvtScale16s64fEPKsjPKhjPdjNS_5Size_IiEES4_(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, d13 = 0.0, d14 = 0.0, i15 = 0, i16 = 0, d17 = 0.0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 d14 = +HEAPF64[i4 >> 3];
 d13 = +HEAPF64[i4 + 8 >> 3];
 i11 = i5 >>> 1;
 i9 = i6 >>> 3;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i1 = i15 + -4 | 0;
 i7 = (i1 | 0) < 0;
 i8 = (i1 | 0) > 3 ? i15 & -4 : 4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i7) i5 = 0; else {
   i5 = 0;
   do {
    i2 = i5 | 1;
    d17 = d13 + d14 * +(HEAP16[i4 + (i2 << 1) >> 1] | 0);
    HEAPF64[i3 + (i5 << 3) >> 3] = d13 + d14 * +(HEAP16[i4 + (i5 << 1) >> 1] | 0);
    HEAPF64[i3 + (i2 << 3) >> 3] = d17;
    i2 = i5 | 2;
    i10 = i5 | 3;
    d17 = d13 + d14 * +(HEAP16[i4 + (i10 << 1) >> 1] | 0);
    HEAPF64[i3 + (i2 << 3) >> 3] = d13 + d14 * +(HEAP16[i4 + (i2 << 1) >> 1] | 0);
    HEAPF64[i3 + (i10 << 3) >> 3] = d17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i1 | 0));
   i5 = i8;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAPF64[i3 + (i5 << 3) >> 3] = d13 + d14 * +(HEAP16[i4 + (i5 << 1) >> 1] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i9 << 3) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE6setbufEPci(i7, i6, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 i4 = i7 + 8 | 0;
 i3 = i7 + 96 | 0;
 HEAP32[i4 + 0 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 if ((HEAP8[i3 >> 0] | 0) != 0 ? (i1 = HEAP32[i7 + 32 >> 2] | 0, (i1 | 0) != 0) : 0) __ZdaPv(i1);
 i4 = i7 + 97 | 0;
 if ((HEAP8[i4 >> 0] | 0) != 0 ? (i2 = HEAP32[i7 + 56 >> 2] | 0, (i2 | 0) != 0) : 0) __ZdaPv(i2);
 i1 = i7 + 52 | 0;
 HEAP32[i1 >> 2] = i5;
 do if (i5 >>> 0 > 8) {
  i1 = HEAP8[i7 + 98 >> 0] | 0;
  if (i1 << 24 >> 24 != 0 & (i6 | 0) != 0) {
   HEAP32[i7 + 32 >> 2] = i6;
   HEAP8[i3 >> 0] = 0;
   break;
  } else {
   HEAP32[i7 + 32 >> 2] = __Znaj(i5) | 0;
   HEAP8[i3 >> 0] = 1;
   break;
  }
 } else {
  HEAP32[i7 + 32 >> 2] = i7 + 44;
  HEAP32[i1 >> 2] = 8;
  HEAP8[i3 >> 0] = 0;
  i1 = HEAP8[i7 + 98 >> 0] | 0;
 } while (0);
 if (i1 << 24 >> 24) {
  HEAP32[i7 + 60 >> 2] = 0;
  HEAP32[i7 + 56 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = (i5 | 0) < 8 ? 8 : i5;
 HEAP32[i7 + 60 >> 2] = i1;
 if ((i6 | 0) != 0 & i1 >>> 0 > 7) {
  HEAP32[i7 + 56 >> 2] = i6;
  HEAP8[i4 >> 0] = 0;
  STACKTOP = i8;
  return i7 | 0;
 } else {
  HEAP32[i7 + 56 >> 2] = __Znaj(i1) | 0;
  HEAP8[i4 >> 0] = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 return 0;
}

function __ZN2cvL16transposeI_32sC6EPhji(i3, i7, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) > 0) i4 = 0; else {
  STACKTOP = i8;
  return;
 }
 do {
  i1 = i3 + (Math_imul(i4, i7) | 0) | 0;
  i2 = i4 * 24 | 0;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) < (i6 | 0)) {
   i5 = i4;
   do {
    i17 = i1 + (i5 * 24 | 0) | 0;
    i9 = (Math_imul(i5, i7) | 0) + i2 | 0;
    i15 = i3 + i9 | 0;
    i16 = HEAP32[i17 >> 2] | 0;
    i14 = HEAP32[i1 + (i5 * 24 | 0) + 4 >> 2] | 0;
    i13 = HEAP32[i1 + (i5 * 24 | 0) + 8 >> 2] | 0;
    i12 = HEAP32[i1 + (i5 * 24 | 0) + 12 >> 2] | 0;
    i11 = HEAP32[i1 + (i5 * 24 | 0) + 16 >> 2] | 0;
    i10 = HEAP32[i1 + (i5 * 24 | 0) + 20 >> 2] | 0;
    HEAP32[i17 + 0 >> 2] = HEAP32[i15 + 0 >> 2];
    HEAP32[i17 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i17 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i17 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    HEAP32[i17 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
    HEAP32[i17 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
    HEAP32[i15 >> 2] = i16;
    HEAP32[i3 + (i9 + 4) >> 2] = i14;
    HEAP32[i3 + (i9 + 8) >> 2] = i13;
    HEAP32[i3 + (i9 + 12) >> 2] = i12;
    HEAP32[i3 + (i9 + 16) >> 2] = i11;
    HEAP32[i3 + (i9 + 20) >> 2] = i10;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
  }
 } while ((i4 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZNK12_GLOBAL__N_115PythonFormatter6formatERKN2cv3MatE(i8, i6, i5) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i1 = i9 + 18 | 0;
 i7 = i9 + 8 | 0;
 i2 = i9;
 i3 = i9 + 17 | 0;
 i4 = i9 + 16 | 0;
 HEAP8[i1 + 0 >> 0] = HEAP8[8016] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[8017] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[8018] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[8019] | 0;
 HEAP8[i1 + 4 >> 0] = HEAP8[8020] | 0;
 if ((HEAP32[i5 + 12 >> 2] | 0) == 1) {
  HEAP8[i1 + 1 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 HEAP32[i2 >> 2] = i1;
 if ((HEAP32[i5 + 8 >> 2] | 0) == 1) i1 = 1; else i1 = (HEAP32[i6 + 12 >> 2] | 0) == 0 & 1;
 HEAP8[i3 >> 0] = i1;
 HEAP8[i4 >> 0] = 0;
 __ZN2cv7makePtrIN12_GLOBAL__N_113FormattedImplEA2_cS3_NS_3MatEPcbbiEENS_3PtrIT_EERKT0_RKT1_RKT2_RKT3_RKT4_RKT5_RKT6_(i7, 8024, 8032, i5, i2, i3, i4, (HEAP32[i5 >> 2] & 7 | 0) == 6 ? i6 + 8 | 0 : i6 + 4 | 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -1;
 if ((i2 | 0) != 1) {
  STACKTOP = i9;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i9;
 return;
}

function _scan_tree(i14, i15, i9) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 i12 = HEAP16[i15 + 2 >> 1] | 0;
 i11 = i12 << 16 >> 16 == 0;
 HEAP16[i15 + (i9 + 1 << 2) + 2 >> 1] = -1;
 i5 = i14 + 2752 | 0;
 i6 = i14 + 2756 | 0;
 i7 = i14 + 2748 | 0;
 i10 = i11 ? 138 : 7;
 i11 = i11 ? 3 : 4;
 i1 = 0;
 i12 = i12 & 65535;
 i13 = -1;
 L1 : while (1) {
  i8 = 0;
  do {
   if ((i1 | 0) > (i9 | 0)) break L1;
   i1 = i1 + 1 | 0;
   i2 = HEAP16[i15 + (i1 << 2) + 2 >> 1] | 0;
   i4 = i2 & 65535;
   i8 = i8 + 1 | 0;
   i3 = (i12 | 0) == (i4 | 0);
  } while ((i8 | 0) < (i10 | 0) & i3);
  do if ((i8 | 0) >= (i11 | 0)) if (!i12) if ((i8 | 0) < 11) {
   HEAP16[i5 >> 1] = (HEAP16[i5 >> 1] | 0) + 1 << 16 >> 16;
   break;
  } else {
   HEAP16[i6 >> 1] = (HEAP16[i6 >> 1] | 0) + 1 << 16 >> 16;
   break;
  } else {
   if ((i12 | 0) != (i13 | 0)) {
    i10 = i14 + (i12 << 2) + 2684 | 0;
    HEAP16[i10 >> 1] = (HEAP16[i10 >> 1] | 0) + 1 << 16 >> 16;
   }
   HEAP16[i7 >> 1] = (HEAP16[i7 >> 1] | 0) + 1 << 16 >> 16;
   break;
  } else {
   i10 = i14 + (i12 << 2) + 2684 | 0;
   HEAP16[i10 >> 1] = (HEAPU16[i10 >> 1] | 0) + i8;
  } while (0);
  if (!(i2 << 16 >> 16)) {
   i13 = i12;
   i10 = 138;
   i11 = 3;
   i12 = i4;
   continue;
  }
  i13 = i12;
  i10 = i3 ? 6 : 7;
  i11 = i3 ? 3 : 4;
  i12 = i4;
 }
 STACKTOP = i16;
 return;
}

function __ZN7testing8internal35DefaultGlobalTestPartResultReporter20ReportTestPartResultERKNS_14TestPartResultE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i4 + 108 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? i4 + 112 | 0 : i1 + 48 | 0;
 i4 = i1 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i1 + 12 >> 2] | 0)) {
  __ZNSt3__16vectorIN7testing14TestPartResultENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i1 + 4 | 0, i5);
  i1 = HEAP32[i3 >> 2] | 0;
  i1 = i1 + 152 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = i2 + 32 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  FUNCTION_TABLE_vii[i2 & 127](i1, i5);
  STACKTOP = i6;
  return;
 }
 if (!i2) i1 = 0; else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i2 + 4 | 0, i5 + 4 | 0);
  HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i2 + 20 | 0, i5 + 20 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i2 + 32 | 0, i5 + 32 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 44;
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = i1 + 152 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = i2 + 32 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 FUNCTION_TABLE_vii[i2 & 127](i1, i5);
 STACKTOP = i6;
 return;
}

function __ZNSt3__16vectorIhNS_9allocatorIhEEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 i7 = i8 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1;
 if ((i4 - i3 | 0) >>> 0 >= i2 >>> 0) {
  do {
   if (!i1) i1 = 0; else {
    HEAP8[i1 >> 0] = 0;
    i1 = HEAP32[i9 >> 2] | 0;
   }
   i1 = i1 + 1 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i3 - i1 + i2 | 0;
 if ((i3 | 0) < 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i8);
 i5 = i1;
 i1 = i4 - i5 | 0;
 if (i1 >>> 0 < 1073741823) {
  i1 = i1 << 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i3 = (HEAP32[i9 >> 2] | 0) - i5 | 0;
  if (!i1) {
   i4 = 0;
   i5 = 0;
  } else i6 = 10;
 } else {
  i1 = 2147483647;
  i3 = (HEAP32[i9 >> 2] | 0) - i5 | 0;
  i6 = 10;
 }
 if ((i6 | 0) == 10) {
  i4 = i1;
  i5 = __Znwj(i1) | 0;
 }
 i1 = i5 + i3 | 0;
 do {
  if (!i1) i1 = 0; else HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i3 = i5 + (i3 - i6) | 0;
 _memcpy(i3 | 0, i2 | 0, i6 | 0) | 0;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i7 >> 2] = i5 + i4;
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 __ZdlPv(i2);
 STACKTOP = i10;
 return;
}

function __ZN7testing8internal18StreamableToStringIxEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i8 + 4 | 0;
 i5 = i8;
 __ZN7testing7MessageC2Ev(i5);
 i6 = HEAP32[i5 >> 2] | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEx(i6 + 8 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i4, i6 + 12 | 0);
 i1 = HEAP8[i4 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i4 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i4 + 8 >> 2] | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i7, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 if (!i6) {
  STACKTOP = i8;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] & 511](i6);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZNSt3__114__split_bufferIPcRNS_9allocatorIS1_EEE10push_frontERKS1_(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 i10 = i9 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 do if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
  i7 = i9 + 8 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i8 = i9 + 12 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  i3 = i6;
  if (i2 >>> 0 < i6 >>> 0) {
   i6 = i2;
   i8 = ((i3 - i6 >> 2) + 1 | 0) / 2 | 0;
   i6 = i6 - i1 | 0;
   i9 = i2 + (i8 - (i6 >> 2) << 2) | 0;
   _memmove(i9 | 0, i1 | 0, i6 | 0) | 0;
   HEAP32[i10 >> 2] = i9;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i8 << 2);
   i1 = i9;
   break;
  }
  i6 = i3 - i1 >> 1;
  i6 = (i6 | 0) == 0 ? 1 : i6;
  i5 = __Znwj(i6 << 2) | 0;
  i1 = i5 + ((i6 + 3 | 0) >>> 2 << 2) | 0;
  i6 = i5 + (i6 << 2) | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if ((i3 | 0) == (i4 | 0)) i2 = i1; else {
   i2 = i1;
   do {
    if (!i2) i2 = 0; else HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) != (i4 | 0));
  }
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i6;
  if (i3) {
   __ZdlPv(i3);
   i1 = HEAP32[i10 >> 2] | 0;
  }
 } while (0);
 HEAP32[i1 + -4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -4;
 STACKTOP = i12;
 return;
}

function __ZNSt3__114__split_bufferIPcNS_9allocatorIS1_EEE10push_frontERKS1_(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 i10 = i9 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 do if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
  i7 = i9 + 8 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i8 = i9 + 12 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  i3 = i6;
  if (i2 >>> 0 < i6 >>> 0) {
   i6 = i2;
   i8 = ((i3 - i6 >> 2) + 1 | 0) / 2 | 0;
   i6 = i6 - i1 | 0;
   i9 = i2 + (i8 - (i6 >> 2) << 2) | 0;
   _memmove(i9 | 0, i1 | 0, i6 | 0) | 0;
   HEAP32[i10 >> 2] = i9;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i8 << 2);
   i1 = i9;
   break;
  }
  i6 = i3 - i1 >> 1;
  i6 = (i6 | 0) == 0 ? 1 : i6;
  i5 = __Znwj(i6 << 2) | 0;
  i1 = i5 + ((i6 + 3 | 0) >>> 2 << 2) | 0;
  i6 = i5 + (i6 << 2) | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if ((i3 | 0) == (i4 | 0)) i2 = i1; else {
   i2 = i1;
   do {
    if (!i2) i2 = 0; else HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) != (i4 | 0));
  }
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i6;
  if (i3) {
   __ZdlPv(i3);
   i1 = HEAP32[i10 >> 2] | 0;
  }
 } while (0);
 HEAP32[i1 + -4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -4;
 STACKTOP = i12;
 return;
}

function __ZN2cvL8cvt8s16uEPKajPKhjPtjNS_5Size_IiEEPd(i10, i13, i1, i2, i6, i5, i4, i3) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5 >>> 1;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i1 = i11 & -4;
 i2 = i6;
 i3 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i10 = HEAP8[i3 + i5 >> 0] | 0;
    i14 = i5 | 1;
    i15 = HEAP8[i3 + i14 >> 0] | 0;
    HEAP16[i2 + (i5 << 1) >> 1] = i10 << 24 >> 24 < 0 ? 0 : i10 << 24 >> 24;
    HEAP16[i2 + (i14 << 1) >> 1] = i15 << 24 >> 24 < 0 ? 0 : i15 << 24 >> 24;
    i14 = i5 | 2;
    i15 = HEAP8[i3 + i14 >> 0] | 0;
    i10 = i5 | 3;
    i6 = HEAP8[i3 + i10 >> 0] | 0;
    HEAP16[i2 + (i14 << 1) >> 1] = i15 << 24 >> 24 < 0 ? 0 : i15 << 24 >> 24;
    HEAP16[i2 + (i10 << 1) >> 1] = i6 << 24 >> 24 < 0 ? 0 : i6 << 24 >> 24;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i1;
  }
  if ((i5 | 0) < (i11 | 0)) do {
   i10 = HEAP8[i3 + i5 >> 0] | 0;
   HEAP16[i2 + (i5 << 1) >> 1] = i10 << 24 >> 24 < 0 ? 0 : i10 << 24 >> 24;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
  if (!i4) break; else {
   i2 = i2 + (i7 << 1) | 0;
   i3 = i3 + i13 | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function _mbtowc(i2, i5, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = i2;
 if (!i5) {
  i1 = 0;
  STACKTOP = i6;
  return i1 | 0;
 }
 do if (i3) {
  if (!i2) {
   HEAP32[i1 >> 2] = i1;
   i4 = i1;
  } else i4 = i2;
  i2 = HEAP8[i5 >> 0] | 0;
  i1 = i2 & 255;
  if (i2 << 24 >> 24 > -1) {
   HEAP32[i4 >> 2] = i1;
   i1 = i2 << 24 >> 24 != 0 & 1;
   STACKTOP = i6;
   return i1 | 0;
  }
  i2 = i1 + -194 | 0;
  if (i2 >>> 0 <= 50) {
   i1 = i5 + 1 | 0;
   i2 = HEAP32[968384 + (i2 << 2) >> 2] | 0;
   if (i3 >>> 0 < 4 ? (i2 & -2147483648 >>> ((i3 * 6 | 0) + -6 | 0) | 0) != 0 : 0) break;
   i1 = HEAPU8[i1 >> 0] | 0;
   i3 = i1 >>> 3;
   if ((i3 + -16 | i3 + (i2 >> 26)) >>> 0 <= 7) {
    i1 = i1 + -128 | i2 << 6;
    if ((i1 | 0) >= 0) {
     HEAP32[i4 >> 2] = i1;
     i1 = 2;
     STACKTOP = i6;
     return i1 | 0;
    }
    i2 = HEAPU8[i5 + 2 >> 0] | 0;
    if ((i2 & 192 | 0) == 128) {
     i2 = i2 + -128 | i1 << 6;
     if ((i2 | 0) >= 0) {
      HEAP32[i4 >> 2] = i2;
      i1 = 3;
      STACKTOP = i6;
      return i1 | 0;
     }
     i1 = HEAPU8[i5 + 3 >> 0] | 0;
     if ((i1 & 192 | 0) == 128) {
      HEAP32[i4 >> 2] = i1 + -128 | i2 << 6;
      i1 = 4;
      STACKTOP = i6;
      return i1 | 0;
     }
    }
   }
  }
 } while (0);
 HEAP32[(___errno_location() | 0) >> 2] = 84;
 i1 = -1;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN2cvL11cvtScale64fEPKdjPKhjPdjNS_5Size_IiEES4_(i12, i5, i1, i2, i10, i6, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, d13 = 0.0, d14 = 0.0, i15 = 0, i16 = 0, d17 = 0.0;
 i16 = STACKTOP;
 i15 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 d14 = +HEAPF64[i4 >> 3];
 d13 = +HEAPF64[i4 + 8 >> 3];
 i11 = i5 >>> 3;
 i9 = i6 >>> 3;
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i1 = i15 + -4 | 0;
 i7 = (i1 | 0) < 0;
 i8 = (i1 | 0) > 3 ? i15 & -4 : 4;
 i3 = i10;
 i4 = i12;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i7) i5 = 0; else {
   i5 = 0;
   do {
    i2 = i5 | 1;
    d17 = d13 + d14 * +HEAPF64[i4 + (i2 << 3) >> 3];
    HEAPF64[i3 + (i5 << 3) >> 3] = d13 + d14 * +HEAPF64[i4 + (i5 << 3) >> 3];
    HEAPF64[i3 + (i2 << 3) >> 3] = d17;
    i2 = i5 | 2;
    i10 = i5 | 3;
    d17 = d13 + d14 * +HEAPF64[i4 + (i10 << 3) >> 3];
    HEAPF64[i3 + (i2 << 3) >> 3] = d13 + d14 * +HEAPF64[i4 + (i2 << 3) >> 3];
    HEAPF64[i3 + (i10 << 3) >> 3] = d17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i1 | 0));
   i5 = i8;
  }
  if ((i5 | 0) < (i15 | 0)) do {
   HEAPF64[i3 + (i5 << 3) >> 3] = d13 + d14 * +HEAPF64[i4 + (i5 << 3) >> 3];
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if (!i6) break; else {
   i3 = i3 + (i9 << 3) | 0;
   i4 = i4 + (i11 << 3) | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cvlsERNSt3__113basic_ostreamIcNS0_11char_traitsIcEEEERKNS_3MatE1056(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i6 + 8 | 0;
 i4 = i6;
 __ZN2cv9Formatter3getEi(i4, 0);
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 FUNCTION_TABLE_viii[HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] & 63](i3, i2, i1);
 i2 = i3 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = FUNCTION_TABLE_ii[HEAP32[HEAP32[i1 >> 2] >> 2] & 127](i1) | 0;
 if (i1) do {
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i5, i1, _strlen(i1 | 0) | 0) | 0;
  i7 = HEAP32[i2 >> 2] | 0;
  i1 = FUNCTION_TABLE_ii[HEAP32[HEAP32[i7 >> 2] >> 2] & 127](i7) | 0;
 } while ((i1 | 0) != 0);
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i8 = i1 + 4 | 0, i7 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i7 + -1, (i7 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return i5 | 0;
 }
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -1;
 if ((i2 | 0) != 1) {
  STACKTOP = i6;
  return i5 | 0;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN2cv12RMByteStream8getDWordEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = i3 + 3 | 0;
 i4 = i7 + 12 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  i1 = (HEAPU8[i3 + 1 >> 0] | 0) << 16 | (HEAPU8[i3 >> 0] | 0) << 24 | (HEAPU8[i3 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 >> 0] | 0);
  HEAP32[i8 >> 2] = i3 + 4;
  STACKTOP = i9;
  return i1 | 0;
 }
 if (i3 >>> 0 < i2 >>> 0) i1 = i3; else {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] & 511](i7);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i6 = HEAPU8[i1 >> 0] | 0;
 i3 = i1 + 1 | 0;
 HEAP32[i8 >> 2] = i3;
 if (i3 >>> 0 >= i2 >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] & 511](i7);
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i5 = HEAPU8[i3 >> 0] | 0;
 i3 = i3 + 1 | 0;
 HEAP32[i8 >> 2] = i3;
 if (i3 >>> 0 >= i2 >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] & 511](i7);
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i4 = HEAPU8[i3 >> 0] | 0;
 i1 = i3 + 1 | 0;
 HEAP32[i8 >> 2] = i1;
 if (i1 >>> 0 >= i2 >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] & 511](i7);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i2 = HEAPU8[i1 >> 0] | 0;
 HEAP32[i8 >> 2] = i1 + 1;
 i1 = i5 << 16 | i6 << 24 | i4 << 8 | i2;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN2cv12RLByteStream8getDWordEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = i3 + 3 | 0;
 i4 = i7 + 12 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  i1 = (HEAPU8[i3 + 1 >> 0] | 0) << 8 | (HEAPU8[i3 >> 0] | 0) | (HEAPU8[i3 + 2 >> 0] | 0) << 16 | (HEAPU8[i1 >> 0] | 0) << 24;
  HEAP32[i8 >> 2] = i3 + 4;
  STACKTOP = i9;
  return i1 | 0;
 }
 if (i3 >>> 0 < i2 >>> 0) i1 = i3; else {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] & 511](i7);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i6 = HEAPU8[i1 >> 0] | 0;
 i3 = i1 + 1 | 0;
 HEAP32[i8 >> 2] = i3;
 if (i3 >>> 0 >= i2 >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] & 511](i7);
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i5 = HEAPU8[i3 >> 0] | 0;
 i3 = i3 + 1 | 0;
 HEAP32[i8 >> 2] = i3;
 if (i3 >>> 0 >= i2 >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] & 511](i7);
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i4 = HEAPU8[i3 >> 0] | 0;
 i1 = i3 + 1 | 0;
 HEAP32[i8 >> 2] = i1;
 if (i1 >>> 0 >= i2 >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] & 511](i7);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i2 = HEAPU8[i1 >> 0] | 0;
 HEAP32[i8 >> 2] = i1 + 1;
 i1 = i5 << 8 | i6 | i4 << 16 | i2 << 24;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw(i11, i10, i1, i4, i8, i9, i7, i5) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i12 = 0;
 i12 = STACKTOP;
 if ((1073741806 - i10 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i11);
 if (!(HEAP8[i11 >> 0] & 1)) i6 = i11 + 4 | 0; else i6 = HEAP32[i11 + 8 >> 2] | 0;
 if (i10 >>> 0 < 536870887) {
  i1 = i1 + i10 | 0;
  i3 = i10 << 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  if (i1 >>> 0 < 2) i2 = 2; else i2 = i1 + 4 & -4;
 } else i2 = 1073741807;
 i3 = __Znwj(i2 << 2) | 0;
 if (i8) _wmemcpy(i3, i6, i8) | 0;
 if (i7) _wmemcpy(i3 + (i8 << 2) | 0, i5, i7) | 0;
 i1 = i4 - i9 | 0;
 if ((i1 | 0) != (i8 | 0)) _wmemcpy(i3 + (i7 + i8 << 2) | 0, i6 + (i9 + i8 << 2) | 0, i1 - i8 | 0) | 0;
 if ((i10 | 0) == 1) {
  i10 = i11 + 8 | 0;
  HEAP32[i10 >> 2] = i3;
  i10 = i2 | 1;
  HEAP32[i11 >> 2] = i10;
  i10 = i1 + i7 | 0;
  i9 = i11 + 4 | 0;
  HEAP32[i9 >> 2] = i10;
  i10 = i3 + (i10 << 2) | 0;
  HEAP32[i10 >> 2] = 0;
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i6);
 i10 = i11 + 8 | 0;
 HEAP32[i10 >> 2] = i3;
 i10 = i2 | 1;
 HEAP32[i11 >> 2] = i10;
 i10 = i1 + i7 | 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = i10;
 i10 = i3 + (i10 << 2) | 0;
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN2cvL9cvt32f32sEPKfjPKhjPijNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 2;
 i8 = i6 >>> 2;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = i13 & -4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    i10 = _lrint(+Math_fround(HEAPF32[i4 + (i5 << 2) >> 2])) | 0;
    i12 = i5 | 1;
    i15 = _lrint(+Math_fround(HEAPF32[i4 + (i12 << 2) >> 2])) | 0;
    HEAP32[i2 + (i5 << 2) >> 2] = i10;
    HEAP32[i2 + (i12 << 2) >> 2] = i15;
    i12 = i5 | 2;
    i15 = _lrint(+Math_fround(HEAPF32[i4 + (i12 << 2) >> 2])) | 0;
    i10 = i5 | 3;
    i3 = _lrint(+Math_fround(HEAPF32[i4 + (i10 << 2) >> 2])) | 0;
    HEAP32[i2 + (i12 << 2) >> 2] = i15;
    HEAP32[i2 + (i10 << 2) >> 2] = i3;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   HEAP32[i2 + (i5 << 2) >> 2] = _lrint(+Math_fround(HEAPF32[i4 + (i5 << 2) >> 2])) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 2) | 0;
   i4 = i4 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZNK2cv5MatOp6invertERKNS_7MatExprEiRS1_(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i9 = i11;
 HEAP32[i9 >> 2] = 1124007936;
 i10 = i9 + 4 | 0;
 i2 = i9 + 8 | 0;
 i7 = i9 + 40 | 0;
 i1 = i10 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i7 >> 2] = i2;
 i8 = i9 + 48 | 0;
 i3 = i9 + 44 | 0;
 HEAP32[i3 >> 2] = i8;
 HEAP32[i9 + 52 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i4, i9, -1);
 __ZN2cv12MatOp_Invert8makeExprERNS_7MatExprEiRKNS_3MatE(i6, i5, i9);
 i2 = i9 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i5 = i1 + 12 | 0, i6 = HEAP32[i5 >> 2] | 0, HEAP32[i5 >> 2] = i6 + -1, (i6 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i9);
 HEAP32[i2 >> 2] = 0;
 i9 = i9 + 16 | 0;
 HEAP32[i9 + 0 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 if ((HEAP32[i10 >> 2] | 0) > 0) {
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i10 >> 2] | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i11;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i11;
 return;
}

function __ZNK2cv12_OutputArray5clearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i7;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1) | 0) != 65536) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] & 511](i1);
  STACKTOP = i7;
  return;
 }
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] & 127](i1) | 0) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i2, 12) | 0) + 0 | 0;
  i4 = 31120 | 0;
  i5 = i3 + 12 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 31144, 27528, 2536);
  __ZN2cv6String10deallocateEv(i2);
 }
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i5 = i4 + 40 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP32[i4 >> 2] & 32768)) {
  i1 = i4 + 44 | 0;
  if ((HEAP32[i4 + 16 >> 2] | 0) >>> 0 > (HEAP32[i4 + 28 >> 2] | 0) >>> 0) i6 = 8;
 } else {
  i1 = i4 + 44 | 0;
  i6 = 8;
 }
 if ((i6 | 0) == 8) {
  __ZN2cv3Mat7reserveEj(i4, 0);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 i2 = Math_imul(HEAP32[i1 >> 2] | 0, 0 - i3 | 0) | 0;
 i1 = i4 + 24 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
 STACKTOP = i7;
 return;
}

function __ZN2cvL8cvt16u8sEPKtjPKhjPajNS_5Size_IiEEPd(i10, i5, i1, i2, i6, i13, i4, i3) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5 >>> 1;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i1 = i11 & -4;
 i2 = i6;
 i3 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i10 = HEAP16[i3 + (i5 << 1) >> 1] | 0;
    i14 = i5 | 1;
    i15 = HEAP16[i3 + (i14 << 1) >> 1] | 0;
    HEAP8[i2 + i5 >> 0] = (i10 & 65535) > 127 ? 127 : i10 & 255;
    HEAP8[i2 + i14 >> 0] = (i15 & 65535) > 127 ? 127 : i15 & 255;
    i14 = i5 | 2;
    i15 = HEAP16[i3 + (i14 << 1) >> 1] | 0;
    i10 = i5 | 3;
    i6 = HEAP16[i3 + (i10 << 1) >> 1] | 0;
    HEAP8[i2 + i14 >> 0] = (i15 & 65535) > 127 ? 127 : i15 & 255;
    HEAP8[i2 + i10 >> 0] = (i6 & 65535) > 127 ? 127 : i6 & 255;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i1;
  }
  if ((i5 | 0) < (i11 | 0)) do {
   i10 = HEAP16[i3 + (i5 << 1) >> 1] | 0;
   HEAP8[i2 + i5 >> 0] = (i10 & 65535) > 127 ? 127 : i10 & 255;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
  if (!i4) break; else {
   i2 = i2 + i13 | 0;
   i3 = i3 + (i7 << 1) | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZN7testing8internal18StreamableToStringIiEENSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERKT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i8 + 4 | 0;
 i5 = i8;
 __ZN7testing7MessageC2Ev(i5);
 i6 = HEAP32[i5 >> 2] | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i6 + 8 | 0, HEAP32[i1 >> 2] | 0) | 0;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i4, i6 + 12 | 0);
 i1 = HEAP8[i4 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i4 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i4 + 8 >> 2] | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i7, i1 << 1);
 if (i1) do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 if (!i6) {
  STACKTOP = i8;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] & 511](i6);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN2cvL8cvt16u8uEPKtjPKhjPhjNS_5Size_IiEEPd(i10, i5, i1, i2, i6, i13, i4, i3) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5 >>> 1;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i1 = i11 & -4;
 i2 = i6;
 i3 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i10 = HEAP16[i3 + (i5 << 1) >> 1] | 0;
    i14 = i5 | 1;
    i15 = HEAP16[i3 + (i14 << 1) >> 1] | 0;
    HEAP8[i2 + i5 >> 0] = (i10 & 65535) > 255 ? -1 : i10 & 255;
    HEAP8[i2 + i14 >> 0] = (i15 & 65535) > 255 ? -1 : i15 & 255;
    i14 = i5 | 2;
    i15 = HEAP16[i3 + (i14 << 1) >> 1] | 0;
    i10 = i5 | 3;
    i6 = HEAP16[i3 + (i10 << 1) >> 1] | 0;
    HEAP8[i2 + i14 >> 0] = (i15 & 65535) > 255 ? -1 : i15 & 255;
    HEAP8[i2 + i10 >> 0] = (i6 & 65535) > 255 ? -1 : i6 & 255;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i1;
  }
  if ((i5 | 0) < (i11 | 0)) do {
   i10 = HEAP16[i3 + (i5 << 1) >> 1] | 0;
   HEAP8[i2 + i5 >> 0] = (i10 & 65535) > 255 ? -1 : i10 & 255;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
  if (!i4) break; else {
   i2 = i2 + i13 | 0;
   i3 = i3 + (i7 << 1) | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZN2cvL9cvt16u32fEPKtjPKhjPfjNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 1;
 i8 = i6 >>> 2;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = (i9 | 0) > 3 ? i13 & -4 : 4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    f15 = Math_fround(HEAPU16[i4 + (i5 << 1) >> 1] | 0);
    i3 = i5 | 1;
    f16 = Math_fround(HEAPU16[i4 + (i3 << 1) >> 1] | 0);
    HEAPF32[i2 + (i5 << 2) >> 2] = f15;
    HEAPF32[i2 + (i3 << 2) >> 2] = f16;
    i3 = i5 | 2;
    f16 = Math_fround(HEAPU16[i4 + (i3 << 1) >> 1] | 0);
    i10 = i5 | 3;
    f15 = Math_fround(HEAPU16[i4 + (i10 << 1) >> 1] | 0);
    HEAPF32[i2 + (i3 << 2) >> 2] = f16;
    HEAPF32[i2 + (i10 << 2) >> 2] = f15;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   HEAPF32[i2 + (i5 << 2) >> 2] = Math_fround(HEAPU16[i4 + (i5 << 1) >> 1] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 2) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cv16SunRasterEncoder5writeERKNS_3MatERKNSt3__16vectorIiNS4_9allocatorIiEEEE(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i8 = i9;
 i3 = HEAP32[i5 + 12 >> 2] | 0;
 i7 = HEAP32[i5 + 8 >> 2] | 0;
 i2 = ((HEAP32[i5 >> 2] | 0) >>> 3 & 511) + 1 | 0;
 i6 = (Math_imul(i2, i3) | 0) + 1 & -2;
 __ZN2cv11WBaseStreamC2Ev(i8);
 HEAP32[i8 >> 2] = 181240;
 if (!(FUNCTION_TABLE_iii[HEAP32[181232 + 16 >> 2] & 127](i8, i4 + 12 | 0) | 0)) {
  i1 = 0;
  __ZN2cv11WBaseStreamD2Ev(i8);
  STACKTOP = i9;
  return i1 | 0;
 }
 __ZN2cv12WLByteStream8putBytesEPKvi(i8, 180112, 4);
 __ZN2cv12WMByteStream8putDWordEi(i8, i3);
 __ZN2cv12WMByteStream8putDWordEi(i8, i7);
 __ZN2cv12WMByteStream8putDWordEi(i8, i2 << 3);
 __ZN2cv12WMByteStream8putDWordEi(i8, Math_imul(i6, i7) | 0);
 __ZN2cv12WMByteStream8putDWordEi(i8, 1);
 __ZN2cv12WMByteStream8putDWordEi(i8, 0);
 __ZN2cv12WMByteStream8putDWordEi(i8, 0);
 if ((i7 | 0) > 0) {
  i3 = i5 + 16 | 0;
  i1 = i5 + 44 | 0;
  i2 = 0;
  do {
   __ZN2cv12WLByteStream8putBytesEPKvi(i8, (HEAP32[i3 >> 2] | 0) + (Math_imul(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i2) | 0) | 0, i6);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i7 | 0));
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] & 511](i8);
 i1 = 1;
 __ZN2cv11WBaseStreamD2Ev(i8);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN2cvL9cvt32s32fEPKijPKhjPfjNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 2;
 i8 = i6 >>> 2;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = (i9 | 0) > 3 ? i13 & -4 : 4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    f15 = Math_fround(HEAP32[i4 + (i5 << 2) >> 2] | 0);
    i3 = i5 | 1;
    f16 = Math_fround(HEAP32[i4 + (i3 << 2) >> 2] | 0);
    HEAPF32[i2 + (i5 << 2) >> 2] = f15;
    HEAPF32[i2 + (i3 << 2) >> 2] = f16;
    i3 = i5 | 2;
    f16 = Math_fround(HEAP32[i4 + (i3 << 2) >> 2] | 0);
    i10 = i5 | 3;
    f15 = Math_fround(HEAP32[i4 + (i10 << 2) >> 2] | 0);
    HEAPF32[i2 + (i3 << 2) >> 2] = f16;
    HEAPF32[i2 + (i10 << 2) >> 2] = f15;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   HEAPF32[i2 + (i5 << 2) >> 2] = Math_fround(HEAP32[i4 + (i5 << 2) >> 2] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 2) | 0;
   i4 = i4 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cvL9cvt16s32fEPKsjPKhjPfjNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 1;
 i8 = i6 >>> 2;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = (i9 | 0) > 3 ? i13 & -4 : 4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    f15 = Math_fround(HEAP16[i4 + (i5 << 1) >> 1] | 0);
    i3 = i5 | 1;
    f16 = Math_fround(HEAP16[i4 + (i3 << 1) >> 1] | 0);
    HEAPF32[i2 + (i5 << 2) >> 2] = f15;
    HEAPF32[i2 + (i3 << 2) >> 2] = f16;
    i3 = i5 | 2;
    f16 = Math_fround(HEAP16[i4 + (i3 << 1) >> 1] | 0);
    i10 = i5 | 3;
    f15 = Math_fround(HEAP16[i4 + (i10 << 1) >> 1] | 0);
    HEAPF32[i2 + (i3 << 2) >> 2] = f16;
    HEAPF32[i2 + (i10 << 2) >> 2] = f15;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   HEAPF32[i2 + (i5 << 2) >> 2] = Math_fround(HEAP16[i4 + (i5 << 1) >> 1] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 2) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cv13AlgorithmInfoC2ERKNS_6StringEPFPNS_9AlgorithmEvE(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = i1;
 i3 = __Znwj(20) | 0;
 HEAP32[i3 + 0 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 i2 = i3 + 12 | 0;
 if ((i2 | 0) != (i5 | 0)) {
  __ZN2cv6String10deallocateEv(i2);
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i1 = i1 + -4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 + 16 >> 2] = HEAP32[i5 + 4 >> 2];
 }
 if ((HEAP8[39576] | 0) == 0 ? (___cxa_guard_acquire(39576) | 0) != 0 : 0) {
  HEAP32[9890] = 0;
  HEAP32[9891] = 0;
  HEAP32[9892] = 0;
  ___cxa_atexit(352, 39560, ___dso_handle | 0) | 0;
  ___cxa_guard_release(39576);
 }
 if (__ZNK2cv13sorted_vectorINS_6StringEPFPNS_9AlgorithmEvEE4findERKS1_RS5_(39560, i5, i4) | 0) {
  STACKTOP = i6;
  return;
 }
 if ((HEAP8[39576] | 0) == 0 ? (___cxa_guard_acquire(39576) | 0) != 0 : 0) {
  HEAP32[9890] = 0;
  HEAP32[9891] = 0;
  HEAP32[9892] = 0;
  ___cxa_atexit(352, 39560, ___dso_handle | 0) | 0;
  ___cxa_guard_release(39576);
 }
 __ZN2cv13sorted_vectorINS_6StringEPFPNS_9AlgorithmEvEE3addERKS1_RKS5_(39560, i5, i4);
 STACKTOP = i6;
 return;
}

function __ZN2cvL13cvtScale8u64fEPKhjS1_jPdjNS_5Size_IiEES2_(i11, i16, i1, i2, i6, i5, i3, i4) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, d12 = 0.0, d13 = 0.0, i14 = 0, i15 = 0, d17 = 0.0;
 i15 = STACKTOP;
 i14 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 d13 = +HEAPF64[i4 >> 3];
 d12 = +HEAPF64[i4 + 8 >> 3];
 i10 = i5 >>> 3;
 if (!i2) {
  STACKTOP = i15;
  return;
 }
 i7 = i14 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = i14 & -4;
 i1 = i6;
 i3 = i11;
 i4 = i2;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i8) i5 = 0; else {
   i5 = 0;
   do {
    i2 = i5 | 1;
    d17 = d12 + d13 * +(HEAPU8[i3 + i2 >> 0] | 0 | 0);
    HEAPF64[i1 + (i5 << 3) >> 3] = d12 + d13 * +(HEAPU8[i3 + i5 >> 0] | 0 | 0);
    HEAPF64[i1 + (i2 << 3) >> 3] = d17;
    i2 = i5 | 2;
    i6 = i5 | 3;
    d17 = d12 + d13 * +(HEAPU8[i3 + i6 >> 0] | 0 | 0);
    HEAPF64[i1 + (i2 << 3) >> 3] = d12 + d13 * +(HEAPU8[i3 + i2 >> 0] | 0 | 0);
    HEAPF64[i1 + (i6 << 3) >> 3] = d17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i7 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i14 | 0)) do {
   HEAPF64[i1 + (i5 << 3) >> 3] = d12 + d13 * +(HEAPU8[i3 + i5 >> 0] | 0 | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if (!i4) break; else {
   i1 = i1 + (i10 << 3) | 0;
   i3 = i3 + i16 | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN2cv17CommandLineParser4Impl12apply_paramsERKNS_6StringES4_(i1, i13, i14) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0;
 i15 = STACKTOP;
 i12 = i1 + 40 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i10 = i1 + 36 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i15;
  return;
 }
 i11 = i14 + 4 | 0;
 i9 = 0;
 do {
  i7 = HEAP32[i1 + (i9 << 5) + 20 >> 2] | 0;
  i4 = HEAP32[i1 + (i9 << 5) + 16 >> 2] | 0;
  L6 : do if ((i7 | 0) != (i4 | 0)) {
   i5 = HEAP32[i13 >> 2] | 0;
   i3 = (i5 | 0) == 0 ? 6232 : i5;
   i8 = 0;
   while (1) {
    i6 = HEAP32[i4 + (i8 << 3) >> 2] | 0;
    if ((i5 | 0) == (i6 | 0)) break;
    i8 = i8 + 1 | 0;
    if (!(_strcmp(i3, (i6 | 0) == 0 ? 6232 : i6) | 0)) break;
    if (i8 >>> 0 >= i7 - i4 >> 3 >>> 0) break L6;
   }
   i3 = i1 + (i9 << 5) + 8 | 0;
   if ((i3 | 0) != (i14 | 0)) {
    __ZN2cv6String10deallocateEv(i3);
    i2 = HEAP32[i14 >> 2] | 0;
    if (!i2) i2 = 0; else {
     i2 = i2 + -4 | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i14 >> 2] | 0;
    }
    HEAP32[i3 >> 2] = i2;
    HEAP32[i1 + (i9 << 5) + 12 >> 2] = HEAP32[i11 >> 2];
    i2 = HEAP32[i12 >> 2] | 0;
    i1 = HEAP32[i10 >> 2] | 0;
   }
  } while (0);
  i9 = i9 + 1 | 0;
 } while (i9 >>> 0 < i2 - i1 >> 5 >>> 0);
 STACKTOP = i15;
 return;
}

function __ZN2cvL9cvt32f64fEPKfjPKhjPdjNS_5Size_IiEES4_(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, d15 = 0.0, d16 = 0.0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 2;
 i8 = i6 >>> 3;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = (i9 | 0) > 3 ? i13 & -4 : 4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    d15 = +Math_fround(HEAPF32[i4 + (i5 << 2) >> 2]);
    i3 = i5 | 1;
    d16 = +Math_fround(HEAPF32[i4 + (i3 << 2) >> 2]);
    HEAPF64[i2 + (i5 << 3) >> 3] = d15;
    HEAPF64[i2 + (i3 << 3) >> 3] = d16;
    i3 = i5 | 2;
    d16 = +Math_fround(HEAPF32[i4 + (i3 << 2) >> 2]);
    i10 = i5 | 3;
    d15 = +Math_fround(HEAPF32[i4 + (i10 << 2) >> 2]);
    HEAPF64[i2 + (i3 << 3) >> 3] = d16;
    HEAPF64[i2 + (i10 << 3) >> 3] = d15;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   HEAPF64[i2 + (i5 << 3) >> 3] = +Math_fround(HEAPF32[i4 + (i5 << 2) >> 2]);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 3) | 0;
   i4 = i4 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc(i11, i10, i1, i4, i8, i9, i7, i5) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i12 = 0;
 i12 = STACKTOP;
 if ((-18 - i10 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i11);
 if (!(HEAP8[i11 >> 0] & 1)) i6 = i11 + 1 | 0; else i6 = HEAP32[i11 + 8 >> 2] | 0;
 if (i10 >>> 0 < 2147483623) {
  i1 = i1 + i10 | 0;
  i3 = i10 << 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  if (i1 >>> 0 < 11) i2 = 11; else i2 = i1 + 16 & -16;
 } else i2 = -17;
 i3 = __Znwj(i2) | 0;
 if (i8) _memcpy(i3 | 0, i6 | 0, i8 | 0) | 0;
 if (i7) _memcpy(i3 + i8 | 0, i5 | 0, i7 | 0) | 0;
 i1 = i4 - i9 | 0;
 if ((i1 | 0) != (i8 | 0)) _memcpy(i3 + (i7 + i8) | 0, i6 + (i9 + i8) | 0, i1 - i8 | 0) | 0;
 if ((i10 | 0) == 10) {
  i10 = i11 + 8 | 0;
  HEAP32[i10 >> 2] = i3;
  i10 = i2 | 1;
  HEAP32[i11 >> 2] = i10;
  i10 = i1 + i7 | 0;
  i9 = i11 + 4 | 0;
  HEAP32[i9 >> 2] = i10;
  i10 = i3 + i10 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i12;
  return;
 }
 __ZdlPv(i6);
 i10 = i11 + 8 | 0;
 HEAP32[i10 >> 2] = i3;
 i10 = i2 | 1;
 HEAP32[i11 >> 2] = i10;
 i10 = i1 + i7 | 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = i10;
 i10 = i3 + i10 | 0;
 HEAP8[i10 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZNK2cv5MatOp9transposeERKNS_7MatExprERS1_(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = 1124007936;
 i9 = i8 + 4 | 0;
 i2 = i8 + 8 | 0;
 i6 = i8 + 40 | 0;
 i1 = i9 + 0 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i6 >> 2] = i2;
 i7 = i8 + 48 | 0;
 i3 = i8 + 44 | 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i8 + 52 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 63](i2, i4, i8, -1);
 __ZN2cv7MatOp_T8makeExprERNS_7MatExprERKNS_3MatEd(i5, i8, 1.0);
 i2 = i8 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i4 = i1 + 12 | 0, i1 = HEAP32[i4 >> 2] | 0, HEAP32[i4 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i8);
 HEAP32[i2 >> 2] = 0;
 i1 = i8 + 16 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i9 >> 2] | 0) > 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i9 >> 2] | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i7 | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i10;
 return;
}

function __ZNK2cv17CommandLineParser4Impl10cat_stringERKNS_6StringE(i9, i1, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 i6 = i10 + 4 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 L1 : do if ((i7 | 0) < 0) i1 = 0; else {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = 0;
  while (1) {
   i1 = i3 + 1 | 0;
   if ((HEAP8[i2 + i3 >> 0] | 0) != 32) {
    i1 = i3;
    break L1;
   }
   if ((i3 | 0) < (i7 | 0)) i3 = i1; else break;
  }
 } while (0);
 i2 = i7;
 while (1) {
  if ((i2 | 0) <= (i1 | 0)) {
   i5 = 8;
   break;
  }
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  if ((HEAP8[i4 + i3 >> 0] | 0) == 32) i2 = i3; else break;
 }
 if ((i5 | 0) == 8) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i9, 0) | 0;
  STACKTOP = i8;
  return;
 }
 i5 = i2 - i1 | 0;
 HEAP32[i9 >> 2] = 0;
 i3 = i9 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i7 >>> 0 < i1 >>> 0 ? i7 : i1;
 i2 = i7 - i1 | 0;
 i2 = i2 >>> 0 > i5 >>> 0 ? i5 : i2;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if ((i2 | 0) == (i7 | 0)) {
  i1 = i4 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  STACKTOP = i8;
  return;
 } else {
  i3 = __ZN2cv6String8allocateEj(i9, i2) | 0;
  _memcpy(i3 | 0, (HEAP32[i10 >> 2] | 0) + i1 | 0, i2 | 0) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN2cvL9cvt64f32fEPKdjPKhjPfjNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 3;
 i8 = i6 >>> 2;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = (i9 | 0) > 3 ? i13 & -4 : 4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    f15 = Math_fround(+HEAPF64[i4 + (i5 << 3) >> 3]);
    i3 = i5 | 1;
    f16 = Math_fround(+HEAPF64[i4 + (i3 << 3) >> 3]);
    HEAPF32[i2 + (i5 << 2) >> 2] = f15;
    HEAPF32[i2 + (i3 << 2) >> 2] = f16;
    i3 = i5 | 2;
    f16 = Math_fround(+HEAPF64[i4 + (i3 << 3) >> 3]);
    i10 = i5 | 3;
    f15 = Math_fround(+HEAPF64[i4 + (i10 << 3) >> 3]);
    HEAPF32[i2 + (i3 << 2) >> 2] = f16;
    HEAPF32[i2 + (i10 << 2) >> 2] = f15;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   HEAPF32[i2 + (i5 << 2) >> 2] = Math_fround(+HEAPF64[i4 + (i5 << 3) >> 3]);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 2) | 0;
   i4 = i4 + (i11 << 3) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 if (i2 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i8);
 i1 = HEAP8[i8 >> 0] | 0;
 if (!(i1 & 1)) i3 = 10; else {
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = (i1 & -2) + -1 | 0;
  i1 = i1 & 255;
 }
 if (!(i1 & 1)) i7 = (i1 & 255) >>> 1; else i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i7 >>> 0 > i2 >>> 0 ? i7 : i2;
 if (i2 >>> 0 < 11) i6 = 10; else i6 = (i2 + 16 & -16) + -1 | 0;
 if ((i6 | 0) == (i3 | 0)) {
  STACKTOP = i9;
  return;
 }
 do if ((i6 | 0) != 10) {
  i2 = i6 + 1 | 0;
  if (i6 >>> 0 > i3 >>> 0) i2 = __Znwj(i2) | 0; else i2 = __Znwj(i2) | 0;
  i1 = HEAP8[i8 >> 0] | 0;
  if (!(i1 & 1)) {
   i3 = 1;
   i4 = i8 + 1 | 0;
   i5 = 0;
   break;
  } else {
   i3 = 1;
   i4 = HEAP32[i8 + 8 >> 2] | 0;
   i5 = 1;
   break;
  }
 } else {
  i2 = i8 + 1 | 0;
  i3 = 0;
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  i5 = 1;
 } while (0);
 if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i8 + 4 >> 2] | 0;
 _memcpy(i2 | 0, i4 | 0, i1 + 1 | 0) | 0;
 if (i5) __ZdlPv(i4);
 if (i3) {
  HEAP32[i8 >> 2] = i6 + 1 | 1;
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i8 + 8 >> 2] = i2;
  STACKTOP = i9;
  return;
 } else {
  HEAP8[i8 >> 0] = i7 << 1;
  STACKTOP = i9;
  return;
 }
}

function __Z12FillGrayRow1PhS_iS_(i3, i2, i4, i9) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 i1 = i3 + i4 | 0;
 if ((i4 | 0) > 8) {
  i7 = i3 + 16 | 0;
  i7 = ((i1 >>> 0 > i7 >>> 0 ? i1 : i7) + (-9 - i3) | 0) >>> 3;
  i8 = i7 + 1 | 0;
  i7 = (i7 << 3) + 8 | 0;
  i4 = i3;
  i5 = i2;
  i6 = i3 + 8 | 0;
  while (1) {
   i11 = HEAPU8[i5 >> 0] | 0;
   HEAP8[i4 >> 0] = HEAP8[i9 + (i11 >>> 7) >> 0] | 0;
   HEAP8[i4 + 1 >> 0] = HEAP8[i9 + (i11 >>> 6 & 1) >> 0] | 0;
   HEAP8[i4 + 2 >> 0] = HEAP8[i9 + (i11 >>> 5 & 1) >> 0] | 0;
   HEAP8[i4 + 3 >> 0] = HEAP8[i9 + (i11 >>> 4 & 1) >> 0] | 0;
   HEAP8[i4 + 4 >> 0] = HEAP8[i9 + (i11 >>> 3 & 1) >> 0] | 0;
   HEAP8[i4 + 5 >> 0] = HEAP8[i9 + (i11 >>> 2 & 1) >> 0] | 0;
   HEAP8[i4 + 6 >> 0] = HEAP8[i9 + (i11 >>> 1 & 1) >> 0] | 0;
   HEAP8[i4 + 7 >> 0] = HEAP8[i9 + (i11 & 1) >> 0] | 0;
   i4 = i6 + 8 | 0;
   if (i4 >>> 0 < i1 >>> 0) {
    i11 = i6;
    i5 = i5 + 1 | 0;
    i6 = i4;
    i4 = i11;
   } else break;
  }
  i3 = i3 + i7 | 0;
  i2 = i2 + i8 | 0;
 }
 if (i3 >>> 0 >= i1 >>> 0) {
  i9 = i3;
  STACKTOP = i10;
  return i9 | 0;
 }
 i2 = (HEAPU8[i2 >> 0] | 0) << 24;
 while (1) {
  HEAP8[i3 >> 0] = HEAP8[i9 + (i2 >>> 31) >> 0] | 0;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 << 1;
 }
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 if (i2 >>> 0 > 1073741807) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i8);
 i1 = HEAP8[i8 >> 0] | 0;
 if (!(i1 & 1)) i3 = 1; else {
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = (i1 & -2) + -1 | 0;
  i1 = i1 & 255;
 }
 if (!(i1 & 1)) i7 = (i1 & 255) >>> 1; else i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i7 >>> 0 > i2 >>> 0 ? i7 : i2;
 if (i2 >>> 0 < 2) i6 = 1; else i6 = (i2 + 4 & -4) + -1 | 0;
 if ((i6 | 0) == (i3 | 0)) {
  STACKTOP = i9;
  return;
 }
 do if ((i6 | 0) != 1) {
  i2 = (i6 << 2) + 4 | 0;
  if (i6 >>> 0 > i3 >>> 0) i2 = __Znwj(i2) | 0; else i2 = __Znwj(i2) | 0;
  i1 = HEAP8[i8 >> 0] | 0;
  if (!(i1 & 1)) {
   i3 = 1;
   i4 = i8 + 4 | 0;
   i5 = 0;
   break;
  } else {
   i3 = 1;
   i4 = HEAP32[i8 + 8 >> 2] | 0;
   i5 = 1;
   break;
  }
 } else {
  i2 = i8 + 4 | 0;
  i3 = 0;
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  i5 = 1;
 } while (0);
 if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i8 + 4 >> 2] | 0;
 _wmemcpy(i2, i4, i1 + 1 | 0) | 0;
 if (i5) __ZdlPv(i4);
 if (i3) {
  HEAP32[i8 >> 2] = i6 + 1 | 1;
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i8 + 8 >> 2] = i2;
  STACKTOP = i9;
  return;
 } else {
  HEAP8[i8 >> 0] = i7 << 1;
  STACKTOP = i9;
  return;
 }
}

function __ZN2cvL13cvtScale8s64fEPKajPKhjPdjNS_5Size_IiEES4_(i11, i16, i1, i2, i6, i5, i3, i4) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, d12 = 0.0, d13 = 0.0, i14 = 0, i15 = 0, d17 = 0.0;
 i15 = STACKTOP;
 i14 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 d13 = +HEAPF64[i4 >> 3];
 d12 = +HEAPF64[i4 + 8 >> 3];
 i10 = i5 >>> 3;
 if (!i2) {
  STACKTOP = i15;
  return;
 }
 i7 = i14 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = i14 & -4;
 i1 = i6;
 i3 = i11;
 i4 = i2;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i8) i5 = 0; else {
   i5 = 0;
   do {
    i2 = i5 | 1;
    d17 = d12 + d13 * +(HEAP8[i3 + i2 >> 0] | 0);
    HEAPF64[i1 + (i5 << 3) >> 3] = d12 + d13 * +(HEAP8[i3 + i5 >> 0] | 0);
    HEAPF64[i1 + (i2 << 3) >> 3] = d17;
    i2 = i5 | 2;
    i6 = i5 | 3;
    d17 = d12 + d13 * +(HEAP8[i3 + i6 >> 0] | 0);
    HEAPF64[i1 + (i2 << 3) >> 3] = d12 + d13 * +(HEAP8[i3 + i2 >> 0] | 0);
    HEAPF64[i1 + (i6 << 3) >> 3] = d17;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i7 | 0));
   i5 = i9;
  }
  if ((i5 | 0) < (i14 | 0)) do {
   HEAPF64[i1 + (i5 << 3) >> 3] = d12 + d13 * +(HEAP8[i3 + i5 >> 0] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if (!i4) break; else {
   i1 = i1 + (i10 << 3) | 0;
   i3 = i3 + i16 | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i10, i6, i8, i9, i7) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i11 + 4 | 0;
 i4 = i11;
 i5 = i1 + 8 | 0;
 i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 127](i5) | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 if (!(i1 & 1)) i2 = (i1 & 255) >>> 1; else i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP8[i5 + 12 >> 0] | 0;
 if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i5 + 16 >> 2] | 0;
 if ((i2 | 0) == (0 - i1 | 0)) {
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 4;
  STACKTOP = i11;
  return;
 }
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
 i9 = __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i6, i3, i5, i5 + 24 | 0, i7, i9, 0) | 0;
 i1 = i9 - i5 | 0;
 if ((i9 | 0) == (i5 | 0) ? (HEAP32[i10 >> 2] | 0) == 12 : 0) {
  HEAP32[i10 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) != 12) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) >= 12) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i10 >> 2] = i1 + 12;
 STACKTOP = i11;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i10, i6, i8, i9, i7) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i11 + 4 | 0;
 i4 = i11;
 i5 = i1 + 8 | 0;
 i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 127](i5) | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 if (!(i1 & 1)) i2 = (i1 & 255) >>> 1; else i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP8[i5 + 12 >> 0] | 0;
 if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i5 + 16 >> 2] | 0;
 if ((i2 | 0) == (0 - i1 | 0)) {
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 4;
  STACKTOP = i11;
  return;
 }
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
 i9 = __ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i6, i3, i5, i5 + 24 | 0, i7, i9, 0) | 0;
 i1 = i9 - i5 | 0;
 if ((i9 | 0) == (i5 | 0) ? (HEAP32[i10 >> 2] | 0) == 12 : 0) {
  HEAP32[i10 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) != 12) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) >= 12) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i10 >> 2] = i1 + 12;
 STACKTOP = i11;
 return;
}

function __ZN4perf8TestBase14getSizeInBytesERKN2cv11_InputArrayE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 76 >> 2] & 127](i3) | 0) {
  i1 = 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 i2 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] & 127](i3, -1) | 0;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3) | 0) != 327680 ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 127](i3) | 0) != 262144 : 0) {
  i1 = ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] & 127](i3, -1) | 0) >>> 3 & 511) + 1 | 0;
  i1 = Math_imul(i1 << (47696 >>> ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] & 127](i3, -1) | 0) << 1 & 14) & 3), i2) | 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 if ((i2 | 0) > 0) {
  i4 = 0;
  i1 = 0;
 } else {
  i1 = 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 do {
  i6 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] & 127](i3, i4) | 0;
  i7 = ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] & 127](i3, i4) | 0) >>> 3 & 511) + 1 | 0;
  i1 = (Math_imul(i7 << (47696 >>> ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] & 127](i3, i4) | 0) << 1 & 14) & 3), i6) | 0) + i1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i2 | 0));
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN7testing8internal23MakeAndRegisterTestInfoEPKcS2_S2_S2_PKvPFvvES6_PNS0_15TestFactoryBaseE(i7, i4, i8, i9, i3, i5, i6, i2) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i11 = i10 + 12 | 0;
 i12 = i10;
 i1 = __Znwj(88) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i7, _strlen(i7 | 0) | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i4, _strlen(i4 | 0) | 0);
 __ZN7testing8TestInfoC2ERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_PKcSB_PKvPNS_8internal15TestFactoryBaseE(i1, i11, i12, i8, i9, i3, i2);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i12);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i11);
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i9 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i9, 163728);
  HEAP32[40934] = i9;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 __ZN7testing8internal12UnitTestImpl11AddTestInfoEPFvvES3_PNS_8TestInfoE(HEAP32[40934] | 0, i5, i6, i1);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNK12_GLOBAL__N_116DefaultFormatter6formatERKN2cv3MatE(i8, i6, i5) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i9 + 18 | 0;
 i7 = i9 + 8 | 0;
 i1 = i9;
 i3 = i9 + 17 | 0;
 i4 = i9 + 16 | 0;
 HEAP8[i2 + 0 >> 0] = HEAP8[8680] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[8681] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[8682] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[8683] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[8684] | 0;
 HEAP32[i1 >> 2] = i2;
 if ((HEAP32[i5 + 8 >> 2] | 0) == 1) i2 = 1; else i2 = (HEAP32[i6 + 12 >> 2] | 0) == 0 & 1;
 HEAP8[i3 >> 0] = i2;
 HEAP8[i4 >> 0] = 0;
 __ZN2cv7makePtrIN12_GLOBAL__N_113FormattedImplEA2_cS3_NS_3MatEPcbbiEENS_3PtrIT_EERKT0_RKT1_RKT2_RKT3_RKT4_RKT5_RKT6_(i7, 8024, 8032, i5, i1, i3, i4, (HEAP32[i5 >> 2] & 7 | 0) == 6 ? i6 + 8 | 0 : i6 + 4 | 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -1;
 if ((i2 | 0) != 1) {
  STACKTOP = i9;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i9;
 return;
}

function __ZNK2cv5MatOp4sizeERKNS_7MatExprE(i6, i1, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 if (HEAP32[i7 + 24 >> 2] | 0) {
  i3 = HEAP32[i7 + 12 >> 2] | 0;
  if ((i3 | 0) < 3) i1 = Math_imul(HEAP32[i7 + 20 >> 2] | 0, HEAP32[i7 + 16 >> 2] | 0) | 0; else {
   i2 = HEAP32[i7 + 48 >> 2] | 0;
   i4 = 0;
   i1 = 1;
   do {
    i1 = Math_imul(HEAP32[i2 + (i4 << 2) >> 2] | 0, i1) | 0;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i3 | 0));
  }
  if (i1) {
   i2 = HEAP32[i7 + 48 >> 2] | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i6 + 4 >> 2] = i1;
   STACKTOP = i5;
   return;
  }
 }
 if (HEAP32[i7 + 80 >> 2] | 0) {
  i2 = HEAP32[i7 + 68 >> 2] | 0;
  if ((i2 | 0) < 3) i1 = Math_imul(HEAP32[i7 + 76 >> 2] | 0, HEAP32[i7 + 72 >> 2] | 0) | 0; else {
   i3 = HEAP32[i7 + 104 >> 2] | 0;
   i4 = 0;
   i1 = 1;
   do {
    i1 = Math_imul(HEAP32[i3 + (i4 << 2) >> 2] | 0, i1) | 0;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i2 | 0));
  }
  if (i1) {
   i2 = HEAP32[i7 + 160 >> 2] | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i6 + 4 >> 2] = i1;
   STACKTOP = i5;
   return;
  }
 }
 i2 = HEAP32[i7 + 104 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 STACKTOP = i5;
 return;
}

function __ZNK12_GLOBAL__N_110CFormatter6formatERKN2cv3MatE(i8, i6, i5) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i9 + 18 | 0;
 i7 = i9 + 8 | 0;
 i1 = i9;
 i3 = i9 + 17 | 0;
 i4 = i9 + 16 | 0;
 HEAP8[i2 + 0 >> 0] = HEAP8[7056] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[7057] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[7058] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[7059] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[7060] | 0;
 HEAP32[i1 >> 2] = i2;
 if ((HEAP32[i5 + 8 >> 2] | 0) == 1) i2 = 1; else i2 = (HEAP32[i6 + 12 >> 2] | 0) == 0 & 1;
 HEAP8[i3 >> 0] = i2;
 HEAP8[i4 >> 0] = 0;
 __ZN2cv7makePtrIN12_GLOBAL__N_113FormattedImplEA2_cS3_NS_3MatEPcbbiEENS_3PtrIT_EERKT0_RKT1_RKT2_RKT3_RKT4_RKT5_RKT6_(i7, 7064, 7072, i5, i1, i3, i4, (HEAP32[i5 >> 2] & 7 | 0) == 6 ? i6 + 8 | 0 : i6 + 4 | 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -1;
 if ((i2 | 0) != 1) {
  STACKTOP = i9;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i9;
 return;
}

function __ZN2cvL9cvt64f32sEPKdjPKhjPijNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 3;
 i8 = i6 >>> 2;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = i13 & -4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    i10 = _lrint(+HEAPF64[i4 + (i5 << 3) >> 3]) | 0;
    i12 = i5 | 1;
    i15 = _lrint(+HEAPF64[i4 + (i12 << 3) >> 3]) | 0;
    HEAP32[i2 + (i5 << 2) >> 2] = i10;
    HEAP32[i2 + (i12 << 2) >> 2] = i15;
    i12 = i5 | 2;
    i15 = _lrint(+HEAPF64[i4 + (i12 << 3) >> 3]) | 0;
    i10 = i5 | 3;
    i3 = _lrint(+HEAPF64[i4 + (i10 << 3) >> 3]) | 0;
    HEAP32[i2 + (i12 << 2) >> 2] = i15;
    HEAP32[i2 + (i10 << 2) >> 2] = i3;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   HEAP32[i2 + (i5 << 2) >> 2] = _lrint(+HEAPF64[i4 + (i5 << 3) >> 3]) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 2) | 0;
   i4 = i4 + (i11 << 3) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZL17icvDoubleToStringPcd(i4, d3) {
 i4 = i4 | 0;
 d3 = +d3;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5;
 HEAPF64[tempDoublePtr >> 3] = d3;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 if ((i2 & 2146435072 | 0) == 2146435072) if (((i2 & 2147483647) + ((HEAP32[tempDoublePtr >> 2] | 0) != 0 & 1) | 0) >>> 0 > 2146435072) {
  HEAP8[i4 + 0 >> 0] = HEAP8[14456] | 0;
  HEAP8[i4 + 1 >> 0] = HEAP8[14457] | 0;
  HEAP8[i4 + 2 >> 0] = HEAP8[14458] | 0;
  HEAP8[i4 + 3 >> 0] = HEAP8[14459] | 0;
  HEAP8[i4 + 4 >> 0] = HEAP8[14460] | 0;
  STACKTOP = i5;
  return i4 | 0;
 } else {
  _strcpy(i4 | 0, ((i2 | 0) < 0 ? 14464 : 14472) | 0) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = _lrint(d3) | 0;
 if (+(i2 | 0) == d3) {
  HEAP32[i1 >> 2] = i2;
  _sprintf(i4, 14440, i1) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAPF64[tempDoublePtr >> 3] = d3;
 HEAP32[i1 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 _sprintf(i4, 14448, i1) | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 if (i1 << 24 >> 24 == 45 | i1 << 24 >> 24 == 43) i2 = i4 + 1 | 0; else i2 = i4;
 while (1) {
  i1 = HEAP8[i2 >> 0] | 0;
  if ((i1 + -48 << 24 >> 24 & 255) < 10) i2 = i2 + 1 | 0; else break;
 }
 if (i1 << 24 >> 24 != 44) {
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP8[i2 >> 0] = 46;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNSt3__110__stdinbufIwE9pbackfailEj(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i9 = i10 + 16 | 0;
 i8 = i10 + 8 | 0;
 i1 = i10 + 4 | 0;
 i3 = i10;
 i5 = i4 + 52 | 0;
 i2 = (HEAP8[i5 >> 0] | 0) != 0;
 if ((i7 | 0) == -1) {
  if (i2) {
   i1 = -1;
   STACKTOP = i10;
   return i1 | 0;
  }
  i1 = HEAP32[i4 + 48 >> 2] | 0;
  HEAP8[i5 >> 0] = (i1 | 0) != -1 & 1;
  STACKTOP = i10;
  return i1 | 0;
 }
 i6 = i4 + 48 | 0;
 L8 : do if (i2) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  i2 = HEAP32[i4 + 36 >> 2] | 0;
  i1 = FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 15](i2, HEAP32[i4 + 40 >> 2] | 0, i1, i1 + 4 | 0, i3, i9, i9 + 8 | 0, i8) | 0;
  if ((i1 | 0) == 3) {
   HEAP8[i9 >> 0] = HEAP32[i6 >> 2];
   HEAP32[i8 >> 2] = i9 + 1;
  } else if ((i1 | 0) == 1 | (i1 | 0) == 2) {
   i1 = -1;
   STACKTOP = i10;
   return i1 | 0;
  }
  i1 = i4 + 32 | 0;
  while (1) {
   i2 = HEAP32[i8 >> 2] | 0;
   if (i2 >>> 0 <= i9 >>> 0) break L8;
   i2 = i2 + -1 | 0;
   HEAP32[i8 >> 2] = i2;
   if ((_ungetc(HEAP8[i2 >> 0] | 0, HEAP32[i1 >> 2] | 0) | 0) == -1) {
    i1 = -1;
    break;
   }
  }
  STACKTOP = i10;
  return i1 | 0;
 } while (0);
 HEAP32[i6 >> 2] = i7;
 HEAP8[i5 >> 0] = 1;
 i1 = i7;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNSt3__110__stdinbufIcE9pbackfailEi(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i9 = i10 + 16 | 0;
 i8 = i10 + 4 | 0;
 i1 = i10 + 8 | 0;
 i3 = i10;
 i5 = i4 + 52 | 0;
 i2 = (HEAP8[i5 >> 0] | 0) != 0;
 if ((i7 | 0) == -1) {
  if (i2) {
   i1 = -1;
   STACKTOP = i10;
   return i1 | 0;
  }
  i1 = HEAP32[i4 + 48 >> 2] | 0;
  HEAP8[i5 >> 0] = (i1 | 0) != -1 & 1;
  STACKTOP = i10;
  return i1 | 0;
 }
 i6 = i4 + 48 | 0;
 L8 : do if (i2) {
  HEAP8[i1 >> 0] = HEAP32[i6 >> 2];
  i2 = HEAP32[i4 + 36 >> 2] | 0;
  i1 = FUNCTION_TABLE_iiiiiiiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] & 15](i2, HEAP32[i4 + 40 >> 2] | 0, i1, i1 + 1 | 0, i3, i9, i9 + 8 | 0, i8) | 0;
  if ((i1 | 0) == 3) {
   HEAP8[i9 >> 0] = HEAP32[i6 >> 2];
   HEAP32[i8 >> 2] = i9 + 1;
  } else if ((i1 | 0) == 1 | (i1 | 0) == 2) {
   i1 = -1;
   STACKTOP = i10;
   return i1 | 0;
  }
  i1 = i4 + 32 | 0;
  while (1) {
   i2 = HEAP32[i8 >> 2] | 0;
   if (i2 >>> 0 <= i9 >>> 0) break L8;
   i2 = i2 + -1 | 0;
   HEAP32[i8 >> 2] = i2;
   if ((_ungetc(HEAP8[i2 >> 0] | 0, HEAP32[i1 >> 2] | 0) | 0) == -1) {
    i1 = -1;
    break;
   }
  }
  STACKTOP = i10;
  return i1 | 0;
 } while (0);
 HEAP32[i6 >> 2] = i7;
 HEAP8[i5 >> 0] = 1;
 i1 = i7;
 STACKTOP = i10;
 return i1 | 0;
}

function _cvStartWriteStruct(i8, i9, i10, i11, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i7 + 8 | 0;
 i6 = i7;
 i1 = (i8 | 0) != 0;
 if (!(i1 ? (HEAP32[i8 >> 2] | 0) == 1280131417 : 0)) {
  i1 = i1 ? -5 : -27;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i5, 31) | 0) + 0 | 0;
  i3 = 9096 | 0;
  i4 = i2 + 31 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i1, i5, 9920, 8960, 2916);
  __ZN2cv6String10deallocateEv(i5);
 }
 if (HEAP32[i8 + 8 >> 2] | 0) {
  i6 = i8 + 228 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  FUNCTION_TABLE_viiii[i6 & 63](i8, i9, i10, i11);
  STACKTOP = i7;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i6, 38) | 0) + 0 | 0;
 i3 = 9944 | 0;
 i4 = i2 + 38 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i6, 9920, 8960, 2916);
 __ZN2cv6String10deallocateEv(i6);
 i6 = i8 + 228 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 FUNCTION_TABLE_viiii[i6 & 63](i8, i9, i10, i11);
 STACKTOP = i7;
 return;
}

function __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE6resizeEj(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 i6 = i4 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i2 = (i5 - i3 | 0) / 56 | 0;
 if (i2 >>> 0 < i1 >>> 0) {
  __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE8__appendEj(i4, i1 - i2 | 0);
  STACKTOP = i7;
  return;
 }
 if (i2 >>> 0 <= i1 >>> 0) {
  STACKTOP = i7;
  return;
 }
 i4 = i3 + (i1 * 56 | 0) | 0;
 if ((i5 | 0) == (i4 | 0)) {
  STACKTOP = i7;
  return;
 }
 do {
  i1 = i5 + -56 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i5 + -20 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != 0 ? (i8 = i3 + 12 | 0, i3 = HEAP32[i8 >> 2] | 0, HEAP32[i8 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i1);
  HEAP32[i2 >> 2] = 0;
  i1 = i5 + -40 | 0;
  i3 = i5 + -52 | 0;
  HEAP32[i1 + 0 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i2 = HEAP32[i5 + -16 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  i1 = HEAP32[i5 + -12 >> 2] | 0;
  if ((i1 | 0) != (i5 + -8 | 0)) __ZN2cv8fastFreeEPv(i1);
  i5 = HEAP32[i6 >> 2] | 0;
 } while ((i5 | 0) != (i4 | 0));
 STACKTOP = i7;
 return;
}

function __ZN2cv6vBinOpIhNS_5OpXorIhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i8, i1, i9, i2, i7, i10) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 i6 = i10 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5 + -1;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i5 = i2;
 i2 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i2 = 0;
   while (1) {
    i13 = i2 | 1;
    i4 = HEAP8[i1 + i13 >> 0] ^ HEAP8[i3 + i13 >> 0];
    HEAP8[i5 + i2 >> 0] = HEAP8[i1 + i2 >> 0] ^ HEAP8[i3 + i2 >> 0];
    HEAP8[i5 + i13 >> 0] = i4;
    i13 = i2 | 2;
    i4 = i2 | 3;
    i12 = HEAP8[i1 + i4 >> 0] ^ HEAP8[i3 + i4 >> 0];
    HEAP8[i5 + i13 >> 0] = HEAP8[i1 + i13 >> 0] ^ HEAP8[i3 + i13 >> 0];
    HEAP8[i5 + i4 >> 0] = i12;
    i4 = i2 + 4 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) > (i2 + -4 | 0)) break; else i2 = i4;
   }
  }
  if ((i4 | 0) < (i2 | 0)) do {
   HEAP8[i5 + i4 >> 0] = HEAP8[i1 + i4 >> 0] ^ HEAP8[i3 + i4 >> 0];
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + -1;
  if (!i4) break; else {
   i1 = i1 + i9 | 0;
   i5 = i5 + i7 | 0;
   i3 = i3 + i8 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cv6vBinOpIhNS_5OpAndIhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i8, i1, i9, i2, i7, i10) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 i6 = i10 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5 + -1;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i5 = i2;
 i2 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i2 = 0;
   while (1) {
    i13 = i2 | 1;
    i4 = HEAP8[i1 + i13 >> 0] & HEAP8[i3 + i13 >> 0];
    HEAP8[i5 + i2 >> 0] = HEAP8[i1 + i2 >> 0] & HEAP8[i3 + i2 >> 0];
    HEAP8[i5 + i13 >> 0] = i4;
    i13 = i2 | 2;
    i4 = i2 | 3;
    i12 = HEAP8[i1 + i4 >> 0] & HEAP8[i3 + i4 >> 0];
    HEAP8[i5 + i13 >> 0] = HEAP8[i1 + i13 >> 0] & HEAP8[i3 + i13 >> 0];
    HEAP8[i5 + i4 >> 0] = i12;
    i4 = i2 + 4 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) > (i2 + -4 | 0)) break; else i2 = i4;
   }
  }
  if ((i4 | 0) < (i2 | 0)) do {
   HEAP8[i5 + i4 >> 0] = HEAP8[i1 + i4 >> 0] & HEAP8[i3 + i4 >> 0];
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + -1;
  if (!i4) break; else {
   i1 = i1 + i9 | 0;
   i5 = i5 + i7 | 0;
   i3 = i3 + i8 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEEC2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i9 + 4 | 0;
 i2 = i9;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i7);
 HEAP32[i7 >> 2] = 177424;
 HEAP32[i7 + 32 >> 2] = 0;
 HEAP32[i7 + 36 >> 2] = 0;
 HEAP32[i7 + 40 >> 2] = 0;
 i3 = i7 + 52 | 0;
 i4 = i7 + 68 | 0;
 i5 = i7 + 98 | 0;
 i6 = i7 + 4 | 0;
 i8 = i3 + 0 | 0;
 i10 = i8 + 44 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i10 | 0));
 HEAP16[i3 + 44 >> 1] = 0;
 HEAP8[i3 + 46 >> 0] = 0;
 __ZNSt3__16localeC2ERKS0_(i1, i6);
 i3 = __ZNKSt3__16locale9has_facetERNS0_2idE(i1, 960792) | 0;
 __ZNSt3__16localeD2Ev(i1);
 if (!i3) {
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = i1 + 12 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  FUNCTION_TABLE_iiii[i1 & 63](i7, 0, 4096) | 0;
  STACKTOP = i9;
  return;
 }
 __ZNSt3__16localeC2ERKS0_(i2, i6);
 HEAP32[i4 >> 2] = __ZNKSt3__16locale9use_facetERNS0_2idE(i2, 960792) | 0;
 __ZNSt3__16localeD2Ev(i2);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP8[i5 >> 0] = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1) | 0) & 1;
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = i1 + 12 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 FUNCTION_TABLE_iiii[i1 & 63](i7, 0, 4096) | 0;
 STACKTOP = i9;
 return;
}

function __ZN2cv6vBinOpIhNS_4OpOrIhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i8, i1, i9, i2, i7, i10) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 i6 = i10 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5 + -1;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i5 = i2;
 i2 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i2 + -4 | 0) < 0) i4 = 0; else {
   i2 = 0;
   while (1) {
    i13 = i2 | 1;
    i4 = HEAP8[i1 + i13 >> 0] | HEAP8[i3 + i13 >> 0];
    HEAP8[i5 + i2 >> 0] = HEAP8[i1 + i2 >> 0] | HEAP8[i3 + i2 >> 0];
    HEAP8[i5 + i13 >> 0] = i4;
    i13 = i2 | 2;
    i4 = i2 | 3;
    i12 = HEAP8[i1 + i4 >> 0] | HEAP8[i3 + i4 >> 0];
    HEAP8[i5 + i13 >> 0] = HEAP8[i1 + i13 >> 0] | HEAP8[i3 + i13 >> 0];
    HEAP8[i5 + i4 >> 0] = i12;
    i4 = i2 + 4 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) > (i2 + -4 | 0)) break; else i2 = i4;
   }
  }
  if ((i4 | 0) < (i2 | 0)) do {
   HEAP8[i5 + i4 >> 0] = HEAP8[i1 + i4 >> 0] | HEAP8[i3 + i4 >> 0];
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 + -1;
  if (!i4) break; else {
   i1 = i1 + i9 | 0;
   i5 = i5 + i7 | 0;
   i3 = i3 + i8 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function _cvNextNArraySlice(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 if ((i2 | 0) <= 0) {
  i1 = 0;
  STACKTOP = i10;
  return i1 | 0;
 }
 i8 = i9 + 184 | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  if ((HEAP32[i9 >> 2] | 0) > 0) {
   i1 = 0;
   do {
    i3 = i9 + (i1 << 2) + 16 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + (HEAP32[(HEAP32[i9 + (i1 << 2) + 184 >> 2] | 0) + (i2 << 3) + 24 >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i9 >> 2] | 0));
  }
  i4 = i9 + (i2 << 2) + 56 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
  HEAP32[i4 >> 2] = i1;
  if ((i1 | 0) > 0) {
   i1 = 1;
   i2 = 11;
   break;
  }
  i1 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i1 + (i2 << 3) + 20 >> 2] | 0;
  i6 = HEAP32[i9 >> 2] | 0;
  L11 : do if ((i6 | 0) > 0) {
   i7 = 0 - i5 | 0;
   i3 = 0;
   while (1) {
    i11 = i9 + (i3 << 2) + 16 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (Math_imul(HEAP32[i1 + (i2 << 3) + 24 >> 2] | 0, i7) | 0);
    i3 = i3 + 1 | 0;
    if ((i3 | 0) >= (i6 | 0)) break L11;
    i1 = HEAP32[i9 + (i3 << 2) + 184 >> 2] | 0;
   }
  } while (0);
  HEAP32[i4 >> 2] = i5;
  if ((i2 | 0) <= 0) {
   i1 = 0;
   i2 = 11;
   break;
  }
 }
 if ((i2 | 0) == 11) {
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function __ZNK2cv15StdMatAllocator10deallocateEPNS_8UMatDataE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i4 + 8 | 0;
 i2 = i4;
 if ((HEAP32[i7 + 8 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i1, 17) | 0) + 0 | 0;
  i5 = 32872 | 0;
  i6 = i3 + 17 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i3 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 32896, 27528, 207);
  __ZN2cv6String10deallocateEv(i1);
 }
 i1 = i7 + 12 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i2, 16) | 0) + 0 | 0;
  i5 = 32912 | 0;
  i6 = i3 + 16 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i3 | 0) < (i6 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 32896, 27528, 208);
  __ZN2cv6String10deallocateEv(i2);
 }
 if (!i7) {
  STACKTOP = i4;
  return;
 }
 if (HEAP32[i1 >> 2] | 0) {
  STACKTOP = i4;
  return;
 }
 if (!(HEAP32[i7 + 32 >> 2] & 32)) {
  i1 = i7 + 20 | 0;
  __ZN2cv8fastFreeEPv(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZN2cv8UMatDataD2Ev(i7);
 __ZdlPv(i7);
 STACKTOP = i4;
 return;
}

function __ZN7testing8internal8FilePath9NormalizeEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 i5 = HEAP8[i6 >> 0] | 0;
 i1 = (i5 & 1) == 0;
 do if (!i1) if (!(HEAP32[i6 + 8 >> 2] | 0)) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6, 159968) | 0;
  STACKTOP = i7;
  return;
 } else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = __Znaj((HEAP32[i6 + 4 >> 2] | 0) + 1 | 0) | 0;
  if (i1) {
   i4 = 7;
   break;
  }
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  break;
 } else {
  i3 = __Znaj(((i5 & 255) >>> 1) + 1 | 0) | 0;
  i2 = i6 + 1 | 0;
  i4 = 7;
 } while (0);
 if ((i4 | 0) == 7) i5 = (i5 & 255) >>> 1;
 _memset(i3 | 0, 0, i5 + 1 | 0) | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i1 = i3; else {
  i4 = i1;
  i1 = i3;
  do {
   HEAP8[i1 >> 0] = i4;
   L15 : do if ((HEAP8[i2 >> 0] | 0) == 47) {
    i4 = 47;
    i5 = i2;
    while (1) {
     i2 = i5 + 1 | 0;
     if (i4 << 24 >> 24 != 47) {
      i2 = i5;
      break L15;
     }
     i4 = HEAP8[i2 >> 0] | 0;
     i5 = i2;
    }
   } else {
    i2 = i2 + 1 | 0;
    i4 = HEAP8[i2 >> 0] | 0;
   } while (0);
   i1 = i1 + 1 | 0;
  } while (i4 << 24 >> 24 != 0);
 }
 HEAP8[i1 >> 0] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6, i3) | 0;
 __ZdaPv(i3);
 STACKTOP = i7;
 return;
}

function _cvWriteString(i7, i8, i10, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i11 + 8 | 0;
 i6 = i11;
 i1 = (i7 | 0) != 0;
 if (!(i1 ? (HEAP32[i7 >> 2] | 0) == 1280131417 : 0)) {
  i1 = i1 ? -5 : -27;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i5, 31) | 0) + 0 | 0;
  i3 = 9096 | 0;
  i4 = i2 + 31 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i1, i5, 10040, 8960, 2948);
  __ZN2cv6String10deallocateEv(i5);
 }
 if (HEAP32[i7 + 8 >> 2] | 0) {
  i6 = i7 + 244 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  FUNCTION_TABLE_viiii[i6 & 63](i7, i8, i10, i9);
  STACKTOP = i11;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i6, 38) | 0) + 0 | 0;
 i3 = 9944 | 0;
 i4 = i2 + 38 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i6, 10040, 8960, 2948);
 __ZN2cv6String10deallocateEv(i6);
 i6 = i7 + 244 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 FUNCTION_TABLE_viiii[i6 & 63](i7, i8, i10, i9);
 STACKTOP = i11;
 return;
}

function __Z12FillUniColorPhRS_iiRiii12PaletteEntry(i1, i12, i13, i2, i14, i11, i3, i10) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 i7 = i13 - i2 | 0;
 i8 = i10 + 1 | 0;
 i9 = i10 + 2 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 while (1) {
  i2 = i1;
  i5 = i1 + i3 | 0;
  i6 = i5 >>> 0 > i4 >>> 0 ? i4 : i5;
  i3 = i2 - i6 + i3 | 0;
  if (i1 >>> 0 < i6 >>> 0) {
   i16 = ~i4;
   i4 = ~i5;
   i4 = -2 - i2 - (i16 >>> 0 > i4 >>> 0 ? i16 : i4) | 0;
   i4 = i4 - ((i4 >>> 0) % 3 | 0) | 0;
   i2 = i1;
   do {
    HEAP8[i2 >> 0] = HEAP8[i10 >> 0] | 0;
    HEAP8[i2 + 1 >> 0] = HEAP8[i8 >> 0] | 0;
    HEAP8[i2 + 2 >> 0] = HEAP8[i9 >> 0] | 0;
    i2 = i2 + 3 | 0;
   } while (i2 >>> 0 < i6 >>> 0);
   i1 = i1 + (i4 + 3) | 0;
   i4 = HEAP32[i12 >> 2] | 0;
  }
  if (i1 >>> 0 < i4 >>> 0) if ((i3 | 0) > 0) continue; else {
   i2 = 9;
   break;
  } else {
   i2 = i4 + i13 | 0;
   HEAP32[i12 >> 2] = i2;
   i1 = i4 + i7 | 0;
   i6 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
   HEAP32[i14 >> 2] = i6;
   if ((i6 | 0) < (i11 | 0) & (i3 | 0) > 0) {
    i4 = i2;
    continue;
   } else {
    i2 = 9;
    break;
   }
  }
 }
 if ((i2 | 0) == 9) {
  STACKTOP = i15;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cv21ImageCodecInitializerD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 i3 = i7 + 12 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1) {
  i6 = i7 + 16 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i5 = i2 + -8 | 0;
    HEAP32[i6 >> 2] = i5;
    i4 = HEAP32[i5 >> 2] | 0;
    if ((i4 | 0) != 0 ? (i10 = i4 + 4 | 0, i9 = HEAP32[i10 >> 2] | 0, HEAP32[i10 >> 2] = i9 + -1, (i9 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] & 511](i4);
    HEAP32[i5 >> 2] = 0;
    HEAP32[i2 + -4 >> 2] = 0;
    i2 = HEAP32[i6 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i5 = i7 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -8 | 0;
   HEAP32[i5 >> 2] = i3;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) != 0 ? (i9 = i4 + 4 | 0, i6 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i6 + -1, (i6 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] & 511](i4);
   HEAP32[i3 >> 2] = 0;
   HEAP32[i2 + -4 >> 2] = 0;
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZN2cvL9cvt16u64fEPKtjPKhjPdjNS_5Size_IiEES4_(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, d15 = 0.0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 1;
 i8 = i6 >>> 3;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = (i9 | 0) > 3 ? i13 & -4 : 4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    i3 = i5 | 1;
    d15 = +(HEAPU16[i4 + (i3 << 1) >> 1] | 0);
    HEAPF64[i2 + (i5 << 3) >> 3] = +(HEAPU16[i4 + (i5 << 1) >> 1] | 0);
    HEAPF64[i2 + (i3 << 3) >> 3] = d15;
    i3 = i5 | 2;
    i10 = i5 | 3;
    d15 = +(HEAPU16[i4 + (i10 << 1) >> 1] | 0);
    HEAPF64[i2 + (i3 << 3) >> 3] = +(HEAPU16[i4 + (i3 << 1) >> 1] | 0);
    HEAPF64[i2 + (i10 << 3) >> 3] = d15;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   HEAPF64[i2 + (i5 << 3) >> 3] = +(HEAPU16[i4 + (i5 << 1) >> 1] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 3) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cvL9cvt32s64fEPKijPKhjPdjNS_5Size_IiEES4_(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, d15 = 0.0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 2;
 i8 = i6 >>> 3;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = (i9 | 0) > 3 ? i13 & -4 : 4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    i3 = i5 | 1;
    d15 = +(HEAP32[i4 + (i3 << 2) >> 2] | 0);
    HEAPF64[i2 + (i5 << 3) >> 3] = +(HEAP32[i4 + (i5 << 2) >> 2] | 0);
    HEAPF64[i2 + (i3 << 3) >> 3] = d15;
    i3 = i5 | 2;
    i10 = i5 | 3;
    d15 = +(HEAP32[i4 + (i10 << 2) >> 2] | 0);
    HEAPF64[i2 + (i3 << 3) >> 3] = +(HEAP32[i4 + (i3 << 2) >> 2] | 0);
    HEAPF64[i2 + (i10 << 3) >> 3] = d15;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   HEAPF64[i2 + (i5 << 3) >> 3] = +(HEAP32[i4 + (i5 << 2) >> 2] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 3) | 0;
   i4 = i4 + (i11 << 2) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cvL9cvt16s64fEPKsjPKhjPdjNS_5Size_IiEES4_(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, d15 = 0.0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 1;
 i8 = i6 >>> 3;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = (i9 | 0) > 3 ? i13 & -4 : 4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    i3 = i5 | 1;
    d15 = +(HEAP16[i4 + (i3 << 1) >> 1] | 0);
    HEAPF64[i2 + (i5 << 3) >> 3] = +(HEAP16[i4 + (i5 << 1) >> 1] | 0);
    HEAPF64[i2 + (i3 << 3) >> 3] = d15;
    i3 = i5 | 2;
    i10 = i5 | 3;
    d15 = +(HEAP16[i4 + (i10 << 1) >> 1] | 0);
    HEAPF64[i2 + (i3 << 3) >> 3] = +(HEAP16[i4 + (i3 << 1) >> 1] | 0);
    HEAPF64[i2 + (i10 << 3) >> 3] = d15;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   HEAPF64[i2 + (i5 << 3) >> 3] = +(HEAP16[i4 + (i5 << 1) >> 1] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 3) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cvL11copyMask32sEPKhjS1_jPhjNS_5Size_IiEEPv(i5, i14, i3, i13, i4, i12, i2, i1) {
 i5 = i5 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 i10 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + -4 | 0;
 i8 = (i7 | 0) < 0;
 i9 = i10 & -4;
 i6 = i2;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i8) i2 = 0; else {
   i1 = 0;
   do {
    if (HEAP8[i3 + i1 >> 0] | 0) HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i5 + (i1 << 2) >> 2];
    i2 = i1 | 1;
    if (HEAP8[i3 + i2 >> 0] | 0) HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
    i2 = i1 | 2;
    if (HEAP8[i3 + i2 >> 0] | 0) HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
    i2 = i1 | 3;
    if (HEAP8[i3 + i2 >> 0] | 0) HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) <= (i7 | 0));
   i2 = i9;
  }
  if ((i2 | 0) < (i10 | 0)) do {
   if (HEAP8[i3 + i2 >> 0] | 0) HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
  if (!i6) break; else {
   i3 = i3 + i13 | 0;
   i4 = i4 + i12 | 0;
   i5 = i5 + i14 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN2cv13AlgorithmInfo8addParamERNS_9AlgorithmEPKcRibMS1_FivEMS1_FviERKNS_6StringE(i7, i3, i5, i8, i6, i1, i2, i4) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i10 = i9 + 24 | 0;
 i11 = i9 + 16 | 0;
 i13 = i9 + 8 | 0;
 i12 = i9;
 i15 = i1 + 4 | 0;
 i15 = HEAPU8[i15 >> 0] | HEAPU8[i15 + 1 >> 0] << 8 | HEAPU8[i15 + 2 >> 0] << 16 | HEAPU8[i15 + 3 >> 0] << 24;
 i14 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 i2 = i2 + 4 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 HEAP32[i13 >> 2] = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
 HEAP32[i13 + 4 >> 2] = i15;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i12 + 4 >> 2] = i2;
 HEAP32[i11 + 0 >> 2] = HEAP32[i13 + 0 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 __ZN2cv13AlgorithmInfo9addParam_ERNS_9AlgorithmEPKciPvbMS1_KFivEMS1_FviERKNS_6StringE(i7, i3, i5, 0, i8, i6, i11, i10, i4);
 STACKTOP = i9;
 return;
}

function __ZN2cv13AlgorithmInfo8addParamERNS_9AlgorithmEPKcRdbMS1_FdvEMS1_FvdERKNS_6StringE(i7, i3, i5, i8, i6, i1, i2, i4) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i10 = i9 + 24 | 0;
 i11 = i9 + 16 | 0;
 i13 = i9 + 8 | 0;
 i12 = i9;
 i15 = i1 + 4 | 0;
 i15 = HEAPU8[i15 >> 0] | HEAPU8[i15 + 1 >> 0] << 8 | HEAPU8[i15 + 2 >> 0] << 16 | HEAPU8[i15 + 3 >> 0] << 24;
 i14 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 i2 = i2 + 4 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 HEAP32[i13 >> 2] = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
 HEAP32[i13 + 4 >> 2] = i15;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i12 + 4 >> 2] = i2;
 HEAP32[i11 + 0 >> 2] = HEAP32[i13 + 0 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 __ZN2cv13AlgorithmInfo9addParam_ERNS_9AlgorithmEPKciPvbMS1_KFivEMS1_FviERKNS_6StringE(i7, i3, i5, 2, i8, i6, i11, i10, i4);
 STACKTOP = i9;
 return;
}

function __ZN2cvL7cvt8u8sEPKhjS1_jPajNS_5Size_IiEEPd(i6, i12, i1, i2, i5, i11, i4, i3) {
 i6 = i6 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i10 = STACKTOP;
 i9 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 i1 = i9 + -4 | 0;
 i7 = (i1 | 0) < 0;
 i8 = i9 & -4;
 i2 = i6;
 i3 = i4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i7) i4 = 0; else {
   i4 = 0;
   do {
    i6 = HEAP8[i2 + i4 >> 0] | 0;
    i14 = i4 | 1;
    i15 = HEAP8[i2 + i14 >> 0] | 0;
    HEAP8[i5 + i4 >> 0] = i6 << 24 >> 24 < 0 ? 127 : i6;
    HEAP8[i5 + i14 >> 0] = i15 << 24 >> 24 < 0 ? 127 : i15;
    i14 = i4 | 2;
    i15 = HEAP8[i2 + i14 >> 0] | 0;
    i6 = i4 | 3;
    i13 = HEAP8[i2 + i6 >> 0] | 0;
    HEAP8[i5 + i14 >> 0] = i15 << 24 >> 24 < 0 ? 127 : i15;
    HEAP8[i5 + i6 >> 0] = i13 << 24 >> 24 < 0 ? 127 : i13;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) <= (i1 | 0));
   i4 = i8;
  }
  if ((i4 | 0) < (i9 | 0)) do {
   i6 = HEAP8[i2 + i4 >> 0] | 0;
   HEAP8[i5 + i4 >> 0] = i6 << 24 >> 24 < 0 ? 127 : i6;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i9 | 0));
  if (!i3) break; else {
   i5 = i5 + i11 | 0;
   i2 = i2 + i12 | 0;
  }
 }
 STACKTOP = i10;
 return;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_(i9, i2, i7) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 i5 = i2;
 i1 = HEAP8[i9 >> 0] | 0;
 if (!(i1 & 1)) {
  i8 = (i1 & 255) >>> 1;
  i3 = 1;
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i3 = (i1 & -2) + -1 | 0;
  i1 = i1 & 255;
 }
 i6 = i7 - i5 >> 2;
 if (!i6) {
  STACKTOP = i10;
  return i9 | 0;
 }
 if ((i3 - i8 | 0) >>> 0 < i6 >>> 0) {
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i9, i3, i8 + i6 - i3 | 0, i8, i8, 0, 0);
  i1 = HEAP8[i9 >> 0] | 0;
 }
 if (!(i1 & 1)) i4 = i9 + 4 | 0; else i4 = HEAP32[i9 + 8 >> 2] | 0;
 i1 = i4 + (i8 << 2) | 0;
 if ((i2 | 0) != (i7 | 0)) {
  i3 = i8 + ((i7 + -4 - i5 | 0) >>> 2) + 1 | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i7 | 0)) break; else i1 = i1 + 4 | 0;
  }
  i1 = i4 + (i3 << 2) | 0;
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + i6 | 0;
 if (!(HEAP8[i9 >> 0] & 1)) {
  HEAP8[i9 >> 0] = i1 << 1;
  STACKTOP = i10;
  return i9 | 0;
 } else {
  HEAP32[i9 + 4 >> 2] = i1;
  STACKTOP = i10;
  return i9 | 0;
 }
 return 0;
}

function __ZN12_GLOBAL__N_110CLAHE_Impl14collectGarbageEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 i2 = i4 + 24 | 0;
 i1 = i4 + 60 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i2);
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 40 | 0;
 i3 = i4 + 28 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 64 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i2 = i4 + 80 | 0;
 i1 = i4 + 116 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i2);
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 96 | 0;
 i3 = i4 + 84 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) <= 0) {
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[i4 + 120 >> 2] | 0;
 i2 = 0;
 do {
  HEAP32[i1 + (i2 << 2) >> 2] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
 STACKTOP = i5;
 return;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEErsERi(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i2 = i10 + 28 | 0;
 i1 = i10 + 24 | 0;
 i3 = i10 + 20 | 0;
 i4 = i10 + 16 | 0;
 i11 = i10 + 32 | 0;
 i6 = i10 + 12 | 0;
 i8 = i10 + 8 | 0;
 i5 = i10 + 4 | 0;
 __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6sentryC2ERS3_b(i11, i9, 0);
 if (!(HEAP8[i11 >> 0] | 0)) {
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i6 >> 2] = 0;
 __ZNSt3__16localeC2ERKS0_(i5, i9 + ((HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 28) | 0);
 i12 = __ZNKSt3__16locale9use_facetERNS0_2idE(i5, 959232) | 0;
 i11 = HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0;
 i13 = HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i9 + (i11 + 24) >> 2];
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
 FUNCTION_TABLE_viiiiiii[i13 & 63](i10, i12, i1, i2, i9 + i11 | 0, i6, i8);
 __ZNSt3__16localeD2Ev(i5);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i9 + i8 | 0, HEAP32[i9 + (i8 + 16) >> 2] | HEAP32[i6 >> 2]);
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN2cvL8cvt8u32fEPKhjS1_jPfjNS_5Size_IiEEPd(i10, i13, i1, i2, i6, i5, i4, i3) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5 >>> 2;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i1 = i11 & -4;
 i2 = i6;
 i3 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    f14 = Math_fround(HEAPU8[i3 + i5 >> 0] | 0);
    i6 = i5 | 1;
    f15 = Math_fround(HEAPU8[i3 + i6 >> 0] | 0);
    HEAPF32[i2 + (i5 << 2) >> 2] = f14;
    HEAPF32[i2 + (i6 << 2) >> 2] = f15;
    i6 = i5 | 2;
    f15 = Math_fround(HEAPU8[i3 + i6 >> 0] | 0);
    i10 = i5 | 3;
    f14 = Math_fround(HEAPU8[i3 + i10 >> 0] | 0);
    HEAPF32[i2 + (i6 << 2) >> 2] = f15;
    HEAPF32[i2 + (i10 << 2) >> 2] = f14;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i1;
  }
  if ((i5 | 0) < (i11 | 0)) do {
   HEAPF32[i2 + (i5 << 2) >> 2] = Math_fround(HEAPU8[i3 + i5 >> 0] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
  if (!i4) break; else {
   i2 = i2 + (i7 << 2) | 0;
   i3 = i3 + i13 | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function _deflateEnd(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 if (!i4) {
  i1 = -2;
  STACKTOP = i7;
  return i1 | 0;
 }
 i5 = i4 + 28 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = -2;
  STACKTOP = i7;
  return i1 | 0;
 }
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 switch (i6 | 0) {
 case 42:
 case 69:
 case 73:
 case 91:
 case 103:
 case 113:
 case 666:
  break;
 default:
  {
   i1 = -2;
   STACKTOP = i7;
   return i1 | 0;
  }
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2) {
  FUNCTION_TABLE_vii[HEAP32[i4 + 36 >> 2] & 127](HEAP32[i4 + 40 >> 2] | 0, i2);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 if (i2) {
  FUNCTION_TABLE_vii[HEAP32[i4 + 36 >> 2] & 127](HEAP32[i4 + 40 >> 2] | 0, i2);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 64 >> 2] | 0;
 if (i2) {
  FUNCTION_TABLE_vii[HEAP32[i4 + 36 >> 2] & 127](HEAP32[i4 + 40 >> 2] | 0, i2);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 i3 = i4 + 36 | 0;
 if (!i2) i2 = i4 + 40 | 0; else {
  i1 = i4 + 40 | 0;
  FUNCTION_TABLE_vii[HEAP32[i3 >> 2] & 127](HEAP32[i1 >> 2] | 0, i2);
  i2 = i1;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 FUNCTION_TABLE_vii[HEAP32[i3 >> 2] & 127](HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i5 >> 2] = 0;
 i1 = (i6 | 0) == 113 ? -3 : 0;
 STACKTOP = i7;
 return i1 | 0;
}

function _cvWriteInt(i7, i8, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i10 + 8 | 0;
 i6 = i10;
 i1 = (i7 | 0) != 0;
 if (!(i1 ? (HEAP32[i7 >> 2] | 0) == 1280131417 : 0)) {
  i1 = i1 ? -5 : -27;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i5, 31) | 0) + 0 | 0;
  i3 = 9096 | 0;
  i4 = i2 + 31 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i1, i5, 10008, 8960, 2932);
  __ZN2cv6String10deallocateEv(i5);
 }
 if (HEAP32[i7 + 8 >> 2] | 0) {
  i1 = i7 + 236 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  FUNCTION_TABLE_viii[i1 & 63](i7, i8, i9);
  STACKTOP = i10;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i6, 38) | 0) + 0 | 0;
 i3 = 9944 | 0;
 i4 = i2 + 38 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i6, 10008, 8960, 2932);
 __ZN2cv6String10deallocateEv(i6);
 i1 = i7 + 236 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 FUNCTION_TABLE_viii[i1 & 63](i7, i8, i9);
 STACKTOP = i10;
 return;
}

function __ZN2cvL8cvt8s32fEPKajPKhjPfjNS_5Size_IiEEPd(i10, i13, i1, i2, i6, i5, i4, i3) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5 >>> 2;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i1 = i11 & -4;
 i2 = i6;
 i3 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    f14 = Math_fround(HEAP8[i3 + i5 >> 0] | 0);
    i6 = i5 | 1;
    f15 = Math_fround(HEAP8[i3 + i6 >> 0] | 0);
    HEAPF32[i2 + (i5 << 2) >> 2] = f14;
    HEAPF32[i2 + (i6 << 2) >> 2] = f15;
    i6 = i5 | 2;
    f15 = Math_fround(HEAP8[i3 + i6 >> 0] | 0);
    i10 = i5 | 3;
    f14 = Math_fround(HEAP8[i3 + i10 >> 0] | 0);
    HEAPF32[i2 + (i6 << 2) >> 2] = f15;
    HEAPF32[i2 + (i10 << 2) >> 2] = f14;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i1;
  }
  if ((i5 | 0) < (i11 | 0)) do {
   HEAPF32[i2 + (i5 << 2) >> 2] = Math_fround(HEAP8[i3 + i5 >> 0] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
  if (!i4) break; else {
   i2 = i2 + (i7 << 2) | 0;
   i3 = i3 + i13 | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZN2cvL7cvt8s8uEPKajPKhjPhjNS_5Size_IiEEPd(i6, i12, i1, i2, i5, i11, i4, i3) {
 i6 = i6 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i10 = STACKTOP;
 i9 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 i1 = i9 + -4 | 0;
 i7 = (i1 | 0) < 0;
 i8 = i9 & -4;
 i2 = i6;
 i3 = i4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i7) i4 = 0; else {
   i4 = 0;
   do {
    i6 = HEAP8[i2 + i4 >> 0] | 0;
    i14 = i4 | 1;
    i15 = HEAP8[i2 + i14 >> 0] | 0;
    HEAP8[i5 + i4 >> 0] = i6 << 24 >> 24 < 0 ? 0 : i6;
    HEAP8[i5 + i14 >> 0] = i15 << 24 >> 24 < 0 ? 0 : i15;
    i14 = i4 | 2;
    i15 = HEAP8[i2 + i14 >> 0] | 0;
    i6 = i4 | 3;
    i13 = HEAP8[i2 + i6 >> 0] | 0;
    HEAP8[i5 + i14 >> 0] = i15 << 24 >> 24 < 0 ? 0 : i15;
    HEAP8[i5 + i6 >> 0] = i13 << 24 >> 24 < 0 ? 0 : i13;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) <= (i1 | 0));
   i4 = i8;
  }
  if ((i4 | 0) < (i9 | 0)) do {
   i6 = HEAP8[i2 + i4 >> 0] | 0;
   HEAP8[i5 + i4 >> 0] = i6 << 24 >> 24 < 0 ? 0 : i6;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i9 | 0));
  if (!i3) break; else {
   i5 = i5 + i11 | 0;
   i2 = i2 + i12 | 0;
  }
 }
 STACKTOP = i10;
 return;
}

function _cvWriteReal(i7, i8, d9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 d9 = +d9;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i10 + 8 | 0;
 i6 = i10;
 i1 = (i7 | 0) != 0;
 if (!(i1 ? (HEAP32[i7 >> 2] | 0) == 1280131417 : 0)) {
  i1 = i1 ? -5 : -27;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i5, 31) | 0) + 0 | 0;
  i3 = 9096 | 0;
  i4 = i2 + 31 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i1, i5, 10024, 8960, 2940);
  __ZN2cv6String10deallocateEv(i5);
 }
 if (HEAP32[i7 + 8 >> 2] | 0) {
  i1 = i7 + 240 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  FUNCTION_TABLE_viid[i1 & 3](i7, i8, d9);
  STACKTOP = i10;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i6, 38) | 0) + 0 | 0;
 i3 = 9944 | 0;
 i4 = i2 + 38 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i6, 10024, 8960, 2940);
 __ZN2cv6String10deallocateEv(i6);
 i1 = i7 + 240 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 FUNCTION_TABLE_viid[i1 & 3](i7, i8, d9);
 STACKTOP = i10;
 return;
}

function __ZNK2cv11MatOp_AddEx3absERKNS_7MatExprERS1_(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, d9 = 0.0, d10 = 0.0, d11 = 0.0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i1 = i6;
 i2 = i7 + 64 | 0;
 i3 = (HEAP32[i7 + 80 >> 2] | 0) == 0;
 if (!i3 ? !(+HEAPF64[i7 + 184 >> 3] == 0.0) : 0) i5 = 6; else i5 = 3;
 do if ((i5 | 0) == 3) {
  d4 = +HEAPF64[i7 + 176 >> 3];
  if (!(+Math_abs(+d4) == 1.0)) if (i3) break; else {
   i5 = 6;
   break;
  }
  d11 = -(d4 * +HEAPF64[i7 + 192 >> 3]);
  d10 = -(d4 * +HEAPF64[i7 + 200 >> 3]);
  d9 = -(d4 * +HEAPF64[i7 + 208 >> 3]);
  d4 = -(d4 * +HEAPF64[i7 + 216 >> 3]);
  i2 = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAPF64[i1 >> 3] = d11;
  HEAPF64[i1 + 8 >> 3] = d10;
  HEAPF64[i1 + 16 >> 3] = d9;
  HEAPF64[i1 + 24 >> 3] = d4;
  __ZN2cv9MatOp_Bin8makeExprERNS_7MatExprEcRKNS_3MatERKNS_7Scalar_IdEE(i8, 97, i7 + 8 | 0, i1);
  STACKTOP = i6;
  return;
 } while (0);
 if ((i5 | 0) == 6 ? (d9 = +HEAPF64[i7 + 176 >> 3], d4 = +HEAPF64[i7 + 184 >> 3], d9 + d4 == 0.0 & d9 * d4 == -1.0) : 0) {
  __ZN2cv9MatOp_Bin8makeExprERNS_7MatExprEcRKNS_3MatES5_d(i8, 97, i7 + 8 | 0, i2, 1.0);
  STACKTOP = i6;
  return;
 }
 __ZNK2cv5MatOp3absERKNS_7MatExprERS1_(0, i7, i8);
 STACKTOP = i6;
 return;
}

function __ZNSt3__16vectorIxNS_9allocatorIxEEE21__push_back_slow_pathIKxEEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((HEAP32[i8 >> 2] | 0) - i1 >> 3) + 1 | 0;
 if (i3 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i9 = i10 + 8 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
 if (i2 >> 3 >>> 0 < 268435455) {
  i2 = i2 >> 2;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 3;
  if (!i2) {
   i5 = 0;
   i4 = 0;
   i3 = i1;
  } else i6 = 6;
 } else {
  i2 = 536870911;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 3;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i5 = i2;
  i4 = __Znwj(i2 << 3) | 0;
  i3 = i1;
 }
 i2 = i4 + (i3 << 3) | 0;
 if (i2) {
  i1 = i7;
  i6 = HEAP32[i1 + 4 >> 2] | 0;
  i7 = i2;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i7 = i4 + (i3 - (i6 >> 3) << 3) | 0;
 _memcpy(i7 | 0, i1 | 0, i6 | 0) | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i4 + (i3 + 1 << 3);
 HEAP32[i9 >> 2] = i4 + (i5 << 3);
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function _cvReleaseHist(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i7 + 8 | 0;
 i4 = i7;
 if (!i5) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 701768, 701600, 2562);
  __ZN2cv6String10deallocateEv(i1);
 }
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 if (!((HEAP32[i6 >> 2] & -65536 | 0) == 1111818240 ? (i2 = i6 + 4 | 0, (HEAP32[i2 >> 2] | 0) != 0) : 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i4, 24) | 0) + 0 | 0;
  i1 = 701784 | 0;
  i3 = i2 + 24 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i4, 701768, 701600, 2569);
  __ZN2cv6String10deallocateEv(i4);
  i2 = i6 + 4 | 0;
 }
 HEAP32[i5 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (HEAP32[i1 >> 2] & -65536 | 0) == 1111752704 : 0) _cvReleaseSparseMat(i2); else {
  _cvReleaseData(i1);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i6 + 264 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  _cvFree_(i2);
  HEAP32[i1 >> 2] = 0;
 }
 _cvFree_(i6);
 STACKTOP = i7;
 return;
}

function __ZN2cvL13minMaxIdx_32sEPKiPKhPiS4_PjS5_ij(i9, i7, i14, i12, i13, i11, i8, i10) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i15 = STACKTOP;
 i1 = HEAP32[i14 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i3 = (i8 | 0) > 0;
 if (!i7) if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   i7 = HEAP32[i9 + (i6 << 2) >> 2] | 0;
   i5 = (i7 | 0) < (i1 | 0);
   i16 = i6 + i10 | 0;
   i2 = i5 ? i16 : i2;
   i1 = i5 ? i7 : i1;
   i5 = (i7 | 0) > (i4 | 0);
   i3 = i5 ? i16 : i3;
   i4 = i5 ? i7 : i4;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5; else if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   i5 = HEAP32[i9 + (i6 << 2) >> 2] | 0;
   i16 = (HEAP8[i7 + i6 >> 0] | 0) != 0;
   i18 = i16 & (i5 | 0) < (i1 | 0);
   i17 = i6 + i10 | 0;
   i2 = i18 ? i17 : i2;
   i1 = i18 ? i5 : i1;
   i16 = i16 & (i5 | 0) > (i4 | 0);
   i3 = i16 ? i17 : i3;
   i4 = i16 ? i5 : i4;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i12 >> 2] = i4;
 STACKTOP = i15;
 return;
}

function __ZN2cvL13minMaxIdx_32fEPKfPKhPfS4_PjS5_ij(i9, i7, i14, i12, i13, i11, i8, i10) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var f1 = f0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i15 = 0, f16 = f0, i17 = 0, i18 = 0;
 i15 = STACKTOP;
 f1 = Math_fround(HEAPF32[i14 >> 2]);
 f4 = Math_fround(HEAPF32[i12 >> 2]);
 i2 = HEAP32[i13 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i3 = (i8 | 0) > 0;
 if (!i7) if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   f16 = Math_fround(HEAPF32[i9 + (i6 << 2) >> 2]);
   i7 = f16 < f1;
   i5 = i6 + i10 | 0;
   i2 = i7 ? i5 : i2;
   f1 = i7 ? f16 : f1;
   i7 = f16 > f4;
   i3 = i7 ? i5 : i3;
   f4 = i7 ? f16 : f4;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5; else if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   f16 = Math_fround(HEAPF32[i9 + (i6 << 2) >> 2]);
   i5 = (HEAP8[i7 + i6 >> 0] | 0) != 0;
   i18 = i5 & f16 < f1;
   i17 = i6 + i10 | 0;
   i2 = i18 ? i17 : i2;
   f1 = i18 ? f16 : f1;
   i5 = i5 & f16 > f4;
   i3 = i5 ? i17 : i3;
   f4 = i5 ? f16 : f4;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i11 >> 2] = i3;
 HEAPF32[i14 >> 2] = f1;
 HEAPF32[i12 >> 2] = f4;
 STACKTOP = i15;
 return;
}

function __ZN6cvtest2TS14update_contextEPNS_8BaseTestEib(i6, i4, i5, i7) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i8;
 i2 = i6 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i4 | 0)) {
  i3 = 0;
  do {
   HEAP32[i1 + 0 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i6 + (i3 * 12 | 0) + 88 | 0, i1) | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < 4);
  i3 = i6 + 64 | 0;
  i9 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = (i9 | 0) != 0 | (i3 | 0) != 0;
  i9 = i1 ? i9 : -1;
  i3 = i1 ? i3 : 0;
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i6 + 24 | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i6 + 32 | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i1 + 4 >> 2] = i3;
 }
 HEAP32[i2 >> 2] = i4;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 20 >> 2] = 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 i3 = i6 + 8 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i6 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 STACKTOP = i8;
 return;
}

function __ZN2cvL13minMaxIdx_16uEPKtPKhPiS4_PjS5_ij(i9, i7, i14, i12, i13, i11, i8, i10) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i15 = STACKTOP;
 i1 = HEAP32[i14 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i3 = (i8 | 0) > 0;
 if (!i7) if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   i7 = HEAPU16[i9 + (i6 << 1) >> 1] | 0;
   i5 = (i7 | 0) < (i1 | 0);
   i16 = i6 + i10 | 0;
   i2 = i5 ? i16 : i2;
   i1 = i5 ? i7 : i1;
   i5 = (i7 | 0) > (i4 | 0);
   i3 = i5 ? i16 : i3;
   i4 = i5 ? i7 : i4;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5; else if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   if (HEAP8[i7 + i6 >> 0] | 0) {
    i5 = HEAPU16[i9 + (i6 << 1) >> 1] | 0;
    i16 = (i5 | 0) < (i1 | 0);
    i17 = i6 + i10 | 0;
    i18 = (i5 | 0) > (i4 | 0);
    i3 = i18 ? i17 : i3;
    i4 = i18 ? i5 : i4;
    i2 = i16 ? i17 : i2;
    i1 = i16 ? i5 : i1;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i12 >> 2] = i4;
 STACKTOP = i15;
 return;
}

function __ZN2cvL13minMaxIdx_16sEPKsPKhPiS4_PjS5_ij(i9, i7, i14, i12, i13, i11, i8, i10) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i15 = STACKTOP;
 i1 = HEAP32[i14 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i3 = (i8 | 0) > 0;
 if (!i7) if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   i7 = HEAP16[i9 + (i6 << 1) >> 1] | 0;
   i5 = (i7 | 0) < (i1 | 0);
   i16 = i6 + i10 | 0;
   i2 = i5 ? i16 : i2;
   i1 = i5 ? i7 : i1;
   i5 = (i7 | 0) > (i4 | 0);
   i3 = i5 ? i16 : i3;
   i4 = i5 ? i7 : i4;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5; else if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   if (HEAP8[i7 + i6 >> 0] | 0) {
    i5 = HEAP16[i9 + (i6 << 1) >> 1] | 0;
    i16 = (i5 | 0) < (i1 | 0);
    i17 = i6 + i10 | 0;
    i18 = (i5 | 0) > (i4 | 0);
    i3 = i18 ? i17 : i3;
    i4 = i18 ? i5 : i4;
    i2 = i16 ? i17 : i2;
    i1 = i16 ? i5 : i1;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i12 >> 2] = i4;
 STACKTOP = i15;
 return;
}

function __ZN2cvL9cvt16u32sEPKtjPKhjPijNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 1;
 i8 = i6 >>> 2;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = i13 & -4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    i12 = i5 | 1;
    i10 = HEAPU16[i4 + (i12 << 1) >> 1] | 0;
    HEAP32[i2 + (i5 << 2) >> 2] = HEAPU16[i4 + (i5 << 1) >> 1];
    HEAP32[i2 + (i12 << 2) >> 2] = i10;
    i12 = i5 | 2;
    i10 = i5 | 3;
    i3 = HEAPU16[i4 + (i10 << 1) >> 1] | 0;
    HEAP32[i2 + (i12 << 2) >> 2] = HEAPU16[i4 + (i12 << 1) >> 1];
    HEAP32[i2 + (i10 << 2) >> 2] = i3;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   HEAP32[i2 + (i5 << 2) >> 2] = HEAPU16[i4 + (i5 << 1) >> 1];
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 2) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cvL15copyMaskGenericEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i15, i2, i13, i4, i12, i14, i1) {
 i3 = i3 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0;
 i16 = STACKTOP;
 i9 = HEAP32[i1 >> 2] | 0;
 i10 = i14 + 4 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i8 + -1;
 if (!i8) {
  STACKTOP = i16;
  return;
 }
 i11 = (i9 | 0) == 0;
 i8 = i4;
 i1 = HEAP32[i14 >> 2] | 0;
 while (1) {
  L6 : do if ((i1 | 0) > 0) {
   if (i11) {
    i4 = 0;
    while (1) {
     i4 = i4 + 1 | 0;
     if ((i4 | 0) >= (i1 | 0)) break L6;
    }
   } else {
    i5 = i8;
    i6 = i3;
    i7 = 0;
   }
   while (1) {
    if (HEAP8[i2 + i7 >> 0] | 0) {
     i4 = 0;
     do {
      HEAP8[i5 + i4 >> 0] = HEAP8[i6 + i4 >> 0] | 0;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i9 | 0));
     i1 = HEAP32[i14 >> 2] | 0;
    }
    i7 = i7 + 1 | 0;
    if ((i7 | 0) >= (i1 | 0)) break; else {
     i5 = i5 + i9 | 0;
     i6 = i6 + i9 | 0;
    }
   }
  } while (0);
  i7 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i7 + -1;
  if (!i7) break; else {
   i2 = i2 + i13 | 0;
   i3 = i3 + i15 | 0;
   i8 = i8 + i12 | 0;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN2cvL12minMaxIdx_8uEPKhS1_PiS2_PjS3_ij(i9, i7, i14, i12, i13, i11, i8, i10) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i15 = STACKTOP;
 i1 = HEAP32[i14 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i3 = (i8 | 0) > 0;
 if (!i7) if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   i7 = HEAPU8[i9 + i6 >> 0] | 0;
   i5 = (i7 | 0) < (i1 | 0);
   i16 = i6 + i10 | 0;
   i2 = i5 ? i16 : i2;
   i1 = i5 ? i7 : i1;
   i5 = (i7 | 0) > (i4 | 0);
   i3 = i5 ? i16 : i3;
   i4 = i5 ? i7 : i4;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5; else if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   if (HEAP8[i7 + i6 >> 0] | 0) {
    i5 = HEAPU8[i9 + i6 >> 0] | 0;
    i16 = (i5 | 0) < (i1 | 0);
    i17 = i6 + i10 | 0;
    i18 = (i5 | 0) > (i4 | 0);
    i3 = i18 ? i17 : i3;
    i4 = i18 ? i5 : i4;
    i2 = i16 ? i17 : i2;
    i1 = i16 ? i5 : i1;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i12 >> 2] = i4;
 STACKTOP = i15;
 return;
}

function __ZN2cvL12minMaxIdx_8sEPKaPKhPiS4_PjS5_ij(i9, i7, i14, i12, i13, i11, i8, i10) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i15 = STACKTOP;
 i1 = HEAP32[i14 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i3 = (i8 | 0) > 0;
 if (!i7) if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   i7 = HEAP8[i9 + i6 >> 0] | 0;
   i5 = (i7 | 0) < (i1 | 0);
   i16 = i6 + i10 | 0;
   i2 = i5 ? i16 : i2;
   i1 = i5 ? i7 : i1;
   i5 = (i7 | 0) > (i4 | 0);
   i3 = i5 ? i16 : i3;
   i4 = i5 ? i7 : i4;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5; else if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   if (HEAP8[i7 + i6 >> 0] | 0) {
    i5 = HEAP8[i9 + i6 >> 0] | 0;
    i16 = (i5 | 0) < (i1 | 0);
    i17 = i6 + i10 | 0;
    i18 = (i5 | 0) > (i4 | 0);
    i3 = i18 ? i17 : i3;
    i4 = i18 ? i5 : i4;
    i2 = i16 ? i17 : i2;
    i1 = i16 ? i5 : i1;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i12 >> 2] = i4;
 STACKTOP = i15;
 return;
}

function __ZN2cvL9cvt16s32sEPKsjPKhjPijNS_5Size_IiEEPd(i12, i5, i1, i2, i10, i6, i4, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i5 >>> 1;
 i8 = i6 >>> 2;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i9 = i13 + -4 | 0;
 i1 = (i9 | 0) < 0;
 i7 = i13 & -4;
 i2 = i10;
 i4 = i12;
 i6 = i3;
 while (1) {
  i6 = i6 + -1 | 0;
  if (i1) i5 = 0; else {
   i5 = 0;
   do {
    i12 = i5 | 1;
    i10 = HEAP16[i4 + (i12 << 1) >> 1] | 0;
    HEAP32[i2 + (i5 << 2) >> 2] = HEAP16[i4 + (i5 << 1) >> 1];
    HEAP32[i2 + (i12 << 2) >> 2] = i10;
    i12 = i5 | 2;
    i10 = i5 | 3;
    i3 = HEAP16[i4 + (i10 << 1) >> 1] | 0;
    HEAP32[i2 + (i12 << 2) >> 2] = HEAP16[i4 + (i12 << 1) >> 1];
    HEAP32[i2 + (i10 << 2) >> 2] = i3;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i9 | 0));
   i5 = i7;
  }
  if ((i5 | 0) < (i13 | 0)) do {
   HEAP32[i2 + (i5 << 2) >> 2] = HEAP16[i4 + (i5 << 1) >> 1];
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  if (!i6) break; else {
   i2 = i2 + (i8 << 2) | 0;
   i4 = i4 + (i11 << 1) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZNSt3__16vectorIPN7testing8internal29ParameterizedTestCaseInfoBaseENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((HEAP32[i8 >> 2] | 0) - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i9 = i10 + 8 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
 if (i2 >> 2 >>> 0 < 536870911) {
  i2 = i2 >> 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  if (!i2) {
   i5 = 0;
   i4 = 0;
   i3 = i1;
  } else i6 = 6;
 } else {
  i2 = 1073741823;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i5 = i2;
  i4 = __Znwj(i2 << 2) | 0;
  i3 = i1;
 }
 i2 = i4 + (i3 << 2) | 0;
 if (i2) HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i7 = i4 + (i3 - (i6 >> 2) << 2) | 0;
 _memcpy(i7 | 0, i1 | 0, i6 | 0) | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i4 + (i3 + 1 << 2);
 HEAP32[i9 >> 2] = i4 + (i5 << 2);
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function ___cxx_global_array_dtor112(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968228 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968216 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968204 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968192 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968180 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968168 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968156 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968144 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968132 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968120 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968108 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968096 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968084 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(968072);
 STACKTOP = i1;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueERS5_E4typeES9_S9_(i9, i5, i8) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 i3 = i5;
 i1 = HEAP8[i9 >> 0] | 0;
 if (!(i1 & 1)) {
  i7 = (i1 & 255) >>> 1;
  i2 = 10;
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = HEAP32[i9 + 4 >> 2] | 0;
  i2 = (i1 & -2) + -1 | 0;
  i1 = i1 & 255;
 }
 i6 = i8 - i3 | 0;
 if ((i8 | 0) == (i5 | 0)) {
  STACKTOP = i10;
  return i9 | 0;
 }
 if ((i2 - i7 | 0) >>> 0 < i6 >>> 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i9, i2, i7 + i6 - i2 | 0, i7, i7, 0, 0);
  i1 = HEAP8[i9 >> 0] | 0;
 }
 if (!(i1 & 1)) i4 = i9 + 1 | 0; else i4 = HEAP32[i9 + 8 >> 2] | 0;
 i3 = i8 + (i7 - i3) | 0;
 i1 = i5;
 i2 = i4 + i7 | 0;
 while (1) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i8 | 0)) break; else i2 = i2 + 1 | 0;
 }
 HEAP8[i4 + i3 >> 0] = 0;
 i1 = i7 + i6 | 0;
 if (!(HEAP8[i9 >> 0] & 1)) {
  HEAP8[i9 >> 0] = i1 << 1;
  STACKTOP = i10;
  return i9 | 0;
 } else {
  HEAP32[i9 + 4 >> 2] = i1;
  STACKTOP = i10;
  return i9 | 0;
 }
 return 0;
}

function ___cxx_global_array_dtor97(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967692 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967680 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967668 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967656 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967644 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967632 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967620 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967608 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967596 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967584 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967572 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967560 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967548 | 0);
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(967536);
 STACKTOP = i1;
 return;
}

function __ZNSt3__16vectorIN2cv3MatENS_9allocatorIS2_EEE10deallocateEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i6 = i7 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i4 = i2 + -56 | 0;
   HEAP32[i6 >> 2] = i4;
   i3 = i2 + -20 | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   if ((i5 | 0) != 0 ? (i9 = i5 + 12 | 0, i5 = HEAP32[i9 >> 2] | 0, HEAP32[i9 >> 2] = i5 + -1, (i5 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i4);
   HEAP32[i3 >> 2] = 0;
   i4 = i2 + -40 | 0;
   i3 = i2 + -52 | 0;
   HEAP32[i4 + 0 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i4 = HEAP32[i2 + -16 >> 2] | 0;
    i5 = 0;
    do {
     HEAP32[i4 + (i5 << 2) >> 2] = 0;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) < (HEAP32[i3 >> 2] | 0));
   }
   i3 = HEAP32[i2 + -12 >> 2] | 0;
   if ((i3 | 0) != (i2 + -8 | 0)) __ZN2cv8fastFreeEPv(i3);
   i2 = HEAP32[i6 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __ZdlPv(i1);
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function _cvEndWriteStruct(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i8 + 8 | 0;
 i6 = i8;
 i1 = (i7 | 0) != 0;
 if (!(i1 ? (HEAP32[i7 >> 2] | 0) == 1280131417 : 0)) {
  i1 = i1 ? -5 : -27;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i5, 31) | 0) + 0 | 0;
  i3 = 9096 | 0;
  i4 = i2 + 31 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i1, i5, 9984, 8960, 2924);
  __ZN2cv6String10deallocateEv(i5);
 }
 if (HEAP32[i7 + 8 >> 2] | 0) {
  i1 = i7 + 232 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  FUNCTION_TABLE_vi[i1 & 511](i7);
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i6, 38) | 0) + 0 | 0;
 i3 = 9944 | 0;
 i4 = i2 + 38 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i6, 9984, 8960, 2924);
 __ZN2cv6String10deallocateEv(i6);
 i1 = i7 + 232 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 FUNCTION_TABLE_vi[i1 & 511](i7);
 STACKTOP = i8;
 return;
}

function _MUSL_vfprintf(i13, i9, i1) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 i8 = i14 + 120 | 0;
 i12 = i14 + 80 | 0;
 i11 = i14;
 i10 = i14 + 136 | 0;
 i2 = i12 + 0 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 if ((_printf_core(0, i9, i8, i11, i12) | 0) < 0) {
  i10 = -1;
  STACKTOP = i14;
  return i10 | 0;
 }
 i2 = i13 + 48 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i4 = i13 + 44 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i10;
  i6 = i13 + 28 | 0;
  HEAP32[i6 >> 2] = i10;
  i7 = i13 + 20 | 0;
  HEAP32[i7 >> 2] = i10;
  HEAP32[i2 >> 2] = 80;
  i3 = i13 + 16 | 0;
  HEAP32[i3 >> 2] = i10 + 80;
  i1 = _printf_core(i13, i9, i8, i11, i12) | 0;
  if (i5) {
   FUNCTION_TABLE_iiii[HEAP32[i13 + 36 >> 2] & 63](i13, 0, 0) | 0;
   i1 = (HEAP32[i7 >> 2] | 0) == 0 ? -1 : i1;
   HEAP32[i4 >> 2] = i5;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
 } else i1 = _printf_core(i13, i9, i8, i11, i12) | 0;
 i10 = i1;
 STACKTOP = i14;
 return i10 | 0;
}

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i7 = i9;
 i4 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 if (i4 - i1 >> 2 >>> 0 >= i6 >>> 0) {
  __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj(i8, i6);
  STACKTOP = i9;
  return;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i5 = i1 - i2 >> 2;
 i3 = i5 + i6 | 0;
 if (i3 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i8);
 i1 = i4 - i2 | 0;
 if (i1 >> 2 >>> 0 < 536870911) {
  i1 = i1 >> 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
 } else i1 = 1073741823;
 __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC2EjjS6_(i7, i1, i5, i8 + 16 | 0);
 __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj(i7, i6);
 __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i7);
 __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED2Ev(i7);
 STACKTOP = i9;
 return;
}

function __ZNK2cv11_InputArray12getOGlBufferEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i7;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1) | 0) != 458752) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i2, 18) | 0) + 0 | 0;
  i4 = 29160 | 0;
  i5 = i3 + 18 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i2, 29184, 27528, 1423);
  __ZN2cv6String10deallocateEv(i2);
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 if (!i1) {
  i1 = i6 + 8 | 0;
  i2 = i2 + 8 | 0;
  HEAP32[i1 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  STACKTOP = i7;
  return;
 }
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i6 + 8 | 0;
 i2 = i2 + 8 | 0;
 HEAP32[i1 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 STACKTOP = i7;
 return;
}

function __ZNSt3__112system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5, i3, i6) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i7;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1) {
  i2 = HEAP8[i6 >> 0] | 0;
  if (!(i2 & 1)) i2 = (i2 & 255) >>> 1; else i2 = HEAP32[i6 + 4 >> 2] | 0;
  if (i2) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i6, 957640) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 63](i4, i2, i1);
  i1 = HEAP8[i4 >> 0] | 0;
  if (!(i1 & 1)) {
   i2 = i4 + 1 | 0;
   i1 = (i1 & 255) >>> 1;
  } else {
   i2 = HEAP32[i4 + 8 >> 2] | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, i2, i1) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 };
 HEAP32[i5 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN7testing8TestCaseD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 HEAP32[i6 >> 2] = 161968;
 i4 = i6 + 20 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i5 = i6 + 24 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) do {
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3) {
   __ZN7testing8TestInfoD2Ev(i3);
   __ZdlPv(i3);
  }
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i1 | 0));
 __ZN7testing10TestResultD2Ev(i6 + 64 | 0);
 i2 = HEAP32[i6 + 32 >> 2] | 0;
 if (i2) {
  i1 = i6 + 36 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2) {
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) HEAP32[i5 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 i1 = i6 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i1 = i6 + 4 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
  STACKTOP = i7;
  return;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 i1 = i6 + 4 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 STACKTOP = i7;
 return;
}

function __ZN4perf8TestBase14_declareHelper10iterationsEj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 i2 = HEAP32[i10 >> 2] | 0;
 i7 = i2 + 36 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i8 = i2 + 40 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = i6;
 if ((i3 | 0) == (i6 | 0)) i3 = i6; else {
  i3 = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3) | 0;
  HEAP32[i8 >> 2] = i3;
 }
 i5 = i2 + 44 | 0;
 if ((HEAP32[i5 >> 2] | 0) - i1 >> 3 >>> 0 < i9 >>> 0) {
  i1 = i3 - i1 >> 3;
  if (!i9) {
   i4 = 0;
   i2 = i3;
   i3 = i6;
  } else {
   i4 = __Znwj(i9 << 3) | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
  }
  i2 = i2 - i3 | 0;
  i6 = i4 + (i1 - (i2 >> 3) << 3) | 0;
  _memcpy(i6 | 0, i3 | 0, i2 | 0) | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i4 + (i1 << 3);
  HEAP32[i5 >> 2] = i4 + (i9 << 3);
  if (i3) __ZdlPv(i3);
 }
 i1 = HEAP32[42408] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i2 + 76 >> 2] = i1 >>> 0 < i9 >>> 0 ? i1 : i9;
 HEAP32[i2 + 80 >> 2] = -1;
 i1 = i2 + 168 | 0;
 i2 = i2 + 96 | 0;
 i3 = i2 + 72 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = -1;
 STACKTOP = i11;
 return i10 | 0;
}

function __Z13FillColorRow8PhS_iP12PaletteEntry(i9, i2, i1, i10) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 i8 = i1 * 3 | 0;
 i5 = i9 + i8 | 0;
 i1 = i9 + 3 | 0;
 if ((i8 | 0) > 3) {
  i7 = i9 + 6 | 0;
  i7 = (((i5 >>> 0 > i7 >>> 0 ? i5 : i7) + (-4 - i9) | 0) >>> 0) / 3 | 0;
  i6 = i7 * 3 | 0;
  i8 = i6 + 6 | 0;
  i7 = i7 + 1 | 0;
  i6 = i6 + 3 | 0;
  i4 = i2;
  i3 = i9;
  while (1) {
   i12 = i10 + ((HEAPU8[i4 >> 0] | 0) << 2) | 0;
   i12 = HEAPU8[i12 >> 0] | HEAPU8[i12 + 1 >> 0] << 8 | HEAPU8[i12 + 2 >> 0] << 16 | HEAPU8[i12 + 3 >> 0] << 24;
   HEAP8[i3 >> 0] = i12;
   HEAP8[i3 + 1 >> 0] = i12 >> 8;
   HEAP8[i3 + 2 >> 0] = i12 >> 16;
   HEAP8[i3 + 3 >> 0] = i12 >> 24;
   i3 = i1 + 3 | 0;
   if (i3 >>> 0 < i5 >>> 0) {
    i12 = i1;
    i4 = i4 + 1 | 0;
    i1 = i3;
    i3 = i12;
   } else break;
  }
  i3 = i9 + i6 | 0;
  i2 = i2 + i7 | 0;
  i1 = i9 + i8 | 0;
 } else i3 = i9;
 i7 = HEAPU8[i2 >> 0] | 0;
 i8 = HEAP8[i10 + (i7 << 2) + 1 >> 0] | 0;
 i9 = HEAP8[i10 + (i7 << 2) + 2 >> 0] | 0;
 HEAP8[i3 >> 0] = HEAP8[i10 + (i7 << 2) >> 0] | 0;
 HEAP8[i3 + 1 >> 0] = i8;
 HEAP8[i3 + 2 >> 0] = i9;
 STACKTOP = i11;
 return i1 | 0;
}

function __ZN2cvL13minMaxIdx_64fEPKdPKhPdS4_PjS5_ij(i9, i7, i14, i12, i13, i11, i8, i10) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i15 = 0, d16 = 0.0, i17 = 0, i18 = 0;
 i15 = STACKTOP;
 d1 = +HEAPF64[i14 >> 3];
 d4 = +HEAPF64[i12 >> 3];
 i2 = HEAP32[i13 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i3 = (i8 | 0) > 0;
 if (!i7) if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   d16 = +HEAPF64[i9 + (i6 << 3) >> 3];
   i7 = d16 < d1;
   i5 = i6 + i10 | 0;
   i2 = i7 ? i5 : i2;
   d1 = i7 ? d16 : d1;
   i7 = d16 > d4;
   i3 = i7 ? i5 : i3;
   d4 = i7 ? d16 : d4;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5; else if (i3) {
  i6 = 0;
  i3 = i5;
  do {
   d16 = +HEAPF64[i9 + (i6 << 3) >> 3];
   i5 = (HEAP8[i7 + i6 >> 0] | 0) != 0;
   i18 = i5 & d16 < d1;
   i17 = i6 + i10 | 0;
   i2 = i18 ? i17 : i2;
   d1 = i18 ? d16 : d1;
   i5 = i5 & d16 > d4;
   i3 = i5 ? i17 : i3;
   d4 = i5 ? d16 : d4;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 } else i3 = i5;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i11 >> 2] = i3;
 HEAPF64[i14 >> 3] = d1;
 HEAPF64[i12 >> 3] = d4;
 STACKTOP = i15;
 return;
}

function __ZNSt3__16vectorIPN7testing17TestEventListenerENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((HEAP32[i8 >> 2] | 0) - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i9 = i10 + 8 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
 if (i2 >> 2 >>> 0 < 536870911) {
  i2 = i2 >> 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  if (!i2) {
   i5 = 0;
   i4 = 0;
   i3 = i1;
  } else i6 = 6;
 } else {
  i2 = 1073741823;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i5 = i2;
  i4 = __Znwj(i2 << 2) | 0;
  i3 = i1;
 }
 i2 = i4 + (i3 << 2) | 0;
 if (i2) HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i7 = i4 + (i3 - (i6 >> 2) << 2) | 0;
 _memcpy(i7 | 0, i1 | 0, i6 | 0) | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i4 + (i3 + 1 << 2);
 HEAP32[i9 >> 2] = i4 + (i5 << 2);
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function _gz_init(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 i2 = i6 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = _malloc(i1) | 0;
 i4 = i6 + 32 | 0;
 HEAP32[i4 >> 2] = i3;
 if (!i3) {
  _gz_error(i6, -4, 143520);
  i1 = -1;
  STACKTOP = i7;
  return i1 | 0;
 }
 i5 = i6 + 40 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  HEAP32[i6 + 24 >> 2] = i1;
  i1 = 0;
  STACKTOP = i7;
  return i1 | 0;
 }
 i8 = _malloc(i1) | 0;
 i1 = i6 + 36 | 0;
 HEAP32[i1 >> 2] = i8;
 if (!i8) {
  _free(i3);
  _gz_error(i6, -4, 143520);
  i1 = -1;
  STACKTOP = i7;
  return i1 | 0;
 }
 HEAP32[i6 + 116 >> 2] = 0;
 HEAP32[i6 + 120 >> 2] = 0;
 HEAP32[i6 + 124 >> 2] = 0;
 if (_deflateInit2_(i6 + 84 | 0, HEAP32[i6 + 60 >> 2] | 0, 8, 31, 8, HEAP32[i6 + 64 >> 2] | 0, 143536, 56) | 0) {
  _free(HEAP32[i1 >> 2] | 0);
  _free(HEAP32[i4 >> 2] | 0);
  _gz_error(i6, -4, 143520);
  i1 = -1;
  STACKTOP = i7;
  return i1 | 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 + 24 >> 2] = i1;
 if (i2) {
  i1 = 0;
  STACKTOP = i7;
  return i1 | 0;
 }
 HEAP32[i6 + 100 >> 2] = i1;
 i1 = HEAP32[i6 + 36 >> 2] | 0;
 HEAP32[i6 + 96 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEErsERy(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i9 + 24 | 0;
 i1 = i9 + 20 | 0;
 i3 = i9 + 16 | 0;
 i4 = i9 + 12 | 0;
 i10 = i9 + 28 | 0;
 i6 = i9 + 8 | 0;
 i5 = i9 + 4 | 0;
 __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6sentryC2ERS3_b(i10, i8, 0);
 if (!(HEAP8[i10 >> 0] | 0)) {
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = 0;
 __ZNSt3__16localeC2ERKS0_(i5, i8 + ((HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 28) | 0);
 i11 = __ZNKSt3__16locale9use_facetERNS0_2idE(i5, 959232) | 0;
 i10 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
 i12 = HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + (i10 + 24) >> 2];
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
 FUNCTION_TABLE_viiiiiii[i12 & 63](i9, i11, i1, i2, i8 + i10 | 0, i6, i7);
 __ZNSt3__16localeD2Ev(i5);
 i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i8 + i1 | 0, HEAP32[i8 + (i1 + 16) >> 2] | HEAP32[i6 >> 2]);
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEErsERj(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i9 + 24 | 0;
 i1 = i9 + 20 | 0;
 i3 = i9 + 16 | 0;
 i4 = i9 + 12 | 0;
 i10 = i9 + 28 | 0;
 i6 = i9 + 8 | 0;
 i5 = i9 + 4 | 0;
 __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6sentryC2ERS3_b(i10, i8, 0);
 if (!(HEAP8[i10 >> 0] | 0)) {
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = 0;
 __ZNSt3__16localeC2ERKS0_(i5, i8 + ((HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 28) | 0);
 i11 = __ZNKSt3__16locale9use_facetERNS0_2idE(i5, 959232) | 0;
 i10 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
 i12 = HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + (i10 + 24) >> 2];
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
 FUNCTION_TABLE_viiiiiii[i12 & 63](i9, i11, i1, i2, i8 + i10 | 0, i6, i7);
 __ZNSt3__16localeD2Ev(i5);
 i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i8 + i1 | 0, HEAP32[i8 + (i1 + 16) >> 2] | HEAP32[i6 >> 2]);
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEErsERf(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i9 + 24 | 0;
 i1 = i9 + 20 | 0;
 i3 = i9 + 16 | 0;
 i4 = i9 + 12 | 0;
 i10 = i9 + 28 | 0;
 i6 = i9 + 8 | 0;
 i5 = i9 + 4 | 0;
 __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6sentryC2ERS3_b(i10, i8, 0);
 if (!(HEAP8[i10 >> 0] | 0)) {
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = 0;
 __ZNSt3__16localeC2ERKS0_(i5, i8 + ((HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 28) | 0);
 i11 = __ZNKSt3__16locale9use_facetERNS0_2idE(i5, 959232) | 0;
 i10 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
 i12 = HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + (i10 + 24) >> 2];
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
 FUNCTION_TABLE_viiiiiii[i12 & 63](i9, i11, i1, i2, i8 + i10 | 0, i6, i7);
 __ZNSt3__16localeD2Ev(i5);
 i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i8 + i1 | 0, HEAP32[i8 + (i1 + 16) >> 2] | HEAP32[i6 >> 2]);
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEErsERd(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i2 = i9 + 24 | 0;
 i1 = i9 + 20 | 0;
 i3 = i9 + 16 | 0;
 i4 = i9 + 12 | 0;
 i10 = i9 + 28 | 0;
 i6 = i9 + 8 | 0;
 i5 = i9 + 4 | 0;
 __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6sentryC2ERS3_b(i10, i8, 0);
 if (!(HEAP8[i10 >> 0] | 0)) {
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = 0;
 __ZNSt3__16localeC2ERKS0_(i5, i8 + ((HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 28) | 0);
 i11 = __ZNKSt3__16locale9use_facetERNS0_2idE(i5, 959232) | 0;
 i10 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
 i12 = HEAP32[(HEAP32[i11 >> 2] | 0) + 44 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + (i10 + 24) >> 2];
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
 FUNCTION_TABLE_viiiiiii[i12 & 63](i9, i11, i1, i2, i8 + i10 | 0, i6, i7);
 __ZNSt3__16localeD2Ev(i5);
 i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i8 + i1 | 0, HEAP32[i8 + (i1 + 16) >> 2] | HEAP32[i6 >> 2]);
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNSt3__16vectorIPN7testing11EnvironmentENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((HEAP32[i8 >> 2] | 0) - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i9 = i10 + 8 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
 if (i2 >> 2 >>> 0 < 536870911) {
  i2 = i2 >> 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  if (!i2) {
   i5 = 0;
   i4 = 0;
   i3 = i1;
  } else i6 = 6;
 } else {
  i2 = 1073741823;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i5 = i2;
  i4 = __Znwj(i2 << 2) | 0;
  i3 = i1;
 }
 i2 = i4 + (i3 << 2) | 0;
 if (i2) HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i7 = i4 + (i3 - (i6 >> 2) << 2) | 0;
 _memcpy(i7 | 0, i1 | 0, i6 | 0) | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i4 + (i3 + 1 << 2);
 HEAP32[i9 >> 2] = i4 + (i5 << 2);
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZNSt3__16vectorIPN2cv16TLSDataContainerENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((HEAP32[i8 >> 2] | 0) - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i9 = i10 + 8 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
 if (i2 >> 2 >>> 0 < 536870911) {
  i2 = i2 >> 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  if (!i2) {
   i5 = 0;
   i4 = 0;
   i3 = i1;
  } else i6 = 6;
 } else {
  i2 = 1073741823;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i5 = i2;
  i4 = __Znwj(i2 << 2) | 0;
  i3 = i1;
 }
 i2 = i4 + (i3 << 2) | 0;
 if (i2) HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i7 = i4 + (i3 - (i6 >> 2) << 2) | 0;
 _memcpy(i7 | 0, i1 | 0, i6 | 0) | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i4 + (i3 + 1 << 2);
 HEAP32[i9 >> 2] = i4 + (i5 << 2);
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZNSt3__16vectorIPN7testing8TestInfoENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((HEAP32[i8 >> 2] | 0) - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i9 = i10 + 8 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
 if (i2 >> 2 >>> 0 < 536870911) {
  i2 = i2 >> 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  if (!i2) {
   i5 = 0;
   i4 = 0;
   i3 = i1;
  } else i6 = 6;
 } else {
  i2 = 1073741823;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i5 = i2;
  i4 = __Znwj(i2 << 2) | 0;
  i3 = i1;
 }
 i2 = i4 + (i3 << 2) | 0;
 if (i2) HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i7 = i4 + (i3 - (i6 >> 2) << 2) | 0;
 _memcpy(i7 | 0, i1 | 0, i6 | 0) | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i4 + (i3 + 1 << 2);
 HEAP32[i9 >> 2] = i4 + (i5 << 2);
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZNSt3__16vectorIPN7testing8TestCaseENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((HEAP32[i8 >> 2] | 0) - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i9 = i10 + 8 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
 if (i2 >> 2 >>> 0 < 536870911) {
  i2 = i2 >> 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  if (!i2) {
   i5 = 0;
   i4 = 0;
   i3 = i1;
  } else i6 = 6;
 } else {
  i2 = 1073741823;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i5 = i2;
  i4 = __Znwj(i2 << 2) | 0;
  i3 = i1;
 }
 i2 = i4 + (i3 << 2) | 0;
 if (i2) HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i7 = i4 + (i3 - (i6 >> 2) << 2) | 0;
 _memcpy(i7 | 0, i1 | 0, i6 | 0) | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i4 + (i3 + 1 << 2);
 HEAP32[i9 >> 2] = i4 + (i5 << 2);
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZN2cv10PxMDecoderD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 179624;
 i2 = i4 + 92 | 0;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] & 511](i2);
 __ZN2cv11RBaseStreamD2Ev(i4 + 92 | 0);
 HEAP32[i4 >> 2] = 179344;
 i2 = i4 + 32 | 0;
 i1 = i4 + 68 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i2);
 HEAP32[i1 >> 2] = 0;
 i2 = i4 + 48 | 0;
 i1 = i4 + 36 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 if ((HEAP32[i1 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 72 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i2 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i1 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 76 >> 2] | 0;
 if ((i1 | 0) == (i4 + 80 | 0)) {
  i1 = i4 + 24 | 0;
  __ZN2cv6String10deallocateEv(i1);
  i1 = i4 + 16 | 0;
  __ZN2cv6String10deallocateEv(i1);
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 i1 = i4 + 24 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = i4 + 16 | 0;
 __ZN2cv6String10deallocateEv(i1);
 STACKTOP = i5;
 return;
}

function __ZN2cvL8cvt8u64fEPKhjS1_jPdjNS_5Size_IiEES2_(i10, i13, i1, i2, i6, i5, i4, i3) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, d14 = 0.0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5 >>> 3;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i1 = i11 & -4;
 i2 = i6;
 i3 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i6 = i5 | 1;
    d14 = +(HEAPU8[i3 + i6 >> 0] | 0);
    HEAPF64[i2 + (i5 << 3) >> 3] = +(HEAPU8[i3 + i5 >> 0] | 0);
    HEAPF64[i2 + (i6 << 3) >> 3] = d14;
    i6 = i5 | 2;
    i10 = i5 | 3;
    d14 = +(HEAPU8[i3 + i10 >> 0] | 0);
    HEAPF64[i2 + (i6 << 3) >> 3] = +(HEAPU8[i3 + i6 >> 0] | 0);
    HEAPF64[i2 + (i10 << 3) >> 3] = d14;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i1;
  }
  if ((i5 | 0) < (i11 | 0)) do {
   HEAPF64[i2 + (i5 << 3) >> 3] = +(HEAPU8[i3 + i5 >> 0] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
  if (!i4) break; else {
   i2 = i2 + (i7 << 3) | 0;
   i3 = i3 + i13 | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function _cvChangeSeqBlock(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5;
 if (!i3) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40152, 39608, 994);
  __ZN2cv6String10deallocateEv(i1);
 }
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i2 + 16 >> 2] | 0;
  HEAP32[i3 + 12 >> 2] = i1;
  i2 = HEAP32[i2 + 12 >> 2] | 0;
  i4 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 28 >> 2] | 0;
  i6 = i3 + 16 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = Math_imul(i4, i2) | 0;
  i2 = i1 + i2 | 0;
  i1 = i3 + 20 | 0;
  HEAP32[i1 >> 2] = i2;
  STACKTOP = i5;
  return;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i2 + 16 >> 2] | 0;
  i2 = HEAP32[i2 + 12 >> 2] | 0;
  i4 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 28 >> 2] | 0;
  HEAP32[i3 + 12 >> 2] = i1 + (Math_imul(i4, i2 + -1 | 0) | 0);
  i6 = i3 + 16 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = Math_imul(i4, i2) | 0;
  i2 = i1 + i2 | 0;
  i1 = i3 + 20 | 0;
  HEAP32[i1 >> 2] = i2;
  STACKTOP = i5;
  return;
 }
}

function __ZN2cvL8cvt8s64fEPKajPKhjPdjNS_5Size_IiEES4_(i10, i13, i1, i2, i6, i5, i4, i3) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, d14 = 0.0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5 >>> 3;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i1 = i11 & -4;
 i2 = i6;
 i3 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i6 = i5 | 1;
    d14 = +(HEAP8[i3 + i6 >> 0] | 0);
    HEAPF64[i2 + (i5 << 3) >> 3] = +(HEAP8[i3 + i5 >> 0] | 0);
    HEAPF64[i2 + (i6 << 3) >> 3] = d14;
    i6 = i5 | 2;
    i10 = i5 | 3;
    d14 = +(HEAP8[i3 + i10 >> 0] | 0);
    HEAPF64[i2 + (i6 << 3) >> 3] = +(HEAP8[i3 + i6 >> 0] | 0);
    HEAPF64[i2 + (i10 << 3) >> 3] = d14;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i1;
  }
  if ((i5 | 0) < (i11 | 0)) do {
   HEAPF64[i2 + (i5 << 3) >> 3] = +(HEAP8[i3 + i5 >> 0] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
  if (!i4) break; else {
   i2 = i2 + (i7 << 3) | 0;
   i3 = i3 + i13 | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZL21icvYMLStartNextStreamP13CvFileStorage(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 if (HEAP32[i8 + 12 >> 2] | 0) {
  STACKTOP = i9;
  return;
 }
 i1 = i8 + 36 | 0;
 if ((HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0) > 0) do __ZL20icvYMLEndWriteStructP13CvFileStorage(i8); while ((HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0) > 0);
 i2 = i8 + 40 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i8 + 72 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i8 + 76 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i5 = i8 + 56 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 > (i1 + i4 | 0) >>> 0) {
  HEAP8[i3 >> 0] = 10;
  HEAP8[i3 + 1 >> 0] = 0;
  __ZL7icvPutsP13CvFileStoragePKc(i8, HEAP32[i7 >> 2] | 0);
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = 0;
  i3 = i4;
 }
 if ((i2 | 0) != (i3 | 0)) {
  if ((i2 | 0) > (i3 | 0)) {
   _memset(i1 + i3 | 0, 32, i2 - i3 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = i1 + i2;
 __ZL7icvPutsP13CvFileStoragePKc(i8, 16752);
 __ZL7icvPutsP13CvFileStoragePKc(i8, 16760);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 STACKTOP = i9;
 return;
}

function _cvGetSize(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i8;
 HEAP32[i5 >> 2] = 0;
 i4 = i5 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 if (i6) {
  i2 = HEAP32[i6 >> 2] | 0;
  if (((i2 & -65536 | 0) == 1111621632 ? (i1 = HEAP32[i6 + 24 >> 2] | 0, (i1 | 0) > -1) : 0) ? (i3 = HEAP32[i6 + 20 >> 2] | 0, (i3 | 0) > -1) : 0) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i4 >> 2] = i3;
   STACKTOP = i8;
   return;
  }
  if ((i2 | 0) == 112) {
   i1 = HEAP32[i6 + 48 >> 2] | 0;
   if (!i1) {
    HEAP32[i5 >> 2] = HEAP32[i6 + 40 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i6 + 44 >> 2];
    STACKTOP = i8;
    return;
   } else {
    HEAP32[i5 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i1 + 16 >> 2];
    STACKTOP = i8;
    return;
   }
  }
 }
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i1 = (__ZN2cv6String8allocateEj(i7, 33) | 0) + 0 | 0;
 i2 = 42400 | 0;
 i3 = i1 + 33 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i7, 42440, 40912, 1245);
 __ZN2cv6String10deallocateEv(i7);
 STACKTOP = i8;
 return;
}

function __ZNSt3__114__num_put_base14__format_floatEPcPKcj(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 if (i2 & 2048) {
  HEAP8[i1 >> 0] = 43;
  i1 = i1 + 1 | 0;
 }
 if (i2 & 1024) {
  HEAP8[i1 >> 0] = 35;
  i1 = i1 + 1 | 0;
 }
 i7 = i2 & 260;
 i5 = i2 >>> 14;
 i8 = (i7 | 0) == 260;
 if (i8) i6 = 0; else {
  HEAP8[i1 >> 0] = 46;
  HEAP8[i1 + 1 >> 0] = 42;
  i1 = i1 + 2 | 0;
  i6 = 1;
 }
 i2 = HEAP8[i4 >> 0] | 0;
 if (i2 << 24 >> 24) {
  i3 = i1;
  while (1) {
   i4 = i4 + 1 | 0;
   i1 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = i2;
   i2 = HEAP8[i4 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break; else i3 = i1;
  }
 }
 do if ((i7 | 0) == 4) if (!(i5 & 1)) {
  HEAP8[i1 >> 0] = 102;
  break;
 } else {
  HEAP8[i1 >> 0] = 70;
  break;
 } else if ((i7 | 0) == 256) if (!(i5 & 1)) {
  HEAP8[i1 >> 0] = 101;
  break;
 } else {
  HEAP8[i1 >> 0] = 69;
  break;
 } else {
  i2 = (i5 & 1 | 0) != 0;
  if (i8) if (i2) {
   HEAP8[i1 >> 0] = 65;
   break;
  } else {
   HEAP8[i1 >> 0] = 97;
   break;
  } else if (i2) {
   HEAP8[i1 >> 0] = 71;
   break;
  } else {
   HEAP8[i1 >> 0] = 103;
   break;
  }
 } while (0);
 STACKTOP = i9;
 return i6 | 0;
}

function __ZNSt3__125__num_get_signed_integralIlEET_PKcS3_Rji(i1, i6, i7, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i9;
 if ((i1 | 0) == (i6 | 0)) {
  HEAP32[i7 >> 2] = 4;
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 i4 = ___errno_location() | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i2 = _strtoll_l(i1, i8, i2, __ZNSt3__16__clocEv() | 0) | 0;
 i1 = tempRet0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) HEAP32[i4 >> 2] = i5;
 if ((HEAP32[i8 >> 2] | 0) != (i6 | 0)) {
  HEAP32[i7 >> 2] = 4;
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 do if ((i3 | 0) == 34) {
  HEAP32[i7 >> 2] = 4;
  if ((i1 | 0) > 0 | (i1 | 0) == 0 & i2 >>> 0 > 0) {
   i1 = 2147483647;
   STACKTOP = i9;
   return i1 | 0;
  }
 } else {
  if ((i1 | 0) < -1 | (i1 | 0) == -1 & i2 >>> 0 < 2147483648) {
   HEAP32[i7 >> 2] = 4;
   break;
  }
  if ((i1 | 0) > 0 | (i1 | 0) == 0 & i2 >>> 0 > 2147483647) {
   HEAP32[i7 >> 2] = 4;
   i1 = 2147483647;
   STACKTOP = i9;
   return i1 | 0;
  } else {
   i1 = i2;
   STACKTOP = i9;
   return i1 | 0;
  }
 } while (0);
 i1 = -2147483648;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNK7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE5BeginEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i7 + 4 | 0;
 i2 = i7;
 i4 = __Znwj(44) | 0;
 i9 = i6 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 127](i5) | 0;
 HEAP32[i1 >> 2] = i5;
 i8 = i6 + 12 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] & 127](i3) | 0;
 HEAP32[i2 >> 2] = i3;
 __ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8IteratorC2EPKNS0_23ParamGeneratorInterfaceINSt3tr15tupleIS4_S6_vvvvvvvvEEEERKNS0_14ParamGeneratorIS4_EERKNS0_13ParamIteratorIS4_EERKNSG_IS6_EERKNSK_IS6_EE(i4, i6, i9, i1, i8, i2);
 if (i3) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
  HEAP32[i2 >> 2] = 0;
 }
 if (!i5) {
  STACKTOP = i7;
  return i4 | 0;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 511](i5);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i7;
 return i4 | 0;
}

function __ZNK7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE3EndEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i7 + 4 | 0;
 i2 = i7;
 i4 = __Znwj(44) | 0;
 i9 = i6 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] & 127](i5) | 0;
 HEAP32[i1 >> 2] = i5;
 i8 = i6 + 12 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] & 127](i3) | 0;
 HEAP32[i2 >> 2] = i3;
 __ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8IteratorC2EPKNS0_23ParamGeneratorInterfaceINSt3tr15tupleIS4_S6_vvvvvvvvEEEERKNS0_14ParamGeneratorIS4_EERKNS0_13ParamIteratorIS4_EERKNSG_IS6_EERKNSK_IS6_EE(i4, i6, i9, i1, i8, i2);
 if (i3) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
  HEAP32[i2 >> 2] = 0;
 }
 if (!i5) {
  STACKTOP = i7;
  return i4 | 0;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 511](i5);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i7;
 return i4 | 0;
}

function __ZNSt3__16vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((HEAP32[i8 >> 2] | 0) - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i9 = i10 + 8 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
 if (i2 >> 2 >>> 0 < 536870911) {
  i2 = i2 >> 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  if (!i2) {
   i5 = 0;
   i4 = 0;
   i3 = i1;
  } else i6 = 6;
 } else {
  i2 = 1073741823;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 >> 2;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i5 = i2;
  i4 = __Znwj(i2 << 2) | 0;
  i3 = i1;
 }
 i2 = i4 + (i3 << 2) | 0;
 if (i2) HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i7 = i4 + (i3 - (i6 >> 2) << 2) | 0;
 _memcpy(i7 | 0, i1 | 0, i6 | 0) | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i4 + (i3 + 1 << 2);
 HEAP32[i9 >> 2] = i4 + (i5 << 2);
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}
function _cvSetImageCOI(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i7 + 8 | 0;
 i2 = i7;
 if (!i4) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-9, i1, 43296, 40912, 3080);
  __ZN2cv6String10deallocateEv(i1);
 }
 if ((HEAP32[i4 + 8 >> 2] | 0) >>> 0 < i6 >>> 0) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-24, i2, 43296, 40912, 3083);
  __ZN2cv6String10deallocateEv(i2);
 }
 i5 = i4 + 48 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = (i1 | 0) != 0;
 if (!(i2 | (i6 | 0) != 0)) {
  STACKTOP = i7;
  return;
 }
 if (i2) {
  HEAP32[i1 >> 2] = i6;
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i4 + 40 >> 2] | 0;
 i2 = HEAP32[i4 + 44 >> 2] | 0;
 i1 = HEAP32[10248] | 0;
 if (!i1) {
  i1 = _cvAlloc(20) | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = i3;
  HEAP32[i1 + 16 >> 2] = i2;
 } else i1 = FUNCTION_TABLE_iiiiii[i1 & 31](i6, 0, 0, i3, i2) | 0;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i7;
 return;
}

function __ZN2cvL8cvt8u16uEPKhjS1_jPtjNS_5Size_IiEEPd(i10, i13, i1, i2, i6, i5, i4, i3) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5 >>> 1;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i1 = i11 & -4;
 i2 = i6;
 i3 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i14 = i5 | 1;
    i10 = HEAPU8[i3 + i14 >> 0] | 0;
    HEAP16[i2 + (i5 << 1) >> 1] = HEAPU8[i3 + i5 >> 0] | 0;
    HEAP16[i2 + (i14 << 1) >> 1] = i10;
    i14 = i5 | 2;
    i10 = i5 | 3;
    i6 = HEAPU8[i3 + i10 >> 0] | 0;
    HEAP16[i2 + (i14 << 1) >> 1] = HEAPU8[i3 + i14 >> 0] | 0;
    HEAP16[i2 + (i10 << 1) >> 1] = i6;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i1;
  }
  if ((i5 | 0) < (i11 | 0)) do {
   HEAP16[i2 + (i5 << 1) >> 1] = HEAPU8[i3 + i5 >> 0] | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
  if (!i4) break; else {
   i2 = i2 + (i7 << 1) | 0;
   i3 = i3 + i13 | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZN2cvL8cvt8u16sEPKhjS1_jPsjNS_5Size_IiEEPd(i10, i13, i1, i2, i6, i5, i4, i3) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5 >>> 1;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i1 = i11 & -4;
 i2 = i6;
 i3 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i14 = i5 | 1;
    i10 = HEAPU8[i3 + i14 >> 0] | 0;
    HEAP16[i2 + (i5 << 1) >> 1] = HEAPU8[i3 + i5 >> 0] | 0;
    HEAP16[i2 + (i14 << 1) >> 1] = i10;
    i14 = i5 | 2;
    i10 = i5 | 3;
    i6 = HEAPU8[i3 + i10 >> 0] | 0;
    HEAP16[i2 + (i14 << 1) >> 1] = HEAPU8[i3 + i14 >> 0] | 0;
    HEAP16[i2 + (i10 << 1) >> 1] = i6;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i1;
  }
  if ((i5 | 0) < (i11 | 0)) do {
   HEAP16[i2 + (i5 << 1) >> 1] = HEAPU8[i3 + i5 >> 0] | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
  if (!i4) break; else {
   i2 = i2 + (i7 << 1) | 0;
   i3 = i3 + i13 | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZNSt3__118__insertion_sort_3IRNS_6__lessIxxEEPxEEvT0_S5_T_(i8, i9, i2) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 i3 = i8 + 16 | 0;
 __ZNSt3__17__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i8, i8 + 8 | 0, i3, i2) | 0;
 i1 = i8 + 24 | 0;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i10;
  return;
 }
 while (1) {
  i7 = i1;
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = i3;
  i2 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if ((i7 | 0) < (i4 | 0) | (i7 | 0) == (i4 | 0) & i6 >>> 0 < i2 >>> 0) {
   i5 = i1;
   while (1) {
    HEAP32[i5 >> 2] = i2;
    HEAP32[i5 + 4 >> 2] = i4;
    if ((i3 | 0) == (i8 | 0)) {
     i3 = i8;
     break;
    }
    i5 = i3 + -8 | 0;
    i4 = i5;
    i2 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    if (!((i7 | 0) < (i4 | 0) | (i7 | 0) == (i4 | 0) & i6 >>> 0 < i2 >>> 0)) break; else {
     i11 = i3;
     i3 = i5;
     i5 = i11;
    }
   }
   i5 = i3;
   HEAP32[i5 >> 2] = i6;
   HEAP32[i5 + 4 >> 2] = i7;
  }
  i2 = i1 + 8 | 0;
  if ((i2 | 0) == (i9 | 0)) break; else {
   i3 = i1;
   i1 = i2;
  }
 }
 STACKTOP = i10;
 return;
}

function __ZN2cvL8cvt8s16sEPKajPKhjPsjNS_5Size_IiEEPd(i10, i13, i1, i2, i6, i5, i4, i3) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5 >>> 1;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i1 = i11 & -4;
 i2 = i6;
 i3 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i14 = i5 | 1;
    i10 = HEAP8[i3 + i14 >> 0] | 0;
    HEAP16[i2 + (i5 << 1) >> 1] = HEAP8[i3 + i5 >> 0] | 0;
    HEAP16[i2 + (i14 << 1) >> 1] = i10;
    i14 = i5 | 2;
    i10 = i5 | 3;
    i6 = HEAP8[i3 + i10 >> 0] | 0;
    HEAP16[i2 + (i14 << 1) >> 1] = HEAP8[i3 + i14 >> 0] | 0;
    HEAP16[i2 + (i10 << 1) >> 1] = i6;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i1;
  }
  if ((i5 | 0) < (i11 | 0)) do {
   HEAP16[i2 + (i5 << 1) >> 1] = HEAP8[i3 + i5 >> 0] | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
  if (!i4) break; else {
   i2 = i2 + (i7 << 1) | 0;
   i3 = i3 + i13 | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function _cvNextTreeNode(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i9;
 if (!i8) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i1, 21) | 0) + 0 | 0;
  i3 = 40744 | 0;
  i4 = i2 + 21 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40768, 39608, 3457);
  __ZN2cv6String10deallocateEv(i1);
 }
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 L4 : do if (i6) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i5 = i2 + 1 | 0, (i5 | 0) < (HEAP32[i8 + 8 >> 2] | 0)) : 0) {
   i2 = i5;
   break;
  } else i3 = i6;
  while (1) {
   i4 = HEAP32[i3 + 12 >> 2] | 0;
   if (i4) break;
   i1 = i2 + -1 | 0;
   if ((i2 | 0) < 1) {
    i2 = i1;
    i1 = 0;
    break L4;
   } else {
    i2 = i1;
    i3 = HEAP32[i3 + 16 >> 2] | 0;
   }
  }
  if (!i3) i1 = 0; else i1 = (HEAP32[i8 + 8 >> 2] | 0) == 0 ? 0 : i4;
 } else i1 = i6; while (0);
 HEAP32[i8 >> 2] = i1;
 HEAP32[i7 >> 2] = i2;
 STACKTOP = i9;
 return i6 | 0;
}

function __ZN2cvL8cvt8u32sEPKhjS1_jPijNS_5Size_IiEEPd(i10, i13, i1, i2, i6, i5, i4, i3) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5 >>> 2;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i1 = i11 & -4;
 i2 = i6;
 i3 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i14 = i5 | 1;
    i10 = HEAPU8[i3 + i14 >> 0] | 0;
    HEAP32[i2 + (i5 << 2) >> 2] = HEAPU8[i3 + i5 >> 0];
    HEAP32[i2 + (i14 << 2) >> 2] = i10;
    i14 = i5 | 2;
    i10 = i5 | 3;
    i6 = HEAPU8[i3 + i10 >> 0] | 0;
    HEAP32[i2 + (i14 << 2) >> 2] = HEAPU8[i3 + i14 >> 0];
    HEAP32[i2 + (i10 << 2) >> 2] = i6;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i1;
  }
  if ((i5 | 0) < (i11 | 0)) do {
   HEAP32[i2 + (i5 << 2) >> 2] = HEAPU8[i3 + i5 >> 0];
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
  if (!i4) break; else {
   i2 = i2 + (i7 << 2) | 0;
   i3 = i3 + i13 | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZN2cvL8cvt8s32sEPKajPKhjPijNS_5Size_IiEEPd(i10, i13, i1, i2, i6, i5, i4, i3) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5 >>> 2;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + -4 | 0;
 i9 = (i8 | 0) < 0;
 i1 = i11 & -4;
 i2 = i6;
 i3 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i9) i5 = 0; else {
   i5 = 0;
   do {
    i14 = i5 | 1;
    i10 = HEAP8[i3 + i14 >> 0] | 0;
    HEAP32[i2 + (i5 << 2) >> 2] = HEAP8[i3 + i5 >> 0];
    HEAP32[i2 + (i14 << 2) >> 2] = i10;
    i14 = i5 | 2;
    i10 = i5 | 3;
    i6 = HEAP8[i3 + i10 >> 0] | 0;
    HEAP32[i2 + (i14 << 2) >> 2] = HEAP8[i3 + i14 >> 0];
    HEAP32[i2 + (i10 << 2) >> 2] = i6;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) <= (i8 | 0));
   i5 = i1;
  }
  if ((i5 | 0) < (i11 | 0)) do {
   HEAP32[i2 + (i5 << 2) >> 2] = HEAP8[i3 + i5 >> 0];
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
  if (!i4) break; else {
   i2 = i2 + (i7 << 2) | 0;
   i3 = i3 + i13 | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZN2cvL5not8uEPKhjS1_jPhjNS_5Size_IiEEPv(i6, i12, i2, i3, i5, i11, i4, i1) {
 i6 = i6 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i10 = STACKTOP;
 i9 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 i1 = i9 + -4 | 0;
 i7 = (i1 | 0) < 0;
 i8 = i9 & -4;
 i2 = i6;
 i3 = i4;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i7) i4 = 0; else {
   i4 = 0;
   do {
    i14 = i4 | 1;
    i6 = ((HEAPU8[i2 + i14 >> 0] | 0) ^ 255) & 255;
    HEAP8[i5 + i4 >> 0] = (HEAPU8[i2 + i4 >> 0] | 0) ^ 255;
    HEAP8[i5 + i14 >> 0] = i6;
    i14 = i4 | 2;
    i6 = i4 | 3;
    i13 = ((HEAPU8[i2 + i6 >> 0] | 0) ^ 255) & 255;
    HEAP8[i5 + i14 >> 0] = (HEAPU8[i2 + i14 >> 0] | 0) ^ 255;
    HEAP8[i5 + i6 >> 0] = i13;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) <= (i1 | 0));
   i4 = i8;
  }
  if ((i4 | 0) < (i9 | 0)) do {
   HEAP8[i5 + i4 >> 0] = (HEAPU8[i2 + i4 >> 0] | 0) ^ 255;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i9 | 0));
  if (!i3) break; else {
   i5 = i5 + i11 | 0;
   i2 = i2 + i12 | 0;
  }
 }
 STACKTOP = i10;
 return;
}

function __ZNSt3__13mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfNS_4lessIS6_EENS4_INS_4pairIKS6_fEEEEEixERSA_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i7;
 i4 = __ZNSt3__13mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfNS_4lessIS6_EENS4_INS_4pairIKS6_fEEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_(i6, i3, i2) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1) {
  i1 = i1 + 28 | 0;
  STACKTOP = i7;
  return i1 | 0;
 }
 i5 = __Znwj(32) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i5 + 16 | 0, i2);
 HEAPF32[i5 + 28 >> 2] = Math_fround(0.0);
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = i1;
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 if (!i1) i1 = i5; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZNSt3__127__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i5;
 i1 = i1 + 28 | 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN2cv3Mat7releaseEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i3 = i4 + 36 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i2 = i1 + 12 | 0, i1 = HEAP32[i2 >> 2] | 0, HEAP32[i2 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i4 + 32 >> 2] | 0;
    if (!i2) {
     if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
      i1 = __Znwj(4) | 0;
      HEAP32[i1 >> 2] = 32784;
      HEAP32[6904] = i1;
      ___cxa_guard_release(27624);
     }
     i2 = HEAP32[6904] | 0;
     i1 = HEAP32[i3 >> 2] | 0;
    }
   }
   FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1);
  }
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 16 | 0;
 i3 = i4 + 4 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) <= 0) {
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[i4 + 40 >> 2] | 0;
 i2 = 0;
 do {
  HEAP32[i1 + (i2 << 2) >> 2] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
 STACKTOP = i5;
 return;
}

function __ZNK2cv5MatOp4typeERKNS_7MatExprE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 if (HEAP32[i6 + 24 >> 2] | 0) {
  i3 = HEAP32[i6 + 12 >> 2] | 0;
  if ((i3 | 0) < 3) i1 = Math_imul(HEAP32[i6 + 20 >> 2] | 0, HEAP32[i6 + 16 >> 2] | 0) | 0; else {
   i2 = HEAP32[i6 + 48 >> 2] | 0;
   i4 = 0;
   i1 = 1;
   do {
    i1 = Math_imul(HEAP32[i2 + (i4 << 2) >> 2] | 0, i1) | 0;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i3 | 0));
  }
  if (i1) {
   i1 = i6 + 8 | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   i1 = i1 & 4095;
   STACKTOP = i5;
   return i1 | 0;
  }
 }
 if (HEAP32[i6 + 80 >> 2] | 0) {
  i2 = HEAP32[i6 + 68 >> 2] | 0;
  if ((i2 | 0) < 3) i1 = Math_imul(HEAP32[i6 + 76 >> 2] | 0, HEAP32[i6 + 72 >> 2] | 0) | 0; else {
   i3 = HEAP32[i6 + 104 >> 2] | 0;
   i4 = 0;
   i1 = 1;
   do {
    i1 = Math_imul(HEAP32[i3 + (i4 << 2) >> 2] | 0, i1) | 0;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i2 | 0));
  }
  if (i1) {
   i1 = i6 + 120 | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   i1 = i1 & 4095;
   STACKTOP = i5;
   return i1 | 0;
  }
 }
 i1 = i6 + 64 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i1 = i1 & 4095;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNK2cv4UMat6copyToERKNS_12_OutputArrayERKNS_11_InputArrayE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i4 = i5;
 if (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] & 127](i1) | 0) {
  __ZNK2cv4UMat6copyToERKNS_12_OutputArrayE(i3, i2);
  STACKTOP = i5;
  return;
 }
 __ZNK2cv4UMat6getMatEi(i4, i3, 16777216);
 __ZNK2cv3Mat6copyToERKNS_12_OutputArrayERKNS_11_InputArrayE(i4, i2, i1);
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i3 = i2 + 12 | 0, i2 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i2 + -1, (i2 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i4);
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 16 | 0;
 i2 = i4 + 4 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i4 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 44 >> 2] | 0;
 if ((i1 | 0) == (i4 + 48 | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i5;
 return;
}

function __ZNK2cv11MatOp_AddEx8subtractERKNS_7Scalar_IdEERKNS_7MatExprERS5_(i1, i7, i2, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, d8 = 0.0, d9 = 0.0, d10 = 0.0;
 i5 = STACKTOP;
 i1 = i2;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __ZN2cv3MataSERKS0_(i6 + 8 | 0, i2 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i6 + 64 | 0, i2 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i6 + 120 | 0, i2 + 120 | 0) | 0;
 i3 = i6 + 176 | 0;
 i4 = i3 + 0 | 0;
 i2 = i2 + 176 | 0;
 i1 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i1 | 0));
 HEAPF64[i3 >> 3] = -+HEAPF64[i3 >> 3];
 i4 = i6 + 184 | 0;
 HEAPF64[i4 >> 3] = -+HEAPF64[i4 >> 3];
 i4 = i6 + 192 | 0;
 i3 = i6 + 200 | 0;
 d10 = +HEAPF64[i7 + 8 >> 3] - +HEAPF64[i3 >> 3];
 i2 = i6 + 208 | 0;
 d9 = +HEAPF64[i7 + 16 >> 3] - +HEAPF64[i2 >> 3];
 i1 = i6 + 216 | 0;
 d8 = +HEAPF64[i7 + 24 >> 3] - +HEAPF64[i1 >> 3];
 HEAPF64[i4 >> 3] = +HEAPF64[i7 >> 3] - +HEAPF64[i4 >> 3];
 HEAPF64[i3 >> 3] = d10;
 HEAPF64[i2 >> 3] = d9;
 HEAPF64[i1 >> 3] = d8;
 STACKTOP = i5;
 return;
}

function __ZL21icvXMLStartNextStreamP13CvFileStorage(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 if (HEAP32[i8 + 12 >> 2] | 0) {
  STACKTOP = i9;
  return;
 }
 i1 = i8 + 36 | 0;
 if ((HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0) > 0) do __ZL20icvXMLEndWriteStructP13CvFileStorage(i8); while ((HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0) > 0);
 i2 = i8 + 40 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i8 + 72 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i8 + 76 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i5 = i8 + 56 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 > (i1 + i4 | 0) >>> 0) {
  HEAP8[i3 >> 0] = 10;
  HEAP8[i3 + 1 >> 0] = 0;
  __ZL7icvPutsP13CvFileStoragePKc(i8, HEAP32[i7 >> 2] | 0);
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = 0;
  i3 = i4;
 }
 if ((i2 | 0) != (i3 | 0)) {
  if ((i2 | 0) > (i3 | 0)) {
   _memset(i1 + i3 | 0, 32, i2 - i3 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = i1 + i2;
 __ZL7icvPutsP13CvFileStoragePKc(i8, 17080);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 STACKTOP = i9;
 return;
}

function __ZNK2cv13sorted_vectorINS_6StringEPFPNS_9AlgorithmEvEE4findERKS1_RS5_(i1, i9, i10) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) {
  i1 = i2;
  i4 = i2;
  i3 = 0;
 } else {
  i8 = HEAP32[i9 >> 2] | 0;
  i5 = (i8 | 0) == 0 ? 39376 : i8;
  i3 = 0;
  i7 = (i2 - i4 | 0) / 12 | 0;
  do {
   i6 = (i7 + i3 | 0) >>> 1;
   i1 = HEAP32[i4 + (i6 * 12 | 0) >> 2] | 0;
   if ((i1 | 0) == (i8 | 0)) i1 = 0; else i1 = (_strcmp((i1 | 0) == 0 ? 39376 : i1, i5) | 0) < 0;
   i3 = i1 ? i6 + 1 | 0 : i3;
   i7 = i1 ? i7 : i6;
  } while (i7 >>> 0 > i3 >>> 0);
  i1 = i2;
 }
 if (i3 >>> 0 >= ((i1 - i4 | 0) / 12 | 0) >>> 0) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = HEAP32[i4 + (i3 * 12 | 0) >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0) ? (_strcmp((i2 | 0) == 0 ? 39376 : i2, (i1 | 0) == 0 ? 39376 : i1) | 0) != 0 : 0) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i10 >> 2] = HEAP32[i4 + (i3 * 12 | 0) + 8 >> 2];
 i10 = 1;
 STACKTOP = i11;
 return i10 | 0;
}

function _cvGetElemType(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i6;
 if (i1) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = i3 & -65536;
  if ((i2 | 0) == 1111752704 | (i2 | 0) == 1111687168) i4 = 6; else if ((i2 | 0) == 1111621632 ? (HEAP32[i1 + 24 >> 2] | 0) > 0 : 0) if (!((HEAP32[i1 + 20 >> 2] | 0) <= 0 ? !((i2 | 0) == 1111687168 | (i2 | 0) == 1111752704) : 0)) i4 = 6;
  if ((i4 | 0) == 6) {
   i1 = i3 & 4095;
   STACKTOP = i6;
   return i1 | 0;
  }
  if ((i3 | 0) == 112 ? (HEAP32[i1 + 68 >> 2] | 0) != 0 : 0) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   i1 = 1125516576 >>> ((i2 >>> 2 & 60) + (i2 >> 31 & 20) | 0) & 7 | (HEAP32[i1 + 8 >> 2] << 3) + -8;
   STACKTOP = i6;
   return i1 | 0;
  }
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = (__ZN2cv6String8allocateEj(i5, 38) | 0) + 0 | 0;
 i2 = 42264 | 0;
 i3 = i1 + 38 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i5, 42368, 40912, 1093);
 __ZN2cv6String10deallocateEv(i5);
 i1 = -1;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN2cvL11dotProd_32fEPKfS1_i(i5, i6, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, d9 = 0.0, d10 = 0.0;
 i7 = STACKTOP;
 i2 = i4 + -4 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  d1 = 0.0;
 } else {
  i3 = 0;
  d1 = 0.0;
  do {
   d10 = +Math_fround(HEAPF32[i5 + (i3 << 2) >> 2]);
   d10 = d10 * +Math_fround(HEAPF32[i6 + (i3 << 2) >> 2]);
   i8 = i3 | 1;
   d9 = +Math_fround(HEAPF32[i5 + (i8 << 2) >> 2]);
   d9 = d10 + d9 * +Math_fround(HEAPF32[i6 + (i8 << 2) >> 2]);
   i8 = i3 | 2;
   d10 = +Math_fround(HEAPF32[i5 + (i8 << 2) >> 2]);
   d10 = d9 + d10 * +Math_fround(HEAPF32[i6 + (i8 << 2) >> 2]);
   i8 = i3 | 3;
   d9 = +Math_fround(HEAPF32[i5 + (i8 << 2) >> 2]);
   d1 = d1 + (d10 + d9 * +Math_fround(HEAPF32[i6 + (i8 << 2) >> 2]));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i2 | 0));
  i2 = i4 & -4;
 }
 if ((i2 | 0) >= (i4 | 0)) {
  d1 = d1 + 0.0;
  STACKTOP = i7;
  return +d1;
 }
 do {
  d9 = +Math_fround(HEAPF32[i5 + (i2 << 2) >> 2]);
  d1 = d1 + d9 * +Math_fround(HEAPF32[i6 + (i2 << 2) >> 2]);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 d1 = d1 + 0.0;
 STACKTOP = i7;
 return +d1;
}

function __ZN7testing8internal35HandleExceptionsInMethodIfSupportedINS0_15TestFactoryBaseEPNS_4TestEEET0_PT_MS6_FS5_vEPKc(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 i1 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 i2 = i2 + 4 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i5 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i5, 163728);
  HEAP32[40934] = i5;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i3 = i3 + (i2 >> 1) | 0;
 i2 = (i2 & 1 | 0) == 0;
 if (!(HEAP8[(HEAP32[40934] | 0) + 212 >> 0] | 0)) {
  if (!i2) i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + i1 >> 2] | 0;
  i1 = FUNCTION_TABLE_ii[i1 & 127](i3) | 0;
  STACKTOP = i4;
  return i1 | 0;
 } else {
  if (!i2) i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + i1 >> 2] | 0;
  i1 = FUNCTION_TABLE_ii[i1 & 127](i3) | 0;
  STACKTOP = i4;
  return i1 | 0;
 }
 return 0;
}

function __ZL25default_terminate_handlerv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 i4 = i4 + 12 | 0;
 i1 = ___cxa_get_globals_fast() | 0;
 if (!i1) _abort_message(968776, i5);
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) _abort_message(968776, i5);
 i1 = i3 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!((i2 & -256 | 0) == 1126902528 & (i1 | 0) == 1129074247)) {
  HEAP32[i5 >> 2] = HEAP32[242154];
  _abort_message(968736, i5);
 }
 if ((i2 | 0) == 1126902529 & (i1 | 0) == 1129074247) i1 = HEAP32[i3 + 44 >> 2] | 0; else i1 = i3 + 80 | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[969168 >> 2] | 0) + 16 >> 2] & 63](969168, i2, i4) | 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[242154] | 0;
  i2 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] & 127](i2) | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i5 + 4 >> 2] = i1;
  HEAP32[i5 + 8 >> 2] = i2;
  _abort_message(968640, i5);
 } else {
  HEAP32[i5 >> 2] = HEAP32[242154];
  HEAP32[i5 + 4 >> 2] = i1;
  _abort_message(968688, i5);
 }
}

function ___fwritex(i3, i6, i5) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (!i2) if (!(___towrite(i5) | 0)) {
  i2 = HEAP32[i1 >> 2] | 0;
  break;
 } else {
  i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 } while (0);
 i7 = i5 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i2 - i1 | 0) >>> 0 < i6 >>> 0) {
  i1 = FUNCTION_TABLE_iiii[HEAP32[i5 + 36 >> 2] & 63](i5, i3, i6) | 0;
  STACKTOP = i8;
  return i1 | 0;
 }
 L11 : do if ((HEAP8[i5 + 75 >> 0] | 0) > -1) {
  i2 = i6;
  while (1) {
   if (!i2) {
    i4 = i6;
    i2 = 0;
    break L11;
   }
   i4 = i2 + -1 | 0;
   if ((HEAP8[i3 + i4 >> 0] | 0) == 10) break; else i2 = i4;
  }
  if ((FUNCTION_TABLE_iiii[HEAP32[i5 + 36 >> 2] & 63](i5, i3, i2) | 0) >>> 0 < i2 >>> 0) {
   i1 = i2;
   STACKTOP = i8;
   return i1 | 0;
  } else {
   i4 = i6 - i2 | 0;
   i3 = i3 + i2 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   break;
  }
 } else {
  i4 = i6;
  i2 = 0;
 } while (0);
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i4;
 i1 = i2 + i4 | 0;
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN2cv4readERKNS_8FileNodeERNS_6StringERKS3_(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i5;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  if (i1) {
   i1 = i1 + -4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  }
 } else {
  if ((HEAP32[i1 >> 2] & 7 | 0) != 3) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   break;
  }
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  if (i1) {
   i2 = _strlen(i1 | 0) | 0;
   _memcpy(__ZN2cv6String8allocateEj(i3, i2) | 0, i1 | 0, i2 | 0) | 0;
  }
 } while (0);
 if ((i3 | 0) == (i4 | 0)) {
  __ZN2cv6String10deallocateEv(i3);
  STACKTOP = i5;
  return;
 }
 __ZN2cv6String10deallocateEv(i4);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN2cv6String10deallocateEv(i3);
 STACKTOP = i5;
 return;
}

function __ZNSt3__16vectorIcNS_9allocatorIcEEE21__push_back_slow_pathIKcEEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = (HEAP32[i8 >> 2] | 0) - i1 + 1 | 0;
 if ((i3 | 0) < 0) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i9 = i10 + 8 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
 if (i2 >>> 0 < 1073741823) {
  i2 = i2 << 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
  if (!i2) {
   i5 = 0;
   i4 = 0;
   i3 = i1;
  } else i6 = 6;
 } else {
  i2 = 2147483647;
  i1 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  i5 = i2;
  i4 = __Znwj(i2) | 0;
  i3 = i1;
 }
 i2 = i4 + i3 | 0;
 if (i2) HEAP8[i2 >> 0] = HEAP8[i7 >> 0] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i7 = i4 + (i3 - i6) | 0;
 _memcpy(i7 | 0, i1 | 0, i6 | 0) | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i4 + (i3 + 1);
 HEAP32[i9 >> 2] = i4 + i5;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZNK7testing8internal8FilePath14RemoveFileNameEv(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i7 = i8 + 12 | 0;
 i5 = i8;
 i2 = (HEAP8[i4 >> 0] & 1) == 0;
 if (i2) i1 = i4 + 1 | 0; else i1 = HEAP32[i4 + 8 >> 2] | 0;
 i3 = _strrchr(i1, 47) | 0;
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 if (!i3) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i7, 164672) | 0; else {
  if (i2) {
   i2 = i4 + 1 | 0;
   i1 = i4 + 1 | 0;
  } else {
   i1 = HEAP32[i4 + 8 >> 2] | 0;
   i2 = i1;
  }
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i1, i3 + 1 - i2 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i5) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i6, i7);
 __ZN7testing8internal8FilePath9NormalizeEv(i6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 STACKTOP = i8;
 return;
}

function __ZNK7testing7Message9GetStringEv(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i6;
 __ZNKSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i4, (HEAP32[i1 >> 2] | 0) + 12 | 0);
 i1 = HEAP8[i4 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i4 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i4 + 8 >> 2] | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i5, i1 << 1);
 if (!i1) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
  STACKTOP = i6;
  return;
 }
 do {
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i5, 160792) | 0; else __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i5, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 STACKTOP = i6;
 return;
}

function __ZNK2cv14MatOp_Identity6assignERKNS_7MatExprERNS_3MatEi(i1, i2, i9, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i7 + 24 | 0;
 i6 = i7;
 i4 = i2 + 8 | 0;
 if ((i8 | 0) != -1 ? (i3 = HEAP32[i4 >> 2] | 0, (i3 & 4095 | 0) != (i8 | 0)) : 0) {
  if ((i3 ^ i8) & 4088) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   i3 = (__ZN2cv6String8allocateEj(i5, 34) | 0) + 0 | 0;
   i2 = 33176 | 0;
   i1 = i3 + 34 | 0;
   do {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    i3 = i3 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i3 | 0) < (i1 | 0));
   __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i5, 33216, 33224, 1195);
   __ZN2cv6String10deallocateEv(i5);
  }
  i1 = i6 + 4 | 0;
  HEAP32[i1 + 0 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i6 >> 2] = 32232;
  HEAP32[i1 >> 2] = 33619968;
  HEAP32[i6 + 8 >> 2] = i9;
  __ZNK2cv3Mat9convertToERKNS_12_OutputArrayEidd(i4, i6, i8, 1.0, 0.0);
  STACKTOP = i7;
  return;
 }
 __ZN2cv3MataSERKS0_(i9, i4) | 0;
 STACKTOP = i7;
 return;
}

function __ZN2cv11RBaseStream9readBlockEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 i1 = i8 + 28 | 0;
 i4 = i8 + 16 | 0;
 i5 = i8 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) - i6 | 0;
 i2 = i8 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i2 = i6 + i7 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  if (i2 >>> 0 < (HEAP32[i8 + 12 >> 2] | 0) >>> 0) {
   STACKTOP = i9;
   return;
  } else {
   i1 = ___cxa_allocate_exception(4) | 0;
   HEAP32[i1 >> 2] = -123;
   ___cxa_throw(i1 | 0, 180768, 0);
  }
 } else {
  i10 = (i7 | 0) % (HEAP32[i8 + 24 >> 2] | 0) | 0;
  i7 = i7 - i10 | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i4 >> 2] = i6 + i10;
  _fseek(i3 | 0, i7 | 0, 0) | 0;
  i1 = _fread(HEAP32[i5 >> 2] | 0, 1, HEAP32[i8 + 24 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 + 12 >> 2] = i2 + i1;
  HEAP32[i4 >> 2] = i2;
  if ((i1 | 0) > 0) {
   STACKTOP = i9;
   return;
  } else {
   i1 = ___cxa_allocate_exception(4) | 0;
   HEAP32[i1 >> 2] = -123;
   ___cxa_throw(i1 | 0, 180768, 0);
  }
 }
}

function __ZN7testing8internal35HandleExceptionsInMethodIfSupportedINS0_12UnitTestImplEbEET0_PT_MS4_FS3_vEPKc(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 i1 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 i2 = i2 + 4 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i5 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i5, 163728);
  HEAP32[40934] = i5;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i3 = i3 + (i2 >> 1) | 0;
 i2 = (i2 & 1 | 0) == 0;
 if (!(HEAP8[(HEAP32[40934] | 0) + 212 >> 0] | 0)) {
  if (!i2) i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + i1 >> 2] | 0;
  i1 = FUNCTION_TABLE_ii[i1 & 127](i3) | 0;
  STACKTOP = i4;
  return i1 | 0;
 } else {
  if (!i2) i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + i1 >> 2] | 0;
  i1 = FUNCTION_TABLE_ii[i1 & 127](i3) | 0;
  STACKTOP = i4;
  return i1 | 0;
 }
 return 0;
}

function __ZN7testing7MessageC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i2;
 i4 = __Znwj(144) | 0;
 i7 = i4 + 64 | 0;
 i3 = i4 + 8 | 0;
 HEAP32[i3 >> 2] = 2640;
 i6 = i4 + 12 | 0;
 HEAP32[i4 >> 2] = 2788;
 HEAP32[i7 >> 2] = 2808;
 HEAP32[i4 + 4 >> 2] = 0;
 __ZNSt3__18ios_base4initEPv(i7, i6);
 HEAP32[i4 + 136 >> 2] = 0;
 HEAP32[i4 + 140 >> 2] = -1;
 HEAP32[i4 >> 2] = 2620;
 HEAP32[i7 >> 2] = 2660;
 HEAP32[i3 >> 2] = 2640;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i6);
 HEAP32[i6 >> 2] = 2952;
 i7 = i4 + 44 | 0;
 HEAP32[i7 + 0 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 24;
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i6, i5);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 HEAP32[i1 >> 2] = i4;
 HEAP32[i4 + ((HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) + 16) >> 2] = 17;
 STACKTOP = i2;
 return;
}

function __ZN2cvL16transposeI_32sC4EPhji(i3, i7, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) > 0) i4 = 0; else {
  STACKTOP = i8;
  return;
 }
 do {
  i1 = i3 + (Math_imul(i4, i7) | 0) | 0;
  i2 = i4 << 4;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) < (i6 | 0)) {
   i5 = i4;
   do {
    i15 = i1 + (i5 << 4) | 0;
    i9 = (Math_imul(i5, i7) | 0) + i2 | 0;
    i13 = i3 + i9 | 0;
    i14 = HEAP32[i15 >> 2] | 0;
    i12 = HEAP32[i1 + (i5 << 4) + 4 >> 2] | 0;
    i11 = HEAP32[i1 + (i5 << 4) + 8 >> 2] | 0;
    i10 = HEAP32[i1 + (i5 << 4) + 12 >> 2] | 0;
    HEAP32[i15 + 0 >> 2] = HEAP32[i13 + 0 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    HEAP32[i15 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
    HEAP32[i13 >> 2] = i14;
    HEAP32[i3 + (i9 + 4) >> 2] = i12;
    HEAP32[i3 + (i9 + 8) >> 2] = i11;
    HEAP32[i3 + (i9 + 12) >> 2] = i10;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
  }
 } while ((i4 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZN2cv16SunRasterDecoderD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 179912;
 __ZN2cv11RBaseStreamD2Ev(i4 + 92 | 0);
 HEAP32[i4 >> 2] = 179344;
 i1 = i4 + 32 | 0;
 i2 = i4 + 68 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i1);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 48 | 0;
 i3 = i4 + 36 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i1 = HEAP32[i4 + 72 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 76 >> 2] | 0;
 if ((i1 | 0) == (i4 + 80 | 0)) {
  i1 = i4 + 24 | 0;
  __ZN2cv6String10deallocateEv(i1);
  i1 = i4 + 16 | 0;
  __ZN2cv6String10deallocateEv(i1);
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 i1 = i4 + 24 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = i4 + 16 | 0;
 __ZN2cv6String10deallocateEv(i1);
 STACKTOP = i5;
 return;
}

function __ZL21icvFSCreateCollectionP13CvFileStorageiP10CvFileNode(i2, i5, i4) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 i3 = i6;
 i1 = i6 + 16 | 0;
 if ((i5 & 7 | 0) == 6) {
  if (HEAP32[i4 >> 2] | 0) {
   i7 = HEAP32[i2 + 88 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 + 60 >> 2];
   HEAP32[i3 + 4 >> 2] = i7;
   HEAP32[i3 + 8 >> 2] = 15360;
   _sprintf(i1, 17440, i3) | 0;
   _cvError(-212, 15336, i1, 8960, 409);
  }
  i3 = HEAP32[i2 + 16 >> 2] | 0;
  i1 = _cvCreateSet(0, 72, 24, i3) | 0;
  HEAP32[i1 + 64 >> 2] = 16;
  i3 = _cvMemStorageAlloc(i3, 64) | 0;
  HEAP32[i1 + 68 >> 2] = i3;
  i3 = i3 + 0 | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  HEAP32[i4 + 8 >> 2] = i1;
  HEAP32[i4 >> 2] = i5;
  _cvSetSeqBlockSize(i1, 8);
  STACKTOP = i6;
  return;
 } else {
  i1 = _cvCreateSeq(0, 56, 16, HEAP32[i2 + 16 >> 2] | 0) | 0;
  if (HEAP32[i4 >> 2] & 7) _cvSeqPush(i1, i4) | 0;
  HEAP32[i4 + 8 >> 2] = i1;
  HEAP32[i4 >> 2] = i5;
  _cvSetSeqBlockSize(i1, 8);
  STACKTOP = i6;
  return;
 }
}

function __ZN2cv10HdrDecoderD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 180128;
 __ZN2cv6String10deallocateEv(i4 + 92 | 0);
 HEAP32[i4 >> 2] = 179344;
 i1 = i4 + 32 | 0;
 i2 = i4 + 68 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i1);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 48 | 0;
 i3 = i4 + 36 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i1 = HEAP32[i4 + 72 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 76 >> 2] | 0;
 if ((i1 | 0) == (i4 + 80 | 0)) {
  i1 = i4 + 24 | 0;
  __ZN2cv6String10deallocateEv(i1);
  i1 = i4 + 16 | 0;
  __ZN2cv6String10deallocateEv(i1);
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 i1 = i4 + 24 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = i4 + 16 | 0;
 __ZN2cv6String10deallocateEv(i1);
 STACKTOP = i5;
 return;
}

function __ZN2cv10BmpDecoderD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 179128;
 __ZN2cv11RBaseStreamD2Ev(i4 + 92 | 0);
 HEAP32[i4 >> 2] = 179344;
 i1 = i4 + 32 | 0;
 i2 = i4 + 68 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i1);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 48 | 0;
 i3 = i4 + 36 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i1 = HEAP32[i4 + 72 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 76 >> 2] | 0;
 if ((i1 | 0) == (i4 + 80 | 0)) {
  i1 = i4 + 24 | 0;
  __ZN2cv6String10deallocateEv(i1);
  i1 = i4 + 16 | 0;
  __ZN2cv6String10deallocateEv(i1);
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 i1 = i4 + 24 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = i4 + 16 | 0;
 __ZN2cv6String10deallocateEv(i1);
 STACKTOP = i5;
 return;
}

function __ZN7testing8internal25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notED0Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 HEAP32[i5 >> 2] = 2416;
 i1 = i5 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  i3 = i5 + 32 | 0;
  while (1) {
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (i2 | 0)) break;
   i4 = i4 + -16 | 0;
   HEAP32[i3 >> 2] = i4;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
  }
  __ZdlPv(HEAP32[i1 >> 2] | 0);
 }
 i4 = i5 + 16 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) {
  i1 = i5 + 4 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
  __ZdlPv(i5);
  STACKTOP = i6;
  return;
 }
 i2 = i5 + 20 | 0;
 while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) break;
  i1 = i1 + -8 | 0;
  HEAP32[i2 >> 2] = i1;
  __ZN7testing8internal10linked_ptrINS0_25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE8TestInfoEED2Ev(i1);
 }
 __ZdlPv(HEAP32[i4 >> 2] | 0);
 i1 = i5 + 4 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 __ZdlPv(i5);
 STACKTOP = i6;
 return;
}

function __Z11FillUniGrayPhRS_iiRiiih(i1, i9, i10, i2, i11, i8, i3, i7) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 i6 = i10 - i2 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 while (1) {
  i2 = i1;
  i4 = i1 + i3 | 0;
  i13 = i4 >>> 0 > i5 >>> 0 ? i5 : i4;
  i3 = i2 - i13 + i3 | 0;
  if (i1 >>> 0 < i13 >>> 0) {
   i13 = ~i5;
   i5 = ~i4;
   i5 = ~i2 - (i13 >>> 0 > i5 >>> 0 ? i13 : i5) | 0;
   i2 = i1 + i5 | 0;
   _memset(i1 | 0, i7 | 0, i5 | 0) | 0;
   do i1 = i1 + 1 | 0; while ((i1 | 0) != (i2 | 0));
   i1 = i2;
   i4 = HEAP32[i9 >> 2] | 0;
  } else i4 = i5;
  if (i1 >>> 0 < i4 >>> 0) if ((i3 | 0) > 0) {
   i5 = i4;
   continue;
  } else {
   i2 = 9;
   break;
  } else {
   i2 = i4 + i10 | 0;
   HEAP32[i9 >> 2] = i2;
   i1 = i4 + i6 | 0;
   i5 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
   HEAP32[i11 >> 2] = i5;
   if ((i5 | 0) < (i8 | 0) & (i3 | 0) > 0) {
    i5 = i2;
    continue;
   } else {
    i2 = 9;
    break;
   }
  }
 }
 if ((i2 | 0) == 9) {
  STACKTOP = i12;
  return i1 | 0;
 }
 return 0;
}

function _memchr(i1, i5, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 i6 = i5 & 255;
 i3 = (i2 | 0) != 0;
 L1 : do if ((i1 & 3 | 0) != 0 & i3) {
  i4 = i5 & 255;
  while (1) {
   if ((HEAP8[i1 >> 0] | 0) == i4 << 24 >> 24) {
    i4 = 6;
    break L1;
   }
   i1 = i1 + 1 | 0;
   i2 = i2 + -1 | 0;
   i3 = (i2 | 0) != 0;
   if (!((i1 & 3 | 0) != 0 & i3)) {
    i4 = 5;
    break;
   }
  }
 } else i4 = 5; while (0);
 if ((i4 | 0) == 5) if (i3) i4 = 6; else i2 = 0;
 L8 : do if ((i4 | 0) == 6) {
  i4 = i5 & 255;
  if ((HEAP8[i1 >> 0] | 0) != i4 << 24 >> 24) {
   i3 = Math_imul(i6, 16843009) | 0;
   L11 : do if (i2 >>> 0 > 3) do {
    i5 = HEAP32[i1 >> 2] ^ i3;
    if ((i5 & -2139062144 ^ -2139062144) & i5 + -16843009) break L11;
    i1 = i1 + 4 | 0;
    i2 = i2 + -4 | 0;
   } while (i2 >>> 0 > 3); while (0);
   if (!i2) i2 = 0; else while (1) {
    if ((HEAP8[i1 >> 0] | 0) == i4 << 24 >> 24) break L8;
    i1 = i1 + 1 | 0;
    i2 = i2 + -1 | 0;
    if (!i2) {
     i2 = 0;
     break;
    }
   }
  }
 } while (0);
 STACKTOP = i7;
 return ((i2 | 0) != 0 ? i1 : 0) | 0;
}

function ___strchrnul(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 i4 = i5 & 255;
 if (!i4) {
  i1 = i1 + (_strlen(i1 | 0) | 0) | 0;
  STACKTOP = i6;
  return i1 | 0;
 }
 L5 : do if (i1 & 3) {
  i3 = i5 & 255;
  i2 = i1;
  while (1) {
   i7 = HEAP8[i2 >> 0] | 0;
   i1 = i2 + 1 | 0;
   if (i7 << 24 >> 24 == 0 ? 1 : i7 << 24 >> 24 == i3 << 24 >> 24) {
    i1 = i2;
    break;
   }
   if (!(i1 & 3)) break L5; else i2 = i1;
  }
  STACKTOP = i6;
  return i1 | 0;
 } while (0);
 i4 = Math_imul(i4, 16843009) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 L12 : do if (!((i2 & -2139062144 ^ -2139062144) & i2 + -16843009)) {
  i3 = i1;
  while (1) {
   i2 = i2 ^ i4;
   i1 = i3 + 4 | 0;
   if ((i2 & -2139062144 ^ -2139062144) & i2 + -16843009) {
    i1 = i3;
    break L12;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 & -2139062144 ^ -2139062144) & i2 + -16843009) break; else i3 = i1;
  }
 } while (0);
 i2 = i5 & 255;
 while (1) {
  i3 = HEAP8[i1 >> 0] | 0;
  if (i3 << 24 >> 24 == 0 ? 1 : i3 << 24 >> 24 == i2 << 24 >> 24) break; else i1 = i1 + 1 | 0;
 }
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN7testing8TestInfoC2ERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_PKcSB_PKvPNS_8internal15TestFactoryBaseE(i7, i1, i2, i3, i4, i6, i5) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i8 = 0;
 i8 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i7, i1);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i7 + 12 | 0, i2);
 if (!i3) i2 = 0; else {
  i2 = __Znwj(12) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i3, _strlen(i3 | 0) | 0);
 }
 HEAP32[i7 + 24 >> 2] = i2;
 if (!i4) i2 = 0; else {
  i2 = __Znwj(12) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i4, _strlen(i4 | 0) | 0);
 }
 HEAP32[i7 + 28 >> 2] = i2;
 HEAP32[i7 + 32 >> 2] = i6;
 HEAP8[i7 + 36 >> 0] = 0;
 HEAP8[i7 + 37 >> 0] = 0;
 HEAP8[i7 + 38 >> 0] = 0;
 HEAP32[i7 + 40 >> 2] = i5;
 i1 = i7 + 52 | 0;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN4perf10RegressionD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i6;
 i3 = i5 + 32 | 0;
 if (__ZNK2cv11FileStorage8isOpenedEv(i3) | 0) __ZN2cv11FileStorage7releaseEv(i3);
 i4 = i5 + 68 | 0;
 if (__ZNK2cv11FileStorage8isOpenedEv(i4) | 0) {
  i1 = HEAP8[i5 + 112 >> 0] | 0;
  if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i5 + 116 >> 2] | 0;
  if (i1) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP8[(__ZN2cv6String8allocateEj(i2, 1) | 0) >> 0] = 125;
   __ZN2cvlsERNS_11FileStorageERKNS_6StringE(i4, i2) | 0;
   __ZN2cv6String10deallocateEv(i2);
  }
  __ZN2cv11FileStorage7releaseEv(i4);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5 + 124 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5 + 112 | 0);
 __ZN2cv11FileStorageD2Ev(i4);
 __ZN2cv11FileStorageD2Ev(i3);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5 + 20 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5 + 8 | 0);
 STACKTOP = i6;
 return;
}

function __Z24icvCvt_BGRA2RGBA_16u_C4RPKtiPti6CvSize(i6, i2, i4, i3, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i12 = STACKTOP;
 i11 = i1 + 4 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i5 = i10 + -1 | 0;
 HEAP32[i11 >> 2] = i5;
 if (!i10) {
  STACKTOP = i12;
  return;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 i9 = i2 >>> 1;
 i7 = i3 >>> 1;
 if ((i10 | 0) > 0) {
  i8 = i10 << 2;
  while (1) {
   i3 = i4;
   i2 = i6;
   i1 = 0;
   while (1) {
    i14 = HEAP16[i2 >> 1] | 0;
    i15 = HEAP16[i2 + 2 >> 1] | 0;
    i13 = HEAP16[i2 + 6 >> 1] | 0;
    HEAP16[i3 >> 1] = HEAP16[i2 + 4 >> 1] | 0;
    HEAP16[i3 + 2 >> 1] = i15;
    HEAP16[i3 + 4 >> 1] = i14;
    HEAP16[i3 + 6 >> 1] = i13;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i10 | 0)) break; else {
     i3 = i3 + 8 | 0;
     i2 = i2 + 8 | 0;
    }
   }
   i2 = i10 << 2;
   if (!i5) break; else {
    i4 = i4 + (i8 + (i7 - i2) << 1) | 0;
    i6 = i6 + (i8 + (i9 - i2) << 1) | 0;
    i5 = i5 + -1 | 0;
   }
  }
 }
 HEAP32[i11 >> 2] = -1;
 STACKTOP = i12;
 return;
}

function __ZNSt3__16vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEC2IPKPKcEET_NS_9enable_ifIXaasr21__is_forward_iteratorISE_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISE_E9referenceEEE5valueESE_E4typeE(i5, i2, i7) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i3 = i5 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i7 - i2 >> 2;
 if (!i4) {
  STACKTOP = i8;
  return;
 }
 if (i4 >>> 0 > 357913941) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i1 = __Znwj(i4 * 12 | 0) | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i3 >> 2] = i1 + (i4 * 12 | 0);
 if ((i2 | 0) == (i7 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  if (!i1) i1 = 0; else {
   i3 = HEAP32[i2 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i3, _strlen(i3 | 0) | 0);
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i1 = i1 + 12 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i7 | 0));
 STACKTOP = i8;
 return;
}

function __ZN2cvL12scaleAdd_64fEPKdS1_PdiS2_(i6, i7, i4, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, i8 = 0, i9 = 0, d10 = 0.0, i11 = 0;
 i8 = STACKTOP;
 d3 = +HEAPF64[i1 >> 3];
 i1 = i5 + -4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i2 = 0;
  do {
   i11 = i2 | 1;
   d10 = d3 * +HEAPF64[i6 + (i11 << 3) >> 3] + +HEAPF64[i7 + (i11 << 3) >> 3];
   HEAPF64[i4 + (i2 << 3) >> 3] = d3 * +HEAPF64[i6 + (i2 << 3) >> 3] + +HEAPF64[i7 + (i2 << 3) >> 3];
   HEAPF64[i4 + (i11 << 3) >> 3] = d10;
   i11 = i2 | 2;
   i9 = i2 | 3;
   d10 = d3 * +HEAPF64[i6 + (i9 << 3) >> 3] + +HEAPF64[i7 + (i9 << 3) >> 3];
   HEAPF64[i4 + (i11 << 3) >> 3] = d3 * +HEAPF64[i6 + (i11 << 3) >> 3] + +HEAPF64[i7 + (i11 << 3) >> 3];
   HEAPF64[i4 + (i9 << 3) >> 3] = d10;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) <= (i1 | 0));
  i1 = i5 & -4;
 }
 if ((i1 | 0) >= (i5 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  HEAPF64[i4 + (i1 << 3) >> 3] = d3 * +HEAPF64[i6 + (i1 << 3) >> 3] + +HEAPF64[i7 + (i1 << 3) >> 3];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i8;
 return;
}

function __ZN2cv16BaseImageDecoderD0Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 179344;
 i1 = i4 + 32 | 0;
 i2 = i4 + 68 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i1);
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 48 | 0;
 i3 = i4 + 36 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 72 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 76 >> 2] | 0;
 if ((i1 | 0) == (i4 + 80 | 0)) {
  i1 = i4 + 24 | 0;
  __ZN2cv6String10deallocateEv(i1);
  i1 = i4 + 16 | 0;
  __ZN2cv6String10deallocateEv(i1);
  __ZdlPv(i4);
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 i1 = i4 + 24 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = i4 + 16 | 0;
 __ZN2cv6String10deallocateEv(i1);
 __ZdlPv(i4);
 STACKTOP = i5;
 return;
}

function __ZN7testing8internal25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notED2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 HEAP32[i5 >> 2] = 2416;
 i1 = i5 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  i3 = i5 + 32 | 0;
  while (1) {
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (i2 | 0)) break;
   i4 = i4 + -16 | 0;
   HEAP32[i3 >> 2] = i4;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
  }
  __ZdlPv(HEAP32[i1 >> 2] | 0);
 }
 i4 = i5 + 16 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) {
  i1 = i5 + 4 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
  STACKTOP = i6;
  return;
 }
 i2 = i5 + 20 | 0;
 while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) break;
  i1 = i1 + -8 | 0;
  HEAP32[i2 >> 2] = i1;
  __ZN7testing8internal10linked_ptrINS0_25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE8TestInfoEED2Ev(i1);
 }
 __ZdlPv(HEAP32[i4 >> 2] | 0);
 i1 = i5 + 4 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 STACKTOP = i6;
 return;
}

function __ZNSt3__16vectorIN2cv6StringENS_9allocatorIS2_EEEC2ERKS5_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 HEAP32[i6 >> 2] = 0;
 i8 = i6 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 i2 = i6 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 i7 = i5 + 4 | 0;
 i3 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
 i4 = i3 >> 3;
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 if (i4 >>> 0 > 536870911) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i6);
 i1 = __Znwj(i3) | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i2 >> 2] = i1 + (i4 << 3);
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  if (i1) {
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   if (i3) {
    i1 = i3 + -4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = HEAP32[i8 >> 2] | 0;
   }
  } else i1 = 0;
  i1 = i1 + 8 | 0;
  HEAP32[i8 >> 2] = i1;
  i2 = i2 + 8 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZNKSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc(i10, i7, i8, i1, i2, i6, i4, i3) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i5 = i9 + 4 | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = i5 + 100;
 __ZNKSt3__110__time_put8__do_putEPcRS1_PK2tmcc(i7 + 8 | 0, i5, i1, i6, i4, i3);
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i5 | 0) == (i7 | 0)) {
  HEAP32[i10 >> 2] = i1;
  STACKTOP = i9;
  return;
 }
 do {
  i4 = HEAP8[i5 >> 0] | 0;
  do if (i1) {
   i2 = i1 + 24 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 28 >> 2] | 0)) {
    i2 = (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] & 127](i1, i4 & 255) | 0) == -1;
    i1 = i2 ? 0 : i1;
    break;
   } else {
    HEAP32[i2 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i4;
    break;
   }
  } else i1 = 0; while (0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i7 | 0));
 HEAP32[i10 >> 2] = i1;
 STACKTOP = i9;
 return;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i10, i9, i1, i4, i7, i8, i6) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i11 = 0;
 i11 = STACKTOP;
 if ((1073741807 - i9 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i10);
 if (!(HEAP8[i10 >> 0] & 1)) i5 = i10 + 4 | 0; else i5 = HEAP32[i10 + 8 >> 2] | 0;
 if (i9 >>> 0 < 536870887) {
  i1 = i1 + i9 | 0;
  i3 = i9 << 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  if (i1 >>> 0 < 2) i2 = 2; else i2 = i1 + 4 & -4;
 } else i2 = 1073741807;
 i3 = __Znwj(i2 << 2) | 0;
 if (i7) _wmemcpy(i3, i5, i7) | 0;
 i1 = i4 - i8 | 0;
 if ((i1 | 0) != (i7 | 0)) _wmemcpy(i3 + (i6 + i7 << 2) | 0, i5 + (i8 + i7 << 2) | 0, i1 - i7 | 0) | 0;
 if ((i9 | 0) == 1) {
  i9 = i10 + 8 | 0;
  HEAP32[i9 >> 2] = i3;
  i9 = i2 | 1;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i5);
 i9 = i10 + 8 | 0;
 HEAP32[i9 >> 2] = i3;
 i9 = i2 | 1;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i11;
 return;
}

function __ZN7testing8internal35HandleExceptionsInMethodIfSupportedINS_8TestCaseEvEET0_PT_MS4_FS3_vEPKc(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 i1 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 i2 = i2 + 4 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i5 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i5, 163728);
  HEAP32[40934] = i5;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i3 = i3 + (i2 >> 1) | 0;
 i2 = (i2 & 1 | 0) == 0;
 if (!(HEAP8[(HEAP32[40934] | 0) + 212 >> 0] | 0)) {
  if (!i2) i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + i1 >> 2] | 0;
  FUNCTION_TABLE_vi[i1 & 511](i3);
  STACKTOP = i4;
  return;
 } else {
  if (!i2) i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + i1 >> 2] | 0;
  FUNCTION_TABLE_vi[i1 & 511](i3);
  STACKTOP = i4;
  return;
 }
}

function __ZN2cv4UMat5setToERKNS_11_InputArrayES3_(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i4 = i6;
 i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 76 >> 2] & 127](i2) | 0;
 __ZNK2cv4UMat6getMatEi(i4, i5, i3 ? 33554432 : 50331648);
 __ZN2cv3Mat5setToERKNS_11_InputArrayES3_(i4, i1, i2) | 0;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i3 = i2 + 12 | 0, i2 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i2 + -1, (i2 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i4);
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 16 | 0;
 i2 = i4 + 4 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = HEAP32[i4 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 44 >> 2] | 0;
 if ((i1 | 0) == (i4 + 48 | 0)) {
  STACKTOP = i6;
  return i5 | 0;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN7testing8internal35HandleExceptionsInMethodIfSupportedINS_4TestEvEET0_PT_MS4_FS3_vEPKc(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 i1 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 i2 = i2 + 4 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i5 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i5, 163728);
  HEAP32[40934] = i5;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i3 = i3 + (i2 >> 1) | 0;
 i2 = (i2 & 1 | 0) == 0;
 if (!(HEAP8[(HEAP32[40934] | 0) + 212 >> 0] | 0)) {
  if (!i2) i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + i1 >> 2] | 0;
  FUNCTION_TABLE_vi[i1 & 511](i3);
  STACKTOP = i4;
  return;
 } else {
  if (!i2) i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + i1 >> 2] | 0;
  FUNCTION_TABLE_vi[i1 & 511](i3);
  STACKTOP = i4;
  return;
 }
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm(i12, i13, i1, i2, i10, i9, i11) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i14 + 12 | 0;
 i5 = i14 + 8 | 0;
 i7 = i14 + 4 | 0;
 i8 = i14;
 i4 = i13 + 8 | 0;
 i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] & 127](i4) | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 i1 = HEAP8[i4 >> 0] | 0;
 if (!(i1 & 1)) {
  i3 = i4 + 4 | 0;
  i2 = (i1 & 255) >>> 1;
  i1 = i4 + 4 | 0;
 } else {
  i1 = HEAP32[i4 + 8 >> 2] | 0;
  i3 = i1;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
 }
 HEAP32[i5 + 0 >> 2] = HEAP32[i7 + 0 >> 2];
 HEAP32[i6 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i12, i13, i5, i6, i10, i9, i11, i1, i3 + (i2 << 2) | 0);
 STACKTOP = i14;
 return;
}

function __ZNK2cv11FileStorage4rootEi(i8, i1, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i9;
 if (!(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 127](i1) | 0)) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = (i6 | 0) != 0;
 if (!(i1 ? (HEAP32[i6 >> 2] | 0) == 1280131417 : 0)) {
  i1 = i1 ? -5 : -27;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i2 = (__ZN2cv6String8allocateEj(i5, 31) | 0) + 0 | 0;
  i3 = 9096 | 0;
  i4 = i2 + 31 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(i1, i5, 9288, 8960, 772);
  __ZN2cv6String10deallocateEv(i5);
 }
 i1 = HEAP32[i6 + 32 >> 2] | 0;
 if ((i1 | 0) != 0 ? (HEAP32[i1 + 24 >> 2] | 0) >>> 0 > i7 >>> 0 : 0) i1 = _cvGetSeqElem(i1, i7) | 0; else i1 = 0;
 HEAP32[i8 >> 2] = i6;
 HEAP32[i8 + 4 >> 2] = i1;
 STACKTOP = i9;
 return;
}

function __ZL20icvXMLEndWriteStructP13CvFileStorage(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i4 = i6 + 8 | 0;
 i1 = i6;
 i2 = i3 + 36 | 0;
 if (!(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i1, 20) | 0) + 0 | 0;
  i7 = 17248 | 0;
  i8 = i5 + 20 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i7 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i7 = i7 + 1 | 0;
  } while ((i5 | 0) < (i8 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-2, i1, 17272, 8960, 2408);
  __ZN2cv6String10deallocateEv(i1);
 }
 __ZL14icvXMLWriteTagP13CvFileStoragePKci10CvAttrList(i3, HEAP32[i3 + 52 >> 2] | 0, 2, 0, 0);
 _cvSeqPop(HEAP32[i2 >> 2] | 0, i4);
 HEAP32[i3 + 40 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 44 >> 2] = HEAP32[i4 + 20 >> 2];
 i5 = i4 + 8 | 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i3 + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 _cvRestoreMemStoragePos(HEAP32[i3 + 24 >> 2] | 0, i4);
 STACKTOP = i6;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i10, i9, i1, i4, i7, i8, i6) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i11 = 0;
 i11 = STACKTOP;
 if ((-17 - i9 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i10);
 if (!(HEAP8[i10 >> 0] & 1)) i5 = i10 + 1 | 0; else i5 = HEAP32[i10 + 8 >> 2] | 0;
 if (i9 >>> 0 < 2147483623) {
  i1 = i1 + i9 | 0;
  i3 = i9 << 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  if (i1 >>> 0 < 11) i2 = 11; else i2 = i1 + 16 & -16;
 } else i2 = -17;
 i3 = __Znwj(i2) | 0;
 if (i7) _memcpy(i3 | 0, i5 | 0, i7 | 0) | 0;
 i1 = i4 - i8 | 0;
 if ((i1 | 0) != (i7 | 0)) _memcpy(i3 + (i6 + i7) | 0, i5 + (i8 + i7) | 0, i1 - i7 | 0) | 0;
 if ((i9 | 0) == 10) {
  i9 = i10 + 8 | 0;
  HEAP32[i9 >> 2] = i3;
  i9 = i2 | 1;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i5);
 i9 = i10 + 8 | 0;
 HEAP32[i9 >> 2] = i3;
 i9 = i2 | 1;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i11;
 return;
}

function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj(i4, i5, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 i1 = i5 + 64 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 0 ? (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] & 127](i5) | 0) == 0 : 0) if (!(_fseeko(HEAP32[i1 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, 0) | 0)) {
  i7 = i3;
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  i1 = i5 + 72 | 0;
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = i6;
  HEAP32[i4 + 0 >> 2] = HEAP32[i3 + 0 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i2;
  return;
 } else {
  i1 = i4;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i1 = i4 + 8 | 0;
  HEAP32[i1 >> 2] = -1;
  HEAP32[i1 + 4 >> 2] = -1;
  STACKTOP = i2;
  return;
 }
 i1 = i4;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = -1;
 STACKTOP = i2;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm(i12, i13, i1, i2, i10, i9, i11) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i14 + 12 | 0;
 i5 = i14 + 8 | 0;
 i7 = i14 + 4 | 0;
 i8 = i14;
 i4 = i13 + 8 | 0;
 i4 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] & 127](i4) | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 i1 = HEAP8[i4 >> 0] | 0;
 if (!(i1 & 1)) {
  i3 = i4 + 1 | 0;
  i2 = (i1 & 255) >>> 1;
  i1 = i4 + 1 | 0;
 } else {
  i1 = HEAP32[i4 + 8 >> 2] | 0;
  i3 = i1;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
 }
 HEAP32[i5 + 0 >> 2] = HEAP32[i7 + 0 >> 2];
 HEAP32[i6 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i12, i13, i5, i6, i10, i9, i11, i1, i3 + i2 | 0);
 STACKTOP = i14;
 return;
}

function _cvRestoreMemStoragePos(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i8 + 8 | 0;
 i4 = i8;
 if (!((i7 | 0) != 0 & (i5 | 0) != 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 39720, 39608, 288);
  __ZN2cv6String10deallocateEv(i1);
 }
 i2 = i5 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i6 = i7 + 16 | 0;
 if ((i3 | 0) > (HEAP32[i6 >> 2] | 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i4, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i4, 39720, 39608, 290);
  __ZN2cv6String10deallocateEv(i4);
  i3 = HEAP32[i2 >> 2] | 0;
 }
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = i7 + 8 | 0;
 HEAP32[i1 >> 2] = i4;
 i2 = i7 + 20 | 0;
 HEAP32[i2 >> 2] = i3;
 if (i4) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 if (!i3) i1 = 0; else i1 = (HEAP32[i6 >> 2] | 0) + -8 | 0;
 HEAP32[i2 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN2cv11WBaseStream10writeBlockEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 i9 = i13 + 12 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i11 = i13 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i10 - i1 | 0;
 if ((i10 | 0) == (i1 | 0)) {
  STACKTOP = i14;
  return;
 }
 i7 = i13 + 32 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (!i8) _fwrite(i1 | 0, 1, i12 | 0, HEAP32[i13 + 24 >> 2] | 0) | 0; else {
  i3 = i8 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i10 = i4 - i2 | 0;
  i5 = i10 + i12 | 0;
  if (i10 >>> 0 >= i5 >>> 0) {
   if (i10 >>> 0 > i5 >>> 0 ? (i6 = i2 + i5 | 0, (i4 | 0) != (i6 | 0)) : 0) HEAP32[i3 >> 2] = i6;
  } else {
   __ZNSt3__16vectorIhNS_9allocatorIhEEE8__appendEj(i8, i12);
   i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  _memcpy(i2 + i10 | 0, i1 | 0, i12 | 0) | 0;
 }
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 i10 = i13 + 20 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i12;
 STACKTOP = i14;
 return;
}

function __ZN2cv16BaseImageDecoder9setSourceERKNS_6StringE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 i2 = i4 + 16 | 0;
 if ((i2 | 0) != (i1 | 0)) {
  __ZN2cv6String10deallocateEv(i2);
  i3 = HEAP32[i1 >> 2] | 0;
  if (!i3) i3 = 0; else {
   i3 = i3 + -4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = HEAP32[i1 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i3;
  HEAP32[i4 + 20 >> 2] = HEAP32[i1 + 4 >> 2];
 }
 i2 = i4 + 32 | 0;
 i1 = i4 + 68 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i2);
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 48 | 0;
 i3 = i4 + 36 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) <= 0) {
  STACKTOP = i5;
  return 1;
 }
 i1 = HEAP32[i4 + 72 >> 2] | 0;
 i2 = 0;
 do {
  HEAP32[i1 + (i2 << 2) >> 2] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
 STACKTOP = i5;
 return 1;
}

function __ZNK7testing8internal8FilePath27RemoveTrailingPathSeparatorEv(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i8;
 i3 = HEAP8[i7 >> 0] | 0;
 i4 = (i3 & 1) == 0;
 if (i4) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i7 + 4 >> 2] | 0;
 if (i1) {
  if (i4) {
   i1 = (i3 & 255) >>> 1;
   i2 = i7 + 1 | 0;
  } else {
   i1 = HEAP32[i7 + 4 >> 2] | 0;
   i2 = HEAP32[i7 + 8 >> 2] | 0;
  }
  if ((HEAP8[i2 + (i1 + -1) >> 0] | 0) == 47) {
   if (i4) i1 = (i3 & 255) >>> 1; else i1 = HEAP32[i7 + 4 >> 2] | 0;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_jjRKS4_(i5, i7, 0, i1 + -1 | 0, i7);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i6, i5);
   __ZN7testing8internal8FilePath9NormalizeEv(i6);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
   STACKTOP = i8;
   return;
  }
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i6, i7);
 STACKTOP = i8;
 return;
}

function _cvGraphAddVtx(i5, i4, i6) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i8 + 8 | 0;
 i2 = i8;
 if (!i5) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i2, 40544, 39608, 2615);
  __ZN2cv6String10deallocateEv(i2);
 }
 i2 = i5 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 if (!i1) {
  _cvSetAdd(i5, 0, i3) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) i1 = -1; else {
   i3 = i2;
   i7 = 6;
  }
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 67108863;
  i3 = i5 + 60 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = i1;
  i2 = i1;
  i7 = 6;
 }
 if ((i7 | 0) == 6) {
  if (i4) _memcpy(i3 + 8 | 0, i4 + 8 | 0, (HEAP32[i5 + 28 >> 2] | 0) + -8 | 0) | 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if (!i6) {
  STACKTOP = i8;
  return i1 | 0;
 }
 HEAP32[i6 >> 2] = i2;
 STACKTOP = i8;
 return i1 | 0;
}

function __Z22icvCvt_BGR2RGB_16u_C3RPKtiPti6CvSize(i3, i11, i2, i12, i1) {
 i3 = i3 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 i10 = i1 + 4 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i4 = i9 + -1 | 0;
 HEAP32[i10 >> 2] = i4;
 if (!i9) {
  STACKTOP = i13;
  return;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = (i7 | 0) > 0;
 i9 = i7 * 3 | 0;
 i6 = i4;
 while (1) {
  if (i8) {
   i1 = i2 + (i9 << 1) | 0;
   i4 = i3;
   i5 = 0;
   while (1) {
    i15 = HEAP16[i4 + 2 >> 1] | 0;
    i14 = HEAP16[i4 + 4 >> 1] | 0;
    HEAP16[i2 + 4 >> 1] = HEAP16[i4 >> 1] | 0;
    HEAP16[i2 + 2 >> 1] = i15;
    HEAP16[i2 >> 1] = i14;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i7 | 0)) break; else {
     i2 = i2 + 6 | 0;
     i4 = i4 + 6 | 0;
    }
   }
   i3 = i3 + (i9 << 1) | 0;
  } else i1 = i2;
  if (!i6) break; else {
   i2 = i1 + (i12 - i9 << 1) | 0;
   i3 = i3 + (i11 - i9 << 1) | 0;
   i6 = i6 + -1 | 0;
  }
 }
 HEAP32[i10 >> 2] = -1;
 STACKTOP = i13;
 return;
}

function __ZN7testing10TestResultD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 i2 = i5 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1) {
  i3 = i5 + 20 | 0;
  while (1) {
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (i1 | 0)) break;
   i7 = i4 + -24 | 0;
   HEAP32[i3 >> 2] = i7;
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4 + -12 | 0);
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
  }
  __ZdlPv(HEAP32[i2 >> 2] | 0);
 }
 i4 = i5 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 i1 = i5 + 8 | 0;
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) break;
  HEAP32[i1 >> 2] = i2 + -44;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2 + -12 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2 + -24 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2 + -40 | 0);
 }
 __ZdlPv(HEAP32[i4 >> 2] | 0);
 STACKTOP = i6;
 return;
}

function __ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 L1 : while (1) {
  i5 = i2 + 1 | 0;
  while (1) {
   i4 = HEAP8[i1 >> 0] | 0;
   i3 = i4 << 24 >> 24;
   if ((i3 | 0) == 58 | (i3 | 0) == 0) {
    i3 = 4;
    break L1;
   } else if ((i3 | 0) == 63) {
    i3 = 5;
    break;
   } else if ((i3 | 0) != 42) {
    i3 = 10;
    break;
   }
   if ((HEAP8[i2 >> 0] | 0) != 0 ? __ZN7testing8internal15UnitTestOptions20PatternMatchesStringEPKcS3_(i1, i5) | 0 : 0) {
    i1 = 1;
    i3 = 11;
    break L1;
   }
   i1 = i1 + 1 | 0;
  }
  if ((i3 | 0) == 5) {
   if (!(HEAP8[i2 >> 0] | 0)) {
    i1 = 0;
    i3 = 11;
    break;
   }
  } else if ((i3 | 0) == 10 ? (0, i4 << 24 >> 24 != (HEAP8[i2 >> 0] | 0)) : 0) {
   i1 = 0;
   i3 = 11;
   break;
  }
  i1 = i1 + 1 | 0;
  i2 = i5;
 }
 if ((i3 | 0) == 4) {
  i1 = (HEAP8[i2 >> 0] | 0) == 0;
  STACKTOP = i6;
  return i1 | 0;
 } else if ((i3 | 0) == 11) {
  STACKTOP = i6;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cv9ExceptionC2EiRKNS_6StringES3_S3_i(i6, i1, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i7 = 0;
 i7 = STACKTOP;
 HEAP32[i6 >> 2] = 18928;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = i1;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i6 + 16 >> 2] = i1;
 HEAP32[i6 + 20 >> 2] = HEAP32[i2 + 4 >> 2];
 if (i1) {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = HEAP32[i3 + 4 >> 2];
 if (i1) {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 + 32 >> 2] = i1;
 HEAP32[i6 + 36 >> 2] = HEAP32[i4 + 4 >> 2];
 if (!i1) {
  i1 = i6 + 40 | 0;
  HEAP32[i1 >> 2] = i5;
  __ZN2cv9Exception13formatMessageEv(i6);
  STACKTOP = i7;
  return;
 }
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i6 + 40 | 0;
 HEAP32[i1 >> 2] = i5;
 __ZN2cv9Exception13formatMessageEv(i6);
 STACKTOP = i7;
 return;
}

function _cvFindGraphEdgeByPtr(i1, i4, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i6;
 if (!((i1 | 0) != 0 & (i4 | 0) != 0 & (i3 | 0) != 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i2, 40560, 39608, 2700);
  __ZN2cv6String10deallocateEv(i2);
 }
 if ((i4 | 0) == (i3 | 0)) {
  i1 = 0;
  STACKTOP = i6;
  return i1 | 0;
 }
 if (!(HEAP32[i1 >> 2] & 16384)) {
  i1 = (HEAP32[i4 >> 2] & 67108863) >>> 0 > (HEAP32[i3 >> 2] & 67108863) >>> 0;
  i5 = i1 ? i3 : i4;
  i3 = i1 ? i4 : i3;
 } else i5 = i4;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  STACKTOP = i6;
  return i1 | 0;
 }
 while (1) {
  i2 = HEAP32[i1 + 20 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) {
   i2 = 9;
   break;
  }
  i1 = HEAP32[i1 + (((i5 | 0) == (i2 | 0) & 1) << 2) + 8 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i2 = 9;
   break;
  }
 }
 if ((i2 | 0) == 9) {
  STACKTOP = i6;
  return i1 | 0;
 }
 return 0;
}

function __ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i5, i4, i3, i7, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0;
 i6 = STACKTOP;
 if ((HEAP32[i4 + 8 >> 2] | 0) == (i5 | 0)) {
  if ((HEAP32[i4 + 4 >> 2] | 0) != (i3 | 0)) {
   STACKTOP = i6;
   return;
  }
  i1 = i4 + 28 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 1) {
   STACKTOP = i6;
   return;
  }
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i6;
  return;
 }
 if ((HEAP32[i4 >> 2] | 0) != (i5 | 0)) {
  STACKTOP = i6;
  return;
 }
 if ((HEAP32[i4 + 16 >> 2] | 0) != (i3 | 0) ? (i2 = i4 + 20 | 0, (HEAP32[i2 >> 2] | 0) != (i3 | 0)) : 0) {
  HEAP32[i4 + 32 >> 2] = i7;
  HEAP32[i2 >> 2] = i3;
  i1 = i4 + 40 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  if ((HEAP32[i4 + 36 >> 2] | 0) == 1 ? (HEAP32[i4 + 24 >> 2] | 0) == 2 : 0) HEAP8[i4 + 54 >> 0] = 1;
  HEAP32[i4 + 44 >> 2] = 4;
  STACKTOP = i6;
  return;
 }
 if ((i7 | 0) != 1) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i4 + 32 >> 2] = 1;
 STACKTOP = i6;
 return;
}

function __ZNKSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc(i9, i6, i7, i2, i1, i5, i4, i3) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 i2 = i8 + 8 | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = i2 + 400;
 __ZNKSt3__110__time_put8__do_putEPwRS1_PK2tmcc(i6 + 8 | 0, i2, i1, i5, i4, i3);
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) == (i5 | 0)) {
  HEAP32[i9 >> 2] = i1;
  STACKTOP = i8;
  return;
 } else i6 = i2;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i3 = i1 + 24 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i1 + 28 >> 2] | 0)) i2 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] & 127](i1, i2) | 0; else {
    HEAP32[i3 >> 2] = i4 + 4;
    HEAP32[i4 >> 2] = i2;
   }
   i1 = (i2 | 0) == -1 ? 0 : i1;
  }
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) != (i5 | 0));
 HEAP32[i9 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i(i2, i6, i3, i1, i4) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 HEAP8[i6 + 53 >> 0] = 1;
 if ((HEAP32[i6 + 4 >> 2] | 0) != (i1 | 0)) {
  STACKTOP = i5;
  return;
 }
 HEAP8[i6 + 52 >> 0] = 1;
 i2 = i6 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = i3;
  HEAP32[i6 + 24 >> 2] = i4;
  HEAP32[i6 + 36 >> 2] = 1;
  if (!((i4 | 0) == 1 ? (HEAP32[i6 + 48 >> 2] | 0) == 1 : 0)) {
   STACKTOP = i5;
   return;
  }
  HEAP8[i6 + 54 >> 0] = 1;
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) != (i3 | 0)) {
  i1 = i6 + 36 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  HEAP8[i6 + 54 >> 0] = 1;
  STACKTOP = i5;
  return;
 }
 i2 = i6 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == 2) {
  HEAP32[i2 >> 2] = i4;
  i1 = i4;
 }
 if (!((i1 | 0) == 1 ? (HEAP32[i6 + 48 >> 2] | 0) == 1 : 0)) {
  STACKTOP = i5;
  return;
 }
 HEAP8[i6 + 54 >> 0] = 1;
 STACKTOP = i5;
 return;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 i1 = HEAP8[i6 >> 0] | 0;
 i2 = (i1 & 1) != 0;
 if (i2) {
  i3 = (HEAP32[i6 >> 2] & -2) + -1 | 0;
  i4 = HEAP32[i6 + 4 >> 2] | 0;
 } else {
  i3 = 1;
  i4 = (i1 & 255) >>> 1;
 }
 if ((i4 | 0) == (i3 | 0)) {
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i6, i3, 1, i3, i3, 0, 0);
  if (!(HEAP8[i6 >> 0] & 1)) i1 = 7; else i1 = 8;
 } else if (i2) i1 = 8; else i1 = 7;
 if ((i1 | 0) == 7) {
  HEAP8[i6 >> 0] = (i4 << 1) + 2;
  i2 = i6 + 4 | 0;
  i1 = i4 + 1 | 0;
  i3 = i2 + (i4 << 2) | 0;
  HEAP32[i3 >> 2] = i5;
  i1 = i2 + (i1 << 2) | 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i7;
  return;
 } else if ((i1 | 0) == 8) {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i4 + 1 | 0;
  HEAP32[i6 + 4 >> 2] = i1;
  i3 = i2 + (i4 << 2) | 0;
  HEAP32[i3 >> 2] = i5;
  i1 = i2 + (i1 << 2) | 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
}

function __Z12FillGrayRow4PhS_iS_(i9, i8, i1, i11) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 i10 = i9 + i1 | 0;
 i2 = i9 + 2 | 0;
 if ((i1 | 0) > 2) {
  i6 = i9 + 4 | 0;
  i6 = ((i10 >>> 0 > i6 >>> 0 ? i10 : i6) + (-3 - i9) | 0) >>> 1;
  i5 = i6 << 1;
  i7 = i5 + 4 | 0;
  i6 = i6 + 1 | 0;
  i5 = i5 + 2 | 0;
  i4 = i8;
  i3 = i9;
  while (1) {
   i1 = HEAPU8[i4 >> 0] | 0;
   HEAP8[i3 >> 0] = HEAP8[i11 + (i1 >>> 4) >> 0] | 0;
   HEAP8[i3 + 1 >> 0] = HEAP8[i11 + (i1 & 15) >> 0] | 0;
   i1 = i2 + 2 | 0;
   if (i1 >>> 0 < i10 >>> 0) {
    i3 = i2;
    i4 = i4 + 1 | 0;
    i2 = i1;
   } else break;
  }
  i3 = i9 + i5 | 0;
  i1 = i8 + i6 | 0;
  i2 = i9 + i7 | 0;
 } else {
  i3 = i9;
  i1 = i8;
 }
 i1 = HEAPU8[i1 >> 0] | 0;
 HEAP8[i3 >> 0] = HEAP8[i11 + (i1 >>> 4) >> 0] | 0;
 if ((i2 | 0) != (i10 | 0)) {
  STACKTOP = i12;
  return i10 | 0;
 }
 HEAP8[i3 + 1 >> 0] = HEAP8[i11 + (i1 & 15) >> 0] | 0;
 STACKTOP = i12;
 return i10 | 0;
}

function __ZN7testing8internal14ParseInt32FlagEPKcS2_Pi(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i7;
 i1 = __ZN7testing8internalL14ParseFlagValueEPKcS2_b(i1, i4, 0) | 0;
 if (!i1) {
  i1 = 0;
  STACKTOP = i7;
  return i1 | 0;
 }
 __ZN7testing7MessageC2Ev(i6);
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = i3 + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 164568, 20) | 0;
 if (!i4) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i4, _strlen(i4 | 0) | 0) | 0;
 i1 = __ZN7testing8internal10ParseInt32ERKNS_7MessageEPKcPi(i6, i1, i5) | 0;
 if (!i3) {
  STACKTOP = i7;
  return i1 | 0;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNK2cv16BaseImageEncoder11throwOnErorEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i9 + 8 | 0;
 i5 = i9;
 i6 = i8 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 __ZN2cv6String8allocateEj(i7, i1 + 25 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 0 | 0;
 i3 = 179432 | 0;
 i4 = i2 + 25 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 _memcpy(i1 + 25 | 0, HEAP32[i8 + 28 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? 179608 : i2;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = _strlen(i2 | 0) | 0;
 _memcpy(__ZN2cv6String8allocateEj(i5, i1) | 0, i2 | 0, i1 | 0) | 0;
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-10, i5, 179464, 179480, 131);
 __ZN2cv6String10deallocateEv(i5);
 __ZN2cv6String10deallocateEv(i7);
 STACKTOP = i9;
 return;
}

function __ZN2cv3ocl13ProgramSource4ImplC2EPKc(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i7;
 i1 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i6 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 if (i2) {
  i8 = _strlen(i2 | 0) | 0;
  _memcpy(__ZN2cv6String8allocateEj(i5, i8) | 0, i2 | 0, i8 | 0) | 0;
 }
 HEAP32[i6 >> 2] = 1;
 if ((i1 | 0) == (i5 | 0)) {
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  __ZN2cv6String10deallocateEv(i1);
  i2 = HEAP32[i5 >> 2] | 0;
  if (!i2) i2 = 0; else {
   i2 = i2 + -4 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   i2 = HEAP32[i5 >> 2] | 0;
  }
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
 }
 i2 = __ZN2cv3oclL5crc64EPKhjy((i2 | 0) == 0 ? 44440 : i2, i1) | 0;
 i1 = i6 + 16 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = tempRet0;
 __ZN2cv6String10deallocateEv(i5);
 STACKTOP = i7;
 return;
}

function _inflateInit2_(i6, i7, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 if (!i1) {
  i1 = -6;
  STACKTOP = i8;
  return i1 | 0;
 }
 if ((HEAP8[i1 >> 0] | 0) != 49 | (i2 | 0) != 56) {
  i1 = -6;
  STACKTOP = i8;
  return i1 | 0;
 }
 if (!i6) {
  i1 = -2;
  STACKTOP = i8;
  return i1 | 0;
 }
 HEAP32[i6 + 24 >> 2] = 0;
 i1 = i6 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 32;
  HEAP32[i6 + 40 >> 2] = 0;
  i2 = 32;
 }
 i4 = i6 + 36 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) HEAP32[i4 >> 2] = 110;
 i5 = i6 + 40 | 0;
 i1 = FUNCTION_TABLE_iiii[i2 & 63](HEAP32[i5 >> 2] | 0, 1, 7116) | 0;
 if (!i1) {
  i1 = -4;
  STACKTOP = i8;
  return i1 | 0;
 }
 i3 = i6 + 28 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i1 + 52 >> 2] = 0;
 i2 = _inflateReset2(i6, i7) | 0;
 if (!i2) {
  i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 }
 FUNCTION_TABLE_vii[HEAP32[i4 >> 2] & 127](HEAP32[i5 >> 2] | 0, i1);
 HEAP32[i3 >> 2] = 0;
 i1 = i2;
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN2cv12WLByteStream7putWordEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 i4 = i6 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i6 + 8 | 0;
 i3 = i7 & 255;
 if (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i1 >> 0] = i3;
  HEAP8[i2 >> 0] = i7 >>> 8;
  i1 = i1 + 2 | 0;
  HEAP32[i4 >> 2] = i1;
  if ((i1 | 0) != (HEAP32[i5 >> 2] | 0)) {
   STACKTOP = i8;
   return;
  }
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
  STACKTOP = i8;
  return;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP8[i1 >> 0] = i3;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i7 >>> 8;
 if ((HEAP32[i4 >> 2] | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  STACKTOP = i8;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 511](i6);
 STACKTOP = i8;
 return;
}

function _vsnprintf(i3, i1, i9, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i2 = i10 + 112 | 0;
 i8 = i10;
 i4 = i8 + 0 | 0;
 i5 = 971544 | 0;
 i6 = i4 + 112 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 if ((i1 + -1 | 0) >>> 0 > 2147483646) if (!i1) i1 = 1; else {
  HEAP32[(___errno_location() | 0) >> 2] = 75;
  i1 = -1;
  STACKTOP = i10;
  return i1 | 0;
 } else i2 = i3;
 i4 = -2 - i2 | 0;
 i4 = i1 >>> 0 > i4 >>> 0 ? i4 : i1;
 HEAP32[i8 + 48 >> 2] = i4;
 i3 = i8 + 20 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i8 + 44 >> 2] = i2;
 i1 = i2 + i4 | 0;
 i2 = i8 + 16 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i8 + 28 >> 2] = i1;
 i1 = _MUSL_vfprintf(i8, i9, i7) | 0;
 if (!i4) {
  STACKTOP = i10;
  return i1 | 0;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 HEAP8[i3 + (((i3 | 0) == (HEAP32[i2 >> 2] | 0)) << 31 >> 31) >> 0] = 0;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN7testing8UnitTest3RunEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7;
 i1 = HEAP8[163824] | 0;
 if (!(i1 & 1)) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[40957] | 0;
 if ((i1 | 0) == 0 ? (i2 = _getenv(163840) | 0, (i2 | 0) != 0) : 0) if (!(HEAP8[i2 >> 0] | 0)) i3 = 0; else {
  i3 = _fopen(i2 | 0, 162960) | 0;
  _fputc(48, i3 | 0) | 0;
  _fclose(i3 | 0) | 0;
  i3 = 0;
 } else {
  i2 = 0;
  i3 = 1;
 }
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP8[i1 + 212 >> 0] = HEAP8[159816] | 0;
 HEAP32[i5 >> 2] = 125;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i4 + 0 >> 2] = HEAP32[i5 + 0 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i1 = (__ZN7testing8internal35HandleExceptionsInMethodIfSupportedINS0_12UnitTestImplEbEET0_PT_MS4_FS3_vEPKc(i1, i4, 163872) | 0) & 1 ^ 1;
 if (i3) {
  STACKTOP = i7;
  return i1 | 0;
 }
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i7;
  return i1 | 0;
 }
 _remove(i2 | 0) | 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9pbackfailEi(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 i1 = i8 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i8 + 24 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = i3;
  i2 = i3;
 }
 i4 = i8 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i8 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i5 >>> 0 >= i3 >>> 0) {
  i1 = -1;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((i7 | 0) == -1) {
  HEAP32[i4 >> 2] = i5;
  HEAP32[i6 >> 2] = i3 + -1;
  HEAP32[i8 + 16 >> 2] = i2;
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 if (!(HEAP32[i8 + 48 >> 2] & 16)) {
  i1 = i7 & 255;
  i3 = i3 + -1 | 0;
  if (i1 << 24 >> 24 != (HEAP8[i3 >> 0] | 0)) {
   i1 = -1;
   STACKTOP = i9;
   return i1 | 0;
  }
 } else {
  i1 = i7 & 255;
  i3 = i3 + -1 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i8 + 16 >> 2] = i2;
 HEAP8[i3 >> 0] = i1;
 i1 = i7;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNK2cv7MatExpr4sizeEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == 33152 | (i3 | 0) == 33144) {
  i3 = HEAP32[i2 + 20 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  STACKTOP = i4;
  return;
 }
 if ((i3 | 0) == 33136) {
  i3 = HEAP32[i2 + 16 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 + 76 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  STACKTOP = i4;
  return;
 }
 if ((i3 | 0) == 33160) {
  i3 = HEAP32[i2 + 20 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 + 76 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  STACKTOP = i4;
  return;
 }
 if ((i3 | 0) == 33168) {
  i3 = HEAP32[i2 + 48 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  STACKTOP = i4;
  return;
 }
 if (!i3) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  STACKTOP = i4;
  return;
 } else {
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] & 63](i1, i3, i2);
  STACKTOP = i4;
  return;
 }
}

function __ZNK2cv11MatOp_AddEx8multiplyERKNS_7MatExprEdRS1_(i1, i2, d7, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d7 = +d7;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 i1 = i2;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __ZN2cv3MataSERKS0_(i6 + 8 | 0, i2 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i6 + 64 | 0, i2 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i6 + 120 | 0, i2 + 120 | 0) | 0;
 i3 = i6 + 176 | 0;
 i4 = i3 + 0 | 0;
 i2 = i2 + 176 | 0;
 i1 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i1 | 0));
 HEAPF64[i3 >> 3] = +HEAPF64[i3 >> 3] * d7;
 i1 = i6 + 184 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] * d7;
 i1 = i6 + 192 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] * d7;
 i1 = i6 + 200 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] * d7;
 i1 = i6 + 208 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] * d7;
 i1 = i6 + 216 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] * d7;
 STACKTOP = i5;
 return;
}

function __ZN2cvL16transposeI_16uC3EPhji(i3, i7, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) > 0) i4 = 0; else {
  STACKTOP = i8;
  return;
 }
 do {
  i1 = i3 + (Math_imul(i4, i7) | 0) | 0;
  i2 = i4 * 6 | 0;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) < (i6 | 0)) {
   i5 = i4;
   do {
    i14 = i1 + (i5 * 6 | 0) | 0;
    i9 = (Math_imul(i5, i7) | 0) + i2 | 0;
    i12 = i3 + i9 | 0;
    i13 = HEAP16[i14 >> 1] | 0;
    i11 = HEAP16[i1 + (i5 * 6 | 0) + 2 >> 1] | 0;
    i10 = HEAP16[i1 + (i5 * 6 | 0) + 4 >> 1] | 0;
    HEAP16[i14 + 0 >> 1] = HEAP16[i12 + 0 >> 1] | 0;
    HEAP16[i14 + 2 >> 1] = HEAP16[i12 + 2 >> 1] | 0;
    HEAP16[i14 + 4 >> 1] = HEAP16[i12 + 4 >> 1] | 0;
    HEAP16[i12 >> 1] = i13;
    HEAP16[i3 + (i9 + 2) >> 1] = i11;
    HEAP16[i3 + (i9 + 4) >> 1] = i10;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
  }
 } while ((i4 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 i1 = HEAP8[i6 >> 0] | 0;
 i2 = (i1 & 1) != 0;
 if (i2) {
  i3 = (HEAP32[i6 >> 2] & -2) + -1 | 0;
  i4 = HEAP32[i6 + 4 >> 2] | 0;
 } else {
  i3 = 10;
  i4 = (i1 & 255) >>> 1;
 }
 if ((i4 | 0) == (i3 | 0)) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i6, i3, 1, i3, i3, 0, 0);
  if (!(HEAP8[i6 >> 0] & 1)) i1 = 7; else i1 = 8;
 } else if (i2) i1 = 8; else i1 = 7;
 if ((i1 | 0) == 7) {
  HEAP8[i6 >> 0] = (i4 << 1) + 2;
  i2 = i6 + 1 | 0;
  i1 = i4 + 1 | 0;
  i3 = i2 + i4 | 0;
  HEAP8[i3 >> 0] = i5;
  i1 = i2 + i1 | 0;
  HEAP8[i1 >> 0] = 0;
  STACKTOP = i7;
  return;
 } else if ((i1 | 0) == 8) {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i4 + 1 | 0;
  HEAP32[i6 + 4 >> 2] = i1;
  i3 = i2 + i4 | 0;
  HEAP8[i3 >> 0] = i5;
  i1 = i2 + i1 | 0;
  HEAP8[i1 >> 0] = 0;
  STACKTOP = i7;
  return;
 }
}

function __Z24icvCvt_BGRA2BGR_8u_C4C3RPKhiPhi6CvSizei(i4, i10, i2, i9, i11, i1) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0;
 i12 = STACKTOP;
 i6 = (i1 | 0) != 0 ? 2 : 0;
 i7 = i11 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i3 = i8 + -1 | 0;
 HEAP32[i7 >> 2] = i3;
 if (!i8) {
  STACKTOP = i12;
  return;
 }
 i8 = i6 ^ 2;
 i1 = i4;
 i4 = HEAP32[i11 >> 2] | 0;
 while (1) {
  if ((i4 | 0) > 0) {
   i3 = 0;
   do {
    i4 = HEAP8[i1 + 1 >> 0] | 0;
    HEAP8[i2 >> 0] = HEAP8[i1 + i6 >> 0] | 0;
    HEAP8[i2 + 1 >> 0] = i4;
    HEAP8[i2 + 2 >> 0] = HEAP8[i1 + i8 >> 0] | 0;
    i3 = i3 + 1 | 0;
    i2 = i2 + 3 | 0;
    i1 = i1 + 4 | 0;
    i4 = HEAP32[i11 >> 2] | 0;
   } while ((i3 | 0) < (i4 | 0));
   i5 = HEAP32[i7 >> 2] | 0;
  } else i5 = i3;
  i2 = i2 + ((Math_imul(i4, -3) | 0) + i9) | 0;
  i3 = i5 + -1 | 0;
  HEAP32[i7 >> 2] = i3;
  if (!i5) break; else i1 = i1 + (i10 - (i4 << 2)) | 0;
 }
 STACKTOP = i12;
 return;
}

function __ZN4perf8TestBaseC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 __ZN7testing4TestC2Ev(i2);
 HEAP32[i2 >> 2] = 174008;
 i1 = i2 + 8 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = -1;
 HEAP32[i2 + 36 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 i1 = i2 + 168 | 0;
 i3 = i2 + 96 | 0;
 i5 = i3 + 72 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP32[i1 >> 2] = -1;
 HEAP32[i2 + 180 >> 2] = i2;
 i1 = i2 + 48 | 0;
 HEAP32[i2 + 84 >> 2] = 0;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = HEAP32[43340];
 HEAP8[i2 + 176 >> 0] = 0;
 HEAP32[i2 + 88 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN2cvL16transposeI_32sC3EPhji(i3, i7, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) > 0) i4 = 0; else {
  STACKTOP = i8;
  return;
 }
 do {
  i1 = i3 + (Math_imul(i4, i7) | 0) | 0;
  i2 = i4 * 12 | 0;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) < (i6 | 0)) {
   i5 = i4;
   do {
    i14 = i1 + (i5 * 12 | 0) | 0;
    i9 = (Math_imul(i5, i7) | 0) + i2 | 0;
    i12 = i3 + i9 | 0;
    i13 = HEAP32[i14 >> 2] | 0;
    i11 = HEAP32[i1 + (i5 * 12 | 0) + 4 >> 2] | 0;
    i10 = HEAP32[i1 + (i5 * 12 | 0) + 8 >> 2] | 0;
    HEAP32[i14 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i12 >> 2] = i13;
    HEAP32[i3 + (i9 + 4) >> 2] = i11;
    HEAP32[i3 + (i9 + 8) >> 2] = i10;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
  }
 } while ((i4 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1, i5, i4, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0;
 i7 = STACKTOP;
 if ((i1 | 0) == (HEAP32[i5 + 8 >> 2] | 0)) {
  __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi(0, i5, i4, i6);
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i2 = i1 + (i3 << 3) + 16 | 0;
 __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1 + 16 | 0, i5, i4, i6);
 if ((i3 | 0) <= 1) {
  STACKTOP = i7;
  return;
 }
 i3 = i5 + 54 | 0;
 i1 = i1 + 24 | 0;
 while (1) {
  __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1, i5, i4, i6);
  if (HEAP8[i3 >> 0] | 0) {
   i1 = 7;
   break;
  }
  i1 = i1 + 8 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 7;
   break;
  }
 }
 if ((i1 | 0) == 7) {
  STACKTOP = i7;
  return;
 }
}

function __ZN7testing8internal17Int32FromEnvOrDieEPKci(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i7 + 4 | 0;
 i5 = i7;
 i2 = _getenv(i4 | 0) | 0;
 if (!i2) {
  STACKTOP = i7;
  return i1 | 0;
 }
 __ZN7testing7MessageC2Ev(i5);
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = i3 + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 164456, 34) | 0;
 if (!i4) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, 160784, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i1, i4, _strlen(i4 | 0) | 0) | 0;
 i1 = __ZN7testing8internal10ParseInt32ERKNS_7MessageEPKcPi(i5, i2, i6) | 0;
 if (i3) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
  HEAP32[i5 >> 2] = 0;
 }
 if (!i1) _exit(1);
 i1 = HEAP32[i6 >> 2] | 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN2cvL11cvtScale16sEPKsjPKhjPsjNS_5Size_IiEEPd(i10, i5, i1, i2, i8, i6, i3, i4) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i9 = 0, f11 = f0, f12 = f0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 i13 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f12 = Math_fround(+HEAPF64[i4 >> 3]);
 f11 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i9 = i5 >>> 1;
 i1 = i6 >>> 1;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i7 = (i13 | 0) > 0;
 i6 = i8;
 i2 = i10;
 i4 = i3;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i7) {
   i5 = 0;
   do {
    i3 = _lrint(+Math_fround(f11 + Math_fround(f12 * Math_fround(HEAP16[i2 + (i5 << 1) >> 1] | 0)))) | 0;
    if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
    HEAP16[i6 + (i5 << 1) >> 1] = i3;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i13 | 0));
  }
  if (!i4) break; else {
   i6 = i6 + (i1 << 1) | 0;
   i2 = i2 + (i9 << 1) | 0;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2cvL15transposeI_8uC3EPhji(i3, i7, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) > 0) i4 = 0; else {
  STACKTOP = i8;
  return;
 }
 do {
  i1 = i3 + (Math_imul(i4, i7) | 0) | 0;
  i2 = i4 * 3 | 0;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) < (i6 | 0)) {
   i5 = i4;
   do {
    i9 = (Math_imul(i5, i7) | 0) + i2 | 0;
    i12 = i3 + i9 | 0;
    i14 = i1 + (i5 * 3 | 0) | 0;
    i13 = HEAP8[i14 >> 0] | 0;
    i11 = HEAP8[i1 + (i5 * 3 | 0) + 1 >> 0] | 0;
    i10 = HEAP8[i1 + (i5 * 3 | 0) + 2 >> 0] | 0;
    HEAP8[i14 + 0 >> 0] = HEAP8[i12 + 0 >> 0] | 0;
    HEAP8[i14 + 1 >> 0] = HEAP8[i12 + 1 >> 0] | 0;
    HEAP8[i14 + 2 >> 0] = HEAP8[i12 + 2 >> 0] | 0;
    HEAP8[i12 >> 0] = i13;
    HEAP8[i3 + (i9 + 1) >> 0] = i11;
    HEAP8[i3 + (i9 + 2) >> 0] = i10;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
  }
 } while ((i4 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __Z23icvCvt_BGRA2RGBA_8u_C4RPKhiPhi6CvSize(i2, i8, i1, i9, i10) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 i7 = i10 + 4 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i3 = i6 + -1 | 0;
 HEAP32[i7 >> 2] = i3;
 if (!i6) {
  STACKTOP = i11;
  return;
 }
 i4 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i4 | 0) > 0) {
   i3 = 0;
   do {
    i6 = HEAP8[i2 >> 0] | 0;
    i5 = HEAP8[i2 + 1 >> 0] | 0;
    i4 = HEAP8[i2 + 3 >> 0] | 0;
    HEAP8[i1 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
    HEAP8[i1 + 1 >> 0] = i5;
    HEAP8[i1 + 2 >> 0] = i6;
    HEAP8[i1 + 3 >> 0] = i4;
    i3 = i3 + 1 | 0;
    i2 = i2 + 4 | 0;
    i1 = i1 + 4 | 0;
    i4 = HEAP32[i10 >> 2] | 0;
   } while ((i3 | 0) < (i4 | 0));
   i5 = HEAP32[i7 >> 2] | 0;
  } else i5 = i3;
  i6 = i4 << 2;
  i3 = i5 + -1 | 0;
  HEAP32[i7 >> 2] = i3;
  if (!i5) break; else {
   i1 = i1 + (i9 - i6) | 0;
   i2 = i2 + (i8 - i6) | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __Z24icvCvt_BGR2Gray_8u_C3C1RPKhiPhi6CvSizei(i3, i10, i2, i9, i11, i1) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0;
 i12 = STACKTOP;
 i6 = (i1 | 0) != 0 ? 2 : 0;
 i7 = i11 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i4 = i8 + -1 | 0;
 HEAP32[i7 >> 2] = i4;
 if (!i8) {
  STACKTOP = i12;
  return;
 }
 i8 = i6 ^ 2;
 i1 = i3;
 i5 = i4;
 i4 = HEAP32[i11 >> 2] | 0;
 while (1) {
  if ((i4 | 0) > 0) {
   i3 = 0;
   do {
    HEAP8[i2 + i3 >> 0] = (((HEAPU8[i1 + i6 >> 0] | 0) * 1868 | 0) + 8192 + ((HEAPU8[i1 + 1 >> 0] | 0) * 9617 | 0) + ((HEAPU8[i1 + i8 >> 0] | 0) * 4899 | 0) | 0) >>> 14;
    i3 = i3 + 1 | 0;
    i1 = i1 + 3 | 0;
    i4 = HEAP32[i11 >> 2] | 0;
   } while ((i3 | 0) < (i4 | 0));
   i3 = HEAP32[i7 >> 2] | 0;
  } else i3 = i5;
  i1 = i1 + ((Math_imul(i4, -3) | 0) + i10) | 0;
  i5 = i3 + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (!i3) break; else i2 = i2 + i9 | 0;
 }
 STACKTOP = i12;
 return;
}

function __ZNSt3__125__num_get_signed_integralIxEET_PKcS3_Rji(i1, i6, i7, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i9;
 if ((i1 | 0) == (i6 | 0)) {
  HEAP32[i7 >> 2] = 4;
  i2 = 0;
  i1 = 0;
  tempRet0 = i2;
  STACKTOP = i9;
  return i1 | 0;
 }
 i4 = ___errno_location() | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i2 = _strtoll_l(i1, i8, i2, __ZNSt3__16__clocEv() | 0) | 0;
 i1 = tempRet0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) HEAP32[i4 >> 2] = i5;
 if ((HEAP32[i8 >> 2] | 0) != (i6 | 0)) {
  HEAP32[i7 >> 2] = 4;
  i2 = 0;
  i1 = 0;
  tempRet0 = i2;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((i3 | 0) == 34) {
  HEAP32[i7 >> 2] = 4;
  i1 = (i1 | 0) > 0 | (i1 | 0) == 0 & i2 >>> 0 > 0;
  tempRet0 = i1 ? 2147483647 : -2147483648;
  STACKTOP = i9;
  return (i1 ? -1 : 0) | 0;
 } else {
  i3 = i1;
  i1 = i2;
  tempRet0 = i3;
  STACKTOP = i9;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cv11FileStorage4openERKNS_6StringEiS3_(i5, i3, i4, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i6 = 0;
 i6 = STACKTOP;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] & 511](i5);
 i3 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP32[i2 + 4 >> 2] | 0)) i1 = 0; else {
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? 12512 : i1;
 }
 i1 = _cvOpenFileStorage((i3 | 0) == 0 ? 12512 : i3, 0, i4, i1) | 0;
 if (!i1) i3 = 0; else {
  i3 = __Znwj(16) | 0;
  HEAP32[i3 + 4 >> 2] = 1;
  HEAP32[i3 >> 2] = 11552;
  HEAP32[i3 + 8 >> 2] = i1;
 }
 i4 = i5 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = i1;
 if ((i2 | 0) != 0 ? (i3 = i2 + 4 | 0, i1 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i1 + -1, (i1 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] & 511](i2);
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] & 127](i5) | 0;
 HEAP32[i5 + 32 >> 2] = i1 ? 6 : 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __Z25icvCvt_BGRA2Gray_8u_C4C1RPKhiPhi6CvSizei(i3, i10, i2, i9, i11, i1) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0;
 i12 = STACKTOP;
 i6 = (i1 | 0) != 0 ? 2 : 0;
 i7 = i11 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i4 = i8 + -1 | 0;
 HEAP32[i7 >> 2] = i4;
 if (!i8) {
  STACKTOP = i12;
  return;
 }
 i8 = i6 ^ 2;
 i1 = i3;
 i5 = i4;
 i4 = HEAP32[i11 >> 2] | 0;
 while (1) {
  if ((i4 | 0) > 0) {
   i3 = 0;
   do {
    HEAP8[i2 + i3 >> 0] = (((HEAPU8[i1 + i6 >> 0] | 0) * 1868 | 0) + 8192 + ((HEAPU8[i1 + 1 >> 0] | 0) * 9617 | 0) + ((HEAPU8[i1 + i8 >> 0] | 0) * 4899 | 0) | 0) >>> 14;
    i3 = i3 + 1 | 0;
    i1 = i1 + 4 | 0;
    i4 = HEAP32[i11 >> 2] | 0;
   } while ((i3 | 0) < (i4 | 0));
   i3 = HEAP32[i7 >> 2] | 0;
  } else i3 = i5;
  i5 = i3 + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (!i3) break; else {
   i2 = i2 + i9 | 0;
   i1 = i1 + (i10 - (i4 << 2)) | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZN7testing10TestResult5ClearEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i4 + 8 | 0;
 while (1) {
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) == (i1 | 0)) break;
  HEAP32[i3 >> 2] = i2 + -44;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2 + -12 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2 + -24 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2 + -40 | 0);
 }
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 i2 = i4 + 20 | 0;
 while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (i1 | 0)) break;
  i6 = i3 + -24 | 0;
  HEAP32[i2 >> 2] = i6;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3 + -12 | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 }
 HEAP32[i4 + 28 >> 2] = 0;
 i1 = i4 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function _cvCloneMat(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i6;
 if (!((((i5 | 0) != 0 ? (i1 = HEAP32[i5 >> 2] | 0, (i1 & -65536 | 0) == 1111621632) : 0) ? (i2 = HEAP32[i5 + 24 >> 2] | 0, (i2 | 0) > 0) : 0) ? (i3 = HEAP32[i5 + 20 >> 2] | 0, (i3 | 0) > 0) : 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i3 = (__ZN2cv6String8allocateEj(i4, 16) | 0) + 0 | 0;
  i2 = 41160 | 0;
  i1 = i3 + 16 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i4, 41184, 40912, 211);
  __ZN2cv6String10deallocateEv(i4);
  i3 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = HEAP32[i5 + 24 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i1 = _cvCreateMatHeader(i3, i2, i1) | 0;
 if (!(HEAP32[i5 + 16 >> 2] | 0)) {
  STACKTOP = i6;
  return i1 | 0;
 }
 _cvCreateData(i1);
 _cvCopy(i5, i1, 0);
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__127__num_get_unsigned_integralItEET_PKcS3_Rji(i1, i6, i7, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i9;
 if ((i1 | 0) == (i6 | 0)) {
  HEAP32[i7 >> 2] = 4;
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((HEAP8[i1 >> 0] | 0) == 45) {
  HEAP32[i7 >> 2] = 4;
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 i4 = ___errno_location() | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i2 = _strtoull_l(i1, i8, i2, __ZNSt3__16__clocEv() | 0) | 0;
 i1 = tempRet0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) HEAP32[i4 >> 2] = i5;
 if ((HEAP32[i8 >> 2] | 0) != (i6 | 0)) {
  HEAP32[i7 >> 2] = 4;
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((i3 | 0) == 34 | (i1 >>> 0 > 0 | (i1 | 0) == 0 & i2 >>> 0 > 65535)) {
  HEAP32[i7 >> 2] = 4;
  i1 = -1;
  STACKTOP = i9;
  return i1 | 0;
 } else {
  i1 = i2 & 65535;
  STACKTOP = i9;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__127__num_get_unsigned_integralImEET_PKcS3_Rji(i1, i6, i7, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i9;
 if ((i1 | 0) == (i6 | 0)) {
  HEAP32[i7 >> 2] = 4;
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((HEAP8[i1 >> 0] | 0) == 45) {
  HEAP32[i7 >> 2] = 4;
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 i4 = ___errno_location() | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i2 = _strtoull_l(i1, i8, i2, __ZNSt3__16__clocEv() | 0) | 0;
 i1 = tempRet0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) HEAP32[i4 >> 2] = i5;
 if ((HEAP32[i8 >> 2] | 0) != (i6 | 0)) {
  HEAP32[i7 >> 2] = 4;
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((i3 | 0) == 34 | (i1 >>> 0 > 0 | (i1 | 0) == 0 & i2 >>> 0 > 4294967295)) {
  HEAP32[i7 >> 2] = 4;
  i1 = -1;
  STACKTOP = i9;
  return i1 | 0;
 } else {
  i1 = i2;
  STACKTOP = i9;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__127__num_get_unsigned_integralIjEET_PKcS3_Rji(i1, i6, i7, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i9;
 if ((i1 | 0) == (i6 | 0)) {
  HEAP32[i7 >> 2] = 4;
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((HEAP8[i1 >> 0] | 0) == 45) {
  HEAP32[i7 >> 2] = 4;
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 i4 = ___errno_location() | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i2 = _strtoull_l(i1, i8, i2, __ZNSt3__16__clocEv() | 0) | 0;
 i1 = tempRet0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) HEAP32[i4 >> 2] = i5;
 if ((HEAP32[i8 >> 2] | 0) != (i6 | 0)) {
  HEAP32[i7 >> 2] = 4;
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((i3 | 0) == 34 | (i1 >>> 0 > 0 | (i1 | 0) == 0 & i2 >>> 0 > 4294967295)) {
  HEAP32[i7 >> 2] = 4;
  i1 = -1;
  STACKTOP = i9;
  return i1 | 0;
 } else {
  i1 = i2;
  STACKTOP = i9;
  return i1 | 0;
 }
 return 0;
}

function __ZN7testing8internal14ShouldUseColorEb(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = (HEAP8[159848] & 1) == 0 ? 159849 | 0 : HEAP32[39964] | 0;
 if (!i1) {
  i1 = 0;
  STACKTOP = i3;
  return i1 | 0;
 }
 if (_strcasecmp(i1, 159872) | 0) {
  if (!(_strcasecmp(i1, 162104) | 0)) {
   i1 = 1;
   STACKTOP = i3;
   return i1 | 0;
  }
  if (!(_strcasecmp(i1, 162112) | 0)) {
   i1 = 1;
   STACKTOP = i3;
   return i1 | 0;
  }
  if (!(_strcasecmp(i1, 162120) | 0)) {
   i1 = 1;
   STACKTOP = i3;
   return i1 | 0;
  }
  i1 = (_strcmp(i1, 162128) | 0) == 0;
  STACKTOP = i3;
  return i1 | 0;
 }
 i1 = _getenv(162016) | 0;
 if (i1) if ((((((_strcmp(i1, 162024) | 0) != 0 ? (_strcmp(i1, 162032) | 0) != 0 : 0) ? (_strcmp(i1, 162048) | 0) != 0 : 0) ? (_strcmp(i1, 162064) | 0) != 0 : 0) ? (_strcmp(i1, 162072) | 0) != 0 : 0) ? (_strcmp(i1, 162088) | 0) != 0 : 0) i1 = (_strcmp(i1, 162096) | 0) == 0; else i1 = 1; else i1 = 0;
 i1 = i1 & i2;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNK2cv11MatOp_AddEx3addERKNS_7MatExprERKNS_7Scalar_IdEERS1_(i1, i2, i6, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i7 = 0;
 i4 = STACKTOP;
 i7 = i2;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 __ZN2cv3MataSERKS0_(i5 + 8 | 0, i2 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i5 + 64 | 0, i2 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i5 + 120 | 0, i2 + 120 | 0) | 0;
 i3 = i5 + 176 | 0;
 i2 = i2 + 176 | 0;
 i1 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  i3 = i3 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i3 | 0) < (i1 | 0));
 i1 = i5 + 192 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i6 >> 3] + +HEAPF64[i1 >> 3];
 i1 = i5 + 200 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i6 + 8 >> 3] + +HEAPF64[i1 >> 3];
 i1 = i5 + 208 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i6 + 16 >> 3] + +HEAPF64[i1 >> 3];
 i1 = i5 + 216 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i6 + 24 >> 3] + +HEAPF64[i1 >> 3];
 STACKTOP = i4;
 return;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i4, i1, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 i5 = i1;
 i2 = i6 - i5 | 0;
 i3 = i2 >> 2;
 if (i3 >>> 0 > 1073741807) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i4);
 if (i3 >>> 0 < 2) {
  HEAP8[i4 >> 0] = i2 >>> 1;
  i4 = i4 + 4 | 0;
 } else {
  i8 = i3 + 4 & -4;
  i2 = __Znwj(i8 << 2) | 0;
  HEAP32[i4 + 8 >> 2] = i2;
  HEAP32[i4 >> 2] = i8 | 1;
  HEAP32[i4 + 4 >> 2] = i3;
  i4 = i2;
 }
 if ((i1 | 0) == (i6 | 0)) {
  i1 = i4;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 i3 = ((i6 + -4 - i5 | 0) >>> 2) + 1 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i6 | 0)) break; else i2 = i2 + 4 | 0;
 }
 i1 = i4 + (i3 << 2) | 0;
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __Z26icvCvt_BGRA2Gray_16u_CnC1RPKtiPti6CvSizeii(i5, i12, i3, i10, i2, i11, i1) {
 i5 = i5 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0;
 i13 = STACKTOP;
 i8 = (i1 | 0) != 0 ? 2 : 0;
 i9 = i2 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i1 = i7 + -1 | 0;
 HEAP32[i9 >> 2] = i1;
 if (!i7) {
  STACKTOP = i13;
  return;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i7 = i8 ^ 2;
 if ((i6 | 0) > 0) while (1) {
  i2 = i5;
  i4 = 0;
  while (1) {
   HEAP16[i3 + (i4 << 1) >> 1] = (((HEAPU16[i2 + (i8 << 1) >> 1] | 0) * 1868 | 0) + 8192 + ((HEAPU16[i2 + 2 >> 1] | 0) * 9617 | 0) + ((HEAPU16[i2 + (i7 << 1) >> 1] | 0) * 4899 | 0) | 0) >>> 14;
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i6 | 0)) break; else i2 = i2 + (i11 << 1) | 0;
  }
  if (!i1) break; else {
   i3 = i3 + (i10 << 1) | 0;
   i5 = i5 + (i12 << 1) | 0;
   i1 = i1 + -1 | 0;
  }
 }
 HEAP32[i9 >> 2] = -1;
 STACKTOP = i13;
 return;
}

function __ZN2cv8dotProd_ItEEdPKT_S3_i(i5, i6, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 i2 = i4 + -4 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  d1 = 0.0;
 } else {
  i3 = 0;
  d1 = 0.0;
  do {
   i10 = i3 | 1;
   i9 = i3 | 2;
   i8 = i3 | 3;
   d1 = d1 + (+(HEAPU16[i5 + (i3 << 1) >> 1] | 0) * +(HEAPU16[i6 + (i3 << 1) >> 1] | 0 | 0) + +(HEAPU16[i5 + (i10 << 1) >> 1] | 0) * +(HEAPU16[i6 + (i10 << 1) >> 1] | 0 | 0) + +(HEAPU16[i5 + (i9 << 1) >> 1] | 0) * +(HEAPU16[i6 + (i9 << 1) >> 1] | 0 | 0) + +(HEAPU16[i5 + (i8 << 1) >> 1] | 0) * +(HEAPU16[i6 + (i8 << 1) >> 1] | 0 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i2 | 0));
  i2 = i4 & -4;
 }
 if ((i2 | 0) >= (i4 | 0)) {
  STACKTOP = i7;
  return +d1;
 }
 do {
  d1 = d1 + +(HEAPU16[i5 + (i2 << 1) >> 1] | 0) * +(HEAPU16[i6 + (i2 << 1) >> 1] | 0 | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i7;
 return +d1;
}

function __ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv(i6, i1, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i5 = i7;
 if ((i6 | 0) == (i1 | 0)) {
  i1 = 1;
  STACKTOP = i7;
  return i1 | 0;
 }
 if (!i1) {
  i1 = 0;
  STACKTOP = i7;
  return i1 | 0;
 }
 i1 = ___dynamic_cast(i1, 969632, 969688, 0) | 0;
 if (!i1) {
  i1 = 0;
  STACKTOP = i7;
  return i1 | 0;
 }
 i2 = i5 + 0 | 0;
 i3 = i2 + 56 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i6;
 HEAP32[i5 + 12 >> 2] = -1;
 HEAP32[i5 + 48 >> 2] = 1;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 63](i1, i5, HEAP32[i4 >> 2] | 0, 1);
 if ((HEAP32[i5 + 24 >> 2] | 0) != 1) {
  i1 = 0;
  STACKTOP = i7;
  return i1 | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i5 + 16 >> 2];
 i1 = 1;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN7testing8TestCaseC2EPKcS2_PFvvES4_(i5, i2, i1, i3, i4) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 HEAP32[i5 >> 2] = 161968;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5 + 4 | 0, i2, _strlen(i2 | 0) | 0);
 if (!i1) i2 = 0; else {
  i2 = __Znwj(12) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i1, _strlen(i1 | 0) | 0);
 }
 HEAP32[i5 + 16 >> 2] = i2;
 i1 = i5 + 20 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i5 + 44 >> 2] = i3;
 HEAP32[i5 + 48 >> 2] = i4;
 HEAP8[i5 + 52 >> 0] = 0;
 i1 = i5 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i5 + 68 | 0;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 STACKTOP = i6;
 return;
}

function _wcrtomb(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i1 = STACKTOP;
 if (!i2) {
  i2 = 1;
  STACKTOP = i1;
  return i2 | 0;
 }
 if (i3 >>> 0 < 128) {
  HEAP8[i2 >> 0] = i3;
  i2 = 1;
  STACKTOP = i1;
  return i2 | 0;
 }
 if (i3 >>> 0 < 2048) {
  HEAP8[i2 >> 0] = i3 >>> 6 | 192;
  HEAP8[i2 + 1 >> 0] = i3 & 63 | 128;
  i2 = 2;
  STACKTOP = i1;
  return i2 | 0;
 }
 if (i3 >>> 0 < 55296 | (i3 & -8192 | 0) == 57344) {
  HEAP8[i2 >> 0] = i3 >>> 12 | 224;
  HEAP8[i2 + 1 >> 0] = i3 >>> 6 & 63 | 128;
  HEAP8[i2 + 2 >> 0] = i3 & 63 | 128;
  i2 = 3;
  STACKTOP = i1;
  return i2 | 0;
 }
 if ((i3 + -65536 | 0) >>> 0 < 1048576) {
  HEAP8[i2 >> 0] = i3 >>> 18 | 240;
  HEAP8[i2 + 1 >> 0] = i3 >>> 12 & 63 | 128;
  HEAP8[i2 + 2 >> 0] = i3 >>> 6 & 63 | 128;
  HEAP8[i2 + 3 >> 0] = i3 & 63 | 128;
  i2 = 4;
  STACKTOP = i1;
  return i2 | 0;
 } else {
  HEAP32[(___errno_location() | 0) >> 2] = 84;
  i2 = -1;
  STACKTOP = i1;
  return i2 | 0;
 }
 return 0;
}

function __ZN2cv8internal18WriteStructContextD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i6;
 _cvEndWriteStruct(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0);
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = i4 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1 + -1 | 0;
 HEAP32[i3 >> 2] = i2;
 if ((HEAP32[i4 + 20 >> 2] | 0) == (i2 | 0)) i1 = 6; else i1 = (HEAP8[i1 + -2 >> 0] | 0) == 123 ? 6 : 1;
 HEAP32[i4 + 32 >> 2] = i1;
 i2 = i4 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 if ((i5 | 0) == (i2 | 0)) {
  __ZN2cv6String10deallocateEv(i5);
  STACKTOP = i6;
  return;
 }
 __ZN2cv6String10deallocateEv(i2);
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = i1;
 HEAP32[i4 + 16 >> 2] = HEAP32[i3 >> 2];
 __ZN2cv6String10deallocateEv(i5);
 STACKTOP = i6;
 return;
}

function __tr_flush_bits(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 i1 = i3 + 5820 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == 16) {
  i2 = i3 + 5816 | 0;
  i8 = HEAP16[i2 >> 1] & 255;
  i7 = i3 + 20 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i6 + 1;
  i5 = i3 + 8 | 0;
  HEAP8[(HEAP32[i5 >> 2] | 0) + i6 >> 0] = i8;
  i6 = (HEAPU16[i2 >> 1] | 0) >>> 8 & 255;
  i3 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i3 + 1;
  HEAP8[(HEAP32[i5 >> 2] | 0) + i3 >> 0] = i6;
  HEAP16[i2 >> 1] = 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i4;
  return;
 }
 if ((i2 | 0) <= 7) {
  STACKTOP = i4;
  return;
 }
 i2 = i3 + 5816 | 0;
 i6 = HEAP16[i2 >> 1] & 255;
 i7 = i3 + 20 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i5 + 1;
 HEAP8[(HEAP32[i3 + 8 >> 2] | 0) + i5 >> 0] = i6;
 HEAP16[i2 >> 1] = (HEAPU16[i2 >> 1] | 0) >>> 8;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -8;
 STACKTOP = i4;
 return;
}

function ___shgetc(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 i1 = i5 + 104 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 if (!((i8 | 0) != 0 ? (HEAP32[i5 + 108 >> 2] | 0) >= (i8 | 0) : 0)) i2 = 3;
 if ((i2 | 0) == 3 ? (i6 = ___uflow(i5) | 0, (i6 | 0) >= 0) : 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i5 + 8 >> 2] | 0;
  if ((i1 | 0) != 0 ? (i3 = HEAP32[i5 + 4 >> 2] | 0, i4 = i1 - (HEAP32[i5 + 108 >> 2] | 0) + -1 | 0, (i2 - i3 | 0) > (i4 | 0)) : 0) HEAP32[i5 + 100 >> 2] = i3 + i4; else HEAP32[i5 + 100 >> 2] = i2;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  if (i2) {
   i3 = i5 + 108 | 0;
   HEAP32[i3 >> 2] = i2 + 1 - i1 + (HEAP32[i3 >> 2] | 0);
  }
  i1 = i1 + -1 | 0;
  if ((HEAPU8[i1 >> 0] | 0 | 0) == (i6 | 0)) {
   i1 = i6;
   STACKTOP = i7;
   return i1 | 0;
  }
  HEAP8[i1 >> 0] = i6;
  i1 = i6;
  STACKTOP = i7;
  return i1 | 0;
 }
 HEAP32[i5 + 100 >> 2] = 0;
 i1 = -1;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN12_GLOBAL__N_113FormattedImplD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 7088;
 __ZN2cv6String10deallocateEv(i4 + 132 | 0);
 __ZN2cv6String10deallocateEv(i4 + 124 | 0);
 i2 = i4 + 44 | 0;
 i1 = i4 + 80 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i6 = i3 + 12 | 0, i3 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i2);
 HEAP32[i1 >> 2] = 0;
 i2 = i4 + 60 | 0;
 i1 = i4 + 48 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 if ((HEAP32[i1 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 84 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i2 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i1 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 88 >> 2] | 0;
 if ((i1 | 0) == (i4 + 92 | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i5;
 return;
}

function _deflateResetKeep(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 if (!i4) {
  i1 = -2;
  STACKTOP = i5;
  return i1 | 0;
 }
 i3 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i3) {
  i1 = -2;
  STACKTOP = i5;
  return i1 | 0;
 }
 if (!(HEAP32[i4 + 32 >> 2] | 0)) {
  i1 = -2;
  STACKTOP = i5;
  return i1 | 0;
 }
 if (!(HEAP32[i4 + 36 >> 2] | 0)) {
  i1 = -2;
  STACKTOP = i5;
  return i1 | 0;
 }
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 2;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = HEAP32[i3 + 8 >> 2];
 i2 = i3 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) < 0) {
  i1 = 0 - i1 | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i3 + 4 >> 2] = (i1 | 0) != 0 ? 42 : 113;
 if ((i1 | 0) == 2) i1 = _crc32(0, 0, 0) | 0; else i1 = _adler32(0, 0, 0) | 0;
 HEAP32[i4 + 48 >> 2] = i1;
 HEAP32[i3 + 40 >> 2] = 0;
 __tr_init(i3);
 i1 = 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN6cvtest2TS7vprintfEiPKcPi(i8, i4, i2, i1) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16400 | 0;
 i3 = i9 + 16 | 0;
 i7 = i9;
 _vsnprintf(i3, 16383, i2, i1) | 0;
 i6 = 0;
 while (1) {
  i2 = i6 + 1 | 0;
  if (1 << i6 & i4) break;
  if ((i2 | 0) < 4) i6 = i2; else {
   i5 = 8;
   break;
  }
 }
 if ((i5 | 0) == 8) {
  STACKTOP = i9;
  return;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i3, _strlen(i3 | 0) | 0);
 i1 = HEAP8[i7 >> 0] | 0;
 if (!(i1 & 1)) {
  i2 = i7 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i2 = HEAP32[i7 + 8 >> 2] | 0;
  i1 = HEAP32[i7 + 4 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8 + (i6 * 12 | 0) + 88 | 0, i2, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7);
 STACKTOP = i9;
 return;
}

function __ZN7testing8internal30ReportFailureInUnknownLocationENS_14TestPartResult4TypeERKNSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i4;
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i5 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i5, 163728);
  HEAP32[40934] = i5;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 159968, 0);
 __ZN7testing8UnitTest17AddTestPartResultENS_14TestPartResult4TypeEPKciRKNSt3__112basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEESD_(163728, i3, 0, -1, i2, i1);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_1L23createCLAHE_Impl_hiddenEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 i3 = __Znwj(136) | 0;
 __ZN2cv9AlgorithmC2Ev(i3);
 HEAP32[i3 >> 2] = 181864;
 HEAPF64[i3 + 8 >> 3] = 40.0;
 HEAP32[i3 + 16 >> 2] = 8;
 HEAP32[i3 + 20 >> 2] = 8;
 HEAP32[i3 + 24 >> 2] = 1124007936;
 i2 = i3 + 32 | 0;
 i1 = i3 + 64 | 0;
 i4 = i3 + 28 | 0;
 i6 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP32[i1 >> 2] = i2;
 i1 = i3 + 72 | 0;
 HEAP32[i3 + 68 >> 2] = i1;
 HEAP32[i3 + 76 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 80 >> 2] = 1124007936;
 i1 = i3 + 88 | 0;
 i2 = i3 + 120 | 0;
 i4 = i3 + 84 | 0;
 i6 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP32[i2 >> 2] = i1;
 i1 = i3 + 128 | 0;
 HEAP32[i3 + 124 >> 2] = i1;
 HEAP32[i3 + 132 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return i3 | 0;
}

function _deflateReset(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 i1 = _deflateResetKeep(i2) | 0;
 if (i1) {
  STACKTOP = i3;
  return i1 | 0;
 }
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 HEAP32[i2 + 60 >> 2] = HEAP32[i2 + 44 >> 2] << 1;
 i4 = HEAP32[i2 + 76 >> 2] | 0;
 i5 = HEAP32[i2 + 68 >> 2] | 0;
 HEAP16[i5 + (i4 + -1 << 1) >> 1] = 0;
 _memset(i5 | 0, 0, (i4 << 1) + -2 | 0) | 0;
 i4 = HEAP32[i2 + 132 >> 2] | 0;
 HEAP32[i2 + 128 >> 2] = HEAPU16[155018 + (i4 * 12 | 0) >> 1];
 HEAP32[i2 + 140 >> 2] = HEAPU16[155016 + (i4 * 12 | 0) >> 1];
 HEAP32[i2 + 144 >> 2] = HEAPU16[155020 + (i4 * 12 | 0) >> 1];
 HEAP32[i2 + 124 >> 2] = HEAPU16[155022 + (i4 * 12 | 0) >> 1];
 HEAP32[i2 + 108 >> 2] = 0;
 HEAP32[i2 + 92 >> 2] = 0;
 HEAP32[i2 + 116 >> 2] = 0;
 HEAP32[i2 + 5812 >> 2] = 0;
 HEAP32[i2 + 120 >> 2] = 2;
 HEAP32[i2 + 96 >> 2] = 2;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = 0;
 STACKTOP = i3;
 return i1 | 0;
}

function _cvCreateChildMemStorage(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i5 + 8 | 0;
 i1 = i5;
 if (!i4) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 39584, 39608, 121);
  __ZN2cv6String10deallocateEv(i1);
 }
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 i2 = _cvAlloc(24) | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i3, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i3, 40888, 39608, 92);
  __ZN2cv6String10deallocateEv(i3);
 }
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = 1116274688;
 HEAP32[i2 + 16 >> 2] = (i1 | 0) < 1 ? 65408 : i1 + 7 & -8;
 HEAP32[i2 + 12 >> 2] = i4;
 STACKTOP = i5;
 return i2 | 0;
}

function __ZN7testing15AssertionResultlsINSt3__112basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEEERS0_RKT_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i7;
 __ZN7testing7MessageC2Ev(i3);
 i1 = HEAP8[i2 >> 0] | 0;
 if (!(i1 & 1)) {
  i4 = i2 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i4 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
 }
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j((HEAP32[i3 >> 2] | 0) + 8 | 0, i4, i1) | 0;
 __ZN7testing15AssertionResult13AppendMessageERKNS_7MessageE(i6, i3);
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i7;
  return i6 | 0;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i5 = HEAP32[i3 >> 2] | 0, (i5 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 511](i5);
 HEAP32[i3 >> 2] = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, i5, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i7 = STACKTOP;
 i1 = HEAP8[i6 >> 0] | 0;
 if (!(i1 & 1)) i2 = 10; else {
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = (i1 & -2) + -1 | 0;
  i1 = i1 & 255;
 }
 if (!(i1 & 1)) i3 = (i1 & 255) >>> 1; else i3 = HEAP32[i6 + 4 >> 2] | 0;
 if ((i2 - i3 | 0) >>> 0 < i4 >>> 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc(i6, i2, i4 - i2 + i3 | 0, i3, i3, 0, i4, i5);
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!i4) {
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(i1 & 1)) i2 = i6 + 1 | 0; else i2 = HEAP32[i6 + 8 >> 2] | 0;
 _memcpy(i2 + i3 | 0, i5 | 0, i4 | 0) | 0;
 i1 = i3 + i4 | 0;
 if (!(HEAP8[i6 >> 0] & 1)) HEAP8[i6 >> 0] = i1 << 1; else HEAP32[i6 + 4 >> 2] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z21icvCvt_BGR2RGB_8u_C3RPKhiPhi6CvSize(i2, i8, i1, i9, i10) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 i7 = i10 + 4 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i3 = i6 + -1 | 0;
 HEAP32[i7 >> 2] = i3;
 if (!i6) {
  STACKTOP = i11;
  return;
 }
 i4 = HEAP32[i10 >> 2] | 0;
 while (1) {
  if ((i4 | 0) > 0) {
   i3 = 0;
   do {
    i6 = HEAP8[i2 + 1 >> 0] | 0;
    i4 = HEAP8[i2 + 2 >> 0] | 0;
    HEAP8[i1 + 2 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP8[i1 + 1 >> 0] = i6;
    HEAP8[i1 >> 0] = i4;
    i3 = i3 + 1 | 0;
    i2 = i2 + 3 | 0;
    i1 = i1 + 3 | 0;
    i4 = HEAP32[i10 >> 2] | 0;
   } while ((i3 | 0) < (i4 | 0));
   i5 = HEAP32[i7 >> 2] | 0;
  } else i5 = i3;
  i6 = i4 * 3 | 0;
  i3 = i5 + -1 | 0;
  HEAP32[i7 >> 2] = i3;
  if (!i5) break; else {
   i1 = i1 + (i9 - i6) | 0;
   i2 = i2 + (i8 - i6) | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i7;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i5, i6);
 do if (HEAP8[i5 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i6 + ((HEAP32[i1 + -12 >> 2] | 0) + 24) >> 2] | 0;
  if (i3) {
   i1 = i3 + 24 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (HEAP32[i3 + 28 >> 2] | 0)) {
    HEAP32[i1 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i4;
    break;
   }
   if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] & 127](i3, i4 & 255) | 0) != -1) break;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i1 = HEAP32[i1 + -12 >> 2] | 0;
  __ZNSt3__18ios_base5clearEj(i6 + i1 | 0, HEAP32[i6 + (i1 + 16) >> 2] | 1);
 } while (0);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i5);
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN2cvL11dotProd_32sEPKiS1_i(i5, i6, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 i2 = i4 + -4 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  d1 = 0.0;
 } else {
  i3 = 0;
  d1 = 0.0;
  do {
   i10 = i3 | 1;
   i9 = i3 | 2;
   i8 = i3 | 3;
   d1 = d1 + (+(HEAP32[i5 + (i3 << 2) >> 2] | 0) * +(HEAP32[i6 + (i3 << 2) >> 2] | 0) + +(HEAP32[i5 + (i10 << 2) >> 2] | 0) * +(HEAP32[i6 + (i10 << 2) >> 2] | 0) + +(HEAP32[i5 + (i9 << 2) >> 2] | 0) * +(HEAP32[i6 + (i9 << 2) >> 2] | 0) + +(HEAP32[i5 + (i8 << 2) >> 2] | 0) * +(HEAP32[i6 + (i8 << 2) >> 2] | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i2 | 0));
  i2 = i4 & -4;
 }
 if ((i2 | 0) >= (i4 | 0)) {
  STACKTOP = i7;
  return +d1;
 }
 do {
  d1 = d1 + +(HEAP32[i5 + (i2 << 2) >> 2] | 0) * +(HEAP32[i6 + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i7;
 return +d1;
}

function __ZN2cvL11dotProd_16sEPKsS1_i(i5, i6, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 i2 = i4 + -4 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  d1 = 0.0;
 } else {
  i3 = 0;
  d1 = 0.0;
  do {
   i10 = i3 | 1;
   i9 = i3 | 2;
   i8 = i3 | 3;
   d1 = d1 + (+(HEAP16[i5 + (i3 << 1) >> 1] | 0) * +(HEAP16[i6 + (i3 << 1) >> 1] | 0) + +(HEAP16[i5 + (i10 << 1) >> 1] | 0) * +(HEAP16[i6 + (i10 << 1) >> 1] | 0) + +(HEAP16[i5 + (i9 << 1) >> 1] | 0) * +(HEAP16[i6 + (i9 << 1) >> 1] | 0) + +(HEAP16[i5 + (i8 << 1) >> 1] | 0) * +(HEAP16[i6 + (i8 << 1) >> 1] | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i2 | 0));
  i2 = i4 & -4;
 }
 if ((i2 | 0) >= (i4 | 0)) {
  STACKTOP = i7;
  return +d1;
 }
 do {
  d1 = d1 + +(HEAP16[i5 + (i2 << 1) >> 1] | 0) * +(HEAP16[i6 + (i2 << 1) >> 1] | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i7;
 return +d1;
}

function _gzrewind(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 if (!i4) {
  i1 = -1;
  STACKTOP = i5;
  return i1 | 0;
 }
 i1 = i4 + 12 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 7247) {
  i1 = -1;
  STACKTOP = i5;
  return i1 | 0;
 }
 i3 = i4 + 76 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!((i2 | 0) == -5 | (i2 | 0) == 0)) {
  i1 = -1;
  STACKTOP = i5;
  return i1 | 0;
 }
 if ((_lseek(HEAP32[i4 + 16 >> 2] | 0, HEAP32[i4 + 48 >> 2] | 0, 0) | 0) == -1) {
  i1 = -1;
  STACKTOP = i5;
  return i1 | 0;
 }
 HEAP32[i4 >> 2] = 0;
 if ((HEAP32[i1 >> 2] | 0) == 7247) {
  HEAP32[i4 + 52 >> 2] = 0;
  HEAP32[i4 + 56 >> 2] = 0;
  HEAP32[i4 + 44 >> 2] = 0;
 }
 HEAP32[i4 + 72 >> 2] = 0;
 i1 = i4 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  if ((HEAP32[i3 >> 2] | 0) != -4) _free(i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 i1 = 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN7testing8internal10linked_ptrINS0_25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE8TestInfoEED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i3 | 0)) {
  i1 = i4;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i2;
  }
  HEAP32[i1 >> 2] = i4;
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i2 = i1 + 24 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i5 = HEAP32[i2 >> 2] | 0, (i5 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 511](i5);
  HEAP32[i2 >> 2] = 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 12 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i6;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i3, i1, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 i4 = i1;
 i2 = i5 - i4 | 0;
 if (i2 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i3);
 if (i2 >>> 0 < 11) {
  HEAP8[i3 >> 0] = i2 << 1;
  i3 = i3 + 1 | 0;
 } else {
  i8 = i2 + 16 & -16;
  i7 = __Znwj(i8) | 0;
  HEAP32[i3 + 8 >> 2] = i7;
  HEAP32[i3 >> 2] = i8 | 1;
  HEAP32[i3 + 4 >> 2] = i2;
  i3 = i7;
 }
 if ((i1 | 0) == (i5 | 0)) {
  i1 = i3;
  HEAP8[i1 >> 0] = 0;
  STACKTOP = i6;
  return;
 }
 i4 = i5 - i4 | 0;
 i2 = i3;
 while (1) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 1 | 0;
 }
 i1 = i3 + i4 | 0;
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEED2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 HEAP32[i5 >> 2] = 1928;
 i2 = i5 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i1 = HEAP32[i5 + 12 >> 2] | 0;
  if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 } else {
  i3 = i1;
  while (1) {
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (i2 | 0)) break; else i3 = i4;
  }
  HEAP32[i3 >> 2] = i1;
 }
 i3 = i5 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i3 | 0)) {
  i2 = i4;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
  }
  HEAP32[i2 >> 2] = i4;
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 STACKTOP = i6;
 return;
}

function _cvReleaseSparseMat(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i1 = i5 + 16 | 0;
 i2 = i5 + 8 | 0;
 i4 = i5;
 if (!i3) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-9, i1, 42024, 40912, 589);
  __ZN2cv6String10deallocateEv(i1);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((HEAP32[i1 >> 2] & -65536 | 0) != 1111752704) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-206, i2, 42024, 40912, 596);
  __ZN2cv6String10deallocateEv(i2);
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + 44 >> 2];
 _cvReleaseMemStorage(i4);
 i2 = i1 + 20 | 0;
 _cvFree_(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 _cvFree_(i1);
 STACKTOP = i5;
 return;
}

function __ZN6CvTypeD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[2644] | 0;
 if (!i2) {
  STACKTOP = i6;
  return;
 } else i5 = i2;
 while (1) {
  if (!(_strcmp(HEAP32[i5 + 16 >> 2] | 0, i3) | 0)) break;
  i2 = HEAP32[i5 + 12 >> 2] | 0;
  if (!i2) {
   i4 = 14;
   break;
  } else i5 = i2;
 }
 if ((i4 | 0) == 14) {
  STACKTOP = i6;
  return;
 }
 i2 = i5 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i5 + 12 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  HEAP32[2644] = i3;
  i1 = HEAP32[i2 >> 2] | 0;
 } else HEAP32[i1 + 12 >> 2] = i3;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) HEAP32[2646] = i1; else {
  HEAP32[i2 + 8 >> 2] = i1;
  i1 = HEAP32[2646] | 0;
 }
 if (!((HEAP32[2644] | 0) != 0 & (i1 | 0) != 0)) {
  HEAP32[2646] = 0;
  HEAP32[2644] = 0;
 }
 _cvFree_(i5);
 STACKTOP = i6;
 return;
}

function __ZN7testing8internal24XmlUnitTestResultPrinter21OutputXmlCDataSectionEPNSt3__113basic_ostreamIcNS2_11char_traitsIcEEEEPKc(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 163088, 9) | 0;
 i2 = _strstr(i1, 163104) | 0;
 if (i2) do {
  __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5writeEPKci(i3, i1, i2 - i1 | 0) | 0;
  __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 163112, 18) | 0;
  i1 = i2 + 3 | 0;
  i2 = _strstr(i1, 163104) | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, i1, _strlen(i1 | 0) | 0) | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i3, 163104, 3) | 0;
 STACKTOP = i4;
 return;
}

function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0;
 if (!(HEAP32[i2 + (i3 + 24) >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 if (HEAP32[i2 + (i3 + 16) >> 2] | 0) {
  STACKTOP = i4;
  return;
 }
 if (!(HEAP32[i2 + (i3 + 4) >> 2] & 8192)) {
  STACKTOP = i4;
  return;
 }
 if (__ZSt18uncaught_exceptionv() | 0) {
  STACKTOP = i4;
  return;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + ((HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2) | 0) != -1) {
  STACKTOP = i4;
  return;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i2 + i1 | 0, HEAP32[i2 + (i1 + 16) >> 2] | 1);
 STACKTOP = i4;
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0;
 if (!(HEAP32[i2 + (i3 + 24) >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 if (HEAP32[i2 + (i3 + 16) >> 2] | 0) {
  STACKTOP = i4;
  return;
 }
 if (!(HEAP32[i2 + (i3 + 4) >> 2] & 8192)) {
  STACKTOP = i4;
  return;
 }
 if (__ZSt18uncaught_exceptionv() | 0) {
  STACKTOP = i4;
  return;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + ((HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2) | 0) != -1) {
  STACKTOP = i4;
  return;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0;
 __ZNSt3__18ios_base5clearEj(i2 + i1 | 0, HEAP32[i2 + (i1 + 16) >> 2] | 1);
 STACKTOP = i4;
 return;
}

function __ZNSt3__114__num_put_base12__format_intEPcPKcbj(i1, i3, i6, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 if (i5 & 2048) {
  HEAP8[i1 >> 0] = 43;
  i1 = i1 + 1 | 0;
 }
 if (i5 & 512) {
  HEAP8[i1 >> 0] = 35;
  i1 = i1 + 1 | 0;
 }
 i2 = HEAP8[i3 >> 0] | 0;
 if (i2 << 24 >> 24) {
  i4 = i3;
  while (1) {
   i4 = i4 + 1 | 0;
   i3 = i1 + 1 | 0;
   HEAP8[i1 >> 0] = i2;
   i2 = HEAP8[i4 >> 0] | 0;
   if (!(i2 << 24 >> 24)) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
 }
 i2 = i5 & 74;
 if ((i2 | 0) == 64) {
  HEAP8[i1 >> 0] = 111;
  STACKTOP = i7;
  return;
 } else if ((i2 | 0) == 8) if (!(i5 & 16384)) {
  HEAP8[i1 >> 0] = 120;
  STACKTOP = i7;
  return;
 } else {
  HEAP8[i1 >> 0] = 88;
  STACKTOP = i7;
  return;
 } else if (i6) {
  HEAP8[i1 >> 0] = 100;
  STACKTOP = i7;
  return;
 } else {
  HEAP8[i1 >> 0] = 117;
  STACKTOP = i7;
  return;
 }
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i6, i5, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i7 = STACKTOP;
 i1 = HEAP8[i6 >> 0] | 0;
 if (!(i1 & 1)) i3 = 10; else {
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = (i1 & -2) + -1 | 0;
  i1 = i1 & 255;
 }
 i2 = (i1 & 1) == 0;
 if (i3 >>> 0 < i4 >>> 0) {
  if (i2) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i6 + 4 >> 2] | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc(i6, i3, i4 - i3 | 0, i1, 0, i1, i4, i5);
  STACKTOP = i7;
  return i6 | 0;
 }
 if (i2) i1 = i6 + 1 | 0; else i1 = HEAP32[i6 + 8 >> 2] | 0;
 _memmove(i1 | 0, i5 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 if (!(HEAP8[i6 >> 0] & 1)) {
  HEAP8[i6 >> 0] = i4 << 1;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  HEAP32[i6 + 4 >> 2] = i4;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj(i6, i5, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i7 = STACKTOP;
 i1 = HEAP8[i6 >> 0] | 0;
 if (!(i1 & 1)) i3 = 1; else {
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = (i1 & -2) + -1 | 0;
  i1 = i1 & 255;
 }
 i2 = (i1 & 1) == 0;
 if (i3 >>> 0 < i4 >>> 0) {
  if (i2) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i6 + 4 >> 2] | 0;
  __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw(i6, i3, i4 - i3 | 0, i1, 0, i1, i4, i5);
  STACKTOP = i7;
  return i6 | 0;
 }
 if (i2) i1 = i6 + 4 | 0; else i1 = HEAP32[i6 + 8 >> 2] | 0;
 _wmemmove(i1, i5, i4) | 0;
 HEAP32[i1 + (i4 << 2) >> 2] = 0;
 if (!(HEAP8[i6 >> 0] & 1)) {
  HEAP8[i6 >> 0] = i4 << 1;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  HEAP32[i6 + 4 >> 2] = i4;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZN7testing14TestPartResult14ExtractSummaryEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 i4 = _strstr(i2, 159728) | 0;
 if (!i4) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, _strlen(i2 | 0) | 0);
  STACKTOP = i6;
  return;
 }
 i5 = i4 - i2 | 0;
 if (i5 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i5 >>> 0 < 11) {
  HEAP8[i1 >> 0] = i5 << 1;
  i1 = i1 + 1 | 0;
 } else {
  i7 = i5 + 16 & -16;
  i3 = __Znwj(i7) | 0;
  HEAP32[i1 + 8 >> 2] = i3;
  HEAP32[i1 >> 2] = i7 | 1;
  HEAP32[i1 + 4 >> 2] = i5;
  i1 = i3;
 }
 if ((i4 | 0) != (i2 | 0)) {
  i3 = i1;
  while (1) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) break; else i3 = i3 + 1 | 0;
  }
  i1 = i1 + i5 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZNSt3__111__stdoutbufIwE4syncEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i9 + 8 | 0;
 i7 = i9;
 i1 = i2 + 36 | 0;
 i3 = i2 + 40 | 0;
 i4 = i8 + 8 | 0;
 i5 = i8;
 i6 = i2 + 32 | 0;
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = FUNCTION_TABLE_iiiiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] & 31](i2, HEAP32[i3 >> 2] | 0, i8, i4, i7) | 0;
  i10 = (HEAP32[i7 >> 2] | 0) - i5 | 0;
  if ((_fwrite(i8 | 0, 1, i10 | 0, HEAP32[i6 >> 2] | 0) | 0) != (i10 | 0)) {
   i1 = -1;
   i2 = 5;
   break;
  }
  if ((i2 | 0) == 2) {
   i1 = -1;
   i2 = 5;
   break;
  } else if ((i2 | 0) != 1) {
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) {
  i1 = ((_fflush(HEAP32[i6 >> 2] | 0) | 0) != 0) << 31 >> 31;
  STACKTOP = i9;
  return i1 | 0;
 } else if ((i2 | 0) == 5) {
  STACKTOP = i9;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__111__stdoutbufIcE4syncEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i9 + 8 | 0;
 i7 = i9;
 i1 = i2 + 36 | 0;
 i3 = i2 + 40 | 0;
 i4 = i8 + 8 | 0;
 i5 = i8;
 i6 = i2 + 32 | 0;
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = FUNCTION_TABLE_iiiiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] & 31](i2, HEAP32[i3 >> 2] | 0, i8, i4, i7) | 0;
  i10 = (HEAP32[i7 >> 2] | 0) - i5 | 0;
  if ((_fwrite(i8 | 0, 1, i10 | 0, HEAP32[i6 >> 2] | 0) | 0) != (i10 | 0)) {
   i1 = -1;
   i2 = 5;
   break;
  }
  if ((i2 | 0) == 2) {
   i1 = -1;
   i2 = 5;
   break;
  } else if ((i2 | 0) != 1) {
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) {
  i1 = ((_fflush(HEAP32[i6 >> 2] | 0) | 0) != 0) << 31 >> 31;
  STACKTOP = i9;
  return i1 | 0;
 } else if ((i2 | 0) == 5) {
  STACKTOP = i9;
  return i1 | 0;
 }
 return 0;
}

function __ZNK2cv11TiffEncoder10newEncoderEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 i4 = __Znwj(36) | 0;
 __ZN2cv16BaseImageEncoderC2Ev(i4);
 HEAP32[i4 >> 2] = 180576;
 i1 = i4 + 4 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = (__ZN2cv6String8allocateEj(i1, 25) | 0) + 0 | 0;
 i2 = 180616 | 0;
 i3 = i1 + 25 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i4 + 24 >> 0] = 1;
 i1 = __Znwj(16) | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i1 >> 2] = 178104;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -1;
 if ((i2 | 0) != 1) {
  STACKTOP = i5;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i5;
 return;
}

function __ZNK2cv10PxMEncoder10newEncoderEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 i4 = __Znwj(36) | 0;
 __ZN2cv16BaseImageEncoderC2Ev(i4);
 HEAP32[i4 >> 2] = 179696;
 i1 = i4 + 4 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = (__ZN2cv6String8allocateEj(i1, 53) | 0) + 0 | 0;
 i2 = 179736 | 0;
 i3 = i1 + 53 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i4 + 24 >> 0] = 1;
 i1 = __Znwj(16) | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i1 >> 2] = 178216;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -1;
 if ((i2 | 0) != 1) {
  STACKTOP = i5;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i5;
 return;
}

function __ZNK2cv10BmpEncoder10newEncoderEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 i4 = __Znwj(36) | 0;
 __ZN2cv16BaseImageEncoderC2Ev(i4);
 HEAP32[i4 >> 2] = 179176;
 i1 = i4 + 4 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = (__ZN2cv6String8allocateEj(i1, 28) | 0) + 0 | 0;
 i2 = 179216 | 0;
 i3 = i1 + 28 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i4 + 24 >> 0] = 1;
 i1 = __Znwj(16) | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i1 >> 2] = 178904;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -1;
 if ((i2 | 0) != 1) {
  STACKTOP = i5;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i5;
 return;
}

function _cvReadRawData(i4, i6, i2, i3) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i5 = i8 + 8 | 0;
 i1 = i8;
 if (!((i6 | 0) != 0 & (i2 | 0) != 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i7 = (__ZN2cv6String8allocateEj(i1, 54) | 0) + 0 | 0;
  i9 = 10504 | 0;
  i10 = i7 + 54 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i9 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i9 = i9 + 1 | 0;
  } while ((i7 | 0) < (i10 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 10560, 8960, 3358);
  __ZN2cv6String10deallocateEv(i1);
 }
 _cvStartReadRawData(i4, i6, i5);
 if ((HEAP32[i6 >> 2] & 7 | 0) != 5) {
  i1 = 1;
  _cvReadRawDataSlice(i4, i5, i1, i2, i3);
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 24 >> 2] | 0;
 _cvReadRawDataSlice(i4, i5, i1, i2, i3);
 STACKTOP = i8;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEjc(i6, i5, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i7 = STACKTOP;
 if (!i5) {
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = HEAP8[i6 >> 0] | 0;
 if (!(i1 & 1)) i2 = 10; else {
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = (i1 & -2) + -1 | 0;
  i1 = i1 & 255;
 }
 if (!(i1 & 1)) i3 = (i1 & 255) >>> 1; else i3 = HEAP32[i6 + 4 >> 2] | 0;
 if ((i2 - i3 | 0) >>> 0 < i5 >>> 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i6, i2, i5 - i2 + i3 | 0, i3, i3, 0, 0);
  i1 = HEAP8[i6 >> 0] | 0;
 }
 if (!(i1 & 1)) i2 = i6 + 1 | 0; else i2 = HEAP32[i6 + 8 >> 2] | 0;
 _memset(i2 + i3 | 0, i4 | 0, i5 | 0) | 0;
 i1 = i3 + i5 | 0;
 if (!(HEAP8[i6 >> 0] & 1)) HEAP8[i6 >> 0] = i1 << 1; else HEAP32[i6 + 4 >> 2] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function _gz_error(i3, i2, i6) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i8;
 i5 = i3 + 80 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1) {
  if ((HEAP32[i3 + 76 >> 2] | 0) != -4) _free(i1);
  HEAP32[i5 >> 2] = 0;
 }
 if (!((i2 | 0) == 0 | (i2 | 0) == -5)) HEAP32[i3 >> 2] = 0;
 i4 = i3 + 76 | 0;
 HEAP32[i4 >> 2] = i2;
 if ((i6 | 0) == 0 | (i2 | 0) == -4) {
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 i2 = _strlen(i1 | 0) | 0;
 i2 = _malloc(i2 + 3 + (_strlen(i6 | 0) | 0) | 0) | 0;
 HEAP32[i5 >> 2] = i2;
 if (!i2) {
  HEAP32[i4 >> 2] = -4;
  STACKTOP = i8;
  return;
 } else {
  i3 = _strlen(i1 | 0) | 0;
  i3 = i3 + 3 + (_strlen(i6 | 0) | 0) | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = 143312;
  HEAP32[i7 + 8 >> 2] = i6;
  _snprintf(i2, i3, 143304, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function _cvCreateImage(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i9 + 8 | 0;
 i2 = i9;
 i5 = i1;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i6 = HEAP32[10242] | 0;
 if (!i6) {
  i1 = _cvAlloc(112) | 0;
  i6 = i2;
  HEAP32[i6 >> 2] = i4;
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i3 + 0 >> 2] = HEAP32[i2 + 0 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  _cvInitImageHeader(i1, i3, i8, i7, 0, 4) | 0;
  _cvCreateData(i1);
  STACKTOP = i9;
  return i1 | 0;
 }
 i1 = i7 + -1 | 0;
 if (i1 >>> 0 < 4) {
  i2 = HEAP32[43368 + (i1 << 3) >> 2] | 0;
  i1 = HEAP32[43372 + (i1 << 3) >> 2] | 0;
 } else {
  i2 = 41088;
  i1 = 41088;
 }
 i1 = FUNCTION_TABLE_iiiiiiiiiiiiiii[i6 & 0](i7, 0, i8, i2, i1, 0, 0, 4, i4, i5, 0, 0, 0, 0) | 0;
 _cvCreateData(i1);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN2cvL15countNonZero32fEPKfi(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 i2 = i4 + -4 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = 0;
  i1 = 0;
  do {
   i9 = Math_fround(HEAPF32[i5 + (i3 << 2) >> 2]) != Math_fround(0.0) & 1;
   i8 = Math_fround(HEAPF32[i5 + ((i3 | 1) << 2) >> 2]) != Math_fround(0.0) & 1;
   i7 = Math_fround(HEAPF32[i5 + ((i3 | 2) << 2) >> 2]) != Math_fround(0.0) & 1;
   i1 = i9 + i1 + i8 + i7 + (Math_fround(HEAPF32[i5 + ((i3 | 3) << 2) >> 2]) != Math_fround(0.0) & 1) | 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i2 | 0));
  i2 = i4 & -4;
 }
 if ((i2 | 0) >= (i4 | 0)) {
  STACKTOP = i6;
  return i1 | 0;
 }
 do {
  i1 = (Math_fround(HEAPF32[i5 + (i2 << 2) >> 2]) != Math_fround(0.0) & 1) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN2cv10HdrDecoderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 __ZN2cv16BaseImageDecoderC2Ev(i1);
 HEAP32[i1 >> 2] = 180128;
 i2 = i1 + 92 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 i4 = i1 + 24 | 0;
 __ZN2cv6String10deallocateEv(i4);
 i4 = __ZN2cv6String8allocateEj(i4, 6) | 0;
 HEAP8[i4 + 0 >> 0] = HEAP8[180168] | 0;
 HEAP8[i4 + 1 >> 0] = HEAP8[180169] | 0;
 HEAP8[i4 + 2 >> 0] = HEAP8[180170] | 0;
 HEAP8[i4 + 3 >> 0] = HEAP8[180171] | 0;
 HEAP8[i4 + 4 >> 0] = HEAP8[180172] | 0;
 HEAP8[i4 + 5 >> 0] = HEAP8[180173] | 0;
 __ZN2cv6String10deallocateEv(i2);
 i2 = (__ZN2cv6String8allocateEj(i2, 10) | 0) + 0 | 0;
 i4 = 180176 | 0;
 i5 = i2 + 10 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i2 | 0) < (i5 | 0));
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 21;
 STACKTOP = i3;
 return;
}

function __ZN2cvL14cvtScale16s32sEPKsjPKhjPijNS_5Size_IiEEPd(i11, i5, i1, i2, i9, i6, i3, i4) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, f8 = f0, f10 = f0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 i12 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f10 = Math_fround(+HEAPF64[i4 >> 3]);
 f8 = Math_fround(+HEAPF64[i4 + 8 >> 3]);
 i7 = i5 >>> 1;
 i5 = i6 >>> 2;
 if (!i3) {
  STACKTOP = i13;
  return;
 }
 i6 = (i12 | 0) > 0;
 i4 = i9;
 i1 = i11;
 while (1) {
  i3 = i3 + -1 | 0;
  if (i6) {
   i2 = 0;
   do {
    HEAP32[i4 + (i2 << 2) >> 2] = _lrint(+Math_fround(f8 + Math_fround(f10 * Math_fround(HEAP16[i1 + (i2 << 1) >> 1] | 0)))) | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i12 | 0));
  }
  if (!i3) break; else {
   i4 = i4 + (i5 << 2) | 0;
   i1 = i1 + (i7 << 1) | 0;
  }
 }
 STACKTOP = i13;
 return;
}

function __ZN2cvL10ReadNumberERNS_12RLByteStreamEi(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 i1 = __ZN2cv12RLByteStream7getByteEv(i5) | 0;
 if ((i1 + -48 | 0) >>> 0 < 10) {
  i2 = 0;
  i3 = 0;
 } else {
  do {
   if ((i1 | 0) == 35) do i1 = __ZN2cv12RLByteStream7getByteEv(i5) | 0; while (!((i1 | 0) == 10 | (i1 | 0) == 13));
   i1 = __ZN2cv12RLByteStream7getByteEv(i5) | 0;
   if (_isspace(i1) | 0) do i1 = __ZN2cv12RLByteStream7getByteEv(i5) | 0; while ((_isspace(i1) | 0) != 0);
  } while ((i1 + -48 | 0) >>> 0 > 9);
  i2 = 0;
  i3 = 0;
 }
 while (1) {
  i3 = i1 + -48 + (i3 * 10 | 0) | 0;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i4 | 0)) {
   i1 = 9;
   break;
  }
  i1 = __ZN2cv12RLByteStream7getByteEv(i5) | 0;
  if ((i1 + -48 | 0) >>> 0 >= 10) {
   i1 = 9;
   break;
  }
 }
 if ((i1 | 0) == 9) {
  STACKTOP = i6;
  return i3 | 0;
 }
 return 0;
}

function __ZNK2cv16SunRasterEncoder10newEncoderEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 i4 = __Znwj(36) | 0;
 __ZN2cv16BaseImageEncoderC2Ev(i4);
 HEAP32[i4 >> 2] = 179960;
 i1 = i4 + 4 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = (__ZN2cv6String8allocateEj(i1, 29) | 0) + 0 | 0;
 i2 = 18e4 | 0;
 i3 = i1 + 29 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = __Znwj(16) | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i1 >> 2] = 178440;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -1;
 if ((i2 | 0) != 1) {
  STACKTOP = i5;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i5;
 return;
}

function __ZN7testing15AssertionResultlsIPKcEERS0_RKT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i6;
 __ZN7testing7MessageC2Ev(i3);
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + 8 | 0;
 if (!i1) __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, 159200, 6) | 0; else __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i2, i1, _strlen(i1 | 0) | 0) | 0;
 __ZN7testing15AssertionResult13AppendMessageERKNS_7MessageE(i5, i3);
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i6;
  return i5 | 0;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i4 = HEAP32[i3 >> 2] | 0, (i4 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 511](i4);
 HEAP32[i3 >> 2] = 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN2cvL10dotProd_8sEPKaS1_i(i5, i6, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 i2 = i4 + -4 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  d1 = 0.0;
 } else {
  i3 = 0;
  d1 = 0.0;
  do {
   i10 = i3 | 1;
   i9 = i3 | 2;
   i8 = i3 | 3;
   d1 = d1 + (+(HEAP8[i5 + i3 >> 0] | 0) * +(HEAP8[i6 + i3 >> 0] | 0) + +(HEAP8[i5 + i10 >> 0] | 0) * +(HEAP8[i6 + i10 >> 0] | 0) + +(HEAP8[i5 + i9 >> 0] | 0) * +(HEAP8[i6 + i9 >> 0] | 0) + +(HEAP8[i5 + i8 >> 0] | 0) * +(HEAP8[i6 + i8 >> 0] | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i2 | 0));
  i2 = i4 & -4;
 }
 if ((i2 | 0) >= (i4 | 0)) {
  d1 = d1 + 0.0;
  STACKTOP = i7;
  return +d1;
 }
 do {
  d1 = d1 + +(HEAP8[i5 + i2 >> 0] | 0) * +(HEAP8[i6 + i2 >> 0] | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 d1 = d1 + 0.0;
 STACKTOP = i7;
 return +d1;
}

function __ZN2cv3minERKNS_3MatES2_RS0_(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i5 = i4 + 40 | 0;
 i7 = i4 + 20 | 0;
 i6 = i4;
 i8 = i5 + 4 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i5 >> 2] = 32232;
 HEAP32[i8 >> 2] = 33619968;
 HEAP32[i5 + 8 >> 2] = i1;
 HEAP32[i7 >> 2] = 32088;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 16842752;
 HEAP32[i7 + 8 >> 2] = i2;
 HEAP32[i6 >> 2] = 32088;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 16842752;
 HEAP32[i6 + 8 >> 2] = i3;
 __ZN2cvL9binary_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_PKPFvPKhjS7_jPhjNS_5Size_IiEEPvEbi(i7, i6, i5, __ZN2cv7noArrayEv() | 0, 5848, 0, 13);
 STACKTOP = i4;
 return;
}

function __ZN2cv3maxERKNS_3MatES2_RS0_(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 i5 = i4 + 40 | 0;
 i7 = i4 + 20 | 0;
 i6 = i4;
 i8 = i5 + 4 | 0;
 HEAP32[i8 + 0 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i5 >> 2] = 32232;
 HEAP32[i8 >> 2] = 33619968;
 HEAP32[i5 + 8 >> 2] = i1;
 HEAP32[i7 >> 2] = 32088;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 16842752;
 HEAP32[i7 + 8 >> 2] = i2;
 HEAP32[i6 >> 2] = 32088;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 16842752;
 HEAP32[i6 + 8 >> 2] = i3;
 __ZN2cvL9binary_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_PKPFvPKhjS7_jPhjNS_5Size_IiEEPvEbi(i7, i6, i5, __ZN2cv7noArrayEv() | 0, 5880, 0, 14);
 STACKTOP = i4;
 return;
}

function __ZNK2cv9MatOp_Bin8multiplyERKNS_7MatExprEdRS1_(i1, i4, d7, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 d7 = +d7;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i1 | 0) == 47 | (i1 | 0) == 42) {
  i1 = i4;
  i5 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = i5;
  __ZN2cv3MataSERKS0_(i2 + 8 | 0, i4 + 8 | 0) | 0;
  __ZN2cv3MataSERKS0_(i2 + 64 | 0, i4 + 64 | 0) | 0;
  __ZN2cv3MataSERKS0_(i2 + 120 | 0, i4 + 120 | 0) | 0;
  i3 = i2 + 176 | 0;
  i5 = i3 + 0 | 0;
  i2 = i4 + 176 | 0;
  i1 = i5 + 48 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   i5 = i5 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i5 | 0) < (i1 | 0));
  HEAPF64[i3 >> 3] = +HEAPF64[i3 >> 3] * d7;
  STACKTOP = i6;
  return;
 } else {
  __ZNK2cv5MatOp8multiplyERKNS_7MatExprEdRS1_(0, i4, d7, i2);
  STACKTOP = i6;
  return;
 }
}

function __ZN7testing15AssertionResult13AppendMessageERKNS_7MessageE(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i6;
 i1 = i2 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __Znwj(12) | 0;
  HEAP32[i2 + 0 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i3 = HEAP32[i1 >> 2] | 0, (i3 | 0) != 0) : 0) {
   __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
   __ZdlPv(i3);
  }
  HEAP32[i1 >> 2] = i2;
 }
 __ZNK7testing7Message9GetStringEv(i5, i4);
 if (!(HEAP8[i5 >> 0] & 1)) i1 = i5 + 1 | 0; else i1 = HEAP32[i5 + 8 >> 2] | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i2, i1) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 STACKTOP = i6;
 return;
}

function __ZN2cvL11dotProd_64fEPKdS1_i(i5, i6, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 i2 = i4 + -4 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  d1 = 0.0;
 } else {
  i3 = 0;
  d1 = 0.0;
  do {
   i10 = i3 | 1;
   i9 = i3 | 2;
   i8 = i3 | 3;
   d1 = d1 + (+HEAPF64[i5 + (i3 << 3) >> 3] * +HEAPF64[i6 + (i3 << 3) >> 3] + +HEAPF64[i5 + (i10 << 3) >> 3] * +HEAPF64[i6 + (i10 << 3) >> 3] + +HEAPF64[i5 + (i9 << 3) >> 3] * +HEAPF64[i6 + (i9 << 3) >> 3] + +HEAPF64[i5 + (i8 << 3) >> 3] * +HEAPF64[i6 + (i8 << 3) >> 3]);
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i2 | 0));
  i2 = i4 & -4;
 }
 if ((i2 | 0) >= (i4 | 0)) {
  STACKTOP = i7;
  return +d1;
 }
 do {
  d1 = d1 + +HEAPF64[i5 + (i2 << 3) >> 3] * +HEAPF64[i6 + (i2 << 3) >> 3];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i7;
 return +d1;
}

function __ZN2cv8dotProd_IhEEdPKT_S3_i(i5, i6, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 i2 = i4 + -4 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  d1 = 0.0;
 } else {
  i3 = 0;
  d1 = 0.0;
  do {
   i10 = i3 | 1;
   i9 = i3 | 2;
   i8 = i3 | 3;
   d1 = d1 + (+(HEAPU8[i5 + i3 >> 0] | 0) * +(HEAPU8[i6 + i3 >> 0] | 0 | 0) + +(HEAPU8[i5 + i10 >> 0] | 0) * +(HEAPU8[i6 + i10 >> 0] | 0 | 0) + +(HEAPU8[i5 + i9 >> 0] | 0) * +(HEAPU8[i6 + i9 >> 0] | 0 | 0) + +(HEAPU8[i5 + i8 >> 0] | 0) * +(HEAPU8[i6 + i8 >> 0] | 0 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i2 | 0));
  i2 = i4 & -4;
 }
 if ((i2 | 0) >= (i4 | 0)) {
  STACKTOP = i7;
  return +d1;
 }
 do {
  d1 = d1 + +(HEAPU8[i5 + i2 >> 0] | 0) * +(HEAPU8[i6 + i2 >> 0] | 0 | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i7;
 return +d1;
}

function __ZNK2cv10HdrEncoder10newEncoderEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 i4 = __Znwj(36) | 0;
 __ZN2cv16BaseImageEncoderC2Ev(i4);
 HEAP32[i4 >> 2] = 180208;
 i1 = i4 + 4 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = (__ZN2cv6String8allocateEj(i1, 26) | 0) + 0 | 0;
 i2 = 180248 | 0;
 i3 = i1 + 26 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = __Znwj(16) | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i1 >> 2] = 178680;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -1;
 if ((i2 | 0) != 1) {
  STACKTOP = i5;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i5;
 return;
}

function _inflateReset(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 if (!i3) {
  i1 = -2;
  STACKTOP = i4;
  return i1 | 0;
 }
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i2) {
  i1 = -2;
  STACKTOP = i4;
  return i1 | 0;
 }
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) HEAP32[i3 + 48 >> 2] = i1 & 1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 32768;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 i1 = i2 + 1328 | 0;
 HEAP32[i2 + 108 >> 2] = i1;
 HEAP32[i2 + 80 >> 2] = i1;
 HEAP32[i2 + 76 >> 2] = i1;
 HEAP32[i2 + 7104 >> 2] = 1;
 HEAP32[i2 + 7108 >> 2] = -1;
 i1 = 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __Z26icvCvt_BGR5652BGR_8u_C2C3RPKhiPhi6CvSize(i2, i7, i1, i8, i9) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 i6 = i9 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i3 = i4 + -1 | 0;
 HEAP32[i6 >> 2] = i3;
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 while (1) {
  if ((i4 | 0) > 0) {
   i3 = 0;
   do {
    i4 = HEAPU16[i2 + (i3 << 1) >> 1] | 0;
    HEAP8[i1 >> 0] = i4 << 3;
    HEAP8[i1 + 1 >> 0] = i4 >>> 3 & 252;
    HEAP8[i1 + 2 >> 0] = i4 >>> 8 & 248;
    i3 = i3 + 1 | 0;
    i1 = i1 + 3 | 0;
    i4 = HEAP32[i9 >> 2] | 0;
   } while ((i3 | 0) < (i4 | 0));
   i5 = HEAP32[i6 >> 2] | 0;
  } else i5 = i3;
  i1 = i1 + ((Math_imul(i4, -3) | 0) + i8) | 0;
  i3 = i5 + -1 | 0;
  HEAP32[i6 >> 2] = i3;
  if (!i5) break; else i2 = i2 + i7 | 0;
 }
 STACKTOP = i10;
 return;
}

function __Z26icvCvt_BGR5552BGR_8u_C2C3RPKhiPhi6CvSize(i2, i7, i1, i8, i9) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 i6 = i9 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i3 = i4 + -1 | 0;
 HEAP32[i6 >> 2] = i3;
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 while (1) {
  if ((i4 | 0) > 0) {
   i3 = 0;
   do {
    i4 = HEAPU16[i2 + (i3 << 1) >> 1] | 0;
    HEAP8[i1 >> 0] = i4 << 3;
    HEAP8[i1 + 1 >> 0] = i4 >>> 2 & 248;
    HEAP8[i1 + 2 >> 0] = i4 >>> 7 & 248;
    i3 = i3 + 1 | 0;
    i1 = i1 + 3 | 0;
    i4 = HEAP32[i9 >> 2] | 0;
   } while ((i3 | 0) < (i4 | 0));
   i5 = HEAP32[i6 >> 2] | 0;
  } else i5 = i3;
  i1 = i1 + ((Math_imul(i4, -3) | 0) + i8) | 0;
  i3 = i5 + -1 | 0;
  HEAP32[i6 >> 2] = i3;
  if (!i5) break; else i2 = i2 + i7 | 0;
 }
 STACKTOP = i10;
 return;
}
function __ZN4perf10Regression8instanceEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = STACKTOP;
 if (HEAP8[169816] | 0) {
  STACKTOP = i1;
  return 169680;
 }
 if (!(___cxa_guard_acquire(169816) | 0)) {
  STACKTOP = i1;
  return 169680;
 }
 i5 = __ZN2cv12getTickCountEv() | 0;
 i3 = tempRet0;
 i4 = (i5 | 0) != 0 | (i3 | 0) != 0;
 i2 = 169680;
 HEAP32[i2 >> 2] = i4 ? i5 : -1;
 HEAP32[i2 + 4 >> 2] = i4 ? i3 : 0;
 HEAP32[42422] = 0;
 HEAP32[42423] = 0;
 HEAP32[42424] = 0;
 HEAP32[42425] = 0;
 HEAP32[42426] = 0;
 HEAP32[42427] = 0;
 __ZN2cv11FileStorageC2Ev(169712);
 __ZN2cv11FileStorageC2Ev(169748);
 HEAP32[42446] = 0;
 HEAP32[42447] = 0;
 HEAP32[42448] = 0;
 HEAP32[42449] = 0;
 HEAP32[42450] = 0;
 HEAP32[42451] = 0;
 HEAP32[42452] = 0;
 HEAP32[42453] = 0;
 ___cxa_atexit(378, 169680, ___dso_handle | 0) | 0;
 ___cxa_guard_release(169816);
 STACKTOP = i1;
 return 169680;
}

function __ZN2cv16BaseImageEncoder14setDestinationERNSt3__16vectorIhNS1_9allocatorIhEEEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i6;
 if (!(HEAP8[i5 + 24 >> 0] | 0)) {
  i1 = 0;
  STACKTOP = i6;
  return i1 | 0;
 }
 HEAP32[i5 + 20 >> 2] = i1;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = i1 + 4 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i2;
 i3 = i5 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i2 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 if ((i4 | 0) != (i3 | 0)) {
  __ZN2cv6String10deallocateEv(i3);
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i1 = i1 + -4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i1;
  HEAP32[i5 + 16 >> 2] = HEAP32[i2 >> 2];
 }
 __ZN2cv6String10deallocateEv(i4);
 i1 = 1;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_(i2, i4, i1, i5, i6) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i7;
 HEAP32[i6 >> 2] = i1;
 i2 = _uselocale(HEAP32[i2 + 8 >> 2] | 0) | 0;
 i1 = _wcrtomb(i3, 0, i4) | 0;
 if (i2) _uselocale(i2 | 0) | 0;
 if ((i1 | 0) == 0 | (i1 | 0) == -1) {
  i1 = 2;
  STACKTOP = i7;
  return i1 | 0;
 }
 i1 = i1 + -1 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i1 >>> 0 > (i5 - i2 | 0) >>> 0) {
  i1 = 1;
  STACKTOP = i7;
  return i1 | 0;
 }
 if (!i1) {
  i1 = 0;
  STACKTOP = i7;
  return i1 | 0;
 }
 while (1) {
  i4 = HEAP8[i3 >> 0] | 0;
  HEAP32[i6 >> 2] = i2 + 1;
  HEAP8[i2 >> 0] = i4;
  i1 = i1 + -1 | 0;
  if (!i1) {
   i1 = 0;
   break;
  }
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i3 + 1 | 0;
 }
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i2, HEAP32[i1 >> 2] | 0);
 __ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i2, HEAP32[i1 + 4 >> 2] | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 16 | 0);
 __ZdlPv(i1);
 STACKTOP = i3;
 return;
}

function __ZNSt3__127__num_get_unsigned_integralIyEET_PKcS3_Rji(i2, i5, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i8;
 do if ((i2 | 0) != (i5 | 0)) {
  if ((HEAP8[i2 >> 0] | 0) == 45) {
   HEAP32[i6 >> 2] = 4;
   i2 = 0;
   i1 = 0;
   break;
  }
  i3 = ___errno_location() | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  i1 = _strtoull_l(i2, i7, i1, __ZNSt3__16__clocEv() | 0) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) HEAP32[i3 >> 2] = i4;
  if ((HEAP32[i7 >> 2] | 0) != (i5 | 0)) {
   HEAP32[i6 >> 2] = 4;
   i2 = 0;
   i1 = 0;
   break;
  }
  if ((i2 | 0) == 34) {
   HEAP32[i6 >> 2] = 4;
   i2 = -1;
   i1 = -1;
  } else i2 = tempRet0;
 } else {
  HEAP32[i6 >> 2] = 4;
  i2 = 0;
  i1 = 0;
 } while (0);
 tempRet0 = i2;
 STACKTOP = i8;
 return i1 | 0;
}

function __Z27icvCvt_BGR5652Gray_8u_C2C1RPKhiPhi6CvSize(i2, i7, i1, i8, i9) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 i6 = i9 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i3 = i4 + -1 | 0;
 HEAP32[i6 >> 2] = i3;
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 while (1) {
  if ((i4 | 0) > 0) {
   i3 = 0;
   do {
    i4 = HEAPU16[i2 + (i3 << 1) >> 1] | 0;
    HEAP8[i1 + i3 >> 0] = (((i4 >>> 3 & 252) * 9617 | 0) + 8192 + ((i4 << 3 & 248) * 1868 | 0) + ((i4 >>> 8 & 248) * 4899 | 0) | 0) >>> 14;
    i3 = i3 + 1 | 0;
    i4 = HEAP32[i9 >> 2] | 0;
   } while ((i3 | 0) < (i4 | 0));
   i5 = HEAP32[i6 >> 2] | 0;
  } else i5 = i3;
  i3 = i5 + -1 | 0;
  HEAP32[i6 >> 2] = i3;
  if (!i5) break; else {
   i1 = i1 + i8 | 0;
   i2 = i2 + i7 | 0;
  }
 }
 STACKTOP = i10;
 return;
}

function __Z27icvCvt_BGR5552Gray_8u_C2C1RPKhiPhi6CvSize(i2, i7, i1, i8, i9) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 i6 = i9 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i3 = i4 + -1 | 0;
 HEAP32[i6 >> 2] = i3;
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 while (1) {
  if ((i4 | 0) > 0) {
   i3 = 0;
   do {
    i4 = HEAPU16[i2 + (i3 << 1) >> 1] | 0;
    HEAP8[i1 + i3 >> 0] = (((i4 >>> 2 & 248) * 9617 | 0) + 8192 + ((i4 << 3 & 248) * 1868 | 0) + ((i4 >>> 7 & 248) * 4899 | 0) | 0) >>> 14;
    i3 = i3 + 1 | 0;
    i4 = HEAP32[i9 >> 2] | 0;
   } while ((i3 | 0) < (i4 | 0));
   i5 = HEAP32[i6 >> 2] | 0;
  } else i5 = i3;
  i3 = i5 + -1 | 0;
  HEAP32[i6 >> 2] = i3;
  if (!i5) break; else {
   i1 = i1 + i8 | 0;
   i2 = i2 + i7 | 0;
  }
 }
 STACKTOP = i10;
 return;
}

function __ZN2cv12RLByteStream8getBytesEPvi(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 if ((i1 | 0) <= 0) {
  i1 = 0;
  STACKTOP = i9;
  return i1 | 0;
 }
 i6 = i8 + 12 | 0;
 i7 = i8 + 16 | 0;
 i5 = i1;
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = 0;
 while (1) {
  i3 = (HEAP32[i6 >> 2] | 0) - i4 | 0;
  i3 = (i3 | 0) > (i5 | 0) ? i5 : i3;
  if ((i3 | 0) <= 0) do {
   FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] & 511](i8);
   i4 = HEAP32[i7 >> 2] | 0;
   i3 = (HEAP32[i6 >> 2] | 0) - i4 | 0;
   i3 = (i3 | 0) > (i5 | 0) ? i5 : i3;
  } while ((i3 | 0) <= 0);
  _memcpy(i2 | 0, i4 | 0, i3 | 0) | 0;
  i4 = (HEAP32[i7 >> 2] | 0) + i3 | 0;
  HEAP32[i7 >> 2] = i4;
  i5 = i5 - i3 | 0;
  i1 = i3 + i1 | 0;
  if ((i5 | 0) <= 0) break; else i2 = i2 + i3 | 0;
 }
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNSt3__112system_errorC2ENS_10error_codeEPKc(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i6 = i4 + 12 | 0;
 i5 = i4;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i3, _strlen(i3 | 0) | 0);
 __ZNSt3__112system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6, i1, i5);
 __ZNSt13runtime_errorC2ERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i6);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i5);
 HEAP32[i2 >> 2] = 957656;
 i5 = i1;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZNSt3__19__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_(i5, i3, i1, i2, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i6;
 __ZNKSt3__18ios_base6getlocEv(i7, i3);
 i3 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 960720) | 0;
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] & 7](i3, 959240, 959272 | 0, i1) | 0;
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 960880) | 0;
 HEAP32[i2 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 127](i1) | 0;
 HEAP32[i4 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 127](i1) | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i5, i1);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i7 >> 2] | 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZNSt3__19__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_(i5, i3, i1, i2, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i6;
 __ZNKSt3__18ios_base6getlocEv(i7, i3);
 i3 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 960728) | 0;
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] & 7](i3, 959240, 959272 | 0, i1) | 0;
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i7, 960872) | 0;
 HEAP8[i2 >> 0] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 127](i1) | 0;
 HEAP8[i4 >> 0] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 127](i1) | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i5, i1);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i7 >> 2] | 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZN2cv12RLByteStream7getWordEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 i6 = i5 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i3 = i5 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  i2 = (HEAPU8[i2 >> 0] | 0) << 8 | (HEAPU8[i1 >> 0] | 0);
  HEAP32[i6 >> 2] = i1 + 2;
  i1 = i2;
  STACKTOP = i7;
  return i1 | 0;
 }
 if (i1 >>> 0 >= i4 >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] & 511](i5);
  i4 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i3 = HEAPU8[i1 >> 0] | 0;
 i1 = i1 + 1 | 0;
 HEAP32[i6 >> 2] = i1;
 if (i1 >>> 0 >= i4 >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] & 511](i5);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i2 = HEAPU8[i1 >> 0] | 0;
 HEAP32[i6 >> 2] = i1 + 1;
 i1 = i2 << 8 | i3;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i5 = i6;
 i3 = i6 + 8 | 0;
 HEAP32[i3 >> 2] = i2;
 if ((HEAP8[168960] | 0) == 0 ? (___cxa_guard_acquire(168960) | 0) != 0 : 0) {
  HEAP8[168952] = (__ZN7testing8internal14ShouldUseColorEb((_isatty(_fileno(HEAP32[_stdout >> 2] | 0) | 0) | 0) != 0) | 0) & 1;
  ___cxa_guard_release(168960);
 }
 if (!((i1 | 0) != 0 & (HEAP8[168952] | 0) != 0)) {
  _vprintf(i4 | 0, i3 | 0) | 0;
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) == 1) i1 = 162128; else if ((i1 | 0) == 2) i1 = 168992; else if ((i1 | 0) == 3) i1 = 169e3; else i1 = 0;
 HEAP32[i5 >> 2] = i1;
 _printf(168968, i5 | 0) | 0;
 _vprintf(i4 | 0, i3 | 0) | 0;
 _printf(168984, i5 | 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZNSt3__114__split_bufferIN2cv23CommandLineParserParamsERNS_9allocatorIS2_EEED2Ev(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i9 + 8 | 0;
 while (1) {
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) == (i1 | 0)) break;
  i5 = i4 + -32 | 0;
  HEAP32[i3 >> 2] = i5;
  i6 = i4 + -16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if (i7) {
   i8 = i4 + -12 | 0;
   while (1) {
    i2 = HEAP32[i8 >> 2] | 0;
    if ((i2 | 0) == (i7 | 0)) break;
    i2 = i2 + -8 | 0;
    HEAP32[i8 >> 2] = i2;
    __ZN2cv6String10deallocateEv(i2);
   }
   __ZdlPv(HEAP32[i6 >> 2] | 0);
  }
  __ZN2cv6String10deallocateEv(i4 + -24 | 0);
  __ZN2cv6String10deallocateEv(i5);
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i10;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE(i5, i6, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 4 | 0;
 i9 = i7;
 i5 = i5 + 8 | 0;
 i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 127](i5) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
 i1 = (__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i1, i8, i5, i5 + 288 | 0, i2, i4, 0) | 0) - i5 | 0;
 if ((i1 | 0) >= 288) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i6 >> 2] = ((i1 | 0) / 12 | 0 | 0) % 12 | 0;
 STACKTOP = i7;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE(i5, i6, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 4 | 0;
 i9 = i7;
 i5 = i5 + 8 | 0;
 i5 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] & 127](i5) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
 i1 = (__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i1, i8, i5, i5 + 288 | 0, i2, i4, 0) | 0) - i5 | 0;
 if ((i1 | 0) >= 288) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i6 >> 2] = ((i1 | 0) / 12 | 0 | 0) % 12 | 0;
 STACKTOP = i7;
 return;
}

function __ZN2cvL16transposeI_32sC2EPhji(i3, i7, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) > 0) i4 = 0; else {
  STACKTOP = i8;
  return;
 }
 do {
  i1 = i3 + (Math_imul(i4, i7) | 0) | 0;
  i2 = i4 << 3;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) < (i6 | 0)) {
   i5 = i4;
   do {
    i12 = i1 + (i5 << 3) | 0;
    i9 = i3 + ((Math_imul(i5, i7) | 0) + i2) | 0;
    i11 = HEAP32[i12 >> 2] | 0;
    i10 = HEAP32[i1 + (i5 << 3) + 4 >> 2] | 0;
    i14 = i9;
    i13 = HEAP32[i14 + 4 >> 2] | 0;
    HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i12 + 4 >> 2] = i13;
    HEAP32[i9 >> 2] = i11;
    HEAP32[i9 + 4 >> 2] = i10;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
  }
 } while ((i4 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 8 | 0;
 i11 = i8 + 4 | 0;
 i10 = i8;
 __ZNKSt3__18ios_base6getlocEv(i11, i4);
 i4 = __ZNKSt3__16locale9use_facetERNS0_2idE(i11, 960720) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i11 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE(i7, i5 + 16 | 0, i1, i9, i3, i4);
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 STACKTOP = i8;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 8 | 0;
 i11 = i8 + 4 | 0;
 i10 = i8;
 __ZNKSt3__18ios_base6getlocEv(i11, i4);
 i4 = __ZNKSt3__16locale9use_facetERNS0_2idE(i11, 960720) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i11 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE(i7, i5 + 24 | 0, i1, i9, i3, i4);
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 STACKTOP = i8;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 8 | 0;
 i11 = i8 + 4 | 0;
 i10 = i8;
 __ZNKSt3__18ios_base6getlocEv(i11, i4);
 i4 = __ZNKSt3__16locale9use_facetERNS0_2idE(i11, 960728) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i11 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE(i7, i5 + 16 | 0, i1, i9, i3, i4);
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 STACKTOP = i8;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 8 | 0;
 i11 = i8 + 4 | 0;
 i10 = i8;
 __ZNKSt3__18ios_base6getlocEv(i11, i4);
 i4 = __ZNKSt3__16locale9use_facetERNS0_2idE(i11, 960728) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i11 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE(i7, i5 + 24 | 0, i1, i9, i3, i4);
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 STACKTOP = i8;
 return;
}

function _cvGetSeqElem(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i3 = HEAP32[i4 + 24 >> 2] | 0;
 if (i3 >>> 0 <= i1 >>> 0) {
  i1 = ((i1 | 0) < 0 ? i3 : 0) + i1 | 0;
  i1 = i1 - ((i1 | 0) >= (i3 | 0) ? i3 : 0) | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   STACKTOP = i5;
   return i1 | 0;
  }
 }
 i2 = HEAP32[i4 + 52 >> 2] | 0;
 if ((i1 << 1 | 0) <= (i3 | 0)) {
  i3 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) >= (i3 | 0)) do {
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i1 = i1 - i3 | 0;
   i3 = HEAP32[i2 + 12 >> 2] | 0;
  } while ((i1 | 0) >= (i3 | 0));
 } else {
  do {
   i2 = HEAP32[i2 >> 2] | 0;
   i3 = i3 - (HEAP32[i2 + 12 >> 2] | 0) | 0;
  } while ((i1 | 0) < (i3 | 0));
  i1 = i1 - i3 | 0;
 }
 i1 = (HEAP32[i2 + 16 >> 2] | 0) + (Math_imul(HEAP32[i4 + 28 >> 2] | 0, i1) | 0) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNK7testing8internal11ValueArray4IiiiiEcvNS0_14ParamGeneratorIT_EEIN4perf7MatTypeEEEv(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i4 = __Znwj(16) | 0;
 HEAP32[i4 >> 2] = 944;
 i2 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i4 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 i11 = i4 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i1 = __Znwj(16) | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 i2 = i1 + 16 | 0;
 HEAP32[i11 >> 2] = i2;
 if (i1) HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i1 + 8 >> 2] = i8;
 HEAP32[i1 + 12 >> 2] = i3;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i9 >> 2] = i4;
 i9 = i9 + 4 | 0;
 HEAP32[i9 >> 2] = i9;
 STACKTOP = i10;
 return;
}

function __ZN4perf8TestBaseD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 174008;
 i1 = HEAP32[i4 + 36 >> 2] | 0;
 if (i1) {
  i3 = i4 + 40 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i2 + (~((i2 + -8 - i1 | 0) >>> 3) << 3);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1) {
  i2 = i4 + 24 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i1);
 }
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i3) {
  __ZN7testing4TestD2Ev(i4);
  STACKTOP = i5;
  return;
 }
 i2 = i4 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) HEAP32[i2 >> 2] = i1 + (~(((i1 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0);
 __ZdlPv(i3);
 __ZN7testing4TestD2Ev(i4);
 STACKTOP = i5;
 return;
}

function __ZNK2cv4cuda7CudaMem18createGpuMatHeaderEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i1, 44) | 0) + 0 | 0;
 i4 = 6624 | 0;
 i5 = i2 + 44 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i2 | 0) < (i5 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-216, i1, 6672, 6688, 87);
 __ZN2cv6String10deallocateEv(i1);
 i1 = __ZN2cv4cuda6GpuMat16defaultAllocatorEv() | 0;
 HEAP32[i6 + 0 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 HEAP32[i6 + 32 >> 2] = i1;
 STACKTOP = i3;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE(i5, i6, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 4 | 0;
 i9 = i7;
 i5 = i5 + 8 | 0;
 i5 = FUNCTION_TABLE_ii[HEAP32[HEAP32[i5 >> 2] >> 2] & 127](i5) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
 i1 = (__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i1, i8, i5, i5 + 168 | 0, i2, i4, 0) | 0) - i5 | 0;
 if ((i1 | 0) >= 168) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i6 >> 2] = ((i1 | 0) / 12 | 0 | 0) % 7 | 0;
 STACKTOP = i7;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE(i5, i6, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i7 + 4 | 0;
 i9 = i7;
 i5 = i5 + 8 | 0;
 i5 = FUNCTION_TABLE_ii[HEAP32[HEAP32[i5 >> 2] >> 2] & 127](i5) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 0 >> 2] = HEAP32[i9 + 0 >> 2];
 i1 = (__ZNSt3__114__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i1, i8, i5, i5 + 168 | 0, i2, i4, 0) | 0) - i5 | 0;
 if ((i1 | 0) >= 168) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i6 >> 2] = ((i1 | 0) / 12 | 0 | 0) % 7 | 0;
 STACKTOP = i7;
 return;
}

function __ZN4perf8TestBase5SetUpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 i3 = 173416;
 i5 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = __ZN2cv6theRNGEv() | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP8[i1 + 176 >> 0] = 0;
 i5 = i1 + 48 | 0;
 HEAP32[i5 + 0 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 1;
 HEAP32[i1 + 76 >> 2] = HEAP32[42408];
 HEAP32[i1 + 80 >> 2] = -1;
 i5 = 169624;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = i1 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i1 >> 2] = i2 + (~((i2 + -8 - i3 | 0) >>> 3) << 3);
 STACKTOP = i4;
 return;
}

function __ZN2cvL9cvt32f16sEPKfjPKhjPsjNS_5Size_IiEEPd(i8, i5, i1, i2, i10, i6, i4, i3) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i7 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i5 >>> 2;
 i1 = i6 >>> 1;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i7 = (i11 | 0) > 0;
 i6 = i8;
 i2 = i10;
 while (1) {
  i4 = i4 + -1 | 0;
  if (i7) {
   i5 = 0;
   do {
    i3 = _lrint(+Math_fround(HEAPF32[i6 + (i5 << 2) >> 2])) | 0;
    if ((i3 + 32768 | 0) >>> 0 >= 65536) i3 = (i3 | 0) > 0 ? 32767 : -32768;
    HEAP16[i2 + (i5 << 1) >> 1] = i3;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i11 | 0));
  }
  if (!i4) break; else {
   i6 = i6 + (i9 << 2) | 0;
   i2 = i2 + (i1 << 1) | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 8 | 0;
 i11 = i8 + 4 | 0;
 i10 = i8;
 __ZNKSt3__18ios_base6getlocEv(i11, i4);
 i4 = __ZNKSt3__16locale9use_facetERNS0_2idE(i11, 960720) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i11 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE(i7, i5 + 20 | 0, i1, i9, i3, i4);
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 STACKTOP = i8;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 8 | 0;
 i11 = i8 + 4 | 0;
 i10 = i8;
 __ZNKSt3__18ios_base6getlocEv(i11, i4);
 i4 = __ZNKSt3__16locale9use_facetERNS0_2idE(i11, 960728) | 0;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i11 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i10 + 0 >> 2];
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE(i7, i5 + 20 | 0, i1, i9, i3, i4);
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 STACKTOP = i8;
 return;
}

function __ZN2cv9Algorithm7_createERKNS_6StringE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = 0;
 if ((HEAP8[39576] | 0) == 0 ? (___cxa_guard_acquire(39576) | 0) != 0 : 0) {
  HEAP32[9890] = 0;
  HEAP32[9891] = 0;
  HEAP32[9892] = 0;
  ___cxa_atexit(352, 39560, ___dso_handle | 0) | 0;
  ___cxa_guard_release(39576);
 }
 if (!(__ZNK2cv13sorted_vectorINS_6StringEPFPNS_9AlgorithmEvEE4findERKS1_RS5_(39560, i1, i2) | 0)) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  STACKTOP = i4;
  return;
 }
 i2 = FUNCTION_TABLE_i[HEAP32[i2 >> 2] & 1]() | 0;
 if (!i2) i1 = 0; else {
  i1 = __Znwj(16) | 0;
  HEAP32[i1 + 4 >> 2] = 1;
  HEAP32[i1 >> 2] = 38728;
  HEAP32[i1 + 8 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __ZNSt3__113__vector_baseIN2cv23CommandLineParserParamsENS_9allocatorIS2_EEED2Ev(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i3 = i9 + 4 | 0;
 while (1) {
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) == (i1 | 0)) break;
  i5 = i4 + -32 | 0;
  HEAP32[i3 >> 2] = i5;
  i6 = i4 + -16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if (i7) {
   i8 = i4 + -12 | 0;
   while (1) {
    i2 = HEAP32[i8 >> 2] | 0;
    if ((i2 | 0) == (i7 | 0)) break;
    i2 = i2 + -8 | 0;
    HEAP32[i8 >> 2] = i2;
    __ZN2cv6String10deallocateEv(i2);
   }
   __ZdlPv(HEAP32[i6 >> 2] | 0);
  }
  __ZN2cv6String10deallocateEv(i4 + -24 | 0);
  __ZN2cv6String10deallocateEv(i5);
 }
 __ZdlPv(HEAP32[i9 >> 2] | 0);
 STACKTOP = i10;
 return;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE9do_lengthERS1_PKcS5_j(i2, i10, i1, i8, i9) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 if ((i9 | 0) == 0 | (i1 | 0) == (i8 | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i7 = i8;
 i6 = i2 + 8 | 0;
 i4 = i1;
 i1 = 0;
 i5 = 0;
 while (1) {
  i3 = _uselocale(HEAP32[i6 >> 2] | 0) | 0;
  i2 = _mbrlen(i4, i7 - i4 | 0, i10) | 0;
  if (i3) _uselocale(i3 | 0) | 0;
  if (!i2) {
   i4 = i4 + 1 | 0;
   i2 = 1;
  } else if ((i2 | 0) == -2 | (i2 | 0) == -1) {
   i2 = 9;
   break;
  } else i4 = i4 + i2 | 0;
  i1 = i2 + i1 | 0;
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= i9 >>> 0 | (i4 | 0) == (i8 | 0)) {
   i2 = 9;
   break;
  }
 }
 if ((i2 | 0) == 9) {
  STACKTOP = i11;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i7, i4, i3) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 i2 = HEAP8[i7 >> 0] | 0;
 i1 = (i2 & 1) == 0;
 if (i1) i6 = (i2 & 255) >>> 1; else i6 = HEAP32[i7 + 4 >> 2] | 0;
 if (i6 >>> 0 < i4 >>> 0) __ZNKSt3__121__basic_string_commonILb1EE20__throw_out_of_rangeEv(i7);
 if (!i3) {
  STACKTOP = i8;
  return i7 | 0;
 }
 if (i1) i5 = i7 + 1 | 0; else i5 = HEAP32[i7 + 8 >> 2] | 0;
 i1 = i6 - i4 | 0;
 i3 = i1 >>> 0 < i3 >>> 0 ? i1 : i3;
 if ((i1 | 0) != (i3 | 0)) {
  _memmove(i5 + i4 | 0, i5 + (i3 + i4) | 0, i1 - i3 | 0) | 0;
  i2 = HEAP8[i7 >> 0] | 0;
 }
 i1 = i6 - i3 | 0;
 if (!(i2 & 1)) HEAP8[i7 >> 0] = i1 << 1; else HEAP32[i7 + 4 >> 2] = i1;
 HEAP8[i5 + i1 >> 0] = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__119__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i7, i9, i8) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 i5 = i7 + 4 | 0;
 i3 = (HEAP32[i5 >> 2] | 0) != 384;
 i2 = HEAP32[i7 >> 2] | 0;
 i6 = i2;
 i4 = (HEAP32[i8 >> 2] | 0) - i6 | 0;
 i4 = i4 >>> 0 < 2147483647 ? i4 << 1 : -1;
 i6 = (HEAP32[i9 >> 2] | 0) - i6 >> 2;
 if (!i3) i2 = 0;
 i1 = _realloc(i2, i4) | 0;
 if (!i1) __ZSt17__throw_bad_allocv();
 if (!i3) {
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  if (i2) {
   FUNCTION_TABLE_vi[HEAP32[i5 >> 2] & 511](i2);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 } else HEAP32[i7 >> 2] = i1;
 HEAP32[i5 >> 2] = 395;
 HEAP32[i9 >> 2] = i1 + (i6 << 2);
 HEAP32[i8 >> 2] = (HEAP32[i7 >> 2] | 0) + (i4 >>> 2 << 2);
 STACKTOP = i10;
 return;
}

function __ZNSt3__119__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i7, i9, i8) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 i5 = i7 + 4 | 0;
 i3 = (HEAP32[i5 >> 2] | 0) != 384;
 i2 = HEAP32[i7 >> 2] | 0;
 i6 = i2;
 i4 = (HEAP32[i8 >> 2] | 0) - i6 | 0;
 i4 = i4 >>> 0 < 2147483647 ? i4 << 1 : -1;
 i6 = (HEAP32[i9 >> 2] | 0) - i6 >> 2;
 if (!i3) i2 = 0;
 i1 = _realloc(i2, i4) | 0;
 if (!i1) __ZSt17__throw_bad_allocv();
 if (!i3) {
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  if (i2) {
   FUNCTION_TABLE_vi[HEAP32[i5 >> 2] & 511](i2);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 } else HEAP32[i7 >> 2] = i1;
 HEAP32[i5 >> 2] = 395;
 HEAP32[i9 >> 2] = i1 + (i6 << 2);
 HEAP32[i8 >> 2] = (HEAP32[i7 >> 2] | 0) + (i4 >>> 2 << 2);
 STACKTOP = i10;
 return;
}

function __ZN2cv11FileStorageD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 HEAP32[i5 >> 2] = 11304;
 i3 = i5 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i5 + 20 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  if (i1) i2 = 5;
 } else {
  i2 = i5 + 8 | 0;
  do {
   _cvEndWriteStruct(HEAP32[i2 >> 2] | 0);
   i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
   HEAP32[i3 >> 2] = i1;
  } while ((i1 | 0) != (HEAP32[i4 >> 2] | 0));
  i2 = 5;
 }
 if ((i2 | 0) == 5) __ZdlPv(i1);
 __ZN2cv6String10deallocateEv(i5 + 12 | 0);
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i4 = i2 + 4 | 0, i3 = HEAP32[i4 >> 2] | 0, HEAP32[i4 >> 2] = i3 + -1, (i3 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] & 511](i2);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i5, i6, i3, i7, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i9 = 0;
 i9 = STACKTOP;
 i1 = HEAP8[i5 >> 0] | 0;
 i4 = (i1 & 1) == 0;
 if (i4) i2 = (i1 & 255) >>> 1; else i2 = HEAP32[i5 + 4 >> 2] | 0;
 if (i2 >>> 0 < i6 >>> 0 | (i8 | 0) == -1) __ZNKSt3__121__basic_string_commonILb1EE20__throw_out_of_rangeEv(i5);
 i1 = i2 - i6 | 0;
 i3 = i1 >>> 0 < i3 >>> 0 ? i1 : i3;
 if (i4) i1 = i5 + 1 | 0; else i1 = HEAP32[i5 + 8 >> 2] | 0;
 i2 = i3 >>> 0 > i8 >>> 0;
 i1 = _memcmp(i1 + i6 | 0, i7, i2 ? i8 : i3) | 0;
 if (i1) {
  STACKTOP = i9;
  return i1 | 0;
 }
 if (i3 >>> 0 < i8 >>> 0) {
  i1 = -1;
  STACKTOP = i9;
  return i1 | 0;
 } else {
  STACKTOP = i9;
  return i2 & 1 | 0;
 }
 return 0;
}

function __GLOBAL__I_a1556() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i2;
 if (HEAP8[183128] | 0) {
  HEAP32[45462] = 183120;
  STACKTOP = i2;
  return;
 }
 if (!(___cxa_guard_acquire(183128) | 0)) {
  HEAP32[45462] = 183120;
  STACKTOP = i2;
  return;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i3 = __ZN2cv6String8allocateEj(i1, 5) | 0;
 HEAP8[i3 + 0 >> 0] = HEAP8[183136] | 0;
 HEAP8[i3 + 1 >> 0] = HEAP8[183137] | 0;
 HEAP8[i3 + 2 >> 0] = HEAP8[183138] | 0;
 HEAP8[i3 + 3 >> 0] = HEAP8[183139] | 0;
 HEAP8[i3 + 4 >> 0] = HEAP8[183140] | 0;
 __ZN2cv13AlgorithmInfoC2ERKNS_6StringEPFPNS_9AlgorithmEvE(183120, i1, 1);
 __ZN2cv6String10deallocateEv(i1);
 ___cxa_atexit(382, 183120, ___dso_handle | 0) | 0;
 ___cxa_guard_release(183128);
 HEAP32[45462] = 183120;
 STACKTOP = i2;
 return;
}

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 i5 = HEAP32[i2 >> 2] | 0;
 i7 = i2 + 4 | 0;
 i4 = i1 + 4 | 0;
 i6 = (HEAP32[i7 >> 2] | 0) - i5 | 0;
 i8 = (HEAP32[i4 >> 2] | 0) + (0 - (i6 >> 2) << 2) | 0;
 HEAP32[i4 >> 2] = i8;
 _memcpy(i8 | 0, i5 | 0, i6 | 0) | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i6;
 i6 = i1 + 8 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i5;
 i6 = i2 + 8 | 0;
 i2 = i1 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i5;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN7testing4Test18HasNonfatalFailureEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i1 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i1, 163728);
  HEAP32[40934] = i1;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i1 = HEAP32[40934] | 0;
 i3 = HEAP32[i1 + 108 >> 2] | 0;
 i3 = (i3 | 0) == 0 ? i1 + 112 | 0 : i3 + 48 | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i1 = 0;
  STACKTOP = i4;
  return i1 | 0;
 } else i2 = 0;
 do {
  i2 = ((HEAP32[i1 >> 2] | 0) == 1 & 1) + i2 | 0;
  i1 = i1 + 44 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i1 = (i2 | 0) > 0;
 STACKTOP = i4;
 return i1 | 0;
}

function _cvSeqPush(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i6;
 if (!i5) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40224, 39608, 1137);
  __ZN2cv6String10deallocateEv(i1);
 }
 i2 = HEAP32[i5 + 28 >> 2] | 0;
 i3 = i5 + 36 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 >= (HEAP32[i5 + 32 >> 2] | 0) >>> 0) {
  __ZL10icvGrowSeqP5CvSeqi(i5, 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if (i4) _memcpy(i1 | 0, i4 | 0, i2 | 0) | 0;
 i4 = (HEAP32[HEAP32[i5 + 52 >> 2] >> 2] | 0) + 12 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = i5 + 24 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 HEAP32[i3 >> 2] = i1 + i2;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN7testing4Test15HasFatalFailureEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i1 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i1, 163728);
  HEAP32[40934] = i1;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 i1 = HEAP32[40934] | 0;
 i3 = HEAP32[i1 + 108 >> 2] | 0;
 i3 = (i3 | 0) == 0 ? i1 + 112 | 0 : i3 + 48 | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i1 = 0;
  STACKTOP = i4;
  return i1 | 0;
 } else i2 = 0;
 do {
  i2 = ((HEAP32[i1 >> 2] | 0) == 2 & 1) + i2 | 0;
  i1 = i1 + 44 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i1 = (i2 | 0) > 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN7testing8internal27CheckedDowncastToActualTypeINS0_25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notEENS0_29ParameterizedTestCaseInfoBaseEEEPT_PT0_(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i3;
 if (!i2) ___cxa_bad_typeid();
 if (__ZN7testing8internal6IsTrueEb((HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + -4 >> 2] | 0) + 4 >> 2] | 0) == 2440) | 0) {
  i1 = ___dynamic_cast(i2, 2576, 2584, 0) | 0;
  STACKTOP = i3;
  return i1 | 0;
 }
 __ZN7testing8internal8GTestLogC2ENS0_16GTestLogSeverityEPKci(i1, 3, 696, 2305);
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(956240, 1472, 51) | 0;
 __ZN7testing8internal8GTestLogD2Ev(i1);
 i1 = ___dynamic_cast(i2, 2576, 2584, 0) | 0;
 STACKTOP = i3;
 return i1 | 0;
}

function _cvGetSeqReaderPos(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i4;
 if (!((i3 | 0) != 0 ? (HEAP32[i3 + 12 >> 2] | 0) != 0 : 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40176, 39608, 1019);
  __ZN2cv6String10deallocateEv(i1);
 }
 i1 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 28 >> 2] | 0;
 if ((i1 | 0) < 33 ? (i2 = i1 + -1 | 0, (-2147450741 >>> i2 & 1 | 0) != 0) : 0) i1 = (HEAP32[i3 + 12 >> 2] | 0) - (HEAP32[i3 + 16 >> 2] | 0) >> HEAP8[40088 + i2 >> 0]; else i1 = ((HEAP32[i3 + 12 >> 2] | 0) - (HEAP32[i3 + 16 >> 2] | 0) | 0) / (i1 | 0) | 0;
 STACKTOP = i4;
 return (HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 8 >> 2] | 0) + i1 - (HEAP32[i3 + 24 >> 2] | 0) | 0;
}

function __ZNKSt3__110__time_put8__do_putEPwRS1_PK2tmcc(i4, i5, i6, i3, i2, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i10 = i7 + 16 | 0;
 i11 = i7 + 12 | 0;
 i8 = i7;
 i9 = i7 + 8 | 0;
 HEAP32[i11 >> 2] = i10 + 100;
 __ZNKSt3__110__time_put8__do_putEPcRS1_PK2tmcc(i4, i10, i11, i3, i2, i1);
 i2 = i8;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = i10;
 i2 = (HEAP32[i6 >> 2] | 0) - i5 >> 2;
 i1 = _uselocale(HEAP32[i4 >> 2] | 0) | 0;
 i2 = _mbsrtowcs(i5, i9, i2, i8) | 0;
 if (i1) _uselocale(i1 | 0) | 0;
 if ((i2 | 0) == -1) __ZNSt3__121__throw_runtime_errorEPKc(961608); else {
  HEAP32[i6 >> 2] = i5 + (i2 << 2);
  STACKTOP = i7;
  return;
 }
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi(i7, i2, i6) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) <= 0) {
  i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 }
 i4 = i7 + 24 | 0;
 i5 = i7 + 28 | 0;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
   if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2] & 127](i7, HEAP32[i2 >> 2] | 0) | 0) == -1) {
    i2 = 7;
    break;
   }
  } else {
   i9 = HEAP32[i2 >> 2] | 0;
   HEAP32[i4 >> 2] = i3 + 4;
   HEAP32[i3 >> 2] = i9;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) < (i6 | 0)) i2 = i2 + 4 | 0; else {
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) {
  STACKTOP = i8;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci(i7, i2, i6) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) <= 0) {
  i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 }
 i4 = i7 + 12 | 0;
 i5 = i7 + 16 | 0;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   HEAP32[i4 >> 2] = i3 + 1;
   i3 = HEAP8[i3 >> 0] | 0;
  } else {
   i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] & 127](i7) | 0;
   if ((i3 | 0) == -1) {
    i2 = 8;
    break;
   }
   i3 = i3 & 255;
  }
  HEAP8[i2 >> 0] = i3;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) < (i6 | 0)) i2 = i2 + 1 | 0; else {
   i2 = 8;
   break;
  }
 }
 if ((i2 | 0) == 8) {
  STACKTOP = i8;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci(i7, i2, i6) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) <= 0) {
  i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 }
 i4 = i7 + 24 | 0;
 i5 = i7 + 28 | 0;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
   if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2] & 127](i7, HEAPU8[i2 >> 0] | 0) | 0) == -1) {
    i2 = 7;
    break;
   }
  } else {
   i9 = HEAP8[i2 >> 0] | 0;
   HEAP32[i4 >> 2] = i3 + 1;
   HEAP8[i3 >> 0] = i9;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) < (i6 | 0)) i2 = i2 + 1 | 0; else {
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) {
  STACKTOP = i8;
  return i1 | 0;
 }
 return 0;
}

function __ZNKSt3__120__time_get_c_storageIwE7__am_pmEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = STACKTOP;
 if (HEAP8[961120] | 0) {
  i2 = HEAP32[240278] | 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 if (!(___cxa_guard_acquire(961120) | 0)) {
  i2 = HEAP32[240278] | 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 if ((HEAP8[965832] | 0) == 0 ? (___cxa_guard_acquire(965832) | 0) != 0 : 0) {
  _memset(965544, 0, 288) | 0;
  ___cxa_atexit(392, 0, ___dso_handle | 0) | 0;
  ___cxa_guard_release(965832);
 }
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(965544, 965840) | 0;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(965556, 965856) | 0;
 HEAP32[240278] = 965544;
 ___cxa_guard_release(961120);
 i2 = HEAP32[240278] | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZNKSt3__120__time_get_c_storageIcE7__am_pmEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = STACKTOP;
 if (HEAP8[961104] | 0) {
  i2 = HEAP32[240274] | 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 if (!(___cxa_guard_acquire(961104) | 0)) {
  i2 = HEAP32[240274] | 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 if ((HEAP8[966160] | 0) == 0 ? (___cxa_guard_acquire(966160) | 0) != 0 : 0) {
  _memset(965872, 0, 288) | 0;
  ___cxa_atexit(391, 0, ___dso_handle | 0) | 0;
  ___cxa_guard_release(966160);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(965872, 966168) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(965884, 966176) | 0;
 HEAP32[240274] = 965872;
 ___cxa_guard_release(961104);
 i2 = HEAP32[240274] | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZNSt3__119__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i6, i8, i7) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 i4 = i6 + 4 | 0;
 i2 = (HEAP32[i4 >> 2] | 0) != 384;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = i1;
 i3 = (HEAP32[i7 >> 2] | 0) - i5 | 0;
 i3 = i3 >>> 0 < 2147483647 ? i3 << 1 : -1;
 i5 = (HEAP32[i8 >> 2] | 0) - i5 | 0;
 i1 = _realloc(i2 ? i1 : 0, i3) | 0;
 if (!i1) __ZSt17__throw_bad_allocv();
 if (!i2) {
  i2 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  if (i2) {
   FUNCTION_TABLE_vi[HEAP32[i4 >> 2] & 511](i2);
   i1 = HEAP32[i6 >> 2] | 0;
  }
 } else HEAP32[i6 >> 2] = i1;
 HEAP32[i4 >> 2] = 395;
 HEAP32[i8 >> 2] = i1 + i5;
 HEAP32[i7 >> 2] = (HEAP32[i6 >> 2] | 0) + i3;
 STACKTOP = i9;
 return;
}

function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i3;
 if (!(HEAP32[i2 + ((HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0)) {
  STACKTOP = i3;
  return i2 | 0;
 }
 __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_(i1, i2);
 if ((HEAP8[i1 >> 0] | 0) != 0 ? (i4 = HEAP32[i2 + ((HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0, (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] & 127](i4) | 0) == -1) : 0) {
  i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0;
  __ZNSt3__18ios_base5clearEj(i2 + i4 | 0, HEAP32[i2 + (i4 + 16) >> 2] | 1);
 }
 __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i1);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i3;
 if (!(HEAP32[i2 + ((HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0)) {
  STACKTOP = i3;
  return i2 | 0;
 }
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i1, i2);
 if ((HEAP8[i1 >> 0] | 0) != 0 ? (i4 = HEAP32[i2 + ((HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0, (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] & 127](i4) | 0) == -1) : 0) {
  i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0;
  __ZNSt3__18ios_base5clearEj(i2 + i4 | 0, HEAP32[i2 + (i4 + 16) >> 2] | 1);
 }
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i1);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZNK7testing8internal8FilePath19RemoveDirectoryNameEv(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5;
 if (!(HEAP8[i4 >> 0] & 1)) i1 = i4 + 1 | 0; else i1 = HEAP32[i4 + 8 >> 2] | 0;
 i1 = _strrchr(i1, 47) | 0;
 if (!i1) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i3, i4);
  STACKTOP = i5;
  return;
 } else {
  i1 = i1 + 1 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i1, _strlen(i1 | 0) | 0);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i3, i2);
  __ZN7testing8internal8FilePath9NormalizeEv(i3);
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
  STACKTOP = i5;
  return;
 }
}

function _cvCreateSet(i5, i4, i3, i6) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i7 + 8 | 0;
 i2 = i7;
 if (!i6) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40496, 39608, 2482);
  __ZN2cv6String10deallocateEv(i1);
 }
 if (!((i3 | 0) > 7 & (i4 | 0) > 63 & (i3 & 3 | 0) == 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i2, 40496, 39608, 2486);
  __ZN2cv6String10deallocateEv(i2);
 }
 i1 = _cvCreateSeq(i5, i4, i3, i6) | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 65535 | 1117257728;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNK2cv10MatOp_GEMM9transposeERKNS_7MatExprERS1_(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 i3 = i7;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i8 + 8 | 0;
 __ZN2cv3MataSERKS0_(i1, i7 + 8 | 0) | 0;
 i2 = i8 + 64 | 0;
 __ZN2cv3MataSERKS0_(i2, i7 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i8 + 120 | 0, i7 + 120 | 0) | 0;
 i3 = i8 + 176 | 0;
 i5 = i7 + 176 | 0;
 i6 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  i3 = i3 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i3 | 0) < (i6 | 0));
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i8 + 4 >> 2] = (i3 << 1 & 2 | i3 & 4 | i3 >>> 1 & 1) ^ 7;
 __ZN2cv4swapERNS_3MatES1_(i1, i2);
 STACKTOP = i4;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi(i7, i2, i6) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) <= 0) {
  i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 }
 i4 = i7 + 12 | 0;
 i5 = i7 + 16 | 0;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
   i3 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] & 127](i7) | 0;
   if ((i3 | 0) == -1) {
    i2 = 7;
    break;
   }
  } else {
   HEAP32[i4 >> 2] = i3 + 4;
   i3 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = i3;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) < (i6 | 0)) i2 = i2 + 4 | 0; else {
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) {
  STACKTOP = i8;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__115__num_get_floatIfEET_PKcS3_Rj(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var d2 = 0.0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, f9 = Math_fround(0);
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i8;
 if ((i1 | 0) == (i5 | 0)) {
  HEAP32[i6 >> 2] = 4;
  f9 = Math_fround(0.0);
  STACKTOP = i8;
  return Math_fround(f9);
 }
 i3 = ___errno_location() | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 d2 = +_strtold_l(i1, i7, __ZNSt3__16__clocEv() | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = i4;
 if ((HEAP32[i7 >> 2] | 0) != (i5 | 0)) {
  HEAP32[i6 >> 2] = 4;
  f9 = Math_fround(0.0);
  STACKTOP = i8;
  return Math_fround(f9);
 }
 if ((i1 | 0) == 34) HEAP32[i6 >> 2] = 4;
 f9 = Math_fround(d2);
 STACKTOP = i8;
 return Math_fround(f9);
}

function __ZN2cv3MatD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i3 = i2 + 12 | 0, i2 = HEAP32[i3 >> 2] | 0, HEAP32[i3 >> 2] = i2 + -1, (i2 | 0) == 1) : 0) __ZN2cv3Mat10deallocateEv(i4);
 HEAP32[i1 >> 2] = 0;
 i2 = i4 + 16 | 0;
 i1 = i4 + 4 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 if ((HEAP32[i1 >> 2] | 0) > 0) {
  i2 = HEAP32[i4 + 40 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i2 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i1 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 44 >> 2] | 0;
 if ((i1 | 0) == (i4 + 48 | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i5;
 return;
}

function __ZN7testing8TestInfoD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 i1 = HEAP32[i3 + 40 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 __ZN7testing10TestResultD2Ev(i3 + 48 | 0);
 i2 = i3 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1);
  __ZdlPv(i1);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i3 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
  __ZdlPv(i2);
  HEAP32[i1 >> 2] = 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3 + 12 | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
 STACKTOP = i4;
 return;
}

function __ZNK2cv12_OutputArray15getOGlBufferRefEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i4;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2) | 0) == 458752) {
  i1 = i2 + 8 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  STACKTOP = i4;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i3 = (__ZN2cv6String8allocateEj(i1, 18) | 0) + 0 | 0;
 i5 = 29160 | 0;
 i6 = i3 + 18 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i5 = i5 + 1 | 0;
 } while ((i3 | 0) < (i6 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 31280, 27528, 2593);
 __ZN2cv6String10deallocateEv(i1);
 i1 = i2 + 8 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNK7testing10TestResult6FailedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 i4 = i2 + 8 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = (HEAP32[i4 >> 2] | 0) - i1 | 0;
 if ((i3 | 0) <= 0) {
  i1 = 0;
  STACKTOP = i6;
  return i1 | 0;
 }
 i5 = i2 + 4 | 0;
 i2 = (i3 | 0) / 44 | 0;
 i3 = 0;
 while (1) {
  if (i2 >>> 0 <= i3 >>> 0) {
   i2 = 5;
   break;
  }
  if (HEAP32[i1 + (i3 * 44 | 0) >> 2] | 0) {
   i1 = 1;
   i2 = 7;
   break;
  }
  i3 = i3 + 1 | 0;
  i2 = ((HEAP32[i4 >> 2] | 0) - i1 | 0) / 44 | 0;
  if ((i3 | 0) >= (i2 | 0)) {
   i1 = 0;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 5) __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i5); else if ((i2 | 0) == 7) {
  STACKTOP = i6;
  return i1 | 0;
 }
 return 0;
}

function __ZNK2cv12_OutputArray13getCudaMemRefEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i4;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2) | 0) == 524288) {
  i1 = i2 + 8 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  STACKTOP = i4;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i3 = (__ZN2cv6String8allocateEj(i1, 13) | 0) + 0 | 0;
 i5 = 29232 | 0;
 i6 = i3 + 13 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i5 = i5 + 1 | 0;
 } while ((i3 | 0) < (i6 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 31296, 27528, 2600);
 __ZN2cv6String10deallocateEv(i1);
 i1 = i2 + 8 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNK2cv12_OutputArray12getGpuMatRefEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i4;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2) | 0) == 589824) {
  i1 = i2 + 8 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  STACKTOP = i4;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i3 = (__ZN2cv6String8allocateEj(i1, 12) | 0) + 0 | 0;
 i5 = 31248 | 0;
 i6 = i3 + 12 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i5 = i5 + 1 | 0;
 } while ((i3 | 0) < (i6 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 31264, 27528, 2586);
 __ZN2cv6String10deallocateEv(i1);
 i1 = i2 + 8 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 STACKTOP = i4;
 return i1 | 0;
}

function _strcasecmp(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 i2 = HEAP8[i3 >> 0] | 0;
 L1 : do if (!(i2 << 24 >> 24)) i2 = 0; else {
  i5 = i2;
  i4 = i2 & 255;
  while (1) {
   i2 = HEAP8[i1 >> 0] | 0;
   if (!(i2 << 24 >> 24)) {
    i2 = i5;
    break L1;
   }
   if (i5 << 24 >> 24 != i2 << 24 >> 24 ? (i2 = _tolower(i4) | 0, (i2 | 0) != (_tolower(HEAPU8[i1 >> 0] | 0) | 0)) : 0) break;
   i3 = i3 + 1 | 0;
   i1 = i1 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) {
    i2 = 0;
    break L1;
   } else {
    i5 = i2;
    i4 = i2 & 255;
   }
  }
  i2 = HEAP8[i3 >> 0] | 0;
 } while (0);
 i2 = _tolower(i2 & 255) | 0;
 i1 = i2 - (_tolower(HEAPU8[i1 >> 0] | 0) | 0) | 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN4perf8TestBase19RecordRunParametersEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i3 = i1 + 12 | 0;
 i2 = i1;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, 173856, 17);
 __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i3, 169664);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, 173880, 14);
 __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEi(i2, HEAP32[43396] | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 STACKTOP = i1;
 return;
}

function __ZNK2cv10MatOp_GEMM8multiplyERKNS_7MatExprEdRS1_(i1, i2, d7, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d7 = +d7;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 i1 = i2;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __ZN2cv3MataSERKS0_(i6 + 8 | 0, i2 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i6 + 64 | 0, i2 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i6 + 120 | 0, i2 + 120 | 0) | 0;
 i3 = i6 + 176 | 0;
 i4 = i3 + 0 | 0;
 i2 = i2 + 176 | 0;
 i1 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i1 | 0));
 HEAPF64[i3 >> 3] = +HEAPF64[i3 >> 3] * d7;
 i1 = i6 + 184 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] * d7;
 STACKTOP = i5;
 return;
}

function __ZN2cv16BaseImageDecoder9setSourceERKNS_3MatE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i7;
 if (!(HEAP8[i6 + 88 >> 0] | 0)) {
  i1 = 0;
  STACKTOP = i7;
  return i1 | 0;
 }
 i3 = i6 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 if ((i2 | 0) != (i3 | 0)) {
  __ZN2cv6String10deallocateEv(i3);
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i1 = i1 + -4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i1;
  HEAP32[i6 + 20 >> 2] = HEAP32[i4 >> 2];
 }
 __ZN2cv6String10deallocateEv(i2);
 __ZN2cv3MataSERKS0_(i6 + 32 | 0, i5) | 0;
 i1 = 1;
 STACKTOP = i7;
 return i1 | 0;
}

function _frexp(d1, i5) {
 d1 = +d1;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr >> 2] | 0;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = _bitshift64Lshr(i2 | 0, i3 | 0, 52) | 0;
 i4 = i4 & 2047;
 if (!i4) {
  if (d1 != 0.0) {
   d1 = +_frexp(d1 * 18446744073709551616.0, i5);
   i2 = (HEAP32[i5 >> 2] | 0) + -64 | 0;
  } else i2 = 0;
  HEAP32[i5 >> 2] = i2;
  STACKTOP = i6;
  return +d1;
 } else if ((i4 | 0) == 2047) {
  STACKTOP = i6;
  return +d1;
 } else {
  HEAP32[i5 >> 2] = i4 + -1022;
  HEAP32[tempDoublePtr >> 2] = i2;
  HEAP32[tempDoublePtr + 4 >> 2] = i3 & -2146435073 | 1071644672;
  d1 = +HEAPF64[tempDoublePtr >> 3];
  STACKTOP = i6;
  return +d1;
 }
 return 0.0;
}

function __ZN2cv3MatC2EiPKiiPvPKj(i10, i6, i7, i9, i5, i8) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 i1 = i10 + 8 | 0;
 i2 = i10 + 16 | 0;
 i3 = i10 + 20 | 0;
 i4 = i10 + 40 | 0;
 i11 = i10 + 4 | 0;
 i13 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i13 | 0));
 HEAP32[i4 >> 2] = i1;
 i4 = i10 + 48 | 0;
 HEAP32[i10 + 44 >> 2] = i4;
 HEAP32[i10 + 52 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i10 >> 2] = i9 & 4095 | 1124007936;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i3 >> 2] = i5;
 __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i10, i6, i7, i8, 1);
 __ZN2cvL11finalizeHdrERNS_3MatE(i10);
 STACKTOP = i12;
 return;
}

function _cvCloneSparseMat(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i6;
 if (!((i5 | 0) != 0 ? (i1 = HEAP32[i5 >> 2] | 0, (i1 & -65536 | 0) == 1111752704) : 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i1 = (__ZN2cv6String8allocateEj(i4, 27) | 0) + 0 | 0;
  i2 = 42048 | 0;
  i3 = i1 + 27 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-5, i4, 42080, 40912, 613);
  __ZN2cv6String10deallocateEv(i4);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i1 = _cvCreateSparseMat(HEAP32[i5 + 4 >> 2] | 0, i5 + 36 | 0, i1) | 0;
 _cvCopy(i5, i1, 0);
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i6, i7, i10, i9, i4, i3, i5, 959784, 959816 | 0);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i6, i7, i10, i9, i4, i3, i5, 959632, 959640 | 0);
 STACKTOP = i8;
 return;
}

function _scalbn(d1, i3) {
 d1 = +d1;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 if ((i3 | 0) > 1023) {
  d1 = d1 * 8988465674311579538646525.0e283;
  i2 = i3 + -1023 | 0;
  if ((i2 | 0) > 1023) {
   i2 = i3 + -2046 | 0;
   i2 = (i2 | 0) > 1023 ? 1023 : i2;
   d1 = d1 * 8988465674311579538646525.0e283;
  }
 } else if ((i3 | 0) < -1022) {
  d1 = d1 * 2.2250738585072014e-308;
  i2 = i3 + 1022 | 0;
  if ((i2 | 0) < -1022) {
   i2 = i3 + 2044 | 0;
   i2 = (i2 | 0) < -1022 ? -1022 : i2;
   d1 = d1 * 2.2250738585072014e-308;
  }
 } else i2 = i3;
 i3 = _bitshift64Shl(i2 + 1023 | 0, 0, 52) | 0;
 i2 = tempRet0;
 HEAP32[tempDoublePtr >> 2] = i3;
 HEAP32[tempDoublePtr + 4 >> 2] = i2;
 d1 = d1 * +HEAPF64[tempDoublePtr >> 3];
 STACKTOP = i4;
 return +d1;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i7, i2, i4, i5, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i6 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i6 + 4 | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i5, i3, 4) | 0;
 if (HEAP32[i5 >> 2] & 4) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) < 69) i1 = i1 + 2e3 | 0; else i1 = (i1 + -69 | 0) >>> 0 < 31 ? i1 + 1900 | 0 : i1;
 HEAP32[i7 >> 2] = i1 + -1900;
 STACKTOP = i6;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i7, i2, i4, i5, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i6 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i6 + 4 | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i5, i3, 4) | 0;
 if (HEAP32[i5 >> 2] & 4) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) < 69) i1 = i1 + 2e3 | 0; else i1 = (i1 + -69 | 0) >>> 0 < 31 ? i1 + 1900 | 0 : i1;
 HEAP32[i7 >> 2] = i1 + -1900;
 STACKTOP = i6;
 return;
}

function __ZNSt3__19__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 __ZNKSt3__18ios_base6getlocEv(i6, i2);
 i2 = __ZNKSt3__16locale9use_facetERNS0_2idE(i6, 960720) | 0;
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] & 7](i2, 959240, 959266 | 0, i1) | 0;
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i6, 960880) | 0;
 HEAP32[i3 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 127](i1) | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i4, i1);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i6 >> 2] | 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZNSt3__19__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 __ZNKSt3__18ios_base6getlocEv(i6, i2);
 i2 = __ZNKSt3__16locale9use_facetERNS0_2idE(i6, 960728) | 0;
 FUNCTION_TABLE_iiiii[HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] & 7](i2, 959240, 959266 | 0, i1) | 0;
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i6, 960872) | 0;
 HEAP8[i3 >> 0] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 127](i1) | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] & 127](i4, i1);
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i6 >> 2] | 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIwEE(i2, i7, i1, i4, i6, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i6, i3, 2) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) > 0 & (i1 | 0) < 13) {
  HEAP32[i7 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i6 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIcEE(i2, i7, i1, i4, i6, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i6, i3, 2) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) > 0 & (i1 | 0) < 13) {
  HEAP32[i7 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i6 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function _cvInitTreeNodeIterator(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i6 + 8 | 0;
 i2 = i6;
 if (!((i5 | 0) != 0 & (i3 | 0) != 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40720, 39608, 3438);
  __ZN2cv6String10deallocateEv(i1);
 }
 if ((i4 | 0) < 0) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i2, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i2, 40720, 39608, 3441);
  __ZN2cv6String10deallocateEv(i2);
 }
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = i4;
 STACKTOP = i6;
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5writeEPKci(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i5;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i3, i4);
 if ((HEAP8[i3 >> 0] | 0) != 0 & (i1 | 0) != 0 ? (i6 = HEAP32[i4 + ((HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) + 24) >> 2] | 0, (FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2] & 63](i6, i2, i1) | 0) != (i1 | 0)) : 0) {
  i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0;
  __ZNSt3__18ios_base5clearEj(i4 + i1 | 0, HEAP32[i4 + (i1 + 16) >> 2] | 1);
 }
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i3);
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIwEE(i2, i6, i1, i4, i7, i3) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i7, i3, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) > 0 & (i1 | 0) < 32) {
  HEAP32[i6 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i7 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIcEE(i2, i6, i1, i4, i7, i3) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i7, i3, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) > 0 & (i1 | 0) < 32) {
  HEAP32[i6 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i7 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIwEE(i2, i6, i1, i4, i7, i3) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i7, i3, 3) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) < 366) {
  HEAP32[i6 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i7 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIcEE(i2, i6, i1, i4, i7, i3) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i7, i3, 3) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) < 366) {
  HEAP32[i6 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i7 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl(i6, i7, i1, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i12 = i8 + 4 | 0;
 i11 = i8;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 0 >> 2] = HEAP32[i12 + 0 >> 2];
 HEAP32[i9 + 0 >> 2] = HEAP32[i11 + 0 >> 2];
 __ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_(i6, i7, i10, i9, i4, i3, i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIwEE(i2, i7, i1, i4, i6, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i6, i3, 2) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) < 13) {
  HEAP32[i7 >> 2] = i1 + -1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i6 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIcEE(i2, i7, i1, i4, i6, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i6, i3, 2) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) < 13) {
  HEAP32[i7 >> 2] = i1 + -1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i6 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZN7testing15AssertionResultlsIA12_cEERS0_RKT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5;
 __ZN7testing7MessageC2Ev(i1);
 i6 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i4, _strlen(i4 | 0) | 0) | 0;
 __ZN7testing15AssertionResult13AppendMessageERKNS_7MessageE(i3, i1);
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return i3 | 0;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return i3 | 0;
}

function __ZN7testing8internal24GetCurrentExecutableNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i3 = i2 + 12 | 0;
 i4 = i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, 159968, 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i4, 160456);
 __ZN7testing8internal8FilePath9NormalizeEv(i4);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i4) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4);
 __ZNK7testing8internal8FilePath19RemoveDirectoryNameEv(i1, i3);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZN7testing15AssertionResultlsIA7_cEERS0_RKT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5;
 __ZN7testing7MessageC2Ev(i1);
 i6 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i4, _strlen(i4 | 0) | 0) | 0;
 __ZN7testing15AssertionResult13AppendMessageERKNS_7MessageE(i3, i1);
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return i3 | 0;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return i3 | 0;
}

function __ZN7testing15AssertionResultlsIA6_cEERS0_RKT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5;
 __ZN7testing7MessageC2Ev(i1);
 i6 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i4, _strlen(i4 | 0) | 0) | 0;
 __ZN7testing15AssertionResult13AppendMessageERKNS_7MessageE(i3, i1);
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return i3 | 0;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return i3 | 0;
}

function __ZN7testing15AssertionResultlsIA5_cEERS0_RKT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5;
 __ZN7testing7MessageC2Ev(i1);
 i6 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i4, _strlen(i4 | 0) | 0) | 0;
 __ZN7testing15AssertionResult13AppendMessageERKNS_7MessageE(i3, i1);
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return i3 | 0;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return i3 | 0;
}

function __ZN7testing15AssertionResultlsIA3_cEERS0_RKT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5;
 __ZN7testing7MessageC2Ev(i1);
 i6 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i4, _strlen(i4 | 0) | 0) | 0;
 __ZN7testing15AssertionResult13AppendMessageERKNS_7MessageE(i3, i1);
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return i3 | 0;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return i3 | 0;
}

function __ZN7testing15AssertionResultlsIA2_cEERS0_RKT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5;
 __ZN7testing7MessageC2Ev(i1);
 i6 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i4, _strlen(i4 | 0) | 0) | 0;
 __ZN7testing15AssertionResult13AppendMessageERKNS_7MessageE(i3, i1);
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return i3 | 0;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return i3 | 0;
}

function __ZN2cvL15countNonZero32sEPKii(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 i2 = i4 + -4 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = 0;
  i1 = 0;
  do {
   i1 = ((HEAP32[i5 + (i3 << 2) >> 2] | 0) != 0 & 1) + i1 + ((HEAP32[i5 + ((i3 | 1) << 2) >> 2] | 0) != 0 & 1) + ((HEAP32[i5 + ((i3 | 2) << 2) >> 2] | 0) != 0 & 1) + ((HEAP32[i5 + ((i3 | 3) << 2) >> 2] | 0) != 0 & 1) | 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i2 | 0));
  i2 = i4 & -4;
 }
 if ((i2 | 0) >= (i4 | 0)) {
  STACKTOP = i6;
  return i1 | 0;
 }
 do {
  i1 = ((HEAP32[i5 + (i2 << 2) >> 2] | 0) != 0 & 1) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN2cvL15countNonZero16uEPKti(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 i2 = i4 + -4 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = 0;
  i1 = 0;
  do {
   i1 = ((HEAP16[i5 + (i3 << 1) >> 1] | 0) != 0 & 1) + i1 + ((HEAP16[i5 + ((i3 | 1) << 1) >> 1] | 0) != 0 & 1) + ((HEAP16[i5 + ((i3 | 2) << 1) >> 1] | 0) != 0 & 1) + ((HEAP16[i5 + ((i3 | 3) << 1) >> 1] | 0) != 0 & 1) | 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i2 | 0));
  i2 = i4 & -4;
 }
 if ((i2 | 0) >= (i4 | 0)) {
  STACKTOP = i6;
  return i1 | 0;
 }
 do {
  i1 = ((HEAP16[i5 + (i2 << 1) >> 1] | 0) != 0 & 1) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__16locale5__impD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 HEAP32[i7 >> 2] = 960648;
 i5 = i7 + 8 | 0;
 i6 = i7 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i4 = 0;
  do {
   i3 = HEAP32[i2 + (i4 << 2) >> 2] | 0;
   if (i3) {
    __ZNSt3__114__shared_count16__release_sharedEv(i3) | 0;
    i1 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 - i2 >> 2 >>> 0);
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i7 + 144 | 0);
 __ZNSt3__113__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i5);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIwEE(i2, i7, i1, i4, i6, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i6, i3, 1) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) < 7) {
  HEAP32[i7 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i6 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIwEE(i2, i7, i1, i4, i6, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i6, i3, 2) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) < 61) {
  HEAP32[i7 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i6 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIwEE(i2, i7, i1, i4, i6, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i6, i3, 2) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) < 60) {
  HEAP32[i7 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i6 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIcEE(i2, i7, i1, i4, i6, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i6, i3, 1) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) < 7) {
  HEAP32[i7 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i6 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIcEE(i2, i7, i1, i4, i6, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i6, i3, 2) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) < 61) {
  HEAP32[i7 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i6 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIcEE(i2, i7, i1, i4, i6, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i6, i3, 2) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) < 60) {
  HEAP32[i7 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i6 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function ___remdi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 8 | 0;
 i8 = i5 | 0;
 i7 = i2 >> 31 | ((i2 | 0) < 0 ? -1 : 0) << 1;
 i6 = ((i2 | 0) < 0 ? -1 : 0) >> 31 | ((i2 | 0) < 0 ? -1 : 0) << 1;
 i10 = i4 >> 31 | ((i4 | 0) < 0 ? -1 : 0) << 1;
 i9 = ((i4 | 0) < 0 ? -1 : 0) >> 31 | ((i4 | 0) < 0 ? -1 : 0) << 1;
 i2 = _i64Subtract(i7 ^ i1, i6 ^ i2, i7, i6) | 0;
 i1 = tempRet0;
 ___udivmoddi4(i2, i1, _i64Subtract(i10 ^ i3, i9 ^ i4, i10, i9) | 0, tempRet0, i8) | 0;
 i1 = _i64Subtract(HEAP32[i8 >> 2] ^ i7, HEAP32[i8 + 4 >> 2] ^ i6, i7, i6) | 0;
 i2 = tempRet0;
 STACKTOP = i5;
 return (tempRet0 = i2, i1) | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIwEE(i2, i7, i1, i4, i6, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i6, i3, 2) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) < 24) {
  HEAP32[i7 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i6 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIcEE(i2, i7, i1, i4, i6, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i1, i2, i6, i3, 2) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 4 | 0) == 0 & (i1 | 0) < 24) {
  HEAP32[i7 >> 2] = i1;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i6 >> 2] = i2 | 4;
  STACKTOP = i5;
  return;
 }
}

function _cvCreateMatND(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i6;
 if ((i2 + -1 | 0) >>> 0 > 31) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i1, 46) | 0) + 0 | 0;
  i7 = 41304 | 0;
  i8 = i5 + 46 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i7 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i7 = i7 + 1 | 0;
  } while ((i5 | 0) < (i8 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i1, 41416, 40912, 286);
  __ZN2cv6String10deallocateEv(i1);
 }
 i1 = _cvAlloc(276) | 0;
 _cvInitMatNDHeader(i1, i2, i3, i4, 0) | 0;
 HEAP32[i1 + 12 >> 2] = 1;
 _cvCreateData(i1);
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i4, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 __ZNSt3__114__shared_count12__add_sharedEv(i4);
 i3 = i2 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i2 + 12 >> 2] | 0) - i1 >> 2 >>> 0 <= i5 >>> 0) {
  __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6resizeEj(i3, i5 + 1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i2 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
 if (!i2) {
  i1 = i1 + (i5 << 2) | 0;
  HEAP32[i1 >> 2] = i4;
  STACKTOP = i6;
  return;
 }
 __ZNSt3__114__shared_count16__release_sharedEv(i2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = i1 + (i5 << 2) | 0;
 HEAP32[i1 >> 2] = i4;
 STACKTOP = i6;
 return;
}

function __ZN2cvL15countNonZero64fEPKdi(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 i2 = i4 + -4 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = 0;
  i1 = 0;
  do {
   i1 = (+HEAPF64[i5 + (i3 << 3) >> 3] != 0.0 & 1) + i1 + (+HEAPF64[i5 + ((i3 | 1) << 3) >> 3] != 0.0 & 1) + (+HEAPF64[i5 + ((i3 | 2) << 3) >> 3] != 0.0 & 1) + (+HEAPF64[i5 + ((i3 | 3) << 3) >> 3] != 0.0 & 1) | 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) <= (i2 | 0));
  i2 = i4 & -4;
 }
 if ((i2 | 0) >= (i4 | 0)) {
  STACKTOP = i6;
  return i1 | 0;
 }
 do {
  i1 = (+HEAPF64[i5 + (i2 << 3) >> 3] != 0.0 & 1) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN2cv10TLSStorage3getEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 _pthread_once(27016, 5) | 0;
 i1 = _pthread_getspecific(HEAP32[6756] | 0) | 0;
 if (i1) {
  STACKTOP = i3;
  return i1 | 0;
 }
 i2 = __Znwj(12) | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i2 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = __Znwj(64) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i8 = (HEAP32[i6 >> 2] | 0) - i1 | 0;
 i7 = i5 + (0 - (i8 >> 2) << 2) | 0;
 _memcpy(i7 | 0, i1 | 0, i8 | 0) | 0;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i4 >> 2] = i5 + 64;
 if (i1) __ZdlPv(i1);
 _pthread_setspecific(HEAP32[6756] | 0, i2 | 0) | 0;
 i1 = i2;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN7testing8internal8GTestLogD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i2;
 __ZNKSt3__18ios_base6getlocEv(i4, 956240 + (HEAP32[(HEAP32[239060] | 0) + -12 >> 2] | 0) | 0);
 i3 = __ZNKSt3__16locale9use_facetERNS0_2idE(i4, 960728) | 0;
 i3 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] & 127](i3, 10) | 0;
 __ZNSt3__16localeD2Ev(i4);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE3putEc(956240, i3) | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(956240) | 0;
 if ((HEAP32[i1 >> 2] | 0) == 3) {
  _fflush(HEAP32[_stderr >> 2] | 0) | 0;
  __ZN7testing8internal5posix5AbortEv();
 } else {
  STACKTOP = i2;
  return;
 }
}

function _sinh(d4) {
 d4 = +d4;
 var d1 = 0.0, d2 = 0.0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 HEAPF64[tempDoublePtr >> 3] = d4;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 d2 = (i3 | 0) < 0 ? -.5 : .5;
 i3 = i3 & 2147483647;
 HEAP32[tempDoublePtr >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[tempDoublePtr + 4 >> 2] = i3;
 d1 = +HEAPF64[tempDoublePtr >> 3];
 if (i3 >>> 0 >= 1082535490) {
  d1 = d2 * 2.0 * +___expo2(d1);
  STACKTOP = i5;
  return +d1;
 }
 d1 = +_expm1(d1);
 if (i3 >>> 0 >= 1072693248) {
  d1 = d2 * (d1 + d1 / (d1 + 1.0));
  STACKTOP = i5;
  return +d1;
 }
 if (i3 >>> 0 < 1045430272) {
  d1 = d4;
  STACKTOP = i5;
  return +d1;
 }
 d1 = d2 * (d1 * 2.0 - d1 * d1 / (d1 + 1.0));
 STACKTOP = i5;
 return +d1;
}

function _cvCreateMatNDHeader(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i6;
 if ((i2 + -1 | 0) >>> 0 > 31) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i5 = (__ZN2cv6String8allocateEj(i1, 46) | 0) + 0 | 0;
  i7 = 41304 | 0;
  i8 = i5 + 46 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i7 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i7 = i7 + 1 | 0;
  } while ((i5 | 0) < (i8 | 0));
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-211, i1, 41416, 40912, 286);
  __ZN2cv6String10deallocateEv(i1);
 }
 i1 = _cvAlloc(276) | 0;
 _cvInitMatNDHeader(i1, i2, i3, i4, 0) | 0;
 HEAP32[i1 + 12 >> 2] = 1;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 i1 = HEAP8[i2 >> 0] | 0;
 if (!(i1 & 1)) {
  i1 = (i1 & 255) >>> 1;
  i2 = i2 + 1 | 0;
 } else {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 if (!i1) {
  i1 = -1;
  STACKTOP = i6;
  return i1 | 0;
 }
 i1 = i2 + (i1 >>> 0 > i3 >>> 0 ? i3 + 1 | 0 : i1) | 0;
 do {
  if ((i1 | 0) == (i2 | 0)) {
   i1 = -1;
   i5 = 9;
   break;
  }
  i1 = i1 + -1 | 0;
 } while ((HEAP8[i1 >> 0] | 0) != i4 << 24 >> 24);
 if ((i5 | 0) == 9) {
  STACKTOP = i6;
  return i1 | 0;
 }
 i1 = i1 - i2 | 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN2cv12WLByteStream8putBytesEPKvi(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i6 = i8 + 8 | 0;
 i7 = i8 + 12 | 0;
 do {
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i5 = i3 - i4 | 0;
  i5 = (i5 | 0) > (i1 | 0) ? i1 : i5;
  if ((i5 | 0) > 0) {
   _memcpy(i4 | 0, i2 | 0, i5 | 0) | 0;
   i4 = (HEAP32[i7 >> 2] | 0) + i5 | 0;
   HEAP32[i7 >> 2] = i4;
   i1 = i1 - i5 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = i2 + i5 | 0;
  }
  if ((i4 | 0) == (i3 | 0)) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] & 511](i8);
 } while ((i1 | 0) != 0);
 STACKTOP = i9;
 return;
}

function __ZN7testing8UnitTest14AddEnvironmentEPNS_11EnvironmentE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = i5;
 if (!i5) {
  i1 = 0;
  STACKTOP = i6;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i4 = i1 + 52 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i1 + 56 >> 2] | 0)) {
  __ZNSt3__16vectorIPN7testing11EnvironmentENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i1 + 48 | 0, i3);
  i1 = i5;
  STACKTOP = i6;
  return i1 | 0;
 }
 if (!i2) i1 = 0; else {
  HEAP32[i2 >> 2] = i5;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 4;
 i1 = i5;
 STACKTOP = i6;
 return i1 | 0;
}

function ___toread(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 i1 = i3 + 74 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i2 + 255 | i2;
 i1 = i3 + 20 | 0;
 i2 = i3 + 44 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) FUNCTION_TABLE_iiii[HEAP32[i3 + 36 >> 2] & 63](i3, 0, 0) | 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!(i1 & 20)) {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 + 8 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = i1;
  i1 = 0;
  STACKTOP = i4;
  return i1 | 0;
 }
 if (!(i1 & 4)) {
  i1 = -1;
  STACKTOP = i4;
  return i1 | 0;
 }
 HEAP32[i3 >> 2] = i1 | 32;
 i1 = -1;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN2cv16BaseImageDecoderC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i3 >> 2] = 179344;
 i1 = i3 + 16 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 1124007936;
 i1 = i3 + 40 | 0;
 i2 = i3 + 72 | 0;
 i4 = i3 + 36 | 0;
 i6 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP32[i2 >> 2] = i1;
 i1 = i3 + 80 | 0;
 HEAP32[i3 + 76 >> 2] = i1;
 HEAP32[i3 + 84 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = -1;
 HEAP8[i3 + 88 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZNK2cv17MatOp_Initializer8multiplyERKNS_7MatExprEdRS1_(i1, i4, d7, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 d7 = +d7;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 i1 = i4;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 __ZN2cv3MataSERKS0_(i2 + 8 | 0, i4 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i2 + 64 | 0, i4 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i2 + 120 | 0, i4 + 120 | 0) | 0;
 i3 = i2 + 176 | 0;
 i5 = i3 + 0 | 0;
 i2 = i4 + 176 | 0;
 i1 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i1 | 0));
 HEAPF64[i3 >> 3] = +HEAPF64[i3 >> 3] * d7;
 STACKTOP = i6;
 return;
}

function _strtold_l(i5, i7, i1) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i4 = i6;
 i1 = i4 + 0 | 0;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i2 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = i5;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i4 + 44 >> 2] = i5;
 HEAP32[i4 + 76 >> 2] = -1;
 ___shlim(i4, 0);
 d3 = +___floatscan(i4, 2, 1);
 i1 = (HEAP32[i2 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) + (HEAP32[i4 + 108 >> 2] | 0) | 0;
 if (!i7) {
  STACKTOP = i6;
  return +d3;
 }
 if (!i1) i1 = i5; else i1 = i5 + i1 | 0;
 HEAP32[i7 >> 2] = i1;
 STACKTOP = i6;
 return +d3;
}

function __ZNK2cv7MatOp_T8multiplyERKNS_7MatExprEdRS1_(i1, i4, d7, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 d7 = +d7;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 i1 = i4;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 __ZN2cv3MataSERKS0_(i2 + 8 | 0, i4 + 8 | 0) | 0;
 __ZN2cv3MataSERKS0_(i2 + 64 | 0, i4 + 64 | 0) | 0;
 __ZN2cv3MataSERKS0_(i2 + 120 | 0, i4 + 120 | 0) | 0;
 i3 = i2 + 176 | 0;
 i5 = i3 + 0 | 0;
 i2 = i4 + 176 | 0;
 i1 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i1 | 0));
 HEAPF64[i3 >> 3] = +HEAPF64[i3 >> 3] * d7;
 STACKTOP = i6;
 return;
}

function __ZNKSt3__17collateIcE10do_compareEPKcS3_S3_S3_(i2, i1, i6, i3, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 L1 : do if ((i3 | 0) == (i5 | 0)) i8 = 6; else while (1) {
  if ((i1 | 0) == (i6 | 0)) {
   i1 = -1;
   break L1;
  }
  i2 = HEAP8[i1 >> 0] | 0;
  i4 = HEAP8[i3 >> 0] | 0;
  if (i2 << 24 >> 24 < i4 << 24 >> 24) {
   i1 = -1;
   break L1;
  }
  if (i4 << 24 >> 24 < i2 << 24 >> 24) {
   i1 = 1;
   break L1;
  }
  i1 = i1 + 1 | 0;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i5 | 0)) {
   i8 = 6;
   break;
  }
 } while (0);
 if ((i8 | 0) == 6) i1 = (i1 | 0) != (i6 | 0) & 1;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi(i1, i4, i3, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i2 = 0, i5 = 0;
 i5 = STACKTOP;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = i3;
  HEAP32[i4 + 24 >> 2] = i6;
  HEAP32[i4 + 36 >> 2] = 1;
  STACKTOP = i5;
  return;
 }
 if ((i2 | 0) != (i3 | 0)) {
  i1 = i4 + 36 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  HEAP32[i4 + 24 >> 2] = 2;
  HEAP8[i4 + 54 >> 0] = 1;
  STACKTOP = i5;
  return;
 }
 i1 = i4 + 24 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 2) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i1 >> 2] = i6;
 STACKTOP = i5;
 return;
}

function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE9pbackfailEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 do if ((HEAP32[i2 + 64 >> 2] | 0) != 0 ? (i5 = i2 + 12 | 0, i4 = HEAP32[i5 >> 2] | 0, (HEAP32[i2 + 8 >> 2] | 0) >>> 0 < i4 >>> 0) : 0) {
  if ((i1 | 0) == -1) {
   HEAP32[i5 >> 2] = i4 + -1;
   i1 = 0;
   break;
  }
  if (!(HEAP32[i2 + 88 >> 2] & 16)) {
   i3 = i1 & 255;
   i2 = i4 + -1 | 0;
   if (i3 << 24 >> 24 != (HEAP8[i2 >> 0] | 0)) {
    i1 = -1;
    break;
   }
  } else {
   i3 = i1 & 255;
   i2 = i4 + -1 | 0;
  }
  HEAP32[i5 >> 2] = i2;
  HEAP8[i2 >> 0] = i3;
 } else i1 = -1; while (0);
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN2cvL11copyMask16uEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i10, i4, i9, i5, i8, i2, i1) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0;
 i7 = STACKTOP;
 i6 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!((i1 | 0) != 0 & (i6 | 0) > 0)) {
  STACKTOP = i7;
  return;
 }
 while (1) {
  i1 = i1 + -1 | 0;
  i2 = 0;
  do {
   if (HEAP8[i4 + i2 >> 0] | 0) HEAP16[i5 + (i2 << 1) >> 1] = HEAP16[i3 + (i2 << 1) >> 1] | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
  if (!i1) break; else {
   i4 = i4 + i9 | 0;
   i5 = i5 + i8 | 0;
   i3 = i3 + i10 | 0;
  }
 }
 STACKTOP = i7;
 return;
}

function __ZN2cv11RBaseStream4openERKNS_6StringE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] & 511](i2);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] & 511](i2);
 i4 = HEAP32[i1 >> 2] | 0;
 i4 = _fopen(((i4 | 0) == 0 ? 181312 : i4) | 0, 180776) | 0;
 i1 = i2 + 20 | 0;
 HEAP32[i1 >> 2] = i4;
 if (!i4) {
  i1 = 0;
  STACKTOP = i3;
  return i1 | 0;
 }
 HEAP8[i2 + 32 >> 0] = 1;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i2 + 8 >> 2];
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] & 511](i2);
 i1 = (HEAP32[i1 >> 2] | 0) != 0;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN7testing8internal29ParameterizedTestCaseRegistryD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 i3 = HEAP32[i4 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) {
  i2 = i3;
  i1 = i3;
 } else {
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   if (i2) {
    FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i1 | 0));
  i2 = HEAP32[i4 >> 2] | 0;
 }
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) != (i2 | 0)) HEAP32[i5 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
 __ZdlPv(i2);
 STACKTOP = i6;
 return;
}

function _cvReleaseImage(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i4;
 if (!i3) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 43072, 40912, 2990);
  __ZN2cv6String10deallocateEv(i1);
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i3 >> 2] = 0;
 _cvReleaseData(i2);
 i1 = HEAP32[10246] | 0;
 if (!i1) {
  i1 = i2 + 48 | 0;
  _cvFree_(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  _cvFree_(i2);
  STACKTOP = i4;
  return;
 } else {
  FUNCTION_TABLE_vii[i1 & 127](i2, 5);
  STACKTOP = i4;
  return;
 }
}

function __ZN2cv3Mat10deallocateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 i4 = i3 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i3 + 32 >> 2] | 0;
  if (!i2) {
   if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
    i1 = __Znwj(4) | 0;
    HEAP32[i1 >> 2] = 32784;
    HEAP32[6904] = i1;
    ___cxa_guard_release(27624);
   }
   i2 = HEAP32[6904] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  }
 }
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2, i1);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function _strtoll(i6, i5, i1) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i4 + 44 >> 2] = i6;
 if ((i6 | 0) < 0) HEAP32[i4 + 8 >> 2] = -1; else HEAP32[i4 + 8 >> 2] = i6 + 2147483647;
 HEAP32[i4 + 76 >> 2] = -1;
 ___shlim(i4, 0);
 i1 = ___intscan(i4, i1, 1, 0, -2147483648) | 0;
 i2 = tempRet0;
 if (!i5) {
  tempRet0 = i2;
  STACKTOP = i7;
  return i1 | 0;
 }
 HEAP32[i5 >> 2] = i6 + ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 + 108 >> 2] | 0) - (HEAP32[i4 + 8 >> 2] | 0));
 tempRet0 = i2;
 STACKTOP = i7;
 return i1 | 0;
}

function _inflateEnd(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 if (!i3) {
  i1 = -2;
  STACKTOP = i7;
  return i1 | 0;
 }
 i6 = i3 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i1 = -2;
  STACKTOP = i7;
  return i1 | 0;
 }
 i4 = i3 + 36 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i1 = -2;
  STACKTOP = i7;
  return i1 | 0;
 }
 i5 = HEAP32[i1 + 52 >> 2] | 0;
 i3 = i3 + 40 | 0;
 if (i5) {
  FUNCTION_TABLE_vii[i2 & 127](HEAP32[i3 >> 2] | 0, i5);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 FUNCTION_TABLE_vii[i2 & 127](HEAP32[i3 >> 2] | 0, i1);
 HEAP32[i6 >> 2] = 0;
 i1 = 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN7testing8internal17TestEventRepeater20OnTestIterationStartERKNS_8UnitTestEi(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i4 = i1 + 12 | 0;
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i7;
  return;
 } else i2 = 0;
 do {
  i8 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] & 63](i8, i6, i5);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) - i1 >> 2 >>> 0);
 STACKTOP = i7;
 return;
}

function __ZN2cvL14transposeI_16uEPhji(i3, i7, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) > 0) i4 = 0; else {
  STACKTOP = i8;
  return;
 }
 do {
  i1 = i3 + (Math_imul(i4, i7) | 0) | 0;
  i2 = i4 << 1;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) < (i6 | 0)) {
   i5 = i4;
   do {
    i11 = i1 + (i5 << 1) | 0;
    i9 = i3 + ((Math_imul(i5, i7) | 0) + i2) | 0;
    i10 = HEAP16[i11 >> 1] | 0;
    HEAP16[i11 >> 1] = HEAP16[i9 >> 1] | 0;
    HEAP16[i9 >> 1] = i10;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
  }
 } while ((i4 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function _strtod(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, d4 = 0.0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i5 = i7;
 i2 = i5 + 0 | 0;
 i3 = i2 + 112 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i5 + 8 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i5 + 44 >> 2] = i1;
 HEAP32[i5 + 76 >> 2] = -1;
 ___shlim(i5, 0);
 d4 = +___floatscan(i5, 1, 1);
 i2 = (HEAP32[i3 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) + (HEAP32[i5 + 108 >> 2] | 0) | 0;
 if (!i6) {
  STACKTOP = i7;
  return +d4;
 }
 if (i2) i1 = i1 + i2 | 0;
 HEAP32[i6 >> 2] = i1;
 STACKTOP = i7;
 return +d4;
}

function __ZN7testing8internal17TestEventRepeaterD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 HEAP32[i2 >> 2] = 162784;
 i4 = i2 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i2 + 12 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 STACKTOP = i6;
 return;
}

function __ZL14icvYMLWriteIntP13CvFileStoragePKci(i2, i3, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i4 = i7 + 23 | 0;
 HEAP8[i4 >> 0] = 0;
 i5 = (i6 | 0) > -1 ? i6 : 0 - i6 | 0;
 while (1) {
  i8 = i5;
  i5 = (i5 >>> 0) / 10 | 0;
  i1 = i4 + -1 | 0;
  HEAP8[i1 >> 0] = i8 + 48 + (Math_imul(i5, -10) | 0);
  if (i8 >>> 0 <= 9) break; else i4 = i1;
 }
 if ((i6 | 0) >= 0) {
  __ZL11icvYMLWriteP13CvFileStoragePKcS2_(i2, i3, i1);
  STACKTOP = i7;
  return;
 }
 i1 = i4 + -2 | 0;
 HEAP8[i1 >> 0] = 45;
 __ZL11icvYMLWriteP13CvFileStoragePKcS2_(i2, i3, i1);
 STACKTOP = i7;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i5, i4, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 i6 = STACKTOP;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = (i1 & 1) == 0;
 if (i2) i1 = (i1 & 255) >>> 1; else i1 = HEAP32[i5 + 4 >> 2] | 0;
 if (i1 >>> 0 < i4 >>> 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEjc(i5, i4 - i1 | 0, i3) | 0;
  STACKTOP = i6;
  return;
 }
 if (i2) {
  HEAP8[i5 + i4 + 1 >> 0] = 0;
  HEAP8[i5 >> 0] = i4 << 1;
  STACKTOP = i6;
  return;
 } else {
  HEAP8[(HEAP32[i5 + 8 >> 2] | 0) + i4 >> 0] = 0;
  HEAP32[i5 + 4 >> 2] = i4;
  STACKTOP = i6;
  return;
 }
}

function __ZN2cvL10copyMask8uEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i10, i4, i9, i5, i8, i2, i1) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0;
 i7 = STACKTOP;
 i6 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!((i1 | 0) != 0 & (i6 | 0) > 0)) {
  STACKTOP = i7;
  return;
 }
 while (1) {
  i1 = i1 + -1 | 0;
  i2 = 0;
  do {
   if (HEAP8[i4 + i2 >> 0] | 0) HEAP8[i5 + i2 >> 0] = HEAP8[i3 + i2 >> 0] | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
  if (!i1) break; else {
   i4 = i4 + i9 | 0;
   i5 = i5 + i8 | 0;
   i3 = i3 + i10 | 0;
  }
 }
 STACKTOP = i7;
 return;
}

function _strtoull(i6, i5, i1) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i4 + 44 >> 2] = i6;
 if ((i6 | 0) < 0) HEAP32[i4 + 8 >> 2] = -1; else HEAP32[i4 + 8 >> 2] = i6 + 2147483647;
 HEAP32[i4 + 76 >> 2] = -1;
 ___shlim(i4, 0);
 i1 = ___intscan(i4, i1, 1, -1, -1) | 0;
 i2 = tempRet0;
 if (!i5) {
  tempRet0 = i2;
  STACKTOP = i7;
  return i1 | 0;
 }
 HEAP32[i5 >> 2] = i6 + ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 + 108 >> 2] | 0) - (HEAP32[i4 + 8 >> 2] | 0));
 tempRet0 = i2;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9underflowEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 i2 = i5 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i5 + 24 >> 2] | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = i3;
  i1 = i3;
 }
 if (!(HEAP32[i5 + 48 >> 2] & 8)) {
  i1 = -1;
  STACKTOP = i6;
  return i1 | 0;
 }
 i4 = i5 + 16 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i5 + 12 >> 2] | 0;
 if (i3 >>> 0 < i1 >>> 0) HEAP32[i4 >> 2] = i1; else i1 = i3;
 if (i2 >>> 0 >= i1 >>> 0) {
  i1 = -1;
  STACKTOP = i6;
  return i1 | 0;
 }
 i1 = HEAPU8[i2 >> 0] | 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__111__stdoutbufIwE6xsputnEPKwi(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 if (HEAP8[i4 + 44 >> 0] | 0) {
  i1 = _fwrite(i2 | 0, 4, i3 | 0, HEAP32[i4 + 32 >> 2] | 0) | 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 if ((i3 | 0) > 0) i1 = 0; else {
  i1 = 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 while (1) {
  if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] & 127](i4, HEAP32[i2 >> 2] | 0) | 0) == -1) {
   i2 = 6;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) < (i3 | 0)) i2 = i2 + 4 | 0; else {
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) {
  STACKTOP = i5;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__111__stdoutbufIcE6xsputnEPKci(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 if (HEAP8[i4 + 44 >> 0] | 0) {
  i1 = _fwrite(i2 | 0, 1, i3 | 0, HEAP32[i4 + 32 >> 2] | 0) | 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 if ((i3 | 0) > 0) i1 = 0; else {
  i1 = 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 while (1) {
  if ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] & 127](i4, HEAPU8[i2 >> 0] | 0) | 0) == -1) {
   i2 = 6;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) < (i3 | 0)) i2 = i2 + 1 | 0; else {
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) {
  STACKTOP = i5;
  return i1 | 0;
 }
 return 0;
}

function __ZNKSt3__17collateIwE10do_compareEPKwS3_S3_S3_(i2, i1, i6, i3, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 L1 : do if ((i3 | 0) == (i5 | 0)) i8 = 6; else while (1) {
  if ((i1 | 0) == (i6 | 0)) {
   i1 = -1;
   break L1;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) < (i4 | 0)) {
   i1 = -1;
   break L1;
  }
  if ((i4 | 0) < (i2 | 0)) {
   i1 = 1;
   break L1;
  }
  i1 = i1 + 4 | 0;
  i3 = i3 + 4 | 0;
  if ((i3 | 0) == (i5 | 0)) {
   i8 = 6;
   break;
  }
 } while (0);
 if ((i8 | 0) == 6) i1 = (i1 | 0) != (i6 | 0) & 1;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN2cvL14transposeI_32sEPhji(i3, i7, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) > 0) i4 = 0; else {
  STACKTOP = i8;
  return;
 }
 do {
  i1 = i3 + (Math_imul(i4, i7) | 0) | 0;
  i2 = i4 << 2;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) < (i6 | 0)) {
   i5 = i4;
   do {
    i11 = i1 + (i5 << 2) | 0;
    i9 = i3 + ((Math_imul(i5, i7) | 0) + i2) | 0;
    i10 = HEAP32[i11 >> 2] | 0;
    HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i9 >> 2] = i10;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
  }
 } while ((i4 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZN7testing15AssertionResultlsIdEERS0_RKT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5;
 __ZN7testing7MessageC2Ev(i1);
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEd((HEAP32[i1 >> 2] | 0) + 8 | 0, +HEAPF64[i4 >> 3]) | 0;
 __ZN7testing15AssertionResult13AppendMessageERKNS_7MessageE(i3, i1);
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return i3 | 0;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return i3 | 0;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i8, i4, i7, i6, i1) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i1 = HEAP8[i4 >> 0] | 0;
 i2 = (i1 & 1) == 0;
 if (i2) i3 = (i1 & 255) >>> 1; else i3 = HEAP32[i4 + 4 >> 2] | 0;
 if (i3 >>> 0 < i7 >>> 0) __ZNKSt3__121__basic_string_commonILb1EE20__throw_out_of_rangeEv(i8);
 if (i2) i1 = i4 + 1 | 0; else i1 = HEAP32[i4 + 8 >> 2] | 0;
 i2 = i3 - i7 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i1 + i7 | 0, i2 >>> 0 < i6 >>> 0 ? i2 : i6);
 STACKTOP = i5;
 return;
}

function __ZNSt3__115__num_get_floatIeEET_PKcS3_Rj(i2, i5, i6) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var d1 = 0.0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i8;
 do if ((i2 | 0) != (i5 | 0)) {
  i3 = ___errno_location() | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  d1 = +_strtold_l(i2, i7, __ZNSt3__16__clocEv() | 0);
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) HEAP32[i3 >> 2] = i4;
  if ((HEAP32[i7 >> 2] | 0) != (i5 | 0)) {
   HEAP32[i6 >> 2] = 4;
   d1 = 0.0;
   break;
  }
  if ((i2 | 0) == 34) HEAP32[i6 >> 2] = 4;
 } else {
  HEAP32[i6 >> 2] = 4;
  d1 = 0.0;
 } while (0);
 STACKTOP = i8;
 return +d1;
}

function __ZNSt3__115__num_get_floatIdEET_PKcS3_Rj(i2, i5, i6) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var d1 = 0.0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i8;
 do if ((i2 | 0) != (i5 | 0)) {
  i3 = ___errno_location() | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  d1 = +_strtold_l(i2, i7, __ZNSt3__16__clocEv() | 0);
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) HEAP32[i3 >> 2] = i4;
  if ((HEAP32[i7 >> 2] | 0) != (i5 | 0)) {
   HEAP32[i6 >> 2] = 4;
   d1 = 0.0;
   break;
  }
  if ((i2 | 0) == 34) HEAP32[i6 >> 2] = 4;
 } else {
  HEAP32[i6 >> 2] = 4;
  d1 = 0.0;
 } while (0);
 STACKTOP = i8;
 return +d1;
}

function __ZN6CvTypeC2EPKcPFiPKvEPFvPPvEPFS6_P13CvFileStorageP10CvFileNodeEPFvSB_S1_S3_10CvAttrListEPFS6_S3_E(i5, i6, i2, i4, i3, i7, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 40;
 HEAP32[i9 + 16 >> 2] = i6;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = i2;
 HEAP32[i9 + 24 >> 2] = i4;
 HEAP32[i9 + 36 >> 2] = i1;
 HEAP32[i9 + 28 >> 2] = i3;
 HEAP32[i9 + 32 >> 2] = i7;
 _cvRegisterType(i9);
 HEAP32[i5 >> 2] = HEAP32[2644];
 STACKTOP = i8;
 return;
}

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6resizeEj(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 i5 = i4 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i6 - i1 >> 2;
 if (i2 >>> 0 < i3 >>> 0) {
  __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj(i4, i3 - i2 | 0);
  STACKTOP = i7;
  return;
 }
 if (i2 >>> 0 <= i3 >>> 0) {
  STACKTOP = i7;
  return;
 }
 i1 = i1 + (i3 << 2) | 0;
 if ((i6 | 0) == (i1 | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = i6 + (~((i6 + -4 - i1 | 0) >>> 2) << 2);
 STACKTOP = i7;
 return;
}

function _realloc(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 do if (i3) {
  if (i2 >>> 0 > 4294967231) {
   HEAP32[(___errno_location() | 0) >> 2] = 12;
   i1 = 0;
   break;
  }
  if (i2 >>> 0 < 11) i1 = 16; else i1 = i2 + 11 & -8;
  i1 = _try_realloc_chunk(i3 + -8 | 0, i1) | 0;
  if (i1) {
   i1 = i1 + 8 | 0;
   break;
  }
  i1 = _malloc(i2) | 0;
  if (!i1) i1 = 0; else {
   i5 = HEAP32[i3 + -4 >> 2] | 0;
   i5 = (i5 & -8) - ((i5 & 3 | 0) == 0 ? 8 : 4) | 0;
   _memcpy(i1 | 0, i3 | 0, (i5 >>> 0 < i2 >>> 0 ? i5 : i2) | 0) | 0;
   _free(i3);
  }
 } else i1 = _malloc(i2) | 0; while (0);
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i7, i2, i4, i6, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i6, i3, 4) | 0;
 if (HEAP32[i6 >> 2] & 4) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i7 >> 2] = i1 + -1900;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i7, i2, i4, i6, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 0 >> 2] = HEAP32[i8 + 0 >> 2];
 i1 = __ZNSt3__120__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i6, i3, 4) | 0;
 if (HEAP32[i6 >> 2] & 4) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i7 >> 2] = i1 + -1900;
 STACKTOP = i5;
 return;
}

function __ZN7testing8internal17TestEventRepeater27OnEnvironmentsTearDownStartERKNS_8UnitTestE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 12 | 0;
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i6;
  return;
 } else i2 = 0;
 do {
  i7 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i7 >> 2] | 0) + 44 >> 2] & 127](i7, i5);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) - i1 >> 2 >>> 0);
 STACKTOP = i6;
 return;
}

function __ZN12_GLOBAL__N_113FormattedImpl13valueToStr32fEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, d4 = 0.0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 i6 = HEAP32[i1 + 88 >> 2] | 0;
 i5 = Math_imul(HEAP32[i6 >> 2] | 0, HEAP32[i1 + 112 >> 2] | 0) | 0;
 d4 = +Math_fround(HEAPF32[(HEAP32[i1 + 60 >> 2] | 0) + ((Math_imul(HEAP32[i6 + 4 >> 2] | 0, HEAP32[i1 + 116 >> 2] | 0) | 0) + i5) + (HEAP32[i1 + 120 >> 2] << 2) >> 2]);
 HEAPF64[tempDoublePtr >> 3] = d4;
 HEAP32[i3 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 _sprintf(i1 + 12 | 0, i1 + 4 | 0, i3) | 0;
 STACKTOP = i2;
 return;
}

function __ZN7testing8internal17TestEventRepeater24OnEnvironmentsSetUpStartERKNS_8UnitTestE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 12 | 0;
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i6;
  return;
 } else i2 = 0;
 do {
  i7 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] & 127](i7, i5);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) - i1 >> 2 >>> 0);
 STACKTOP = i6;
 return;
}

function __ZN7testing8internal17TestEventRepeater16OnTestPartResultERKNS_14TestPartResultE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 12 | 0;
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i6;
  return;
 } else i2 = 0;
 do {
  i7 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i7 >> 2] | 0) + 32 >> 2] & 127](i7, i5);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) - i1 >> 2 >>> 0);
 STACKTOP = i6;
 return;
}

function __ZN2cvL13transposeI_8uEPhji(i2, i7, i6) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 if ((i6 | 0) > 0) i3 = 0; else {
  STACKTOP = i8;
  return;
 }
 do {
  i1 = Math_imul(i3, i7) | 0;
  i4 = i3;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) < (i6 | 0)) {
   i5 = i3;
   do {
    i11 = i2 + (i5 + i1) | 0;
    i9 = i2 + ((Math_imul(i5, i7) | 0) + i4) | 0;
    i10 = HEAP8[i11 >> 0] | 0;
    HEAP8[i11 >> 0] = HEAP8[i9 >> 0] | 0;
    HEAP8[i9 >> 0] = i10;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
  }
 } while ((i3 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZNSt3__117__call_once_proxyINS_5tupleIJNS_12_GLOBAL__N_111__fake_bindEEEEEEvPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 i4 = i1 + 4 | 0;
 i2 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
 i4 = i4 + 4 | 0;
 i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
 i1 = (HEAP32[i1 >> 2] | 0) + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  FUNCTION_TABLE_vi[i2 & 511](i1);
  STACKTOP = i3;
  return;
 } else {
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + i2 >> 2] | 0;
  FUNCTION_TABLE_vi[i2 & 511](i1);
  STACKTOP = i3;
  return;
 }
}

function __ZN7testing8internal17TestEventRepeater18OnTestProgramStartERKNS_8UnitTestE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 12 | 0;
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i6;
  return;
 } else i2 = 0;
 do {
  i7 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] & 127](i7, i5);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) - i1 >> 2 >>> 0);
 STACKTOP = i6;
 return;
}

function __ZTv0_n12_NSt3__118basic_stringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0;
 i3 = i1 + i6 | 0;
 HEAP32[i3 >> 2] = 2620;
 i4 = i1 + (i6 + 64) | 0;
 HEAP32[i4 >> 2] = 2660;
 HEAP32[i1 + (i6 + 8) >> 2] = 2640;
 i5 = i1 + (i6 + 12) | 0;
 HEAP32[i5 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + (i6 + 44) | 0);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i5);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i4);
 __ZdlPv(i3);
 STACKTOP = i2;
 return;
}

function __ZN7testing8internal24XmlUnitTestResultPrinterC2EPKc(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i3 >> 2] = 162856;
 i6 = i3 + 4 | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i1, _strlen(i1 | 0) | 0);
 i1 = HEAP8[i6 >> 0] | 0;
 if (i1 & 1) {
  if (HEAP32[i3 + 12 >> 2] | 0) {
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   i4 = 5;
  }
 } else {
  i2 = (i1 & 255) >>> 1;
  i4 = 5;
 }
 if ((i4 | 0) == 5 ? (i2 | 0) != 0 : 0) {
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[_stderr >> 2] | 0;
 _fwrite(162920, 32, 1, i1 | 0) | 0;
 _fflush(i1 | 0) | 0;
 _exit(1);
}

function __ZN7testing8internal17TestEventRepeater15OnTestCaseStartERKNS_8TestCaseE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 12 | 0;
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i6;
  return;
 } else i2 = 0;
 do {
  i7 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] & 127](i7, i5);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) - i1 >> 2 >>> 0);
 STACKTOP = i6;
 return;
}

function __ZN2cv11FileStorage7releaseEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i6 = i2 + 4 | 0, i5 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i5 + -1, (i5 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] & 511](i2);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 i1 = i3 + 24 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
  i1 = i3 + 32 | 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i4;
  return;
 }
 HEAP32[i1 >> 2] = i2;
 i1 = i3 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 HEAP32[i5 >> 2] = 177424;
 i1 = i5 + 64 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE4syncEv(i5) | 0, (_fclose(i2 | 0) | 0) == 0) : 0) HEAP32[i1 >> 2] = 0;
 if ((HEAP8[i5 + 96 >> 0] | 0) != 0 ? (i4 = HEAP32[i5 + 32 >> 2] | 0, (i4 | 0) != 0) : 0) __ZdaPv(i4);
 if ((HEAP8[i5 + 97 >> 0] | 0) != 0 ? (i3 = HEAP32[i5 + 56 >> 2] | 0, (i3 | 0) != 0) : 0) __ZdaPv(i3);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i5);
 STACKTOP = i6;
 return;
}

function __ZN2cv4UMat8copySizeERKS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 __ZN2cvL7setSizeERNS_4UMatEiPKiPKjb(i2, HEAP32[i1 + 4 >> 2] | 0, 0, 0, 0);
 i4 = i2 + 4 | 0;
 if ((HEAP32[i4 >> 2] | 0) <= 0) {
  STACKTOP = i7;
  return;
 }
 i5 = HEAP32[i1 + 32 >> 2] | 0;
 i6 = HEAP32[i2 + 32 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 i2 = 0;
 do {
  HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
  HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (HEAP32[i4 >> 2] | 0));
 STACKTOP = i7;
 return;
}

function _cvCreateMemStorage(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i4;
 i2 = _cvAlloc(24) | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40888, 39608, 92);
  __ZN2cv6String10deallocateEv(i1);
 }
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = 1116274688;
 HEAP32[i2 + 16 >> 2] = (i3 | 0) < 1 ? 65408 : i3 + 7 & -8;
 STACKTOP = i4;
 return i2 | 0;
}

function __ZN12_GLOBAL__N_113FormattedImpl13valueToStr64fEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, d4 = 0.0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 i6 = HEAP32[i1 + 88 >> 2] | 0;
 i5 = Math_imul(HEAP32[i6 >> 2] | 0, HEAP32[i1 + 112 >> 2] | 0) | 0;
 d4 = +HEAPF64[(HEAP32[i1 + 60 >> 2] | 0) + ((Math_imul(HEAP32[i6 + 4 >> 2] | 0, HEAP32[i1 + 116 >> 2] | 0) | 0) + i5) + (HEAP32[i1 + 120 >> 2] << 3) >> 3];
 HEAPF64[tempDoublePtr >> 3] = d4;
 HEAP32[i3 >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[tempDoublePtr + 4 >> 2];
 _sprintf(i1 + 12 | 0, i1 + 4 | 0, i3) | 0;
 STACKTOP = i2;
 return;
}

function __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC2EjjS6_(i6, i4, i5, i1) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i7 = 0;
 i7 = STACKTOP;
 i3 = i6 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = i1;
 do if (i4) {
  i2 = i1 + 112 | 0;
  if ((HEAP8[i2 >> 0] | 0) == 0 & i4 >>> 0 < 29) {
   HEAP8[i2 >> 0] = 1;
   break;
  } else {
   i1 = __Znwj(i4 << 2) | 0;
   break;
  }
 } else i1 = 0; while (0);
 HEAP32[i6 >> 2] = i1;
 i2 = i1 + (i5 << 2) | 0;
 HEAP32[i6 + 8 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i3 >> 2] = i1 + (i4 << 2);
 STACKTOP = i7;
 return;
}

function __ZNK2cv12MatOp_Invert6matmulERKNS_7MatExprES3_RS1_(i5, i1, i2, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i6 = 0;
 i6 = STACKTOP;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) == 33144 & (i3 | 0) == 33104) {
  __ZN2cv11MatOp_Solve8makeExprERNS_7MatExprEiRKNS_3MatES5_(i4, HEAP32[i1 + 4 >> 2] | 0, i1 + 8 | 0, i2 + 8 | 0);
  STACKTOP = i6;
  return;
 }
 if ((i5 | 0) == (i3 | 0)) {
  __ZNK2cv5MatOp6matmulERKNS_7MatExprES3_RS1_(i3, i1, i2, i4);
  STACKTOP = i6;
  return;
 } else {
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] & 63](i3, i1, i2, i4);
  STACKTOP = i6;
  return;
 }
}

function __ZNK2cv10HdrDecoder14checkSignatureERKNS_6StringE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) >>> 0 >= i2 >>> 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? 180560 : i1;
  i5 = HEAP32[i3 + 24 >> 2] | 0;
  if (!(_memcmp(i1, (i5 | 0) == 0 ? 180560 : i5, i2) | 0)) {
   i1 = 1;
   STACKTOP = i4;
   return i1 | 0;
  }
  i2 = HEAP32[i3 + 92 >> 2] | 0;
  if (!(_memcmp(i1, (i2 | 0) == 0 ? 180560 : i2, HEAP32[i3 + 96 >> 2] | 0) | 0)) {
   i1 = 1;
   STACKTOP = i4;
   return i1 | 0;
  }
 }
 i1 = 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN7testing8internal17TestEventRepeater11OnTestStartERKNS_8TestInfoE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 12 | 0;
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i6;
  return;
 } else i2 = 0;
 do {
  i7 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] & 127](i7, i5);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) - i1 >> 2 >>> 0);
 STACKTOP = i6;
 return;
}

function __ZN2cv3Mat8copySizeERKS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 __ZN2cvL7setSizeERNS_3MatEiPKiPKjb(i2, HEAP32[i1 + 4 >> 2] | 0, 0, 0, 0);
 i4 = i2 + 4 | 0;
 if ((HEAP32[i4 >> 2] | 0) <= 0) {
  STACKTOP = i7;
  return;
 }
 i5 = HEAP32[i1 + 40 >> 2] | 0;
 i6 = HEAP32[i2 + 40 >> 2] | 0;
 i3 = HEAP32[i1 + 44 >> 2] | 0;
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 i2 = 0;
 do {
  HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
  HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (HEAP32[i4 >> 2] | 0));
 STACKTOP = i7;
 return;
}

function __ZN7testing4Test14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 if ((HEAP8[163744] | 0) == 0 ? (___cxa_guard_acquire(163744) | 0) != 0 : 0) {
  HEAP32[40932] = 163936;
  i4 = __Znwj(216) | 0;
  __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i4, 163728);
  HEAP32[40934] = i4;
  ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
  ___cxa_guard_release(163744);
 }
 __ZN7testing8UnitTest14RecordPropertyERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(163728, i1, i2);
 STACKTOP = i3;
 return;
}

function __ZL17icvSortIdxCmpFuncPKvS0_Pv(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 if ((i6 | 0) > 0) i4 = 0; else {
  i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 }
 while (1) {
  i2 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
  i1 = HEAP32[i3 + (i4 << 2) >> 2] | 0;
  i4 = i4 + 1 | 0;
  if ((i2 | 0) != (i1 | 0)) break;
  if ((i4 | 0) >= (i6 | 0)) {
   i1 = 0;
   i7 = 5;
   break;
  }
 }
 if ((i7 | 0) == 5) {
  STACKTOP = i8;
  return i1 | 0;
 }
 i1 = i2 - i1 | 0;
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN7testing8internal17TestEventRepeater18OnTestIterationEndERKNS_8UnitTestEi(i1, i5, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 i3 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) <= 0) {
  STACKTOP = i6;
  return;
 }
 i1 = i1 >> 2;
 while (1) {
  i1 = i1 + -1 | 0;
  i2 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] & 63](i2, i5, i4);
  if ((i1 | 0) <= 0) break;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 STACKTOP = i6;
 return;
}

function _vasprintf(i7, i6, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i8;
 i2 = _malloc(240) | 0;
 do if (i2) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = _vsnprintf(i2, 240, i6, i1) | 0;
  if (i1 >>> 0 < 240) {
   i3 = _realloc(i2, i1 + 1 | 0) | 0;
   HEAP32[i7 >> 2] = (i3 | 0) != 0 ? i3 : i2;
   break;
  }
  _free(i2);
  if ((i1 | 0) >= 0 ? (i4 = i1 + 1 | 0, i3 = _malloc(i4) | 0, HEAP32[i7 >> 2] = i3, (i3 | 0) != 0) : 0) i1 = _vsnprintf(i3, i4, i6, i5) | 0; else i1 = -1;
 } else i1 = -1; while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZNSt3__111__call_onceERVmPvPFvS2_E(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 _pthread_mutex_lock(957792) | 0;
 if ((HEAP32[i2 >> 2] | 0) == 1) do _pthread_cond_wait(957816, 957792) | 0; while ((HEAP32[i2 >> 2] | 0) == 1);
 if (!(HEAP32[i2 >> 2] | 0)) {
  HEAP32[i2 >> 2] = 1;
  _pthread_mutex_unlock(957792) | 0;
  FUNCTION_TABLE_vi[i3 & 511](i1);
  _pthread_mutex_lock(957792) | 0;
  HEAP32[i2 >> 2] = -1;
  _pthread_mutex_unlock(957792) | 0;
  _pthread_cond_broadcast(957816) | 0;
  STACKTOP = i4;
  return;
 } else {
  _pthread_mutex_unlock(957792) | 0;
  STACKTOP = i4;
  return;
 }
}

function __ZNK2cv11MatOp_AddEx9transposeERKNS_7MatExprERS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 do if ((HEAP32[i2 >> 2] | 0) == 33112) {
  if ((HEAP32[i2 + 80 >> 2] | 0) != 0 ? !(+HEAPF64[i2 + 184 >> 3] == 0.0) : 0) break;
  if (((+HEAPF64[i2 + 192 >> 3] == 0.0 ? +HEAPF64[i2 + 200 >> 3] == 0.0 : 0) ? +HEAPF64[i2 + 208 >> 3] == 0.0 : 0) ? +HEAPF64[i2 + 216 >> 3] == 0.0 : 0) {
   __ZN2cv7MatOp_T8makeExprERNS_7MatExprERKNS_3MatEd(i3, i2 + 8 | 0, +HEAPF64[i2 + 176 >> 3]);
   STACKTOP = i1;
   return;
  }
 } while (0);
 __ZNK2cv5MatOp9transposeERKNS_7MatExprERS1_(0, i2, i3);
 STACKTOP = i1;
 return;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter16OnTestPartResultERKNS_14TestPartResultE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i4;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 __ZN7testing8internalL27PrintTestPartResultToStringERKNS_14TestPartResultE(i2, i3);
 if (!(HEAP8[i2 >> 0] & 1)) i1 = i2 + 1 | 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
 _puts(i1 | 0) | 0;
 i1 = HEAP32[_stdout >> 2] | 0;
 _fflush(i1 | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 _fflush(i1 | 0) | 0;
 STACKTOP = i4;
 return;
}

function __ZN2cvL10cmp_paramsERKNS_23CommandLineParserParamsES2_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if ((i2 | 0) < (i1 | 0)) {
  i1 = 1;
  STACKTOP = i5;
  return i1 | 0;
 }
 if ((i2 | 0) > (i1 | 0)) {
  i1 = 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 i2 = HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0;
 i1 = HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i1 = 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 i1 = (_strcmp((i2 | 0) == 0 ? 6232 : i2, (i1 | 0) == 0 ? 6232 : i1) | 0) < 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN2cv10HdrDecoder10readHeaderEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = _fopen(((i1 | 0) == 0 ? 180560 : i1) | 0, 180192) | 0;
 i2 = i3 + 100 | 0;
 HEAP32[i2 >> 2] = i1;
 if (!i1) {
  i1 = 0;
  STACKTOP = i4;
  return i1 | 0;
 }
 i5 = i3 + 4 | 0;
 i3 = i3 + 8 | 0;
 __Z15RGBE_ReadHeaderP8_IO_FILEPiS1_P16rgbe_header_info(i1, i5, i3, 0) | 0;
 if ((HEAP32[i5 >> 2] | 0) >= 1 ? (HEAP32[i3 >> 2] | 0) >= 1 : 0) {
  i1 = 1;
  STACKTOP = i4;
  return i1 | 0;
 }
 _fclose(HEAP32[i2 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 i1 = 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE6do_outERS1_PKDsS5_RS5_PcS7_RS7_(i5, i1, i2, i3, i4, i6, i7, i8) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i5 + 4 | 0;
 i9 = i5;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i9 >> 2] = i6;
 i1 = __ZNSt3__1L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i2, i3, i10, i6, i7, i9, 1114111, 0) | 0;
 HEAP32[i4 >> 2] = i2 + ((HEAP32[i10 >> 2] | 0) - i2 >> 1 << 1);
 HEAP32[i8 >> 2] = i6 + ((HEAP32[i9 >> 2] | 0) - i6);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE5do_inERS1_PKcS5_RS5_PDsS7_RS7_(i5, i1, i2, i3, i4, i6, i7, i8) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i5 + 4 | 0;
 i9 = i5;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i9 >> 2] = i6;
 i1 = __ZNSt3__1L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE(i2, i3, i10, i6, i7, i9, 1114111, 0) | 0;
 HEAP32[i4 >> 2] = i2 + ((HEAP32[i10 >> 2] | 0) - i2);
 HEAP32[i8 >> 2] = i6 + ((HEAP32[i9 >> 2] | 0) - i6 >> 1 << 1);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE6do_outERS1_PKDiS5_RS5_PcS7_RS7_(i5, i1, i2, i3, i4, i6, i7, i8) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i5 + 4 | 0;
 i9 = i5;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i9 >> 2] = i6;
 i1 = __ZNSt3__1L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i2, i3, i10, i6, i7, i9, 1114111, 0) | 0;
 HEAP32[i4 >> 2] = i2 + ((HEAP32[i10 >> 2] | 0) - i2 >> 2 << 2);
 HEAP32[i8 >> 2] = i6 + ((HEAP32[i9 >> 2] | 0) - i6);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter11OnTestStartERKNS_8TestInfoE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i5;
 __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(2, 162528, i4);
 if (!(HEAP8[i3 >> 0] & 1)) i2 = i3 + 1 | 0; else i2 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = i3 + 12 | 0;
 if (!(HEAP8[i1 >> 0] & 1)) i1 = i1 + 1 | 0; else i1 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i1;
 _printf(162624, i4 | 0) | 0;
 _putchar(10) | 0;
 _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE5do_inERS1_PKcS5_RS5_PDiS7_RS7_(i5, i1, i2, i3, i4, i6, i7, i8) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i10 = i5 + 4 | 0;
 i9 = i5;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i9 >> 2] = i6;
 i1 = __ZNSt3__1L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i2, i3, i10, i6, i7, i9, 1114111, 0) | 0;
 HEAP32[i4 >> 2] = i2 + ((HEAP32[i10 >> 2] | 0) - i2);
 HEAP32[i8 >> 2] = i6 + ((HEAP32[i9 >> 2] | 0) - i6 >> 2 << 2);
 STACKTOP = i5;
 return i1 | 0;
}

function _memcpy(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((i2 | 0) >= 4096) return _emscripten_memcpy_big(i1 | 0, i4 | 0, i2 | 0) | 0;
 i3 = i1 | 0;
 if ((i1 & 3) == (i4 & 3)) {
  while (i1 & 3) {
   if (!i2) return i3 | 0;
   HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i4 = i4 + 1 | 0;
   i2 = i2 - 1 | 0;
  }
  while ((i2 | 0) >= 4) {
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   i1 = i1 + 4 | 0;
   i4 = i4 + 4 | 0;
   i2 = i2 - 4 | 0;
  }
 }
 while ((i2 | 0) > 0) {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i4 = i4 + 1 | 0;
  i2 = i2 - 1 | 0;
 }
 return i3 | 0;
}

function ___divdi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i2 >> 31 | ((i2 | 0) < 0 ? -1 : 0) << 1;
 i9 = ((i2 | 0) < 0 ? -1 : 0) >> 31 | ((i2 | 0) < 0 ? -1 : 0) << 1;
 i6 = i4 >> 31 | ((i4 | 0) < 0 ? -1 : 0) << 1;
 i5 = ((i4 | 0) < 0 ? -1 : 0) >> 31 | ((i4 | 0) < 0 ? -1 : 0) << 1;
 i8 = _i64Subtract(i10 ^ i1, i9 ^ i2, i10, i9) | 0;
 i7 = tempRet0;
 i2 = i6 ^ i10;
 i1 = i5 ^ i9;
 i1 = _i64Subtract((___udivmoddi4(i8, i7, _i64Subtract(i6 ^ i3, i5 ^ i4, i6, i5) | 0, tempRet0, 0) | 0) ^ i2, tempRet0 ^ i1, i2, i1) | 0;
 return i1 | 0;
}

function __ZNSt3__111__stdoutbufIwEC2EP8_IO_FILEP11__mbstate_t(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEEC2Ev(i3);
 HEAP32[i3 >> 2] = 957136;
 HEAP32[i3 + 32 >> 2] = i1;
 __ZNSt3__16localeC2ERKS0_(i5, i3 + 4 | 0);
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i5, 960800) | 0;
 __ZNSt3__16localeD2Ev(i5);
 HEAP32[i3 + 36 >> 2] = i1;
 HEAP32[i3 + 40 >> 2] = i2;
 HEAP8[i3 + 44 >> 0] = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1) | 0) & 1;
 STACKTOP = i4;
 return;
}

function __ZNSt3__111__stdoutbufIcEC2EP8_IO_FILEP11__mbstate_t(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i3);
 HEAP32[i3 >> 2] = 957392;
 HEAP32[i3 + 32 >> 2] = i1;
 __ZNSt3__16localeC2ERKS0_(i5, i3 + 4 | 0);
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i5, 960792) | 0;
 __ZNSt3__16localeD2Ev(i5);
 HEAP32[i3 + 36 >> 2] = i1;
 HEAP32[i3 + 40 >> 2] = i2;
 HEAP8[i3 + 44 >> 0] = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1) | 0) & 1;
 STACKTOP = i4;
 return;
}

function __ZN2cv4UMatD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 i1 = i3 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 0 ? (i5 = i2 + 8 | 0, i2 = HEAP32[i5 >> 2] | 0, HEAP32[i5 >> 2] = i2 + -1, (i2 | 0) == 1) : 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] & 127](i5, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[HEAP32[i3 + 32 >> 2] >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i3 + 36 >> 2] | 0;
 if ((i1 | 0) == (i3 + 40 | 0)) {
  STACKTOP = i4;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i4;
 return;
}

function __ZN7testing8internal17TestEventRepeater25OnEnvironmentsTearDownEndERKNS_8UnitTestE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) <= 0) {
  STACKTOP = i5;
  return;
 }
 i1 = i1 >> 2;
 while (1) {
  i1 = i1 + -1 | 0;
  i2 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] & 127](i2, i4);
  if ((i1 | 0) <= 0) break;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 STACKTOP = i5;
 return;
}

function __ZN2cv17CommandLineParserD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 i4 = (HEAP32[i1 >> 2] | 0) + 48 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + -1;
 if ((i3 | 0) != 1) {
  STACKTOP = i2;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 __ZNSt3__113__vector_baseIN2cv23CommandLineParserParamsENS_9allocatorIS2_EEED2Ev(i1 + 36 | 0);
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 20 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN7testing8internal8FilePath13GetCurrentDirEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 4112 | 0;
 i4 = i2 + 12 | 0;
 i3 = i2;
 _memset(i4 | 0, 0, 4097) | 0;
 i5 = (_getcwd(i4 | 0, 4097) | 0) == 0;
 i4 = i5 ? 159968 : i4;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i4, _strlen(i4 | 0) | 0);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1, i3);
 __ZN7testing8internal8FilePath9NormalizeEv(i1);
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZN7testing8internal17TestEventRepeater22OnEnvironmentsSetUpEndERKNS_8UnitTestE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) <= 0) {
  STACKTOP = i5;
  return;
 }
 i1 = i1 >> 2;
 while (1) {
  i1 = i1 + -1 | 0;
  i2 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] & 127](i2, i4);
  if ((i1 | 0) <= 0) break;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 STACKTOP = i5;
 return;
}

function __ZL14icvXMLWriteIntP13CvFileStoragePKci(i5, i6, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i2 = i7 + 23 | 0;
 HEAP8[i2 >> 0] = 0;
 i3 = (i4 | 0) > -1 ? i4 : 0 - i4 | 0;
 while (1) {
  i8 = i3;
  i3 = (i3 >>> 0) / 10 | 0;
  i1 = i2 + -1 | 0;
  HEAP8[i1 >> 0] = i8 + 48 + (Math_imul(i3, -10) | 0);
  if (i8 >>> 0 <= 9) break; else i2 = i1;
 }
 if ((i4 | 0) < 0) {
  i1 = i2 + -2 | 0;
  HEAP8[i1 >> 0] = 45;
 }
 __ZL17icvXMLWriteScalarP13CvFileStoragePKcS2_i(i5, i6, i1, _strlen(i1 | 0) | 0);
 STACKTOP = i7;
 return;
}

function _strtol(i5, i4, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = 0;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i3 + 44 >> 2] = i5;
 if ((i5 | 0) < 0) HEAP32[i3 + 8 >> 2] = -1; else HEAP32[i3 + 8 >> 2] = i5 + 2147483647;
 HEAP32[i3 + 76 >> 2] = -1;
 ___shlim(i3, 0);
 i1 = ___intscan(i3, i1, 1, -2147483648, 0) | 0;
 if (!i4) {
  STACKTOP = i6;
  return i1 | 0;
 }
 HEAP32[i4 >> 2] = i5 + ((HEAP32[i2 >> 2] | 0) + (HEAP32[i3 + 108 >> 2] | 0) - (HEAP32[i3 + 8 >> 2] | 0));
 STACKTOP = i6;
 return i1 | 0;
}

function __ZL15icvReleaseGraphPPv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i4;
 if (i2) {
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i4;
  return;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i3 = (__ZN2cv6String8allocateEj(i1, 19) | 0) + 0 | 0;
 i5 = 11016 | 0;
 i6 = i3 + 19 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i5 = i5 + 1 | 0;
 } while ((i3 | 0) < (i6 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 13304, 8960, 4393);
 __ZN2cv6String10deallocateEv(i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN7testing8internal17TestEventRepeater16OnTestProgramEndERKNS_8UnitTestE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) <= 0) {
  STACKTOP = i5;
  return;
 }
 i1 = i1 >> 2;
 while (1) {
  i1 = i1 + -1 | 0;
  i2 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] & 127](i2, i4);
  if ((i1 | 0) <= 0) break;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 STACKTOP = i5;
 return;
}

function __ZL13icvReleaseSeqPPv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i4;
 if (i2) {
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i4;
  return;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i3 = (__ZN2cv6String8allocateEj(i1, 19) | 0) + 0 | 0;
 i5 = 11016 | 0;
 i6 = i3 + 19 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i5 = i5 + 1 | 0;
 } while ((i3 | 0) < (i6 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 13840, 8960, 3979);
 __ZN2cv6String10deallocateEv(i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN2cv4cuda6GpuMat5setToENS_7Scalar_IdEERKNS_11_InputArrayERNS0_6StreamE(i6, i3, i1, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i3, 44) | 0) + 0 | 0;
 i4 = 8816 | 0;
 i5 = i2 + 44 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i2 | 0) < (i5 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-216, i3, 8864, 8880, 87);
 __ZN2cv6String10deallocateEv(i3);
 STACKTOP = i1;
 return i6 | 0;
}

function __ZNSt3__18ios_base5clearEj(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5;
 i2 = (HEAP32[i4 + 24 >> 2] | 0) == 0;
 if (i2) HEAP32[i4 + 16 >> 2] = i3 | 1; else HEAP32[i4 + 16 >> 2] = i3;
 if (!((i2 & 1 | i3) & HEAP32[i4 + 20 >> 2])) {
  STACKTOP = i5;
  return;
 } else {
  i2 = ___cxa_allocate_exception(16) | 0;
  __ZNSt3__117iostream_categoryEv() | 0;
  i3 = i1;
  HEAP32[i3 >> 2] = 1;
  HEAP32[i3 + 4 >> 2] = 958224;
  __ZNSt3__18ios_base7failureC2EPKcRKNS_10error_codeE(i2, 958280, i1);
  ___cxa_throw(i2 | 0, 958328, 263);
 }
}

function __ZN7testing8internal17TestEventRepeater13OnTestCaseEndERKNS_8TestCaseE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) <= 0) {
  STACKTOP = i5;
  return;
 }
 i1 = i1 >> 2;
 while (1) {
  i1 = i1 + -1 | 0;
  i2 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 127](i2, i4);
  if ((i1 | 0) <= 0) break;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 STACKTOP = i5;
 return;
}

function __ZTv0_n12_NSt3__118basic_stringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0;
 HEAP32[i1 + i5 >> 2] = 2620;
 i3 = i1 + (i5 + 64) | 0;
 HEAP32[i3 >> 2] = 2660;
 HEAP32[i1 + (i5 + 8) >> 2] = 2640;
 i4 = i1 + (i5 + 12) | 0;
 HEAP32[i4 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + (i5 + 44) | 0);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i4);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZN7testing8internal17TestEventRepeater9OnTestEndERKNS_8TestInfoE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) <= 0) {
  STACKTOP = i5;
  return;
 }
 i1 = i1 >> 2;
 while (1) {
  i1 = i1 + -1 | 0;
  i2 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] & 127](i2, i4);
  if ((i1 | 0) <= 0) break;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 STACKTOP = i5;
 return;
}

function __ZNKSt3__15ctypeIwE5do_isEPKwS3_Pt(i1, i7, i6, i2) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 if ((i7 | 0) == (i6 | 0)) {
  i1 = i7;
  STACKTOP = i5;
  return i1 | 0;
 }
 i4 = ((i6 + -4 - i7 | 0) >>> 2) + 1 | 0;
 i3 = i7;
 while (1) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 >>> 0 < 128) i1 = HEAP16[(__ZNSt3__15ctypeIcE13classic_tableEv() | 0) + (i1 << 1) >> 1] | 0; else i1 = 0;
  HEAP16[i2 >> 1] = i1;
  i3 = i3 + 4 | 0;
  if ((i3 | 0) == (i6 | 0)) break; else i2 = i2 + 2 | 0;
 }
 i1 = i7 + (i4 << 2) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function _strncmp(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 if (!i2) {
  i1 = 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 i3 = HEAP8[i4 >> 0] | 0;
 L4 : do if (!(i3 << 24 >> 24)) i3 = 0; else while (1) {
  i2 = i2 + -1 | 0;
  i6 = HEAP8[i1 >> 0] | 0;
  if (!(i6 << 24 >> 24 != 0 & (i2 | 0) != 0 & i3 << 24 >> 24 == i6 << 24 >> 24)) break L4;
  i4 = i4 + 1 | 0;
  i1 = i1 + 1 | 0;
  i3 = HEAP8[i4 >> 0] | 0;
  if (!(i3 << 24 >> 24)) {
   i3 = 0;
   break;
  }
 } while (0);
 i1 = (i3 & 255) - (HEAPU8[i1 >> 0] | 0) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNKSt3__110__time_put8__do_putEPcRS1_PK2tmcc(i9, i5, i6, i7, i3, i4) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i10;
 HEAP8[i8 >> 0] = 37;
 i1 = i8 + 1 | 0;
 HEAP8[i1 >> 0] = i3;
 i2 = i8 + 2 | 0;
 HEAP8[i2 >> 0] = i4;
 HEAP8[i8 + 3 >> 0] = 0;
 if (i4 << 24 >> 24) {
  HEAP8[i1 >> 0] = i4;
  HEAP8[i2 >> 0] = i3;
 }
 HEAP32[i6 >> 2] = i5 + (_strftime_l(i5 | 0, (HEAP32[i6 >> 2] | 0) - i5 | 0, i8 | 0, i7 | 0, HEAP32[i9 >> 2] | 0) | 0);
 STACKTOP = i10;
 return;
}

function __ZNK2cv16SunRasterDecoder10newDecoderEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 i5 = __Znwj(1172) | 0;
 __ZN2cv16SunRasterDecoderC2Ev(i5);
 i1 = __Znwj(16) | 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i1 >> 2] = 178560;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + -1;
 if ((i3 | 0) != 1) {
  STACKTOP = i2;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i2;
 return;
}

function __ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i5, i3, i2, i1, i4, i6) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 i7 = STACKTOP;
 if ((i5 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) {
  __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i(0, i3, i2, i1, i4);
  STACKTOP = i7;
  return;
 } else {
  i5 = HEAP32[i5 + 8 >> 2] | 0;
  FUNCTION_TABLE_viiiiii[HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] & 31](i5, i3, i2, i1, i4, i6);
  STACKTOP = i7;
  return;
 }
}

function __ZNSt3__110__stdinbufIwE5imbueERKNS_6localeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 i5 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960800) | 0;
 i4 = i2 + 36 | 0;
 HEAP32[i4 >> 2] = i5;
 i1 = i2 + 44 | 0;
 HEAP32[i1 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] & 127](i5) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 HEAP8[i2 + 53 >> 0] = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] & 127](i4) | 0) & 1;
 if ((HEAP32[i1 >> 2] | 0) > 8) __ZNSt3__121__throw_runtime_errorEPKc(957344); else {
  STACKTOP = i3;
  return;
 }
}

function __ZNSt3__110__stdinbufIcE5imbueERKNS_6localeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 i5 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960792) | 0;
 i4 = i2 + 36 | 0;
 HEAP32[i4 >> 2] = i5;
 i1 = i2 + 44 | 0;
 HEAP32[i1 >> 2] = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] & 127](i5) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 HEAP8[i2 + 53 >> 0] = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] & 127](i4) | 0) & 1;
 if ((HEAP32[i1 >> 2] | 0) > 8) __ZNSt3__121__throw_runtime_errorEPKc(957344); else {
  STACKTOP = i3;
  return;
 }
}

function __ZN2cv3ogl6Buffer6createEiiiNS1_6TargetEb(i6, i4, i5, i3, i1, i2) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i1, 46) | 0) + 0 | 0;
 i4 = 18304 | 0;
 i5 = i2 + 46 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i2 | 0) < (i5 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-218, i1, 18352, 18248, 58);
 __ZN2cv6String10deallocateEv(i1);
 STACKTOP = i3;
 return;
}

function _gzclose_r(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 if (!i1) {
  i1 = -2;
  STACKTOP = i2;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 12 >> 2] | 0) != 7247) {
  i1 = -2;
  STACKTOP = i2;
  return i1 | 0;
 }
 if (HEAP32[i1 + 24 >> 2] | 0) {
  _inflateEnd(i1 + 84 | 0) | 0;
  _free(HEAP32[i1 + 36 >> 2] | 0);
  _free(HEAP32[i1 + 32 >> 2] | 0);
 }
 i3 = (HEAP32[i1 + 76 >> 2] | 0) == -5 ? -5 : 0;
 _gz_error(i1, 0, 0);
 _free(HEAP32[i1 + 20 >> 2] | 0);
 i4 = _close(HEAP32[i1 + 16 >> 2] | 0) | 0;
 _free(i1);
 i1 = (i4 | 0) != 0 ? -1 : i3;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__114__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 i2 = HEAP32[i2 + 4 >> 2] & 176;
 do if ((i2 | 0) == 16) {
  i2 = HEAP8[i1 >> 0] | 0;
  if (i2 << 24 >> 24 == 43 | i2 << 24 >> 24 == 45) {
   i1 = i1 + 1 | 0;
   break;
  }
  if ((i3 - i1 | 0) > 1 & i2 << 24 >> 24 == 48 ? (i2 = HEAP8[i1 + 1 >> 0] | 0, i2 << 24 >> 24 == 88 | i2 << 24 >> 24 == 120) : 0) i1 = i1 + 2 | 0; else i4 = 7;
 } else if ((i2 | 0) == 32) i1 = i3; else i4 = 7; while (0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 if (i1 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i2);
 if (i1 >>> 0 < 11) {
  HEAP8[i2 >> 0] = i4 << 1;
  i1 = i2 + 1 | 0;
 } else {
  i6 = i1 + 16 & -16;
  i1 = __Znwj(i6) | 0;
  HEAP32[i2 + 8 >> 2] = i1;
  HEAP32[i2 >> 2] = i6 | 1;
  HEAP32[i2 + 4 >> 2] = i4;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 if (i3 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i3 >>> 0 < 11) {
  HEAP8[i1 >> 0] = i3 << 1;
  i1 = i1 + 1 | 0;
 } else {
  i6 = i3 + 16 & -16;
  i5 = __Znwj(i6) | 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i1 >> 2] = i6 | 1;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i5;
 }
 _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __ZN2cv11WBaseStream4openERKNS_6StringE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] & 511](i2);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] & 511](i2);
 i1 = HEAP32[i1 >> 2] | 0;
 i1 = _fopen(((i1 | 0) == 0 ? 181312 : i1) | 0, 180920) | 0;
 HEAP32[i2 + 24 >> 2] = i1;
 if (!i1) {
  i1 = (i1 | 0) != 0;
  STACKTOP = i3;
  return i1 | 0;
 }
 HEAP8[i2 + 28 >> 0] = 1;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = HEAP32[i2 + 4 >> 2];
 i1 = (i1 | 0) != 0;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 if (i3 >>> 0 > 1073741807) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i3 >>> 0 < 2) {
  HEAP8[i1 >> 0] = i3 << 1;
  i1 = i1 + 4 | 0;
 } else {
  i6 = i3 + 4 & -4;
  i5 = __Znwj(i6 << 2) | 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i1 >> 2] = i6 | 1;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i5;
 }
 _wmemcpy(i1, i2, i3) | 0;
 HEAP32[i1 + (i3 << 2) >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZNK2cv10PxMDecoder10newDecoderEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 i5 = __Znwj(1168) | 0;
 __ZN2cv10PxMDecoderC2Ev(i5);
 i1 = __Znwj(16) | 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i1 >> 2] = 178328;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + -1;
 if ((i3 | 0) != 1) {
  STACKTOP = i2;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i2;
 return;
}

function __ZNK2cv10BmpDecoder10newDecoderEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 i5 = __Znwj(1168) | 0;
 __ZN2cv10BmpDecoderC2Ev(i5);
 i1 = __Znwj(16) | 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i1 >> 2] = 179016;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + -1;
 if ((i3 | 0) != 1) {
  STACKTOP = i2;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 if (i3 >>> 0 > 4294967279) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i3 >>> 0 < 11) {
  HEAP8[i1 >> 0] = i3 << 1;
  i1 = i1 + 1 | 0;
 } else {
  i6 = i3 + 16 & -16;
  i5 = __Znwj(i6) | 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i1 >> 2] = i6 | 1;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i5;
 }
 _memset(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __ZNK2cv10HdrDecoder10newDecoderEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 i5 = __Znwj(104) | 0;
 __ZN2cv10HdrDecoderC2Ev(i5);
 i1 = __Znwj(16) | 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i1 >> 2] = 178792;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + -1;
 if ((i3 | 0) != 1) {
  STACKTOP = i2;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 if (i3 >>> 0 > 1073741807) __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i3 >>> 0 < 2) {
  HEAP8[i1 >> 0] = i3 << 1;
  i1 = i1 + 4 | 0;
 } else {
  i6 = i3 + 4 & -4;
  i5 = __Znwj(i6 << 2) | 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i1 >> 2] = i6 | 1;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i5;
 }
 _wmemset(i1, i2, i3) | 0;
 HEAP32[i1 + (i3 << 2) >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN2cvL7makeKeyEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i3;
 if (!(_pthread_key_create(27024, 372) | 0)) {
  STACKTOP = i3;
  return;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i2 = (__ZN2cv6String8allocateEj(i1, 12) | 0) + 0 | 0;
 i4 = 27032 | 0;
 i5 = i2 + 12 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i2 | 0) < (i5 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-215, i1, 27048, 26776, 950);
 __ZN2cv6String10deallocateEv(i1);
 STACKTOP = i3;
 return;
}

function __ZN2cv16BaseImageEncoder14setDestinationERKNS_6StringE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 i2 = i4 + 12 | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i1 = i4 + 20 | 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i5;
  return 1;
 }
 __ZN2cv6String10deallocateEv(i2);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i1 = i1 + -4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = i1;
 HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 4 >> 2];
 i1 = i4 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return 1;
}

function __ZN6cvtestL15tsErrorCallbackEiPKcS1_S1_iPNS_2TSE(i5, i3, i1, i2, i4, i6) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i8 = i7;
 i9 = HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0;
 i5 = _cvErrorStr(i5) | 0;
 i3 = (HEAP8[i3 >> 0] | 0) != 0 ? i3 : 158168;
 HEAP32[i8 >> 2] = i5;
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = i3;
 HEAP32[i8 + 12 >> 2] = i2;
 HEAP32[i8 + 16 >> 2] = i4;
 FUNCTION_TABLE_viiii[i9 & 63](i6, 2, 159208, i8);
 STACKTOP = i7;
 return 0;
}

function __ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 i1 = HEAP8[i2 >> 0] | 0;
 if (!(i1 & 1)) {
  i1 = (i1 & 255) >>> 1;
  i2 = i2 + 1 | 0;
 } else {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 if (i1 >>> 0 <= i4 >>> 0) {
  i1 = -1;
  STACKTOP = i5;
  return i1 | 0;
 }
 i1 = _memchr(i2 + i4 | 0, i3 & 255, i1 - i4 | 0) | 0;
 if (!i1) {
  i1 = -1;
  STACKTOP = i5;
  return i1 | 0;
 }
 i1 = i1 - i2 | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN7CvMatNDC2ERKN2cv3MatE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 i2 = i4 + 4 | 0;
 _cvInitMatNDHeader(i5, HEAP32[i2 >> 2] | 0, HEAP32[i4 + 40 >> 2] | 0, HEAP32[i4 >> 2] & 4095, HEAP32[i4 + 16 >> 2] | 0) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i1 = HEAP32[i4 + 44 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i5 + (i3 << 3) + 24 >> 2] = HEAP32[i1 + (i3 << 2) >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i2 | 0));
 }
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | HEAP32[i4 >> 2] & 16384;
 STACKTOP = i6;
 return;
}

function __Z45gtest_Size_MatType_bitwise_not_EvalGenerator_v(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i3 = i2;
 i4 = HEAP32[23] | 0;
 HEAP32[i3 >> 2] = HEAP32[22];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i3 + 8 >> 2] = 2;
 HEAP32[i3 + 12 >> 2] = 10;
 HEAP32[i3 + 16 >> 2] = 18;
 HEAP32[i3 + 20 >> 2] = 26;
 __ZNK7testing8internal23CartesianProductHolder2INS0_11ValueArray1IN2cv5Size_IiEEEENS0_11ValueArray4IiiiiEEEcvNS0_14ParamGeneratorINSt3tr15tupleIT_T0_vvvvvvvvEEEEIS5_N4perf7MatTypeEEEv(i1, i3);
 STACKTOP = i2;
 return;
}

function _cvCreateGraph(i3, i4, i6, i2, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i7;
 if ((i4 | 0) < 68 | (i2 | 0) < 24 | (i6 | 0) < 8) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-201, i1, 40528, 39608, 2581);
  __ZN2cv6String10deallocateEv(i1);
 }
 i1 = _cvCreateSet(i3, i4, i6, i5) | 0;
 HEAP32[i1 + 64 >> 2] = _cvCreateSet(0, 64, i2, i5) | 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __Z14IsColorPaletteP12PaletteEntryi(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i3 = 1 << i1;
 L1 : do if ((i1 | 0) == 31) i1 = 0; else {
  i2 = 0;
  while (1) {
   i1 = HEAP8[i4 + (i2 << 2) >> 0] | 0;
   if (i1 << 24 >> 24 != (HEAP8[i4 + (i2 << 2) + 1 >> 0] | 0)) {
    i1 = 1;
    break L1;
   }
   if (i1 << 24 >> 24 != (HEAP8[i4 + (i2 << 2) + 2 >> 0] | 0)) {
    i1 = 1;
    break L1;
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= (i3 | 0)) {
    i1 = 0;
    break;
   }
  }
 } while (0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN2cv16FileNodeIteratorppEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 i4 = i5 + 40 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = i5 + 8 | 0;
 i3 = HEAP32[i5 + 12 >> 2] | 0;
 if ((i3 | 0) != 0 ? (i7 = i5 + 20 | 0, i3 = (HEAP32[i7 >> 2] | 0) + (HEAP32[i3 + 28 >> 2] | 0) | 0, HEAP32[i7 >> 2] = i3, i3 >>> 0 >= (HEAP32[i5 + 28 >> 2] | 0) >>> 0) : 0) {
  _cvChangeSeqBlock(i2, 1);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + -1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i4 + 8 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  HEAP8[i1 + 112 >> 0] = 0;
  STACKTOP = i5;
  return;
 } else {
  __ZdlPv(i2);
  STACKTOP = i5;
  return;
 }
}

function __ZN2cvL6cvt64sEPKxjPKhjPxjNS_5Size_IiEEPd(i9, i5, i1, i3, i2, i6, i8, i4) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i7 = 0, i10 = 0;
 i10 = STACKTOP;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i5 >>> 3;
 i5 = i6 >>> 3;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 >> 2] << 3;
 i4 = i9;
 while (1) {
  i1 = i1 + -1 | 0;
  _memcpy(i2 | 0, i4 | 0, i3 | 0) | 0;
  if (!i1) break; else {
   i4 = i4 + (i7 << 3) | 0;
   i2 = i2 + (i5 << 3) | 0;
  }
 }
 STACKTOP = i10;
 return;
}

function __ZN2cvL6cvt32sEPKijPKhjPijNS_5Size_IiEEPd(i9, i5, i1, i3, i2, i6, i8, i4) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i7 = 0, i10 = 0;
 i10 = STACKTOP;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i5 >>> 2;
 i5 = i6 >>> 2;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 >> 2] << 2;
 i4 = i9;
 while (1) {
  i1 = i1 + -1 | 0;
  _memcpy(i2 | 0, i4 | 0, i3 | 0) | 0;
  if (!i1) break; else {
   i4 = i4 + (i7 << 2) | 0;
   i2 = i2 + (i5 << 2) | 0;
  }
 }
 STACKTOP = i10;
 return;
}

function __ZN2cvL6cvt16uEPKtjPKhjPtjNS_5Size_IiEEPd(i9, i5, i1, i3, i2, i6, i8, i4) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i7 = 0, i10 = 0;
 i10 = STACKTOP;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i5 >>> 1;
 i5 = i6 >>> 1;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 >> 2] << 1;
 i4 = i9;
 while (1) {
  i1 = i1 + -1 | 0;
  _memcpy(i2 | 0, i4 | 0, i3 | 0) | 0;
  if (!i1) break; else {
   i4 = i4 + (i7 << 1) | 0;
   i2 = i2 + (i5 << 1) | 0;
  }
 }
 STACKTOP = i10;
 return;
}

function __Znwj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 i2 = (i1 | 0) == 0 ? 1 : i1;
 i1 = _malloc(i2) | 0;
 if (i1) {
  STACKTOP = i3;
  return i1 | 0;
 }
 while (1) {
  i1 = __ZSt15get_new_handlerv() | 0;
  if (!i1) {
   i2 = 4;
   break;
  }
  FUNCTION_TABLE_v[i1 & 7]();
  i1 = _malloc(i2) | 0;
  if (i1) {
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 4) {
  i1 = ___cxa_allocate_exception(4) | 0;
  HEAP32[i1 >> 2] = 968984;
  ___cxa_throw(i1 | 0, 969032, 328);
 } else if ((i2 | 0) == 5) {
  STACKTOP = i3;
  return i1 | 0;
 }
 return 0;
}

function __ZN2cv4cuda7CudaMem6createEiii(i3, i2, i1, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i3 = (__ZN2cv6String8allocateEj(i4, 44) | 0) + 0 | 0;
 i1 = 6624 | 0;
 i5 = i3 + 44 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-216, i4, 6672, 6688, 87);
 __ZN2cv6String10deallocateEv(i4);
 STACKTOP = i2;
 return;
}

function __ZN2cv4cuda6GpuMat6createEiii(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i3 = (__ZN2cv6String8allocateEj(i4, 44) | 0) + 0 | 0;
 i1 = 8816 | 0;
 i5 = i3 + 44 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-216, i4, 8864, 8880, 87);
 __ZN2cv6String10deallocateEv(i4);
 STACKTOP = i2;
 return;
}

function __ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8Iterator7CurrentEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i2 = i4 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1) {
  STACKTOP = i5;
  return i1 | 0;
 }
 i1 = __Znwj(8) | 0;
 i4 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i3 = HEAP32[i2 >> 2] | 0, (i3 | 0) != 0) : 0) __ZdlPv(i3);
 HEAP32[i2 >> 2] = i1;
 STACKTOP = i5;
 return i1 | 0;
}

function __Z15FillGrayPaletteP12PaletteEntryib(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 i4 = 1 << i2;
 i3 = i1 ? 255 : 0;
 if ((i2 | 0) == 31) {
  STACKTOP = i6;
  return;
 }
 i1 = i4 + -1 | 0;
 i2 = 0;
 do {
  i7 = (((i2 * 255 | 0) / (i1 | 0) | 0) ^ i3) & 255;
  HEAP8[i5 + (i2 << 2) + 2 >> 0] = i7;
  HEAP8[i5 + (i2 << 2) + 1 >> 0] = i7;
  HEAP8[i5 + (i2 << 2) >> 0] = i7;
  HEAP8[i5 + (i2 << 2) + 3 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 STACKTOP = i6;
 return;
}

function __ZNKSt3__15ctypeIwE10do_toupperEPwPKw(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 if ((i6 | 0) == (i5 | 0)) {
  i1 = i6;
  STACKTOP = i4;
  return i1 | 0;
 }
 i3 = ((i5 + -4 - i6 | 0) >>> 2) + 1 | 0;
 i2 = i6;
 do {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 >>> 0 < 128) i1 = HEAP32[(__ZNSt3__15ctypeIcE21__classic_upper_tableEv() | 0) + (i1 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i5 | 0));
 i1 = i6 + (i3 << 2) | 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNKSt3__15ctypeIwE10do_tolowerEPwPKw(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 if ((i6 | 0) == (i5 | 0)) {
  i1 = i6;
  STACKTOP = i4;
  return i1 | 0;
 }
 i3 = ((i5 + -4 - i6 | 0) >>> 2) + 1 | 0;
 i2 = i6;
 do {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 >>> 0 < 128) i1 = HEAP32[(__ZNSt3__15ctypeIcE21__classic_lower_tableEv() | 0) + (i1 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i5 | 0));
 i1 = i6 + (i3 << 2) | 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNKSt3__15ctypeIwE9do_narrowEPKwS3_cPc(i1, i8, i7, i6, i4) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 if ((i8 | 0) == (i7 | 0)) {
  i1 = i8;
  STACKTOP = i5;
  return i1 | 0;
 }
 i3 = ((i7 + -4 - i8 | 0) >>> 2) + 1 | 0;
 i2 = i8;
 i1 = i4;
 while (1) {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP8[i1 >> 0] = i4 >>> 0 < 128 ? i4 & 255 : i6;
  i2 = i2 + 4 | 0;
  if ((i2 | 0) == (i7 | 0)) break; else i1 = i1 + 1 | 0;
 }
 i1 = i8 + (i3 << 2) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function ___towrite(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 i1 = i2 + 74 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i4 + 255 | i4;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(i1 & 8)) {
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i2 + 28 >> 2] = i1;
  HEAP32[i2 + 20 >> 2] = i1;
  HEAP32[i2 + 16 >> 2] = i1 + (HEAP32[i2 + 48 >> 2] | 0);
  i1 = 0;
  STACKTOP = i3;
  return i1 | 0;
 } else {
  HEAP32[i2 >> 2] = i1 | 32;
  i1 = -1;
  STACKTOP = i3;
  return i1 | 0;
 }
 return 0;
}

function __ZThn8_NSt3__118basic_stringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = 2620;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = 2660;
 HEAP32[i1 + 8 >> 2] = 2640;
 i4 = i1 + 12 | 0;
 HEAP32[i4 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 44 | 0);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i4);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i3);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 if ((i4 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) {
  __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi(0, i2, i1, i3);
  STACKTOP = i5;
  return;
 } else {
  i4 = HEAP32[i4 + 8 >> 2] | 0;
  FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] & 63](i4, i2, i1, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZNSt3__18ios_base7failureC2EPKcRKNS_10error_codeE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 + 0 >> 2] = HEAP32[i6 + 0 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZNSt3__112system_errorC2ENS_10error_codeEPKc(i3, i5, i2);
 HEAP32[i3 >> 2] = 958248;
 STACKTOP = i4;
 return;
}

function _memset(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i3 = i2 + i1 | 0;
 if ((i1 | 0) >= 20) {
  i6 = i6 & 255;
  i5 = i2 & 3;
  i7 = i6 | i6 << 8 | i6 << 16 | i6 << 24;
  i4 = i3 & ~3;
  if (i5) {
   i5 = i2 + 4 - i5 | 0;
   while ((i2 | 0) < (i5 | 0)) {
    HEAP8[i2 >> 0] = i6;
    i2 = i2 + 1 | 0;
   }
  }
  while ((i2 | 0) < (i4 | 0)) {
   HEAP32[i2 >> 2] = i7;
   i2 = i2 + 4 | 0;
  }
 }
 while ((i2 | 0) < (i3 | 0)) {
  HEAP8[i2 >> 0] = i6;
  i2 = i2 + 1 | 0;
 }
 return i2 - i1 | 0;
}

function __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i7, i5, i4, i3, i6, i8) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i9 = 0;
 i9 = STACKTOP;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i2 >> 8;
 if (i2 & 1) i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + i1 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 FUNCTION_TABLE_viiiiii[HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] & 31](i7, i5, i4, i3 + i1 | 0, (i2 & 2 | 0) != 0 ? i6 : 2, i8);
 STACKTOP = i9;
 return;
}

function __ZNSt3__110__stdinbufIwEC2EP8_IO_FILEP11__mbstate_t(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEEC2Ev(i3);
 HEAP32[i3 >> 2] = 957248;
 HEAP32[i3 + 32 >> 2] = i1;
 HEAP32[i3 + 40 >> 2] = i2;
 HEAP32[i3 + 48 >> 2] = -1;
 HEAP8[i3 + 52 >> 0] = 0;
 __ZNSt3__16localeC2ERKS0_(i5, i3 + 4 | 0);
 __ZNSt3__110__stdinbufIwE5imbueERKNS_6localeE(i3, i5);
 __ZNSt3__16localeD2Ev(i5);
 STACKTOP = i4;
 return;
}

function __ZNSt3__110__stdinbufIcEC2EP8_IO_FILEP11__mbstate_t(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i3);
 HEAP32[i3 >> 2] = 957504;
 HEAP32[i3 + 32 >> 2] = i1;
 HEAP32[i3 + 40 >> 2] = i2;
 HEAP32[i3 + 48 >> 2] = -1;
 HEAP8[i3 + 52 >> 0] = 0;
 __ZNSt3__16localeC2ERKS0_(i5, i3 + 4 | 0);
 __ZNSt3__110__stdinbufIcE5imbueERKNS_6localeE(i3, i5);
 __ZNSt3__16localeD2Ev(i5);
 STACKTOP = i4;
 return;
}

function __ZNK2cv4UMat8ndoffsetEPj(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 i2 = i1 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= 0) {
  STACKTOP = i6;
  return;
 }
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i4 = 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 do {
  i7 = HEAP32[i3 + (i4 << 2) >> 2] | 0;
  i8 = (i1 >>> 0) / (i7 >>> 0) | 0;
  HEAP32[i5 + (i4 << 2) >> 2] = i8;
  i1 = i1 - (Math_imul(i8, i7) | 0) | 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (HEAP32[i2 >> 2] | 0));
 STACKTOP = i6;
 return;
}

function __ZNKSt3__15ctypeIwE11do_scan_notEtPKwS3_(i2, i4, i3, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 L1 : do if ((i3 | 0) == (i1 | 0)) i1 = i3; else {
  i2 = i3;
  do {
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 >>> 0 >= 128) {
    i1 = i2;
    break L1;
   }
   if (!((HEAP16[(__ZNSt3__15ctypeIcE13classic_tableEv() | 0) + (i3 << 1) >> 1] & i4) << 16 >> 16)) {
    i1 = i2;
    break L1;
   }
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i1 | 0));
 } while (0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN4perf10Regression3addEPNS_8TestBaseERKNSt3__112basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEERKN2cv11_InputArrayEdNS_10ERROR_TYPEE(i5, i4, i1, d2, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 if (i5) HEAP8[i5 + 176 >> 0] = 1;
 __ZN4perf10Regression8instanceEv() | 0;
 i1 = __ZN4perf10RegressionclERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERKN2cv11_InputArrayEdNS_10ERROR_TYPEE(169680, i4, i1, d2, i3) | 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN2cv16SunRasterDecoderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 __ZN2cv16BaseImageDecoderC2Ev(i1);
 HEAP32[i1 >> 2] = 179912;
 i3 = i1 + 92 | 0;
 __ZN2cv11RBaseStreamC2Ev(i3);
 HEAP32[i3 >> 2] = 181160;
 HEAP32[i1 + 1156 >> 2] = -1;
 i1 = i1 + 24 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = __ZN2cv6String8allocateEj(i1, 4) | 0;
 HEAP8[i1 >> 0] = -1788172711;
 HEAP8[i1 + 1 >> 0] = -1788172711 >> 8;
 HEAP8[i1 + 2 >> 0] = -1788172711 >> 16;
 HEAP8[i1 + 3 >> 0] = -1788172711 >> 24;
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_4cuda6StreamENS_14DefaultDeleterIS3_EEE10deleteSelfEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (i1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != 0 ? (i6 = i2 + 4 | 0, i5 = HEAP32[i6 >> 2] | 0, HEAP32[i6 >> 2] = i5 + -1, (i5 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] & 511](i2);
  __ZdlPv(i1);
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 511](i3);
 STACKTOP = i4;
 return;
}

function __ZN2cv11addWeightedERKNS_11_InputArrayEdS2_ddRKNS_12_OutputArrayEi(i6, d1, i7, d2, d5, i3, i4) {
 i6 = i6 | 0;
 d1 = +d1;
 i7 = i7 | 0;
 d2 = +d2;
 d5 = +d5;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 i9 = i8;
 HEAPF64[i9 >> 3] = d1;
 HEAPF64[i9 + 8 >> 3] = d2;
 HEAPF64[i9 + 16 >> 3] = d5;
 __ZN2cvL9arithm_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_iPPFvPKhjS7_jPhjNS_5Size_IiEEPvEbSB_i(i6, i7, i3, __ZN2cv7noArrayEv() | 0, i4, 5176, 1, i9, 8);
 STACKTOP = i8;
 return;
}

function __ZThn8_NSt3__118basic_stringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 i4 = i1 + -8 | 0;
 HEAP32[i4 >> 2] = 2620;
 i1 = i4 + 64 | 0;
 HEAP32[i1 >> 2] = 2660;
 HEAP32[i4 + 8 >> 2] = 2640;
 i3 = i4 + 12 | 0;
 HEAP32[i3 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i4 + 44 | 0);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i3);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv8multiplyERKNS_11_InputArrayES2_RKNS_12_OutputArrayEdi(i4, i5, i1, d3, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 d3 = +d3;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i6;
 HEAPF64[i8 >> 3] = d3;
 i9 = __ZN2cv7noArrayEv() | 0;
 i7 = +Math_abs(+(d3 + -1.0)) < 2.220446049250313e-16;
 __ZN2cvL9arithm_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_iPPFvPKhjS7_jPhjNS_5Size_IiEEPvEbSB_i(i4, i5, i1, i9, i2, 5272, 1, i8, i7 ? 4 : 5);
 STACKTOP = i6;
 return;
}

function __ZNK2cv8FileNode4nameEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (((i1 | 0) != 0 ? (HEAP32[i1 >> 2] & 64 | 0) != 0 : 0) ? (i2 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + 8 >> 2] | 0, (i2 | 0) != 0) : 0) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i1 = _strlen(i2 | 0) | 0;
  _memcpy(__ZN2cv6String8allocateEj(i3, i1) | 0, i2 | 0, i1 | 0) | 0;
  STACKTOP = i4;
  return;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZNSt3__113__vector_baseINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = i4 + 4 | 0;
 while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (i1 | 0)) break;
  i3 = i3 + -12 | 0;
  HEAP32[i2 >> 2] = i3;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3);
 }
 __ZdlPv(HEAP32[i4 >> 2] | 0);
 STACKTOP = i5;
 return;
}

function _wmemmove(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0;
 i5 = STACKTOP;
 i2 = (i1 | 0) == 0;
 if (i4 - i3 >> 2 >>> 0 < i1 >>> 0) {
  if (!i2) do {
   i1 = i1 + -1 | 0;
   HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i3 + (i1 << 2) >> 2];
  } while ((i1 | 0) != 0);
 } else if (!i2) {
  i2 = i3;
  i3 = i4;
  while (1) {
   i1 = i1 + -1 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   if (!i1) break; else {
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   }
  }
 }
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 if ((i4 | 0) == (i2 | 0)) {
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = HEAP8[i2 >> 0] | 0;
 if (!(i1 & 1)) {
  i3 = i2 + 1 | 0;
  i1 = (i1 & 255) >>> 1;
 } else {
  i3 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i4, i3, i1) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i6, i4, i3, i5, i7) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i8 = 0;
 i8 = STACKTOP;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i2 >> 8;
 if (i2 & 1) i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + i1 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 FUNCTION_TABLE_viiiii[HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] & 31](i6, i4, i3 + i1 | 0, (i2 & 2 | 0) != 0 ? i5 : 2, i7);
 STACKTOP = i8;
 return;
}

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 if (i2 >>> 0 > 1073741823) __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i3);
 i1 = i3 + 128 | 0;
 if ((HEAP8[i1 >> 0] | 0) == 0 & i2 >>> 0 < 29) {
  HEAP8[i1 >> 0] = 1;
  i1 = i3 + 16 | 0;
 } else i1 = __Znwj(i2 << 2) | 0;
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 8 >> 2] = i1 + (i2 << 2);
 STACKTOP = i4;
 return;
}

function __ZN2cv10fastMallocEj(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i5;
 i1 = i5 + 8 | 0;
 i2 = _malloc(i3 + 20 | 0) | 0;
 if (!i2) {
  HEAP32[i4 >> 2] = i3;
  __ZN2cv6formatEPKcz(i1, 6768, i4);
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-4, i1, 6800, 6824, 52);
  __ZN2cv6String10deallocateEv(i1);
  i1 = 0;
  STACKTOP = i5;
  return i1 | 0;
 } else {
  i1 = i2 + 19 & -16;
  HEAP32[i1 + -4 >> 2] = i2;
  STACKTOP = i5;
  return i1 | 0;
 }
 return 0;
}

function _rint(d2) {
 d2 = +d2;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 HEAPF64[tempDoublePtr >> 3] = d2;
 i1 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = i1 & 2146435072;
 if (i4 >>> 0 > 1126170624 | (i4 | 0) == 1126170624 & 0 > 0) {
  STACKTOP = i3;
  return +d2;
 }
 i1 = (i1 | 0) < 0;
 if (i1) d2 = d2 + -4503599627370496.0 + 4503599627370496.0; else d2 = d2 + 4503599627370496.0 + -4503599627370496.0;
 if (!(d2 == 0.0)) {
  STACKTOP = i3;
  return +d2;
 }
 d2 = i1 ? -0.0 : 0.0;
 STACKTOP = i3;
 return +d2;
}

function __ZN2cv4readERKNS_8FileNodeERff(i2, i4, f1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 do if (i3) {
  i2 = HEAP32[i3 >> 2] & 7;
  if ((i2 | 0) == 1) {
   f1 = Math_fround(HEAP32[i3 + 8 >> 2] | 0);
   break;
  } else if ((i2 | 0) == 2) {
   f1 = Math_fround(+HEAPF64[i3 + 8 >> 3]);
   break;
  } else {
   f1 = Math_fround(1000000019999999998489706.0e6);
   break;
  }
 } while (0);
 HEAPF32[i4 >> 2] = f1;
 STACKTOP = i5;
 return;
}

function __ZNSt3__118basic_stringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 2620;
 HEAP32[i1 + 64 >> 2] = 2660;
 HEAP32[i1 + 8 >> 2] = 2640;
 i3 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 44 | 0);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i3);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i1 + 64 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function _cvReleaseMemStorage(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i3;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 39672, 39608, 183);
  __ZN2cv6String10deallocateEv(i1);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __ZL20icvDestroyMemStorageP12CvMemStorage(i1);
 _cvFree_(i1);
 STACKTOP = i3;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 if (!(HEAP8[i1 >> 0] & 1)) {
  HEAP32[i2 + 0 >> 2] = HEAP32[i1 + 0 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  STACKTOP = i3;
  return;
 } else {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, HEAP32[i1 + 8 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
  STACKTOP = i3;
  return;
 }
}

function __ZN2cv17AlgorithmInfoDataD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 __ZN2cv6String10deallocateEv(i4 + 12 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = i4 + 4 | 0;
 while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (i1 | 0)) break;
  i6 = i3 + -44 | 0;
  HEAP32[i2 >> 2] = i6;
  __ZN2cv6String10deallocateEv(i3 + -8 | 0);
  __ZN2cv6String10deallocateEv(i6);
 }
 __ZdlPv(HEAP32[i4 >> 2] | 0);
 STACKTOP = i5;
 return;
}

function __ZN4perf8TestBase14_declareHelper3outERKN2cv17_InputOutputArrayENS0_10WarmUpTypeE(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) != (HEAP32[i1 + 40 >> 2] | 0)) {
  STACKTOP = i5;
  return i3 | 0;
 }
 __ZN4perf8TestBase12declareArrayERNSt3__16vectorINS1_4pairIiN2cv5Size_IiEEEENS1_9allocatorIS7_EEEERKNS4_17_InputOutputArrayENS0_10WarmUpTypeE(i1 + 20 | 0, i2, i4);
 STACKTOP = i5;
 return i3 | 0;
}

function __ZN2cvL5cvt8uEPKhjS1_jPhjNS_5Size_IiEEPd(i6, i9, i1, i3, i2, i8, i5, i4) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i7 = 0;
 i7 = STACKTOP;
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 } else i4 = i6;
 while (1) {
  i1 = i1 + -1 | 0;
  _memcpy(i2 | 0, i4 | 0, i3 | 0) | 0;
  if (!i1) break; else {
   i4 = i4 + i9 | 0;
   i2 = i2 + i8 | 0;
  }
 }
 STACKTOP = i7;
 return;
}

function __ZN4perf8TestBase14_declareHelper2inERKN2cv17_InputOutputArrayENS0_10WarmUpTypeE(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) != (HEAP32[i1 + 40 >> 2] | 0)) {
  STACKTOP = i5;
  return i3 | 0;
 }
 __ZN4perf8TestBase12declareArrayERNSt3__16vectorINS1_4pairIiN2cv5Size_IiEEEENS1_9allocatorIS7_EEEERKNS4_17_InputOutputArrayENS0_10WarmUpTypeE(i1 + 8 | 0, i2, i4);
 STACKTOP = i5;
 return i3 | 0;
}

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC2Ej(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 128 >> 0] = 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj(i2, i1);
 __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj(i2, i1);
 STACKTOP = i3;
 return;
}

function __ZNKSt3__15ctypeIwE10do_scan_isEtPKwS3_(i2, i4, i3, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 L1 : do if ((i3 | 0) == (i1 | 0)) i1 = i3; else {
  i2 = i3;
  do {
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 >>> 0 < 128 ? (HEAP16[(__ZNSt3__15ctypeIcE13classic_tableEv() | 0) + (i3 << 1) >> 1] & i4) << 16 >> 16 != 0 : 0) {
    i1 = i2;
    break L1;
   }
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i1 | 0));
 } while (0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i6, i4, i3, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i7 = 0;
 i7 = STACKTOP;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i2 >> 8;
 if (i2 & 1) i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + i1 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] & 63](i6, i4, i3 + i1 | 0, (i2 & 2 | 0) != 0 ? i5 : 2);
 STACKTOP = i7;
 return;
}

function _cvAlloc(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i5;
 i1 = i5 + 8 | 0;
 i2 = _malloc(i3 + 20 | 0) | 0;
 if (!i2) {
  HEAP32[i4 >> 2] = i3;
  __ZN2cv6formatEPKcz(i1, 6768, i4);
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-4, i1, 6800, 6824, 52);
  __ZN2cv6String10deallocateEv(i1);
  i1 = 0;
  STACKTOP = i5;
  return i1 | 0;
 } else {
  i1 = i2 + 19 & -16;
  HEAP32[i1 + -4 >> 2] = i2;
  STACKTOP = i5;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__113__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = i4 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 if ((i4 + 16 | 0) == (i1 | 0)) {
  HEAP8[i4 + 128 >> 0] = 0;
  STACKTOP = i5;
  return;
 } else {
  __ZdlPv(i1);
  STACKTOP = i5;
  return;
 }
}

function __ZN12_GLOBAL__N_113FormattedImpl13valueToStr16uEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 i5 = HEAP32[i1 + 88 >> 2] | 0;
 i4 = Math_imul(HEAP32[i5 >> 2] | 0, HEAP32[i1 + 112 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = HEAPU16[(HEAP32[i1 + 60 >> 2] | 0) + ((Math_imul(HEAP32[i5 + 4 >> 2] | 0, HEAP32[i1 + 116 >> 2] | 0) | 0) + i4) + (HEAP32[i1 + 120 >> 2] << 1) >> 1];
 _sprintf(i1 + 12 | 0, 7288, i3) | 0;
 STACKTOP = i2;
 return;
}

function __ZNK2cv16BaseImageDecoder14checkSignatureERKNS_6StringE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 i1 = FUNCTION_TABLE_ii[HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] & 127](i3) | 0;
 if ((HEAP32[i2 + 4 >> 2] | 0) >>> 0 < i1 >>> 0) {
  i1 = 0;
  STACKTOP = i4;
  return i1 | 0;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i3 + 24 >> 2] | 0;
 i1 = (_memcmp((i5 | 0) == 0 ? 179608 : i5, (i2 | 0) == 0 ? 179608 : i2, i1) | 0) == 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN12_GLOBAL__N_113FormattedImpl13valueToStr32sEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 i5 = HEAP32[i1 + 88 >> 2] | 0;
 i4 = Math_imul(HEAP32[i5 >> 2] | 0, HEAP32[i1 + 112 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[(HEAP32[i1 + 60 >> 2] | 0) + ((Math_imul(HEAP32[i5 + 4 >> 2] | 0, HEAP32[i1 + 116 >> 2] | 0) | 0) + i4) + (HEAP32[i1 + 120 >> 2] << 2) >> 2];
 _sprintf(i1 + 12 | 0, 7288, i3) | 0;
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_113FormattedImpl13valueToStr16sEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 i5 = HEAP32[i1 + 88 >> 2] | 0;
 i4 = Math_imul(HEAP32[i5 >> 2] | 0, HEAP32[i1 + 112 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = HEAP16[(HEAP32[i1 + 60 >> 2] | 0) + ((Math_imul(HEAP32[i5 + 4 >> 2] | 0, HEAP32[i1 + 116 >> 2] | 0) | 0) + i4) + (HEAP32[i1 + 120 >> 2] << 1) >> 1];
 _sprintf(i1 + 12 | 0, 7288, i3) | 0;
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_113FormattedImpl12valueToStr8uEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 i4 = HEAP32[i1 + 88 >> 2] | 0;
 i5 = Math_imul(HEAP32[i4 >> 2] | 0, HEAP32[i1 + 112 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = HEAPU8[(HEAP32[i1 + 60 >> 2] | 0) + (i5 + (HEAP32[i1 + 120 >> 2] | 0) + (Math_imul(HEAP32[i4 + 4 >> 2] | 0, HEAP32[i1 + 116 >> 2] | 0) | 0)) >> 0];
 _sprintf(i1 + 12 | 0, 7296, i3) | 0;
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_113FormattedImpl12valueToStr8sEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 i4 = HEAP32[i1 + 88 >> 2] | 0;
 i5 = Math_imul(HEAP32[i4 >> 2] | 0, HEAP32[i1 + 112 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = HEAP8[(HEAP32[i1 + 60 >> 2] | 0) + (i5 + (HEAP32[i1 + 120 >> 2] | 0) + (Math_imul(HEAP32[i4 + 4 >> 2] | 0, HEAP32[i1 + 116 >> 2] | 0) | 0)) >> 0];
 _sprintf(i1 + 12 | 0, 7296, i3) | 0;
 STACKTOP = i2;
 return;
}

function __ZNSt3__118basic_stringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 2620;
 HEAP32[i1 + 64 >> 2] = 2660;
 HEAP32[i1 + 8 >> 2] = 2640;
 i3 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 44 | 0);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i3);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i1 + 64 | 0);
 STACKTOP = i2;
 return;
}

function __ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8Iterator7CurrentEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i2 = i4 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1) {
  STACKTOP = i5;
  return i1 | 0;
 }
 i1 = __Znwj(4) | 0;
 HEAP32[i1 >> 2] = HEAP32[HEAP32[i4 + 8 >> 2] >> 2];
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i3 = HEAP32[i2 >> 2] | 0, (i3 | 0) != 0) : 0) __ZdlPv(i3);
 HEAP32[i2 >> 2] = i1;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN7testing8internal15TestMetaFactoryI41Size_MatType_bitwise_not_bitwise_not_TestE17CreateTestFactoryENSt3tr15tupleIN2cv5Size_IiEEN4perf7MatTypeEvvvvvvvvEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 i2 = __Znwj(16) | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = 3608;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = i1;
 STACKTOP = i3;
 return i2 | 0;
}

function dynCall_iiiiiiiiiiiiiii(i15, i1, i7, i8, i9, i10, i11, i12, i13, i14, i2, i3, i4, i5, i6) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return FUNCTION_TABLE_iiiiiiiiiiiiiii[i15 & 0](i1 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
}

function _cvSaveMemStoragePos(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i4;
 if (!((i3 | 0) != 0 & (i2 | 0) != 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 39696, 39608, 276);
  __ZN2cv6String10deallocateEv(i1);
 }
 HEAP32[i2 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 20 >> 2];
 STACKTOP = i4;
 return;
}

function __ZN2cv12RMByteStreamD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP32[i3 >> 2] = 180720;
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  _fclose(i2 | 0) | 0;
  HEAP32[i1 >> 2] = 0;
 }
 HEAP8[i3 + 32 >> 0] = 0;
 if (!(HEAP8[i3 + 4 >> 0] | 0)) {
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 511](i3);
 __ZdlPv(i3);
 STACKTOP = i4;
 return;
}

function __ZN2cv12RLByteStreamD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP32[i3 >> 2] = 180720;
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  _fclose(i2 | 0) | 0;
  HEAP32[i1 >> 2] = 0;
 }
 HEAP8[i3 + 32 >> 0] = 0;
 if (!(HEAP8[i3 + 4 >> 0] | 0)) {
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 511](i3);
 __ZdlPv(i3);
 STACKTOP = i4;
 return;
}

function __ZN2cv11RBaseStreamD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP32[i3 >> 2] = 180720;
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  _fclose(i2 | 0) | 0;
  HEAP32[i1 >> 2] = 0;
 }
 HEAP8[i3 + 32 >> 0] = 0;
 if (!(HEAP8[i3 + 4 >> 0] | 0)) {
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 511](i3);
 __ZdlPv(i3);
 STACKTOP = i4;
 return;
}

function __Z16CvtPaletteToGrayPK12PaletteEntryPhi(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 if ((i1 | 0) > 0) i3 = 0; else {
  STACKTOP = i5;
  return;
 }
 do {
  i6 = i4 + (i3 << 2) | 0;
  HEAP8[i2 + i3 >> 0] = (((HEAPU8[i6 >> 0] | 0) * 1868 | 0) + 8192 + ((HEAPU8[i6 + 1 >> 0] | 0) * 9617 | 0) + ((HEAPU8[i6 + 2 >> 0] | 0) * 4899 | 0) | 0) >>> 14;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i1 | 0));
 STACKTOP = i5;
 return;
}

function __ZNKSt3__114error_category10equivalentEiRKNS_15error_conditionE(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i5;
 FUNCTION_TABLE_viii[HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] & 63](i1, i4, i2);
 if ((HEAP32[i1 + 4 >> 2] | 0) != (HEAP32[i3 + 4 >> 2] | 0)) {
  i1 = 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 >> 2] | 0) == (HEAP32[i3 >> 2] | 0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt3__18ios_base4initEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP32[i2 + 24 >> 2] = i1;
 HEAP32[i2 + 16 >> 2] = (i1 | 0) == 0 & 1;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 4098;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 6;
 i3 = i2 + 28 | 0;
 i2 = i2 + 32 | 0;
 i1 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i1 | 0));
 __ZNSt3__16localeC2Ev(i3);
 STACKTOP = i4;
 return;
}

function __ZN7testing8UnitTest11GetInstanceEv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 if (HEAP8[163744] | 0) {
  STACKTOP = i1;
  return 163728;
 }
 if (!(___cxa_guard_acquire(163744) | 0)) {
  STACKTOP = i1;
  return 163728;
 }
 HEAP32[40932] = 163936;
 i2 = __Znwj(216) | 0;
 __ZN7testing8internal12UnitTestImplC2EPNS_8UnitTestE(i2, 163728);
 HEAP32[40934] = i2;
 ___cxa_atexit(136, 163728, ___dso_handle | 0) | 0;
 ___cxa_guard_release(163744);
 STACKTOP = i1;
 return 163728;
}

function __ZN2cvL10absdiff64fEPKdjS1_jPdjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp64IdNS_9OpAbsDiffIdEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL10absdiff32sEPKijS1_jPijNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp32IiNS_9OpAbsDiffIiEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL10absdiff32fEPKfjS1_jPfjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp32IfNS_9OpAbsDiffIfEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cv11TiffEncoderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 __ZN2cv16BaseImageEncoderC2Ev(i1);
 HEAP32[i1 >> 2] = 180576;
 i2 = i1 + 4 | 0;
 __ZN2cv6String10deallocateEv(i2);
 i2 = (__ZN2cv6String8allocateEj(i2, 25) | 0) + 0 | 0;
 i4 = 180616 | 0;
 i5 = i2 + 25 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i2 | 0) < (i5 | 0));
 HEAP8[i1 + 24 >> 0] = 1;
 STACKTOP = i3;
 return;
}

function _cvGetImageCOI(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i3;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-9, i1, 43312, 40912, 3103);
  __ZN2cv6String10deallocateEv(i1);
 }
 i1 = HEAP32[i2 + 48 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  STACKTOP = i3;
  return i1 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN2cvL10absdiff16uEPKtjS1_jPtjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpItNS_9OpAbsDiffItEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL10absdiff16sEPKsjS1_jPsjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIsNS_9OpAbsDiffIsEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cv10PxMEncoderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 __ZN2cv16BaseImageEncoderC2Ev(i1);
 HEAP32[i1 >> 2] = 179696;
 i2 = i1 + 4 | 0;
 __ZN2cv6String10deallocateEv(i2);
 i2 = (__ZN2cv6String8allocateEj(i2, 53) | 0) + 0 | 0;
 i4 = 179736 | 0;
 i5 = i2 + 53 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i2 | 0) < (i5 | 0));
 HEAP8[i1 + 24 >> 0] = 1;
 STACKTOP = i3;
 return;
}

function __ZN2cv10BmpEncoderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 __ZN2cv16BaseImageEncoderC2Ev(i1);
 HEAP32[i1 >> 2] = 179176;
 i2 = i1 + 4 | 0;
 __ZN2cv6String10deallocateEv(i2);
 i2 = (__ZN2cv6String8allocateEj(i2, 28) | 0) + 0 | 0;
 i4 = 179216 | 0;
 i5 = i2 + 28 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i2 | 0) < (i5 | 0));
 HEAP8[i1 + 24 >> 0] = 1;
 STACKTOP = i3;
 return;
}

function __ZNKSt3__15ctypeIcE10do_toupperEPcPKc(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 if ((i3 | 0) == (i1 | 0)) {
  i1 = i3;
  STACKTOP = i4;
  return i1 | 0;
 }
 do {
  i2 = HEAP8[i3 >> 0] | 0;
  if (i2 << 24 >> 24 > -1) i2 = HEAP32[(__ZNSt3__15ctypeIcE21__classic_upper_tableEv() | 0) + (i2 << 24 >> 24 << 2) >> 2] & 255;
  HEAP8[i3 >> 0] = i2;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i1 | 0));
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNKSt3__15ctypeIcE10do_tolowerEPcPKc(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 if ((i3 | 0) == (i1 | 0)) {
  i1 = i3;
  STACKTOP = i4;
  return i1 | 0;
 }
 do {
  i2 = HEAP8[i3 >> 0] | 0;
  if (i2 << 24 >> 24 > -1) i2 = HEAP32[(__ZNSt3__15ctypeIcE21__classic_lower_tableEv() | 0) + (i2 << 24 >> 24 << 2) >> 2] & 255;
  HEAP8[i3 >> 0] = i2;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i1 | 0));
 STACKTOP = i4;
 return i1 | 0;
}

function _strcmp(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i3 = HEAP8[i4 >> 0] | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 if (i3 << 24 >> 24 == 0 ? 1 : i3 << 24 >> 24 != i1 << 24 >> 24) i2 = i3; else {
  do {
   i4 = i4 + 1 | 0;
   i2 = i2 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   i1 = HEAP8[i2 >> 0] | 0;
  } while (!(i3 << 24 >> 24 == 0 ? 1 : i3 << 24 >> 24 != i1 << 24 >> 24));
  i2 = i3;
 }
 STACKTOP = i5;
 return (i2 & 255) - (i1 & 255) | 0;
}

function __ZN2cvL9absdiff8uEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIhNS_9OpAbsDiffIhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL9absdiff8sEPKajS1_jPajNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIaNS_9OpAbsDiffIaEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP8[i3 >> 0] = 0;
 HEAP32[i3 + 4 >> 2] = i2;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0;
 if (HEAP32[i2 + (i1 + 16) >> 2] | 0) {
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i2 + (i1 + 72) >> 2] | 0;
 if (i1) __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv(i1) | 0;
 HEAP8[i3 >> 0] = 1;
 STACKTOP = i4;
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP8[i3 >> 0] = 0;
 HEAP32[i3 + 4 >> 2] = i2;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0;
 if (HEAP32[i2 + (i1 + 16) >> 2] | 0) {
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i2 + (i1 + 72) >> 2] | 0;
 if (i1) __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i1) | 0;
 HEAP8[i3 >> 0] = 1;
 STACKTOP = i4;
 return;
}

function _memcmp(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 L1 : do if (!i1) i1 = 0; else {
  while (1) {
   i3 = HEAP8[i2 >> 0] | 0;
   i4 = HEAP8[i5 >> 0] | 0;
   if (i3 << 24 >> 24 != i4 << 24 >> 24) break;
   i1 = i1 + -1 | 0;
   if (!i1) {
    i1 = 0;
    break L1;
   } else {
    i2 = i2 + 1 | 0;
    i5 = i5 + 1 | 0;
   }
  }
  i1 = (i3 & 255) - (i4 & 255) | 0;
 } while (0);
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__18ios_base16__call_callbacksENS0_5eventE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 i1 = HEAP32[i5 + 40 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i2 = i5 + 32 | 0;
 i3 = i5 + 36 | 0;
 do {
  i1 = i1 + -1 | 0;
  FUNCTION_TABLE_viii[HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] & 63](i4, i5, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
 } while ((i1 | 0) != 0);
 STACKTOP = i6;
 return;
}

function __ZN2cvL6sub64fEPKdjS1_jPdjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp64IdNS_5OpSubIdddEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6sub32sEPKijS1_jPijNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp32IiNS_5OpSubIiiiEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6sub32fEPKfjS1_jPfjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp32IfNS_5OpSubIfffEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6add64fEPKdjS1_jPdjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp64IdNS_5OpAddIdddEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6add32sEPKijS1_jPijNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp32IiNS_5OpAddIiiiEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6add32fEPKfjS1_jPfjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp32IfNS_5OpAddIfffEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cv11RBaseStreamD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP32[i3 >> 2] = 180720;
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  _fclose(i2 | 0) | 0;
  HEAP32[i1 >> 2] = 0;
 }
 HEAP8[i3 + 32 >> 0] = 0;
 if (!(HEAP8[i3 + 4 >> 0] | 0)) {
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] & 511](i3);
 STACKTOP = i4;
 return;
}

function __ZN7testing8internal12AssertHelperC2ENS_14TestPartResult4TypeEPKciS5_(i4, i5, i1, i2, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 i7 = __Znwj(24) | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i7 + 8 >> 2] = i2;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7 + 12 | 0, i3, _strlen(i3 | 0) | 0);
 HEAP32[i4 >> 2] = i7;
 STACKTOP = i6;
 return;
}

function __ZN2cvL6sub16uEPKtjS1_jPtjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpItNS_5OpSubItttEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6sub16sEPKsjS1_jPsjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIsNS_5OpSubIsssEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6min64fEPKdjS1_jPdjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp64IdNS_5OpMinIdEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6min32sEPKijS1_jPijNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp32IiNS_5OpMinIiEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6min32fEPKfjS1_jPfjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp32IfNS_5OpMinIfEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6max64fEPKdjS1_jPdjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp64IdNS_5OpMaxIdEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6max32sEPKijS1_jPijNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp32IiNS_5OpMaxIiEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6max32fEPKfjS1_jPfjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv8vBinOp32IfNS_5OpMaxIfEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6add16uEPKtjS1_jPtjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpItNS_5OpAddItttEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6add16sEPKsjS1_jPsjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIsNS_5OpAddIsssEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function ___string_read(i6, i5, i7) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 i3 = i6 + 84 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i7 + 256 | 0;
 i2 = _memchr(i4, 0, i1) | 0;
 if (i2) i1 = i2 - i4 | 0;
 i2 = i1 >>> 0 < i7 >>> 0 ? i1 : i7;
 _memcpy(i5 | 0, i4 | 0, i2 | 0) | 0;
 HEAP32[i6 + 4 >> 2] = i4 + i2;
 i1 = i4 + i1 | 0;
 HEAP32[i6 + 8 >> 2] = i1;
 HEAP32[i3 >> 2] = i1;
 STACKTOP = i8;
 return i2 | 0;
}

function __ZN2cvL5sub8uEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIhNS_5OpSubIhhhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL5sub8sEPKajS1_jPajNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIaNS_5OpSubIaaaEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL5add8uEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIhNS_5OpAddIhhhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL5add8sEPKajS1_jPajNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIaNS_5OpAddIaaaEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6min16uEPKtjS1_jPtjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpItNS_5OpMinItEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6min16sEPKsjS1_jPsjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIsNS_5OpMinIsEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6max16uEPKtjS1_jPtjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpItNS_5OpMaxItEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL6max16sEPKsjS1_jPsjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIsNS_5OpMaxIsEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cv7PrintToERKNS_5Size_IiEEPNSt3__113basic_ostreamIcNS4_11char_traitsIcEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = __ZNSt3__124__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i1, HEAP32[i2 >> 2] | 0) | 0, 170096, 1) | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEElsEi(i1, HEAP32[i2 + 4 >> 2] | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE11do_encodingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 i1 = i1 + 8 | 0;
 i2 = _uselocale(HEAP32[i1 >> 2] | 0) | 0;
 i3 = _mbtowc(0, 0, 4) | 0;
 if (i2) _uselocale(i2 | 0) | 0;
 if (!i3) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1) {
   i1 = _uselocale(i1 | 0) | 0;
   if (!i1) i1 = 0; else {
    _uselocale(i1 | 0) | 0;
    i1 = 0;
   }
  } else i1 = 1;
 } else i1 = -1;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN2cvL5xor8uEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIhNS_5OpXorIhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL5min8uEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIhNS_5OpMinIhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL5min8sEPKajS1_jPajNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIaNS_5OpMinIaEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL5max8uEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIhNS_5OpMaxIhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL5max8sEPKajS1_jPajNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIaNS_5OpMaxIaEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cvL5and8uEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIhNS_5OpAndIhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function _vsscanf(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 i2 = i6;
 i5 = i2 + 0 | 0;
 i7 = i5 + 112 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP32[i2 + 32 >> 2] = 34;
 HEAP32[i2 + 44 >> 2] = i4;
 HEAP32[i2 + 76 >> 2] = -1;
 HEAP32[i2 + 84 >> 2] = i4;
 i1 = _MUSL_vfscanf(i2, i3, i1) | 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN2cvL4or8uEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i6, i4, i7, i2, i5, i8, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cv6vBinOpIhNS_4OpOrIhEENS_3NOPEEEvPKT_jS6_jPS4_jNS_5Size_IiEE(i3, i6, i4, i7, i2, i5, i9);
 STACKTOP = i1;
 return;
}

function __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPS1_i(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 HEAP32[i4 + 0 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 __ZN2cv15NAryMatIterator4initEPPKNS_3MatEPS1_PPhi(i4, i1, i3, 0, i2);
 STACKTOP = i5;
 return;
}

function __ZN2cv15NAryMatIteratorC2EPPKNS_3MatEPPhi(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 HEAP32[i4 + 0 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 __ZN2cv15NAryMatIterator4initEPPKNS_3MatEPS1_PPhi(i4, i1, 0, i3, i2);
 STACKTOP = i5;
 return;
}

function __ZTv0_n12_NSt3__114basic_ofstreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0;
 i3 = i1 + i5 | 0;
 HEAP32[i3 >> 2] = 177268;
 i4 = i1 + (i5 + 104) | 0;
 HEAP32[i4 >> 2] = 177288;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev(i1 + (i5 + 4) | 0);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i4);
 __ZdlPv(i3);
 STACKTOP = i2;
 return;
}

function __ZTv0_n12_NSt3__114basic_ifstreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0;
 i3 = i1 + i5 | 0;
 HEAP32[i3 >> 2] = 177684;
 i4 = i1 + (i5 + 108) | 0;
 HEAP32[i4 >> 2] = 177704;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev(i1 + (i5 + 8) | 0);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i4);
 __ZdlPv(i3);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__15ctypeIcE9do_narrowEPKcS3_cPc(i3, i4, i1, i5, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 if ((i4 | 0) == (i1 | 0)) {
  i1 = i4;
  STACKTOP = i6;
  return i1 | 0;
 } else i3 = i4;
 while (1) {
  i4 = HEAP8[i3 >> 0] | 0;
  HEAP8[i2 >> 0] = i4 << 24 >> 24 > -1 ? i4 : i5;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 + 1 | 0;
 }
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNKSt3__120__time_get_c_storageIwE3__xEv(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 if (HEAP8[961184] | 0) {
  STACKTOP = i1;
  return 961168;
 }
 if (!(___cxa_guard_acquire(961184) | 0)) {
  STACKTOP = i1;
  return 961168;
 }
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(961168, 961192, _wcslen(961192) | 0);
 ___cxa_atexit(393, 961168, ___dso_handle | 0) | 0;
 ___cxa_guard_release(961184);
 STACKTOP = i1;
 return 961168;
}

function __ZNKSt3__120__time_get_c_storageIwE3__rEv(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 if (HEAP8[961552] | 0) {
  STACKTOP = i1;
  return 961536;
 }
 if (!(___cxa_guard_acquire(961552) | 0)) {
  STACKTOP = i1;
  return 961536;
 }
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(961536, 961560, _wcslen(961560) | 0);
 ___cxa_atexit(393, 961536, ___dso_handle | 0) | 0;
 ___cxa_guard_release(961552);
 STACKTOP = i1;
 return 961536;
}

function __ZNKSt3__120__time_get_c_storageIwE3__cEv(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 if (HEAP8[961400] | 0) {
  STACKTOP = i1;
  return 961384;
 }
 if (!(___cxa_guard_acquire(961400) | 0)) {
  STACKTOP = i1;
  return 961384;
 }
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(961384, 961408, _wcslen(961408) | 0);
 ___cxa_atexit(393, 961384, ___dso_handle | 0) | 0;
 ___cxa_guard_release(961400);
 STACKTOP = i1;
 return 961384;
}

function __ZNKSt3__120__time_get_c_storageIwE3__XEv(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 if (HEAP8[961288] | 0) {
  STACKTOP = i1;
  return 961272;
 }
 if (!(___cxa_guard_acquire(961288) | 0)) {
  STACKTOP = i1;
  return 961272;
 }
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(961272, 961296, _wcslen(961296) | 0);
 ___cxa_atexit(393, 961272, ___dso_handle | 0) | 0;
 ___cxa_guard_release(961288);
 STACKTOP = i1;
 return 961272;
}

function copyTempDouble(i1) {
 i1 = i1 | 0;
 HEAP8[tempDoublePtr >> 0] = HEAP8[i1 >> 0];
 HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i1 + 1 >> 0];
 HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i1 + 2 >> 0];
 HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i1 + 3 >> 0];
 HEAP8[tempDoublePtr + 4 >> 0] = HEAP8[i1 + 4 >> 0];
 HEAP8[tempDoublePtr + 5 >> 0] = HEAP8[i1 + 5 >> 0];
 HEAP8[tempDoublePtr + 6 >> 0] = HEAP8[i1 + 6 >> 0];
 HEAP8[tempDoublePtr + 7 >> 0] = HEAP8[i1 + 7 >> 0];
}

function _cvClearSet(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i3;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN2cv6String8allocateEj(i1, 0) | 0;
  __ZN2cv5errorEiRKNS_6StringEPKcS4_i(-27, i1, 40352, 39608, 1595);
  __ZN2cv6String10deallocateEv(i1);
 }
 _cvSeqPopMulti(i2, 0, HEAP32[i2 + 24 >> 2] | 0, 0);
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8Iterator7AdvanceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
 i1 = i1 + 12 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i3;
  return;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8Iterator7AdvanceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 8;
 i1 = i1 + 12 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i3;
  return;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN2cv10BmpDecoderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 __ZN2cv16BaseImageDecoderC2Ev(i1);
 HEAP32[i1 >> 2] = 179128;
 i3 = i1 + 92 | 0;
 __ZN2cv11RBaseStreamC2Ev(i3);
 HEAP32[i3 >> 2] = 180968;
 i3 = i1 + 24 | 0;
 __ZN2cv6String10deallocateEv(i3);
 i3 = __ZN2cv6String8allocateEj(i3, 2) | 0;
 HEAP8[i3 >> 0] = 66;
 HEAP8[i3 + 1 >> 0] = 77;
 HEAP32[i1 + 1160 >> 2] = -1;
 HEAP8[i1 + 88 >> 0] = 1;
 STACKTOP = i2;
 return;
}

function __ZN2cv4readERKNS_8FileNodeERii(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 do if (i2) {
  i1 = HEAP32[i2 >> 2] & 7;
  if ((i1 | 0) == 1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   break;
  } else if ((i1 | 0) == 2) {
   i1 = _lrint(+HEAPF64[i2 + 8 >> 3]) | 0;
   break;
  } else {
   i1 = 2147483647;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function _copysign(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i5 = HEAP32[tempDoublePtr >> 2] | 0;
 i4 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 HEAPF64[tempDoublePtr >> 3] = d2;
 i4 = HEAP32[tempDoublePtr + 4 >> 2] & -2147483648 | i4 & 2147483647;
 HEAP32[tempDoublePtr >> 2] = i5;
 HEAP32[tempDoublePtr + 4 >> 2] = i4;
 d1 = +HEAPF64[tempDoublePtr >> 3];
 STACKTOP = i3;
 return +d1;
}

function __ZN7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEED0Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 944;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i4);
  STACKTOP = i5;
  return;
 }
 i2 = i4 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 __ZdlPv(i4);
 STACKTOP = i5;
 return;
}

function __ZN7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEED0Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 HEAP32[i4 >> 2] = 1536;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i4);
  STACKTOP = i5;
  return;
 }
 i2 = i4 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
 __ZdlPv(i1);
 __ZdlPv(i4);
 STACKTOP = i5;
 return;
}

function __ZN2cvL7recip8uEPKhjS1_jPhjNS_5Size_IiEEPv(i3, i6, i4, i7, i1, i5, i8, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN2cvL6recip_IhEEvPKT_jS3_jPS1_jNS_5Size_IiEEd(i4, i7, i1, i5, i6, +HEAPF64[i2 >> 3]);
 STACKTOP = i3;
 return;
}

function __ZN2cv16SunRasterEncoderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 __ZN2cv16BaseImageEncoderC2Ev(i1);
 HEAP32[i1 >> 2] = 179960;
 i1 = i1 + 4 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = (__ZN2cv6String8allocateEj(i1, 29) | 0) + 0 | 0;
 i2 = 18e4 | 0;
 i3 = i1 + 29 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 STACKTOP = i4;
 return;
}

function __ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i6, i4, i3, i2, i5, i1) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i1 = STACKTOP;
 if ((HEAP32[i4 + 8 >> 2] | 0) != (i6 | 0)) {
  STACKTOP = i1;
  return;
 }
 __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i(0, i4, i3, i2, i5);
 STACKTOP = i1;
 return;
}

function __ZN2cv4readERKNS_8FileNodeERdd(i2, i4, d1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 d1 = +d1;
 var i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 do if (i3) {
  i2 = HEAP32[i3 >> 2] & 7;
  if ((i2 | 0) == 1) {
   d1 = +(HEAP32[i3 + 8 >> 2] | 0);
   break;
  } else if ((i2 | 0) == 2) {
   d1 = +HEAPF64[i3 + 8 >> 3];
   break;
  } else {
   d1 = 1.e+300;
   break;
  }
 } while (0);
 HEAPF64[i4 >> 3] = d1;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__120__time_get_c_storageIcE3__rEv(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 if (HEAP8[961512] | 0) {
  STACKTOP = i1;
  return 961496;
 }
 if (!(___cxa_guard_acquire(961512) | 0)) {
  STACKTOP = i1;
  return 961496;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(961496, 961520, 11);
 ___cxa_atexit(377, 961496, ___dso_handle | 0) | 0;
 ___cxa_guard_release(961512);
 STACKTOP = i1;
 return 961496;
}

function __ZNKSt3__120__time_get_c_storageIcE3__cEv(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 if (HEAP8[961352] | 0) {
  STACKTOP = i1;
  return 961336;
 }
 if (!(___cxa_guard_acquire(961352) | 0)) {
  STACKTOP = i1;
  return 961336;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(961336, 961360, 20);
 ___cxa_atexit(377, 961336, ___dso_handle | 0) | 0;
 ___cxa_guard_release(961352);
 STACKTOP = i1;
 return 961336;
}

function __ZN2cv6divideERKNS_11_InputArrayES2_RKNS_12_OutputArrayEdi(i4, i5, i1, d3, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 d3 = +d3;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i6;
 HEAPF64[i7 >> 3] = d3;
 __ZN2cvL9arithm_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_iPPFvPKhjS7_jPhjNS_5Size_IiEEPvEbSB_i(i4, i5, i1, __ZN2cv7noArrayEv() | 0, i2, 5240, 1, i7, 6);
 STACKTOP = i6;
 return;
}

function __ZN2cv10HdrEncoderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 __ZN2cv16BaseImageEncoderC2Ev(i1);
 HEAP32[i1 >> 2] = 180208;
 i1 = i1 + 4 | 0;
 __ZN2cv6String10deallocateEv(i1);
 i1 = (__ZN2cv6String8allocateEj(i1, 26) | 0) + 0 | 0;
 i2 = 180248 | 0;
 i3 = i1 + 26 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 STACKTOP = i4;
 return;
}

function __ZN2cv13sorted_vectorINS_6StringEPFPNS_9AlgorithmEvEED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = i4 + 4 | 0;
 while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (i1 | 0)) break;
  i3 = i3 + -12 | 0;
  HEAP32[i2 >> 2] = i3;
  __ZN2cv6String10deallocateEv(i3);
 }
 __ZdlPv(HEAP32[i4 >> 2] | 0);
 STACKTOP = i5;
 return;
}

function __ZN2cv11RBaseStream6setPosEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 if (!(HEAP32[i2 + 20 >> 2] | 0)) {
  HEAP32[i2 + 16 >> 2] = (HEAP32[i2 + 8 >> 2] | 0) + i1;
  HEAP32[i2 + 28 >> 2] = 0;
  STACKTOP = i3;
  return;
 } else {
  i4 = (i1 | 0) % (HEAP32[i2 + 24 >> 2] | 0) | 0;
  HEAP32[i2 + 28 >> 2] = i1 - i4;
  HEAP32[i2 + 16 >> 2] = (HEAP32[i2 + 8 >> 2] | 0) + i4;
  STACKTOP = i3;
  return;
 }
}

function __GLOBAL__I_a187() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 if (((((__ZN2cvL14initInterTab2DEib(1, 0) | 0) != 0 ? (__ZN2cvL14initInterTab2DEib(1, 1) | 0) != 0 : 0) ? (__ZN2cvL14initInterTab2DEib(2, 0) | 0) != 0 : 0) ? (__ZN2cvL14initInterTab2DEib(2, 1) | 0) != 0 : 0) ? (__ZN2cvL14initInterTab2DEib(4, 0) | 0) != 0 : 0) i1 = (__ZN2cvL14initInterTab2DEib(4, 1) | 0) != 0 & 1; else i1 = 0;
 HEAP8[183144] = i1;
 STACKTOP = i2;
 return;
}

function dynCall_viiiiiiiiiiddi(i14, i1, i6, i7, i8, i9, i10, i11, i12, i13, i2, d3, d4, i5) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 i5 = i5 | 0;
 FUNCTION_TABLE_viiiiiiiiiiddi[i14 & 7](i1 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i2 | 0, +d3, +d4, i5 | 0);
}

function __ZN2cv11WBaseStream4openERNSt3__16vectorIhNS1_9allocatorIhEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] & 511](i2);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] & 511](i2);
 HEAP32[i2 + 32 >> 2] = i1;
 HEAP8[i2 + 28 >> 0] = 1;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = HEAP32[i2 + 4 >> 2];
 STACKTOP = i3;
 return 1;
}

function __ZN2cv19getBuildInformationEv() {
 var i1 = 0;
 i1 = STACKTOP;
 if (HEAP8[19584] | 0) {
  STACKTOP = i1;
  return 19576;
 }
 if (!(___cxa_guard_acquire(19584) | 0)) {
  STACKTOP = i1;
  return 19576;
 }
 HEAP32[4894] = 0;
 HEAP32[4895] = 0;
 _memcpy(__ZN2cv6String8allocateEj(19576, 5788) | 0, 19592, 5788) | 0;
 ___cxa_atexit(351, 19576, ___dso_handle | 0) | 0;
 ___cxa_guard_release(19584);
 STACKTOP = i1;
 return 19576;
}

function __ZNSt3__114__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do {
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = 0;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  i1 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 STACKTOP = i4;
 return;
}

function __ZTv0_n12_NSt3__114basic_ofstreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0;
 HEAP32[i1 + i4 >> 2] = 177268;
 i3 = i1 + (i4 + 104) | 0;
 HEAP32[i3 >> 2] = 177288;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev(i1 + (i4 + 4) | 0);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZTv0_n12_NSt3__114basic_ifstreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0;
 HEAP32[i1 + i4 >> 2] = 177684;
 i3 = i1 + (i4 + 108) | 0;
 HEAP32[i3 >> 2] = 177704;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev(i1 + (i4 + 8) | 0);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZNSt3__112__snprintf_lEPcjP15__locale_structPKcz(i5, i4, i2, i3, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = i1;
 i2 = _uselocale(i2 | 0) | 0;
 i1 = _vsnprintf(i5, i4, i3, i7) | 0;
 if (!i2) {
  STACKTOP = i6;
  return i1 | 0;
 }
 _uselocale(i2 | 0) | 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__13mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfNS_4lessIS6_EENS4_INS_4pairIKS6_fEEEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__16__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN2cv6divideEdRKNS_11_InputArrayERKNS_12_OutputArrayEi(d3, i4, i1, i2) {
 d3 = +d3;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 HEAPF64[i6 >> 3] = d3;
 __ZN2cvL9arithm_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_iPPFvPKhjS7_jPhjNS_5Size_IiEEPvEbSB_i(i4, i4, i1, __ZN2cv7noArrayEv() | 0, i2, 5208, 1, i6, 7);
 STACKTOP = i5;
 return;
}

function __ZN2cv3ipp19getIppErrorLocationEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 i6 = HEAP32[6714] | 0;
 i5 = HEAP32[6716] | 0;
 i4 = HEAP32[6712] | 0;
 HEAP32[i3 >> 2] = (i6 | 0) != 0 ? i6 : 26888;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 8 >> 2] = (i4 | 0) != 0 ? i4 : 26888;
 __ZN2cv6formatEPKcz(i1, 26872, i3);
 STACKTOP = i2;
 return;
}

function ___shlim(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 HEAP32[i3 + 104 >> 2] = i4;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 - i2 | 0;
 HEAP32[i3 + 108 >> 2] = i6;
 if ((i4 | 0) != 0 & (i6 | 0) > (i4 | 0)) {
  HEAP32[i3 + 100 >> 2] = i2 + i4;
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i3 + 100 >> 2] = i1;
  STACKTOP = i5;
  return;
 }
}

function __ZNSt3__16vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do {
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = 0;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  i1 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 STACKTOP = i4;
 return;
}

function __ZNKSt3__17collateIwE7do_hashEPKwS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 if ((i2 | 0) == (i3 | 0)) {
  i1 = 0;
  STACKTOP = i4;
  return i1 | 0;
 } else i1 = 0;
 do {
  i1 = (HEAP32[i2 >> 2] | 0) + (i1 << 4) | 0;
  i5 = i1 & -268435456;
  i1 = (i5 >>> 24 | i5) ^ i1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i3 | 0));
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 if ((HEAP32[i2 + 8 >> 2] | 0) != (i4 | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi(0, i2, i1, i3);
 STACKTOP = i5;
 return;
}

function __ZNKSt3__17collateIcE7do_hashEPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 if ((i2 | 0) == (i3 | 0)) {
  i1 = 0;
  STACKTOP = i4;
  return i1 | 0;
 } else i1 = 0;
 do {
  i1 = (HEAP8[i2 >> 0] | 0) + (i1 << 4) | 0;
  i5 = i1 & -268435456;
  i1 = (i5 >>> 24 | i5) ^ i1;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN6cvtest2TSD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP32[i3 >> 2] = 158208;
 i1 = i3 + 88 | 0;
 i2 = i3 + 136 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3 + 48 | 0);
 __ZdlPv(i3);
 STACKTOP = i4;
 return;
}

function __Z12FillGrayRow8PhS_iS_(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0;
 i6 = STACKTOP;
 if ((i4 | 0) > 0) i2 = 0; else {
  i1 = i1 + i4 | 0;
  STACKTOP = i6;
  return i1 | 0;
 }
 do {
  HEAP8[i1 + i2 >> 0] = HEAP8[i5 + (HEAPU8[i3 + i2 >> 0] | 0) >> 0] | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 i1 = i1 + i4 | 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNK2cv12_OutputArray14createSameSizeERKNS_11_InputArrayEi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i5 = i4;
 i1 = FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] & 63](i1, i5, -1) | 0;
 FUNCTION_TABLE_viiiiiii[HEAP32[(HEAP32[i3 >> 2] | 0) + 144 >> 2] & 63](i3, i1, i5, i2, -1, 0, 0);
 STACKTOP = i4;
 return;
}

function ___cxa_can_catch(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 i2 = FUNCTION_TABLE_iiii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 63](i1, i2, i3) | 0;
 i1 = i2 & 1;
 if (!i2) {
  STACKTOP = i5;
  return i1 | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt3__111__stdoutbufIwE5imbueERKNS_6localeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2) | 0;
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960800) | 0;
 HEAP32[i2 + 36 >> 2] = i1;
 HEAP8[i2 + 44 >> 0] = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1) | 0) & 1;
 STACKTOP = i3;
 return;
}

function __ZNSt3__111__stdoutbufIcE5imbueERKNS_6localeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] & 127](i2) | 0;
 i1 = __ZNKSt3__16locale9use_facetERNS0_2idE(i1, 960792) | 0;
 HEAP32[i2 + 36 >> 2] = i1;
 HEAP8[i2 + 44 >> 0] = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 127](i1) | 0) & 1;
 STACKTOP = i3;
 return;
}

function __ZN7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP32[i1 >> 2] = 944;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
 __ZdlPv(i3);
 STACKTOP = i4;
 return;
}

function __ZN7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP32[i1 >> 2] = 1536;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -8 - i3 | 0) >>> 3) << 3);
 __ZdlPv(i3);
 STACKTOP = i4;
 return;
}

function __ZN2cv11FileStorage19releaseAndGetStringEv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if ((i1 | 0) != 0 ? (HEAP32[i1 + 268 >> 2] | 0) != 0 : 0) __ZL8icvCloseP13CvFileStoragePN2cv6StringE(i1, i2);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] & 511](i3);
 STACKTOP = i4;
 return;
}

function __ZN2cv11RBaseStream8allocateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 i1 = i2 + 4 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  STACKTOP = i3;
  return;
 }
 i4 = HEAP32[i2 + 24 >> 2] | 0;
 i5 = __Znaj((i4 | 0) > -1 ? i4 : -1) | 0;
 HEAP32[i2 + 8 >> 2] = i5;
 i4 = i5 + i4 | 0;
 HEAP32[i2 + 12 >> 2] = i4;
 HEAP32[i2 + 16 >> 2] = i4;
 HEAP8[i1 >> 0] = 1;
 STACKTOP = i3;
 return;
}

function ___muldsi3(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 & 65535;
 i4 = i2 & 65535;
 i3 = Math_imul(i4, i6) | 0;
 i5 = i1 >>> 16;
 i4 = (i3 >>> 16) + (Math_imul(i4, i5) | 0) | 0;
 i2 = i2 >>> 16;
 i1 = Math_imul(i2, i6) | 0;
 return (tempRet0 = (i4 >>> 16) + (Math_imul(i2, i5) | 0) + (((i4 & 65535) + i1 | 0) >>> 16) | 0, i4 + i1 << 16 | i3 & 65535 | 0) | 0;
}

function __ZNK2cv17CommandLineParser11printErrorsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i3;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = (i1 | 0) == 0 ? 6232 : i1;
 _printf(6280, i2 | 0) | 0;
 _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZN7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8IteratorD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 HEAP32[i1 >> 2] = 1128;
 i1 = i1 + 12 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i3;
  return;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN2cv12getTickCountEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i2 + 8 | 0;
 _gettimeofday(i1 | 0, i2 | 0) | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i3 = ___muldi3(i3 | 0, ((i3 | 0) < 0) << 31 >> 31 | 0, 1e6, 0) | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = _i64Add(i3 | 0, tempRet0 | 0, i1 | 0, ((i1 | 0) < 0) << 31 >> 31 | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZSt9terminatev() {
 var i1 = 0, i2 = 0;
 i1 = ___cxa_get_globals_fast() | 0;
 if (((i1 | 0) != 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) ? (i1 = i2 + 48 | 0, (HEAP32[i1 >> 2] & -256 | 0) == 1126902528 ? (HEAP32[i1 + 4 >> 2] | 0) == 1129074247 : 0) : 0) __ZSt11__terminatePFvvE(HEAP32[i2 + 12 >> 2] | 0);
 i1 = HEAP32[242152] | 0;
 HEAP32[242152] = i1 + 0;
 __ZSt11__terminatePFvvE(i1);
}

function __ZN7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8IteratorD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 HEAP32[i1 >> 2] = 1720;
 i1 = i1 + 12 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i3;
  return;
 }
 if (__ZN7testing8internal6IsTrueEb(1) | 0 ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZNSt3__112__asprintf_lEPPcP15__locale_structPKcz(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 i2 = _uselocale(i2 | 0) | 0;
 i1 = _vasprintf(i4, i3, i6) | 0;
 if (!i2) {
  STACKTOP = i5;
  return i1 | 0;
 }
 _uselocale(i2 | 0) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN2cv11bitwise_xorERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = 193;
 __ZN2cvL9binary_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_PKPFvPKhjS7_jPhjNS_5Size_IiEEPvEbi(i1, i2, i3, i4, i6, 1, 11);
 STACKTOP = i5;
 return;
}

function __ZN6cvtest2TSD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP32[i3 >> 2] = 158208;
 i1 = i3 + 88 | 0;
 i2 = i3 + 136 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i3 + 48 | 0);
 STACKTOP = i4;
 return;
}

function __ZN2cv11bitwise_andERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = 191;
 __ZN2cvL9binary_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_PKPFvPKhjS7_jPhjNS_5Size_IiEEPvEbi(i1, i2, i3, i4, i6, 1, 9);
 STACKTOP = i5;
 return;
}

function __ZN2cv11WBaseStream5closeEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i1 = i4 + 28 | 0;
 if (HEAP8[i1 >> 0] | 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] & 511](i4);
 i2 = i4 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3) {
  _fclose(i3 | 0) | 0;
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN2cv10bitwise_orERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = 192;
 __ZN2cvL9binary_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_PKPFvPKhjS7_jPhjNS_5Size_IiEEPvEbi(i1, i2, i3, i4, i6, 1, 10);
 STACKTOP = i5;
 return;
}

function __ZNKSt3__15ctypeIwE8do_widenEPKcS3_Pw(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 if ((i4 | 0) == (i1 | 0)) {
  i1 = i4;
  STACKTOP = i5;
  return i1 | 0;
 } else i3 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP8[i3 >> 0];
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 + 4 | 0;
 }
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt3__110__sscanf_lEPKcP15__locale_structS1_z(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 i2 = _uselocale(i2 | 0) | 0;
 i1 = _vsscanf(i4, i3, i6) | 0;
 if (!i2) {
  STACKTOP = i5;
  return i1 | 0;
 }
 _uselocale(i2 | 0) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN2cv11RBaseStream5closeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  _fclose(i2 | 0) | 0;
  HEAP32[i1 >> 2] = 0;
 }
 HEAP8[i3 + 32 >> 0] = 0;
 if (HEAP8[i3 + 4 >> 0] | 0) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZNSt3__15ctypeIcEC2EPKtbj(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 HEAP32[i4 + 4 >> 2] = i1 + -1;
 HEAP32[i4 >> 2] = 960744;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP8[i4 + 12 >> 0] = i2 & 1;
 if (i3) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i1 >> 2] = __ZNSt3__15ctypeIcE13classic_tableEv() | 0;
 STACKTOP = i5;
 return;
}

function __ZN2cv3PtrINS_4cuda6StreamEED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i5 = i1 + 4 | 0, i4 = HEAP32[i5 >> 2] | 0, HEAP32[i5 >> 2] = i4 + -1, (i4 | 0) == 1) : 0) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZNK2cv10PxMDecoder14checkSignatureERKNS_6StringE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 if (((HEAP32[i3 + 4 >> 2] | 0) >>> 0 > 2 ? (i2 = HEAP32[i3 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 80) : 0) ? ((HEAP8[i2 + 1 >> 0] | 0) + -49 << 24 >> 24 & 255) < 6 : 0) i1 = (_isspace(HEAP8[i2 + 2 >> 0] | 0) | 0) != 0; else i1 = 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN2cv5MutexC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i4 = i2;
 i3 = __Znwj(28) | 0;
 _pthread_mutexattr_init(i4 | 0) | 0;
 _pthread_mutexattr_settype(i4 | 0, 1) | 0;
 _pthread_mutex_init(i3 | 0, i4 | 0) | 0;
 _pthread_mutexattr_destroy(i4 | 0) | 0;
 HEAP32[i3 + 24 >> 2] = 1;
 HEAP32[i1 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5uflowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1) {
  i1 = -1;
  STACKTOP = i2;
  return i1 | 0;
 }
 i3 = i1 + 12 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i1 + 4;
 i1 = HEAP32[i1 >> 2] | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5uflowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 if ((FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] & 127](i1) | 0) == -1) {
  i1 = -1;
  STACKTOP = i2;
  return i1 | 0;
 }
 i3 = i1 + 12 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i1 + 1;
 i1 = HEAPU8[i1 >> 0] | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN2cv12RLByteStream7getByteEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 i3 = i2 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 >= (HEAP32[i2 + 12 >> 2] | 0) >>> 0) {
  FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] & 511](i2);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i2 = HEAPU8[i1 >> 0] | 0;
 HEAP32[i3 >> 2] = i1 + 1;
 STACKTOP = i4;
 return i2 | 0;
}

function __ZNKSt3__119__iostream_category7messageEi(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 if ((i2 | 0) != 1 & (i2 | 0) < 257) {
  __ZNKSt3__112__do_message7messageEi(i1, i3, i2);
  STACKTOP = i4;
  return;
 } else {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 958184, 35);
  STACKTOP = i4;
  return;
 }
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_118CLAHE_CalcLut_BodyItLi4096ELi4EEENS_14DefaultDeleterIS4_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekposENS_4fposI11__mbstate_tEEj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 i1 = i1 + 8 | 0;
 FUNCTION_TABLE_viiiiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] & 31](i3, i4, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, 0, i2);
 STACKTOP = i5;
 return;
}

function __ZN7testing15AssertionResultC2ERKS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __Znwj(12) | 0;
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i4, i1);
  i1 = i4;
 }
 HEAP32[i2 + 4 >> 2] = i1;
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_118CLAHE_CalcLut_BodyIhLi256ELi0EEENS_14DefaultDeleterIS4_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6String10deallocateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i1 = i1 + -4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + -1;
 if ((i2 | 0) != 1) {
  STACKTOP = i3;
  return;
 }
 __ZN2cv8fastFreeEPv(i1);
 STACKTOP = i3;
 return;
}

function ___memrchr(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i3 = i2 & 255;
 i2 = i1;
 while (1) {
  if (!i2) {
   i1 = 0;
   i2 = 4;
   break;
  }
  i2 = i2 + -1 | 0;
  i1 = i4 + i2 | 0;
  if ((HEAP8[i1 >> 0] | 0) == i3 << 24 >> 24) {
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) {
  STACKTOP = i5;
  return i1 | 0;
 }
 return 0;
}

function __ZNKSt3__120__time_get_c_storageIcE3__xEv(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 if ((HEAP8[961144] | 0) == 0 ? (___cxa_guard_acquire(961144) | 0) != 0 : 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(961128, 961152, 8);
  ___cxa_atexit(377, 961128, ___dso_handle | 0) | 0;
  ___cxa_guard_release(961144);
 }
 STACKTOP = i1;
 return 961128;
}

function __ZNKSt3__120__time_get_c_storageIcE3__XEv(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 if ((HEAP8[961248] | 0) == 0 ? (___cxa_guard_acquire(961248) | 0) != 0 : 0) {
  __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(961232, 961256, 8);
  ___cxa_atexit(377, 961232, ___dso_handle | 0) | 0;
  ___cxa_guard_release(961248);
 }
 STACKTOP = i1;
 return 961232;
}

function __ZN2cv5writeERNS_11FileStorageERKNS_6StringES4_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 if (!(HEAP32[i1 + 4 >> 2] | 0)) i1 = 0; else {
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? 12512 : i1;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 _cvWriteString(HEAP32[i2 + 8 >> 2] | 0, i1, (i3 | 0) == 0 ? 12512 : i3, 0);
 STACKTOP = i4;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_124CLAHE_Interpolation_BodyItEENS_14DefaultDeleterIS4_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_124CLAHE_Interpolation_BodyIhEENS_14DefaultDeleterIS4_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv3ocl13ProgramSourceD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i3 + -1;
 if (!((i3 | 0) == 1 & (HEAP8[26720] | 0) == 0)) {
  STACKTOP = i2;
  return;
 }
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv11bitwise_notERKNS_11_InputArrayERKNS_12_OutputArrayES2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = 194;
 __ZN2cvL9binary_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_PKPFvPKhjS7_jPhjNS_5Size_IiEEPvEbi(i1, i1, i2, i3, i5, 1, 12);
 STACKTOP = i4;
 return;
}

function __ZNSt3__18ios_base4InitD2Ev(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(956152) | 0;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE5flushEv(956328) | 0;
 __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv(956504) | 0;
 __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEE5flushEv(956680) | 0;
 STACKTOP = i1;
 return;
}

function _memmove(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((i4 | 0) < (i1 | 0) & (i1 | 0) < (i4 + i2 | 0)) {
  i3 = i1;
  i4 = i4 + i2 | 0;
  i1 = i1 + i2 | 0;
  while ((i2 | 0) > 0) {
   i1 = i1 - 1 | 0;
   i4 = i4 - 1 | 0;
   i2 = i2 - 1 | 0;
   HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  }
  i1 = i3;
 } else _memcpy(i1, i4, i2) | 0;
 return i1 | 0;
}

function __ZNK2cv7TLSDataINS_11CoreTLSDataEE18createDataInstanceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 i1 = __Znwj(32) | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = -1;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN2cv3ocl5QueueC2Ev(i1 + 12 | 0);
 HEAP32[i1 + 16 >> 2] = -1;
 HEAP32[i1 + 20 >> 2] = -1;
 HEAP8[i1 + 24 >> 0] = 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __tr_init(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 + 2840 >> 2] = i1 + 148;
 HEAP32[i1 + 2848 >> 2] = 155904;
 HEAP32[i1 + 2852 >> 2] = i1 + 2440;
 HEAP32[i1 + 2860 >> 2] = 155928;
 HEAP32[i1 + 2864 >> 2] = i1 + 2684;
 HEAP32[i1 + 2872 >> 2] = 155952;
 HEAP16[i1 + 5816 >> 1] = 0;
 HEAP32[i1 + 5820 >> 2] = 0;
 _init_block(i1);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__16locale5__imp9use_facetEl(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 if (__ZNKSt3__16locale5__imp9has_facetEl(i2, i1) | 0) {
  STACKTOP = i3;
  return HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 } else {
  i1 = ___cxa_allocate_exception(4) | 0;
  __ZNSt8bad_castC2Ev(i1);
  ___cxa_throw(i1 | 0, 969544, 335);
 }
 return 0;
}

function __ZN7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8IteratorD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP32[i3 >> 2] = 1128;
 i1 = i3 + 12 | 0;
 if (((HEAP32[i1 >> 2] | 0) != 0 ? __ZN7testing8internal6IsTrueEb(1) | 0 : 0) ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) __ZdlPv(i2);
 __ZdlPv(i3);
 STACKTOP = i4;
 return;
}

function __ZN7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8IteratorD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 HEAP32[i3 >> 2] = 1720;
 i1 = i3 + 12 | 0;
 if (((HEAP32[i1 >> 2] | 0) != 0 ? __ZN7testing8internal6IsTrueEb(1) | 0 : 0) ? (i2 = HEAP32[i1 >> 2] | 0, (i2 | 0) != 0) : 0) __ZdlPv(i2);
 __ZdlPv(i3);
 STACKTOP = i4;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEEC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 957952;
 __ZNSt3__16localeC2Ev(i1 + 4 | 0);
 i1 = i1 + 8 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 957888;
 __ZNSt3__16localeC2Ev(i1 + 4 | 0);
 i1 = i1 + 8 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZNKSt3__15ctypeIcE8do_widenEPKcS3_Pc(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 if ((i4 | 0) == (i1 | 0)) i1 = i4; else {
  i3 = i4;
  while (1) {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 + 1 | 0;
  }
 }
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_116DefaultFormatterENS_14DefaultDeleterIS3_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_115PythonFormatterENS_14DefaultDeleterIS3_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_115MatlabFormatterENS_14DefaultDeleterIS3_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZNSt3__118__libcpp_refstringC2EPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 i5 = _strlen(i1 | 0) | 0;
 i4 = __Znwj(i5 + 13 | 0) | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = 0;
 i4 = i4 + 12 | 0;
 _memcpy(i4 | 0, i1 | 0, i5 + 1 | 0) | 0;
 HEAP32[i2 >> 2] = i4;
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_114NumpyFormatterENS_14DefaultDeleterIS3_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_113FormattedImplENS_14DefaultDeleterIS3_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_112CSVFormatterENS_14DefaultDeleterIS3_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function _llvm_cttz_i32(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP8[cttz_i8 + (i2 & 255) >> 0] | 0;
 if ((i1 | 0) < 8) return i1 | 0;
 i1 = HEAP8[cttz_i8 + (i2 >> 8 & 255) >> 0] | 0;
 if ((i1 | 0) < 8) return i1 + 8 | 0;
 i1 = HEAP8[cttz_i8 + (i2 >> 16 & 255) >> 0] | 0;
 if ((i1 | 0) < 8) return i1 + 16 | 0;
 return (HEAP8[cttz_i8 + (i2 >>> 24) >> 0] | 0) + 24 | 0;
}

function _llvm_ctlz_i32(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP8[ctlz_i8 + (i2 >>> 24) >> 0] | 0;
 if ((i1 | 0) < 8) return i1 | 0;
 i1 = HEAP8[ctlz_i8 + (i2 >> 16 & 255) >> 0] | 0;
 if ((i1 | 0) < 8) return i1 + 8 | 0;
 i1 = HEAP8[ctlz_i8 + (i2 >> 8 & 255) >> 0] | 0;
 if ((i1 | 0) < 8) return i1 + 16 | 0;
 return (HEAP8[ctlz_i8 + (i2 & 255) >> 0] | 0) + 24 | 0;
}

function _cvMemStorageAllocString(i2, i4, i3, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 if ((i1 | 0) <= -1) i1 = _strlen(i3 | 0) | 0;
 HEAP32[i2 >> 2] = i1;
 i4 = _cvMemStorageAlloc(i4, i1 + 1 | 0) | 0;
 HEAP32[i2 + 4 >> 2] = i4;
 _memcpy(i4 | 0, i3 | 0, i1 | 0) | 0;
 HEAP8[i4 + i1 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN2cv6detail12PtrOwnerImplI13CvFileStorageNS_14DefaultDeleterIS2_EEE10deleteSelfEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNK2cv14DefaultDeleterI13CvFileStorageEclEPS1_(i1 + 12 | 0, HEAP32[i1 + 8 >> 2] | 0);
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__16locale2id5__getEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i3;
 if ((HEAP32[i2 >> 2] | 0) != -1) {
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = 385;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__111__call_onceERVmPvPFvS2_E(i2, i1, 386);
 }
 STACKTOP = i3;
 return (HEAP32[i2 + 4 >> 2] | 0) + -1 | 0;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_110CFormatterENS_14DefaultDeleterIS3_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZL11icvCloneSeqPKv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2 + 8 | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 1073741823;
 HEAP32[i3 + 0 >> 2] = HEAP32[i4 + 0 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 i1 = _cvSeqSlice(i1, i3, 0, 1) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__18ios_baseD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 958272;
 __ZNSt3__18ios_base16__call_callbacksENS0_5eventE(i1, 0);
 __ZNSt3__16localeD2Ev(i1 + 28 | 0);
 _free(HEAP32[i1 + 32 >> 2] | 0);
 _free(HEAP32[i1 + 36 >> 2] | 0);
 _free(HEAP32[i1 + 48 >> 2] | 0);
 _free(HEAP32[i1 + 60 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN2cv5MutexD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 i5 = (HEAP32[i2 >> 2] | 0) + 24 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i4 + -1;
 if ((i4 | 0) == 1 ? (i1 = HEAP32[i2 >> 2] | 0, (i1 | 0) != 0) : 0) {
  _pthread_mutex_destroy(i1 | 0) | 0;
  __ZdlPv(i1);
 }
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN6cvtest2TS6printfEiPKcz(i4, i3, i1, i5) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i6;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i2 >> 2] = i5;
 FUNCTION_TABLE_viiii[HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] & 63](i4, i3, i1, i2);
 STACKTOP = i6;
 return;
}

function __ZN2cvL14countNonZero8uEPKhi(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i1 = 0;
 } else {
  i1 = 0;
  STACKTOP = i5;
  return i1 | 0;
 }
 do {
  i1 = ((HEAP8[i4 + i2 >> 0] | 0) != 0 & 1) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN2cv11RBaseStream7releaseEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i2 = i4 + 4 | 0;
 i1 = i4 + 8 | 0;
 if ((HEAP8[i2 >> 0] | 0) != 0 ? (i3 = HEAP32[i1 >> 2] | 0, (i3 | 0) != 0) : 0) __ZdaPv(i3);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i2 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function _sn_write(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 i5 = i1 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i1 = (HEAP32[i1 + 16 >> 2] | 0) - i6 | 0;
 i1 = i1 >>> 0 > i2 >>> 0 ? i2 : i1;
 _memcpy(i6 | 0, i3 | 0, i1 | 0) | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i1;
 STACKTOP = i4;
 return i2 | 0;
}

function __ZNSt3__114__shared_count16__release_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 i4 = i1 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + -1;
 if (i3) {
  i1 = 0;
  STACKTOP = i2;
  return i1 | 0;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 511](i1);
 i1 = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN2cv6detail12PtrOwnerImplINS_16SunRasterEncoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_16SunRasterDecoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZNKSt3__18messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = STACKTOP;
 if (!(HEAP8[i3 >> 0] & 1)) i1 = i3 + 1 | 0; else i1 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = _catopen(i1 | 0, 1) | 0;
 STACKTOP = i2;
 return i1 >>> ((i1 | 0) != (-1 | 0) & 1) | 0;
}

function __ZNKSt3__18messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = STACKTOP;
 if (!(HEAP8[i3 >> 0] & 1)) i1 = i3 + 1 | 0; else i1 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = _catopen(i1 | 0, 1) | 0;
 STACKTOP = i2;
 return i1 >>> ((i1 | 0) != (-1 | 0) & 1) | 0;
}

function __GLOBAL__I_a392() {
 var i1 = 0;
 i1 = STACKTOP;
 _memset(19008, 0, 260) | 0;
 HEAP32[4752] = 0;
 _memset(19272, 0, 260) | 0;
 HEAP8[19552] = 0;
 HEAP8[19560] = HEAP8[19019] | 0;
 HEAP8[19568] = HEAP8[19022] | 0;
 __ZN2cv16TLSDataContainerC2Ev(26832);
 HEAP32[6708] = 26936;
 ___cxa_atexit(94, 26832, ___dso_handle | 0) | 0;
 STACKTOP = i1;
 return;
}

function __ZNK2cv16BaseImageEncoder14getDescriptionEv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 8 >> 2];
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 STACKTOP = i4;
 return;
}

function __ZN2cv11WBaseStream8allocateEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 i2 = i4 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i4 + 16 >> 2] | 0;
 if (!i1) {
  i1 = __Znaj((i3 | 0) > -1 ? i3 : -1) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i4 + 8 >> 2] = i1 + i3;
 HEAP32[i4 + 12 >> 2] = i1;
 STACKTOP = i5;
 return;
}

function __ZN2cv8subtractERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i2, i3, i1, i5, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 __ZN2cvL9arithm_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_iPPFvPKhjS7_jPhjNS_5Size_IiEEPvEbSB_i(i2, i3, i1, i5, i4, 5336, 0, 0, 1);
 STACKTOP = i6;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_11TiffEncoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_10PxMEncoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_10PxMDecoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_10HdrEncoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_10HdrDecoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_10BmpEncoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_10BmpDecoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZNK2cv7MatExpr4typeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 33168) if ((i2 | 0) != 33128) if (!i2) i1 = -1; else i1 = FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] & 127](i2, i1) | 0; else i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] & 4095;
 STACKTOP = i3;
 return i1 | 0;
}

function dynCall_viiiiiiiiii(i11, i1, i3, i4, i5, i6, i7, i8, i9, i10, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 FUNCTION_TABLE_viiiiiiiiii[i11 & 1](i1 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i2 | 0);
}

function __ZNSt13runtime_errorC2ERKNSt3__112basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 HEAP32[i2 >> 2] = 969208;
 if (!(HEAP8[i1 >> 0] & 1)) i1 = i1 + 1 | 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZNSt3__118__libcpp_refstringC2EPKc(i2 + 4 | 0, i1);
 STACKTOP = i3;
 return;
}

function __ZNK2cv8FileNodeixERKNS_6StringE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 i5 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i2 = _cvGetFileNodeByName(i5, HEAP32[i3 + 4 >> 2] | 0, (i2 | 0) == 0 ? 12512 : i2) | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i1 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __ZN4perf10Regression4InitERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZN4perf10Regression8instanceEv() | 0;
 __ZN4perf10Regression4initERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_(169680, i2, i1);
 STACKTOP = i3;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_9AlgorithmENS_14DefaultDeleterIS2_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv3addERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_i(i4, i5, i1, i3, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 __ZN2cvL9arithm_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_iPPFvPKhjS7_jPhjNS_5Size_IiEEPvEbSB_i(i4, i5, i1, i3, i2, 5368, 0, 0, 0);
 STACKTOP = i6;
 return;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter27OnEnvironmentsTearDownStartERKNS_8UnitTestE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(2, 162440, i1);
 _puts(169408) | 0;
 _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 STACKTOP = i1;
 return;
}

function __ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8Iterator5CloneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 i2 = __Znwj(16) | 0;
 HEAP32[i2 >> 2] = 1128;
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter24OnEnvironmentsSetUpStartERKNS_8UnitTestE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 __ZN7testing8internalL13ColoredPrintfENS0_10GTestColorEPKcz(2, 162440, i1);
 _puts(169376) | 0;
 _fflush(HEAP32[_stdout >> 2] | 0) | 0;
 STACKTOP = i1;
 return;
}

function _wmemcpy(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0;
 i5 = STACKTOP;
 if (!i1) {
  STACKTOP = i5;
  return i4 | 0;
 } else i3 = i4;
 while (1) {
  i1 = i1 + -1 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  if (!i1) break; else {
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  }
 }
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8Iterator5CloneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 i2 = __Znwj(16) | 0;
 HEAP32[i2 >> 2] = 1720;
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZNK2cv12MatAllocator5unmapEPNS_8UMatDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 if (HEAP32[i2 + 8 >> 2] | 0) {
  STACKTOP = i3;
  return;
 }
 if (HEAP32[i2 + 12 >> 2] | 0) {
  STACKTOP = i3;
  return;
 }
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] & 127](i1, i2);
 STACKTOP = i3;
 return;
}

function __ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE5BeginEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 i2 = __Znwj(16) | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = 1128;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = 0;
 STACKTOP = i3;
 return i2 | 0;
}

function ___uflow(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i1 = i3;
 if ((HEAP32[i2 + 8 >> 2] | 0) == 0 ? (___toread(i2) | 0) != 0 : 0) i1 = -1; else if ((FUNCTION_TABLE_iiii[HEAP32[i2 + 32 >> 2] & 63](i2, i1, 1) | 0) == 1) i1 = HEAPU8[i1 >> 0] | 0; else i1 = -1;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE5BeginEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 i2 = __Znwj(16) | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = 1720;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE3EndEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 i2 = __Znwj(16) | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = 1128;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = 0;
 STACKTOP = i3;
 return i2 | 0;
}

function dynCall_viiiiiiiddi(i11, i1, i3, i4, i5, i6, i7, i8, d9, d10, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 d9 = +d9;
 d10 = +d10;
 i2 = i2 | 0;
 FUNCTION_TABLE_viiiiiiiddi[i11 & 7](i1 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, +d9, +d10, i2 | 0);
}

function __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 177268;
 HEAP32[i1 + 104 >> 2] = 177288;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev(i1 + 4 | 0);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i1 + 104 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__114basic_ifstreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 177684;
 HEAP32[i1 + 108 >> 2] = 177704;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev(i1 + 8 | 0);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i1 + 108 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE3EndEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 i2 = __Znwj(16) | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = 1720;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZNKSt3__16locale5__imp9has_facetEl(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] | 0) - i1 >> 2 >>> 0 <= i2 >>> 0) {
  i1 = 0;
  STACKTOP = i4;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + (i2 << 2) >> 2] | 0) != 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 32 | 0);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN7testing8internal38DefaultPerThreadTestPartResultReporter20ReportTestPartResultERKNS_14TestPartResultE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i2 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 36 >> 2] | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] & 127](i2, i1);
 STACKTOP = i3;
 return;
}

function __ZN2cv7absdiffERKNS_11_InputArrayES2_RKNS_12_OutputArrayE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 __ZN2cvL9arithm_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_iPPFvPKhjS7_jPhjNS_5Size_IiEEPvEbSB_i(i2, i3, i1, __ZN2cv7noArrayEv() | 0, -1, 5304, 0, 0, 3);
 STACKTOP = i4;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj(i5, i6, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = -1;
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj(i5, i6, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = -1;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_jjRKS4_(i5, i4, i3, i2, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i5, i4, i3, i2, i1);
 STACKTOP = i6;
 return;
}

function __ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 i4 = (HEAP32[i1 >> 2] | 0) + -4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + -1;
 if ((i3 + -1 | 0) >= 0) {
  STACKTOP = i2;
  return;
 }
 __ZdlPv((HEAP32[i1 >> 2] | 0) + -12 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 177268;
 HEAP32[i1 + 104 >> 2] = 177288;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev(i1 + 4 | 0);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i1 + 104 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__114basic_ifstreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 177684;
 HEAP32[i1 + 108 >> 2] = 177704;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev(i1 + 8 | 0);
 __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i1 + 108 | 0);
 STACKTOP = i2;
 return;
}

function __ZNK7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8Iterator5CloneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 i2 = __Znwj(44) | 0;
 __ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8IteratorC2ERKS8_(i2, i1);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN2cv5writeERNS_11FileStorageERKNS_6StringEi(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 if (!(HEAP32[i1 + 4 >> 2] | 0)) i1 = 0; else {
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? 12512 : i1;
 }
 _cvWriteInt(HEAP32[i2 + 8 >> 2] | 0, i1, i3);
 STACKTOP = i4;
 return;
}

function __ZNKSt3__17collateIwE12do_transformEPKwS3_(i3, i4, i2, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = STACKTOP;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i3, i2, i1);
 STACKTOP = i4;
 return;
}

function __ZNKSt3__17collateIcE12do_transformEPKcS3_(i3, i4, i2, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i3, i2, i1);
 STACKTOP = i4;
 return;
}

function __ZN7testing8internal24ParameterizedTestFactoryI41Size_MatType_bitwise_not_bitwise_not_TestE10CreateTestEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[172] = i1 + 4;
 i1 = __Znwj(192) | 0;
 __ZN4perf8TestBaseC2Ev(i1);
 HEAP32[i1 >> 2] = 576;
 HEAP32[i1 + 184 >> 2] = 616;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 2952;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 32 | 0);
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv5writeERNS_11FileStorageERKNS_6StringEd(i2, i1, d3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 d3 = +d3;
 var i4 = 0;
 i4 = STACKTOP;
 if (!(HEAP32[i1 + 4 >> 2] | 0)) i1 = 0; else {
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? 12512 : i1;
 }
 _cvWriteReal(HEAP32[i2 + 8 >> 2] | 0, i1, d3);
 STACKTOP = i4;
 return;
}

function __ZN2cv3minERKNS_11_InputArrayES2_RKNS_12_OutputArrayE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 __ZN2cvL9binary_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_PKPFvPKhjS7_jPhjNS_5Size_IiEEPvEbi(i2, i3, i1, __ZN2cv7noArrayEv() | 0, 5848, 0, 13);
 STACKTOP = i4;
 return;
}

function __ZN2cv3maxERKNS_11_InputArrayES2_RKNS_12_OutputArrayE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 __ZN2cvL9binary_opERKNS_11_InputArrayES2_RKNS_12_OutputArrayES2_PKPFvPKhjS7_jPhjNS_5Size_IiEEPvEbi(i2, i3, i1, __ZN2cv7noArrayEv() | 0, 5880, 0, 14);
 STACKTOP = i4;
 return;
}

function dynCall_viiiiiiiii(i10, i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 FUNCTION_TABLE_viiiiiiiii[i10 & 7](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
}

function __ZL15icvXMLWriteRealP13CvFileStoragePKcd(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 i5 = i4;
 __ZL17icvXMLWriteScalarP13CvFileStoragePKcS2_i(i1, i2, i5, _strlen(__ZL17icvDoubleToStringPcd(i5, d3) | 0) | 0);
 STACKTOP = i4;
 return;
}

function __ZNKSt3__114error_category10equivalentERKNS_10error_codeEi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 if ((HEAP32[i1 + 4 >> 2] | 0) != (i3 | 0)) {
  i1 = 0;
  STACKTOP = i4;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0);
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN2cv9ExceptionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 18928;
 __ZN2cv6String10deallocateEv(i1 + 32 | 0);
 __ZN2cv6String10deallocateEv(i1 + 24 | 0);
 __ZN2cv6String10deallocateEv(i1 + 16 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv11FileStorageC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 11304;
 i1 = i1 + 4 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN2cv5randuERKNS_17_InputOutputArrayERKNS_11_InputArrayES5_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 __ZN2cv3RNG4fillERKNS_17_InputOutputArrayEiRKNS_11_InputArrayES6_b(__ZNK2cv16TLSDataContainer7getDataEv(26832) | 0, i1, 0, i3, i2, 0);
 STACKTOP = i4;
 return;
}

function __ZNSt3__17codecvtIwc11__mbstate_tED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 960816;
 i1 = i1 + 8 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) == (__ZNSt3__16__clocEv() | 0)) {
  STACKTOP = i2;
  return;
 }
 _freelocale(HEAP32[i1 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN7testing8UnitTestD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 HEAP32[i2 >> 2] = 163936;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  STACKTOP = i3;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 __ZdlPv(i2);
 STACKTOP = i3;
 return;
}

function __ZNKSt3__15ctypeIwE5do_isEtw(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 if (i2 >>> 0 >= 128) {
  i2 = 0;
  STACKTOP = i1;
  return i2 | 0;
 }
 i2 = (HEAP16[(__ZNSt3__15ctypeIcE13classic_tableEv() | 0) + (i2 << 1) >> 1] & i3) << 16 >> 16 != 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = __ZNKSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i2, 0, -1, i1, _strlen(i1 | 0) | 0) | 0;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN2cv16BaseImageEncoderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 179392;
 i2 = i1 + 4 | 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP8[i1 + 24 >> 0] = 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 return;
}

function __ZN2cv10PxMDecoderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 __ZN2cv16BaseImageDecoderC2Ev(i1);
 HEAP32[i1 >> 2] = 179624;
 i3 = i1 + 92 | 0;
 __ZN2cv11RBaseStreamC2Ev(i3);
 HEAP32[i3 >> 2] = 180968;
 HEAP32[i1 + 1156 >> 2] = -1;
 HEAP8[i1 + 88 >> 0] = 1;
 STACKTOP = i2;
 return;
}

function __ZN2cv6String8allocateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 i4 = __ZN2cv10fastMallocEj(i1 + 8 & -4) | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i2 >> 2] = i4 + 4;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP8[i4 + (i1 + 4) >> 0] = 0;
 STACKTOP = i3;
 return HEAP32[i2 >> 2] | 0;
}

function __ZN2cv8UMatDataC2EPKNS_12MatAllocatorE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 i2 = i2 + 8 | 0;
 i1 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i1 | 0));
 STACKTOP = i3;
 return;
}

function __ZN2cv11RBaseStreamC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 180720;
 i2 = i1 + 8 | 0;
 HEAP32[i2 + 0 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 32768;
 HEAP8[i1 + 32 >> 0] = 0;
 HEAP8[i1 + 4 >> 0] = 0;
 return;
}

function __ZN2cv9ExceptionD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 18928;
 __ZN2cv6String10deallocateEv(i1 + 32 | 0);
 __ZN2cv6String10deallocateEv(i1 + 24 | 0);
 __ZN2cv6String10deallocateEv(i1 + 16 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function b24(i1, i2, i7, i8, i9, i10, i11, i12, i13, i14, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 abort(24);
 return 0;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE9do_lengthERS1_PKcS5_j(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = STACKTOP;
 i1 = __ZNSt3__1L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE(i2, i3, i4, 1114111, 0) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN2cv6detail12PtrOwnerImplINS_4cuda6Stream4ImplENS_14DefaultDeleterIS4_EEE10deleteSelfEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1) __ZdlPv(i1);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 511](i2);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale8__globalEv() {
 var i1 = 0;
 i1 = STACKTOP;
 if ((HEAP8[960704] | 0) == 0 ? (___cxa_guard_acquire(960704) | 0) != 0 : 0) {
  __ZNSt3__16locale5__imp11make_globalEv() | 0;
  HEAP32[240174] = 960688;
  ___cxa_guard_release(960704);
 }
 STACKTOP = i1;
 return HEAP32[240174] | 0;
}

function __ZNSt3__16locale7classicEv() {
 var i1 = 0;
 i1 = STACKTOP;
 if ((HEAP8[960680] | 0) == 0 ? (___cxa_guard_acquire(960680) | 0) != 0 : 0) {
  __ZNSt3__16locale5__imp12make_classicEv() | 0;
  HEAP32[240168] = 960664;
  ___cxa_guard_release(960680);
 }
 STACKTOP = i1;
 return HEAP32[240168] | 0;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE9do_lengthERS1_PKcS5_j(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = STACKTOP;
 i1 = __ZNSt3__1L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i2, i3, i4, 1114111, 0) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN7testing4TestD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 HEAP32[i2 >> 2] = 160816;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  STACKTOP = i3;
  return;
 }
 __ZN7testing8internal14GTestFlagSaverD2Ev(i1);
 __ZdlPv(i1);
 __ZdlPv(i2);
 STACKTOP = i3;
 return;
}

function __ZN2cv3Mat15getStdAllocatorEv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 if ((HEAP8[27624] | 0) == 0 ? (___cxa_guard_acquire(27624) | 0) != 0 : 0) {
  i2 = __Znwj(4) | 0;
  HEAP32[i2 >> 2] = 32784;
  HEAP32[6904] = i2;
  ___cxa_guard_release(27624);
 }
 STACKTOP = i1;
 return HEAP32[6904] | 0;
}

function __ZNSt3__16locale5__imp7installINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960520) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960472) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960416) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960336) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI11__mbstate_tEEj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i3 + 8 | 0;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = -1;
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i3 + 8 | 0;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = -1;
 return;
}

function dynCall_iiiiiiiii(i9, i1, i2, i3, i4, i5, i6, i7, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return FUNCTION_TABLE_iiiiiiiii[i9 & 15](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
}

function ___uremdi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 8 | 0;
 i5 = i6 | 0;
 ___udivmoddi4(i1, i2, i3, i4, i5) | 0;
 STACKTOP = i6;
 return (tempRet0 = HEAP32[i5 + 4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
}

function __ZNSt3__16locale5__imp7installINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960040) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960008) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(959776) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(959624) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(959512) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(959416) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(959352) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(959232) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i2, i1, _strlen(i1 | 0) | 0) | 0;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i2, i1, _strlen(i1 | 0) | 0) | 0;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (i1) {
  i1 = _uselocale(i1 | 0) | 0;
  if (!i1) i1 = 4; else {
   _uselocale(i1 | 0) | 0;
   i1 = 4;
  }
 } else i1 = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN2cv4UMat10deallocateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] & 127](i4, i3);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZNSt3__117iostream_categoryEv() {
 var i1 = 0;
 i1 = STACKTOP;
 if ((HEAP8[958232] | 0) == 0 ? (___cxa_guard_acquire(958232) | 0) != 0 : 0) {
  HEAP32[239556] = 959008;
  ___cxa_atexit(267, 958224, ___dso_handle | 0) | 0;
  ___cxa_guard_release(958232);
 }
 STACKTOP = i1;
 return 958224;
}

function __ZNKSt3__15ctypeIcE10do_tolowerEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 if (i2 << 24 >> 24 <= -1) {
  STACKTOP = i1;
  return i2 | 0;
 }
 i2 = HEAP32[(__ZNSt3__15ctypeIcE21__classic_lower_tableEv() | 0) + (i2 << 24 >> 24 << 2) >> 2] & 255;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj(i2, i1, _wcslen(i1) | 0) | 0;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNKSt3__15ctypeIcE10do_toupperEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 if (i2 << 24 >> 24 <= -1) {
  STACKTOP = i1;
  return i2 | 0;
 }
 i2 = HEAP32[(__ZNSt3__15ctypeIcE21__classic_upper_tableEv() | 0) + ((i2 & 255) << 2) >> 2] & 255;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZNK2cv9Algorithm5writeERNS_11FileStorageE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNK2cv13AlgorithmInfo5writeEPKNS_9AlgorithmERNS_11FileStorageE(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] & 127](i2) | 0, i2, i1);
 STACKTOP = i3;
 return;
}

function __ZNK2cv8FileNodeixEPKc(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 i5 = HEAP32[i3 >> 2] | 0;
 i2 = _cvGetFileNodeByName(i5, HEAP32[i3 + 4 >> 2] | 0, i2) | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i1 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function dynCall_viiiiiiii(i9, i1, i2, i3, i4, i5, i6, i7, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 FUNCTION_TABLE_viiiiiiii[i9 & 255](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0);
}

function __ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8IteratorD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8IteratorD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN7testing8internal12AssertHelperD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 12 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN41Size_MatType_bitwise_not_bitwise_not_Test8TestBodyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN2cv3ipp12setIppStatusEiPKcS2_i(0, 0, 0, 0);
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] & 511](i1);
 __Z14checkIppStatusv();
 STACKTOP = i2;
 return;
}

function __ZN2cv16SunRasterEncoderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179392;
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv16BaseImageEncoderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179392;
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv9Algorithm4readERKNS_8FileNodeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNK2cv13AlgorithmInfo4readEPNS_9AlgorithmERKNS_8FileNodeE(FUNCTION_TABLE_ii[HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] & 127](i2) | 0, i2, i1);
 STACKTOP = i3;
 return;
}

function __ZNK2cv11_InputArray4rowsEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i4;
 FUNCTION_TABLE_viii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 63](i3, i2, i1);
 STACKTOP = i4;
 return HEAP32[i3 + 4 >> 2] | 0;
}

function ___muldi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = i1;
 i6 = i3;
 i1 = ___muldsi3(i5, i6) | 0;
 i3 = tempRet0;
 return (tempRet0 = (Math_imul(i2, i6) | 0) + (Math_imul(i4, i5) | 0) + i3 | i3 & 0, i1 | 0 | 0) | 0;
}

function __ZN7testing8internal18OsStackTraceGetter17CurrentStackTraceEii(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, 159968, 0);
 STACKTOP = i1;
 return;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_(i6, i1, i4, i2, i5, i7, i3, i8) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i8 >> 2] = i7;
 return 3;
}

function __ZNKSt3__15ctypeIwE10do_toupperEw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 if (i2 >>> 0 >= 128) {
  STACKTOP = i1;
  return i2 | 0;
 }
 i2 = HEAP32[(__ZNSt3__15ctypeIcE21__classic_upper_tableEv() | 0) + (i2 << 2) >> 2] | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZNKSt3__15ctypeIwE10do_tolowerEw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 if (i2 >>> 0 >= 128) {
  STACKTOP = i1;
  return i2 | 0;
 }
 i2 = HEAP32[(__ZNSt3__15ctypeIcE21__classic_lower_tableEv() | 0) + (i2 << 2) >> 2] | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZN2cv11WBaseStreamC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 180888;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 32768;
 HEAP8[i1 + 28 >> 0] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 return;
}

function __ZN2cv11TiffEncoderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179392;
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZL15icvYMLWriteRealP13CvFileStoragePKcd(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 __ZL11icvYMLWriteP13CvFileStoragePKcS2_(i1, i2, __ZL17icvDoubleToStringPcd(i4, d3) | 0);
 STACKTOP = i4;
 return;
}

function ___cxa_get_globals_fast() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if (!(_pthread_once(968800, 6) | 0)) {
  i2 = _pthread_getspecific(HEAP32[242198] | 0) | 0;
  STACKTOP = i1;
  return i2 | 0;
 } else _abort_message(968808, i1);
 return 0;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_(i6, i1, i4, i2, i5, i7, i3, i8) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i8 >> 2] = i7;
 return 3;
}

function __ZNKSt3__112__do_message7messageEi(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i3 = STACKTOP;
 i2 = _strerror(i2 | 0) | 0;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, _strlen(i2 | 0) | 0);
 STACKTOP = i3;
 return;
}

function __ZNK2cv11_InputArray4colsEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i4;
 FUNCTION_TABLE_viii[HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] & 63](i3, i2, i1);
 STACKTOP = i4;
 return HEAP32[i3 >> 2] | 0;
}

function __ZN7testing8UnitTestD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 163936;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv10PxMEncoderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179392;
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv10HdrEncoderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179392;
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv10BmpEncoderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179392;
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__16__clocEv() {
 var i1 = 0;
 i1 = STACKTOP;
 if ((HEAP8[960624] | 0) == 0 ? (___cxa_guard_acquire(960624) | 0) != 0 : 0) {
  HEAP32[240154] = _newlocale(2147483647, 960632, 0) | 0;
  ___cxa_guard_release(960624);
 }
 STACKTOP = i1;
 return HEAP32[240154] | 0;
}

function __GLOBAL__I_a530() {
 var i1 = 0;
 i1 = STACKTOP;
 __ZN6CvTypeC2EPKcPFiPKvEPFvPPvEPFS6_P13CvFileStorageP10CvFileNodeEPFvSB_S1_S3_10CvAttrListEPFS6_S3_E(702032, 702040, 126, 383, 82, 49, 127);
 ___cxa_atexit(354, 702032, ___dso_handle | 0) | 0;
 STACKTOP = i1;
 return;
}

function __ZNSt3__114__num_get_base10__get_baseERNS_8ios_baseE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = HEAP32[i1 + 4 >> 2] & 74;
 if ((i1 | 0) == 8) i1 = 16; else if ((i1 | 0) == 64) i1 = 8; else if (!i1) i1 = 0; else i1 = 10;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN2cv3ocl5QueueD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) != 0 ? (i3 = HEAP32[i1 >> 2] | 0, HEAP32[i1 >> 2] = i3 + -1, (i3 | 0) == 1 & (HEAP8[26720] | 0) == 0) : 0) __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function _wmemset(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0;
 i5 = STACKTOP;
 if (i1) {
  i2 = i4;
  while (1) {
   i1 = i1 + -1 | 0;
   HEAP32[i2 >> 2] = i3;
   if (!i1) break; else i2 = i2 + 4 | 0;
  }
 }
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZL8icvIsMatPKv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if (((i1 | 0) != 0 ? (HEAP32[i1 >> 2] & -65536 | 0) == 1111621632 : 0) ? (HEAP32[i1 + 24 >> 2] | 0) > -1 : 0) i1 = (HEAP32[i1 + 20 >> 2] | 0) > -1; else i1 = 0;
 STACKTOP = i2;
 return i1 & 1 | 0;
}

function __ZN2cv11WBaseStream7releaseEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) __ZdaPv(i2);
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN2cv16SunRasterEncoderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179392;
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function __ZN2cv16BaseImageEncoderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179392;
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function _testSetjmp(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 while ((i2 | 0) < 20) {
  i1 = HEAP32[i4 + (i2 << 3) >> 2] | 0;
  if (!i1) break;
  if ((i1 | 0) == (i3 | 0)) return HEAP32[i4 + ((i2 << 3) + 4) >> 2] | 0;
  i2 = i2 + 1 | 0;
 }
 return 0;
}

function _strncpy(i4, i5, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 while ((i1 | 0) < (i2 | 0)) {
  HEAP8[i4 + i1 >> 0] = i3 ? 0 : HEAP8[i5 + i1 >> 0] | 0;
  i3 = i3 ? 1 : (HEAP8[i5 + i1 >> 0] | 0) == 0;
  i1 = i1 + 1 | 0;
 }
 return i4 | 0;
}

function __ZNSt3__16locale5__imp7installINS_7codecvtIDsc11__mbstate_tEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960856) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_7codecvtIDic11__mbstate_tEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960864) | 0);
 STACKTOP = i3;
 return;
}

function __ZN7testing8internal12UnitTestImpl28CurrentOsStackTraceExceptTopEi(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 159968, 0);
 STACKTOP = i2;
 return;
}

function b27(i1, i2, i6, i7, i8, i9, i10, i11, i12, i13, d3, d4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 d3 = +d3;
 d4 = +d4;
 i5 = i5 | 0;
 abort(27);
}

function __ZNSt3__16locale5__imp7installINS_7codecvtIwc11__mbstate_tEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960800) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_7codecvtIcc11__mbstate_tEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960792) | 0);
 STACKTOP = i3;
 return;
}

function __ZN7testing4TestD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 160816;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 __ZN7testing8internal14GTestFlagSaverD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_19destruct_EPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 _free(i1);
 if (!(_pthread_setspecific(HEAP32[242198] | 0, 0) | 0)) {
  STACKTOP = i2;
  return;
 } else _abort_message(968920, i2);
}

function __ZN2cv11TiffEncoderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179392;
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function __ZN2cv10PxMEncoderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179392;
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function __ZN2cv10HdrEncoderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179392;
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function __ZN2cv10BmpEncoderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179392;
 __ZN2cv6String10deallocateEv(i1 + 28 | 0);
 __ZN2cv6String10deallocateEv(i1 + 12 | 0);
 __ZN2cv6String10deallocateEv(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function _snprintf(i3, i2, i1, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i4;
 i1 = _vsnprintf(i3, i2, i1, i6) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNKSt3__16locale9use_facetERNS0_2idE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i1 >> 2] | 0;
 i1 = __ZNKSt3__16locale5__imp9use_facetEl(i1, __ZNSt3__16locale2id5__getEv(i2) | 0) | 0;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNKSt3__16locale9has_facetERNS0_2idE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i1 >> 2] | 0;
 i1 = __ZNKSt3__16locale5__imp9has_facetEl(i1, __ZNSt3__16locale2id5__getEv(i2) | 0) | 0;
 STACKTOP = i3;
 return i1 | 0;
}

function dynCall_viiiiiii(i8, i1, i2, i3, i4, i5, i6, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 FUNCTION_TABLE_viiiiiii[i8 & 63](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
}

function _gzclose(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 do if (i1) if ((HEAP32[i1 + 12 >> 2] | 0) == 7247) {
  i1 = _gzclose_r(i1) | 0;
  break;
 } else {
  i1 = _gzclose_w(i1) | 0;
  break;
 } else i1 = -2; while (0);
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN2cv15getCopyMaskFuncEj(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if (i1 >>> 0 < 33) {
  i1 = HEAP32[46504 + (i1 << 2) >> 2] | 0;
  STACKTOP = i2;
  return ((i1 | 0) == 0 ? 195 : i1) | 0;
 } else {
  STACKTOP = i2;
  return 195;
 }
 return 0;
}

function __ZNSt3__16locale5__imp7installINS_10moneypunctIwLb1EEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960296) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_10moneypunctIwLb0EEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960232) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_10moneypunctIcLb1EEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960168) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_10moneypunctIcLb0EEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960104) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6sentryC1ERS3_b(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEE6sentryC2ERS3_b(i3, i1, i2);
 STACKTOP = i4;
 return;
}

function __ZNK2cv12MatAllocator23getBufferPoolControllerEv(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 if ((HEAP8[27608] | 0) == 0 ? (___cxa_guard_acquire(27608) | 0) != 0 : 0) {
  HEAP32[6900] = 32984;
  ___cxa_guard_release(27608);
 }
 STACKTOP = i1;
 return 27600;
}

function __ZN7testing8internal24XmlUnitTestResultPrinterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 162856;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv16BaseImageDecoderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 179344;
 __ZN2cv3MatD2Ev(i1 + 32 | 0);
 __ZN2cv6String10deallocateEv(i1 + 24 | 0);
 __ZN2cv6String10deallocateEv(i1 + 16 | 0);
 STACKTOP = i2;
 return;
}

function __ZTv0_n12_NSt3__114basic_iostreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__114basic_iostreamIcNS_11char_traitsIcEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__110__time_putD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) == (__ZNSt3__16__clocEv() | 0)) {
  STACKTOP = i2;
  return;
 }
 _freelocale(HEAP32[i1 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i1);
 STACKTOP = i3;
 return;
}

function dynCall_viiiiiid(i8, i1, i2, i3, i4, i5, i6, d7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 d7 = +d7;
 FUNCTION_TABLE_viiiiiid[i8 & 3](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, +d7);
}

function __ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 STACKTOP = i2;
 return;
}

function __ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 STACKTOP = i2;
 return;
}

function __ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 STACKTOP = i2;
 return;
}

function __ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__16locale5__imp7installINS_8numpunctIwEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960880) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_8numpunctIcEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960872) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_8messagesIwEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960600) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_8messagesIcEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960560) | 0);
 STACKTOP = i3;
 return;
}

function _abort_message(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 HEAP32[i3 >> 2] = i2;
 i2 = HEAP32[_stderr >> 2] | 0;
 _vfprintf(i2 | 0, i1 | 0, i3 | 0) | 0;
 _fputc(10, i2 | 0) | 0;
 _abort();
}

function __ZNSt3__16locale5__imp7installINS_7collateIwEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(959160) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_7collateIcEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(959120) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp11make_globalEv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 i2 = HEAP32[(__ZNSt3__16locale7classicEv() | 0) >> 2] | 0;
 HEAP32[240172] = i2;
 __ZNSt3__114__shared_count12__add_sharedEv(i2);
 STACKTOP = i1;
 return 960688;
}

function __ZNK2cv11FileStorage8isOpenedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  STACKTOP = i2;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 272 >> 0] | 0) != 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN2cv13parallel_for_ERKNS_5RangeERKNS_16ParallelLoopBodyEd(i3, i1, d2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 var i4 = 0;
 i4 = STACKTOP;
 FUNCTION_TABLE_vii[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] & 127](i1, i3);
 STACKTOP = i4;
 return;
}

function __ZL10icvIsGraphPKv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 if ((i2 | 0) != 0 ? (i1 = HEAP32[i2 >> 2] | 0, (i1 & -65536 | 0) == 1117257728) : 0) i1 = (i1 & 12288 | 0) == 4096; else i1 = 0;
 STACKTOP = i3;
 return i1 & 1 | 0;
}

function __ZNSt3__16locale5__imp7installINS_5ctypeIwEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960720) | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__16locale5__imp7installINS_5ctypeIcEEEEvPT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16locale5__imp7installEPNS0_5facetEl(i2, i1, __ZNSt3__16locale2id5__getEv(960728) | 0);
 STACKTOP = i3;
 return;
}

function __GLOBAL__I_a320() {
 var i1 = 0;
 i1 = STACKTOP;
 __ZN2cv5MutexC2Ev(18520);
 ___cxa_atexit(361, 18520, ___dso_handle | 0) | 0;
 HEAP32[4632] = 0;
 HEAP32[4633] = 0;
 ___cxa_atexit(362, 18528, ___dso_handle | 0) | 0;
 STACKTOP = i1;
 return;
}

function __ZNSt3__17codecvtIwc11__mbstate_tEC2Ej(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 >> 2] = 960816;
 HEAP32[i2 + 8 >> 2] = __ZNSt3__16__clocEv() | 0;
 STACKTOP = i3;
 return;
}

function __ZNK2cv11_InputArray8channelsEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = ((FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] & 127](i2, i1) | 0) >>> 3 & 511) + 1 | 0;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN6cvtest2TS20set_failed_test_infoEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = i1 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 HEAP32[i1 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function copyTempFloat(i1) {
 i1 = i1 | 0;
 HEAP8[tempDoublePtr >> 0] = HEAP8[i1 >> 0];
 HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i1 + 1 >> 0];
 HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i1 + 2 >> 0];
 HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i1 + 3 >> 0];
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if (!(HEAP8[i1 >> 0] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZdlPv(HEAP32[i1 + 8 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if (!(HEAP8[i1 >> 0] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZdlPv(HEAP32[i1 + 8 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__16localeC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 i3 = HEAP32[(__ZNSt3__16locale8__globalEv() | 0) >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 __ZNSt3__114__shared_count12__add_sharedEv(i3);
 STACKTOP = i2;
 return;
}

function dynCall_iiiiiii(i7, i1, i2, i3, i4, i5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return FUNCTION_TABLE_iiiiiii[i7 & 1](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
}

function _bitshift64Ashr(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i1 | 0) < 32) {
  tempRet0 = i2 >> i1;
  return i3 >>> i1 | (i2 & (1 << i1) - 1) << 32 - i1;
 }
 tempRet0 = (i2 | 0) < 0 ? -1 : 0;
 return i2 >> i1 - 32 | 0;
}

function __ZN7testing8internal24XmlUnitTestResultPrinterD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 162856;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__15ctypeIcED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 HEAP32[i2 >> 2] = 960744;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if ((i1 | 0) != 0 ? (HEAP8[i2 + 12 >> 0] | 0) != 0 : 0) __ZdaPv(i1);
 STACKTOP = i3;
 return;
}

function __ZNK2cv14DefaultDeleterI13CvFileStorageEclEPS1_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 _cvReleaseFileStorage(i3);
 STACKTOP = i2;
 return;
}

function _sprintf(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i1 = _vsprintf(i2, i1, i5) | 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNKSt3__18numpunctIwE12do_falsenameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, 961008, _wcslen(961008) | 0);
 STACKTOP = i2;
 return;
}

function __ZNK2cv7TLSDataINS_11CoreTLSDataEE18deleteDataInstanceEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 if (!i2) {
  STACKTOP = i1;
  return;
 }
 __ZN2cv3ocl5QueueD2Ev(i2 + 12 | 0);
 __ZdlPv(i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__16locale5facet16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__18numpunctIwE11do_truenameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, 960976, _wcslen(960976) | 0);
 STACKTOP = i2;
 return;
}

function _sscanf(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i1 = _vsscanf(i2, i1, i5) | 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __GLOBAL__I_a270() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 i1 = 17496;
 do {
  __ZN2cv5MutexC2Ev(i1);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (17620 | 0));
 ___cxa_atexit(360, 0, ___dso_handle | 0) | 0;
 STACKTOP = i2;
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC1ERS3_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i2, i1);
 STACKTOP = i3;
 return;
}

function __ZNKSt3__121__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1) {
 i1 = i1 | 0;
 i1 = ___cxa_allocate_exception(8) | 0;
 __ZNSt11logic_errorC2EPKc(i1, 957864);
 HEAP32[i1 >> 2] = 969328;
 ___cxa_throw(i1 | 0, 969368, 330);
}

function __ZNKSt3__121__basic_string_commonILb1EE20__throw_length_errorEv(i1) {
 i1 = i1 | 0;
 i1 = ___cxa_allocate_exception(8) | 0;
 __ZNSt11logic_errorC2EPKc(i1, 957864);
 HEAP32[i1 >> 2] = 969264;
 ___cxa_throw(i1 | 0, 969304, 330);
}

function __ZNKSt3__120__vector_base_commonILb1EE20__throw_out_of_rangeEv(i1) {
 i1 = i1 | 0;
 i1 = ___cxa_allocate_exception(8) | 0;
 __ZNSt11logic_errorC2EPKc(i1, 960608);
 HEAP32[i1 >> 2] = 969328;
 ___cxa_throw(i1 | 0, 969368, 330);
}

function __ZNKSt3__120__vector_base_commonILb1EE20__throw_length_errorEv(i1) {
 i1 = i1 | 0;
 i1 = ___cxa_allocate_exception(8) | 0;
 __ZNSt11logic_errorC2EPKc(i1, 960608);
 HEAP32[i1 >> 2] = 969264;
 ___cxa_throw(i1 | 0, 969304, 330);
}

function __ZN4perf8TestBase10startTimerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 i3 = __ZN2cv12getTickCountEv() | 0;
 i1 = i1 + 48 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = tempRet0;
 STACKTOP = i2;
 return;
}

function dynCall_viiiiii(i7, i1, i2, i3, i4, i5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 FUNCTION_TABLE_viiiiii[i7 & 31](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
}

function __ZTv0_n12_NSt3__114basic_iostreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 12) | 0);
 STACKTOP = i2;
 return;
}

function __ZN2cv3ocl13ProgramSourceC2EPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 i4 = __Znwj(24) | 0;
 __ZN2cv3ocl13ProgramSource4ImplC2EPKc(i4, i1);
 HEAP32[i2 >> 2] = i4;
 STACKTOP = i3;
 return;
}

function __ZN2cv13redirectErrorEPFiiPKcS1_S1_iPvES2_PS2_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 if (i2) HEAP32[i2 >> 2] = HEAP32[6350];
 i2 = HEAP32[6348] | 0;
 HEAP32[6348] = i1;
 HEAP32[6350] = i3;
 return i2 | 0;
}

function __ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 4) | 0);
 STACKTOP = i2;
 return;
}

function __ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 4) | 0);
 STACKTOP = i2;
 return;
}

function __ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 8) | 0);
 STACKTOP = i2;
 return;
}

function __ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + ((HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 8) | 0);
 STACKTOP = i2;
 return;
}

function __ZL9icvIsHistPKv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if ((i1 | 0) != 0 ? (HEAP32[i1 >> 2] & -65536 | 0) == 1111818240 : 0) i1 = (HEAP32[i1 + 4 >> 2] | 0) != 0; else i1 = 0;
 STACKTOP = i2;
 return i1 & 1 | 0;
}

function __ZNKSt3__18numpunctIwE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1, i2 + 16 | 0);
 STACKTOP = i3;
 return;
}

function __ZNKSt3__18numpunctIcE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC1ERKS5_(i1, i2 + 12 | 0);
 STACKTOP = i3;
 return;
}

function _bitshift64Shl(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i1 | 0) < 32) {
  tempRet0 = i2 << i1 | (i3 & (1 << i1) - 1 << 32 - i1) >>> 32 - i1;
  return i3 << i1;
 }
 tempRet0 = i3 << i1 - 32;
 return 0;
}

function __ZN2cv13AlgorithmInfoD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 __ZN2cv17AlgorithmInfoDataD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZL12icvCloneHistPK11CvHistogram(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = 0;
 _cvCopyHist(i1, i2);
 STACKTOP = i3;
 return HEAP32[i2 >> 2] | 0;
}

function __ZNK2cv11_InputArray5depthEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = (FUNCTION_TABLE_iii[HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] & 127](i2, i1) | 0) & 7;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN2cv8UMatDataD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = i1 + 0 | 0;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 STACKTOP = i3;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_110construct_Ev() {
 var i1 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if (!(_pthread_key_create(968792, 396) | 0)) {
  STACKTOP = i1;
  return;
 } else _abort_message(968864, i1);
}

function dynCall_viiiiid(i7, i1, i2, i3, i4, i5, d6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 FUNCTION_TABLE_viiiiid[i7 & 7](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, +d6);
}

function __ZN7testing4Test11DeleteSelf_Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 511](i1);
 STACKTOP = i2;
 return;
}

function _bitshift64Lshr(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i1 | 0) < 32) {
  tempRet0 = i2 >>> i1;
  return i3 >>> i1 | (i2 & (1 << i1) - 1) << 32 - i1;
 }
 tempRet0 = 0;
 return i2 >>> i1 - 32 | 0;
}

function __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__110moneypunctIwLb1EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i1, 1, 45);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__110moneypunctIwLb0EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 __ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i1, 1, 45);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__110moneypunctIcLb1EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i1, 1, 45);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__110moneypunctIcLb0EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i1, 1, 45);
 STACKTOP = i2;
 return;
}

function __ZNSt3__16localeC2ERKS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 __ZNSt3__114__shared_count12__add_sharedEv(i1);
 STACKTOP = i3;
 return;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE9do_lengthERS1_PKcS5_j(i5, i1, i3, i2, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i2 - i3 | 0;
 return (i1 >>> 0 < i4 >>> 0 ? i1 : i4) | 0;
}

function __ZNSt3__18ios_base33__set_badbit_and_consider_rethrowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
 if (!(HEAP32[i1 + 20 >> 2] & 1)) return; else ___cxa_rethrow();
}

function _gzputs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 i3 = _strlen(i2 | 0) | 0;
 i1 = _gzwrite(i1, i2, i3) | 0;
 STACKTOP = i4;
 return ((i1 | 0) == 0 & (i3 | 0) != 0 ? -1 : i1) | 0;
}

function __ZNSt3__18numpunctIwED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 960936;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 16 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__18numpunctIcED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 960896;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1 + 12 | 0);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__18numpunctIcE12do_falsenameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 961e3, 5);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__18numpunctIcE11do_truenameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 __ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, 960968, 4);
 STACKTOP = i2;
 return;
}

function __ZNK12_GLOBAL__N_110CLAHE_Impl16getTilesGridSizeEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 return;
}

function dynCall_iiiiii(i6, i1, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return FUNCTION_TABLE_iiiiii[i6 & 31](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
}

function __ZN2cvL10dotProd_8uEPKhS1_i(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var d4 = 0.0, i5 = 0;
 i5 = STACKTOP;
 d4 = +__ZN2cv8dotProd_IhEEdPKT_S3_i(i2, i3, i1) + 0.0;
 STACKTOP = i5;
 return +d4;
}

function __ZN12_GLOBAL__N_118CLAHE_CalcLut_BodyItLi4096ELi4EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN12_GLOBAL__N_118CLAHE_CalcLut_BodyItLi4096ELi4EED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 957952;
 __ZNSt3__16localeD2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 957888;
 __ZNSt3__16localeD2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_118CLAHE_CalcLut_BodyIhLi256ELi0EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN12_GLOBAL__N_118CLAHE_CalcLut_BodyIhLi256ELi0EED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__110__time_putD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__110__time_putD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cvL11dotProd_16uEPKtS1_i(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var d4 = 0.0, i5 = 0;
 i5 = STACKTOP;
 d4 = +__ZN2cv8dotProd_ItEEdPKT_S3_i(i2, i3, i1);
 STACKTOP = i5;
 return +d4;
}

function __ZThn8_NSt3__114basic_iostreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__114basic_iostreamIcNS_11char_traitsIcEEED0Ev(i1 + -8 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt13runtime_errorC2EPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 HEAP32[i2 >> 2] = 969208;
 __ZNSt3__118__libcpp_refstringC2EPKc(i2 + 4 | 0, i1);
 STACKTOP = i3;
 return;
}

function b23(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 abort(23);
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt11logic_errorC2EPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 HEAP32[i2 >> 2] = 969184;
 __ZNSt3__118__libcpp_refstringC2EPKc(i2 + 4 | 0, i1);
 STACKTOP = i3;
 return;
}

function __ZNK2cv12_OutputArray6neededEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = (FUNCTION_TABLE_ii[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 127](i1) | 0) != 0;
 STACKTOP = i2;
 return i1 | 0;
}

function dynCall_viiiii(i6, i1, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 FUNCTION_TABLE_viiiii[i6 & 31](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_118CLAHE_CalcLut_BodyItLi4096ELi4EEENS_14DefaultDeleterIS4_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv3ipp12setIppStatusEiPKcS2_i(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 HEAP32[6710] = i4;
 HEAP32[6712] = i2;
 HEAP32[6714] = i1;
 HEAP32[6716] = i3;
 return;
}

function __ZN12_GLOBAL__N_124CLAHE_Interpolation_BodyItED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN12_GLOBAL__N_124CLAHE_Interpolation_BodyItED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_124CLAHE_Interpolation_BodyIhED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN12_GLOBAL__N_124CLAHE_Interpolation_BodyIhED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function ___cxx_global_array_dtor(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = 17620 | 0;
 do {
  i1 = i1 + -4 | 0;
  __ZN2cv5MutexD2Ev(i1);
 } while ((i1 | 0) != 17496);
 STACKTOP = i2;
 return;
}

function __ZThn184_N41Size_MatType_bitwise_not_bitwise_not_TestD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = i1 + -184 | 0;
 __ZN4perf8TestBaseD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_118CLAHE_CalcLut_BodyIhLi256ELi0EEENS_14DefaultDeleterIS4_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_110CLAHE_Impl16setTilesGridSizeEN2cv5Size_IiEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 4 >> 2];
 return;
}

function _strchr(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i2 = ___strchrnul(i2, i1) | 0;
 STACKTOP = i3;
 return ((HEAP8[i2 >> 0] | 0) == (i1 & 255) << 24 >> 24 ? i2 : 0) | 0;
}

function b7(i1, i2, i3, i4, i5, i6, i7, d8, d9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 d8 = +d8;
 d9 = +d9;
 i10 = i10 | 0;
 abort(7);
}

function _gzeof(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if ((i1 | 0) != 0 ? (HEAP32[i1 + 12 >> 2] | 0) == 7247 : 0) i1 = HEAP32[i1 + 56 >> 2] | 0; else i1 = 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_124CLAHE_Interpolation_BodyItEENS_14DefaultDeleterIS4_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_124CLAHE_Interpolation_BodyIhEENS_14DefaultDeleterIS4_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function _cvCreateMat(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 i1 = _cvCreateMatHeader(i1, i3, i2) | 0;
 _cvCreateData(i1);
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 957952;
 __ZNSt3__16localeD2Ev(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 957952;
 __ZNSt3__16localeD2Ev(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 957888;
 __ZNSt3__16localeD2Ev(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 957888;
 __ZNSt3__16localeD2Ev(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function dynCall_viiiid(i6, i1, i2, i3, i4, d5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 FUNCTION_TABLE_viiiid[i6 & 3](i1 | 0, i2 | 0, i3 | 0, i4 | 0, +d5);
}

function __ZNKSt3__110moneypunctIwLb1EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIwLb1EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIwLb0EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIwLb0EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIcLb1EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIcLb1EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIcLb0EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__110moneypunctIcLb0EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__110__time_putD2Ev(i1 + 8 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__110__time_putD2Ev(i1 + 8 | 0);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_(i3, i1, i4, i2, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i4;
 return 3;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE10do_unshiftERS1_PcS4_RS4_(i3, i1, i4, i2, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i4;
 return 3;
}

function __ZN7testing14InitGoogleTestEPiPPc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZN7testing8internal18InitGoogleTestImplIcEEvPiPPT_(i1, i2);
 STACKTOP = i3;
 return;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_(i3, i1, i4, i2, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i4;
 return 3;
}

function __ZN4perf17TestBaseWithParamINSt3tr15tupleIN2cv5Size_IiEENS_7MatTypeEvvvvvvvvEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN4perf8TestBaseD2Ev(i1);
 STACKTOP = i2;
 return;
}

function _strcpy(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 do {
  HEAP8[i2 + i1 >> 0] = HEAP8[i3 + i1 >> 0];
  i1 = i1 + 1 | 0;
 } while (HEAP8[i3 + (i1 - 1) >> 0] | 0);
 return i2 | 0;
}

function ___cxa_is_pointer_type(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if (!i1) i1 = 0; else i1 = (___dynamic_cast(i1, 969632, 969800, 0) | 0) != 0;
 STACKTOP = i2;
 return i1 & 1 | 0;
}

function _wcslen(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 i1 = i2;
 while (1) if (!(HEAP32[i1 >> 2] | 0)) break; else i1 = i1 + 4 | 0;
 STACKTOP = i3;
 return i1 - i2 >> 2 | 0;
}

function _mbrlen(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 i1 = _mbrtowc(0, i2, i1, (i3 | 0) != 0 ? i3 : 968592) | 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNSt3__121__throw_runtime_errorEPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = ___cxa_allocate_exception(8) | 0;
 __ZNSt13runtime_errorC2EPKc(i2, i1);
 ___cxa_throw(i2 | 0, 969408, 128);
}

function __ZN7testing8internal24ParameterizedTestFactoryI41Size_MatType_bitwise_not_bitwise_not_TestED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function _i64Subtract(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 - i4 - (i3 >>> 0 > i1 >>> 0 | 0) >>> 0;
 return (tempRet0 = i2, i1 - i3 >>> 0 | 0) | 0;
}

function __ZN7testing8internal17TestEventRepeaterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN7testing8internal17TestEventRepeaterD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN4perf8TestBase15RunPerfTestBodyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 FUNCTION_TABLE_vi[HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] & 511](i1);
 STACKTOP = i2;
 return;
}

function __ZNK2cv10HdrDecoder15signatureLengthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i1 = HEAP32[i1 + 96 >> 2] | 0;
 return (i2 >>> 0 > i1 >>> 0 ? i2 : i1) | 0;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_116DefaultFormatterENS_14DefaultDeleterIS3_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__114basic_iostreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + 12 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_115PythonFormatterENS_14DefaultDeleterIS3_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_115MatlabFormatterENS_14DefaultDeleterIS3_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function dynCall_iiiii(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return FUNCTION_TABLE_iiiii[i5 & 7](i1 | 0, i2 | 0, i3 | 0, i4 | 0) | 0;
}

function __ZNSt3__111__stdoutbufIwED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__111__stdoutbufIcED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt13runtime_errorD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 969208;
 __ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_114NumpyFormatterENS_14DefaultDeleterIS3_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function _i64Add(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i3 = i1 + i3 >>> 0;
 return (tempRet0 = i2 + i4 + (i3 >>> 0 < i1 >>> 0 | 0) >>> 0, i3 | 0) | 0;
}

function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__110__stdinbufIwED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__110__stdinbufIcED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_113FormattedImplENS_14DefaultDeleterIS3_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function b8(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 abort(8);
}

function __ZNSt11logic_errorD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 HEAP32[i1 >> 2] = 969184;
 __ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_112CSVFormatterENS_14DefaultDeleterIS3_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZThn8_NSt3__114basic_iostreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + -8 + 12 | 0);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__110moneypunctIwLb1EE16do_positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIwLb0EE16do_positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIcLb1EE16do_positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIcLb0EE16do_positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN7testing8internal15TestMetaFactoryI41Size_MatType_bitwise_not_bitwise_not_TestED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_110CFormatterENS_14DefaultDeleterIS3_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__110__stdinbufIwE9underflowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = __ZNSt3__110__stdinbufIwE9__getcharEb(i1, 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__110__stdinbufIcE9underflowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = __ZNSt3__110__stdinbufIcE9__getcharEb(i1, 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__17codecvtIwc11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__17codecvtIwc11__mbstate_tED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__110moneypunctIwLb1EE14do_curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIwLb0EE14do_curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIcLb1EE14do_curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIcLb0EE14do_curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN7testing8internal26GoogleTestFailureExceptionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt13runtime_errorD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN7testing8internal12UnitTestImplD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN7testing8internal12UnitTestImplD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function b19(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 abort(19);
 return 0;
}

function _vsprintf(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 i1 = _vsnprintf(i3, 2147483647, i2, i1) | 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZThn184_N41Size_MatType_bitwise_not_bitwise_not_TestD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN4perf8TestBaseD2Ev(i1 + -184 | 0);
 STACKTOP = i2;
 return;
}

function __ZN41Size_MatType_bitwise_not_bitwise_not_Test4BodyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN4perf8TestBase15RunPerfTestBodyEv(i1);
 STACKTOP = i2;
 return;
}

function __GLOBAL__I_a1104() {
 var i1 = 0;
 i1 = STACKTOP;
 __ZN2cv21ImageCodecInitializerC2Ev(178072);
 ___cxa_atexit(381, 178072, ___dso_handle | 0) | 0;
 STACKTOP = i1;
 return;
}

function __ZNSt3__16locale5__imp12make_classicEv() {
 var i1 = 0;
 i1 = STACKTOP;
 __ZNSt3__16locale5__impC2Ej(965072, 1);
 HEAP32[240166] = 965072;
 STACKTOP = i1;
 return 960664;
}

function __ZNK2cv15StdMatAllocator8allocateEPNS_8UMatDataEiNS_14UMatUsageFlagsE(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (i4 | 0) != 0 | 0;
}

function __ZNSt3__15ctypeIcE21__classic_upper_tableEv() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 i1 = HEAP32[(___ctype_toupper_loc() | 0) >> 2] | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__15ctypeIcE21__classic_lower_tableEv() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 i1 = HEAP32[(___ctype_tolower_loc() | 0) >> 2] | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__110__stdinbufIwE5uflowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = __ZNSt3__110__stdinbufIwE9__getcharEb(i1, 1) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__110__stdinbufIcE5uflowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = __ZNSt3__110__stdinbufIcE9__getcharEb(i1, 1) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNKSt3__110moneypunctIwLb1EE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIwLb0EE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIcLb1EE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNKSt3__110moneypunctIcLb0EE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 0 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function dynCall_viiii(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 FUNCTION_TABLE_viiii[i5 & 63](i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function __ZNSt3__16localeD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__114__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
 STACKTOP = i2;
 return;
}

function __ZNKSt3__114error_category23default_error_conditionEi(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 return;
}

function __ZN6cvtestL13signalHandlerEi(i1) {
 i1 = i1 | 0;
 if ((i1 | 0) == 7 | (i1 | 0) == 11) i1 = -6; else if ((i1 | 0) == 8) i1 = -6; else i1 = -4;
 _longjmp(158008, i1 | 0);
}

function __ZN2cv6detail12PtrOwnerImplINS_16SunRasterEncoderENS_14DefaultDeleterIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_16SunRasterDecoderENS_14DefaultDeleterIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_113FormattedImplD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN12_GLOBAL__N_113FormattedImplD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function _strrchr(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = ___memrchr(i2, i1, (_strlen(i2 | 0) | 0) + 1 | 0) | 0;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN41Size_MatType_bitwise_not_bitwise_not_TestD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN4perf8TestBaseD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_4cuda6Stream4ImplENS_14DefaultDeleterIS4_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function _strtoull_l(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 i1 = _strtoull(i4, i3, i1) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__114basic_iostreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + 12 | 0);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__18messagesIwE8do_closeEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = STACKTOP;
 _catclose(((i1 | 0) == -1 ? -1 : i1 << 1) | 0) | 0;
 STACKTOP = i2;
 return;
}

function __ZNKSt3__18messagesIcE8do_closeEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = STACKTOP;
 _catclose(((i1 | 0) == -1 ? -1 : i1 << 1) | 0) | 0;
 STACKTOP = i2;
 return;
}

function __ZNKSt3__18ios_base6getlocEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 __ZNSt3__16localeC2ERKS0_(i1, i2 + 28 | 0);
 STACKTOP = i3;
 return;
}

function __ZN7testing8TestCase19RunTearDownTestCaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 FUNCTION_TABLE_v[HEAP32[i1 + 48 >> 2] & 7]();
 STACKTOP = i2;
 return;
}

function __ZN2cv15setUseOptimizedEb(i1) {
 i1 = i1 | 0;
 HEAP8[19544] = i1 & 1;
 i1 = i1 ? 19008 : 19272;
 HEAP32[4884] = i1;
 HEAP8[19552] = HEAP8[i1 + 7 >> 0] | 0;
 return;
}

function _strtoll_l(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 i1 = _strtoll(i4, i3, i1) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _isalnum(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if (!(_isalpha(i1) | 0)) i1 = (i1 + -48 | 0) >>> 0 < 10; else i1 = 1;
 STACKTOP = i2;
 return i1 & 1 | 0;
}

function __ZZN4perf8TestBase10_calibrateEvEN7_helperD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN4perf8TestBaseD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + 4 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + 8 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1 + 8 | 0);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_11TiffEncoderENS_14DefaultDeleterIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function dynCall_viiid(i5, i1, i2, i3, d4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 FUNCTION_TABLE_viiid[i5 & 31](i1 | 0, i2 | 0, i3 | 0, +d4);
}

function _do_read(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 i1 = ___string_read(i2, i1, i3) | 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNK10__cxxabiv116__enum_type_info9can_catchEPKNS_16__shim_type_infoERPv(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return (i2 | 0) == (i3 | 0) | 0;
}

function __ZN2cvL16deleteTLSStorageEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if (i1) {
  __ZN2cv10TLSStorageD2Ev(i1);
  __ZdlPv(i1);
 }
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_4cuda6StreamENS_14DefaultDeleterIS3_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_10PxMEncoderENS_14DefaultDeleterIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_10PxMDecoderENS_14DefaultDeleterIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_10HdrEncoderENS_14DefaultDeleterIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_10HdrDecoderENS_14DefaultDeleterIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_10BmpEncoderENS_14DefaultDeleterIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_10BmpDecoderENS_14DefaultDeleterIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_110CLAHE_ImplD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN12_GLOBAL__N_110CLAHE_ImplD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function dynCall_viidi(i5, i1, i2, d3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 FUNCTION_TABLE_viidi[i5 & 7](i1 | 0, i2 | 0, +d3, i4 | 0);
}

function dynCall_vidii(i5, i1, d2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 i4 = i4 | 0;
 FUNCTION_TABLE_vidii[i5 & 3](i1 | 0, +d2, i3 | 0, i4 | 0);
}

function __ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN7testing8TestCase16RunSetUpTestCaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 FUNCTION_TABLE_v[HEAP32[i1 + 44 >> 2] & 7]();
 STACKTOP = i2;
 return;
}

function __ZN2cv7TLSDataINS_11CoreTLSDataEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN2cv16TLSDataContainerD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplI13CvFileStorageNS_14DefaultDeleterIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function b15(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 abort(15);
}

function __ZSt11__terminatePFvvE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 FUNCTION_TABLE_v[i1 & 7]();
 _abort_message(969048, i2);
}

function __ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6detail12PtrOwnerImplINS_9AlgorithmENS_14DefaultDeleterIS2_EEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __GLOBAL__I_a1953() {
 var i1 = 0;
 i1 = STACKTOP;
 __ZNSt3__18ios_base4InitC2Ev(0);
 ___cxa_atexit(394, 956768, ___dso_handle | 0) | 0;
 STACKTOP = i1;
 return;
}

function __ZNK7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8Iterator13BaseGeneratorEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function _wctomb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 if (!i1) i1 = 0; else i1 = _wcrtomb(i1, i2, 0) | 0;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNSt3__15ctypeIcE13classic_tableEv() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 i1 = HEAP32[(___ctype_b_loc() | 0) >> 2] | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _zcalloc(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = STACKTOP;
 i1 = _malloc(Math_imul(i3, i1) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__18ios_base7failureD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__112system_errorD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__16locale2id6__initEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[240178] | 0;
 HEAP32[240178] = i2 + 1;
 HEAP32[i1 + 4 >> 2] = i2 + 1;
 return;
}

function __ZN7testing8internal38DefaultPerThreadTestPartResultReporterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv16TLSDataContainerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN2cv16TLSDataContainerD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv16SunRasterDecoderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN2cv16SunRasterDecoderD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function dynCall_iiii(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return FUNCTION_TABLE_iiii[i4 & 63](i1 | 0, i2 | 0, i3 | 0) | 0;
}

function ___expo2(d1) {
 d1 = +d1;
 d1 = +Math_exp(+(d1 + -1416.0996898839683)) * 2247116418577894884661631.0e283 * 2247116418577894884661631.0e283;
 return +d1;
}

function __ZNSt3__19basic_iosIwNS_11char_traitsIwEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__19basic_iosIcNS_11char_traitsIcEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1);
 STACKTOP = i2;
 return;
}

function __ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8Iterator13BaseGeneratorEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZN7testing8internal35DefaultGlobalTestPartResultReporterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__16locale5__impD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__16locale5__impD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8Iterator13BaseGeneratorEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function dynCall_diii(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return +FUNCTION_TABLE_diii[i4 & 7](i1 | 0, i2 | 0, i3 | 0);
}

function __ZNSt3__112system_errorD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt13runtime_errorD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__18numpunctIwED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18numpunctIwED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__18numpunctIcED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18numpunctIcED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv11WBaseStream6getPosEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 12 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) - (HEAP32[i1 + 4 >> 2] | 0) | 0;
}

function __ZN2cv11RBaseStream6getPosEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) + (HEAP32[i1 + 28 >> 2] | 0) - (HEAP32[i1 + 8 >> 2] | 0) | 0;
}

function _toupper(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 i2 = (_islower(i1) | 0) == 0;
 STACKTOP = i3;
 return (i2 ? i1 : i1 & 95) | 0;
}

function _tolower(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 i2 = (_isupper(i1) | 0) == 0;
 STACKTOP = i3;
 return (i2 ? i1 : i1 | 32) | 0;
}

function __ZSt17__throw_bad_allocv() {
 var i1 = 0;
 i1 = ___cxa_allocate_exception(4) | 0;
 __ZNSt9bad_allocC2Ev(i1);
 ___cxa_throw(i1 | 0, 969032, 328);
}

function __ZNSt13runtime_errorD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt13runtime_errorD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN7testing8TestCaseD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN7testing8TestCaseD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv5Mutex6unlockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 _pthread_mutex_unlock(HEAP32[i1 >> 2] | 0) | 0;
 STACKTOP = i2;
 return;
}

function ___udivdi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = ___udivmoddi4(i1, i2, i3, i4, 0) | 0;
 return i1 | 0;
}

function __ZN2cv6theRNGEv() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 i1 = __ZNK2cv16TLSDataContainer7getDataEv(26832) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN2cv12WMByteStreamD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN2cv11WBaseStreamD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv12WLByteStreamD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN2cv11WBaseStreamD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function b20(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 abort(20);
}

function __ZN2cv11WBaseStreamD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN2cv11WBaseStreamD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv11FileStorageD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN2cv11FileStorageD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function runPostSets() {}
function _strlen(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2;
 while (HEAP8[i1 >> 0] | 0) i1 = i1 + 1 | 0;
 return i1 - i2 | 0;
}

function __ZNSt12out_of_rangeD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt11logic_errorD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt12length_errorD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt11logic_errorD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function dynCall_viii(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 FUNCTION_TABLE_viii[i4 & 63](i1 | 0, i2 | 0, i3 | 0);
}

function _lrint(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 i3 = _fetestexcept(32) | 0;
 d1 = +_rint(d1);
 STACKTOP = i2;
 return ~~d1 | 0;
}

function __ZNSt3__18ios_baseD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__18ios_baseD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__15ctypeIcED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__15ctypeIcED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt11logic_errorD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt11logic_errorD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNK7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8Iterator7CurrentEv(i1) {
 i1 = i1 | 0;
 return i1 + 32 | 0;
}

function __ZN2cv5Mutex4lockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 _pthread_mutex_lock(HEAP32[i1 >> 2] | 0) | 0;
 STACKTOP = i2;
 return;
}

function __ZN2cv10PxMDecoderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN2cv10PxMDecoderD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv10HdrDecoderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN2cv10HdrDecoderD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv10BmpDecoderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN2cv10BmpDecoderD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function b21(i1, i2, i3, i4, i5, i6, d7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 d7 = +d7;
 abort(21);
}

function __ZNSt3__18ios_base7failureD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt3__112system_errorD2Ev(i1);
 STACKTOP = i2;
 return;
}

function __ZNK2cv8FileNode4typeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] & 7;
 return i1 | 0;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter25OnEnvironmentsTearDownEndERKNS_8UnitTestE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN7testing22EmptyTestEventListener20OnTestIterationStartERKNS_8UnitTestEi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN2cv11RBaseStream4skipEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 16 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i1;
 return;
}

function ___cxa_bad_typeid() {
 var i1 = 0;
 i1 = ___cxa_allocate_exception(4) | 0;
 __ZNSt10bad_typeidC2Ev(i1);
 ___cxa_throw(i1 | 0, 969576, 337);
}

function __ZN4perf8TestBaseD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN4perf8TestBaseD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}
function stackAlloc(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + i1 | 0;
 STACKTOP = STACKTOP + 15 & -16;
 return i2 | 0;
}

function _gzopen(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 i1 = _gz_open(i2, -1, i1) | 0;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter22OnEnvironmentsSetUpEndERKNS_8UnitTestE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZL14icvIsSparseMatPKv(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = (HEAP32[i1 >> 2] & -65536 | 0) == 1111752704;
 return i1 & 1 | 0;
}

function __ZNK7testing8internal25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE15GetTestCaseNameEv(i1) {
 i1 = i1 | 0;
 return i1 + 4 | 0;
}

function __ZNSt3__114__shared_count12__add_sharedEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZNKSt3__15ctypeIwE9do_narrowEwc(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (i1 >>> 0 < 128 ? i1 & 255 : i2) | 0;
}

function __ZNK2cv16BaseImageEncoder10newEncoderEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZNK2cv16BaseImageDecoder10newDecoderEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN2cv8fastFreeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if (i1) _free(HEAP32[i1 + -4 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZL13icvCloneGraphPKv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = _cvCloneGraph(i1, 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function dynCall_viid(i4, i1, i2, d3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 FUNCTION_TABLE_viid[i4 & 3](i1 | 0, i2 | 0, +d3);
}

function b5(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 abort(5);
 return 0;
}

function __ZNSt3__112system_errorD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZNSt13runtime_errorD2Ev(i1);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__15ctypeIcE9do_narrowEcc(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (i1 << 24 >> 24 > -1 ? i1 : i2) | 0;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i3 | 0;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6setbufEPci(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i3 | 0;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter18OnTestProgramStartERKNS_8UnitTestE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN7testing8internal18OsStackTraceGetterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZL10icvIsMatNDPKv(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = (HEAP32[i1 >> 2] & -65536 | 0) == 1111687168;
 return i1 & 1 | 0;
}

function _isxdigit(i1) {
 i1 = i1 | 0;
 if ((i1 + -48 | 0) >>> 0 < 10) i1 = 1; else i1 = ((i1 | 32) + -97 | 0) >>> 0 < 6;
 return i1 & 1 | 0;
}

function __ZNK7testing8internal25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE17GetTestCaseTypeIdEv(i1) {
 i1 = i1 | 0;
 return 3120;
}

function __ZN2cv14getConvertFuncEii(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAP32[43848 + ((i1 & 7) << 5) + ((i2 & 7) << 2) >> 2] | 0;
}

function __ZN7testing8internal27PrettyUnitTestResultPrinter16OnTestProgramEndERKNS_8UnitTestE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN10__cxxabiv121__vmi_class_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function dynCall_vif(i3, i1, f2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 FUNCTION_TABLE_vif[i3 & 0](i1 | 0, Math_fround(f2));
}

function __ZN7testing8internal19TestMetaFactoryBaseINSt3tr15tupleIN2cv5Size_IiEEN4perf7MatTypeEvvvvvvvvEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10__cxxabiv120__si_class_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZL8icvIsSeqPKv(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = (HEAP32[i1 >> 2] & -65536 | 0) == 1117323264;
 return i1 & 1 | 0;
}

function __ZNSt3__17codecvtIDsc11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__17codecvtIDic11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__117__widen_from_utf8ILj32EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN7testing22EmptyTestEventListener27OnEnvironmentsTearDownStartERKNS_8UnitTestE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN12_GLOBAL__N_116DefaultFormatterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_113FormatterBase12setMultilineEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = i1 & 1;
 return;
}

function __ZNSt3__17codecvtIcc11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__116__narrow_to_utf8ILj32EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv6StringD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZN2cv6String10deallocateEv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_115PythonFormatterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_115PerfEnvironmentD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_115MatlabFormatterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN10__cxxabiv117__class_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function _copysignl(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var i3 = 0;
 i3 = STACKTOP;
 d1 = +_copysign(d1, d2);
 STACKTOP = i3;
 return +d1;
}

function __ZN7testing22EmptyTestEventListener25OnEnvironmentsTearDownEndERKNS_8UnitTestE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN2cv25DummyBufferPoolControllerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_114NumpyFormatterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_113FormatterBase15set64fPrecisionEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __ZN12_GLOBAL__N_113FormatterBase15set32fPrecisionEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN10__cxxabiv116__enum_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function dynCall_iii(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return FUNCTION_TABLE_iii[i3 & 127](i1 | 0, i2 | 0) | 0;
}

function b16(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 abort(16);
}

function _scalbnl(d2, i1) {
 d2 = +d2;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 d2 = +_scalbn(d2, i1);
 STACKTOP = i3;
 return +d2;
}

function _llvm_bswap_i32(i1) {
 i1 = i1 | 0;
 return (i1 & 255) << 24 | (i1 >> 8 & 255) << 16 | (i1 >> 16 & 255) << 8 | i1 >>> 24 | 0;
}

function __ZN7testing22EmptyTestEventListener24OnEnvironmentsSetUpStartERKNS_8UnitTestE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function _cvFree_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 if (i1) _free(HEAP32[i1 + -4 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN7testing22EmptyTestEventListener16OnTestPartResultERKNS_14TestPartResultE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN12_GLOBAL__N_112CSVFormatterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function _ldexp(d2, i1) {
 d2 = +d2;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 d2 = +_scalbn(d2, i1);
 STACKTOP = i3;
 return +d2;
}

function _frexpl(d2, i1) {
 d2 = +d2;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 d2 = +_frexp(d2, i1);
 STACKTOP = i3;
 return +d2;
}

function __ZNSt3__119__iostream_categoryD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN7testing22EmptyTestEventListener22OnEnvironmentsSetUpEndERKNS_8UnitTestE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN25PerfValidationEnvironmentD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __Z14cvReleaseMatNDPP7CvMatND(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 _cvReleaseMat(i1);
 STACKTOP = i2;
 return;
}

function b14(i1, i2, i3, i4, i5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 abort(14);
}

function _isxdigit_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 i1 = _isxdigit(i1) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN12_GLOBAL__N_110CFormatterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__110moneypunctIwLb1EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__110moneypunctIwLb0EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__110moneypunctIcLb1EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__110moneypunctIcLb0EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNK7testing8UnitTest17current_test_infoEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 108 >> 2] | 0;
}

function __ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZN7testing22EmptyTestEventListener18OnTestProgramStartERKNS_8UnitTestE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function b11(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 abort(11);
 return 0;
}

function _fmodl(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var i3 = 0;
 i3 = STACKTOP;
 d1 = +_fmod(d1, d2);
 STACKTOP = i3;
 return +d1;
}

function __ZNK2cv9Exception4whatEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return ((i1 | 0) == 0 ? 26888 : i1) | 0;
}

function __ZN2cv17_InputOutputArrayD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv17MatOp_InitializerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_110CLAHE_Impl12setClipLimitEd(i2, d1) {
 i2 = i2 | 0;
 d1 = +d1;
 HEAPF64[i2 + 8 >> 3] = d1;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN7testing22EmptyTestEventListener16OnTestProgramEndERKNS_8UnitTestE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN7testing8UnitTest27parameterized_test_registryEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 8 >> 2] | 0) + 84 | 0;
}

function __ZN7testing22EmptyTestEventListener15OnTestCaseStartERKNS_8TestCaseE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN2cv15StdMatAllocatorD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}
function __ZL10icvIsImagePKv(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = (HEAP32[i1 >> 2] | 0) == 112;
 return i1 & 1 | 0;
}

function __ZNSt3__16locale5facetD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv14MatOp_IdentityD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function dynCall_vii(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 FUNCTION_TABLE_vii[i3 & 127](i1 | 0, i2 | 0);
}

function __ZNSt3__18messagesIwED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__18messagesIcED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN7testing22EmptyTestEventListener13OnTestCaseEndERKNS_8TestCaseE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZNSt3__17collateIwED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__17collateIcED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv12_OutputArrayD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv12MatOp_InvertD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function _isspace(i1) {
 i1 = i1 | 0;
 if ((i1 | 0) == 32) i1 = 1; else i1 = (i1 + -9 | 0) >>> 0 < 5;
 return i1 & 1 | 0;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return -1;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return -1;
}

function __ZNK2cv16BaseImageEncoder17isFormatSupportedEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (i1 | 0) == 0 | 0;
}

function __ZNK2cv11TiffEncoder17isFormatSupportedEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (i1 & -3 | 0) == 0 | 0;
}

function __ZN7testing22EmptyTestEventListener11OnTestStartERKNS_8TestInfoE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN2cv11_InputArrayD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv11MatOp_SolveD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv11MatOp_AddExD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__15ctypeIwED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE8overflowEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return -1;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE8overflowEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return -1;
}

function __ZNK2cv12_OutputArray9fixedSizeEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 4 >> 2] & 1073741824 | 0) != 0 | 0;
}

function __ZNK2cv10PxMEncoder17isFormatSupportedEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (i1 & -3 | 0) == 0 | 0;
}

function __ZN2cv10MatOp_GEMMD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt10bad_typeidD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __Znaj(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 i1 = __Znwj(i1) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN7testing22EmptyTestEventListener9OnTestEndERKNS_8TestInfoE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN2cv9MatOp_CmpD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv9MatOp_BinD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN2cv9AlgorithmD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZSt15get_new_handlerv() {
 var i1 = 0;
 i1 = HEAP32[242286] | 0;
 HEAP32[242286] = i1 + 0;
 return i1 | 0;
}

function __ZNSt9bad_allocD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN7testing16AssertionSuccessEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 >> 0] = 1;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN7testing16AssertionFailureEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZNSt8bad_castD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNK2cv17CommandLineParser5checkEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[HEAP32[i1 >> 2] >> 0] | 0) == 0 | 0;
}

function __ZNK2cv12MatAllocator3mapEPNS_8UMatDataEi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN2cv7MatOp_TD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_113FormattedImpl15valueToStrOtherEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 12 >> 0] = 0;
 return;
}

function dynCall_vid(i3, i1, d2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 FUNCTION_TABLE_vid[i3 & 1](i1 | 0, +d2);
}

function __ZNK2cv10HdrEncoder17isFormatSupportedEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (i1 | 0) != 6 | 0;
}

function setThrew(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!__THREW__) {
  __THREW__ = i1;
  threwValue = i2;
 }
}

function b0(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 abort(0);
}

function dynCall_fi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return Math_fround(FUNCTION_TABLE_fi[i2 & 0](i1 | 0));
}

function b18(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 abort(18);
}

function _mbsinit(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 1; else i1 = (HEAP32[i1 >> 2] | 0) == 0;
 return i1 & 1 | 0;
}

function __ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK2cv17MatOp_Initializer11elementWiseERKNS_7MatExprE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv25DummyBufferPoolController18setMaxReservedSizeEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK2cv14MatOp_Identity11elementWiseERKNS_7MatExprE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 1;
}

function __ZNK12_GLOBAL__N_110CLAHE_Impl12getClipLimitEv(i1) {
 i1 = i1 | 0;
 return +(+HEAPF64[i1 + 8 >> 3]);
}

function b28(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 abort(28);
 return 0;
}

function __ZNSt3__114basic_iostreamIcNS_11char_traitsIcEEED2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK2cv16BaseImageDecoder15signatureLengthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __ZNK2cv12MatOp_Invert11elementWiseERKNS_7MatExprE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function _zcfree(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 _free(i2);
 STACKTOP = i1;
 return;
}

function __ZNK2cv11MatOp_Solve11elementWiseERKNS_7MatExprE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZNK2cv11MatOp_AddEx11elementWiseERKNS_7MatExprE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 1;
}

function __ZN12_GLOBAL__N_113FormattedImpl5resetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 108 >> 2] = 0;
 return;
}

function dynCall_ii(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return FUNCTION_TABLE_ii[i2 & 127](i1 | 0) | 0;
}

function ___clang_call_terminate(i1) {
 i1 = i1 | 0;
 ___cxa_begin_catch(i1 | 0) | 0;
 __ZSt9terminatev();
}

function __ZNKSt3__18numpunctIwE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNKSt3__15ctypeIwE8do_widenEc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return i1 << 24 >> 24 | 0;
}

function __ZNK2cv12_OutputArray9fixedTypeEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 4 >> 2] | 0) < 0 | 0;
}

function __ZNK2cv10MatOp_GEMM11elementWiseERKNS_7MatExprE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__18numpunctIwE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZdaPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZNKSt3__18numpunctIcE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 9 >> 0] | 0;
}

function __ZNKSt3__18numpunctIcE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 8 >> 0] | 0;
}

function __ZNK2cv9MatOp_Cmp11elementWiseERKNS_7MatExprE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 1;
}

function __ZNK2cv9MatOp_Bin11elementWiseERKNS_7MatExprE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 1;
}

function __ZN2cv11RBaseStream8isOpenedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 32 >> 0] | 0) != 0 | 0;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9underflowEv(i1) {
 i1 = i1 | 0;
 return -1;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9underflowEv(i1) {
 i1 = i1 | 0;
 return -1;
}

function __ZdlPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 _free(i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9showmanycEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9showmanycEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK2cv7MatOp_T11elementWiseERKNS_7MatExprE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function dynCall_di(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return +FUNCTION_TABLE_di[i2 & 1](i1 | 0);
}

function __ZNK2cv11_InputArray4kindEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] & 2031616 | 0;
}

function __ZNKSt3__110moneypunctIwLb1EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return 2147483647;
}

function __ZNKSt3__110moneypunctIwLb1EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return 2147483647;
}

function __ZNKSt3__110moneypunctIwLb0EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return 2147483647;
}

function __ZNKSt3__110moneypunctIwLb0EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return 2147483647;
}

function __ZN7testing8internal18OsStackTraceGetter16UponLeavingGTestEv(i1) {
 i1 = i1 | 0;
 return;
}

function b33(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 abort(33);
}

function __ZNK2cv25DummyBufferPoolController18getMaxReservedSizeEv(i1) {
 i1 = i1 | 0;
 return -1;
}

function __ZN2cv25DummyBufferPoolController22freeAllReservedBuffersEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE4syncEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE4syncEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function _isdigit_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (i1 + -48 | 0) >>> 0 < 10 | 0;
}

function __ZNKSt3__17codecvtIwc11__mbstate_tE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK2cv16BaseImageDecoder4typeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function dynCall_vi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 FUNCTION_TABLE_vi[i2 & 511](i1 | 0);
}

function b29(i1, i2, i3, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 abort(29);
}

function b10(i1, d2, i3, i4) {
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 i4 = i4 | 0;
 abort(10);
}

function __ZNK2cv25DummyBufferPoolController15getReservedSizeEv(i1) {
 i1 = i1 | 0;
 return -1;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return 4;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return 4;
}

function __ZNKSt3__15ctypeIcE8do_widenEc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return i1 | 0;
}

function b9(i1, i2, d3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 abort(9);
}

function b25(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 abort(25);
 return 0.0;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZZN4perf8TestBase10_calibrateEvEN7_helper8TestBodyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNKSt3__17codecvtIDsc11__mbstate_tE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__17codecvtIDic11__mbstate_tE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__110moneypunctIcLb1EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return 127;
}

function __ZNKSt3__110moneypunctIcLb1EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return 127;
}

function __ZNKSt3__110moneypunctIcLb0EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return 127;
}

function __ZNKSt3__110moneypunctIcLb0EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return 127;
}

function __ZN7testing8internal27OsStackTraceGetterInterfaceD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function b13(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 abort(13);
 return 0;
}

function __ZNKSt3__17codecvtIcc11__mbstate_tE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNKSt13runtime_error4whatEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNKSt11logic_error4whatEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNKSt3__110moneypunctIwLb1EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__110moneypunctIwLb0EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__110moneypunctIcLb1EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__110moneypunctIcLb0EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNSt10bad_typeidC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 969472;
 return;
}

function __ZN7testing31TestPartResultReporterInterfaceD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt9bad_allocC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 968984;
 return;
}

function __ZN2cv9AlgorithmC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 37896;
 return;
}

function __ZNSt8bad_castC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 969432;
 return;
}

function __ZNKSt3__119__iostream_category4nameEv(i1) {
 i1 = i1 | 0;
 return 958168;
}

function __ZN12_GLOBAL__N_115PerfEnvironment8TearDownEv(i1) {
 i1 = i1 | 0;
 return;
}

function _isalpha(i1) {
 i1 = i1 | 0;
 return ((i1 | 32) + -97 | 0) >>> 0 < 26 | 0;
}

function __ZNK10__cxxabiv116__shim_type_info5noop2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK10__cxxabiv116__shim_type_info5noop1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv3ocl5QueueC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function b30(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 abort(30);
}

function __ZN7testing8internal15TestFactoryBaseD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK2cv10PxMDecoder15signatureLengthEv(i1) {
 i1 = i1 | 0;
 return 3;
}

function dynCall_i(i1) {
 i1 = i1 | 0;
 return FUNCTION_TABLE_i[i1 & 1]() | 0;
}

function b32(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 abort(32);
}

function __ZN25PerfValidationEnvironment5SetUpEv(i1) {
 i1 = i1 | 0;
 return;
}

function _isupper(i1) {
 i1 = i1 | 0;
 return (i1 + -65 | 0) >>> 0 < 26 | 0;
}

function _islower(i1) {
 i1 = i1 | 0;
 return (i1 + -97 | 0) >>> 0 < 26 | 0;
}

function __ZN10__cxxabiv116__shim_type_infoD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN7testing8internal6IsTrueEb(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function b12(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 abort(12);
 return 0;
}

function __ZN7testing17TestEventListenerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN7testing11Environment5SetupEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNSt3__110moneypunctIwLb1EED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__110moneypunctIwLb0EED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__110moneypunctIcLb1EED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__110moneypunctIcLb0EED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNKSt10bad_typeid4whatEv(i1) {
 i1 = i1 | 0;
 return 969488;
}

function __ZN7testing11Environment5SetUpEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv20BufferPoolControllerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function b1(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 abort(1);
}

function b22(i1) {
 i1 = i1 | 0;
 abort(22);
 return Math_fround(0);
}

function __ZNSt3__114error_categoryD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__114__shared_countD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNKSt9bad_alloc4whatEv(i1) {
 i1 = i1 | 0;
 return 969e3;
}

function __ZNKSt8bad_cast4whatEv(i1) {
 i1 = i1 | 0;
 return 969448;
}

function __ZN2cv4cuda7CudaMem7releaseEv(i1) {
 i1 = i1 | 0;
 return;
}

function dynCall_v(i1) {
 i1 = i1 | 0;
 FUNCTION_TABLE_v[i1 & 7]();
}

function __ZN7testing11EnvironmentD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv4cuda6GpuMat7releaseEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv16ParallelLoopBodyD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN7testing4Test8TearDownEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv3ogl6Buffer7releaseEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv3ipp12getIppStatusEv() {
 return HEAP32[6710] | 0;
}

function ___cxa_pure_virtual__wrapper() {
 ___cxa_pure_virtual();
}

function __ZNSt3__16locale5facetD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__112__do_nothingEPv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK2cv9Algorithm4infoEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN7testing4Test5SetupEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN2cv6detail8PtrOwnerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__18messagesIwED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__18messagesIcED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__17collateIwED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__17collateIcED1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN7testing4Test5SetUpEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv4cuda6GpuMat16defaultAllocatorEv() {
 return 0;
}

function __ZN2cv12MatAllocatorD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv13setNumThreadsEi(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv11_InputArrayD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function b4(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 abort(4);
}

function __ZNSt10bad_typeidD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN7testing8internal5posix5AbortEv() {
 _abort();
}

function __ZN7testing4Test16TearDownTestCaseEv() {
 return;
}

function __ZN2cv9FormatterD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv9AlgorithmD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv24currentParallelFrameworkEv() {
 return 0;
}

function __ZNSt9type_infoD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt9exceptionD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt9bad_allocD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function stackRestore(i1) {
 i1 = i1 | 0;
 STACKTOP = i1;
}

function b2(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 abort(2);
}

function b17(i1) {
 i1 = i1 | 0;
 abort(17);
 return 0.0;
}

function __ZNSt8bad_castD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function setTempRet0(i1) {
 i1 = i1 | 0;
 tempRet0 = i1;
}

function __ZN7testing4Test13SetUpTestCaseEv() {
 return;
}

function __ZN2cv5MatOpD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2cv16getTickFrequencyEv() {
 return 1.0e6;
}

function _feclearexcept(i1) {
 i1 = i1 | 0;
 return 0;
}

function b6(i1) {
 i1 = i1 | 0;
 abort(6);
 return 0;
}

function _fetestexcept(i1) {
 i1 = i1 | 0;
 return 0;
}

function _cvSetErrStatus(i1) {
 i1 = i1 | 0;
 return;
}

function getTempRet0() {
 return tempRet0 | 0;
}

function __ZN2cv7noArrayEv() {
 return 31384;
}

function stackSave() {
 return STACKTOP | 0;
}

function b3(i1) {
 i1 = i1 | 0;
 abort(3);
}

function b26() {
 abort(26);
 return 0;
}

function _cvGetErrStatus() {
 return 0;
}

function b31() {
 abort(31);
}

// EMSCRIPTEN_END_FUNCS
  var FUNCTION_TABLE_viiiii = [b0,__ZN2cvL12transpose_8uEPKhjPhjNS_5Size_IiEE,__ZN2cvL13transpose_16uEPKhjPhjNS_5Size_IiEE,__ZN2cvL14transpose_8uC3EPKhjPhjNS_5Size_IiEE,__ZN2cvL13transpose_32sEPKhjPhjNS_5Size_IiEE,__ZN2cvL15transpose_16uC3EPKhjPhjNS_5Size_IiEE,__ZN2cvL15transpose_32sC2EPKhjPhjNS_5Size_IiEE,__ZN2cvL15transpose_32sC3EPKhjPhjNS_5Size_IiEE,__ZN2cvL15transpose_32sC4EPKhjPhjNS_5Size_IiEE,__ZN2cvL15transpose_32sC6EPKhjPhjNS_5Size_IiEE,__ZN2cvL15transpose_32sC8EPKhjPhjNS_5Size_IiEE,__ZNK2cv5MatOp3roiERKNS_7MatExprERKNS_5RangeES6_RS1_,__ZN2cvL8randi_8uEPhiPyPKNS_9DivStructEb,__ZN2cvL8randi_8sEPaiPyPKNS_9DivStructEb,__ZN2cvL9randi_16uEPtiPyPKNS_9DivStructEb,__ZN2cvL9randi_16sEPsiPyPKNS_9DivStructEb,__ZN2cvL9randi_32sEPiiPyPKNS_9DivStructEb,__ZN2cvL9randf_32fEPfiPyPKNS_3VecIfLi2EEEb,__ZN2cvL9randf_64fEPdiPyPKNS_3VecIdLi2EEEb,__ZN2cvL11randBits_8uEPhiPyPKNS_3VecIiLi2EEEb,__ZN2cvL11randBits_8sEPaiPyPKNS_3VecIiLi2EEEb,__ZN2cvL12randBits_16uEPtiPyPKNS_3VecIiLi2EEEb,__ZN2cvL12randBits_16sEPsiPyPKNS_3VecIiLi2EEEb,__ZN2cvL12randBits_32sEPiiPyPKNS_3VecIiLi2EEEb,__ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib,__ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib,__ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib,__ZN2cvL12scaleAdd_64fEPKdS1_PdiS2_,__ZN2cvL12scaleAdd_32fEPKfS1_PfiS2_
  ,b0,b0,b0];
  var FUNCTION_TABLE_vif = [b1];
  var FUNCTION_TABLE_vid = [b2,__ZN12_GLOBAL__N_110CLAHE_Impl12setClipLimitEd];
  var FUNCTION_TABLE_vi = [b3,__ZN4perf17TestBaseWithParamINSt3tr15tupleIN2cv5Size_IiEENS_7MatTypeEvvvvvvvvEEED2Ev,__ZN41Size_MatType_bitwise_not_bitwise_not_TestD0Ev,__ZN4perf8TestBase5SetUpEv,__ZN4perf8TestBase8TearDownEv,__ZN41Size_MatType_bitwise_not_bitwise_not_Test8TestBodyEv,__ZN24Size_MatType_bitwise_not12PerfTestBodyEv,__ZN41Size_MatType_bitwise_not_bitwise_not_Test4BodyEv,__ZThn184_N41Size_MatType_bitwise_not_bitwise_not_TestD1Ev,__ZThn184_N41Size_MatType_bitwise_not_bitwise_not_TestD0Ev,__ZN7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEED2Ev,__ZN7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEED0Ev,__ZN7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8IteratorD2Ev,__ZN7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8IteratorD0Ev,__ZN7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8Iterator7AdvanceEv,__ZN7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEED2Ev,__ZN7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEED0Ev,__ZN7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8IteratorD2Ev,__ZN7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8IteratorD0Ev,__ZN7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8Iterator7AdvanceEv,__ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEED2Ev,__ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEED0Ev,__ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8IteratorD2Ev,__ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8IteratorD0Ev,__ZN7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8Iterator7AdvanceEv,__ZN7testing8internal25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notED2Ev,__ZN7testing8internal25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notED0Ev,__ZN7testing8internal25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE13RegisterTestsEv,__ZNSt3__118basic_stringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev
  ,__ZNSt3__118basic_stringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev,__ZThn8_NSt3__118basic_stringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev,__ZThn8_NSt3__118basic_stringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev,__ZTv0_n12_NSt3__118basic_stringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev,__ZTv0_n12_NSt3__118basic_stringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev,__ZNSt3__114basic_iostreamIcNS_11char_traitsIcEEED1Ev,__ZNSt3__114basic_iostreamIcNS_11char_traitsIcEEED0Ev,__ZThn8_NSt3__114basic_iostreamIcNS_11char_traitsIcEEED1Ev,__ZThn8_NSt3__114basic_iostreamIcNS_11char_traitsIcEEED0Ev,__ZTv0_n12_NSt3__114basic_iostreamIcNS_11char_traitsIcEEED1Ev,__ZTv0_n12_NSt3__114basic_iostreamIcNS_11char_traitsIcEEED0Ev,__ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev,__ZNSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev,__ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED1Ev,__ZTv0_n12_NSt3__113basic_istreamIcNS_11char_traitsIcEEED0Ev,__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev,__ZNSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev,__ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED1Ev,__ZTv0_n12_NSt3__113basic_ostreamIcNS_11char_traitsIcEEED0Ev,__ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev,__ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev,__ZN2cv11_InputArrayD2Ev,__ZN2cv17_InputOutputArrayD0Ev,__ZNK2cv12_OutputArray7releaseEv,__ZNK2cv12_OutputArray5clearEv,__ZN7testing8internal19TestMetaFactoryBaseINSt3tr15tupleIN2cv5Size_IiEEN4perf7MatTypeEvvvvvvvvEEED2Ev,__ZN7testing8internal15TestMetaFactoryI41Size_MatType_bitwise_not_bitwise_not_TestED0Ev,__ZN7testing8internal15TestFactoryBaseD2Ev,__ZN7testing8internal24ParameterizedTestFactoryI41Size_MatType_bitwise_not_bitwise_not_TestED0Ev,__ZN2cv9FormatterD2Ev
  ,__ZN12_GLOBAL__N_110CFormatterD0Ev,__ZN12_GLOBAL__N_113FormattedImpl5resetEv,__ZN12_GLOBAL__N_113FormattedImplD2Ev,__ZN12_GLOBAL__N_113FormattedImplD0Ev,__ZN2cv6detail8PtrOwnerD2Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_113FormattedImplENS_14DefaultDeleterIS3_EEED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_113FormattedImplENS_14DefaultDeleterIS3_EEE10deleteSelfEv,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_110CFormatterENS_14DefaultDeleterIS3_EEED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_110CFormatterENS_14DefaultDeleterIS3_EEE10deleteSelfEv,__ZN12_GLOBAL__N_114NumpyFormatterD0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_114NumpyFormatterENS_14DefaultDeleterIS3_EEED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_114NumpyFormatterENS_14DefaultDeleterIS3_EEE10deleteSelfEv,__ZN12_GLOBAL__N_115PythonFormatterD0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_115PythonFormatterENS_14DefaultDeleterIS3_EEED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_115PythonFormatterENS_14DefaultDeleterIS3_EEE10deleteSelfEv,__ZN12_GLOBAL__N_112CSVFormatterD0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_112CSVFormatterENS_14DefaultDeleterIS3_EEED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_112CSVFormatterENS_14DefaultDeleterIS3_EEE10deleteSelfEv,__ZN12_GLOBAL__N_115MatlabFormatterD0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_115MatlabFormatterENS_14DefaultDeleterIS3_EEED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_115MatlabFormatterENS_14DefaultDeleterIS3_EEE10deleteSelfEv,__ZN12_GLOBAL__N_116DefaultFormatterD0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_116DefaultFormatterENS_14DefaultDeleterIS3_EEED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_116DefaultFormatterENS_14DefaultDeleterIS3_EEE10deleteSelfEv,__ZN2cv11FileStorageD2Ev,__ZN2cv11FileStorageD0Ev,__ZN2cv11FileStorage7releaseEv,__ZN2cv6detail12PtrOwnerImplI13CvFileStorageNS_14DefaultDeleterIS2_EEED0Ev,__ZN2cv6detail12PtrOwnerImplI13CvFileStorageNS_14DefaultDeleterIS2_EEE10deleteSelfEv,__ZN2cv6detail12PtrOwnerImplINS_4cuda6StreamENS_14DefaultDeleterIS3_EEED0Ev
  ,__ZN2cv6detail12PtrOwnerImplINS_4cuda6StreamENS_14DefaultDeleterIS3_EEE10deleteSelfEv,__ZN2cv6detail12PtrOwnerImplINS_4cuda6Stream4ImplENS_14DefaultDeleterIS4_EEED0Ev,__ZN2cv6detail12PtrOwnerImplINS_4cuda6Stream4ImplENS_14DefaultDeleterIS4_EEE10deleteSelfEv,__ZN2cv9ExceptionD2Ev,__ZN2cv9ExceptionD0Ev,__ZN2cv16TLSDataContainerD2Ev,__ZN2cv16TLSDataContainerD0Ev,__ZN2cv7TLSDataINS_11CoreTLSDataEED0Ev,__ZN2cv11_InputArrayD0Ev,__ZN2cv12_OutputArrayD0Ev,__ZN2cv12MatAllocatorD2Ev,__ZN2cv15StdMatAllocatorD0Ev,__ZN2cv25DummyBufferPoolController22freeAllReservedBuffersEv,__ZN2cv20BufferPoolControllerD2Ev,__ZN2cv25DummyBufferPoolControllerD0Ev,__ZN2cv5MatOpD2Ev,__ZN2cv14MatOp_IdentityD0Ev,__ZN2cv11MatOp_AddExD0Ev,__ZN2cv9MatOp_BinD0Ev,__ZN2cv9MatOp_CmpD0Ev,__ZN2cv10MatOp_GEMMD0Ev,__ZN2cv12MatOp_InvertD0Ev,__ZN2cv7MatOp_TD0Ev,__ZN2cv11MatOp_SolveD0Ev,__ZN2cv17MatOp_InitializerD0Ev,__ZN2cv9AlgorithmD2Ev,__ZN2cv9AlgorithmD0Ev,__ZN2cv6detail12PtrOwnerImplINS_9AlgorithmENS_14DefaultDeleterIS2_EEED0Ev,__ZN2cv6detail12PtrOwnerImplINS_9AlgorithmENS_14DefaultDeleterIS2_EEE10deleteSelfEv,__ZN6cvtest2TSD2Ev
  ,__ZN6cvtest2TSD0Ev,__ZN6cvtest2TS16set_gtest_statusEv,__ZN7testing31TestPartResultReporterInterfaceD2Ev,__ZN7testing8internal35DefaultGlobalTestPartResultReporterD0Ev,__ZN7testing8internal38DefaultPerThreadTestPartResultReporterD0Ev,__ZN7testing4TestD2Ev,__ZN7testing4TestD0Ev,__ZN7testing4Test5SetUpEv,__ZN7testing4Test8TearDownEv,__ZNSt13runtime_errorD2Ev,__ZN7testing8internal26GoogleTestFailureExceptionD0Ev,__ZN7testing8TestCaseD2Ev,__ZN7testing8TestCaseD0Ev,__ZN7testing8internal17TestEventRepeaterD2Ev,__ZN7testing8internal17TestEventRepeaterD0Ev,__ZN7testing8internal24XmlUnitTestResultPrinterD2Ev,__ZN7testing8internal24XmlUnitTestResultPrinterD0Ev,__ZN7testing8UnitTestD2Ev,__ZN7testing8UnitTestD0Ev,__ZN7testing8internal12UnitTestImplD2Ev,__ZN7testing8internal12UnitTestImplD0Ev,__ZN7testing8internal27OsStackTraceGetterInterfaceD2Ev,__ZN7testing8internal18OsStackTraceGetterD0Ev,__ZN7testing8internal18OsStackTraceGetter16UponLeavingGTestEv,__ZN7testing17TestEventListenerD2Ev,__ZN7testing8internal27PrettyUnitTestResultPrinterD0Ev,__ZN4perf8TestBaseD2Ev,__ZN4perf8TestBaseD0Ev,__ZZN4perf8TestBase10_calibrateEvEN7_helperD0Ev,__ZZN4perf8TestBase10_calibrateEvEN7_helper8TestBodyEv
  ,__ZZN4perf8TestBase10_calibrateEvEN7_helper12PerfTestBodyEv,__ZN7testing11EnvironmentD2Ev,__ZN25PerfValidationEnvironmentD0Ev,__ZN25PerfValidationEnvironment5SetUpEv,__ZN25PerfValidationEnvironment8TearDownEv,__ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED1Ev,__ZNSt3__114basic_ofstreamIcNS_11char_traitsIcEEED0Ev,__ZTv0_n12_NSt3__114basic_ofstreamIcNS_11char_traitsIcEEED1Ev,__ZTv0_n12_NSt3__114basic_ofstreamIcNS_11char_traitsIcEEED0Ev,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED2Ev,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEED0Ev,__ZNSt3__114basic_ifstreamIcNS_11char_traitsIcEEED1Ev,__ZNSt3__114basic_ifstreamIcNS_11char_traitsIcEEED0Ev,__ZTv0_n12_NSt3__114basic_ifstreamIcNS_11char_traitsIcEEED1Ev,__ZTv0_n12_NSt3__114basic_ifstreamIcNS_11char_traitsIcEEED0Ev,__ZN12_GLOBAL__N_115PerfEnvironmentD0Ev,__ZN7testing11Environment5SetUpEv,__ZN12_GLOBAL__N_115PerfEnvironment8TearDownEv,__ZN2cv6detail12PtrOwnerImplINS_11TiffEncoderENS_14DefaultDeleterIS2_EEED0Ev,__ZN2cv6detail12PtrOwnerImplINS_11TiffEncoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv,__ZN2cv6detail12PtrOwnerImplINS_10PxMEncoderENS_14DefaultDeleterIS2_EEED0Ev,__ZN2cv6detail12PtrOwnerImplINS_10PxMEncoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv,__ZN2cv6detail12PtrOwnerImplINS_10PxMDecoderENS_14DefaultDeleterIS2_EEED0Ev,__ZN2cv6detail12PtrOwnerImplINS_10PxMDecoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv,__ZN2cv6detail12PtrOwnerImplINS_16SunRasterEncoderENS_14DefaultDeleterIS2_EEED0Ev,__ZN2cv6detail12PtrOwnerImplINS_16SunRasterEncoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv,__ZN2cv6detail12PtrOwnerImplINS_16SunRasterDecoderENS_14DefaultDeleterIS2_EEED0Ev,__ZN2cv6detail12PtrOwnerImplINS_16SunRasterDecoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv,__ZN2cv6detail12PtrOwnerImplINS_10HdrEncoderENS_14DefaultDeleterIS2_EEED0Ev,__ZN2cv6detail12PtrOwnerImplINS_10HdrEncoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv
  ,__ZN2cv6detail12PtrOwnerImplINS_10HdrDecoderENS_14DefaultDeleterIS2_EEED0Ev,__ZN2cv6detail12PtrOwnerImplINS_10HdrDecoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv,__ZN2cv6detail12PtrOwnerImplINS_10BmpEncoderENS_14DefaultDeleterIS2_EEED0Ev,__ZN2cv6detail12PtrOwnerImplINS_10BmpEncoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv,__ZN2cv6detail12PtrOwnerImplINS_10BmpDecoderENS_14DefaultDeleterIS2_EEED0Ev,__ZN2cv6detail12PtrOwnerImplINS_10BmpDecoderENS_14DefaultDeleterIS2_EEE10deleteSelfEv,__ZN2cv10BmpDecoderD2Ev,__ZN2cv10BmpDecoderD0Ev,__ZN2cv10BmpEncoderD2Ev,__ZN2cv10BmpEncoderD0Ev,__ZNK2cv16BaseImageEncoder11throwOnErorEv,__ZN2cv16BaseImageDecoderD2Ev,__ZN2cv16BaseImageDecoderD0Ev,__ZN2cv16BaseImageEncoderD2Ev,__ZN2cv16BaseImageEncoderD0Ev,__ZN2cv10PxMDecoderD2Ev,__ZN2cv10PxMDecoderD0Ev,__ZN2cv10PxMEncoderD2Ev,__ZN2cv10PxMEncoderD0Ev,__ZN2cv16SunRasterDecoderD2Ev,__ZN2cv16SunRasterDecoderD0Ev,__ZN2cv16SunRasterEncoderD2Ev,__ZN2cv16SunRasterEncoderD0Ev,__ZN2cv10HdrDecoderD2Ev,__ZN2cv10HdrDecoderD0Ev,__ZN2cv10HdrEncoderD2Ev,__ZN2cv10HdrEncoderD0Ev,__ZN2cv11TiffEncoderD2Ev,__ZN2cv11TiffEncoderD0Ev,__ZN2cv11RBaseStreamD2Ev
  ,__ZN2cv11RBaseStreamD0Ev,__ZN2cv11RBaseStream5closeEv,__ZN2cv11RBaseStream9readBlockEv,__ZN2cv11RBaseStream7releaseEv,__ZN2cv11RBaseStream8allocateEv,__ZN2cv11WBaseStreamD2Ev,__ZN2cv11WBaseStreamD0Ev,__ZN2cv11WBaseStream5closeEv,__ZN2cv11WBaseStream10writeBlockEv,__ZN2cv11WBaseStream7releaseEv,__ZN2cv11WBaseStream8allocateEv,__ZN2cv12RLByteStreamD0Ev,__ZN2cv12WLByteStreamD0Ev,__ZN2cv12RMByteStreamD0Ev,__ZN2cv12WMByteStreamD0Ev,__ZN12_GLOBAL__N_110CLAHE_ImplD2Ev,__ZN12_GLOBAL__N_110CLAHE_ImplD0Ev,__ZN12_GLOBAL__N_110CLAHE_Impl14collectGarbageEv,__ZN12_GLOBAL__N_124CLAHE_Interpolation_BodyItED2Ev,__ZN12_GLOBAL__N_124CLAHE_Interpolation_BodyItED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_124CLAHE_Interpolation_BodyItEENS_14DefaultDeleterIS4_EEED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_124CLAHE_Interpolation_BodyItEENS_14DefaultDeleterIS4_EEE10deleteSelfEv,__ZN12_GLOBAL__N_124CLAHE_Interpolation_BodyIhED2Ev,__ZN12_GLOBAL__N_124CLAHE_Interpolation_BodyIhED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_124CLAHE_Interpolation_BodyIhEENS_14DefaultDeleterIS4_EEED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_124CLAHE_Interpolation_BodyIhEENS_14DefaultDeleterIS4_EEE10deleteSelfEv,__ZN12_GLOBAL__N_118CLAHE_CalcLut_BodyItLi4096ELi4EED2Ev,__ZN12_GLOBAL__N_118CLAHE_CalcLut_BodyItLi4096ELi4EED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_118CLAHE_CalcLut_BodyItLi4096ELi4EEENS_14DefaultDeleterIS4_EEED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_118CLAHE_CalcLut_BodyItLi4096ELi4EEENS_14DefaultDeleterIS4_EEE10deleteSelfEv
  ,__ZN12_GLOBAL__N_118CLAHE_CalcLut_BodyIhLi256ELi0EED2Ev,__ZN12_GLOBAL__N_118CLAHE_CalcLut_BodyIhLi256ELi0EED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_118CLAHE_CalcLut_BodyIhLi256ELi0EEENS_14DefaultDeleterIS4_EEED0Ev,__ZN2cv6detail12PtrOwnerImplIN12_GLOBAL__N_118CLAHE_CalcLut_BodyIhLi256ELi0EEENS_14DefaultDeleterIS4_EEE10deleteSelfEv,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED2Ev,__ZNSt3__111__stdoutbufIwED0Ev,__ZNSt3__110__stdinbufIwED0Ev,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED2Ev,__ZNSt3__111__stdoutbufIcED0Ev,__ZNSt3__110__stdinbufIcED0Ev,__ZNSt3__112system_errorD2Ev,__ZNSt3__112system_errorD0Ev,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED1Ev,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEED0Ev,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED1Ev,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEED0Ev,__ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev,__ZNSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev,__ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED1Ev,__ZTv0_n12_NSt3__113basic_istreamIwNS_11char_traitsIwEEED0Ev,__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev,__ZNSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev,__ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED1Ev,__ZTv0_n12_NSt3__113basic_ostreamIwNS_11char_traitsIwEEED0Ev,__ZNSt3__18ios_base7failureD2Ev,__ZNSt3__18ios_base7failureD0Ev,__ZNSt3__18ios_baseD2Ev,__ZNSt3__18ios_baseD0Ev,__ZNSt3__114error_categoryD2Ev,__ZNSt3__119__iostream_categoryD0Ev
  ,__ZNSt3__17collateIcED1Ev,__ZNSt3__17collateIcED0Ev,__ZNSt3__16locale5facet16__on_zero_sharedEv,__ZNSt3__17collateIwED1Ev,__ZNSt3__17collateIwED0Ev,__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,__ZNSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,__ZNSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,__ZNSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,__ZNSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,__ZNSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,__ZNSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,__ZNSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,__ZNSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__110moneypunctIcLb0EED1Ev,__ZNSt3__110moneypunctIcLb0EED0Ev,__ZNSt3__110moneypunctIcLb1EED1Ev,__ZNSt3__110moneypunctIcLb1EED0Ev,__ZNSt3__110moneypunctIwLb0EED1Ev,__ZNSt3__110moneypunctIwLb0EED0Ev,__ZNSt3__110moneypunctIwLb1EED1Ev,__ZNSt3__110moneypunctIwLb1EED0Ev,__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev
  ,__ZNSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,__ZNSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED1Ev,__ZNSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED1Ev,__ZNSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__18messagesIcED1Ev,__ZNSt3__18messagesIcED0Ev,__ZNSt3__18messagesIwED1Ev,__ZNSt3__18messagesIwED0Ev,__ZNSt3__16locale5__impD2Ev,__ZNSt3__16locale5__impD0Ev,__ZNSt3__15ctypeIcED2Ev,__ZNSt3__15ctypeIcED0Ev,__ZNSt3__17codecvtIwc11__mbstate_tED2Ev,__ZNSt3__17codecvtIwc11__mbstate_tED0Ev,__ZNSt3__18numpunctIcED2Ev,__ZNSt3__18numpunctIcED0Ev,__ZNSt3__18numpunctIwED2Ev,__ZNSt3__18numpunctIwED0Ev,__ZNSt3__16locale5facetD2Ev,__ZNSt3__16locale5facetD0Ev,__ZNSt3__15ctypeIwED0Ev,__ZNSt3__17codecvtIcc11__mbstate_tED0Ev,__ZNSt3__17codecvtIDsc11__mbstate_tED0Ev,__ZNSt3__17codecvtIDic11__mbstate_tED0Ev,__ZNSt3__116__narrow_to_utf8ILj32EED0Ev,__ZNSt3__117__widen_from_utf8ILj32EED0Ev,__ZNSt9bad_allocD2Ev
  ,__ZNSt9bad_allocD0Ev,__ZNSt11logic_errorD2Ev,__ZNSt11logic_errorD0Ev,__ZNSt13runtime_errorD0Ev,__ZNSt12length_errorD0Ev,__ZNSt12out_of_rangeD0Ev,__ZNSt8bad_castD2Ev,__ZNSt8bad_castD0Ev,__ZNSt10bad_typeidD2Ev,__ZNSt10bad_typeidD0Ev,__ZN10__cxxabiv116__shim_type_infoD2Ev,__ZN10__cxxabiv117__class_type_infoD0Ev,__ZNK10__cxxabiv116__shim_type_info5noop1Ev,__ZNK10__cxxabiv116__shim_type_info5noop2Ev,__ZN10__cxxabiv116__enum_type_infoD0Ev,__ZN10__cxxabiv120__si_class_type_infoD0Ev,__ZN10__cxxabiv121__vmi_class_type_infoD0Ev,__Z45gtest_Size_MatType_bitwise_not_EvalGenerator_v,__ZL20icvXMLEndWriteStructP13CvFileStorage,__ZL21icvXMLStartNextStreamP13CvFileStorage,__ZL20icvYMLEndWriteStructP13CvFileStorage,__ZL21icvYMLStartNextStreamP13CvFileStorage,__ZN2cv6StringD2Ev,__ZN2cv13sorted_vectorINS_6StringEPFPNS_9AlgorithmEvEED2Ev,__ZL13icvReleaseSeqPPv,__ZN6CvTypeD2Ev,__ZL15icvReleaseGraphPPv,_cvReleaseSparseMat,_cvReleaseImage,_cvReleaseMat
  ,__Z14cvReleaseMatNDPP7CvMatND,___cxx_global_array_dtor,__ZN2cv5MutexD2Ev,__ZN2cv3PtrINS_4cuda6StreamEED2Ev,__ZN2cv3ocl13ProgramSourceD2Ev,__ZN12_GLOBAL__N_113FormattedImpl12valueToStr8uEv,__ZN12_GLOBAL__N_113FormattedImpl12valueToStr8sEv,__ZN12_GLOBAL__N_113FormattedImpl13valueToStr16uEv,__ZN12_GLOBAL__N_113FormattedImpl13valueToStr16sEv,__ZN12_GLOBAL__N_113FormattedImpl13valueToStr32sEv,__ZN12_GLOBAL__N_113FormattedImpl13valueToStr32fEv,__ZN12_GLOBAL__N_113FormattedImpl13valueToStr64fEv,__ZN12_GLOBAL__N_113FormattedImpl15valueToStrOtherEv,__ZN2cvL16deleteTLSStorageEPv,__ZN6cvtestL13signalHandlerEi,__ZN7testing4Test11DeleteSelf_Ev,__ZN7testing8TestCase16RunSetUpTestCaseEv,__ZN7testing8TestCase19RunTearDownTestCaseEv,__ZNSt3__112basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev,__ZN4perf10RegressionD2Ev,__ZNSt3__113__vector_baseINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEED2Ev,__ZNSt3__13mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEfNS_4lessIS6_EENS4_INS_4pairIKS6_fEEEEED2Ev,__ZN2cv21ImageCodecInitializerD2Ev,__ZN2cv13AlgorithmInfoD2Ev,_cvReleaseHist,__ZNSt3__112__do_nothingEPv,__ZNSt3__16locale2id6__initEv,__ZNSt3__117__call_once_proxyINS_5tupleIJNS_12_GLOBAL__N_111__fake_bindEEEEEEvPv,___cxx_global_array_dtor112,___cxx_global_array_dtor97
  ,___cxx_global_array_dtor73,___cxx_global_array_dtor48,___cxx_global_array_dtor45,___cxx_global_array_dtor1954,__ZNSt3__112basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED1Ev,__ZNSt3__18ios_base4InitD2Ev,_free,__ZN10__cxxabiv112_GLOBAL__N_19destruct_EPv,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3
  ,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3
  ,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3
  ,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3,b3
  ,b3,b3,b3];
  var FUNCTION_TABLE_vii = [b4,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE,__ZNK2cv11_InputArray12getMatVectorERNSt3__16vectorINS_3MatENS1_9allocatorIS3_EEEE,__ZNK2cv11_InputArray13getUMatVectorERNSt3__16vectorINS_4UMatENS1_9allocatorIS3_EEEE,__ZNK2cv11_InputArray9getGpuMatEv,__ZNK2cv11_InputArray12getOGlBufferEv,__ZNK2cv11_InputArray6copyToERKNS_12_OutputArrayE,__ZN12_GLOBAL__N_113FormatterBase15set32fPrecisionEi,__ZN12_GLOBAL__N_113FormatterBase15set64fPrecisionEi,__ZN12_GLOBAL__N_113FormatterBase12setMultilineEb,__ZN2cv11FileStorage19releaseAndGetStringEv,__ZNK2cv7TLSDataINS_11CoreTLSDataEE18deleteDataInstanceEPv,__ZNK2cv15StdMatAllocator10deallocateEPNS_8UMatDataE,__ZNK2cv12MatAllocator5unmapEPNS_8UMatDataE,__ZN2cv25DummyBufferPoolController18setMaxReservedSizeEj,__ZNK2cv9Algorithm5writeERNS_11FileStorageE,__ZN2cv9Algorithm4readERKNS_8FileNodeE,__ZN6cvtest2TS4initERKNSt3__112basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE,__ZN6cvtest2TS20set_failed_test_infoEi,__ZN7testing8internal35DefaultGlobalTestPartResultReporter20ReportTestPartResultERKNS_14TestPartResultE,__ZN7testing8internal38DefaultPerThreadTestPartResultReporter20ReportTestPartResultERKNS_14TestPartResultE,__ZN7testing8internal17TestEventRepeater18OnTestProgramStartERKNS_8UnitTestE,__ZN7testing8internal17TestEventRepeater24OnEnvironmentsSetUpStartERKNS_8UnitTestE,__ZN7testing8internal17TestEventRepeater22OnEnvironmentsSetUpEndERKNS_8UnitTestE,__ZN7testing8internal17TestEventRepeater15OnTestCaseStartERKNS_8TestCaseE,__ZN7testing8internal17TestEventRepeater11OnTestStartERKNS_8TestInfoE,__ZN7testing8internal17TestEventRepeater16OnTestPartResultERKNS_14TestPartResultE,__ZN7testing8internal17TestEventRepeater9OnTestEndERKNS_8TestInfoE,__ZN7testing8internal17TestEventRepeater13OnTestCaseEndERKNS_8TestCaseE
  ,__ZN7testing8internal17TestEventRepeater27OnEnvironmentsTearDownStartERKNS_8UnitTestE,__ZN7testing8internal17TestEventRepeater25OnEnvironmentsTearDownEndERKNS_8UnitTestE,__ZN7testing8internal17TestEventRepeater16OnTestProgramEndERKNS_8UnitTestE,__ZN7testing22EmptyTestEventListener18OnTestProgramStartERKNS_8UnitTestE,__ZN7testing22EmptyTestEventListener24OnEnvironmentsSetUpStartERKNS_8UnitTestE,__ZN7testing22EmptyTestEventListener22OnEnvironmentsSetUpEndERKNS_8UnitTestE,__ZN7testing22EmptyTestEventListener15OnTestCaseStartERKNS_8TestCaseE,__ZN7testing22EmptyTestEventListener11OnTestStartERKNS_8TestInfoE,__ZN7testing22EmptyTestEventListener16OnTestPartResultERKNS_14TestPartResultE,__ZN7testing22EmptyTestEventListener9OnTestEndERKNS_8TestInfoE,__ZN7testing22EmptyTestEventListener13OnTestCaseEndERKNS_8TestCaseE,__ZN7testing22EmptyTestEventListener27OnEnvironmentsTearDownStartERKNS_8UnitTestE,__ZN7testing22EmptyTestEventListener25OnEnvironmentsTearDownEndERKNS_8UnitTestE,__ZN7testing22EmptyTestEventListener16OnTestProgramEndERKNS_8UnitTestE,__ZN7testing8internal27PrettyUnitTestResultPrinter18OnTestProgramStartERKNS_8UnitTestE,__ZN7testing8internal27PrettyUnitTestResultPrinter24OnEnvironmentsSetUpStartERKNS_8UnitTestE,__ZN7testing8internal27PrettyUnitTestResultPrinter22OnEnvironmentsSetUpEndERKNS_8UnitTestE,__ZN7testing8internal27PrettyUnitTestResultPrinter15OnTestCaseStartERKNS_8TestCaseE,__ZN7testing8internal27PrettyUnitTestResultPrinter11OnTestStartERKNS_8TestInfoE,__ZN7testing8internal27PrettyUnitTestResultPrinter16OnTestPartResultERKNS_14TestPartResultE,__ZN7testing8internal27PrettyUnitTestResultPrinter9OnTestEndERKNS_8TestInfoE,__ZN7testing8internal27PrettyUnitTestResultPrinter13OnTestCaseEndERKNS_8TestCaseE,__ZN7testing8internal27PrettyUnitTestResultPrinter27OnEnvironmentsTearDownStartERKNS_8UnitTestE,__ZN7testing8internal27PrettyUnitTestResultPrinter25OnEnvironmentsTearDownEndERKNS_8UnitTestE,__ZN7testing8internal27PrettyUnitTestResultPrinter16OnTestProgramEndERKNS_8UnitTestE,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE,__ZNK2cv10BmpDecoder10newDecoderEv,__ZNK2cv16BaseImageEncoder14getDescriptionEv,__ZNK2cv10BmpEncoder10newEncoderEv,__ZNK2cv16BaseImageDecoder10newDecoderEv
  ,__ZNK2cv16BaseImageEncoder10newEncoderEv,__ZNK2cv10PxMDecoder10newDecoderEv,__ZNK2cv10PxMEncoder10newEncoderEv,__ZNK2cv16SunRasterDecoder10newDecoderEv,__ZNK2cv16SunRasterEncoder10newEncoderEv,__ZNK2cv10HdrDecoder10newDecoderEv,__ZNK2cv10HdrEncoder10newEncoderEv,__ZNK2cv11TiffEncoder10newEncoderEv,__ZN12_GLOBAL__N_110CLAHE_Impl16setTilesGridSizeEN2cv5Size_IiEE,__ZNK12_GLOBAL__N_110CLAHE_Impl16getTilesGridSizeEv,__ZNK12_GLOBAL__N_124CLAHE_Interpolation_BodyItEclERKN2cv5RangeE,__ZNK12_GLOBAL__N_124CLAHE_Interpolation_BodyIhEclERKN2cv5RangeE,__ZNK12_GLOBAL__N_118CLAHE_CalcLut_BodyItLi4096ELi4EEclERKN2cv5RangeE,__ZNK12_GLOBAL__N_118CLAHE_CalcLut_BodyIhLi256ELi0EEclERKN2cv5RangeE,__ZNSt3__111__stdoutbufIwE5imbueERKNS_6localeE,__ZNSt3__110__stdinbufIwE5imbueERKNS_6localeE,__ZNSt3__111__stdoutbufIcE5imbueERKNS_6localeE,__ZNSt3__110__stdinbufIcE5imbueERKNS_6localeE,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE,__ZNKSt3__110moneypunctIcLb0EE11do_groupingEv,__ZNKSt3__110moneypunctIcLb0EE14do_curr_symbolEv,__ZNKSt3__110moneypunctIcLb0EE16do_positive_signEv,__ZNKSt3__110moneypunctIcLb0EE16do_negative_signEv,__ZNKSt3__110moneypunctIcLb0EE13do_pos_formatEv,__ZNKSt3__110moneypunctIcLb0EE13do_neg_formatEv,__ZNKSt3__110moneypunctIcLb1EE11do_groupingEv,__ZNKSt3__110moneypunctIcLb1EE14do_curr_symbolEv,__ZNKSt3__110moneypunctIcLb1EE16do_positive_signEv,__ZNKSt3__110moneypunctIcLb1EE16do_negative_signEv,__ZNKSt3__110moneypunctIcLb1EE13do_pos_formatEv
  ,__ZNKSt3__110moneypunctIcLb1EE13do_neg_formatEv,__ZNKSt3__110moneypunctIwLb0EE11do_groupingEv,__ZNKSt3__110moneypunctIwLb0EE14do_curr_symbolEv,__ZNKSt3__110moneypunctIwLb0EE16do_positive_signEv,__ZNKSt3__110moneypunctIwLb0EE16do_negative_signEv,__ZNKSt3__110moneypunctIwLb0EE13do_pos_formatEv,__ZNKSt3__110moneypunctIwLb0EE13do_neg_formatEv,__ZNKSt3__110moneypunctIwLb1EE11do_groupingEv,__ZNKSt3__110moneypunctIwLb1EE14do_curr_symbolEv,__ZNKSt3__110moneypunctIwLb1EE16do_positive_signEv,__ZNKSt3__110moneypunctIwLb1EE16do_negative_signEv,__ZNKSt3__110moneypunctIwLb1EE13do_pos_formatEv,__ZNKSt3__110moneypunctIwLb1EE13do_neg_formatEv,__ZNKSt3__18messagesIcE8do_closeEi,__ZNKSt3__18messagesIwE8do_closeEi,__ZNKSt3__18numpunctIcE11do_groupingEv,__ZNKSt3__18numpunctIcE11do_truenameEv,__ZNKSt3__18numpunctIcE12do_falsenameEv,__ZNKSt3__18numpunctIwE11do_groupingEv,__ZNKSt3__18numpunctIwE11do_truenameEv,__ZNKSt3__18numpunctIwE12do_falsenameEv,_zcfree,b4,b4,b4,b4,b4,b4,b4,b4
  ,b4,b4,b4,b4,b4,b4,b4,b4,b4];
  var FUNCTION_TABLE_iiiiiii = [b5,__ZN6cvtestL15tsErrorCallbackEiPKcS1_S1_iPNS_2TSE];
  var FUNCTION_TABLE_ii = [b6,__ZN7testing4Test5SetupEv,__ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE5BeginEv,__ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE3EndEv,__ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8Iterator13BaseGeneratorEv,__ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8Iterator5CloneEv,__ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8Iterator7CurrentEv,__ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE5BeginEv,__ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE3EndEv,__ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8Iterator13BaseGeneratorEv,__ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8Iterator5CloneEv,__ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8Iterator7CurrentEv,__ZNK7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE5BeginEv,__ZNK7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE3EndEv,__ZNK7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8Iterator13BaseGeneratorEv,__ZNK7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8Iterator5CloneEv,__ZNK7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8Iterator7CurrentEv,__ZNK7testing8internal25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE15GetTestCaseNameEv,__ZNK7testing8internal25ParameterizedTestCaseInfoI24Size_MatType_bitwise_notE17GetTestCaseTypeIdEv,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE4syncEv,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9showmanycEv,__ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9underflowEv,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE5uflowEv,__ZNK2cv11_InputArray4kindEv,__ZNK2cv11_InputArray5emptyEv,__ZNK2cv12_OutputArray9fixedSizeEv,__ZNK2cv12_OutputArray9fixedTypeEv,__ZNK2cv12_OutputArray6neededEv,__ZNK2cv12_OutputArray12getGpuMatRefEv
  ,__ZNK2cv12_OutputArray15getOGlBufferRefEv,__ZNK2cv12_OutputArray13getCudaMemRefEv,__ZN7testing8internal24ParameterizedTestFactoryI41Size_MatType_bitwise_not_bitwise_not_TestE10CreateTestEv,__ZN12_GLOBAL__N_113FormattedImpl4nextEv,__ZNK2cv11FileStorage8isOpenedEv,__ZNK2cv9Exception4whatEv,__ZNK2cv7TLSDataINS_11CoreTLSDataEE18createDataInstanceEv,__ZNK2cv12MatAllocator23getBufferPoolControllerEv,__ZNK2cv25DummyBufferPoolController15getReservedSizeEv,__ZNK2cv25DummyBufferPoolController18getMaxReservedSizeEv,__ZNK2cv9Algorithm4infoEv,__ZNKSt13runtime_error4whatEv,__ZN7testing11Environment5SetupEv,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE4syncEv,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE9underflowEv,__ZNK2cv16BaseImageDecoder4typeEv,__ZN2cv10BmpDecoder10readHeaderEv,__ZNK2cv16BaseImageDecoder15signatureLengthEv,__ZN2cv10PxMDecoder10readHeaderEv,__ZNK2cv10PxMDecoder15signatureLengthEv,__ZN2cv16SunRasterDecoder10readHeaderEv,__ZN2cv10HdrDecoder10readHeaderEv,__ZNK2cv10HdrDecoder15signatureLengthEv,__ZNK12_GLOBAL__N_110CLAHE_Impl4infoEv,__ZNSt3__111__stdoutbufIwE4syncEv,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9showmanycEv,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9underflowEv,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE5uflowEv,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE4syncEv,__ZNSt3__110__stdinbufIwE9underflowEv
  ,__ZNSt3__110__stdinbufIwE5uflowEv,__ZNSt3__111__stdoutbufIcE4syncEv,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9underflowEv,__ZNSt3__110__stdinbufIcE9underflowEv,__ZNSt3__110__stdinbufIcE5uflowEv,__ZNKSt3__119__iostream_category4nameEv,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv,__ZNKSt3__120__time_get_c_storageIcE7__weeksEv,__ZNKSt3__120__time_get_c_storageIcE8__monthsEv,__ZNKSt3__120__time_get_c_storageIcE7__am_pmEv,__ZNKSt3__120__time_get_c_storageIcE3__cEv,__ZNKSt3__120__time_get_c_storageIcE3__rEv,__ZNKSt3__120__time_get_c_storageIcE3__xEv,__ZNKSt3__120__time_get_c_storageIcE3__XEv,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv,__ZNKSt3__120__time_get_c_storageIwE7__weeksEv,__ZNKSt3__120__time_get_c_storageIwE8__monthsEv,__ZNKSt3__120__time_get_c_storageIwE7__am_pmEv,__ZNKSt3__120__time_get_c_storageIwE3__cEv,__ZNKSt3__120__time_get_c_storageIwE3__rEv,__ZNKSt3__120__time_get_c_storageIwE3__xEv,__ZNKSt3__120__time_get_c_storageIwE3__XEv,__ZNKSt3__110moneypunctIcLb0EE16do_decimal_pointEv,__ZNKSt3__110moneypunctIcLb0EE16do_thousands_sepEv,__ZNKSt3__110moneypunctIcLb0EE14do_frac_digitsEv,__ZNKSt3__110moneypunctIcLb1EE16do_decimal_pointEv,__ZNKSt3__110moneypunctIcLb1EE16do_thousands_sepEv,__ZNKSt3__110moneypunctIcLb1EE14do_frac_digitsEv,__ZNKSt3__110moneypunctIwLb0EE16do_decimal_pointEv,__ZNKSt3__110moneypunctIwLb0EE16do_thousands_sepEv
  ,__ZNKSt3__110moneypunctIwLb0EE14do_frac_digitsEv,__ZNKSt3__110moneypunctIwLb1EE16do_decimal_pointEv,__ZNKSt3__110moneypunctIwLb1EE16do_thousands_sepEv,__ZNKSt3__110moneypunctIwLb1EE14do_frac_digitsEv,__ZNKSt3__17codecvtIwc11__mbstate_tE11do_encodingEv,__ZNKSt3__17codecvtIwc11__mbstate_tE16do_always_noconvEv,__ZNKSt3__17codecvtIwc11__mbstate_tE13do_max_lengthEv,__ZNKSt3__18numpunctIcE16do_decimal_pointEv,__ZNKSt3__18numpunctIcE16do_thousands_sepEv,__ZNKSt3__18numpunctIwE16do_decimal_pointEv,__ZNKSt3__18numpunctIwE16do_thousands_sepEv,__ZNKSt3__17codecvtIcc11__mbstate_tE11do_encodingEv,__ZNKSt3__17codecvtIcc11__mbstate_tE16do_always_noconvEv,__ZNKSt3__17codecvtIcc11__mbstate_tE13do_max_lengthEv,__ZNKSt3__17codecvtIDsc11__mbstate_tE11do_encodingEv,__ZNKSt3__17codecvtIDsc11__mbstate_tE16do_always_noconvEv,__ZNKSt3__17codecvtIDsc11__mbstate_tE13do_max_lengthEv,__ZNKSt3__17codecvtIDic11__mbstate_tE11do_encodingEv,__ZNKSt3__17codecvtIDic11__mbstate_tE16do_always_noconvEv,__ZNKSt3__17codecvtIDic11__mbstate_tE13do_max_lengthEv,__ZNKSt9bad_alloc4whatEv,__ZNKSt11logic_error4whatEv,__ZNKSt8bad_cast4whatEv,__ZNKSt10bad_typeid4whatEv,__ZL8icvIsSeqPKv,__ZL11icvCloneSeqPKv,__ZL10icvIsGraphPKv,__ZL13icvCloneGraphPKv,__ZL14icvIsSparseMatPKv,_cvCloneSparseMat
  ,__ZL10icvIsImagePKv,_cvCloneImage,__ZL8icvIsMatPKv,_cvCloneMat,__ZL10icvIsMatNDPKv,_cvCloneMatND,__ZN7testing8internal12UnitTestImpl11RunAllTestsEv,__ZL9icvIsHistPKv,__ZL12icvCloneHistPK11CvHistogram];
  var FUNCTION_TABLE_viiiiiiiddi = [b7,__ZN2cvL13GEMMStore_32fEPKfjPKdjPfjNS_5Size_IiEEddi,__ZN2cvL13GEMMStore_64fEPKdjS1_jPdjNS_5Size_IiEEddi,__ZN2cvL14GEMMStore_32fcEPKNS_7ComplexIfEEjPKNS0_IdEEjPS1_jNS_5Size_IiEEddi,__ZN2cvL14GEMMStore_64fcEPKNS_7ComplexIdEEjS3_jPS1_jNS_5Size_IiEEddi,b7,b7,b7];
  var FUNCTION_TABLE_viiiiiiiii = [b8,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc,__ZN2cvL16GEMMBlockMul_32fEPKfjS1_jPdjNS_5Size_IiEES4_i,__ZN2cvL16GEMMBlockMul_64fEPKdjS1_jPdjNS_5Size_IiEES4_i,__ZN2cvL17GEMMBlockMul_32fcEPKNS_7ComplexIfEEjS3_jPNS0_IdEEjNS_5Size_IiEES7_i,__ZN2cvL17GEMMBlockMul_64fcEPKNS_7ComplexIdEEjS3_jPS1_jNS_5Size_IiEES6_i,b8];
  var FUNCTION_TABLE_viidi = [b9,__ZNK2cv5MatOp8multiplyERKNS_7MatExprEdRS1_,__ZNK2cv11MatOp_AddEx8multiplyERKNS_7MatExprEdRS1_,__ZNK2cv9MatOp_Bin8multiplyERKNS_7MatExprEdRS1_,__ZNK2cv10MatOp_GEMM8multiplyERKNS_7MatExprEdRS1_,__ZNK2cv7MatOp_T8multiplyERKNS_7MatExprEdRS1_,__ZNK2cv17MatOp_Initializer8multiplyERKNS_7MatExprEdRS1_,b9];
  var FUNCTION_TABLE_vidii = [b10,__ZNK2cv5MatOp6divideEdRKNS_7MatExprERS1_,__ZNK2cv11MatOp_AddEx6divideEdRKNS_7MatExprERS1_,__ZNK2cv9MatOp_Bin6divideEdRKNS_7MatExprERS1_];
  var FUNCTION_TABLE_iiiiii = [b11,__ZN2cv17checkIntegerRangeILi0EEEbNS_3MatERNS_6Point_IiEEiiRd,__ZN2cv17checkIntegerRangeILi1EEEbNS_3MatERNS_6Point_IiEEiiRd,__ZN2cv17checkIntegerRangeILi2EEEbNS_3MatERNS_6Point_IiEEiiRd,__ZN2cv17checkIntegerRangeILi3EEEbNS_3MatERNS_6Point_IiEEiiRd,__ZN2cv17checkIntegerRangeILi4EEEbNS_3MatERNS_6Point_IiEEiiRd,__ZN2cvL5sum8uEPKhS1_Piii,__ZN2cvL5sum8sEPKaPKhPiii,__ZN2cvL6sum16uEPKtPKhPiii,__ZN2cvL6sum16sEPKsPKhPiii,__ZN2cvL6sum32sEPKiPKhPdii,__ZN2cvL6sum32fEPKfPKhPdii,__ZN2cvL6sum64fEPKdPKhPdii,__ZNKSt3__17collateIcE10do_compareEPKcS3_S3_S3_,__ZNKSt3__17collateIwE10do_compareEPKwS3_S3_S3_,__ZNKSt3__15ctypeIcE9do_narrowEPKcS3_cPc,__ZNKSt3__17codecvtIwc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,__ZNKSt3__17codecvtIwc11__mbstate_tE9do_lengthERS1_PKcS5_j,__ZNKSt3__15ctypeIwE9do_narrowEPKwS3_cPc,__ZNKSt3__17codecvtIcc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,__ZNKSt3__17codecvtIcc11__mbstate_tE9do_lengthERS1_PKcS5_j,__ZNKSt3__17codecvtIDsc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,__ZNKSt3__17codecvtIDsc11__mbstate_tE9do_lengthERS1_PKcS5_j,__ZNKSt3__17codecvtIDic11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,__ZNKSt3__17codecvtIDic11__mbstate_tE9do_lengthERS1_PKcS5_j,b11,b11,b11,b11
  ,b11,b11,b11];
  var FUNCTION_TABLE_iii = [b12,__ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN4perf7MatTypeEE8Iterator6EqualsERKNS0_22ParamIteratorInterfaceIS3_EE,__ZNK7testing8internal30ValuesInIteratorRangeGeneratorIN2cv5Size_IiEEE8Iterator6EqualsERKNS0_22ParamIteratorInterfaceIS4_EE,__ZNK7testing8internal26CartesianProductGenerator2IN2cv5Size_IiEEN4perf7MatTypeEE8Iterator6EqualsERKNS0_22ParamIteratorInterfaceINSt3tr15tupleIS4_S6_vvvvvvvvEEEE,__ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9pbackfailEi,__ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE8overflowEi,__ZNK2cv11_InputArray4dimsEi,__ZNK2cv11_InputArray4colsEi,__ZNK2cv11_InputArray4rowsEi,__ZNK2cv11_InputArray8sameSizeERKS0_,__ZNK2cv11_InputArray5totalEi,__ZNK2cv11_InputArray4typeEi,__ZNK2cv11_InputArray5depthEi,__ZNK2cv11_InputArray8channelsEi,__ZNK2cv11_InputArray12isContinuousEi,__ZNK2cv11_InputArray11isSubmatrixEi,__ZNK2cv11_InputArray6offsetEi,__ZNK2cv11_InputArray4stepEi,__ZNK2cv12_OutputArray9getMatRefEi,__ZNK2cv12_OutputArray10getUMatRefEi,__ZN7testing8internal15TestMetaFactoryI41Size_MatType_bitwise_not_bitwise_not_TestE17CreateTestFactoryENSt3tr15tupleIN2cv5Size_IiEEN4perf7MatTypeEvvvvvvvvEE,__ZN2cvL14countNonZero8uEPKhi,__ZN2cvL15countNonZero16uEPKti,__ZN2cvL15countNonZero32sEPKii,__ZN2cvL15countNonZero32fEPKfi,__ZN2cvL15countNonZero64fEPKdi,__ZNK2cv14MatOp_Identity11elementWiseERKNS_7MatExprE,__ZNK2cv5MatOp4typeERKNS_7MatExprE,__ZNK2cv11MatOp_AddEx11elementWiseERKNS_7MatExprE
  ,__ZNK2cv9MatOp_Bin11elementWiseERKNS_7MatExprE,__ZNK2cv9MatOp_Cmp11elementWiseERKNS_7MatExprE,__ZNK2cv10MatOp_GEMM11elementWiseERKNS_7MatExprE,__ZNK2cv12MatOp_Invert11elementWiseERKNS_7MatExprE,__ZNK2cv7MatOp_T11elementWiseERKNS_7MatExprE,__ZNK2cv11MatOp_Solve11elementWiseERKNS_7MatExprE,__ZNK2cv17MatOp_Initializer11elementWiseERKNS_7MatExprE,_deflate_stored,_deflate_fast,_deflate_slow,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE9pbackfailEi,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE8overflowEi,__ZN2cv16BaseImageDecoder9setSourceERKNS_6StringE,__ZN2cv16BaseImageDecoder9setSourceERKNS_3MatE,__ZN2cv10BmpDecoder8readDataERNS_3MatE,__ZNK2cv16BaseImageDecoder14checkSignatureERKNS_6StringE,__ZNK2cv16BaseImageEncoder17isFormatSupportedEi,__ZN2cv16BaseImageEncoder14setDestinationERKNS_6StringE,__ZN2cv16BaseImageEncoder14setDestinationERNSt3__16vectorIhNS1_9allocatorIhEEEE,__ZN2cv10PxMDecoder8readDataERNS_3MatE,__ZNK2cv10PxMDecoder14checkSignatureERKNS_6StringE,__ZNK2cv10PxMEncoder17isFormatSupportedEi,__ZN2cv16SunRasterDecoder8readDataERNS_3MatE,__ZN2cv10HdrDecoder8readDataERNS_3MatE,__ZNK2cv10HdrDecoder14checkSignatureERKNS_6StringE,__ZNK2cv10HdrEncoder17isFormatSupportedEi,__ZNK2cv11TiffEncoder17isFormatSupportedEi,__ZN2cv11RBaseStream4openERKNS_6StringE,__ZN2cv11RBaseStream4openERKNS_3MatE,__ZN2cv11WBaseStream4openERKNS_6StringE
  ,__ZN2cv11WBaseStream4openERNSt3__16vectorIhNS1_9allocatorIhEEEE,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj,__ZNSt3__111__stdoutbufIwE8overflowEj,__ZNSt3__110__stdinbufIwE9pbackfailEj,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE8overflowEj,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi,__ZNSt3__111__stdoutbufIcE8overflowEi,__ZNSt3__110__stdinbufIcE9pbackfailEi,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE8overflowEi,__ZNKSt3__15ctypeIcE10do_toupperEc,__ZNKSt3__15ctypeIcE10do_tolowerEc,__ZNKSt3__15ctypeIcE8do_widenEc,__ZNKSt3__15ctypeIwE10do_toupperEw,__ZNKSt3__15ctypeIwE10do_tolowerEw,__ZNKSt3__15ctypeIwE8do_widenEc,__ZN2cvL10cmp_paramsERKNS_23CommandLineParserParamsES2_,__ZL10icvReadSeqP13CvFileStorageP10CvFileNode,__ZL14icvReadSeqTreeP13CvFileStorageP10CvFileNode,__ZL12icvReadGraphP13CvFileStorageP10CvFileNode,__ZL16icvReadSparseMatP13CvFileStorageP10CvFileNode,__ZL12icvReadImageP13CvFileStorageP10CvFileNode,__ZL10icvReadMatP13CvFileStorageP10CvFileNode,__ZL12icvReadMatNDP13CvFileStorageP10CvFileNode,__ZL11icvReadHistP13CvFileStorageP10CvFileNode,b12,b12,b12,b12,b12,b12
  ,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12,b12
  ,b12,b12,b12,b12,b12,b12,b12,b12,b12];
  var FUNCTION_TABLE_iiii = [b13,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6setbufEPci,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci,__ZNK2cv11_InputArray6sizendEPii,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE6setbufEPci,__ZN2cv10BmpEncoder5writeERKNS_3MatERKNSt3__16vectorIiNS4_9allocatorIiEEEE,__ZN2cv10PxMEncoder5writeERKNS_3MatERKNSt3__16vectorIiNS4_9allocatorIiEEEE,__ZN2cv16SunRasterEncoder5writeERKNS_3MatERKNSt3__16vectorIiNS4_9allocatorIiEEEE,__ZN2cv10HdrEncoder5writeERKNS_3MatERKNSt3__16vectorIiNS4_9allocatorIiEEEE,__ZN2cv11TiffEncoder5writeERKNS_3MatERKNSt3__16vectorIiNS4_9allocatorIiEEEE,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi,__ZNSt3__111__stdoutbufIwE6xsputnEPKwi,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi,__ZNSt3__111__stdoutbufIcE6xsputnEPKci,__ZNKSt3__114error_category10equivalentEiRKNS_15error_conditionE,__ZNKSt3__114error_category10equivalentERKNS_10error_codeEi,__ZNKSt3__17collateIcE7do_hashEPKcS3_,__ZNKSt3__17collateIwE7do_hashEPKwS3_,__ZNKSt3__18messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE,__ZNKSt3__18messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE,__ZNKSt3__15ctypeIcE10do_toupperEPcPKc,__ZNKSt3__15ctypeIcE10do_tolowerEPcPKc,__ZNKSt3__15ctypeIcE9do_narrowEcc,__ZNKSt3__15ctypeIwE5do_isEtw,__ZNKSt3__15ctypeIwE10do_toupperEPwPKw,__ZNKSt3__15ctypeIwE10do_tolowerEPwPKw,__ZNKSt3__15ctypeIwE9do_narrowEwc
  ,__ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv,__ZNK10__cxxabiv116__enum_type_info9can_catchEPKNS_16__shim_type_infoERPv,_sn_write,_zcalloc,__ZL17icvSortIdxCmpFuncPKvS0_Pv,_do_read,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13,b13
  ,b13,b13,b13,b13,b13];
  var FUNCTION_TABLE_viiiiid = [b14,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe,b14,b14,b14];
  var FUNCTION_TABLE_viiiiiiii = [b15,__ZN2cvL5cmp8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL5cmp8sEPKajS1_jPhjNS_5Size_IiEEPv,__ZN2cvL6cmp16uEPKtjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL6cmp16sEPKsjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL6cmp32sEPKijS1_jPhjNS_5Size_IiEEPv,__ZN2cvL6cmp32fEPKfjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL6cmp64fEPKdjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL13addWeighted8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL13addWeighted8sEPKajS1_jPajNS_5Size_IiEEPv,__ZN2cvL14addWeighted16uEPKtjS1_jPtjNS_5Size_IiEEPv,__ZN2cvL14addWeighted16sEPKsjS1_jPsjNS_5Size_IiEEPv,__ZN2cvL14addWeighted32sEPKijS1_jPijNS_5Size_IiEEPv,__ZN2cvL14addWeighted32fEPKfjS1_jPfjNS_5Size_IiEEPv,__ZN2cvL14addWeighted64fEPKdjS1_jPdjNS_5Size_IiEEPv,__ZN2cvL7recip8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL7recip8sEPKajS1_jPajNS_5Size_IiEEPv,__ZN2cvL8recip16uEPKtjS1_jPtjNS_5Size_IiEEPv,__ZN2cvL8recip16sEPKsjS1_jPsjNS_5Size_IiEEPv,__ZN2cvL8recip32sEPKijS1_jPijNS_5Size_IiEEPv,__ZN2cvL8recip32fEPKfjS1_jPfjNS_5Size_IiEEPv,__ZN2cvL8recip64fEPKdjS1_jPdjNS_5Size_IiEEPv,__ZN2cvL5div8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL5div8sEPKajS1_jPajNS_5Size_IiEEPv,__ZN2cvL6div16uEPKtjS1_jPtjNS_5Size_IiEEPv,__ZN2cvL6div16sEPKsjS1_jPsjNS_5Size_IiEEPv,__ZN2cvL6div32sEPKijS1_jPijNS_5Size_IiEEPv,__ZN2cvL6div32fEPKfjS1_jPfjNS_5Size_IiEEPv,__ZN2cvL6div64fEPKdjS1_jPdjNS_5Size_IiEEPv
  ,__ZN2cvL5mul8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL5mul8sEPKajS1_jPajNS_5Size_IiEEPv,__ZN2cvL6mul16uEPKtjS1_jPtjNS_5Size_IiEEPv,__ZN2cvL6mul16sEPKsjS1_jPsjNS_5Size_IiEEPv,__ZN2cvL6mul32sEPKijS1_jPijNS_5Size_IiEEPv,__ZN2cvL6mul32fEPKfjS1_jPfjNS_5Size_IiEEPv,__ZN2cvL6mul64fEPKdjS1_jPdjNS_5Size_IiEEPv,__ZN2cvL9absdiff8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL9absdiff8sEPKajS1_jPajNS_5Size_IiEEPv,__ZN2cvL10absdiff16uEPKtjS1_jPtjNS_5Size_IiEEPv,__ZN2cvL10absdiff16sEPKsjS1_jPsjNS_5Size_IiEEPv,__ZN2cvL10absdiff32sEPKijS1_jPijNS_5Size_IiEEPv,__ZN2cvL10absdiff32fEPKfjS1_jPfjNS_5Size_IiEEPv,__ZN2cvL10absdiff64fEPKdjS1_jPdjNS_5Size_IiEEPv,__ZN2cvL5sub8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL5sub8sEPKajS1_jPajNS_5Size_IiEEPv,__ZN2cvL6sub16uEPKtjS1_jPtjNS_5Size_IiEEPv,__ZN2cvL6sub16sEPKsjS1_jPsjNS_5Size_IiEEPv,__ZN2cvL6sub32sEPKijS1_jPijNS_5Size_IiEEPv,__ZN2cvL6sub32fEPKfjS1_jPfjNS_5Size_IiEEPv,__ZN2cvL6sub64fEPKdjS1_jPdjNS_5Size_IiEEPv,__ZN2cvL5add8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL5add8sEPKajS1_jPajNS_5Size_IiEEPv,__ZN2cvL6add16uEPKtjS1_jPtjNS_5Size_IiEEPv,__ZN2cvL6add16sEPKsjS1_jPsjNS_5Size_IiEEPv,__ZN2cvL6add32sEPKijS1_jPijNS_5Size_IiEEPv,__ZN2cvL6add32fEPKfjS1_jPfjNS_5Size_IiEEPv,__ZN2cvL6add64fEPKdjS1_jPdjNS_5Size_IiEEPv,__ZN2cvL5min8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL5min8sEPKajS1_jPajNS_5Size_IiEEPv
  ,__ZN2cvL6min16uEPKtjS1_jPtjNS_5Size_IiEEPv,__ZN2cvL6min16sEPKsjS1_jPsjNS_5Size_IiEEPv,__ZN2cvL6min32sEPKijS1_jPijNS_5Size_IiEEPv,__ZN2cvL6min32fEPKfjS1_jPfjNS_5Size_IiEEPv,__ZN2cvL6min64fEPKdjS1_jPdjNS_5Size_IiEEPv,__ZN2cvL5max8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL5max8sEPKajS1_jPajNS_5Size_IiEEPv,__ZN2cvL6max16uEPKtjS1_jPtjNS_5Size_IiEEPv,__ZN2cvL6max16sEPKsjS1_jPsjNS_5Size_IiEEPv,__ZN2cvL6max32sEPKijS1_jPijNS_5Size_IiEEPv,__ZN2cvL6max32fEPKfjS1_jPfjNS_5Size_IiEEPv,__ZN2cvL6max64fEPKdjS1_jPdjNS_5Size_IiEEPv,__ZN2cvL12minMaxIdx_8uEPKhS1_PiS2_PjS3_ij,__ZN2cvL12minMaxIdx_8sEPKaPKhPiS4_PjS5_ij,__ZN2cvL13minMaxIdx_16uEPKtPKhPiS4_PjS5_ij,__ZN2cvL13minMaxIdx_16sEPKsPKhPiS4_PjS5_ij,__ZN2cvL13minMaxIdx_32sEPKiPKhPiS4_PjS5_ij,__ZN2cvL13minMaxIdx_32fEPKfPKhPfS4_PjS5_ij,__ZN2cvL13minMaxIdx_64fEPKdPKhPdS4_PjS5_ij,__ZNK2cv12MatAllocator8downloadEPNS_8UMatDataEPviPKjS5_S5_S5_,__ZNK2cv12MatAllocator6uploadEPNS_8UMatDataEPKviPKjS6_S6_S6_,__ZN2cvL5cvt8uEPKhjS1_jPhjNS_5Size_IiEEPd,__ZN2cvL7cvt8s8uEPKajPKhjPhjNS_5Size_IiEEPd,__ZN2cvL8cvt16u8uEPKtjPKhjPhjNS_5Size_IiEEPd,__ZN2cvL8cvt16s8uEPKsjPKhjPhjNS_5Size_IiEEPd,__ZN2cvL8cvt32s8uEPKijPKhjPhjNS_5Size_IiEEPd,__ZN2cvL8cvt32f8uEPKfjPKhjPhjNS_5Size_IiEEPd,__ZN2cvL8cvt64f8uEPKdjPKhjPhjNS_5Size_IiEEPd,__ZN2cvL7cvt8u8sEPKhjS1_jPajNS_5Size_IiEEPd,__ZN2cvL8cvt16u8sEPKtjPKhjPajNS_5Size_IiEEPd
  ,__ZN2cvL8cvt16s8sEPKsjPKhjPajNS_5Size_IiEEPd,__ZN2cvL8cvt32s8sEPKijPKhjPajNS_5Size_IiEEPd,__ZN2cvL8cvt32f8sEPKfjPKhjPajNS_5Size_IiEEPd,__ZN2cvL8cvt64f8sEPKdjPKhjPajNS_5Size_IiEEPd,__ZN2cvL8cvt8u16uEPKhjS1_jPtjNS_5Size_IiEEPd,__ZN2cvL8cvt8s16uEPKajPKhjPtjNS_5Size_IiEEPd,__ZN2cvL6cvt16uEPKtjPKhjPtjNS_5Size_IiEEPd,__ZN2cvL9cvt16s16uEPKsjPKhjPtjNS_5Size_IiEEPd,__ZN2cvL9cvt32s16uEPKijPKhjPtjNS_5Size_IiEEPd,__ZN2cvL9cvt32f16uEPKfjPKhjPtjNS_5Size_IiEEPd,__ZN2cvL9cvt64f16uEPKdjPKhjPtjNS_5Size_IiEEPd,__ZN2cvL8cvt8u16sEPKhjS1_jPsjNS_5Size_IiEEPd,__ZN2cvL8cvt8s16sEPKajPKhjPsjNS_5Size_IiEEPd,__ZN2cvL9cvt16u16sEPKtjPKhjPsjNS_5Size_IiEEPd,__ZN2cvL9cvt32s16sEPKijPKhjPsjNS_5Size_IiEEPd,__ZN2cvL9cvt32f16sEPKfjPKhjPsjNS_5Size_IiEEPd,__ZN2cvL9cvt64f16sEPKdjPKhjPsjNS_5Size_IiEEPd,__ZN2cvL8cvt8u32sEPKhjS1_jPijNS_5Size_IiEEPd,__ZN2cvL8cvt8s32sEPKajPKhjPijNS_5Size_IiEEPd,__ZN2cvL9cvt16u32sEPKtjPKhjPijNS_5Size_IiEEPd,__ZN2cvL9cvt16s32sEPKsjPKhjPijNS_5Size_IiEEPd,__ZN2cvL6cvt32sEPKijPKhjPijNS_5Size_IiEEPd,__ZN2cvL9cvt32f32sEPKfjPKhjPijNS_5Size_IiEEPd,__ZN2cvL9cvt64f32sEPKdjPKhjPijNS_5Size_IiEEPd,__ZN2cvL8cvt8u32fEPKhjS1_jPfjNS_5Size_IiEEPd,__ZN2cvL8cvt8s32fEPKajPKhjPfjNS_5Size_IiEEPd,__ZN2cvL9cvt16u32fEPKtjPKhjPfjNS_5Size_IiEEPd,__ZN2cvL9cvt16s32fEPKsjPKhjPfjNS_5Size_IiEEPd,__ZN2cvL9cvt32s32fEPKijPKhjPfjNS_5Size_IiEEPd,__ZN2cvL9cvt64f32fEPKdjPKhjPfjNS_5Size_IiEEPd
  ,__ZN2cvL8cvt8u64fEPKhjS1_jPdjNS_5Size_IiEES2_,__ZN2cvL8cvt8s64fEPKajPKhjPdjNS_5Size_IiEES4_,__ZN2cvL9cvt16u64fEPKtjPKhjPdjNS_5Size_IiEES4_,__ZN2cvL9cvt16s64fEPKsjPKhjPdjNS_5Size_IiEES4_,__ZN2cvL9cvt32s64fEPKijPKhjPdjNS_5Size_IiEES4_,__ZN2cvL9cvt32f64fEPKfjPKhjPdjNS_5Size_IiEES4_,__ZN2cvL6cvt64sEPKxjPKhjPxjNS_5Size_IiEEPd,__ZN2cvL10cvtScale8uEPKhjS1_jPhjNS_5Size_IiEEPd,__ZN2cvL12cvtScale8s8uEPKajPKhjPhjNS_5Size_IiEEPd,__ZN2cvL13cvtScale16u8uEPKtjPKhjPhjNS_5Size_IiEEPd,__ZN2cvL13cvtScale16s8uEPKsjPKhjPhjNS_5Size_IiEEPd,__ZN2cvL13cvtScale32s8uEPKijPKhjPhjNS_5Size_IiEEPd,__ZN2cvL13cvtScale32f8uEPKfjPKhjPhjNS_5Size_IiEEPd,__ZN2cvL13cvtScale64f8uEPKdjPKhjPhjNS_5Size_IiEEPd,__ZN2cvL12cvtScale8u8sEPKhjS1_jPajNS_5Size_IiEEPd,__ZN2cvL10cvtScale8sEPKajPKhjPajNS_5Size_IiEEPd,__ZN2cvL13cvtScale16u8sEPKtjPKhjPajNS_5Size_IiEEPd,__ZN2cvL13cvtScale16s8sEPKsjPKhjPajNS_5Size_IiEEPd,__ZN2cvL13cvtScale32s8sEPKijPKhjPajNS_5Size_IiEEPd,__ZN2cvL13cvtScale32f8sEPKfjPKhjPajNS_5Size_IiEEPd,__ZN2cvL13cvtScale64f8sEPKdjPKhjPajNS_5Size_IiEEPd,__ZN2cvL13cvtScale8u16uEPKhjS1_jPtjNS_5Size_IiEEPd,__ZN2cvL13cvtScale8s16uEPKajPKhjPtjNS_5Size_IiEEPd,__ZN2cvL11cvtScale16uEPKtjPKhjPtjNS_5Size_IiEEPd,__ZN2cvL14cvtScale16s16uEPKsjPKhjPtjNS_5Size_IiEEPd,__ZN2cvL14cvtScale32s16uEPKijPKhjPtjNS_5Size_IiEEPd,__ZN2cvL14cvtScale32f16uEPKfjPKhjPtjNS_5Size_IiEEPd,__ZN2cvL14cvtScale64f16uEPKdjPKhjPtjNS_5Size_IiEEPd,__ZN2cvL13cvtScale8u16sEPKhjS1_jPsjNS_5Size_IiEEPd,__ZN2cvL13cvtScale8s16sEPKajPKhjPsjNS_5Size_IiEEPd
  ,__ZN2cvL14cvtScale16u16sEPKtjPKhjPsjNS_5Size_IiEEPd,__ZN2cvL11cvtScale16sEPKsjPKhjPsjNS_5Size_IiEEPd,__ZN2cvL14cvtScale32s16sEPKijPKhjPsjNS_5Size_IiEEPd,__ZN2cvL14cvtScale32f16sEPKfjPKhjPsjNS_5Size_IiEEPd,__ZN2cvL14cvtScale64f16sEPKdjPKhjPsjNS_5Size_IiEEPd,__ZN2cvL13cvtScale8u32sEPKhjS1_jPijNS_5Size_IiEEPd,__ZN2cvL13cvtScale8s32sEPKajPKhjPijNS_5Size_IiEEPd,__ZN2cvL14cvtScale16u32sEPKtjPKhjPijNS_5Size_IiEEPd,__ZN2cvL14cvtScale16s32sEPKsjPKhjPijNS_5Size_IiEEPd,__ZN2cvL11cvtScale32sEPKijPKhjPijNS_5Size_IiEEPd,__ZN2cvL14cvtScale32f32sEPKfjPKhjPijNS_5Size_IiEEPd,__ZN2cvL14cvtScale64f32sEPKdjPKhjPijNS_5Size_IiEEPd,__ZN2cvL13cvtScale8u32fEPKhjS1_jPfjNS_5Size_IiEEPd,__ZN2cvL13cvtScale8s32fEPKajPKhjPfjNS_5Size_IiEEPd,__ZN2cvL14cvtScale16u32fEPKtjPKhjPfjNS_5Size_IiEEPd,__ZN2cvL14cvtScale16s32fEPKsjPKhjPfjNS_5Size_IiEEPd,__ZN2cvL14cvtScale32s32fEPKijPKhjPfjNS_5Size_IiEEPd,__ZN2cvL11cvtScale32fEPKfjPKhjPfjNS_5Size_IiEEPd,__ZN2cvL14cvtScale64f32fEPKdjPKhjPfjNS_5Size_IiEEPd,__ZN2cvL13cvtScale8u64fEPKhjS1_jPdjNS_5Size_IiEES2_,__ZN2cvL13cvtScale8s64fEPKajPKhjPdjNS_5Size_IiEES4_,__ZN2cvL14cvtScale16u64fEPKtjPKhjPdjNS_5Size_IiEES4_,__ZN2cvL14cvtScale16s64fEPKsjPKhjPdjNS_5Size_IiEES4_,__ZN2cvL14cvtScale32s64fEPKijPKhjPdjNS_5Size_IiEES4_,__ZN2cvL14cvtScale32f64fEPKfjPKhjPdjNS_5Size_IiEES4_,__ZN2cvL11cvtScale64fEPKdjPKhjPdjNS_5Size_IiEES4_,__ZN2cvL10copyMask8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL11copyMask16uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL12copyMask8uC3EPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL11copyMask32sEPKhjS1_jPhjNS_5Size_IiEEPv
  ,__ZN2cvL13copyMask16uC3EPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL13copyMask32sC2EPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL13copyMask32sC3EPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL13copyMask32sC4EPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL13copyMask32sC6EPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL13copyMask32sC8EPKhjS1_jPhjNS_5Size_IiEEPv,__ZNKSt3__18time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc,__ZNKSt3__18time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc,__ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe,__ZNKSt3__19money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE,__ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe,__ZNKSt3__19money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE,__ZN2cvL5and8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL4or8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL5xor8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL5not8uEPKhjS1_jPhjNS_5Size_IiEEPv,__ZN2cvL15copyMaskGenericEPKhjS1_jPhjNS_5Size_IiEEPv,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15
  ,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15
  ,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15,b15];
  var FUNCTION_TABLE_viiiiii = [b16,__ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekoffExNS_8ios_base7seekdirEj,__ZNK2cv12_OutputArray6createENS_5Size_IiEEiibi,__ZN2cvL13mixChannels8uEPPKhPKiPPhS4_ii,__ZN2cvL14mixChannels16uEPPKtPKiPPtS4_ii,__ZN2cvL14mixChannels32sEPPKiS1_PPiS1_ii,__ZN2cvL14mixChannels64sEPPKxPKiPPxS4_ii,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv,__ZNKSt3__18messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,__ZNKSt3__18messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE,__ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib,__ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib,__ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib,b16,b16,b16,b16,b16,b16
  ,b16,b16,b16];
  var FUNCTION_TABLE_di = [b17,__ZNK12_GLOBAL__N_110CLAHE_Impl12getClipLimitEv];
  var FUNCTION_TABLE_viiiid = [b18,__ZNK2cv5MatOp8multiplyERKNS_7MatExprES3_RS1_d,__ZNK2cv5MatOp6divideERKNS_7MatExprES3_RS1_d,b18];
  var FUNCTION_TABLE_iiiiiiiii = [b19,__ZNK2cv15StdMatAllocator8allocateEiPKiiPvPjiNS_14UMatUsageFlagsE,__ZNKSt3__17codecvtIwc11__mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_,__ZNKSt3__17codecvtIwc11__mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_,__ZNKSt3__17codecvtIcc11__mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_,__ZNKSt3__17codecvtIcc11__mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_,__ZNKSt3__17codecvtIDsc11__mbstate_tE6do_outERS1_PKDsS5_RS5_PcS7_RS7_,__ZNKSt3__17codecvtIDsc11__mbstate_tE5do_inERS1_PKcS5_RS5_PDsS7_RS7_,__ZNKSt3__17codecvtIDic11__mbstate_tE6do_outERS1_PKDiS5_RS5_PcS7_RS7_,__ZNKSt3__17codecvtIDic11__mbstate_tE5do_inERS1_PKcS5_RS5_PDiS7_RS7_,b19,b19,b19,b19,b19,b19];
  var FUNCTION_TABLE_viiiiiii = [b20,__ZNK2cv12_OutputArray6createEiiiibi,__ZNK2cv12_OutputArray6createEiPKiiibi,__ZN2cvL13randnScale_8uEPKfPhiiS1_S1_b,__ZN2cvL13randnScale_8sEPKfPaiiS1_S1_b,__ZN2cvL14randnScale_16uEPKfPtiiS1_S1_b,__ZN2cvL14randnScale_16sEPKfPsiiS1_S1_b,__ZN2cvL14randnScale_32sEPKfPiiiS1_S1_b,__ZN2cvL14randnScale_32fEPKfPfiiS1_S1_b,__ZN2cvL14randnScale_64fEPKfPdiiPKdS4_b,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe,__ZNKSt3__17num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf
  ,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe,__ZNKSt3__17num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx,__ZNKSt3__17num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx,__ZNKSt3__17num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__18time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE,__ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20,b20
  ,b20,b20,b20,b20,b20];
  var FUNCTION_TABLE_viiiiiid = [b21,__ZNKSt3__19money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce,__ZNKSt3__19money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe,b21];
  var FUNCTION_TABLE_fi = [b22];
  var FUNCTION_TABLE_viiiiiiiiii = [b23,__ZNK2cv12MatAllocator4copyEPNS_8UMatDataES2_iPKjS4_S4_S4_S4_b];
  var FUNCTION_TABLE_iiiiiiiiiiiiiii = [b24];
  var FUNCTION_TABLE_diii = [b25,__ZN2cvL10dotProd_8uEPKhS1_i,__ZN2cvL10dotProd_8sEPKaS1_i,__ZN2cvL11dotProd_16uEPKtS1_i,__ZN2cvL11dotProd_16sEPKsS1_i,__ZN2cvL11dotProd_32sEPKiS1_i,__ZN2cvL11dotProd_32fEPKfS1_i,__ZN2cvL11dotProd_64fEPKdS1_i];
  var FUNCTION_TABLE_i = [b26,__ZN12_GLOBAL__N_1L23createCLAHE_Impl_hiddenEv];
  var FUNCTION_TABLE_viiiiiiiiiiddi = [b27,__ZN2cvL17GEMMSingleMul_32fEPKfjS1_jS1_jPfjNS_5Size_IiEES4_ddi,__ZN2cvL17GEMMSingleMul_64fEPKdjS1_jS1_jPdjNS_5Size_IiEES4_ddi,__ZN2cvL18GEMMSingleMul_32fcEPKNS_7ComplexIfEEjS3_jS3_jPS1_jNS_5Size_IiEES6_ddi,__ZN2cvL18GEMMSingleMul_64fcEPKNS_7ComplexIdEEjS3_jS3_jPS1_jNS_5Size_IiEES6_ddi,b27,b27,b27];
  var FUNCTION_TABLE_iiiii = [b28,__ZN2cv11FileStorage4openERKNS_6StringEiS3_,__ZNK2cv15StdMatAllocator8allocateEPNS_8UMatDataEiNS_14UMatUsageFlagsE,__ZNKSt3__15ctypeIcE8do_widenEPKcS3_Pc,__ZNKSt3__15ctypeIwE5do_isEPKwS3_Pt,__ZNKSt3__15ctypeIwE10do_scan_isEtPKwS3_,__ZNKSt3__15ctypeIwE11do_scan_notEtPKwS3_,__ZNKSt3__15ctypeIwE8do_widenEPKcS3_Pw];
  var FUNCTION_TABLE_viiid = [b29,__ZN2cvL14MulTransposedLIhfEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedRIhfEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedLIhdEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedRIhdEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedLItfEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedRItfEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedLItdEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedRItdEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedLIsfEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedRIsfEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedLIsdEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedRIsdEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedLIffEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedRIffEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedLIfdEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedRIfdEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedLIddEEvRKNS_3MatERS1_S3_d,__ZN2cvL14MulTransposedRIddEEvRKNS_3MatERS1_S3_d,b29,b29,b29,b29,b29,b29,b29,b29,b29,b29
  ,b29,b29,b29];
  var FUNCTION_TABLE_viii = [b30,__ZNK2cv11_InputArray6getMatEi,__ZNK2cv11_InputArray7getUMatEi,__ZNK2cv11_InputArray4sizeEi,__ZNK2cv11_InputArray6copyToERKNS_12_OutputArrayERKS0_,__ZNK2cv12_OutputArray14createSameSizeERKNS_11_InputArrayEi,__ZNK2cv12_OutputArray5setToERKNS_11_InputArrayES3_,__ZNK12_GLOBAL__N_110CFormatter6formatERKN2cv3MatE,__ZNK12_GLOBAL__N_114NumpyFormatter6formatERKN2cv3MatE,__ZNK12_GLOBAL__N_115PythonFormatter6formatERKN2cv3MatE,__ZNK12_GLOBAL__N_112CSVFormatter6formatERKN2cv3MatE,__ZNK12_GLOBAL__N_115MatlabFormatter6formatERKN2cv3MatE,__ZNK12_GLOBAL__N_116DefaultFormatter6formatERKN2cv3MatE,__ZN2cvL13transposeI_8uEPhji,__ZN2cvL14transposeI_16uEPhji,__ZN2cvL15transposeI_8uC3EPhji,__ZN2cvL14transposeI_32sEPhji,__ZN2cvL16transposeI_16uC3EPhji,__ZN2cvL16transposeI_32sC2EPhji,__ZN2cvL16transposeI_32sC3EPhji,__ZN2cvL16transposeI_32sC4EPhji,__ZN2cvL16transposeI_32sC6EPhji,__ZN2cvL16transposeI_32sC8EPhji,__ZNK2cv12MatAllocator3mapEPNS_8UMatDataEi,__ZNK2cv5MatOp12augAssignAddERKNS_7MatExprERNS_3MatE,__ZNK2cv5MatOp17augAssignSubtractERKNS_7MatExprERNS_3MatE,__ZNK2cv5MatOp17augAssignMultiplyERKNS_7MatExprERNS_3MatE,__ZNK2cv5MatOp15augAssignDivideERKNS_7MatExprERNS_3MatE,__ZNK2cv5MatOp12augAssignAndERKNS_7MatExprERNS_3MatE
  ,__ZNK2cv5MatOp11augAssignOrERKNS_7MatExprERNS_3MatE,__ZNK2cv5MatOp12augAssignXorERKNS_7MatExprERNS_3MatE,__ZNK2cv5MatOp3absERKNS_7MatExprERS1_,__ZNK2cv5MatOp9transposeERKNS_7MatExprERS1_,__ZNK2cv5MatOp4sizeERKNS_7MatExprE,__ZNK2cv11MatOp_AddEx3absERKNS_7MatExprERS1_,__ZNK2cv11MatOp_AddEx9transposeERKNS_7MatExprERS1_,__ZNK2cv10MatOp_GEMM9transposeERKNS_7MatExprERS1_,__ZNK2cv7MatOp_T9transposeERKNS_7MatExprERS1_,__ZN7testing8internal17TestEventRepeater20OnTestIterationStartERKNS_8UnitTestEi,__ZN7testing8internal17TestEventRepeater18OnTestIterationEndERKNS_8UnitTestEi,__ZN7testing22EmptyTestEventListener20OnTestIterationStartERKNS_8UnitTestEi,__ZN7testing8internal24XmlUnitTestResultPrinter18OnTestIterationEndERKNS_8UnitTestEi,__ZN7testing8internal27PrettyUnitTestResultPrinter20OnTestIterationStartERKNS_8UnitTestEi,__ZN7testing8internal27PrettyUnitTestResultPrinter18OnTestIterationEndERKNS_8UnitTestEi,__ZN12_GLOBAL__N_110CLAHE_Impl5applyERKN2cv11_InputArrayERKNS1_12_OutputArrayE,__ZNKSt3__114error_category23default_error_conditionEi,__ZNKSt3__119__iostream_category7messageEi,__ZL14icvXMLWriteIntP13CvFileStoragePKci,__ZL18icvXMLWriteCommentP13CvFileStoragePKci,__ZL14icvYMLWriteIntP13CvFileStoragePKci,__ZL18icvYMLWriteCommentP13CvFileStoragePKci,b30,b30,b30,b30,b30,b30,b30,b30
  ,b30,b30,b30,b30,b30];
  var FUNCTION_TABLE_v = [b31,___cxa_pure_virtual__wrapper,__ZL25default_terminate_handlerv,__ZN7testing4Test13SetUpTestCaseEv,__ZN7testing4Test16TearDownTestCaseEv,__ZN2cvL7makeKeyEv,__ZN10__cxxabiv112_GLOBAL__N_110construct_Ev,b31];
  var FUNCTION_TABLE_viid = [b32,__ZL15icvXMLWriteRealP13CvFileStoragePKcd,__ZL15icvYMLWriteRealP13CvFileStoragePKcd,b32];
  var FUNCTION_TABLE_viiii = [b33,__ZNSt3__115basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekposENS_4fposI11__mbstate_tEEj,__ZNK2cv14MatOp_Identity6assignERKNS_7MatExprERNS_3MatEi,__ZNK2cv5MatOp4diagERKNS_7MatExprEiRS1_,__ZNK2cv5MatOp3addERKNS_7MatExprES3_RS1_,__ZNK2cv5MatOp3addERKNS_7MatExprERKNS_7Scalar_IdEERS1_,__ZNK2cv5MatOp8subtractERKNS_7MatExprES3_RS1_,__ZNK2cv5MatOp8subtractERKNS_7Scalar_IdEERKNS_7MatExprERS5_,__ZNK2cv5MatOp6matmulERKNS_7MatExprES3_RS1_,__ZNK2cv5MatOp6invertERKNS_7MatExprEiRS1_,__ZNK2cv11MatOp_AddEx6assignERKNS_7MatExprERNS_3MatEi,__ZNK2cv11MatOp_AddEx3addERKNS_7MatExprERKNS_7Scalar_IdEERS1_,__ZNK2cv11MatOp_AddEx8subtractERKNS_7Scalar_IdEERKNS_7MatExprERS5_,__ZNK2cv9MatOp_Bin6assignERKNS_7MatExprERNS_3MatEi,__ZNK2cv9MatOp_Cmp6assignERKNS_7MatExprERNS_3MatEi,__ZNK2cv10MatOp_GEMM6assignERKNS_7MatExprERNS_3MatEi,__ZNK2cv10MatOp_GEMM3addERKNS_7MatExprES3_RS1_,__ZNK2cv10MatOp_GEMM8subtractERKNS_7MatExprES3_RS1_,__ZNK2cv12MatOp_Invert6assignERKNS_7MatExprERNS_3MatEi,__ZNK2cv12MatOp_Invert6matmulERKNS_7MatExprES3_RS1_,__ZNK2cv7MatOp_T6assignERKNS_7MatExprERNS_3MatEi,__ZNK2cv11MatOp_Solve6assignERKNS_7MatExprERNS_3MatEi,__ZNK2cv17MatOp_Initializer6assignERKNS_7MatExprERNS_3MatEi,__ZN2cvL7merge8uEPPKhPhii,__ZN2cvL8merge16uEPPKtPtii,__ZN2cvL8merge32sEPPKiPiii,__ZN2cvL8merge64sEPPKxPxii,__ZN6cvtest2TS6printfEiPKcz,__ZN6cvtest2TS7vprintfEiPKcPi
  ,__ZN6cvtest2TS14update_contextEPNS_8BaseTestEib,__ZN7testing8internal18OsStackTraceGetter17CurrentStackTraceEii,__ZNSt3__113basic_filebufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj,__ZNSt3__115basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI11__mbstate_tEEj,__ZNSt3__115basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj,__ZNKSt3__17collateIcE12do_transformEPKcS3_,__ZNKSt3__17collateIwE12do_transformEPKwS3_,__ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,__ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,__ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,__ZL22icvXMLStartWriteStructP13CvFileStoragePKciS2_,__ZL17icvXMLWriteStringP13CvFileStoragePKcS2_i,__ZL22icvYMLStartWriteStructP13CvFileStoragePKciS2_,__ZL17icvYMLWriteStringP13CvFileStoragePKcS2_i,__ZL15icvWriteSeqTreeP13CvFileStoragePKcPKv10CvAttrList,__ZL13icvWriteGraphP13CvFileStoragePKcPKv10CvAttrList,__ZL17icvWriteSparseMatP13CvFileStoragePKcPKv10CvAttrList,__ZL13icvWriteImageP13CvFileStoragePKcPKv10CvAttrList,__ZL11icvWriteMatP13CvFileStoragePKcPKv10CvAttrList,__ZL13icvWriteMatNDP13CvFileStoragePKcPKv10CvAttrList,__ZL12icvWriteHistP13CvFileStoragePKcPKv10CvAttrList,b33,b33,b33,b33,b33,b33,b33,b33,b33
  ,b33,b33,b33,b33,b33];

  return { _testSetjmp: _testSetjmp, ___cxa_can_catch: ___cxa_can_catch, _bitshift64Ashr: _bitshift64Ashr, _free: _free, _main: _main, _realloc: _realloc, _strncpy: _strncpy, _memmove: _memmove, ___cxa_is_pointer_type: ___cxa_is_pointer_type, _saveSetjmp: _saveSetjmp, _memset: _memset, _malloc: _malloc, _i64Add: _i64Add, _memcpy: _memcpy, _strlen: _strlen, _bitshift64Lshr: _bitshift64Lshr, _i64Subtract: _i64Subtract, _strcpy: _strcpy, _llvm_bswap_i32: _llvm_bswap_i32, _bitshift64Shl: _bitshift64Shl, __GLOBAL__I_a: __GLOBAL__I_a, __GLOBAL__I_a147: __GLOBAL__I_a147, __GLOBAL__I_a270: __GLOBAL__I_a270, __GLOBAL__I_a320: __GLOBAL__I_a320, __GLOBAL__I_a392: __GLOBAL__I_a392, __GLOBAL__I_a1405: __GLOBAL__I_a1405, __GLOBAL__I_a325: __GLOBAL__I_a325, __GLOBAL__I_a743: __GLOBAL__I_a743, __GLOBAL__I_a1055: __GLOBAL__I_a1055, __GLOBAL__I_a1104: __GLOBAL__I_a1104, __GLOBAL__I_a1556: __GLOBAL__I_a1556, __GLOBAL__I_a187: __GLOBAL__I_a187, __GLOBAL__I_a530: __GLOBAL__I_a530, __GLOBAL__I_a1585: __GLOBAL__I_a1585, __GLOBAL__I_a1953: __GLOBAL__I_a1953, runPostSets: runPostSets, stackAlloc: stackAlloc, stackSave: stackSave, stackRestore: stackRestore, setThrew: setThrew, setTempRet0: setTempRet0, getTempRet0: getTempRet0, dynCall_viiiii: dynCall_viiiii, dynCall_vif: dynCall_vif, dynCall_vid: dynCall_vid, dynCall_vi: dynCall_vi, dynCall_vii: dynCall_vii, dynCall_iiiiiii: dynCall_iiiiiii, dynCall_ii: dynCall_ii, dynCall_viiiiiiiddi: dynCall_viiiiiiiddi, dynCall_viiiiiiiii: dynCall_viiiiiiiii, dynCall_viidi: dynCall_viidi, dynCall_vidii: dynCall_vidii, dynCall_iiiiii: dynCall_iiiiii, dynCall_iii: dynCall_iii, dynCall_iiii: dynCall_iiii, dynCall_viiiiid: dynCall_viiiiid, dynCall_viiiiiiii: dynCall_viiiiiiii, dynCall_viiiiii: dynCall_viiiiii, dynCall_di: dynCall_di, dynCall_viiiid: dynCall_viiiid, dynCall_iiiiiiiii: dynCall_iiiiiiiii, dynCall_viiiiiii: dynCall_viiiiiii, dynCall_viiiiiid: dynCall_viiiiiid, dynCall_fi: dynCall_fi, dynCall_viiiiiiiiii: dynCall_viiiiiiiiii, dynCall_iiiiiiiiiiiiiii: dynCall_iiiiiiiiiiiiiii, dynCall_diii: dynCall_diii, dynCall_i: dynCall_i, dynCall_viiiiiiiiiiddi: dynCall_viiiiiiiiiiddi, dynCall_iiiii: dynCall_iiiii, dynCall_viiid: dynCall_viiid, dynCall_viii: dynCall_viii, dynCall_v: dynCall_v, dynCall_viid: dynCall_viid, dynCall_viiii: dynCall_viiii };
})
// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg, Module.asmLibraryArg, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var ___cxa_can_catch = Module["___cxa_can_catch"] = asm["___cxa_can_catch"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var ___cxa_is_pointer_type = Module["___cxa_is_pointer_type"] = asm["___cxa_is_pointer_type"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _llvm_bswap_i32 = Module["_llvm_bswap_i32"] = asm["_llvm_bswap_i32"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var __GLOBAL__I_a147 = Module["__GLOBAL__I_a147"] = asm["__GLOBAL__I_a147"];
var __GLOBAL__I_a270 = Module["__GLOBAL__I_a270"] = asm["__GLOBAL__I_a270"];
var __GLOBAL__I_a320 = Module["__GLOBAL__I_a320"] = asm["__GLOBAL__I_a320"];
var __GLOBAL__I_a392 = Module["__GLOBAL__I_a392"] = asm["__GLOBAL__I_a392"];
var __GLOBAL__I_a1405 = Module["__GLOBAL__I_a1405"] = asm["__GLOBAL__I_a1405"];
var __GLOBAL__I_a325 = Module["__GLOBAL__I_a325"] = asm["__GLOBAL__I_a325"];
var __GLOBAL__I_a743 = Module["__GLOBAL__I_a743"] = asm["__GLOBAL__I_a743"];
var __GLOBAL__I_a1055 = Module["__GLOBAL__I_a1055"] = asm["__GLOBAL__I_a1055"];
var __GLOBAL__I_a1104 = Module["__GLOBAL__I_a1104"] = asm["__GLOBAL__I_a1104"];
var __GLOBAL__I_a1556 = Module["__GLOBAL__I_a1556"] = asm["__GLOBAL__I_a1556"];
var __GLOBAL__I_a187 = Module["__GLOBAL__I_a187"] = asm["__GLOBAL__I_a187"];
var __GLOBAL__I_a530 = Module["__GLOBAL__I_a530"] = asm["__GLOBAL__I_a530"];
var __GLOBAL__I_a1585 = Module["__GLOBAL__I_a1585"] = asm["__GLOBAL__I_a1585"];
var __GLOBAL__I_a1953 = Module["__GLOBAL__I_a1953"] = asm["__GLOBAL__I_a1953"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_vif = Module["dynCall_vif"] = asm["dynCall_vif"];
var dynCall_vid = Module["dynCall_vid"] = asm["dynCall_vid"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiii = Module["dynCall_iiiiiii"] = asm["dynCall_iiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viiiiiiiddi = Module["dynCall_viiiiiiiddi"] = asm["dynCall_viiiiiiiddi"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_vidii = Module["dynCall_vidii"] = asm["dynCall_vidii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_di = Module["dynCall_di"] = asm["dynCall_di"];
var dynCall_viiiid = Module["dynCall_viiiid"] = asm["dynCall_viiiid"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_fi = Module["dynCall_fi"] = asm["dynCall_fi"];
var dynCall_viiiiiiiiii = Module["dynCall_viiiiiiiiii"] = asm["dynCall_viiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiii"];
var dynCall_diii = Module["dynCall_diii"] = asm["dynCall_diii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_viiiiiiiiiiddi = Module["dynCall_viiiiiiiiiiddi"] = asm["dynCall_viiiiiiiiiiddi"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiid = Module["dynCall_viiid"] = asm["dynCall_viiid"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_viid = Module["dynCall_viid"] = asm["dynCall_viid"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];
Runtime.stackAlloc = asm["stackAlloc"];
Runtime.stackSave = asm["stackSave"];
Runtime.stackRestore = asm["stackRestore"];
Runtime.setTempRet0 = asm["setTempRet0"];
Runtime.getTempRet0 = asm["getTempRet0"];
var i64Math = (function() {
 var goog = {
  math: {}
 };
 goog.math.Long = (function(low, high) {
  this.low_ = low | 0;
  this.high_ = high | 0;
 });
 goog.math.Long.IntCache_ = {};
 goog.math.Long.fromInt = (function(value) {
  if (-128 <= value && value < 128) {
   var cachedObj = goog.math.Long.IntCache_[value];
   if (cachedObj) {
    return cachedObj;
   }
  }
  var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
  if (-128 <= value && value < 128) {
   goog.math.Long.IntCache_[value] = obj;
  }
  return obj;
 });
 goog.math.Long.fromNumber = (function(value) {
  if (isNaN(value) || !isFinite(value)) {
   return goog.math.Long.ZERO;
  } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
   return goog.math.Long.MIN_VALUE;
  } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
   return goog.math.Long.MAX_VALUE;
  } else if (value < 0) {
   return goog.math.Long.fromNumber(-value).negate();
  } else {
   return new goog.math.Long(value % goog.math.Long.TWO_PWR_32_DBL_ | 0, value / goog.math.Long.TWO_PWR_32_DBL_ | 0);
  }
 });
 goog.math.Long.fromBits = (function(lowBits, highBits) {
  return new goog.math.Long(lowBits, highBits);
 });
 goog.math.Long.fromString = (function(str, opt_radix) {
  if (str.length == 0) {
   throw Error("number format error: empty string");
  }
  var radix = opt_radix || 10;
  if (radix < 2 || 36 < radix) {
   throw Error("radix out of range: " + radix);
  }
  if (str.charAt(0) == "-") {
   return goog.math.Long.fromString(str.substring(1), radix).negate();
  } else if (str.indexOf("-") >= 0) {
   throw Error('number format error: interior "-" character: ' + str);
  }
  var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));
  var result = goog.math.Long.ZERO;
  for (var i = 0; i < str.length; i += 8) {
   var size = Math.min(8, str.length - i);
   var value = parseInt(str.substring(i, i + size), radix);
   if (size < 8) {
    var power = goog.math.Long.fromNumber(Math.pow(radix, size));
    result = result.multiply(power).add(goog.math.Long.fromNumber(value));
   } else {
    result = result.multiply(radixToPower);
    result = result.add(goog.math.Long.fromNumber(value));
   }
  }
  return result;
 });
 goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;
 goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;
 goog.math.Long.TWO_PWR_32_DBL_ = goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;
 goog.math.Long.TWO_PWR_31_DBL_ = goog.math.Long.TWO_PWR_32_DBL_ / 2;
 goog.math.Long.TWO_PWR_48_DBL_ = goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;
 goog.math.Long.TWO_PWR_64_DBL_ = goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;
 goog.math.Long.TWO_PWR_63_DBL_ = goog.math.Long.TWO_PWR_64_DBL_ / 2;
 goog.math.Long.ZERO = goog.math.Long.fromInt(0);
 goog.math.Long.ONE = goog.math.Long.fromInt(1);
 goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);
 goog.math.Long.MAX_VALUE = goog.math.Long.fromBits(4294967295 | 0, 2147483647 | 0);
 goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 2147483648 | 0);
 goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);
 goog.math.Long.prototype.toInt = (function() {
  return this.low_;
 });
 goog.math.Long.prototype.toNumber = (function() {
  return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ + this.getLowBitsUnsigned();
 });
 goog.math.Long.prototype.toString = (function(opt_radix) {
  var radix = opt_radix || 10;
  if (radix < 2 || 36 < radix) {
   throw Error("radix out of range: " + radix);
  }
  if (this.isZero()) {
   return "0";
  }
  if (this.isNegative()) {
   if (this.equals(goog.math.Long.MIN_VALUE)) {
    var radixLong = goog.math.Long.fromNumber(radix);
    var div = this.div(radixLong);
    var rem = div.multiply(radixLong).subtract(this);
    return div.toString(radix) + rem.toInt().toString(radix);
   } else {
    return "-" + this.negate().toString(radix);
   }
  }
  var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));
  var rem = this;
  var result = "";
  while (true) {
   var remDiv = rem.div(radixToPower);
   var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
   var digits = intval.toString(radix);
   rem = remDiv;
   if (rem.isZero()) {
    return digits + result;
   } else {
    while (digits.length < 6) {
     digits = "0" + digits;
    }
    result = "" + digits + result;
   }
  }
 });
 goog.math.Long.prototype.getHighBits = (function() {
  return this.high_;
 });
 goog.math.Long.prototype.getLowBits = (function() {
  return this.low_;
 });
 goog.math.Long.prototype.getLowBitsUnsigned = (function() {
  return this.low_ >= 0 ? this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
 });
 goog.math.Long.prototype.getNumBitsAbs = (function() {
  if (this.isNegative()) {
   if (this.equals(goog.math.Long.MIN_VALUE)) {
    return 64;
   } else {
    return this.negate().getNumBitsAbs();
   }
  } else {
   var val = this.high_ != 0 ? this.high_ : this.low_;
   for (var bit = 31; bit > 0; bit--) {
    if ((val & 1 << bit) != 0) {
     break;
    }
   }
   return this.high_ != 0 ? bit + 33 : bit + 1;
  }
 });
 goog.math.Long.prototype.isZero = (function() {
  return this.high_ == 0 && this.low_ == 0;
 });
 goog.math.Long.prototype.isNegative = (function() {
  return this.high_ < 0;
 });
 goog.math.Long.prototype.isOdd = (function() {
  return (this.low_ & 1) == 1;
 });
 goog.math.Long.prototype.equals = (function(other) {
  return this.high_ == other.high_ && this.low_ == other.low_;
 });
 goog.math.Long.prototype.notEquals = (function(other) {
  return this.high_ != other.high_ || this.low_ != other.low_;
 });
 goog.math.Long.prototype.lessThan = (function(other) {
  return this.compare(other) < 0;
 });
 goog.math.Long.prototype.lessThanOrEqual = (function(other) {
  return this.compare(other) <= 0;
 });
 goog.math.Long.prototype.greaterThan = (function(other) {
  return this.compare(other) > 0;
 });
 goog.math.Long.prototype.greaterThanOrEqual = (function(other) {
  return this.compare(other) >= 0;
 });
 goog.math.Long.prototype.compare = (function(other) {
  if (this.equals(other)) {
   return 0;
  }
  var thisNeg = this.isNegative();
  var otherNeg = other.isNegative();
  if (thisNeg && !otherNeg) {
   return -1;
  }
  if (!thisNeg && otherNeg) {
   return 1;
  }
  if (this.subtract(other).isNegative()) {
   return -1;
  } else {
   return 1;
  }
 });
 goog.math.Long.prototype.negate = (function() {
  if (this.equals(goog.math.Long.MIN_VALUE)) {
   return goog.math.Long.MIN_VALUE;
  } else {
   return this.not().add(goog.math.Long.ONE);
  }
 });
 goog.math.Long.prototype.add = (function(other) {
  var a48 = this.high_ >>> 16;
  var a32 = this.high_ & 65535;
  var a16 = this.low_ >>> 16;
  var a00 = this.low_ & 65535;
  var b48 = other.high_ >>> 16;
  var b32 = other.high_ & 65535;
  var b16 = other.low_ >>> 16;
  var b00 = other.low_ & 65535;
  var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
  c00 += a00 + b00;
  c16 += c00 >>> 16;
  c00 &= 65535;
  c16 += a16 + b16;
  c32 += c16 >>> 16;
  c16 &= 65535;
  c32 += a32 + b32;
  c48 += c32 >>> 16;
  c32 &= 65535;
  c48 += a48 + b48;
  c48 &= 65535;
  return goog.math.Long.fromBits(c16 << 16 | c00, c48 << 16 | c32);
 });
 goog.math.Long.prototype.subtract = (function(other) {
  return this.add(other.negate());
 });
 goog.math.Long.prototype.multiply = (function(other) {
  if (this.isZero()) {
   return goog.math.Long.ZERO;
  } else if (other.isZero()) {
   return goog.math.Long.ZERO;
  }
  if (this.equals(goog.math.Long.MIN_VALUE)) {
   return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
  } else if (other.equals(goog.math.Long.MIN_VALUE)) {
   return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
  }
  if (this.isNegative()) {
   if (other.isNegative()) {
    return this.negate().multiply(other.negate());
   } else {
    return this.negate().multiply(other).negate();
   }
  } else if (other.isNegative()) {
   return this.multiply(other.negate()).negate();
  }
  if (this.lessThan(goog.math.Long.TWO_PWR_24_) && other.lessThan(goog.math.Long.TWO_PWR_24_)) {
   return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
  }
  var a48 = this.high_ >>> 16;
  var a32 = this.high_ & 65535;
  var a16 = this.low_ >>> 16;
  var a00 = this.low_ & 65535;
  var b48 = other.high_ >>> 16;
  var b32 = other.high_ & 65535;
  var b16 = other.low_ >>> 16;
  var b00 = other.low_ & 65535;
  var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
  c00 += a00 * b00;
  c16 += c00 >>> 16;
  c00 &= 65535;
  c16 += a16 * b00;
  c32 += c16 >>> 16;
  c16 &= 65535;
  c16 += a00 * b16;
  c32 += c16 >>> 16;
  c16 &= 65535;
  c32 += a32 * b00;
  c48 += c32 >>> 16;
  c32 &= 65535;
  c32 += a16 * b16;
  c48 += c32 >>> 16;
  c32 &= 65535;
  c32 += a00 * b32;
  c48 += c32 >>> 16;
  c32 &= 65535;
  c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
  c48 &= 65535;
  return goog.math.Long.fromBits(c16 << 16 | c00, c48 << 16 | c32);
 });
 goog.math.Long.prototype.div = (function(other) {
  if (other.isZero()) {
   throw Error("division by zero");
  } else if (this.isZero()) {
   return goog.math.Long.ZERO;
  }
  if (this.equals(goog.math.Long.MIN_VALUE)) {
   if (other.equals(goog.math.Long.ONE) || other.equals(goog.math.Long.NEG_ONE)) {
    return goog.math.Long.MIN_VALUE;
   } else if (other.equals(goog.math.Long.MIN_VALUE)) {
    return goog.math.Long.ONE;
   } else {
    var halfThis = this.shiftRight(1);
    var approx = halfThis.div(other).shiftLeft(1);
    if (approx.equals(goog.math.Long.ZERO)) {
     return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
    } else {
     var rem = this.subtract(other.multiply(approx));
     var result = approx.add(rem.div(other));
     return result;
    }
   }
  } else if (other.equals(goog.math.Long.MIN_VALUE)) {
   return goog.math.Long.ZERO;
  }
  if (this.isNegative()) {
   if (other.isNegative()) {
    return this.negate().div(other.negate());
   } else {
    return this.negate().div(other).negate();
   }
  } else if (other.isNegative()) {
   return this.div(other.negate()).negate();
  }
  var res = goog.math.Long.ZERO;
  var rem = this;
  while (rem.greaterThanOrEqual(other)) {
   var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));
   var log2 = Math.ceil(Math.log(approx) / Math.LN2);
   var delta = log2 <= 48 ? 1 : Math.pow(2, log2 - 48);
   var approxRes = goog.math.Long.fromNumber(approx);
   var approxRem = approxRes.multiply(other);
   while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
    approx -= delta;
    approxRes = goog.math.Long.fromNumber(approx);
    approxRem = approxRes.multiply(other);
   }
   if (approxRes.isZero()) {
    approxRes = goog.math.Long.ONE;
   }
   res = res.add(approxRes);
   rem = rem.subtract(approxRem);
  }
  return res;
 });
 goog.math.Long.prototype.modulo = (function(other) {
  return this.subtract(this.div(other).multiply(other));
 });
 goog.math.Long.prototype.not = (function() {
  return goog.math.Long.fromBits(~this.low_, ~this.high_);
 });
 goog.math.Long.prototype.and = (function(other) {
  return goog.math.Long.fromBits(this.low_ & other.low_, this.high_ & other.high_);
 });
 goog.math.Long.prototype.or = (function(other) {
  return goog.math.Long.fromBits(this.low_ | other.low_, this.high_ | other.high_);
 });
 goog.math.Long.prototype.xor = (function(other) {
  return goog.math.Long.fromBits(this.low_ ^ other.low_, this.high_ ^ other.high_);
 });
 goog.math.Long.prototype.shiftLeft = (function(numBits) {
  numBits &= 63;
  if (numBits == 0) {
   return this;
  } else {
   var low = this.low_;
   if (numBits < 32) {
    var high = this.high_;
    return goog.math.Long.fromBits(low << numBits, high << numBits | low >>> 32 - numBits);
   } else {
    return goog.math.Long.fromBits(0, low << numBits - 32);
   }
  }
 });
 goog.math.Long.prototype.shiftRight = (function(numBits) {
  numBits &= 63;
  if (numBits == 0) {
   return this;
  } else {
   var high = this.high_;
   if (numBits < 32) {
    var low = this.low_;
    return goog.math.Long.fromBits(low >>> numBits | high << 32 - numBits, high >> numBits);
   } else {
    return goog.math.Long.fromBits(high >> numBits - 32, high >= 0 ? 0 : -1);
   }
  }
 });
 goog.math.Long.prototype.shiftRightUnsigned = (function(numBits) {
  numBits &= 63;
  if (numBits == 0) {
   return this;
  } else {
   var high = this.high_;
   if (numBits < 32) {
    var low = this.low_;
    return goog.math.Long.fromBits(low >>> numBits | high << 32 - numBits, high >>> numBits);
   } else if (numBits == 32) {
    return goog.math.Long.fromBits(high, 0);
   } else {
    return goog.math.Long.fromBits(high >>> numBits - 32, 0);
   }
  }
 });
 var navigator = {
  appName: "Modern Browser"
 };
 var dbits;
 var canary = 0xdeadbeefcafe;
 var j_lm = (canary & 16777215) == 15715070;
 function BigInteger(a, b, c) {
  if (a != null) if ("number" == typeof a) this.fromNumber(a, b, c); else if (b == null && "string" != typeof a) this.fromString(a, 256); else this.fromString(a, b);
 }
 function nbi() {
  return new BigInteger(null);
 }
 function am1(i, x, w, j, c, n) {
  while (--n >= 0) {
   var v = x * this[i++] + w[j] + c;
   c = Math.floor(v / 67108864);
   w[j++] = v & 67108863;
  }
  return c;
 }
 function am2(i, x, w, j, c, n) {
  var xl = x & 32767, xh = x >> 15;
  while (--n >= 0) {
   var l = this[i] & 32767;
   var h = this[i++] >> 15;
   var m = xh * l + h * xl;
   l = xl * l + ((m & 32767) << 15) + w[j] + (c & 1073741823);
   c = (l >>> 30) + (m >>> 15) + xh * h + (c >>> 30);
   w[j++] = l & 1073741823;
  }
  return c;
 }
 function am3(i, x, w, j, c, n) {
  var xl = x & 16383, xh = x >> 14;
  while (--n >= 0) {
   var l = this[i] & 16383;
   var h = this[i++] >> 14;
   var m = xh * l + h * xl;
   l = xl * l + ((m & 16383) << 14) + w[j] + c;
   c = (l >> 28) + (m >> 14) + xh * h;
   w[j++] = l & 268435455;
  }
  return c;
 }
 if (j_lm && navigator.appName == "Microsoft Internet Explorer") {
  BigInteger.prototype.am = am2;
  dbits = 30;
 } else if (j_lm && navigator.appName != "Netscape") {
  BigInteger.prototype.am = am1;
  dbits = 26;
 } else {
  BigInteger.prototype.am = am3;
  dbits = 28;
 }
 BigInteger.prototype.DB = dbits;
 BigInteger.prototype.DM = (1 << dbits) - 1;
 BigInteger.prototype.DV = 1 << dbits;
 var BI_FP = 52;
 BigInteger.prototype.FV = Math.pow(2, BI_FP);
 BigInteger.prototype.F1 = BI_FP - dbits;
 BigInteger.prototype.F2 = 2 * dbits - BI_FP;
 var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
 var BI_RC = new Array;
 var rr, vv;
 rr = "0".charCodeAt(0);
 for (vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
 rr = "a".charCodeAt(0);
 for (vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
 rr = "A".charCodeAt(0);
 for (vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
 function int2char(n) {
  return BI_RM.charAt(n);
 }
 function intAt(s, i) {
  var c = BI_RC[s.charCodeAt(i)];
  return c == null ? -1 : c;
 }
 function bnpCopyTo(r) {
  for (var i = this.t - 1; i >= 0; --i) r[i] = this[i];
  r.t = this.t;
  r.s = this.s;
 }
 function bnpFromInt(x) {
  this.t = 1;
  this.s = x < 0 ? -1 : 0;
  if (x > 0) this[0] = x; else if (x < -1) this[0] = x + DV; else this.t = 0;
 }
 function nbv(i) {
  var r = nbi();
  r.fromInt(i);
  return r;
 }
 function bnpFromString(s, b) {
  var k;
  if (b == 16) k = 4; else if (b == 8) k = 3; else if (b == 256) k = 8; else if (b == 2) k = 1; else if (b == 32) k = 5; else if (b == 4) k = 2; else {
   this.fromRadix(s, b);
   return;
  }
  this.t = 0;
  this.s = 0;
  var i = s.length, mi = false, sh = 0;
  while (--i >= 0) {
   var x = k == 8 ? s[i] & 255 : intAt(s, i);
   if (x < 0) {
    if (s.charAt(i) == "-") mi = true;
    continue;
   }
   mi = false;
   if (sh == 0) this[this.t++] = x; else if (sh + k > this.DB) {
    this[this.t - 1] |= (x & (1 << this.DB - sh) - 1) << sh;
    this[this.t++] = x >> this.DB - sh;
   } else this[this.t - 1] |= x << sh;
   sh += k;
   if (sh >= this.DB) sh -= this.DB;
  }
  if (k == 8 && (s[0] & 128) != 0) {
   this.s = -1;
   if (sh > 0) this[this.t - 1] |= (1 << this.DB - sh) - 1 << sh;
  }
  this.clamp();
  if (mi) BigInteger.ZERO.subTo(this, this);
 }
 function bnpClamp() {
  var c = this.s & this.DM;
  while (this.t > 0 && this[this.t - 1] == c) --this.t;
 }
 function bnToString(b) {
  if (this.s < 0) return "-" + this.negate().toString(b);
  var k;
  if (b == 16) k = 4; else if (b == 8) k = 3; else if (b == 2) k = 1; else if (b == 32) k = 5; else if (b == 4) k = 2; else return this.toRadix(b);
  var km = (1 << k) - 1, d, m = false, r = "", i = this.t;
  var p = this.DB - i * this.DB % k;
  if (i-- > 0) {
   if (p < this.DB && (d = this[i] >> p) > 0) {
    m = true;
    r = int2char(d);
   }
   while (i >= 0) {
    if (p < k) {
     d = (this[i] & (1 << p) - 1) << k - p;
     d |= this[--i] >> (p += this.DB - k);
    } else {
     d = this[i] >> (p -= k) & km;
     if (p <= 0) {
      p += this.DB;
      --i;
     }
    }
    if (d > 0) m = true;
    if (m) r += int2char(d);
   }
  }
  return m ? r : "0";
 }
 function bnNegate() {
  var r = nbi();
  BigInteger.ZERO.subTo(this, r);
  return r;
 }
 function bnAbs() {
  return this.s < 0 ? this.negate() : this;
 }
 function bnCompareTo(a) {
  var r = this.s - a.s;
  if (r != 0) return r;
  var i = this.t;
  r = i - a.t;
  if (r != 0) return this.s < 0 ? -r : r;
  while (--i >= 0) if ((r = this[i] - a[i]) != 0) return r;
  return 0;
 }
 function nbits(x) {
  var r = 1, t;
  if ((t = x >>> 16) != 0) {
   x = t;
   r += 16;
  }
  if ((t = x >> 8) != 0) {
   x = t;
   r += 8;
  }
  if ((t = x >> 4) != 0) {
   x = t;
   r += 4;
  }
  if ((t = x >> 2) != 0) {
   x = t;
   r += 2;
  }
  if ((t = x >> 1) != 0) {
   x = t;
   r += 1;
  }
  return r;
 }
 function bnBitLength() {
  if (this.t <= 0) return 0;
  return this.DB * (this.t - 1) + nbits(this[this.t - 1] ^ this.s & this.DM);
 }
 function bnpDLShiftTo(n, r) {
  var i;
  for (i = this.t - 1; i >= 0; --i) r[i + n] = this[i];
  for (i = n - 1; i >= 0; --i) r[i] = 0;
  r.t = this.t + n;
  r.s = this.s;
 }
 function bnpDRShiftTo(n, r) {
  for (var i = n; i < this.t; ++i) r[i - n] = this[i];
  r.t = Math.max(this.t - n, 0);
  r.s = this.s;
 }
 function bnpLShiftTo(n, r) {
  var bs = n % this.DB;
  var cbs = this.DB - bs;
  var bm = (1 << cbs) - 1;
  var ds = Math.floor(n / this.DB), c = this.s << bs & this.DM, i;
  for (i = this.t - 1; i >= 0; --i) {
   r[i + ds + 1] = this[i] >> cbs | c;
   c = (this[i] & bm) << bs;
  }
  for (i = ds - 1; i >= 0; --i) r[i] = 0;
  r[ds] = c;
  r.t = this.t + ds + 1;
  r.s = this.s;
  r.clamp();
 }
 function bnpRShiftTo(n, r) {
  r.s = this.s;
  var ds = Math.floor(n / this.DB);
  if (ds >= this.t) {
   r.t = 0;
   return;
  }
  var bs = n % this.DB;
  var cbs = this.DB - bs;
  var bm = (1 << bs) - 1;
  r[0] = this[ds] >> bs;
  for (var i = ds + 1; i < this.t; ++i) {
   r[i - ds - 1] |= (this[i] & bm) << cbs;
   r[i - ds] = this[i] >> bs;
  }
  if (bs > 0) r[this.t - ds - 1] |= (this.s & bm) << cbs;
  r.t = this.t - ds;
  r.clamp();
 }
 function bnpSubTo(a, r) {
  var i = 0, c = 0, m = Math.min(a.t, this.t);
  while (i < m) {
   c += this[i] - a[i];
   r[i++] = c & this.DM;
   c >>= this.DB;
  }
  if (a.t < this.t) {
   c -= a.s;
   while (i < this.t) {
    c += this[i];
    r[i++] = c & this.DM;
    c >>= this.DB;
   }
   c += this.s;
  } else {
   c += this.s;
   while (i < a.t) {
    c -= a[i];
    r[i++] = c & this.DM;
    c >>= this.DB;
   }
   c -= a.s;
  }
  r.s = c < 0 ? -1 : 0;
  if (c < -1) r[i++] = this.DV + c; else if (c > 0) r[i++] = c;
  r.t = i;
  r.clamp();
 }
 function bnpMultiplyTo(a, r) {
  var x = this.abs(), y = a.abs();
  var i = x.t;
  r.t = i + y.t;
  while (--i >= 0) r[i] = 0;
  for (i = 0; i < y.t; ++i) r[i + x.t] = x.am(0, y[i], r, i, 0, x.t);
  r.s = 0;
  r.clamp();
  if (this.s != a.s) BigInteger.ZERO.subTo(r, r);
 }
 function bnpSquareTo(r) {
  var x = this.abs();
  var i = r.t = 2 * x.t;
  while (--i >= 0) r[i] = 0;
  for (i = 0; i < x.t - 1; ++i) {
   var c = x.am(i, x[i], r, 2 * i, 0, 1);
   if ((r[i + x.t] += x.am(i + 1, 2 * x[i], r, 2 * i + 1, c, x.t - i - 1)) >= x.DV) {
    r[i + x.t] -= x.DV;
    r[i + x.t + 1] = 1;
   }
  }
  if (r.t > 0) r[r.t - 1] += x.am(i, x[i], r, 2 * i, 0, 1);
  r.s = 0;
  r.clamp();
 }
 function bnpDivRemTo(m, q, r) {
  var pm = m.abs();
  if (pm.t <= 0) return;
  var pt = this.abs();
  if (pt.t < pm.t) {
   if (q != null) q.fromInt(0);
   if (r != null) this.copyTo(r);
   return;
  }
  if (r == null) r = nbi();
  var y = nbi(), ts = this.s, ms = m.s;
  var nsh = this.DB - nbits(pm[pm.t - 1]);
  if (nsh > 0) {
   pm.lShiftTo(nsh, y);
   pt.lShiftTo(nsh, r);
  } else {
   pm.copyTo(y);
   pt.copyTo(r);
  }
  var ys = y.t;
  var y0 = y[ys - 1];
  if (y0 == 0) return;
  var yt = y0 * (1 << this.F1) + (ys > 1 ? y[ys - 2] >> this.F2 : 0);
  var d1 = this.FV / yt, d2 = (1 << this.F1) / yt, e = 1 << this.F2;
  var i = r.t, j = i - ys, t = q == null ? nbi() : q;
  y.dlShiftTo(j, t);
  if (r.compareTo(t) >= 0) {
   r[r.t++] = 1;
   r.subTo(t, r);
  }
  BigInteger.ONE.dlShiftTo(ys, t);
  t.subTo(y, y);
  while (y.t < ys) y[y.t++] = 0;
  while (--j >= 0) {
   var qd = r[--i] == y0 ? this.DM : Math.floor(r[i] * d1 + (r[i - 1] + e) * d2);
   if ((r[i] += y.am(0, qd, r, j, 0, ys)) < qd) {
    y.dlShiftTo(j, t);
    r.subTo(t, r);
    while (r[i] < --qd) r.subTo(t, r);
   }
  }
  if (q != null) {
   r.drShiftTo(ys, q);
   if (ts != ms) BigInteger.ZERO.subTo(q, q);
  }
  r.t = ys;
  r.clamp();
  if (nsh > 0) r.rShiftTo(nsh, r);
  if (ts < 0) BigInteger.ZERO.subTo(r, r);
 }
 function bnMod(a) {
  var r = nbi();
  this.abs().divRemTo(a, null, r);
  if (this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r, r);
  return r;
 }
 function Classic(m) {
  this.m = m;
 }
 function cConvert(x) {
  if (x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m); else return x;
 }
 function cRevert(x) {
  return x;
 }
 function cReduce(x) {
  x.divRemTo(this.m, null, x);
 }
 function cMulTo(x, y, r) {
  x.multiplyTo(y, r);
  this.reduce(r);
 }
 function cSqrTo(x, r) {
  x.squareTo(r);
  this.reduce(r);
 }
 Classic.prototype.convert = cConvert;
 Classic.prototype.revert = cRevert;
 Classic.prototype.reduce = cReduce;
 Classic.prototype.mulTo = cMulTo;
 Classic.prototype.sqrTo = cSqrTo;
 function bnpInvDigit() {
  if (this.t < 1) return 0;
  var x = this[0];
  if ((x & 1) == 0) return 0;
  var y = x & 3;
  y = y * (2 - (x & 15) * y) & 15;
  y = y * (2 - (x & 255) * y) & 255;
  y = y * (2 - ((x & 65535) * y & 65535)) & 65535;
  y = y * (2 - x * y % this.DV) % this.DV;
  return y > 0 ? this.DV - y : -y;
 }
 function Montgomery(m) {
  this.m = m;
  this.mp = m.invDigit();
  this.mpl = this.mp & 32767;
  this.mph = this.mp >> 15;
  this.um = (1 << m.DB - 15) - 1;
  this.mt2 = 2 * m.t;
 }
 function montConvert(x) {
  var r = nbi();
  x.abs().dlShiftTo(this.m.t, r);
  r.divRemTo(this.m, null, r);
  if (x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r, r);
  return r;
 }
 function montRevert(x) {
  var r = nbi();
  x.copyTo(r);
  this.reduce(r);
  return r;
 }
 function montReduce(x) {
  while (x.t <= this.mt2) x[x.t++] = 0;
  for (var i = 0; i < this.m.t; ++i) {
   var j = x[i] & 32767;
   var u0 = j * this.mpl + ((j * this.mph + (x[i] >> 15) * this.mpl & this.um) << 15) & x.DM;
   j = i + this.m.t;
   x[j] += this.m.am(0, u0, x, i, 0, this.m.t);
   while (x[j] >= x.DV) {
    x[j] -= x.DV;
    x[++j]++;
   }
  }
  x.clamp();
  x.drShiftTo(this.m.t, x);
  if (x.compareTo(this.m) >= 0) x.subTo(this.m, x);
 }
 function montSqrTo(x, r) {
  x.squareTo(r);
  this.reduce(r);
 }
 function montMulTo(x, y, r) {
  x.multiplyTo(y, r);
  this.reduce(r);
 }
 Montgomery.prototype.convert = montConvert;
 Montgomery.prototype.revert = montRevert;
 Montgomery.prototype.reduce = montReduce;
 Montgomery.prototype.mulTo = montMulTo;
 Montgomery.prototype.sqrTo = montSqrTo;
 function bnpIsEven() {
  return (this.t > 0 ? this[0] & 1 : this.s) == 0;
 }
 function bnpExp(e, z) {
  if (e > 4294967295 || e < 1) return BigInteger.ONE;
  var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e) - 1;
  g.copyTo(r);
  while (--i >= 0) {
   z.sqrTo(r, r2);
   if ((e & 1 << i) > 0) z.mulTo(r2, g, r); else {
    var t = r;
    r = r2;
    r2 = t;
   }
  }
  return z.revert(r);
 }
 function bnModPowInt(e, m) {
  var z;
  if (e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
  return this.exp(e, z);
 }
 BigInteger.prototype.copyTo = bnpCopyTo;
 BigInteger.prototype.fromInt = bnpFromInt;
 BigInteger.prototype.fromString = bnpFromString;
 BigInteger.prototype.clamp = bnpClamp;
 BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
 BigInteger.prototype.drShiftTo = bnpDRShiftTo;
 BigInteger.prototype.lShiftTo = bnpLShiftTo;
 BigInteger.prototype.rShiftTo = bnpRShiftTo;
 BigInteger.prototype.subTo = bnpSubTo;
 BigInteger.prototype.multiplyTo = bnpMultiplyTo;
 BigInteger.prototype.squareTo = bnpSquareTo;
 BigInteger.prototype.divRemTo = bnpDivRemTo;
 BigInteger.prototype.invDigit = bnpInvDigit;
 BigInteger.prototype.isEven = bnpIsEven;
 BigInteger.prototype.exp = bnpExp;
 BigInteger.prototype.toString = bnToString;
 BigInteger.prototype.negate = bnNegate;
 BigInteger.prototype.abs = bnAbs;
 BigInteger.prototype.compareTo = bnCompareTo;
 BigInteger.prototype.bitLength = bnBitLength;
 BigInteger.prototype.mod = bnMod;
 BigInteger.prototype.modPowInt = bnModPowInt;
 BigInteger.ZERO = nbv(0);
 BigInteger.ONE = nbv(1);
 function bnpFromRadix(s, b) {
  this.fromInt(0);
  if (b == null) b = 10;
  var cs = this.chunkSize(b);
  var d = Math.pow(b, cs), mi = false, j = 0, w = 0;
  for (var i = 0; i < s.length; ++i) {
   var x = intAt(s, i);
   if (x < 0) {
    if (s.charAt(i) == "-" && this.signum() == 0) mi = true;
    continue;
   }
   w = b * w + x;
   if (++j >= cs) {
    this.dMultiply(d);
    this.dAddOffset(w, 0);
    j = 0;
    w = 0;
   }
  }
  if (j > 0) {
   this.dMultiply(Math.pow(b, j));
   this.dAddOffset(w, 0);
  }
  if (mi) BigInteger.ZERO.subTo(this, this);
 }
 function bnpChunkSize(r) {
  return Math.floor(Math.LN2 * this.DB / Math.log(r));
 }
 function bnSigNum() {
  if (this.s < 0) return -1; else if (this.t <= 0 || this.t == 1 && this[0] <= 0) return 0; else return 1;
 }
 function bnpDMultiply(n) {
  this[this.t] = this.am(0, n - 1, this, 0, 0, this.t);
  ++this.t;
  this.clamp();
 }
 function bnpDAddOffset(n, w) {
  if (n == 0) return;
  while (this.t <= w) this[this.t++] = 0;
  this[w] += n;
  while (this[w] >= this.DV) {
   this[w] -= this.DV;
   if (++w >= this.t) this[this.t++] = 0;
   ++this[w];
  }
 }
 function bnpToRadix(b) {
  if (b == null) b = 10;
  if (this.signum() == 0 || b < 2 || b > 36) return "0";
  var cs = this.chunkSize(b);
  var a = Math.pow(b, cs);
  var d = nbv(a), y = nbi(), z = nbi(), r = "";
  this.divRemTo(d, y, z);
  while (y.signum() > 0) {
   r = (a + z.intValue()).toString(b).substr(1) + r;
   y.divRemTo(d, y, z);
  }
  return z.intValue().toString(b) + r;
 }
 function bnIntValue() {
  if (this.s < 0) {
   if (this.t == 1) return this[0] - this.DV; else if (this.t == 0) return -1;
  } else if (this.t == 1) return this[0]; else if (this.t == 0) return 0;
  return (this[1] & (1 << 32 - this.DB) - 1) << this.DB | this[0];
 }
 function bnpAddTo(a, r) {
  var i = 0, c = 0, m = Math.min(a.t, this.t);
  while (i < m) {
   c += this[i] + a[i];
   r[i++] = c & this.DM;
   c >>= this.DB;
  }
  if (a.t < this.t) {
   c += a.s;
   while (i < this.t) {
    c += this[i];
    r[i++] = c & this.DM;
    c >>= this.DB;
   }
   c += this.s;
  } else {
   c += this.s;
   while (i < a.t) {
    c += a[i];
    r[i++] = c & this.DM;
    c >>= this.DB;
   }
   c += a.s;
  }
  r.s = c < 0 ? -1 : 0;
  if (c > 0) r[i++] = c; else if (c < -1) r[i++] = this.DV + c;
  r.t = i;
  r.clamp();
 }
 BigInteger.prototype.fromRadix = bnpFromRadix;
 BigInteger.prototype.chunkSize = bnpChunkSize;
 BigInteger.prototype.signum = bnSigNum;
 BigInteger.prototype.dMultiply = bnpDMultiply;
 BigInteger.prototype.dAddOffset = bnpDAddOffset;
 BigInteger.prototype.toRadix = bnpToRadix;
 BigInteger.prototype.intValue = bnIntValue;
 BigInteger.prototype.addTo = bnpAddTo;
 var Wrapper = {
  abs: (function(l, h) {
   var x = new goog.math.Long(l, h);
   var ret;
   if (x.isNegative()) {
    ret = x.negate();
   } else {
    ret = x;
   }
   HEAP32[tempDoublePtr >> 2] = ret.low_;
   HEAP32[tempDoublePtr + 4 >> 2] = ret.high_;
  }),
  ensureTemps: (function() {
   if (Wrapper.ensuredTemps) return;
   Wrapper.ensuredTemps = true;
   Wrapper.two32 = new BigInteger;
   Wrapper.two32.fromString("4294967296", 10);
   Wrapper.two64 = new BigInteger;
   Wrapper.two64.fromString("18446744073709551616", 10);
   Wrapper.temp1 = new BigInteger;
   Wrapper.temp2 = new BigInteger;
  }),
  lh2bignum: (function(l, h) {
   var a = new BigInteger;
   a.fromString(h.toString(), 10);
   var b = new BigInteger;
   a.multiplyTo(Wrapper.two32, b);
   var c = new BigInteger;
   c.fromString(l.toString(), 10);
   var d = new BigInteger;
   c.addTo(b, d);
   return d;
  }),
  stringify: (function(l, h, unsigned) {
   var ret = (new goog.math.Long(l, h)).toString();
   if (unsigned && ret[0] == "-") {
    Wrapper.ensureTemps();
    var bignum = new BigInteger;
    bignum.fromString(ret, 10);
    ret = new BigInteger;
    Wrapper.two64.addTo(bignum, ret);
    ret = ret.toString(10);
   }
   return ret;
  }),
  fromString: (function(str, base, min, max, unsigned) {
   Wrapper.ensureTemps();
   var bignum = new BigInteger;
   bignum.fromString(str, base);
   var bigmin = new BigInteger;
   bigmin.fromString(min, 10);
   var bigmax = new BigInteger;
   bigmax.fromString(max, 10);
   if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
    var temp = new BigInteger;
    bignum.addTo(Wrapper.two64, temp);
    bignum = temp;
   }
   var error = false;
   if (bignum.compareTo(bigmin) < 0) {
    bignum = bigmin;
    error = true;
   } else if (bignum.compareTo(bigmax) > 0) {
    bignum = bigmax;
    error = true;
   }
   var ret = goog.math.Long.fromString(bignum.toString());
   HEAP32[tempDoublePtr >> 2] = ret.low_;
   HEAP32[tempDoublePtr + 4 >> 2] = ret.high_;
   if (error) throw "range error";
  })
 };
 return Wrapper;
})();
if (memoryInitializer) {
 if (typeof Module["locateFile"] === "function") {
  memoryInitializer = Module["locateFile"](memoryInitializer);
 } else if (Module["memoryInitializerPrefixURL"]) {
  memoryInitializer = Module["memoryInitializerPrefixURL"] + memoryInitializer;
 }
 if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
  var data = Module["readBinary"](memoryInitializer);
  HEAPU8.set(data, STATIC_BASE);
 } else {
  addRunDependency("memory initializer");
  Browser.asyncLoad(memoryInitializer, (function(data) {
   HEAPU8.set(data, STATIC_BASE);
   removeRunDependency("memory initializer");
  }), (function(data) {
   throw "could not load memory initializer " + memoryInitializer;
  }));
 }
}
function ExitStatus(status) {
 this.name = "ExitStatus";
 this.message = "Program terminated with exit(" + status + ")";
 this.status = status;
}
ExitStatus.prototype = new Error;
ExitStatus.prototype.constructor = ExitStatus;
var initialStackTop;
var preloadStartTime = null;
var calledMain = false;
dependenciesFulfilled = function runCaller() {
 if (!Module["calledRun"] && shouldRunNow) run();
 if (!Module["calledRun"]) dependenciesFulfilled = runCaller;
};
Module["callMain"] = Module.callMain = function callMain(args) {
 assert(runDependencies == 0, "cannot call main when async dependencies remain! (listen on __ATMAIN__)");
 assert(__ATPRERUN__.length == 0, "cannot call main when preRun functions remain to be called");
 args = args || [];
 ensureInitRuntime();
 var argc = args.length + 1;
 function pad() {
  for (var i = 0; i < 4 - 1; i++) {
   argv.push(0);
  }
 }
 var argv = [ allocate(intArrayFromString(Module["thisProgram"]), "i8", ALLOC_NORMAL) ];
 pad();
 for (var i = 0; i < argc - 1; i = i + 1) {
  argv.push(allocate(intArrayFromString(args[i]), "i8", ALLOC_NORMAL));
  pad();
 }
 argv.push(0);
 argv = allocate(argv, "i32", ALLOC_NORMAL);
 initialStackTop = STACKTOP;
 try {
  var ret = Module["_main"](argc, argv, 0);
  exit(ret);
 } catch (e) {
  if (e instanceof ExitStatus) {
   return;
  } else if (e == "SimulateInfiniteLoop") {
   Module["noExitRuntime"] = true;
   return;
  } else {
   if (e && typeof e === "object" && e.stack) Module.printErr("exception thrown: " + [ e, e.stack ]);
   throw e;
  }
 } finally {
  calledMain = true;
 }
};
function run(args) {
 args = args || Module["arguments"];
 if (preloadStartTime === null) preloadStartTime = Date.now();
 if (runDependencies > 0) {
  return;
 }
 preRun();
 if (runDependencies > 0) return;
 if (Module["calledRun"]) return;
 function doRun() {
  if (Module["calledRun"]) return;
  Module["calledRun"] = true;
  if (ABORT) return;
  ensureInitRuntime();
  preMain();
  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
   Module.printErr("pre-main prep time: " + (Date.now() - preloadStartTime) + " ms");
  }
  if (Module["onRuntimeInitialized"]) Module["onRuntimeInitialized"]();
  if (Module["_main"] && shouldRunNow) Module["callMain"](args);
  postRun();
 }
 if (Module["setStatus"]) {
  Module["setStatus"]("Running...");
  setTimeout((function() {
   setTimeout((function() {
    Module["setStatus"]("");
   }), 1);
   doRun();
  }), 1);
 } else {
  doRun();
 }
}
Module["run"] = Module.run = run;
function exit(status) {
 if (Module["noExitRuntime"]) {
  return;
 }
 ABORT = true;
 EXITSTATUS = status;
 STACKTOP = initialStackTop;
 exitRuntime();
 if (ENVIRONMENT_IS_NODE) {
  process["stdout"]["once"]("drain", (function() {
   process["exit"](status);
  }));
  console.log(" ");
  setTimeout((function() {
   process["exit"](status);
  }), 500);
 } else if (ENVIRONMENT_IS_SHELL && typeof quit === "function") {
  quit(status);
 }
 throw new ExitStatus(status);
}
Module["exit"] = Module.exit = exit;
function abort(text) {
 if (text) {
  Module.print(text);
  Module.printErr(text);
 }
 ABORT = true;
 EXITSTATUS = 1;
 var extra = "\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";
 throw "abort() at " + stackTrace() + extra;
}
Module["abort"] = Module.abort = abort;
if (Module["preInit"]) {
 if (typeof Module["preInit"] == "function") Module["preInit"] = [ Module["preInit"] ];
 while (Module["preInit"].length > 0) {
  Module["preInit"].pop()();
 }
}
var shouldRunNow = true;
if (Module["noInitialRun"]) {
 shouldRunNow = false;
}
run();




